/* automatically generated by rust-bindgen 0.71.1 */

#[repr(C)]
#[derive(Copy, Clone, Debug, Default, Eq, Hash, Ord, PartialEq, PartialOrd)]
pub struct __BindgenBitfieldUnit<Storage> {
    storage: Storage,
}
impl<Storage> __BindgenBitfieldUnit<Storage> {
    #[inline]
    pub const fn new(storage: Storage) -> Self {
        Self { storage }
    }
}
impl<Storage> __BindgenBitfieldUnit<Storage>
where
    Storage: AsRef<[u8]> + AsMut<[u8]>,
{
    #[inline]
    fn extract_bit(byte: u8, index: usize) -> bool {
        let bit_index = if cfg!(target_endian = "big") {
            7 - (index % 8)
        } else {
            index % 8
        };
        let mask = 1 << bit_index;
        byte & mask == mask
    }
    #[inline]
    pub fn get_bit(&self, index: usize) -> bool {
        debug_assert!(index / 8 < self.storage.as_ref().len());
        let byte_index = index / 8;
        let byte = self.storage.as_ref()[byte_index];
        Self::extract_bit(byte, index)
    }
    #[inline]
    pub unsafe fn raw_get_bit(this: *const Self, index: usize) -> bool {
        debug_assert!(index / 8 < core::mem::size_of::<Storage>());
        let byte_index = index / 8;
        let byte = *(core::ptr::addr_of!((*this).storage) as *const u8).offset(byte_index as isize);
        Self::extract_bit(byte, index)
    }
    #[inline]
    fn change_bit(byte: u8, index: usize, val: bool) -> u8 {
        let bit_index = if cfg!(target_endian = "big") {
            7 - (index % 8)
        } else {
            index % 8
        };
        let mask = 1 << bit_index;
        if val {
            byte | mask
        } else {
            byte & !mask
        }
    }
    #[inline]
    pub fn set_bit(&mut self, index: usize, val: bool) {
        debug_assert!(index / 8 < self.storage.as_ref().len());
        let byte_index = index / 8;
        let byte = &mut self.storage.as_mut()[byte_index];
        *byte = Self::change_bit(*byte, index, val);
    }
    #[inline]
    pub unsafe fn raw_set_bit(this: *mut Self, index: usize, val: bool) {
        debug_assert!(index / 8 < core::mem::size_of::<Storage>());
        let byte_index = index / 8;
        let byte =
            (core::ptr::addr_of_mut!((*this).storage) as *mut u8).offset(byte_index as isize);
        *byte = Self::change_bit(*byte, index, val);
    }
    #[inline]
    pub fn get(&self, bit_offset: usize, bit_width: u8) -> u64 {
        debug_assert!(bit_width <= 64);
        debug_assert!(bit_offset / 8 < self.storage.as_ref().len());
        debug_assert!((bit_offset + (bit_width as usize)) / 8 <= self.storage.as_ref().len());
        let mut val = 0;
        for i in 0..(bit_width as usize) {
            if self.get_bit(i + bit_offset) {
                let index = if cfg!(target_endian = "big") {
                    bit_width as usize - 1 - i
                } else {
                    i
                };
                val |= 1 << index;
            }
        }
        val
    }
    #[inline]
    pub unsafe fn raw_get(this: *const Self, bit_offset: usize, bit_width: u8) -> u64 {
        debug_assert!(bit_width <= 64);
        debug_assert!(bit_offset / 8 < core::mem::size_of::<Storage>());
        debug_assert!((bit_offset + (bit_width as usize)) / 8 <= core::mem::size_of::<Storage>());
        let mut val = 0;
        for i in 0..(bit_width as usize) {
            if Self::raw_get_bit(this, i + bit_offset) {
                let index = if cfg!(target_endian = "big") {
                    bit_width as usize - 1 - i
                } else {
                    i
                };
                val |= 1 << index;
            }
        }
        val
    }
    #[inline]
    pub fn set(&mut self, bit_offset: usize, bit_width: u8, val: u64) {
        debug_assert!(bit_width <= 64);
        debug_assert!(bit_offset / 8 < self.storage.as_ref().len());
        debug_assert!((bit_offset + (bit_width as usize)) / 8 <= self.storage.as_ref().len());
        for i in 0..(bit_width as usize) {
            let mask = 1 << i;
            let val_bit_is_set = val & mask == mask;
            let index = if cfg!(target_endian = "big") {
                bit_width as usize - 1 - i
            } else {
                i
            };
            self.set_bit(index + bit_offset, val_bit_is_set);
        }
    }
    #[inline]
    pub unsafe fn raw_set(this: *mut Self, bit_offset: usize, bit_width: u8, val: u64) {
        debug_assert!(bit_width <= 64);
        debug_assert!(bit_offset / 8 < core::mem::size_of::<Storage>());
        debug_assert!((bit_offset + (bit_width as usize)) / 8 <= core::mem::size_of::<Storage>());
        for i in 0..(bit_width as usize) {
            let mask = 1 << i;
            let val_bit_is_set = val & mask == mask;
            let index = if cfg!(target_endian = "big") {
                bit_width as usize - 1 - i
            } else {
                i
            };
            Self::raw_set_bit(this, index + bit_offset, val_bit_is_set);
        }
    }
}
#[doc = r" If Bindgen could only determine the size and alignment of a"]
#[doc = r" type, it is represented like this."]
#[derive(PartialEq, Copy, Clone, Debug, Hash)]
#[repr(C)]
pub struct __BindgenOpaqueArray<T: Copy, const N: usize>(pub [T; N]);
impl<T: Copy + Default, const N: usize> Default for __BindgenOpaqueArray<T, N> {
    fn default() -> Self {
        Self([<T as Default>::default(); N])
    }
}
#[repr(C)]
#[derive(Default)]
pub struct __IncompleteArrayField<T>(::core::marker::PhantomData<T>, [T; 0]);
impl<T> __IncompleteArrayField<T> {
    #[inline]
    pub const fn new() -> Self {
        __IncompleteArrayField(::core::marker::PhantomData, [])
    }
    #[inline]
    pub fn as_ptr(&self) -> *const T {
        self as *const _ as *const T
    }
    #[inline]
    pub fn as_mut_ptr(&mut self) -> *mut T {
        self as *mut _ as *mut T
    }
    #[inline]
    pub unsafe fn as_slice(&self, len: usize) -> &[T] {
        ::core::slice::from_raw_parts(self.as_ptr(), len)
    }
    #[inline]
    pub unsafe fn as_mut_slice(&mut self, len: usize) -> &mut [T] {
        ::core::slice::from_raw_parts_mut(self.as_mut_ptr(), len)
    }
}
impl<T> ::core::fmt::Debug for __IncompleteArrayField<T> {
    fn fmt(&self, fmt: &mut ::core::fmt::Formatter<'_>) -> ::core::fmt::Result {
        fmt.write_str("__IncompleteArrayField")
    }
}
#[repr(C)]
pub struct __BindgenUnionField<T>(::core::marker::PhantomData<T>);
impl<T> __BindgenUnionField<T> {
    #[inline]
    pub const fn new() -> Self {
        __BindgenUnionField(::core::marker::PhantomData)
    }
    #[inline]
    pub unsafe fn as_ref(&self) -> &T {
        ::core::mem::transmute(self)
    }
    #[inline]
    pub unsafe fn as_mut(&mut self) -> &mut T {
        ::core::mem::transmute(self)
    }
}
impl<T> ::core::default::Default for __BindgenUnionField<T> {
    #[inline]
    fn default() -> Self {
        Self::new()
    }
}
impl<T> ::core::clone::Clone for __BindgenUnionField<T> {
    #[inline]
    fn clone(&self) -> Self {
        *self
    }
}
impl<T> ::core::marker::Copy for __BindgenUnionField<T> {}
impl<T> ::core::fmt::Debug for __BindgenUnionField<T> {
    fn fmt(&self, fmt: &mut ::core::fmt::Formatter<'_>) -> ::core::fmt::Result {
        fmt.write_str("__BindgenUnionField")
    }
}
impl<T> ::core::hash::Hash for __BindgenUnionField<T> {
    fn hash<H: ::core::hash::Hasher>(&self, _state: &mut H) {}
}
impl<T> ::core::cmp::PartialEq for __BindgenUnionField<T> {
    fn eq(&self, _other: &__BindgenUnionField<T>) -> bool {
        true
    }
}
impl<T> ::core::cmp::Eq for __BindgenUnionField<T> {}
pub const CONFIG_RTC_DRV_CROS_EC_MODULE: u32 = 1;
pub const CONFIG_SERIAL_8250_RT288X: u32 = 1;
pub const CONFIG_VIDEO_PVRUSB2_MODULE: u32 = 1;
pub const CONFIG_EDAC_GHES: u32 = 1;
pub const CONFIG_NFC_MRVL_MODULE: u32 = 1;
pub const CONFIG_IPV6_IOAM6_LWTUNNEL: u32 = 1;
pub const CONFIG_RZG2L_THERMAL_MODULE: u32 = 1;
pub const CONFIG_SERIAL_8250_RUNTIME_UARTS: u32 = 32;
pub const CONFIG_USB_GSPCA_PAC7311_MODULE: u32 = 1;
pub const CONFIG_IIO_GTS_HELPER_MODULE: u32 = 1;
pub const CONFIG_GENERIC_PHY_MIPI_DPHY: u32 = 1;
pub const CONFIG_TI_K3_R5_REMOTEPROC_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_SUN8I_CE_MODULE: u32 = 1;
pub const CONFIG_FSL_DPAA2_ETH_DCB: u32 = 1;
pub const CONFIG_NET_CLS_BPF_MODULE: u32 = 1;
pub const CONFIG_ROCKCHIP_DW_MIPI_DSI2: u32 = 1;
pub const CONFIG_SPI_CADENCE_QUADSPI_MODULE: u32 = 1;
pub const CONFIG_PWM_AXI_PWMGEN_MODULE: u32 = 1;
pub const CONFIG_DHT11_MODULE: u32 = 1;
pub const CONFIG_USB_LD_MODULE: u32 = 1;
pub const CONFIG_UBSAN_BOUNDS: u32 = 1;
pub const CONFIG_SPI_BCM2835AUX_MODULE: u32 = 1;
pub const CONFIG_ATH10K_SNOC_MODULE: u32 = 1;
pub const CONFIG_ARCH_USES_HIGH_VMA_FLAGS: u32 = 1;
pub const CONFIG_LEDS_AS3645A_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_SQ930X_MODULE: u32 = 1;
pub const CONFIG_RFKILL_MODULE: u32 = 1;
pub const CONFIG_SPARSEMEM_VMEMMAP_ENABLE: u32 = 1;
pub const CONFIG_STRING_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_QCOM_PD_MAPPER_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_SIMPLE_MODULE: u32 = 1;
pub const CONFIG_NET_9P_VIRTIO_MODULE: u32 = 1;
pub const CONFIG_USB_COMMON: u32 = 1;
pub const CONFIG_MTD_MAP_BANK_WIDTH_1: u32 = 1;
pub const CONFIG_TABLET_SERIAL_WACOM4_MODULE: u32 = 1;
pub const CONFIG_SCSI_ENCLOSURE_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_FIPS: u32 = 1;
pub const CONFIG_MODULE_UNLOAD_TAINT_TRACKING: u32 = 1;
pub const CONFIG_BALLOON_COMPACTION: u32 = 1;
pub const CONFIG_NFT_FIB_IPV4_MODULE: u32 = 1;
pub const CONFIG_QRTR_MODULE: u32 = 1;
pub const CONFIG_MSM_GPUCC_8998_MODULE: u32 = 1;
pub const CONFIG_ARM_SMMU_V3_SVA: u32 = 1;
pub const CONFIG_SND_SOC_TAS6424_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_RK805_MODULE: u32 = 1;
pub const CONFIG_NET_ACT_PEDIT_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_CPT_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA30_AHUB_MODULE: u32 = 1;
pub const CONFIG_MMC_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_SHA256_ARM64: u32 = 1;
pub const CONFIG_CROS_EC_MODULE: u32 = 1;
pub const CONFIG_CM32181_MODULE: u32 = 1;
pub const CONFIG_GPIOLIB: u32 = 1;
pub const CONFIG_USB_DWC2_MODULE: u32 = 1;
pub const CONFIG_DVB_LGS8GXX_MODULE: u32 = 1;
pub const CONFIG_HYPERV_UTILS_MODULE: u32 = 1;
pub const CONFIG_ARCH_MXC: u32 = 1;
pub const CONFIG_NF_CONNTRACK_EVENTS: u32 = 1;
pub const CONFIG_DRM_IMX93_MIPI_DSI_MODULE: u32 = 1;
pub const CONFIG_NET_EMATCH_NBYTE_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_AUO_PIXCIR_MODULE: u32 = 1;
pub const CONFIG_DM_CACHE_SMQ_MODULE: u32 = 1;
pub const CONFIG_IR_SANYO_DECODER_MODULE: u32 = 1;
pub const CONFIG_NFS_V3_MODULE: u32 = 1;
pub const CONFIG_INPUT_KXTJ9_MODULE: u32 = 1;
pub const CONFIG_VIDEO_DEV_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_OV534_MODULE: u32 = 1;
pub const CONFIG_RESET_IMX_SCU_MODULE: u32 = 1;
pub const CONFIG_ANDROID_BINDER_DEVICES: &[u8; 26] = b"binder,hwbinder,vndbinder\0";
pub const CONFIG_KPSS_XCC_MODULE: u32 = 1;
pub const CONFIG_DRM_DW_HDMI_CEC_MODULE: u32 = 1;
pub const CONFIG_VDPA_MODULE: u32 = 1;
pub const CONFIG_SND_EMU10K1_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_MASQUERADE_MODULE: u32 = 1;
pub const CONFIG_VIDEO_HANTRO_IMX8M: u32 = 1;
pub const CONFIG_VL6180_MODULE: u32 = 1;
pub const CONFIG_GPIO_MVEBU: u32 = 1;
pub const CONFIG_V4L2_VP9_MODULE: u32 = 1;
pub const CONFIG_QSEMI_PHY_MODULE: u32 = 1;
pub const CONFIG_RFKILL_INPUT: u32 = 1;
pub const CONFIG_USB_GSPCA_TOUPTEK_MODULE: u32 = 1;
pub const CONFIG_USB_XHCI_RZV2M: u32 = 1;
pub const CONFIG_GENERIC_IRQ_CHIP: u32 = 1;
pub const CONFIG_SND_SOC_MT6357_MODULE: u32 = 1;
pub const CONFIG_USB_ROLE_SWITCH: u32 = 1;
pub const CONFIG_SCSI_MYRB_MODULE: u32 = 1;
pub const CONFIG_IRQ_BYPASS_MANAGER: u32 = 1;
pub const CONFIG_HW_RANDOM_HISI_MODULE: u32 = 1;
pub const CONFIG_REGMAP_SOUNDWIRE_MODULE: u32 = 1;
pub const CONFIG_NET_HANDSHAKE: u32 = 1;
pub const CONFIG_NF_CONNTRACK_OVS: u32 = 1;
pub const CONFIG_SPI_AMLOGIC_SPIFC_A1_MODULE: u32 = 1;
pub const CONFIG_TEGRA_WATCHDOG_MODULE: u32 = 1;
pub const CONFIG_SPI_CADENCE_XSPI_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_RATEEST_MODULE: u32 = 1;
pub const CONFIG_ARM_SCPI_PROTOCOL_MODULE: u32 = 1;
pub const CONFIG_HTS221_I2C_MODULE: u32 = 1;
pub const CONFIG_LIBFDT: u32 = 1;
pub const CONFIG_R8169_MODULE: u32 = 1;
pub const CONFIG_IWLMVM_MODULE: u32 = 1;
pub const CONFIG_ATH10K_CE: u32 = 1;
pub const CONFIG_NFC_PN533_I2C_MODULE: u32 = 1;
pub const CONFIG_PAGE_SHIFT: u32 = 12;
pub const CONFIG_ARM64_ERRATUM_2224489: u32 = 1;
pub const CONFIG_NLS_ASCII: u32 = 1;
pub const CONFIG_UIO_HV_GENERIC_MODULE: u32 = 1;
pub const CONFIG_SND_ES1968_MODULE: u32 = 1;
pub const CONFIG_GPIO_CADENCE_MODULE: u32 = 1;
pub const CONFIG_IMX7ULP_WDT_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_TIME_MODULE: u32 = 1;
pub const CONFIG_AF8133J_MODULE: u32 = 1;
pub const CONFIG_DRIVER_PE_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_SECURITY_LOCKDOWN_LSM_EARLY: u32 = 1;
pub const CONFIG_NFS_COMMON: u32 = 1;
pub const CONFIG_PPPOATM_MODULE: u32 = 1;
pub const CONFIG_WL12XX_MODULE: u32 = 1;
pub const CONFIG_CGROUP_NET_CLASSID: u32 = 1;
pub const CONFIG_NET_DSA_TAG_EDSA_MODULE: u32 = 1;
pub const CONFIG_LOGIG940_FF: u32 = 1;
pub const CONFIG_DVB_ISL6423_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MAX6697_MODULE: u32 = 1;
pub const CONFIG_PCIE_ARMADA_8K: u32 = 1;
pub const CONFIG_I2C_CADENCE_MODULE: u32 = 1;
pub const CONFIG_PHY_CADENCE_DPHY_RX_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_ROCKCHIP_PDM_MODULE: u32 = 1;
pub const CONFIG_TREE_RCU: u32 = 1;
pub const CONFIG_LRU_GEN_WALKS_MMU: u32 = 1;
pub const CONFIG_SYSVIPC_COMPAT: u32 = 1;
pub const CONFIG_CLK_R9A09G011: u32 = 1;
pub const CONFIG_USB_ISP1760_HCD: u32 = 1;
pub const CONFIG_CRYPTO_CRYPTD: u32 = 1;
pub const CONFIG_VIDEO_SAA711X_MODULE: u32 = 1;
pub const CONFIG_INFINIBAND_USER_MAD_MODULE: u32 = 1;
pub const CONFIG_VIDEO_SUN6I_ISP_MODULE: u32 = 1;
pub const CONFIG_GENERIC_SCHED_CLOCK: u32 = 1;
pub const CONFIG_CRYPTO_ECC: u32 = 1;
pub const CONFIG_BMC150_ACCEL_MODULE: u32 = 1;
pub const CONFIG_CRC_CCITT: u32 = 1;
pub const CONFIG_FUNCTION_TRACE_ARGS: u32 = 1;
pub const CONFIG_USB_NET_AX8817X_MODULE: u32 = 1;
pub const CONFIG_SYSTEM_BLACKLIST_HASH_LIST: &[u8; 1] = b"\0";
pub const CONFIG_INFINIBAND_QEDR_MODULE: u32 = 1;
pub const CONFIG_AHCI_XGENE_MODULE: u32 = 1;
pub const CONFIG_NLS_CODEPAGE_437: u32 = 1;
pub const CONFIG_DRM_TI_SN65DSI83_MODULE: u32 = 1;
pub const CONFIG_SENSORS_GL518SM_MODULE: u32 = 1;
pub const CONFIG_RMI4_F03_SERIO_MODULE: u32 = 1;
pub const CONFIG_X9250_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_SOF_PCI_MODULE: u32 = 1;
pub const CONFIG_VIDEO_TC358743_CEC: u32 = 1;
pub const CONFIG_CRYPTO_GCM: u32 = 1;
pub const CONFIG_ICE_SWITCHDEV: u32 = 1;
pub const CONFIG_CRYPTO_WP512_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_AXP209_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TI_EDMA_PCM_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_MAX98396_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_PCM1789_I2C_MODULE: u32 = 1;
pub const CONFIG_SBITMAP: u32 = 1;
pub const CONFIG_DRM_PANEL_STARTEK_KD070FHFID015_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_AIRCABLE_MODULE: u32 = 1;
pub const CONFIG_USB_NET_CDCETHER_MODULE: u32 = 1;
pub const CONFIG_NET_NCSI: u32 = 1;
pub const CONFIG_DMA_NONCOHERENT_MMAP: u32 = 1;
pub const CONFIG_LRU_CACHE_MODULE: u32 = 1;
pub const CONFIG_AS_IS_GNU: u32 = 1;
pub const CONFIG_OF_NUMA: u32 = 1;
pub const CONFIG_STACKPROTECTOR_STRONG: u32 = 1;
pub const CONFIG_RTW88_MODULE: u32 = 1;
pub const CONFIG_PAGE_EXTENSION: u32 = 1;
pub const CONFIG_IR_RC6_DECODER_MODULE: u32 = 1;
pub const CONFIG_K3_RTI_WATCHDOG_MODULE: u32 = 1;
pub const CONFIG_ENCRYPTED_KEYS: u32 = 1;
pub const CONFIG_DVB_USB_UMT_010_MODULE: u32 = 1;
pub const CONFIG_USB_EZUSB_FX2_MODULE: u32 = 1;
pub const CONFIG_ARM_PMUV3: u32 = 1;
pub const CONFIG_IIO_TRIGGER: u32 = 1;
pub const CONFIG_USB_XHCI_PCI_RENESAS: u32 = 1;
pub const CONFIG_EXPORTFS_BLOCK_OPS: u32 = 1;
pub const CONFIG_TERANETICS_PHY_MODULE: u32 = 1;
pub const CONFIG_V4L2_FWNODE_MODULE: u32 = 1;
pub const CONFIG_SENSORS_INA209_MODULE: u32 = 1;
pub const CONFIG_INIT_STACK_ALL_ZERO: u32 = 1;
pub const CONFIG_MMC_SDHCI_OF_ARASAN_MODULE: u32 = 1;
pub const CONFIG_SENSORS_DELTA_AHE50DC_FAN_MODULE: u32 = 1;
pub const CONFIG_ACPI_FAN: u32 = 1;
pub const CONFIG_SND_SOC_ADAU1373_MODULE: u32 = 1;
pub const CONFIG_HID_STEAM_MODULE: u32 = 1;
pub const CONFIG_RANDSTRUCT_NONE: u32 = 1;
pub const CONFIG_HTS221_MODULE: u32 = 1;
pub const CONFIG_RTC_I2C_AND_SPI: u32 = 1;
pub const CONFIG_RADIO_SHARK2_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV9282_MODULE: u32 = 1;
pub const CONFIG_CMA_SIZE_SEL_MBYTES: u32 = 1;
pub const CONFIG_ROMFS_ON_BLOCK: u32 = 1;
pub const CONFIG_TMPFS: u32 = 1;
pub const CONFIG_FUNCTION_ALIGNMENT_4B: u32 = 1;
pub const CONFIG_TINYDRM_MI0283QT_MODULE: u32 = 1;
pub const CONFIG_PMBUS_MODULE: u32 = 1;
pub const CONFIG_MUX_MMIO_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_NETLINK_MODULE: u32 = 1;
pub const CONFIG_DM_MIRROR: u32 = 1;
pub const CONFIG_SDM_VIDEOCC_845_MODULE: u32 = 1;
pub const CONFIG_RTW89_8852BT_MODULE: u32 = 1;
pub const CONFIG_FPGA_MGR_LATTICE_SYSCONFIG_SPI_MODULE: u32 = 1;
pub const CONFIG_ARCH_ZYNQMP: u32 = 1;
pub const CONFIG_VIDEO_OV02A10_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_USB_IRTOUCH: u32 = 1;
pub const CONFIG_HWSPINLOCK_OMAP_MODULE: u32 = 1;
pub const CONFIG_INFINIBAND_ISER_MODULE: u32 = 1;
pub const CONFIG_CARL9170_MODULE: u32 = 1;
pub const CONFIG_DNET_MODULE: u32 = 1;
pub const CONFIG_IPV6: u32 = 1;
pub const CONFIG_GENERIC_IRQ_KEXEC_CLEAR_VM_FORWARD: u32 = 1;
pub const CONFIG_RTC_DRV_FM3130_MODULE: u32 = 1;
pub const CONFIG_MCTP_SERIAL_MODULE: u32 = 1;
pub const CONFIG_SCSI_DMA: u32 = 1;
pub const CONFIG_SIGNALFD: u32 = 1;
pub const CONFIG_SENSORS_INTEL_M10_BMC_HWMON_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_M48T59_MODULE: u32 = 1;
pub const CONFIG_DVB_DDBRIDGE_MODULE: u32 = 1;
pub const CONFIG_V4L2_JPEG_HELPER_MODULE: u32 = 1;
pub const CONFIG_HID_ORTEK_MODULE: u32 = 1;
pub const CONFIG_USB_PWC_INPUT_EVDEV: u32 = 1;
pub const CONFIG_ASYNC_RAID6_RECOV_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_1463225: u32 = 1;
pub const CONFIG_MTD_NAND_TEGRA_MODULE: u32 = 1;
pub const CONFIG_MLX5_SF_MANAGER: u32 = 1;
pub const CONFIG_CPU_FREQ_GOV_PERFORMANCE: u32 = 1;
pub const CONFIG_F2FS_FS_LZORLE: u32 = 1;
pub const CONFIG_CHARGER_LT3651_MODULE: u32 = 1;
pub const CONFIG_SERIAL_AMBA_PL011_CONSOLE: u32 = 1;
pub const CONFIG_CFG80211_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_2441009: u32 = 1;
pub const CONFIG_MMC_CB710_MODULE: u32 = 1;
pub const CONFIG_NFT_TPROXY_MODULE: u32 = 1;
pub const CONFIG_INFINIBAND_RTRS_SERVER_MODULE: u32 = 1;
pub const CONFIG_INPUT_CS40L50_VIBRA_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_MICREL: u32 = 1;
pub const CONFIG_USB_MUSB_SUNXI_MODULE: u32 = 1;
pub const CONFIG_RT2X00_LIB_DEBUGFS: u32 = 1;
pub const CONFIG_DRM_PANEL_SAMSUNG_S6E63J0X03_MODULE: u32 = 1;
pub const CONFIG_MTD_MAP_BANK_WIDTH_2: u32 = 1;
pub const CONFIG_RESET_RZG2L_USBPHY_CTRL_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_ASIX: u32 = 1;
pub const CONFIG_TRANS_TABLE: u32 = 1;
pub const CONFIG_SND_HDA_INTEL_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV5645_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_XILINX_AUDIO_FORMATTER_MODULE: u32 = 1;
pub const CONFIG_SYSFS_SYSCALL: u32 = 1;
pub const CONFIG_DRM_CDNS_MHDP8546_MODULE: u32 = 1;
pub const CONFIG_QCOM_STATS_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_RT700_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_SAFE_PADDED: u32 = 1;
pub const CONFIG_QORIQ_THERMAL_MODULE: u32 = 1;
pub const CONFIG_MFD_RT5120_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TLV320AIC31XX_MODULE: u32 = 1;
pub const CONFIG_REGMAP_I3C_MODULE: u32 = 1;
pub const CONFIG_RENESAS_RZG2L_IRQC: u32 = 1;
pub const CONFIG_MTD_NAND_ECC_MXIC: u32 = 1;
pub const CONFIG_ACPI_HED: u32 = 1;
pub const CONFIG_USB_DWC3_MODULE: u32 = 1;
pub const CONFIG_HID_GOODIX_SPI_MODULE: u32 = 1;
pub const CONFIG_BRIDGE_EBT_IP6_MODULE: u32 = 1;
pub const CONFIG_HAVE_UID16: u32 = 1;
pub const CONFIG_DEVFREQ_GOV_POWERSAVE_MODULE: u32 = 1;
pub const CONFIG_CLK_IMX95_BLK_CTL_MODULE: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_DEBUG_PAGEALLOC: u32 = 1;
pub const CONFIG_VIDEO_AR0521_MODULE: u32 = 1;
pub const CONFIG_UHID_MODULE: u32 = 1;
pub const CONFIG_IR_GPIO_CIR_MODULE: u32 = 1;
pub const CONFIG_MMC_DW_BLUEFIELD_MODULE: u32 = 1;
pub const CONFIG_HID_RAZER_MODULE: u32 = 1;
pub const CONFIG_SECURITY_NETWORK: u32 = 1;
pub const CONFIG_CRYPTO_DRBG: u32 = 1;
pub const CONFIG_VIDEO_SUN8I_DEINTERLACE_MODULE: u32 = 1;
pub const CONFIG_SENSORS_RM3100_I2C_MODULE: u32 = 1;
pub const CONFIG_GIANFAR_MODULE: u32 = 1;
pub const CONFIG_HOTPLUG_SMT: u32 = 1;
pub const CONFIG_IPE_PROP_DM_VERITY: u32 = 1;
pub const CONFIG_NET_IPIP_MODULE: u32 = 1;
pub const CONFIG_WDTPCI_MODULE: u32 = 1;
pub const CONFIG_MTK_NET_PHYLIB_MODULE: u32 = 1;
pub const CONFIG_AIO: u32 = 1;
pub const CONFIG_HID_SPEEDLINK_MODULE: u32 = 1;
pub const CONFIG_DRM_AMDGPU_USERPTR: u32 = 1;
pub const CONFIG_RMNET_MODULE: u32 = 1;
pub const CONFIG_DRM_AMDGPU_SI: u32 = 1;
pub const CONFIG_CLK_IMX8ULP: u32 = 1;
pub const CONFIG_EXTCON_USBC_CROS_EC_MODULE: u32 = 1;
pub const CONFIG_FSL_MC_UAPI_SUPPORT: u32 = 1;
pub const CONFIG_INV_MPU6050_IIO_MODULE: u32 = 1;
pub const CONFIG_GENERIC_IRQ_SHOW: u32 = 1;
pub const CONFIG_SM_GCC_8550_MODULE: u32 = 1;
pub const CONFIG_DRM_AMD_ISP: u32 = 1;
pub const CONFIG_SND_SOC_QDSP6_PRM_MODULE: u32 = 1;
pub const CONFIG_SCSI_DH_RDAC_MODULE: u32 = 1;
pub const CONFIG_HNS3_DCB: u32 = 1;
pub const CONFIG_JFFS2_FS_SECURITY: u32 = 1;
pub const CONFIG_BLOCK_LEGACY_AUTOLOAD: u32 = 1;
pub const CONFIG_VIDEO_GC2145_MODULE: u32 = 1;
pub const CONFIG_HP_WATCHDOG_MODULE: u32 = 1;
pub const CONFIG_PCI_SW_SWITCHTEC_MODULE: u32 = 1;
pub const CONFIG_DWMAC_GENERIC_MODULE: u32 = 1;
pub const CONFIG_SECURITY_TOMOYO_MAX_ACCEPT_ENTRY: u32 = 2048;
pub const CONFIG_MPU3050_I2C_MODULE: u32 = 1;
pub const CONFIG_VIDEO_TDA7432_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_WM8994_MODULE: u32 = 1;
pub const CONFIG_SPI_SUN6I_MODULE: u32 = 1;
pub const CONFIG_NETFS_SUPPORT_MODULE: u32 = 1;
pub const CONFIG_ACPI_HOTPLUG_MEMORY: u32 = 1;
pub const CONFIG_CAN_KVASER_USB_MODULE: u32 = 1;
pub const CONFIG_MTD_RAW_NAND_MODULE: u32 = 1;
pub const CONFIG_TI_ADC128S052_MODULE: u32 = 1;
pub const CONFIG_HID_WINWING_MODULE: u32 = 1;
pub const CONFIG_GPIO_DWAPB_MODULE: u32 = 1;
pub const CONFIG_RPCSEC_GSS_KRB5_MODULE: u32 = 1;
pub const CONFIG_DP83848_PHY_MODULE: u32 = 1;
pub const CONFIG_WDAT_WDT_MODULE: u32 = 1;
pub const CONFIG_PCI_PASID: u32 = 1;
pub const CONFIG_WL1251_SDIO_MODULE: u32 = 1;
pub const CONFIG_VIDEO_E5010_JPEG_ENC_MODULE: u32 = 1;
pub const CONFIG_ZYNQMP_FIRMWARE: u32 = 1;
pub const CONFIG_SC_DISPCC_7180_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_SHARP_LQ101R1SX01_MODULE: u32 = 1;
pub const CONFIG_F2FS_FS_MODULE: u32 = 1;
pub const CONFIG_IP_VS_MH_TAB_INDEX: u32 = 12;
pub const CONFIG_CRYPTO_KPP: u32 = 1;
pub const CONFIG_GENERIC_STRNLEN_USER: u32 = 1;
pub const CONFIG_SUN50I_H616_CCU: u32 = 1;
pub const CONFIG_HW_RANDOM_ROCKCHIP_MODULE: u32 = 1;
pub const CONFIG_NET_FOU_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_SC7280_MODULE: u32 = 1;
pub const CONFIG_OF_IRQ: u32 = 1;
pub const CONFIG_PWM_XILINX_MODULE: u32 = 1;
pub const CONFIG_VIDEO_DW9714_MODULE: u32 = 1;
pub const CONFIG_I2C_TEGRA_BPMP_MODULE: u32 = 1;
pub const CONFIG_SND_LAYLA20_MODULE: u32 = 1;
pub const CONFIG_BLK_SED_OPAL: u32 = 1;
pub const CONFIG_PGTABLE_LEVELS: u32 = 4;
pub const CONFIG_QFMT_V2: u32 = 1;
pub const CONFIG_CRYPTO_ECB: u32 = 1;
pub const CONFIG_DRM_AST_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_MICROSOFT: u32 = 1;
pub const CONFIG_IDLE_PAGE_TRACKING: u32 = 1;
pub const CONFIG_CRYPTO_DEV_SA2UL_MODULE: u32 = 1;
pub const CONFIG_B44_MODULE: u32 = 1;
pub const CONFIG_TI_MESSAGE_MANAGER: u32 = 1;
pub const CONFIG_BT_BNEP_MODULE: u32 = 1;
pub const CONFIG_MVEBU_ICU: u32 = 1;
pub const CONFIG_MFD_QNAP_MCU_MODULE: u32 = 1;
pub const CONFIG_REGMAP: u32 = 1;
pub const CONFIG_SLAB_OBJ_EXT: u32 = 1;
pub const CONFIG_CRYPTO_ARCH_HAVE_LIB_POLY1305: u32 = 1;
pub const CONFIG_BT_HCIBPA10X_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MAX1619_MODULE: u32 = 1;
pub const CONFIG_QCOM_CPR_MODULE: u32 = 1;
pub const CONFIG_PCI_ATS: u32 = 1;
pub const CONFIG_SCSI_SYM53C8XX_MAX_TAGS: u32 = 64;
pub const CONFIG_NET_VENDOR_8390: u32 = 1;
pub const CONFIG_NLS_MAC_ROMANIAN_MODULE: u32 = 1;
pub const CONFIG_USB_NET_GL620A_MODULE: u32 = 1;
pub const CONFIG_TEGRA186_TIMER: u32 = 1;
pub const CONFIG_DVB_ZL10039_MODULE: u32 = 1;
pub const CONFIG_LED_TRIGGER_PHY: u32 = 1;
pub const CONFIG_DRM_FBDEV_EMULATION: u32 = 1;
pub const CONFIG_DRM_ANALOGIX_DP_MODULE: u32 = 1;
pub const CONFIG_USER_NS: u32 = 1;
pub const CONFIG_RT73USB_MODULE: u32 = 1;
pub const CONFIG_NFSD_V4_2_INTER_SSC: u32 = 1;
pub const CONFIG_TOUCHSCREEN_CY8CTMA140_MODULE: u32 = 1;
pub const CONFIG_HWMON_VID_MODULE: u32 = 1;
pub const CONFIG_MWL8K_MODULE: u32 = 1;
pub const CONFIG_RTW89_MODULE: u32 = 1;
pub const CONFIG_POWER_RESET_XGENE: u32 = 1;
pub const CONFIG_MODULE_DEBUGFS: u32 = 1;
pub const CONFIG_GENERIC_HWEIGHT: u32 = 1;
pub const CONFIG_LEDS_LM3601X_MODULE: u32 = 1;
pub const CONFIG_SECURITY_YAMA: u32 = 1;
pub const CONFIG_VIDEO_SONY_BTF_MPX_MODULE: u32 = 1;
pub const CONFIG_RTW88_8822BE_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_ADAU1372_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_SM6115_MODULE: u32 = 1;
pub const CONFIG_DRM_PANIC_SCREEN: &[u8; 5] = b"user\0";
pub const CONFIG_ACPI_AC: u32 = 1;
pub const CONFIG_USB_SERIAL_OPTION_MODULE: u32 = 1;
pub const CONFIG_SCD30_SERIAL_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_QCE_SHA: u32 = 1;
pub const CONFIG_IEEE802154_ATUSB_MODULE: u32 = 1;
pub const CONFIG_NVME_AUTH_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_QAT_C62XVF_MODULE: u32 = 1;
pub const CONFIG_EROFS_FS_POSIX_ACL: u32 = 1;
pub const CONFIG_SND_AU8810_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_MEMBARRIER_SYNC_CORE: u32 = 1;
pub const CONFIG_SND_SOC_RT5616_MODULE: u32 = 1;
pub const CONFIG_USB_RTL8152_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_ADC_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV8856_MODULE: u32 = 1;
pub const CONFIG_GAMEPORT_FM801_MODULE: u32 = 1;
pub const CONFIG_I2C_CP2615_MODULE: u32 = 1;
pub const CONFIG_W1_SLAVE_DS28E04_MODULE: u32 = 1;
pub const CONFIG_DRM_ITE_IT6505_MODULE: u32 = 1;
pub const CONFIG_HAVE_C_RECORDMCOUNT: u32 = 1;
pub const CONFIG_DRM_PANEL_SITRONIX_ST7703_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_VIA: u32 = 1;
pub const CONFIG_SND_SOC_MSM8916_WCD_ANALOG_MODULE: u32 = 1;
pub const CONFIG_RESET_MESON_COMMON: u32 = 1;
pub const CONFIG_NF_TABLES_IPV4: u32 = 1;
pub const CONFIG_MAC80211_STA_HASH_MAX_SIZE: u32 = 0;
pub const CONFIG_DEBUG_WX: u32 = 1;
pub const CONFIG_TICK_ONESHOT: u32 = 1;
pub const CONFIG_INET_ESP_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_SAFE_MODULE: u32 = 1;
pub const CONFIG_NFC_NXP_NCI_I2C_MODULE: u32 = 1;
pub const CONFIG_INFINIBAND_MODULE: u32 = 1;
pub const CONFIG_MDIO_XGENE_MODULE: u32 = 1;
pub const CONFIG_VIDEO_TW9903_MODULE: u32 = 1;
pub const CONFIG_ARCH_WANT_HUGE_PMD_SHARE: u32 = 1;
pub const CONFIG_SM_GCC_7150_MODULE: u32 = 1;
pub const CONFIG_RSI_USB_MODULE: u32 = 1;
pub const CONFIG_RSI_COEX: u32 = 1;
pub const CONFIG_DRM: u32 = 1;
pub const CONFIG_VIDEO_RENESAS_VSP1_MODULE: u32 = 1;
pub const CONFIG_BCMA_POSSIBLE: u32 = 1;
pub const CONFIG_NF_REJECT_IPV6_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV8865_MODULE: u32 = 1;
pub const CONFIG_NFC_MODULE: u32 = 1;
pub const CONFIG_NFSD_V4_SECURITY_LABEL: u32 = 1;
pub const CONFIG_MLXSW_MINIMAL_MODULE: u32 = 1;
pub const CONFIG_TI_K3_DSP_REMOTEPROC_MODULE: u32 = 1;
pub const CONFIG_MFD_TPS6594_MODULE: u32 = 1;
pub const CONFIG_MT76_USB_MODULE: u32 = 1;
pub const CONFIG_TCG_TPM: u32 = 1;
pub const CONFIG_USB_ISIGHTFW_MODULE: u32 = 1;
pub const CONFIG_PCIE_DW_PLAT: u32 = 1;
pub const CONFIG_QCOM_COINCELL_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_SCMI: u32 = 1;
pub const CONFIG_SND_SOC_APQ8016_SBC_MODULE: u32 = 1;
pub const CONFIG_NET_DSA_TAG_DSA_COMMON_MODULE: u32 = 1;
pub const CONFIG_BMI270_MODULE: u32 = 1;
pub const CONFIG_CLK_R9A09G057: u32 = 1;
pub const CONFIG_STMMAC_ETH_MODULE: u32 = 1;
pub const CONFIG_USB_YUREX_MODULE: u32 = 1;
pub const CONFIG_USB_IPHETH_MODULE: u32 = 1;
pub const CONFIG_BCACHEFS_QUOTA: u32 = 1;
pub const CONFIG_DMA_BOUNCE_UNALIGNED_KMALLOC: u32 = 1;
pub const CONFIG_USB_GSPCA_PAC7302_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_VERTEXCOM: u32 = 1;
pub const CONFIG_IIO_TIGHTLOOP_TRIGGER_MODULE: u32 = 1;
pub const CONFIG_TI_K3_M4_REMOTEPROC_MODULE: u32 = 1;
pub const CONFIG_BLK_DEV_MD: u32 = 1;
pub const CONFIG_NET_DSA_TAG_QCA_MODULE: u32 = 1;
pub const CONFIG_CPU_LITTLE_ENDIAN: u32 = 1;
pub const CONFIG_MEMSTICK_R592_MODULE: u32 = 1;
pub const CONFIG_I2C_RIIC_MODULE: u32 = 1;
pub const CONFIG_VFIO_PCI_MODULE: u32 = 1;
pub const CONFIG_TEHUTI_MODULE: u32 = 1;
pub const CONFIG_BATMAN_ADV_NC: u32 = 1;
pub const CONFIG_SND_PCM_IEC958: u32 = 1;
pub const CONFIG_CPUMASK_OFFSTACK: u32 = 1;
pub const CONFIG_I2C_ALGOPCA_MODULE: u32 = 1;
pub const CONFIG_BATTERY_BQ27XXX_I2C_MODULE: u32 = 1;
pub const CONFIG_ISCSI_TCP_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_QCOM_SPMI_MODULE: u32 = 1;
pub const CONFIG_MIPI_I3C_HCI_PCI_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_TRACE_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_GENERIC: u32 = 1;
pub const CONFIG_DMIID: u32 = 1;
pub const CONFIG_NFC_DIGITAL_MODULE: u32 = 1;
pub const CONFIG_MLX5_SF: u32 = 1;
pub const CONFIG_DM9051_MODULE: u32 = 1;
pub const CONFIG_CORESIGHT_STM_MODULE: u32 = 1;
pub const CONFIG_BRIDGE_EBT_NFLOG_MODULE: u32 = 1;
pub const CONFIG_INFINIBAND_MTHCA_MODULE: u32 = 1;
pub const CONFIG_HID_SIGMAMICRO_MODULE: u32 = 1;
pub const CONFIG_NF_DUP_IPV4_MODULE: u32 = 1;
pub const CONFIG_IR_IMON_RAW_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_PCM3168A_I2C_MODULE: u32 = 1;
pub const CONFIG_CAN_IFI_CANFD_MODULE: u32 = 1;
pub const CONFIG_BRIDGE_EBT_SNAT_MODULE: u32 = 1;
pub const CONFIG_USB_GPIO_VBUS_MODULE: u32 = 1;
pub const CONFIG_RELAY: u32 = 1;
pub const CONFIG_BLACKHOLE_DEV_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_CPUSETS: u32 = 1;
pub const CONFIG_PINCTRL_MLXBF3_MODULE: u32 = 1;
pub const CONFIG_MTD_NAND_CADENCE_MODULE: u32 = 1;
pub const CONFIG_DRM_NOUVEAU_MODULE: u32 = 1;
pub const CONFIG_AD4130_MODULE: u32 = 1;
pub const CONFIG_USB_KC2190: u32 = 1;
pub const CONFIG_PCIE_CADENCE_PLAT_HOST: u32 = 1;
pub const CONFIG_SND_HDA_CODEC_VIA_MODULE: u32 = 1;
pub const CONFIG_BCM2835_VCHIQ_MODULE: u32 = 1;
pub const CONFIG_RESET_SCMI: u32 = 1;
pub const CONFIG_CPU_FREQ_STAT: u32 = 1;
pub const CONFIG_LOOPBACK_TARGET_MODULE: u32 = 1;
pub const CONFIG_SCSI_MVSAS_MODULE: u32 = 1;
pub const CONFIG_AL3000A_MODULE: u32 = 1;
pub const CONFIG_MLX5_INFINIBAND_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_CLASSIFY_MODULE: u32 = 1;
pub const CONFIG_LXT_PHY_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_DAVICOM: u32 = 1;
pub const CONFIG_NVME_TARGET_AUTH: u32 = 1;
pub const CONFIG_DRM_MESON_MODULE: u32 = 1;
pub const CONFIG_MFD_RSMU_SPI_MODULE: u32 = 1;
pub const CONFIG_SPI_RSPI_MODULE: u32 = 1;
pub const CONFIG_NFS_V3_ACL: u32 = 1;
pub const CONFIG_DVB_SMIPCIE_MODULE: u32 = 1;
pub const CONFIG_CRC_T10DIF: u32 = 1;
pub const CONFIG_ATA_BMDMA: u32 = 1;
pub const CONFIG_ARM_SMMU_V3: u32 = 1;
pub const CONFIG_USB_TMC_MODULE: u32 = 1;
pub const CONFIG_PPPOE_HASH_BITS_4: u32 = 1;
pub const CONFIG_BCMA_HOST_PCI: u32 = 1;
pub const CONFIG_QCOM_OCMEM_MODULE: u32 = 1;
pub const CONFIG_QCA83XX_PHY_MODULE: u32 = 1;
pub const CONFIG_SECURITY_LANDLOCK: u32 = 1;
pub const CONFIG_NET_DSA_TAG_DSA_MODULE: u32 = 1;
pub const CONFIG_X509_CERTIFICATE_PARSER: u32 = 1;
pub const CONFIG_DRM_NWL_MIPI_DSI_MODULE: u32 = 1;
pub const CONFIG_MAC80211_RC_DEFAULT: &[u8; 12] = b"minstrel_ht\0";
pub const CONFIG_MCP41010_MODULE: u32 = 1;
pub const CONFIG_HID_CYPRESS_MODULE: u32 = 1;
pub const CONFIG_MLX4_INFINIBAND_MODULE: u32 = 1;
pub const CONFIG_RICHTEK_RTQ6056_MODULE: u32 = 1;
pub const CONFIG_DP83822_PHY_MODULE: u32 = 1;
pub const CONFIG_SKGE_GENESIS: u32 = 1;
pub const CONFIG_EVENTFD: u32 = 1;
pub const CONFIG_TEGRA241_CMDQV: u32 = 1;
pub const CONFIG_SND_SOC_WM8903_MODULE: u32 = 1;
pub const CONFIG_NFC_NCI_SPI_MODULE: u32 = 1;
pub const CONFIG_GENERIC_CPU_VULNERABILITIES: u32 = 1;
pub const CONFIG_PINCTRL_SM8450_LPASS_LPI_MODULE: u32 = 1;
pub const CONFIG_BACKLIGHT_LM3630A_MODULE: u32 = 1;
pub const CONFIG_FXAS21002C_MODULE: u32 = 1;
pub const CONFIG_SYSTEM_BLACKLIST_KEYRING: u32 = 1;
pub const CONFIG_DRM_PARADE_PS8640_MODULE: u32 = 1;
pub const CONFIG_I2C_MUX_GPIO_MODULE: u32 = 1;
pub const CONFIG_QCOM_L2_PMU: u32 = 1;
pub const CONFIG_PCIE_ROCKCHIP_DW_HOST: u32 = 1;
pub const CONFIG_NFSD_V4: u32 = 1;
pub const CONFIG_NUMA: u32 = 1;
pub const CONFIG_VIDEO_HEXIUM_GEMINI_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_I2C_AND_SPI_MODULE: u32 = 1;
pub const CONFIG_HID_VIVALDI_COMMON_MODULE: u32 = 1;
pub const CONFIG_NET_SHAPER: u32 = 1;
pub const CONFIG_TI_AM335X_ADC_MODULE: u32 = 1;
pub const CONFIG_ZLIB_DEFLATE: u32 = 1;
pub const CONFIG_BNXT_HWMON: u32 = 1;
pub const CONFIG_DRM_ZYNQMP_DPSUB_AUDIO: u32 = 1;
pub const CONFIG_PID_IN_CONTEXTIDR: u32 = 1;
pub const CONFIG_USB_NET_DM9601_MODULE: u32 = 1;
pub const CONFIG_PCIE_XILINX_DMA_PL: u32 = 1;
pub const CONFIG_SCSI_ARCMSR_MODULE: u32 = 1;
pub const CONFIG_WLCORE_MODULE: u32 = 1;
pub const CONFIG_IP_NF_NAT_MODULE: u32 = 1;
pub const CONFIG_B43_PHY_HT: u32 = 1;
pub const CONFIG_PNP: u32 = 1;
pub const CONFIG_SATA_AHCI: u32 = 1;
pub const CONFIG_HID_SONY_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_PCRYPT_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_CHELSIO: u32 = 1;
pub const CONFIG_SND_HDA_CODEC_CMEDIA_MODULE: u32 = 1;
pub const CONFIG_NF_DEFRAG_IPV6_MODULE: u32 = 1;
pub const CONFIG_SENSORS_ADP1050_MODULE: u32 = 1;
pub const CONFIG_PCI_NPEM: u32 = 1;
pub const CONFIG_SND_SOC_ADAU17X1_MODULE: u32 = 1;
pub const CONFIG_GCC_SUPPORTS_DYNAMIC_FTRACE_WITH_ARGS: u32 = 1;
pub const CONFIG_SERIAL_SC16IS7XX_SPI_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_MAX98390_MODULE: u32 = 1;
pub const CONFIG_SUNXI_NMI_INTC: u32 = 1;
pub const CONFIG_ARM_SMMU: u32 = 1;
pub const CONFIG_IXGBE_IPSEC: u32 = 1;
pub const CONFIG_ZSMALLOC: u32 = 1;
pub const CONFIG_MESON_SECURE_PM_DOMAINS: u32 = 1;
pub const CONFIG_CRYPTO_RNG: u32 = 1;
pub const CONFIG_HID_SENSOR_ALS_MODULE: u32 = 1;
pub const CONFIG_TCP_CONG_DCTCP_MODULE: u32 = 1;
pub const CONFIG_SM_CAMCC_7150_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_MAX77650_MODULE: u32 = 1;
pub const CONFIG_NLMON_MODULE: u32 = 1;
pub const CONFIG_FILE_LOCKING: u32 = 1;
pub const CONFIG_CORESIGHT_SINK_TPIU_MODULE: u32 = 1;
pub const CONFIG_NOUVEAU_DEBUG: u32 = 5;
pub const CONFIG_MAG3110_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TFA989X_MODULE: u32 = 1;
pub const CONFIG_FUNCTION_ALIGNMENT_8B: u32 = 1;
pub const CONFIG_TI_K3_AM65_CPSW_NUSS_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_ABEOZ9_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_HMAC: u32 = 1;
pub const CONFIG_TEE_MODULE: u32 = 1;
pub const CONFIG_PCIE_MICROCHIP_HOST: u32 = 1;
pub const CONFIG_ADXL355_I2C_MODULE: u32 = 1;
pub const CONFIG_DMA_VIRTUAL_CHANNELS: u32 = 1;
pub const CONFIG_DRM_PANEL_ILITEK_ILI9341_MODULE: u32 = 1;
pub const CONFIG_SCSI_INITIO_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_FIXED_VOLTAGE: u32 = 1;
pub const CONFIG_GP_PCI1XXXX_MODULE: u32 = 1;
pub const CONFIG_GPIO_VIRTIO_MODULE: u32 = 1;
pub const CONFIG_PGTABLE_HAS_HUGE_LEAVES: u32 = 1;
pub const CONFIG_FS_ENCRYPTION_ALGS: u32 = 1;
pub const CONFIG_SND_SUN4I_I2S_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_CYTTSP5_MODULE: u32 = 1;
pub const CONFIG_STACKINIT_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_AD7766_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_USER_API_SKCIPHER: u32 = 1;
pub const CONFIG_SND_SOC_TLV320AIC32X4_SPI_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_FCRYPT_MODULE: u32 = 1;
pub const CONFIG_CROS_EC_SENSORHUB_MODULE: u32 = 1;
pub const CONFIG_IEEE802154_CC2520_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_AES: u32 = 1;
pub const CONFIG_SND_HDA_PREALLOC_SIZE: u32 = 2048;
pub const CONFIG_USB_XUSBATM_MODULE: u32 = 1;
pub const CONFIG_PAGE_SIZE_4KB: u32 = 1;
pub const CONFIG_NFSD_V4_DELEG_TIMESTAMPS: u32 = 1;
pub const CONFIG_I2C_CHARDEV_MODULE: u32 = 1;
pub const CONFIG_BCM_NET_PHYPTP_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MAX31760_MODULE: u32 = 1;
pub const CONFIG_VIDEO_VIM2M_MODULE: u32 = 1;
pub const CONFIG_AF_UNIX_OOB: u32 = 1;
pub const CONFIG_QCOM_NET_PHYLIB_MODULE: u32 = 1;
pub const CONFIG_MMC_SPI_MODULE: u32 = 1;
pub const CONFIG_INPUT_JOYDEV_MODULE: u32 = 1;
pub const CONFIG_DVB_MN88472_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_CCP_DD_MODULE: u32 = 1;
pub const CONFIG_DMI: u32 = 1;
pub const CONFIG_HAVE_DYNAMIC_FTRACE: u32 = 1;
pub const CONFIG_AFS_FS_MODULE: u32 = 1;
pub const CONFIG_BT_VIRTIO_MODULE: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_CRASH_DUMP: u32 = 1;
pub const CONFIG_DEV_SYNC_PROBE_MODULE: u32 = 1;
pub const CONFIG_QCOM_SMD_RPM_MODULE: u32 = 1;
pub const CONFIG_VIRTIO_CONSOLE: u32 = 1;
pub const CONFIG_MDIO_I2C_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV13858_MODULE: u32 = 1;
pub const CONFIG_SMC_MODULE: u32 = 1;
pub const CONFIG_IDPF_MODULE: u32 = 1;
pub const CONFIG_RPMSG_WWAN_CTRL_MODULE: u32 = 1;
pub const CONFIG_DVB_OR51211_MODULE: u32 = 1;
pub const CONFIG_SND_HDA_ALIGNED_MMIO: u32 = 1;
pub const CONFIG_RTC_DRV_MAX6916_MODULE: u32 = 1;
pub const CONFIG_MFD_ROHM_BD96801_MODULE: u32 = 1;
pub const CONFIG_STUB_CLK_HI6220: u32 = 1;
pub const CONFIG_NET_IFE_SKBTCINDEX_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_UPD78F0730_MODULE: u32 = 1;
pub const CONFIG_HID_ROCCAT_MODULE: u32 = 1;
pub const CONFIG_MAX34408_MODULE: u32 = 1;
pub const CONFIG_DWMAC_TEGRA_MODULE: u32 = 1;
pub const CONFIG_ATH10K_DEBUGFS: u32 = 1;
pub const CONFIG_TCM_PSCSI_MODULE: u32 = 1;
pub const CONFIG_HID_KYSONA_MODULE: u32 = 1;
pub const CONFIG_IP6_NF_TARGET_SYNPROXY_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV5647_MODULE: u32 = 1;
pub const CONFIG_RESET_MESON_MODULE: u32 = 1;
pub const CONFIG_NET_SCH_HFSC_MODULE: u32 = 1;
pub const CONFIG_SENSORS_DRIVETEMP_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_FSL_CAAM_INTC_TIME_THLD: u32 = 8192;
pub const CONFIG_GENERIC_MSI_IRQ: u32 = 1;
pub const CONFIG_FB_SYS_COPYAREA: u32 = 1;
pub const CONFIG_OF_DYNAMIC: u32 = 1;
pub const CONFIG_ARM_DMC620_PMU_MODULE: u32 = 1;
pub const CONFIG_POWER_SUPPLY: u32 = 1;
pub const CONFIG_HAVE_MOD_ARCH_SPECIFIC: u32 = 1;
pub const CONFIG_ROCKER_MODULE: u32 = 1;
pub const CONFIG_CROS_TYPEC_SWITCH_MODULE: u32 = 1;
pub const CONFIG_FPGA_DFL_EMIF_MODULE: u32 = 1;
pub const CONFIG_DEVTMPFS: u32 = 1;
pub const CONFIG_SURFACE_PLATFORMS: u32 = 1;
pub const CONFIG_HAVE_DEBUG_KMEMLEAK: u32 = 1;
pub const CONFIG_BLK_DEV_BSG: u32 = 1;
pub const CONFIG_MEDIA_PCI_SUPPORT: u32 = 1;
pub const CONFIG_AT803X_PHY_MODULE: u32 = 1;
pub const CONFIG_MESON_CANVAS_MODULE: u32 = 1;
pub const CONFIG_MACVTAP_MODULE: u32 = 1;
pub const CONFIG_IPE_PROP_FS_VERITY: u32 = 1;
pub const CONFIG_IPV6_FOU_MODULE: u32 = 1;
pub const CONFIG_VIDEO_TEGRA_MODULE: u32 = 1;
pub const CONFIG_DRM_DISPLAY_HDMI_HELPER: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_PHYSDEV_MODULE: u32 = 1;
pub const CONFIG_USB_ANNOUNCE_NEW_DEVICES: u32 = 1;
pub const CONFIG_USB_NET_QMI_WWAN_MODULE: u32 = 1;
pub const CONFIG_QCOM_LMH_MODULE: u32 = 1;
pub const CONFIG_RT2800PCI_RT53XX: u32 = 1;
pub const CONFIG_USB_USBNET_MODULE: u32 = 1;
pub const CONFIG_INPUT_EVDEV: u32 = 1;
pub const CONFIG_IPV6_ROUTE_INFO: u32 = 1;
pub const CONFIG_TI_ADS1015_MODULE: u32 = 1;
pub const CONFIG_QCOM_BAM_DMUX_MODULE: u32 = 1;
pub const CONFIG_HZ_1000: u32 = 1;
pub const CONFIG_HUGETLBFS: u32 = 1;
pub const CONFIG_SND_SOC_IMX_CARD_MODULE: u32 = 1;
pub const CONFIG_INTEGRITY_PLATFORM_KEYRING: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA30_I2S_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA20_DAS_MODULE: u32 = 1;
pub const CONFIG_KERNEL_MODE_NEON: u32 = 1;
pub const CONFIG_BCM2712_MIP: u32 = 1;
pub const CONFIG_CIFS_XATTR: u32 = 1;
pub const CONFIG_MHI_BUS_MODULE: u32 = 1;
pub const CONFIG_MLX5_CORE_EN_DCB: u32 = 1;
pub const CONFIG_ZRAM_BACKEND_842: u32 = 1;
pub const CONFIG_SENSORS_NPCM7XX_MODULE: u32 = 1;
pub const CONFIG_I2C_THUNDERX_MODULE: u32 = 1;
pub const CONFIG_DRM_MESON_DW_MIPI_DSI_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TS3A227E_MODULE: u32 = 1;
pub const CONFIG_USB_NET_RNDIS_HOST_MODULE: u32 = 1;
pub const CONFIG_NETWORK_FILESYSTEMS: u32 = 1;
pub const CONFIG_SM_VIDEOCC_8250_MODULE: u32 = 1;
pub const CONFIG_MISC_RTSX_PCI_MODULE: u32 = 1;
pub const CONFIG_XFS_QUOTA: u32 = 1;
pub const CONFIG_RTW88_8814AE_MODULE: u32 = 1;
pub const CONFIG_PWM_OMAP_DMTIMER_MODULE: u32 = 1;
pub const CONFIG_COMPACT_UNEVICTABLE_DEFAULT: u32 = 1;
pub const CONFIG_ARCH_HAS_DEBUG_WX: u32 = 1;
pub const CONFIG_VIDEO_HI556_MODULE: u32 = 1;
pub const CONFIG_NET_EGRESS: u32 = 1;
pub const CONFIG_SND_USB_CAIAQ_MODULE: u32 = 1;
pub const CONFIG_SM_DISPCC_8450_MODULE: u32 = 1;
pub const CONFIG_MLX5_SW_STEERING: u32 = 1;
pub const CONFIG_W1_MASTER_DS2490_MODULE: u32 = 1;
pub const CONFIG_USB_XHCI_PLATFORM_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TLV320AIC32X4_I2C_MODULE: u32 = 1;
pub const CONFIG_CROSS_MEMORY_ATTACH: u32 = 1;
pub const CONFIG_LD_ORPHAN_WARN: u32 = 1;
pub const CONFIG_EROFS_FS_BACKED_BY_FILE: u32 = 1;
pub const CONFIG_USB_SERIAL_CH341_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_RS9_PCIE_MODULE: u32 = 1;
pub const CONFIG_INET_TCP_DIAG: u32 = 1;
pub const CONFIG_DRM_EXEC_MODULE: u32 = 1;
pub const CONFIG_AHCI_SUNXI_MODULE: u32 = 1;
pub const CONFIG_KEYBOARD_ATKBD: u32 = 1;
pub const CONFIG_SENSORS_ASC7621_MODULE: u32 = 1;
pub const CONFIG_MXC6255_MODULE: u32 = 1;
pub const CONFIG_CLK_PX30: u32 = 1;
pub const CONFIG_TMP006_MODULE: u32 = 1;
pub const CONFIG_VIDEO_AK881X_MODULE: u32 = 1;
pub const CONFIG_HID_NTRIG: u32 = 1;
pub const CONFIG_ARCH_WANT_LD_ORPHAN_WARN: u32 = 1;
pub const CONFIG_EROFS_FS_MODULE: u32 = 1;
pub const CONFIG_VIDEO_SAA7164_MODULE: u32 = 1;
pub const CONFIG_QCOM_VADC_COMMON_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_3194386: u32 = 1;
pub const CONFIG_DTPM_DEVFREQ: u32 = 1;
pub const CONFIG_RTC_DRV_STK17TA8_MODULE: u32 = 1;
pub const CONFIG_SENSORS_QNAP_MCU_HWMON_MODULE: u32 = 1;
pub const CONFIG_USB_NET_CDC_SUBSET_ENABLE_MODULE: u32 = 1;
pub const CONFIG_NF_CONNTRACK_TFTP_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TLV320AIC23_SPI_MODULE: u32 = 1;
pub const CONFIG_BPF_PRELOAD: u32 = 1;
pub const CONFIG_PARAVIRT_TIME_ACCOUNTING: u32 = 1;
pub const CONFIG_I2C_NVIDIA_GPU_MODULE: u32 = 1;
pub const CONFIG_OBJAGG_MODULE: u32 = 1;
pub const CONFIG_SND_GINA20_MODULE: u32 = 1;
pub const CONFIG_EDAC_BLUEFIELD_MODULE: u32 = 1;
pub const CONFIG_DVB_BUDGET_CORE_MODULE: u32 = 1;
pub const CONFIG_BLK_DEV_INTEGRITY: u32 = 1;
pub const CONFIG_DM_INIT: u32 = 1;
pub const CONFIG_USB_CDNS3_GADGET: u32 = 1;
pub const CONFIG_PPPOL2TP_MODULE: u32 = 1;
pub const CONFIG_ACPI_DEBUG: u32 = 1;
pub const CONFIG_CRYPTO_DEV_SUN8I_SS_HASH: u32 = 1;
pub const CONFIG_IOMMU_SVA: u32 = 1;
pub const CONFIG_BACKLIGHT_ARCXCNN_MODULE: u32 = 1;
pub const CONFIG_SENSORS_DPS920AB_MODULE: u32 = 1;
pub const CONFIG_EXTCON_LC824206XA_MODULE: u32 = 1;
pub const CONFIG_VIDEO: u32 = 1;
pub const CONFIG_VIDEO_MT9M114_MODULE: u32 = 1;
pub const CONFIG_ARCH_NXP: u32 = 1;
pub const CONFIG_AHCI_IMX_MODULE: u32 = 1;
pub const CONFIG_ROCKCHIP_IOMMU: u32 = 1;
pub const CONFIG_ALIM7101_WDT_MODULE: u32 = 1;
pub const CONFIG_DRM_EXPORT_FOR_TESTS: u32 = 1;
pub const CONFIG_SUN50I_ERRATUM_UNKNOWN1: u32 = 1;
pub const CONFIG_RADIO_SAA7706H_MODULE: u32 = 1;
pub const CONFIG_INTERCONNECT_QCOM_SA8775P_MODULE: u32 = 1;
pub const CONFIG_NET_ACT_CONNMARK_MODULE: u32 = 1;
pub const CONFIG_GENERIC_EARLY_IOREMAP: u32 = 1;
pub const CONFIG_SND_SOC_MAX98363_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_PCM5102A_MODULE: u32 = 1;
pub const CONFIG_RTL8821AE_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_ADAU7118_MODULE: u32 = 1;
pub const CONFIG_BINDGEN_VERSION_TEXT: &[u8; 15] = b"bindgen 0.71.1\0";
pub const CONFIG_PINCTRL_TEGRA234: u32 = 1;
pub const CONFIG_BT_RFCOMM_MODULE: u32 = 1;
pub const CONFIG_XFRM_ESP_MODULE: u32 = 1;
pub const CONFIG_CACHEFILES_ONDEMAND: u32 = 1;
pub const CONFIG_PINCTRL_SC7280: u32 = 1;
pub const CONFIG_SND_SOC_CS42L42_SDW_MODULE: u32 = 1;
pub const CONFIG_AMD_XGBE_DCB: u32 = 1;
pub const CONFIG_KEYBOARD_TM2_TOUCHKEY_MODULE: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_PAGE_TABLE_CHECK: u32 = 1;
pub const CONFIG_RTL8188EE_MODULE: u32 = 1;
pub const CONFIG_CXL_SUSPEND: u32 = 1;
pub const CONFIG_DEBUG_SECTION_MISMATCH: u32 = 1;
pub const CONFIG_PHY_ROCKCHIP_DPHY_RX0_MODULE: u32 = 1;
pub const CONFIG_ZRAM_BACKEND_LZ4HC: u32 = 1;
pub const CONFIG_CAN_SLCAN_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_NW80X_MODULE: u32 = 1;
pub const CONFIG_SND_USB_CAIAQ_INPUT: u32 = 1;
pub const CONFIG_RT2800USB_RT35XX: u32 = 1;
pub const CONFIG_OF_FLATTREE: u32 = 1;
pub const CONFIG_IIO_GTS_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_SPEAKUP_SYNTH_SOFT_MODULE: u32 = 1;
pub const CONFIG_IP_NF_MATCH_ECN_MODULE: u32 = 1;
pub const CONFIG_DVB_B2C2_FLEXCOP_PCI_MODULE: u32 = 1;
pub const CONFIG_SND_USB_VARIAX_MODULE: u32 = 1;
pub const CONFIG_SERIAL_DEV_BUS: u32 = 1;
pub const CONFIG_USB_RTL8150_MODULE: u32 = 1;
pub const CONFIG_L2TP_MODULE: u32 = 1;
pub const CONFIG_COMPAT_BINFMT_ELF: u32 = 1;
pub const CONFIG_WWAN_DEBUGFS: u32 = 1;
pub const CONFIG_CAN_ESD_USB_MODULE: u32 = 1;
pub const CONFIG_USB_SEVSEG_MODULE: u32 = 1;
pub const CONFIG_DRM_SIMPLE_BRIDGE_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_SITRONIX_ST7701_MODULE: u32 = 1;
pub const CONFIG_NETROM_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_SET_MODULE: u32 = 1;
pub const CONFIG_NF_TABLES_IPV6: u32 = 1;
pub const CONFIG_BSD_PROCESS_ACCT: u32 = 1;
pub const CONFIG_GAMEPORT_EMU10K1_MODULE: u32 = 1;
pub const CONFIG_SND_SEQ_MIDI_MODULE: u32 = 1;
pub const CONFIG_GPIO_STMPE: u32 = 1;
pub const CONFIG_SCSI_STEX_MODULE: u32 = 1;
pub const CONFIG_DVB_MN88473_MODULE: u32 = 1;
pub const CONFIG_INPUT_FF_MEMLESS_MODULE: u32 = 1;
pub const CONFIG_DRM_IMX_LCDIF_MODULE: u32 = 1;
pub const CONFIG_XZ_DEC_SPARC: u32 = 1;
pub const CONFIG_ROCKCHIP_THERMAL_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_RZG2L_VBCTRL_MODULE: u32 = 1;
pub const CONFIG_TYPEC_ANX7411_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV64A40_MODULE: u32 = 1;
pub const CONFIG_B43_LEDS: u32 = 1;
pub const CONFIG_SND_SOC_TAS2781_COMLIB_MODULE: u32 = 1;
pub const CONFIG_NF_REJECT_IPV4_MODULE: u32 = 1;
pub const CONFIG_MEMSTICK_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_TSC2007_IIO: u32 = 1;
pub const CONFIG_MWIFIEX_PCIE_MODULE: u32 = 1;
pub const CONFIG_LEDS_TRIGGER_INPUT_EVENTS_MODULE: u32 = 1;
pub const CONFIG_TEST_BPF_MODULE: u32 = 1;
pub const CONFIG_SERIAL_8250_EXTENDED: u32 = 1;
pub const CONFIG_SYSTEM_BLACKLIST_AUTH_UPDATE: u32 = 1;
pub const CONFIG_CC_HAS_NO_PROFILE_FN_ATTR: u32 = 1;
pub const CONFIG_SND_SOC_ADAU1372_I2C_MODULE: u32 = 1;
pub const CONFIG_MDIO_CAVIUM_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_SOF_ACPI_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TPA6130A2_MODULE: u32 = 1;
pub const CONFIG_RESET_IMX8MP_AUDIOMIX_MODULE: u32 = 1;
pub const CONFIG_SENSORS_EMC1403_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_IMX: u32 = 1;
pub const CONFIG_DRM_FSL_LDB_MODULE: u32 = 1;
pub const CONFIG_USB_U_SERIAL_MODULE: u32 = 1;
pub const CONFIG_ACPI_SPCR_TABLE: u32 = 1;
pub const CONFIG_MODULE_COMPRESS: u32 = 1;
pub const CONFIG_CGROUP_MISC: u32 = 1;
pub const CONFIG_NATSEMI_MODULE: u32 = 1;
pub const CONFIG_NET_IPVTI_MODULE: u32 = 1;
pub const CONFIG_KXSD9_SPI_MODULE: u32 = 1;
pub const CONFIG_TYPEC_WUSB3801_MODULE: u32 = 1;
pub const CONFIG_SND_SERIAL_GENERIC_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_USERSPACE_CONSUMER_MODULE: u32 = 1;
pub const CONFIG_APPLE_RTKIT_MODULE: u32 = 1;
pub const CONFIG_VEXPRESS_CONFIG: u32 = 1;
pub const CONFIG_OF_GPIO: u32 = 1;
pub const CONFIG_INTERCONNECT_QCOM_RPMH: u32 = 1;
pub const CONFIG_MMA7660_MODULE: u32 = 1;
pub const CONFIG_MISC_RTSX_USB_MODULE: u32 = 1;
pub const CONFIG_NVMEM_QCOM_SEC_QFPROM_MODULE: u32 = 1;
pub const CONFIG_DVB_MB86A20S_MODULE: u32 = 1;
pub const CONFIG_ADXL380_SPI_MODULE: u32 = 1;
pub const CONFIG_CLK_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_OCTEON_EP_MODULE: u32 = 1;
pub const CONFIG_RCU_CPU_STALL_TIMEOUT: u32 = 60;
pub const CONFIG_NF_DUP_IPV6_MODULE: u32 = 1;
pub const CONFIG_PHY_MESON_AXG_PCIE_MODULE: u32 = 1;
pub const CONFIG_RCU_TRACE: u32 = 1;
pub const CONFIG_IP_MROUTE_COMMON: u32 = 1;
pub const CONFIG_QCOM_PDR_HELPERS_MODULE: u32 = 1;
pub const CONFIG_USB_EHCI_HCD: u32 = 1;
pub const CONFIG_TOUCHSCREEN_USB_EASYTOUCH: u32 = 1;
pub const CONFIG_RTL8192DU_MODULE: u32 = 1;
pub const CONFIG_PHY_QCOM_USB_HSIC_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_ANSI_CPRNG_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_QCOM_LABIBB_MODULE: u32 = 1;
pub const CONFIG_XILINX_EMACLITE_MODULE: u32 = 1;
pub const CONFIG_STRICT_KERNEL_RWX: u32 = 1;
pub const CONFIG_ARM_SMMU_V3_PMU_MODULE: u32 = 1;
pub const CONFIG_MMC_SDHCI_UHS2_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_QCOM_SPMI_PMIC: u32 = 1;
pub const CONFIG_INFINIBAND_ON_DEMAND_PAGING: u32 = 1;
pub const CONFIG_USB_CONFIGFS_OBEX: u32 = 1;
pub const CONFIG_USB_SERIAL_QUALCOMM_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_SOF_COMPRESS: u32 = 1;
pub const CONFIG_COMMON_CLK_BD718XX_MODULE: u32 = 1;
pub const CONFIG_RTW88_SDIO_MODULE: u32 = 1;
pub const CONFIG_LZO_COMPRESS: u32 = 1;
pub const CONFIG_SPARSEMEM_VMEMMAP: u32 = 1;
pub const CONFIG_LEDS_CROS_EC_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_MT2266_MODULE: u32 = 1;
pub const CONFIG_I2C_NFORCE2_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_STREEBOG_MODULE: u32 = 1;
pub const CONFIG_HID_SUPPORT: u32 = 1;
pub const CONFIG_CXL_PMEM_MODULE: u32 = 1;
pub const CONFIG_INTERCONNECT_IMX8MN_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_CHELSIO_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_2658417: u32 = 1;
pub const CONFIG_IP_NF_ARPFILTER_MODULE: u32 = 1;
pub const CONFIG_PHY_FSL_IMX8MQ_USB_MODULE: u32 = 1;
pub const CONFIG_CHROMEOS_OF_HW_PROBER: u32 = 1;
pub const CONFIG_MACB_MODULE: u32 = 1;
pub const CONFIG_HID_SMARTJOYPLUS_MODULE: u32 = 1;
pub const CONFIG_I2C_CCGX_UCSI_MODULE: u32 = 1;
pub const CONFIG_ASYNC_PQ_MODULE: u32 = 1;
pub const CONFIG_VFAT_FS_MODULE: u32 = 1;
pub const CONFIG_LCD_CLASS_DEVICE_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_ROCKER: u32 = 1;
pub const CONFIG_FONT_8x8: u32 = 1;
pub const CONFIG_PINCTRL_SUN55I_A523: u32 = 1;
pub const CONFIG_EFIVAR_FS: u32 = 1;
pub const CONFIG_SND_SOC_WCD_MBHC_MODULE: u32 = 1;
pub const CONFIG_NFC_MICROREAD_I2C_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_MESON_EE_CLKC: u32 = 1;
pub const CONFIG_UBIFS_FS_XATTR: u32 = 1;
pub const CONFIG_SECURITY_DMESG_RESTRICT: u32 = 1;
pub const CONFIG_SERIAL_8250_BCM2835AUX: u32 = 1;
pub const CONFIG_LEDS_GPIO_MODULE: u32 = 1;
pub const CONFIG_CHELSIO_T1_1G: u32 = 1;
pub const CONFIG_DVB_HOPPER_MODULE: u32 = 1;
pub const CONFIG_HNS_MDIO_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEFLATE: u32 = 1;
pub const CONFIG_LTR501_MODULE: u32 = 1;
pub const CONFIG_E100_MODULE: u32 = 1;
pub const CONFIG_MACSEC_MODULE: u32 = 1;
pub const CONFIG_IP_ROUTE_MULTIPATH: u32 = 1;
pub const CONFIG_MFD_RT4831_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_AXG: u32 = 1;
pub const CONFIG_KFENCE_STRESS_TEST_FAULTS: u32 = 0;
pub const CONFIG_SND_SOC_RT5663_MODULE: u32 = 1;
pub const CONFIG_FSL_XGMAC_MDIO_MODULE: u32 = 1;
pub const CONFIG_TIME_NS: u32 = 1;
pub const CONFIG_SPI_ARMADA_3700_MODULE: u32 = 1;
pub const CONFIG_QEDI_MODULE: u32 = 1;
pub const CONFIG_UCS2_STRING: u32 = 1;
pub const CONFIG_DM_MULTIPATH_QL_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_PF9453_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_PCM6240_MODULE: u32 = 1;
pub const CONFIG_MAGIC_SYSRQ_DEFAULT_ENABLE: u32 = 0;
pub const CONFIG_VIDEO_MT9M001_MODULE: u32 = 1;
pub const CONFIG_PACKET: u32 = 1;
pub const CONFIG_LEDS_TRIGGER_TRANSIENT_MODULE: u32 = 1;
pub const CONFIG_VGA_ARB_MAX_GPUS: u32 = 16;
pub const CONFIG_MMC_DW_PCI_MODULE: u32 = 1;
pub const CONFIG_NO_HZ_COMMON: u32 = 1;
pub const CONFIG_SCSI_ESAS2R_MODULE: u32 = 1;
pub const CONFIG_MEMTEST: u32 = 1;
pub const CONFIG_6LOWPAN_GHC_EXT_HDR_HOP_MODULE: u32 = 1;
pub const CONFIG_DRM_VIRTIO_GPU_MODULE: u32 = 1;
pub const CONFIG_MFD_TPS65086_MODULE: u32 = 1;
pub const CONFIG_USB_STORAGE_SDDR55_MODULE: u32 = 1;
pub const CONFIG_CC_HAS_SANE_FUNCTION_ALIGNMENT: u32 = 1;
pub const CONFIG_SENSORS_LM95234_MODULE: u32 = 1;
pub const CONFIG_SND_PCM_OSS_PLUGINS: u32 = 1;
pub const CONFIG_STACKDEPOT_MAX_FRAMES: u32 = 64;
pub const CONFIG_ARM64_PTR_AUTH: u32 = 1;
pub const CONFIG_CHARLCD_BL_FLASH: u32 = 1;
pub const CONFIG_COMMON_CLK_MESON_REGMAP: u32 = 1;
pub const CONFIG_BRIDGE_EBT_ARP_MODULE: u32 = 1;
pub const CONFIG_KEXEC_IMAGE_VERIFY_SIG: u32 = 1;
pub const CONFIG_COMMON_CLK_MESON_PHASE: u32 = 1;
pub const CONFIG_SND_SERIAL_U16550_MODULE: u32 = 1;
pub const CONFIG_FPGA_DFL_PCI_MODULE: u32 = 1;
pub const CONFIG_PTP_1588_CLOCK_KVM_MODULE: u32 = 1;
pub const CONFIG_FB_CFB_FILLRECT: u32 = 1;
pub const CONFIG_TINYDRM_SHARP_MEMORY_MODULE: u32 = 1;
pub const CONFIG_BRIDGE_EBT_T_NAT_MODULE: u32 = 1;
pub const CONFIG_NF_DEFRAG_IPV4_MODULE: u32 = 1;
pub const CONFIG_FAIR_GROUP_SCHED: u32 = 1;
pub const CONFIG_QCOM_SPMI_IADC_MODULE: u32 = 1;
pub const CONFIG_TI_ICSSG_PRUETH_SR1_MODULE: u32 = 1;
pub const CONFIG_ZSTD_DECOMPRESS: u32 = 1;
pub const CONFIG_TEGRA_BPMP: u32 = 1;
pub const CONFIG_NETFILTER_ADVANCED: u32 = 1;
pub const CONFIG_FAT_FS_MODULE: u32 = 1;
pub const CONFIG_USB_CONFIGFS_NCM: u32 = 1;
pub const CONFIG_DRM_PANIC_FOREGROUND_COLOR: u32 = 16777215;
pub const CONFIG_REGULATOR_MAX77503_MODULE: u32 = 1;
pub const CONFIG_CDROM_PKTCDVD_MODULE: u32 = 1;
pub const CONFIG_SA_VIDEOCC_8775P_MODULE: u32 = 1;
pub const CONFIG_NVME_MULTIPATH: u32 = 1;
pub const CONFIG_B43LEGACY_DMA_AND_PIO_MODE: u32 = 1;
pub const CONFIG_PCI_DOMAINS_GENERIC: u32 = 1;
pub const CONFIG_SND_MESON_GX_SOUND_CARD_MODULE: u32 = 1;
pub const CONFIG_PSTORE_DEFAULT_KMSG_BYTES: u32 = 10240;
pub const CONFIG_VIDEO_CX231XX_RC: u32 = 1;
pub const CONFIG_IP6_NF_TARGET_REJECT_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_LPASS_MACRO_COMMON_MODULE: u32 = 1;
pub const CONFIG_MLX5_BRIDGE: u32 = 1;
pub const CONFIG_RTC_DRV_R7301_MODULE: u32 = 1;
pub const CONFIG_RTW89_8852BTE_MODULE: u32 = 1;
pub const CONFIG_GENERIC_TIME_VSYSCALL: u32 = 1;
pub const CONFIG_MMU_GATHER_RCU_TABLE_FREE: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_PER_VMA_LOCK: u32 = 1;
pub const CONFIG_USB_DWC3_QCOM_MODULE: u32 = 1;
pub const CONFIG_SERIAL_8250_OMAP_TTYO_FIXUP: u32 = 1;
pub const CONFIG_PHY_J721E_WIZ_MODULE: u32 = 1;
pub const CONFIG_SND_CS46XX_NEW_DSP: u32 = 1;
pub const CONFIG_NVIDIA_CORESIGHT_PMU_ARCH_SYSTEM_PMU_MODULE: u32 = 1;
pub const CONFIG_DRM_MSM_DSI_10NM_PHY: u32 = 1;
pub const CONFIG_DVB_AS102_FE_MODULE: u32 = 1;
pub const CONFIG_FPGA_MGR_ICE40_SPI_MODULE: u32 = 1;
pub const CONFIG_IR_IMON_DECODER_MODULE: u32 = 1;
pub const CONFIG_DLN2_ADC_MODULE: u32 = 1;
pub const CONFIG_NR_CPUS: u32 = 4096;
pub const CONFIG_V4L2_CCI_MODULE: u32 = 1;
pub const CONFIG_SERIAL_SH_SCI_CONSOLE: u32 = 1;
pub const CONFIG_ARCH_HIBERNATION_POSSIBLE: u32 = 1;
pub const CONFIG_HID_ACCUTOUCH_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_USB_E2I: u32 = 1;
pub const CONFIG_HAVE_FUNCTION_TRACER: u32 = 1;
pub const CONFIG_ASYNC_MEMCPY_MODULE: u32 = 1;
pub const CONFIG_PWM_RASPBERRYPI_POE_MODULE: u32 = 1;
pub const CONFIG_MLXSW_PCI_MODULE: u32 = 1;
pub const CONFIG_HISILICON_ERRATUM_161600802: u32 = 1;
pub const CONFIG_LINEAR_RANGES_TEST_MODULE: u32 = 1;
pub const CONFIG_QCOM_INLINE_CRYPTO_ENGINE_MODULE: u32 = 1;
pub const CONFIG_SPI_QPIC_SNAND_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_NAU8824_MODULE: u32 = 1;
pub const CONFIG_LOG_BUF_SHIFT: u32 = 18;
pub const CONFIG_PHY_AM654_SERDES_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_1742098: u32 = 1;
pub const CONFIG_LEDS_TRIGGER_DEFAULT_ON_MODULE: u32 = 1;
pub const CONFIG_IPV6_OPTIMISTIC_DAD: u32 = 1;
pub const CONFIG_SND_SOC_MAX98927_MODULE: u32 = 1;
pub const CONFIG_FB_EFI: u32 = 1;
pub const CONFIG_AUDIT: u32 = 1;
pub const CONFIG_SQUASHFS_XATTR: u32 = 1;
pub const CONFIG_BH1745_MODULE: u32 = 1;
pub const CONFIG_NET_9P_MODULE: u32 = 1;
pub const CONFIG_QCOM_IRQ_COMBINER: u32 = 1;
pub const CONFIG_BT_HCIBTUSB_MODULE: u32 = 1;
pub const CONFIG_PWM_HIBVT_MODULE: u32 = 1;
pub const CONFIG_DRM_DW_HDMI_MODULE: u32 = 1;
pub const CONFIG_HW_RANDOM_HISTB: u32 = 1;
pub const CONFIG_SC_GPUCC_7280_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_AES_ARM64_CE_CCM: u32 = 1;
pub const CONFIG_IR_SPI_MODULE: u32 = 1;
pub const CONFIG_HOTPLUG_PCI_ACPI_AMPERE_ALTRA_MODULE: u32 = 1;
pub const CONFIG_DRM_XE_JOB_TIMEOUT_MAX: u32 = 10000;
pub const CONFIG_USB_HUB_USB251XB_MODULE: u32 = 1;
pub const CONFIG_TCP_CONG_SCALABLE_MODULE: u32 = 1;
pub const CONFIG_SND_SEQ_DEVICE_MODULE: u32 = 1;
pub const CONFIG_VEML3235_MODULE: u32 = 1;
pub const CONFIG_DVB_DRX39XYJ_MODULE: u32 = 1;
pub const CONFIG_RTW88_USB_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CROS_EC_CODEC_MODULE: u32 = 1;
pub const CONFIG_MOUSE_CYAPA_MODULE: u32 = 1;
pub const CONFIG_VIDEO_TW9906_MODULE: u32 = 1;
pub const CONFIG_AD3552R_HS_MODULE: u32 = 1;
pub const CONFIG_QED_MODULE: u32 = 1;
pub const CONFIG_GPIO_RASPBERRYPI_EXP_MODULE: u32 = 1;
pub const CONFIG_HW_RANDOM_XGENE_MODULE: u32 = 1;
pub const CONFIG_QCOM_WCNSS_CTRL_MODULE: u32 = 1;
pub const CONFIG_DAMON_RECLAIM: u32 = 1;
pub const CONFIG_NVMEM_LAYOUT_U_BOOT_ENV_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_CONNTRACK_MODULE: u32 = 1;
pub const CONFIG_NF_SOCKET_IPV4_MODULE: u32 = 1;
pub const CONFIG_CAN_DEV_MODULE: u32 = 1;
pub const CONFIG_SND_SEQ_HRTIMER_DEFAULT: u32 = 1;
pub const CONFIG_YELLOWFIN_MODULE: u32 = 1;
pub const CONFIG_MSE102X_MODULE: u32 = 1;
pub const CONFIG_NVME_TCP_TLS: u32 = 1;
pub const CONFIG_USB_ATM_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_AXP20X_MODULE: u32 = 1;
pub const CONFIG_VSOCKETS_DIAG_MODULE: u32 = 1;
pub const CONFIG_USB_LED_TRIG: u32 = 1;
pub const CONFIG_NET_SCH_GRED_MODULE: u32 = 1;
pub const CONFIG_DM_MULTIPATH_MODULE: u32 = 1;
pub const CONFIG_MDIO_DEVICE: u32 = 1;
pub const CONFIG_CAN_J1939_MODULE: u32 = 1;
pub const CONFIG_LS_SCFG_MSI: u32 = 1;
pub const CONFIG_EVENT_TRACING: u32 = 1;
pub const CONFIG_KRETPROBES: u32 = 1;
pub const CONFIG_BCM_NET_PHYLIB_MODULE: u32 = 1;
pub const CONFIG_PAGE_POISONING: u32 = 1;
pub const CONFIG_RTC_DRV_TEGRA_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_CE6230_MODULE: u32 = 1;
pub const CONFIG_SERIAL_8250_SHARE_IRQ: u32 = 1;
pub const CONFIG_MLX5_HW_STEERING: u32 = 1;
pub const CONFIG_ARM64_PSEUDO_NMI: u32 = 1;
pub const CONFIG_LOCKD_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_CYPRESS_M8_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_RK3288_HDMI_ANALOG_MODULE: u32 = 1;
pub const CONFIG_6LOWPAN_GHC_UDP_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_SUN8I_CE_HASH: u32 = 1;
pub const CONFIG_RPMSG_CTRL_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_88PM886_MODULE: u32 = 1;
pub const CONFIG_HID_CREATIVE_SB0540_MODULE: u32 = 1;
pub const CONFIG_BPF_LSM: u32 = 1;
pub const CONFIG_BACKLIGHT_RT4831_MODULE: u32 = 1;
pub const CONFIG_NVME_TARGET_RDMA_MODULE: u32 = 1;
pub const CONFIG_IP_ROUTE_VERBOSE: u32 = 1;
pub const CONFIG_DRM_PARADE_PS8622_MODULE: u32 = 1;
pub const CONFIG_COMPACTION: u32 = 1;
pub const CONFIG_REGULATOR_RT4801_MODULE: u32 = 1;
pub const CONFIG_FB_CFB_IMAGEBLIT: u32 = 1;
pub const CONFIG_HWPOISON_INJECT_MODULE: u32 = 1;
pub const CONFIG_BRANCH_PROFILE_NONE: u32 = 1;
pub const CONFIG_SND_SOC_NTP8918_MODULE: u32 = 1;
pub const CONFIG_VIDEOBUF2_VMALLOC_MODULE: u32 = 1;
pub const CONFIG_BRIDGE_EBT_IP_MODULE: u32 = 1;
pub const CONFIG_NVMEM_U_BOOT_ENV_MODULE: u32 = 1;
pub const CONFIG_INPUT: u32 = 1;
pub const CONFIG_BIG_KEYS: u32 = 1;
pub const CONFIG_MMC_DW_HI3798MV200_MODULE: u32 = 1;
pub const CONFIG_TI_ADS131E08_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_FSL_EASRC_MODULE: u32 = 1;
pub const CONFIG_WLAN_VENDOR_RSI: u32 = 1;
pub const CONFIG_GENERIC_IRQ_IPI: u32 = 1;
pub const CONFIG_SND_SOC_RT711_MODULE: u32 = 1;
pub const CONFIG_USB_MAX3420_UDC_MODULE: u32 = 1;
pub const CONFIG_USB_NET_PLUSB_MODULE: u32 = 1;
pub const CONFIG_BLK_MQ_VIRTIO: u32 = 1;
pub const CONFIG_SPI_MICROCHIP_CORE_MODULE: u32 = 1;
pub const CONFIG_HWSPINLOCK_SUN6I_MODULE: u32 = 1;
pub const CONFIG_OF_FPGA_REGION_MODULE: u32 = 1;
pub const CONFIG_NFT_LOG_MODULE: u32 = 1;
pub const CONFIG_PWRSEQ_EMMC_MODULE: u32 = 1;
pub const CONFIG_MVPP2_MODULE: u32 = 1;
pub const CONFIG_RADIO_ADAPTERS_MODULE: u32 = 1;
pub const CONFIG_KPROBES_SANITY_TEST_MODULE: u32 = 1;
pub const CONFIG_QCOM_IPCC_MODULE: u32 = 1;
pub const CONFIG_SMPRO_MISC_MODULE: u32 = 1;
pub const CONFIG_BRIDGE_EBT_REDIRECT_MODULE: u32 = 1;
pub const CONFIG_FPGA_BRIDGE_MODULE: u32 = 1;
pub const CONFIG_TCG_TPM2_HMAC: u32 = 1;
pub const CONFIG_NET_TEST_MODULE: u32 = 1;
pub const CONFIG_FUEL_GAUGE_MM8013_MODULE: u32 = 1;
pub const CONFIG_INTERCONNECT_IMX8MM_MODULE: u32 = 1;
pub const CONFIG_VXLAN_MODULE: u32 = 1;
pub const CONFIG_RXKAD: u32 = 1;
pub const CONFIG_SONY_FF: u32 = 1;
pub const CONFIG_CAN_M_CAN_PCI_MODULE: u32 = 1;
pub const CONFIG_RTW88_8723DE_MODULE: u32 = 1;
pub const CONFIG_DEV_COREDUMP: u32 = 1;
pub const CONFIG_SND_SOC_QDSP6_AFE_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_MODULE: u32 = 1;
pub const CONFIG_OF_EARLY_FLATTREE: u32 = 1;
pub const CONFIG_FB_DMAMEM_HELPERS_DEFERRED: u32 = 1;
pub const CONFIG_SM_GCC_8450_MODULE: u32 = 1;
pub const CONFIG_BATMAN_ADV_BATMAN_V: u32 = 1;
pub const CONFIG_PINCTRL_SUN50I_H616: u32 = 1;
pub const CONFIG_QAT_VFIO_PCI_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_POLYVAL_MODULE: u32 = 1;
pub const CONFIG_TYPEC_MUX_PTN36502_MODULE: u32 = 1;
pub const CONFIG_DVB_B2C2_FLEXCOP_MODULE: u32 = 1;
pub const CONFIG_GPIO_PCF857X_MODULE: u32 = 1;
pub const CONFIG_TABLET_USB_HANWANG_MODULE: u32 = 1;
pub const CONFIG_TI_K3_AM65_CPSW_SWITCHDEV: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA210_AMX_MODULE: u32 = 1;
pub const CONFIG_APPLE_DART_MODULE: u32 = 1;
pub const CONFIG_E1000_MODULE: u32 = 1;
pub const CONFIG_FRAMEBUFFER_CONSOLE: u32 = 1;
pub const CONFIG_SND_INDIGO_MODULE: u32 = 1;
pub const CONFIG_CLK_FD_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_DAVINCI_MCASP_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_GENERIC_CRASHKERNEL_RESERVATION: u32 = 1;
pub const CONFIG_SND_SOC_AW88166_MODULE: u32 = 1;
pub const CONFIG_JOYSTICK_XPAD_FF: u32 = 1;
pub const CONFIG_CRYPTO_ENGINE: u32 = 1;
pub const CONFIG_COUNTER_MODULE: u32 = 1;
pub const CONFIG_POLYNOMIAL_MODULE: u32 = 1;
pub const CONFIG_BLK_ICQ: u32 = 1;
pub const CONFIG_MPL115_MODULE: u32 = 1;
pub const CONFIG_CLK_RK3528: u32 = 1;
pub const CONFIG_NF_CONNTRACK_MARK: u32 = 1;
pub const CONFIG_RTC_DRV_MSM6242_MODULE: u32 = 1;
pub const CONFIG_USERMODE_DRIVER: u32 = 1;
pub const CONFIG_POWER_MLXBF_MODULE: u32 = 1;
pub const CONFIG_HAVE_GCC_PLUGINS: u32 = 1;
pub const CONFIG_USB_NET_SMSC95XX_MODULE: u32 = 1;
pub const CONFIG_SENSORS_NCT6683_MODULE: u32 = 1;
pub const CONFIG_MEMSTICK_TIFM_MS_MODULE: u32 = 1;
pub const CONFIG_DVB_AF9033_MODULE: u32 = 1;
pub const CONFIG_SND_DESIGNWARE_PCM: u32 = 1;
pub const CONFIG_NO_HZ: u32 = 1;
pub const CONFIG_CLK_VEXPRESS_OSC: u32 = 1;
pub const CONFIG_VIDEO_GO7007_USB_MODULE: u32 = 1;
pub const CONFIG_DP83869_PHY_MODULE: u32 = 1;
pub const CONFIG_SND_SUN8I_CODEC_MODULE: u32 = 1;
pub const CONFIG_MFD_ADP5585_MODULE: u32 = 1;
pub const CONFIG_PWM_CLK_MODULE: u32 = 1;
pub const CONFIG_SCSI_LIB_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_ARM_CORESIGHT_PMU_ARCH_SYSTEM_PMU_MODULE: u32 = 1;
pub const CONFIG_CEPH_FSCACHE: u32 = 1;
pub const CONFIG_RING_BUFFER: u32 = 1;
pub const CONFIG_W1_MASTER_GPIO_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_IMX_PCM_DMA_MODULE: u32 = 1;
pub const CONFIG_I2C_MUX_PCA954x_MODULE: u32 = 1;
pub const CONFIG_NET_DSA_TAG_MTK_MODULE: u32 = 1;
pub const CONFIG_USB_HSIC_USB4604_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA210_ADX_MODULE: u32 = 1;
pub const CONFIG_DRM_V3D_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_TSC2007_MODULE: u32 = 1;
pub const CONFIG_QCOM_A53PLL_MODULE: u32 = 1;
pub const CONFIG_DM_SNAPSHOT: u32 = 1;
pub const CONFIG_MCP4821_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_IUU_MODULE: u32 = 1;
pub const CONFIG_DRM_ITE_IT6263_MODULE: u32 = 1;
pub const CONFIG_NET_PKTGEN_MODULE: u32 = 1;
pub const CONFIG_LLC_MODULE: u32 = 1;
pub const CONFIG_IMA_NG_TEMPLATE: u32 = 1;
pub const CONFIG_ARMADA_THERMAL_MODULE: u32 = 1;
pub const CONFIG_VIDEO_AU0828_MODULE: u32 = 1;
pub const CONFIG_MFD_SYSCON: u32 = 1;
pub const CONFIG_VIDEO_STK1160_MODULE: u32 = 1;
pub const CONFIG_SENSORS_GPIO_FAN_MODULE: u32 = 1;
pub const CONFIG_GPIOLIB_FASTPATH_LIMIT: u32 = 512;
pub const CONFIG_MAC80211_LEDS: u32 = 1;
pub const CONFIG_USB_NET_AQC111_MODULE: u32 = 1;
pub const CONFIG_SECURITY_SELINUX_BOOTPARAM: u32 = 1;
pub const CONFIG_JFS_SECURITY: u32 = 1;
pub const CONFIG_PCIPCWATCHDOG_MODULE: u32 = 1;
pub const CONFIG_ARM64_ACPI_PARKING_PROTOCOL: u32 = 1;
pub const CONFIG_NFC_MRVL_USB_MODULE: u32 = 1;
pub const CONFIG_DRM_LONTIUM_LT8912B_MODULE: u32 = 1;
pub const CONFIG_GENERIC_IRQ_SHOW_LEVEL: u32 = 1;
pub const CONFIG_RT2800USB_MODULE: u32 = 1;
pub const CONFIG_BT_BNEP_PROTO_FILTER: u32 = 1;
pub const CONFIG_RESET_CONTROLLER: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_HUGETLBFS: u32 = 1;
pub const CONFIG_RTC_DRV_IMX_SC_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_M41T80_WDT: u32 = 1;
pub const CONFIG_SURFACE_AGGREGATOR_HUB_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_MCP795_MODULE: u32 = 1;
pub const CONFIG_PID_NS: u32 = 1;
pub const CONFIG_DRM_GPUVM_MODULE: u32 = 1;
pub const CONFIG_VIDEO_TC358743_MODULE: u32 = 1;
pub const CONFIG_NVME_HWMON: u32 = 1;
pub const CONFIG_IP6_NF_TARGET_NPT_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_SHA1_ARM64_CE: u32 = 1;
pub const CONFIG_MB1232_MODULE: u32 = 1;
pub const CONFIG_SC_LPASS_CORECC_7280_MODULE: u32 = 1;
pub const CONFIG_PHY_HI6220_USB_MODULE: u32 = 1;
pub const CONFIG_TINYDRM_ILI9163_MODULE: u32 = 1;
pub const CONFIG_HASH_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_HAVE_KVM_DIRTY_RING: u32 = 1;
pub const CONFIG_ROHM_BU27034_MODULE: u32 = 1;
pub const CONFIG_CGROUP_PERF: u32 = 1;
pub const CONFIG_GCD_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_INET6_ESP_OFFLOAD_MODULE: u32 = 1;
pub const CONFIG_RAPIDIO_MPORT_CDEV_MODULE: u32 = 1;
pub const CONFIG_L2TP_ETH_MODULE: u32 = 1;
pub const CONFIG_IGC_LEDS: u32 = 1;
pub const CONFIG_SOC_TEGRA_FLOWCTRL: u32 = 1;
pub const CONFIG_VIDEO_MSP3400_MODULE: u32 = 1;
pub const CONFIG_USB_PWC_MODULE: u32 = 1;
pub const CONFIG_HARDIRQS_SW_RESEND: u32 = 1;
pub const CONFIG_IIO_CONSUMERS_PER_TRIGGER: u32 = 2;
pub const CONFIG_FRAMEBUFFER_CONSOLE_ROTATION: u32 = 1;
pub const CONFIG_BNX2X_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAVE_NMI_SAFE_CMPXCHG: u32 = 1;
pub const CONFIG_SSIF_IPMI_BMC_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_CHACHA20_NEON: u32 = 1;
pub const CONFIG_NETFILTER_NETLINK_GLUE_CT: u32 = 1;
pub const CONFIG_SERIAL_8250_TEGRA: u32 = 1;
pub const CONFIG_DRM_PANEL_KINGDISPLAY_KD097D04_MODULE: u32 = 1;
pub const CONFIG_SCSI_MPT2SAS_MAX_SGE: u32 = 128;
pub const CONFIG_DRM_SUN4I_MODULE: u32 = 1;
pub const CONFIG_FREEZER: u32 = 1;
pub const CONFIG_RTC_DRV_HYM8563_MODULE: u32 = 1;
pub const CONFIG_INFINIBAND_USER_MEM: u32 = 1;
pub const CONFIG_DVB_USB_V2_MODULE: u32 = 1;
pub const CONFIG_MYRI10GE_MODULE: u32 = 1;
pub const CONFIG_VM_EVENT_COUNTERS: u32 = 1;
pub const CONFIG_PAGE_SIZE_LESS_THAN_64KB: u32 = 1;
pub const CONFIG_VLAN_8021Q_MODULE: u32 = 1;
pub const CONFIG_CLK_QORIQ: u32 = 1;
pub const CONFIG_AQTION_MODULE: u32 = 1;
pub const CONFIG_PHY_FSL_LYNX_28G_MODULE: u32 = 1;
pub const CONFIG_ASSOCIATIVE_ARRAY: u32 = 1;
pub const CONFIG_PNFS_FILE_LAYOUT_MODULE: u32 = 1;
pub const CONFIG_MARVELL_GTI_WDT: u32 = 1;
pub const CONFIG_RTL8723_COMMON_MODULE: u32 = 1;
pub const CONFIG_KEYBOARD_STMPE_MODULE: u32 = 1;
pub const CONFIG_AXP288_ADC_MODULE: u32 = 1;
pub const CONFIG_EFI_EARLYCON: u32 = 1;
pub const CONFIG_MINIX_SUBPARTITION: u32 = 1;
pub const CONFIG_IPE_PROP_DM_VERITY_SIGNATURE: u32 = 1;
pub const CONFIG_EXT4_FS_SECURITY: u32 = 1;
pub const CONFIG_SENSORS_SHT3x_MODULE: u32 = 1;
pub const CONFIG_BRCMFMAC_USB: u32 = 1;
pub const CONFIG_SUNRPC_SWAP: u32 = 1;
pub const CONFIG_XFS_SUPPORT_V4: u32 = 1;
pub const CONFIG_TOUCHSCREEN_USB_DMC_TSC10: u32 = 1;
pub const CONFIG_BRIDGE_EBT_VLAN_MODULE: u32 = 1;
pub const CONFIG_SENSORS_G760A_MODULE: u32 = 1;
pub const CONFIG_SM_GCC_8150: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA210_ADMAIF_MODULE: u32 = 1;
pub const CONFIG_UNICODE_NORMALIZATION_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_CRASH_RESERVE: u32 = 1;
pub const CONFIG_SND_VIRTUOSO_MODULE: u32 = 1;
pub const CONFIG_ATH_COMMON_MODULE: u32 = 1;
pub const CONFIG_ARM_GIC_MAX_NR: u32 = 1;
pub const CONFIG_UACCE_MODULE: u32 = 1;
pub const CONFIG_BLK_DEV: u32 = 1;
pub const CONFIG_CRYPTO_SIG: u32 = 1;
pub const CONFIG_RT61PCI_MODULE: u32 = 1;
pub const CONFIG_EFI_COCO_SECRET: u32 = 1;
pub const CONFIG_DRM_BUDDY_MODULE: u32 = 1;
pub const CONFIG_POWER_SEQUENCING_MODULE: u32 = 1;
pub const CONFIG_SPI_TEGRA210_QUAD: u32 = 1;
pub const CONFIG_BT_HCIBTUSB_POLL_SYNC: u32 = 1;
pub const CONFIG_GPIO_DS4520_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_PL2303_MODULE: u32 = 1;
pub const CONFIG_DRM_AUX_BRIDGE_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_MSG2638_MODULE: u32 = 1;
pub const CONFIG_9P_FSCACHE: u32 = 1;
pub const CONFIG_CGROUP_PIDS: u32 = 1;
pub const CONFIG_VIDEO_SUNXI_CEDRUS_MODULE: u32 = 1;
pub const CONFIG_APPLE_M1_CPU_PMU: u32 = 1;
pub const CONFIG_PHY_QCOM_USB_HS_28NM_MODULE: u32 = 1;
pub const CONFIG_VIDEO_CX88_MODULE: u32 = 1;
pub const CONFIG_RMI4_F30: u32 = 1;
pub const CONFIG_INDIRECT_PIO: u32 = 1;
pub const CONFIG_SND_HDA_INTEL_HDMI_SILENT_STREAM: u32 = 1;
pub const CONFIG_NVDIMM_KEYS: u32 = 1;
pub const CONFIG_IMA_ARCH_POLICY: u32 = 1;
pub const CONFIG_SENSORS_IBMAEM_MODULE: u32 = 1;
pub const CONFIG_SENSORS_W83L786NG_MODULE: u32 = 1;
pub const CONFIG_SOCK_VALIDATE_XMIT: u32 = 1;
pub const CONFIG_HISILICON_ERRATUM_162100801: u32 = 1;
pub const CONFIG_DVB_USB_AZ6007_MODULE: u32 = 1;
pub const CONFIG_INTEGRITY_ASYMMETRIC_KEYS: u32 = 1;
pub const CONFIG_PINCTRL_IMX8MQ: u32 = 1;
pub const CONFIG_INET6_ESP_MODULE: u32 = 1;
pub const CONFIG_FPROBE: u32 = 1;
pub const CONFIG_ACPI_IORT: u32 = 1;
pub const CONFIG_CAN_GW_MODULE: u32 = 1;
pub const CONFIG_NF_CONNTRACK_SIP_MODULE: u32 = 1;
pub const CONFIG_NET_RX_BUSY_POLL: u32 = 1;
pub const CONFIG_IMX_DSP_MODULE: u32 = 1;
pub const CONFIG_EDAC: u32 = 1;
pub const CONFIG_MESON_IRQ_GPIO: u32 = 1;
pub const CONFIG_USB_CHIPIDEA_HOST: u32 = 1;
pub const CONFIG_PAHOLE_VERSION: u32 = 130;
pub const CONFIG_HTS221_SPI_MODULE: u32 = 1;
pub const CONFIG_ASYNC_TX_DISABLE_XOR_VAL_DMA: u32 = 1;
pub const CONFIG_SND_MPU401_MODULE: u32 = 1;
pub const CONFIG_HW_RANDOM_OMAP_MODULE: u32 = 1;
pub const CONFIG_PKCS7_MESSAGE_PARSER: u32 = 1;
pub const CONFIG_VIDEO_TVP514X_MODULE: u32 = 1;
pub const CONFIG_REGMAP_SLIMBUS_MODULE: u32 = 1;
pub const CONFIG_LRU_GEN_ENABLED: u32 = 1;
pub const CONFIG_ADXL355_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_AXI_CLKGEN_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_SILEAD_MODULE: u32 = 1;
pub const CONFIG_HWSPINLOCK_QCOM_MODULE: u32 = 1;
pub const CONFIG_PTP_1588_CLOCK_IDT82P33_MODULE: u32 = 1;
pub const CONFIG_SPMI_PMIC_CLKDIV_MODULE: u32 = 1;
pub const CONFIG_B43LEGACY_PCICORE_AUTOSELECT: u32 = 1;
pub const CONFIG_MEDIA_SUPPORT_MODULE: u32 = 1;
pub const CONFIG_I2C_DESIGNWARE_PLATFORM: u32 = 1;
pub const CONFIG_SENSORS_TSL2550_MODULE: u32 = 1;
pub const CONFIG_BPQETHER_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_SMSC: u32 = 1;
pub const CONFIG_TRACE_CLOCK: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA_MACHINE_DRV_MODULE: u32 = 1;
pub const CONFIG_R6040_MODULE: u32 = 1;
pub const CONFIG_TCG_TIS_I2C_INFINEON_MODULE: u32 = 1;
pub const CONFIG_ARCH_TEGRA_241_SOC: u32 = 1;
pub const CONFIG_HAVE_KVM_IRQ_BYPASS: u32 = 1;
pub const CONFIG_EXTCON_SM5502_MODULE: u32 = 1;
pub const CONFIG_RAPIDIO_ENUM_BASIC_MODULE: u32 = 1;
pub const CONFIG_ACPI_BUTTON: u32 = 1;
pub const CONFIG_AUXDISPLAY: u32 = 1;
pub const CONFIG_QCOM_PMIC_GLINK_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_TI_MODULE: u32 = 1;
pub const CONFIG_FPGA_MGR_XILINX_CORE_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_IMX_AUDIO_RPMSG_MODULE: u32 = 1;
pub const CONFIG_CAVIUM_PTP_MODULE: u32 = 1;
pub const CONFIG_BATTERY_MAX1720X_MODULE: u32 = 1;
pub const CONFIG_NOZOMI_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_HISI_HPRE_MODULE: u32 = 1;
pub const CONFIG_VIDEO_GC0308_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_IMX8DXL: u32 = 1;
pub const CONFIG_RTC_INTF_SYSFS: u32 = 1;
pub const CONFIG_USB_DWC3_KEYSTONE_MODULE: u32 = 1;
pub const CONFIG_FB_NOTIFY: u32 = 1;
pub const CONFIG_SUN_PARTITION: u32 = 1;
pub const CONFIG_QUOTA: u32 = 1;
pub const CONFIG_ARM_QCOM_CPUFREQ_HW_MODULE: u32 = 1;
pub const CONFIG_VIA_RHINE_MODULE: u32 = 1;
pub const CONFIG_ACPI_PRMT: u32 = 1;
pub const CONFIG_TCG_TIS_I2C_CR50_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_TCPMSS_MODULE: u32 = 1;
pub const CONFIG_NFT_TUNNEL_MODULE: u32 = 1;
pub const CONFIG_ACPI_TABLE_UPGRADE: u32 = 1;
pub const CONFIG_SERIAL_FSL_LINFLEXUART_CONSOLE: u32 = 1;
pub const CONFIG_SND_SOC_TLV320AIC3X_I2C_MODULE: u32 = 1;
pub const CONFIG_DVB_L64781_MODULE: u32 = 1;
pub const CONFIG_MT7663U_MODULE: u32 = 1;
pub const CONFIG_TASKS_RCU_GENERIC: u32 = 1;
pub const CONFIG_CRYPTO_SHA1: u32 = 1;
pub const CONFIG_IP_SET_HASH_IPPORT_MODULE: u32 = 1;
pub const CONFIG_PREEMPT_NOTIFIERS: u32 = 1;
pub const CONFIG_PINCTRL_SUNXI: u32 = 1;
pub const CONFIG_UBIFS_FS_SECURITY: u32 = 1;
pub const CONFIG_ARCH_THUNDER: u32 = 1;
pub const CONFIG_VIDEO_VP27SMPX_MODULE: u32 = 1;
pub const CONFIG_SOC_TEGRA_FUSE: u32 = 1;
pub const CONFIG_SND_VIRTIO_MODULE: u32 = 1;
pub const CONFIG_NFT_DUP_IPV6_MODULE: u32 = 1;
pub const CONFIG_FS_VERITY: u32 = 1;
pub const CONFIG_RC_ATI_REMOTE_MODULE: u32 = 1;
pub const CONFIG_PATA_ACPI_MODULE: u32 = 1;
pub const CONFIG_FB_BACKLIGHT: u32 = 1;
pub const CONFIG_SMC_DIAG_MODULE: u32 = 1;
pub const CONFIG_JOYSTICK_PXRC_MODULE: u32 = 1;
pub const CONFIG_CONTEXT_TRACKING: u32 = 1;
pub const CONFIG_USB_CHAOSKEY_MODULE: u32 = 1;
pub const CONFIG_ARCH_BCM2835: u32 = 1;
pub const CONFIG_GPIO_ZYNQMP_MODEPIN: u32 = 1;
pub const CONFIG_MMC_SDHCI_CADENCE_MODULE: u32 = 1;
pub const CONFIG_DEVTMPFS_SAFE: u32 = 1;
pub const CONFIG_NET_EMATCH_U32_MODULE: u32 = 1;
pub const CONFIG_MEDIA_CEC_RC: u32 = 1;
pub const CONFIG_QCOM_SMSM_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_CYBERJACK_MODULE: u32 = 1;
pub const CONFIG_VIDEO_BT866_MODULE: u32 = 1;
pub const CONFIG_DRM_PANTHOR_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_SIS_I2C_MODULE: u32 = 1;
pub const CONFIG_STRING_HELPERS_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_VIDEO_UPD64083_MODULE: u32 = 1;
pub const CONFIG_EDAC_DMC520_MODULE: u32 = 1;
pub const CONFIG_DVB_LGDT3305_MODULE: u32 = 1;
pub const CONFIG_MFD_88PM886_PMIC: u32 = 1;
pub const CONFIG_IP6_NF_MANGLE_MODULE: u32 = 1;
pub const CONFIG_GPIO_MAX732X_MODULE: u32 = 1;
pub const CONFIG_PAGE_IDLE_FLAG: u32 = 1;
pub const CONFIG_CRYPTO_LZ4HC_MODULE: u32 = 1;
pub const CONFIG_TASK_IO_ACCOUNTING: u32 = 1;
pub const CONFIG_WLAN: u32 = 1;
pub const CONFIG_PTP_DFL_TOD_MODULE: u32 = 1;
pub const CONFIG_INET6_AH_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_FSL_ESAI_MODULE: u32 = 1;
pub const CONFIG_IEEE802154_6LOWPAN_MODULE: u32 = 1;
pub const CONFIG_PCI_PWRCTL_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_ORIENTATION_QUIRKS: u32 = 1;
pub const CONFIG_ATH10K_USB_MODULE: u32 = 1;
pub const CONFIG_EDAC_ZYNQMP_MODULE: u32 = 1;
pub const CONFIG_SOFTLOCKUP_DETECTOR: u32 = 1;
pub const CONFIG_TI_SCI_INTA_IRQCHIP_MODULE: u32 = 1;
pub const CONFIG_MTD_GEN_PROBE_MODULE: u32 = 1;
pub const CONFIG_BT_HCIUART_BCSP: u32 = 1;
pub const CONFIG_USB4: u32 = 1;
pub const CONFIG_IP_NF_TARGET_TTL_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_TICK_BROADCAST: u32 = 1;
pub const CONFIG_SND_SOC_CARD_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_PWM_MODULE: u32 = 1;
pub const CONFIG_VIDEO_SYNOPSYS_HDMIRX_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_NFQUEUE_MODULE: u32 = 1;
pub const CONFIG_KVM_GENERIC_HARDWARE_ENABLING: u32 = 1;
pub const CONFIG_CHARGER_MAX77705_MODULE: u32 = 1;
pub const CONFIG_DVB_SP2_MODULE: u32 = 1;
pub const CONFIG_SENSORS_NCT7802_MODULE: u32 = 1;
pub const CONFIG_MMC_SDHCI_TEGRA_MODULE: u32 = 1;
pub const CONFIG_PWRSEQ_SIMPLE_MODULE: u32 = 1;
pub const CONFIG_SPI_ZYNQMP_GQSPI_MODULE: u32 = 1;
pub const CONFIG_SC_LPASS_CORECC_7180_MODULE: u32 = 1;
pub const CONFIG_XILINX_ZYNQMP_DMA_MODULE: u32 = 1;
pub const CONFIG_DVB_AU8522_MODULE: u32 = 1;
pub const CONFIG_RTL8192CE_MODULE: u32 = 1;
pub const CONFIG_IR_FINTEK_MODULE: u32 = 1;
pub const CONFIG_DVB_CXD2820R_MODULE: u32 = 1;
pub const CONFIG_OPTEE_MODULE: u32 = 1;
pub const CONFIG_NF_SOCKET_IPV6_MODULE: u32 = 1;
pub const CONFIG_KEYBOARD_PINEPHONE_MODULE: u32 = 1;
pub const CONFIG_PCIE_DW_HOST: u32 = 1;
pub const CONFIG_ARCH_WANT_COMPAT_IPC_PARSE_VERSION: u32 = 1;
pub const CONFIG_IWLMLD_MODULE: u32 = 1;
pub const CONFIG_USB_MON: u32 = 1;
pub const CONFIG_SND_SONICVIBES_MODULE: u32 = 1;
pub const CONFIG_ULTRASOC_SMB_MODULE: u32 = 1;
pub const CONFIG_EXTCON_GPIO_MODULE: u32 = 1;
pub const CONFIG_TIPC_DIAG_MODULE: u32 = 1;
pub const CONFIG_DAVICOM_PHY_MODULE: u32 = 1;
pub const CONFIG_BT_QCOMSMD_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_SH_PFC: u32 = 1;
pub const CONFIG_INET6_XFRM_TUNNEL_MODULE: u32 = 1;
pub const CONFIG_TSNEP_MODULE: u32 = 1;
pub const CONFIG_CAN_FLEXCAN_MODULE: u32 = 1;
pub const CONFIG_NETWORK_SECMARK: u32 = 1;
pub const CONFIG_MFD_DLN2_MODULE: u32 = 1;
pub const CONFIG_ACPI_APEI_SEA: u32 = 1;
pub const CONFIG_MDIO_OCTEON_MODULE: u32 = 1;
pub const CONFIG_SENSORS_SY7636A_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_USB_NEXIO: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_2441007: u32 = 1;
pub const CONFIG_BLK_DEV_IO_TRACE: u32 = 1;
pub const CONFIG_SND_TRIDENT_MODULE: u32 = 1;
pub const CONFIG_SND_OSSEMUL: u32 = 1;
pub const CONFIG_SND_SOC_AK4458_MODULE: u32 = 1;
pub const CONFIG_IMA_KEYRINGS_PERMIT_SIGNED_BY_BUILTIN_OR_SECONDARY: u32 = 1;
pub const CONFIG_GPIO_XLP_MODULE: u32 = 1;
pub const CONFIG_DWMAC_SUN8I_MODULE: u32 = 1;
pub const CONFIG_INTERCONNECT_QCOM_SC8280XP_MODULE: u32 = 1;
pub const CONFIG_SPI_FSL_QUADSPI_MODULE: u32 = 1;
pub const CONFIG_MLXSW_CORE_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_ARMADA_CP110: u32 = 1;
pub const CONFIG_SND_CMIPCI_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_ECDSA: u32 = 1;
pub const CONFIG_COMMON_CLK_SI544_MODULE: u32 = 1;
pub const CONFIG_MMC_SDHCI_AM654_MODULE: u32 = 1;
pub const CONFIG_ROCKCHIP_LVDS: u32 = 1;
pub const CONFIG_SND_SOC_LPASS_HDMI_MODULE: u32 = 1;
pub const CONFIG_KVM: u32 = 1;
pub const CONFIG_NFT_FLOW_OFFLOAD_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_CONNLIMIT_MODULE: u32 = 1;
pub const CONFIG_DEFAULT_MMAP_MIN_ADDR: u32 = 65536;
pub const CONFIG_SENSORS_LM95241_MODULE: u32 = 1;
pub const CONFIG_NLS_CODEPAGE_936_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_827319: u32 = 1;
pub const CONFIG_GPIO_PCA953X: u32 = 1;
pub const CONFIG_CRYPTO_CMAC: u32 = 1;
pub const CONFIG_TRANSPARENT_HUGEPAGE: u32 = 1;
pub const CONFIG_BT_MSFTEXT: u32 = 1;
pub const CONFIG_REGULATOR_RT4803_MODULE: u32 = 1;
pub const CONFIG_WLAN_VENDOR_BROADCOM: u32 = 1;
pub const CONFIG_NET_SCH_MULTIQ_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_ZET6223_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_HYNITRON_CSTXXX_MODULE: u32 = 1;
pub const CONFIG_ARM_FFA_TRANSPORT: u32 = 1;
pub const CONFIG_BPF_JIT_DEFAULT_ON: u32 = 1;
pub const CONFIG_LEDS_LT3593_MODULE: u32 = 1;
pub const CONFIG_SERIAL_8250_EXAR_MODULE: u32 = 1;
pub const CONFIG_SPI_DW_DMA: u32 = 1;
pub const CONFIG_QLCNIC_SRIOV: u32 = 1;
pub const CONFIG_ZRAM_WRITEBACK: u32 = 1;
pub const CONFIG_NFS_V4_MODULE: u32 = 1;
pub const CONFIG_ARM64_WORKAROUND_TRBE_WRITE_OUT_OF_RANGE: u32 = 1;
pub const CONFIG_SND_SOC_IMX_AUDMUX_MODULE: u32 = 1;
pub const CONFIG_INTERCONNECT_QCOM_SMD_RPM_MODULE: u32 = 1;
pub const CONFIG_CLK_RK3368: u32 = 1;
pub const CONFIG_DVB_TUNER_ITD1000_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_ES7134_MODULE: u32 = 1;
pub const CONFIG_NET_NSH_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_ARMADA38X_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_ARM_VERSATILE_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV4689_MODULE: u32 = 1;
pub const CONFIG_HID_GOOGLE_STADIA_FF_MODULE: u32 = 1;
pub const CONFIG_HID_LCPOWER_MODULE: u32 = 1;
pub const CONFIG_F2FS_FS_SECURITY: u32 = 1;
pub const CONFIG_SND_AC97_CODEC_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_PFC_R8A774A1: u32 = 1;
pub const CONFIG_PINCTRL_IMX8MP: u32 = 1;
pub const CONFIG_GENEVE_MODULE: u32 = 1;
pub const CONFIG_DVB_NXT6000_MODULE: u32 = 1;
pub const CONFIG_BLK_DEV_NBD_MODULE: u32 = 1;
pub const CONFIG_SOC_IMX9_MODULE: u32 = 1;
pub const CONFIG_SERIAL_MESON: u32 = 1;
pub const CONFIG_IIO_ST_GYRO_SPI_3AXIS_MODULE: u32 = 1;
pub const CONFIG_ARM64_HW_AFDBM: u32 = 1;
pub const CONFIG_KFENCE_NUM_OBJECTS: u32 = 255;
pub const CONFIG_IP_SET_HASH_NET_MODULE: u32 = 1;
pub const CONFIG_KCMP: u32 = 1;
pub const CONFIG_RTC_DRV_DS1742_MODULE: u32 = 1;
pub const CONFIG_TEGRA_IOMMU_SMMU: u32 = 1;
pub const CONFIG_DRM_NOUVEAU_CH7006_MODULE: u32 = 1;
pub const CONFIG_SENSORS_ACPI_POWER_MODULE: u32 = 1;
pub const CONFIG_XFRM_ALGO: u32 = 1;
pub const CONFIG_SD_ADC_MODULATOR_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_STMICRO: u32 = 1;
pub const CONFIG_AX88796B_PHY_MODULE: u32 = 1;
pub const CONFIG_IPU_BRIDGE_MODULE: u32 = 1;
pub const CONFIG_DPAA_ERRATUM_A050385: u32 = 1;
pub const CONFIG_FTRACE_MCOUNT_RECORD: u32 = 1;
pub const CONFIG_LEDS_TRIGGER_TTY_MODULE: u32 = 1;
pub const CONFIG_BUILD_SALT: &[u8; 56] =
    b"6.15.0-0.rc7.20250525.d0c22de9.460.vanilla.fc43.aarch64\0";
pub const CONFIG_PINCTRL_MESON_AXG: u32 = 1;
pub const CONFIG_SND_BT87X_MODULE: u32 = 1;
pub const CONFIG_DRM_XE_PREEMPT_TIMEOUT: u32 = 640000;
pub const CONFIG_HISILICON_LPC: u32 = 1;
pub const CONFIG_HID_NINTENDO_MODULE: u32 = 1;
pub const CONFIG_SND_HDA_CODEC_CIRRUS_MODULE: u32 = 1;
pub const CONFIG_GPIO_EXAR_MODULE: u32 = 1;
pub const CONFIG_DUMMY_CONSOLE_ROWS: u32 = 25;
pub const CONFIG_NVME_FABRICS_MODULE: u32 = 1;
pub const CONFIG_FUNCTION_TRACER: u32 = 1;
pub const CONFIG_SURFACE_AGGREGATOR_TABLET_SWITCH_MODULE: u32 = 1;
pub const CONFIG_MEDIA_CONTROLLER_DVB: u32 = 1;
pub const CONFIG_AD5272_MODULE: u32 = 1;
pub const CONFIG_DM_DEBUG: u32 = 1;
pub const CONFIG_MODPROBE_PATH: &[u8; 19] = b"/usr/sbin/modprobe\0";
pub const CONFIG_MLXSW_CORE_HWMON: u32 = 1;
pub const CONFIG_RTL8187_MODULE: u32 = 1;
pub const CONFIG_HID_MEGAWORLD_FF_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_2038923: u32 = 1;
pub const CONFIG_POSIX_MQUEUE: u32 = 1;
pub const CONFIG_LEDS_GROUP_MULTICOLOR_MODULE: u32 = 1;
pub const CONFIG_SENSORS_POWR1220_MODULE: u32 = 1;
pub const CONFIG_TEXTSEARCH_FSM_MODULE: u32 = 1;
pub const CONFIG_VHOST_SCSI_MODULE: u32 = 1;
pub const CONFIG_NFSD_SCSILAYOUT: u32 = 1;
pub const CONFIG_RMI4_SMB_MODULE: u32 = 1;
pub const CONFIG_STMPE_ADC_MODULE: u32 = 1;
pub const CONFIG_MQ_IOSCHED_DEADLINE: u32 = 1;
pub const CONFIG_HAVE_CLK: u32 = 1;
pub const CONFIG_USB_SERIAL_SIERRAWIRELESS_MODULE: u32 = 1;
pub const CONFIG_MAC_PARTITION: u32 = 1;
pub const CONFIG_SND_SOC_SIMPLE_AMPLIFIER_MODULE: u32 = 1;
pub const CONFIG_DRM_AMD_SECURE_DISPLAY: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_RT: u32 = 1;
pub const CONFIG_DEBUG_FS: u32 = 1;
pub const CONFIG_USB_ONBOARD_DEV_USB5744: u32 = 1;
pub const CONFIG_MEDIA_CEC_SUPPORT: u32 = 1;
pub const CONFIG_SND_SOC_RT5677_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_MANTIX_MLAF057WE51_MODULE: u32 = 1;
pub const CONFIG_CROS_KBD_LED_BACKLIGHT_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_DS1307_MODULE: u32 = 1;
pub const CONFIG_PPTP_MODULE: u32 = 1;
pub const CONFIG_VIDEO_TEGRA_VDE_MODULE: u32 = 1;
pub const CONFIG_FUTEX: u32 = 1;
pub const CONFIG_DM_VDO_MODULE: u32 = 1;
pub const CONFIG_HID_GLORIOUS_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_TI_K3_MODULE: u32 = 1;
pub const CONFIG_IP_SET_MAX: u32 = 256;
pub const CONFIG_ASYNC_CORE_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_FEIXIN_K101_IM2BA02_MODULE: u32 = 1;
pub const CONFIG_RAPIDIO_CHMAN_MODULE: u32 = 1;
pub const CONFIG_HAVE_DYNAMIC_FTRACE_WITH_CALL_OPS: u32 = 1;
pub const CONFIG_ADIS16475_MODULE: u32 = 1;
pub const CONFIG_MODULE_SIG_KEY_TYPE_RSA: u32 = 1;
pub const CONFIG_ATALK_MODULE: u32 = 1;
pub const CONFIG_NF_TABLES_INET: u32 = 1;
pub const CONFIG_TCM_USER2_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_SAMSUNG_S6E88A0_AMS452EF01_MODULE: u32 = 1;
pub const CONFIG_VIDEO_TDA9840_MODULE: u32 = 1;
pub const CONFIG_NEED_PER_CPU_EMBED_FIRST_CHUNK: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_819472: u32 = 1;
pub const CONFIG_SND_SOC_ZL38060_MODULE: u32 = 1;
pub const CONFIG_SERIAL_SH_SCI_DMA: u32 = 1;
pub const CONFIG_SERIAL_TEGRA_TCU_CONSOLE: u32 = 1;
pub const CONFIG_MTD_MCHP48L640_MODULE: u32 = 1;
pub const CONFIG_JOYSTICK_XPAD_LEDS: u32 = 1;
pub const CONFIG_RTC_DRV_DS1685: u32 = 1;
pub const CONFIG_USB_LCD_MODULE: u32 = 1;
pub const CONFIG_OCTEONTX2_PF_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_CURRENT_STACK_POINTER: u32 = 1;
pub const CONFIG_USB_SL811_HCD_ISO: u32 = 1;
pub const CONFIG_SENSORS_CHIPCAP2_MODULE: u32 = 1;
pub const CONFIG_RAPIDIO_MODULE: u32 = 1;
pub const CONFIG_FB_SYSMEM_HELPERS: u32 = 1;
pub const CONFIG_RESET_QCOM_PDC_MODULE: u32 = 1;
pub const CONFIG_ROCKCHIP_PM_DOMAINS: u32 = 1;
pub const CONFIG_NVMEM_MESON_EFUSE_MODULE: u32 = 1;
pub const CONFIG_SERIAL_8250_PNP: u32 = 1;
pub const CONFIG_USBIP_VHCI_NR_HCS: u32 = 1;
pub const CONFIG_BE2NET_LANCER: u32 = 1;
pub const CONFIG_ARCH_RENESAS: u32 = 1;
pub const CONFIG_HAVE_FUNCTION_ERROR_INJECTION: u32 = 1;
pub const CONFIG_CAN_CTUCANFD_PCI_MODULE: u32 = 1;
pub const CONFIG_RADIO_SHARK_MODULE: u32 = 1;
pub const CONFIG_XILINX_XADC_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_PIXCIR_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CX2072X_MODULE: u32 = 1;
pub const CONFIG_JOYSTICK_SENSEHAT_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MAX1668_MODULE: u32 = 1;
pub const CONFIG_MEGARAID_MM_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_ADAU7118_I2C_MODULE: u32 = 1;
pub const CONFIG_HAS_DMA: u32 = 1;
pub const CONFIG_SOFTIRQ_ON_OWN_STACK: u32 = 1;
pub const CONFIG_OPT3001_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_KHADAS_TS050_MODULE: u32 = 1;
pub const CONFIG_SENSORS_TDA38640_MODULE: u32 = 1;
pub const CONFIG_SND_MONA_MODULE: u32 = 1;
pub const CONFIG_W1_SLAVE_DS2413_MODULE: u32 = 1;
pub const CONFIG_MLX4_EN_MODULE: u32 = 1;
pub const CONFIG_ARCH_WANT_BATCHED_UNMAP_TLB_FLUSH: u32 = 1;
pub const CONFIG_SX9324_MODULE: u32 = 1;
pub const CONFIG_SND_MESON_CODEC_GLUE_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_USER_API: u32 = 1;
pub const CONFIG_AUDITSYSCALL: u32 = 1;
pub const CONFIG_CLK_IMX93: u32 = 1;
pub const CONFIG_ANDROID_BINDERFS: u32 = 1;
pub const CONFIG_STACKDEPOT: u32 = 1;
pub const CONFIG_CHARGER_LTC4162L_MODULE: u32 = 1;
pub const CONFIG_IP_SET_BITMAP_IPMAC_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_FSL_RPMSG_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TLV320AIC3X_MODULE: u32 = 1;
pub const CONFIG_KEBA_LAN9252_MODULE: u32 = 1;
pub const CONFIG_ARM64: u32 = 1;
pub const CONFIG_ARCH_HAS_ACPI_TABLE_UPGRADE: u32 = 1;
pub const CONFIG_USB_CDNS_SUPPORT_MODULE: u32 = 1;
pub const CONFIG_TIMER_ACPI: u32 = 1;
pub const CONFIG_ARCH_R9A09G057: u32 = 1;
pub const CONFIG_GENERIC_BUG: u32 = 1;
pub const CONFIG_CEC_MESON_AO_MODULE: u32 = 1;
pub const CONFIG_XFS_MEMORY_BUFS: u32 = 1;
pub const CONFIG_IP_VS_MODULE: u32 = 1;
pub const CONFIG_SND_LOLA_MODULE: u32 = 1;
pub const CONFIG_MOUSE_ELAN_I2C_I2C: u32 = 1;
pub const CONFIG_USB_WDM_MODULE: u32 = 1;
pub const CONFIG_TCP_CONG_ILLINOIS_MODULE: u32 = 1;
pub const CONFIG_VIDEO_ROCKCHIP_ISP1_MODULE: u32 = 1;
pub const CONFIG_BT_RFCOMM_TTY: u32 = 1;
pub const CONFIG_BT_ATH3K_MODULE: u32 = 1;
pub const CONFIG_AD3552R_MODULE: u32 = 1;
pub const CONFIG_USBIP_CORE_MODULE: u32 = 1;
pub const CONFIG_UNION_FIND: u32 = 1;
pub const CONFIG_BRCMUTIL_MODULE: u32 = 1;
pub const CONFIG_BTRFS_FS: u32 = 1;
pub const CONFIG_KVFREE_RCU_BATCHED: u32 = 1;
pub const CONFIG_SND_HDA_CODEC_REALTEK_MODULE: u32 = 1;
pub const CONFIG_VIDEO_TW9910_MODULE: u32 = 1;
pub const CONFIG_DRM_MSM_DSI_7NM_PHY: u32 = 1;
pub const CONFIG_IP_VS_IPV6: u32 = 1;
pub const CONFIG_CPU_FREQ_GOV_COMMON: u32 = 1;
pub const CONFIG_PPP_MPPE_MODULE: u32 = 1;
pub const CONFIG_SCSI_QLA_FC_MODULE: u32 = 1;
pub const CONFIG_HAVE_ALIGNED_STRUCT_PAGE: u32 = 1;
pub const CONFIG_THUNDER_NIC_VF_MODULE: u32 = 1;
pub const CONFIG_I2C_MUX_MULE_MODULE: u32 = 1;
pub const CONFIG_CB710_CORE_MODULE: u32 = 1;
pub const CONFIG_FUSE_IO_URING: u32 = 1;
pub const CONFIG_CEPH_LIB_MODULE: u32 = 1;
pub const CONFIG_LEGACY_DIRECT_IO: u32 = 1;
pub const CONFIG_PHY_QCOM_USB_SNPS_FEMTO_V2_MODULE: u32 = 1;
pub const CONFIG_BATMAN_ADV_MCAST: u32 = 1;
pub const CONFIG_LOCK_SPIN_ON_OWNER: u32 = 1;
pub const CONFIG_HAVE_PERF_USER_STACK_DUMP: u32 = 1;
pub const CONFIG_GPIO_IDIO_16_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_SNVS_MODULE: u32 = 1;
pub const CONFIG_VIDEO_ADV7842_MODULE: u32 = 1;
pub const CONFIG_NVME_CORE_MODULE: u32 = 1;
pub const CONFIG_SVC_I3C_MASTER_MODULE: u32 = 1;
pub const CONFIG_AMD_PHY_MODULE: u32 = 1;
pub const CONFIG_USB_PCI_AMD: u32 = 1;
pub const CONFIG_VIDEO_OV13B10_MODULE: u32 = 1;
pub const CONFIG_SENSORS_AXI_FAN_CONTROL_MODULE: u32 = 1;
pub const CONFIG_HNS3_HCLGEVF_MODULE: u32 = 1;
pub const CONFIG_NF_CT_NETLINK_TIMEOUT_MODULE: u32 = 1;
pub const CONFIG_B43LEGACY_DMA: u32 = 1;
pub const CONFIG_SKB_EXTENSIONS: u32 = 1;
pub const CONFIG_HUGETLB_PAGE: u32 = 1;
pub const CONFIG_SND_SOC_TAS5805M_MODULE: u32 = 1;
pub const CONFIG_HMEM_REPORTING: u32 = 1;
pub const CONFIG_MMC_SUNXI_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_ES8328_SPI_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_TEGRA: u32 = 1;
pub const CONFIG_SND_SOC_MAX98088_MODULE: u32 = 1;
pub const CONFIG_XFRM_INTERFACE_MODULE: u32 = 1;
pub const CONFIG_DMA_NUMA_CMA: u32 = 1;
pub const CONFIG_HAVE_ARCH_RANDOMIZE_KSTACK_OFFSET: u32 = 1;
pub const CONFIG_SERIAL_CORE: u32 = 1;
pub const CONFIG_DVB_USB_GP8PSK_MODULE: u32 = 1;
pub const CONFIG_ROSE_MODULE: u32 = 1;
pub const CONFIG_HOTPLUG_PCI_PCIE: u32 = 1;
pub const CONFIG_ARM64_PMEM: u32 = 1;
pub const CONFIG_NFS_USE_KERNEL_DNS: u32 = 1;
pub const CONFIG_MLX_WDT_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_1286807: u32 = 1;
pub const CONFIG_NO_HZ_FULL: u32 = 1;
pub const CONFIG_SENSORS_MP5023_MODULE: u32 = 1;
pub const CONFIG_INPUT_PM8XXX_VIBRATOR_MODULE: u32 = 1;
pub const CONFIG_TYPEC_QCOM_PMIC_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_SDCA_OPTIONAL_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CS35L45_I2C_MODULE: u32 = 1;
pub const CONFIG_LEDS_TRIGGERS: u32 = 1;
pub const CONFIG_NET_SCH_TBF_MODULE: u32 = 1;
pub const CONFIG_SECURITY_NETWORK_XFRM: u32 = 1;
pub const CONFIG_BRCMSMAC_MODULE: u32 = 1;
pub const CONFIG_CAN_MCP251X_MODULE: u32 = 1;
pub const CONFIG_UBIFS_FS_LZO: u32 = 1;
pub const CONFIG_SND_SOC_WM8731_MODULE: u32 = 1;
pub const CONFIG_SENSORS_LTC2945_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_SM8350_LPASS_LPI_MODULE: u32 = 1;
pub const CONFIG_K3_THERMAL_MODULE: u32 = 1;
pub const CONFIG_MLX5_CORE_MODULE: u32 = 1;
pub const CONFIG_GENERIC_IRQ_STAT_SNAPSHOT: u32 = 1;
pub const CONFIG_NET_KEY_MODULE: u32 = 1;
pub const CONFIG_REMOTE_TARGET_MODULE: u32 = 1;
pub const CONFIG_SERIAL_MCTRL_GPIO: u32 = 1;
pub const CONFIG_REGULATOR_MAX77686_MODULE: u32 = 1;
pub const CONFIG_NET_DSA_TAG_HELLCREEK_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_ZC3XX_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_CCM: u32 = 1;
pub const CONFIG_SCSI_INIA100_MODULE: u32 = 1;
pub const CONFIG_QLCNIC_MODULE: u32 = 1;
pub const CONFIG_EROFS_FS_ZIP_DEFLATE: u32 = 1;
pub const CONFIG_IP_VS_NQ_MODULE: u32 = 1;
pub const CONFIG_SERIAL_AMBA_PL011: u32 = 1;
pub const CONFIG_QCOM_QSEECOM: u32 = 1;
pub const CONFIG_PRESTERA_PCI_MODULE: u32 = 1;
pub const CONFIG_CLK_RENESAS_DIV6: u32 = 1;
pub const CONFIG_ARM64_PA_BITS_48: u32 = 1;
pub const CONFIG_SPEAKUP_SYNTH_AUDPTR_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA210_MIXER_MODULE: u32 = 1;
pub const CONFIG_SND_RAWMIDI_MODULE: u32 = 1;
pub const CONFIG_ARM64_LSE_ATOMICS: u32 = 1;
pub const CONFIG_JOYSTICK_SIDEWINDER_MODULE: u32 = 1;
pub const CONFIG_HAVE_PWRCTL: u32 = 1;
pub const CONFIG_TI_SYSC: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_SHADOW_CALL_STACK: u32 = 1;
pub const CONFIG_GENERIC_GETTIMEOFDAY: u32 = 1;
pub const CONFIG_QCOM_QDF2400_ERRATUM_0065: u32 = 1;
pub const CONFIG_IP_SET_HASH_IPMARK_MODULE: u32 = 1;
pub const CONFIG_LEDS_CR0014114_MODULE: u32 = 1;
pub const CONFIG_IIO_CROS_EC_SENSORS_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_QCOM_SMD_RPM_MODULE: u32 = 1;
pub const CONFIG_FW_UPLOAD: u32 = 1;
pub const CONFIG_EDAC_LAYERSCAPE_MODULE: u32 = 1;
pub const CONFIG_MLXBF_GIGE_MODULE: u32 = 1;
pub const CONFIG_TEGRA_HOST1X_MODULE: u32 = 1;
pub const CONFIG_QEDE_MODULE: u32 = 1;
pub const CONFIG_SND_USB: u32 = 1;
pub const CONFIG_VIDEO_DS90UB960_MODULE: u32 = 1;
pub const CONFIG_NET_ACT_CT_MODULE: u32 = 1;
pub const CONFIG_VIDEO_CX18_ALSA_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_TV8532_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_RTL28XXU_MODULE: u32 = 1;
pub const CONFIG_PCS_XPCS_MODULE: u32 = 1;
pub const CONFIG_IMA_DEFAULT_TEMPLATE: &[u8; 7] = b"ima-ng\0";
pub const CONFIG_ND_CLAIM: u32 = 1;
pub const CONFIG_BRCMFMAC_PROTO_MSGBUF: u32 = 1;
pub const CONFIG_GPIO_CDEV_V1: u32 = 1;
pub const CONFIG_SYN_COOKIES: u32 = 1;
pub const CONFIG_SND_SOC_SIGMADSP_MODULE: u32 = 1;
pub const CONFIG_INFINIBAND_IPOIB_CM: u32 = 1;
pub const CONFIG_ARCH_HAS_FORTIFY_SOURCE: u32 = 1;
pub const CONFIG_HISILICON_ERRATUM_161010101: u32 = 1;
pub const CONFIG_DRM_ETNAVIV_THERMAL: u32 = 1;
pub const CONFIG_DRM_PANIC_SCREEN_QR_VERSION: u32 = 40;
pub const CONFIG_VIDEO_LT6911UXE_MODULE: u32 = 1;
pub const CONFIG_CLK_R8A774A1: u32 = 1;
pub const CONFIG_MT7663S_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_SCTP_MODULE: u32 = 1;
pub const CONFIG_HID_GEMBIRD_MODULE: u32 = 1;
pub const CONFIG_MAX77620_THERMAL_MODULE: u32 = 1;
pub const CONFIG_NF_FLOW_TABLE_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_SHA3: u32 = 1;
pub const CONFIG_SPI_XLP_MODULE: u32 = 1;
pub const CONFIG_NFC_SIM_MODULE: u32 = 1;
pub const CONFIG_SND_PCMTEST_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_QUALCOMM: u32 = 1;
pub const CONFIG_ZRAM_DEF_COMP_LZORLE: u32 = 1;
pub const CONFIG_STACKTRACE_SUPPORT: u32 = 1;
pub const CONFIG_JOYSTICK_ADC_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_HDA_MODULE: u32 = 1;
pub const CONFIG_TEGRA186_GPC_DMA_MODULE: u32 = 1;
pub const CONFIG_NFT_DUP_IPV4_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_CONNMARK_MODULE: u32 = 1;
pub const CONFIG_PCIEASPM_DEFAULT: u32 = 1;
pub const CONFIG_FPGA_MODULE: u32 = 1;
pub const CONFIG_SND_MODULE: u32 = 1;
pub const CONFIG_MVEBU_ODMI: u32 = 1;
pub const CONFIG_SENSORS_W83627EHF_MODULE: u32 = 1;
pub const CONFIG_MEGARAID_LEGACY_MODULE: u32 = 1;
pub const CONFIG_MD_LINEAR_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_AEAD: u32 = 1;
pub const CONFIG_IEEE802154_MRF24J40_MODULE: u32 = 1;
pub const CONFIG_BCMGENET_MODULE: u32 = 1;
pub const CONFIG_ROCKCHIP_ERRATUM_3568002: u32 = 1;
pub const CONFIG_PCI_IMX6_HOST: u32 = 1;
pub const CONFIG_MAX31856_MODULE: u32 = 1;
pub const CONFIG_CHARGER_RT9471_MODULE: u32 = 1;
pub const CONFIG_BLK_DEV_THROTTLING: u32 = 1;
pub const CONFIG_PDS_VFIO_PCI_MODULE: u32 = 1;
pub const CONFIG_NVIDIA_CARMEL_CNP_ERRATUM: u32 = 1;
pub const CONFIG_NET_DSA_TAG_LAN9303_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_ADAU_UTILS_MODULE: u32 = 1;
pub const CONFIG_SECTION_MISMATCH_WARN_ONLY: u32 = 1;
pub const CONFIG_ASYNC_XOR_MODULE: u32 = 1;
pub const CONFIG_PROC_CHILDREN: u32 = 1;
pub const CONFIG_INET_MPTCP_DIAG: u32 = 1;
pub const CONFIG_FPGA_DFL_AFU_MODULE: u32 = 1;
pub const CONFIG_DRM_DISPLAY_HDCP_HELPER: u32 = 1;
pub const CONFIG_CC_IS_GCC: u32 = 1;
pub const CONFIG_SQUASHFS_FILE_DIRECT: u32 = 1;
pub const CONFIG_SPI_QCOM_QSPI_MODULE: u32 = 1;
pub const CONFIG_FDMA: u32 = 1;
pub const CONFIG_AX25_MODULE: u32 = 1;
pub const CONFIG_VSOCKETS_LOOPBACK_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_MESON: u32 = 1;
pub const CONFIG_VIDEO_MXB_MODULE: u32 = 1;
pub const CONFIG_BLK_DEV_UBLK_MODULE: u32 = 1;
pub const CONFIG_QCOM_CLK_APCS_MSM8916_MODULE: u32 = 1;
pub const CONFIG_CMDLINE: &[u8; 1] = b"\0";
pub const CONFIG_SENSORS_IIO_HWMON_MODULE: u32 = 1;
pub const CONFIG_HAVE_CMPXCHG_LOCAL: u32 = 1;
pub const CONFIG_JOYSTICK_COBRA_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_SUN50I_H616_R: u32 = 1;
pub const CONFIG_MLXREG_IO_MODULE: u32 = 1;
pub const CONFIG_FPGA_MGR_ALTERA_PS_SPI_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_PL031: u32 = 1;
pub const CONFIG_RPMB_MODULE: u32 = 1;
pub const CONFIG_IPV6_ROUTER_PREF: u32 = 1;
pub const CONFIG_CGROUP_SCHED: u32 = 1;
pub const CONFIG_DMA_ENGINE: u32 = 1;
pub const CONFIG_PRIME_NUMBERS_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_FSL_CAAM_INTC: u32 = 1;
pub const CONFIG_FPGA_REGION_MODULE: u32 = 1;
pub const CONFIG_DA280_MODULE: u32 = 1;
pub const CONFIG_SENSORS_RM3100_SPI_MODULE: u32 = 1;
pub const CONFIG_MAX44009_MODULE: u32 = 1;
pub const CONFIG_MMC_SDHI_MODULE: u32 = 1;
pub const CONFIG_DVB_TDA10048_MODULE: u32 = 1;
pub const CONFIG_ARM_ARMADA_8K_CPUFREQ_MODULE: u32 = 1;
pub const CONFIG_PCIE_XILINX_CPM: u32 = 1;
pub const CONFIG_F2FS_FS_COMPRESSION: u32 = 1;
pub const CONFIG_IP_SET_HASH_MAC_MODULE: u32 = 1;
pub const CONFIG_SQUASHFS_COMPILE_DECOMP_MULTI_PERCPU: u32 = 1;
pub const CONFIG_NET_DSA_LOOP_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_CRC32C: u32 = 1;
pub const CONFIG_PM_STD_PARTITION: &[u8; 1] = b"\0";
pub const CONFIG_CRYPTO_DEV_FSL_CAAM_AHASH_API_DESC_MODULE: u32 = 1;
pub const CONFIG_L2TP_IP_MODULE: u32 = 1;
pub const CONFIG_HNS_ENET_MODULE: u32 = 1;
pub const CONFIG_DM_ZONED_MODULE: u32 = 1;
pub const CONFIG_ARM_CCI400_COMMON: u32 = 1;
pub const CONFIG_SND_INDIGODJ_MODULE: u32 = 1;
pub const CONFIG_INTERCONNECT_QCOM_MSM8916_MODULE: u32 = 1;
pub const CONFIG_RD_BZIP2: u32 = 1;
pub const CONFIG_NLS_CODEPAGE_1250_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_MAX2165_MODULE: u32 = 1;
pub const CONFIG_DVB_LNBP22_MODULE: u32 = 1;
pub const CONFIG_ECRYPT_FS_MODULE: u32 = 1;
pub const CONFIG_DWMAC_IMX8_MODULE: u32 = 1;
pub const CONFIG_FRAMEBUFFER_CONSOLE_DEFERRED_TAKEOVER: u32 = 1;
pub const CONFIG_PHYS_ADDR_T_64BIT: u32 = 1;
pub const CONFIG_USB_F_NCM_MODULE: u32 = 1;
pub const CONFIG_UVC_COMMON_MODULE: u32 = 1;
pub const CONFIG_HAVE_FUNCTION_GRAPH_TRACER: u32 = 1;
pub const CONFIG_BPF_UNPRIV_DEFAULT_OFF: u32 = 1;
pub const CONFIG_FB_MODE_HELPERS: u32 = 1;
pub const CONFIG_USB_GSPCA_OV534_9_MODULE: u32 = 1;
pub const CONFIG_MFD_TPS6594_I2C_MODULE: u32 = 1;
pub const CONFIG_SCSI_IPR_TRACE: u32 = 1;
pub const CONFIG_CGROUP_BPF: u32 = 1;
pub const CONFIG_DRM_IMX8MP_DW_HDMI_BRIDGE_MODULE: u32 = 1;
pub const CONFIG_MT76_LEDS: u32 = 1;
pub const CONFIG_BT_AOSPEXT: u32 = 1;
pub const CONFIG_NET_SCH_CBS_MODULE: u32 = 1;
pub const CONFIG_INFINIBAND_ERDMA_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TDA7419_MODULE: u32 = 1;
pub const CONFIG_SUN8I_DE2_CCU: u32 = 1;
pub const CONFIG_HIDRAW: u32 = 1;
pub const CONFIG_RTC_DRV_AS3722_MODULE: u32 = 1;
pub const CONFIG_MSPRO_BLOCK_MODULE: u32 = 1;
pub const CONFIG_NVME_APPLE_MODULE: u32 = 1;
pub const CONFIG_ARM64_AS_HAS_MTE: u32 = 1;
pub const CONFIG_DVB_USB_AF9005_REMOTE_MODULE: u32 = 1;
pub const CONFIG_SRAM: u32 = 1;
pub const CONFIG_CRYPTO_DES_MODULE: u32 = 1;
pub const CONFIG_IR_NEC_DECODER_MODULE: u32 = 1;
pub const CONFIG_ARM_SDE_INTERFACE: u32 = 1;
pub const CONFIG_LOCK_DEBUGGING_SUPPORT: u32 = 1;
pub const CONFIG_VIDEOBUF2_DMA_CONTIG_MODULE: u32 = 1;
pub const CONFIG_ATH10K_PCI_MODULE: u32 = 1;
pub const CONFIG_MCTP: u32 = 1;
pub const CONFIG_SCSI_ISCSI_ATTRS_MODULE: u32 = 1;
pub const CONFIG_SECURITY_SELINUX_SID2STR_CACHE_SIZE: u32 = 256;
pub const CONFIG_BUG: u32 = 1;
pub const CONFIG_JFFS2_RTIME: u32 = 1;
pub const CONFIG_DVB_AU8522_V4L_MODULE: u32 = 1;
pub const CONFIG_IR_HIX5HD2_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_ROCKCHIP_MODULE: u32 = 1;
pub const CONFIG_QCOM_TZMEM_MODE_GENERIC: u32 = 1;
pub const CONFIG_IPVTAP_MODULE: u32 = 1;
pub const CONFIG_QCOM_Q6V5_WCSS_MODULE: u32 = 1;
pub const CONFIG_VIDEO_MT9P031_MODULE: u32 = 1;
pub const CONFIG_MEMORY: u32 = 1;
pub const CONFIG_TTPCI_EEPROM_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_RT715_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_GCOV_PROFILE_ALL: u32 = 1;
pub const CONFIG_AF_KCM_MODULE: u32 = 1;
pub const CONFIG_SND_SYNTH_EMUX_MODULE: u32 = 1;
pub const CONFIG_QCOM_WDT_MODULE: u32 = 1;
pub const CONFIG_NFC_SHDLC: u32 = 1;
pub const CONFIG_ROCKCHIP_SARADC_MODULE: u32 = 1;
pub const CONFIG_VIDEO_KS0127_MODULE: u32 = 1;
pub const CONFIG_XZ_DEC_BCJ: u32 = 1;
pub const CONFIG_USB_SERIAL_OTI6858_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_2457168: u32 = 1;
pub const CONFIG_DRM_KMS_HELPER: u32 = 1;
pub const CONFIG_CHELSIO_T4_DCB: u32 = 1;
pub const CONFIG_TCS3472_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_SC7180_MODULE: u32 = 1;
pub const CONFIG_PCI_PWRCTL_PWRSEQ_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_TCPOPTSTRIP_MODULE: u32 = 1;
pub const CONFIG_SND_MESON_AXG_TDM_FORMATTER_MODULE: u32 = 1;
pub const CONFIG_HAVE_ARCH_USERFAULTFD_WP: u32 = 1;
pub const CONFIG_FB_SYSMEM_FOPS: u32 = 1;
pub const CONFIG_DRM_SUN8I_TCON_TOP_MODULE: u32 = 1;
pub const CONFIG_SERIAL_SH_SCI_EARLYCON: u32 = 1;
pub const CONFIG_PAGE_REPORTING: u32 = 1;
pub const CONFIG_SCHED_HRTICK: u32 = 1;
pub const CONFIG_IMA_APPRAISE_BOOTPARAM: u32 = 1;
pub const CONFIG_TRACING_SUPPORT: u32 = 1;
pub const CONFIG_QCOM_PBS_MODULE: u32 = 1;
pub const CONFIG_IOMMU_MM_DATA: u32 = 1;
pub const CONFIG_MPLS: u32 = 1;
pub const CONFIG_SERIAL_SC16IS7XX_I2C_MODULE: u32 = 1;
pub const CONFIG_STACK_TRACER: u32 = 1;
pub const CONFIG_SND_UMP_LEGACY_RAWMIDI: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_HL_MODULE: u32 = 1;
pub const CONFIG_NET_ACT_SKBMOD_MODULE: u32 = 1;
pub const CONFIG_LEDS_LP50XX_MODULE: u32 = 1;
pub const CONFIG_TEGRA_IVC: u32 = 1;
pub const CONFIG_SCTP_DEFAULT_COOKIE_HMAC_SHA1: u32 = 1;
pub const CONFIG_PINCTRL_SUN50I_A64_R: u32 = 1;
pub const CONFIG_NET_HANDSHAKE_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_USB_EHCI_PCI: u32 = 1;
pub const CONFIG_MFD_RT5033_MODULE: u32 = 1;
pub const CONFIG_SPI_BCM2835_MODULE: u32 = 1;
pub const CONFIG_DRM_DISPLAY_DP_TUNNEL: u32 = 1;
pub const CONFIG_ACPI_HMAT: u32 = 1;
pub const CONFIG_PCIE_MOBIVEIL: u32 = 1;
pub const CONFIG_RUST_OVERFLOW_CHECKS: u32 = 1;
pub const CONFIG_REGULATOR_RT5120_MODULE: u32 = 1;
pub const CONFIG_GPIO_ROCKCHIP: u32 = 1;
pub const CONFIG_GNSS_SIRF_SERIAL_MODULE: u32 = 1;
pub const CONFIG_IP_SET_HASH_IP_MODULE: u32 = 1;
pub const CONFIG_VIRTIO_MENU: u32 = 1;
pub const CONFIG_RTC_DRV_RX8581_MODULE: u32 = 1;
pub const CONFIG_BRIDGE_MRP: u32 = 1;
pub const CONFIG_NVME_TARGET_TCP_TLS: u32 = 1;
pub const CONFIG_ARM_PSCI_FW: u32 = 1;
pub const CONFIG_SURFACE_PRO3_BUTTON_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_CADENCE: u32 = 1;
pub const CONFIG_NFT_BRIDGE_META_MODULE: u32 = 1;
pub const CONFIG_SPLIT_PTE_PTLOCKS: u32 = 1;
pub const CONFIG_BLK_DEV_WRITE_MOUNTED: u32 = 1;
pub const CONFIG_PINCTRL_ARMADA_37XX: u32 = 1;
pub const CONFIG_CRYPTO_DEV_NITROX_CNN55XX_MODULE: u32 = 1;
pub const CONFIG_MT76x02_USB_MODULE: u32 = 1;
pub const CONFIG_USB_NET_SMSC75XX_MODULE: u32 = 1;
pub const CONFIG_ROMFS_BACKED_BY_BLOCK: u32 = 1;
pub const CONFIG_RTC_DRV_DS1305_MODULE: u32 = 1;
pub const CONFIG_SENSORS_BH1770_MODULE: u32 = 1;
pub const CONFIG_ALTERA_PR_IP_CORE_MODULE: u32 = 1;
pub const CONFIG_ADXL372_MODULE: u32 = 1;
pub const CONFIG_SURFACE_ACPI_NOTIFY_MODULE: u32 = 1;
pub const CONFIG_HAVE_IOREMAP_PROT: u32 = 1;
pub const CONFIG_INT_LOG_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_CC_NO_STRINGOP_OVERFLOW: u32 = 1;
pub const CONFIG_DRM_SUN8I_MIXER_MODULE: u32 = 1;
pub const CONFIG_DRM_UDL_MODULE: u32 = 1;
pub const CONFIG_PCIE_THERMAL: u32 = 1;
pub const CONFIG_DRM_PANEL_SAMSUNG_ATNA33XC20_MODULE: u32 = 1;
pub const CONFIG_LEDS_TRIGGER_TIMER_MODULE: u32 = 1;
pub const CONFIG_MMC_REALTEK_USB_MODULE: u32 = 1;
pub const CONFIG_INTEGRITY_AUDIT: u32 = 1;
pub const CONFIG_VIRTIO_FS_MODULE: u32 = 1;
pub const CONFIG_B53_MMAP_DRIVER_MODULE: u32 = 1;
pub const CONFIG_SERIAL_SAMSUNG_CONSOLE: u32 = 1;
pub const CONFIG_NET_SELFTESTS: u32 = 1;
pub const CONFIG_SND_COMPRESS_ACCEL: u32 = 1;
pub const CONFIG_ARM_QCOM_CPUFREQ_NVMEM_MODULE: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_MEMORY_FAILURE: u32 = 1;
pub const CONFIG_XILLYBUS_OF_MODULE: u32 = 1;
pub const CONFIG_DW_DMAC_MODULE: u32 = 1;
pub const CONFIG_SENSORS_GL520SM_MODULE: u32 = 1;
pub const CONFIG_IMX8M_BLK_CTRL: u32 = 1;
pub const CONFIG_ROCKCHIP_VOP2: u32 = 1;
pub const CONFIG_CRYPTO_DEV_ATMEL_I2C_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_STMPE_MODULE: u32 = 1;
pub const CONFIG_ARCH_WANT_PMD_MKWRITE: u32 = 1;
pub const CONFIG_USB_SERIAL_QCAUX_MODULE: u32 = 1;
pub const CONFIG_SENSORS_AD7314_MODULE: u32 = 1;
pub const CONFIG_6LOWPAN_DEBUGFS: u32 = 1;
pub const CONFIG_I2C_STUB_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_GARMIN_MODULE: u32 = 1;
pub const CONFIG_QCOM_RAMP_CTRL_MODULE: u32 = 1;
pub const CONFIG_QLA3XXX_MODULE: u32 = 1;
pub const CONFIG_AS_HAS_NON_CONST_ULEB128: u32 = 1;
pub const CONFIG_INTERCONNECT_QCOM: u32 = 1;
pub const CONFIG_RTL8187_LEDS: u32 = 1;
pub const CONFIG_F2FS_UNFAIR_RWSEM: u32 = 1;
pub const CONFIG_SM_GCC_8650_MODULE: u32 = 1;
pub const CONFIG_CHARGER_RT9467_MODULE: u32 = 1;
pub const CONFIG_LLD_VERSION: u32 = 0;
pub const CONFIG_USB_STORAGE_ONETOUCH_MODULE: u32 = 1;
pub const CONFIG_REMOTEPROC: u32 = 1;
pub const CONFIG_TI_K3_CPPI_DESC_POOL_MODULE: u32 = 1;
pub const CONFIG_6LOWPAN_NHC_DEST_MODULE: u32 = 1;
pub const CONFIG_W1_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_HASH: u32 = 1;
pub const CONFIG_MLXBF_PMC_MODULE: u32 = 1;
pub const CONFIG_SND_USB_UA101_MODULE: u32 = 1;
pub const CONFIG_MLXSW_CORE_THERMAL: u32 = 1;
pub const CONFIG_CRYPTO_AUTHENC: u32 = 1;
pub const CONFIG_DRM_CLIENT_LIB: u32 = 1;
pub const CONFIG_ARCH_ENABLE_MEMORY_HOTPLUG: u32 = 1;
pub const CONFIG_NET_ACT_GACT_MODULE: u32 = 1;
pub const CONFIG_MEDIA_ATTACH: u32 = 1;
pub const CONFIG_PINCTRL_TEGRA210: u32 = 1;
pub const CONFIG_IIO_ST_SENSORS_SPI_MODULE: u32 = 1;
pub const CONFIG_DRM_XE_DISPLAY: u32 = 1;
pub const CONFIG_VIDEO_VICODEC_MODULE: u32 = 1;
pub const CONFIG_IP_NF_TARGET_NETMAP_MODULE: u32 = 1;
pub const CONFIG_USB_DWC3_HAPS_MODULE: u32 = 1;
pub const CONFIG_IP_NF_MANGLE_MODULE: u32 = 1;
pub const CONFIG_IIO_ST_ACCEL_I2C_3AXIS_MODULE: u32 = 1;
pub const CONFIG_NF_CONNTRACK_SANE_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_DEVGROUP_MODULE: u32 = 1;
pub const CONFIG_IP6_NF_MATCH_EUI64_MODULE: u32 = 1;
pub const CONFIG_SERIAL_ARC_MODULE: u32 = 1;
pub const CONFIG_THUNDER_NIC_RGX_MODULE: u32 = 1;
pub const CONFIG_ATL1_MODULE: u32 = 1;
pub const CONFIG_RPMSG_QCOM_GLINK_RPM_MODULE: u32 = 1;
pub const CONFIG_SC_DISPCC_7280_MODULE: u32 = 1;
pub const CONFIG_DAX: u32 = 1;
pub const CONFIG_MEMREGION: u32 = 1;
pub const CONFIG_PHY_MESON_AXG_MIPI_PCIE_ANALOG: u32 = 1;
pub const CONFIG_IS_SIGNED_TYPE_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_LEDS_SGM3140_MODULE: u32 = 1;
pub const CONFIG_IOSM_MODULE: u32 = 1;
pub const CONFIG_TCP_CONG_WESTWOOD_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TAS2764_MODULE: u32 = 1;
pub const CONFIG_SERIAL_QCOM_GENI: u32 = 1;
pub const CONFIG_ACPI_EC: u32 = 1;
pub const CONFIG_NETFILTER_EGRESS: u32 = 1;
pub const CONFIG_OF_PARTITION: u32 = 1;
pub const CONFIG_IR_NUVOTON_MODULE: u32 = 1;
pub const CONFIG_L2TP_V3: u32 = 1;
pub const CONFIG_RTC_DRV_BBNSM_MODULE: u32 = 1;
pub const CONFIG_BD79703_MODULE: u32 = 1;
pub const CONFIG_DRM_IMX8MP_HDMI_PVI_MODULE: u32 = 1;
pub const CONFIG_I2C_HID_OF_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_AU6610_MODULE: u32 = 1;
pub const CONFIG_SYSTEM_TRUSTED_KEYS: &[u8; 15] = b"certs/rhel.pem\0";
pub const CONFIG_CHARGER_SMB347_MODULE: u32 = 1;
pub const CONFIG_IP_MROUTE_MULTIPLE_TABLES: u32 = 1;
pub const CONFIG_NET_DSA_TAG_BRCM_COMMON_MODULE: u32 = 1;
pub const CONFIG_FPGA_MGR_ALTERA_CVP_MODULE: u32 = 1;
pub const CONFIG_NLS_CODEPAGE_1251_MODULE: u32 = 1;
pub const CONFIG_PCIE_CADENCE_PLAT: u32 = 1;
pub const CONFIG_FSL_ENETC_QOS: u32 = 1;
pub const CONFIG_HID_PRODIKEYS_MODULE: u32 = 1;
pub const CONFIG_DRM_SSD130X_SPI_MODULE: u32 = 1;
pub const CONFIG_VIDEO_BCM2835_MODULE: u32 = 1;
pub const CONFIG_LEDS_PCA9532_MODULE: u32 = 1;
pub const CONFIG_GPIO_VF610: u32 = 1;
pub const CONFIG_GPIOLIB_IRQCHIP: u32 = 1;
pub const CONFIG_XILLYBUS_CLASS_MODULE: u32 = 1;
pub const CONFIG_QCOM_Q6V5_ADSP_MODULE: u32 = 1;
pub const CONFIG_SERIAL_MESON_CONSOLE: u32 = 1;
pub const CONFIG_SPEAKUP_SYNTH_ACNTSA_MODULE: u32 = 1;
pub const CONFIG_TINYDRM_ILI9341_MODULE: u32 = 1;
pub const CONFIG_HYPERV_BALLOON_MODULE: u32 = 1;
pub const CONFIG_NET_SCH_SFQ_MODULE: u32 = 1;
pub const CONFIG_GPIO_WATCHDOG_MODULE: u32 = 1;
pub const CONFIG_SPEAKUP_SYNTH_BNS_MODULE: u32 = 1;
pub const CONFIG_QCOM_MDT_LOADER_MODULE: u32 = 1;
pub const CONFIG_SCSI_SAS_ATTRS_MODULE: u32 = 1;
pub const CONFIG_EFI: u32 = 1;
pub const CONFIG_FORTIFY_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_VBOXSF_FS_MODULE: u32 = 1;
pub const CONFIG_SUNRPC_MODULE: u32 = 1;
pub const CONFIG_NLS_MAC_CELTIC_MODULE: u32 = 1;
pub const CONFIG_TI_DAC7311_MODULE: u32 = 1;
pub const CONFIG_THERMAL_EMERGENCY_POWEROFF_DELAY_MS: u32 = 0;
pub const CONFIG_NF_CONNTRACK_NETBIOS_NS_MODULE: u32 = 1;
pub const CONFIG_ARCH_TEGRA_194_SOC: u32 = 1;
pub const CONFIG_NF_NAT_OVS: u32 = 1;
pub const CONFIG_TYPEC_RT1719_MODULE: u32 = 1;
pub const CONFIG_DVB_STV0900_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_834220: u32 = 1;
pub const CONFIG_SUN8I_R_CCU: u32 = 1;
pub const CONFIG_USB_CDNS_HOST: u32 = 1;
pub const CONFIG_RMI4_F34: u32 = 1;
pub const CONFIG_RUST_PHYLIB_ABSTRACTIONS: u32 = 1;
pub const CONFIG_CHELSIO_LIB_MODULE: u32 = 1;
pub const CONFIG_FS_STACK: u32 = 1;
pub const CONFIG_LEDS_BRIGHTNESS_HW_CHANGED: u32 = 1;
pub const CONFIG_SENSORS_LTC2947_MODULE: u32 = 1;
pub const CONFIG_MT76x2E_MODULE: u32 = 1;
pub const CONFIG_SOFTLOCKUP_DETECTOR_INTR_STORM: u32 = 1;
pub const CONFIG_AD7091R_MODULE: u32 = 1;
pub const CONFIG_VIDEO_MAX96717_MODULE: u32 = 1;
pub const CONFIG_ARCH_SELECTS_KEXEC_FILE: u32 = 1;
pub const CONFIG_GENERIC_CPU_DEVICES: u32 = 1;
pub const CONFIG_LEDS_PCA963X_MODULE: u32 = 1;
pub const CONFIG_CONNECTOR: u32 = 1;
pub const CONFIG_ARM_SBSA_WATCHDOG_MODULE: u32 = 1;
pub const CONFIG_SENSORS_TC654_MODULE: u32 = 1;
pub const CONFIG_MEAN_AND_VARIANCE_UNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_VIRTIO_PCI_LIB: u32 = 1;
pub const CONFIG_QCOM_AOSS_QMP_MODULE: u32 = 1;
pub const CONFIG_ARCH_WANT_FRAME_POINTERS: u32 = 1;
pub const CONFIG_DRM_VGEM_MODULE: u32 = 1;
pub const CONFIG_HSR_MODULE: u32 = 1;
pub const CONFIG_SOC_TEGRA_POWERGATE_BPMP: u32 = 1;
pub const CONFIG_TCP_MD5SIG: u32 = 1;
pub const CONFIG_MARVELL_CN10K_DDR_PMU_MODULE: u32 = 1;
pub const CONFIG_SSB_BLOCKIO: u32 = 1;
pub const CONFIG_REGULATOR_MP5416_MODULE: u32 = 1;
pub const CONFIG_DM_UEVENT: u32 = 1;
pub const CONFIG_UBIFS_FS_ZSTD: u32 = 1;
pub const CONFIG_MEMORY_HOTREMOVE: u32 = 1;
pub const CONFIG_IMX_DSP_REMOTEPROC_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_LIB_CHACHA: u32 = 1;
pub const CONFIG_PAC1934_MODULE: u32 = 1;
pub const CONFIG_BRIDGE_EBT_LOG_MODULE: u32 = 1;
pub const CONFIG_SFP_MODULE: u32 = 1;
pub const CONFIG_CPU_IDLE: u32 = 1;
pub const CONFIG_CGROUP_FREEZER: u32 = 1;
pub const CONFIG_MTD_CFI_MODULE: u32 = 1;
pub const CONFIG_EROFS_FS_ZIP_ZSTD: u32 = 1;
pub const CONFIG_ARM64_TLB_RANGE: u32 = 1;
pub const CONFIG_PINCTRL_MSM8916_MODULE: u32 = 1;
pub const CONFIG_RT2X00_MODULE: u32 = 1;
pub const CONFIG_PREEMPT_COUNT: u32 = 1;
pub const CONFIG_SND_SOC_X1E80100_MODULE: u32 = 1;
pub const CONFIG_GENERIC_IRQ_IPI_MUX: u32 = 1;
pub const CONFIG_KXSD9_I2C_MODULE: u32 = 1;
pub const CONFIG_I2C_BCM2835_MODULE: u32 = 1;
pub const CONFIG_MMC_MESON_GX_MODULE: u32 = 1;
pub const CONFIG_CAN_MODULE: u32 = 1;
pub const CONFIG_TI_ADS1100_MODULE: u32 = 1;
pub const CONFIG_GVE_MODULE: u32 = 1;
pub const CONFIG_IIO_CONFIGFS_MODULE: u32 = 1;
pub const CONFIG_IP6_NF_IPTABLES_LEGACY_MODULE: u32 = 1;
pub const CONFIG_HISI_DMA_MODULE: u32 = 1;
pub const CONFIG_MLX5_CLS_ACT: u32 = 1;
pub const CONFIG_KUSER_HELPERS: u32 = 1;
pub const CONFIG_HID_BATTERY_STRENGTH: u32 = 1;
pub const CONFIG_DVB_NXT200X_MODULE: u32 = 1;
pub const CONFIG_NET_SCH_HHF_MODULE: u32 = 1;
pub const CONFIG_LEDS_CLASS_MULTICOLOR_MODULE: u32 = 1;
pub const CONFIG_DW_EDMA_PCIE_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_SOF_XTENSA_MODULE: u32 = 1;
pub const CONFIG_HID_SENSOR_TEMP_MODULE: u32 = 1;
pub const CONFIG_IOMMU_DEFAULT_DMA_LAZY: u32 = 1;
pub const CONFIG_HID_SENSOR_HUB_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_MESON_AXG_PMX: u32 = 1;
pub const CONFIG_PM_CLK: u32 = 1;
pub const CONFIG_NET_XGRESS: u32 = 1;
pub const CONFIG_IMX_SC_THERMAL_MODULE: u32 = 1;
pub const CONFIG_SPI_FSL_LPSPI_MODULE: u32 = 1;
pub const CONFIG_SND_VX222_MODULE: u32 = 1;
pub const CONFIG_SATA_HOST: u32 = 1;
pub const CONFIG_SND_PCM_TIMER: u32 = 1;
pub const CONFIG_ROCKCHIP_DW_HDMI: u32 = 1;
pub const CONFIG_DRM_ANALOGIX_ANX6345_MODULE: u32 = 1;
pub const CONFIG_SCSI_PROC_FS: u32 = 1;
pub const CONFIG_LITEX_LITEETH_MODULE: u32 = 1;
pub const CONFIG_DVB_STB6000_MODULE: u32 = 1;
pub const CONFIG_QED_ISCSI: u32 = 1;
pub const CONFIG_CRYPTO_HW: u32 = 1;
pub const CONFIG_PHY_QCOM_SGMII_ETH_MODULE: u32 = 1;
pub const CONFIG_LTC1660_MODULE: u32 = 1;
pub const CONFIG_TIPC_MODULE: u32 = 1;
pub const CONFIG_SYSC_R9A08G045: u32 = 1;
pub const CONFIG_ARM_GIC_V3: u32 = 1;
pub const CONFIG_NFT_SOCKET_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_NETLINK_QUEUE_MODULE: u32 = 1;
pub const CONFIG_CFG80211_REQUIRE_SIGNED_REGDB: u32 = 1;
pub const CONFIG_MPU3050_MODULE: u32 = 1;
pub const CONFIG_KALLSYMS_ALL: u32 = 1;
pub const CONFIG_USB_F_MASS_STORAGE_MODULE: u32 = 1;
pub const CONFIG_COREDUMP: u32 = 1;
pub const CONFIG_CLK_RK3588: u32 = 1;
pub const CONFIG_RELOCATABLE: u32 = 1;
pub const CONFIG_PM_GENERIC_DOMAINS_OF: u32 = 1;
pub const CONFIG_SERIAL_JSM_MODULE: u32 = 1;
pub const CONFIG_VIRTIO_MEM_MODULE: u32 = 1;
pub const CONFIG_SATA_ACARD_AHCI_MODULE: u32 = 1;
pub const CONFIG_HAVE_KVM_MSI: u32 = 1;
pub const CONFIG_CC_HAS_ZERO_CALL_USED_REGS: u32 = 1;
pub const CONFIG_BRIDGE_EBT_PKTTYPE_MODULE: u32 = 1;
pub const CONFIG_MESON_EE_PM_DOMAINS: u32 = 1;
pub const CONFIG_RC_DEVICES: u32 = 1;
pub const CONFIG_B43_BUSES_BCMA_AND_SSB: u32 = 1;
pub const CONFIG_USB_EHCI_HCD_ORION_MODULE: u32 = 1;
pub const CONFIG_JOYSTICK_GUILLEMOT_MODULE: u32 = 1;
pub const CONFIG_ARCH_KEEP_MEMBLOCK: u32 = 1;
pub const CONFIG_CRYPTO_HASH2: u32 = 1;
pub const CONFIG_SECCOMP: u32 = 1;
pub const CONFIG_SNET_VDPA_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CS35L56_I2C_MODULE: u32 = 1;
pub const CONFIG_NET_DSA_MV88E6XXX_PTP: u32 = 1;
pub const CONFIG_DAMON: u32 = 1;
pub const CONFIG_TIFM_CORE_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_LIB_GF128MUL: u32 = 1;
pub const CONFIG_SPLIT_PMD_PTLOCKS: u32 = 1;
pub const CONFIG_HID_MICROSOFT_MODULE: u32 = 1;
pub const CONFIG_SGETMASK_SYSCALL: u32 = 1;
pub const CONFIG_USB_MUSB_DUAL_ROLE: u32 = 1;
pub const CONFIG_SND_SOC_APPLE_MCA_MODULE: u32 = 1;
pub const CONFIG_TI_ICSSG_PRUETH_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_PCM3060_MODULE: u32 = 1;
pub const CONFIG_NVMEM_LAYOUT_ONIE_TLV_MODULE: u32 = 1;
pub const CONFIG_IP6_NF_IPTABLES_MODULE: u32 = 1;
pub const CONFIG_MLXBF_TMFIFO_MODULE: u32 = 1;
pub const CONFIG_SHMEM: u32 = 1;
pub const CONFIG_A11Y_BRAILLE_CONSOLE: u32 = 1;
pub const CONFIG_IWLWIFI_OPMODE_MODULAR: u32 = 1;
pub const CONFIG_VIDEO_TC358746_MODULE: u32 = 1;
pub const CONFIG_FPGA_MGR_MACHXO2_SPI_MODULE: u32 = 1;
pub const CONFIG_NVGRACE_GPU_VFIO_PCI_MODULE: u32 = 1;
pub const CONFIG_IIO_BUFFER_DMAENGINE_MODULE: u32 = 1;
pub const CONFIG_NFT_CT_MODULE: u32 = 1;
pub const CONFIG_SUNXI_MBUS: u32 = 1;
pub const CONFIG_RTL8723BS_MODULE: u32 = 1;
pub const CONFIG_SOC_IMX8M: u32 = 1;
pub const CONFIG_IO_URING_ZCRX: u32 = 1;
pub const CONFIG_NET_ACT_IFE_MODULE: u32 = 1;
pub const CONFIG_BCACHEFS_POSIX_ACL: u32 = 1;
pub const CONFIG_VSOCKMON_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_NMI_SAFE_THIS_CPU_OPS: u32 = 1;
pub const CONFIG_DVB_DIB3000MC_MODULE: u32 = 1;
pub const CONFIG_I2C_BOARDINFO: u32 = 1;
pub const CONFIG_SND_SOC_FSL_MICFIL_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV7740_MODULE: u32 = 1;
pub const CONFIG_SERIO_ALTERA_PS2_MODULE: u32 = 1;
pub const CONFIG_ATL2_MODULE: u32 = 1;
pub const CONFIG_GPIO_BD9571MWV_MODULE: u32 = 1;
pub const CONFIG_UIO_MODULE: u32 = 1;
pub const CONFIG_KEXEC_SIG: u32 = 1;
pub const CONFIG_SSB_PCIHOST: u32 = 1;
pub const CONFIG_NET_VENDOR_ALTEON: u32 = 1;
pub const CONFIG_ATA_VERBOSE_ERROR: u32 = 1;
pub const CONFIG_ARCH_RZG2L: u32 = 1;
pub const CONFIG_SND_HDA_CODEC_CONEXANT_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_R9701_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_WIDECHIPS_WS2401_MODULE: u32 = 1;
pub const CONFIG_PLDMFW: u32 = 1;
pub const CONFIG_VIDEO_MAX9271_LIB_MODULE: u32 = 1;
pub const CONFIG_SENSORS_TPS40422_MODULE: u32 = 1;
pub const CONFIG_THERMAL_NETLINK: u32 = 1;
pub const CONFIG_BATTERY_LENOVO_YOGA_C630_MODULE: u32 = 1;
pub const CONFIG_VIRTIO_ANCHOR: u32 = 1;
pub const CONFIG_SKGE_MODULE: u32 = 1;
pub const CONFIG_RMI4_SPI_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_ES8328_I2C_MODULE: u32 = 1;
pub const CONFIG_MT76_SDIO_MODULE: u32 = 1;
pub const CONFIG_CHELSIO_T3_MODULE: u32 = 1;
pub const CONFIG_SND_TIMER_MODULE: u32 = 1;
pub const CONFIG_NETLINK_DIAG: u32 = 1;
pub const CONFIG_NLS_MAC_ICELAND_MODULE: u32 = 1;
pub const CONFIG_SMS_SIANO_RC: u32 = 1;
pub const CONFIG_HAVE_POSIX_CPU_TIMERS_TASK_WORK: u32 = 1;
pub const CONFIG_ARM_PMU_ACPI: u32 = 1;
pub const CONFIG_SC_CAMCC_7180_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_SC8280XP_MODULE: u32 = 1;
pub const CONFIG_RPCSEC_GSS_KRB5_ENCTYPES_AES_SHA2: u32 = 1;
pub const CONFIG_NLS_CODEPAGE_949_MODULE: u32 = 1;
pub const CONFIG_SENSORS_W83L785TS_MODULE: u32 = 1;
pub const CONFIG_SENSORS_XDPE152_MODULE: u32 = 1;
pub const CONFIG_VIRTIO_BLK: u32 = 1;
pub const CONFIG_KUNIT_MODULE: u32 = 1;
pub const CONFIG_RTLWIFI_PCI_MODULE: u32 = 1;
pub const CONFIG_BRIDGE_MODULE: u32 = 1;
pub const CONFIG_IRQ_FORCED_THREADING: u32 = 1;
pub const CONFIG_HARDLOCKUP_DETECTOR: u32 = 1;
pub const CONFIG_VIDEO_GO7007_LOADER_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_MANAGER2: u32 = 1;
pub const CONFIG_ASYNC_TX_DISABLE_PQ_VAL_DMA: u32 = 1;
pub const CONFIG_NET_VENDOR_MICROCHIP: u32 = 1;
pub const CONFIG_MESSAGE_LOGLEVEL_DEFAULT: u32 = 4;
pub const CONFIG_SND_MESON_AIU_MODULE: u32 = 1;
pub const CONFIG_KEYBOARD_CROS_EC_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_DS1343_MODULE: u32 = 1;
pub const CONFIG_SCSI_CXGB4_ISCSI_MODULE: u32 = 1;
pub const CONFIG_IP_NF_FILTER_MODULE: u32 = 1;
pub const CONFIG_MAX77620_WATCHDOG_MODULE: u32 = 1;
pub const CONFIG_SQUASHFS_MODULE: u32 = 1;
pub const CONFIG_WLAN_VENDOR_ATH: u32 = 1;
pub const CONFIG_DRM_TI_DLPC3433_MODULE: u32 = 1;
pub const CONFIG_SND_DUMMY_MODULE: u32 = 1;
pub const CONFIG_SPI_AMD: u32 = 1;
pub const CONFIG_PWM_TEGRA: u32 = 1;
pub const CONFIG_USB_RZV2M_USB3DRD_MODULE: u32 = 1;
pub const CONFIG_MLXREG_LC_MODULE: u32 = 1;
pub const CONFIG_DVB_S921_MODULE: u32 = 1;
pub const CONFIG_SENSORS_LM95245_MODULE: u32 = 1;
pub const CONFIG_FPGA_DFL_FME_MODULE: u32 = 1;
pub const CONFIG_NLS_CODEPAGE_932_MODULE: u32 = 1;
pub const CONFIG_WLAN_VENDOR_MARVELL: u32 = 1;
pub const CONFIG_NET_SCH_MQPRIO_LIB_MODULE: u32 = 1;
pub const CONFIG_DRM_MSM_DP: u32 = 1;
pub const CONFIG_AD4695_MODULE: u32 = 1;
pub const CONFIG_SOCK_RX_QUEUE_MAPPING: u32 = 1;
pub const CONFIG_AUXILIARY_BUS: u32 = 1;
pub const CONFIG_SERIAL_XILINX_PS_UART_CONSOLE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_SUN8I_CE_TRNG: u32 = 1;
pub const CONFIG_ARCH_HIBERNATION_HEADER: u32 = 1;
pub const CONFIG_DECOMPRESS_LZ4: u32 = 1;
pub const CONFIG_VFIO_CONTAINER: u32 = 1;
pub const CONFIG_PINCTRL_SA8775P_MODULE: u32 = 1;
pub const CONFIG_VIDEO_TDA1997X_MODULE: u32 = 1;
pub const CONFIG_SENSORS_VT1211_MODULE: u32 = 1;
pub const CONFIG_DTPM_CPU: u32 = 1;
pub const CONFIG_PINCTRL_SM8250_LPASS_LPI_MODULE: u32 = 1;
pub const CONFIG_DVB_CX24117_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_ETOMS_MODULE: u32 = 1;
pub const CONFIG_ARCH_WANT_DEFAULT_BPF_JIT: u32 = 1;
pub const CONFIG_GPIO_SIM_MODULE: u32 = 1;
pub const CONFIG_NLS_ISO8859_1_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CHV3_CODEC_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_KCOV: u32 = 1;
pub const CONFIG_HID_TOPSEED_MODULE: u32 = 1;
pub const CONFIG_NET_EMATCH_META_MODULE: u32 = 1;
pub const CONFIG_DYNAMIC_FTRACE_WITH_DIRECT_CALLS: u32 = 1;
pub const CONFIG_MPLS_IPTUNNEL_MODULE: u32 = 1;
pub const CONFIG_PM_SLEEP_DEBUG: u32 = 1;
pub const CONFIG_BT_HCIUART_RTL: u32 = 1;
pub const CONFIG_GENERIC_IRQ_INJECTION: u32 = 1;
pub const CONFIG_VIDEO_MAX96714_MODULE: u32 = 1;
pub const CONFIG_AFS_FSCACHE: u32 = 1;
pub const CONFIG_IMA_LSM_RULES: u32 = 1;
pub const CONFIG_USB_TRANCEVIBRATOR_MODULE: u32 = 1;
pub const CONFIG_ARCH_S32: u32 = 1;
pub const CONFIG_NET_VENDOR_CAVIUM: u32 = 1;
pub const CONFIG_WLAN_VENDOR_ZYDAS: u32 = 1;
pub const CONFIG_AD3552R_LIB_MODULE: u32 = 1;
pub const CONFIG_SENSORS_SHT21_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_MR97310A_MODULE: u32 = 1;
pub const CONFIG_PCNET32_MODULE: u32 = 1;
pub const CONFIG_DTC: u32 = 1;
pub const CONFIG_PATA_TIMINGS: u32 = 1;
pub const CONFIG_NETFILTER_XT_MARK_MODULE: u32 = 1;
pub const CONFIG_COMPAT: u32 = 1;
pub const CONFIG_VIRT_CPU_ACCOUNTING: u32 = 1;
pub const CONFIG_UTIL_MACROS_KUNIT_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_DIGI_ACCELEPORT_MODULE: u32 = 1;
pub const CONFIG_ARCH_ENABLE_HUGEPAGE_MIGRATION: u32 = 1;
pub const CONFIG_COMMON_CLK_GXBB: u32 = 1;
pub const CONFIG_PSTORE: u32 = 1;
pub const CONFIG_CLK_X1E80100_GCC: u32 = 1;
pub const CONFIG_IIO_ST_LSM6DSX_SPI_MODULE: u32 = 1;
pub const CONFIG_NET_CLS_ROUTE4_MODULE: u32 = 1;
pub const CONFIG_ARM_IMX8M_DDRC_DEVFREQ_MODULE: u32 = 1;
pub const CONFIG_TMPFS_INODE64: u32 = 1;
pub const CONFIG_TI_TSC2046_MODULE: u32 = 1;
pub const CONFIG_SCSI_UFS_CRYPTO: u32 = 1;
pub const CONFIG_IIO_TRIGGERED_EVENT_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_AF9035_MODULE: u32 = 1;
pub const CONFIG_RESET_SIMPLE: u32 = 1;
pub const CONFIG_SND_BCD2000_MODULE: u32 = 1;
pub const CONFIG_BT_HCIBTUSB_AUTO_ISOC_ALT: u32 = 1;
pub const CONFIG_NET_SCH_CHOKE_MODULE: u32 = 1;
pub const CONFIG_VIDEO_DW100_MODULE: u32 = 1;
pub const CONFIG_NIC7018_WDT_MODULE: u32 = 1;
pub const CONFIG_CORESIGHT_LINKS_AND_SINKS_MODULE: u32 = 1;
pub const CONFIG_INTEL_XWAY_PHY_MODULE: u32 = 1;
pub const CONFIG_RMI4_F55: u32 = 1;
pub const CONFIG_EXCLUSIVE_SYSTEM_RAM: u32 = 1;
pub const CONFIG_FW_LOADER_COMPRESS: u32 = 1;
pub const CONFIG_CRYPTO_LIB_POLY1305_RSIZE: u32 = 9;
pub const CONFIG_INIT_ENV_ARG_LIMIT: u32 = 32;
pub const CONFIG_CACHEFILES_MODULE: u32 = 1;
pub const CONFIG_PCI_HOST_GENERIC: u32 = 1;
pub const CONFIG_QEDF_MODULE: u32 = 1;
pub const CONFIG_SUN8I_H3_CCU: u32 = 1;
pub const CONFIG_STANDALONE: u32 = 1;
pub const CONFIG_USB_SERIAL_CONSOLE: u32 = 1;
pub const CONFIG_USB_CONFIGFS_EEM: u32 = 1;
pub const CONFIG_TEHUTI_TN40_MODULE: u32 = 1;
pub const CONFIG_XFRM_MIGRATE: u32 = 1;
pub const CONFIG_SND_DYNAMIC_MINORS: u32 = 1;
pub const CONFIG_IP_PIMSM_V1: u32 = 1;
pub const CONFIG_CRYPTO_DEV_QAT_C62X_MODULE: u32 = 1;
pub const CONFIG_CC_HAS_AUTO_VAR_INIT_ZERO: u32 = 1;
pub const CONFIG_SCSI_VIRTIO_MODULE: u32 = 1;
pub const CONFIG_FPGA_DFL_NIOS_INTEL_PAC_N3000_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_LPASS_TX_MACRO_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAVE_TRACE_MMIO_ACCESS: u32 = 1;
pub const CONFIG_DM_FLAKEY_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_MAX77686_MODULE: u32 = 1;
pub const CONFIG_ZD1211RW_MODULE: u32 = 1;
pub const CONFIG_SECURITY_INFINIBAND: u32 = 1;
pub const CONFIG_VIDEO_GO7007_USB_S2250_BOARD_MODULE: u32 = 1;
pub const CONFIG_FUN_CORE_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_XIRLINK_CIT_MODULE: u32 = 1;
pub const CONFIG_DVB_DRXK_MODULE: u32 = 1;
pub const CONFIG_JFFS2_FS_POSIX_ACL: u32 = 1;
pub const CONFIG_I2C_PCA_PLATFORM_MODULE: u32 = 1;
pub const CONFIG_TI_AM65_CPSW_QOS: u32 = 1;
pub const CONFIG_CAVIUM_ERRATUM_22375: u32 = 1;
pub const CONFIG_EXT_GROUP_SCHED: u32 = 1;
pub const CONFIG_EROFS_FS_SECURITY: u32 = 1;
pub const CONFIG_I2C_HID: u32 = 1;
pub const CONFIG_PREEMPT_BUILD: u32 = 1;
pub const CONFIG_BT_HCIUART_MRVL: u32 = 1;
pub const CONFIG_DRM_I2C_ADV7511_MODULE: u32 = 1;
pub const CONFIG_TPS6594_ESM_MODULE: u32 = 1;
pub const CONFIG_LOGIWHEELS_FF: u32 = 1;
pub const CONFIG_DRM_AMDGPU_MODULE: u32 = 1;
pub const CONFIG_DRM_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_SND_EMU10K1X_MODULE: u32 = 1;
pub const CONFIG_AF_RXRPC_MODULE: u32 = 1;
pub const CONFIG_842_COMPRESS: u32 = 1;
pub const CONFIG_TI_EQEP_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_PCM186X_MODULE: u32 = 1;
pub const CONFIG_SERIAL_ARC_NR_PORTS: u32 = 1;
pub const CONFIG_DVB_USB_ANYSEE_MODULE: u32 = 1;
pub const CONFIG_DEFAULT_TCP_CONG: &[u8; 6] = b"cubic\0";
pub const CONFIG_VL53L0X_I2C_MODULE: u32 = 1;
pub const CONFIG_DRM_XE_PREEMPT_TIMEOUT_MIN: u32 = 1;
pub const CONFIG_I2C_TINY_USB_MODULE: u32 = 1;
pub const CONFIG_IR_TTUSBIR_MODULE: u32 = 1;
pub const CONFIG_SUNXI_WATCHDOG_MODULE: u32 = 1;
pub const CONFIG_MPTCP_IPV6: u32 = 1;
pub const CONFIG_SPI_MESON_SPICC_MODULE: u32 = 1;
pub const CONFIG_BATTERY_SAMSUNG_SDI: u32 = 1;
pub const CONFIG_DEVFREQ_EVENT_ROCKCHIP_DFI_MODULE: u32 = 1;
pub const CONFIG_MSHV_ROOT_MODULE: u32 = 1;
pub const CONFIG_NVMEM_APPLE_EFUSES_MODULE: u32 = 1;
pub const CONFIG_DWMAC_ROCKCHIP_MODULE: u32 = 1;
pub const CONFIG_MTD_CFI_UTIL_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_NETLINK_ACCT_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_QDSP6_APM_LPASS_DAI_MODULE: u32 = 1;
pub const CONFIG_HAVE_KERNEL_ZSTD: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_LTO_CLANG: u32 = 1;
pub const CONFIG_PHY_CAN_TRANSCEIVER_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_RT715_SDW_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_AC97_BUS: u32 = 1;
pub const CONFIG_SMC91X_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_L2TP_MODULE: u32 = 1;
pub const CONFIG_MIPI_I3C_HCI_MODULE: u32 = 1;
pub const CONFIG_VIDEO_PVRUSB2_SYSFS: u32 = 1;
pub const CONFIG_IP6_NF_SECURITY_MODULE: u32 = 1;
pub const CONFIG_USB_STORAGE_REALTEK_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_OKI: u32 = 1;
pub const CONFIG_ARM_CCN: u32 = 1;
pub const CONFIG_RTW88_8821CS_MODULE: u32 = 1;
pub const CONFIG_WIL6210_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_QDSP6_PRM_LPASS_CLOCKS_MODULE: u32 = 1;
pub const CONFIG_SECURITY_IPE: u32 = 1;
pub const CONFIG_CRYPTO_CRC32_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_APPLE_Z2_MODULE: u32 = 1;
pub const CONFIG_TPS6594_PFSM_MODULE: u32 = 1;
pub const CONFIG_SPI_MEM: u32 = 1;
pub const CONFIG_UCSI_ACPI_MODULE: u32 = 1;
pub const CONFIG_MMC_BLOCK_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_RX8025_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_SSM3515_MODULE: u32 = 1;
pub const CONFIG_GCC_NO_STRINGOP_OVERFLOW: u32 = 1;
pub const CONFIG_CONTIG_ALLOC: u32 = 1;
pub const CONFIG_SC_GCC_7280: u32 = 1;
pub const CONFIG_VIDEO_MT9V111_MODULE: u32 = 1;
pub const CONFIG_SMBFS_MODULE: u32 = 1;
pub const CONFIG_SYSTEM_EXTRA_CERTIFICATE_SIZE: u32 = 4096;
pub const CONFIG_DRM_PANFROST_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA20_SPDIF_MODULE: u32 = 1;
pub const CONFIG_USB_DWC3_PCI_MODULE: u32 = 1;
pub const CONFIG_AX25_DAMA_SLAVE: u32 = 1;
pub const CONFIG_CPU_FREQ_GOV_ATTR_SET: u32 = 1;
pub const CONFIG_SENSORS_CRPS_MODULE: u32 = 1;
pub const CONFIG_RWSEM_SPIN_ON_OWNER: u32 = 1;
pub const CONFIG_ARCH_HAS_STRICT_MODULE_RWX: u32 = 1;
pub const CONFIG_DRM_PRIVACY_SCREEN: u32 = 1;
pub const CONFIG_SPI_PL022_MODULE: u32 = 1;
pub const CONFIG_DVB_DIB3000MB_MODULE: u32 = 1;
pub const CONFIG_DVB_TS2020_MODULE: u32 = 1;
pub const CONFIG_DRM_DISPLAY_DP_AUX_BUS_MODULE: u32 = 1;
pub const CONFIG_LRU_GEN: u32 = 1;
pub const CONFIG_SERIAL_TEGRA_TCU: u32 = 1;
pub const CONFIG_DPAA2_CONSOLE_MODULE: u32 = 1;
pub const CONFIG_WLAN_VENDOR_INTEL: u32 = 1;
pub const CONFIG_VIDEO_CX88_MPEG_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_ESSIV_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_SPCP8X5_MODULE: u32 = 1;
pub const CONFIG_FPGA_MGR_XILINX_SELECTMAP_MODULE: u32 = 1;
pub const CONFIG_ATH5K_DEBUG: u32 = 1;
pub const CONFIG_COMMON_CLK_HI3519_MODULE: u32 = 1;
pub const CONFIG_BATTERY_GAUGE_LTC2941_MODULE: u32 = 1;
pub const CONFIG_GPIO_GENERIC_PLATFORM: u32 = 1;
pub const CONFIG_ARCH_HAS_KERNEL_FPU_SUPPORT: u32 = 1;
pub const CONFIG_KEYBOARD_QT1070_MODULE: u32 = 1;
pub const CONFIG_VIDEO_IMX8_ISI_MODULE: u32 = 1;
pub const CONFIG_SC_CAMCC_8280XP_MODULE: u32 = 1;
pub const CONFIG_RPMSG_TTY_MODULE: u32 = 1;
pub const CONFIG_OPEN_ALLIANCE_HELPERS: u32 = 1;
pub const CONFIG_HID_CMEDIA_MODULE: u32 = 1;
pub const CONFIG_DVB_LNBP21_MODULE: u32 = 1;
pub const CONFIG_RPCSEC_GSS_KRB5_ENCTYPES_AES_SHA1: u32 = 1;
pub const CONFIG_HOTPLUG_CORE_SYNC: u32 = 1;
pub const CONFIG_PHY_QCOM_QMP_PCIE_MODULE: u32 = 1;
pub const CONFIG_HID_ICADE_MODULE: u32 = 1;
pub const CONFIG_DVB_AU8522_DTV_MODULE: u32 = 1;
pub const CONFIG_SCSI_UFS_HWMON: u32 = 1;
pub const CONFIG_MELLANOX_PLATFORM: u32 = 1;
pub const CONFIG_RTC_DRV_TPS6594_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_ATHEROS: u32 = 1;
pub const CONFIG_DVB_SP887X_MODULE: u32 = 1;
pub const CONFIG_LEDS_TRIGGER_CAMERA_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_RTMV20_MODULE: u32 = 1;
pub const CONFIG_DVB_TDA10021_MODULE: u32 = 1;
pub const CONFIG_VIRTIO_MMIO_MODULE: u32 = 1;
pub const CONFIG_ELFCORE: u32 = 1;
pub const CONFIG_TI_PRUSS_MODULE: u32 = 1;
pub const CONFIG_CARL9170_WPC: u32 = 1;
pub const CONFIG_BLK_PM: u32 = 1;
pub const CONFIG_SPI_ALTERA_DFL_MODULE: u32 = 1;
pub const CONFIG_HDC2010_MODULE: u32 = 1;
pub const CONFIG_SND_VMASTER: u32 = 1;
pub const CONFIG_SERIAL_8250_RSA: u32 = 1;
pub const CONFIG_I2C_TEGRA_MODULE: u32 = 1;
pub const CONFIG_MFD_AC100_MODULE: u32 = 1;
pub const CONFIG_MLX5_CORE_EN: u32 = 1;
pub const CONFIG_CIFS_DEBUG: u32 = 1;
pub const CONFIG_ZYNQMP_IPI_MBOX: u32 = 1;
pub const CONFIG_ARM_SMMU_MMU_500_CPRE_ERRATA: u32 = 1;
pub const CONFIG_USBIP_VHCI_HCD_MODULE: u32 = 1;
pub const CONFIG_DVB_CX24116_MODULE: u32 = 1;
pub const CONFIG_BRIDGE_EBT_DNAT_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_SILAN: u32 = 1;
pub const CONFIG_MEDIA_TUNER_MXL5005S_MODULE: u32 = 1;
pub const CONFIG_NET_DSA_MV88E6XXX_LEDS: u32 = 1;
pub const CONFIG_OF_PMEM: u32 = 1;
pub const CONFIG_HID_MULTITOUCH_MODULE: u32 = 1;
pub const CONFIG_SND_HDA_CODEC_SI3054_MODULE: u32 = 1;
pub const CONFIG_REGMAP_KUNIT_MODULE: u32 = 1;
pub const CONFIG_SENSORS_UCD9000_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_PCM3168A_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_QDSP6_ADM_MODULE: u32 = 1;
pub const CONFIG_MFD_SPMI_PMIC_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_ZINITIX_MODULE: u32 = 1;
pub const CONFIG_GNSS_MODULE: u32 = 1;
pub const CONFIG_IMA_APPRAISE_MODSIG: u32 = 1;
pub const CONFIG_SND_VERBOSE_PROCFS: u32 = 1;
pub const CONFIG_NET_SCH_INGRESS_MODULE: u32 = 1;
pub const CONFIG_BRIDGE_EBT_AMONG_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_TDA827X_MODULE: u32 = 1;
pub const CONFIG_LEDS_KTD202X_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA20_AC97_MODULE: u32 = 1;
pub const CONFIG_GENERIC_CPU_AUTOPROBE: u32 = 1;
pub const CONFIG_WLAN_VENDOR_ST: u32 = 1;
pub const CONFIG_SOLARIS_X86_PARTITION: u32 = 1;
pub const CONFIG_VMGENID: u32 = 1;
pub const CONFIG_ADIN_PHY_MODULE: u32 = 1;
pub const CONFIG_JFFS2_ZLIB: u32 = 1;
pub const CONFIG_NFC_MICROREAD_MODULE: u32 = 1;
pub const CONFIG_INPUT_MOUSEDEV: u32 = 1;
pub const CONFIG_NET_SCH_CAKE_MODULE: u32 = 1;
pub const CONFIG_NETDEVICES: u32 = 1;
pub const CONFIG_FW_CS_DSP_MODULE: u32 = 1;
pub const CONFIG_USB_CDNS3_IMX_MODULE: u32 = 1;
pub const CONFIG_DRM_CLIENT_DEFAULT: &[u8; 6] = b"fbdev\0";
pub const CONFIG_LAN743X_MODULE: u32 = 1;
pub const CONFIG_IIO_BUFFER_DMA_MODULE: u32 = 1;
pub const CONFIG_ARCH_MVEBU: u32 = 1;
pub const CONFIG_NLS_CODEPAGE_874_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_QCOM_REFGEN_MODULE: u32 = 1;
pub const CONFIG_VIDEO_TEA6415C_MODULE: u32 = 1;
pub const CONFIG_RTL8180_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_BENQ_MODULE: u32 = 1;
pub const CONFIG_BMP280_MODULE: u32 = 1;
pub const CONFIG_BLK_RQ_ALLOC_TIME: u32 = 1;
pub const CONFIG_VIDEO_ADV7393_MODULE: u32 = 1;
pub const CONFIG_INET_XFRM_TUNNEL_MODULE: u32 = 1;
pub const CONFIG_INPUT_MISC: u32 = 1;
pub const CONFIG_UBIFS_FS_ZLIB: u32 = 1;
pub const CONFIG_NF_NAT_H323_MODULE: u32 = 1;
pub const CONFIG_IP_PIMSM_V2: u32 = 1;
pub const CONFIG_INPUT_BBNSM_PWRKEY_MODULE: u32 = 1;
pub const CONFIG_KGDB_HONOUR_BLOCKLIST: u32 = 1;
pub const CONFIG_FSL_DPAA2_QDMA_MODULE: u32 = 1;
pub const CONFIG_ETHTOOL_NETLINK: u32 = 1;
pub const CONFIG_NVME_TARGET_LOOP_MODULE: u32 = 1;
pub const CONFIG_VIRTIO_PCI_LIB_LEGACY: u32 = 1;
pub const CONFIG_SND_HDA_CS_DSP_CONTROLS_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK: u32 = 1;
pub const CONFIG_QCOM_PIL_INFO_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TLV320ADC3XXX_MODULE: u32 = 1;
pub const CONFIG_HAVE_ARM_SMCCC: u32 = 1;
pub const CONFIG_USBPCWATCHDOG_MODULE: u32 = 1;
pub const CONFIG_SC_LPASSCC_7280_MODULE: u32 = 1;
pub const CONFIG_DEBUG_INFO: u32 = 1;
pub const CONFIG_SERIAL_MSM_CONSOLE: u32 = 1;
pub const CONFIG_KXSD9_MODULE: u32 = 1;
pub const CONFIG_SND_RME96_MODULE: u32 = 1;
pub const CONFIG_AHCI_CEVA_MODULE: u32 = 1;
pub const CONFIG_VIDEO_CX2341X_MODULE: u32 = 1;
pub const CONFIG_ACPI_APEI_EINJ_MODULE: u32 = 1;
pub const CONFIG_RMI4_F3A: u32 = 1;
pub const CONFIG_RT2X00_LIB_LEDS: u32 = 1;
pub const CONFIG_LEDS_SYSCON: u32 = 1;
pub const CONFIG_VIDEO_ROCKCHIP_RGA_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_DS1374_WDT: u32 = 1;
pub const CONFIG_VIDEO_CADENCE_CSI2TX_MODULE: u32 = 1;
pub const CONFIG_MAX31865_MODULE: u32 = 1;
pub const CONFIG_HID_PICOLCD_FB: u32 = 1;
pub const CONFIG_SCSI_SCAN_ASYNC: u32 = 1;
pub const CONFIG_CRYPTO_BLOWFISH_MODULE: u32 = 1;
pub const CONFIG_BCM54140_PHY_MODULE: u32 = 1;
pub const CONFIG_RTW89_PCI_MODULE: u32 = 1;
pub const CONFIG_USB_PULSE8_CEC_MODULE: u32 = 1;
pub const CONFIG_PHYLINK_MODULE: u32 = 1;
pub const CONFIG_EFI_SOFT_RESERVE: u32 = 1;
pub const CONFIG_SENSORS_MPQ7932_REGULATOR: u32 = 1;
pub const CONFIG_SENSORS_ISL29028_MODULE: u32 = 1;
pub const CONFIG_SATA_PMP: u32 = 1;
pub const CONFIG_PCIE_ECRC: u32 = 1;
pub const CONFIG_DMA_SHARED_BUFFER: u32 = 1;
pub const CONFIG_MODULES: u32 = 1;
pub const CONFIG_SCHED_HW_PRESSURE: u32 = 1;
pub const CONFIG_SND_SOC_IMX_HDMI_MODULE: u32 = 1;
pub const CONFIG_MLX5_VDPA: u32 = 1;
pub const CONFIG_RT2800PCI_RT35XX: u32 = 1;
pub const CONFIG_IPV6_SEG6_HMAC: u32 = 1;
pub const CONFIG_SND_SEQ_VIRMIDI_MODULE: u32 = 1;
pub const CONFIG_QCOM_SPMI_VADC_MODULE: u32 = 1;
pub const CONFIG_SND_SIMPLE_CARD_UTILS_MODULE: u32 = 1;
pub const CONFIG_NF_NAT_MODULE: u32 = 1;
pub const CONFIG_CACHESTAT_SYSCALL: u32 = 1;
pub const CONFIG_CMA_SIZE_MBYTES: u32 = 64;
pub const CONFIG_DRM_IMX_DCSS_MODULE: u32 = 1;
pub const CONFIG_SYS_R9A09G057: u32 = 1;
pub const CONFIG_CROS_EC_SPI_MODULE: u32 = 1;
pub const CONFIG_SND_HDA_INPUT_BEEP: u32 = 1;
pub const CONFIG_CRYPTO_DEV_ZYNQMP_AES_MODULE: u32 = 1;
pub const CONFIG_CAN_MCP251XFD_MODULE: u32 = 1;
pub const CONFIG_USB_CONFIGFS_ACM: u32 = 1;
pub const CONFIG_SND_SOC_SOF_OF_DEV_MODULE: u32 = 1;
pub const CONFIG_I2C_BRCMSTB_MODULE: u32 = 1;
pub const CONFIG_IIO_ST_ACCEL_SPI_3AXIS_MODULE: u32 = 1;
pub const CONFIG_NFS_DISABLE_UDP_SUPPORT: u32 = 1;
pub const CONFIG_MAX_SKB_FRAGS: u32 = 17;
pub const CONFIG_USERFAULTFD: u32 = 1;
pub const CONFIG_RTC_DRV_RK808_MODULE: u32 = 1;
pub const CONFIG_RPMSG_QCOM_GLINK_SMEM_MODULE: u32 = 1;
pub const CONFIG_SENSORS_PC87427_MODULE: u32 = 1;
pub const CONFIG_BOOT_PRINTK_DELAY: u32 = 1;
pub const CONFIG_CRYPTO_ACOMP2: u32 = 1;
pub const CONFIG_SND_CA0106_MODULE: u32 = 1;
pub const CONFIG_VIDEO_AU0828_V4L2: u32 = 1;
pub const CONFIG_DM_WRITECACHE_MODULE: u32 = 1;
pub const CONFIG_HOTPLUG_PCI_ACPI_IBM_MODULE: u32 = 1;
pub const CONFIG_VIDEO_APTINA_PLL_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_ADAU7002_MODULE: u32 = 1;
pub const CONFIG_SENSORS_W83773G_MODULE: u32 = 1;
pub const CONFIG_VIDEO_CODA_MODULE: u32 = 1;
pub const CONFIG_V4L2_CCI_I2C_MODULE: u32 = 1;
pub const CONFIG_NF_NAT_TFTP_MODULE: u32 = 1;
pub const CONFIG_RTW88_8723D_MODULE: u32 = 1;
pub const CONFIG_MFD_CS42L43_SDW_MODULE: u32 = 1;
pub const CONFIG_PPS_CLIENT_GPIO_MODULE: u32 = 1;
pub const CONFIG_INET_TABLE_PERTURB_ORDER: u32 = 16;
pub const CONFIG_SND_ALS300_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_ROCKCHIP_SPDIF_MODULE: u32 = 1;
pub const CONFIG_LEDS_TRIGGER_MTD: u32 = 1;
pub const CONFIG_VIRTIO_INPUT_MODULE: u32 = 1;
pub const CONFIG_IIO_SW_TRIGGER_MODULE: u32 = 1;
pub const CONFIG_HID_LOGITECH_MODULE: u32 = 1;
pub const CONFIG_MESON_SM: u32 = 1;
pub const CONFIG_TI_ECAP_CAPTURE_MODULE: u32 = 1;
pub const CONFIG_SND_NM256_MODULE: u32 = 1;
pub const CONFIG_IXGBEVF_IPSEC: u32 = 1;
pub const CONFIG_NITRO_ENCLAVES_MODULE: u32 = 1;
pub const CONFIG_RT2X00_LIB_USB_MODULE: u32 = 1;
pub const CONFIG_CORTINA_PHY_MODULE: u32 = 1;
pub const CONFIG_IIO_BUFFER: u32 = 1;
pub const CONFIG_INET_ESPINTCP: u32 = 1;
pub const CONFIG_SND_SOC_AW88395_LIB_MODULE: u32 = 1;
pub const CONFIG_VIDEO_HANTRO_SUNXI: u32 = 1;
pub const CONFIG_ISCSI_BOOT_SYSFS_MODULE: u32 = 1;
pub const CONFIG_TCM_IBLOCK_MODULE: u32 = 1;
pub const CONFIG_TSL4531_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_FEIYANG_FY07024DI26A30D_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_FSL_CAAM_PRNG_API: u32 = 1;
pub const CONFIG_ATOMIC64_SELFTEST: u32 = 1;
pub const CONFIG_IIO_SYSFS_TRIGGER_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_2119858: u32 = 1;
pub const CONFIG_HID_SENSOR_MAGNETOMETER_3D_MODULE: u32 = 1;
pub const CONFIG_NFC_PN544_I2C_MODULE: u32 = 1;
pub const CONFIG_DMA_ENGINE_RAID: u32 = 1;
pub const CONFIG_SENSORS_NCT7904_MODULE: u32 = 1;
pub const CONFIG_NF_CONNTRACK_FTP_MODULE: u32 = 1;
pub const CONFIG_ARM_SMMU_QCOM: u32 = 1;
pub const CONFIG_REGULATOR_PCA9450_MODULE: u32 = 1;
pub const CONFIG_BCM2835_VCHIQ_MMAL_MODULE: u32 = 1;
pub const CONFIG_FWCTL_MLX5_MODULE: u32 = 1;
pub const CONFIG_MMU_GATHER_TABLE_FREE: u32 = 1;
pub const CONFIG_PERSISTENT_KEYRINGS: u32 = 1;
pub const CONFIG_ARC_EMAC_CORE_MODULE: u32 = 1;
pub const CONFIG_COMMON_RESET_HI6220_MODULE: u32 = 1;
pub const CONFIG_SLIM_QCOM_NGD_CTRL_MODULE: u32 = 1;
pub const CONFIG_DRM_ADP_MODULE: u32 = 1;
pub const CONFIG_CHELSIO_T1_MODULE: u32 = 1;
pub const CONFIG_PMS7003_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_TOPRO_MODULE: u32 = 1;
pub const CONFIG_SENSORS_PWM_FAN_MODULE: u32 = 1;
pub const CONFIG_ADXL355_SPI_MODULE: u32 = 1;
pub const CONFIG_BITREVERSE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_2067961: u32 = 1;
pub const CONFIG_CRASH_DUMP: u32 = 1;
pub const CONFIG_PSI: u32 = 1;
pub const CONFIG_REGULATOR_TPS6594_MODULE: u32 = 1;
pub const CONFIG_HAVE_ARCH_KASAN_VMALLOC: u32 = 1;
pub const CONFIG_KEYBOARD_ADC_MODULE: u32 = 1;
pub const CONFIG_IPV6_NDISC_NODETYPE: u32 = 1;
pub const CONFIG_USB_ISP1761_UDC: u32 = 1;
pub const CONFIG_DRM_TOSHIBA_TC358764_MODULE: u32 = 1;
pub const CONFIG_EDAC_ECS: u32 = 1;
pub const CONFIG_SND_SOC_ES8323_MODULE: u32 = 1;
pub const CONFIG_DRM_GUD_MODULE: u32 = 1;
pub const CONFIG_HID_MONTEREY_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_PACKET_ENGINES: u32 = 1;
pub const CONFIG_GFS2_FS_LOCKING_DLM: u32 = 1;
pub const CONFIG_IIO_BACKEND_MODULE: u32 = 1;
pub const CONFIG_SERIAL_EARLYCON_SEMIHOST: u32 = 1;
pub const CONFIG_USB_NET_NET1080_MODULE: u32 = 1;
pub const CONFIG_KHADAS_MCU_FAN_THERMAL_MODULE: u32 = 1;
pub const CONFIG_INPUT_IQS269A_MODULE: u32 = 1;
pub const CONFIG_DWMAC_S32_MODULE: u32 = 1;
pub const CONFIG_AHCI_TEGRA_MODULE: u32 = 1;
pub const CONFIG_BLK_DEV_SD: u32 = 1;
pub const CONFIG_IIO_ST_GYRO_I2C_3AXIS_MODULE: u32 = 1;
pub const CONFIG_MT76x0U_MODULE: u32 = 1;
pub const CONFIG_USB_XHCI_PCI: u32 = 1;
pub const CONFIG_QCOM_TSENS_MODULE: u32 = 1;
pub const CONFIG_RT2800USB_RT3573: u32 = 1;
pub const CONFIG_SENSORS_VT8231_MODULE: u32 = 1;
pub const CONFIG_HAVE_FTRACE_GRAPH_FUNC: u32 = 1;
pub const CONFIG_ATH9K_BTCOEX_SUPPORT: u32 = 1;
pub const CONFIG_TOUCHSCREEN_HYCON_HY46XX_MODULE: u32 = 1;
pub const CONFIG_IMX7D_ADC_MODULE: u32 = 1;
pub const CONFIG_CLK_X1E80100_DISPCC_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CS42XX8_I2C_MODULE: u32 = 1;
pub const CONFIG_SSB_DRIVER_PCICORE_POSSIBLE: u32 = 1;
pub const CONFIG_CDROM_PKTCDVD_BUFFERS: u32 = 8;
pub const CONFIG_IIO_ST_MAGN_SPI_3AXIS_MODULE: u32 = 1;
pub const CONFIG_NFC_PN544_MODULE: u32 = 1;
pub const CONFIG_CLK_RCAR_GEN3_CPG: u32 = 1;
pub const CONFIG_PINCTRL_RZV2M: u32 = 1;
pub const CONFIG_SCHED_INFO: u32 = 1;
pub const CONFIG_AD74115_MODULE: u32 = 1;
pub const CONFIG_PHY_ROCKCHIP_PCIE: u32 = 1;
pub const CONFIG_IP_VS_LC_MODULE: u32 = 1;
pub const CONFIG_NLS_ISO8859_3_MODULE: u32 = 1;
pub const CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE: u32 = 1;
pub const CONFIG_USB_CHIPIDEA_MODULE: u32 = 1;
pub const CONFIG_W1_SLAVE_DS2780_MODULE: u32 = 1;
pub const CONFIG_ROCKCHIP_RK3066_HDMI: u32 = 1;
pub const CONFIG_SND_SOC_WCD939X_SDW_MODULE: u32 = 1;
pub const CONFIG_ARM64_CONTPTE: u32 = 1;
pub const CONFIG_UDF_FS_MODULE: u32 = 1;
pub const CONFIG_VIDEO_MAX96712_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_SHA3_ARM64_MODULE: u32 = 1;
pub const CONFIG_HAVE_KPROBES: u32 = 1;
pub const CONFIG_NET_SCH_ETF_MODULE: u32 = 1;
pub const CONFIG_NVME_FC_MODULE: u32 = 1;
pub const CONFIG_PCIE_MOBIVEIL_HOST: u32 = 1;
pub const CONFIG_MMC_DW_HI3798CV200_MODULE: u32 = 1;
pub const CONFIG_IIO_INV_SENSORS_TIMESTAMP_MODULE: u32 = 1;
pub const CONFIG_IGB_HWMON: u32 = 1;
pub const CONFIG_ACPI_HOTPLUG_CPU: u32 = 1;
pub const CONFIG_SND_AUDIO_GRAPH_CARD2_CUSTOM_SAMPLE_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_KRB5_MODULE: u32 = 1;
pub const CONFIG_DEV_DAX_KMEM_MODULE: u32 = 1;
pub const CONFIG_VIDEO_RASPBERRYPI_PISP_BE_MODULE: u32 = 1;
pub const CONFIG_DEBUG_MEMORY_INIT: u32 = 1;
pub const CONFIG_RIONET_RX_SIZE: u32 = 128;
pub const CONFIG_USB_SERIAL_KEYSPAN_PDA_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA210_MVC_MODULE: u32 = 1;
pub const CONFIG_RASPBERRYPI_POWER: u32 = 1;
pub const CONFIG_BOOTTIME_TRACING: u32 = 1;
pub const CONFIG_VIDEO_CX231XX_DVB_MODULE: u32 = 1;
pub const CONFIG_RC_MAP_MODULE: u32 = 1;
pub const CONFIG_RTLWIFI_USB_MODULE: u32 = 1;
pub const CONFIG_RTL8192D_COMMON_MODULE: u32 = 1;
pub const CONFIG_CM3605_MODULE: u32 = 1;
pub const CONFIG_OF_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_NLS_UCS2_UTILS_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV5693_MODULE: u32 = 1;
pub const CONFIG_SND_HDA_CODEC_CA0110_MODULE: u32 = 1;
pub const CONFIG_MEDIA_PLATFORM_DRIVERS: u32 = 1;
pub const CONFIG_RADIO_TEA5764_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TEST_SUPPORT: u32 = 1;
pub const CONFIG_ARM_ARMADA_37XX_CPUFREQ_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_2077057: u32 = 1;
pub const CONFIG_ACPI_MCFG: u32 = 1;
pub const CONFIG_MFD_AXP20X: u32 = 1;
pub const CONFIG_HAVE_KVM_CPU_RELAX_INTERCEPT: u32 = 1;
pub const CONFIG_SND_VX_LIB_MODULE: u32 = 1;
pub const CONFIG_HID_JABRA_MODULE: u32 = 1;
pub const CONFIG_ASN1_ENCODER: u32 = 1;
pub const CONFIG_DVB_MB86A16_MODULE: u32 = 1;
pub const CONFIG_CHELSIO_INLINE_CRYPTO: u32 = 1;
pub const CONFIG_EEPROM_93XX46_MODULE: u32 = 1;
pub const CONFIG_ETHOC_MODULE: u32 = 1;
pub const CONFIG_LWTUNNEL: u32 = 1;
pub const CONFIG_SND_ICE1724_MODULE: u32 = 1;
pub const CONFIG_SND_RIPTIDE_MODULE: u32 = 1;
pub const CONFIG_BCM_VK_TTY: u32 = 1;
pub const CONFIG_CMA_ALIGNMENT: u32 = 8;
pub const CONFIG_VIDEO_SAA7185_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_MESON_CPU_DYNDIV: u32 = 1;
pub const CONFIG_SND_HDA_SCODEC_COMPONENT_MODULE: u32 = 1;
pub const CONFIG_MT7601U_MODULE: u32 = 1;
pub const CONFIG_ARMADA_AP806_SYSCON: u32 = 1;
pub const CONFIG_DRM_DW_HDMI_AHB_AUDIO_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_BPF_MODULE: u32 = 1;
pub const CONFIG_SUN6I_R_INTC: u32 = 1;
pub const CONFIG_CRYPTO_DEV_FSL_CAAM_INTC_COUNT_THLD: u32 = 8;
pub const CONFIG_IWLEGACY_MODULE: u32 = 1;
pub const CONFIG_I2C_XLP9XX_MODULE: u32 = 1;
pub const CONFIG_FORCEDETH_MODULE: u32 = 1;
pub const CONFIG_TI_K3_AM65_CPTS_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_IPAQ_MODULE: u32 = 1;
pub const CONFIG_RTW88_8723CS_MODULE: u32 = 1;
pub const CONFIG_LAN966X_SWITCH_MODULE: u32 = 1;
pub const CONFIG_FS_ENCRYPTION_INLINE_CRYPT: u32 = 1;
pub const CONFIG_ACPI_BGRT: u32 = 1;
pub const CONFIG_LEDS_SY7802_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_SMA1303_MODULE: u32 = 1;
pub const CONFIG_DMA_DIRECT_REMAP: u32 = 1;
pub const CONFIG_SSB_SDIOHOST: u32 = 1;
pub const CONFIG_VIDEO_OV9734_MODULE: u32 = 1;
pub const CONFIG_MDIO_THUNDER_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_WM8960_MODULE: u32 = 1;
pub const CONFIG_8139TOO_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_XCTR_MODULE: u32 = 1;
pub const CONFIG_ARCH_ROCKCHIP: u32 = 1;
pub const CONFIG_RTC_DRV_PCF2123_MODULE: u32 = 1;
pub const CONFIG_VIDEO_CX88_VP3054_MODULE: u32 = 1;
pub const CONFIG_CAN_XILINXCAN_MODULE: u32 = 1;
pub const CONFIG_TYPEC_UCSI_MODULE: u32 = 1;
pub const CONFIG_SYSVIPC_SYSCTL: u32 = 1;
pub const CONFIG_MESON_GXL_PHY_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_OMNINET_MODULE: u32 = 1;
pub const CONFIG_I2C_MUX_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL: u32 = 1;
pub const CONFIG_MDIO_BUS_MUX_MULTIPLEXER_MODULE: u32 = 1;
pub const CONFIG_FANOTIFY: u32 = 1;
pub const CONFIG_PHY_ROCKCHIP_INNO_HDMI_MODULE: u32 = 1;
pub const CONFIG_SND_SUN8I_CODEC_ANALOG_MODULE: u32 = 1;
pub const CONFIG_DMADEVICES: u32 = 1;
pub const CONFIG_SND_SOC_SIMPLE_MUX_MODULE: u32 = 1;
pub const CONFIG_TCP_CONG_YEAH_MODULE: u32 = 1;
pub const CONFIG_HW_RANDOM_CAVIUM_MODULE: u32 = 1;
pub const CONFIG_FS_MBCACHE: u32 = 1;
pub const CONFIG_IMX_GPCV2: u32 = 1;
pub const CONFIG_DRM_PANEL_LG_LG4573_MODULE: u32 = 1;
pub const CONFIG_LEDS_PCA995X_MODULE: u32 = 1;
pub const CONFIG_ARM64_AMU_EXTN: u32 = 1;
pub const CONFIG_RTW88_8821CU_MODULE: u32 = 1;
pub const CONFIG_GPIO_REGMAP_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_TPS6594_MODULE: u32 = 1;
pub const CONFIG_BCM87XX_PHY_MODULE: u32 = 1;
pub const CONFIG_QCOM_SPMI_RRADC_MODULE: u32 = 1;
pub const CONFIG_INIT_ON_ALLOC_DEFAULT_ON: u32 = 1;
pub const CONFIG_SQUASHFS_FRAGMENT_CACHE_SIZE: u32 = 3;
pub const CONFIG_TIMER_OF: u32 = 1;
pub const CONFIG_HASHTABLE_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_XILINX_I2S_MODULE: u32 = 1;
pub const CONFIG_PTP_1588_CLOCK_FC3W_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_HISI_TRNG_MODULE: u32 = 1;
pub const CONFIG_IIO_ST_PRESS_MODULE: u32 = 1;
pub const CONFIG_AXP20X_POWER_MODULE: u32 = 1;
pub const CONFIG_KSM: u32 = 1;
pub const CONFIG_USB_UAS_MODULE: u32 = 1;
pub const CONFIG_CAN_RX_OFFLOAD: u32 = 1;
pub const CONFIG_SND_HWDEP_MODULE: u32 = 1;
pub const CONFIG_AHCI_DWC_MODULE: u32 = 1;
pub const CONFIG_RC_XBOX_DVD_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_LIB_SHA256: u32 = 1;
pub const CONFIG_IIO_ST_LSM6DSX_MODULE: u32 = 1;
pub const CONFIG_AF_RXRPC_IPV6: u32 = 1;
pub const CONFIG_LZ4HC_COMPRESS_MODULE: u32 = 1;
pub const CONFIG_OMAP_GPMC: u32 = 1;
pub const CONFIG_ARMADA_AP_CPU_CLK: u32 = 1;
pub const CONFIG_SND_SOC_RT5677_SPI_MODULE: u32 = 1;
pub const CONFIG_SERIAL_8250_DMA: u32 = 1;
pub const CONFIG_BT_HCIBTUSB_BCM: u32 = 1;
pub const CONFIG_NET_IP_TUNNEL_MODULE: u32 = 1;
pub const CONFIG_FXAS21002C_I2C_MODULE: u32 = 1;
pub const CONFIG_I2C_DESIGNWARE_PCI_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_OLIMEX_LCD_OLINUXINO_MODULE: u32 = 1;
pub const CONFIG_SCSI_BNX2X_FCOE_MODULE: u32 = 1;
pub const CONFIG_HAVE_PCI: u32 = 1;
pub const CONFIG_DVB_TDA665x_MODULE: u32 = 1;
pub const CONFIG_VFIO_CDX_MODULE: u32 = 1;
pub const CONFIG_REGMAP_SPMI: u32 = 1;
pub const CONFIG_USERCOPY_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_QM1D1C0042_MODULE: u32 = 1;
pub const CONFIG_USB_DWC3_MESON_G12A_MODULE: u32 = 1;
pub const CONFIG_DM_CLONE_MODULE: u32 = 1;
pub const CONFIG_MFD_CS40L50_SPI_MODULE: u32 = 1;
pub const CONFIG_AD7124_MODULE: u32 = 1;
pub const CONFIG_INTEGRITY_MACHINE_KEYRING: u32 = 1;
pub const CONFIG_MLXSW_I2C_MODULE: u32 = 1;
pub const CONFIG_NEED_SG_DMA_FLAGS: u32 = 1;
pub const CONFIG_IP_NF_TARGET_SYNPROXY_MODULE: u32 = 1;
pub const CONFIG_USB_KEENE_MODULE: u32 = 1;
pub const CONFIG_SURFACE_HID_MODULE: u32 = 1;
pub const CONFIG_RC_DECODERS: u32 = 1;
pub const CONFIG_MT76x2_COMMON_MODULE: u32 = 1;
pub const CONFIG_BME680_SPI_MODULE: u32 = 1;
pub const CONFIG_AD7380_MODULE: u32 = 1;
pub const CONFIG_W1_SLAVE_SMEM_MODULE: u32 = 1;
pub const CONFIG_GP2AP002_MODULE: u32 = 1;
pub const CONFIG_CAVIUM_TX2_ERRATUM_219: u32 = 1;
pub const CONFIG_CLK_LS1028A_PLLDIG: u32 = 1;
pub const CONFIG_HI6220_MBOX: u32 = 1;
pub const CONFIG_RTW89_8852B_COMMON_MODULE: u32 = 1;
pub const CONFIG_ARCH_XGENE: u32 = 1;
pub const CONFIG_ISL29020_MODULE: u32 = 1;
pub const CONFIG_SND_HDA_SCODEC_CS35L41_SPI_MODULE: u32 = 1;
pub const CONFIG_PHY_MESON_G12A_USB2: u32 = 1;
pub const CONFIG_6PACK_MODULE: u32 = 1;
pub const CONFIG_BRIDGE_EBT_802_3_MODULE: u32 = 1;
pub const CONFIG_ACPI_CONTAINER: u32 = 1;
pub const CONFIG_CEC_GPIO_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_M920X_MODULE: u32 = 1;
pub const CONFIG_DVB_TDA10023_MODULE: u32 = 1;
pub const CONFIG_LEDS_QCOM_LPG_MODULE: u32 = 1;
pub const CONFIG_CHR_DEV_SG: u32 = 1;
pub const CONFIG_PCI_IMX6: u32 = 1;
pub const CONFIG_PROBE_EVENTS_BTF_ARGS: u32 = 1;
pub const CONFIG_RTC_DRV_RV3032_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_HW_PTE_YOUNG: u32 = 1;
pub const CONFIG_PINCTRL_SUN50I_A64: u32 = 1;
pub const CONFIG_HI6421V600_IRQ_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_CY8C95X0_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_COLIBRI_VF50_MODULE: u32 = 1;
pub const CONFIG_MMU: u32 = 1;
pub const CONFIG_QTNFMAC_PCIE_MODULE: u32 = 1;
pub const CONFIG_NET_DSA_HIRSCHMANN_HELLCREEK_MODULE: u32 = 1;
pub const CONFIG_SSB_DRIVER_PCICORE: u32 = 1;
pub const CONFIG_RAVB_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_MT2131_MODULE: u32 = 1;
pub const CONFIG_IMX_GPCV2_PM_DOMAINS: u32 = 1;
pub const CONFIG_IEEE802154_SOCKET_MODULE: u32 = 1;
pub const CONFIG_HID_NVIDIA_SHIELD_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA_RT5677_MODULE: u32 = 1;
pub const CONFIG_IP6_NF_MATCH_MH_MODULE: u32 = 1;
pub const CONFIG_SECURITY: u32 = 1;
pub const CONFIG_SND_SOC_TAS2781_FMWLIB_MODULE: u32 = 1;
pub const CONFIG_DRM_MIPI_DSI: u32 = 1;
pub const CONFIG_FS_ENCRYPTION: u32 = 1;
pub const CONFIG_SENSORS_ARM_SCMI_MODULE: u32 = 1;
pub const CONFIG_IR_XMP_DECODER_MODULE: u32 = 1;
pub const CONFIG_MEDIA_COMMON_OPTIONS: u32 = 1;
pub const CONFIG_USB_RAW_GADGET_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_RNG2: u32 = 1;
pub const CONFIG_SENSORS_MP5920_MODULE: u32 = 1;
pub const CONFIG_NLS_ISO8859_2_MODULE: u32 = 1;
pub const CONFIG_HID_TIVO_MODULE: u32 = 1;
pub const CONFIG_RENESAS_RZG2LWDT_MODULE: u32 = 1;
pub const CONFIG_PHY_QCOM_QMP_UFS_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_AXG_AUDIO: u32 = 1;
pub const CONFIG_W1_SLAVE_DS2781_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV7640_MODULE: u32 = 1;
pub const CONFIG_IPV6_GRE_MODULE: u32 = 1;
pub const CONFIG_DRM_XE_FORCE_PROBE: &[u8; 1] = b"\0";
pub const CONFIG_SND_HDA_I915: u32 = 1;
pub const CONFIG_MXC_CLK: u32 = 1;
pub const CONFIG_KEYBOARD_GPIO_MODULE: u32 = 1;
pub const CONFIG_MMC_DW_PLTFM_MODULE: u32 = 1;
pub const CONFIG_NET_FOU_IP_TUNNELS: u32 = 1;
pub const CONFIG_MMC_MESON_MX_SDIO_MODULE: u32 = 1;
pub const CONFIG_DRM_LOAD_EDID_FIRMWARE: u32 = 1;
pub const CONFIG_MDIO_BUS_MUX_GPIO_MODULE: u32 = 1;
pub const CONFIG_KFENCE_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_MINIX_FS_MODULE: u32 = 1;
pub const CONFIG_SND_USB_AUDIO_MODULE: u32 = 1;
pub const CONFIG_RC_CORE: u32 = 1;
pub const CONFIG_BCM2835_MBOX: u32 = 1;
pub const CONFIG_CRYPTO_DEV_ALLWINNER: u32 = 1;
pub const CONFIG_DRM_RZG2L_DU_MODULE: u32 = 1;
pub const CONFIG_ADXL380_I2C_MODULE: u32 = 1;
pub const CONFIG_BMP280_SPI_MODULE: u32 = 1;
pub const CONFIG_USB_CDNS3_PCI_WRAP_MODULE: u32 = 1;
pub const CONFIG_HAMACHI_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DRBG_CTR: u32 = 1;
pub const CONFIG_REGULATOR_TPS6286X_MODULE: u32 = 1;
pub const CONFIG_NET_SCH_QFQ_MODULE: u32 = 1;
pub const CONFIG_MANTIS_CORE_MODULE: u32 = 1;
pub const CONFIG_I2C_ZHAOXIN_MODULE: u32 = 1;
pub const CONFIG_IPE_POLICY_SIG_SECONDARY_KEYRING: u32 = 1;
pub const CONFIG_DRM_AMD_DC_FP: u32 = 1;
pub const CONFIG_SPI_DESIGNWARE_MODULE: u32 = 1;
pub const CONFIG_KEYBOARD_IMX_BBM_SCMI: u32 = 1;
pub const CONFIG_USB_CDNSP_PCI_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_USB_ZYTRONIC: u32 = 1;
pub const CONFIG_AS_HAS_SHA3: u32 = 1;
pub const CONFIG_BME680_I2C_MODULE: u32 = 1;
pub const CONFIG_MOUSE_SYNAPTICS_USB_MODULE: u32 = 1;
pub const CONFIG_MFD_CROS_EC_DEV_MODULE: u32 = 1;
pub const CONFIG_DRM_TEGRA_STAGING: u32 = 1;
pub const CONFIG_VCAP: u32 = 1;
pub const CONFIG_CFG80211_DEFAULT_PS: u32 = 1;
pub const CONFIG_SND_SOC_RT722_SDCA_SDW_MODULE: u32 = 1;
pub const CONFIG_PHY_SUN6I_MIPI_DPHY_MODULE: u32 = 1;
pub const CONFIG_BT_LE_L2CAP_ECRED: u32 = 1;
pub const CONFIG_MT76_CONNAC_LIB_MODULE: u32 = 1;
pub const CONFIG_SND_SEQUENCER_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TAS2781_I2C_MODULE: u32 = 1;
pub const CONFIG_SOUNDWIRE_MODULE: u32 = 1;
pub const CONFIG_OPENVSWITCH_GENEVE_MODULE: u32 = 1;
pub const CONFIG_XILLYBUS_MODULE: u32 = 1;
pub const CONFIG_NET_TC_SKB_EXT: u32 = 1;
pub const CONFIG_WLAN_VENDOR_MEDIATEK: u32 = 1;
pub const CONFIG_CAN_CALC_BITTIMING: u32 = 1;
pub const CONFIG_IPC_NS: u32 = 1;
pub const CONFIG_RTC_DRV_DS1390_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_DEBUG_VIRTUAL: u32 = 1;
pub const CONFIG_HID_PID: u32 = 1;
pub const CONFIG_SND_SOC_FSL_XCVR_MODULE: u32 = 1;
pub const CONFIG_IOMMU_SUPPORT: u32 = 1;
pub const CONFIG_MUX_GPIO_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_RESET_CONTROLLER: u32 = 1;
pub const CONFIG_IPMI_WATCHDOG_MODULE: u32 = 1;
pub const CONFIG_NET_ACT_NAT_MODULE: u32 = 1;
pub const CONFIG_BROADCOM_PHY_MODULE: u32 = 1;
pub const CONFIG_USB_CHIPIDEA_MSM_MODULE: u32 = 1;
pub const CONFIG_VDPA_SIM_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_FSL_ASRC_MODULE: u32 = 1;
pub const CONFIG_DPLL: u32 = 1;
pub const CONFIG_SND_SOC_MAX98357A_MODULE: u32 = 1;
pub const CONFIG_HID_MACALLY_MODULE: u32 = 1;
pub const CONFIG_VFIO_IOMMU_TYPE1_MODULE: u32 = 1;
pub const CONFIG_JOYSTICK_ADI_MODULE: u32 = 1;
pub const CONFIG_MEMBARRIER: u32 = 1;
pub const CONFIG_ROCKCHIP_INNO_HDMI: u32 = 1;
pub const CONFIG_SUN8I_THERMAL_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_WM8961_MODULE: u32 = 1;
pub const CONFIG_SENSORS_DME1737_MODULE: u32 = 1;
pub const CONFIG_ENERGY_MODEL: u32 = 1;
pub const CONFIG_INPUT_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_B43_BCMA: u32 = 1;
pub const CONFIG_VIDEO_TLV320AIC23B_MODULE: u32 = 1;
pub const CONFIG_CHARGER_BQ2515X_MODULE: u32 = 1;
pub const CONFIG_PCI_IOV: u32 = 1;
pub const CONFIG_AD4030_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_NOVATEK_NVT_TS_MODULE: u32 = 1;
pub const CONFIG_USB_VL600_MODULE: u32 = 1;
pub const CONFIG_QCOM_CLK_SMD_RPM_MODULE: u32 = 1;
pub const CONFIG_CPU_IDLE_GOV_MENU: u32 = 1;
pub const CONFIG_INV_ICM42600_MODULE: u32 = 1;
pub const CONFIG_XILINX_ZYNQMP_DPDMA_MODULE: u32 = 1;
pub const CONFIG_NETKIT: u32 = 1;
pub const CONFIG_SENSORS_XDP710_MODULE: u32 = 1;
pub const CONFIG_GPIO_PCA9570_MODULE: u32 = 1;
pub const CONFIG_INTERCONNECT_QCOM_SC7180: u32 = 1;
pub const CONFIG_JFFS2_FS_DEBUG: u32 = 0;
pub const CONFIG_NETFILTER_XT_MATCH_HELPER_MODULE: u32 = 1;
pub const CONFIG_OF_ADDRESS: u32 = 1;
pub const CONFIG_CRC32_ARCH: u32 = 1;
pub const CONFIG_CRYPTO_ARCH_HAVE_LIB_CHACHA: u32 = 1;
pub const CONFIG_INFINIBAND_IPOIB_MODULE: u32 = 1;
pub const CONFIG_VIDEO_LM3560_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_MCT_U232_MODULE: u32 = 1;
pub const CONFIG_ARM_CCI: u32 = 1;
pub const CONFIG_VIDEO_RZG2L_CSI2_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV2640_MODULE: u32 = 1;
pub const CONFIG_SECURITY_TOMOYO_ACTIVATION_TRIGGER: &[u8; 25] = b"/usr/lib/systemd/systemd\0";
pub const CONFIG_MFD_RSMU_I2C_MODULE: u32 = 1;
pub const CONFIG_VSOCKETS_MODULE: u32 = 1;
pub const CONFIG_CHECK_SIGNATURE: u32 = 1;
pub const CONFIG_ARM_DSU_PMU_MODULE: u32 = 1;
pub const CONFIG_CLK_R9A08G045: u32 = 1;
pub const CONFIG_KEYBOARD_CYPRESS_SF_MODULE: u32 = 1;
pub const CONFIG_QED_OOO: u32 = 1;
pub const CONFIG_SH_TIMER_CMT: u32 = 1;
pub const CONFIG_MEDIA_DIGITAL_TV_SUPPORT: u32 = 1;
pub const CONFIG_SENSORS_EMC2305_MODULE: u32 = 1;
pub const CONFIG_MXC4005_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_NETRONOME: u32 = 1;
pub const CONFIG_NET_CLS_CGROUP: u32 = 1;
pub const CONFIG_CRYPTO_DRBG_MENU: u32 = 1;
pub const CONFIG_CLS_U32_MARK: u32 = 1;
pub const CONFIG_READ_ONLY_THP_FOR_FS: u32 = 1;
pub const CONFIG_SCSI_SNIC_MODULE: u32 = 1;
pub const CONFIG_PCI_J721E: u32 = 1;
pub const CONFIG_RENESAS_IRQC: u32 = 1;
pub const CONFIG_DVB_LNBH25_MODULE: u32 = 1;
pub const CONFIG_BATTERY_CW2015_MODULE: u32 = 1;
pub const CONFIG_KEBA_CP500_MODULE: u32 = 1;
pub const CONFIG_DRM_HISI_KIRIN_MODULE: u32 = 1;
pub const CONFIG_MT7996E_MODULE: u32 = 1;
pub const CONFIG_W1_SLAVE_THERM_MODULE: u32 = 1;
pub const CONFIG_MAX30100_MODULE: u32 = 1;
pub const CONFIG_DRM_TI_TFP410_MODULE: u32 = 1;
pub const CONFIG_VHOST_IOTLB_MODULE: u32 = 1;
pub const CONFIG_IPMI_DMI_DECODE: u32 = 1;
pub const CONFIG_SUN50I_A64_CCU: u32 = 1;
pub const CONFIG_SND_SOC_WM8524_MODULE: u32 = 1;
pub const CONFIG_CW1200_WLAN_SPI_MODULE: u32 = 1;
pub const CONFIG_XZ_DEC: u32 = 1;
pub const CONFIG_BLK_DEV_RUST_NULL_MODULE: u32 = 1;
pub const CONFIG_HSA_AMD: u32 = 1;
pub const CONFIG_ARM64_CONT_PTE_SHIFT: u32 = 4;
pub const CONFIG_SENSORS_ADS7828_MODULE: u32 = 1;
pub const CONFIG_IIO_MS_SENSORS_I2C_MODULE: u32 = 1;
pub const CONFIG_USB_DSBR_MODULE: u32 = 1;
pub const CONFIG_CC_HAS_KASAN_SW_TAGS: u32 = 1;
pub const CONFIG_MOXTET_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_ROCKCHIP_I2S_MODULE: u32 = 1;
pub const CONFIG_CIFS_ALLOW_INSECURE_LEGACY: u32 = 1;
pub const CONFIG_ATH11K_MODULE: u32 = 1;
pub const CONFIG_THERMAL_HWMON: u32 = 1;
pub const CONFIG_LEDS_TRIGGER_CPU: u32 = 1;
pub const CONFIG_MLX5_EN_ARFS: u32 = 1;
pub const CONFIG_ROCKCHIP_DW_HDMI_QP: u32 = 1;
pub const CONFIG_PCI_QUIRKS: u32 = 1;
pub const CONFIG_DRM_DW_HDMI_GP_AUDIO_MODULE: u32 = 1;
pub const CONFIG_MFD_CS40L50_I2C_MODULE: u32 = 1;
pub const CONFIG_NET_DSA_TAG_BRCM_MODULE: u32 = 1;
pub const CONFIG_NET_SCH_FQ_CODEL: u32 = 1;
pub const CONFIG_IPV6_ILA_MODULE: u32 = 1;
pub const CONFIG_TEGRA_TIMER: u32 = 1;
pub const CONFIG_NET_VENDOR_FUNGIBLE: u32 = 1;
pub const CONFIG_PATA_MARVELL_MODULE: u32 = 1;
pub const CONFIG_MTD_NAND_NANDSIM_MODULE: u32 = 1;
pub const CONFIG_GENERIC_PINCONF: u32 = 1;
pub const CONFIG_PHY_HI3670_USB_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_CRC32: u32 = 1;
pub const CONFIG_MEDIA_TUNER_SI2157_MODULE: u32 = 1;
pub const CONFIG_DW_DMAC_PCI_MODULE: u32 = 1;
pub const CONFIG_NFS_COMMON_LOCALIO_SUPPORT_MODULE: u32 = 1;
pub const CONFIG_BLK_CGROUP_IOPRIO: u32 = 1;
pub const CONFIG_CROS_EC_VBC_MODULE: u32 = 1;
pub const CONFIG_MD: u32 = 1;
pub const CONFIG_I2C_VIRTIO_MODULE: u32 = 1;
pub const CONFIG_PCPU_DEV_REFCNT: u32 = 1;
pub const CONFIG_PVPANIC: u32 = 1;
pub const CONFIG_I40E_MODULE: u32 = 1;
pub const CONFIG_IR_ITE_CIR_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_DS1347_MODULE: u32 = 1;
pub const CONFIG_SM_DISPCC_8250_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA210_SFC_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_RT5631_MODULE: u32 = 1;
pub const CONFIG_SENSORS_RASPBERRYPI_HWMON_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_AMAZON: u32 = 1;
pub const CONFIG_TI_PRUSS_INTC_MODULE: u32 = 1;
pub const CONFIG_MODULE_UNLOAD: u32 = 1;
pub const CONFIG_NET_VENDOR_INTEL: u32 = 1;
pub const CONFIG_THERMAL_DEFAULT_GOV_STEP_WISE: u32 = 1;
pub const CONFIG_IMA_READ_POLICY: u32 = 1;
pub const CONFIG_SYSC_RZ: u32 = 1;
pub const CONFIG_DVB_TDA8261_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_SUN8I_H3_R: u32 = 1;
pub const CONFIG_ATH9K_RFKILL: u32 = 1;
pub const CONFIG_BATTERY_MAX17042_MODULE: u32 = 1;
pub const CONFIG_FPGA_DFL_FME_MGR_MODULE: u32 = 1;
pub const CONFIG_CONSOLE_LOGLEVEL_DEFAULT: u32 = 7;
pub const CONFIG_CADENCE_WATCHDOG_MODULE: u32 = 1;
pub const CONFIG_RT2800USB_RT55XX: u32 = 1;
pub const CONFIG_SPEAKUP_SYNTH_LTLK_MODULE: u32 = 1;
pub const CONFIG_DVB_DIB7000M_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_T613_MODULE: u32 = 1;
pub const CONFIG_VITESSE_PHY_MODULE: u32 = 1;
pub const CONFIG_TCP_CONG_BIC_MODULE: u32 = 1;
pub const CONFIG_ARM64_BTI: u32 = 1;
pub const CONFIG_IGBVF_MODULE: u32 = 1;
pub const CONFIG_PAGE_COUNTER: u32 = 1;
pub const CONFIG_CONSOLE_TRANSLATIONS: u32 = 1;
pub const CONFIG_IP_VS_RR_MODULE: u32 = 1;
pub const CONFIG_CPU_FREQ_GOV_POWERSAVE: u32 = 1;
pub const CONFIG_CRYPTO_TWOFISH_COMMON_MODULE: u32 = 1;
pub const CONFIG_USB_ACM_MODULE: u32 = 1;
pub const CONFIG_QCOM_APR_MODULE: u32 = 1;
pub const CONFIG_DVB_CX22700_MODULE: u32 = 1;
pub const CONFIG_MHP_DEFAULT_ONLINE_TYPE_OFFLINE: u32 = 1;
pub const CONFIG_XGENE_PMU: u32 = 1;
pub const CONFIG_WATCHDOG_OPEN_TIMEOUT: u32 = 0;
pub const CONFIG_BUILDTIME_TABLE_SORT: u32 = 1;
pub const CONFIG_NLS_ISO8859_5_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_VP702X_MODULE: u32 = 1;
pub const CONFIG_E1000E_MODULE: u32 = 1;
pub const CONFIG_HAVE_CONTEXT_TRACKING_USER: u32 = 1;
pub const CONFIG_IEEE802154_DRIVERS_MODULE: u32 = 1;
pub const CONFIG_BINFMT_SCRIPT: u32 = 1;
pub const CONFIG_SND_SOC_FSL_ASOC_CARD_MODULE: u32 = 1;
pub const CONFIG_OPT4060_MODULE: u32 = 1;
pub const CONFIG_SENSORS_CORSAIR_PSU_MODULE: u32 = 1;
pub const CONFIG_MD_RAID1_MODULE: u32 = 1;
pub const CONFIG_VIRTIO_NET_MODULE: u32 = 1;
pub const CONFIG_QCOM_GPI_DMA_MODULE: u32 = 1;
pub const CONFIG_PINMUX: u32 = 1;
pub const CONFIG_CRYPTO_SIG2: u32 = 1;
pub const CONFIG_XFS_DRAIN_INTENTS: u32 = 1;
pub const CONFIG_CRYPTO_DEV_CAVIUM_ZIP_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_FSL_AUDMIX_MODULE: u32 = 1;
pub const CONFIG_MAC80211_MODULE: u32 = 1;
pub const CONFIG_DVB_STV0910_MODULE: u32 = 1;
pub const CONFIG_THRUSTMASTER_FF: u32 = 1;
pub const CONFIG_SND_MIXER_OSS_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAVE_ELF_PROT: u32 = 1;
pub const CONFIG_RTW88_8822CU_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_WM8741_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_TDA18271_MODULE: u32 = 1;
pub const CONFIG_MULTIUSER: u32 = 1;
pub const CONFIG_SERIAL_8250_EM: u32 = 1;
pub const CONFIG_CRYPTO_842: u32 = 1;
pub const CONFIG_CRYPTO_AEGIS128_SIMD: u32 = 1;
pub const CONFIG_USB_AN2720: u32 = 1;
pub const CONFIG_DRM_IMX8QXP_PIXEL_COMBINER_MODULE: u32 = 1;
pub const CONFIG_FONT_8x16: u32 = 1;
pub const CONFIG_HWLAT_TRACER: u32 = 1;
pub const CONFIG_NLS_MAC_ROMAN_MODULE: u32 = 1;
pub const CONFIG_RTW88_8822C_MODULE: u32 = 1;
pub const CONFIG_PPP_MODULE: u32 = 1;
pub const CONFIG_ZOPT2201_MODULE: u32 = 1;
pub const CONFIG_HID_SENSOR_CUSTOM_INTEL_HINGE_MODULE: u32 = 1;
pub const CONFIG_HAVE_KVM_IRQ_ROUTING: u32 = 1;
pub const CONFIG_NETFILTER_SKIP_EGRESS: u32 = 1;
pub const CONFIG_SM_VIDEOCC_7150_MODULE: u32 = 1;
pub const CONFIG_TOOLS_SUPPORT_RELR: u32 = 1;
pub const CONFIG_SND_SOC_WM8804_SPI_MODULE: u32 = 1;
pub const CONFIG_SPMI: u32 = 1;
pub const CONFIG_PCIE_XILINX: u32 = 1;
pub const CONFIG_BRIDGE_IGMP_SNOOPING: u32 = 1;
pub const CONFIG_SECURITY_SELINUX_AVC_STATS: u32 = 1;
pub const CONFIG_USB_GSPCA_JL2005BCD_MODULE: u32 = 1;
pub const CONFIG_VCNL4035_MODULE: u32 = 1;
pub const CONFIG_I2C_DLN2_MODULE: u32 = 1;
pub const CONFIG_CMA: u32 = 1;
pub const CONFIG_SND_USB_TONEPORT_MODULE: u32 = 1;
pub const CONFIG_IP6_NF_FILTER_MODULE: u32 = 1;
pub const CONFIG_HID_SAITEK_MODULE: u32 = 1;
pub const CONFIG_XILINX_AMS_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_AES_ARM64_CE_BLK: u32 = 1;
pub const CONFIG_DRM_PANEL_NOVATEK_NT35560_MODULE: u32 = 1;
pub const CONFIG_IP_NF_ARPTABLES_MODULE: u32 = 1;
pub const CONFIG_ARCH_FORCE_MAX_ORDER: u32 = 10;
pub const CONFIG_HID_VIVALDI_MODULE: u32 = 1;
pub const CONFIG_MHI_WWAN_CTRL_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_MARK_MODULE: u32 = 1;
pub const CONFIG_CHARGER_GPIO_MODULE: u32 = 1;
pub const CONFIG_LAN966X_DCB: u32 = 1;
pub const CONFIG_SCSI_DH: u32 = 1;
pub const CONFIG_ARM64_LD_HAS_FIX_ERRATUM_843419: u32 = 1;
pub const CONFIG_HID_ACRUX_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_MESON_A1: u32 = 1;
pub const CONFIG_TI_SCI_PROTOCOL: u32 = 1;
pub const CONFIG_INTERCONNECT_QCOM_SM6115_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_LENGTH_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_M41T80_MODULE: u32 = 1;
pub const CONFIG_TMPFS_XATTR: u32 = 1;
pub const CONFIG_TOUCHSCREEN_USB_GUNZE: u32 = 1;
pub const CONFIG_NEED_PER_CPU_PAGE_FIRST_CHUNK: u32 = 1;
pub const CONFIG_VIDEO_SUN4I_CSI_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_WM8962_MODULE: u32 = 1;
pub const CONFIG_BRCMFMAC_PCIE: u32 = 1;
pub const CONFIG_DRM_XE_TIMESLICE_MIN: u32 = 1;
pub const CONFIG_DVB_BCM3510_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_ADAU1761_SPI_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_824069: u32 = 1;
pub const CONFIG_BLOCK: u32 = 1;
pub const CONFIG_SERIAL_SH_SCI: u32 = 1;
pub const CONFIG_CYPRESS_FIRMWARE_MODULE: u32 = 1;
pub const CONFIG_FSL_ENETC_IERB_MODULE: u32 = 1;
pub const CONFIG_PCI_LABEL: u32 = 1;
pub const CONFIG_SND_LX6464ES_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_FSL_MQS_MODULE: u32 = 1;
pub const CONFIG_PTP_1588_CLOCK_OPTIONAL: u32 = 1;
pub const CONFIG_CRYPTO_JITTERENTROPY_MEMORY_BLOCKS: u32 = 64;
pub const CONFIG_I2C_MLXBF_MODULE: u32 = 1;
pub const CONFIG_DM_BUFIO: u32 = 1;
pub const CONFIG_DRM_PANEL_TPO_TPG110_MODULE: u32 = 1;
pub const CONFIG_HAVE_IMA_KEXEC: u32 = 1;
pub const CONFIG_PRINTK_INDEX: u32 = 1;
pub const CONFIG_SPEAKUP_SYNTH_TXPRT_MODULE: u32 = 1;
pub const CONFIG_SCSI_UFS_TI_J721E_MODULE: u32 = 1;
pub const CONFIG_MPTCP: u32 = 1;
pub const CONFIG_TYPEC_TCPCI_MAXIM_MODULE: u32 = 1;
pub const CONFIG_ARM64_PTR_AUTH_KERNEL: u32 = 1;
pub const CONFIG_CPU_FREQ: u32 = 1;
pub const CONFIG_IWLWIFI_KUNIT_TESTS_MODULE: u32 = 1;
pub const CONFIG_USB_G_SERIAL_MODULE: u32 = 1;
pub const CONFIG_FAT_DEFAULT_IOCHARSET: &[u8; 6] = b"ascii\0";
pub const CONFIG_SENSORS_DS620_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_INNOLUX_EJ030NA_MODULE: u32 = 1;
pub const CONFIG_NFSD_PNFS: u32 = 1;
pub const CONFIG_SND_SOC_QCOM_SDW_MODULE: u32 = 1;
pub const CONFIG_FSL_ENETC_PTP_CLOCK_MODULE: u32 = 1;
pub const CONFIG_TTY: u32 = 1;
pub const CONFIG_IMX2_WDT_MODULE: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_PMD_PFNMAP: u32 = 1;
pub const CONFIG_PHY_QCOM_EUSB2_REPEATER_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_ZD1301_MODULE: u32 = 1;
pub const CONFIG_DECOMPRESS_LZMA: u32 = 1;
pub const CONFIG_DVB_MANTIS_MODULE: u32 = 1;
pub const CONFIG_IR_IGUANA_MODULE: u32 = 1;
pub const CONFIG_CEC_NXP_TDA9950_MODULE: u32 = 1;
pub const CONFIG_ARM_RASPBERRYPI_CPUFREQ_MODULE: u32 = 1;
pub const CONFIG_842_DECOMPRESS: u32 = 1;
pub const CONFIG_FEALNX_MODULE: u32 = 1;
pub const CONFIG_I40EVF_MODULE: u32 = 1;
pub const CONFIG_CFS_BANDWIDTH: u32 = 1;
pub const CONFIG_LEDS_LM3530_MODULE: u32 = 1;
pub const CONFIG_IMX_SCMI_MISC_DRV_MODULE: u32 = 1;
pub const CONFIG_INTERCONNECT_QCOM_BCM_VOTER: u32 = 1;
pub const CONFIG_B43_BCMA_PIO: u32 = 1;
pub const CONFIG_ACPI_TAD_MODULE: u32 = 1;
pub const CONFIG_SYMBOLIC_ERRNAME: u32 = 1;
pub const CONFIG_SENSORS_LINEAGE_MODULE: u32 = 1;
pub const CONFIG_VIDEO_CX88_ENABLE_VP3054: u32 = 1;
pub const CONFIG_CAN_PEAK_USB_MODULE: u32 = 1;
pub const CONFIG_LEDS_AW200XX_MODULE: u32 = 1;
pub const CONFIG_QUEUED_SPINLOCKS: u32 = 1;
pub const CONFIG_DRM_IMX8QXP_PIXEL_LINK_MODULE: u32 = 1;
pub const CONFIG_SENSORS_LTC2978_MODULE: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_INT128: u32 = 1;
pub const CONFIG_TCP_CONG_BBR_MODULE: u32 = 1;
pub const CONFIG_ARMADA_CP110_SYSCON: u32 = 1;
pub const CONFIG_RV_REACT_PANIC: u32 = 1;
pub const CONFIG_ARM_SCMI_TRANSPORT_VIRTIO_VERSION1_COMPLIANCE: u32 = 1;
pub const CONFIG_CRYPTO_MD4_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_NEWVISION_NV3051D_MODULE: u32 = 1;
pub const CONFIG_SERIAL_8250_CONSOLE: u32 = 1;
pub const CONFIG_LOCK_MM_AND_FIND_VMA: u32 = 1;
pub const CONFIG_SOC_BUS: u32 = 1;
pub const CONFIG_RESET_HISI: u32 = 1;
pub const CONFIG_MODULE_SIG_HASH: &[u8; 7] = b"sha512\0";
pub const CONFIG_SND_SOC_RK3399_GRU_SOUND_MODULE: u32 = 1;
pub const CONFIG_NETWORK_PHY_TIMESTAMPING: u32 = 1;
pub const CONFIG_PINCTRL_SM4250_LPASS_LPI_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_QCOM_COMMON_MODULE: u32 = 1;
pub const CONFIG_PROC_KCORE: u32 = 1;
pub const CONFIG_ARCH_USE_CMPXCHG_LOCKREF: u32 = 1;
pub const CONFIG_DEBUG_INFO_DWARF_TOOLCHAIN_DEFAULT: u32 = 1;
pub const CONFIG_CLK_IMX8MM: u32 = 1;
pub const CONFIG_FSL_MC_DPIO_MODULE: u32 = 1;
pub const CONFIG_GPIO_IMX_SCU: u32 = 1;
pub const CONFIG_ARCH_HAS_KEEPINITRD: u32 = 1;
pub const CONFIG_CLK_SP810: u32 = 1;
pub const CONFIG_FW_LOADER_DEBUG: u32 = 1;
pub const CONFIG_ARCH_HAS_SUBPAGE_FAULTS: u32 = 1;
pub const CONFIG_RTW88_LEDS: u32 = 1;
pub const CONFIG_VIDEO_CX25840_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_GPIO: u32 = 1;
pub const CONFIG_XFS_POSIX_ACL: u32 = 1;
pub const CONFIG_BLK_MQ_STACKING: u32 = 1;
pub const CONFIG_DRM_KUNIT_TEST_HELPERS_MODULE: u32 = 1;
pub const CONFIG_LEDS_BLINKM_MULTICOLOR: u32 = 1;
pub const CONFIG_SWP_EMULATION: u32 = 1;
pub const CONFIG_CHARGER_SURFACE_MODULE: u32 = 1;
pub const CONFIG_SENSORS_NZXT_KRAKEN2_MODULE: u32 = 1;
pub const CONFIG_CORESIGHT_CTCU_MODULE: u32 = 1;
pub const CONFIG_DRM_TOSHIBA_TC358767_MODULE: u32 = 1;
pub const CONFIG_HAVE_TRUSTED_KEYS: u32 = 1;
pub const CONFIG_SND_SOC_ES8326_MODULE: u32 = 1;
pub const CONFIG_CARL9170_LEDS: u32 = 1;
pub const CONFIG_NF_DUP_NETDEV_MODULE: u32 = 1;
pub const CONFIG_NET_ACT_CSUM_MODULE: u32 = 1;
pub const CONFIG_SND_MESON_AXG_TDM_INTERFACE_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_TDA9887_MODULE: u32 = 1;
pub const CONFIG_CROS_EC_CHARDEV_MODULE: u32 = 1;
pub const CONFIG_SCSI_UFSHCD_MODULE: u32 = 1;
pub const CONFIG_POWERCAP: u32 = 1;
pub const CONFIG_I2C_MUX_GPMUX_MODULE: u32 = 1;
pub const CONFIG_CHARGER_RT5033_MODULE: u32 = 1;
pub const CONFIG_IOMMUFD_MODULE: u32 = 1;
pub const CONFIG_TIMERLAT_TRACER: u32 = 1;
pub const CONFIG_INET6_IPCOMP_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_SP_CCP: u32 = 1;
pub const CONFIG_FW_LOADER_SYSFS: u32 = 1;
pub const CONFIG_NFT_COMPAT_MODULE: u32 = 1;
pub const CONFIG_TEGRA20_APB_DMA: u32 = 1;
pub const CONFIG_NET_DSA_TAG_XRS700X_MODULE: u32 = 1;
pub const CONFIG_ARM64_TAGGED_ADDR_ABI: u32 = 1;
pub const CONFIG_DRM_VC4_HDMI_CEC: u32 = 1;
pub const CONFIG_SA_CAMCC_8775P_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_ALGAPI2: u32 = 1;
pub const CONFIG_SQUASHFS_ZSTD: u32 = 1;
pub const CONFIG_SCSI_PMCRAID_MODULE: u32 = 1;
pub const CONFIG_DMA_CMA: u32 = 1;
pub const CONFIG_BCM7XXX_PHY_MODULE: u32 = 1;
pub const CONFIG_SENSORS_SBTSI_MODULE: u32 = 1;
pub const CONFIG_CPU_MITIGATIONS: u32 = 1;
pub const CONFIG_TEE_STMM_EFI_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_R820T_MODULE: u32 = 1;
pub const CONFIG_NLS_ISO8859_4_MODULE: u32 = 1;
pub const CONFIG_MFD_STMPE: u32 = 1;
pub const CONFIG_RAID6_PQ: u32 = 1;
pub const CONFIG_HID_WACOM_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MP2975_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_RK3308_MODULE: u32 = 1;
pub const CONFIG_MD_RAID0_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_LPASS_PLATFORM_MODULE: u32 = 1;
pub const CONFIG_LEDS_NCP5623_MODULE: u32 = 1;
pub const CONFIG_CLZ_TAB: u32 = 1;
pub const CONFIG_PROC_MEM_ALWAYS_FORCE: u32 = 1;
pub const CONFIG_BLKDEV_UBLK_LEGACY_OPCODES: u32 = 1;
pub const CONFIG_SND_CS4281_MODULE: u32 = 1;
pub const CONFIG_PCIE_MOBIVEIL_PLAT: u32 = 1;
pub const CONFIG_CHROME_PLATFORMS: u32 = 1;
pub const CONFIG_ARCH_USES_PG_ARCH_2: u32 = 1;
pub const CONFIG_NVME_TARGET_MODULE: u32 = 1;
pub const CONFIG_PINCONF: u32 = 1;
pub const CONFIG_PM_DEVFREQ_EVENT: u32 = 1;
pub const CONFIG_SND_HDA_PATCH_LOADER: u32 = 1;
pub const CONFIG_FUNCTION_ALIGNMENT: u32 = 8;
pub const CONFIG_F2FS_STAT_FS: u32 = 1;
pub const CONFIG_SND_COMPRESS_OFFLOAD_MODULE: u32 = 1;
pub const CONFIG_ARM_SCMI_TRANSPORT_MAILBOX: u32 = 1;
pub const CONFIG_SND_DESIGNWARE_I2S_MODULE: u32 = 1;
pub const CONFIG_TI_K3_PSIL_MODULE: u32 = 1;
pub const CONFIG_ATH9K_AHB: u32 = 1;
pub const CONFIG_CFG80211_USE_KERNEL_REGDB_KEYS: u32 = 1;
pub const CONFIG_NCN26000_PHY_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_PKTTYPE_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_XTS: u32 = 1;
pub const CONFIG_NVMEM_LAYOUT_SL28_VPD_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_MAC_MODULE: u32 = 1;
pub const CONFIG_IIO_SW_DEVICE_MODULE: u32 = 1;
pub const CONFIG_INET6_ESPINTCP: u32 = 1;
pub const CONFIG_DVB_TC90522_MODULE: u32 = 1;
pub const CONFIG_LEDS_TRIGGER_HEARTBEAT_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_TPS65086_MODULE: u32 = 1;
pub const CONFIG_INET_SCTP_DIAG_MODULE: u32 = 1;
pub const CONFIG_RTW88_8822B_MODULE: u32 = 1;
pub const CONFIG_PPS: u32 = 1;
pub const CONFIG_EFI_TEST_MODULE: u32 = 1;
pub const CONFIG_NFC_PORT100_MODULE: u32 = 1;
pub const CONFIG_INTERCONNECT_QCOM_SDX75_MODULE: u32 = 1;
pub const CONFIG_INTERCONNECT: u32 = 1;
pub const CONFIG_MAC80211_HAS_RC: u32 = 1;
pub const CONFIG_ARM_ARCH_TIMER: u32 = 1;
pub const CONFIG_NLS_MAC_GREEK_MODULE: u32 = 1;
pub const CONFIG_ARCH_USE_GNU_PROPERTY: u32 = 1;
pub const CONFIG_SND_SOC_WM8753_MODULE: u32 = 1;
pub const CONFIG_VIDEO_EM28XX_MODULE: u32 = 1;
pub const CONFIG_GLOB: u32 = 1;
pub const CONFIG_ATH12K_MODULE: u32 = 1;
pub const CONFIG_OCTEON_EP_VF_MODULE: u32 = 1;
pub const CONFIG_CAN_BCM_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_MAX77620: u32 = 1;
pub const CONFIG_PAC1921_MODULE: u32 = 1;
pub const CONFIG_SPI_MICROCHIP_CORE_QSPI_MODULE: u32 = 1;
pub const CONFIG_SCSI_SYM53C8XX_DMA_ADDRESSING_MODE: u32 = 1;
pub const CONFIG_SND_SOC_RK3328_MODULE: u32 = 1;
pub const CONFIG_SENSORS_TMP421_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_MARS_MODULE: u32 = 1;
pub const CONFIG_IP_ROUTE_CLASSID: u32 = 1;
pub const CONFIG_ST_UVIS25_I2C_MODULE: u32 = 1;
pub const CONFIG_VIDEO_VIVID_OSD: u32 = 1;
pub const CONFIG_RPMSG_MODULE: u32 = 1;
pub const CONFIG_SERIAL_XILINX_PS_UART: u32 = 1;
pub const CONFIG_FM10K_MODULE: u32 = 1;
pub const CONFIG_DEVMEM: u32 = 1;
pub const CONFIG_REGULATOR_RK808_MODULE: u32 = 1;
pub const CONFIG_SENSORS_ADS7871_MODULE: u32 = 1;
pub const CONFIG_USBIP_HOST_MODULE: u32 = 1;
pub const CONFIG_BACKLIGHT_GPIO_MODULE: u32 = 1;
pub const CONFIG_VIDEO_IMX214_MODULE: u32 = 1;
pub const CONFIG_USB_GADGET_VBUS_DRAW: u32 = 100;
pub const CONFIG_NETFILTER_XT_CONNMARK_MODULE: u32 = 1;
pub const CONFIG_NFS_V4_SECURITY_LABEL: u32 = 1;
pub const CONFIG_ISCSI_IBFT_MODULE: u32 = 1;
pub const CONFIG_KEXEC_CORE: u32 = 1;
pub const CONFIG_MFD_BD9571MWV_MODULE: u32 = 1;
pub const CONFIG_NET_9P_FD_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_TDA18218_MODULE: u32 = 1;
pub const CONFIG_VIDEO_DS90UB913_MODULE: u32 = 1;
pub const CONFIG_DVB_DRXD_MODULE: u32 = 1;
pub const CONFIG_LSM: &[u8; 49] = b"lockdown,yama,integrity,selinux,bpf,landlock,ipe\0";
pub const CONFIG_INTERCONNECT_QCOM_SC8180X_MODULE: u32 = 1;
pub const CONFIG_SND_HDA_EXT_CORE_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_PKEYS: u32 = 1;
pub const CONFIG_BMC150_ACCEL_I2C_MODULE: u32 = 1;
pub const CONFIG_TEGRA_HOST1X_FIREWALL: u32 = 1;
pub const CONFIG_GPIO_MAX77620: u32 = 1;
pub const CONFIG_HID_RETRODE_MODULE: u32 = 1;
pub const CONFIG_I2C_MESON_MODULE: u32 = 1;
pub const CONFIG_USB_NET_MCS7830_MODULE: u32 = 1;
pub const CONFIG_GNSS_USB_MODULE: u32 = 1;
pub const CONFIG_FB_CFB_COPYAREA: u32 = 1;
pub const CONFIG_CRYPTO_ALGAPI: u32 = 1;
pub const CONFIG_KVM_XFER_TO_GUEST_WORK: u32 = 1;
pub const CONFIG_DWMAC_SUNXI_MODULE: u32 = 1;
pub const CONFIG_ICP10100_MODULE: u32 = 1;
pub const CONFIG_DYNAMIC_EVENTS: u32 = 1;
pub const CONFIG_HTU21_MODULE: u32 = 1;
pub const CONFIG_SND_PCXHR_MODULE: u32 = 1;
pub const CONFIG_DWMAC_MESON_MODULE: u32 = 1;
pub const CONFIG_CLONE_BACKWARDS: u32 = 1;
pub const CONFIG_SND_SOC_TLV320AIC23_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_ORISETECH_OTM8009A_MODULE: u32 = 1;
pub const CONFIG_SERIAL_EARLYCON: u32 = 1;
pub const CONFIG_RTC_DRV_M41T94_MODULE: u32 = 1;
pub const CONFIG_NF_NAT_IRC_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_SAMSUNG_DB7430_MODULE: u32 = 1;
pub const CONFIG_GET_FREE_REGION: u32 = 1;
pub const CONFIG_USB_F_HID_MODULE: u32 = 1;
pub const CONFIG_AD5770R_MODULE: u32 = 1;
pub const CONFIG_DEVPORT: u32 = 1;
pub const CONFIG_SPI_ALTERA_CORE_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_HKDF: u32 = 1;
pub const CONFIG_MFD_INTEL_M10_BMC_CORE_MODULE: u32 = 1;
pub const CONFIG_USB: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_CT_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_1542419: u32 = 1;
pub const CONFIG_SCTP_COOKIE_HMAC_SHA1: u32 = 1;
pub const CONFIG_ARCH_VEXPRESS: u32 = 1;
pub const CONFIG_DRM_PANEL_JDI_LPM102A188A_MODULE: u32 = 1;
pub const CONFIG_ELF_CORE: u32 = 1;
pub const CONFIG_OMAP_DM_TIMER: u32 = 1;
pub const CONFIG_PCI_HOST_COMMON: u32 = 1;
pub const CONFIG_TASK_DELAY_ACCT: u32 = 1;
pub const CONFIG_F2FS_FS_XATTR: u32 = 1;
pub const CONFIG_DVB_ATBM8830_MODULE: u32 = 1;
pub const CONFIG_SERIAL_FSL_LPUART: u32 = 1;
pub const CONFIG_DM_DELAY_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_FSL_CAAM_PKC_API: u32 = 1;
pub const CONFIG_SCSI_QLOGIC_1280_MODULE: u32 = 1;
pub const CONFIG_DVB_PLL_MODULE: u32 = 1;
pub const CONFIG_THERMAL: u32 = 1;
pub const CONFIG_SPI_AX88796C_COMPRESSION: u32 = 1;
pub const CONFIG_NFC_ST21NFCA_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_AES_ARM64_CE: u32 = 1;
pub const CONFIG_SI7020_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_BPF_LINK: u32 = 1;
pub const CONFIG_CRYPTO_DEV_FSL_CAAM_CRYPTO_API_QI: u32 = 1;
pub const CONFIG_SND_BCM2835_MODULE: u32 = 1;
pub const CONFIG_DVB_LG2160_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_SY8106A_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_DLINK: u32 = 1;
pub const CONFIG_IP_SET_HASH_IPPORTNET_MODULE: u32 = 1;
pub const CONFIG_HISILICON_IRQ_MBIGEN: u32 = 1;
pub const CONFIG_I2C_MUX_MLXCPLD_MODULE: u32 = 1;
pub const CONFIG_PPPOE_HASH_BITS: u32 = 4;
pub const CONFIG_CAN_EMS_USB_MODULE: u32 = 1;
pub const CONFIG_FTRACE_SYSCALLS: u32 = 1;
pub const CONFIG_NET_TEAM_MODE_ROUNDROBIN_MODULE: u32 = 1;
pub const CONFIG_CAN_VXCAN_MODULE: u32 = 1;
pub const CONFIG_ARM_TSTEE_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_NOVA_T_USB2_MODULE: u32 = 1;
pub const CONFIG_SENSORS_LTC4245_MODULE: u32 = 1;
pub const CONFIG_QCOM_WCNSS_PIL_MODULE: u32 = 1;
pub const CONFIG_VIDEO_TI_CAL_MODULE: u32 = 1;
pub const CONFIG_UCSI_STM32G0_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_MD5: u32 = 1;
pub const CONFIG_SND_DRIVERS: u32 = 1;
pub const CONFIG_REGULATOR_FAN53555: u32 = 1;
pub const CONFIG_PACKING_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_IIO_KX022A_SPI_MODULE: u32 = 1;
pub const CONFIG_SND_AC97_POWER_SAVE_DEFAULT: u32 = 0;
pub const CONFIG_INPUT_CMA3000_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_CXUSB_ANALOG: u32 = 1;
pub const CONFIG_SMSC9420_MODULE: u32 = 1;
pub const CONFIG_ATH6KL_MODULE: u32 = 1;
pub const CONFIG_ATH9K_HTC_MODULE: u32 = 1;
pub const CONFIG_DM_AUDIT: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_POLICY_MODULE: u32 = 1;
pub const CONFIG_XZ_DEC_X86: u32 = 1;
pub const CONFIG_SND_HDA_HWDEP: u32 = 1;
pub const CONFIG_VT_CONSOLE_SLEEP: u32 = 1;
pub const CONFIG_NLS_KOI8_U_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_SOCIONEXT: u32 = 1;
pub const CONFIG_PINCTRL_SUN50I_H6: u32 = 1;
pub const CONFIG_SCSI_SPI_ATTRS_MODULE: u32 = 1;
pub const CONFIG_RUSTC_VERSION: u32 = 108600;
pub const CONFIG_CRYPTO_SERPENT_MODULE: u32 = 1;
pub const CONFIG_MTD_BLKDEVS_MODULE: u32 = 1;
pub const CONFIG_SENSORS_NZXT_KRAKEN3_MODULE: u32 = 1;
pub const CONFIG_MCP4018_MODULE: u32 = 1;
pub const CONFIG_HTE_TEGRA194_MODULE: u32 = 1;
pub const CONFIG_DEBUG_KERNEL: u32 = 1;
pub const CONFIG_MMC_SDHCI_MSM_MODULE: u32 = 1;
pub const CONFIG_ARM_FFA_SMCCC: u32 = 1;
pub const CONFIG_RCU_NOCB_CPU: u32 = 1;
pub const CONFIG_SURFACE_HOTPLUG_MODULE: u32 = 1;
pub const CONFIG_ASYNC_TX_DMA: u32 = 1;
pub const CONFIG_SND_SOC_PCM512x_I2C_MODULE: u32 = 1;
pub const CONFIG_AS_HAS_MOPS: u32 = 1;
pub const CONFIG_CRYPTO_DEV_QCOM_RNG_MODULE: u32 = 1;
pub const CONFIG_DRM_XE_DP_TUNNEL: u32 = 1;
pub const CONFIG_SCSI_QLA_ISCSI_MODULE: u32 = 1;
pub const CONFIG_NVME_TARGET_PASSTHRU: u32 = 1;
pub const CONFIG_CAN_M_CAN_MODULE: u32 = 1;
pub const CONFIG_MOUSE_ELAN_I2C_SMBUS: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA210_OPE_MODULE: u32 = 1;
pub const CONFIG_CEC_CORE_MODULE: u32 = 1;
pub const CONFIG_BATTERY_MAX17040_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_EFI: u32 = 1;
pub const CONFIG_WLAN_VENDOR_TI: u32 = 1;
pub const CONFIG_EEPROM_93CX6_MODULE: u32 = 1;
pub const CONFIG_VIDEOBUF2_CORE_MODULE: u32 = 1;
pub const CONFIG_DRM_TOSHIBA_TC358775_MODULE: u32 = 1;
pub const CONFIG_ATM_CLIP_MODULE: u32 = 1;
pub const CONFIG_ARMADA_37XX_RWTM_MBOX_MODULE: u32 = 1;
pub const CONFIG_PCIE_EDR: u32 = 1;
pub const CONFIG_USB_SERIAL_DEBUG_MODULE: u32 = 1;
pub const CONFIG_HID_VIEWSONIC_MODULE: u32 = 1;
pub const CONFIG_MISC_FILESYSTEMS: u32 = 1;
pub const CONFIG_QUOTA_TREE: u32 = 1;
pub const CONFIG_NFT_FIB_MODULE: u32 = 1;
pub const CONFIG_SM_DISPCC_6115_MODULE: u32 = 1;
pub const CONFIG_CROS_EC_RPMSG_MODULE: u32 = 1;
pub const CONFIG_NET_DSA_REALTEK_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_GHASH: u32 = 1;
pub const CONFIG_MDIO_BITBANG_MODULE: u32 = 1;
pub const CONFIG_NET_ACT_TUNNEL_KEY_MODULE: u32 = 1;
pub const CONFIG_CGROUP_RDMA: u32 = 1;
pub const CONFIG_DP83TD510_PHY_MODULE: u32 = 1;
pub const CONFIG_INOTIFY_USER: u32 = 1;
pub const CONFIG_DVB_CX22702_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_VICAM_MODULE: u32 = 1;
pub const CONFIG_IMX_REMOTEPROC_MODULE: u32 = 1;
pub const CONFIG_NLS_ISO8859_7_MODULE: u32 = 1;
pub const CONFIG_ALTERA_MSGDMA_MODULE: u32 = 1;
pub const CONFIG_SYSC_R8A774A1: u32 = 1;
pub const CONFIG_SENSORS_LTC2947_SPI_MODULE: u32 = 1;
pub const CONFIG_PHYLIB: u32 = 1;
pub const CONFIG_HIBMCGE_MODULE: u32 = 1;
pub const CONFIG_FAT_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_B43_HWRNG: u32 = 1;
pub const CONFIG_SLUB_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_DVB_GP8PSK_FE_MODULE: u32 = 1;
pub const CONFIG_SPI_MUX_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_GIGANTIC_PAGE: u32 = 1;
pub const CONFIG_PCI_BRIDGE_EMUL: u32 = 1;
pub const CONFIG_PINCTRL_AC5: u32 = 1;
pub const CONFIG_FPGA_DFL_FME_REGION_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TLV320ADCX140_MODULE: u32 = 1;
pub const CONFIG_DEV_DAX_HMEM_MODULE: u32 = 1;
pub const CONFIG_NET_EMATCH_IPT_MODULE: u32 = 1;
pub const CONFIG_USB_MICROTEK_MODULE: u32 = 1;
pub const CONFIG_HDMI: u32 = 1;
pub const CONFIG_ARCH_USES_PG_ARCH_3: u32 = 1;
pub const CONFIG_SND_SOC_RT5659_MODULE: u32 = 1;
pub const CONFIG_NET_UDP_TUNNEL_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_USB_COMPOSITE_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_WM8804_I2C_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_DIB3000MC_MODULE: u32 = 1;
pub const CONFIG_DRM_GM12U320_MODULE: u32 = 1;
pub const CONFIG_RTW88_8822CS_MODULE: u32 = 1;
pub const CONFIG_NET_DSA_TAG_RTL8_4_MODULE: u32 = 1;
pub const CONFIG_USB_DWC3_OF_SIMPLE_MODULE: u32 = 1;
pub const CONFIG_INPUT_TABLET: u32 = 1;
pub const CONFIG_V4L_PLATFORM_DRIVERS: u32 = 1;
pub const CONFIG_NCSI_OEM_CMD_GET_MAC: u32 = 1;
pub const CONFIG_MAXIM_THERMOCOUPLE_MODULE: u32 = 1;
pub const CONFIG_PPPOE_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_FSL_UTILS_MODULE: u32 = 1;
pub const CONFIG_LIBERTAS_THINFIRM_MODULE: u32 = 1;
pub const CONFIG_DP83867_PHY_MODULE: u32 = 1;
pub const CONFIG_XILINX_GMII2RGMII_MODULE: u32 = 1;
pub const CONFIG_SYSFB_SIMPLEFB: u32 = 1;
pub const CONFIG_TRANSPARENT_HUGEPAGE_MADVISE: u32 = 1;
pub const CONFIG_CAN_GS_USB_MODULE: u32 = 1;
pub const CONFIG_HAVE_DYNAMIC_FTRACE_WITH_ARGS: u32 = 1;
pub const CONFIG_TEST_HMM_MODULE: u32 = 1;
pub const CONFIG_BITFIELD_KUNIT_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_SYSCALL_WRAPPER: u32 = 1;
pub const CONFIG_WLAN_VENDOR_QUANTENNA: u32 = 1;
pub const CONFIG_USB_OTG_FSM_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_X1E80100_MODULE: u32 = 1;
pub const CONFIG_REED_SOLOMON_MODULE: u32 = 1;
pub const CONFIG_HAVE_ARCH_MMAP_RND_COMPAT_BITS: u32 = 1;
pub const CONFIG_FAT_DEFAULT_CODEPAGE: u32 = 437;
pub const CONFIG_COMMON_CLK_HI6220: u32 = 1;
pub const CONFIG_DMA_COHERENT_POOL: u32 = 1;
pub const CONFIG_RDMA_SIW_MODULE: u32 = 1;
pub const CONFIG_SCSI_UFS_BSG: u32 = 1;
pub const CONFIG_VIDEO_OV01A10_MODULE: u32 = 1;
pub const CONFIG_RMI4_2D_SENSOR: u32 = 1;
pub const CONFIG_SENSORS_LM25066_MODULE: u32 = 1;
pub const CONFIG_MMC_REALTEK_PCI_MODULE: u32 = 1;
pub const CONFIG_SENSORS_PC87360_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_EDP_MODULE: u32 = 1;
pub const CONFIG_HYPERV_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_ARM_SCMI: u32 = 1;
pub const CONFIG_SND_SOC_FSL_SPDIF_MODULE: u32 = 1;
pub const CONFIG_DRM_POWERVR_MODULE: u32 = 1;
pub const CONFIG_NLATTR: u32 = 1;
pub const CONFIG_TI_LMP92064_MODULE: u32 = 1;
pub const CONFIG_SIPHASH_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_SUNRPC_XPRT_RDMA_MODULE: u32 = 1;
pub const CONFIG_DVB_SI21XX_MODULE: u32 = 1;
pub const CONFIG_SLAB_BUCKETS: u32 = 1;
pub const CONFIG_SND_SOC_QDSP6_ASM_DAI_MODULE: u32 = 1;
pub const CONFIG_ACPI_PCI_SLOT: u32 = 1;
pub const CONFIG_PDC_ADMA_MODULE: u32 = 1;
pub const CONFIG_RT2800PCI_RT3290: u32 = 1;
pub const CONFIG_HAVE_GUP_FAST: u32 = 1;
pub const CONFIG_SENSORS_Q54SJ108A2_MODULE: u32 = 1;
pub const CONFIG_MLX4_EN_DCB: u32 = 1;
pub const CONFIG_ARM64_MTE: u32 = 1;
pub const CONFIG_NFT_REJECT_INET_MODULE: u32 = 1;
pub const CONFIG_SND_OXYGEN_LIB_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_MAX8893_MODULE: u32 = 1;
pub const CONFIG_CORDIC_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_SMA1307_MODULE: u32 = 1;
pub const CONFIG_ADXL372_SPI_MODULE: u32 = 1;
pub const CONFIG_ARM_SCMI_HAVE_TRANSPORT: u32 = 1;
pub const CONFIG_RTC_DRV_M48T35_MODULE: u32 = 1;
pub const CONFIG_NUMA_BALANCING_DEFAULT_ENABLED: u32 = 1;
pub const CONFIG_RESET_QCOM_AOSS: u32 = 1;
pub const CONFIG_SCHED_MC: u32 = 1;
pub const CONFIG_HYPERV_KEYBOARD_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_PCF2127_MODULE: u32 = 1;
pub const CONFIG_TCP_CONG_ADVANCED: u32 = 1;
pub const CONFIG_CEPH_FS_SECURITY_LABEL: u32 = 1;
pub const CONFIG_REGULATOR_TPS62360_MODULE: u32 = 1;
pub const CONFIG_INTEGRITY_CA_MACHINE_KEYRING_MAX: u32 = 1;
pub const CONFIG_MLX5_TC_CT: u32 = 1;
pub const CONFIG_ARCH_HAS_CC_PLATFORM: u32 = 1;
pub const CONFIG_SND_SOC_RT5682_MODULE: u32 = 1;
pub const CONFIG_USB_KAWETH_MODULE: u32 = 1;
pub const CONFIG_USB_NET_CDC_MBIM_MODULE: u32 = 1;
pub const CONFIG_SENSORS_LM90_MODULE: u32 = 1;
pub const CONFIG_JOYSTICK_QWIIC_MODULE: u32 = 1;
pub const CONFIG_MCTP_TRANSPORT_USB_MODULE: u32 = 1;
pub const CONFIG_CHROMEOS_PRIVACY_SCREEN_MODULE: u32 = 1;
pub const CONFIG_BCM_SBA_RAID_MODULE: u32 = 1;
pub const CONFIG_MMU_NOTIFIER: u32 = 1;
pub const CONFIG_DRM_PANEL_ELIDA_KD35T133_MODULE: u32 = 1;
pub const CONFIG_NFT_REJECT_NETDEV_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_CAMELLIA_MODULE: u32 = 1;
pub const CONFIG_HID_GFRM_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_M41T93_MODULE: u32 = 1;
pub const CONFIG_AD4851_MODULE: u32 = 1;
pub const CONFIG_MEDIA_USB_SUPPORT: u32 = 1;
pub const CONFIG_INTERCONNECT_QCOM_SM8250_MODULE: u32 = 1;
pub const CONFIG_PCIE_KIRIN: u32 = 1;
pub const CONFIG_FSL_FMAN_MODULE: u32 = 1;
pub const CONFIG_MOUSE_ELAN_I2C_MODULE: u32 = 1;
pub const CONFIG_RTLWIFI_MODULE: u32 = 1;
pub const CONFIG_HAVE_EBPF_JIT: u32 = 1;
pub const CONFIG_USB_SERIAL_EMPEG_MODULE: u32 = 1;
pub const CONFIG_NET_ACT_MIRRED_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_WANGXUN: u32 = 1;
pub const CONFIG_INTEGRITY: u32 = 1;
pub const CONFIG_PM_OPP: u32 = 1;
pub const CONFIG_RFS_ACCEL: u32 = 1;
pub const CONFIG_SM_DISPCC_7150_MODULE: u32 = 1;
pub const CONFIG_SCSI_MPT3SAS_MODULE: u32 = 1;
pub const CONFIG_YAM_MODULE: u32 = 1;
pub const CONFIG_KALLSYMS: u32 = 1;
pub const CONFIG_SPI_TEGRA114_MODULE: u32 = 1;
pub const CONFIG_INPUT_AXP20X_PEK_MODULE: u32 = 1;
pub const CONFIG_LEDS_TRIGGER_ACTIVITY_MODULE: u32 = 1;
pub const CONFIG_HID_PLANTRONICS_MODULE: u32 = 1;
pub const CONFIG_HID_SEMITEK_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_RT4831_MODULE: u32 = 1;
pub const CONFIG_SMS_SIANO_MDTV_MODULE: u32 = 1;
pub const CONFIG_INPUT_E3X0_BUTTON_MODULE: u32 = 1;
pub const CONFIG_MDIO_BUS: u32 = 1;
pub const CONFIG_ARM64_WORKAROUND_SPECULATIVE_UNPRIV_LOAD: u32 = 1;
pub const CONFIG_NVMEM_LAYOUTS: u32 = 1;
pub const CONFIG_LEDS_LM3532_MODULE: u32 = 1;
pub const CONFIG_SPI_QUP_MODULE: u32 = 1;
pub const CONFIG_SCSI_MOD: u32 = 1;
pub const CONFIG_SND_SEQ_UMP_CLIENT_MODULE: u32 = 1;
pub const CONFIG_ZSMALLOC_CHAIN_SIZE: u32 = 8;
pub const CONFIG_CUSE_MODULE: u32 = 1;
pub const CONFIG_IIO_MODULE: u32 = 1;
pub const CONFIG_ATH9K_HW_MODULE: u32 = 1;
pub const CONFIG_FUNCTION_GRAPH_TRACER: u32 = 1;
pub const CONFIG_GPIO_MXC_MODULE: u32 = 1;
pub const CONFIG_BCMA_DRIVER_GPIO: u32 = 1;
pub const CONFIG_COMMON_CLK_HI3559A: u32 = 1;
pub const CONFIG_DVB_BUDGET_CI_MODULE: u32 = 1;
pub const CONFIG_DRM_SUN6I_DSI_MODULE: u32 = 1;
pub const CONFIG_I2C_HELPER_AUTO: u32 = 1;
pub const CONFIG_HZ: u32 = 1000;
pub const CONFIG_TRACING: u32 = 1;
pub const CONFIG_ACPI: u32 = 1;
pub const CONFIG_HAMRADIO: u32 = 1;
pub const CONFIG_ARCH_USE_QUEUED_SPINLOCKS: u32 = 1;
pub const CONFIG_MLX5_TC_SAMPLE: u32 = 1;
pub const CONFIG_IWLWIFI_LEDS: u32 = 1;
pub const CONFIG_CHECKPOINT_RESTORE: u32 = 1;
pub const CONFIG_BLK_DEV_DM: u32 = 1;
pub const CONFIG_ICE_HWMON: u32 = 1;
pub const CONFIG_NF_CONNTRACK_LABELS: u32 = 1;
pub const CONFIG_NETFILTER_NETLINK_OSF_MODULE: u32 = 1;
pub const CONFIG_KVM_COMMON: u32 = 1;
pub const CONFIG_W1_SLAVE_DS2406_MODULE: u32 = 1;
pub const CONFIG_RUNTIME_TESTING_MENU: u32 = 1;
pub const CONFIG_SENSORS_ISL29018_MODULE: u32 = 1;
pub const CONFIG_RTW88_PCI_MODULE: u32 = 1;
pub const CONFIG_VIRTUALIZATION: u32 = 1;
pub const CONFIG_MFD_VX855_MODULE: u32 = 1;
pub const CONFIG_EDAC_LEGACY_SYSFS: u32 = 1;
pub const CONFIG_USB_SERIAL_NAVMAN_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CS40L50_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_IMX_SCMI: u32 = 1;
pub const CONFIG_CHELSIO_T4_MODULE: u32 = 1;
pub const CONFIG_DRM_RADEON_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_AZ6027_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_SUN50I_H5: u32 = 1;
pub const CONFIG_NET_CLS_FLOWER_MODULE: u32 = 1;
pub const CONFIG_PLATFORM_MHU_MODULE: u32 = 1;
pub const CONFIG_DVB_MT312_MODULE: u32 = 1;
pub const CONFIG_VIDEO_IMX_MIPI_CSIS_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_IQS5XX_MODULE: u32 = 1;
pub const CONFIG_ARM_TEGRA186_CPUFREQ_MODULE: u32 = 1;
pub const CONFIG_TASKSTATS: u32 = 1;
pub const CONFIG_TARGET_CORE_MODULE: u32 = 1;
pub const CONFIG_USB_CONFIGFS_F_FS: u32 = 1;
pub const CONFIG_NFT_FIB_NETDEV_MODULE: u32 = 1;
pub const CONFIG_IP6_NF_TARGET_MASQUERADE_MODULE: u32 = 1;
pub const CONFIG_RING_BUFFER_BENCHMARK_MODULE: u32 = 1;
pub const CONFIG_IDPF_SINGLEQ: u32 = 1;
pub const CONFIG_IIO_RESCALE_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_PTDUMP: u32 = 1;
pub const CONFIG_SND_MIA_MODULE: u32 = 1;
pub const CONFIG_VIDEO_IMX258_MODULE: u32 = 1;
pub const CONFIG_MDIO_REGMAP_MODULE: u32 = 1;
pub const CONFIG_MVPP2_PTP: u32 = 1;
pub const CONFIG_CXL_REGION: u32 = 1;
pub const CONFIG_SDM_LPASSCC_845_MODULE: u32 = 1;
pub const CONFIG_DRM_DW_MIPI_DSI2_MODULE: u32 = 1;
pub const CONFIG_ZONEFS_FS_MODULE: u32 = 1;
pub const CONFIG_MT76_CORE_MODULE: u32 = 1;
pub const CONFIG_MTDRAM_ERASE_SIZE: u32 = 128;
pub const CONFIG_DYNAMIC_FTRACE_WITH_ARGS: u32 = 1;
pub const CONFIG_SENSORS_MR75203_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_AUDIT_MODULE: u32 = 1;
pub const CONFIG_ATH9K_DEBUGFS: u32 = 1;
pub const CONFIG_CXL_PORT_MODULE: u32 = 1;
pub const CONFIG_SMPRO_ERRMON_MODULE: u32 = 1;
pub const CONFIG_OPENVSWITCH_MODULE: u32 = 1;
pub const CONFIG_PHY_RCAR_GEN3_USB2_MODULE: u32 = 1;
pub const CONFIG_MFD_MAX5970_MODULE: u32 = 1;
pub const CONFIG_ACPI_FFH: u32 = 1;
pub const CONFIG_QLCNIC_DCB: u32 = 1;
pub const CONFIG_IPV6_SIT_MODULE: u32 = 1;
pub const CONFIG_RT2800_LIB_MMIO_MODULE: u32 = 1;
pub const CONFIG_DWMAC_IPQ806X_MODULE: u32 = 1;
pub const CONFIG_DMABUF_HEAPS: u32 = 1;
pub const CONFIG_SND_SOC_RT5645_MODULE: u32 = 1;
pub const CONFIG_STE10XP_MODULE: u32 = 1;
pub const CONFIG_FS_POSIX_ACL: u32 = 1;
pub const CONFIG_DVB_CX24110_MODULE: u32 = 1;
pub const CONFIG_VIDEO_I2C_MODULE: u32 = 1;
pub const CONFIG_BLK_DEV_RAM_COUNT: u32 = 16;
pub const CONFIG_INTERVAL_TREE_SPAN_ITER: u32 = 1;
pub const CONFIG_MESON_WATCHDOG_MODULE: u32 = 1;
pub const CONFIG_NLS_ISO8859_6_MODULE: u32 = 1;
pub const CONFIG_USB_STORAGE_USBAT_MODULE: u32 = 1;
pub const CONFIG_MFD_VEXPRESS_SYSREG: u32 = 1;
pub const CONFIG_SENSORS_ADC128D818_MODULE: u32 = 1;
pub const CONFIG_RTW88_8821AU_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_DSCP_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_SQ905C_MODULE: u32 = 1;
pub const CONFIG_MT7921U_MODULE: u32 = 1;
pub const CONFIG_DRM_XE_MODULE: u32 = 1;
pub const CONFIG_INET_RAW_DIAG: u32 = 1;
pub const CONFIG_CRYPTO_DEV_ROCKCHIP_MODULE: u32 = 1;
pub const CONFIG_DVB_TDA10086_MODULE: u32 = 1;
pub const CONFIG_POWER_RESET_VEXPRESS: u32 = 1;
pub const CONFIG_MXC_CLK_SCU: u32 = 1;
pub const CONFIG_VIDEO_RZG2L_CRU_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_QCOM_MODULE: u32 = 1;
pub const CONFIG_ARMADA_37XX_CLK: u32 = 1;
pub const CONFIG_DW_WATCHDOG_MODULE: u32 = 1;
pub const CONFIG_VALIDATE_FS_PARSER: u32 = 1;
pub const CONFIG_IR_IMON_MODULE: u32 = 1;
pub const CONFIG_SLIP_COMPRESSED: u32 = 1;
pub const CONFIG_DRM_VMWGFX_MODULE: u32 = 1;
pub const CONFIG_PREEMPTION: u32 = 1;
pub const CONFIG_BINARY_PRINTF: u32 = 1;
pub const CONFIG_SND_SOC_PCM3060_SPI_MODULE: u32 = 1;
pub const CONFIG_PL330_DMA_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_QDSP6_AFE_CLOCKS_MODULE: u32 = 1;
pub const CONFIG_DRM_CDNS_DSI_MODULE: u32 = 1;
pub const CONFIG_TIGON3_HWMON: u32 = 1;
pub const CONFIG_HAVE_ARCH_KCSAN: u32 = 1;
pub const CONFIG_HAVE_PERF_EVENTS_NMI: u32 = 1;
pub const CONFIG_PCIE_QCOM: u32 = 1;
pub const CONFIG_VIDEO_RDACM20_MODULE: u32 = 1;
pub const CONFIG_HAVE_ARCH_KASAN_SW_TAGS: u32 = 1;
pub const CONFIG_QCOM_TZMEM: u32 = 1;
pub const CONFIG_MFD_CORE: u32 = 1;
pub const CONFIG_PVPANIC_PCI_MODULE: u32 = 1;
pub const CONFIG_TRACE_IRQFLAGS_SUPPORT: u32 = 1;
pub const CONFIG_MTD_SPI_NAND_MODULE: u32 = 1;
pub const CONFIG_CORESIGHT_TPDA_MODULE: u32 = 1;
pub const CONFIG_IR_MESON_MODULE: u32 = 1;
pub const CONFIG_IPVLAN_L3S: u32 = 1;
pub const CONFIG_CRYPTO_XXHASH: u32 = 1;
pub const CONFIG_SENSORS_NCT7363_MODULE: u32 = 1;
pub const CONFIG_IR_SHARP_DECODER_MODULE: u32 = 1;
pub const CONFIG_PRP_DUP_DISCARD_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_TIMERFD: u32 = 1;
pub const CONFIG_RTC_HCTOSYS_DEVICE: &[u8; 5] = b"rtc0\0";
pub const CONFIG_SND_SOC_LPASS_WSA_MACRO_MODULE: u32 = 1;
pub const CONFIG_SND_USB_POD_MODULE: u32 = 1;
pub const CONFIG_UFS_FS_MODULE: u32 = 1;
pub const CONFIG_USB_STORAGE_FREECOM_MODULE: u32 = 1;
pub const CONFIG_DRM_SSD130X_MODULE: u32 = 1;
pub const CONFIG_IIO_ST_LSM6DSX_I3C_MODULE: u32 = 1;
pub const CONFIG_SENSORS_W83627HF_MODULE: u32 = 1;
pub const CONFIG_PREEMPT_VOLUNTARY: u32 = 1;
pub const CONFIG_GENERIC_VDSO_TIME_NS: u32 = 1;
pub const CONFIG_KEYS_REQUEST_CACHE: u32 = 1;
pub const CONFIG_MLX5_VFIO_PCI_MODULE: u32 = 1;
pub const CONFIG_SERIAL_MVEBU_UART: u32 = 1;
pub const CONFIG_SND_SOC_NTP8835_MODULE: u32 = 1;
pub const CONFIG_SND_JACK_INPUT_DEV: u32 = 1;
pub const CONFIG_JFFS2_FS_MODULE: u32 = 1;
pub const CONFIG_IRQ_MSI_IOMMU: u32 = 1;
pub const CONFIG_COMMON_CLK_MESON_PLL: u32 = 1;
pub const CONFIG_DRM_CLIENT_SETUP: u32 = 1;
pub const CONFIG_NET_VENDOR_MYRI: u32 = 1;
pub const CONFIG_FSL_PQ_MDIO_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_META: u32 = 1;
pub const CONFIG_NET_TEAM_MODE_LOADBALANCE_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_ARK3116_MODULE: u32 = 1;
pub const CONFIG_SECURITY_PATH: u32 = 1;
pub const CONFIG_HID_SUNPLUS_MODULE: u32 = 1;
pub const CONFIG_PHY_TEGRA_XUSB_MODULE: u32 = 1;
pub const CONFIG_NET_IFE_SKBMARK_MODULE: u32 = 1;
pub const CONFIG_USB_OTG: u32 = 1;
pub const CONFIG_QCOM_SPM: u32 = 1;
pub const CONFIG_UCLAMP_BUCKETS_COUNT: u32 = 5;
pub const CONFIG_MCP3422_MODULE: u32 = 1;
pub const CONFIG_VIDEO_ADV7183_MODULE: u32 = 1;
pub const CONFIG_NF_NAT_SNMP_BASIC_MODULE: u32 = 1;
pub const CONFIG_ZPOOL: u32 = 1;
pub const CONFIG_COMMON_CLK_C3_PERIPHERALS: u32 = 1;
pub const CONFIG_SND_EMU10K1_SEQ_MODULE: u32 = 1;
pub const CONFIG_VMCORE_INFO: u32 = 1;
pub const CONFIG_CAN_MCBA_USB_MODULE: u32 = 1;
pub const CONFIG_SND_KORG1212_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_MIPI_DBI_MODULE: u32 = 1;
pub const CONFIG_DLM_DEBUG: u32 = 1;
pub const CONFIG_GPIO_XGENE: u32 = 1;
pub const CONFIG_ARM64_HAFT: u32 = 1;
pub const CONFIG_ARM_MHU_MODULE: u32 = 1;
pub const CONFIG_USB_NET_CH9200_MODULE: u32 = 1;
pub const CONFIG_USB_SI470X_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CS35L56_SHARED_MODULE: u32 = 1;
pub const CONFIG_NFT_FWD_NETDEV_MODULE: u32 = 1;
pub const CONFIG_AD5766_MODULE: u32 = 1;
pub const CONFIG_FB_CORE: u32 = 1;
pub const CONFIG_CRYPTO_JITTERENTROPY_MEMSIZE_2: u32 = 1;
pub const CONFIG_VIDEO_HANTRO_HEVC_RFC: u32 = 1;
pub const CONFIG_REGULATOR_HI6421V530_MODULE: u32 = 1;
pub const CONFIG_INPUT_88PM886_ONKEY_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_MESON_S4: u32 = 1;
pub const CONFIG_DRM_GEM_DMA_HELPER_MODULE: u32 = 1;
pub const CONFIG_SENSORS_LM93_MODULE: u32 = 1;
pub const CONFIG_IRQ_DOMAIN: u32 = 1;
pub const CONFIG_HID_ELO_MODULE: u32 = 1;
pub const CONFIG_ARM_TIMER_SP804: u32 = 1;
pub const CONFIG_HAVE_KERNEL_GZIP: u32 = 1;
pub const CONFIG_PROBE_EVENTS: u32 = 1;
pub const CONFIG_BPF_JIT_ALWAYS_ON: u32 = 1;
pub const CONFIG_LDISC_AUTOLOAD: u32 = 1;
pub const CONFIG_ARM_SPE_PMU_MODULE: u32 = 1;
pub const CONFIG_DYNAMIC_DEBUG_CORE: u32 = 1;
pub const CONFIG_XDP_SOCKETS_DIAG_MODULE: u32 = 1;
pub const CONFIG_PCI_PRI: u32 = 1;
pub const CONFIG_PINCTRL_AMLOGIC_T7: u32 = 1;
pub const CONFIG_ADXL313_SPI_MODULE: u32 = 1;
pub const CONFIG_SIS190_MODULE: u32 = 1;
pub const CONFIG_DEVICE_PRIVATE: u32 = 1;
pub const CONFIG_CRYPTO_AKCIPHER2: u32 = 1;
pub const CONFIG_WATCHDOG_HANDLE_BOOT_ENABLED: u32 = 1;
pub const CONFIG_VIDEO_SUNXI: u32 = 1;
pub const CONFIG_NF_NAT_REDIRECT: u32 = 1;
pub const CONFIG_GPIO_TPIC2810_MODULE: u32 = 1;
pub const CONFIG_SECURITY_SELINUX_SIDTAB_HASH_BITS: u32 = 9;
pub const CONFIG_TI_DAVINCI_MDIO_MODULE: u32 = 1;
pub const CONFIG_SWIOTLB: u32 = 1;
pub const CONFIG_SENSORS_SMSC47B397_MODULE: u32 = 1;
pub const CONFIG_SCHED_AUTOGROUP: u32 = 1;
pub const CONFIG_IGC_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_SUN50I_A100: u32 = 1;
pub const CONFIG_IP_VS_SH_MODULE: u32 = 1;
pub const CONFIG_USB_XHCI_DBGCAP: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_CPU_MODULE: u32 = 1;
pub const CONFIG_HAVE_ARCH_HUGE_VMALLOC: u32 = 1;
pub const CONFIG_DRM_PANEL_VISIONOX_RM692E5_MODULE: u32 = 1;
pub const CONFIG_DEVFREQ_GOV_USERSPACE_MODULE: u32 = 1;
pub const CONFIG_MFD_INTEL_M10_BMC_SPI_MODULE: u32 = 1;
pub const CONFIG_ARCH_SUNXI: u32 = 1;
pub const CONFIG_NFT_CONNLIMIT_MODULE: u32 = 1;
pub const CONFIG_SCREEN_INFO: u32 = 1;
pub const CONFIG_CRYPTO_DEV_OCTEONTX_CPT_MODULE: u32 = 1;
pub const CONFIG_NLS_MAC_CYRILLIC_MODULE: u32 = 1;
pub const CONFIG_PHY_MVEBU_A3700_UTMI_MODULE: u32 = 1;
pub const CONFIG_BT_BCM_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_LIB_BLAKE2S_GENERIC: u32 = 1;
pub const CONFIG_HARDENED_USERCOPY: u32 = 1;
pub const CONFIG_BUILDTIME_MCOUNT_SORT: u32 = 1;
pub const CONFIG_TOUCHSCREEN_EETI_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_MARK_MODULE: u32 = 1;
pub const CONFIG_PWM_TIEHRPWM_MODULE: u32 = 1;
pub const CONFIG_HAS_IOMEM: u32 = 1;
pub const CONFIG_SND_SOC_QDSP6_ASM_MODULE: u32 = 1;
pub const CONFIG_HAVE_CMPXCHG_DOUBLE: u32 = 1;
pub const CONFIG_VIDEO_ADV7343_MODULE: u32 = 1;
pub const CONFIG_PCIEASPM: u32 = 1;
pub const CONFIG_CMA_AREAS: u32 = 7;
pub const CONFIG_MVMDIO_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XTABLES: u32 = 1;
pub const CONFIG_MT7915E_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_MXL5007T_MODULE: u32 = 1;
pub const CONFIG_BT_MRVL_SDIO_MODULE: u32 = 1;
pub const CONFIG_IR_GPIO_TX_MODULE: u32 = 1;
pub const CONFIG_POWER_RESET_AS3722: u32 = 1;
pub const CONFIG_CLKSRC_MMIO: u32 = 1;
pub const CONFIG_RESET_TI_TPS380X_MODULE: u32 = 1;
pub const CONFIG_B43LEGACY_MODULE: u32 = 1;
pub const CONFIG_SCSI_FDOMAIN_PCI_MODULE: u32 = 1;
pub const CONFIG_W1_SLAVE_DS2405_MODULE: u32 = 1;
pub const CONFIG_TRACER_MAX_TRACE: u32 = 1;
pub const CONFIG_KEY_NOTIFICATIONS: u32 = 1;
pub const CONFIG_MDIO_BUS_MUX_MMIOREG_MODULE: u32 = 1;
pub const CONFIG_CLK_IMX8MN: u32 = 1;
pub const CONFIG_SND_SOC_TI_SDMA_PCM_MODULE: u32 = 1;
pub const CONFIG_WWAN_HWSIM_MODULE: u32 = 1;
pub const CONFIG_IPV6_MULTIPLE_TABLES: u32 = 1;
pub const CONFIG_BRIDGE_EBT_T_FILTER_MODULE: u32 = 1;
pub const CONFIG_USB_ADUTUX_MODULE: u32 = 1;
pub const CONFIG_ARM_ARCH_TIMER_OOL_WORKAROUND: u32 = 1;
pub const CONFIG_SENSORS_BPA_RS600_MODULE: u32 = 1;
pub const CONFIG_SENSORS_SMPRO_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_LIB_AESCFB: u32 = 1;
pub const CONFIG_BT_HCIBTSDIO_MODULE: u32 = 1;
pub const CONFIG_CDX_BUS: u32 = 1;
pub const CONFIG_DVB_USB_A800_MODULE: u32 = 1;
pub const CONFIG_IR_STREAMZAP_MODULE: u32 = 1;
pub const CONFIG_EC_ACER_ASPIRE1_MODULE: u32 = 1;
pub const CONFIG_BNXT_DCB: u32 = 1;
pub const CONFIG_NF_CONNTRACK_PROCFS: u32 = 1;
pub const CONFIG_SYSC_RCAR: u32 = 1;
pub const CONFIG_IMA_APPRAISE: u32 = 1;
pub const CONFIG_NF_CONNTRACK_H323_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_FC0011_MODULE: u32 = 1;
pub const CONFIG_HID_UNIVERSAL_PIDFF_MODULE: u32 = 1;
pub const CONFIG_VHOST_NET_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_RT5514_SPI_MODULE: u32 = 1;
pub const CONFIG_MFD_RK8XX_SPI_MODULE: u32 = 1;
pub const CONFIG_DRM_TOSHIBA_TC358762_MODULE: u32 = 1;
pub const CONFIG_B53_SPI_DRIVER_MODULE: u32 = 1;
pub const CONFIG_IP_VS_PROTO_UDP: u32 = 1;
pub const CONFIG_USB_CHIPIDEA_UDC: u32 = 1;
pub const CONFIG_TCG_TIS_SYNQUACER_MODULE: u32 = 1;
pub const CONFIG_XZ_DEC_POWERPC: u32 = 1;
pub const CONFIG_SND_SOC_TAS2770_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_SM6115_LPASS_LPI_MODULE: u32 = 1;
pub const CONFIG_BPF: u32 = 1;
pub const CONFIG_FW_CS_DSP_KUNIT_TEST_UTILS_MODULE: u32 = 1;
pub const CONFIG_XZ_DEC_ARM64: u32 = 1;
pub const CONFIG_SND_SUN8I_ADDA_PR_REGMAP_MODULE: u32 = 1;
pub const CONFIG_LOCALVERSION: &[u8; 1] = b"\0";
pub const CONFIG_IIO_CROS_EC_BARO_MODULE: u32 = 1;
pub const CONFIG_MMC_SDHCI_F_SDH30_MODULE: u32 = 1;
pub const CONFIG_USB_CONFIGFS_F_HID: u32 = 1;
pub const CONFIG_HID_GT683R_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CS42XX8_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TAS2780_MODULE: u32 = 1;
pub const CONFIG_BT_INTEL_MODULE: u32 = 1;
pub const CONFIG_IOSCHED_BFQ: u32 = 1;
pub const CONFIG_LIBETH_MODULE: u32 = 1;
pub const CONFIG_ARM64_SVE: u32 = 1;
pub const CONFIG_MICROCHIP_PHY_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_AMD: u32 = 1;
pub const CONFIG_CPUFREQ_DT_MODULE: u32 = 1;
pub const CONFIG_SUN50I_IOMMU: u32 = 1;
pub const CONFIG_HID_EVISION_MODULE: u32 = 1;
pub const CONFIG_TYPEC_NVIDIA_ALTMODE_MODULE: u32 = 1;
pub const CONFIG_DVB_RTL2830_MODULE: u32 = 1;
pub const CONFIG_MDIO_BUS_MUX_MESON_GXL_MODULE: u32 = 1;
pub const CONFIG_POWER_RESET_SYSCON: u32 = 1;
pub const CONFIG_USB_STORAGE_DATAFAB_MODULE: u32 = 1;
pub const CONFIG_SND_AUDIO_GRAPH_CARD2_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MPQ8785_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_AF9015_MODULE: u32 = 1;
pub const CONFIG_HID_TWINHAN_MODULE: u32 = 1;
pub const CONFIG_BCM2711_THERMAL_MODULE: u32 = 1;
pub const CONFIG_REGMAP_MMIO: u32 = 1;
pub const CONFIG_IOMMU_IO_PGTABLE: u32 = 1;
pub const CONFIG_KEXEC: u32 = 1;
pub const CONFIG_MFD_HI6421_SPMI_MODULE: u32 = 1;
pub const CONFIG_SND_ALOOP_MODULE: u32 = 1;
pub const CONFIG_SND_HRTIMER_MODULE: u32 = 1;
pub const CONFIG_NF_NAT_SIP_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_FSL_FLEXSPI_MODULE: u32 = 1;
pub const CONFIG_B53_MDIO_DRIVER_MODULE: u32 = 1;
pub const CONFIG_PRINTF_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA_AUDIO_GRAPH_CARD_MODULE: u32 = 1;
pub const CONFIG_RT2X00_LIB_MMIO_MODULE: u32 = 1;
pub const CONFIG_NLS_ISO8859_9_MODULE: u32 = 1;
pub const CONFIG_CHARGER_BD99954_MODULE: u32 = 1;
pub const CONFIG_IP_NF_TARGET_ECN_MODULE: u32 = 1;
pub const CONFIG_DRM_MSM_MDSS: u32 = 1;
pub const CONFIG_PDS_CORE_MODULE: u32 = 1;
pub const CONFIG_RZG2L_ADC_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_ADIANTUM_MODULE: u32 = 1;
pub const CONFIG_DRM_VIRTIO_GPU_KMS: u32 = 1;
pub const CONFIG_ARM_SCMI_PROTOCOL: u32 = 1;
pub const CONFIG_TEGRA_BPMP_THERMAL_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_BLOWFISH_COMMON_MODULE: u32 = 1;
pub const CONFIG_CROS_EC_TYPEC_MODULE: u32 = 1;
pub const CONFIG_DVB_TTUSB_BUDGET_MODULE: u32 = 1;
pub const CONFIG_SLUB: u32 = 1;
pub const CONFIG_NET_SCH_PRIO_MODULE: u32 = 1;
pub const CONFIG_AD8460_MODULE: u32 = 1;
pub const CONFIG_IFB_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CS35L56_SPI_MODULE: u32 = 1;
pub const CONFIG_STACKPROTECTOR: u32 = 1;
pub const CONFIG_EXT4_FS_POSIX_ACL: u32 = 1;
pub const CONFIG_NET_VENDOR_AMD: u32 = 1;
pub const CONFIG_QORIQ_CPUFREQ_MODULE: u32 = 1;
pub const CONFIG_FSL_DPAA: u32 = 1;
pub const CONFIG_SND_SOC_UDA1342_MODULE: u32 = 1;
pub const CONFIG_IR_MCEUSB_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_CP210X_MODULE: u32 = 1;
pub const CONFIG_MLXBF_BOOTCTL_MODULE: u32 = 1;
pub const CONFIG_PWM_TIECAP_MODULE: u32 = 1;
pub const CONFIG_TCG_CRB: u32 = 1;
pub const CONFIG_SLIP_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV5695_MODULE: u32 = 1;
pub const CONFIG_LONGEST_SYM_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_AW88399_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TOPOLOGY: u32 = 1;
pub const CONFIG_DVB_USB_DW2102_MODULE: u32 = 1;
pub const CONFIG_PRIME_NUMBERS_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_IP_NF_IPTABLES_MODULE: u32 = 1;
pub const CONFIG_TSM_REPORTS_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_ADAU1761_MODULE: u32 = 1;
pub const CONFIG_USB_IOWARRIOR_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_MAX20411_MODULE: u32 = 1;
pub const CONFIG_ST_UVIS25_SPI_MODULE: u32 = 1;
pub const CONFIG_HID_KENSINGTON_MODULE: u32 = 1;
pub const CONFIG_SND_ES1938_MODULE: u32 = 1;
pub const CONFIG_DRM_TI_TPD12S015_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_STV0680_MODULE: u32 = 1;
pub const CONFIG_B43_PCICORE_AUTOSELECT: u32 = 1;
pub const CONFIG_HAVE_REGS_AND_STACK_ACCESS_API: u32 = 1;
pub const CONFIG_USB_GSPCA_SN9C20X_MODULE: u32 = 1;
pub const CONFIG_ROCKCHIP_CDN_DP: u32 = 1;
pub const CONFIG_QCOM_HFPLL_MODULE: u32 = 1;
pub const CONFIG_DVB_ZL10353_MODULE: u32 = 1;
pub const CONFIG_OCTEONEP_VDPA_MODULE: u32 = 1;
pub const CONFIG_TABLET_USB_ACECAD_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_DSCP_MODULE: u32 = 1;
pub const CONFIG_SCD30_CORE_MODULE: u32 = 1;
pub const CONFIG_HAVE_SAMPLE_FTRACE_DIRECT: u32 = 1;
pub const CONFIG_SND_USB_PODHD_MODULE: u32 = 1;
pub const CONFIG_STMPE_SPI: u32 = 1;
pub const CONFIG_DVB_TDA8083_MODULE: u32 = 1;
pub const CONFIG_PHY_MVEBU_A3700_COMPHY_MODULE: u32 = 1;
pub const CONFIG_B53_SERDES_MODULE: u32 = 1;
pub const CONFIG_USB_DWC2_PCI_MODULE: u32 = 1;
pub const CONFIG_DRM_HDLCD_MODULE: u32 = 1;
pub const CONFIG_KGDB_TESTS: u32 = 1;
pub const CONFIG_FIRMWARE_MEMMAP: u32 = 1;
pub const CONFIG_ARCH_DMA_ADDR_T_64BIT: u32 = 1;
pub const CONFIG_EMAC_ROCKCHIP_MODULE: u32 = 1;
pub const CONFIG_DVB_STV090x_MODULE: u32 = 1;
pub const CONFIG_VIRTIO_VSOCKETS_COMMON_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_FSL_CAAM_RNG_API: u32 = 1;
pub const CONFIG_NFT_COMPAT_ARP_MODULE: u32 = 1;
pub const CONFIG_HID_A4TECH_MODULE: u32 = 1;
pub const CONFIG_VIDEO_IMX319_MODULE: u32 = 1;
pub const CONFIG_ACPI_CPPC_CPUFREQ_MODULE: u32 = 1;
pub const CONFIG_VIDEO_ADV7180_MODULE: u32 = 1;
pub const CONFIG_USB_F_FS_MODULE: u32 = 1;
pub const CONFIG_SENSORS_ADT7X10_MODULE: u32 = 1;
pub const CONFIG_PHY_FSL_IMX8M_PCIE: u32 = 1;
pub const CONFIG_DVB_ASCOT2E_MODULE: u32 = 1;
pub const CONFIG_PCIE_APPLE: u32 = 1;
pub const CONFIG_LEDS_CLASS_FLASH_MODULE: u32 = 1;
pub const CONFIG_TI_SCI_INTR_IRQCHIP_MODULE: u32 = 1;
pub const CONFIG_VIDEO_CX88_BLACKBIRD_MODULE: u32 = 1;
pub const CONFIG_EFI_ESRT: u32 = 1;
pub const CONFIG_MEDIA_TUNER_TEA5767_MODULE: u32 = 1;
pub const CONFIG_IMX_SCMI_MISC_EXT_MODULE: u32 = 1;
pub const CONFIG_WATCH_QUEUE: u32 = 1;
pub const CONFIG_ARM_SCMI_TRANSPORT_SMC: u32 = 1;
pub const CONFIG_SND_SOC_TLV320AIC3X_SPI_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_LIB_ARC4_MODULE: u32 = 1;
pub const CONFIG_QCOM_SPMI_ADC_TM5_MODULE: u32 = 1;
pub const CONFIG_MFD_CS40L50_CORE_MODULE: u32 = 1;
pub const CONFIG_TEST_KSTRTOX: u32 = 1;
pub const CONFIG_SENSORS_LM92_MODULE: u32 = 1;
pub const CONFIG_TEXTSEARCH_BM_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_DS1553_MODULE: u32 = 1;
pub const CONFIG_SND_PROC_FS: u32 = 1;
pub const CONFIG_USB_GSPCA_SUNPLUS_MODULE: u32 = 1;
pub const CONFIG_HID_SENSOR_INCLINOMETER_3D_MODULE: u32 = 1;
pub const CONFIG_FPGA_MGR_XILINX_SPI_MODULE: u32 = 1;
pub const CONFIG_BATMAN_ADV_DAT: u32 = 1;
pub const CONFIG_UTS_NS: u32 = 1;
pub const CONFIG_MLX5_FPGA: u32 = 1;
pub const CONFIG_HAVE_IRQ_TIME_ACCOUNTING: u32 = 1;
pub const CONFIG_ACPI_APEI_PCIEAER: u32 = 1;
pub const CONFIG_CRYPTO_CTR: u32 = 1;
pub const CONFIG_SND_SOC_RT1017_SDCA_SDW_MODULE: u32 = 1;
pub const CONFIG_DVB_M88DS3103_MODULE: u32 = 1;
pub const CONFIG_SPI_HISI_SFC_MODULE: u32 = 1;
pub const CONFIG_SERIAL_8250_PCILIB: u32 = 1;
pub const CONFIG_SHUFFLE_PAGE_ALLOCATOR: u32 = 1;
pub const CONFIG_DVB_AF9013_MODULE: u32 = 1;
pub const CONFIG_CAN_VCAN_MODULE: u32 = 1;
pub const CONFIG_POSIX_CPU_TIMERS_TASK_WORK: u32 = 1;
pub const CONFIG_SND_INTEL_NHLT: u32 = 1;
pub const CONFIG_HID_ALPS_MODULE: u32 = 1;
pub const CONFIG_IGB_MODULE: u32 = 1;
pub const CONFIG_FSL_DPAA_ETH_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_SI521XX: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_SECMARK_MODULE: u32 = 1;
pub const CONFIG_MWIFIEX_MODULE: u32 = 1;
pub const CONFIG_OMAP_USB2_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_NCT3018Y_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_USB_ITM: u32 = 1;
pub const CONFIG_VHOST_MENU: u32 = 1;
pub const CONFIG_LOG_CPU_MAX_BUF_SHIFT: u32 = 12;
pub const CONFIG_TYPEC_STUSB160X_MODULE: u32 = 1;
pub const CONFIG_LEDS_USER_MODULE: u32 = 1;
pub const CONFIG_PCIE_BRCMSTB: u32 = 1;
pub const CONFIG_USB_EHCI_TT_NEWSCHED: u32 = 1;
pub const CONFIG_SENSORS_NCT6775_CORE_MODULE: u32 = 1;
pub const CONFIG_RMI4_F03: u32 = 1;
pub const CONFIG_CRYPTO_CBC: u32 = 1;
pub const CONFIG_SND_PCM_MODULE: u32 = 1;
pub const CONFIG_ROCKCHIP_GRF: u32 = 1;
pub const CONFIG_SND_SOC_J721E_EVM_MODULE: u32 = 1;
pub const CONFIG_SND_SEQ_MIDI_EVENT_MODULE: u32 = 1;
pub const CONFIG_GPIO_SYSCON_MODULE: u32 = 1;
pub const CONFIG_6LOWPAN_NHC_MOBILITY_MODULE: u32 = 1;
pub const CONFIG_IMA_SECURE_AND_OR_TRUSTED_BOOT: u32 = 1;
pub const CONFIG_SC_DISPCC_8280XP_MODULE: u32 = 1;
pub const CONFIG_NFS_ACL_SUPPORT_MODULE: u32 = 1;
pub const CONFIG_CGROUP_WRITEBACK: u32 = 1;
pub const CONFIG_SECURITY_LOCKDOWN_LSM: u32 = 1;
pub const CONFIG_USB_DWC3_AM62_MODULE: u32 = 1;
pub const CONFIG_I2C_QCOM_GENI_MODULE: u32 = 1;
pub const CONFIG_I2C_MUX_PCA9541_MODULE: u32 = 1;
pub const CONFIG_NET_DEVLINK: u32 = 1;
pub const CONFIG_IIO_ST_LSM6DSX_I2C_MODULE: u32 = 1;
pub const CONFIG_OF_RESOLVE: u32 = 1;
pub const CONFIG_SND_SOC_WCD939X_MODULE: u32 = 1;
pub const CONFIG_SERIAL_SAMSUNG: u32 = 1;
pub const CONFIG_QCOM_GDSC: u32 = 1;
pub const CONFIG_USB_CATC_MODULE: u32 = 1;
pub const CONFIG_ARCH_TEGRA_132_SOC: u32 = 1;
pub const CONFIG_RMI4_F12: u32 = 1;
pub const CONFIG_HOTPLUG_CORE_SYNC_DEAD: u32 = 1;
pub const CONFIG_SPI_ROCKCHIP_SFC_MODULE: u32 = 1;
pub const CONFIG_EFI_GENERIC_STUB: u32 = 1;
pub const CONFIG_MARVELL_88X2222_PHY_MODULE: u32 = 1;
pub const CONFIG_MAC80211_RC_DEFAULT_MINSTREL: u32 = 1;
pub const CONFIG_NF_CONNTRACK_SNMP_MODULE: u32 = 1;
pub const CONFIG_NLS_KOI8_R_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_DA7219_MODULE: u32 = 1;
pub const CONFIG_RTW88_8821A_MODULE: u32 = 1;
pub const CONFIG_TEXTSEARCH_KMP_MODULE: u32 = 1;
pub const CONFIG_DVB_EC100_MODULE: u32 = 1;
pub const CONFIG_EXPERT: u32 = 1;
pub const CONFIG_REBOOT_MODE: u32 = 1;
pub const CONFIG_IIO_ST_SENSORS_I2C_MODULE: u32 = 1;
pub const CONFIG_HIST_TRIGGERS: u32 = 1;
pub const CONFIG_DM_MULTIPATH_ST_MODULE: u32 = 1;
pub const CONFIG_REGMAP_SCCB_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_INGRESS: u32 = 1;
pub const CONFIG_W1_SLAVE_DS2433_MODULE: u32 = 1;
pub const CONFIG_MFD_CS42L43_I2C_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_CONNMARK_MODULE: u32 = 1;
pub const CONFIG_WL1251_SPI_MODULE: u32 = 1;
pub const CONFIG_RT2800PCI_RT33XX: u32 = 1;
pub const CONFIG_PCIE_TEGRA194_HOST: u32 = 1;
pub const CONFIG_ARM_PSCI_CPUIDLE_DOMAIN: u32 = 1;
pub const CONFIG_IIO_BUFFER_HW_CONSUMER_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_QDSP6_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_SHA512_ARM64_MODULE: u32 = 1;
pub const CONFIG_ARM_SCMI_POWERCAP_MODULE: u32 = 1;
pub const CONFIG_DVB_DS3000_MODULE: u32 = 1;
pub const CONFIG_VIDEO_RJ54N1_MODULE: u32 = 1;
pub const CONFIG_HI3660_MBOX: u32 = 1;
pub const CONFIG_IIO_FORMAT_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_DRM_CHRONTEL_CH7033_MODULE: u32 = 1;
pub const CONFIG_AMD8111_ETH_MODULE: u32 = 1;
pub const CONFIG_NF_FLOW_TABLE_INET_MODULE: u32 = 1;
pub const CONFIG_ACCESSIBILITY: u32 = 1;
pub const CONFIG_I2C_DESIGNWARE_SLAVE: u32 = 1;
pub const CONFIG_NS83820_MODULE: u32 = 1;
pub const CONFIG_USB_NET_HUAWEI_CDC_NCM_MODULE: u32 = 1;
pub const CONFIG_A64FX_DIAG: u32 = 1;
pub const CONFIG_DM_MULTIPATH_IOA_MODULE: u32 = 1;
pub const CONFIG_USB_STORAGE_JUMPSHOT_MODULE: u32 = 1;
pub const CONFIG_BCMA_DRIVER_PCI: u32 = 1;
pub const CONFIG_CAN_ROCKCHIP_CANFD_MODULE: u32 = 1;
pub const CONFIG_BT_LEDS: u32 = 1;
pub const CONFIG_VIDEO_MAX9286_MODULE: u32 = 1;
pub const CONFIG_TEST_MISC_MINOR_MODULE: u32 = 1;
pub const CONFIG_PHY_TEGRA194_P2U: u32 = 1;
pub const CONFIG_NLS_ISO8859_8_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_ATMEL_MXT_MODULE: u32 = 1;
pub const CONFIG_USB_CHIPIDEA_TEGRA_MODULE: u32 = 1;
pub const CONFIG_UID16: u32 = 1;
pub const CONFIG_LEDS_ST1202_MODULE: u32 = 1;
pub const CONFIG_XZ_DEC_MICROLZMA: u32 = 1;
pub const CONFIG_GPIO_ADP5585_MODULE: u32 = 1;
pub const CONFIG_TIPC_MEDIA_UDP: u32 = 1;
pub const CONFIG_SWAP: u32 = 1;
pub const CONFIG_CB710_DEBUG_ASSUMPTIONS: u32 = 1;
pub const CONFIG_MTD_UBI_NVMEM_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_WCD938X_SDW_MODULE: u32 = 1;
pub const CONFIG_ASYNC_RAID6_TEST_MODULE: u32 = 1;
pub const CONFIG_EPIC100_MODULE: u32 = 1;
pub const CONFIG_MAGIC_SYSRQ_SERIAL: u32 = 1;
pub const CONFIG_HAVE_STACKPROTECTOR: u32 = 1;
pub const CONFIG_BNX2_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_LOG_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_LIB_CURVE25519_INTERNAL_MODULE: u32 = 1;
pub const CONFIG_MT7615E_MODULE: u32 = 1;
pub const CONFIG_ACPI_MDIO: u32 = 1;
pub const CONFIG_PCIE_ROCKCHIP: u32 = 1;
pub const CONFIG_RTC_DRV_ISL12026_MODULE: u32 = 1;
pub const CONFIG_FXOS8700_I2C_MODULE: u32 = 1;
pub const CONFIG_HMC425_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_MAX77802_MODULE: u32 = 1;
pub const CONFIG_SENSORS_THMC50_MODULE: u32 = 1;
pub const CONFIG_SND_SEQ_MIDI_EMUL_MODULE: u32 = 1;
pub const CONFIG_HAVE_ARCH_JUMP_LABEL: u32 = 1;
pub const CONFIG_COMMON_CLK_C3_PLL: u32 = 1;
pub const CONFIG_PINCTRL_IMX8QM: u32 = 1;
pub const CONFIG_USB_CONFIGFS_ECM: u32 = 1;
pub const CONFIG_CRYPTO_PCBC_MODULE: u32 = 1;
pub const CONFIG_IEEE802154_MCR20A_MODULE: u32 = 1;
pub const CONFIG_BCM_VIDEOCORE_MODULE: u32 = 1;
pub const CONFIG_NETDEVSIM_MODULE: u32 = 1;
pub const CONFIG_STEAM_FF: u32 = 1;
pub const CONFIG_BCMA_MODULE: u32 = 1;
pub const CONFIG_HID_HOLTEK_MODULE: u32 = 1;
pub const CONFIG_NETCONSOLE_DYNAMIC: u32 = 1;
pub const CONFIG_NF_CONNTRACK_BROADCAST_MODULE: u32 = 1;
pub const CONFIG_MMC_SDHCI_IPROC_MODULE: u32 = 1;
pub const CONFIG_SND_MESON_AXG_TDMIN_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_NON_OVERLAPPING_ADDRESS_SPACE: u32 = 1;
pub const CONFIG_QCA807X_PHY_MODULE: u32 = 1;
pub const CONFIG_KEYBOARD_SNVS_PWRKEY_MODULE: u32 = 1;
pub const CONFIG_RT2800USB_RT33XX: u32 = 1;
pub const CONFIG_MMC_SDHCI_PLTFM_MODULE: u32 = 1;
pub const CONFIG_SENSORS_SPD5118_DETECT: u32 = 1;
pub const CONFIG_MT76x0_COMMON_MODULE: u32 = 1;
pub const CONFIG_WLCORE_SPI_MODULE: u32 = 1;
pub const CONFIG_CXL_MEM_MODULE: u32 = 1;
pub const CONFIG_SND_OPL3_LIB_MODULE: u32 = 1;
pub const CONFIG_TI_K3_UDMA_MODULE: u32 = 1;
pub const CONFIG_NFT_SYNPROXY_MODULE: u32 = 1;
pub const CONFIG_HID_ZYDACRON_MODULE: u32 = 1;
pub const CONFIG_PREEMPT_RCU: u32 = 1;
pub const CONFIG_USB_NET_ZAURUS_MODULE: u32 = 1;
pub const CONFIG_VIDEO_SAA6588_MODULE: u32 = 1;
pub const CONFIG_CC_HAS_BRANCH_PROT_PAC_RET_BTI: u32 = 1;
pub const CONFIG_HAVE_SYSCALL_TRACEPOINTS: u32 = 1;
pub const CONFIG_IOMMU_IOVA: u32 = 1;
pub const CONFIG_XOR_BLOCKS: u32 = 1;
pub const CONFIG_DNOTIFY: u32 = 1;
pub const CONFIG_LEDS_TRIGGER_BACKLIGHT_MODULE: u32 = 1;
pub const CONFIG_BPF_STREAM_PARSER: u32 = 1;
pub const CONFIG_MEDIA_SUBDRV_AUTOSELECT: u32 = 1;
pub const CONFIG_XILINX_VCU_MODULE: u32 = 1;
pub const CONFIG_MACVLAN_MODULE: u32 = 1;
pub const CONFIG_SC_VIDEOCC_7180_MODULE: u32 = 1;
pub const CONFIG_TEGRA_MC: u32 = 1;
pub const CONFIG_SENSORS_SHT15_MODULE: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_KEXEC: u32 = 1;
pub const CONFIG_IP_NF_RAW_MODULE: u32 = 1;
pub const CONFIG_HAVE_HW_BREAKPOINT: u32 = 1;
pub const CONFIG_BRIDGE_NF_EBTABLES_LEGACY_MODULE: u32 = 1;
pub const CONFIG_GPIO_BRCMSTB_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_RAYDIUM_RM69380_MODULE: u32 = 1;
pub const CONFIG_MOUSE_VSXXXAA_MODULE: u32 = 1;
pub const CONFIG_AS_HAS_ARMV8_4: u32 = 1;
pub const CONFIG_SPI_CH341_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_SAMSUNG_S6E88A0_AMS427AP24_MODULE: u32 = 1;
pub const CONFIG_RANDOM_KMALLOC_CACHES: u32 = 1;
pub const CONFIG_VIDEO_TEA6420_MODULE: u32 = 1;
pub const CONFIG_SCSI_MPT3SAS_MAX_SGE: u32 = 128;
pub const CONFIG_HNS_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_BACKLIGHT_QUIRKS_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_CTS: u32 = 1;
pub const CONFIG_DVB_USB_EC168_MODULE: u32 = 1;
pub const CONFIG_IMX8QXP_ADC_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_OPS_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_RSI_91X_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_WCD_CLASSH_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_SPCA1528_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_ILI210X_MODULE: u32 = 1;
pub const CONFIG_AD7625_MODULE: u32 = 1;
pub const CONFIG_ZYNQMP_POWER: u32 = 1;
pub const CONFIG_GPIO_AGGREGATOR_MODULE: u32 = 1;
pub const CONFIG_SLIM_QCOM_CTRL_MODULE: u32 = 1;
pub const CONFIG_HAVE_NMI: u32 = 1;
pub const CONFIG_ARM_SP805_WATCHDOG_MODULE: u32 = 1;
pub const CONFIG_CC_HAS_INT128: u32 = 1;
pub const CONFIG_VIDEO_THS8200_MODULE: u32 = 1;
pub const CONFIG_SENSORS_F75375S_MODULE: u32 = 1;
pub const CONFIG_SND_INDIGOIOX_MODULE: u32 = 1;
pub const CONFIG_SND_MESON_G12A_TOACODEC_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_SOF_TOPLEVEL: u32 = 1;
pub const CONFIG_SCSI_NETLINK: u32 = 1;
pub const CONFIG_CRYPTO_USER_API_AEAD: u32 = 1;
pub const CONFIG_SPI_KSPI2_MODULE: u32 = 1;
pub const CONFIG_NETCONSOLE_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_SUN50I_H6_R: u32 = 1;
pub const CONFIG_HAVE_VIRT_CPU_ACCOUNTING_GEN: u32 = 1;
pub const CONFIG_VIRTIO_VFIO_PCI_MODULE: u32 = 1;
pub const CONFIG_SND_HDSPM_MODULE: u32 = 1;
pub const CONFIG_DRM_XE_DEVMEM_MIRROR: u32 = 1;
pub const CONFIG_VIDEO_ALLEGRO_DVT_MODULE: u32 = 1;
pub const CONFIG_GENERIC_CLOCKEVENTS_BROADCAST: u32 = 1;
pub const CONFIG_CRYPTO_DEV_SAFEXCEL_MODULE: u32 = 1;
pub const CONFIG_DVB_TTUSB_DEC_MODULE: u32 = 1;
pub const CONFIG_RTC_NVMEM: u32 = 1;
pub const CONFIG_DRM_PANEL_LINCOLNTECH_LCD197_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_WCD937X_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_IMAGIS_MODULE: u32 = 1;
pub const CONFIG_SCSI_HPTIOP_MODULE: u32 = 1;
pub const CONFIG_JFS_POSIX_ACL: u32 = 1;
pub const CONFIG_VIDEO_VPX3220_MODULE: u32 = 1;
pub const CONFIG_WATCHDOG_SYSFS: u32 = 1;
pub const CONFIG_I2C_RK3X: u32 = 1;
pub const CONFIG_OPT4001_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_BD96801_MODULE: u32 = 1;
pub const CONFIG_SENSORS_POWERZ_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_XGENE: u32 = 1;
pub const CONFIG_MEDIA_ALTERA_CI_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_SOF_OF_MODULE: u32 = 1;
pub const CONFIG_QCOM_ICC_BWMON_MODULE: u32 = 1;
pub const CONFIG_SENSORS_TPS546D24_MODULE: u32 = 1;
pub const CONFIG_NCSI_OEM_CMD_KEEP_PHY: u32 = 1;
pub const CONFIG_USB_SERIAL_QT2_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_ILITEK_ILI9882T_MODULE: u32 = 1;
pub const CONFIG_SPI_GPIO_MODULE: u32 = 1;
pub const CONFIG_HID_LED_MODULE: u32 = 1;
pub const CONFIG_FB_SYS_FILLRECT: u32 = 1;
pub const CONFIG_I2C_DIOLAN_U2C_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_WCD9335_MODULE: u32 = 1;
pub const CONFIG_XARRAY_MULTI: u32 = 1;
pub const CONFIG_USB_SERIAL_IPW_MODULE: u32 = 1;
pub const CONFIG_DRM_ACCEL_QAIC_MODULE: u32 = 1;
pub const CONFIG_USBIP_VUDC_MODULE: u32 = 1;
pub const CONFIG_RMI4_F11: u32 = 1;
pub const CONFIG_SND_SOC_QDSP6_CORE_MODULE: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_KEXEC_FILE: u32 = 1;
pub const CONFIG_DCB: u32 = 1;
pub const CONFIG_ZSWAP: u32 = 1;
pub const CONFIG_SENSORS_TMP103_MODULE: u32 = 1;
pub const CONFIG_PHY_MESON_G12A_MIPI_DPHY_ANALOG: u32 = 1;
pub const CONFIG_MT7921_COMMON_MODULE: u32 = 1;
pub const CONFIG_PCIE_ROCKCHIP_HOST: u32 = 1;
pub const CONFIG_ZSWAP_COMPRESSOR_DEFAULT_LZO: u32 = 1;
pub const CONFIG_TI_ADS8344_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_FC0013_MODULE: u32 = 1;
pub const CONFIG_SENSORS_ADM1025_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_TWOFISH_MODULE: u32 = 1;
pub const CONFIG_HAVE_ARCH_PREL32_RELOCATIONS: u32 = 1;
pub const CONFIG_PACKING: u32 = 1;
pub const CONFIG_IPV6_MIP6: u32 = 1;
pub const CONFIG_SND_FM801_TEA575X_BOOL: u32 = 1;
pub const CONFIG_NET_DSA_QCA8K_LEDS_SUPPORT: u32 = 1;
pub const CONFIG_W1_SLAVE_DS2430_MODULE: u32 = 1;
pub const CONFIG_BT_HCIUART_QCA: u32 = 1;
pub const CONFIG_MHI_NET_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_RNG_DEFAULT: u32 = 1;
pub const CONFIG_RV: u32 = 1;
pub const CONFIG_STREAM_PARSER: u32 = 1;
pub const CONFIG_KVM_GENERIC_MMU_NOTIFIER: u32 = 1;
pub const CONFIG_VIDEO_BCM2835_UNICAM_MODULE: u32 = 1;
pub const CONFIG_UEFI_CPER: u32 = 1;
pub const CONFIG_SENSORS_CORSAIR_CPRO_MODULE: u32 = 1;
pub const CONFIG_IP_VS_SED_MODULE: u32 = 1;
pub const CONFIG_LIBFCOE_MODULE: u32 = 1;
pub const CONFIG_ADF4377_MODULE: u32 = 1;
pub const CONFIG_MDIO_DEVRES: u32 = 1;
pub const CONFIG_XZ_DEC_ARM: u32 = 1;
pub const CONFIG_SND_HDA_SCODEC_CS35L41_I2C_MODULE: u32 = 1;
pub const CONFIG_DVB_RTL2832_MODULE: u32 = 1;
pub const CONFIG_INET_ESP_OFFLOAD_MODULE: u32 = 1;
pub const CONFIG_NET_DSA_MT7530_MODULE: u32 = 1;
pub const CONFIG_NET_DSA_MODULE: u32 = 1;
pub const CONFIG_SENSORS_INA2XX_MODULE: u32 = 1;
pub const CONFIG_MTD_UBI_BEB_LIMIT: u32 = 20;
pub const CONFIG_HOTPLUG_PCI: u32 = 1;
pub const CONFIG_SA_DISPCC_8775P_MODULE: u32 = 1;
pub const CONFIG_VIDEO_S5K5BAF_MODULE: u32 = 1;
pub const CONFIG_USB_VIDEO_CLASS_MODULE: u32 = 1;
pub const CONFIG_F2FS_FS_LZO: u32 = 1;
pub const CONFIG_VIDEO_IMX8_ISI_M2M: u32 = 1;
pub const CONFIG_SENSORS_AD7418_MODULE: u32 = 1;
pub const CONFIG_NFC_NCI_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_RT5640_MODULE: u32 = 1;
pub const CONFIG_CLK_RCAR_CPG_LIB: u32 = 1;
pub const CONFIG_AXP20X_ADC_MODULE: u32 = 1;
pub const CONFIG_IEEE802154_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_DS1374_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_IDLETIMER_MODULE: u32 = 1;
pub const CONFIG_CIFS_POSIX: u32 = 1;
pub const CONFIG_ARM_CCI_PMU_MODULE: u32 = 1;
pub const CONFIG_HID_COUGAR_MODULE: u32 = 1;
pub const CONFIG_ROCKCHIP_IODOMAIN_MODULE: u32 = 1;
pub const CONFIG_MMC_HSQ_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_MAX98090_MODULE: u32 = 1;
pub const CONFIG_PWM: u32 = 1;
pub const CONFIG_DRM_XE_JOB_TIMEOUT_MIN: u32 = 1;
pub const CONFIG_APPLE_WATCHDOG_MODULE: u32 = 1;
pub const CONFIG_CONFIGFS_FS: u32 = 1;
pub const CONFIG_QCOM_HIDMA_MGMT_MODULE: u32 = 1;
pub const CONFIG_NVIDIA_SHIELD_FF: u32 = 1;
pub const CONFIG_JFFS2_FS_WRITEBUFFER: u32 = 1;
pub const CONFIG_PINCTRL_BCM2835: u32 = 1;
pub const CONFIG_MTD_SST25L_MODULE: u32 = 1;
pub const CONFIG_DEFAULT_INIT: &[u8; 1] = b"\0";
pub const CONFIG_RT2500PCI_MODULE: u32 = 1;
pub const CONFIG_XILLYUSB_MODULE: u32 = 1;
pub const CONFIG_SPMI_HISI3670_MODULE: u32 = 1;
pub const CONFIG_MAX1241_MODULE: u32 = 1;
pub const CONFIG_KXCJK1013_MODULE: u32 = 1;
pub const CONFIG_MLX_PLATFORM_MODULE: u32 = 1;
pub const CONFIG_VIRT_DRIVERS: u32 = 1;
pub const CONFIG_DMABUF_HEAPS_CMA: u32 = 1;
pub const CONFIG_COMMON_CLK_VC3_MODULE: u32 = 1;
pub const CONFIG_KEYBOARD_IMX_SC_KEY_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_NITROX_MODULE: u32 = 1;
pub const CONFIG_PCI_HYPERV_MODULE: u32 = 1;
pub const CONFIG_ATA_ACPI: u32 = 1;
pub const CONFIG_RTW88_8723DU_MODULE: u32 = 1;
pub const CONFIG_NET_CLS: u32 = 1;
pub const CONFIG_XFS_LIVE_HOOKS: u32 = 1;
pub const CONFIG_SND_SOC_ICS43432_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_AGERE: u32 = 1;
pub const CONFIG_SERIAL_MVEBU_CONSOLE: u32 = 1;
pub const CONFIG_W1_CON: u32 = 1;
pub const CONFIG_HID_ACRUX_FF: u32 = 1;
pub const CONFIG_OF_RESERVED_MEM: u32 = 1;
pub const CONFIG_NFT_REJECT_IPV4_MODULE: u32 = 1;
pub const CONFIG_IP6_NF_MATCH_OPTS_MODULE: u32 = 1;
pub const CONFIG_MV_XOR_V2: u32 = 1;
pub const CONFIG_TOUCHSCREEN_USB_EGALAX: u32 = 1;
pub const CONFIG_THUNDER_NIC_BGX_MODULE: u32 = 1;
pub const CONFIG_SATA_MV_MODULE: u32 = 1;
pub const CONFIG_SCHEDSTATS: u32 = 1;
pub const CONFIG_ALTERA_STAPL_MODULE: u32 = 1;
pub const CONFIG_INFINIBAND_IPOIB_DEBUG: u32 = 1;
pub const CONFIG_VIA_VELOCITY_MODULE: u32 = 1;
pub const CONFIG_REALTEK_PHY_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_KPP2: u32 = 1;
pub const CONFIG_TCP_AO: u32 = 1;
pub const CONFIG_AD7091R8_MODULE: u32 = 1;
pub const CONFIG_NET_ACT_SKBEDIT_MODULE: u32 = 1;
pub const CONFIG_DRM_DISPLAY_DP_AUX_CEC: u32 = 1;
pub const CONFIG_MCP9600_MODULE: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_KEXEC_SIG: u32 = 1;
pub const CONFIG_DRM_CDNS_MHDP8546_J721E: u32 = 1;
pub const CONFIG_VHOST_VSOCK_MODULE: u32 = 1;
pub const CONFIG_MMC_CAVIUM_THUNDERX_MODULE: u32 = 1;
pub const CONFIG_BLK_DEV_LOOP_MIN_COUNT: u32 = 0;
pub const CONFIG_DRM_DISPLAY_CONNECTOR_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_RT700_SDW_MODULE: u32 = 1;
pub const CONFIG_B43LEGACY_HWRNG: u32 = 1;
pub const CONFIG_NFT_QUEUE_MODULE: u32 = 1;
pub const CONFIG_SC_GCC_7180: u32 = 1;
pub const CONFIG_CRYPTO_DRBG_HASH: u32 = 1;
pub const CONFIG_PINCTRL_SCMI: u32 = 1;
pub const CONFIG_HAVE_ARM_SMCCC_DISCOVERY: u32 = 1;
pub const CONFIG_CRYPTO_DEV_MARVELL_CESA_MODULE: u32 = 1;
pub const CONFIG_DCACHE_WORD_ACCESS: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_CFI_CLANG: u32 = 1;
pub const CONFIG_RENESAS_RZV2HWDT_MODULE: u32 = 1;
pub const CONFIG_RANDOMIZE_KSTACK_OFFSET_DEFAULT: u32 = 1;
pub const CONFIG_SND_SUN4I_SPDIF_MODULE: u32 = 1;
pub const CONFIG_DRM_TTM_HELPER_MODULE: u32 = 1;
pub const CONFIG_CDROM: u32 = 1;
pub const CONFIG_MFD_TI_AM335X_TSCADC_MODULE: u32 = 1;
pub const CONFIG_RCU_TORTURE_TEST_MODULE: u32 = 1;
pub const CONFIG_SUN6I_RTC_CCU: u32 = 1;
pub const CONFIG_THUNDERX2_PMU_MODULE: u32 = 1;
pub const CONFIG_DRM_VKMS_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_TEA5761_MODULE: u32 = 1;
pub const CONFIG_PHY_FSL_IMX8QM_HSIO_MODULE: u32 = 1;
pub const CONFIG_SENSORS_SCH56XX_COMMON_MODULE: u32 = 1;
pub const CONFIG_CONTEXT_SWITCH_TRACER: u32 = 1;
pub const CONFIG_USB_GSPCA_VC032X_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_NTPFW_MODULE: u32 = 1;
pub const CONFIG_MMC_DW_MODULE: u32 = 1;
pub const CONFIG_AS_HAS_ARMV8_5: u32 = 1;
pub const CONFIG_PCI_AARDVARK: u32 = 1;
pub const CONFIG_RUSTC_LLVM_VERSION: u32 = 200103;
pub const CONFIG_MMC_TMIO_CORE_MODULE: u32 = 1;
pub const CONFIG_EXTCON: u32 = 1;
pub const CONFIG_CRYPTO_DEV_QAT_DH895xCCVF_MODULE: u32 = 1;
pub const CONFIG_RESET_GPIO_MODULE: u32 = 1;
pub const CONFIG_BAYCOM_SER_FDX_MODULE: u32 = 1;
pub const CONFIG_ADXL367_MODULE: u32 = 1;
pub const CONFIG_IIO_INTERRUPT_TRIGGER_MODULE: u32 = 1;
pub const CONFIG_INPUT_RK805_PWRKEY_MODULE: u32 = 1;
pub const CONFIG_GPIO_TEGRA186: u32 = 1;
pub const CONFIG_MT7663_USB_SDIO_COMMON_MODULE: u32 = 1;
pub const CONFIG_PCI_LAYERSCAPE: u32 = 1;
pub const CONFIG_ARCH_HAS_PTDUMP: u32 = 1;
pub const CONFIG_DRM_I2C_NXP_TDA998X_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_STK014_MODULE: u32 = 1;
pub const CONFIG_DMA_ACPI: u32 = 1;
pub const CONFIG_INPUT_KEYBOARD: u32 = 1;
pub const CONFIG_FSL_GUTS: u32 = 1;
pub const CONFIG_CRYPTO_DEV_QAT_MODULE: u32 = 1;
pub const CONFIG_GENERIC_IDLE_POLL_SETUP: u32 = 1;
pub const CONFIG_TOUCHSCREEN_EXC3000_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_S32G2: u32 = 1;
pub const CONFIG_TRUSTED_KEYS: u32 = 1;
pub const CONFIG_CROS_EC_UART_MODULE: u32 = 1;
pub const CONFIG_ATH9K_COMMON_MODULE: u32 = 1;
pub const CONFIG_TCG_TIS_I2C_NUVOTON_MODULE: u32 = 1;
pub const CONFIG_MQ_IOSCHED_KYBER: u32 = 1;
pub const CONFIG_CHARGER_BQ24735_MODULE: u32 = 1;
pub const CONFIG_SND_SEQ_DUMMY_MODULE: u32 = 1;
pub const CONFIG_SPI_ORION_MODULE: u32 = 1;
pub const CONFIG_XZ_DEC_RISCV: u32 = 1;
pub const CONFIG_DEVICE_MIGRATION: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_832075: u32 = 1;
pub const CONFIG_SND_MPU401_UART_MODULE: u32 = 1;
pub const CONFIG_DRAGONRISE_FF: u32 = 1;
pub const CONFIG_REGULATOR_VCTRL_MODULE: u32 = 1;
pub const CONFIG_THREAD_INFO_IN_TASK: u32 = 1;
pub const CONFIG_SYSFS: u32 = 1;
pub const CONFIG_XFS_RT: u32 = 1;
pub const CONFIG_RD_ZSTD: u32 = 1;
pub const CONFIG_IRQ_TIME_ACCOUNTING: u32 = 1;
pub const CONFIG_USB_MR800_MODULE: u32 = 1;
pub const CONFIG_SECURITY_SELINUX_DEVELOP: u32 = 1;
pub const CONFIG_MT7925E_MODULE: u32 = 1;
pub const CONFIG_ADXL380_MODULE: u32 = 1;
pub const CONFIG_DRM_SAMSUNG_DSIM_MODULE: u32 = 1;
pub const CONFIG_HAVE_ARCH_THREAD_STRUCT_WHITELIST: u32 = 1;
pub const CONFIG_MMC_BCM2835_MODULE: u32 = 1;
pub const CONFIG_BRCMFMAC_PROTO_BCDC: u32 = 1;
pub const CONFIG_SIGNATURE: u32 = 1;
pub const CONFIG_MFD_SM501_GPIO: u32 = 1;
pub const CONFIG_INFINIBAND_SRPT_MODULE: u32 = 1;
pub const CONFIG_NET_CLS_FLOW_MODULE: u32 = 1;
pub const CONFIG_VIDEO_SAA7146_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_ST1232_MODULE: u32 = 1;
pub const CONFIG_DM_THIN_PROVISIONING_MODULE: u32 = 1;
pub const CONFIG_ASYNC_TX_ENABLE_CHANNEL_SWITCH: u32 = 1;
pub const CONFIG_TCP_CONG_HYBLA_MODULE: u32 = 1;
pub const CONFIG_SND_UMP_MODULE: u32 = 1;
pub const CONFIG_VIDEO_SUN6I_CSI_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_FSL_CAAM_COMMON_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_AW87390_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_XC5000_MODULE: u32 = 1;
pub const CONFIG_HAVE_RSEQ: u32 = 1;
pub const CONFIG_ACPI_CCA_REQUIRED: u32 = 1;
pub const CONFIG_USB_DWC3_IMX8MP_MODULE: u32 = 1;
pub const CONFIG_HID_AUREAL_MODULE: u32 = 1;
pub const CONFIG_LEDS_PCA9532_GPIO: u32 = 1;
pub const CONFIG_DVB_CORE_MODULE: u32 = 1;
pub const CONFIG_IP_NF_TARGET_REJECT_MODULE: u32 = 1;
pub const CONFIG_REGMAP_IRQ: u32 = 1;
pub const CONFIG_SND_SOC_COMPRESS: u32 = 1;
pub const CONFIG_NET_EMATCH_TEXT_MODULE: u32 = 1;
pub const CONFIG_HAVE_KCSAN_COMPILER: u32 = 1;
pub const CONFIG_TCG_VTPM_PROXY_MODULE: u32 = 1;
pub const CONFIG_EFI_VARS_PSTORE: u32 = 1;
pub const CONFIG_SND_ENS1370_MODULE: u32 = 1;
pub const CONFIG_ATA_OVER_ETH_MODULE: u32 = 1;
pub const CONFIG_IPVLAN_MODULE: u32 = 1;
pub const CONFIG_MMC_ALCOR_MODULE: u32 = 1;
pub const CONFIG_SERIO_RAW_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_IMX_ES8328_MODULE: u32 = 1;
pub const CONFIG_STRICT_DEVMEM: u32 = 1;
pub const CONFIG_GCC10_NO_ARRAY_BOUNDS: u32 = 1;
pub const CONFIG_SND_SOC_CS35L41_LIB_MODULE: u32 = 1;
pub const CONFIG_ROCKCHIP_RGB: u32 = 1;
pub const CONFIG_RTC_DRV_DS1672_MODULE: u32 = 1;
pub const CONFIG_ARCH_THUNDER2: u32 = 1;
pub const CONFIG_SENSORS_TMP102_MODULE: u32 = 1;
pub const CONFIG_RTW88_8821C_MODULE: u32 = 1;
pub const CONFIG_SND_INDIGOIO_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_FC0012_MODULE: u32 = 1;
pub const CONFIG_SENSORS_ADM1026_MODULE: u32 = 1;
pub const CONFIG_EEPROM_AT25_MODULE: u32 = 1;
pub const CONFIG_VIDEO_S5K6A3_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_STATE_MODULE: u32 = 1;
pub const CONFIG_DRM_DRAW: u32 = 1;
pub const CONFIG_SND_SOC_ES8328_MODULE: u32 = 1;
pub const CONFIG_SENSORS_NCT6775_I2C_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_TEGRA_XUSB: u32 = 1;
pub const CONFIG_SPI_DYNAMIC: u32 = 1;
pub const CONFIG_PPP_DEFLATE_MODULE: u32 = 1;
pub const CONFIG_W1_SLAVE_DS2431_MODULE: u32 = 1;
pub const CONFIG_CPU_FREQ_GOV_ONDEMAND: u32 = 1;
pub const CONFIG_SENSORS_MAX8688_MODULE: u32 = 1;
pub const CONFIG_DRM_MSM_DSI_20NM_PHY: u32 = 1;
pub const CONFIG_MMC_DW_ROCKCHIP_MODULE: u32 = 1;
pub const CONFIG_BCM_VK_MODULE: u32 = 1;
pub const CONFIG_VT_HW_CONSOLE_BINDING: u32 = 1;
pub const CONFIG_PHY_ROCKCHIP_INNO_CSIDPHY_MODULE: u32 = 1;
pub const CONFIG_I2C_ALGOBIT_MODULE: u32 = 1;
pub const CONFIG_INPUT_RT5120_PWRKEY_MODULE: u32 = 1;
pub const CONFIG_SENSORS_PM6764TR_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_SAMSUNG_S6E3HA2_MODULE: u32 = 1;
pub const CONFIG_EXTCON_USBC_TUSB320_MODULE: u32 = 1;
pub const CONFIG_I2C_HID_ACPI_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_CAST_COMMON_MODULE: u32 = 1;
pub const CONFIG_NF_NAT_MASQUERADE: u32 = 1;
pub const CONFIG_GENERIC_CLOCKEVENTS: u32 = 1;
pub const CONFIG_NF_CT_NETLINK_HELPER_MODULE: u32 = 1;
pub const CONFIG_MOUSE_SYNAPTICS_I2C_MODULE: u32 = 1;
pub const CONFIG_NLS_CODEPAGE_852_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_WHITEHEAT_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_ECN_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_QCE_SW_MAX_LEN: u32 = 512;
pub const CONFIG_BMC150_MAGN_I2C_MODULE: u32 = 1;
pub const CONFIG_BT_HCIUART_MODULE: u32 = 1;
pub const CONFIG_IPMI_DEVICE_INTERFACE_MODULE: u32 = 1;
pub const CONFIG_ARCH_QCOM: u32 = 1;
pub const CONFIG_COMMON_CLK_RK808_MODULE: u32 = 1;
pub const CONFIG_MSM_MMCC_8996_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_AF9005_MODULE: u32 = 1;
pub const CONFIG_SND_HDA_CIRRUS_SCODEC_MODULE: u32 = 1;
pub const CONFIG_VIDEO_USBTV_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_RT5682_SDW_MODULE: u32 = 1;
pub const CONFIG_SND_HDSP_MODULE: u32 = 1;
pub const CONFIG_RTC_CLASS: u32 = 1;
pub const CONFIG_IPQ_GCC_5018_MODULE: u32 = 1;
pub const CONFIG_PHY_QCOM_QUSB2_MODULE: u32 = 1;
pub const CONFIG_POWER_SEQUENCING_QCOM_WCN_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_RAA215300_MODULE: u32 = 1;
pub const CONFIG_SENSORS_ASUS_ROG_RYUJIN_MODULE: u32 = 1;
pub const CONFIG_INPUT_PWM_BEEPER_MODULE: u32 = 1;
pub const CONFIG_ARM64_4K_PAGES: u32 = 1;
pub const CONFIG_CIFS_SWN_UPCALL: u32 = 1;
pub const CONFIG_CRYPTO_LZO: u32 = 1;
pub const CONFIG_LEDS_IS31FL32XX_MODULE: u32 = 1;
pub const CONFIG_ROCKCHIP_ANALOGIX_DP: u32 = 1;
pub const CONFIG_NLS_CODEPAGE_869_MODULE: u32 = 1;
pub const CONFIG_GPIO_WCD934X_MODULE: u32 = 1;
pub const CONFIG_CPUFREQ_DT_PLATDEV: u32 = 1;
pub const CONFIG_FWNODE_MDIO: u32 = 1;
pub const CONFIG_BATTERY_AXP20X_MODULE: u32 = 1;
pub const CONFIG_PERF_EVENTS: u32 = 1;
pub const CONFIG_DRM_PANIC_BACKGROUND_COLOR: u32 = 0;
pub const CONFIG_IP6_NF_MATCH_AH_MODULE: u32 = 1;
pub const CONFIG_HAVE_HARDLOCKUP_DETECTOR_PERF: u32 = 1;
pub const CONFIG_CORESIGHT_TPDM_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_BOE_TV101WUM_NL6_MODULE: u32 = 1;
pub const CONFIG_RV_REACT_PRINTK: u32 = 1;
pub const CONFIG_SENSORS_SURFACE_FAN_MODULE: u32 = 1;
pub const CONFIG_MHI_WWAN_MBIM_MODULE: u32 = 1;
pub const CONFIG_RESET_ZYNQMP: u32 = 1;
pub const CONFIG_SENSORS_ADT7470_MODULE: u32 = 1;
pub const CONFIG_NET_ACT_VLAN_MODULE: u32 = 1;
pub const CONFIG_TCG_TIS: u32 = 1;
pub const CONFIG_REGULATOR_RTQ2134_MODULE: u32 = 1;
pub const CONFIG_I2C_APPLE_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_JADARD_JD9365DA_H3_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_LED_MODULE: u32 = 1;
pub const CONFIG_SERIAL_8250_NR_UARTS: u32 = 32;
pub const CONFIG_ADIS16550_MODULE: u32 = 1;
pub const CONFIG_CRC8: u32 = 1;
pub const CONFIG_PCIEPORTBUS: u32 = 1;
pub const CONFIG_PCIE_DPC: u32 = 1;
pub const CONFIG_USB_STORAGE_MODULE: u32 = 1;
pub const CONFIG_QCM_GCC_2290_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_LME2510_MODULE: u32 = 1;
pub const CONFIG_SENSORS_TPS53679_MODULE: u32 = 1;
pub const CONFIG_IOMMU_API: u32 = 1;
pub const CONFIG_ZISOFS: u32 = 1;
pub const CONFIG_MAPPING_DIRTY_HELPERS: u32 = 1;
pub const CONFIG_CRYPTO_RSA: u32 = 1;
pub const CONFIG_IPMB_DEVICE_INTERFACE_MODULE: u32 = 1;
pub const CONFIG_HID_LOGITECH_HIDPP_MODULE: u32 = 1;
pub const CONFIG_RVU_ESWITCH_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_WM8994_MODULE: u32 = 1;
pub const CONFIG_VMXNET3_MODULE: u32 = 1;
pub const CONFIG_SERIAL_8250_MANY_PORTS: u32 = 1;
pub const CONFIG_IR_JVC_DECODER_MODULE: u32 = 1;
pub const CONFIG_NVME_TCP_MODULE: u32 = 1;
pub const CONFIG_QCOM_APCS_IPC_MODULE: u32 = 1;
pub const CONFIG_NET_IPGRE_BROADCAST: u32 = 1;
pub const CONFIG_SENSORS_SHTC1_MODULE: u32 = 1;
pub const CONFIG_LOCKD_V4: u32 = 1;
pub const CONFIG_SURFACE_HID_CORE_MODULE: u32 = 1;
pub const CONFIG_DM_DUST_MODULE: u32 = 1;
pub const CONFIG_CIFS_DFS_UPCALL: u32 = 1;
pub const CONFIG_TYPEC_TCPCI_MODULE: u32 = 1;
pub const CONFIG_SDM_GCC_845_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_SONY_TULIP_TRULY_NT35521_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_QDF2XXX_MODULE: u32 = 1;
pub const CONFIG_AQUANTIA_PHY_MODULE: u32 = 1;
pub const CONFIG_TYPEC_TBT_ALTMODE_MODULE: u32 = 1;
pub const CONFIG_WATCHDOG_CORE: u32 = 1;
pub const CONFIG_IIO_ST_ACCEL_3AXIS_MODULE: u32 = 1;
pub const CONFIG_UCSI_CCG_MODULE: u32 = 1;
pub const CONFIG_HAVE_ARCH_KASAN_HW_TAGS: u32 = 1;
pub const CONFIG_SND_HDA_CODEC_HDMI_MODULE: u32 = 1;
pub const CONFIG_NVMEM_REBOOT_MODE_MODULE: u32 = 1;
pub const CONFIG_SCSI_DH_EMC_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_SYNC_DMA_FOR_CPU: u32 = 1;
pub const CONFIG_RTC_LIB_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_VIRTUAL_CONSUMER_MODULE: u32 = 1;
pub const CONFIG_CROS_USBPD_NOTIFY_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_RZ_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_RT6160_MODULE: u32 = 1;
pub const CONFIG_CHARGER_UCS1002_MODULE: u32 = 1;
pub const CONFIG_AS_HAS_ARMV8_2: u32 = 1;
pub const CONFIG_BQL: u32 = 1;
pub const CONFIG_IO_URING: u32 = 1;
pub const CONFIG_HID_SENSOR_ACCEL_3D_MODULE: u32 = 1;
pub const CONFIG_DAMON_PADDR: u32 = 1;
pub const CONFIG_IIO_ADIS_LIB_BUFFER: u32 = 1;
pub const CONFIG_ASYMMETRIC_KEY_TYPE: u32 = 1;
pub const CONFIG_INV_ICM42600_SPI_MODULE: u32 = 1;
pub const CONFIG_ACPI_TABLE_LIB: u32 = 1;
pub const CONFIG_VIDEO_TI_CAL_MC: u32 = 1;
pub const CONFIG_RTC_DRV_PCF8523_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MAX20751_MODULE: u32 = 1;
pub const CONFIG_I2C_SYNQUACER_MODULE: u32 = 1;
pub const CONFIG_INPUT_MOUSE: u32 = 1;
pub const CONFIG_PROC_VMCORE: u32 = 1;
pub const CONFIG_SENSORS_MP2891_MODULE: u32 = 1;
pub const CONFIG_VIDEO_IMX8MQ_MIPI_CSI2_MODULE: u32 = 1;
pub const CONFIG_DEV_DAX_PMEM: u32 = 1;
pub const CONFIG_PHY_SUN4I_USB_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_X1205_MODULE: u32 = 1;
pub const CONFIG_MMC_USHC_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_BOE_TV101WUM_LL2_MODULE: u32 = 1;
pub const CONFIG_KVM_GENERIC_DIRTYLOG_READ_PROTECT: u32 = 1;
pub const CONFIG_DECOMPRESS_XZ: u32 = 1;
pub const CONFIG_MICROCHIP_T1S_PHY_MODULE: u32 = 1;
pub const CONFIG_NVME_HOST_AUTH: u32 = 1;
pub const CONFIG_SND_HDA_CODEC_SIGMATEL_MODULE: u32 = 1;
pub const CONFIG_MLX5_ESWITCH: u32 = 1;
pub const CONFIG_LEDS_PWM_MODULE: u32 = 1;
pub const CONFIG_VIDEO_SAA7134_MODULE: u32 = 1;
pub const CONFIG_USB_LEGOTOWER_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_MSM8996_MODULE: u32 = 1;
pub const CONFIG_TEGRA_ACONNECT_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_MAX6900_MODULE: u32 = 1;
pub const CONFIG_RATIONAL_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_DRM_VC4_MODULE: u32 = 1;
pub const CONFIG_MTD_BLOCK_MODULE: u32 = 1;
pub const CONFIG_CC_HAS_MULTIDIMENSIONAL_NONSTRING: u32 = 1;
pub const CONFIG_SND_RME9652_MODULE: u32 = 1;
pub const CONFIG_SPI_THUNDERX_MODULE: u32 = 1;
pub const CONFIG_NET_DSA_BCM_SF2_MODULE: u32 = 1;
pub const CONFIG_TIPC_CRYPTO: u32 = 1;
pub const CONFIG_ARM_SCPI_POWER_DOMAIN_MODULE: u32 = 1;
pub const CONFIG_INFINIBAND_USER_ACCESS_MODULE: u32 = 1;
pub const CONFIG_NLS_CODEPAGE_737_MODULE: u32 = 1;
pub const CONFIG_SENSORS_SMSC47M192_MODULE: u32 = 1;
pub const CONFIG_MODULES_USE_ELF_RELA: u32 = 1;
pub const CONFIG_NFS_V4_2: u32 = 1;
pub const CONFIG_NVME_KEYRING_MODULE: u32 = 1;
pub const CONFIG_DW_AXI_DMAC_MODULE: u32 = 1;
pub const CONFIG_CPU_FREQ_DEFAULT_GOV_SCHEDUTIL: u32 = 1;
pub const CONFIG_RTC_DRV_RV3029C2_MODULE: u32 = 1;
pub const CONFIG_RT2400PCI_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_RZG2L: u32 = 1;
pub const CONFIG_CLOSURES: u32 = 1;
pub const CONFIG_MFD_AXP20X_I2C: u32 = 1;
pub const CONFIG_ARCH_TEGRA: u32 = 1;
pub const CONFIG_BOOT_CONFIG: u32 = 1;
pub const CONFIG_SND_SOC_CS_AMP_LIB_TEST_MODULE: u32 = 1;
pub const CONFIG_DRM_NOUVEAU_GSP_DEFAULT: u32 = 1;
pub const CONFIG_MUX_ADG792A_MODULE: u32 = 1;
pub const CONFIG_USB_XHCI_HCD: u32 = 1;
pub const CONFIG_HID_KYE_MODULE: u32 = 1;
pub const CONFIG_ETHERNET: u32 = 1;
pub const CONFIG_DRM_IMX_LDB_HELPER_MODULE: u32 = 1;
pub const CONFIG_DRM_PANIC: u32 = 1;
pub const CONFIG_INFINIBAND_RTRS_CLIENT_MODULE: u32 = 1;
pub const CONFIG_DRM_TTM_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV772X_MODULE: u32 = 1;
pub const CONFIG_NFSD_V3_ACL: u32 = 1;
pub const CONFIG_NETFILTER_CONNCOUNT_MODULE: u32 = 1;
pub const CONFIG_MTD_CFI_I2: u32 = 1;
pub const CONFIG_VIDEO_MESON_VDEC_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_FSL_SSI_MODULE: u32 = 1;
pub const CONFIG_DRM_NOUVEAU_SIL164_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_LPASS_VA_MACRO_MODULE: u32 = 1;
pub const CONFIG_SPMI_MSM_PMIC_ARB: u32 = 1;
pub const CONFIG_SND_ENS1371_MODULE: u32 = 1;
pub const CONFIG_CEC_TEGRA_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_QAT_4XXX_MODULE: u32 = 1;
pub const CONFIG_GTP_MODULE: u32 = 1;
pub const CONFIG_ARM64_VA_BITS: u32 = 48;
pub const CONFIG_TREE_SRCU: u32 = 1;
pub const CONFIG_CXL_ACPI_MODULE: u32 = 1;
pub const CONFIG_NETFS_STATS: u32 = 1;
pub const CONFIG_QCOM_RPMPD_MODULE: u32 = 1;
pub const CONFIG_RADIO_SI470X_MODULE: u32 = 1;
pub const CONFIG_SA_GPUCC_8775P_MODULE: u32 = 1;
pub const CONFIG_IWLWIFI_MODULE: u32 = 1;
pub const CONFIG_BT_MTK_MODULE: u32 = 1;
pub const CONFIG_NF_CONNTRACK_AMANDA_MODULE: u32 = 1;
pub const CONFIG_TI_ADS7924_MODULE: u32 = 1;
pub const CONFIG_IRQ_FASTEOI_HIERARCHY_HANDLERS: u32 = 1;
pub const CONFIG_EEPROM_AT24_MODULE: u32 = 1;
pub const CONFIG_BT_HIDP_MODULE: u32 = 1;
pub const CONFIG_SND_MAESTRO3_INPUT: u32 = 1;
pub const CONFIG_SCSI_UFSHCD_PLATFORM_MODULE: u32 = 1;
pub const CONFIG_ACPI_PROCESSOR: u32 = 1;
pub const CONFIG_POWER_RESET_SYSCON_POWEROFF: u32 = 1;
pub const CONFIG_BACKLIGHT_MP3309C_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_STRICT_KERNEL_RWX: u32 = 1;
pub const CONFIG_SUNRPC_BACKCHANNEL: u32 = 1;
pub const CONFIG_I2C_SLAVE: u32 = 1;
pub const CONFIG_RTL8192SE_MODULE: u32 = 1;
pub const CONFIG_ARM64_CONT_PMD_SHIFT: u32 = 4;
pub const CONFIG_WL1251_MODULE: u32 = 1;
pub const CONFIG_ARMV8_DEPRECATED: u32 = 1;
pub const CONFIG_REGULATOR_RTQ6752_MODULE: u32 = 1;
pub const CONFIG_NF_CONNTRACK_TIMEOUT: u32 = 1;
pub const CONFIG_SUN50I_H6_CCU: u32 = 1;
pub const CONFIG_WWAN: u32 = 1;
pub const CONFIG_EFI_ZBOOT: u32 = 1;
pub const CONFIG_HW_RANDOM_BCM2835_MODULE: u32 = 1;
pub const CONFIG_NET_ACT_POLICE_MODULE: u32 = 1;
pub const CONFIG_HID_UCLOGIC_MODULE: u32 = 1;
pub const CONFIG_BLOCK_HOLDER_DEPRECATED: u32 = 1;
pub const CONFIG_HID_WALTOP_MODULE: u32 = 1;
pub const CONFIG_RIONET_TX_SIZE: u32 = 128;
pub const CONFIG_USB_STORAGE_ISD200_MODULE: u32 = 1;
pub const CONFIG_GPIO_CROS_EC_MODULE: u32 = 1;
pub const CONFIG_USB_SNP_CORE_MODULE: u32 = 1;
pub const CONFIG_SENSORS_AQUACOMPUTER_D5NEXT_MODULE: u32 = 1;
pub const CONFIG_DRM_MIPI_DBI_MODULE: u32 = 1;
pub const CONFIG_USB_EHCI_TEGRA_MODULE: u32 = 1;
pub const CONFIG_SCSI_LPFC_MODULE: u32 = 1;
pub const CONFIG_VIDEO_SUN8I_ROTATE_MODULE: u32 = 1;
pub const CONFIG_REALTEK_AUTOPM: u32 = 1;
pub const CONFIG_MCP3911_MODULE: u32 = 1;
pub const CONFIG_VIDEO_IR_I2C_MODULE: u32 = 1;
pub const CONFIG_CC_HAVE_STACKPROTECTOR_SYSREG: u32 = 1;
pub const CONFIG_LEDS_TRIGGER_GPIO_MODULE: u32 = 1;
pub const CONFIG_LV0104CS_MODULE: u32 = 1;
pub const CONFIG_NFT_REJECT_MODULE: u32 = 1;
pub const CONFIG_SND_RME32_MODULE: u32 = 1;
pub const CONFIG_INET_DIAG_DESTROY: u32 = 1;
pub const CONFIG_8139CP_MODULE: u32 = 1;
pub const CONFIG_NET_NS: u32 = 1;
pub const CONFIG_NET_TEAM_MODE_BROADCAST_MODULE: u32 = 1;
pub const CONFIG_CRC16: u32 = 1;
pub const CONFIG_SOCK_CGROUP_DATA: u32 = 1;
pub const CONFIG_VIDEO_CADENCE_CSI2RX_MODULE: u32 = 1;
pub const CONFIG_GPIO_RCAR_MODULE: u32 = 1;
pub const CONFIG_TABLET_USB_PEGASUS_MODULE: u32 = 1;
pub const CONFIG_ISL29003_MODULE: u32 = 1;
pub const CONFIG_JOYSTICK_PSXPAD_SPI_MODULE: u32 = 1;
pub const CONFIG_USB_AUTOSUSPEND_DELAY: u32 = 2;
pub const CONFIG_CRYPTO_SEQIV: u32 = 1;
pub const CONFIG_SND_SOC_ADAU7118_HW_MODULE: u32 = 1;
pub const CONFIG_DP83640_PHY_MODULE: u32 = 1;
pub const CONFIG_ARCH_MMAP_RND_COMPAT_BITS_MAX: u32 = 16;
pub const CONFIG_NLS_CODEPAGE_866_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_RT711_SDW_MODULE: u32 = 1;
pub const CONFIG_SENSORS_FTSTEUTATES_MODULE: u32 = 1;
pub const CONFIG_BRCMSMAC_LEDS: u32 = 1;
pub const CONFIG_IPMI_HANDLER_MODULE: u32 = 1;
pub const CONFIG_MUTEX_SPIN_ON_OWNER: u32 = 1;
pub const CONFIG_SPI_IMX_MODULE: u32 = 1;
pub const CONFIG_ACPI_APEI_GHES: u32 = 1;
pub const CONFIG_FSNOTIFY: u32 = 1;
pub const CONFIG_ARM_TEGRA_DEVFREQ_MODULE: u32 = 1;
pub const CONFIG_NET_FLOW_LIMIT: u32 = 1;
pub const CONFIG_NET_DSA_TAG_KSZ_MODULE: u32 = 1;
pub const CONFIG_FS_DAX_PMD: u32 = 1;
pub const CONFIG_OF_OVERLAY: u32 = 1;
pub const CONFIG_NFT_REJECT_IPV6_MODULE: u32 = 1;
pub const CONFIG_ARCH_BCM: u32 = 1;
pub const CONFIG_CHELSIO_TLS_DEVICE_MODULE: u32 = 1;
pub const CONFIG_GNSS_UBX_SERIAL_MODULE: u32 = 1;
pub const CONFIG_CIFS_MODULE: u32 = 1;
pub const CONFIG_DW_EDMA_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_MESON_VRTC_MODULE: u32 = 1;
pub const CONFIG_DRM_ANALOGIX_ANX78XX_MODULE: u32 = 1;
pub const CONFIG_TEGRA_HSP_MBOX: u32 = 1;
pub const CONFIG_ALX_MODULE: u32 = 1;
pub const CONFIG_CHARGER_QCOM_SMBB_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_ROHM_MODULE: u32 = 1;
pub const CONFIG_PCIE_LAYERSCAPE_GEN4: u32 = 1;
pub const CONFIG_EXT4_KUNIT_TESTS_MODULE: u32 = 1;
pub const CONFIG_INPUT_TOUCHSCREEN: u32 = 1;
pub const CONFIG_VIDEO_OV5670_MODULE: u32 = 1;
pub const CONFIG_BFQ_GROUP_IOSCHED: u32 = 1;
pub const CONFIG_PCI_TEGRA: u32 = 1;
pub const CONFIG_CICADA_PHY_MODULE: u32 = 1;
pub const CONFIG_VIRTIO: u32 = 1;
pub const CONFIG_NET_DROP_MONITOR: u32 = 1;
pub const CONFIG_PHY_QCOM_USB_SS_MODULE: u32 = 1;
pub const CONFIG_IP_SET_HASH_NETIFACE_MODULE: u32 = 1;
pub const CONFIG_SCANF_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_SUN4I_SS_PRNG: u32 = 1;
pub const CONFIG_I2C_SI470X_MODULE: u32 = 1;
pub const CONFIG_SND_INTEL_DSP_CONFIG_MODULE: u32 = 1;
pub const CONFIG_VIDEO_RENESAS_FCP_MODULE: u32 = 1;
pub const CONFIG_VIDEO_UPD64031A_MODULE: u32 = 1;
pub const CONFIG_NET_DSA_TAG_BRCM_LEGACY_MODULE: u32 = 1;
pub const CONFIG_BOSCH_BNO055_I2C_MODULE: u32 = 1;
pub const CONFIG_ARM_SMMU_V3_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_ROCKCHIP_MAX98090_MODULE: u32 = 1;
pub const CONFIG_CLS_U32_PERF: u32 = 1;
pub const CONFIG_ACPI_GTDT: u32 = 1;
pub const CONFIG_MMC_BLOCK_MINORS: u32 = 8;
pub const CONFIG_CRYPTO_DEV_SUN8I_SS_PRNG: u32 = 1;
pub const CONFIG_CRYPTO_USER_API_HASH: u32 = 1;
pub const CONFIG_QED_FCOE: u32 = 1;
pub const CONFIG_PARTITION_ADVANCED: u32 = 1;
pub const CONFIG_IIO_SCMI_MODULE: u32 = 1;
pub const CONFIG_SM_GCC_8250_MODULE: u32 = 1;
pub const CONFIG_JOYSTICK_JOYDUMP_MODULE: u32 = 1;
pub const CONFIG_FSL_RCPM: u32 = 1;
pub const CONFIG_NFT_FIB_INET_MODULE: u32 = 1;
pub const CONFIG_DVB_MT352_MODULE: u32 = 1;
pub const CONFIG_EEPROM_IDT_89HPESX_MODULE: u32 = 1;
pub const CONFIG_PWM_SUN4I_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CS42L42_CORE_MODULE: u32 = 1;
pub const CONFIG_ALTERA_TSE_MODULE: u32 = 1;
pub const CONFIG_SENSORS_LTC4151_MODULE: u32 = 1;
pub const CONFIG_ZRAM_DEF_COMP: &[u8; 8] = b"lzo-rle\0";
pub const CONFIG_SUN6I_MSGBOX: u32 = 1;
pub const CONFIG_ATH5K_PCI: u32 = 1;
pub const CONFIG_TCG_ATMEL_MODULE: u32 = 1;
pub const CONFIG_AS_HAS_ARMV8_3: u32 = 1;
pub const CONFIG_CLK_X1E80100_TCSRCC_MODULE: u32 = 1;
pub const CONFIG_DEBUG_LIST: u32 = 1;
pub const CONFIG_SND_SOC_WM8804_MODULE: u32 = 1;
pub const CONFIG_ATH11K_AHB_MODULE: u32 = 1;
pub const CONFIG_NFSD_MODULE: u32 = 1;
pub const CONFIG_PM_GENERIC_DOMAINS_SLEEP: u32 = 1;
pub const CONFIG_HID_CHICONY_MODULE: u32 = 1;
pub const CONFIG_USB_MA901_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_SHA512_ARM64_CE_MODULE: u32 = 1;
pub const CONFIG_DRM_GPUSVM_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MAX197_MODULE: u32 = 1;
pub const CONFIG_PCI_ECAM: u32 = 1;
pub const CONFIG_SYSTEM_TRUSTED_KEYRING: u32 = 1;
pub const CONFIG_CRYPTO_ZSTD_MODULE: u32 = 1;
pub const CONFIG_ARCH_LAYERSCAPE: u32 = 1;
pub const CONFIG_DM_VERITY_VERIFY_ROOTHASH_SIG_PLATFORM_KEYRING: u32 = 1;
pub const CONFIG_ARCH_MMAP_RND_BITS_MAX: u32 = 33;
pub const CONFIG_BMP280_I2C_MODULE: u32 = 1;
pub const CONFIG_VIDEO_TUNER_MODULE: u32 = 1;
pub const CONFIG_NET_EMATCH_IPSET_MODULE: u32 = 1;
pub const CONFIG_ACPI_NHLT: u32 = 1;
pub const CONFIG_IP_VS_MH_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_XC2028_MODULE: u32 = 1;
pub const CONFIG_BATMAN_ADV_BLA: u32 = 1;
pub const CONFIG_REGULATOR_MAX77857_MODULE: u32 = 1;
pub const CONFIG_CGROUP_DEVICE: u32 = 1;
pub const CONFIG_SM_GPUCC_8650_MODULE: u32 = 1;
pub const CONFIG_USB_NET_CDC_SUBSET_MODULE: u32 = 1;
pub const CONFIG_SENSORS_NTC_THERMISTOR_MODULE: u32 = 1;
pub const CONFIG_VIDEO_MESON_GE2D_MODULE: u32 = 1;
pub const CONFIG_SCSI_FC_ATTRS_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_QUOTA_MODULE: u32 = 1;
pub const CONFIG_SM_VIDEOCC_8350_MODULE: u32 = 1;
pub const CONFIG_VIDEO_SAA7134_DVB_MODULE: u32 = 1;
pub const CONFIG_VIDEO_TVP7002_MODULE: u32 = 1;
pub const CONFIG_HT16K33_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_OPERA1_MODULE: u32 = 1;
pub const CONFIG_ARCH_TEGRA_210_SOC: u32 = 1;
pub const CONFIG_RTC_DRV_PCF8583_MODULE: u32 = 1;
pub const CONFIG_PCIEAER_INJECT_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_MODULE: u32 = 1;
pub const CONFIG_SYNC_FILE: u32 = 1;
pub const CONFIG_BPF_SYSCALL: u32 = 1;
pub const CONFIG_PHY_QCOM_QMP_PCIE_8996_MODULE: u32 = 1;
pub const CONFIG_DEVFREQ_GOV_PASSIVE_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_PF8X00_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_FSL_CAAM_CRYPTO_API_DESC_MODULE: u32 = 1;
pub const CONFIG_ARM_SCMI_POWER_DOMAIN: u32 = 1;
pub const CONFIG_VIDEO_GO7007_MODULE: u32 = 1;
pub const CONFIG_SND_PCI: u32 = 1;
pub const CONFIG_USB_NET_INT51X1_MODULE: u32 = 1;
pub const CONFIG_USB_EHCI_HCD_PLATFORM_MODULE: u32 = 1;
pub const CONFIG_HID_PENMOUNT_MODULE: u32 = 1;
pub const CONFIG_IP_SET_LIST_SET_MODULE: u32 = 1;
pub const CONFIG_LIBFC_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_RS5C348_MODULE: u32 = 1;
pub const CONFIG_ICPLUS_PHY_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV08X40_MODULE: u32 = 1;
pub const CONFIG_BRIDGE_EBT_ARPREPLY_MODULE: u32 = 1;
pub const CONFIG_NFS_V4_2_SSC_HELPER: u32 = 1;
pub const CONFIG_IIO_KFIFO_BUF_MODULE: u32 = 1;
pub const CONFIG_JOYSTICK_INTERACT_MODULE: u32 = 1;
pub const CONFIG_MTD_CFI_I1: u32 = 1;
pub const CONFIG_LEDS_LP3944_MODULE: u32 = 1;
pub const CONFIG_LEDS_AN30259A_MODULE: u32 = 1;
pub const CONFIG_VIRTIO_PCI: u32 = 1;
pub const CONFIG_RD_LZMA: u32 = 1;
pub const CONFIG_DA311_MODULE: u32 = 1;
pub const CONFIG_MFD_INTEL_M10_BMC_PMCI_MODULE: u32 = 1;
pub const CONFIG_W1_SLAVE_DS2408_MODULE: u32 = 1;
pub const CONFIG_NFP_APP_FLOWER: u32 = 1;
pub const CONFIG_VIRTIO_PCI_LEGACY: u32 = 1;
pub const CONFIG_NTFS3_LZX_XPRESS: u32 = 1;
pub const CONFIG_RTC_DRV_DS1685_FAMILY_MODULE: u32 = 1;
pub const CONFIG_RUSTC_SUPPORTS_ARM64: u32 = 1;
pub const CONFIG_SENSORS_BEL_PFE_MODULE: u32 = 1;
pub const CONFIG_HAVE_ARCH_USERFAULTFD_MINOR: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_UPROBES: u32 = 1;
pub const CONFIG_SND_MAESTRO3_MODULE: u32 = 1;
pub const CONFIG_MEMORY_ISOLATION: u32 = 1;
pub const CONFIG_IWLEGACY_DEBUGFS: u32 = 1;
pub const CONFIG_IP_MROUTE: u32 = 1;
pub const CONFIG_JOYSTICK_TMDC_MODULE: u32 = 1;
pub const CONFIG_MFD_QCOM_PM8008_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_DEBUG_VM_PGTABLE: u32 = 1;
pub const CONFIG_VIDEO_CS3308_MODULE: u32 = 1;
pub const CONFIG_FB_SYS_IMAGEBLIT: u32 = 1;
pub const CONFIG_NET_DSA_TAG_NONE_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_FIPS_NAME: &[u8; 31] = b"Linux Kernel Cryptographic API\0";
pub const CONFIG_PTE_MARKER_UFFD_WP: u32 = 1;
pub const CONFIG_MFD_MAX77714_MODULE: u32 = 1;
pub const CONFIG_ZYNQMP_PM_DOMAINS: u32 = 1;
pub const CONFIG_USB_CONFIGFS_F_MIDI2: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_ACPI: u32 = 1;
pub const CONFIG_PREEMPT_DYNAMIC: u32 = 1;
pub const CONFIG_RTL8XXXU_MODULE: u32 = 1;
pub const CONFIG_ROCKCHIP_TIMER: u32 = 1;
pub const CONFIG_TINYDRM_REPAPER_MODULE: u32 = 1;
pub const CONFIG_USB_NET_KALMIA_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_BELKIN_MODULE: u32 = 1;
pub const CONFIG_DRM_ANALOGIX_ANX7625_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_AES_TI_MODULE: u32 = 1;
pub const CONFIG_PHY_MVEBU_CP110_UTMI_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_JITTERENTROPY_OSR: u32 = 1;
pub const CONFIG_HAVE_KRETPROBES: u32 = 1;
pub const CONFIG_TOUCHSCREEN_USB_GOTOP: u32 = 1;
pub const CONFIG_ZSWAP_SHRINKER_DEFAULT_ON: u32 = 1;
pub const CONFIG_SPI_SPIDEV_MODULE: u32 = 1;
pub const CONFIG_RTW88_8814A_MODULE: u32 = 1;
pub const CONFIG_QRTR_SMD_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_PAC207_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_EMULEX: u32 = 1;
pub const CONFIG_MARVELL_88Q2XXX_PHY_MODULE: u32 = 1;
pub const CONFIG_NLS_CODEPAGE_850_MODULE: u32 = 1;
pub const CONFIG_IIO_RESCALE_MODULE: u32 = 1;
pub const CONFIG_IPE_BOOT_POLICY: &[u8; 1] = b"\0";
pub const CONFIG_AD7949_MODULE: u32 = 1;
pub const CONFIG_IR_SUNXI_MODULE: u32 = 1;
pub const CONFIG_SKB_DECRYPTED: u32 = 1;
pub const CONFIG_NINTENDO_FF: u32 = 1;
pub const CONFIG_CORESIGHT_SOURCE_ETM4X_MODULE: u32 = 1;
pub const CONFIG_OPENVSWITCH_GRE_MODULE: u32 = 1;
pub const CONFIG_NLS_MAC_INUIT_MODULE: u32 = 1;
pub const CONFIG_NF_CONNTRACK_BRIDGE_MODULE: u32 = 1;
pub const CONFIG_SND_MESON_AXG_SPDIFIN_MODULE: u32 = 1;
pub const CONFIG_HID_SENSOR_DEVICE_ROTATION_MODULE: u32 = 1;
pub const CONFIG_KEYS: u32 = 1;
pub const CONFIG_ADUX1020_MODULE: u32 = 1;
pub const CONFIG_VIDEO_TVAUDIO_MODULE: u32 = 1;
pub const CONFIG_MT7921S_MODULE: u32 = 1;
pub const CONFIG_IFCVF_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_ISL1208_MODULE: u32 = 1;
pub const CONFIG_DVB_OR51132_MODULE: u32 = 1;
pub const CONFIG_INA2XX_ADC_MODULE: u32 = 1;
pub const CONFIG_I2C_HID_OF_GOODIX_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CS42L43_SDW_MODULE: u32 = 1;
pub const CONFIG_MMC_DW_K3_MODULE: u32 = 1;
pub const CONFIG_IIO_ST_MAGN_I2C_3AXIS_MODULE: u32 = 1;
pub const CONFIG_DRM_WERROR: u32 = 1;
pub const CONFIG_HID_GREENASIA_MODULE: u32 = 1;
pub const CONFIG_CW1200_WLAN_SDIO_MODULE: u32 = 1;
pub const CONFIG_CXD2880_SPI_DRV_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_MMS114_MODULE: u32 = 1;
pub const CONFIG_HID_SENSOR_GYRO_3D_MODULE: u32 = 1;
pub const CONFIG_IPMI_POWEROFF_MODULE: u32 = 1;
pub const CONFIG_TI_ADS7138_MODULE: u32 = 1;
pub const CONFIG_SND_HDA_SCODEC_CS35L56_MODULE: u32 = 1;
pub const CONFIG_CAN_M_CAN_PLATFORM_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_ISL12022_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CS4271_I2C_MODULE: u32 = 1;
pub const CONFIG_IMA_MEASURE_PCR_IDX: u32 = 10;
pub const CONFIG_ARM64_CNP: u32 = 1;
pub const CONFIG_NET_SWITCHDEV: u32 = 1;
pub const CONFIG_ARM_PSCI_CPUIDLE: u32 = 1;
pub const CONFIG_REGMAP_SPI_AVMM_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MP9941_MODULE: u32 = 1;
pub const CONFIG_MACB_USE_HWSTAMP: u32 = 1;
pub const CONFIG_ADXL372_I2C_MODULE: u32 = 1;
pub const CONFIG_DRM_IMX8QXP_LDB_MODULE: u32 = 1;
pub const CONFIG_SCSI_SYM53C8XX_2_MODULE: u32 = 1;
pub const CONFIG_PNFS_BLOCK_MODULE: u32 = 1;
pub const CONFIG_V4L2_ASYNC_MODULE: u32 = 1;
pub const CONFIG_INT_POW_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_AUDIT_GENERIC: u32 = 1;
pub const CONFIG_TURRIS_MOX_RWTM_MODULE: u32 = 1;
pub const CONFIG_QLCNIC_HWMON: u32 = 1;
pub const CONFIG_DRM_PANEL_VISIONOX_RM69299_MODULE: u32 = 1;
pub const CONFIG_SH_TIMER_TMU: u32 = 1;
pub const CONFIG_PSAMPLE_MODULE: u32 = 1;
pub const CONFIG_RTW88_8822BS_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_SOF_IMX_TOPLEVEL: u32 = 1;
pub const CONFIG_DRM_PANEL_ILITEK_IL9322_MODULE: u32 = 1;
pub const CONFIG_I2C_SLAVE_EEPROM_MODULE: u32 = 1;
pub const CONFIG_ACPI_DOCK: u32 = 1;
pub const CONFIG_ACPI_VIDEO_MODULE: u32 = 1;
pub const CONFIG_IO_WQ: u32 = 1;
pub const CONFIG_COMMON_CLK_ROCKCHIP: u32 = 1;
pub const CONFIG_VHOST_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_UTILS_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_RADIO_SI4713_MODULE: u32 = 1;
pub const CONFIG_VIDEO_HANTRO_MODULE: u32 = 1;
pub const CONFIG_HAVE_ARCH_HUGE_VMAP: u32 = 1;
pub const CONFIG_PTP_1588_CLOCK_QORIQ_MODULE: u32 = 1;
pub const CONFIG_VDSO_GETRANDOM: u32 = 1;
pub const CONFIG_RTLBTCOEXIST_MODULE: u32 = 1;
pub const CONFIG_SND_HDA_SCODEC_TAS2781_I2C_MODULE: u32 = 1;
pub const CONFIG_NET_DSA_MV88E6XXX_MODULE: u32 = 1;
pub const CONFIG_VIA_RHINE_MMIO: u32 = 1;
pub const CONFIG_CLK_BCM2835: u32 = 1;
pub const CONFIG_UCSI_LENOVO_YOGA_C630_MODULE: u32 = 1;
pub const CONFIG_AS_VERSION: u32 = 24400;
pub const CONFIG_SENSORS_LT7182S_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_CCP: u32 = 1;
pub const CONFIG_TEST_SORT_MODULE: u32 = 1;
pub const CONFIG_RTW89_8852BE_MODULE: u32 = 1;
pub const CONFIG_AMT_MODULE: u32 = 1;
pub const CONFIG_DRM_MSM_DPU: u32 = 1;
pub const CONFIG_BLK_CGROUP_PUNT_BIO: u32 = 1;
pub const CONFIG_REGULATOR_VEXPRESS_MODULE: u32 = 1;
pub const CONFIG_INET_UDP_DIAG: u32 = 1;
pub const CONFIG_USB_STORAGE_ALAUDA_MODULE: u32 = 1;
pub const CONFIG_NET_SCH_HTB_MODULE: u32 = 1;
pub const CONFIG_IP_VS_FO_MODULE: u32 = 1;
pub const CONFIG_CHELSIO_IPSEC_INLINE_MODULE: u32 = 1;
pub const CONFIG_USB_NET_DRIVERS: u32 = 1;
pub const CONFIG_ARCH_USE_QUEUED_RWLOCKS: u32 = 1;
pub const CONFIG_SCSI_SAS_LIBSAS_MODULE: u32 = 1;
pub const CONFIG_ROCKCHIP_MBOX: u32 = 1;
pub const CONFIG_DVB_TUA6100_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_AC100_MODULE: u32 = 1;
pub const CONFIG_NFT_HASH_MODULE: u32 = 1;
pub const CONFIG_EXTCON_PTN5150_MODULE: u32 = 1;
pub const CONFIG_PWM_IMX27_MODULE: u32 = 1;
pub const CONFIG_IEEE802154_FAKELB_MODULE: u32 = 1;
pub const CONFIG_AIR_EN8811H_PHY_MODULE: u32 = 1;
pub const CONFIG_DRM_I2C_ADV7511_AUDIO: u32 = 1;
pub const CONFIG_ARCH_HAS_RELR: u32 = 1;
pub const CONFIG_UBIFS_FS_AUTHENTICATION: u32 = 1;
pub const CONFIG_IMX8MM_THERMAL_MODULE: u32 = 1;
pub const CONFIG_BRCMFMAC_SDIO: u32 = 1;
pub const CONFIG_EXTCON_USB_GPIO_MODULE: u32 = 1;
pub const CONFIG_ACPI_APEI_EINJ_CXL: u32 = 1;
pub const CONFIG_LEDS_TRIGGER_PATTERN_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_RTQ2208_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_ABX80X_MODULE: u32 = 1;
pub const CONFIG_DM_CRYPT_MODULE: u32 = 1;
pub const CONFIG_IPV6_FOU_TUNNEL_MODULE: u32 = 1;
pub const CONFIG_IRQ_SIM: u32 = 1;
pub const CONFIG_HID_THRUSTMASTER_MODULE: u32 = 1;
pub const CONFIG_RV_REACTORS: u32 = 1;
pub const CONFIG_I2C_HID_OF_ELAN_MODULE: u32 = 1;
pub const CONFIG_NFS_FS_MODULE: u32 = 1;
pub const CONFIG_SOUND_OSS_CORE_PRECLAIM: u32 = 1;
pub const CONFIG_DVB_S5H1420_MODULE: u32 = 1;
pub const CONFIG_BE2NET_BE3: u32 = 1;
pub const CONFIG_NET_VENDOR_NATSEMI: u32 = 1;
pub const CONFIG_IIO_CROS_EC_ACCEL_LEGACY_MODULE: u32 = 1;
pub const CONFIG_CROS_HPS_I2C_MODULE: u32 = 1;
pub const CONFIG_SERIAL_TEGRA_UTC_CONSOLE: u32 = 1;
pub const CONFIG_RTC_DRV_BQ32K_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_AMLOGIC_C3: u32 = 1;
pub const CONFIG_MD_BITMAP_FILE: u32 = 1;
pub const CONFIG_FUTEX_PI: u32 = 1;
pub const CONFIG_HAS_IOPORT_MAP: u32 = 1;
pub const CONFIG_XFRM_STATISTICS: u32 = 1;
pub const CONFIG_STM_MODULE: u32 = 1;
pub const CONFIG_AD7191_MODULE: u32 = 1;
pub const CONFIG_PHY_ROCKCHIP_EMMC_MODULE: u32 = 1;
pub const CONFIG_ZRAM_BACKEND_LZO: u32 = 1;
pub const CONFIG_RTC_DRV_MAX6902_MODULE: u32 = 1;
pub const CONFIG_DWMAC_QCOM_ETHQOS_MODULE: u32 = 1;
pub const CONFIG_IP_VS_PROTO_AH: u32 = 1;
pub const CONFIG_RTC_INTF_DEV: u32 = 1;
pub const CONFIG_NETFILTER_SYNPROXY_MODULE: u32 = 1;
pub const CONFIG_NVMEM_RCAR_EFUSE_MODULE: u32 = 1;
pub const CONFIG_DRM_MSM_MODULE: u32 = 1;
pub const CONFIG_DVB_M88RS2000_MODULE: u32 = 1;
pub const CONFIG_IP6_NF_MATCH_IPV6HEADER_MODULE: u32 = 1;
pub const CONFIG_I2C_AMD_MP2_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DRBG_HMAC: u32 = 1;
pub const CONFIG_ARCH_BINFMT_ELF_EXTRA_PHDRS: u32 = 1;
pub const CONFIG_SNI_NETSEC_MODULE: u32 = 1;
pub const CONFIG_BRIDGE_EBT_STP_MODULE: u32 = 1;
pub const CONFIG_NFS_LOCALIO: u32 = 1;
pub const CONFIG_ZSWAP_ZPOOL_DEFAULT_ZSMALLOC: u32 = 1;
pub const CONFIG_DRM_SSD130X_I2C_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_KEYSPAN_MODULE: u32 = 1;
pub const CONFIG_DVB_SI2165_MODULE: u32 = 1;
pub const CONFIG_MFD_WL1273_CORE_MODULE: u32 = 1;
pub const CONFIG_INTERCONNECT_QCOM_SDM845_MODULE: u32 = 1;
pub const CONFIG_RTL8723BE_MODULE: u32 = 1;
pub const CONFIG_PCIE_PLDA_HOST: u32 = 1;
pub const CONFIG_DRM_IMX_LCDC_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_MARVELL_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_RT5033_MODULE: u32 = 1;
pub const CONFIG_QCOM_PMIC_PDCHARGER_ULOG_MODULE: u32 = 1;
pub const CONFIG_IP6_NF_MATCH_FRAG_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_SUMMIT_MODULE: u32 = 1;
pub const CONFIG_SENSORS_ADCXX_MODULE: u32 = 1;
pub const CONFIG_REALTEK_PHY_HWMON: u32 = 1;
pub const CONFIG_DRM_PANEL_SAMSUNG_SOFEF00_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_PCF85063_MODULE: u32 = 1;
pub const CONFIG_USB_TEGRA_XUDC_MODULE: u32 = 1;
pub const CONFIG_MLX5_EN_IPSEC: u32 = 1;
pub const CONFIG_SENSORS_EMC6W201_MODULE: u32 = 1;
pub const CONFIG_RUST_IS_AVAILABLE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_1508412: u32 = 1;
pub const CONFIG_LINEDISP_MODULE: u32 = 1;
pub const CONFIG_HIBERNATION_DEF_COMP: &[u8; 4] = b"lzo\0";
pub const CONFIG_SENSORS_AMC6821_MODULE: u32 = 1;
pub const CONFIG_MTD_NAND_ECC_SW_HAMMING: u32 = 1;
pub const CONFIG_SPI_OFFLOAD: u32 = 1;
pub const CONFIG_MT7615_COMMON_MODULE: u32 = 1;
pub const CONFIG_DRM_DISPLAY_HELPER_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_MVEBU: u32 = 1;
pub const CONFIG_ARM_APPLE_SOC_CPUFREQ_MODULE: u32 = 1;
pub const CONFIG_PWM_MESON_MODULE: u32 = 1;
pub const CONFIG_ARM64_WORKAROUND_TRBE_OVERWRITE_FILL_MODE: u32 = 1;
pub const CONFIG_RTC_DRV_ZYNQMP_MODULE: u32 = 1;
pub const CONFIG_BRIDGE_EBT_MARK_T_MODULE: u32 = 1;
pub const CONFIG_EDAC_XGENE_MODULE: u32 = 1;
pub const CONFIG_MFD_AXP20X_RSB_MODULE: u32 = 1;
pub const CONFIG_CPU_IDLE_MULTIPLE_DRIVERS: u32 = 1;
pub const CONFIG_MARVELL_PEM_PMU_MODULE: u32 = 1;
pub const CONFIG_CROS_EC_SYSFS_MODULE: u32 = 1;
pub const CONFIG_SUN50I_A100_CCU: u32 = 1;
pub const CONFIG_ECHO_MODULE: u32 = 1;
pub const CONFIG_TRACE_EVAL_MAP_FILE: u32 = 1;
pub const CONFIG_DRM_PANEL_RONBO_RB070D30_MODULE: u32 = 1;
pub const CONFIG_NF_CONNTRACK_PPTP_MODULE: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_LTO_CLANG_THIN: u32 = 1;
pub const CONFIG_ARCH_MMAP_RND_BITS: u32 = 18;
pub const CONFIG_TYPEC_FUSB302_MODULE: u32 = 1;
pub const CONFIG_SENSORS_W83792D_MODULE: u32 = 1;
pub const CONFIG_LIST_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_EROFS_FS_ZIP_LZMA: u32 = 1;
pub const CONFIG_PINCTRL_IMX8QXP: u32 = 1;
pub const CONFIG_DRM_TOSHIBA_TC358768_MODULE: u32 = 1;
pub const CONFIG_SENSORS_TMP464_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_IPCOMP_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_AS3722_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_SOF_MTK_TOPLEVEL: u32 = 1;
pub const CONFIG_MLX5_MPFS: u32 = 1;
pub const CONFIG_MARVELL_CN10K_TAD_PMU_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_WCD938X_MODULE: u32 = 1;
pub const CONFIG_PCIE_DW: u32 = 1;
pub const CONFIG_XFRM_SUB_POLICY: u32 = 1;
pub const CONFIG_ARCH_DEFAULT_CRASH_DUMP: u32 = 1;
pub const CONFIG_RT2800PCI_MODULE: u32 = 1;
pub const CONFIG_PHY_QCOM_SNPS_EUSB2_MODULE: u32 = 1;
pub const CONFIG_PCI_HOST_THUNDER_ECAM: u32 = 1;
pub const CONFIG_IP6_NF_MATCH_RPFILTER_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_SOF_MODULE: u32 = 1;
pub const CONFIG_DRM_BOCHS_MODULE: u32 = 1;
pub const CONFIG_LS_EXTIRQ: u32 = 1;
pub const CONFIG_MTD_CFI_INTELEXT_MODULE: u32 = 1;
pub const CONFIG_MM_ID: u32 = 1;
pub const CONFIG_NET_SCH_SFB_MODULE: u32 = 1;
pub const CONFIG_PHY_FSL_SAMSUNG_HDMI_PHY_MODULE: u32 = 1;
pub const CONFIG_GENERIC_PINCTRL_GROUPS: u32 = 1;
pub const CONFIG_LTC2983_MODULE: u32 = 1;
pub const CONFIG_HID_SENSOR_HUMIDITY_MODULE: u32 = 1;
pub const CONFIG_BMC150_MAGN_SPI_MODULE: u32 = 1;
pub const CONFIG_RTW89_8851B_MODULE: u32 = 1;
pub const CONFIG_MDIO_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CS35L45_SPI_MODULE: u32 = 1;
pub const CONFIG_NF_CT_PROTO_UDPLITE: u32 = 1;
pub const CONFIG_RENESAS_DMA: u32 = 1;
pub const CONFIG_XFS_FS_MODULE: u32 = 1;
pub const CONFIG_DMA_BCM2835_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_DVBSKY_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_QCOM_PM8008_MODULE: u32 = 1;
pub const CONFIG_SX9310_MODULE: u32 = 1;
pub const CONFIG_SENSORS_AD7414_MODULE: u32 = 1;
pub const CONFIG_BMI160_MODULE: u32 = 1;
pub const CONFIG_TINYDRM_ST7735R_MODULE: u32 = 1;
pub const CONFIG_NLS_CODEPAGE_857_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_TEE_MODULE: u32 = 1;
pub const CONFIG_HISI_THERMAL_MODULE: u32 = 1;
pub const CONFIG_QCOM_FALKOR_ERRATUM_E1041: u32 = 1;
pub const CONFIG_PROFILING: u32 = 1;
pub const CONFIG_ARCH_HAS_ZONE_DMA_SET: u32 = 1;
pub const CONFIG_CRYPTO_POLY1305_MODULE: u32 = 1;
pub const CONFIG_VIDEO_SAA7134_GO7007_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_AW88261_MODULE: u32 = 1;
pub const CONFIG_BRCMSTB_L2_IRQ: u32 = 1;
pub const CONFIG_RTW88_8812A_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_1024718: u32 = 1;
pub const CONFIG_CROS_EC_TYPEC_ALTMODES: u32 = 1;
pub const CONFIG_HW_RANDOM_TIMERIOMEM_MODULE: u32 = 1;
pub const CONFIG_SDM_GPUCC_845_MODULE: u32 = 1;
pub const CONFIG_RT2X00_LIB_FIRMWARE: u32 = 1;
pub const CONFIG_BT_HCIBCM203X_MODULE: u32 = 1;
pub const CONFIG_TEST_LOCKUP_MODULE: u32 = 1;
pub const CONFIG_BCM2835_POWER: u32 = 1;
pub const CONFIG_DRM_MESON_DW_HDMI_MODULE: u32 = 1;
pub const CONFIG_SUN50I_DE2_BUS: u32 = 1;
pub const CONFIG_ACPI_WATCHDOG: u32 = 1;
pub const CONFIG_COMMON_CLK_ZYNQMP: u32 = 1;
pub const CONFIG_HID_SAMSUNG_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_SPDIF_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_IT913X_MODULE: u32 = 1;
pub const CONFIG_SND_SIMPLE_CARD_MODULE: u32 = 1;
pub const CONFIG_USB4_NET_MODULE: u32 = 1;
pub const CONFIG_MESON_DDR_PMU_MODULE: u32 = 1;
pub const CONFIG_VIDEO_AMPHION_VPU_MODULE: u32 = 1;
pub const CONFIG_INT_SQRT_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_NLS_CODEPAGE_864_MODULE: u32 = 1;
pub const CONFIG_CAN_8DEV_USB_MODULE: u32 = 1;
pub const CONFIG_USB_CXACRU_MODULE: u32 = 1;
pub const CONFIG_KVM_VFIO: u32 = 1;
pub const CONFIG_F2FS_IOSTAT: u32 = 1;
pub const CONFIG_HID_BPF: u32 = 1;
pub const CONFIG_COMMON_CLK_VC7_MODULE: u32 = 1;
pub const CONFIG_6LOWPAN_NHC_ROUTING_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_FTDI_SIO_MODULE: u32 = 1;
pub const CONFIG_USB_CDNS2_UDC_MODULE: u32 = 1;
pub const CONFIG_SCSI_CONSTANTS: u32 = 1;
pub const CONFIG_HAVE_ARCH_TRANSPARENT_HUGEPAGE: u32 = 1;
pub const CONFIG_NET_SCH_FIFO: u32 = 1;
pub const CONFIG_BRIDGE_VLAN_FILTERING: u32 = 1;
pub const CONFIG_TRACE_IRQFLAGS_NMI_SUPPORT: u32 = 1;
pub const CONFIG_BT_HCIUART_ATH3K: u32 = 1;
pub const CONFIG_OMAP2PLUS_MBOX_MODULE: u32 = 1;
pub const CONFIG_GPIO_VIRTUSER_MODULE: u32 = 1;
pub const CONFIG_TYPEC_TCPM_MODULE: u32 = 1;
pub const CONFIG_PCI_XGENE: u32 = 1;
pub const CONFIG_ARM64_WORKAROUND_REPEAT_TLBI: u32 = 1;
pub const CONFIG_IIO_ST_MAGN_3AXIS_MODULE: u32 = 1;
pub const CONFIG_GPIO_MPSSE_MODULE: u32 = 1;
pub const CONFIG_INFINIBAND_EFA_MODULE: u32 = 1;
pub const CONFIG_I2C_MLXCPLD_MODULE: u32 = 1;
pub const CONFIG_ARCH_TEGRA_234_SOC: u32 = 1;
pub const CONFIG_ARCH_BINFMT_ELF_STATE: u32 = 1;
pub const CONFIG_NLS_DEFAULT: &[u8; 5] = b"utf8\0";
pub const CONFIG_SND_MESON_CARD_UTILS_MODULE: u32 = 1;
pub const CONFIG_THP_SWAP: u32 = 1;
pub const CONFIG_MEDIA_TUNER_XC4000_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MP2975_REGULATOR: u32 = 1;
pub const CONFIG_I2C_XGENE_SLIMPRO_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_ADI_AXI_I2S_MODULE: u32 = 1;
pub const CONFIG_KFIFO_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_USB_ELO: u32 = 1;
pub const CONFIG_EROFS_FS_ONDEMAND: u32 = 1;
pub const CONFIG_RTW88_8723X_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_MSM: u32 = 1;
pub const CONFIG_ARCH_HISI: u32 = 1;
pub const CONFIG_CRYPTO_DH_RFC7919_GROUPS: u32 = 1;
pub const CONFIG_SENSORS_ADT7462_MODULE: u32 = 1;
pub const CONFIG_MESON_GX_SOCINFO: u32 = 1;
pub const CONFIG_INTERCONNECT_CLK: u32 = 1;
pub const CONFIG_RTW88_88XXA_MODULE: u32 = 1;
pub const CONFIG_CC_HAS_MIN_FUNCTION_ALIGNMENT: u32 = 1;
pub const CONFIG_SENSORS_HS3001_MODULE: u32 = 1;
pub const CONFIG_JOYSTICK_XPAD_MODULE: u32 = 1;
pub const CONFIG_BT_MRVL_MODULE: u32 = 1;
pub const CONFIG_SCSI_FDOMAIN_MODULE: u32 = 1;
pub const CONFIG_SENSORS_TC74_MODULE: u32 = 1;
pub const CONFIG_USB_QCOM_EUD_MODULE: u32 = 1;
pub const CONFIG_DMA_NEED_SYNC: u32 = 1;
pub const CONFIG_VEML6030_MODULE: u32 = 1;
pub const CONFIG_AF_RXRPC_DEBUG: u32 = 1;
pub const CONFIG_NLS_ISO8859_13_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CS35L56_MODULE: u32 = 1;
pub const CONFIG_MMC_SDHCI_PCI_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_EGALAX_MODULE: u32 = 1;
pub const CONFIG_RESET_SUNXI: u32 = 1;
pub const CONFIG_MMC_VIA_SDMMC_MODULE: u32 = 1;
pub const CONFIG_CORESIGHT_TRBE_MODULE: u32 = 1;
pub const CONFIG_ARM_SCMI_TRANSPORT_VIRTIO: u32 = 1;
pub const CONFIG_PCIE_APPLE_MSI_DOORBELL_ADDR: u32 = 4294963200;
pub const CONFIG_DRM_AMD_DC: u32 = 1;
pub const CONFIG_DVB_NETUP_UNIDVB_MODULE: u32 = 1;
pub const CONFIG_MTDRAM_TOTAL_SIZE: u32 = 4096;
pub const CONFIG_LOCK_DOWN_KERNEL_FORCE_NONE: u32 = 1;
pub const CONFIG_REGULATOR: u32 = 1;
pub const CONFIG_TYPEC_MUX_PI3USB30532_MODULE: u32 = 1;
pub const CONFIG_HID_PLAYSTATION_MODULE: u32 = 1;
pub const CONFIG_SENSORS_INA3221_MODULE: u32 = 1;
pub const CONFIG_ACPI_I2C_OPREGION: u32 = 1;
pub const CONFIG_NFP_MODULE: u32 = 1;
pub const CONFIG_6LOWPAN_GHC_EXT_HDR_DEST_MODULE: u32 = 1;
pub const CONFIG_PHY_QCOM_QMP_USB_LEGACY_MODULE: u32 = 1;
pub const CONFIG_VIDEO_LM3646_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TAS2562_MODULE: u32 = 1;
pub const CONFIG_PWM_IMX_TPM_MODULE: u32 = 1;
pub const CONFIG_INPUT_SPARSEKMAP_MODULE: u32 = 1;
pub const CONFIG_SCSI_UFS_HISI_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_CONNLABEL_MODULE: u32 = 1;
pub const CONFIG_NXP_ENETC_PF_COMMON_MODULE: u32 = 1;
pub const CONFIG_TORTURE_TEST_MODULE: u32 = 1;
pub const CONFIG_DVB_LGDT3306A_MODULE: u32 = 1;
pub const CONFIG_SERIAL_QCOM_GENI_CONSOLE: u32 = 1;
pub const CONFIG_CLK_RK3562: u32 = 1;
pub const CONFIG_GRO_CELLS: u32 = 1;
pub const CONFIG_TOUCHSCREEN_GOODIX_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_JITTERENTROPY_MEMORY_BLOCKSIZE: u32 = 32;
pub const CONFIG_PACKET_DIAG: u32 = 1;
pub const CONFIG_GENERIC_STRNCPY_FROM_USER: u32 = 1;
pub const CONFIG_ISCSI_TARGET_CXGB4_MODULE: u32 = 1;
pub const CONFIG_HID_RMI_MODULE: u32 = 1;
pub const CONFIG_BE2NET_BE2: u32 = 1;
pub const CONFIG_TEXTSEARCH: u32 = 1;
pub const CONFIG_HAVE_MOVE_PMD: u32 = 1;
pub const CONFIG_NETXEN_NIC_MODULE: u32 = 1;
pub const CONFIG_DRM_LONTIUM_LT9611_MODULE: u32 = 1;
pub const CONFIG_CORESIGHT_SINK_ETBV10_MODULE: u32 = 1;
pub const CONFIG_DRM_XE_ENABLE_SCHEDTIMEOUT_LIMIT: u32 = 1;
pub const CONFIG_VHOST_VDPA_MODULE: u32 = 1;
pub const CONFIG_IWLWIFI_DEBUGFS: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_RECENT_MODULE: u32 = 1;
pub const CONFIG_PROC_EVENTS: u32 = 1;
pub const CONFIG_IIO_CROS_EC_SENSORS_LID_ANGLE_MODULE: u32 = 1;
pub const CONFIG_TEGRA210_EMC_MODULE: u32 = 1;
pub const CONFIG_INFINIBAND_SRP_MODULE: u32 = 1;
pub const CONFIG_USB_F_MIDI2_MODULE: u32 = 1;
pub const CONFIG_FAILOVER_MODULE: u32 = 1;
pub const CONFIG_TYPEC_MUX_NB7VPQ904M_MODULE: u32 = 1;
pub const CONFIG_PAGE_MAPCOUNT: u32 = 1;
pub const CONFIG_LINEAR_RANGES: u32 = 1;
pub const CONFIG_PCI_PWRCTL_SLOT_MODULE: u32 = 1;
pub const CONFIG_NFS_V4_1: u32 = 1;
pub const CONFIG_AMPERE_CORESIGHT_PMU_ARCH_SYSTEM_PMU_MODULE: u32 = 1;
pub const CONFIG_INPUT_MAX77650_ONKEY_MODULE: u32 = 1;
pub const CONFIG_BOSCH_BNO055_SERIAL_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_AK5558_MODULE: u32 = 1;
pub const CONFIG_RAPIDIO_CPS_XX_MODULE: u32 = 1;
pub const CONFIG_APPLE_AIC: u32 = 1;
pub const CONFIG_NF_TPROXY_IPV4_MODULE: u32 = 1;
pub const CONFIG_NF_CONNTRACK_IRC_MODULE: u32 = 1;
pub const CONFIG_SCHED_STACK_END_CHECK: u32 = 1;
pub const CONFIG_DM_LOG_USERSPACE_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_2253138: u32 = 1;
pub const CONFIG_PCI_KEYSTONE: u32 = 1;
pub const CONFIG_DRM_PANEL_ILITEK_ILI9881C_MODULE: u32 = 1;
pub const CONFIG_BRIDGE_EBT_BROUTE_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_PCM3060_I2C_MODULE: u32 = 1;
pub const CONFIG_VIRTIO_DMA_SHARED_BUFFER_MODULE: u32 = 1;
pub const CONFIG_SND_HDA_CORE_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_ALLWINNER: u32 = 1;
pub const CONFIG_SCSI_UFS_CDNS_PLATFORM_MODULE: u32 = 1;
pub const CONFIG_HID: u32 = 1;
pub const CONFIG_CRYPTO_LZ4_MODULE: u32 = 1;
pub const CONFIG_XILINX_XDMA_MODULE: u32 = 1;
pub const CONFIG_DM_VERITY_VERIFY_ROOTHASH_SIG_SECONDARY_KEYRING: u32 = 1;
pub const CONFIG_NET_VENDOR_HISILICON: u32 = 1;
pub const CONFIG_ARM64_RAS_EXTN: u32 = 1;
pub const CONFIG_SCSI_MYRS_MODULE: u32 = 1;
pub const CONFIG_ACPI_REDUCED_HARDWARE_ONLY: u32 = 1;
pub const CONFIG_NFC_PN533_MODULE: u32 = 1;
pub const CONFIG_MTK_T7XX_MODULE: u32 = 1;
pub const CONFIG_NE2K_PCI_MODULE: u32 = 1;
pub const CONFIG_NET_TEAM_MODE_RANDOM_MODULE: u32 = 1;
pub const CONFIG_TI_K3_SOCINFO: u32 = 1;
pub const CONFIG_FPGA_MGR_LATTICE_SYSCONFIG_MODULE: u32 = 1;
pub const CONFIG_INTERCONNECT_IMX8MQ_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_GENERIC_DMAENGINE_PCM: u32 = 1;
pub const CONFIG_VIDEO_BT856_MODULE: u32 = 1;
pub const CONFIG_NFT_MASQ_MODULE: u32 = 1;
pub const CONFIG_HISI_PMU: u32 = 1;
pub const CONFIG_NET_IFE_SKBPRIO_MODULE: u32 = 1;
pub const CONFIG_HID_CP2112_MODULE: u32 = 1;
pub const CONFIG_NET_SCH_TEQL_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_LIB_UTILS: u32 = 1;
pub const CONFIG_SND_SOC_DA7213_MODULE: u32 = 1;
pub const CONFIG_VEML6070_MODULE: u32 = 1;
pub const CONFIG_SG_POOL: u32 = 1;
pub const CONFIG_PWC_RZV2M: u32 = 1;
pub const CONFIG_PHY_MIXEL_LVDS_PHY_MODULE: u32 = 1;
pub const CONFIG_ARM_ARCH_TIMER_EVTSTREAM: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_HUGE_PFNMAP: u32 = 1;
pub const CONFIG_CLK_RASPBERRYPI: u32 = 1;
pub const CONFIG_CRYPTO_DH: u32 = 1;
pub const CONFIG_KFENCE: u32 = 1;
pub const CONFIG_DRM_CROS_EC_ANX7688_MODULE: u32 = 1;
pub const CONFIG_MTD_BLOCK2MTD_MODULE: u32 = 1;
pub const CONFIG_CC_HAS_WORKING_NOSANITIZE_ADDRESS: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_HMARK_MODULE: u32 = 1;
pub const CONFIG_BLK_CGROUP_RWSTAT: u32 = 1;
pub const CONFIG_SND_SOC_LPASS_SC7180_MODULE: u32 = 1;
pub const CONFIG_USB_CDNS3_MODULE: u32 = 1;
pub const CONFIG_QCOM_HIDMA_MODULE: u32 = 1;
pub const CONFIG_NTFS3_FS_POSIX_ACL: u32 = 1;
pub const CONFIG_DRM_PANEL_BOE_BF060Y8M_AJ0_MODULE: u32 = 1;
pub const CONFIG_SMS_SDIO_DRV_MODULE: u32 = 1;
pub const CONFIG_GENERIC_LIB_DEVMEM_IS_ALLOWED: u32 = 1;
pub const CONFIG_DRM_PANEL_VISIONOX_R66451_MODULE: u32 = 1;
pub const CONFIG_CROS_EC_PROTO: u32 = 1;
pub const CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS: u32 = 1;
pub const CONFIG_SURFACE_AGGREGATOR_BUS: u32 = 1;
pub const CONFIG_NET_EMATCH: u32 = 1;
pub const CONFIG_SND_HDA_POWER_SAVE_DEFAULT: u32 = 1;
pub const CONFIG_B44_PCI_AUTOSELECT: u32 = 1;
pub const CONFIG_TYPEC_MODULE: u32 = 1;
pub const CONFIG_VIDEO_HANTRO_ROCKCHIP: u32 = 1;
pub const CONFIG_RPMSG_CHAR_MODULE: u32 = 1;
pub const CONFIG_MODULE_SIG_SHA512: u32 = 1;
pub const CONFIG_DRM_ZYNQMP_DPSUB_MODULE: u32 = 1;
pub const CONFIG_LTC2664_MODULE: u32 = 1;
pub const CONFIG_IP6_NF_MATCH_HL_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_DMA_PREP_COHERENT: u32 = 1;
pub const CONFIG_CLK_QCM2290_GPUCC_MODULE: u32 = 1;
pub const CONFIG_SENSORS_SMSC47M1_MODULE: u32 = 1;
pub const CONFIG_SENSORS_NCT6775_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_OWNER_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA210_AHUB_MODULE: u32 = 1;
pub const CONFIG_MMC_SDHI_INTERNAL_DMAC_MODULE: u32 = 1;
pub const CONFIG_BINFMT_MISC_MODULE: u32 = 1;
pub const CONFIG_CAN_PEAK_PCIEFD_MODULE: u32 = 1;
pub const CONFIG_BLK_DEV_RNBD_CLIENT_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CS35L36_MODULE: u32 = 1;
pub const CONFIG_MT792x_LIB_MODULE: u32 = 1;
pub const CONFIG_FSL_ENETC_VF_MODULE: u32 = 1;
pub const CONFIG_DVB_STV6110x_MODULE: u32 = 1;
pub const CONFIG_USB_PCI: u32 = 1;
pub const CONFIG_SND_SOC_MSM8916_WCD_DIGITAL_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_FINEPIX_MODULE: u32 = 1;
pub const CONFIG_MRP_MODULE: u32 = 1;
pub const CONFIG_SCHED_MM_CID: u32 = 1;
pub const CONFIG_ACPI_VIOT: u32 = 1;
pub const CONFIG_NFSD_BLOCKLAYOUT: u32 = 1;
pub const CONFIG_PWM_DWC_CORE_MODULE: u32 = 1;
pub const CONFIG_ADVISE_SYSCALLS: u32 = 1;
pub const CONFIG_MT76x2U_MODULE: u32 = 1;
pub const CONFIG_THERMAL_GOV_STEP_WISE: u32 = 1;
pub const CONFIG_SND_SOC_SDM845_MODULE: u32 = 1;
pub const CONFIG_NET: u32 = 1;
pub const CONFIG_MOUSE_APPLETOUCH_MODULE: u32 = 1;
pub const CONFIG_ARCH_ENABLE_SPLIT_PMD_PTLOCK: u32 = 1;
pub const CONFIG_INTEGRITY_CA_MACHINE_KEYRING: u32 = 1;
pub const CONFIG_WLAN_VENDOR_MICROCHIP: u32 = 1;
pub const CONFIG_CPU_PM: u32 = 1;
pub const CONFIG_MPL115_I2C_MODULE: u32 = 1;
pub const CONFIG_IEEE802154_ADF7242_MODULE: u32 = 1;
pub const CONFIG_SCSI_MVSAS_TASKLET: u32 = 1;
pub const CONFIG_NET_DSA_TAG_GSWIP_MODULE: u32 = 1;
pub const CONFIG_XFRM_IPCOMP_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_PCTV452E_MODULE: u32 = 1;
pub const CONFIG_GPIO_ACPI: u32 = 1;
pub const CONFIG_NVMEM_LAYERSCAPE_SFP_MODULE: u32 = 1;
pub const CONFIG_AD5110_MODULE: u32 = 1;
pub const CONFIG_DEFAULT_CUBIC: u32 = 1;
pub const CONFIG_XFRM_USER: u32 = 1;
pub const CONFIG_HOTPLUG_PCI_OCTEONEP: u32 = 1;
pub const CONFIG_VFIO_NOIOMMU: u32 = 1;
pub const CONFIG_NLS_CODEPAGE_865_MODULE: u32 = 1;
pub const CONFIG_USB_DEFAULT_AUTHORIZATION_MODE: u32 = 1;
pub const CONFIG_NET_REDIRECT: u32 = 1;
pub const CONFIG_ACPI_THERMAL: u32 = 1;
pub const CONFIG_CRYPTO_DEV_FSL_CAAM_AHASH_API: u32 = 1;
pub const CONFIG_LOAD_UEFI_KEYS: u32 = 1;
pub const CONFIG_VFIO_PLATFORM_AMDXGBE_RESET_MODULE: u32 = 1;
pub const CONFIG_USB_LAN78XX_MODULE: u32 = 1;
pub const CONFIG_SMS_USB_DRV_MODULE: u32 = 1;
pub const CONFIG_GACT_PROB: u32 = 1;
pub const CONFIG_SND_SOC_QDSP6_APM_DAI_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_ENGLEDER: u32 = 1;
pub const CONFIG_ATL1E_MODULE: u32 = 1;
pub const CONFIG_VIDEO_CAMERA_SENSOR: u32 = 1;
pub const CONFIG_TRACEPOINTS: u32 = 1;
pub const CONFIG_SCHED_SMT: u32 = 1;
pub const CONFIG_XLNX_EVENT_MANAGER: u32 = 1;
pub const CONFIG_LIRC: u32 = 1;
pub const CONFIG_UNINLINE_SPIN_UNLOCK: u32 = 1;
pub const CONFIG_HNS_DSAF_MODULE: u32 = 1;
pub const CONFIG_INITRAMFS_SOURCE: &[u8; 1] = b"\0";
pub const CONFIG_EXFAT_FS_MODULE: u32 = 1;
pub const CONFIG_BUG_ON_DATA_CORRUPTION: u32 = 1;
pub const CONFIG_VCNL3020_MODULE: u32 = 1;
pub const CONFIG_B43_PHY_N: u32 = 1;
pub const CONFIG_TIME_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_ARM64_EPAN: u32 = 1;
pub const CONFIG_SIGNED_PE_FILE_VERIFICATION: u32 = 1;
pub const CONFIG_USB_CDNS3_TI_MODULE: u32 = 1;
pub const CONFIG_UNIX98_PTYS: u32 = 1;
pub const CONFIG_RAPIDIO_DISC_TIMEOUT: u32 = 30;
pub const CONFIG_RANDOMIZE_KSTACK_OFFSET: u32 = 1;
pub const CONFIG_SOUNDWIRE_QCOM_MODULE: u32 = 1;
pub const CONFIG_ARM_SMMU_DISABLE_BYPASS_BY_DEFAULT: u32 = 1;
pub const CONFIG_USB_APPLEDISPLAY_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_BOE_TH101MB31UIG002_28A_MODULE: u32 = 1;
pub const CONFIG_PPP_SYNC_TTY_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_CONNBYTES_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_NONLEAF_PMD_YOUNG: u32 = 1;
pub const CONFIG_SM_GPUCC_6115_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_SC8280XP_LPASS_LPI_MODULE: u32 = 1;
pub const CONFIG_HW_RANDOM_CN10K_MODULE: u32 = 1;
pub const CONFIG_JOYSTICK_GRIP_MP_MODULE: u32 = 1;
pub const CONFIG_RTW88_8822BU_MODULE: u32 = 1;
pub const CONFIG_DMA_DECLARE_COHERENT: u32 = 1;
pub const CONFIG_PCI_PF_STUB_MODULE: u32 = 1;
pub const CONFIG_DRM_CIRRUS_QEMU_MODULE: u32 = 1;
pub const CONFIG_DRM_SUBALLOC_HELPER_MODULE: u32 = 1;
pub const CONFIG_VIDEO_RP1_CFE_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MAX1111_MODULE: u32 = 1;
pub const CONFIG_PPP_BSDCOMP_MODULE: u32 = 1;
pub const CONFIG_USB_GADGET_MODULE: u32 = 1;
pub const CONFIG_BRIDGE_EBT_LIMIT_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MC34VR500_MODULE: u32 = 1;
pub const CONFIG_CMDLINE_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_HID_WIIMOTE_MODULE: u32 = 1;
pub const CONFIG_FUJITSU_ERRATUM_010001: u32 = 1;
pub const CONFIG_BACKLIGHT_KTZ8866_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_GHASH_ARM64_CE_MODULE: u32 = 1;
pub const CONFIG_QCOM_RPM_MASTER_STATS_MODULE: u32 = 1;
pub const CONFIG_MEMORY_BALLOON: u32 = 1;
pub const CONFIG_VFIO_MODULE: u32 = 1;
pub const CONFIG_NFC_HCI_MODULE: u32 = 1;
pub const CONFIG_NLS_ISO8859_14_MODULE: u32 = 1;
pub const CONFIG_IMX_SCU_PD: u32 = 1;
pub const CONFIG_STMPE_I2C: u32 = 1;
pub const CONFIG_EXECMEM: u32 = 1;
pub const CONFIG_HARDLOCKUP_DETECTOR_COUNTS_HRTIMER: u32 = 1;
pub const CONFIG_DVB_ZD1301_DEMOD_MODULE: u32 = 1;
pub const CONFIG_DEBUG_INFO_BTF_MODULES: u32 = 1;
pub const CONFIG_COMMON_CLK_QCOM: u32 = 1;
pub const CONFIG_SND_SOC_WM_ADSP_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_REALTEK: u32 = 1;
pub const CONFIG_XFRM_OFFLOAD: u32 = 1;
pub const CONFIG_ZRAM_MULTI_COMP: u32 = 1;
pub const CONFIG_POWER_RESET_QCOM_PON_MODULE: u32 = 1;
pub const CONFIG_PRU_REMOTEPROC_MODULE: u32 = 1;
pub const CONFIG_IPV6_SEG6_LWTUNNEL: u32 = 1;
pub const CONFIG_SDM_GCC_660_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_TDA18212_MODULE: u32 = 1;
pub const CONFIG_CHARGER_CROS_PCHG_MODULE: u32 = 1;
pub const CONFIG_NET_DSA_TAG_RTL4_A_MODULE: u32 = 1;
pub const CONFIG_PCIE_ROCKCHIP_DW: u32 = 1;
pub const CONFIG_SENSORS_LTC2947_I2C_MODULE: u32 = 1;
pub const CONFIG_OVERLAY_FS_MODULE: u32 = 1;
pub const CONFIG_SND_SUN50I_CODEC_ANALOG_MODULE: u32 = 1;
pub const CONFIG_SECONDARY_TRUSTED_KEYRING: u32 = 1;
pub const CONFIG_BT_MODULE: u32 = 1;
pub const CONFIG_ZRAM_BACKEND_DEFLATE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_USB_IDEALTEK: u32 = 1;
pub const CONFIG_BMA180_MODULE: u32 = 1;
pub const CONFIG_VT: u32 = 1;
pub const CONFIG_GENERIC_ARCH_NUMA: u32 = 1;
pub const CONFIG_USB_GSPCA_JEILINJ_MODULE: u32 = 1;
pub const CONFIG_NET_CLS_ACT: u32 = 1;
pub const CONFIG_ARM_TEGRA194_CPUFREQ_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_VISIONOX_VTDR6130_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_MXL111SF_MODULE: u32 = 1;
pub const CONFIG_ET131X_MODULE: u32 = 1;
pub const CONFIG_COMPAT_OLD_SIGACTION: u32 = 1;
pub const CONFIG_EEPROM_MAX6875_MODULE: u32 = 1;
pub const CONFIG_VIDEO_VIMC_MODULE: u32 = 1;
pub const CONFIG_LIBNVDIMM: u32 = 1;
pub const CONFIG_PAHOLE_HAS_LANG_EXCLUDE: u32 = 1;
pub const CONFIG_PHY_QCOM_EDP_MODULE: u32 = 1;
pub const CONFIG_IP_SET_HASH_IPPORTIP_MODULE: u32 = 1;
pub const CONFIG_SMP: u32 = 1;
pub const CONFIG_ARCH_MMAP_RND_COMPAT_BITS: u32 = 11;
pub const CONFIG_REGULATOR_ANATOP_MODULE: u32 = 1;
pub const CONFIG_VLAN_8021Q_MVRP: u32 = 1;
pub const CONFIG_SCSI_BNX2_ISCSI_MODULE: u32 = 1;
pub const CONFIG_R8169_LEDS: u32 = 1;
pub const CONFIG_BT_HCIBTUSB_RTL: u32 = 1;
pub const CONFIG_CFG80211_MODULE: u32 = 1;
pub const CONFIG_NFT_QUOTA_MODULE: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_MSEAL_SYSTEM_MAPPINGS: u32 = 1;
pub const CONFIG_CEPH_FS_POSIX_ACL: u32 = 1;
pub const CONFIG_BT_RTL_MODULE: u32 = 1;
pub const CONFIG_SECURITYFS: u32 = 1;
pub const CONFIG_VIDEO_CX88_DVB_MODULE: u32 = 1;
pub const CONFIG_VIDEO_SOLO6X10_MODULE: u32 = 1;
pub const CONFIG_QUEUED_RWLOCKS: u32 = 1;
pub const CONFIG_DRM_PANEL_ILITEK_ILI9806E_MODULE: u32 = 1;
pub const CONFIG_VMWARE_VMCI_VSOCKETS_MODULE: u32 = 1;
pub const CONFIG_BT_HCIVHCI_MODULE: u32 = 1;
pub const CONFIG_KGDB_SERIAL_CONSOLE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_DCCP_MODULE: u32 = 1;
pub const CONFIG_LSM_MMAP_MIN_ADDR: u32 = 65535;
pub const CONFIG_PINCTRL_SC7180: u32 = 1;
pub const CONFIG_MAC80211_RC_MINSTREL: u32 = 1;
pub const CONFIG_I2C_QCOM_CCI_MODULE: u32 = 1;
pub const CONFIG_VIDEO_CX231XX_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_HASHLIMIT_MODULE: u32 = 1;
pub const CONFIG_HAVE_ARCH_AUDITSYSCALL: u32 = 1;
pub const CONFIG_REGULATOR_PFUZE100_MODULE: u32 = 1;
pub const CONFIG_IMA_QUEUE_EARLY_BOOT_KEYS: u32 = 1;
pub const CONFIG_SND_HDA_SCODEC_TAS2781_SPI_MODULE: u32 = 1;
pub const CONFIG_ROCKCHIP_PHY_MODULE: u32 = 1;
pub const CONFIG_BLK_DEV_LOOP_MODULE: u32 = 1;
pub const CONFIG_IPV6_SUBTREES: u32 = 1;
pub const CONFIG_FTRACE_MCOUNT_USE_PATCHABLE_FUNCTION_ENTRY: u32 = 1;
pub const CONFIG_VIDEO_SYNOPSYS_HDMIRX_LOAD_DEFAULT_EDID: u32 = 1;
pub const CONFIG_SENSORS_ADT7310_MODULE: u32 = 1;
pub const CONFIG_SETEND_EMULATION: u32 = 1;
pub const CONFIG_HID_EMS_FF_MODULE: u32 = 1;
pub const CONFIG_PHY_HI3660_USB_MODULE: u32 = 1;
pub const CONFIG_SPEAKUP_MODULE: u32 = 1;
pub const CONFIG_MICROSEMI_PHY_MODULE: u32 = 1;
pub const CONFIG_HID_SENSOR_IIO_TRIGGER_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV2659_MODULE: u32 = 1;
pub const CONFIG_BTRFS_FS_POSIX_ACL: u32 = 1;
pub const CONFIG_CLK_X1E80100_CAMCC_MODULE: u32 = 1;
pub const CONFIG_GPIO_PL061: u32 = 1;
pub const CONFIG_HID_UDRAW_PS3_MODULE: u32 = 1;
pub const CONFIG_HID_APPLE_MODULE: u32 = 1;
pub const CONFIG_XILINX_INTC: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA_SGTL5000_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_DIGITV_MODULE: u32 = 1;
pub const CONFIG_ACPI_GENERIC_GSI: u32 = 1;
pub const CONFIG_DRM_MXS: u32 = 1;
pub const CONFIG_AC97_BUS_MODULE: u32 = 1;
pub const CONFIG_STK3310_MODULE: u32 = 1;
pub const CONFIG_VIDEO_SAA7134_ALSA_MODULE: u32 = 1;
pub const CONFIG_USB_BELKIN: u32 = 1;
pub const CONFIG_DRM_RADEON_USERPTR: u32 = 1;
pub const CONFIG_SND_SOC_RT5682S_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_WM_HUBS_MODULE: u32 = 1;
pub const CONFIG_RCU_STALL_COMMON: u32 = 1;
pub const CONFIG_USB_UEAGLEATM_MODULE: u32 = 1;
pub const CONFIG_BLK_DEV_ZONED: u32 = 1;
pub const CONFIG_RT2X00_LIB_MODULE: u32 = 1;
pub const CONFIG_HAVE_ASM_MODVERSIONS: u32 = 1;
pub const CONFIG_DVB_STB6100_MODULE: u32 = 1;
pub const CONFIG_HID_SENSOR_IIO_COMMON_MODULE: u32 = 1;
pub const CONFIG_QCOM_GSBI: u32 = 1;
pub const CONFIG_IMX_MBOX_MODULE: u32 = 1;
pub const CONFIG_TCP_CONG_CDG_MODULE: u32 = 1;
pub const CONFIG_INFINIBAND_ADDR_TRANS: u32 = 1;
pub const CONFIG_QCOM_CLK_RPMH: u32 = 1;
pub const CONFIG_DRM_PANEL_HIMAX_HX8394_MODULE: u32 = 1;
pub const CONFIG_PCIE_CADENCE: u32 = 1;
pub const CONFIG_INTERCONNECT_IMX8MP_MODULE: u32 = 1;
pub const CONFIG_APDS9960_MODULE: u32 = 1;
pub const CONFIG_NFS_DEBUG: u32 = 1;
pub const CONFIG_PHY_HISTB_COMBPHY_MODULE: u32 = 1;
pub const CONFIG_AUDIT_ARCH_COMPAT_GENERIC: u32 = 1;
pub const CONFIG_RESET_MESON_AUX: u32 = 1;
pub const CONFIG_MDIO_HISI_FEMAC_MODULE: u32 = 1;
pub const CONFIG_PHY_MIXEL_MIPI_DPHY_MODULE: u32 = 1;
pub const CONFIG_NET_FC: u32 = 1;
pub const CONFIG_BT_HCIRSI_MODULE: u32 = 1;
pub const CONFIG_ARMADA_37XX_WATCHDOG_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_WCD934X_MODULE: u32 = 1;
pub const CONFIG_DA_MON_EVENTS_ID: u32 = 1;
pub const CONFIG_TINYDRM_ILI9486_MODULE: u32 = 1;
pub const CONFIG_SCSI_LOGGING: u32 = 1;
pub const CONFIG_VIDEO_ISL7998X_MODULE: u32 = 1;
pub const CONFIG_HAVE_PERF_EVENTS: u32 = 1;
pub const CONFIG_PHY_CADENCE_SALVO_MODULE: u32 = 1;
pub const CONFIG_RFKILL_LEDS: u32 = 1;
pub const CONFIG_DRM_FBDEV_OVERALLOC: u32 = 100;
pub const CONFIG_ARM_SCMI_POWER_CONTROL: u32 = 1;
pub const CONFIG_SECRETMEM: u32 = 1;
pub const CONFIG_MSA311_MODULE: u32 = 1;
pub const CONFIG_IO_STRICT_DEVMEM: u32 = 1;
pub const CONFIG_VIDEO_OV2685_MODULE: u32 = 1;
pub const CONFIG_DM_VERITY_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_QCOM_RPMH: u32 = 1;
pub const CONFIG_CONSOLE_POLL: u32 = 1;
pub const CONFIG_HW_RANDOM_OPTEE_MODULE: u32 = 1;
pub const CONFIG_NFT_NUMGEN_MODULE: u32 = 1;
pub const CONFIG_ARM_GIC_V3_ITS: u32 = 1;
pub const CONFIG_ATM_MODULE: u32 = 1;
pub const CONFIG_NET_SCH_MQPRIO_MODULE: u32 = 1;
pub const CONFIG_SENSORS_APDS990X_MODULE: u32 = 1;
pub const CONFIG_W1_SLAVE_DS2423_MODULE: u32 = 1;
pub const CONFIG_ROCKCHIP_VOP: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_U32_MODULE: u32 = 1;
pub const CONFIG_DVB_DM1105_MODULE: u32 = 1;
pub const CONFIG_SCSI_SYM53C8XX_MMIO: u32 = 1;
pub const CONFIG_NLS_CODEPAGE_855_MODULE: u32 = 1;
pub const CONFIG_USB_DWC2_DUAL_ROLE: u32 = 1;
pub const CONFIG_RTC_DRV_DS1511_MODULE: u32 = 1;
pub const CONFIG_NGBE_MODULE: u32 = 1;
pub const CONFIG_IP6_NF_TARGET_HL_MODULE: u32 = 1;
pub const CONFIG_HUGETLB_PMD_PAGE_TABLE_SHARING: u32 = 1;
pub const CONFIG_BMI270_I2C_MODULE: u32 = 1;
pub const CONFIG_NET_KEY_MIGRATE: u32 = 1;
pub const CONFIG_PINCTRL_ARMADA_AP806: u32 = 1;
pub const CONFIG_APDS9160_MODULE: u32 = 1;
pub const CONFIG_SND_INDIGODJX_MODULE: u32 = 1;
pub const CONFIG_USB_STORAGE_KARMA_MODULE: u32 = 1;
pub const CONFIG_VIDEO_AK7375_MODULE: u32 = 1;
pub const CONFIG_HID_MAYFLASH_MODULE: u32 = 1;
pub const CONFIG_B43LEGACY_PCI_AUTOSELECT: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_826319: u32 = 1;
pub const CONFIG_MEMSTICK_JMICRON_38X_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_QT1010_MODULE: u32 = 1;
pub const CONFIG_BONDING_MODULE: u32 = 1;
pub const CONFIG_PCIE_TPH: u32 = 1;
pub const CONFIG_LTO_NONE: u32 = 1;
pub const CONFIG_LEDS_QNAP_MCU_MODULE: u32 = 1;
pub const CONFIG_SURFACE_DTX_MODULE: u32 = 1;
pub const CONFIG_NLS_CODEPAGE_862_MODULE: u32 = 1;
pub const CONFIG_TYPEC_MUX_IT5205_MODULE: u32 = 1;
pub const CONFIG_SERIAL_8250_PCI1XXXX: u32 = 1;
pub const CONFIG_MFD_HI655X_PMIC_MODULE: u32 = 1;
pub const CONFIG_HAVE_DMA_CONTIGUOUS: u32 = 1;
pub const CONFIG_HNS3_ENET_MODULE: u32 = 1;
pub const CONFIG_USB_TEGRA_PHY_MODULE: u32 = 1;
pub const CONFIG_HID_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV6650_MODULE: u32 = 1;
pub const CONFIG_DVB_ISL6405_MODULE: u32 = 1;
pub const CONFIG_MTD_PHYSMAP_MODULE: u32 = 1;
pub const CONFIG_RTW88_8723DS_MODULE: u32 = 1;
pub const CONFIG_SENSORS_ADT7475_MODULE: u32 = 1;
pub const CONFIG_ARCH_PROC_KCORE_TEXT: u32 = 1;
pub const CONFIG_MTD_CFI_STAA_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MP2993_MODULE: u32 = 1;
pub const CONFIG_CAN_NETLINK: u32 = 1;
pub const CONFIG_JFFS2_FS_XATTR: u32 = 1;
pub const CONFIG_BACKLIGHT_CLASS_DEVICE: u32 = 1;
pub const CONFIG_CFG80211_DEBUGFS: u32 = 1;
pub const CONFIG_KEYBOARD_TEGRA_MODULE: u32 = 1;
pub const CONFIG_NF_TABLES_MODULE: u32 = 1;
pub const CONFIG_SERIAL_FSL_LINFLEXUART: u32 = 1;
pub const CONFIG_CRYPTO_MANAGER: u32 = 1;
pub const CONFIG_ADXL367_SPI_MODULE: u32 = 1;
pub const CONFIG_SC_GPUCC_8280XP_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_FSL_FTM_ALARM_MODULE: u32 = 1;
pub const CONFIG_USB_F_EEM_MODULE: u32 = 1;
pub const CONFIG_LOGO_LINUX_CLUT224: u32 = 1;
pub const CONFIG_HIBERNATION_COMP_LZO: u32 = 1;
pub const CONFIG_SENSORS_PCF8591_MODULE: u32 = 1;
pub const CONFIG_SUSPEND_FREEZER: u32 = 1;
pub const CONFIG_NET_VENDOR_MARVELL: u32 = 1;
pub const CONFIG_CAN_ISOTP_MODULE: u32 = 1;
pub const CONFIG_NVMEM_ROCKCHIP_EFUSE_MODULE: u32 = 1;
pub const CONFIG_RTW89_CORE_MODULE: u32 = 1;
pub const CONFIG_SCSI_DC395x_MODULE: u32 = 1;
pub const CONFIG_DVB_NET: u32 = 1;
pub const CONFIG_SSB_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_LIB_POLY1305_GENERIC_MODULE: u32 = 1;
pub const CONFIG_DECOMPRESS_LZO: u32 = 1;
pub const CONFIG_QRTR_MHI_MODULE: u32 = 1;
pub const CONFIG_ARM_TEGRA124_CPUFREQ: u32 = 1;
pub const CONFIG_OVERLAY_FS_REDIRECT_ALWAYS_FOLLOW: u32 = 1;
pub const CONFIG_NLS_ISO8859_15_MODULE: u32 = 1;
pub const CONFIG_LEDS_PWM_MULTICOLOR_MODULE: u32 = 1;
pub const CONFIG_ARCH_R9A07G044: u32 = 1;
pub const CONFIG_HAVE_ARCH_STACKLEAK: u32 = 1;
pub const CONFIG_BACKLIGHT_QCOM_WLED_MODULE: u32 = 1;
pub const CONFIG_MEDIA_CAMERA_SUPPORT: u32 = 1;
pub const CONFIG_CHARLCD_MODULE: u32 = 1;
pub const CONFIG_RFKILL_GPIO_MODULE: u32 = 1;
pub const CONFIG_SM_TCSRCC_8650_MODULE: u32 = 1;
pub const CONFIG_NET_DSA_SMSC_LAN9303_I2C_MODULE: u32 = 1;
pub const CONFIG_TYPEC_MUX_TUSB1046_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_ROCKCHIP: u32 = 1;
pub const CONFIG_ARM64_USE_LSE_ATOMICS: u32 = 1;
pub const CONFIG_SND_SEQ_UMP: u32 = 1;
pub const CONFIG_VIDEO_VIVID_CEC: u32 = 1;
pub const CONFIG_NET_SCH_PLUG_MODULE: u32 = 1;
pub const CONFIG_NET_DSA_TAG_SJA1105_MODULE: u32 = 1;
pub const CONFIG_DEV_DAX_CXL_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_CLUSTER_MODULE: u32 = 1;
pub const CONFIG_VIDEO_SAA6752HS_MODULE: u32 = 1;
pub const CONFIG_PPP_MULTILINK: u32 = 1;
pub const CONFIG_QCOM_QMI_HELPERS_MODULE: u32 = 1;
pub const CONFIG_LZ4_DECOMPRESS: u32 = 1;
pub const CONFIG_USB_SERIAL_IR_MODULE: u32 = 1;
pub const CONFIG_DRM_SUN8I_DW_HDMI_MODULE: u32 = 1;
pub const CONFIG_MFD_RK8XX_I2C_MODULE: u32 = 1;
pub const CONFIG_SND_HDA_CODEC_CA0132_MODULE: u32 = 1;
pub const CONFIG_IP_VS_PROTO_ESP: u32 = 1;
pub const CONFIG_SND_SOC_CS35L45_MODULE: u32 = 1;
pub const CONFIG_SCSI_CHELSIO_FCOE_MODULE: u32 = 1;
pub const CONFIG_VIDEO_TI_J721E_CSI2RX_MODULE: u32 = 1;
pub const CONFIG_QUOTA_NETLINK_INTERFACE: u32 = 1;
pub const CONFIG_USB_EMI62_MODULE: u32 = 1;
pub const CONFIG_NFT_DUP_NETDEV_MODULE: u32 = 1;
pub const CONFIG_SENSORS_XGENE_MODULE: u32 = 1;
pub const CONFIG_SCSI_SAS_HOST_SMP: u32 = 1;
pub const CONFIG_IIO_ST_SENSORS_CORE_MODULE: u32 = 1;
pub const CONFIG_IP6_NF_NAT_MODULE: u32 = 1;
pub const CONFIG_RD_LZO: u32 = 1;
pub const CONFIG_RTW89_8852C_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_AQUANTIA: u32 = 1;
pub const CONFIG_HID_LENOVO_MODULE: u32 = 1;
pub const CONFIG_CEPH_FS_MODULE: u32 = 1;
pub const CONFIG_DRM_DISPLAY_HDMI_STATE_HELPER: u32 = 1;
pub const CONFIG_RASPBERRYPI_FIRMWARE: u32 = 1;
pub const CONFIG_ATA_SFF: u32 = 1;
pub const CONFIG_INPUT_MOUSEDEV_SCREEN_X: u32 = 1024;
pub const CONFIG_ALTERA_PR_IP_CORE_PLAT_MODULE: u32 = 1;
pub const CONFIG_PINCTRL: u32 = 1;
pub const CONFIG_PINCTRL_LPASS_LPI_MODULE: u32 = 1;
pub const CONFIG_PHY_QCOM_QMP_USB_MODULE: u32 = 1;
pub const CONFIG_SENSORS_PIM4328_MODULE: u32 = 1;
pub const CONFIG_SCSI_PROTO_TEST_MODULE: u32 = 1;
pub const CONFIG_SUN55I_A523_R_CCU_MODULE: u32 = 1;
pub const CONFIG_DRM_DW_MIPI_DSI_MODULE: u32 = 1;
pub const CONFIG_STP_MODULE: u32 = 1;
pub const CONFIG_PHY_MESON_G12A_USB3_PCIE_MODULE: u32 = 1;
pub const CONFIG_APPLE_ADMAC_MODULE: u32 = 1;
pub const CONFIG_ATH9K_PCI_NO_EEPROM_MODULE: u32 = 1;
pub const CONFIG_GPIO_MAX77650_MODULE: u32 = 1;
pub const CONFIG_NFC_NXP_NCI_MODULE: u32 = 1;
pub const CONFIG_TCM_QLA2XXX_MODULE: u32 = 1;
pub const CONFIG_SENSORS_HTU31_MODULE: u32 = 1;
pub const CONFIG_MCP320X_MODULE: u32 = 1;
pub const CONFIG_JME_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_VISOR_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_845719: u32 = 1;
pub const CONFIG_PINCTRL_AS3722: u32 = 1;
pub const CONFIG_BE2NET_MODULE: u32 = 1;
pub const CONFIG_NET_SCH_RED_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_SCPI_MODULE: u32 = 1;
pub const CONFIG_DAMON_VADDR: u32 = 1;
pub const CONFIG_DVB_VES1X93_MODULE: u32 = 1;
pub const CONFIG_VIDEO_MT9V011_MODULE: u32 = 1;
pub const CONFIG_VIDEO_TVEEPROM_MODULE: u32 = 1;
pub const CONFIG_NF_TPROXY_IPV6_MODULE: u32 = 1;
pub const CONFIG_STAGING: u32 = 1;
pub const CONFIG_SENSORS_CROS_EC_MODULE: u32 = 1;
pub const CONFIG_SCSI_DH_HP_SW_MODULE: u32 = 1;
pub const CONFIG_MISC_RTSX_MODULE: u32 = 1;
pub const CONFIG_QCOM_SMP2P_MODULE: u32 = 1;
pub const CONFIG_MEDIA_CONTROLLER: u32 = 1;
pub const CONFIG_RTC_DRV_EM3027_MODULE: u32 = 1;
pub const CONFIG_DRM_DW_HDMI_I2S_AUDIO_MODULE: u32 = 1;
pub const CONFIG_USB_SUPPORT: u32 = 1;
pub const CONFIG_WLCORE_SDIO_MODULE: u32 = 1;
pub const CONFIG_DVB_MXL5XX_MODULE: u32 = 1;
pub const CONFIG_TCG_TIS_CORE: u32 = 1;
pub const CONFIG_IP_VS_LBLC_MODULE: u32 = 1;
pub const CONFIG_ACPI_PROCESSOR_IDLE: u32 = 1;
pub const CONFIG_CRYPTO_JITTERENTROPY: u32 = 1;
pub const CONFIG_PREVENT_FIRMWARE_BUILD: u32 = 1;
pub const CONFIG_W1_MASTER_UART_MODULE: u32 = 1;
pub const CONFIG_SENSORS_ATXP1_MODULE: u32 = 1;
pub const CONFIG_HW_RANDOM_VIRTIO: u32 = 1;
pub const CONFIG_FXOS8700_SPI_MODULE: u32 = 1;
pub const CONFIG_MEGARAID_SAS_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_AMLOGIC_A4: u32 = 1;
pub const CONFIG_DRM_XE_PREEMPT_TIMEOUT_MAX: u32 = 10000000;
pub const CONFIG_NVMEM_SPMI_SDAM_MODULE: u32 = 1;
pub const CONFIG_DRM_ITE_IT66121_MODULE: u32 = 1;
pub const CONFIG_IP_VS_TAB_BITS: u32 = 12;
pub const CONFIG_PWM_PCA9685_MODULE: u32 = 1;
pub const CONFIG_USB_MV_UDC_MODULE: u32 = 1;
pub const CONFIG_NFC_TRF7970A_MODULE: u32 = 1;
pub const CONFIG_USB_CONFIGFS_SERIAL: u32 = 1;
pub const CONFIG_MFD_MAX77705_MODULE: u32 = 1;
pub const CONFIG_SENSORS_FSP_3Y_MODULE: u32 = 1;
pub const CONFIG_CC_HAS_SANCOV_TRACE_PC: u32 = 1;
pub const CONFIG_QCOM_KRYO_L2_ACCESSORS: u32 = 1;
pub const CONFIG_PSTORE_COMPRESS: u32 = 1;
pub const CONFIG_REGULATOR_QCOM_USB_VBUS_MODULE: u32 = 1;
pub const CONFIG_USB_ULPI: u32 = 1;
pub const CONFIG_DM_ZERO: u32 = 1;
pub const CONFIG_RTW88_8814AU_MODULE: u32 = 1;
pub const CONFIG_HW_PERF_EVENTS: u32 = 1;
pub const CONFIG_I2C_GPIO_MODULE: u32 = 1;
pub const CONFIG_IP_SET_HASH_NETNET_MODULE: u32 = 1;
pub const CONFIG_RESET_MESON_AUDIO_ARB_MODULE: u32 = 1;
pub const CONFIG_FW_LOADER_COMPRESS_ZSTD: u32 = 1;
pub const CONFIG_LEDS_QCOM_FLASH_MODULE: u32 = 1;
pub const CONFIG_IR_REDRAT3_MODULE: u32 = 1;
pub const CONFIG_NFT_LIMIT_MODULE: u32 = 1;
pub const CONFIG_IPV6_TUNNEL_MODULE: u32 = 1;
pub const CONFIG_XZ_DEC_ARMTHUMB: u32 = 1;
pub const CONFIG_VIDEO_ADV7604_MODULE: u32 = 1;
pub const CONFIG_BT_HCIUART_SERDEV: u32 = 1;
pub const CONFIG_ZONE_DMA32: u32 = 1;
pub const CONFIG_EDAC_QCOM_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_1165522: u32 = 1;
pub const CONFIG_CC_HAS_KASAN_GENERIC: u32 = 1;
pub const CONFIG_NET_FAILOVER_MODULE: u32 = 1;
pub const CONFIG_MLXSW_SPECTRUM_DCB: u32 = 1;
pub const CONFIG_KEXEC_FILE: u32 = 1;
pub const CONFIG_B43_PIO: u32 = 1;
pub const CONFIG_SND_SOC_RK817_MODULE: u32 = 1;
pub const CONFIG_SENSORS_ADM1031_MODULE: u32 = 1;
pub const CONFIG_PRINTK_TIME: u32 = 1;
pub const CONFIG_QCOM_SMEM_MODULE: u32 = 1;
pub const CONFIG_PHY_ROCKCHIP_USBDP_MODULE: u32 = 1;
pub const CONFIG_DAMON_SYSFS: u32 = 1;
pub const CONFIG_TSL2772_MODULE: u32 = 1;
pub const CONFIG_TIFM_7XX1_MODULE: u32 = 1;
pub const CONFIG_ARM_ALLWINNER_SUN50I_CPUFREQ_NVMEM_MODULE: u32 = 1;
pub const CONFIG_INTERCONNECT_QCOM_MSM8953_MODULE: u32 = 1;
pub const CONFIG_HOLTEK_FF: u32 = 1;
pub const CONFIG_SND_SOC_CS35L34_MODULE: u32 = 1;
pub const CONFIG_I2C_CROS_EC_TUNNEL_MODULE: u32 = 1;
pub const CONFIG_KUNIT_EXAMPLE_TEST_MODULE: u32 = 1;
pub const CONFIG_BOSCH_BNO055_MODULE: u32 = 1;
pub const CONFIG_GREENASIA_FF: u32 = 1;
pub const CONFIG_FSCACHE_STATS: u32 = 1;
pub const CONFIG_REGULATOR_RASPBERRYPI_TOUCHSCREEN_ATTINY_MODULE: u32 = 1;
pub const CONFIG_APPLE_MFI_FASTCHARGE_MODULE: u32 = 1;
pub const CONFIG_ACPI_CPPC_LIB: u32 = 1;
pub const CONFIG_DMI_SYSFS: u32 = 1;
pub const CONFIG_ZLIB_INFLATE: u32 = 1;
pub const CONFIG_ARCH_WANTS_THP_SWAP: u32 = 1;
pub const CONFIG_VIDEO_ML86V7667_MODULE: u32 = 1;
pub const CONFIG_FPROBE_EVENTS: u32 = 1;
pub const CONFIG_HID_BIGBEN_FF_MODULE: u32 = 1;
pub const CONFIG_HID_BETOP_FF_MODULE: u32 = 1;
pub const CONFIG_HAVE_KVM_VCPU_RUN_PID_CHANGE: u32 = 1;
pub const CONFIG_ROCKCHIP_DTPM_MODULE: u32 = 1;
pub const CONFIG_NOVA_CORE_MODULE: u32 = 1;
pub const CONFIG_IMX9_BLK_CTRL: u32 = 1;
pub const CONFIG_W1_MASTER_DS2482_MODULE: u32 = 1;
pub const CONFIG_MEMCPY_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_MTD_UBI_MODULE: u32 = 1;
pub const CONFIG_NLS_CODEPAGE_863_MODULE: u32 = 1;
pub const CONFIG_SERIAL_8250_OMAP: u32 = 1;
pub const CONFIG_RTC_DRV_RP5C01_MODULE: u32 = 1;
pub const CONFIG_MFD_MAX77686: u32 = 1;
pub const CONFIG_BLK_DEV_RAM_MODULE: u32 = 1;
pub const CONFIG_VGA_ARB: u32 = 1;
pub const CONFIG_CRYPTO_LIB_CURVE25519_MODULE: u32 = 1;
pub const CONFIG_LOGIRUMBLEPAD2_FF: u32 = 1;
pub const CONFIG_IMX_MU_MSI_MODULE: u32 = 1;
pub const CONFIG_GENERIC_IOREMAP: u32 = 1;
pub const CONFIG_SC_VIDEOCC_7280_MODULE: u32 = 1;
pub const CONFIG_DP83TG720_PHY_MODULE: u32 = 1;
pub const CONFIG_ATL1C_MODULE: u32 = 1;
pub const CONFIG_APDS9802ALS_MODULE: u32 = 1;
pub const CONFIG_ARCH_R9A09G011: u32 = 1;
pub const CONFIG_CRYPTO_DEV_SUN4I_SS_MODULE: u32 = 1;
pub const CONFIG_PWM_ADP5585_MODULE: u32 = 1;
pub const CONFIG_USB_EPSON2888: u32 = 1;
pub const CONFIG_ARCH_USE_MEMTEST: u32 = 1;
pub const CONFIG_HID_GENERIC: u32 = 1;
pub const CONFIG_ACPI_PFRUT_MODULE: u32 = 1;
pub const CONFIG_USB_PHY: u32 = 1;
pub const CONFIG_DEBUG_INFO_BTF: u32 = 1;
pub const CONFIG_TABLET_USB_AIPTEK_MODULE: u32 = 1;
pub const CONFIG_CAN_RAW_MODULE: u32 = 1;
pub const CONFIG_ARM_CCI5xx_PMU: u32 = 1;
pub const CONFIG_VIDEO_OV5675_MODULE: u32 = 1;
pub const CONFIG_QCA808X_PHY_MODULE: u32 = 1;
pub const CONFIG_CRC_OPTIMIZATIONS: u32 = 1;
pub const CONFIG_SND_HDA_SCODEC_CS35L41_MODULE: u32 = 1;
pub const CONFIG_RODATA_FULL_DEFAULT_ENABLED: u32 = 1;
pub const CONFIG_NET_DSA_XRS700X_MODULE: u32 = 1;
pub const CONFIG_VIDEO_ADV748X_MODULE: u32 = 1;
pub const CONFIG_APERTURE_HELPERS: u32 = 1;
pub const CONFIG_UNICODE: u32 = 1;
pub const CONFIG_GAMEPORT_MODULE: u32 = 1;
pub const CONFIG_RMI4_I2C_MODULE: u32 = 1;
pub const CONFIG_DM_LOG_WRITES_MODULE: u32 = 1;
pub const CONFIG_B44_PCI: u32 = 1;
pub const CONFIG_VIDEO_GS1662_MODULE: u32 = 1;
pub const CONFIG_USB_SIERRA_NET_MODULE: u32 = 1;
pub const CONFIG_TINYDRM_ILI9225_MODULE: u32 = 1;
pub const CONFIG_SPI_BITBANG_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_AMLOGIC_A4: u32 = 1;
pub const CONFIG_SND_MESON_AXG_TODDR_MODULE: u32 = 1;
pub const CONFIG_SWPHY: u32 = 1;
pub const CONFIG_SND_SOC_RT712_SDCA_DMIC_SDW_MODULE: u32 = 1;
pub const CONFIG_SERIAL_MSM: u32 = 1;
pub const CONFIG_CGROUP_CPUACCT: u32 = 1;
pub const CONFIG_SENSORS_ADM1275_MODULE: u32 = 1;
pub const CONFIG_SND_I2S_HI6210_I2S_MODULE: u32 = 1;
pub const CONFIG_VIDEO_SAA717X_MODULE: u32 = 1;
pub const CONFIG_CLK_RK3576: u32 = 1;
pub const CONFIG_MEMSTICK_REALTEK_USB_MODULE: u32 = 1;
pub const CONFIG_SC_CAMCC_7280_MODULE: u32 = 1;
pub const CONFIG_SND_HDA_COMPONENT: u32 = 1;
pub const CONFIG_NETFILTER_NETLINK_HOOK_MODULE: u32 = 1;
pub const CONFIG_USB_CHIPIDEA_IMX_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_APPLE_GPIO_MODULE: u32 = 1;
pub const CONFIG_SPI_DW_PCI_MODULE: u32 = 1;
pub const CONFIG_VCHIQ_CDEV: u32 = 1;
pub const CONFIG_SND_SOC_ROCKCHIP_RT5645_MODULE: u32 = 1;
pub const CONFIG_PA12203001_MODULE: u32 = 1;
pub const CONFIG_USB_STORAGE_CYPRESS_ATACB_MODULE: u32 = 1;
pub const CONFIG_SIS900_MODULE: u32 = 1;
pub const CONFIG_DRM_SCHED_MODULE: u32 = 1;
pub const CONFIG_HSA_AMD_SVM: u32 = 1;
pub const CONFIG_CRYPTO_DEV_QCE_AEAD: u32 = 1;
pub const CONFIG_REGULATOR_RT6190_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_TEST_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_BRIDGE: u32 = 1;
pub const CONFIG_DVB_USB_GL861_MODULE: u32 = 1;
pub const CONFIG_IONIC_MODULE: u32 = 1;
pub const CONFIG_IP_VS_WLC_MODULE: u32 = 1;
pub const CONFIG_NET_POLL_CONTROLLER: u32 = 1;
pub const CONFIG_MVNETA_MODULE: u32 = 1;
pub const CONFIG_DW_DMAC_CORE_MODULE: u32 = 1;
pub const CONFIG_JOYSTICK_ANALOG_MODULE: u32 = 1;
pub const CONFIG_INFINIBAND_MTHCA_DEBUG: u32 = 1;
pub const CONFIG_HID_XIAOMI_MODULE: u32 = 1;
pub const CONFIG_FS_DAX: u32 = 1;
pub const CONFIG_TOUCHSCREEN_EDT_FT5X06_MODULE: u32 = 1;
pub const CONFIG_PHY_ROCKCHIP_NANENG_COMBO_PHY_MODULE: u32 = 1;
pub const CONFIG_RTW89_8852B_MODULE: u32 = 1;
pub const CONFIG_BT_HCIUART_3WIRE: u32 = 1;
pub const CONFIG_DIMLIB: u32 = 1;
pub const CONFIG_OCTEONTX2_MBOX_MODULE: u32 = 1;
pub const CONFIG_MMC_SDHCI_ACPI_MODULE: u32 = 1;
pub const CONFIG_6LOWPAN_GHC_ICMPV6_MODULE: u32 = 1;
pub const CONFIG_HAVE_KVM_READONLY_MEM: u32 = 1;
pub const CONFIG_SERIAL_OF_PLATFORM: u32 = 1;
pub const CONFIG_GPIO_MB86S7X_MODULE: u32 = 1;
pub const CONFIG_INPUT_MOUSEDEV_SCREEN_Y: u32 = 768;
pub const CONFIG_CP15_BARRIER_EMULATION: u32 = 1;
pub const CONFIG_MEMCG: u32 = 1;
pub const CONFIG_DRM_DISPLAY_DP_AUX_CHARDEV: u32 = 1;
pub const CONFIG_PWM_ROCKCHIP_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_SI5341_MODULE: u32 = 1;
pub const CONFIG_SENSORS_SPD5118_MODULE: u32 = 1;
pub const CONFIG_BH1750_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_LIB_CHACHA20POLY1305: u32 = 1;
pub const CONFIG_ZSTD_COMPRESS: u32 = 1;
pub const CONFIG_MAILBOX: u32 = 1;
pub const CONFIG_SPARSE_IRQ: u32 = 1;
pub const CONFIG_NEED_SG_DMA_LENGTH: u32 = 1;
pub const CONFIG_VHOST_TASK: u32 = 1;
pub const CONFIG_CLK_X1E80100_GPUCC_MODULE: u32 = 1;
pub const CONFIG_IPV6_SEG6_BPF: u32 = 1;
pub const CONFIG_DVB_TUNER_DIB0070_MODULE: u32 = 1;
pub const CONFIG_QCOM_IPA_MODULE: u32 = 1;
pub const CONFIG_SUSPEND: u32 = 1;
pub const CONFIG_SYSCTL_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_F8153X_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TSCS42XX_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_FREESCALE: u32 = 1;
pub const CONFIG_SND_USB_AUDIO_MIDI_V2: u32 = 1;
pub const CONFIG_KGDB: u32 = 1;
pub const CONFIG_SENSORS_GIGABYTE_WATERFORCE_MODULE: u32 = 1;
pub const CONFIG_GRACE_PERIOD_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA186_DSPK_MODULE: u32 = 1;
pub const CONFIG_ATH6KL_DEBUG: u32 = 1;
pub const CONFIG_NF_FLOW_TABLE_PROCFS: u32 = 1;
pub const CONFIG_SOC_TI: u32 = 1;
pub const CONFIG_PINCTRL_SINGLE: u32 = 1;
pub const CONFIG_RTL8192DE_MODULE: u32 = 1;
pub const CONFIG_NFC_PN532_UART_MODULE: u32 = 1;
pub const CONFIG_CRC_T10DIF_ARCH: u32 = 1;
pub const CONFIG_FSL_IMX8_DDR_PMU_MODULE: u32 = 1;
pub const CONFIG_HAVE_FUNCTION_ARG_ACCESS_API: u32 = 1;
pub const CONFIG_PINCTRL_IMX_SCU: u32 = 1;
pub const CONFIG_MMC_ARMMMCI_MODULE: u32 = 1;
pub const CONFIG_MFD_CS42L43_MODULE: u32 = 1;
pub const CONFIG_CORESIGHT_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_ES8316_MODULE: u32 = 1;
pub const CONFIG_BD96801_WATCHDOG_MODULE: u32 = 1;
pub const CONFIG_ENVELOPE_DETECTOR_MODULE: u32 = 1;
pub const CONFIG_VIDEO_IMX7_CSI_MODULE: u32 = 1;
pub const CONFIG_RT2800_LIB_MODULE: u32 = 1;
pub const CONFIG_CC_IMPLICIT_FALLTHROUGH: &[u8; 25] = b"-Wimplicit-fallthrough=5\0";
pub const CONFIG_FB_DMAMEM_HELPERS: u32 = 1;
pub const CONFIG_IP_MULTIPLE_TABLES: u32 = 1;
pub const CONFIG_RT2X00_LIB_CRYPTO: u32 = 1;
pub const CONFIG_TMP117_MODULE: u32 = 1;
pub const CONFIG_DRM_MSM_DSI: u32 = 1;
pub const CONFIG_PPP_FILTER: u32 = 1;
pub const CONFIG_PTP_1588_CLOCK_VMCLOCK_MODULE: u32 = 1;
pub const CONFIG_VDPA_SIM_BLOCK_MODULE: u32 = 1;
pub const CONFIG_GPIO_PCA953X_IRQ: u32 = 1;
pub const CONFIG_NET_DSA_TAG_OCELOT_8021Q_MODULE: u32 = 1;
pub const CONFIG_VIDEO_QCOM_VENUS_MODULE: u32 = 1;
pub const CONFIG_WLAN_VENDOR_RALINK: u32 = 1;
pub const CONFIG_IR_MCE_KBD_DECODER_MODULE: u32 = 1;
pub const CONFIG_EDAC_MEM_REPAIR: u32 = 1;
pub const CONFIG_RATIONAL: u32 = 1;
pub const CONFIG_SENSORS_LM25066_REGULATOR: u32 = 1;
pub const CONFIG_NF_CONNTRACK_MODULE: u32 = 1;
pub const CONFIG_GENERIC_VDSO_DATA_STORE: u32 = 1;
pub const CONFIG_QCOM_L3_PMU: u32 = 1;
pub const CONFIG_RAPIDIO_RXS_GEN3_MODULE: u32 = 1;
pub const CONFIG_POWER_RESET_MSM: u32 = 1;
pub const CONFIG_SYSTEM_EXTRA_CERTIFICATE: u32 = 1;
pub const CONFIG_EXTCON_ADC_JACK_MODULE: u32 = 1;
pub const CONFIG_STACKPROTECTOR_PER_TASK: u32 = 1;
pub const CONFIG_W1_SLAVE_DS2438_MODULE: u32 = 1;
pub const CONFIG_MEMORY_HOTPLUG: u32 = 1;
pub const CONFIG_CRC64: u32 = 1;
pub const CONFIG_TEGRA210_EMC_TABLE: u32 = 1;
pub const CONFIG_TRUSTED_KEYS_TPM: u32 = 1;
pub const CONFIG_KEY_DH_OPERATIONS: u32 = 1;
pub const CONFIG_HID_GYRATION_MODULE: u32 = 1;
pub const CONFIG_NTSYNC_MODULE: u32 = 1;
pub const CONFIG_UBSAN: u32 = 1;
pub const CONFIG_USB_U_ETHER_MODULE: u32 = 1;
pub const CONFIG_VIDEO_TW2804_MODULE: u32 = 1;
pub const CONFIG_ZONE_DMA: u32 = 1;
pub const CONFIG_GNSS_SERIAL_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_AES_ARM64_NEON_BLK: u32 = 1;
pub const CONFIG_SND_USB_LINE6_MODULE: u32 = 1;
pub const CONFIG_REGMAP_RAM_MODULE: u32 = 1;
pub const CONFIG_AHCI_MVEBU_MODULE: u32 = 1;
pub const CONFIG_TLS_DEVICE: u32 = 1;
pub const CONFIG_DRM_LONTIUM_LT9611UXC_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_TTUSB2_MODULE: u32 = 1;
pub const CONFIG_WIL6210_ISR_COR: u32 = 1;
pub const CONFIG_SND_MAX_CARDS: u32 = 32;
pub const CONFIG_ARCH_HAS_PMEM_API: u32 = 1;
pub const CONFIG_IIO_MUX_MODULE: u32 = 1;
pub const CONFIG_RD_GZIP: u32 = 1;
pub const CONFIG_MV_XOR: u32 = 1;
pub const CONFIG_DRM_ROCKCHIP_MODULE: u32 = 1;
pub const CONFIG_VIDEO_THS7303_MODULE: u32 = 1;
pub const CONFIG_AMD_XGBE_MODULE: u32 = 1;
pub const CONFIG_FB_DEFERRED_IO: u32 = 1;
pub const CONFIG_LIBWX_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CS35L35_MODULE: u32 = 1;
pub const CONFIG_CROS_KUNIT_EC_PROTO_TEST_MODULE: u32 = 1;
pub const CONFIG_NET_SCH_NETEM_MODULE: u32 = 1;
pub const CONFIG_IP_NF_MATCH_RPFILTER_MODULE: u32 = 1;
pub const CONFIG_MSDOS_PARTITION: u32 = 1;
pub const CONFIG_B43_SDIO: u32 = 1;
pub const CONFIG_TIMER_PROBE: u32 = 1;
pub const CONFIG_PCC: u32 = 1;
pub const CONFIG_SYNTH_EVENTS: u32 = 1;
pub const CONFIG_DVB_USB_DTV5100_MODULE: u32 = 1;
pub const CONFIG_POWER_SUPPLY_HWMON: u32 = 1;
pub const CONFIG_SND_IMX_SOC_MODULE: u32 = 1;
pub const CONFIG_PHYLIB_LEDS: u32 = 1;
pub const CONFIG_NETFILTER_NETLINK_LOG_MODULE: u32 = 1;
pub const CONFIG_SUNXI_SRAM: u32 = 1;
pub const CONFIG_CPU_FREQ_GOV_CONSERVATIVE: u32 = 1;
pub const CONFIG_ZSTD_COMMON: u32 = 1;
pub const CONFIG_TCG_TIS_SPI_MODULE: u32 = 1;
pub const CONFIG_PHY_ROCKCHIP_DP_MODULE: u32 = 1;
pub const CONFIG_IIO_CROS_EC_LIGHT_PROX_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_USB_3M: u32 = 1;
pub const CONFIG_QCOM_CPUCP_MBOX_MODULE: u32 = 1;
pub const CONFIG_WATCHDOG: u32 = 1;
pub const CONFIG_BRIDGE_NETFILTER_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_RDC: u32 = 1;
pub const CONFIG_SND_SOC_MAX9759_MODULE: u32 = 1;
pub const CONFIG_MODULE_DECOMPRESS: u32 = 1;
pub const CONFIG_NLS_CODEPAGE_860_MODULE: u32 = 1;
pub const CONFIG_LOGITECH_FF: u32 = 1;
pub const CONFIG_VIDEO_VIVID_MODULE: u32 = 1;
pub const CONFIG_TEST_VMALLOC_MODULE: u32 = 1;
pub const CONFIG_IR_IGORPLUGUSB_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_CONNSECMARK_MODULE: u32 = 1;
pub const CONFIG_I2C_HID_CORE_MODULE: u32 = 1;
pub const CONFIG_HW_RANDOM_ARM_SMCCC_TRNG: u32 = 1;
pub const CONFIG_MWIFIEX_SDIO_MODULE: u32 = 1;
pub const CONFIG_XFRM: u32 = 1;
pub const CONFIG_QCOM_RPROC_COMMON_MODULE: u32 = 1;
pub const CONFIG_IPV6_PIMSM_V2: u32 = 1;
pub const CONFIG_FIX_EARLYCON_MEM: u32 = 1;
pub const CONFIG_SCHED_CORE: u32 = 1;
pub const CONFIG_TCG_TIS_I2C_ATMEL_MODULE: u32 = 1;
pub const CONFIG_NVMEM_SUNXI_SID_MODULE: u32 = 1;
pub const CONFIG_GNSS_MTK_SERIAL_MODULE: u32 = 1;
pub const CONFIG_DVB_A8293_MODULE: u32 = 1;
pub const CONFIG_PRESTERA_MODULE: u32 = 1;
pub const CONFIG_APPLE_PMGR_PWRSTATE: u32 = 1;
pub const CONFIG_ORANGEFS_FS_MODULE: u32 = 1;
pub const CONFIG_MLX90614_MODULE: u32 = 1;
pub const CONFIG_INTERCONNECT_QCOM_SM8450_MODULE: u32 = 1;
pub const CONFIG_LEDS_MAX77650_MODULE: u32 = 1;
pub const CONFIG_IRQCHIP: u32 = 1;
pub const CONFIG_ARCH_HAS_FAST_MULTIPLIER: u32 = 1;
pub const CONFIG_IOMMUFD_DRIVER_CORE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_RASPBERRYPI_FW_MODULE: u32 = 1;
pub const CONFIG_FW_LOADER: u32 = 1;
pub const CONFIG_PWM_STMPE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_TEGRA_MODULE: u32 = 1;
pub const CONFIG_INV_ICM42600_I2C_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_SC8280XP_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_KINECT_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_RT1318_SDW_MODULE: u32 = 1;
pub const CONFIG_RTC_SYSTOHC: u32 = 1;
pub const CONFIG_DRM_PANEL_SAMSUNG_AMS581VF01_MODULE: u32 = 1;
pub const CONFIG_JFS_FS_MODULE: u32 = 1;
pub const CONFIG_CROS_EC_MKBP_PROXIMITY_MODULE: u32 = 1;
pub const CONFIG_QCOM_Q6V5_MSS_MODULE: u32 = 1;
pub const CONFIG_SENSORS_W83791D_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_SY8827N_MODULE: u32 = 1;
pub const CONFIG_INPUT_PM8941_PWRKEY_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_RM_TS_MODULE: u32 = 1;
pub const CONFIG_FPGA_DFL_MODULE: u32 = 1;
pub const CONFIG_INET_IPCOMP_MODULE: u32 = 1;
pub const CONFIG_ROMFS_FS_MODULE: u32 = 1;
pub const CONFIG_IP6_NF_MATCH_RT_MODULE: u32 = 1;
pub const CONFIG_SCSI_WD719X_MODULE: u32 = 1;
pub const CONFIG_ARM_SCMI_HAVE_MSG: u32 = 1;
pub const CONFIG_MEDIA_TUNER_MT20XX_MODULE: u32 = 1;
pub const CONFIG_PHY_ROCKCHIP_SAMSUNG_HDPTX_MODULE: u32 = 1;
pub const CONFIG_INFINIBAND_CXGB4_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_SOF_IPC3: u32 = 1;
pub const CONFIG_VIDEO_IMX219_MODULE: u32 = 1;
pub const CONFIG_L2TP_DEBUGFS_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_CACHE_LINE_SIZE: u32 = 1;
pub const CONFIG_SENSORS_TPS25990_REGULATOR: u32 = 1;
pub const CONFIG_DRM_BRIDGE_CONNECTOR: u32 = 1;
pub const CONFIG_DM_RAID_MODULE: u32 = 1;
pub const CONFIG_EXPORTFS: u32 = 1;
pub const CONFIG_RPR0521_MODULE: u32 = 1;
pub const CONFIG_SC_GCC_8280XP: u32 = 1;
pub const CONFIG_SND_SOC_CS43130_MODULE: u32 = 1;
pub const CONFIG_VIDEO_HDPVR_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_HCTR2_MODULE: u32 = 1;
pub const CONFIG_SURFACE_AGGREGATOR_CDEV_MODULE: u32 = 1;
pub const CONFIG_MMC_DW_EXYNOS_MODULE: u32 = 1;
pub const CONFIG_MAC80211_HWSIM_MODULE: u32 = 1;
pub const CONFIG_SCA3300_MODULE: u32 = 1;
pub const CONFIG_TCP_CONG_VEGAS_MODULE: u32 = 1;
pub const CONFIG_INFINIBAND_IPOIB_DEBUG_DATA: u32 = 1;
pub const CONFIG_SND_HDA_CIRRUS_SCODEC_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_GPIO_DLN2_MODULE: u32 = 1;
pub const CONFIG_PANIC_TIMEOUT: u32 = 0;
pub const CONFIG_VIDEO_IMX296_MODULE: u32 = 1;
pub const CONFIG_VFIO_PLATFORM_BASE_MODULE: u32 = 1;
pub const CONFIG_PTP_1588_CLOCK: u32 = 1;
pub const CONFIG_MDIO_BCM_UNIMAC_MODULE: u32 = 1;
pub const CONFIG_DRM_SII902X_MODULE: u32 = 1;
pub const CONFIG_FW_LOADER_COMPRESS_XZ: u32 = 1;
pub const CONFIG_SUN4I_TIMER: u32 = 1;
pub const CONFIG_MSM_GCC_8939_MODULE: u32 = 1;
pub const CONFIG_TYPEC_MUX_PS883X_MODULE: u32 = 1;
pub const CONFIG_NET_CORE: u32 = 1;
pub const CONFIG_CORESIGHT_CATU_MODULE: u32 = 1;
pub const CONFIG_DVB_LGDT330X_MODULE: u32 = 1;
pub const CONFIG_SOFT_WATCHDOG_MODULE: u32 = 1;
pub const CONFIG_RTW89_8852A_MODULE: u32 = 1;
pub const CONFIG_LD_IS_BFD: u32 = 1;
pub const CONFIG_INFINIBAND_ISERT_MODULE: u32 = 1;
pub const CONFIG_SND_SUN4I_CODEC_MODULE: u32 = 1;
pub const CONFIG_MMU_LAZY_TLB_REFCOUNT: u32 = 1;
pub const CONFIG_NAMESPACES: u32 = 1;
pub const CONFIG_SND_PCM_ELD: u32 = 1;
pub const CONFIG_DECOMPRESS_GZIP: u32 = 1;
pub const CONFIG_CROS_EC_I2C_MODULE: u32 = 1;
pub const CONFIG_HWMON: u32 = 1;
pub const CONFIG_TYPEC_TPS6598X_MODULE: u32 = 1;
pub const CONFIG_BRCMFMAC_MODULE: u32 = 1;
pub const CONFIG_ACPI_BATTERY: u32 = 1;
pub const CONFIG_I2C_PCI1XXXX_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_MESON_T9015_MODULE: u32 = 1;
pub const CONFIG_PHY_MESON_AXG_MIPI_DPHY_MODULE: u32 = 1;
pub const CONFIG_IP_NF_ARP_MANGLE_MODULE: u32 = 1;
pub const CONFIG_RTW88_8821CE_MODULE: u32 = 1;
pub const CONFIG_USB_SISUSBVGA_MODULE: u32 = 1;
pub const CONFIG_HD44780_MODULE: u32 = 1;
pub const CONFIG_VIDEO_RENESAS_FDP1_MODULE: u32 = 1;
pub const CONFIG_PCI_KEYSTONE_HOST: u32 = 1;
pub const CONFIG_QCOM_QSEECOM_UEFISECAPP: u32 = 1;
pub const CONFIG_CPU_RMAP: u32 = 1;
pub const CONFIG_IP6_NF_RAW_MODULE: u32 = 1;
pub const CONFIG_VFIO_PCI_CORE_MODULE: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_NUMA_BALANCING: u32 = 1;
pub const CONFIG_BUFFER_HEAD: u32 = 1;
pub const CONFIG_DVB_NGENE_MODULE: u32 = 1;
pub const CONFIG_MWIFIEX_USB_MODULE: u32 = 1;
pub const CONFIG_CLK_RENESAS: u32 = 1;
pub const CONFIG_NET_9P_RDMA_MODULE: u32 = 1;
pub const CONFIG_CC_HAS_AUTO_VAR_INIT_PATTERN: u32 = 1;
pub const CONFIG_SND_HDA_CODEC_SENARYTECH_MODULE: u32 = 1;
pub const CONFIG_VIDEO_CX23885_MODULE: u32 = 1;
pub const CONFIG_FORTIFY_SOURCE: u32 = 1;
pub const CONFIG_INPUT_IQS626A_MODULE: u32 = 1;
pub const CONFIG_HWSPINLOCK: u32 = 1;
pub const CONFIG_I2C_DESIGNWARE_CORE: u32 = 1;
pub const CONFIG_DRM_ACCEL: u32 = 1;
pub const CONFIG_PINCTRL_SUN20I_D1: u32 = 1;
pub const CONFIG_ENCLOSURE_SERVICES_MODULE: u32 = 1;
pub const CONFIG_BT_HCIBTUSB_MTK: u32 = 1;
pub const CONFIG_DMA_OF: u32 = 1;
pub const CONFIG_SND_SOC_RL6231_MODULE: u32 = 1;
pub const CONFIG_DVB_SI2168_MODULE: u32 = 1;
pub const CONFIG_FB_SYSMEM_HELPERS_DEFERRED: u32 = 1;
pub const CONFIG_MFD_SIMPLE_MFD_I2C_MODULE: u32 = 1;
pub const CONFIG_6LOWPAN_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_858921: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_1418040: u32 = 1;
pub const CONFIG_TI_ICSS_IEP_MODULE: u32 = 1;
pub const CONFIG_WPCM450_SOC_MODULE: u32 = 1;
pub const CONFIG_DUMMY_MODULE: u32 = 1;
pub const CONFIG_QCOM_SYSMON_MODULE: u32 = 1;
pub const CONFIG_SYSCON_REBOOT_MODE: u32 = 1;
pub const CONFIG_VIDEO_EM28XX_V4L2_MODULE: u32 = 1;
pub const CONFIG_DM_BIO_PRISON_MODULE: u32 = 1;
pub const CONFIG_MMC_SDHCI_IO_ACCESSORS: u32 = 1;
pub const CONFIG_BMC150_ACCEL_SPI_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_FAMILY_ARP: u32 = 1;
pub const CONFIG_SND_SOC_XILINX_SPDIF_MODULE: u32 = 1;
pub const CONFIG_HIBERNATE_CALLBACKS: u32 = 1;
pub const CONFIG_DRM_KOMEDA_MODULE: u32 = 1;
pub const CONFIG_SYS_SUPPORTS_SH_TMU: u32 = 1;
pub const CONFIG_DVB_USB_CXUSB_MODULE: u32 = 1;
pub const CONFIG_IR_RCMM_DECODER_MODULE: u32 = 1;
pub const CONFIG_TASKS_TRACE_RCU: u32 = 1;
pub const CONFIG_VIDEO_S5C73M3_MODULE: u32 = 1;
pub const CONFIG_6LOWPAN_NHC_MODULE: u32 = 1;
pub const CONFIG_MHP_MEMMAP_ON_MEMORY: u32 = 1;
pub const CONFIG_REGULATOR_RT6245_MODULE: u32 = 1;
pub const CONFIG_HARDENED_USERCOPY_DEFAULT_ON: u32 = 1;
pub const CONFIG_SERIO_AMBAKMI_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_MELLANOX: u32 = 1;
pub const CONFIG_IR_SERIAL_MODULE: u32 = 1;
pub const CONFIG_SKY2_MODULE: u32 = 1;
pub const CONFIG_RIONET_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_CRC_T10DIF: u32 = 1;
pub const CONFIG_SND_SOC_AK4619_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_RT1320_SDW_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_SPCA501_MODULE: u32 = 1;
pub const CONFIG_BT_LE: u32 = 1;
pub const CONFIG_XGENE_SLIMPRO_MBOX_MODULE: u32 = 1;
pub const CONFIG_IXGBE_MODULE: u32 = 1;
pub const CONFIG_SENSORS_NZXT_SMART2_MODULE: u32 = 1;
pub const CONFIG_MT76x02_LIB_MODULE: u32 = 1;
pub const CONFIG_BACKLIGHT_LM3509_MODULE: u32 = 1;
pub const CONFIG_DYNAMIC_DEBUG: u32 = 1;
pub const CONFIG_ZRAM_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV2680_MODULE: u32 = 1;
pub const CONFIG_SERIAL_DEV_CTRL_TTYPORT: u32 = 1;
pub const CONFIG_SND_AZT3328_MODULE: u32 = 1;
pub const CONFIG_PCI_DOMAINS: u32 = 1;
pub const CONFIG_RTW89_8922AE_MODULE: u32 = 1;
pub const CONFIG_CPU_FREQ_GOV_SCHEDUTIL: u32 = 1;
pub const CONFIG_PCI_XGENE_MSI: u32 = 1;
pub const CONFIG_SC_LPASSCC_8280XP_MODULE: u32 = 1;
pub const CONFIG_IMA_DEFAULT_HASH_SHA256: u32 = 1;
pub const CONFIG_BMC150_MAGN_MODULE: u32 = 1;
pub const CONFIG_IR_PWM_TX_MODULE: u32 = 1;
pub const CONFIG_SURFACE_AGGREGATOR_REGISTRY_MODULE: u32 = 1;
pub const CONFIG_EFI_RUNTIME_WRAPPERS: u32 = 1;
pub const CONFIG_USB_MDC800_MODULE: u32 = 1;
pub const CONFIG_NF_CT_NETLINK_MODULE: u32 = 1;
pub const CONFIG_IIO_TRIGGERED_BUFFER_MODULE: u32 = 1;
pub const CONFIG_IOMMU_IO_PGTABLE_LPAE: u32 = 1;
pub const CONFIG_TCG_ARM_CRB_FFA: u32 = 1;
pub const CONFIG_CHECKSUM_KUNIT_MODULE: u32 = 1;
pub const CONFIG_EDAC_SYNOPSYS_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_NAT_MODULE: u32 = 1;
pub const CONFIG_SERIAL_SC16IS7XX_MODULE: u32 = 1;
pub const CONFIG_CAVIUM_ERRATUM_27456: u32 = 1;
pub const CONFIG_ATH10K_LEDS: u32 = 1;
pub const CONFIG_SND_SOC_ADI_AXI_SPDIF_MODULE: u32 = 1;
pub const CONFIG_FWCTL_PDS_MODULE: u32 = 1;
pub const CONFIG_6LOWPAN_NHC_FRAGMENT_MODULE: u32 = 1;
pub const CONFIG_PROC_SYSCTL: u32 = 1;
pub const CONFIG_HDC100X_MODULE: u32 = 1;
pub const CONFIG_MIGRATION: u32 = 1;
pub const CONFIG_DVB_PLUTO2_MODULE: u32 = 1;
pub const CONFIG_HAVE_EFFICIENT_UNALIGNED_ACCESS: u32 = 1;
pub const CONFIG_I2C_OMAP_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_PM8XXX_MODULE: u32 = 1;
pub const CONFIG_DRM_CHIPONE_ICN6211_MODULE: u32 = 1;
pub const CONFIG_ATH9K_MODULE: u32 = 1;
pub const CONFIG_XILLYBUS_PCIE_MODULE: u32 = 1;
pub const CONFIG_BITS_TEST_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_AKCIPHER: u32 = 1;
pub const CONFIG_HID_APPLEIR_MODULE: u32 = 1;
pub const CONFIG_MTD_SPI_NOR_SWP_DISABLE_ON_VOLATILE: u32 = 1;
pub const CONFIG_SX9360_MODULE: u32 = 1;
pub const CONFIG_NEED_KVM_DIRTY_RING_WITH_BITMAP: u32 = 1;
pub const CONFIG_NET_SCHED: u32 = 1;
pub const CONFIG_NET_CLS_FW_MODULE: u32 = 1;
pub const CONFIG_HAVE_HARDLOCKUP_DETECTOR_BUDDY: u32 = 1;
pub const CONFIG_NLS_CODEPAGE_861_MODULE: u32 = 1;
pub const CONFIG_VIDEO_HEXIUM_ORION_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_CHACHA20_MODULE: u32 = 1;
pub const CONFIG_MPLS_ROUTING_MODULE: u32 = 1;
pub const CONFIG_PAGE_POOL: u32 = 1;
pub const CONFIG_CRYPTO_USER_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_ESP_MODULE: u32 = 1;
pub const CONFIG_RT2500USB_MODULE: u32 = 1;
pub const CONFIG_NVME_TARGET_TCP_MODULE: u32 = 1;
pub const CONFIG_KFENCE_SAMPLE_INTERVAL: u32 = 100;
pub const CONFIG_HID_XINMO_MODULE: u32 = 1;
pub const CONFIG_NTFS3_FS_MODULE: u32 = 1;
pub const CONFIG_NETPOLL: u32 = 1;
pub const CONFIG_SCSI_DMX3191D_MODULE: u32 = 1;
pub const CONFIG_SPI_MESON_SPIFC_MODULE: u32 = 1;
pub const CONFIG_SERIAL_TEGRA: u32 = 1;
pub const CONFIG_DRM_TEGRA_MODULE: u32 = 1;
pub const CONFIG_VIDEOBUF2_MEMOPS_MODULE: u32 = 1;
pub const CONFIG_IIO_ST_PRESS_SPI_MODULE: u32 = 1;
pub const CONFIG_OVERFLOW_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_NET_MPLS_GSO_MODULE: u32 = 1;
pub const CONFIG_MII_MODULE: u32 = 1;
pub const CONFIG_DM_VERITY_VERIFY_ROOTHASH_SIG: u32 = 1;
pub const CONFIG_BCMA_DRIVER_GMAC_CMN: u32 = 1;
pub const CONFIG_OF_MDIO: u32 = 1;
pub const CONFIG_NVMEM_SYSFS: u32 = 1;
pub const CONFIG_IMA_DEFAULT_HASH: &[u8; 7] = b"sha256\0";
pub const CONFIG_RTC_DRV_XGENE_MODULE: u32 = 1;
pub const CONFIG_HYPERV_STORAGE_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_ADAU1761_I2C_MODULE: u32 = 1;
pub const CONFIG_SENSORS_ADM1266_MODULE: u32 = 1;
pub const CONFIG_DVB_TDA18271C2DD_MODULE: u32 = 1;
pub const CONFIG_9P_FS_POSIX_ACL: u32 = 1;
pub const CONFIG_USB_STORAGE_ENE_UB6250_MODULE: u32 = 1;
pub const CONFIG_B53_SRAB_DRIVER_MODULE: u32 = 1;
pub const CONFIG_SCSI_COMMON: u32 = 1;
pub const CONFIG_SPARSEMEM_EXTREME: u32 = 1;
pub const CONFIG_SND_SOC_TI_UDMA_PCM_MODULE: u32 = 1;
pub const CONFIG_NOUVEAU_PLATFORM_DRIVER: u32 = 1;
pub const CONFIG_PHY_ROCKCHIP_TYPEC_MODULE: u32 = 1;
pub const CONFIG_MLX5_EN_RXNFC: u32 = 1;
pub const CONFIG_CEC_MESON_G12A_AO_MODULE: u32 = 1;
pub const CONFIG_RTSN_MODULE: u32 = 1;
pub const CONFIG_USB_M5602_MODULE: u32 = 1;
pub const CONFIG_RSEQ: u32 = 1;
pub const CONFIG_SND_PCM_OSS_MODULE: u32 = 1;
pub const CONFIG_IOMMU_DMA: u32 = 1;
pub const CONFIG_SECURITY_TOMOYO_MAX_AUDIT_LOG: u32 = 1024;
pub const CONFIG_SND_SOC_IDT821034_MODULE: u32 = 1;
pub const CONFIG_JOYSTICK_GRIP_MODULE: u32 = 1;
pub const CONFIG_NET_SCH_DRR_MODULE: u32 = 1;
pub const CONFIG_DRM_DW_HDMI_QP_MODULE: u32 = 1;
pub const CONFIG_JOYSTICK_PSXPAD_SPI_FF: u32 = 1;
pub const CONFIG_SENSORS_JC42_MODULE: u32 = 1;
pub const CONFIG_VIDEO_QCOM_CAMSS_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_ILITEK_MODULE: u32 = 1;
pub const CONFIG_SYSCTL_EXCEPTION_TRACE: u32 = 1;
pub const CONFIG_NEW_LEDS: u32 = 1;
pub const CONFIG_ARM_PMU: u32 = 1;
pub const CONFIG_SPI_AX88796C_MODULE: u32 = 1;
pub const CONFIG_UCLAMP_TASK: u32 = 1;
pub const CONFIG_PINCTRL_SM8450_MODULE: u32 = 1;
pub const CONFIG_MHI_BUS_PCI_GENERIC_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_QAT_420XX_MODULE: u32 = 1;
pub const CONFIG_RAS: u32 = 1;
pub const CONFIG_PINCTRL_MESON_GXBB: u32 = 1;
pub const CONFIG_NF_TABLES_NETDEV: u32 = 1;
pub const CONFIG_SSB_SPROM: u32 = 1;
pub const CONFIG_SND_USB_6FIRE_MODULE: u32 = 1;
pub const CONFIG_HISI_HIKEY_USB_MODULE: u32 = 1;
pub const CONFIG_PCIE_TEGRA194: u32 = 1;
pub const CONFIG_VIDEO_ADP1653_MODULE: u32 = 1;
pub const CONFIG_BT_6LOWPAN_MODULE: u32 = 1;
pub const CONFIG_DVB_STV0367_MODULE: u32 = 1;
pub const CONFIG_SERIAL_8250_PERICOM: u32 = 1;
pub const CONFIG_PWM_DWC_MODULE: u32 = 1;
pub const CONFIG_SPI_PCI1XXXX_MODULE: u32 = 1;
pub const CONFIG_SCSI_IPR_MODULE: u32 = 1;
pub const CONFIG_KVM_MMIO: u32 = 1;
pub const CONFIG_SCSI_CXGB3_ISCSI_MODULE: u32 = 1;
pub const CONFIG_SPI_DLN2_MODULE: u32 = 1;
pub const CONFIG_DRM_SIMPLEDRM: u32 = 1;
pub const CONFIG_PADATA: u32 = 1;
pub const CONFIG_VIDEO_FB_IVTV_MODULE: u32 = 1;
pub const CONFIG_KEYBOARD_GPIO_POLLED_MODULE: u32 = 1;
pub const CONFIG_HID_PXRC_MODULE: u32 = 1;
pub const CONFIG_HD44780_COMMON_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_PTE_SPECIAL: u32 = 1;
pub const CONFIG_BLK_DEV_RBD_MODULE: u32 = 1;
pub const CONFIG_SND_DARLA20_MODULE: u32 = 1;
pub const CONFIG_RENESAS_OSTM: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_2054223: u32 = 1;
pub const CONFIG_SND_SOC_CS4265_MODULE: u32 = 1;
pub const CONFIG_ARM64_PA_BITS: u32 = 48;
pub const CONFIG_VIDEO_OV5648_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_MT2060_MODULE: u32 = 1;
pub const CONFIG_CC_HAS_ASM_INLINE: u32 = 1;
pub const CONFIG_VIDEO_DS90UB953_MODULE: u32 = 1;
pub const CONFIG_POWER_RESET_TPS65086: u32 = 1;
pub const CONFIG_CHARGER_QCOM_SMB2_MODULE: u32 = 1;
pub const CONFIG_UCSI_PMIC_GLINK_MODULE: u32 = 1;
pub const CONFIG_GPIO_MLXBF2_MODULE: u32 = 1;
pub const CONFIG_SATA_AHCI_PLATFORM_MODULE: u32 = 1;
pub const CONFIG_VFIO_AMBA_MODULE: u32 = 1;
pub const CONFIG_SENSORS_W83781D_MODULE: u32 = 1;
pub const CONFIG_FB: u32 = 1;
pub const CONFIG_REGULATOR_RT5190A_MODULE: u32 = 1;
pub const CONFIG_PHY_HISI_INNO_USB2_MODULE: u32 = 1;
pub const CONFIG_IP_VS_FTP_MODULE: u32 = 1;
pub const CONFIG_BT_HCIBCM4377_MODULE: u32 = 1;
pub const CONFIG_ADXL313_MODULE: u32 = 1;
pub const CONFIG_HID_STEELSERIES_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_2064142: u32 = 1;
pub const CONFIG_USB_LEDS_TRIGGER_USBPORT_MODULE: u32 = 1;
pub const CONFIG_SENSORS_TMP513_MODULE: u32 = 1;
pub const CONFIG_VIDEO_CS5345_MODULE: u32 = 1;
pub const CONFIG_F2FS_FS_LZ4: u32 = 1;
pub const CONFIG_HAS_SECURITY_AUDIT: u32 = 1;
pub const CONFIG_VIRT_WIFI_MODULE: u32 = 1;
pub const CONFIG_V4L_TEST_DRIVERS: u32 = 1;
pub const CONFIG_DRM_PANIC_SCREEN_QR_CODE: u32 = 1;
pub const CONFIG_SND_SOC_BD28623_MODULE: u32 = 1;
pub const CONFIG_TI_SYSCON_CLK_MODULE: u32 = 1;
pub const CONFIG_PWM_CROS_EC_MODULE: u32 = 1;
pub const CONFIG_PDS_VDPA_MODULE: u32 = 1;
pub const CONFIG_VIDEO_CX88_ALSA_MODULE: u32 = 1;
pub const CONFIG_HAVE_ACPI_APEI: u32 = 1;
pub const CONFIG_COMMON_CLK_MESON_SCLK_DIV: u32 = 1;
pub const CONFIG_SND_SOC_QDSP6_APM_MODULE: u32 = 1;
pub const CONFIG_GPIO_MLXBF_MODULE: u32 = 1;
pub const CONFIG_SCSI_UFS_QCOM_MODULE: u32 = 1;
pub const CONFIG_NLS_CODEPAGE_950_MODULE: u32 = 1;
pub const CONFIG_CHARGER_BQ25980_MODULE: u32 = 1;
pub const CONFIG_IR_RC5_DECODER_MODULE: u32 = 1;
pub const CONFIG_MMC_SDHCI_ESDHC_IMX_MODULE: u32 = 1;
pub const CONFIG_SENSORS_LM78_MODULE: u32 = 1;
pub const CONFIG_RTW89_8852AE_MODULE: u32 = 1;
pub const CONFIG_IMX_SCMI_BBM_EXT: u32 = 1;
pub const CONFIG_BT_HCIUART_INTEL: u32 = 1;
pub const CONFIG_KPROBE_EVENTS: u32 = 1;
pub const CONFIG_MLX4_DEBUG: u32 = 1;
pub const CONFIG_PROC_VMCORE_DEVICE_DUMP: u32 = 1;
pub const CONFIG_F2FS_FS_POSIX_ACL: u32 = 1;
pub const CONFIG_RTC_DRV_SUN6I: u32 = 1;
pub const CONFIG_CRYPTO_DEV_QAT_C3XXX_MODULE: u32 = 1;
pub const CONFIG_CHARGER_BQ256XX_MODULE: u32 = 1;
pub const CONFIG_BATTERY_SURFACE_MODULE: u32 = 1;
pub const CONFIG_PCIE_XILINX_NWL: u32 = 1;
pub const CONFIG_ATH10K_AHB: u32 = 1;
pub const CONFIG_CC_HAS_ASM_GOTO_TIED_OUTPUT: u32 = 1;
pub const CONFIG_ISCSI_TARGET_MODULE: u32 = 1;
pub const CONFIG_TABLET_USB_KBTAB_MODULE: u32 = 1;
pub const CONFIG_BLK_DEV_INITRD: u32 = 1;
pub const CONFIG_CIFS_FSCACHE: u32 = 1;
pub const CONFIG_SCSI_MPI3MR_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV7251_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_TDA8290_MODULE: u32 = 1;
pub const CONFIG_BE2ISCSI_MODULE: u32 = 1;
pub const CONFIG_DWC_PCIE_PMU_MODULE: u32 = 1;
pub const CONFIG_USB_F_SERIAL_MODULE: u32 = 1;
pub const CONFIG_NEED_TASKS_RCU: u32 = 1;
pub const CONFIG_MICROSOFT_MANA_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_OPTICON_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_SPCA500_MODULE: u32 = 1;
pub const CONFIG_B43_PHY_LP: u32 = 1;
pub const CONFIG_INET: u32 = 1;
pub const CONFIG_MAX30208_MODULE: u32 = 1;
pub const CONFIG_DL2K_MODULE: u32 = 1;
pub const CONFIG_VIDEO_CX18_MODULE: u32 = 1;
pub const CONFIG_HID_PETALYNX_MODULE: u32 = 1;
pub const CONFIG_DEVFREQ_GOV_SIMPLE_ONDEMAND_MODULE: u32 = 1;
pub const CONFIG_BLK_DEV_SR: u32 = 1;
pub const CONFIG_MD_AUTODETECT: u32 = 1;
pub const CONFIG_CHR_DEV_ST_MODULE: u32 = 1;
pub const CONFIG_QCOM_PDC: u32 = 1;
pub const CONFIG_ATH11K_PCI_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_REDIRECT_MODULE: u32 = 1;
pub const CONFIG_POWER_RESET: u32 = 1;
pub const CONFIG_RTC_DRV_OPTEE_MODULE: u32 = 1;
pub const CONFIG_ATA: u32 = 1;
pub const CONFIG_ADXRS290_MODULE: u32 = 1;
pub const CONFIG_BLK_DEV_RAM_SIZE: u32 = 16384;
pub const CONFIG_POWER_RESET_REGULATOR: u32 = 1;
pub const CONFIG_USB_EMI26_MODULE: u32 = 1;
pub const CONFIG_SENSORS_ZL6100_MODULE: u32 = 1;
pub const CONFIG_IMX93_ADC_MODULE: u32 = 1;
pub const CONFIG_ATH6KL_USB_MODULE: u32 = 1;
pub const CONFIG_SND_HDA_SCODEC_CS35L56_I2C_MODULE: u32 = 1;
pub const CONFIG_TYPEC_MUX_FSA4480_MODULE: u32 = 1;
pub const CONFIG_RPS: u32 = 1;
pub const CONFIG_REGULATOR_CROS_EC_MODULE: u32 = 1;
pub const CONFIG_HW_RANDOM_MESON_MODULE: u32 = 1;
pub const CONFIG_PCI_P2PDMA: u32 = 1;
pub const CONFIG_HID_PICOLCD_LCD: u32 = 1;
pub const CONFIG_SND_MESON_G12A_TOHDMITX_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_ELAN_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_CAST6_MODULE: u32 = 1;
pub const CONFIG_GENERIC_ARCH_TOPOLOGY: u32 = 1;
pub const CONFIG_ARM64_VA_BITS_48: u32 = 1;
pub const CONFIG_NF_CONNTRACK_SECMARK: u32 = 1;
pub const CONFIG_FEC_MODULE: u32 = 1;
pub const CONFIG_LEDS_TRIGGER_NETDEV_MODULE: u32 = 1;
pub const CONFIG_RESET_TEGRA_BPMP: u32 = 1;
pub const CONFIG_CGROUP_NET_PRIO: u32 = 1;
pub const CONFIG_MPILIB: u32 = 1;
pub const CONFIG_MT7603E_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_MC44S803_MODULE: u32 = 1;
pub const CONFIG_GARP_MODULE: u32 = 1;
pub const CONFIG_IPE_POLICY_SIG_PLATFORM_KEYRING: u32 = 1;
pub const CONFIG_RTC_DRV_RV3028_MODULE: u32 = 1;
pub const CONFIG_PHY_XILINX_ZYNQMP_MODULE: u32 = 1;
pub const CONFIG_FIRMWARE_TABLE: u32 = 1;
pub const CONFIG_SND_DMAENGINE_PCM_MODULE: u32 = 1;
pub const CONFIG_LEDS_TLC591XX_MODULE: u32 = 1;
pub const CONFIG_NET_ACT_SIMP_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_CHECKSUM_MODULE: u32 = 1;
pub const CONFIG_VIDEO_IMX335_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_SD3078_MODULE: u32 = 1;
pub const CONFIG_IP_NF_SECURITY_MODULE: u32 = 1;
pub const CONFIG_EPOLL: u32 = 1;
pub const CONFIG_ARM_SMMU_V3_IOMMUFD: u32 = 1;
pub const CONFIG_SM_CAMCC_8250_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_MSM8998_MODULE: u32 = 1;
pub const CONFIG_LEDS_MLXREG_MODULE: u32 = 1;
pub const CONFIG_ACPI_PLATFORM_PROFILE_MODULE: u32 = 1;
pub const CONFIG_ARM_GIC_V2M: u32 = 1;
pub const CONFIG_TYPEC_MUX_GPIO_SBU_MODULE: u32 = 1;
pub const CONFIG_PCIE_QCOM_COMMON: u32 = 1;
pub const CONFIG_SND_SOC_SOF_IMX8_MODULE: u32 = 1;
pub const CONFIG_TIMER_IMX_SYS_CTR: u32 = 1;
pub const CONFIG_RTC_DRV_DS3232_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_MESON_MPLL: u32 = 1;
pub const CONFIG_I3C_MODULE: u32 = 1;
pub const CONFIG_CGROUPS: u32 = 1;
pub const CONFIG_VIDEO_SAA7146_VV_MODULE: u32 = 1;
pub const CONFIG_UDMABUF: u32 = 1;
pub const CONFIG_DRM_HYPERV_MODULE: u32 = 1;
pub const CONFIG_CNIC_MODULE: u32 = 1;
pub const CONFIG_NFSD_FLEXFILELAYOUT: u32 = 1;
pub const CONFIG_CLK_RK3328: u32 = 1;
pub const CONFIG_CHARGER_CROS_CONTROL_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_AW88395_MODULE: u32 = 1;
pub const CONFIG_USB_F_SUBSET_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_PCF85363_MODULE: u32 = 1;
pub const CONFIG_ARCH_SYNQUACER: u32 = 1;
pub const CONFIG_SENSORS_PLI1209BC_REGULATOR: u32 = 1;
pub const CONFIG_SND_SOC_SGTL5000_MODULE: u32 = 1;
pub const CONFIG_AXI_DMAC_MODULE: u32 = 1;
pub const CONFIG_NET_CLS_MATCHALL_MODULE: u32 = 1;
pub const CONFIG_XILINX_LL_TEMAC_MODULE: u32 = 1;
pub const CONFIG_RUST_FW_LOADER_ABSTRACTIONS: u32 = 1;
pub const CONFIG_PKCS8_PRIVATE_KEY_PARSER_MODULE: u32 = 1;
pub const CONFIG_SERIAL_8250: u32 = 1;
pub const CONFIG_ABP060MG_MODULE: u32 = 1;
pub const CONFIG_NET_DSA_MT7530_MMIO_MODULE: u32 = 1;
pub const CONFIG_HAVE_ARCH_KASAN: u32 = 1;
pub const CONFIG_CRYPTO_CHACHA20POLY1305_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL: u32 = 1;
pub const CONFIG_USE_PERCPU_NUMA_NODE_ID: u32 = 1;
pub const CONFIG_NUMA_KEEP_MEMINFO: u32 = 1;
pub const CONFIG_HID_ELAN_MODULE: u32 = 1;
pub const CONFIG_MFD_MAX77620: u32 = 1;
pub const CONFIG_EC_LENOVO_YOGA_C630_MODULE: u32 = 1;
pub const CONFIG_PHY_MVEBU_A38X_COMPHY_MODULE: u32 = 1;
pub const CONFIG_QCOM_Q6V5_COMMON_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_HASH_INFO: u32 = 1;
pub const CONFIG_DRM_AMD_ACP: u32 = 1;
pub const CONFIG_QED_LL2: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_IPVS_MODULE: u32 = 1;
pub const CONFIG_CRC32: u32 = 1;
pub const CONFIG_CRYPTO_DEV_QAT_DH895xCC_MODULE: u32 = 1;
pub const CONFIG_EXT4_FS: u32 = 1;
pub const CONFIG_AK8975_MODULE: u32 = 1;
pub const CONFIG_SENSORS_INA238_MODULE: u32 = 1;
pub const CONFIG_ARM_CCA_GUEST_MODULE: u32 = 1;
pub const CONFIG_HID_EZKEY_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_NOVATEK_NT35950_MODULE: u32 = 1;
pub const CONFIG_FANOTIFY_ACCESS_PERMISSIONS: u32 = 1;
pub const CONFIG_IR_SERIAL_TRANSMITTER: u32 = 1;
pub const CONFIG_FUEL_GAUGE_STC3117_MODULE: u32 = 1;
pub const CONFIG_PHY_ROCKCHIP_INNO_USB2_MODULE: u32 = 1;
pub const CONFIG_EVM_ATTR_FSUUID: u32 = 1;
pub const CONFIG_TOUCHSCREEN_HIMAX_HX83112B_MODULE: u32 = 1;
pub const CONFIG_TCP_CONG_HSTCP_MODULE: u32 = 1;
pub const CONFIG_ARCH_R8A774A1: u32 = 1;
pub const CONFIG_SND_HDA_INPUT_BEEP_MODE: u32 = 0;
pub const CONFIG_GPIO_CDEV: u32 = 1;
pub const CONFIG_CAN_F81604_MODULE: u32 = 1;
pub const CONFIG_VIDEO_PVRUSB2_DVB: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_NOTRACK_MODULE: u32 = 1;
pub const CONFIG_QCOM_SOCINFO_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_UACCESS_FLUSHCACHE: u32 = 1;
pub const CONFIG_USB_SERIAL_XSENS_MT_MODULE: u32 = 1;
pub const CONFIG_BATTERY_SBS_MODULE: u32 = 1;
pub const CONFIG_DRM_AUX_HPD_BRIDGE_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CS42L43_MODULE: u32 = 1;
pub const CONFIG_RUST: u32 = 1;
pub const CONFIG_NVMEM_QCOM_QFPROM_MODULE: u32 = 1;
pub const CONFIG_ATH9K_PCOEM: u32 = 1;
pub const CONFIG_MLX5_CORE_IPOIB: u32 = 1;
pub const CONFIG_SOUND_OSS_CORE: u32 = 1;
pub const CONFIG_LIBIE_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CS4271_MODULE: u32 = 1;
pub const CONFIG_VBOXGUEST_MODULE: u32 = 1;
pub const CONFIG_VIDEO_IMX290_MODULE: u32 = 1;
pub const CONFIG_BSD_PROCESS_ACCT_V3: u32 = 1;
pub const CONFIG_PHY_SUN50I_USB3_MODULE: u32 = 1;
pub const CONFIG_FUSE_PASSTHROUGH: u32 = 1;
pub const CONFIG_RTL8192C_COMMON_MODULE: u32 = 1;
pub const CONFIG_IMA_WRITE_POLICY: u32 = 1;
pub const CONFIG_USB_F_OBEX_MODULE: u32 = 1;
pub const CONFIG_XILINX_WINDOW_WATCHDOG_MODULE: u32 = 1;
pub const CONFIG_DT_IDLE_STATES: u32 = 1;
pub const CONFIG_HAVE_SETUP_PER_CPU_AREA: u32 = 1;
pub const CONFIG_USBIP_VHCI_HC_PORTS: u32 = 8;
pub const CONFIG_PCIE_PTM: u32 = 1;
pub const CONFIG_SLIMBUS_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_SET_DIRECT_MAP: u32 = 1;
pub const CONFIG_USB_SERIAL_SIMPLE_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_REALM_MODULE: u32 = 1;
pub const CONFIG_RUSTC_VERSION_TEXT: &[u8; 59] =
    b"rustc 1.86.0 (05f9846f8 2025-03-31) (Fedora 1.86.0-2.fc43)\0";
pub const CONFIG_USB_CHIPIDEA_PCI_MODULE: u32 = 1;
pub const CONFIG_CIFS_UPCALL: u32 = 1;
pub const CONFIG_SOCIONEXT_SYNQUACER_PREITS: u32 = 1;
pub const CONFIG_CRYPTO_DEV_QAT_C3XXXVF_MODULE: u32 = 1;
pub const CONFIG_USB_SL811_HCD_MODULE: u32 = 1;
pub const CONFIG_OPEN_DICE_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_RATEEST_MODULE: u32 = 1;
pub const CONFIG_HNS3_HCLGE_MODULE: u32 = 1;
pub const CONFIG_SND_MIXART_MODULE: u32 = 1;
pub const CONFIG_SATA_MOBILE_LPM_POLICY: u32 = 3;
pub const CONFIG_DMARD10_MODULE: u32 = 1;
pub const CONFIG_AS_HAS_LSE_ATOMICS: u32 = 1;
pub const CONFIG_VCNL4000_MODULE: u32 = 1;
pub const CONFIG_SND_HDA_GENERIC_MODULE: u32 = 1;
pub const CONFIG_GPIO_MLXBF3_MODULE: u32 = 1;
pub const CONFIG_WL18XX_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_TPS65219_MODULE: u32 = 1;
pub const CONFIG_FSL_ERRATUM_A008585: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA_MODULE: u32 = 1;
pub const CONFIG_MFD_ROHM_BD718XX: u32 = 1;
pub const CONFIG_SURFACE_KBD_MODULE: u32 = 1;
pub const CONFIG_KUNIT_ALL_TESTS_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_SHA2_ARM64_CE: u32 = 1;
pub const CONFIG_DECOMPRESS_BZIP2: u32 = 1;
pub const CONFIG_RDMA_RXE_MODULE: u32 = 1;
pub const CONFIG_MODULE_SIG: u32 = 1;
pub const CONFIG_MODULE_SIG_FORMAT: u32 = 1;
pub const CONFIG_SA_GCC_8775P_MODULE: u32 = 1;
pub const CONFIG_BLK_DEV_RNBD_SERVER_MODULE: u32 = 1;
pub const CONFIG_I2C_QUP_MODULE: u32 = 1;
pub const CONFIG_HAVE_ARCH_VMAP_STACK: u32 = 1;
pub const CONFIG_EFI_STUB: u32 = 1;
pub const CONFIG_GPIO_WM8994_MODULE: u32 = 1;
pub const CONFIG_BT_HCIUART_H4: u32 = 1;
pub const CONFIG_SND_SOC_FSL_AUD2HTX_MODULE: u32 = 1;
pub const CONFIG_DMABUF_HEAPS_SYSTEM: u32 = 1;
pub const CONFIG_MIN_HEAP: u32 = 1;
pub const CONFIG_ARM64_WORKAROUND_TSB_FLUSH_FAILURE: u32 = 1;
pub const CONFIG_SSB_DRIVER_GPIO: u32 = 1;
pub const CONFIG_RTC_LIB: u32 = 1;
pub const CONFIG_QCOM_SMEM_STATE: u32 = 1;
pub const CONFIG_HAVE_MOVE_PUD: u32 = 1;
pub const CONFIG_SENSORS_LM77_MODULE: u32 = 1;
pub const CONFIG_SND_MESON_AXG_SOUND_CARD_MODULE: u32 = 1;
pub const CONFIG_RADIO_WL1273_MODULE: u32 = 1;
pub const CONFIG_QED_SRIOV: u32 = 1;
pub const CONFIG_PWRSEQ_SD8787_MODULE: u32 = 1;
pub const CONFIG_PM8916_WATCHDOG_MODULE: u32 = 1;
pub const CONFIG_ARM_PKVM_GUEST: u32 = 1;
pub const CONFIG_RESET_TI_SCI_MODULE: u32 = 1;
pub const CONFIG_INPUT_UINPUT_MODULE: u32 = 1;
pub const CONFIG_SCSI_DEBUG_MODULE: u32 = 1;
pub const CONFIG_CAN_HI311X_MODULE: u32 = 1;
pub const CONFIG_SENSORS_TMP108_MODULE: u32 = 1;
pub const CONFIG_PER_VMA_LOCK: u32 = 1;
pub const CONFIG_ND_PFN: u32 = 1;
pub const CONFIG_NFT_REDIR_MODULE: u32 = 1;
pub const CONFIG_ARCH_APPLE: u32 = 1;
pub const CONFIG_SPI_NXP_FLEXSPI_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_POLY1305_NEON: u32 = 1;
pub const CONFIG_SND_SOC_PCM186X_I2C_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_SONIXB_MODULE: u32 = 1;
pub const CONFIG_DQL: u32 = 1;
pub const CONFIG_I2C_MV64XXX_MODULE: u32 = 1;
pub const CONFIG_SG_SPLIT: u32 = 1;
pub const CONFIG_RSI_DEBUGFS: u32 = 1;
pub const CONFIG_DRM_I2C_ADV7511_CEC: u32 = 1;
pub const CONFIG_IR_TOY_MODULE: u32 = 1;
pub const CONFIG_TCG_TIS_I2C_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_AMDISP_MODULE: u32 = 1;
pub const CONFIG_SECCOMP_FILTER: u32 = 1;
pub const CONFIG_GPIO_PCI_IDIO_16_MODULE: u32 = 1;
pub const CONFIG_MEGARAID_NEWGEN: u32 = 1;
pub const CONFIG_TASKS_RCU: u32 = 1;
pub const CONFIG_I2C_VERSATILE_MODULE: u32 = 1;
pub const CONFIG_BNXT_SRIOV: u32 = 1;
pub const CONFIG_GCC_VERSION: u32 = 150101;
pub const CONFIG_6LOWPAN_NHC_IPV6_MODULE: u32 = 1;
pub const CONFIG_HAVE_ARCH_JUMP_LABEL_RELATIVE: u32 = 1;
pub const CONFIG_DRM_PANEL_SAMSUNG_S6E3HA8_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CS42L84_MODULE: u32 = 1;
pub const CONFIG_POWER_RESET_GPIO: u32 = 1;
pub const CONFIG_NET_VENDOR_RENESAS: u32 = 1;
pub const CONFIG_RTC_DRV_IMX_BBM_SCMI_MODULE: u32 = 1;
pub const CONFIG_I2C_MUX_PINCTRL_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CS4234_MODULE: u32 = 1;
pub const CONFIG_ARCH_R9A08G045: u32 = 1;
pub const CONFIG_SYSCTL: u32 = 1;
pub const CONFIG_THERMAL_GOV_USER_SPACE: u32 = 1;
pub const CONFIG_ARM64_WORKAROUND_CLEAN_CACHE: u32 = 1;
pub const CONFIG_PANIC_ON_OOPS_VALUE: u32 = 0;
pub const CONFIG_NVMEM: u32 = 1;
pub const CONFIG_CRYPTO_LIB_SHA1: u32 = 1;
pub const CONFIG_TI_SCI_INTA_MSI_DOMAIN: u32 = 1;
pub const CONFIG_ZONE_DEVICE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_QCE_MODULE: u32 = 1;
pub const CONFIG_VIDEO_EM28XX_ALSA_MODULE: u32 = 1;
pub const CONFIG_VLAN_8021Q_GVRP: u32 = 1;
pub const CONFIG_FSL_EDMA_MODULE: u32 = 1;
pub const CONFIG_IP_NF_IPTABLES_LEGACY_MODULE: u32 = 1;
pub const CONFIG_CPUFREQ_VIRT_MODULE: u32 = 1;
pub const CONFIG_USB_ISP1760_MODULE: u32 = 1;
pub const CONFIG_HID_DRAGONRISE_MODULE: u32 = 1;
pub const CONFIG_OCTEONTX2_AF_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_STRING_MODULE: u32 = 1;
pub const CONFIG_SND_AU8830_MODULE: u32 = 1;
pub const CONFIG_GPIO_TEGRA: u32 = 1;
pub const CONFIG_BCM2835_WDT_MODULE: u32 = 1;
pub const CONFIG_SSB_POSSIBLE: u32 = 1;
pub const CONFIG_VIDEO_IMX334_MODULE: u32 = 1;
pub const CONFIG_SPI_SYNQUACER_MODULE: u32 = 1;
pub const CONFIG_VIDEO_IMX274_MODULE: u32 = 1;
pub const CONFIG_SENSORS_PT5161L_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_XILINX: u32 = 1;
pub const CONFIG_TIGON3_MODULE: u32 = 1;
pub const CONFIG_XLNX_R5_REMOTEPROC_MODULE: u32 = 1;
pub const CONFIG_MAXLINEAR_GPHY_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_SOF_IMX9_MODULE: u32 = 1;
pub const CONFIG_CEC_CROS_EC_MODULE: u32 = 1;
pub const CONFIG_NLS_UTF8_MODULE: u32 = 1;
pub const CONFIG_SERIAL_8250_FSL: u32 = 1;
pub const CONFIG_WLAN_VENDOR_REALTEK: u32 = 1;
pub const CONFIG_CRYPTO_DEV_FSL_CAAM_CRYPTO_API: u32 = 1;
pub const CONFIG_B43_PCI_AUTOSELECT: u32 = 1;
pub const CONFIG_USB_GSPCA_STK1135_MODULE: u32 = 1;
pub const CONFIG_GPIO_GENERIC: u32 = 1;
pub const CONFIG_SURFACE_GPE_MODULE: u32 = 1;
pub const CONFIG_DRM_MSM_GPU_STATE: u32 = 1;
pub const CONFIG_SCHED_CLASS_EXT: u32 = 1;
pub const CONFIG_BACKLIGHT_LP855X_MODULE: u32 = 1;
pub const CONFIG_PM_SLEEP_SMP: u32 = 1;
pub const CONFIG_POWER_RESET_GPIO_RESTART: u32 = 1;
pub const CONFIG_FIXED_PHY: u32 = 1;
pub const CONFIG_CRYPTO_NULL: u32 = 1;
pub const CONFIG_REGULATOR_HI655X_MODULE: u32 = 1;
pub const CONFIG_POSIX_MQUEUE_SYSCTL: u32 = 1;
pub const CONFIG_CDX_CONTROLLER_MODULE: u32 = 1;
pub const CONFIG_HOTPLUG_PCI_ACPI: u32 = 1;
pub const CONFIG_INTERRUPT_CNT_MODULE: u32 = 1;
pub const CONFIG_MULTIPLEXER_MODULE: u32 = 1;
pub const CONFIG_HIBERNATION: u32 = 1;
pub const CONFIG_DRM_MALI_DISPLAY_MODULE: u32 = 1;
pub const CONFIG_IP_VS_DH_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_MESON_CLKC_UTILS: u32 = 1;
pub const CONFIG_INPUT_QNAP_MCU_MODULE: u32 = 1;
pub const CONFIG_VIDEO_TW686X_MODULE: u32 = 1;
pub const CONFIG_AD_SIGMA_DELTA_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_PCM512x_MODULE: u32 = 1;
pub const CONFIG_RTW89_8851BE_MODULE: u32 = 1;
pub const CONFIG_IOMMU_IO_PGTABLE_DART: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_OSF_MODULE: u32 = 1;
pub const CONFIG_SND_HDA_CODEC_CS8409_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_ZYNQMP: u32 = 1;
pub const CONFIG_IPMI_SI_MODULE: u32 = 1;
pub const CONFIG_IWL4965_MODULE: u32 = 1;
pub const CONFIG_HID_FT260_MODULE: u32 = 1;
pub const CONFIG_SERIAL_CORE_CONSOLE: u32 = 1;
pub const CONFIG_INTERCONNECT_QCOM_OSM_L3_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV8858_MODULE: u32 = 1;
pub const CONFIG_XXHASH: u32 = 1;
pub const CONFIG_SND_SOC_BT_SCO_MODULE: u32 = 1;
pub const CONFIG_NET_L3_MASTER_DEV: u32 = 1;
pub const CONFIG_TASK_XACCT: u32 = 1;
pub const CONFIG_NET_SOCK_MSG: u32 = 1;
pub const CONFIG_PAGE_OWNER: u32 = 1;
pub const CONFIG_SENSORS_ADM9240_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_LIB_DES_MODULE: u32 = 1;
pub const CONFIG_IPQ_CMN_PLL_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CS42L42_MODULE: u32 = 1;
pub const CONFIG_SND_SEQUENCER_OSS_MODULE: u32 = 1;
pub const CONFIG_INPUT_MAX77693_HAPTIC_MODULE: u32 = 1;
pub const CONFIG_EVM: u32 = 1;
pub const CONFIG_EFI_PARAMS_FROM_FDT: u32 = 1;
pub const CONFIG_MESON_SARADC_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_ECDH: u32 = 1;
pub const CONFIG_ATA_PIIX: u32 = 1;
pub const CONFIG_RTC_DRV_DS2404_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_MAX31335_MODULE: u32 = 1;
pub const CONFIG_ACPI_APMT: u32 = 1;
pub const CONFIG_AL_FIC: u32 = 1;
pub const CONFIG_ARCH_R9A07G054: u32 = 1;
pub const CONFIG_PHY_MESON_GXL_USB2_MODULE: u32 = 1;
pub const CONFIG_CORESIGHT_CTI_MODULE: u32 = 1;
pub const CONFIG_DRM_NOUVEAU_BACKLIGHT: u32 = 1;
pub const CONFIG_DVB_DYNAMIC_MINORS: u32 = 1;
pub const CONFIG_HID_PICOLCD_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_IMX_AUDMIX_MODULE: u32 = 1;
pub const CONFIG_IRQ_DOMAIN_HIERARCHY: u32 = 1;
pub const CONFIG_SPI_CADENCE_MODULE: u32 = 1;
pub const CONFIG_SND_JACK: u32 = 1;
pub const CONFIG_IWLDVM_MODULE: u32 = 1;
pub const CONFIG_NET_ACT_BPF_MODULE: u32 = 1;
pub const CONFIG_UNMAP_KERNEL_AT_EL0: u32 = 1;
pub const CONFIG_CRC_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_HID_LETSKETCH_MODULE: u32 = 1;
pub const CONFIG_CAN_CTUCANFD_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_DIB0700_MODULE: u32 = 1;
pub const CONFIG_SENSORS_TMP401_MODULE: u32 = 1;
pub const CONFIG_CONTEXT_TRACKING_USER: u32 = 1;
pub const CONFIG_SND_SOC_LPASS_APQ8016_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_LIB_POLY1305: u32 = 1;
pub const CONFIG_SND_SOC_CS_AMP_LIB_MODULE: u32 = 1;
pub const CONFIG_SLUB_CPU_PARTIAL: u32 = 1;
pub const CONFIG_I2C_SCMI_MODULE: u32 = 1;
pub const CONFIG_MTD_NAND_CORE_MODULE: u32 = 1;
pub const CONFIG_NET_DSA_XRS700X_I2C_MODULE: u32 = 1;
pub const CONFIG_CLK_RZV2H: u32 = 1;
pub const CONFIG_ACPI_NFIT_MODULE: u32 = 1;
pub const CONFIG_GENERIC_IRQ_PROBE: u32 = 1;
pub const CONFIG_CRYPTO_ECRDSA_MODULE: u32 = 1;
pub const CONFIG_TCP_CONG_VENO_MODULE: u32 = 1;
pub const CONFIG_9P_FS_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_MODULE: u32 = 1;
pub const CONFIG_SQUASHFS_LZO: u32 = 1;
pub const CONFIG_IMX_SCU: u32 = 1;
pub const CONFIG_FRAMEBUFFER_CONSOLE_DETECT_PRIMARY: u32 = 1;
pub const CONFIG_NET_SCH_TAPRIO_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_PCM1789_MODULE: u32 = 1;
pub const CONFIG_SENSORS_W83795_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_KRB5ENC_MODULE: u32 = 1;
pub const CONFIG_SENSORS_LTC3815_MODULE: u32 = 1;
pub const CONFIG_NVMEM_IMX_OCOTP_MODULE: u32 = 1;
pub const CONFIG_APPLE_MAILBOX_MODULE: u32 = 1;
pub const CONFIG_FRAME_WARN: u32 = 2048;
pub const CONFIG_DYNAMIC_FTRACE: u32 = 1;
pub const CONFIG_DRM_PANEL_SITRONIX_ST7789V_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_SIGMADSP_REGMAP_MODULE: u32 = 1;
pub const CONFIG_NLS_MAC_CENTEURO_MODULE: u32 = 1;
pub const CONFIG_VIDEO_DW9768_MODULE: u32 = 1;
pub const CONFIG_LD_VERSION: u32 = 24400;
pub const CONFIG_SND_SOC_QDSP6_AFE_DAI_MODULE: u32 = 1;
pub const CONFIG_NET_CLS_U32_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_PANASONIC_VVX10F034N00_MODULE: u32 = 1;
pub const CONFIG_VT_CONSOLE: u32 = 1;
pub const CONFIG_INET_AH_MODULE: u32 = 1;
pub const CONFIG_I2C: u32 = 1;
pub const CONFIG_RESET_RASPBERRYPI: u32 = 1;
pub const CONFIG_NET_SCH_ETS_MODULE: u32 = 1;
pub const CONFIG_VFIO_PLATFORM_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA210_I2S_MODULE: u32 = 1;
pub const CONFIG_CC_HAS_UBSAN_BOUNDS_STRICT: u32 = 1;
pub const CONFIG_BATTERY_RT5033_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_MODULE: u32 = 1;
pub const CONFIG_VIDEO_V4L2_TPG_MODULE: u32 = 1;
pub const CONFIG_ADXL313_I2C_MODULE: u32 = 1;
pub const CONFIG_USB_MUSB_HDRC_MODULE: u32 = 1;
pub const CONFIG_ARM64_SW_TTBR0_PAN: u32 = 1;
pub const CONFIG_SCSI_MVUMI_MODULE: u32 = 1;
pub const CONFIG_CAVIUM_ERRATUM_23144: u32 = 1;
pub const CONFIG_GPIO_MPC8XXX: u32 = 1;
pub const CONFIG_PCIE_PME: u32 = 1;
pub const CONFIG_BCACHEFS_FS_MODULE: u32 = 1;
pub const CONFIG_MD_RAID10_MODULE: u32 = 1;
pub const CONFIG_LEDS_CLASS: u32 = 1;
pub const CONFIG_MEDIA_RADIO_SUPPORT: u32 = 1;
pub const CONFIG_LSI_ET1011C_PHY_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_ADI: u32 = 1;
pub const CONFIG_DRM_MSM_MDP5: u32 = 1;
pub const CONFIG_LTC2688_MODULE: u32 = 1;
pub const CONFIG_LEDS_TRIGGER_PANIC: u32 = 1;
pub const CONFIG_BT_HCIUART_AG6XX: u32 = 1;
pub const CONFIG_RESOURCE_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_PM_SLEEP: u32 = 1;
pub const CONFIG_VIDEO_IMX415_MODULE: u32 = 1;
pub const CONFIG_NET_SCH_CODEL_MODULE: u32 = 1;
pub const CONFIG_MODULE_SIG_ALL: u32 = 1;
pub const CONFIG_ALIBABA_UNCORE_DRW_PMU_MODULE: u32 = 1;
pub const CONFIG_PHY_QCOM_UNIPHY_PCIE_28LP: u32 = 1;
pub const CONFIG_SENSORS_ADM1029_MODULE: u32 = 1;
pub const CONFIG_VIDEO_DW9807_VCM_MODULE: u32 = 1;
pub const CONFIG_DRM_BRIDGE: u32 = 1;
pub const CONFIG_PINCTRL_SUN55I_A523_R: u32 = 1;
pub const CONFIG_REED_SOLOMON_DEC8: u32 = 1;
pub const CONFIG_MKISS_MODULE: u32 = 1;
pub const CONFIG_VIDEO_SAA7134_RC: u32 = 1;
pub const CONFIG_USB_GSPCA_SPCA506_MODULE: u32 = 1;
pub const CONFIG_ACPI_NUMA: u32 = 1;
pub const CONFIG_AD74413R_MODULE: u32 = 1;
pub const CONFIG_SENSORS_ADT7410_MODULE: u32 = 1;
pub const CONFIG_IWLWIFI_DEBUG: u32 = 1;
pub const CONFIG_HID_MAGICMOUSE: u32 = 1;
pub const CONFIG_NET_SCH_FQ_MODULE: u32 = 1;
pub const CONFIG_THERMAL_OF: u32 = 1;
pub const CONFIG_VIDEO_BT848_MODULE: u32 = 1;
pub const CONFIG_DRM_LIMA_MODULE: u32 = 1;
pub const CONFIG_RT2800USB_RT53XX: u32 = 1;
pub const CONFIG_VIDEO_M52790_MODULE: u32 = 1;
pub const CONFIG_SYSTEM_DATA_VERIFICATION: u32 = 1;
pub const CONFIG_VIRTIO_IOMMU: u32 = 1;
pub const CONFIG_LOCK_TORTURE_TEST_MODULE: u32 = 1;
pub const CONFIG_CC_HAS_BRANCH_PROT_PAC_RET: u32 = 1;
pub const CONFIG_HIBERNATION_SNAPSHOT_DEV: u32 = 1;
pub const CONFIG_ARM_CMN_MODULE: u32 = 1;
pub const CONFIG_HID_ZEROPLUS_MODULE: u32 = 1;
pub const CONFIG_SND_HDA_DSP_LOADER: u32 = 1;
pub const CONFIG_USB_DWC3_XILINX_MODULE: u32 = 1;
pub const CONFIG_NET_PTP_CLASSIFY: u32 = 1;
pub const CONFIG_SND_SOC_RT711_SDCA_SDW_MODULE: u32 = 1;
pub const CONFIG_VMAP_STACK: u32 = 1;
pub const CONFIG_GPIO_ZYNQ_MODULE: u32 = 1;
pub const CONFIG_ICE_MODULE: u32 = 1;
pub const CONFIG_PM: u32 = 1;
pub const CONFIG_DST_CACHE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_VIRTIO_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_CCP_CRYPTO_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_SHA512: u32 = 1;
pub const CONFIG_MEMORY_FAILURE: u32 = 1;
pub const CONFIG_LIST_HARDENED: u32 = 1;
pub const CONFIG_IIO_ST_PRESS_I2C_MODULE: u32 = 1;
pub const CONFIG_SENSORS_F71882FG_MODULE: u32 = 1;
pub const CONFIG_ADXL367_I2C_MODULE: u32 = 1;
pub const CONFIG_IRQ_POLL: u32 = 1;
pub const CONFIG_LEDS_LP8864_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_GOOGLE: u32 = 1;
pub const CONFIG_ARCH_SPARSEMEM_ENABLE: u32 = 1;
pub const CONFIG_ARCH_ENABLE_THP_MIGRATION: u32 = 1;
pub const CONFIG_STUB_CLK_HI3660: u32 = 1;
pub const CONFIG_ACPI_THERMAL_LIB: u32 = 1;
pub const CONFIG_USB_EHCI_ROOT_HUB_TT: u32 = 1;
pub const CONFIG_MVEBU_PIC: u32 = 1;
pub const CONFIG_USB_NET_AX88179_178A_MODULE: u32 = 1;
pub const CONFIG_NLS_CODEPAGE_775_MODULE: u32 = 1;
pub const CONFIG_CMA_SYSFS: u32 = 1;
pub const CONFIG_MARVELL_PHY_MODULE: u32 = 1;
pub const CONFIG_HID_PRIMAX_MODULE: u32 = 1;
pub const CONFIG_NLS: u32 = 1;
pub const CONFIG_USB_S2255_MODULE: u32 = 1;
pub const CONFIG_IP_SET_HASH_NETPORTNET_MODULE: u32 = 1;
pub const CONFIG_SDM_CAMCC_845_MODULE: u32 = 1;
pub const CONFIG_OID_REGISTRY: u32 = 1;
pub const CONFIG_IIO_KX022A_MODULE: u32 = 1;
pub const CONFIG_MEDIATEK_GE_PHY_MODULE: u32 = 1;
pub const CONFIG_USER_STACKTRACE_SUPPORT: u32 = 1;
pub const CONFIG_SND_CTXFI_MODULE: u32 = 1;
pub const CONFIG_QCOM_COMMAND_DB: u32 = 1;
pub const CONFIG_BT_NXPUART_MODULE: u32 = 1;
pub const CONFIG_THERMAL_MMIO_MODULE: u32 = 1;
pub const CONFIG_SPI_OFFLOAD_TRIGGER_PWM_MODULE: u32 = 1;
pub const CONFIG_THUNDER_NIC_PF_MODULE: u32 = 1;
pub const CONFIG_SCHED_TRACER: u32 = 1;
pub const CONFIG_MLXREG_HOTPLUG_MODULE: u32 = 1;
pub const CONFIG_B43_PHY_G: u32 = 1;
pub const CONFIG_INPUT_CMA3000_I2C_MODULE: u32 = 1;
pub const CONFIG_BNXT_FLOWER_OFFLOAD: u32 = 1;
pub const CONFIG_TOUCHSCREEN_WACOM_I2C_MODULE: u32 = 1;
pub const CONFIG_ACPI_ALS_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OG01A1B_MODULE: u32 = 1;
pub const CONFIG_GENERIC_IRQ_MIGRATION: u32 = 1;
pub const CONFIG_SQUASHFS_ZLIB: u32 = 1;
pub const CONFIG_MLX4_CORE_MODULE: u32 = 1;
pub const CONFIG_MLX5_DPLL_MODULE: u32 = 1;
pub const CONFIG_CAN_CAN327_MODULE: u32 = 1;
pub const CONFIG_SUNXI_CCU: u32 = 1;
pub const CONFIG_SPEAKUP_SYNTH_APOLLO_MODULE: u32 = 1;
pub const CONFIG_SPEAKUP_SYNTH_DECTLK_MODULE: u32 = 1;
pub const CONFIG_MFD_TPS65219_MODULE: u32 = 1;
pub const CONFIG_DVB_HORUS3A_MODULE: u32 = 1;
pub const CONFIG_QCOM_MPM_MODULE: u32 = 1;
pub const CONFIG_ARCH_DEFAULT_KEXEC_IMAGE_VERIFY_SIG: u32 = 1;
pub const CONFIG_XFRM_IPTFS_MODULE: u32 = 1;
pub const CONFIG_SENSORS_LM87_MODULE: u32 = 1;
pub const CONFIG_BACKLIGHT_PWM_MODULE: u32 = 1;
pub const CONFIG_RPCSEC_GSS_KRB5_ENCTYPES_CAMELLIA: u32 = 1;
pub const CONFIG_USB_VIDEO_CLASS_INPUT_EVDEV: u32 = 1;
pub const CONFIG_SOC_TEGRA_PMC: u32 = 1;
pub const CONFIG_DVB_STV0297_MODULE: u32 = 1;
pub const CONFIG_IPMI_IPMB_MODULE: u32 = 1;
pub const CONFIG_NET_DSA_TAG_BRCM_PREPEND_MODULE: u32 = 1;
pub const CONFIG_SENSORS_LTC4215_MODULE: u32 = 1;
pub const CONFIG_AUDIT_COMPAT_GENERIC: u32 = 1;
pub const CONFIG_NETFILTER_FAMILY_BRIDGE: u32 = 1;
pub const CONFIG_RENESAS_GEN4_PTP_MODULE: u32 = 1;
pub const CONFIG_CC_NO_ARRAY_BOUNDS: u32 = 1;
pub const CONFIG_6LOWPAN_GHC_EXT_HDR_ROUTE_MODULE: u32 = 1;
pub const CONFIG_MLX90632_MODULE: u32 = 1;
pub const CONFIG_DRM_TIDSS_MODULE: u32 = 1;
pub const CONFIG_FIB_RULES: u32 = 1;
pub const CONFIG_NFT_XFRM_MODULE: u32 = 1;
pub const CONFIG_CONTEXT_TRACKING_IDLE: u32 = 1;
pub const CONFIG_AD7779_MODULE: u32 = 1;
pub const CONFIG_BLK_DEBUG_FS: u32 = 1;
pub const CONFIG_SND_SUN50I_DMIC_MODULE: u32 = 1;
pub const CONFIG_INPUT_HISI_POWERKEY: u32 = 1;
pub const CONFIG_JBD2: u32 = 1;
pub const CONFIG_VIDEO_IMX208_MODULE: u32 = 1;
pub const CONFIG_FONT_SUPPORT: u32 = 1;
pub const CONFIG_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_NXP_CBTX_PHY_MODULE: u32 = 1;
pub const CONFIG_SENSORS_LTC4222_MODULE: u32 = 1;
pub const CONFIG_ARCH_WANTS_EXECMEM_LATE: u32 = 1;
pub const CONFIG_ARM_SCMI_HAVE_SHMEM: u32 = 1;
pub const CONFIG_USB_CDNS3_HOST: u32 = 1;
pub const CONFIG_GENERIC_IRQ_EFFECTIVE_AFF_MASK: u32 = 1;
pub const CONFIG_CRYPTO_DEV_FSL_CAAM_RINGSIZE: u32 = 3;
pub const CONFIG_PINCTRL_TEGRA124: u32 = 1;
pub const CONFIG_WIRELESS: u32 = 1;
pub const CONFIG_THERMAL_GOV_FAIR_SHARE: u32 = 1;
pub const CONFIG_BLK_DEV_BSGLIB: u32 = 1;
pub const CONFIG_COMMON_CLK_MAX77686: u32 = 1;
pub const CONFIG_SUN50I_A100_R_CCU: u32 = 1;
pub const CONFIG_9P_FS_SECURITY: u32 = 1;
pub const CONFIG_VIDEO_ADV7170_MODULE: u32 = 1;
pub const CONFIG_NET_SCH_FQ_PIE_MODULE: u32 = 1;
pub const CONFIG_MLXSW_SPECTRUM_MODULE: u32 = 1;
pub const CONFIG_PHY_ROCKCHIP_INNO_DSIDPHY_MODULE: u32 = 1;
pub const CONFIG_SATA_SIL24_MODULE: u32 = 1;
pub const CONFIG_MAX1363_MODULE: u32 = 1;
pub const CONFIG_SCSI_DH_ALUA_MODULE: u32 = 1;
pub const CONFIG_VIDEO_IMX283_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MCP3021_MODULE: u32 = 1;
pub const CONFIG_USB_SNP_UDC_PLAT_MODULE: u32 = 1;
pub const CONFIG_SND_CS46XX_MODULE: u32 = 1;
pub const CONFIG_NETFILTER: u32 = 1;
pub const CONFIG_TCG_FTPM_TEE_MODULE: u32 = 1;
pub const CONFIG_LIBERTAS_THINFIRM_USB_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_MT2063_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_HL_MODULE: u32 = 1;
pub const CONFIG_SND_MESON_AXG_TDMOUT_MODULE: u32 = 1;
pub const CONFIG_DVB_STV6111_MODULE: u32 = 1;
pub const CONFIG_NVME_RDMA_MODULE: u32 = 1;
pub const CONFIG_REGMAP_SPI_MODULE: u32 = 1;
pub const CONFIG_NET_ACT_GATE_MODULE: u32 = 1;
pub const CONFIG_COMMON_RESET_HI3660_MODULE: u32 = 1;
pub const CONFIG_CXL_PCI_MODULE: u32 = 1;
pub const CONFIG_SND_VIRMIDI_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_SN9C2028_MODULE: u32 = 1;
pub const CONFIG_SYS_SUPPORTS_SH_CMT: u32 = 1;
pub const CONFIG_NET_IPGRE_MODULE: u32 = 1;
pub const CONFIG_MSM_GCC_8996: u32 = 1;
pub const CONFIG_INFINIBAND_IRDMA_MODULE: u32 = 1;
pub const CONFIG_DYNAMIC_FTRACE_WITH_CALL_OPS: u32 = 1;
pub const CONFIG_SND_USB_AUDIO_USE_MEDIA_CONTROLLER: u32 = 1;
pub const CONFIG_BSD_DISKLABEL: u32 = 1;
pub const CONFIG_USB_STORAGE_SDDR09_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV9650_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_RASPBERRYPI_TOUCHSCREEN_MODULE: u32 = 1;
pub const CONFIG_VIDEO_WAVE_VPU_MODULE: u32 = 1;
pub const CONFIG_BLK_WBT_MQ: u32 = 1;
pub const CONFIG_CHROMEOS_ACPI_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_PCM186X_SPI_MODULE: u32 = 1;
pub const CONFIG_DVB_CXD2841ER_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_QCE_ENABLE_ALL: u32 = 1;
pub const CONFIG_FUNCTION_GRAPH_RETVAL: u32 = 1;
pub const CONFIG_GPIO_TPS65219_MODULE: u32 = 1;
pub const CONFIG_DRM_DISPLAY_DP_HELPER: u32 = 1;
pub const CONFIG_EFI_VARS_PSTORE_DEFAULT_DISABLE: u32 = 1;
pub const CONFIG_SND_SOC_ES8311_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_LPASS_RX_MACRO_MODULE: u32 = 1;
pub const CONFIG_VIDEO_TVP5150_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_IMX8MN: u32 = 1;
pub const CONFIG_CLK_RZG2L: u32 = 1;
pub const CONFIG_ENA_ETHERNET_MODULE: u32 = 1;
pub const CONFIG_HFSPLUS_FS_MODULE: u32 = 1;
pub const CONFIG_SENSORS_ARM_SCPI_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_SKCIPHER: u32 = 1;
pub const CONFIG_USB_CONFIGFS_F_TCM: u32 = 1;
pub const CONFIG_MLX5_EN_TLS: u32 = 1;
pub const CONFIG_SENSORS_LM75_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_MOS7840_MODULE: u32 = 1;
pub const CONFIG_NETDEV_ADDR_LIST_TEST_MODULE: u32 = 1;
pub const CONFIG_IR_SONY_DECODER_MODULE: u32 = 1;
pub const CONFIG_SERIO_ARC_PS2_MODULE: u32 = 1;
pub const CONFIG_HID_ITE_MODULE: u32 = 1;
pub const CONFIG_HAVE_FUNCTION_GRAPH_FREGS: u32 = 1;
pub const CONFIG_VIDEO_IMX355_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TLV320AIC23_I2C_MODULE: u32 = 1;
pub const CONFIG_PCP_BATCH_SCALE_MAX: u32 = 5;
pub const CONFIG_VIDEO_ST_MIPID02_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_NFACCT_MODULE: u32 = 1;
pub const CONFIG_VIDEO_IMX412_MODULE: u32 = 1;
pub const CONFIG_SLAB_FREELIST_HARDENED: u32 = 1;
pub const CONFIG_PM_GENERIC_DOMAINS: u32 = 1;
pub const CONFIG_CRYPTO_LRW_MODULE: u32 = 1;
pub const CONFIG_XFS_ONLINE_SCRUB: u32 = 1;
pub const CONFIG_SERIO_LIBPS2: u32 = 1;
pub const CONFIG_MMA8452_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_SPCA505_MODULE: u32 = 1;
pub const CONFIG_TAP_MODULE: u32 = 1;
pub const CONFIG_HAVE_PREEMPT_DYNAMIC: u32 = 1;
pub const CONFIG_CRYPTO_CURVE25519_MODULE: u32 = 1;
pub const CONFIG_ARM64_PLATFORM_DEVICES: u32 = 1;
pub const CONFIG_USB_DEFAULT_PERSIST: u32 = 1;
pub const CONFIG_SND_SOC_MAX98520_MODULE: u32 = 1;
pub const CONFIG_SENSORS_ADT7411_MODULE: u32 = 1;
pub const CONFIG_TCP_CONG_CUBIC: u32 = 1;
pub const CONFIG_CLK_BCM2711_DVP_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_SDM845_MODULE: u32 = 1;
pub const CONFIG_NVMEM_MESON_MX_EFUSE_MODULE: u32 = 1;
pub const CONFIG_HID_THINGM_MODULE: u32 = 1;
pub const CONFIG_ATM_BR2684_MODULE: u32 = 1;
pub const CONFIG_DRM_MSM_HDMI: u32 = 1;
pub const CONFIG_SCTP_COOKIE_HMAC_MD5: u32 = 1;
pub const CONFIG_XDP_SOCKETS: u32 = 1;
pub const CONFIG_CRYPTO_ECHAINIV_MODULE: u32 = 1;
pub const CONFIG_TINYDRM_HX8357D_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_TEGRA194: u32 = 1;
pub const CONFIG_MEGARAID_MAILBOX_MODULE: u32 = 1;
pub const CONFIG_MTD_NAND_MARVELL_MODULE: u32 = 1;
pub const CONFIG_RTW89_8922A_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_UBSAN: u32 = 1;
pub const CONFIG_MFD_WCD934X_MODULE: u32 = 1;
pub const CONFIG_HID_PICOLCD_LEDS: u32 = 1;
pub const CONFIG_DVB_DIB7000P_MODULE: u32 = 1;
pub const CONFIG_CW1200_MODULE: u32 = 1;
pub const CONFIG_JFFS2_SUMMARY: u32 = 1;
pub const CONFIG_VIDEO_CCS_PLL_MODULE: u32 = 1;
pub const CONFIG_IP_SET_BITMAP_IP_MODULE: u32 = 1;
pub const CONFIG_VMAP_PFN: u32 = 1;
pub const CONFIG_SENSORS_TPS25990_MODULE: u32 = 1;
pub const CONFIG_ARCH_WANT_DEFAULT_TOPDOWN_MMAP_LAYOUT: u32 = 1;
pub const CONFIG_HAVE_SOFTIRQ_ON_OWN_STACK: u32 = 1;
pub const CONFIG_MTD_CFI_AMDSTD_MODULE: u32 = 1;
pub const CONFIG_MMC_QCOM_DML: u32 = 1;
pub const CONFIG_ACPI_PPTT: u32 = 1;
pub const CONFIG_VIRT_CPU_ACCOUNTING_GEN: u32 = 1;
pub const CONFIG_IMX_IRQSTEER: u32 = 1;
pub const CONFIG_EFI_ARMSTUB_DTB_LOADER: u32 = 1;
pub const CONFIG_BPF_JIT: u32 = 1;
pub const CONFIG_TRACE_GPU_MEM: u32 = 1;
pub const CONFIG_ARCH_HAS_MEM_ENCRYPT: u32 = 1;
pub const CONFIG_SUNRPC_DEBUG: u32 = 1;
pub const CONFIG_HID_MALTRON_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_CAST5_MODULE: u32 = 1;
pub const CONFIG_PM_TEST_SUSPEND: u32 = 1;
pub const CONFIG_NET_TEAM_MODE_ACTIVEBACKUP_MODULE: u32 = 1;
pub const CONFIG_MT7921E_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_HI3660: u32 = 1;
pub const CONFIG_DVB_AS102_MODULE: u32 = 1;
pub const CONFIG_CLK_FIXED_RATE_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_HID_PANTHERLORD_MODULE: u32 = 1;
pub const CONFIG_BATMAN_ADV_TRACING: u32 = 1;
pub const CONFIG_HAVE_CLK_PREPARE: u32 = 1;
pub const CONFIG_USB_CONFIGFS_MASS_STORAGE: u32 = 1;
pub const CONFIG_AS_HAS_LDAPR: u32 = 1;
pub const CONFIG_SENSORS_SURFACE_TEMP_MODULE: u32 = 1;
pub const CONFIG_IR_ENE_MODULE: u32 = 1;
pub const CONFIG_SURFACE_PLATFORM_PROFILE_MODULE: u32 = 1;
pub const CONFIG_UNIXWARE_DISKLABEL: u32 = 1;
pub const CONFIG_SPI_ROCKCHIP_MODULE: u32 = 1;
pub const CONFIG_PTP_1588_CLOCK_MOCK_MODULE: u32 = 1;
pub const CONFIG_AS_HAS_CFI_NEGATE_RA_STATE: u32 = 1;
pub const CONFIG_HAVE_RUST: u32 = 1;
pub const CONFIG_BLK_DEV_BSG_COMMON: u32 = 1;
pub const CONFIG_CFG80211_CRDA_SUPPORT: u32 = 1;
pub const CONFIG_SND_SOC_RT5514_MODULE: u32 = 1;
pub const CONFIG_MFD_RK8XX_MODULE: u32 = 1;
pub const CONFIG_IP_ADVANCED_ROUTER: u32 = 1;
pub const CONFIG_HMM_MIRROR: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA_RT5631_MODULE: u32 = 1;
pub const CONFIG_JOYSTICK_IFORCE_MODULE: u32 = 1;
pub const CONFIG_SND_ICE1712_MODULE: u32 = 1;
pub const CONFIG_GENERIC_CSUM: u32 = 1;
pub const CONFIG_IP_VS_OVF_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_GENIV: u32 = 1;
pub const CONFIG_REGULATOR_ACT8865_MODULE: u32 = 1;
pub const CONFIG_TRACER_SNAPSHOT: u32 = 1;
pub const CONFIG_VIDEO_EM28XX_RC_MODULE: u32 = 1;
pub const CONFIG_USB_ONBOARD_DEV_MODULE: u32 = 1;
pub const CONFIG_FTRACE: u32 = 1;
pub const CONFIG_BAYCOM_SER_HDX_MODULE: u32 = 1;
pub const CONFIG_ARM_SMC_WATCHDOG_MODULE: u32 = 1;
pub const CONFIG_RTL8192EE_MODULE: u32 = 1;
pub const CONFIG_USB_DWC3_ULPI: u32 = 1;
pub const CONFIG_SND_SOC_HDMI_CODEC_MODULE: u32 = 1;
pub const CONFIG_DNS_RESOLVER_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_S4_PLL: u32 = 1;
pub const CONFIG_MTD_DATAFLASH_OTP: u32 = 1;
pub const CONFIG_SUNRPC_GSS_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_LPASS_SC7280_MODULE: u32 = 1;
pub const CONFIG_SERIAL_SH_SCI_NR_UARTS: u32 = 18;
pub const CONFIG_VIDEOMODE_HELPERS: u32 = 1;
pub const CONFIG_SQUASHFS_LZ4: u32 = 1;
pub const CONFIG_MITIGATE_SPECTRE_BRANCH_HISTORY: u32 = 1;
pub const CONFIG_EDAC_SUPPORT: u32 = 1;
pub const CONFIG_USB_PRINTER_MODULE: u32 = 1;
pub const CONFIG_FW_CFG_SYSFS_MODULE: u32 = 1;
pub const CONFIG_AFS_DEBUG: u32 = 1;
pub const CONFIG_HAVE_ARCH_COMPILER_H: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_2645198: u32 = 1;
pub const CONFIG_B44_PCICORE_AUTOSELECT: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_NETMAP_MODULE: u32 = 1;
pub const CONFIG_VDPA_SIM_NET_MODULE: u32 = 1;
pub const CONFIG_ACPI_IPMI_MODULE: u32 = 1;
pub const CONFIG_RAPIDIO_CPS_GEN2_MODULE: u32 = 1;
pub const CONFIG_SPI_MASTER: u32 = 1;
pub const CONFIG_TEGRA_HOST1X_CONTEXT_BUS: u32 = 1;
pub const CONFIG_SND_INTEL_SOUNDWIRE_ACPI_MODULE: u32 = 1;
pub const CONFIG_VIDEO_SAA7110_MODULE: u32 = 1;
pub const CONFIG_F2FS_FS_LZ4HC: u32 = 1;
pub const CONFIG_USB_GSPCA_SE401_MODULE: u32 = 1;
pub const CONFIG_STRIP_ASM_SYMS: u32 = 1;
pub const CONFIG_SENSORS_SIS5595_MODULE: u32 = 1;
pub const CONFIG_PWM_GPIO_MODULE: u32 = 1;
pub const CONFIG_MDIO_MVUSB_MODULE: u32 = 1;
pub const CONFIG_EFI_PARTITION: u32 = 1;
pub const CONFIG_QCS_GCC_404_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MAX6620_MODULE: u32 = 1;
pub const CONFIG_ARCH_R9A07G043: u32 = 1;
pub const CONFIG_MTD_SPI_NOR_MODULE: u32 = 1;
pub const CONFIG_QCOM_SSC_BLOCK_BUS: u32 = 1;
pub const CONFIG_SND_AC97_POWER_SAVE: u32 = 1;
pub const CONFIG_PCIE_BUS_DEFAULT: u32 = 1;
pub const CONFIG_EDAC_THUNDERX_MODULE: u32 = 1;
pub const CONFIG_I2C_PXA_MODULE: u32 = 1;
pub const CONFIG_BUILTIN_RETURN_ADDRESS_STRIPS_PAC: u32 = 1;
pub const CONFIG_SENSORS_LTC2990_MODULE: u32 = 1;
pub const CONFIG_MDIO_GPIO_MODULE: u32 = 1;
pub const CONFIG_AX88796B_RUST_PHY: u32 = 1;
pub const CONFIG_MARVELL_10G_PHY_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_ADI_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CS530X_I2C_MODULE: u32 = 1;
pub const CONFIG_ST_UVIS25_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_SAMSUNG_S6E8AA0_MODULE: u32 = 1;
pub const CONFIG_MACB_PCI_MODULE: u32 = 1;
pub const CONFIG_SCSI_UFS_ROCKCHIP_MODULE: u32 = 1;
pub const CONFIG_VIDEO_SAA7127_MODULE: u32 = 1;
pub const CONFIG_MAX11205_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_HISI_QM_MODULE: u32 = 1;
pub const CONFIG_MT792x_USB_MODULE: u32 = 1;
pub const CONFIG_IP_NF_MATCH_TTL_MODULE: u32 = 1;
pub const CONFIG_MMC_TIFM_SD_MODULE: u32 = 1;
pub const CONFIG_HW_RANDOM_IPROC_RNG200_MODULE: u32 = 1;
pub const CONFIG_FHANDLE: u32 = 1;
pub const CONFIG_SND_SOC_TOPOLOGY_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_SND_USB_HIFACE_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_843419: u32 = 1;
pub const CONFIG_XFS_SUPPORT_ASCII_CI: u32 = 1;
pub const CONFIG_COMPRESSED_INSTALL: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_CGROUP_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_SSU100_MODULE: u32 = 1;
pub const CONFIG_SENSORS_G762_MODULE: u32 = 1;
pub const CONFIG_ARCH_MHP_MEMMAP_ON_MEMORY_ENABLE: u32 = 1;
pub const CONFIG_FPGA_DFL_FME_BRIDGE_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_F81232_MODULE: u32 = 1;
pub const CONFIG_NVME_TARGET_FCLOOP_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_SPCA561_MODULE: u32 = 1;
pub const CONFIG_SND_DARLA24_MODULE: u32 = 1;
pub const CONFIG_MAC80211_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_SURFACE_AGGREGATOR_MODULE: u32 = 1;
pub const CONFIG_ACPI_AGDI: u32 = 1;
pub const CONFIG_SGL_ALLOC: u32 = 1;
pub const CONFIG_TYPEC_HD3SS3220_MODULE: u32 = 1;
pub const CONFIG_DRM_MSM_DSI_28NM_PHY: u32 = 1;
pub const CONFIG_NVMEM_ZYNQMP_MODULE: u32 = 1;
pub const CONFIG_GENERIC_PCI_IOMAP: u32 = 1;
pub const CONFIG_RST_RCAR: u32 = 1;
pub const CONFIG_QCOM_BAM_DMA: u32 = 1;
pub const CONFIG_CRYPTO_USER_API_RNG: u32 = 1;
pub const CONFIG_RTC_DRV_MV_MODULE: u32 = 1;
pub const CONFIG_DVB_STV6110_MODULE: u32 = 1;
pub const CONFIG_MLXFW_MODULE: u32 = 1;
pub const CONFIG_NF_CT_PROTO_GRE: u32 = 1;
pub const CONFIG_RENESAS_RZV2H_ICU: u32 = 1;
pub const CONFIG_SUN20I_GPADC_MODULE: u32 = 1;
pub const CONFIG_BT_HCIBFUSB_MODULE: u32 = 1;
pub const CONFIG_FSL_MC_BUS: u32 = 1;
pub const CONFIG_SOUND_MODULE: u32 = 1;
pub const CONFIG_SENSORS_W83793_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_2966298: u32 = 1;
pub const CONFIG_RAPIDIO_DMA_ENGINE: u32 = 1;
pub const CONFIG_NET_DSA_TAG_TRAILER_MODULE: u32 = 1;
pub const CONFIG_USB_DWC3_DUAL_ROLE: u32 = 1;
pub const CONFIG_NLS_MAC_TURKISH_MODULE: u32 = 1;
pub const CONFIG_GENERIC_ALLOCATOR: u32 = 1;
pub const CONFIG_DVB_TDA1004X_MODULE: u32 = 1;
pub const CONFIG_SND_MESON_AXG_PDM_MODULE: u32 = 1;
pub const CONFIG_HAVE_ARCH_KGDB: u32 = 1;
pub const CONFIG_DRM_PANEL_RAYDIUM_RM692E5_MODULE: u32 = 1;
pub const CONFIG_SERIAL_TEGRA_UTC_MODULE: u32 = 1;
pub const CONFIG_HID_HYPERV_MOUSE_MODULE: u32 = 1;
pub const CONFIG_MTD_NAND_ECC: u32 = 1;
pub const CONFIG_NET_INGRESS: u32 = 1;
pub const CONFIG_CRYPTO_AEAD2: u32 = 1;
pub const CONFIG_INFINIBAND_VIRT_DMA: u32 = 1;
pub const CONFIG_VIDEO_HI846_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_IMX8MM: u32 = 1;
pub const CONFIG_MANA_INFINIBAND_MODULE: u32 = 1;
pub const CONFIG_DM_PERSISTENT_DATA_MODULE: u32 = 1;
pub const CONFIG_QCOM_RPMHPD: u32 = 1;
pub const CONFIG_NET_ACT_MPLS_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA_RT5640_MODULE: u32 = 1;
pub const CONFIG_GENERIC_BUG_RELATIVE_POINTERS: u32 = 1;
pub const CONFIG_SND_YMFPCI_MODULE: u32 = 1;
pub const CONFIG_ARCH_STACKWALK: u32 = 1;
pub const CONFIG_BNXT_MODULE: u32 = 1;
pub const CONFIG_SPI: u32 = 1;
pub const CONFIG_NODES_SHIFT: u32 = 9;
pub const CONFIG_LCD_PLATFORM_MODULE: u32 = 1;
pub const CONFIG_USB_HIDDEV: u32 = 1;
pub const CONFIG_CEC_CH7322_MODULE: u32 = 1;
pub const CONFIG_RPMSG_QCOM_GLINK_MODULE: u32 = 1;
pub const CONFIG_SERIAL_SAMSUNG_UARTS: u32 = 4;
pub const CONFIG_SENSORS_IT87_MODULE: u32 = 1;
pub const CONFIG_TCM_FILEIO_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_AES_ARM64_BS_MODULE: u32 = 1;
pub const CONFIG_HID_U2FZERO_MODULE: u32 = 1;
pub const CONFIG_BACKLIGHT_KTD253_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_ZFORCE_MODULE: u32 = 1;
pub const CONFIG_KUNIT_DEBUGFS: u32 = 1;
pub const CONFIG_HFS_FS_MODULE: u32 = 1;
pub const CONFIG_HAVE_ARCH_MMAP_RND_BITS: u32 = 1;
pub const CONFIG_SND_FM801_MODULE: u32 = 1;
pub const CONFIG_VIDEO_MT9V032_MODULE: u32 = 1;
pub const CONFIG_IMX_SDMA_MODULE: u32 = 1;
pub const CONFIG_HAVE_PERF_REGS: u32 = 1;
pub const CONFIG_HW_RANDOM_XIPHERA_MODULE: u32 = 1;
pub const CONFIG_QCOM_EMAC_MODULE: u32 = 1;
pub const CONFIG_SND_MESON_AXG_FRDDR_MODULE: u32 = 1;
pub const CONFIG_CXL_FEATURES: u32 = 1;
pub const CONFIG_MOTORCOMM_PHY_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA186_ASRC_MODULE: u32 = 1;
pub const CONFIG_VIDEO_AD5820_MODULE: u32 = 1;
pub const CONFIG_PPS_GENERATOR_MODULE: u32 = 1;
pub const CONFIG_VIDEO_MT9T112_MODULE: u32 = 1;
pub const CONFIG_MTD_PHYSMAP_OF: u32 = 1;
pub const CONFIG_RESET_TI_SYSCON_MODULE: u32 = 1;
pub const CONFIG_SERIAL_IMX: u32 = 1;
pub const CONFIG_IMA_MEASURE_ASYMMETRIC_KEYS: u32 = 1;
pub const CONFIG_INTERCONNECT_QCOM_SM8150_MODULE: u32 = 1;
pub const CONFIG_NVMEM_IMX_OCOTP_SCU_MODULE: u32 = 1;
pub const CONFIG_DVB_STB0899_MODULE: u32 = 1;
pub const CONFIG_AD7292_MODULE: u32 = 1;
pub const CONFIG_UEFI_CPER_ARM: u32 = 1;
pub const CONFIG_SND_SOC_WM8731_I2C_MODULE: u32 = 1;
pub const CONFIG_PAGE_SIZE_LESS_THAN_256KB: u32 = 1;
pub const CONFIG_IPV6_SIT_6RD: u32 = 1;
pub const CONFIG_FUSE_DAX: u32 = 1;
pub const CONFIG_HAS_IOPORT: u32 = 1;
pub const CONFIG_DA_MON_EVENTS: u32 = 1;
pub const CONFIG_REGULATOR_RT5759_MODULE: u32 = 1;
pub const CONFIG_NET_9P_USBG_MODULE: u32 = 1;
pub const CONFIG_STRICT_MODULE_RWX: u32 = 1;
pub const CONFIG_IXGBEVF_MODULE: u32 = 1;
pub const CONFIG_CORESIGHT_LINK_AND_SINK_TMC_MODULE: u32 = 1;
pub const CONFIG_CXL_BUS_MODULE: u32 = 1;
pub const CONFIG_MAC802154_MODULE: u32 = 1;
pub const CONFIG_USB_NET_SR9700_MODULE: u32 = 1;
pub const CONFIG_PCS_MTK_LYNXI_MODULE: u32 = 1;
pub const CONFIG_FXOS8700_MODULE: u32 = 1;
pub const CONFIG_QCOM_RMTFS_MEM_MODULE: u32 = 1;
pub const CONFIG_PCI: u32 = 1;
pub const CONFIG_SENSORS_PMBUS_MODULE: u32 = 1;
pub const CONFIG_USB_OHCI_HCD_PCI_MODULE: u32 = 1;
pub const CONFIG_PHY_TI_GMII_SEL_MODULE: u32 = 1;
pub const CONFIG_SND_OPL3_LIB_SEQ_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_CPIA1_MODULE: u32 = 1;
pub const CONFIG_CHARGER_RK817_MODULE: u32 = 1;
pub const CONFIG_CLANG_VERSION: u32 = 0;
pub const CONFIG_DEV_DAX: u32 = 1;
pub const CONFIG_CEC_NOTIFIER: u32 = 1;
pub const CONFIG_BRIDGE_EBT_MARK_MODULE: u32 = 1;
pub const CONFIG_BATTERY_UG3105_MODULE: u32 = 1;
pub const CONFIG_B43_MODULE: u32 = 1;
pub const CONFIG_CLK_R9A07G043: u32 = 1;
pub const CONFIG_DM_CACHE_MODULE: u32 = 1;
pub const CONFIG_QCOM_FASTRPC_MODULE: u32 = 1;
pub const CONFIG_B43_SSB: u32 = 1;
pub const CONFIG_SCD30_I2C_MODULE: u32 = 1;
pub const CONFIG_CAVIUM_CPT_MODULE: u32 = 1;
pub const CONFIG_BMI270_SPI_MODULE: u32 = 1;
pub const CONFIG_DVB_HELENE_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_ELF_RANDOMIZE: u32 = 1;
pub const CONFIG_NFS_V4_1_IMPLEMENTATION_ID_DOMAIN: &[u8; 11] = b"kernel.org\0";
pub const CONFIG_SCSI: u32 = 1;
pub const CONFIG_DVB_ZL10036_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_IPRANGE_MODULE: u32 = 1;
pub const CONFIG_NF_CONNTRACK_TIMESTAMP: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA_MAX98090_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_MAX9867_MODULE: u32 = 1;
pub const CONFIG_INPUT_LEDS: u32 = 1;
pub const CONFIG_USB_RTL8153_ECM_MODULE: u32 = 1;
pub const CONFIG_INTERCONNECT_QCOM_X1E80100_MODULE: u32 = 1;
pub const CONFIG_IIO_CROS_EC_SENSORS_CORE_MODULE: u32 = 1;
pub const CONFIG_USB_CHIPIDEA_GENERIC_MODULE: u32 = 1;
pub const CONFIG_MAGIC_SYSRQ: u32 = 1;
pub const CONFIG_OF_OVERLAY_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_GENERIC_CALIBRATE_DELAY: u32 = 1;
pub const CONFIG_CRYPTO_KDF800108_CTR: u32 = 1;
pub const CONFIG_REGULATOR_RT5739_MODULE: u32 = 1;
pub const CONFIG_MAGIC_SYSRQ_SERIAL_SEQUENCE: &[u8; 1] = b"\0";
pub const CONFIG_BT_BNEP_MC_FILTER: u32 = 1;
pub const CONFIG_K3_DMA_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MAX34440_MODULE: u32 = 1;
pub const CONFIG_CRC7_MODULE: u32 = 1;
pub const CONFIG_MEDIA_ANALOG_TV_SUPPORT: u32 = 1;
pub const CONFIG_HAVE_KVM_IRQCHIP: u32 = 1;
pub const CONFIG_LD_ORPHAN_WARN_LEVEL: &[u8; 5] = b"warn\0";
pub const CONFIG_USB_OHCI_HCD_PLATFORM_MODULE: u32 = 1;
pub const CONFIG_PCI_MESON: u32 = 1;
pub const CONFIG_AIX_PARTITION: u32 = 1;
pub const CONFIG_RTW88_8703B_MODULE: u32 = 1;
pub const CONFIG_DVB_TDA10071_MODULE: u32 = 1;
pub const CONFIG_I2C_MUX_REG_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_FC2580_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_USB_JASTEC: u32 = 1;
pub const CONFIG_DRM_CDNS_DSI_J721E: u32 = 1;
pub const CONFIG_CAN_RCAR_CANFD_MODULE: u32 = 1;
pub const CONFIG_CC_HAS_ASM_GOTO_OUTPUT: u32 = 1;
pub const CONFIG_64BIT: u32 = 1;
pub const CONFIG_I2C_MUX_LTC4306_MODULE: u32 = 1;
pub const CONFIG_SPI_OMAP24XX_MODULE: u32 = 1;
pub const CONFIG_USB_CONFIGFS_ECM_SUBSET: u32 = 1;
pub const CONFIG_DVB_IX2505V_MODULE: u32 = 1;
pub const CONFIG_USB_OHCI_LITTLE_ENDIAN: u32 = 1;
pub const CONFIG_ISO9660_FS_MODULE: u32 = 1;
pub const CONFIG_UNIX_DIAG: u32 = 1;
pub const CONFIG_TCG_TIS_SPI_CR50: u32 = 1;
pub const CONFIG_QTNFMAC_MODULE: u32 = 1;
pub const CONFIG_NFS_SWAP: u32 = 1;
pub const CONFIG_SND_HDA_GENERIC_LEDS: u32 = 1;
pub const CONFIG_DVB_VES1820_MODULE: u32 = 1;
pub const CONFIG_SENSORS_LM85_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CHV3_I2S_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_LIB_CHACHA_GENERIC: u32 = 1;
pub const CONFIG_COMMON_CLK_MESON_VCLK: u32 = 1;
pub const CONFIG_APDS9306_MODULE: u32 = 1;
pub const CONFIG_DMA_OPS_HELPERS: u32 = 1;
pub const CONFIG_VIDEOBUF2_DVB_MODULE: u32 = 1;
pub const CONFIG_DVB_STV0299_MODULE: u32 = 1;
pub const CONFIG_IP_SCTP_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_FSL_DPAA2_CAAM_MODULE: u32 = 1;
pub const CONFIG_QCOM_SPMI_ADC5_MODULE: u32 = 1;
pub const CONFIG_IP_VS_PROTO_SCTP: u32 = 1;
pub const CONFIG_INPUT_TPS65219_PWRBUTTON_MODULE: u32 = 1;
pub const CONFIG_BATTERY_BQ27XXX_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_QCM2290_MODULE: u32 = 1;
pub const CONFIG_IP_VS_TWOS_MODULE: u32 = 1;
pub const CONFIG_FPGA_MGR_ZYNQMP_FPGA_MODULE: u32 = 1;
pub const CONFIG_SENSORS_LTC2991_MODULE: u32 = 1;
pub const CONFIG_USB_GADGET_STORAGE_NUM_BUFFERS: u32 = 2;
pub const CONFIG_RADIO_MAXIRADIO_MODULE: u32 = 1;
pub const CONFIG_PM_DEBUG: u32 = 1;
pub const CONFIG_VIDEOBUF2_DMA_SG_MODULE: u32 = 1;
pub const CONFIG_NET_DSA_SMSC_LAN9303_MDIO_MODULE: u32 = 1;
pub const CONFIG_MMC_SDHCI_XENON_MODULE: u32 = 1;
pub const CONFIG_TEGRA_SOCTHERM_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_NULL2: u32 = 1;
pub const CONFIG_NET_VENDOR_TI: u32 = 1;
pub const CONFIG_BACKLIGHT_LED_MODULE: u32 = 1;
pub const CONFIG_BLK_CGROUP: u32 = 1;
pub const CONFIG_BNX2X_SRIOV: u32 = 1;
pub const CONFIG_PINCTRL_SUN8I_H3: u32 = 1;
pub const CONFIG_HAVE_ARCH_KFENCE: u32 = 1;
pub const CONFIG_HYPERV_NET_MODULE: u32 = 1;
pub const CONFIG_AL3010_MODULE: u32 = 1;
pub const CONFIG_HID_CORSAIR_MODULE: u32 = 1;
pub const CONFIG_IPV6_VTI_MODULE: u32 = 1;
pub const CONFIG_RTL8XXXU_UNTESTED: u32 = 1;
pub const CONFIG_COMMON_CLK_MESON_DUALDIV: u32 = 1;
pub const CONFIG_CLK_RK3568: u32 = 1;
pub const CONFIG_DRM_IMX8QM_LDB_MODULE: u32 = 1;
pub const CONFIG_U_SERIAL_CONSOLE: u32 = 1;
pub const CONFIG_PINCTRL_RENESAS: u32 = 1;
pub const CONFIG_HID_NTI_MODULE: u32 = 1;
pub const CONFIG_DECOMPRESS_ZSTD: u32 = 1;
pub const CONFIG_DRM_PANEL_MAGNACHIP_D53E6EA8966_MODULE: u32 = 1;
pub const CONFIG_ARM_MHU_V3_MODULE: u32 = 1;
pub const CONFIG_NF_LOG_ARP_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_AW8738_MODULE: u32 = 1;
pub const CONFIG_MTD_MAP_BANK_WIDTH_4: u32 = 1;
pub const CONFIG_NF_NAT_AMANDA_MODULE: u32 = 1;
pub const CONFIG_SND_UTIMER: u32 = 1;
pub const CONFIG_OLD_SIGSUSPEND3: u32 = 1;
pub const CONFIG_CROS_EC_WATCHDOG_MODULE: u32 = 1;
pub const CONFIG_MAX11410_MODULE: u32 = 1;
pub const CONFIG_NET_TEAM_MODULE: u32 = 1;
pub const CONFIG_LEDS_MAX77705_MODULE: u32 = 1;
pub const CONFIG_MDIO_BUS_MUX_MODULE: u32 = 1;
pub const CONFIG_SSB_PCIHOST_POSSIBLE: u32 = 1;
pub const CONFIG_SND_HDA_CODEC_ANALOG_MODULE: u32 = 1;
pub const CONFIG_XPS: u32 = 1;
pub const CONFIG_SND_SOC_QDSP6_COMMON_MODULE: u32 = 1;
pub const CONFIG_GPIO_THUNDERX_MODULE: u32 = 1;
pub const CONFIG_AMLOGIC_THERMAL_MODULE: u32 = 1;
pub const CONFIG_6LOWPAN_GHC_EXT_HDR_FRAG_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_STATISTIC_MODULE: u32 = 1;
pub const CONFIG_ZRAM_BACKEND_LZ4: u32 = 1;
pub const CONFIG_DRM_PL111_MODULE: u32 = 1;
pub const CONFIG_VIRTIO_VDPA_MODULE: u32 = 1;
pub const CONFIG_QCOM_IOMMU: u32 = 1;
pub const CONFIG_COMPAT_32BIT_TIME: u32 = 1;
pub const CONFIG_NVMEM_ROCKCHIP_OTP_MODULE: u32 = 1;
pub const CONFIG_POWER_RESET_RESTART: u32 = 1;
pub const CONFIG_MPTCP_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_SENSORS_SCH5627_MODULE: u32 = 1;
pub const CONFIG_HOTPLUG_CPU: u32 = 1;
pub const CONFIG_NFS_FSCACHE: u32 = 1;
pub const CONFIG_MSM_GCC_8998: u32 = 1;
pub const CONFIG_PAGE_POOL_STATS: u32 = 1;
pub const CONFIG_WANT_DEV_COREDUMP: u32 = 1;
pub const CONFIG_NET_IPGRE_DEMUX_MODULE: u32 = 1;
pub const CONFIG_USB_LIBCOMPOSITE_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MPQ7932_MODULE: u32 = 1;
pub const CONFIG_JOYSTICK_GF2K_MODULE: u32 = 1;
pub const CONFIG_DVB_PT1_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_JDI_R63452_MODULE: u32 = 1;
pub const CONFIG_MISC_ALCOR_PCI_MODULE: u32 = 1;
pub const CONFIG_RANDOMIZE_BASE: u32 = 1;
pub const CONFIG_INTEGRITY_TRUSTED_KEYRING: u32 = 1;
pub const CONFIG_NET_VENDOR_PENSANDO: u32 = 1;
pub const CONFIG_VIDEO_HI847_MODULE: u32 = 1;
pub const CONFIG_SERIAL_8250_DFL_MODULE: u32 = 1;
pub const CONFIG_F2FS_FS_ZSTD: u32 = 1;
pub const CONFIG_RTC_DRV_CADENCE_MODULE: u32 = 1;
pub const CONFIG_SENSORS_SCH5636_MODULE: u32 = 1;
pub const CONFIG_BLK_DEV_NVME_MODULE: u32 = 1;
pub const CONFIG_VIDEO_QCOM_IRIS_MODULE: u32 = 1;
pub const CONFIG_ARM_GIC_PM: u32 = 1;
pub const CONFIG_INTERCONNECT_IMX_MODULE: u32 = 1;
pub const CONFIG_GPIO_DAVINCI_MODULE: u32 = 1;
pub const CONFIG_SENSORS_LM73_MODULE: u32 = 1;
pub const CONFIG_CLK_IMX8MQ: u32 = 1;
pub const CONFIG_DVB_USB_VP7045_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_SET_MEMORY: u32 = 1;
pub const CONFIG_DVB_USB_DTT200U_MODULE: u32 = 1;
pub const CONFIG_HID_CHERRY_MODULE: u32 = 1;
pub const CONFIG_MAC80211_MESH: u32 = 1;
pub const CONFIG_BLK_WBT: u32 = 1;
pub const CONFIG_SPI_QCOM_GENI_MODULE: u32 = 1;
pub const CONFIG_TASKS_RUDE_RCU: u32 = 1;
pub const CONFIG_MTD_UBI_WL_THRESHOLD: u32 = 4096;
pub const CONFIG_REGMAP_SOUNDWIRE_MBQ_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_WWAN_MODULE: u32 = 1;
pub const CONFIG_IP_SET_HASH_NETPORT_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_HIMAX_HX83102_MODULE: u32 = 1;
pub const CONFIG_PAHOLE_HAS_SPLIT_BTF: u32 = 1;
pub const CONFIG_NET_ACT_SAMPLE_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_MESON8_PMX: u32 = 1;
pub const CONFIG_USB_ARMLINUX: u32 = 1;
pub const CONFIG_ZEROPLUS_FF: u32 = 1;
pub const CONFIG_KUNIT_AUTORUN_ENABLED: u32 = 1;
pub const CONFIG_HID_KEYTOUCH_MODULE: u32 = 1;
pub const CONFIG_SPI_FSL_DSPI_MODULE: u32 = 1;
pub const CONFIG_RTW89_8852CE_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_PCM512x_SPI_MODULE: u32 = 1;
pub const CONFIG_IMA: u32 = 1;
pub const CONFIG_REGULATOR_PWM: u32 = 1;
pub const CONFIG_SND_SOC_AC97_CODEC_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_MP886X_MODULE: u32 = 1;
pub const CONFIG_SMSC_PHY_MODULE: u32 = 1;
pub const CONFIG_BLK_INLINE_ENCRYPTION: u32 = 1;
pub const CONFIG_CC_HAS_SIGN_RETURN_ADDRESS: u32 = 1;
pub const CONFIG_SND_SOC_DMIC_MODULE: u32 = 1;
pub const CONFIG_USB_XHCI_RCAR_MODULE: u32 = 1;
pub const CONFIG_AD7293_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_ADDRTYPE_MODULE: u32 = 1;
pub const CONFIG_SENSORS_LTC4260_MODULE: u32 = 1;
pub const CONFIG_QCOM_Q6V5_PAS_MODULE: u32 = 1;
pub const CONFIG_CC_CAN_LINK: u32 = 1;
pub const CONFIG_SATA_AHCI_SEATTLE_MODULE: u32 = 1;
pub const CONFIG_BT_MTKSDIO_MODULE: u32 = 1;
pub const CONFIG_IPQ_NSSCC_QCA8K_MODULE: u32 = 1;
pub const CONFIG_B53_MODULE: u32 = 1;
pub const CONFIG_JOYSTICK_IFORCE_USB_MODULE: u32 = 1;
pub const CONFIG_MT7925_COMMON_MODULE: u32 = 1;
pub const CONFIG_DEFAULT_SECURITY_SELINUX: u32 = 1;
pub const CONFIG_PCI_HISI: u32 = 1;
pub const CONFIG_CHARGER_MAX77976_MODULE: u32 = 1;
pub const CONFIG_NF_LOG_IPV6_MODULE: u32 = 1;
pub const CONFIG_CC_HAS_AUTO_VAR_INIT_ZERO_BARE: u32 = 1;
pub const CONFIG_MMC_VUB300_MODULE: u32 = 1;
pub const CONFIG_IPMI_PLAT_DATA: u32 = 1;
pub const CONFIG_RTC_DRV_S35390A_MODULE: u32 = 1;
pub const CONFIG_KERNFS: u32 = 1;
pub const CONFIG_DRM_MGAG200_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_1902691: u32 = 1;
pub const CONFIG_SND_SOC_TLV320AIC32X4_MODULE: u32 = 1;
pub const CONFIG_DM_MULTIPATH_HST_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_S32CC: u32 = 1;
pub const CONFIG_6LOWPAN_NHC_UDP_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_S4_PERIPHERALS: u32 = 1;
pub const CONFIG_SERIO_SERPORT_MODULE: u32 = 1;
pub const CONFIG_ACPI_APEI_MEMORY_FAILURE: u32 = 1;
pub const CONFIG_V4L2_H264_MODULE: u32 = 1;
pub const CONFIG_INPUT_SOC_BUTTON_ARRAY_MODULE: u32 = 1;
pub const CONFIG_RD_XZ: u32 = 1;
pub const CONFIG_HAVE_PAGE_SIZE_4KB: u32 = 1;
pub const CONFIG_DRM_AMDGPU_CIK: u32 = 1;
pub const CONFIG_VIDEO_V4L2_I2C: u32 = 1;
pub const CONFIG_IIO_ADIS_LIB_MODULE: u32 = 1;
pub const CONFIG_MDIO_BUS_MUX_MESON_G12A_MODULE: u32 = 1;
pub const CONFIG_MSDOS_FS_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_AES_ARM64: u32 = 1;
pub const CONFIG_USB_ULPI_BUS_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_IMX_RPMSG_MODULE: u32 = 1;
pub const CONFIG_DM_EBS_MODULE: u32 = 1;
pub const CONFIG_SECURITY_TOMOYO_POLICY_LOADER: &[u8; 18] = b"/sbin/tomoyo-init\0";
pub const CONFIG_ARCH_PKEY_BITS: u32 = 3;
pub const CONFIG_SND_SOC_QDSP6_ROUTING_MODULE: u32 = 1;
pub const CONFIG_SM_CAMCC_8650_MODULE: u32 = 1;
pub const CONFIG_PCIEAER: u32 = 1;
pub const CONFIG_IP_VS_SH_TAB_BITS: u32 = 8;
pub const CONFIG_BE2NET_SKYHAWK: u32 = 1;
pub const CONFIG_SND_MTPAV_MODULE: u32 = 1;
pub const CONFIG_DVB_S5H1411_MODULE: u32 = 1;
pub const CONFIG_ATH6KL_SDIO_MODULE: u32 = 1;
pub const CONFIG_HAVE_SCHED_AVG_IRQ: u32 = 1;
pub const CONFIG_CRC_ITU_T_MODULE: u32 = 1;
pub const CONFIG_PFCP_MODULE: u32 = 1;
pub const CONFIG_SCSI_SRP_ATTRS_MODULE: u32 = 1;
pub const CONFIG_SND_ECHO3G_MODULE: u32 = 1;
pub const CONFIG_KEYBOARD_QT1050_MODULE: u32 = 1;
pub const CONFIG_DT_IDLE_GENPD: u32 = 1;
pub const CONFIG_PINCTRL_SC8180X_MODULE: u32 = 1;
pub const CONFIG_SSB_SDIOHOST_POSSIBLE: u32 = 1;
pub const CONFIG_DEVFREQ_GOV_PERFORMANCE_MODULE: u32 = 1;
pub const CONFIG_SENSORS_UCD9200_MODULE: u32 = 1;
pub const CONFIG_PCIE_HISI_STB: u32 = 1;
pub const CONFIG_AHCI_QORIQ_MODULE: u32 = 1;
pub const CONFIG_SENSORS_RM3100_MODULE: u32 = 1;
pub const CONFIG_INFINIBAND_RTRS_MODULE: u32 = 1;
pub const CONFIG_IP_FIB_TRIE_STATS: u32 = 1;
pub const CONFIG_RPMSG_NS_MODULE: u32 = 1;
pub const CONFIG_PROC_PAGE_MONITOR: u32 = 1;
pub const CONFIG_FUN_ETH_MODULE: u32 = 1;
pub const CONFIG_HAVE_ARCH_SECCOMP_FILTER: u32 = 1;
pub const CONFIG_NET_DSA_TAG_OCELOT_MODULE: u32 = 1;
pub const CONFIG_DEBUG_BUGVERBOSE: u32 = 1;
pub const CONFIG_PLAYSTATION_FF: u32 = 1;
pub const CONFIG_SND_SOC_MAX98373_SDW_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MP2888_MODULE: u32 = 1;
pub const CONFIG_ATH9K_COMMON_DEBUG: u32 = 1;
pub const CONFIG_EXT4_USE_FOR_EXT2: u32 = 1;
pub const CONFIG_USB_PEGASUS_MODULE: u32 = 1;
pub const CONFIG_PTP_1588_CLOCK_IDTCM_MODULE: u32 = 1;
pub const CONFIG_UIO_PCI_GENERIC_MODULE: u32 = 1;
pub const CONFIG_OF_IOMMU: u32 = 1;
pub const CONFIG_SLAB_FREELIST_RANDOM: u32 = 1;
pub const CONFIG_MFD_MAX77650_MODULE: u32 = 1;
pub const CONFIG_FXAS21002C_SPI_MODULE: u32 = 1;
pub const CONFIG_ARCH_SUSPEND_POSSIBLE: u32 = 1;
pub const CONFIG_USB_IDMOUSE_MODULE: u32 = 1;
pub const CONFIG_KPROBES: u32 = 1;
pub const CONFIG_TEST_IOV_ITER_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_IQS7211_MODULE: u32 = 1;
pub const CONFIG_RT_MUTEXES: u32 = 1;
pub const CONFIG_UPROBE_EVENTS: u32 = 1;
pub const CONFIG_TEGRA_GMI_MODULE: u32 = 1;
pub const CONFIG_PCI_DOE: u32 = 1;
pub const CONFIG_BLK_CGROUP_IOLATENCY: u32 = 1;
pub const CONFIG_CEC_PIN: u32 = 1;
pub const CONFIG_ARM64_PAN: u32 = 1;
pub const CONFIG_ANDROID_BINDER_IPC: u32 = 1;
pub const CONFIG_PARTITION_PERCPU: u32 = 1;
pub const CONFIG_CHELSIO_T4VF_MODULE: u32 = 1;
pub const CONFIG_NET_IFE_MODULE: u32 = 1;
pub const CONFIG_CHARGER_AXP20X_MODULE: u32 = 1;
pub const CONFIG_RD_LZ4: u32 = 1;
pub const CONFIG_SND_HDA_SCODEC_CS35L56_SPI_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_EDGEPORT_MODULE: u32 = 1;
pub const CONFIG_SECURITY_TOMOYO: u32 = 1;
pub const CONFIG_VIDEO_ADV7175_MODULE: u32 = 1;
pub const CONFIG_IPMI_SSIF_MODULE: u32 = 1;
pub const CONFIG_IEEE802154_AT86RF230_MODULE: u32 = 1;
pub const CONFIG_NET_DSA_XRS700X_MDIO_MODULE: u32 = 1;
pub const CONFIG_SENSORS_LIS3_I2C_MODULE: u32 = 1;
pub const CONFIG_DVB_MXL692_MODULE: u32 = 1;
pub const CONFIG_VIDEO_CX231XX_ALSA_MODULE: u32 = 1;
pub const CONFIG_MFD_SY7636A_MODULE: u32 = 1;
pub const CONFIG_BCACHEFS_SIX_OPTIMISTIC_SPIN: u32 = 1;
pub const CONFIG_DEFAULT_HOSTNAME: &[u8; 7] = b"(none)\0";
pub const CONFIG_VFIO_PCI_INTX: u32 = 1;
pub const CONFIG_MLX5_MACSEC: u32 = 1;
pub const CONFIG_GENERIC_NET_UTILS: u32 = 1;
pub const CONFIG_SND_AUDIO_GRAPH_CARD_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_TPS65132_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_QCE_SKCIPHER: u32 = 1;
pub const CONFIG_SND_SOC_ROCKCHIP_I2S_TDM_MODULE: u32 = 1;
pub const CONFIG_USB_CONN_GPIO_MODULE: u32 = 1;
pub const CONFIG_LMP91000_MODULE: u32 = 1;
pub const CONFIG_DM_ERA_MODULE: u32 = 1;
pub const CONFIG_RTW88_8812AU_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_RX8010_MODULE: u32 = 1;
pub const CONFIG_IP_VS_WRR_MODULE: u32 = 1;
pub const CONFIG_SYSFB: u32 = 1;
pub const CONFIG_LEDS_TRIGGER_ONESHOT_MODULE: u32 = 1;
pub const CONFIG_NVDIMM_PFN: u32 = 1;
pub const CONFIG_SECURITY_SELINUX: u32 = 1;
pub const CONFIG_FRAME_POINTER: u32 = 1;
pub const CONFIG_BLK_DEV_DRBD_MODULE: u32 = 1;
pub const CONFIG_I2C_IMX_MODULE: u32 = 1;
pub const CONFIG_INPUT_JOYSTICK: u32 = 1;
pub const CONFIG_BLK_DEV_DM_BUILTIN: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_2139208: u32 = 1;
pub const CONFIG_DRM_DISPLAY_DSC_HELPER: u32 = 1;
pub const CONFIG_SMARTJOYPLUS_FF: u32 = 1;
pub const CONFIG_IP5XXX_POWER_MODULE: u32 = 1;
pub const CONFIG_VMWARE_VMCI_MODULE: u32 = 1;
pub const CONFIG_SCSI_LOWLEVEL: u32 = 1;
pub const CONFIG_DRM_PANEL_NOVATEK_NT35510_MODULE: u32 = 1;
pub const CONFIG_SENSORS_LM63_MODULE: u32 = 1;
pub const CONFIG_SOC_TEGRA_CBB_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_WCD937X_SDW_MODULE: u32 = 1;
pub const CONFIG_INTERVAL_TREE: u32 = 1;
pub const CONFIG_ADIN1110_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_PCF8563_MODULE: u32 = 1;
pub const CONFIG_DRM_MSM_DSI_14NM_PHY: u32 = 1;
pub const CONFIG_QCOM_FALKOR_ERRATUM_1009: u32 = 1;
pub const CONFIG_MESON_GXBB_WATCHDOG_MODULE: u32 = 1;
pub const CONFIG_W1_SLAVE_DS2805_MODULE: u32 = 1;
pub const CONFIG_SPARSEMEM: u32 = 1;
pub const CONFIG_CXL_PMU_MODULE: u32 = 1;
pub const CONFIG_BCACHE_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_ATMEL_SHA204A_MODULE: u32 = 1;
pub const CONFIG_INPUT_IQS7222_MODULE: u32 = 1;
pub const CONFIG_HVC_DRIVER: u32 = 1;
pub const CONFIG_BLK_CGROUP_IOCOST: u32 = 1;
pub const CONFIG_NLS_MAC_GAELIC_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_MAX8973_MODULE: u32 = 1;
pub const CONFIG_SND_HDA_TEGRA_MODULE: u32 = 1;
pub const CONFIG_NFP_NET_IPSEC: u32 = 1;
pub const CONFIG_NET_VENDOR_BROADCOM: u32 = 1;
pub const CONFIG_SPEAKUP_SYNTH_SPKOUT_MODULE: u32 = 1;
pub const CONFIG_RTC_SYSTOHC_DEVICE: &[u8; 5] = b"rtc0\0";
pub const CONFIG_DEV_DAX_HMEM_DEVICES: u32 = 1;
pub const CONFIG_RTC_DRV_RX4581_MODULE: u32 = 1;
pub const CONFIG_INPUT_GPIO_VIBRA_MODULE: u32 = 1;
pub const CONFIG_ARM64_WORKAROUND_SPECULATIVE_AT: u32 = 1;
pub const CONFIG_OSNOISE_TRACER: u32 = 1;
pub const CONFIG_PWM_BCM2835_MODULE: u32 = 1;
pub const CONFIG_RTC_INTF_PROC: u32 = 1;
pub const CONFIG_USB_CHIPIDEA_NPCM_MODULE: u32 = 1;
pub const CONFIG_RC_LOOPBACK_MODULE: u32 = 1;
pub const CONFIG_CLK_IMX8MP: u32 = 1;
pub const CONFIG_AUTOFS_FS: u32 = 1;
pub const CONFIG_DVB_CX24123_MODULE: u32 = 1;
pub const CONFIG_MDIO_IPQ8064_MODULE: u32 = 1;
pub const CONFIG_ARM_SUN8I_A33_MBUS_DEVFREQ_MODULE: u32 = 1;
pub const CONFIG_LD_CAN_USE_KEEP_IN_OVERLAY: u32 = 1;
pub const CONFIG_SND_SOC_SOF_IMX_COMMON_MODULE: u32 = 1;
pub const CONFIG_I2C_SIMTEC_MODULE: u32 = 1;
pub const CONFIG_IPV6_MROUTE_MULTIPLE_TABLES: u32 = 1;
pub const CONFIG_FUNCTION_PROFILER: u32 = 1;
pub const CONFIG_ARCH_HAS_PTE_DEVMAP: u32 = 1;
pub const CONFIG_BT_BREDR: u32 = 1;
pub const CONFIG_SND_SOC_AUDIO_IIO_AUX_MODULE: u32 = 1;
pub const CONFIG_PWM_APPLE_MODULE: u32 = 1;
pub const CONFIG_TYPEC_DP_ALTMODE_MODULE: u32 = 1;
pub const CONFIG_MODULE_COMPRESS_XZ: u32 = 1;
pub const CONFIG_RPMSG_QCOM_SMD_MODULE: u32 = 1;
pub const CONFIG_XFRM_ESPINTCP: u32 = 1;
pub const CONFIG_GPIO_MOXTET_MODULE: u32 = 1;
pub const CONFIG_LEDS_LP3952_MODULE: u32 = 1;
pub const CONFIG_ARCH_WANTS_NO_INSTR: u32 = 1;
pub const CONFIG_NET_DSA_QCA8K_MODULE: u32 = 1;
pub const CONFIG_USB_HID: u32 = 1;
pub const CONFIG_SMSC911X_MODULE: u32 = 1;
pub const CONFIG_PHY_CADENCE_TORRENT_MODULE: u32 = 1;
pub const CONFIG_SND_ES1968_RADIO: u32 = 1;
pub const CONFIG_USB_HSO_MODULE: u32 = 1;
pub const CONFIG_NFT_BRIDGE_REJECT_MODULE: u32 = 1;
pub const CONFIG_SND_HDA_RECONFIG: u32 = 1;
pub const CONFIG_PHY_ROCKCHIP_USB_MODULE: u32 = 1;
pub const CONFIG_AD9467_MODULE: u32 = 1;
pub const CONFIG_PARMAN_MODULE: u32 = 1;
pub const CONFIG_IIO_BUFFER_CB_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_SKCIPHER2: u32 = 1;
pub const CONFIG_MTD_MODULE: u32 = 1;
pub const CONFIG_SENSORS_LTC4261_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CS42L83_MODULE: u32 = 1;
pub const CONFIG_SC_GPUCC_7180_MODULE: u32 = 1;
pub const CONFIG_PCI_MSI: u32 = 1;
pub const CONFIG_UBIFS_ATIME_SUPPORT: u32 = 1;
pub const CONFIG_SND_SOC_MAX98373_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_IMX93: u32 = 1;
pub const CONFIG_CLK_RK3308: u32 = 1;
pub const CONFIG_RMI4_CORE_MODULE: u32 = 1;
pub const CONFIG_HAVE_GENERIC_VDSO: u32 = 1;
pub const CONFIG_ARM_SCPI_CPUFREQ_MODULE: u32 = 1;
pub const CONFIG_INTERCONNECT_QCOM_QCM2290_MODULE: u32 = 1;
pub const CONFIG_SND_HDA_MODULE: u32 = 1;
pub const CONFIG_QCOM_SPMI_TEMP_ALARM_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_USB_PANJIT: u32 = 1;
pub const CONFIG_VIDEO_DW9719_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_RT5682_I2C_MODULE: u32 = 1;
pub const CONFIG_NF_TABLES_ARP: u32 = 1;
pub const CONFIG_TMPFS_POSIX_ACL: u32 = 1;
pub const CONFIG_VIDEO_OV08D10_MODULE: u32 = 1;
pub const CONFIG_PCIE_DW_PLAT_HOST: u32 = 1;
pub const CONFIG_MODULES_TREE_LOOKUP: u32 = 1;
pub const CONFIG_TI_SCI_CLK_MODULE: u32 = 1;
pub const CONFIG_CGROUP_DMEM: u32 = 1;
pub const CONFIG_FW_LOADER_PAGED_BUF: u32 = 1;
pub const CONFIG_IRQ_MSI_LIB: u32 = 1;
pub const CONFIG_HNS3_MODULE: u32 = 1;
pub const CONFIG_NILFS2_FS_MODULE: u32 = 1;
pub const CONFIG_IP_VS_PE_SIP_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_KOBIL_SCT_MODULE: u32 = 1;
pub const CONFIG_BATMAN_ADV_MODULE: u32 = 1;
pub const CONFIG_NXP_C45_TJA11XX_PHY_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_RTQ9128_MODULE: u32 = 1;
pub const CONFIG_NVMEM_RMEM_MODULE: u32 = 1;
pub const CONFIG_USB_NET_CDC_EEM_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_MSM8996_MODULE: u32 = 1;
pub const CONFIG_BMI160_I2C_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_E4000_MODULE: u32 = 1;
pub const CONFIG_CPUMASK_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_DS1286_MODULE: u32 = 1;
pub const CONFIG_INTEGRITY_SIGNATURE: u32 = 1;
pub const CONFIG_POWER_RESET_HISI: u32 = 1;
pub const CONFIG_RTL8723AE_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_MP8859_MODULE: u32 = 1;
pub const CONFIG_DRM_CLIENT_DEFAULT_FBDEV: u32 = 1;
pub const CONFIG_VIDEO_ROCKCHIP_VDEC_MODULE: u32 = 1;
pub const CONFIG_SND_AU8820_MODULE: u32 = 1;
pub const CONFIG_RAPIDIO_TSI721_MODULE: u32 = 1;
pub const CONFIG_CLK_R9A07G054: u32 = 1;
pub const CONFIG_SENSORS_TDA38640_REGULATOR: u32 = 1;
pub const CONFIG_CPU_FREQ_GOV_USERSPACE: u32 = 1;
pub const CONFIG_PHY_QCOM_QMP_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_USB_ETT_TC45USB: u32 = 1;
pub const CONFIG_SND_SOC_ADAU1372_SPI_MODULE: u32 = 1;
pub const CONFIG_SUNXI_RSB_MODULE: u32 = 1;
pub const CONFIG_PCIE_CADENCE_HOST: u32 = 1;
pub const CONFIG_CRYPTO_DEV_FSL_CAAM_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_WSA883X_MODULE: u32 = 1;
pub const CONFIG_SCSI_SYM53C8XX_DEFAULT_TAGS: u32 = 16;
pub const CONFIG_PHY_ROCKCHIP_SNPS_PCIE3_MODULE: u32 = 1;
pub const CONFIG_BLK_DEV_NULL_BLK_MODULE: u32 = 1;
pub const CONFIG_IP_VS_PROTO_AH_ESP: u32 = 1;
pub const CONFIG_HAVE_ARCH_BITREVERSE: u32 = 1;
pub const CONFIG_JOLIET: u32 = 1;
pub const CONFIG_DEVFREQ_THERMAL: u32 = 1;
pub const CONFIG_V4L_MEM2MEM_DRIVERS: u32 = 1;
pub const CONFIG_JOYSTICK_IFORCE_232_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_G12A: u32 = 1;
pub const CONFIG_INFINIBAND_OCRDMA_MODULE: u32 = 1;
pub const CONFIG_MVEBU_SEI: u32 = 1;
pub const CONFIG_EROFS_FS_ZIP: u32 = 1;
pub const CONFIG_DVB_S5H1409_MODULE: u32 = 1;
pub const CONFIG_SENSORS_LM83_MODULE: u32 = 1;
pub const CONFIG_SQUASHFS_DECOMP_MULTI_PERCPU: u32 = 1;
pub const CONFIG_BCM2835_THERMAL_MODULE: u32 = 1;
pub const CONFIG_B43LEGACY_PIO: u32 = 1;
pub const CONFIG_HAVE_DYNAMIC_FTRACE_WITH_DIRECT_CALLS: u32 = 1;
pub const CONFIG_CLK_IMX8QXP: u32 = 1;
pub const CONFIG_IMX_SC_WDT_MODULE: u32 = 1;
pub const CONFIG_SERIAL_8250_DW: u32 = 1;
pub const CONFIG_MTD_DATAFLASH_MODULE: u32 = 1;
pub const CONFIG_ACENIC_MODULE: u32 = 1;
pub const CONFIG_SPI_DW_MMIO_MODULE: u32 = 1;
pub const CONFIG_TEGRA_CLK_DFLL: u32 = 1;
pub const CONFIG_MD_RAID456_MODULE: u32 = 1;
pub const CONFIG_I6300ESB_WDT_MODULE: u32 = 1;
pub const CONFIG_IMA_KEXEC: u32 = 1;
pub const CONFIG_SM_GCC_8350_MODULE: u32 = 1;
pub const CONFIG_FSL_ENETC_CORE_MODULE: u32 = 1;
pub const CONFIG_TEGRA_AHB: u32 = 1;
pub const CONFIG_W1_SLAVE_DS2433_CRC: u32 = 1;
pub const CONFIG_HW_RANDOM_TPM: u32 = 1;
pub const CONFIG_ILLEGAL_POINTER_VALUE: i64 = -2401263026318606336;
pub const CONFIG_IWLEGACY_DEBUG: u32 = 1;
pub const CONFIG_ARCH_HAS_SETUP_DMA_OPS: u32 = 1;
pub const CONFIG_INPUT_MATRIXKMAP_MODULE: u32 = 1;
pub const CONFIG_IP_NF_MATCH_AH_MODULE: u32 = 1;
pub const CONFIG_GROUP_SCHED_WEIGHT: u32 = 1;
pub const CONFIG_MEDIA_TUNER_SIMPLE_MODULE: u32 = 1;
pub const CONFIG_UPROBES: u32 = 1;
pub const CONFIG_PHY_QCOM_QMP_COMBO_MODULE: u32 = 1;
pub const CONFIG_VP_VDPA_MODULE: u32 = 1;
pub const CONFIG_ARM_SCMI_CPUFREQ_MODULE: u32 = 1;
pub const CONFIG_DW_XDATA_PCIE_MODULE: u32 = 1;
pub const CONFIG_GPIO_XGENE_SB_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_IMX8ULP: u32 = 1;
pub const CONFIG_NFT_NAT_MODULE: u32 = 1;
pub const CONFIG_ZSWAP_COMPRESSOR_DEFAULT: &[u8; 4] = b"lzo\0";
pub const CONFIG_DRM_PANEL_RAYDIUM_RM67200_MODULE: u32 = 1;
pub const CONFIG_VIDEO_CS53L32A_MODULE: u32 = 1;
pub const CONFIG_MAX31827_MODULE: u32 = 1;
pub const CONFIG_SENSORS_VEXPRESS_MODULE: u32 = 1;
pub const CONFIG_NF_CONNTRACK_ZONES: u32 = 1;
pub const CONFIG_ROCKCHIP_ERRATUM_3588001: u32 = 1;
pub const CONFIG_INTERCONNECT_QCOM_SC7280: u32 = 1;
pub const CONFIG_DRM_CLIENT: u32 = 1;
pub const CONFIG_SCSI_AM53C974_MODULE: u32 = 1;
pub const CONFIG_MFD_SMPRO_MODULE: u32 = 1;
pub const CONFIG_USB_UHCI_HCD_MODULE: u32 = 1;
pub const CONFIG_SENSORS_VIA686A_MODULE: u32 = 1;
pub const CONFIG_MT76x0E_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_MULTIPORT_MODULE: u32 = 1;
pub const CONFIG_TI_K3_RINGACC_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_NHPOLY1305_MODULE: u32 = 1;
pub const CONFIG_IIO_KX022A_I2C_MODULE: u32 = 1;
pub const CONFIG_GENERIC_PHY: u32 = 1;
pub const CONFIG_FCOE_MODULE: u32 = 1;
pub const CONFIG_XILINX_SDFEC_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_LIMIT_MODULE: u32 = 1;
pub const CONFIG_IPV6_MROUTE: u32 = 1;
pub const CONFIG_UAPI_HEADER_TEST: u32 = 1;
pub const CONFIG_USB_RAINSHADOW_CEC_MODULE: u32 = 1;
pub const CONFIG_INET6_TUNNEL_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_MAX77620: u32 = 1;
pub const CONFIG_GUEST_PERF_EVENTS: u32 = 1;
pub const CONFIG_MCP4728_MODULE: u32 = 1;
pub const CONFIG_TEGRA210_ADMA_MODULE: u32 = 1;
pub const CONFIG_DVB_BT8XX_MODULE: u32 = 1;
pub const CONFIG_VIDEO_ET8EK8_MODULE: u32 = 1;
pub const CONFIG_MT7925U_MODULE: u32 = 1;
pub const CONFIG_IWL3945_MODULE: u32 = 1;
pub const CONFIG_USB_EHCI_FSL_MODULE: u32 = 1;
pub const CONFIG_DUMMY_CONSOLE: u32 = 1;
pub const CONFIG_FB_TILEBLITTING: u32 = 1;
pub const CONFIG_RTL_CARDS_MODULE: u32 = 1;
pub const CONFIG_PANTHERLORD_FF: u32 = 1;
pub const CONFIG_DVB_TUNER_DIB0090_MODULE: u32 = 1;
pub const CONFIG_USB_F_TCM_MODULE: u32 = 1;
pub const CONFIG_HAVE_ARCH_TRACEHOOK: u32 = 1;
pub const CONFIG_IXGBE_HWMON: u32 = 1;
pub const CONFIG_ACPI_FPDT: u32 = 1;
pub const CONFIG_CRYPTO_DEV_AMLOGIC_GXL: u32 = 1;
pub const CONFIG_ARM_AMBA: u32 = 1;
pub const CONFIG_NET_DSA_SMSC_LAN9303_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_XR_MODULE: u32 = 1;
pub const CONFIG_USB_XHCI_MVEBU_MODULE: u32 = 1;
pub const CONFIG_TI_SCI_PM_DOMAINS_MODULE: u32 = 1;
pub const CONFIG_MVEBU_GICP: u32 = 1;
pub const CONFIG_IP_SET_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_SAMSUNG_LD9040_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_CS530X_MODULE: u32 = 1;
pub const CONFIG_IP_SET_BITMAP_PORT_MODULE: u32 = 1;
pub const CONFIG_ACPI_APEI: u32 = 1;
pub const CONFIG_TCP_CONG_NV_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_IMX_PCM_RPMSG_MODULE: u32 = 1;
pub const CONFIG_VIDEO_CCS_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_TCPMSS_MODULE: u32 = 1;
pub const CONFIG_SLHC_MODULE: u32 = 1;
pub const CONFIG_VIDEO_WM8775_MODULE: u32 = 1;
pub const CONFIG_SLUB_DEBUG: u32 = 1;
pub const CONFIG_PPS_CLIENT_LDISC_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_SQ905_MODULE: u32 = 1;
pub const CONFIG_EDAC_SCRUB: u32 = 1;
pub const CONFIG_PHY_CADENCE_DPHY_MODULE: u32 = 1;
pub const CONFIG_SND_BCM2835_SOC_I2S_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_3117295: u32 = 1;
pub const CONFIG_TOUCHSCREEN_USB_GENERAL_TOUCH: u32 = 1;
pub const CONFIG_CLK_RK3399: u32 = 1;
pub const CONFIG_CPU_FREQ_THERMAL: u32 = 1;
pub const CONFIG_QCOM_RPMH: u32 = 1;
pub const CONFIG_REGULATOR_HI6421_MODULE: u32 = 1;
pub const CONFIG_QCOM_PDR_MSG_MODULE: u32 = 1;
pub const CONFIG_DVB_CX24120_MODULE: u32 = 1;
pub const CONFIG_ATH10K_SDIO_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_DIBUSB_MB_MODULE: u32 = 1;
pub const CONFIG_DRM_NXP_PTN3460_MODULE: u32 = 1;
pub const CONFIG_BRIDGE_CFM: u32 = 1;
pub const CONFIG_BAREUDP_MODULE: u32 = 1;
pub const CONFIG_LEDS_BLINKM_MODULE: u32 = 1;
pub const CONFIG_RADIO_TEA575X_MODULE: u32 = 1;
pub const CONFIG_CPU_THERMAL: u32 = 1;
pub const CONFIG_MMC_RICOH_MMC: u32 = 1;
pub const CONFIG_CRYPTO_SHA256: u32 = 1;
pub const CONFIG_CRYPTO_DEV_OCTEONTX2_CPT_MODULE: u32 = 1;
pub const CONFIG_DRM_XE_TIMESLICE_MAX: u32 = 10000000;
pub const CONFIG_REGULATOR_HI6421V600_MODULE: u32 = 1;
pub const CONFIG_ATH10K_MODULE: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_KEXEC_IMAGE_VERIFY_SIG: u32 = 1;
pub const CONFIG_SND_CTL_LED_MODULE: u32 = 1;
pub const CONFIG_NUMA_BALANCING: u32 = 1;
pub const CONFIG_ARM_CCI400_PMU: u32 = 1;
pub const CONFIG_VIRTIO_MMIO_CMDLINE_DEVICES: u32 = 1;
pub const CONFIG_CLK_TEGRA_BPMP: u32 = 1;
pub const CONFIG_HAVE_BUILDTIME_MCOUNT_SORT: u32 = 1;
pub const CONFIG_ATM_LANE_MODULE: u32 = 1;
pub const CONFIG_FWCTL_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_SEIKO_43WVF1G_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_KONICA_MODULE: u32 = 1;
pub const CONFIG_NET_EMATCH_CMP_MODULE: u32 = 1;
pub const CONFIG_QUOTACTL: u32 = 1;
pub const CONFIG_FSL_QDMA_MODULE: u32 = 1;
pub const CONFIG_BRIDGE_NF_EBTABLES_MODULE: u32 = 1;
pub const CONFIG_CAVIUM_ERRATUM_23154: u32 = 1;
pub const CONFIG_EXFAT_DEFAULT_IOCHARSET: &[u8; 5] = b"utf8\0";
pub const CONFIG_ARMADA_AP_CP_HELPER: u32 = 1;
pub const CONFIG_VIDEOBUF2_V4L2_MODULE: u32 = 1;
pub const CONFIG_PHY_MESON8B_USB2_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_ARC: u32 = 1;
pub const CONFIG_COMMON_CLK_MESON_VID_PLL_DIV: u32 = 1;
pub const CONFIG_WIL6210_DEBUGFS: u32 = 1;
pub const CONFIG_BT_HCIUART_BCM: u32 = 1;
pub const CONFIG_NET_VENDOR_NVIDIA: u32 = 1;
pub const CONFIG_UNIX: u32 = 1;
pub const CONFIG_TINYDRM_ST7586_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_M88RS6000T_MODULE: u32 = 1;
pub const CONFIG_IRQ_WORK: u32 = 1;
pub const CONFIG_RZ_DMAC_MODULE: u32 = 1;
pub const CONFIG_IPV6_RPL_LWTUNNEL: u32 = 1;
pub const CONFIG_ARCH_ENABLE_MEMORY_HOTREMOVE: u32 = 1;
pub const CONFIG_SND_SOC_WSA884X_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_COMMENT_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_MESON_G12A: u32 = 1;
pub const CONFIG_TI_K3_UDMA_GLUE_LAYER_MODULE: u32 = 1;
pub const CONFIG_EROFS_FS_XATTR: u32 = 1;
pub const CONFIG_CRYPTO_DEV_SUN8I_SS_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_LIB_CURVE25519_GENERIC_MODULE: u32 = 1;
pub const CONFIG_FSL_DPAA2_ETH_MODULE: u32 = 1;
pub const CONFIG_TRACING_MAP: u32 = 1;
pub const CONFIG_NLS_MAC_CROATIAN_MODULE: u32 = 1;
pub const CONFIG_MMC_SDHCI_OF_ESDHC_MODULE: u32 = 1;
pub const CONFIG_SCSI_HPSA_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_TPROXY_MODULE: u32 = 1;
pub const CONFIG_SGI_PARTITION: u32 = 1;
pub const CONFIG_DUMMY_CONSOLE_COLUMNS: u32 = 80;
pub const CONFIG_NF_LOG_IPV4_MODULE: u32 = 1;
pub const CONFIG_TLS_MODULE: u32 = 1;
pub const CONFIG_PCI_HYPERV_INTERFACE_MODULE: u32 = 1;
pub const CONFIG_NET_DEVMEM: u32 = 1;
pub const CONFIG_ATH9K_PCI: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_1530923: u32 = 1;
pub const CONFIG_B43LEGACY_LEDS: u32 = 1;
pub const CONFIG_MFD_KHADAS_MCU_MODULE: u32 = 1;
pub const CONFIG_TCP_CONG_HTCP_MODULE: u32 = 1;
pub const CONFIG_SND_LAYLA24_MODULE: u32 = 1;
pub const CONFIG_HID_PICOLCD_BACKLIGHT: u32 = 1;
pub const CONFIG_STACKTRACE: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA_MAX98088_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_MAX5970_MODULE: u32 = 1;
pub const CONFIG_MMC_SDHCI_PXAV3_MODULE: u32 = 1;
pub const CONFIG_WCN36XX_MODULE: u32 = 1;
pub const CONFIG_DTPM: u32 = 1;
pub const CONFIG_DRM_TI_SN65DSI86_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_MESON_AO_CLKC: u32 = 1;
pub const CONFIG_DVB_USB_CINERGY_T2_MODULE: u32 = 1;
pub const CONFIG_BT_HCIBTUSB_AUTOSUSPEND: u32 = 1;
pub const CONFIG_INTERCONNECT_QCOM_RPMH_POSSIBLE: u32 = 1;
pub const CONFIG_CRYPTO_LIB_CHACHA_INTERNAL: u32 = 1;
pub const CONFIG_8139TOO_8129: u32 = 1;
pub const CONFIG_6LOWPAN_NHC_HOP_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_2051678: u32 = 1;
pub const CONFIG_TUN_MODULE: u32 = 1;
pub const CONFIG_SCSI_IPR_DUMP: u32 = 1;
pub const CONFIG_PHY_XGENE: u32 = 1;
pub const CONFIG_NET_CLS_BASIC_MODULE: u32 = 1;
pub const CONFIG_TCP_CONG_LP_MODULE: u32 = 1;
pub const CONFIG_DVB_USB_TECHNISAT_USB2_MODULE: u32 = 1;
pub const CONFIG_ARCH_USE_SYM_ANNOTATIONS: u32 = 1;
pub const CONFIG_RTC_DRV_RV3029_HWMON: u32 = 1;
pub const CONFIG_SENSORS_IBMPEX_MODULE: u32 = 1;
pub const CONFIG_MAC80211_DEBUGFS: u32 = 1;
pub const CONFIG_SUN50I_H6_R_CCU: u32 = 1;
pub const CONFIG_IXGBE_DCB: u32 = 1;
pub const CONFIG_MOUSE_BCM5974_MODULE: u32 = 1;
pub const CONFIG_ATH5K_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MAX6639_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MAX31790_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_XCBC_MODULE: u32 = 1;
pub const CONFIG_AR5523_MODULE: u32 = 1;
pub const CONFIG_MLX4_CORE_GEN2: u32 = 1;
pub const CONFIG_CHROMEOS_TBMC: u32 = 1;
pub const CONFIG_HW_RANDOM: u32 = 1;
pub const CONFIG_DRM_PANEL_TRULY_NT35597_WQXGA_MODULE: u32 = 1;
pub const CONFIG_GPIO_FXL6408_MODULE: u32 = 1;
pub const CONFIG_IP_NF_TARGET_MASQUERADE_MODULE: u32 = 1;
pub const CONFIG_BPF_PRELOAD_UMD_MODULE: u32 = 1;
pub const CONFIG_RCU_NEED_SEGCBLIST: u32 = 1;
pub const CONFIG_SND_SOC_WM8940_MODULE: u32 = 1;
pub const CONFIG_SENSORS_LM80_MODULE: u32 = 1;
pub const CONFIG_SENSORS_INA233_MODULE: u32 = 1;
pub const CONFIG_USB_NET_CX82310_ETH_MODULE: u32 = 1;
pub const CONFIG_RUSTC_HAS_COERCE_POINTEE: u32 = 1;
pub const CONFIG_BT_QCA_MODULE: u32 = 1;
pub const CONFIG_RTC_DRV_RV8803_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_FSL_SAI_MODULE: u32 = 1;
pub const CONFIG_LEDS_MAX5970_MODULE: u32 = 1;
pub const CONFIG_MFD_HI6421_PMIC_MODULE: u32 = 1;
pub const CONFIG_SLIP_SMART: u32 = 1;
pub const CONFIG_INTERCONNECT_QCOM_MSM8996_MODULE: u32 = 1;
pub const CONFIG_NEED_DMA_MAP_STATE: u32 = 1;
pub const CONFIG_BT_MTKUART_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_HI655X_MODULE: u32 = 1;
pub const CONFIG_TCM_FC_MODULE: u32 = 1;
pub const CONFIG_UBIFS_FS_MODULE: u32 = 1;
pub const CONFIG_RCU_EXP_CPU_STALL_TIMEOUT: u32 = 0;
pub const CONFIG_ROCKCHIP_DW_MIPI_DSI: u32 = 1;
pub const CONFIG_OF: u32 = 1;
pub const CONFIG_ARM_IMX_CPUFREQ_DT_MODULE: u32 = 1;
pub const CONFIG_DRM_PANEL_RAYDIUM_RM68200_MODULE: u32 = 1;
pub const CONFIG_MODULE_SIG_KEY: &[u8; 22] = b"certs/signing_key.pem\0";
pub const CONFIG_ARCH_MMAP_RND_BITS_MIN: u32 = 18;
pub const CONFIG_SPI_APPLE_MODULE: u32 = 1;
pub const CONFIG_UBSAN_SHIFT: u32 = 1;
pub const CONFIG_USB_SERIAL_SYMBOL_MODULE: u32 = 1;
pub const CONFIG_OPENVSWITCH_VXLAN_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_BLAKE2B: u32 = 1;
pub const CONFIG_DEBUG_SHIRQ: u32 = 1;
pub const CONFIG_NVDIMM_DAX: u32 = 1;
pub const CONFIG_SENSORS_PLI1209BC_MODULE: u32 = 1;
pub const CONFIG_MMC_SDHCI_OF_DWCMSHC_MODULE: u32 = 1;
pub const CONFIG_GFS2_FS_MODULE: u32 = 1;
pub const CONFIG_INFINIBAND_ADDR_TRANS_CONFIGFS: u32 = 1;
pub const CONFIG_UIO_DFL_MODULE: u32 = 1;
pub const CONFIG_ATA_FORCE: u32 = 1;
pub const CONFIG_QCOM_GENI_SE: u32 = 1;
pub const CONFIG_ARM64_POE: u32 = 1;
pub const CONFIG_FSL_DPAA2_SWITCH_MODULE: u32 = 1;
pub const CONFIG_IP_SET_HASH_IPMAC_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_MAX98373_I2C_MODULE: u32 = 1;
pub const CONFIG_SND_ES1968_INPUT: u32 = 1;
pub const CONFIG_BLK_MQ_PCI: u32 = 1;
pub const CONFIG_SND_HDA_CODEC_CA0132_DSP: u32 = 1;
pub const CONFIG_CRYPTO_DEV_SUN8I_CE_PRNG: u32 = 1;
pub const CONFIG_SENSORS_DS1621_MODULE: u32 = 1;
pub const CONFIG_RT2800USB_UNKNOWN: u32 = 1;
pub const CONFIG_SYSVIPC: u32 = 1;
pub const CONFIG_LOCKDEP_SUPPORT: u32 = 1;
pub const CONFIG_PHY_QCOM_USB_HS_MODULE: u32 = 1;
pub const CONFIG_SPI_SN_F_OSPI_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV5640_MODULE: u32 = 1;
pub const CONFIG_ARM64_ERRATUM_1319367: u32 = 1;
pub const CONFIG_ARCH_MESON: u32 = 1;
pub const CONFIG_NFT_FIB_IPV6_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_TDA18250_MODULE: u32 = 1;
pub const CONFIG_MEDIA_TUNER_QM1D1B0004_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_NETERION: u32 = 1;
pub const CONFIG_IIO_ST_GYRO_3AXIS_MODULE: u32 = 1;
pub const CONFIG_ARM_PL172_MPMC_MODULE: u32 = 1;
pub const CONFIG_BT_HCIUART_LL: u32 = 1;
pub const CONFIG_CLK_RENESAS_CPG_MSSR: u32 = 1;
pub const CONFIG_TCP_SIGPOOL: u32 = 1;
pub const CONFIG_PHY_QCOM_PCIE2_MODULE: u32 = 1;
pub const CONFIG_RT2X00_LIB_PCI_MODULE: u32 = 1;
pub const CONFIG_FSCACHE: u32 = 1;
pub const CONFIG_MFD_SM501_MODULE: u32 = 1;
pub const CONFIG_DM_INTEGRITY_MODULE: u32 = 1;
pub const CONFIG_USB_CONFIGFS_MODULE: u32 = 1;
pub const CONFIG_USB_F_ECM_MODULE: u32 = 1;
pub const CONFIG_CORESIGHT_CPU_DEBUG_MODULE: u32 = 1;
pub const CONFIG_DWMAC_DWC_QOS_ETH_MODULE: u32 = 1;
pub const CONFIG_MEDIA_SUPPORT_FILTER: u32 = 1;
pub const CONFIG_CRYPTO: u32 = 1;
pub const CONFIG_NF_TABLES_BRIDGE_MODULE: u32 = 1;
pub const CONFIG_USB_XHCI_TEGRA_MODULE: u32 = 1;
pub const CONFIG_PCIEAER_CXL: u32 = 1;
pub const CONFIG_PARAVIRT: u32 = 1;
pub const CONFIG_PHY_NXP_PTN3222_MODULE: u32 = 1;
pub const CONFIG_HID_ELECOM_MODULE: u32 = 1;
pub const CONFIG_LOGO: u32 = 1;
pub const CONFIG_VIDEO_IMX_PXP_MODULE: u32 = 1;
pub const CONFIG_FPGA_M10_BMC_SEC_UPDATE_MODULE: u32 = 1;
pub const CONFIG_PCI_J721E_HOST: u32 = 1;
pub const CONFIG_MSM_GCC_8916: u32 = 1;
pub const CONFIG_HAVE_ARCH_SECCOMP: u32 = 1;
pub const CONFIG_SND_CORE_TEST_MODULE: u32 = 1;
pub const CONFIG_VCPU_STALL_DETECTOR_MODULE: u32 = 1;
pub const CONFIG_DVB_TUNER_CX24113_MODULE: u32 = 1;
pub const CONFIG_ARM_SCMI_TRANSPORT_OPTEE_MODULE: u32 = 1;
pub const CONFIG_IOMMU_IOPF: u32 = 1;
pub const CONFIG_ARM_TI_CPUFREQ: u32 = 1;
pub const CONFIG_CAVIUM_ERRATUM_30115: u32 = 1;
pub const CONFIG_AMPERE_ERRATUM_AC03_CPU_38: u32 = 1;
pub const CONFIG_HID_MCP2221_MODULE: u32 = 1;
pub const CONFIG_VFIO_GROUP: u32 = 1;
pub const CONFIG_VIDEO_OV9640_MODULE: u32 = 1;
pub const CONFIG_CHARGER_MAX77650_MODULE: u32 = 1;
pub const CONFIG_USB_ISP1760_DUAL_ROLE: u32 = 1;
pub const CONFIG_DRM_ETNAVIV_MODULE: u32 = 1;
pub const CONFIG_SENSORS_LM70_MODULE: u32 = 1;
pub const CONFIG_VIDEO_VIVID_MAX_DEVS: u32 = 64;
pub const CONFIG_PINCTRL_MESON_GXL: u32 = 1;
pub const CONFIG_BLK_CGROUP_FC_APPID: u32 = 1;
pub const CONFIG_PROC_FS: u32 = 1;
pub const CONFIG_USB_ALI_M5632: u32 = 1;
pub const CONFIG_DRM_MSM_HDMI_HDCP: u32 = 1;
pub const CONFIG_RSI_SDIO_MODULE: u32 = 1;
pub const CONFIG_VIDEO_OV2740_MODULE: u32 = 1;
pub const CONFIG_SND_CTL_FAST_LOOKUP: u32 = 1;
pub const CONFIG_DVB_USB_DIBUSB_MC_MODULE: u32 = 1;
pub const CONFIG_TXGBE_MODULE: u32 = 1;
pub const CONFIG_ARCH_USE_MEMREMAP_PROT: u32 = 1;
pub const CONFIG_SENSORS_MAX16064_MODULE: u32 = 1;
pub const CONFIG_ARCH_RCAR_GEN3: u32 = 1;
pub const CONFIG_SND_SOC_CS35L56_SDW_MODULE: u32 = 1;
pub const CONFIG_DEBUG_INFO_COMPRESSED_NONE: u32 = 1;
pub const CONFIG_CRYPTO_MICHAEL_MIC_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_DEV_ATMEL_ECC_MODULE: u32 = 1;
pub const CONFIG_PM_DEVFREQ: u32 = 1;
pub const CONFIG_DRM_CLIENT_SELECTION: u32 = 1;
pub const CONFIG_SENSORS_F71805F_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_TEHUTI: u32 = 1;
pub const CONFIG_NF_CT_PROTO_SCTP: u32 = 1;
pub const CONFIG_CRYPTO_LIB_POLY1305_INTERNAL: u32 = 1;
pub const CONFIG_BLK_DEV_PMEM: u32 = 1;
pub const CONFIG_USB_GSPCA_SPCA508_MODULE: u32 = 1;
pub const CONFIG_SX_COMMON_MODULE: u32 = 1;
pub const CONFIG_BPF_EVENTS: u32 = 1;
pub const CONFIG_SOC_RENESAS: u32 = 1;
pub const CONFIG_MEDIA_PLATFORM_SUPPORT: u32 = 1;
pub const CONFIG_MTD_DATAFLASH_WRITE_VERIFY: u32 = 1;
pub const CONFIG_HEADERS_INSTALL: u32 = 1;
pub const CONFIG_TMPFS_QUOTA: u32 = 1;
pub const CONFIG_VIDEO_VISL_MODULE: u32 = 1;
pub const CONFIG_POSIX_TIMERS: u32 = 1;
pub const CONFIG_HID_BELKIN_MODULE: u32 = 1;
pub const CONFIG_DVB_ISL6421_MODULE: u32 = 1;
pub const CONFIG_SND_OXYGEN_MODULE: u32 = 1;
pub const CONFIG_I2C_ATR_MODULE: u32 = 1;
pub const CONFIG_ARM_RK3399_DMC_DEVFREQ_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_KLSI_MODULE: u32 = 1;
pub const CONFIG_APPLE_SART_MODULE: u32 = 1;
pub const CONFIG_BME680_MODULE: u32 = 1;
pub const CONFIG_PCS_LYNX_MODULE: u32 = 1;
pub const CONFIG_SM_GCC_6115_MODULE: u32 = 1;
pub const CONFIG_RPMSG_VIRTIO_MODULE: u32 = 1;
pub const CONFIG_NOP_USB_XCEIV_MODULE: u32 = 1;
pub const CONFIG_GENERIC_TRACER: u32 = 1;
pub const CONFIG_NET_DSA_MT7530_MDIO_MODULE: u32 = 1;
pub const CONFIG_ATA_GENERIC_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_APPLE_NCO_MODULE: u32 = 1;
pub const CONFIG_SQUASHFS_XZ: u32 = 1;
pub const CONFIG_PINCTRL_IMX91: u32 = 1;
pub const CONFIG_OCTEONTX2_VF_MODULE: u32 = 1;
pub const CONFIG_SCSI_SMARTPQI_MODULE: u32 = 1;
pub const CONFIG_CC_HAS_COUNTED_BY: u32 = 1;
pub const CONFIG_PPP_ASYNC_MODULE: u32 = 1;
pub const CONFIG_S2IO_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA210_DMIC_MODULE: u32 = 1;
pub const CONFIG_OSF_PARTITION: u32 = 1;
pub const CONFIG_DVB_MAX_ADAPTERS: u32 = 16;
pub const CONFIG_NET_VENDOR_SIS: u32 = 1;
pub const CONFIG_BCMA_BLOCKIO: u32 = 1;
pub const CONFIG_V4L2_MEM2MEM_DEV_MODULE: u32 = 1;
pub const CONFIG_KERNEL_ZSTD: u32 = 1;
pub const CONFIG_LEDS_REGULATOR_MODULE: u32 = 1;
pub const CONFIG_CC_HAVE_SHADOW_CALL_STACK: u32 = 1;
pub const CONFIG_DRM_IMX8QXP_PIXEL_LINK_TO_DPI_MODULE: u32 = 1;
pub const CONFIG_NOUVEAU_DEBUG_DEFAULT: u32 = 3;
pub const CONFIG_ARM_GIC_V3_ITS_FSL_MC: u32 = 1;
pub const CONFIG_RTC_DRV_RS5C372_MODULE: u32 = 1;
pub const CONFIG_NET_XGENE_MODULE: u32 = 1;
pub const CONFIG_HAVE_PREEMPT_DYNAMIC_KEY: u32 = 1;
pub const CONFIG_XFRM_AH_MODULE: u32 = 1;
pub const CONFIG_DVB_DIB8000_MODULE: u32 = 1;
pub const CONFIG_INET_DIAG: u32 = 1;
pub const CONFIG_CLK_ICST: u32 = 1;
pub const CONFIG_JOYSTICK_A3D_MODULE: u32 = 1;
pub const CONFIG_FS_IOMAP: u32 = 1;
pub const CONFIG_FB_IOMEM_HELPERS: u32 = 1;
pub const CONFIG_NATIONAL_PHY_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MLXREG_FAN_MODULE: u32 = 1;
pub const CONFIG_DRM_QXL_MODULE: u32 = 1;
pub const CONFIG_INPUT_VIVALDIFMAP: u32 = 1;
pub const CONFIG_CHARGER_CROS_USBPD_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_POLYVAL_ARM64_CE_MODULE: u32 = 1;
pub const CONFIG_THERMAL_STATISTICS: u32 = 1;
pub const CONFIG_USB_GSPCA_DTCS033_MODULE: u32 = 1;
pub const CONFIG_IP_VS_PROTO_TCP: u32 = 1;
pub const CONFIG_USB_GL860_MODULE: u32 = 1;
pub const CONFIG_ALLOW_DEV_COREDUMP: u32 = 1;
pub const CONFIG_ASN1: u32 = 1;
pub const CONFIG_NF_NAT_PPTP_MODULE: u32 = 1;
pub const CONFIG_COMMON_CLK_HI3670: u32 = 1;
pub const CONFIG_STAGING_MEDIA: u32 = 1;
pub const CONFIG_RAID_ATTRS_MODULE: u32 = 1;
pub const CONFIG_MMC_CQHCI_MODULE: u32 = 1;
pub const CONFIG_DRM_DISPLAY_HDMI_AUDIO_HELPER: u32 = 1;
pub const CONFIG_DRM_PANEL_DSI_CM_MODULE: u32 = 1;
pub const CONFIG_DEVTMPFS_MOUNT: u32 = 1;
pub const CONFIG_REGULATOR_BD9571MWV_MODULE: u32 = 1;
pub const CONFIG_NFC_ST21NFCA_I2C_MODULE: u32 = 1;
pub const CONFIG_RANDOMIZE_MODULE_REGION_FULL: u32 = 1;
pub const CONFIG_HAVE_FTRACE_MCOUNT_RECORD: u32 = 1;
pub const CONFIG_HID_LOGITECH_DJ_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_TEGRA20_I2S_MODULE: u32 = 1;
pub const CONFIG_USB_SERIAL_EDGEPORT_TI_MODULE: u32 = 1;
pub const CONFIG_BATTERY_QCOM_BATTMGR_MODULE: u32 = 1;
pub const CONFIG_CONSOLE_LOGLEVEL_QUIET: u32 = 3;
pub const CONFIG_ACPI_PCC: u32 = 1;
pub const CONFIG_DRM_PANEL_SAMSUNG_AMS639RQ08_MODULE: u32 = 1;
pub const CONFIG_VIDEO_BT819_MODULE: u32 = 1;
pub const CONFIG_NETFILTER_XT_TARGET_NFLOG_MODULE: u32 = 1;
pub const CONFIG_QCOM_LLCC_MODULE: u32 = 1;
pub const CONFIG_SCSI_EFCT_MODULE: u32 = 1;
pub const CONFIG_XILINX_PR_DECOUPLER_MODULE: u32 = 1;
pub const CONFIG_FSL_ENETC_MODULE: u32 = 1;
pub const CONFIG_INET_TUNNEL_MODULE: u32 = 1;
pub const CONFIG_VIDEO_WM8739_MODULE: u32 = 1;
pub const CONFIG_HTE: u32 = 1;
pub const CONFIG_DMA_SUN6I_MODULE: u32 = 1;
pub const CONFIG_IEEE802154_CA8210_MODULE: u32 = 1;
pub const CONFIG_PCI_SYSCALL: u32 = 1;
pub const CONFIG_LZO_DECOMPRESS: u32 = 1;
pub const CONFIG_DM_UNSTRIPED_MODULE: u32 = 1;
pub const CONFIG_VIRTIO_VSOCKETS_MODULE: u32 = 1;
pub const CONFIG_ARM_NI_MODULE: u32 = 1;
pub const CONFIG_NUMA_MEMBLKS: u32 = 1;
pub const CONFIG_JUMP_LABEL: u32 = 1;
pub const CONFIG_GENERIC_SMP_IDLE_THREAD: u32 = 1;
pub const CONFIG_DRM_PANIC_SCREEN_QR_CODE_URL: &[u8; 1] = b"\0";
pub const CONFIG_USB_ARCH_HAS_HCD: u32 = 1;
pub const CONFIG_GPIO_TPS65086_MODULE: u32 = 1;
pub const CONFIG_REED_SOLOMON_ENC8: u32 = 1;
pub const CONFIG_NET_EMATCH_STACK: u32 = 32;
pub const CONFIG_NF_NAT_FTP_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_AEGIS128_MODULE: u32 = 1;
pub const CONFIG_VIDEO_IMX8_JPEG_MODULE: u32 = 1;
pub const CONFIG_DPOT_DAC_MODULE: u32 = 1;
pub const CONFIG_LDM_PARTITION: u32 = 1;
pub const CONFIG_EEPROM_EE1004_MODULE: u32 = 1;
pub const CONFIG_IAVF_MODULE: u32 = 1;
pub const CONFIG_UBSAN_BOUNDS_STRICT: u32 = 1;
pub const CONFIG_VIDEO_UDA1342_MODULE: u32 = 1;
pub const CONFIG_ARCH_MMAP_RND_COMPAT_BITS_MIN: u32 = 11;
pub const CONFIG_NET_EMATCH_CANID_MODULE: u32 = 1;
pub const CONFIG_RTC_HCTOSYS: u32 = 1;
pub const CONFIG_SDM_DISPCC_845_MODULE: u32 = 1;
pub const CONFIG_EXTRA_FIRMWARE: &[u8; 1] = b"\0";
pub const CONFIG_IP_MULTICAST: u32 = 1;
pub const CONFIG_LATENCYTOP: u32 = 1;
pub const CONFIG_DVB_BUDGET_MODULE: u32 = 1;
pub const CONFIG_MFD_WM8994_MODULE: u32 = 1;
pub const CONFIG_PNPACPI: u32 = 1;
pub const CONFIG_ARM_SMCCC_SOC_ID: u32 = 1;
pub const CONFIG_ASYMMETRIC_PUBLIC_KEY_SUBTYPE: u32 = 1;
pub const CONFIG_DVB_STV0288_MODULE: u32 = 1;
pub const CONFIG_PHY_CADENCE_SIERRA_MODULE: u32 = 1;
pub const CONFIG_SCSI_UFSHCD_PCI_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MAX6650_MODULE: u32 = 1;
pub const CONFIG_LOCKUP_DETECTOR: u32 = 1;
pub const CONFIG_FUSE_FS_MODULE: u32 = 1;
pub const CONFIG_USB_STV06XX_MODULE: u32 = 1;
pub const CONFIG_NFC_PN533_USB_MODULE: u32 = 1;
pub const CONFIG_QCOM_SCM: u32 = 1;
pub const CONFIG_SENSORS_LIS3LV02D_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_NHPOLY1305_NEON_MODULE: u32 = 1;
pub const CONFIG_SUN55I_A523_CCU_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_ADS7846_MODULE: u32 = 1;
pub const CONFIG_SERIAL_8250_DWLIB: u32 = 1;
pub const CONFIG_ZRAM_BACKEND_ZSTD: u32 = 1;
pub const CONFIG_OF_KOBJ: u32 = 1;
pub const CONFIG_USB_F_ACM_MODULE: u32 = 1;
pub const CONFIG_ARM_GIC: u32 = 1;
pub const CONFIG_KSZ884X_PCI_MODULE: u32 = 1;
pub const CONFIG_RESET_IMX7: u32 = 1;
pub const CONFIG_RTW88_CORE_MODULE: u32 = 1;
pub const CONFIG_PSTORE_RAM_MODULE: u32 = 1;
pub const CONFIG_EFI_CUSTOM_SSDT_OVERLAYS: u32 = 1;
pub const CONFIG_MEDIA_TUNER_TUA9001_MODULE: u32 = 1;
pub const CONFIG_SENSORS_ISL28022_MODULE: u32 = 1;
pub const CONFIG_FSL_DPAA2_PTP_CLOCK_MODULE: u32 = 1;
pub const CONFIG_BT_HCIUART_NOKIA_MODULE: u32 = 1;
pub const CONFIG_NOP_TRACER: u32 = 1;
pub const CONFIG_HAVE_KVM_DIRTY_RING_ACQ_REL: u32 = 1;
pub const CONFIG_TOUCHSCREEN_TI_AM335X_TSC_MODULE: u32 = 1;
pub const CONFIG_MICREL_PHY_MODULE: u32 = 1;
pub const CONFIG_CLK_GATE_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_LZ4_COMPRESS_MODULE: u32 = 1;
pub const CONFIG_TOUCHSCREEN_USB_ETURBO: u32 = 1;
pub const CONFIG_NETFILTER_XT_MATCH_SOCKET_MODULE: u32 = 1;
pub const CONFIG_ARCH_HAS_FORCE_DMA_UNENCRYPTED: u32 = 1;
pub const CONFIG_IP_VS_LBLCR_MODULE: u32 = 1;
pub const CONFIG_ARCH_SEATTLE: u32 = 1;
pub const CONFIG_REGULATOR_AW37503_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_IMX_SGTL5000_MODULE: u32 = 1;
pub const CONFIG_BTREE: u32 = 1;
pub const CONFIG_DRM_SII9234_MODULE: u32 = 1;
pub const CONFIG_PNFS_FLEXFILE_LAYOUT_MODULE: u32 = 1;
pub const CONFIG_AMD_QDMA_MODULE: u32 = 1;
pub const CONFIG_GENERIC_PINMUX_FUNCTIONS: u32 = 1;
pub const CONFIG_FW_CS_DSP_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_PINCTRL_SUN50I_A100_R: u32 = 1;
pub const CONFIG_SND_SOC_AW88081_MODULE: u32 = 1;
pub const CONFIG_VETH_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_CONEX_MODULE: u32 = 1;
pub const CONFIG_USB_ULPI_VIEWPORT: u32 = 1;
pub const CONFIG_RV_MON_WWNR: u32 = 1;
pub const CONFIG_RPCSEC_GSS_KRB5_KUNIT_TEST_MODULE: u32 = 1;
pub const CONFIG_IP_VS_NFCT: u32 = 1;
pub const CONFIG_NSM_MODULE: u32 = 1;
pub const CONFIG_IMX_INTMUX: u32 = 1;
pub const CONFIG_CAN_CTUCANFD_PLATFORM_MODULE: u32 = 1;
pub const CONFIG_MAX5522_MODULE: u32 = 1;
pub const CONFIG_PHY_MVEBU_CP110_COMPHY_MODULE: u32 = 1;
pub const CONFIG_DVB_CXD2099_MODULE: u32 = 1;
pub const CONFIG_SDIO_UART_MODULE: u32 = 1;
pub const CONFIG_SSB_B43_PCI_BRIDGE: u32 = 1;
pub const CONFIG_MFD_AS3722: u32 = 1;
pub const CONFIG_SERIAL_FSL_LPUART_CONSOLE: u32 = 1;
pub const CONFIG_NET_SCH_PIE_MODULE: u32 = 1;
pub const CONFIG_UCLAMP_TASK_GROUP: u32 = 1;
pub const CONFIG_RTC_DRV_88PM886_MODULE: u32 = 1;
pub const CONFIG_SERIAL_IMX_CONSOLE: u32 = 1;
pub const CONFIG_USB_SERIAL_MOS7720_MODULE: u32 = 1;
pub const CONFIG_NET_VENDOR_LITEX: u32 = 1;
pub const CONFIG_RTW88_8822CE_MODULE: u32 = 1;
pub const CONFIG_AD4000_MODULE: u32 = 1;
pub const CONFIG_VIDEO_V4L2_SUBDEV_API: u32 = 1;
pub const CONFIG_SCSI_SAS_ATA: u32 = 1;
pub const CONFIG_INV_MPU6050_I2C_MODULE: u32 = 1;
pub const CONFIG_IKHEADERS_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MAX31722_MODULE: u32 = 1;
pub const CONFIG_NVME_TARGET_FC_MODULE: u32 = 1;
pub const CONFIG_LEDS_LM3692X_MODULE: u32 = 1;
pub const CONFIG_SENSORS_MAX16065_MODULE: u32 = 1;
pub const CONFIG_VIRTIO_BALLOON_MODULE: u32 = 1;
pub const CONFIG_BCMA_HOST_PCI_POSSIBLE: u32 = 1;
pub const CONFIG_VHOST_RING_MODULE: u32 = 1;
pub const CONFIG_CPU_ISOLATION: u32 = 1;
pub const CONFIG_SERIAL_8250_PCI: u32 = 1;
pub const CONFIG_NET_VENDOR_QLOGIC: u32 = 1;
pub const CONFIG_USB_GSPCA_SONIXJ_MODULE: u32 = 1;
pub const CONFIG_ARM_SCMI_PERF_DOMAIN: u32 = 1;
pub const CONFIG_ZSWAP_ZPOOL_DEFAULT: &[u8; 9] = b"zsmalloc\0";
pub const CONFIG_EDAC_VERSAL_MODULE: u32 = 1;
pub const CONFIG_LWTUNNEL_BPF: u32 = 1;
pub const CONFIG_NET_ACT_CTINFO_MODULE: u32 = 1;
pub const CONFIG_DLM_MODULE: u32 = 1;
pub const CONFIG_SERIO: u32 = 1;
pub const CONFIG_CHR_DEV_SCH_MODULE: u32 = 1;
pub const CONFIG_SC92031_MODULE: u32 = 1;
pub const CONFIG_USB_GSPCA_OV519_MODULE: u32 = 1;
pub const CONFIG_NET_VRF_MODULE: u32 = 1;
pub const CONFIG_DRM_GEM_SHMEM_HELPER: u32 = 1;
pub const CONFIG_ARCH_SUPPORTS_ATOMIC_RMW: u32 = 1;
pub const CONFIG_CROS_EC_UCSI_MODULE: u32 = 1;
pub const CONFIG_DRM_LIB_RANDOM: u32 = 1;
pub const CONFIG_HARDLOCKUP_DETECTOR_PERF: u32 = 1;
pub const CONFIG_DVB_TDA826X_MODULE: u32 = 1;
pub const CONFIG_BT_INTEL_PCIE_MODULE: u32 = 1;
pub const CONFIG_CRYPTO_LIB_AES: u32 = 1;
pub const CONFIG_MMC_SDHCI_BRCMSTB_MODULE: u32 = 1;
pub const CONFIG_FSL_ENETC_MDIO_MODULE: u32 = 1;
pub const CONFIG_VFIO_FSL_MC_MODULE: u32 = 1;
pub const CONFIG_HYPERV_VSOCKETS_MODULE: u32 = 1;
pub const CONFIG_BPF_LIRC_MODE2: u32 = 1;
pub const CONFIG_ARM64_E0PD: u32 = 1;
pub const CONFIG_PINCTRL_SC7280_LPASS_LPI_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_LPASS_CDC_DMA_MODULE: u32 = 1;
pub const CONFIG_BMI160_SPI_MODULE: u32 = 1;
pub const CONFIG_SND_GINA24_MODULE: u32 = 1;
pub const CONFIG_CROS_USBPD_LOGGER_MODULE: u32 = 1;
pub const CONFIG_DM_VERITY_FEC: u32 = 1;
pub const CONFIG_MLX5_VDPA_NET_MODULE: u32 = 1;
pub const CONFIG_SND_MESON_AXG_FIFO_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_SY7636A_MODULE: u32 = 1;
pub const CONFIG_NF_LOG_SYSLOG_MODULE: u32 = 1;
pub const CONFIG_LTRF216A_MODULE: u32 = 1;
pub const CONFIG_USB_OHCI_HCD_MODULE: u32 = 1;
pub const CONFIG_NET_XGENE_V2_MODULE: u32 = 1;
pub const CONFIG_I2C_IMX_LPI2C_MODULE: u32 = 1;
pub const CONFIG_VFIO_VIRQFD: u32 = 1;
pub const CONFIG_ARCH_TEGRA_186_SOC: u32 = 1;
pub const CONFIG_DRM_PANEL_SHARP_LS043T1LE01_MODULE: u32 = 1;
pub const CONFIG_CLK_GFM_LPASS_SM8250_MODULE: u32 = 1;
pub const CONFIG_FB_IOMEM_FOPS: u32 = 1;
pub const CONFIG_FW_CACHE: u32 = 1;
pub const CONFIG_ARCH_HAS_SYNC_DMA_FOR_DEVICE: u32 = 1;
pub const CONFIG_REGMAP_I2C: u32 = 1;
pub const CONFIG_CRYPTO_DEV_FSL_CAAM_JR_MODULE: u32 = 1;
pub const CONFIG_STMMAC_PLATFORM_MODULE: u32 = 1;
pub const CONFIG_IP_NF_TARGET_REDIRECT_MODULE: u32 = 1;
pub const CONFIG_MTD_MTDRAM_MODULE: u32 = 1;
pub const CONFIG_CLK_R9A07G044: u32 = 1;
pub const CONFIG_HID_TOPRE_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_WM8731_SPI_MODULE: u32 = 1;
pub const CONFIG_MMC_SDHCI_MODULE: u32 = 1;
pub const CONFIG_IOMMUFD_DRIVER: u32 = 1;
pub const CONFIG_VIDEO_MUX_MODULE: u32 = 1;
pub const CONFIG_PRINTK: u32 = 1;
pub const CONFIG_LEDS_TRIGGER_DISK: u32 = 1;
pub const CONFIG_DM_SWITCH_MODULE: u32 = 1;
pub const CONFIG_VIDEO_EM28XX_DVB_MODULE: u32 = 1;
pub const CONFIG_SND_MESON_AXG_SPDIFOUT_MODULE: u32 = 1;
pub const CONFIG_NETLABEL: u32 = 1;
pub const CONFIG_PINCTRL_CS42L43_MODULE: u32 = 1;
pub const CONFIG_I2C_KEBA_MODULE: u32 = 1;
pub const CONFIG_MEMCG_V1: u32 = 1;
pub const CONFIG_PCI_STUB: u32 = 1;
pub const CONFIG_CRYPTO_RMD160_MODULE: u32 = 1;
pub const CONFIG_PCI_HOST_THUNDER_PEM: u32 = 1;
pub const CONFIG_USB_NET_CDC_NCM_MODULE: u32 = 1;
pub const CONFIG_CC_VERSION_TEXT: &[u8; 45] = b"gcc (GCC) 15.1.1 20250521 (Red Hat 15.1.1-2)\0";
pub const CONFIG_EQUALIZER_MODULE: u32 = 1;
pub const CONFIG_REGULATOR_BD718XX_MODULE: u32 = 1;
pub const CONFIG_SND_SOC_LPASS_CPU_MODULE: u32 = 1;
pub const CONFIG_VIDEO_IVTV_MODULE: u32 = 1;
pub const CONFIG_DVB_BUDGET_AV_MODULE: u32 = 1;
pub const CONFIG_IP6_NF_MATCH_SRH_MODULE: u32 = 1;
pub const CONFIG_BINFMT_ELF: u32 = 1;
pub const CONFIG_I2C_ARB_GPIO_CHALLENGE_MODULE: u32 = 1;
pub const CONFIG_BLK_DEV_RNBD: u32 = 1;
pub const CONFIG_HIGH_RES_TIMERS: u32 = 1;
pub const CONFIG_I2C_SMBUS_MODULE: u32 = 1;
pub const CONFIG_DEBUG_FS_ALLOW_ALL: u32 = 1;
pub const CONFIG_NULL_TTY_MODULE: u32 = 1;
pub const CONFIG_ARCH_K3: u32 = 1;
pub const CONFIG_QED_RDMA: u32 = 1;
pub const CONFIG_HAVE_SAMPLE_FTRACE_DIRECT_MULTI: u32 = 1;
pub const CONFIG_WIREGUARD_MODULE: u32 = 1;
pub const CONFIG_MEMFD_CREATE: u32 = 1;
pub const CONFIG_ARM_IMX_BUS_DEVFREQ_MODULE: u32 = 1;
pub const CONFIG_POWER_RESET_ODROID_GO_ULTRA_POWEROFF: u32 = 1;
pub const CONFIG_SND_SOC_RT715_SDCA_SDW_MODULE: u32 = 1;
pub const CONFIG_USB_HSIC_USB3503_MODULE: u32 = 1;
pub const CONFIG_MTD_OF_PARTS_MODULE: u32 = 1;
pub const CONFIG_DRM_AMD_DC_SI: u32 = 1;
pub const __LITTLE_ENDIAN: u32 = 1234;
pub const KASAN_ABI_VERSION: u32 = 5;
pub const ASM_INPUT_G: &[u8; 3] = b"ir\0";
pub const ASM_INPUT_RM: &[u8; 2] = b"r\0";
pub const USE_TYPEOF_UNQUAL: u32 = 1;
pub const __BITS_PER_LONG: u32 = 64;
pub const __BITS_PER_LONG_LONG: u32 = 64;
pub const BITS_PER_LONG: u32 = 64;
pub const BITS_PER_LONG_LONG: u32 = 64;
pub const __FD_SETSIZE: u32 = 1024;
pub const KCSAN_ACCESS_WRITE: u32 = 1;
pub const KCSAN_ACCESS_COMPOUND: u32 = 2;
pub const KCSAN_ACCESS_ATOMIC: u32 = 4;
pub const KCSAN_ACCESS_ASSERT: u32 = 8;
pub const KCSAN_ACCESS_SCOPED: u32 = 16;
pub const EPERM: u32 = 1;
pub const ENOENT: u32 = 2;
pub const ESRCH: u32 = 3;
pub const EINTR: u32 = 4;
pub const EIO: u32 = 5;
pub const ENXIO: u32 = 6;
pub const E2BIG: u32 = 7;
pub const ENOEXEC: u32 = 8;
pub const EBADF: u32 = 9;
pub const ECHILD: u32 = 10;
pub const EAGAIN: u32 = 11;
pub const ENOMEM: u32 = 12;
pub const EACCES: u32 = 13;
pub const EFAULT: u32 = 14;
pub const ENOTBLK: u32 = 15;
pub const EBUSY: u32 = 16;
pub const EEXIST: u32 = 17;
pub const EXDEV: u32 = 18;
pub const ENODEV: u32 = 19;
pub const ENOTDIR: u32 = 20;
pub const EISDIR: u32 = 21;
pub const EINVAL: u32 = 22;
pub const ENFILE: u32 = 23;
pub const EMFILE: u32 = 24;
pub const ENOTTY: u32 = 25;
pub const ETXTBSY: u32 = 26;
pub const EFBIG: u32 = 27;
pub const ENOSPC: u32 = 28;
pub const ESPIPE: u32 = 29;
pub const EROFS: u32 = 30;
pub const EMLINK: u32 = 31;
pub const EPIPE: u32 = 32;
pub const EDOM: u32 = 33;
pub const ERANGE: u32 = 34;
pub const EDEADLK: u32 = 35;
pub const ENAMETOOLONG: u32 = 36;
pub const ENOLCK: u32 = 37;
pub const ENOSYS: u32 = 38;
pub const ENOTEMPTY: u32 = 39;
pub const ELOOP: u32 = 40;
pub const EWOULDBLOCK: u32 = 11;
pub const ENOMSG: u32 = 42;
pub const EIDRM: u32 = 43;
pub const ECHRNG: u32 = 44;
pub const EL2NSYNC: u32 = 45;
pub const EL3HLT: u32 = 46;
pub const EL3RST: u32 = 47;
pub const ELNRNG: u32 = 48;
pub const EUNATCH: u32 = 49;
pub const ENOCSI: u32 = 50;
pub const EL2HLT: u32 = 51;
pub const EBADE: u32 = 52;
pub const EBADR: u32 = 53;
pub const EXFULL: u32 = 54;
pub const ENOANO: u32 = 55;
pub const EBADRQC: u32 = 56;
pub const EBADSLT: u32 = 57;
pub const EDEADLOCK: u32 = 35;
pub const EBFONT: u32 = 59;
pub const ENOSTR: u32 = 60;
pub const ENODATA: u32 = 61;
pub const ETIME: u32 = 62;
pub const ENOSR: u32 = 63;
pub const ENONET: u32 = 64;
pub const ENOPKG: u32 = 65;
pub const EREMOTE: u32 = 66;
pub const ENOLINK: u32 = 67;
pub const EADV: u32 = 68;
pub const ESRMNT: u32 = 69;
pub const ECOMM: u32 = 70;
pub const EPROTO: u32 = 71;
pub const EMULTIHOP: u32 = 72;
pub const EDOTDOT: u32 = 73;
pub const EBADMSG: u32 = 74;
pub const EOVERFLOW: u32 = 75;
pub const ENOTUNIQ: u32 = 76;
pub const EBADFD: u32 = 77;
pub const EREMCHG: u32 = 78;
pub const ELIBACC: u32 = 79;
pub const ELIBBAD: u32 = 80;
pub const ELIBSCN: u32 = 81;
pub const ELIBMAX: u32 = 82;
pub const ELIBEXEC: u32 = 83;
pub const EILSEQ: u32 = 84;
pub const ERESTART: u32 = 85;
pub const ESTRPIPE: u32 = 86;
pub const EUSERS: u32 = 87;
pub const ENOTSOCK: u32 = 88;
pub const EDESTADDRREQ: u32 = 89;
pub const EMSGSIZE: u32 = 90;
pub const EPROTOTYPE: u32 = 91;
pub const ENOPROTOOPT: u32 = 92;
pub const EPROTONOSUPPORT: u32 = 93;
pub const ESOCKTNOSUPPORT: u32 = 94;
pub const EOPNOTSUPP: u32 = 95;
pub const EPFNOSUPPORT: u32 = 96;
pub const EAFNOSUPPORT: u32 = 97;
pub const EADDRINUSE: u32 = 98;
pub const EADDRNOTAVAIL: u32 = 99;
pub const ENETDOWN: u32 = 100;
pub const ENETUNREACH: u32 = 101;
pub const ENETRESET: u32 = 102;
pub const ECONNABORTED: u32 = 103;
pub const ECONNRESET: u32 = 104;
pub const ENOBUFS: u32 = 105;
pub const EISCONN: u32 = 106;
pub const ENOTCONN: u32 = 107;
pub const ESHUTDOWN: u32 = 108;
pub const ETOOMANYREFS: u32 = 109;
pub const ETIMEDOUT: u32 = 110;
pub const ECONNREFUSED: u32 = 111;
pub const EHOSTDOWN: u32 = 112;
pub const EHOSTUNREACH: u32 = 113;
pub const EALREADY: u32 = 114;
pub const EINPROGRESS: u32 = 115;
pub const ESTALE: u32 = 116;
pub const EUCLEAN: u32 = 117;
pub const ENOTNAM: u32 = 118;
pub const ENAVAIL: u32 = 119;
pub const EISNAM: u32 = 120;
pub const EREMOTEIO: u32 = 121;
pub const EDQUOT: u32 = 122;
pub const ENOMEDIUM: u32 = 123;
pub const EMEDIUMTYPE: u32 = 124;
pub const ECANCELED: u32 = 125;
pub const ENOKEY: u32 = 126;
pub const EKEYEXPIRED: u32 = 127;
pub const EKEYREVOKED: u32 = 128;
pub const EKEYREJECTED: u32 = 129;
pub const EOWNERDEAD: u32 = 130;
pub const ENOTRECOVERABLE: u32 = 131;
pub const ERFKILL: u32 = 132;
pub const EHWPOISON: u32 = 133;
pub const MAX_ERRNO: u32 = 4095;
pub const KERN_SOH: &[u8; 2] = b"\x01\0";
pub const KERN_SOH_ASCII: u8 = 1u8;
pub const KERN_EMERG: &[u8; 3] = b"\x010\0";
pub const KERN_ALERT: &[u8; 3] = b"\x011\0";
pub const KERN_CRIT: &[u8; 3] = b"\x012\0";
pub const KERN_ERR: &[u8; 3] = b"\x013\0";
pub const KERN_WARNING: &[u8; 3] = b"\x014\0";
pub const KERN_NOTICE: &[u8; 3] = b"\x015\0";
pub const KERN_INFO: &[u8; 3] = b"\x016\0";
pub const KERN_DEBUG: &[u8; 3] = b"\x017\0";
pub const KERN_DEFAULT: &[u8; 1] = b"\0";
pub const KERN_CONT: &[u8; 3] = b"\x01c\0";
pub const LOGLEVEL_SCHED: i32 = -2;
pub const LOGLEVEL_DEFAULT: i32 = -1;
pub const LOGLEVEL_EMERG: u32 = 0;
pub const LOGLEVEL_ALERT: u32 = 1;
pub const LOGLEVEL_CRIT: u32 = 2;
pub const LOGLEVEL_ERR: u32 = 3;
pub const LOGLEVEL_WARNING: u32 = 4;
pub const LOGLEVEL_NOTICE: u32 = 5;
pub const LOGLEVEL_INFO: u32 = 6;
pub const LOGLEVEL_DEBUG: u32 = 7;
pub const BITS_PER_BYTE: u32 = 8;
pub const EXEC_PAGESIZE: u32 = 65536;
pub const HZ: u32 = 100;
pub const NOGROUP: i32 = -1;
pub const MAXHOSTNAMELEN: u32 = 64;
pub const USER_HZ: u32 = 100;
pub const CLOCKS_PER_SEC: u32 = 100;
pub const _Q_LOCKED_OFFSET: u32 = 0;
pub const _Q_LOCKED_BITS: u32 = 8;
pub const _Q_PENDING_OFFSET: u32 = 8;
pub const _Q_PENDING_BITS: u32 = 8;
pub const _Q_TAIL_IDX_OFFSET: u32 = 16;
pub const _Q_TAIL_IDX_BITS: u32 = 2;
pub const _Q_TAIL_CPU_OFFSET: u32 = 18;
pub const _Q_TAIL_CPU_BITS: u32 = 14;
pub const _Q_TAIL_OFFSET: u32 = 16;
pub const _Q_LOCKED_VAL: u32 = 1;
pub const _Q_PENDING_VAL: u32 = 256;
pub const MAX_LOCKDEP_SUBCLASSES: u32 = 8;
pub const SPINLOCK_MAGIC: u32 = 3735899821;
pub const DEFAULT_RATELIMIT_INTERVAL: u32 = 5000;
pub const DEFAULT_RATELIMIT_BURST: u32 = 10;
pub const PRINTK_MAX_SINGLE_HEADER_LEN: u32 = 2;
pub const MESSAGE_LOGLEVEL_DEFAULT: u32 = 4;
pub const CONSOLE_LOGLEVEL_SILENT: u32 = 0;
pub const CONSOLE_LOGLEVEL_MIN: u32 = 1;
pub const CONSOLE_LOGLEVEL_DEBUG: u32 = 10;
pub const CONSOLE_LOGLEVEL_MOTORMOUTH: u32 = 15;
pub const CONSOLE_LOGLEVEL_DEFAULT: u32 = 7;
pub const CONSOLE_LOGLEVEL_QUIET: u32 = 3;
pub const DEVKMSG_STR_MAX_SIZE: u32 = 10;
pub const FW_BUG: &[u8; 17] = b"[Firmware Bug]: \0";
pub const FW_WARN: &[u8; 18] = b"[Firmware Warn]: \0";
pub const FW_INFO: &[u8; 18] = b"[Firmware Info]: \0";
pub const HW_ERR: &[u8; 19] = b"[Hardware Error]: \0";
pub const DEPRECATED: &[u8; 15] = b"[Deprecated]: \0";
pub const KPROBES_BRK_IMM: u32 = 4;
pub const UPROBES_BRK_IMM: u32 = 5;
pub const KPROBES_BRK_SS_IMM: u32 = 6;
pub const KRETPROBES_BRK_IMM: u32 = 7;
pub const FAULT_BRK_IMM: u32 = 256;
pub const KGDB_DYN_DBG_BRK_IMM: u32 = 1024;
pub const KGDB_COMPILED_DBG_BRK_IMM: u32 = 1025;
pub const BUG_BRK_IMM: u32 = 2048;
pub const KASAN_BRK_IMM: u32 = 2304;
pub const KASAN_BRK_MASK: u32 = 255;
pub const UBSAN_BRK_IMM: u32 = 21760;
pub const UBSAN_BRK_MASK: u32 = 255;
pub const CFI_BRK_IMM_BASE: u32 = 32768;
pub const AARCH64_INSN_SIZE: u32 = 4;
pub const AARCH64_BREAK_MON: u32 = 3558866944;
pub const AARCH64_BREAK_FAULT: u32 = 3558875136;
pub const A32_RN_OFFSET: u32 = 16;
pub const A32_RT_OFFSET: u32 = 12;
pub const A32_RT2_OFFSET: u32 = 0;
pub const JUMP_LABEL_NOP_SIZE: u32 = 4;
pub const JUMP_TYPE_FALSE: u32 = 0;
pub const JUMP_TYPE_TRUE: u32 = 1;
pub const JUMP_TYPE_LINKED: u32 = 2;
pub const JUMP_TYPE_MASK: u32 = 3;
pub const CLS_BITS: u32 = 6;
pub const _DPRINTK_CLASS_DFLT: u32 = 63;
pub const _DPRINTK_FLAGS_NONE: u32 = 0;
pub const _DPRINTK_FLAGS_PRINT: u32 = 1;
pub const _DPRINTK_FLAGS_INCL_MODNAME: u32 = 2;
pub const _DPRINTK_FLAGS_INCL_FUNCNAME: u32 = 4;
pub const _DPRINTK_FLAGS_INCL_LINENO: u32 = 8;
pub const _DPRINTK_FLAGS_INCL_TID: u32 = 16;
pub const _DPRINTK_FLAGS_INCL_SOURCENAME: u32 = 32;
pub const _DPRINTK_FLAGS_INCL_ANY: u32 = 62;
pub const _DPRINTK_FLAGS_DEFAULT: u32 = 0;
pub const PREEMPT_BITS: u32 = 8;
pub const SOFTIRQ_BITS: u32 = 8;
pub const HARDIRQ_BITS: u32 = 4;
pub const NMI_BITS: u32 = 4;
pub const PREEMPT_SHIFT: u32 = 0;
pub const SOFTIRQ_SHIFT: u32 = 8;
pub const HARDIRQ_SHIFT: u32 = 16;
pub const NMI_SHIFT: u32 = 20;
pub const PREEMPT_OFFSET: u32 = 1;
pub const SOFTIRQ_OFFSET: u32 = 256;
pub const HARDIRQ_OFFSET: u32 = 65536;
pub const NMI_OFFSET: u32 = 1048576;
pub const SOFTIRQ_DISABLE_OFFSET: u32 = 512;
pub const INIT_PREEMPT_COUNT: u32 = 1;
pub const NR_OPEN: u32 = 1024;
pub const NGROUPS_MAX: u32 = 65536;
pub const ARG_MAX: u32 = 131072;
pub const LINK_MAX: u32 = 127;
pub const MAX_CANON: u32 = 255;
pub const MAX_INPUT: u32 = 255;
pub const NAME_MAX: u32 = 255;
pub const PATH_MAX: u32 = 4096;
pub const PIPE_BUF: u32 = 4096;
pub const XATTR_NAME_MAX: u32 = 255;
pub const XATTR_SIZE_MAX: u32 = 65536;
pub const XATTR_LIST_MAX: u32 = 65536;
pub const RTSIG_MAX: u32 = 32;
pub const UINT_MAX: i32 = -1;
pub const ULONG_MAX: i32 = -1;
pub const ULLONG_MAX: i32 = -1;
pub const UINTPTR_MAX: i32 = -1;
pub const CUT_HERE: &[u8; 38] = b"------------[ cut here ]------------\n\0";
pub const BUGFLAG_WARNING: u32 = 1;
pub const BUGFLAG_ONCE: u32 = 2;
pub const BUGFLAG_DONE: u32 = 4;
pub const BUGFLAG_NO_CUT_HERE: u32 = 8;
pub const PANIC_CPU_INVALID: i32 = -1;
pub const TAINT_PROPRIETARY_MODULE: u32 = 0;
pub const TAINT_FORCED_MODULE: u32 = 1;
pub const TAINT_CPU_OUT_OF_SPEC: u32 = 2;
pub const TAINT_FORCED_RMMOD: u32 = 3;
pub const TAINT_MACHINE_CHECK: u32 = 4;
pub const TAINT_BAD_PAGE: u32 = 5;
pub const TAINT_USER: u32 = 6;
pub const TAINT_DIE: u32 = 7;
pub const TAINT_OVERRIDDEN_ACPI_TABLE: u32 = 8;
pub const TAINT_WARN: u32 = 9;
pub const TAINT_CRAP: u32 = 10;
pub const TAINT_FIRMWARE_WORKAROUND: u32 = 11;
pub const TAINT_OOT_MODULE: u32 = 12;
pub const TAINT_UNSIGNED_MODULE: u32 = 13;
pub const TAINT_SOFTLOCKUP: u32 = 14;
pub const TAINT_LIVEPATCH: u32 = 15;
pub const TAINT_AUX: u32 = 16;
pub const TAINT_RANDSTRUCT: u32 = 17;
pub const TAINT_TEST: u32 = 18;
pub const TAINT_FWCTL: u32 = 19;
pub const TAINT_FLAGS_COUNT: u32 = 20;
pub const TAINT_FLAGS_MAX: u32 = 1048575;
pub const ERESTARTSYS: u32 = 512;
pub const ERESTARTNOINTR: u32 = 513;
pub const ERESTARTNOHAND: u32 = 514;
pub const ENOIOCTLCMD: u32 = 515;
pub const ERESTART_RESTARTBLOCK: u32 = 516;
pub const EPROBE_DEFER: u32 = 517;
pub const EOPENSTALE: u32 = 518;
pub const ENOPARAM: u32 = 519;
pub const EBADHANDLE: u32 = 521;
pub const ENOTSYNC: u32 = 522;
pub const EBADCOOKIE: u32 = 523;
pub const ENOTSUPP: u32 = 524;
pub const ETOOSMALL: u32 = 525;
pub const ESERVERFAULT: u32 = 526;
pub const EBADTYPE: u32 = 527;
pub const EJUKEBOX: u32 = 528;
pub const EIOCBQUEUED: u32 = 529;
pub const ERECALLCONFLICT: u32 = 530;
pub const ENOGRACE: u32 = 531;
pub const SI_LOAD_SHIFT: u32 = 16;
pub const ARM64_ALWAYS_BOOT: u32 = 0;
pub const ARM64_ALWAYS_SYSTEM: u32 = 1;
pub const ARM64_BTI: u32 = 2;
pub const ARM64_HAS_32BIT_EL0_DO_NOT_USE: u32 = 3;
pub const ARM64_HAS_32BIT_EL1: u32 = 4;
pub const ARM64_HAS_ADDRESS_AUTH: u32 = 5;
pub const ARM64_HAS_ADDRESS_AUTH_ARCH_QARMA3: u32 = 6;
pub const ARM64_HAS_ADDRESS_AUTH_ARCH_QARMA5: u32 = 7;
pub const ARM64_HAS_ADDRESS_AUTH_IMP_DEF: u32 = 8;
pub const ARM64_HAS_AMU_EXTN: u32 = 9;
pub const ARM64_HAS_ARMv8_4_TTL: u32 = 10;
pub const ARM64_HAS_CACHE_DIC: u32 = 11;
pub const ARM64_HAS_CACHE_IDC: u32 = 12;
pub const ARM64_HAS_CNP: u32 = 13;
pub const ARM64_HAS_CRC32: u32 = 14;
pub const ARM64_HAS_DCPODP: u32 = 15;
pub const ARM64_HAS_DCPOP: u32 = 16;
pub const ARM64_HAS_DIT: u32 = 17;
pub const ARM64_HAS_E0PD: u32 = 18;
pub const ARM64_HAS_ECV: u32 = 19;
pub const ARM64_HAS_ECV_CNTPOFF: u32 = 20;
pub const ARM64_HAS_EPAN: u32 = 21;
pub const ARM64_HAS_EVT: u32 = 22;
pub const ARM64_HAS_FPMR: u32 = 23;
pub const ARM64_HAS_FGT: u32 = 24;
pub const ARM64_HAS_FPSIMD: u32 = 25;
pub const ARM64_HAS_GCS: u32 = 26;
pub const ARM64_HAS_GENERIC_AUTH: u32 = 27;
pub const ARM64_HAS_GENERIC_AUTH_ARCH_QARMA3: u32 = 28;
pub const ARM64_HAS_GENERIC_AUTH_ARCH_QARMA5: u32 = 29;
pub const ARM64_HAS_GENERIC_AUTH_IMP_DEF: u32 = 30;
pub const ARM64_HAS_GIC_CPUIF_SYSREGS: u32 = 31;
pub const ARM64_HAS_GIC_PRIO_MASKING: u32 = 32;
pub const ARM64_HAS_GIC_PRIO_RELAXED_SYNC: u32 = 33;
pub const ARM64_HAS_HCR_NV1: u32 = 34;
pub const ARM64_HAS_HCX: u32 = 35;
pub const ARM64_HAS_LDAPR: u32 = 36;
pub const ARM64_HAS_LPA2: u32 = 37;
pub const ARM64_HAS_LSE_ATOMICS: u32 = 38;
pub const ARM64_HAS_MOPS: u32 = 39;
pub const ARM64_HAS_NESTED_VIRT: u32 = 40;
pub const ARM64_HAS_PAN: u32 = 41;
pub const ARM64_HAS_PMUV3: u32 = 42;
pub const ARM64_HAS_S1PIE: u32 = 43;
pub const ARM64_HAS_S1POE: u32 = 44;
pub const ARM64_HAS_RAS_EXTN: u32 = 45;
pub const ARM64_HAS_RNG: u32 = 46;
pub const ARM64_HAS_SB: u32 = 47;
pub const ARM64_HAS_STAGE2_FWB: u32 = 48;
pub const ARM64_HAS_TCR2: u32 = 49;
pub const ARM64_HAS_TIDCP1: u32 = 50;
pub const ARM64_HAS_TLB_RANGE: u32 = 51;
pub const ARM64_HAS_VA52: u32 = 52;
pub const ARM64_HAS_VIRT_HOST_EXTN: u32 = 53;
pub const ARM64_HAS_WFXT: u32 = 54;
pub const ARM64_HAFT: u32 = 55;
pub const ARM64_HW_DBM: u32 = 56;
pub const ARM64_KVM_HVHE: u32 = 57;
pub const ARM64_KVM_PROTECTED_MODE: u32 = 58;
pub const ARM64_MISMATCHED_CACHE_TYPE: u32 = 59;
pub const ARM64_MPAM: u32 = 60;
pub const ARM64_MPAM_HCR: u32 = 61;
pub const ARM64_MTE: u32 = 62;
pub const ARM64_MTE_ASYMM: u32 = 63;
pub const ARM64_SME: u32 = 64;
pub const ARM64_SME_FA64: u32 = 65;
pub const ARM64_SME2: u32 = 66;
pub const ARM64_SPECTRE_V2: u32 = 67;
pub const ARM64_SPECTRE_V3A: u32 = 68;
pub const ARM64_SPECTRE_V4: u32 = 69;
pub const ARM64_SPECTRE_BHB: u32 = 70;
pub const ARM64_SSBS: u32 = 71;
pub const ARM64_SVE: u32 = 72;
pub const ARM64_UNMAP_KERNEL_AT_EL0: u32 = 73;
pub const ARM64_WORKAROUND_834220: u32 = 74;
pub const ARM64_WORKAROUND_843419: u32 = 75;
pub const ARM64_WORKAROUND_845719: u32 = 76;
pub const ARM64_WORKAROUND_858921: u32 = 77;
pub const ARM64_WORKAROUND_1418040: u32 = 78;
pub const ARM64_WORKAROUND_1463225: u32 = 79;
pub const ARM64_WORKAROUND_1508412: u32 = 80;
pub const ARM64_WORKAROUND_1542419: u32 = 81;
pub const ARM64_WORKAROUND_1742098: u32 = 82;
pub const ARM64_WORKAROUND_1902691: u32 = 83;
pub const ARM64_WORKAROUND_2038923: u32 = 84;
pub const ARM64_WORKAROUND_2064142: u32 = 85;
pub const ARM64_WORKAROUND_2077057: u32 = 86;
pub const ARM64_WORKAROUND_2457168: u32 = 87;
pub const ARM64_WORKAROUND_2645198: u32 = 88;
pub const ARM64_WORKAROUND_2658417: u32 = 89;
pub const ARM64_WORKAROUND_AMPERE_AC03_CPU_38: u32 = 90;
pub const ARM64_WORKAROUND_TRBE_OVERWRITE_FILL_MODE: u32 = 91;
pub const ARM64_WORKAROUND_TSB_FLUSH_FAILURE: u32 = 92;
pub const ARM64_WORKAROUND_TRBE_WRITE_OUT_OF_RANGE: u32 = 93;
pub const ARM64_WORKAROUND_CAVIUM_23154: u32 = 94;
pub const ARM64_WORKAROUND_CAVIUM_27456: u32 = 95;
pub const ARM64_WORKAROUND_CAVIUM_30115: u32 = 96;
pub const ARM64_WORKAROUND_CAVIUM_TX2_219_PRFM: u32 = 97;
pub const ARM64_WORKAROUND_CAVIUM_TX2_219_TVM: u32 = 98;
pub const ARM64_WORKAROUND_CLEAN_CACHE: u32 = 99;
pub const ARM64_WORKAROUND_DEVICE_LOAD_ACQUIRE: u32 = 100;
pub const ARM64_WORKAROUND_NVIDIA_CARMEL_CNP: u32 = 101;
pub const ARM64_WORKAROUND_PMUV3_IMPDEF_TRAPS: u32 = 102;
pub const ARM64_WORKAROUND_QCOM_FALKOR_E1003: u32 = 103;
pub const ARM64_WORKAROUND_QCOM_ORYON_CNTVOFF: u32 = 104;
pub const ARM64_WORKAROUND_REPEAT_TLBI: u32 = 105;
pub const ARM64_WORKAROUND_SPECULATIVE_AT: u32 = 106;
pub const ARM64_WORKAROUND_SPECULATIVE_SSBS: u32 = 107;
pub const ARM64_WORKAROUND_SPECULATIVE_UNPRIV_LOAD: u32 = 108;
pub const ARM64_NCAPS: u32 = 109;
pub const ARM64_CB_SHIFT: u32 = 15;
pub const __LSE_PREAMBLE: &[u8; 21] = b".arch_extension lse\n\0";
pub const BITOP_LE_SWIZZLE: u32 = 0;
pub const SZ_1: u32 = 1;
pub const SZ_2: u32 = 2;
pub const SZ_4: u32 = 4;
pub const SZ_8: u32 = 8;
pub const SZ_16: u32 = 16;
pub const SZ_32: u32 = 32;
pub const SZ_64: u32 = 64;
pub const SZ_128: u32 = 128;
pub const SZ_256: u32 = 256;
pub const SZ_512: u32 = 512;
pub const SZ_1K: u32 = 1024;
pub const SZ_2K: u32 = 2048;
pub const SZ_4K: u32 = 4096;
pub const SZ_8K: u32 = 8192;
pub const SZ_16K: u32 = 16384;
pub const SZ_24K: u32 = 24576;
pub const SZ_32K: u32 = 32768;
pub const SZ_64K: u32 = 65536;
pub const SZ_128K: u32 = 131072;
pub const SZ_192K: u32 = 196608;
pub const SZ_256K: u32 = 262144;
pub const SZ_384K: u32 = 393216;
pub const SZ_512K: u32 = 524288;
pub const SZ_1M: u32 = 1048576;
pub const SZ_2M: u32 = 2097152;
pub const SZ_3M: u32 = 3145728;
pub const SZ_4M: u32 = 4194304;
pub const SZ_6M: u32 = 6291456;
pub const SZ_8M: u32 = 8388608;
pub const SZ_12M: u32 = 12582912;
pub const SZ_16M: u32 = 16777216;
pub const SZ_18M: u32 = 18874368;
pub const SZ_24M: u32 = 25165824;
pub const SZ_32M: u32 = 33554432;
pub const SZ_64M: u32 = 67108864;
pub const SZ_128M: u32 = 134217728;
pub const SZ_256M: u32 = 268435456;
pub const SZ_512M: u32 = 536870912;
pub const SZ_1G: u32 = 1073741824;
pub const SZ_2G: u32 = 2147483648;
pub const PAGE_SHIFT: u32 = 12;
pub const PCI_IO_SIZE: u32 = 16777216;
pub const VA_BITS: u32 = 48;
pub const MODULES_VSIZE: u32 = 2147483648;
pub const VA_BITS_MIN: u32 = 48;
pub const KASAN_THREAD_SHIFT: u32 = 0;
pub const MIN_THREAD_SHIFT: u32 = 14;
pub const THREAD_SHIFT: u32 = 14;
pub const THREAD_SIZE_ORDER: u32 = 2;
pub const OVERFLOW_STACK_SIZE: u32 = 4096;
pub const NVHE_STACK_SHIFT: u32 = 12;
pub const SEGMENT_ALIGN: u32 = 65536;
pub const MT_NORMAL: u32 = 0;
pub const MT_NORMAL_TAGGED: u32 = 1;
pub const MT_NORMAL_NC: u32 = 2;
pub const MT_DEVICE_nGnRnE: u32 = 3;
pub const MT_DEVICE_nGnRE: u32 = 4;
pub const MT_S2_NORMAL: u32 = 15;
pub const MT_S2_NORMAL_NC: u32 = 5;
pub const MT_S2_DEVICE_nGnRE: u32 = 1;
pub const MT_S2_FWB_NORMAL: u32 = 6;
pub const MT_S2_FWB_NORMAL_NC: u32 = 5;
pub const MT_S2_FWB_DEVICE_nGnRE: u32 = 1;
pub const LINUX_MM_DEBUG_H: u32 = 1;
pub const MIN_FDT_ALIGN: u32 = 8;
pub const MAX_FDT_SIZE: u32 = 2097152;
pub const MIN_KIMG_ALIGN: u32 = 2097152;
pub const KASAN_TAG_KERNEL: u32 = 255;
pub const KASAN_TAG_INVALID: u32 = 254;
pub const KASAN_TAG_MAX: u32 = 253;
pub const KASAN_TAG_MIN: u32 = 0;
pub const Op0_shift: u32 = 19;
pub const Op0_mask: u32 = 3;
pub const Op1_shift: u32 = 16;
pub const Op1_mask: u32 = 7;
pub const CRn_shift: u32 = 12;
pub const CRn_mask: u32 = 15;
pub const CRm_shift: u32 = 8;
pub const CRm_mask: u32 = 15;
pub const Op2_shift: u32 = 5;
pub const Op2_mask: u32 = 7;
pub const PSTATE_Imm_shift: u32 = 8;
pub const SYS_OSDTRRX_EL1_Op0: u32 = 2;
pub const SYS_OSDTRRX_EL1_Op1: u32 = 0;
pub const SYS_OSDTRRX_EL1_CRn: u32 = 0;
pub const SYS_OSDTRRX_EL1_CRm: u32 = 0;
pub const SYS_OSDTRRX_EL1_Op2: u32 = 2;
pub const OSDTRRX_EL1_DTRRX_SHIFT: u32 = 0;
pub const OSDTRRX_EL1_DTRRX_WIDTH: u32 = 32;
pub const SYS_MDCCINT_EL1_Op0: u32 = 2;
pub const SYS_MDCCINT_EL1_Op1: u32 = 0;
pub const SYS_MDCCINT_EL1_CRn: u32 = 0;
pub const SYS_MDCCINT_EL1_CRm: u32 = 2;
pub const SYS_MDCCINT_EL1_Op2: u32 = 0;
pub const MDCCINT_EL1_RX_SHIFT: u32 = 30;
pub const MDCCINT_EL1_RX_WIDTH: u32 = 1;
pub const MDCCINT_EL1_TX_SHIFT: u32 = 29;
pub const MDCCINT_EL1_TX_WIDTH: u32 = 1;
pub const SYS_MDSCR_EL1_Op0: u32 = 2;
pub const SYS_MDSCR_EL1_Op1: u32 = 0;
pub const SYS_MDSCR_EL1_CRn: u32 = 0;
pub const SYS_MDSCR_EL1_CRm: u32 = 2;
pub const SYS_MDSCR_EL1_Op2: u32 = 2;
pub const MDSCR_EL1_EHBWE_SHIFT: u32 = 35;
pub const MDSCR_EL1_EHBWE_WIDTH: u32 = 1;
pub const MDSCR_EL1_EnSPM_SHIFT: u32 = 34;
pub const MDSCR_EL1_EnSPM_WIDTH: u32 = 1;
pub const MDSCR_EL1_TTA_SHIFT: u32 = 33;
pub const MDSCR_EL1_TTA_WIDTH: u32 = 1;
pub const MDSCR_EL1_EMBWE_SHIFT: u32 = 32;
pub const MDSCR_EL1_EMBWE_WIDTH: u32 = 1;
pub const MDSCR_EL1_TFO_SHIFT: u32 = 31;
pub const MDSCR_EL1_TFO_WIDTH: u32 = 1;
pub const MDSCR_EL1_RXfull_SHIFT: u32 = 30;
pub const MDSCR_EL1_RXfull_WIDTH: u32 = 1;
pub const MDSCR_EL1_TXfull_SHIFT: u32 = 29;
pub const MDSCR_EL1_TXfull_WIDTH: u32 = 1;
pub const MDSCR_EL1_RXO_SHIFT: u32 = 27;
pub const MDSCR_EL1_RXO_WIDTH: u32 = 1;
pub const MDSCR_EL1_TXU_SHIFT: u32 = 26;
pub const MDSCR_EL1_TXU_WIDTH: u32 = 1;
pub const MDSCR_EL1_INTdis_SHIFT: u32 = 22;
pub const MDSCR_EL1_INTdis_WIDTH: u32 = 2;
pub const MDSCR_EL1_TDA_SHIFT: u32 = 21;
pub const MDSCR_EL1_TDA_WIDTH: u32 = 1;
pub const MDSCR_EL1_SC2_SHIFT: u32 = 19;
pub const MDSCR_EL1_SC2_WIDTH: u32 = 1;
pub const MDSCR_EL1_MDE_SHIFT: u32 = 15;
pub const MDSCR_EL1_MDE_WIDTH: u32 = 1;
pub const MDSCR_EL1_HDE_SHIFT: u32 = 14;
pub const MDSCR_EL1_HDE_WIDTH: u32 = 1;
pub const MDSCR_EL1_KDE_SHIFT: u32 = 13;
pub const MDSCR_EL1_KDE_WIDTH: u32 = 1;
pub const MDSCR_EL1_TDCC_SHIFT: u32 = 12;
pub const MDSCR_EL1_TDCC_WIDTH: u32 = 1;
pub const MDSCR_EL1_ERR_SHIFT: u32 = 6;
pub const MDSCR_EL1_ERR_WIDTH: u32 = 1;
pub const MDSCR_EL1_SS_SHIFT: u32 = 0;
pub const MDSCR_EL1_SS_WIDTH: u32 = 1;
pub const SYS_OSDTRTX_EL1_Op0: u32 = 2;
pub const SYS_OSDTRTX_EL1_Op1: u32 = 0;
pub const SYS_OSDTRTX_EL1_CRn: u32 = 0;
pub const SYS_OSDTRTX_EL1_CRm: u32 = 3;
pub const SYS_OSDTRTX_EL1_Op2: u32 = 2;
pub const OSDTRTX_EL1_DTRTX_SHIFT: u32 = 0;
pub const OSDTRTX_EL1_DTRTX_WIDTH: u32 = 32;
pub const SYS_OSECCR_EL1_Op0: u32 = 2;
pub const SYS_OSECCR_EL1_Op1: u32 = 0;
pub const SYS_OSECCR_EL1_CRn: u32 = 0;
pub const SYS_OSECCR_EL1_CRm: u32 = 6;
pub const SYS_OSECCR_EL1_Op2: u32 = 2;
pub const OSECCR_EL1_EDECCR_SHIFT: u32 = 0;
pub const OSECCR_EL1_EDECCR_WIDTH: u32 = 32;
pub const SYS_OSLAR_EL1_Op0: u32 = 2;
pub const SYS_OSLAR_EL1_Op1: u32 = 0;
pub const SYS_OSLAR_EL1_CRn: u32 = 1;
pub const SYS_OSLAR_EL1_CRm: u32 = 0;
pub const SYS_OSLAR_EL1_Op2: u32 = 4;
pub const OSLAR_EL1_OSLK_SHIFT: u32 = 0;
pub const OSLAR_EL1_OSLK_WIDTH: u32 = 1;
pub const SYS_ID_PFR0_EL1_Op0: u32 = 3;
pub const SYS_ID_PFR0_EL1_Op1: u32 = 0;
pub const SYS_ID_PFR0_EL1_CRn: u32 = 0;
pub const SYS_ID_PFR0_EL1_CRm: u32 = 1;
pub const SYS_ID_PFR0_EL1_Op2: u32 = 0;
pub const ID_PFR0_EL1_RAS_SHIFT: u32 = 28;
pub const ID_PFR0_EL1_RAS_WIDTH: u32 = 4;
pub const ID_PFR0_EL1_DIT_SHIFT: u32 = 24;
pub const ID_PFR0_EL1_DIT_WIDTH: u32 = 4;
pub const ID_PFR0_EL1_AMU_SHIFT: u32 = 20;
pub const ID_PFR0_EL1_AMU_WIDTH: u32 = 4;
pub const ID_PFR0_EL1_CSV2_SHIFT: u32 = 16;
pub const ID_PFR0_EL1_CSV2_WIDTH: u32 = 4;
pub const ID_PFR0_EL1_State3_SHIFT: u32 = 12;
pub const ID_PFR0_EL1_State3_WIDTH: u32 = 4;
pub const ID_PFR0_EL1_State2_SHIFT: u32 = 8;
pub const ID_PFR0_EL1_State2_WIDTH: u32 = 4;
pub const ID_PFR0_EL1_State1_SHIFT: u32 = 4;
pub const ID_PFR0_EL1_State1_WIDTH: u32 = 4;
pub const ID_PFR0_EL1_State0_SHIFT: u32 = 0;
pub const ID_PFR0_EL1_State0_WIDTH: u32 = 4;
pub const SYS_ID_PFR1_EL1_Op0: u32 = 3;
pub const SYS_ID_PFR1_EL1_Op1: u32 = 0;
pub const SYS_ID_PFR1_EL1_CRn: u32 = 0;
pub const SYS_ID_PFR1_EL1_CRm: u32 = 1;
pub const SYS_ID_PFR1_EL1_Op2: u32 = 1;
pub const ID_PFR1_EL1_GIC_SHIFT: u32 = 28;
pub const ID_PFR1_EL1_GIC_WIDTH: u32 = 4;
pub const ID_PFR1_EL1_Virt_frac_SHIFT: u32 = 24;
pub const ID_PFR1_EL1_Virt_frac_WIDTH: u32 = 4;
pub const ID_PFR1_EL1_Sec_frac_SHIFT: u32 = 20;
pub const ID_PFR1_EL1_Sec_frac_WIDTH: u32 = 4;
pub const ID_PFR1_EL1_GenTimer_SHIFT: u32 = 16;
pub const ID_PFR1_EL1_GenTimer_WIDTH: u32 = 4;
pub const ID_PFR1_EL1_Virtualization_SHIFT: u32 = 12;
pub const ID_PFR1_EL1_Virtualization_WIDTH: u32 = 4;
pub const ID_PFR1_EL1_MProgMod_SHIFT: u32 = 8;
pub const ID_PFR1_EL1_MProgMod_WIDTH: u32 = 4;
pub const ID_PFR1_EL1_Security_SHIFT: u32 = 4;
pub const ID_PFR1_EL1_Security_WIDTH: u32 = 4;
pub const ID_PFR1_EL1_ProgMod_SHIFT: u32 = 0;
pub const ID_PFR1_EL1_ProgMod_WIDTH: u32 = 4;
pub const SYS_ID_DFR0_EL1_Op0: u32 = 3;
pub const SYS_ID_DFR0_EL1_Op1: u32 = 0;
pub const SYS_ID_DFR0_EL1_CRn: u32 = 0;
pub const SYS_ID_DFR0_EL1_CRm: u32 = 1;
pub const SYS_ID_DFR0_EL1_Op2: u32 = 2;
pub const ID_DFR0_EL1_TraceFilt_SHIFT: u32 = 28;
pub const ID_DFR0_EL1_TraceFilt_WIDTH: u32 = 4;
pub const ID_DFR0_EL1_PerfMon_SHIFT: u32 = 24;
pub const ID_DFR0_EL1_PerfMon_WIDTH: u32 = 4;
pub const ID_DFR0_EL1_MProfDbg_SHIFT: u32 = 20;
pub const ID_DFR0_EL1_MProfDbg_WIDTH: u32 = 4;
pub const ID_DFR0_EL1_MMapTrc_SHIFT: u32 = 16;
pub const ID_DFR0_EL1_MMapTrc_WIDTH: u32 = 4;
pub const ID_DFR0_EL1_CopTrc_SHIFT: u32 = 12;
pub const ID_DFR0_EL1_CopTrc_WIDTH: u32 = 4;
pub const ID_DFR0_EL1_MMapDbg_SHIFT: u32 = 8;
pub const ID_DFR0_EL1_MMapDbg_WIDTH: u32 = 4;
pub const ID_DFR0_EL1_CopSDbg_SHIFT: u32 = 4;
pub const ID_DFR0_EL1_CopSDbg_WIDTH: u32 = 4;
pub const ID_DFR0_EL1_CopDbg_SHIFT: u32 = 0;
pub const ID_DFR0_EL1_CopDbg_WIDTH: u32 = 4;
pub const SYS_ID_AFR0_EL1_Op0: u32 = 3;
pub const SYS_ID_AFR0_EL1_Op1: u32 = 0;
pub const SYS_ID_AFR0_EL1_CRn: u32 = 0;
pub const SYS_ID_AFR0_EL1_CRm: u32 = 1;
pub const SYS_ID_AFR0_EL1_Op2: u32 = 3;
pub const ID_AFR0_EL1_IMPDEF3_SHIFT: u32 = 12;
pub const ID_AFR0_EL1_IMPDEF3_WIDTH: u32 = 4;
pub const ID_AFR0_EL1_IMPDEF2_SHIFT: u32 = 8;
pub const ID_AFR0_EL1_IMPDEF2_WIDTH: u32 = 4;
pub const ID_AFR0_EL1_IMPDEF1_SHIFT: u32 = 4;
pub const ID_AFR0_EL1_IMPDEF1_WIDTH: u32 = 4;
pub const ID_AFR0_EL1_IMPDEF0_SHIFT: u32 = 0;
pub const ID_AFR0_EL1_IMPDEF0_WIDTH: u32 = 4;
pub const SYS_ID_MMFR0_EL1_Op0: u32 = 3;
pub const SYS_ID_MMFR0_EL1_Op1: u32 = 0;
pub const SYS_ID_MMFR0_EL1_CRn: u32 = 0;
pub const SYS_ID_MMFR0_EL1_CRm: u32 = 1;
pub const SYS_ID_MMFR0_EL1_Op2: u32 = 4;
pub const ID_MMFR0_EL1_InnerShr_SHIFT: u32 = 28;
pub const ID_MMFR0_EL1_InnerShr_WIDTH: u32 = 4;
pub const ID_MMFR0_EL1_FCSE_SHIFT: u32 = 24;
pub const ID_MMFR0_EL1_FCSE_WIDTH: u32 = 4;
pub const ID_MMFR0_EL1_AuxReg_SHIFT: u32 = 20;
pub const ID_MMFR0_EL1_AuxReg_WIDTH: u32 = 4;
pub const ID_MMFR0_EL1_TCM_SHIFT: u32 = 16;
pub const ID_MMFR0_EL1_TCM_WIDTH: u32 = 4;
pub const ID_MMFR0_EL1_ShareLvl_SHIFT: u32 = 12;
pub const ID_MMFR0_EL1_ShareLvl_WIDTH: u32 = 4;
pub const ID_MMFR0_EL1_OuterShr_SHIFT: u32 = 8;
pub const ID_MMFR0_EL1_OuterShr_WIDTH: u32 = 4;
pub const ID_MMFR0_EL1_PMSA_SHIFT: u32 = 4;
pub const ID_MMFR0_EL1_PMSA_WIDTH: u32 = 4;
pub const ID_MMFR0_EL1_VMSA_SHIFT: u32 = 0;
pub const ID_MMFR0_EL1_VMSA_WIDTH: u32 = 4;
pub const SYS_ID_MMFR1_EL1_Op0: u32 = 3;
pub const SYS_ID_MMFR1_EL1_Op1: u32 = 0;
pub const SYS_ID_MMFR1_EL1_CRn: u32 = 0;
pub const SYS_ID_MMFR1_EL1_CRm: u32 = 1;
pub const SYS_ID_MMFR1_EL1_Op2: u32 = 5;
pub const ID_MMFR1_EL1_BPred_SHIFT: u32 = 28;
pub const ID_MMFR1_EL1_BPred_WIDTH: u32 = 4;
pub const ID_MMFR1_EL1_L1TstCln_SHIFT: u32 = 24;
pub const ID_MMFR1_EL1_L1TstCln_WIDTH: u32 = 4;
pub const ID_MMFR1_EL1_L1Uni_SHIFT: u32 = 20;
pub const ID_MMFR1_EL1_L1Uni_WIDTH: u32 = 4;
pub const ID_MMFR1_EL1_L1Hvd_SHIFT: u32 = 16;
pub const ID_MMFR1_EL1_L1Hvd_WIDTH: u32 = 4;
pub const ID_MMFR1_EL1_L1UniSW_SHIFT: u32 = 12;
pub const ID_MMFR1_EL1_L1UniSW_WIDTH: u32 = 4;
pub const ID_MMFR1_EL1_L1HvdSW_SHIFT: u32 = 8;
pub const ID_MMFR1_EL1_L1HvdSW_WIDTH: u32 = 4;
pub const ID_MMFR1_EL1_L1UniVA_SHIFT: u32 = 4;
pub const ID_MMFR1_EL1_L1UniVA_WIDTH: u32 = 4;
pub const ID_MMFR1_EL1_L1HvdVA_SHIFT: u32 = 0;
pub const ID_MMFR1_EL1_L1HvdVA_WIDTH: u32 = 4;
pub const SYS_ID_MMFR2_EL1_Op0: u32 = 3;
pub const SYS_ID_MMFR2_EL1_Op1: u32 = 0;
pub const SYS_ID_MMFR2_EL1_CRn: u32 = 0;
pub const SYS_ID_MMFR2_EL1_CRm: u32 = 1;
pub const SYS_ID_MMFR2_EL1_Op2: u32 = 6;
pub const ID_MMFR2_EL1_HWAccFlg_SHIFT: u32 = 28;
pub const ID_MMFR2_EL1_HWAccFlg_WIDTH: u32 = 4;
pub const ID_MMFR2_EL1_WFIStall_SHIFT: u32 = 24;
pub const ID_MMFR2_EL1_WFIStall_WIDTH: u32 = 4;
pub const ID_MMFR2_EL1_MemBarr_SHIFT: u32 = 20;
pub const ID_MMFR2_EL1_MemBarr_WIDTH: u32 = 4;
pub const ID_MMFR2_EL1_UniTLB_SHIFT: u32 = 16;
pub const ID_MMFR2_EL1_UniTLB_WIDTH: u32 = 4;
pub const ID_MMFR2_EL1_HvdTLB_SHIFT: u32 = 12;
pub const ID_MMFR2_EL1_HvdTLB_WIDTH: u32 = 4;
pub const ID_MMFR2_EL1_L1HvdRng_SHIFT: u32 = 8;
pub const ID_MMFR2_EL1_L1HvdRng_WIDTH: u32 = 4;
pub const ID_MMFR2_EL1_L1HvdBG_SHIFT: u32 = 4;
pub const ID_MMFR2_EL1_L1HvdBG_WIDTH: u32 = 4;
pub const ID_MMFR2_EL1_L1HvdFG_SHIFT: u32 = 0;
pub const ID_MMFR2_EL1_L1HvdFG_WIDTH: u32 = 4;
pub const SYS_ID_MMFR3_EL1_Op0: u32 = 3;
pub const SYS_ID_MMFR3_EL1_Op1: u32 = 0;
pub const SYS_ID_MMFR3_EL1_CRn: u32 = 0;
pub const SYS_ID_MMFR3_EL1_CRm: u32 = 1;
pub const SYS_ID_MMFR3_EL1_Op2: u32 = 7;
pub const ID_MMFR3_EL1_Supersec_SHIFT: u32 = 28;
pub const ID_MMFR3_EL1_Supersec_WIDTH: u32 = 4;
pub const ID_MMFR3_EL1_CMemSz_SHIFT: u32 = 24;
pub const ID_MMFR3_EL1_CMemSz_WIDTH: u32 = 4;
pub const ID_MMFR3_EL1_CohWalk_SHIFT: u32 = 20;
pub const ID_MMFR3_EL1_CohWalk_WIDTH: u32 = 4;
pub const ID_MMFR3_EL1_PAN_SHIFT: u32 = 16;
pub const ID_MMFR3_EL1_PAN_WIDTH: u32 = 4;
pub const ID_MMFR3_EL1_MaintBcst_SHIFT: u32 = 12;
pub const ID_MMFR3_EL1_MaintBcst_WIDTH: u32 = 4;
pub const ID_MMFR3_EL1_BPMaint_SHIFT: u32 = 8;
pub const ID_MMFR3_EL1_BPMaint_WIDTH: u32 = 4;
pub const ID_MMFR3_EL1_CMaintSW_SHIFT: u32 = 4;
pub const ID_MMFR3_EL1_CMaintSW_WIDTH: u32 = 4;
pub const ID_MMFR3_EL1_CMaintVA_SHIFT: u32 = 0;
pub const ID_MMFR3_EL1_CMaintVA_WIDTH: u32 = 4;
pub const SYS_ID_ISAR0_EL1_Op0: u32 = 3;
pub const SYS_ID_ISAR0_EL1_Op1: u32 = 0;
pub const SYS_ID_ISAR0_EL1_CRn: u32 = 0;
pub const SYS_ID_ISAR0_EL1_CRm: u32 = 2;
pub const SYS_ID_ISAR0_EL1_Op2: u32 = 0;
pub const ID_ISAR0_EL1_Divide_SHIFT: u32 = 24;
pub const ID_ISAR0_EL1_Divide_WIDTH: u32 = 4;
pub const ID_ISAR0_EL1_Debug_SHIFT: u32 = 20;
pub const ID_ISAR0_EL1_Debug_WIDTH: u32 = 4;
pub const ID_ISAR0_EL1_Coproc_SHIFT: u32 = 16;
pub const ID_ISAR0_EL1_Coproc_WIDTH: u32 = 4;
pub const ID_ISAR0_EL1_CmpBranch_SHIFT: u32 = 12;
pub const ID_ISAR0_EL1_CmpBranch_WIDTH: u32 = 4;
pub const ID_ISAR0_EL1_BitField_SHIFT: u32 = 8;
pub const ID_ISAR0_EL1_BitField_WIDTH: u32 = 4;
pub const ID_ISAR0_EL1_BitCount_SHIFT: u32 = 4;
pub const ID_ISAR0_EL1_BitCount_WIDTH: u32 = 4;
pub const ID_ISAR0_EL1_Swap_SHIFT: u32 = 0;
pub const ID_ISAR0_EL1_Swap_WIDTH: u32 = 4;
pub const SYS_ID_ISAR1_EL1_Op0: u32 = 3;
pub const SYS_ID_ISAR1_EL1_Op1: u32 = 0;
pub const SYS_ID_ISAR1_EL1_CRn: u32 = 0;
pub const SYS_ID_ISAR1_EL1_CRm: u32 = 2;
pub const SYS_ID_ISAR1_EL1_Op2: u32 = 1;
pub const ID_ISAR1_EL1_Jazelle_SHIFT: u32 = 28;
pub const ID_ISAR1_EL1_Jazelle_WIDTH: u32 = 4;
pub const ID_ISAR1_EL1_Interwork_SHIFT: u32 = 24;
pub const ID_ISAR1_EL1_Interwork_WIDTH: u32 = 4;
pub const ID_ISAR1_EL1_Immediate_SHIFT: u32 = 20;
pub const ID_ISAR1_EL1_Immediate_WIDTH: u32 = 4;
pub const ID_ISAR1_EL1_IfThen_SHIFT: u32 = 16;
pub const ID_ISAR1_EL1_IfThen_WIDTH: u32 = 4;
pub const ID_ISAR1_EL1_Extend_SHIFT: u32 = 12;
pub const ID_ISAR1_EL1_Extend_WIDTH: u32 = 4;
pub const ID_ISAR1_EL1_Except_AR_SHIFT: u32 = 8;
pub const ID_ISAR1_EL1_Except_AR_WIDTH: u32 = 4;
pub const ID_ISAR1_EL1_Except_SHIFT: u32 = 4;
pub const ID_ISAR1_EL1_Except_WIDTH: u32 = 4;
pub const ID_ISAR1_EL1_Endian_SHIFT: u32 = 0;
pub const ID_ISAR1_EL1_Endian_WIDTH: u32 = 4;
pub const SYS_ID_ISAR2_EL1_Op0: u32 = 3;
pub const SYS_ID_ISAR2_EL1_Op1: u32 = 0;
pub const SYS_ID_ISAR2_EL1_CRn: u32 = 0;
pub const SYS_ID_ISAR2_EL1_CRm: u32 = 2;
pub const SYS_ID_ISAR2_EL1_Op2: u32 = 2;
pub const ID_ISAR2_EL1_Reversal_SHIFT: u32 = 28;
pub const ID_ISAR2_EL1_Reversal_WIDTH: u32 = 4;
pub const ID_ISAR2_EL1_PSR_AR_SHIFT: u32 = 24;
pub const ID_ISAR2_EL1_PSR_AR_WIDTH: u32 = 4;
pub const ID_ISAR2_EL1_MultU_SHIFT: u32 = 20;
pub const ID_ISAR2_EL1_MultU_WIDTH: u32 = 4;
pub const ID_ISAR2_EL1_MultS_SHIFT: u32 = 16;
pub const ID_ISAR2_EL1_MultS_WIDTH: u32 = 4;
pub const ID_ISAR2_EL1_Mult_SHIFT: u32 = 12;
pub const ID_ISAR2_EL1_Mult_WIDTH: u32 = 4;
pub const ID_ISAR2_EL1_MultiAccessInt_SHIFT: u32 = 8;
pub const ID_ISAR2_EL1_MultiAccessInt_WIDTH: u32 = 4;
pub const ID_ISAR2_EL1_MemHint_SHIFT: u32 = 4;
pub const ID_ISAR2_EL1_MemHint_WIDTH: u32 = 4;
pub const ID_ISAR2_EL1_LoadStore_SHIFT: u32 = 0;
pub const ID_ISAR2_EL1_LoadStore_WIDTH: u32 = 4;
pub const SYS_ID_ISAR3_EL1_Op0: u32 = 3;
pub const SYS_ID_ISAR3_EL1_Op1: u32 = 0;
pub const SYS_ID_ISAR3_EL1_CRn: u32 = 0;
pub const SYS_ID_ISAR3_EL1_CRm: u32 = 2;
pub const SYS_ID_ISAR3_EL1_Op2: u32 = 3;
pub const ID_ISAR3_EL1_T32EE_SHIFT: u32 = 28;
pub const ID_ISAR3_EL1_T32EE_WIDTH: u32 = 4;
pub const ID_ISAR3_EL1_TrueNOP_SHIFT: u32 = 24;
pub const ID_ISAR3_EL1_TrueNOP_WIDTH: u32 = 4;
pub const ID_ISAR3_EL1_T32Copy_SHIFT: u32 = 20;
pub const ID_ISAR3_EL1_T32Copy_WIDTH: u32 = 4;
pub const ID_ISAR3_EL1_TabBranch_SHIFT: u32 = 16;
pub const ID_ISAR3_EL1_TabBranch_WIDTH: u32 = 4;
pub const ID_ISAR3_EL1_SynchPrim_SHIFT: u32 = 12;
pub const ID_ISAR3_EL1_SynchPrim_WIDTH: u32 = 4;
pub const ID_ISAR3_EL1_SVC_SHIFT: u32 = 8;
pub const ID_ISAR3_EL1_SVC_WIDTH: u32 = 4;
pub const ID_ISAR3_EL1_SIMD_SHIFT: u32 = 4;
pub const ID_ISAR3_EL1_SIMD_WIDTH: u32 = 4;
pub const ID_ISAR3_EL1_Saturate_SHIFT: u32 = 0;
pub const ID_ISAR3_EL1_Saturate_WIDTH: u32 = 4;
pub const SYS_ID_ISAR4_EL1_Op0: u32 = 3;
pub const SYS_ID_ISAR4_EL1_Op1: u32 = 0;
pub const SYS_ID_ISAR4_EL1_CRn: u32 = 0;
pub const SYS_ID_ISAR4_EL1_CRm: u32 = 2;
pub const SYS_ID_ISAR4_EL1_Op2: u32 = 4;
pub const ID_ISAR4_EL1_SWP_frac_SHIFT: u32 = 28;
pub const ID_ISAR4_EL1_SWP_frac_WIDTH: u32 = 4;
pub const ID_ISAR4_EL1_PSR_M_SHIFT: u32 = 24;
pub const ID_ISAR4_EL1_PSR_M_WIDTH: u32 = 4;
pub const ID_ISAR4_EL1_SynchPrim_frac_SHIFT: u32 = 20;
pub const ID_ISAR4_EL1_SynchPrim_frac_WIDTH: u32 = 4;
pub const ID_ISAR4_EL1_Barrier_SHIFT: u32 = 16;
pub const ID_ISAR4_EL1_Barrier_WIDTH: u32 = 4;
pub const ID_ISAR4_EL1_SMC_SHIFT: u32 = 12;
pub const ID_ISAR4_EL1_SMC_WIDTH: u32 = 4;
pub const ID_ISAR4_EL1_Writeback_SHIFT: u32 = 8;
pub const ID_ISAR4_EL1_Writeback_WIDTH: u32 = 4;
pub const ID_ISAR4_EL1_WithShifts_SHIFT: u32 = 4;
pub const ID_ISAR4_EL1_WithShifts_WIDTH: u32 = 4;
pub const ID_ISAR4_EL1_Unpriv_SHIFT: u32 = 0;
pub const ID_ISAR4_EL1_Unpriv_WIDTH: u32 = 4;
pub const SYS_ID_ISAR5_EL1_Op0: u32 = 3;
pub const SYS_ID_ISAR5_EL1_Op1: u32 = 0;
pub const SYS_ID_ISAR5_EL1_CRn: u32 = 0;
pub const SYS_ID_ISAR5_EL1_CRm: u32 = 2;
pub const SYS_ID_ISAR5_EL1_Op2: u32 = 5;
pub const ID_ISAR5_EL1_VCMA_SHIFT: u32 = 28;
pub const ID_ISAR5_EL1_VCMA_WIDTH: u32 = 4;
pub const ID_ISAR5_EL1_RDM_SHIFT: u32 = 24;
pub const ID_ISAR5_EL1_RDM_WIDTH: u32 = 4;
pub const ID_ISAR5_EL1_CRC32_SHIFT: u32 = 16;
pub const ID_ISAR5_EL1_CRC32_WIDTH: u32 = 4;
pub const ID_ISAR5_EL1_SHA2_SHIFT: u32 = 12;
pub const ID_ISAR5_EL1_SHA2_WIDTH: u32 = 4;
pub const ID_ISAR5_EL1_SHA1_SHIFT: u32 = 8;
pub const ID_ISAR5_EL1_SHA1_WIDTH: u32 = 4;
pub const ID_ISAR5_EL1_AES_SHIFT: u32 = 4;
pub const ID_ISAR5_EL1_AES_WIDTH: u32 = 4;
pub const ID_ISAR5_EL1_SEVL_SHIFT: u32 = 0;
pub const ID_ISAR5_EL1_SEVL_WIDTH: u32 = 4;
pub const SYS_ID_ISAR6_EL1_Op0: u32 = 3;
pub const SYS_ID_ISAR6_EL1_Op1: u32 = 0;
pub const SYS_ID_ISAR6_EL1_CRn: u32 = 0;
pub const SYS_ID_ISAR6_EL1_CRm: u32 = 2;
pub const SYS_ID_ISAR6_EL1_Op2: u32 = 7;
pub const ID_ISAR6_EL1_I8MM_SHIFT: u32 = 24;
pub const ID_ISAR6_EL1_I8MM_WIDTH: u32 = 4;
pub const ID_ISAR6_EL1_BF16_SHIFT: u32 = 20;
pub const ID_ISAR6_EL1_BF16_WIDTH: u32 = 4;
pub const ID_ISAR6_EL1_SPECRES_SHIFT: u32 = 16;
pub const ID_ISAR6_EL1_SPECRES_WIDTH: u32 = 4;
pub const ID_ISAR6_EL1_SB_SHIFT: u32 = 12;
pub const ID_ISAR6_EL1_SB_WIDTH: u32 = 4;
pub const ID_ISAR6_EL1_FHM_SHIFT: u32 = 8;
pub const ID_ISAR6_EL1_FHM_WIDTH: u32 = 4;
pub const ID_ISAR6_EL1_DP_SHIFT: u32 = 4;
pub const ID_ISAR6_EL1_DP_WIDTH: u32 = 4;
pub const ID_ISAR6_EL1_JSCVT_SHIFT: u32 = 0;
pub const ID_ISAR6_EL1_JSCVT_WIDTH: u32 = 4;
pub const SYS_ID_MMFR4_EL1_Op0: u32 = 3;
pub const SYS_ID_MMFR4_EL1_Op1: u32 = 0;
pub const SYS_ID_MMFR4_EL1_CRn: u32 = 0;
pub const SYS_ID_MMFR4_EL1_CRm: u32 = 2;
pub const SYS_ID_MMFR4_EL1_Op2: u32 = 6;
pub const ID_MMFR4_EL1_EVT_SHIFT: u32 = 28;
pub const ID_MMFR4_EL1_EVT_WIDTH: u32 = 4;
pub const ID_MMFR4_EL1_CCIDX_SHIFT: u32 = 24;
pub const ID_MMFR4_EL1_CCIDX_WIDTH: u32 = 4;
pub const ID_MMFR4_EL1_LSM_SHIFT: u32 = 20;
pub const ID_MMFR4_EL1_LSM_WIDTH: u32 = 4;
pub const ID_MMFR4_EL1_HPDS_SHIFT: u32 = 16;
pub const ID_MMFR4_EL1_HPDS_WIDTH: u32 = 4;
pub const ID_MMFR4_EL1_CnP_SHIFT: u32 = 12;
pub const ID_MMFR4_EL1_CnP_WIDTH: u32 = 4;
pub const ID_MMFR4_EL1_XNX_SHIFT: u32 = 8;
pub const ID_MMFR4_EL1_XNX_WIDTH: u32 = 4;
pub const ID_MMFR4_EL1_AC2_SHIFT: u32 = 4;
pub const ID_MMFR4_EL1_AC2_WIDTH: u32 = 4;
pub const ID_MMFR4_EL1_SpecSEI_SHIFT: u32 = 0;
pub const ID_MMFR4_EL1_SpecSEI_WIDTH: u32 = 4;
pub const SYS_MVFR0_EL1_Op0: u32 = 3;
pub const SYS_MVFR0_EL1_Op1: u32 = 0;
pub const SYS_MVFR0_EL1_CRn: u32 = 0;
pub const SYS_MVFR0_EL1_CRm: u32 = 3;
pub const SYS_MVFR0_EL1_Op2: u32 = 0;
pub const MVFR0_EL1_FPRound_SHIFT: u32 = 28;
pub const MVFR0_EL1_FPRound_WIDTH: u32 = 4;
pub const MVFR0_EL1_FPShVec_SHIFT: u32 = 24;
pub const MVFR0_EL1_FPShVec_WIDTH: u32 = 4;
pub const MVFR0_EL1_FPSqrt_SHIFT: u32 = 20;
pub const MVFR0_EL1_FPSqrt_WIDTH: u32 = 4;
pub const MVFR0_EL1_FPDivide_SHIFT: u32 = 16;
pub const MVFR0_EL1_FPDivide_WIDTH: u32 = 4;
pub const MVFR0_EL1_FPTrap_SHIFT: u32 = 12;
pub const MVFR0_EL1_FPTrap_WIDTH: u32 = 4;
pub const MVFR0_EL1_FPDP_SHIFT: u32 = 8;
pub const MVFR0_EL1_FPDP_WIDTH: u32 = 4;
pub const MVFR0_EL1_FPSP_SHIFT: u32 = 4;
pub const MVFR0_EL1_FPSP_WIDTH: u32 = 4;
pub const MVFR0_EL1_SIMDReg_SHIFT: u32 = 0;
pub const MVFR0_EL1_SIMDReg_WIDTH: u32 = 4;
pub const SYS_MVFR1_EL1_Op0: u32 = 3;
pub const SYS_MVFR1_EL1_Op1: u32 = 0;
pub const SYS_MVFR1_EL1_CRn: u32 = 0;
pub const SYS_MVFR1_EL1_CRm: u32 = 3;
pub const SYS_MVFR1_EL1_Op2: u32 = 1;
pub const MVFR1_EL1_SIMDFMAC_SHIFT: u32 = 28;
pub const MVFR1_EL1_SIMDFMAC_WIDTH: u32 = 4;
pub const MVFR1_EL1_FPHP_SHIFT: u32 = 24;
pub const MVFR1_EL1_FPHP_WIDTH: u32 = 4;
pub const MVFR1_EL1_SIMDHP_SHIFT: u32 = 20;
pub const MVFR1_EL1_SIMDHP_WIDTH: u32 = 4;
pub const MVFR1_EL1_SIMDSP_SHIFT: u32 = 16;
pub const MVFR1_EL1_SIMDSP_WIDTH: u32 = 4;
pub const MVFR1_EL1_SIMDInt_SHIFT: u32 = 12;
pub const MVFR1_EL1_SIMDInt_WIDTH: u32 = 4;
pub const MVFR1_EL1_SIMDLS_SHIFT: u32 = 8;
pub const MVFR1_EL1_SIMDLS_WIDTH: u32 = 4;
pub const MVFR1_EL1_FPDNaN_SHIFT: u32 = 4;
pub const MVFR1_EL1_FPDNaN_WIDTH: u32 = 4;
pub const MVFR1_EL1_FPFtZ_SHIFT: u32 = 0;
pub const MVFR1_EL1_FPFtZ_WIDTH: u32 = 4;
pub const SYS_MVFR2_EL1_Op0: u32 = 3;
pub const SYS_MVFR2_EL1_Op1: u32 = 0;
pub const SYS_MVFR2_EL1_CRn: u32 = 0;
pub const SYS_MVFR2_EL1_CRm: u32 = 3;
pub const SYS_MVFR2_EL1_Op2: u32 = 2;
pub const MVFR2_EL1_FPMisc_SHIFT: u32 = 4;
pub const MVFR2_EL1_FPMisc_WIDTH: u32 = 4;
pub const MVFR2_EL1_SIMDMisc_SHIFT: u32 = 0;
pub const MVFR2_EL1_SIMDMisc_WIDTH: u32 = 4;
pub const SYS_ID_PFR2_EL1_Op0: u32 = 3;
pub const SYS_ID_PFR2_EL1_Op1: u32 = 0;
pub const SYS_ID_PFR2_EL1_CRn: u32 = 0;
pub const SYS_ID_PFR2_EL1_CRm: u32 = 3;
pub const SYS_ID_PFR2_EL1_Op2: u32 = 4;
pub const ID_PFR2_EL1_RAS_frac_SHIFT: u32 = 8;
pub const ID_PFR2_EL1_RAS_frac_WIDTH: u32 = 4;
pub const ID_PFR2_EL1_SSBS_SHIFT: u32 = 4;
pub const ID_PFR2_EL1_SSBS_WIDTH: u32 = 4;
pub const ID_PFR2_EL1_CSV3_SHIFT: u32 = 0;
pub const ID_PFR2_EL1_CSV3_WIDTH: u32 = 4;
pub const SYS_ID_DFR1_EL1_Op0: u32 = 3;
pub const SYS_ID_DFR1_EL1_Op1: u32 = 0;
pub const SYS_ID_DFR1_EL1_CRn: u32 = 0;
pub const SYS_ID_DFR1_EL1_CRm: u32 = 3;
pub const SYS_ID_DFR1_EL1_Op2: u32 = 5;
pub const ID_DFR1_EL1_HPMN0_SHIFT: u32 = 4;
pub const ID_DFR1_EL1_HPMN0_WIDTH: u32 = 4;
pub const ID_DFR1_EL1_MTPMU_SHIFT: u32 = 0;
pub const ID_DFR1_EL1_MTPMU_WIDTH: u32 = 4;
pub const SYS_ID_MMFR5_EL1_Op0: u32 = 3;
pub const SYS_ID_MMFR5_EL1_Op1: u32 = 0;
pub const SYS_ID_MMFR5_EL1_CRn: u32 = 0;
pub const SYS_ID_MMFR5_EL1_CRm: u32 = 3;
pub const SYS_ID_MMFR5_EL1_Op2: u32 = 6;
pub const ID_MMFR5_EL1_nTLBPA_SHIFT: u32 = 4;
pub const ID_MMFR5_EL1_nTLBPA_WIDTH: u32 = 4;
pub const ID_MMFR5_EL1_ETS_SHIFT: u32 = 0;
pub const ID_MMFR5_EL1_ETS_WIDTH: u32 = 4;
pub const SYS_ID_AA64PFR0_EL1_Op0: u32 = 3;
pub const SYS_ID_AA64PFR0_EL1_Op1: u32 = 0;
pub const SYS_ID_AA64PFR0_EL1_CRn: u32 = 0;
pub const SYS_ID_AA64PFR0_EL1_CRm: u32 = 4;
pub const SYS_ID_AA64PFR0_EL1_Op2: u32 = 0;
pub const ID_AA64PFR0_EL1_CSV3_SHIFT: u32 = 60;
pub const ID_AA64PFR0_EL1_CSV3_WIDTH: u32 = 4;
pub const ID_AA64PFR0_EL1_CSV2_SHIFT: u32 = 56;
pub const ID_AA64PFR0_EL1_CSV2_WIDTH: u32 = 4;
pub const ID_AA64PFR0_EL1_RME_SHIFT: u32 = 52;
pub const ID_AA64PFR0_EL1_RME_WIDTH: u32 = 4;
pub const ID_AA64PFR0_EL1_DIT_SHIFT: u32 = 48;
pub const ID_AA64PFR0_EL1_DIT_WIDTH: u32 = 4;
pub const ID_AA64PFR0_EL1_AMU_SHIFT: u32 = 44;
pub const ID_AA64PFR0_EL1_AMU_WIDTH: u32 = 4;
pub const ID_AA64PFR0_EL1_MPAM_SHIFT: u32 = 40;
pub const ID_AA64PFR0_EL1_MPAM_WIDTH: u32 = 4;
pub const ID_AA64PFR0_EL1_SEL2_SHIFT: u32 = 36;
pub const ID_AA64PFR0_EL1_SEL2_WIDTH: u32 = 4;
pub const ID_AA64PFR0_EL1_SVE_SHIFT: u32 = 32;
pub const ID_AA64PFR0_EL1_SVE_WIDTH: u32 = 4;
pub const ID_AA64PFR0_EL1_RAS_SHIFT: u32 = 28;
pub const ID_AA64PFR0_EL1_RAS_WIDTH: u32 = 4;
pub const ID_AA64PFR0_EL1_GIC_SHIFT: u32 = 24;
pub const ID_AA64PFR0_EL1_GIC_WIDTH: u32 = 4;
pub const ID_AA64PFR0_EL1_AdvSIMD_SHIFT: u32 = 20;
pub const ID_AA64PFR0_EL1_AdvSIMD_WIDTH: u32 = 4;
pub const ID_AA64PFR0_EL1_FP_SHIFT: u32 = 16;
pub const ID_AA64PFR0_EL1_FP_WIDTH: u32 = 4;
pub const ID_AA64PFR0_EL1_EL3_SHIFT: u32 = 12;
pub const ID_AA64PFR0_EL1_EL3_WIDTH: u32 = 4;
pub const ID_AA64PFR0_EL1_EL2_SHIFT: u32 = 8;
pub const ID_AA64PFR0_EL1_EL2_WIDTH: u32 = 4;
pub const ID_AA64PFR0_EL1_EL1_SHIFT: u32 = 4;
pub const ID_AA64PFR0_EL1_EL1_WIDTH: u32 = 4;
pub const ID_AA64PFR0_EL1_EL0_SHIFT: u32 = 0;
pub const ID_AA64PFR0_EL1_EL0_WIDTH: u32 = 4;
pub const SYS_ID_AA64PFR1_EL1_Op0: u32 = 3;
pub const SYS_ID_AA64PFR1_EL1_Op1: u32 = 0;
pub const SYS_ID_AA64PFR1_EL1_CRn: u32 = 0;
pub const SYS_ID_AA64PFR1_EL1_CRm: u32 = 4;
pub const SYS_ID_AA64PFR1_EL1_Op2: u32 = 1;
pub const ID_AA64PFR1_EL1_PFAR_SHIFT: u32 = 60;
pub const ID_AA64PFR1_EL1_PFAR_WIDTH: u32 = 4;
pub const ID_AA64PFR1_EL1_DF2_SHIFT: u32 = 56;
pub const ID_AA64PFR1_EL1_DF2_WIDTH: u32 = 4;
pub const ID_AA64PFR1_EL1_MTEX_SHIFT: u32 = 52;
pub const ID_AA64PFR1_EL1_MTEX_WIDTH: u32 = 4;
pub const ID_AA64PFR1_EL1_THE_SHIFT: u32 = 48;
pub const ID_AA64PFR1_EL1_THE_WIDTH: u32 = 4;
pub const ID_AA64PFR1_EL1_GCS_SHIFT: u32 = 44;
pub const ID_AA64PFR1_EL1_GCS_WIDTH: u32 = 4;
pub const ID_AA64PFR1_EL1_MTE_frac_SHIFT: u32 = 40;
pub const ID_AA64PFR1_EL1_MTE_frac_WIDTH: u32 = 4;
pub const ID_AA64PFR1_EL1_NMI_SHIFT: u32 = 36;
pub const ID_AA64PFR1_EL1_NMI_WIDTH: u32 = 4;
pub const ID_AA64PFR1_EL1_CSV2_frac_SHIFT: u32 = 32;
pub const ID_AA64PFR1_EL1_CSV2_frac_WIDTH: u32 = 4;
pub const ID_AA64PFR1_EL1_RNDR_trap_SHIFT: u32 = 28;
pub const ID_AA64PFR1_EL1_RNDR_trap_WIDTH: u32 = 4;
pub const ID_AA64PFR1_EL1_SME_SHIFT: u32 = 24;
pub const ID_AA64PFR1_EL1_SME_WIDTH: u32 = 4;
pub const ID_AA64PFR1_EL1_MPAM_frac_SHIFT: u32 = 16;
pub const ID_AA64PFR1_EL1_MPAM_frac_WIDTH: u32 = 4;
pub const ID_AA64PFR1_EL1_RAS_frac_SHIFT: u32 = 12;
pub const ID_AA64PFR1_EL1_RAS_frac_WIDTH: u32 = 4;
pub const ID_AA64PFR1_EL1_MTE_SHIFT: u32 = 8;
pub const ID_AA64PFR1_EL1_MTE_WIDTH: u32 = 4;
pub const ID_AA64PFR1_EL1_SSBS_SHIFT: u32 = 4;
pub const ID_AA64PFR1_EL1_SSBS_WIDTH: u32 = 4;
pub const ID_AA64PFR1_EL1_BT_SHIFT: u32 = 0;
pub const ID_AA64PFR1_EL1_BT_WIDTH: u32 = 4;
pub const SYS_ID_AA64PFR2_EL1_Op0: u32 = 3;
pub const SYS_ID_AA64PFR2_EL1_Op1: u32 = 0;
pub const SYS_ID_AA64PFR2_EL1_CRn: u32 = 0;
pub const SYS_ID_AA64PFR2_EL1_CRm: u32 = 4;
pub const SYS_ID_AA64PFR2_EL1_Op2: u32 = 2;
pub const ID_AA64PFR2_EL1_FPMR_SHIFT: u32 = 32;
pub const ID_AA64PFR2_EL1_FPMR_WIDTH: u32 = 4;
pub const ID_AA64PFR2_EL1_UINJ_SHIFT: u32 = 16;
pub const ID_AA64PFR2_EL1_UINJ_WIDTH: u32 = 4;
pub const ID_AA64PFR2_EL1_MTEFAR_SHIFT: u32 = 8;
pub const ID_AA64PFR2_EL1_MTEFAR_WIDTH: u32 = 4;
pub const ID_AA64PFR2_EL1_MTESTOREONLY_SHIFT: u32 = 4;
pub const ID_AA64PFR2_EL1_MTESTOREONLY_WIDTH: u32 = 4;
pub const ID_AA64PFR2_EL1_MTEPERM_SHIFT: u32 = 0;
pub const ID_AA64PFR2_EL1_MTEPERM_WIDTH: u32 = 4;
pub const SYS_ID_AA64ZFR0_EL1_Op0: u32 = 3;
pub const SYS_ID_AA64ZFR0_EL1_Op1: u32 = 0;
pub const SYS_ID_AA64ZFR0_EL1_CRn: u32 = 0;
pub const SYS_ID_AA64ZFR0_EL1_CRm: u32 = 4;
pub const SYS_ID_AA64ZFR0_EL1_Op2: u32 = 4;
pub const ID_AA64ZFR0_EL1_F64MM_SHIFT: u32 = 56;
pub const ID_AA64ZFR0_EL1_F64MM_WIDTH: u32 = 4;
pub const ID_AA64ZFR0_EL1_F32MM_SHIFT: u32 = 52;
pub const ID_AA64ZFR0_EL1_F32MM_WIDTH: u32 = 4;
pub const ID_AA64ZFR0_EL1_F16MM_SHIFT: u32 = 48;
pub const ID_AA64ZFR0_EL1_F16MM_WIDTH: u32 = 4;
pub const ID_AA64ZFR0_EL1_I8MM_SHIFT: u32 = 44;
pub const ID_AA64ZFR0_EL1_I8MM_WIDTH: u32 = 4;
pub const ID_AA64ZFR0_EL1_SM4_SHIFT: u32 = 40;
pub const ID_AA64ZFR0_EL1_SM4_WIDTH: u32 = 4;
pub const ID_AA64ZFR0_EL1_SHA3_SHIFT: u32 = 32;
pub const ID_AA64ZFR0_EL1_SHA3_WIDTH: u32 = 4;
pub const ID_AA64ZFR0_EL1_B16B16_SHIFT: u32 = 24;
pub const ID_AA64ZFR0_EL1_B16B16_WIDTH: u32 = 4;
pub const ID_AA64ZFR0_EL1_BF16_SHIFT: u32 = 20;
pub const ID_AA64ZFR0_EL1_BF16_WIDTH: u32 = 4;
pub const ID_AA64ZFR0_EL1_BitPerm_SHIFT: u32 = 16;
pub const ID_AA64ZFR0_EL1_BitPerm_WIDTH: u32 = 4;
pub const ID_AA64ZFR0_EL1_EltPerm_SHIFT: u32 = 12;
pub const ID_AA64ZFR0_EL1_EltPerm_WIDTH: u32 = 4;
pub const ID_AA64ZFR0_EL1_AES_SHIFT: u32 = 4;
pub const ID_AA64ZFR0_EL1_AES_WIDTH: u32 = 4;
pub const ID_AA64ZFR0_EL1_SVEver_SHIFT: u32 = 0;
pub const ID_AA64ZFR0_EL1_SVEver_WIDTH: u32 = 4;
pub const SYS_ID_AA64SMFR0_EL1_Op0: u32 = 3;
pub const SYS_ID_AA64SMFR0_EL1_Op1: u32 = 0;
pub const SYS_ID_AA64SMFR0_EL1_CRn: u32 = 0;
pub const SYS_ID_AA64SMFR0_EL1_CRm: u32 = 4;
pub const SYS_ID_AA64SMFR0_EL1_Op2: u32 = 5;
pub const ID_AA64SMFR0_EL1_FA64_SHIFT: u32 = 63;
pub const ID_AA64SMFR0_EL1_FA64_WIDTH: u32 = 1;
pub const ID_AA64SMFR0_EL1_LUTv2_SHIFT: u32 = 60;
pub const ID_AA64SMFR0_EL1_LUTv2_WIDTH: u32 = 1;
pub const ID_AA64SMFR0_EL1_SMEver_SHIFT: u32 = 56;
pub const ID_AA64SMFR0_EL1_SMEver_WIDTH: u32 = 4;
pub const ID_AA64SMFR0_EL1_I16I64_SHIFT: u32 = 52;
pub const ID_AA64SMFR0_EL1_I16I64_WIDTH: u32 = 4;
pub const ID_AA64SMFR0_EL1_F64F64_SHIFT: u32 = 48;
pub const ID_AA64SMFR0_EL1_F64F64_WIDTH: u32 = 1;
pub const ID_AA64SMFR0_EL1_I16I32_SHIFT: u32 = 44;
pub const ID_AA64SMFR0_EL1_I16I32_WIDTH: u32 = 4;
pub const ID_AA64SMFR0_EL1_B16B16_SHIFT: u32 = 43;
pub const ID_AA64SMFR0_EL1_B16B16_WIDTH: u32 = 1;
pub const ID_AA64SMFR0_EL1_F16F16_SHIFT: u32 = 42;
pub const ID_AA64SMFR0_EL1_F16F16_WIDTH: u32 = 1;
pub const ID_AA64SMFR0_EL1_F8F16_SHIFT: u32 = 41;
pub const ID_AA64SMFR0_EL1_F8F16_WIDTH: u32 = 1;
pub const ID_AA64SMFR0_EL1_F8F32_SHIFT: u32 = 40;
pub const ID_AA64SMFR0_EL1_F8F32_WIDTH: u32 = 1;
pub const ID_AA64SMFR0_EL1_I8I32_SHIFT: u32 = 36;
pub const ID_AA64SMFR0_EL1_I8I32_WIDTH: u32 = 4;
pub const ID_AA64SMFR0_EL1_F16F32_SHIFT: u32 = 35;
pub const ID_AA64SMFR0_EL1_F16F32_WIDTH: u32 = 1;
pub const ID_AA64SMFR0_EL1_B16F32_SHIFT: u32 = 34;
pub const ID_AA64SMFR0_EL1_B16F32_WIDTH: u32 = 1;
pub const ID_AA64SMFR0_EL1_BI32I32_SHIFT: u32 = 33;
pub const ID_AA64SMFR0_EL1_BI32I32_WIDTH: u32 = 1;
pub const ID_AA64SMFR0_EL1_F32F32_SHIFT: u32 = 32;
pub const ID_AA64SMFR0_EL1_F32F32_WIDTH: u32 = 1;
pub const ID_AA64SMFR0_EL1_SF8FMA_SHIFT: u32 = 30;
pub const ID_AA64SMFR0_EL1_SF8FMA_WIDTH: u32 = 1;
pub const ID_AA64SMFR0_EL1_SF8DP4_SHIFT: u32 = 29;
pub const ID_AA64SMFR0_EL1_SF8DP4_WIDTH: u32 = 1;
pub const ID_AA64SMFR0_EL1_SF8DP2_SHIFT: u32 = 28;
pub const ID_AA64SMFR0_EL1_SF8DP2_WIDTH: u32 = 1;
pub const ID_AA64SMFR0_EL1_SBitPerm_SHIFT: u32 = 25;
pub const ID_AA64SMFR0_EL1_SBitPerm_WIDTH: u32 = 1;
pub const ID_AA64SMFR0_EL1_AES_SHIFT: u32 = 24;
pub const ID_AA64SMFR0_EL1_AES_WIDTH: u32 = 1;
pub const ID_AA64SMFR0_EL1_SFEXPA_SHIFT: u32 = 23;
pub const ID_AA64SMFR0_EL1_SFEXPA_WIDTH: u32 = 1;
pub const ID_AA64SMFR0_EL1_STMOP_SHIFT: u32 = 16;
pub const ID_AA64SMFR0_EL1_STMOP_WIDTH: u32 = 1;
pub const ID_AA64SMFR0_EL1_SMOP4_SHIFT: u32 = 0;
pub const ID_AA64SMFR0_EL1_SMOP4_WIDTH: u32 = 1;
pub const SYS_ID_AA64FPFR0_EL1_Op0: u32 = 3;
pub const SYS_ID_AA64FPFR0_EL1_Op1: u32 = 0;
pub const SYS_ID_AA64FPFR0_EL1_CRn: u32 = 0;
pub const SYS_ID_AA64FPFR0_EL1_CRm: u32 = 4;
pub const SYS_ID_AA64FPFR0_EL1_Op2: u32 = 7;
pub const ID_AA64FPFR0_EL1_F8CVT_SHIFT: u32 = 31;
pub const ID_AA64FPFR0_EL1_F8CVT_WIDTH: u32 = 1;
pub const ID_AA64FPFR0_EL1_F8FMA_SHIFT: u32 = 30;
pub const ID_AA64FPFR0_EL1_F8FMA_WIDTH: u32 = 1;
pub const ID_AA64FPFR0_EL1_F8DP4_SHIFT: u32 = 29;
pub const ID_AA64FPFR0_EL1_F8DP4_WIDTH: u32 = 1;
pub const ID_AA64FPFR0_EL1_F8DP2_SHIFT: u32 = 28;
pub const ID_AA64FPFR0_EL1_F8DP2_WIDTH: u32 = 1;
pub const ID_AA64FPFR0_EL1_F8MM8_SHIFT: u32 = 27;
pub const ID_AA64FPFR0_EL1_F8MM8_WIDTH: u32 = 1;
pub const ID_AA64FPFR0_EL1_F8MM4_SHIFT: u32 = 26;
pub const ID_AA64FPFR0_EL1_F8MM4_WIDTH: u32 = 1;
pub const ID_AA64FPFR0_EL1_F8E4M3_SHIFT: u32 = 1;
pub const ID_AA64FPFR0_EL1_F8E4M3_WIDTH: u32 = 1;
pub const ID_AA64FPFR0_EL1_F8E5M2_SHIFT: u32 = 0;
pub const ID_AA64FPFR0_EL1_F8E5M2_WIDTH: u32 = 1;
pub const SYS_ID_AA64DFR0_EL1_Op0: u32 = 3;
pub const SYS_ID_AA64DFR0_EL1_Op1: u32 = 0;
pub const SYS_ID_AA64DFR0_EL1_CRn: u32 = 0;
pub const SYS_ID_AA64DFR0_EL1_CRm: u32 = 5;
pub const SYS_ID_AA64DFR0_EL1_Op2: u32 = 0;
pub const ID_AA64DFR0_EL1_HPMN0_SHIFT: u32 = 60;
pub const ID_AA64DFR0_EL1_HPMN0_WIDTH: u32 = 4;
pub const ID_AA64DFR0_EL1_ExtTrcBuff_SHIFT: u32 = 56;
pub const ID_AA64DFR0_EL1_ExtTrcBuff_WIDTH: u32 = 4;
pub const ID_AA64DFR0_EL1_BRBE_SHIFT: u32 = 52;
pub const ID_AA64DFR0_EL1_BRBE_WIDTH: u32 = 4;
pub const ID_AA64DFR0_EL1_MTPMU_SHIFT: u32 = 48;
pub const ID_AA64DFR0_EL1_MTPMU_WIDTH: u32 = 4;
pub const ID_AA64DFR0_EL1_TraceBuffer_SHIFT: u32 = 44;
pub const ID_AA64DFR0_EL1_TraceBuffer_WIDTH: u32 = 4;
pub const ID_AA64DFR0_EL1_TraceFilt_SHIFT: u32 = 40;
pub const ID_AA64DFR0_EL1_TraceFilt_WIDTH: u32 = 4;
pub const ID_AA64DFR0_EL1_DoubleLock_SHIFT: u32 = 36;
pub const ID_AA64DFR0_EL1_DoubleLock_WIDTH: u32 = 4;
pub const ID_AA64DFR0_EL1_PMSVer_SHIFT: u32 = 32;
pub const ID_AA64DFR0_EL1_PMSVer_WIDTH: u32 = 4;
pub const ID_AA64DFR0_EL1_CTX_CMPs_SHIFT: u32 = 28;
pub const ID_AA64DFR0_EL1_CTX_CMPs_WIDTH: u32 = 4;
pub const ID_AA64DFR0_EL1_SEBEP_SHIFT: u32 = 24;
pub const ID_AA64DFR0_EL1_SEBEP_WIDTH: u32 = 4;
pub const ID_AA64DFR0_EL1_WRPs_SHIFT: u32 = 20;
pub const ID_AA64DFR0_EL1_WRPs_WIDTH: u32 = 4;
pub const ID_AA64DFR0_EL1_PMSS_SHIFT: u32 = 16;
pub const ID_AA64DFR0_EL1_PMSS_WIDTH: u32 = 4;
pub const ID_AA64DFR0_EL1_BRPs_SHIFT: u32 = 12;
pub const ID_AA64DFR0_EL1_BRPs_WIDTH: u32 = 4;
pub const ID_AA64DFR0_EL1_PMUVer_SHIFT: u32 = 8;
pub const ID_AA64DFR0_EL1_PMUVer_WIDTH: u32 = 4;
pub const ID_AA64DFR0_EL1_TraceVer_SHIFT: u32 = 4;
pub const ID_AA64DFR0_EL1_TraceVer_WIDTH: u32 = 4;
pub const ID_AA64DFR0_EL1_DebugVer_SHIFT: u32 = 0;
pub const ID_AA64DFR0_EL1_DebugVer_WIDTH: u32 = 4;
pub const SYS_ID_AA64DFR1_EL1_Op0: u32 = 3;
pub const SYS_ID_AA64DFR1_EL1_Op1: u32 = 0;
pub const SYS_ID_AA64DFR1_EL1_CRn: u32 = 0;
pub const SYS_ID_AA64DFR1_EL1_CRm: u32 = 5;
pub const SYS_ID_AA64DFR1_EL1_Op2: u32 = 1;
pub const ID_AA64DFR1_EL1_ABL_CMPs_SHIFT: u32 = 56;
pub const ID_AA64DFR1_EL1_ABL_CMPs_WIDTH: u32 = 8;
pub const ID_AA64DFR1_EL1_DPFZS_SHIFT: u32 = 52;
pub const ID_AA64DFR1_EL1_DPFZS_WIDTH: u32 = 4;
pub const ID_AA64DFR1_EL1_EBEP_SHIFT: u32 = 48;
pub const ID_AA64DFR1_EL1_EBEP_WIDTH: u32 = 4;
pub const ID_AA64DFR1_EL1_ITE_SHIFT: u32 = 44;
pub const ID_AA64DFR1_EL1_ITE_WIDTH: u32 = 4;
pub const ID_AA64DFR1_EL1_ABLE_SHIFT: u32 = 40;
pub const ID_AA64DFR1_EL1_ABLE_WIDTH: u32 = 4;
pub const ID_AA64DFR1_EL1_PMICNTR_SHIFT: u32 = 36;
pub const ID_AA64DFR1_EL1_PMICNTR_WIDTH: u32 = 4;
pub const ID_AA64DFR1_EL1_SPMU_SHIFT: u32 = 32;
pub const ID_AA64DFR1_EL1_SPMU_WIDTH: u32 = 4;
pub const ID_AA64DFR1_EL1_CTX_CMPs_SHIFT: u32 = 24;
pub const ID_AA64DFR1_EL1_CTX_CMPs_WIDTH: u32 = 8;
pub const ID_AA64DFR1_EL1_WRPs_SHIFT: u32 = 16;
pub const ID_AA64DFR1_EL1_WRPs_WIDTH: u32 = 8;
pub const ID_AA64DFR1_EL1_BRPs_SHIFT: u32 = 8;
pub const ID_AA64DFR1_EL1_BRPs_WIDTH: u32 = 8;
pub const ID_AA64DFR1_EL1_SYSPMUID_SHIFT: u32 = 0;
pub const ID_AA64DFR1_EL1_SYSPMUID_WIDTH: u32 = 8;
pub const SYS_ID_AA64DFR2_EL1_Op0: u32 = 3;
pub const SYS_ID_AA64DFR2_EL1_Op1: u32 = 0;
pub const SYS_ID_AA64DFR2_EL1_CRn: u32 = 0;
pub const SYS_ID_AA64DFR2_EL1_CRm: u32 = 5;
pub const SYS_ID_AA64DFR2_EL1_Op2: u32 = 2;
pub const ID_AA64DFR2_EL1_TRBE_EXC_SHIFT: u32 = 24;
pub const ID_AA64DFR2_EL1_TRBE_EXC_WIDTH: u32 = 4;
pub const ID_AA64DFR2_EL1_SPE_nVM_SHIFT: u32 = 20;
pub const ID_AA64DFR2_EL1_SPE_nVM_WIDTH: u32 = 4;
pub const ID_AA64DFR2_EL1_SPE_EXC_SHIFT: u32 = 16;
pub const ID_AA64DFR2_EL1_SPE_EXC_WIDTH: u32 = 4;
pub const ID_AA64DFR2_EL1_BWE_SHIFT: u32 = 4;
pub const ID_AA64DFR2_EL1_BWE_WIDTH: u32 = 4;
pub const ID_AA64DFR2_EL1_STEP_SHIFT: u32 = 0;
pub const ID_AA64DFR2_EL1_STEP_WIDTH: u32 = 4;
pub const SYS_ID_AA64AFR0_EL1_Op0: u32 = 3;
pub const SYS_ID_AA64AFR0_EL1_Op1: u32 = 0;
pub const SYS_ID_AA64AFR0_EL1_CRn: u32 = 0;
pub const SYS_ID_AA64AFR0_EL1_CRm: u32 = 5;
pub const SYS_ID_AA64AFR0_EL1_Op2: u32 = 4;
pub const ID_AA64AFR0_EL1_IMPDEF7_SHIFT: u32 = 28;
pub const ID_AA64AFR0_EL1_IMPDEF7_WIDTH: u32 = 4;
pub const ID_AA64AFR0_EL1_IMPDEF6_SHIFT: u32 = 24;
pub const ID_AA64AFR0_EL1_IMPDEF6_WIDTH: u32 = 4;
pub const ID_AA64AFR0_EL1_IMPDEF5_SHIFT: u32 = 20;
pub const ID_AA64AFR0_EL1_IMPDEF5_WIDTH: u32 = 4;
pub const ID_AA64AFR0_EL1_IMPDEF4_SHIFT: u32 = 16;
pub const ID_AA64AFR0_EL1_IMPDEF4_WIDTH: u32 = 4;
pub const ID_AA64AFR0_EL1_IMPDEF3_SHIFT: u32 = 12;
pub const ID_AA64AFR0_EL1_IMPDEF3_WIDTH: u32 = 4;
pub const ID_AA64AFR0_EL1_IMPDEF2_SHIFT: u32 = 8;
pub const ID_AA64AFR0_EL1_IMPDEF2_WIDTH: u32 = 4;
pub const ID_AA64AFR0_EL1_IMPDEF1_SHIFT: u32 = 4;
pub const ID_AA64AFR0_EL1_IMPDEF1_WIDTH: u32 = 4;
pub const ID_AA64AFR0_EL1_IMPDEF0_SHIFT: u32 = 0;
pub const ID_AA64AFR0_EL1_IMPDEF0_WIDTH: u32 = 4;
pub const SYS_ID_AA64AFR1_EL1_Op0: u32 = 3;
pub const SYS_ID_AA64AFR1_EL1_Op1: u32 = 0;
pub const SYS_ID_AA64AFR1_EL1_CRn: u32 = 0;
pub const SYS_ID_AA64AFR1_EL1_CRm: u32 = 5;
pub const SYS_ID_AA64AFR1_EL1_Op2: u32 = 5;
pub const SYS_ID_AA64ISAR0_EL1_Op0: u32 = 3;
pub const SYS_ID_AA64ISAR0_EL1_Op1: u32 = 0;
pub const SYS_ID_AA64ISAR0_EL1_CRn: u32 = 0;
pub const SYS_ID_AA64ISAR0_EL1_CRm: u32 = 6;
pub const SYS_ID_AA64ISAR0_EL1_Op2: u32 = 0;
pub const ID_AA64ISAR0_EL1_RNDR_SHIFT: u32 = 60;
pub const ID_AA64ISAR0_EL1_RNDR_WIDTH: u32 = 4;
pub const ID_AA64ISAR0_EL1_TLB_SHIFT: u32 = 56;
pub const ID_AA64ISAR0_EL1_TLB_WIDTH: u32 = 4;
pub const ID_AA64ISAR0_EL1_TS_SHIFT: u32 = 52;
pub const ID_AA64ISAR0_EL1_TS_WIDTH: u32 = 4;
pub const ID_AA64ISAR0_EL1_FHM_SHIFT: u32 = 48;
pub const ID_AA64ISAR0_EL1_FHM_WIDTH: u32 = 4;
pub const ID_AA64ISAR0_EL1_DP_SHIFT: u32 = 44;
pub const ID_AA64ISAR0_EL1_DP_WIDTH: u32 = 4;
pub const ID_AA64ISAR0_EL1_SM4_SHIFT: u32 = 40;
pub const ID_AA64ISAR0_EL1_SM4_WIDTH: u32 = 4;
pub const ID_AA64ISAR0_EL1_SM3_SHIFT: u32 = 36;
pub const ID_AA64ISAR0_EL1_SM3_WIDTH: u32 = 4;
pub const ID_AA64ISAR0_EL1_SHA3_SHIFT: u32 = 32;
pub const ID_AA64ISAR0_EL1_SHA3_WIDTH: u32 = 4;
pub const ID_AA64ISAR0_EL1_RDM_SHIFT: u32 = 28;
pub const ID_AA64ISAR0_EL1_RDM_WIDTH: u32 = 4;
pub const ID_AA64ISAR0_EL1_TME_SHIFT: u32 = 24;
pub const ID_AA64ISAR0_EL1_TME_WIDTH: u32 = 4;
pub const ID_AA64ISAR0_EL1_ATOMIC_SHIFT: u32 = 20;
pub const ID_AA64ISAR0_EL1_ATOMIC_WIDTH: u32 = 4;
pub const ID_AA64ISAR0_EL1_CRC32_SHIFT: u32 = 16;
pub const ID_AA64ISAR0_EL1_CRC32_WIDTH: u32 = 4;
pub const ID_AA64ISAR0_EL1_SHA2_SHIFT: u32 = 12;
pub const ID_AA64ISAR0_EL1_SHA2_WIDTH: u32 = 4;
pub const ID_AA64ISAR0_EL1_SHA1_SHIFT: u32 = 8;
pub const ID_AA64ISAR0_EL1_SHA1_WIDTH: u32 = 4;
pub const ID_AA64ISAR0_EL1_AES_SHIFT: u32 = 4;
pub const ID_AA64ISAR0_EL1_AES_WIDTH: u32 = 4;
pub const SYS_ID_AA64ISAR1_EL1_Op0: u32 = 3;
pub const SYS_ID_AA64ISAR1_EL1_Op1: u32 = 0;
pub const SYS_ID_AA64ISAR1_EL1_CRn: u32 = 0;
pub const SYS_ID_AA64ISAR1_EL1_CRm: u32 = 6;
pub const SYS_ID_AA64ISAR1_EL1_Op2: u32 = 1;
pub const ID_AA64ISAR1_EL1_LS64_SHIFT: u32 = 60;
pub const ID_AA64ISAR1_EL1_LS64_WIDTH: u32 = 4;
pub const ID_AA64ISAR1_EL1_XS_SHIFT: u32 = 56;
pub const ID_AA64ISAR1_EL1_XS_WIDTH: u32 = 4;
pub const ID_AA64ISAR1_EL1_I8MM_SHIFT: u32 = 52;
pub const ID_AA64ISAR1_EL1_I8MM_WIDTH: u32 = 4;
pub const ID_AA64ISAR1_EL1_DGH_SHIFT: u32 = 48;
pub const ID_AA64ISAR1_EL1_DGH_WIDTH: u32 = 4;
pub const ID_AA64ISAR1_EL1_BF16_SHIFT: u32 = 44;
pub const ID_AA64ISAR1_EL1_BF16_WIDTH: u32 = 4;
pub const ID_AA64ISAR1_EL1_SPECRES_SHIFT: u32 = 40;
pub const ID_AA64ISAR1_EL1_SPECRES_WIDTH: u32 = 4;
pub const ID_AA64ISAR1_EL1_SB_SHIFT: u32 = 36;
pub const ID_AA64ISAR1_EL1_SB_WIDTH: u32 = 4;
pub const ID_AA64ISAR1_EL1_FRINTTS_SHIFT: u32 = 32;
pub const ID_AA64ISAR1_EL1_FRINTTS_WIDTH: u32 = 4;
pub const ID_AA64ISAR1_EL1_GPI_SHIFT: u32 = 28;
pub const ID_AA64ISAR1_EL1_GPI_WIDTH: u32 = 4;
pub const ID_AA64ISAR1_EL1_GPA_SHIFT: u32 = 24;
pub const ID_AA64ISAR1_EL1_GPA_WIDTH: u32 = 4;
pub const ID_AA64ISAR1_EL1_LRCPC_SHIFT: u32 = 20;
pub const ID_AA64ISAR1_EL1_LRCPC_WIDTH: u32 = 4;
pub const ID_AA64ISAR1_EL1_FCMA_SHIFT: u32 = 16;
pub const ID_AA64ISAR1_EL1_FCMA_WIDTH: u32 = 4;
pub const ID_AA64ISAR1_EL1_JSCVT_SHIFT: u32 = 12;
pub const ID_AA64ISAR1_EL1_JSCVT_WIDTH: u32 = 4;
pub const ID_AA64ISAR1_EL1_API_SHIFT: u32 = 8;
pub const ID_AA64ISAR1_EL1_API_WIDTH: u32 = 4;
pub const ID_AA64ISAR1_EL1_APA_SHIFT: u32 = 4;
pub const ID_AA64ISAR1_EL1_APA_WIDTH: u32 = 4;
pub const ID_AA64ISAR1_EL1_DPB_SHIFT: u32 = 0;
pub const ID_AA64ISAR1_EL1_DPB_WIDTH: u32 = 4;
pub const SYS_ID_AA64ISAR2_EL1_Op0: u32 = 3;
pub const SYS_ID_AA64ISAR2_EL1_Op1: u32 = 0;
pub const SYS_ID_AA64ISAR2_EL1_CRn: u32 = 0;
pub const SYS_ID_AA64ISAR2_EL1_CRm: u32 = 6;
pub const SYS_ID_AA64ISAR2_EL1_Op2: u32 = 2;
pub const ID_AA64ISAR2_EL1_ATS1A_SHIFT: u32 = 60;
pub const ID_AA64ISAR2_EL1_ATS1A_WIDTH: u32 = 4;
pub const ID_AA64ISAR2_EL1_LUT_SHIFT: u32 = 56;
pub const ID_AA64ISAR2_EL1_LUT_WIDTH: u32 = 4;
pub const ID_AA64ISAR2_EL1_CSSC_SHIFT: u32 = 52;
pub const ID_AA64ISAR2_EL1_CSSC_WIDTH: u32 = 4;
pub const ID_AA64ISAR2_EL1_RPRFM_SHIFT: u32 = 48;
pub const ID_AA64ISAR2_EL1_RPRFM_WIDTH: u32 = 4;
pub const ID_AA64ISAR2_EL1_PCDPHINT_SHIFT: u32 = 44;
pub const ID_AA64ISAR2_EL1_PCDPHINT_WIDTH: u32 = 4;
pub const ID_AA64ISAR2_EL1_PRFMSLC_SHIFT: u32 = 40;
pub const ID_AA64ISAR2_EL1_PRFMSLC_WIDTH: u32 = 4;
pub const ID_AA64ISAR2_EL1_SYSINSTR_128_SHIFT: u32 = 36;
pub const ID_AA64ISAR2_EL1_SYSINSTR_128_WIDTH: u32 = 4;
pub const ID_AA64ISAR2_EL1_SYSREG_128_SHIFT: u32 = 32;
pub const ID_AA64ISAR2_EL1_SYSREG_128_WIDTH: u32 = 4;
pub const ID_AA64ISAR2_EL1_CLRBHB_SHIFT: u32 = 28;
pub const ID_AA64ISAR2_EL1_CLRBHB_WIDTH: u32 = 4;
pub const ID_AA64ISAR2_EL1_PAC_frac_SHIFT: u32 = 24;
pub const ID_AA64ISAR2_EL1_PAC_frac_WIDTH: u32 = 4;
pub const ID_AA64ISAR2_EL1_BC_SHIFT: u32 = 20;
pub const ID_AA64ISAR2_EL1_BC_WIDTH: u32 = 4;
pub const ID_AA64ISAR2_EL1_MOPS_SHIFT: u32 = 16;
pub const ID_AA64ISAR2_EL1_MOPS_WIDTH: u32 = 4;
pub const ID_AA64ISAR2_EL1_APA3_SHIFT: u32 = 12;
pub const ID_AA64ISAR2_EL1_APA3_WIDTH: u32 = 4;
pub const ID_AA64ISAR2_EL1_GPA3_SHIFT: u32 = 8;
pub const ID_AA64ISAR2_EL1_GPA3_WIDTH: u32 = 4;
pub const ID_AA64ISAR2_EL1_RPRES_SHIFT: u32 = 4;
pub const ID_AA64ISAR2_EL1_RPRES_WIDTH: u32 = 4;
pub const ID_AA64ISAR2_EL1_WFxT_SHIFT: u32 = 0;
pub const ID_AA64ISAR2_EL1_WFxT_WIDTH: u32 = 4;
pub const SYS_ID_AA64ISAR3_EL1_Op0: u32 = 3;
pub const SYS_ID_AA64ISAR3_EL1_Op1: u32 = 0;
pub const SYS_ID_AA64ISAR3_EL1_CRn: u32 = 0;
pub const SYS_ID_AA64ISAR3_EL1_CRm: u32 = 6;
pub const SYS_ID_AA64ISAR3_EL1_Op2: u32 = 3;
pub const ID_AA64ISAR3_EL1_FPRCVT_SHIFT: u32 = 28;
pub const ID_AA64ISAR3_EL1_FPRCVT_WIDTH: u32 = 4;
pub const ID_AA64ISAR3_EL1_LSUI_SHIFT: u32 = 24;
pub const ID_AA64ISAR3_EL1_LSUI_WIDTH: u32 = 4;
pub const ID_AA64ISAR3_EL1_OCCMO_SHIFT: u32 = 20;
pub const ID_AA64ISAR3_EL1_OCCMO_WIDTH: u32 = 4;
pub const ID_AA64ISAR3_EL1_LSFE_SHIFT: u32 = 16;
pub const ID_AA64ISAR3_EL1_LSFE_WIDTH: u32 = 4;
pub const ID_AA64ISAR3_EL1_PACM_SHIFT: u32 = 12;
pub const ID_AA64ISAR3_EL1_PACM_WIDTH: u32 = 4;
pub const ID_AA64ISAR3_EL1_TLBIW_SHIFT: u32 = 8;
pub const ID_AA64ISAR3_EL1_TLBIW_WIDTH: u32 = 4;
pub const ID_AA64ISAR3_EL1_FAMINMAX_SHIFT: u32 = 4;
pub const ID_AA64ISAR3_EL1_FAMINMAX_WIDTH: u32 = 4;
pub const ID_AA64ISAR3_EL1_CPA_SHIFT: u32 = 0;
pub const ID_AA64ISAR3_EL1_CPA_WIDTH: u32 = 4;
pub const SYS_ID_AA64MMFR0_EL1_Op0: u32 = 3;
pub const SYS_ID_AA64MMFR0_EL1_Op1: u32 = 0;
pub const SYS_ID_AA64MMFR0_EL1_CRn: u32 = 0;
pub const SYS_ID_AA64MMFR0_EL1_CRm: u32 = 7;
pub const SYS_ID_AA64MMFR0_EL1_Op2: u32 = 0;
pub const ID_AA64MMFR0_EL1_ECV_SHIFT: u32 = 60;
pub const ID_AA64MMFR0_EL1_ECV_WIDTH: u32 = 4;
pub const ID_AA64MMFR0_EL1_FGT_SHIFT: u32 = 56;
pub const ID_AA64MMFR0_EL1_FGT_WIDTH: u32 = 4;
pub const ID_AA64MMFR0_EL1_EXS_SHIFT: u32 = 44;
pub const ID_AA64MMFR0_EL1_EXS_WIDTH: u32 = 4;
pub const ID_AA64MMFR0_EL1_TGRAN4_2_SHIFT: u32 = 40;
pub const ID_AA64MMFR0_EL1_TGRAN4_2_WIDTH: u32 = 4;
pub const ID_AA64MMFR0_EL1_TGRAN64_2_SHIFT: u32 = 36;
pub const ID_AA64MMFR0_EL1_TGRAN64_2_WIDTH: u32 = 4;
pub const ID_AA64MMFR0_EL1_TGRAN16_2_SHIFT: u32 = 32;
pub const ID_AA64MMFR0_EL1_TGRAN16_2_WIDTH: u32 = 4;
pub const ID_AA64MMFR0_EL1_TGRAN4_SHIFT: u32 = 28;
pub const ID_AA64MMFR0_EL1_TGRAN4_WIDTH: u32 = 4;
pub const ID_AA64MMFR0_EL1_TGRAN64_SHIFT: u32 = 24;
pub const ID_AA64MMFR0_EL1_TGRAN64_WIDTH: u32 = 4;
pub const ID_AA64MMFR0_EL1_TGRAN16_SHIFT: u32 = 20;
pub const ID_AA64MMFR0_EL1_TGRAN16_WIDTH: u32 = 4;
pub const ID_AA64MMFR0_EL1_BIGENDEL0_SHIFT: u32 = 16;
pub const ID_AA64MMFR0_EL1_BIGENDEL0_WIDTH: u32 = 4;
pub const ID_AA64MMFR0_EL1_SNSMEM_SHIFT: u32 = 12;
pub const ID_AA64MMFR0_EL1_SNSMEM_WIDTH: u32 = 4;
pub const ID_AA64MMFR0_EL1_BIGEND_SHIFT: u32 = 8;
pub const ID_AA64MMFR0_EL1_BIGEND_WIDTH: u32 = 4;
pub const ID_AA64MMFR0_EL1_ASIDBITS_SHIFT: u32 = 4;
pub const ID_AA64MMFR0_EL1_ASIDBITS_WIDTH: u32 = 4;
pub const ID_AA64MMFR0_EL1_PARANGE_SHIFT: u32 = 0;
pub const ID_AA64MMFR0_EL1_PARANGE_WIDTH: u32 = 4;
pub const SYS_ID_AA64MMFR1_EL1_Op0: u32 = 3;
pub const SYS_ID_AA64MMFR1_EL1_Op1: u32 = 0;
pub const SYS_ID_AA64MMFR1_EL1_CRn: u32 = 0;
pub const SYS_ID_AA64MMFR1_EL1_CRm: u32 = 7;
pub const SYS_ID_AA64MMFR1_EL1_Op2: u32 = 1;
pub const ID_AA64MMFR1_EL1_ECBHB_SHIFT: u32 = 60;
pub const ID_AA64MMFR1_EL1_ECBHB_WIDTH: u32 = 4;
pub const ID_AA64MMFR1_EL1_CMOW_SHIFT: u32 = 56;
pub const ID_AA64MMFR1_EL1_CMOW_WIDTH: u32 = 4;
pub const ID_AA64MMFR1_EL1_TIDCP1_SHIFT: u32 = 52;
pub const ID_AA64MMFR1_EL1_TIDCP1_WIDTH: u32 = 4;
pub const ID_AA64MMFR1_EL1_nTLBPA_SHIFT: u32 = 48;
pub const ID_AA64MMFR1_EL1_nTLBPA_WIDTH: u32 = 4;
pub const ID_AA64MMFR1_EL1_AFP_SHIFT: u32 = 44;
pub const ID_AA64MMFR1_EL1_AFP_WIDTH: u32 = 4;
pub const ID_AA64MMFR1_EL1_HCX_SHIFT: u32 = 40;
pub const ID_AA64MMFR1_EL1_HCX_WIDTH: u32 = 4;
pub const ID_AA64MMFR1_EL1_ETS_SHIFT: u32 = 36;
pub const ID_AA64MMFR1_EL1_ETS_WIDTH: u32 = 4;
pub const ID_AA64MMFR1_EL1_TWED_SHIFT: u32 = 32;
pub const ID_AA64MMFR1_EL1_TWED_WIDTH: u32 = 4;
pub const ID_AA64MMFR1_EL1_XNX_SHIFT: u32 = 28;
pub const ID_AA64MMFR1_EL1_XNX_WIDTH: u32 = 4;
pub const ID_AA64MMFR1_EL1_SpecSEI_SHIFT: u32 = 24;
pub const ID_AA64MMFR1_EL1_SpecSEI_WIDTH: u32 = 4;
pub const ID_AA64MMFR1_EL1_PAN_SHIFT: u32 = 20;
pub const ID_AA64MMFR1_EL1_PAN_WIDTH: u32 = 4;
pub const ID_AA64MMFR1_EL1_LO_SHIFT: u32 = 16;
pub const ID_AA64MMFR1_EL1_LO_WIDTH: u32 = 4;
pub const ID_AA64MMFR1_EL1_HPDS_SHIFT: u32 = 12;
pub const ID_AA64MMFR1_EL1_HPDS_WIDTH: u32 = 4;
pub const ID_AA64MMFR1_EL1_VH_SHIFT: u32 = 8;
pub const ID_AA64MMFR1_EL1_VH_WIDTH: u32 = 4;
pub const ID_AA64MMFR1_EL1_VMIDBits_SHIFT: u32 = 4;
pub const ID_AA64MMFR1_EL1_VMIDBits_WIDTH: u32 = 4;
pub const ID_AA64MMFR1_EL1_HAFDBS_SHIFT: u32 = 0;
pub const ID_AA64MMFR1_EL1_HAFDBS_WIDTH: u32 = 4;
pub const SYS_ID_AA64MMFR2_EL1_Op0: u32 = 3;
pub const SYS_ID_AA64MMFR2_EL1_Op1: u32 = 0;
pub const SYS_ID_AA64MMFR2_EL1_CRn: u32 = 0;
pub const SYS_ID_AA64MMFR2_EL1_CRm: u32 = 7;
pub const SYS_ID_AA64MMFR2_EL1_Op2: u32 = 2;
pub const ID_AA64MMFR2_EL1_E0PD_SHIFT: u32 = 60;
pub const ID_AA64MMFR2_EL1_E0PD_WIDTH: u32 = 4;
pub const ID_AA64MMFR2_EL1_EVT_SHIFT: u32 = 56;
pub const ID_AA64MMFR2_EL1_EVT_WIDTH: u32 = 4;
pub const ID_AA64MMFR2_EL1_BBM_SHIFT: u32 = 52;
pub const ID_AA64MMFR2_EL1_BBM_WIDTH: u32 = 4;
pub const ID_AA64MMFR2_EL1_TTL_SHIFT: u32 = 48;
pub const ID_AA64MMFR2_EL1_TTL_WIDTH: u32 = 4;
pub const ID_AA64MMFR2_EL1_FWB_SHIFT: u32 = 40;
pub const ID_AA64MMFR2_EL1_FWB_WIDTH: u32 = 4;
pub const ID_AA64MMFR2_EL1_IDS_SHIFT: u32 = 36;
pub const ID_AA64MMFR2_EL1_IDS_WIDTH: u32 = 4;
pub const ID_AA64MMFR2_EL1_AT_SHIFT: u32 = 32;
pub const ID_AA64MMFR2_EL1_AT_WIDTH: u32 = 4;
pub const ID_AA64MMFR2_EL1_ST_SHIFT: u32 = 28;
pub const ID_AA64MMFR2_EL1_ST_WIDTH: u32 = 4;
pub const ID_AA64MMFR2_EL1_NV_SHIFT: u32 = 24;
pub const ID_AA64MMFR2_EL1_NV_WIDTH: u32 = 4;
pub const ID_AA64MMFR2_EL1_CCIDX_SHIFT: u32 = 20;
pub const ID_AA64MMFR2_EL1_CCIDX_WIDTH: u32 = 4;
pub const ID_AA64MMFR2_EL1_VARange_SHIFT: u32 = 16;
pub const ID_AA64MMFR2_EL1_VARange_WIDTH: u32 = 4;
pub const ID_AA64MMFR2_EL1_IESB_SHIFT: u32 = 12;
pub const ID_AA64MMFR2_EL1_IESB_WIDTH: u32 = 4;
pub const ID_AA64MMFR2_EL1_LSM_SHIFT: u32 = 8;
pub const ID_AA64MMFR2_EL1_LSM_WIDTH: u32 = 4;
pub const ID_AA64MMFR2_EL1_UAO_SHIFT: u32 = 4;
pub const ID_AA64MMFR2_EL1_UAO_WIDTH: u32 = 4;
pub const ID_AA64MMFR2_EL1_CnP_SHIFT: u32 = 0;
pub const ID_AA64MMFR2_EL1_CnP_WIDTH: u32 = 4;
pub const SYS_ID_AA64MMFR3_EL1_Op0: u32 = 3;
pub const SYS_ID_AA64MMFR3_EL1_Op1: u32 = 0;
pub const SYS_ID_AA64MMFR3_EL1_CRn: u32 = 0;
pub const SYS_ID_AA64MMFR3_EL1_CRm: u32 = 7;
pub const SYS_ID_AA64MMFR3_EL1_Op2: u32 = 3;
pub const ID_AA64MMFR3_EL1_Spec_FPACC_SHIFT: u32 = 60;
pub const ID_AA64MMFR3_EL1_Spec_FPACC_WIDTH: u32 = 4;
pub const ID_AA64MMFR3_EL1_ADERR_SHIFT: u32 = 56;
pub const ID_AA64MMFR3_EL1_ADERR_WIDTH: u32 = 4;
pub const ID_AA64MMFR3_EL1_SDERR_SHIFT: u32 = 52;
pub const ID_AA64MMFR3_EL1_SDERR_WIDTH: u32 = 4;
pub const ID_AA64MMFR3_EL1_ANERR_SHIFT: u32 = 44;
pub const ID_AA64MMFR3_EL1_ANERR_WIDTH: u32 = 4;
pub const ID_AA64MMFR3_EL1_SNERR_SHIFT: u32 = 40;
pub const ID_AA64MMFR3_EL1_SNERR_WIDTH: u32 = 4;
pub const ID_AA64MMFR3_EL1_D128_2_SHIFT: u32 = 36;
pub const ID_AA64MMFR3_EL1_D128_2_WIDTH: u32 = 4;
pub const ID_AA64MMFR3_EL1_D128_SHIFT: u32 = 32;
pub const ID_AA64MMFR3_EL1_D128_WIDTH: u32 = 4;
pub const ID_AA64MMFR3_EL1_MEC_SHIFT: u32 = 28;
pub const ID_AA64MMFR3_EL1_MEC_WIDTH: u32 = 4;
pub const ID_AA64MMFR3_EL1_AIE_SHIFT: u32 = 24;
pub const ID_AA64MMFR3_EL1_AIE_WIDTH: u32 = 4;
pub const ID_AA64MMFR3_EL1_S2POE_SHIFT: u32 = 20;
pub const ID_AA64MMFR3_EL1_S2POE_WIDTH: u32 = 4;
pub const ID_AA64MMFR3_EL1_S1POE_SHIFT: u32 = 16;
pub const ID_AA64MMFR3_EL1_S1POE_WIDTH: u32 = 4;
pub const ID_AA64MMFR3_EL1_S2PIE_SHIFT: u32 = 12;
pub const ID_AA64MMFR3_EL1_S2PIE_WIDTH: u32 = 4;
pub const ID_AA64MMFR3_EL1_S1PIE_SHIFT: u32 = 8;
pub const ID_AA64MMFR3_EL1_S1PIE_WIDTH: u32 = 4;
pub const ID_AA64MMFR3_EL1_SCTLRX_SHIFT: u32 = 4;
pub const ID_AA64MMFR3_EL1_SCTLRX_WIDTH: u32 = 4;
pub const ID_AA64MMFR3_EL1_TCRX_SHIFT: u32 = 0;
pub const ID_AA64MMFR3_EL1_TCRX_WIDTH: u32 = 4;
pub const SYS_ID_AA64MMFR4_EL1_Op0: u32 = 3;
pub const SYS_ID_AA64MMFR4_EL1_Op1: u32 = 0;
pub const SYS_ID_AA64MMFR4_EL1_CRn: u32 = 0;
pub const SYS_ID_AA64MMFR4_EL1_CRm: u32 = 7;
pub const SYS_ID_AA64MMFR4_EL1_Op2: u32 = 4;
pub const ID_AA64MMFR4_EL1_E3DSE_SHIFT: u32 = 36;
pub const ID_AA64MMFR4_EL1_E3DSE_WIDTH: u32 = 4;
pub const ID_AA64MMFR4_EL1_E2H0_SHIFT: u32 = 24;
pub const ID_AA64MMFR4_EL1_E2H0_WIDTH: u32 = 4;
pub const ID_AA64MMFR4_EL1_NV_frac_SHIFT: u32 = 20;
pub const ID_AA64MMFR4_EL1_NV_frac_WIDTH: u32 = 4;
pub const ID_AA64MMFR4_EL1_FGWTE3_SHIFT: u32 = 16;
pub const ID_AA64MMFR4_EL1_FGWTE3_WIDTH: u32 = 4;
pub const ID_AA64MMFR4_EL1_HACDBS_SHIFT: u32 = 12;
pub const ID_AA64MMFR4_EL1_HACDBS_WIDTH: u32 = 4;
pub const ID_AA64MMFR4_EL1_ASID2_SHIFT: u32 = 8;
pub const ID_AA64MMFR4_EL1_ASID2_WIDTH: u32 = 4;
pub const ID_AA64MMFR4_EL1_EIESB_SHIFT: u32 = 4;
pub const ID_AA64MMFR4_EL1_EIESB_WIDTH: u32 = 4;
pub const SYS_SCTLR_EL1_Op0: u32 = 3;
pub const SYS_SCTLR_EL1_Op1: u32 = 0;
pub const SYS_SCTLR_EL1_CRn: u32 = 1;
pub const SYS_SCTLR_EL1_CRm: u32 = 0;
pub const SYS_SCTLR_EL1_Op2: u32 = 0;
pub const SCTLR_EL1_TIDCP_SHIFT: u32 = 63;
pub const SCTLR_EL1_TIDCP_WIDTH: u32 = 1;
pub const SCTLR_EL1_SPINTMASK_SHIFT: u32 = 62;
pub const SCTLR_EL1_SPINTMASK_WIDTH: u32 = 1;
pub const SCTLR_EL1_NMI_SHIFT: u32 = 61;
pub const SCTLR_EL1_NMI_WIDTH: u32 = 1;
pub const SCTLR_EL1_EnTP2_SHIFT: u32 = 60;
pub const SCTLR_EL1_EnTP2_WIDTH: u32 = 1;
pub const SCTLR_EL1_TCSO_SHIFT: u32 = 59;
pub const SCTLR_EL1_TCSO_WIDTH: u32 = 1;
pub const SCTLR_EL1_TCSO0_SHIFT: u32 = 58;
pub const SCTLR_EL1_TCSO0_WIDTH: u32 = 1;
pub const SCTLR_EL1_EPAN_SHIFT: u32 = 57;
pub const SCTLR_EL1_EPAN_WIDTH: u32 = 1;
pub const SCTLR_EL1_EnALS_SHIFT: u32 = 56;
pub const SCTLR_EL1_EnALS_WIDTH: u32 = 1;
pub const SCTLR_EL1_EnAS0_SHIFT: u32 = 55;
pub const SCTLR_EL1_EnAS0_WIDTH: u32 = 1;
pub const SCTLR_EL1_EnASR_SHIFT: u32 = 54;
pub const SCTLR_EL1_EnASR_WIDTH: u32 = 1;
pub const SCTLR_EL1_TME_SHIFT: u32 = 53;
pub const SCTLR_EL1_TME_WIDTH: u32 = 1;
pub const SCTLR_EL1_TME0_SHIFT: u32 = 52;
pub const SCTLR_EL1_TME0_WIDTH: u32 = 1;
pub const SCTLR_EL1_TMT_SHIFT: u32 = 51;
pub const SCTLR_EL1_TMT_WIDTH: u32 = 1;
pub const SCTLR_EL1_TMT0_SHIFT: u32 = 50;
pub const SCTLR_EL1_TMT0_WIDTH: u32 = 1;
pub const SCTLR_EL1_TWEDEL_SHIFT: u32 = 46;
pub const SCTLR_EL1_TWEDEL_WIDTH: u32 = 4;
pub const SCTLR_EL1_TWEDEn_SHIFT: u32 = 45;
pub const SCTLR_EL1_TWEDEn_WIDTH: u32 = 1;
pub const SCTLR_EL1_DSSBS_SHIFT: u32 = 44;
pub const SCTLR_EL1_DSSBS_WIDTH: u32 = 1;
pub const SCTLR_EL1_ATA_SHIFT: u32 = 43;
pub const SCTLR_EL1_ATA_WIDTH: u32 = 1;
pub const SCTLR_EL1_ATA0_SHIFT: u32 = 42;
pub const SCTLR_EL1_ATA0_WIDTH: u32 = 1;
pub const SCTLR_EL1_TCF_SHIFT: u32 = 40;
pub const SCTLR_EL1_TCF_WIDTH: u32 = 2;
pub const SCTLR_EL1_TCF0_SHIFT: u32 = 38;
pub const SCTLR_EL1_TCF0_WIDTH: u32 = 2;
pub const SCTLR_EL1_ITFSB_SHIFT: u32 = 37;
pub const SCTLR_EL1_ITFSB_WIDTH: u32 = 1;
pub const SCTLR_EL1_BT1_SHIFT: u32 = 36;
pub const SCTLR_EL1_BT1_WIDTH: u32 = 1;
pub const SCTLR_EL1_BT0_SHIFT: u32 = 35;
pub const SCTLR_EL1_BT0_WIDTH: u32 = 1;
pub const SCTLR_EL1_EnFPM_SHIFT: u32 = 34;
pub const SCTLR_EL1_EnFPM_WIDTH: u32 = 1;
pub const SCTLR_EL1_MSCEn_SHIFT: u32 = 33;
pub const SCTLR_EL1_MSCEn_WIDTH: u32 = 1;
pub const SCTLR_EL1_CMOW_SHIFT: u32 = 32;
pub const SCTLR_EL1_CMOW_WIDTH: u32 = 1;
pub const SCTLR_EL1_EnIA_SHIFT: u32 = 31;
pub const SCTLR_EL1_EnIA_WIDTH: u32 = 1;
pub const SCTLR_EL1_EnIB_SHIFT: u32 = 30;
pub const SCTLR_EL1_EnIB_WIDTH: u32 = 1;
pub const SCTLR_EL1_LSMAOE_SHIFT: u32 = 29;
pub const SCTLR_EL1_LSMAOE_WIDTH: u32 = 1;
pub const SCTLR_EL1_nTLSMD_SHIFT: u32 = 28;
pub const SCTLR_EL1_nTLSMD_WIDTH: u32 = 1;
pub const SCTLR_EL1_EnDA_SHIFT: u32 = 27;
pub const SCTLR_EL1_EnDA_WIDTH: u32 = 1;
pub const SCTLR_EL1_UCI_SHIFT: u32 = 26;
pub const SCTLR_EL1_UCI_WIDTH: u32 = 1;
pub const SCTLR_EL1_EE_SHIFT: u32 = 25;
pub const SCTLR_EL1_EE_WIDTH: u32 = 1;
pub const SCTLR_EL1_E0E_SHIFT: u32 = 24;
pub const SCTLR_EL1_E0E_WIDTH: u32 = 1;
pub const SCTLR_EL1_SPAN_SHIFT: u32 = 23;
pub const SCTLR_EL1_SPAN_WIDTH: u32 = 1;
pub const SCTLR_EL1_EIS_SHIFT: u32 = 22;
pub const SCTLR_EL1_EIS_WIDTH: u32 = 1;
pub const SCTLR_EL1_IESB_SHIFT: u32 = 21;
pub const SCTLR_EL1_IESB_WIDTH: u32 = 1;
pub const SCTLR_EL1_TSCXT_SHIFT: u32 = 20;
pub const SCTLR_EL1_TSCXT_WIDTH: u32 = 1;
pub const SCTLR_EL1_WXN_SHIFT: u32 = 19;
pub const SCTLR_EL1_WXN_WIDTH: u32 = 1;
pub const SCTLR_EL1_nTWE_SHIFT: u32 = 18;
pub const SCTLR_EL1_nTWE_WIDTH: u32 = 1;
pub const SCTLR_EL1_nTWI_SHIFT: u32 = 16;
pub const SCTLR_EL1_nTWI_WIDTH: u32 = 1;
pub const SCTLR_EL1_UCT_SHIFT: u32 = 15;
pub const SCTLR_EL1_UCT_WIDTH: u32 = 1;
pub const SCTLR_EL1_DZE_SHIFT: u32 = 14;
pub const SCTLR_EL1_DZE_WIDTH: u32 = 1;
pub const SCTLR_EL1_EnDB_SHIFT: u32 = 13;
pub const SCTLR_EL1_EnDB_WIDTH: u32 = 1;
pub const SCTLR_EL1_I_SHIFT: u32 = 12;
pub const SCTLR_EL1_I_WIDTH: u32 = 1;
pub const SCTLR_EL1_EOS_SHIFT: u32 = 11;
pub const SCTLR_EL1_EOS_WIDTH: u32 = 1;
pub const SCTLR_EL1_EnRCTX_SHIFT: u32 = 10;
pub const SCTLR_EL1_EnRCTX_WIDTH: u32 = 1;
pub const SCTLR_EL1_UMA_SHIFT: u32 = 9;
pub const SCTLR_EL1_UMA_WIDTH: u32 = 1;
pub const SCTLR_EL1_SED_SHIFT: u32 = 8;
pub const SCTLR_EL1_SED_WIDTH: u32 = 1;
pub const SCTLR_EL1_ITD_SHIFT: u32 = 7;
pub const SCTLR_EL1_ITD_WIDTH: u32 = 1;
pub const SCTLR_EL1_nAA_SHIFT: u32 = 6;
pub const SCTLR_EL1_nAA_WIDTH: u32 = 1;
pub const SCTLR_EL1_CP15BEN_SHIFT: u32 = 5;
pub const SCTLR_EL1_CP15BEN_WIDTH: u32 = 1;
pub const SCTLR_EL1_SA0_SHIFT: u32 = 4;
pub const SCTLR_EL1_SA0_WIDTH: u32 = 1;
pub const SCTLR_EL1_SA_SHIFT: u32 = 3;
pub const SCTLR_EL1_SA_WIDTH: u32 = 1;
pub const SCTLR_EL1_C_SHIFT: u32 = 2;
pub const SCTLR_EL1_C_WIDTH: u32 = 1;
pub const SCTLR_EL1_A_SHIFT: u32 = 1;
pub const SCTLR_EL1_A_WIDTH: u32 = 1;
pub const SCTLR_EL1_M_SHIFT: u32 = 0;
pub const SCTLR_EL1_M_WIDTH: u32 = 1;
pub const SYS_CPACR_EL1_Op0: u32 = 3;
pub const SYS_CPACR_EL1_Op1: u32 = 0;
pub const SYS_CPACR_EL1_CRn: u32 = 1;
pub const SYS_CPACR_EL1_CRm: u32 = 0;
pub const SYS_CPACR_EL1_Op2: u32 = 2;
pub const CPACR_EL1_E0POE_SHIFT: u32 = 29;
pub const CPACR_EL1_E0POE_WIDTH: u32 = 1;
pub const CPACR_EL1_TTA_SHIFT: u32 = 28;
pub const CPACR_EL1_TTA_WIDTH: u32 = 1;
pub const CPACR_EL1_SMEN_SHIFT: u32 = 24;
pub const CPACR_EL1_SMEN_WIDTH: u32 = 2;
pub const CPACR_EL1_FPEN_SHIFT: u32 = 20;
pub const CPACR_EL1_FPEN_WIDTH: u32 = 2;
pub const CPACR_EL1_ZEN_SHIFT: u32 = 16;
pub const CPACR_EL1_ZEN_WIDTH: u32 = 2;
pub const SYS_TRFCR_EL1_Op0: u32 = 3;
pub const SYS_TRFCR_EL1_Op1: u32 = 0;
pub const SYS_TRFCR_EL1_CRn: u32 = 1;
pub const SYS_TRFCR_EL1_CRm: u32 = 2;
pub const SYS_TRFCR_EL1_Op2: u32 = 1;
pub const TRFCR_EL1_TS_SHIFT: u32 = 5;
pub const TRFCR_EL1_TS_WIDTH: u32 = 2;
pub const TRFCR_EL1_ExTRE_SHIFT: u32 = 1;
pub const TRFCR_EL1_ExTRE_WIDTH: u32 = 1;
pub const TRFCR_EL1_E0TRE_SHIFT: u32 = 0;
pub const TRFCR_EL1_E0TRE_WIDTH: u32 = 1;
pub const SYS_SMPRI_EL1_Op0: u32 = 3;
pub const SYS_SMPRI_EL1_Op1: u32 = 0;
pub const SYS_SMPRI_EL1_CRn: u32 = 1;
pub const SYS_SMPRI_EL1_CRm: u32 = 2;
pub const SYS_SMPRI_EL1_Op2: u32 = 4;
pub const SMPRI_EL1_PRIORITY_SHIFT: u32 = 0;
pub const SMPRI_EL1_PRIORITY_WIDTH: u32 = 4;
pub const ZCR_ELx_LEN_SHIFT: u32 = 0;
pub const ZCR_ELx_LEN_WIDTH: u32 = 4;
pub const SYS_ZCR_EL1_Op0: u32 = 3;
pub const SYS_ZCR_EL1_Op1: u32 = 0;
pub const SYS_ZCR_EL1_CRn: u32 = 1;
pub const SYS_ZCR_EL1_CRm: u32 = 2;
pub const SYS_ZCR_EL1_Op2: u32 = 0;
pub const SMCR_ELx_FA64_SHIFT: u32 = 31;
pub const SMCR_ELx_FA64_WIDTH: u32 = 1;
pub const SMCR_ELx_EZT0_SHIFT: u32 = 30;
pub const SMCR_ELx_EZT0_WIDTH: u32 = 1;
pub const SMCR_ELx_LEN_SHIFT: u32 = 0;
pub const SMCR_ELx_LEN_WIDTH: u32 = 4;
pub const SYS_SMCR_EL1_Op0: u32 = 3;
pub const SYS_SMCR_EL1_Op1: u32 = 0;
pub const SYS_SMCR_EL1_CRn: u32 = 1;
pub const SYS_SMCR_EL1_CRm: u32 = 2;
pub const SYS_SMCR_EL1_Op2: u32 = 6;
pub const GCSCR_ELx_STREn_SHIFT: u32 = 9;
pub const GCSCR_ELx_STREn_WIDTH: u32 = 1;
pub const GCSCR_ELx_PUSHMEn_SHIFT: u32 = 8;
pub const GCSCR_ELx_PUSHMEn_WIDTH: u32 = 1;
pub const GCSCR_ELx_EXLOCKEN_SHIFT: u32 = 6;
pub const GCSCR_ELx_EXLOCKEN_WIDTH: u32 = 1;
pub const GCSCR_ELx_RVCHKEN_SHIFT: u32 = 5;
pub const GCSCR_ELx_RVCHKEN_WIDTH: u32 = 1;
pub const GCSCR_ELx_PCRSEL_SHIFT: u32 = 0;
pub const GCSCR_ELx_PCRSEL_WIDTH: u32 = 1;
pub const SYS_GCSCR_EL1_Op0: u32 = 3;
pub const SYS_GCSCR_EL1_Op1: u32 = 0;
pub const SYS_GCSCR_EL1_CRn: u32 = 2;
pub const SYS_GCSCR_EL1_CRm: u32 = 5;
pub const SYS_GCSCR_EL1_Op2: u32 = 0;
pub const GCSPR_ELx_PTR_SHIFT: u32 = 3;
pub const GCSPR_ELx_PTR_WIDTH: u32 = 61;
pub const SYS_GCSPR_EL1_Op0: u32 = 3;
pub const SYS_GCSPR_EL1_Op1: u32 = 0;
pub const SYS_GCSPR_EL1_CRn: u32 = 2;
pub const SYS_GCSPR_EL1_CRm: u32 = 5;
pub const SYS_GCSPR_EL1_Op2: u32 = 1;
pub const SYS_GCSCRE0_EL1_Op0: u32 = 3;
pub const SYS_GCSCRE0_EL1_Op1: u32 = 0;
pub const SYS_GCSCRE0_EL1_CRn: u32 = 2;
pub const SYS_GCSCRE0_EL1_CRm: u32 = 5;
pub const SYS_GCSCRE0_EL1_Op2: u32 = 2;
pub const GCSCRE0_EL1_nTR_SHIFT: u32 = 10;
pub const GCSCRE0_EL1_nTR_WIDTH: u32 = 1;
pub const GCSCRE0_EL1_STREn_SHIFT: u32 = 9;
pub const GCSCRE0_EL1_STREn_WIDTH: u32 = 1;
pub const GCSCRE0_EL1_PUSHMEn_SHIFT: u32 = 8;
pub const GCSCRE0_EL1_PUSHMEn_WIDTH: u32 = 1;
pub const GCSCRE0_EL1_RVCHKEN_SHIFT: u32 = 5;
pub const GCSCRE0_EL1_RVCHKEN_WIDTH: u32 = 1;
pub const GCSCRE0_EL1_PCRSEL_SHIFT: u32 = 0;
pub const GCSCRE0_EL1_PCRSEL_WIDTH: u32 = 1;
pub const SYS_ALLINT_Op0: u32 = 3;
pub const SYS_ALLINT_Op1: u32 = 0;
pub const SYS_ALLINT_CRn: u32 = 4;
pub const SYS_ALLINT_CRm: u32 = 3;
pub const SYS_ALLINT_Op2: u32 = 0;
pub const ALLINT_ALLINT_SHIFT: u32 = 13;
pub const ALLINT_ALLINT_WIDTH: u32 = 1;
pub const SYS_FAR_EL1_Op0: u32 = 3;
pub const SYS_FAR_EL1_Op1: u32 = 0;
pub const SYS_FAR_EL1_CRn: u32 = 6;
pub const SYS_FAR_EL1_CRm: u32 = 0;
pub const SYS_FAR_EL1_Op2: u32 = 0;
pub const FAR_EL1_ADDR_SHIFT: u32 = 0;
pub const FAR_EL1_ADDR_WIDTH: u32 = 64;
pub const SYS_PMICNTR_EL0_Op0: u32 = 3;
pub const SYS_PMICNTR_EL0_Op1: u32 = 3;
pub const SYS_PMICNTR_EL0_CRn: u32 = 9;
pub const SYS_PMICNTR_EL0_CRm: u32 = 4;
pub const SYS_PMICNTR_EL0_Op2: u32 = 0;
pub const PMICNTR_EL0_ICNT_SHIFT: u32 = 0;
pub const PMICNTR_EL0_ICNT_WIDTH: u32 = 64;
pub const SYS_PMICFILTR_EL0_Op0: u32 = 3;
pub const SYS_PMICFILTR_EL0_Op1: u32 = 3;
pub const SYS_PMICFILTR_EL0_CRn: u32 = 9;
pub const SYS_PMICFILTR_EL0_CRm: u32 = 6;
pub const SYS_PMICFILTR_EL0_Op2: u32 = 0;
pub const PMICFILTR_EL0_SYNC_SHIFT: u32 = 58;
pub const PMICFILTR_EL0_SYNC_WIDTH: u32 = 1;
pub const PMICFILTR_EL0_VS_SHIFT: u32 = 56;
pub const PMICFILTR_EL0_VS_WIDTH: u32 = 2;
pub const PMICFILTR_EL0_P_SHIFT: u32 = 31;
pub const PMICFILTR_EL0_P_WIDTH: u32 = 1;
pub const PMICFILTR_EL0_U_SHIFT: u32 = 30;
pub const PMICFILTR_EL0_U_WIDTH: u32 = 1;
pub const PMICFILTR_EL0_NSK_SHIFT: u32 = 29;
pub const PMICFILTR_EL0_NSK_WIDTH: u32 = 1;
pub const PMICFILTR_EL0_NSU_SHIFT: u32 = 28;
pub const PMICFILTR_EL0_NSU_WIDTH: u32 = 1;
pub const PMICFILTR_EL0_NSH_SHIFT: u32 = 27;
pub const PMICFILTR_EL0_NSH_WIDTH: u32 = 1;
pub const PMICFILTR_EL0_M_SHIFT: u32 = 26;
pub const PMICFILTR_EL0_M_WIDTH: u32 = 1;
pub const PMICFILTR_EL0_SH_SHIFT: u32 = 24;
pub const PMICFILTR_EL0_SH_WIDTH: u32 = 1;
pub const PMICFILTR_EL0_T_SHIFT: u32 = 23;
pub const PMICFILTR_EL0_T_WIDTH: u32 = 1;
pub const PMICFILTR_EL0_RLK_SHIFT: u32 = 22;
pub const PMICFILTR_EL0_RLK_WIDTH: u32 = 1;
pub const PMICFILTR_EL0_RLU_SHIFT: u32 = 21;
pub const PMICFILTR_EL0_RLU_WIDTH: u32 = 1;
pub const PMICFILTR_EL0_RLH_SHIFT: u32 = 20;
pub const PMICFILTR_EL0_RLH_WIDTH: u32 = 1;
pub const PMICFILTR_EL0_evtCount_SHIFT: u32 = 0;
pub const PMICFILTR_EL0_evtCount_WIDTH: u32 = 16;
pub const SYS_PMSCR_EL1_Op0: u32 = 3;
pub const SYS_PMSCR_EL1_Op1: u32 = 0;
pub const SYS_PMSCR_EL1_CRn: u32 = 9;
pub const SYS_PMSCR_EL1_CRm: u32 = 9;
pub const SYS_PMSCR_EL1_Op2: u32 = 0;
pub const PMSCR_EL1_PCT_SHIFT: u32 = 6;
pub const PMSCR_EL1_PCT_WIDTH: u32 = 2;
pub const PMSCR_EL1_TS_SHIFT: u32 = 5;
pub const PMSCR_EL1_TS_WIDTH: u32 = 1;
pub const PMSCR_EL1_PA_SHIFT: u32 = 4;
pub const PMSCR_EL1_PA_WIDTH: u32 = 1;
pub const PMSCR_EL1_CX_SHIFT: u32 = 3;
pub const PMSCR_EL1_CX_WIDTH: u32 = 1;
pub const PMSCR_EL1_E1SPE_SHIFT: u32 = 1;
pub const PMSCR_EL1_E1SPE_WIDTH: u32 = 1;
pub const PMSCR_EL1_E0SPE_SHIFT: u32 = 0;
pub const PMSCR_EL1_E0SPE_WIDTH: u32 = 1;
pub const SYS_PMSNEVFR_EL1_Op0: u32 = 3;
pub const SYS_PMSNEVFR_EL1_Op1: u32 = 0;
pub const SYS_PMSNEVFR_EL1_CRn: u32 = 9;
pub const SYS_PMSNEVFR_EL1_CRm: u32 = 9;
pub const SYS_PMSNEVFR_EL1_Op2: u32 = 1;
pub const PMSNEVFR_EL1_E_SHIFT: u32 = 0;
pub const PMSNEVFR_EL1_E_WIDTH: u32 = 64;
pub const SYS_PMSICR_EL1_Op0: u32 = 3;
pub const SYS_PMSICR_EL1_Op1: u32 = 0;
pub const SYS_PMSICR_EL1_CRn: u32 = 9;
pub const SYS_PMSICR_EL1_CRm: u32 = 9;
pub const SYS_PMSICR_EL1_Op2: u32 = 2;
pub const PMSICR_EL1_ECOUNT_SHIFT: u32 = 56;
pub const PMSICR_EL1_ECOUNT_WIDTH: u32 = 8;
pub const PMSICR_EL1_COUNT_SHIFT: u32 = 0;
pub const PMSICR_EL1_COUNT_WIDTH: u32 = 32;
pub const SYS_PMSIRR_EL1_Op0: u32 = 3;
pub const SYS_PMSIRR_EL1_Op1: u32 = 0;
pub const SYS_PMSIRR_EL1_CRn: u32 = 9;
pub const SYS_PMSIRR_EL1_CRm: u32 = 9;
pub const SYS_PMSIRR_EL1_Op2: u32 = 3;
pub const PMSIRR_EL1_INTERVAL_SHIFT: u32 = 8;
pub const PMSIRR_EL1_INTERVAL_WIDTH: u32 = 24;
pub const PMSIRR_EL1_RND_SHIFT: u32 = 0;
pub const PMSIRR_EL1_RND_WIDTH: u32 = 1;
pub const SYS_PMSFCR_EL1_Op0: u32 = 3;
pub const SYS_PMSFCR_EL1_Op1: u32 = 0;
pub const SYS_PMSFCR_EL1_CRn: u32 = 9;
pub const SYS_PMSFCR_EL1_CRm: u32 = 9;
pub const SYS_PMSFCR_EL1_Op2: u32 = 4;
pub const PMSFCR_EL1_ST_SHIFT: u32 = 18;
pub const PMSFCR_EL1_ST_WIDTH: u32 = 1;
pub const PMSFCR_EL1_LD_SHIFT: u32 = 17;
pub const PMSFCR_EL1_LD_WIDTH: u32 = 1;
pub const PMSFCR_EL1_B_SHIFT: u32 = 16;
pub const PMSFCR_EL1_B_WIDTH: u32 = 1;
pub const PMSFCR_EL1_FnE_SHIFT: u32 = 3;
pub const PMSFCR_EL1_FnE_WIDTH: u32 = 1;
pub const PMSFCR_EL1_FL_SHIFT: u32 = 2;
pub const PMSFCR_EL1_FL_WIDTH: u32 = 1;
pub const PMSFCR_EL1_FT_SHIFT: u32 = 1;
pub const PMSFCR_EL1_FT_WIDTH: u32 = 1;
pub const PMSFCR_EL1_FE_SHIFT: u32 = 0;
pub const PMSFCR_EL1_FE_WIDTH: u32 = 1;
pub const SYS_PMSEVFR_EL1_Op0: u32 = 3;
pub const SYS_PMSEVFR_EL1_Op1: u32 = 0;
pub const SYS_PMSEVFR_EL1_CRn: u32 = 9;
pub const SYS_PMSEVFR_EL1_CRm: u32 = 9;
pub const SYS_PMSEVFR_EL1_Op2: u32 = 5;
pub const PMSEVFR_EL1_E_SHIFT: u32 = 0;
pub const PMSEVFR_EL1_E_WIDTH: u32 = 64;
pub const SYS_PMSLATFR_EL1_Op0: u32 = 3;
pub const SYS_PMSLATFR_EL1_Op1: u32 = 0;
pub const SYS_PMSLATFR_EL1_CRn: u32 = 9;
pub const SYS_PMSLATFR_EL1_CRm: u32 = 9;
pub const SYS_PMSLATFR_EL1_Op2: u32 = 6;
pub const PMSLATFR_EL1_MINLAT_SHIFT: u32 = 0;
pub const PMSLATFR_EL1_MINLAT_WIDTH: u32 = 16;
pub const SYS_PMSIDR_EL1_Op0: u32 = 3;
pub const SYS_PMSIDR_EL1_Op1: u32 = 0;
pub const SYS_PMSIDR_EL1_CRn: u32 = 9;
pub const SYS_PMSIDR_EL1_CRm: u32 = 9;
pub const SYS_PMSIDR_EL1_Op2: u32 = 7;
pub const PMSIDR_EL1_PBT_SHIFT: u32 = 24;
pub const PMSIDR_EL1_PBT_WIDTH: u32 = 1;
pub const PMSIDR_EL1_FORMAT_SHIFT: u32 = 20;
pub const PMSIDR_EL1_FORMAT_WIDTH: u32 = 4;
pub const PMSIDR_EL1_COUNTSIZE_SHIFT: u32 = 16;
pub const PMSIDR_EL1_COUNTSIZE_WIDTH: u32 = 4;
pub const PMSIDR_EL1_MAXSIZE_SHIFT: u32 = 12;
pub const PMSIDR_EL1_MAXSIZE_WIDTH: u32 = 4;
pub const PMSIDR_EL1_INTERVAL_SHIFT: u32 = 8;
pub const PMSIDR_EL1_INTERVAL_WIDTH: u32 = 4;
pub const PMSIDR_EL1_FnE_SHIFT: u32 = 6;
pub const PMSIDR_EL1_FnE_WIDTH: u32 = 1;
pub const PMSIDR_EL1_ERND_SHIFT: u32 = 5;
pub const PMSIDR_EL1_ERND_WIDTH: u32 = 1;
pub const PMSIDR_EL1_LDS_SHIFT: u32 = 4;
pub const PMSIDR_EL1_LDS_WIDTH: u32 = 1;
pub const PMSIDR_EL1_ARCHINST_SHIFT: u32 = 3;
pub const PMSIDR_EL1_ARCHINST_WIDTH: u32 = 1;
pub const PMSIDR_EL1_FL_SHIFT: u32 = 2;
pub const PMSIDR_EL1_FL_WIDTH: u32 = 1;
pub const PMSIDR_EL1_FT_SHIFT: u32 = 1;
pub const PMSIDR_EL1_FT_WIDTH: u32 = 1;
pub const PMSIDR_EL1_FE_SHIFT: u32 = 0;
pub const PMSIDR_EL1_FE_WIDTH: u32 = 1;
pub const SYS_PMBLIMITR_EL1_Op0: u32 = 3;
pub const SYS_PMBLIMITR_EL1_Op1: u32 = 0;
pub const SYS_PMBLIMITR_EL1_CRn: u32 = 9;
pub const SYS_PMBLIMITR_EL1_CRm: u32 = 10;
pub const SYS_PMBLIMITR_EL1_Op2: u32 = 0;
pub const PMBLIMITR_EL1_LIMIT_SHIFT: u32 = 12;
pub const PMBLIMITR_EL1_LIMIT_WIDTH: u32 = 52;
pub const PMBLIMITR_EL1_PMFZ_SHIFT: u32 = 5;
pub const PMBLIMITR_EL1_PMFZ_WIDTH: u32 = 1;
pub const PMBLIMITR_EL1_FM_SHIFT: u32 = 1;
pub const PMBLIMITR_EL1_FM_WIDTH: u32 = 2;
pub const PMBLIMITR_EL1_E_SHIFT: u32 = 0;
pub const PMBLIMITR_EL1_E_WIDTH: u32 = 1;
pub const SYS_PMBPTR_EL1_Op0: u32 = 3;
pub const SYS_PMBPTR_EL1_Op1: u32 = 0;
pub const SYS_PMBPTR_EL1_CRn: u32 = 9;
pub const SYS_PMBPTR_EL1_CRm: u32 = 10;
pub const SYS_PMBPTR_EL1_Op2: u32 = 1;
pub const PMBPTR_EL1_PTR_SHIFT: u32 = 0;
pub const PMBPTR_EL1_PTR_WIDTH: u32 = 64;
pub const SYS_PMBSR_EL1_Op0: u32 = 3;
pub const SYS_PMBSR_EL1_Op1: u32 = 0;
pub const SYS_PMBSR_EL1_CRn: u32 = 9;
pub const SYS_PMBSR_EL1_CRm: u32 = 10;
pub const SYS_PMBSR_EL1_Op2: u32 = 3;
pub const PMBSR_EL1_EC_SHIFT: u32 = 26;
pub const PMBSR_EL1_EC_WIDTH: u32 = 6;
pub const PMBSR_EL1_DL_SHIFT: u32 = 19;
pub const PMBSR_EL1_DL_WIDTH: u32 = 1;
pub const PMBSR_EL1_EA_SHIFT: u32 = 18;
pub const PMBSR_EL1_EA_WIDTH: u32 = 1;
pub const PMBSR_EL1_S_SHIFT: u32 = 17;
pub const PMBSR_EL1_S_WIDTH: u32 = 1;
pub const PMBSR_EL1_COLL_SHIFT: u32 = 16;
pub const PMBSR_EL1_COLL_WIDTH: u32 = 1;
pub const PMBSR_EL1_MSS_SHIFT: u32 = 0;
pub const PMBSR_EL1_MSS_WIDTH: u32 = 16;
pub const SYS_PMBIDR_EL1_Op0: u32 = 3;
pub const SYS_PMBIDR_EL1_Op1: u32 = 0;
pub const SYS_PMBIDR_EL1_CRn: u32 = 9;
pub const SYS_PMBIDR_EL1_CRm: u32 = 10;
pub const SYS_PMBIDR_EL1_Op2: u32 = 7;
pub const PMBIDR_EL1_EA_SHIFT: u32 = 8;
pub const PMBIDR_EL1_EA_WIDTH: u32 = 4;
pub const PMBIDR_EL1_F_SHIFT: u32 = 5;
pub const PMBIDR_EL1_F_WIDTH: u32 = 1;
pub const PMBIDR_EL1_P_SHIFT: u32 = 4;
pub const PMBIDR_EL1_P_WIDTH: u32 = 1;
pub const PMBIDR_EL1_ALIGN_SHIFT: u32 = 0;
pub const PMBIDR_EL1_ALIGN_WIDTH: u32 = 4;
pub const SYS_PMUACR_EL1_Op0: u32 = 3;
pub const SYS_PMUACR_EL1_Op1: u32 = 0;
pub const SYS_PMUACR_EL1_CRn: u32 = 9;
pub const SYS_PMUACR_EL1_CRm: u32 = 14;
pub const SYS_PMUACR_EL1_Op2: u32 = 4;
pub const PMUACR_EL1_F0_SHIFT: u32 = 32;
pub const PMUACR_EL1_F0_WIDTH: u32 = 1;
pub const PMUACR_EL1_C_SHIFT: u32 = 31;
pub const PMUACR_EL1_C_WIDTH: u32 = 1;
pub const PMUACR_EL1_P_SHIFT: u32 = 0;
pub const PMUACR_EL1_P_WIDTH: u32 = 31;
pub const SYS_PMSELR_EL0_Op0: u32 = 3;
pub const SYS_PMSELR_EL0_Op1: u32 = 3;
pub const SYS_PMSELR_EL0_CRn: u32 = 9;
pub const SYS_PMSELR_EL0_CRm: u32 = 12;
pub const SYS_PMSELR_EL0_Op2: u32 = 5;
pub const PMSELR_EL0_SEL_SHIFT: u32 = 0;
pub const PMSELR_EL0_SEL_WIDTH: u32 = 5;
pub const CONTEXTIDR_ELx_PROCID_SHIFT: u32 = 0;
pub const CONTEXTIDR_ELx_PROCID_WIDTH: u32 = 32;
pub const SYS_CONTEXTIDR_EL1_Op0: u32 = 3;
pub const SYS_CONTEXTIDR_EL1_Op1: u32 = 0;
pub const SYS_CONTEXTIDR_EL1_CRn: u32 = 13;
pub const SYS_CONTEXTIDR_EL1_CRm: u32 = 0;
pub const SYS_CONTEXTIDR_EL1_Op2: u32 = 1;
pub const SYS_RCWSMASK_EL1_Op0: u32 = 3;
pub const SYS_RCWSMASK_EL1_Op1: u32 = 0;
pub const SYS_RCWSMASK_EL1_CRn: u32 = 13;
pub const SYS_RCWSMASK_EL1_CRm: u32 = 0;
pub const SYS_RCWSMASK_EL1_Op2: u32 = 3;
pub const RCWSMASK_EL1_RCWSMASK_SHIFT: u32 = 0;
pub const RCWSMASK_EL1_RCWSMASK_WIDTH: u32 = 64;
pub const SYS_TPIDR_EL1_Op0: u32 = 3;
pub const SYS_TPIDR_EL1_Op1: u32 = 0;
pub const SYS_TPIDR_EL1_CRn: u32 = 13;
pub const SYS_TPIDR_EL1_CRm: u32 = 0;
pub const SYS_TPIDR_EL1_Op2: u32 = 4;
pub const TPIDR_EL1_ThreadID_SHIFT: u32 = 0;
pub const TPIDR_EL1_ThreadID_WIDTH: u32 = 64;
pub const SYS_RCWMASK_EL1_Op0: u32 = 3;
pub const SYS_RCWMASK_EL1_Op1: u32 = 0;
pub const SYS_RCWMASK_EL1_CRn: u32 = 13;
pub const SYS_RCWMASK_EL1_CRm: u32 = 0;
pub const SYS_RCWMASK_EL1_Op2: u32 = 6;
pub const RCWMASK_EL1_RCWMASK_SHIFT: u32 = 0;
pub const RCWMASK_EL1_RCWMASK_WIDTH: u32 = 64;
pub const SYS_SCXTNUM_EL1_Op0: u32 = 3;
pub const SYS_SCXTNUM_EL1_Op1: u32 = 0;
pub const SYS_SCXTNUM_EL1_CRn: u32 = 13;
pub const SYS_SCXTNUM_EL1_CRm: u32 = 0;
pub const SYS_SCXTNUM_EL1_Op2: u32 = 7;
pub const SCXTNUM_EL1_SoftwareContextNumber_SHIFT: u32 = 0;
pub const SCXTNUM_EL1_SoftwareContextNumber_WIDTH: u32 = 64;
pub const SYS_CCSIDR_EL1_Op0: u32 = 3;
pub const SYS_CCSIDR_EL1_Op1: u32 = 1;
pub const SYS_CCSIDR_EL1_CRn: u32 = 0;
pub const SYS_CCSIDR_EL1_CRm: u32 = 0;
pub const SYS_CCSIDR_EL1_Op2: u32 = 0;
pub const CCSIDR_EL1_NumSets_SHIFT: u32 = 13;
pub const CCSIDR_EL1_NumSets_WIDTH: u32 = 15;
pub const CCSIDR_EL1_Associativity_SHIFT: u32 = 3;
pub const CCSIDR_EL1_Associativity_WIDTH: u32 = 10;
pub const CCSIDR_EL1_LineSize_SHIFT: u32 = 0;
pub const CCSIDR_EL1_LineSize_WIDTH: u32 = 3;
pub const SYS_CLIDR_EL1_Op0: u32 = 3;
pub const SYS_CLIDR_EL1_Op1: u32 = 1;
pub const SYS_CLIDR_EL1_CRn: u32 = 0;
pub const SYS_CLIDR_EL1_CRm: u32 = 0;
pub const SYS_CLIDR_EL1_Op2: u32 = 1;
pub const CLIDR_EL1_Ttypen_SHIFT: u32 = 33;
pub const CLIDR_EL1_Ttypen_WIDTH: u32 = 14;
pub const CLIDR_EL1_ICB_SHIFT: u32 = 30;
pub const CLIDR_EL1_ICB_WIDTH: u32 = 3;
pub const CLIDR_EL1_LoUU_SHIFT: u32 = 27;
pub const CLIDR_EL1_LoUU_WIDTH: u32 = 3;
pub const CLIDR_EL1_LoC_SHIFT: u32 = 24;
pub const CLIDR_EL1_LoC_WIDTH: u32 = 3;
pub const CLIDR_EL1_LoUIS_SHIFT: u32 = 21;
pub const CLIDR_EL1_LoUIS_WIDTH: u32 = 3;
pub const CLIDR_EL1_Ctype7_SHIFT: u32 = 18;
pub const CLIDR_EL1_Ctype7_WIDTH: u32 = 3;
pub const CLIDR_EL1_Ctype6_SHIFT: u32 = 15;
pub const CLIDR_EL1_Ctype6_WIDTH: u32 = 3;
pub const CLIDR_EL1_Ctype5_SHIFT: u32 = 12;
pub const CLIDR_EL1_Ctype5_WIDTH: u32 = 3;
pub const CLIDR_EL1_Ctype4_SHIFT: u32 = 9;
pub const CLIDR_EL1_Ctype4_WIDTH: u32 = 3;
pub const CLIDR_EL1_Ctype3_SHIFT: u32 = 6;
pub const CLIDR_EL1_Ctype3_WIDTH: u32 = 3;
pub const CLIDR_EL1_Ctype2_SHIFT: u32 = 3;
pub const CLIDR_EL1_Ctype2_WIDTH: u32 = 3;
pub const CLIDR_EL1_Ctype1_SHIFT: u32 = 0;
pub const CLIDR_EL1_Ctype1_WIDTH: u32 = 3;
pub const SYS_CCSIDR2_EL1_Op0: u32 = 3;
pub const SYS_CCSIDR2_EL1_Op1: u32 = 1;
pub const SYS_CCSIDR2_EL1_CRn: u32 = 0;
pub const SYS_CCSIDR2_EL1_CRm: u32 = 0;
pub const SYS_CCSIDR2_EL1_Op2: u32 = 2;
pub const CCSIDR2_EL1_NumSets_SHIFT: u32 = 0;
pub const CCSIDR2_EL1_NumSets_WIDTH: u32 = 24;
pub const SYS_GMID_EL1_Op0: u32 = 3;
pub const SYS_GMID_EL1_Op1: u32 = 1;
pub const SYS_GMID_EL1_CRn: u32 = 0;
pub const SYS_GMID_EL1_CRm: u32 = 0;
pub const SYS_GMID_EL1_Op2: u32 = 4;
pub const GMID_EL1_BS_SHIFT: u32 = 0;
pub const GMID_EL1_BS_WIDTH: u32 = 4;
pub const SYS_SMIDR_EL1_Op0: u32 = 3;
pub const SYS_SMIDR_EL1_Op1: u32 = 1;
pub const SYS_SMIDR_EL1_CRn: u32 = 0;
pub const SYS_SMIDR_EL1_CRm: u32 = 0;
pub const SYS_SMIDR_EL1_Op2: u32 = 6;
pub const SMIDR_EL1_IMPLEMENTER_SHIFT: u32 = 24;
pub const SMIDR_EL1_IMPLEMENTER_WIDTH: u32 = 8;
pub const SMIDR_EL1_REVISION_SHIFT: u32 = 16;
pub const SMIDR_EL1_REVISION_WIDTH: u32 = 8;
pub const SMIDR_EL1_SMPS_SHIFT: u32 = 15;
pub const SMIDR_EL1_SMPS_WIDTH: u32 = 1;
pub const SMIDR_EL1_AFFINITY_SHIFT: u32 = 0;
pub const SMIDR_EL1_AFFINITY_WIDTH: u32 = 12;
pub const SYS_CSSELR_EL1_Op0: u32 = 3;
pub const SYS_CSSELR_EL1_Op1: u32 = 2;
pub const SYS_CSSELR_EL1_CRn: u32 = 0;
pub const SYS_CSSELR_EL1_CRm: u32 = 0;
pub const SYS_CSSELR_EL1_Op2: u32 = 0;
pub const CSSELR_EL1_TnD_SHIFT: u32 = 4;
pub const CSSELR_EL1_TnD_WIDTH: u32 = 1;
pub const CSSELR_EL1_Level_SHIFT: u32 = 1;
pub const CSSELR_EL1_Level_WIDTH: u32 = 3;
pub const CSSELR_EL1_InD_SHIFT: u32 = 0;
pub const CSSELR_EL1_InD_WIDTH: u32 = 1;
pub const SYS_CTR_EL0_Op0: u32 = 3;
pub const SYS_CTR_EL0_Op1: u32 = 3;
pub const SYS_CTR_EL0_CRn: u32 = 0;
pub const SYS_CTR_EL0_CRm: u32 = 0;
pub const SYS_CTR_EL0_Op2: u32 = 1;
pub const CTR_EL0_TminLine_SHIFT: u32 = 32;
pub const CTR_EL0_TminLine_WIDTH: u32 = 6;
pub const CTR_EL0_DIC_SHIFT: u32 = 29;
pub const CTR_EL0_DIC_WIDTH: u32 = 1;
pub const CTR_EL0_IDC_SHIFT: u32 = 28;
pub const CTR_EL0_IDC_WIDTH: u32 = 1;
pub const CTR_EL0_CWG_SHIFT: u32 = 24;
pub const CTR_EL0_CWG_WIDTH: u32 = 4;
pub const CTR_EL0_ERG_SHIFT: u32 = 20;
pub const CTR_EL0_ERG_WIDTH: u32 = 4;
pub const CTR_EL0_DminLine_SHIFT: u32 = 16;
pub const CTR_EL0_DminLine_WIDTH: u32 = 4;
pub const CTR_EL0_L1Ip_SHIFT: u32 = 14;
pub const CTR_EL0_L1Ip_WIDTH: u32 = 2;
pub const CTR_EL0_IminLine_SHIFT: u32 = 0;
pub const CTR_EL0_IminLine_WIDTH: u32 = 4;
pub const SYS_DCZID_EL0_Op0: u32 = 3;
pub const SYS_DCZID_EL0_Op1: u32 = 3;
pub const SYS_DCZID_EL0_CRn: u32 = 0;
pub const SYS_DCZID_EL0_CRm: u32 = 0;
pub const SYS_DCZID_EL0_Op2: u32 = 7;
pub const DCZID_EL0_DZP_SHIFT: u32 = 4;
pub const DCZID_EL0_DZP_WIDTH: u32 = 1;
pub const DCZID_EL0_BS_SHIFT: u32 = 0;
pub const DCZID_EL0_BS_WIDTH: u32 = 4;
pub const SYS_GCSPR_EL0_Op0: u32 = 3;
pub const SYS_GCSPR_EL0_Op1: u32 = 3;
pub const SYS_GCSPR_EL0_CRn: u32 = 2;
pub const SYS_GCSPR_EL0_CRm: u32 = 5;
pub const SYS_GCSPR_EL0_Op2: u32 = 1;
pub const SYS_SVCR_Op0: u32 = 3;
pub const SYS_SVCR_Op1: u32 = 3;
pub const SYS_SVCR_CRn: u32 = 4;
pub const SYS_SVCR_CRm: u32 = 2;
pub const SYS_SVCR_Op2: u32 = 2;
pub const SVCR_ZA_SHIFT: u32 = 1;
pub const SVCR_ZA_WIDTH: u32 = 1;
pub const SVCR_SM_SHIFT: u32 = 0;
pub const SVCR_SM_WIDTH: u32 = 1;
pub const SYS_FPMR_Op0: u32 = 3;
pub const SYS_FPMR_Op1: u32 = 3;
pub const SYS_FPMR_CRn: u32 = 4;
pub const SYS_FPMR_CRm: u32 = 4;
pub const SYS_FPMR_Op2: u32 = 2;
pub const FPMR_LSCALE2_SHIFT: u32 = 32;
pub const FPMR_LSCALE2_WIDTH: u32 = 6;
pub const FPMR_NSCALE_SHIFT: u32 = 24;
pub const FPMR_NSCALE_WIDTH: u32 = 8;
pub const FPMR_LSCALE_SHIFT: u32 = 16;
pub const FPMR_LSCALE_WIDTH: u32 = 7;
pub const FPMR_OSC_SHIFT: u32 = 15;
pub const FPMR_OSC_WIDTH: u32 = 1;
pub const FPMR_OSM_SHIFT: u32 = 14;
pub const FPMR_OSM_WIDTH: u32 = 1;
pub const FPMR_F8D_SHIFT: u32 = 6;
pub const FPMR_F8D_WIDTH: u32 = 3;
pub const FPMR_F8S2_SHIFT: u32 = 3;
pub const FPMR_F8S2_WIDTH: u32 = 3;
pub const FPMR_F8S1_SHIFT: u32 = 0;
pub const FPMR_F8S1_WIDTH: u32 = 3;
pub const HFGxTR_EL2_nAMAIR2_EL1_SHIFT: u32 = 63;
pub const HFGxTR_EL2_nAMAIR2_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_nMAIR2_EL1_SHIFT: u32 = 62;
pub const HFGxTR_EL2_nMAIR2_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_nS2POR_EL1_SHIFT: u32 = 61;
pub const HFGxTR_EL2_nS2POR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_nPOR_EL1_SHIFT: u32 = 60;
pub const HFGxTR_EL2_nPOR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_nPOR_EL0_SHIFT: u32 = 59;
pub const HFGxTR_EL2_nPOR_EL0_WIDTH: u32 = 1;
pub const HFGxTR_EL2_nPIR_EL1_SHIFT: u32 = 58;
pub const HFGxTR_EL2_nPIR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_nPIRE0_EL1_SHIFT: u32 = 57;
pub const HFGxTR_EL2_nPIRE0_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_nRCWMASK_EL1_SHIFT: u32 = 56;
pub const HFGxTR_EL2_nRCWMASK_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_nTPIDR2_EL0_SHIFT: u32 = 55;
pub const HFGxTR_EL2_nTPIDR2_EL0_WIDTH: u32 = 1;
pub const HFGxTR_EL2_nSMPRI_EL1_SHIFT: u32 = 54;
pub const HFGxTR_EL2_nSMPRI_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_nGCS_EL1_SHIFT: u32 = 53;
pub const HFGxTR_EL2_nGCS_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_nGCS_EL0_SHIFT: u32 = 52;
pub const HFGxTR_EL2_nGCS_EL0_WIDTH: u32 = 1;
pub const HFGxTR_EL2_nACCDATA_EL1_SHIFT: u32 = 50;
pub const HFGxTR_EL2_nACCDATA_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_ERXADDR_EL1_SHIFT: u32 = 49;
pub const HFGxTR_EL2_ERXADDR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_ERXPFGCDN_EL1_SHIFT: u32 = 48;
pub const HFGxTR_EL2_ERXPFGCDN_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_ERXPFGCTL_EL1_SHIFT: u32 = 47;
pub const HFGxTR_EL2_ERXPFGCTL_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_ERXPFGF_EL1_SHIFT: u32 = 46;
pub const HFGxTR_EL2_ERXPFGF_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_ERXMISCn_EL1_SHIFT: u32 = 45;
pub const HFGxTR_EL2_ERXMISCn_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_ERXSTATUS_EL1_SHIFT: u32 = 44;
pub const HFGxTR_EL2_ERXSTATUS_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_ERXCTLR_EL1_SHIFT: u32 = 43;
pub const HFGxTR_EL2_ERXCTLR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_ERXFR_EL1_SHIFT: u32 = 42;
pub const HFGxTR_EL2_ERXFR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_ERRSELR_EL1_SHIFT: u32 = 41;
pub const HFGxTR_EL2_ERRSELR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_ERRIDR_EL1_SHIFT: u32 = 40;
pub const HFGxTR_EL2_ERRIDR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_ICC_IGRPENn_EL1_SHIFT: u32 = 39;
pub const HFGxTR_EL2_ICC_IGRPENn_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_VBAR_EL1_SHIFT: u32 = 38;
pub const HFGxTR_EL2_VBAR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_TTBR1_EL1_SHIFT: u32 = 37;
pub const HFGxTR_EL2_TTBR1_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_TTBR0_EL1_SHIFT: u32 = 36;
pub const HFGxTR_EL2_TTBR0_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_TPIDR_EL0_SHIFT: u32 = 35;
pub const HFGxTR_EL2_TPIDR_EL0_WIDTH: u32 = 1;
pub const HFGxTR_EL2_TPIDRRO_EL0_SHIFT: u32 = 34;
pub const HFGxTR_EL2_TPIDRRO_EL0_WIDTH: u32 = 1;
pub const HFGxTR_EL2_TPIDR_EL1_SHIFT: u32 = 33;
pub const HFGxTR_EL2_TPIDR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_TCR_EL1_SHIFT: u32 = 32;
pub const HFGxTR_EL2_TCR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_SCXTNUM_EL0_SHIFT: u32 = 31;
pub const HFGxTR_EL2_SCXTNUM_EL0_WIDTH: u32 = 1;
pub const HFGxTR_EL2_SCXTNUM_EL1_SHIFT: u32 = 30;
pub const HFGxTR_EL2_SCXTNUM_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_SCTLR_EL1_SHIFT: u32 = 29;
pub const HFGxTR_EL2_SCTLR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_REVIDR_EL1_SHIFT: u32 = 28;
pub const HFGxTR_EL2_REVIDR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_PAR_EL1_SHIFT: u32 = 27;
pub const HFGxTR_EL2_PAR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_MPIDR_EL1_SHIFT: u32 = 26;
pub const HFGxTR_EL2_MPIDR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_MIDR_EL1_SHIFT: u32 = 25;
pub const HFGxTR_EL2_MIDR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_MAIR_EL1_SHIFT: u32 = 24;
pub const HFGxTR_EL2_MAIR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_LORSA_EL1_SHIFT: u32 = 23;
pub const HFGxTR_EL2_LORSA_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_LORN_EL1_SHIFT: u32 = 22;
pub const HFGxTR_EL2_LORN_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_LORID_EL1_SHIFT: u32 = 21;
pub const HFGxTR_EL2_LORID_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_LOREA_EL1_SHIFT: u32 = 20;
pub const HFGxTR_EL2_LOREA_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_LORC_EL1_SHIFT: u32 = 19;
pub const HFGxTR_EL2_LORC_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_ISR_EL1_SHIFT: u32 = 18;
pub const HFGxTR_EL2_ISR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_FAR_EL1_SHIFT: u32 = 17;
pub const HFGxTR_EL2_FAR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_ESR_EL1_SHIFT: u32 = 16;
pub const HFGxTR_EL2_ESR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_DCZID_EL0_SHIFT: u32 = 15;
pub const HFGxTR_EL2_DCZID_EL0_WIDTH: u32 = 1;
pub const HFGxTR_EL2_CTR_EL0_SHIFT: u32 = 14;
pub const HFGxTR_EL2_CTR_EL0_WIDTH: u32 = 1;
pub const HFGxTR_EL2_CSSELR_EL1_SHIFT: u32 = 13;
pub const HFGxTR_EL2_CSSELR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_CPACR_EL1_SHIFT: u32 = 12;
pub const HFGxTR_EL2_CPACR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_CONTEXTIDR_EL1_SHIFT: u32 = 11;
pub const HFGxTR_EL2_CONTEXTIDR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_CLIDR_EL1_SHIFT: u32 = 10;
pub const HFGxTR_EL2_CLIDR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_CCSIDR_EL1_SHIFT: u32 = 9;
pub const HFGxTR_EL2_CCSIDR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_APIBKey_SHIFT: u32 = 8;
pub const HFGxTR_EL2_APIBKey_WIDTH: u32 = 1;
pub const HFGxTR_EL2_APIAKey_SHIFT: u32 = 7;
pub const HFGxTR_EL2_APIAKey_WIDTH: u32 = 1;
pub const HFGxTR_EL2_APGAKey_SHIFT: u32 = 6;
pub const HFGxTR_EL2_APGAKey_WIDTH: u32 = 1;
pub const HFGxTR_EL2_APDBKey_SHIFT: u32 = 5;
pub const HFGxTR_EL2_APDBKey_WIDTH: u32 = 1;
pub const HFGxTR_EL2_APDAKey_SHIFT: u32 = 4;
pub const HFGxTR_EL2_APDAKey_WIDTH: u32 = 1;
pub const HFGxTR_EL2_AMAIR_EL1_SHIFT: u32 = 3;
pub const HFGxTR_EL2_AMAIR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_AIDR_EL1_SHIFT: u32 = 2;
pub const HFGxTR_EL2_AIDR_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_AFSR1_EL1_SHIFT: u32 = 1;
pub const HFGxTR_EL2_AFSR1_EL1_WIDTH: u32 = 1;
pub const HFGxTR_EL2_AFSR0_EL1_SHIFT: u32 = 0;
pub const HFGxTR_EL2_AFSR0_EL1_WIDTH: u32 = 1;
pub const SYS_MDCR_EL2_Op0: u32 = 3;
pub const SYS_MDCR_EL2_Op1: u32 = 4;
pub const SYS_MDCR_EL2_CRn: u32 = 1;
pub const SYS_MDCR_EL2_CRm: u32 = 1;
pub const SYS_MDCR_EL2_Op2: u32 = 1;
pub const MDCR_EL2_EnSTEPOP_SHIFT: u32 = 50;
pub const MDCR_EL2_EnSTEPOP_WIDTH: u32 = 1;
pub const MDCR_EL2_EBWE_SHIFT: u32 = 43;
pub const MDCR_EL2_EBWE_WIDTH: u32 = 1;
pub const MDCR_EL2_PMEE_SHIFT: u32 = 40;
pub const MDCR_EL2_PMEE_WIDTH: u32 = 2;
pub const MDCR_EL2_HPMFZS_SHIFT: u32 = 36;
pub const MDCR_EL2_HPMFZS_WIDTH: u32 = 1;
pub const MDCR_EL2_PMSSE_SHIFT: u32 = 30;
pub const MDCR_EL2_PMSSE_WIDTH: u32 = 2;
pub const MDCR_EL2_HPMFZO_SHIFT: u32 = 29;
pub const MDCR_EL2_HPMFZO_WIDTH: u32 = 1;
pub const MDCR_EL2_MTPME_SHIFT: u32 = 28;
pub const MDCR_EL2_MTPME_WIDTH: u32 = 1;
pub const MDCR_EL2_TDCC_SHIFT: u32 = 27;
pub const MDCR_EL2_TDCC_WIDTH: u32 = 1;
pub const MDCR_EL2_HLP_SHIFT: u32 = 26;
pub const MDCR_EL2_HLP_WIDTH: u32 = 1;
pub const MDCR_EL2_E2TB_SHIFT: u32 = 24;
pub const MDCR_EL2_E2TB_WIDTH: u32 = 2;
pub const MDCR_EL2_HCCD_SHIFT: u32 = 23;
pub const MDCR_EL2_HCCD_WIDTH: u32 = 1;
pub const MDCR_EL2_TTRF_SHIFT: u32 = 19;
pub const MDCR_EL2_TTRF_WIDTH: u32 = 1;
pub const MDCR_EL2_HPMD_SHIFT: u32 = 17;
pub const MDCR_EL2_HPMD_WIDTH: u32 = 1;
pub const MDCR_EL2_EnSPM_SHIFT: u32 = 15;
pub const MDCR_EL2_EnSPM_WIDTH: u32 = 1;
pub const MDCR_EL2_TPMS_SHIFT: u32 = 14;
pub const MDCR_EL2_TPMS_WIDTH: u32 = 1;
pub const MDCR_EL2_E2PB_SHIFT: u32 = 12;
pub const MDCR_EL2_E2PB_WIDTH: u32 = 2;
pub const MDCR_EL2_TDRA_SHIFT: u32 = 11;
pub const MDCR_EL2_TDRA_WIDTH: u32 = 1;
pub const MDCR_EL2_TDOSA_SHIFT: u32 = 10;
pub const MDCR_EL2_TDOSA_WIDTH: u32 = 1;
pub const MDCR_EL2_TDA_SHIFT: u32 = 9;
pub const MDCR_EL2_TDA_WIDTH: u32 = 1;
pub const MDCR_EL2_TDE_SHIFT: u32 = 8;
pub const MDCR_EL2_TDE_WIDTH: u32 = 1;
pub const MDCR_EL2_HPME_SHIFT: u32 = 7;
pub const MDCR_EL2_HPME_WIDTH: u32 = 1;
pub const MDCR_EL2_TPM_SHIFT: u32 = 6;
pub const MDCR_EL2_TPM_WIDTH: u32 = 1;
pub const MDCR_EL2_TPMCR_SHIFT: u32 = 5;
pub const MDCR_EL2_TPMCR_WIDTH: u32 = 1;
pub const MDCR_EL2_HPMN_SHIFT: u32 = 0;
pub const MDCR_EL2_HPMN_WIDTH: u32 = 5;
pub const SYS_HFGRTR_EL2_Op0: u32 = 3;
pub const SYS_HFGRTR_EL2_Op1: u32 = 4;
pub const SYS_HFGRTR_EL2_CRn: u32 = 1;
pub const SYS_HFGRTR_EL2_CRm: u32 = 1;
pub const SYS_HFGRTR_EL2_Op2: u32 = 4;
pub const SYS_HFGWTR_EL2_Op0: u32 = 3;
pub const SYS_HFGWTR_EL2_Op1: u32 = 4;
pub const SYS_HFGWTR_EL2_CRn: u32 = 1;
pub const SYS_HFGWTR_EL2_CRm: u32 = 1;
pub const SYS_HFGWTR_EL2_Op2: u32 = 5;
pub const SYS_HFGITR_EL2_Op0: u32 = 3;
pub const SYS_HFGITR_EL2_Op1: u32 = 4;
pub const SYS_HFGITR_EL2_CRn: u32 = 1;
pub const SYS_HFGITR_EL2_CRm: u32 = 1;
pub const SYS_HFGITR_EL2_Op2: u32 = 6;
pub const HFGITR_EL2_ATS1E1A_SHIFT: u32 = 62;
pub const HFGITR_EL2_ATS1E1A_WIDTH: u32 = 1;
pub const HFGITR_EL2_COSPRCTX_SHIFT: u32 = 60;
pub const HFGITR_EL2_COSPRCTX_WIDTH: u32 = 1;
pub const HFGITR_EL2_nGCSEPP_SHIFT: u32 = 59;
pub const HFGITR_EL2_nGCSEPP_WIDTH: u32 = 1;
pub const HFGITR_EL2_nGCSSTR_EL1_SHIFT: u32 = 58;
pub const HFGITR_EL2_nGCSSTR_EL1_WIDTH: u32 = 1;
pub const HFGITR_EL2_nGCSPUSHM_EL1_SHIFT: u32 = 57;
pub const HFGITR_EL2_nGCSPUSHM_EL1_WIDTH: u32 = 1;
pub const HFGITR_EL2_nBRBIALL_SHIFT: u32 = 56;
pub const HFGITR_EL2_nBRBIALL_WIDTH: u32 = 1;
pub const HFGITR_EL2_nBRBINJ_SHIFT: u32 = 55;
pub const HFGITR_EL2_nBRBINJ_WIDTH: u32 = 1;
pub const HFGITR_EL2_DCCVAC_SHIFT: u32 = 54;
pub const HFGITR_EL2_DCCVAC_WIDTH: u32 = 1;
pub const HFGITR_EL2_SVC_EL1_SHIFT: u32 = 53;
pub const HFGITR_EL2_SVC_EL1_WIDTH: u32 = 1;
pub const HFGITR_EL2_SVC_EL0_SHIFT: u32 = 52;
pub const HFGITR_EL2_SVC_EL0_WIDTH: u32 = 1;
pub const HFGITR_EL2_ERET_SHIFT: u32 = 51;
pub const HFGITR_EL2_ERET_WIDTH: u32 = 1;
pub const HFGITR_EL2_CPPRCTX_SHIFT: u32 = 50;
pub const HFGITR_EL2_CPPRCTX_WIDTH: u32 = 1;
pub const HFGITR_EL2_DVPRCTX_SHIFT: u32 = 49;
pub const HFGITR_EL2_DVPRCTX_WIDTH: u32 = 1;
pub const HFGITR_EL2_CFPRCTX_SHIFT: u32 = 48;
pub const HFGITR_EL2_CFPRCTX_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIVAALE1_SHIFT: u32 = 47;
pub const HFGITR_EL2_TLBIVAALE1_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIVALE1_SHIFT: u32 = 46;
pub const HFGITR_EL2_TLBIVALE1_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIVAAE1_SHIFT: u32 = 45;
pub const HFGITR_EL2_TLBIVAAE1_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIASIDE1_SHIFT: u32 = 44;
pub const HFGITR_EL2_TLBIASIDE1_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIVAE1_SHIFT: u32 = 43;
pub const HFGITR_EL2_TLBIVAE1_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIVMALLE1_SHIFT: u32 = 42;
pub const HFGITR_EL2_TLBIVMALLE1_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIRVAALE1_SHIFT: u32 = 41;
pub const HFGITR_EL2_TLBIRVAALE1_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIRVALE1_SHIFT: u32 = 40;
pub const HFGITR_EL2_TLBIRVALE1_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIRVAAE1_SHIFT: u32 = 39;
pub const HFGITR_EL2_TLBIRVAAE1_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIRVAE1_SHIFT: u32 = 38;
pub const HFGITR_EL2_TLBIRVAE1_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIRVAALE1IS_SHIFT: u32 = 37;
pub const HFGITR_EL2_TLBIRVAALE1IS_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIRVALE1IS_SHIFT: u32 = 36;
pub const HFGITR_EL2_TLBIRVALE1IS_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIRVAAE1IS_SHIFT: u32 = 35;
pub const HFGITR_EL2_TLBIRVAAE1IS_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIRVAE1IS_SHIFT: u32 = 34;
pub const HFGITR_EL2_TLBIRVAE1IS_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIVAALE1IS_SHIFT: u32 = 33;
pub const HFGITR_EL2_TLBIVAALE1IS_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIVALE1IS_SHIFT: u32 = 32;
pub const HFGITR_EL2_TLBIVALE1IS_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIVAAE1IS_SHIFT: u32 = 31;
pub const HFGITR_EL2_TLBIVAAE1IS_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIASIDE1IS_SHIFT: u32 = 30;
pub const HFGITR_EL2_TLBIASIDE1IS_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIVAE1IS_SHIFT: u32 = 29;
pub const HFGITR_EL2_TLBIVAE1IS_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIVMALLE1IS_SHIFT: u32 = 28;
pub const HFGITR_EL2_TLBIVMALLE1IS_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIRVAALE1OS_SHIFT: u32 = 27;
pub const HFGITR_EL2_TLBIRVAALE1OS_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIRVALE1OS_SHIFT: u32 = 26;
pub const HFGITR_EL2_TLBIRVALE1OS_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIRVAAE1OS_SHIFT: u32 = 25;
pub const HFGITR_EL2_TLBIRVAAE1OS_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIRVAE1OS_SHIFT: u32 = 24;
pub const HFGITR_EL2_TLBIRVAE1OS_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIVAALE1OS_SHIFT: u32 = 23;
pub const HFGITR_EL2_TLBIVAALE1OS_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIVALE1OS_SHIFT: u32 = 22;
pub const HFGITR_EL2_TLBIVALE1OS_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIVAAE1OS_SHIFT: u32 = 21;
pub const HFGITR_EL2_TLBIVAAE1OS_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIASIDE1OS_SHIFT: u32 = 20;
pub const HFGITR_EL2_TLBIASIDE1OS_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIVAE1OS_SHIFT: u32 = 19;
pub const HFGITR_EL2_TLBIVAE1OS_WIDTH: u32 = 1;
pub const HFGITR_EL2_TLBIVMALLE1OS_SHIFT: u32 = 18;
pub const HFGITR_EL2_TLBIVMALLE1OS_WIDTH: u32 = 1;
pub const HFGITR_EL2_ATS1E1WP_SHIFT: u32 = 17;
pub const HFGITR_EL2_ATS1E1WP_WIDTH: u32 = 1;
pub const HFGITR_EL2_ATS1E1RP_SHIFT: u32 = 16;
pub const HFGITR_EL2_ATS1E1RP_WIDTH: u32 = 1;
pub const HFGITR_EL2_ATS1E0W_SHIFT: u32 = 15;
pub const HFGITR_EL2_ATS1E0W_WIDTH: u32 = 1;
pub const HFGITR_EL2_ATS1E0R_SHIFT: u32 = 14;
pub const HFGITR_EL2_ATS1E0R_WIDTH: u32 = 1;
pub const HFGITR_EL2_ATS1E1W_SHIFT: u32 = 13;
pub const HFGITR_EL2_ATS1E1W_WIDTH: u32 = 1;
pub const HFGITR_EL2_ATS1E1R_SHIFT: u32 = 12;
pub const HFGITR_EL2_ATS1E1R_WIDTH: u32 = 1;
pub const HFGITR_EL2_DCZVA_SHIFT: u32 = 11;
pub const HFGITR_EL2_DCZVA_WIDTH: u32 = 1;
pub const HFGITR_EL2_DCCIVAC_SHIFT: u32 = 10;
pub const HFGITR_EL2_DCCIVAC_WIDTH: u32 = 1;
pub const HFGITR_EL2_DCCVADP_SHIFT: u32 = 9;
pub const HFGITR_EL2_DCCVADP_WIDTH: u32 = 1;
pub const HFGITR_EL2_DCCVAP_SHIFT: u32 = 8;
pub const HFGITR_EL2_DCCVAP_WIDTH: u32 = 1;
pub const HFGITR_EL2_DCCVAU_SHIFT: u32 = 7;
pub const HFGITR_EL2_DCCVAU_WIDTH: u32 = 1;
pub const HFGITR_EL2_DCCISW_SHIFT: u32 = 6;
pub const HFGITR_EL2_DCCISW_WIDTH: u32 = 1;
pub const HFGITR_EL2_DCCSW_SHIFT: u32 = 5;
pub const HFGITR_EL2_DCCSW_WIDTH: u32 = 1;
pub const HFGITR_EL2_DCISW_SHIFT: u32 = 4;
pub const HFGITR_EL2_DCISW_WIDTH: u32 = 1;
pub const HFGITR_EL2_DCIVAC_SHIFT: u32 = 3;
pub const HFGITR_EL2_DCIVAC_WIDTH: u32 = 1;
pub const HFGITR_EL2_ICIVAU_SHIFT: u32 = 2;
pub const HFGITR_EL2_ICIVAU_WIDTH: u32 = 1;
pub const HFGITR_EL2_ICIALLU_SHIFT: u32 = 1;
pub const HFGITR_EL2_ICIALLU_WIDTH: u32 = 1;
pub const HFGITR_EL2_ICIALLUIS_SHIFT: u32 = 0;
pub const HFGITR_EL2_ICIALLUIS_WIDTH: u32 = 1;
pub const SYS_TRFCR_EL2_Op0: u32 = 3;
pub const SYS_TRFCR_EL2_Op1: u32 = 4;
pub const SYS_TRFCR_EL2_CRn: u32 = 1;
pub const SYS_TRFCR_EL2_CRm: u32 = 2;
pub const SYS_TRFCR_EL2_Op2: u32 = 1;
pub const TRFCR_EL2_TS_SHIFT: u32 = 5;
pub const TRFCR_EL2_TS_WIDTH: u32 = 2;
pub const TRFCR_EL2_CX_SHIFT: u32 = 3;
pub const TRFCR_EL2_CX_WIDTH: u32 = 1;
pub const TRFCR_EL2_E2TRE_SHIFT: u32 = 1;
pub const TRFCR_EL2_E2TRE_WIDTH: u32 = 1;
pub const TRFCR_EL2_E0HTRE_SHIFT: u32 = 0;
pub const TRFCR_EL2_E0HTRE_WIDTH: u32 = 1;
pub const SYS_HDFGRTR2_EL2_Op0: u32 = 3;
pub const SYS_HDFGRTR2_EL2_Op1: u32 = 4;
pub const SYS_HDFGRTR2_EL2_CRn: u32 = 3;
pub const SYS_HDFGRTR2_EL2_CRm: u32 = 1;
pub const SYS_HDFGRTR2_EL2_Op2: u32 = 0;
pub const HDFGRTR2_EL2_nPMBMAR_EL1_SHIFT: u32 = 24;
pub const HDFGRTR2_EL2_nPMBMAR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nMDSTEPOP_EL1_SHIFT: u32 = 23;
pub const HDFGRTR2_EL2_nMDSTEPOP_EL1_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nTRBMPAM_EL1_SHIFT: u32 = 22;
pub const HDFGRTR2_EL2_nTRBMPAM_EL1_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nTRCITECR_EL1_SHIFT: u32 = 20;
pub const HDFGRTR2_EL2_nTRCITECR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nPMSDSFR_EL1_SHIFT: u32 = 19;
pub const HDFGRTR2_EL2_nPMSDSFR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nSPMDEVAFF_EL1_SHIFT: u32 = 18;
pub const HDFGRTR2_EL2_nSPMDEVAFF_EL1_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nSPMID_SHIFT: u32 = 17;
pub const HDFGRTR2_EL2_nSPMID_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nSPMSCR_EL1_SHIFT: u32 = 16;
pub const HDFGRTR2_EL2_nSPMSCR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nSPMACCESSR_EL1_SHIFT: u32 = 15;
pub const HDFGRTR2_EL2_nSPMACCESSR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nSPMCR_EL0_SHIFT: u32 = 14;
pub const HDFGRTR2_EL2_nSPMCR_EL0_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nSPMOVS_SHIFT: u32 = 13;
pub const HDFGRTR2_EL2_nSPMOVS_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nSPMINTEN_SHIFT: u32 = 12;
pub const HDFGRTR2_EL2_nSPMINTEN_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nSPMCNTEN_SHIFT: u32 = 11;
pub const HDFGRTR2_EL2_nSPMCNTEN_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nSPMSELR_EL0_SHIFT: u32 = 10;
pub const HDFGRTR2_EL2_nSPMSELR_EL0_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nSPMEVTYPERn_EL0_SHIFT: u32 = 9;
pub const HDFGRTR2_EL2_nSPMEVTYPERn_EL0_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nSPMEVCNTRn_EL0_SHIFT: u32 = 8;
pub const HDFGRTR2_EL2_nSPMEVCNTRn_EL0_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nPMSSCR_EL1_SHIFT: u32 = 7;
pub const HDFGRTR2_EL2_nPMSSCR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nPMSSDATA_SHIFT: u32 = 6;
pub const HDFGRTR2_EL2_nPMSSDATA_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nMDSELR_EL1_SHIFT: u32 = 5;
pub const HDFGRTR2_EL2_nMDSELR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nPMUACR_EL1_SHIFT: u32 = 4;
pub const HDFGRTR2_EL2_nPMUACR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nPMICFILTR_EL0_SHIFT: u32 = 3;
pub const HDFGRTR2_EL2_nPMICFILTR_EL0_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nPMICNTR_EL0_SHIFT: u32 = 2;
pub const HDFGRTR2_EL2_nPMICNTR_EL0_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nPMIAR_EL1_SHIFT: u32 = 1;
pub const HDFGRTR2_EL2_nPMIAR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR2_EL2_nPMECR_EL1_SHIFT: u32 = 0;
pub const HDFGRTR2_EL2_nPMECR_EL1_WIDTH: u32 = 1;
pub const SYS_HDFGWTR2_EL2_Op0: u32 = 3;
pub const SYS_HDFGWTR2_EL2_Op1: u32 = 4;
pub const SYS_HDFGWTR2_EL2_CRn: u32 = 3;
pub const SYS_HDFGWTR2_EL2_CRm: u32 = 1;
pub const SYS_HDFGWTR2_EL2_Op2: u32 = 1;
pub const HDFGWTR2_EL2_nPMBMAR_EL1_SHIFT: u32 = 24;
pub const HDFGWTR2_EL2_nPMBMAR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR2_EL2_nMDSTEPOP_EL1_SHIFT: u32 = 23;
pub const HDFGWTR2_EL2_nMDSTEPOP_EL1_WIDTH: u32 = 1;
pub const HDFGWTR2_EL2_nTRBMPAM_EL1_SHIFT: u32 = 22;
pub const HDFGWTR2_EL2_nTRBMPAM_EL1_WIDTH: u32 = 1;
pub const HDFGWTR2_EL2_nPMZR_EL0_SHIFT: u32 = 21;
pub const HDFGWTR2_EL2_nPMZR_EL0_WIDTH: u32 = 1;
pub const HDFGWTR2_EL2_nTRCITECR_EL1_SHIFT: u32 = 20;
pub const HDFGWTR2_EL2_nTRCITECR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR2_EL2_nPMSDSFR_EL1_SHIFT: u32 = 19;
pub const HDFGWTR2_EL2_nPMSDSFR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR2_EL2_nSPMSCR_EL1_SHIFT: u32 = 16;
pub const HDFGWTR2_EL2_nSPMSCR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR2_EL2_nSPMACCESSR_EL1_SHIFT: u32 = 15;
pub const HDFGWTR2_EL2_nSPMACCESSR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR2_EL2_nSPMCR_EL0_SHIFT: u32 = 14;
pub const HDFGWTR2_EL2_nSPMCR_EL0_WIDTH: u32 = 1;
pub const HDFGWTR2_EL2_nSPMOVS_SHIFT: u32 = 13;
pub const HDFGWTR2_EL2_nSPMOVS_WIDTH: u32 = 1;
pub const HDFGWTR2_EL2_nSPMINTEN_SHIFT: u32 = 12;
pub const HDFGWTR2_EL2_nSPMINTEN_WIDTH: u32 = 1;
pub const HDFGWTR2_EL2_nSPMCNTEN_SHIFT: u32 = 11;
pub const HDFGWTR2_EL2_nSPMCNTEN_WIDTH: u32 = 1;
pub const HDFGWTR2_EL2_nSPMSELR_EL0_SHIFT: u32 = 10;
pub const HDFGWTR2_EL2_nSPMSELR_EL0_WIDTH: u32 = 1;
pub const HDFGWTR2_EL2_nSPMEVTYPERn_EL0_SHIFT: u32 = 9;
pub const HDFGWTR2_EL2_nSPMEVTYPERn_EL0_WIDTH: u32 = 1;
pub const HDFGWTR2_EL2_nSPMEVCNTRn_EL0_SHIFT: u32 = 8;
pub const HDFGWTR2_EL2_nSPMEVCNTRn_EL0_WIDTH: u32 = 1;
pub const HDFGWTR2_EL2_nPMSSCR_EL1_SHIFT: u32 = 7;
pub const HDFGWTR2_EL2_nPMSSCR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR2_EL2_nMDSELR_EL1_SHIFT: u32 = 5;
pub const HDFGWTR2_EL2_nMDSELR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR2_EL2_nPMUACR_EL1_SHIFT: u32 = 4;
pub const HDFGWTR2_EL2_nPMUACR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR2_EL2_nPMICFILTR_EL0_SHIFT: u32 = 3;
pub const HDFGWTR2_EL2_nPMICFILTR_EL0_WIDTH: u32 = 1;
pub const HDFGWTR2_EL2_nPMICNTR_EL0_SHIFT: u32 = 2;
pub const HDFGWTR2_EL2_nPMICNTR_EL0_WIDTH: u32 = 1;
pub const HDFGWTR2_EL2_nPMIAR_EL1_SHIFT: u32 = 1;
pub const HDFGWTR2_EL2_nPMIAR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR2_EL2_nPMECR_EL1_SHIFT: u32 = 0;
pub const HDFGWTR2_EL2_nPMECR_EL1_WIDTH: u32 = 1;
pub const SYS_HFGRTR2_EL2_Op0: u32 = 3;
pub const SYS_HFGRTR2_EL2_Op1: u32 = 4;
pub const SYS_HFGRTR2_EL2_CRn: u32 = 3;
pub const SYS_HFGRTR2_EL2_CRm: u32 = 1;
pub const SYS_HFGRTR2_EL2_Op2: u32 = 2;
pub const HFGRTR2_EL2_nACTLRALIAS_EL1_SHIFT: u32 = 14;
pub const HFGRTR2_EL2_nACTLRALIAS_EL1_WIDTH: u32 = 1;
pub const HFGRTR2_EL2_nACTLRMASK_EL1_SHIFT: u32 = 13;
pub const HFGRTR2_EL2_nACTLRMASK_EL1_WIDTH: u32 = 1;
pub const HFGRTR2_EL2_nTCR2ALIAS_EL1_SHIFT: u32 = 12;
pub const HFGRTR2_EL2_nTCR2ALIAS_EL1_WIDTH: u32 = 1;
pub const HFGRTR2_EL2_nTCRALIAS_EL1_SHIFT: u32 = 11;
pub const HFGRTR2_EL2_nTCRALIAS_EL1_WIDTH: u32 = 1;
pub const HFGRTR2_EL2_nSCTLRALIAS2_EL1_SHIFT: u32 = 10;
pub const HFGRTR2_EL2_nSCTLRALIAS2_EL1_WIDTH: u32 = 1;
pub const HFGRTR2_EL2_nSCTLRALIAS_EL1_SHIFT: u32 = 9;
pub const HFGRTR2_EL2_nSCTLRALIAS_EL1_WIDTH: u32 = 1;
pub const HFGRTR2_EL2_nCPACRALIAS_EL1_SHIFT: u32 = 8;
pub const HFGRTR2_EL2_nCPACRALIAS_EL1_WIDTH: u32 = 1;
pub const HFGRTR2_EL2_nTCR2MASK_EL1_SHIFT: u32 = 7;
pub const HFGRTR2_EL2_nTCR2MASK_EL1_WIDTH: u32 = 1;
pub const HFGRTR2_EL2_nTCRMASK_EL1_SHIFT: u32 = 6;
pub const HFGRTR2_EL2_nTCRMASK_EL1_WIDTH: u32 = 1;
pub const HFGRTR2_EL2_nSCTLR2MASK_EL1_SHIFT: u32 = 5;
pub const HFGRTR2_EL2_nSCTLR2MASK_EL1_WIDTH: u32 = 1;
pub const HFGRTR2_EL2_nSCTLRMASK_EL1_SHIFT: u32 = 4;
pub const HFGRTR2_EL2_nSCTLRMASK_EL1_WIDTH: u32 = 1;
pub const HFGRTR2_EL2_nCPACRMASK_EL1_SHIFT: u32 = 3;
pub const HFGRTR2_EL2_nCPACRMASK_EL1_WIDTH: u32 = 1;
pub const HFGRTR2_EL2_nRCWSMASK_EL1_SHIFT: u32 = 2;
pub const HFGRTR2_EL2_nRCWSMASK_EL1_WIDTH: u32 = 1;
pub const HFGRTR2_EL2_nERXGSR_EL1_SHIFT: u32 = 1;
pub const HFGRTR2_EL2_nERXGSR_EL1_WIDTH: u32 = 1;
pub const HFGRTR2_EL2_nPFAR_EL1_SHIFT: u32 = 0;
pub const HFGRTR2_EL2_nPFAR_EL1_WIDTH: u32 = 1;
pub const SYS_HFGWTR2_EL2_Op0: u32 = 3;
pub const SYS_HFGWTR2_EL2_Op1: u32 = 4;
pub const SYS_HFGWTR2_EL2_CRn: u32 = 3;
pub const SYS_HFGWTR2_EL2_CRm: u32 = 1;
pub const SYS_HFGWTR2_EL2_Op2: u32 = 3;
pub const HFGWTR2_EL2_nACTLRALIAS_EL1_SHIFT: u32 = 14;
pub const HFGWTR2_EL2_nACTLRALIAS_EL1_WIDTH: u32 = 1;
pub const HFGWTR2_EL2_nACTLRMASK_EL1_SHIFT: u32 = 13;
pub const HFGWTR2_EL2_nACTLRMASK_EL1_WIDTH: u32 = 1;
pub const HFGWTR2_EL2_nTCR2ALIAS_EL1_SHIFT: u32 = 12;
pub const HFGWTR2_EL2_nTCR2ALIAS_EL1_WIDTH: u32 = 1;
pub const HFGWTR2_EL2_nTCRALIAS_EL1_SHIFT: u32 = 11;
pub const HFGWTR2_EL2_nTCRALIAS_EL1_WIDTH: u32 = 1;
pub const HFGWTR2_EL2_nSCTLRALIAS2_EL1_SHIFT: u32 = 10;
pub const HFGWTR2_EL2_nSCTLRALIAS2_EL1_WIDTH: u32 = 1;
pub const HFGWTR2_EL2_nSCTLRALIAS_EL1_SHIFT: u32 = 9;
pub const HFGWTR2_EL2_nSCTLRALIAS_EL1_WIDTH: u32 = 1;
pub const HFGWTR2_EL2_nCPACRALIAS_EL1_SHIFT: u32 = 8;
pub const HFGWTR2_EL2_nCPACRALIAS_EL1_WIDTH: u32 = 1;
pub const HFGWTR2_EL2_nTCR2MASK_EL1_SHIFT: u32 = 7;
pub const HFGWTR2_EL2_nTCR2MASK_EL1_WIDTH: u32 = 1;
pub const HFGWTR2_EL2_nTCRMASK_EL1_SHIFT: u32 = 6;
pub const HFGWTR2_EL2_nTCRMASK_EL1_WIDTH: u32 = 1;
pub const HFGWTR2_EL2_nSCTLR2MASK_EL1_SHIFT: u32 = 5;
pub const HFGWTR2_EL2_nSCTLR2MASK_EL1_WIDTH: u32 = 1;
pub const HFGWTR2_EL2_nSCTLRMASK_EL1_SHIFT: u32 = 4;
pub const HFGWTR2_EL2_nSCTLRMASK_EL1_WIDTH: u32 = 1;
pub const HFGWTR2_EL2_nCPACRMASK_EL1_SHIFT: u32 = 3;
pub const HFGWTR2_EL2_nCPACRMASK_EL1_WIDTH: u32 = 1;
pub const HFGWTR2_EL2_nRCWSMASK_EL1_SHIFT: u32 = 2;
pub const HFGWTR2_EL2_nRCWSMASK_EL1_WIDTH: u32 = 1;
pub const HFGWTR2_EL2_nPFAR_EL1_SHIFT: u32 = 0;
pub const HFGWTR2_EL2_nPFAR_EL1_WIDTH: u32 = 1;
pub const SYS_HDFGRTR_EL2_Op0: u32 = 3;
pub const SYS_HDFGRTR_EL2_Op1: u32 = 4;
pub const SYS_HDFGRTR_EL2_CRn: u32 = 3;
pub const SYS_HDFGRTR_EL2_CRm: u32 = 1;
pub const SYS_HDFGRTR_EL2_Op2: u32 = 4;
pub const HDFGRTR_EL2_PMBIDR_EL1_SHIFT: u32 = 63;
pub const HDFGRTR_EL2_PMBIDR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_nPMSNEVFR_EL1_SHIFT: u32 = 62;
pub const HDFGRTR_EL2_nPMSNEVFR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_nBRBDATA_SHIFT: u32 = 61;
pub const HDFGRTR_EL2_nBRBDATA_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_nBRBCTL_SHIFT: u32 = 60;
pub const HDFGRTR_EL2_nBRBCTL_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_nBRBIDR_SHIFT: u32 = 59;
pub const HDFGRTR_EL2_nBRBIDR_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_PMCEIDn_EL0_SHIFT: u32 = 58;
pub const HDFGRTR_EL2_PMCEIDn_EL0_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_PMUSERENR_EL0_SHIFT: u32 = 57;
pub const HDFGRTR_EL2_PMUSERENR_EL0_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_TRBTRG_EL1_SHIFT: u32 = 56;
pub const HDFGRTR_EL2_TRBTRG_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_TRBSR_EL1_SHIFT: u32 = 55;
pub const HDFGRTR_EL2_TRBSR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_TRBPTR_EL1_SHIFT: u32 = 54;
pub const HDFGRTR_EL2_TRBPTR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_TRBMAR_EL1_SHIFT: u32 = 53;
pub const HDFGRTR_EL2_TRBMAR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_TRBLIMITR_EL1_SHIFT: u32 = 52;
pub const HDFGRTR_EL2_TRBLIMITR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_TRBIDR_EL1_SHIFT: u32 = 51;
pub const HDFGRTR_EL2_TRBIDR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_TRBBASER_EL1_SHIFT: u32 = 50;
pub const HDFGRTR_EL2_TRBBASER_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_TRCVICTLR_SHIFT: u32 = 48;
pub const HDFGRTR_EL2_TRCVICTLR_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_TRCSTATR_SHIFT: u32 = 47;
pub const HDFGRTR_EL2_TRCSTATR_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_TRCSSCSRn_SHIFT: u32 = 46;
pub const HDFGRTR_EL2_TRCSSCSRn_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_TRCSEQSTR_SHIFT: u32 = 45;
pub const HDFGRTR_EL2_TRCSEQSTR_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_TRCPRGCTLR_SHIFT: u32 = 44;
pub const HDFGRTR_EL2_TRCPRGCTLR_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_TRCOSLSR_SHIFT: u32 = 43;
pub const HDFGRTR_EL2_TRCOSLSR_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_TRCIMSPECn_SHIFT: u32 = 41;
pub const HDFGRTR_EL2_TRCIMSPECn_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_TRCID_SHIFT: u32 = 40;
pub const HDFGRTR_EL2_TRCID_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_TRCCNTVRn_SHIFT: u32 = 37;
pub const HDFGRTR_EL2_TRCCNTVRn_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_TRCCLAIM_SHIFT: u32 = 36;
pub const HDFGRTR_EL2_TRCCLAIM_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_TRCAUXCTLR_SHIFT: u32 = 35;
pub const HDFGRTR_EL2_TRCAUXCTLR_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_TRCAUTHSTATUS_SHIFT: u32 = 34;
pub const HDFGRTR_EL2_TRCAUTHSTATUS_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_TRC_SHIFT: u32 = 33;
pub const HDFGRTR_EL2_TRC_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_PMSLATFR_EL1_SHIFT: u32 = 32;
pub const HDFGRTR_EL2_PMSLATFR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_PMSIRR_EL1_SHIFT: u32 = 31;
pub const HDFGRTR_EL2_PMSIRR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_PMSIDR_EL1_SHIFT: u32 = 30;
pub const HDFGRTR_EL2_PMSIDR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_PMSICR_EL1_SHIFT: u32 = 29;
pub const HDFGRTR_EL2_PMSICR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_PMSFCR_EL1_SHIFT: u32 = 28;
pub const HDFGRTR_EL2_PMSFCR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_PMSEVFR_EL1_SHIFT: u32 = 27;
pub const HDFGRTR_EL2_PMSEVFR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_PMSCR_EL1_SHIFT: u32 = 26;
pub const HDFGRTR_EL2_PMSCR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_PMBSR_EL1_SHIFT: u32 = 25;
pub const HDFGRTR_EL2_PMBSR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_PMBPTR_EL1_SHIFT: u32 = 24;
pub const HDFGRTR_EL2_PMBPTR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_PMBLIMITR_EL1_SHIFT: u32 = 23;
pub const HDFGRTR_EL2_PMBLIMITR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_PMMIR_EL1_SHIFT: u32 = 22;
pub const HDFGRTR_EL2_PMMIR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_PMSELR_EL0_SHIFT: u32 = 19;
pub const HDFGRTR_EL2_PMSELR_EL0_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_PMOVS_SHIFT: u32 = 18;
pub const HDFGRTR_EL2_PMOVS_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_PMINTEN_SHIFT: u32 = 17;
pub const HDFGRTR_EL2_PMINTEN_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_PMCNTEN_SHIFT: u32 = 16;
pub const HDFGRTR_EL2_PMCNTEN_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_PMCCNTR_EL0_SHIFT: u32 = 15;
pub const HDFGRTR_EL2_PMCCNTR_EL0_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_PMCCFILTR_EL0_SHIFT: u32 = 14;
pub const HDFGRTR_EL2_PMCCFILTR_EL0_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_PMEVTYPERn_EL0_SHIFT: u32 = 13;
pub const HDFGRTR_EL2_PMEVTYPERn_EL0_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_PMEVCNTRn_EL0_SHIFT: u32 = 12;
pub const HDFGRTR_EL2_PMEVCNTRn_EL0_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_OSDLR_EL1_SHIFT: u32 = 11;
pub const HDFGRTR_EL2_OSDLR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_OSECCR_EL1_SHIFT: u32 = 10;
pub const HDFGRTR_EL2_OSECCR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_OSLSR_EL1_SHIFT: u32 = 9;
pub const HDFGRTR_EL2_OSLSR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_DBGPRCR_EL1_SHIFT: u32 = 7;
pub const HDFGRTR_EL2_DBGPRCR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_DBGAUTHSTATUS_EL1_SHIFT: u32 = 6;
pub const HDFGRTR_EL2_DBGAUTHSTATUS_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_DBGCLAIM_SHIFT: u32 = 5;
pub const HDFGRTR_EL2_DBGCLAIM_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_MDSCR_EL1_SHIFT: u32 = 4;
pub const HDFGRTR_EL2_MDSCR_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_DBGWVRn_EL1_SHIFT: u32 = 3;
pub const HDFGRTR_EL2_DBGWVRn_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_DBGWCRn_EL1_SHIFT: u32 = 2;
pub const HDFGRTR_EL2_DBGWCRn_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_DBGBVRn_EL1_SHIFT: u32 = 1;
pub const HDFGRTR_EL2_DBGBVRn_EL1_WIDTH: u32 = 1;
pub const HDFGRTR_EL2_DBGBCRn_EL1_SHIFT: u32 = 0;
pub const HDFGRTR_EL2_DBGBCRn_EL1_WIDTH: u32 = 1;
pub const SYS_HDFGWTR_EL2_Op0: u32 = 3;
pub const SYS_HDFGWTR_EL2_Op1: u32 = 4;
pub const SYS_HDFGWTR_EL2_CRn: u32 = 3;
pub const SYS_HDFGWTR_EL2_CRm: u32 = 1;
pub const SYS_HDFGWTR_EL2_Op2: u32 = 5;
pub const HDFGWTR_EL2_nPMSNEVFR_EL1_SHIFT: u32 = 62;
pub const HDFGWTR_EL2_nPMSNEVFR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_nBRBDATA_SHIFT: u32 = 61;
pub const HDFGWTR_EL2_nBRBDATA_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_nBRBCTL_SHIFT: u32 = 60;
pub const HDFGWTR_EL2_nBRBCTL_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_PMUSERENR_EL0_SHIFT: u32 = 57;
pub const HDFGWTR_EL2_PMUSERENR_EL0_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_TRBTRG_EL1_SHIFT: u32 = 56;
pub const HDFGWTR_EL2_TRBTRG_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_TRBSR_EL1_SHIFT: u32 = 55;
pub const HDFGWTR_EL2_TRBSR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_TRBPTR_EL1_SHIFT: u32 = 54;
pub const HDFGWTR_EL2_TRBPTR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_TRBMAR_EL1_SHIFT: u32 = 53;
pub const HDFGWTR_EL2_TRBMAR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_TRBLIMITR_EL1_SHIFT: u32 = 52;
pub const HDFGWTR_EL2_TRBLIMITR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_TRBBASER_EL1_SHIFT: u32 = 50;
pub const HDFGWTR_EL2_TRBBASER_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_TRFCR_EL1_SHIFT: u32 = 49;
pub const HDFGWTR_EL2_TRFCR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_TRCVICTLR_SHIFT: u32 = 48;
pub const HDFGWTR_EL2_TRCVICTLR_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_TRCSSCSRn_SHIFT: u32 = 46;
pub const HDFGWTR_EL2_TRCSSCSRn_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_TRCSEQSTR_SHIFT: u32 = 45;
pub const HDFGWTR_EL2_TRCSEQSTR_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_TRCPRGCTLR_SHIFT: u32 = 44;
pub const HDFGWTR_EL2_TRCPRGCTLR_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_TRCOSLAR_SHIFT: u32 = 42;
pub const HDFGWTR_EL2_TRCOSLAR_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_TRCIMSPECn_SHIFT: u32 = 41;
pub const HDFGWTR_EL2_TRCIMSPECn_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_TRCCNTVRn_SHIFT: u32 = 37;
pub const HDFGWTR_EL2_TRCCNTVRn_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_TRCCLAIM_SHIFT: u32 = 36;
pub const HDFGWTR_EL2_TRCCLAIM_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_TRCAUXCTLR_SHIFT: u32 = 35;
pub const HDFGWTR_EL2_TRCAUXCTLR_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_TRC_SHIFT: u32 = 33;
pub const HDFGWTR_EL2_TRC_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_PMSLATFR_EL1_SHIFT: u32 = 32;
pub const HDFGWTR_EL2_PMSLATFR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_PMSIRR_EL1_SHIFT: u32 = 31;
pub const HDFGWTR_EL2_PMSIRR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_PMSICR_EL1_SHIFT: u32 = 29;
pub const HDFGWTR_EL2_PMSICR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_PMSFCR_EL1_SHIFT: u32 = 28;
pub const HDFGWTR_EL2_PMSFCR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_PMSEVFR_EL1_SHIFT: u32 = 27;
pub const HDFGWTR_EL2_PMSEVFR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_PMSCR_EL1_SHIFT: u32 = 26;
pub const HDFGWTR_EL2_PMSCR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_PMBSR_EL1_SHIFT: u32 = 25;
pub const HDFGWTR_EL2_PMBSR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_PMBPTR_EL1_SHIFT: u32 = 24;
pub const HDFGWTR_EL2_PMBPTR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_PMBLIMITR_EL1_SHIFT: u32 = 23;
pub const HDFGWTR_EL2_PMBLIMITR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_PMCR_EL0_SHIFT: u32 = 21;
pub const HDFGWTR_EL2_PMCR_EL0_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_PMSWINC_EL0_SHIFT: u32 = 20;
pub const HDFGWTR_EL2_PMSWINC_EL0_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_PMSELR_EL0_SHIFT: u32 = 19;
pub const HDFGWTR_EL2_PMSELR_EL0_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_PMOVS_SHIFT: u32 = 18;
pub const HDFGWTR_EL2_PMOVS_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_PMINTEN_SHIFT: u32 = 17;
pub const HDFGWTR_EL2_PMINTEN_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_PMCNTEN_SHIFT: u32 = 16;
pub const HDFGWTR_EL2_PMCNTEN_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_PMCCNTR_EL0_SHIFT: u32 = 15;
pub const HDFGWTR_EL2_PMCCNTR_EL0_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_PMCCFILTR_EL0_SHIFT: u32 = 14;
pub const HDFGWTR_EL2_PMCCFILTR_EL0_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_PMEVTYPERn_EL0_SHIFT: u32 = 13;
pub const HDFGWTR_EL2_PMEVTYPERn_EL0_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_PMEVCNTRn_EL0_SHIFT: u32 = 12;
pub const HDFGWTR_EL2_PMEVCNTRn_EL0_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_OSDLR_EL1_SHIFT: u32 = 11;
pub const HDFGWTR_EL2_OSDLR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_OSECCR_EL1_SHIFT: u32 = 10;
pub const HDFGWTR_EL2_OSECCR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_OSLAR_EL1_SHIFT: u32 = 8;
pub const HDFGWTR_EL2_OSLAR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_DBGPRCR_EL1_SHIFT: u32 = 7;
pub const HDFGWTR_EL2_DBGPRCR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_DBGCLAIM_SHIFT: u32 = 5;
pub const HDFGWTR_EL2_DBGCLAIM_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_MDSCR_EL1_SHIFT: u32 = 4;
pub const HDFGWTR_EL2_MDSCR_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_DBGWVRn_EL1_SHIFT: u32 = 3;
pub const HDFGWTR_EL2_DBGWVRn_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_DBGWCRn_EL1_SHIFT: u32 = 2;
pub const HDFGWTR_EL2_DBGWCRn_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_DBGBVRn_EL1_SHIFT: u32 = 1;
pub const HDFGWTR_EL2_DBGBVRn_EL1_WIDTH: u32 = 1;
pub const HDFGWTR_EL2_DBGBCRn_EL1_SHIFT: u32 = 0;
pub const HDFGWTR_EL2_DBGBCRn_EL1_WIDTH: u32 = 1;
pub const SYS_HAFGRTR_EL2_Op0: u32 = 3;
pub const SYS_HAFGRTR_EL2_Op1: u32 = 4;
pub const SYS_HAFGRTR_EL2_CRn: u32 = 3;
pub const SYS_HAFGRTR_EL2_CRm: u32 = 1;
pub const SYS_HAFGRTR_EL2_Op2: u32 = 6;
pub const HAFGRTR_EL2_AMEVTYPER115_EL0_SHIFT: u32 = 49;
pub const HAFGRTR_EL2_AMEVTYPER115_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVCNTR115_EL0_SHIFT: u32 = 48;
pub const HAFGRTR_EL2_AMEVCNTR115_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVTYPER114_EL0_SHIFT: u32 = 47;
pub const HAFGRTR_EL2_AMEVTYPER114_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVCNTR114_EL0_SHIFT: u32 = 46;
pub const HAFGRTR_EL2_AMEVCNTR114_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVTYPER113_EL0_SHIFT: u32 = 45;
pub const HAFGRTR_EL2_AMEVTYPER113_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVCNTR113_EL0_SHIFT: u32 = 44;
pub const HAFGRTR_EL2_AMEVCNTR113_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVTYPER112_EL0_SHIFT: u32 = 43;
pub const HAFGRTR_EL2_AMEVTYPER112_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVCNTR112_EL0_SHIFT: u32 = 42;
pub const HAFGRTR_EL2_AMEVCNTR112_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVTYPER111_EL0_SHIFT: u32 = 41;
pub const HAFGRTR_EL2_AMEVTYPER111_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVCNTR111_EL0_SHIFT: u32 = 40;
pub const HAFGRTR_EL2_AMEVCNTR111_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVTYPER110_EL0_SHIFT: u32 = 39;
pub const HAFGRTR_EL2_AMEVTYPER110_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVCNTR110_EL0_SHIFT: u32 = 38;
pub const HAFGRTR_EL2_AMEVCNTR110_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVTYPER19_EL0_SHIFT: u32 = 37;
pub const HAFGRTR_EL2_AMEVTYPER19_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVCNTR19_EL0_SHIFT: u32 = 36;
pub const HAFGRTR_EL2_AMEVCNTR19_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVTYPER18_EL0_SHIFT: u32 = 35;
pub const HAFGRTR_EL2_AMEVTYPER18_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVCNTR18_EL0_SHIFT: u32 = 34;
pub const HAFGRTR_EL2_AMEVCNTR18_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVTYPER17_EL0_SHIFT: u32 = 33;
pub const HAFGRTR_EL2_AMEVTYPER17_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVCNTR17_EL0_SHIFT: u32 = 32;
pub const HAFGRTR_EL2_AMEVCNTR17_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVTYPER16_EL0_SHIFT: u32 = 31;
pub const HAFGRTR_EL2_AMEVTYPER16_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVCNTR16_EL0_SHIFT: u32 = 30;
pub const HAFGRTR_EL2_AMEVCNTR16_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVTYPER15_EL0_SHIFT: u32 = 29;
pub const HAFGRTR_EL2_AMEVTYPER15_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVCNTR15_EL0_SHIFT: u32 = 28;
pub const HAFGRTR_EL2_AMEVCNTR15_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVTYPER14_EL0_SHIFT: u32 = 27;
pub const HAFGRTR_EL2_AMEVTYPER14_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVCNTR14_EL0_SHIFT: u32 = 26;
pub const HAFGRTR_EL2_AMEVCNTR14_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVTYPER13_EL0_SHIFT: u32 = 25;
pub const HAFGRTR_EL2_AMEVTYPER13_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVCNTR13_EL0_SHIFT: u32 = 24;
pub const HAFGRTR_EL2_AMEVCNTR13_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVTYPER12_EL0_SHIFT: u32 = 23;
pub const HAFGRTR_EL2_AMEVTYPER12_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVCNTR12_EL0_SHIFT: u32 = 22;
pub const HAFGRTR_EL2_AMEVCNTR12_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVTYPER11_EL0_SHIFT: u32 = 21;
pub const HAFGRTR_EL2_AMEVTYPER11_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVCNTR11_EL0_SHIFT: u32 = 20;
pub const HAFGRTR_EL2_AMEVCNTR11_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVTYPER10_EL0_SHIFT: u32 = 19;
pub const HAFGRTR_EL2_AMEVTYPER10_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVCNTR10_EL0_SHIFT: u32 = 18;
pub const HAFGRTR_EL2_AMEVCNTR10_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMCNTEN1_SHIFT: u32 = 17;
pub const HAFGRTR_EL2_AMCNTEN1_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVCNTR03_EL0_SHIFT: u32 = 4;
pub const HAFGRTR_EL2_AMEVCNTR03_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVCNTR02_EL0_SHIFT: u32 = 3;
pub const HAFGRTR_EL2_AMEVCNTR02_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVCNTR01_EL0_SHIFT: u32 = 2;
pub const HAFGRTR_EL2_AMEVCNTR01_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMEVCNTR00_EL0_SHIFT: u32 = 1;
pub const HAFGRTR_EL2_AMEVCNTR00_EL0_WIDTH: u32 = 1;
pub const HAFGRTR_EL2_AMCNTEN0_SHIFT: u32 = 0;
pub const HAFGRTR_EL2_AMCNTEN0_WIDTH: u32 = 1;
pub const SYS_HFGITR2_EL2_Op0: u32 = 3;
pub const SYS_HFGITR2_EL2_Op1: u32 = 4;
pub const SYS_HFGITR2_EL2_CRn: u32 = 3;
pub const SYS_HFGITR2_EL2_CRm: u32 = 1;
pub const SYS_HFGITR2_EL2_Op2: u32 = 7;
pub const HFGITR2_EL2_nDCCIVAPS_SHIFT: u32 = 1;
pub const HFGITR2_EL2_nDCCIVAPS_WIDTH: u32 = 1;
pub const HFGITR2_EL2_TSBCSYNC_SHIFT: u32 = 0;
pub const HFGITR2_EL2_TSBCSYNC_WIDTH: u32 = 1;
pub const SYS_ZCR_EL2_Op0: u32 = 3;
pub const SYS_ZCR_EL2_Op1: u32 = 4;
pub const SYS_ZCR_EL2_CRn: u32 = 1;
pub const SYS_ZCR_EL2_CRm: u32 = 2;
pub const SYS_ZCR_EL2_Op2: u32 = 0;
pub const SYS_HCRX_EL2_Op0: u32 = 3;
pub const SYS_HCRX_EL2_Op1: u32 = 4;
pub const SYS_HCRX_EL2_CRn: u32 = 1;
pub const SYS_HCRX_EL2_CRm: u32 = 2;
pub const SYS_HCRX_EL2_Op2: u32 = 2;
pub const HCRX_EL2_PACMEn_SHIFT: u32 = 24;
pub const HCRX_EL2_PACMEn_WIDTH: u32 = 1;
pub const HCRX_EL2_EnFPM_SHIFT: u32 = 23;
pub const HCRX_EL2_EnFPM_WIDTH: u32 = 1;
pub const HCRX_EL2_GCSEn_SHIFT: u32 = 22;
pub const HCRX_EL2_GCSEn_WIDTH: u32 = 1;
pub const HCRX_EL2_EnIDCP128_SHIFT: u32 = 21;
pub const HCRX_EL2_EnIDCP128_WIDTH: u32 = 1;
pub const HCRX_EL2_EnSDERR_SHIFT: u32 = 20;
pub const HCRX_EL2_EnSDERR_WIDTH: u32 = 1;
pub const HCRX_EL2_TMEA_SHIFT: u32 = 19;
pub const HCRX_EL2_TMEA_WIDTH: u32 = 1;
pub const HCRX_EL2_EnSNERR_SHIFT: u32 = 18;
pub const HCRX_EL2_EnSNERR_WIDTH: u32 = 1;
pub const HCRX_EL2_D128En_SHIFT: u32 = 17;
pub const HCRX_EL2_D128En_WIDTH: u32 = 1;
pub const HCRX_EL2_PTTWI_SHIFT: u32 = 16;
pub const HCRX_EL2_PTTWI_WIDTH: u32 = 1;
pub const HCRX_EL2_SCTLR2En_SHIFT: u32 = 15;
pub const HCRX_EL2_SCTLR2En_WIDTH: u32 = 1;
pub const HCRX_EL2_TCR2En_SHIFT: u32 = 14;
pub const HCRX_EL2_TCR2En_WIDTH: u32 = 1;
pub const HCRX_EL2_MSCEn_SHIFT: u32 = 11;
pub const HCRX_EL2_MSCEn_WIDTH: u32 = 1;
pub const HCRX_EL2_MCE2_SHIFT: u32 = 10;
pub const HCRX_EL2_MCE2_WIDTH: u32 = 1;
pub const HCRX_EL2_CMOW_SHIFT: u32 = 9;
pub const HCRX_EL2_CMOW_WIDTH: u32 = 1;
pub const HCRX_EL2_VFNMI_SHIFT: u32 = 8;
pub const HCRX_EL2_VFNMI_WIDTH: u32 = 1;
pub const HCRX_EL2_VINMI_SHIFT: u32 = 7;
pub const HCRX_EL2_VINMI_WIDTH: u32 = 1;
pub const HCRX_EL2_TALLINT_SHIFT: u32 = 6;
pub const HCRX_EL2_TALLINT_WIDTH: u32 = 1;
pub const HCRX_EL2_SMPME_SHIFT: u32 = 5;
pub const HCRX_EL2_SMPME_WIDTH: u32 = 1;
pub const HCRX_EL2_FGTnXS_SHIFT: u32 = 4;
pub const HCRX_EL2_FGTnXS_WIDTH: u32 = 1;
pub const HCRX_EL2_FnXS_SHIFT: u32 = 3;
pub const HCRX_EL2_FnXS_WIDTH: u32 = 1;
pub const HCRX_EL2_EnASR_SHIFT: u32 = 2;
pub const HCRX_EL2_EnASR_WIDTH: u32 = 1;
pub const HCRX_EL2_EnALS_SHIFT: u32 = 1;
pub const HCRX_EL2_EnALS_WIDTH: u32 = 1;
pub const HCRX_EL2_EnAS0_SHIFT: u32 = 0;
pub const HCRX_EL2_EnAS0_WIDTH: u32 = 1;
pub const SYS_SMPRIMAP_EL2_Op0: u32 = 3;
pub const SYS_SMPRIMAP_EL2_Op1: u32 = 4;
pub const SYS_SMPRIMAP_EL2_CRn: u32 = 1;
pub const SYS_SMPRIMAP_EL2_CRm: u32 = 2;
pub const SYS_SMPRIMAP_EL2_Op2: u32 = 5;
pub const SMPRIMAP_EL2_P15_SHIFT: u32 = 60;
pub const SMPRIMAP_EL2_P15_WIDTH: u32 = 4;
pub const SMPRIMAP_EL2_P14_SHIFT: u32 = 56;
pub const SMPRIMAP_EL2_P14_WIDTH: u32 = 4;
pub const SMPRIMAP_EL2_P13_SHIFT: u32 = 52;
pub const SMPRIMAP_EL2_P13_WIDTH: u32 = 4;
pub const SMPRIMAP_EL2_P12_SHIFT: u32 = 48;
pub const SMPRIMAP_EL2_P12_WIDTH: u32 = 4;
pub const SMPRIMAP_EL2_P11_SHIFT: u32 = 44;
pub const SMPRIMAP_EL2_P11_WIDTH: u32 = 4;
pub const SMPRIMAP_EL2_P10_SHIFT: u32 = 40;
pub const SMPRIMAP_EL2_P10_WIDTH: u32 = 4;
pub const SMPRIMAP_EL2_F9_SHIFT: u32 = 36;
pub const SMPRIMAP_EL2_F9_WIDTH: u32 = 4;
pub const SMPRIMAP_EL2_P8_SHIFT: u32 = 32;
pub const SMPRIMAP_EL2_P8_WIDTH: u32 = 4;
pub const SMPRIMAP_EL2_P7_SHIFT: u32 = 28;
pub const SMPRIMAP_EL2_P7_WIDTH: u32 = 4;
pub const SMPRIMAP_EL2_P6_SHIFT: u32 = 24;
pub const SMPRIMAP_EL2_P6_WIDTH: u32 = 4;
pub const SMPRIMAP_EL2_P5_SHIFT: u32 = 20;
pub const SMPRIMAP_EL2_P5_WIDTH: u32 = 4;
pub const SMPRIMAP_EL2_P4_SHIFT: u32 = 16;
pub const SMPRIMAP_EL2_P4_WIDTH: u32 = 4;
pub const SMPRIMAP_EL2_P3_SHIFT: u32 = 12;
pub const SMPRIMAP_EL2_P3_WIDTH: u32 = 4;
pub const SMPRIMAP_EL2_P2_SHIFT: u32 = 8;
pub const SMPRIMAP_EL2_P2_WIDTH: u32 = 4;
pub const SMPRIMAP_EL2_P1_SHIFT: u32 = 4;
pub const SMPRIMAP_EL2_P1_WIDTH: u32 = 4;
pub const SMPRIMAP_EL2_P0_SHIFT: u32 = 0;
pub const SMPRIMAP_EL2_P0_WIDTH: u32 = 4;
pub const SYS_SMCR_EL2_Op0: u32 = 3;
pub const SYS_SMCR_EL2_Op1: u32 = 4;
pub const SYS_SMCR_EL2_CRn: u32 = 1;
pub const SYS_SMCR_EL2_CRm: u32 = 2;
pub const SYS_SMCR_EL2_Op2: u32 = 6;
pub const SYS_GCSCR_EL2_Op0: u32 = 3;
pub const SYS_GCSCR_EL2_Op1: u32 = 4;
pub const SYS_GCSCR_EL2_CRn: u32 = 2;
pub const SYS_GCSCR_EL2_CRm: u32 = 5;
pub const SYS_GCSCR_EL2_Op2: u32 = 0;
pub const SYS_GCSPR_EL2_Op0: u32 = 3;
pub const SYS_GCSPR_EL2_Op1: u32 = 4;
pub const SYS_GCSPR_EL2_CRn: u32 = 2;
pub const SYS_GCSPR_EL2_CRm: u32 = 5;
pub const SYS_GCSPR_EL2_Op2: u32 = 1;
pub const SYS_DACR32_EL2_Op0: u32 = 3;
pub const SYS_DACR32_EL2_Op1: u32 = 4;
pub const SYS_DACR32_EL2_CRn: u32 = 3;
pub const SYS_DACR32_EL2_CRm: u32 = 0;
pub const SYS_DACR32_EL2_Op2: u32 = 0;
pub const DACR32_EL2_D15_SHIFT: u32 = 30;
pub const DACR32_EL2_D15_WIDTH: u32 = 2;
pub const DACR32_EL2_D14_SHIFT: u32 = 28;
pub const DACR32_EL2_D14_WIDTH: u32 = 2;
pub const DACR32_EL2_D13_SHIFT: u32 = 26;
pub const DACR32_EL2_D13_WIDTH: u32 = 2;
pub const DACR32_EL2_D12_SHIFT: u32 = 24;
pub const DACR32_EL2_D12_WIDTH: u32 = 2;
pub const DACR32_EL2_D11_SHIFT: u32 = 22;
pub const DACR32_EL2_D11_WIDTH: u32 = 2;
pub const DACR32_EL2_D10_SHIFT: u32 = 20;
pub const DACR32_EL2_D10_WIDTH: u32 = 2;
pub const DACR32_EL2_D9_SHIFT: u32 = 18;
pub const DACR32_EL2_D9_WIDTH: u32 = 2;
pub const DACR32_EL2_D8_SHIFT: u32 = 16;
pub const DACR32_EL2_D8_WIDTH: u32 = 2;
pub const DACR32_EL2_D7_SHIFT: u32 = 14;
pub const DACR32_EL2_D7_WIDTH: u32 = 2;
pub const DACR32_EL2_D6_SHIFT: u32 = 12;
pub const DACR32_EL2_D6_WIDTH: u32 = 2;
pub const DACR32_EL2_D5_SHIFT: u32 = 10;
pub const DACR32_EL2_D5_WIDTH: u32 = 2;
pub const DACR32_EL2_D4_SHIFT: u32 = 8;
pub const DACR32_EL2_D4_WIDTH: u32 = 2;
pub const DACR32_EL2_D3_SHIFT: u32 = 6;
pub const DACR32_EL2_D3_WIDTH: u32 = 2;
pub const DACR32_EL2_D2_SHIFT: u32 = 4;
pub const DACR32_EL2_D2_WIDTH: u32 = 2;
pub const DACR32_EL2_D1_SHIFT: u32 = 2;
pub const DACR32_EL2_D1_WIDTH: u32 = 2;
pub const DACR32_EL2_D0_SHIFT: u32 = 0;
pub const DACR32_EL2_D0_WIDTH: u32 = 2;
pub const SYS_FAR_EL2_Op0: u32 = 3;
pub const SYS_FAR_EL2_Op1: u32 = 4;
pub const SYS_FAR_EL2_CRn: u32 = 6;
pub const SYS_FAR_EL2_CRm: u32 = 0;
pub const SYS_FAR_EL2_Op2: u32 = 0;
pub const FAR_EL2_ADDR_SHIFT: u32 = 0;
pub const FAR_EL2_ADDR_WIDTH: u32 = 64;
pub const SYS_PMSCR_EL2_Op0: u32 = 3;
pub const SYS_PMSCR_EL2_Op1: u32 = 4;
pub const SYS_PMSCR_EL2_CRn: u32 = 9;
pub const SYS_PMSCR_EL2_CRm: u32 = 9;
pub const SYS_PMSCR_EL2_Op2: u32 = 0;
pub const PMSCR_EL2_PCT_SHIFT: u32 = 6;
pub const PMSCR_EL2_PCT_WIDTH: u32 = 2;
pub const PMSCR_EL2_TS_SHIFT: u32 = 5;
pub const PMSCR_EL2_TS_WIDTH: u32 = 1;
pub const PMSCR_EL2_PA_SHIFT: u32 = 4;
pub const PMSCR_EL2_PA_WIDTH: u32 = 1;
pub const PMSCR_EL2_CX_SHIFT: u32 = 3;
pub const PMSCR_EL2_CX_WIDTH: u32 = 1;
pub const PMSCR_EL2_E2SPE_SHIFT: u32 = 1;
pub const PMSCR_EL2_E2SPE_WIDTH: u32 = 1;
pub const PMSCR_EL2_E0HSPE_SHIFT: u32 = 0;
pub const PMSCR_EL2_E0HSPE_WIDTH: u32 = 1;
pub const SYS_MPAMHCR_EL2_Op0: u32 = 3;
pub const SYS_MPAMHCR_EL2_Op1: u32 = 4;
pub const SYS_MPAMHCR_EL2_CRn: u32 = 10;
pub const SYS_MPAMHCR_EL2_CRm: u32 = 4;
pub const SYS_MPAMHCR_EL2_Op2: u32 = 0;
pub const MPAMHCR_EL2_TRAP_MPAMIDR_EL1_SHIFT: u32 = 31;
pub const MPAMHCR_EL2_TRAP_MPAMIDR_EL1_WIDTH: u32 = 1;
pub const MPAMHCR_EL2_GSTAPP_PLK_SHIFT: u32 = 8;
pub const MPAMHCR_EL2_GSTAPP_PLK_WIDTH: u32 = 1;
pub const MPAMHCR_EL2_EL1_VPMEN_SHIFT: u32 = 1;
pub const MPAMHCR_EL2_EL1_VPMEN_WIDTH: u32 = 1;
pub const MPAMHCR_EL2_EL0_VPMEN_SHIFT: u32 = 0;
pub const MPAMHCR_EL2_EL0_VPMEN_WIDTH: u32 = 1;
pub const SYS_MPAMVPMV_EL2_Op0: u32 = 3;
pub const SYS_MPAMVPMV_EL2_Op1: u32 = 4;
pub const SYS_MPAMVPMV_EL2_CRn: u32 = 10;
pub const SYS_MPAMVPMV_EL2_CRm: u32 = 4;
pub const SYS_MPAMVPMV_EL2_Op2: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V31_SHIFT: u32 = 31;
pub const MPAMVPMV_EL2_VPM_V31_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V30_SHIFT: u32 = 30;
pub const MPAMVPMV_EL2_VPM_V30_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V29_SHIFT: u32 = 29;
pub const MPAMVPMV_EL2_VPM_V29_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V28_SHIFT: u32 = 28;
pub const MPAMVPMV_EL2_VPM_V28_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V27_SHIFT: u32 = 27;
pub const MPAMVPMV_EL2_VPM_V27_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V26_SHIFT: u32 = 26;
pub const MPAMVPMV_EL2_VPM_V26_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V25_SHIFT: u32 = 25;
pub const MPAMVPMV_EL2_VPM_V25_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V24_SHIFT: u32 = 24;
pub const MPAMVPMV_EL2_VPM_V24_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V23_SHIFT: u32 = 23;
pub const MPAMVPMV_EL2_VPM_V23_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V22_SHIFT: u32 = 22;
pub const MPAMVPMV_EL2_VPM_V22_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V21_SHIFT: u32 = 21;
pub const MPAMVPMV_EL2_VPM_V21_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V20_SHIFT: u32 = 20;
pub const MPAMVPMV_EL2_VPM_V20_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V19_SHIFT: u32 = 19;
pub const MPAMVPMV_EL2_VPM_V19_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V18_SHIFT: u32 = 18;
pub const MPAMVPMV_EL2_VPM_V18_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V17_SHIFT: u32 = 17;
pub const MPAMVPMV_EL2_VPM_V17_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V16_SHIFT: u32 = 16;
pub const MPAMVPMV_EL2_VPM_V16_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V15_SHIFT: u32 = 15;
pub const MPAMVPMV_EL2_VPM_V15_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V14_SHIFT: u32 = 14;
pub const MPAMVPMV_EL2_VPM_V14_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V13_SHIFT: u32 = 13;
pub const MPAMVPMV_EL2_VPM_V13_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V12_SHIFT: u32 = 12;
pub const MPAMVPMV_EL2_VPM_V12_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V11_SHIFT: u32 = 11;
pub const MPAMVPMV_EL2_VPM_V11_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V10_SHIFT: u32 = 10;
pub const MPAMVPMV_EL2_VPM_V10_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V9_SHIFT: u32 = 9;
pub const MPAMVPMV_EL2_VPM_V9_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V8_SHIFT: u32 = 8;
pub const MPAMVPMV_EL2_VPM_V8_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V7_SHIFT: u32 = 7;
pub const MPAMVPMV_EL2_VPM_V7_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V6_SHIFT: u32 = 6;
pub const MPAMVPMV_EL2_VPM_V6_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V5_SHIFT: u32 = 5;
pub const MPAMVPMV_EL2_VPM_V5_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V4_SHIFT: u32 = 4;
pub const MPAMVPMV_EL2_VPM_V4_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V3_SHIFT: u32 = 3;
pub const MPAMVPMV_EL2_VPM_V3_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V2_SHIFT: u32 = 2;
pub const MPAMVPMV_EL2_VPM_V2_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V1_SHIFT: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V1_WIDTH: u32 = 1;
pub const MPAMVPMV_EL2_VPM_V0_SHIFT: u32 = 0;
pub const MPAMVPMV_EL2_VPM_V0_WIDTH: u32 = 1;
pub const SYS_MPAM2_EL2_Op0: u32 = 3;
pub const SYS_MPAM2_EL2_Op1: u32 = 4;
pub const SYS_MPAM2_EL2_CRn: u32 = 10;
pub const SYS_MPAM2_EL2_CRm: u32 = 5;
pub const SYS_MPAM2_EL2_Op2: u32 = 0;
pub const MPAM2_EL2_MPAMEN_SHIFT: u32 = 63;
pub const MPAM2_EL2_MPAMEN_WIDTH: u32 = 1;
pub const MPAM2_EL2_TIDR_SHIFT: u32 = 58;
pub const MPAM2_EL2_TIDR_WIDTH: u32 = 1;
pub const MPAM2_EL2_ALTSP_HFC_SHIFT: u32 = 56;
pub const MPAM2_EL2_ALTSP_HFC_WIDTH: u32 = 1;
pub const MPAM2_EL2_ALTSP_EL2_SHIFT: u32 = 55;
pub const MPAM2_EL2_ALTSP_EL2_WIDTH: u32 = 1;
pub const MPAM2_EL2_ALTSP_FRCD_SHIFT: u32 = 54;
pub const MPAM2_EL2_ALTSP_FRCD_WIDTH: u32 = 1;
pub const MPAM2_EL2_EnMPAMSM_SHIFT: u32 = 50;
pub const MPAM2_EL2_EnMPAMSM_WIDTH: u32 = 1;
pub const MPAM2_EL2_TRAPMPAM0EL1_SHIFT: u32 = 49;
pub const MPAM2_EL2_TRAPMPAM0EL1_WIDTH: u32 = 1;
pub const MPAM2_EL2_TRAPMPAM1EL1_SHIFT: u32 = 48;
pub const MPAM2_EL2_TRAPMPAM1EL1_WIDTH: u32 = 1;
pub const MPAM2_EL2_PMG_D_SHIFT: u32 = 40;
pub const MPAM2_EL2_PMG_D_WIDTH: u32 = 8;
pub const MPAM2_EL2_PMG_I_SHIFT: u32 = 32;
pub const MPAM2_EL2_PMG_I_WIDTH: u32 = 8;
pub const MPAM2_EL2_PARTID_D_SHIFT: u32 = 16;
pub const MPAM2_EL2_PARTID_D_WIDTH: u32 = 16;
pub const MPAM2_EL2_PARTID_I_SHIFT: u32 = 0;
pub const MPAM2_EL2_PARTID_I_WIDTH: u32 = 16;
pub const SYS_MPAMVPM0_EL2_Op0: u32 = 3;
pub const SYS_MPAMVPM0_EL2_Op1: u32 = 4;
pub const SYS_MPAMVPM0_EL2_CRn: u32 = 10;
pub const SYS_MPAMVPM0_EL2_CRm: u32 = 6;
pub const SYS_MPAMVPM0_EL2_Op2: u32 = 0;
pub const MPAMVPM0_EL2_PhyPARTID3_SHIFT: u32 = 48;
pub const MPAMVPM0_EL2_PhyPARTID3_WIDTH: u32 = 16;
pub const MPAMVPM0_EL2_PhyPARTID2_SHIFT: u32 = 32;
pub const MPAMVPM0_EL2_PhyPARTID2_WIDTH: u32 = 16;
pub const MPAMVPM0_EL2_PhyPARTID1_SHIFT: u32 = 16;
pub const MPAMVPM0_EL2_PhyPARTID1_WIDTH: u32 = 16;
pub const MPAMVPM0_EL2_PhyPARTID0_SHIFT: u32 = 0;
pub const MPAMVPM0_EL2_PhyPARTID0_WIDTH: u32 = 16;
pub const SYS_MPAMVPM1_EL2_Op0: u32 = 3;
pub const SYS_MPAMVPM1_EL2_Op1: u32 = 4;
pub const SYS_MPAMVPM1_EL2_CRn: u32 = 10;
pub const SYS_MPAMVPM1_EL2_CRm: u32 = 6;
pub const SYS_MPAMVPM1_EL2_Op2: u32 = 1;
pub const MPAMVPM1_EL2_PhyPARTID7_SHIFT: u32 = 48;
pub const MPAMVPM1_EL2_PhyPARTID7_WIDTH: u32 = 16;
pub const MPAMVPM1_EL2_PhyPARTID6_SHIFT: u32 = 32;
pub const MPAMVPM1_EL2_PhyPARTID6_WIDTH: u32 = 16;
pub const MPAMVPM1_EL2_PhyPARTID5_SHIFT: u32 = 16;
pub const MPAMVPM1_EL2_PhyPARTID5_WIDTH: u32 = 16;
pub const MPAMVPM1_EL2_PhyPARTID4_SHIFT: u32 = 0;
pub const MPAMVPM1_EL2_PhyPARTID4_WIDTH: u32 = 16;
pub const SYS_MPAMVPM2_EL2_Op0: u32 = 3;
pub const SYS_MPAMVPM2_EL2_Op1: u32 = 4;
pub const SYS_MPAMVPM2_EL2_CRn: u32 = 10;
pub const SYS_MPAMVPM2_EL2_CRm: u32 = 6;
pub const SYS_MPAMVPM2_EL2_Op2: u32 = 2;
pub const MPAMVPM2_EL2_PhyPARTID11_SHIFT: u32 = 48;
pub const MPAMVPM2_EL2_PhyPARTID11_WIDTH: u32 = 16;
pub const MPAMVPM2_EL2_PhyPARTID10_SHIFT: u32 = 32;
pub const MPAMVPM2_EL2_PhyPARTID10_WIDTH: u32 = 16;
pub const MPAMVPM2_EL2_PhyPARTID9_SHIFT: u32 = 16;
pub const MPAMVPM2_EL2_PhyPARTID9_WIDTH: u32 = 16;
pub const MPAMVPM2_EL2_PhyPARTID8_SHIFT: u32 = 0;
pub const MPAMVPM2_EL2_PhyPARTID8_WIDTH: u32 = 16;
pub const SYS_MPAMVPM3_EL2_Op0: u32 = 3;
pub const SYS_MPAMVPM3_EL2_Op1: u32 = 4;
pub const SYS_MPAMVPM3_EL2_CRn: u32 = 10;
pub const SYS_MPAMVPM3_EL2_CRm: u32 = 6;
pub const SYS_MPAMVPM3_EL2_Op2: u32 = 3;
pub const MPAMVPM3_EL2_PhyPARTID15_SHIFT: u32 = 48;
pub const MPAMVPM3_EL2_PhyPARTID15_WIDTH: u32 = 16;
pub const MPAMVPM3_EL2_PhyPARTID14_SHIFT: u32 = 32;
pub const MPAMVPM3_EL2_PhyPARTID14_WIDTH: u32 = 16;
pub const MPAMVPM3_EL2_PhyPARTID13_SHIFT: u32 = 16;
pub const MPAMVPM3_EL2_PhyPARTID13_WIDTH: u32 = 16;
pub const MPAMVPM3_EL2_PhyPARTID12_SHIFT: u32 = 0;
pub const MPAMVPM3_EL2_PhyPARTID12_WIDTH: u32 = 16;
pub const SYS_MPAMVPM4_EL2_Op0: u32 = 3;
pub const SYS_MPAMVPM4_EL2_Op1: u32 = 4;
pub const SYS_MPAMVPM4_EL2_CRn: u32 = 10;
pub const SYS_MPAMVPM4_EL2_CRm: u32 = 6;
pub const SYS_MPAMVPM4_EL2_Op2: u32 = 4;
pub const MPAMVPM4_EL2_PhyPARTID19_SHIFT: u32 = 48;
pub const MPAMVPM4_EL2_PhyPARTID19_WIDTH: u32 = 16;
pub const MPAMVPM4_EL2_PhyPARTID18_SHIFT: u32 = 32;
pub const MPAMVPM4_EL2_PhyPARTID18_WIDTH: u32 = 16;
pub const MPAMVPM4_EL2_PhyPARTID17_SHIFT: u32 = 16;
pub const MPAMVPM4_EL2_PhyPARTID17_WIDTH: u32 = 16;
pub const MPAMVPM4_EL2_PhyPARTID16_SHIFT: u32 = 0;
pub const MPAMVPM4_EL2_PhyPARTID16_WIDTH: u32 = 16;
pub const SYS_MPAMVPM5_EL2_Op0: u32 = 3;
pub const SYS_MPAMVPM5_EL2_Op1: u32 = 4;
pub const SYS_MPAMVPM5_EL2_CRn: u32 = 10;
pub const SYS_MPAMVPM5_EL2_CRm: u32 = 6;
pub const SYS_MPAMVPM5_EL2_Op2: u32 = 5;
pub const MPAMVPM5_EL2_PhyPARTID23_SHIFT: u32 = 48;
pub const MPAMVPM5_EL2_PhyPARTID23_WIDTH: u32 = 16;
pub const MPAMVPM5_EL2_PhyPARTID22_SHIFT: u32 = 32;
pub const MPAMVPM5_EL2_PhyPARTID22_WIDTH: u32 = 16;
pub const MPAMVPM5_EL2_PhyPARTID21_SHIFT: u32 = 16;
pub const MPAMVPM5_EL2_PhyPARTID21_WIDTH: u32 = 16;
pub const MPAMVPM5_EL2_PhyPARTID20_SHIFT: u32 = 0;
pub const MPAMVPM5_EL2_PhyPARTID20_WIDTH: u32 = 16;
pub const SYS_MPAMVPM6_EL2_Op0: u32 = 3;
pub const SYS_MPAMVPM6_EL2_Op1: u32 = 4;
pub const SYS_MPAMVPM6_EL2_CRn: u32 = 10;
pub const SYS_MPAMVPM6_EL2_CRm: u32 = 6;
pub const SYS_MPAMVPM6_EL2_Op2: u32 = 6;
pub const MPAMVPM6_EL2_PhyPARTID27_SHIFT: u32 = 48;
pub const MPAMVPM6_EL2_PhyPARTID27_WIDTH: u32 = 16;
pub const MPAMVPM6_EL2_PhyPARTID26_SHIFT: u32 = 32;
pub const MPAMVPM6_EL2_PhyPARTID26_WIDTH: u32 = 16;
pub const MPAMVPM6_EL2_PhyPARTID25_SHIFT: u32 = 16;
pub const MPAMVPM6_EL2_PhyPARTID25_WIDTH: u32 = 16;
pub const MPAMVPM6_EL2_PhyPARTID24_SHIFT: u32 = 0;
pub const MPAMVPM6_EL2_PhyPARTID24_WIDTH: u32 = 16;
pub const SYS_MPAMVPM7_EL2_Op0: u32 = 3;
pub const SYS_MPAMVPM7_EL2_Op1: u32 = 4;
pub const SYS_MPAMVPM7_EL2_CRn: u32 = 10;
pub const SYS_MPAMVPM7_EL2_CRm: u32 = 6;
pub const SYS_MPAMVPM7_EL2_Op2: u32 = 7;
pub const MPAMVPM7_EL2_PhyPARTID31_SHIFT: u32 = 48;
pub const MPAMVPM7_EL2_PhyPARTID31_WIDTH: u32 = 16;
pub const MPAMVPM7_EL2_PhyPARTID30_SHIFT: u32 = 32;
pub const MPAMVPM7_EL2_PhyPARTID30_WIDTH: u32 = 16;
pub const MPAMVPM7_EL2_PhyPARTID29_SHIFT: u32 = 16;
pub const MPAMVPM7_EL2_PhyPARTID29_WIDTH: u32 = 16;
pub const MPAMVPM7_EL2_PhyPARTID28_SHIFT: u32 = 0;
pub const MPAMVPM7_EL2_PhyPARTID28_WIDTH: u32 = 16;
pub const SYS_ICH_HCR_EL2_Op0: u32 = 3;
pub const SYS_ICH_HCR_EL2_Op1: u32 = 4;
pub const SYS_ICH_HCR_EL2_CRn: u32 = 12;
pub const SYS_ICH_HCR_EL2_CRm: u32 = 11;
pub const SYS_ICH_HCR_EL2_Op2: u32 = 0;
pub const ICH_HCR_EL2_EOIcount_SHIFT: u32 = 27;
pub const ICH_HCR_EL2_EOIcount_WIDTH: u32 = 5;
pub const ICH_HCR_EL2_DVIM_SHIFT: u32 = 15;
pub const ICH_HCR_EL2_DVIM_WIDTH: u32 = 1;
pub const ICH_HCR_EL2_TDIR_SHIFT: u32 = 14;
pub const ICH_HCR_EL2_TDIR_WIDTH: u32 = 1;
pub const ICH_HCR_EL2_TSEI_SHIFT: u32 = 13;
pub const ICH_HCR_EL2_TSEI_WIDTH: u32 = 1;
pub const ICH_HCR_EL2_TALL1_SHIFT: u32 = 12;
pub const ICH_HCR_EL2_TALL1_WIDTH: u32 = 1;
pub const ICH_HCR_EL2_TALL0_SHIFT: u32 = 11;
pub const ICH_HCR_EL2_TALL0_WIDTH: u32 = 1;
pub const ICH_HCR_EL2_TC_SHIFT: u32 = 10;
pub const ICH_HCR_EL2_TC_WIDTH: u32 = 1;
pub const ICH_HCR_EL2_vSGIEOICount_SHIFT: u32 = 8;
pub const ICH_HCR_EL2_vSGIEOICount_WIDTH: u32 = 1;
pub const ICH_HCR_EL2_VGrp1DIE_SHIFT: u32 = 7;
pub const ICH_HCR_EL2_VGrp1DIE_WIDTH: u32 = 1;
pub const ICH_HCR_EL2_VGrp1EIE_SHIFT: u32 = 6;
pub const ICH_HCR_EL2_VGrp1EIE_WIDTH: u32 = 1;
pub const ICH_HCR_EL2_VGrp0DIE_SHIFT: u32 = 5;
pub const ICH_HCR_EL2_VGrp0DIE_WIDTH: u32 = 1;
pub const ICH_HCR_EL2_VGrp0EIE_SHIFT: u32 = 4;
pub const ICH_HCR_EL2_VGrp0EIE_WIDTH: u32 = 1;
pub const ICH_HCR_EL2_NPIE_SHIFT: u32 = 3;
pub const ICH_HCR_EL2_NPIE_WIDTH: u32 = 1;
pub const ICH_HCR_EL2_LRENPIE_SHIFT: u32 = 2;
pub const ICH_HCR_EL2_LRENPIE_WIDTH: u32 = 1;
pub const ICH_HCR_EL2_UIE_SHIFT: u32 = 1;
pub const ICH_HCR_EL2_UIE_WIDTH: u32 = 1;
pub const ICH_HCR_EL2_En_SHIFT: u32 = 0;
pub const ICH_HCR_EL2_En_WIDTH: u32 = 1;
pub const SYS_ICH_VTR_EL2_Op0: u32 = 3;
pub const SYS_ICH_VTR_EL2_Op1: u32 = 4;
pub const SYS_ICH_VTR_EL2_CRn: u32 = 12;
pub const SYS_ICH_VTR_EL2_CRm: u32 = 11;
pub const SYS_ICH_VTR_EL2_Op2: u32 = 1;
pub const ICH_VTR_EL2_PRIbits_SHIFT: u32 = 29;
pub const ICH_VTR_EL2_PRIbits_WIDTH: u32 = 3;
pub const ICH_VTR_EL2_PREbits_SHIFT: u32 = 26;
pub const ICH_VTR_EL2_PREbits_WIDTH: u32 = 3;
pub const ICH_VTR_EL2_IDbits_SHIFT: u32 = 23;
pub const ICH_VTR_EL2_IDbits_WIDTH: u32 = 3;
pub const ICH_VTR_EL2_SEIS_SHIFT: u32 = 22;
pub const ICH_VTR_EL2_SEIS_WIDTH: u32 = 1;
pub const ICH_VTR_EL2_A3V_SHIFT: u32 = 21;
pub const ICH_VTR_EL2_A3V_WIDTH: u32 = 1;
pub const ICH_VTR_EL2_nV4_SHIFT: u32 = 20;
pub const ICH_VTR_EL2_nV4_WIDTH: u32 = 1;
pub const ICH_VTR_EL2_TDS_SHIFT: u32 = 19;
pub const ICH_VTR_EL2_TDS_WIDTH: u32 = 1;
pub const ICH_VTR_EL2_DVIM_SHIFT: u32 = 18;
pub const ICH_VTR_EL2_DVIM_WIDTH: u32 = 1;
pub const ICH_VTR_EL2_ListRegs_SHIFT: u32 = 0;
pub const ICH_VTR_EL2_ListRegs_WIDTH: u32 = 5;
pub const SYS_ICH_MISR_EL2_Op0: u32 = 3;
pub const SYS_ICH_MISR_EL2_Op1: u32 = 4;
pub const SYS_ICH_MISR_EL2_CRn: u32 = 12;
pub const SYS_ICH_MISR_EL2_CRm: u32 = 11;
pub const SYS_ICH_MISR_EL2_Op2: u32 = 2;
pub const ICH_MISR_EL2_VGrp1D_SHIFT: u32 = 7;
pub const ICH_MISR_EL2_VGrp1D_WIDTH: u32 = 1;
pub const ICH_MISR_EL2_VGrp1E_SHIFT: u32 = 6;
pub const ICH_MISR_EL2_VGrp1E_WIDTH: u32 = 1;
pub const ICH_MISR_EL2_VGrp0D_SHIFT: u32 = 5;
pub const ICH_MISR_EL2_VGrp0D_WIDTH: u32 = 1;
pub const ICH_MISR_EL2_VGrp0E_SHIFT: u32 = 4;
pub const ICH_MISR_EL2_VGrp0E_WIDTH: u32 = 1;
pub const ICH_MISR_EL2_NP_SHIFT: u32 = 3;
pub const ICH_MISR_EL2_NP_WIDTH: u32 = 1;
pub const ICH_MISR_EL2_LRENP_SHIFT: u32 = 2;
pub const ICH_MISR_EL2_LRENP_WIDTH: u32 = 1;
pub const ICH_MISR_EL2_U_SHIFT: u32 = 1;
pub const ICH_MISR_EL2_U_WIDTH: u32 = 1;
pub const ICH_MISR_EL2_EOI_SHIFT: u32 = 0;
pub const ICH_MISR_EL2_EOI_WIDTH: u32 = 1;
pub const SYS_CONTEXTIDR_EL2_Op0: u32 = 3;
pub const SYS_CONTEXTIDR_EL2_Op1: u32 = 4;
pub const SYS_CONTEXTIDR_EL2_CRn: u32 = 13;
pub const SYS_CONTEXTIDR_EL2_CRm: u32 = 0;
pub const SYS_CONTEXTIDR_EL2_Op2: u32 = 1;
pub const SYS_CNTPOFF_EL2_Op0: u32 = 3;
pub const SYS_CNTPOFF_EL2_Op1: u32 = 4;
pub const SYS_CNTPOFF_EL2_CRn: u32 = 14;
pub const SYS_CNTPOFF_EL2_CRm: u32 = 0;
pub const SYS_CNTPOFF_EL2_Op2: u32 = 6;
pub const CNTPOFF_EL2_PhysicalOffset_SHIFT: u32 = 0;
pub const CNTPOFF_EL2_PhysicalOffset_WIDTH: u32 = 64;
pub const SYS_CPACR_EL12_Op0: u32 = 3;
pub const SYS_CPACR_EL12_Op1: u32 = 5;
pub const SYS_CPACR_EL12_CRn: u32 = 1;
pub const SYS_CPACR_EL12_CRm: u32 = 0;
pub const SYS_CPACR_EL12_Op2: u32 = 2;
pub const SYS_ZCR_EL12_Op0: u32 = 3;
pub const SYS_ZCR_EL12_Op1: u32 = 5;
pub const SYS_ZCR_EL12_CRn: u32 = 1;
pub const SYS_ZCR_EL12_CRm: u32 = 2;
pub const SYS_ZCR_EL12_Op2: u32 = 0;
pub const SYS_TRFCR_EL12_Op0: u32 = 3;
pub const SYS_TRFCR_EL12_Op1: u32 = 5;
pub const SYS_TRFCR_EL12_CRn: u32 = 1;
pub const SYS_TRFCR_EL12_CRm: u32 = 2;
pub const SYS_TRFCR_EL12_Op2: u32 = 1;
pub const SYS_SMCR_EL12_Op0: u32 = 3;
pub const SYS_SMCR_EL12_Op1: u32 = 5;
pub const SYS_SMCR_EL12_CRn: u32 = 1;
pub const SYS_SMCR_EL12_CRm: u32 = 2;
pub const SYS_SMCR_EL12_Op2: u32 = 6;
pub const SYS_GCSCR_EL12_Op0: u32 = 3;
pub const SYS_GCSCR_EL12_Op1: u32 = 5;
pub const SYS_GCSCR_EL12_CRn: u32 = 2;
pub const SYS_GCSCR_EL12_CRm: u32 = 5;
pub const SYS_GCSCR_EL12_Op2: u32 = 0;
pub const SYS_GCSPR_EL12_Op0: u32 = 3;
pub const SYS_GCSPR_EL12_Op1: u32 = 5;
pub const SYS_GCSPR_EL12_CRn: u32 = 2;
pub const SYS_GCSPR_EL12_CRm: u32 = 5;
pub const SYS_GCSPR_EL12_Op2: u32 = 1;
pub const SYS_FAR_EL12_Op0: u32 = 3;
pub const SYS_FAR_EL12_Op1: u32 = 5;
pub const SYS_FAR_EL12_CRn: u32 = 6;
pub const SYS_FAR_EL12_CRm: u32 = 0;
pub const SYS_FAR_EL12_Op2: u32 = 0;
pub const FAR_EL12_ADDR_SHIFT: u32 = 0;
pub const FAR_EL12_ADDR_WIDTH: u32 = 64;
pub const SYS_MPAM1_EL12_Op0: u32 = 3;
pub const SYS_MPAM1_EL12_Op1: u32 = 5;
pub const SYS_MPAM1_EL12_CRn: u32 = 10;
pub const SYS_MPAM1_EL12_CRm: u32 = 5;
pub const SYS_MPAM1_EL12_Op2: u32 = 0;
pub const SYS_CONTEXTIDR_EL12_Op0: u32 = 3;
pub const SYS_CONTEXTIDR_EL12_Op1: u32 = 5;
pub const SYS_CONTEXTIDR_EL12_CRn: u32 = 13;
pub const SYS_CONTEXTIDR_EL12_CRm: u32 = 0;
pub const SYS_CONTEXTIDR_EL12_Op2: u32 = 1;
pub const TTBRx_EL1_ASID_SHIFT: u32 = 48;
pub const TTBRx_EL1_ASID_WIDTH: u32 = 16;
pub const TTBRx_EL1_BADDR_SHIFT: u32 = 1;
pub const TTBRx_EL1_BADDR_WIDTH: u32 = 47;
pub const TTBRx_EL1_CnP_SHIFT: u32 = 0;
pub const TTBRx_EL1_CnP_WIDTH: u32 = 1;
pub const SYS_TTBR0_EL1_Op0: u32 = 3;
pub const SYS_TTBR0_EL1_Op1: u32 = 0;
pub const SYS_TTBR0_EL1_CRn: u32 = 2;
pub const SYS_TTBR0_EL1_CRm: u32 = 0;
pub const SYS_TTBR0_EL1_Op2: u32 = 0;
pub const SYS_TTBR1_EL1_Op0: u32 = 3;
pub const SYS_TTBR1_EL1_Op1: u32 = 0;
pub const SYS_TTBR1_EL1_CRn: u32 = 2;
pub const SYS_TTBR1_EL1_CRm: u32 = 0;
pub const SYS_TTBR1_EL1_Op2: u32 = 1;
pub const SYS_TCR2_EL1_Op0: u32 = 3;
pub const SYS_TCR2_EL1_Op1: u32 = 0;
pub const SYS_TCR2_EL1_CRn: u32 = 2;
pub const SYS_TCR2_EL1_CRm: u32 = 0;
pub const SYS_TCR2_EL1_Op2: u32 = 3;
pub const TCR2_EL1_DisCH1_SHIFT: u32 = 15;
pub const TCR2_EL1_DisCH1_WIDTH: u32 = 1;
pub const TCR2_EL1_DisCH0_SHIFT: u32 = 14;
pub const TCR2_EL1_DisCH0_WIDTH: u32 = 1;
pub const TCR2_EL1_HAFT_SHIFT: u32 = 11;
pub const TCR2_EL1_HAFT_WIDTH: u32 = 1;
pub const TCR2_EL1_PTTWI_SHIFT: u32 = 10;
pub const TCR2_EL1_PTTWI_WIDTH: u32 = 1;
pub const TCR2_EL1_D128_SHIFT: u32 = 5;
pub const TCR2_EL1_D128_WIDTH: u32 = 1;
pub const TCR2_EL1_AIE_SHIFT: u32 = 4;
pub const TCR2_EL1_AIE_WIDTH: u32 = 1;
pub const TCR2_EL1_POE_SHIFT: u32 = 3;
pub const TCR2_EL1_POE_WIDTH: u32 = 1;
pub const TCR2_EL1_E0POE_SHIFT: u32 = 2;
pub const TCR2_EL1_E0POE_WIDTH: u32 = 1;
pub const TCR2_EL1_PIE_SHIFT: u32 = 1;
pub const TCR2_EL1_PIE_WIDTH: u32 = 1;
pub const TCR2_EL1_PnCH_SHIFT: u32 = 0;
pub const TCR2_EL1_PnCH_WIDTH: u32 = 1;
pub const SYS_TCR2_EL12_Op0: u32 = 3;
pub const SYS_TCR2_EL12_Op1: u32 = 5;
pub const SYS_TCR2_EL12_CRn: u32 = 2;
pub const SYS_TCR2_EL12_CRm: u32 = 0;
pub const SYS_TCR2_EL12_Op2: u32 = 3;
pub const SYS_TCR2_EL2_Op0: u32 = 3;
pub const SYS_TCR2_EL2_Op1: u32 = 4;
pub const SYS_TCR2_EL2_CRn: u32 = 2;
pub const SYS_TCR2_EL2_CRm: u32 = 0;
pub const SYS_TCR2_EL2_Op2: u32 = 3;
pub const TCR2_EL2_DisCH1_SHIFT: u32 = 15;
pub const TCR2_EL2_DisCH1_WIDTH: u32 = 1;
pub const TCR2_EL2_DisCH0_SHIFT: u32 = 14;
pub const TCR2_EL2_DisCH0_WIDTH: u32 = 1;
pub const TCR2_EL2_AMEC1_SHIFT: u32 = 13;
pub const TCR2_EL2_AMEC1_WIDTH: u32 = 1;
pub const TCR2_EL2_AMEC0_SHIFT: u32 = 12;
pub const TCR2_EL2_AMEC0_WIDTH: u32 = 1;
pub const TCR2_EL2_HAFT_SHIFT: u32 = 11;
pub const TCR2_EL2_HAFT_WIDTH: u32 = 1;
pub const TCR2_EL2_PTTWI_SHIFT: u32 = 10;
pub const TCR2_EL2_PTTWI_WIDTH: u32 = 1;
pub const TCR2_EL2_D128_SHIFT: u32 = 5;
pub const TCR2_EL2_D128_WIDTH: u32 = 1;
pub const TCR2_EL2_AIE_SHIFT: u32 = 4;
pub const TCR2_EL2_AIE_WIDTH: u32 = 1;
pub const TCR2_EL2_POE_SHIFT: u32 = 3;
pub const TCR2_EL2_POE_WIDTH: u32 = 1;
pub const TCR2_EL2_E0POE_SHIFT: u32 = 2;
pub const TCR2_EL2_E0POE_WIDTH: u32 = 1;
pub const TCR2_EL2_PIE_SHIFT: u32 = 1;
pub const TCR2_EL2_PIE_WIDTH: u32 = 1;
pub const TCR2_EL2_PnCH_SHIFT: u32 = 0;
pub const TCR2_EL2_PnCH_WIDTH: u32 = 1;
pub const MAIR2_ELx_Attr7_SHIFT: u32 = 56;
pub const MAIR2_ELx_Attr7_WIDTH: u32 = 8;
pub const MAIR2_ELx_Attr6_SHIFT: u32 = 48;
pub const MAIR2_ELx_Attr6_WIDTH: u32 = 8;
pub const MAIR2_ELx_Attr5_SHIFT: u32 = 40;
pub const MAIR2_ELx_Attr5_WIDTH: u32 = 8;
pub const MAIR2_ELx_Attr4_SHIFT: u32 = 32;
pub const MAIR2_ELx_Attr4_WIDTH: u32 = 8;
pub const MAIR2_ELx_Attr3_SHIFT: u32 = 24;
pub const MAIR2_ELx_Attr3_WIDTH: u32 = 8;
pub const MAIR2_ELx_Attr2_SHIFT: u32 = 16;
pub const MAIR2_ELx_Attr2_WIDTH: u32 = 8;
pub const MAIR2_ELx_Attr1_SHIFT: u32 = 8;
pub const MAIR2_ELx_Attr1_WIDTH: u32 = 8;
pub const MAIR2_ELx_Attr0_SHIFT: u32 = 0;
pub const MAIR2_ELx_Attr0_WIDTH: u32 = 8;
pub const SYS_MAIR2_EL1_Op0: u32 = 3;
pub const SYS_MAIR2_EL1_Op1: u32 = 0;
pub const SYS_MAIR2_EL1_CRn: u32 = 10;
pub const SYS_MAIR2_EL1_CRm: u32 = 2;
pub const SYS_MAIR2_EL1_Op2: u32 = 1;
pub const SYS_MAIR2_EL2_Op0: u32 = 3;
pub const SYS_MAIR2_EL2_Op1: u32 = 4;
pub const SYS_MAIR2_EL2_CRn: u32 = 10;
pub const SYS_MAIR2_EL2_CRm: u32 = 1;
pub const SYS_MAIR2_EL2_Op2: u32 = 1;
pub const SYS_AMAIR2_EL1_Op0: u32 = 3;
pub const SYS_AMAIR2_EL1_Op1: u32 = 0;
pub const SYS_AMAIR2_EL1_CRn: u32 = 10;
pub const SYS_AMAIR2_EL1_CRm: u32 = 3;
pub const SYS_AMAIR2_EL1_Op2: u32 = 1;
pub const AMAIR2_EL1_ImpDef_SHIFT: u32 = 0;
pub const AMAIR2_EL1_ImpDef_WIDTH: u32 = 64;
pub const SYS_AMAIR2_EL2_Op0: u32 = 3;
pub const SYS_AMAIR2_EL2_Op1: u32 = 4;
pub const SYS_AMAIR2_EL2_CRn: u32 = 10;
pub const SYS_AMAIR2_EL2_CRm: u32 = 3;
pub const SYS_AMAIR2_EL2_Op2: u32 = 1;
pub const AMAIR2_EL2_ImpDef_SHIFT: u32 = 0;
pub const AMAIR2_EL2_ImpDef_WIDTH: u32 = 64;
pub const PIRx_ELx_Perm15_SHIFT: u32 = 60;
pub const PIRx_ELx_Perm15_WIDTH: u32 = 4;
pub const PIRx_ELx_Perm14_SHIFT: u32 = 56;
pub const PIRx_ELx_Perm14_WIDTH: u32 = 4;
pub const PIRx_ELx_Perm13_SHIFT: u32 = 52;
pub const PIRx_ELx_Perm13_WIDTH: u32 = 4;
pub const PIRx_ELx_Perm12_SHIFT: u32 = 48;
pub const PIRx_ELx_Perm12_WIDTH: u32 = 4;
pub const PIRx_ELx_Perm11_SHIFT: u32 = 44;
pub const PIRx_ELx_Perm11_WIDTH: u32 = 4;
pub const PIRx_ELx_Perm10_SHIFT: u32 = 40;
pub const PIRx_ELx_Perm10_WIDTH: u32 = 4;
pub const PIRx_ELx_Perm9_SHIFT: u32 = 36;
pub const PIRx_ELx_Perm9_WIDTH: u32 = 4;
pub const PIRx_ELx_Perm8_SHIFT: u32 = 32;
pub const PIRx_ELx_Perm8_WIDTH: u32 = 4;
pub const PIRx_ELx_Perm7_SHIFT: u32 = 28;
pub const PIRx_ELx_Perm7_WIDTH: u32 = 4;
pub const PIRx_ELx_Perm6_SHIFT: u32 = 24;
pub const PIRx_ELx_Perm6_WIDTH: u32 = 4;
pub const PIRx_ELx_Perm5_SHIFT: u32 = 20;
pub const PIRx_ELx_Perm5_WIDTH: u32 = 4;
pub const PIRx_ELx_Perm4_SHIFT: u32 = 16;
pub const PIRx_ELx_Perm4_WIDTH: u32 = 4;
pub const PIRx_ELx_Perm3_SHIFT: u32 = 12;
pub const PIRx_ELx_Perm3_WIDTH: u32 = 4;
pub const PIRx_ELx_Perm2_SHIFT: u32 = 8;
pub const PIRx_ELx_Perm2_WIDTH: u32 = 4;
pub const PIRx_ELx_Perm1_SHIFT: u32 = 4;
pub const PIRx_ELx_Perm1_WIDTH: u32 = 4;
pub const PIRx_ELx_Perm0_SHIFT: u32 = 0;
pub const PIRx_ELx_Perm0_WIDTH: u32 = 4;
pub const SYS_PIRE0_EL1_Op0: u32 = 3;
pub const SYS_PIRE0_EL1_Op1: u32 = 0;
pub const SYS_PIRE0_EL1_CRn: u32 = 10;
pub const SYS_PIRE0_EL1_CRm: u32 = 2;
pub const SYS_PIRE0_EL1_Op2: u32 = 2;
pub const SYS_PIRE0_EL12_Op0: u32 = 3;
pub const SYS_PIRE0_EL12_Op1: u32 = 5;
pub const SYS_PIRE0_EL12_CRn: u32 = 10;
pub const SYS_PIRE0_EL12_CRm: u32 = 2;
pub const SYS_PIRE0_EL12_Op2: u32 = 2;
pub const SYS_PIRE0_EL2_Op0: u32 = 3;
pub const SYS_PIRE0_EL2_Op1: u32 = 4;
pub const SYS_PIRE0_EL2_CRn: u32 = 10;
pub const SYS_PIRE0_EL2_CRm: u32 = 2;
pub const SYS_PIRE0_EL2_Op2: u32 = 2;
pub const SYS_PIR_EL1_Op0: u32 = 3;
pub const SYS_PIR_EL1_Op1: u32 = 0;
pub const SYS_PIR_EL1_CRn: u32 = 10;
pub const SYS_PIR_EL1_CRm: u32 = 2;
pub const SYS_PIR_EL1_Op2: u32 = 3;
pub const SYS_PIR_EL12_Op0: u32 = 3;
pub const SYS_PIR_EL12_Op1: u32 = 5;
pub const SYS_PIR_EL12_CRn: u32 = 10;
pub const SYS_PIR_EL12_CRm: u32 = 2;
pub const SYS_PIR_EL12_Op2: u32 = 3;
pub const SYS_PIR_EL2_Op0: u32 = 3;
pub const SYS_PIR_EL2_Op1: u32 = 4;
pub const SYS_PIR_EL2_CRn: u32 = 10;
pub const SYS_PIR_EL2_CRm: u32 = 2;
pub const SYS_PIR_EL2_Op2: u32 = 3;
pub const SYS_POR_EL0_Op0: u32 = 3;
pub const SYS_POR_EL0_Op1: u32 = 3;
pub const SYS_POR_EL0_CRn: u32 = 10;
pub const SYS_POR_EL0_CRm: u32 = 2;
pub const SYS_POR_EL0_Op2: u32 = 4;
pub const SYS_POR_EL1_Op0: u32 = 3;
pub const SYS_POR_EL1_Op1: u32 = 0;
pub const SYS_POR_EL1_CRn: u32 = 10;
pub const SYS_POR_EL1_CRm: u32 = 2;
pub const SYS_POR_EL1_Op2: u32 = 4;
pub const SYS_POR_EL2_Op0: u32 = 3;
pub const SYS_POR_EL2_Op1: u32 = 4;
pub const SYS_POR_EL2_CRn: u32 = 10;
pub const SYS_POR_EL2_CRm: u32 = 2;
pub const SYS_POR_EL2_Op2: u32 = 4;
pub const SYS_POR_EL12_Op0: u32 = 3;
pub const SYS_POR_EL12_Op1: u32 = 5;
pub const SYS_POR_EL12_CRn: u32 = 10;
pub const SYS_POR_EL12_CRm: u32 = 2;
pub const SYS_POR_EL12_Op2: u32 = 4;
pub const SYS_S2POR_EL1_Op0: u32 = 3;
pub const SYS_S2POR_EL1_Op1: u32 = 0;
pub const SYS_S2POR_EL1_CRn: u32 = 10;
pub const SYS_S2POR_EL1_CRm: u32 = 2;
pub const SYS_S2POR_EL1_Op2: u32 = 5;
pub const SYS_S2PIR_EL2_Op0: u32 = 3;
pub const SYS_S2PIR_EL2_Op1: u32 = 4;
pub const SYS_S2PIR_EL2_CRn: u32 = 10;
pub const SYS_S2PIR_EL2_CRm: u32 = 2;
pub const SYS_S2PIR_EL2_Op2: u32 = 5;
pub const SYS_LORSA_EL1_Op0: u32 = 3;
pub const SYS_LORSA_EL1_Op1: u32 = 0;
pub const SYS_LORSA_EL1_CRn: u32 = 10;
pub const SYS_LORSA_EL1_CRm: u32 = 4;
pub const SYS_LORSA_EL1_Op2: u32 = 0;
pub const LORSA_EL1_SA_SHIFT: u32 = 16;
pub const LORSA_EL1_SA_WIDTH: u32 = 36;
pub const LORSA_EL1_Valid_SHIFT: u32 = 0;
pub const LORSA_EL1_Valid_WIDTH: u32 = 1;
pub const SYS_LOREA_EL1_Op0: u32 = 3;
pub const SYS_LOREA_EL1_Op1: u32 = 0;
pub const SYS_LOREA_EL1_CRn: u32 = 10;
pub const SYS_LOREA_EL1_CRm: u32 = 4;
pub const SYS_LOREA_EL1_Op2: u32 = 1;
pub const LOREA_EL1_EA_51_48_SHIFT: u32 = 48;
pub const LOREA_EL1_EA_51_48_WIDTH: u32 = 4;
pub const LOREA_EL1_EA_47_16_SHIFT: u32 = 16;
pub const LOREA_EL1_EA_47_16_WIDTH: u32 = 32;
pub const SYS_LORN_EL1_Op0: u32 = 3;
pub const SYS_LORN_EL1_Op1: u32 = 0;
pub const SYS_LORN_EL1_CRn: u32 = 10;
pub const SYS_LORN_EL1_CRm: u32 = 4;
pub const SYS_LORN_EL1_Op2: u32 = 2;
pub const LORN_EL1_Num_SHIFT: u32 = 0;
pub const LORN_EL1_Num_WIDTH: u32 = 8;
pub const SYS_LORC_EL1_Op0: u32 = 3;
pub const SYS_LORC_EL1_Op1: u32 = 0;
pub const SYS_LORC_EL1_CRn: u32 = 10;
pub const SYS_LORC_EL1_CRm: u32 = 4;
pub const SYS_LORC_EL1_Op2: u32 = 3;
pub const LORC_EL1_DS_SHIFT: u32 = 2;
pub const LORC_EL1_DS_WIDTH: u32 = 8;
pub const LORC_EL1_EN_SHIFT: u32 = 0;
pub const LORC_EL1_EN_WIDTH: u32 = 1;
pub const SYS_MPAMIDR_EL1_Op0: u32 = 3;
pub const SYS_MPAMIDR_EL1_Op1: u32 = 0;
pub const SYS_MPAMIDR_EL1_CRn: u32 = 10;
pub const SYS_MPAMIDR_EL1_CRm: u32 = 4;
pub const SYS_MPAMIDR_EL1_Op2: u32 = 4;
pub const MPAMIDR_EL1_HAS_SDEFLT_SHIFT: u32 = 61;
pub const MPAMIDR_EL1_HAS_SDEFLT_WIDTH: u32 = 1;
pub const MPAMIDR_EL1_HAS_FORCE_NS_SHIFT: u32 = 60;
pub const MPAMIDR_EL1_HAS_FORCE_NS_WIDTH: u32 = 1;
pub const MPAMIDR_EL1_SP4_SHIFT: u32 = 59;
pub const MPAMIDR_EL1_SP4_WIDTH: u32 = 1;
pub const MPAMIDR_EL1_HAS_TIDR_SHIFT: u32 = 58;
pub const MPAMIDR_EL1_HAS_TIDR_WIDTH: u32 = 1;
pub const MPAMIDR_EL1_HAS_ALTSP_SHIFT: u32 = 57;
pub const MPAMIDR_EL1_HAS_ALTSP_WIDTH: u32 = 1;
pub const MPAMIDR_EL1_PMG_MAX_SHIFT: u32 = 32;
pub const MPAMIDR_EL1_PMG_MAX_WIDTH: u32 = 8;
pub const MPAMIDR_EL1_VPMR_MAX_SHIFT: u32 = 18;
pub const MPAMIDR_EL1_VPMR_MAX_WIDTH: u32 = 3;
pub const MPAMIDR_EL1_HAS_HCR_SHIFT: u32 = 17;
pub const MPAMIDR_EL1_HAS_HCR_WIDTH: u32 = 1;
pub const MPAMIDR_EL1_PARTID_MAX_SHIFT: u32 = 0;
pub const MPAMIDR_EL1_PARTID_MAX_WIDTH: u32 = 16;
pub const SYS_LORID_EL1_Op0: u32 = 3;
pub const SYS_LORID_EL1_Op1: u32 = 0;
pub const SYS_LORID_EL1_CRn: u32 = 10;
pub const SYS_LORID_EL1_CRm: u32 = 4;
pub const SYS_LORID_EL1_Op2: u32 = 7;
pub const LORID_EL1_LD_SHIFT: u32 = 16;
pub const LORID_EL1_LD_WIDTH: u32 = 8;
pub const LORID_EL1_LR_SHIFT: u32 = 0;
pub const LORID_EL1_LR_WIDTH: u32 = 8;
pub const SYS_MPAM1_EL1_Op0: u32 = 3;
pub const SYS_MPAM1_EL1_Op1: u32 = 0;
pub const SYS_MPAM1_EL1_CRn: u32 = 10;
pub const SYS_MPAM1_EL1_CRm: u32 = 5;
pub const SYS_MPAM1_EL1_Op2: u32 = 0;
pub const MPAM1_EL1_MPAMEN_SHIFT: u32 = 63;
pub const MPAM1_EL1_MPAMEN_WIDTH: u32 = 1;
pub const MPAM1_EL1_FORCED_NS_SHIFT: u32 = 60;
pub const MPAM1_EL1_FORCED_NS_WIDTH: u32 = 1;
pub const MPAM1_EL1_ALTSP_FRCD_SHIFT: u32 = 54;
pub const MPAM1_EL1_ALTSP_FRCD_WIDTH: u32 = 1;
pub const MPAM1_EL1_PMG_D_SHIFT: u32 = 40;
pub const MPAM1_EL1_PMG_D_WIDTH: u32 = 8;
pub const MPAM1_EL1_PMG_I_SHIFT: u32 = 32;
pub const MPAM1_EL1_PMG_I_WIDTH: u32 = 8;
pub const MPAM1_EL1_PARTID_D_SHIFT: u32 = 16;
pub const MPAM1_EL1_PARTID_D_WIDTH: u32 = 16;
pub const MPAM1_EL1_PARTID_I_SHIFT: u32 = 0;
pub const MPAM1_EL1_PARTID_I_WIDTH: u32 = 16;
pub const SYS_MPAM0_EL1_Op0: u32 = 3;
pub const SYS_MPAM0_EL1_Op1: u32 = 0;
pub const SYS_MPAM0_EL1_CRn: u32 = 10;
pub const SYS_MPAM0_EL1_CRm: u32 = 5;
pub const SYS_MPAM0_EL1_Op2: u32 = 1;
pub const MPAM0_EL1_PMG_D_SHIFT: u32 = 40;
pub const MPAM0_EL1_PMG_D_WIDTH: u32 = 8;
pub const MPAM0_EL1_PMG_I_SHIFT: u32 = 32;
pub const MPAM0_EL1_PMG_I_WIDTH: u32 = 8;
pub const MPAM0_EL1_PARTID_D_SHIFT: u32 = 16;
pub const MPAM0_EL1_PARTID_D_WIDTH: u32 = 16;
pub const MPAM0_EL1_PARTID_I_SHIFT: u32 = 0;
pub const MPAM0_EL1_PARTID_I_WIDTH: u32 = 16;
pub const SYS_ISR_EL1_Op0: u32 = 3;
pub const SYS_ISR_EL1_Op1: u32 = 0;
pub const SYS_ISR_EL1_CRn: u32 = 12;
pub const SYS_ISR_EL1_CRm: u32 = 1;
pub const SYS_ISR_EL1_Op2: u32 = 0;
pub const ISR_EL1_IS_SHIFT: u32 = 10;
pub const ISR_EL1_IS_WIDTH: u32 = 1;
pub const ISR_EL1_FS_SHIFT: u32 = 9;
pub const ISR_EL1_FS_WIDTH: u32 = 1;
pub const ISR_EL1_A_SHIFT: u32 = 8;
pub const ISR_EL1_A_WIDTH: u32 = 1;
pub const ISR_EL1_I_SHIFT: u32 = 7;
pub const ISR_EL1_I_WIDTH: u32 = 1;
pub const ISR_EL1_F_SHIFT: u32 = 6;
pub const ISR_EL1_F_WIDTH: u32 = 1;
pub const SYS_ICC_NMIAR1_EL1_Op0: u32 = 3;
pub const SYS_ICC_NMIAR1_EL1_Op1: u32 = 0;
pub const SYS_ICC_NMIAR1_EL1_CRn: u32 = 12;
pub const SYS_ICC_NMIAR1_EL1_CRm: u32 = 9;
pub const SYS_ICC_NMIAR1_EL1_Op2: u32 = 5;
pub const ICC_NMIAR1_EL1_INTID_SHIFT: u32 = 0;
pub const ICC_NMIAR1_EL1_INTID_WIDTH: u32 = 24;
pub const SYS_TRBLIMITR_EL1_Op0: u32 = 3;
pub const SYS_TRBLIMITR_EL1_Op1: u32 = 0;
pub const SYS_TRBLIMITR_EL1_CRn: u32 = 9;
pub const SYS_TRBLIMITR_EL1_CRm: u32 = 11;
pub const SYS_TRBLIMITR_EL1_Op2: u32 = 0;
pub const TRBLIMITR_EL1_LIMIT_SHIFT: u32 = 12;
pub const TRBLIMITR_EL1_LIMIT_WIDTH: u32 = 52;
pub const TRBLIMITR_EL1_XE_SHIFT: u32 = 6;
pub const TRBLIMITR_EL1_XE_WIDTH: u32 = 1;
pub const TRBLIMITR_EL1_nVM_SHIFT: u32 = 5;
pub const TRBLIMITR_EL1_nVM_WIDTH: u32 = 1;
pub const TRBLIMITR_EL1_TM_SHIFT: u32 = 3;
pub const TRBLIMITR_EL1_TM_WIDTH: u32 = 2;
pub const TRBLIMITR_EL1_FM_SHIFT: u32 = 1;
pub const TRBLIMITR_EL1_FM_WIDTH: u32 = 2;
pub const TRBLIMITR_EL1_E_SHIFT: u32 = 0;
pub const TRBLIMITR_EL1_E_WIDTH: u32 = 1;
pub const SYS_TRBPTR_EL1_Op0: u32 = 3;
pub const SYS_TRBPTR_EL1_Op1: u32 = 0;
pub const SYS_TRBPTR_EL1_CRn: u32 = 9;
pub const SYS_TRBPTR_EL1_CRm: u32 = 11;
pub const SYS_TRBPTR_EL1_Op2: u32 = 1;
pub const TRBPTR_EL1_PTR_SHIFT: u32 = 0;
pub const TRBPTR_EL1_PTR_WIDTH: u32 = 64;
pub const SYS_TRBBASER_EL1_Op0: u32 = 3;
pub const SYS_TRBBASER_EL1_Op1: u32 = 0;
pub const SYS_TRBBASER_EL1_CRn: u32 = 9;
pub const SYS_TRBBASER_EL1_CRm: u32 = 11;
pub const SYS_TRBBASER_EL1_Op2: u32 = 2;
pub const TRBBASER_EL1_BASE_SHIFT: u32 = 12;
pub const TRBBASER_EL1_BASE_WIDTH: u32 = 52;
pub const SYS_TRBSR_EL1_Op0: u32 = 3;
pub const SYS_TRBSR_EL1_Op1: u32 = 0;
pub const SYS_TRBSR_EL1_CRn: u32 = 9;
pub const SYS_TRBSR_EL1_CRm: u32 = 11;
pub const SYS_TRBSR_EL1_Op2: u32 = 3;
pub const TRBSR_EL1_MSS2_SHIFT: u32 = 32;
pub const TRBSR_EL1_MSS2_WIDTH: u32 = 24;
pub const TRBSR_EL1_EC_SHIFT: u32 = 26;
pub const TRBSR_EL1_EC_WIDTH: u32 = 6;
pub const TRBSR_EL1_DAT_SHIFT: u32 = 23;
pub const TRBSR_EL1_DAT_WIDTH: u32 = 1;
pub const TRBSR_EL1_IRQ_SHIFT: u32 = 22;
pub const TRBSR_EL1_IRQ_WIDTH: u32 = 1;
pub const TRBSR_EL1_TRG_SHIFT: u32 = 21;
pub const TRBSR_EL1_TRG_WIDTH: u32 = 1;
pub const TRBSR_EL1_WRAP_SHIFT: u32 = 20;
pub const TRBSR_EL1_WRAP_WIDTH: u32 = 1;
pub const TRBSR_EL1_EA_SHIFT: u32 = 18;
pub const TRBSR_EL1_EA_WIDTH: u32 = 1;
pub const TRBSR_EL1_S_SHIFT: u32 = 17;
pub const TRBSR_EL1_S_WIDTH: u32 = 1;
pub const TRBSR_EL1_MSS_SHIFT: u32 = 0;
pub const TRBSR_EL1_MSS_WIDTH: u32 = 16;
pub const SYS_TRBMAR_EL1_Op0: u32 = 3;
pub const SYS_TRBMAR_EL1_Op1: u32 = 0;
pub const SYS_TRBMAR_EL1_CRn: u32 = 9;
pub const SYS_TRBMAR_EL1_CRm: u32 = 11;
pub const SYS_TRBMAR_EL1_Op2: u32 = 4;
pub const TRBMAR_EL1_PAS_SHIFT: u32 = 10;
pub const TRBMAR_EL1_PAS_WIDTH: u32 = 2;
pub const TRBMAR_EL1_SH_SHIFT: u32 = 8;
pub const TRBMAR_EL1_SH_WIDTH: u32 = 2;
pub const TRBMAR_EL1_Attr_SHIFT: u32 = 0;
pub const TRBMAR_EL1_Attr_WIDTH: u32 = 8;
pub const SYS_TRBTRG_EL1_Op0: u32 = 3;
pub const SYS_TRBTRG_EL1_Op1: u32 = 0;
pub const SYS_TRBTRG_EL1_CRn: u32 = 9;
pub const SYS_TRBTRG_EL1_CRm: u32 = 11;
pub const SYS_TRBTRG_EL1_Op2: u32 = 6;
pub const TRBTRG_EL1_TRG_SHIFT: u32 = 0;
pub const TRBTRG_EL1_TRG_WIDTH: u32 = 32;
pub const SYS_TRBIDR_EL1_Op0: u32 = 3;
pub const SYS_TRBIDR_EL1_Op1: u32 = 0;
pub const SYS_TRBIDR_EL1_CRn: u32 = 9;
pub const SYS_TRBIDR_EL1_CRm: u32 = 11;
pub const SYS_TRBIDR_EL1_Op2: u32 = 7;
pub const TRBIDR_EL1_EA_SHIFT: u32 = 8;
pub const TRBIDR_EL1_EA_WIDTH: u32 = 4;
pub const TRBIDR_EL1_F_SHIFT: u32 = 5;
pub const TRBIDR_EL1_F_WIDTH: u32 = 1;
pub const TRBIDR_EL1_P_SHIFT: u32 = 4;
pub const TRBIDR_EL1_P_WIDTH: u32 = 1;
pub const TRBIDR_EL1_Align_SHIFT: u32 = 0;
pub const TRBIDR_EL1_Align_WIDTH: u32 = 4;
pub const SYS_HPFAR_EL2_Op0: u32 = 3;
pub const SYS_HPFAR_EL2_Op1: u32 = 4;
pub const SYS_HPFAR_EL2_CRn: u32 = 6;
pub const SYS_HPFAR_EL2_CRm: u32 = 0;
pub const SYS_HPFAR_EL2_Op2: u32 = 4;
pub const HPFAR_EL2_NS_SHIFT: u32 = 63;
pub const HPFAR_EL2_NS_WIDTH: u32 = 1;
pub const HPFAR_EL2_FIPA_SHIFT: u32 = 4;
pub const HPFAR_EL2_FIPA_WIDTH: u32 = 44;
pub const OSLSR_EL1_OSLM_NI: u32 = 0;
pub const PMBSR_EL1_FAULT_FSC_SHIFT: u32 = 0;
pub const PMBSR_EL1_BUF_BSC_SHIFT: u32 = 0;
pub const PMBSR_EL1_BUF_BSC_FULL: u32 = 1;
pub const TRBSR_EL1_BSC_SHIFT: u32 = 0;
pub const AT_Op0: u32 = 1;
pub const AT_CRn: u32 = 7;
pub const TLBI_Op0: u32 = 1;
pub const TLBI_Op1_EL1: u32 = 0;
pub const TLBI_Op1_EL2: u32 = 4;
pub const TLBI_CRn_XS: u32 = 8;
pub const TLBI_CRn_nXS: u32 = 9;
pub const TLBI_CRm_IPAIS: u32 = 0;
pub const TLBI_CRm_nROS: u32 = 1;
pub const TLBI_CRm_RIS: u32 = 2;
pub const TLBI_CRm_nRIS: u32 = 3;
pub const TLBI_CRm_IPAONS: u32 = 4;
pub const TLBI_CRm_ROS: u32 = 5;
pub const TLBI_CRm_RNS: u32 = 6;
pub const TLBI_CRm_nRNS: u32 = 7;
pub const SCTLR_ELx_EE_SHIFT: u32 = 25;
pub const SCTLR_ELx_ENIA_SHIFT: u32 = 31;
pub const ENDIAN_SET_EL2: u32 = 0;
pub const ENDIAN_SET_EL1: u32 = 0;
pub const ID_AA64MMFR0_EL1_TGRAN4_SUPPORTED_MIN: u32 = 0;
pub const ID_AA64MMFR0_EL1_TGRAN4_SUPPORTED_MAX: u32 = 7;
pub const ID_AA64MMFR0_EL1_TGRAN64_SUPPORTED_MIN: u32 = 0;
pub const ID_AA64MMFR0_EL1_TGRAN64_SUPPORTED_MAX: u32 = 7;
pub const ID_AA64MMFR0_EL1_TGRAN16_SUPPORTED_MIN: u32 = 1;
pub const ID_AA64MMFR0_EL1_TGRAN16_SUPPORTED_MAX: u32 = 15;
pub const ARM64_MIN_PARANGE_BITS: u32 = 32;
pub const ID_AA64MMFR0_EL1_TGRAN_2_SUPPORTED_DEFAULT: u32 = 0;
pub const ID_AA64MMFR0_EL1_TGRAN_2_SUPPORTED_NONE: u32 = 1;
pub const ID_AA64MMFR0_EL1_TGRAN_2_SUPPORTED_MIN: u32 = 2;
pub const ID_AA64MMFR0_EL1_TGRAN_2_SUPPORTED_LPA2: u32 = 3;
pub const ID_AA64MMFR0_EL1_TGRAN_2_SUPPORTED_MAX: u32 = 7;
pub const ID_AA64MMFR0_EL1_TGRAN_SHIFT: u32 = 28;
pub const ID_AA64MMFR0_EL1_TGRAN_SUPPORTED_MIN: u32 = 0;
pub const ID_AA64MMFR0_EL1_TGRAN_SUPPORTED_MAX: u32 = 7;
pub const ID_AA64MMFR0_EL1_TGRAN_2_SHIFT: u32 = 40;
pub const SYS_GCR_EL1_EXCL_MASK: u32 = 65535;
pub const KERNEL_GCR_EL1_EXCL: u32 = 65535;
pub const SYS_RGSR_EL1_TAG_MASK: u32 = 15;
pub const SYS_RGSR_EL1_SEED_SHIFT: u32 = 8;
pub const SYS_RGSR_EL1_SEED_MASK: u32 = 65535;
pub const SYS_TFSR_EL1_TF0_SHIFT: u32 = 0;
pub const SYS_TFSR_EL1_TF1_SHIFT: u32 = 1;
pub const ICH_LR_VIRTUAL_ID_MASK: u32 = 4294967295;
pub const ICH_LR_EOI: u64 = 2199023255552;
pub const ICH_LR_GROUP: u64 = 1152921504606846976;
pub const ICH_LR_HW: u64 = 2305843009213693952;
pub const ICH_LR_STATE: i64 = -4611686018427387904;
pub const ICH_LR_PENDING_BIT: u64 = 4611686018427387904;
pub const ICH_LR_ACTIVE_BIT: i64 = -9223372036854775808;
pub const ICH_LR_PHYS_ID_SHIFT: u32 = 32;
pub const ICH_LR_PHYS_ID_MASK: u64 = 4393751543808;
pub const ICH_LR_PRIORITY_SHIFT: u32 = 48;
pub const ICH_LR_PRIORITY_MASK: u64 = 71776119061217280;
pub const ICH_VMCR_ACK_CTL_SHIFT: u32 = 2;
pub const ICH_VMCR_ACK_CTL_MASK: u32 = 4;
pub const ICH_VMCR_FIQ_EN_SHIFT: u32 = 3;
pub const ICH_VMCR_FIQ_EN_MASK: u32 = 8;
pub const ICH_VMCR_CBPR_SHIFT: u32 = 4;
pub const ICH_VMCR_CBPR_MASK: u32 = 16;
pub const ICH_VMCR_EOIM_SHIFT: u32 = 9;
pub const ICH_VMCR_EOIM_MASK: u32 = 512;
pub const ICH_VMCR_BPR1_SHIFT: u32 = 18;
pub const ICH_VMCR_BPR1_MASK: u32 = 1835008;
pub const ICH_VMCR_BPR0_SHIFT: u32 = 21;
pub const ICH_VMCR_BPR0_MASK: u32 = 14680064;
pub const ICH_VMCR_PMR_SHIFT: u32 = 24;
pub const ICH_VMCR_PMR_MASK: u32 = 4278190080;
pub const ICH_VMCR_ENG0_SHIFT: u32 = 0;
pub const ICH_VMCR_ENG0_MASK: u32 = 1;
pub const ICH_VMCR_ENG1_SHIFT: u32 = 1;
pub const ICH_VMCR_ENG1_MASK: u32 = 2;
pub const PIRx_ELx_BITS_PER_IDX: u32 = 4;
pub const POR_ELx_BITS_PER_IDX: u32 = 4;
pub const GCS_CAP_ADDR_SHIFT: u32 = 12;
pub const GCS_CAP_ADDR_WIDTH: u32 = 52;
pub const GCS_CAP_TOKEN_SHIFT: u32 = 0;
pub const GCS_CAP_TOKEN_WIDTH: u32 = 12;
pub const GCS_CAP_VALID_TOKEN: u32 = 1;
pub const GCS_CAP_IN_PROGRESS_TOKEN: u32 = 5;
pub const ARM64_FEATURE_FIELD_BITS: u32 = 4;
pub const MIN_MEMBLOCK_ADDR: u32 = 0;
pub const TIF_SIGPENDING: u32 = 0;
pub const TIF_NEED_RESCHED: u32 = 1;
pub const TIF_NOTIFY_RESUME: u32 = 2;
pub const TIF_FOREIGN_FPSTATE: u32 = 3;
pub const TIF_UPROBE: u32 = 4;
pub const TIF_MTE_ASYNC_FAULT: u32 = 5;
pub const TIF_NOTIFY_SIGNAL: u32 = 6;
pub const TIF_SYSCALL_TRACE: u32 = 8;
pub const TIF_SYSCALL_AUDIT: u32 = 9;
pub const TIF_SYSCALL_TRACEPOINT: u32 = 10;
pub const TIF_SECCOMP: u32 = 11;
pub const TIF_SYSCALL_EMU: u32 = 12;
pub const TIF_MEMDIE: u32 = 18;
pub const TIF_FREEZE: u32 = 19;
pub const TIF_RESTORE_SIGMASK: u32 = 20;
pub const TIF_SINGLESTEP: u32 = 21;
pub const TIF_32BIT: u32 = 22;
pub const TIF_SVE: u32 = 23;
pub const TIF_SVE_VL_INHERIT: u32 = 24;
pub const TIF_SSBD: u32 = 25;
pub const TIF_TAGGED_ADDR: u32 = 26;
pub const TIF_SME: u32 = 27;
pub const TIF_SME_VL_INHERIT: u32 = 28;
pub const TIF_KERNEL_FPSTATE: u32 = 29;
pub const TIF_TSC_SIGSEGV: u32 = 30;
pub const _TIF_SIGPENDING: u32 = 1;
pub const _TIF_NEED_RESCHED: u32 = 2;
pub const _TIF_NOTIFY_RESUME: u32 = 4;
pub const _TIF_FOREIGN_FPSTATE: u32 = 8;
pub const _TIF_SYSCALL_TRACE: u32 = 256;
pub const _TIF_SYSCALL_AUDIT: u32 = 512;
pub const _TIF_SYSCALL_TRACEPOINT: u32 = 1024;
pub const _TIF_SECCOMP: u32 = 2048;
pub const _TIF_SYSCALL_EMU: u32 = 4096;
pub const _TIF_UPROBE: u32 = 16;
pub const _TIF_SINGLESTEP: u32 = 2097152;
pub const _TIF_32BIT: u32 = 4194304;
pub const _TIF_SVE: u32 = 8388608;
pub const _TIF_MTE_ASYNC_FAULT: u32 = 32;
pub const _TIF_NOTIFY_SIGNAL: u32 = 64;
pub const _TIF_TSC_SIGSEGV: u32 = 1073741824;
pub const _TIF_WORK_MASK: u32 = 127;
pub const _TIF_SYSCALL_WORK: u32 = 7936;
pub const TIF_NEED_RESCHED_LAZY: u32 = 1;
pub const _TIF_NEED_RESCHED_LAZY: u32 = 2;
pub const PREEMPT_DISABLE_OFFSET: u32 = 1;
pub const PREEMPT_LOCK_OFFSET: u32 = 1;
pub const SOFTIRQ_LOCK_OFFSET: u32 = 513;
pub const INVALID_HWID: i32 = -1;
pub const MPIDR_UP_BITMASK: u32 = 1073741824;
pub const MPIDR_MT_BITMASK: u32 = 16777216;
pub const MPIDR_LEVEL_BITS_SHIFT: u32 = 3;
pub const MPIDR_LEVEL_BITS: u32 = 8;
pub const MPIDR_LEVEL_MASK: u32 = 255;
pub const MIDR_REVISION_MASK: u32 = 15;
pub const MIDR_PARTNUM_SHIFT: u32 = 4;
pub const MIDR_PARTNUM_MASK: u32 = 65520;
pub const MIDR_ARCHITECTURE_SHIFT: u32 = 16;
pub const MIDR_ARCHITECTURE_MASK: u32 = 983040;
pub const MIDR_VARIANT_SHIFT: u32 = 20;
pub const MIDR_VARIANT_MASK: u32 = 15728640;
pub const MIDR_IMPLEMENTOR_SHIFT: u32 = 24;
pub const MIDR_IMPLEMENTOR_MASK: u32 = 4278190080;
pub const MIDR_CPU_MODEL_MASK: u32 = 4279238640;
pub const ARM_CPU_IMP_ARM: u32 = 65;
pub const ARM_CPU_IMP_APM: u32 = 80;
pub const ARM_CPU_IMP_CAVIUM: u32 = 67;
pub const ARM_CPU_IMP_BRCM: u32 = 66;
pub const ARM_CPU_IMP_QCOM: u32 = 81;
pub const ARM_CPU_IMP_NVIDIA: u32 = 78;
pub const ARM_CPU_IMP_FUJITSU: u32 = 70;
pub const ARM_CPU_IMP_HISI: u32 = 72;
pub const ARM_CPU_IMP_APPLE: u32 = 97;
pub const ARM_CPU_IMP_AMPERE: u32 = 192;
pub const ARM_CPU_IMP_MICROSOFT: u32 = 109;
pub const ARM_CPU_PART_AEM_V8: u32 = 3343;
pub const ARM_CPU_PART_FOUNDATION: u32 = 3328;
pub const ARM_CPU_PART_CORTEX_A57: u32 = 3335;
pub const ARM_CPU_PART_CORTEX_A72: u32 = 3336;
pub const ARM_CPU_PART_CORTEX_A53: u32 = 3331;
pub const ARM_CPU_PART_CORTEX_A73: u32 = 3337;
pub const ARM_CPU_PART_CORTEX_A75: u32 = 3338;
pub const ARM_CPU_PART_CORTEX_A35: u32 = 3332;
pub const ARM_CPU_PART_CORTEX_A55: u32 = 3333;
pub const ARM_CPU_PART_CORTEX_A76: u32 = 3339;
pub const ARM_CPU_PART_NEOVERSE_N1: u32 = 3340;
pub const ARM_CPU_PART_CORTEX_A77: u32 = 3341;
pub const ARM_CPU_PART_CORTEX_A76AE: u32 = 3342;
pub const ARM_CPU_PART_NEOVERSE_V1: u32 = 3392;
pub const ARM_CPU_PART_CORTEX_A78: u32 = 3393;
pub const ARM_CPU_PART_CORTEX_A78AE: u32 = 3394;
pub const ARM_CPU_PART_CORTEX_X1: u32 = 3396;
pub const ARM_CPU_PART_CORTEX_A510: u32 = 3398;
pub const ARM_CPU_PART_CORTEX_X1C: u32 = 3404;
pub const ARM_CPU_PART_CORTEX_A520: u32 = 3456;
pub const ARM_CPU_PART_CORTEX_A710: u32 = 3399;
pub const ARM_CPU_PART_CORTEX_A715: u32 = 3405;
pub const ARM_CPU_PART_CORTEX_X2: u32 = 3400;
pub const ARM_CPU_PART_NEOVERSE_N2: u32 = 3401;
pub const ARM_CPU_PART_CORTEX_A78C: u32 = 3403;
pub const ARM_CPU_PART_CORTEX_X3: u32 = 3406;
pub const ARM_CPU_PART_NEOVERSE_V2: u32 = 3407;
pub const ARM_CPU_PART_CORTEX_A720: u32 = 3457;
pub const ARM_CPU_PART_CORTEX_X4: u32 = 3458;
pub const ARM_CPU_PART_NEOVERSE_V3: u32 = 3460;
pub const ARM_CPU_PART_CORTEX_X925: u32 = 3461;
pub const ARM_CPU_PART_CORTEX_A725: u32 = 3463;
pub const ARM_CPU_PART_NEOVERSE_N3: u32 = 3470;
pub const APM_CPU_PART_XGENE: u32 = 0;
pub const APM_CPU_VAR_POTENZA: u32 = 0;
pub const CAVIUM_CPU_PART_THUNDERX: u32 = 161;
pub const CAVIUM_CPU_PART_THUNDERX_81XX: u32 = 162;
pub const CAVIUM_CPU_PART_THUNDERX_83XX: u32 = 163;
pub const CAVIUM_CPU_PART_THUNDERX2: u32 = 175;
pub const CAVIUM_CPU_PART_OCTX2_98XX: u32 = 177;
pub const CAVIUM_CPU_PART_OCTX2_96XX: u32 = 178;
pub const CAVIUM_CPU_PART_OCTX2_95XX: u32 = 179;
pub const CAVIUM_CPU_PART_OCTX2_95XXN: u32 = 180;
pub const CAVIUM_CPU_PART_OCTX2_95XXMM: u32 = 181;
pub const CAVIUM_CPU_PART_OCTX2_95XXO: u32 = 182;
pub const BRCM_CPU_PART_BRAHMA_B53: u32 = 256;
pub const BRCM_CPU_PART_VULCAN: u32 = 1302;
pub const QCOM_CPU_PART_FALKOR_V1: u32 = 2048;
pub const QCOM_CPU_PART_FALKOR: u32 = 3072;
pub const QCOM_CPU_PART_KRYO: u32 = 512;
pub const QCOM_CPU_PART_KRYO_2XX_GOLD: u32 = 2048;
pub const QCOM_CPU_PART_KRYO_2XX_SILVER: u32 = 2049;
pub const QCOM_CPU_PART_KRYO_3XX_GOLD: u32 = 2050;
pub const QCOM_CPU_PART_KRYO_3XX_SILVER: u32 = 2051;
pub const QCOM_CPU_PART_KRYO_4XX_GOLD: u32 = 2052;
pub const QCOM_CPU_PART_KRYO_4XX_SILVER: u32 = 2053;
pub const QCOM_CPU_PART_ORYON_X1: u32 = 1;
pub const NVIDIA_CPU_PART_DENVER: u32 = 3;
pub const NVIDIA_CPU_PART_CARMEL: u32 = 4;
pub const FUJITSU_CPU_PART_A64FX: u32 = 1;
pub const HISI_CPU_PART_TSV110: u32 = 3329;
pub const HISI_CPU_PART_HIP09: u32 = 3330;
pub const APPLE_CPU_PART_M1_ICESTORM: u32 = 34;
pub const APPLE_CPU_PART_M1_FIRESTORM: u32 = 35;
pub const APPLE_CPU_PART_M1_ICESTORM_PRO: u32 = 36;
pub const APPLE_CPU_PART_M1_FIRESTORM_PRO: u32 = 37;
pub const APPLE_CPU_PART_M1_ICESTORM_MAX: u32 = 40;
pub const APPLE_CPU_PART_M1_FIRESTORM_MAX: u32 = 41;
pub const APPLE_CPU_PART_M2_BLIZZARD: u32 = 50;
pub const APPLE_CPU_PART_M2_AVALANCHE: u32 = 51;
pub const APPLE_CPU_PART_M2_BLIZZARD_PRO: u32 = 52;
pub const APPLE_CPU_PART_M2_AVALANCHE_PRO: u32 = 53;
pub const APPLE_CPU_PART_M2_BLIZZARD_MAX: u32 = 56;
pub const APPLE_CPU_PART_M2_AVALANCHE_MAX: u32 = 57;
pub const AMPERE_CPU_PART_AMPERE1: u32 = 2755;
pub const AMPERE_CPU_PART_AMPERE1A: u32 = 2756;
pub const MICROSOFT_CPU_PART_AZURE_COBALT_100: u32 = 3401;
pub const HWCAP_FP: u32 = 1;
pub const HWCAP_ASIMD: u32 = 2;
pub const HWCAP_EVTSTRM: u32 = 4;
pub const HWCAP_AES: u32 = 8;
pub const HWCAP_PMULL: u32 = 16;
pub const HWCAP_SHA1: u32 = 32;
pub const HWCAP_SHA2: u32 = 64;
pub const HWCAP_CRC32: u32 = 128;
pub const HWCAP_ATOMICS: u32 = 256;
pub const HWCAP_FPHP: u32 = 512;
pub const HWCAP_ASIMDHP: u32 = 1024;
pub const HWCAP_CPUID: u32 = 2048;
pub const HWCAP_ASIMDRDM: u32 = 4096;
pub const HWCAP_JSCVT: u32 = 8192;
pub const HWCAP_FCMA: u32 = 16384;
pub const HWCAP_LRCPC: u32 = 32768;
pub const HWCAP_DCPOP: u32 = 65536;
pub const HWCAP_SHA3: u32 = 131072;
pub const HWCAP_SM3: u32 = 262144;
pub const HWCAP_SM4: u32 = 524288;
pub const HWCAP_ASIMDDP: u32 = 1048576;
pub const HWCAP_SHA512: u32 = 2097152;
pub const HWCAP_SVE: u32 = 4194304;
pub const HWCAP_ASIMDFHM: u32 = 8388608;
pub const HWCAP_DIT: u32 = 16777216;
pub const HWCAP_USCAT: u32 = 33554432;
pub const HWCAP_ILRCPC: u32 = 67108864;
pub const HWCAP_FLAGM: u32 = 134217728;
pub const HWCAP_SSBS: u32 = 268435456;
pub const HWCAP_SB: u32 = 536870912;
pub const HWCAP_PACA: u32 = 1073741824;
pub const HWCAP_PACG: u32 = 2147483648;
pub const HWCAP_GCS: u64 = 4294967296;
pub const HWCAP_CMPBR: u64 = 8589934592;
pub const HWCAP_FPRCVT: u64 = 17179869184;
pub const HWCAP_F8MM8: u64 = 34359738368;
pub const HWCAP_F8MM4: u64 = 68719476736;
pub const HWCAP_SVE_F16MM: u64 = 137438953472;
pub const HWCAP_SVE_ELTPERM: u64 = 274877906944;
pub const HWCAP_SVE_AES2: u64 = 549755813888;
pub const HWCAP_SVE_BFSCALE: u64 = 1099511627776;
pub const HWCAP_SVE2P2: u64 = 2199023255552;
pub const HWCAP_SME2P2: u64 = 4398046511104;
pub const HWCAP_SME_SBITPERM: u64 = 8796093022208;
pub const HWCAP_SME_AES: u64 = 17592186044416;
pub const HWCAP_SME_SFEXPA: u64 = 35184372088832;
pub const HWCAP_SME_STMOP: u64 = 70368744177664;
pub const HWCAP_SME_SMOP4: u64 = 140737488355328;
pub const HWCAP2_DCPODP: u32 = 1;
pub const HWCAP2_SVE2: u32 = 2;
pub const HWCAP2_SVEAES: u32 = 4;
pub const HWCAP2_SVEPMULL: u32 = 8;
pub const HWCAP2_SVEBITPERM: u32 = 16;
pub const HWCAP2_SVESHA3: u32 = 32;
pub const HWCAP2_SVESM4: u32 = 64;
pub const HWCAP2_FLAGM2: u32 = 128;
pub const HWCAP2_FRINT: u32 = 256;
pub const HWCAP2_SVEI8MM: u32 = 512;
pub const HWCAP2_SVEF32MM: u32 = 1024;
pub const HWCAP2_SVEF64MM: u32 = 2048;
pub const HWCAP2_SVEBF16: u32 = 4096;
pub const HWCAP2_I8MM: u32 = 8192;
pub const HWCAP2_BF16: u32 = 16384;
pub const HWCAP2_DGH: u32 = 32768;
pub const HWCAP2_RNG: u32 = 65536;
pub const HWCAP2_BTI: u32 = 131072;
pub const HWCAP2_MTE: u32 = 262144;
pub const HWCAP2_ECV: u32 = 524288;
pub const HWCAP2_AFP: u32 = 1048576;
pub const HWCAP2_RPRES: u32 = 2097152;
pub const HWCAP2_MTE3: u32 = 4194304;
pub const HWCAP2_SME: u32 = 8388608;
pub const HWCAP2_SME_I16I64: u32 = 16777216;
pub const HWCAP2_SME_F64F64: u32 = 33554432;
pub const HWCAP2_SME_I8I32: u32 = 67108864;
pub const HWCAP2_SME_F16F32: u32 = 134217728;
pub const HWCAP2_SME_B16F32: u32 = 268435456;
pub const HWCAP2_SME_F32F32: u32 = 536870912;
pub const HWCAP2_SME_FA64: u32 = 1073741824;
pub const HWCAP2_WFXT: u32 = 2147483648;
pub const HWCAP2_EBF16: u64 = 4294967296;
pub const HWCAP2_SVE_EBF16: u64 = 8589934592;
pub const HWCAP2_CSSC: u64 = 17179869184;
pub const HWCAP2_RPRFM: u64 = 34359738368;
pub const HWCAP2_SVE2P1: u64 = 68719476736;
pub const HWCAP2_SME2: u64 = 137438953472;
pub const HWCAP2_SME2P1: u64 = 274877906944;
pub const HWCAP2_SME_I16I32: u64 = 549755813888;
pub const HWCAP2_SME_BI32I32: u64 = 1099511627776;
pub const HWCAP2_SME_B16B16: u64 = 2199023255552;
pub const HWCAP2_SME_F16F16: u64 = 4398046511104;
pub const HWCAP2_MOPS: u64 = 8796093022208;
pub const HWCAP2_HBC: u64 = 17592186044416;
pub const HWCAP2_SVE_B16B16: u64 = 35184372088832;
pub const HWCAP2_LRCPC3: u64 = 70368744177664;
pub const HWCAP2_LSE128: u64 = 140737488355328;
pub const HWCAP2_FPMR: u64 = 281474976710656;
pub const HWCAP2_LUT: u64 = 562949953421312;
pub const HWCAP2_FAMINMAX: u64 = 1125899906842624;
pub const HWCAP2_F8CVT: u64 = 2251799813685248;
pub const HWCAP2_F8FMA: u64 = 4503599627370496;
pub const HWCAP2_F8DP4: u64 = 9007199254740992;
pub const HWCAP2_F8DP2: u64 = 18014398509481984;
pub const HWCAP2_F8E4M3: u64 = 36028797018963968;
pub const HWCAP2_F8E5M2: u64 = 72057594037927936;
pub const HWCAP2_SME_LUTV2: u64 = 144115188075855872;
pub const HWCAP2_SME_F8F16: u64 = 288230376151711744;
pub const HWCAP2_SME_F8F32: u64 = 576460752303423488;
pub const HWCAP2_SME_SF8FMA: u64 = 1152921504606846976;
pub const HWCAP2_SME_SF8DP4: u64 = 2305843009213693952;
pub const HWCAP2_SME_SF8DP2: u64 = 4611686018427387904;
pub const HWCAP2_POE: i64 = -9223372036854775808;
pub const COMPAT_HWCAP_SWP: u32 = 1;
pub const COMPAT_HWCAP_HALF: u32 = 2;
pub const COMPAT_HWCAP_THUMB: u32 = 4;
pub const COMPAT_HWCAP_26BIT: u32 = 8;
pub const COMPAT_HWCAP_FAST_MULT: u32 = 16;
pub const COMPAT_HWCAP_FPA: u32 = 32;
pub const COMPAT_HWCAP_VFP: u32 = 64;
pub const COMPAT_HWCAP_EDSP: u32 = 128;
pub const COMPAT_HWCAP_JAVA: u32 = 256;
pub const COMPAT_HWCAP_IWMMXT: u32 = 512;
pub const COMPAT_HWCAP_CRUNCH: u32 = 1024;
pub const COMPAT_HWCAP_THUMBEE: u32 = 2048;
pub const COMPAT_HWCAP_NEON: u32 = 4096;
pub const COMPAT_HWCAP_VFPv3: u32 = 8192;
pub const COMPAT_HWCAP_VFPV3D16: u32 = 16384;
pub const COMPAT_HWCAP_TLS: u32 = 32768;
pub const COMPAT_HWCAP_VFPv4: u32 = 65536;
pub const COMPAT_HWCAP_IDIVA: u32 = 131072;
pub const COMPAT_HWCAP_IDIVT: u32 = 262144;
pub const COMPAT_HWCAP_IDIV: u32 = 393216;
pub const COMPAT_HWCAP_VFPD32: u32 = 524288;
pub const COMPAT_HWCAP_LPAE: u32 = 1048576;
pub const COMPAT_HWCAP_EVTSTRM: u32 = 2097152;
pub const COMPAT_HWCAP_FPHP: u32 = 4194304;
pub const COMPAT_HWCAP_ASIMDHP: u32 = 8388608;
pub const COMPAT_HWCAP_ASIMDDP: u32 = 16777216;
pub const COMPAT_HWCAP_ASIMDFHM: u32 = 33554432;
pub const COMPAT_HWCAP_ASIMDBF16: u32 = 67108864;
pub const COMPAT_HWCAP_I8MM: u32 = 134217728;
pub const COMPAT_HWCAP2_AES: u32 = 1;
pub const COMPAT_HWCAP2_PMULL: u32 = 2;
pub const COMPAT_HWCAP2_SHA1: u32 = 4;
pub const COMPAT_HWCAP2_SHA2: u32 = 8;
pub const COMPAT_HWCAP2_CRC32: u32 = 16;
pub const COMPAT_HWCAP2_SB: u32 = 32;
pub const COMPAT_HWCAP2_SSBS: u32 = 64;
pub const MAX_CPU_FEATURES: u32 = 192;
pub const ARM64_SW_FEATURE_OVERRIDE_NOKASLR: u32 = 0;
pub const ARM64_SW_FEATURE_OVERRIDE_HVHE: u32 = 4;
pub const ARM64_SW_FEATURE_OVERRIDE_RODATA_OFF: u32 = 8;
pub const STATIC_CALL_SITE_TAIL: u32 = 1;
pub const STATIC_CALL_SITE_INIT: u32 = 2;
pub const STATIC_CALL_SITE_FLAGS: u32 = 3;
pub const STACK_MAGIC: u32 = 3735928559;
pub const READ: u32 = 0;
pub const WRITE: u32 = 1;
pub const FORTIFY_READ: u32 = 0;
pub const FORTIFY_WRITE: u32 = 1;
pub const BITMAP_MEM_ALIGNMENT: u32 = 8;
pub const BITMAP_MEM_MASK: u32 = 7;
pub const NR_CPUS: u32 = 4096;
pub const MIN_THREADS_LEFT_FOR_ROOT: u32 = 4;
pub const PIDS_PER_CPU_DEFAULT: u32 = 1024;
pub const PIDS_PER_CPU_MIN: u32 = 8;
pub const ___GFP_SKIP_ZERO: u32 = 0;
pub const ___GFP_SKIP_KASAN: u32 = 0;
pub const ___GFP_NOLOCKDEP: u32 = 0;
pub const NODES_SHIFT: u32 = 9;
pub const MAX_NUMNODES: u32 = 512;
pub const NUMA_NO_NODE: i32 = -1;
pub const PAGE_POISON: u32 = 170;
pub const SLUB_RED_INACTIVE: u32 = 187;
pub const SLUB_RED_ACTIVE: u32 = 204;
pub const POISON_INUSE: u32 = 90;
pub const POISON_FREE: u32 = 107;
pub const POISON_END: u32 = 165;
pub const POISON_FREE_INITMEM: u32 = 204;
pub const JBD_POISON_FREE: u32 = 91;
pub const JBD2_POISON_FREE: u32 = 92;
pub const POOL_POISON_FREED: u32 = 167;
pub const POOL_POISON_ALLOCATED: u32 = 169;
pub const ATM_POISON_FREE: u32 = 18;
pub const ATM_POISON: u32 = 3735928559;
pub const MUTEX_DEBUG_INIT: u32 = 17;
pub const MUTEX_DEBUG_FREE: u32 = 34;
pub const KEY_DESTROY: u32 = 189;
pub const _IOC_NRBITS: u32 = 8;
pub const _IOC_TYPEBITS: u32 = 8;
pub const _IOC_SIZEBITS: u32 = 14;
pub const _IOC_DIRBITS: u32 = 2;
pub const _IOC_NRMASK: u32 = 255;
pub const _IOC_TYPEMASK: u32 = 255;
pub const _IOC_SIZEMASK: u32 = 16383;
pub const _IOC_DIRMASK: u32 = 3;
pub const _IOC_NRSHIFT: u32 = 0;
pub const _IOC_TYPESHIFT: u32 = 8;
pub const _IOC_SIZESHIFT: u32 = 16;
pub const _IOC_DIRSHIFT: u32 = 30;
pub const _IOC_NONE: u32 = 0;
pub const _IOC_WRITE: u32 = 1;
pub const _IOC_READ: u32 = 2;
pub const IOC_IN: u32 = 1073741824;
pub const IOC_OUT: u32 = 2147483648;
pub const IOC_INOUT: u32 = 3221225472;
pub const IOCSIZE_MASK: u32 = 1073676288;
pub const IOCSIZE_SHIFT: u32 = 16;
pub const GRND_NONBLOCK: u32 = 1;
pub const GRND_RANDOM: u32 = 2;
pub const GRND_INSECURE: u32 = 4;
pub const NUMA_NO_MEMBLK: i32 = -1;
pub const PTDESC_ORDER: u32 = 3;
pub const PTDESC_TABLE_SHIFT: u32 = 9;
pub const PTRS_PER_PTE: u32 = 512;
pub const PTRS_PER_PMD: u32 = 512;
pub const PTRS_PER_PUD: u32 = 512;
pub const CONT_PTE_SHIFT: u32 = 16;
pub const CONT_PTES: u32 = 16;
pub const PTE_PI_IDX_0: u32 = 6;
pub const PTE_PI_IDX_1: u32 = 51;
pub const PTE_PI_IDX_2: u32 = 53;
pub const PTE_PI_IDX_3: u32 = 54;
pub const TCR_T0SZ_OFFSET: u32 = 0;
pub const TCR_T1SZ_OFFSET: u32 = 16;
pub const TCR_TxSZ_WIDTH: u32 = 6;
pub const TCR_EPD0_SHIFT: u32 = 7;
pub const TCR_IRGN0_SHIFT: u32 = 8;
pub const TCR_EPD1_SHIFT: u32 = 23;
pub const TCR_IRGN1_SHIFT: u32 = 24;
pub const TCR_ORGN0_SHIFT: u32 = 10;
pub const TCR_ORGN1_SHIFT: u32 = 26;
pub const TCR_SH0_SHIFT: u32 = 12;
pub const TCR_SH1_SHIFT: u32 = 28;
pub const TCR_TG0_SHIFT: u32 = 14;
pub const TCR_TG1_SHIFT: u32 = 30;
pub const TCR_IPS_SHIFT: u32 = 32;
pub const TCR_HPD0_SHIFT: u32 = 41;
pub const TCR_HPD1_SHIFT: u32 = 42;
pub const __PAGETABLE_P4D_FOLDED: u32 = 1;
pub const PTRS_PER_P4D: u32 = 1;
pub const ARM_SMCCC_TYPE_SHIFT: u32 = 31;
pub const ARM_SMCCC_SMC_32: u32 = 0;
pub const ARM_SMCCC_SMC_64: u32 = 1;
pub const ARM_SMCCC_CALL_CONV_SHIFT: u32 = 30;
pub const ARM_SMCCC_OWNER_MASK: u32 = 63;
pub const ARM_SMCCC_OWNER_SHIFT: u32 = 24;
pub const ARM_SMCCC_FUNC_MASK: u32 = 65535;
pub const ARM_SMCCC_OWNER_ARCH: u32 = 0;
pub const ARM_SMCCC_OWNER_CPU: u32 = 1;
pub const ARM_SMCCC_OWNER_SIP: u32 = 2;
pub const ARM_SMCCC_OWNER_OEM: u32 = 3;
pub const ARM_SMCCC_OWNER_STANDARD: u32 = 4;
pub const ARM_SMCCC_OWNER_STANDARD_HYP: u32 = 5;
pub const ARM_SMCCC_OWNER_VENDOR_HYP: u32 = 6;
pub const ARM_SMCCC_OWNER_TRUSTED_APP: u32 = 48;
pub const ARM_SMCCC_OWNER_TRUSTED_APP_END: u32 = 49;
pub const ARM_SMCCC_OWNER_TRUSTED_OS: u32 = 50;
pub const ARM_SMCCC_OWNER_TRUSTED_OS_END: u32 = 63;
pub const ARM_SMCCC_FUNC_QUERY_CALL_UID: u32 = 65281;
pub const ARM_SMCCC_QUIRK_NONE: u32 = 0;
pub const ARM_SMCCC_QUIRK_QCOM_A6: u32 = 1;
pub const ARM_SMCCC_VERSION_1_0: u32 = 65536;
pub const ARM_SMCCC_VERSION_1_1: u32 = 65537;
pub const ARM_SMCCC_VERSION_1_2: u32 = 65538;
pub const ARM_SMCCC_VERSION_1_3: u32 = 65539;
pub const ARM_SMCCC_1_3_SVE_HINT: u32 = 65536;
pub const ARM_SMCCC_CALL_HINTS: u32 = 65536;
pub const ARM_SMCCC_VENDOR_HYP_UID_KVM_REG_0: u32 = 3060773928;
pub const ARM_SMCCC_VENDOR_HYP_UID_KVM_REG_1: u32 = 3910255918;
pub const ARM_SMCCC_VENDOR_HYP_UID_KVM_REG_2: u32 = 1447807657;
pub const ARM_SMCCC_VENDOR_HYP_UID_KVM_REG_3: u32 = 1949958221;
pub const ARM_SMCCC_KVM_FUNC_FEATURES: u32 = 0;
pub const ARM_SMCCC_KVM_FUNC_PTP: u32 = 1;
pub const ARM_SMCCC_KVM_FUNC_HYP_MEMINFO: u32 = 2;
pub const ARM_SMCCC_KVM_FUNC_MEM_SHARE: u32 = 3;
pub const ARM_SMCCC_KVM_FUNC_MEM_UNSHARE: u32 = 4;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_5: u32 = 5;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_6: u32 = 6;
pub const ARM_SMCCC_KVM_FUNC_MMIO_GUARD: u32 = 7;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_8: u32 = 8;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_9: u32 = 9;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_10: u32 = 10;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_11: u32 = 11;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_12: u32 = 12;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_13: u32 = 13;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_14: u32 = 14;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_15: u32 = 15;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_16: u32 = 16;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_17: u32 = 17;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_18: u32 = 18;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_19: u32 = 19;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_20: u32 = 20;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_21: u32 = 21;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_22: u32 = 22;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_23: u32 = 23;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_24: u32 = 24;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_25: u32 = 25;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_26: u32 = 26;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_27: u32 = 27;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_28: u32 = 28;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_29: u32 = 29;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_30: u32 = 30;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_31: u32 = 31;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_32: u32 = 32;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_33: u32 = 33;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_34: u32 = 34;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_35: u32 = 35;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_36: u32 = 36;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_37: u32 = 37;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_38: u32 = 38;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_39: u32 = 39;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_40: u32 = 40;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_41: u32 = 41;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_42: u32 = 42;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_43: u32 = 43;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_44: u32 = 44;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_45: u32 = 45;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_46: u32 = 46;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_47: u32 = 47;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_48: u32 = 48;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_49: u32 = 49;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_50: u32 = 50;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_51: u32 = 51;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_52: u32 = 52;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_53: u32 = 53;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_54: u32 = 54;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_55: u32 = 55;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_56: u32 = 56;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_57: u32 = 57;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_58: u32 = 58;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_59: u32 = 59;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_60: u32 = 60;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_61: u32 = 61;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_62: u32 = 62;
pub const ARM_SMCCC_KVM_FUNC_PKVM_RESV_63: u32 = 63;
pub const ARM_SMCCC_KVM_FUNC_DISCOVER_IMPL_VER: u32 = 64;
pub const ARM_SMCCC_KVM_FUNC_DISCOVER_IMPL_CPUS: u32 = 65;
pub const ARM_SMCCC_KVM_FUNC_FEATURES_2: u32 = 127;
pub const ARM_SMCCC_KVM_NUM_FUNCS: u32 = 128;
pub const SMCCC_ARCH_WORKAROUND_RET_UNAFFECTED: u32 = 1;
pub const KVM_PTP_VIRT_COUNTER: u32 = 0;
pub const KVM_PTP_PHYS_COUNTER: u32 = 1;
pub const SMCCC_RET_SUCCESS: u32 = 0;
pub const SMCCC_RET_NOT_SUPPORTED: i32 = -1;
pub const SMCCC_RET_NOT_REQUIRED: i32 = -2;
pub const SMCCC_RET_INVALID_PARAMETER: i32 = -3;
pub const SMCCC_SMC_INST: &[u8; 7] = b"smc\t#0\0";
pub const SMCCC_HVC_INST: &[u8; 7] = b"hvc\t#0\0";
pub const RSI_GRANULE_SHIFT: u32 = 12;
pub const RSI_PDEV_NAME: &[u8; 12] = b"arm-cca-dev\0";
pub const PHYS_MASK_SHIFT: u32 = 48;
pub const MAX_PHYSMEM_BITS: u32 = 48;
pub const MAX_POSSIBLE_PHYSMEM_BITS: u32 = 52;
pub const SECTION_SIZE_BITS: u32 = 27;
pub const __SVE_VQ_BYTES: u32 = 16;
pub const __SVE_VQ_MIN: u32 = 1;
pub const __SVE_VQ_MAX: u32 = 512;
pub const __SVE_VL_MIN: u32 = 16;
pub const __SVE_VL_MAX: u32 = 8192;
pub const __SVE_NUM_ZREGS: u32 = 32;
pub const __SVE_NUM_PREGS: u32 = 16;
pub const __SVE_ZREGS_OFFSET: u32 = 0;
pub const PSR_MODE_EL0t: u32 = 0;
pub const PSR_MODE_EL1t: u32 = 4;
pub const PSR_MODE_EL1h: u32 = 5;
pub const PSR_MODE_EL2t: u32 = 8;
pub const PSR_MODE_EL2h: u32 = 9;
pub const PSR_MODE_EL3t: u32 = 12;
pub const PSR_MODE_EL3h: u32 = 13;
pub const PSR_MODE_MASK: u32 = 15;
pub const PSR_MODE32_BIT: u32 = 16;
pub const PSR_F_BIT: u32 = 64;
pub const PSR_I_BIT: u32 = 128;
pub const PSR_A_BIT: u32 = 256;
pub const PSR_D_BIT: u32 = 512;
pub const PSR_BTYPE_MASK: u32 = 3072;
pub const PSR_SSBS_BIT: u32 = 4096;
pub const PSR_PAN_BIT: u32 = 4194304;
pub const PSR_UAO_BIT: u32 = 8388608;
pub const PSR_DIT_BIT: u32 = 16777216;
pub const PSR_TCO_BIT: u32 = 33554432;
pub const PSR_V_BIT: u32 = 268435456;
pub const PSR_C_BIT: u32 = 536870912;
pub const PSR_Z_BIT: u32 = 1073741824;
pub const PSR_N_BIT: u32 = 2147483648;
pub const PSR_BTYPE_SHIFT: u32 = 10;
pub const PSR_f: u32 = 4278190080;
pub const PSR_s: u32 = 16711680;
pub const PSR_x: u32 = 65280;
pub const PSR_c: u32 = 255;
pub const PSR_BTYPE_NONE: u32 = 0;
pub const PSR_BTYPE_JC: u32 = 1024;
pub const PSR_BTYPE_C: u32 = 2048;
pub const PSR_BTYPE_J: u32 = 3072;
pub const PTRACE_SYSEMU: u32 = 31;
pub const PTRACE_SYSEMU_SINGLESTEP: u32 = 32;
pub const PTRACE_PEEKMTETAGS: u32 = 33;
pub const PTRACE_POKEMTETAGS: u32 = 34;
pub const SVE_PT_REGS_MASK: u32 = 1;
pub const SVE_PT_REGS_FPSIMD: u32 = 0;
pub const SVE_PT_REGS_SVE: u32 = 1;
pub const SVE_PT_VL_INHERIT: u32 = 2;
pub const SVE_PT_VL_ONEXEC: u32 = 4;
pub const ZA_PT_VL_INHERIT: u32 = 2;
pub const ZA_PT_VL_ONEXEC: u32 = 4;
pub const CurrentEL_EL1: u32 = 4;
pub const CurrentEL_EL2: u32 = 8;
pub const INIT_PSTATE_EL1: u32 = 965;
pub const INIT_PSTATE_EL2: u32 = 969;
pub const GICV3_PRIO_UNMASKED: u32 = 224;
pub const GICV3_PRIO_IRQ: u32 = 192;
pub const GICV3_PRIO_NMI: u32 = 128;
pub const GICV3_PRIO_PSR_I_SET: u32 = 16;
pub const GIC_PRIO_IRQON: u32 = 224;
pub const GIC_PRIO_IRQOFF: u32 = 192;
pub const GIC_PRIO_PSR_I_SET: u32 = 16;
pub const PSR_MODE_THREAD_BIT: u32 = 1;
pub const PSR_IL_BIT: u32 = 1048576;
pub const COMPAT_PTRACE_GETREGS: u32 = 12;
pub const COMPAT_PTRACE_SETREGS: u32 = 13;
pub const COMPAT_PTRACE_GET_THREAD_AREA: u32 = 22;
pub const COMPAT_PTRACE_SET_SYSCALL: u32 = 23;
pub const COMPAT_PTRACE_GETVFPREGS: u32 = 27;
pub const COMPAT_PTRACE_SETVFPREGS: u32 = 28;
pub const COMPAT_PTRACE_GETHBPREGS: u32 = 29;
pub const COMPAT_PTRACE_SETHBPREGS: u32 = 30;
pub const PSR_AA32_MODE_MASK: u32 = 31;
pub const PSR_AA32_MODE_USR: u32 = 16;
pub const PSR_AA32_MODE_FIQ: u32 = 17;
pub const PSR_AA32_MODE_IRQ: u32 = 18;
pub const PSR_AA32_MODE_SVC: u32 = 19;
pub const PSR_AA32_MODE_ABT: u32 = 23;
pub const PSR_AA32_MODE_HYP: u32 = 26;
pub const PSR_AA32_MODE_UND: u32 = 27;
pub const PSR_AA32_MODE_SYS: u32 = 31;
pub const PSR_AA32_T_BIT: u32 = 32;
pub const PSR_AA32_F_BIT: u32 = 64;
pub const PSR_AA32_I_BIT: u32 = 128;
pub const PSR_AA32_A_BIT: u32 = 256;
pub const PSR_AA32_E_BIT: u32 = 512;
pub const PSR_AA32_PAN_BIT: u32 = 4194304;
pub const PSR_AA32_SSBS_BIT: u32 = 8388608;
pub const PSR_AA32_DIT_BIT: u32 = 16777216;
pub const PSR_AA32_Q_BIT: u32 = 134217728;
pub const PSR_AA32_V_BIT: u32 = 268435456;
pub const PSR_AA32_C_BIT: u32 = 536870912;
pub const PSR_AA32_Z_BIT: u32 = 1073741824;
pub const PSR_AA32_N_BIT: u32 = 2147483648;
pub const PSR_AA32_IT_MASK: u32 = 100727808;
pub const PSR_AA32_GE_MASK: u32 = 983040;
pub const PSR_AA32_ENDSTATE: u32 = 0;
pub const COMPAT_PSR_DIT_BIT: u32 = 2097152;
pub const COMPAT_PT_TEXT_ADDR: u32 = 65536;
pub const COMPAT_PT_DATA_ADDR: u32 = 65540;
pub const COMPAT_PT_TEXT_END_ADDR: u32 = 65544;
pub const NO_SYSCALL: i32 = -1;
pub const FRAME_META_TYPE_NONE: u32 = 0;
pub const FRAME_META_TYPE_FINAL: u32 = 1;
pub const FRAME_META_TYPE_PT_REGS: u32 = 2;
pub const COMPAT_USER_SZ: u32 = 296;
pub const NR_REG_ARGUMENTS: u32 = 8;
pub const PER_CPU_SHARED_ALIGNED_SECTION: &[u8; 1] = b"\0";
pub const PER_CPU_ALIGNED_SECTION: &[u8; 1] = b"\0";
pub const PER_CPU_BASE_SECTION: &[u8; 14] = b".data..percpu\0";
pub const CPU_STUCK_REASON_SHIFT: u32 = 8;
pub const CPU_MMU_OFF: i32 = -1;
pub const CPU_BOOT_SUCCESS: u32 = 0;
pub const CPU_KILL_ME: u32 = 1;
pub const CPU_STUCK_IN_KERNEL: u32 = 2;
pub const CPU_PANIC_KERNEL: u32 = 3;
pub const force_read_lock_recursive: u32 = 0;
pub const SINGLE_DEPTH_NESTING: u32 = 1;
pub const LOCK_SECTION_END: &[u8; 12] = b".previous\n\t\0";
pub const RWLOCK_MAGIC: u32 = 3736018669;
pub const NET_IP_ALIGN: u32 = 0;
pub const MTE_CTRL_GCR_USER_EXCL_SHIFT: u32 = 0;
pub const MTE_CTRL_GCR_USER_EXCL_MASK: u32 = 65535;
pub const MTE_CTRL_TCF_SYNC: u32 = 65536;
pub const MTE_CTRL_TCF_ASYNC: u32 = 131072;
pub const MTE_CTRL_TCF_ASYMM: u32 = 262144;
pub const L1_CACHE_SHIFT: u32 = 6;
pub const L1_CACHE_BYTES: u32 = 64;
pub const CLIDR_LOUU_SHIFT: u32 = 27;
pub const CLIDR_LOC_SHIFT: u32 = 24;
pub const CLIDR_LOUIS_SHIFT: u32 = 21;
pub const ARCH_DMA_MINALIGN: u32 = 128;
pub const ARCH_KMALLOC_MINALIGN: u32 = 8;
pub const MTE_TAG_SHIFT: u32 = 56;
pub const MTE_TAG_SIZE: u32 = 4;
pub const ICACHEF_ALIASING: u32 = 0;
pub const SMP_CACHE_BYTES: u32 = 64;
pub const INTERNODE_CACHE_SHIFT: u32 = 6;
pub const HVC_SET_VECTORS: u32 = 0;
pub const HVC_SOFT_RESTART: u32 = 1;
pub const HVC_RESET_VECTORS: u32 = 2;
pub const HVC_FINALISE_EL2: u32 = 3;
pub const HVC_STUB_HCALL_NR: u32 = 4;
pub const HVC_STUB_ERR: u32 = 195938833;
pub const BOOT_CPU_MODE_EL1: u32 = 3601;
pub const BOOT_CPU_MODE_EL2: u32 = 3602;
pub const ARM64_VECTOR_TABLE_LEN: u32 = 2048;
pub const AARCH64_BREAKPOINT_EL1: u32 = 1;
pub const AARCH64_BREAKPOINT_EL0: u32 = 2;
pub const DBG_HMC_HYP: u32 = 8192;
pub const ARM_BREAKPOINT_EXECUTE: u32 = 0;
pub const ARM_BREAKPOINT_LOAD: u32 = 1;
pub const ARM_BREAKPOINT_STORE: u32 = 2;
pub const ARM_BREAKPOINT_LEN_1: u32 = 1;
pub const ARM_BREAKPOINT_LEN_2: u32 = 3;
pub const ARM_BREAKPOINT_LEN_3: u32 = 7;
pub const ARM_BREAKPOINT_LEN_4: u32 = 15;
pub const ARM_BREAKPOINT_LEN_5: u32 = 31;
pub const ARM_BREAKPOINT_LEN_6: u32 = 63;
pub const ARM_BREAKPOINT_LEN_7: u32 = 127;
pub const ARM_BREAKPOINT_LEN_8: u32 = 255;
pub const ARM_KERNEL_STEP_NONE: u32 = 0;
pub const ARM_KERNEL_STEP_ACTIVE: u32 = 1;
pub const ARM_KERNEL_STEP_SUSPEND: u32 = 2;
pub const ARM_MAX_BRP: u32 = 16;
pub const ARM_MAX_WRP: u32 = 16;
pub const AARCH64_DBG_REG_BVR: u32 = 0;
pub const AARCH64_DBG_REG_BCR: u32 = 16;
pub const AARCH64_DBG_REG_WVR: u32 = 32;
pub const AARCH64_DBG_REG_WCR: u32 = 48;
pub const PR_SET_PDEATHSIG: u32 = 1;
pub const PR_GET_PDEATHSIG: u32 = 2;
pub const PR_GET_DUMPABLE: u32 = 3;
pub const PR_SET_DUMPABLE: u32 = 4;
pub const PR_GET_UNALIGN: u32 = 5;
pub const PR_SET_UNALIGN: u32 = 6;
pub const PR_UNALIGN_NOPRINT: u32 = 1;
pub const PR_UNALIGN_SIGBUS: u32 = 2;
pub const PR_GET_KEEPCAPS: u32 = 7;
pub const PR_SET_KEEPCAPS: u32 = 8;
pub const PR_GET_FPEMU: u32 = 9;
pub const PR_SET_FPEMU: u32 = 10;
pub const PR_FPEMU_NOPRINT: u32 = 1;
pub const PR_FPEMU_SIGFPE: u32 = 2;
pub const PR_GET_FPEXC: u32 = 11;
pub const PR_SET_FPEXC: u32 = 12;
pub const PR_FP_EXC_SW_ENABLE: u32 = 128;
pub const PR_FP_EXC_DIV: u32 = 65536;
pub const PR_FP_EXC_OVF: u32 = 131072;
pub const PR_FP_EXC_UND: u32 = 262144;
pub const PR_FP_EXC_RES: u32 = 524288;
pub const PR_FP_EXC_INV: u32 = 1048576;
pub const PR_FP_EXC_DISABLED: u32 = 0;
pub const PR_FP_EXC_NONRECOV: u32 = 1;
pub const PR_FP_EXC_ASYNC: u32 = 2;
pub const PR_FP_EXC_PRECISE: u32 = 3;
pub const PR_GET_TIMING: u32 = 13;
pub const PR_SET_TIMING: u32 = 14;
pub const PR_TIMING_STATISTICAL: u32 = 0;
pub const PR_TIMING_TIMESTAMP: u32 = 1;
pub const PR_SET_NAME: u32 = 15;
pub const PR_GET_NAME: u32 = 16;
pub const PR_GET_ENDIAN: u32 = 19;
pub const PR_SET_ENDIAN: u32 = 20;
pub const PR_ENDIAN_BIG: u32 = 0;
pub const PR_ENDIAN_LITTLE: u32 = 1;
pub const PR_ENDIAN_PPC_LITTLE: u32 = 2;
pub const PR_GET_SECCOMP: u32 = 21;
pub const PR_SET_SECCOMP: u32 = 22;
pub const PR_CAPBSET_READ: u32 = 23;
pub const PR_CAPBSET_DROP: u32 = 24;
pub const PR_GET_TSC: u32 = 25;
pub const PR_SET_TSC: u32 = 26;
pub const PR_TSC_ENABLE: u32 = 1;
pub const PR_TSC_SIGSEGV: u32 = 2;
pub const PR_GET_SECUREBITS: u32 = 27;
pub const PR_SET_SECUREBITS: u32 = 28;
pub const PR_SET_TIMERSLACK: u32 = 29;
pub const PR_GET_TIMERSLACK: u32 = 30;
pub const PR_TASK_PERF_EVENTS_DISABLE: u32 = 31;
pub const PR_TASK_PERF_EVENTS_ENABLE: u32 = 32;
pub const PR_MCE_KILL: u32 = 33;
pub const PR_MCE_KILL_CLEAR: u32 = 0;
pub const PR_MCE_KILL_SET: u32 = 1;
pub const PR_MCE_KILL_LATE: u32 = 0;
pub const PR_MCE_KILL_EARLY: u32 = 1;
pub const PR_MCE_KILL_DEFAULT: u32 = 2;
pub const PR_MCE_KILL_GET: u32 = 34;
pub const PR_SET_MM: u32 = 35;
pub const PR_SET_MM_START_CODE: u32 = 1;
pub const PR_SET_MM_END_CODE: u32 = 2;
pub const PR_SET_MM_START_DATA: u32 = 3;
pub const PR_SET_MM_END_DATA: u32 = 4;
pub const PR_SET_MM_START_STACK: u32 = 5;
pub const PR_SET_MM_START_BRK: u32 = 6;
pub const PR_SET_MM_BRK: u32 = 7;
pub const PR_SET_MM_ARG_START: u32 = 8;
pub const PR_SET_MM_ARG_END: u32 = 9;
pub const PR_SET_MM_ENV_START: u32 = 10;
pub const PR_SET_MM_ENV_END: u32 = 11;
pub const PR_SET_MM_AUXV: u32 = 12;
pub const PR_SET_MM_EXE_FILE: u32 = 13;
pub const PR_SET_MM_MAP: u32 = 14;
pub const PR_SET_MM_MAP_SIZE: u32 = 15;
pub const PR_SET_PTRACER: u32 = 1499557217;
pub const PR_SET_CHILD_SUBREAPER: u32 = 36;
pub const PR_GET_CHILD_SUBREAPER: u32 = 37;
pub const PR_SET_NO_NEW_PRIVS: u32 = 38;
pub const PR_GET_NO_NEW_PRIVS: u32 = 39;
pub const PR_GET_TID_ADDRESS: u32 = 40;
pub const PR_SET_THP_DISABLE: u32 = 41;
pub const PR_GET_THP_DISABLE: u32 = 42;
pub const PR_MPX_ENABLE_MANAGEMENT: u32 = 43;
pub const PR_MPX_DISABLE_MANAGEMENT: u32 = 44;
pub const PR_SET_FP_MODE: u32 = 45;
pub const PR_GET_FP_MODE: u32 = 46;
pub const PR_FP_MODE_FR: u32 = 1;
pub const PR_FP_MODE_FRE: u32 = 2;
pub const PR_CAP_AMBIENT: u32 = 47;
pub const PR_CAP_AMBIENT_IS_SET: u32 = 1;
pub const PR_CAP_AMBIENT_RAISE: u32 = 2;
pub const PR_CAP_AMBIENT_LOWER: u32 = 3;
pub const PR_CAP_AMBIENT_CLEAR_ALL: u32 = 4;
pub const PR_SVE_SET_VL: u32 = 50;
pub const PR_SVE_SET_VL_ONEXEC: u32 = 262144;
pub const PR_SVE_GET_VL: u32 = 51;
pub const PR_SVE_VL_LEN_MASK: u32 = 65535;
pub const PR_SVE_VL_INHERIT: u32 = 131072;
pub const PR_GET_SPECULATION_CTRL: u32 = 52;
pub const PR_SET_SPECULATION_CTRL: u32 = 53;
pub const PR_SPEC_STORE_BYPASS: u32 = 0;
pub const PR_SPEC_INDIRECT_BRANCH: u32 = 1;
pub const PR_SPEC_L1D_FLUSH: u32 = 2;
pub const PR_SPEC_NOT_AFFECTED: u32 = 0;
pub const PR_SPEC_PRCTL: u32 = 1;
pub const PR_SPEC_ENABLE: u32 = 2;
pub const PR_SPEC_DISABLE: u32 = 4;
pub const PR_SPEC_FORCE_DISABLE: u32 = 8;
pub const PR_SPEC_DISABLE_NOEXEC: u32 = 16;
pub const PR_PAC_RESET_KEYS: u32 = 54;
pub const PR_PAC_APIAKEY: u32 = 1;
pub const PR_PAC_APIBKEY: u32 = 2;
pub const PR_PAC_APDAKEY: u32 = 4;
pub const PR_PAC_APDBKEY: u32 = 8;
pub const PR_PAC_APGAKEY: u32 = 16;
pub const PR_SET_TAGGED_ADDR_CTRL: u32 = 55;
pub const PR_GET_TAGGED_ADDR_CTRL: u32 = 56;
pub const PR_TAGGED_ADDR_ENABLE: u32 = 1;
pub const PR_MTE_TCF_NONE: u32 = 0;
pub const PR_MTE_TCF_SYNC: u32 = 2;
pub const PR_MTE_TCF_ASYNC: u32 = 4;
pub const PR_MTE_TCF_MASK: u32 = 6;
pub const PR_MTE_TAG_SHIFT: u32 = 3;
pub const PR_MTE_TAG_MASK: u32 = 524280;
pub const PR_MTE_TCF_SHIFT: u32 = 1;
pub const PR_PMLEN_SHIFT: u32 = 24;
pub const PR_PMLEN_MASK: u32 = 2130706432;
pub const PR_SET_IO_FLUSHER: u32 = 57;
pub const PR_GET_IO_FLUSHER: u32 = 58;
pub const PR_SET_SYSCALL_USER_DISPATCH: u32 = 59;
pub const PR_SYS_DISPATCH_OFF: u32 = 0;
pub const PR_SYS_DISPATCH_ON: u32 = 1;
pub const SYSCALL_DISPATCH_FILTER_ALLOW: u32 = 0;
pub const SYSCALL_DISPATCH_FILTER_BLOCK: u32 = 1;
pub const PR_PAC_SET_ENABLED_KEYS: u32 = 60;
pub const PR_PAC_GET_ENABLED_KEYS: u32 = 61;
pub const PR_SCHED_CORE: u32 = 62;
pub const PR_SCHED_CORE_GET: u32 = 0;
pub const PR_SCHED_CORE_CREATE: u32 = 1;
pub const PR_SCHED_CORE_SHARE_TO: u32 = 2;
pub const PR_SCHED_CORE_SHARE_FROM: u32 = 3;
pub const PR_SCHED_CORE_MAX: u32 = 4;
pub const PR_SCHED_CORE_SCOPE_THREAD: u32 = 0;
pub const PR_SCHED_CORE_SCOPE_THREAD_GROUP: u32 = 1;
pub const PR_SCHED_CORE_SCOPE_PROCESS_GROUP: u32 = 2;
pub const PR_SME_SET_VL: u32 = 63;
pub const PR_SME_SET_VL_ONEXEC: u32 = 262144;
pub const PR_SME_GET_VL: u32 = 64;
pub const PR_SME_VL_LEN_MASK: u32 = 65535;
pub const PR_SME_VL_INHERIT: u32 = 131072;
pub const PR_SET_MDWE: u32 = 65;
pub const PR_MDWE_REFUSE_EXEC_GAIN: u32 = 1;
pub const PR_MDWE_NO_INHERIT: u32 = 2;
pub const PR_GET_MDWE: u32 = 66;
pub const PR_SET_VMA: u32 = 1398164801;
pub const PR_SET_VMA_ANON_NAME: u32 = 0;
pub const PR_GET_AUXV: u32 = 1096112214;
pub const PR_SET_MEMORY_MERGE: u32 = 67;
pub const PR_GET_MEMORY_MERGE: u32 = 68;
pub const PR_RISCV_V_SET_CONTROL: u32 = 69;
pub const PR_RISCV_V_GET_CONTROL: u32 = 70;
pub const PR_RISCV_V_VSTATE_CTRL_DEFAULT: u32 = 0;
pub const PR_RISCV_V_VSTATE_CTRL_OFF: u32 = 1;
pub const PR_RISCV_V_VSTATE_CTRL_ON: u32 = 2;
pub const PR_RISCV_V_VSTATE_CTRL_INHERIT: u32 = 16;
pub const PR_RISCV_V_VSTATE_CTRL_CUR_MASK: u32 = 3;
pub const PR_RISCV_V_VSTATE_CTRL_NEXT_MASK: u32 = 12;
pub const PR_RISCV_V_VSTATE_CTRL_MASK: u32 = 31;
pub const PR_RISCV_SET_ICACHE_FLUSH_CTX: u32 = 71;
pub const PR_RISCV_CTX_SW_FENCEI_ON: u32 = 0;
pub const PR_RISCV_CTX_SW_FENCEI_OFF: u32 = 1;
pub const PR_RISCV_SCOPE_PER_PROCESS: u32 = 0;
pub const PR_RISCV_SCOPE_PER_THREAD: u32 = 1;
pub const PR_PPC_GET_DEXCR: u32 = 72;
pub const PR_PPC_SET_DEXCR: u32 = 73;
pub const PR_PPC_DEXCR_SBHE: u32 = 0;
pub const PR_PPC_DEXCR_IBRTPD: u32 = 1;
pub const PR_PPC_DEXCR_SRAPD: u32 = 2;
pub const PR_PPC_DEXCR_NPHIE: u32 = 3;
pub const PR_PPC_DEXCR_CTRL_EDITABLE: u32 = 1;
pub const PR_PPC_DEXCR_CTRL_SET: u32 = 2;
pub const PR_PPC_DEXCR_CTRL_CLEAR: u32 = 4;
pub const PR_PPC_DEXCR_CTRL_SET_ONEXEC: u32 = 8;
pub const PR_PPC_DEXCR_CTRL_CLEAR_ONEXEC: u32 = 16;
pub const PR_PPC_DEXCR_CTRL_MASK: u32 = 31;
pub const PR_GET_SHADOW_STACK_STATUS: u32 = 74;
pub const PR_SET_SHADOW_STACK_STATUS: u32 = 75;
pub const PR_SHADOW_STACK_ENABLE: u32 = 1;
pub const PR_SHADOW_STACK_WRITE: u32 = 2;
pub const PR_SHADOW_STACK_PUSH: u32 = 4;
pub const PR_LOCK_SHADOW_STACK_STATUS: u32 = 76;
pub const PR_TIMER_CREATE_RESTORE_IDS: u32 = 77;
pub const PR_TIMER_CREATE_RESTORE_IDS_OFF: u32 = 0;
pub const PR_TIMER_CREATE_RESTORE_IDS_ON: u32 = 1;
pub const PR_TIMER_CREATE_RESTORE_IDS_GET: u32 = 2;
pub const PR_PAC_ENABLED_KEYS_MASK: u32 = 15;
pub const BP_HARDEN_EL2_SLOTS: u32 = 4;
pub const __BP_HARDEN_HYP_VECS_SZ: u32 = 6144;
pub const AARCH32_VECTORS_BASE: u32 = 4294901760;
pub const FPSIMD_MAGIC: u32 = 1179680769;
pub const ESR_MAGIC: u32 = 1163088385;
pub const POE_MAGIC: u32 = 1347372336;
pub const EXTRA_MAGIC: u32 = 1163416577;
pub const SVE_MAGIC: u32 = 1398162689;
pub const SVE_SIG_FLAG_SM: u32 = 1;
pub const TPIDR2_MAGIC: u32 = 1414547714;
pub const FPMR_MAGIC: u32 = 1179667794;
pub const ZA_MAGIC: u32 = 1412850501;
pub const ZT_MAGIC: u32 = 1515474433;
pub const GCS_MAGIC: u32 = 1195594496;
pub const SVE_VQ_BYTES: u32 = 16;
pub const SVE_VQ_MIN: u32 = 1;
pub const SVE_VQ_MAX: u32 = 512;
pub const SVE_VL_MIN: u32 = 16;
pub const SVE_VL_MAX: u32 = 8192;
pub const SVE_NUM_ZREGS: u32 = 32;
pub const SVE_NUM_PREGS: u32 = 16;
pub const ZT_SIG_REG_SIZE: u32 = 512;
pub const ZT_SIG_REG_BYTES: u32 = 64;
pub const VFP_FPSCR_STAT_MASK: u32 = 4160749727;
pub const VFP_FPSCR_CTRL_MASK: u32 = 133668608;
pub const VFP_STATE_SIZE: u32 = 260;
pub const VL_ARCH_MAX: u32 = 256;
pub const _QW_WAITING: u32 = 256;
pub const _QW_LOCKED: u32 = 255;
pub const _QW_WMASK: u32 = 511;
pub const _QR_SHIFT: u32 = 9;
pub const _QR_BIAS: u32 = 512;
pub const STAT_HAVE_NSEC: u32 = 1;
pub const MSEC_PER_SEC: u32 = 1000;
pub const USEC_PER_MSEC: u32 = 1000;
pub const NSEC_PER_USEC: u32 = 1000;
pub const NSEC_PER_MSEC: u32 = 1000000;
pub const USEC_PER_SEC: u32 = 1000000;
pub const NSEC_PER_SEC: u32 = 1000000000;
pub const PSEC_PER_SEC: u64 = 1000000000000;
pub const FSEC_PER_SEC: u64 = 1000000000000000;
pub const ITIMER_REAL: u32 = 0;
pub const ITIMER_VIRTUAL: u32 = 1;
pub const ITIMER_PROF: u32 = 2;
pub const CLOCK_REALTIME: u32 = 0;
pub const CLOCK_MONOTONIC: u32 = 1;
pub const CLOCK_PROCESS_CPUTIME_ID: u32 = 2;
pub const CLOCK_THREAD_CPUTIME_ID: u32 = 3;
pub const CLOCK_MONOTONIC_RAW: u32 = 4;
pub const CLOCK_REALTIME_COARSE: u32 = 5;
pub const CLOCK_MONOTONIC_COARSE: u32 = 6;
pub const CLOCK_BOOTTIME: u32 = 7;
pub const CLOCK_REALTIME_ALARM: u32 = 8;
pub const CLOCK_BOOTTIME_ALARM: u32 = 9;
pub const CLOCK_SGI_CYCLE: u32 = 10;
pub const CLOCK_TAI: u32 = 11;
pub const MAX_CLOCKS: u32 = 16;
pub const CLOCKS_MASK: u32 = 1;
pub const CLOCKS_MONO: u32 = 1;
pub const TIMER_ABSTIME: u32 = 1;
pub const PSEC_PER_NSEC: u32 = 1000;
pub const TIME_UPTIME_SEC_MAX: u32 = 946080000;
pub const NTP_API: u32 = 4;
pub const ADJ_OFFSET: u32 = 1;
pub const ADJ_FREQUENCY: u32 = 2;
pub const ADJ_MAXERROR: u32 = 4;
pub const ADJ_ESTERROR: u32 = 8;
pub const ADJ_STATUS: u32 = 16;
pub const ADJ_TIMECONST: u32 = 32;
pub const ADJ_TAI: u32 = 128;
pub const ADJ_SETOFFSET: u32 = 256;
pub const ADJ_MICRO: u32 = 4096;
pub const ADJ_NANO: u32 = 8192;
pub const ADJ_TICK: u32 = 16384;
pub const MOD_OFFSET: u32 = 1;
pub const MOD_FREQUENCY: u32 = 2;
pub const MOD_MAXERROR: u32 = 4;
pub const MOD_ESTERROR: u32 = 8;
pub const MOD_STATUS: u32 = 16;
pub const MOD_TIMECONST: u32 = 32;
pub const MOD_TAI: u32 = 128;
pub const MOD_MICRO: u32 = 4096;
pub const MOD_NANO: u32 = 8192;
pub const STA_PLL: u32 = 1;
pub const STA_PPSFREQ: u32 = 2;
pub const STA_PPSTIME: u32 = 4;
pub const STA_FLL: u32 = 8;
pub const STA_INS: u32 = 16;
pub const STA_DEL: u32 = 32;
pub const STA_UNSYNC: u32 = 64;
pub const STA_FREQHOLD: u32 = 128;
pub const STA_PPSSIGNAL: u32 = 256;
pub const STA_PPSJITTER: u32 = 512;
pub const STA_PPSWANDER: u32 = 1024;
pub const STA_PPSERROR: u32 = 2048;
pub const STA_CLOCKERR: u32 = 4096;
pub const STA_NANO: u32 = 8192;
pub const STA_MODE: u32 = 16384;
pub const STA_CLK: u32 = 32768;
pub const STA_RONLY: u32 = 65280;
pub const TIME_OK: u32 = 0;
pub const TIME_INS: u32 = 1;
pub const TIME_DEL: u32 = 2;
pub const TIME_OOP: u32 = 3;
pub const TIME_WAIT: u32 = 4;
pub const TIME_ERROR: u32 = 5;
pub const TIME_BAD: u32 = 5;
pub const ADJ_ADJTIME: u32 = 32768;
pub const ADJ_OFFSET_SINGLESHOT: u32 = 1;
pub const ADJ_OFFSET_READONLY: u32 = 8192;
pub const CODETAG_SECTION_START_PREFIX: &[u8; 9] = b"__start_\0";
pub const CODETAG_SECTION_STOP_PREFIX: &[u8; 8] = b"__stop_\0";
pub const CSIGNAL: u32 = 255;
pub const CLONE_VM: u32 = 256;
pub const CLONE_FS: u32 = 512;
pub const CLONE_FILES: u32 = 1024;
pub const CLONE_SIGHAND: u32 = 2048;
pub const CLONE_PIDFD: u32 = 4096;
pub const CLONE_PTRACE: u32 = 8192;
pub const CLONE_VFORK: u32 = 16384;
pub const CLONE_PARENT: u32 = 32768;
pub const CLONE_THREAD: u32 = 65536;
pub const CLONE_NEWNS: u32 = 131072;
pub const CLONE_SYSVSEM: u32 = 262144;
pub const CLONE_SETTLS: u32 = 524288;
pub const CLONE_PARENT_SETTID: u32 = 1048576;
pub const CLONE_CHILD_CLEARTID: u32 = 2097152;
pub const CLONE_DETACHED: u32 = 4194304;
pub const CLONE_UNTRACED: u32 = 8388608;
pub const CLONE_CHILD_SETTID: u32 = 16777216;
pub const CLONE_NEWCGROUP: u32 = 33554432;
pub const CLONE_NEWUTS: u32 = 67108864;
pub const CLONE_NEWIPC: u32 = 134217728;
pub const CLONE_NEWUSER: u32 = 268435456;
pub const CLONE_NEWPID: u32 = 536870912;
pub const CLONE_NEWNET: u32 = 1073741824;
pub const CLONE_IO: u32 = 2147483648;
pub const CLONE_CLEAR_SIGHAND: u64 = 4294967296;
pub const CLONE_INTO_CGROUP: u64 = 8589934592;
pub const CLONE_NEWTIME: u32 = 128;
pub const CLONE_ARGS_SIZE_VER0: u32 = 64;
pub const CLONE_ARGS_SIZE_VER1: u32 = 80;
pub const CLONE_ARGS_SIZE_VER2: u32 = 88;
pub const SCHED_NORMAL: u32 = 0;
pub const SCHED_FIFO: u32 = 1;
pub const SCHED_RR: u32 = 2;
pub const SCHED_BATCH: u32 = 3;
pub const SCHED_IDLE: u32 = 5;
pub const SCHED_DEADLINE: u32 = 6;
pub const SCHED_EXT: u32 = 7;
pub const SCHED_RESET_ON_FORK: u32 = 1073741824;
pub const SCHED_FLAG_RESET_ON_FORK: u32 = 1;
pub const SCHED_FLAG_RECLAIM: u32 = 2;
pub const SCHED_FLAG_DL_OVERRUN: u32 = 4;
pub const SCHED_FLAG_KEEP_POLICY: u32 = 8;
pub const SCHED_FLAG_KEEP_PARAMS: u32 = 16;
pub const SCHED_FLAG_UTIL_CLAMP_MIN: u32 = 32;
pub const SCHED_FLAG_UTIL_CLAMP_MAX: u32 = 64;
pub const SCHED_FLAG_KEEP_ALL: u32 = 24;
pub const SCHED_FLAG_UTIL_CLAMP: u32 = 96;
pub const SCHED_FLAG_ALL: u32 = 127;
pub const KMSAN_RETVAL_SIZE: u32 = 800;
pub const KMSAN_PARAM_SIZE: u32 = 800;
pub const OSQ_UNLOCKED_VAL: u32 = 0;
pub const RUSAGE_SELF: u32 = 0;
pub const RUSAGE_CHILDREN: i32 = -1;
pub const RUSAGE_BOTH: i32 = -2;
pub const RUSAGE_THREAD: u32 = 1;
pub const RLIM64_INFINITY: i32 = -1;
pub const PRIO_MIN: i32 = -20;
pub const PRIO_MAX: u32 = 20;
pub const PRIO_PROCESS: u32 = 0;
pub const PRIO_PGRP: u32 = 1;
pub const PRIO_USER: u32 = 2;
pub const _STK_LIM: u32 = 8388608;
pub const MLOCK_LIMIT: u32 = 8388608;
pub const RLIMIT_CPU: u32 = 0;
pub const RLIMIT_FSIZE: u32 = 1;
pub const RLIMIT_DATA: u32 = 2;
pub const RLIMIT_STACK: u32 = 3;
pub const RLIMIT_CORE: u32 = 4;
pub const RLIMIT_RSS: u32 = 5;
pub const RLIMIT_NPROC: u32 = 6;
pub const RLIMIT_NOFILE: u32 = 7;
pub const RLIMIT_MEMLOCK: u32 = 8;
pub const RLIMIT_AS: u32 = 9;
pub const RLIMIT_LOCKS: u32 = 10;
pub const RLIMIT_SIGPENDING: u32 = 11;
pub const RLIMIT_MSGQUEUE: u32 = 12;
pub const RLIMIT_NICE: u32 = 13;
pub const RLIMIT_RTPRIO: u32 = 14;
pub const RLIMIT_RTTIME: u32 = 15;
pub const RLIM_NLIMITS: u32 = 16;
pub const RLIM_INFINITY: i32 = -1;
pub const LT_SAVECOUNT: u32 = 32;
pub const LT_BACKTRACEDEPTH: u32 = 12;
pub const MAX_NICE: u32 = 19;
pub const MIN_NICE: i32 = -20;
pub const NICE_WIDTH: u32 = 40;
pub const MAX_RT_PRIO: u32 = 100;
pub const MAX_DL_PRIO: u32 = 0;
pub const MAX_PRIO: u32 = 140;
pub const DEFAULT_PRIO: u32 = 120;
pub const SA_RESTORER: u32 = 67108864;
pub const MINSIGSTKSZ: u32 = 5120;
pub const SIGSTKSZ: u32 = 16384;
pub const _NSIG: u32 = 64;
pub const _NSIG_BPW: u32 = 64;
pub const _NSIG_WORDS: u32 = 1;
pub const SIGHUP: u32 = 1;
pub const SIGINT: u32 = 2;
pub const SIGQUIT: u32 = 3;
pub const SIGILL: u32 = 4;
pub const SIGTRAP: u32 = 5;
pub const SIGABRT: u32 = 6;
pub const SIGIOT: u32 = 6;
pub const SIGBUS: u32 = 7;
pub const SIGFPE: u32 = 8;
pub const SIGKILL: u32 = 9;
pub const SIGUSR1: u32 = 10;
pub const SIGSEGV: u32 = 11;
pub const SIGUSR2: u32 = 12;
pub const SIGPIPE: u32 = 13;
pub const SIGALRM: u32 = 14;
pub const SIGTERM: u32 = 15;
pub const SIGSTKFLT: u32 = 16;
pub const SIGCHLD: u32 = 17;
pub const SIGCONT: u32 = 18;
pub const SIGSTOP: u32 = 19;
pub const SIGTSTP: u32 = 20;
pub const SIGTTIN: u32 = 21;
pub const SIGTTOU: u32 = 22;
pub const SIGURG: u32 = 23;
pub const SIGXCPU: u32 = 24;
pub const SIGXFSZ: u32 = 25;
pub const SIGVTALRM: u32 = 26;
pub const SIGPROF: u32 = 27;
pub const SIGWINCH: u32 = 28;
pub const SIGIO: u32 = 29;
pub const SIGPOLL: u32 = 29;
pub const SIGPWR: u32 = 30;
pub const SIGSYS: u32 = 31;
pub const SIGUNUSED: u32 = 31;
pub const SIGRTMIN: u32 = 32;
pub const SIGRTMAX: u32 = 64;
pub const SA_NOCLDSTOP: u32 = 1;
pub const SA_NOCLDWAIT: u32 = 2;
pub const SA_SIGINFO: u32 = 4;
pub const SA_UNSUPPORTED: u32 = 1024;
pub const SA_EXPOSE_TAGBITS: u32 = 2048;
pub const SA_ONSTACK: u32 = 134217728;
pub const SA_RESTART: u32 = 268435456;
pub const SA_NODEFER: u32 = 1073741824;
pub const SA_RESETHAND: u32 = 2147483648;
pub const SA_NOMASK: u32 = 1073741824;
pub const SA_ONESHOT: u32 = 2147483648;
pub const SIG_BLOCK: u32 = 0;
pub const SIG_UNBLOCK: u32 = 1;
pub const SIG_SETMASK: u32 = 2;
pub const SI_MAX_SIZE: u32 = 128;
pub const SI_USER: u32 = 0;
pub const SI_KERNEL: u32 = 128;
pub const SI_QUEUE: i32 = -1;
pub const SI_TIMER: i32 = -2;
pub const SI_MESGQ: i32 = -3;
pub const SI_ASYNCIO: i32 = -4;
pub const SI_SIGIO: i32 = -5;
pub const SI_TKILL: i32 = -6;
pub const SI_DETHREAD: i32 = -7;
pub const SI_ASYNCNL: i32 = -60;
pub const ILL_ILLOPC: u32 = 1;
pub const ILL_ILLOPN: u32 = 2;
pub const ILL_ILLADR: u32 = 3;
pub const ILL_ILLTRP: u32 = 4;
pub const ILL_PRVOPC: u32 = 5;
pub const ILL_PRVREG: u32 = 6;
pub const ILL_COPROC: u32 = 7;
pub const ILL_BADSTK: u32 = 8;
pub const ILL_BADIADDR: u32 = 9;
pub const __ILL_BREAK: u32 = 10;
pub const __ILL_BNDMOD: u32 = 11;
pub const NSIGILL: u32 = 11;
pub const FPE_INTDIV: u32 = 1;
pub const FPE_INTOVF: u32 = 2;
pub const FPE_FLTDIV: u32 = 3;
pub const FPE_FLTOVF: u32 = 4;
pub const FPE_FLTUND: u32 = 5;
pub const FPE_FLTRES: u32 = 6;
pub const FPE_FLTINV: u32 = 7;
pub const FPE_FLTSUB: u32 = 8;
pub const __FPE_DECOVF: u32 = 9;
pub const __FPE_DECDIV: u32 = 10;
pub const __FPE_DECERR: u32 = 11;
pub const __FPE_INVASC: u32 = 12;
pub const __FPE_INVDEC: u32 = 13;
pub const FPE_FLTUNK: u32 = 14;
pub const FPE_CONDTRAP: u32 = 15;
pub const NSIGFPE: u32 = 15;
pub const SEGV_MAPERR: u32 = 1;
pub const SEGV_ACCERR: u32 = 2;
pub const SEGV_BNDERR: u32 = 3;
pub const SEGV_PKUERR: u32 = 4;
pub const SEGV_ACCADI: u32 = 5;
pub const SEGV_ADIDERR: u32 = 6;
pub const SEGV_ADIPERR: u32 = 7;
pub const SEGV_MTEAERR: u32 = 8;
pub const SEGV_MTESERR: u32 = 9;
pub const SEGV_CPERR: u32 = 10;
pub const NSIGSEGV: u32 = 10;
pub const BUS_ADRALN: u32 = 1;
pub const BUS_ADRERR: u32 = 2;
pub const BUS_OBJERR: u32 = 3;
pub const BUS_MCEERR_AR: u32 = 4;
pub const BUS_MCEERR_AO: u32 = 5;
pub const NSIGBUS: u32 = 5;
pub const TRAP_BRKPT: u32 = 1;
pub const TRAP_TRACE: u32 = 2;
pub const TRAP_BRANCH: u32 = 3;
pub const TRAP_HWBKPT: u32 = 4;
pub const TRAP_UNK: u32 = 5;
pub const TRAP_PERF: u32 = 6;
pub const NSIGTRAP: u32 = 6;
pub const TRAP_PERF_FLAG_ASYNC: u32 = 1;
pub const CLD_EXITED: u32 = 1;
pub const CLD_KILLED: u32 = 2;
pub const CLD_DUMPED: u32 = 3;
pub const CLD_TRAPPED: u32 = 4;
pub const CLD_STOPPED: u32 = 5;
pub const CLD_CONTINUED: u32 = 6;
pub const NSIGCHLD: u32 = 6;
pub const POLL_IN: u32 = 1;
pub const POLL_OUT: u32 = 2;
pub const POLL_MSG: u32 = 3;
pub const POLL_ERR: u32 = 4;
pub const POLL_PRI: u32 = 5;
pub const POLL_HUP: u32 = 6;
pub const NSIGPOLL: u32 = 6;
pub const SYS_SECCOMP: u32 = 1;
pub const SYS_USER_DISPATCH: u32 = 2;
pub const NSIGSYS: u32 = 2;
pub const EMT_TAGOVF: u32 = 1;
pub const NSIGEMT: u32 = 1;
pub const SIGEV_SIGNAL: u32 = 0;
pub const SIGEV_NONE: u32 = 1;
pub const SIGEV_THREAD: u32 = 2;
pub const SIGEV_THREAD_ID: u32 = 4;
pub const SIGEV_MAX_SIZE: u32 = 64;
pub const SS_ONSTACK: u32 = 1;
pub const SS_DISABLE: u32 = 2;
pub const SS_AUTODISARM: u32 = 2147483648;
pub const SS_FLAG_BITS: u32 = 2147483648;
pub const SIGQUEUE_PREALLOC: u32 = 1;
pub const SA_IMMUTABLE: u32 = 8388608;
pub const __ARCH_UAPI_SA_FLAGS: u32 = 67108864;
pub const UAPI_SA_FLAGS: u32 = 3690989575;
pub const CPUCLOCK_PERTHREAD_MASK: u32 = 4;
pub const CPUCLOCK_CLOCK_MASK: u32 = 3;
pub const CPUCLOCK_PROF: u32 = 0;
pub const CPUCLOCK_VIRT: u32 = 1;
pub const CPUCLOCK_SCHED: u32 = 2;
pub const CPUCLOCK_MAX: u32 = 3;
pub const CLOCKFD: u32 = 3;
pub const CLOCKFD_MASK: u32 = 7;
pub const MAX_DA_NAME_LEN: u32 = 32;
pub const RV_PER_TASK_MONITORS: u32 = 1;
pub const RV_PER_TASK_MONITOR_INIT: u32 = 1;
pub const TRACEPOINT_DEFS_H: u32 = 1;
pub const KM_MAX_IDX: u32 = 16;
pub const TASK_RUNNING: u32 = 0;
pub const TASK_INTERRUPTIBLE: u32 = 1;
pub const TASK_UNINTERRUPTIBLE: u32 = 2;
pub const __TASK_STOPPED: u32 = 4;
pub const __TASK_TRACED: u32 = 8;
pub const EXIT_DEAD: u32 = 16;
pub const EXIT_ZOMBIE: u32 = 32;
pub const EXIT_TRACE: u32 = 48;
pub const TASK_PARKED: u32 = 64;
pub const TASK_DEAD: u32 = 128;
pub const TASK_WAKEKILL: u32 = 256;
pub const TASK_WAKING: u32 = 512;
pub const TASK_NOLOAD: u32 = 1024;
pub const TASK_NEW: u32 = 2048;
pub const TASK_RTLOCK_WAIT: u32 = 4096;
pub const TASK_FREEZABLE: u32 = 8192;
pub const TASK_FROZEN: u32 = 32768;
pub const TASK_STATE_MAX: u32 = 65536;
pub const TASK_ANY: u32 = 65535;
pub const TASK_KILLABLE: u32 = 258;
pub const TASK_STOPPED: u32 = 260;
pub const TASK_TRACED: u32 = 8;
pub const TASK_IDLE: u32 = 1026;
pub const TASK_NORMAL: u32 = 3;
pub const TASK_REPORT: u32 = 127;
pub const SCHED_FIXEDPOINT_SHIFT: u32 = 10;
pub const SCHED_FIXEDPOINT_SCALE: u32 = 1024;
pub const SCHED_CAPACITY_SHIFT: u32 = 10;
pub const SCHED_CAPACITY_SCALE: u32 = 1024;
pub const UTIL_EST_WEIGHT_SHIFT: u32 = 2;
pub const UTIL_AVG_UNCHANGED: u32 = 2147483648;
pub const UCLAMP_BUCKETS: u32 = 5;
pub const PERF_NR_CONTEXTS: u32 = 4;
pub const TASK_REPORT_IDLE: u32 = 128;
pub const TASK_REPORT_MAX: u32 = 256;
pub const PF_VCPU: u32 = 1;
pub const PF_IDLE: u32 = 2;
pub const PF_EXITING: u32 = 4;
pub const PF_POSTCOREDUMP: u32 = 8;
pub const PF_IO_WORKER: u32 = 16;
pub const PF_WQ_WORKER: u32 = 32;
pub const PF_FORKNOEXEC: u32 = 64;
pub const PF_MCE_PROCESS: u32 = 128;
pub const PF_SUPERPRIV: u32 = 256;
pub const PF_DUMPCORE: u32 = 512;
pub const PF_SIGNALED: u32 = 1024;
pub const PF_MEMALLOC: u32 = 2048;
pub const PF_NPROC_EXCEEDED: u32 = 4096;
pub const PF_USED_MATH: u32 = 8192;
pub const PF_USER_WORKER: u32 = 16384;
pub const PF_NOFREEZE: u32 = 32768;
pub const PF_KCOMPACTD: u32 = 65536;
pub const PF_KSWAPD: u32 = 131072;
pub const PF_MEMALLOC_NOFS: u32 = 262144;
pub const PF_MEMALLOC_NOIO: u32 = 524288;
pub const PF_LOCAL_THROTTLE: u32 = 1048576;
pub const PF_KTHREAD: u32 = 2097152;
pub const PF_RANDOMIZE: u32 = 4194304;
pub const PF__HOLE__00800000: u32 = 8388608;
pub const PF__HOLE__01000000: u32 = 16777216;
pub const PF__HOLE__02000000: u32 = 33554432;
pub const PF_NO_SETAFFINITY: u32 = 67108864;
pub const PF_MCE_EARLY: u32 = 134217728;
pub const PF_MEMALLOC_PIN: u32 = 268435456;
pub const PF_BLOCK_TS: u32 = 536870912;
pub const PF__HOLE__40000000: u32 = 1073741824;
pub const PF_SUSPEND_TASK: u32 = 2147483648;
pub const PFA_NO_NEW_PRIVS: u32 = 0;
pub const PFA_SPREAD_PAGE: u32 = 1;
pub const PFA_SPREAD_SLAB: u32 = 2;
pub const PFA_SPEC_SSB_DISABLE: u32 = 3;
pub const PFA_SPEC_SSB_FORCE_DISABLE: u32 = 4;
pub const PFA_SPEC_IB_DISABLE: u32 = 5;
pub const PFA_SPEC_IB_FORCE_DISABLE: u32 = 6;
pub const PFA_SPEC_SSB_NOEXEC: u32 = 7;
pub const MIGHT_RESCHED_RCU_SHIFT: u32 = 8;
pub const MIGHT_RESCHED_PREEMPT_MASK: u32 = 255;
pub const PREEMPT_LOCK_RESCHED_OFFSETS: u32 = 1;
pub const PERCPU_MODULE_RESERVE: u32 = 8192;
pub const PCPU_MIN_ALLOC_SHIFT: u32 = 2;
pub const PCPU_MIN_ALLOC_SIZE: u32 = 4;
pub const PERCPU_DYNAMIC_SIZE_SHIFT: u32 = 12;
pub const PERCPU_DYNAMIC_EARLY_SIZE: u32 = 81920;
pub const PERCPU_DYNAMIC_RESERVE: u32 = 114688;
pub const ARCH_TIMER_CTRL_ENABLE: u32 = 1;
pub const ARCH_TIMER_CTRL_IT_MASK: u32 = 2;
pub const ARCH_TIMER_CTRL_IT_STAT: u32 = 4;
pub const CNTHCTL_EL1PCTEN: u32 = 1;
pub const CNTHCTL_EL1PCEN: u32 = 2;
pub const CNTHCTL_EVNTEN: u32 = 4;
pub const CNTHCTL_EVNTDIR: u32 = 8;
pub const CNTHCTL_EVNTI: u32 = 240;
pub const CNTHCTL_ECV: u32 = 4096;
pub const CNTHCTL_EL1TVT: u32 = 8192;
pub const CNTHCTL_EL1TVCT: u32 = 16384;
pub const CNTHCTL_EL1NVPCT: u32 = 32768;
pub const CNTHCTL_EL1NVVCT: u32 = 65536;
pub const CNTHCTL_CNTVMASK: u32 = 262144;
pub const CNTHCTL_CNTPMASK: u32 = 524288;
pub const ARCH_TIMER_PHYS_ACCESS: u32 = 0;
pub const ARCH_TIMER_VIRT_ACCESS: u32 = 1;
pub const ARCH_TIMER_MEM_PHYS_ACCESS: u32 = 2;
pub const ARCH_TIMER_MEM_VIRT_ACCESS: u32 = 3;
pub const ARCH_TIMER_MEM_MAX_FRAMES: u32 = 8;
pub const ARCH_TIMER_USR_PCT_ACCESS_EN: u32 = 1;
pub const ARCH_TIMER_USR_VCT_ACCESS_EN: u32 = 2;
pub const ARCH_TIMER_VIRT_EVT_EN: u32 = 4;
pub const ARCH_TIMER_EVT_TRIGGER_SHIFT: u32 = 4;
pub const ARCH_TIMER_EVT_TRIGGER_MASK: u32 = 240;
pub const ARCH_TIMER_USR_VT_ACCESS_EN: u32 = 256;
pub const ARCH_TIMER_USR_PT_ACCESS_EN: u32 = 512;
pub const ARCH_TIMER_EVT_INTERVAL_SCALE: u32 = 131072;
pub const ARCH_TIMER_EVT_STREAM_PERIOD_US: u32 = 100;
pub const ARCH_TIMER_EVT_STREAM_FREQ: u32 = 10000;
pub const SHIFT_PLL: u32 = 2;
pub const SHIFT_FLL: u32 = 2;
pub const MAXTC: u32 = 10;
pub const SHIFT_USEC: u32 = 16;
pub const PPM_SCALE_INV_SHIFT: u32 = 19;
pub const MAXPHASE: u32 = 500000000;
pub const MAXFREQ: u32 = 500000;
pub const MINSEC: u32 = 256;
pub const MAXSEC: u32 = 2048;
pub const NTP_PHASE_LIMIT: u32 = 16000000;
pub const NTP_SCALE_SHIFT: u32 = 32;
pub const NTP_INTERVAL_FREQ: u32 = 1000;
pub const NTP_INTERVAL_LENGTH: u32 = 1000000;
pub const PIT_TICK_RATE: u32 = 1193182;
pub const COMPAT_USER_HZ: u32 = 100;
pub const COMPAT_RLIM_INFINITY: u32 = 4294967295;
pub const COMPAT_OFF_T_MAX: u32 = 2147483647;
pub const _COMPAT_NSIG: u32 = 64;
pub const _COMPAT_NSIG_BPW: u32 = 32;
pub const ADFS_SUPER_MAGIC: u32 = 44533;
pub const AFFS_SUPER_MAGIC: u32 = 44543;
pub const AFS_SUPER_MAGIC: u32 = 1397113167;
pub const AUTOFS_SUPER_MAGIC: u32 = 391;
pub const CEPH_SUPER_MAGIC: u32 = 12805120;
pub const CODA_SUPER_MAGIC: u32 = 1937076805;
pub const CRAMFS_MAGIC: u32 = 684539205;
pub const CRAMFS_MAGIC_WEND: u32 = 1161678120;
pub const DEBUGFS_MAGIC: u32 = 1684170528;
pub const SECURITYFS_MAGIC: u32 = 1935894131;
pub const SELINUX_MAGIC: u32 = 4185718668;
pub const SMACK_MAGIC: u32 = 1128357203;
pub const RAMFS_MAGIC: u32 = 2240043254;
pub const TMPFS_MAGIC: u32 = 16914836;
pub const HUGETLBFS_MAGIC: u32 = 2508478710;
pub const SQUASHFS_MAGIC: u32 = 1936814952;
pub const ECRYPTFS_SUPER_MAGIC: u32 = 61791;
pub const EFS_SUPER_MAGIC: u32 = 4278867;
pub const EROFS_SUPER_MAGIC_V1: u32 = 3774210530;
pub const EXT2_SUPER_MAGIC: u32 = 61267;
pub const EXT3_SUPER_MAGIC: u32 = 61267;
pub const XENFS_SUPER_MAGIC: u32 = 2881100148;
pub const EXT4_SUPER_MAGIC: u32 = 61267;
pub const BTRFS_SUPER_MAGIC: u32 = 2435016766;
pub const NILFS_SUPER_MAGIC: u32 = 13364;
pub const F2FS_SUPER_MAGIC: u32 = 4076150800;
pub const HPFS_SUPER_MAGIC: u32 = 4187351113;
pub const ISOFS_SUPER_MAGIC: u32 = 38496;
pub const JFFS2_SUPER_MAGIC: u32 = 29366;
pub const XFS_SUPER_MAGIC: u32 = 1481003842;
pub const PSTOREFS_MAGIC: u32 = 1634035564;
pub const EFIVARFS_MAGIC: u32 = 3730735588;
pub const HOSTFS_SUPER_MAGIC: u32 = 12648430;
pub const OVERLAYFS_SUPER_MAGIC: u32 = 2035054128;
pub const FUSE_SUPER_MAGIC: u32 = 1702057286;
pub const BCACHEFS_SUPER_MAGIC: u32 = 3393526350;
pub const MINIX_SUPER_MAGIC: u32 = 4991;
pub const MINIX_SUPER_MAGIC2: u32 = 5007;
pub const MINIX2_SUPER_MAGIC: u32 = 9320;
pub const MINIX2_SUPER_MAGIC2: u32 = 9336;
pub const MINIX3_SUPER_MAGIC: u32 = 19802;
pub const MSDOS_SUPER_MAGIC: u32 = 19780;
pub const EXFAT_SUPER_MAGIC: u32 = 538032816;
pub const NCP_SUPER_MAGIC: u32 = 22092;
pub const NFS_SUPER_MAGIC: u32 = 26985;
pub const OCFS2_SUPER_MAGIC: u32 = 1952539503;
pub const OPENPROM_SUPER_MAGIC: u32 = 40865;
pub const QNX4_SUPER_MAGIC: u32 = 47;
pub const QNX6_SUPER_MAGIC: u32 = 1746473250;
pub const AFS_FS_MAGIC: u32 = 1799439955;
pub const REISERFS_SUPER_MAGIC: u32 = 1382369651;
pub const REISERFS_SUPER_MAGIC_STRING: &[u8; 9] = b"ReIsErFs\0";
pub const REISER2FS_SUPER_MAGIC_STRING: &[u8; 10] = b"ReIsEr2Fs\0";
pub const REISER2FS_JR_SUPER_MAGIC_STRING: &[u8; 10] = b"ReIsEr3Fs\0";
pub const SMB_SUPER_MAGIC: u32 = 20859;
pub const CIFS_SUPER_MAGIC: u32 = 4283649346;
pub const SMB2_SUPER_MAGIC: u32 = 4266872130;
pub const CGROUP_SUPER_MAGIC: u32 = 2613483;
pub const CGROUP2_SUPER_MAGIC: u32 = 1667723888;
pub const RDTGROUP_SUPER_MAGIC: u32 = 124082209;
pub const STACK_END_MAGIC: u32 = 1470918301;
pub const TRACEFS_MAGIC: u32 = 1953653091;
pub const V9FS_MAGIC: u32 = 16914839;
pub const BDEVFS_MAGIC: u32 = 1650746742;
pub const DAXFS_MAGIC: u32 = 1684300152;
pub const BINFMTFS_MAGIC: u32 = 1112100429;
pub const DEVPTS_SUPER_MAGIC: u32 = 7377;
pub const BINDERFS_SUPER_MAGIC: u32 = 1819242352;
pub const FUTEXFS_SUPER_MAGIC: u32 = 195894762;
pub const PIPEFS_MAGIC: u32 = 1346981957;
pub const PROC_SUPER_MAGIC: u32 = 40864;
pub const SOCKFS_MAGIC: u32 = 1397703499;
pub const SYSFS_MAGIC: u32 = 1650812274;
pub const USBDEVICE_SUPER_MAGIC: u32 = 40866;
pub const MTD_INODE_FS_MAGIC: u32 = 288389204;
pub const ANON_INODE_FS_MAGIC: u32 = 151263540;
pub const BTRFS_TEST_MAGIC: u32 = 1936880249;
pub const NSFS_MAGIC: u32 = 1853056627;
pub const BPF_FS_MAGIC: u32 = 3405662737;
pub const AAFS_MAGIC: u32 = 1513908720;
pub const ZONEFS_MAGIC: u32 = 1515144787;
pub const UDF_SUPER_MAGIC: u32 = 352400198;
pub const DMA_BUF_MAGIC: u32 = 1145913666;
pub const DEVMEM_MAGIC: u32 = 1162691661;
pub const SECRETMEM_MAGIC: u32 = 1397048141;
pub const PID_FS_MAGIC: u32 = 1346978886;
pub const KASAN_VMALLOC_PAGE_RANGE: u32 = 1;
pub const KASAN_VMALLOC_TLB_FLUSH: u32 = 2;
pub const COMPAT_UTS_MACHINE: &[u8; 9] = b"armv8l\0\0\0";
pub const COMPAT_MINSIGSTKSZ: u32 = 2048;
pub const STAT64_HAS_BROKEN_ST_INO: u32 = 1;
pub const S_IFMT: u32 = 61440;
pub const S_IFSOCK: u32 = 49152;
pub const S_IFLNK: u32 = 40960;
pub const S_IFREG: u32 = 32768;
pub const S_IFBLK: u32 = 24576;
pub const S_IFDIR: u32 = 16384;
pub const S_IFCHR: u32 = 8192;
pub const S_IFIFO: u32 = 4096;
pub const S_ISUID: u32 = 2048;
pub const S_ISGID: u32 = 1024;
pub const S_ISVTX: u32 = 512;
pub const S_IRWXU: u32 = 448;
pub const S_IRUSR: u32 = 256;
pub const S_IWUSR: u32 = 128;
pub const S_IXUSR: u32 = 64;
pub const S_IRWXG: u32 = 56;
pub const S_IRGRP: u32 = 32;
pub const S_IWGRP: u32 = 16;
pub const S_IXGRP: u32 = 8;
pub const S_IRWXO: u32 = 7;
pub const S_IROTH: u32 = 4;
pub const S_IWOTH: u32 = 2;
pub const S_IXOTH: u32 = 1;
pub const STATX_TYPE: u32 = 1;
pub const STATX_MODE: u32 = 2;
pub const STATX_NLINK: u32 = 4;
pub const STATX_UID: u32 = 8;
pub const STATX_GID: u32 = 16;
pub const STATX_ATIME: u32 = 32;
pub const STATX_MTIME: u32 = 64;
pub const STATX_CTIME: u32 = 128;
pub const STATX_INO: u32 = 256;
pub const STATX_SIZE: u32 = 512;
pub const STATX_BLOCKS: u32 = 1024;
pub const STATX_BASIC_STATS: u32 = 2047;
pub const STATX_BTIME: u32 = 2048;
pub const STATX_MNT_ID: u32 = 4096;
pub const STATX_DIOALIGN: u32 = 8192;
pub const STATX_MNT_ID_UNIQUE: u32 = 16384;
pub const STATX_SUBVOL: u32 = 32768;
pub const STATX_WRITE_ATOMIC: u32 = 65536;
pub const STATX_DIO_READ_ALIGN: u32 = 131072;
pub const STATX__RESERVED: u32 = 2147483648;
pub const STATX_ATTR_COMPRESSED: u32 = 4;
pub const STATX_ATTR_IMMUTABLE: u32 = 16;
pub const STATX_ATTR_APPEND: u32 = 32;
pub const STATX_ATTR_NODUMP: u32 = 64;
pub const STATX_ATTR_ENCRYPTED: u32 = 2048;
pub const STATX_ATTR_AUTOMOUNT: u32 = 4096;
pub const STATX_ATTR_MOUNT_ROOT: u32 = 8192;
pub const STATX_ATTR_VERITY: u32 = 1048576;
pub const STATX_ATTR_DAX: u32 = 2097152;
pub const STATX_ATTR_WRITE_ATOMIC: u32 = 4194304;
pub const S_IRWXUGO: u32 = 511;
pub const S_IALLUGO: u32 = 4095;
pub const S_IRUGO: u32 = 292;
pub const S_IWUGO: u32 = 146;
pub const S_IXUGO: u32 = 73;
pub const UTIME_NOW: u32 = 1073741823;
pub const UTIME_OMIT: u32 = 1073741822;
pub const DEFAULT_OVERFLOWUID: u32 = 65534;
pub const DEFAULT_OVERFLOWGID: u32 = 65534;
pub const DEFAULT_FS_OVERFLOWUID: u32 = 65534;
pub const DEFAULT_FS_OVERFLOWGID: u32 = 65534;
pub const KSTAT_ATTR_FS_IOC_FLAGS: u32 = 1050740;
pub const KSTAT_ATTR_VFS_FLAGS: u32 = 48;
pub const STATX_CHANGE_COOKIE: u32 = 1073741824;
pub const STATX_ATTR_CHANGE_MONOTONIC: i64 = -9223372036854775808;
pub const BUILD_ID_SIZE_MAX: u32 = 20;
pub const WQ_FLAG_EXCLUSIVE: u32 = 1;
pub const WQ_FLAG_WOKEN: u32 = 2;
pub const WQ_FLAG_CUSTOM: u32 = 4;
pub const WQ_FLAG_DONE: u32 = 8;
pub const WQ_FLAG_PRIORITY: u32 = 16;
pub const KCSAN_SEQLOCK_REGION_MAX: u32 = 1000;
pub const PB_migratetype_bits: u32 = 3;
pub const NR_PAGEFLAGS: u32 = 26;
pub const MAX_NR_ZONES: u32 = 5;
pub const NR_CPUS_BITS: u32 = 12;
pub const SPINLOCK_SIZE: u32 = 4;
pub const LRU_GEN_WIDTH: u32 = 3;
pub const __LRU_REFS_WIDTH: u32 = 2;
pub const ZONES_SHIFT: u32 = 3;
pub const ZONES_WIDTH: u32 = 3;
pub const SECTIONS_SHIFT: u32 = 21;
pub const SECTIONS_WIDTH: u32 = 0;
pub const NODES_WIDTH: u32 = 9;
pub const KASAN_TAG_WIDTH: u32 = 0;
pub const LAST__PID_SHIFT: u32 = 8;
pub const LAST__PID_MASK: u32 = 255;
pub const LAST__CPU_SHIFT: u32 = 12;
pub const LAST__CPU_MASK: u32 = 4095;
pub const LAST_CPUPID_SHIFT: u32 = 20;
pub const LAST_CPUPID_WIDTH: u32 = 20;
pub const AT_SYSINFO_EHDR: u32 = 33;
pub const AT_MINSIGSTKSZ: u32 = 51;
pub const AT_VECTOR_SIZE_ARCH: u32 = 2;
pub const AT_NULL: u32 = 0;
pub const AT_IGNORE: u32 = 1;
pub const AT_EXECFD: u32 = 2;
pub const AT_PHDR: u32 = 3;
pub const AT_PHENT: u32 = 4;
pub const AT_PHNUM: u32 = 5;
pub const AT_PAGESZ: u32 = 6;
pub const AT_BASE: u32 = 7;
pub const AT_FLAGS: u32 = 8;
pub const AT_ENTRY: u32 = 9;
pub const AT_NOTELF: u32 = 10;
pub const AT_UID: u32 = 11;
pub const AT_EUID: u32 = 12;
pub const AT_GID: u32 = 13;
pub const AT_EGID: u32 = 14;
pub const AT_PLATFORM: u32 = 15;
pub const AT_HWCAP: u32 = 16;
pub const AT_CLKTCK: u32 = 17;
pub const AT_SECURE: u32 = 23;
pub const AT_BASE_PLATFORM: u32 = 24;
pub const AT_RANDOM: u32 = 25;
pub const AT_HWCAP2: u32 = 26;
pub const AT_RSEQ_FEATURE_SIZE: u32 = 27;
pub const AT_RSEQ_ALIGN: u32 = 28;
pub const AT_HWCAP3: u32 = 29;
pub const AT_HWCAP4: u32 = 30;
pub const AT_EXECFN: u32 = 31;
pub const AT_VECTOR_SIZE_BASE: u32 = 22;
pub const RCU_SEQ_CTR_SHIFT: u32 = 2;
pub const RCU_SEQ_STATE_MASK: u32 = 3;
pub const NUM_ACTIVE_RCU_POLL_OLDSTATE: u32 = 2;
pub const TRC_NEED_QS: u32 = 1;
pub const TRC_NEED_QS_CHECKED: u32 = 2;
pub const NUM_ACTIVE_RCU_POLL_FULL_OLDSTATE: u32 = 4;
pub const MAPLE_NODE_SLOTS: u32 = 31;
pub const MAPLE_RANGE64_SLOTS: u32 = 16;
pub const MAPLE_ARANGE64_SLOTS: u32 = 10;
pub const MAPLE_ALLOC_SLOTS: u32 = 30;
pub const MAPLE_NODE_MASK: u32 = 255;
pub const MT_FLAGS_ALLOC_RANGE: u32 = 1;
pub const MT_FLAGS_USE_RCU: u32 = 2;
pub const MT_FLAGS_HEIGHT_OFFSET: u32 = 2;
pub const MT_FLAGS_HEIGHT_MASK: u32 = 124;
pub const MT_FLAGS_LOCK_MASK: u32 = 768;
pub const MT_FLAGS_LOCK_IRQ: u32 = 256;
pub const MT_FLAGS_LOCK_BH: u32 = 512;
pub const MT_FLAGS_LOCK_EXTERN: u32 = 768;
pub const MT_FLAGS_ALLOC_WRAPPED: u32 = 2048;
pub const MAPLE_HEIGHT_MAX: u32 = 31;
pub const MAPLE_NODE_TYPE_MASK: u32 = 15;
pub const MAPLE_NODE_TYPE_SHIFT: u32 = 3;
pub const MAPLE_RESERVED_RANGE: u32 = 4096;
pub const RWSEM_UNLOCKED_VALUE: u32 = 0;
pub const RWSEM_WRITER_LOCKED: u32 = 1;
pub const TICK_NSEC: u32 = 1000000;
pub const HZ_TO_MSEC_SHR32: u32 = 31;
pub const MSEC_TO_HZ_SHR32: u32 = 31;
pub const HZ_TO_MSEC_NUM: u32 = 1;
pub const HZ_TO_MSEC_DEN: u32 = 1;
pub const MSEC_TO_HZ_NUM: u32 = 1;
pub const MSEC_TO_HZ_DEN: u32 = 1;
pub const HZ_TO_USEC_SHR32: u32 = 22;
pub const USEC_TO_HZ_SHR32: u32 = 41;
pub const HZ_TO_USEC_NUM: u32 = 1000;
pub const HZ_TO_USEC_DEN: u32 = 1;
pub const USEC_TO_HZ_NUM: u32 = 1;
pub const USEC_TO_HZ_DEN: u32 = 1000;
pub const HZ_TO_NSEC_NUM: u32 = 1000000;
pub const HZ_TO_NSEC_DEN: u32 = 1;
pub const NSEC_TO_HZ_NUM: u32 = 1;
pub const NSEC_TO_HZ_DEN: u32 = 1000000;
pub const SHIFT_HZ: u32 = 10;
pub const TICK_USEC: u32 = 1000;
pub const USER_TICK_USEC: u32 = 10000;
pub const SEC_JIFFIE_SC: u32 = 21;
pub const NSEC_JIFFIE_SC: u32 = 51;
pub const TIMESTAMP_SIZE: u32 = 30;
pub const LOW_RES_NSEC: u32 = 1000000;
pub const KTIME_LOW_RES: u32 = 1000000;
pub const TIMER_CPUMASK: u32 = 262143;
pub const TIMER_MIGRATING: u32 = 262144;
pub const TIMER_BASEMASK: u32 = 524287;
pub const TIMER_DEFERRABLE: u32 = 524288;
pub const TIMER_PINNED: u32 = 1048576;
pub const TIMER_IRQSAFE: u32 = 2097152;
pub const TIMER_INIT_FLAGS: u32 = 3670016;
pub const TIMER_ARRAYSHIFT: u32 = 22;
pub const TIMER_ARRAYMASK: u32 = 4290772992;
pub const TIMER_TRACE_FLAGMASK: u32 = 3932160;
pub const NEXT_TIMER_MAX_DELTA: u32 = 1073741823;
pub const UPROBE_HANDLER_REMOVE: u32 = 1;
pub const UPROBE_HANDLER_IGNORE: u32 = 2;
pub const MAX_URETPROBE_DEPTH: u32 = 64;
pub const UPROBE_NO_TRAMPOLINE_VADDR: i32 = -1;
pub const ESR_ELx_EC_SHIFT: u32 = 26;
pub const ESR_ELx_EC_WIDTH: u32 = 6;
pub const ESR_ELx_IL_SHIFT: u32 = 25;
pub const ESR_ELx_ISS2_SHIFT: u32 = 32;
pub const ESR_ELx_WNR_SHIFT: u32 = 6;
pub const ESR_ELx_IDS_SHIFT: u32 = 24;
pub const ESR_ELx_AET_SHIFT: u32 = 10;
pub const ESR_ELx_SET_SHIFT: u32 = 11;
pub const ESR_ELx_FnV_SHIFT: u32 = 10;
pub const ESR_ELx_EA_SHIFT: u32 = 9;
pub const ESR_ELx_S1PTW_SHIFT: u32 = 7;
pub const ESR_ELx_FSC: u32 = 63;
pub const ESR_ELx_FSC_TYPE: u32 = 60;
pub const ESR_ELx_FSC_LEVEL: u32 = 3;
pub const ESR_ELx_FSC_EXTABT: u32 = 16;
pub const ESR_ELx_FSC_MTE: u32 = 17;
pub const ESR_ELx_FSC_SERROR: u32 = 17;
pub const ESR_ELx_FSC_ACCESS: u32 = 8;
pub const ESR_ELx_FSC_FAULT: u32 = 4;
pub const ESR_ELx_FSC_PERM: u32 = 12;
pub const ESR_ELx_FSC_SECC: u32 = 24;
pub const ESR_ELx_FSC_ADDRSZ: u32 = 0;
pub const ESR_ELx_FSC_FAULT_nL: u32 = 44;
pub const ESR_ELx_ISV_SHIFT: u32 = 24;
pub const ESR_ELx_SAS_SHIFT: u32 = 22;
pub const ESR_ELx_SSE_SHIFT: u32 = 21;
pub const ESR_ELx_SRT_SHIFT: u32 = 16;
pub const ESR_ELx_SF_SHIFT: u32 = 15;
pub const ESR_ELx_AR_SHIFT: u32 = 14;
pub const ESR_ELx_CM_SHIFT: u32 = 8;
pub const ESR_ELx_TnD_SHIFT: u32 = 10;
pub const ESR_ELx_TagAccess_SHIFT: u32 = 9;
pub const ESR_ELx_GCS_SHIFT: u32 = 8;
pub const ESR_ELx_Overlay_SHIFT: u32 = 6;
pub const ESR_ELx_DirtyBit_SHIFT: u32 = 5;
pub const ESR_ELx_Xs_SHIFT: u32 = 0;
pub const ESR_ELx_COND_SHIFT: u32 = 20;
pub const ESR_ELx_BRK64_ISS_COMMENT_MASK: u32 = 65535;
pub const ESR_ELx_SYS64_ISS_RES0_SHIFT: u32 = 22;
pub const ESR_ELx_SYS64_ISS_DIR_MASK: u32 = 1;
pub const ESR_ELx_SYS64_ISS_DIR_READ: u32 = 1;
pub const ESR_ELx_SYS64_ISS_DIR_WRITE: u32 = 0;
pub const ESR_ELx_SYS64_ISS_RT_SHIFT: u32 = 5;
pub const ESR_ELx_SYS64_ISS_CRM_SHIFT: u32 = 1;
pub const ESR_ELx_SYS64_ISS_CRN_SHIFT: u32 = 10;
pub const ESR_ELx_SYS64_ISS_OP1_SHIFT: u32 = 14;
pub const ESR_ELx_SYS64_ISS_OP2_SHIFT: u32 = 17;
pub const ESR_ELx_SYS64_ISS_OP0_SHIFT: u32 = 20;
pub const ESR_ELx_SYS64_ISS_CRM_DC_CIVAC: u32 = 14;
pub const ESR_ELx_SYS64_ISS_CRM_DC_CVADP: u32 = 13;
pub const ESR_ELx_SYS64_ISS_CRM_DC_CVAP: u32 = 12;
pub const ESR_ELx_SYS64_ISS_CRM_DC_CVAU: u32 = 11;
pub const ESR_ELx_SYS64_ISS_CRM_DC_CVAC: u32 = 10;
pub const ESR_ELx_SYS64_ISS_CRM_IC_IVAU: u32 = 5;
pub const ESR_ELx_ERET_ISS_ERET: u32 = 2;
pub const ESR_ELx_ERET_ISS_ERETA: u32 = 1;
pub const ESR_ELx_CP15_32_ISS_DIR_MASK: u32 = 1;
pub const ESR_ELx_CP15_32_ISS_DIR_READ: u32 = 1;
pub const ESR_ELx_CP15_32_ISS_DIR_WRITE: u32 = 0;
pub const ESR_ELx_CP15_32_ISS_RT_SHIFT: u32 = 5;
pub const ESR_ELx_CP15_32_ISS_CRM_SHIFT: u32 = 1;
pub const ESR_ELx_CP15_32_ISS_CRN_SHIFT: u32 = 10;
pub const ESR_ELx_CP15_32_ISS_OP1_SHIFT: u32 = 14;
pub const ESR_ELx_CP15_32_ISS_OP2_SHIFT: u32 = 17;
pub const ESR_ELx_CP15_64_ISS_DIR_MASK: u32 = 1;
pub const ESR_ELx_CP15_64_ISS_DIR_READ: u32 = 1;
pub const ESR_ELx_CP15_64_ISS_DIR_WRITE: u32 = 0;
pub const ESR_ELx_CP15_64_ISS_RT_SHIFT: u32 = 5;
pub const ESR_ELx_CP15_64_ISS_RT2_SHIFT: u32 = 10;
pub const ESR_ELx_CP15_64_ISS_OP1_SHIFT: u32 = 16;
pub const ESR_ELx_CP15_64_ISS_CRM_SHIFT: u32 = 1;
pub const ESR_ELx_SME_ISS_SME_DISABLED: u32 = 0;
pub const ESR_ELx_SME_ISS_ILL: u32 = 1;
pub const ESR_ELx_SME_ISS_SM_DISABLED: u32 = 2;
pub const ESR_ELx_SME_ISS_ZA_DISABLED: u32 = 3;
pub const ESR_ELx_SME_ISS_ZT_DISABLED: u32 = 4;
pub const ESR_ELx_ExType_SHIFT: u32 = 20;
pub const ESR_ELx_Raddr_SHIFT: u32 = 10;
pub const ESR_ELx_Rn_SHIFT: u32 = 5;
pub const ESR_ELx_Rvalue_SHIFT: u32 = 5;
pub const ESR_ELx_IT_SHIFT: u32 = 0;
pub const ESR_ELx_ExType_DATA_CHECK: u32 = 0;
pub const ESR_ELx_ExType_EXLOCK: u32 = 1;
pub const ESR_ELx_ExType_STR: u32 = 2;
pub const ESR_ELx_IT_RET: u32 = 0;
pub const ESR_ELx_IT_GCSPOPM: u32 = 1;
pub const ESR_ELx_IT_RET_KEYA: u32 = 2;
pub const ESR_ELx_IT_RET_KEYB: u32 = 3;
pub const ESR_ELx_IT_GCSSS1: u32 = 4;
pub const ESR_ELx_IT_GCSSS2: u32 = 5;
pub const ESR_ELx_IT_GCSPOPCX: u32 = 6;
pub const ESR_ELx_IT_GCSPOPX: u32 = 7;
pub const DBG_MDSCR_SS: u32 = 1;
pub const DBG_SPSR_SS: u32 = 2097152;
pub const DBG_MDSCR_KDE: u32 = 8192;
pub const DBG_MDSCR_MDE: u32 = 32768;
pub const DBG_MDSCR_MASK: i32 = -40961;
pub const DBG_ESR_EVT_HWBP: u32 = 0;
pub const DBG_ESR_EVT_HWSS: u32 = 1;
pub const DBG_ESR_EVT_HWWP: u32 = 2;
pub const DBG_ESR_EVT_BRK: u32 = 6;
pub const BREAK_INSTR_SIZE: u32 = 4;
pub const AARCH64_BREAK_KGDB_DYN_DBG: u32 = 3558899712;
pub const CACHE_FLUSH_IS_SAFE: u32 = 1;
pub const BRK64_OPCODE_KPROBES: u32 = 3558867072;
pub const BRK64_OPCODE_KPROBES_SS: u32 = 3558867136;
pub const BRK64_OPCODE_UPROBES: u32 = 3558867104;
pub const DBG_ESR_EVT_BKPT: u32 = 4;
pub const DBG_ESR_EVT_VECC: u32 = 5;
pub const AARCH32_BREAK_ARM: u32 = 133169648;
pub const AARCH32_BREAK_THUMB: u32 = 56833;
pub const AARCH32_BREAK_THUMB2_LO: u32 = 63472;
pub const AARCH32_BREAK_THUMB2_HI: u32 = 40960;
pub const DBG_ARCH_ID_RESERVED: u32 = 0;
pub const DBG_HOOK_HANDLED: u32 = 0;
pub const DBG_HOOK_ERROR: u32 = 1;
pub const UPROBE_SWBP_INSN_SIZE: u32 = 4;
pub const UPROBE_XOL_SLOT_BYTES: u32 = 4;
pub const MMCF_AARCH32: u32 = 1;
pub const USER_ASID_BIT: u32 = 48;
pub const AT_VECTOR_SIZE: u32 = 50;
pub const INIT_PASID: u32 = 0;
pub const ENCODED_PAGE_BITS: u32 = 3;
pub const ENCODED_PAGE_BIT_DELAY_RMAP: u32 = 1;
pub const ENCODED_PAGE_BIT_NR_PAGES_NEXT: u32 = 2;
pub const MM_ID_DUMMY: u32 = 0;
pub const MM_ID_MIN: u32 = 1;
pub const VMA_LOCK_OFFSET: u32 = 1073741824;
pub const VMA_REF_LIMIT: u32 = 1073741823;
pub const MM_MT_FLAGS: u32 = 771;
pub const MMF_DUMPABLE_BITS: u32 = 2;
pub const MMF_DUMPABLE_MASK: u32 = 3;
pub const MMF_DUMP_ANON_PRIVATE: u32 = 2;
pub const MMF_DUMP_ANON_SHARED: u32 = 3;
pub const MMF_DUMP_MAPPED_PRIVATE: u32 = 4;
pub const MMF_DUMP_MAPPED_SHARED: u32 = 5;
pub const MMF_DUMP_ELF_HEADERS: u32 = 6;
pub const MMF_DUMP_HUGETLB_PRIVATE: u32 = 7;
pub const MMF_DUMP_HUGETLB_SHARED: u32 = 8;
pub const MMF_DUMP_DAX_PRIVATE: u32 = 9;
pub const MMF_DUMP_DAX_SHARED: u32 = 10;
pub const MMF_DUMP_FILTER_SHIFT: u32 = 2;
pub const MMF_DUMP_FILTER_BITS: u32 = 9;
pub const MMF_DUMP_FILTER_MASK: u32 = 2044;
pub const MMF_DUMP_MASK_DEFAULT_ELF: u32 = 64;
pub const MMF_VM_MERGEABLE: u32 = 16;
pub const MMF_VM_HUGEPAGE: u32 = 17;
pub const MMF_HAS_UPROBES: u32 = 19;
pub const MMF_RECALC_UPROBES: u32 = 20;
pub const MMF_OOM_SKIP: u32 = 21;
pub const MMF_UNSTABLE: u32 = 22;
pub const MMF_HUGE_ZERO_PAGE: u32 = 23;
pub const MMF_DISABLE_THP: u32 = 24;
pub const MMF_DISABLE_THP_MASK: u32 = 16777216;
pub const MMF_OOM_REAP_QUEUED: u32 = 25;
pub const MMF_MULTIPROCESS: u32 = 26;
pub const MMF_HAS_PINNED: u32 = 27;
pub const MMF_HAS_MDWE: u32 = 28;
pub const MMF_HAS_MDWE_MASK: u32 = 268435456;
pub const MMF_HAS_MDWE_NO_INHERIT: u32 = 29;
pub const MMF_VM_MERGE_ANY: u32 = 30;
pub const MMF_VM_MERGE_ANY_MASK: u32 = 1073741824;
pub const MMF_TOPDOWN: u32 = 31;
pub const MMF_TOPDOWN_MASK: u32 = 2147483648;
pub const MMF_INIT_MASK: u32 = 3506440191;
pub const PAGEFLAGS_MASK: u32 = 67108863;
pub const PAGE_POISON_PATTERN: i32 = -1;
pub const FOLIO_PF_ANY: u32 = 0;
pub const FOLIO_PF_HEAD: u32 = 0;
pub const FOLIO_PF_NO_TAIL: u32 = 0;
pub const FOLIO_PF_NO_COMPOUND: u32 = 0;
pub const FOLIO_PF_SECOND: u32 = 1;
pub const FOLIO_HEAD_PAGE: u32 = 0;
pub const FOLIO_SECOND_PAGE: u32 = 1;
pub const PAGE_MAPPING_ANON: u32 = 1;
pub const PAGE_MAPPING_MOVABLE: u32 = 2;
pub const PAGE_MAPPING_KSM: u32 = 3;
pub const PAGE_MAPPING_FLAGS: u32 = 3;
pub const MAX_PAGE_ORDER: u32 = 10;
pub const MAX_ORDER_NR_PAGES: u32 = 1024;
pub const NR_PAGE_ORDERS: u32 = 11;
pub const PAGE_ALLOC_COSTLY_ORDER: u32 = 3;
pub const MIGRATETYPE_MASK: u32 = 7;
pub const LRU_BASE: u32 = 0;
pub const LRU_ACTIVE: u32 = 1;
pub const LRU_FILE: u32 = 2;
pub const WORKINGSET_ANON: u32 = 0;
pub const WORKINGSET_FILE: u32 = 1;
pub const ANON_AND_FILE: u32 = 2;
pub const MIN_NR_GENS: u32 = 2;
pub const MAX_NR_GENS: u32 = 4;
pub const MAX_NR_TIERS: u32 = 4;
pub const MIN_LRU_BATCH: u32 = 64;
pub const MAX_LRU_BATCH: u32 = 4096;
pub const NR_HIST_GENS: u32 = 1;
pub const NR_BLOOM_FILTERS: u32 = 2;
pub const MEMCG_NR_GENS: u32 = 3;
pub const MEMCG_NR_BINS: u32 = 8;
pub const NR_PCP_THP: u32 = 2;
pub const ASYNC_AND_SYNC: u32 = 2;
pub const ZONEID_SHIFT: u32 = 12;
pub const ZONES_MASK: u32 = 7;
pub const NODES_MASK: u32 = 511;
pub const SECTIONS_MASK: u32 = 0;
pub const LAST_CPUPID_MASK: u32 = 1048575;
pub const KASAN_TAG_MASK: u32 = 0;
pub const ZONEID_MASK: u32 = 4095;
pub const DEF_PRIORITY: u32 = 12;
pub const MAX_ZONES_PER_ZONELIST: u32 = 2560;
pub const RCU_DONE_TAIL: u32 = 0;
pub const RCU_WAIT_TAIL: u32 = 1;
pub const RCU_NEXT_READY_TAIL: u32 = 2;
pub const RCU_NEXT_TAIL: u32 = 3;
pub const RCU_CBLIST_NSEGS: u32 = 4;
pub const SRCU_READ_FLAVOR_NORMAL: u32 = 1;
pub const SRCU_READ_FLAVOR_NMI: u32 = 2;
pub const SRCU_READ_FLAVOR_LITE: u32 = 4;
pub const SRCU_READ_FLAVOR_FAST: u32 = 8;
pub const SRCU_READ_FLAVOR_ALL: u32 = 15;
pub const SRCU_READ_FLAVOR_SLOWGP: u32 = 12;
pub const RCU_FANOUT: u32 = 64;
pub const RCU_FANOUT_LEAF: u32 = 16;
pub const RCU_FANOUT_1: u32 = 16;
pub const RCU_FANOUT_2: u32 = 1024;
pub const RCU_FANOUT_3: u32 = 65536;
pub const RCU_FANOUT_4: u32 = 4194304;
pub const RCU_NUM_LVLS: u32 = 3;
pub const NUM_RCU_LVL_0: u32 = 1;
pub const SRCU_SIZE_SMALL: u32 = 0;
pub const SRCU_SIZE_ALLOC: u32 = 1;
pub const SRCU_SIZE_WAIT_BARRIER: u32 = 2;
pub const SRCU_SIZE_WAIT_CALL: u32 = 3;
pub const SRCU_SIZE_WAIT_CBS1: u32 = 4;
pub const SRCU_SIZE_WAIT_CBS2: u32 = 5;
pub const SRCU_SIZE_WAIT_CBS3: u32 = 6;
pub const SRCU_SIZE_WAIT_CBS4: u32 = 7;
pub const SRCU_SIZE_BIG: u32 = 8;
pub const SRCU_STATE_IDLE: u32 = 0;
pub const SRCU_STATE_SCAN1: u32 = 1;
pub const SRCU_STATE_SCAN2: u32 = 2;
pub const SRCU_GP_SEQ_INITIAL_VAL: i32 = -400;
pub const SRCU_GP_SEQ_INITIAL_VAL_WITH_STATE: i32 = -401;
pub const SRCU_GET_STATE_COMPLETED: u32 = 1;
pub const NUM_ACTIVE_SRCU_POLL_OLDSTATE: u32 = 2;
pub const NOTIFY_DONE: u32 = 0;
pub const NOTIFY_OK: u32 = 1;
pub const NOTIFY_STOP_MASK: u32 = 32768;
pub const NOTIFY_BAD: u32 = 32770;
pub const NOTIFY_STOP: u32 = 32769;
pub const NETLINK_URELEASE: u32 = 1;
pub const KBD_KEYCODE: u32 = 1;
pub const KBD_UNBOUND_KEYCODE: u32 = 2;
pub const KBD_UNICODE: u32 = 3;
pub const KBD_KEYSYM: u32 = 4;
pub const KBD_POST_KEYSYM: u32 = 5;
pub const PA_SECTION_SHIFT: u32 = 27;
pub const PFN_SECTION_SHIFT: u32 = 15;
pub const NR_MEM_SECTIONS: u32 = 2097152;
pub const PAGES_PER_SECTION: u32 = 32768;
pub const PAGE_SECTION_MASK: i32 = -32768;
pub const SUBSECTION_SHIFT: u32 = 21;
pub const SUBSECTION_SIZE: u32 = 2097152;
pub const PFN_SUBSECTION_SHIFT: u32 = 9;
pub const PAGES_PER_SUBSECTION: u32 = 512;
pub const PAGE_SUBSECTION_MASK: i32 = -512;
pub const SUBSECTIONS_PER_SECTION: u32 = 64;
pub const NR_NODE_MEMBLKS: u32 = 1024;
pub const LOCAL_DISTANCE: u32 = 10;
pub const REMOTE_DISTANCE: u32 = 20;
pub const DISTANCE_BITS: u32 = 8;
pub const RECLAIM_DISTANCE: u32 = 30;
pub const PENALTY_FOR_NODE_WITH_CPUS: u32 = 1;
pub const GFP_MOVABLE_SHIFT: u32 = 3;
pub const GFP_ZONES_SHIFT: u32 = 2;
pub const CTL_MAXNAME: u32 = 10;
pub const UMH_NO_WAIT: u32 = 0;
pub const UMH_WAIT_EXEC: u32 = 1;
pub const UMH_WAIT_PROC: u32 = 2;
pub const UMH_KILLABLE: u32 = 4;
pub const UMH_FREEZABLE: u32 = 8;
pub const KMOD_PATH_LEN: u32 = 256;
pub const R_ARM_NONE: u32 = 0;
pub const R_AARCH64_NONE: u32 = 256;
pub const R_AARCH64_ABS64: u32 = 257;
pub const R_AARCH64_ABS32: u32 = 258;
pub const R_AARCH64_ABS16: u32 = 259;
pub const R_AARCH64_PREL64: u32 = 260;
pub const R_AARCH64_PREL32: u32 = 261;
pub const R_AARCH64_PREL16: u32 = 262;
pub const R_AARCH64_MOVW_UABS_G0: u32 = 263;
pub const R_AARCH64_MOVW_UABS_G0_NC: u32 = 264;
pub const R_AARCH64_MOVW_UABS_G1: u32 = 265;
pub const R_AARCH64_MOVW_UABS_G1_NC: u32 = 266;
pub const R_AARCH64_MOVW_UABS_G2: u32 = 267;
pub const R_AARCH64_MOVW_UABS_G2_NC: u32 = 268;
pub const R_AARCH64_MOVW_UABS_G3: u32 = 269;
pub const R_AARCH64_MOVW_SABS_G0: u32 = 270;
pub const R_AARCH64_MOVW_SABS_G1: u32 = 271;
pub const R_AARCH64_MOVW_SABS_G2: u32 = 272;
pub const R_AARCH64_LD_PREL_LO19: u32 = 273;
pub const R_AARCH64_ADR_PREL_LO21: u32 = 274;
pub const R_AARCH64_ADR_PREL_PG_HI21: u32 = 275;
pub const R_AARCH64_ADR_PREL_PG_HI21_NC: u32 = 276;
pub const R_AARCH64_ADD_ABS_LO12_NC: u32 = 277;
pub const R_AARCH64_LDST8_ABS_LO12_NC: u32 = 278;
pub const R_AARCH64_TSTBR14: u32 = 279;
pub const R_AARCH64_CONDBR19: u32 = 280;
pub const R_AARCH64_JUMP26: u32 = 282;
pub const R_AARCH64_CALL26: u32 = 283;
pub const R_AARCH64_LDST16_ABS_LO12_NC: u32 = 284;
pub const R_AARCH64_LDST32_ABS_LO12_NC: u32 = 285;
pub const R_AARCH64_LDST64_ABS_LO12_NC: u32 = 286;
pub const R_AARCH64_LDST128_ABS_LO12_NC: u32 = 299;
pub const R_AARCH64_MOVW_PREL_G0: u32 = 287;
pub const R_AARCH64_MOVW_PREL_G0_NC: u32 = 288;
pub const R_AARCH64_MOVW_PREL_G1: u32 = 289;
pub const R_AARCH64_MOVW_PREL_G1_NC: u32 = 290;
pub const R_AARCH64_MOVW_PREL_G2: u32 = 291;
pub const R_AARCH64_MOVW_PREL_G2_NC: u32 = 292;
pub const R_AARCH64_MOVW_PREL_G3: u32 = 293;
pub const R_AARCH64_RELATIVE: u32 = 1027;
pub const ELF_PLATFORM_SIZE: u32 = 16;
pub const ELF_PLATFORM: &[u8; 8] = b"aarch64\0";
pub const EM_NONE: u32 = 0;
pub const EM_M32: u32 = 1;
pub const EM_SPARC: u32 = 2;
pub const EM_386: u32 = 3;
pub const EM_68K: u32 = 4;
pub const EM_88K: u32 = 5;
pub const EM_486: u32 = 6;
pub const EM_860: u32 = 7;
pub const EM_MIPS: u32 = 8;
pub const EM_MIPS_RS3_LE: u32 = 10;
pub const EM_MIPS_RS4_BE: u32 = 10;
pub const EM_PARISC: u32 = 15;
pub const EM_SPARC32PLUS: u32 = 18;
pub const EM_PPC: u32 = 20;
pub const EM_PPC64: u32 = 21;
pub const EM_SPU: u32 = 23;
pub const EM_ARM: u32 = 40;
pub const EM_SH: u32 = 42;
pub const EM_SPARCV9: u32 = 43;
pub const EM_H8_300: u32 = 46;
pub const EM_IA_64: u32 = 50;
pub const EM_X86_64: u32 = 62;
pub const EM_S390: u32 = 22;
pub const EM_CRIS: u32 = 76;
pub const EM_M32R: u32 = 88;
pub const EM_MN10300: u32 = 89;
pub const EM_OPENRISC: u32 = 92;
pub const EM_ARCOMPACT: u32 = 93;
pub const EM_XTENSA: u32 = 94;
pub const EM_BLACKFIN: u32 = 106;
pub const EM_UNICORE: u32 = 110;
pub const EM_ALTERA_NIOS2: u32 = 113;
pub const EM_TI_C6000: u32 = 140;
pub const EM_HEXAGON: u32 = 164;
pub const EM_NDS32: u32 = 167;
pub const EM_AARCH64: u32 = 183;
pub const EM_TILEPRO: u32 = 188;
pub const EM_MICROBLAZE: u32 = 189;
pub const EM_TILEGX: u32 = 191;
pub const EM_ARCV2: u32 = 195;
pub const EM_RISCV: u32 = 243;
pub const EM_BPF: u32 = 247;
pub const EM_CSKY: u32 = 252;
pub const EM_LOONGARCH: u32 = 258;
pub const EM_FRV: u32 = 21569;
pub const EM_ALPHA: u32 = 36902;
pub const EM_CYGNUS_M32R: u32 = 36929;
pub const EM_S390_OLD: u32 = 41872;
pub const EM_CYGNUS_MN10300: u32 = 48879;
pub const PT_NULL: u32 = 0;
pub const PT_LOAD: u32 = 1;
pub const PT_DYNAMIC: u32 = 2;
pub const PT_INTERP: u32 = 3;
pub const PT_NOTE: u32 = 4;
pub const PT_SHLIB: u32 = 5;
pub const PT_PHDR: u32 = 6;
pub const PT_TLS: u32 = 7;
pub const PT_LOOS: u32 = 1610612736;
pub const PT_HIOS: u32 = 1879048191;
pub const PT_LOPROC: u32 = 1879048192;
pub const PT_HIPROC: u32 = 2147483647;
pub const PT_GNU_EH_FRAME: u32 = 1685382480;
pub const PT_GNU_STACK: u32 = 1685382481;
pub const PT_GNU_RELRO: u32 = 1685382482;
pub const PT_GNU_PROPERTY: u32 = 1685382483;
pub const PT_AARCH64_MEMTAG_MTE: u32 = 1879048194;
pub const PN_XNUM: u32 = 65535;
pub const ET_NONE: u32 = 0;
pub const ET_REL: u32 = 1;
pub const ET_EXEC: u32 = 2;
pub const ET_DYN: u32 = 3;
pub const ET_CORE: u32 = 4;
pub const ET_LOPROC: u32 = 65280;
pub const ET_HIPROC: u32 = 65535;
pub const DT_NULL: u32 = 0;
pub const DT_NEEDED: u32 = 1;
pub const DT_PLTRELSZ: u32 = 2;
pub const DT_PLTGOT: u32 = 3;
pub const DT_HASH: u32 = 4;
pub const DT_STRTAB: u32 = 5;
pub const DT_SYMTAB: u32 = 6;
pub const DT_RELA: u32 = 7;
pub const DT_RELASZ: u32 = 8;
pub const DT_RELAENT: u32 = 9;
pub const DT_STRSZ: u32 = 10;
pub const DT_SYMENT: u32 = 11;
pub const DT_INIT: u32 = 12;
pub const DT_FINI: u32 = 13;
pub const DT_SONAME: u32 = 14;
pub const DT_RPATH: u32 = 15;
pub const DT_SYMBOLIC: u32 = 16;
pub const DT_REL: u32 = 17;
pub const DT_RELSZ: u32 = 18;
pub const DT_RELENT: u32 = 19;
pub const DT_PLTREL: u32 = 20;
pub const DT_DEBUG: u32 = 21;
pub const DT_TEXTREL: u32 = 22;
pub const DT_JMPREL: u32 = 23;
pub const DT_ENCODING: u32 = 32;
pub const OLD_DT_LOOS: u32 = 1610612736;
pub const DT_LOOS: u32 = 1610612749;
pub const DT_HIOS: u32 = 1879044096;
pub const DT_VALRNGLO: u32 = 1879047424;
pub const DT_VALRNGHI: u32 = 1879047679;
pub const DT_ADDRRNGLO: u32 = 1879047680;
pub const DT_GNU_HASH: u32 = 1879047925;
pub const DT_ADDRRNGHI: u32 = 1879047935;
pub const DT_VERSYM: u32 = 1879048176;
pub const DT_RELACOUNT: u32 = 1879048185;
pub const DT_RELCOUNT: u32 = 1879048186;
pub const DT_FLAGS_1: u32 = 1879048187;
pub const DT_VERDEF: u32 = 1879048188;
pub const DT_VERDEFNUM: u32 = 1879048189;
pub const DT_VERNEED: u32 = 1879048190;
pub const DT_VERNEEDNUM: u32 = 1879048191;
pub const OLD_DT_HIOS: u32 = 1879048191;
pub const DT_LOPROC: u32 = 1879048192;
pub const DT_HIPROC: u32 = 2147483647;
pub const STB_LOCAL: u32 = 0;
pub const STB_GLOBAL: u32 = 1;
pub const STB_WEAK: u32 = 2;
pub const STN_UNDEF: u32 = 0;
pub const STT_NOTYPE: u32 = 0;
pub const STT_OBJECT: u32 = 1;
pub const STT_FUNC: u32 = 2;
pub const STT_SECTION: u32 = 3;
pub const STT_FILE: u32 = 4;
pub const STT_COMMON: u32 = 5;
pub const STT_TLS: u32 = 6;
pub const VER_FLG_BASE: u32 = 1;
pub const VER_FLG_WEAK: u32 = 2;
pub const EI_NIDENT: u32 = 16;
pub const PF_R: u32 = 4;
pub const PF_W: u32 = 2;
pub const PF_X: u32 = 1;
pub const SHT_NULL: u32 = 0;
pub const SHT_PROGBITS: u32 = 1;
pub const SHT_SYMTAB: u32 = 2;
pub const SHT_STRTAB: u32 = 3;
pub const SHT_RELA: u32 = 4;
pub const SHT_HASH: u32 = 5;
pub const SHT_DYNAMIC: u32 = 6;
pub const SHT_NOTE: u32 = 7;
pub const SHT_NOBITS: u32 = 8;
pub const SHT_REL: u32 = 9;
pub const SHT_SHLIB: u32 = 10;
pub const SHT_DYNSYM: u32 = 11;
pub const SHT_NUM: u32 = 12;
pub const SHT_LOPROC: u32 = 1879048192;
pub const SHT_HIPROC: u32 = 2147483647;
pub const SHT_LOUSER: u32 = 2147483648;
pub const SHT_HIUSER: u32 = 4294967295;
pub const SHF_WRITE: u32 = 1;
pub const SHF_ALLOC: u32 = 2;
pub const SHF_EXECINSTR: u32 = 4;
pub const SHF_MERGE: u32 = 16;
pub const SHF_STRINGS: u32 = 32;
pub const SHF_INFO_LINK: u32 = 64;
pub const SHF_LINK_ORDER: u32 = 128;
pub const SHF_OS_NONCONFORMING: u32 = 256;
pub const SHF_GROUP: u32 = 512;
pub const SHF_TLS: u32 = 1024;
pub const SHF_RELA_LIVEPATCH: u32 = 1048576;
pub const SHF_RO_AFTER_INIT: u32 = 2097152;
pub const SHF_ORDERED: u32 = 67108864;
pub const SHF_EXCLUDE: u32 = 134217728;
pub const SHF_MASKOS: u32 = 267386880;
pub const SHF_MASKPROC: u32 = 4026531840;
pub const SHN_UNDEF: u32 = 0;
pub const SHN_LORESERVE: u32 = 65280;
pub const SHN_LOPROC: u32 = 65280;
pub const SHN_HIPROC: u32 = 65311;
pub const SHN_LIVEPATCH: u32 = 65312;
pub const SHN_ABS: u32 = 65521;
pub const SHN_COMMON: u32 = 65522;
pub const SHN_HIRESERVE: u32 = 65535;
pub const EI_MAG0: u32 = 0;
pub const EI_MAG1: u32 = 1;
pub const EI_MAG2: u32 = 2;
pub const EI_MAG3: u32 = 3;
pub const EI_CLASS: u32 = 4;
pub const EI_DATA: u32 = 5;
pub const EI_VERSION: u32 = 6;
pub const EI_OSABI: u32 = 7;
pub const EI_PAD: u32 = 8;
pub const ELFMAG0: u32 = 127;
pub const ELFMAG1: u8 = 69u8;
pub const ELFMAG2: u8 = 76u8;
pub const ELFMAG3: u8 = 70u8;
pub const ELFMAG: &[u8; 5] = b"\x7FELF\0";
pub const SELFMAG: u32 = 4;
pub const ELFCLASSNONE: u32 = 0;
pub const ELFCLASS32: u32 = 1;
pub const ELFCLASS64: u32 = 2;
pub const ELFCLASSNUM: u32 = 3;
pub const ELFDATANONE: u32 = 0;
pub const ELFDATA2LSB: u32 = 1;
pub const ELFDATA2MSB: u32 = 2;
pub const EV_NONE: u32 = 0;
pub const EV_CURRENT: u32 = 1;
pub const EV_NUM: u32 = 2;
pub const ELFOSABI_NONE: u32 = 0;
pub const ELFOSABI_LINUX: u32 = 3;
pub const ELF_OSABI: u32 = 0;
pub const NN_GNU_PROPERTY_TYPE_0: &[u8; 4] = b"GNU\0";
pub const NT_GNU_PROPERTY_TYPE_0: u32 = 5;
pub const NN_PRSTATUS: &[u8; 5] = b"CORE\0";
pub const NT_PRSTATUS: u32 = 1;
pub const NN_PRFPREG: &[u8; 5] = b"CORE\0";
pub const NT_PRFPREG: u32 = 2;
pub const NN_PRPSINFO: &[u8; 5] = b"CORE\0";
pub const NT_PRPSINFO: u32 = 3;
pub const NN_TASKSTRUCT: &[u8; 5] = b"CORE\0";
pub const NT_TASKSTRUCT: u32 = 4;
pub const NN_AUXV: &[u8; 5] = b"CORE\0";
pub const NT_AUXV: u32 = 6;
pub const NN_SIGINFO: &[u8; 5] = b"CORE\0";
pub const NT_SIGINFO: u32 = 1397311305;
pub const NN_FILE: &[u8; 5] = b"CORE\0";
pub const NT_FILE: u32 = 1179208773;
pub const NN_PRXFPREG: &[u8; 6] = b"LINUX\0";
pub const NT_PRXFPREG: u32 = 1189489535;
pub const NN_PPC_VMX: &[u8; 6] = b"LINUX\0";
pub const NT_PPC_VMX: u32 = 256;
pub const NN_PPC_SPE: &[u8; 6] = b"LINUX\0";
pub const NT_PPC_SPE: u32 = 257;
pub const NN_PPC_VSX: &[u8; 6] = b"LINUX\0";
pub const NT_PPC_VSX: u32 = 258;
pub const NN_PPC_TAR: &[u8; 6] = b"LINUX\0";
pub const NT_PPC_TAR: u32 = 259;
pub const NN_PPC_PPR: &[u8; 6] = b"LINUX\0";
pub const NT_PPC_PPR: u32 = 260;
pub const NN_PPC_DSCR: &[u8; 6] = b"LINUX\0";
pub const NT_PPC_DSCR: u32 = 261;
pub const NN_PPC_EBB: &[u8; 6] = b"LINUX\0";
pub const NT_PPC_EBB: u32 = 262;
pub const NN_PPC_PMU: &[u8; 6] = b"LINUX\0";
pub const NT_PPC_PMU: u32 = 263;
pub const NN_PPC_TM_CGPR: &[u8; 6] = b"LINUX\0";
pub const NT_PPC_TM_CGPR: u32 = 264;
pub const NN_PPC_TM_CFPR: &[u8; 6] = b"LINUX\0";
pub const NT_PPC_TM_CFPR: u32 = 265;
pub const NN_PPC_TM_CVMX: &[u8; 6] = b"LINUX\0";
pub const NT_PPC_TM_CVMX: u32 = 266;
pub const NN_PPC_TM_CVSX: &[u8; 6] = b"LINUX\0";
pub const NT_PPC_TM_CVSX: u32 = 267;
pub const NN_PPC_TM_SPR: &[u8; 6] = b"LINUX\0";
pub const NT_PPC_TM_SPR: u32 = 268;
pub const NN_PPC_TM_CTAR: &[u8; 6] = b"LINUX\0";
pub const NT_PPC_TM_CTAR: u32 = 269;
pub const NN_PPC_TM_CPPR: &[u8; 6] = b"LINUX\0";
pub const NT_PPC_TM_CPPR: u32 = 270;
pub const NN_PPC_TM_CDSCR: &[u8; 6] = b"LINUX\0";
pub const NT_PPC_TM_CDSCR: u32 = 271;
pub const NN_PPC_PKEY: &[u8; 6] = b"LINUX\0";
pub const NT_PPC_PKEY: u32 = 272;
pub const NN_PPC_DEXCR: &[u8; 6] = b"LINUX\0";
pub const NT_PPC_DEXCR: u32 = 273;
pub const NN_PPC_HASHKEYR: &[u8; 6] = b"LINUX\0";
pub const NT_PPC_HASHKEYR: u32 = 274;
pub const NN_386_TLS: &[u8; 6] = b"LINUX\0";
pub const NT_386_TLS: u32 = 512;
pub const NN_386_IOPERM: &[u8; 6] = b"LINUX\0";
pub const NT_386_IOPERM: u32 = 513;
pub const NN_X86_XSTATE: &[u8; 6] = b"LINUX\0";
pub const NT_X86_XSTATE: u32 = 514;
pub const NN_X86_SHSTK: &[u8; 6] = b"LINUX\0";
pub const NT_X86_SHSTK: u32 = 516;
pub const NN_X86_XSAVE_LAYOUT: &[u8; 6] = b"LINUX\0";
pub const NT_X86_XSAVE_LAYOUT: u32 = 517;
pub const NN_S390_HIGH_GPRS: &[u8; 6] = b"LINUX\0";
pub const NT_S390_HIGH_GPRS: u32 = 768;
pub const NN_S390_TIMER: &[u8; 6] = b"LINUX\0";
pub const NT_S390_TIMER: u32 = 769;
pub const NN_S390_TODCMP: &[u8; 6] = b"LINUX\0";
pub const NT_S390_TODCMP: u32 = 770;
pub const NN_S390_TODPREG: &[u8; 6] = b"LINUX\0";
pub const NT_S390_TODPREG: u32 = 771;
pub const NN_S390_CTRS: &[u8; 6] = b"LINUX\0";
pub const NT_S390_CTRS: u32 = 772;
pub const NN_S390_PREFIX: &[u8; 6] = b"LINUX\0";
pub const NT_S390_PREFIX: u32 = 773;
pub const NN_S390_LAST_BREAK: &[u8; 6] = b"LINUX\0";
pub const NT_S390_LAST_BREAK: u32 = 774;
pub const NN_S390_SYSTEM_CALL: &[u8; 6] = b"LINUX\0";
pub const NT_S390_SYSTEM_CALL: u32 = 775;
pub const NN_S390_TDB: &[u8; 6] = b"LINUX\0";
pub const NT_S390_TDB: u32 = 776;
pub const NN_S390_VXRS_LOW: &[u8; 6] = b"LINUX\0";
pub const NT_S390_VXRS_LOW: u32 = 777;
pub const NN_S390_VXRS_HIGH: &[u8; 6] = b"LINUX\0";
pub const NT_S390_VXRS_HIGH: u32 = 778;
pub const NN_S390_GS_CB: &[u8; 6] = b"LINUX\0";
pub const NT_S390_GS_CB: u32 = 779;
pub const NN_S390_GS_BC: &[u8; 6] = b"LINUX\0";
pub const NT_S390_GS_BC: u32 = 780;
pub const NN_S390_RI_CB: &[u8; 6] = b"LINUX\0";
pub const NT_S390_RI_CB: u32 = 781;
pub const NN_S390_PV_CPU_DATA: &[u8; 6] = b"LINUX\0";
pub const NT_S390_PV_CPU_DATA: u32 = 782;
pub const NN_ARM_VFP: &[u8; 6] = b"LINUX\0";
pub const NT_ARM_VFP: u32 = 1024;
pub const NN_ARM_TLS: &[u8; 6] = b"LINUX\0";
pub const NT_ARM_TLS: u32 = 1025;
pub const NN_ARM_HW_BREAK: &[u8; 6] = b"LINUX\0";
pub const NT_ARM_HW_BREAK: u32 = 1026;
pub const NN_ARM_HW_WATCH: &[u8; 6] = b"LINUX\0";
pub const NT_ARM_HW_WATCH: u32 = 1027;
pub const NN_ARM_SYSTEM_CALL: &[u8; 6] = b"LINUX\0";
pub const NT_ARM_SYSTEM_CALL: u32 = 1028;
pub const NN_ARM_SVE: &[u8; 6] = b"LINUX\0";
pub const NT_ARM_SVE: u32 = 1029;
pub const NN_ARM_PAC_MASK: &[u8; 6] = b"LINUX\0";
pub const NT_ARM_PAC_MASK: u32 = 1030;
pub const NN_ARM_PACA_KEYS: &[u8; 6] = b"LINUX\0";
pub const NT_ARM_PACA_KEYS: u32 = 1031;
pub const NN_ARM_PACG_KEYS: &[u8; 6] = b"LINUX\0";
pub const NT_ARM_PACG_KEYS: u32 = 1032;
pub const NN_ARM_TAGGED_ADDR_CTRL: &[u8; 6] = b"LINUX\0";
pub const NT_ARM_TAGGED_ADDR_CTRL: u32 = 1033;
pub const NN_ARM_PAC_ENABLED_KEYS: &[u8; 6] = b"LINUX\0";
pub const NT_ARM_PAC_ENABLED_KEYS: u32 = 1034;
pub const NN_ARM_SSVE: &[u8; 6] = b"LINUX\0";
pub const NT_ARM_SSVE: u32 = 1035;
pub const NN_ARM_ZA: &[u8; 6] = b"LINUX\0";
pub const NT_ARM_ZA: u32 = 1036;
pub const NN_ARM_ZT: &[u8; 6] = b"LINUX\0";
pub const NT_ARM_ZT: u32 = 1037;
pub const NN_ARM_FPMR: &[u8; 6] = b"LINUX\0";
pub const NT_ARM_FPMR: u32 = 1038;
pub const NN_ARM_POE: &[u8; 6] = b"LINUX\0";
pub const NT_ARM_POE: u32 = 1039;
pub const NN_ARM_GCS: &[u8; 6] = b"LINUX\0";
pub const NT_ARM_GCS: u32 = 1040;
pub const NN_ARC_V2: &[u8; 6] = b"LINUX\0";
pub const NT_ARC_V2: u32 = 1536;
pub const NN_VMCOREDD: &[u8; 6] = b"LINUX\0";
pub const NT_VMCOREDD: u32 = 1792;
pub const NN_MIPS_DSP: &[u8; 6] = b"LINUX\0";
pub const NT_MIPS_DSP: u32 = 2048;
pub const NN_MIPS_FP_MODE: &[u8; 6] = b"LINUX\0";
pub const NT_MIPS_FP_MODE: u32 = 2049;
pub const NN_MIPS_MSA: &[u8; 6] = b"LINUX\0";
pub const NT_MIPS_MSA: u32 = 2050;
pub const NN_RISCV_CSR: &[u8; 6] = b"LINUX\0";
pub const NT_RISCV_CSR: u32 = 2304;
pub const NN_RISCV_VECTOR: &[u8; 6] = b"LINUX\0";
pub const NT_RISCV_VECTOR: u32 = 2305;
pub const NN_RISCV_TAGGED_ADDR_CTRL: &[u8; 6] = b"LINUX\0";
pub const NT_RISCV_TAGGED_ADDR_CTRL: u32 = 2306;
pub const NN_LOONGARCH_CPUCFG: &[u8; 6] = b"LINUX\0";
pub const NT_LOONGARCH_CPUCFG: u32 = 2560;
pub const NN_LOONGARCH_CSR: &[u8; 6] = b"LINUX\0";
pub const NT_LOONGARCH_CSR: u32 = 2561;
pub const NN_LOONGARCH_LSX: &[u8; 6] = b"LINUX\0";
pub const NT_LOONGARCH_LSX: u32 = 2562;
pub const NN_LOONGARCH_LASX: &[u8; 6] = b"LINUX\0";
pub const NT_LOONGARCH_LASX: u32 = 2563;
pub const NN_LOONGARCH_LBT: &[u8; 6] = b"LINUX\0";
pub const NT_LOONGARCH_LBT: u32 = 2564;
pub const NN_LOONGARCH_HW_BREAK: &[u8; 6] = b"LINUX\0";
pub const NT_LOONGARCH_HW_BREAK: u32 = 2565;
pub const NN_LOONGARCH_HW_WATCH: &[u8; 6] = b"LINUX\0";
pub const NT_LOONGARCH_HW_WATCH: u32 = 2566;
pub const GNU_PROPERTY_AARCH64_FEATURE_1_AND: u32 = 3221225472;
pub const GNU_PROPERTY_AARCH64_FEATURE_1_BTI: u32 = 1;
pub const LINUX_VFS_DEBUG_H: u32 = 1;
pub const MINORBITS: u32 = 20;
pub const MINORMASK: u32 = 1048575;
pub const LIST_BL_LOCKMASK: u32 = 1;
pub const GOLDEN_RATIO_32: u32 = 1640531527;
pub const GOLDEN_RATIO_64: u64 = 7046029254386353131;
pub const DNAME_INLINE_WORDS: u32 = 5;
pub const SHRINKER_UNIT_BITS: u32 = 64;
pub const SHRINK_STOP: i32 = -1;
pub const SHRINK_EMPTY: i32 = -2;
pub const DEFAULT_SEEKS: u32 = 2;
pub const SUID_DUMP_DISABLE: u32 = 0;
pub const SUID_DUMP_USER: u32 = 1;
pub const SUID_DUMP_ROOT: u32 = 2;
pub const BITS_PER_XA_VALUE: u32 = 63;
pub const XA_MAX_MARKS: u32 = 3;
pub const RADIX_TREE_ENTRY_MASK: u32 = 3;
pub const RADIX_TREE_INTERNAL_NODE: u32 = 2;
pub const RADIX_TREE_MAX_TAGS: u32 = 3;
pub const RESERVED_PIDS: u32 = 300;
pub const _LINUX_CAPABILITY_VERSION_1: u32 = 429392688;
pub const _LINUX_CAPABILITY_U32S_1: u32 = 1;
pub const _LINUX_CAPABILITY_VERSION_2: u32 = 537333798;
pub const _LINUX_CAPABILITY_U32S_2: u32 = 2;
pub const _LINUX_CAPABILITY_VERSION_3: u32 = 537396514;
pub const _LINUX_CAPABILITY_U32S_3: u32 = 2;
pub const VFS_CAP_REVISION_MASK: u32 = 4278190080;
pub const VFS_CAP_REVISION_SHIFT: u32 = 24;
pub const VFS_CAP_FLAGS_MASK: i64 = -4278190081;
pub const VFS_CAP_FLAGS_EFFECTIVE: u32 = 1;
pub const VFS_CAP_REVISION_1: u32 = 16777216;
pub const VFS_CAP_U32_1: u32 = 1;
pub const VFS_CAP_REVISION_2: u32 = 33554432;
pub const VFS_CAP_U32_2: u32 = 2;
pub const VFS_CAP_REVISION_3: u32 = 50331648;
pub const VFS_CAP_U32_3: u32 = 2;
pub const VFS_CAP_U32: u32 = 2;
pub const VFS_CAP_REVISION: u32 = 50331648;
pub const CAP_CHOWN: u32 = 0;
pub const CAP_DAC_OVERRIDE: u32 = 1;
pub const CAP_DAC_READ_SEARCH: u32 = 2;
pub const CAP_FOWNER: u32 = 3;
pub const CAP_FSETID: u32 = 4;
pub const CAP_KILL: u32 = 5;
pub const CAP_SETGID: u32 = 6;
pub const CAP_SETUID: u32 = 7;
pub const CAP_SETPCAP: u32 = 8;
pub const CAP_LINUX_IMMUTABLE: u32 = 9;
pub const CAP_NET_BIND_SERVICE: u32 = 10;
pub const CAP_NET_BROADCAST: u32 = 11;
pub const CAP_NET_ADMIN: u32 = 12;
pub const CAP_NET_RAW: u32 = 13;
pub const CAP_IPC_LOCK: u32 = 14;
pub const CAP_IPC_OWNER: u32 = 15;
pub const CAP_SYS_MODULE: u32 = 16;
pub const CAP_SYS_RAWIO: u32 = 17;
pub const CAP_SYS_CHROOT: u32 = 18;
pub const CAP_SYS_PTRACE: u32 = 19;
pub const CAP_SYS_PACCT: u32 = 20;
pub const CAP_SYS_ADMIN: u32 = 21;
pub const CAP_SYS_BOOT: u32 = 22;
pub const CAP_SYS_NICE: u32 = 23;
pub const CAP_SYS_RESOURCE: u32 = 24;
pub const CAP_SYS_TIME: u32 = 25;
pub const CAP_SYS_TTY_CONFIG: u32 = 26;
pub const CAP_MKNOD: u32 = 27;
pub const CAP_LEASE: u32 = 28;
pub const CAP_AUDIT_WRITE: u32 = 29;
pub const CAP_AUDIT_CONTROL: u32 = 30;
pub const CAP_SETFCAP: u32 = 31;
pub const CAP_MAC_OVERRIDE: u32 = 32;
pub const CAP_MAC_ADMIN: u32 = 33;
pub const CAP_SYSLOG: u32 = 34;
pub const CAP_WAKE_ALARM: u32 = 35;
pub const CAP_BLOCK_SUSPEND: u32 = 36;
pub const CAP_AUDIT_READ: u32 = 37;
pub const CAP_PERFMON: u32 = 38;
pub const CAP_BPF: u32 = 39;
pub const CAP_CHECKPOINT_RESTORE: u32 = 40;
pub const CAP_LAST_CAP: u32 = 40;
pub const _KERNEL_CAPABILITY_VERSION: u32 = 537396514;
pub const O_DIRECTORY: u32 = 16384;
pub const O_NOFOLLOW: u32 = 32768;
pub const O_DIRECT: u32 = 65536;
pub const O_LARGEFILE: u32 = 131072;
pub const O_ACCMODE: u32 = 3;
pub const O_RDONLY: u32 = 0;
pub const O_WRONLY: u32 = 1;
pub const O_RDWR: u32 = 2;
pub const O_CREAT: u32 = 64;
pub const O_EXCL: u32 = 128;
pub const O_NOCTTY: u32 = 256;
pub const O_TRUNC: u32 = 512;
pub const O_APPEND: u32 = 1024;
pub const O_NONBLOCK: u32 = 2048;
pub const O_DSYNC: u32 = 4096;
pub const FASYNC: u32 = 8192;
pub const O_NOATIME: u32 = 262144;
pub const O_CLOEXEC: u32 = 524288;
pub const __O_SYNC: u32 = 1048576;
pub const O_SYNC: u32 = 1052672;
pub const O_PATH: u32 = 2097152;
pub const __O_TMPFILE: u32 = 4194304;
pub const O_TMPFILE: u32 = 4210688;
pub const O_NDELAY: u32 = 2048;
pub const F_DUPFD: u32 = 0;
pub const F_GETFD: u32 = 1;
pub const F_SETFD: u32 = 2;
pub const F_GETFL: u32 = 3;
pub const F_SETFL: u32 = 4;
pub const F_GETLK: u32 = 5;
pub const F_SETLK: u32 = 6;
pub const F_SETLKW: u32 = 7;
pub const F_SETOWN: u32 = 8;
pub const F_GETOWN: u32 = 9;
pub const F_SETSIG: u32 = 10;
pub const F_GETSIG: u32 = 11;
pub const F_GETLK64: u32 = 12;
pub const F_SETLK64: u32 = 13;
pub const F_SETLKW64: u32 = 14;
pub const F_SETOWN_EX: u32 = 15;
pub const F_GETOWN_EX: u32 = 16;
pub const F_GETOWNER_UIDS: u32 = 17;
pub const F_OFD_GETLK: u32 = 36;
pub const F_OFD_SETLK: u32 = 37;
pub const F_OFD_SETLKW: u32 = 38;
pub const F_OWNER_TID: u32 = 0;
pub const F_OWNER_PID: u32 = 1;
pub const F_OWNER_PGRP: u32 = 2;
pub const FD_CLOEXEC: u32 = 1;
pub const F_RDLCK: u32 = 0;
pub const F_WRLCK: u32 = 1;
pub const F_UNLCK: u32 = 2;
pub const F_EXLCK: u32 = 4;
pub const F_SHLCK: u32 = 8;
pub const LOCK_SH: u32 = 1;
pub const LOCK_EX: u32 = 2;
pub const LOCK_NB: u32 = 4;
pub const LOCK_UN: u32 = 8;
pub const LOCK_MAND: u32 = 32;
pub const LOCK_READ: u32 = 64;
pub const LOCK_WRITE: u32 = 128;
pub const LOCK_RW: u32 = 192;
pub const F_LINUX_SPECIFIC_BASE: u32 = 1024;
pub const RESOLVE_NO_XDEV: u32 = 1;
pub const RESOLVE_NO_MAGICLINKS: u32 = 2;
pub const RESOLVE_NO_SYMLINKS: u32 = 4;
pub const RESOLVE_BENEATH: u32 = 8;
pub const RESOLVE_IN_ROOT: u32 = 16;
pub const RESOLVE_CACHED: u32 = 32;
pub const F_SETLEASE: u32 = 1024;
pub const F_GETLEASE: u32 = 1025;
pub const F_NOTIFY: u32 = 1026;
pub const F_DUPFD_QUERY: u32 = 1027;
pub const F_CREATED_QUERY: u32 = 1028;
pub const F_CANCELLK: u32 = 1029;
pub const F_DUPFD_CLOEXEC: u32 = 1030;
pub const F_SETPIPE_SZ: u32 = 1031;
pub const F_GETPIPE_SZ: u32 = 1032;
pub const F_ADD_SEALS: u32 = 1033;
pub const F_GET_SEALS: u32 = 1034;
pub const F_SEAL_SEAL: u32 = 1;
pub const F_SEAL_SHRINK: u32 = 2;
pub const F_SEAL_GROW: u32 = 4;
pub const F_SEAL_WRITE: u32 = 8;
pub const F_SEAL_FUTURE_WRITE: u32 = 16;
pub const F_SEAL_EXEC: u32 = 32;
pub const F_GET_RW_HINT: u32 = 1035;
pub const F_SET_RW_HINT: u32 = 1036;
pub const F_GET_FILE_RW_HINT: u32 = 1037;
pub const F_SET_FILE_RW_HINT: u32 = 1038;
pub const RWH_WRITE_LIFE_NOT_SET: u32 = 0;
pub const RWH_WRITE_LIFE_NONE: u32 = 1;
pub const RWH_WRITE_LIFE_SHORT: u32 = 2;
pub const RWH_WRITE_LIFE_MEDIUM: u32 = 3;
pub const RWH_WRITE_LIFE_LONG: u32 = 4;
pub const RWH_WRITE_LIFE_EXTREME: u32 = 5;
pub const RWF_WRITE_LIFE_NOT_SET: u32 = 0;
pub const DN_ACCESS: u32 = 1;
pub const DN_MODIFY: u32 = 2;
pub const DN_CREATE: u32 = 4;
pub const DN_DELETE: u32 = 8;
pub const DN_RENAME: u32 = 16;
pub const DN_ATTRIB: u32 = 32;
pub const DN_MULTISHOT: u32 = 2147483648;
pub const AT_FDCWD: i32 = -100;
pub const AT_SYMLINK_NOFOLLOW: u32 = 256;
pub const AT_SYMLINK_FOLLOW: u32 = 1024;
pub const AT_NO_AUTOMOUNT: u32 = 2048;
pub const AT_EMPTY_PATH: u32 = 4096;
pub const AT_STATX_SYNC_TYPE: u32 = 24576;
pub const AT_STATX_SYNC_AS_STAT: u32 = 0;
pub const AT_STATX_FORCE_SYNC: u32 = 8192;
pub const AT_STATX_DONT_SYNC: u32 = 16384;
pub const AT_RECURSIVE: u32 = 32768;
pub const AT_RENAME_NOREPLACE: u32 = 1;
pub const AT_RENAME_EXCHANGE: u32 = 2;
pub const AT_RENAME_WHITEOUT: u32 = 4;
pub const AT_EACCESS: u32 = 512;
pub const AT_REMOVEDIR: u32 = 512;
pub const AT_HANDLE_FID: u32 = 512;
pub const AT_HANDLE_MNT_ID_UNIQUE: u32 = 1;
pub const AT_HANDLE_CONNECTABLE: u32 = 2;
pub const AT_EXECVE_CHECK: u32 = 65536;
pub const VALID_OPEN_FLAGS: u32 = 8388547;
pub const VALID_RESOLVE_FLAGS: u32 = 63;
pub const OPEN_HOW_SIZE_VER0: u32 = 24;
pub const OPEN_HOW_SIZE_LATEST: u32 = 24;
pub const SIGEMT_MASK: u32 = 0;
pub const JOBCTL_STOP_SIGMASK: u32 = 65535;
pub const JOBCTL_STOP_DEQUEUED_BIT: u32 = 16;
pub const JOBCTL_STOP_PENDING_BIT: u32 = 17;
pub const JOBCTL_STOP_CONSUME_BIT: u32 = 18;
pub const JOBCTL_TRAP_STOP_BIT: u32 = 19;
pub const JOBCTL_TRAP_NOTIFY_BIT: u32 = 20;
pub const JOBCTL_TRAPPING_BIT: u32 = 21;
pub const JOBCTL_LISTENING_BIT: u32 = 22;
pub const JOBCTL_TRAP_FREEZE_BIT: u32 = 23;
pub const JOBCTL_PTRACE_FROZEN_BIT: u32 = 24;
pub const JOBCTL_STOPPED_BIT: u32 = 26;
pub const JOBCTL_TRACED_BIT: u32 = 27;
pub const JOBCTL_STOP_DEQUEUED: u32 = 65536;
pub const JOBCTL_STOP_PENDING: u32 = 131072;
pub const JOBCTL_STOP_CONSUME: u32 = 262144;
pub const JOBCTL_TRAP_STOP: u32 = 524288;
pub const JOBCTL_TRAP_NOTIFY: u32 = 1048576;
pub const JOBCTL_TRAPPING: u32 = 2097152;
pub const JOBCTL_LISTENING: u32 = 4194304;
pub const JOBCTL_TRAP_FREEZE: u32 = 8388608;
pub const JOBCTL_PTRACE_FROZEN: u32 = 16777216;
pub const JOBCTL_STOPPED: u32 = 67108864;
pub const JOBCTL_TRACED: u32 = 134217728;
pub const JOBCTL_TRAP_MASK: u32 = 1572864;
pub const JOBCTL_PENDING_MASK: u32 = 1703936;
pub const SWAPPER_SKIP_LEVEL: u32 = 1;
pub const SWAPPER_PGTABLE_LEVELS: u32 = 3;
pub const IDMAP_VA_BITS: u32 = 48;
pub const KERNEL_SEGMENT_COUNT: u32 = 5;
pub const EARLY_SEGMENT_EXTRA_PAGES: u32 = 6;
pub const EARLY_IDMAP_EXTRA_PAGES: u32 = 3;
pub const EARLY_IDMAP_EXTRA_FDT_PAGES: u32 = 2;
pub const EX_TYPE_NONE: u32 = 0;
pub const EX_TYPE_BPF: u32 = 1;
pub const EX_TYPE_UACCESS_ERR_ZERO: u32 = 2;
pub const EX_TYPE_KACCESS_ERR_ZERO: u32 = 3;
pub const EX_TYPE_UACCESS_CPY: u32 = 4;
pub const EX_TYPE_LOAD_UNALIGNED_ZEROPAD: u32 = 5;
pub const EX_DATA_REG_ERR_SHIFT: u32 = 0;
pub const EX_DATA_REG_ZERO_SHIFT: u32 = 5;
pub const EX_DATA_REG_DATA_SHIFT: u32 = 0;
pub const EX_DATA_REG_ADDR_SHIFT: u32 = 5;
pub const CLONE_LEGACY_FLAGS: u32 = 4294967295;
pub const ASSOC_ARRAY_KEY_CHUNK_SIZE: u32 = 64;
pub const KEY_POS_VIEW: u32 = 16777216;
pub const KEY_POS_READ: u32 = 33554432;
pub const KEY_POS_WRITE: u32 = 67108864;
pub const KEY_POS_SEARCH: u32 = 134217728;
pub const KEY_POS_LINK: u32 = 268435456;
pub const KEY_POS_SETATTR: u32 = 536870912;
pub const KEY_POS_ALL: u32 = 1056964608;
pub const KEY_USR_VIEW: u32 = 65536;
pub const KEY_USR_READ: u32 = 131072;
pub const KEY_USR_WRITE: u32 = 262144;
pub const KEY_USR_SEARCH: u32 = 524288;
pub const KEY_USR_LINK: u32 = 1048576;
pub const KEY_USR_SETATTR: u32 = 2097152;
pub const KEY_USR_ALL: u32 = 4128768;
pub const KEY_GRP_VIEW: u32 = 256;
pub const KEY_GRP_READ: u32 = 512;
pub const KEY_GRP_WRITE: u32 = 1024;
pub const KEY_GRP_SEARCH: u32 = 2048;
pub const KEY_GRP_LINK: u32 = 4096;
pub const KEY_GRP_SETATTR: u32 = 8192;
pub const KEY_GRP_ALL: u32 = 16128;
pub const KEY_OTH_VIEW: u32 = 1;
pub const KEY_OTH_READ: u32 = 2;
pub const KEY_OTH_WRITE: u32 = 4;
pub const KEY_OTH_SEARCH: u32 = 8;
pub const KEY_OTH_LINK: u32 = 16;
pub const KEY_OTH_SETATTR: u32 = 32;
pub const KEY_OTH_ALL: u32 = 63;
pub const KEY_PERM_UNDEF: u32 = 4294967295;
pub const KEY_FLAG_DEAD: u32 = 0;
pub const KEY_FLAG_REVOKED: u32 = 1;
pub const KEY_FLAG_IN_QUOTA: u32 = 2;
pub const KEY_FLAG_USER_CONSTRUCT: u32 = 3;
pub const KEY_FLAG_ROOT_CAN_CLEAR: u32 = 4;
pub const KEY_FLAG_INVALIDATED: u32 = 5;
pub const KEY_FLAG_BUILTIN: u32 = 6;
pub const KEY_FLAG_ROOT_CAN_INVAL: u32 = 7;
pub const KEY_FLAG_KEEP: u32 = 8;
pub const KEY_FLAG_UID_KEYRING: u32 = 9;
pub const KEY_FLAG_FINAL_PUT: u32 = 10;
pub const KEY_ALLOC_IN_QUOTA: u32 = 0;
pub const KEY_ALLOC_QUOTA_OVERRUN: u32 = 1;
pub const KEY_ALLOC_NOT_IN_QUOTA: u32 = 2;
pub const KEY_ALLOC_BUILT_IN: u32 = 4;
pub const KEY_ALLOC_BYPASS_RESTRICTION: u32 = 8;
pub const KEY_ALLOC_UID_KEYRING: u32 = 16;
pub const KEY_ALLOC_SET_KEEP: u32 = 32;
pub const HIGH_RES_NSEC: u32 = 1;
pub const KTIME_HIGH_RES: u32 = 1;
pub const MONOTONIC_RES_NSEC: u32 = 1;
pub const KTIME_MONOTONIC_RES: u32 = 1;
pub const HRTIMER_STATE_INACTIVE: u32 = 0;
pub const HRTIMER_STATE_ENQUEUED: u32 = 1;
pub const ALARMTIMER_STATE_INACTIVE: u32 = 0;
pub const ALARMTIMER_STATE_ENQUEUED: u32 = 1;
pub const RCUREF_ONEREF: u32 = 0;
pub const RCUREF_MAXREF: u32 = 2147483647;
pub const RCUREF_SATURATED: u32 = 2684354560;
pub const RCUREF_RELEASED: u32 = 3221225472;
pub const RCUREF_DEAD: u32 = 3758096384;
pub const RCUREF_NOREF: u32 = 4294967295;
pub const SIGNAL_STOP_STOPPED: u32 = 1;
pub const SIGNAL_STOP_CONTINUED: u32 = 2;
pub const SIGNAL_GROUP_EXIT: u32 = 4;
pub const SIGNAL_CLD_STOPPED: u32 = 16;
pub const SIGNAL_CLD_CONTINUED: u32 = 32;
pub const SIGNAL_CLD_MASK: u32 = 48;
pub const SIGNAL_UNKILLABLE: u32 = 64;
pub const SIGNAL_STOP_MASK: u32 = 51;
pub const UUID_SIZE: u32 = 16;
pub const UUID_STRING_LEN: u32 = 36;
pub const RR_TIMESLICE: u32 = 100;
pub const IOPRIO_CLASS_SHIFT: u32 = 13;
pub const IOPRIO_NR_CLASSES: u32 = 8;
pub const IOPRIO_CLASS_MASK: u32 = 7;
pub const IOPRIO_PRIO_MASK: u32 = 8191;
pub const IOPRIO_LEVEL_NR_BITS: u32 = 3;
pub const IOPRIO_NR_LEVELS: u32 = 8;
pub const IOPRIO_LEVEL_MASK: u32 = 7;
pub const IOPRIO_BE_NR: u32 = 8;
pub const IOPRIO_NORM: u32 = 4;
pub const IOPRIO_BE_NORM: u32 = 4;
pub const IOPRIO_HINT_SHIFT: u32 = 3;
pub const IOPRIO_HINT_NR_BITS: u32 = 10;
pub const IOPRIO_NR_HINTS: u32 = 1024;
pub const IOPRIO_HINT_MASK: u32 = 1023;
pub const S_DT_SHIFT: u32 = 12;
pub const S_DT_MASK: u32 = 15;
pub const DT_UNKNOWN: u32 = 0;
pub const DT_FIFO: u32 = 1;
pub const DT_CHR: u32 = 2;
pub const DT_DIR: u32 = 4;
pub const DT_BLK: u32 = 6;
pub const DT_REG: u32 = 8;
pub const DT_LNK: u32 = 10;
pub const DT_SOCK: u32 = 12;
pub const DT_WHT: u32 = 14;
pub const DT_MAX: u32 = 16;
pub const FT_UNKNOWN: u32 = 0;
pub const FT_REG_FILE: u32 = 1;
pub const FT_DIR: u32 = 2;
pub const FT_CHRDEV: u32 = 3;
pub const FT_BLKDEV: u32 = 4;
pub const FT_FIFO: u32 = 5;
pub const FT_SOCK: u32 = 6;
pub const FT_SYMLINK: u32 = 7;
pub const FT_MAX: u32 = 8;
pub const MNT_NOSUID: u32 = 1;
pub const MNT_NODEV: u32 = 2;
pub const MNT_NOEXEC: u32 = 4;
pub const MNT_NOATIME: u32 = 8;
pub const MNT_NODIRATIME: u32 = 16;
pub const MNT_RELATIME: u32 = 32;
pub const MNT_READONLY: u32 = 64;
pub const MNT_NOSYMFOLLOW: u32 = 128;
pub const MNT_SHRINKABLE: u32 = 256;
pub const MNT_WRITE_HOLD: u32 = 512;
pub const MNT_SHARED: u32 = 4096;
pub const MNT_UNBINDABLE: u32 = 8192;
pub const MNT_SHARED_MASK: u32 = 8192;
pub const MNT_USER_SETTABLE_MASK: u32 = 255;
pub const MNT_ATIME_MASK: u32 = 56;
pub const MNT_INTERNAL: u32 = 16384;
pub const MNT_LOCK_ATIME: u32 = 262144;
pub const MNT_LOCK_NOEXEC: u32 = 524288;
pub const MNT_LOCK_NOSUID: u32 = 1048576;
pub const MNT_LOCK_NODEV: u32 = 2097152;
pub const MNT_LOCK_READONLY: u32 = 4194304;
pub const MNT_LOCKED: u32 = 8388608;
pub const MNT_DOOMED: u32 = 16777216;
pub const MNT_SYNC_UMOUNT: u32 = 33554432;
pub const MNT_MARKED: u32 = 67108864;
pub const MNT_UMOUNT: u32 = 134217728;
pub const KMALLOC_SHIFT_HIGH: u32 = 13;
pub const KMALLOC_SHIFT_MAX: u32 = 22;
pub const KMALLOC_SHIFT_LOW: u32 = 3;
pub const KMALLOC_MAX_SIZE: u32 = 4194304;
pub const KMALLOC_MAX_CACHE_SIZE: u32 = 8192;
pub const KMALLOC_MAX_ORDER: u32 = 10;
pub const KMALLOC_MIN_SIZE: u32 = 8;
pub const RANDOM_KMALLOC_CACHES_NR: u32 = 15;
pub const FILE_REF_ONEREF: u32 = 0;
pub const FILE_REF_MAXREF: u64 = 9223372036854775807;
pub const FILE_REF_SATURATED: i64 = -6917529027641081856;
pub const FILE_REF_RELEASED: i64 = -4611686018427387904;
pub const FILE_REF_DEAD: i64 = -2305843009213693952;
pub const FILE_REF_NOREF: i32 = -1;
pub const UNICODE_MAJ_SHIFT: u32 = 16;
pub const UNICODE_MIN_SHIFT: u32 = 8;
pub const INR_OPEN_CUR: u32 = 1024;
pub const INR_OPEN_MAX: u32 = 4096;
pub const BLOCK_SIZE_BITS: u32 = 10;
pub const BLOCK_SIZE: u32 = 1024;
pub const IO_INTEGRITY_CHK_GUARD: u32 = 1;
pub const IO_INTEGRITY_CHK_REFTAG: u32 = 2;
pub const IO_INTEGRITY_CHK_APPTAG: u32 = 4;
pub const IO_INTEGRITY_VALID_FLAGS: u32 = 7;
pub const SEEK_SET: u32 = 0;
pub const SEEK_CUR: u32 = 1;
pub const SEEK_END: u32 = 2;
pub const SEEK_DATA: u32 = 3;
pub const SEEK_HOLE: u32 = 4;
pub const SEEK_MAX: u32 = 4;
pub const RENAME_NOREPLACE: u32 = 1;
pub const RENAME_EXCHANGE: u32 = 2;
pub const RENAME_WHITEOUT: u32 = 4;
pub const FILE_DEDUPE_RANGE_SAME: u32 = 0;
pub const FILE_DEDUPE_RANGE_DIFFERS: u32 = 1;
pub const NR_FILE: u32 = 8192;
pub const FS_XFLAG_REALTIME: u32 = 1;
pub const FS_XFLAG_PREALLOC: u32 = 2;
pub const FS_XFLAG_IMMUTABLE: u32 = 8;
pub const FS_XFLAG_APPEND: u32 = 16;
pub const FS_XFLAG_SYNC: u32 = 32;
pub const FS_XFLAG_NOATIME: u32 = 64;
pub const FS_XFLAG_NODUMP: u32 = 128;
pub const FS_XFLAG_RTINHERIT: u32 = 256;
pub const FS_XFLAG_PROJINHERIT: u32 = 512;
pub const FS_XFLAG_NOSYMLINKS: u32 = 1024;
pub const FS_XFLAG_EXTSIZE: u32 = 2048;
pub const FS_XFLAG_EXTSZINHERIT: u32 = 4096;
pub const FS_XFLAG_NODEFRAG: u32 = 8192;
pub const FS_XFLAG_FILESTREAM: u32 = 16384;
pub const FS_XFLAG_DAX: u32 = 32768;
pub const FS_XFLAG_COWEXTSIZE: u32 = 65536;
pub const FS_XFLAG_HASATTR: u32 = 2147483648;
pub const BMAP_IOCTL: u32 = 1;
pub const FSLABEL_MAX: u32 = 256;
pub const FS_SECRM_FL: u32 = 1;
pub const FS_UNRM_FL: u32 = 2;
pub const FS_COMPR_FL: u32 = 4;
pub const FS_SYNC_FL: u32 = 8;
pub const FS_IMMUTABLE_FL: u32 = 16;
pub const FS_APPEND_FL: u32 = 32;
pub const FS_NODUMP_FL: u32 = 64;
pub const FS_NOATIME_FL: u32 = 128;
pub const FS_DIRTY_FL: u32 = 256;
pub const FS_COMPRBLK_FL: u32 = 512;
pub const FS_NOCOMP_FL: u32 = 1024;
pub const FS_ENCRYPT_FL: u32 = 2048;
pub const FS_BTREE_FL: u32 = 4096;
pub const FS_INDEX_FL: u32 = 4096;
pub const FS_IMAGIC_FL: u32 = 8192;
pub const FS_JOURNAL_DATA_FL: u32 = 16384;
pub const FS_NOTAIL_FL: u32 = 32768;
pub const FS_DIRSYNC_FL: u32 = 65536;
pub const FS_TOPDIR_FL: u32 = 131072;
pub const FS_HUGE_FILE_FL: u32 = 262144;
pub const FS_EXTENT_FL: u32 = 524288;
pub const FS_VERITY_FL: u32 = 1048576;
pub const FS_EA_INODE_FL: u32 = 2097152;
pub const FS_EOFBLOCKS_FL: u32 = 4194304;
pub const FS_NOCOW_FL: u32 = 8388608;
pub const FS_DAX_FL: u32 = 33554432;
pub const FS_INLINE_DATA_FL: u32 = 268435456;
pub const FS_PROJINHERIT_FL: u32 = 536870912;
pub const FS_CASEFOLD_FL: u32 = 1073741824;
pub const FS_RESERVED_FL: u32 = 2147483648;
pub const FS_FL_USER_VISIBLE: u32 = 253951;
pub const FS_FL_USER_MODIFIABLE: u32 = 229631;
pub const SYNC_FILE_RANGE_WAIT_BEFORE: u32 = 1;
pub const SYNC_FILE_RANGE_WRITE: u32 = 2;
pub const SYNC_FILE_RANGE_WAIT_AFTER: u32 = 4;
pub const SYNC_FILE_RANGE_WRITE_AND_WAIT: u32 = 7;
pub const PROCFS_IOCTL_MAGIC: u8 = 102u8;
pub const PAGE_IS_WPALLOWED: u32 = 1;
pub const PAGE_IS_WRITTEN: u32 = 2;
pub const PAGE_IS_FILE: u32 = 4;
pub const PAGE_IS_PRESENT: u32 = 8;
pub const PAGE_IS_SWAPPED: u32 = 16;
pub const PAGE_IS_PFNZERO: u32 = 32;
pub const PAGE_IS_HUGE: u32 = 64;
pub const PAGE_IS_SOFT_DIRTY: u32 = 128;
pub const PM_SCAN_WP_MATCHING: u32 = 1;
pub const PM_SCAN_CHECK_WPASYNC: u32 = 2;
pub const MAY_EXEC: u32 = 1;
pub const MAY_WRITE: u32 = 2;
pub const MAY_READ: u32 = 4;
pub const MAY_APPEND: u32 = 8;
pub const MAY_ACCESS: u32 = 16;
pub const MAY_OPEN: u32 = 32;
pub const MAY_CHDIR: u32 = 64;
pub const MAY_NOT_BLOCK: u32 = 128;
pub const ATTR_MODE: u32 = 1;
pub const ATTR_UID: u32 = 2;
pub const ATTR_GID: u32 = 4;
pub const ATTR_SIZE: u32 = 8;
pub const ATTR_ATIME: u32 = 16;
pub const ATTR_MTIME: u32 = 32;
pub const ATTR_CTIME: u32 = 64;
pub const ATTR_ATIME_SET: u32 = 128;
pub const ATTR_MTIME_SET: u32 = 256;
pub const ATTR_FORCE: u32 = 512;
pub const ATTR_KILL_SUID: u32 = 2048;
pub const ATTR_KILL_SGID: u32 = 4096;
pub const ATTR_FILE: u32 = 8192;
pub const ATTR_KILL_PRIV: u32 = 16384;
pub const ATTR_OPEN: u32 = 32768;
pub const ATTR_TIMES_SET: u32 = 65536;
pub const ATTR_TOUCH: u32 = 131072;
pub const ATTR_DELEG: u32 = 262144;
pub const WHITEOUT_MODE: u32 = 0;
pub const WHITEOUT_DEV: u32 = 0;
pub const XQM_USRQUOTA: u32 = 0;
pub const XQM_GRPQUOTA: u32 = 1;
pub const XQM_PRJQUOTA: u32 = 2;
pub const XQM_MAXQUOTAS: u32 = 3;
pub const FS_DQUOT_VERSION: u32 = 1;
pub const FS_DQ_ISOFT: u32 = 1;
pub const FS_DQ_IHARD: u32 = 2;
pub const FS_DQ_BSOFT: u32 = 4;
pub const FS_DQ_BHARD: u32 = 8;
pub const FS_DQ_RTBSOFT: u32 = 16;
pub const FS_DQ_RTBHARD: u32 = 32;
pub const FS_DQ_LIMIT_MASK: u32 = 63;
pub const FS_DQ_BTIMER: u32 = 64;
pub const FS_DQ_ITIMER: u32 = 128;
pub const FS_DQ_RTBTIMER: u32 = 256;
pub const FS_DQ_TIMER_MASK: u32 = 448;
pub const FS_DQ_BWARNS: u32 = 512;
pub const FS_DQ_IWARNS: u32 = 1024;
pub const FS_DQ_RTBWARNS: u32 = 2048;
pub const FS_DQ_WARNS_MASK: u32 = 3584;
pub const FS_DQ_BCOUNT: u32 = 4096;
pub const FS_DQ_ICOUNT: u32 = 8192;
pub const FS_DQ_RTBCOUNT: u32 = 16384;
pub const FS_DQ_ACCT_MASK: u32 = 28672;
pub const FS_DQ_BIGTIME: u32 = 32768;
pub const FS_QUOTA_UDQ_ACCT: u32 = 1;
pub const FS_QUOTA_UDQ_ENFD: u32 = 2;
pub const FS_QUOTA_GDQ_ACCT: u32 = 4;
pub const FS_QUOTA_GDQ_ENFD: u32 = 8;
pub const FS_QUOTA_PDQ_ACCT: u32 = 16;
pub const FS_QUOTA_PDQ_ENFD: u32 = 32;
pub const FS_USER_QUOTA: u32 = 1;
pub const FS_PROJ_QUOTA: u32 = 2;
pub const FS_GROUP_QUOTA: u32 = 4;
pub const FS_QSTAT_VERSION: u32 = 1;
pub const FS_QSTATV_VERSION1: u32 = 1;
pub const V1_INIT_ALLOC: u32 = 1;
pub const V1_INIT_REWRITE: u32 = 1;
pub const V1_DEL_ALLOC: u32 = 0;
pub const V1_DEL_REWRITE: u32 = 2;
pub const QTREE_INIT_ALLOC: u32 = 4;
pub const QTREE_INIT_REWRITE: u32 = 2;
pub const QTREE_DEL_ALLOC: u32 = 0;
pub const QTREE_DEL_REWRITE: u32 = 6;
pub const V2_INIT_ALLOC: u32 = 4;
pub const V2_INIT_REWRITE: u32 = 2;
pub const V2_DEL_ALLOC: u32 = 0;
pub const V2_DEL_REWRITE: u32 = 6;
pub const OVERFLOW_PROJID: u32 = 65534;
pub const __DQUOT_VERSION__: &[u8; 12] = b"dquot_6.6.0\0";
pub const MAXQUOTAS: u32 = 3;
pub const USRQUOTA: u32 = 0;
pub const GRPQUOTA: u32 = 1;
pub const PRJQUOTA: u32 = 2;
pub const SUBCMDMASK: u32 = 255;
pub const SUBCMDSHIFT: u32 = 8;
pub const Q_SYNC: u32 = 8388609;
pub const Q_QUOTAON: u32 = 8388610;
pub const Q_QUOTAOFF: u32 = 8388611;
pub const Q_GETFMT: u32 = 8388612;
pub const Q_GETINFO: u32 = 8388613;
pub const Q_SETINFO: u32 = 8388614;
pub const Q_GETQUOTA: u32 = 8388615;
pub const Q_SETQUOTA: u32 = 8388616;
pub const Q_GETNEXTQUOTA: u32 = 8388617;
pub const QFMT_VFS_OLD: u32 = 1;
pub const QFMT_VFS_V0: u32 = 2;
pub const QFMT_OCFS2: u32 = 3;
pub const QFMT_VFS_V1: u32 = 4;
pub const QFMT_SHMEM: u32 = 5;
pub const QIF_DQBLKSIZE_BITS: u32 = 10;
pub const QIF_DQBLKSIZE: u32 = 1024;
pub const IIF_BGRACE: u32 = 1;
pub const IIF_IGRACE: u32 = 2;
pub const IIF_FLAGS: u32 = 4;
pub const IIF_ALL: u32 = 7;
pub const QUOTA_NL_NOWARN: u32 = 0;
pub const QUOTA_NL_IHARDWARN: u32 = 1;
pub const QUOTA_NL_ISOFTLONGWARN: u32 = 2;
pub const QUOTA_NL_ISOFTWARN: u32 = 3;
pub const QUOTA_NL_BHARDWARN: u32 = 4;
pub const QUOTA_NL_BSOFTLONGWARN: u32 = 5;
pub const QUOTA_NL_BSOFTWARN: u32 = 6;
pub const QUOTA_NL_IHARDBELOW: u32 = 7;
pub const QUOTA_NL_ISOFTBELOW: u32 = 8;
pub const QUOTA_NL_BHARDBELOW: u32 = 9;
pub const QUOTA_NL_BSOFTBELOW: u32 = 10;
pub const QTYPE_MASK_USR: u32 = 1;
pub const QTYPE_MASK_GRP: u32 = 2;
pub const QTYPE_MASK_PRJ: u32 = 4;
pub const DQ_MOD_B: u32 = 0;
pub const DQ_BLKS_B: u32 = 1;
pub const DQ_INODES_B: u32 = 2;
pub const DQ_FAKE_B: u32 = 3;
pub const DQ_READ_B: u32 = 4;
pub const DQ_ACTIVE_B: u32 = 5;
pub const DQ_RELEASING_B: u32 = 6;
pub const DQ_LASTSET_B: u32 = 7;
pub const QC_INO_SOFT: u32 = 1;
pub const QC_INO_HARD: u32 = 2;
pub const QC_SPC_SOFT: u32 = 4;
pub const QC_SPC_HARD: u32 = 8;
pub const QC_RT_SPC_SOFT: u32 = 16;
pub const QC_RT_SPC_HARD: u32 = 32;
pub const QC_LIMIT_MASK: u32 = 63;
pub const QC_SPC_TIMER: u32 = 64;
pub const QC_INO_TIMER: u32 = 128;
pub const QC_RT_SPC_TIMER: u32 = 256;
pub const QC_TIMER_MASK: u32 = 448;
pub const QC_SPC_WARNS: u32 = 512;
pub const QC_INO_WARNS: u32 = 1024;
pub const QC_RT_SPC_WARNS: u32 = 2048;
pub const QC_WARNS_MASK: u32 = 3584;
pub const QC_SPACE: u32 = 4096;
pub const QC_INO_COUNT: u32 = 8192;
pub const QC_RT_SPACE: u32 = 16384;
pub const QC_ACCT_MASK: u32 = 28672;
pub const QC_FLAGS: u32 = 32768;
pub const QCI_SYSFILE: u32 = 1;
pub const QCI_ROOT_SQUASH: u32 = 2;
pub const QCI_ACCT_ENABLED: u32 = 4;
pub const QCI_LIMITS_ENFORCED: u32 = 8;
pub const FILESYSTEM_MAX_STACK_DEPTH: u32 = 2;
pub const IOCB_EVENTFD: u32 = 65536;
pub const IOCB_DIRECT: u32 = 131072;
pub const IOCB_WRITE: u32 = 262144;
pub const IOCB_WAITQ: u32 = 524288;
pub const IOCB_NOIO: u32 = 1048576;
pub const IOCB_ALLOC_CACHE: u32 = 2097152;
pub const IOCB_DIO_CALLER_COMP: u32 = 4194304;
pub const IOCB_AIO_RW: u32 = 8388608;
pub const IOCB_HAS_METADATA: u32 = 16777216;
pub const IOP_FASTPERM: u32 = 1;
pub const IOP_LOOKUP: u32 = 2;
pub const IOP_NOFOLLOW: u32 = 4;
pub const IOP_XATTR: u32 = 8;
pub const IOP_DEFAULT_READLINK: u32 = 16;
pub const IOP_MGTIME: u32 = 32;
pub const IOP_CACHED_LINK: u32 = 64;
pub const MAX_NON_LFS: u32 = 2147483647;
pub const FASYNC_MAGIC: u32 = 17921;
pub const SB_ENC_STRICT_MODE_FL: u32 = 1;
pub const SB_ENC_NO_COMPAT_FALLBACK_FL: u32 = 2;
pub const MNT_FORCE: u32 = 1;
pub const MNT_DETACH: u32 = 2;
pub const MNT_EXPIRE: u32 = 4;
pub const UMOUNT_NOFOLLOW: u32 = 8;
pub const UMOUNT_UNUSED: u32 = 2147483648;
pub const SB_I_CGROUPWB: u32 = 1;
pub const SB_I_NOEXEC: u32 = 2;
pub const SB_I_NODEV: u32 = 4;
pub const SB_I_STABLE_WRITES: u32 = 8;
pub const SB_I_USERNS_VISIBLE: u32 = 16;
pub const SB_I_IMA_UNVERIFIABLE_SIGNATURE: u32 = 32;
pub const SB_I_UNTRUSTED_MOUNTER: u32 = 64;
pub const SB_I_EVM_HMAC_UNSUPPORTED: u32 = 128;
pub const SB_I_SKIP_SYNC: u32 = 256;
pub const SB_I_PERSB_BDI: u32 = 512;
pub const SB_I_TS_EXPIRY_WARNED: u32 = 1024;
pub const SB_I_RETIRED: u32 = 2048;
pub const SB_I_NOUMASK: u32 = 4096;
pub const SB_I_NOIDMAP: u32 = 8192;
pub const SB_I_ALLOW_HSM: u32 = 16384;
pub const NOMMU_MAP_COPY: u32 = 1;
pub const NOMMU_MAP_DIRECT: u32 = 8;
pub const REMAP_FILE_DEDUP: u32 = 1;
pub const REMAP_FILE_CAN_SHORTEN: u32 = 2;
pub const REMAP_FILE_ADVISORY: u32 = 2;
pub const COPY_FILE_SPLICE: u32 = 1;
pub const S_SYNC: u32 = 1;
pub const S_NOATIME: u32 = 2;
pub const S_APPEND: u32 = 4;
pub const S_IMMUTABLE: u32 = 8;
pub const S_DEAD: u32 = 16;
pub const S_NOQUOTA: u32 = 32;
pub const S_DIRSYNC: u32 = 64;
pub const S_NOCMTIME: u32 = 128;
pub const S_SWAPFILE: u32 = 256;
pub const S_PRIVATE: u32 = 512;
pub const S_IMA: u32 = 1024;
pub const S_AUTOMOUNT: u32 = 2048;
pub const S_NOSEC: u32 = 4096;
pub const S_DAX: u32 = 8192;
pub const S_ENCRYPTED: u32 = 16384;
pub const S_CASEFOLD: u32 = 32768;
pub const S_VERITY: u32 = 65536;
pub const S_KERNEL_FILE: u32 = 131072;
pub const __I_NEW: u32 = 0;
pub const I_NEW: u32 = 1;
pub const __I_SYNC: u32 = 1;
pub const I_SYNC: u32 = 2;
pub const __I_LRU_ISOLATING: u32 = 2;
pub const I_LRU_ISOLATING: u32 = 4;
pub const I_DIRTY_SYNC: u32 = 8;
pub const I_DIRTY_DATASYNC: u32 = 16;
pub const I_DIRTY_PAGES: u32 = 32;
pub const I_WILL_FREE: u32 = 64;
pub const I_FREEING: u32 = 128;
pub const I_CLEAR: u32 = 256;
pub const I_REFERENCED: u32 = 512;
pub const I_LINKABLE: u32 = 1024;
pub const I_DIRTY_TIME: u32 = 2048;
pub const I_WB_SWITCH: u32 = 4096;
pub const I_OVL_INUSE: u32 = 8192;
pub const I_CREATING: u32 = 16384;
pub const I_DONTCACHE: u32 = 32768;
pub const I_SYNC_QUEUED: u32 = 65536;
pub const I_PINNING_NETFS_WB: u32 = 131072;
pub const I_DIRTY_INODE: u32 = 24;
pub const I_DIRTY: u32 = 56;
pub const I_DIRTY_ALL: u32 = 2104;
pub const FS_REQUIRES_DEV: u32 = 1;
pub const FS_BINARY_MOUNTDATA: u32 = 2;
pub const FS_HAS_SUBTYPE: u32 = 4;
pub const FS_USERNS_MOUNT: u32 = 8;
pub const FS_DISALLOW_NOTIFY_PERM: u32 = 16;
pub const FS_ALLOW_IDMAP: u32 = 32;
pub const FS_MGTIME: u32 = 64;
pub const FS_LBS: u32 = 128;
pub const FS_RENAME_DOES_D_MOVE: u32 = 32768;
pub const CHRDEV_MAJOR_MAX: u32 = 512;
pub const CHRDEV_MAJOR_DYN_END: u32 = 234;
pub const CHRDEV_MAJOR_DYN_EXT_START: u32 = 511;
pub const CHRDEV_MAJOR_DYN_EXT_END: u32 = 384;
pub const COMPAT_ELF_PLATFORM: &[u8; 4] = b"v8l\0";
pub const COMPAT_ELF_NGREG: u32 = 18;
pub const COMPAT_ELF_ET_DYN_BASE: u32 = 4194304;
pub const EF_ARM_EABI_MASK: u32 = 4278190080;
pub const ARM64_ELF_BTI: u32 = 1;
pub const ELF32_GNU_PROPERTY_ALIGN: u32 = 4;
pub const ELF64_GNU_PROPERTY_ALIGN: u32 = 8;
pub const ELF_GNU_PROPERTY_ALIGN: u32 = 8;
pub const IDR_FREE: u32 = 0;
pub const IDA_CHUNK_SIZE: u32 = 128;
pub const KERNFS_TYPE_MASK: u32 = 15;
pub const KERNFS_FLAG_MASK: i32 = -16;
pub const KERNFS_MAX_USER_XATTRS: u32 = 128;
pub const KERNFS_USER_XATTR_SIZE_LIMIT: u32 = 131072;
pub const SYSFS_PREALLOC: u32 = 4096;
pub const SYSFS_GROUP_INVISIBLE: u32 = 8192;
pub const UEVENT_HELPER_PATH_LEN: u32 = 256;
pub const UEVENT_NUM_ENVP: u32 = 64;
pub const UEVENT_BUFFER_SIZE: u32 = 2048;
pub const KUNIT_PARAM_DESC_SIZE: u32 = 128;
pub const KUNIT_STATUS_COMMENT_SIZE: u32 = 256;
pub const KUNIT_INDENT_LEN: u32 = 4;
pub const KUNIT_SUBTEST_INDENT: &[u8; 5] = b"    \0";
pub const KUNIT_SUBSUBTEST_INDENT: &[u8; 9] = b"        \0";
pub const NR_IRQS: u32 = 64;
pub const HCR_ATA_SHIFT: u32 = 56;
pub const HCR_RW_SHIFT: u32 = 31;
pub const HCR_BSU: u32 = 3072;
pub const MPAMHCR_HOST_FLAGS: u32 = 0;
pub const TCR_EL2_DS: u64 = 4294967296;
pub const TCR_EL2_RES1: u32 = 2155872256;
pub const TCR_EL2_HPD: u32 = 16777216;
pub const TCR_EL2_TBI: u32 = 1048576;
pub const TCR_EL2_PS_SHIFT: u32 = 16;
pub const TCR_EL2_PS_MASK: u32 = 458752;
pub const TCR_EL2_PS_40B: u32 = 131072;
pub const TCR_EL2_T0SZ_MASK: u32 = 63;
pub const VTCR_EL2_DS: u64 = 4294967296;
pub const VTCR_EL2_RES1: u32 = 2147483648;
pub const VTCR_EL2_HD: u32 = 4194304;
pub const VTCR_EL2_HA: u32 = 2097152;
pub const VTCR_EL2_PS_SHIFT: u32 = 16;
pub const VTCR_EL2_PS_MASK: u32 = 458752;
pub const VTCR_EL2_SL0_SHIFT: u32 = 6;
pub const VTCR_EL2_SL0_MASK: u32 = 192;
pub const VTCR_EL2_T0SZ_MASK: u32 = 63;
pub const VTCR_EL2_VS_SHIFT: u32 = 19;
pub const VTCR_EL2_VS_8BIT: u32 = 0;
pub const VTCR_EL2_VS_16BIT: u32 = 524288;
pub const VTCR_EL2_TGRAN_SL0_BASE: u32 = 2;
pub const CPTR_EL2_TFP_SHIFT: u32 = 10;
pub const CPTR_EL2_TCPAC: u32 = 2147483648;
pub const CPTR_EL2_TAM: u32 = 1073741824;
pub const CPTR_EL2_TTA: u32 = 1048576;
pub const CPTR_EL2_TSM: u32 = 4096;
pub const CPTR_EL2_TFP: u32 = 1024;
pub const CPTR_EL2_TZ: u32 = 256;
pub const MMU_NOTIFIER_RANGE_BLOCKABLE: u32 = 1;
pub const TLBI_TTL_TG_4K: u32 = 1;
pub const TLBI_TTL_TG_16K: u32 = 2;
pub const TLBI_TTL_TG_64K: u32 = 3;
pub const MAX_DVM_OPS: u32 = 512;
pub const FIX_BTMAPS_SLOTS: u32 = 7;
pub const HUGE_MAX_HSTATE: u32 = 4;
pub const __SWP_TYPE_SHIFT: u32 = 6;
pub const __SWP_TYPE_BITS: u32 = 5;
pub const __SWP_TYPE_MASK: u32 = 31;
pub const __SWP_OFFSET_SHIFT: u32 = 12;
pub const __SWP_OFFSET_BITS: u32 = 50;
pub const __SWP_OFFSET_MASK: u64 = 1125899906842623;
pub const USER_PGTABLES_CEILING: u32 = 0;
pub const FIRST_USER_ADDRESS: u32 = 0;
pub const __PGTBL_PGD_MODIFIED: u32 = 0;
pub const __PGTBL_P4D_MODIFIED: u32 = 1;
pub const __PGTBL_PUD_MODIFIED: u32 = 2;
pub const __PGTBL_PMD_MODIFIED: u32 = 3;
pub const __PGTBL_PTE_MODIFIED: u32 = 4;
pub const MAX_PTRS_PER_PTE: u32 = 512;
pub const MAX_PTRS_PER_PMD: u32 = 512;
pub const MAX_PTRS_PER_PUD: u32 = 512;
pub const MAX_PTRS_PER_P4D: u32 = 1;
pub const IO_SPACE_LIMIT: u32 = 16777215;
pub const SWNODE_GRAPH_PORT_NAME_FMT: &[u8; 8] = b"port@%u\0";
pub const SWNODE_GRAPH_ENDPOINT_NAME_FMT: &[u8; 12] = b"endpoint@%u\0";
pub const NR_FWNODE_REFERENCE_ARGS: u32 = 16;
pub const PIO_INDIRECT_SIZE: u32 = 16384;
pub const MMIO_UPPER_LIMIT: u32 = 16760831;
pub const NR_IRQS_LEGACY: u32 = 0;
pub const ARCH_IRQ_INIT_FLAGS: u32 = 0;
pub const IRQ_DEFAULT_INIT_FLAGS: u32 = 0;
pub const INVALID_HWIRQ: i32 = -1;
pub const __ARCH_IRQ_EXIT_IRQS_DISABLED: u32 = 1;
pub const IRQF_TRIGGER_NONE: u32 = 0;
pub const IRQF_TRIGGER_RISING: u32 = 1;
pub const IRQF_TRIGGER_FALLING: u32 = 2;
pub const IRQF_TRIGGER_HIGH: u32 = 4;
pub const IRQF_TRIGGER_LOW: u32 = 8;
pub const IRQF_TRIGGER_MASK: u32 = 15;
pub const IRQF_TRIGGER_PROBE: u32 = 16;
pub const IRQF_SHARED: u32 = 128;
pub const IRQF_PROBE_SHARED: u32 = 256;
pub const __IRQF_TIMER: u32 = 512;
pub const IRQF_PERCPU: u32 = 1024;
pub const IRQF_NOBALANCING: u32 = 2048;
pub const IRQF_IRQPOLL: u32 = 4096;
pub const IRQF_ONESHOT: u32 = 8192;
pub const IRQF_NO_SUSPEND: u32 = 16384;
pub const IRQF_FORCE_RESUME: u32 = 32768;
pub const IRQF_NO_THREAD: u32 = 65536;
pub const IRQF_EARLY_RESUME: u32 = 131072;
pub const IRQF_COND_SUSPEND: u32 = 262144;
pub const IRQF_NO_AUTOEN: u32 = 524288;
pub const IRQF_NO_DEBUG: u32 = 1048576;
pub const IRQF_COND_ONESHOT: u32 = 2097152;
pub const IRQF_TIMER: u32 = 82432;
pub const IRQ_NOTCONNECTED: u32 = 2147483648;
pub const IRQ_AFFINITY_MAX_SETS: u32 = 4;
pub const TRACE_CONTEXT_BITS: u32 = 4;
pub const IORESOURCE_BITS: u32 = 255;
pub const IORESOURCE_TYPE_BITS: u32 = 7936;
pub const IORESOURCE_IO: u32 = 256;
pub const IORESOURCE_MEM: u32 = 512;
pub const IORESOURCE_REG: u32 = 768;
pub const IORESOURCE_IRQ: u32 = 1024;
pub const IORESOURCE_DMA: u32 = 2048;
pub const IORESOURCE_BUS: u32 = 4096;
pub const IORESOURCE_PREFETCH: u32 = 8192;
pub const IORESOURCE_READONLY: u32 = 16384;
pub const IORESOURCE_CACHEABLE: u32 = 32768;
pub const IORESOURCE_RANGELENGTH: u32 = 65536;
pub const IORESOURCE_SHADOWABLE: u32 = 131072;
pub const IORESOURCE_SIZEALIGN: u32 = 262144;
pub const IORESOURCE_STARTALIGN: u32 = 524288;
pub const IORESOURCE_MEM_64: u32 = 1048576;
pub const IORESOURCE_WINDOW: u32 = 2097152;
pub const IORESOURCE_MUXED: u32 = 4194304;
pub const IORESOURCE_EXT_TYPE_BITS: u32 = 16777216;
pub const IORESOURCE_SYSRAM: u32 = 16777216;
pub const IORESOURCE_SYSRAM_DRIVER_MANAGED: u32 = 33554432;
pub const IORESOURCE_SYSRAM_MERGEABLE: u32 = 67108864;
pub const IORESOURCE_EXCLUSIVE: u32 = 134217728;
pub const IORESOURCE_DISABLED: u32 = 268435456;
pub const IORESOURCE_UNSET: u32 = 536870912;
pub const IORESOURCE_AUTO: u32 = 1073741824;
pub const IORESOURCE_BUSY: u32 = 2147483648;
pub const IORESOURCE_SYSTEM_RAM: u32 = 16777728;
pub const IORESOURCE_IRQ_HIGHEDGE: u32 = 1;
pub const IORESOURCE_IRQ_LOWEDGE: u32 = 2;
pub const IORESOURCE_IRQ_HIGHLEVEL: u32 = 4;
pub const IORESOURCE_IRQ_LOWLEVEL: u32 = 8;
pub const IORESOURCE_IRQ_SHAREABLE: u32 = 16;
pub const IORESOURCE_IRQ_OPTIONAL: u32 = 32;
pub const IORESOURCE_IRQ_WAKECAPABLE: u32 = 64;
pub const IORESOURCE_DMA_TYPE_MASK: u32 = 3;
pub const IORESOURCE_DMA_8BIT: u32 = 0;
pub const IORESOURCE_DMA_8AND16BIT: u32 = 1;
pub const IORESOURCE_DMA_16BIT: u32 = 2;
pub const IORESOURCE_DMA_MASTER: u32 = 4;
pub const IORESOURCE_DMA_BYTE: u32 = 8;
pub const IORESOURCE_DMA_WORD: u32 = 16;
pub const IORESOURCE_DMA_SPEED_MASK: u32 = 192;
pub const IORESOURCE_DMA_COMPATIBLE: u32 = 0;
pub const IORESOURCE_DMA_TYPEA: u32 = 64;
pub const IORESOURCE_DMA_TYPEB: u32 = 128;
pub const IORESOURCE_DMA_TYPEF: u32 = 192;
pub const IORESOURCE_MEM_WRITEABLE: u32 = 1;
pub const IORESOURCE_MEM_CACHEABLE: u32 = 2;
pub const IORESOURCE_MEM_RANGELENGTH: u32 = 4;
pub const IORESOURCE_MEM_TYPE_MASK: u32 = 24;
pub const IORESOURCE_MEM_8BIT: u32 = 0;
pub const IORESOURCE_MEM_16BIT: u32 = 8;
pub const IORESOURCE_MEM_8AND16BIT: u32 = 16;
pub const IORESOURCE_MEM_32BIT: u32 = 24;
pub const IORESOURCE_MEM_SHADOWABLE: u32 = 32;
pub const IORESOURCE_MEM_EXPANSIONROM: u32 = 64;
pub const IORESOURCE_MEM_NONPOSTED: u32 = 128;
pub const IORESOURCE_IO_16BIT_ADDR: u32 = 1;
pub const IORESOURCE_IO_FIXED: u32 = 2;
pub const IORESOURCE_IO_SPARSE: u32 = 4;
pub const IORESOURCE_ROM_ENABLE: u32 = 1;
pub const IORESOURCE_ROM_SHADOW: u32 = 2;
pub const IORESOURCE_PCI_FIXED: u32 = 16;
pub const IORESOURCE_PCI_EA_BEI: u32 = 32;
pub const PGMAP_ALTMAP_VALID: u32 = 1;
pub const MAPCOUNT_ELF_CORE_MARGIN: u32 = 5;
pub const VM_NONE: u32 = 0;
pub const VM_READ: u32 = 1;
pub const VM_WRITE: u32 = 2;
pub const VM_EXEC: u32 = 4;
pub const VM_SHARED: u32 = 8;
pub const VM_MAYREAD: u32 = 16;
pub const VM_MAYWRITE: u32 = 32;
pub const VM_MAYEXEC: u32 = 64;
pub const VM_MAYSHARE: u32 = 128;
pub const VM_GROWSDOWN: u32 = 256;
pub const VM_UFFD_MISSING: u32 = 512;
pub const VM_PFNMAP: u32 = 1024;
pub const VM_UFFD_WP: u32 = 4096;
pub const VM_LOCKED: u32 = 8192;
pub const VM_IO: u32 = 16384;
pub const VM_SEQ_READ: u32 = 32768;
pub const VM_RAND_READ: u32 = 65536;
pub const VM_DONTCOPY: u32 = 131072;
pub const VM_DONTEXPAND: u32 = 262144;
pub const VM_LOCKONFAULT: u32 = 524288;
pub const VM_ACCOUNT: u32 = 1048576;
pub const VM_NORESERVE: u32 = 2097152;
pub const VM_HUGETLB: u32 = 4194304;
pub const VM_SYNC: u32 = 8388608;
pub const VM_ARCH_1: u32 = 16777216;
pub const VM_WIPEONFORK: u32 = 33554432;
pub const VM_DONTDUMP: u32 = 67108864;
pub const VM_SOFTDIRTY: u32 = 0;
pub const VM_MIXEDMAP: u32 = 268435456;
pub const VM_HUGEPAGE: u32 = 536870912;
pub const VM_NOHUGEPAGE: u32 = 1073741824;
pub const VM_MERGEABLE: u32 = 2147483648;
pub const VM_HIGH_ARCH_BIT_0: u32 = 32;
pub const VM_HIGH_ARCH_BIT_1: u32 = 33;
pub const VM_HIGH_ARCH_BIT_2: u32 = 34;
pub const VM_HIGH_ARCH_BIT_3: u32 = 35;
pub const VM_HIGH_ARCH_BIT_4: u32 = 36;
pub const VM_HIGH_ARCH_BIT_5: u32 = 37;
pub const VM_HIGH_ARCH_BIT_6: u32 = 38;
pub const VM_PKEY_SHIFT: u32 = 32;
pub const VM_PKEY_BIT3: u32 = 0;
pub const VM_PKEY_BIT4: u32 = 0;
pub const VM_SHADOW_STACK: u32 = 0;
pub const VM_ARM64_BTI: u32 = 16777216;
pub const VM_ARCH_CLEAR: u32 = 16777216;
pub const VM_GROWSUP: u32 = 0;
pub const VM_UFFD_MINOR_BIT: u32 = 38;
pub const VM_ALLOW_ANY_UNCACHED_BIT: u32 = 39;
pub const VM_DROPPABLE_BIT: u32 = 40;
pub const VM_DATA_FLAGS_NON_EXEC: u32 = 115;
pub const VM_DATA_FLAGS_EXEC: u32 = 119;
pub const VM_STARTGAP_FLAGS: u32 = 256;
pub const VM_STACK: u32 = 256;
pub const VM_STACK_EARLY: u32 = 0;
pub const VM_ACCESS_FLAGS: u32 = 7;
pub const VM_SPECIAL: u32 = 268715008;
pub const VM_NO_KHUGEPAGED: u32 = 272909312;
pub const VM_INIT_DEF_MASK: u32 = 1073741824;
pub const VM_LOCKED_MASK: u32 = 532480;
pub const TVA_SMAPS: u32 = 1;
pub const TVA_IN_PF: u32 = 2;
pub const TVA_ENFORCE_SYSFS: u32 = 4;
pub const GUP_PIN_COUNTING_BIAS: u32 = 1024;
pub const PAGE_ACCESS_TIME_MIN_BITS: u32 = 12;
pub const PAGE_ACCESS_TIME_BUCKETS: u32 = 0;
pub const PAGE_ACCESS_TIME_MASK: u32 = 1048575;
pub const MM_CP_TRY_CHANGE_WRITABLE: u32 = 1;
pub const MM_CP_PROT_NUMA: u32 = 2;
pub const MM_CP_UFFD_WP: u32 = 4;
pub const MM_CP_UFFD_WP_RESOLVE: u32 = 8;
pub const MM_CP_UFFD_WP_ALL: u32 = 12;
pub const VM_UNMAPPED_AREA_TOPDOWN: u32 = 1;
pub const VMEMMAP_RESERVE_NR: u32 = 2;
pub const VM_SEALED_SYSMAP: u32 = 0;
pub const KSYM_NAME_LEN: u32 = 512;
pub const MAX_PID_NS_LEVEL: u32 = 32;
pub const MEMFD_NOEXEC_SCOPE_EXEC: u32 = 0;
pub const MEMFD_NOEXEC_SCOPE_NOEXEC_SEAL: u32 = 1;
pub const MEMFD_NOEXEC_SCOPE_NOEXEC_ENFORCED: u32 = 2;
pub const PIDNS_ADDING: u32 = 2147483648;
pub const PTRACE_TRACEME: u32 = 0;
pub const PTRACE_PEEKTEXT: u32 = 1;
pub const PTRACE_PEEKDATA: u32 = 2;
pub const PTRACE_PEEKUSR: u32 = 3;
pub const PTRACE_POKETEXT: u32 = 4;
pub const PTRACE_POKEDATA: u32 = 5;
pub const PTRACE_POKEUSR: u32 = 6;
pub const PTRACE_CONT: u32 = 7;
pub const PTRACE_KILL: u32 = 8;
pub const PTRACE_SINGLESTEP: u32 = 9;
pub const PTRACE_ATTACH: u32 = 16;
pub const PTRACE_DETACH: u32 = 17;
pub const PTRACE_SYSCALL: u32 = 24;
pub const PTRACE_SETOPTIONS: u32 = 16896;
pub const PTRACE_GETEVENTMSG: u32 = 16897;
pub const PTRACE_GETSIGINFO: u32 = 16898;
pub const PTRACE_SETSIGINFO: u32 = 16899;
pub const PTRACE_GETREGSET: u32 = 16900;
pub const PTRACE_SETREGSET: u32 = 16901;
pub const PTRACE_SEIZE: u32 = 16902;
pub const PTRACE_INTERRUPT: u32 = 16903;
pub const PTRACE_LISTEN: u32 = 16904;
pub const PTRACE_PEEKSIGINFO: u32 = 16905;
pub const PTRACE_GETSIGMASK: u32 = 16906;
pub const PTRACE_SETSIGMASK: u32 = 16907;
pub const PTRACE_SECCOMP_GET_FILTER: u32 = 16908;
pub const PTRACE_SECCOMP_GET_METADATA: u32 = 16909;
pub const PTRACE_GET_SYSCALL_INFO: u32 = 16910;
pub const PTRACE_SYSCALL_INFO_NONE: u32 = 0;
pub const PTRACE_SYSCALL_INFO_ENTRY: u32 = 1;
pub const PTRACE_SYSCALL_INFO_EXIT: u32 = 2;
pub const PTRACE_SYSCALL_INFO_SECCOMP: u32 = 3;
pub const PTRACE_GET_RSEQ_CONFIGURATION: u32 = 16911;
pub const PTRACE_SET_SYSCALL_USER_DISPATCH_CONFIG: u32 = 16912;
pub const PTRACE_GET_SYSCALL_USER_DISPATCH_CONFIG: u32 = 16913;
pub const PTRACE_EVENTMSG_SYSCALL_ENTRY: u32 = 1;
pub const PTRACE_EVENTMSG_SYSCALL_EXIT: u32 = 2;
pub const PTRACE_PEEKSIGINFO_SHARED: u32 = 1;
pub const PTRACE_EVENT_FORK: u32 = 1;
pub const PTRACE_EVENT_VFORK: u32 = 2;
pub const PTRACE_EVENT_CLONE: u32 = 3;
pub const PTRACE_EVENT_EXEC: u32 = 4;
pub const PTRACE_EVENT_VFORK_DONE: u32 = 5;
pub const PTRACE_EVENT_EXIT: u32 = 6;
pub const PTRACE_EVENT_SECCOMP: u32 = 7;
pub const PTRACE_EVENT_STOP: u32 = 128;
pub const PTRACE_O_TRACESYSGOOD: u32 = 1;
pub const PTRACE_O_TRACEFORK: u32 = 2;
pub const PTRACE_O_TRACEVFORK: u32 = 4;
pub const PTRACE_O_TRACECLONE: u32 = 8;
pub const PTRACE_O_TRACEEXEC: u32 = 16;
pub const PTRACE_O_TRACEVFORKDONE: u32 = 32;
pub const PTRACE_O_TRACEEXIT: u32 = 64;
pub const PTRACE_O_TRACESECCOMP: u32 = 128;
pub const PTRACE_O_EXITKILL: u32 = 1048576;
pub const PTRACE_O_SUSPEND_SECCOMP: u32 = 2097152;
pub const PTRACE_O_MASK: u32 = 3145983;
pub const SECCOMP_MODE_DISABLED: u32 = 0;
pub const SECCOMP_MODE_STRICT: u32 = 1;
pub const SECCOMP_MODE_FILTER: u32 = 2;
pub const SECCOMP_SET_MODE_STRICT: u32 = 0;
pub const SECCOMP_SET_MODE_FILTER: u32 = 1;
pub const SECCOMP_GET_ACTION_AVAIL: u32 = 2;
pub const SECCOMP_GET_NOTIF_SIZES: u32 = 3;
pub const SECCOMP_FILTER_FLAG_TSYNC: u32 = 1;
pub const SECCOMP_FILTER_FLAG_LOG: u32 = 2;
pub const SECCOMP_FILTER_FLAG_SPEC_ALLOW: u32 = 4;
pub const SECCOMP_FILTER_FLAG_NEW_LISTENER: u32 = 8;
pub const SECCOMP_FILTER_FLAG_TSYNC_ESRCH: u32 = 16;
pub const SECCOMP_FILTER_FLAG_WAIT_KILLABLE_RECV: u32 = 32;
pub const SECCOMP_RET_KILL_PROCESS: u32 = 2147483648;
pub const SECCOMP_RET_KILL_THREAD: u32 = 0;
pub const SECCOMP_RET_KILL: u32 = 0;
pub const SECCOMP_RET_TRAP: u32 = 196608;
pub const SECCOMP_RET_ERRNO: u32 = 327680;
pub const SECCOMP_RET_USER_NOTIF: u32 = 2143289344;
pub const SECCOMP_RET_TRACE: u32 = 2146435072;
pub const SECCOMP_RET_LOG: u32 = 2147221504;
pub const SECCOMP_RET_ALLOW: u32 = 2147418112;
pub const SECCOMP_RET_ACTION_FULL: u32 = 4294901760;
pub const SECCOMP_RET_ACTION: u32 = 2147418112;
pub const SECCOMP_RET_DATA: u32 = 65535;
pub const SECCOMP_USER_NOTIF_FLAG_CONTINUE: u32 = 1;
pub const SECCOMP_USER_NOTIF_FD_SYNC_WAKE_UP: u32 = 1;
pub const SECCOMP_ADDFD_FLAG_SETFD: u32 = 1;
pub const SECCOMP_ADDFD_FLAG_SEND: u32 = 2;
pub const SECCOMP_IOC_MAGIC: u8 = 33u8;
pub const SECCOMP_FILTER_FLAG_MASK: u32 = 63;
pub const SECCOMP_NOTIFY_ADDFD_SIZE_VER0: u32 = 24;
pub const SECCOMP_NOTIFY_ADDFD_SIZE_LATEST: u32 = 24;
pub const __NR_compat32_restart_syscall: u32 = 0;
pub const __NR_compat32_exit: u32 = 1;
pub const __NR_compat32_fork: u32 = 2;
pub const __NR_compat32_read: u32 = 3;
pub const __NR_compat32_write: u32 = 4;
pub const __NR_compat32_open: u32 = 5;
pub const __NR_compat32_close: u32 = 6;
pub const __NR_compat32_creat: u32 = 8;
pub const __NR_compat32_link: u32 = 9;
pub const __NR_compat32_unlink: u32 = 10;
pub const __NR_compat32_execve: u32 = 11;
pub const __NR_compat32_chdir: u32 = 12;
pub const __NR_compat32_mknod: u32 = 14;
pub const __NR_compat32_chmod: u32 = 15;
pub const __NR_compat32_lchown: u32 = 16;
pub const __NR_compat32_lseek: u32 = 19;
pub const __NR_compat32_getpid: u32 = 20;
pub const __NR_compat32_mount: u32 = 21;
pub const __NR_compat32_setuid: u32 = 23;
pub const __NR_compat32_getuid: u32 = 24;
pub const __NR_compat32_ptrace: u32 = 26;
pub const __NR_compat32_pause: u32 = 29;
pub const __NR_compat32_access: u32 = 33;
pub const __NR_compat32_nice: u32 = 34;
pub const __NR_compat32_sync: u32 = 36;
pub const __NR_compat32_kill: u32 = 37;
pub const __NR_compat32_rename: u32 = 38;
pub const __NR_compat32_mkdir: u32 = 39;
pub const __NR_compat32_rmdir: u32 = 40;
pub const __NR_compat32_dup: u32 = 41;
pub const __NR_compat32_pipe: u32 = 42;
pub const __NR_compat32_times: u32 = 43;
pub const __NR_compat32_brk: u32 = 45;
pub const __NR_compat32_setgid: u32 = 46;
pub const __NR_compat32_getgid: u32 = 47;
pub const __NR_compat32_geteuid: u32 = 49;
pub const __NR_compat32_getegid: u32 = 50;
pub const __NR_compat32_acct: u32 = 51;
pub const __NR_compat32_umount2: u32 = 52;
pub const __NR_compat32_ioctl: u32 = 54;
pub const __NR_compat32_fcntl: u32 = 55;
pub const __NR_compat32_setpgid: u32 = 57;
pub const __NR_compat32_umask: u32 = 60;
pub const __NR_compat32_chroot: u32 = 61;
pub const __NR_compat32_ustat: u32 = 62;
pub const __NR_compat32_dup2: u32 = 63;
pub const __NR_compat32_getppid: u32 = 64;
pub const __NR_compat32_getpgrp: u32 = 65;
pub const __NR_compat32_setsid: u32 = 66;
pub const __NR_compat32_sigaction: u32 = 67;
pub const __NR_compat32_setreuid: u32 = 70;
pub const __NR_compat32_setregid: u32 = 71;
pub const __NR_compat32_sigsuspend: u32 = 72;
pub const __NR_compat32_sigpending: u32 = 73;
pub const __NR_compat32_sethostname: u32 = 74;
pub const __NR_compat32_setrlimit: u32 = 75;
pub const __NR_compat32_getrusage: u32 = 77;
pub const __NR_compat32_gettimeofday: u32 = 78;
pub const __NR_compat32_settimeofday: u32 = 79;
pub const __NR_compat32_getgroups: u32 = 80;
pub const __NR_compat32_setgroups: u32 = 81;
pub const __NR_compat32_symlink: u32 = 83;
pub const __NR_compat32_readlink: u32 = 85;
pub const __NR_compat32_uselib: u32 = 86;
pub const __NR_compat32_swapon: u32 = 87;
pub const __NR_compat32_reboot: u32 = 88;
pub const __NR_compat32_munmap: u32 = 91;
pub const __NR_compat32_truncate: u32 = 92;
pub const __NR_compat32_ftruncate: u32 = 93;
pub const __NR_compat32_fchmod: u32 = 94;
pub const __NR_compat32_fchown: u32 = 95;
pub const __NR_compat32_getpriority: u32 = 96;
pub const __NR_compat32_setpriority: u32 = 97;
pub const __NR_compat32_statfs: u32 = 99;
pub const __NR_compat32_fstatfs: u32 = 100;
pub const __NR_compat32_syslog: u32 = 103;
pub const __NR_compat32_setitimer: u32 = 104;
pub const __NR_compat32_getitimer: u32 = 105;
pub const __NR_compat32_stat: u32 = 106;
pub const __NR_compat32_lstat: u32 = 107;
pub const __NR_compat32_fstat: u32 = 108;
pub const __NR_compat32_vhangup: u32 = 111;
pub const __NR_compat32_wait4: u32 = 114;
pub const __NR_compat32_swapoff: u32 = 115;
pub const __NR_compat32_sysinfo: u32 = 116;
pub const __NR_compat32_fsync: u32 = 118;
pub const __NR_compat32_sigreturn: u32 = 119;
pub const __NR_compat32_clone: u32 = 120;
pub const __NR_compat32_setdomainname: u32 = 121;
pub const __NR_compat32_uname: u32 = 122;
pub const __NR_compat32_adjtimex: u32 = 124;
pub const __NR_compat32_mprotect: u32 = 125;
pub const __NR_compat32_sigprocmask: u32 = 126;
pub const __NR_compat32_init_module: u32 = 128;
pub const __NR_compat32_delete_module: u32 = 129;
pub const __NR_compat32_quotactl: u32 = 131;
pub const __NR_compat32_getpgid: u32 = 132;
pub const __NR_compat32_fchdir: u32 = 133;
pub const __NR_compat32_bdflush: u32 = 134;
pub const __NR_compat32_sysfs: u32 = 135;
pub const __NR_compat32_personality: u32 = 136;
pub const __NR_compat32_setfsuid: u32 = 138;
pub const __NR_compat32_setfsgid: u32 = 139;
pub const __NR_compat32__llseek: u32 = 140;
pub const __NR_compat32_getdents: u32 = 141;
pub const __NR_compat32__newselect: u32 = 142;
pub const __NR_compat32_flock: u32 = 143;
pub const __NR_compat32_msync: u32 = 144;
pub const __NR_compat32_readv: u32 = 145;
pub const __NR_compat32_writev: u32 = 146;
pub const __NR_compat32_getsid: u32 = 147;
pub const __NR_compat32_fdatasync: u32 = 148;
pub const __NR_compat32__sysctl: u32 = 149;
pub const __NR_compat32_mlock: u32 = 150;
pub const __NR_compat32_munlock: u32 = 151;
pub const __NR_compat32_mlockall: u32 = 152;
pub const __NR_compat32_munlockall: u32 = 153;
pub const __NR_compat32_sched_setparam: u32 = 154;
pub const __NR_compat32_sched_getparam: u32 = 155;
pub const __NR_compat32_sched_setscheduler: u32 = 156;
pub const __NR_compat32_sched_getscheduler: u32 = 157;
pub const __NR_compat32_sched_yield: u32 = 158;
pub const __NR_compat32_sched_get_priority_max: u32 = 159;
pub const __NR_compat32_sched_get_priority_min: u32 = 160;
pub const __NR_compat32_sched_rr_get_interval: u32 = 161;
pub const __NR_compat32_nanosleep: u32 = 162;
pub const __NR_compat32_mremap: u32 = 163;
pub const __NR_compat32_setresuid: u32 = 164;
pub const __NR_compat32_getresuid: u32 = 165;
pub const __NR_compat32_poll: u32 = 168;
pub const __NR_compat32_nfsservctl: u32 = 169;
pub const __NR_compat32_setresgid: u32 = 170;
pub const __NR_compat32_getresgid: u32 = 171;
pub const __NR_compat32_prctl: u32 = 172;
pub const __NR_compat32_rt_sigreturn: u32 = 173;
pub const __NR_compat32_rt_sigaction: u32 = 174;
pub const __NR_compat32_rt_sigprocmask: u32 = 175;
pub const __NR_compat32_rt_sigpending: u32 = 176;
pub const __NR_compat32_rt_sigtimedwait: u32 = 177;
pub const __NR_compat32_rt_sigqueueinfo: u32 = 178;
pub const __NR_compat32_rt_sigsuspend: u32 = 179;
pub const __NR_compat32_pread64: u32 = 180;
pub const __NR_compat32_pwrite64: u32 = 181;
pub const __NR_compat32_chown: u32 = 182;
pub const __NR_compat32_getcwd: u32 = 183;
pub const __NR_compat32_capget: u32 = 184;
pub const __NR_compat32_capset: u32 = 185;
pub const __NR_compat32_sigaltstack: u32 = 186;
pub const __NR_compat32_sendfile: u32 = 187;
pub const __NR_compat32_vfork: u32 = 190;
pub const __NR_compat32_ugetrlimit: u32 = 191;
pub const __NR_compat32_mmap2: u32 = 192;
pub const __NR_compat32_truncate64: u32 = 193;
pub const __NR_compat32_ftruncate64: u32 = 194;
pub const __NR_compat32_stat64: u32 = 195;
pub const __NR_compat32_lstat64: u32 = 196;
pub const __NR_compat32_fstat64: u32 = 197;
pub const __NR_compat32_lchown32: u32 = 198;
pub const __NR_compat32_getuid32: u32 = 199;
pub const __NR_compat32_getgid32: u32 = 200;
pub const __NR_compat32_geteuid32: u32 = 201;
pub const __NR_compat32_getegid32: u32 = 202;
pub const __NR_compat32_setreuid32: u32 = 203;
pub const __NR_compat32_setregid32: u32 = 204;
pub const __NR_compat32_getgroups32: u32 = 205;
pub const __NR_compat32_setgroups32: u32 = 206;
pub const __NR_compat32_fchown32: u32 = 207;
pub const __NR_compat32_setresuid32: u32 = 208;
pub const __NR_compat32_getresuid32: u32 = 209;
pub const __NR_compat32_setresgid32: u32 = 210;
pub const __NR_compat32_getresgid32: u32 = 211;
pub const __NR_compat32_chown32: u32 = 212;
pub const __NR_compat32_setuid32: u32 = 213;
pub const __NR_compat32_setgid32: u32 = 214;
pub const __NR_compat32_setfsuid32: u32 = 215;
pub const __NR_compat32_setfsgid32: u32 = 216;
pub const __NR_compat32_getdents64: u32 = 217;
pub const __NR_compat32_pivot_root: u32 = 218;
pub const __NR_compat32_mincore: u32 = 219;
pub const __NR_compat32_madvise: u32 = 220;
pub const __NR_compat32_fcntl64: u32 = 221;
pub const __NR_compat32_gettid: u32 = 224;
pub const __NR_compat32_readahead: u32 = 225;
pub const __NR_compat32_setxattr: u32 = 226;
pub const __NR_compat32_lsetxattr: u32 = 227;
pub const __NR_compat32_fsetxattr: u32 = 228;
pub const __NR_compat32_getxattr: u32 = 229;
pub const __NR_compat32_lgetxattr: u32 = 230;
pub const __NR_compat32_fgetxattr: u32 = 231;
pub const __NR_compat32_listxattr: u32 = 232;
pub const __NR_compat32_llistxattr: u32 = 233;
pub const __NR_compat32_flistxattr: u32 = 234;
pub const __NR_compat32_removexattr: u32 = 235;
pub const __NR_compat32_lremovexattr: u32 = 236;
pub const __NR_compat32_fremovexattr: u32 = 237;
pub const __NR_compat32_tkill: u32 = 238;
pub const __NR_compat32_sendfile64: u32 = 239;
pub const __NR_compat32_futex: u32 = 240;
pub const __NR_compat32_sched_setaffinity: u32 = 241;
pub const __NR_compat32_sched_getaffinity: u32 = 242;
pub const __NR_compat32_io_setup: u32 = 243;
pub const __NR_compat32_io_destroy: u32 = 244;
pub const __NR_compat32_io_getevents: u32 = 245;
pub const __NR_compat32_io_submit: u32 = 246;
pub const __NR_compat32_io_cancel: u32 = 247;
pub const __NR_compat32_exit_group: u32 = 248;
pub const __NR_compat32_lookup_dcookie: u32 = 249;
pub const __NR_compat32_epoll_create: u32 = 250;
pub const __NR_compat32_epoll_ctl: u32 = 251;
pub const __NR_compat32_epoll_wait: u32 = 252;
pub const __NR_compat32_remap_file_pages: u32 = 253;
pub const __NR_compat32_set_tid_address: u32 = 256;
pub const __NR_compat32_timer_create: u32 = 257;
pub const __NR_compat32_timer_settime: u32 = 258;
pub const __NR_compat32_timer_gettime: u32 = 259;
pub const __NR_compat32_timer_getoverrun: u32 = 260;
pub const __NR_compat32_timer_delete: u32 = 261;
pub const __NR_compat32_clock_settime: u32 = 262;
pub const __NR_compat32_clock_gettime: u32 = 263;
pub const __NR_compat32_clock_getres: u32 = 264;
pub const __NR_compat32_clock_nanosleep: u32 = 265;
pub const __NR_compat32_statfs64: u32 = 266;
pub const __NR_compat32_fstatfs64: u32 = 267;
pub const __NR_compat32_tgkill: u32 = 268;
pub const __NR_compat32_utimes: u32 = 269;
pub const __NR_compat32_arm_fadvise64_64: u32 = 270;
pub const __NR_compat32_pciconfig_iobase: u32 = 271;
pub const __NR_compat32_pciconfig_read: u32 = 272;
pub const __NR_compat32_pciconfig_write: u32 = 273;
pub const __NR_compat32_mq_open: u32 = 274;
pub const __NR_compat32_mq_unlink: u32 = 275;
pub const __NR_compat32_mq_timedsend: u32 = 276;
pub const __NR_compat32_mq_timedreceive: u32 = 277;
pub const __NR_compat32_mq_notify: u32 = 278;
pub const __NR_compat32_mq_getsetattr: u32 = 279;
pub const __NR_compat32_waitid: u32 = 280;
pub const __NR_compat32_socket: u32 = 281;
pub const __NR_compat32_bind: u32 = 282;
pub const __NR_compat32_connect: u32 = 283;
pub const __NR_compat32_listen: u32 = 284;
pub const __NR_compat32_accept: u32 = 285;
pub const __NR_compat32_getsockname: u32 = 286;
pub const __NR_compat32_getpeername: u32 = 287;
pub const __NR_compat32_socketpair: u32 = 288;
pub const __NR_compat32_send: u32 = 289;
pub const __NR_compat32_sendto: u32 = 290;
pub const __NR_compat32_recv: u32 = 291;
pub const __NR_compat32_recvfrom: u32 = 292;
pub const __NR_compat32_shutdown: u32 = 293;
pub const __NR_compat32_setsockopt: u32 = 294;
pub const __NR_compat32_getsockopt: u32 = 295;
pub const __NR_compat32_sendmsg: u32 = 296;
pub const __NR_compat32_recvmsg: u32 = 297;
pub const __NR_compat32_semop: u32 = 298;
pub const __NR_compat32_semget: u32 = 299;
pub const __NR_compat32_semctl: u32 = 300;
pub const __NR_compat32_msgsnd: u32 = 301;
pub const __NR_compat32_msgrcv: u32 = 302;
pub const __NR_compat32_msgget: u32 = 303;
pub const __NR_compat32_msgctl: u32 = 304;
pub const __NR_compat32_shmat: u32 = 305;
pub const __NR_compat32_shmdt: u32 = 306;
pub const __NR_compat32_shmget: u32 = 307;
pub const __NR_compat32_shmctl: u32 = 308;
pub const __NR_compat32_add_key: u32 = 309;
pub const __NR_compat32_request_key: u32 = 310;
pub const __NR_compat32_keyctl: u32 = 311;
pub const __NR_compat32_semtimedop: u32 = 312;
pub const __NR_compat32_vserver: u32 = 313;
pub const __NR_compat32_ioprio_set: u32 = 314;
pub const __NR_compat32_ioprio_get: u32 = 315;
pub const __NR_compat32_inotify_init: u32 = 316;
pub const __NR_compat32_inotify_add_watch: u32 = 317;
pub const __NR_compat32_inotify_rm_watch: u32 = 318;
pub const __NR_compat32_mbind: u32 = 319;
pub const __NR_compat32_get_mempolicy: u32 = 320;
pub const __NR_compat32_set_mempolicy: u32 = 321;
pub const __NR_compat32_openat: u32 = 322;
pub const __NR_compat32_mkdirat: u32 = 323;
pub const __NR_compat32_mknodat: u32 = 324;
pub const __NR_compat32_fchownat: u32 = 325;
pub const __NR_compat32_futimesat: u32 = 326;
pub const __NR_compat32_fstatat64: u32 = 327;
pub const __NR_compat32_unlinkat: u32 = 328;
pub const __NR_compat32_renameat: u32 = 329;
pub const __NR_compat32_linkat: u32 = 330;
pub const __NR_compat32_symlinkat: u32 = 331;
pub const __NR_compat32_readlinkat: u32 = 332;
pub const __NR_compat32_fchmodat: u32 = 333;
pub const __NR_compat32_faccessat: u32 = 334;
pub const __NR_compat32_pselect6: u32 = 335;
pub const __NR_compat32_ppoll: u32 = 336;
pub const __NR_compat32_unshare: u32 = 337;
pub const __NR_compat32_set_robust_list: u32 = 338;
pub const __NR_compat32_get_robust_list: u32 = 339;
pub const __NR_compat32_splice: u32 = 340;
pub const __NR_compat32_arm_sync_file_range: u32 = 341;
pub const __NR_compat32_tee: u32 = 342;
pub const __NR_compat32_vmsplice: u32 = 343;
pub const __NR_compat32_move_pages: u32 = 344;
pub const __NR_compat32_getcpu: u32 = 345;
pub const __NR_compat32_epoll_pwait: u32 = 346;
pub const __NR_compat32_kexec_load: u32 = 347;
pub const __NR_compat32_utimensat: u32 = 348;
pub const __NR_compat32_signalfd: u32 = 349;
pub const __NR_compat32_timerfd_create: u32 = 350;
pub const __NR_compat32_eventfd: u32 = 351;
pub const __NR_compat32_fallocate: u32 = 352;
pub const __NR_compat32_timerfd_settime: u32 = 353;
pub const __NR_compat32_timerfd_gettime: u32 = 354;
pub const __NR_compat32_signalfd4: u32 = 355;
pub const __NR_compat32_eventfd2: u32 = 356;
pub const __NR_compat32_epoll_create1: u32 = 357;
pub const __NR_compat32_dup3: u32 = 358;
pub const __NR_compat32_pipe2: u32 = 359;
pub const __NR_compat32_inotify_init1: u32 = 360;
pub const __NR_compat32_preadv: u32 = 361;
pub const __NR_compat32_pwritev: u32 = 362;
pub const __NR_compat32_rt_tgsigqueueinfo: u32 = 363;
pub const __NR_compat32_perf_event_open: u32 = 364;
pub const __NR_compat32_recvmmsg: u32 = 365;
pub const __NR_compat32_accept4: u32 = 366;
pub const __NR_compat32_fanotify_init: u32 = 367;
pub const __NR_compat32_fanotify_mark: u32 = 368;
pub const __NR_compat32_prlimit64: u32 = 369;
pub const __NR_compat32_name_to_handle_at: u32 = 370;
pub const __NR_compat32_open_by_handle_at: u32 = 371;
pub const __NR_compat32_clock_adjtime: u32 = 372;
pub const __NR_compat32_syncfs: u32 = 373;
pub const __NR_compat32_sendmmsg: u32 = 374;
pub const __NR_compat32_setns: u32 = 375;
pub const __NR_compat32_process_vm_readv: u32 = 376;
pub const __NR_compat32_process_vm_writev: u32 = 377;
pub const __NR_compat32_kcmp: u32 = 378;
pub const __NR_compat32_finit_module: u32 = 379;
pub const __NR_compat32_sched_setattr: u32 = 380;
pub const __NR_compat32_sched_getattr: u32 = 381;
pub const __NR_compat32_renameat2: u32 = 382;
pub const __NR_compat32_seccomp: u32 = 383;
pub const __NR_compat32_getrandom: u32 = 384;
pub const __NR_compat32_memfd_create: u32 = 385;
pub const __NR_compat32_bpf: u32 = 386;
pub const __NR_compat32_execveat: u32 = 387;
pub const __NR_compat32_userfaultfd: u32 = 388;
pub const __NR_compat32_membarrier: u32 = 389;
pub const __NR_compat32_mlock2: u32 = 390;
pub const __NR_compat32_copy_file_range: u32 = 391;
pub const __NR_compat32_preadv2: u32 = 392;
pub const __NR_compat32_pwritev2: u32 = 393;
pub const __NR_compat32_pkey_mprotect: u32 = 394;
pub const __NR_compat32_pkey_alloc: u32 = 395;
pub const __NR_compat32_pkey_free: u32 = 396;
pub const __NR_compat32_statx: u32 = 397;
pub const __NR_compat32_rseq: u32 = 398;
pub const __NR_compat32_io_pgetevents: u32 = 399;
pub const __NR_compat32_migrate_pages: u32 = 400;
pub const __NR_compat32_kexec_file_load: u32 = 401;
pub const __NR_compat32_clock_gettime64: u32 = 403;
pub const __NR_compat32_clock_settime64: u32 = 404;
pub const __NR_compat32_clock_adjtime64: u32 = 405;
pub const __NR_compat32_clock_getres_time64: u32 = 406;
pub const __NR_compat32_clock_nanosleep_time64: u32 = 407;
pub const __NR_compat32_timer_gettime64: u32 = 408;
pub const __NR_compat32_timer_settime64: u32 = 409;
pub const __NR_compat32_timerfd_gettime64: u32 = 410;
pub const __NR_compat32_timerfd_settime64: u32 = 411;
pub const __NR_compat32_utimensat_time64: u32 = 412;
pub const __NR_compat32_pselect6_time64: u32 = 413;
pub const __NR_compat32_ppoll_time64: u32 = 414;
pub const __NR_compat32_io_pgetevents_time64: u32 = 416;
pub const __NR_compat32_recvmmsg_time64: u32 = 417;
pub const __NR_compat32_mq_timedsend_time64: u32 = 418;
pub const __NR_compat32_mq_timedreceive_time64: u32 = 419;
pub const __NR_compat32_semtimedop_time64: u32 = 420;
pub const __NR_compat32_rt_sigtimedwait_time64: u32 = 421;
pub const __NR_compat32_futex_time64: u32 = 422;
pub const __NR_compat32_sched_rr_get_interval_time64: u32 = 423;
pub const __NR_compat32_pidfd_send_signal: u32 = 424;
pub const __NR_compat32_io_uring_setup: u32 = 425;
pub const __NR_compat32_io_uring_enter: u32 = 426;
pub const __NR_compat32_io_uring_register: u32 = 427;
pub const __NR_compat32_open_tree: u32 = 428;
pub const __NR_compat32_move_mount: u32 = 429;
pub const __NR_compat32_fsopen: u32 = 430;
pub const __NR_compat32_fsconfig: u32 = 431;
pub const __NR_compat32_fsmount: u32 = 432;
pub const __NR_compat32_fspick: u32 = 433;
pub const __NR_compat32_pidfd_open: u32 = 434;
pub const __NR_compat32_clone3: u32 = 435;
pub const __NR_compat32_close_range: u32 = 436;
pub const __NR_compat32_openat2: u32 = 437;
pub const __NR_compat32_pidfd_getfd: u32 = 438;
pub const __NR_compat32_faccessat2: u32 = 439;
pub const __NR_compat32_process_madvise: u32 = 440;
pub const __NR_compat32_epoll_pwait2: u32 = 441;
pub const __NR_compat32_mount_setattr: u32 = 442;
pub const __NR_compat32_quotactl_fd: u32 = 443;
pub const __NR_compat32_landlock_create_ruleset: u32 = 444;
pub const __NR_compat32_landlock_add_rule: u32 = 445;
pub const __NR_compat32_landlock_restrict_self: u32 = 446;
pub const __NR_compat32_process_mrelease: u32 = 448;
pub const __NR_compat32_futex_waitv: u32 = 449;
pub const __NR_compat32_set_mempolicy_home_node: u32 = 450;
pub const __NR_compat32_cachestat: u32 = 451;
pub const __NR_compat32_fchmodat2: u32 = 452;
pub const __NR_compat32_map_shadow_stack: u32 = 453;
pub const __NR_compat32_futex_wake: u32 = 454;
pub const __NR_compat32_futex_wait: u32 = 455;
pub const __NR_compat32_futex_requeue: u32 = 456;
pub const __NR_compat32_statmount: u32 = 457;
pub const __NR_compat32_listmount: u32 = 458;
pub const __NR_compat32_lsm_get_self_attr: u32 = 459;
pub const __NR_compat32_lsm_set_self_attr: u32 = 460;
pub const __NR_compat32_lsm_list_modules: u32 = 461;
pub const __NR_compat32_mseal: u32 = 462;
pub const __NR_compat32_setxattrat: u32 = 463;
pub const __NR_compat32_getxattrat: u32 = 464;
pub const __NR_compat32_listxattrat: u32 = 465;
pub const __NR_compat32_removexattrat: u32 = 466;
pub const __NR_compat32_open_tree_attr: u32 = 467;
pub const __NR_compat32_syscalls: u32 = 468;
pub const __NR_seccomp_read_32: u32 = 3;
pub const __NR_seccomp_write_32: u32 = 4;
pub const __NR_seccomp_exit_32: u32 = 1;
pub const __NR_seccomp_sigreturn_32: u32 = 173;
pub const __ARM_NR_COMPAT_BASE: u32 = 983040;
pub const __ARM_NR_compat_cacheflush: u32 = 983042;
pub const __ARM_NR_compat_set_tls: u32 = 983045;
pub const __ARM_NR_COMPAT_END: u32 = 985088;
pub const __NR_io_setup: u32 = 0;
pub const __NR_io_destroy: u32 = 1;
pub const __NR_io_submit: u32 = 2;
pub const __NR_io_cancel: u32 = 3;
pub const __NR_io_getevents: u32 = 4;
pub const __NR_setxattr: u32 = 5;
pub const __NR_lsetxattr: u32 = 6;
pub const __NR_fsetxattr: u32 = 7;
pub const __NR_getxattr: u32 = 8;
pub const __NR_lgetxattr: u32 = 9;
pub const __NR_fgetxattr: u32 = 10;
pub const __NR_listxattr: u32 = 11;
pub const __NR_llistxattr: u32 = 12;
pub const __NR_flistxattr: u32 = 13;
pub const __NR_removexattr: u32 = 14;
pub const __NR_lremovexattr: u32 = 15;
pub const __NR_fremovexattr: u32 = 16;
pub const __NR_getcwd: u32 = 17;
pub const __NR_lookup_dcookie: u32 = 18;
pub const __NR_eventfd2: u32 = 19;
pub const __NR_epoll_create1: u32 = 20;
pub const __NR_epoll_ctl: u32 = 21;
pub const __NR_epoll_pwait: u32 = 22;
pub const __NR_dup: u32 = 23;
pub const __NR_dup3: u32 = 24;
pub const __NR_fcntl: u32 = 25;
pub const __NR_inotify_init1: u32 = 26;
pub const __NR_inotify_add_watch: u32 = 27;
pub const __NR_inotify_rm_watch: u32 = 28;
pub const __NR_ioctl: u32 = 29;
pub const __NR_ioprio_set: u32 = 30;
pub const __NR_ioprio_get: u32 = 31;
pub const __NR_flock: u32 = 32;
pub const __NR_mknodat: u32 = 33;
pub const __NR_mkdirat: u32 = 34;
pub const __NR_unlinkat: u32 = 35;
pub const __NR_symlinkat: u32 = 36;
pub const __NR_linkat: u32 = 37;
pub const __NR_renameat: u32 = 38;
pub const __NR_umount2: u32 = 39;
pub const __NR_mount: u32 = 40;
pub const __NR_pivot_root: u32 = 41;
pub const __NR_nfsservctl: u32 = 42;
pub const __NR_statfs: u32 = 43;
pub const __NR_fstatfs: u32 = 44;
pub const __NR_truncate: u32 = 45;
pub const __NR_ftruncate: u32 = 46;
pub const __NR_fallocate: u32 = 47;
pub const __NR_faccessat: u32 = 48;
pub const __NR_chdir: u32 = 49;
pub const __NR_fchdir: u32 = 50;
pub const __NR_chroot: u32 = 51;
pub const __NR_fchmod: u32 = 52;
pub const __NR_fchmodat: u32 = 53;
pub const __NR_fchownat: u32 = 54;
pub const __NR_fchown: u32 = 55;
pub const __NR_openat: u32 = 56;
pub const __NR_close: u32 = 57;
pub const __NR_vhangup: u32 = 58;
pub const __NR_pipe2: u32 = 59;
pub const __NR_quotactl: u32 = 60;
pub const __NR_getdents64: u32 = 61;
pub const __NR_lseek: u32 = 62;
pub const __NR_read: u32 = 63;
pub const __NR_write: u32 = 64;
pub const __NR_readv: u32 = 65;
pub const __NR_writev: u32 = 66;
pub const __NR_pread64: u32 = 67;
pub const __NR_pwrite64: u32 = 68;
pub const __NR_preadv: u32 = 69;
pub const __NR_pwritev: u32 = 70;
pub const __NR_sendfile: u32 = 71;
pub const __NR_pselect6: u32 = 72;
pub const __NR_ppoll: u32 = 73;
pub const __NR_signalfd4: u32 = 74;
pub const __NR_vmsplice: u32 = 75;
pub const __NR_splice: u32 = 76;
pub const __NR_tee: u32 = 77;
pub const __NR_readlinkat: u32 = 78;
pub const __NR_newfstatat: u32 = 79;
pub const __NR_fstat: u32 = 80;
pub const __NR_sync: u32 = 81;
pub const __NR_fsync: u32 = 82;
pub const __NR_fdatasync: u32 = 83;
pub const __NR_sync_file_range: u32 = 84;
pub const __NR_timerfd_create: u32 = 85;
pub const __NR_timerfd_settime: u32 = 86;
pub const __NR_timerfd_gettime: u32 = 87;
pub const __NR_utimensat: u32 = 88;
pub const __NR_acct: u32 = 89;
pub const __NR_capget: u32 = 90;
pub const __NR_capset: u32 = 91;
pub const __NR_personality: u32 = 92;
pub const __NR_exit: u32 = 93;
pub const __NR_exit_group: u32 = 94;
pub const __NR_waitid: u32 = 95;
pub const __NR_set_tid_address: u32 = 96;
pub const __NR_unshare: u32 = 97;
pub const __NR_futex: u32 = 98;
pub const __NR_set_robust_list: u32 = 99;
pub const __NR_get_robust_list: u32 = 100;
pub const __NR_nanosleep: u32 = 101;
pub const __NR_getitimer: u32 = 102;
pub const __NR_setitimer: u32 = 103;
pub const __NR_kexec_load: u32 = 104;
pub const __NR_init_module: u32 = 105;
pub const __NR_delete_module: u32 = 106;
pub const __NR_timer_create: u32 = 107;
pub const __NR_timer_gettime: u32 = 108;
pub const __NR_timer_getoverrun: u32 = 109;
pub const __NR_timer_settime: u32 = 110;
pub const __NR_timer_delete: u32 = 111;
pub const __NR_clock_settime: u32 = 112;
pub const __NR_clock_gettime: u32 = 113;
pub const __NR_clock_getres: u32 = 114;
pub const __NR_clock_nanosleep: u32 = 115;
pub const __NR_syslog: u32 = 116;
pub const __NR_ptrace: u32 = 117;
pub const __NR_sched_setparam: u32 = 118;
pub const __NR_sched_setscheduler: u32 = 119;
pub const __NR_sched_getscheduler: u32 = 120;
pub const __NR_sched_getparam: u32 = 121;
pub const __NR_sched_setaffinity: u32 = 122;
pub const __NR_sched_getaffinity: u32 = 123;
pub const __NR_sched_yield: u32 = 124;
pub const __NR_sched_get_priority_max: u32 = 125;
pub const __NR_sched_get_priority_min: u32 = 126;
pub const __NR_sched_rr_get_interval: u32 = 127;
pub const __NR_restart_syscall: u32 = 128;
pub const __NR_kill: u32 = 129;
pub const __NR_tkill: u32 = 130;
pub const __NR_tgkill: u32 = 131;
pub const __NR_sigaltstack: u32 = 132;
pub const __NR_rt_sigsuspend: u32 = 133;
pub const __NR_rt_sigaction: u32 = 134;
pub const __NR_rt_sigprocmask: u32 = 135;
pub const __NR_rt_sigpending: u32 = 136;
pub const __NR_rt_sigtimedwait: u32 = 137;
pub const __NR_rt_sigqueueinfo: u32 = 138;
pub const __NR_rt_sigreturn: u32 = 139;
pub const __NR_setpriority: u32 = 140;
pub const __NR_getpriority: u32 = 141;
pub const __NR_reboot: u32 = 142;
pub const __NR_setregid: u32 = 143;
pub const __NR_setgid: u32 = 144;
pub const __NR_setreuid: u32 = 145;
pub const __NR_setuid: u32 = 146;
pub const __NR_setresuid: u32 = 147;
pub const __NR_getresuid: u32 = 148;
pub const __NR_setresgid: u32 = 149;
pub const __NR_getresgid: u32 = 150;
pub const __NR_setfsuid: u32 = 151;
pub const __NR_setfsgid: u32 = 152;
pub const __NR_times: u32 = 153;
pub const __NR_setpgid: u32 = 154;
pub const __NR_getpgid: u32 = 155;
pub const __NR_getsid: u32 = 156;
pub const __NR_setsid: u32 = 157;
pub const __NR_getgroups: u32 = 158;
pub const __NR_setgroups: u32 = 159;
pub const __NR_uname: u32 = 160;
pub const __NR_sethostname: u32 = 161;
pub const __NR_setdomainname: u32 = 162;
pub const __NR_getrlimit: u32 = 163;
pub const __NR_setrlimit: u32 = 164;
pub const __NR_getrusage: u32 = 165;
pub const __NR_umask: u32 = 166;
pub const __NR_prctl: u32 = 167;
pub const __NR_getcpu: u32 = 168;
pub const __NR_gettimeofday: u32 = 169;
pub const __NR_settimeofday: u32 = 170;
pub const __NR_adjtimex: u32 = 171;
pub const __NR_getpid: u32 = 172;
pub const __NR_getppid: u32 = 173;
pub const __NR_getuid: u32 = 174;
pub const __NR_geteuid: u32 = 175;
pub const __NR_getgid: u32 = 176;
pub const __NR_getegid: u32 = 177;
pub const __NR_gettid: u32 = 178;
pub const __NR_sysinfo: u32 = 179;
pub const __NR_mq_open: u32 = 180;
pub const __NR_mq_unlink: u32 = 181;
pub const __NR_mq_timedsend: u32 = 182;
pub const __NR_mq_timedreceive: u32 = 183;
pub const __NR_mq_notify: u32 = 184;
pub const __NR_mq_getsetattr: u32 = 185;
pub const __NR_msgget: u32 = 186;
pub const __NR_msgctl: u32 = 187;
pub const __NR_msgrcv: u32 = 188;
pub const __NR_msgsnd: u32 = 189;
pub const __NR_semget: u32 = 190;
pub const __NR_semctl: u32 = 191;
pub const __NR_semtimedop: u32 = 192;
pub const __NR_semop: u32 = 193;
pub const __NR_shmget: u32 = 194;
pub const __NR_shmctl: u32 = 195;
pub const __NR_shmat: u32 = 196;
pub const __NR_shmdt: u32 = 197;
pub const __NR_socket: u32 = 198;
pub const __NR_socketpair: u32 = 199;
pub const __NR_bind: u32 = 200;
pub const __NR_listen: u32 = 201;
pub const __NR_accept: u32 = 202;
pub const __NR_connect: u32 = 203;
pub const __NR_getsockname: u32 = 204;
pub const __NR_getpeername: u32 = 205;
pub const __NR_sendto: u32 = 206;
pub const __NR_recvfrom: u32 = 207;
pub const __NR_setsockopt: u32 = 208;
pub const __NR_getsockopt: u32 = 209;
pub const __NR_shutdown: u32 = 210;
pub const __NR_sendmsg: u32 = 211;
pub const __NR_recvmsg: u32 = 212;
pub const __NR_readahead: u32 = 213;
pub const __NR_brk: u32 = 214;
pub const __NR_munmap: u32 = 215;
pub const __NR_mremap: u32 = 216;
pub const __NR_add_key: u32 = 217;
pub const __NR_request_key: u32 = 218;
pub const __NR_keyctl: u32 = 219;
pub const __NR_clone: u32 = 220;
pub const __NR_execve: u32 = 221;
pub const __NR_mmap: u32 = 222;
pub const __NR_fadvise64: u32 = 223;
pub const __NR_swapon: u32 = 224;
pub const __NR_swapoff: u32 = 225;
pub const __NR_mprotect: u32 = 226;
pub const __NR_msync: u32 = 227;
pub const __NR_mlock: u32 = 228;
pub const __NR_munlock: u32 = 229;
pub const __NR_mlockall: u32 = 230;
pub const __NR_munlockall: u32 = 231;
pub const __NR_mincore: u32 = 232;
pub const __NR_madvise: u32 = 233;
pub const __NR_remap_file_pages: u32 = 234;
pub const __NR_mbind: u32 = 235;
pub const __NR_get_mempolicy: u32 = 236;
pub const __NR_set_mempolicy: u32 = 237;
pub const __NR_migrate_pages: u32 = 238;
pub const __NR_move_pages: u32 = 239;
pub const __NR_rt_tgsigqueueinfo: u32 = 240;
pub const __NR_perf_event_open: u32 = 241;
pub const __NR_accept4: u32 = 242;
pub const __NR_recvmmsg: u32 = 243;
pub const __NR_wait4: u32 = 260;
pub const __NR_prlimit64: u32 = 261;
pub const __NR_fanotify_init: u32 = 262;
pub const __NR_fanotify_mark: u32 = 263;
pub const __NR_name_to_handle_at: u32 = 264;
pub const __NR_open_by_handle_at: u32 = 265;
pub const __NR_clock_adjtime: u32 = 266;
pub const __NR_syncfs: u32 = 267;
pub const __NR_setns: u32 = 268;
pub const __NR_sendmmsg: u32 = 269;
pub const __NR_process_vm_readv: u32 = 270;
pub const __NR_process_vm_writev: u32 = 271;
pub const __NR_kcmp: u32 = 272;
pub const __NR_finit_module: u32 = 273;
pub const __NR_sched_setattr: u32 = 274;
pub const __NR_sched_getattr: u32 = 275;
pub const __NR_renameat2: u32 = 276;
pub const __NR_seccomp: u32 = 277;
pub const __NR_getrandom: u32 = 278;
pub const __NR_memfd_create: u32 = 279;
pub const __NR_bpf: u32 = 280;
pub const __NR_execveat: u32 = 281;
pub const __NR_userfaultfd: u32 = 282;
pub const __NR_membarrier: u32 = 283;
pub const __NR_mlock2: u32 = 284;
pub const __NR_copy_file_range: u32 = 285;
pub const __NR_preadv2: u32 = 286;
pub const __NR_pwritev2: u32 = 287;
pub const __NR_pkey_mprotect: u32 = 288;
pub const __NR_pkey_alloc: u32 = 289;
pub const __NR_pkey_free: u32 = 290;
pub const __NR_statx: u32 = 291;
pub const __NR_io_pgetevents: u32 = 292;
pub const __NR_rseq: u32 = 293;
pub const __NR_kexec_file_load: u32 = 294;
pub const __NR_pidfd_send_signal: u32 = 424;
pub const __NR_io_uring_setup: u32 = 425;
pub const __NR_io_uring_enter: u32 = 426;
pub const __NR_io_uring_register: u32 = 427;
pub const __NR_open_tree: u32 = 428;
pub const __NR_move_mount: u32 = 429;
pub const __NR_fsopen: u32 = 430;
pub const __NR_fsconfig: u32 = 431;
pub const __NR_fsmount: u32 = 432;
pub const __NR_fspick: u32 = 433;
pub const __NR_pidfd_open: u32 = 434;
pub const __NR_clone3: u32 = 435;
pub const __NR_close_range: u32 = 436;
pub const __NR_openat2: u32 = 437;
pub const __NR_pidfd_getfd: u32 = 438;
pub const __NR_faccessat2: u32 = 439;
pub const __NR_process_madvise: u32 = 440;
pub const __NR_epoll_pwait2: u32 = 441;
pub const __NR_mount_setattr: u32 = 442;
pub const __NR_quotactl_fd: u32 = 443;
pub const __NR_landlock_create_ruleset: u32 = 444;
pub const __NR_landlock_add_rule: u32 = 445;
pub const __NR_landlock_restrict_self: u32 = 446;
pub const __NR_memfd_secret: u32 = 447;
pub const __NR_process_mrelease: u32 = 448;
pub const __NR_futex_waitv: u32 = 449;
pub const __NR_set_mempolicy_home_node: u32 = 450;
pub const __NR_cachestat: u32 = 451;
pub const __NR_fchmodat2: u32 = 452;
pub const __NR_map_shadow_stack: u32 = 453;
pub const __NR_futex_wake: u32 = 454;
pub const __NR_futex_wait: u32 = 455;
pub const __NR_futex_requeue: u32 = 456;
pub const __NR_statmount: u32 = 457;
pub const __NR_listmount: u32 = 458;
pub const __NR_lsm_get_self_attr: u32 = 459;
pub const __NR_lsm_set_self_attr: u32 = 460;
pub const __NR_lsm_list_modules: u32 = 461;
pub const __NR_mseal: u32 = 462;
pub const __NR_setxattrat: u32 = 463;
pub const __NR_getxattrat: u32 = 464;
pub const __NR_listxattrat: u32 = 465;
pub const __NR_removexattrat: u32 = 466;
pub const __NR_open_tree_attr: u32 = 467;
pub const __NR_syscalls: u32 = 468;
pub const NR_syscalls: u32 = 468;
pub const __NR_seccomp_read: u32 = 63;
pub const __NR_seccomp_write: u32 = 64;
pub const __NR_seccomp_exit: u32 = 93;
pub const __NR_seccomp_sigreturn: u32 = 139;
pub const SECCOMP_ARCH_NATIVE_NR: u32 = 468;
pub const SECCOMP_ARCH_NATIVE_NAME: &[u8; 8] = b"aarch64\0";
pub const SECCOMP_ARCH_COMPAT_NR: u32 = 468;
pub const SECCOMP_ARCH_COMPAT_NAME: &[u8; 4] = b"arm\0";
pub const PT_SEIZED: u32 = 65536;
pub const PT_PTRACED: u32 = 1;
pub const PT_OPT_FLAG_SHIFT: u32 = 3;
pub const PT_EXITKILL: u32 = 8388608;
pub const PT_SUSPEND_SECCOMP: u32 = 16777216;
pub const PTRACE_MODE_READ: u32 = 1;
pub const PTRACE_MODE_ATTACH: u32 = 2;
pub const PTRACE_MODE_NOAUDIT: u32 = 4;
pub const PTRACE_MODE_FSCREDS: u32 = 8;
pub const PTRACE_MODE_REALCREDS: u32 = 16;
pub const PTRACE_MODE_READ_FSCREDS: u32 = 9;
pub const PTRACE_MODE_READ_REALCREDS: u32 = 17;
pub const PTRACE_MODE_ATTACH_FSCREDS: u32 = 10;
pub const PTRACE_MODE_ATTACH_REALCREDS: u32 = 18;
pub const ARCH_SUPPORTS_FTRACE_OPS: u32 = 1;
pub const MCOUNT_INSN_SIZE: u32 = 4;
pub const FTRACE_PLT_IDX: u32 = 0;
pub const NR_FTRACE_PLTS: u32 = 1;
pub const ARCH_FTRACE_SHIFT_STACK_TRACER: u32 = 1;
pub const IPC_CREAT: u32 = 512;
pub const IPC_EXCL: u32 = 1024;
pub const IPC_NOWAIT: u32 = 2048;
pub const IPC_DIPC: u32 = 4096;
pub const IPC_OWN: u32 = 8192;
pub const IPC_RMID: u32 = 0;
pub const IPC_SET: u32 = 1;
pub const IPC_STAT: u32 = 2;
pub const IPC_INFO: u32 = 3;
pub const IPC_OLD: u32 = 0;
pub const IPC_64: u32 = 256;
pub const SEMOP: u32 = 1;
pub const SEMGET: u32 = 2;
pub const SEMCTL: u32 = 3;
pub const SEMTIMEDOP: u32 = 4;
pub const MSGSND: u32 = 11;
pub const MSGRCV: u32 = 12;
pub const MSGGET: u32 = 13;
pub const MSGCTL: u32 = 14;
pub const SHMAT: u32 = 21;
pub const SHMDT: u32 = 22;
pub const SHMGET: u32 = 23;
pub const SHMCTL: u32 = 24;
pub const DIPC: u32 = 25;
pub const SEM_UNDO: u32 = 4096;
pub const GETPID: u32 = 11;
pub const GETVAL: u32 = 12;
pub const GETALL: u32 = 13;
pub const GETNCNT: u32 = 14;
pub const GETZCNT: u32 = 15;
pub const SETVAL: u32 = 16;
pub const SETALL: u32 = 17;
pub const SEM_STAT: u32 = 18;
pub const SEM_INFO: u32 = 19;
pub const SEM_STAT_ANY: u32 = 20;
pub const SEMMNI: u32 = 32000;
pub const SEMMSL: u32 = 32000;
pub const SEMMNS: u32 = 1024000000;
pub const SEMOPM: u32 = 500;
pub const SEMVMX: u32 = 32767;
pub const SEMAEM: u32 = 32767;
pub const SEMUME: u32 = 500;
pub const SEMMNU: u32 = 1024000000;
pub const SEMMAP: u32 = 1024000000;
pub const SEMUSZ: u32 = 20;
pub const FIOSETOWN: u32 = 35073;
pub const SIOCSPGRP: u32 = 35074;
pub const FIOGETOWN: u32 = 35075;
pub const SIOCGPGRP: u32 = 35076;
pub const SIOCATMARK: u32 = 35077;
pub const SIOCGSTAMP_OLD: u32 = 35078;
pub const SIOCGSTAMPNS_OLD: u32 = 35079;
pub const SOL_SOCKET: u32 = 1;
pub const SO_DEBUG: u32 = 1;
pub const SO_REUSEADDR: u32 = 2;
pub const SO_TYPE: u32 = 3;
pub const SO_ERROR: u32 = 4;
pub const SO_DONTROUTE: u32 = 5;
pub const SO_BROADCAST: u32 = 6;
pub const SO_SNDBUF: u32 = 7;
pub const SO_RCVBUF: u32 = 8;
pub const SO_SNDBUFFORCE: u32 = 32;
pub const SO_RCVBUFFORCE: u32 = 33;
pub const SO_KEEPALIVE: u32 = 9;
pub const SO_OOBINLINE: u32 = 10;
pub const SO_NO_CHECK: u32 = 11;
pub const SO_PRIORITY: u32 = 12;
pub const SO_LINGER: u32 = 13;
pub const SO_BSDCOMPAT: u32 = 14;
pub const SO_REUSEPORT: u32 = 15;
pub const SO_PASSCRED: u32 = 16;
pub const SO_PEERCRED: u32 = 17;
pub const SO_RCVLOWAT: u32 = 18;
pub const SO_SNDLOWAT: u32 = 19;
pub const SO_RCVTIMEO_OLD: u32 = 20;
pub const SO_SNDTIMEO_OLD: u32 = 21;
pub const SO_SECURITY_AUTHENTICATION: u32 = 22;
pub const SO_SECURITY_ENCRYPTION_TRANSPORT: u32 = 23;
pub const SO_SECURITY_ENCRYPTION_NETWORK: u32 = 24;
pub const SO_BINDTODEVICE: u32 = 25;
pub const SO_ATTACH_FILTER: u32 = 26;
pub const SO_DETACH_FILTER: u32 = 27;
pub const SO_GET_FILTER: u32 = 26;
pub const SO_PEERNAME: u32 = 28;
pub const SO_ACCEPTCONN: u32 = 30;
pub const SO_PEERSEC: u32 = 31;
pub const SO_PASSSEC: u32 = 34;
pub const SO_MARK: u32 = 36;
pub const SO_PROTOCOL: u32 = 38;
pub const SO_DOMAIN: u32 = 39;
pub const SO_RXQ_OVFL: u32 = 40;
pub const SO_WIFI_STATUS: u32 = 41;
pub const SCM_WIFI_STATUS: u32 = 41;
pub const SO_PEEK_OFF: u32 = 42;
pub const SO_NOFCS: u32 = 43;
pub const SO_LOCK_FILTER: u32 = 44;
pub const SO_SELECT_ERR_QUEUE: u32 = 45;
pub const SO_BUSY_POLL: u32 = 46;
pub const SO_MAX_PACING_RATE: u32 = 47;
pub const SO_BPF_EXTENSIONS: u32 = 48;
pub const SO_INCOMING_CPU: u32 = 49;
pub const SO_ATTACH_BPF: u32 = 50;
pub const SO_DETACH_BPF: u32 = 27;
pub const SO_ATTACH_REUSEPORT_CBPF: u32 = 51;
pub const SO_ATTACH_REUSEPORT_EBPF: u32 = 52;
pub const SO_CNX_ADVICE: u32 = 53;
pub const SCM_TIMESTAMPING_OPT_STATS: u32 = 54;
pub const SO_MEMINFO: u32 = 55;
pub const SO_INCOMING_NAPI_ID: u32 = 56;
pub const SO_COOKIE: u32 = 57;
pub const SCM_TIMESTAMPING_PKTINFO: u32 = 58;
pub const SO_PEERGROUPS: u32 = 59;
pub const SO_ZEROCOPY: u32 = 60;
pub const SO_TXTIME: u32 = 61;
pub const SCM_TXTIME: u32 = 61;
pub const SO_BINDTOIFINDEX: u32 = 62;
pub const SO_TIMESTAMP_OLD: u32 = 29;
pub const SO_TIMESTAMPNS_OLD: u32 = 35;
pub const SO_TIMESTAMPING_OLD: u32 = 37;
pub const SO_TIMESTAMP_NEW: u32 = 63;
pub const SO_TIMESTAMPNS_NEW: u32 = 64;
pub const SO_TIMESTAMPING_NEW: u32 = 65;
pub const SO_RCVTIMEO_NEW: u32 = 66;
pub const SO_SNDTIMEO_NEW: u32 = 67;
pub const SO_DETACH_REUSEPORT_BPF: u32 = 68;
pub const SO_PREFER_BUSY_POLL: u32 = 69;
pub const SO_BUSY_POLL_BUDGET: u32 = 70;
pub const SO_NETNS_COOKIE: u32 = 71;
pub const SO_BUF_LOCK: u32 = 72;
pub const SO_RESERVE_MEM: u32 = 73;
pub const SO_TXREHASH: u32 = 74;
pub const SO_RCVMARK: u32 = 75;
pub const SO_PASSPIDFD: u32 = 76;
pub const SO_PEERPIDFD: u32 = 77;
pub const SO_DEVMEM_LINEAR: u32 = 78;
pub const SCM_DEVMEM_LINEAR: u32 = 78;
pub const SO_DEVMEM_DMABUF: u32 = 79;
pub const SCM_DEVMEM_DMABUF: u32 = 79;
pub const SO_DEVMEM_DONTNEED: u32 = 80;
pub const SCM_TS_OPT_ID: u32 = 81;
pub const SO_RCVPRIORITY: u32 = 82;
pub const SOCK_IOC_TYPE: u32 = 137;
pub const SIOCGSTAMP: u32 = 35078;
pub const SIOCGSTAMPNS: u32 = 35079;
pub const SIOCADDRT: u32 = 35083;
pub const SIOCDELRT: u32 = 35084;
pub const SIOCRTMSG: u32 = 35085;
pub const SIOCGIFNAME: u32 = 35088;
pub const SIOCSIFLINK: u32 = 35089;
pub const SIOCGIFCONF: u32 = 35090;
pub const SIOCGIFFLAGS: u32 = 35091;
pub const SIOCSIFFLAGS: u32 = 35092;
pub const SIOCGIFADDR: u32 = 35093;
pub const SIOCSIFADDR: u32 = 35094;
pub const SIOCGIFDSTADDR: u32 = 35095;
pub const SIOCSIFDSTADDR: u32 = 35096;
pub const SIOCGIFBRDADDR: u32 = 35097;
pub const SIOCSIFBRDADDR: u32 = 35098;
pub const SIOCGIFNETMASK: u32 = 35099;
pub const SIOCSIFNETMASK: u32 = 35100;
pub const SIOCGIFMETRIC: u32 = 35101;
pub const SIOCSIFMETRIC: u32 = 35102;
pub const SIOCGIFMEM: u32 = 35103;
pub const SIOCSIFMEM: u32 = 35104;
pub const SIOCGIFMTU: u32 = 35105;
pub const SIOCSIFMTU: u32 = 35106;
pub const SIOCSIFNAME: u32 = 35107;
pub const SIOCSIFHWADDR: u32 = 35108;
pub const SIOCGIFENCAP: u32 = 35109;
pub const SIOCSIFENCAP: u32 = 35110;
pub const SIOCGIFHWADDR: u32 = 35111;
pub const SIOCGIFSLAVE: u32 = 35113;
pub const SIOCSIFSLAVE: u32 = 35120;
pub const SIOCADDMULTI: u32 = 35121;
pub const SIOCDELMULTI: u32 = 35122;
pub const SIOCGIFINDEX: u32 = 35123;
pub const SIOGIFINDEX: u32 = 35123;
pub const SIOCSIFPFLAGS: u32 = 35124;
pub const SIOCGIFPFLAGS: u32 = 35125;
pub const SIOCDIFADDR: u32 = 35126;
pub const SIOCSIFHWBROADCAST: u32 = 35127;
pub const SIOCGIFCOUNT: u32 = 35128;
pub const SIOCGIFBR: u32 = 35136;
pub const SIOCSIFBR: u32 = 35137;
pub const SIOCGIFTXQLEN: u32 = 35138;
pub const SIOCSIFTXQLEN: u32 = 35139;
pub const SIOCETHTOOL: u32 = 35142;
pub const SIOCGMIIPHY: u32 = 35143;
pub const SIOCGMIIREG: u32 = 35144;
pub const SIOCSMIIREG: u32 = 35145;
pub const SIOCWANDEV: u32 = 35146;
pub const SIOCOUTQNSD: u32 = 35147;
pub const SIOCGSKNS: u32 = 35148;
pub const SIOCDARP: u32 = 35155;
pub const SIOCGARP: u32 = 35156;
pub const SIOCSARP: u32 = 35157;
pub const SIOCDRARP: u32 = 35168;
pub const SIOCGRARP: u32 = 35169;
pub const SIOCSRARP: u32 = 35170;
pub const SIOCGIFMAP: u32 = 35184;
pub const SIOCSIFMAP: u32 = 35185;
pub const SIOCADDDLCI: u32 = 35200;
pub const SIOCDELDLCI: u32 = 35201;
pub const SIOCGIFVLAN: u32 = 35202;
pub const SIOCSIFVLAN: u32 = 35203;
pub const SIOCBONDENSLAVE: u32 = 35216;
pub const SIOCBONDRELEASE: u32 = 35217;
pub const SIOCBONDSETHWADDR: u32 = 35218;
pub const SIOCBONDSLAVEINFOQUERY: u32 = 35219;
pub const SIOCBONDINFOQUERY: u32 = 35220;
pub const SIOCBONDCHANGEACTIVE: u32 = 35221;
pub const SIOCBRADDBR: u32 = 35232;
pub const SIOCBRDELBR: u32 = 35233;
pub const SIOCBRADDIF: u32 = 35234;
pub const SIOCBRDELIF: u32 = 35235;
pub const SIOCSHWTSTAMP: u32 = 35248;
pub const SIOCGHWTSTAMP: u32 = 35249;
pub const SIOCDEVPRIVATE: u32 = 35312;
pub const SIOCPROTOPRIVATE: u32 = 35296;
pub const UIO_FASTIOV: u32 = 8;
pub const UIO_MAXIOV: u32 = 1024;
pub const ITER_SOURCE: u32 = 1;
pub const ITER_DEST: u32 = 0;
pub const _K_SS_MAXSIZE: u32 = 128;
pub const SOCK_SNDBUF_LOCK: u32 = 1;
pub const SOCK_RCVBUF_LOCK: u32 = 2;
pub const SOCK_BUF_LOCK_MASK: u32 = 3;
pub const SOCK_TXREHASH_DEFAULT: u32 = 255;
pub const SOCK_TXREHASH_DISABLED: u32 = 0;
pub const SOCK_TXREHASH_ENABLED: u32 = 1;
pub const SCM_RIGHTS: u32 = 1;
pub const SCM_CREDENTIALS: u32 = 2;
pub const SCM_SECURITY: u32 = 3;
pub const SCM_PIDFD: u32 = 4;
pub const AF_UNSPEC: u32 = 0;
pub const AF_UNIX: u32 = 1;
pub const AF_LOCAL: u32 = 1;
pub const AF_INET: u32 = 2;
pub const AF_AX25: u32 = 3;
pub const AF_IPX: u32 = 4;
pub const AF_APPLETALK: u32 = 5;
pub const AF_NETROM: u32 = 6;
pub const AF_BRIDGE: u32 = 7;
pub const AF_ATMPVC: u32 = 8;
pub const AF_X25: u32 = 9;
pub const AF_INET6: u32 = 10;
pub const AF_ROSE: u32 = 11;
pub const AF_DECnet: u32 = 12;
pub const AF_NETBEUI: u32 = 13;
pub const AF_SECURITY: u32 = 14;
pub const AF_KEY: u32 = 15;
pub const AF_NETLINK: u32 = 16;
pub const AF_ROUTE: u32 = 16;
pub const AF_PACKET: u32 = 17;
pub const AF_ASH: u32 = 18;
pub const AF_ECONET: u32 = 19;
pub const AF_ATMSVC: u32 = 20;
pub const AF_RDS: u32 = 21;
pub const AF_SNA: u32 = 22;
pub const AF_IRDA: u32 = 23;
pub const AF_PPPOX: u32 = 24;
pub const AF_WANPIPE: u32 = 25;
pub const AF_LLC: u32 = 26;
pub const AF_IB: u32 = 27;
pub const AF_MPLS: u32 = 28;
pub const AF_CAN: u32 = 29;
pub const AF_TIPC: u32 = 30;
pub const AF_BLUETOOTH: u32 = 31;
pub const AF_IUCV: u32 = 32;
pub const AF_RXRPC: u32 = 33;
pub const AF_ISDN: u32 = 34;
pub const AF_PHONET: u32 = 35;
pub const AF_IEEE802154: u32 = 36;
pub const AF_CAIF: u32 = 37;
pub const AF_ALG: u32 = 38;
pub const AF_NFC: u32 = 39;
pub const AF_VSOCK: u32 = 40;
pub const AF_KCM: u32 = 41;
pub const AF_QIPCRTR: u32 = 42;
pub const AF_SMC: u32 = 43;
pub const AF_XDP: u32 = 44;
pub const AF_MCTP: u32 = 45;
pub const AF_MAX: u32 = 46;
pub const PF_UNSPEC: u32 = 0;
pub const PF_UNIX: u32 = 1;
pub const PF_LOCAL: u32 = 1;
pub const PF_INET: u32 = 2;
pub const PF_AX25: u32 = 3;
pub const PF_IPX: u32 = 4;
pub const PF_APPLETALK: u32 = 5;
pub const PF_NETROM: u32 = 6;
pub const PF_BRIDGE: u32 = 7;
pub const PF_ATMPVC: u32 = 8;
pub const PF_X25: u32 = 9;
pub const PF_INET6: u32 = 10;
pub const PF_ROSE: u32 = 11;
pub const PF_DECnet: u32 = 12;
pub const PF_NETBEUI: u32 = 13;
pub const PF_SECURITY: u32 = 14;
pub const PF_KEY: u32 = 15;
pub const PF_NETLINK: u32 = 16;
pub const PF_ROUTE: u32 = 16;
pub const PF_PACKET: u32 = 17;
pub const PF_ASH: u32 = 18;
pub const PF_ECONET: u32 = 19;
pub const PF_ATMSVC: u32 = 20;
pub const PF_RDS: u32 = 21;
pub const PF_SNA: u32 = 22;
pub const PF_IRDA: u32 = 23;
pub const PF_PPPOX: u32 = 24;
pub const PF_WANPIPE: u32 = 25;
pub const PF_LLC: u32 = 26;
pub const PF_IB: u32 = 27;
pub const PF_MPLS: u32 = 28;
pub const PF_CAN: u32 = 29;
pub const PF_TIPC: u32 = 30;
pub const PF_BLUETOOTH: u32 = 31;
pub const PF_IUCV: u32 = 32;
pub const PF_RXRPC: u32 = 33;
pub const PF_ISDN: u32 = 34;
pub const PF_PHONET: u32 = 35;
pub const PF_IEEE802154: u32 = 36;
pub const PF_CAIF: u32 = 37;
pub const PF_ALG: u32 = 38;
pub const PF_NFC: u32 = 39;
pub const PF_VSOCK: u32 = 40;
pub const PF_KCM: u32 = 41;
pub const PF_QIPCRTR: u32 = 42;
pub const PF_SMC: u32 = 43;
pub const PF_XDP: u32 = 44;
pub const PF_MCTP: u32 = 45;
pub const PF_MAX: u32 = 46;
pub const SOMAXCONN: u32 = 4096;
pub const MSG_OOB: u32 = 1;
pub const MSG_PEEK: u32 = 2;
pub const MSG_DONTROUTE: u32 = 4;
pub const MSG_TRYHARD: u32 = 4;
pub const MSG_CTRUNC: u32 = 8;
pub const MSG_PROBE: u32 = 16;
pub const MSG_TRUNC: u32 = 32;
pub const MSG_DONTWAIT: u32 = 64;
pub const MSG_EOR: u32 = 128;
pub const MSG_WAITALL: u32 = 256;
pub const MSG_FIN: u32 = 512;
pub const MSG_SYN: u32 = 1024;
pub const MSG_CONFIRM: u32 = 2048;
pub const MSG_RST: u32 = 4096;
pub const MSG_ERRQUEUE: u32 = 8192;
pub const MSG_NOSIGNAL: u32 = 16384;
pub const MSG_MORE: u32 = 32768;
pub const MSG_WAITFORONE: u32 = 65536;
pub const MSG_SENDPAGE_NOPOLICY: u32 = 65536;
pub const MSG_BATCH: u32 = 262144;
pub const MSG_EOF: u32 = 512;
pub const MSG_NO_SHARED_FRAGS: u32 = 524288;
pub const MSG_SENDPAGE_DECRYPTED: u32 = 1048576;
pub const MSG_SOCK_DEVMEM: u32 = 33554432;
pub const MSG_ZEROCOPY: u32 = 67108864;
pub const MSG_SPLICE_PAGES: u32 = 134217728;
pub const MSG_FASTOPEN: u32 = 536870912;
pub const MSG_CMSG_CLOEXEC: u32 = 1073741824;
pub const MSG_CMSG_COMPAT: u32 = 2147483648;
pub const MSG_INTERNAL_SENDMSG_FLAGS: u32 = 135331840;
pub const SOL_IP: u32 = 0;
pub const SOL_TCP: u32 = 6;
pub const SOL_UDP: u32 = 17;
pub const SOL_IPV6: u32 = 41;
pub const SOL_ICMPV6: u32 = 58;
pub const SOL_SCTP: u32 = 132;
pub const SOL_UDPLITE: u32 = 136;
pub const SOL_RAW: u32 = 255;
pub const SOL_IPX: u32 = 256;
pub const SOL_AX25: u32 = 257;
pub const SOL_ATALK: u32 = 258;
pub const SOL_NETROM: u32 = 259;
pub const SOL_ROSE: u32 = 260;
pub const SOL_DECNET: u32 = 261;
pub const SOL_X25: u32 = 262;
pub const SOL_PACKET: u32 = 263;
pub const SOL_ATM: u32 = 264;
pub const SOL_AAL: u32 = 265;
pub const SOL_IRDA: u32 = 266;
pub const SOL_NETBEUI: u32 = 267;
pub const SOL_LLC: u32 = 268;
pub const SOL_DCCP: u32 = 269;
pub const SOL_NETLINK: u32 = 270;
pub const SOL_TIPC: u32 = 271;
pub const SOL_RXRPC: u32 = 272;
pub const SOL_PPPOL2TP: u32 = 273;
pub const SOL_BLUETOOTH: u32 = 274;
pub const SOL_PNPIPE: u32 = 275;
pub const SOL_RDS: u32 = 276;
pub const SOL_IUCV: u32 = 277;
pub const SOL_CAIF: u32 = 278;
pub const SOL_ALG: u32 = 279;
pub const SOL_NFC: u32 = 280;
pub const SOL_KCM: u32 = 281;
pub const SOL_TLS: u32 = 282;
pub const SOL_XDP: u32 = 283;
pub const SOL_MPTCP: u32 = 284;
pub const SOL_MCTP: u32 = 285;
pub const SOL_SMC: u32 = 286;
pub const SOL_VSOCK: u32 = 287;
pub const IPX_TYPE: u32 = 1;
pub const __UAPI_DEF_IF_IFCONF: u32 = 1;
pub const __UAPI_DEF_IF_IFMAP: u32 = 1;
pub const __UAPI_DEF_IF_IFNAMSIZ: u32 = 1;
pub const __UAPI_DEF_IF_IFREQ: u32 = 1;
pub const __UAPI_DEF_IF_NET_DEVICE_FLAGS: u32 = 1;
pub const __UAPI_DEF_IF_NET_DEVICE_FLAGS_LOWER_UP_DORMANT_ECHO: u32 = 1;
pub const __UAPI_DEF_IN_ADDR: u32 = 1;
pub const __UAPI_DEF_IN_IPPROTO: u32 = 1;
pub const __UAPI_DEF_IN_PKTINFO: u32 = 1;
pub const __UAPI_DEF_IP_MREQ: u32 = 1;
pub const __UAPI_DEF_SOCKADDR_IN: u32 = 1;
pub const __UAPI_DEF_IN_CLASS: u32 = 1;
pub const __UAPI_DEF_IN6_ADDR: u32 = 1;
pub const __UAPI_DEF_IN6_ADDR_ALT: u32 = 1;
pub const __UAPI_DEF_SOCKADDR_IN6: u32 = 1;
pub const __UAPI_DEF_IPV6_MREQ: u32 = 1;
pub const __UAPI_DEF_IPPROTO_V6: u32 = 1;
pub const __UAPI_DEF_IPV6_OPTIONS: u32 = 1;
pub const __UAPI_DEF_IN6_PKTINFO: u32 = 1;
pub const __UAPI_DEF_IP6_MTUINFO: u32 = 1;
pub const __UAPI_DEF_XATTR: u32 = 1;
pub const IFNAMSIZ: u32 = 16;
pub const IFALIASZ: u32 = 256;
pub const ALTIFNAMSIZ: u32 = 128;
pub const GENERIC_HDLC_VERSION: u32 = 4;
pub const CLOCK_DEFAULT: u32 = 0;
pub const CLOCK_EXT: u32 = 1;
pub const CLOCK_INT: u32 = 2;
pub const CLOCK_TXINT: u32 = 3;
pub const CLOCK_TXFROMRX: u32 = 4;
pub const ENCODING_DEFAULT: u32 = 0;
pub const ENCODING_NRZ: u32 = 1;
pub const ENCODING_NRZI: u32 = 2;
pub const ENCODING_FM_MARK: u32 = 3;
pub const ENCODING_FM_SPACE: u32 = 4;
pub const ENCODING_MANCHESTER: u32 = 5;
pub const PARITY_DEFAULT: u32 = 0;
pub const PARITY_NONE: u32 = 1;
pub const PARITY_CRC16_PR0: u32 = 2;
pub const PARITY_CRC16_PR1: u32 = 3;
pub const PARITY_CRC16_PR0_CCITT: u32 = 4;
pub const PARITY_CRC16_PR1_CCITT: u32 = 5;
pub const PARITY_CRC32_PR0_CCITT: u32 = 6;
pub const PARITY_CRC32_PR1_CCITT: u32 = 7;
pub const LMI_DEFAULT: u32 = 0;
pub const LMI_NONE: u32 = 1;
pub const LMI_ANSI: u32 = 2;
pub const LMI_CCITT: u32 = 3;
pub const LMI_CISCO: u32 = 4;
pub const IF_GET_IFACE: u32 = 1;
pub const IF_GET_PROTO: u32 = 2;
pub const IF_IFACE_V35: u32 = 4096;
pub const IF_IFACE_V24: u32 = 4097;
pub const IF_IFACE_X21: u32 = 4098;
pub const IF_IFACE_T1: u32 = 4099;
pub const IF_IFACE_E1: u32 = 4100;
pub const IF_IFACE_SYNC_SERIAL: u32 = 4101;
pub const IF_IFACE_X21D: u32 = 4102;
pub const IF_PROTO_HDLC: u32 = 8192;
pub const IF_PROTO_PPP: u32 = 8193;
pub const IF_PROTO_CISCO: u32 = 8194;
pub const IF_PROTO_FR: u32 = 8195;
pub const IF_PROTO_FR_ADD_PVC: u32 = 8196;
pub const IF_PROTO_FR_DEL_PVC: u32 = 8197;
pub const IF_PROTO_X25: u32 = 8198;
pub const IF_PROTO_HDLC_ETH: u32 = 8199;
pub const IF_PROTO_FR_ADD_ETH_PVC: u32 = 8200;
pub const IF_PROTO_FR_DEL_ETH_PVC: u32 = 8201;
pub const IF_PROTO_FR_PVC: u32 = 8202;
pub const IF_PROTO_FR_ETH_PVC: u32 = 8203;
pub const IF_PROTO_RAW: u32 = 8204;
pub const IFHWADDRLEN: u32 = 6;
pub const IOCB_FLAG_RESFD: u32 = 1;
pub const IOCB_FLAG_IOPRIO: u32 = 2;
pub const COMPAT_USE_64BIT_TIME: u32 = 0;
pub const _COMPAT_NSIG_WORDS: u32 = 2;
pub const FTRACE_FORCE_LIST_FUNC: u32 = 0;
pub const FTRACE_REGS_MAX_ARGS: u32 = 6;
pub const FTRACE_OPS_FL_SAVE_ARGS: u32 = 0;
pub const FTRACE_REF_MAX_SHIFT: u32 = 19;
pub const FTRACE_REF_MAX: u32 = 524287;
pub const FTRACE_OPS_GRAPH_STUB: u32 = 0;
pub const FTRACE_CALLSITE_SECTION: &[u8; 29] = b"__patchable_function_entries\0";
pub const FTRACE_RETFUNC_DEPTH: u32 = 50;
pub const FTRACE_RETSTACK_ALLOC_SIZE: u32 = 32;
pub const MAX_TRACER_SIZE: u32 = 100;
pub const OBJPOOL_NR_OBJECT_MAX: u32 = 16777216;
pub const OBJPOOL_OBJECT_SIZE_MAX: u32 = 65536;
pub const MAX_INSN_SIZE: u32 = 2;
pub const kretprobe_blacklist_size: u32 = 0;
pub const KPROBE_HIT_ACTIVE: u32 = 1;
pub const KPROBE_HIT_SS: u32 = 2;
pub const KPROBE_REENTER: u32 = 4;
pub const KPROBE_HIT_SSDONE: u32 = 8;
pub const KPROBE_FLAG_GONE: u32 = 1;
pub const KPROBE_FLAG_DISABLED: u32 = 2;
pub const KPROBE_FLAG_OPTIMIZED: u32 = 4;
pub const KPROBE_FLAG_FTRACE: u32 = 8;
pub const KPROBE_FLAG_ON_FUNC_ENTRY: u32 = 16;
pub const KRETPROBE_MAX_DATA_SIZE: u32 = 4096;
pub const KPROBE_INSN_PAGE_SYM: &[u8; 17] = b"kprobe_insn_page\0";
pub const KPROBE_OPTINSN_PAGE_SYM: &[u8; 20] = b"kprobe_optinsn_page\0";
pub const _GP_REGS: u32 = 33;
pub const _FP_REGS: u32 = 32;
pub const _EXTRA_REGS: u32 = 3;
pub const GP_REG_BYTES: u32 = 264;
pub const DBG_MAX_REG_NUM: u32 = 68;
pub const BUFMAX: u32 = 2048;
pub const NUMREGBYTES: u32 = 788;
pub const KGDB_MAX_BREAKPOINTS: u32 = 1000;
pub const KGDB_HW_BREAKPOINT: u32 = 1;
pub const ARCH_IMPLEMENTS_FLUSH_DCACHE_PAGE: u32 = 1;
pub const PRINTK_INFO_SUBSYSTEM_LEN: u32 = 16;
pub const PRINTK_INFO_DEVICE_LEN: u32 = 48;
pub const SCHED_CPUFREQ_IOWAIT: u32 = 1;
pub const SDF_SHARED_CHILD: u32 = 1;
pub const SDF_SHARED_PARENT: u32 = 2;
pub const SDF_NEEDS_GROUPS: u32 = 4;
pub const SDTL_OVERLAP: u32 = 1;
pub const EM_MAX_POWER: u32 = 64000000;
pub const EM_MAX_NUM_CPUS: u32 = 4096;
pub const PM_EVENT_INVALID: i32 = -1;
pub const PM_EVENT_ON: u32 = 0;
pub const PM_EVENT_FREEZE: u32 = 1;
pub const PM_EVENT_SUSPEND: u32 = 2;
pub const PM_EVENT_HIBERNATE: u32 = 4;
pub const PM_EVENT_QUIESCE: u32 = 8;
pub const PM_EVENT_RESUME: u32 = 16;
pub const PM_EVENT_THAW: u32 = 32;
pub const PM_EVENT_RESTORE: u32 = 64;
pub const PM_EVENT_RECOVER: u32 = 128;
pub const PM_EVENT_USER: u32 = 256;
pub const PM_EVENT_REMOTE: u32 = 512;
pub const PM_EVENT_AUTO: u32 = 1024;
pub const PM_EVENT_SLEEP: u32 = 6;
pub const PM_EVENT_USER_SUSPEND: u32 = 258;
pub const PM_EVENT_USER_RESUME: u32 = 272;
pub const PM_EVENT_REMOTE_RESUME: u32 = 528;
pub const PM_EVENT_AUTO_SUSPEND: u32 = 1026;
pub const PM_EVENT_AUTO_RESUME: u32 = 1040;
pub const PM_EVENT_PRETHAW: u32 = 8;
pub const SECTOR_SHIFT: u32 = 9;
pub const SECTOR_SIZE: u32 = 512;
pub const PAGE_SECTORS_SHIFT: u32 = 3;
pub const PAGE_SECTORS: u32 = 8;
pub const SECTOR_MASK: u32 = 7;
pub const BD_PARTNO: u32 = 255;
pub const BD_READ_ONLY: u32 = 256;
pub const BD_WRITE_HOLDER: u32 = 512;
pub const BD_HAS_SUBMIT_BIO: u32 = 1024;
pub const BD_RO_WARNED: u32 = 2048;
pub const BLK_STS_OK: u32 = 0;
pub const BLK_QC_T_NONE: i32 = -1;
pub const BIO_MAX_SECTORS: i32 = -1;
pub const REQ_OP_BITS: u32 = 8;
pub const REQ_FLAG_BITS: u32 = 24;
pub const BIO_MAX_VECS: u32 = 256;
pub const BIO_MAX_INLINE_VECS: u32 = 1024;
pub const BIO_POOL_SIZE: u32 = 2;
pub const SBQ_WAIT_QUEUES: u32 = 8;
pub const SBQ_WAKE_BATCH: u32 = 8;
pub const FDPUT_FPUT: u32 = 1;
pub const FDPUT_POS_UNLOCK: u32 = 2;
pub const BLKCG_MAX_POLS: u32 = 6;
pub const DISK_MAX_PARTS: u32 = 256;
pub const DISK_NAME_LEN: u32 = 32;
pub const PARTITION_META_INFO_VOLNAMELTH: u32 = 64;
pub const PARTITION_META_INFO_UUIDLTH: u32 = 37;
pub const GD_NEED_PART_SCAN: u32 = 0;
pub const GD_READ_ONLY: u32 = 1;
pub const GD_DEAD: u32 = 2;
pub const GD_NATIVE_CAPACITY: u32 = 3;
pub const GD_ADDED: u32 = 4;
pub const GD_SUPPRESS_PART_SCAN: u32 = 5;
pub const GD_OWNS_QUEUE: u32 = 6;
pub const BLK_MAX_BLOCK_SIZE: u32 = 65536;
pub const BLK_DEFAULT_SG_TIMEOUT: u32 = 60000;
pub const BLK_MIN_SG_TIMEOUT: u32 = 7000;
pub const BLK_POLL_ONESHOT: u32 = 1;
pub const BLKDEV_ZERO_NOUNMAP: u32 = 1;
pub const BLKDEV_ZERO_NOFALLBACK: u32 = 2;
pub const BLKDEV_ZERO_KILLABLE: u32 = 4;
pub const BLK_DEF_MAX_SECTORS_CAP: u32 = 2560;
pub const BDEVNAME_SIZE: u32 = 32;
pub const BDEVT_SIZE: u32 = 10;
pub const BLKDEV_MAJOR_MAX: u32 = 512;
pub const SG_CHAIN: u32 = 1;
pub const SG_END: u32 = 2;
pub const SG_PAGE_LINK_MASK: u32 = 3;
pub const SG_DMA_BUS_ADDRESS: u32 = 1;
pub const SG_DMA_SWIOTLB: u32 = 2;
pub const SG_CHUNK_SIZE: u32 = 128;
pub const SG_MAX_SEGMENTS: u32 = 2048;
pub const SG_MITER_ATOMIC: u32 = 1;
pub const SG_MITER_TO_SG: u32 = 2;
pub const SG_MITER_FROM_SG: u32 = 4;
pub const SG_MITER_LOCAL: u32 = 8;
pub const PREFETCH_STRIDE: u32 = 256;
pub const BLKDEV_MIN_RQ: u32 = 4;
pub const BLKDEV_DEFAULT_RQ: u32 = 128;
pub const BLK_MQ_MAX_DEPTH: u32 = 10240;
pub const BLK_MQ_NO_HCTX_IDX: i32 = -1;
pub const DMA_ATTR_WEAK_ORDERING: u32 = 2;
pub const DMA_ATTR_WRITE_COMBINE: u32 = 4;
pub const DMA_ATTR_NO_KERNEL_MAPPING: u32 = 16;
pub const DMA_ATTR_SKIP_CPU_SYNC: u32 = 32;
pub const DMA_ATTR_FORCE_CONTIGUOUS: u32 = 64;
pub const DMA_ATTR_ALLOC_SINGLE_PAGES: u32 = 128;
pub const DMA_ATTR_NO_WARN: u32 = 256;
pub const DMA_ATTR_PRIVILEGED: u32 = 512;
pub const IPV6_FL_A_GET: u32 = 0;
pub const IPV6_FL_A_PUT: u32 = 1;
pub const IPV6_FL_A_RENEW: u32 = 2;
pub const IPV6_FL_F_CREATE: u32 = 1;
pub const IPV6_FL_F_EXCL: u32 = 2;
pub const IPV6_FL_F_REFLECT: u32 = 4;
pub const IPV6_FL_F_REMOTE: u32 = 8;
pub const IPV6_FL_S_NONE: u32 = 0;
pub const IPV6_FL_S_EXCL: u32 = 1;
pub const IPV6_FL_S_PROCESS: u32 = 2;
pub const IPV6_FL_S_USER: u32 = 3;
pub const IPV6_FL_S_ANY: u32 = 255;
pub const IPV6_FLOWINFO_FLOWLABEL: u32 = 1048575;
pub const IPV6_FLOWINFO_PRIORITY: u32 = 267386880;
pub const IPV6_PRIORITY_UNCHARACTERIZED: u32 = 0;
pub const IPV6_PRIORITY_FILLER: u32 = 256;
pub const IPV6_PRIORITY_UNATTENDED: u32 = 512;
pub const IPV6_PRIORITY_RESERVED1: u32 = 768;
pub const IPV6_PRIORITY_BULK: u32 = 1024;
pub const IPV6_PRIORITY_RESERVED2: u32 = 1280;
pub const IPV6_PRIORITY_INTERACTIVE: u32 = 1536;
pub const IPV6_PRIORITY_CONTROL: u32 = 1792;
pub const IPV6_PRIORITY_8: u32 = 2048;
pub const IPV6_PRIORITY_9: u32 = 2304;
pub const IPV6_PRIORITY_10: u32 = 2560;
pub const IPV6_PRIORITY_11: u32 = 2816;
pub const IPV6_PRIORITY_12: u32 = 3072;
pub const IPV6_PRIORITY_13: u32 = 3328;
pub const IPV6_PRIORITY_14: u32 = 3584;
pub const IPV6_PRIORITY_15: u32 = 3840;
pub const IPPROTO_HOPOPTS: u32 = 0;
pub const IPPROTO_ROUTING: u32 = 43;
pub const IPPROTO_FRAGMENT: u32 = 44;
pub const IPPROTO_ICMPV6: u32 = 58;
pub const IPPROTO_NONE: u32 = 59;
pub const IPPROTO_DSTOPTS: u32 = 60;
pub const IPPROTO_MH: u32 = 135;
pub const IPV6_TLV_PAD1: u32 = 0;
pub const IPV6_TLV_PADN: u32 = 1;
pub const IPV6_TLV_ROUTERALERT: u32 = 5;
pub const IPV6_TLV_CALIPSO: u32 = 7;
pub const IPV6_TLV_IOAM: u32 = 49;
pub const IPV6_TLV_JUMBO: u32 = 194;
pub const IPV6_TLV_HAO: u32 = 201;
pub const IPV6_ADDRFORM: u32 = 1;
pub const IPV6_2292PKTINFO: u32 = 2;
pub const IPV6_2292HOPOPTS: u32 = 3;
pub const IPV6_2292DSTOPTS: u32 = 4;
pub const IPV6_2292RTHDR: u32 = 5;
pub const IPV6_2292PKTOPTIONS: u32 = 6;
pub const IPV6_CHECKSUM: u32 = 7;
pub const IPV6_2292HOPLIMIT: u32 = 8;
pub const IPV6_NEXTHOP: u32 = 9;
pub const IPV6_AUTHHDR: u32 = 10;
pub const IPV6_FLOWINFO: u32 = 11;
pub const IPV6_UNICAST_HOPS: u32 = 16;
pub const IPV6_MULTICAST_IF: u32 = 17;
pub const IPV6_MULTICAST_HOPS: u32 = 18;
pub const IPV6_MULTICAST_LOOP: u32 = 19;
pub const IPV6_ADD_MEMBERSHIP: u32 = 20;
pub const IPV6_DROP_MEMBERSHIP: u32 = 21;
pub const IPV6_ROUTER_ALERT: u32 = 22;
pub const IPV6_MTU_DISCOVER: u32 = 23;
pub const IPV6_MTU: u32 = 24;
pub const IPV6_RECVERR: u32 = 25;
pub const IPV6_V6ONLY: u32 = 26;
pub const IPV6_JOIN_ANYCAST: u32 = 27;
pub const IPV6_LEAVE_ANYCAST: u32 = 28;
pub const IPV6_MULTICAST_ALL: u32 = 29;
pub const IPV6_ROUTER_ALERT_ISOLATE: u32 = 30;
pub const IPV6_RECVERR_RFC4884: u32 = 31;
pub const IPV6_PMTUDISC_DONT: u32 = 0;
pub const IPV6_PMTUDISC_WANT: u32 = 1;
pub const IPV6_PMTUDISC_DO: u32 = 2;
pub const IPV6_PMTUDISC_PROBE: u32 = 3;
pub const IPV6_PMTUDISC_INTERFACE: u32 = 4;
pub const IPV6_PMTUDISC_OMIT: u32 = 5;
pub const IPV6_FLOWLABEL_MGR: u32 = 32;
pub const IPV6_FLOWINFO_SEND: u32 = 33;
pub const IPV6_IPSEC_POLICY: u32 = 34;
pub const IPV6_XFRM_POLICY: u32 = 35;
pub const IPV6_HDRINCL: u32 = 36;
pub const IPV6_RECVPKTINFO: u32 = 49;
pub const IPV6_PKTINFO: u32 = 50;
pub const IPV6_RECVHOPLIMIT: u32 = 51;
pub const IPV6_HOPLIMIT: u32 = 52;
pub const IPV6_RECVHOPOPTS: u32 = 53;
pub const IPV6_HOPOPTS: u32 = 54;
pub const IPV6_RTHDRDSTOPTS: u32 = 55;
pub const IPV6_RECVRTHDR: u32 = 56;
pub const IPV6_RTHDR: u32 = 57;
pub const IPV6_RECVDSTOPTS: u32 = 58;
pub const IPV6_DSTOPTS: u32 = 59;
pub const IPV6_RECVPATHMTU: u32 = 60;
pub const IPV6_PATHMTU: u32 = 61;
pub const IPV6_DONTFRAG: u32 = 62;
pub const IPV6_RECVTCLASS: u32 = 66;
pub const IPV6_TCLASS: u32 = 67;
pub const IPV6_AUTOFLOWLABEL: u32 = 70;
pub const IPV6_ADDR_PREFERENCES: u32 = 72;
pub const IPV6_PREFER_SRC_TMP: u32 = 1;
pub const IPV6_PREFER_SRC_PUBLIC: u32 = 2;
pub const IPV6_PREFER_SRC_PUBTMP_DEFAULT: u32 = 256;
pub const IPV6_PREFER_SRC_COA: u32 = 4;
pub const IPV6_PREFER_SRC_HOME: u32 = 1024;
pub const IPV6_PREFER_SRC_CGA: u32 = 8;
pub const IPV6_PREFER_SRC_NONCGA: u32 = 2048;
pub const IPV6_MINHOPCOUNT: u32 = 73;
pub const IPV6_ORIGDSTADDR: u32 = 74;
pub const IPV6_RECVORIGDSTADDR: u32 = 74;
pub const IPV6_TRANSPARENT: u32 = 75;
pub const IPV6_UNICAST_IF: u32 = 76;
pub const IPV6_RECVFRAGSIZE: u32 = 77;
pub const IPV6_FREEBIND: u32 = 78;
pub const SIPHASH_CONST_0: u64 = 8317987319222330741;
pub const SIPHASH_CONST_1: u64 = 7237128888997146477;
pub const SIPHASH_CONST_2: u64 = 7816392313619706465;
pub const SIPHASH_CONST_3: u64 = 8387220255154660723;
pub const HSIPHASH_CONST_0: u32 = 0;
pub const HSIPHASH_CONST_1: u32 = 0;
pub const HSIPHASH_CONST_2: u32 = 1819895653;
pub const HSIPHASH_CONST_3: u32 = 1952801890;
pub const ETH_ALEN: u32 = 6;
pub const ETH_TLEN: u32 = 2;
pub const ETH_HLEN: u32 = 14;
pub const ETH_ZLEN: u32 = 60;
pub const ETH_DATA_LEN: u32 = 1500;
pub const ETH_FRAME_LEN: u32 = 1514;
pub const ETH_FCS_LEN: u32 = 4;
pub const ETH_MIN_MTU: u32 = 68;
pub const ETH_MAX_MTU: u32 = 65535;
pub const ETH_P_LOOP: u32 = 96;
pub const ETH_P_PUP: u32 = 512;
pub const ETH_P_PUPAT: u32 = 513;
pub const ETH_P_TSN: u32 = 8944;
pub const ETH_P_ERSPAN2: u32 = 8939;
pub const ETH_P_IP: u32 = 2048;
pub const ETH_P_X25: u32 = 2053;
pub const ETH_P_ARP: u32 = 2054;
pub const ETH_P_BPQ: u32 = 2303;
pub const ETH_P_IEEEPUP: u32 = 2560;
pub const ETH_P_IEEEPUPAT: u32 = 2561;
pub const ETH_P_BATMAN: u32 = 17157;
pub const ETH_P_DEC: u32 = 24576;
pub const ETH_P_DNA_DL: u32 = 24577;
pub const ETH_P_DNA_RC: u32 = 24578;
pub const ETH_P_DNA_RT: u32 = 24579;
pub const ETH_P_LAT: u32 = 24580;
pub const ETH_P_DIAG: u32 = 24581;
pub const ETH_P_CUST: u32 = 24582;
pub const ETH_P_SCA: u32 = 24583;
pub const ETH_P_TEB: u32 = 25944;
pub const ETH_P_RARP: u32 = 32821;
pub const ETH_P_ATALK: u32 = 32923;
pub const ETH_P_AARP: u32 = 33011;
pub const ETH_P_8021Q: u32 = 33024;
pub const ETH_P_ERSPAN: u32 = 35006;
pub const ETH_P_IPX: u32 = 33079;
pub const ETH_P_IPV6: u32 = 34525;
pub const ETH_P_PAUSE: u32 = 34824;
pub const ETH_P_SLOW: u32 = 34825;
pub const ETH_P_WCCP: u32 = 34878;
pub const ETH_P_MPLS_UC: u32 = 34887;
pub const ETH_P_MPLS_MC: u32 = 34888;
pub const ETH_P_ATMMPOA: u32 = 34892;
pub const ETH_P_PPP_DISC: u32 = 34915;
pub const ETH_P_PPP_SES: u32 = 34916;
pub const ETH_P_LINK_CTL: u32 = 34924;
pub const ETH_P_ATMFATE: u32 = 34948;
pub const ETH_P_PAE: u32 = 34958;
pub const ETH_P_PROFINET: u32 = 34962;
pub const ETH_P_REALTEK: u32 = 34969;
pub const ETH_P_AOE: u32 = 34978;
pub const ETH_P_ETHERCAT: u32 = 34980;
pub const ETH_P_8021AD: u32 = 34984;
pub const ETH_P_802_EX1: u32 = 34997;
pub const ETH_P_PREAUTH: u32 = 35015;
pub const ETH_P_TIPC: u32 = 35018;
pub const ETH_P_LLDP: u32 = 35020;
pub const ETH_P_MRP: u32 = 35043;
pub const ETH_P_MACSEC: u32 = 35045;
pub const ETH_P_8021AH: u32 = 35047;
pub const ETH_P_MVRP: u32 = 35061;
pub const ETH_P_1588: u32 = 35063;
pub const ETH_P_NCSI: u32 = 35064;
pub const ETH_P_PRP: u32 = 35067;
pub const ETH_P_CFM: u32 = 35074;
pub const ETH_P_FCOE: u32 = 35078;
pub const ETH_P_IBOE: u32 = 35093;
pub const ETH_P_TDLS: u32 = 35085;
pub const ETH_P_FIP: u32 = 35092;
pub const ETH_P_80221: u32 = 35095;
pub const ETH_P_HSR: u32 = 35119;
pub const ETH_P_NSH: u32 = 35151;
pub const ETH_P_LOOPBACK: u32 = 36864;
pub const ETH_P_QINQ1: u32 = 37120;
pub const ETH_P_QINQ2: u32 = 37376;
pub const ETH_P_QINQ3: u32 = 37632;
pub const ETH_P_EDSA: u32 = 56026;
pub const ETH_P_DSA_8021Q: u32 = 56027;
pub const ETH_P_DSA_A5PSW: u32 = 57345;
pub const ETH_P_IFE: u32 = 60734;
pub const ETH_P_AF_IUCV: u32 = 64507;
pub const ETH_P_802_3_MIN: u32 = 1536;
pub const ETH_P_802_3: u32 = 1;
pub const ETH_P_AX25: u32 = 2;
pub const ETH_P_ALL: u32 = 3;
pub const ETH_P_802_2: u32 = 4;
pub const ETH_P_SNAP: u32 = 5;
pub const ETH_P_DDCMP: u32 = 6;
pub const ETH_P_WAN_PPP: u32 = 7;
pub const ETH_P_PPP_MP: u32 = 8;
pub const ETH_P_LOCALTALK: u32 = 9;
pub const ETH_P_CAN: u32 = 12;
pub const ETH_P_CANFD: u32 = 13;
pub const ETH_P_CANXL: u32 = 14;
pub const ETH_P_PPPTALK: u32 = 16;
pub const ETH_P_TR_802_2: u32 = 17;
pub const ETH_P_MOBITEX: u32 = 21;
pub const ETH_P_CONTROL: u32 = 22;
pub const ETH_P_IRDA: u32 = 23;
pub const ETH_P_ECONET: u32 = 24;
pub const ETH_P_HDLC: u32 = 25;
pub const ETH_P_ARCNET: u32 = 26;
pub const ETH_P_DSA: u32 = 27;
pub const ETH_P_TRAILER: u32 = 28;
pub const ETH_P_PHONET: u32 = 245;
pub const ETH_P_IEEE802154: u32 = 246;
pub const ETH_P_CAIF: u32 = 247;
pub const ETH_P_XDSA: u32 = 248;
pub const ETH_P_MAP: u32 = 249;
pub const ETH_P_MCTP: u32 = 250;
pub const __UAPI_DEF_ETHHDR: u32 = 1;
pub const TC_PRIO_BESTEFFORT: u32 = 0;
pub const TC_PRIO_FILLER: u32 = 1;
pub const TC_PRIO_BULK: u32 = 2;
pub const TC_PRIO_INTERACTIVE_BULK: u32 = 4;
pub const TC_PRIO_INTERACTIVE: u32 = 6;
pub const TC_PRIO_CONTROL: u32 = 7;
pub const TC_PRIO_MAX: u32 = 15;
pub const TC_H_MAJ_MASK: u32 = 4294901760;
pub const TC_H_MIN_MASK: u32 = 65535;
pub const TC_H_UNSPEC: u32 = 0;
pub const TC_H_ROOT: u32 = 4294967295;
pub const TC_H_INGRESS: u32 = 4294967281;
pub const TC_H_CLSACT: u32 = 4294967281;
pub const TC_H_MIN_PRIORITY: u32 = 65504;
pub const TC_H_MIN_INGRESS: u32 = 65522;
pub const TC_H_MIN_EGRESS: u32 = 65523;
pub const TC_LINKLAYER_MASK: u32 = 15;
pub const TC_RTAB_SIZE: u32 = 1024;
pub const SKBPRIO_MAX_PRIORITY: u32 = 64;
pub const TCQ_PRIO_BANDS: u32 = 16;
pub const TCQ_MIN_PRIO_BANDS: u32 = 2;
pub const TCQ_PLUG_BUFFER: u32 = 0;
pub const TCQ_PLUG_RELEASE_ONE: u32 = 1;
pub const TCQ_PLUG_RELEASE_INDEFINITE: u32 = 2;
pub const TCQ_PLUG_LIMIT: u32 = 3;
pub const TC_RED_ECN: u32 = 1;
pub const TC_RED_HARDDROP: u32 = 2;
pub const TC_RED_ADAPTATIVE: u32 = 4;
pub const TC_RED_NODROP: u32 = 8;
pub const TC_RED_HISTORIC_FLAGS: u32 = 7;
pub const MAX_DPs: u32 = 16;
pub const TC_HTB_NUMPRIO: u32 = 8;
pub const TC_HTB_MAXDEPTH: u32 = 8;
pub const TC_HTB_PROTOVER: u32 = 3;
pub const NETEM_DIST_SCALE: u32 = 8192;
pub const NETEM_DIST_MAX: u32 = 16384;
pub const TC_QOPT_BITMASK: u32 = 15;
pub const TC_QOPT_MAX_QUEUE: u32 = 16;
pub const TC_MQPRIO_F_MODE: u32 = 1;
pub const TC_MQPRIO_F_SHAPER: u32 = 2;
pub const TC_MQPRIO_F_MIN_RATE: u32 = 4;
pub const TC_MQPRIO_F_MAX_RATE: u32 = 8;
pub const SFB_MAX_PROB: u32 = 65535;
pub const FQ_CODEL_QUANTUM_MAX: u32 = 1048576;
pub const FQ_BANDS: u32 = 3;
pub const FQ_MIN_WEIGHT: u32 = 16384;
pub const TC_CAKE_MAX_TINS: u32 = 8;
pub const TCQ_ETS_MAX_BANDS: u32 = 16;
pub const TC_COOKIE_MAX_SIZE: u32 = 16;
pub const TCA_ACT_FLAGS_NO_PERCPU_STATS: u32 = 1;
pub const TCA_ACT_FLAGS_SKIP_HW: u32 = 2;
pub const TCA_ACT_FLAGS_SKIP_SW: u32 = 4;
pub const TCA_ACT_HW_STATS_IMMEDIATE: u32 = 1;
pub const TCA_ACT_HW_STATS_DELAYED: u32 = 2;
pub const TCA_ACT_MAX_PRIO: u32 = 32;
pub const TCA_ACT_BIND: u32 = 1;
pub const TCA_ACT_NOBIND: u32 = 0;
pub const TCA_ACT_UNBIND: u32 = 1;
pub const TCA_ACT_NOUNBIND: u32 = 0;
pub const TCA_ACT_REPLACE: u32 = 1;
pub const TCA_ACT_NOREPLACE: u32 = 0;
pub const TC_ACT_UNSPEC: i32 = -1;
pub const TC_ACT_OK: u32 = 0;
pub const TC_ACT_RECLASSIFY: u32 = 1;
pub const TC_ACT_SHOT: u32 = 2;
pub const TC_ACT_PIPE: u32 = 3;
pub const TC_ACT_STOLEN: u32 = 4;
pub const TC_ACT_QUEUED: u32 = 5;
pub const TC_ACT_REPEAT: u32 = 6;
pub const TC_ACT_REDIRECT: u32 = 7;
pub const TC_ACT_TRAP: u32 = 8;
pub const TC_ACT_VALUE_MAX: u32 = 8;
pub const __TC_ACT_EXT_SHIFT: u32 = 28;
pub const TC_ACT_EXT_VAL_MASK: u32 = 268435455;
pub const TCA_ACT_GACT: u32 = 5;
pub const TCA_ACT_IPT: u32 = 6;
pub const TCA_ACT_PEDIT: u32 = 7;
pub const TCA_ACT_MIRRED: u32 = 8;
pub const TCA_ACT_NAT: u32 = 9;
pub const TCA_ACT_XT: u32 = 10;
pub const TCA_ACT_SKBEDIT: u32 = 11;
pub const TCA_ACT_VLAN: u32 = 12;
pub const TCA_ACT_BPF: u32 = 13;
pub const TCA_ACT_CONNMARK: u32 = 14;
pub const TCA_ACT_SKBMOD: u32 = 15;
pub const TCA_ACT_CSUM: u32 = 16;
pub const TCA_ACT_TUNNEL_KEY: u32 = 17;
pub const TCA_ACT_SIMP: u32 = 22;
pub const TCA_ACT_IFE: u32 = 25;
pub const TCA_ACT_SAMPLE: u32 = 26;
pub const TC_POLICE_UNSPEC: i32 = -1;
pub const TC_POLICE_OK: u32 = 0;
pub const TC_POLICE_RECLASSIFY: u32 = 1;
pub const TC_POLICE_SHOT: u32 = 2;
pub const TC_POLICE_PIPE: u32 = 3;
pub const TCA_CLS_FLAGS_SKIP_HW: u32 = 1;
pub const TCA_CLS_FLAGS_SKIP_SW: u32 = 2;
pub const TCA_CLS_FLAGS_IN_HW: u32 = 4;
pub const TCA_CLS_FLAGS_NOT_IN_HW: u32 = 8;
pub const TCA_CLS_FLAGS_VERBOSE: u32 = 16;
pub const TC_U32_UNSPEC: u32 = 0;
pub const TC_U32_ROOT: u32 = 4293918720;
pub const TC_U32_TERMINAL: u32 = 1;
pub const TC_U32_OFFSET: u32 = 2;
pub const TC_U32_VAROFFSET: u32 = 4;
pub const TC_U32_EAT: u32 = 8;
pub const TC_U32_MAXDEPTH: u32 = 8;
pub const TCA_BPF_FLAG_ACT_DIRECT: u32 = 1;
pub const TCA_FLOWER_MASK_FLAGS_RANGE: u32 = 1;
pub const TCF_EM_REL_END: u32 = 0;
pub const TCF_EM_REL_AND: u32 = 1;
pub const TCF_EM_REL_OR: u32 = 2;
pub const TCF_EM_INVERT: u32 = 4;
pub const TCF_EM_SIMPLE: u32 = 8;
pub const TCF_EM_REL_MASK: u32 = 3;
pub const TCF_EM_CONTAINER: u32 = 0;
pub const TCF_EM_CMP: u32 = 1;
pub const TCF_EM_NBYTE: u32 = 2;
pub const TCF_EM_U32: u32 = 3;
pub const TCF_EM_META: u32 = 4;
pub const TCF_EM_TEXT: u32 = 5;
pub const TCF_EM_VLAN: u32 = 6;
pub const TCF_EM_CANID: u32 = 7;
pub const TCF_EM_IPSET: u32 = 8;
pub const TCF_EM_IPT: u32 = 9;
pub const TCF_EM_MAX: u32 = 9;
pub const FLOW_DIS_MPLS_MAX: u32 = 7;
pub const FLOW_DIS_TUN_OPTS_MAX: u32 = 255;
pub const FLOW_DIS_CFM_MDL_MAX: u32 = 7;
pub const FLOW_KEYS_DIGEST_LEN: u32 = 16;
pub const PACKET_HOST: u32 = 0;
pub const PACKET_BROADCAST: u32 = 1;
pub const PACKET_MULTICAST: u32 = 2;
pub const PACKET_OTHERHOST: u32 = 3;
pub const PACKET_OUTGOING: u32 = 4;
pub const PACKET_LOOPBACK: u32 = 5;
pub const PACKET_USER: u32 = 6;
pub const PACKET_KERNEL: u32 = 7;
pub const PACKET_FASTROUTE: u32 = 6;
pub const PACKET_ADD_MEMBERSHIP: u32 = 1;
pub const PACKET_DROP_MEMBERSHIP: u32 = 2;
pub const PACKET_RECV_OUTPUT: u32 = 3;
pub const PACKET_RX_RING: u32 = 5;
pub const PACKET_STATISTICS: u32 = 6;
pub const PACKET_COPY_THRESH: u32 = 7;
pub const PACKET_AUXDATA: u32 = 8;
pub const PACKET_ORIGDEV: u32 = 9;
pub const PACKET_VERSION: u32 = 10;
pub const PACKET_HDRLEN: u32 = 11;
pub const PACKET_RESERVE: u32 = 12;
pub const PACKET_TX_RING: u32 = 13;
pub const PACKET_LOSS: u32 = 14;
pub const PACKET_VNET_HDR: u32 = 15;
pub const PACKET_TX_TIMESTAMP: u32 = 16;
pub const PACKET_TIMESTAMP: u32 = 17;
pub const PACKET_FANOUT: u32 = 18;
pub const PACKET_TX_HAS_OFF: u32 = 19;
pub const PACKET_QDISC_BYPASS: u32 = 20;
pub const PACKET_ROLLOVER_STATS: u32 = 21;
pub const PACKET_FANOUT_DATA: u32 = 22;
pub const PACKET_IGNORE_OUTGOING: u32 = 23;
pub const PACKET_VNET_HDR_SZ: u32 = 24;
pub const PACKET_FANOUT_HASH: u32 = 0;
pub const PACKET_FANOUT_LB: u32 = 1;
pub const PACKET_FANOUT_CPU: u32 = 2;
pub const PACKET_FANOUT_ROLLOVER: u32 = 3;
pub const PACKET_FANOUT_RND: u32 = 4;
pub const PACKET_FANOUT_QM: u32 = 5;
pub const PACKET_FANOUT_CBPF: u32 = 6;
pub const PACKET_FANOUT_EBPF: u32 = 7;
pub const PACKET_FANOUT_FLAG_ROLLOVER: u32 = 4096;
pub const PACKET_FANOUT_FLAG_UNIQUEID: u32 = 8192;
pub const PACKET_FANOUT_FLAG_IGNORE_OUTGOING: u32 = 16384;
pub const PACKET_FANOUT_FLAG_DEFRAG: u32 = 32768;
pub const TP_STATUS_KERNEL: u32 = 0;
pub const TP_STATUS_USER: u32 = 1;
pub const TP_STATUS_COPY: u32 = 2;
pub const TP_STATUS_LOSING: u32 = 4;
pub const TP_STATUS_CSUMNOTREADY: u32 = 8;
pub const TP_STATUS_VLAN_VALID: u32 = 16;
pub const TP_STATUS_BLK_TMO: u32 = 32;
pub const TP_STATUS_VLAN_TPID_VALID: u32 = 64;
pub const TP_STATUS_CSUM_VALID: u32 = 128;
pub const TP_STATUS_GSO_TCP: u32 = 256;
pub const TP_STATUS_AVAILABLE: u32 = 0;
pub const TP_STATUS_SEND_REQUEST: u32 = 1;
pub const TP_STATUS_SENDING: u32 = 2;
pub const TP_STATUS_WRONG_FORMAT: u32 = 4;
pub const TP_STATUS_TS_SOFTWARE: u32 = 536870912;
pub const TP_STATUS_TS_SYS_HARDWARE: u32 = 1073741824;
pub const TP_STATUS_TS_RAW_HARDWARE: u32 = 2147483648;
pub const TP_FT_REQ_FILL_RXHASH: u32 = 1;
pub const TPACKET_ALIGNMENT: u32 = 16;
pub const PACKET_MR_MULTICAST: u32 = 0;
pub const PACKET_MR_PROMISC: u32 = 1;
pub const PACKET_MR_ALLMULTI: u32 = 2;
pub const PACKET_MR_UNICAST: u32 = 3;
pub const LOOPBACK_IFINDEX: u32 = 1;
pub const FLOWI_FLAG_ANYSRC: u32 = 1;
pub const FLOWI_FLAG_KNOWN_NH: u32 = 2;
pub const FLOWI_FLAG_L3MDEV_OIF: u32 = 4;
pub const NF_CT_STATE_INVALID_BIT: u32 = 1;
pub const NF_CT_STATE_UNTRACKED_BIT: u32 = 64;
pub const NF_CT_EXPECT_PERMANENT: u32 = 1;
pub const NF_CT_EXPECT_INACTIVE: u32 = 2;
pub const NF_CT_EXPECT_USERSPACE: u32 = 4;
pub const NFCT_INFOMASK: u32 = 7;
pub const NFCT_PTRMASK: i32 = -8;
pub const SKB_DROP_REASON_SUBSYS_SHIFT: u32 = 16;
pub const NET_IOV: u32 = 1;
pub const CHECKSUM_NONE: u32 = 0;
pub const CHECKSUM_UNNECESSARY: u32 = 1;
pub const CHECKSUM_COMPLETE: u32 = 2;
pub const CHECKSUM_PARTIAL: u32 = 3;
pub const SKB_MAX_CSUM_LEVEL: u32 = 3;
pub const MAX_SKB_FRAGS: u32 = 17;
pub const GSO_BY_FRAGS: u32 = 65535;
pub const SKB_DATAREF_SHIFT: u32 = 16;
pub const SKB_DATAREF_MASK: u32 = 65535;
pub const NET_SKBUFF_DATA_USES_OFFSET: u32 = 1;
pub const CLONED_MASK: u32 = 1;
pub const PKT_TYPE_MAX: u32 = 7;
pub const SKB_TSTAMP_TYPE_MASK: u32 = 3;
pub const TC_AT_INGRESS_MASK: u32 = 4;
pub const SKB_ALLOC_FCLONE: u32 = 1;
pub const SKB_ALLOC_RX: u32 = 2;
pub const SKB_ALLOC_NAPI: u32 = 4;
pub const SKB_DST_NOREF: u32 = 1;
pub const SKB_DST_PTRMASK: i32 = -2;
pub const ENCAP_TYPE_ETHER: u32 = 0;
pub const ENCAP_TYPE_IPPROTO: u32 = 1;
pub const CHECKSUM_BREAK: u32 = 76;
pub const MAC_ADDR_STR_LEN: u32 = 17;
pub const NPROTO: u32 = 46;
pub const SYS_SOCKET: u32 = 1;
pub const SYS_BIND: u32 = 2;
pub const SYS_CONNECT: u32 = 3;
pub const SYS_LISTEN: u32 = 4;
pub const SYS_ACCEPT: u32 = 5;
pub const SYS_GETSOCKNAME: u32 = 6;
pub const SYS_GETPEERNAME: u32 = 7;
pub const SYS_SOCKETPAIR: u32 = 8;
pub const SYS_SEND: u32 = 9;
pub const SYS_RECV: u32 = 10;
pub const SYS_SENDTO: u32 = 11;
pub const SYS_RECVFROM: u32 = 12;
pub const SYS_SHUTDOWN: u32 = 13;
pub const SYS_SETSOCKOPT: u32 = 14;
pub const SYS_GETSOCKOPT: u32 = 15;
pub const SYS_SENDMSG: u32 = 16;
pub const SYS_RECVMSG: u32 = 17;
pub const SYS_ACCEPT4: u32 = 18;
pub const SYS_RECVMMSG: u32 = 19;
pub const SYS_SENDMMSG: u32 = 20;
pub const __SO_ACCEPTCON: u32 = 65536;
pub const SOCKWQ_ASYNC_NOSPACE: u32 = 0;
pub const SOCKWQ_ASYNC_WAITDATA: u32 = 1;
pub const SOCK_NOSPACE: u32 = 2;
pub const SOCK_PASSCRED: u32 = 3;
pub const SOCK_PASSSEC: u32 = 4;
pub const SOCK_SUPPORT_ZC: u32 = 5;
pub const SOCK_CUSTOM_SOCKOPT: u32 = 6;
pub const SOCK_PASSPIDFD: u32 = 7;
pub const SOCK_TYPE_MASK: u32 = 15;
pub const SOCK_CLOEXEC: u32 = 524288;
pub const SOCK_NONBLOCK: u32 = 2048;
pub const _LINUX_BPF_H: u32 = 1;
pub const BPF_LD: u32 = 0;
pub const BPF_LDX: u32 = 1;
pub const BPF_ST: u32 = 2;
pub const BPF_STX: u32 = 3;
pub const BPF_ALU: u32 = 4;
pub const BPF_JMP: u32 = 5;
pub const BPF_RET: u32 = 6;
pub const BPF_MISC: u32 = 7;
pub const BPF_W: u32 = 0;
pub const BPF_H: u32 = 8;
pub const BPF_B: u32 = 16;
pub const BPF_IMM: u32 = 0;
pub const BPF_ABS: u32 = 32;
pub const BPF_IND: u32 = 64;
pub const BPF_MEM: u32 = 96;
pub const BPF_LEN: u32 = 128;
pub const BPF_MSH: u32 = 160;
pub const BPF_ADD: u32 = 0;
pub const BPF_SUB: u32 = 16;
pub const BPF_MUL: u32 = 32;
pub const BPF_DIV: u32 = 48;
pub const BPF_OR: u32 = 64;
pub const BPF_AND: u32 = 80;
pub const BPF_LSH: u32 = 96;
pub const BPF_RSH: u32 = 112;
pub const BPF_NEG: u32 = 128;
pub const BPF_MOD: u32 = 144;
pub const BPF_XOR: u32 = 160;
pub const BPF_JA: u32 = 0;
pub const BPF_JEQ: u32 = 16;
pub const BPF_JGT: u32 = 32;
pub const BPF_JGE: u32 = 48;
pub const BPF_JSET: u32 = 64;
pub const BPF_K: u32 = 0;
pub const BPF_X: u32 = 8;
pub const BPF_MAXINSNS: u32 = 4096;
pub const BPF_JMP32: u32 = 6;
pub const BPF_ALU64: u32 = 7;
pub const BPF_DW: u32 = 24;
pub const BPF_MEMSX: u32 = 128;
pub const BPF_ATOMIC: u32 = 192;
pub const BPF_XADD: u32 = 192;
pub const BPF_MOV: u32 = 176;
pub const BPF_ARSH: u32 = 192;
pub const BPF_END: u32 = 208;
pub const BPF_TO_LE: u32 = 0;
pub const BPF_TO_BE: u32 = 8;
pub const BPF_FROM_LE: u32 = 0;
pub const BPF_FROM_BE: u32 = 8;
pub const BPF_JNE: u32 = 80;
pub const BPF_JLT: u32 = 160;
pub const BPF_JLE: u32 = 176;
pub const BPF_JSGT: u32 = 96;
pub const BPF_JSGE: u32 = 112;
pub const BPF_JSLT: u32 = 192;
pub const BPF_JSLE: u32 = 208;
pub const BPF_JCOND: u32 = 224;
pub const BPF_CALL: u32 = 128;
pub const BPF_EXIT: u32 = 144;
pub const BPF_FETCH: u32 = 1;
pub const BPF_XCHG: u32 = 225;
pub const BPF_CMPXCHG: u32 = 241;
pub const BPF_LOAD_ACQ: u32 = 256;
pub const BPF_STORE_REL: u32 = 272;
pub const BPF_F_ALLOW_OVERRIDE: u32 = 1;
pub const BPF_F_ALLOW_MULTI: u32 = 2;
pub const BPF_F_REPLACE: u32 = 4;
pub const BPF_F_BEFORE: u32 = 8;
pub const BPF_F_AFTER: u32 = 16;
pub const BPF_F_ID: u32 = 32;
pub const BPF_F_PREORDER: u32 = 64;
pub const BPF_F_STRICT_ALIGNMENT: u32 = 1;
pub const BPF_F_ANY_ALIGNMENT: u32 = 2;
pub const BPF_F_TEST_RND_HI32: u32 = 4;
pub const BPF_F_TEST_STATE_FREQ: u32 = 8;
pub const BPF_F_SLEEPABLE: u32 = 16;
pub const BPF_F_XDP_HAS_FRAGS: u32 = 32;
pub const BPF_F_XDP_DEV_BOUND_ONLY: u32 = 64;
pub const BPF_F_TEST_REG_INVARIANTS: u32 = 128;
pub const BPF_F_NETFILTER_IP_DEFRAG: u32 = 1;
pub const BPF_PSEUDO_MAP_FD: u32 = 1;
pub const BPF_PSEUDO_MAP_IDX: u32 = 5;
pub const BPF_PSEUDO_MAP_VALUE: u32 = 2;
pub const BPF_PSEUDO_MAP_IDX_VALUE: u32 = 6;
pub const BPF_PSEUDO_BTF_ID: u32 = 3;
pub const BPF_PSEUDO_FUNC: u32 = 4;
pub const BPF_PSEUDO_CALL: u32 = 1;
pub const BPF_PSEUDO_KFUNC_CALL: u32 = 2;
pub const BPF_F_QUERY_EFFECTIVE: u32 = 1;
pub const BPF_F_TEST_RUN_ON_CPU: u32 = 1;
pub const BPF_F_TEST_XDP_LIVE_FRAMES: u32 = 2;
pub const BPF_F_TEST_SKB_CHECKSUM_COMPLETE: u32 = 4;
pub const BPF_BUILD_ID_SIZE: u32 = 20;
pub const BPF_OBJ_NAME_LEN: u32 = 16;
pub const XDP_PACKET_HEADROOM: u32 = 256;
pub const BPF_TAG_SIZE: u32 = 8;
pub const BPF_MAJOR_VERSION: u32 = 1;
pub const BPF_MINOR_VERSION: u32 = 1;
pub const BPF_A: u32 = 16;
pub const BPF_TAX: u32 = 0;
pub const BPF_TXA: u32 = 128;
pub const BPF_MEMWORDS: u32 = 16;
pub const SKF_AD_OFF: i32 = -4096;
pub const SKF_AD_PROTOCOL: u32 = 0;
pub const SKF_AD_PKTTYPE: u32 = 4;
pub const SKF_AD_IFINDEX: u32 = 8;
pub const SKF_AD_NLATTR: u32 = 12;
pub const SKF_AD_NLATTR_NEST: u32 = 16;
pub const SKF_AD_MARK: u32 = 20;
pub const SKF_AD_QUEUE: u32 = 24;
pub const SKF_AD_HATYPE: u32 = 28;
pub const SKF_AD_RXHASH: u32 = 32;
pub const SKF_AD_CPU: u32 = 36;
pub const SKF_AD_ALU_XOR_X: u32 = 40;
pub const SKF_AD_VLAN_TAG: u32 = 44;
pub const SKF_AD_VLAN_TAG_PRESENT: u32 = 48;
pub const SKF_AD_PAY_OFFSET: u32 = 52;
pub const SKF_AD_RANDOM: u32 = 56;
pub const SKF_AD_VLAN_TPID: u32 = 60;
pub const SKF_AD_MAX: u32 = 64;
pub const SKF_NET_OFF: i32 = -1048576;
pub const SKF_LL_OFF: i32 = -2097152;
pub const BPF_NET_OFF: i32 = -1048576;
pub const BPF_LL_OFF: i32 = -2097152;
pub const _LINUX_BTF_H: u32 = 1;
pub const BTF_SET8_KFUNCS: u32 = 1;
pub const BTF_IDS_SECTION: &[u8; 9] = b".BTF_ids\0";
pub const BTF_MAGIC: u32 = 60319;
pub const BTF_VERSION: u32 = 1;
pub const BTF_MAX_TYPE: u32 = 1048575;
pub const BTF_MAX_NAME_OFFSET: u32 = 16777215;
pub const BTF_MAX_VLEN: u32 = 65535;
pub const BTF_INT_SIGNED: u32 = 1;
pub const BTF_INT_CHAR: u32 = 2;
pub const BTF_INT_BOOL: u32 = 4;
pub const KF_ACQUIRE: u32 = 1;
pub const KF_RELEASE: u32 = 2;
pub const KF_RET_NULL: u32 = 4;
pub const KF_TRUSTED_ARGS: u32 = 16;
pub const KF_SLEEPABLE: u32 = 32;
pub const KF_DESTRUCTIVE: u32 = 64;
pub const KF_RCU: u32 = 128;
pub const KF_ITER_NEW: u32 = 256;
pub const KF_ITER_NEXT: u32 = 512;
pub const KF_ITER_DESTROY: u32 = 1024;
pub const KF_RCU_PROTECTED: u32 = 2048;
pub const KF_FASTCALL: u32 = 4096;
pub const KF_ARENA_RET: u32 = 8192;
pub const KF_ARENA_ARG1: u32 = 16384;
pub const KF_ARENA_ARG2: u32 = 32768;
pub const BTF_SHOW_UNSAFE: u32 = 16;
pub const CPU_ONLINE: u32 = 2;
pub const CPU_UP_PREPARE: u32 = 3;
pub const CPU_DEAD: u32 = 7;
pub const CPU_DEAD_FROZEN: u32 = 8;
pub const CPU_POST_DEAD: u32 = 9;
pub const CPU_BROKEN: u32 = 11;
pub const static_call_initialized: u32 = 0;
pub const TASKSTATS_VERSION: u32 = 15;
pub const TS_COMM_LEN: u32 = 32;
pub const TASKSTATS_GENL_NAME: &[u8; 10] = b"TASKSTATS\0";
pub const TASKSTATS_GENL_VERSION: u32 = 1;
pub const _U: u32 = 1;
pub const _L: u32 = 2;
pub const _D: u32 = 4;
pub const _C: u32 = 8;
pub const _P: u32 = 16;
pub const _S: u32 = 32;
pub const _X: u32 = 64;
pub const _SP: u32 = 128;
pub const SEQ_SKIP: u32 = 1;
pub const UID_GID_MAP_MAX_BASE_EXTENTS: u32 = 5;
pub const UID_GID_MAP_MAX_EXTENTS: u32 = 340;
pub const USERNS_SETGROUPS_ALLOWED: u32 = 1;
pub const USERNS_INIT_FLAGS: u32 = 1;
pub const CGROUP_LSM_NUM: u32 = 10;
pub const MAX_CGROUP_TYPE_NAMELEN: u32 = 32;
pub const MAX_CGROUP_ROOT_NAMELEN: u32 = 64;
pub const MAX_CFTYPE_NAME: u32 = 64;
pub const CGROUP_WEIGHT_MIN: u32 = 1;
pub const CGROUP_WEIGHT_DFL: u32 = 100;
pub const CGROUP_WEIGHT_MAX: u32 = 10000;
pub const EFD_SEMAPHORE: u32 = 1;
pub const EFD_CLOEXEC: u32 = 524288;
pub const EFD_NONBLOCK: u32 = 2048;
pub const EFD_SHARED_FCNTL_FLAGS: u32 = 526336;
pub const EFD_FLAGS_SET: u32 = 526337;
pub const FPROP_FRAC_SHIFT: u32 = 10;
pub const FPROP_FRAC_BASE: u32 = 1024;
pub const PAGEVEC_SIZE: u32 = 31;
pub const DIRTY_SCOPE: u32 = 8;
pub const BDP_ASYNC: u32 = 1;
pub const MEM_CGROUP_ID_SHIFT: u32 = 16;
pub const MEMCG_CGWB_FRN_CNT: u32 = 4;
pub const MEMCG_CHARGE_BATCH: u32 = 64;
pub const smp_cond_time_check_count: u32 = 200;
pub const RES_DEF_TIMEOUT: u32 = 250000000;
pub const RES_NR_HELD: u32 = 31;
pub const BPF_BASE_TYPE_BITS: u32 = 8;
pub const BPF_BASE_TYPE_LIMIT: u32 = 256;
pub const MAX_BPF_FUNC_ARGS: u32 = 12;
pub const MAX_BPF_FUNC_REG_ARGS: u32 = 5;
pub const BPF_DISPATCHER_MAX: u32 = 48;
pub const BPF_STRUCT_OPS_MAX_NR_MEMBERS: u32 = 64;
pub const BPF_COMPLEXITY_LIMIT_INSNS: u32 = 1000000;
pub const MAX_TAIL_CALL_CNT: u32 = 33;
pub const BPF_MAX_USER_RINGBUF_SAMPLES: u32 = 131072;
pub const BPF_RET_BIND_NO_CAP_NET_BIND_SERVICE: u32 = 1;
pub const BPF_RET_SET_CN: u32 = 1;
pub const BPF_ITER_FUNC_PREFIX: &[u8; 10] = b"bpf_iter_\0";
pub const BPF_ITER_CTX_ARG_MAX: u32 = 2;
pub const MAX_BPRINTF_VARARGS: u32 = 12;
pub const MAX_BPRINTF_BUF: u32 = 1024;
pub const LSM_ID_UNDEF: u32 = 0;
pub const LSM_ID_CAPABILITY: u32 = 100;
pub const LSM_ID_SELINUX: u32 = 101;
pub const LSM_ID_SMACK: u32 = 102;
pub const LSM_ID_TOMOYO: u32 = 103;
pub const LSM_ID_APPARMOR: u32 = 104;
pub const LSM_ID_YAMA: u32 = 105;
pub const LSM_ID_LOADPIN: u32 = 106;
pub const LSM_ID_SAFESETID: u32 = 107;
pub const LSM_ID_LOCKDOWN: u32 = 108;
pub const LSM_ID_BPF: u32 = 109;
pub const LSM_ID_LANDLOCK: u32 = 110;
pub const LSM_ID_IMA: u32 = 111;
pub const LSM_ID_EVM: u32 = 112;
pub const LSM_ID_IPE: u32 = 113;
pub const LSM_ATTR_UNDEF: u32 = 0;
pub const LSM_ATTR_CURRENT: u32 = 100;
pub const LSM_ATTR_EXEC: u32 = 101;
pub const LSM_ATTR_FSCREATE: u32 = 102;
pub const LSM_ATTR_KEYCREATE: u32 = 103;
pub const LSM_ATTR_PREV: u32 = 104;
pub const LSM_ATTR_SOCKCREATE: u32 = 105;
pub const LSM_FLAG_SINGLE: u32 = 1;
pub const CAP_OPT_NONE: u32 = 0;
pub const SECURITY_LSM_NATIVE_LABELS: u32 = 1;
pub const LSM_SETID_ID: u32 = 1;
pub const LSM_SETID_RE: u32 = 2;
pub const LSM_SETID_RES: u32 = 4;
pub const LSM_SETID_FS: u32 = 8;
pub const LSM_PRLIMIT_READ: u32 = 1;
pub const LSM_PRLIMIT_WRITE: u32 = 2;
pub const LSM_UNSAFE_SHARE: u32 = 1;
pub const LSM_UNSAFE_PTRACE: u32 = 2;
pub const LSM_UNSAFE_NO_NEW_PRIVS: u32 = 4;
pub const SCM_MAX_FD: u32 = 253;
pub const NETLINK_ROUTE: u32 = 0;
pub const NETLINK_UNUSED: u32 = 1;
pub const NETLINK_USERSOCK: u32 = 2;
pub const NETLINK_FIREWALL: u32 = 3;
pub const NETLINK_SOCK_DIAG: u32 = 4;
pub const NETLINK_NFLOG: u32 = 5;
pub const NETLINK_XFRM: u32 = 6;
pub const NETLINK_SELINUX: u32 = 7;
pub const NETLINK_ISCSI: u32 = 8;
pub const NETLINK_AUDIT: u32 = 9;
pub const NETLINK_FIB_LOOKUP: u32 = 10;
pub const NETLINK_CONNECTOR: u32 = 11;
pub const NETLINK_NETFILTER: u32 = 12;
pub const NETLINK_IP6_FW: u32 = 13;
pub const NETLINK_DNRTMSG: u32 = 14;
pub const NETLINK_KOBJECT_UEVENT: u32 = 15;
pub const NETLINK_GENERIC: u32 = 16;
pub const NETLINK_SCSITRANSPORT: u32 = 18;
pub const NETLINK_ECRYPTFS: u32 = 19;
pub const NETLINK_RDMA: u32 = 20;
pub const NETLINK_CRYPTO: u32 = 21;
pub const NETLINK_SMC: u32 = 22;
pub const NETLINK_INET_DIAG: u32 = 4;
pub const MAX_LINKS: u32 = 32;
pub const NLM_F_REQUEST: u32 = 1;
pub const NLM_F_MULTI: u32 = 2;
pub const NLM_F_ACK: u32 = 4;
pub const NLM_F_ECHO: u32 = 8;
pub const NLM_F_DUMP_INTR: u32 = 16;
pub const NLM_F_DUMP_FILTERED: u32 = 32;
pub const NLM_F_ROOT: u32 = 256;
pub const NLM_F_MATCH: u32 = 512;
pub const NLM_F_ATOMIC: u32 = 1024;
pub const NLM_F_DUMP: u32 = 768;
pub const NLM_F_REPLACE: u32 = 256;
pub const NLM_F_EXCL: u32 = 512;
pub const NLM_F_CREATE: u32 = 1024;
pub const NLM_F_APPEND: u32 = 2048;
pub const NLM_F_NONREC: u32 = 256;
pub const NLM_F_BULK: u32 = 512;
pub const NLM_F_CAPPED: u32 = 256;
pub const NLM_F_ACK_TLVS: u32 = 512;
pub const NLMSG_ALIGNTO: u32 = 4;
pub const NLMSG_NOOP: u32 = 1;
pub const NLMSG_ERROR: u32 = 2;
pub const NLMSG_DONE: u32 = 3;
pub const NLMSG_OVERRUN: u32 = 4;
pub const NLMSG_MIN_TYPE: u32 = 16;
pub const NETLINK_ADD_MEMBERSHIP: u32 = 1;
pub const NETLINK_DROP_MEMBERSHIP: u32 = 2;
pub const NETLINK_PKTINFO: u32 = 3;
pub const NETLINK_BROADCAST_ERROR: u32 = 4;
pub const NETLINK_NO_ENOBUFS: u32 = 5;
pub const NETLINK_LISTEN_ALL_NSID: u32 = 8;
pub const NETLINK_LIST_MEMBERSHIPS: u32 = 9;
pub const NETLINK_CAP_ACK: u32 = 10;
pub const NETLINK_EXT_ACK: u32 = 11;
pub const NETLINK_GET_STRICT_CHK: u32 = 12;
pub const NET_MAJOR: u32 = 36;
pub const NLA_F_NESTED: u32 = 32768;
pub const NLA_F_NET_BYTEORDER: u32 = 16384;
pub const NLA_TYPE_MASK: i32 = -49153;
pub const NLA_ALIGNTO: u32 = 4;
pub const NETLINK_CTX_SIZE: u32 = 48;
pub const NL_CFG_F_NONROOT_RECV: u32 = 1;
pub const NL_CFG_F_NONROOT_SEND: u32 = 2;
pub const NETLINK_MAX_COOKIE_LEN: u32 = 20;
pub const NETLINK_MAX_FMTMSG_LEN: u32 = 80;
pub const ETH_MDIO_SUPPORTS_C22: u32 = 1;
pub const ETH_MDIO_SUPPORTS_C45: u32 = 2;
pub const ETHTOOL_FWVERS_LEN: u32 = 32;
pub const ETHTOOL_BUSINFO_LEN: u32 = 32;
pub const ETHTOOL_EROMVERS_LEN: u32 = 32;
pub const SOPASS_MAX: u32 = 6;
pub const PFC_STORM_PREVENTION_AUTO: u32 = 65535;
pub const PFC_STORM_PREVENTION_DISABLE: u32 = 0;
pub const DOWNSHIFT_DEV_DEFAULT_COUNT: u32 = 255;
pub const DOWNSHIFT_DEV_DISABLE: u32 = 0;
pub const ETHTOOL_PHY_FAST_LINK_DOWN_ON: u32 = 0;
pub const ETHTOOL_PHY_FAST_LINK_DOWN_OFF: u32 = 255;
pub const ETHTOOL_PHY_EDPD_DFLT_TX_MSECS: u32 = 65535;
pub const ETHTOOL_PHY_EDPD_NO_TX: u32 = 65534;
pub const ETHTOOL_PHY_EDPD_DISABLE: u32 = 0;
pub const ETH_GSTRING_LEN: u32 = 32;
pub const ETH_RX_NFC_IP4: u32 = 1;
pub const ETHTOOL_RX_FLOW_SPEC_RING: u32 = 4294967295;
pub const ETHTOOL_RX_FLOW_SPEC_RING_VF: u64 = 1095216660480;
pub const ETHTOOL_RX_FLOW_SPEC_RING_VF_OFF: u32 = 32;
pub const ETH_RXFH_CONTEXT_ALLOC: u32 = 4294967295;
pub const ETH_RXFH_INDIR_NO_CHANGE: u32 = 4294967295;
pub const ETHTOOL_RXNTUPLE_ACTION_DROP: i32 = -1;
pub const ETHTOOL_RXNTUPLE_ACTION_CLEAR: i32 = -2;
pub const ETHTOOL_FLASH_MAX_FILENAME: u32 = 128;
pub const ETH_FW_DUMP_DISABLE: u32 = 0;
pub const MAX_NUM_QUEUE: u32 = 4096;
pub const ETHTOOL_GSET: u32 = 1;
pub const ETHTOOL_SSET: u32 = 2;
pub const ETHTOOL_GDRVINFO: u32 = 3;
pub const ETHTOOL_GREGS: u32 = 4;
pub const ETHTOOL_GWOL: u32 = 5;
pub const ETHTOOL_SWOL: u32 = 6;
pub const ETHTOOL_GMSGLVL: u32 = 7;
pub const ETHTOOL_SMSGLVL: u32 = 8;
pub const ETHTOOL_NWAY_RST: u32 = 9;
pub const ETHTOOL_GLINK: u32 = 10;
pub const ETHTOOL_GEEPROM: u32 = 11;
pub const ETHTOOL_SEEPROM: u32 = 12;
pub const ETHTOOL_GCOALESCE: u32 = 14;
pub const ETHTOOL_SCOALESCE: u32 = 15;
pub const ETHTOOL_GRINGPARAM: u32 = 16;
pub const ETHTOOL_SRINGPARAM: u32 = 17;
pub const ETHTOOL_GPAUSEPARAM: u32 = 18;
pub const ETHTOOL_SPAUSEPARAM: u32 = 19;
pub const ETHTOOL_GRXCSUM: u32 = 20;
pub const ETHTOOL_SRXCSUM: u32 = 21;
pub const ETHTOOL_GTXCSUM: u32 = 22;
pub const ETHTOOL_STXCSUM: u32 = 23;
pub const ETHTOOL_GSG: u32 = 24;
pub const ETHTOOL_SSG: u32 = 25;
pub const ETHTOOL_TEST: u32 = 26;
pub const ETHTOOL_GSTRINGS: u32 = 27;
pub const ETHTOOL_PHYS_ID: u32 = 28;
pub const ETHTOOL_GSTATS: u32 = 29;
pub const ETHTOOL_GTSO: u32 = 30;
pub const ETHTOOL_STSO: u32 = 31;
pub const ETHTOOL_GPERMADDR: u32 = 32;
pub const ETHTOOL_GUFO: u32 = 33;
pub const ETHTOOL_SUFO: u32 = 34;
pub const ETHTOOL_GGSO: u32 = 35;
pub const ETHTOOL_SGSO: u32 = 36;
pub const ETHTOOL_GFLAGS: u32 = 37;
pub const ETHTOOL_SFLAGS: u32 = 38;
pub const ETHTOOL_GPFLAGS: u32 = 39;
pub const ETHTOOL_SPFLAGS: u32 = 40;
pub const ETHTOOL_GRXFH: u32 = 41;
pub const ETHTOOL_SRXFH: u32 = 42;
pub const ETHTOOL_GGRO: u32 = 43;
pub const ETHTOOL_SGRO: u32 = 44;
pub const ETHTOOL_GRXRINGS: u32 = 45;
pub const ETHTOOL_GRXCLSRLCNT: u32 = 46;
pub const ETHTOOL_GRXCLSRULE: u32 = 47;
pub const ETHTOOL_GRXCLSRLALL: u32 = 48;
pub const ETHTOOL_SRXCLSRLDEL: u32 = 49;
pub const ETHTOOL_SRXCLSRLINS: u32 = 50;
pub const ETHTOOL_FLASHDEV: u32 = 51;
pub const ETHTOOL_RESET: u32 = 52;
pub const ETHTOOL_SRXNTUPLE: u32 = 53;
pub const ETHTOOL_GRXNTUPLE: u32 = 54;
pub const ETHTOOL_GSSET_INFO: u32 = 55;
pub const ETHTOOL_GRXFHINDIR: u32 = 56;
pub const ETHTOOL_SRXFHINDIR: u32 = 57;
pub const ETHTOOL_GFEATURES: u32 = 58;
pub const ETHTOOL_SFEATURES: u32 = 59;
pub const ETHTOOL_GCHANNELS: u32 = 60;
pub const ETHTOOL_SCHANNELS: u32 = 61;
pub const ETHTOOL_SET_DUMP: u32 = 62;
pub const ETHTOOL_GET_DUMP_FLAG: u32 = 63;
pub const ETHTOOL_GET_DUMP_DATA: u32 = 64;
pub const ETHTOOL_GET_TS_INFO: u32 = 65;
pub const ETHTOOL_GMODULEINFO: u32 = 66;
pub const ETHTOOL_GMODULEEEPROM: u32 = 67;
pub const ETHTOOL_GEEE: u32 = 68;
pub const ETHTOOL_SEEE: u32 = 69;
pub const ETHTOOL_GRSSH: u32 = 70;
pub const ETHTOOL_SRSSH: u32 = 71;
pub const ETHTOOL_GTUNABLE: u32 = 72;
pub const ETHTOOL_STUNABLE: u32 = 73;
pub const ETHTOOL_GPHYSTATS: u32 = 74;
pub const ETHTOOL_PERQUEUE: u32 = 75;
pub const ETHTOOL_GLINKSETTINGS: u32 = 76;
pub const ETHTOOL_SLINKSETTINGS: u32 = 77;
pub const ETHTOOL_PHY_GTUNABLE: u32 = 78;
pub const ETHTOOL_PHY_STUNABLE: u32 = 79;
pub const ETHTOOL_GFECPARAM: u32 = 80;
pub const ETHTOOL_SFECPARAM: u32 = 81;
pub const SPARC_ETH_GSET: u32 = 1;
pub const SPARC_ETH_SSET: u32 = 2;
pub const SPEED_10: u32 = 10;
pub const SPEED_100: u32 = 100;
pub const SPEED_1000: u32 = 1000;
pub const SPEED_2500: u32 = 2500;
pub const SPEED_5000: u32 = 5000;
pub const SPEED_10000: u32 = 10000;
pub const SPEED_14000: u32 = 14000;
pub const SPEED_20000: u32 = 20000;
pub const SPEED_25000: u32 = 25000;
pub const SPEED_40000: u32 = 40000;
pub const SPEED_50000: u32 = 50000;
pub const SPEED_56000: u32 = 56000;
pub const SPEED_100000: u32 = 100000;
pub const SPEED_200000: u32 = 200000;
pub const SPEED_400000: u32 = 400000;
pub const SPEED_800000: u32 = 800000;
pub const SPEED_UNKNOWN: i32 = -1;
pub const DUPLEX_HALF: u32 = 0;
pub const DUPLEX_FULL: u32 = 1;
pub const DUPLEX_UNKNOWN: u32 = 255;
pub const MASTER_SLAVE_CFG_UNSUPPORTED: u32 = 0;
pub const MASTER_SLAVE_CFG_UNKNOWN: u32 = 1;
pub const MASTER_SLAVE_CFG_MASTER_PREFERRED: u32 = 2;
pub const MASTER_SLAVE_CFG_SLAVE_PREFERRED: u32 = 3;
pub const MASTER_SLAVE_CFG_MASTER_FORCE: u32 = 4;
pub const MASTER_SLAVE_CFG_SLAVE_FORCE: u32 = 5;
pub const MASTER_SLAVE_STATE_UNSUPPORTED: u32 = 0;
pub const MASTER_SLAVE_STATE_UNKNOWN: u32 = 1;
pub const MASTER_SLAVE_STATE_MASTER: u32 = 2;
pub const MASTER_SLAVE_STATE_SLAVE: u32 = 3;
pub const MASTER_SLAVE_STATE_ERR: u32 = 4;
pub const RATE_MATCH_NONE: u32 = 0;
pub const RATE_MATCH_PAUSE: u32 = 1;
pub const RATE_MATCH_CRS: u32 = 2;
pub const RATE_MATCH_OPEN_LOOP: u32 = 3;
pub const PORT_TP: u32 = 0;
pub const PORT_AUI: u32 = 1;
pub const PORT_MII: u32 = 2;
pub const PORT_FIBRE: u32 = 3;
pub const PORT_BNC: u32 = 4;
pub const PORT_DA: u32 = 5;
pub const PORT_NONE: u32 = 239;
pub const PORT_OTHER: u32 = 255;
pub const XCVR_INTERNAL: u32 = 0;
pub const XCVR_EXTERNAL: u32 = 1;
pub const XCVR_DUMMY1: u32 = 2;
pub const XCVR_DUMMY2: u32 = 3;
pub const XCVR_DUMMY3: u32 = 4;
pub const AUTONEG_DISABLE: u32 = 0;
pub const AUTONEG_ENABLE: u32 = 1;
pub const ETH_TP_MDI_INVALID: u32 = 0;
pub const ETH_TP_MDI: u32 = 1;
pub const ETH_TP_MDI_X: u32 = 2;
pub const ETH_TP_MDI_AUTO: u32 = 3;
pub const WAKE_PHY: u32 = 1;
pub const WAKE_UCAST: u32 = 2;
pub const WAKE_MCAST: u32 = 4;
pub const WAKE_BCAST: u32 = 8;
pub const WAKE_ARP: u32 = 16;
pub const WAKE_MAGIC: u32 = 32;
pub const WAKE_MAGICSECURE: u32 = 64;
pub const WAKE_FILTER: u32 = 128;
pub const WOL_MODE_COUNT: u32 = 8;
pub const RXH_XFRM_SYM_XOR: u32 = 1;
pub const RXH_XFRM_SYM_OR_XOR: u32 = 2;
pub const RXH_XFRM_NO_CHANGE: u32 = 255;
pub const TCP_V4_FLOW: u32 = 1;
pub const UDP_V4_FLOW: u32 = 2;
pub const SCTP_V4_FLOW: u32 = 3;
pub const AH_ESP_V4_FLOW: u32 = 4;
pub const TCP_V6_FLOW: u32 = 5;
pub const UDP_V6_FLOW: u32 = 6;
pub const SCTP_V6_FLOW: u32 = 7;
pub const AH_ESP_V6_FLOW: u32 = 8;
pub const AH_V4_FLOW: u32 = 9;
pub const ESP_V4_FLOW: u32 = 10;
pub const AH_V6_FLOW: u32 = 11;
pub const ESP_V6_FLOW: u32 = 12;
pub const IPV4_USER_FLOW: u32 = 13;
pub const IP_USER_FLOW: u32 = 13;
pub const IPV6_USER_FLOW: u32 = 14;
pub const IPV4_FLOW: u32 = 16;
pub const IPV6_FLOW: u32 = 17;
pub const ETHER_FLOW: u32 = 18;
pub const GTPU_V4_FLOW: u32 = 19;
pub const GTPU_V6_FLOW: u32 = 20;
pub const GTPC_V4_FLOW: u32 = 21;
pub const GTPC_V6_FLOW: u32 = 22;
pub const GTPC_TEID_V4_FLOW: u32 = 23;
pub const GTPC_TEID_V6_FLOW: u32 = 24;
pub const GTPU_EH_V4_FLOW: u32 = 25;
pub const GTPU_EH_V6_FLOW: u32 = 26;
pub const GTPU_UL_V4_FLOW: u32 = 27;
pub const GTPU_UL_V6_FLOW: u32 = 28;
pub const GTPU_DL_V4_FLOW: u32 = 29;
pub const GTPU_DL_V6_FLOW: u32 = 30;
pub const FLOW_EXT: u32 = 2147483648;
pub const FLOW_MAC_EXT: u32 = 1073741824;
pub const FLOW_RSS: u32 = 536870912;
pub const RXH_L2DA: u32 = 2;
pub const RXH_VLAN: u32 = 4;
pub const RXH_L3_PROTO: u32 = 8;
pub const RXH_IP_SRC: u32 = 16;
pub const RXH_IP_DST: u32 = 32;
pub const RXH_L4_B_0_1: u32 = 64;
pub const RXH_L4_B_2_3: u32 = 128;
pub const RXH_GTP_TEID: u32 = 256;
pub const RXH_DISCARD: u32 = 2147483648;
pub const RX_CLS_FLOW_DISC: i32 = -1;
pub const RX_CLS_FLOW_WAKE: i32 = -2;
pub const RX_CLS_LOC_SPECIAL: u32 = 2147483648;
pub const RX_CLS_LOC_ANY: u32 = 4294967295;
pub const RX_CLS_LOC_FIRST: u32 = 4294967294;
pub const RX_CLS_LOC_LAST: u32 = 4294967293;
pub const ETH_MODULE_SFF_8079: u32 = 1;
pub const ETH_MODULE_SFF_8079_LEN: u32 = 256;
pub const ETH_MODULE_SFF_8472: u32 = 2;
pub const ETH_MODULE_SFF_8472_LEN: u32 = 512;
pub const ETH_MODULE_SFF_8636: u32 = 3;
pub const ETH_MODULE_SFF_8636_LEN: u32 = 256;
pub const ETH_MODULE_SFF_8436: u32 = 4;
pub const ETH_MODULE_SFF_8436_LEN: u32 = 256;
pub const ETH_MODULE_SFF_8636_MAX_LEN: u32 = 640;
pub const ETH_MODULE_SFF_8436_MAX_LEN: u32 = 640;
pub const ETH_RESET_SHARED_SHIFT: u32 = 16;
pub const ETH_RSS_HASH_UNKNOWN: u32 = 0;
pub const ETH_RSS_HASH_NO_CHANGE: u32 = 0;
pub const ETHTOOL_STAT_NOT_SET: i32 = -1;
pub const ETHTOOL_MAX_LANES: u32 = 8;
pub const ETHTOOL_RMON_HIST_MAX: u32 = 10;
pub const ETH_MODULE_EEPROM_PAGE_LEN: u32 = 128;
pub const ETH_MODULE_MAX_I2C_ADDRESS: u32 = 127;
pub const FW_ACTION_NOUEVENT: u32 = 0;
pub const FW_ACTION_UEVENT: u32 = 1;
pub const MII_BMCR: u32 = 0;
pub const MII_BMSR: u32 = 1;
pub const MII_PHYSID1: u32 = 2;
pub const MII_PHYSID2: u32 = 3;
pub const MII_ADVERTISE: u32 = 4;
pub const MII_LPA: u32 = 5;
pub const MII_EXPANSION: u32 = 6;
pub const MII_CTRL1000: u32 = 9;
pub const MII_STAT1000: u32 = 10;
pub const MII_MMD_CTRL: u32 = 13;
pub const MII_MMD_DATA: u32 = 14;
pub const MII_ESTATUS: u32 = 15;
pub const MII_DCOUNTER: u32 = 18;
pub const MII_FCSCOUNTER: u32 = 19;
pub const MII_NWAYTEST: u32 = 20;
pub const MII_RERRCOUNTER: u32 = 21;
pub const MII_SREVISION: u32 = 22;
pub const MII_RESV1: u32 = 23;
pub const MII_LBRERROR: u32 = 24;
pub const MII_PHYADDR: u32 = 25;
pub const MII_RESV2: u32 = 26;
pub const MII_TPISTATUS: u32 = 27;
pub const MII_NCONFIG: u32 = 28;
pub const BMCR_RESV: u32 = 63;
pub const BMCR_SPEED1000: u32 = 64;
pub const BMCR_CTST: u32 = 128;
pub const BMCR_FULLDPLX: u32 = 256;
pub const BMCR_ANRESTART: u32 = 512;
pub const BMCR_ISOLATE: u32 = 1024;
pub const BMCR_PDOWN: u32 = 2048;
pub const BMCR_ANENABLE: u32 = 4096;
pub const BMCR_SPEED100: u32 = 8192;
pub const BMCR_LOOPBACK: u32 = 16384;
pub const BMCR_RESET: u32 = 32768;
pub const BMCR_SPEED10: u32 = 0;
pub const BMSR_ERCAP: u32 = 1;
pub const BMSR_JCD: u32 = 2;
pub const BMSR_LSTATUS: u32 = 4;
pub const BMSR_ANEGCAPABLE: u32 = 8;
pub const BMSR_RFAULT: u32 = 16;
pub const BMSR_ANEGCOMPLETE: u32 = 32;
pub const BMSR_RESV: u32 = 192;
pub const BMSR_ESTATEN: u32 = 256;
pub const BMSR_100HALF2: u32 = 512;
pub const BMSR_100FULL2: u32 = 1024;
pub const BMSR_10HALF: u32 = 2048;
pub const BMSR_10FULL: u32 = 4096;
pub const BMSR_100HALF: u32 = 8192;
pub const BMSR_100FULL: u32 = 16384;
pub const BMSR_100BASE4: u32 = 32768;
pub const ADVERTISE_SLCT: u32 = 31;
pub const ADVERTISE_CSMA: u32 = 1;
pub const ADVERTISE_10HALF: u32 = 32;
pub const ADVERTISE_1000XFULL: u32 = 32;
pub const ADVERTISE_10FULL: u32 = 64;
pub const ADVERTISE_1000XHALF: u32 = 64;
pub const ADVERTISE_100HALF: u32 = 128;
pub const ADVERTISE_1000XPAUSE: u32 = 128;
pub const ADVERTISE_100FULL: u32 = 256;
pub const ADVERTISE_1000XPSE_ASYM: u32 = 256;
pub const ADVERTISE_100BASE4: u32 = 512;
pub const ADVERTISE_PAUSE_CAP: u32 = 1024;
pub const ADVERTISE_PAUSE_ASYM: u32 = 2048;
pub const ADVERTISE_RESV: u32 = 4096;
pub const ADVERTISE_RFAULT: u32 = 8192;
pub const ADVERTISE_LPACK: u32 = 16384;
pub const ADVERTISE_NPAGE: u32 = 32768;
pub const ADVERTISE_FULL: u32 = 321;
pub const ADVERTISE_ALL: u32 = 480;
pub const LPA_SLCT: u32 = 31;
pub const LPA_10HALF: u32 = 32;
pub const LPA_1000XFULL: u32 = 32;
pub const LPA_10FULL: u32 = 64;
pub const LPA_1000XHALF: u32 = 64;
pub const LPA_100HALF: u32 = 128;
pub const LPA_1000XPAUSE: u32 = 128;
pub const LPA_100FULL: u32 = 256;
pub const LPA_1000XPAUSE_ASYM: u32 = 256;
pub const LPA_100BASE4: u32 = 512;
pub const LPA_PAUSE_CAP: u32 = 1024;
pub const LPA_PAUSE_ASYM: u32 = 2048;
pub const LPA_RESV: u32 = 4096;
pub const LPA_RFAULT: u32 = 8192;
pub const LPA_LPACK: u32 = 16384;
pub const LPA_NPAGE: u32 = 32768;
pub const LPA_DUPLEX: u32 = 320;
pub const LPA_100: u32 = 896;
pub const EXPANSION_NWAY: u32 = 1;
pub const EXPANSION_LCWP: u32 = 2;
pub const EXPANSION_ENABLENPAGE: u32 = 4;
pub const EXPANSION_NPCAPABLE: u32 = 8;
pub const EXPANSION_MFAULTS: u32 = 16;
pub const EXPANSION_RESV: u32 = 65504;
pub const ESTATUS_1000_XFULL: u32 = 32768;
pub const ESTATUS_1000_XHALF: u32 = 16384;
pub const ESTATUS_1000_TFULL: u32 = 8192;
pub const ESTATUS_1000_THALF: u32 = 4096;
pub const NWAYTEST_RESV1: u32 = 255;
pub const NWAYTEST_LOOPBACK: u32 = 256;
pub const NWAYTEST_RESV2: u32 = 65024;
pub const ADVERTISE_SGMII: u32 = 1;
pub const LPA_SGMII: u32 = 1;
pub const LPA_SGMII_SPD_MASK: u32 = 3072;
pub const LPA_SGMII_FULL_DUPLEX: u32 = 4096;
pub const LPA_SGMII_DPX_SPD_MASK: u32 = 7168;
pub const LPA_SGMII_10: u32 = 0;
pub const LPA_SGMII_10HALF: u32 = 0;
pub const LPA_SGMII_10FULL: u32 = 4096;
pub const LPA_SGMII_100: u32 = 1024;
pub const LPA_SGMII_100HALF: u32 = 1024;
pub const LPA_SGMII_100FULL: u32 = 5120;
pub const LPA_SGMII_1000: u32 = 2048;
pub const LPA_SGMII_1000HALF: u32 = 2048;
pub const LPA_SGMII_1000FULL: u32 = 6144;
pub const LPA_SGMII_LINK: u32 = 32768;
pub const ADVERTISE_1000FULL: u32 = 512;
pub const ADVERTISE_1000HALF: u32 = 256;
pub const CTL1000_PREFER_MASTER: u32 = 1024;
pub const CTL1000_AS_MASTER: u32 = 2048;
pub const CTL1000_ENABLE_MASTER: u32 = 4096;
pub const LPA_1000MSFAIL: u32 = 32768;
pub const LPA_1000MSRES: u32 = 16384;
pub const LPA_1000LOCALRXOK: u32 = 8192;
pub const LPA_1000REMRXOK: u32 = 4096;
pub const LPA_1000FULL: u32 = 2048;
pub const LPA_1000HALF: u32 = 1024;
pub const FLOW_CTRL_TX: u32 = 1;
pub const FLOW_CTRL_RX: u32 = 2;
pub const MII_MMD_CTRL_DEVAD_MASK: u32 = 31;
pub const MII_MMD_CTRL_ADDR: u32 = 0;
pub const MII_MMD_CTRL_NOINCR: u32 = 16384;
pub const MII_MMD_CTRL_INCR_RDWT: u32 = 32768;
pub const MII_MMD_CTRL_INCR_ON_WT: u32 = 49152;
pub const MDIO_MMD_PMAPMD: u32 = 1;
pub const MDIO_MMD_WIS: u32 = 2;
pub const MDIO_MMD_PCS: u32 = 3;
pub const MDIO_MMD_PHYXS: u32 = 4;
pub const MDIO_MMD_DTEXS: u32 = 5;
pub const MDIO_MMD_TC: u32 = 6;
pub const MDIO_MMD_AN: u32 = 7;
pub const MDIO_MMD_POWER_UNIT: u32 = 13;
pub const MDIO_MMD_C22EXT: u32 = 29;
pub const MDIO_MMD_VEND1: u32 = 30;
pub const MDIO_MMD_VEND2: u32 = 31;
pub const MDIO_CTRL1: u32 = 0;
pub const MDIO_STAT1: u32 = 1;
pub const MDIO_DEVID1: u32 = 2;
pub const MDIO_DEVID2: u32 = 3;
pub const MDIO_SPEED: u32 = 4;
pub const MDIO_DEVS1: u32 = 5;
pub const MDIO_DEVS2: u32 = 6;
pub const MDIO_CTRL2: u32 = 7;
pub const MDIO_STAT2: u32 = 8;
pub const MDIO_PMA_TXDIS: u32 = 9;
pub const MDIO_PMA_RXDET: u32 = 10;
pub const MDIO_PMA_EXTABLE: u32 = 11;
pub const MDIO_PKGID1: u32 = 14;
pub const MDIO_PKGID2: u32 = 15;
pub const MDIO_AN_ADVERTISE: u32 = 16;
pub const MDIO_AN_LPA: u32 = 19;
pub const MDIO_PCS_EEE_ABLE: u32 = 20;
pub const MDIO_PCS_EEE_ABLE2: u32 = 21;
pub const MDIO_PMA_NG_EXTABLE: u32 = 21;
pub const MDIO_PCS_EEE_WK_ERR: u32 = 22;
pub const MDIO_PHYXS_LNSTAT: u32 = 24;
pub const MDIO_AN_EEE_ADV: u32 = 60;
pub const MDIO_AN_EEE_LPABLE: u32 = 61;
pub const MDIO_AN_EEE_ADV2: u32 = 62;
pub const MDIO_AN_EEE_LPABLE2: u32 = 63;
pub const MDIO_AN_CTRL2: u32 = 64;
pub const MDIO_PMA_10GBT_SWAPPOL: u32 = 130;
pub const MDIO_PMA_10GBT_TXPWR: u32 = 131;
pub const MDIO_PMA_10GBT_SNR: u32 = 133;
pub const MDIO_PMA_10GBR_FSRT_CSR: u32 = 147;
pub const MDIO_PMA_10GBR_FECABLE: u32 = 170;
pub const MDIO_PCS_10GBX_STAT1: u32 = 24;
pub const MDIO_PCS_10GBRT_STAT1: u32 = 32;
pub const MDIO_PCS_10GBRT_STAT2: u32 = 33;
pub const MDIO_AN_10GBT_CTRL: u32 = 32;
pub const MDIO_AN_10GBT_STAT: u32 = 33;
pub const MDIO_B10L_PMA_CTRL: u32 = 2294;
pub const MDIO_PMA_10T1L_STAT: u32 = 2295;
pub const MDIO_PCS_10T1L_CTRL: u32 = 2278;
pub const MDIO_PMA_PMD_BT1: u32 = 18;
pub const MDIO_AN_T1_CTRL: u32 = 512;
pub const MDIO_AN_T1_STAT: u32 = 513;
pub const MDIO_AN_T1_ADV_L: u32 = 514;
pub const MDIO_AN_T1_ADV_M: u32 = 515;
pub const MDIO_AN_T1_ADV_H: u32 = 516;
pub const MDIO_AN_T1_LP_L: u32 = 517;
pub const MDIO_AN_T1_LP_M: u32 = 518;
pub const MDIO_AN_T1_LP_H: u32 = 519;
pub const MDIO_AN_10BT1_AN_CTRL: u32 = 526;
pub const MDIO_AN_10BT1_AN_STAT: u32 = 527;
pub const MDIO_PMA_PMD_BT1_CTRL: u32 = 2100;
pub const MDIO_PCS_1000BT1_CTRL: u32 = 2304;
pub const MDIO_PCS_1000BT1_STAT: u32 = 2305;
pub const MDIO_PMA_LASI_RXCTRL: u32 = 36864;
pub const MDIO_PMA_LASI_TXCTRL: u32 = 36865;
pub const MDIO_PMA_LASI_CTRL: u32 = 36866;
pub const MDIO_PMA_LASI_RXSTAT: u32 = 36867;
pub const MDIO_PMA_LASI_TXSTAT: u32 = 36868;
pub const MDIO_PMA_LASI_STAT: u32 = 36869;
pub const MDIO_CTRL1_SPEEDSELEXT: u32 = 8256;
pub const MDIO_CTRL1_SPEEDSEL: u32 = 8316;
pub const MDIO_CTRL1_FULLDPLX: u32 = 256;
pub const MDIO_CTRL1_LPOWER: u32 = 2048;
pub const MDIO_CTRL1_RESET: u32 = 32768;
pub const MDIO_PMA_CTRL1_LOOPBACK: u32 = 1;
pub const MDIO_PMA_CTRL1_SPEED1000: u32 = 64;
pub const MDIO_PMA_CTRL1_SPEED100: u32 = 8192;
pub const MDIO_PCS_CTRL1_LOOPBACK: u32 = 16384;
pub const MDIO_PHYXS_CTRL1_LOOPBACK: u32 = 16384;
pub const MDIO_AN_CTRL1_RESTART: u32 = 512;
pub const MDIO_AN_CTRL1_ENABLE: u32 = 4096;
pub const MDIO_AN_CTRL1_XNP: u32 = 8192;
pub const MDIO_PCS_CTRL1_CLKSTOP_EN: u32 = 1024;
pub const MDIO_CTRL1_SPEED10G: u32 = 8256;
pub const MDIO_CTRL1_SPEED10P2B: u32 = 8260;
pub const MDIO_CTRL1_SPEED2_5G: u32 = 8280;
pub const MDIO_CTRL1_SPEED5G: u32 = 8284;
pub const MDIO_STAT1_LPOWERABLE: u32 = 2;
pub const MDIO_STAT1_LSTATUS: u32 = 4;
pub const MDIO_STAT1_FAULT: u32 = 128;
pub const MDIO_PCS_STAT1_CLKSTOP_CAP: u32 = 64;
pub const MDIO_AN_STAT1_LPABLE: u32 = 1;
pub const MDIO_AN_STAT1_ABLE: u32 = 8;
pub const MDIO_AN_STAT1_RFAULT: u32 = 16;
pub const MDIO_AN_STAT1_COMPLETE: u32 = 32;
pub const MDIO_AN_STAT1_PAGE: u32 = 64;
pub const MDIO_AN_STAT1_XNP: u32 = 128;
pub const MDIO_SPEED_10G: u32 = 1;
pub const MDIO_PMA_SPEED_2B: u32 = 2;
pub const MDIO_PMA_SPEED_10P: u32 = 4;
pub const MDIO_PMA_SPEED_1000: u32 = 16;
pub const MDIO_PMA_SPEED_100: u32 = 32;
pub const MDIO_PMA_SPEED_10: u32 = 64;
pub const MDIO_PMA_SPEED_2_5G: u32 = 8192;
pub const MDIO_PMA_SPEED_5G: u32 = 16384;
pub const MDIO_PCS_SPEED_10P2B: u32 = 2;
pub const MDIO_PCS_SPEED_2_5G: u32 = 64;
pub const MDIO_PCS_SPEED_5G: u32 = 128;
pub const MDIO_PMA_CTRL2_TYPE: u32 = 15;
pub const MDIO_PMA_CTRL2_10GBCX4: u32 = 0;
pub const MDIO_PMA_CTRL2_10GBEW: u32 = 1;
pub const MDIO_PMA_CTRL2_10GBLW: u32 = 2;
pub const MDIO_PMA_CTRL2_10GBSW: u32 = 3;
pub const MDIO_PMA_CTRL2_10GBLX4: u32 = 4;
pub const MDIO_PMA_CTRL2_10GBER: u32 = 5;
pub const MDIO_PMA_CTRL2_10GBLR: u32 = 6;
pub const MDIO_PMA_CTRL2_10GBSR: u32 = 7;
pub const MDIO_PMA_CTRL2_10GBLRM: u32 = 8;
pub const MDIO_PMA_CTRL2_10GBT: u32 = 9;
pub const MDIO_PMA_CTRL2_10GBKX4: u32 = 10;
pub const MDIO_PMA_CTRL2_10GBKR: u32 = 11;
pub const MDIO_PMA_CTRL2_1000BT: u32 = 12;
pub const MDIO_PMA_CTRL2_1000BKX: u32 = 13;
pub const MDIO_PMA_CTRL2_100BTX: u32 = 14;
pub const MDIO_PMA_CTRL2_10BT: u32 = 15;
pub const MDIO_PMA_CTRL2_2_5GBT: u32 = 48;
pub const MDIO_PMA_CTRL2_5GBT: u32 = 49;
pub const MDIO_PMA_CTRL2_BASET1: u32 = 61;
pub const MDIO_PCS_CTRL2_TYPE: u32 = 3;
pub const MDIO_PCS_CTRL2_10GBR: u32 = 0;
pub const MDIO_PCS_CTRL2_10GBX: u32 = 1;
pub const MDIO_PCS_CTRL2_10GBW: u32 = 2;
pub const MDIO_PCS_CTRL2_10GBT: u32 = 3;
pub const MDIO_STAT2_RXFAULT: u32 = 1024;
pub const MDIO_STAT2_TXFAULT: u32 = 2048;
pub const MDIO_STAT2_DEVPRST: u32 = 49152;
pub const MDIO_STAT2_DEVPRST_VAL: u32 = 32768;
pub const MDIO_PMA_STAT2_LBABLE: u32 = 1;
pub const MDIO_PMA_STAT2_10GBEW: u32 = 2;
pub const MDIO_PMA_STAT2_10GBLW: u32 = 4;
pub const MDIO_PMA_STAT2_10GBSW: u32 = 8;
pub const MDIO_PMA_STAT2_10GBLX4: u32 = 16;
pub const MDIO_PMA_STAT2_10GBER: u32 = 32;
pub const MDIO_PMA_STAT2_10GBLR: u32 = 64;
pub const MDIO_PMA_STAT2_10GBSR: u32 = 128;
pub const MDIO_PMD_STAT2_TXDISAB: u32 = 256;
pub const MDIO_PMA_STAT2_EXTABLE: u32 = 512;
pub const MDIO_PMA_STAT2_RXFLTABLE: u32 = 4096;
pub const MDIO_PMA_STAT2_TXFLTABLE: u32 = 8192;
pub const MDIO_PCS_STAT2_10GBR: u32 = 1;
pub const MDIO_PCS_STAT2_10GBX: u32 = 2;
pub const MDIO_PCS_STAT2_10GBW: u32 = 4;
pub const MDIO_PCS_STAT2_RXFLTABLE: u32 = 4096;
pub const MDIO_PCS_STAT2_TXFLTABLE: u32 = 8192;
pub const MDIO_PMD_TXDIS_GLOBAL: u32 = 1;
pub const MDIO_PMD_TXDIS_0: u32 = 2;
pub const MDIO_PMD_TXDIS_1: u32 = 4;
pub const MDIO_PMD_TXDIS_2: u32 = 8;
pub const MDIO_PMD_TXDIS_3: u32 = 16;
pub const MDIO_PMD_RXDET_GLOBAL: u32 = 1;
pub const MDIO_PMD_RXDET_0: u32 = 2;
pub const MDIO_PMD_RXDET_1: u32 = 4;
pub const MDIO_PMD_RXDET_2: u32 = 8;
pub const MDIO_PMD_RXDET_3: u32 = 16;
pub const MDIO_PMA_EXTABLE_10GCX4: u32 = 1;
pub const MDIO_PMA_EXTABLE_10GBLRM: u32 = 2;
pub const MDIO_PMA_EXTABLE_10GBT: u32 = 4;
pub const MDIO_PMA_EXTABLE_10GBKX4: u32 = 8;
pub const MDIO_PMA_EXTABLE_10GBKR: u32 = 16;
pub const MDIO_PMA_EXTABLE_1000BT: u32 = 32;
pub const MDIO_PMA_EXTABLE_1000BKX: u32 = 64;
pub const MDIO_PMA_EXTABLE_100BTX: u32 = 128;
pub const MDIO_PMA_EXTABLE_10BT: u32 = 256;
pub const MDIO_PMA_EXTABLE_BT1: u32 = 2048;
pub const MDIO_PMA_EXTABLE_NBT: u32 = 16384;
pub const MDIO_PHYXS_LNSTAT_SYNC0: u32 = 1;
pub const MDIO_PHYXS_LNSTAT_SYNC1: u32 = 2;
pub const MDIO_PHYXS_LNSTAT_SYNC2: u32 = 4;
pub const MDIO_PHYXS_LNSTAT_SYNC3: u32 = 8;
pub const MDIO_PHYXS_LNSTAT_ALIGN: u32 = 4096;
pub const MDIO_PMA_10GBT_SWAPPOL_ABNX: u32 = 1;
pub const MDIO_PMA_10GBT_SWAPPOL_CDNX: u32 = 2;
pub const MDIO_PMA_10GBT_SWAPPOL_AREV: u32 = 256;
pub const MDIO_PMA_10GBT_SWAPPOL_BREV: u32 = 512;
pub const MDIO_PMA_10GBT_SWAPPOL_CREV: u32 = 1024;
pub const MDIO_PMA_10GBT_SWAPPOL_DREV: u32 = 2048;
pub const MDIO_PMA_10GBT_TXPWR_SHORT: u32 = 1;
pub const MDIO_PMA_10GBT_SNR_BIAS: u32 = 32768;
pub const MDIO_PMA_10GBT_SNR_MAX: u32 = 127;
pub const MDIO_PMA_10GBR_FECABLE_ABLE: u32 = 1;
pub const MDIO_PMA_10GBR_FECABLE_ERRABLE: u32 = 2;
pub const MDIO_PMA_10GBR_FSRT_ENABLE: u32 = 1;
pub const MDIO_PCS_10GBRT_STAT1_BLKLK: u32 = 1;
pub const MDIO_PCS_10GBRT_STAT2_ERR: u32 = 255;
pub const MDIO_PCS_10GBRT_STAT2_BER: u32 = 16128;
pub const MDIO_AN_10GBT_CTRL_ADVFSRT2_5G: u32 = 32;
pub const MDIO_AN_10GBT_CTRL_ADV2_5G: u32 = 128;
pub const MDIO_AN_10GBT_CTRL_ADV5G: u32 = 256;
pub const MDIO_AN_10GBT_CTRL_ADV10G: u32 = 4096;
pub const MDIO_AN_10GBT_STAT_LP2_5G: u32 = 32;
pub const MDIO_AN_10GBT_STAT_LP5G: u32 = 64;
pub const MDIO_AN_10GBT_STAT_LPTRR: u32 = 512;
pub const MDIO_AN_10GBT_STAT_LPLTABLE: u32 = 1024;
pub const MDIO_AN_10GBT_STAT_LP10G: u32 = 2048;
pub const MDIO_AN_10GBT_STAT_REMOK: u32 = 4096;
pub const MDIO_AN_10GBT_STAT_LOCOK: u32 = 8192;
pub const MDIO_AN_10GBT_STAT_MS: u32 = 16384;
pub const MDIO_AN_10GBT_STAT_MSFLT: u32 = 32768;
pub const MDIO_PMA_10T1L_CTRL_LB_EN: u32 = 1;
pub const MDIO_PMA_10T1L_CTRL_EEE_EN: u32 = 1024;
pub const MDIO_PMA_10T1L_CTRL_LOW_POWER: u32 = 2048;
pub const MDIO_PMA_10T1L_CTRL_2V4_EN: u32 = 4096;
pub const MDIO_PMA_10T1L_CTRL_TX_DIS: u32 = 16384;
pub const MDIO_PMA_10T1L_CTRL_PMA_RST: u32 = 32768;
pub const MDIO_PMA_10T1L_STAT_LINK: u32 = 1;
pub const MDIO_PMA_10T1L_STAT_FAULT: u32 = 2;
pub const MDIO_PMA_10T1L_STAT_POLARITY: u32 = 4;
pub const MDIO_PMA_10T1L_STAT_RECV_FAULT: u32 = 512;
pub const MDIO_PMA_10T1L_STAT_EEE: u32 = 1024;
pub const MDIO_PMA_10T1L_STAT_LOW_POWER: u32 = 2048;
pub const MDIO_PMA_10T1L_STAT_2V4_ABLE: u32 = 4096;
pub const MDIO_PMA_10T1L_STAT_LB_ABLE: u32 = 8192;
pub const MDIO_PCS_10T1L_CTRL_LB: u32 = 16384;
pub const MDIO_PCS_10T1L_CTRL_RESET: u32 = 32768;
pub const MDIO_PMA_PMD_BT1_B100_ABLE: u32 = 1;
pub const MDIO_PMA_PMD_BT1_B1000_ABLE: u32 = 2;
pub const MDIO_PMA_PMD_BT1_B10L_ABLE: u32 = 4;
pub const MDIO_AN_T1_ADV_L_PAUSE_CAP: u32 = 1024;
pub const MDIO_AN_T1_ADV_L_PAUSE_ASYM: u32 = 2048;
pub const MDIO_AN_T1_ADV_L_FORCE_MS: u32 = 4096;
pub const MDIO_AN_T1_ADV_L_REMOTE_FAULT: u32 = 8192;
pub const MDIO_AN_T1_ADV_L_ACK: u32 = 16384;
pub const MDIO_AN_T1_ADV_L_NEXT_PAGE_REQ: u32 = 32768;
pub const MDIO_AN_T1_ADV_M_B10L: u32 = 16384;
pub const MDIO_AN_T1_ADV_M_1000BT1: u32 = 128;
pub const MDIO_AN_T1_ADV_M_100BT1: u32 = 32;
pub const MDIO_AN_T1_ADV_M_MST: u32 = 16;
pub const MDIO_AN_T1_ADV_H_10L_TX_HI_REQ: u32 = 4096;
pub const MDIO_AN_T1_ADV_H_10L_TX_HI: u32 = 8192;
pub const MDIO_AN_T1_LP_L_PAUSE_CAP: u32 = 1024;
pub const MDIO_AN_T1_LP_L_PAUSE_ASYM: u32 = 2048;
pub const MDIO_AN_T1_LP_L_FORCE_MS: u32 = 4096;
pub const MDIO_AN_T1_LP_L_REMOTE_FAULT: u32 = 8192;
pub const MDIO_AN_T1_LP_L_ACK: u32 = 16384;
pub const MDIO_AN_T1_LP_L_NEXT_PAGE_REQ: u32 = 32768;
pub const MDIO_AN_T1_LP_M_MST: u32 = 16;
pub const MDIO_AN_T1_LP_M_B10L: u32 = 16384;
pub const MDIO_AN_T1_LP_H_10L_TX_HI_REQ: u32 = 4096;
pub const MDIO_AN_T1_LP_H_10L_TX_HI: u32 = 8192;
pub const MDIO_AN_10BT1_AN_CTRL_ADV_EEE_T1L: u32 = 16384;
pub const MDIO_AN_10BT1_AN_STAT_LPA_EEE_T1L: u32 = 16384;
pub const MDIO_PMA_PMD_BT1_CTRL_STRAP: u32 = 15;
pub const MDIO_PMA_PMD_BT1_CTRL_STRAP_B1000: u32 = 1;
pub const MDIO_PMA_PMD_BT1_CTRL_CFG_MST: u32 = 16384;
pub const MDIO_PCS_1000BT1_CTRL_LOW_POWER: u32 = 2048;
pub const MDIO_PCS_1000BT1_CTRL_DISABLE_TX: u32 = 16384;
pub const MDIO_PCS_1000BT1_CTRL_RESET: u32 = 32768;
pub const MDIO_PCS_1000BT1_STAT_LINK: u32 = 4;
pub const MDIO_PCS_1000BT1_STAT_FAULT: u32 = 128;
pub const MDIO_AN_EEE_ADV_100TX: u32 = 2;
pub const MDIO_AN_EEE_ADV_1000T: u32 = 4;
pub const MDIO_EEE_100TX: u32 = 2;
pub const MDIO_EEE_1000T: u32 = 4;
pub const MDIO_EEE_10GT: u32 = 8;
pub const MDIO_EEE_1000KX: u32 = 16;
pub const MDIO_EEE_10GKX4: u32 = 32;
pub const MDIO_EEE_10GKR: u32 = 64;
pub const MDIO_EEE_40GR_FW: u32 = 256;
pub const MDIO_EEE_40GR_DS: u32 = 512;
pub const MDIO_EEE_100GR_FW: u32 = 4096;
pub const MDIO_EEE_100GR_DS: u32 = 8192;
pub const MDIO_EEE_2_5GT: u32 = 1;
pub const MDIO_EEE_5GT: u32 = 2;
pub const MDIO_AN_THP_BP2_5GT: u32 = 8;
pub const MDIO_PMA_NG_EXTABLE_2_5GBT: u32 = 1;
pub const MDIO_PMA_NG_EXTABLE_5GBT: u32 = 2;
pub const MDIO_PMA_LASI_RX_PHYXSLFLT: u32 = 1;
pub const MDIO_PMA_LASI_RX_PCSLFLT: u32 = 8;
pub const MDIO_PMA_LASI_RX_PMALFLT: u32 = 16;
pub const MDIO_PMA_LASI_RX_OPTICPOWERFLT: u32 = 32;
pub const MDIO_PMA_LASI_RX_WISLFLT: u32 = 512;
pub const MDIO_PMA_LASI_TX_PHYXSLFLT: u32 = 1;
pub const MDIO_PMA_LASI_TX_PCSLFLT: u32 = 8;
pub const MDIO_PMA_LASI_TX_PMALFLT: u32 = 16;
pub const MDIO_PMA_LASI_TX_LASERPOWERFLT: u32 = 128;
pub const MDIO_PMA_LASI_TX_LASERTEMPFLT: u32 = 256;
pub const MDIO_PMA_LASI_TX_LASERBICURRFLT: u32 = 512;
pub const MDIO_PMA_LASI_LSALARM: u32 = 1;
pub const MDIO_PMA_LASI_TXALARM: u32 = 2;
pub const MDIO_PMA_LASI_RXALARM: u32 = 4;
pub const MDIO_PHY_ID_C45: u32 = 32768;
pub const MDIO_PHY_ID_PRTAD: u32 = 992;
pub const MDIO_PHY_ID_DEVAD: u32 = 31;
pub const MDIO_PHY_ID_C45_MASK: u32 = 33791;
pub const MDIO_USXGMII_EEE_CLK_STP: u32 = 128;
pub const MDIO_USXGMII_EEE: u32 = 256;
pub const MDIO_USXGMII_SPD_MASK: u32 = 3584;
pub const MDIO_USXGMII_FULL_DUPLEX: u32 = 4096;
pub const MDIO_USXGMII_DPX_SPD_MASK: u32 = 7680;
pub const MDIO_USXGMII_10: u32 = 0;
pub const MDIO_USXGMII_10HALF: u32 = 0;
pub const MDIO_USXGMII_10FULL: u32 = 4096;
pub const MDIO_USXGMII_100: u32 = 512;
pub const MDIO_USXGMII_100HALF: u32 = 512;
pub const MDIO_USXGMII_100FULL: u32 = 4608;
pub const MDIO_USXGMII_1000: u32 = 1024;
pub const MDIO_USXGMII_1000HALF: u32 = 1024;
pub const MDIO_USXGMII_1000FULL: u32 = 5120;
pub const MDIO_USXGMII_10G: u32 = 1536;
pub const MDIO_USXGMII_10GHALF: u32 = 1536;
pub const MDIO_USXGMII_10GFULL: u32 = 5632;
pub const MDIO_USXGMII_2500: u32 = 2048;
pub const MDIO_USXGMII_2500HALF: u32 = 2048;
pub const MDIO_USXGMII_2500FULL: u32 = 6144;
pub const MDIO_USXGMII_5000: u32 = 2560;
pub const MDIO_USXGMII_5000HALF: u32 = 2560;
pub const MDIO_USXGMII_5000FULL: u32 = 6656;
pub const MDIO_USXGMII_LINK: u32 = 32768;
pub const PCI_ANY_ID: i32 = -1;
pub const IEEE1394_MATCH_VENDOR_ID: u32 = 1;
pub const IEEE1394_MATCH_MODEL_ID: u32 = 2;
pub const IEEE1394_MATCH_SPECIFIER_ID: u32 = 4;
pub const IEEE1394_MATCH_VERSION: u32 = 8;
pub const USB_DEVICE_ID_MATCH_VENDOR: u32 = 1;
pub const USB_DEVICE_ID_MATCH_PRODUCT: u32 = 2;
pub const USB_DEVICE_ID_MATCH_DEV_LO: u32 = 4;
pub const USB_DEVICE_ID_MATCH_DEV_HI: u32 = 8;
pub const USB_DEVICE_ID_MATCH_DEV_CLASS: u32 = 16;
pub const USB_DEVICE_ID_MATCH_DEV_SUBCLASS: u32 = 32;
pub const USB_DEVICE_ID_MATCH_DEV_PROTOCOL: u32 = 64;
pub const USB_DEVICE_ID_MATCH_INT_CLASS: u32 = 128;
pub const USB_DEVICE_ID_MATCH_INT_SUBCLASS: u32 = 256;
pub const USB_DEVICE_ID_MATCH_INT_PROTOCOL: u32 = 512;
pub const USB_DEVICE_ID_MATCH_INT_NUMBER: u32 = 1024;
pub const HID_ANY_ID: i32 = -1;
pub const HID_BUS_ANY: u32 = 65535;
pub const HID_GROUP_ANY: u32 = 0;
pub const CCW_DEVICE_ID_MATCH_CU_TYPE: u32 = 1;
pub const CCW_DEVICE_ID_MATCH_CU_MODEL: u32 = 2;
pub const CCW_DEVICE_ID_MATCH_DEVICE_TYPE: u32 = 4;
pub const CCW_DEVICE_ID_MATCH_DEVICE_MODEL: u32 = 8;
pub const AP_DEVICE_ID_MATCH_CARD_TYPE: u32 = 1;
pub const AP_DEVICE_ID_MATCH_QUEUE_TYPE: u32 = 2;
pub const ACPI_ID_LEN: u32 = 16;
pub const PNP_ID_LEN: u32 = 8;
pub const PNP_MAX_DEVICES: u32 = 8;
pub const SERIO_ANY: u32 = 255;
pub const PCMCIA_DEV_ID_MATCH_MANF_ID: u32 = 1;
pub const PCMCIA_DEV_ID_MATCH_CARD_ID: u32 = 2;
pub const PCMCIA_DEV_ID_MATCH_FUNC_ID: u32 = 4;
pub const PCMCIA_DEV_ID_MATCH_FUNCTION: u32 = 8;
pub const PCMCIA_DEV_ID_MATCH_PROD_ID1: u32 = 16;
pub const PCMCIA_DEV_ID_MATCH_PROD_ID2: u32 = 32;
pub const PCMCIA_DEV_ID_MATCH_PROD_ID3: u32 = 64;
pub const PCMCIA_DEV_ID_MATCH_PROD_ID4: u32 = 128;
pub const PCMCIA_DEV_ID_MATCH_DEVICE_NO: u32 = 256;
pub const PCMCIA_DEV_ID_MATCH_FAKE_CIS: u32 = 512;
pub const PCMCIA_DEV_ID_MATCH_ANONYMOUS: u32 = 1024;
pub const INPUT_DEVICE_ID_EV_MAX: u32 = 31;
pub const INPUT_DEVICE_ID_KEY_MIN_INTERESTING: u32 = 113;
pub const INPUT_DEVICE_ID_KEY_MAX: u32 = 767;
pub const INPUT_DEVICE_ID_REL_MAX: u32 = 15;
pub const INPUT_DEVICE_ID_ABS_MAX: u32 = 63;
pub const INPUT_DEVICE_ID_MSC_MAX: u32 = 7;
pub const INPUT_DEVICE_ID_LED_MAX: u32 = 15;
pub const INPUT_DEVICE_ID_SND_MAX: u32 = 7;
pub const INPUT_DEVICE_ID_FF_MAX: u32 = 127;
pub const INPUT_DEVICE_ID_SW_MAX: u32 = 16;
pub const INPUT_DEVICE_ID_PROP_MAX: u32 = 31;
pub const INPUT_DEVICE_ID_MATCH_BUS: u32 = 1;
pub const INPUT_DEVICE_ID_MATCH_VENDOR: u32 = 2;
pub const INPUT_DEVICE_ID_MATCH_PRODUCT: u32 = 4;
pub const INPUT_DEVICE_ID_MATCH_VERSION: u32 = 8;
pub const INPUT_DEVICE_ID_MATCH_EVBIT: u32 = 16;
pub const INPUT_DEVICE_ID_MATCH_KEYBIT: u32 = 32;
pub const INPUT_DEVICE_ID_MATCH_RELBIT: u32 = 64;
pub const INPUT_DEVICE_ID_MATCH_ABSBIT: u32 = 128;
pub const INPUT_DEVICE_ID_MATCH_MSCIT: u32 = 256;
pub const INPUT_DEVICE_ID_MATCH_LEDBIT: u32 = 512;
pub const INPUT_DEVICE_ID_MATCH_SNDBIT: u32 = 1024;
pub const INPUT_DEVICE_ID_MATCH_FFBIT: u32 = 2048;
pub const INPUT_DEVICE_ID_MATCH_SWBIT: u32 = 4096;
pub const INPUT_DEVICE_ID_MATCH_PROPBIT: u32 = 8192;
pub const EISA_SIG_LEN: u32 = 8;
pub const EISA_DEVICE_MODALIAS_FMT: &[u8; 9] = b"eisa:s%s\0";
pub const PA_HWTYPE_ANY_ID: u32 = 255;
pub const PA_HVERSION_REV_ANY_ID: u32 = 255;
pub const PA_HVERSION_ANY_ID: u32 = 65535;
pub const PA_SVERSION_ANY_ID: u32 = 4294967295;
pub const SDIO_ANY_ID: i32 = -1;
pub const SSB_ANY_VENDOR: u32 = 65535;
pub const SSB_ANY_ID: u32 = 65535;
pub const SSB_ANY_REV: u32 = 255;
pub const BCMA_ANY_MANUF: u32 = 65535;
pub const BCMA_ANY_ID: u32 = 65535;
pub const BCMA_ANY_REV: u32 = 255;
pub const BCMA_ANY_CLASS: u32 = 255;
pub const VIRTIO_DEV_ANY_ID: u32 = 4294967295;
pub const RPMSG_NAME_SIZE: u32 = 32;
pub const RPMSG_DEVICE_MODALIAS_FMT: &[u8; 9] = b"rpmsg:%s\0";
pub const I2C_NAME_SIZE: u32 = 20;
pub const I2C_MODULE_PREFIX: &[u8; 5] = b"i2c:\0";
pub const PCI_EPF_NAME_SIZE: u32 = 20;
pub const PCI_EPF_MODULE_PREFIX: &[u8; 9] = b"pci_epf:\0";
pub const I3C_MATCH_DCR: u32 = 1;
pub const I3C_MATCH_MANUF: u32 = 2;
pub const I3C_MATCH_PART: u32 = 4;
pub const I3C_MATCH_EXTRA_INFO: u32 = 8;
pub const SPI_NAME_SIZE: u32 = 32;
pub const SPI_MODULE_PREFIX: &[u8; 5] = b"spi:\0";
pub const SLIMBUS_NAME_SIZE: u32 = 32;
pub const SLIMBUS_MODULE_PREFIX: &[u8; 6] = b"slim:\0";
pub const APR_NAME_SIZE: u32 = 32;
pub const APR_MODULE_PREFIX: &[u8; 5] = b"apr:\0";
pub const SPMI_NAME_SIZE: u32 = 32;
pub const SPMI_MODULE_PREFIX: &[u8; 6] = b"spmi:\0";
pub const PLATFORM_NAME_SIZE: u32 = 20;
pub const PLATFORM_MODULE_PREFIX: &[u8; 10] = b"platform:\0";
pub const MDIO_NAME_SIZE: u32 = 32;
pub const MDIO_MODULE_PREFIX: &[u8; 6] = b"mdio:\0";
pub const MDIO_ID_FMT: &[u8; 65] =
    b"%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u\0";
pub const ZORRO_WILDCARD: u32 = 4294967295;
pub const ZORRO_DEVICE_MODALIAS_FMT: &[u8; 12] = b"zorro:i%08X\0";
pub const ISAPNP_ANY_ID: u32 = 65535;
pub const X86_VENDOR_ANY: u32 = 65535;
pub const X86_FAMILY_ANY: u32 = 0;
pub const X86_MODEL_ANY: u32 = 0;
pub const X86_STEPPING_ANY: u32 = 0;
pub const X86_STEP_MIN: u32 = 0;
pub const X86_STEP_MAX: u32 = 15;
pub const X86_FEATURE_ANY: u32 = 0;
pub const X86_CPU_TYPE_ANY: u32 = 0;
pub const IPACK_ANY_FORMAT: u32 = 255;
pub const IPACK_ANY_ID: i32 = -1;
pub const MEI_CL_MODULE_PREFIX: &[u8; 5] = b"mei:\0";
pub const MEI_CL_NAME_SIZE: u32 = 32;
pub const MEI_CL_VERSION_ANY: u32 = 255;
pub const RIO_ANY_ID: u32 = 65535;
pub const TBSVC_MATCH_PROTOCOL_KEY: u32 = 1;
pub const TBSVC_MATCH_PROTOCOL_ID: u32 = 2;
pub const TBSVC_MATCH_PROTOCOL_VERSION: u32 = 4;
pub const TBSVC_MATCH_PROTOCOL_REVISION: u32 = 8;
pub const TYPEC_ANY_MODE: u32 = 7;
pub const WMI_MODULE_PREFIX: &[u8; 5] = b"wmi:\0";
pub const MHI_DEVICE_MODALIAS_FMT: &[u8; 7] = b"mhi:%s\0";
pub const MHI_NAME_SIZE: u32 = 32;
pub const MHI_EP_DEVICE_MODALIAS_FMT: &[u8; 10] = b"mhi_ep:%s\0";
pub const AUXILIARY_NAME_SIZE: u32 = 32;
pub const AUXILIARY_MODULE_PREFIX: &[u8; 11] = b"auxiliary:\0";
pub const SSAM_MATCH_TARGET: u32 = 1;
pub const SSAM_MATCH_INSTANCE: u32 = 2;
pub const SSAM_MATCH_FUNCTION: u32 = 4;
pub const ISHTP_MODULE_PREFIX: &[u8; 7] = b"ishtp:\0";
pub const CDX_ANY_ID: u32 = 65535;
pub const MDIO_DEVICE_FLAG_PHY: u32 = 1;
pub const MDIO_PRTAD_NONE: i32 = -1;
pub const MDIO_DEVAD_NONE: i32 = -1;
pub const MDIO_SUPPORTS_C22: u32 = 1;
pub const MDIO_SUPPORTS_C45: u32 = 2;
pub const MDIO_EMULATE_C22: u32 = 4;
pub const UNNAMED_MAJOR: u32 = 0;
pub const MEM_MAJOR: u32 = 1;
pub const RAMDISK_MAJOR: u32 = 1;
pub const FLOPPY_MAJOR: u32 = 2;
pub const PTY_MASTER_MAJOR: u32 = 2;
pub const IDE0_MAJOR: u32 = 3;
pub const HD_MAJOR: u32 = 3;
pub const PTY_SLAVE_MAJOR: u32 = 3;
pub const TTY_MAJOR: u32 = 4;
pub const TTYAUX_MAJOR: u32 = 5;
pub const LP_MAJOR: u32 = 6;
pub const VCS_MAJOR: u32 = 7;
pub const LOOP_MAJOR: u32 = 7;
pub const SCSI_DISK0_MAJOR: u32 = 8;
pub const SCSI_TAPE_MAJOR: u32 = 9;
pub const MD_MAJOR: u32 = 9;
pub const MISC_MAJOR: u32 = 10;
pub const SCSI_CDROM_MAJOR: u32 = 11;
pub const MUX_MAJOR: u32 = 11;
pub const XT_DISK_MAJOR: u32 = 13;
pub const INPUT_MAJOR: u32 = 13;
pub const SOUND_MAJOR: u32 = 14;
pub const CDU31A_CDROM_MAJOR: u32 = 15;
pub const JOYSTICK_MAJOR: u32 = 15;
pub const GOLDSTAR_CDROM_MAJOR: u32 = 16;
pub const OPTICS_CDROM_MAJOR: u32 = 17;
pub const SANYO_CDROM_MAJOR: u32 = 18;
pub const MITSUMI_X_CDROM_MAJOR: u32 = 20;
pub const MFM_ACORN_MAJOR: u32 = 21;
pub const SCSI_GENERIC_MAJOR: u32 = 21;
pub const IDE1_MAJOR: u32 = 22;
pub const DIGICU_MAJOR: u32 = 22;
pub const DIGI_MAJOR: u32 = 23;
pub const MITSUMI_CDROM_MAJOR: u32 = 23;
pub const CDU535_CDROM_MAJOR: u32 = 24;
pub const STL_SERIALMAJOR: u32 = 24;
pub const MATSUSHITA_CDROM_MAJOR: u32 = 25;
pub const STL_CALLOUTMAJOR: u32 = 25;
pub const MATSUSHITA_CDROM2_MAJOR: u32 = 26;
pub const QIC117_TAPE_MAJOR: u32 = 27;
pub const MATSUSHITA_CDROM3_MAJOR: u32 = 27;
pub const MATSUSHITA_CDROM4_MAJOR: u32 = 28;
pub const STL_SIOMEMMAJOR: u32 = 28;
pub const ACSI_MAJOR: u32 = 28;
pub const AZTECH_CDROM_MAJOR: u32 = 29;
pub const FB_MAJOR: u32 = 29;
pub const MTD_BLOCK_MAJOR: u32 = 31;
pub const CM206_CDROM_MAJOR: u32 = 32;
pub const IDE2_MAJOR: u32 = 33;
pub const IDE3_MAJOR: u32 = 34;
pub const Z8530_MAJOR: u32 = 34;
pub const XPRAM_MAJOR: u32 = 35;
pub const NETLINK_MAJOR: u32 = 36;
pub const PS2ESDI_MAJOR: u32 = 36;
pub const IDETAPE_MAJOR: u32 = 37;
pub const Z2RAM_MAJOR: u32 = 37;
pub const APBLOCK_MAJOR: u32 = 38;
pub const DDV_MAJOR: u32 = 39;
pub const NBD_MAJOR: u32 = 43;
pub const RISCOM8_NORMAL_MAJOR: u32 = 48;
pub const DAC960_MAJOR: u32 = 48;
pub const RISCOM8_CALLOUT_MAJOR: u32 = 49;
pub const MKISS_MAJOR: u32 = 55;
pub const DSP56K_MAJOR: u32 = 55;
pub const IDE4_MAJOR: u32 = 56;
pub const IDE5_MAJOR: u32 = 57;
pub const SCSI_DISK1_MAJOR: u32 = 65;
pub const SCSI_DISK2_MAJOR: u32 = 66;
pub const SCSI_DISK3_MAJOR: u32 = 67;
pub const SCSI_DISK4_MAJOR: u32 = 68;
pub const SCSI_DISK5_MAJOR: u32 = 69;
pub const SCSI_DISK6_MAJOR: u32 = 70;
pub const SCSI_DISK7_MAJOR: u32 = 71;
pub const COMPAQ_SMART2_MAJOR: u32 = 72;
pub const COMPAQ_SMART2_MAJOR1: u32 = 73;
pub const COMPAQ_SMART2_MAJOR2: u32 = 74;
pub const COMPAQ_SMART2_MAJOR3: u32 = 75;
pub const COMPAQ_SMART2_MAJOR4: u32 = 76;
pub const COMPAQ_SMART2_MAJOR5: u32 = 77;
pub const COMPAQ_SMART2_MAJOR6: u32 = 78;
pub const COMPAQ_SMART2_MAJOR7: u32 = 79;
pub const SPECIALIX_NORMAL_MAJOR: u32 = 75;
pub const SPECIALIX_CALLOUT_MAJOR: u32 = 76;
pub const AURORA_MAJOR: u32 = 79;
pub const I2O_MAJOR: u32 = 80;
pub const SHMIQ_MAJOR: u32 = 85;
pub const SCSI_CHANGER_MAJOR: u32 = 86;
pub const IDE6_MAJOR: u32 = 88;
pub const IDE7_MAJOR: u32 = 89;
pub const IDE8_MAJOR: u32 = 90;
pub const MTD_CHAR_MAJOR: u32 = 90;
pub const IDE9_MAJOR: u32 = 91;
pub const DASD_MAJOR: u32 = 94;
pub const MDISK_MAJOR: u32 = 95;
pub const UBD_MAJOR: u32 = 98;
pub const PP_MAJOR: u32 = 99;
pub const JSFD_MAJOR: u32 = 99;
pub const PHONE_MAJOR: u32 = 100;
pub const COMPAQ_CISS_MAJOR: u32 = 104;
pub const COMPAQ_CISS_MAJOR1: u32 = 105;
pub const COMPAQ_CISS_MAJOR2: u32 = 106;
pub const COMPAQ_CISS_MAJOR3: u32 = 107;
pub const COMPAQ_CISS_MAJOR4: u32 = 108;
pub const COMPAQ_CISS_MAJOR5: u32 = 109;
pub const COMPAQ_CISS_MAJOR6: u32 = 110;
pub const COMPAQ_CISS_MAJOR7: u32 = 111;
pub const VIODASD_MAJOR: u32 = 112;
pub const VIOCD_MAJOR: u32 = 113;
pub const ATARAID_MAJOR: u32 = 114;
pub const SCSI_DISK8_MAJOR: u32 = 128;
pub const SCSI_DISK9_MAJOR: u32 = 129;
pub const SCSI_DISK10_MAJOR: u32 = 130;
pub const SCSI_DISK11_MAJOR: u32 = 131;
pub const SCSI_DISK12_MAJOR: u32 = 132;
pub const SCSI_DISK13_MAJOR: u32 = 133;
pub const SCSI_DISK14_MAJOR: u32 = 134;
pub const SCSI_DISK15_MAJOR: u32 = 135;
pub const UNIX98_PTY_MASTER_MAJOR: u32 = 128;
pub const UNIX98_PTY_MAJOR_COUNT: u32 = 8;
pub const UNIX98_PTY_SLAVE_MAJOR: u32 = 136;
pub const DRBD_MAJOR: u32 = 147;
pub const RTF_MAJOR: u32 = 150;
pub const RAW_MAJOR: u32 = 162;
pub const USB_ACM_MAJOR: u32 = 166;
pub const USB_ACM_AUX_MAJOR: u32 = 167;
pub const USB_CHAR_MAJOR: u32 = 180;
pub const MMC_BLOCK_MAJOR: u32 = 179;
pub const VXVM_MAJOR: u32 = 199;
pub const VXSPEC_MAJOR: u32 = 200;
pub const VXDMP_MAJOR: u32 = 201;
pub const XENVBD_MAJOR: u32 = 202;
pub const MSR_MAJOR: u32 = 202;
pub const CPUID_MAJOR: u32 = 203;
pub const OSST_MAJOR: u32 = 206;
pub const IBM_TTY3270_MAJOR: u32 = 227;
pub const IBM_FS3270_MAJOR: u32 = 228;
pub const VIOTAPE_MAJOR: u32 = 230;
pub const BLOCK_EXT_MAJOR: u32 = 259;
pub const SCSI_OSD_MAJOR: u32 = 260;
pub const PSMOUSE_MINOR: u32 = 1;
pub const MS_BUSMOUSE_MINOR: u32 = 2;
pub const ATIXL_BUSMOUSE_MINOR: u32 = 3;
pub const ATARIMOUSE_MINOR: u32 = 5;
pub const SUN_MOUSE_MINOR: u32 = 6;
pub const APOLLO_MOUSE_MINOR: u32 = 7;
pub const PC110PAD_MINOR: u32 = 9;
pub const WATCHDOG_MINOR: u32 = 130;
pub const TEMP_MINOR: u32 = 131;
pub const APM_MINOR_DEV: u32 = 134;
pub const RTC_MINOR: u32 = 135;
pub const VHCI_MINOR: u32 = 137;
pub const SUN_OPENPROM_MINOR: u32 = 139;
pub const DMAPI_MINOR: u32 = 140;
pub const NVRAM_MINOR: u32 = 144;
pub const SBUS_FLASH_MINOR: u32 = 152;
pub const SGI_MMTIMER: u32 = 153;
pub const PMU_MINOR: u32 = 154;
pub const STORE_QUEUE_MINOR: u32 = 155;
pub const LCD_MINOR: u32 = 156;
pub const AC_MINOR: u32 = 157;
pub const BUTTON_MINOR: u32 = 158;
pub const NWFLASH_MINOR: u32 = 160;
pub const ENVCTRL_MINOR: u32 = 162;
pub const I2O_MINOR: u32 = 166;
pub const UCTRL_MINOR: u32 = 174;
pub const AGPGART_MINOR: u32 = 175;
pub const TOSH_MINOR_DEV: u32 = 181;
pub const HWRNG_MINOR: u32 = 183;
pub const KEYPAD_MINOR: u32 = 185;
pub const IRNET_MINOR: u32 = 187;
pub const D7S_MINOR: u32 = 193;
pub const VFIO_MINOR: u32 = 196;
pub const PXA3XX_GCU_MINOR: u32 = 197;
pub const TUN_MINOR: u32 = 200;
pub const CUSE_MINOR: u32 = 203;
pub const MWAVE_MINOR: u32 = 219;
pub const MPT_MINOR: u32 = 220;
pub const MPT2SAS_MINOR: u32 = 221;
pub const MPT3SAS_MINOR: u32 = 222;
pub const UINPUT_MINOR: u32 = 223;
pub const MISC_MCELOG_MINOR: u32 = 227;
pub const HPET_MINOR: u32 = 228;
pub const FUSE_MINOR: u32 = 229;
pub const SNAPSHOT_MINOR: u32 = 231;
pub const KVM_MINOR: u32 = 232;
pub const BTRFS_MINOR: u32 = 234;
pub const AUTOFS_MINOR: u32 = 235;
pub const MAPPER_CTRL_MINOR: u32 = 236;
pub const LOOP_CTRL_MINOR: u32 = 237;
pub const VHOST_NET_MINOR: u32 = 238;
pub const UHID_MINOR: u32 = 239;
pub const USERIO_MINOR: u32 = 240;
pub const VHOST_VSOCK_MINOR: u32 = 241;
pub const RFKILL_MINOR: u32 = 242;
pub const MISC_DYNAMIC_MINOR: u32 = 255;
pub const MSI_ANY_INDEX: i32 = -1;
pub const PCI_CFG_SPACE_SIZE: u32 = 256;
pub const PCI_CFG_SPACE_EXP_SIZE: u32 = 4096;
pub const PCI_STD_HEADER_SIZEOF: u32 = 64;
pub const PCI_STD_NUM_BARS: u32 = 6;
pub const PCI_VENDOR_ID: u32 = 0;
pub const PCI_DEVICE_ID: u32 = 2;
pub const PCI_COMMAND: u32 = 4;
pub const PCI_COMMAND_IO: u32 = 1;
pub const PCI_COMMAND_MEMORY: u32 = 2;
pub const PCI_COMMAND_MASTER: u32 = 4;
pub const PCI_COMMAND_SPECIAL: u32 = 8;
pub const PCI_COMMAND_INVALIDATE: u32 = 16;
pub const PCI_COMMAND_VGA_PALETTE: u32 = 32;
pub const PCI_COMMAND_PARITY: u32 = 64;
pub const PCI_COMMAND_WAIT: u32 = 128;
pub const PCI_COMMAND_SERR: u32 = 256;
pub const PCI_COMMAND_FAST_BACK: u32 = 512;
pub const PCI_COMMAND_INTX_DISABLE: u32 = 1024;
pub const PCI_STATUS: u32 = 6;
pub const PCI_STATUS_IMM_READY: u32 = 1;
pub const PCI_STATUS_INTERRUPT: u32 = 8;
pub const PCI_STATUS_CAP_LIST: u32 = 16;
pub const PCI_STATUS_66MHZ: u32 = 32;
pub const PCI_STATUS_UDF: u32 = 64;
pub const PCI_STATUS_FAST_BACK: u32 = 128;
pub const PCI_STATUS_PARITY: u32 = 256;
pub const PCI_STATUS_DEVSEL_MASK: u32 = 1536;
pub const PCI_STATUS_DEVSEL_FAST: u32 = 0;
pub const PCI_STATUS_DEVSEL_MEDIUM: u32 = 512;
pub const PCI_STATUS_DEVSEL_SLOW: u32 = 1024;
pub const PCI_STATUS_SIG_TARGET_ABORT: u32 = 2048;
pub const PCI_STATUS_REC_TARGET_ABORT: u32 = 4096;
pub const PCI_STATUS_REC_MASTER_ABORT: u32 = 8192;
pub const PCI_STATUS_SIG_SYSTEM_ERROR: u32 = 16384;
pub const PCI_STATUS_DETECTED_PARITY: u32 = 32768;
pub const PCI_CLASS_REVISION: u32 = 8;
pub const PCI_REVISION_ID: u32 = 8;
pub const PCI_CLASS_PROG: u32 = 9;
pub const PCI_CLASS_DEVICE: u32 = 10;
pub const PCI_CACHE_LINE_SIZE: u32 = 12;
pub const PCI_LATENCY_TIMER: u32 = 13;
pub const PCI_HEADER_TYPE: u32 = 14;
pub const PCI_HEADER_TYPE_MASK: u32 = 127;
pub const PCI_HEADER_TYPE_NORMAL: u32 = 0;
pub const PCI_HEADER_TYPE_BRIDGE: u32 = 1;
pub const PCI_HEADER_TYPE_CARDBUS: u32 = 2;
pub const PCI_HEADER_TYPE_MFD: u32 = 128;
pub const PCI_BIST: u32 = 15;
pub const PCI_BIST_CODE_MASK: u32 = 15;
pub const PCI_BIST_START: u32 = 64;
pub const PCI_BIST_CAPABLE: u32 = 128;
pub const PCI_BASE_ADDRESS_0: u32 = 16;
pub const PCI_BASE_ADDRESS_1: u32 = 20;
pub const PCI_BASE_ADDRESS_2: u32 = 24;
pub const PCI_BASE_ADDRESS_3: u32 = 28;
pub const PCI_BASE_ADDRESS_4: u32 = 32;
pub const PCI_BASE_ADDRESS_5: u32 = 36;
pub const PCI_BASE_ADDRESS_SPACE: u32 = 1;
pub const PCI_BASE_ADDRESS_SPACE_IO: u32 = 1;
pub const PCI_BASE_ADDRESS_SPACE_MEMORY: u32 = 0;
pub const PCI_BASE_ADDRESS_MEM_TYPE_MASK: u32 = 6;
pub const PCI_BASE_ADDRESS_MEM_TYPE_32: u32 = 0;
pub const PCI_BASE_ADDRESS_MEM_TYPE_1M: u32 = 2;
pub const PCI_BASE_ADDRESS_MEM_TYPE_64: u32 = 4;
pub const PCI_BASE_ADDRESS_MEM_PREFETCH: u32 = 8;
pub const PCI_BASE_ADDRESS_MEM_MASK: i32 = -16;
pub const PCI_BASE_ADDRESS_IO_MASK: i32 = -4;
pub const PCI_CARDBUS_CIS: u32 = 40;
pub const PCI_SUBSYSTEM_VENDOR_ID: u32 = 44;
pub const PCI_SUBSYSTEM_ID: u32 = 46;
pub const PCI_ROM_ADDRESS: u32 = 48;
pub const PCI_ROM_ADDRESS_ENABLE: u32 = 1;
pub const PCI_ROM_ADDRESS_MASK: i32 = -2048;
pub const PCI_CAPABILITY_LIST: u32 = 52;
pub const PCI_INTERRUPT_LINE: u32 = 60;
pub const PCI_INTERRUPT_PIN: u32 = 61;
pub const PCI_MIN_GNT: u32 = 62;
pub const PCI_MAX_LAT: u32 = 63;
pub const PCI_PRIMARY_BUS: u32 = 24;
pub const PCI_SECONDARY_BUS: u32 = 25;
pub const PCI_SUBORDINATE_BUS: u32 = 26;
pub const PCI_SEC_LATENCY_TIMER: u32 = 27;
pub const PCI_IO_BASE: u32 = 28;
pub const PCI_IO_LIMIT: u32 = 29;
pub const PCI_IO_RANGE_TYPE_MASK: u32 = 15;
pub const PCI_IO_RANGE_TYPE_16: u32 = 0;
pub const PCI_IO_RANGE_TYPE_32: u32 = 1;
pub const PCI_IO_RANGE_MASK: i32 = -16;
pub const PCI_IO_1K_RANGE_MASK: i32 = -4;
pub const PCI_SEC_STATUS: u32 = 30;
pub const PCI_MEMORY_BASE: u32 = 32;
pub const PCI_MEMORY_LIMIT: u32 = 34;
pub const PCI_MEMORY_RANGE_TYPE_MASK: u32 = 15;
pub const PCI_MEMORY_RANGE_MASK: i32 = -16;
pub const PCI_PREF_MEMORY_BASE: u32 = 36;
pub const PCI_PREF_MEMORY_LIMIT: u32 = 38;
pub const PCI_PREF_RANGE_TYPE_MASK: u32 = 15;
pub const PCI_PREF_RANGE_TYPE_32: u32 = 0;
pub const PCI_PREF_RANGE_TYPE_64: u32 = 1;
pub const PCI_PREF_RANGE_MASK: i32 = -16;
pub const PCI_PREF_BASE_UPPER32: u32 = 40;
pub const PCI_PREF_LIMIT_UPPER32: u32 = 44;
pub const PCI_IO_BASE_UPPER16: u32 = 48;
pub const PCI_IO_LIMIT_UPPER16: u32 = 50;
pub const PCI_ROM_ADDRESS1: u32 = 56;
pub const PCI_BRIDGE_CONTROL: u32 = 62;
pub const PCI_BRIDGE_CTL_PARITY: u32 = 1;
pub const PCI_BRIDGE_CTL_SERR: u32 = 2;
pub const PCI_BRIDGE_CTL_ISA: u32 = 4;
pub const PCI_BRIDGE_CTL_VGA: u32 = 8;
pub const PCI_BRIDGE_CTL_MASTER_ABORT: u32 = 32;
pub const PCI_BRIDGE_CTL_BUS_RESET: u32 = 64;
pub const PCI_BRIDGE_CTL_FAST_BACK: u32 = 128;
pub const PCI_CB_CAPABILITY_LIST: u32 = 20;
pub const PCI_CB_SEC_STATUS: u32 = 22;
pub const PCI_CB_PRIMARY_BUS: u32 = 24;
pub const PCI_CB_CARD_BUS: u32 = 25;
pub const PCI_CB_SUBORDINATE_BUS: u32 = 26;
pub const PCI_CB_LATENCY_TIMER: u32 = 27;
pub const PCI_CB_MEMORY_BASE_0: u32 = 28;
pub const PCI_CB_MEMORY_LIMIT_0: u32 = 32;
pub const PCI_CB_MEMORY_BASE_1: u32 = 36;
pub const PCI_CB_MEMORY_LIMIT_1: u32 = 40;
pub const PCI_CB_IO_BASE_0: u32 = 44;
pub const PCI_CB_IO_BASE_0_HI: u32 = 46;
pub const PCI_CB_IO_LIMIT_0: u32 = 48;
pub const PCI_CB_IO_LIMIT_0_HI: u32 = 50;
pub const PCI_CB_IO_BASE_1: u32 = 52;
pub const PCI_CB_IO_BASE_1_HI: u32 = 54;
pub const PCI_CB_IO_LIMIT_1: u32 = 56;
pub const PCI_CB_IO_LIMIT_1_HI: u32 = 58;
pub const PCI_CB_IO_RANGE_MASK: i32 = -4;
pub const PCI_CB_BRIDGE_CONTROL: u32 = 62;
pub const PCI_CB_BRIDGE_CTL_PARITY: u32 = 1;
pub const PCI_CB_BRIDGE_CTL_SERR: u32 = 2;
pub const PCI_CB_BRIDGE_CTL_ISA: u32 = 4;
pub const PCI_CB_BRIDGE_CTL_VGA: u32 = 8;
pub const PCI_CB_BRIDGE_CTL_MASTER_ABORT: u32 = 32;
pub const PCI_CB_BRIDGE_CTL_CB_RESET: u32 = 64;
pub const PCI_CB_BRIDGE_CTL_16BIT_INT: u32 = 128;
pub const PCI_CB_BRIDGE_CTL_PREFETCH_MEM0: u32 = 256;
pub const PCI_CB_BRIDGE_CTL_PREFETCH_MEM1: u32 = 512;
pub const PCI_CB_BRIDGE_CTL_POST_WRITES: u32 = 1024;
pub const PCI_CB_SUBSYSTEM_VENDOR_ID: u32 = 64;
pub const PCI_CB_SUBSYSTEM_ID: u32 = 66;
pub const PCI_CB_LEGACY_MODE_BASE: u32 = 68;
pub const PCI_CAP_LIST_ID: u32 = 0;
pub const PCI_CAP_ID_PM: u32 = 1;
pub const PCI_CAP_ID_AGP: u32 = 2;
pub const PCI_CAP_ID_VPD: u32 = 3;
pub const PCI_CAP_ID_SLOTID: u32 = 4;
pub const PCI_CAP_ID_MSI: u32 = 5;
pub const PCI_CAP_ID_CHSWP: u32 = 6;
pub const PCI_CAP_ID_PCIX: u32 = 7;
pub const PCI_CAP_ID_HT: u32 = 8;
pub const PCI_CAP_ID_VNDR: u32 = 9;
pub const PCI_CAP_ID_DBG: u32 = 10;
pub const PCI_CAP_ID_CCRC: u32 = 11;
pub const PCI_CAP_ID_SHPC: u32 = 12;
pub const PCI_CAP_ID_SSVID: u32 = 13;
pub const PCI_CAP_ID_AGP3: u32 = 14;
pub const PCI_CAP_ID_SECDEV: u32 = 15;
pub const PCI_CAP_ID_EXP: u32 = 16;
pub const PCI_CAP_ID_MSIX: u32 = 17;
pub const PCI_CAP_ID_SATA: u32 = 18;
pub const PCI_CAP_ID_AF: u32 = 19;
pub const PCI_CAP_ID_EA: u32 = 20;
pub const PCI_CAP_ID_MAX: u32 = 20;
pub const PCI_CAP_LIST_NEXT: u32 = 1;
pub const PCI_CAP_FLAGS: u32 = 2;
pub const PCI_CAP_SIZEOF: u32 = 4;
pub const PCI_PM_PMC: u32 = 2;
pub const PCI_PM_CAP_VER_MASK: u32 = 7;
pub const PCI_PM_CAP_PME_CLOCK: u32 = 8;
pub const PCI_PM_CAP_RESERVED: u32 = 16;
pub const PCI_PM_CAP_DSI: u32 = 32;
pub const PCI_PM_CAP_AUX_POWER: u32 = 448;
pub const PCI_PM_CAP_D1: u32 = 512;
pub const PCI_PM_CAP_D2: u32 = 1024;
pub const PCI_PM_CAP_PME: u32 = 2048;
pub const PCI_PM_CAP_PME_MASK: u32 = 63488;
pub const PCI_PM_CAP_PME_D0: u32 = 2048;
pub const PCI_PM_CAP_PME_D1: u32 = 4096;
pub const PCI_PM_CAP_PME_D2: u32 = 8192;
pub const PCI_PM_CAP_PME_D3hot: u32 = 16384;
pub const PCI_PM_CAP_PME_D3cold: u32 = 32768;
pub const PCI_PM_CAP_PME_SHIFT: u32 = 11;
pub const PCI_PM_CTRL: u32 = 4;
pub const PCI_PM_CTRL_STATE_MASK: u32 = 3;
pub const PCI_PM_CTRL_NO_SOFT_RESET: u32 = 8;
pub const PCI_PM_CTRL_PME_ENABLE: u32 = 256;
pub const PCI_PM_CTRL_DATA_SEL_MASK: u32 = 7680;
pub const PCI_PM_CTRL_DATA_SCALE_MASK: u32 = 24576;
pub const PCI_PM_CTRL_PME_STATUS: u32 = 32768;
pub const PCI_PM_PPB_EXTENSIONS: u32 = 6;
pub const PCI_PM_PPB_B2_B3: u32 = 64;
pub const PCI_PM_BPCC_ENABLE: u32 = 128;
pub const PCI_PM_DATA_REGISTER: u32 = 7;
pub const PCI_PM_SIZEOF: u32 = 8;
pub const PCI_AGP_VERSION: u32 = 2;
pub const PCI_AGP_RFU: u32 = 3;
pub const PCI_AGP_STATUS: u32 = 4;
pub const PCI_AGP_STATUS_RQ_MASK: u32 = 4278190080;
pub const PCI_AGP_STATUS_SBA: u32 = 512;
pub const PCI_AGP_STATUS_64BIT: u32 = 32;
pub const PCI_AGP_STATUS_FW: u32 = 16;
pub const PCI_AGP_STATUS_RATE4: u32 = 4;
pub const PCI_AGP_STATUS_RATE2: u32 = 2;
pub const PCI_AGP_STATUS_RATE1: u32 = 1;
pub const PCI_AGP_COMMAND: u32 = 8;
pub const PCI_AGP_COMMAND_RQ_MASK: u32 = 4278190080;
pub const PCI_AGP_COMMAND_SBA: u32 = 512;
pub const PCI_AGP_COMMAND_AGP: u32 = 256;
pub const PCI_AGP_COMMAND_64BIT: u32 = 32;
pub const PCI_AGP_COMMAND_FW: u32 = 16;
pub const PCI_AGP_COMMAND_RATE4: u32 = 4;
pub const PCI_AGP_COMMAND_RATE2: u32 = 2;
pub const PCI_AGP_COMMAND_RATE1: u32 = 1;
pub const PCI_AGP_SIZEOF: u32 = 12;
pub const PCI_VPD_ADDR: u32 = 2;
pub const PCI_VPD_ADDR_MASK: u32 = 32767;
pub const PCI_VPD_ADDR_F: u32 = 32768;
pub const PCI_VPD_DATA: u32 = 4;
pub const PCI_CAP_VPD_SIZEOF: u32 = 8;
pub const PCI_SID_ESR: u32 = 2;
pub const PCI_SID_ESR_NSLOTS: u32 = 31;
pub const PCI_SID_ESR_FIC: u32 = 32;
pub const PCI_SID_CHASSIS_NR: u32 = 3;
pub const PCI_MSI_FLAGS: u32 = 2;
pub const PCI_MSI_FLAGS_ENABLE: u32 = 1;
pub const PCI_MSI_FLAGS_QMASK: u32 = 14;
pub const PCI_MSI_FLAGS_QSIZE: u32 = 112;
pub const PCI_MSI_FLAGS_64BIT: u32 = 128;
pub const PCI_MSI_FLAGS_MASKBIT: u32 = 256;
pub const PCI_MSI_RFU: u32 = 3;
pub const PCI_MSI_ADDRESS_LO: u32 = 4;
pub const PCI_MSI_ADDRESS_HI: u32 = 8;
pub const PCI_MSI_DATA_32: u32 = 8;
pub const PCI_MSI_MASK_32: u32 = 12;
pub const PCI_MSI_PENDING_32: u32 = 16;
pub const PCI_MSI_DATA_64: u32 = 12;
pub const PCI_MSI_MASK_64: u32 = 16;
pub const PCI_MSI_PENDING_64: u32 = 20;
pub const PCI_MSIX_FLAGS: u32 = 2;
pub const PCI_MSIX_FLAGS_QSIZE: u32 = 2047;
pub const PCI_MSIX_FLAGS_MASKALL: u32 = 16384;
pub const PCI_MSIX_FLAGS_ENABLE: u32 = 32768;
pub const PCI_MSIX_TABLE: u32 = 4;
pub const PCI_MSIX_TABLE_BIR: u32 = 7;
pub const PCI_MSIX_TABLE_OFFSET: u32 = 4294967288;
pub const PCI_MSIX_PBA: u32 = 8;
pub const PCI_MSIX_PBA_BIR: u32 = 7;
pub const PCI_MSIX_PBA_OFFSET: u32 = 4294967288;
pub const PCI_MSIX_FLAGS_BIRMASK: u32 = 7;
pub const PCI_CAP_MSIX_SIZEOF: u32 = 12;
pub const PCI_MSIX_ENTRY_SIZE: u32 = 16;
pub const PCI_MSIX_ENTRY_LOWER_ADDR: u32 = 0;
pub const PCI_MSIX_ENTRY_UPPER_ADDR: u32 = 4;
pub const PCI_MSIX_ENTRY_DATA: u32 = 8;
pub const PCI_MSIX_ENTRY_VECTOR_CTRL: u32 = 12;
pub const PCI_MSIX_ENTRY_CTRL_MASKBIT: u32 = 1;
pub const PCI_MSIX_ENTRY_CTRL_ST: u32 = 4294901760;
pub const PCI_CHSWP_CSR: u32 = 2;
pub const PCI_CHSWP_DHA: u32 = 1;
pub const PCI_CHSWP_EIM: u32 = 2;
pub const PCI_CHSWP_PIE: u32 = 4;
pub const PCI_CHSWP_LOO: u32 = 8;
pub const PCI_CHSWP_PI: u32 = 48;
pub const PCI_CHSWP_EXT: u32 = 64;
pub const PCI_CHSWP_INS: u32 = 128;
pub const PCI_AF_LENGTH: u32 = 2;
pub const PCI_AF_CAP: u32 = 3;
pub const PCI_AF_CAP_TP: u32 = 1;
pub const PCI_AF_CAP_FLR: u32 = 2;
pub const PCI_AF_CTRL: u32 = 4;
pub const PCI_AF_CTRL_FLR: u32 = 1;
pub const PCI_AF_STATUS: u32 = 5;
pub const PCI_AF_STATUS_TP: u32 = 1;
pub const PCI_CAP_AF_SIZEOF: u32 = 6;
pub const PCI_EA_NUM_ENT: u32 = 2;
pub const PCI_EA_NUM_ENT_MASK: u32 = 63;
pub const PCI_EA_FIRST_ENT: u32 = 4;
pub const PCI_EA_FIRST_ENT_BRIDGE: u32 = 8;
pub const PCI_EA_ES: u32 = 7;
pub const PCI_EA_BEI: u32 = 240;
pub const PCI_EA_SEC_BUS_MASK: u32 = 255;
pub const PCI_EA_SUB_BUS_MASK: u32 = 65280;
pub const PCI_EA_SUB_BUS_SHIFT: u32 = 8;
pub const PCI_EA_BEI_BAR0: u32 = 0;
pub const PCI_EA_BEI_BAR5: u32 = 5;
pub const PCI_EA_BEI_BRIDGE: u32 = 6;
pub const PCI_EA_BEI_ENI: u32 = 7;
pub const PCI_EA_BEI_ROM: u32 = 8;
pub const PCI_EA_BEI_VF_BAR0: u32 = 9;
pub const PCI_EA_BEI_VF_BAR5: u32 = 14;
pub const PCI_EA_BEI_RESERVED: u32 = 15;
pub const PCI_EA_PP: u32 = 65280;
pub const PCI_EA_SP: u32 = 16711680;
pub const PCI_EA_P_MEM: u32 = 0;
pub const PCI_EA_P_MEM_PREFETCH: u32 = 1;
pub const PCI_EA_P_IO: u32 = 2;
pub const PCI_EA_P_VF_MEM_PREFETCH: u32 = 3;
pub const PCI_EA_P_VF_MEM: u32 = 4;
pub const PCI_EA_P_BRIDGE_MEM: u32 = 5;
pub const PCI_EA_P_BRIDGE_MEM_PREFETCH: u32 = 6;
pub const PCI_EA_P_BRIDGE_IO: u32 = 7;
pub const PCI_EA_P_MEM_RESERVED: u32 = 253;
pub const PCI_EA_P_IO_RESERVED: u32 = 254;
pub const PCI_EA_P_UNAVAILABLE: u32 = 255;
pub const PCI_EA_WRITABLE: u32 = 1073741824;
pub const PCI_EA_ENABLE: u32 = 2147483648;
pub const PCI_EA_BASE: u32 = 4;
pub const PCI_EA_MAX_OFFSET: u32 = 8;
pub const PCI_EA_IS_64: u32 = 2;
pub const PCI_EA_FIELD_MASK: u32 = 4294967292;
pub const PCI_X_CMD: u32 = 2;
pub const PCI_X_CMD_DPERR_E: u32 = 1;
pub const PCI_X_CMD_ERO: u32 = 2;
pub const PCI_X_CMD_READ_512: u32 = 0;
pub const PCI_X_CMD_READ_1K: u32 = 4;
pub const PCI_X_CMD_READ_2K: u32 = 8;
pub const PCI_X_CMD_READ_4K: u32 = 12;
pub const PCI_X_CMD_MAX_READ: u32 = 12;
pub const PCI_X_CMD_SPLIT_1: u32 = 0;
pub const PCI_X_CMD_SPLIT_2: u32 = 16;
pub const PCI_X_CMD_SPLIT_3: u32 = 32;
pub const PCI_X_CMD_SPLIT_4: u32 = 48;
pub const PCI_X_CMD_SPLIT_8: u32 = 64;
pub const PCI_X_CMD_SPLIT_12: u32 = 80;
pub const PCI_X_CMD_SPLIT_16: u32 = 96;
pub const PCI_X_CMD_SPLIT_32: u32 = 112;
pub const PCI_X_CMD_MAX_SPLIT: u32 = 112;
pub const PCI_X_STATUS: u32 = 4;
pub const PCI_X_STATUS_DEVFN: u32 = 255;
pub const PCI_X_STATUS_BUS: u32 = 65280;
pub const PCI_X_STATUS_64BIT: u32 = 65536;
pub const PCI_X_STATUS_133MHZ: u32 = 131072;
pub const PCI_X_STATUS_SPL_DISC: u32 = 262144;
pub const PCI_X_STATUS_UNX_SPL: u32 = 524288;
pub const PCI_X_STATUS_COMPLEX: u32 = 1048576;
pub const PCI_X_STATUS_MAX_READ: u32 = 6291456;
pub const PCI_X_STATUS_MAX_SPLIT: u32 = 58720256;
pub const PCI_X_STATUS_MAX_CUM: u32 = 469762048;
pub const PCI_X_STATUS_SPL_ERR: u32 = 536870912;
pub const PCI_X_STATUS_266MHZ: u32 = 1073741824;
pub const PCI_X_STATUS_533MHZ: u32 = 2147483648;
pub const PCI_X_ECC_CSR: u32 = 8;
pub const PCI_CAP_PCIX_SIZEOF_V0: u32 = 8;
pub const PCI_CAP_PCIX_SIZEOF_V1: u32 = 24;
pub const PCI_CAP_PCIX_SIZEOF_V2: u32 = 24;
pub const PCI_X_BRIDGE_SSTATUS: u32 = 2;
pub const PCI_X_SSTATUS_64BIT: u32 = 1;
pub const PCI_X_SSTATUS_133MHZ: u32 = 2;
pub const PCI_X_SSTATUS_FREQ: u32 = 960;
pub const PCI_X_SSTATUS_VERS: u32 = 12288;
pub const PCI_X_SSTATUS_V1: u32 = 4096;
pub const PCI_X_SSTATUS_V2: u32 = 8192;
pub const PCI_X_SSTATUS_266MHZ: u32 = 16384;
pub const PCI_X_SSTATUS_533MHZ: u32 = 32768;
pub const PCI_X_BRIDGE_STATUS: u32 = 4;
pub const PCI_SSVID_VENDOR_ID: u32 = 4;
pub const PCI_SSVID_DEVICE_ID: u32 = 6;
pub const PCI_EXP_FLAGS: u32 = 2;
pub const PCI_EXP_FLAGS_VERS: u32 = 15;
pub const PCI_EXP_FLAGS_TYPE: u32 = 240;
pub const PCI_EXP_TYPE_ENDPOINT: u32 = 0;
pub const PCI_EXP_TYPE_LEG_END: u32 = 1;
pub const PCI_EXP_TYPE_ROOT_PORT: u32 = 4;
pub const PCI_EXP_TYPE_UPSTREAM: u32 = 5;
pub const PCI_EXP_TYPE_DOWNSTREAM: u32 = 6;
pub const PCI_EXP_TYPE_PCI_BRIDGE: u32 = 7;
pub const PCI_EXP_TYPE_PCIE_BRIDGE: u32 = 8;
pub const PCI_EXP_TYPE_RC_END: u32 = 9;
pub const PCI_EXP_TYPE_RC_EC: u32 = 10;
pub const PCI_EXP_FLAGS_SLOT: u32 = 256;
pub const PCI_EXP_FLAGS_IRQ: u32 = 15872;
pub const PCI_EXP_FLAGS_FLIT: u32 = 32768;
pub const PCI_EXP_DEVCAP: u32 = 4;
pub const PCI_EXP_DEVCAP_PAYLOAD: u32 = 7;
pub const PCI_EXP_DEVCAP_PHANTOM: u32 = 24;
pub const PCI_EXP_DEVCAP_EXT_TAG: u32 = 32;
pub const PCI_EXP_DEVCAP_L0S: u32 = 448;
pub const PCI_EXP_DEVCAP_L1: u32 = 3584;
pub const PCI_EXP_DEVCAP_ATN_BUT: u32 = 4096;
pub const PCI_EXP_DEVCAP_ATN_IND: u32 = 8192;
pub const PCI_EXP_DEVCAP_PWR_IND: u32 = 16384;
pub const PCI_EXP_DEVCAP_RBER: u32 = 32768;
pub const PCI_EXP_DEVCAP_PWR_VAL: u32 = 66846720;
pub const PCI_EXP_DEVCAP_PWR_SCL: u32 = 201326592;
pub const PCI_EXP_DEVCAP_FLR: u32 = 268435456;
pub const PCI_EXP_DEVCTL: u32 = 8;
pub const PCI_EXP_DEVCTL_CERE: u32 = 1;
pub const PCI_EXP_DEVCTL_NFERE: u32 = 2;
pub const PCI_EXP_DEVCTL_FERE: u32 = 4;
pub const PCI_EXP_DEVCTL_URRE: u32 = 8;
pub const PCI_EXP_DEVCTL_RELAX_EN: u32 = 16;
pub const PCI_EXP_DEVCTL_PAYLOAD: u32 = 224;
pub const PCI_EXP_DEVCTL_PAYLOAD_128B: u32 = 0;
pub const PCI_EXP_DEVCTL_PAYLOAD_256B: u32 = 32;
pub const PCI_EXP_DEVCTL_PAYLOAD_512B: u32 = 64;
pub const PCI_EXP_DEVCTL_PAYLOAD_1024B: u32 = 96;
pub const PCI_EXP_DEVCTL_PAYLOAD_2048B: u32 = 128;
pub const PCI_EXP_DEVCTL_PAYLOAD_4096B: u32 = 160;
pub const PCI_EXP_DEVCTL_EXT_TAG: u32 = 256;
pub const PCI_EXP_DEVCTL_PHANTOM: u32 = 512;
pub const PCI_EXP_DEVCTL_AUX_PME: u32 = 1024;
pub const PCI_EXP_DEVCTL_NOSNOOP_EN: u32 = 2048;
pub const PCI_EXP_DEVCTL_READRQ: u32 = 28672;
pub const PCI_EXP_DEVCTL_READRQ_128B: u32 = 0;
pub const PCI_EXP_DEVCTL_READRQ_256B: u32 = 4096;
pub const PCI_EXP_DEVCTL_READRQ_512B: u32 = 8192;
pub const PCI_EXP_DEVCTL_READRQ_1024B: u32 = 12288;
pub const PCI_EXP_DEVCTL_READRQ_2048B: u32 = 16384;
pub const PCI_EXP_DEVCTL_READRQ_4096B: u32 = 20480;
pub const PCI_EXP_DEVCTL_BCR_FLR: u32 = 32768;
pub const PCI_EXP_DEVSTA: u32 = 10;
pub const PCI_EXP_DEVSTA_CED: u32 = 1;
pub const PCI_EXP_DEVSTA_NFED: u32 = 2;
pub const PCI_EXP_DEVSTA_FED: u32 = 4;
pub const PCI_EXP_DEVSTA_URD: u32 = 8;
pub const PCI_EXP_DEVSTA_AUXPD: u32 = 16;
pub const PCI_EXP_DEVSTA_TRPND: u32 = 32;
pub const PCI_CAP_EXP_RC_ENDPOINT_SIZEOF_V1: u32 = 12;
pub const PCI_EXP_LNKCAP: u32 = 12;
pub const PCI_EXP_LNKCAP_SLS: u32 = 15;
pub const PCI_EXP_LNKCAP_SLS_2_5GB: u32 = 1;
pub const PCI_EXP_LNKCAP_SLS_5_0GB: u32 = 2;
pub const PCI_EXP_LNKCAP_SLS_8_0GB: u32 = 3;
pub const PCI_EXP_LNKCAP_SLS_16_0GB: u32 = 4;
pub const PCI_EXP_LNKCAP_SLS_32_0GB: u32 = 5;
pub const PCI_EXP_LNKCAP_SLS_64_0GB: u32 = 6;
pub const PCI_EXP_LNKCAP_MLW: u32 = 1008;
pub const PCI_EXP_LNKCAP_ASPMS: u32 = 3072;
pub const PCI_EXP_LNKCAP_ASPM_L0S: u32 = 1024;
pub const PCI_EXP_LNKCAP_ASPM_L1: u32 = 2048;
pub const PCI_EXP_LNKCAP_L0SEL: u32 = 28672;
pub const PCI_EXP_LNKCAP_L1EL: u32 = 229376;
pub const PCI_EXP_LNKCAP_CLKPM: u32 = 262144;
pub const PCI_EXP_LNKCAP_SDERC: u32 = 524288;
pub const PCI_EXP_LNKCAP_DLLLARC: u32 = 1048576;
pub const PCI_EXP_LNKCAP_LBNC: u32 = 2097152;
pub const PCI_EXP_LNKCAP_PN: u32 = 4278190080;
pub const PCI_EXP_LNKCTL: u32 = 16;
pub const PCI_EXP_LNKCTL_ASPMC: u32 = 3;
pub const PCI_EXP_LNKCTL_ASPM_L0S: u32 = 1;
pub const PCI_EXP_LNKCTL_ASPM_L1: u32 = 2;
pub const PCI_EXP_LNKCTL_RCB: u32 = 8;
pub const PCI_EXP_LNKCTL_LD: u32 = 16;
pub const PCI_EXP_LNKCTL_RL: u32 = 32;
pub const PCI_EXP_LNKCTL_CCC: u32 = 64;
pub const PCI_EXP_LNKCTL_ES: u32 = 128;
pub const PCI_EXP_LNKCTL_CLKREQ_EN: u32 = 256;
pub const PCI_EXP_LNKCTL_HAWD: u32 = 512;
pub const PCI_EXP_LNKCTL_LBMIE: u32 = 1024;
pub const PCI_EXP_LNKCTL_LABIE: u32 = 2048;
pub const PCI_EXP_LNKSTA: u32 = 18;
pub const PCI_EXP_LNKSTA_CLS: u32 = 15;
pub const PCI_EXP_LNKSTA_CLS_2_5GB: u32 = 1;
pub const PCI_EXP_LNKSTA_CLS_5_0GB: u32 = 2;
pub const PCI_EXP_LNKSTA_CLS_8_0GB: u32 = 3;
pub const PCI_EXP_LNKSTA_CLS_16_0GB: u32 = 4;
pub const PCI_EXP_LNKSTA_CLS_32_0GB: u32 = 5;
pub const PCI_EXP_LNKSTA_CLS_64_0GB: u32 = 6;
pub const PCI_EXP_LNKSTA_NLW: u32 = 1008;
pub const PCI_EXP_LNKSTA_NLW_X1: u32 = 16;
pub const PCI_EXP_LNKSTA_NLW_X2: u32 = 32;
pub const PCI_EXP_LNKSTA_NLW_X4: u32 = 64;
pub const PCI_EXP_LNKSTA_NLW_X8: u32 = 128;
pub const PCI_EXP_LNKSTA_NLW_SHIFT: u32 = 4;
pub const PCI_EXP_LNKSTA_LT: u32 = 2048;
pub const PCI_EXP_LNKSTA_SLC: u32 = 4096;
pub const PCI_EXP_LNKSTA_DLLLA: u32 = 8192;
pub const PCI_EXP_LNKSTA_LBMS: u32 = 16384;
pub const PCI_EXP_LNKSTA_LABS: u32 = 32768;
pub const PCI_CAP_EXP_ENDPOINT_SIZEOF_V1: u32 = 20;
pub const PCI_EXP_SLTCAP: u32 = 20;
pub const PCI_EXP_SLTCAP_ABP: u32 = 1;
pub const PCI_EXP_SLTCAP_PCP: u32 = 2;
pub const PCI_EXP_SLTCAP_MRLSP: u32 = 4;
pub const PCI_EXP_SLTCAP_AIP: u32 = 8;
pub const PCI_EXP_SLTCAP_PIP: u32 = 16;
pub const PCI_EXP_SLTCAP_HPS: u32 = 32;
pub const PCI_EXP_SLTCAP_HPC: u32 = 64;
pub const PCI_EXP_SLTCAP_SPLV: u32 = 32640;
pub const PCI_EXP_SLTCAP_SPLS: u32 = 98304;
pub const PCI_EXP_SLTCAP_EIP: u32 = 131072;
pub const PCI_EXP_SLTCAP_NCCS: u32 = 262144;
pub const PCI_EXP_SLTCAP_PSN: u32 = 4294443008;
pub const PCI_EXP_SLTCTL: u32 = 24;
pub const PCI_EXP_SLTCTL_ABPE: u32 = 1;
pub const PCI_EXP_SLTCTL_PFDE: u32 = 2;
pub const PCI_EXP_SLTCTL_MRLSCE: u32 = 4;
pub const PCI_EXP_SLTCTL_PDCE: u32 = 8;
pub const PCI_EXP_SLTCTL_CCIE: u32 = 16;
pub const PCI_EXP_SLTCTL_HPIE: u32 = 32;
pub const PCI_EXP_SLTCTL_AIC: u32 = 192;
pub const PCI_EXP_SLTCTL_ATTN_IND_SHIFT: u32 = 6;
pub const PCI_EXP_SLTCTL_ATTN_IND_ON: u32 = 64;
pub const PCI_EXP_SLTCTL_ATTN_IND_BLINK: u32 = 128;
pub const PCI_EXP_SLTCTL_ATTN_IND_OFF: u32 = 192;
pub const PCI_EXP_SLTCTL_PIC: u32 = 768;
pub const PCI_EXP_SLTCTL_PWR_IND_ON: u32 = 256;
pub const PCI_EXP_SLTCTL_PWR_IND_BLINK: u32 = 512;
pub const PCI_EXP_SLTCTL_PWR_IND_OFF: u32 = 768;
pub const PCI_EXP_SLTCTL_PCC: u32 = 1024;
pub const PCI_EXP_SLTCTL_PWR_ON: u32 = 0;
pub const PCI_EXP_SLTCTL_PWR_OFF: u32 = 1024;
pub const PCI_EXP_SLTCTL_EIC: u32 = 2048;
pub const PCI_EXP_SLTCTL_DLLSCE: u32 = 4096;
pub const PCI_EXP_SLTCTL_ASPL_DISABLE: u32 = 8192;
pub const PCI_EXP_SLTCTL_IBPD_DISABLE: u32 = 16384;
pub const PCI_EXP_SLTSTA: u32 = 26;
pub const PCI_EXP_SLTSTA_ABP: u32 = 1;
pub const PCI_EXP_SLTSTA_PFD: u32 = 2;
pub const PCI_EXP_SLTSTA_MRLSC: u32 = 4;
pub const PCI_EXP_SLTSTA_PDC: u32 = 8;
pub const PCI_EXP_SLTSTA_CC: u32 = 16;
pub const PCI_EXP_SLTSTA_MRLSS: u32 = 32;
pub const PCI_EXP_SLTSTA_PDS: u32 = 64;
pub const PCI_EXP_SLTSTA_EIS: u32 = 128;
pub const PCI_EXP_SLTSTA_DLLSC: u32 = 256;
pub const PCI_EXP_RTCTL: u32 = 28;
pub const PCI_EXP_RTCTL_SECEE: u32 = 1;
pub const PCI_EXP_RTCTL_SENFEE: u32 = 2;
pub const PCI_EXP_RTCTL_SEFEE: u32 = 4;
pub const PCI_EXP_RTCTL_PMEIE: u32 = 8;
pub const PCI_EXP_RTCTL_RRS_SVE: u32 = 16;
pub const PCI_EXP_RTCTL_CRSSVE: u32 = 16;
pub const PCI_EXP_RTCAP: u32 = 30;
pub const PCI_EXP_RTCAP_RRS_SV: u32 = 1;
pub const PCI_EXP_RTCAP_CRSVIS: u32 = 1;
pub const PCI_EXP_RTSTA: u32 = 32;
pub const PCI_EXP_RTSTA_PME_RQ_ID: u32 = 65535;
pub const PCI_EXP_RTSTA_PME: u32 = 65536;
pub const PCI_EXP_RTSTA_PENDING: u32 = 131072;
pub const PCI_EXP_DEVCAP2: u32 = 36;
pub const PCI_EXP_DEVCAP2_COMP_TMOUT_DIS: u32 = 16;
pub const PCI_EXP_DEVCAP2_ARI: u32 = 32;
pub const PCI_EXP_DEVCAP2_ATOMIC_ROUTE: u32 = 64;
pub const PCI_EXP_DEVCAP2_ATOMIC_COMP32: u32 = 128;
pub const PCI_EXP_DEVCAP2_ATOMIC_COMP64: u32 = 256;
pub const PCI_EXP_DEVCAP2_ATOMIC_COMP128: u32 = 512;
pub const PCI_EXP_DEVCAP2_LTR: u32 = 2048;
pub const PCI_EXP_DEVCAP2_TPH_COMP_MASK: u32 = 12288;
pub const PCI_EXP_DEVCAP2_OBFF_MASK: u32 = 786432;
pub const PCI_EXP_DEVCAP2_OBFF_MSG: u32 = 262144;
pub const PCI_EXP_DEVCAP2_OBFF_WAKE: u32 = 524288;
pub const PCI_EXP_DEVCAP2_EE_PREFIX: u32 = 2097152;
pub const PCI_EXP_DEVCAP2_EE_PREFIX_MAX: u32 = 12582912;
pub const PCI_EXP_DEVCTL2: u32 = 40;
pub const PCI_EXP_DEVCTL2_COMP_TIMEOUT: u32 = 15;
pub const PCI_EXP_DEVCTL2_COMP_TMOUT_DIS: u32 = 16;
pub const PCI_EXP_DEVCTL2_ARI: u32 = 32;
pub const PCI_EXP_DEVCTL2_ATOMIC_REQ: u32 = 64;
pub const PCI_EXP_DEVCTL2_ATOMIC_EGRESS_BLOCK: u32 = 128;
pub const PCI_EXP_DEVCTL2_IDO_REQ_EN: u32 = 256;
pub const PCI_EXP_DEVCTL2_IDO_CMP_EN: u32 = 512;
pub const PCI_EXP_DEVCTL2_LTR_EN: u32 = 1024;
pub const PCI_EXP_DEVCTL2_OBFF_MSGA_EN: u32 = 8192;
pub const PCI_EXP_DEVCTL2_OBFF_MSGB_EN: u32 = 16384;
pub const PCI_EXP_DEVCTL2_OBFF_WAKE_EN: u32 = 24576;
pub const PCI_EXP_DEVSTA2: u32 = 42;
pub const PCI_CAP_EXP_RC_ENDPOINT_SIZEOF_V2: u32 = 44;
pub const PCI_EXP_LNKCAP2: u32 = 44;
pub const PCI_EXP_LNKCAP2_SLS: u32 = 254;
pub const PCI_EXP_LNKCAP2_SLS_2_5GB: u32 = 2;
pub const PCI_EXP_LNKCAP2_SLS_5_0GB: u32 = 4;
pub const PCI_EXP_LNKCAP2_SLS_8_0GB: u32 = 8;
pub const PCI_EXP_LNKCAP2_SLS_16_0GB: u32 = 16;
pub const PCI_EXP_LNKCAP2_SLS_32_0GB: u32 = 32;
pub const PCI_EXP_LNKCAP2_SLS_64_0GB: u32 = 64;
pub const PCI_EXP_LNKCAP2_CROSSLINK: u32 = 256;
pub const PCI_EXP_LNKCTL2: u32 = 48;
pub const PCI_EXP_LNKCTL2_TLS: u32 = 15;
pub const PCI_EXP_LNKCTL2_TLS_2_5GT: u32 = 1;
pub const PCI_EXP_LNKCTL2_TLS_5_0GT: u32 = 2;
pub const PCI_EXP_LNKCTL2_TLS_8_0GT: u32 = 3;
pub const PCI_EXP_LNKCTL2_TLS_16_0GT: u32 = 4;
pub const PCI_EXP_LNKCTL2_TLS_32_0GT: u32 = 5;
pub const PCI_EXP_LNKCTL2_TLS_64_0GT: u32 = 6;
pub const PCI_EXP_LNKCTL2_ENTER_COMP: u32 = 16;
pub const PCI_EXP_LNKCTL2_TX_MARGIN: u32 = 896;
pub const PCI_EXP_LNKCTL2_HASD: u32 = 32;
pub const PCI_EXP_LNKSTA2: u32 = 50;
pub const PCI_EXP_LNKSTA2_FLIT: u32 = 1024;
pub const PCI_CAP_EXP_ENDPOINT_SIZEOF_V2: u32 = 50;
pub const PCI_EXP_SLTCAP2: u32 = 52;
pub const PCI_EXP_SLTCAP2_IBPD: u32 = 1;
pub const PCI_EXP_SLTCTL2: u32 = 56;
pub const PCI_EXP_SLTSTA2: u32 = 58;
pub const PCI_EXT_CAP_ID_ERR: u32 = 1;
pub const PCI_EXT_CAP_ID_VC: u32 = 2;
pub const PCI_EXT_CAP_ID_DSN: u32 = 3;
pub const PCI_EXT_CAP_ID_PWR: u32 = 4;
pub const PCI_EXT_CAP_ID_RCLD: u32 = 5;
pub const PCI_EXT_CAP_ID_RCILC: u32 = 6;
pub const PCI_EXT_CAP_ID_RCEC: u32 = 7;
pub const PCI_EXT_CAP_ID_MFVC: u32 = 8;
pub const PCI_EXT_CAP_ID_VC9: u32 = 9;
pub const PCI_EXT_CAP_ID_RCRB: u32 = 10;
pub const PCI_EXT_CAP_ID_VNDR: u32 = 11;
pub const PCI_EXT_CAP_ID_CAC: u32 = 12;
pub const PCI_EXT_CAP_ID_ACS: u32 = 13;
pub const PCI_EXT_CAP_ID_ARI: u32 = 14;
pub const PCI_EXT_CAP_ID_ATS: u32 = 15;
pub const PCI_EXT_CAP_ID_SRIOV: u32 = 16;
pub const PCI_EXT_CAP_ID_MRIOV: u32 = 17;
pub const PCI_EXT_CAP_ID_MCAST: u32 = 18;
pub const PCI_EXT_CAP_ID_PRI: u32 = 19;
pub const PCI_EXT_CAP_ID_AMD_XXX: u32 = 20;
pub const PCI_EXT_CAP_ID_REBAR: u32 = 21;
pub const PCI_EXT_CAP_ID_DPA: u32 = 22;
pub const PCI_EXT_CAP_ID_TPH: u32 = 23;
pub const PCI_EXT_CAP_ID_LTR: u32 = 24;
pub const PCI_EXT_CAP_ID_SECPCI: u32 = 25;
pub const PCI_EXT_CAP_ID_PMUX: u32 = 26;
pub const PCI_EXT_CAP_ID_PASID: u32 = 27;
pub const PCI_EXT_CAP_ID_DPC: u32 = 29;
pub const PCI_EXT_CAP_ID_L1SS: u32 = 30;
pub const PCI_EXT_CAP_ID_PTM: u32 = 31;
pub const PCI_EXT_CAP_ID_DVSEC: u32 = 35;
pub const PCI_EXT_CAP_ID_DLF: u32 = 37;
pub const PCI_EXT_CAP_ID_PL_16GT: u32 = 38;
pub const PCI_EXT_CAP_ID_NPEM: u32 = 41;
pub const PCI_EXT_CAP_ID_PL_32GT: u32 = 42;
pub const PCI_EXT_CAP_ID_DOE: u32 = 46;
pub const PCI_EXT_CAP_ID_MAX: u32 = 46;
pub const PCI_EXT_CAP_DSN_SIZEOF: u32 = 12;
pub const PCI_EXT_CAP_MCAST_ENDPOINT_SIZEOF: u32 = 40;
pub const PCI_ERR_UNCOR_STATUS: u32 = 4;
pub const PCI_ERR_UNC_UND: u32 = 1;
pub const PCI_ERR_UNC_DLP: u32 = 16;
pub const PCI_ERR_UNC_SURPDN: u32 = 32;
pub const PCI_ERR_UNC_POISON_TLP: u32 = 4096;
pub const PCI_ERR_UNC_FCP: u32 = 8192;
pub const PCI_ERR_UNC_COMP_TIME: u32 = 16384;
pub const PCI_ERR_UNC_COMP_ABORT: u32 = 32768;
pub const PCI_ERR_UNC_UNX_COMP: u32 = 65536;
pub const PCI_ERR_UNC_RX_OVER: u32 = 131072;
pub const PCI_ERR_UNC_MALF_TLP: u32 = 262144;
pub const PCI_ERR_UNC_ECRC: u32 = 524288;
pub const PCI_ERR_UNC_UNSUP: u32 = 1048576;
pub const PCI_ERR_UNC_ACSV: u32 = 2097152;
pub const PCI_ERR_UNC_INTN: u32 = 4194304;
pub const PCI_ERR_UNC_MCBTLP: u32 = 8388608;
pub const PCI_ERR_UNC_ATOMEG: u32 = 16777216;
pub const PCI_ERR_UNC_TLPPRE: u32 = 33554432;
pub const PCI_ERR_UNCOR_MASK: u32 = 8;
pub const PCI_ERR_UNCOR_SEVER: u32 = 12;
pub const PCI_ERR_COR_STATUS: u32 = 16;
pub const PCI_ERR_COR_RCVR: u32 = 1;
pub const PCI_ERR_COR_BAD_TLP: u32 = 64;
pub const PCI_ERR_COR_BAD_DLLP: u32 = 128;
pub const PCI_ERR_COR_REP_ROLL: u32 = 256;
pub const PCI_ERR_COR_REP_TIMER: u32 = 4096;
pub const PCI_ERR_COR_ADV_NFAT: u32 = 8192;
pub const PCI_ERR_COR_INTERNAL: u32 = 16384;
pub const PCI_ERR_COR_LOG_OVER: u32 = 32768;
pub const PCI_ERR_COR_MASK: u32 = 20;
pub const PCI_ERR_CAP: u32 = 24;
pub const PCI_ERR_CAP_ECRC_GENC: u32 = 32;
pub const PCI_ERR_CAP_ECRC_GENE: u32 = 64;
pub const PCI_ERR_CAP_ECRC_CHKC: u32 = 128;
pub const PCI_ERR_CAP_ECRC_CHKE: u32 = 256;
pub const PCI_ERR_CAP_PREFIX_LOG_PRESENT: u32 = 2048;
pub const PCI_ERR_CAP_TLP_LOG_FLIT: u32 = 262144;
pub const PCI_ERR_CAP_TLP_LOG_SIZE: u32 = 16252928;
pub const PCI_ERR_HEADER_LOG: u32 = 28;
pub const PCI_ERR_ROOT_COMMAND: u32 = 44;
pub const PCI_ERR_ROOT_CMD_COR_EN: u32 = 1;
pub const PCI_ERR_ROOT_CMD_NONFATAL_EN: u32 = 2;
pub const PCI_ERR_ROOT_CMD_FATAL_EN: u32 = 4;
pub const PCI_ERR_ROOT_STATUS: u32 = 48;
pub const PCI_ERR_ROOT_COR_RCV: u32 = 1;
pub const PCI_ERR_ROOT_MULTI_COR_RCV: u32 = 2;
pub const PCI_ERR_ROOT_UNCOR_RCV: u32 = 4;
pub const PCI_ERR_ROOT_MULTI_UNCOR_RCV: u32 = 8;
pub const PCI_ERR_ROOT_FIRST_FATAL: u32 = 16;
pub const PCI_ERR_ROOT_NONFATAL_RCV: u32 = 32;
pub const PCI_ERR_ROOT_FATAL_RCV: u32 = 64;
pub const PCI_ERR_ROOT_AER_IRQ: u32 = 4160749568;
pub const PCI_ERR_ROOT_ERR_SRC: u32 = 52;
pub const PCI_ERR_PREFIX_LOG: u32 = 56;
pub const PCI_VC_PORT_CAP1: u32 = 4;
pub const PCI_VC_CAP1_EVCC: u32 = 7;
pub const PCI_VC_CAP1_LPEVCC: u32 = 112;
pub const PCI_VC_CAP1_ARB_SIZE: u32 = 3072;
pub const PCI_VC_PORT_CAP2: u32 = 8;
pub const PCI_VC_CAP2_32_PHASE: u32 = 2;
pub const PCI_VC_CAP2_64_PHASE: u32 = 4;
pub const PCI_VC_CAP2_128_PHASE: u32 = 8;
pub const PCI_VC_CAP2_ARB_OFF: u32 = 4278190080;
pub const PCI_VC_PORT_CTRL: u32 = 12;
pub const PCI_VC_PORT_CTRL_LOAD_TABLE: u32 = 1;
pub const PCI_VC_PORT_STATUS: u32 = 14;
pub const PCI_VC_PORT_STATUS_TABLE: u32 = 1;
pub const PCI_VC_RES_CAP: u32 = 16;
pub const PCI_VC_RES_CAP_32_PHASE: u32 = 2;
pub const PCI_VC_RES_CAP_64_PHASE: u32 = 4;
pub const PCI_VC_RES_CAP_128_PHASE: u32 = 8;
pub const PCI_VC_RES_CAP_128_PHASE_TB: u32 = 16;
pub const PCI_VC_RES_CAP_256_PHASE: u32 = 32;
pub const PCI_VC_RES_CAP_ARB_OFF: u32 = 4278190080;
pub const PCI_VC_RES_CTRL: u32 = 20;
pub const PCI_VC_RES_CTRL_LOAD_TABLE: u32 = 65536;
pub const PCI_VC_RES_CTRL_ARB_SELECT: u32 = 917504;
pub const PCI_VC_RES_CTRL_ID: u32 = 117440512;
pub const PCI_VC_RES_CTRL_ENABLE: u32 = 2147483648;
pub const PCI_VC_RES_STATUS: u32 = 26;
pub const PCI_VC_RES_STATUS_TABLE: u32 = 1;
pub const PCI_VC_RES_STATUS_NEGO: u32 = 2;
pub const PCI_CAP_VC_BASE_SIZEOF: u32 = 16;
pub const PCI_CAP_VC_PER_VC_SIZEOF: u32 = 12;
pub const PCI_PWR_DSR: u32 = 4;
pub const PCI_PWR_DATA: u32 = 8;
pub const PCI_PWR_CAP: u32 = 12;
pub const PCI_EXT_CAP_PWR_SIZEOF: u32 = 16;
pub const PCI_RCEC_RCIEP_BITMAP: u32 = 4;
pub const PCI_RCEC_BUSN: u32 = 8;
pub const PCI_RCEC_BUSN_REG_VER: u32 = 2;
pub const PCI_VNDR_HEADER: u32 = 4;
pub const HT_3BIT_CAP_MASK: u32 = 224;
pub const HT_CAPTYPE_SLAVE: u32 = 0;
pub const HT_CAPTYPE_HOST: u32 = 32;
pub const HT_5BIT_CAP_MASK: u32 = 248;
pub const HT_CAPTYPE_IRQ: u32 = 128;
pub const HT_CAPTYPE_REMAPPING_40: u32 = 160;
pub const HT_CAPTYPE_REMAPPING_64: u32 = 162;
pub const HT_CAPTYPE_UNITID_CLUMP: u32 = 144;
pub const HT_CAPTYPE_EXTCONF: u32 = 152;
pub const HT_CAPTYPE_MSI_MAPPING: u32 = 168;
pub const HT_MSI_FLAGS: u32 = 2;
pub const HT_MSI_FLAGS_ENABLE: u32 = 1;
pub const HT_MSI_FLAGS_FIXED: u32 = 2;
pub const HT_MSI_FIXED_ADDR: u32 = 4276092928;
pub const HT_MSI_ADDR_LO: u32 = 4;
pub const HT_MSI_ADDR_LO_MASK: u32 = 4293918720;
pub const HT_MSI_ADDR_HI: u32 = 8;
pub const HT_CAPTYPE_DIRECT_ROUTE: u32 = 176;
pub const HT_CAPTYPE_VCSET: u32 = 184;
pub const HT_CAPTYPE_ERROR_RETRY: u32 = 192;
pub const HT_CAPTYPE_GEN3: u32 = 208;
pub const HT_CAPTYPE_PM: u32 = 224;
pub const HT_CAP_SIZEOF_LONG: u32 = 28;
pub const HT_CAP_SIZEOF_SHORT: u32 = 24;
pub const PCI_ARI_CAP: u32 = 4;
pub const PCI_ARI_CAP_MFVC: u32 = 1;
pub const PCI_ARI_CAP_ACS: u32 = 2;
pub const PCI_ARI_CTRL: u32 = 6;
pub const PCI_ARI_CTRL_MFVC: u32 = 1;
pub const PCI_ARI_CTRL_ACS: u32 = 2;
pub const PCI_EXT_CAP_ARI_SIZEOF: u32 = 8;
pub const PCI_ATS_CAP: u32 = 4;
pub const PCI_ATS_MAX_QDEP: u32 = 32;
pub const PCI_ATS_CAP_PAGE_ALIGNED: u32 = 32;
pub const PCI_ATS_CTRL: u32 = 6;
pub const PCI_ATS_CTRL_ENABLE: u32 = 32768;
pub const PCI_ATS_MIN_STU: u32 = 12;
pub const PCI_EXT_CAP_ATS_SIZEOF: u32 = 8;
pub const PCI_PRI_CTRL: u32 = 4;
pub const PCI_PRI_CTRL_ENABLE: u32 = 1;
pub const PCI_PRI_CTRL_RESET: u32 = 2;
pub const PCI_PRI_STATUS: u32 = 6;
pub const PCI_PRI_STATUS_RF: u32 = 1;
pub const PCI_PRI_STATUS_UPRGI: u32 = 2;
pub const PCI_PRI_STATUS_STOPPED: u32 = 256;
pub const PCI_PRI_STATUS_PASID: u32 = 32768;
pub const PCI_PRI_MAX_REQ: u32 = 8;
pub const PCI_PRI_ALLOC_REQ: u32 = 12;
pub const PCI_EXT_CAP_PRI_SIZEOF: u32 = 16;
pub const PCI_PASID_CAP: u32 = 4;
pub const PCI_PASID_CAP_EXEC: u32 = 2;
pub const PCI_PASID_CAP_PRIV: u32 = 4;
pub const PCI_PASID_CAP_WIDTH: u32 = 7936;
pub const PCI_PASID_CTRL: u32 = 6;
pub const PCI_PASID_CTRL_ENABLE: u32 = 1;
pub const PCI_PASID_CTRL_EXEC: u32 = 2;
pub const PCI_PASID_CTRL_PRIV: u32 = 4;
pub const PCI_EXT_CAP_PASID_SIZEOF: u32 = 8;
pub const PCI_SRIOV_CAP: u32 = 4;
pub const PCI_SRIOV_CAP_VFM: u32 = 1;
pub const PCI_SRIOV_CTRL: u32 = 8;
pub const PCI_SRIOV_CTRL_VFE: u32 = 1;
pub const PCI_SRIOV_CTRL_VFM: u32 = 2;
pub const PCI_SRIOV_CTRL_INTR: u32 = 4;
pub const PCI_SRIOV_CTRL_MSE: u32 = 8;
pub const PCI_SRIOV_CTRL_ARI: u32 = 16;
pub const PCI_SRIOV_STATUS: u32 = 10;
pub const PCI_SRIOV_STATUS_VFM: u32 = 1;
pub const PCI_SRIOV_INITIAL_VF: u32 = 12;
pub const PCI_SRIOV_TOTAL_VF: u32 = 14;
pub const PCI_SRIOV_NUM_VF: u32 = 16;
pub const PCI_SRIOV_FUNC_LINK: u32 = 18;
pub const PCI_SRIOV_VF_OFFSET: u32 = 20;
pub const PCI_SRIOV_VF_STRIDE: u32 = 22;
pub const PCI_SRIOV_VF_DID: u32 = 26;
pub const PCI_SRIOV_SUP_PGSIZE: u32 = 28;
pub const PCI_SRIOV_SYS_PGSIZE: u32 = 32;
pub const PCI_SRIOV_BAR: u32 = 36;
pub const PCI_SRIOV_NUM_BARS: u32 = 6;
pub const PCI_SRIOV_VFM: u32 = 60;
pub const PCI_SRIOV_VFM_UA: u32 = 0;
pub const PCI_SRIOV_VFM_MI: u32 = 1;
pub const PCI_SRIOV_VFM_MO: u32 = 2;
pub const PCI_SRIOV_VFM_AV: u32 = 3;
pub const PCI_EXT_CAP_SRIOV_SIZEOF: u32 = 64;
pub const PCI_LTR_MAX_SNOOP_LAT: u32 = 4;
pub const PCI_LTR_MAX_NOSNOOP_LAT: u32 = 6;
pub const PCI_LTR_VALUE_MASK: u32 = 1023;
pub const PCI_LTR_SCALE_MASK: u32 = 7168;
pub const PCI_LTR_SCALE_SHIFT: u32 = 10;
pub const PCI_LTR_NOSNOOP_VALUE: u32 = 67043328;
pub const PCI_LTR_NOSNOOP_SCALE: u32 = 469762048;
pub const PCI_EXT_CAP_LTR_SIZEOF: u32 = 8;
pub const PCI_ACS_CAP: u32 = 4;
pub const PCI_ACS_SV: u32 = 1;
pub const PCI_ACS_TB: u32 = 2;
pub const PCI_ACS_RR: u32 = 4;
pub const PCI_ACS_CR: u32 = 8;
pub const PCI_ACS_UF: u32 = 16;
pub const PCI_ACS_EC: u32 = 32;
pub const PCI_ACS_DT: u32 = 64;
pub const PCI_ACS_EGRESS_BITS: u32 = 5;
pub const PCI_ACS_CTRL: u32 = 6;
pub const PCI_ACS_EGRESS_CTL_V: u32 = 8;
pub const PCI_SATA_REGS: u32 = 4;
pub const PCI_SATA_REGS_MASK: u32 = 15;
pub const PCI_SATA_REGS_INLINE: u32 = 15;
pub const PCI_SATA_SIZEOF_SHORT: u32 = 8;
pub const PCI_SATA_SIZEOF_LONG: u32 = 16;
pub const PCI_REBAR_CAP: u32 = 4;
pub const PCI_REBAR_CAP_SIZES: u32 = 4294967280;
pub const PCI_REBAR_CTRL: u32 = 8;
pub const PCI_REBAR_CTRL_BAR_IDX: u32 = 7;
pub const PCI_REBAR_CTRL_NBAR_MASK: u32 = 224;
pub const PCI_REBAR_CTRL_NBAR_SHIFT: u32 = 5;
pub const PCI_REBAR_CTRL_BAR_SIZE: u32 = 7936;
pub const PCI_REBAR_CTRL_BAR_SHIFT: u32 = 8;
pub const PCI_DPA_CAP: u32 = 4;
pub const PCI_DPA_CAP_SUBSTATE_MASK: u32 = 31;
pub const PCI_DPA_BASE_SIZEOF: u32 = 16;
pub const PCI_EXP_DEVCAP2_TPH_COMP_NONE: u32 = 0;
pub const PCI_EXP_DEVCAP2_TPH_COMP_TPH_ONLY: u32 = 1;
pub const PCI_EXP_DEVCAP2_TPH_COMP_EXT_TPH: u32 = 3;
pub const PCI_TPH_CAP: u32 = 4;
pub const PCI_TPH_CAP_ST_NS: u32 = 1;
pub const PCI_TPH_CAP_ST_IV: u32 = 2;
pub const PCI_TPH_CAP_ST_DS: u32 = 4;
pub const PCI_TPH_CAP_EXT_TPH: u32 = 256;
pub const PCI_TPH_CAP_LOC_MASK: u32 = 1536;
pub const PCI_TPH_LOC_NONE: u32 = 0;
pub const PCI_TPH_LOC_CAP: u32 = 512;
pub const PCI_TPH_LOC_MSIX: u32 = 1024;
pub const PCI_TPH_CAP_ST_MASK: u32 = 134152192;
pub const PCI_TPH_CAP_ST_SHIFT: u32 = 16;
pub const PCI_TPH_BASE_SIZEOF: u32 = 12;
pub const PCI_TPH_CTRL: u32 = 8;
pub const PCI_TPH_CTRL_MODE_SEL_MASK: u32 = 7;
pub const PCI_TPH_ST_NS_MODE: u32 = 0;
pub const PCI_TPH_ST_IV_MODE: u32 = 1;
pub const PCI_TPH_ST_DS_MODE: u32 = 2;
pub const PCI_TPH_CTRL_REQ_EN_MASK: u32 = 768;
pub const PCI_TPH_REQ_DISABLE: u32 = 0;
pub const PCI_TPH_REQ_TPH_ONLY: u32 = 1;
pub const PCI_TPH_REQ_EXT_TPH: u32 = 3;
pub const PCI_EXP_DPC_CAP: u32 = 4;
pub const PCI_EXP_DPC_IRQ: u32 = 31;
pub const PCI_EXP_DPC_CAP_RP_EXT: u32 = 32;
pub const PCI_EXP_DPC_CAP_POISONED_TLP: u32 = 64;
pub const PCI_EXP_DPC_CAP_SW_TRIGGER: u32 = 128;
pub const PCI_EXP_DPC_RP_PIO_LOG_SIZE: u32 = 3840;
pub const PCI_EXP_DPC_CAP_DL_ACTIVE: u32 = 4096;
pub const PCI_EXP_DPC_RP_PIO_LOG_SIZE4: u32 = 8192;
pub const PCI_EXP_DPC_CTL: u32 = 6;
pub const PCI_EXP_DPC_CTL_EN_FATAL: u32 = 1;
pub const PCI_EXP_DPC_CTL_EN_NONFATAL: u32 = 2;
pub const PCI_EXP_DPC_CTL_INT_EN: u32 = 8;
pub const PCI_EXP_DPC_STATUS: u32 = 8;
pub const PCI_EXP_DPC_STATUS_TRIGGER: u32 = 1;
pub const PCI_EXP_DPC_STATUS_TRIGGER_RSN: u32 = 6;
pub const PCI_EXP_DPC_STATUS_TRIGGER_RSN_UNCOR: u32 = 0;
pub const PCI_EXP_DPC_STATUS_TRIGGER_RSN_NFE: u32 = 2;
pub const PCI_EXP_DPC_STATUS_TRIGGER_RSN_FE: u32 = 4;
pub const PCI_EXP_DPC_STATUS_TRIGGER_RSN_IN_EXT: u32 = 6;
pub const PCI_EXP_DPC_STATUS_INTERRUPT: u32 = 8;
pub const PCI_EXP_DPC_RP_BUSY: u32 = 16;
pub const PCI_EXP_DPC_STATUS_TRIGGER_RSN_EXT: u32 = 96;
pub const PCI_EXP_DPC_STATUS_TRIGGER_RSN_RP_PIO: u32 = 0;
pub const PCI_EXP_DPC_STATUS_TRIGGER_RSN_SW_TRIGGER: u32 = 32;
pub const PCI_EXP_DPC_RP_PIO_FEP: u32 = 7936;
pub const PCI_EXP_DPC_SOURCE_ID: u32 = 10;
pub const PCI_EXP_DPC_RP_PIO_STATUS: u32 = 12;
pub const PCI_EXP_DPC_RP_PIO_MASK: u32 = 16;
pub const PCI_EXP_DPC_RP_PIO_SEVERITY: u32 = 20;
pub const PCI_EXP_DPC_RP_PIO_SYSERROR: u32 = 24;
pub const PCI_EXP_DPC_RP_PIO_EXCEPTION: u32 = 28;
pub const PCI_EXP_DPC_RP_PIO_HEADER_LOG: u32 = 32;
pub const PCI_EXP_DPC_RP_PIO_IMPSPEC_LOG: u32 = 48;
pub const PCI_EXP_DPC_RP_PIO_TLPPREFIX_LOG: u32 = 52;
pub const PCI_PTM_CAP: u32 = 4;
pub const PCI_PTM_CAP_REQ: u32 = 1;
pub const PCI_PTM_CAP_RES: u32 = 2;
pub const PCI_PTM_CAP_ROOT: u32 = 4;
pub const PCI_PTM_GRANULARITY_MASK: u32 = 65280;
pub const PCI_PTM_CTRL: u32 = 8;
pub const PCI_PTM_CTRL_ENABLE: u32 = 1;
pub const PCI_PTM_CTRL_ROOT: u32 = 2;
pub const PCI_L1SS_CAP: u32 = 4;
pub const PCI_L1SS_CAP_PCIPM_L1_2: u32 = 1;
pub const PCI_L1SS_CAP_PCIPM_L1_1: u32 = 2;
pub const PCI_L1SS_CAP_ASPM_L1_2: u32 = 4;
pub const PCI_L1SS_CAP_ASPM_L1_1: u32 = 8;
pub const PCI_L1SS_CAP_L1_PM_SS: u32 = 16;
pub const PCI_L1SS_CAP_CM_RESTORE_TIME: u32 = 65280;
pub const PCI_L1SS_CAP_P_PWR_ON_SCALE: u32 = 196608;
pub const PCI_L1SS_CAP_P_PWR_ON_VALUE: u32 = 16252928;
pub const PCI_L1SS_CTL1: u32 = 8;
pub const PCI_L1SS_CTL1_PCIPM_L1_2: u32 = 1;
pub const PCI_L1SS_CTL1_PCIPM_L1_1: u32 = 2;
pub const PCI_L1SS_CTL1_ASPM_L1_2: u32 = 4;
pub const PCI_L1SS_CTL1_ASPM_L1_1: u32 = 8;
pub const PCI_L1SS_CTL1_L1_2_MASK: u32 = 5;
pub const PCI_L1SS_CTL1_L1SS_MASK: u32 = 15;
pub const PCI_L1SS_CTL1_CM_RESTORE_TIME: u32 = 65280;
pub const PCI_L1SS_CTL1_LTR_L12_TH_VALUE: u32 = 67043328;
pub const PCI_L1SS_CTL1_LTR_L12_TH_SCALE: u32 = 3758096384;
pub const PCI_L1SS_CTL2: u32 = 12;
pub const PCI_L1SS_CTL2_T_PWR_ON_SCALE: u32 = 3;
pub const PCI_L1SS_CTL2_T_PWR_ON_VALUE: u32 = 248;
pub const PCI_DVSEC_HEADER1: u32 = 4;
pub const PCI_DVSEC_HEADER2: u32 = 8;
pub const PCI_DLF_CAP: u32 = 4;
pub const PCI_DLF_EXCHANGE_ENABLE: u32 = 2147483648;
pub const PCI_PL_16GT_LE_CTRL: u32 = 32;
pub const PCI_PL_16GT_LE_CTRL_DSP_TX_PRESET_MASK: u32 = 15;
pub const PCI_PL_16GT_LE_CTRL_USP_TX_PRESET_MASK: u32 = 240;
pub const PCI_PL_16GT_LE_CTRL_USP_TX_PRESET_SHIFT: u32 = 4;
pub const PCI_NPEM_CAP: u32 = 4;
pub const PCI_NPEM_CAP_CAPABLE: u32 = 1;
pub const PCI_NPEM_CTRL: u32 = 8;
pub const PCI_NPEM_CTRL_ENABLE: u32 = 1;
pub const PCI_NPEM_CMD_RESET: u32 = 2;
pub const PCI_NPEM_IND_OK: u32 = 4;
pub const PCI_NPEM_IND_LOCATE: u32 = 8;
pub const PCI_NPEM_IND_FAIL: u32 = 16;
pub const PCI_NPEM_IND_REBUILD: u32 = 32;
pub const PCI_NPEM_IND_PFA: u32 = 64;
pub const PCI_NPEM_IND_HOTSPARE: u32 = 128;
pub const PCI_NPEM_IND_ICA: u32 = 256;
pub const PCI_NPEM_IND_IFA: u32 = 512;
pub const PCI_NPEM_IND_IDT: u32 = 1024;
pub const PCI_NPEM_IND_DISABLED: u32 = 2048;
pub const PCI_NPEM_IND_SPEC_0: u32 = 16777216;
pub const PCI_NPEM_IND_SPEC_1: u32 = 33554432;
pub const PCI_NPEM_IND_SPEC_2: u32 = 67108864;
pub const PCI_NPEM_IND_SPEC_3: u32 = 134217728;
pub const PCI_NPEM_IND_SPEC_4: u32 = 268435456;
pub const PCI_NPEM_IND_SPEC_5: u32 = 536870912;
pub const PCI_NPEM_IND_SPEC_6: u32 = 1073741824;
pub const PCI_NPEM_IND_SPEC_7: u32 = 2147483648;
pub const PCI_NPEM_STATUS: u32 = 12;
pub const PCI_NPEM_STATUS_CC: u32 = 1;
pub const PCI_DOE_CAP: u32 = 4;
pub const PCI_DOE_CAP_INT_SUP: u32 = 1;
pub const PCI_DOE_CAP_INT_MSG_NUM: u32 = 4094;
pub const PCI_DOE_CTRL: u32 = 8;
pub const PCI_DOE_CTRL_ABORT: u32 = 1;
pub const PCI_DOE_CTRL_INT_EN: u32 = 2;
pub const PCI_DOE_CTRL_GO: u32 = 2147483648;
pub const PCI_DOE_STATUS: u32 = 12;
pub const PCI_DOE_STATUS_BUSY: u32 = 1;
pub const PCI_DOE_STATUS_INT_STATUS: u32 = 2;
pub const PCI_DOE_STATUS_ERROR: u32 = 4;
pub const PCI_DOE_STATUS_DATA_OBJECT_READY: u32 = 2147483648;
pub const PCI_DOE_WRITE: u32 = 16;
pub const PCI_DOE_READ: u32 = 20;
pub const PCI_DOE_CAP_SIZEOF: u32 = 24;
pub const PCI_DOE_DATA_OBJECT_HEADER_1_VID: u32 = 65535;
pub const PCI_DOE_DATA_OBJECT_HEADER_1_TYPE: u32 = 16711680;
pub const PCI_DOE_DATA_OBJECT_HEADER_2_LENGTH: u32 = 262143;
pub const PCI_DOE_DATA_OBJECT_DISC_REQ_3_INDEX: u32 = 255;
pub const PCI_DOE_DATA_OBJECT_DISC_REQ_3_VER: u32 = 65280;
pub const PCI_DOE_DATA_OBJECT_DISC_RSP_3_VID: u32 = 65535;
pub const PCI_DOE_DATA_OBJECT_DISC_RSP_3_TYPE: u32 = 16711680;
pub const PCI_DOE_DATA_OBJECT_DISC_RSP_3_NEXT_INDEX: u32 = 4278190080;
pub const PCI_DOE_DATA_OBJECT_DISC_RSP_3_PROTOCOL: u32 = 16711680;
pub const PCI_DVSEC_CXL_PORT: u32 = 3;
pub const PCI_DVSEC_CXL_PORT_CTL: u32 = 12;
pub const PCI_DVSEC_CXL_PORT_CTL_UNMASK_SBR: u32 = 1;
pub const PCI_CLASS_NOT_DEFINED: u32 = 0;
pub const PCI_CLASS_NOT_DEFINED_VGA: u32 = 1;
pub const PCI_BASE_CLASS_STORAGE: u32 = 1;
pub const PCI_CLASS_STORAGE_SCSI: u32 = 256;
pub const PCI_CLASS_STORAGE_IDE: u32 = 257;
pub const PCI_CLASS_STORAGE_FLOPPY: u32 = 258;
pub const PCI_CLASS_STORAGE_IPI: u32 = 259;
pub const PCI_CLASS_STORAGE_RAID: u32 = 260;
pub const PCI_CLASS_STORAGE_SATA: u32 = 262;
pub const PCI_CLASS_STORAGE_SATA_AHCI: u32 = 67073;
pub const PCI_CLASS_STORAGE_SAS: u32 = 263;
pub const PCI_CLASS_STORAGE_EXPRESS: u32 = 67586;
pub const PCI_CLASS_STORAGE_OTHER: u32 = 384;
pub const PCI_BASE_CLASS_NETWORK: u32 = 2;
pub const PCI_CLASS_NETWORK_ETHERNET: u32 = 512;
pub const PCI_CLASS_NETWORK_TOKEN_RING: u32 = 513;
pub const PCI_CLASS_NETWORK_FDDI: u32 = 514;
pub const PCI_CLASS_NETWORK_ATM: u32 = 515;
pub const PCI_CLASS_NETWORK_OTHER: u32 = 640;
pub const PCI_BASE_CLASS_DISPLAY: u32 = 3;
pub const PCI_CLASS_DISPLAY_VGA: u32 = 768;
pub const PCI_CLASS_DISPLAY_XGA: u32 = 769;
pub const PCI_CLASS_DISPLAY_3D: u32 = 770;
pub const PCI_CLASS_DISPLAY_OTHER: u32 = 896;
pub const PCI_BASE_CLASS_MULTIMEDIA: u32 = 4;
pub const PCI_CLASS_MULTIMEDIA_VIDEO: u32 = 1024;
pub const PCI_CLASS_MULTIMEDIA_AUDIO: u32 = 1025;
pub const PCI_CLASS_MULTIMEDIA_PHONE: u32 = 1026;
pub const PCI_CLASS_MULTIMEDIA_HD_AUDIO: u32 = 1027;
pub const PCI_CLASS_MULTIMEDIA_OTHER: u32 = 1152;
pub const PCI_BASE_CLASS_MEMORY: u32 = 5;
pub const PCI_CLASS_MEMORY_RAM: u32 = 1280;
pub const PCI_CLASS_MEMORY_FLASH: u32 = 1281;
pub const PCI_CLASS_MEMORY_CXL: u32 = 1282;
pub const PCI_CLASS_MEMORY_OTHER: u32 = 1408;
pub const PCI_BASE_CLASS_BRIDGE: u32 = 6;
pub const PCI_CLASS_BRIDGE_HOST: u32 = 1536;
pub const PCI_CLASS_BRIDGE_ISA: u32 = 1537;
pub const PCI_CLASS_BRIDGE_EISA: u32 = 1538;
pub const PCI_CLASS_BRIDGE_MC: u32 = 1539;
pub const PCI_CLASS_BRIDGE_PCI: u32 = 1540;
pub const PCI_CLASS_BRIDGE_PCI_NORMAL: u32 = 394240;
pub const PCI_CLASS_BRIDGE_PCI_SUBTRACTIVE: u32 = 394241;
pub const PCI_CLASS_BRIDGE_PCMCIA: u32 = 1541;
pub const PCI_CLASS_BRIDGE_NUBUS: u32 = 1542;
pub const PCI_CLASS_BRIDGE_CARDBUS: u32 = 1543;
pub const PCI_CLASS_BRIDGE_RACEWAY: u32 = 1544;
pub const PCI_CLASS_BRIDGE_OTHER: u32 = 1664;
pub const PCI_BASE_CLASS_COMMUNICATION: u32 = 7;
pub const PCI_CLASS_COMMUNICATION_SERIAL: u32 = 1792;
pub const PCI_CLASS_COMMUNICATION_PARALLEL: u32 = 1793;
pub const PCI_CLASS_COMMUNICATION_MULTISERIAL: u32 = 1794;
pub const PCI_CLASS_COMMUNICATION_MODEM: u32 = 1795;
pub const PCI_CLASS_COMMUNICATION_OTHER: u32 = 1920;
pub const PCI_SERIAL_16550_COMPATIBLE: u32 = 2;
pub const PCI_BASE_CLASS_SYSTEM: u32 = 8;
pub const PCI_CLASS_SYSTEM_PIC: u32 = 2048;
pub const PCI_CLASS_SYSTEM_PIC_IOAPIC: u32 = 524304;
pub const PCI_CLASS_SYSTEM_PIC_IOXAPIC: u32 = 524320;
pub const PCI_CLASS_SYSTEM_DMA: u32 = 2049;
pub const PCI_CLASS_SYSTEM_TIMER: u32 = 2050;
pub const PCI_CLASS_SYSTEM_RTC: u32 = 2051;
pub const PCI_CLASS_SYSTEM_PCI_HOTPLUG: u32 = 2052;
pub const PCI_CLASS_SYSTEM_SDHCI: u32 = 2053;
pub const PCI_CLASS_SYSTEM_RCEC: u32 = 2055;
pub const PCI_CLASS_SYSTEM_OTHER: u32 = 2176;
pub const PCI_BASE_CLASS_INPUT: u32 = 9;
pub const PCI_CLASS_INPUT_KEYBOARD: u32 = 2304;
pub const PCI_CLASS_INPUT_PEN: u32 = 2305;
pub const PCI_CLASS_INPUT_MOUSE: u32 = 2306;
pub const PCI_CLASS_INPUT_SCANNER: u32 = 2307;
pub const PCI_CLASS_INPUT_GAMEPORT: u32 = 2308;
pub const PCI_CLASS_INPUT_OTHER: u32 = 2432;
pub const PCI_BASE_CLASS_DOCKING: u32 = 10;
pub const PCI_CLASS_DOCKING_GENERIC: u32 = 2560;
pub const PCI_CLASS_DOCKING_OTHER: u32 = 2688;
pub const PCI_BASE_CLASS_PROCESSOR: u32 = 11;
pub const PCI_CLASS_PROCESSOR_386: u32 = 2816;
pub const PCI_CLASS_PROCESSOR_486: u32 = 2817;
pub const PCI_CLASS_PROCESSOR_PENTIUM: u32 = 2818;
pub const PCI_CLASS_PROCESSOR_ALPHA: u32 = 2832;
pub const PCI_CLASS_PROCESSOR_POWERPC: u32 = 2848;
pub const PCI_CLASS_PROCESSOR_MIPS: u32 = 2864;
pub const PCI_CLASS_PROCESSOR_CO: u32 = 2880;
pub const PCI_BASE_CLASS_SERIAL: u32 = 12;
pub const PCI_CLASS_SERIAL_FIREWIRE: u32 = 3072;
pub const PCI_CLASS_SERIAL_FIREWIRE_OHCI: u32 = 786448;
pub const PCI_CLASS_SERIAL_ACCESS: u32 = 3073;
pub const PCI_CLASS_SERIAL_SSA: u32 = 3074;
pub const PCI_CLASS_SERIAL_USB: u32 = 3075;
pub const PCI_CLASS_SERIAL_USB_UHCI: u32 = 787200;
pub const PCI_CLASS_SERIAL_USB_OHCI: u32 = 787216;
pub const PCI_CLASS_SERIAL_USB_EHCI: u32 = 787232;
pub const PCI_CLASS_SERIAL_USB_XHCI: u32 = 787248;
pub const PCI_CLASS_SERIAL_USB_CDNS: u32 = 787328;
pub const PCI_CLASS_SERIAL_USB_DEVICE: u32 = 787454;
pub const PCI_CLASS_SERIAL_FIBER: u32 = 3076;
pub const PCI_CLASS_SERIAL_SMBUS: u32 = 3077;
pub const PCI_CLASS_SERIAL_IPMI: u32 = 3079;
pub const PCI_CLASS_SERIAL_IPMI_SMIC: u32 = 788224;
pub const PCI_CLASS_SERIAL_IPMI_KCS: u32 = 788225;
pub const PCI_CLASS_SERIAL_IPMI_BT: u32 = 788226;
pub const PCI_BASE_CLASS_WIRELESS: u32 = 13;
pub const PCI_CLASS_WIRELESS_RF_CONTROLLER: u32 = 3344;
pub const PCI_CLASS_WIRELESS_WHCI: u32 = 856080;
pub const PCI_BASE_CLASS_INTELLIGENT: u32 = 14;
pub const PCI_CLASS_INTELLIGENT_I2O: u32 = 3584;
pub const PCI_BASE_CLASS_SATELLITE: u32 = 15;
pub const PCI_CLASS_SATELLITE_TV: u32 = 3840;
pub const PCI_CLASS_SATELLITE_AUDIO: u32 = 3841;
pub const PCI_CLASS_SATELLITE_VOICE: u32 = 3843;
pub const PCI_CLASS_SATELLITE_DATA: u32 = 3844;
pub const PCI_BASE_CLASS_CRYPT: u32 = 16;
pub const PCI_CLASS_CRYPT_NETWORK: u32 = 4096;
pub const PCI_CLASS_CRYPT_ENTERTAINMENT: u32 = 4097;
pub const PCI_CLASS_CRYPT_OTHER: u32 = 4224;
pub const PCI_BASE_CLASS_SIGNAL_PROCESSING: u32 = 17;
pub const PCI_CLASS_SP_DPIO: u32 = 4352;
pub const PCI_CLASS_SP_OTHER: u32 = 4480;
pub const PCI_BASE_CLASS_ACCELERATOR: u32 = 18;
pub const PCI_CLASS_ACCELERATOR_PROCESSING: u32 = 4608;
pub const PCI_CLASS_OTHERS: u32 = 255;
pub const PCI_VENDOR_ID_PCI_SIG: u32 = 1;
pub const PCI_VENDOR_ID_LOONGSON: u32 = 20;
pub const PCI_DEVICE_ID_LOONGSON_HDA: u32 = 31239;
pub const PCI_DEVICE_ID_LOONGSON_HDMI: u32 = 31287;
pub const PCI_VENDOR_ID_SOLIDIGM: u32 = 606;
pub const PCI_VENDOR_ID_TTTECH: u32 = 855;
pub const PCI_DEVICE_ID_TTTECH_MC322: u32 = 10;
pub const PCI_VENDOR_ID_DYNALINK: u32 = 1653;
pub const PCI_DEVICE_ID_DYNALINK_IS64PH: u32 = 5890;
pub const PCI_VENDOR_ID_UBIQUITI: u32 = 1911;
pub const PCI_VENDOR_ID_BERKOM: u32 = 2161;
pub const PCI_DEVICE_ID_BERKOM_A1T: u32 = 65441;
pub const PCI_DEVICE_ID_BERKOM_T_CONCEPT: u32 = 65442;
pub const PCI_DEVICE_ID_BERKOM_A4T: u32 = 65444;
pub const PCI_DEVICE_ID_BERKOM_SCITEL_QUADRO: u32 = 65448;
pub const PCI_VENDOR_ID_ITTIM: u32 = 2888;
pub const PCI_VENDOR_ID_COMPAQ: u32 = 3601;
pub const PCI_DEVICE_ID_COMPAQ_TOKENRING: u32 = 1288;
pub const PCI_DEVICE_ID_COMPAQ_TACHYON: u32 = 41212;
pub const PCI_DEVICE_ID_COMPAQ_SMART2P: u32 = 44560;
pub const PCI_DEVICE_ID_COMPAQ_NETEL100: u32 = 44594;
pub const PCI_DEVICE_ID_COMPAQ_NETEL10: u32 = 44596;
pub const PCI_DEVICE_ID_COMPAQ_TRIFLEX_IDE: u32 = 44595;
pub const PCI_DEVICE_ID_COMPAQ_NETFLEX3I: u32 = 44597;
pub const PCI_DEVICE_ID_COMPAQ_NETEL100D: u32 = 44608;
pub const PCI_DEVICE_ID_COMPAQ_NETEL100PI: u32 = 44611;
pub const PCI_DEVICE_ID_COMPAQ_NETEL100I: u32 = 45073;
pub const PCI_DEVICE_ID_COMPAQ_CISS: u32 = 45152;
pub const PCI_DEVICE_ID_COMPAQ_CISSB: u32 = 45432;
pub const PCI_DEVICE_ID_COMPAQ_CISSC: u32 = 70;
pub const PCI_DEVICE_ID_COMPAQ_THUNDER: u32 = 61744;
pub const PCI_DEVICE_ID_COMPAQ_NETFLEX3B: u32 = 61776;
pub const PCI_VENDOR_ID_NCR: u32 = 4096;
pub const PCI_VENDOR_ID_LSI_LOGIC: u32 = 4096;
pub const PCI_DEVICE_ID_NCR_53C810: u32 = 1;
pub const PCI_DEVICE_ID_NCR_53C820: u32 = 2;
pub const PCI_DEVICE_ID_NCR_53C825: u32 = 3;
pub const PCI_DEVICE_ID_NCR_53C815: u32 = 4;
pub const PCI_DEVICE_ID_LSI_53C810AP: u32 = 5;
pub const PCI_DEVICE_ID_NCR_53C860: u32 = 6;
pub const PCI_DEVICE_ID_LSI_53C1510: u32 = 10;
pub const PCI_DEVICE_ID_NCR_53C896: u32 = 11;
pub const PCI_DEVICE_ID_NCR_53C895: u32 = 12;
pub const PCI_DEVICE_ID_NCR_53C885: u32 = 13;
pub const PCI_DEVICE_ID_NCR_53C875: u32 = 15;
pub const PCI_DEVICE_ID_NCR_53C1510: u32 = 16;
pub const PCI_DEVICE_ID_LSI_53C895A: u32 = 18;
pub const PCI_DEVICE_ID_LSI_53C875A: u32 = 19;
pub const PCI_DEVICE_ID_LSI_53C1010_33: u32 = 32;
pub const PCI_DEVICE_ID_LSI_53C1010_66: u32 = 33;
pub const PCI_DEVICE_ID_LSI_53C1030: u32 = 48;
pub const PCI_DEVICE_ID_LSI_1030_53C1035: u32 = 50;
pub const PCI_DEVICE_ID_LSI_53C1035: u32 = 64;
pub const PCI_DEVICE_ID_NCR_53C875J: u32 = 143;
pub const PCI_DEVICE_ID_LSI_FC909: u32 = 1569;
pub const PCI_DEVICE_ID_LSI_FC929: u32 = 1570;
pub const PCI_DEVICE_ID_LSI_FC929_LAN: u32 = 1571;
pub const PCI_DEVICE_ID_LSI_FC919: u32 = 1572;
pub const PCI_DEVICE_ID_LSI_FC919_LAN: u32 = 1573;
pub const PCI_DEVICE_ID_LSI_FC929X: u32 = 1574;
pub const PCI_DEVICE_ID_LSI_FC939X: u32 = 1602;
pub const PCI_DEVICE_ID_LSI_FC949X: u32 = 1600;
pub const PCI_DEVICE_ID_LSI_FC949ES: u32 = 1606;
pub const PCI_DEVICE_ID_LSI_FC919X: u32 = 1576;
pub const PCI_DEVICE_ID_NCR_YELLOWFIN: u32 = 1793;
pub const PCI_DEVICE_ID_LSI_61C102: u32 = 2305;
pub const PCI_DEVICE_ID_LSI_63C815: u32 = 4096;
pub const PCI_DEVICE_ID_LSI_SAS1064: u32 = 80;
pub const PCI_DEVICE_ID_LSI_SAS1064R: u32 = 1041;
pub const PCI_DEVICE_ID_LSI_SAS1066: u32 = 94;
pub const PCI_DEVICE_ID_LSI_SAS1068: u32 = 84;
pub const PCI_DEVICE_ID_LSI_SAS1064A: u32 = 92;
pub const PCI_DEVICE_ID_LSI_SAS1064E: u32 = 86;
pub const PCI_DEVICE_ID_LSI_SAS1066E: u32 = 90;
pub const PCI_DEVICE_ID_LSI_SAS1068E: u32 = 88;
pub const PCI_DEVICE_ID_LSI_SAS1078: u32 = 96;
pub const PCI_VENDOR_ID_ATI: u32 = 4098;
pub const PCI_DEVICE_ID_ATI_68800: u32 = 16728;
pub const PCI_DEVICE_ID_ATI_215CT222: u32 = 17236;
pub const PCI_DEVICE_ID_ATI_210888CX: u32 = 17240;
pub const PCI_DEVICE_ID_ATI_215ET222: u32 = 17748;
pub const PCI_DEVICE_ID_ATI_215GB: u32 = 18242;
pub const PCI_DEVICE_ID_ATI_215GD: u32 = 18244;
pub const PCI_DEVICE_ID_ATI_215GI: u32 = 18249;
pub const PCI_DEVICE_ID_ATI_215GP: u32 = 18256;
pub const PCI_DEVICE_ID_ATI_215GQ: u32 = 18257;
pub const PCI_DEVICE_ID_ATI_215XL: u32 = 18258;
pub const PCI_DEVICE_ID_ATI_215GT: u32 = 18260;
pub const PCI_DEVICE_ID_ATI_215GTB: u32 = 18261;
pub const PCI_DEVICE_ID_ATI_215_IV: u32 = 18262;
pub const PCI_DEVICE_ID_ATI_215_IW: u32 = 18263;
pub const PCI_DEVICE_ID_ATI_215_IZ: u32 = 18266;
pub const PCI_DEVICE_ID_ATI_210888GX: u32 = 18264;
pub const PCI_DEVICE_ID_ATI_215_LB: u32 = 19522;
pub const PCI_DEVICE_ID_ATI_215_LD: u32 = 19524;
pub const PCI_DEVICE_ID_ATI_215_LG: u32 = 19527;
pub const PCI_DEVICE_ID_ATI_215_LI: u32 = 19529;
pub const PCI_DEVICE_ID_ATI_215_LM: u32 = 19533;
pub const PCI_DEVICE_ID_ATI_215_LN: u32 = 19534;
pub const PCI_DEVICE_ID_ATI_215_LR: u32 = 19538;
pub const PCI_DEVICE_ID_ATI_215_LS: u32 = 19539;
pub const PCI_DEVICE_ID_ATI_264_LT: u32 = 19540;
pub const PCI_DEVICE_ID_ATI_264VT: u32 = 22100;
pub const PCI_DEVICE_ID_ATI_264VU: u32 = 22101;
pub const PCI_DEVICE_ID_ATI_264VV: u32 = 22102;
pub const PCI_DEVICE_ID_ATI_RAGE128_RE: u32 = 21061;
pub const PCI_DEVICE_ID_ATI_RAGE128_RF: u32 = 21062;
pub const PCI_DEVICE_ID_ATI_RAGE128_RG: u32 = 21063;
pub const PCI_DEVICE_ID_ATI_RAGE128_RK: u32 = 21067;
pub const PCI_DEVICE_ID_ATI_RAGE128_RL: u32 = 21068;
pub const PCI_DEVICE_ID_ATI_RAGE128_SE: u32 = 21317;
pub const PCI_DEVICE_ID_ATI_RAGE128_SF: u32 = 21318;
pub const PCI_DEVICE_ID_ATI_RAGE128_SG: u32 = 21319;
pub const PCI_DEVICE_ID_ATI_RAGE128_SH: u32 = 21320;
pub const PCI_DEVICE_ID_ATI_RAGE128_SK: u32 = 21323;
pub const PCI_DEVICE_ID_ATI_RAGE128_SL: u32 = 21324;
pub const PCI_DEVICE_ID_ATI_RAGE128_SM: u32 = 21325;
pub const PCI_DEVICE_ID_ATI_RAGE128_SN: u32 = 21326;
pub const PCI_DEVICE_ID_ATI_RAGE128_TF: u32 = 21574;
pub const PCI_DEVICE_ID_ATI_RAGE128_TL: u32 = 21580;
pub const PCI_DEVICE_ID_ATI_RAGE128_TR: u32 = 21586;
pub const PCI_DEVICE_ID_ATI_RAGE128_TS: u32 = 21587;
pub const PCI_DEVICE_ID_ATI_RAGE128_TT: u32 = 21588;
pub const PCI_DEVICE_ID_ATI_RAGE128_TU: u32 = 21589;
pub const PCI_DEVICE_ID_ATI_RAGE128_LE: u32 = 19525;
pub const PCI_DEVICE_ID_ATI_RAGE128_LF: u32 = 19526;
pub const PCI_DEVICE_ID_ATI_RAGE128_MF: u32 = 19782;
pub const PCI_DEVICE_ID_ATI_RAGE128_ML: u32 = 19788;
pub const PCI_DEVICE_ID_ATI_RAGE128_PA: u32 = 20545;
pub const PCI_DEVICE_ID_ATI_RAGE128_PB: u32 = 20546;
pub const PCI_DEVICE_ID_ATI_RAGE128_PC: u32 = 20547;
pub const PCI_DEVICE_ID_ATI_RAGE128_PD: u32 = 20548;
pub const PCI_DEVICE_ID_ATI_RAGE128_PE: u32 = 20549;
pub const PCI_DEVICE_ID_ATI_RAGE128_PF: u32 = 20550;
pub const PCI_DEVICE_ID_ATI_RAGE128_PG: u32 = 20551;
pub const PCI_DEVICE_ID_ATI_RAGE128_PH: u32 = 20552;
pub const PCI_DEVICE_ID_ATI_RAGE128_PI: u32 = 20553;
pub const PCI_DEVICE_ID_ATI_RAGE128_PJ: u32 = 20554;
pub const PCI_DEVICE_ID_ATI_RAGE128_PK: u32 = 20555;
pub const PCI_DEVICE_ID_ATI_RAGE128_PL: u32 = 20556;
pub const PCI_DEVICE_ID_ATI_RAGE128_PM: u32 = 20557;
pub const PCI_DEVICE_ID_ATI_RAGE128_PN: u32 = 20558;
pub const PCI_DEVICE_ID_ATI_RAGE128_PO: u32 = 20559;
pub const PCI_DEVICE_ID_ATI_RAGE128_PP: u32 = 20560;
pub const PCI_DEVICE_ID_ATI_RAGE128_PQ: u32 = 20561;
pub const PCI_DEVICE_ID_ATI_RAGE128_PR: u32 = 20562;
pub const PCI_DEVICE_ID_ATI_RAGE128_PS: u32 = 20563;
pub const PCI_DEVICE_ID_ATI_RAGE128_PT: u32 = 20564;
pub const PCI_DEVICE_ID_ATI_RAGE128_PU: u32 = 20565;
pub const PCI_DEVICE_ID_ATI_RAGE128_PV: u32 = 20566;
pub const PCI_DEVICE_ID_ATI_RAGE128_PW: u32 = 20567;
pub const PCI_DEVICE_ID_ATI_RAGE128_PX: u32 = 20568;
pub const PCI_DEVICE_ID_ATI_RADEON_QD: u32 = 20804;
pub const PCI_DEVICE_ID_ATI_RADEON_QE: u32 = 20805;
pub const PCI_DEVICE_ID_ATI_RADEON_QF: u32 = 20806;
pub const PCI_DEVICE_ID_ATI_RADEON_QG: u32 = 20807;
pub const PCI_DEVICE_ID_ATI_RADEON_QY: u32 = 20825;
pub const PCI_DEVICE_ID_ATI_RADEON_QZ: u32 = 20826;
pub const PCI_DEVICE_ID_ATI_RADEON_QL: u32 = 20812;
pub const PCI_DEVICE_ID_ATI_RADEON_QN: u32 = 20814;
pub const PCI_DEVICE_ID_ATI_RADEON_QO: u32 = 20815;
pub const PCI_DEVICE_ID_ATI_RADEON_Ql: u32 = 20844;
pub const PCI_DEVICE_ID_ATI_RADEON_BB: u32 = 16962;
pub const PCI_DEVICE_ID_ATI_RADEON_QM: u32 = 20813;
pub const PCI_DEVICE_ID_ATI_RADEON_QW: u32 = 20823;
pub const PCI_DEVICE_ID_ATI_RADEON_QX: u32 = 20824;
pub const PCI_DEVICE_ID_ATI_RADEON_Id: u32 = 18788;
pub const PCI_DEVICE_ID_ATI_RADEON_Ie: u32 = 18789;
pub const PCI_DEVICE_ID_ATI_RADEON_If: u32 = 18790;
pub const PCI_DEVICE_ID_ATI_RADEON_Ig: u32 = 18791;
pub const PCI_DEVICE_ID_ATI_RADEON_Ya: u32 = 22881;
pub const PCI_DEVICE_ID_ATI_RADEON_Yd: u32 = 22884;
pub const PCI_DEVICE_ID_ATI_RADEON_ND: u32 = 20036;
pub const PCI_DEVICE_ID_ATI_RADEON_NE: u32 = 20037;
pub const PCI_DEVICE_ID_ATI_RADEON_NF: u32 = 20038;
pub const PCI_DEVICE_ID_ATI_RADEON_NG: u32 = 20039;
pub const PCI_DEVICE_ID_ATI_RADEON_LY: u32 = 19545;
pub const PCI_DEVICE_ID_ATI_RADEON_LZ: u32 = 19546;
pub const PCI_DEVICE_ID_ATI_RADEON_LW: u32 = 19543;
pub const PCI_DEVICE_ID_ATI_RADEON_LX: u32 = 19544;
pub const PCI_DEVICE_ID_ATI_RADEON_Ld: u32 = 19556;
pub const PCI_DEVICE_ID_ATI_RADEON_Le: u32 = 19557;
pub const PCI_DEVICE_ID_ATI_RADEON_Lf: u32 = 19558;
pub const PCI_DEVICE_ID_ATI_RADEON_Lg: u32 = 19559;
pub const PCI_DEVICE_ID_ATI_RS100: u32 = 51888;
pub const PCI_DEVICE_ID_ATI_RS200: u32 = 51890;
pub const PCI_DEVICE_ID_ATI_RS200_B: u32 = 52146;
pub const PCI_DEVICE_ID_ATI_RS250: u32 = 51891;
pub const PCI_DEVICE_ID_ATI_RS300_100: u32 = 22576;
pub const PCI_DEVICE_ID_ATI_RS300_133: u32 = 22577;
pub const PCI_DEVICE_ID_ATI_RS300_166: u32 = 22578;
pub const PCI_DEVICE_ID_ATI_RS300_200: u32 = 22579;
pub const PCI_DEVICE_ID_ATI_RS350_100: u32 = 30768;
pub const PCI_DEVICE_ID_ATI_RS350_133: u32 = 30769;
pub const PCI_DEVICE_ID_ATI_RS350_166: u32 = 30770;
pub const PCI_DEVICE_ID_ATI_RS350_200: u32 = 30771;
pub const PCI_DEVICE_ID_ATI_RS400_100: u32 = 23088;
pub const PCI_DEVICE_ID_ATI_RS400_133: u32 = 23089;
pub const PCI_DEVICE_ID_ATI_RS400_166: u32 = 23090;
pub const PCI_DEVICE_ID_ATI_RS400_200: u32 = 23091;
pub const PCI_DEVICE_ID_ATI_RS480: u32 = 22864;
pub const PCI_DEVICE_ID_ATI_IXP200_IDE: u32 = 17225;
pub const PCI_DEVICE_ID_ATI_IXP200_SMBUS: u32 = 17235;
pub const PCI_DEVICE_ID_ATI_IXP300_SMBUS: u32 = 17251;
pub const PCI_DEVICE_ID_ATI_IXP300_IDE: u32 = 17257;
pub const PCI_DEVICE_ID_ATI_IXP300_SATA: u32 = 17262;
pub const PCI_DEVICE_ID_ATI_IXP400_SMBUS: u32 = 17266;
pub const PCI_DEVICE_ID_ATI_IXP400_IDE: u32 = 17270;
pub const PCI_DEVICE_ID_ATI_IXP400_SATA: u32 = 17273;
pub const PCI_DEVICE_ID_ATI_IXP400_SATA2: u32 = 17274;
pub const PCI_DEVICE_ID_ATI_IXP600_SATA: u32 = 17280;
pub const PCI_DEVICE_ID_ATI_SBX00_SMBUS: u32 = 17285;
pub const PCI_DEVICE_ID_ATI_IXP600_IDE: u32 = 17292;
pub const PCI_DEVICE_ID_ATI_IXP700_SATA: u32 = 17296;
pub const PCI_DEVICE_ID_ATI_IXP700_IDE: u32 = 17308;
pub const PCI_VENDOR_ID_VLSI: u32 = 4100;
pub const PCI_DEVICE_ID_VLSI_82C592: u32 = 5;
pub const PCI_DEVICE_ID_VLSI_82C593: u32 = 6;
pub const PCI_DEVICE_ID_VLSI_82C594: u32 = 7;
pub const PCI_DEVICE_ID_VLSI_82C597: u32 = 9;
pub const PCI_DEVICE_ID_VLSI_82C541: u32 = 12;
pub const PCI_DEVICE_ID_VLSI_82C543: u32 = 13;
pub const PCI_DEVICE_ID_VLSI_82C532: u32 = 257;
pub const PCI_DEVICE_ID_VLSI_82C534: u32 = 258;
pub const PCI_DEVICE_ID_VLSI_82C535: u32 = 260;
pub const PCI_DEVICE_ID_VLSI_82C147: u32 = 261;
pub const PCI_DEVICE_ID_VLSI_VAS96011: u32 = 1794;
pub const PCI_DEVICE_ID_RD890_IOMMU: u32 = 23075;
pub const PCI_VENDOR_ID_ADL: u32 = 4101;
pub const PCI_DEVICE_ID_ADL_2301: u32 = 8961;
pub const PCI_VENDOR_ID_NS: u32 = 4107;
pub const PCI_DEVICE_ID_NS_87415: u32 = 2;
pub const PCI_DEVICE_ID_NS_87560_LIO: u32 = 14;
pub const PCI_DEVICE_ID_NS_87560_USB: u32 = 18;
pub const PCI_DEVICE_ID_NS_83815: u32 = 32;
pub const PCI_DEVICE_ID_NS_83820: u32 = 34;
pub const PCI_DEVICE_ID_NS_CS5535_ISA: u32 = 43;
pub const PCI_DEVICE_ID_NS_CS5535_IDE: u32 = 45;
pub const PCI_DEVICE_ID_NS_CS5535_AUDIO: u32 = 46;
pub const PCI_DEVICE_ID_NS_CS5535_USB: u32 = 47;
pub const PCI_DEVICE_ID_NS_GX_VIDEO: u32 = 48;
pub const PCI_DEVICE_ID_NS_SATURN: u32 = 53;
pub const PCI_DEVICE_ID_NS_SCx200_BRIDGE: u32 = 1280;
pub const PCI_DEVICE_ID_NS_SCx200_SMI: u32 = 1281;
pub const PCI_DEVICE_ID_NS_SCx200_IDE: u32 = 1282;
pub const PCI_DEVICE_ID_NS_SCx200_AUDIO: u32 = 1283;
pub const PCI_DEVICE_ID_NS_SCx200_VIDEO: u32 = 1284;
pub const PCI_DEVICE_ID_NS_SCx200_XBUS: u32 = 1285;
pub const PCI_DEVICE_ID_NS_SC1100_BRIDGE: u32 = 1296;
pub const PCI_DEVICE_ID_NS_SC1100_SMI: u32 = 1297;
pub const PCI_DEVICE_ID_NS_SC1100_XBUS: u32 = 1301;
pub const PCI_DEVICE_ID_NS_87410: u32 = 53249;
pub const PCI_DEVICE_ID_NS_GX_HOST_BRIDGE: u32 = 40;
pub const PCI_VENDOR_ID_TSENG: u32 = 4108;
pub const PCI_DEVICE_ID_TSENG_W32P_2: u32 = 12802;
pub const PCI_DEVICE_ID_TSENG_W32P_b: u32 = 12805;
pub const PCI_DEVICE_ID_TSENG_W32P_c: u32 = 12806;
pub const PCI_DEVICE_ID_TSENG_W32P_d: u32 = 12807;
pub const PCI_DEVICE_ID_TSENG_ET6000: u32 = 12808;
pub const PCI_VENDOR_ID_WEITEK: u32 = 4110;
pub const PCI_DEVICE_ID_WEITEK_P9000: u32 = 36865;
pub const PCI_DEVICE_ID_WEITEK_P9100: u32 = 37120;
pub const PCI_VENDOR_ID_DEC: u32 = 4113;
pub const PCI_DEVICE_ID_DEC_BRD: u32 = 1;
pub const PCI_DEVICE_ID_DEC_TULIP: u32 = 2;
pub const PCI_DEVICE_ID_DEC_TGA: u32 = 4;
pub const PCI_DEVICE_ID_DEC_TULIP_FAST: u32 = 9;
pub const PCI_DEVICE_ID_DEC_TGA2: u32 = 13;
pub const PCI_DEVICE_ID_DEC_FDDI: u32 = 15;
pub const PCI_DEVICE_ID_DEC_TULIP_PLUS: u32 = 20;
pub const PCI_DEVICE_ID_DEC_21142: u32 = 25;
pub const PCI_DEVICE_ID_DEC_21052: u32 = 33;
pub const PCI_DEVICE_ID_DEC_21150: u32 = 34;
pub const PCI_DEVICE_ID_DEC_21152: u32 = 36;
pub const PCI_DEVICE_ID_DEC_21153: u32 = 37;
pub const PCI_DEVICE_ID_DEC_21154: u32 = 38;
pub const PCI_DEVICE_ID_DEC_21285: u32 = 4197;
pub const PCI_DEVICE_ID_COMPAQ_42XX: u32 = 70;
pub const PCI_VENDOR_ID_CIRRUS: u32 = 4115;
pub const PCI_DEVICE_ID_CIRRUS_7548: u32 = 56;
pub const PCI_DEVICE_ID_CIRRUS_5430: u32 = 160;
pub const PCI_DEVICE_ID_CIRRUS_5434_4: u32 = 164;
pub const PCI_DEVICE_ID_CIRRUS_5434_8: u32 = 168;
pub const PCI_DEVICE_ID_CIRRUS_5436: u32 = 172;
pub const PCI_DEVICE_ID_CIRRUS_5446: u32 = 184;
pub const PCI_DEVICE_ID_CIRRUS_5480: u32 = 188;
pub const PCI_DEVICE_ID_CIRRUS_5462: u32 = 208;
pub const PCI_DEVICE_ID_CIRRUS_5464: u32 = 212;
pub const PCI_DEVICE_ID_CIRRUS_5465: u32 = 214;
pub const PCI_DEVICE_ID_CIRRUS_6729: u32 = 4352;
pub const PCI_DEVICE_ID_CIRRUS_6832: u32 = 4368;
pub const PCI_DEVICE_ID_CIRRUS_7543: u32 = 4610;
pub const PCI_DEVICE_ID_CIRRUS_4610: u32 = 24577;
pub const PCI_DEVICE_ID_CIRRUS_4612: u32 = 24579;
pub const PCI_DEVICE_ID_CIRRUS_4615: u32 = 24580;
pub const PCI_VENDOR_ID_IBM: u32 = 4116;
pub const PCI_DEVICE_ID_IBM_TR: u32 = 24;
pub const PCI_DEVICE_ID_IBM_TR_WAKE: u32 = 62;
pub const PCI_DEVICE_ID_IBM_CPC710_PCI64: u32 = 252;
pub const PCI_DEVICE_ID_IBM_SNIPE: u32 = 384;
pub const PCI_DEVICE_ID_IBM_CITRINE: u32 = 652;
pub const PCI_DEVICE_ID_IBM_GEMSTONE: u32 = 45414;
pub const PCI_DEVICE_ID_IBM_OBSIDIAN: u32 = 701;
pub const PCI_DEVICE_ID_IBM_ICOM_DEV_ID_1: u32 = 49;
pub const PCI_DEVICE_ID_IBM_ICOM_DEV_ID_2: u32 = 537;
pub const PCI_DEVICE_ID_IBM_ICOM_V2_TWO_PORTS_RVX: u32 = 538;
pub const PCI_DEVICE_ID_IBM_ICOM_V2_ONE_PORT_RVX_ONE_PORT_MDM: u32 = 593;
pub const PCI_DEVICE_ID_IBM_ICOM_V2_ONE_PORT_RVX_ONE_PORT_MDM_PCIE: u32 = 865;
pub const PCI_DEVICE_ID_IBM_ICOM_FOUR_PORT_MODEL: u32 = 594;
pub const PCI_DEVICE_ID_IBM_ISM: u32 = 1261;
pub const PCI_SUBVENDOR_ID_IBM: u32 = 4116;
pub const PCI_SUBDEVICE_ID_IBM_SATURN_SERIAL_ONE_PORT: u32 = 980;
pub const PCI_VENDOR_ID_UNISYS: u32 = 4120;
pub const PCI_DEVICE_ID_UNISYS_DMA_DIRECTOR: u32 = 28;
pub const PCI_VENDOR_ID_COMPEX2: u32 = 4122;
pub const PCI_DEVICE_ID_COMPEX2_100VG: u32 = 5;
pub const PCI_VENDOR_ID_WD: u32 = 4124;
pub const PCI_DEVICE_ID_WD_90C: u32 = 49738;
pub const PCI_VENDOR_ID_AMI: u32 = 4126;
pub const PCI_DEVICE_ID_AMI_MEGARAID3: u32 = 6496;
pub const PCI_DEVICE_ID_AMI_MEGARAID: u32 = 36880;
pub const PCI_DEVICE_ID_AMI_MEGARAID2: u32 = 36960;
pub const PCI_VENDOR_ID_AMD: u32 = 4130;
pub const PCI_DEVICE_ID_AMD_K8_NB: u32 = 4352;
pub const PCI_DEVICE_ID_AMD_K8_NB_ADDRMAP: u32 = 4353;
pub const PCI_DEVICE_ID_AMD_K8_NB_MEMCTL: u32 = 4354;
pub const PCI_DEVICE_ID_AMD_K8_NB_MISC: u32 = 4355;
pub const PCI_DEVICE_ID_AMD_10H_NB_HT: u32 = 4608;
pub const PCI_DEVICE_ID_AMD_10H_NB_MAP: u32 = 4609;
pub const PCI_DEVICE_ID_AMD_10H_NB_DRAM: u32 = 4610;
pub const PCI_DEVICE_ID_AMD_10H_NB_MISC: u32 = 4611;
pub const PCI_DEVICE_ID_AMD_10H_NB_LINK: u32 = 4612;
pub const PCI_DEVICE_ID_AMD_11H_NB_HT: u32 = 4864;
pub const PCI_DEVICE_ID_AMD_11H_NB_MAP: u32 = 4865;
pub const PCI_DEVICE_ID_AMD_11H_NB_DRAM: u32 = 4866;
pub const PCI_DEVICE_ID_AMD_11H_NB_MISC: u32 = 4867;
pub const PCI_DEVICE_ID_AMD_11H_NB_LINK: u32 = 4868;
pub const PCI_DEVICE_ID_AMD_15H_M10H_F3: u32 = 5123;
pub const PCI_DEVICE_ID_AMD_15H_M30H_NB_F3: u32 = 5149;
pub const PCI_DEVICE_ID_AMD_15H_M30H_NB_F4: u32 = 5150;
pub const PCI_DEVICE_ID_AMD_15H_M60H_NB_F3: u32 = 5491;
pub const PCI_DEVICE_ID_AMD_15H_M60H_NB_F4: u32 = 5492;
pub const PCI_DEVICE_ID_AMD_15H_NB_F0: u32 = 5632;
pub const PCI_DEVICE_ID_AMD_15H_NB_F1: u32 = 5633;
pub const PCI_DEVICE_ID_AMD_15H_NB_F2: u32 = 5634;
pub const PCI_DEVICE_ID_AMD_15H_NB_F3: u32 = 5635;
pub const PCI_DEVICE_ID_AMD_15H_NB_F4: u32 = 5636;
pub const PCI_DEVICE_ID_AMD_15H_NB_F5: u32 = 5637;
pub const PCI_DEVICE_ID_AMD_16H_NB_F3: u32 = 5427;
pub const PCI_DEVICE_ID_AMD_16H_NB_F4: u32 = 5428;
pub const PCI_DEVICE_ID_AMD_16H_M30H_NB_F3: u32 = 5507;
pub const PCI_DEVICE_ID_AMD_16H_M30H_NB_F4: u32 = 5508;
pub const PCI_DEVICE_ID_AMD_17H_DF_F3: u32 = 5219;
pub const PCI_DEVICE_ID_AMD_17H_M10H_DF_F3: u32 = 5611;
pub const PCI_DEVICE_ID_AMD_17H_M30H_DF_F3: u32 = 5267;
pub const PCI_DEVICE_ID_AMD_17H_M40H_DF_F3: u32 = 5107;
pub const PCI_DEVICE_ID_AMD_17H_M60H_DF_F3: u32 = 5195;
pub const PCI_DEVICE_ID_AMD_17H_M70H_DF_F3: u32 = 5187;
pub const PCI_DEVICE_ID_AMD_17H_MA0H_DF_F3: u32 = 5927;
pub const PCI_DEVICE_ID_AMD_19H_DF_F3: u32 = 5715;
pub const PCI_DEVICE_ID_AMD_19H_M10H_DF_F3: u32 = 5296;
pub const PCI_DEVICE_ID_AMD_19H_M40H_DF_F3: u32 = 5756;
pub const PCI_DEVICE_ID_AMD_19H_M50H_DF_F3: u32 = 5741;
pub const PCI_DEVICE_ID_AMD_19H_M60H_DF_F3: u32 = 5347;
pub const PCI_DEVICE_ID_AMD_19H_M70H_DF_F3: u32 = 5363;
pub const PCI_DEVICE_ID_AMD_19H_M78H_DF_F3: u32 = 4859;
pub const PCI_DEVICE_ID_AMD_1AH_M00H_DF_F3: u32 = 4803;
pub const PCI_DEVICE_ID_AMD_1AH_M20H_DF_F3: u32 = 5883;
pub const PCI_DEVICE_ID_AMD_1AH_M60H_DF_F3: u32 = 4683;
pub const PCI_DEVICE_ID_AMD_1AH_M70H_DF_F3: u32 = 4795;
pub const PCI_DEVICE_ID_AMD_MI200_DF_F3: u32 = 5331;
pub const PCI_DEVICE_ID_AMD_MI300_DF_F3: u32 = 5419;
pub const PCI_DEVICE_ID_AMD_VANGOGH_USB: u32 = 5690;
pub const PCI_DEVICE_ID_AMD_CNB17H_F3: u32 = 5891;
pub const PCI_DEVICE_ID_AMD_LANCE: u32 = 8192;
pub const PCI_DEVICE_ID_AMD_LANCE_HOME: u32 = 8193;
pub const PCI_DEVICE_ID_AMD_SCSI: u32 = 8224;
pub const PCI_DEVICE_ID_AMD_SERENADE: u32 = 14016;
pub const PCI_DEVICE_ID_AMD_FE_GATE_7006: u32 = 28678;
pub const PCI_DEVICE_ID_AMD_FE_GATE_7007: u32 = 28679;
pub const PCI_DEVICE_ID_AMD_FE_GATE_700C: u32 = 28684;
pub const PCI_DEVICE_ID_AMD_FE_GATE_700E: u32 = 28686;
pub const PCI_DEVICE_ID_AMD_COBRA_7401: u32 = 29697;
pub const PCI_DEVICE_ID_AMD_VIPER_7409: u32 = 29705;
pub const PCI_DEVICE_ID_AMD_VIPER_740B: u32 = 29707;
pub const PCI_DEVICE_ID_AMD_VIPER_7410: u32 = 29712;
pub const PCI_DEVICE_ID_AMD_VIPER_7411: u32 = 29713;
pub const PCI_DEVICE_ID_AMD_VIPER_7413: u32 = 29715;
pub const PCI_DEVICE_ID_AMD_VIPER_7440: u32 = 29760;
pub const PCI_DEVICE_ID_AMD_OPUS_7441: u32 = 29761;
pub const PCI_DEVICE_ID_AMD_OPUS_7443: u32 = 29763;
pub const PCI_DEVICE_ID_AMD_VIPER_7443: u32 = 29763;
pub const PCI_DEVICE_ID_AMD_OPUS_7445: u32 = 29765;
pub const PCI_DEVICE_ID_AMD_GOLAM_7450: u32 = 29776;
pub const PCI_DEVICE_ID_AMD_8111_PCI: u32 = 29792;
pub const PCI_DEVICE_ID_AMD_8111_LPC: u32 = 29800;
pub const PCI_DEVICE_ID_AMD_8111_IDE: u32 = 29801;
pub const PCI_DEVICE_ID_AMD_8111_SMBUS2: u32 = 29802;
pub const PCI_DEVICE_ID_AMD_8111_SMBUS: u32 = 29803;
pub const PCI_DEVICE_ID_AMD_8111_AUDIO: u32 = 29805;
pub const PCI_DEVICE_ID_AMD_8151_0: u32 = 29780;
pub const PCI_DEVICE_ID_AMD_8131_BRIDGE: u32 = 29776;
pub const PCI_DEVICE_ID_AMD_8131_APIC: u32 = 29777;
pub const PCI_DEVICE_ID_AMD_8132_BRIDGE: u32 = 29784;
pub const PCI_DEVICE_ID_AMD_NL_USB: u32 = 30994;
pub const PCI_DEVICE_ID_AMD_CS5535_IDE: u32 = 8335;
pub const PCI_DEVICE_ID_AMD_CS5536_ISA: u32 = 8336;
pub const PCI_DEVICE_ID_AMD_CS5536_FLASH: u32 = 8337;
pub const PCI_DEVICE_ID_AMD_CS5536_AUDIO: u32 = 8339;
pub const PCI_DEVICE_ID_AMD_CS5536_OHC: u32 = 8340;
pub const PCI_DEVICE_ID_AMD_CS5536_EHC: u32 = 8341;
pub const PCI_DEVICE_ID_AMD_CS5536_UDC: u32 = 8342;
pub const PCI_DEVICE_ID_AMD_CS5536_UOC: u32 = 8343;
pub const PCI_DEVICE_ID_AMD_CS5536_DEV_IDE: u32 = 8338;
pub const PCI_DEVICE_ID_AMD_CS5536_IDE: u32 = 8346;
pub const PCI_DEVICE_ID_AMD_LX_VIDEO: u32 = 8321;
pub const PCI_DEVICE_ID_AMD_LX_AES: u32 = 8322;
pub const PCI_DEVICE_ID_AMD_HUDSON2_SATA_IDE: u32 = 30720;
pub const PCI_DEVICE_ID_AMD_HUDSON2_SMBUS: u32 = 30731;
pub const PCI_DEVICE_ID_AMD_HUDSON2_IDE: u32 = 30732;
pub const PCI_DEVICE_ID_AMD_KERNCZ_SMBUS: u32 = 30987;
pub const PCI_VENDOR_ID_TRIDENT: u32 = 4131;
pub const PCI_DEVICE_ID_TRIDENT_4DWAVE_DX: u32 = 8192;
pub const PCI_DEVICE_ID_TRIDENT_4DWAVE_NX: u32 = 8193;
pub const PCI_DEVICE_ID_TRIDENT_9320: u32 = 37664;
pub const PCI_DEVICE_ID_TRIDENT_9388: u32 = 37768;
pub const PCI_DEVICE_ID_TRIDENT_9397: u32 = 37783;
pub const PCI_DEVICE_ID_TRIDENT_939A: u32 = 37786;
pub const PCI_DEVICE_ID_TRIDENT_9520: u32 = 38176;
pub const PCI_DEVICE_ID_TRIDENT_9525: u32 = 38181;
pub const PCI_DEVICE_ID_TRIDENT_9420: u32 = 37920;
pub const PCI_DEVICE_ID_TRIDENT_9440: u32 = 37952;
pub const PCI_DEVICE_ID_TRIDENT_9660: u32 = 38496;
pub const PCI_DEVICE_ID_TRIDENT_9750: u32 = 38736;
pub const PCI_DEVICE_ID_TRIDENT_9850: u32 = 38992;
pub const PCI_DEVICE_ID_TRIDENT_9880: u32 = 39040;
pub const PCI_DEVICE_ID_TRIDENT_8400: u32 = 33792;
pub const PCI_DEVICE_ID_TRIDENT_8420: u32 = 33824;
pub const PCI_DEVICE_ID_TRIDENT_8500: u32 = 34048;
pub const PCI_VENDOR_ID_AI: u32 = 4133;
pub const PCI_DEVICE_ID_AI_M1435: u32 = 5173;
pub const PCI_VENDOR_ID_DELL: u32 = 4136;
pub const PCI_DEVICE_ID_DELL_RACIII: u32 = 8;
pub const PCI_DEVICE_ID_DELL_RAC4: u32 = 18;
pub const PCI_DEVICE_ID_DELL_PERC5: u32 = 21;
pub const PCI_SUBVENDOR_ID_DELL: u32 = 4136;
pub const PCI_VENDOR_ID_MATROX: u32 = 4139;
pub const PCI_DEVICE_ID_MATROX_MGA_2: u32 = 1304;
pub const PCI_DEVICE_ID_MATROX_MIL: u32 = 1305;
pub const PCI_DEVICE_ID_MATROX_MYS: u32 = 1306;
pub const PCI_DEVICE_ID_MATROX_MIL_2: u32 = 1307;
pub const PCI_DEVICE_ID_MATROX_MYS_AGP: u32 = 1310;
pub const PCI_DEVICE_ID_MATROX_MIL_2_AGP: u32 = 1311;
pub const PCI_DEVICE_ID_MATROX_MGA_IMP: u32 = 3344;
pub const PCI_DEVICE_ID_MATROX_G100_MM: u32 = 4096;
pub const PCI_DEVICE_ID_MATROX_G100_AGP: u32 = 4097;
pub const PCI_DEVICE_ID_MATROX_G200_PCI: u32 = 1312;
pub const PCI_DEVICE_ID_MATROX_G200_AGP: u32 = 1313;
pub const PCI_DEVICE_ID_MATROX_G400: u32 = 1317;
pub const PCI_DEVICE_ID_MATROX_G200EV_PCI: u32 = 1328;
pub const PCI_DEVICE_ID_MATROX_G550: u32 = 9511;
pub const PCI_DEVICE_ID_MATROX_VIA: u32 = 17718;
pub const PCI_VENDOR_ID_MOBILITY_ELECTRONICS: u32 = 5362;
pub const PCI_VENDOR_ID_CT: u32 = 4140;
pub const PCI_DEVICE_ID_CT_69000: u32 = 192;
pub const PCI_DEVICE_ID_CT_65545: u32 = 216;
pub const PCI_DEVICE_ID_CT_65548: u32 = 220;
pub const PCI_DEVICE_ID_CT_65550: u32 = 224;
pub const PCI_DEVICE_ID_CT_65554: u32 = 228;
pub const PCI_DEVICE_ID_CT_65555: u32 = 229;
pub const PCI_VENDOR_ID_MIRO: u32 = 4145;
pub const PCI_DEVICE_ID_MIRO_36050: u32 = 22017;
pub const PCI_DEVICE_ID_MIRO_DC10PLUS: u32 = 32510;
pub const PCI_DEVICE_ID_MIRO_DC30PLUS: u32 = 55297;
pub const PCI_VENDOR_ID_NEC: u32 = 4147;
pub const PCI_DEVICE_ID_NEC_CBUS_1: u32 = 1;
pub const PCI_DEVICE_ID_NEC_LOCAL: u32 = 2;
pub const PCI_DEVICE_ID_NEC_ATM: u32 = 3;
pub const PCI_DEVICE_ID_NEC_R4000: u32 = 4;
pub const PCI_DEVICE_ID_NEC_486: u32 = 5;
pub const PCI_DEVICE_ID_NEC_ACCEL_1: u32 = 6;
pub const PCI_DEVICE_ID_NEC_UXBUS: u32 = 7;
pub const PCI_DEVICE_ID_NEC_ACCEL_2: u32 = 8;
pub const PCI_DEVICE_ID_NEC_GRAPH: u32 = 9;
pub const PCI_DEVICE_ID_NEC_VL: u32 = 22;
pub const PCI_DEVICE_ID_NEC_STARALPHA2: u32 = 44;
pub const PCI_DEVICE_ID_NEC_CBUS_2: u32 = 45;
pub const PCI_DEVICE_ID_NEC_USB: u32 = 53;
pub const PCI_DEVICE_ID_NEC_CBUS_3: u32 = 59;
pub const PCI_DEVICE_ID_NEC_NAPCCARD: u32 = 62;
pub const PCI_DEVICE_ID_NEC_PCX2: u32 = 70;
pub const PCI_DEVICE_ID_NEC_VRC5476: u32 = 155;
pub const PCI_DEVICE_ID_NEC_VRC4173: u32 = 165;
pub const PCI_DEVICE_ID_NEC_VRC5477_AC97: u32 = 166;
pub const PCI_DEVICE_ID_NEC_PC9821CS01: u32 = 32780;
pub const PCI_DEVICE_ID_NEC_PC9821NRB06: u32 = 32781;
pub const PCI_VENDOR_ID_FD: u32 = 4150;
pub const PCI_DEVICE_ID_FD_36C70: u32 = 0;
pub const PCI_VENDOR_ID_SI: u32 = 4153;
pub const PCI_DEVICE_ID_SI_5591_AGP: u32 = 1;
pub const PCI_DEVICE_ID_SI_6202: u32 = 2;
pub const PCI_DEVICE_ID_SI_503: u32 = 8;
pub const PCI_DEVICE_ID_SI_ACPI: u32 = 9;
pub const PCI_DEVICE_ID_SI_SMBUS: u32 = 22;
pub const PCI_DEVICE_ID_SI_LPC: u32 = 24;
pub const PCI_DEVICE_ID_SI_5597_VGA: u32 = 512;
pub const PCI_DEVICE_ID_SI_6205: u32 = 517;
pub const PCI_DEVICE_ID_SI_501: u32 = 1030;
pub const PCI_DEVICE_ID_SI_496: u32 = 1174;
pub const PCI_DEVICE_ID_SI_300: u32 = 768;
pub const PCI_DEVICE_ID_SI_315H: u32 = 784;
pub const PCI_DEVICE_ID_SI_315: u32 = 789;
pub const PCI_DEVICE_ID_SI_315PRO: u32 = 805;
pub const PCI_DEVICE_ID_SI_530: u32 = 1328;
pub const PCI_DEVICE_ID_SI_540: u32 = 1344;
pub const PCI_DEVICE_ID_SI_550: u32 = 1360;
pub const PCI_DEVICE_ID_SI_540_VGA: u32 = 21248;
pub const PCI_DEVICE_ID_SI_550_VGA: u32 = 21269;
pub const PCI_DEVICE_ID_SI_620: u32 = 1568;
pub const PCI_DEVICE_ID_SI_630: u32 = 1584;
pub const PCI_DEVICE_ID_SI_633: u32 = 1587;
pub const PCI_DEVICE_ID_SI_635: u32 = 1589;
pub const PCI_DEVICE_ID_SI_640: u32 = 1600;
pub const PCI_DEVICE_ID_SI_645: u32 = 1605;
pub const PCI_DEVICE_ID_SI_646: u32 = 1606;
pub const PCI_DEVICE_ID_SI_648: u32 = 1608;
pub const PCI_DEVICE_ID_SI_650: u32 = 1616;
pub const PCI_DEVICE_ID_SI_651: u32 = 1617;
pub const PCI_DEVICE_ID_SI_655: u32 = 1621;
pub const PCI_DEVICE_ID_SI_661: u32 = 1633;
pub const PCI_DEVICE_ID_SI_730: u32 = 1840;
pub const PCI_DEVICE_ID_SI_733: u32 = 1843;
pub const PCI_DEVICE_ID_SI_630_VGA: u32 = 25344;
pub const PCI_DEVICE_ID_SI_735: u32 = 1845;
pub const PCI_DEVICE_ID_SI_740: u32 = 1856;
pub const PCI_DEVICE_ID_SI_741: u32 = 1857;
pub const PCI_DEVICE_ID_SI_745: u32 = 1861;
pub const PCI_DEVICE_ID_SI_746: u32 = 1862;
pub const PCI_DEVICE_ID_SI_755: u32 = 1877;
pub const PCI_DEVICE_ID_SI_760: u32 = 1888;
pub const PCI_DEVICE_ID_SI_900: u32 = 2304;
pub const PCI_DEVICE_ID_SI_961: u32 = 2401;
pub const PCI_DEVICE_ID_SI_962: u32 = 2402;
pub const PCI_DEVICE_ID_SI_963: u32 = 2403;
pub const PCI_DEVICE_ID_SI_965: u32 = 2405;
pub const PCI_DEVICE_ID_SI_966: u32 = 2406;
pub const PCI_DEVICE_ID_SI_968: u32 = 2408;
pub const PCI_DEVICE_ID_SI_1180: u32 = 4480;
pub const PCI_DEVICE_ID_SI_5511: u32 = 21777;
pub const PCI_DEVICE_ID_SI_5513: u32 = 21779;
pub const PCI_DEVICE_ID_SI_5517: u32 = 21783;
pub const PCI_DEVICE_ID_SI_5518: u32 = 21784;
pub const PCI_DEVICE_ID_SI_5571: u32 = 21873;
pub const PCI_DEVICE_ID_SI_5581: u32 = 21889;
pub const PCI_DEVICE_ID_SI_5582: u32 = 21890;
pub const PCI_DEVICE_ID_SI_5591: u32 = 21905;
pub const PCI_DEVICE_ID_SI_5596: u32 = 21910;
pub const PCI_DEVICE_ID_SI_5597: u32 = 21911;
pub const PCI_DEVICE_ID_SI_5598: u32 = 21912;
pub const PCI_DEVICE_ID_SI_5600: u32 = 22016;
pub const PCI_DEVICE_ID_SI_7012: u32 = 28690;
pub const PCI_DEVICE_ID_SI_7013: u32 = 28691;
pub const PCI_DEVICE_ID_SI_7016: u32 = 28694;
pub const PCI_DEVICE_ID_SI_7018: u32 = 28696;
pub const PCI_VENDOR_ID_HP: u32 = 4156;
pub const PCI_VENDOR_ID_HP_3PAR: u32 = 5520;
pub const PCI_DEVICE_ID_HP_VISUALIZE_EG: u32 = 4101;
pub const PCI_DEVICE_ID_HP_VISUALIZE_FX6: u32 = 4102;
pub const PCI_DEVICE_ID_HP_VISUALIZE_FX4: u32 = 4104;
pub const PCI_DEVICE_ID_HP_VISUALIZE_FX2: u32 = 4106;
pub const PCI_DEVICE_ID_HP_TACHYON: u32 = 4136;
pub const PCI_DEVICE_ID_HP_TACHLITE: u32 = 4137;
pub const PCI_DEVICE_ID_HP_J2585A: u32 = 4144;
pub const PCI_DEVICE_ID_HP_J2585B: u32 = 4145;
pub const PCI_DEVICE_ID_HP_J2973A: u32 = 4160;
pub const PCI_DEVICE_ID_HP_J2970A: u32 = 4162;
pub const PCI_DEVICE_ID_HP_DIVA: u32 = 4168;
pub const PCI_DEVICE_ID_HP_DIVA_TOSCA1: u32 = 4169;
pub const PCI_DEVICE_ID_HP_DIVA_TOSCA2: u32 = 4170;
pub const PCI_DEVICE_ID_HP_DIVA_MAESTRO: u32 = 4171;
pub const PCI_DEVICE_ID_HP_REO_IOC: u32 = 4337;
pub const PCI_DEVICE_ID_HP_VISUALIZE_FXE: u32 = 4235;
pub const PCI_DEVICE_ID_HP_DIVA_HALFDOME: u32 = 4643;
pub const PCI_DEVICE_ID_HP_DIVA_KEYSTONE: u32 = 4646;
pub const PCI_DEVICE_ID_HP_DIVA_POWERBAR: u32 = 4647;
pub const PCI_DEVICE_ID_HP_ZX1_IOC: u32 = 4650;
pub const PCI_DEVICE_ID_HP_PCIX_LBA: u32 = 4654;
pub const PCI_DEVICE_ID_HP_SX1000_IOC: u32 = 4732;
pub const PCI_DEVICE_ID_HP_DIVA_EVEREST: u32 = 4738;
pub const PCI_DEVICE_ID_HP_DIVA_AUX: u32 = 4752;
pub const PCI_DEVICE_ID_HP_DIVA_RMP3: u32 = 4865;
pub const PCI_DEVICE_ID_HP_DIVA_HURRICANE: u32 = 4906;
pub const PCI_DEVICE_ID_HP_CISSA: u32 = 12832;
pub const PCI_DEVICE_ID_HP_CISSC: u32 = 12848;
pub const PCI_DEVICE_ID_HP_CISSD: u32 = 12856;
pub const PCI_DEVICE_ID_HP_CISSE: u32 = 12858;
pub const PCI_DEVICE_ID_HP_CISSF: u32 = 12859;
pub const PCI_DEVICE_ID_HP_CISSH: u32 = 12860;
pub const PCI_DEVICE_ID_HP_CISSI: u32 = 12857;
pub const PCI_DEVICE_ID_HP_ZX2_IOC: u32 = 16433;
pub const PCI_VENDOR_ID_PCTECH: u32 = 4162;
pub const PCI_DEVICE_ID_PCTECH_RZ1000: u32 = 4096;
pub const PCI_DEVICE_ID_PCTECH_RZ1001: u32 = 4097;
pub const PCI_DEVICE_ID_PCTECH_SAMURAI_IDE: u32 = 12320;
pub const PCI_VENDOR_ID_ASUSTEK: u32 = 4163;
pub const PCI_DEVICE_ID_ASUSTEK_0675: u32 = 1653;
pub const PCI_VENDOR_ID_DPT: u32 = 4164;
pub const PCI_DEVICE_ID_DPT: u32 = 41984;
pub const PCI_VENDOR_ID_OPTI: u32 = 4165;
pub const PCI_DEVICE_ID_OPTI_82C558: u32 = 50520;
pub const PCI_DEVICE_ID_OPTI_82C621: u32 = 50721;
pub const PCI_DEVICE_ID_OPTI_82C700: u32 = 50944;
pub const PCI_DEVICE_ID_OPTI_82C825: u32 = 54632;
pub const PCI_VENDOR_ID_ELSA: u32 = 4168;
pub const PCI_DEVICE_ID_ELSA_MICROLINK: u32 = 4096;
pub const PCI_DEVICE_ID_ELSA_QS3000: u32 = 12288;
pub const PCI_VENDOR_ID_STMICRO: u32 = 4170;
pub const PCI_DEVICE_ID_STMICRO_USB_HOST: u32 = 52224;
pub const PCI_DEVICE_ID_STMICRO_USB_OHCI: u32 = 52225;
pub const PCI_DEVICE_ID_STMICRO_USB_OTG: u32 = 52226;
pub const PCI_DEVICE_ID_STMICRO_UART_HWFC: u32 = 52227;
pub const PCI_DEVICE_ID_STMICRO_UART_NO_HWFC: u32 = 52228;
pub const PCI_DEVICE_ID_STMICRO_SOC_DMA: u32 = 52229;
pub const PCI_DEVICE_ID_STMICRO_SATA: u32 = 52230;
pub const PCI_DEVICE_ID_STMICRO_I2C: u32 = 52231;
pub const PCI_DEVICE_ID_STMICRO_SPI_HS: u32 = 52232;
pub const PCI_DEVICE_ID_STMICRO_MAC: u32 = 52233;
pub const PCI_DEVICE_ID_STMICRO_SDIO_EMMC: u32 = 52234;
pub const PCI_DEVICE_ID_STMICRO_SDIO: u32 = 52235;
pub const PCI_DEVICE_ID_STMICRO_GPIO: u32 = 52236;
pub const PCI_DEVICE_ID_STMICRO_VIP: u32 = 52237;
pub const PCI_DEVICE_ID_STMICRO_AUDIO_ROUTER_DMA: u32 = 52238;
pub const PCI_DEVICE_ID_STMICRO_AUDIO_ROUTER_SRCS: u32 = 52239;
pub const PCI_DEVICE_ID_STMICRO_AUDIO_ROUTER_MSPS: u32 = 52240;
pub const PCI_DEVICE_ID_STMICRO_CAN: u32 = 52241;
pub const PCI_DEVICE_ID_STMICRO_MLB: u32 = 52242;
pub const PCI_DEVICE_ID_STMICRO_DBP: u32 = 52243;
pub const PCI_DEVICE_ID_STMICRO_SATA_PHY: u32 = 52244;
pub const PCI_DEVICE_ID_STMICRO_ESRAM: u32 = 52245;
pub const PCI_DEVICE_ID_STMICRO_VIC: u32 = 52246;
pub const PCI_VENDOR_ID_BUSLOGIC: u32 = 4171;
pub const PCI_DEVICE_ID_BUSLOGIC_MULTIMASTER_NC: u32 = 320;
pub const PCI_DEVICE_ID_BUSLOGIC_MULTIMASTER: u32 = 4160;
pub const PCI_DEVICE_ID_BUSLOGIC_FLASHPOINT: u32 = 33072;
pub const PCI_VENDOR_ID_TI: u32 = 4172;
pub const PCI_DEVICE_ID_TI_TVP4020: u32 = 15623;
pub const PCI_DEVICE_ID_TI_4450: u32 = 32785;
pub const PCI_DEVICE_ID_TI_XX21_XX11: u32 = 32817;
pub const PCI_DEVICE_ID_TI_XX21_XX11_FM: u32 = 32819;
pub const PCI_DEVICE_ID_TI_XX21_XX11_SD: u32 = 32820;
pub const PCI_DEVICE_ID_TI_X515: u32 = 32822;
pub const PCI_DEVICE_ID_TI_XX12: u32 = 32825;
pub const PCI_DEVICE_ID_TI_XX12_FM: u32 = 32827;
pub const PCI_DEVICE_ID_TI_XIO2000A: u32 = 33329;
pub const PCI_DEVICE_ID_TI_1130: u32 = 44050;
pub const PCI_DEVICE_ID_TI_1031: u32 = 44051;
pub const PCI_DEVICE_ID_TI_1131: u32 = 44053;
pub const PCI_DEVICE_ID_TI_1250: u32 = 44054;
pub const PCI_DEVICE_ID_TI_1220: u32 = 44055;
pub const PCI_DEVICE_ID_TI_1221: u32 = 44057;
pub const PCI_DEVICE_ID_TI_1210: u32 = 44058;
pub const PCI_DEVICE_ID_TI_1450: u32 = 44059;
pub const PCI_DEVICE_ID_TI_1225: u32 = 44060;
pub const PCI_DEVICE_ID_TI_1251A: u32 = 44061;
pub const PCI_DEVICE_ID_TI_1211: u32 = 44062;
pub const PCI_DEVICE_ID_TI_1251B: u32 = 44063;
pub const PCI_DEVICE_ID_TI_4410: u32 = 44097;
pub const PCI_DEVICE_ID_TI_4451: u32 = 44098;
pub const PCI_DEVICE_ID_TI_4510: u32 = 44100;
pub const PCI_DEVICE_ID_TI_4520: u32 = 44102;
pub const PCI_DEVICE_ID_TI_7510: u32 = 44103;
pub const PCI_DEVICE_ID_TI_7610: u32 = 44104;
pub const PCI_DEVICE_ID_TI_7410: u32 = 44105;
pub const PCI_DEVICE_ID_TI_1410: u32 = 44112;
pub const PCI_DEVICE_ID_TI_1420: u32 = 44113;
pub const PCI_DEVICE_ID_TI_1451A: u32 = 44114;
pub const PCI_DEVICE_ID_TI_1620: u32 = 44116;
pub const PCI_DEVICE_ID_TI_1520: u32 = 44117;
pub const PCI_DEVICE_ID_TI_1510: u32 = 44118;
pub const PCI_DEVICE_ID_TI_X620: u32 = 44173;
pub const PCI_DEVICE_ID_TI_X420: u32 = 44174;
pub const PCI_DEVICE_ID_TI_XX20_FM: u32 = 44175;
pub const PCI_DEVICE_ID_TI_J721E: u32 = 45069;
pub const PCI_DEVICE_ID_TI_DRA74x: u32 = 46336;
pub const PCI_DEVICE_ID_TI_DRA72x: u32 = 46337;
pub const PCI_VENDOR_ID_SONY: u32 = 4173;
pub const PCI_VENDOR_ID_WINBOND2: u32 = 4176;
pub const PCI_DEVICE_ID_WINBOND2_89C940F: u32 = 23130;
pub const PCI_DEVICE_ID_WINBOND2_6692: u32 = 26258;
pub const PCI_VENDOR_ID_ANIGMA: u32 = 4177;
pub const PCI_DEVICE_ID_ANIGMA_MC145575: u32 = 256;
pub const PCI_VENDOR_ID_EFAR: u32 = 4181;
pub const PCI_DEVICE_ID_EFAR_SLC90E66_1: u32 = 37168;
pub const PCI_DEVICE_ID_EFAR_SLC90E66_3: u32 = 37987;
pub const PCI_VENDOR_ID_MOTOROLA: u32 = 4183;
pub const PCI_DEVICE_ID_MOTOROLA_MPC105: u32 = 1;
pub const PCI_DEVICE_ID_MOTOROLA_MPC106: u32 = 2;
pub const PCI_DEVICE_ID_MOTOROLA_MPC107: u32 = 4;
pub const PCI_DEVICE_ID_MOTOROLA_RAVEN: u32 = 18433;
pub const PCI_DEVICE_ID_MOTOROLA_FALCON: u32 = 18434;
pub const PCI_DEVICE_ID_MOTOROLA_HAWK: u32 = 18435;
pub const PCI_DEVICE_ID_MOTOROLA_HARRIER: u32 = 18443;
pub const PCI_DEVICE_ID_MOTOROLA_MPC5200: u32 = 22531;
pub const PCI_DEVICE_ID_MOTOROLA_MPC5200B: u32 = 22537;
pub const PCI_VENDOR_ID_PROMISE: u32 = 4186;
pub const PCI_DEVICE_ID_PROMISE_20265: u32 = 3376;
pub const PCI_DEVICE_ID_PROMISE_20267: u32 = 19760;
pub const PCI_DEVICE_ID_PROMISE_20246: u32 = 19763;
pub const PCI_DEVICE_ID_PROMISE_20262: u32 = 19768;
pub const PCI_DEVICE_ID_PROMISE_20263: u32 = 3384;
pub const PCI_DEVICE_ID_PROMISE_20268: u32 = 19816;
pub const PCI_DEVICE_ID_PROMISE_20269: u32 = 19817;
pub const PCI_DEVICE_ID_PROMISE_20270: u32 = 25192;
pub const PCI_DEVICE_ID_PROMISE_20271: u32 = 25193;
pub const PCI_DEVICE_ID_PROMISE_20275: u32 = 4725;
pub const PCI_DEVICE_ID_PROMISE_20276: u32 = 21109;
pub const PCI_DEVICE_ID_PROMISE_20277: u32 = 29301;
pub const PCI_VENDOR_ID_FOXCONN: u32 = 4187;
pub const PCI_VENDOR_ID_UMC: u32 = 4192;
pub const PCI_DEVICE_ID_UMC_UM8673F: u32 = 257;
pub const PCI_DEVICE_ID_UMC_UM8886BF: u32 = 26426;
pub const PCI_DEVICE_ID_UMC_UM8886A: u32 = 34922;
pub const PCI_VENDOR_ID_PICOPOWER: u32 = 4198;
pub const PCI_DEVICE_ID_PICOPOWER_PT86C523: u32 = 2;
pub const PCI_DEVICE_ID_PICOPOWER_PT86C523BBP: u32 = 32770;
pub const PCI_VENDOR_ID_MYLEX: u32 = 4201;
pub const PCI_DEVICE_ID_MYLEX_DAC960_P: u32 = 1;
pub const PCI_DEVICE_ID_MYLEX_DAC960_PD: u32 = 2;
pub const PCI_DEVICE_ID_MYLEX_DAC960_PG: u32 = 16;
pub const PCI_DEVICE_ID_MYLEX_DAC960_LA: u32 = 32;
pub const PCI_DEVICE_ID_MYLEX_DAC960_LP: u32 = 80;
pub const PCI_DEVICE_ID_MYLEX_DAC960_BA: u32 = 47702;
pub const PCI_DEVICE_ID_MYLEX_DAC960_GEM: u32 = 45414;
pub const PCI_VENDOR_ID_APPLE: u32 = 4203;
pub const PCI_DEVICE_ID_APPLE_BANDIT: u32 = 1;
pub const PCI_DEVICE_ID_APPLE_HYDRA: u32 = 14;
pub const PCI_DEVICE_ID_APPLE_UNI_N_FW: u32 = 24;
pub const PCI_DEVICE_ID_APPLE_UNI_N_AGP: u32 = 32;
pub const PCI_DEVICE_ID_APPLE_UNI_N_GMAC: u32 = 33;
pub const PCI_DEVICE_ID_APPLE_UNI_N_GMACP: u32 = 36;
pub const PCI_DEVICE_ID_APPLE_UNI_N_AGP_P: u32 = 39;
pub const PCI_DEVICE_ID_APPLE_UNI_N_AGP15: u32 = 45;
pub const PCI_DEVICE_ID_APPLE_UNI_N_PCI15: u32 = 46;
pub const PCI_DEVICE_ID_APPLE_UNI_N_GMAC2: u32 = 50;
pub const PCI_DEVICE_ID_APPLE_UNI_N_ATA: u32 = 51;
pub const PCI_DEVICE_ID_APPLE_UNI_N_AGP2: u32 = 52;
pub const PCI_DEVICE_ID_APPLE_IPID_ATA100: u32 = 59;
pub const PCI_DEVICE_ID_APPLE_K2_ATA100: u32 = 67;
pub const PCI_DEVICE_ID_APPLE_U3_AGP: u32 = 75;
pub const PCI_DEVICE_ID_APPLE_K2_GMAC: u32 = 76;
pub const PCI_DEVICE_ID_APPLE_SH_ATA: u32 = 80;
pub const PCI_DEVICE_ID_APPLE_SH_SUNGEM: u32 = 81;
pub const PCI_DEVICE_ID_APPLE_U3L_AGP: u32 = 88;
pub const PCI_DEVICE_ID_APPLE_U3H_AGP: u32 = 89;
pub const PCI_DEVICE_ID_APPLE_U4_PCIE: u32 = 91;
pub const PCI_DEVICE_ID_APPLE_IPID2_AGP: u32 = 102;
pub const PCI_DEVICE_ID_APPLE_IPID2_ATA: u32 = 105;
pub const PCI_DEVICE_ID_APPLE_IPID2_FW: u32 = 106;
pub const PCI_DEVICE_ID_APPLE_IPID2_GMAC: u32 = 107;
pub const PCI_DEVICE_ID_APPLE_TIGON3: u32 = 5701;
pub const PCI_VENDOR_ID_YAMAHA: u32 = 4211;
pub const PCI_DEVICE_ID_YAMAHA_724: u32 = 4;
pub const PCI_DEVICE_ID_YAMAHA_724F: u32 = 13;
pub const PCI_DEVICE_ID_YAMAHA_740: u32 = 10;
pub const PCI_DEVICE_ID_YAMAHA_740C: u32 = 12;
pub const PCI_DEVICE_ID_YAMAHA_744: u32 = 16;
pub const PCI_DEVICE_ID_YAMAHA_754: u32 = 18;
pub const PCI_VENDOR_ID_QLOGIC: u32 = 4215;
pub const PCI_DEVICE_ID_QLOGIC_ISP10160: u32 = 4118;
pub const PCI_DEVICE_ID_QLOGIC_ISP1020: u32 = 4128;
pub const PCI_DEVICE_ID_QLOGIC_ISP1080: u32 = 4224;
pub const PCI_DEVICE_ID_QLOGIC_ISP12160: u32 = 4630;
pub const PCI_DEVICE_ID_QLOGIC_ISP1240: u32 = 4672;
pub const PCI_DEVICE_ID_QLOGIC_ISP1280: u32 = 4736;
pub const PCI_DEVICE_ID_QLOGIC_ISP2100: u32 = 8448;
pub const PCI_DEVICE_ID_QLOGIC_ISP2200: u32 = 8704;
pub const PCI_DEVICE_ID_QLOGIC_ISP2300: u32 = 8960;
pub const PCI_DEVICE_ID_QLOGIC_ISP2312: u32 = 8978;
pub const PCI_DEVICE_ID_QLOGIC_ISP2322: u32 = 8994;
pub const PCI_DEVICE_ID_QLOGIC_ISP6312: u32 = 25362;
pub const PCI_DEVICE_ID_QLOGIC_ISP6322: u32 = 25378;
pub const PCI_DEVICE_ID_QLOGIC_ISP2422: u32 = 9250;
pub const PCI_DEVICE_ID_QLOGIC_ISP2432: u32 = 9266;
pub const PCI_DEVICE_ID_QLOGIC_ISP2512: u32 = 9490;
pub const PCI_DEVICE_ID_QLOGIC_ISP2522: u32 = 9506;
pub const PCI_DEVICE_ID_QLOGIC_ISP5422: u32 = 21538;
pub const PCI_DEVICE_ID_QLOGIC_ISP5432: u32 = 21554;
pub const PCI_VENDOR_ID_CYRIX: u32 = 4216;
pub const PCI_DEVICE_ID_CYRIX_5510: u32 = 0;
pub const PCI_DEVICE_ID_CYRIX_PCI_MASTER: u32 = 1;
pub const PCI_DEVICE_ID_CYRIX_5520: u32 = 2;
pub const PCI_DEVICE_ID_CYRIX_5530_LEGACY: u32 = 256;
pub const PCI_DEVICE_ID_CYRIX_5530_IDE: u32 = 258;
pub const PCI_DEVICE_ID_CYRIX_5530_AUDIO: u32 = 259;
pub const PCI_DEVICE_ID_CYRIX_5530_VIDEO: u32 = 260;
pub const PCI_VENDOR_ID_CONTAQ: u32 = 4224;
pub const PCI_DEVICE_ID_CONTAQ_82C693: u32 = 50835;
pub const PCI_VENDOR_ID_OLICOM: u32 = 4237;
pub const PCI_DEVICE_ID_OLICOM_OC2325: u32 = 18;
pub const PCI_DEVICE_ID_OLICOM_OC2183: u32 = 19;
pub const PCI_DEVICE_ID_OLICOM_OC2326: u32 = 20;
pub const PCI_VENDOR_ID_SUN: u32 = 4238;
pub const PCI_DEVICE_ID_SUN_EBUS: u32 = 4096;
pub const PCI_DEVICE_ID_SUN_HAPPYMEAL: u32 = 4097;
pub const PCI_DEVICE_ID_SUN_RIO_EBUS: u32 = 4352;
pub const PCI_DEVICE_ID_SUN_RIO_GEM: u32 = 4353;
pub const PCI_DEVICE_ID_SUN_RIO_1394: u32 = 4354;
pub const PCI_DEVICE_ID_SUN_RIO_USB: u32 = 4355;
pub const PCI_DEVICE_ID_SUN_GEM: u32 = 11181;
pub const PCI_DEVICE_ID_SUN_SIMBA: u32 = 20480;
pub const PCI_DEVICE_ID_SUN_PBM: u32 = 32768;
pub const PCI_DEVICE_ID_SUN_SCHIZO: u32 = 32769;
pub const PCI_DEVICE_ID_SUN_SABRE: u32 = 40960;
pub const PCI_DEVICE_ID_SUN_HUMMINGBIRD: u32 = 40961;
pub const PCI_DEVICE_ID_SUN_TOMATILLO: u32 = 43009;
pub const PCI_DEVICE_ID_SUN_CASSINI: u32 = 43962;
pub const PCI_VENDOR_ID_NI: u32 = 4243;
pub const PCI_DEVICE_ID_NI_PCI2322: u32 = 53552;
pub const PCI_DEVICE_ID_NI_PCI2324: u32 = 53568;
pub const PCI_DEVICE_ID_NI_PCI2328: u32 = 53584;
pub const PCI_DEVICE_ID_NI_PXI8422_2322: u32 = 53648;
pub const PCI_DEVICE_ID_NI_PXI8422_2324: u32 = 53664;
pub const PCI_DEVICE_ID_NI_PXI8420_2322: u32 = 53712;
pub const PCI_DEVICE_ID_NI_PXI8420_2324: u32 = 53728;
pub const PCI_DEVICE_ID_NI_PXI8420_2328: u32 = 53744;
pub const PCI_DEVICE_ID_NI_PXI8420_23216: u32 = 53745;
pub const PCI_DEVICE_ID_NI_PCI2322I: u32 = 53840;
pub const PCI_DEVICE_ID_NI_PCI2324I: u32 = 53872;
pub const PCI_DEVICE_ID_NI_PCI23216: u32 = 53936;
pub const PCI_DEVICE_ID_NI_PXI8430_2322: u32 = 28800;
pub const PCI_DEVICE_ID_NI_PCI8430_2322: u32 = 28891;
pub const PCI_DEVICE_ID_NI_PXI8430_2324: u32 = 28893;
pub const PCI_DEVICE_ID_NI_PCI8430_2324: u32 = 28895;
pub const PCI_DEVICE_ID_NI_PXI8430_2328: u32 = 28898;
pub const PCI_DEVICE_ID_NI_PCI8430_2328: u32 = 28900;
pub const PCI_DEVICE_ID_NI_PXI8430_23216: u32 = 28902;
pub const PCI_DEVICE_ID_NI_PCI8430_23216: u32 = 28903;
pub const PCI_DEVICE_ID_NI_PXI8432_2322: u32 = 28904;
pub const PCI_DEVICE_ID_NI_PCI8432_2322: u32 = 28906;
pub const PCI_DEVICE_ID_NI_PXI8432_2324: u32 = 28908;
pub const PCI_DEVICE_ID_NI_PCI8432_2324: u32 = 28910;
pub const PCI_VENDOR_ID_CMD: u32 = 4245;
pub const PCI_DEVICE_ID_CMD_643: u32 = 1603;
pub const PCI_DEVICE_ID_CMD_646: u32 = 1606;
pub const PCI_DEVICE_ID_CMD_648: u32 = 1608;
pub const PCI_DEVICE_ID_CMD_649: u32 = 1609;
pub const PCI_DEVICE_ID_SII_680: u32 = 1664;
pub const PCI_DEVICE_ID_SII_3112: u32 = 12562;
pub const PCI_DEVICE_ID_SII_1210SA: u32 = 576;
pub const PCI_VENDOR_ID_BROOKTREE: u32 = 4254;
pub const PCI_DEVICE_ID_BROOKTREE_878: u32 = 2168;
pub const PCI_DEVICE_ID_BROOKTREE_879: u32 = 2169;
pub const PCI_VENDOR_ID_SGI: u32 = 4265;
pub const PCI_DEVICE_ID_SGI_IOC3: u32 = 3;
pub const PCI_DEVICE_ID_SGI_LITHIUM: u32 = 4098;
pub const PCI_VENDOR_ID_WINBOND: u32 = 4269;
pub const PCI_DEVICE_ID_WINBOND_82C105: u32 = 261;
pub const PCI_DEVICE_ID_WINBOND_83C553: u32 = 1381;
pub const PCI_VENDOR_ID_PLX: u32 = 4277;
pub const PCI_DEVICE_ID_PLX_R685: u32 = 4144;
pub const PCI_DEVICE_ID_PLX_ROMULUS: u32 = 4202;
pub const PCI_DEVICE_ID_PLX_SPCOM800: u32 = 4214;
pub const PCI_DEVICE_ID_PLX_1077: u32 = 4215;
pub const PCI_DEVICE_ID_PLX_SPCOM200: u32 = 4355;
pub const PCI_DEVICE_ID_PLX_DJINN_ITOO: u32 = 4433;
pub const PCI_DEVICE_ID_PLX_R753: u32 = 4434;
pub const PCI_DEVICE_ID_PLX_OLITEC: u32 = 4487;
pub const PCI_DEVICE_ID_PLX_PCI200SYN: u32 = 12694;
pub const PCI_DEVICE_ID_PLX_9030: u32 = 36912;
pub const PCI_DEVICE_ID_PLX_9050: u32 = 36944;
pub const PCI_DEVICE_ID_PLX_9056: u32 = 36950;
pub const PCI_DEVICE_ID_PLX_9080: u32 = 36992;
pub const PCI_DEVICE_ID_PLX_GTEK_SERIAL2: u32 = 40961;
pub const PCI_VENDOR_ID_MADGE: u32 = 4278;
pub const PCI_DEVICE_ID_MADGE_MK2: u32 = 2;
pub const PCI_VENDOR_ID_3COM: u32 = 4279;
pub const PCI_DEVICE_ID_3COM_3C985: u32 = 1;
pub const PCI_DEVICE_ID_3COM_3C940: u32 = 5888;
pub const PCI_DEVICE_ID_3COM_3C339: u32 = 13200;
pub const PCI_DEVICE_ID_3COM_3C359: u32 = 13712;
pub const PCI_DEVICE_ID_3COM_3C940B: u32 = 33003;
pub const PCI_DEVICE_ID_3COM_3CR990: u32 = 39168;
pub const PCI_DEVICE_ID_3COM_3CR990_TX_95: u32 = 39170;
pub const PCI_DEVICE_ID_3COM_3CR990_TX_97: u32 = 39171;
pub const PCI_DEVICE_ID_3COM_3CR990B: u32 = 39172;
pub const PCI_DEVICE_ID_3COM_3CR990_FX: u32 = 39173;
pub const PCI_DEVICE_ID_3COM_3CR990SVR95: u32 = 39176;
pub const PCI_DEVICE_ID_3COM_3CR990SVR97: u32 = 39177;
pub const PCI_DEVICE_ID_3COM_3CR990SVR: u32 = 39178;
pub const PCI_VENDOR_ID_AL: u32 = 4281;
pub const PCI_DEVICE_ID_AL_M1489: u32 = 5257;
pub const PCI_DEVICE_ID_AL_M1533: u32 = 5427;
pub const PCI_DEVICE_ID_AL_M1535: u32 = 5429;
pub const PCI_DEVICE_ID_AL_M1541: u32 = 5441;
pub const PCI_DEVICE_ID_AL_M1563: u32 = 5475;
pub const PCI_DEVICE_ID_AL_M1621: u32 = 5665;
pub const PCI_DEVICE_ID_AL_M1631: u32 = 5681;
pub const PCI_DEVICE_ID_AL_M1632: u32 = 5682;
pub const PCI_DEVICE_ID_AL_M1641: u32 = 5697;
pub const PCI_DEVICE_ID_AL_M1644: u32 = 5700;
pub const PCI_DEVICE_ID_AL_M1647: u32 = 5703;
pub const PCI_DEVICE_ID_AL_M1651: u32 = 5713;
pub const PCI_DEVICE_ID_AL_M1671: u32 = 5745;
pub const PCI_DEVICE_ID_AL_M1681: u32 = 5761;
pub const PCI_DEVICE_ID_AL_M1683: u32 = 5763;
pub const PCI_DEVICE_ID_AL_M1689: u32 = 5769;
pub const PCI_DEVICE_ID_AL_M5219: u32 = 21017;
pub const PCI_DEVICE_ID_AL_M5228: u32 = 21032;
pub const PCI_DEVICE_ID_AL_M5229: u32 = 21033;
pub const PCI_DEVICE_ID_AL_M5451: u32 = 21585;
pub const PCI_DEVICE_ID_AL_M7101: u32 = 28929;
pub const PCI_VENDOR_ID_NEOMAGIC: u32 = 4296;
pub const PCI_DEVICE_ID_NEOMAGIC_NM256AV_AUDIO: u32 = 32773;
pub const PCI_DEVICE_ID_NEOMAGIC_NM256ZX_AUDIO: u32 = 32774;
pub const PCI_DEVICE_ID_NEOMAGIC_NM256XL_PLUS_AUDIO: u32 = 32790;
pub const PCI_VENDOR_ID_TCONRAD: u32 = 4314;
pub const PCI_DEVICE_ID_TCONRAD_TOKENRING: u32 = 1288;
pub const PCI_VENDOR_ID_ROHM: u32 = 4315;
pub const PCI_VENDOR_ID_NVIDIA: u32 = 4318;
pub const PCI_DEVICE_ID_NVIDIA_TNT: u32 = 32;
pub const PCI_DEVICE_ID_NVIDIA_TNT2: u32 = 40;
pub const PCI_DEVICE_ID_NVIDIA_UTNT2: u32 = 41;
pub const PCI_DEVICE_ID_NVIDIA_TNT_UNKNOWN: u32 = 42;
pub const PCI_DEVICE_ID_NVIDIA_VTNT2: u32 = 44;
pub const PCI_DEVICE_ID_NVIDIA_UVTNT2: u32 = 45;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP04_SMBUS: u32 = 52;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP04_IDE: u32 = 53;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP04_SATA: u32 = 54;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP04_SATA2: u32 = 62;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_6800_ULTRA: u32 = 64;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_6800: u32 = 65;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_6800_LE: u32 = 66;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_6800_GT: u32 = 69;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO_FX_4000: u32 = 78;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE4_SMBUS: u32 = 82;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_CK804_IDE: u32 = 83;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_CK804_SATA: u32 = 84;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_CK804_SATA2: u32 = 85;
pub const PCI_DEVICE_ID_NVIDIA_CK804_AUDIO: u32 = 89;
pub const PCI_DEVICE_ID_NVIDIA_CK804_PCIE: u32 = 93;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE2_SMBUS: u32 = 100;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE2_IDE: u32 = 101;
pub const PCI_DEVICE_ID_NVIDIA_MCP2_MODEM: u32 = 105;
pub const PCI_DEVICE_ID_NVIDIA_MCP2_AUDIO: u32 = 106;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE2S_SMBUS: u32 = 132;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE2S_IDE: u32 = 133;
pub const PCI_DEVICE_ID_NVIDIA_MCP2S_MODEM: u32 = 137;
pub const PCI_DEVICE_ID_NVIDIA_CK8_AUDIO: u32 = 138;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE2S_SATA: u32 = 142;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_7800_GT: u32 = 144;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_7800_GTX: u32 = 145;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_GO_7800: u32 = 152;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_GO_7800_GTX: u32 = 153;
pub const PCI_DEVICE_ID_NVIDIA_ITNT2: u32 = 160;
pub const PCI_DEVICE_ID_GEFORCE_6800A: u32 = 193;
pub const PCI_DEVICE_ID_GEFORCE_6800A_LE: u32 = 194;
pub const PCI_DEVICE_ID_GEFORCE_GO_6800: u32 = 200;
pub const PCI_DEVICE_ID_GEFORCE_GO_6800_ULTRA: u32 = 201;
pub const PCI_DEVICE_ID_QUADRO_FX_GO1400: u32 = 204;
pub const PCI_DEVICE_ID_QUADRO_FX_1400: u32 = 206;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE3: u32 = 209;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE3_SMBUS: u32 = 212;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE3_IDE: u32 = 213;
pub const PCI_DEVICE_ID_NVIDIA_MCP3_MODEM: u32 = 217;
pub const PCI_DEVICE_ID_NVIDIA_MCP3_AUDIO: u32 = 218;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE3S: u32 = 225;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE3S_SATA: u32 = 227;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE3S_SMBUS: u32 = 228;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE3S_IDE: u32 = 229;
pub const PCI_DEVICE_ID_NVIDIA_CK8S_AUDIO: u32 = 234;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE3S_SATA2: u32 = 238;
pub const PCIE_DEVICE_ID_NVIDIA_GEFORCE_6800_ALT1: u32 = 240;
pub const PCIE_DEVICE_ID_NVIDIA_GEFORCE_6600_ALT1: u32 = 241;
pub const PCIE_DEVICE_ID_NVIDIA_GEFORCE_6600_ALT2: u32 = 242;
pub const PCIE_DEVICE_ID_NVIDIA_GEFORCE_6200_ALT1: u32 = 243;
pub const PCIE_DEVICE_ID_NVIDIA_GEFORCE_6800_GT: u32 = 249;
pub const PCIE_DEVICE_ID_NVIDIA_QUADRO_NVS280: u32 = 253;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_SDR: u32 = 256;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_DDR: u32 = 257;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO: u32 = 259;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE2_MX: u32 = 272;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE2_MX2: u32 = 273;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE2_GO: u32 = 274;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO2_MXR: u32 = 275;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_6600_GT: u32 = 320;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_6600: u32 = 321;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_6610_XL: u32 = 325;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO_FX_540: u32 = 334;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_6200: u32 = 335;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE2_GTS: u32 = 336;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE2_GTS2: u32 = 337;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE2_ULTRA: u32 = 338;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO2_PRO: u32 = 339;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_6200_TURBOCACHE: u32 = 353;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_GO_6200: u32 = 356;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_GO_6250: u32 = 358;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_GO_6200_1: u32 = 359;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_GO_6250_1: u32 = 360;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_MX_460: u32 = 368;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_MX_440: u32 = 369;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_MX_420: u32 = 370;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_MX_440_SE: u32 = 371;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_440_GO: u32 = 372;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_420_GO: u32 = 373;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_420_GO_M32: u32 = 374;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_460_GO: u32 = 375;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO4_500XGL: u32 = 376;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_440_GO_M64: u32 = 377;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO4_200: u32 = 378;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO4_550XGL: u32 = 379;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO4_500_GOGL: u32 = 380;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_410_GO_M16: u32 = 381;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_MX_440_8X: u32 = 385;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_MX_440SE_8X: u32 = 386;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_MX_420_8X: u32 = 387;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_MX_4000: u32 = 389;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_448_GO: u32 = 390;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_488_GO: u32 = 391;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO4_580_XGL: u32 = 392;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_MX_MAC: u32 = 393;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO4_280_NVS: u32 = 394;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO4_380_XGL: u32 = 395;
pub const PCI_DEVICE_ID_NVIDIA_IGEFORCE2: u32 = 416;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE: u32 = 420;
pub const PCI_DEVICE_ID_NVIDIA_MCP1_AUDIO: u32 = 433;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_SMBUS: u32 = 436;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_IDE: u32 = 444;
pub const PCI_DEVICE_ID_NVIDIA_MCP1_MODEM: u32 = 449;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE2: u32 = 480;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE3: u32 = 512;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE3_1: u32 = 513;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE3_2: u32 = 514;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO_DDC: u32 = 515;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_6800B: u32 = 529;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_6800B_LE: u32 = 530;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_6800B_GT: u32 = 533;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_TI_4600: u32 = 592;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_TI_4400: u32 = 593;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_TI_4200: u32 = 595;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO4_900XGL: u32 = 600;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO4_750XGL: u32 = 601;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO4_700XGL: u32 = 603;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP51_SMBUS: u32 = 612;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP51_IDE: u32 = 613;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP51_SATA: u32 = 614;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP51_SATA2: u32 = 615;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP55_SMBUS: u32 = 872;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP55_IDE: u32 = 878;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP55_SATA: u32 = 894;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP55_SATA2: u32 = 895;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_TI_4800: u32 = 640;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_TI_4800_8X: u32 = 641;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_TI_4800SE: u32 = 642;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE4_4200_GO: u32 = 646;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO4_980_XGL: u32 = 648;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO4_780_XGL: u32 = 649;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO4_700_GOGL: u32 = 652;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_5800_ULTRA: u32 = 769;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_5800: u32 = 770;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO_FX_2000: u32 = 776;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO_FX_1000: u32 = 777;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_5600_ULTRA: u32 = 785;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_5600: u32 = 786;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_5600SE: u32 = 788;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_GO5600: u32 = 794;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_GO5650: u32 = 795;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO_FX_GO700: u32 = 796;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_5200: u32 = 800;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_5200_ULTRA: u32 = 801;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_5200_1: u32 = 802;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_5200SE: u32 = 803;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_GO5200: u32 = 804;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_GO5250: u32 = 805;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_5500: u32 = 806;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_5100: u32 = 807;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_GO5250_32: u32 = 808;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_GO_5200: u32 = 809;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO_NVS_280_PCI: u32 = 810;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO_FX_500: u32 = 811;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_GO5300: u32 = 812;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_GO5100: u32 = 813;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_5900_ULTRA: u32 = 816;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_5900: u32 = 817;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_5900XT: u32 = 818;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_5950_ULTRA: u32 = 819;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_5900ZT: u32 = 820;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO_FX_3000: u32 = 824;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO_FX_700: u32 = 831;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_5700_ULTRA: u32 = 833;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_5700: u32 = 834;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_5700LE: u32 = 835;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_5700VE: u32 = 836;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_GO5700_1: u32 = 839;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_FX_GO5700_2: u32 = 840;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO_FX_GO1000: u32 = 844;
pub const PCI_DEVICE_ID_NVIDIA_QUADRO_FX_1100: u32 = 846;
pub const PCI_DEVICE_ID_NVIDIA_MCP55_BRIDGE_V0: u32 = 864;
pub const PCI_DEVICE_ID_NVIDIA_MCP55_BRIDGE_V4: u32 = 868;
pub const PCI_DEVICE_ID_NVIDIA_NVENET_15: u32 = 883;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP61_SATA: u32 = 999;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP61_SMBUS: u32 = 1003;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP61_IDE: u32 = 1004;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP61_SATA2: u32 = 1014;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP61_SATA3: u32 = 1015;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP65_SMBUS: u32 = 1094;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP65_IDE: u32 = 1096;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP67_SMBUS: u32 = 1346;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP67_IDE: u32 = 1376;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP73_IDE: u32 = 1388;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP78S_SMBUS: u32 = 1874;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP77_IDE: u32 = 1881;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP73_SMBUS: u32 = 2008;
pub const PCI_DEVICE_ID_NVIDIA_GEFORCE_320M: u32 = 2208;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP79_SMBUS: u32 = 2722;
pub const PCI_DEVICE_ID_NVIDIA_NFORCE_MCP89_SATA: u32 = 3461;
pub const PCI_VENDOR_ID_IMS: u32 = 4320;
pub const PCI_DEVICE_ID_IMS_TT128: u32 = 37160;
pub const PCI_DEVICE_ID_IMS_TT3D: u32 = 37173;
pub const PCI_VENDOR_ID_AMCC: u32 = 4328;
pub const PCI_VENDOR_ID_AMPERE: u32 = 7663;
pub const PCI_VENDOR_ID_INTERG: u32 = 4330;
pub const PCI_DEVICE_ID_INTERG_1682: u32 = 5762;
pub const PCI_DEVICE_ID_INTERG_2000: u32 = 8192;
pub const PCI_DEVICE_ID_INTERG_2010: u32 = 8208;
pub const PCI_DEVICE_ID_INTERG_5000: u32 = 20480;
pub const PCI_DEVICE_ID_INTERG_5050: u32 = 20560;
pub const PCI_VENDOR_ID_REALTEK: u32 = 4332;
pub const PCI_DEVICE_ID_REALTEK_8139: u32 = 33081;
pub const PCI_VENDOR_ID_XILINX: u32 = 4334;
pub const PCI_DEVICE_ID_RME_DIGI96: u32 = 16320;
pub const PCI_DEVICE_ID_RME_DIGI96_8: u32 = 16321;
pub const PCI_DEVICE_ID_RME_DIGI96_8_PRO: u32 = 16322;
pub const PCI_DEVICE_ID_RME_DIGI96_8_PAD_OR_PST: u32 = 16323;
pub const PCI_DEVICE_ID_XILINX_HAMMERFALL_DSP: u32 = 16325;
pub const PCI_DEVICE_ID_XILINX_HAMMERFALL_DSP_MADI: u32 = 16326;
pub const PCI_VENDOR_ID_INIT: u32 = 4353;
pub const PCI_VENDOR_ID_CREATIVE: u32 = 4354;
pub const PCI_DEVICE_ID_CREATIVE_EMU10K1: u32 = 2;
pub const PCI_DEVICE_ID_CREATIVE_20K1: u32 = 5;
pub const PCI_DEVICE_ID_CREATIVE_20K2: u32 = 11;
pub const PCI_SUBDEVICE_ID_CREATIVE_SB0760: u32 = 36;
pub const PCI_SUBDEVICE_ID_CREATIVE_SB08801: u32 = 65;
pub const PCI_SUBDEVICE_ID_CREATIVE_SB08802: u32 = 66;
pub const PCI_SUBDEVICE_ID_CREATIVE_SB08803: u32 = 67;
pub const PCI_SUBDEVICE_ID_CREATIVE_SB1270: u32 = 98;
pub const PCI_SUBDEVICE_ID_CREATIVE_HENDRIX: u32 = 24576;
pub const PCI_VENDOR_ID_ECTIVA: u32 = 4354;
pub const PCI_DEVICE_ID_ECTIVA_EV1938: u32 = 35128;
pub const PCI_VENDOR_ID_TTI: u32 = 4355;
pub const PCI_DEVICE_ID_TTI_HPT343: u32 = 3;
pub const PCI_DEVICE_ID_TTI_HPT366: u32 = 4;
pub const PCI_DEVICE_ID_TTI_HPT372: u32 = 5;
pub const PCI_DEVICE_ID_TTI_HPT302: u32 = 6;
pub const PCI_DEVICE_ID_TTI_HPT371: u32 = 7;
pub const PCI_DEVICE_ID_TTI_HPT374: u32 = 8;
pub const PCI_DEVICE_ID_TTI_HPT372N: u32 = 9;
pub const PCI_VENDOR_ID_SIGMA: u32 = 4357;
pub const PCI_VENDOR_ID_VIA: u32 = 4358;
pub const PCI_DEVICE_ID_VIA_8763_0: u32 = 408;
pub const PCI_DEVICE_ID_VIA_8380_0: u32 = 516;
pub const PCI_DEVICE_ID_VIA_3238_0: u32 = 568;
pub const PCI_DEVICE_ID_VIA_PT880: u32 = 600;
pub const PCI_DEVICE_ID_VIA_PT880ULTRA: u32 = 776;
pub const PCI_DEVICE_ID_VIA_PX8X0_0: u32 = 601;
pub const PCI_DEVICE_ID_VIA_3269_0: u32 = 617;
pub const PCI_DEVICE_ID_VIA_K8T800PRO_0: u32 = 642;
pub const PCI_DEVICE_ID_VIA_3296_0: u32 = 662;
pub const PCI_DEVICE_ID_VIA_8363_0: u32 = 773;
pub const PCI_DEVICE_ID_VIA_P4M800CE: u32 = 788;
pub const PCI_DEVICE_ID_VIA_P4M890: u32 = 807;
pub const PCI_DEVICE_ID_VIA_VT3324: u32 = 804;
pub const PCI_DEVICE_ID_VIA_VT3336: u32 = 822;
pub const PCI_DEVICE_ID_VIA_VT3351: u32 = 849;
pub const PCI_DEVICE_ID_VIA_VT3364: u32 = 868;
pub const PCI_DEVICE_ID_VIA_8371_0: u32 = 913;
pub const PCI_DEVICE_ID_VIA_6415: u32 = 1045;
pub const PCI_DEVICE_ID_VIA_8501_0: u32 = 1281;
pub const PCI_DEVICE_ID_VIA_82C561: u32 = 1377;
pub const PCI_DEVICE_ID_VIA_82C586_1: u32 = 1393;
pub const PCI_DEVICE_ID_VIA_82C576: u32 = 1398;
pub const PCI_DEVICE_ID_VIA_82C586_0: u32 = 1414;
pub const PCI_DEVICE_ID_VIA_82C596: u32 = 1430;
pub const PCI_DEVICE_ID_VIA_82C597_0: u32 = 1431;
pub const PCI_DEVICE_ID_VIA_82C598_0: u32 = 1432;
pub const PCI_DEVICE_ID_VIA_8601_0: u32 = 1537;
pub const PCI_DEVICE_ID_VIA_8605_0: u32 = 1541;
pub const PCI_DEVICE_ID_VIA_82C686: u32 = 1670;
pub const PCI_DEVICE_ID_VIA_82C691_0: u32 = 1681;
pub const PCI_DEVICE_ID_VIA_82C576_1: u32 = 5489;
pub const PCI_DEVICE_ID_VIA_82C586_2: u32 = 12344;
pub const PCI_DEVICE_ID_VIA_82C586_3: u32 = 12352;
pub const PCI_DEVICE_ID_VIA_82C596_3: u32 = 12368;
pub const PCI_DEVICE_ID_VIA_82C596B_3: u32 = 12369;
pub const PCI_DEVICE_ID_VIA_82C686_4: u32 = 12375;
pub const PCI_DEVICE_ID_VIA_82C686_5: u32 = 12376;
pub const PCI_DEVICE_ID_VIA_8233_5: u32 = 12377;
pub const PCI_DEVICE_ID_VIA_8233_0: u32 = 12404;
pub const PCI_DEVICE_ID_VIA_8633_0: u32 = 12433;
pub const PCI_DEVICE_ID_VIA_8367_0: u32 = 12441;
pub const PCI_DEVICE_ID_VIA_8653_0: u32 = 12545;
pub const PCI_DEVICE_ID_VIA_8622: u32 = 12546;
pub const PCI_DEVICE_ID_VIA_8235_USB_2: u32 = 12548;
pub const PCI_DEVICE_ID_VIA_8233C_0: u32 = 12553;
pub const PCI_DEVICE_ID_VIA_8361: u32 = 12562;
pub const PCI_DEVICE_ID_VIA_XM266: u32 = 12566;
pub const PCI_DEVICE_ID_VIA_612X: u32 = 12569;
pub const PCI_DEVICE_ID_VIA_862X_0: u32 = 12579;
pub const PCI_DEVICE_ID_VIA_8753_0: u32 = 12584;
pub const PCI_DEVICE_ID_VIA_8233A: u32 = 12615;
pub const PCI_DEVICE_ID_VIA_8703_51_0: u32 = 12616;
pub const PCI_DEVICE_ID_VIA_8237_SATA: u32 = 12617;
pub const PCI_DEVICE_ID_VIA_XN266: u32 = 12630;
pub const PCI_DEVICE_ID_VIA_6410: u32 = 12644;
pub const PCI_DEVICE_ID_VIA_8754C_0: u32 = 12648;
pub const PCI_DEVICE_ID_VIA_8235: u32 = 12663;
pub const PCI_DEVICE_ID_VIA_8385_0: u32 = 12680;
pub const PCI_DEVICE_ID_VIA_8377_0: u32 = 12681;
pub const PCI_DEVICE_ID_VIA_8378_0: u32 = 12805;
pub const PCI_DEVICE_ID_VIA_8783_0: u32 = 12808;
pub const PCI_DEVICE_ID_VIA_8237: u32 = 12839;
pub const PCI_DEVICE_ID_VIA_8251: u32 = 12935;
pub const PCI_DEVICE_ID_VIA_8261: u32 = 13314;
pub const PCI_DEVICE_ID_VIA_8237A: u32 = 13111;
pub const PCI_DEVICE_ID_VIA_8237S: u32 = 13170;
pub const PCI_DEVICE_ID_VIA_SATA_EIDE: u32 = 21284;
pub const PCI_DEVICE_ID_VIA_8231: u32 = 33329;
pub const PCI_DEVICE_ID_VIA_8231_4: u32 = 33333;
pub const PCI_DEVICE_ID_VIA_8365_1: u32 = 33541;
pub const PCI_DEVICE_ID_VIA_CX700: u32 = 33572;
pub const PCI_DEVICE_ID_VIA_CX700_IDE: u32 = 1409;
pub const PCI_DEVICE_ID_VIA_VX800: u32 = 33619;
pub const PCI_DEVICE_ID_VIA_VX855: u32 = 33801;
pub const PCI_DEVICE_ID_VIA_VX900: u32 = 33808;
pub const PCI_DEVICE_ID_VIA_8371_1: u32 = 33681;
pub const PCI_DEVICE_ID_VIA_82C598_1: u32 = 34200;
pub const PCI_DEVICE_ID_VIA_838X_1: u32 = 45448;
pub const PCI_DEVICE_ID_VIA_83_87XX_1: u32 = 45464;
pub const PCI_DEVICE_ID_VIA_VX855_IDE: u32 = 50185;
pub const PCI_DEVICE_ID_VIA_ANON: u32 = 65535;
pub const PCI_VENDOR_ID_SIEMENS: u32 = 4362;
pub const PCI_DEVICE_ID_SIEMENS_DSCC4: u32 = 8450;
pub const PCI_VENDOR_ID_VORTEX: u32 = 4377;
pub const PCI_DEVICE_ID_VORTEX_GDT60x0: u32 = 0;
pub const PCI_DEVICE_ID_VORTEX_GDT6000B: u32 = 1;
pub const PCI_DEVICE_ID_VORTEX_GDT6x10: u32 = 2;
pub const PCI_DEVICE_ID_VORTEX_GDT6x20: u32 = 3;
pub const PCI_DEVICE_ID_VORTEX_GDT6530: u32 = 4;
pub const PCI_DEVICE_ID_VORTEX_GDT6550: u32 = 5;
pub const PCI_DEVICE_ID_VORTEX_GDT6x17: u32 = 6;
pub const PCI_DEVICE_ID_VORTEX_GDT6x27: u32 = 7;
pub const PCI_DEVICE_ID_VORTEX_GDT6537: u32 = 8;
pub const PCI_DEVICE_ID_VORTEX_GDT6557: u32 = 9;
pub const PCI_DEVICE_ID_VORTEX_GDT6x15: u32 = 10;
pub const PCI_DEVICE_ID_VORTEX_GDT6x25: u32 = 11;
pub const PCI_DEVICE_ID_VORTEX_GDT6535: u32 = 12;
pub const PCI_DEVICE_ID_VORTEX_GDT6555: u32 = 13;
pub const PCI_DEVICE_ID_VORTEX_GDT6x17RP: u32 = 256;
pub const PCI_DEVICE_ID_VORTEX_GDT6x27RP: u32 = 257;
pub const PCI_DEVICE_ID_VORTEX_GDT6537RP: u32 = 258;
pub const PCI_DEVICE_ID_VORTEX_GDT6557RP: u32 = 259;
pub const PCI_DEVICE_ID_VORTEX_GDT6x11RP: u32 = 260;
pub const PCI_DEVICE_ID_VORTEX_GDT6x21RP: u32 = 261;
pub const PCI_VENDOR_ID_EF: u32 = 4378;
pub const PCI_DEVICE_ID_EF_ATM_FPGA: u32 = 0;
pub const PCI_DEVICE_ID_EF_ATM_ASIC: u32 = 2;
pub const PCI_DEVICE_ID_EF_ATM_LANAI2: u32 = 3;
pub const PCI_DEVICE_ID_EF_ATM_LANAIHB: u32 = 5;
pub const PCI_VENDOR_ID_IDT: u32 = 4381;
pub const PCI_DEVICE_ID_IDT_IDT77201: u32 = 1;
pub const PCI_VENDOR_ID_FORE: u32 = 4391;
pub const PCI_DEVICE_ID_FORE_PCA200E: u32 = 768;
pub const PCI_VENDOR_ID_PHILIPS: u32 = 4401;
pub const PCI_DEVICE_ID_PHILIPS_SAA7146: u32 = 28998;
pub const PCI_DEVICE_ID_PHILIPS_SAA9730: u32 = 38704;
pub const PCI_VENDOR_ID_EICON: u32 = 4403;
pub const PCI_DEVICE_ID_EICON_DIVA20: u32 = 57346;
pub const PCI_DEVICE_ID_EICON_DIVA20_U: u32 = 57348;
pub const PCI_DEVICE_ID_EICON_DIVA201: u32 = 57349;
pub const PCI_DEVICE_ID_EICON_DIVA202: u32 = 57355;
pub const PCI_DEVICE_ID_EICON_MAESTRA: u32 = 57360;
pub const PCI_DEVICE_ID_EICON_MAESTRAQ: u32 = 57362;
pub const PCI_DEVICE_ID_EICON_MAESTRAQ_U: u32 = 57363;
pub const PCI_DEVICE_ID_EICON_MAESTRAP: u32 = 57364;
pub const PCI_VENDOR_ID_CISCO: u32 = 4407;
pub const PCI_VENDOR_ID_ZIATECH: u32 = 4408;
pub const PCI_DEVICE_ID_ZIATECH_5550_HC: u32 = 21840;
pub const PCI_VENDOR_ID_SYSKONNECT: u32 = 4424;
pub const PCI_DEVICE_ID_SYSKONNECT_TR: u32 = 16896;
pub const PCI_DEVICE_ID_SYSKONNECT_GE: u32 = 17152;
pub const PCI_DEVICE_ID_SYSKONNECT_YU: u32 = 17184;
pub const PCI_DEVICE_ID_SYSKONNECT_9DXX: u32 = 17408;
pub const PCI_DEVICE_ID_SYSKONNECT_9MXX: u32 = 17664;
pub const PCI_VENDOR_ID_DIGI: u32 = 4431;
pub const PCI_DEVICE_ID_DIGI_DF_M_IOM2_E: u32 = 112;
pub const PCI_DEVICE_ID_DIGI_DF_M_E: u32 = 113;
pub const PCI_DEVICE_ID_DIGI_DF_M_IOM2_A: u32 = 114;
pub const PCI_DEVICE_ID_DIGI_DF_M_A: u32 = 115;
pub const PCI_DEVICE_ID_DIGI_NEO_8: u32 = 177;
pub const PCI_DEVICE_ID_NEO_2DB9: u32 = 200;
pub const PCI_DEVICE_ID_NEO_2DB9PRI: u32 = 201;
pub const PCI_DEVICE_ID_NEO_2RJ45: u32 = 202;
pub const PCI_DEVICE_ID_NEO_2RJ45PRI: u32 = 203;
pub const PCIE_DEVICE_ID_NEO_4_IBM: u32 = 244;
pub const PCI_VENDOR_ID_XIRCOM: u32 = 4445;
pub const PCI_DEVICE_ID_XIRCOM_RBM56G: u32 = 257;
pub const PCI_DEVICE_ID_XIRCOM_X3201_MDM: u32 = 259;
pub const PCI_VENDOR_ID_SERVERWORKS: u32 = 4454;
pub const PCI_DEVICE_ID_SERVERWORKS_HE: u32 = 8;
pub const PCI_DEVICE_ID_SERVERWORKS_LE: u32 = 9;
pub const PCI_DEVICE_ID_SERVERWORKS_GCNB_LE: u32 = 23;
pub const PCI_DEVICE_ID_SERVERWORKS_HT1000_PXB: u32 = 54;
pub const PCI_DEVICE_ID_SERVERWORKS_EPB: u32 = 259;
pub const PCI_DEVICE_ID_SERVERWORKS_HT2000_PCIE: u32 = 306;
pub const PCI_DEVICE_ID_SERVERWORKS_OSB4: u32 = 512;
pub const PCI_DEVICE_ID_SERVERWORKS_CSB5: u32 = 513;
pub const PCI_DEVICE_ID_SERVERWORKS_CSB6: u32 = 515;
pub const PCI_DEVICE_ID_SERVERWORKS_HT1000SB: u32 = 517;
pub const PCI_DEVICE_ID_SERVERWORKS_OSB4IDE: u32 = 529;
pub const PCI_DEVICE_ID_SERVERWORKS_CSB5IDE: u32 = 530;
pub const PCI_DEVICE_ID_SERVERWORKS_CSB6IDE: u32 = 531;
pub const PCI_DEVICE_ID_SERVERWORKS_HT1000IDE: u32 = 532;
pub const PCI_DEVICE_ID_SERVERWORKS_CSB6IDE2: u32 = 535;
pub const PCI_DEVICE_ID_SERVERWORKS_CSB6LPC: u32 = 551;
pub const PCI_DEVICE_ID_SERVERWORKS_HT1100LD: u32 = 1032;
pub const PCI_VENDOR_ID_ALTERA: u32 = 4466;
pub const PCI_VENDOR_ID_SBE: u32 = 4470;
pub const PCI_DEVICE_ID_SBE_WANXL100: u32 = 769;
pub const PCI_DEVICE_ID_SBE_WANXL200: u32 = 770;
pub const PCI_DEVICE_ID_SBE_WANXL400: u32 = 260;
pub const PCI_SUBDEVICE_ID_SBE_T3E3: u32 = 9;
pub const PCI_SUBDEVICE_ID_SBE_2T3E3_P0: u32 = 2305;
pub const PCI_SUBDEVICE_ID_SBE_2T3E3_P1: u32 = 2306;
pub const PCI_VENDOR_ID_TOSHIBA: u32 = 4473;
pub const PCI_DEVICE_ID_TOSHIBA_PICCOLO_1: u32 = 257;
pub const PCI_DEVICE_ID_TOSHIBA_PICCOLO_2: u32 = 258;
pub const PCI_DEVICE_ID_TOSHIBA_PICCOLO_3: u32 = 259;
pub const PCI_DEVICE_ID_TOSHIBA_PICCOLO_5: u32 = 261;
pub const PCI_DEVICE_ID_TOSHIBA_TOPIC95: u32 = 1546;
pub const PCI_DEVICE_ID_TOSHIBA_TOPIC97: u32 = 1551;
pub const PCI_DEVICE_ID_TOSHIBA_TOPIC100: u32 = 1559;
pub const PCI_VENDOR_ID_TOSHIBA_2: u32 = 4143;
pub const PCI_DEVICE_ID_TOSHIBA_TC35815CF: u32 = 48;
pub const PCI_DEVICE_ID_TOSHIBA_TC35815_NWU: u32 = 49;
pub const PCI_DEVICE_ID_TOSHIBA_TC35815_TX4939: u32 = 50;
pub const PCI_DEVICE_ID_TOSHIBA_TC86C001_IDE: u32 = 261;
pub const PCI_DEVICE_ID_TOSHIBA_TC86C001_MISC: u32 = 264;
pub const PCI_DEVICE_ID_TOSHIBA_SPIDER_NET: u32 = 435;
pub const PCI_VENDOR_ID_ATTO: u32 = 4476;
pub const PCI_VENDOR_ID_RICOH: u32 = 4480;
pub const PCI_DEVICE_ID_RICOH_RL5C465: u32 = 1125;
pub const PCI_DEVICE_ID_RICOH_RL5C466: u32 = 1126;
pub const PCI_DEVICE_ID_RICOH_RL5C475: u32 = 1141;
pub const PCI_DEVICE_ID_RICOH_RL5C476: u32 = 1142;
pub const PCI_DEVICE_ID_RICOH_RL5C478: u32 = 1144;
pub const PCI_DEVICE_ID_RICOH_R5C822: u32 = 2082;
pub const PCI_DEVICE_ID_RICOH_R5CE822: u32 = 59426;
pub const PCI_DEVICE_ID_RICOH_R5CE823: u32 = 59427;
pub const PCI_DEVICE_ID_RICOH_R5C832: u32 = 2098;
pub const PCI_DEVICE_ID_RICOH_R5C843: u32 = 2115;
pub const PCI_VENDOR_ID_DLINK: u32 = 4486;
pub const PCI_DEVICE_ID_DLINK_DGE510T: u32 = 19456;
pub const PCI_VENDOR_ID_ARTOP: u32 = 4497;
pub const PCI_DEVICE_ID_ARTOP_ATP850UF: u32 = 5;
pub const PCI_DEVICE_ID_ARTOP_ATP860: u32 = 6;
pub const PCI_DEVICE_ID_ARTOP_ATP860R: u32 = 7;
pub const PCI_DEVICE_ID_ARTOP_ATP865: u32 = 8;
pub const PCI_DEVICE_ID_ARTOP_ATP865R: u32 = 9;
pub const PCI_DEVICE_ID_ARTOP_ATP867A: u32 = 10;
pub const PCI_DEVICE_ID_ARTOP_ATP867B: u32 = 11;
pub const PCI_DEVICE_ID_ARTOP_AEC7610: u32 = 32770;
pub const PCI_DEVICE_ID_ARTOP_AEC7612UW: u32 = 32784;
pub const PCI_DEVICE_ID_ARTOP_AEC7612U: u32 = 32800;
pub const PCI_DEVICE_ID_ARTOP_AEC7612S: u32 = 32816;
pub const PCI_DEVICE_ID_ARTOP_AEC7612D: u32 = 32832;
pub const PCI_DEVICE_ID_ARTOP_AEC7612SUW: u32 = 32848;
pub const PCI_DEVICE_ID_ARTOP_8060: u32 = 32864;
pub const PCI_VENDOR_ID_ZEITNET: u32 = 4499;
pub const PCI_DEVICE_ID_ZEITNET_1221: u32 = 1;
pub const PCI_DEVICE_ID_ZEITNET_1225: u32 = 2;
pub const PCI_VENDOR_ID_FUJITSU_ME: u32 = 4510;
pub const PCI_DEVICE_ID_FUJITSU_FS155: u32 = 1;
pub const PCI_DEVICE_ID_FUJITSU_FS50: u32 = 3;
pub const PCI_SUBVENDOR_ID_KEYSPAN: u32 = 4521;
pub const PCI_SUBDEVICE_ID_KEYSPAN_SX2: u32 = 21300;
pub const PCI_VENDOR_ID_MARVELL: u32 = 4523;
pub const PCI_VENDOR_ID_MARVELL_EXT: u32 = 6987;
pub const PCI_DEVICE_ID_MARVELL_GT64111: u32 = 16710;
pub const PCI_DEVICE_ID_MARVELL_GT64260: u32 = 25648;
pub const PCI_DEVICE_ID_MARVELL_MV64360: u32 = 25696;
pub const PCI_DEVICE_ID_MARVELL_MV64460: u32 = 25728;
pub const PCI_DEVICE_ID_MARVELL_88ALP01_NAND: u32 = 16640;
pub const PCI_DEVICE_ID_MARVELL_88ALP01_SD: u32 = 16641;
pub const PCI_DEVICE_ID_MARVELL_88ALP01_CCIC: u32 = 16642;
pub const PCI_VENDOR_ID_V3: u32 = 4528;
pub const PCI_DEVICE_ID_V3_V960: u32 = 1;
pub const PCI_DEVICE_ID_V3_V351: u32 = 2;
pub const PCI_VENDOR_ID_ATT: u32 = 4545;
pub const PCI_DEVICE_ID_ATT_VENUS_MODEM: u32 = 1152;
pub const PCI_VENDOR_ID_SPECIALIX: u32 = 4555;
pub const PCI_SUBDEVICE_ID_SPECIALIX_SPEED4: u32 = 40964;
pub const PCI_VENDOR_ID_ANALOG_DEVICES: u32 = 4564;
pub const PCI_DEVICE_ID_AD1889JS: u32 = 6281;
pub const PCI_DEVICE_ID_SEGA_BBA: u32 = 4660;
pub const PCI_VENDOR_ID_ZORAN: u32 = 4574;
pub const PCI_DEVICE_ID_ZORAN_36057: u32 = 24663;
pub const PCI_DEVICE_ID_ZORAN_36120: u32 = 24864;
pub const PCI_VENDOR_ID_COMPEX: u32 = 4598;
pub const PCI_DEVICE_ID_COMPEX_ENET100VG4: u32 = 274;
pub const PCI_VENDOR_ID_PMC_Sierra: u32 = 4600;
pub const PCI_VENDOR_ID_MICROSEMI: u32 = 4600;
pub const PCI_VENDOR_ID_RP: u32 = 4606;
pub const PCI_VENDOR_ID_CYCLADES: u32 = 4622;
pub const PCI_DEVICE_ID_PC300_RX_2: u32 = 768;
pub const PCI_DEVICE_ID_PC300_RX_1: u32 = 769;
pub const PCI_DEVICE_ID_PC300_TE_2: u32 = 784;
pub const PCI_DEVICE_ID_PC300_TE_1: u32 = 785;
pub const PCI_DEVICE_ID_PC300_TE_M_2: u32 = 800;
pub const PCI_DEVICE_ID_PC300_TE_M_1: u32 = 801;
pub const PCI_VENDOR_ID_ESSENTIAL: u32 = 4623;
pub const PCI_DEVICE_ID_ESSENTIAL_ROADRUNNER: u32 = 1;
pub const PCI_VENDOR_ID_O2: u32 = 4631;
pub const PCI_DEVICE_ID_O2_6729: u32 = 26409;
pub const PCI_DEVICE_ID_O2_6730: u32 = 26426;
pub const PCI_DEVICE_ID_O2_6832: u32 = 26674;
pub const PCI_DEVICE_ID_O2_6836: u32 = 26678;
pub const PCI_DEVICE_ID_O2_6812: u32 = 26738;
pub const PCI_DEVICE_ID_O2_6933: u32 = 26931;
pub const PCI_DEVICE_ID_O2_8120: u32 = 33056;
pub const PCI_DEVICE_ID_O2_8220: u32 = 33312;
pub const PCI_DEVICE_ID_O2_8221: u32 = 33313;
pub const PCI_DEVICE_ID_O2_8320: u32 = 33568;
pub const PCI_DEVICE_ID_O2_8321: u32 = 33569;
pub const PCI_VENDOR_ID_3DFX: u32 = 4634;
pub const PCI_DEVICE_ID_3DFX_VOODOO: u32 = 1;
pub const PCI_DEVICE_ID_3DFX_VOODOO2: u32 = 2;
pub const PCI_DEVICE_ID_3DFX_BANSHEE: u32 = 3;
pub const PCI_DEVICE_ID_3DFX_VOODOO3: u32 = 5;
pub const PCI_DEVICE_ID_3DFX_VOODOO5: u32 = 9;
pub const PCI_VENDOR_ID_AVM: u32 = 4676;
pub const PCI_DEVICE_ID_AVM_B1: u32 = 1792;
pub const PCI_DEVICE_ID_AVM_C4: u32 = 2048;
pub const PCI_DEVICE_ID_AVM_A1: u32 = 2560;
pub const PCI_DEVICE_ID_AVM_A1_V2: u32 = 3584;
pub const PCI_DEVICE_ID_AVM_C2: u32 = 4352;
pub const PCI_DEVICE_ID_AVM_T1: u32 = 4608;
pub const PCI_VENDOR_ID_STALLION: u32 = 4685;
pub const PCI_VENDOR_ID_AT: u32 = 4697;
pub const PCI_SUBDEVICE_ID_AT_2700FX: u32 = 9985;
pub const PCI_SUBDEVICE_ID_AT_2701FX: u32 = 9987;
pub const PCI_VENDOR_ID_ASIX: u32 = 4699;
pub const PCI_DEVICE_ID_ASIX_AX99100: u32 = 37120;
pub const PCI_DEVICE_ID_ASIX_AX99100_LB: u32 = 37136;
pub const PCI_VENDOR_ID_ESS: u32 = 4701;
pub const PCI_DEVICE_ID_ESS_ESS1968: u32 = 6504;
pub const PCI_DEVICE_ID_ESS_ESS1978: u32 = 6520;
pub const PCI_DEVICE_ID_ESS_ALLEGRO_1: u32 = 6536;
pub const PCI_DEVICE_ID_ESS_ALLEGRO: u32 = 6537;
pub const PCI_DEVICE_ID_ESS_CANYON3D_2LE: u32 = 6544;
pub const PCI_DEVICE_ID_ESS_CANYON3D_2: u32 = 6546;
pub const PCI_DEVICE_ID_ESS_MAESTRO3: u32 = 6552;
pub const PCI_DEVICE_ID_ESS_MAESTRO3_1: u32 = 6553;
pub const PCI_DEVICE_ID_ESS_MAESTRO3_HW: u32 = 6554;
pub const PCI_DEVICE_ID_ESS_MAESTRO3_2: u32 = 6555;
pub const PCI_VENDOR_ID_SATSAGEM: u32 = 4711;
pub const PCI_DEVICE_ID_SATSAGEM_NICCY: u32 = 4118;
pub const PCI_VENDOR_ID_ENSONIQ: u32 = 4724;
pub const PCI_DEVICE_ID_ENSONIQ_CT5880: u32 = 22656;
pub const PCI_DEVICE_ID_ENSONIQ_ES1370: u32 = 20480;
pub const PCI_DEVICE_ID_ENSONIQ_ES1371: u32 = 4977;
pub const PCI_VENDOR_ID_TRANSMETA: u32 = 4729;
pub const PCI_DEVICE_ID_EFFICEON: u32 = 96;
pub const PCI_VENDOR_ID_ROCKWELL: u32 = 4730;
pub const PCI_VENDOR_ID_ITE: u32 = 4739;
pub const PCI_DEVICE_ID_ITE_8172: u32 = 33138;
pub const PCI_DEVICE_ID_ITE_8211: u32 = 33297;
pub const PCI_DEVICE_ID_ITE_8212: u32 = 33298;
pub const PCI_DEVICE_ID_ITE_8213: u32 = 33299;
pub const PCI_DEVICE_ID_ITE_8152: u32 = 33106;
pub const PCI_DEVICE_ID_ITE_8872: u32 = 34930;
pub const PCI_DEVICE_ID_ITE_IT8330G_0: u32 = 59526;
pub const PCI_DEVICE_ID_ESS_ESS0100: u32 = 256;
pub const PCI_VENDOR_ID_ALTEON: u32 = 4782;
pub const PCI_SUBVENDOR_ID_CONNECT_TECH: u32 = 4804;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_BH8_232: u32 = 1;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_BH4_232: u32 = 2;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_BH2_232: u32 = 3;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_BH8_485: u32 = 4;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_BH8_485_4_4: u32 = 5;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_BH4_485: u32 = 6;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_BH4_485_2_2: u32 = 7;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_BH2_485: u32 = 8;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_BH8_485_2_6: u32 = 9;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_BH081101V1: u32 = 10;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_BH041101V1: u32 = 11;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_BH2_20MHZ: u32 = 12;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_BH2_PTM: u32 = 13;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_NT960PCI: u32 = 256;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_TITAN_2: u32 = 513;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_TITAN_4: u32 = 514;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_2_232: u32 = 768;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_4_232: u32 = 769;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_8_232: u32 = 770;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_1_1: u32 = 784;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_2_2: u32 = 785;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_4_4: u32 = 786;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_2: u32 = 800;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_4: u32 = 801;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_8: u32 = 802;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_2_485: u32 = 816;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_4_485: u32 = 817;
pub const PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_8_485: u32 = 818;
pub const PCI_VENDOR_ID_NVIDIA_SGS: u32 = 4818;
pub const PCI_DEVICE_ID_NVIDIA_SGS_RIVA128: u32 = 24;
pub const PCI_VENDOR_ID_PERICOM: u32 = 4824;
pub const PCI_DEVICE_ID_PERICOM_PI7C9X7951: u32 = 31057;
pub const PCI_DEVICE_ID_PERICOM_PI7C9X7952: u32 = 31058;
pub const PCI_DEVICE_ID_PERICOM_PI7C9X7954: u32 = 31060;
pub const PCI_DEVICE_ID_PERICOM_PI7C9X7958: u32 = 31064;
pub const PCI_SUBVENDOR_ID_CHASE_PCIFAST: u32 = 4832;
pub const PCI_SUBDEVICE_ID_CHASE_PCIFAST4: u32 = 49;
pub const PCI_SUBDEVICE_ID_CHASE_PCIFAST8: u32 = 33;
pub const PCI_SUBDEVICE_ID_CHASE_PCIFAST16: u32 = 17;
pub const PCI_SUBDEVICE_ID_CHASE_PCIFAST16FMC: u32 = 65;
pub const PCI_SUBVENDOR_ID_CHASE_PCIRAS: u32 = 4685;
pub const PCI_SUBDEVICE_ID_CHASE_PCIRAS4: u32 = 61441;
pub const PCI_SUBDEVICE_ID_CHASE_PCIRAS8: u32 = 61456;
pub const PCI_VENDOR_ID_AUREAL: u32 = 4843;
pub const PCI_DEVICE_ID_AUREAL_VORTEX_1: u32 = 1;
pub const PCI_DEVICE_ID_AUREAL_VORTEX_2: u32 = 2;
pub const PCI_DEVICE_ID_AUREAL_ADVANTAGE: u32 = 3;
pub const PCI_VENDOR_ID_ELECTRONICDESIGNGMBH: u32 = 4856;
pub const PCI_DEVICE_ID_LML_33R10: u32 = 35330;
pub const PCI_VENDOR_ID_ESDGMBH: u32 = 4862;
pub const PCI_DEVICE_ID_ESDGMBH_CPCIASIO4: u32 = 273;
pub const PCI_VENDOR_ID_CB: u32 = 4871;
pub const PCI_VENDOR_ID_SIIG: u32 = 4895;
pub const PCI_SUBVENDOR_ID_SIIG: u32 = 4895;
pub const PCI_DEVICE_ID_SIIG_1S_10x_550: u32 = 4096;
pub const PCI_DEVICE_ID_SIIG_1S_10x_650: u32 = 4097;
pub const PCI_DEVICE_ID_SIIG_1S_10x_850: u32 = 4098;
pub const PCI_DEVICE_ID_SIIG_1S1P_10x_550: u32 = 4112;
pub const PCI_DEVICE_ID_SIIG_1S1P_10x_650: u32 = 4113;
pub const PCI_DEVICE_ID_SIIG_1S1P_10x_850: u32 = 4114;
pub const PCI_DEVICE_ID_SIIG_1P_10x: u32 = 4128;
pub const PCI_DEVICE_ID_SIIG_2P_10x: u32 = 4129;
pub const PCI_DEVICE_ID_SIIG_2S_10x_550: u32 = 4144;
pub const PCI_DEVICE_ID_SIIG_2S_10x_650: u32 = 4145;
pub const PCI_DEVICE_ID_SIIG_2S_10x_850: u32 = 4146;
pub const PCI_DEVICE_ID_SIIG_2S1P_10x_550: u32 = 4148;
pub const PCI_DEVICE_ID_SIIG_2S1P_10x_650: u32 = 4149;
pub const PCI_DEVICE_ID_SIIG_2S1P_10x_850: u32 = 4150;
pub const PCI_DEVICE_ID_SIIG_4S_10x_550: u32 = 4176;
pub const PCI_DEVICE_ID_SIIG_4S_10x_650: u32 = 4177;
pub const PCI_DEVICE_ID_SIIG_4S_10x_850: u32 = 4178;
pub const PCI_DEVICE_ID_SIIG_1S_20x_550: u32 = 8192;
pub const PCI_DEVICE_ID_SIIG_1S_20x_650: u32 = 8193;
pub const PCI_DEVICE_ID_SIIG_1S_20x_850: u32 = 8194;
pub const PCI_DEVICE_ID_SIIG_1P_20x: u32 = 8224;
pub const PCI_DEVICE_ID_SIIG_2P_20x: u32 = 8225;
pub const PCI_DEVICE_ID_SIIG_2S_20x_550: u32 = 8240;
pub const PCI_DEVICE_ID_SIIG_2S_20x_650: u32 = 8241;
pub const PCI_DEVICE_ID_SIIG_2S_20x_850: u32 = 8242;
pub const PCI_DEVICE_ID_SIIG_2P1S_20x_550: u32 = 8256;
pub const PCI_DEVICE_ID_SIIG_2P1S_20x_650: u32 = 8257;
pub const PCI_DEVICE_ID_SIIG_2P1S_20x_850: u32 = 8258;
pub const PCI_DEVICE_ID_SIIG_1S1P_20x_550: u32 = 8208;
pub const PCI_DEVICE_ID_SIIG_1S1P_20x_650: u32 = 8209;
pub const PCI_DEVICE_ID_SIIG_1S1P_20x_850: u32 = 8210;
pub const PCI_DEVICE_ID_SIIG_4S_20x_550: u32 = 8272;
pub const PCI_DEVICE_ID_SIIG_4S_20x_650: u32 = 8273;
pub const PCI_DEVICE_ID_SIIG_4S_20x_850: u32 = 8274;
pub const PCI_DEVICE_ID_SIIG_2S1P_20x_550: u32 = 8288;
pub const PCI_DEVICE_ID_SIIG_2S1P_20x_650: u32 = 8289;
pub const PCI_DEVICE_ID_SIIG_2S1P_20x_850: u32 = 8290;
pub const PCI_DEVICE_ID_SIIG_8S_20x_550: u32 = 8320;
pub const PCI_DEVICE_ID_SIIG_8S_20x_650: u32 = 8321;
pub const PCI_DEVICE_ID_SIIG_8S_20x_850: u32 = 8322;
pub const PCI_SUBDEVICE_ID_SIIG_QUARTET_SERIAL: u32 = 8272;
pub const PCI_VENDOR_ID_RADISYS: u32 = 4913;
pub const PCI_VENDOR_ID_MICRO_MEMORY: u32 = 4914;
pub const PCI_DEVICE_ID_MICRO_MEMORY_5415CN: u32 = 21525;
pub const PCI_DEVICE_ID_MICRO_MEMORY_5425CN: u32 = 21541;
pub const PCI_DEVICE_ID_MICRO_MEMORY_6155: u32 = 24917;
pub const PCI_VENDOR_ID_DOMEX: u32 = 4938;
pub const PCI_DEVICE_ID_DOMEX_DMX3191D: u32 = 1;
pub const PCI_VENDOR_ID_INTASHIELD: u32 = 4954;
pub const PCI_DEVICE_ID_INTASHIELD_IS200: u32 = 3456;
pub const PCI_DEVICE_ID_INTASHIELD_IS400: u32 = 3520;
pub const PCI_VENDOR_ID_QUATECH: u32 = 4956;
pub const PCI_DEVICE_ID_QUATECH_QSC100: u32 = 16;
pub const PCI_DEVICE_ID_QUATECH_DSC100: u32 = 32;
pub const PCI_DEVICE_ID_QUATECH_DSC200: u32 = 48;
pub const PCI_DEVICE_ID_QUATECH_QSC200: u32 = 64;
pub const PCI_DEVICE_ID_QUATECH_ESC100D: u32 = 80;
pub const PCI_DEVICE_ID_QUATECH_ESC100M: u32 = 96;
pub const PCI_DEVICE_ID_QUATECH_QSCP100: u32 = 288;
pub const PCI_DEVICE_ID_QUATECH_DSCP100: u32 = 304;
pub const PCI_DEVICE_ID_QUATECH_QSCP200: u32 = 320;
pub const PCI_DEVICE_ID_QUATECH_DSCP200: u32 = 336;
pub const PCI_DEVICE_ID_QUATECH_QSCLP100: u32 = 368;
pub const PCI_DEVICE_ID_QUATECH_DSCLP100: u32 = 384;
pub const PCI_DEVICE_ID_QUATECH_DSC100E: u32 = 385;
pub const PCI_DEVICE_ID_QUATECH_SSCLP100: u32 = 400;
pub const PCI_DEVICE_ID_QUATECH_QSCLP200: u32 = 416;
pub const PCI_DEVICE_ID_QUATECH_DSCLP200: u32 = 432;
pub const PCI_DEVICE_ID_QUATECH_DSC200E: u32 = 433;
pub const PCI_DEVICE_ID_QUATECH_SSCLP200: u32 = 448;
pub const PCI_DEVICE_ID_QUATECH_ESCLP100: u32 = 480;
pub const PCI_DEVICE_ID_QUATECH_SPPXP_100: u32 = 632;
pub const PCI_VENDOR_ID_SEALEVEL: u32 = 4958;
pub const PCI_DEVICE_ID_SEALEVEL_U530: u32 = 28929;
pub const PCI_DEVICE_ID_SEALEVEL_UCOMM2: u32 = 29185;
pub const PCI_DEVICE_ID_SEALEVEL_UCOMM422: u32 = 29698;
pub const PCI_DEVICE_ID_SEALEVEL_UCOMM232: u32 = 29186;
pub const PCI_DEVICE_ID_SEALEVEL_COMM4: u32 = 29697;
pub const PCI_DEVICE_ID_SEALEVEL_COMM8: u32 = 30721;
pub const PCI_DEVICE_ID_SEALEVEL_7803: u32 = 30723;
pub const PCI_DEVICE_ID_SEALEVEL_UCOMM8: u32 = 30724;
pub const PCI_VENDOR_ID_HYPERCOPE: u32 = 4965;
pub const PCI_DEVICE_ID_HYPERCOPE_PLX: u32 = 36944;
pub const PCI_SUBDEVICE_ID_HYPERCOPE_OLD_ERGO: u32 = 260;
pub const PCI_SUBDEVICE_ID_HYPERCOPE_ERGO: u32 = 262;
pub const PCI_SUBDEVICE_ID_HYPERCOPE_METRO: u32 = 263;
pub const PCI_SUBDEVICE_ID_HYPERCOPE_CHAMP2: u32 = 264;
pub const PCI_VENDOR_ID_DIGIGRAM: u32 = 4969;
pub const PCI_SUBDEVICE_ID_DIGIGRAM_LX6464ES_SERIAL_SUBSYSTEM: u32 = 49153;
pub const PCI_SUBDEVICE_ID_DIGIGRAM_LX6464ES_CAE_SERIAL_SUBSYSTEM: u32 = 49154;
pub const PCI_SUBDEVICE_ID_DIGIGRAM_LX6464ESE_SERIAL_SUBSYSTEM: u32 = 49185;
pub const PCI_SUBDEVICE_ID_DIGIGRAM_LX6464ESE_CAE_SERIAL_SUBSYSTEM: u32 = 49186;
pub const PCI_VENDOR_ID_KAWASAKI: u32 = 4971;
pub const PCI_DEVICE_ID_MCHIP_KL5A72002: u32 = 65281;
pub const PCI_VENDOR_ID_CNET: u32 = 4977;
pub const PCI_DEVICE_ID_CNET_GIGACARD: u32 = 17230;
pub const PCI_VENDOR_ID_LMC: u32 = 4982;
pub const PCI_DEVICE_ID_LMC_HSSI: u32 = 3;
pub const PCI_DEVICE_ID_LMC_DS3: u32 = 4;
pub const PCI_DEVICE_ID_LMC_SSI: u32 = 5;
pub const PCI_DEVICE_ID_LMC_T1: u32 = 6;
pub const PCI_VENDOR_ID_NETGEAR: u32 = 4997;
pub const PCI_DEVICE_ID_NETGEAR_GA620: u32 = 25098;
pub const PCI_VENDOR_ID_APPLICOM: u32 = 5001;
pub const PCI_DEVICE_ID_APPLICOM_PCIGENERIC: u32 = 1;
pub const PCI_DEVICE_ID_APPLICOM_PCI2000IBS_CAN: u32 = 2;
pub const PCI_DEVICE_ID_APPLICOM_PCI2000PFB: u32 = 3;
pub const PCI_VENDOR_ID_MOXA: u32 = 5011;
pub const PCI_DEVICE_ID_MOXA_CP204J: u32 = 8256;
pub const PCI_DEVICE_ID_MOXA_C218: u32 = 8576;
pub const PCI_DEVICE_ID_MOXA_C320: u32 = 12800;
pub const PCI_VENDOR_ID_CCD: u32 = 5015;
pub const PCI_DEVICE_ID_CCD_HFC4S: u32 = 2228;
pub const PCI_SUBDEVICE_ID_CCD_PMX2S: u32 = 4660;
pub const PCI_DEVICE_ID_CCD_HFC8S: u32 = 5816;
pub const PCI_DEVICE_ID_CCD_2BD0: u32 = 11216;
pub const PCI_DEVICE_ID_CCD_HFCE1: u32 = 12465;
pub const PCI_SUBDEVICE_ID_CCD_SPD4S: u32 = 12598;
pub const PCI_SUBDEVICE_ID_CCD_SPDE1: u32 = 12599;
pub const PCI_DEVICE_ID_CCD_B000: u32 = 45056;
pub const PCI_DEVICE_ID_CCD_B006: u32 = 45062;
pub const PCI_DEVICE_ID_CCD_B007: u32 = 45063;
pub const PCI_DEVICE_ID_CCD_B008: u32 = 45064;
pub const PCI_DEVICE_ID_CCD_B009: u32 = 45065;
pub const PCI_DEVICE_ID_CCD_B00A: u32 = 45066;
pub const PCI_DEVICE_ID_CCD_B00B: u32 = 45067;
pub const PCI_DEVICE_ID_CCD_B00C: u32 = 45068;
pub const PCI_DEVICE_ID_CCD_B100: u32 = 45312;
pub const PCI_SUBDEVICE_ID_CCD_IOB4ST: u32 = 46368;
pub const PCI_SUBDEVICE_ID_CCD_IOB8STR: u32 = 46369;
pub const PCI_SUBDEVICE_ID_CCD_IOB8ST: u32 = 46370;
pub const PCI_SUBDEVICE_ID_CCD_IOB1E1: u32 = 46371;
pub const PCI_SUBDEVICE_ID_CCD_SWYX4S: u32 = 46400;
pub const PCI_SUBDEVICE_ID_CCD_JH4S20: u32 = 46416;
pub const PCI_SUBDEVICE_ID_CCD_IOB8ST_1: u32 = 46418;
pub const PCI_SUBDEVICE_ID_CCD_JHSE1: u32 = 46419;
pub const PCI_SUBDEVICE_ID_CCD_JH8S: u32 = 46427;
pub const PCI_SUBDEVICE_ID_CCD_BN4S: u32 = 46432;
pub const PCI_SUBDEVICE_ID_CCD_BN8S: u32 = 46434;
pub const PCI_SUBDEVICE_ID_CCD_BNE1: u32 = 46435;
pub const PCI_SUBDEVICE_ID_CCD_BNE1D: u32 = 46436;
pub const PCI_SUBDEVICE_ID_CCD_BNE1DP: u32 = 46437;
pub const PCI_SUBDEVICE_ID_CCD_BN2S: u32 = 46438;
pub const PCI_SUBDEVICE_ID_CCD_BN1SM: u32 = 46439;
pub const PCI_SUBDEVICE_ID_CCD_BN4SM: u32 = 46440;
pub const PCI_SUBDEVICE_ID_CCD_BN2SM: u32 = 46441;
pub const PCI_SUBDEVICE_ID_CCD_BNE1M: u32 = 46442;
pub const PCI_SUBDEVICE_ID_CCD_BN8SP: u32 = 46443;
pub const PCI_SUBDEVICE_ID_CCD_HFC4S: u32 = 46624;
pub const PCI_SUBDEVICE_ID_CCD_HFC8S: u32 = 46626;
pub const PCI_DEVICE_ID_CCD_B700: u32 = 46848;
pub const PCI_DEVICE_ID_CCD_B701: u32 = 46849;
pub const PCI_SUBDEVICE_ID_CCD_HFCE1: u32 = 50467;
pub const PCI_SUBDEVICE_ID_CCD_OV2S: u32 = 59524;
pub const PCI_SUBDEVICE_ID_CCD_OV4S: u32 = 59528;
pub const PCI_SUBDEVICE_ID_CCD_OV8S: u32 = 59800;
pub const PCI_VENDOR_ID_EXAR: u32 = 5032;
pub const PCI_DEVICE_ID_EXAR_XR17C152: u32 = 338;
pub const PCI_DEVICE_ID_EXAR_XR17C154: u32 = 340;
pub const PCI_DEVICE_ID_EXAR_XR17C158: u32 = 344;
pub const PCI_DEVICE_ID_EXAR_XR17V352: u32 = 850;
pub const PCI_DEVICE_ID_EXAR_XR17V354: u32 = 852;
pub const PCI_DEVICE_ID_EXAR_XR17V358: u32 = 856;
pub const PCI_VENDOR_ID_MICROGATE: u32 = 5056;
pub const PCI_VENDOR_ID_3WARE: u32 = 5057;
pub const PCI_DEVICE_ID_3WARE_1000: u32 = 4096;
pub const PCI_DEVICE_ID_3WARE_7000: u32 = 4097;
pub const PCI_DEVICE_ID_3WARE_9000: u32 = 4098;
pub const PCI_VENDOR_ID_IOMEGA: u32 = 5066;
pub const PCI_DEVICE_ID_IOMEGA_BUZ: u32 = 16945;
pub const PCI_VENDOR_ID_ABOCOM: u32 = 5073;
pub const PCI_DEVICE_ID_ABOCOM_2BD1: u32 = 11217;
pub const PCI_VENDOR_ID_SUNDANCE: u32 = 5104;
pub const PCI_VENDOR_ID_CMEDIA: u32 = 5110;
pub const PCI_DEVICE_ID_CMEDIA_CM8338A: u32 = 256;
pub const PCI_DEVICE_ID_CMEDIA_CM8338B: u32 = 257;
pub const PCI_DEVICE_ID_CMEDIA_CM8738: u32 = 273;
pub const PCI_DEVICE_ID_CMEDIA_CM8738B: u32 = 274;
pub const PCI_VENDOR_ID_ADVANTECH: u32 = 5118;
pub const PCI_VENDOR_ID_MEILHAUS: u32 = 5122;
pub const PCI_VENDOR_ID_LAVA: u32 = 5127;
pub const PCI_DEVICE_ID_LAVA_DSERIAL: u32 = 256;
pub const PCI_DEVICE_ID_LAVA_QUATRO_A: u32 = 257;
pub const PCI_DEVICE_ID_LAVA_QUATRO_B: u32 = 258;
pub const PCI_DEVICE_ID_LAVA_QUATTRO_A: u32 = 288;
pub const PCI_DEVICE_ID_LAVA_QUATTRO_B: u32 = 289;
pub const PCI_DEVICE_ID_LAVA_OCTO_A: u32 = 384;
pub const PCI_DEVICE_ID_LAVA_OCTO_B: u32 = 385;
pub const PCI_DEVICE_ID_LAVA_PORT_PLUS: u32 = 512;
pub const PCI_DEVICE_ID_LAVA_QUAD_A: u32 = 513;
pub const PCI_DEVICE_ID_LAVA_QUAD_B: u32 = 514;
pub const PCI_DEVICE_ID_LAVA_SSERIAL: u32 = 1280;
pub const PCI_DEVICE_ID_LAVA_PORT_650: u32 = 1536;
pub const PCI_DEVICE_ID_LAVA_PARALLEL: u32 = 32768;
pub const PCI_DEVICE_ID_LAVA_DUAL_PAR_A: u32 = 32770;
pub const PCI_DEVICE_ID_LAVA_DUAL_PAR_B: u32 = 32771;
pub const PCI_DEVICE_ID_LAVA_BOCA_IOPPAR: u32 = 34816;
pub const PCI_VENDOR_ID_TIMEDIA: u32 = 5129;
pub const PCI_DEVICE_ID_TIMEDIA_1889: u32 = 29032;
pub const PCI_VENDOR_ID_ICE: u32 = 5138;
pub const PCI_DEVICE_ID_ICE_1712: u32 = 5906;
pub const PCI_DEVICE_ID_VT1724: u32 = 5924;
pub const PCI_VENDOR_ID_MICROSOFT: u32 = 5140;
pub const PCI_DEVICE_ID_HYPERV_VIDEO: u32 = 21331;
pub const PCI_VENDOR_ID_OXSEMI: u32 = 5141;
pub const PCI_DEVICE_ID_OXSEMI_12PCI840: u32 = 33795;
pub const PCI_DEVICE_ID_OXSEMI_PCIe840: u32 = 49152;
pub const PCI_DEVICE_ID_OXSEMI_PCIe840_G: u32 = 49156;
pub const PCI_DEVICE_ID_OXSEMI_PCIe952_0: u32 = 49408;
pub const PCI_DEVICE_ID_OXSEMI_PCIe952_0_G: u32 = 49412;
pub const PCI_DEVICE_ID_OXSEMI_PCIe952_1: u32 = 49424;
pub const PCI_DEVICE_ID_OXSEMI_PCIe952_1_G: u32 = 49428;
pub const PCI_DEVICE_ID_OXSEMI_PCIe952_1_U: u32 = 49432;
pub const PCI_DEVICE_ID_OXSEMI_PCIe952_1_GU: u32 = 49436;
pub const PCI_DEVICE_ID_OXSEMI_16PCI954: u32 = 38145;
pub const PCI_DEVICE_ID_OXSEMI_C950: u32 = 38155;
pub const PCI_DEVICE_ID_OXSEMI_16PCI95N: u32 = 38161;
pub const PCI_DEVICE_ID_OXSEMI_16PCI954PP: u32 = 38163;
pub const PCI_DEVICE_ID_OXSEMI_16PCI952: u32 = 38177;
pub const PCI_DEVICE_ID_OXSEMI_16PCI952PP: u32 = 38179;
pub const PCI_SUBDEVICE_ID_OXSEMI_C950: u32 = 1;
pub const PCI_VENDOR_ID_CHELSIO: u32 = 5157;
pub const PCI_VENDOR_ID_EDIMAX: u32 = 5170;
pub const PCI_VENDOR_ID_ADLINK: u32 = 5194;
pub const PCI_VENDOR_ID_SAMSUNG: u32 = 5197;
pub const PCI_VENDOR_ID_GIGABYTE: u32 = 5208;
pub const PCI_VENDOR_ID_AMBIT: u32 = 5224;
pub const PCI_VENDOR_ID_MYRICOM: u32 = 5313;
pub const PCI_VENDOR_ID_MEDIATEK: u32 = 5315;
pub const PCI_DEVICE_ID_MEDIATEK_7629: u32 = 30249;
pub const PCI_VENDOR_ID_TITAN: u32 = 5330;
pub const PCI_DEVICE_ID_TITAN_010L: u32 = 32769;
pub const PCI_DEVICE_ID_TITAN_100L: u32 = 32784;
pub const PCI_DEVICE_ID_TITAN_110L: u32 = 32785;
pub const PCI_DEVICE_ID_TITAN_200L: u32 = 32800;
pub const PCI_DEVICE_ID_TITAN_210L: u32 = 32801;
pub const PCI_DEVICE_ID_TITAN_400L: u32 = 32832;
pub const PCI_DEVICE_ID_TITAN_800L: u32 = 32896;
pub const PCI_DEVICE_ID_TITAN_100: u32 = 40961;
pub const PCI_DEVICE_ID_TITAN_200: u32 = 40965;
pub const PCI_DEVICE_ID_TITAN_400: u32 = 40963;
pub const PCI_DEVICE_ID_TITAN_800B: u32 = 40964;
pub const PCI_VENDOR_ID_PANACOM: u32 = 5332;
pub const PCI_DEVICE_ID_PANACOM_QUADMODEM: u32 = 1024;
pub const PCI_DEVICE_ID_PANACOM_DUALMODEM: u32 = 1026;
pub const PCI_VENDOR_ID_SIPACKETS: u32 = 5337;
pub const PCI_DEVICE_ID_SP1011: u32 = 16;
pub const PCI_VENDOR_ID_AFAVLAB: u32 = 5339;
pub const PCI_DEVICE_ID_AFAVLAB_P028: u32 = 8576;
pub const PCI_DEVICE_ID_AFAVLAB_P030: u32 = 8578;
pub const PCI_SUBDEVICE_ID_AFAVLAB_P061: u32 = 8528;
pub const PCI_VENDOR_ID_AMPLICON: u32 = 5340;
pub const PCI_VENDOR_ID_BCM_GVC: u32 = 5284;
pub const PCI_VENDOR_ID_BROADCOM: u32 = 5348;
pub const PCI_DEVICE_ID_TIGON3_5752: u32 = 5632;
pub const PCI_DEVICE_ID_TIGON3_5752M: u32 = 5633;
pub const PCI_DEVICE_ID_NX2_5709: u32 = 5689;
pub const PCI_DEVICE_ID_NX2_5709S: u32 = 5690;
pub const PCI_DEVICE_ID_TIGON3_5700: u32 = 5700;
pub const PCI_DEVICE_ID_TIGON3_5701: u32 = 5701;
pub const PCI_DEVICE_ID_TIGON3_5702: u32 = 5702;
pub const PCI_DEVICE_ID_TIGON3_5703: u32 = 5703;
pub const PCI_DEVICE_ID_TIGON3_5704: u32 = 5704;
pub const PCI_DEVICE_ID_TIGON3_5704S_2: u32 = 5705;
pub const PCI_DEVICE_ID_NX2_5706: u32 = 5706;
pub const PCI_DEVICE_ID_NX2_5708: u32 = 5708;
pub const PCI_DEVICE_ID_TIGON3_5702FE: u32 = 5709;
pub const PCI_DEVICE_ID_NX2_57710: u32 = 5710;
pub const PCI_DEVICE_ID_NX2_57711: u32 = 5711;
pub const PCI_DEVICE_ID_NX2_57711E: u32 = 5712;
pub const PCI_DEVICE_ID_TIGON3_5705: u32 = 5715;
pub const PCI_DEVICE_ID_TIGON3_5705_2: u32 = 5716;
pub const PCI_DEVICE_ID_TIGON3_5719: u32 = 5719;
pub const PCI_DEVICE_ID_TIGON3_5721: u32 = 5721;
pub const PCI_DEVICE_ID_TIGON3_5722: u32 = 5722;
pub const PCI_DEVICE_ID_TIGON3_5723: u32 = 5723;
pub const PCI_DEVICE_ID_TIGON3_5705M: u32 = 5725;
pub const PCI_DEVICE_ID_TIGON3_5705M_2: u32 = 5726;
pub const PCI_DEVICE_ID_NX2_57712: u32 = 5730;
pub const PCI_DEVICE_ID_NX2_57712E: u32 = 5731;
pub const PCI_DEVICE_ID_NX2_57712_MF: u32 = 5731;
pub const PCI_DEVICE_ID_TIGON3_5714: u32 = 5736;
pub const PCI_DEVICE_ID_TIGON3_5714S: u32 = 5737;
pub const PCI_DEVICE_ID_TIGON3_5780: u32 = 5738;
pub const PCI_DEVICE_ID_TIGON3_5780S: u32 = 5739;
pub const PCI_DEVICE_ID_TIGON3_5705F: u32 = 5742;
pub const PCI_DEVICE_ID_NX2_57712_VF: u32 = 5743;
pub const PCI_DEVICE_ID_TIGON3_5754M: u32 = 5746;
pub const PCI_DEVICE_ID_TIGON3_5755M: u32 = 5747;
pub const PCI_DEVICE_ID_TIGON3_5756: u32 = 5748;
pub const PCI_DEVICE_ID_TIGON3_5750: u32 = 5750;
pub const PCI_DEVICE_ID_TIGON3_5751: u32 = 5751;
pub const PCI_DEVICE_ID_TIGON3_5715: u32 = 5752;
pub const PCI_DEVICE_ID_TIGON3_5715S: u32 = 5753;
pub const PCI_DEVICE_ID_TIGON3_5754: u32 = 5754;
pub const PCI_DEVICE_ID_TIGON3_5755: u32 = 5755;
pub const PCI_DEVICE_ID_TIGON3_5751M: u32 = 5757;
pub const PCI_DEVICE_ID_TIGON3_5751F: u32 = 5758;
pub const PCI_DEVICE_ID_TIGON3_5787F: u32 = 5759;
pub const PCI_DEVICE_ID_TIGON3_5761E: u32 = 5760;
pub const PCI_DEVICE_ID_TIGON3_5761: u32 = 5761;
pub const PCI_DEVICE_ID_TIGON3_5764: u32 = 5764;
pub const PCI_DEVICE_ID_NX2_57800: u32 = 5770;
pub const PCI_DEVICE_ID_NX2_57840: u32 = 5773;
pub const PCI_DEVICE_ID_NX2_57810: u32 = 5774;
pub const PCI_DEVICE_ID_TIGON3_5787M: u32 = 5779;
pub const PCI_DEVICE_ID_TIGON3_5782: u32 = 5782;
pub const PCI_DEVICE_ID_TIGON3_5784: u32 = 5784;
pub const PCI_DEVICE_ID_TIGON3_5786: u32 = 5786;
pub const PCI_DEVICE_ID_TIGON3_5787: u32 = 5787;
pub const PCI_DEVICE_ID_TIGON3_5788: u32 = 5788;
pub const PCI_DEVICE_ID_TIGON3_5789: u32 = 5789;
pub const PCI_DEVICE_ID_NX2_57840_4_10: u32 = 5793;
pub const PCI_DEVICE_ID_NX2_57840_2_20: u32 = 5794;
pub const PCI_DEVICE_ID_NX2_57840_MF: u32 = 5796;
pub const PCI_DEVICE_ID_NX2_57800_MF: u32 = 5797;
pub const PCI_DEVICE_ID_TIGON3_5702X: u32 = 5798;
pub const PCI_DEVICE_ID_TIGON3_5703X: u32 = 5799;
pub const PCI_DEVICE_ID_TIGON3_5704S: u32 = 5800;
pub const PCI_DEVICE_ID_NX2_57800_VF: u32 = 5801;
pub const PCI_DEVICE_ID_NX2_5706S: u32 = 5802;
pub const PCI_DEVICE_ID_NX2_5708S: u32 = 5804;
pub const PCI_DEVICE_ID_NX2_57840_VF: u32 = 5805;
pub const PCI_DEVICE_ID_NX2_57810_MF: u32 = 5806;
pub const PCI_DEVICE_ID_NX2_57810_VF: u32 = 5807;
pub const PCI_DEVICE_ID_TIGON3_5702A3: u32 = 5830;
pub const PCI_DEVICE_ID_TIGON3_5703A3: u32 = 5831;
pub const PCI_DEVICE_ID_TIGON3_5781: u32 = 5853;
pub const PCI_DEVICE_ID_TIGON3_5753: u32 = 5879;
pub const PCI_DEVICE_ID_TIGON3_5753M: u32 = 5885;
pub const PCI_DEVICE_ID_TIGON3_5753F: u32 = 5886;
pub const PCI_DEVICE_ID_TIGON3_5901: u32 = 5901;
pub const PCI_DEVICE_ID_BCM4401B1: u32 = 5900;
pub const PCI_DEVICE_ID_TIGON3_5901_2: u32 = 5902;
pub const PCI_DEVICE_ID_TIGON3_5906: u32 = 5906;
pub const PCI_DEVICE_ID_TIGON3_5906M: u32 = 5907;
pub const PCI_DEVICE_ID_BCM4401: u32 = 17409;
pub const PCI_DEVICE_ID_BCM4401B0: u32 = 17410;
pub const PCI_VENDOR_ID_TOPIC: u32 = 5407;
pub const PCI_DEVICE_ID_TOPIC_TP560: u32 = 0;
pub const PCI_VENDOR_ID_MAINPINE: u32 = 5410;
pub const PCI_DEVICE_ID_MAINPINE_PBRIDGE: u32 = 256;
pub const PCI_VENDOR_ID_ENE: u32 = 5412;
pub const PCI_DEVICE_ID_ENE_CB710_FLASH: u32 = 1296;
pub const PCI_DEVICE_ID_ENE_CB712_SD: u32 = 1360;
pub const PCI_DEVICE_ID_ENE_CB712_SD_2: u32 = 1361;
pub const PCI_DEVICE_ID_ENE_CB714_SD: u32 = 1872;
pub const PCI_DEVICE_ID_ENE_CB714_SD_2: u32 = 1873;
pub const PCI_DEVICE_ID_ENE_1211: u32 = 4625;
pub const PCI_DEVICE_ID_ENE_1225: u32 = 4645;
pub const PCI_DEVICE_ID_ENE_1410: u32 = 5136;
pub const PCI_DEVICE_ID_ENE_710: u32 = 5137;
pub const PCI_DEVICE_ID_ENE_712: u32 = 5138;
pub const PCI_DEVICE_ID_ENE_1420: u32 = 5152;
pub const PCI_DEVICE_ID_ENE_720: u32 = 5153;
pub const PCI_DEVICE_ID_ENE_722: u32 = 5154;
pub const PCI_SUBVENDOR_ID_PERLE: u32 = 5471;
pub const PCI_SUBDEVICE_ID_PCI_RAS4: u32 = 61441;
pub const PCI_SUBDEVICE_ID_PCI_RAS8: u32 = 61456;
pub const PCI_VENDOR_ID_SYBA: u32 = 5522;
pub const PCI_DEVICE_ID_SYBA_2P_EPP: u32 = 1922;
pub const PCI_DEVICE_ID_SYBA_1P_ECP: u32 = 1923;
pub const PCI_VENDOR_ID_MORETON: u32 = 5546;
pub const PCI_DEVICE_ID_RASTEL_2PORT: u32 = 8192;
pub const PCI_VENDOR_ID_VMWARE: u32 = 5549;
pub const PCI_DEVICE_ID_VMWARE_VMXNET3: u32 = 1968;
pub const PCI_VENDOR_ID_ZOLTRIX: u32 = 5552;
pub const PCI_DEVICE_ID_ZOLTRIX_2BD0: u32 = 11216;
pub const PCI_VENDOR_ID_MELLANOX: u32 = 5555;
pub const PCI_DEVICE_ID_MELLANOX_CONNECTX3: u32 = 4099;
pub const PCI_DEVICE_ID_MELLANOX_CONNECTX3_PRO: u32 = 4103;
pub const PCI_DEVICE_ID_MELLANOX_CONNECTIB: u32 = 4113;
pub const PCI_DEVICE_ID_MELLANOX_CONNECTX4: u32 = 4115;
pub const PCI_DEVICE_ID_MELLANOX_CONNECTX4_LX: u32 = 4117;
pub const PCI_DEVICE_ID_MELLANOX_TAVOR: u32 = 23108;
pub const PCI_DEVICE_ID_MELLANOX_TAVOR_BRIDGE: u32 = 23110;
pub const PCI_DEVICE_ID_MELLANOX_SINAI_OLD: u32 = 24204;
pub const PCI_DEVICE_ID_MELLANOX_SINAI: u32 = 25204;
pub const PCI_DEVICE_ID_MELLANOX_ARBEL_COMPAT: u32 = 25208;
pub const PCI_DEVICE_ID_MELLANOX_ARBEL: u32 = 25218;
pub const PCI_DEVICE_ID_MELLANOX_HERMON_SDR: u32 = 25408;
pub const PCI_DEVICE_ID_MELLANOX_HERMON_DDR: u32 = 25418;
pub const PCI_DEVICE_ID_MELLANOX_HERMON_QDR: u32 = 25428;
pub const PCI_DEVICE_ID_MELLANOX_HERMON_EN: u32 = 25448;
pub const PCI_DEVICE_ID_MELLANOX_CONNECTX_EN: u32 = 25458;
pub const PCI_DEVICE_ID_MELLANOX_HERMON_DDR_GEN2: u32 = 26418;
pub const PCI_DEVICE_ID_MELLANOX_HERMON_QDR_GEN2: u32 = 26428;
pub const PCI_DEVICE_ID_MELLANOX_CONNECTX_EN_5_GEN2: u32 = 26438;
pub const PCI_DEVICE_ID_MELLANOX_HERMON_EN_GEN2: u32 = 26448;
pub const PCI_DEVICE_ID_MELLANOX_CONNECTX_EN_T_GEN2: u32 = 26458;
pub const PCI_DEVICE_ID_MELLANOX_CONNECTX_EN_GEN2: u32 = 26468;
pub const PCI_DEVICE_ID_MELLANOX_CONNECTX2: u32 = 26478;
pub const PCI_VENDOR_ID_DFI: u32 = 5565;
pub const PCI_VENDOR_ID_QUICKNET: u32 = 5602;
pub const PCI_DEVICE_ID_QUICKNET_XJ: u32 = 1280;
pub const PCI_VENDOR_ID_ADDIDATA: u32 = 5560;
pub const PCI_DEVICE_ID_ADDIDATA_APCI7500: u32 = 28672;
pub const PCI_DEVICE_ID_ADDIDATA_APCI7420: u32 = 28673;
pub const PCI_DEVICE_ID_ADDIDATA_APCI7300: u32 = 28674;
pub const PCI_DEVICE_ID_ADDIDATA_APCI7500_2: u32 = 28681;
pub const PCI_DEVICE_ID_ADDIDATA_APCI7420_2: u32 = 28682;
pub const PCI_DEVICE_ID_ADDIDATA_APCI7300_2: u32 = 28683;
pub const PCI_DEVICE_ID_ADDIDATA_APCI7500_3: u32 = 28684;
pub const PCI_DEVICE_ID_ADDIDATA_APCI7420_3: u32 = 28685;
pub const PCI_DEVICE_ID_ADDIDATA_APCI7300_3: u32 = 28686;
pub const PCI_DEVICE_ID_ADDIDATA_APCI7800_3: u32 = 28687;
pub const PCI_DEVICE_ID_ADDIDATA_APCIe7300: u32 = 28688;
pub const PCI_DEVICE_ID_ADDIDATA_APCIe7420: u32 = 28689;
pub const PCI_DEVICE_ID_ADDIDATA_APCIe7500: u32 = 28690;
pub const PCI_DEVICE_ID_ADDIDATA_APCIe7800: u32 = 28691;
pub const PCI_VENDOR_ID_PDC: u32 = 5609;
pub const PCI_VENDOR_ID_FARSITE: u32 = 5657;
pub const PCI_DEVICE_ID_FARSITE_T2P: u32 = 1024;
pub const PCI_DEVICE_ID_FARSITE_T4P: u32 = 1088;
pub const PCI_DEVICE_ID_FARSITE_T1U: u32 = 1552;
pub const PCI_DEVICE_ID_FARSITE_T2U: u32 = 1568;
pub const PCI_DEVICE_ID_FARSITE_T4U: u32 = 1600;
pub const PCI_DEVICE_ID_FARSITE_TE1: u32 = 5648;
pub const PCI_DEVICE_ID_FARSITE_TE1C: u32 = 5650;
pub const PCI_VENDOR_ID_ARIMA: u32 = 5663;
pub const PCI_VENDOR_ID_BROCADE: u32 = 5719;
pub const PCI_DEVICE_ID_BROCADE_CT: u32 = 20;
pub const PCI_DEVICE_ID_BROCADE_FC_8G1P: u32 = 23;
pub const PCI_DEVICE_ID_BROCADE_CT_FC: u32 = 33;
pub const PCI_VENDOR_ID_SIBYTE: u32 = 5741;
pub const PCI_DEVICE_ID_BCM1250_PCI: u32 = 1;
pub const PCI_DEVICE_ID_BCM1250_HT: u32 = 2;
pub const PCI_VENDOR_ID_ATHEROS: u32 = 5772;
pub const PCI_VENDOR_ID_NETCELL: u32 = 5788;
pub const PCI_DEVICE_ID_REVOLUTION: u32 = 68;
pub const PCI_VENDOR_ID_CENATEK: u32 = 5834;
pub const PCI_DEVICE_ID_CENATEK_IDE: u32 = 1;
pub const PCI_VENDOR_ID_SYNOPSYS: u32 = 5827;
pub const PCI_DEVICE_ID_SYNOPSYS_HAPSUSB3: u32 = 43981;
pub const PCI_DEVICE_ID_SYNOPSYS_HAPSUSB3_AXI: u32 = 43982;
pub const PCI_DEVICE_ID_SYNOPSYS_HAPSUSB31: u32 = 43983;
pub const PCI_DEVICE_ID_SYNOPSYS_EDDA: u32 = 60890;
pub const PCI_VENDOR_ID_USR: u32 = 5868;
pub const PCI_VENDOR_ID_VITESSE: u32 = 5925;
pub const PCI_DEVICE_ID_VITESSE_VSC7174: u32 = 29044;
pub const PCI_VENDOR_ID_LINKSYS: u32 = 5943;
pub const PCI_DEVICE_ID_LINKSYS_EG1064: u32 = 4196;
pub const PCI_VENDOR_ID_ALTIMA: u32 = 5947;
pub const PCI_DEVICE_ID_ALTIMA_AC1000: u32 = 1000;
pub const PCI_DEVICE_ID_ALTIMA_AC1001: u32 = 1001;
pub const PCI_DEVICE_ID_ALTIMA_AC9100: u32 = 1002;
pub const PCI_DEVICE_ID_ALTIMA_AC1003: u32 = 1003;
pub const PCI_VENDOR_ID_CAVIUM: u32 = 6013;
pub const PCI_VENDOR_ID_TECHWELL: u32 = 6039;
pub const PCI_DEVICE_ID_TECHWELL_6800: u32 = 26624;
pub const PCI_DEVICE_ID_TECHWELL_6801: u32 = 26625;
pub const PCI_DEVICE_ID_TECHWELL_6804: u32 = 26628;
pub const PCI_DEVICE_ID_TECHWELL_6816_1: u32 = 26640;
pub const PCI_DEVICE_ID_TECHWELL_6816_2: u32 = 26641;
pub const PCI_DEVICE_ID_TECHWELL_6816_3: u32 = 26642;
pub const PCI_DEVICE_ID_TECHWELL_6816_4: u32 = 26643;
pub const PCI_VENDOR_ID_BELKIN: u32 = 6041;
pub const PCI_DEVICE_ID_BELKIN_F5D7010V7: u32 = 28703;
pub const PCI_VENDOR_ID_RDC: u32 = 6131;
pub const PCI_DEVICE_ID_RDC_R6020: u32 = 24608;
pub const PCI_DEVICE_ID_RDC_R6030: u32 = 24624;
pub const PCI_DEVICE_ID_RDC_R6040: u32 = 24640;
pub const PCI_DEVICE_ID_RDC_R6060: u32 = 24672;
pub const PCI_DEVICE_ID_RDC_R6061: u32 = 24673;
pub const PCI_DEVICE_ID_RDC_D1010: u32 = 4112;
pub const PCI_VENDOR_ID_GLI: u32 = 6048;
pub const PCI_VENDOR_ID_LENOVO: u32 = 6058;
pub const PCI_VENDOR_ID_QCOM: u32 = 6091;
pub const PCI_VENDOR_ID_CDNS: u32 = 6093;
pub const PCI_DEVICE_ID_CDNS_USBSS: u32 = 256;
pub const PCI_DEVICE_ID_CDNS_USB: u32 = 288;
pub const PCI_DEVICE_ID_CDNS_USBSSP: u32 = 512;
pub const PCI_VENDOR_ID_ARECA: u32 = 6099;
pub const PCI_DEVICE_ID_ARECA_1110: u32 = 4368;
pub const PCI_DEVICE_ID_ARECA_1120: u32 = 4384;
pub const PCI_DEVICE_ID_ARECA_1130: u32 = 4400;
pub const PCI_DEVICE_ID_ARECA_1160: u32 = 4448;
pub const PCI_DEVICE_ID_ARECA_1170: u32 = 4464;
pub const PCI_DEVICE_ID_ARECA_1200: u32 = 4608;
pub const PCI_DEVICE_ID_ARECA_1201: u32 = 4609;
pub const PCI_DEVICE_ID_ARECA_1202: u32 = 4610;
pub const PCI_DEVICE_ID_ARECA_1210: u32 = 4624;
pub const PCI_DEVICE_ID_ARECA_1220: u32 = 4640;
pub const PCI_DEVICE_ID_ARECA_1230: u32 = 4656;
pub const PCI_DEVICE_ID_ARECA_1260: u32 = 4704;
pub const PCI_DEVICE_ID_ARECA_1270: u32 = 4720;
pub const PCI_DEVICE_ID_ARECA_1280: u32 = 4736;
pub const PCI_DEVICE_ID_ARECA_1380: u32 = 4992;
pub const PCI_DEVICE_ID_ARECA_1381: u32 = 4993;
pub const PCI_DEVICE_ID_ARECA_1680: u32 = 5760;
pub const PCI_DEVICE_ID_ARECA_1681: u32 = 5761;
pub const PCI_VENDOR_ID_S2IO: u32 = 6101;
pub const PCI_DEVICE_ID_S2IO_WIN: u32 = 22321;
pub const PCI_DEVICE_ID_S2IO_UNI: u32 = 22577;
pub const PCI_DEVICE_ID_HERC_WIN: u32 = 22322;
pub const PCI_DEVICE_ID_HERC_UNI: u32 = 22578;
pub const PCI_VENDOR_ID_SITECOM: u32 = 6189;
pub const PCI_DEVICE_ID_SITECOM_DC105V2: u32 = 12393;
pub const PCI_VENDOR_ID_TOPSPIN: u32 = 6247;
pub const PCI_VENDOR_ID_COMMTECH: u32 = 6391;
pub const PCI_VENDOR_ID_SILAN: u32 = 6404;
pub const PCI_VENDOR_ID_RENESAS: u32 = 6418;
pub const PCI_DEVICE_ID_RENESAS_SH7781: u32 = 1;
pub const PCI_DEVICE_ID_RENESAS_SH7780: u32 = 2;
pub const PCI_DEVICE_ID_RENESAS_SH7763: u32 = 4;
pub const PCI_DEVICE_ID_RENESAS_SH7785: u32 = 7;
pub const PCI_DEVICE_ID_RENESAS_SH7786: u32 = 16;
pub const PCI_VENDOR_ID_SOLARFLARE: u32 = 6436;
pub const PCI_DEVICE_ID_SOLARFLARE_SFC4000A_0: u32 = 1795;
pub const PCI_DEVICE_ID_SOLARFLARE_SFC4000A_1: u32 = 26371;
pub const PCI_DEVICE_ID_SOLARFLARE_SFC4000B: u32 = 1808;
pub const PCI_VENDOR_ID_TDI: u32 = 6446;
pub const PCI_DEVICE_ID_TDI_EHCI: u32 = 257;
pub const PCI_VENDOR_ID_FREESCALE: u32 = 6487;
pub const PCI_VENDOR_ID_NXP: u32 = 6487;
pub const PCI_DEVICE_ID_MPC8308: u32 = 49158;
pub const PCI_DEVICE_ID_MPC8315E: u32 = 180;
pub const PCI_DEVICE_ID_MPC8315: u32 = 181;
pub const PCI_DEVICE_ID_MPC8314E: u32 = 182;
pub const PCI_DEVICE_ID_MPC8314: u32 = 183;
pub const PCI_DEVICE_ID_MPC8378E: u32 = 196;
pub const PCI_DEVICE_ID_MPC8378: u32 = 197;
pub const PCI_DEVICE_ID_MPC8377E: u32 = 198;
pub const PCI_DEVICE_ID_MPC8377: u32 = 199;
pub const PCI_DEVICE_ID_MPC8548E: u32 = 18;
pub const PCI_DEVICE_ID_MPC8548: u32 = 19;
pub const PCI_DEVICE_ID_MPC8543E: u32 = 20;
pub const PCI_DEVICE_ID_MPC8543: u32 = 21;
pub const PCI_DEVICE_ID_MPC8547E: u32 = 24;
pub const PCI_DEVICE_ID_MPC8545E: u32 = 25;
pub const PCI_DEVICE_ID_MPC8545: u32 = 26;
pub const PCI_DEVICE_ID_MPC8569E: u32 = 97;
pub const PCI_DEVICE_ID_MPC8569: u32 = 96;
pub const PCI_DEVICE_ID_MPC8568E: u32 = 32;
pub const PCI_DEVICE_ID_MPC8568: u32 = 33;
pub const PCI_DEVICE_ID_MPC8567E: u32 = 34;
pub const PCI_DEVICE_ID_MPC8567: u32 = 35;
pub const PCI_DEVICE_ID_MPC8533E: u32 = 48;
pub const PCI_DEVICE_ID_MPC8533: u32 = 49;
pub const PCI_DEVICE_ID_MPC8544E: u32 = 50;
pub const PCI_DEVICE_ID_MPC8544: u32 = 51;
pub const PCI_DEVICE_ID_MPC8572E: u32 = 64;
pub const PCI_DEVICE_ID_MPC8572: u32 = 65;
pub const PCI_DEVICE_ID_MPC8536E: u32 = 80;
pub const PCI_DEVICE_ID_MPC8536: u32 = 81;
pub const PCI_DEVICE_ID_P2020E: u32 = 112;
pub const PCI_DEVICE_ID_P2020: u32 = 113;
pub const PCI_DEVICE_ID_P2010E: u32 = 120;
pub const PCI_DEVICE_ID_P2010: u32 = 121;
pub const PCI_DEVICE_ID_P1020E: u32 = 256;
pub const PCI_DEVICE_ID_P1020: u32 = 257;
pub const PCI_DEVICE_ID_P1021E: u32 = 258;
pub const PCI_DEVICE_ID_P1021: u32 = 259;
pub const PCI_DEVICE_ID_P1011E: u32 = 264;
pub const PCI_DEVICE_ID_P1011: u32 = 265;
pub const PCI_DEVICE_ID_P1022E: u32 = 272;
pub const PCI_DEVICE_ID_P1022: u32 = 273;
pub const PCI_DEVICE_ID_P1013E: u32 = 280;
pub const PCI_DEVICE_ID_P1013: u32 = 281;
pub const PCI_DEVICE_ID_P4080E: u32 = 1024;
pub const PCI_DEVICE_ID_P4080: u32 = 1025;
pub const PCI_DEVICE_ID_P4040E: u32 = 1032;
pub const PCI_DEVICE_ID_P4040: u32 = 1033;
pub const PCI_DEVICE_ID_P2040E: u32 = 1040;
pub const PCI_DEVICE_ID_P2040: u32 = 1041;
pub const PCI_DEVICE_ID_P3041E: u32 = 1054;
pub const PCI_DEVICE_ID_P3041: u32 = 1055;
pub const PCI_DEVICE_ID_P5020E: u32 = 1056;
pub const PCI_DEVICE_ID_P5020: u32 = 1057;
pub const PCI_DEVICE_ID_P5010E: u32 = 1064;
pub const PCI_DEVICE_ID_P5010: u32 = 1065;
pub const PCI_DEVICE_ID_MPC8641: u32 = 28688;
pub const PCI_DEVICE_ID_MPC8641D: u32 = 28689;
pub const PCI_DEVICE_ID_MPC8610: u32 = 28696;
pub const PCI_VENDOR_ID_PASEMI: u32 = 6489;
pub const PCI_VENDOR_ID_ATTANSIC: u32 = 6505;
pub const PCI_DEVICE_ID_ATTANSIC_L1: u32 = 4168;
pub const PCI_DEVICE_ID_ATTANSIC_L2: u32 = 8264;
pub const PCI_VENDOR_ID_JMICRON: u32 = 6523;
pub const PCI_DEVICE_ID_JMICRON_JMB360: u32 = 9056;
pub const PCI_DEVICE_ID_JMICRON_JMB361: u32 = 9057;
pub const PCI_DEVICE_ID_JMICRON_JMB362: u32 = 9058;
pub const PCI_DEVICE_ID_JMICRON_JMB363: u32 = 9059;
pub const PCI_DEVICE_ID_JMICRON_JMB364: u32 = 9060;
pub const PCI_DEVICE_ID_JMICRON_JMB365: u32 = 9061;
pub const PCI_DEVICE_ID_JMICRON_JMB366: u32 = 9062;
pub const PCI_DEVICE_ID_JMICRON_JMB368: u32 = 9064;
pub const PCI_DEVICE_ID_JMICRON_JMB369: u32 = 9065;
pub const PCI_DEVICE_ID_JMICRON_JMB38X_SD: u32 = 9089;
pub const PCI_DEVICE_ID_JMICRON_JMB38X_MMC: u32 = 9090;
pub const PCI_DEVICE_ID_JMICRON_JMB38X_MS: u32 = 9091;
pub const PCI_DEVICE_ID_JMICRON_JMB385_MS: u32 = 9096;
pub const PCI_DEVICE_ID_JMICRON_JMB388_SD: u32 = 9105;
pub const PCI_DEVICE_ID_JMICRON_JMB388_ESD: u32 = 9106;
pub const PCI_DEVICE_ID_JMICRON_JMB390_MS: u32 = 9107;
pub const PCI_VENDOR_ID_KORENIX: u32 = 6530;
pub const PCI_DEVICE_ID_KORENIX_JETCARDF0: u32 = 5632;
pub const PCI_DEVICE_ID_KORENIX_JETCARDF1: u32 = 5887;
pub const PCI_DEVICE_ID_KORENIX_JETCARDF2: u32 = 5888;
pub const PCI_DEVICE_ID_KORENIX_JETCARDF3: u32 = 6143;
pub const PCI_VENDOR_ID_HUAWEI: u32 = 6629;
pub const PCI_DEVICE_ID_HUAWEI_ZIP_VF: u32 = 41553;
pub const PCI_DEVICE_ID_HUAWEI_SEC_VF: u32 = 41558;
pub const PCI_DEVICE_ID_HUAWEI_HPRE_VF: u32 = 41561;
pub const PCI_VENDOR_ID_NETRONOME: u32 = 6638;
pub const PCI_DEVICE_ID_NETRONOME_NFP3800: u32 = 14336;
pub const PCI_DEVICE_ID_NETRONOME_NFP4000: u32 = 16384;
pub const PCI_DEVICE_ID_NETRONOME_NFP5000: u32 = 20480;
pub const PCI_DEVICE_ID_NETRONOME_NFP6000: u32 = 24576;
pub const PCI_DEVICE_ID_NETRONOME_NFP3800_VF: u32 = 14339;
pub const PCI_DEVICE_ID_NETRONOME_NFP6000_VF: u32 = 24579;
pub const PCI_VENDOR_ID_QMI: u32 = 6706;
pub const PCI_VENDOR_ID_AZWAVE: u32 = 6715;
pub const PCI_VENDOR_ID_REDHAT_QUMRANET: u32 = 6900;
pub const PCI_SUBVENDOR_ID_REDHAT_QUMRANET: u32 = 6900;
pub const PCI_SUBDEVICE_ID_QEMU: u32 = 4352;
pub const PCI_VENDOR_ID_ASMEDIA: u32 = 6945;
pub const PCI_VENDOR_ID_REDHAT: u32 = 6966;
pub const PCI_VENDOR_ID_WCHIC: u32 = 7168;
pub const PCI_DEVICE_ID_WCHIC_CH382_0S1P: u32 = 12368;
pub const PCI_DEVICE_ID_WCHIC_CH382_2S1P: u32 = 12880;
pub const PCI_DEVICE_ID_WCHIC_CH382_2S: u32 = 12883;
pub const PCI_VENDOR_ID_SILICOM_DENMARK: u32 = 7212;
pub const PCI_VENDOR_ID_AMAZON_ANNAPURNA_LABS: u32 = 7222;
pub const PCI_VENDOR_ID_CIRCUITCO: u32 = 7368;
pub const PCI_SUBSYSTEM_ID_CIRCUITCO_MINNOWBOARD: u32 = 1;
pub const PCI_VENDOR_ID_AMAZON: u32 = 7439;
pub const PCI_VENDOR_ID_ZHAOXIN: u32 = 7447;
pub const PCI_VENDOR_ID_ROCKCHIP: u32 = 7559;
pub const PCI_VENDOR_ID_HYGON: u32 = 7572;
pub const PCI_VENDOR_ID_META: u32 = 7579;
pub const PCI_VENDOR_ID_FUNGIBLE: u32 = 7597;
pub const PCI_VENDOR_ID_HXT: u32 = 7615;
pub const PCI_VENDOR_ID_TEKRAM: u32 = 7649;
pub const PCI_DEVICE_ID_TEKRAM_DC290: u32 = 56361;
pub const PCI_VENDOR_ID_ALIBABA: u32 = 7661;
pub const PCI_VENDOR_ID_CXL: u32 = 7832;
pub const PCI_VENDOR_ID_TEHUTI: u32 = 8137;
pub const PCI_DEVICE_ID_TEHUTI_3009: u32 = 12297;
pub const PCI_DEVICE_ID_TEHUTI_3010: u32 = 12304;
pub const PCI_DEVICE_ID_TEHUTI_3014: u32 = 12308;
pub const PCI_VENDOR_ID_SUNIX: u32 = 8148;
pub const PCI_DEVICE_ID_SUNIX_1999: u32 = 6553;
pub const PCI_VENDOR_ID_HINT: u32 = 13192;
pub const PCI_DEVICE_ID_HINT_VXPROII_IDE: u32 = 32787;
pub const PCI_VENDOR_ID_3DLABS: u32 = 15677;
pub const PCI_DEVICE_ID_3DLABS_PERMEDIA2: u32 = 7;
pub const PCI_DEVICE_ID_3DLABS_PERMEDIA2V: u32 = 9;
pub const PCI_VENDOR_ID_NETXEN: u32 = 16448;
pub const PCI_DEVICE_ID_NX2031_10GXSR: u32 = 1;
pub const PCI_DEVICE_ID_NX2031_10GCX4: u32 = 2;
pub const PCI_DEVICE_ID_NX2031_4GCU: u32 = 3;
pub const PCI_DEVICE_ID_NX2031_IMEZ: u32 = 4;
pub const PCI_DEVICE_ID_NX2031_HMEZ: u32 = 5;
pub const PCI_DEVICE_ID_NX2031_XG_MGMT: u32 = 36;
pub const PCI_DEVICE_ID_NX2031_XG_MGMT2: u32 = 37;
pub const PCI_DEVICE_ID_NX3031: u32 = 256;
pub const PCI_VENDOR_ID_AKS: u32 = 16748;
pub const PCI_DEVICE_ID_AKS_ALADDINCARD: u32 = 256;
pub const PCI_VENDOR_ID_WCHCN: u32 = 17224;
pub const PCI_DEVICE_ID_WCHCN_CH353_4S: u32 = 13395;
pub const PCI_DEVICE_ID_WCHCN_CH353_2S1PF: u32 = 20550;
pub const PCI_DEVICE_ID_WCHCN_CH353_1S1P: u32 = 20563;
pub const PCI_DEVICE_ID_WCHCN_CH353_2S1P: u32 = 28755;
pub const PCI_VENDOR_ID_ACCESSIO: u32 = 18767;
pub const PCI_DEVICE_ID_ACCESSIO_WDG_CSM: u32 = 8896;
pub const PCI_VENDOR_ID_S3: u32 = 21299;
pub const PCI_DEVICE_ID_S3_TRIO: u32 = 34833;
pub const PCI_DEVICE_ID_S3_868: u32 = 34944;
pub const PCI_DEVICE_ID_S3_968: u32 = 35056;
pub const PCI_DEVICE_ID_S3_SAVAGE4: u32 = 35365;
pub const PCI_DEVICE_ID_S3_PROSAVAGE8: u32 = 36100;
pub const PCI_DEVICE_ID_S3_SONICVIBES: u32 = 51712;
pub const PCI_VENDOR_ID_DUNORD: u32 = 21828;
pub const PCI_DEVICE_ID_DUNORD_I3000: u32 = 1;
pub const PCI_VENDOR_ID_DCI: u32 = 26214;
pub const PCI_DEVICE_ID_DCI_PCCOM4: u32 = 1;
pub const PCI_DEVICE_ID_DCI_PCCOM8: u32 = 2;
pub const PCI_DEVICE_ID_DCI_PCCOM2: u32 = 4;
pub const PCI_VENDOR_ID_GLENFLY: u32 = 26470;
pub const PCI_VENDOR_ID_INTEL: u32 = 32902;
pub const PCI_DEVICE_ID_INTEL_EESSC: u32 = 8;
pub const PCI_DEVICE_ID_INTEL_HDA_CML_LP: u32 = 712;
pub const PCI_DEVICE_ID_INTEL_PXHD_0: u32 = 800;
pub const PCI_DEVICE_ID_INTEL_PXHD_1: u32 = 801;
pub const PCI_DEVICE_ID_INTEL_PXH_0: u32 = 809;
pub const PCI_DEVICE_ID_INTEL_PXH_1: u32 = 810;
pub const PCI_DEVICE_ID_INTEL_PXHV: u32 = 812;
pub const PCI_DEVICE_ID_INTEL_80332_0: u32 = 816;
pub const PCI_DEVICE_ID_INTEL_80332_1: u32 = 818;
pub const PCI_DEVICE_ID_INTEL_80333_0: u32 = 880;
pub const PCI_DEVICE_ID_INTEL_80333_1: u32 = 882;
pub const PCI_DEVICE_ID_INTEL_QAT_DH895XCC: u32 = 1077;
pub const PCI_DEVICE_ID_INTEL_QAT_DH895XCC_VF: u32 = 1091;
pub const PCI_DEVICE_ID_INTEL_82375: u32 = 1154;
pub const PCI_DEVICE_ID_INTEL_82424: u32 = 1155;
pub const PCI_DEVICE_ID_INTEL_82378: u32 = 1156;
pub const PCI_DEVICE_ID_INTEL_82425: u32 = 1158;
pub const PCI_DEVICE_ID_INTEL_HDA_CML_H: u32 = 1736;
pub const PCI_DEVICE_ID_INTEL_MRST_SD0: u32 = 2055;
pub const PCI_DEVICE_ID_INTEL_MRST_SD1: u32 = 2056;
pub const PCI_DEVICE_ID_INTEL_HDA_OAKTRAIL: u32 = 2058;
pub const PCI_DEVICE_ID_INTEL_MFD_SD: u32 = 2080;
pub const PCI_DEVICE_ID_INTEL_MFD_SDIO1: u32 = 2081;
pub const PCI_DEVICE_ID_INTEL_MFD_SDIO2: u32 = 2082;
pub const PCI_DEVICE_ID_INTEL_MFD_EMMC0: u32 = 2083;
pub const PCI_DEVICE_ID_INTEL_MFD_EMMC1: u32 = 2084;
pub const PCI_DEVICE_ID_INTEL_MRST_SD2: u32 = 2127;
pub const PCI_DEVICE_ID_INTEL_QUARK_X1000_ILB: u32 = 2398;
pub const PCI_DEVICE_ID_INTEL_I960: u32 = 2400;
pub const PCI_DEVICE_ID_INTEL_I960RM: u32 = 2402;
pub const PCI_DEVICE_ID_INTEL_HDA_HSW_0: u32 = 2572;
pub const PCI_DEVICE_ID_INTEL_DSA_SPR0: u32 = 2853;
pub const PCI_DEVICE_ID_INTEL_HDA_HSW_2: u32 = 3084;
pub const PCI_DEVICE_ID_INTEL_CENTERTON_ILB: u32 = 3168;
pub const PCI_DEVICE_ID_INTEL_IAX_SPR0: u32 = 3326;
pub const PCI_DEVICE_ID_INTEL_HDA_HSW_3: u32 = 3340;
pub const PCI_DEVICE_ID_INTEL_HDA_BYT: u32 = 3844;
pub const PCI_DEVICE_ID_INTEL_SST_BYT: u32 = 3880;
pub const PCI_DEVICE_ID_INTEL_8257X_SOL: u32 = 4194;
pub const PCI_DEVICE_ID_INTEL_82573E_SOL: u32 = 4229;
pub const PCI_DEVICE_ID_INTEL_82573L_SOL: u32 = 4239;
pub const PCI_DEVICE_ID_INTEL_82815_MC: u32 = 4400;
pub const PCI_DEVICE_ID_INTEL_82815_CGC: u32 = 4402;
pub const PCI_DEVICE_ID_INTEL_SST_TNG: u32 = 4506;
pub const PCI_DEVICE_ID_INTEL_82092AA_0: u32 = 4641;
pub const PCI_DEVICE_ID_INTEL_82437: u32 = 4653;
pub const PCI_DEVICE_ID_INTEL_82371FB_0: u32 = 4654;
pub const PCI_DEVICE_ID_INTEL_82371FB_1: u32 = 4656;
pub const PCI_DEVICE_ID_INTEL_82371MX: u32 = 4660;
pub const PCI_DEVICE_ID_INTEL_82441: u32 = 4663;
pub const PCI_DEVICE_ID_INTEL_82380FB: u32 = 4683;
pub const PCI_DEVICE_ID_INTEL_82439: u32 = 4688;
pub const PCI_DEVICE_ID_INTEL_LIGHT_RIDGE: u32 = 5395;
pub const PCI_DEVICE_ID_INTEL_EAGLE_RIDGE: u32 = 5402;
pub const PCI_DEVICE_ID_INTEL_LIGHT_PEAK: u32 = 5403;
pub const PCI_DEVICE_ID_INTEL_CACTUS_RIDGE_4C: u32 = 5447;
pub const PCI_DEVICE_ID_INTEL_CACTUS_RIDGE_2C: u32 = 5448;
pub const PCI_DEVICE_ID_INTEL_PORT_RIDGE: u32 = 5449;
pub const PCI_DEVICE_ID_INTEL_REDWOOD_RIDGE_2C_NHI: u32 = 5478;
pub const PCI_DEVICE_ID_INTEL_REDWOOD_RIDGE_2C_BRIDGE: u32 = 5479;
pub const PCI_DEVICE_ID_INTEL_REDWOOD_RIDGE_4C_NHI: u32 = 5480;
pub const PCI_DEVICE_ID_INTEL_REDWOOD_RIDGE_4C_BRIDGE: u32 = 5481;
pub const PCI_DEVICE_ID_INTEL_FALCON_RIDGE_2C_NHI: u32 = 5482;
pub const PCI_DEVICE_ID_INTEL_FALCON_RIDGE_2C_BRIDGE: u32 = 5483;
pub const PCI_DEVICE_ID_INTEL_FALCON_RIDGE_4C_NHI: u32 = 5484;
pub const PCI_DEVICE_ID_INTEL_FALCON_RIDGE_4C_BRIDGE: u32 = 5485;
pub const PCI_DEVICE_ID_INTEL_ALPINE_RIDGE_2C_NHI: u32 = 5493;
pub const PCI_DEVICE_ID_INTEL_ALPINE_RIDGE_2C_BRIDGE: u32 = 5494;
pub const PCI_DEVICE_ID_INTEL_ALPINE_RIDGE_4C_NHI: u32 = 5495;
pub const PCI_DEVICE_ID_INTEL_ALPINE_RIDGE_4C_BRIDGE: u32 = 5496;
pub const PCI_DEVICE_ID_INTEL_HDA_BDW: u32 = 5644;
pub const PCI_DEVICE_ID_INTEL_80960_RP: u32 = 6496;
pub const PCI_DEVICE_ID_INTEL_QAT_C3XXX: u32 = 6626;
pub const PCI_DEVICE_ID_INTEL_QAT_C3XXX_VF: u32 = 6627;
pub const PCI_DEVICE_ID_INTEL_82840_HB: u32 = 6689;
pub const PCI_DEVICE_ID_INTEL_82845_HB: u32 = 6704;
pub const PCI_DEVICE_ID_INTEL_IOAT: u32 = 6712;
pub const PCI_DEVICE_ID_INTEL_HDA_CPT: u32 = 7200;
pub const PCI_DEVICE_ID_INTEL_COUGARPOINT_LPC_MIN: u32 = 7233;
pub const PCI_DEVICE_ID_INTEL_COUGARPOINT_LPC_MAX: u32 = 7263;
pub const PCI_DEVICE_ID_INTEL_HDA_PBG: u32 = 7456;
pub const PCI_DEVICE_ID_INTEL_PATSBURG_LPC_0: u32 = 7488;
pub const PCI_DEVICE_ID_INTEL_PATSBURG_LPC_1: u32 = 7489;
pub const PCI_DEVICE_ID_INTEL_HDA_PPT: u32 = 7712;
pub const PCI_DEVICE_ID_INTEL_PANTHERPOINT_XHCI: u32 = 7729;
pub const PCI_DEVICE_ID_INTEL_PANTHERPOINT_LPC_MIN: u32 = 7744;
pub const PCI_DEVICE_ID_INTEL_PANTHERPOINT_LPC_MAX: u32 = 7775;
pub const PCI_DEVICE_ID_INTEL_VMD_201D: u32 = 8221;
pub const PCI_DEVICE_ID_INTEL_HDA_BSW: u32 = 8836;
pub const PCI_DEVICE_ID_INTEL_SST_BSW: u32 = 8872;
pub const PCI_DEVICE_ID_INTEL_DH89XXCC_LPC_MIN: u32 = 8976;
pub const PCI_DEVICE_ID_INTEL_DH89XXCC_LPC_MAX: u32 = 8991;
pub const PCI_DEVICE_ID_INTEL_82801AA_0: u32 = 9232;
pub const PCI_DEVICE_ID_INTEL_82801AA_1: u32 = 9233;
pub const PCI_DEVICE_ID_INTEL_82801AA_3: u32 = 9235;
pub const PCI_DEVICE_ID_INTEL_82801AA_5: u32 = 9237;
pub const PCI_DEVICE_ID_INTEL_82801AA_6: u32 = 9238;
pub const PCI_DEVICE_ID_INTEL_82801AA_8: u32 = 9240;
pub const PCI_DEVICE_ID_INTEL_82801AB_0: u32 = 9248;
pub const PCI_DEVICE_ID_INTEL_82801AB_1: u32 = 9249;
pub const PCI_DEVICE_ID_INTEL_82801AB_3: u32 = 9251;
pub const PCI_DEVICE_ID_INTEL_82801AB_5: u32 = 9253;
pub const PCI_DEVICE_ID_INTEL_82801AB_6: u32 = 9254;
pub const PCI_DEVICE_ID_INTEL_82801AB_8: u32 = 9256;
pub const PCI_DEVICE_ID_INTEL_82801BA_0: u32 = 9280;
pub const PCI_DEVICE_ID_INTEL_82801BA_2: u32 = 9283;
pub const PCI_DEVICE_ID_INTEL_82801BA_4: u32 = 9285;
pub const PCI_DEVICE_ID_INTEL_82801BA_6: u32 = 9288;
pub const PCI_DEVICE_ID_INTEL_82801BA_8: u32 = 9290;
pub const PCI_DEVICE_ID_INTEL_82801BA_9: u32 = 9291;
pub const PCI_DEVICE_ID_INTEL_82801BA_10: u32 = 9292;
pub const PCI_DEVICE_ID_INTEL_82801BA_11: u32 = 9294;
pub const PCI_DEVICE_ID_INTEL_82801E_0: u32 = 9296;
pub const PCI_DEVICE_ID_INTEL_82801E_11: u32 = 9307;
pub const PCI_DEVICE_ID_INTEL_82801CA_0: u32 = 9344;
pub const PCI_DEVICE_ID_INTEL_82801CA_3: u32 = 9347;
pub const PCI_DEVICE_ID_INTEL_82801CA_5: u32 = 9349;
pub const PCI_DEVICE_ID_INTEL_82801CA_6: u32 = 9350;
pub const PCI_DEVICE_ID_INTEL_82801CA_10: u32 = 9354;
pub const PCI_DEVICE_ID_INTEL_82801CA_11: u32 = 9355;
pub const PCI_DEVICE_ID_INTEL_82801CA_12: u32 = 9356;
pub const PCI_DEVICE_ID_INTEL_82801DB_0: u32 = 9408;
pub const PCI_DEVICE_ID_INTEL_82801DB_1: u32 = 9409;
pub const PCI_DEVICE_ID_INTEL_82801DB_2: u32 = 9410;
pub const PCI_DEVICE_ID_INTEL_82801DB_3: u32 = 9411;
pub const PCI_DEVICE_ID_INTEL_82801DB_5: u32 = 9413;
pub const PCI_DEVICE_ID_INTEL_82801DB_6: u32 = 9414;
pub const PCI_DEVICE_ID_INTEL_82801DB_9: u32 = 9417;
pub const PCI_DEVICE_ID_INTEL_82801DB_10: u32 = 9418;
pub const PCI_DEVICE_ID_INTEL_82801DB_11: u32 = 9419;
pub const PCI_DEVICE_ID_INTEL_82801DB_12: u32 = 9420;
pub const PCI_DEVICE_ID_INTEL_82801EB_0: u32 = 9424;
pub const PCI_DEVICE_ID_INTEL_82801EB_1: u32 = 9425;
pub const PCI_DEVICE_ID_INTEL_82801EB_3: u32 = 9427;
pub const PCI_DEVICE_ID_INTEL_82801EB_5: u32 = 9429;
pub const PCI_DEVICE_ID_INTEL_82801EB_6: u32 = 9430;
pub const PCI_DEVICE_ID_INTEL_82801EB_11: u32 = 9435;
pub const PCI_DEVICE_ID_INTEL_82801EB_12: u32 = 9436;
pub const PCI_DEVICE_ID_INTEL_82801EB_13: u32 = 9437;
pub const PCI_DEVICE_ID_INTEL_82820_HB: u32 = 9472;
pub const PCI_DEVICE_ID_INTEL_82820_UP_HB: u32 = 9473;
pub const PCI_DEVICE_ID_INTEL_82850_HB: u32 = 9520;
pub const PCI_DEVICE_ID_INTEL_82860_HB: u32 = 9521;
pub const PCI_DEVICE_ID_INTEL_E7501_MCH: u32 = 9548;
pub const PCI_DEVICE_ID_INTEL_7505_0: u32 = 9552;
pub const PCI_DEVICE_ID_INTEL_7205_0: u32 = 9565;
pub const PCI_DEVICE_ID_INTEL_82845G_HB: u32 = 9568;
pub const PCI_DEVICE_ID_INTEL_82845G_IG: u32 = 9570;
pub const PCI_DEVICE_ID_INTEL_82865_HB: u32 = 9584;
pub const PCI_DEVICE_ID_INTEL_82865_IG: u32 = 9586;
pub const PCI_DEVICE_ID_INTEL_82875_HB: u32 = 9592;
pub const PCI_DEVICE_ID_INTEL_82915G_HB: u32 = 9600;
pub const PCI_DEVICE_ID_INTEL_82915G_IG: u32 = 9602;
pub const PCI_DEVICE_ID_INTEL_82915GM_HB: u32 = 9616;
pub const PCI_DEVICE_ID_INTEL_82915GM_IG: u32 = 9618;
pub const PCI_DEVICE_ID_INTEL_ESB_1: u32 = 9633;
pub const PCI_DEVICE_ID_INTEL_ESB_2: u32 = 9634;
pub const PCI_DEVICE_ID_INTEL_ESB_4: u32 = 9636;
pub const PCI_DEVICE_ID_INTEL_ESB_5: u32 = 9638;
pub const PCI_DEVICE_ID_INTEL_ESB_9: u32 = 9643;
pub const PCI_DEVICE_ID_INTEL_ESB_10: u32 = 9644;
pub const PCI_DEVICE_ID_INTEL_5000_ERR: u32 = 9712;
pub const PCI_DEVICE_ID_INTEL_5000_FBD0: u32 = 9717;
pub const PCI_DEVICE_ID_INTEL_5000_FBD1: u32 = 9718;
pub const PCI_DEVICE_ID_INTEL_ICH6_0: u32 = 9792;
pub const PCI_DEVICE_ID_INTEL_ICH6_1: u32 = 9793;
pub const PCI_DEVICE_ID_INTEL_ICH6_2: u32 = 9794;
pub const PCI_DEVICE_ID_INTEL_HDA_ICH6: u32 = 9832;
pub const PCI_DEVICE_ID_INTEL_ICH6_16: u32 = 9834;
pub const PCI_DEVICE_ID_INTEL_ICH6_17: u32 = 9837;
pub const PCI_DEVICE_ID_INTEL_ICH6_18: u32 = 9838;
pub const PCI_DEVICE_ID_INTEL_ICH6_19: u32 = 9839;
pub const PCI_DEVICE_ID_INTEL_ESB2_0: u32 = 9840;
pub const PCI_DEVICE_ID_INTEL_ESB2_14: u32 = 9880;
pub const PCI_DEVICE_ID_INTEL_HDA_ESB2: u32 = 9882;
pub const PCI_DEVICE_ID_INTEL_ESB2_17: u32 = 9883;
pub const PCI_DEVICE_ID_INTEL_ESB2_18: u32 = 9886;
pub const PCI_DEVICE_ID_INTEL_82945G_HB: u32 = 10096;
pub const PCI_DEVICE_ID_INTEL_82945G_IG: u32 = 10098;
pub const PCI_DEVICE_ID_INTEL_3000_HB: u32 = 10104;
pub const PCI_DEVICE_ID_INTEL_82945GM_HB: u32 = 10144;
pub const PCI_DEVICE_ID_INTEL_82945GM_IG: u32 = 10146;
pub const PCI_DEVICE_ID_INTEL_ICH7_30: u32 = 10160;
pub const PCI_DEVICE_ID_INTEL_ICH7_0: u32 = 10168;
pub const PCI_DEVICE_ID_INTEL_ICH7_1: u32 = 10169;
pub const PCI_DEVICE_ID_INTEL_TGP_LPC: u32 = 10172;
pub const PCI_DEVICE_ID_INTEL_ICH7_31: u32 = 10173;
pub const PCI_DEVICE_ID_INTEL_HDA_ICH7: u32 = 10200;
pub const PCI_DEVICE_ID_INTEL_ICH7_17: u32 = 10202;
pub const PCI_DEVICE_ID_INTEL_ICH7_19: u32 = 10205;
pub const PCI_DEVICE_ID_INTEL_ICH7_20: u32 = 10206;
pub const PCI_DEVICE_ID_INTEL_ICH7_21: u32 = 10207;
pub const PCI_DEVICE_ID_INTEL_ICH8_0: u32 = 10256;
pub const PCI_DEVICE_ID_INTEL_ICH8_1: u32 = 10257;
pub const PCI_DEVICE_ID_INTEL_ICH8_2: u32 = 10258;
pub const PCI_DEVICE_ID_INTEL_ICH8_3: u32 = 10260;
pub const PCI_DEVICE_ID_INTEL_ICH8_4: u32 = 10261;
pub const PCI_DEVICE_ID_INTEL_ICH8_5: u32 = 10302;
pub const PCI_DEVICE_ID_INTEL_HDA_ICH8: u32 = 10315;
pub const PCI_DEVICE_ID_INTEL_ICH8_6: u32 = 10320;
pub const PCI_DEVICE_ID_INTEL_VMD_28C0: u32 = 10432;
pub const PCI_DEVICE_ID_INTEL_ICH9_0: u32 = 10512;
pub const PCI_DEVICE_ID_INTEL_ICH9_2: u32 = 10514;
pub const PCI_DEVICE_ID_INTEL_ICH9_3: u32 = 10515;
pub const PCI_DEVICE_ID_INTEL_ICH9_4: u32 = 10516;
pub const PCI_DEVICE_ID_INTEL_ICH9_7: u32 = 10518;
pub const PCI_DEVICE_ID_INTEL_ICH9_1: u32 = 10519;
pub const PCI_DEVICE_ID_INTEL_ICH9_8: u32 = 10520;
pub const PCI_DEVICE_ID_INTEL_ICH9_5: u32 = 10521;
pub const PCI_DEVICE_ID_INTEL_ICH9_6: u32 = 10544;
pub const PCI_DEVICE_ID_INTEL_HDA_ICH9_0: u32 = 10558;
pub const PCI_DEVICE_ID_INTEL_HDA_ICH9_1: u32 = 10559;
pub const PCI_DEVICE_ID_INTEL_I7_MCR: u32 = 11288;
pub const PCI_DEVICE_ID_INTEL_I7_MC_TAD: u32 = 11289;
pub const PCI_DEVICE_ID_INTEL_I7_MC_RAS: u32 = 11290;
pub const PCI_DEVICE_ID_INTEL_I7_MC_TEST: u32 = 11292;
pub const PCI_DEVICE_ID_INTEL_I7_MC_CH0_CTRL: u32 = 11296;
pub const PCI_DEVICE_ID_INTEL_I7_MC_CH0_ADDR: u32 = 11297;
pub const PCI_DEVICE_ID_INTEL_I7_MC_CH0_RANK: u32 = 11298;
pub const PCI_DEVICE_ID_INTEL_I7_MC_CH0_TC: u32 = 11299;
pub const PCI_DEVICE_ID_INTEL_I7_MC_CH1_CTRL: u32 = 11304;
pub const PCI_DEVICE_ID_INTEL_I7_MC_CH1_ADDR: u32 = 11305;
pub const PCI_DEVICE_ID_INTEL_I7_MC_CH1_RANK: u32 = 11306;
pub const PCI_DEVICE_ID_INTEL_I7_MC_CH1_TC: u32 = 11307;
pub const PCI_DEVICE_ID_INTEL_I7_MC_CH2_CTRL: u32 = 11312;
pub const PCI_DEVICE_ID_INTEL_I7_MC_CH2_ADDR: u32 = 11313;
pub const PCI_DEVICE_ID_INTEL_I7_MC_CH2_RANK: u32 = 11314;
pub const PCI_DEVICE_ID_INTEL_I7_MC_CH2_TC: u32 = 11315;
pub const PCI_DEVICE_ID_INTEL_I7_NONCORE_ALT: u32 = 11328;
pub const PCI_DEVICE_ID_INTEL_I7_NONCORE: u32 = 11329;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_NONCORE: u32 = 11344;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_NONCORE_ALT: u32 = 11345;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_NONCORE_REV2: u32 = 11376;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_SAD: u32 = 11393;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_QPI_LINK0: u32 = 11408;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_QPI_PHY0: u32 = 11409;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MCR: u32 = 11416;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_TAD: u32 = 11417;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_TEST: u32 = 11420;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_CH0_CTRL: u32 = 11424;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_CH0_ADDR: u32 = 11425;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_CH0_RANK: u32 = 11426;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_CH0_TC: u32 = 11427;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_CH1_CTRL: u32 = 11432;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_CH1_ADDR: u32 = 11433;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_CH1_RANK: u32 = 11434;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_CH1_TC: u32 = 11435;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MCR_REV2: u32 = 11672;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_TAD_REV2: u32 = 11673;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_RAS_REV2: u32 = 11674;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_TEST_REV2: u32 = 11676;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_CH0_CTRL_REV2: u32 = 11680;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_CH0_ADDR_REV2: u32 = 11681;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_CH0_RANK_REV2: u32 = 11682;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_CH0_TC_REV2: u32 = 11683;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_CH1_CTRL_REV2: u32 = 11688;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_CH1_ADDR_REV2: u32 = 11689;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_CH1_RANK_REV2: u32 = 11690;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_CH1_TC_REV2: u32 = 11691;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_CH2_CTRL_REV2: u32 = 11696;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_CH2_ADDR_REV2: u32 = 11697;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_CH2_RANK_REV2: u32 = 11698;
pub const PCI_DEVICE_ID_INTEL_LYNNFIELD_MC_CH2_TC_REV2: u32 = 11699;
pub const PCI_DEVICE_ID_INTEL_HDA_GML: u32 = 12696;
pub const PCI_DEVICE_ID_INTEL_82855PM_HB: u32 = 13120;
pub const PCI_DEVICE_ID_INTEL_IOAT_TBG4: u32 = 13353;
pub const PCI_DEVICE_ID_INTEL_IOAT_TBG5: u32 = 13354;
pub const PCI_DEVICE_ID_INTEL_IOAT_TBG6: u32 = 13355;
pub const PCI_DEVICE_ID_INTEL_IOAT_TBG7: u32 = 13356;
pub const PCI_DEVICE_ID_INTEL_X58_HUB_MGMT: u32 = 13358;
pub const PCI_DEVICE_ID_INTEL_IOAT_TBG0: u32 = 13360;
pub const PCI_DEVICE_ID_INTEL_IOAT_TBG1: u32 = 13361;
pub const PCI_DEVICE_ID_INTEL_IOAT_TBG2: u32 = 13362;
pub const PCI_DEVICE_ID_INTEL_IOAT_TBG3: u32 = 13363;
pub const PCI_DEVICE_ID_INTEL_HDA_ICL_LP: u32 = 13512;
pub const PCI_DEVICE_ID_INTEL_82830_HB: u32 = 13685;
pub const PCI_DEVICE_ID_INTEL_82830_CGC: u32 = 13687;
pub const PCI_DEVICE_ID_INTEL_82855GM_HB: u32 = 13696;
pub const PCI_DEVICE_ID_INTEL_82855GM_IG: u32 = 13698;
pub const PCI_DEVICE_ID_INTEL_82854_HB: u32 = 13708;
pub const PCI_DEVICE_ID_INTEL_82854_IG: u32 = 13710;
pub const PCI_DEVICE_ID_INTEL_E7520_MCH: u32 = 13712;
pub const PCI_DEVICE_ID_INTEL_E7320_MCH: u32 = 13714;
pub const PCI_DEVICE_ID_INTEL_MCH_PA: u32 = 13717;
pub const PCI_DEVICE_ID_INTEL_MCH_PA1: u32 = 13718;
pub const PCI_DEVICE_ID_INTEL_MCH_PB: u32 = 13719;
pub const PCI_DEVICE_ID_INTEL_MCH_PB1: u32 = 13720;
pub const PCI_DEVICE_ID_INTEL_MCH_PC: u32 = 13721;
pub const PCI_DEVICE_ID_INTEL_MCH_PC1: u32 = 13722;
pub const PCI_DEVICE_ID_INTEL_E7525_MCH: u32 = 13726;
pub const PCI_DEVICE_ID_INTEL_IOAT_CNB: u32 = 13835;
pub const PCI_DEVICE_ID_INTEL_FBD_CNB: u32 = 13836;
pub const PCI_DEVICE_ID_INTEL_I7300_MCH_ERR: u32 = 13836;
pub const PCI_DEVICE_ID_INTEL_I7300_MCH_FB0: u32 = 13839;
pub const PCI_DEVICE_ID_INTEL_I7300_MCH_FB1: u32 = 13840;
pub const PCI_DEVICE_ID_INTEL_IOAT_JSF0: u32 = 14096;
pub const PCI_DEVICE_ID_INTEL_IOAT_JSF1: u32 = 14097;
pub const PCI_DEVICE_ID_INTEL_IOAT_JSF2: u32 = 14098;
pub const PCI_DEVICE_ID_INTEL_IOAT_JSF3: u32 = 14099;
pub const PCI_DEVICE_ID_INTEL_IOAT_JSF4: u32 = 14100;
pub const PCI_DEVICE_ID_INTEL_IOAT_JSF5: u32 = 14101;
pub const PCI_DEVICE_ID_INTEL_IOAT_JSF6: u32 = 14102;
pub const PCI_DEVICE_ID_INTEL_IOAT_JSF7: u32 = 14103;
pub const PCI_DEVICE_ID_INTEL_IOAT_JSF8: u32 = 14104;
pub const PCI_DEVICE_ID_INTEL_IOAT_JSF9: u32 = 14105;
pub const PCI_DEVICE_ID_INTEL_QAT_C62X: u32 = 14280;
pub const PCI_DEVICE_ID_INTEL_QAT_C62X_VF: u32 = 14281;
pub const PCI_DEVICE_ID_INTEL_HDA_ICL_N: u32 = 14536;
pub const PCI_DEVICE_ID_INTEL_ICH10_0: u32 = 14868;
pub const PCI_DEVICE_ID_INTEL_ICH10_1: u32 = 14870;
pub const PCI_DEVICE_ID_INTEL_ICH10_2: u32 = 14872;
pub const PCI_DEVICE_ID_INTEL_ICH10_3: u32 = 14874;
pub const PCI_DEVICE_ID_INTEL_ICH10_4: u32 = 14896;
pub const PCI_DEVICE_ID_INTEL_HDA_ICH10_0: u32 = 14910;
pub const PCI_DEVICE_ID_INTEL_ICH10_5: u32 = 14944;
pub const PCI_DEVICE_ID_INTEL_HDA_ICH10_1: u32 = 14958;
pub const PCI_DEVICE_ID_INTEL_5_3400_SERIES_LPC_MIN: u32 = 15104;
pub const PCI_DEVICE_ID_INTEL_5_3400_SERIES_LPC_MAX: u32 = 15135;
pub const PCI_DEVICE_ID_INTEL_HDA_5_3400_SERIES_0: u32 = 15190;
pub const PCI_DEVICE_ID_INTEL_HDA_5_3400_SERIES_1: u32 = 15191;
pub const PCI_DEVICE_ID_INTEL_IOAT_SNB0: u32 = 15392;
pub const PCI_DEVICE_ID_INTEL_IOAT_SNB1: u32 = 15393;
pub const PCI_DEVICE_ID_INTEL_IOAT_SNB2: u32 = 15394;
pub const PCI_DEVICE_ID_INTEL_IOAT_SNB3: u32 = 15395;
pub const PCI_DEVICE_ID_INTEL_IOAT_SNB4: u32 = 15396;
pub const PCI_DEVICE_ID_INTEL_IOAT_SNB5: u32 = 15397;
pub const PCI_DEVICE_ID_INTEL_IOAT_SNB6: u32 = 15398;
pub const PCI_DEVICE_ID_INTEL_IOAT_SNB7: u32 = 15399;
pub const PCI_DEVICE_ID_INTEL_IOAT_SNB8: u32 = 15406;
pub const PCI_DEVICE_ID_INTEL_IOAT_SNB9: u32 = 15407;
pub const PCI_DEVICE_ID_INTEL_UNC_QPI0: u32 = 15425;
pub const PCI_DEVICE_ID_INTEL_UNC_QPI1: u32 = 15426;
pub const PCI_DEVICE_ID_INTEL_UNC_R2PCIE: u32 = 15427;
pub const PCI_DEVICE_ID_INTEL_UNC_R3QPI0: u32 = 15428;
pub const PCI_DEVICE_ID_INTEL_UNC_R3QPI1: u32 = 15429;
pub const PCI_DEVICE_ID_INTEL_UNC_HA: u32 = 15430;
pub const PCI_DEVICE_ID_INTEL_SBRIDGE_IMC_RAS: u32 = 15473;
pub const PCI_DEVICE_ID_INTEL_SBRIDGE_IMC_ERR0: u32 = 15474;
pub const PCI_DEVICE_ID_INTEL_SBRIDGE_IMC_ERR1: u32 = 15475;
pub const PCI_DEVICE_ID_INTEL_SBRIDGE_IMC_ERR2: u32 = 15478;
pub const PCI_DEVICE_ID_INTEL_SBRIDGE_IMC_ERR3: u32 = 15479;
pub const PCI_DEVICE_ID_INTEL_SBRIDGE_IMC_HA0: u32 = 15520;
pub const PCI_DEVICE_ID_INTEL_SBRIDGE_IMC_TA: u32 = 15528;
pub const PCI_DEVICE_ID_INTEL_SBRIDGE_IMC_TAD0: u32 = 15530;
pub const PCI_DEVICE_ID_INTEL_SBRIDGE_IMC_TAD1: u32 = 15531;
pub const PCI_DEVICE_ID_INTEL_SBRIDGE_IMC_TAD2: u32 = 15532;
pub const PCI_DEVICE_ID_INTEL_SBRIDGE_IMC_TAD3: u32 = 15533;
pub const PCI_DEVICE_ID_INTEL_UNC_IMC0: u32 = 15536;
pub const PCI_DEVICE_ID_INTEL_UNC_IMC1: u32 = 15537;
pub const PCI_DEVICE_ID_INTEL_UNC_IMC2: u32 = 15540;
pub const PCI_DEVICE_ID_INTEL_UNC_IMC3: u32 = 15541;
pub const PCI_DEVICE_ID_INTEL_SBRIDGE_IMC_DDRIO: u32 = 15544;
pub const PCI_DEVICE_ID_INTEL_JAKETOWN_UBOX: u32 = 15584;
pub const PCI_DEVICE_ID_INTEL_SBRIDGE_SAD0: u32 = 15604;
pub const PCI_DEVICE_ID_INTEL_SBRIDGE_BR: u32 = 15605;
pub const PCI_DEVICE_ID_INTEL_SBRIDGE_SAD1: u32 = 15606;
pub const PCI_DEVICE_ID_INTEL_HDA_ICL_H: u32 = 15816;
pub const PCI_DEVICE_ID_INTEL_IOAT_SNB: u32 = 16431;
pub const PCI_DEVICE_ID_INTEL_5400_ERR: u32 = 16432;
pub const PCI_DEVICE_ID_INTEL_5400_FBD0: u32 = 16437;
pub const PCI_DEVICE_ID_INTEL_5400_FBD1: u32 = 16438;
pub const PCI_DEVICE_ID_INTEL_HDA_TGL_H: u32 = 17352;
pub const PCI_DEVICE_ID_INTEL_HDA_DG1: u32 = 18701;
pub const PCI_DEVICE_ID_INTEL_HDA_EHL_0: u32 = 19285;
pub const PCI_DEVICE_ID_INTEL_HDA_EHL_3: u32 = 19288;
pub const PCI_DEVICE_ID_INTEL_HDA_JSL_N: u32 = 19912;
pub const PCI_DEVICE_ID_INTEL_HDA_DG2_0: u32 = 20368;
pub const PCI_DEVICE_ID_INTEL_HDA_DG2_1: u32 = 20369;
pub const PCI_DEVICE_ID_INTEL_HDA_DG2_2: u32 = 20370;
pub const PCI_DEVICE_ID_INTEL_EP80579_0: u32 = 20529;
pub const PCI_DEVICE_ID_INTEL_EP80579_1: u32 = 20530;
pub const PCI_DEVICE_ID_INTEL_HDA_ADL_P: u32 = 20936;
pub const PCI_DEVICE_ID_INTEL_HDA_ADL_PS: u32 = 20937;
pub const PCI_DEVICE_ID_INTEL_HDA_RPL_P_0: u32 = 20938;
pub const PCI_DEVICE_ID_INTEL_HDA_RPL_P_1: u32 = 20939;
pub const PCI_DEVICE_ID_INTEL_HDA_ADL_M: u32 = 20940;
pub const PCI_DEVICE_ID_INTEL_HDA_ADL_PX: u32 = 20941;
pub const PCI_DEVICE_ID_INTEL_HDA_RPL_M: u32 = 20942;
pub const PCI_DEVICE_ID_INTEL_HDA_RPL_PX: u32 = 20943;
pub const PCI_DEVICE_ID_INTEL_HDA_ADL_N: u32 = 21704;
pub const PCI_DEVICE_ID_INTEL_HDA_APL: u32 = 23192;
pub const PCI_DEVICE_ID_INTEL_5100_16: u32 = 26096;
pub const PCI_DEVICE_ID_INTEL_5100_19: u32 = 26099;
pub const PCI_DEVICE_ID_INTEL_5100_21: u32 = 26101;
pub const PCI_DEVICE_ID_INTEL_5100_22: u32 = 26102;
pub const PCI_DEVICE_ID_INTEL_IOAT_SCNB: u32 = 26111;
pub const PCI_DEVICE_ID_INTEL_82371SB_0: u32 = 28672;
pub const PCI_DEVICE_ID_INTEL_82371SB_1: u32 = 28688;
pub const PCI_DEVICE_ID_INTEL_82371SB_2: u32 = 28704;
pub const PCI_DEVICE_ID_INTEL_82437VX: u32 = 28720;
pub const PCI_DEVICE_ID_INTEL_82439TX: u32 = 28928;
pub const PCI_DEVICE_ID_INTEL_82371AB_0: u32 = 28944;
pub const PCI_DEVICE_ID_INTEL_82371AB: u32 = 28945;
pub const PCI_DEVICE_ID_INTEL_82371AB_2: u32 = 28946;
pub const PCI_DEVICE_ID_INTEL_82371AB_3: u32 = 28947;
pub const PCI_DEVICE_ID_INTEL_82810_MC1: u32 = 28960;
pub const PCI_DEVICE_ID_INTEL_82810_IG1: u32 = 28961;
pub const PCI_DEVICE_ID_INTEL_82810_MC3: u32 = 28962;
pub const PCI_DEVICE_ID_INTEL_82810_IG3: u32 = 28963;
pub const PCI_DEVICE_ID_INTEL_82810E_MC: u32 = 28964;
pub const PCI_DEVICE_ID_INTEL_82810E_IG: u32 = 28965;
pub const PCI_DEVICE_ID_INTEL_82443LX_0: u32 = 29056;
pub const PCI_DEVICE_ID_INTEL_82443LX_1: u32 = 29057;
pub const PCI_DEVICE_ID_INTEL_82443BX_0: u32 = 29072;
pub const PCI_DEVICE_ID_INTEL_82443BX_1: u32 = 29073;
pub const PCI_DEVICE_ID_INTEL_82443BX_2: u32 = 29074;
pub const PCI_DEVICE_ID_INTEL_440MX: u32 = 29077;
pub const PCI_DEVICE_ID_INTEL_440MX_6: u32 = 29078;
pub const PCI_DEVICE_ID_INTEL_82443MX_0: u32 = 29080;
pub const PCI_DEVICE_ID_INTEL_82443MX_1: u32 = 29081;
pub const PCI_DEVICE_ID_INTEL_82443MX_3: u32 = 29083;
pub const PCI_DEVICE_ID_INTEL_82443GX_0: u32 = 29088;
pub const PCI_DEVICE_ID_INTEL_82443GX_2: u32 = 29090;
pub const PCI_DEVICE_ID_INTEL_82372FB_1: u32 = 30209;
pub const PCI_DEVICE_ID_INTEL_HDA_ARL: u32 = 30504;
pub const PCI_DEVICE_ID_INTEL_HDA_RPL_S: u32 = 31312;
pub const PCI_DEVICE_ID_INTEL_HDA_ADL_S: u32 = 31440;
pub const PCI_DEVICE_ID_INTEL_HDA_MTL: u32 = 32296;
pub const PCI_DEVICE_ID_INTEL_HDA_ARL_S: u32 = 32592;
pub const PCI_DEVICE_ID_INTEL_SCH_LPC: u32 = 33049;
pub const PCI_DEVICE_ID_INTEL_SCH_IDE: u32 = 33050;
pub const PCI_DEVICE_ID_INTEL_HDA_POULSBO: u32 = 33051;
pub const PCI_DEVICE_ID_INTEL_E6XX_CU: u32 = 33155;
pub const PCI_DEVICE_ID_INTEL_ITC_LPC: u32 = 33158;
pub const PCI_DEVICE_ID_INTEL_82454GX: u32 = 33988;
pub const PCI_DEVICE_ID_INTEL_82450GX: u32 = 33989;
pub const PCI_DEVICE_ID_INTEL_82451NX: u32 = 33994;
pub const PCI_DEVICE_ID_INTEL_82454NX: u32 = 33995;
pub const PCI_DEVICE_ID_INTEL_84460GX: u32 = 34026;
pub const PCI_DEVICE_ID_INTEL_IXP4XX: u32 = 34048;
pub const PCI_DEVICE_ID_INTEL_HDA_LPT: u32 = 35872;
pub const PCI_DEVICE_ID_INTEL_HDA_9_SERIES: u32 = 36000;
pub const PCI_DEVICE_ID_INTEL_HDA_WBG_0: u32 = 36128;
pub const PCI_DEVICE_ID_INTEL_HDA_WBG_1: u32 = 36129;
pub const PCI_DEVICE_ID_INTEL_IXP2800: u32 = 36868;
pub const PCI_DEVICE_ID_INTEL_HDA_LKF: u32 = 39112;
pub const PCI_DEVICE_ID_INTEL_VMD_9A0B: u32 = 39435;
pub const PCI_DEVICE_ID_INTEL_HDA_LPT_LP_0: u32 = 39968;
pub const PCI_DEVICE_ID_INTEL_HDA_LPT_LP_1: u32 = 39969;
pub const PCI_DEVICE_ID_INTEL_HDA_WPT_LP: u32 = 40096;
pub const PCI_DEVICE_ID_INTEL_HDA_SKL_LP: u32 = 40304;
pub const PCI_DEVICE_ID_INTEL_HDA_KBL_LP: u32 = 40305;
pub const PCI_DEVICE_ID_INTEL_HDA_CNL_LP: u32 = 40392;
pub const PCI_DEVICE_ID_INTEL_HDA_TGL_LP: u32 = 41160;
pub const PCI_DEVICE_ID_INTEL_HDA_SKL: u32 = 41328;
pub const PCI_DEVICE_ID_INTEL_HDA_KBL: u32 = 41329;
pub const PCI_DEVICE_ID_INTEL_HDA_LBG_0: u32 = 41456;
pub const PCI_DEVICE_ID_INTEL_HDA_LBG_1: u32 = 41584;
pub const PCI_DEVICE_ID_INTEL_HDA_KBL_H: u32 = 41712;
pub const PCI_DEVICE_ID_INTEL_HDA_CNL_H: u32 = 41800;
pub const PCI_DEVICE_ID_INTEL_HDA_CML_S: u32 = 41968;
pub const PCI_DEVICE_ID_INTEL_HDA_LNL_P: u32 = 43048;
pub const PCI_DEVICE_ID_INTEL_S21152BB: u32 = 45394;
pub const PCI_DEVICE_ID_INTEL_HDA_BMG: u32 = 58103;
pub const PCI_DEVICE_ID_INTEL_HDA_PTL_H: u32 = 58152;
pub const PCI_DEVICE_ID_INTEL_HDA_PTL: u32 = 58408;
pub const PCI_DEVICE_ID_INTEL_HDA_CML_R: u32 = 61640;
pub const PCI_DEVICE_ID_INTEL_HDA_RKL_S: u32 = 61896;
pub const PCI_VENDOR_ID_WANGXUN: u32 = 32904;
pub const PCI_VENDOR_ID_SCALEMP: u32 = 34438;
pub const PCI_DEVICE_ID_SCALEMP_VSMP_CTL: u32 = 4112;
pub const PCI_VENDOR_ID_COMPUTONE: u32 = 36366;
pub const PCI_DEVICE_ID_COMPUTONE_PG: u32 = 770;
pub const PCI_SUBVENDOR_ID_COMPUTONE: u32 = 36366;
pub const PCI_SUBDEVICE_ID_COMPUTONE_PG4: u32 = 1;
pub const PCI_SUBDEVICE_ID_COMPUTONE_PG8: u32 = 2;
pub const PCI_SUBDEVICE_ID_COMPUTONE_PG6: u32 = 3;
pub const PCI_VENDOR_ID_KTI: u32 = 36398;
pub const PCI_VENDOR_ID_ADAPTEC: u32 = 36868;
pub const PCI_DEVICE_ID_ADAPTEC_7810: u32 = 4216;
pub const PCI_DEVICE_ID_ADAPTEC_7821: u32 = 8568;
pub const PCI_DEVICE_ID_ADAPTEC_38602: u32 = 14432;
pub const PCI_DEVICE_ID_ADAPTEC_7850: u32 = 20600;
pub const PCI_DEVICE_ID_ADAPTEC_7855: u32 = 21880;
pub const PCI_DEVICE_ID_ADAPTEC_3860: u32 = 24632;
pub const PCI_DEVICE_ID_ADAPTEC_1480A: u32 = 24693;
pub const PCI_DEVICE_ID_ADAPTEC_7860: u32 = 24696;
pub const PCI_DEVICE_ID_ADAPTEC_7861: u32 = 24952;
pub const PCI_DEVICE_ID_ADAPTEC_7870: u32 = 28792;
pub const PCI_DEVICE_ID_ADAPTEC_7871: u32 = 29048;
pub const PCI_DEVICE_ID_ADAPTEC_7872: u32 = 29304;
pub const PCI_DEVICE_ID_ADAPTEC_7873: u32 = 29560;
pub const PCI_DEVICE_ID_ADAPTEC_7874: u32 = 29816;
pub const PCI_DEVICE_ID_ADAPTEC_7895: u32 = 30869;
pub const PCI_DEVICE_ID_ADAPTEC_7880: u32 = 32888;
pub const PCI_DEVICE_ID_ADAPTEC_7881: u32 = 33144;
pub const PCI_DEVICE_ID_ADAPTEC_7882: u32 = 33400;
pub const PCI_DEVICE_ID_ADAPTEC_7883: u32 = 33656;
pub const PCI_DEVICE_ID_ADAPTEC_7884: u32 = 33912;
pub const PCI_DEVICE_ID_ADAPTEC_7885: u32 = 34168;
pub const PCI_DEVICE_ID_ADAPTEC_7886: u32 = 34424;
pub const PCI_DEVICE_ID_ADAPTEC_7887: u32 = 34680;
pub const PCI_DEVICE_ID_ADAPTEC_7888: u32 = 34936;
pub const PCI_VENDOR_ID_ADAPTEC2: u32 = 36869;
pub const PCI_DEVICE_ID_ADAPTEC2_2940U2: u32 = 16;
pub const PCI_DEVICE_ID_ADAPTEC2_2930U2: u32 = 17;
pub const PCI_DEVICE_ID_ADAPTEC2_7890B: u32 = 19;
pub const PCI_DEVICE_ID_ADAPTEC2_7890: u32 = 31;
pub const PCI_DEVICE_ID_ADAPTEC2_3940U2: u32 = 80;
pub const PCI_DEVICE_ID_ADAPTEC2_3950U2D: u32 = 81;
pub const PCI_DEVICE_ID_ADAPTEC2_7896: u32 = 95;
pub const PCI_DEVICE_ID_ADAPTEC2_7892A: u32 = 128;
pub const PCI_DEVICE_ID_ADAPTEC2_7892B: u32 = 129;
pub const PCI_DEVICE_ID_ADAPTEC2_7892D: u32 = 131;
pub const PCI_DEVICE_ID_ADAPTEC2_7892P: u32 = 143;
pub const PCI_DEVICE_ID_ADAPTEC2_7899A: u32 = 192;
pub const PCI_DEVICE_ID_ADAPTEC2_7899B: u32 = 193;
pub const PCI_DEVICE_ID_ADAPTEC2_7899D: u32 = 195;
pub const PCI_DEVICE_ID_ADAPTEC2_7899P: u32 = 207;
pub const PCI_DEVICE_ID_ADAPTEC2_OBSIDIAN: u32 = 1280;
pub const PCI_DEVICE_ID_ADAPTEC2_SCAMP: u32 = 1283;
pub const PCI_VENDOR_ID_HOLTEK: u32 = 37906;
pub const PCI_DEVICE_ID_HOLTEK_6565: u32 = 25957;
pub const PCI_VENDOR_ID_NETMOS: u32 = 38672;
pub const PCI_DEVICE_ID_NETMOS_9705: u32 = 38661;
pub const PCI_DEVICE_ID_NETMOS_9715: u32 = 38677;
pub const PCI_DEVICE_ID_NETMOS_9735: u32 = 38709;
pub const PCI_DEVICE_ID_NETMOS_9745: u32 = 38725;
pub const PCI_DEVICE_ID_NETMOS_9755: u32 = 38741;
pub const PCI_DEVICE_ID_NETMOS_9805: u32 = 38917;
pub const PCI_DEVICE_ID_NETMOS_9815: u32 = 38933;
pub const PCI_DEVICE_ID_NETMOS_9835: u32 = 38965;
pub const PCI_DEVICE_ID_NETMOS_9845: u32 = 38981;
pub const PCI_DEVICE_ID_NETMOS_9855: u32 = 38997;
pub const PCI_DEVICE_ID_NETMOS_9865: u32 = 39013;
pub const PCI_DEVICE_ID_NETMOS_9900: u32 = 39168;
pub const PCI_DEVICE_ID_NETMOS_9901: u32 = 39169;
pub const PCI_DEVICE_ID_NETMOS_9904: u32 = 39172;
pub const PCI_DEVICE_ID_NETMOS_9912: u32 = 39186;
pub const PCI_DEVICE_ID_NETMOS_9922: u32 = 39202;
pub const PCI_VENDOR_ID_3COM_2: u32 = 42791;
pub const PCI_VENDOR_ID_SOLIDRUN: u32 = 53347;
pub const PCI_VENDOR_ID_DIGIUM: u32 = 53601;
pub const PCI_DEVICE_ID_DIGIUM_HFC4S: u32 = 46096;
pub const PCI_SUBVENDOR_ID_EXSYS: u32 = 55373;
pub const PCI_SUBDEVICE_ID_EXSYS_4014: u32 = 16404;
pub const PCI_SUBDEVICE_ID_EXSYS_4055: u32 = 16469;
pub const PCI_VENDOR_ID_TIGERJET: u32 = 57689;
pub const PCI_DEVICE_ID_TIGERJET_300: u32 = 1;
pub const PCI_DEVICE_ID_TIGERJET_100: u32 = 2;
pub const PCI_VENDOR_ID_XILINX_RME: u32 = 60000;
pub const PCI_DEVICE_ID_RME_DIGI32: u32 = 39062;
pub const PCI_DEVICE_ID_RME_DIGI32_PRO: u32 = 39063;
pub const PCI_DEVICE_ID_RME_DIGI32_8: u32 = 39064;
pub const PCI_VENDOR_ID_XEN: u32 = 22611;
pub const PCI_DEVICE_ID_XEN_PLATFORM: u32 = 1;
pub const PCI_VENDOR_ID_OCZ: u32 = 7045;
pub const PCI_VENDOR_ID_NCUBE: u32 = 4351;
pub const PCI_STATUS_ERROR_BITS: u32 = 63744;
pub const PCI_NUM_RESET_METHODS: u32 = 8;
pub const PCI_BRIDGE_RESOURCE_NUM: u32 = 4;
pub const PCI_NUM_INTX: u32 = 4;
pub const PCI_ERROR_RESPONSE: i32 = -1;
pub const PCI_DOMAIN_NR_NOT_SET: i32 = -1;
pub const PCI_REGION_FLAG_MASK: u32 = 15;
pub const PCIBIOS_SUCCESSFUL: u32 = 0;
pub const PCIBIOS_FUNC_NOT_SUPPORTED: u32 = 129;
pub const PCIBIOS_BAD_VENDOR_ID: u32 = 131;
pub const PCIBIOS_DEVICE_NOT_FOUND: u32 = 134;
pub const PCIBIOS_BAD_REGISTER_NUMBER: u32 = 135;
pub const PCIBIOS_SET_FAILED: u32 = 136;
pub const PCIBIOS_BUFFER_TOO_SMALL: u32 = 137;
pub const PCI_IRQ_INTX: u32 = 1;
pub const PCI_IRQ_MSI: u32 = 2;
pub const PCI_IRQ_MSIX: u32 = 4;
pub const PCI_IRQ_AFFINITY: u32 = 8;
pub const HAVE_PCI_REQ_REGIONS: u32 = 2;
pub const PCI_VGA_STATE_CHANGE_BRIDGE: u32 = 1;
pub const PCI_VGA_STATE_CHANGE_DECODES: u32 = 2;
pub const PCI_IRQ_VIRTUAL: u32 = 16;
pub const PCI_IRQ_ALL_TYPES: u32 = 7;
pub const PCIBIOS_MIN_IO: u32 = 4096;
pub const PCIBIOS_MIN_MEM: u32 = 0;
pub const PCIPCI_FAIL: u32 = 1;
pub const PCIPCI_TRITON: u32 = 2;
pub const PCIPCI_NATOMA: u32 = 4;
pub const PCIPCI_VIAETBF: u32 = 8;
pub const PCIPCI_VSFX: u32 = 16;
pub const PCIPCI_ALIMAGIK: u32 = 32;
pub const PCIAGP_FAIL: u32 = 64;
pub const PCI_VPD_LRDT: u32 = 128;
pub const PCI_VPD_LTIN_ID_STRING: u32 = 2;
pub const PCI_VPD_LTIN_RO_DATA: u32 = 16;
pub const PCI_VPD_LTIN_RW_DATA: u32 = 17;
pub const PCI_VPD_RO_KEYWORD_PARTNO: &[u8; 3] = b"PN\0";
pub const PCI_VPD_RO_KEYWORD_SERIALNO: &[u8; 3] = b"SN\0";
pub const PCI_VPD_RO_KEYWORD_MFR_ID: &[u8; 3] = b"MN\0";
pub const PCI_VPD_RO_KEYWORD_VENDOR0: &[u8; 3] = b"V0\0";
pub const PCI_VPD_RO_KEYWORD_CHKSUM: &[u8; 3] = b"RV\0";
pub const LEDS_TRIG_TYPE_EDGE: u32 = 0;
pub const LEDS_TRIG_TYPE_LEVEL: u32 = 1;
pub const LEDS_BOOST_OFF: u32 = 0;
pub const LEDS_BOOST_ADAPTIVE: u32 = 1;
pub const LEDS_BOOST_FIXED: u32 = 2;
pub const LED_COLOR_ID_WHITE: u32 = 0;
pub const LED_COLOR_ID_RED: u32 = 1;
pub const LED_COLOR_ID_GREEN: u32 = 2;
pub const LED_COLOR_ID_BLUE: u32 = 3;
pub const LED_COLOR_ID_AMBER: u32 = 4;
pub const LED_COLOR_ID_VIOLET: u32 = 5;
pub const LED_COLOR_ID_YELLOW: u32 = 6;
pub const LED_COLOR_ID_IR: u32 = 7;
pub const LED_COLOR_ID_MULTI: u32 = 8;
pub const LED_COLOR_ID_RGB: u32 = 9;
pub const LED_COLOR_ID_PURPLE: u32 = 10;
pub const LED_COLOR_ID_ORANGE: u32 = 11;
pub const LED_COLOR_ID_PINK: u32 = 12;
pub const LED_COLOR_ID_CYAN: u32 = 13;
pub const LED_COLOR_ID_LIME: u32 = 14;
pub const LED_COLOR_ID_MAX: u32 = 15;
pub const LED_FUNCTION_CAPSLOCK: &[u8; 9] = b"capslock\0";
pub const LED_FUNCTION_SCROLLLOCK: &[u8; 11] = b"scrolllock\0";
pub const LED_FUNCTION_NUMLOCK: &[u8; 8] = b"numlock\0";
pub const LED_FUNCTION_FNLOCK: &[u8; 7] = b"fnlock\0";
pub const LED_FUNCTION_KBD_BACKLIGHT: &[u8; 14] = b"kbd_backlight\0";
pub const LED_FUNCTION_POWER: &[u8; 6] = b"power\0";
pub const LED_FUNCTION_DISK: &[u8; 5] = b"disk\0";
pub const LED_FUNCTION_CHARGING: &[u8; 9] = b"charging\0";
pub const LED_FUNCTION_STATUS: &[u8; 7] = b"status\0";
pub const LED_FUNCTION_MICMUTE: &[u8; 8] = b"micmute\0";
pub const LED_FUNCTION_MUTE: &[u8; 5] = b"mute\0";
pub const LED_FUNCTION_PLAYER1: &[u8; 9] = b"player-1\0";
pub const LED_FUNCTION_PLAYER2: &[u8; 9] = b"player-2\0";
pub const LED_FUNCTION_PLAYER3: &[u8; 9] = b"player-3\0";
pub const LED_FUNCTION_PLAYER4: &[u8; 9] = b"player-4\0";
pub const LED_FUNCTION_PLAYER5: &[u8; 9] = b"player-5\0";
pub const LED_FUNCTION_ACTIVITY: &[u8; 9] = b"activity\0";
pub const LED_FUNCTION_ALARM: &[u8; 6] = b"alarm\0";
pub const LED_FUNCTION_BACKLIGHT: &[u8; 10] = b"backlight\0";
pub const LED_FUNCTION_BLUETOOTH: &[u8; 10] = b"bluetooth\0";
pub const LED_FUNCTION_BOOT: &[u8; 5] = b"boot\0";
pub const LED_FUNCTION_CPU: &[u8; 4] = b"cpu\0";
pub const LED_FUNCTION_DEBUG: &[u8; 6] = b"debug\0";
pub const LED_FUNCTION_DISK_ACTIVITY: &[u8; 14] = b"disk-activity\0";
pub const LED_FUNCTION_DISK_ERR: &[u8; 9] = b"disk-err\0";
pub const LED_FUNCTION_DISK_READ: &[u8; 10] = b"disk-read\0";
pub const LED_FUNCTION_DISK_WRITE: &[u8; 11] = b"disk-write\0";
pub const LED_FUNCTION_FAULT: &[u8; 6] = b"fault\0";
pub const LED_FUNCTION_FLASH: &[u8; 6] = b"flash\0";
pub const LED_FUNCTION_HEARTBEAT: &[u8; 10] = b"heartbeat\0";
pub const LED_FUNCTION_INDICATOR: &[u8; 10] = b"indicator\0";
pub const LED_FUNCTION_LAN: &[u8; 4] = b"lan\0";
pub const LED_FUNCTION_MAIL: &[u8; 5] = b"mail\0";
pub const LED_FUNCTION_MOBILE: &[u8; 7] = b"mobile\0";
pub const LED_FUNCTION_MTD: &[u8; 4] = b"mtd\0";
pub const LED_FUNCTION_PANIC: &[u8; 6] = b"panic\0";
pub const LED_FUNCTION_PROGRAMMING: &[u8; 12] = b"programming\0";
pub const LED_FUNCTION_RX: &[u8; 3] = b"rx\0";
pub const LED_FUNCTION_SD: &[u8; 3] = b"sd\0";
pub const LED_FUNCTION_SPEED_LAN: &[u8; 10] = b"speed-lan\0";
pub const LED_FUNCTION_SPEED_WAN: &[u8; 10] = b"speed-wan\0";
pub const LED_FUNCTION_STANDBY: &[u8; 8] = b"standby\0";
pub const LED_FUNCTION_TORCH: &[u8; 6] = b"torch\0";
pub const LED_FUNCTION_TX: &[u8; 3] = b"tx\0";
pub const LED_FUNCTION_USB: &[u8; 4] = b"usb\0";
pub const LED_FUNCTION_WAN: &[u8; 4] = b"wan\0";
pub const LED_FUNCTION_WAN_ONLINE: &[u8; 11] = b"wan-online\0";
pub const LED_FUNCTION_WLAN: &[u8; 5] = b"wlan\0";
pub const LED_FUNCTION_WLAN_2GHZ: &[u8; 10] = b"wlan-2ghz\0";
pub const LED_FUNCTION_WLAN_5GHZ: &[u8; 10] = b"wlan-5ghz\0";
pub const LED_FUNCTION_WLAN_6GHZ: &[u8; 10] = b"wlan-6ghz\0";
pub const LED_FUNCTION_WPS: &[u8; 4] = b"wps\0";
pub const LED_BLINK_SW: u32 = 0;
pub const LED_BLINK_ONESHOT: u32 = 1;
pub const LED_BLINK_ONESHOT_STOP: u32 = 2;
pub const LED_BLINK_INVERT: u32 = 3;
pub const LED_BLINK_BRIGHTNESS_CHANGE: u32 = 4;
pub const LED_BLINK_DISABLE: u32 = 5;
pub const LED_SET_BRIGHTNESS_OFF: u32 = 6;
pub const LED_SET_BRIGHTNESS: u32 = 7;
pub const LED_SET_BLINK: u32 = 8;
pub const TRIG_NAME_MAX: u32 = 50;
pub const GPIO_LED_NO_BLINK_LOW: u32 = 0;
pub const GPIO_LED_NO_BLINK_HIGH: u32 = 1;
pub const GPIO_LED_BLINK: u32 = 2;
pub const DELAY_CONST_MAX: u32 = 20000;
pub const MAX_UDELAY_MS: u32 = 5;
pub const PHY_POLL: i32 = -1;
pub const PHY_MAC_INTERRUPT: i32 = -2;
pub const PHY_IS_INTERNAL: u32 = 1;
pub const PHY_RST_AFTER_CLK_EN: u32 = 2;
pub const PHY_POLL_CABLE_TEST: u32 = 4;
pub const PHY_ALWAYS_CALL_SUSPEND: u32 = 8;
pub const MDIO_DEVICE_IS_PHY: u32 = 2147483648;
pub const PHY_MAX_ADDR: u32 = 32;
pub const PHY_ID_FMT: &[u8; 8] = b"%s:%02x\0";
pub const MII_BUS_ID_SIZE: u32 = 61;
pub const MDIO_MMD_NUM: u32 = 32;
pub const PHY_F_NO_IRQ: u32 = 2147483648;
pub const PHY_F_RXC_ALWAYS_ON: u32 = 1073741824;
pub const PHY_PAIR_ALL: i32 = -1;
pub const PLATFORM_DEVID_NONE: i32 = -1;
pub const PLATFORM_DEVID_AUTO: i32 = -2;
pub const POLLIN: u32 = 1;
pub const POLLPRI: u32 = 2;
pub const POLLOUT: u32 = 4;
pub const POLLERR: u32 = 8;
pub const POLLHUP: u32 = 16;
pub const POLLNVAL: u32 = 32;
pub const POLLRDNORM: u32 = 64;
pub const POLLRDBAND: u32 = 128;
pub const POLLWRNORM: u32 = 256;
pub const POLLWRBAND: u32 = 512;
pub const POLLMSG: u32 = 1024;
pub const POLLREMOVE: u32 = 4096;
pub const POLLRDHUP: u32 = 8192;
pub const EPOLL_CLOEXEC: u32 = 524288;
pub const EPOLL_CTL_ADD: u32 = 1;
pub const EPOLL_CTL_DEL: u32 = 2;
pub const EPOLL_CTL_MOD: u32 = 3;
pub const EPOLL_IOC_TYPE: u32 = 138;
pub const MAX_STACK_ALLOC: u32 = 832;
pub const FRONTEND_STACK_ALLOC: u32 = 256;
pub const SELECT_STACK_ALLOC: u32 = 256;
pub const POLL_STACK_ALLOC: u32 = 256;
pub const WQUEUES_STACK_ALLOC: u32 = 576;
pub const TRACEPOINT_DEFAULT_PRIO: u32 = 10;
pub const STACK_DEPOT_EXTRA_BITS: u32 = 5;
pub const DEPOT_POOL_ORDER: u32 = 2;
pub const DEPOT_POOL_SIZE: u32 = 16384;
pub const DEPOT_STACK_ALIGN: u32 = 4;
pub const DEPOT_OFFSET_BITS: u32 = 10;
pub const STACK_DEPOT_FLAGS_NUM: u32 = 2;
pub const DRM_NAME: &[u8; 4] = b"drm\0";
pub const DRM_MIN_ORDER: u32 = 5;
pub const DRM_MAX_ORDER: u32 = 22;
pub const DRM_RAM_PERCENT: u32 = 10;
pub const _DRM_LOCK_HELD: u32 = 2147483648;
pub const _DRM_LOCK_CONT: u32 = 1073741824;
pub const _DRM_VBLANK_HIGH_CRTC_SHIFT: u32 = 1;
pub const _DRM_PRE_MODESET: u32 = 1;
pub const _DRM_POST_MODESET: u32 = 2;
pub const DRM_CAP_DUMB_BUFFER: u32 = 1;
pub const DRM_CAP_VBLANK_HIGH_CRTC: u32 = 2;
pub const DRM_CAP_DUMB_PREFERRED_DEPTH: u32 = 3;
pub const DRM_CAP_DUMB_PREFER_SHADOW: u32 = 4;
pub const DRM_CAP_PRIME: u32 = 5;
pub const DRM_PRIME_CAP_IMPORT: u32 = 1;
pub const DRM_PRIME_CAP_EXPORT: u32 = 2;
pub const DRM_CAP_TIMESTAMP_MONOTONIC: u32 = 6;
pub const DRM_CAP_ASYNC_PAGE_FLIP: u32 = 7;
pub const DRM_CAP_CURSOR_WIDTH: u32 = 8;
pub const DRM_CAP_CURSOR_HEIGHT: u32 = 9;
pub const DRM_CAP_ADDFB2_MODIFIERS: u32 = 16;
pub const DRM_CAP_PAGE_FLIP_TARGET: u32 = 17;
pub const DRM_CAP_CRTC_IN_VBLANK_EVENT: u32 = 18;
pub const DRM_CAP_SYNCOBJ: u32 = 19;
pub const DRM_CAP_SYNCOBJ_TIMELINE: u32 = 20;
pub const DRM_CAP_ATOMIC_ASYNC_PAGE_FLIP: u32 = 21;
pub const DRM_CLIENT_CAP_STEREO_3D: u32 = 1;
pub const DRM_CLIENT_CAP_UNIVERSAL_PLANES: u32 = 2;
pub const DRM_CLIENT_CAP_ATOMIC: u32 = 3;
pub const DRM_CLIENT_CAP_ASPECT_RATIO: u32 = 4;
pub const DRM_CLIENT_CAP_WRITEBACK_CONNECTORS: u32 = 5;
pub const DRM_CLIENT_CAP_CURSOR_PLANE_HOTSPOT: u32 = 6;
pub const DRM_RDWR: u32 = 2;
pub const DRM_CLOEXEC: u32 = 524288;
pub const DRM_SYNCOBJ_CREATE_SIGNALED: u32 = 1;
pub const DRM_SYNCOBJ_FD_TO_HANDLE_FLAGS_IMPORT_SYNC_FILE: u32 = 1;
pub const DRM_SYNCOBJ_HANDLE_TO_FD_FLAGS_EXPORT_SYNC_FILE: u32 = 1;
pub const DRM_SYNCOBJ_WAIT_FLAGS_WAIT_ALL: u32 = 1;
pub const DRM_SYNCOBJ_WAIT_FLAGS_WAIT_FOR_SUBMIT: u32 = 2;
pub const DRM_SYNCOBJ_WAIT_FLAGS_WAIT_AVAILABLE: u32 = 4;
pub const DRM_SYNCOBJ_WAIT_FLAGS_WAIT_DEADLINE: u32 = 8;
pub const DRM_SYNCOBJ_QUERY_FLAGS_LAST_SUBMITTED: u32 = 1;
pub const DRM_CRTC_SEQUENCE_RELATIVE: u32 = 1;
pub const DRM_CRTC_SEQUENCE_NEXT_ON_MISS: u32 = 2;
pub const DRM_CLIENT_NAME_MAX_LEN: u32 = 64;
pub const DRM_CONNECTOR_NAME_LEN: u32 = 32;
pub const DRM_DISPLAY_MODE_LEN: u32 = 32;
pub const DRM_PROP_NAME_LEN: u32 = 32;
pub const DRM_MODE_TYPE_BUILTIN: u32 = 1;
pub const DRM_MODE_TYPE_CLOCK_C: u32 = 3;
pub const DRM_MODE_TYPE_CRTC_C: u32 = 5;
pub const DRM_MODE_TYPE_PREFERRED: u32 = 8;
pub const DRM_MODE_TYPE_DEFAULT: u32 = 16;
pub const DRM_MODE_TYPE_USERDEF: u32 = 32;
pub const DRM_MODE_TYPE_DRIVER: u32 = 64;
pub const DRM_MODE_TYPE_ALL: u32 = 104;
pub const DRM_MODE_FLAG_PHSYNC: u32 = 1;
pub const DRM_MODE_FLAG_NHSYNC: u32 = 2;
pub const DRM_MODE_FLAG_PVSYNC: u32 = 4;
pub const DRM_MODE_FLAG_NVSYNC: u32 = 8;
pub const DRM_MODE_FLAG_INTERLACE: u32 = 16;
pub const DRM_MODE_FLAG_DBLSCAN: u32 = 32;
pub const DRM_MODE_FLAG_CSYNC: u32 = 64;
pub const DRM_MODE_FLAG_PCSYNC: u32 = 128;
pub const DRM_MODE_FLAG_NCSYNC: u32 = 256;
pub const DRM_MODE_FLAG_HSKEW: u32 = 512;
pub const DRM_MODE_FLAG_BCAST: u32 = 1024;
pub const DRM_MODE_FLAG_PIXMUX: u32 = 2048;
pub const DRM_MODE_FLAG_DBLCLK: u32 = 4096;
pub const DRM_MODE_FLAG_CLKDIV2: u32 = 8192;
pub const DRM_MODE_FLAG_3D_MASK: u32 = 507904;
pub const DRM_MODE_FLAG_3D_NONE: u32 = 0;
pub const DRM_MODE_FLAG_3D_FRAME_PACKING: u32 = 16384;
pub const DRM_MODE_FLAG_3D_FIELD_ALTERNATIVE: u32 = 32768;
pub const DRM_MODE_FLAG_3D_LINE_ALTERNATIVE: u32 = 49152;
pub const DRM_MODE_FLAG_3D_SIDE_BY_SIDE_FULL: u32 = 65536;
pub const DRM_MODE_FLAG_3D_L_DEPTH: u32 = 81920;
pub const DRM_MODE_FLAG_3D_L_DEPTH_GFX_GFX_DEPTH: u32 = 98304;
pub const DRM_MODE_FLAG_3D_TOP_AND_BOTTOM: u32 = 114688;
pub const DRM_MODE_FLAG_3D_SIDE_BY_SIDE_HALF: u32 = 131072;
pub const DRM_MODE_PICTURE_ASPECT_NONE: u32 = 0;
pub const DRM_MODE_PICTURE_ASPECT_4_3: u32 = 1;
pub const DRM_MODE_PICTURE_ASPECT_16_9: u32 = 2;
pub const DRM_MODE_PICTURE_ASPECT_64_27: u32 = 3;
pub const DRM_MODE_PICTURE_ASPECT_256_135: u32 = 4;
pub const DRM_MODE_CONTENT_TYPE_NO_DATA: u32 = 0;
pub const DRM_MODE_CONTENT_TYPE_GRAPHICS: u32 = 1;
pub const DRM_MODE_CONTENT_TYPE_PHOTO: u32 = 2;
pub const DRM_MODE_CONTENT_TYPE_CINEMA: u32 = 3;
pub const DRM_MODE_CONTENT_TYPE_GAME: u32 = 4;
pub const DRM_MODE_FLAG_PIC_AR_MASK: u32 = 7864320;
pub const DRM_MODE_FLAG_PIC_AR_NONE: u32 = 0;
pub const DRM_MODE_FLAG_PIC_AR_4_3: u32 = 524288;
pub const DRM_MODE_FLAG_PIC_AR_16_9: u32 = 1048576;
pub const DRM_MODE_FLAG_PIC_AR_64_27: u32 = 1572864;
pub const DRM_MODE_FLAG_PIC_AR_256_135: u32 = 2097152;
pub const DRM_MODE_FLAG_ALL: u32 = 521215;
pub const DRM_MODE_DPMS_ON: u32 = 0;
pub const DRM_MODE_DPMS_STANDBY: u32 = 1;
pub const DRM_MODE_DPMS_SUSPEND: u32 = 2;
pub const DRM_MODE_DPMS_OFF: u32 = 3;
pub const DRM_MODE_SCALE_NONE: u32 = 0;
pub const DRM_MODE_SCALE_FULLSCREEN: u32 = 1;
pub const DRM_MODE_SCALE_CENTER: u32 = 2;
pub const DRM_MODE_SCALE_ASPECT: u32 = 3;
pub const DRM_MODE_DITHERING_OFF: u32 = 0;
pub const DRM_MODE_DITHERING_ON: u32 = 1;
pub const DRM_MODE_DITHERING_AUTO: u32 = 2;
pub const DRM_MODE_DIRTY_OFF: u32 = 0;
pub const DRM_MODE_DIRTY_ON: u32 = 1;
pub const DRM_MODE_DIRTY_ANNOTATE: u32 = 2;
pub const DRM_MODE_LINK_STATUS_GOOD: u32 = 0;
pub const DRM_MODE_LINK_STATUS_BAD: u32 = 1;
pub const DRM_MODE_ROTATE_0: u32 = 1;
pub const DRM_MODE_ROTATE_90: u32 = 2;
pub const DRM_MODE_ROTATE_180: u32 = 4;
pub const DRM_MODE_ROTATE_270: u32 = 8;
pub const DRM_MODE_ROTATE_MASK: u32 = 15;
pub const DRM_MODE_REFLECT_X: u32 = 16;
pub const DRM_MODE_REFLECT_Y: u32 = 32;
pub const DRM_MODE_REFLECT_MASK: u32 = 48;
pub const DRM_MODE_CONTENT_PROTECTION_UNDESIRED: u32 = 0;
pub const DRM_MODE_CONTENT_PROTECTION_DESIRED: u32 = 1;
pub const DRM_MODE_CONTENT_PROTECTION_ENABLED: u32 = 2;
pub const DRM_MODE_PRESENT_TOP_FIELD: u32 = 1;
pub const DRM_MODE_PRESENT_BOTTOM_FIELD: u32 = 2;
pub const DRM_MODE_ENCODER_NONE: u32 = 0;
pub const DRM_MODE_ENCODER_DAC: u32 = 1;
pub const DRM_MODE_ENCODER_TMDS: u32 = 2;
pub const DRM_MODE_ENCODER_LVDS: u32 = 3;
pub const DRM_MODE_ENCODER_TVDAC: u32 = 4;
pub const DRM_MODE_ENCODER_VIRTUAL: u32 = 5;
pub const DRM_MODE_ENCODER_DSI: u32 = 6;
pub const DRM_MODE_ENCODER_DPMST: u32 = 7;
pub const DRM_MODE_ENCODER_DPI: u32 = 8;
pub const DRM_MODE_CONNECTOR_Unknown: u32 = 0;
pub const DRM_MODE_CONNECTOR_VGA: u32 = 1;
pub const DRM_MODE_CONNECTOR_DVII: u32 = 2;
pub const DRM_MODE_CONNECTOR_DVID: u32 = 3;
pub const DRM_MODE_CONNECTOR_DVIA: u32 = 4;
pub const DRM_MODE_CONNECTOR_Composite: u32 = 5;
pub const DRM_MODE_CONNECTOR_SVIDEO: u32 = 6;
pub const DRM_MODE_CONNECTOR_LVDS: u32 = 7;
pub const DRM_MODE_CONNECTOR_Component: u32 = 8;
pub const DRM_MODE_CONNECTOR_9PinDIN: u32 = 9;
pub const DRM_MODE_CONNECTOR_DisplayPort: u32 = 10;
pub const DRM_MODE_CONNECTOR_HDMIA: u32 = 11;
pub const DRM_MODE_CONNECTOR_HDMIB: u32 = 12;
pub const DRM_MODE_CONNECTOR_TV: u32 = 13;
pub const DRM_MODE_CONNECTOR_eDP: u32 = 14;
pub const DRM_MODE_CONNECTOR_VIRTUAL: u32 = 15;
pub const DRM_MODE_CONNECTOR_DSI: u32 = 16;
pub const DRM_MODE_CONNECTOR_DPI: u32 = 17;
pub const DRM_MODE_CONNECTOR_WRITEBACK: u32 = 18;
pub const DRM_MODE_CONNECTOR_SPI: u32 = 19;
pub const DRM_MODE_CONNECTOR_USB: u32 = 20;
pub const DRM_MODE_PROP_PENDING: u32 = 1;
pub const DRM_MODE_PROP_RANGE: u32 = 2;
pub const DRM_MODE_PROP_IMMUTABLE: u32 = 4;
pub const DRM_MODE_PROP_ENUM: u32 = 8;
pub const DRM_MODE_PROP_BLOB: u32 = 16;
pub const DRM_MODE_PROP_BITMASK: u32 = 32;
pub const DRM_MODE_PROP_LEGACY_TYPE: u32 = 58;
pub const DRM_MODE_PROP_EXTENDED_TYPE: u32 = 65472;
pub const DRM_MODE_PROP_ATOMIC: u32 = 2147483648;
pub const DRM_MODE_OBJECT_CRTC: u32 = 3435973836;
pub const DRM_MODE_OBJECT_CONNECTOR: u32 = 3233857728;
pub const DRM_MODE_OBJECT_ENCODER: u32 = 3772834016;
pub const DRM_MODE_OBJECT_MODE: u32 = 3739147998;
pub const DRM_MODE_OBJECT_PROPERTY: u32 = 2964369584;
pub const DRM_MODE_OBJECT_FB: u32 = 4227595259;
pub const DRM_MODE_OBJECT_BLOB: u32 = 3149642683;
pub const DRM_MODE_OBJECT_PLANE: u32 = 4008636142;
pub const DRM_MODE_OBJECT_ANY: u32 = 0;
pub const DRM_MODE_FB_INTERLACED: u32 = 1;
pub const DRM_MODE_FB_MODIFIERS: u32 = 2;
pub const DRM_MODE_FB_DIRTY_ANNOTATE_COPY: u32 = 1;
pub const DRM_MODE_FB_DIRTY_ANNOTATE_FILL: u32 = 2;
pub const DRM_MODE_FB_DIRTY_FLAGS: u32 = 3;
pub const DRM_MODE_FB_DIRTY_MAX_CLIPS: u32 = 256;
pub const DRM_MODE_CURSOR_BO: u32 = 1;
pub const DRM_MODE_CURSOR_MOVE: u32 = 2;
pub const DRM_MODE_CURSOR_FLAGS: u32 = 3;
pub const DRM_MODE_PAGE_FLIP_EVENT: u32 = 1;
pub const DRM_MODE_PAGE_FLIP_ASYNC: u32 = 2;
pub const DRM_MODE_PAGE_FLIP_TARGET_ABSOLUTE: u32 = 4;
pub const DRM_MODE_PAGE_FLIP_TARGET_RELATIVE: u32 = 8;
pub const DRM_MODE_PAGE_FLIP_TARGET: u32 = 12;
pub const DRM_MODE_PAGE_FLIP_FLAGS: u32 = 15;
pub const DRM_MODE_ATOMIC_TEST_ONLY: u32 = 256;
pub const DRM_MODE_ATOMIC_NONBLOCK: u32 = 512;
pub const DRM_MODE_ATOMIC_ALLOW_MODESET: u32 = 1024;
pub const DRM_MODE_ATOMIC_FLAGS: u32 = 1795;
pub const FORMAT_BLOB_CURRENT: u32 = 1;
pub const DRM_IOCTL_BASE: u8 = 100u8;
pub const DRM_COMMAND_BASE: u32 = 64;
pub const DRM_COMMAND_END: u32 = 160;
pub const DRM_EVENT_VBLANK: u32 = 1;
pub const DRM_EVENT_FLIP_COMPLETE: u32 = 2;
pub const DRM_EVENT_CRTC_SEQUENCE: u32 = 3;
pub const DRM_FORMAT_BIG_ENDIAN: u32 = 2147483648;
pub const DRM_FORMAT_INVALID: u32 = 0;
pub const DRM_FORMAT_MOD_VENDOR_NONE: u32 = 0;
pub const DRM_FORMAT_MOD_VENDOR_INTEL: u32 = 1;
pub const DRM_FORMAT_MOD_VENDOR_AMD: u32 = 2;
pub const DRM_FORMAT_MOD_VENDOR_NVIDIA: u32 = 3;
pub const DRM_FORMAT_MOD_VENDOR_SAMSUNG: u32 = 4;
pub const DRM_FORMAT_MOD_VENDOR_QCOM: u32 = 5;
pub const DRM_FORMAT_MOD_VENDOR_VIVANTE: u32 = 6;
pub const DRM_FORMAT_MOD_VENDOR_BROADCOM: u32 = 7;
pub const DRM_FORMAT_MOD_VENDOR_ARM: u32 = 8;
pub const DRM_FORMAT_MOD_VENDOR_ALLWINNER: u32 = 9;
pub const DRM_FORMAT_MOD_VENDOR_AMLOGIC: u32 = 10;
pub const DRM_FORMAT_MOD_VENDOR_MTK: u32 = 11;
pub const DRM_FORMAT_RESERVED: u64 = 72057594037927935;
pub const DRM_FORMAT_MOD_NONE: u32 = 0;
pub const VIVANTE_MOD_TS_64_4: u64 = 281474976710656;
pub const VIVANTE_MOD_TS_64_2: u64 = 562949953421312;
pub const VIVANTE_MOD_TS_128_4: u64 = 844424930131968;
pub const VIVANTE_MOD_TS_256_4: u64 = 1125899906842624;
pub const VIVANTE_MOD_TS_MASK: u64 = 4222124650659840;
pub const VIVANTE_MOD_COMP_DEC400: u64 = 4503599627370496;
pub const VIVANTE_MOD_COMP_MASK: u64 = 67553994410557440;
pub const VIVANTE_MOD_EXT_MASK: u64 = 71776119061217280;
pub const __fourcc_mod_broadcom_param_shift: u32 = 8;
pub const __fourcc_mod_broadcom_param_bits: u32 = 48;
pub const DRM_FORMAT_MOD_ARM_TYPE_AFBC: u32 = 0;
pub const DRM_FORMAT_MOD_ARM_TYPE_MISC: u32 = 1;
pub const AFBC_FORMAT_MOD_BLOCK_SIZE_MASK: u32 = 15;
pub const AFBC_FORMAT_MOD_BLOCK_SIZE_16x16: u32 = 1;
pub const AFBC_FORMAT_MOD_BLOCK_SIZE_32x8: u32 = 2;
pub const AFBC_FORMAT_MOD_BLOCK_SIZE_64x4: u32 = 3;
pub const AFBC_FORMAT_MOD_BLOCK_SIZE_32x8_64x4: u32 = 4;
pub const AFBC_FORMAT_MOD_YTR: u32 = 16;
pub const AFBC_FORMAT_MOD_SPLIT: u32 = 32;
pub const AFBC_FORMAT_MOD_SPARSE: u32 = 64;
pub const AFBC_FORMAT_MOD_CBR: u32 = 128;
pub const AFBC_FORMAT_MOD_TILED: u32 = 256;
pub const AFBC_FORMAT_MOD_SC: u32 = 512;
pub const AFBC_FORMAT_MOD_DB: u32 = 1024;
pub const AFBC_FORMAT_MOD_BCH: u32 = 2048;
pub const AFBC_FORMAT_MOD_USM: u32 = 4096;
pub const DRM_FORMAT_MOD_ARM_TYPE_AFRC: u32 = 2;
pub const AFRC_FORMAT_MOD_CU_SIZE_MASK: u32 = 15;
pub const AFRC_FORMAT_MOD_CU_SIZE_16: u32 = 1;
pub const AFRC_FORMAT_MOD_CU_SIZE_24: u32 = 2;
pub const AFRC_FORMAT_MOD_CU_SIZE_32: u32 = 3;
pub const AFRC_FORMAT_MOD_LAYOUT_SCAN: u32 = 256;
pub const __fourcc_mod_amlogic_layout_mask: u32 = 255;
pub const __fourcc_mod_amlogic_options_shift: u32 = 8;
pub const __fourcc_mod_amlogic_options_mask: u32 = 255;
pub const AMLOGIC_FBC_LAYOUT_BASIC: u32 = 1;
pub const AMLOGIC_FBC_LAYOUT_SCATTER: u32 = 2;
pub const AMLOGIC_FBC_OPTION_MEM_SAVING: u32 = 1;
pub const MTK_FMT_MOD_TILE_MASK: u32 = 15;
pub const MTK_FMT_MOD_TILE_NONE: u32 = 0;
pub const MTK_FMT_MOD_TILE_16L32S: u32 = 1;
pub const MTK_FMT_MOD_COMPRESS_MASK: u32 = 3840;
pub const MTK_FMT_MOD_COMPRESS_NONE: u32 = 0;
pub const MTK_FMT_MOD_COMPRESS_V1: u32 = 256;
pub const MTK_FMT_MOD_10BIT_LAYOUT_MASK: u32 = 983040;
pub const MTK_FMT_MOD_10BIT_LAYOUT_PACKED: u32 = 0;
pub const MTK_FMT_MOD_10BIT_LAYOUT_LSBTILED: u32 = 65536;
pub const MTK_FMT_MOD_10BIT_LAYOUT_LSBRASTER: u32 = 131072;
pub const AMD_FMT_MOD_TILE_VER_GFX9: u32 = 1;
pub const AMD_FMT_MOD_TILE_VER_GFX10: u32 = 2;
pub const AMD_FMT_MOD_TILE_VER_GFX10_RBPLUS: u32 = 3;
pub const AMD_FMT_MOD_TILE_VER_GFX11: u32 = 4;
pub const AMD_FMT_MOD_TILE_VER_GFX12: u32 = 5;
pub const AMD_FMT_MOD_TILE_GFX9_64K_S: u32 = 9;
pub const AMD_FMT_MOD_TILE_GFX9_64K_D: u32 = 10;
pub const AMD_FMT_MOD_TILE_GFX9_4K_D_X: u32 = 22;
pub const AMD_FMT_MOD_TILE_GFX9_64K_S_X: u32 = 25;
pub const AMD_FMT_MOD_TILE_GFX9_64K_D_X: u32 = 26;
pub const AMD_FMT_MOD_TILE_GFX9_64K_R_X: u32 = 27;
pub const AMD_FMT_MOD_TILE_GFX11_256K_R_X: u32 = 31;
pub const AMD_FMT_MOD_TILE_GFX12_256B_2D: u32 = 1;
pub const AMD_FMT_MOD_TILE_GFX12_4K_2D: u32 = 2;
pub const AMD_FMT_MOD_TILE_GFX12_64K_2D: u32 = 3;
pub const AMD_FMT_MOD_TILE_GFX12_256K_2D: u32 = 4;
pub const AMD_FMT_MOD_DCC_BLOCK_64B: u32 = 0;
pub const AMD_FMT_MOD_DCC_BLOCK_128B: u32 = 1;
pub const AMD_FMT_MOD_DCC_BLOCK_256B: u32 = 2;
pub const AMD_FMT_MOD_TILE_VERSION_SHIFT: u32 = 0;
pub const AMD_FMT_MOD_TILE_VERSION_MASK: u32 = 255;
pub const AMD_FMT_MOD_TILE_SHIFT: u32 = 8;
pub const AMD_FMT_MOD_TILE_MASK: u32 = 31;
pub const AMD_FMT_MOD_DCC_SHIFT: u32 = 13;
pub const AMD_FMT_MOD_DCC_MASK: u32 = 1;
pub const AMD_FMT_MOD_DCC_RETILE_SHIFT: u32 = 14;
pub const AMD_FMT_MOD_DCC_RETILE_MASK: u32 = 1;
pub const AMD_FMT_MOD_DCC_PIPE_ALIGN_SHIFT: u32 = 15;
pub const AMD_FMT_MOD_DCC_PIPE_ALIGN_MASK: u32 = 1;
pub const AMD_FMT_MOD_DCC_INDEPENDENT_64B_SHIFT: u32 = 16;
pub const AMD_FMT_MOD_DCC_INDEPENDENT_64B_MASK: u32 = 1;
pub const AMD_FMT_MOD_DCC_INDEPENDENT_128B_SHIFT: u32 = 17;
pub const AMD_FMT_MOD_DCC_INDEPENDENT_128B_MASK: u32 = 1;
pub const AMD_FMT_MOD_DCC_MAX_COMPRESSED_BLOCK_SHIFT: u32 = 18;
pub const AMD_FMT_MOD_DCC_MAX_COMPRESSED_BLOCK_MASK: u32 = 3;
pub const AMD_FMT_MOD_DCC_CONSTANT_ENCODE_SHIFT: u32 = 20;
pub const AMD_FMT_MOD_DCC_CONSTANT_ENCODE_MASK: u32 = 1;
pub const AMD_FMT_MOD_PIPE_XOR_BITS_SHIFT: u32 = 21;
pub const AMD_FMT_MOD_PIPE_XOR_BITS_MASK: u32 = 7;
pub const AMD_FMT_MOD_BANK_XOR_BITS_SHIFT: u32 = 24;
pub const AMD_FMT_MOD_BANK_XOR_BITS_MASK: u32 = 7;
pub const AMD_FMT_MOD_PACKERS_SHIFT: u32 = 27;
pub const AMD_FMT_MOD_PACKERS_MASK: u32 = 7;
pub const AMD_FMT_MOD_RB_SHIFT: u32 = 30;
pub const AMD_FMT_MOD_RB_MASK: u32 = 7;
pub const AMD_FMT_MOD_PIPE_SHIFT: u32 = 33;
pub const AMD_FMT_MOD_PIPE_MASK: u32 = 7;
pub const DRM_FORMAT_MAX_PLANES: u32 = 4;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ftrace_branch_data {
    pub func: *const ffi::c_char,
    pub file: *const ffi::c_char,
    pub line: ffi::c_uint,
    pub __bindgen_anon_1: ftrace_branch_data__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union ftrace_branch_data__bindgen_ty_1 {
    pub __bindgen_anon_1: ftrace_branch_data__bindgen_ty_1__bindgen_ty_1,
    pub __bindgen_anon_2: ftrace_branch_data__bindgen_ty_1__bindgen_ty_2,
    pub miss_hit: [ffi::c_ulong; 2usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ftrace_branch_data__bindgen_ty_1__bindgen_ty_1 {
    pub correct: ffi::c_ulong,
    pub incorrect: ffi::c_ulong,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ftrace_branch_data__bindgen_ty_1__bindgen_ty_2 {
    pub miss: ffi::c_ulong,
    pub hit: ffi::c_ulong,
}
impl Default for ftrace_branch_data__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for ftrace_branch_data {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ftrace_likely_data {
    pub data: ftrace_branch_data,
    pub constant: ffi::c_ulong,
}
impl Default for ftrace_likely_data {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn ftrace_likely_update(
        f: *mut ftrace_likely_data,
        val: ffi::c_int,
        expect: ffi::c_int,
        is_constant: ffi::c_int,
    );
}
pub type __s8 = ffi::c_schar;
pub type __u8 = ffi::c_uchar;
pub type __s16 = ffi::c_short;
pub type __u16 = ffi::c_ushort;
pub type __s32 = ffi::c_int;
pub type __u32 = ffi::c_uint;
pub type __s64 = ffi::c_longlong;
pub type __u64 = ffi::c_ulonglong;
pub type s8 = __s8;
pub type u8_ = __u8;
pub type s16 = __s16;
pub type u16_ = __u16;
pub type s32 = __s32;
pub type u32_ = __u32;
pub type s64 = __s64;
pub type u64_ = __u64;
pub const false_: _bindgen_ty_1 = 0;
pub const true_: _bindgen_ty_1 = 1;
pub type _bindgen_ty_1 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct __kernel_fd_set {
    pub fds_bits: [ffi::c_ulong; 16usize],
}
pub type __kernel_sighandler_t = ::core::option::Option<unsafe extern "C" fn(arg1: ffi::c_int)>;
pub type __kernel_key_t = ffi::c_int;
pub type __kernel_mqd_t = ffi::c_int;
pub type __kernel_old_uid_t = ffi::c_ushort;
pub type __kernel_old_gid_t = ffi::c_ushort;
pub type __kernel_long_t = ffi::c_long;
pub type __kernel_ulong_t = ffi::c_ulong;
pub type __kernel_ino_t = __kernel_ulong_t;
pub type __kernel_mode_t = ffi::c_uint;
pub type __kernel_pid_t = ffi::c_int;
pub type __kernel_ipc_pid_t = ffi::c_int;
pub type __kernel_uid_t = ffi::c_uint;
pub type __kernel_gid_t = ffi::c_uint;
pub type __kernel_suseconds_t = __kernel_long_t;
pub type __kernel_daddr_t = ffi::c_int;
pub type __kernel_uid32_t = ffi::c_uint;
pub type __kernel_gid32_t = ffi::c_uint;
pub type __kernel_old_dev_t = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct __kernel_fsid_t {
    pub val: [ffi::c_int; 2usize],
}
pub type __kernel_off_t = __kernel_long_t;
pub type __kernel_loff_t = ffi::c_longlong;
pub type __kernel_old_time_t = __kernel_long_t;
pub type __kernel_time64_t = ffi::c_longlong;
pub type __kernel_clock_t = __kernel_long_t;
pub type __kernel_timer_t = ffi::c_int;
pub type __kernel_clockid_t = ffi::c_int;
pub type __kernel_caddr_t = *mut ffi::c_char;
pub type __kernel_uid16_t = ffi::c_ushort;
pub type __kernel_gid16_t = ffi::c_ushort;
pub type __s128 = i128;
pub type __u128 = u128;
pub type __le16 = __u16;
pub type __be16 = __u16;
pub type __le32 = __u32;
pub type __be32 = __u32;
pub type __le64 = __u64;
pub type __be64 = __u64;
pub type __sum16 = __u16;
pub type __wsum = __u32;
pub type __poll_t = ffi::c_uint;
pub type s128 = __s128;
pub type u128_ = __u128;
pub type __kernel_dev_t = u32_;
pub type fd_set = __kernel_fd_set;
pub type dev_t = __kernel_dev_t;
pub type ino_t = __kernel_ulong_t;
pub type mode_t = __kernel_mode_t;
pub type umode_t = ffi::c_ushort;
pub type nlink_t = u32_;
pub type off_t = __kernel_off_t;
pub type pid_t = __kernel_pid_t;
pub type daddr_t = __kernel_daddr_t;
pub type key_t = __kernel_key_t;
pub type suseconds_t = __kernel_suseconds_t;
pub type timer_t = __kernel_timer_t;
pub type clockid_t = __kernel_clockid_t;
pub type mqd_t = __kernel_mqd_t;
pub type bool_ = bool;
pub type uid_t = __kernel_uid32_t;
pub type gid_t = __kernel_gid32_t;
pub type uid16_t = __kernel_uid16_t;
pub type gid16_t = __kernel_gid16_t;
pub type old_uid_t = __kernel_old_uid_t;
pub type old_gid_t = __kernel_old_gid_t;
pub type loff_t = __kernel_loff_t;
pub type clock_t = __kernel_clock_t;
pub type caddr_t = __kernel_caddr_t;
pub type u_char = ffi::c_uchar;
pub type u_short = ffi::c_ushort;
pub type u_int = ffi::c_uint;
pub type u_long = ffi::c_ulong;
pub type unchar = ffi::c_uchar;
pub type ushort = ffi::c_ushort;
pub type uint = ffi::c_uint;
pub type ulong = ffi::c_ulong;
pub type ullong = ffi::c_ulonglong;
pub type u_int8_t = u8_;
pub type u_int16_t = u16_;
pub type u_int32_t = u32_;
pub type u_int64_t = u64_;
pub type ktime_t = s64;
pub type sector_t = u64_;
pub type blkcnt_t = u64_;
pub type dma_addr_t = u64_;
pub type gfp_t = ffi::c_uint;
pub type slab_flags_t = ffi::c_uint;
pub type fmode_t = ffi::c_uint;
pub type phys_addr_t = u64_;
pub type resource_size_t = phys_addr_t;
pub type irq_hw_number_t = ffi::c_ulong;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct atomic_t {
    pub counter: ffi::c_int,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct atomic64_t {
    pub counter: s64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct rcuref_t {
    pub refcnt: atomic_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct list_head {
    pub next: *mut list_head,
    pub prev: *mut list_head,
}
impl Default for list_head {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct hlist_head {
    pub first: *mut hlist_node,
}
impl Default for hlist_head {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct hlist_node {
    pub next: *mut hlist_node,
    pub pprev: *mut *mut hlist_node,
}
impl Default for hlist_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ustat {
    pub f_tfree: __kernel_daddr_t,
    pub f_tinode: ffi::c_ulong,
    pub f_fname: [ffi::c_char; 6usize],
    pub f_fpack: [ffi::c_char; 6usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct callback_head {
    pub next: *mut callback_head,
    pub func: ::core::option::Option<unsafe extern "C" fn(head: *mut callback_head)>,
}
impl Default for callback_head {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type rcu_callback_t = ::core::option::Option<unsafe extern "C" fn(head: *mut callback_head)>;
pub type call_rcu_func_t =
    ::core::option::Option<unsafe extern "C" fn(head: *mut callback_head, func: rcu_callback_t)>;
pub type swap_r_func_t = ::core::option::Option<
    unsafe extern "C" fn(
        a: *mut ffi::c_void,
        b: *mut ffi::c_void,
        size: ffi::c_int,
        priv_: *const ffi::c_void,
    ),
>;
pub type swap_func_t = ::core::option::Option<
    unsafe extern "C" fn(a: *mut ffi::c_void, b: *mut ffi::c_void, size: ffi::c_int),
>;
pub type cmp_r_func_t = ::core::option::Option<
    unsafe extern "C" fn(
        a: *const ffi::c_void,
        b: *const ffi::c_void,
        priv_: *const ffi::c_void,
    ) -> ffi::c_int,
>;
pub type cmp_func_t = ::core::option::Option<
    unsafe extern "C" fn(a: *const ffi::c_void, b: *const ffi::c_void) -> ffi::c_int,
>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rcuwait {
    pub task: *mut task_struct,
}
impl Default for rcuwait {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct kcsan_scoped_access {}
pub type va_list = __BindgenOpaqueArray<u64, 4usize>;
pub type initcall_t = ::core::option::Option<unsafe extern "C" fn() -> ffi::c_int>;
pub type exitcall_t = ::core::option::Option<unsafe extern "C" fn()>;
pub type initcall_entry_t = ffi::c_int;
extern "C" {
    pub static mut __con_initcall_start: [initcall_entry_t; 0usize];
}
extern "C" {
    pub static mut __con_initcall_end: [initcall_entry_t; 0usize];
}
pub type ctor_fn_t = ::core::option::Option<unsafe extern "C" fn()>;
extern "C" {
    pub fn do_one_initcall(fn_: initcall_t) -> ffi::c_int;
}
extern "C" {
    pub static mut boot_command_line: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut saved_command_line: *mut ffi::c_char;
}
extern "C" {
    pub static mut saved_command_line_len: ffi::c_uint;
}
extern "C" {
    pub static mut reset_devices: ffi::c_uint;
}
extern "C" {
    pub fn setup_arch(arg1: *mut *mut ffi::c_char);
}
extern "C" {
    pub fn prepare_namespace();
}
extern "C" {
    pub fn init_rootfs();
}
extern "C" {
    pub fn init_IRQ();
}
extern "C" {
    pub fn time_init();
}
extern "C" {
    pub fn poking_init();
}
extern "C" {
    pub fn pgtable_cache_init();
}
extern "C" {
    pub static mut __initcall_start: [initcall_entry_t; 0usize];
}
extern "C" {
    pub static mut __initcall0_start: [initcall_entry_t; 0usize];
}
extern "C" {
    pub static mut __initcall1_start: [initcall_entry_t; 0usize];
}
extern "C" {
    pub static mut __initcall2_start: [initcall_entry_t; 0usize];
}
extern "C" {
    pub static mut __initcall3_start: [initcall_entry_t; 0usize];
}
extern "C" {
    pub static mut __initcall4_start: [initcall_entry_t; 0usize];
}
extern "C" {
    pub static mut __initcall5_start: [initcall_entry_t; 0usize];
}
extern "C" {
    pub static mut __initcall6_start: [initcall_entry_t; 0usize];
}
extern "C" {
    pub static mut __initcall7_start: [initcall_entry_t; 0usize];
}
extern "C" {
    pub static mut __initcall_end: [initcall_entry_t; 0usize];
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct file_system_type {
    pub name: *const ffi::c_char,
    pub fs_flags: ffi::c_int,
    pub init_fs_context:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut fs_context) -> ffi::c_int>,
    pub parameters: *const fs_parameter_spec,
    pub mount: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut file_system_type,
            arg2: ffi::c_int,
            arg3: *const ffi::c_char,
            arg4: *mut ffi::c_void,
        ) -> *mut dentry,
    >,
    pub kill_sb: ::core::option::Option<unsafe extern "C" fn(arg1: *mut super_block)>,
    pub owner: *mut module,
    pub next: *mut file_system_type,
    pub fs_supers: hlist_head,
    pub s_lock_key: lock_class_key,
    pub s_umount_key: lock_class_key,
    pub s_vfs_rename_key: lock_class_key,
    pub s_writers_key: [lock_class_key; 3usize],
    pub i_lock_key: lock_class_key,
    pub i_mutex_key: lock_class_key,
    pub invalidate_lock_key: lock_class_key,
    pub i_mutex_dir_key: lock_class_key,
}
impl Default for file_system_type {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut rootfs_fs_type: file_system_type;
}
extern "C" {
    pub static mut rodata_enabled: bool_;
}
extern "C" {
    pub fn mark_rodata_ro();
}
extern "C" {
    pub static mut late_time_init: ::core::option::Option<unsafe extern "C" fn()>;
}
extern "C" {
    pub static mut initcall_debug: bool_;
}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct module {
    pub state: module_state,
    pub list: list_head,
    pub name: [ffi::c_char; 56usize],
    pub mkobj: module_kobject,
    pub modinfo_attrs: *mut module_attribute,
    pub version: *const ffi::c_char,
    pub srcversion: *const ffi::c_char,
    pub holders_dir: *mut kobject,
    pub syms: *mut kernel_symbol,
    pub crcs: *const u32_,
    pub num_syms: ffi::c_uint,
    pub param_lock: mutex,
    pub kp: *mut kernel_param,
    pub num_kp: ffi::c_uint,
    pub num_gpl_syms: ffi::c_uint,
    pub gpl_syms: *const kernel_symbol,
    pub gpl_crcs: *const u32_,
    pub using_gplonly_symbols: bool_,
    pub sig_ok: bool_,
    pub async_probe_requested: bool_,
    pub num_exentries: ffi::c_uint,
    pub extable: *mut exception_table_entry,
    pub init: ::core::option::Option<unsafe extern "C" fn() -> ffi::c_int>,
    pub mem: [module_memory; 7usize],
    pub arch: mod_arch_specific,
    pub taints: ffi::c_ulong,
    pub num_bugs: ffi::c_uint,
    pub bug_list: list_head,
    pub bug_table: *mut bug_entry,
    pub kallsyms: *mut mod_kallsyms,
    pub core_kallsyms: mod_kallsyms,
    pub sect_attrs: *mut module_sect_attrs,
    pub notes_attrs: *mut module_notes_attrs,
    pub args: *mut ffi::c_char,
    pub percpu: *mut ffi::c_void,
    pub percpu_size: ffi::c_uint,
    pub noinstr_text_start: *mut ffi::c_void,
    pub noinstr_text_size: ffi::c_uint,
    pub num_tracepoints: ffi::c_uint,
    pub tracepoints_ptrs: *const ffi::c_int,
    pub num_srcu_structs: ffi::c_uint,
    pub srcu_struct_ptrs: *mut *mut srcu_struct,
    pub num_bpf_raw_events: ffi::c_uint,
    pub bpf_raw_events: *mut bpf_raw_event_map,
    pub btf_data_size: ffi::c_uint,
    pub btf_base_data_size: ffi::c_uint,
    pub btf_data: *mut ffi::c_void,
    pub btf_base_data: *mut ffi::c_void,
    pub jump_entries: *mut jump_entry,
    pub num_jump_entries: ffi::c_uint,
    pub num_trace_bprintk_fmt: ffi::c_uint,
    pub trace_bprintk_fmt_start: *mut *const ffi::c_char,
    pub trace_events: *mut *mut trace_event_call,
    pub num_trace_events: ffi::c_uint,
    pub trace_evals: *mut *mut trace_eval_map,
    pub num_trace_evals: ffi::c_uint,
    pub num_ftrace_callsites: ffi::c_uint,
    pub ftrace_callsites: *mut ffi::c_ulong,
    pub kprobes_text_start: *mut ffi::c_void,
    pub kprobes_text_size: ffi::c_uint,
    pub kprobe_blacklist: *mut ffi::c_ulong,
    pub num_kprobe_blacklist: ffi::c_uint,
    pub num_kunit_init_suites: ffi::c_int,
    pub kunit_init_suites: *mut *mut kunit_suite,
    pub num_kunit_suites: ffi::c_int,
    pub kunit_suites: *mut *mut kunit_suite,
    pub printk_index_size: ffi::c_uint,
    pub printk_index_start: *mut *mut pi_entry,
    pub source_list: list_head,
    pub target_list: list_head,
    pub exit: ::core::option::Option<unsafe extern "C" fn()>,
    pub refcnt: atomic_t,
    pub dyndbg_info: _ddebug_info,
}
impl Default for module {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut __this_module: module;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct qspinlock {
    pub __bindgen_anon_1: qspinlock__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union qspinlock__bindgen_ty_1 {
    pub val: atomic_t,
    pub __bindgen_anon_1: qspinlock__bindgen_ty_1__bindgen_ty_1,
    pub __bindgen_anon_2: qspinlock__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct qspinlock__bindgen_ty_1__bindgen_ty_1 {
    pub locked: u8_,
    pub pending: u8_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct qspinlock__bindgen_ty_1__bindgen_ty_2 {
    pub locked_pending: u16_,
    pub tail: u16_,
}
impl Default for qspinlock__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for qspinlock {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type arch_spinlock_t = qspinlock;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct qrwlock {
    pub __bindgen_anon_1: qrwlock__bindgen_ty_1,
    pub wait_lock: arch_spinlock_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union qrwlock__bindgen_ty_1 {
    pub cnts: atomic_t,
    pub __bindgen_anon_1: qrwlock__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct qrwlock__bindgen_ty_1__bindgen_ty_1 {
    pub wlocked: u8_,
    pub __lstate: [u8_; 3usize],
}
impl Default for qrwlock__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for qrwlock {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type arch_rwlock_t = qrwlock;
pub const lockdep_wait_type_LD_WAIT_INV: lockdep_wait_type = 0;
pub const lockdep_wait_type_LD_WAIT_FREE: lockdep_wait_type = 1;
pub const lockdep_wait_type_LD_WAIT_SPIN: lockdep_wait_type = 2;
pub const lockdep_wait_type_LD_WAIT_CONFIG: lockdep_wait_type = 2;
pub const lockdep_wait_type_LD_WAIT_SLEEP: lockdep_wait_type = 3;
pub const lockdep_wait_type_LD_WAIT_MAX: lockdep_wait_type = 4;
pub type lockdep_wait_type = ffi::c_uint;
pub const lockdep_lock_type_LD_LOCK_NORMAL: lockdep_lock_type = 0;
pub const lockdep_lock_type_LD_LOCK_PERCPU: lockdep_lock_type = 1;
pub const lockdep_lock_type_LD_LOCK_WAIT_OVERRIDE: lockdep_lock_type = 2;
pub const lockdep_lock_type_LD_LOCK_MAX: lockdep_lock_type = 3;
pub type lockdep_lock_type = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct lock_class_key {}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct lockdep_map {}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pin_cookie {}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct raw_spinlock {
    pub raw_lock: arch_spinlock_t,
}
impl Default for raw_spinlock {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type raw_spinlock_t = raw_spinlock;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ratelimit_state {
    pub lock: raw_spinlock_t,
    pub interval: ffi::c_int,
    pub burst: ffi::c_int,
    pub printed: ffi::c_int,
    pub missed: ffi::c_int,
    pub flags: ffi::c_uint,
    pub begin: ffi::c_ulong,
}
impl Default for ratelimit_state {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn ___ratelimit(rs: *mut ratelimit_state, func: *const ffi::c_char) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct console {
    _unused: [u8; 0],
}
extern "C" {
    pub static linux_banner: [ffi::c_char; 0usize];
}
extern "C" {
    pub static linux_proc_banner: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut oops_in_progress: ffi::c_int;
}
extern "C" {
    pub fn match_devname_and_update_preferred_console(
        match_: *const ffi::c_char,
        name: *const ffi::c_char,
        idx: ffi::c_short,
    ) -> ffi::c_int;
}
extern "C" {
    pub static mut console_printk: [ffi::c_int; 0usize];
}
extern "C" {
    pub fn console_verbose();
}
extern "C" {
    pub static mut devkmsg_log_str: [ffi::c_char; 10usize];
}
extern "C" {
    pub static mut suppress_printk: ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct va_format {
    pub fmt: *const ffi::c_char,
    pub va: *mut va_list,
}
impl Default for va_format {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn vprintk_emit(
        facility: ffi::c_int,
        level: ffi::c_int,
        dev_info: *const dev_printk_info,
        fmt: *const ffi::c_char,
        args: va_list,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vprintk(fmt: *const ffi::c_char, args: va_list) -> ffi::c_int;
}
extern "C" {
    pub fn _printk(fmt: *const ffi::c_char, ...) -> ffi::c_int;
}
extern "C" {
    pub fn _printk_deferred(fmt: *const ffi::c_char, ...) -> ffi::c_int;
}
extern "C" {
    pub fn __printk_deferred_enter();
}
extern "C" {
    pub fn __printk_deferred_exit();
}
extern "C" {
    pub fn printk_force_console_enter();
}
extern "C" {
    pub fn printk_force_console_exit();
}
extern "C" {
    pub fn __printk_ratelimit(func: *const ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub fn printk_timed_ratelimit(
        caller_jiffies: *mut ffi::c_ulong,
        interval_msec: ffi::c_uint,
    ) -> bool_;
}
extern "C" {
    pub static mut printk_delay_msec: ffi::c_int;
}
extern "C" {
    pub static mut dmesg_restrict: ffi::c_int;
}
extern "C" {
    pub fn wake_up_klogd();
}
extern "C" {
    pub fn log_buf_addr_get() -> *mut ffi::c_char;
}
extern "C" {
    pub fn log_buf_len_get() -> u32_;
}
extern "C" {
    pub fn log_buf_vmcoreinfo_setup();
}
extern "C" {
    pub fn setup_log_buf(early: ffi::c_int);
}
extern "C" {
    pub fn dump_stack_set_arch_desc(fmt: *const ffi::c_char, ...);
}
extern "C" {
    pub fn dump_stack_print_info(log_lvl: *const ffi::c_char);
}
extern "C" {
    pub fn show_regs_print_info(log_lvl: *const ffi::c_char);
}
extern "C" {
    pub fn dump_stack_lvl(log_lvl: *const ffi::c_char);
}
extern "C" {
    pub fn dump_stack();
}
extern "C" {
    pub fn printk_trigger_flush();
}
extern "C" {
    pub fn console_try_replay_all();
}
extern "C" {
    pub fn printk_legacy_allow_panic_sync();
}
extern "C" {
    pub fn nbcon_device_try_acquire(con: *mut console) -> bool_;
}
extern "C" {
    pub fn nbcon_device_release(con: *mut console);
}
extern "C" {
    pub fn nbcon_atomic_flush_unsafe();
}
extern "C" {
    pub fn pr_flush(timeout_ms: ffi::c_int, reset_on_progress: bool_) -> bool_;
}
extern "C" {
    pub fn this_cpu_in_panic() -> bool_;
}
extern "C" {
    pub fn __printk_cpu_sync_try_get() -> ffi::c_int;
}
extern "C" {
    pub fn __printk_cpu_sync_wait();
}
extern "C" {
    pub fn __printk_cpu_sync_put();
}
extern "C" {
    pub static mut kptr_restrict: ffi::c_int;
}
#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct pi_entry {
    pub fmt: *const ffi::c_char,
    pub func: *const ffi::c_char,
    pub file: *const ffi::c_char,
    pub line: ffi::c_uint,
    pub level: *const ffi::c_char,
    pub subsys_fmt_prefix: *const ffi::c_char,
}
impl Default for pi_entry {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut static_key_initialized: bool_;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct static_key {
    pub enabled: atomic_t,
    pub __bindgen_anon_1: static_key__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union static_key__bindgen_ty_1 {
    pub type_: ffi::c_ulong,
    pub entries: *mut jump_entry,
    pub next: *mut static_key_mod,
}
impl Default for static_key__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for static_key {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_NOP: aarch64_insn_hint_cr_op = 0;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_YIELD: aarch64_insn_hint_cr_op = 32;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_WFE: aarch64_insn_hint_cr_op = 64;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_WFI: aarch64_insn_hint_cr_op = 96;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_SEV: aarch64_insn_hint_cr_op = 128;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_SEVL: aarch64_insn_hint_cr_op = 160;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_XPACLRI: aarch64_insn_hint_cr_op = 224;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_PACIA_1716: aarch64_insn_hint_cr_op = 256;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_PACIB_1716: aarch64_insn_hint_cr_op = 320;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_AUTIA_1716: aarch64_insn_hint_cr_op = 384;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_AUTIB_1716: aarch64_insn_hint_cr_op = 448;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_PACIAZ: aarch64_insn_hint_cr_op = 768;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_PACIASP: aarch64_insn_hint_cr_op = 800;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_PACIBZ: aarch64_insn_hint_cr_op = 832;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_PACIBSP: aarch64_insn_hint_cr_op = 864;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_AUTIAZ: aarch64_insn_hint_cr_op = 896;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_AUTIASP: aarch64_insn_hint_cr_op = 928;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_AUTIBZ: aarch64_insn_hint_cr_op = 960;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_AUTIBSP: aarch64_insn_hint_cr_op = 992;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_ESB: aarch64_insn_hint_cr_op = 512;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_PSB: aarch64_insn_hint_cr_op = 544;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_TSB: aarch64_insn_hint_cr_op = 576;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_CSDB: aarch64_insn_hint_cr_op = 640;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_CLEARBHB: aarch64_insn_hint_cr_op = 704;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_BTI: aarch64_insn_hint_cr_op = 1024;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_BTIC: aarch64_insn_hint_cr_op = 1088;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_BTIJ: aarch64_insn_hint_cr_op = 1152;
pub const aarch64_insn_hint_cr_op_AARCH64_INSN_HINT_BTIJC: aarch64_insn_hint_cr_op = 1216;
pub type aarch64_insn_hint_cr_op = ffi::c_uint;
pub const aarch64_insn_imm_type_AARCH64_INSN_IMM_ADR: aarch64_insn_imm_type = 0;
pub const aarch64_insn_imm_type_AARCH64_INSN_IMM_26: aarch64_insn_imm_type = 1;
pub const aarch64_insn_imm_type_AARCH64_INSN_IMM_19: aarch64_insn_imm_type = 2;
pub const aarch64_insn_imm_type_AARCH64_INSN_IMM_16: aarch64_insn_imm_type = 3;
pub const aarch64_insn_imm_type_AARCH64_INSN_IMM_14: aarch64_insn_imm_type = 4;
pub const aarch64_insn_imm_type_AARCH64_INSN_IMM_12: aarch64_insn_imm_type = 5;
pub const aarch64_insn_imm_type_AARCH64_INSN_IMM_9: aarch64_insn_imm_type = 6;
pub const aarch64_insn_imm_type_AARCH64_INSN_IMM_7: aarch64_insn_imm_type = 7;
pub const aarch64_insn_imm_type_AARCH64_INSN_IMM_6: aarch64_insn_imm_type = 8;
pub const aarch64_insn_imm_type_AARCH64_INSN_IMM_S: aarch64_insn_imm_type = 9;
pub const aarch64_insn_imm_type_AARCH64_INSN_IMM_R: aarch64_insn_imm_type = 10;
pub const aarch64_insn_imm_type_AARCH64_INSN_IMM_N: aarch64_insn_imm_type = 11;
pub const aarch64_insn_imm_type_AARCH64_INSN_IMM_MAX: aarch64_insn_imm_type = 12;
pub type aarch64_insn_imm_type = ffi::c_uint;
pub const aarch64_insn_register_type_AARCH64_INSN_REGTYPE_RT: aarch64_insn_register_type = 0;
pub const aarch64_insn_register_type_AARCH64_INSN_REGTYPE_RN: aarch64_insn_register_type = 1;
pub const aarch64_insn_register_type_AARCH64_INSN_REGTYPE_RT2: aarch64_insn_register_type = 2;
pub const aarch64_insn_register_type_AARCH64_INSN_REGTYPE_RM: aarch64_insn_register_type = 3;
pub const aarch64_insn_register_type_AARCH64_INSN_REGTYPE_RD: aarch64_insn_register_type = 4;
pub const aarch64_insn_register_type_AARCH64_INSN_REGTYPE_RA: aarch64_insn_register_type = 5;
pub const aarch64_insn_register_type_AARCH64_INSN_REGTYPE_RS: aarch64_insn_register_type = 6;
pub type aarch64_insn_register_type = ffi::c_uint;
pub const aarch64_insn_register_AARCH64_INSN_REG_0: aarch64_insn_register = 0;
pub const aarch64_insn_register_AARCH64_INSN_REG_1: aarch64_insn_register = 1;
pub const aarch64_insn_register_AARCH64_INSN_REG_2: aarch64_insn_register = 2;
pub const aarch64_insn_register_AARCH64_INSN_REG_3: aarch64_insn_register = 3;
pub const aarch64_insn_register_AARCH64_INSN_REG_4: aarch64_insn_register = 4;
pub const aarch64_insn_register_AARCH64_INSN_REG_5: aarch64_insn_register = 5;
pub const aarch64_insn_register_AARCH64_INSN_REG_6: aarch64_insn_register = 6;
pub const aarch64_insn_register_AARCH64_INSN_REG_7: aarch64_insn_register = 7;
pub const aarch64_insn_register_AARCH64_INSN_REG_8: aarch64_insn_register = 8;
pub const aarch64_insn_register_AARCH64_INSN_REG_9: aarch64_insn_register = 9;
pub const aarch64_insn_register_AARCH64_INSN_REG_10: aarch64_insn_register = 10;
pub const aarch64_insn_register_AARCH64_INSN_REG_11: aarch64_insn_register = 11;
pub const aarch64_insn_register_AARCH64_INSN_REG_12: aarch64_insn_register = 12;
pub const aarch64_insn_register_AARCH64_INSN_REG_13: aarch64_insn_register = 13;
pub const aarch64_insn_register_AARCH64_INSN_REG_14: aarch64_insn_register = 14;
pub const aarch64_insn_register_AARCH64_INSN_REG_15: aarch64_insn_register = 15;
pub const aarch64_insn_register_AARCH64_INSN_REG_16: aarch64_insn_register = 16;
pub const aarch64_insn_register_AARCH64_INSN_REG_17: aarch64_insn_register = 17;
pub const aarch64_insn_register_AARCH64_INSN_REG_18: aarch64_insn_register = 18;
pub const aarch64_insn_register_AARCH64_INSN_REG_19: aarch64_insn_register = 19;
pub const aarch64_insn_register_AARCH64_INSN_REG_20: aarch64_insn_register = 20;
pub const aarch64_insn_register_AARCH64_INSN_REG_21: aarch64_insn_register = 21;
pub const aarch64_insn_register_AARCH64_INSN_REG_22: aarch64_insn_register = 22;
pub const aarch64_insn_register_AARCH64_INSN_REG_23: aarch64_insn_register = 23;
pub const aarch64_insn_register_AARCH64_INSN_REG_24: aarch64_insn_register = 24;
pub const aarch64_insn_register_AARCH64_INSN_REG_25: aarch64_insn_register = 25;
pub const aarch64_insn_register_AARCH64_INSN_REG_26: aarch64_insn_register = 26;
pub const aarch64_insn_register_AARCH64_INSN_REG_27: aarch64_insn_register = 27;
pub const aarch64_insn_register_AARCH64_INSN_REG_28: aarch64_insn_register = 28;
pub const aarch64_insn_register_AARCH64_INSN_REG_29: aarch64_insn_register = 29;
pub const aarch64_insn_register_AARCH64_INSN_REG_FP: aarch64_insn_register = 29;
pub const aarch64_insn_register_AARCH64_INSN_REG_30: aarch64_insn_register = 30;
pub const aarch64_insn_register_AARCH64_INSN_REG_LR: aarch64_insn_register = 30;
pub const aarch64_insn_register_AARCH64_INSN_REG_ZR: aarch64_insn_register = 31;
pub const aarch64_insn_register_AARCH64_INSN_REG_SP: aarch64_insn_register = 31;
pub type aarch64_insn_register = ffi::c_uint;
pub const aarch64_insn_special_register_AARCH64_INSN_SPCLREG_SPSR_EL1:
    aarch64_insn_special_register = 49664;
pub const aarch64_insn_special_register_AARCH64_INSN_SPCLREG_ELR_EL1:
    aarch64_insn_special_register = 49665;
pub const aarch64_insn_special_register_AARCH64_INSN_SPCLREG_SP_EL0: aarch64_insn_special_register =
    49672;
pub const aarch64_insn_special_register_AARCH64_INSN_SPCLREG_SPSEL: aarch64_insn_special_register =
    49680;
pub const aarch64_insn_special_register_AARCH64_INSN_SPCLREG_CURRENTEL:
    aarch64_insn_special_register = 49682;
pub const aarch64_insn_special_register_AARCH64_INSN_SPCLREG_DAIF: aarch64_insn_special_register =
    55825;
pub const aarch64_insn_special_register_AARCH64_INSN_SPCLREG_NZCV: aarch64_insn_special_register =
    55824;
pub const aarch64_insn_special_register_AARCH64_INSN_SPCLREG_FPCR: aarch64_insn_special_register =
    55840;
pub const aarch64_insn_special_register_AARCH64_INSN_SPCLREG_DSPSR_EL0:
    aarch64_insn_special_register = 55848;
pub const aarch64_insn_special_register_AARCH64_INSN_SPCLREG_DLR_EL0:
    aarch64_insn_special_register = 55849;
pub const aarch64_insn_special_register_AARCH64_INSN_SPCLREG_SPSR_EL2:
    aarch64_insn_special_register = 57856;
pub const aarch64_insn_special_register_AARCH64_INSN_SPCLREG_ELR_EL2:
    aarch64_insn_special_register = 57857;
pub const aarch64_insn_special_register_AARCH64_INSN_SPCLREG_SP_EL1: aarch64_insn_special_register =
    57864;
pub const aarch64_insn_special_register_AARCH64_INSN_SPCLREG_SPSR_INQ:
    aarch64_insn_special_register = 57880;
pub const aarch64_insn_special_register_AARCH64_INSN_SPCLREG_SPSR_ABT:
    aarch64_insn_special_register = 57881;
pub const aarch64_insn_special_register_AARCH64_INSN_SPCLREG_SPSR_UND:
    aarch64_insn_special_register = 57882;
pub const aarch64_insn_special_register_AARCH64_INSN_SPCLREG_SPSR_FIQ:
    aarch64_insn_special_register = 57883;
pub const aarch64_insn_special_register_AARCH64_INSN_SPCLREG_SPSR_EL3:
    aarch64_insn_special_register = 61952;
pub const aarch64_insn_special_register_AARCH64_INSN_SPCLREG_ELR_EL3:
    aarch64_insn_special_register = 61953;
pub const aarch64_insn_special_register_AARCH64_INSN_SPCLREG_SP_EL2: aarch64_insn_special_register =
    61968;
pub type aarch64_insn_special_register = ffi::c_uint;
pub const aarch64_insn_system_register_AARCH64_INSN_SYSREG_TPIDR_EL1: aarch64_insn_system_register =
    18052;
pub const aarch64_insn_system_register_AARCH64_INSN_SYSREG_TPIDR_EL2: aarch64_insn_system_register =
    26242;
pub const aarch64_insn_system_register_AARCH64_INSN_SYSREG_SP_EL0: aarch64_insn_system_register =
    16904;
pub type aarch64_insn_system_register = ffi::c_uint;
pub const aarch64_insn_variant_AARCH64_INSN_VARIANT_32BIT: aarch64_insn_variant = 0;
pub const aarch64_insn_variant_AARCH64_INSN_VARIANT_64BIT: aarch64_insn_variant = 1;
pub type aarch64_insn_variant = ffi::c_uint;
pub const aarch64_insn_condition_AARCH64_INSN_COND_EQ: aarch64_insn_condition = 0;
pub const aarch64_insn_condition_AARCH64_INSN_COND_NE: aarch64_insn_condition = 1;
pub const aarch64_insn_condition_AARCH64_INSN_COND_CS: aarch64_insn_condition = 2;
pub const aarch64_insn_condition_AARCH64_INSN_COND_CC: aarch64_insn_condition = 3;
pub const aarch64_insn_condition_AARCH64_INSN_COND_MI: aarch64_insn_condition = 4;
pub const aarch64_insn_condition_AARCH64_INSN_COND_PL: aarch64_insn_condition = 5;
pub const aarch64_insn_condition_AARCH64_INSN_COND_VS: aarch64_insn_condition = 6;
pub const aarch64_insn_condition_AARCH64_INSN_COND_VC: aarch64_insn_condition = 7;
pub const aarch64_insn_condition_AARCH64_INSN_COND_HI: aarch64_insn_condition = 8;
pub const aarch64_insn_condition_AARCH64_INSN_COND_LS: aarch64_insn_condition = 9;
pub const aarch64_insn_condition_AARCH64_INSN_COND_GE: aarch64_insn_condition = 10;
pub const aarch64_insn_condition_AARCH64_INSN_COND_LT: aarch64_insn_condition = 11;
pub const aarch64_insn_condition_AARCH64_INSN_COND_GT: aarch64_insn_condition = 12;
pub const aarch64_insn_condition_AARCH64_INSN_COND_LE: aarch64_insn_condition = 13;
pub const aarch64_insn_condition_AARCH64_INSN_COND_AL: aarch64_insn_condition = 14;
pub type aarch64_insn_condition = ffi::c_uint;
pub const aarch64_insn_branch_type_AARCH64_INSN_BRANCH_NOLINK: aarch64_insn_branch_type = 0;
pub const aarch64_insn_branch_type_AARCH64_INSN_BRANCH_LINK: aarch64_insn_branch_type = 1;
pub const aarch64_insn_branch_type_AARCH64_INSN_BRANCH_RETURN: aarch64_insn_branch_type = 2;
pub const aarch64_insn_branch_type_AARCH64_INSN_BRANCH_COMP_ZERO: aarch64_insn_branch_type = 3;
pub const aarch64_insn_branch_type_AARCH64_INSN_BRANCH_COMP_NONZERO: aarch64_insn_branch_type = 4;
pub type aarch64_insn_branch_type = ffi::c_uint;
pub const aarch64_insn_size_type_AARCH64_INSN_SIZE_8: aarch64_insn_size_type = 0;
pub const aarch64_insn_size_type_AARCH64_INSN_SIZE_16: aarch64_insn_size_type = 1;
pub const aarch64_insn_size_type_AARCH64_INSN_SIZE_32: aarch64_insn_size_type = 2;
pub const aarch64_insn_size_type_AARCH64_INSN_SIZE_64: aarch64_insn_size_type = 3;
pub type aarch64_insn_size_type = ffi::c_uint;
pub const aarch64_insn_ldst_type_AARCH64_INSN_LDST_LOAD_REG_OFFSET: aarch64_insn_ldst_type = 0;
pub const aarch64_insn_ldst_type_AARCH64_INSN_LDST_STORE_REG_OFFSET: aarch64_insn_ldst_type = 1;
pub const aarch64_insn_ldst_type_AARCH64_INSN_LDST_LOAD_IMM_OFFSET: aarch64_insn_ldst_type = 2;
pub const aarch64_insn_ldst_type_AARCH64_INSN_LDST_STORE_IMM_OFFSET: aarch64_insn_ldst_type = 3;
pub const aarch64_insn_ldst_type_AARCH64_INSN_LDST_LOAD_PAIR_PRE_INDEX: aarch64_insn_ldst_type = 4;
pub const aarch64_insn_ldst_type_AARCH64_INSN_LDST_STORE_PAIR_PRE_INDEX: aarch64_insn_ldst_type = 5;
pub const aarch64_insn_ldst_type_AARCH64_INSN_LDST_LOAD_PAIR_POST_INDEX: aarch64_insn_ldst_type = 6;
pub const aarch64_insn_ldst_type_AARCH64_INSN_LDST_STORE_PAIR_POST_INDEX: aarch64_insn_ldst_type =
    7;
pub const aarch64_insn_ldst_type_AARCH64_INSN_LDST_LOAD_ACQ: aarch64_insn_ldst_type = 8;
pub const aarch64_insn_ldst_type_AARCH64_INSN_LDST_LOAD_EX: aarch64_insn_ldst_type = 9;
pub const aarch64_insn_ldst_type_AARCH64_INSN_LDST_LOAD_ACQ_EX: aarch64_insn_ldst_type = 10;
pub const aarch64_insn_ldst_type_AARCH64_INSN_LDST_STORE_REL: aarch64_insn_ldst_type = 11;
pub const aarch64_insn_ldst_type_AARCH64_INSN_LDST_STORE_EX: aarch64_insn_ldst_type = 12;
pub const aarch64_insn_ldst_type_AARCH64_INSN_LDST_STORE_REL_EX: aarch64_insn_ldst_type = 13;
pub const aarch64_insn_ldst_type_AARCH64_INSN_LDST_SIGNED_LOAD_IMM_OFFSET: aarch64_insn_ldst_type =
    14;
pub const aarch64_insn_ldst_type_AARCH64_INSN_LDST_SIGNED_LOAD_REG_OFFSET: aarch64_insn_ldst_type =
    15;
pub type aarch64_insn_ldst_type = ffi::c_uint;
pub const aarch64_insn_adsb_type_AARCH64_INSN_ADSB_ADD: aarch64_insn_adsb_type = 0;
pub const aarch64_insn_adsb_type_AARCH64_INSN_ADSB_SUB: aarch64_insn_adsb_type = 1;
pub const aarch64_insn_adsb_type_AARCH64_INSN_ADSB_ADD_SETFLAGS: aarch64_insn_adsb_type = 2;
pub const aarch64_insn_adsb_type_AARCH64_INSN_ADSB_SUB_SETFLAGS: aarch64_insn_adsb_type = 3;
pub type aarch64_insn_adsb_type = ffi::c_uint;
pub const aarch64_insn_movewide_type_AARCH64_INSN_MOVEWIDE_ZERO: aarch64_insn_movewide_type = 0;
pub const aarch64_insn_movewide_type_AARCH64_INSN_MOVEWIDE_KEEP: aarch64_insn_movewide_type = 1;
pub const aarch64_insn_movewide_type_AARCH64_INSN_MOVEWIDE_INVERSE: aarch64_insn_movewide_type = 2;
pub type aarch64_insn_movewide_type = ffi::c_uint;
pub const aarch64_insn_bitfield_type_AARCH64_INSN_BITFIELD_MOVE: aarch64_insn_bitfield_type = 0;
pub const aarch64_insn_bitfield_type_AARCH64_INSN_BITFIELD_MOVE_UNSIGNED:
    aarch64_insn_bitfield_type = 1;
pub const aarch64_insn_bitfield_type_AARCH64_INSN_BITFIELD_MOVE_SIGNED: aarch64_insn_bitfield_type =
    2;
pub type aarch64_insn_bitfield_type = ffi::c_uint;
pub const aarch64_insn_data1_type_AARCH64_INSN_DATA1_REVERSE_16: aarch64_insn_data1_type = 0;
pub const aarch64_insn_data1_type_AARCH64_INSN_DATA1_REVERSE_32: aarch64_insn_data1_type = 1;
pub const aarch64_insn_data1_type_AARCH64_INSN_DATA1_REVERSE_64: aarch64_insn_data1_type = 2;
pub type aarch64_insn_data1_type = ffi::c_uint;
pub const aarch64_insn_data2_type_AARCH64_INSN_DATA2_UDIV: aarch64_insn_data2_type = 0;
pub const aarch64_insn_data2_type_AARCH64_INSN_DATA2_SDIV: aarch64_insn_data2_type = 1;
pub const aarch64_insn_data2_type_AARCH64_INSN_DATA2_LSLV: aarch64_insn_data2_type = 2;
pub const aarch64_insn_data2_type_AARCH64_INSN_DATA2_LSRV: aarch64_insn_data2_type = 3;
pub const aarch64_insn_data2_type_AARCH64_INSN_DATA2_ASRV: aarch64_insn_data2_type = 4;
pub const aarch64_insn_data2_type_AARCH64_INSN_DATA2_RORV: aarch64_insn_data2_type = 5;
pub type aarch64_insn_data2_type = ffi::c_uint;
pub const aarch64_insn_data3_type_AARCH64_INSN_DATA3_MADD: aarch64_insn_data3_type = 0;
pub const aarch64_insn_data3_type_AARCH64_INSN_DATA3_MSUB: aarch64_insn_data3_type = 1;
pub type aarch64_insn_data3_type = ffi::c_uint;
pub const aarch64_insn_logic_type_AARCH64_INSN_LOGIC_AND: aarch64_insn_logic_type = 0;
pub const aarch64_insn_logic_type_AARCH64_INSN_LOGIC_BIC: aarch64_insn_logic_type = 1;
pub const aarch64_insn_logic_type_AARCH64_INSN_LOGIC_ORR: aarch64_insn_logic_type = 2;
pub const aarch64_insn_logic_type_AARCH64_INSN_LOGIC_ORN: aarch64_insn_logic_type = 3;
pub const aarch64_insn_logic_type_AARCH64_INSN_LOGIC_EOR: aarch64_insn_logic_type = 4;
pub const aarch64_insn_logic_type_AARCH64_INSN_LOGIC_EON: aarch64_insn_logic_type = 5;
pub const aarch64_insn_logic_type_AARCH64_INSN_LOGIC_AND_SETFLAGS: aarch64_insn_logic_type = 6;
pub const aarch64_insn_logic_type_AARCH64_INSN_LOGIC_BIC_SETFLAGS: aarch64_insn_logic_type = 7;
pub type aarch64_insn_logic_type = ffi::c_uint;
pub const aarch64_insn_prfm_type_AARCH64_INSN_PRFM_TYPE_PLD: aarch64_insn_prfm_type = 0;
pub const aarch64_insn_prfm_type_AARCH64_INSN_PRFM_TYPE_PLI: aarch64_insn_prfm_type = 1;
pub const aarch64_insn_prfm_type_AARCH64_INSN_PRFM_TYPE_PST: aarch64_insn_prfm_type = 2;
pub type aarch64_insn_prfm_type = ffi::c_uint;
pub const aarch64_insn_prfm_target_AARCH64_INSN_PRFM_TARGET_L1: aarch64_insn_prfm_target = 0;
pub const aarch64_insn_prfm_target_AARCH64_INSN_PRFM_TARGET_L2: aarch64_insn_prfm_target = 1;
pub const aarch64_insn_prfm_target_AARCH64_INSN_PRFM_TARGET_L3: aarch64_insn_prfm_target = 2;
pub type aarch64_insn_prfm_target = ffi::c_uint;
pub const aarch64_insn_prfm_policy_AARCH64_INSN_PRFM_POLICY_KEEP: aarch64_insn_prfm_policy = 0;
pub const aarch64_insn_prfm_policy_AARCH64_INSN_PRFM_POLICY_STRM: aarch64_insn_prfm_policy = 1;
pub type aarch64_insn_prfm_policy = ffi::c_uint;
pub const aarch64_insn_adr_type_AARCH64_INSN_ADR_TYPE_ADRP: aarch64_insn_adr_type = 0;
pub const aarch64_insn_adr_type_AARCH64_INSN_ADR_TYPE_ADR: aarch64_insn_adr_type = 1;
pub type aarch64_insn_adr_type = ffi::c_uint;
pub const aarch64_insn_mem_atomic_op_AARCH64_INSN_MEM_ATOMIC_ADD: aarch64_insn_mem_atomic_op = 0;
pub const aarch64_insn_mem_atomic_op_AARCH64_INSN_MEM_ATOMIC_CLR: aarch64_insn_mem_atomic_op = 1;
pub const aarch64_insn_mem_atomic_op_AARCH64_INSN_MEM_ATOMIC_EOR: aarch64_insn_mem_atomic_op = 2;
pub const aarch64_insn_mem_atomic_op_AARCH64_INSN_MEM_ATOMIC_SET: aarch64_insn_mem_atomic_op = 3;
pub const aarch64_insn_mem_atomic_op_AARCH64_INSN_MEM_ATOMIC_SWP: aarch64_insn_mem_atomic_op = 4;
pub type aarch64_insn_mem_atomic_op = ffi::c_uint;
pub const aarch64_insn_mem_order_type_AARCH64_INSN_MEM_ORDER_NONE: aarch64_insn_mem_order_type = 0;
pub const aarch64_insn_mem_order_type_AARCH64_INSN_MEM_ORDER_ACQ: aarch64_insn_mem_order_type = 1;
pub const aarch64_insn_mem_order_type_AARCH64_INSN_MEM_ORDER_REL: aarch64_insn_mem_order_type = 2;
pub const aarch64_insn_mem_order_type_AARCH64_INSN_MEM_ORDER_ACQREL: aarch64_insn_mem_order_type =
    3;
pub type aarch64_insn_mem_order_type = ffi::c_uint;
pub const aarch64_insn_mb_type_AARCH64_INSN_MB_SY: aarch64_insn_mb_type = 0;
pub const aarch64_insn_mb_type_AARCH64_INSN_MB_ST: aarch64_insn_mb_type = 1;
pub const aarch64_insn_mb_type_AARCH64_INSN_MB_LD: aarch64_insn_mb_type = 2;
pub const aarch64_insn_mb_type_AARCH64_INSN_MB_ISH: aarch64_insn_mb_type = 3;
pub const aarch64_insn_mb_type_AARCH64_INSN_MB_ISHST: aarch64_insn_mb_type = 4;
pub const aarch64_insn_mb_type_AARCH64_INSN_MB_ISHLD: aarch64_insn_mb_type = 5;
pub const aarch64_insn_mb_type_AARCH64_INSN_MB_NSH: aarch64_insn_mb_type = 6;
pub const aarch64_insn_mb_type_AARCH64_INSN_MB_NSHST: aarch64_insn_mb_type = 7;
pub const aarch64_insn_mb_type_AARCH64_INSN_MB_NSHLD: aarch64_insn_mb_type = 8;
pub const aarch64_insn_mb_type_AARCH64_INSN_MB_OSH: aarch64_insn_mb_type = 9;
pub const aarch64_insn_mb_type_AARCH64_INSN_MB_OSHST: aarch64_insn_mb_type = 10;
pub const aarch64_insn_mb_type_AARCH64_INSN_MB_OSHLD: aarch64_insn_mb_type = 11;
pub type aarch64_insn_mb_type = ffi::c_uint;
pub type aarch64_insn_encoding_class = i32;
extern "C" {
    pub fn aarch64_get_insn_class(insn: u32_) -> aarch64_insn_encoding_class;
}
extern "C" {
    pub fn aarch64_insn_decode_immediate(type_: aarch64_insn_imm_type, insn: u32_) -> u64_;
}
extern "C" {
    pub fn aarch64_insn_encode_immediate(
        type_: aarch64_insn_imm_type,
        insn: u32_,
        imm: u64_,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_decode_register(type_: aarch64_insn_register_type, insn: u32_) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_branch_imm(
        pc: ffi::c_ulong,
        addr: ffi::c_ulong,
        type_: aarch64_insn_branch_type,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_comp_branch_imm(
        pc: ffi::c_ulong,
        addr: ffi::c_ulong,
        reg: aarch64_insn_register,
        variant: aarch64_insn_variant,
        type_: aarch64_insn_branch_type,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_cond_branch_imm(
        pc: ffi::c_ulong,
        addr: ffi::c_ulong,
        cond: aarch64_insn_condition,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_branch_reg(
        reg: aarch64_insn_register,
        type_: aarch64_insn_branch_type,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_load_store_reg(
        reg: aarch64_insn_register,
        base: aarch64_insn_register,
        offset: aarch64_insn_register,
        size: aarch64_insn_size_type,
        type_: aarch64_insn_ldst_type,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_load_store_imm(
        reg: aarch64_insn_register,
        base: aarch64_insn_register,
        imm: ffi::c_uint,
        size: aarch64_insn_size_type,
        type_: aarch64_insn_ldst_type,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_load_literal(
        pc: ffi::c_ulong,
        addr: ffi::c_ulong,
        reg: aarch64_insn_register,
        is64bit: bool_,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_load_store_pair(
        reg1: aarch64_insn_register,
        reg2: aarch64_insn_register,
        base: aarch64_insn_register,
        offset: ffi::c_int,
        variant: aarch64_insn_variant,
        type_: aarch64_insn_ldst_type,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_load_acq_store_rel(
        reg: aarch64_insn_register,
        base: aarch64_insn_register,
        size: aarch64_insn_size_type,
        type_: aarch64_insn_ldst_type,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_load_store_ex(
        reg: aarch64_insn_register,
        base: aarch64_insn_register,
        state: aarch64_insn_register,
        size: aarch64_insn_size_type,
        type_: aarch64_insn_ldst_type,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_add_sub_imm(
        dst: aarch64_insn_register,
        src: aarch64_insn_register,
        imm: ffi::c_int,
        variant: aarch64_insn_variant,
        type_: aarch64_insn_adsb_type,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_adr(
        pc: ffi::c_ulong,
        addr: ffi::c_ulong,
        reg: aarch64_insn_register,
        type_: aarch64_insn_adr_type,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_bitfield(
        dst: aarch64_insn_register,
        src: aarch64_insn_register,
        immr: ffi::c_int,
        imms: ffi::c_int,
        variant: aarch64_insn_variant,
        type_: aarch64_insn_bitfield_type,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_movewide(
        dst: aarch64_insn_register,
        imm: ffi::c_int,
        shift: ffi::c_int,
        variant: aarch64_insn_variant,
        type_: aarch64_insn_movewide_type,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_add_sub_shifted_reg(
        dst: aarch64_insn_register,
        src: aarch64_insn_register,
        reg: aarch64_insn_register,
        shift: ffi::c_int,
        variant: aarch64_insn_variant,
        type_: aarch64_insn_adsb_type,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_data1(
        dst: aarch64_insn_register,
        src: aarch64_insn_register,
        variant: aarch64_insn_variant,
        type_: aarch64_insn_data1_type,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_data2(
        dst: aarch64_insn_register,
        src: aarch64_insn_register,
        reg: aarch64_insn_register,
        variant: aarch64_insn_variant,
        type_: aarch64_insn_data2_type,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_data3(
        dst: aarch64_insn_register,
        src: aarch64_insn_register,
        reg1: aarch64_insn_register,
        reg2: aarch64_insn_register,
        variant: aarch64_insn_variant,
        type_: aarch64_insn_data3_type,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_logical_shifted_reg(
        dst: aarch64_insn_register,
        src: aarch64_insn_register,
        reg: aarch64_insn_register,
        shift: ffi::c_int,
        variant: aarch64_insn_variant,
        type_: aarch64_insn_logic_type,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_move_reg(
        dst: aarch64_insn_register,
        src: aarch64_insn_register,
        variant: aarch64_insn_variant,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_logical_immediate(
        type_: aarch64_insn_logic_type,
        variant: aarch64_insn_variant,
        Rn: aarch64_insn_register,
        Rd: aarch64_insn_register,
        imm: u64_,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_extr(
        variant: aarch64_insn_variant,
        Rm: aarch64_insn_register,
        Rn: aarch64_insn_register,
        Rd: aarch64_insn_register,
        lsb: u8_,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_atomic_ld_op(
        result: aarch64_insn_register,
        address: aarch64_insn_register,
        value: aarch64_insn_register,
        size: aarch64_insn_size_type,
        op: aarch64_insn_mem_atomic_op,
        order: aarch64_insn_mem_order_type,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_cas(
        result: aarch64_insn_register,
        address: aarch64_insn_register,
        value: aarch64_insn_register,
        size: aarch64_insn_size_type,
        order: aarch64_insn_mem_order_type,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_dmb(type_: aarch64_insn_mb_type) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_dsb(type_: aarch64_insn_mb_type) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_gen_mrs(
        result: aarch64_insn_register,
        sysreg: aarch64_insn_system_register,
    ) -> u32_;
}
extern "C" {
    pub fn aarch64_get_branch_offset(insn: u32_) -> s32;
}
extern "C" {
    pub fn aarch64_set_branch_offset(insn: u32_, offset: s32) -> u32_;
}
extern "C" {
    pub fn aarch64_insn_adrp_get_offset(insn: u32_) -> s32;
}
extern "C" {
    pub fn aarch64_insn_adrp_set_offset(insn: u32_, offset: s32) -> u32_;
}
extern "C" {
    pub fn aarch32_insn_is_wide(insn: u32_) -> bool_;
}
extern "C" {
    pub fn aarch64_insn_extract_system_reg(insn: u32_) -> u32_;
}
extern "C" {
    pub fn aarch32_insn_extract_reg_num(insn: u32_, offset: ffi::c_int) -> u32_;
}
extern "C" {
    pub fn aarch32_insn_mcr_extract_opc2(insn: u32_) -> u32_;
}
extern "C" {
    pub fn aarch32_insn_mcr_extract_crm(insn: u32_) -> u32_;
}
pub type pstate_check_t = ::core::option::Option<unsafe extern "C" fn(arg1: ffi::c_ulong) -> bool_>;
extern "C" {
    pub static aarch32_opcode_cond_checks: [pstate_check_t; 16usize];
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct jump_entry {
    pub code: s32,
    pub target: s32,
    pub key: ffi::c_long,
}
pub const jump_label_type_JUMP_LABEL_NOP: jump_label_type = 0;
pub const jump_label_type_JUMP_LABEL_JMP: jump_label_type = 1;
pub type jump_label_type = ffi::c_uint;
extern "C" {
    pub static mut __start___jump_table: [jump_entry; 0usize];
}
extern "C" {
    pub static mut __stop___jump_table: [jump_entry; 0usize];
}
extern "C" {
    pub fn jump_label_init();
}
extern "C" {
    pub fn jump_label_init_ro();
}
extern "C" {
    pub fn jump_label_lock();
}
extern "C" {
    pub fn jump_label_unlock();
}
extern "C" {
    pub fn arch_jump_label_transform(entry: *mut jump_entry, type_: jump_label_type);
}
extern "C" {
    pub fn arch_jump_label_transform_queue(entry: *mut jump_entry, type_: jump_label_type)
        -> bool_;
}
extern "C" {
    pub fn arch_jump_label_transform_apply();
}
extern "C" {
    pub fn jump_label_text_reserved(start: *mut ffi::c_void, end: *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn static_key_slow_inc(key: *mut static_key) -> bool_;
}
extern "C" {
    pub fn static_key_fast_inc_not_disabled(key: *mut static_key) -> bool_;
}
extern "C" {
    pub fn static_key_slow_dec(key: *mut static_key);
}
extern "C" {
    pub fn static_key_slow_inc_cpuslocked(key: *mut static_key) -> bool_;
}
extern "C" {
    pub fn static_key_slow_dec_cpuslocked(key: *mut static_key);
}
extern "C" {
    pub fn static_key_count(key: *mut static_key) -> ffi::c_int;
}
extern "C" {
    pub fn static_key_enable(key: *mut static_key);
}
extern "C" {
    pub fn static_key_disable(key: *mut static_key);
}
extern "C" {
    pub fn static_key_enable_cpuslocked(key: *mut static_key);
}
extern "C" {
    pub fn static_key_disable_cpuslocked(key: *mut static_key);
}
extern "C" {
    pub fn jump_label_init_type(entry: *mut jump_entry) -> jump_label_type;
}
pub const class_jump_label_lock_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_jump_label_lock_t {
    pub lock: *mut ffi::c_void,
}
impl Default for class_jump_label_lock_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct static_key_true {
    pub key: static_key,
}
impl Default for static_key_true {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct static_key_false {
    pub key: static_key,
}
impl Default for static_key_false {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn ____wrong_branch_error() -> bool_;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _ddebug {
    pub modname: *const ffi::c_char,
    pub function: *const ffi::c_char,
    pub filename: *const ffi::c_char,
    pub format: *const ffi::c_char,
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
    pub key: _ddebug__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _ddebug__bindgen_ty_1 {
    pub dd_key_true: static_key_true,
    pub dd_key_false: static_key_false,
}
impl Default for _ddebug__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for _ddebug {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl _ddebug {
    #[inline]
    pub fn lineno(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 18u8) as u32) }
    }
    #[inline]
    pub fn set_lineno(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 18u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn lineno_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                18u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_lineno_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                18u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn class_id(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(18usize, 6u8) as u32) }
    }
    #[inline]
    pub fn set_class_id(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(18usize, 6u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn class_id_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                18usize,
                6u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_class_id_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                18usize,
                6u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn flags(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(24usize, 8u8) as u32) }
    }
    #[inline]
    pub fn set_flags(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(24usize, 8u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn flags_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                24usize,
                8u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_flags_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                24usize,
                8u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        lineno: ffi::c_uint,
        class_id: ffi::c_uint,
        flags: ffi::c_uint,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 18u8, {
            let lineno: u32 = unsafe { ::core::mem::transmute(lineno) };
            lineno as u64
        });
        __bindgen_bitfield_unit.set(18usize, 6u8, {
            let class_id: u32 = unsafe { ::core::mem::transmute(class_id) };
            class_id as u64
        });
        __bindgen_bitfield_unit.set(24usize, 8u8, {
            let flags: u32 = unsafe { ::core::mem::transmute(flags) };
            flags as u64
        });
        __bindgen_bitfield_unit
    }
}
pub const class_map_type_DD_CLASS_TYPE_DISJOINT_BITS: class_map_type = 0;
pub const class_map_type_DD_CLASS_TYPE_LEVEL_NUM: class_map_type = 1;
pub const class_map_type_DD_CLASS_TYPE_DISJOINT_NAMES: class_map_type = 2;
pub const class_map_type_DD_CLASS_TYPE_LEVEL_NAMES: class_map_type = 3;
pub type class_map_type = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ddebug_class_map {
    pub link: list_head,
    pub mod_: *mut module,
    pub mod_name: *const ffi::c_char,
    pub class_names: *mut *const ffi::c_char,
    pub length: ffi::c_int,
    pub base: ffi::c_int,
    pub map_type: class_map_type,
}
impl Default for ddebug_class_map {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _ddebug_info {
    pub descs: *mut _ddebug,
    pub classes: *mut ddebug_class_map,
    pub num_descs: ffi::c_uint,
    pub num_classes: ffi::c_uint,
}
impl Default for _ddebug_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ddebug_class_param {
    pub __bindgen_anon_1: ddebug_class_param__bindgen_ty_1,
    pub flags: [ffi::c_char; 8usize],
    pub map: *const ddebug_class_map,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union ddebug_class_param__bindgen_ty_1 {
    pub bits: *mut ffi::c_ulong,
    pub lvl: *mut ffi::c_uint,
}
impl Default for ddebug_class_param__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for ddebug_class_param {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn __dynamic_pr_debug(descriptor: *mut _ddebug, fmt: *const ffi::c_char, ...);
}
extern "C" {
    pub fn __dynamic_dev_dbg(
        descriptor: *mut _ddebug,
        dev: *const device,
        fmt: *const ffi::c_char,
        ...
    );
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct net_device {
    _unused: [u8; 0],
}
extern "C" {
    pub fn __dynamic_netdev_dbg(
        descriptor: *mut _ddebug,
        dev: *const net_device,
        fmt: *const ffi::c_char,
        ...
    );
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ib_device {
    _unused: [u8; 0],
}
extern "C" {
    pub fn __dynamic_ibdev_dbg(
        descriptor: *mut _ddebug,
        ibdev: *const ib_device,
        fmt: *const ffi::c_char,
        ...
    );
}
extern "C" {
    pub fn ddebug_dyndbg_module_param_cb(
        param: *mut ffi::c_char,
        val: *mut ffi::c_char,
        modname: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn param_set_dyndbg_classes(
        instr: *const ffi::c_char,
        kp: *const kernel_param,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn param_get_dyndbg_classes(
        buffer: *mut ffi::c_char,
        kp: *const kernel_param,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct kernel_param_ops {
    pub flags: ffi::c_uint,
    pub set: ::core::option::Option<
        unsafe extern "C" fn(val: *const ffi::c_char, kp: *const kernel_param) -> ffi::c_int,
    >,
    pub get: ::core::option::Option<
        unsafe extern "C" fn(buffer: *mut ffi::c_char, kp: *const kernel_param) -> ffi::c_int,
    >,
    pub free: ::core::option::Option<unsafe extern "C" fn(arg: *mut ffi::c_void)>,
}
extern "C" {
    pub static param_ops_dyndbg_classes: kernel_param_ops;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct file_operations {
    pub owner: *mut module,
    pub fop_flags: fop_flags_t,
    pub llseek: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut file, arg2: loff_t, arg3: ffi::c_int) -> loff_t,
    >,
    pub read: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut file,
            arg2: *mut ffi::c_char,
            arg3: usize,
            arg4: *mut loff_t,
        ) -> isize,
    >,
    pub write: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut file,
            arg2: *const ffi::c_char,
            arg3: usize,
            arg4: *mut loff_t,
        ) -> isize,
    >,
    pub read_iter: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut kiocb, arg2: *mut iov_iter) -> isize,
    >,
    pub write_iter: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut kiocb, arg2: *mut iov_iter) -> isize,
    >,
    pub iopoll: ::core::option::Option<
        unsafe extern "C" fn(
            kiocb: *mut kiocb,
            arg1: *mut io_comp_batch,
            flags: ffi::c_uint,
        ) -> ffi::c_int,
    >,
    pub iterate_shared: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut file, arg2: *mut dir_context) -> ffi::c_int,
    >,
    pub poll: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut file, arg2: *mut poll_table_struct) -> __poll_t,
    >,
    pub unlocked_ioctl: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut file, arg2: ffi::c_uint, arg3: ffi::c_ulong) -> ffi::c_long,
    >,
    pub compat_ioctl: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut file, arg2: ffi::c_uint, arg3: ffi::c_ulong) -> ffi::c_long,
    >,
    pub mmap: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut file, arg2: *mut vm_area_struct) -> ffi::c_int,
    >,
    pub open: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut inode, arg2: *mut file) -> ffi::c_int,
    >,
    pub flush:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut file, id: fl_owner_t) -> ffi::c_int>,
    pub release: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut inode, arg2: *mut file) -> ffi::c_int,
    >,
    pub fsync: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut file,
            arg2: loff_t,
            arg3: loff_t,
            datasync: ffi::c_int,
        ) -> ffi::c_int,
    >,
    pub fasync: ::core::option::Option<
        unsafe extern "C" fn(arg1: ffi::c_int, arg2: *mut file, arg3: ffi::c_int) -> ffi::c_int,
    >,
    pub lock: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut file, arg2: ffi::c_int, arg3: *mut file_lock) -> ffi::c_int,
    >,
    pub get_unmapped_area: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut file,
            arg2: ffi::c_ulong,
            arg3: ffi::c_ulong,
            arg4: ffi::c_ulong,
            arg5: ffi::c_ulong,
        ) -> ffi::c_ulong,
    >,
    pub check_flags: ::core::option::Option<unsafe extern "C" fn(arg1: ffi::c_int) -> ffi::c_int>,
    pub flock: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut file, arg2: ffi::c_int, arg3: *mut file_lock) -> ffi::c_int,
    >,
    pub splice_write: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut pipe_inode_info,
            arg2: *mut file,
            arg3: *mut loff_t,
            arg4: usize,
            arg5: ffi::c_uint,
        ) -> isize,
    >,
    pub splice_read: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut file,
            arg2: *mut loff_t,
            arg3: *mut pipe_inode_info,
            arg4: usize,
            arg5: ffi::c_uint,
        ) -> isize,
    >,
    pub splice_eof: ::core::option::Option<unsafe extern "C" fn(file: *mut file)>,
    pub setlease: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut file,
            arg2: ffi::c_int,
            arg3: *mut *mut file_lease,
            arg4: *mut *mut ffi::c_void,
        ) -> ffi::c_int,
    >,
    pub fallocate: ::core::option::Option<
        unsafe extern "C" fn(
            file: *mut file,
            mode: ffi::c_int,
            offset: loff_t,
            len: loff_t,
        ) -> ffi::c_long,
    >,
    pub show_fdinfo: ::core::option::Option<unsafe extern "C" fn(m: *mut seq_file, f: *mut file)>,
    pub copy_file_range: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut file,
            arg2: loff_t,
            arg3: *mut file,
            arg4: loff_t,
            arg5: usize,
            arg6: ffi::c_uint,
        ) -> isize,
    >,
    pub remap_file_range: ::core::option::Option<
        unsafe extern "C" fn(
            file_in: *mut file,
            pos_in: loff_t,
            file_out: *mut file,
            pos_out: loff_t,
            len: loff_t,
            remap_flags: ffi::c_uint,
        ) -> loff_t,
    >,
    pub fadvise: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut file,
            arg2: loff_t,
            arg3: loff_t,
            arg4: ffi::c_int,
        ) -> ffi::c_int,
    >,
    pub uring_cmd: ::core::option::Option<
        unsafe extern "C" fn(ioucmd: *mut io_uring_cmd, issue_flags: ffi::c_uint) -> ffi::c_int,
    >,
    pub uring_cmd_iopoll: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut io_uring_cmd,
            arg2: *mut io_comp_batch,
            poll_flags: ffi::c_uint,
        ) -> ffi::c_int,
    >,
}
impl Default for file_operations {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static kmsg_fops: file_operations;
}
pub const DUMP_PREFIX_NONE: _bindgen_ty_2 = 0;
pub const DUMP_PREFIX_ADDRESS: _bindgen_ty_2 = 1;
pub const DUMP_PREFIX_OFFSET: _bindgen_ty_2 = 2;
pub type _bindgen_ty_2 = ffi::c_uint;
extern "C" {
    pub fn hex_dump_to_buffer(
        buf: *const ffi::c_void,
        len: usize,
        rowsize: ffi::c_int,
        groupsize: ffi::c_int,
        linebuf: *mut ffi::c_char,
        linebuflen: usize,
        ascii: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn print_hex_dump(
        level: *const ffi::c_char,
        prefix_str: *const ffi::c_char,
        prefix_type: ffi::c_int,
        rowsize: ffi::c_int,
        groupsize: ffi::c_int,
        buf: *const ffi::c_void,
        len: usize,
        ascii: bool_,
    );
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct string_stream {
    _unused: [u8; 0],
}
pub const kunit_assert_type_KUNIT_ASSERTION: kunit_assert_type = 0;
pub const kunit_assert_type_KUNIT_EXPECTATION: kunit_assert_type = 1;
pub type kunit_assert_type = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kunit_loc {
    pub line: ffi::c_int,
    pub file: *const ffi::c_char,
}
impl Default for kunit_loc {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct kunit_assert {}
pub type assert_format_t = ::core::option::Option<
    unsafe extern "C" fn(
        assert: *const kunit_assert,
        message: *const va_format,
        stream: *mut string_stream,
    ),
>;
extern "C" {
    pub fn kunit_assert_prologue(
        loc: *const kunit_loc,
        type_: kunit_assert_type,
        stream: *mut string_stream,
    );
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct kunit_fail_assert {
    pub assert: kunit_assert,
}
extern "C" {
    pub fn kunit_fail_assert_format(
        assert: *const kunit_assert,
        message: *const va_format,
        stream: *mut string_stream,
    );
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kunit_unary_assert {
    pub assert: kunit_assert,
    pub condition: *const ffi::c_char,
    pub expected_true: bool_,
}
impl Default for kunit_unary_assert {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn kunit_unary_assert_format(
        assert: *const kunit_assert,
        message: *const va_format,
        stream: *mut string_stream,
    );
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kunit_ptr_not_err_assert {
    pub assert: kunit_assert,
    pub text: *const ffi::c_char,
    pub value: *const ffi::c_void,
}
impl Default for kunit_ptr_not_err_assert {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn kunit_ptr_not_err_assert_format(
        assert: *const kunit_assert,
        message: *const va_format,
        stream: *mut string_stream,
    );
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kunit_binary_assert_text {
    pub operation: *const ffi::c_char,
    pub left_text: *const ffi::c_char,
    pub right_text: *const ffi::c_char,
}
impl Default for kunit_binary_assert_text {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kunit_binary_assert {
    pub assert: kunit_assert,
    pub text: *const kunit_binary_assert_text,
    pub left_value: ffi::c_longlong,
    pub right_value: ffi::c_longlong,
}
impl Default for kunit_binary_assert {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn kunit_binary_assert_format(
        assert: *const kunit_assert,
        message: *const va_format,
        stream: *mut string_stream,
    );
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kunit_binary_ptr_assert {
    pub assert: kunit_assert,
    pub text: *const kunit_binary_assert_text,
    pub left_value: *const ffi::c_void,
    pub right_value: *const ffi::c_void,
}
impl Default for kunit_binary_ptr_assert {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn kunit_binary_ptr_assert_format(
        assert: *const kunit_assert,
        message: *const va_format,
        stream: *mut string_stream,
    );
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kunit_binary_str_assert {
    pub assert: kunit_assert,
    pub text: *const kunit_binary_assert_text,
    pub left_value: *const ffi::c_char,
    pub right_value: *const ffi::c_char,
}
impl Default for kunit_binary_str_assert {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn kunit_binary_str_assert_format(
        assert: *const kunit_assert,
        message: *const va_format,
        stream: *mut string_stream,
    );
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kunit_mem_assert {
    pub assert: kunit_assert,
    pub text: *const kunit_binary_assert_text,
    pub left_value: *const ffi::c_void,
    pub right_value: *const ffi::c_void,
    pub size: usize,
}
impl Default for kunit_mem_assert {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn kunit_mem_assert_format(
        assert: *const kunit_assert,
        message: *const va_format,
        stream: *mut string_stream,
    );
}
extern "C" {
    pub fn kunit_assert_print_msg(message: *const va_format, stream: *mut string_stream);
}
extern "C" {
    pub fn is_literal(text: *const ffi::c_char, value: ffi::c_longlong) -> bool_;
}
extern "C" {
    pub fn is_str_literal(text: *const ffi::c_char, value: *const ffi::c_char) -> bool_;
}
extern "C" {
    pub fn kunit_assert_hexdump(
        stream: *mut string_stream,
        buf: *const ffi::c_void,
        compared_buf: *const ffi::c_void,
        len: usize,
    );
}
pub type kunit_try_catch_func_t =
    ::core::option::Option<unsafe extern "C" fn(arg1: *mut ffi::c_void)>;
#[repr(C)]
#[repr(align(8))]
#[derive(Default, Copy, Clone)]
pub struct kunit_try_catch {
    pub _bindgen_opaque_blob: [u64; 5usize],
}
extern "C" {
    pub fn kunit_try_catch_run(try_catch: *mut kunit_try_catch, context: *mut ffi::c_void);
}
extern "C" {
    pub fn kunit_try_catch_throw(try_catch: *mut kunit_try_catch) -> !;
}
extern "C" {
    pub static mut panic_blink:
        ::core::option::Option<unsafe extern "C" fn(state: ffi::c_int) -> ffi::c_long>;
}
extern "C" {
    pub fn panic(fmt: *const ffi::c_char, ...) -> !;
}
extern "C" {
    pub fn nmi_panic(regs: *mut pt_regs, msg: *const ffi::c_char);
}
extern "C" {
    pub fn check_panic_on_warn(origin: *const ffi::c_char);
}
extern "C" {
    pub fn oops_enter();
}
extern "C" {
    pub fn oops_exit();
}
extern "C" {
    pub fn oops_may_print() -> bool_;
}
extern "C" {
    pub static mut panic_triggering_all_cpu_backtrace: bool_;
}
extern "C" {
    pub static mut panic_timeout: ffi::c_int;
}
extern "C" {
    pub static mut panic_print: ffi::c_ulong;
}
extern "C" {
    pub static mut panic_on_oops: ffi::c_int;
}
extern "C" {
    pub static mut panic_on_unrecovered_nmi: ffi::c_int;
}
extern "C" {
    pub static mut panic_on_io_nmi: ffi::c_int;
}
extern "C" {
    pub static mut panic_on_warn: ffi::c_int;
}
extern "C" {
    pub static mut panic_on_taint: ffi::c_ulong;
}
extern "C" {
    pub static mut panic_on_taint_nousertaint: bool_;
}
extern "C" {
    pub static mut sysctl_panic_on_rcu_stall: ffi::c_int;
}
extern "C" {
    pub static mut sysctl_max_rcu_stall_to_panic: ffi::c_int;
}
extern "C" {
    pub static mut sysctl_panic_on_stackoverflow: ffi::c_int;
}
extern "C" {
    pub static mut crash_kexec_post_notifiers: bool_;
}
extern "C" {
    pub fn __stack_chk_fail();
}
extern "C" {
    pub fn abort();
}
extern "C" {
    pub static mut panic_cpu: atomic_t;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct taint_flag {
    pub c_true: ffi::c_char,
    pub c_false: ffi::c_char,
    pub module: bool_,
    pub desc: *const ffi::c_char,
}
impl Default for taint_flag {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static taint_flags: [taint_flag; 20usize];
}
pub const lockdep_ok_LOCKDEP_STILL_OK: lockdep_ok = 0;
pub const lockdep_ok_LOCKDEP_NOW_UNRELIABLE: lockdep_ok = 1;
pub type lockdep_ok = ffi::c_uint;
extern "C" {
    pub fn print_tainted() -> *const ffi::c_char;
}
extern "C" {
    pub fn print_tainted_verbose() -> *const ffi::c_char;
}
extern "C" {
    pub fn add_taint(flag: ffi::c_uint, arg1: lockdep_ok);
}
extern "C" {
    pub fn test_taint(flag: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn get_taint() -> ffi::c_ulong;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct warn_args {
    _unused: [u8; 0],
}
extern "C" {
    pub fn __warn(
        file: *const ffi::c_char,
        line: ffi::c_int,
        caller: *mut ffi::c_void,
        taint: ffi::c_uint,
        regs: *mut pt_regs,
        args: *mut warn_args,
    );
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bug_entry {
    pub bug_addr_disp: ffi::c_int,
    pub file_disp: ffi::c_int,
    pub line: ffi::c_ushort,
    pub flags: ffi::c_ushort,
}
extern "C" {
    pub fn warn_slowpath_fmt(
        file: *const ffi::c_char,
        line: ffi::c_int,
        taint: ffi::c_uint,
        fmt: *const ffi::c_char,
        ...
    );
}
extern "C" {
    pub fn __warn_printk(fmt: *const ffi::c_char, ...);
}
pub const bug_trap_type_BUG_TRAP_TYPE_NONE: bug_trap_type = 0;
pub const bug_trap_type_BUG_TRAP_TYPE_WARN: bug_trap_type = 1;
pub const bug_trap_type_BUG_TRAP_TYPE_BUG: bug_trap_type = 2;
pub type bug_trap_type = ffi::c_uint;
extern "C" {
    pub fn bug_get_file_line(
        bug: *mut bug_entry,
        file: *mut *const ffi::c_char,
        line: *mut ffi::c_uint,
    );
}
extern "C" {
    pub fn find_bug(bugaddr: ffi::c_ulong) -> *mut bug_entry;
}
extern "C" {
    pub fn report_bug(bug_addr: ffi::c_ulong, regs: *mut pt_regs) -> bug_trap_type;
}
extern "C" {
    pub fn is_valid_bugaddr(addr: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn generic_bug_clear_once();
}
extern "C" {
    pub fn mem_dump_obj(object: *mut ffi::c_void);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct timespec {
    _unused: [u8; 0],
}
pub const timespec_type_TT_NONE: timespec_type = 0;
pub const timespec_type_TT_NATIVE: timespec_type = 1;
pub const timespec_type_TT_COMPAT: timespec_type = 2;
pub type timespec_type = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct restart_block {
    pub arch_data: ffi::c_ulong,
    pub fn_: ::core::option::Option<unsafe extern "C" fn(arg1: *mut restart_block) -> ffi::c_long>,
    pub __bindgen_anon_1: restart_block__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union restart_block__bindgen_ty_1 {
    pub futex: restart_block__bindgen_ty_1__bindgen_ty_1,
    pub nanosleep: restart_block__bindgen_ty_1__bindgen_ty_2,
    pub poll: restart_block__bindgen_ty_1__bindgen_ty_3,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct restart_block__bindgen_ty_1__bindgen_ty_1 {
    pub uaddr: *mut u32_,
    pub val: u32_,
    pub flags: u32_,
    pub bitset: u32_,
    pub time: u64_,
    pub uaddr2: *mut u32_,
}
impl Default for restart_block__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct restart_block__bindgen_ty_1__bindgen_ty_2 {
    pub clockid: clockid_t,
    pub type_: timespec_type,
    pub __bindgen_anon_1: restart_block__bindgen_ty_1__bindgen_ty_2__bindgen_ty_1,
    pub expires: u64_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union restart_block__bindgen_ty_1__bindgen_ty_2__bindgen_ty_1 {
    pub rmtp: *mut __kernel_timespec,
    pub compat_rmtp: *mut old_timespec32,
}
impl Default for restart_block__bindgen_ty_1__bindgen_ty_2__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for restart_block__bindgen_ty_1__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct restart_block__bindgen_ty_1__bindgen_ty_3 {
    pub ufds: *mut pollfd,
    pub nfds: ffi::c_int,
    pub has_timeout: ffi::c_int,
    pub tv_sec: ffi::c_ulong,
    pub tv_nsec: ffi::c_ulong,
}
impl Default for restart_block__bindgen_ty_1__bindgen_ty_3 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for restart_block__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for restart_block {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn do_no_restart_syscall(parm: *mut restart_block) -> ffi::c_long;
}
#[repr(C)]
#[derive(Default)]
pub struct sysinfo {
    pub uptime: __kernel_long_t,
    pub loads: [__kernel_ulong_t; 3usize],
    pub totalram: __kernel_ulong_t,
    pub freeram: __kernel_ulong_t,
    pub sharedram: __kernel_ulong_t,
    pub bufferram: __kernel_ulong_t,
    pub totalswap: __kernel_ulong_t,
    pub freeswap: __kernel_ulong_t,
    pub procs: __u16,
    pub pad: __u16,
    pub totalhigh: __kernel_ulong_t,
    pub freehigh: __kernel_ulong_t,
    pub mem_unit: __u32,
    pub _f: __IncompleteArrayField<ffi::c_char>,
}
extern "C" {
    pub fn __sw_hweight8(w: ffi::c_uint) -> ffi::c_uint;
}
extern "C" {
    pub fn __sw_hweight16(w: ffi::c_uint) -> ffi::c_uint;
}
extern "C" {
    pub fn __sw_hweight32(w: ffi::c_uint) -> ffi::c_uint;
}
extern "C" {
    pub fn __sw_hweight64(w: __u64) -> ffi::c_ulong;
}
#[repr(C)]
#[repr(align(16))]
#[derive(Copy, Clone)]
pub union __u128_halves {
    pub full: u128_,
    pub __bindgen_anon_1: __u128_halves__bindgen_ty_1,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct __u128_halves__bindgen_ty_1 {
    pub low: u64_,
    pub high: u64_,
}
impl Default for __u128_halves {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[repr(align(4))]
#[derive(Default, Copy, Clone)]
pub struct alt_instr {
    pub _bindgen_opaque_blob: [u32; 3usize],
}
pub type alternative_cb_t = ::core::option::Option<
    unsafe extern "C" fn(
        alt: *mut alt_instr,
        origptr: *mut __le32,
        updptr: *mut __le32,
        nr_inst: ffi::c_int,
    ),
>;
extern "C" {
    pub fn apply_boot_alternatives();
}
extern "C" {
    pub fn apply_alternatives_all();
}
extern "C" {
    pub fn alternative_is_applied(cpucap: u16_) -> bool_;
}
extern "C" {
    pub fn apply_alternatives_module(start: *mut ffi::c_void, length: usize);
}
extern "C" {
    pub fn alt_cb_patch_nops(
        alt: *mut alt_instr,
        origptr: *mut __le32,
        updptr: *mut __le32,
        nr_inst: ffi::c_int,
    );
}
pub type atomic_long_t = atomic64_t;
pub const BAD_STACK: _bindgen_ty_3 = -1;
pub const NOT_STACK: _bindgen_ty_3 = 0;
pub const GOOD_FRAME: _bindgen_ty_3 = 1;
pub const GOOD_STACK: _bindgen_ty_3 = 2;
pub type _bindgen_ty_3 = ffi::c_int;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct vma_merge_struct {
    _unused: [u8; 0],
}
extern "C" {
    pub fn dump_page(page: *const page, reason: *const ffi::c_char);
}
extern "C" {
    pub fn dump_vma(vma: *const vm_area_struct);
}
extern "C" {
    pub fn dump_mm(mm: *const mm_struct);
}
extern "C" {
    pub fn dump_vmg(vmg: *const vma_merge_struct, reason: *const ffi::c_char);
}
extern "C" {
    pub fn vma_iter_dump_tree(vmi: *const vma_iterator);
}
extern "C" {
    pub static mut _text: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut _stext: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut _etext: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut _data: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut _sdata: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut _edata: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __bss_start: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __bss_stop: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __init_begin: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __init_end: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut _sinittext: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut _einittext: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __start_ro_after_init: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __end_ro_after_init: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut _end: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __per_cpu_start: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __per_cpu_end: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __kprobes_text_start: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __kprobes_text_end: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __entry_text_start: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __entry_text_end: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __start_rodata: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __end_rodata: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __irqentry_text_start: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __irqentry_text_end: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __softirqentry_text_start: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __softirqentry_text_end: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __start_once: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __end_once: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __ctors_start: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __ctors_end: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __start_opd: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __end_opd: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __noinstr_text_start: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __noinstr_text_end: [ffi::c_char; 0usize];
}
extern "C" {
    pub static __nosave_begin: ffi::c_void;
}
extern "C" {
    pub static __nosave_end: ffi::c_void;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct func_desc_t {
    pub addr: ffi::c_ulong,
}
extern "C" {
    pub static mut __alt_instructions: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __alt_instructions_end: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __hibernate_exit_text_start: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __hibernate_exit_text_end: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __hyp_idmap_text_start: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __hyp_idmap_text_end: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __hyp_text_start: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __hyp_text_end: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __hyp_rodata_start: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __hyp_rodata_end: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __hyp_reloc_begin: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __hyp_reloc_end: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __hyp_bss_start: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __hyp_bss_end: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __idmap_text_start: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __idmap_text_end: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __initdata_begin: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __initdata_end: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __inittext_begin: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __inittext_end: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __exittext_begin: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __exittext_end: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __mmuoff_data_start: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __mmuoff_data_end: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __entry_tramp_text_start: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __entry_tramp_text_end: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __relocate_new_kernel_start: [ffi::c_char; 0usize];
}
extern "C" {
    pub static mut __relocate_new_kernel_end: [ffi::c_char; 0usize];
}
extern "C" {
    pub fn __field_overflow();
}
extern "C" {
    pub fn __bad_mask();
}
extern "C" {
    pub static mut memstart_addr: s64;
}
extern "C" {
    pub static mut kimage_voffset: u64_;
}
extern "C" {
    pub fn kaslr_init();
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pfn_t {
    pub val: u64_,
}
extern "C" {
    pub fn dump_mem_limit();
}
extern "C" {
    #[link_name = "\u{1}sp"]
    pub static mut current_stack_pointer: ffi::c_ulong;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct thread_info {
    pub flags: ffi::c_ulong,
    pub ttbr0: u64_,
    pub __bindgen_anon_1: thread_info__bindgen_ty_1,
    pub cpu: u32_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union thread_info__bindgen_ty_1 {
    pub preempt_count: u64_,
    pub preempt: thread_info__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct thread_info__bindgen_ty_1__bindgen_ty_1 {
    pub count: u32_,
    pub need_resched: u32_,
}
impl Default for thread_info__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for thread_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn arch_setup_new_exec();
}
extern "C" {
    pub fn arch_task_cache_init();
}
extern "C" {
    pub fn arch_release_task_struct(tsk: *mut task_struct);
}
extern "C" {
    pub fn arch_dup_task_struct(dst: *mut task_struct, src: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn preempt_schedule();
}
extern "C" {
    pub fn preempt_schedule_notrace();
}
extern "C" {
    pub static mut sk_dynamic_irqentry_exit_cond_resched: static_key_true;
}
extern "C" {
    pub fn dynamic_preempt_schedule();
}
extern "C" {
    pub fn dynamic_preempt_schedule_notrace();
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct preempt_ops {
    pub sched_in: ::core::option::Option<
        unsafe extern "C" fn(notifier: *mut preempt_notifier, cpu: ffi::c_int),
    >,
    pub sched_out: ::core::option::Option<
        unsafe extern "C" fn(notifier: *mut preempt_notifier, next: *mut task_struct),
    >,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct preempt_notifier {
    pub link: hlist_node,
    pub ops: *mut preempt_ops,
}
impl Default for preempt_notifier {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn preempt_notifier_inc();
}
extern "C" {
    pub fn preempt_notifier_dec();
}
extern "C" {
    pub fn preempt_notifier_register(notifier: *mut preempt_notifier);
}
extern "C" {
    pub fn preempt_notifier_unregister(notifier: *mut preempt_notifier);
}
extern "C" {
    pub fn migrate_disable();
}
extern "C" {
    pub fn migrate_enable();
}
pub const class_preempt_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_preempt_t {
    pub lock: *mut ffi::c_void,
}
impl Default for class_preempt_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const class_preempt_notrace_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_preempt_notrace_t {
    pub lock: *mut ffi::c_void,
}
impl Default for class_preempt_notrace_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const class_migrate_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_migrate_t {
    pub lock: *mut ffi::c_void,
}
impl Default for class_migrate_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn preempt_model_none() -> bool_;
}
extern "C" {
    pub fn preempt_model_voluntary() -> bool_;
}
extern "C" {
    pub fn preempt_model_full() -> bool_;
}
extern "C" {
    pub fn preempt_model_lazy() -> bool_;
}
extern "C" {
    pub fn preempt_model_str() -> *const ffi::c_char;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct midr_range {
    pub model: u32_,
    pub rv_min: u32_,
    pub rv_max: u32_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct target_impl_cpu {
    pub midr: u64_,
    pub revidr: u64_,
    pub aidr: u64_,
}
extern "C" {
    pub fn cpu_errata_set_target_impl(num: u64_, impl_cpus: *mut ffi::c_void) -> bool_;
}
extern "C" {
    pub fn is_midr_in_range_list(ranges: *const midr_range) -> bool_;
}
extern "C" {
    pub static mut compat_elf_hwcap: ffi::c_uint;
}
extern "C" {
    pub static mut compat_elf_hwcap2: ffi::c_uint;
}
extern "C" {
    pub static mut compat_elf_hwcap3: ffi::c_uint;
}
pub const CAP_HWCAP: _bindgen_ty_4 = 1;
pub const CAP_COMPAT_HWCAP: _bindgen_ty_4 = 2;
pub const CAP_COMPAT_HWCAP2: _bindgen_ty_4 = 3;
pub type _bindgen_ty_4 = ffi::c_uint;
extern "C" {
    pub static hex_asc: [ffi::c_char; 0usize];
}
extern "C" {
    pub static hex_asc_upper: [ffi::c_char; 0usize];
}
extern "C" {
    pub fn hex_to_bin(ch: ffi::c_uchar) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn hex2bin(dst: *mut u8_, src: *const ffi::c_char, count: usize) -> ffi::c_int;
}
extern "C" {
    pub fn bin2hex(
        dst: *mut ffi::c_char,
        src: *const ffi::c_void,
        count: usize,
    ) -> *mut ffi::c_char;
}
extern "C" {
    pub fn mac_pton(s: *const ffi::c_char, mac: *mut u8_) -> bool_;
}
extern "C" {
    #[must_use]
    pub fn _kstrtoul(
        s: *const ffi::c_char,
        base: ffi::c_uint,
        res: *mut ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn _kstrtol(s: *const ffi::c_char, base: ffi::c_uint, res: *mut ffi::c_long) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn kstrtoull(
        s: *const ffi::c_char,
        base: ffi::c_uint,
        res: *mut ffi::c_ulonglong,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn kstrtoll(
        s: *const ffi::c_char,
        base: ffi::c_uint,
        res: *mut ffi::c_longlong,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn kstrtouint(
        s: *const ffi::c_char,
        base: ffi::c_uint,
        res: *mut ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn kstrtoint(s: *const ffi::c_char, base: ffi::c_uint, res: *mut ffi::c_int) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn kstrtou16(s: *const ffi::c_char, base: ffi::c_uint, res: *mut u16_) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn kstrtos16(s: *const ffi::c_char, base: ffi::c_uint, res: *mut s16) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn kstrtou8(s: *const ffi::c_char, base: ffi::c_uint, res: *mut u8_) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn kstrtos8(s: *const ffi::c_char, base: ffi::c_uint, res: *mut s8) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn kstrtobool(s: *const ffi::c_char, res: *mut bool_) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn kstrtoull_from_user(
        s: *const ffi::c_char,
        count: usize,
        base: ffi::c_uint,
        res: *mut ffi::c_ulonglong,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn kstrtoll_from_user(
        s: *const ffi::c_char,
        count: usize,
        base: ffi::c_uint,
        res: *mut ffi::c_longlong,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn kstrtoul_from_user(
        s: *const ffi::c_char,
        count: usize,
        base: ffi::c_uint,
        res: *mut ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn kstrtol_from_user(
        s: *const ffi::c_char,
        count: usize,
        base: ffi::c_uint,
        res: *mut ffi::c_long,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn kstrtouint_from_user(
        s: *const ffi::c_char,
        count: usize,
        base: ffi::c_uint,
        res: *mut ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn kstrtoint_from_user(
        s: *const ffi::c_char,
        count: usize,
        base: ffi::c_uint,
        res: *mut ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn kstrtou16_from_user(
        s: *const ffi::c_char,
        count: usize,
        base: ffi::c_uint,
        res: *mut u16_,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn kstrtos16_from_user(
        s: *const ffi::c_char,
        count: usize,
        base: ffi::c_uint,
        res: *mut s16,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn kstrtou8_from_user(
        s: *const ffi::c_char,
        count: usize,
        base: ffi::c_uint,
        res: *mut u8_,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn kstrtos8_from_user(
        s: *const ffi::c_char,
        count: usize,
        base: ffi::c_uint,
        res: *mut s8,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn kstrtobool_from_user(s: *const ffi::c_char, count: usize, res: *mut bool_)
        -> ffi::c_int;
}
extern "C" {
    pub fn simple_strtoul(
        arg1: *const ffi::c_char,
        arg2: *mut *mut ffi::c_char,
        arg3: ffi::c_uint,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn simple_strntoul(
        arg1: *const ffi::c_char,
        arg2: *mut *mut ffi::c_char,
        arg3: ffi::c_uint,
        arg4: usize,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn simple_strtol(
        arg1: *const ffi::c_char,
        arg2: *mut *mut ffi::c_char,
        arg3: ffi::c_uint,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn simple_strtoull(
        arg1: *const ffi::c_char,
        arg2: *mut *mut ffi::c_char,
        arg3: ffi::c_uint,
    ) -> ffi::c_ulonglong;
}
extern "C" {
    pub fn simple_strtoll(
        arg1: *const ffi::c_char,
        arg2: *mut *mut ffi::c_char,
        arg3: ffi::c_uint,
    ) -> ffi::c_longlong;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct s8_fract {
    pub numerator: __s8,
    pub denominator: __s8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct u8_fract {
    pub numerator: __u8,
    pub denominator: __u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct s16_fract {
    pub numerator: __s16,
    pub denominator: __s16,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct u16_fract {
    pub numerator: __u16,
    pub denominator: __u16,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct s32_fract {
    pub numerator: __s32,
    pub denominator: __s32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct u32_fract {
    pub numerator: __u32,
    pub denominator: __u32,
}
extern "C" {
    pub fn int_pow(base: u64_, exp: ffi::c_uint) -> u64_;
}
extern "C" {
    pub fn int_sqrt(arg1: ffi::c_ulong) -> ffi::c_ulong;
}
extern "C" {
    pub fn num_to_str(
        buf: *mut ffi::c_char,
        size: ffi::c_int,
        num: ffi::c_ulonglong,
        width: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sprintf(buf: *mut ffi::c_char, fmt: *const ffi::c_char, ...) -> ffi::c_int;
}
extern "C" {
    pub fn vsprintf(buf: *mut ffi::c_char, arg1: *const ffi::c_char, arg2: va_list) -> ffi::c_int;
}
extern "C" {
    pub fn snprintf(buf: *mut ffi::c_char, size: usize, fmt: *const ffi::c_char, ...)
        -> ffi::c_int;
}
extern "C" {
    pub fn vsnprintf(
        buf: *mut ffi::c_char,
        size: usize,
        fmt: *const ffi::c_char,
        args: va_list,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn scnprintf(
        buf: *mut ffi::c_char,
        size: usize,
        fmt: *const ffi::c_char,
        ...
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vscnprintf(
        buf: *mut ffi::c_char,
        size: usize,
        fmt: *const ffi::c_char,
        args: va_list,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kasprintf(gfp: gfp_t, fmt: *const ffi::c_char, ...) -> *mut ffi::c_char;
}
extern "C" {
    pub fn kvasprintf(gfp: gfp_t, fmt: *const ffi::c_char, args: va_list) -> *mut ffi::c_char;
}
extern "C" {
    pub fn kvasprintf_const(
        gfp: gfp_t,
        fmt: *const ffi::c_char,
        args: va_list,
    ) -> *const ffi::c_char;
}
extern "C" {
    pub fn sscanf(arg1: *const ffi::c_char, arg2: *const ffi::c_char, ...) -> ffi::c_int;
}
extern "C" {
    pub fn vsscanf(arg1: *const ffi::c_char, arg2: *const ffi::c_char, arg3: va_list)
        -> ffi::c_int;
}
extern "C" {
    pub static mut no_hash_pointers: bool_;
}
extern "C" {
    pub fn no_hash_pointers_enable(str_: *mut ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub fn rust_fmt_argument(
        buf: *mut ffi::c_char,
        end: *mut ffi::c_char,
        ptr: *const ffi::c_void,
    ) -> *mut ffi::c_char;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct static_call_site {
    pub addr: s32,
    pub key: s32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct static_call_key {
    pub func: *mut ffi::c_void,
}
impl Default for static_call_key {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct user {
    _unused: [u8; 0],
}
extern "C" {
    pub fn dynamic_might_resched() -> ffi::c_int;
}
extern "C" {
    pub fn do_exit(error_code: ffi::c_long) -> !;
}
extern "C" {
    pub fn core_kernel_text(addr: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn __kernel_text_address(addr: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn kernel_text_address(addr: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn func_ptr_is_kernel_text(ptr: *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn bust_spinlocks(yes: ffi::c_int);
}
extern "C" {
    pub static mut root_mountflags: ffi::c_int;
}
extern "C" {
    pub static mut early_boot_irqs_disabled: bool_;
}
pub const system_states_SYSTEM_BOOTING: system_states = 0;
pub const system_states_SYSTEM_SCHEDULING: system_states = 1;
pub const system_states_SYSTEM_FREEING_INITMEM: system_states = 2;
pub const system_states_SYSTEM_RUNNING: system_states = 3;
pub const system_states_SYSTEM_HALT: system_states = 4;
pub const system_states_SYSTEM_POWER_OFF: system_states = 5;
pub const system_states_SYSTEM_RESTART: system_states = 6;
pub const system_states_SYSTEM_SUSPEND: system_states = 7;
pub type system_states = ffi::c_uint;
extern "C" {
    pub static mut system_state: system_states;
}
pub const ftrace_dump_mode_DUMP_NONE: ftrace_dump_mode = 0;
pub const ftrace_dump_mode_DUMP_ALL: ftrace_dump_mode = 1;
pub const ftrace_dump_mode_DUMP_ORIG: ftrace_dump_mode = 2;
pub const ftrace_dump_mode_DUMP_PARAM: ftrace_dump_mode = 3;
pub type ftrace_dump_mode = ffi::c_uint;
extern "C" {
    pub fn tracing_on();
}
extern "C" {
    pub fn tracing_off();
}
extern "C" {
    pub fn tracing_is_on() -> ffi::c_int;
}
extern "C" {
    pub fn tracing_snapshot();
}
extern "C" {
    pub fn tracing_snapshot_alloc();
}
extern "C" {
    pub fn tracing_start();
}
extern "C" {
    pub fn tracing_stop();
}
extern "C" {
    pub fn __trace_bprintk(ip: ffi::c_ulong, fmt: *const ffi::c_char, ...) -> ffi::c_int;
}
extern "C" {
    pub fn __trace_printk(ip: ffi::c_ulong, fmt: *const ffi::c_char, ...) -> ffi::c_int;
}
extern "C" {
    pub fn __trace_bputs(ip: ffi::c_ulong, str_: *const ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub fn __trace_puts(ip: ffi::c_ulong, str_: *const ffi::c_char, size: ffi::c_int)
        -> ffi::c_int;
}
extern "C" {
    pub fn trace_dump_stack(skip: ffi::c_int);
}
extern "C" {
    pub fn __ftrace_vbprintk(ip: ffi::c_ulong, fmt: *const ffi::c_char, ap: va_list) -> ffi::c_int;
}
extern "C" {
    pub fn __ftrace_vprintk(ip: ffi::c_ulong, fmt: *const ffi::c_char, ap: va_list) -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_dump(oops_dump_mode: ftrace_dump_mode);
}
extern "C" {
    pub fn _find_next_bit(
        addr1: *const ffi::c_ulong,
        nbits: ffi::c_ulong,
        start: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn _find_next_and_bit(
        addr1: *const ffi::c_ulong,
        addr2: *const ffi::c_ulong,
        nbits: ffi::c_ulong,
        start: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn _find_next_andnot_bit(
        addr1: *const ffi::c_ulong,
        addr2: *const ffi::c_ulong,
        nbits: ffi::c_ulong,
        start: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn _find_next_or_bit(
        addr1: *const ffi::c_ulong,
        addr2: *const ffi::c_ulong,
        nbits: ffi::c_ulong,
        start: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn _find_next_zero_bit(
        addr: *const ffi::c_ulong,
        nbits: ffi::c_ulong,
        start: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn _find_first_bit(addr: *const ffi::c_ulong, size: ffi::c_ulong) -> ffi::c_ulong;
}
extern "C" {
    pub fn __find_nth_bit(
        addr: *const ffi::c_ulong,
        size: ffi::c_ulong,
        n: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn __find_nth_and_bit(
        addr1: *const ffi::c_ulong,
        addr2: *const ffi::c_ulong,
        size: ffi::c_ulong,
        n: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn __find_nth_andnot_bit(
        addr1: *const ffi::c_ulong,
        addr2: *const ffi::c_ulong,
        size: ffi::c_ulong,
        n: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn __find_nth_and_andnot_bit(
        addr1: *const ffi::c_ulong,
        addr2: *const ffi::c_ulong,
        addr3: *const ffi::c_ulong,
        size: ffi::c_ulong,
        n: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn _find_first_and_bit(
        addr1: *const ffi::c_ulong,
        addr2: *const ffi::c_ulong,
        size: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn _find_first_and_and_bit(
        addr1: *const ffi::c_ulong,
        addr2: *const ffi::c_ulong,
        addr3: *const ffi::c_ulong,
        size: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn _find_first_zero_bit(addr: *const ffi::c_ulong, size: ffi::c_ulong) -> ffi::c_ulong;
}
extern "C" {
    pub fn _find_last_bit(addr: *const ffi::c_ulong, size: ffi::c_ulong) -> ffi::c_ulong;
}
extern "C" {
    pub fn find_next_clump8(
        clump: *mut ffi::c_ulong,
        addr: *const ffi::c_ulong,
        size: ffi::c_ulong,
        offset: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn strndup_user(arg1: *const ffi::c_char, arg2: ffi::c_long) -> *mut ffi::c_char;
}
extern "C" {
    pub fn memdup_user(arg1: *const ffi::c_void, arg2: usize) -> *mut ffi::c_void;
}
extern "C" {
    pub fn vmemdup_user(arg1: *const ffi::c_void, arg2: usize) -> *mut ffi::c_void;
}
extern "C" {
    pub fn memdup_user_nul(arg1: *const ffi::c_void, arg2: usize) -> *mut ffi::c_void;
}
extern "C" {
    pub fn strrchr(arg1: *const ffi::c_char, c: ffi::c_int) -> *mut ffi::c_char;
}
extern "C" {
    pub fn strchr(arg1: *const ffi::c_char, c: ffi::c_int) -> *mut ffi::c_char;
}
extern "C" {
    pub fn strcmp(arg1: *const ffi::c_char, arg2: *const ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub fn strncmp(
        arg1: *const ffi::c_char,
        arg2: *const ffi::c_char,
        arg3: __kernel_size_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn strlen(arg1: *const ffi::c_char) -> __kernel_size_t;
}
extern "C" {
    pub fn strnlen(arg1: *const ffi::c_char, arg2: __kernel_size_t) -> __kernel_size_t;
}
extern "C" {
    pub fn memcmp(arg1: *const ffi::c_void, arg2: *const ffi::c_void, arg3: usize) -> ffi::c_int;
}
extern "C" {
    pub fn memchr(
        arg1: *const ffi::c_void,
        arg2: ffi::c_int,
        arg3: __kernel_size_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn memcpy(
        arg1: *mut ffi::c_void,
        arg2: *const ffi::c_void,
        arg3: __kernel_size_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn __memcpy(
        arg1: *mut ffi::c_void,
        arg2: *const ffi::c_void,
        arg3: __kernel_size_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn memmove(
        arg1: *mut ffi::c_void,
        arg2: *const ffi::c_void,
        arg3: __kernel_size_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn __memmove(
        arg1: *mut ffi::c_void,
        arg2: *const ffi::c_void,
        arg3: __kernel_size_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn memset(
        arg1: *mut ffi::c_void,
        arg2: ffi::c_int,
        arg3: __kernel_size_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn __memset(
        arg1: *mut ffi::c_void,
        arg2: ffi::c_int,
        arg3: __kernel_size_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn memcpy_flushcache(dst: *mut ffi::c_void, src: *const ffi::c_void, cnt: usize);
}
extern "C" {
    pub fn strcpy(arg1: *mut ffi::c_char, arg2: *const ffi::c_char) -> *mut ffi::c_char;
}
extern "C" {
    pub fn strncpy(
        arg1: *mut ffi::c_char,
        arg2: *const ffi::c_char,
        arg3: __kernel_size_t,
    ) -> *mut ffi::c_char;
}
extern "C" {
    pub fn sized_strscpy(arg1: *mut ffi::c_char, arg2: *const ffi::c_char, arg3: usize) -> isize;
}
extern "C" {
    pub fn strcat(arg1: *mut ffi::c_char, arg2: *const ffi::c_char) -> *mut ffi::c_char;
}
extern "C" {
    pub fn strncat(
        arg1: *mut ffi::c_char,
        arg2: *const ffi::c_char,
        arg3: __kernel_size_t,
    ) -> *mut ffi::c_char;
}
extern "C" {
    pub fn strlcat(
        arg1: *mut ffi::c_char,
        arg2: *const ffi::c_char,
        arg3: __kernel_size_t,
    ) -> usize;
}
extern "C" {
    pub fn strcasecmp(s1: *const ffi::c_char, s2: *const ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub fn strncasecmp(s1: *const ffi::c_char, s2: *const ffi::c_char, n: usize) -> ffi::c_int;
}
extern "C" {
    pub fn strchrnul(arg1: *const ffi::c_char, arg2: ffi::c_int) -> *mut ffi::c_char;
}
extern "C" {
    pub fn strnchrnul(arg1: *const ffi::c_char, arg2: usize, arg3: ffi::c_int) -> *mut ffi::c_char;
}
extern "C" {
    pub fn strnchr(arg1: *const ffi::c_char, arg2: usize, arg3: ffi::c_int) -> *mut ffi::c_char;
}
extern "C" {
    #[must_use]
    pub fn skip_spaces(arg1: *const ffi::c_char) -> *mut ffi::c_char;
}
extern "C" {
    pub fn strim(arg1: *mut ffi::c_char) -> *mut ffi::c_char;
}
extern "C" {
    pub fn strstr(arg1: *const ffi::c_char, arg2: *const ffi::c_char) -> *mut ffi::c_char;
}
extern "C" {
    pub fn strnstr(
        arg1: *const ffi::c_char,
        arg2: *const ffi::c_char,
        arg3: usize,
    ) -> *mut ffi::c_char;
}
extern "C" {
    pub fn strpbrk(arg1: *const ffi::c_char, arg2: *const ffi::c_char) -> *mut ffi::c_char;
}
extern "C" {
    pub fn strsep(arg1: *mut *mut ffi::c_char, arg2: *const ffi::c_char) -> *mut ffi::c_char;
}
extern "C" {
    pub fn strspn(arg1: *const ffi::c_char, arg2: *const ffi::c_char) -> __kernel_size_t;
}
extern "C" {
    pub fn strcspn(arg1: *const ffi::c_char, arg2: *const ffi::c_char) -> __kernel_size_t;
}
extern "C" {
    pub fn memset16(arg1: *mut u16, arg2: u16, arg3: __kernel_size_t) -> *mut ffi::c_void;
}
extern "C" {
    pub fn memset32(arg1: *mut u32, arg2: u32, arg3: __kernel_size_t) -> *mut ffi::c_void;
}
extern "C" {
    pub fn memset64(arg1: *mut u64, arg2: u64, arg3: __kernel_size_t) -> *mut ffi::c_void;
}
extern "C" {
    pub fn __memcat_p(a: *mut *mut ffi::c_void, b: *mut *mut ffi::c_void) -> *mut *mut ffi::c_void;
}
extern "C" {
    pub fn memscan(
        arg1: *mut ffi::c_void,
        arg2: ffi::c_int,
        arg3: __kernel_size_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn bcmp(
        arg1: *const ffi::c_void,
        arg2: *const ffi::c_void,
        arg3: __kernel_size_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn memchr_inv(s: *const ffi::c_void, c: ffi::c_int, n: usize) -> *mut ffi::c_void;
}
extern "C" {
    pub fn strreplace(
        str_: *mut ffi::c_char,
        old: ffi::c_char,
        new: ffi::c_char,
    ) -> *mut ffi::c_char;
}
extern "C" {
    pub fn kfree_const(x: *const ffi::c_void);
}
extern "C" {
    pub fn kstrdup(s: *const ffi::c_char, gfp: gfp_t) -> *mut ffi::c_char;
}
extern "C" {
    pub fn kstrdup_const(s: *const ffi::c_char, gfp: gfp_t) -> *const ffi::c_char;
}
extern "C" {
    pub fn kstrndup(s: *const ffi::c_char, len: usize, gfp: gfp_t) -> *mut ffi::c_char;
}
extern "C" {
    pub fn kmemdup_noprof(src: *const ffi::c_void, len: usize, gfp: gfp_t) -> *mut ffi::c_void;
}
extern "C" {
    pub fn kvmemdup(src: *const ffi::c_void, len: usize, gfp: gfp_t) -> *mut ffi::c_void;
}
extern "C" {
    pub fn kmemdup_nul(s: *const ffi::c_char, len: usize, gfp: gfp_t) -> *mut ffi::c_char;
}
extern "C" {
    pub fn kmemdup_array(
        src: *const ffi::c_void,
        count: usize,
        element_size: usize,
        gfp: gfp_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn argv_split(
        gfp: gfp_t,
        str_: *const ffi::c_char,
        argcp: *mut ffi::c_int,
    ) -> *mut *mut ffi::c_char;
}
extern "C" {
    pub fn argv_free(argv: *mut *mut ffi::c_char);
}
extern "C" {
    pub fn get_option(str_: *mut *mut ffi::c_char, pint: *mut ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn get_options(
        str_: *const ffi::c_char,
        nints: ffi::c_int,
        ints: *mut ffi::c_int,
    ) -> *mut ffi::c_char;
}
extern "C" {
    pub fn memparse(ptr: *const ffi::c_char, retptr: *mut *mut ffi::c_char) -> ffi::c_ulonglong;
}
extern "C" {
    pub fn parse_option_str(str_: *const ffi::c_char, option: *const ffi::c_char) -> bool_;
}
extern "C" {
    pub fn next_arg(
        args: *mut ffi::c_char,
        param: *mut *mut ffi::c_char,
        val: *mut *mut ffi::c_char,
    ) -> *mut ffi::c_char;
}
extern "C" {
    pub fn sysfs_streq(s1: *const ffi::c_char, s2: *const ffi::c_char) -> bool_;
}
extern "C" {
    pub fn match_string(
        array: *const *const ffi::c_char,
        n: usize,
        string: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __sysfs_match_string(
        array: *const *const ffi::c_char,
        n: usize,
        s: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vbin_printf(
        bin_buf: *mut u32_,
        size: usize,
        fmt: *const ffi::c_char,
        args: va_list,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bstr_printf(
        buf: *mut ffi::c_char,
        size: usize,
        fmt: *const ffi::c_char,
        bin_buf: *const u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn memory_read_from_buffer(
        to: *mut ffi::c_void,
        count: usize,
        ppos: *mut loff_t,
        from: *const ffi::c_void,
        available: usize,
    ) -> isize;
}
extern "C" {
    pub fn ptr_to_hashval(ptr: *const ffi::c_void, hashval_out: *mut ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn memweight(ptr: *const ffi::c_void, bytes: usize) -> usize;
}
pub const fortify_func_FORTIFY_FUNC_strncpy: fortify_func = 0;
pub const fortify_func_FORTIFY_FUNC_strnlen: fortify_func = 1;
pub const fortify_func_FORTIFY_FUNC_strlen: fortify_func = 2;
pub const fortify_func_FORTIFY_FUNC_strscpy: fortify_func = 3;
pub const fortify_func_FORTIFY_FUNC_strlcat: fortify_func = 4;
pub const fortify_func_FORTIFY_FUNC_strcat: fortify_func = 5;
pub const fortify_func_FORTIFY_FUNC_strncat: fortify_func = 6;
pub const fortify_func_FORTIFY_FUNC_memset: fortify_func = 7;
pub const fortify_func_FORTIFY_FUNC_memcpy: fortify_func = 8;
pub const fortify_func_FORTIFY_FUNC_memmove: fortify_func = 9;
pub const fortify_func_FORTIFY_FUNC_memscan: fortify_func = 10;
pub const fortify_func_FORTIFY_FUNC_memcmp: fortify_func = 11;
pub const fortify_func_FORTIFY_FUNC_memchr: fortify_func = 12;
pub const fortify_func_FORTIFY_FUNC_memchr_inv: fortify_func = 13;
pub const fortify_func_FORTIFY_FUNC_kmemdup: fortify_func = 14;
pub const fortify_func_FORTIFY_FUNC_strcpy: fortify_func = 15;
pub const fortify_func_FORTIFY_FUNC_UNKNOWN: fortify_func = 16;
pub type fortify_func = ffi::c_uint;
extern "C" {
    pub fn __fortify_report(reason: u8_, avail: usize, size: usize);
}
extern "C" {
    pub fn __fortify_panic(reason: u8_, avail: usize, size: usize) -> !;
}
extern "C" {
    pub fn __read_overflow();
}
extern "C" {
    pub fn __read_overflow2();
}
extern "C" {
    pub fn __read_overflow2_field(avail: usize, wanted: usize);
}
extern "C" {
    pub fn __write_overflow();
}
extern "C" {
    pub fn __write_overflow_field(avail: usize, wanted: usize);
}
extern "C" {
    pub fn memcpy_and_pad(
        dest: *mut ffi::c_void,
        dest_len: usize,
        src: *const ffi::c_void,
        count: usize,
        pad: ffi::c_int,
    );
}
extern "C" {
    pub fn bitmap_parse_user(
        ubuf: *const ffi::c_char,
        ulen: ffi::c_uint,
        dst: *mut ffi::c_ulong,
        nbits: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bitmap_print_to_pagebuf(
        list: bool_,
        buf: *mut ffi::c_char,
        maskp: *const ffi::c_ulong,
        nmaskbits: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bitmap_print_bitmask_to_buf(
        buf: *mut ffi::c_char,
        maskp: *const ffi::c_ulong,
        nmaskbits: ffi::c_int,
        off: loff_t,
        count: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bitmap_print_list_to_buf(
        buf: *mut ffi::c_char,
        maskp: *const ffi::c_ulong,
        nmaskbits: ffi::c_int,
        off: loff_t,
        count: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bitmap_parse(
        buf: *const ffi::c_char,
        buflen: ffi::c_uint,
        dst: *mut ffi::c_ulong,
        nbits: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bitmap_parselist(
        buf: *const ffi::c_char,
        maskp: *mut ffi::c_ulong,
        nmaskbits: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bitmap_parselist_user(
        ubuf: *const ffi::c_char,
        ulen: ffi::c_uint,
        dst: *mut ffi::c_ulong,
        nbits: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bitmap_alloc(nbits: ffi::c_uint, flags: gfp_t) -> *mut ffi::c_ulong;
}
extern "C" {
    pub fn bitmap_zalloc(nbits: ffi::c_uint, flags: gfp_t) -> *mut ffi::c_ulong;
}
extern "C" {
    pub fn bitmap_alloc_node(
        nbits: ffi::c_uint,
        flags: gfp_t,
        node: ffi::c_int,
    ) -> *mut ffi::c_ulong;
}
extern "C" {
    pub fn bitmap_zalloc_node(
        nbits: ffi::c_uint,
        flags: gfp_t,
        node: ffi::c_int,
    ) -> *mut ffi::c_ulong;
}
extern "C" {
    pub fn bitmap_free(bitmap: *const ffi::c_ulong);
}
extern "C" {
    pub fn devm_bitmap_alloc(
        dev: *mut device,
        nbits: ffi::c_uint,
        flags: gfp_t,
    ) -> *mut ffi::c_ulong;
}
extern "C" {
    pub fn devm_bitmap_zalloc(
        dev: *mut device,
        nbits: ffi::c_uint,
        flags: gfp_t,
    ) -> *mut ffi::c_ulong;
}
extern "C" {
    pub fn __bitmap_equal(
        bitmap1: *const ffi::c_ulong,
        bitmap2: *const ffi::c_ulong,
        nbits: ffi::c_uint,
    ) -> bool_;
}
extern "C" {
    pub fn __bitmap_or_equal(
        src1: *const ffi::c_ulong,
        src2: *const ffi::c_ulong,
        src3: *const ffi::c_ulong,
        nbits: ffi::c_uint,
    ) -> bool_;
}
extern "C" {
    pub fn __bitmap_complement(
        dst: *mut ffi::c_ulong,
        src: *const ffi::c_ulong,
        nbits: ffi::c_uint,
    );
}
extern "C" {
    pub fn __bitmap_shift_right(
        dst: *mut ffi::c_ulong,
        src: *const ffi::c_ulong,
        shift: ffi::c_uint,
        nbits: ffi::c_uint,
    );
}
extern "C" {
    pub fn __bitmap_shift_left(
        dst: *mut ffi::c_ulong,
        src: *const ffi::c_ulong,
        shift: ffi::c_uint,
        nbits: ffi::c_uint,
    );
}
extern "C" {
    pub fn bitmap_cut(
        dst: *mut ffi::c_ulong,
        src: *const ffi::c_ulong,
        first: ffi::c_uint,
        cut: ffi::c_uint,
        nbits: ffi::c_uint,
    );
}
extern "C" {
    pub fn __bitmap_and(
        dst: *mut ffi::c_ulong,
        bitmap1: *const ffi::c_ulong,
        bitmap2: *const ffi::c_ulong,
        nbits: ffi::c_uint,
    ) -> bool_;
}
extern "C" {
    pub fn __bitmap_or(
        dst: *mut ffi::c_ulong,
        bitmap1: *const ffi::c_ulong,
        bitmap2: *const ffi::c_ulong,
        nbits: ffi::c_uint,
    );
}
extern "C" {
    pub fn __bitmap_xor(
        dst: *mut ffi::c_ulong,
        bitmap1: *const ffi::c_ulong,
        bitmap2: *const ffi::c_ulong,
        nbits: ffi::c_uint,
    );
}
extern "C" {
    pub fn __bitmap_andnot(
        dst: *mut ffi::c_ulong,
        bitmap1: *const ffi::c_ulong,
        bitmap2: *const ffi::c_ulong,
        nbits: ffi::c_uint,
    ) -> bool_;
}
extern "C" {
    pub fn __bitmap_replace(
        dst: *mut ffi::c_ulong,
        old: *const ffi::c_ulong,
        new: *const ffi::c_ulong,
        mask: *const ffi::c_ulong,
        nbits: ffi::c_uint,
    );
}
extern "C" {
    pub fn __bitmap_intersects(
        bitmap1: *const ffi::c_ulong,
        bitmap2: *const ffi::c_ulong,
        nbits: ffi::c_uint,
    ) -> bool_;
}
extern "C" {
    pub fn __bitmap_subset(
        bitmap1: *const ffi::c_ulong,
        bitmap2: *const ffi::c_ulong,
        nbits: ffi::c_uint,
    ) -> bool_;
}
extern "C" {
    pub fn __bitmap_weight(bitmap: *const ffi::c_ulong, nbits: ffi::c_uint) -> ffi::c_uint;
}
extern "C" {
    pub fn __bitmap_weight_and(
        bitmap1: *const ffi::c_ulong,
        bitmap2: *const ffi::c_ulong,
        nbits: ffi::c_uint,
    ) -> ffi::c_uint;
}
extern "C" {
    pub fn __bitmap_weight_andnot(
        bitmap1: *const ffi::c_ulong,
        bitmap2: *const ffi::c_ulong,
        nbits: ffi::c_uint,
    ) -> ffi::c_uint;
}
extern "C" {
    pub fn __bitmap_set(map: *mut ffi::c_ulong, start: ffi::c_uint, len: ffi::c_int);
}
extern "C" {
    pub fn __bitmap_clear(map: *mut ffi::c_ulong, start: ffi::c_uint, len: ffi::c_int);
}
extern "C" {
    pub fn bitmap_find_next_zero_area_off(
        map: *mut ffi::c_ulong,
        size: ffi::c_ulong,
        start: ffi::c_ulong,
        nr: ffi::c_uint,
        align_mask: ffi::c_ulong,
        align_offset: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn bitmap_remap(
        dst: *mut ffi::c_ulong,
        src: *const ffi::c_ulong,
        old: *const ffi::c_ulong,
        new: *const ffi::c_ulong,
        nbits: ffi::c_uint,
    );
}
extern "C" {
    pub fn bitmap_bitremap(
        oldbit: ffi::c_int,
        old: *const ffi::c_ulong,
        new: *const ffi::c_ulong,
        bits: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bitmap_onto(
        dst: *mut ffi::c_ulong,
        orig: *const ffi::c_ulong,
        relmap: *const ffi::c_ulong,
        bits: ffi::c_uint,
    );
}
extern "C" {
    pub fn bitmap_fold(
        dst: *mut ffi::c_ulong,
        orig: *const ffi::c_ulong,
        sz: ffi::c_uint,
        nbits: ffi::c_uint,
    );
}
extern "C" {
    pub fn bitmap_from_arr32(bitmap: *mut ffi::c_ulong, buf: *const u32_, nbits: ffi::c_uint);
}
extern "C" {
    pub fn bitmap_to_arr32(buf: *mut u32_, bitmap: *const ffi::c_ulong, nbits: ffi::c_uint);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct cpumask {
    pub bits: [ffi::c_ulong; 64usize],
}
impl Default for cpumask {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type cpumask_t = cpumask;
pub type cpumask_var_t = *mut cpumask;
pub const ___GFP_DMA_BIT: _bindgen_ty_5 = 0;
pub const ___GFP_HIGHMEM_BIT: _bindgen_ty_5 = 1;
pub const ___GFP_DMA32_BIT: _bindgen_ty_5 = 2;
pub const ___GFP_MOVABLE_BIT: _bindgen_ty_5 = 3;
pub const ___GFP_RECLAIMABLE_BIT: _bindgen_ty_5 = 4;
pub const ___GFP_HIGH_BIT: _bindgen_ty_5 = 5;
pub const ___GFP_IO_BIT: _bindgen_ty_5 = 6;
pub const ___GFP_FS_BIT: _bindgen_ty_5 = 7;
pub const ___GFP_ZERO_BIT: _bindgen_ty_5 = 8;
pub const ___GFP_UNUSED_BIT: _bindgen_ty_5 = 9;
pub const ___GFP_DIRECT_RECLAIM_BIT: _bindgen_ty_5 = 10;
pub const ___GFP_KSWAPD_RECLAIM_BIT: _bindgen_ty_5 = 11;
pub const ___GFP_WRITE_BIT: _bindgen_ty_5 = 12;
pub const ___GFP_NOWARN_BIT: _bindgen_ty_5 = 13;
pub const ___GFP_RETRY_MAYFAIL_BIT: _bindgen_ty_5 = 14;
pub const ___GFP_NOFAIL_BIT: _bindgen_ty_5 = 15;
pub const ___GFP_NORETRY_BIT: _bindgen_ty_5 = 16;
pub const ___GFP_MEMALLOC_BIT: _bindgen_ty_5 = 17;
pub const ___GFP_COMP_BIT: _bindgen_ty_5 = 18;
pub const ___GFP_NOMEMALLOC_BIT: _bindgen_ty_5 = 19;
pub const ___GFP_HARDWALL_BIT: _bindgen_ty_5 = 20;
pub const ___GFP_THISNODE_BIT: _bindgen_ty_5 = 21;
pub const ___GFP_ACCOUNT_BIT: _bindgen_ty_5 = 22;
pub const ___GFP_ZEROTAGS_BIT: _bindgen_ty_5 = 23;
pub const ___GFP_NO_OBJ_EXT_BIT: _bindgen_ty_5 = 24;
pub const ___GFP_LAST_BIT: _bindgen_ty_5 = 25;
pub type _bindgen_ty_5 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct nodemask_t {
    pub bits: [ffi::c_ulong; 8usize],
}
extern "C" {
    pub static mut __invalid_size_argument_for_IOC: ffi::c_uint;
}
extern "C" {
    pub fn irq_get_nr_irqs() -> ffi::c_uint;
}
extern "C" {
    pub fn irq_set_nr_irqs(nr: ffi::c_uint) -> ffi::c_uint;
}
extern "C" {
    pub fn irq_to_desc(irq: ffi::c_uint) -> *mut irq_desc;
}
extern "C" {
    pub fn irq_get_next_irq(offset: ffi::c_uint) -> ffi::c_uint;
}
#[repr(C)]
#[derive(Default)]
pub struct rand_pool_info {
    pub entropy_count: ffi::c_int,
    pub buf_size: ffi::c_int,
    pub buf: __IncompleteArrayField<__u32>,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct vgetrandom_opaque_params {
    pub size_of_opaque_state: __u32,
    pub mmap_prot: __u32,
    pub mmap_flags: __u32,
    pub reserved: [__u32; 13usize],
}
extern "C" {
    pub fn add_device_randomness(buf: *const ffi::c_void, len: usize);
}
extern "C" {
    pub fn add_bootloader_randomness(buf: *const ffi::c_void, len: usize);
}
extern "C" {
    pub fn add_input_randomness(type_: ffi::c_uint, code: ffi::c_uint, value: ffi::c_uint);
}
extern "C" {
    pub fn add_interrupt_randomness(irq: ffi::c_int);
}
extern "C" {
    pub fn add_hwgenerator_randomness(
        buf: *const ffi::c_void,
        len: usize,
        entropy: usize,
        sleep_after: bool_,
    );
}
extern "C" {
    pub fn add_vmfork_randomness(unique_vm_id: *const ffi::c_void, len: usize);
}
extern "C" {
    pub fn register_random_vmfork_notifier(nb: *mut notifier_block) -> ffi::c_int;
}
extern "C" {
    pub fn unregister_random_vmfork_notifier(nb: *mut notifier_block) -> ffi::c_int;
}
extern "C" {
    pub fn get_random_bytes(buf: *mut ffi::c_void, len: usize);
}
extern "C" {
    pub fn get_random_u8() -> u8_;
}
extern "C" {
    pub fn get_random_u16() -> u16_;
}
extern "C" {
    pub fn get_random_u32() -> u32_;
}
extern "C" {
    pub fn get_random_u64() -> u64_;
}
extern "C" {
    pub fn __get_random_u32_below(ceil: u32_) -> u32_;
}
extern "C" {
    pub fn random_init_early(command_line: *const ffi::c_char);
}
extern "C" {
    pub fn random_init();
}
extern "C" {
    pub fn rng_is_initialized() -> bool_;
}
extern "C" {
    pub fn wait_for_random_bytes() -> ffi::c_int;
}
extern "C" {
    pub fn execute_with_initialized_rng(nb: *mut notifier_block) -> ffi::c_int;
}
extern "C" {
    pub fn random_prepare_cpu(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn random_online_cpu(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub static mut _unused_nodemask_arg_: nodemask_t;
}
pub const node_states_N_POSSIBLE: node_states = 0;
pub const node_states_N_ONLINE: node_states = 1;
pub const node_states_N_NORMAL_MEMORY: node_states = 2;
pub const node_states_N_HIGH_MEMORY: node_states = 2;
pub const node_states_N_MEMORY: node_states = 3;
pub const node_states_N_CPU: node_states = 4;
pub const node_states_N_GENERIC_INITIATOR: node_states = 5;
pub const node_states_NR_NODE_STATES: node_states = 6;
pub type node_states = ffi::c_uint;
extern "C" {
    pub static mut node_states: [nodemask_t; 6usize];
}
extern "C" {
    pub static mut nr_node_ids: ffi::c_uint;
}
extern "C" {
    pub static mut nr_online_nodes: ffi::c_uint;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct nodemask_scratch {
    pub mask1: nodemask_t,
    pub mask2: nodemask_t,
}
pub type pteval_t = u64_;
pub type pmdval_t = u64_;
pub type pudval_t = u64_;
pub type p4dval_t = u64_;
pub type pgdval_t = u64_;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pte_t {
    pub pte: pteval_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pmd_t {
    pub pmd: pmdval_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pud_t {
    pub pud: pudval_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pgd_t {
    pub pgd: pgdval_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pgprot_t {
    pub pgprot: pteval_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct p4d_t {
    pub pgd: pgd_t,
}
pub const arm_smccc_conduit_SMCCC_CONDUIT_NONE: arm_smccc_conduit = 0;
pub const arm_smccc_conduit_SMCCC_CONDUIT_SMC: arm_smccc_conduit = 1;
pub const arm_smccc_conduit_SMCCC_CONDUIT_HVC: arm_smccc_conduit = 2;
pub type arm_smccc_conduit = ffi::c_uint;
extern "C" {
    pub fn arm_smccc_1_1_get_conduit() -> arm_smccc_conduit;
}
extern "C" {
    pub fn arm_smccc_get_version() -> u32_;
}
extern "C" {
    pub fn arm_smccc_version_init(version: u32_, conduit: arm_smccc_conduit);
}
extern "C" {
    pub fn arm_smccc_get_soc_id_version() -> s32;
}
extern "C" {
    pub fn arm_smccc_get_soc_id_revision() -> s32;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct arm_smccc_res {
    pub a0: ffi::c_ulong,
    pub a1: ffi::c_ulong,
    pub a2: ffi::c_ulong,
    pub a3: ffi::c_ulong,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct arm_smccc_1_2_regs {
    pub a0: ffi::c_ulong,
    pub a1: ffi::c_ulong,
    pub a2: ffi::c_ulong,
    pub a3: ffi::c_ulong,
    pub a4: ffi::c_ulong,
    pub a5: ffi::c_ulong,
    pub a6: ffi::c_ulong,
    pub a7: ffi::c_ulong,
    pub a8: ffi::c_ulong,
    pub a9: ffi::c_ulong,
    pub a10: ffi::c_ulong,
    pub a11: ffi::c_ulong,
    pub a12: ffi::c_ulong,
    pub a13: ffi::c_ulong,
    pub a14: ffi::c_ulong,
    pub a15: ffi::c_ulong,
    pub a16: ffi::c_ulong,
    pub a17: ffi::c_ulong,
}
extern "C" {
    pub fn arm_smccc_1_2_hvc(args: *const arm_smccc_1_2_regs, res: *mut arm_smccc_1_2_regs);
}
extern "C" {
    pub fn arm_smccc_1_2_smc(args: *const arm_smccc_1_2_regs, res: *mut arm_smccc_1_2_regs);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct arm_smccc_quirk {
    pub id: ffi::c_int,
    pub state: arm_smccc_quirk__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union arm_smccc_quirk__bindgen_ty_1 {
    pub a6: ffi::c_ulong,
}
impl Default for arm_smccc_quirk__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for arm_smccc_quirk {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn __arm_smccc_smc(
        a0: ffi::c_ulong,
        a1: ffi::c_ulong,
        a2: ffi::c_ulong,
        a3: ffi::c_ulong,
        a4: ffi::c_ulong,
        a5: ffi::c_ulong,
        a6: ffi::c_ulong,
        a7: ffi::c_ulong,
        res: *mut arm_smccc_res,
        quirk: *mut arm_smccc_quirk,
    );
}
extern "C" {
    pub fn __arm_smccc_hvc(
        a0: ffi::c_ulong,
        a1: ffi::c_ulong,
        a2: ffi::c_ulong,
        a3: ffi::c_ulong,
        a4: ffi::c_ulong,
        a5: ffi::c_ulong,
        a6: ffi::c_ulong,
        a7: ffi::c_ulong,
        res: *mut arm_smccc_res,
        quirk: *mut arm_smccc_quirk,
    );
}
#[repr(C)]
#[repr(align(4096))]
#[derive(Copy, Clone)]
pub struct realm_config {
    pub __bindgen_anon_1: realm_config__bindgen_ty_1,
    pub __bindgen_anon_2: realm_config__bindgen_ty_2,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union realm_config__bindgen_ty_1 {
    pub __bindgen_anon_1: realm_config__bindgen_ty_1__bindgen_ty_1,
    pub pad: [u8_; 512usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct realm_config__bindgen_ty_1__bindgen_ty_1 {
    pub ipa_bits: ffi::c_ulong,
    pub hash_algo: ffi::c_ulong,
}
impl Default for realm_config__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union realm_config__bindgen_ty_2 {
    pub rpv: [u8_; 64usize],
    pub pad2: [u8_; 3584usize],
}
impl Default for realm_config__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for realm_config {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const ripas_RSI_RIPAS_EMPTY: ripas = 0;
pub const ripas_RSI_RIPAS_RAM: ripas = 1;
pub const ripas_RSI_RIPAS_DESTROYED: ripas = 2;
pub const ripas_RSI_RIPAS_DEV: ripas = 3;
pub type ripas = ffi::c_uint;
extern "C" {
    pub static mut rsi_present: static_key_false;
}
extern "C" {
    pub fn arm64_rsi_init();
}
extern "C" {
    pub fn __arm64_is_protected_mmio(base: phys_addr_t, size: usize) -> bool_;
}
extern "C" {
    pub static mut arm64_use_ng_mappings: bool_;
}
extern "C" {
    pub static mut prot_ns_shared: ffi::c_ulong;
}
extern "C" {
    pub static mut node_data: [*mut pglist_data; 0usize];
}
extern "C" {
    pub fn alloc_node_data(nid: ffi::c_int);
}
extern "C" {
    pub fn alloc_offline_node_data(nid: ffi::c_int);
}
extern "C" {
    pub fn numa_nearest_node(node: ffi::c_int, state: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn nearest_node_nodemask(node: ffi::c_int, mask: *mut nodemask_t) -> ffi::c_int;
}
extern "C" {
    pub fn memory_add_physaddr_to_nid(start: u64_) -> ffi::c_int;
}
extern "C" {
    pub fn phys_to_target_node(start: u64_) -> ffi::c_int;
}
extern "C" {
    pub fn numa_fill_memblks(start: u64_, end: u64_) -> ffi::c_int;
}
extern "C" {
    pub static mut nr_cpu_ids: ffi::c_uint;
}
extern "C" {
    pub static mut __cpu_possible_mask: cpumask;
}
extern "C" {
    pub static mut __cpu_online_mask: cpumask;
}
extern "C" {
    pub static mut __cpu_enabled_mask: cpumask;
}
extern "C" {
    pub static mut __cpu_present_mask: cpumask;
}
extern "C" {
    pub static mut __cpu_active_mask: cpumask;
}
extern "C" {
    pub static mut __cpu_dying_mask: cpumask;
}
extern "C" {
    pub static mut __num_online_cpus: atomic_t;
}
extern "C" {
    pub static mut cpus_booted_once_mask: cpumask_t;
}
extern "C" {
    pub fn cpumask_local_spread(i: ffi::c_uint, node: ffi::c_int) -> ffi::c_uint;
}
extern "C" {
    pub fn cpumask_any_and_distribute(src1p: *const cpumask, src2p: *const cpumask) -> ffi::c_uint;
}
extern "C" {
    pub fn cpumask_any_distribute(srcp: *const cpumask) -> ffi::c_uint;
}
extern "C" {
    pub fn alloc_cpumask_var_node(
        mask: *mut cpumask_var_t,
        flags: gfp_t,
        node: ffi::c_int,
    ) -> bool_;
}
extern "C" {
    pub fn alloc_bootmem_cpumask_var(mask: *mut cpumask_var_t);
}
extern "C" {
    pub fn free_cpumask_var(mask: cpumask_var_t);
}
extern "C" {
    pub fn free_bootmem_cpumask_var(mask: cpumask_var_t);
}
extern "C" {
    pub static cpu_all_bits: [ffi::c_ulong; 64usize];
}
extern "C" {
    pub fn init_cpu_present(src: *const cpumask);
}
extern "C" {
    pub fn init_cpu_possible(src: *const cpumask);
}
extern "C" {
    pub fn set_cpu_online(cpu: ffi::c_uint, online: bool_);
}
extern "C" {
    pub static mut cpu_bit_bitmap: [[ffi::c_ulong; 64usize]; 65usize];
}
pub const ftr_type_FTR_EXACT: ftr_type = 0;
pub const ftr_type_FTR_LOWER_SAFE: ftr_type = 1;
pub const ftr_type_FTR_HIGHER_SAFE: ftr_type = 2;
pub const ftr_type_FTR_HIGHER_OR_ZERO_SAFE: ftr_type = 3;
pub type ftr_type = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct arm64_ftr_bits {
    pub sign: bool_,
    pub visible: bool_,
    pub strict: bool_,
    pub type_: ftr_type,
    pub shift: u8_,
    pub width: u8_,
    pub safe_val: s64,
}
impl Default for arm64_ftr_bits {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct arm64_ftr_override {
    pub val: u64_,
    pub mask: u64_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct arm64_ftr_reg {
    pub name: *const ffi::c_char,
    pub strict_mask: u64_,
    pub user_mask: u64_,
    pub sys_val: u64_,
    pub user_val: u64_,
    pub override_: *mut arm64_ftr_override,
    pub ftr_bits: *const arm64_ftr_bits,
}
impl Default for arm64_ftr_reg {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut arm64_ftr_reg_ctrel0: arm64_ftr_reg;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct arm64_cpu_capabilities {
    pub desc: *const ffi::c_char,
    pub capability: u16_,
    pub type_: u16_,
    pub matches: ::core::option::Option<
        unsafe extern "C" fn(caps: *const arm64_cpu_capabilities, scope: ffi::c_int) -> bool_,
    >,
    pub cpu_enable:
        ::core::option::Option<unsafe extern "C" fn(cap: *const arm64_cpu_capabilities)>,
    pub __bindgen_anon_1: arm64_cpu_capabilities__bindgen_ty_1,
    pub match_list: *const arm64_cpu_capabilities,
    pub cpus: *const cpumask,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union arm64_cpu_capabilities__bindgen_ty_1 {
    pub __bindgen_anon_1: arm64_cpu_capabilities__bindgen_ty_1__bindgen_ty_1,
    pub midr_range_list: *const midr_range,
    pub __bindgen_anon_2: arm64_cpu_capabilities__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct arm64_cpu_capabilities__bindgen_ty_1__bindgen_ty_1 {
    pub midr_range: midr_range,
    pub fixed_revs: *const arm64_cpu_capabilities__bindgen_ty_1__bindgen_ty_1_arm64_midr_revidr,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct arm64_cpu_capabilities__bindgen_ty_1__bindgen_ty_1_arm64_midr_revidr {
    pub midr_rv: u32_,
    pub revidr_mask: u32_,
}
impl Default for arm64_cpu_capabilities__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct arm64_cpu_capabilities__bindgen_ty_1__bindgen_ty_2 {
    pub sys_reg: u32_,
    pub field_pos: u8_,
    pub field_width: u8_,
    pub min_field_value: u8_,
    pub max_field_value: u8_,
    pub hwcap_type: u8_,
    pub sign: bool_,
    pub hwcap: ffi::c_ulong,
}
impl Default for arm64_cpu_capabilities__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for arm64_cpu_capabilities {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut system_cpucaps: [ffi::c_ulong; 2usize];
}
extern "C" {
    pub static mut boot_cpucaps: [ffi::c_ulong; 2usize];
}
extern "C" {
    pub fn this_cpu_has_cap(cap: ffi::c_uint) -> bool_;
}
extern "C" {
    pub fn cpu_set_feature(num: ffi::c_uint);
}
extern "C" {
    pub fn cpu_have_feature(num: ffi::c_uint) -> bool_;
}
extern "C" {
    pub fn cpu_get_elf_hwcap() -> ffi::c_ulong;
}
extern "C" {
    pub fn cpu_get_elf_hwcap2() -> ffi::c_ulong;
}
extern "C" {
    pub fn cpu_get_elf_hwcap3() -> ffi::c_ulong;
}
extern "C" {
    pub fn setup_boot_cpu_features();
}
extern "C" {
    pub fn setup_system_features();
}
extern "C" {
    pub fn setup_user_features();
}
extern "C" {
    pub fn check_local_cpu_capabilities();
}
extern "C" {
    pub fn read_sanitised_ftr_reg(id: u32_) -> u64_;
}
extern "C" {
    pub fn __read_sysreg_by_encoding(sys_id: u32_) -> u64_;
}
extern "C" {
    pub fn system_32bit_el0_cpumask() -> *const cpumask;
}
extern "C" {
    pub fn fallback_32bit_el0_cpumask() -> *const cpumask;
}
extern "C" {
    pub static mut arm64_mismatched_32bit_el0: static_key_false;
}
extern "C" {
    pub fn do_emulate_mrs(regs: *mut pt_regs, sys_reg: u32_, rt: u32_) -> ffi::c_int;
}
extern "C" {
    pub fn try_emulate_mrs(regs: *mut pt_regs, isn: u32_) -> bool_;
}
extern "C" {
    pub fn cpu_has_amu_feat(cpu: ffi::c_int) -> bool_;
}
extern "C" {
    pub fn get_cpu_with_amu_feat() -> ffi::c_int;
}
extern "C" {
    pub fn arm64_ftr_safe_value(ftrp: *const arm64_ftr_bits, new: s64, cur: s64) -> s64;
}
extern "C" {
    pub fn get_arm64_ftr_reg(sys_id: u32_) -> *mut arm64_ftr_reg;
}
extern "C" {
    pub static mut id_aa64mmfr0_override: arm64_ftr_override;
}
extern "C" {
    pub static mut id_aa64mmfr1_override: arm64_ftr_override;
}
extern "C" {
    pub static mut id_aa64mmfr2_override: arm64_ftr_override;
}
extern "C" {
    pub static mut id_aa64pfr0_override: arm64_ftr_override;
}
extern "C" {
    pub static mut id_aa64pfr1_override: arm64_ftr_override;
}
extern "C" {
    pub static mut id_aa64zfr0_override: arm64_ftr_override;
}
extern "C" {
    pub static mut id_aa64smfr0_override: arm64_ftr_override;
}
extern "C" {
    pub static mut id_aa64isar1_override: arm64_ftr_override;
}
extern "C" {
    pub static mut id_aa64isar2_override: arm64_ftr_override;
}
extern "C" {
    pub static mut arm64_sw_feature_override: arm64_ftr_override;
}
extern "C" {
    pub fn get_kvm_ipa_limit() -> u32_;
}
extern "C" {
    pub fn dump_cpu_features();
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct user_pt_regs {
    pub regs: [__u64; 31usize],
    pub sp: __u64,
    pub pc: __u64,
    pub pstate: __u64,
}
#[repr(C)]
#[repr(align(16))]
#[derive(Default, Copy, Clone)]
pub struct user_fpsimd_state {
    pub vregs: [__uint128_t; 32usize],
    pub fpsr: __u32,
    pub fpcr: __u32,
    pub __reserved: [__u32; 2usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct user_hwdebug_state {
    pub dbg_info: __u32,
    pub pad: __u32,
    pub dbg_regs: [user_hwdebug_state__bindgen_ty_1; 16usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct user_hwdebug_state__bindgen_ty_1 {
    pub addr: __u64,
    pub ctrl: __u32,
    pub pad: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct user_sve_header {
    pub size: __u32,
    pub max_size: __u32,
    pub vl: __u16,
    pub max_vl: __u16,
    pub flags: __u16,
    pub __reserved: __u16,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct user_pac_mask {
    pub data_mask: __u64,
    pub insn_mask: __u64,
}
#[repr(C)]
#[repr(align(16))]
#[derive(Default, Copy, Clone)]
pub struct user_pac_address_keys {
    pub apiakey: __uint128_t,
    pub apibkey: __uint128_t,
    pub apdakey: __uint128_t,
    pub apdbkey: __uint128_t,
}
#[repr(C)]
#[repr(align(16))]
#[derive(Default, Copy, Clone)]
pub struct user_pac_generic_keys {
    pub apgakey: __uint128_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct user_za_header {
    pub size: __u32,
    pub max_size: __u32,
    pub vl: __u16,
    pub max_vl: __u16,
    pub flags: __u16,
    pub __reserved: __u16,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct user_gcs {
    pub features_enabled: __u64,
    pub features_locked: __u64,
    pub gcspr_el0: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct frame_record {
    pub fp: u64_,
    pub lr: u64_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct frame_record_meta {
    pub record: frame_record,
    pub type_: u64_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct pt_regs {
    pub __bindgen_anon_1: pt_regs__bindgen_ty_1,
    pub orig_x0: u64_,
    pub syscallno: s32,
    pub pmr: u32_,
    pub sdei_ttbr1: u64_,
    pub stackframe: frame_record_meta,
    pub lockdep_hardirqs: u64_,
    pub exit_rcu: u64_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union pt_regs__bindgen_ty_1 {
    pub user_regs: user_pt_regs,
    pub __bindgen_anon_1: pt_regs__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pt_regs__bindgen_ty_1__bindgen_ty_1 {
    pub regs: [u64_; 31usize],
    pub sp: u64_,
    pub pc: u64_,
    pub pstate: u64_,
}
impl Default for pt_regs__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for pt_regs {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn regs_query_register_offset(name: *const ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub fn regs_get_kernel_stack_nth(regs: *mut pt_regs, n: ffi::c_uint) -> ffi::c_ulong;
}
extern "C" {
    pub fn valid_user_regs(regs: *mut user_pt_regs, task: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn profile_pc(regs: *mut pt_regs) -> ffi::c_ulong;
}
extern "C" {
    pub fn __bad_size_call_parameter();
}
extern "C" {
    pub static mut __per_cpu_offset: [ffi::c_ulong; 4096usize];
}
extern "C" {
    pub fn setup_per_cpu_areas();
}
pub const class_irq_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_irq_t {
    pub lock: *mut ffi::c_void,
}
impl Default for class_irq_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const class_irqsave_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_irqsave_t {
    pub lock: *mut ffi::c_void,
    pub flags: ffi::c_ulong,
}
impl Default for class_irqsave_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn _local_bh_enable();
}
extern "C" {
    pub fn __local_bh_enable_ip(ip: ffi::c_ulong, cnt: ffi::c_uint);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct llist_head {
    pub first: *mut llist_node,
}
impl Default for llist_head {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct llist_node {
    pub next: *mut llist_node,
}
impl Default for llist_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn llist_add_batch(
        new_first: *mut llist_node,
        new_last: *mut llist_node,
        head: *mut llist_head,
    ) -> bool_;
}
extern "C" {
    pub fn llist_del_first(head: *mut llist_head) -> *mut llist_node;
}
extern "C" {
    pub fn llist_del_first_this(head: *mut llist_head, this: *mut llist_node) -> bool_;
}
extern "C" {
    pub fn llist_reverse_order(head: *mut llist_node) -> *mut llist_node;
}
pub const CSD_FLAG_LOCK: _bindgen_ty_6 = 1;
pub const IRQ_WORK_PENDING: _bindgen_ty_6 = 1;
pub const IRQ_WORK_BUSY: _bindgen_ty_6 = 2;
pub const IRQ_WORK_LAZY: _bindgen_ty_6 = 4;
pub const IRQ_WORK_HARD_IRQ: _bindgen_ty_6 = 8;
pub const IRQ_WORK_CLAIMED: _bindgen_ty_6 = 3;
pub const CSD_TYPE_ASYNC: _bindgen_ty_6 = 0;
pub const CSD_TYPE_SYNC: _bindgen_ty_6 = 16;
pub const CSD_TYPE_IRQ_WORK: _bindgen_ty_6 = 32;
pub const CSD_TYPE_TTWU: _bindgen_ty_6 = 48;
pub const CSD_FLAG_TYPE_MASK: _bindgen_ty_6 = 240;
pub type _bindgen_ty_6 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct __call_single_node {
    pub llist: llist_node,
    pub __bindgen_anon_1: __call_single_node__bindgen_ty_1,
    pub src: u16_,
    pub dst: u16_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union __call_single_node__bindgen_ty_1 {
    pub u_flags: ffi::c_uint,
    pub a_flags: atomic_t,
}
impl Default for __call_single_node__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for __call_single_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type smp_call_func_t = ::core::option::Option<unsafe extern "C" fn(info: *mut ffi::c_void)>;
pub type smp_cond_func_t =
    ::core::option::Option<unsafe extern "C" fn(cpu: ffi::c_int, info: *mut ffi::c_void) -> bool_>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct __call_single_data {
    pub node: __call_single_node,
    pub func: smp_call_func_t,
    pub info: *mut ffi::c_void,
}
impl Default for __call_single_data {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type call_single_data_t = __call_single_data;
extern "C" {
    pub fn __smp_call_single_queue(cpu: ffi::c_int, node: *mut llist_node);
}
extern "C" {
    pub static mut total_cpus: ffi::c_uint;
}
extern "C" {
    pub fn smp_call_function_single(
        cpuid: ffi::c_int,
        func: smp_call_func_t,
        info: *mut ffi::c_void,
        wait: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn on_each_cpu_cond_mask(
        cond_func: smp_cond_func_t,
        func: smp_call_func_t,
        info: *mut ffi::c_void,
        wait: bool_,
        mask: *const cpumask,
    );
}
extern "C" {
    pub fn smp_call_function_single_async(
        cpu: ffi::c_int,
        csd: *mut call_single_data_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn panic_smp_self_stop() -> !;
}
extern "C" {
    pub fn nmi_panic_self_stop(regs: *mut pt_regs) -> !;
}
extern "C" {
    pub fn crash_smp_send_stop();
}
extern "C" {
    pub fn smp_prepare_boot_cpu();
}
extern "C" {
    pub static mut __cpu_logical_map: [u64_; 4096usize];
}
extern "C" {
    pub fn cpu_logical_map(cpu: ffi::c_uint) -> u64_;
}
extern "C" {
    pub fn smp_init_cpus();
}
extern "C" {
    pub fn set_smp_ipi_range(ipi_base: ffi::c_int, nr_ipi: ffi::c_int);
}
extern "C" {
    pub fn secondary_start_kernel();
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct secondary_data {
    pub task: *mut task_struct,
    pub status: ffi::c_long,
}
impl Default for secondary_data {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut secondary_data: secondary_data;
}
extern "C" {
    pub static mut __early_cpu_boot_status: ffi::c_long;
}
extern "C" {
    pub fn secondary_entry();
}
extern "C" {
    pub fn arch_send_call_function_single_ipi(cpu: ffi::c_int);
}
extern "C" {
    pub fn arch_send_call_function_ipi_mask(mask: *const cpumask);
}
extern "C" {
    pub fn arch_send_wakeup_ipi(cpu: ffi::c_uint);
}
extern "C" {
    pub fn __cpu_disable() -> ffi::c_int;
}
extern "C" {
    pub fn cpu_die() -> !;
}
extern "C" {
    pub fn cpu_die_early() -> !;
}
extern "C" {
    pub fn cpus_are_stuck_in_kernel() -> bool_;
}
extern "C" {
    pub fn smp_crash_stop_failed() -> bool_;
}
extern "C" {
    pub fn smp_send_stop();
}
extern "C" {
    pub fn arch_smp_send_reschedule(cpu: ffi::c_int);
}
extern "C" {
    pub fn smp_prepare_cpus(max_cpus: ffi::c_uint);
}
extern "C" {
    pub fn __cpu_up(cpunum: ffi::c_uint, tidle: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn smp_cpus_done(max_cpus: ffi::c_uint);
}
extern "C" {
    pub fn smp_call_function(func: smp_call_func_t, info: *mut ffi::c_void, wait: ffi::c_int);
}
extern "C" {
    pub fn smp_call_function_many(
        mask: *const cpumask,
        func: smp_call_func_t,
        info: *mut ffi::c_void,
        wait: bool_,
    );
}
extern "C" {
    pub fn smp_call_function_any(
        mask: *const cpumask,
        func: smp_call_func_t,
        info: *mut ffi::c_void,
        wait: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kick_all_cpus_sync();
}
extern "C" {
    pub fn wake_up_all_idle_cpus();
}
extern "C" {
    pub fn call_function_init();
}
extern "C" {
    pub fn generic_smp_call_function_single_interrupt();
}
extern "C" {
    pub static mut setup_max_cpus: ffi::c_uint;
}
extern "C" {
    pub fn setup_nr_cpu_ids();
}
extern "C" {
    pub fn smp_init();
}
extern "C" {
    pub static mut __boot_cpu_id: ffi::c_int;
}
extern "C" {
    pub fn arch_disable_smp_support();
}
extern "C" {
    pub fn arch_thaw_secondary_cpus_begin();
}
extern "C" {
    pub fn arch_thaw_secondary_cpus_end();
}
extern "C" {
    pub fn smp_setup_processor_id();
}
extern "C" {
    pub fn smp_call_on_cpu(
        cpu: ffi::c_uint,
        func: ::core::option::Option<unsafe extern "C" fn(arg1: *mut ffi::c_void) -> ffi::c_int>,
        par: *mut ffi::c_void,
        phys: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn smpcfd_prepare_cpu(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn smpcfd_dead_cpu(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn smpcfd_dying_cpu(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn lock_is_held(arg1: *const ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn lockdep_is_held(arg1: *const ffi::c_void) -> ffi::c_int;
}
pub const xhlock_context_t_XHLOCK_HARD: xhlock_context_t = 0;
pub const xhlock_context_t_XHLOCK_SOFT: xhlock_context_t = 1;
pub const xhlock_context_t_XHLOCK_CTX_NR: xhlock_context_t = 2;
pub type xhlock_context_t = ffi::c_uint;
#[repr(C)]
#[repr(align(4))]
#[derive(Default, Copy, Clone)]
pub struct spinlock {
    pub _bindgen_opaque_blob: u32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union spinlock__bindgen_ty_1 {
    pub rlock: raw_spinlock,
}
impl Default for spinlock__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type spinlock_t = spinlock;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rwlock_t {
    pub raw_lock: arch_rwlock_t,
}
impl Default for rwlock_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn queued_spin_lock_slowpath(lock: *mut qspinlock, val: u32_);
}
extern "C" {
    pub static mut __icache_flags: ffi::c_ulong;
}
extern "C" {
    pub fn cache_line_size() -> ffi::c_int;
}
#[repr(C)]
#[repr(align(64))]
pub struct cacheline_padding {
    pub x: __IncompleteArrayField<ffi::c_char>,
}
impl Default for cacheline_padding {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut __boot_cpu_mode: [u32_; 2usize];
}
extern "C" {
    pub fn __hyp_set_vectors(phys_vector_base: phys_addr_t);
}
extern "C" {
    pub fn __hyp_reset_vectors();
}
extern "C" {
    pub fn is_kvm_arm_initialised() -> bool_;
}
extern "C" {
    pub static mut kvm_protected_mode_initialized: static_key_false;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct arch_hw_breakpoint_ctrl {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
impl arch_hw_breakpoint_ctrl {
    #[inline]
    pub fn __reserved(&self) -> u32_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 19u8) as u32) }
    }
    #[inline]
    pub fn set___reserved(&mut self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 19u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn __reserved_raw(this: *const Self) -> u32_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                19u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set___reserved_raw(this: *mut Self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                19u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn len(&self) -> u32_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(19usize, 8u8) as u32) }
    }
    #[inline]
    pub fn set_len(&mut self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(19usize, 8u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn len_raw(this: *const Self) -> u32_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                19usize,
                8u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_len_raw(this: *mut Self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                19usize,
                8u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn type_(&self) -> u32_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(27usize, 2u8) as u32) }
    }
    #[inline]
    pub fn set_type(&mut self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(27usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn type__raw(this: *const Self) -> u32_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                27usize,
                2u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_type_raw(this: *mut Self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                27usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn privilege(&self) -> u32_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(29usize, 2u8) as u32) }
    }
    #[inline]
    pub fn set_privilege(&mut self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(29usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn privilege_raw(this: *const Self) -> u32_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                29usize,
                2u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_privilege_raw(this: *mut Self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                29usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn enabled(&self) -> u32_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(31usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_enabled(&mut self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(31usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn enabled_raw(this: *const Self) -> u32_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                31usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_enabled_raw(this: *mut Self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                31usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        __reserved: u32_,
        len: u32_,
        type_: u32_,
        privilege: u32_,
        enabled: u32_,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 19u8, {
            let __reserved: u32 = unsafe { ::core::mem::transmute(__reserved) };
            __reserved as u64
        });
        __bindgen_bitfield_unit.set(19usize, 8u8, {
            let len: u32 = unsafe { ::core::mem::transmute(len) };
            len as u64
        });
        __bindgen_bitfield_unit.set(27usize, 2u8, {
            let type_: u32 = unsafe { ::core::mem::transmute(type_) };
            type_ as u64
        });
        __bindgen_bitfield_unit.set(29usize, 2u8, {
            let privilege: u32 = unsafe { ::core::mem::transmute(privilege) };
            privilege as u64
        });
        __bindgen_bitfield_unit.set(31usize, 1u8, {
            let enabled: u32 = unsafe { ::core::mem::transmute(enabled) };
            enabled as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct arch_hw_breakpoint {
    pub address: u64_,
    pub trigger: u64_,
    pub ctrl: arch_hw_breakpoint_ctrl,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct perf_event_attr {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct perf_event {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct pmu {
    _unused: [u8; 0],
}
extern "C" {
    pub fn arch_bp_generic_fields(
        ctrl: arch_hw_breakpoint_ctrl,
        gen_len: *mut ffi::c_int,
        gen_type: *mut ffi::c_int,
        offset: *mut ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn arch_check_bp_in_kernelspace(hw: *mut arch_hw_breakpoint) -> ffi::c_int;
}
extern "C" {
    pub fn hw_breakpoint_arch_parse(
        bp: *mut perf_event,
        attr: *const perf_event_attr,
        hw: *mut arch_hw_breakpoint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn hw_breakpoint_exceptions_notify(
        unused: *mut notifier_block,
        val: ffi::c_ulong,
        data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn arch_install_hw_breakpoint(bp: *mut perf_event) -> ffi::c_int;
}
extern "C" {
    pub fn arch_uninstall_hw_breakpoint(bp: *mut perf_event);
}
extern "C" {
    pub fn hw_breakpoint_pmu_read(bp: *mut perf_event);
}
extern "C" {
    pub fn hw_breakpoint_slots(type_: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn hw_breakpoint_thread_switch(next: *mut task_struct);
}
extern "C" {
    pub fn ptrace_hw_copy_thread(task: *mut task_struct);
}
extern "C" {
    pub fn cpu_suspend_set_dbg_restorer(
        hw_bp_restore: ::core::option::Option<
            unsafe extern "C" fn(arg1: ffi::c_uint) -> ffi::c_int,
        >,
    );
}
extern "C" {
    pub fn mte_enable_kernel_sync();
}
extern "C" {
    pub fn mte_enable_kernel_async();
}
extern "C" {
    pub fn mte_enable_kernel_asymm();
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct prctl_mm_map {
    pub start_code: __u64,
    pub end_code: __u64,
    pub start_data: __u64,
    pub end_data: __u64,
    pub start_brk: __u64,
    pub brk: __u64,
    pub start_stack: __u64,
    pub arg_start: __u64,
    pub arg_end: __u64,
    pub env_start: __u64,
    pub env_end: __u64,
    pub auxv: *mut __u64,
    pub auxv_size: __u32,
    pub exe_fd: __u32,
}
impl Default for prctl_mm_map {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ptrauth_key {
    pub lo: ffi::c_ulong,
    pub hi: ffi::c_ulong,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ptrauth_keys_user {
    pub apia: ptrauth_key,
    pub apib: ptrauth_key,
    pub apda: ptrauth_key,
    pub apdb: ptrauth_key,
    pub apga: ptrauth_key,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ptrauth_keys_kernel {
    pub apia: ptrauth_key,
}
extern "C" {
    pub fn ptrauth_prctl_reset_keys(tsk: *mut task_struct, arg: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn ptrauth_set_enabled_keys(
        tsk: *mut task_struct,
        keys: ffi::c_ulong,
        enabled: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn ptrauth_get_enabled_keys(tsk: *mut task_struct) -> ffi::c_int;
}
pub const mitigation_state_SPECTRE_UNAFFECTED: mitigation_state = 0;
pub const mitigation_state_SPECTRE_MITIGATED: mitigation_state = 1;
pub const mitigation_state_SPECTRE_VULNERABLE: mitigation_state = 2;
pub type mitigation_state = ffi::c_uint;
pub const arm64_hyp_spectre_vector_HYP_VECTOR_DIRECT: arm64_hyp_spectre_vector = 0;
pub const arm64_hyp_spectre_vector_HYP_VECTOR_SPECTRE_DIRECT: arm64_hyp_spectre_vector = 1;
pub const arm64_hyp_spectre_vector_HYP_VECTOR_INDIRECT: arm64_hyp_spectre_vector = 2;
pub const arm64_hyp_spectre_vector_HYP_VECTOR_SPECTRE_INDIRECT: arm64_hyp_spectre_vector = 3;
pub type arm64_hyp_spectre_vector = ffi::c_uint;
pub type bp_hardening_cb_t = ::core::option::Option<unsafe extern "C" fn()>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bp_hardening_data {
    pub slot: arm64_hyp_spectre_vector,
    pub fn_: bp_hardening_cb_t,
}
impl Default for bp_hardening_data {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut bp_hardening_data: bp_hardening_data;
}
extern "C" {
    pub fn arm64_get_spectre_v2_state() -> mitigation_state;
}
extern "C" {
    pub fn has_spectre_v2(cap: *const arm64_cpu_capabilities, scope: ffi::c_int) -> bool_;
}
extern "C" {
    pub fn spectre_v2_enable_mitigation(__unused: *const arm64_cpu_capabilities);
}
extern "C" {
    pub fn has_spectre_v3a(cap: *const arm64_cpu_capabilities, scope: ffi::c_int) -> bool_;
}
extern "C" {
    pub fn spectre_v3a_enable_mitigation(__unused: *const arm64_cpu_capabilities);
}
extern "C" {
    pub fn arm64_get_spectre_v4_state() -> mitigation_state;
}
extern "C" {
    pub fn has_spectre_v4(cap: *const arm64_cpu_capabilities, scope: ffi::c_int) -> bool_;
}
extern "C" {
    pub fn spectre_v4_enable_mitigation(__unused: *const arm64_cpu_capabilities);
}
extern "C" {
    pub fn spectre_v4_enable_task_mitigation(tsk: *mut task_struct);
}
extern "C" {
    pub fn arm64_get_meltdown_state() -> mitigation_state;
}
extern "C" {
    pub fn arm64_get_spectre_bhb_state() -> mitigation_state;
}
extern "C" {
    pub fn is_spectre_bhb_affected(
        entry: *const arm64_cpu_capabilities,
        scope: ffi::c_int,
    ) -> bool_;
}
extern "C" {
    pub static mut __nospectre_bhb: bool_;
}
extern "C" {
    pub fn get_spectre_bhb_loop_value() -> u8_;
}
extern "C" {
    pub fn is_spectre_bhb_fw_mitigated() -> bool_;
}
extern "C" {
    pub fn spectre_bhb_enable_mitigation(__unused: *const arm64_cpu_capabilities);
}
extern "C" {
    pub fn try_emulate_el1_ssbs(regs: *mut pt_regs, instr: u32_) -> bool_;
}
extern "C" {
    pub fn spectre_v4_patch_fw_mitigation_enable(
        alt: *mut alt_instr,
        origptr: *mut __le32,
        updptr: *mut __le32,
        nr_inst: ffi::c_int,
    );
}
extern "C" {
    pub fn smccc_patch_fw_mitigation_conduit(
        alt: *mut alt_instr,
        origptr: *mut __le32,
        updptr: *mut __le32,
        nr_inst: ffi::c_int,
    );
}
extern "C" {
    pub fn spectre_bhb_patch_loop_mitigation_enable(
        alt: *mut alt_instr,
        origptr: *mut __le32,
        updptr: *mut __le32,
        nr_inst: ffi::c_int,
    );
}
extern "C" {
    pub fn spectre_bhb_patch_fw_mitigation_enabled(
        alt: *mut alt_instr,
        origptr: *mut __le32,
        updptr: *mut __le32,
        nr_inst: ffi::c_int,
    );
}
extern "C" {
    pub fn spectre_bhb_patch_loop_iter(
        alt: *mut alt_instr,
        origptr: *mut __le32,
        updptr: *mut __le32,
        nr_inst: ffi::c_int,
    );
}
extern "C" {
    pub fn spectre_bhb_patch_wa3(
        alt: *mut alt_instr,
        origptr: *mut __le32,
        updptr: *mut __le32,
        nr_inst: ffi::c_int,
    );
}
extern "C" {
    pub fn spectre_bhb_patch_clearbhb(
        alt: *mut alt_instr,
        origptr: *mut __le32,
        updptr: *mut __le32,
        nr_inst: ffi::c_int,
    );
}
extern "C" {
    pub static mut arm64_dma_phys_limit: phys_addr_t;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct debug_info {
    pub suspended_step: ffi::c_int,
    pub bps_disabled: ffi::c_int,
    pub wps_disabled: ffi::c_int,
    pub hbp_break: [*mut perf_event; 16usize],
    pub hbp_watch: [*mut perf_event; 16usize],
}
impl Default for debug_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const vec_type_ARM64_VEC_SVE: vec_type = 0;
pub const vec_type_ARM64_VEC_SME: vec_type = 1;
pub const vec_type_ARM64_VEC_MAX: vec_type = 2;
pub type vec_type = ffi::c_uint;
pub const fp_type_FP_STATE_CURRENT: fp_type = 0;
pub const fp_type_FP_STATE_FPSIMD: fp_type = 1;
pub const fp_type_FP_STATE_SVE: fp_type = 2;
pub type fp_type = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct cpu_context {
    pub x19: ffi::c_ulong,
    pub x20: ffi::c_ulong,
    pub x21: ffi::c_ulong,
    pub x22: ffi::c_ulong,
    pub x23: ffi::c_ulong,
    pub x24: ffi::c_ulong,
    pub x25: ffi::c_ulong,
    pub x26: ffi::c_ulong,
    pub x27: ffi::c_ulong,
    pub x28: ffi::c_ulong,
    pub fp: ffi::c_ulong,
    pub sp: ffi::c_ulong,
    pub pc: ffi::c_ulong,
}
#[repr(C)]
#[repr(align(16))]
#[derive(Copy, Clone)]
pub struct thread_struct {
    pub cpu_context: cpu_context,
    pub __bindgen_padding_0: u64,
    pub uw: thread_struct__bindgen_ty_1,
    pub fp_type: fp_type,
    pub fpsimd_cpu: ffi::c_uint,
    pub sve_state: *mut ffi::c_void,
    pub sme_state: *mut ffi::c_void,
    pub vl: [ffi::c_uint; 2usize],
    pub vl_onexec: [ffi::c_uint; 2usize],
    pub fault_address: ffi::c_ulong,
    pub fault_code: ffi::c_ulong,
    pub debug: debug_info,
    pub __bindgen_padding_1: u64,
    pub kernel_fpsimd_state: user_fpsimd_state,
    pub kernel_fpsimd_cpu: ffi::c_uint,
    pub keys_user: ptrauth_keys_user,
    pub keys_kernel: ptrauth_keys_kernel,
    pub mte_ctrl: u64_,
    pub sctlr_user: u64_,
    pub svcr: u64_,
    pub tpidr2_el0: u64_,
    pub por_el0: u64_,
}
#[repr(C)]
#[repr(align(16))]
#[derive(Default, Copy, Clone)]
pub struct thread_struct__bindgen_ty_1 {
    pub tp_value: ffi::c_ulong,
    pub tp2_value: ffi::c_ulong,
    pub fpmr: u64_,
    pub pad: ffi::c_ulong,
    pub fpsimd_state: user_fpsimd_state,
}
impl Default for thread_struct {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn task_get_vl(task: *const task_struct, type_: vec_type) -> ffi::c_uint;
}
extern "C" {
    pub fn task_set_vl(task: *mut task_struct, type_: vec_type, vl: ffi::c_ulong);
}
extern "C" {
    pub fn task_set_vl_onexec(task: *mut task_struct, type_: vec_type, vl: ffi::c_ulong);
}
extern "C" {
    pub fn task_get_vl_onexec(task: *const task_struct, type_: vec_type) -> ffi::c_uint;
}
extern "C" {
    pub fn tls_preserve_current_state();
}
extern "C" {
    pub fn __get_wchan(p: *mut task_struct) -> ffi::c_ulong;
}
extern "C" {
    pub fn update_sctlr_el1(sctlr: u64_);
}
extern "C" {
    pub fn cpu_switch_to(prev: *mut task_struct, next: *mut task_struct) -> *mut task_struct;
}
extern "C" {
    pub static mut signal_minsigstksz: ffi::c_ulong;
}
extern "C" {
    pub fn minsigstksz_setup();
}
#[repr(C)]
#[repr(align(16))]
#[derive(Copy, Clone)]
pub struct sigcontext {
    pub fault_address: __u64,
    pub regs: [__u64; 31usize],
    pub sp: __u64,
    pub pc: __u64,
    pub pstate: __u64,
    pub __bindgen_padding_0: [u8; 8usize],
    pub __reserved: [__u8; 4096usize],
}
impl Default for sigcontext {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct _aarch64_ctx {
    pub magic: __u32,
    pub size: __u32,
}
#[repr(C)]
#[repr(align(16))]
#[derive(Default, Copy, Clone)]
pub struct fpsimd_context {
    pub head: _aarch64_ctx,
    pub fpsr: __u32,
    pub fpcr: __u32,
    pub vregs: [__uint128_t; 32usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct esr_context {
    pub head: _aarch64_ctx,
    pub esr: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct poe_context {
    pub head: _aarch64_ctx,
    pub por_el0: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct extra_context {
    pub head: _aarch64_ctx,
    pub datap: __u64,
    pub size: __u32,
    pub __reserved: [__u32; 3usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sve_context {
    pub head: _aarch64_ctx,
    pub vl: __u16,
    pub flags: __u16,
    pub __reserved: [__u16; 2usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tpidr2_context {
    pub head: _aarch64_ctx,
    pub tpidr2: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct fpmr_context {
    pub head: _aarch64_ctx,
    pub fpmr: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct za_context {
    pub head: _aarch64_ctx,
    pub vl: __u16,
    pub __reserved: [__u16; 3usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct zt_context {
    pub head: _aarch64_ctx,
    pub nregs: __u16,
    pub __reserved: [__u16; 3usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct gcs_context {
    pub head: _aarch64_ctx,
    pub gcspr: __u64,
    pub features_enabled: __u64,
    pub reserved: __u64,
}
extern "C" {
    pub fn fpsimd_save_state(state: *mut user_fpsimd_state);
}
extern "C" {
    pub fn fpsimd_load_state(state: *mut user_fpsimd_state);
}
extern "C" {
    pub fn fpsimd_thread_switch(next: *mut task_struct);
}
extern "C" {
    pub fn fpsimd_flush_thread();
}
extern "C" {
    pub fn fpsimd_signal_preserve_current_state();
}
extern "C" {
    pub fn fpsimd_preserve_current_state();
}
extern "C" {
    pub fn fpsimd_restore_current_state();
}
extern "C" {
    pub fn fpsimd_update_current_state(state: *const user_fpsimd_state);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct cpu_fp_state {
    pub st: *mut user_fpsimd_state,
    pub sve_state: *mut ffi::c_void,
    pub sme_state: *mut ffi::c_void,
    pub svcr: *mut u64_,
    pub fpmr: *mut u64_,
    pub sve_vl: ffi::c_uint,
    pub sme_vl: ffi::c_uint,
    pub fp_type: *mut fp_type,
    pub to_save: fp_type,
}
impl Default for cpu_fp_state {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn fpsimd_bind_state_to_cpu(fp_state: *mut cpu_fp_state);
}
extern "C" {
    pub fn fpsimd_flush_task_state(target: *mut task_struct);
}
extern "C" {
    pub fn fpsimd_save_and_flush_cpu_state();
}
extern "C" {
    pub fn sve_save_state(state: *mut ffi::c_void, pfpsr: *mut u32_, save_ffr: ffi::c_int);
}
extern "C" {
    pub fn sve_load_state(state: *const ffi::c_void, pfpsr: *const u32_, restore_ffr: ffi::c_int);
}
extern "C" {
    pub fn sve_flush_live(flush_ffr: bool_, vq_minus_1: ffi::c_ulong);
}
extern "C" {
    pub fn sve_get_vl() -> ffi::c_uint;
}
extern "C" {
    pub fn sve_set_vq(vq_minus_1: ffi::c_ulong);
}
extern "C" {
    pub fn sme_set_vq(vq_minus_1: ffi::c_ulong);
}
extern "C" {
    pub fn sme_save_state(state: *mut ffi::c_void, zt: ffi::c_int);
}
extern "C" {
    pub fn sme_load_state(state: *const ffi::c_void, zt: ffi::c_int);
}
extern "C" {
    pub fn cpu_enable_fpsimd(__unused: *const arm64_cpu_capabilities);
}
extern "C" {
    pub fn cpu_enable_sve(__unused: *const arm64_cpu_capabilities);
}
extern "C" {
    pub fn cpu_enable_sme(__unused: *const arm64_cpu_capabilities);
}
extern "C" {
    pub fn cpu_enable_sme2(__unused: *const arm64_cpu_capabilities);
}
extern "C" {
    pub fn cpu_enable_fa64(__unused: *const arm64_cpu_capabilities);
}
extern "C" {
    pub fn cpu_enable_fpmr(__unused: *const arm64_cpu_capabilities);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct vl_info {
    pub type_: vec_type,
    pub name: *const ffi::c_char,
    pub min_vl: ffi::c_int,
    pub max_vl: ffi::c_int,
    pub max_virtualisable_vl: ffi::c_int,
    pub vq_map: [ffi::c_ulong; 8usize],
    pub vq_partial_map: [ffi::c_ulong; 8usize],
}
impl Default for vl_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn sve_alloc(task: *mut task_struct, flush: bool_);
}
extern "C" {
    pub fn fpsimd_release_task(task: *mut task_struct);
}
extern "C" {
    pub fn fpsimd_sync_to_sve(task: *mut task_struct);
}
extern "C" {
    pub fn fpsimd_force_sync_to_sve(task: *mut task_struct);
}
extern "C" {
    pub fn sve_sync_to_fpsimd(task: *mut task_struct);
}
extern "C" {
    pub fn sve_sync_from_fpsimd_zeropad(task: *mut task_struct);
}
extern "C" {
    pub fn vec_set_vector_length(
        task: *mut task_struct,
        type_: vec_type,
        vl: ffi::c_ulong,
        flags: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sve_set_current_vl(arg: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn sve_get_current_vl() -> ffi::c_int;
}
extern "C" {
    pub fn vec_init_vq_map(type_: vec_type);
}
extern "C" {
    pub fn vec_update_vq_map(type_: vec_type);
}
extern "C" {
    pub fn vec_verify_vq_map(type_: vec_type) -> ffi::c_int;
}
extern "C" {
    pub fn sve_setup();
}
extern "C" {
    pub static mut vl_info: [vl_info; 2usize];
}
extern "C" {
    pub fn sve_state_size(task: *const task_struct) -> usize;
}
extern "C" {
    pub fn __efi_fpsimd_begin();
}
extern "C" {
    pub fn __efi_fpsimd_end();
}
extern "C" {
    pub fn set_tagged_addr_ctrl(task: *mut task_struct, arg: ffi::c_ulong) -> ffi::c_long;
}
extern "C" {
    pub fn get_tagged_addr_ctrl(task: *mut task_struct) -> ffi::c_long;
}
extern "C" {
    pub fn get_tsc_mode(adr: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn set_tsc_mode(val: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn queued_read_lock_slowpath(lock: *mut qrwlock);
}
extern "C" {
    pub fn queued_write_lock_slowpath(lock: *mut qrwlock);
}
extern "C" {
    pub fn in_lock_functions(addr: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn _raw_spin_lock(lock: *mut raw_spinlock_t);
}
extern "C" {
    pub fn _raw_spin_lock_nested(lock: *mut raw_spinlock_t, subclass: ffi::c_int);
}
extern "C" {
    pub fn _raw_spin_lock_nest_lock(lock: *mut raw_spinlock_t, map: *mut lockdep_map);
}
extern "C" {
    pub fn _raw_spin_lock_bh(lock: *mut raw_spinlock_t);
}
extern "C" {
    pub fn _raw_spin_lock_irq(lock: *mut raw_spinlock_t);
}
extern "C" {
    pub fn _raw_spin_lock_irqsave(lock: *mut raw_spinlock_t) -> ffi::c_ulong;
}
extern "C" {
    pub fn _raw_spin_lock_irqsave_nested(
        lock: *mut raw_spinlock_t,
        subclass: ffi::c_int,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn _raw_spin_trylock(lock: *mut raw_spinlock_t) -> ffi::c_int;
}
extern "C" {
    pub fn _raw_spin_trylock_bh(lock: *mut raw_spinlock_t) -> ffi::c_int;
}
extern "C" {
    pub fn _raw_spin_unlock(lock: *mut raw_spinlock_t);
}
extern "C" {
    pub fn _raw_spin_unlock_bh(lock: *mut raw_spinlock_t);
}
extern "C" {
    pub fn _raw_spin_unlock_irq(lock: *mut raw_spinlock_t);
}
extern "C" {
    pub fn _raw_spin_unlock_irqrestore(lock: *mut raw_spinlock_t, flags: ffi::c_ulong);
}
extern "C" {
    pub fn _raw_read_lock(lock: *mut rwlock_t);
}
extern "C" {
    pub fn _raw_write_lock(lock: *mut rwlock_t);
}
extern "C" {
    pub fn _raw_write_lock_nested(lock: *mut rwlock_t, subclass: ffi::c_int);
}
extern "C" {
    pub fn _raw_read_lock_bh(lock: *mut rwlock_t);
}
extern "C" {
    pub fn _raw_write_lock_bh(lock: *mut rwlock_t);
}
extern "C" {
    pub fn _raw_read_lock_irq(lock: *mut rwlock_t);
}
extern "C" {
    pub fn _raw_write_lock_irq(lock: *mut rwlock_t);
}
extern "C" {
    pub fn _raw_read_lock_irqsave(lock: *mut rwlock_t) -> ffi::c_ulong;
}
extern "C" {
    pub fn _raw_write_lock_irqsave(lock: *mut rwlock_t) -> ffi::c_ulong;
}
extern "C" {
    pub fn _raw_read_trylock(lock: *mut rwlock_t) -> ffi::c_int;
}
extern "C" {
    pub fn _raw_write_trylock(lock: *mut rwlock_t) -> ffi::c_int;
}
extern "C" {
    pub fn _raw_read_unlock(lock: *mut rwlock_t);
}
extern "C" {
    pub fn _raw_write_unlock(lock: *mut rwlock_t);
}
extern "C" {
    pub fn _raw_read_unlock_bh(lock: *mut rwlock_t);
}
extern "C" {
    pub fn _raw_write_unlock_bh(lock: *mut rwlock_t);
}
extern "C" {
    pub fn _raw_read_unlock_irq(lock: *mut rwlock_t);
}
extern "C" {
    pub fn _raw_write_unlock_irq(lock: *mut rwlock_t);
}
extern "C" {
    pub fn _raw_read_unlock_irqrestore(lock: *mut rwlock_t, flags: ffi::c_ulong);
}
extern "C" {
    pub fn _raw_write_unlock_irqrestore(lock: *mut rwlock_t, flags: ffi::c_ulong);
}
extern "C" {
    pub fn _atomic_dec_and_lock(atomic: *mut atomic_t, lock: *mut spinlock_t) -> ffi::c_int;
}
extern "C" {
    pub fn _atomic_dec_and_lock_irqsave(
        atomic: *mut atomic_t,
        lock: *mut spinlock_t,
        flags: *mut ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn _atomic_dec_and_raw_lock(atomic: *mut atomic_t, lock: *mut raw_spinlock_t)
        -> ffi::c_int;
}
extern "C" {
    pub fn _atomic_dec_and_raw_lock_irqsave(
        atomic: *mut atomic_t,
        lock: *mut raw_spinlock_t,
        flags: *mut ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __alloc_bucket_spinlocks(
        locks: *mut *mut spinlock_t,
        lock_mask: *mut ffi::c_uint,
        max_size: usize,
        cpu_mult: ffi::c_uint,
        gfp: gfp_t,
        name: *const ffi::c_char,
        key: *mut lock_class_key,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn free_bucket_spinlocks(locks: *mut spinlock_t);
}
pub const class_raw_spinlock_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_raw_spinlock_t {
    pub lock: *mut raw_spinlock_t,
}
impl Default for class_raw_spinlock_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const class_raw_spinlock_try_is_conditional: bool_ = true;
pub type class_raw_spinlock_try_t = class_raw_spinlock_t;
pub const class_raw_spinlock_nested_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_raw_spinlock_nested_t {
    pub lock: *mut raw_spinlock_t,
}
impl Default for class_raw_spinlock_nested_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const class_raw_spinlock_irq_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_raw_spinlock_irq_t {
    pub lock: *mut raw_spinlock_t,
}
impl Default for class_raw_spinlock_irq_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const class_raw_spinlock_irq_try_is_conditional: bool_ = true;
pub type class_raw_spinlock_irq_try_t = class_raw_spinlock_irq_t;
pub const class_raw_spinlock_bh_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_raw_spinlock_bh_t {
    pub lock: *mut raw_spinlock_t,
}
impl Default for class_raw_spinlock_bh_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const class_raw_spinlock_bh_try_is_conditional: bool_ = true;
pub type class_raw_spinlock_bh_try_t = class_raw_spinlock_bh_t;
pub const class_raw_spinlock_irqsave_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_raw_spinlock_irqsave_t {
    pub lock: *mut raw_spinlock_t,
    pub flags: ffi::c_ulong,
}
impl Default for class_raw_spinlock_irqsave_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const class_raw_spinlock_irqsave_try_is_conditional: bool_ = true;
pub type class_raw_spinlock_irqsave_try_t = class_raw_spinlock_irqsave_t;
pub const class_spinlock_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_spinlock_t {
    pub lock: *mut spinlock_t,
}
impl Default for class_spinlock_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const class_spinlock_try_is_conditional: bool_ = true;
pub type class_spinlock_try_t = class_spinlock_t;
pub const class_spinlock_irq_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_spinlock_irq_t {
    pub lock: *mut spinlock_t,
}
impl Default for class_spinlock_irq_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const class_spinlock_irq_try_is_conditional: bool_ = true;
pub type class_spinlock_irq_try_t = class_spinlock_irq_t;
pub const class_spinlock_bh_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_spinlock_bh_t {
    pub lock: *mut spinlock_t,
}
impl Default for class_spinlock_bh_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const class_spinlock_bh_try_is_conditional: bool_ = true;
pub type class_spinlock_bh_try_t = class_spinlock_bh_t;
pub const class_spinlock_irqsave_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_spinlock_irqsave_t {
    pub lock: *mut spinlock_t,
    pub flags: ffi::c_ulong,
}
impl Default for class_spinlock_irqsave_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const class_spinlock_irqsave_try_is_conditional: bool_ = true;
pub type class_spinlock_irqsave_try_t = class_spinlock_irqsave_t;
pub const class_read_lock_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_read_lock_t {
    pub lock: *mut rwlock_t,
}
impl Default for class_read_lock_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const class_read_lock_irq_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_read_lock_irq_t {
    pub lock: *mut rwlock_t,
}
impl Default for class_read_lock_irq_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const class_read_lock_irqsave_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_read_lock_irqsave_t {
    pub lock: *mut rwlock_t,
    pub flags: ffi::c_ulong,
}
impl Default for class_read_lock_irqsave_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const class_write_lock_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_write_lock_t {
    pub lock: *mut rwlock_t,
}
impl Default for class_write_lock_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const class_write_lock_irq_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_write_lock_irq_t {
    pub lock: *mut rwlock_t,
}
impl Default for class_write_lock_irq_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const class_write_lock_irqsave_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_write_lock_irqsave_t {
    pub lock: *mut rwlock_t,
    pub flags: ffi::c_ulong,
}
impl Default for class_write_lock_irqsave_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct refcount_struct {
    pub refs: atomic_t,
}
pub type refcount_t = refcount_struct;
pub const refcount_saturation_type_REFCOUNT_ADD_NOT_ZERO_OVF: refcount_saturation_type = 0;
pub const refcount_saturation_type_REFCOUNT_ADD_OVF: refcount_saturation_type = 1;
pub const refcount_saturation_type_REFCOUNT_ADD_UAF: refcount_saturation_type = 2;
pub const refcount_saturation_type_REFCOUNT_SUB_UAF: refcount_saturation_type = 3;
pub const refcount_saturation_type_REFCOUNT_DEC_LEAK: refcount_saturation_type = 4;
pub type refcount_saturation_type = ffi::c_uint;
extern "C" {
    pub fn refcount_warn_saturate(r: *mut refcount_t, t: refcount_saturation_type);
}
extern "C" {
    #[must_use]
    pub fn refcount_dec_if_one(r: *mut refcount_t) -> bool_;
}
extern "C" {
    #[must_use]
    pub fn refcount_dec_not_one(r: *mut refcount_t) -> bool_;
}
extern "C" {
    #[must_use]
    pub fn refcount_dec_and_mutex_lock(r: *mut refcount_t, lock: *mut mutex) -> bool_;
}
extern "C" {
    #[must_use]
    pub fn refcount_dec_and_lock(r: *mut refcount_t, lock: *mut spinlock_t) -> bool_;
}
extern "C" {
    #[must_use]
    pub fn refcount_dec_and_lock_irqsave(
        r: *mut refcount_t,
        lock: *mut spinlock_t,
        flags: *mut ffi::c_ulong,
    ) -> bool_;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct kref {
    pub refcount: refcount_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct stat {
    pub st_dev: ffi::c_ulong,
    pub st_ino: ffi::c_ulong,
    pub st_mode: ffi::c_uint,
    pub st_nlink: ffi::c_uint,
    pub st_uid: ffi::c_uint,
    pub st_gid: ffi::c_uint,
    pub st_rdev: ffi::c_ulong,
    pub __pad1: ffi::c_ulong,
    pub st_size: ffi::c_long,
    pub st_blksize: ffi::c_int,
    pub __pad2: ffi::c_int,
    pub st_blocks: ffi::c_long,
    pub st_atime: ffi::c_long,
    pub st_atime_nsec: ffi::c_ulong,
    pub st_mtime: ffi::c_long,
    pub st_mtime_nsec: ffi::c_ulong,
    pub st_ctime: ffi::c_long,
    pub st_ctime_nsec: ffi::c_ulong,
    pub __unused4: ffi::c_uint,
    pub __unused5: ffi::c_uint,
}
extern "C" {
    pub fn iter_div_u64_rem(dividend: u64_, divisor: u32_, remainder: *mut u64_) -> u32_;
}
extern "C" {
    pub fn mul_u64_u64_div_u64(a: u64_, mul: u64_, div: u64_) -> u64_;
}
pub type time64_t = __s64;
pub type timeu64_t = __u64;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct __kernel_timespec {
    pub tv_sec: __kernel_time64_t,
    pub tv_nsec: ffi::c_longlong,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct __kernel_itimerspec {
    pub it_interval: __kernel_timespec,
    pub it_value: __kernel_timespec,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct __kernel_old_timeval {
    pub tv_sec: __kernel_long_t,
    pub tv_usec: __kernel_long_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct __kernel_old_timespec {
    pub tv_sec: __kernel_old_time_t,
    pub tv_nsec: ffi::c_long,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct __kernel_old_itimerval {
    pub it_interval: __kernel_old_timeval,
    pub it_value: __kernel_old_timeval,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct __kernel_sock_timeval {
    pub tv_sec: __s64,
    pub tv_usec: __s64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct timezone {
    pub tz_minuteswest: ffi::c_int,
    pub tz_dsttime: ffi::c_int,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct timespec64 {
    pub tv_sec: time64_t,
    pub tv_nsec: ffi::c_long,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct itimerspec64 {
    pub it_interval: timespec64,
    pub it_value: timespec64,
}
extern "C" {
    pub fn set_normalized_timespec64(ts: *mut timespec64, sec: time64_t, nsec: s64);
}
extern "C" {
    pub fn ns_to_timespec64(nsec: s64) -> timespec64;
}
extern "C" {
    pub fn timespec64_add_safe(lhs: timespec64, rhs: timespec64) -> timespec64;
}
extern "C" {
    pub static mut sys_tz: timezone;
}
extern "C" {
    pub fn get_timespec64(ts: *mut timespec64, uts: *const __kernel_timespec) -> ffi::c_int;
}
extern "C" {
    pub fn put_timespec64(ts: *const timespec64, uts: *mut __kernel_timespec) -> ffi::c_int;
}
extern "C" {
    pub fn get_itimerspec64(it: *mut itimerspec64, uit: *const __kernel_itimerspec) -> ffi::c_int;
}
extern "C" {
    pub fn put_itimerspec64(it: *const itimerspec64, uit: *mut __kernel_itimerspec) -> ffi::c_int;
}
extern "C" {
    pub fn mktime64(
        year: ffi::c_uint,
        mon: ffi::c_uint,
        day: ffi::c_uint,
        hour: ffi::c_uint,
        min: ffi::c_uint,
        sec: ffi::c_uint,
    ) -> time64_t;
}
extern "C" {
    pub fn clear_itimer();
}
extern "C" {
    pub fn do_utimes(
        dfd: ffi::c_int,
        filename: *const ffi::c_char,
        times: *mut timespec64,
        flags: ffi::c_int,
    ) -> ffi::c_long;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tm {
    pub tm_sec: ffi::c_int,
    pub tm_min: ffi::c_int,
    pub tm_hour: ffi::c_int,
    pub tm_mday: ffi::c_int,
    pub tm_mon: ffi::c_int,
    pub tm_year: ffi::c_long,
    pub tm_wday: ffi::c_int,
    pub tm_yday: ffi::c_int,
}
extern "C" {
    pub fn time64_to_tm(totalsecs: time64_t, offset: ffi::c_int, result: *mut tm);
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct __kernel_timex_timeval {
    pub tv_sec: __kernel_time64_t,
    pub tv_usec: ffi::c_longlong,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct __kernel_timex {
    pub modes: ffi::c_uint,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
    pub offset: ffi::c_longlong,
    pub freq: ffi::c_longlong,
    pub maxerror: ffi::c_longlong,
    pub esterror: ffi::c_longlong,
    pub status: ffi::c_int,
    pub _bitfield_align_2: [u8; 0],
    pub _bitfield_2: __BindgenBitfieldUnit<[u8; 4usize]>,
    pub constant: ffi::c_longlong,
    pub precision: ffi::c_longlong,
    pub tolerance: ffi::c_longlong,
    pub time: __kernel_timex_timeval,
    pub tick: ffi::c_longlong,
    pub ppsfreq: ffi::c_longlong,
    pub jitter: ffi::c_longlong,
    pub shift: ffi::c_int,
    pub _bitfield_align_3: [u8; 0],
    pub _bitfield_3: __BindgenBitfieldUnit<[u8; 4usize]>,
    pub stabil: ffi::c_longlong,
    pub jitcnt: ffi::c_longlong,
    pub calcnt: ffi::c_longlong,
    pub errcnt: ffi::c_longlong,
    pub stbcnt: ffi::c_longlong,
    pub tai: ffi::c_int,
    pub _bitfield_align_4: [u8; 0],
    pub _bitfield_4: __BindgenBitfieldUnit<[u8; 44usize]>,
}
impl Default for __kernel_timex {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl __kernel_timex {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit
    }
    #[inline]
    pub fn new_bitfield_2() -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit
    }
    #[inline]
    pub fn new_bitfield_3() -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
extern "C" {
    pub fn random_get_entropy_fallback() -> ffi::c_ulong;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct codetag_type {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct codetag_module {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct seq_buf {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct codetag {
    pub flags: ffi::c_uint,
    pub lineno: ffi::c_uint,
    pub modname: *const ffi::c_char,
    pub function: *const ffi::c_char,
    pub filename: *const ffi::c_char,
}
impl Default for codetag {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union codetag_ref {
    pub ct: *mut codetag,
}
impl Default for codetag_ref {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct codetag_type_desc {
    pub section: *const ffi::c_char,
    pub tag_size: usize,
    pub module_load: ::core::option::Option<
        unsafe extern "C" fn(cttype: *mut codetag_type, cmod: *mut codetag_module),
    >,
    pub module_unload: ::core::option::Option<
        unsafe extern "C" fn(cttype: *mut codetag_type, cmod: *mut codetag_module),
    >,
    pub module_replaced:
        ::core::option::Option<unsafe extern "C" fn(mod_: *mut module, new_mod: *mut module)>,
    pub needs_section_mem: ::core::option::Option<
        unsafe extern "C" fn(mod_: *mut module, size: ffi::c_ulong) -> bool_,
    >,
    pub alloc_section_mem: ::core::option::Option<
        unsafe extern "C" fn(
            mod_: *mut module,
            size: ffi::c_ulong,
            prepend: ffi::c_uint,
            align: ffi::c_ulong,
        ) -> *mut ffi::c_void,
    >,
    pub free_section_mem:
        ::core::option::Option<unsafe extern "C" fn(mod_: *mut module, used: bool_)>,
}
impl Default for codetag_type_desc {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct codetag_iterator {
    pub cttype: *mut codetag_type,
    pub cmod: *mut codetag_module,
    pub mod_id: ffi::c_ulong,
    pub ct: *mut codetag,
}
impl Default for codetag_iterator {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn codetag_lock_module_list(cttype: *mut codetag_type, lock: bool_);
}
extern "C" {
    pub fn codetag_trylock_module_list(cttype: *mut codetag_type) -> bool_;
}
extern "C" {
    pub fn codetag_get_ct_iter(cttype: *mut codetag_type) -> codetag_iterator;
}
extern "C" {
    pub fn codetag_next_ct(iter: *mut codetag_iterator) -> *mut codetag;
}
extern "C" {
    pub fn codetag_to_text(out: *mut seq_buf, ct: *mut codetag);
}
extern "C" {
    pub fn codetag_register_type(desc: *const codetag_type_desc) -> *mut codetag_type;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct alloc_tag_counters {
    pub bytes: u64_,
    pub calls: u64_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct alloc_tag {
    pub ct: codetag,
    pub counters: *mut alloc_tag_counters,
}
impl Default for alloc_tag {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct alloc_tag_kernel_section {
    pub first_tag: *mut alloc_tag,
    pub count: ffi::c_ulong,
}
impl Default for alloc_tag_kernel_section {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct alloc_tag_module_section {
    pub __bindgen_anon_1: alloc_tag_module_section__bindgen_ty_1,
    pub end_addr: ffi::c_ulong,
    pub size: ffi::c_ulong,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union alloc_tag_module_section__bindgen_ty_1 {
    pub start_addr: ffi::c_ulong,
    pub first_tag: *mut alloc_tag,
}
impl Default for alloc_tag_module_section__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for alloc_tag_module_section {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct clone_args {
    pub flags: __u64,
    pub pidfd: __u64,
    pub child_tid: __u64,
    pub parent_tid: __u64,
    pub exit_signal: __u64,
    pub stack: __u64,
    pub stack_size: __u64,
    pub tls: __u64,
    pub set_tid: __u64,
    pub set_tid_size: __u64,
    pub cgroup: __u64,
}
pub const pid_type_PIDTYPE_PID: pid_type = 0;
pub const pid_type_PIDTYPE_TGID: pid_type = 1;
pub const pid_type_PIDTYPE_PGID: pid_type = 2;
pub const pid_type_PIDTYPE_SID: pid_type = 3;
pub const pid_type_PIDTYPE_MAX: pid_type = 4;
pub type pid_type = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct pid_namespace {
    pub idr: idr,
    pub rcu: callback_head,
    pub pid_allocated: ffi::c_uint,
    pub child_reaper: *mut task_struct,
    pub pid_cachep: *mut kmem_cache,
    pub level: ffi::c_uint,
    pub pid_max: ffi::c_int,
    pub parent: *mut pid_namespace,
    pub bacct: *mut fs_pin,
    pub user_ns: *mut user_namespace,
    pub ucounts: *mut ucounts,
    pub reboot: ffi::c_int,
    pub ns: ns_common,
    pub work: work_struct,
    pub set: ctl_table_set,
    pub sysctls: *mut ctl_table_header,
    pub memfd_noexec_scope: ffi::c_int,
}
impl Default for pid_namespace {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut init_pid_ns: pid_namespace;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sem_undo_list {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sysv_sem {
    pub undo_list: *mut sem_undo_list,
}
impl Default for sysv_sem {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const UNAME26: _bindgen_ty_7 = 131072;
pub const ADDR_NO_RANDOMIZE: _bindgen_ty_7 = 262144;
pub const FDPIC_FUNCPTRS: _bindgen_ty_7 = 524288;
pub const MMAP_PAGE_ZERO: _bindgen_ty_7 = 1048576;
pub const ADDR_COMPAT_LAYOUT: _bindgen_ty_7 = 2097152;
pub const READ_IMPLIES_EXEC: _bindgen_ty_7 = 4194304;
pub const ADDR_LIMIT_32BIT: _bindgen_ty_7 = 8388608;
pub const SHORT_INODE: _bindgen_ty_7 = 16777216;
pub const WHOLE_SECONDS: _bindgen_ty_7 = 33554432;
pub const STICKY_TIMEOUTS: _bindgen_ty_7 = 67108864;
pub const ADDR_LIMIT_3GB: _bindgen_ty_7 = 134217728;
pub type _bindgen_ty_7 = ffi::c_uint;
pub const PER_LINUX: _bindgen_ty_8 = 0;
pub const PER_LINUX_32BIT: _bindgen_ty_8 = 8388608;
pub const PER_LINUX_FDPIC: _bindgen_ty_8 = 524288;
pub const PER_SVR4: _bindgen_ty_8 = 68157441;
pub const PER_SVR3: _bindgen_ty_8 = 83886082;
pub const PER_SCOSVR3: _bindgen_ty_8 = 117440515;
pub const PER_OSR5: _bindgen_ty_8 = 100663299;
pub const PER_WYSEV386: _bindgen_ty_8 = 83886084;
pub const PER_ISCR4: _bindgen_ty_8 = 67108869;
pub const PER_BSD: _bindgen_ty_8 = 6;
pub const PER_SUNOS: _bindgen_ty_8 = 67108870;
pub const PER_XENIX: _bindgen_ty_8 = 83886087;
pub const PER_LINUX32: _bindgen_ty_8 = 8;
pub const PER_LINUX32_3GB: _bindgen_ty_8 = 134217736;
pub const PER_IRIX32: _bindgen_ty_8 = 67108873;
pub const PER_IRIXN32: _bindgen_ty_8 = 67108874;
pub const PER_IRIX64: _bindgen_ty_8 = 67108875;
pub const PER_RISCOS: _bindgen_ty_8 = 12;
pub const PER_SOLARIS: _bindgen_ty_8 = 67108877;
pub const PER_UW7: _bindgen_ty_8 = 68157454;
pub const PER_OSF4: _bindgen_ty_8 = 15;
pub const PER_HPUX: _bindgen_ty_8 = 16;
pub const PER_MASK: _bindgen_ty_8 = 255;
pub type _bindgen_ty_8 = ffi::c_uint;
extern "C" {
    pub fn copy_page(to: *mut ffi::c_void, from: *const ffi::c_void);
}
extern "C" {
    pub fn clear_page(to: *mut ffi::c_void);
}
extern "C" {
    pub fn copy_user_highpage(
        to: *mut page,
        from: *mut page,
        vaddr: ffi::c_ulong,
        vma: *mut vm_area_struct,
    );
}
extern "C" {
    pub fn copy_highpage(to: *mut page, from: *mut page);
}
extern "C" {
    pub fn vma_alloc_zeroed_movable_folio(
        vma: *mut vm_area_struct,
        vaddr: ffi::c_ulong,
    ) -> *mut folio;
}
extern "C" {
    pub fn tag_clear_highpage(to: *mut page);
}
pub type pgtable_t = *mut page;
extern "C" {
    pub fn pfn_is_map_memory(pfn: ffi::c_ulong) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sysv_shm {
    pub shm_clist: list_head,
}
impl Default for sysv_shm {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn do_shmat(
        shmid: ffi::c_int,
        shmaddr: *mut ffi::c_char,
        shmflg: ffi::c_int,
        addr: *mut ffi::c_ulong,
        shmlba: ffi::c_ulong,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn exit_shm(task: *mut task_struct);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kmsan_context_state {
    pub param_tls: [ffi::c_char; 800usize],
    pub retval_tls: [ffi::c_char; 800usize],
    pub va_arg_tls: [ffi::c_char; 800usize],
    pub va_arg_origin_tls: [ffi::c_char; 800usize],
    pub va_arg_overflow_size_tls: u64_,
    pub param_origin_tls: [ffi::c_char; 800usize],
    pub retval_origin_tls: u32_,
}
impl Default for kmsan_context_state {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kmsan_ctx {
    pub cstate: kmsan_context_state,
    pub kmsan_in_runtime: ffi::c_int,
    pub depth: ffi::c_uint,
}
impl Default for kmsan_ctx {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct optimistic_spin_queue {
    pub tail: atomic_t,
}
extern "C" {
    pub fn osq_lock(lock: *mut optimistic_spin_queue) -> bool_;
}
extern "C" {
    pub fn osq_unlock(lock: *mut optimistic_spin_queue);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mutex {
    pub owner: atomic_long_t,
    pub wait_lock: raw_spinlock_t,
    pub osq: optimistic_spin_queue,
    pub wait_list: list_head,
}
impl Default for mutex {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct plist_head {
    pub node_list: list_head,
}
impl Default for plist_head {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct plist_node {
    pub prio: ffi::c_int,
    pub prio_list: list_head,
    pub node_list: list_head,
}
impl Default for plist_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rb_node {
    pub __rb_parent_color: ffi::c_ulong,
    pub rb_right: *mut rb_node,
    pub rb_left: *mut rb_node,
}
impl Default for rb_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rb_root {
    pub rb_node: *mut rb_node,
}
impl Default for rb_root {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rb_root_cached {
    pub rb_root: rb_root,
    pub rb_leftmost: *mut rb_node,
}
impl Default for rb_root_cached {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct timerqueue_node {
    pub node: rb_node,
    pub expires: ktime_t,
}
impl Default for timerqueue_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct timerqueue_head {
    pub rb_root: rb_root_cached,
}
impl Default for timerqueue_head {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const hrtimer_restart_HRTIMER_NORESTART: hrtimer_restart = 0;
pub const hrtimer_restart_HRTIMER_RESTART: hrtimer_restart = 1;
pub type hrtimer_restart = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct hrtimer {
    pub node: timerqueue_node,
    pub _softexpires: ktime_t,
    pub function:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut hrtimer) -> hrtimer_restart>,
    pub base: *mut hrtimer_clock_base,
    pub state: u8_,
    pub is_rel: u8_,
    pub is_soft: u8_,
    pub is_hard: u8_,
}
impl Default for hrtimer {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct timer_list {
    pub entry: hlist_node,
    pub expires: ffi::c_ulong,
    pub function: ::core::option::Option<unsafe extern "C" fn(arg1: *mut timer_list)>,
    pub flags: u32_,
}
impl Default for timer_list {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct seccomp_filter {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct seccomp {
    pub mode: ffi::c_int,
    pub filter_count: atomic_t,
    pub filter: *mut seccomp_filter,
}
impl Default for seccomp {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct rusage {
    pub ru_utime: __kernel_old_timeval,
    pub ru_stime: __kernel_old_timeval,
    pub ru_maxrss: __kernel_long_t,
    pub ru_ixrss: __kernel_long_t,
    pub ru_idrss: __kernel_long_t,
    pub ru_isrss: __kernel_long_t,
    pub ru_minflt: __kernel_long_t,
    pub ru_majflt: __kernel_long_t,
    pub ru_nswap: __kernel_long_t,
    pub ru_inblock: __kernel_long_t,
    pub ru_oublock: __kernel_long_t,
    pub ru_msgsnd: __kernel_long_t,
    pub ru_msgrcv: __kernel_long_t,
    pub ru_nsignals: __kernel_long_t,
    pub ru_nvcsw: __kernel_long_t,
    pub ru_nivcsw: __kernel_long_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct rlimit {
    pub rlim_cur: __kernel_ulong_t,
    pub rlim_max: __kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct rlimit64 {
    pub rlim_cur: __u64,
    pub rlim_max: __u64,
}
extern "C" {
    pub fn getrusage(p: *mut task_struct, who: ffi::c_int, ru: *mut rusage);
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct latency_record {
    pub backtrace: [ffi::c_ulong; 12usize],
    pub count: ffi::c_uint,
    pub time: ffi::c_ulong,
    pub max: ffi::c_ulong,
}
extern "C" {
    pub static mut latencytop_enabled: ffi::c_int;
}
extern "C" {
    pub fn __account_scheduler_latency(
        task: *mut task_struct,
        usecs: ffi::c_int,
        inter: ffi::c_int,
    );
}
extern "C" {
    pub fn clear_tsk_latency_tracing(p: *mut task_struct);
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct task_cputime {
    pub stime: u64_,
    pub utime: u64_,
    pub sum_exec_runtime: ffi::c_ulonglong,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sigset_t {
    pub sig: [ffi::c_ulong; 1usize],
}
pub type old_sigset_t = ffi::c_ulong;
pub type __signalfn_t = ::core::option::Option<unsafe extern "C" fn(arg1: ffi::c_int)>;
pub type __sighandler_t = __signalfn_t;
pub type __restorefn_t = ::core::option::Option<unsafe extern "C" fn()>;
pub type __sigrestore_t = __restorefn_t;
#[repr(C)]
pub struct sigaltstack {
    pub ss_sp: *mut ffi::c_void,
    pub ss_flags: ffi::c_int,
    pub ss_size: __kernel_size_t,
}
impl Default for sigaltstack {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type stack_t = sigaltstack;
#[repr(C)]
#[derive(Copy, Clone)]
pub union sigval {
    pub sival_int: ffi::c_int,
    pub sival_ptr: *mut ffi::c_void,
}
impl Default for sigval {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type sigval_t = sigval;
#[repr(C)]
#[derive(Copy, Clone)]
pub union __sifields {
    pub _kill: __sifields__bindgen_ty_1,
    pub _timer: __sifields__bindgen_ty_2,
    pub _rt: __sifields__bindgen_ty_3,
    pub _sigchld: __sifields__bindgen_ty_4,
    pub _sigfault: __sifields__bindgen_ty_5,
    pub _sigpoll: __sifields__bindgen_ty_6,
    pub _sigsys: __sifields__bindgen_ty_7,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct __sifields__bindgen_ty_1 {
    pub _pid: __kernel_pid_t,
    pub _uid: __kernel_uid32_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct __sifields__bindgen_ty_2 {
    pub _tid: __kernel_timer_t,
    pub _overrun: ffi::c_int,
    pub _sigval: sigval_t,
    pub _sys_private: ffi::c_int,
}
impl Default for __sifields__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct __sifields__bindgen_ty_3 {
    pub _pid: __kernel_pid_t,
    pub _uid: __kernel_uid32_t,
    pub _sigval: sigval_t,
}
impl Default for __sifields__bindgen_ty_3 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct __sifields__bindgen_ty_4 {
    pub _pid: __kernel_pid_t,
    pub _uid: __kernel_uid32_t,
    pub _status: ffi::c_int,
    pub _utime: __kernel_clock_t,
    pub _stime: __kernel_clock_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct __sifields__bindgen_ty_5 {
    pub _addr: *mut ffi::c_void,
    pub __bindgen_anon_1: __sifields__bindgen_ty_5__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union __sifields__bindgen_ty_5__bindgen_ty_1 {
    pub _trapno: ffi::c_int,
    pub _addr_lsb: ffi::c_short,
    pub _addr_bnd: __sifields__bindgen_ty_5__bindgen_ty_1__bindgen_ty_1,
    pub _addr_pkey: __sifields__bindgen_ty_5__bindgen_ty_1__bindgen_ty_2,
    pub _perf: __sifields__bindgen_ty_5__bindgen_ty_1__bindgen_ty_3,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct __sifields__bindgen_ty_5__bindgen_ty_1__bindgen_ty_1 {
    pub _dummy_bnd: [ffi::c_char; 8usize],
    pub _lower: *mut ffi::c_void,
    pub _upper: *mut ffi::c_void,
}
impl Default for __sifields__bindgen_ty_5__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct __sifields__bindgen_ty_5__bindgen_ty_1__bindgen_ty_2 {
    pub _dummy_pkey: [ffi::c_char; 8usize],
    pub _pkey: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct __sifields__bindgen_ty_5__bindgen_ty_1__bindgen_ty_3 {
    pub _data: ffi::c_ulong,
    pub _type: __u32,
    pub _flags: __u32,
}
impl Default for __sifields__bindgen_ty_5__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for __sifields__bindgen_ty_5 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct __sifields__bindgen_ty_6 {
    pub _band: ffi::c_long,
    pub _fd: ffi::c_int,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct __sifields__bindgen_ty_7 {
    pub _call_addr: *mut ffi::c_void,
    pub _syscall: ffi::c_int,
    pub _arch: ffi::c_uint,
}
impl Default for __sifields__bindgen_ty_7 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for __sifields {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct siginfo {
    pub __bindgen_anon_1: siginfo__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union siginfo__bindgen_ty_1 {
    pub __bindgen_anon_1: siginfo__bindgen_ty_1__bindgen_ty_1,
    pub _si_pad: [ffi::c_int; 32usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct siginfo__bindgen_ty_1__bindgen_ty_1 {
    pub si_signo: ffi::c_int,
    pub si_errno: ffi::c_int,
    pub si_code: ffi::c_int,
    pub _sifields: __sifields,
}
impl Default for siginfo__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for siginfo__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for siginfo {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type siginfo_t = siginfo;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sigevent {
    pub sigev_value: sigval_t,
    pub sigev_signo: ffi::c_int,
    pub sigev_notify: ffi::c_int,
    pub _sigev_un: sigevent__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sigevent__bindgen_ty_1 {
    pub _pad: [ffi::c_int; 12usize],
    pub _tid: ffi::c_int,
    pub _sigev_thread: sigevent__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sigevent__bindgen_ty_1__bindgen_ty_1 {
    pub _function: ::core::option::Option<unsafe extern "C" fn(arg1: sigval_t)>,
    pub _attribute: *mut ffi::c_void,
}
impl Default for sigevent__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for sigevent__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for sigevent {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type sigevent_t = sigevent;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kernel_siginfo {
    pub __bindgen_anon_1: kernel_siginfo__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kernel_siginfo__bindgen_ty_1 {
    pub si_signo: ffi::c_int,
    pub si_errno: ffi::c_int,
    pub si_code: ffi::c_int,
    pub _sifields: __sifields,
}
impl Default for kernel_siginfo__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for kernel_siginfo {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type kernel_siginfo_t = kernel_siginfo;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sigqueue {
    pub list: list_head,
    pub flags: ffi::c_int,
    pub info: kernel_siginfo_t,
    pub ucounts: *mut ucounts,
}
impl Default for sigqueue {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sigpending {
    pub list: list_head,
    pub signal: sigset_t,
}
impl Default for sigpending {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sigaction {
    pub sa_handler: __sighandler_t,
    pub sa_flags: ffi::c_ulong,
    pub sa_restorer: __sigrestore_t,
    pub sa_mask: sigset_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct k_sigaction {
    pub sa: sigaction,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ksignal {
    pub ka: k_sigaction,
    pub info: kernel_siginfo_t,
    pub sig: ffi::c_int,
}
impl Default for ksignal {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct syscall_user_dispatch {}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct arch_tlbflush_unmap_batch {}
pub const MM_FILEPAGES: _bindgen_ty_9 = 0;
pub const MM_ANONPAGES: _bindgen_ty_9 = 1;
pub const MM_SWAPENTS: _bindgen_ty_9 = 2;
pub const MM_SHMEMPAGES: _bindgen_ty_9 = 3;
pub const NR_MM_COUNTERS: _bindgen_ty_9 = 4;
pub type _bindgen_ty_9 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct page_frag {
    pub page: *mut page,
    pub offset: __u32,
    pub size: __u32,
}
impl Default for page_frag {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct page_frag_cache {
    pub encoded_page: ffi::c_ulong,
    pub offset: __u32,
    pub pagecnt_bias: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tlbflush_unmap_batch {
    pub arch: arch_tlbflush_unmap_batch,
    pub flush_required: bool_,
    pub writable: bool_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct netdev_xmit {
    pub recursion: u16_,
    pub more: u8_,
    pub skip_txqueue: u8_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct task_io_accounting {
    pub rchar: u64_,
    pub wchar: u64_,
    pub syscr: u64_,
    pub syscw: u64_,
    pub read_bytes: u64_,
    pub write_bytes: u64_,
    pub cancelled_write_bytes: u64_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct posix_cputimer_base {
    pub nextevt: u64_,
    pub tqhead: timerqueue_head,
}
impl Default for posix_cputimer_base {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct posix_cputimers {
    pub bases: [posix_cputimer_base; 3usize],
    pub timers_active: ffi::c_uint,
    pub expiry_active: ffi::c_uint,
}
impl Default for posix_cputimers {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct posix_cputimers_work {
    pub work: callback_head,
    pub mutex: mutex,
    pub scheduled: ffi::c_uint,
}
impl Default for posix_cputimers_work {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const rseq_cpu_id_state_RSEQ_CPU_ID_UNINITIALIZED: rseq_cpu_id_state = -1;
pub const rseq_cpu_id_state_RSEQ_CPU_ID_REGISTRATION_FAILED: rseq_cpu_id_state = -2;
pub type rseq_cpu_id_state = ffi::c_int;
pub const rseq_flags_RSEQ_FLAG_UNREGISTER: rseq_flags = 1;
pub type rseq_flags = ffi::c_uint;
pub const rseq_cs_flags_bit_RSEQ_CS_FLAG_NO_RESTART_ON_PREEMPT_BIT: rseq_cs_flags_bit = 0;
pub const rseq_cs_flags_bit_RSEQ_CS_FLAG_NO_RESTART_ON_SIGNAL_BIT: rseq_cs_flags_bit = 1;
pub const rseq_cs_flags_bit_RSEQ_CS_FLAG_NO_RESTART_ON_MIGRATE_BIT: rseq_cs_flags_bit = 2;
pub type rseq_cs_flags_bit = ffi::c_uint;
pub const rseq_cs_flags_RSEQ_CS_FLAG_NO_RESTART_ON_PREEMPT: rseq_cs_flags = 1;
pub const rseq_cs_flags_RSEQ_CS_FLAG_NO_RESTART_ON_SIGNAL: rseq_cs_flags = 2;
pub const rseq_cs_flags_RSEQ_CS_FLAG_NO_RESTART_ON_MIGRATE: rseq_cs_flags = 4;
pub type rseq_cs_flags = ffi::c_uint;
#[repr(C)]
#[repr(align(32))]
#[derive(Default, Copy, Clone)]
pub struct rseq_cs {
    pub version: __u32,
    pub flags: __u32,
    pub start_ip: __u64,
    pub post_commit_offset: __u64,
    pub abort_ip: __u64,
}
#[repr(C)]
#[repr(align(32))]
#[derive(Default)]
pub struct rseq {
    pub cpu_id_start: __u32,
    pub cpu_id: __u32,
    pub rseq_cs: __u64,
    pub flags: __u32,
    pub node_id: __u32,
    pub mm_cid: __u32,
    pub end: __IncompleteArrayField<ffi::c_char>,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct seqcount {
    pub sequence: ffi::c_uint,
}
pub type seqcount_t = seqcount;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct seqcount_raw_spinlock {
    pub seqcount: seqcount_t,
}
pub type seqcount_raw_spinlock_t = seqcount_raw_spinlock;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct seqcount_spinlock {
    pub seqcount: seqcount_t,
}
pub type seqcount_spinlock_t = seqcount_spinlock;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct seqcount_rwlock {
    pub seqcount: seqcount_t,
}
pub type seqcount_rwlock_t = seqcount_rwlock;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct seqcount_mutex {
    pub seqcount: seqcount_t,
}
pub type seqcount_mutex_t = seqcount_mutex;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct seqlock_t {
    pub seqcount: seqcount_spinlock_t,
    pub lock: spinlock_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct da_monitor {
    pub monitoring: bool_,
    pub curr_state: ffi::c_uint,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union rv_task_monitor {
    pub da_mon: da_monitor,
}
impl Default for rv_task_monitor {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rv_reactor {
    pub name: *const ffi::c_char,
    pub description: *const ffi::c_char,
    pub react: ::core::option::Option<unsafe extern "C" fn(msg: *mut ffi::c_char)>,
}
impl Default for rv_reactor {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rv_monitor {
    pub name: *const ffi::c_char,
    pub description: *const ffi::c_char,
    pub enabled: bool_,
    pub enable: ::core::option::Option<unsafe extern "C" fn() -> ffi::c_int>,
    pub disable: ::core::option::Option<unsafe extern "C" fn()>,
    pub reset: ::core::option::Option<unsafe extern "C" fn()>,
    pub react: ::core::option::Option<unsafe extern "C" fn(msg: *mut ffi::c_char)>,
}
impl Default for rv_monitor {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn rv_monitoring_on() -> bool_;
}
extern "C" {
    pub fn rv_unregister_monitor(monitor: *mut rv_monitor) -> ffi::c_int;
}
extern "C" {
    pub fn rv_register_monitor(monitor: *mut rv_monitor, parent: *mut rv_monitor) -> ffi::c_int;
}
extern "C" {
    pub fn rv_get_task_monitor_slot() -> ffi::c_int;
}
extern "C" {
    pub fn rv_put_task_monitor_slot(slot: ffi::c_int);
}
extern "C" {
    pub fn rv_reacting_on() -> bool_;
}
extern "C" {
    pub fn rv_unregister_reactor(reactor: *mut rv_reactor) -> ffi::c_int;
}
extern "C" {
    pub fn rv_register_reactor(reactor: *mut rv_reactor) -> ffi::c_int;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct kuid_t {
    pub val: uid_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct kgid_t {
    pub val: gid_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct trace_print_flags {
    pub mask: ffi::c_ulong,
    pub name: *const ffi::c_char,
}
impl Default for trace_print_flags {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct trace_print_flags_u64 {
    pub mask: ffi::c_ulonglong,
    pub name: *const ffi::c_char,
}
impl Default for trace_print_flags_u64 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tracepoint_func {
    pub func: *mut ffi::c_void,
    pub data: *mut ffi::c_void,
    pub prio: ffi::c_int,
}
impl Default for tracepoint_func {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tracepoint_ext {
    pub regfunc: ::core::option::Option<unsafe extern "C" fn() -> ffi::c_int>,
    pub unregfunc: ::core::option::Option<unsafe extern "C" fn()>,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub __bindgen_padding_0: [u8; 7usize],
}
impl tracepoint_ext {
    #[inline]
    pub fn faultable(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_faultable(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn faultable_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_faultable_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(faultable: ffi::c_uint) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let faultable: u32 = unsafe { ::core::mem::transmute(faultable) };
            faultable as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tracepoint {
    pub name: *const ffi::c_char,
    pub key: static_key_false,
    pub static_call_key: *mut static_call_key,
    pub static_call_tramp: *mut ffi::c_void,
    pub iterator: *mut ffi::c_void,
    pub probestub: *mut ffi::c_void,
    pub funcs: *mut tracepoint_func,
    pub ext: *mut tracepoint_ext,
}
impl Default for tracepoint {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type tracepoint_ptr_t = ffi::c_int;
#[repr(C)]
#[repr(align(32))]
#[derive(Copy, Clone)]
pub struct bpf_raw_event_map {
    pub tp: *mut tracepoint,
    pub bpf_func: *mut ffi::c_void,
    pub num_args: u32_,
    pub writable_size: u32_,
}
impl Default for bpf_raw_event_map {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct audit_context {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_local_storage {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_net_context {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct capture_control {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct cfs_rq {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fs_struct {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct futex_pi_state {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct io_uring_task {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mempolicy {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct nameidata {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct perf_event_context {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct perf_ctx_data {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct pipe_inode_info {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rcu_node {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct reclaim_state {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct robust_list_head {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct root_domain {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rq {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sched_attr {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct task_delay_info {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct task_group {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct user_event_mm {
    _unused: [u8; 0],
}
extern "C" {
    pub static mut debug_locks: ffi::c_int;
}
extern "C" {
    pub static mut debug_locks_silent: ffi::c_int;
}
extern "C" {
    pub fn debug_locks_off() -> ffi::c_int;
}
extern "C" {
    pub fn __mutex_init(lock: *mut mutex, name: *const ffi::c_char, key: *mut lock_class_key);
}
extern "C" {
    pub fn mutex_is_locked(lock: *mut mutex) -> bool_;
}
extern "C" {
    pub fn mutex_lock(lock: *mut mutex);
}
extern "C" {
    #[must_use]
    pub fn mutex_lock_interruptible(lock: *mut mutex) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn mutex_lock_killable(lock: *mut mutex) -> ffi::c_int;
}
extern "C" {
    pub fn mutex_lock_io(lock: *mut mutex);
}
extern "C" {
    pub fn mutex_trylock(lock: *mut mutex) -> ffi::c_int;
}
extern "C" {
    pub fn mutex_unlock(lock: *mut mutex);
}
extern "C" {
    pub fn atomic_dec_and_mutex_lock(cnt: *mut atomic_t, lock: *mut mutex) -> ffi::c_int;
}
pub type class_mutex_t = *mut mutex;
pub const class_mutex_is_conditional: bool_ = false;
pub const class_mutex_try_is_conditional: bool_ = true;
pub type class_mutex_try_t = class_mutex_t;
pub const class_mutex_intr_is_conditional: bool_ = true;
pub type class_mutex_intr_t = class_mutex_t;
extern "C" {
    pub fn mutex_get_owner(lock: *mut mutex) -> ffi::c_ulong;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct workqueue_struct {
    _unused: [u8; 0],
}
pub type work_func_t = ::core::option::Option<unsafe extern "C" fn(work: *mut work_struct)>;
extern "C" {
    pub fn delayed_work_timer_fn(t: *mut timer_list);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct work_struct {
    pub data: atomic_long_t,
    pub entry: list_head,
    pub func: work_func_t,
}
impl Default for work_struct {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rhash_head {
    pub next: *mut rhash_head,
}
impl Default for rhash_head {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rhlist_head {
    pub rhead: rhash_head,
    pub next: *mut rhlist_head,
}
impl Default for rhlist_head {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bucket_table {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rhashtable_compare_arg {
    pub ht: *mut rhashtable,
    pub key: *const ffi::c_void,
}
impl Default for rhashtable_compare_arg {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type rht_hashfn_t = ::core::option::Option<
    unsafe extern "C" fn(data: *const ffi::c_void, len: u32_, seed: u32_) -> u32_,
>;
pub type rht_obj_hashfn_t = ::core::option::Option<
    unsafe extern "C" fn(data: *const ffi::c_void, len: u32_, seed: u32_) -> u32_,
>;
pub type rht_obj_cmpfn_t = ::core::option::Option<
    unsafe extern "C" fn(arg: *mut rhashtable_compare_arg, obj: *const ffi::c_void) -> ffi::c_int,
>;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct rhashtable_params {
    pub nelem_hint: u16_,
    pub key_len: u16_,
    pub key_offset: u16_,
    pub head_offset: u16_,
    pub max_size: ffi::c_uint,
    pub min_size: u16_,
    pub automatic_shrinking: bool_,
    pub hashfn: rht_hashfn_t,
    pub obj_hashfn: rht_obj_hashfn_t,
    pub obj_cmpfn: rht_obj_cmpfn_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rhashtable {
    pub tbl: *mut bucket_table,
    pub key_len: ffi::c_uint,
    pub max_elems: ffi::c_uint,
    pub p: rhashtable_params,
    pub rhlist: bool_,
    pub run_work: work_struct,
    pub mutex: mutex,
    pub lock: spinlock_t,
    pub nelems: atomic_t,
}
impl Default for rhashtable {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rhltable {
    pub ht: rhashtable,
}
impl Default for rhltable {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rhashtable_walker {
    pub list: list_head,
    pub tbl: *mut bucket_table,
}
impl Default for rhashtable_walker {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rhashtable_iter {
    pub ht: *mut rhashtable,
    pub p: *mut rhash_head,
    pub list: *mut rhlist_head,
    pub walker: rhashtable_walker,
    pub slot: ffi::c_uint,
    pub skip: ffi::c_uint,
    pub end_of_table: bool_,
}
impl Default for rhashtable_iter {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn rhashtable_init_noprof(
        ht: *mut rhashtable,
        params: *const rhashtable_params,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn rhltable_init_noprof(hlt: *mut rhltable, params: *const rhashtable_params)
        -> ffi::c_int;
}
pub const scx_public_consts_SCX_OPS_NAME_LEN: scx_public_consts = 128;
pub const scx_public_consts_SCX_SLICE_DFL: scx_public_consts = 20000000;
pub const scx_public_consts_SCX_SLICE_INF: scx_public_consts = 18446744073709551615;
pub type scx_public_consts = ffi::c_ulong;
pub const scx_dsq_id_flags_SCX_DSQ_FLAG_BUILTIN: scx_dsq_id_flags = 9223372036854775808;
pub const scx_dsq_id_flags_SCX_DSQ_FLAG_LOCAL_ON: scx_dsq_id_flags = 4611686018427387904;
pub const scx_dsq_id_flags_SCX_DSQ_INVALID: scx_dsq_id_flags = 9223372036854775808;
pub const scx_dsq_id_flags_SCX_DSQ_GLOBAL: scx_dsq_id_flags = 9223372036854775809;
pub const scx_dsq_id_flags_SCX_DSQ_LOCAL: scx_dsq_id_flags = 9223372036854775810;
pub const scx_dsq_id_flags_SCX_DSQ_LOCAL_ON: scx_dsq_id_flags = 13835058055282163712;
pub const scx_dsq_id_flags_SCX_DSQ_LOCAL_CPU_MASK: scx_dsq_id_flags = 4294967295;
pub type scx_dsq_id_flags = ffi::c_ulong;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct scx_dispatch_q {
    pub lock: raw_spinlock_t,
    pub list: list_head,
    pub priq: rb_root,
    pub nr: u32_,
    pub seq: u32_,
    pub id: u64_,
    pub hash_node: rhash_head,
    pub free_node: llist_node,
    pub rcu: callback_head,
}
impl Default for scx_dispatch_q {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const scx_ent_flags_SCX_TASK_QUEUED: scx_ent_flags = 1;
pub const scx_ent_flags_SCX_TASK_RESET_RUNNABLE_AT: scx_ent_flags = 4;
pub const scx_ent_flags_SCX_TASK_DEQD_FOR_SLEEP: scx_ent_flags = 8;
pub const scx_ent_flags_SCX_TASK_STATE_SHIFT: scx_ent_flags = 8;
pub const scx_ent_flags_SCX_TASK_STATE_BITS: scx_ent_flags = 2;
pub const scx_ent_flags_SCX_TASK_STATE_MASK: scx_ent_flags = 768;
pub const scx_ent_flags_SCX_TASK_CURSOR: scx_ent_flags = -2147483648;
pub type scx_ent_flags = ffi::c_int;
pub const scx_task_state_SCX_TASK_NONE: scx_task_state = 0;
pub const scx_task_state_SCX_TASK_INIT: scx_task_state = 1;
pub const scx_task_state_SCX_TASK_READY: scx_task_state = 2;
pub const scx_task_state_SCX_TASK_ENABLED: scx_task_state = 3;
pub const scx_task_state_SCX_TASK_NR_STATES: scx_task_state = 4;
pub type scx_task_state = ffi::c_uint;
pub const scx_ent_dsq_flags_SCX_TASK_DSQ_ON_PRIQ: scx_ent_dsq_flags = 1;
pub type scx_ent_dsq_flags = ffi::c_uint;
pub const scx_kf_mask_SCX_KF_UNLOCKED: scx_kf_mask = 0;
pub const scx_kf_mask_SCX_KF_CPU_RELEASE: scx_kf_mask = 1;
pub const scx_kf_mask_SCX_KF_DISPATCH: scx_kf_mask = 2;
pub const scx_kf_mask_SCX_KF_ENQUEUE: scx_kf_mask = 4;
pub const scx_kf_mask_SCX_KF_SELECT_CPU: scx_kf_mask = 8;
pub const scx_kf_mask_SCX_KF_REST: scx_kf_mask = 16;
pub const scx_kf_mask___SCX_KF_RQ_LOCKED: scx_kf_mask = 31;
pub const scx_kf_mask___SCX_KF_TERMINAL: scx_kf_mask = 28;
pub type scx_kf_mask = ffi::c_uint;
pub const scx_dsq_lnode_flags_SCX_DSQ_LNODE_ITER_CURSOR: scx_dsq_lnode_flags = 1;
pub const scx_dsq_lnode_flags___SCX_DSQ_LNODE_PRIV_SHIFT: scx_dsq_lnode_flags = 16;
pub type scx_dsq_lnode_flags = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct scx_dsq_list_node {
    pub node: list_head,
    pub flags: u32_,
    pub priv_: u32_,
}
impl Default for scx_dsq_list_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sched_ext_entity {
    pub dsq: *mut scx_dispatch_q,
    pub dsq_list: scx_dsq_list_node,
    pub dsq_priq: rb_node,
    pub dsq_seq: u32_,
    pub dsq_flags: u32_,
    pub flags: u32_,
    pub weight: u32_,
    pub sticky_cpu: s32,
    pub holding_cpu: s32,
    pub selected_cpu: s32,
    pub kf_mask: u32_,
    pub kf_tasks: [*mut task_struct; 2usize],
    pub ops_state: atomic_long_t,
    pub runnable_node: list_head,
    pub runnable_at: ffi::c_ulong,
    pub core_sched_at: u64_,
    pub ddsp_dsq_id: u64_,
    pub ddsp_enq_flags: u64_,
    pub slice: u64_,
    pub dsq_vtime: u64_,
    pub disallow: bool_,
    pub cgrp_moving_from: *mut cgroup,
    pub tasks_node: list_head,
}
impl Default for sched_ext_entity {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn sched_ext_free(p: *mut task_struct);
}
extern "C" {
    pub fn print_scx_info(log_lvl: *const ffi::c_char, p: *mut task_struct);
}
extern "C" {
    pub fn scx_softlockup(dur_s: u32_);
}
pub const TASK_COMM_LEN: _bindgen_ty_10 = 16;
pub type _bindgen_ty_10 = ffi::c_uint;
extern "C" {
    pub fn sched_tick();
}
extern "C" {
    pub fn schedule_timeout(timeout: ffi::c_long) -> ffi::c_long;
}
extern "C" {
    pub fn schedule_timeout_interruptible(timeout: ffi::c_long) -> ffi::c_long;
}
extern "C" {
    pub fn schedule_timeout_killable(timeout: ffi::c_long) -> ffi::c_long;
}
extern "C" {
    pub fn schedule_timeout_uninterruptible(timeout: ffi::c_long) -> ffi::c_long;
}
extern "C" {
    pub fn schedule_timeout_idle(timeout: ffi::c_long) -> ffi::c_long;
}
extern "C" {
    pub fn schedule();
}
extern "C" {
    pub fn schedule_preempt_disabled();
}
extern "C" {
    pub fn preempt_schedule_irq();
}
extern "C" {
    #[must_use]
    pub fn io_schedule_prepare() -> ffi::c_int;
}
extern "C" {
    pub fn io_schedule_finish(token: ffi::c_int);
}
extern "C" {
    pub fn io_schedule_timeout(timeout: ffi::c_long) -> ffi::c_long;
}
extern "C" {
    pub fn io_schedule();
}
extern "C" {
    pub static mut __tracepoint_sched_set_state_tp: tracepoint;
}
extern "C" {
    pub fn __trace_set_current_state(state_value: ffi::c_int);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct prev_cputime {
    pub utime: u64_,
    pub stime: u64_,
    pub lock: raw_spinlock_t,
}
impl Default for prev_cputime {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const vtime_state_VTIME_INACTIVE: vtime_state = 0;
pub const vtime_state_VTIME_IDLE: vtime_state = 1;
pub const vtime_state_VTIME_SYS: vtime_state = 2;
pub const vtime_state_VTIME_USER: vtime_state = 3;
pub const vtime_state_VTIME_GUEST: vtime_state = 4;
pub type vtime_state = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct vtime {
    pub seqcount: seqcount_t,
    pub starttime: ffi::c_ulonglong,
    pub state: vtime_state,
    pub cpu: ffi::c_uint,
    pub utime: u64_,
    pub stime: u64_,
    pub gtime: u64_,
}
impl Default for vtime {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const uclamp_id_UCLAMP_MIN: uclamp_id = 0;
pub const uclamp_id_UCLAMP_MAX: uclamp_id = 1;
pub const uclamp_id_UCLAMP_CNT: uclamp_id = 2;
pub type uclamp_id = ffi::c_uint;
extern "C" {
    pub static mut def_root_domain: root_domain;
}
extern "C" {
    pub static mut sched_domains_mutex: mutex;
}
extern "C" {
    pub fn sched_domains_mutex_lock();
}
extern "C" {
    pub fn sched_domains_mutex_unlock();
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sched_param {
    pub sched_priority: ffi::c_int,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sched_info {
    pub pcount: ffi::c_ulong,
    pub run_delay: ffi::c_ulonglong,
    pub max_run_delay: ffi::c_ulonglong,
    pub min_run_delay: ffi::c_ulonglong,
    pub last_arrival: ffi::c_ulonglong,
    pub last_queued: ffi::c_ulonglong,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct load_weight {
    pub weight: ffi::c_ulong,
    pub inv_weight: u32_,
}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct sched_avg {
    pub last_update_time: u64_,
    pub load_sum: u64_,
    pub runnable_sum: u64_,
    pub util_sum: u32_,
    pub period_contrib: u32_,
    pub load_avg: ffi::c_ulong,
    pub runnable_avg: ffi::c_ulong,
    pub util_avg: ffi::c_ulong,
    pub util_est: ffi::c_uint,
}
impl Default for sched_avg {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct sched_statistics {
    pub wait_start: u64_,
    pub wait_max: u64_,
    pub wait_count: u64_,
    pub wait_sum: u64_,
    pub iowait_count: u64_,
    pub iowait_sum: u64_,
    pub sleep_start: u64_,
    pub sleep_max: u64_,
    pub sum_sleep_runtime: s64,
    pub block_start: u64_,
    pub block_max: u64_,
    pub sum_block_runtime: s64,
    pub exec_max: s64,
    pub slice_max: u64_,
    pub nr_migrations_cold: u64_,
    pub nr_failed_migrations_affine: u64_,
    pub nr_failed_migrations_running: u64_,
    pub nr_failed_migrations_hot: u64_,
    pub nr_forced_migrations: u64_,
    pub nr_wakeups: u64_,
    pub nr_wakeups_sync: u64_,
    pub nr_wakeups_migrate: u64_,
    pub nr_wakeups_local: u64_,
    pub nr_wakeups_remote: u64_,
    pub nr_wakeups_affine: u64_,
    pub nr_wakeups_affine_attempts: u64_,
    pub nr_wakeups_passive: u64_,
    pub nr_wakeups_idle: u64_,
    pub core_forceidle_sum: u64_,
}
impl Default for sched_statistics {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct sched_entity {
    pub load: load_weight,
    pub run_node: rb_node,
    pub deadline: u64_,
    pub min_vruntime: u64_,
    pub min_slice: u64_,
    pub group_node: list_head,
    pub on_rq: ffi::c_uchar,
    pub sched_delayed: ffi::c_uchar,
    pub rel_deadline: ffi::c_uchar,
    pub custom_slice: ffi::c_uchar,
    pub exec_start: u64_,
    pub sum_exec_runtime: u64_,
    pub prev_sum_exec_runtime: u64_,
    pub vruntime: u64_,
    pub vlag: s64,
    pub slice: u64_,
    pub nr_migrations: u64_,
    pub depth: ffi::c_int,
    pub parent: *mut sched_entity,
    pub cfs_rq: *mut cfs_rq,
    pub my_q: *mut cfs_rq,
    pub runnable_weight: ffi::c_ulong,
    pub __bindgen_padding_0: u64,
    pub avg: sched_avg,
}
impl Default for sched_entity {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sched_rt_entity {
    pub run_list: list_head,
    pub timeout: ffi::c_ulong,
    pub watchdog_stamp: ffi::c_ulong,
    pub time_slice: ffi::c_uint,
    pub on_rq: ffi::c_ushort,
    pub on_list: ffi::c_ushort,
    pub back: *mut sched_rt_entity,
}
impl Default for sched_rt_entity {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type dl_server_has_tasks_f =
    ::core::option::Option<unsafe extern "C" fn(arg1: *mut sched_dl_entity) -> bool_>;
pub type dl_server_pick_f =
    ::core::option::Option<unsafe extern "C" fn(arg1: *mut sched_dl_entity) -> *mut task_struct>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sched_dl_entity {
    pub rb_node: rb_node,
    pub dl_runtime: u64_,
    pub dl_deadline: u64_,
    pub dl_period: u64_,
    pub dl_bw: u64_,
    pub dl_density: u64_,
    pub runtime: s64,
    pub deadline: u64_,
    pub flags: ffi::c_uint,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
    pub dl_timer: hrtimer,
    pub inactive_timer: hrtimer,
    pub rq: *mut rq,
    pub server_has_tasks: dl_server_has_tasks_f,
    pub server_pick_task: dl_server_pick_f,
    pub pi_se: *mut sched_dl_entity,
}
impl Default for sched_dl_entity {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl sched_dl_entity {
    #[inline]
    pub fn dl_throttled(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_dl_throttled(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn dl_throttled_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_dl_throttled_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn dl_yielded(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_dl_yielded(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn dl_yielded_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_dl_yielded_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn dl_non_contending(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_dl_non_contending(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn dl_non_contending_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_dl_non_contending_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn dl_overrun(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_dl_overrun(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn dl_overrun_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_dl_overrun_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn dl_server(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_dl_server(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn dl_server_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_dl_server_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn dl_server_active(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_dl_server_active(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(5usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn dl_server_active_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_dl_server_active_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn dl_defer(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_dl_defer(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(6usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn dl_defer_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                6usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_dl_defer_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                6usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn dl_defer_armed(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_dl_defer_armed(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(7usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn dl_defer_armed_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                7usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_dl_defer_armed_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                7usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn dl_defer_running(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(8usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_dl_defer_running(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(8usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn dl_defer_running_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                8usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_dl_defer_running_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                8usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        dl_throttled: ffi::c_uint,
        dl_yielded: ffi::c_uint,
        dl_non_contending: ffi::c_uint,
        dl_overrun: ffi::c_uint,
        dl_server: ffi::c_uint,
        dl_server_active: ffi::c_uint,
        dl_defer: ffi::c_uint,
        dl_defer_armed: ffi::c_uint,
        dl_defer_running: ffi::c_uint,
    ) -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let dl_throttled: u32 = unsafe { ::core::mem::transmute(dl_throttled) };
            dl_throttled as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let dl_yielded: u32 = unsafe { ::core::mem::transmute(dl_yielded) };
            dl_yielded as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let dl_non_contending: u32 = unsafe { ::core::mem::transmute(dl_non_contending) };
            dl_non_contending as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let dl_overrun: u32 = unsafe { ::core::mem::transmute(dl_overrun) };
            dl_overrun as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let dl_server: u32 = unsafe { ::core::mem::transmute(dl_server) };
            dl_server as u64
        });
        __bindgen_bitfield_unit.set(5usize, 1u8, {
            let dl_server_active: u32 = unsafe { ::core::mem::transmute(dl_server_active) };
            dl_server_active as u64
        });
        __bindgen_bitfield_unit.set(6usize, 1u8, {
            let dl_defer: u32 = unsafe { ::core::mem::transmute(dl_defer) };
            dl_defer as u64
        });
        __bindgen_bitfield_unit.set(7usize, 1u8, {
            let dl_defer_armed: u32 = unsafe { ::core::mem::transmute(dl_defer_armed) };
            dl_defer_armed as u64
        });
        __bindgen_bitfield_unit.set(8usize, 1u8, {
            let dl_defer_running: u32 = unsafe { ::core::mem::transmute(dl_defer_running) };
            dl_defer_running as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[repr(align(4))]
#[derive(Default, Copy, Clone)]
pub struct uclamp_se {
    pub _bitfield_align_1: [u16; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
    pub __bindgen_padding_0: u16,
}
impl uclamp_se {
    #[inline]
    pub fn value(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 11u8) as u32) }
    }
    #[inline]
    pub fn set_value(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 11u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn value_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                11u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_value_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                11u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn bucket_id(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(11usize, 3u8) as u32) }
    }
    #[inline]
    pub fn set_bucket_id(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(11usize, 3u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn bucket_id_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                11usize,
                3u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_bucket_id_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                11usize,
                3u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn active(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(14usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_active(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(14usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn active_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                14usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_active_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                14usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn user_defined(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(15usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_user_defined(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(15usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn user_defined_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                15usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_user_defined_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                15usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        value: ffi::c_uint,
        bucket_id: ffi::c_uint,
        active: ffi::c_uint,
        user_defined: ffi::c_uint,
    ) -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 11u8, {
            let value: u32 = unsafe { ::core::mem::transmute(value) };
            value as u64
        });
        __bindgen_bitfield_unit.set(11usize, 3u8, {
            let bucket_id: u32 = unsafe { ::core::mem::transmute(bucket_id) };
            bucket_id as u64
        });
        __bindgen_bitfield_unit.set(14usize, 1u8, {
            let active: u32 = unsafe { ::core::mem::transmute(active) };
            active as u64
        });
        __bindgen_bitfield_unit.set(15usize, 1u8, {
            let user_defined: u32 = unsafe { ::core::mem::transmute(user_defined) };
            user_defined as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union rcu_special {
    pub b: rcu_special__bindgen_ty_1,
    pub s: u32_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct rcu_special__bindgen_ty_1 {
    pub blocked: u8_,
    pub need_qs: u8_,
    pub exp_hint: u8_,
    pub need_mb: u8_,
}
impl Default for rcu_special {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const perf_event_task_context_perf_invalid_context: perf_event_task_context = -1;
pub const perf_event_task_context_perf_hw_context: perf_event_task_context = 0;
pub const perf_event_task_context_perf_sw_context: perf_event_task_context = 1;
pub const perf_event_task_context_perf_nr_task_contexts: perf_event_task_context = 2;
pub type perf_event_task_context = ffi::c_int;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct wake_q_node {
    pub next: *mut wake_q_node,
}
impl Default for wake_q_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct kmap_ctrl {}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct task_struct {
    pub thread_info: thread_info,
    pub __state: ffi::c_uint,
    pub saved_state: ffi::c_uint,
    pub stack: *mut ffi::c_void,
    pub usage: refcount_t,
    pub flags: ffi::c_uint,
    pub ptrace: ffi::c_uint,
    pub on_cpu: ffi::c_int,
    pub wake_entry: __call_single_node,
    pub wakee_flips: ffi::c_uint,
    pub wakee_flip_decay_ts: ffi::c_ulong,
    pub last_wakee: *mut task_struct,
    pub recent_used_cpu: ffi::c_int,
    pub wake_cpu: ffi::c_int,
    pub on_rq: ffi::c_int,
    pub prio: ffi::c_int,
    pub static_prio: ffi::c_int,
    pub normal_prio: ffi::c_int,
    pub rt_priority: ffi::c_uint,
    pub __bindgen_padding_0: [u64; 7usize],
    pub se: sched_entity,
    pub rt: sched_rt_entity,
    pub dl: sched_dl_entity,
    pub dl_server: *mut sched_dl_entity,
    pub scx: sched_ext_entity,
    pub sched_class: *mut sched_class,
    pub core_node: rb_node,
    pub core_cookie: ffi::c_ulong,
    pub core_occupation: ffi::c_uint,
    pub sched_task_group: *mut task_group,
    pub uclamp_req: [uclamp_se; 2usize],
    pub uclamp: [uclamp_se; 2usize],
    pub __bindgen_padding_1: [u64; 7usize],
    pub stats: sched_statistics,
    pub preempt_notifiers: hlist_head,
    pub btrace_seq: ffi::c_uint,
    pub policy: ffi::c_uint,
    pub max_allowed_capacity: ffi::c_ulong,
    pub nr_cpus_allowed: ffi::c_int,
    pub cpus_ptr: *const cpumask_t,
    pub user_cpus_ptr: *mut cpumask_t,
    pub cpus_mask: cpumask_t,
    pub migration_pending: *mut ffi::c_void,
    pub migration_disabled: ffi::c_ushort,
    pub migration_flags: ffi::c_ushort,
    pub rcu_read_lock_nesting: ffi::c_int,
    pub rcu_read_unlock_special: rcu_special,
    pub rcu_node_entry: list_head,
    pub rcu_blocked_node: *mut rcu_node,
    pub rcu_tasks_nvcsw: ffi::c_ulong,
    pub rcu_tasks_holdout: u8_,
    pub rcu_tasks_idx: u8_,
    pub rcu_tasks_idle_cpu: ffi::c_int,
    pub rcu_tasks_holdout_list: list_head,
    pub rcu_tasks_exit_cpu: ffi::c_int,
    pub rcu_tasks_exit_list: list_head,
    pub trc_reader_nesting: ffi::c_int,
    pub trc_ipi_to_cpu: ffi::c_int,
    pub trc_reader_special: rcu_special,
    pub trc_holdout_list: list_head,
    pub trc_blkd_node: list_head,
    pub trc_blkd_cpu: ffi::c_int,
    pub sched_info: sched_info,
    pub tasks: list_head,
    pub pushable_tasks: plist_node,
    pub pushable_dl_tasks: rb_node,
    pub mm: *mut mm_struct,
    pub active_mm: *mut mm_struct,
    pub faults_disabled_mapping: *mut address_space,
    pub exit_state: ffi::c_int,
    pub exit_code: ffi::c_int,
    pub exit_signal: ffi::c_int,
    pub pdeath_signal: ffi::c_int,
    pub jobctl: ffi::c_ulong,
    pub personality: ffi::c_uint,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 6usize]>,
    pub atomic_flags: ffi::c_ulong,
    pub restart_block: restart_block,
    pub pid: pid_t,
    pub tgid: pid_t,
    pub stack_canary: ffi::c_ulong,
    pub real_parent: *mut task_struct,
    pub parent: *mut task_struct,
    pub children: list_head,
    pub sibling: list_head,
    pub group_leader: *mut task_struct,
    pub ptraced: list_head,
    pub ptrace_entry: list_head,
    pub thread_pid: *mut pid,
    pub pid_links: [hlist_node; 4usize],
    pub thread_node: list_head,
    pub vfork_done: *mut completion,
    pub set_child_tid: *mut ffi::c_int,
    pub clear_child_tid: *mut ffi::c_int,
    pub worker_private: *mut ffi::c_void,
    pub utime: u64_,
    pub stime: u64_,
    pub gtime: u64_,
    pub prev_cputime: prev_cputime,
    pub vtime: vtime,
    pub tick_dep_mask: atomic_t,
    pub nvcsw: ffi::c_ulong,
    pub nivcsw: ffi::c_ulong,
    pub start_time: u64_,
    pub start_boottime: u64_,
    pub min_flt: ffi::c_ulong,
    pub maj_flt: ffi::c_ulong,
    pub posix_cputimers: posix_cputimers,
    pub posix_cputimers_work: posix_cputimers_work,
    pub ptracer_cred: *const cred,
    pub real_cred: *const cred,
    pub cred: *const cred,
    pub cached_requested_key: *mut key,
    pub comm: [ffi::c_char; 16usize],
    pub nameidata: *mut nameidata,
    pub sysvsem: sysv_sem,
    pub sysvshm: sysv_shm,
    pub fs: *mut fs_struct,
    pub files: *mut files_struct,
    pub io_uring: *mut io_uring_task,
    pub nsproxy: *mut nsproxy,
    pub signal: *mut signal_struct,
    pub sighand: *mut sighand_struct,
    pub blocked: sigset_t,
    pub real_blocked: sigset_t,
    pub saved_sigmask: sigset_t,
    pub pending: sigpending,
    pub sas_ss_sp: ffi::c_ulong,
    pub sas_ss_size: usize,
    pub sas_ss_flags: ffi::c_uint,
    pub task_works: *mut callback_head,
    pub audit_context: *mut audit_context,
    pub loginuid: kuid_t,
    pub sessionid: ffi::c_uint,
    pub seccomp: seccomp,
    pub syscall_dispatch: syscall_user_dispatch,
    pub parent_exec_id: u64_,
    pub self_exec_id: u64_,
    pub alloc_lock: spinlock_t,
    pub pi_lock: raw_spinlock_t,
    pub wake_q: wake_q_node,
    pub pi_waiters: rb_root_cached,
    pub pi_top_task: *mut task_struct,
    pub pi_blocked_on: *mut rt_mutex_waiter,
    pub in_ubsan: ffi::c_uint,
    pub journal_info: *mut ffi::c_void,
    pub bio_list: *mut bio_list,
    pub plug: *mut blk_plug,
    pub reclaim_state: *mut reclaim_state,
    pub io_context: *mut io_context,
    pub capture_control: *mut capture_control,
    pub ptrace_message: ffi::c_ulong,
    pub last_siginfo: *mut kernel_siginfo_t,
    pub ioac: task_io_accounting,
    pub psi_flags: ffi::c_uint,
    pub acct_rss_mem1: u64_,
    pub acct_vm_mem1: u64_,
    pub acct_timexpd: u64_,
    pub mems_allowed: nodemask_t,
    pub mems_allowed_seq: seqcount_spinlock_t,
    pub cpuset_mem_spread_rotor: ffi::c_int,
    pub cgroups: *mut css_set,
    pub cg_list: list_head,
    pub robust_list: *mut robust_list_head,
    pub compat_robust_list: *mut compat_robust_list_head,
    pub pi_state_list: list_head,
    pub pi_state_cache: *mut futex_pi_state,
    pub futex_exit_mutex: mutex,
    pub futex_state: ffi::c_uint,
    pub perf_recursion: [u8_; 4usize],
    pub perf_event_ctxp: *mut perf_event_context,
    pub perf_event_mutex: mutex,
    pub perf_event_list: list_head,
    pub perf_ctx_data: *mut perf_ctx_data,
    pub mempolicy: *mut mempolicy,
    pub il_prev: ffi::c_short,
    pub il_weight: u8_,
    pub pref_node_fork: ffi::c_short,
    pub numa_scan_seq: ffi::c_int,
    pub numa_scan_period: ffi::c_uint,
    pub numa_scan_period_max: ffi::c_uint,
    pub numa_preferred_nid: ffi::c_int,
    pub numa_migrate_retry: ffi::c_ulong,
    pub node_stamp: u64_,
    pub last_task_numa_placement: u64_,
    pub last_sum_exec_runtime: u64_,
    pub numa_work: callback_head,
    pub numa_group: *mut numa_group,
    pub numa_faults: *mut ffi::c_ulong,
    pub total_numa_faults: ffi::c_ulong,
    pub numa_faults_locality: [ffi::c_ulong; 3usize],
    pub numa_pages_migrated: ffi::c_ulong,
    pub rseq: *mut rseq,
    pub rseq_len: u32_,
    pub rseq_sig: u32_,
    pub rseq_event_mask: ffi::c_ulong,
    pub mm_cid: ffi::c_int,
    pub last_mm_cid: ffi::c_int,
    pub migrate_from_cpu: ffi::c_int,
    pub mm_cid_active: ffi::c_int,
    pub cid_work: callback_head,
    pub tlb_ubc: tlbflush_unmap_batch,
    pub splice_pipe: *mut pipe_inode_info,
    pub task_frag: page_frag,
    pub delays: *mut task_delay_info,
    pub nr_dirtied: ffi::c_int,
    pub nr_dirtied_pause: ffi::c_int,
    pub dirty_paused_when: ffi::c_ulong,
    pub latency_record_count: ffi::c_int,
    pub latency_record: [latency_record; 32usize],
    pub timer_slack_ns: u64_,
    pub default_timer_slack_ns: u64_,
    pub kunit_test: *mut kunit,
    pub curr_ret_stack: ffi::c_int,
    pub curr_ret_depth: ffi::c_int,
    pub ret_stack: *mut ffi::c_ulong,
    pub ftrace_timestamp: ffi::c_ulonglong,
    pub ftrace_sleeptime: ffi::c_ulonglong,
    pub trace_overrun: atomic_t,
    pub tracing_graph_pause: atomic_t,
    pub trace_recursion: ffi::c_ulong,
    pub memcg_in_oom: *mut mem_cgroup,
    pub memcg_nr_pages_over_high: ffi::c_uint,
    pub active_memcg: *mut mem_cgroup,
    pub objcg: *mut obj_cgroup,
    pub throttle_disk: *mut gendisk,
    pub utask: *mut uprobe_task,
    pub sequential_io: ffi::c_uint,
    pub sequential_io_avg: ffi::c_uint,
    pub kmap_ctrl: kmap_ctrl,
    pub rcu: callback_head,
    pub rcu_users: refcount_t,
    pub pagefault_disabled: ffi::c_int,
    pub oom_reaper_list: *mut task_struct,
    pub oom_reaper_timer: timer_list,
    pub stack_vm_area: *mut vm_struct,
    pub stack_refcount: refcount_t,
    pub security: *mut ffi::c_void,
    pub bpf_storage: *mut bpf_local_storage,
    pub bpf_ctx: *mut bpf_run_ctx,
    pub bpf_net_context: *mut bpf_net_context,
    pub kretprobe_instances: llist_head,
    pub rv: [rv_task_monitor; 1usize],
    pub __bindgen_padding_2: u64,
    pub thread: thread_struct,
}
impl Default for task_struct {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl task_struct {
    #[inline]
    pub fn sched_reset_on_fork(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_sched_reset_on_fork(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn sched_reset_on_fork_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_sched_reset_on_fork_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn sched_contributes_to_load(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_sched_contributes_to_load(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn sched_contributes_to_load_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_sched_contributes_to_load_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn sched_migrated(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_sched_migrated(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn sched_migrated_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_sched_migrated_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn sched_task_hot(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_sched_task_hot(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn sched_task_hot_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_sched_task_hot_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn sched_remote_wakeup(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(32usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_sched_remote_wakeup(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(32usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn sched_remote_wakeup_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                32usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_sched_remote_wakeup_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                32usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn sched_rt_mutex(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(33usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_sched_rt_mutex(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(33usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn sched_rt_mutex_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                33usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_sched_rt_mutex_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                33usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn in_execve(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(34usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_in_execve(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(34usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn in_execve_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                34usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_in_execve_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                34usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn in_iowait(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(35usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_in_iowait(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(35usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn in_iowait_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                35usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_in_iowait_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                35usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn in_user_fault(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(36usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_in_user_fault(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(36usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn in_user_fault_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                36usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_in_user_fault_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                36usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn in_lru_fault(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(37usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_in_lru_fault(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(37usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn in_lru_fault_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                37usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_in_lru_fault_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                37usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn no_cgroup_migration(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(38usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_no_cgroup_migration(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(38usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn no_cgroup_migration_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                38usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_no_cgroup_migration_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                38usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn frozen(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(39usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_frozen(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(39usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn frozen_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                39usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_frozen_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                39usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn use_memdelay(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(40usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_use_memdelay(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(40usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn use_memdelay_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                40usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_use_memdelay_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                40usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn in_memstall(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(41usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_in_memstall(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(41usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn in_memstall_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                41usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_in_memstall_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                41usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn in_page_owner(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(42usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_in_page_owner(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(42usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn in_page_owner_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                42usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_in_page_owner_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                42usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn in_eventfd(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(43usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_in_eventfd(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(43usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn in_eventfd_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                43usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_in_eventfd_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                43usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn in_thrashing(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(44usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_in_thrashing(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(44usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn in_thrashing_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                44usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_in_thrashing_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                44usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        sched_reset_on_fork: ffi::c_uint,
        sched_contributes_to_load: ffi::c_uint,
        sched_migrated: ffi::c_uint,
        sched_task_hot: ffi::c_uint,
        sched_remote_wakeup: ffi::c_uint,
        sched_rt_mutex: ffi::c_uint,
        in_execve: ffi::c_uint,
        in_iowait: ffi::c_uint,
        in_user_fault: ffi::c_uint,
        in_lru_fault: ffi::c_uint,
        no_cgroup_migration: ffi::c_uint,
        frozen: ffi::c_uint,
        use_memdelay: ffi::c_uint,
        in_memstall: ffi::c_uint,
        in_page_owner: ffi::c_uint,
        in_eventfd: ffi::c_uint,
        in_thrashing: ffi::c_uint,
    ) -> __BindgenBitfieldUnit<[u8; 6usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 6usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let sched_reset_on_fork: u32 = unsafe { ::core::mem::transmute(sched_reset_on_fork) };
            sched_reset_on_fork as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let sched_contributes_to_load: u32 =
                unsafe { ::core::mem::transmute(sched_contributes_to_load) };
            sched_contributes_to_load as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let sched_migrated: u32 = unsafe { ::core::mem::transmute(sched_migrated) };
            sched_migrated as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let sched_task_hot: u32 = unsafe { ::core::mem::transmute(sched_task_hot) };
            sched_task_hot as u64
        });
        __bindgen_bitfield_unit.set(32usize, 1u8, {
            let sched_remote_wakeup: u32 = unsafe { ::core::mem::transmute(sched_remote_wakeup) };
            sched_remote_wakeup as u64
        });
        __bindgen_bitfield_unit.set(33usize, 1u8, {
            let sched_rt_mutex: u32 = unsafe { ::core::mem::transmute(sched_rt_mutex) };
            sched_rt_mutex as u64
        });
        __bindgen_bitfield_unit.set(34usize, 1u8, {
            let in_execve: u32 = unsafe { ::core::mem::transmute(in_execve) };
            in_execve as u64
        });
        __bindgen_bitfield_unit.set(35usize, 1u8, {
            let in_iowait: u32 = unsafe { ::core::mem::transmute(in_iowait) };
            in_iowait as u64
        });
        __bindgen_bitfield_unit.set(36usize, 1u8, {
            let in_user_fault: u32 = unsafe { ::core::mem::transmute(in_user_fault) };
            in_user_fault as u64
        });
        __bindgen_bitfield_unit.set(37usize, 1u8, {
            let in_lru_fault: u32 = unsafe { ::core::mem::transmute(in_lru_fault) };
            in_lru_fault as u64
        });
        __bindgen_bitfield_unit.set(38usize, 1u8, {
            let no_cgroup_migration: u32 = unsafe { ::core::mem::transmute(no_cgroup_migration) };
            no_cgroup_migration as u64
        });
        __bindgen_bitfield_unit.set(39usize, 1u8, {
            let frozen: u32 = unsafe { ::core::mem::transmute(frozen) };
            frozen as u64
        });
        __bindgen_bitfield_unit.set(40usize, 1u8, {
            let use_memdelay: u32 = unsafe { ::core::mem::transmute(use_memdelay) };
            use_memdelay as u64
        });
        __bindgen_bitfield_unit.set(41usize, 1u8, {
            let in_memstall: u32 = unsafe { ::core::mem::transmute(in_memstall) };
            in_memstall as u64
        });
        __bindgen_bitfield_unit.set(42usize, 1u8, {
            let in_page_owner: u32 = unsafe { ::core::mem::transmute(in_page_owner) };
            in_page_owner as u64
        });
        __bindgen_bitfield_unit.set(43usize, 1u8, {
            let in_eventfd: u32 = unsafe { ::core::mem::transmute(in_eventfd) };
            in_eventfd as u64
        });
        __bindgen_bitfield_unit.set(44usize, 1u8, {
            let in_thrashing: u32 = unsafe { ::core::mem::transmute(in_thrashing) };
            in_thrashing as u64
        });
        __bindgen_bitfield_unit
    }
}
extern "C" {
    pub static mut cad_pid: *mut pid;
}
extern "C" {
    pub fn cpuset_cpumask_can_shrink(cur: *const cpumask, trial: *const cpumask) -> ffi::c_int;
}
extern "C" {
    pub fn task_can_attach(p: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn dl_bw_alloc(cpu: ffi::c_int, dl_bw: u64_) -> ffi::c_int;
}
extern "C" {
    pub fn dl_bw_free(cpu: ffi::c_int, dl_bw: u64_);
}
extern "C" {
    pub fn do_set_cpus_allowed(p: *mut task_struct, new_mask: *const cpumask);
}
extern "C" {
    pub fn set_cpus_allowed_ptr(p: *mut task_struct, new_mask: *const cpumask) -> ffi::c_int;
}
extern "C" {
    pub fn dup_user_cpus_ptr(
        dst: *mut task_struct,
        src: *mut task_struct,
        node: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn release_user_cpus_ptr(p: *mut task_struct);
}
extern "C" {
    pub fn dl_task_check_affinity(p: *mut task_struct, mask: *const cpumask) -> ffi::c_int;
}
extern "C" {
    pub fn force_compatible_cpus_allowed_ptr(p: *mut task_struct);
}
extern "C" {
    pub fn relax_compatible_cpus_allowed_ptr(p: *mut task_struct);
}
extern "C" {
    pub fn yield_to(p: *mut task_struct, preempt: bool_) -> ffi::c_int;
}
extern "C" {
    pub fn set_user_nice(p: *mut task_struct, nice: ffi::c_long);
}
extern "C" {
    pub fn task_prio(p: *const task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn can_nice(p: *const task_struct, nice: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn task_curr(p: *const task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn idle_cpu(cpu: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn available_idle_cpu(cpu: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn sched_setscheduler(
        arg1: *mut task_struct,
        arg2: ffi::c_int,
        arg3: *const sched_param,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sched_setscheduler_nocheck(
        arg1: *mut task_struct,
        arg2: ffi::c_int,
        arg3: *const sched_param,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sched_set_fifo(p: *mut task_struct);
}
extern "C" {
    pub fn sched_set_fifo_low(p: *mut task_struct);
}
extern "C" {
    pub fn sched_set_normal(p: *mut task_struct, nice: ffi::c_int);
}
extern "C" {
    pub fn sched_setattr(arg1: *mut task_struct, arg2: *const sched_attr) -> ffi::c_int;
}
extern "C" {
    pub fn sched_setattr_nocheck(arg1: *mut task_struct, arg2: *const sched_attr) -> ffi::c_int;
}
extern "C" {
    pub fn idle_task(cpu: ffi::c_int) -> *mut task_struct;
}
extern "C" {
    pub fn curr_task(cpu: ffi::c_int) -> *mut task_struct;
}
extern "C" {
    pub fn ia64_set_curr_task(cpu: ffi::c_int, p: *mut task_struct);
}
extern "C" {
    #[link_name = "\u{1}yield"]
    pub fn yield_();
}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub union thread_union {
    pub task: task_struct,
    pub stack: [ffi::c_ulong; 2048usize],
}
impl Default for thread_union {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut init_stack: [ffi::c_ulong; 2048usize];
}
extern "C" {
    pub fn find_task_by_vpid(nr: pid_t) -> *mut task_struct;
}
extern "C" {
    pub fn find_task_by_pid_ns(nr: pid_t, ns: *mut pid_namespace) -> *mut task_struct;
}
extern "C" {
    pub fn find_get_task_by_vpid(nr: pid_t) -> *mut task_struct;
}
extern "C" {
    pub fn wake_up_state(tsk: *mut task_struct, state: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn wake_up_process(tsk: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn wake_up_new_task(tsk: *mut task_struct);
}
extern "C" {
    pub fn kick_process(tsk: *mut task_struct);
}
extern "C" {
    pub fn __set_task_comm(tsk: *mut task_struct, from: *const ffi::c_char, exec: bool_);
}
extern "C" {
    pub fn wait_task_inactive(arg1: *mut task_struct, match_state: ffi::c_uint) -> ffi::c_ulong;
}
extern "C" {
    pub fn __cond_resched() -> ffi::c_int;
}
extern "C" {
    pub fn dynamic_cond_resched() -> ffi::c_int;
}
extern "C" {
    pub fn __cond_resched_lock(lock: *mut spinlock_t) -> ffi::c_int;
}
extern "C" {
    pub fn __cond_resched_rwlock_read(lock: *mut rwlock_t) -> ffi::c_int;
}
extern "C" {
    pub fn __cond_resched_rwlock_write(lock: *mut rwlock_t) -> ffi::c_int;
}
extern "C" {
    pub fn set_task_cpu(p: *mut task_struct, cpu: ffi::c_uint);
}
extern "C" {
    pub fn sched_task_on_rq(p: *mut task_struct) -> bool_;
}
extern "C" {
    pub fn get_wchan(p: *mut task_struct) -> ffi::c_ulong;
}
extern "C" {
    pub fn cpu_curr_snapshot(cpu: ffi::c_int) -> *mut task_struct;
}
extern "C" {
    pub fn sched_setaffinity(pid: pid_t, new_mask: *const cpumask) -> ffi::c_long;
}
extern "C" {
    pub fn sched_getaffinity(pid: pid_t, mask: *mut cpumask) -> ffi::c_long;
}
extern "C" {
    pub fn sched_cpu_util(cpu: ffi::c_int) -> ffi::c_ulong;
}
extern "C" {
    pub fn sched_core_free(tsk: *mut task_struct);
}
extern "C" {
    pub fn sched_core_fork(p: *mut task_struct);
}
extern "C" {
    pub fn sched_core_share_pid(
        cmd: ffi::c_uint,
        pid: pid_t,
        type_: pid_type,
        uaddr: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sched_core_idle_cpu(cpu: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn sched_set_stop_task(cpu: ffi::c_int, stop: *mut task_struct);
}
extern "C" {
    pub static mut pcpu_base_addr: *mut ffi::c_void;
}
extern "C" {
    pub static mut pcpu_unit_offsets: *const ffi::c_ulong;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct pcpu_group_info {
    pub nr_units: ffi::c_int,
    pub base_offset: ffi::c_ulong,
    pub cpu_map: *mut ffi::c_uint,
}
impl Default for pcpu_group_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct pcpu_alloc_info {
    pub static_size: usize,
    pub reserved_size: usize,
    pub dyn_size: usize,
    pub unit_size: usize,
    pub atom_size: usize,
    pub alloc_size: usize,
    pub __ai_size: usize,
    pub nr_groups: ffi::c_int,
    pub groups: __IncompleteArrayField<pcpu_group_info>,
}
impl Default for pcpu_alloc_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const pcpu_fc_PCPU_FC_AUTO: pcpu_fc = 0;
pub const pcpu_fc_PCPU_FC_EMBED: pcpu_fc = 1;
pub const pcpu_fc_PCPU_FC_PAGE: pcpu_fc = 2;
pub const pcpu_fc_PCPU_FC_NR: pcpu_fc = 3;
pub type pcpu_fc = ffi::c_uint;
extern "C" {
    pub static pcpu_fc_names: [*const ffi::c_char; 3usize];
}
extern "C" {
    pub static mut pcpu_chosen_fc: pcpu_fc;
}
pub type pcpu_fc_cpu_to_node_fn_t =
    ::core::option::Option<unsafe extern "C" fn(cpu: ffi::c_int) -> ffi::c_int>;
pub type pcpu_fc_cpu_distance_fn_t =
    ::core::option::Option<unsafe extern "C" fn(from: ffi::c_uint, to: ffi::c_uint) -> ffi::c_int>;
extern "C" {
    pub fn pcpu_alloc_alloc_info(
        nr_groups: ffi::c_int,
        nr_units: ffi::c_int,
    ) -> *mut pcpu_alloc_info;
}
extern "C" {
    pub fn pcpu_free_alloc_info(ai: *mut pcpu_alloc_info);
}
extern "C" {
    pub fn pcpu_setup_first_chunk(ai: *const pcpu_alloc_info, base_addr: *mut ffi::c_void);
}
extern "C" {
    pub fn pcpu_embed_first_chunk(
        reserved_size: usize,
        dyn_size: usize,
        atom_size: usize,
        cpu_distance_fn: pcpu_fc_cpu_distance_fn_t,
        cpu_to_nd_fn: pcpu_fc_cpu_to_node_fn_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pcpu_populate_pte(addr: ffi::c_ulong);
}
extern "C" {
    pub fn pcpu_page_first_chunk(
        reserved_size: usize,
        cpu_to_nd_fn: pcpu_fc_cpu_to_node_fn_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __is_kernel_percpu_address(addr: ffi::c_ulong, can_addr: *mut ffi::c_ulong) -> bool_;
}
extern "C" {
    pub fn is_kernel_percpu_address(addr: ffi::c_ulong) -> bool_;
}
extern "C" {
    pub fn pcpu_alloc_noprof(
        size: usize,
        align: usize,
        reserved: bool_,
        gfp: gfp_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn free_percpu(__pdata: *mut ffi::c_void);
}
extern "C" {
    pub fn per_cpu_ptr_to_phys(addr: *mut ffi::c_void) -> phys_addr_t;
}
extern "C" {
    pub fn pcpu_nr_pages() -> ffi::c_ulong;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct cyclecounter {
    pub read: ::core::option::Option<unsafe extern "C" fn(cc: *const cyclecounter) -> u64_>,
    pub mask: u64_,
    pub mult: u32_,
    pub shift: u32_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct timecounter {
    pub cc: *const cyclecounter,
    pub cycle_last: u64_,
    pub nsec: u64_,
    pub mask: u64_,
    pub frac: u64_,
}
impl Default for timecounter {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn timecounter_init(tc: *mut timecounter, cc: *const cyclecounter, start_tstamp: u64_);
}
extern "C" {
    pub fn timecounter_read(tc: *mut timecounter) -> u64_;
}
extern "C" {
    pub fn timecounter_cyc2time(tc: *const timecounter, cycle_tstamp: u64_) -> u64_;
}
pub const arch_timer_reg_ARCH_TIMER_REG_CTRL: arch_timer_reg = 0;
pub const arch_timer_reg_ARCH_TIMER_REG_CVAL: arch_timer_reg = 1;
pub type arch_timer_reg = ffi::c_uint;
pub const arch_timer_ppi_nr_ARCH_TIMER_PHYS_SECURE_PPI: arch_timer_ppi_nr = 0;
pub const arch_timer_ppi_nr_ARCH_TIMER_PHYS_NONSECURE_PPI: arch_timer_ppi_nr = 1;
pub const arch_timer_ppi_nr_ARCH_TIMER_VIRT_PPI: arch_timer_ppi_nr = 2;
pub const arch_timer_ppi_nr_ARCH_TIMER_HYP_PPI: arch_timer_ppi_nr = 3;
pub const arch_timer_ppi_nr_ARCH_TIMER_HYP_VIRT_PPI: arch_timer_ppi_nr = 4;
pub const arch_timer_ppi_nr_ARCH_TIMER_MAX_TIMER_PPI: arch_timer_ppi_nr = 5;
pub type arch_timer_ppi_nr = ffi::c_uint;
pub const arch_timer_spi_nr_ARCH_TIMER_PHYS_SPI: arch_timer_spi_nr = 0;
pub const arch_timer_spi_nr_ARCH_TIMER_VIRT_SPI: arch_timer_spi_nr = 1;
pub const arch_timer_spi_nr_ARCH_TIMER_MAX_TIMER_SPI: arch_timer_spi_nr = 2;
pub type arch_timer_spi_nr = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct arch_timer_kvm_info {
    pub timecounter: timecounter,
    pub virtual_irq: ffi::c_int,
    pub physical_irq: ffi::c_int,
}
impl Default for arch_timer_kvm_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct arch_timer_mem_frame {
    pub valid: bool_,
    pub cntbase: phys_addr_t,
    pub size: usize,
    pub phys_irq: ffi::c_int,
    pub virt_irq: ffi::c_int,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct arch_timer_mem {
    pub cntctlbase: phys_addr_t,
    pub size: usize,
    pub frame: [arch_timer_mem_frame; 8usize],
}
extern "C" {
    pub fn arch_timer_get_rate() -> u32_;
}
extern "C" {
    pub static mut arch_timer_read_counter: ::core::option::Option<unsafe extern "C" fn() -> u64_>;
}
extern "C" {
    pub fn arch_timer_get_kvm_info() -> *mut arch_timer_kvm_info;
}
extern "C" {
    pub fn arch_timer_evtstrm_available() -> bool_;
}
pub const arch_timer_erratum_match_type_ate_match_dt: arch_timer_erratum_match_type = 0;
pub const arch_timer_erratum_match_type_ate_match_local_cap_id: arch_timer_erratum_match_type = 1;
pub const arch_timer_erratum_match_type_ate_match_acpi_oem_info: arch_timer_erratum_match_type = 2;
pub type arch_timer_erratum_match_type = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct clock_event_device {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct arch_timer_erratum_workaround {
    pub match_type: arch_timer_erratum_match_type,
    pub id: *const ffi::c_void,
    pub desc: *const ffi::c_char,
    pub read_cntpct_el0: ::core::option::Option<unsafe extern "C" fn() -> u64_>,
    pub read_cntvct_el0: ::core::option::Option<unsafe extern "C" fn() -> u64_>,
    pub set_next_event_phys: ::core::option::Option<
        unsafe extern "C" fn(arg1: ffi::c_ulong, arg2: *mut clock_event_device) -> ffi::c_int,
    >,
    pub set_next_event_virt: ::core::option::Option<
        unsafe extern "C" fn(arg1: ffi::c_ulong, arg2: *mut clock_event_device) -> ffi::c_int,
    >,
    pub disable_compat_vdso: bool_,
}
impl Default for arch_timer_erratum_workaround {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut timer_unstable_counter_workaround: *const arch_timer_erratum_workaround;
}
pub type cycles_t = ffi::c_ulong;
extern "C" {
    pub fn do_adjtimex(arg1: *mut __kernel_timex) -> ffi::c_int;
}
extern "C" {
    pub fn do_clock_adjtime(which_clock: clockid_t, ktx: *mut __kernel_timex) -> ffi::c_int;
}
extern "C" {
    pub fn hardpps(arg1: *const timespec64, arg2: *const timespec64);
}
extern "C" {
    pub fn read_current_timer(timer_val: *mut ffi::c_ulong) -> ffi::c_int;
}
pub type old_time32_t = s32;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct old_timespec32 {
    pub tv_sec: old_time32_t,
    pub tv_nsec: s32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct old_timeval32 {
    pub tv_sec: old_time32_t,
    pub tv_usec: s32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct old_itimerspec32 {
    pub it_interval: old_timespec32,
    pub it_value: old_timespec32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct old_utimbuf32 {
    pub actime: old_time32_t,
    pub modtime: old_time32_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct old_timex32 {
    pub modes: u32_,
    pub offset: s32,
    pub freq: s32,
    pub maxerror: s32,
    pub esterror: s32,
    pub status: s32,
    pub constant: s32,
    pub precision: s32,
    pub tolerance: s32,
    pub time: old_timeval32,
    pub tick: s32,
    pub ppsfreq: s32,
    pub jitter: s32,
    pub shift: s32,
    pub stabil: s32,
    pub jitcnt: s32,
    pub calcnt: s32,
    pub errcnt: s32,
    pub stbcnt: s32,
    pub tai: s32,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 44usize]>,
}
impl Default for old_timex32 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn get_old_timespec32(arg1: *mut timespec64, arg2: *const ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn put_old_timespec32(arg1: *const timespec64, arg2: *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn get_old_itimerspec32(
        its: *mut itimerspec64,
        uits: *const old_itimerspec32,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn put_old_itimerspec32(
        its: *const itimerspec64,
        uits: *mut old_itimerspec32,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn get_old_timex32(arg1: *mut __kernel_timex, arg2: *const old_timex32) -> ffi::c_int;
}
extern "C" {
    pub fn put_old_timex32(arg1: *mut old_timex32, arg2: *const __kernel_timex) -> ffi::c_int;
}
extern "C" {
    pub fn ns_to_kernel_old_timeval(nsec: s64) -> __kernel_old_timeval;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct timens_offset {
    pub sec: s64,
    pub nsec: u64_,
}
pub type compat_mode_t = u16_;
pub type __compat_uid_t = u16_;
pub type __compat_gid_t = u16_;
pub type compat_ipc_pid_t = u16_;
pub type compat_size_t = u32_;
pub type compat_ssize_t = s32;
pub type compat_clock_t = s32;
pub type compat_pid_t = s32;
pub type compat_ino_t = u32_;
pub type compat_off_t = s32;
pub type compat_loff_t = s64;
pub type compat_daddr_t = s32;
pub type compat_timer_t = s32;
pub type compat_key_t = s32;
pub type compat_short_t = s16;
pub type compat_int_t = s32;
pub type compat_long_t = s32;
pub type compat_ushort_t = u16_;
pub type compat_uint_t = u32_;
pub type compat_ulong_t = u32_;
pub type compat_uptr_t = u32_;
pub type compat_caddr_t = u32_;
pub type compat_aio_context_t = u32_;
pub type compat_old_sigset_t = u32_;
pub type __compat_uid32_t = u32_;
pub type __compat_gid32_t = u32_;
pub type compat_s64 = s64;
pub type compat_u64 = u64_;
pub type compat_sigset_word = u32_;
pub type compat_dev_t = u32_;
pub type compat_fsid_t = __kernel_fsid_t;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_ipc64_perm {
    pub key: compat_key_t,
    pub uid: __compat_uid32_t,
    pub gid: __compat_gid32_t,
    pub cuid: __compat_uid32_t,
    pub cgid: __compat_gid32_t,
    pub mode: compat_mode_t,
    pub __pad1: [ffi::c_uchar; 2usize],
    pub seq: compat_ushort_t,
    pub __pad2: compat_ushort_t,
    pub unused1: compat_ulong_t,
    pub unused2: compat_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_semid64_ds {
    pub sem_perm: compat_ipc64_perm,
    pub sem_otime: compat_ulong_t,
    pub sem_otime_high: compat_ulong_t,
    pub sem_ctime: compat_ulong_t,
    pub sem_ctime_high: compat_ulong_t,
    pub sem_nsems: compat_ulong_t,
    pub __unused3: compat_ulong_t,
    pub __unused4: compat_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_msqid64_ds {
    pub msg_perm: compat_ipc64_perm,
    pub msg_stime: compat_ulong_t,
    pub msg_stime_high: compat_ulong_t,
    pub msg_rtime: compat_ulong_t,
    pub msg_rtime_high: compat_ulong_t,
    pub msg_ctime: compat_ulong_t,
    pub msg_ctime_high: compat_ulong_t,
    pub msg_cbytes: compat_ulong_t,
    pub msg_qnum: compat_ulong_t,
    pub msg_qbytes: compat_ulong_t,
    pub msg_lspid: compat_pid_t,
    pub msg_lrpid: compat_pid_t,
    pub __unused4: compat_ulong_t,
    pub __unused5: compat_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_shmid64_ds {
    pub shm_perm: compat_ipc64_perm,
    pub shm_segsz: compat_size_t,
    pub shm_atime: compat_ulong_t,
    pub shm_atime_high: compat_ulong_t,
    pub shm_dtime: compat_ulong_t,
    pub shm_dtime_high: compat_ulong_t,
    pub shm_ctime: compat_ulong_t,
    pub shm_ctime_high: compat_ulong_t,
    pub shm_cpid: compat_pid_t,
    pub shm_lpid: compat_pid_t,
    pub shm_nattch: compat_ulong_t,
    pub __unused4: compat_ulong_t,
    pub __unused5: compat_ulong_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kmem_cache {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct slab {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct vm_struct {
    _unused: [u8; 0],
}
pub type kasan_vmalloc_flags_t = ffi::c_uint;
extern "C" {
    pub fn put_task_stack(tsk: *mut task_struct);
}
extern "C" {
    pub fn exit_task_stack_account(tsk: *mut task_struct);
}
extern "C" {
    pub fn thread_stack_cache_init();
}
extern "C" {
    pub fn set_task_stack_end_magic(tsk: *mut task_struct);
}
pub type __compat_uid16_t = u16_;
pub type __compat_gid16_t = u16_;
pub type compat_nlink_t = s32;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_stat {
    pub st_dev: compat_dev_t,
    pub st_ino: compat_ino_t,
    pub st_mode: compat_mode_t,
    pub st_nlink: compat_ushort_t,
    pub st_uid: __compat_uid16_t,
    pub st_gid: __compat_gid16_t,
    pub st_rdev: compat_dev_t,
    pub st_size: compat_off_t,
    pub st_blksize: compat_off_t,
    pub st_blocks: compat_off_t,
    pub st_atime: old_time32_t,
    pub st_atime_nsec: compat_ulong_t,
    pub st_mtime: old_time32_t,
    pub st_mtime_nsec: compat_ulong_t,
    pub st_ctime: old_time32_t,
    pub st_ctime_nsec: compat_ulong_t,
    pub __unused4: [compat_ulong_t; 2usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_statfs {
    pub f_type: ffi::c_int,
    pub f_bsize: ffi::c_int,
    pub f_blocks: ffi::c_int,
    pub f_bfree: ffi::c_int,
    pub f_bavail: ffi::c_int,
    pub f_files: ffi::c_int,
    pub f_ffree: ffi::c_int,
    pub f_fsid: compat_fsid_t,
    pub f_namelen: ffi::c_int,
    pub f_frsize: ffi::c_int,
    pub f_flags: ffi::c_int,
    pub f_spare: [ffi::c_int; 4usize],
}
extern "C" {
    pub fn compat_arm_syscall(regs: *mut pt_regs, scno: ffi::c_int) -> ffi::c_long;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct stat64 {
    pub st_dev: compat_u64,
    pub __pad0: [ffi::c_uchar; 4usize],
    pub __st_ino: compat_ulong_t,
    pub st_mode: compat_uint_t,
    pub st_nlink: compat_uint_t,
    pub st_uid: compat_ulong_t,
    pub st_gid: compat_ulong_t,
    pub st_rdev: compat_u64,
    pub __pad3: [ffi::c_uchar; 4usize],
    pub st_size: compat_s64,
    pub st_blksize: compat_ulong_t,
    pub st_blocks: compat_u64,
    pub st_atime: compat_ulong_t,
    pub st_atime_nsec: compat_ulong_t,
    pub st_mtime: compat_ulong_t,
    pub st_mtime_nsec: compat_ulong_t,
    pub st_ctime: compat_ulong_t,
    pub st_ctime_nsec: compat_ulong_t,
    pub st_ino: compat_u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct statx_timestamp {
    pub tv_sec: __s64,
    pub tv_nsec: __u32,
    pub __reserved: __s32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct statx {
    pub stx_mask: __u32,
    pub stx_blksize: __u32,
    pub stx_attributes: __u64,
    pub stx_nlink: __u32,
    pub stx_uid: __u32,
    pub stx_gid: __u32,
    pub stx_mode: __u16,
    pub __spare0: [__u16; 1usize],
    pub stx_ino: __u64,
    pub stx_size: __u64,
    pub stx_blocks: __u64,
    pub stx_attributes_mask: __u64,
    pub stx_atime: statx_timestamp,
    pub stx_btime: statx_timestamp,
    pub stx_ctime: statx_timestamp,
    pub stx_mtime: statx_timestamp,
    pub stx_rdev_major: __u32,
    pub stx_rdev_minor: __u32,
    pub stx_dev_major: __u32,
    pub stx_dev_minor: __u32,
    pub stx_mnt_id: __u64,
    pub stx_dio_mem_align: __u32,
    pub stx_dio_offset_align: __u32,
    pub stx_subvol: __u64,
    pub stx_atomic_write_unit_min: __u32,
    pub stx_atomic_write_unit_max: __u32,
    pub stx_atomic_write_segments_max: __u32,
    pub stx_dio_read_offset_align: __u32,
    pub __spare3: [__u64; 9usize],
}
extern "C" {
    pub static mut overflowuid: ffi::c_int;
}
extern "C" {
    pub static mut overflowgid: ffi::c_int;
}
extern "C" {
    pub fn __bad_uid();
}
extern "C" {
    pub fn __bad_gid();
}
extern "C" {
    pub static mut fs_overflowuid: ffi::c_int;
}
extern "C" {
    pub static mut fs_overflowgid: ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct user_namespace {
    pub uid_map: uid_gid_map,
    pub gid_map: uid_gid_map,
    pub projid_map: uid_gid_map,
    pub parent: *mut user_namespace,
    pub level: ffi::c_int,
    pub owner: kuid_t,
    pub group: kgid_t,
    pub ns: ns_common,
    pub flags: ffi::c_ulong,
    pub parent_could_setfcap: bool_,
    pub keyring_name_list: list_head,
    pub user_keyring_register: *mut key,
    pub keyring_sem: rw_semaphore,
    pub persistent_keyring_register: *mut key,
    pub work: work_struct,
    pub set: ctl_table_set,
    pub sysctls: *mut ctl_table_header,
    pub ucounts: *mut ucounts,
    pub ucount_max: [ffi::c_long; 12usize],
    pub rlimit_max: [ffi::c_long; 4usize],
    pub binfmt_misc: *mut binfmt_misc,
}
impl Default for user_namespace {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut init_user_ns: user_namespace;
}
extern "C" {
    pub fn make_kuid(from: *mut user_namespace, uid: uid_t) -> kuid_t;
}
extern "C" {
    pub fn make_kgid(from: *mut user_namespace, gid: gid_t) -> kgid_t;
}
extern "C" {
    pub fn from_kuid(to: *mut user_namespace, uid: kuid_t) -> uid_t;
}
extern "C" {
    pub fn from_kgid(to: *mut user_namespace, gid: kgid_t) -> gid_t;
}
extern "C" {
    pub fn from_kuid_munged(to: *mut user_namespace, uid: kuid_t) -> uid_t;
}
extern "C" {
    pub fn from_kgid_munged(to: *mut user_namespace, gid: kgid_t) -> gid_t;
}
extern "C" {
    pub fn map_id_down(map: *mut uid_gid_map, id: u32_) -> u32_;
}
extern "C" {
    pub fn map_id_up(map: *mut uid_gid_map, id: u32_) -> u32_;
}
extern "C" {
    pub fn map_id_range_up(map: *mut uid_gid_map, id: u32_, count: u32_) -> u32_;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct kstat {
    pub result_mask: u32_,
    pub mode: umode_t,
    pub nlink: ffi::c_uint,
    pub blksize: u32,
    pub attributes: u64_,
    pub attributes_mask: u64_,
    pub ino: u64_,
    pub dev: dev_t,
    pub rdev: dev_t,
    pub uid: kuid_t,
    pub gid: kgid_t,
    pub size: loff_t,
    pub atime: timespec64,
    pub mtime: timespec64,
    pub ctime: timespec64,
    pub btime: timespec64,
    pub blocks: u64_,
    pub mnt_id: u64_,
    pub change_cookie: u64_,
    pub subvol: u64_,
    pub dio_mem_align: u32_,
    pub dio_offset_align: u32_,
    pub dio_read_offset_align: u32_,
    pub atomic_write_unit_min: u32_,
    pub atomic_write_unit_max: u32_,
    pub atomic_write_segments_max: u32_,
}
extern "C" {
    pub fn build_id_parse(
        vma: *mut vm_area_struct,
        build_id: *mut ffi::c_uchar,
        size: *mut __u32,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn build_id_parse_nofault(
        vma: *mut vm_area_struct,
        build_id: *mut ffi::c_uchar,
        size: *mut __u32,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn build_id_parse_buf(
        buf: *const ffi::c_void,
        build_id: *mut ffi::c_uchar,
        buf_size: u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub static mut vmlinux_build_id: [ffi::c_uchar; 20usize];
}
extern "C" {
    pub fn init_vmlinux_build_id();
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct hlist_nulls_head {
    pub first: *mut hlist_nulls_node,
}
impl Default for hlist_nulls_head {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct hlist_nulls_node {
    pub next: *mut hlist_nulls_node,
    pub pprev: *mut *mut hlist_nulls_node,
}
impl Default for hlist_nulls_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type wait_queue_entry_t = wait_queue_entry;
pub type wait_queue_func_t = ::core::option::Option<
    unsafe extern "C" fn(
        wq_entry: *mut wait_queue_entry,
        mode: ffi::c_uint,
        flags: ffi::c_int,
        key: *mut ffi::c_void,
    ) -> ffi::c_int,
>;
extern "C" {
    pub fn default_wake_function(
        wq_entry: *mut wait_queue_entry,
        mode: ffi::c_uint,
        flags: ffi::c_int,
        key: *mut ffi::c_void,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct wait_queue_entry {
    pub flags: ffi::c_uint,
    pub private: *mut ffi::c_void,
    pub func: wait_queue_func_t,
    pub entry: list_head,
}
impl Default for wait_queue_entry {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct wait_queue_head {
    pub lock: spinlock_t,
    pub head: list_head,
}
impl Default for wait_queue_head {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type wait_queue_head_t = wait_queue_head;
extern "C" {
    pub fn __init_waitqueue_head(
        wq_head: *mut wait_queue_head,
        name: *const ffi::c_char,
        arg1: *mut lock_class_key,
    );
}
extern "C" {
    pub fn add_wait_queue(wq_head: *mut wait_queue_head, wq_entry: *mut wait_queue_entry);
}
extern "C" {
    pub fn add_wait_queue_exclusive(wq_head: *mut wait_queue_head, wq_entry: *mut wait_queue_entry);
}
extern "C" {
    pub fn add_wait_queue_priority(wq_head: *mut wait_queue_head, wq_entry: *mut wait_queue_entry);
}
extern "C" {
    pub fn remove_wait_queue(wq_head: *mut wait_queue_head, wq_entry: *mut wait_queue_entry);
}
extern "C" {
    pub fn __wake_up(
        wq_head: *mut wait_queue_head,
        mode: ffi::c_uint,
        nr: ffi::c_int,
        key: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __wake_up_on_current_cpu(
        wq_head: *mut wait_queue_head,
        mode: ffi::c_uint,
        key: *mut ffi::c_void,
    );
}
extern "C" {
    pub fn __wake_up_locked_key(
        wq_head: *mut wait_queue_head,
        mode: ffi::c_uint,
        key: *mut ffi::c_void,
    );
}
extern "C" {
    pub fn __wake_up_sync_key(
        wq_head: *mut wait_queue_head,
        mode: ffi::c_uint,
        key: *mut ffi::c_void,
    );
}
extern "C" {
    pub fn __wake_up_locked_sync_key(
        wq_head: *mut wait_queue_head,
        mode: ffi::c_uint,
        key: *mut ffi::c_void,
    );
}
extern "C" {
    pub fn __wake_up_locked(wq_head: *mut wait_queue_head, mode: ffi::c_uint, nr: ffi::c_int);
}
extern "C" {
    pub fn __wake_up_sync(wq_head: *mut wait_queue_head, mode: ffi::c_uint);
}
extern "C" {
    pub fn __wake_up_pollfree(wq_head: *mut wait_queue_head);
}
extern "C" {
    pub fn init_wait_entry(wq_entry: *mut wait_queue_entry, flags: ffi::c_int);
}
extern "C" {
    pub fn do_wait_intr(arg1: *mut wait_queue_head_t, arg2: *mut wait_queue_entry_t) -> ffi::c_int;
}
extern "C" {
    pub fn do_wait_intr_irq(
        arg1: *mut wait_queue_head_t,
        arg2: *mut wait_queue_entry_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn prepare_to_wait(
        wq_head: *mut wait_queue_head,
        wq_entry: *mut wait_queue_entry,
        state: ffi::c_int,
    );
}
extern "C" {
    pub fn prepare_to_wait_exclusive(
        wq_head: *mut wait_queue_head,
        wq_entry: *mut wait_queue_entry,
        state: ffi::c_int,
    ) -> bool_;
}
extern "C" {
    pub fn prepare_to_wait_event(
        wq_head: *mut wait_queue_head,
        wq_entry: *mut wait_queue_entry,
        state: ffi::c_int,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn finish_wait(wq_head: *mut wait_queue_head, wq_entry: *mut wait_queue_entry);
}
extern "C" {
    pub fn wait_woken(
        wq_entry: *mut wait_queue_entry,
        mode: ffi::c_uint,
        timeout: ffi::c_long,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn woken_wake_function(
        wq_entry: *mut wait_queue_entry,
        mode: ffi::c_uint,
        sync: ffi::c_int,
        key: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn autoremove_wake_function(
        wq_entry: *mut wait_queue_entry,
        mode: ffi::c_uint,
        sync: ffi::c_int,
        key: *mut ffi::c_void,
    ) -> ffi::c_int;
}
pub type task_call_f = ::core::option::Option<
    unsafe extern "C" fn(p: *mut task_struct, arg: *mut ffi::c_void) -> ffi::c_int,
>;
extern "C" {
    pub fn task_call_func(
        p: *mut task_struct,
        func: task_call_f,
        arg: *mut ffi::c_void,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct seqcount_latch_t {
    pub seqcount: seqcount_t,
}
pub const pageblock_bits_PB_migrate: pageblock_bits = 0;
pub const pageblock_bits_PB_migrate_end: pageblock_bits = 2;
pub const pageblock_bits_PB_migrate_skip: pageblock_bits = 3;
pub const pageblock_bits_NR_PAGEBLOCK_BITS: pageblock_bits = 4;
pub type pageblock_bits = ffi::c_uint;
extern "C" {
    pub fn get_pfnblock_flags_mask(
        page: *const page,
        pfn: ffi::c_ulong,
        mask: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn set_pfnblock_flags_mask(
        page: *mut page,
        flags: ffi::c_ulong,
        pfn: ffi::c_ulong,
        mask: ffi::c_ulong,
    );
}
extern "C" {
    pub fn ct_irq_enter();
}
extern "C" {
    pub fn ct_irq_exit();
}
extern "C" {
    pub fn ct_irq_enter_irqson();
}
extern "C" {
    pub fn ct_irq_exit_irqson();
}
extern "C" {
    pub fn ct_nmi_enter();
}
extern "C" {
    pub fn ct_nmi_exit();
}
extern "C" {
    pub fn call_rcu(head: *mut callback_head, func: rcu_callback_t);
}
extern "C" {
    pub fn rcu_barrier_tasks();
}
extern "C" {
    pub fn synchronize_rcu();
}
extern "C" {
    pub fn get_completed_synchronize_rcu() -> ffi::c_ulong;
}
extern "C" {
    pub fn get_completed_synchronize_rcu_full(rgosp: *mut rcu_gp_oldstate);
}
extern "C" {
    pub fn __rcu_read_lock();
}
extern "C" {
    pub fn __rcu_read_unlock();
}
extern "C" {
    pub fn rcu_init();
}
extern "C" {
    pub static mut rcu_scheduler_active: ffi::c_int;
}
extern "C" {
    pub fn rcu_sched_clock_irq(user: ffi::c_int);
}
extern "C" {
    pub fn rcu_sysrq_start();
}
extern "C" {
    pub fn rcu_sysrq_end();
}
extern "C" {
    pub fn rcu_irq_work_resched();
}
extern "C" {
    pub fn rcu_init_nohz();
}
extern "C" {
    pub fn rcu_nocb_cpu_offload(cpu: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn rcu_nocb_cpu_deoffload(cpu: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn rcu_nocb_flush_deferred_wakeup();
}
extern "C" {
    pub fn call_rcu_tasks(head: *mut callback_head, func: rcu_callback_t);
}
extern "C" {
    pub fn synchronize_rcu_tasks();
}
extern "C" {
    pub fn rcu_tasks_torture_stats_print(tt: *mut ffi::c_char, tf: *mut ffi::c_char);
}
extern "C" {
    pub fn rcu_trc_cmpxchg_need_qs(t: *mut task_struct, old: u8_, new: u8_) -> u8_;
}
extern "C" {
    pub fn rcu_tasks_trace_qs_blkd(t: *mut task_struct);
}
extern "C" {
    pub fn rcu_tasks_trace_torture_stats_print(tt: *mut ffi::c_char, tf: *mut ffi::c_char);
}
extern "C" {
    pub fn synchronize_rcu_tasks_rude();
}
extern "C" {
    pub fn rcu_tasks_rude_torture_stats_print(tt: *mut ffi::c_char, tf: *mut ffi::c_char);
}
extern "C" {
    pub fn exit_tasks_rcu_start();
}
extern "C" {
    pub fn exit_tasks_rcu_finish();
}
extern "C" {
    pub fn rcu_softirq_qs();
}
extern "C" {
    pub fn rcu_note_context_switch(preempt: bool_);
}
extern "C" {
    pub fn rcu_needs_cpu() -> ffi::c_int;
}
extern "C" {
    pub fn rcu_cpu_stall_reset();
}
extern "C" {
    pub fn rcu_request_urgent_qs_task(t: *mut task_struct);
}
extern "C" {
    pub fn synchronize_rcu_expedited();
}
extern "C" {
    pub fn rcu_barrier();
}
extern "C" {
    pub fn rcu_momentary_eqs();
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct rcu_gp_oldstate {
    pub rgos_norm: ffi::c_ulong,
    pub rgos_exp: ffi::c_ulong,
}
extern "C" {
    pub fn start_poll_synchronize_rcu_expedited() -> ffi::c_ulong;
}
extern "C" {
    pub fn start_poll_synchronize_rcu_expedited_full(rgosp: *mut rcu_gp_oldstate);
}
extern "C" {
    pub fn cond_synchronize_rcu_expedited(oldstate: ffi::c_ulong);
}
extern "C" {
    pub fn cond_synchronize_rcu_expedited_full(rgosp: *mut rcu_gp_oldstate);
}
extern "C" {
    pub fn get_state_synchronize_rcu() -> ffi::c_ulong;
}
extern "C" {
    pub fn get_state_synchronize_rcu_full(rgosp: *mut rcu_gp_oldstate);
}
extern "C" {
    pub fn start_poll_synchronize_rcu() -> ffi::c_ulong;
}
extern "C" {
    pub fn start_poll_synchronize_rcu_full(rgosp: *mut rcu_gp_oldstate);
}
extern "C" {
    pub fn poll_state_synchronize_rcu(oldstate: ffi::c_ulong) -> bool_;
}
extern "C" {
    pub fn poll_state_synchronize_rcu_full(rgosp: *mut rcu_gp_oldstate) -> bool_;
}
extern "C" {
    pub fn cond_synchronize_rcu(oldstate: ffi::c_ulong);
}
extern "C" {
    pub fn cond_synchronize_rcu_full(rgosp: *mut rcu_gp_oldstate);
}
extern "C" {
    pub fn rcu_preempt_deferred_qs(t: *mut task_struct);
}
extern "C" {
    pub fn exit_rcu();
}
extern "C" {
    pub fn rcu_scheduler_starting();
}
extern "C" {
    pub fn rcu_end_inkernel_boot();
}
extern "C" {
    pub fn rcu_inkernel_boot_has_ended() -> bool_;
}
extern "C" {
    pub fn rcu_is_watching() -> bool_;
}
extern "C" {
    pub fn rcutree_prepare_cpu(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn rcutree_online_cpu(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn rcutree_report_cpu_starting(cpu: ffi::c_uint);
}
extern "C" {
    pub fn rcutree_dead_cpu(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn rcutree_dying_cpu(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn rcutree_offline_cpu(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn rcutree_migrate_callbacks(cpu: ffi::c_int);
}
extern "C" {
    pub fn rcutree_report_cpu_dead();
}
extern "C" {
    pub static mut rcu_lock_map: lockdep_map;
}
extern "C" {
    pub static mut rcu_bh_lock_map: lockdep_map;
}
extern "C" {
    pub static mut rcu_sched_lock_map: lockdep_map;
}
extern "C" {
    pub static mut rcu_callback_map: lockdep_map;
}
extern "C" {
    pub fn kvfree_call_rcu(head: *mut callback_head, ptr: *mut ffi::c_void);
}
extern "C" {
    pub static mut rcu_expedited: ffi::c_int;
}
extern "C" {
    pub static mut rcu_normal: ffi::c_int;
}
pub const class_rcu_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_rcu_t {
    pub lock: *mut ffi::c_void,
}
impl Default for class_rcu_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn rb_insert_color(arg1: *mut rb_node, arg2: *mut rb_root);
}
extern "C" {
    pub fn rb_erase(arg1: *mut rb_node, arg2: *mut rb_root);
}
extern "C" {
    pub fn rb_next(arg1: *const rb_node) -> *mut rb_node;
}
extern "C" {
    pub fn rb_prev(arg1: *const rb_node) -> *mut rb_node;
}
extern "C" {
    pub fn rb_first(arg1: *const rb_root) -> *mut rb_node;
}
extern "C" {
    pub fn rb_last(arg1: *const rb_root) -> *mut rb_node;
}
extern "C" {
    pub fn rb_first_postorder(arg1: *const rb_root) -> *mut rb_node;
}
extern "C" {
    pub fn rb_next_postorder(arg1: *const rb_node) -> *mut rb_node;
}
extern "C" {
    pub fn rb_replace_node(victim: *mut rb_node, new: *mut rb_node, root: *mut rb_root);
}
extern "C" {
    pub fn rb_replace_node_rcu(victim: *mut rb_node, new: *mut rb_node, root: *mut rb_root);
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct maple_metadata {
    pub end: ffi::c_uchar,
    pub gap: ffi::c_uchar,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct maple_range_64 {
    pub parent: *mut maple_pnode,
    pub pivot: [ffi::c_ulong; 15usize],
    pub __bindgen_anon_1: maple_range_64__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union maple_range_64__bindgen_ty_1 {
    pub slot: [*mut ffi::c_void; 16usize],
    pub __bindgen_anon_1: maple_range_64__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct maple_range_64__bindgen_ty_1__bindgen_ty_1 {
    pub pad: [*mut ffi::c_void; 15usize],
    pub meta: maple_metadata,
}
impl Default for maple_range_64__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for maple_range_64__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for maple_range_64 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct maple_arange_64 {
    pub parent: *mut maple_pnode,
    pub pivot: [ffi::c_ulong; 9usize],
    pub slot: [*mut ffi::c_void; 10usize],
    pub gap: [ffi::c_ulong; 10usize],
    pub meta: maple_metadata,
}
impl Default for maple_arange_64 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct maple_alloc {
    pub total: ffi::c_ulong,
    pub node_count: ffi::c_uchar,
    pub request_count: ffi::c_uint,
    pub slot: [*mut maple_alloc; 30usize],
}
impl Default for maple_alloc {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct maple_topiary {
    pub parent: *mut maple_pnode,
    pub next: *mut maple_enode,
}
impl Default for maple_topiary {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const maple_type_maple_dense: maple_type = 0;
pub const maple_type_maple_leaf_64: maple_type = 1;
pub const maple_type_maple_range_64: maple_type = 2;
pub const maple_type_maple_arange_64: maple_type = 3;
pub type maple_type = ffi::c_uint;
pub const store_type_wr_invalid: store_type = 0;
pub const store_type_wr_new_root: store_type = 1;
pub const store_type_wr_store_root: store_type = 2;
pub const store_type_wr_exact_fit: store_type = 3;
pub const store_type_wr_spanning_store: store_type = 4;
pub const store_type_wr_split_store: store_type = 5;
pub const store_type_wr_rebalance: store_type = 6;
pub const store_type_wr_append: store_type = 7;
pub const store_type_wr_node_store: store_type = 8;
pub const store_type_wr_slot_store: store_type = 9;
pub type store_type = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct lockdep_map_p {}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct maple_tree {
    pub __bindgen_anon_1: maple_tree__bindgen_ty_1,
    pub ma_flags: ffi::c_uint,
    pub ma_root: *mut ffi::c_void,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union maple_tree__bindgen_ty_1 {
    pub ma_lock: spinlock_t,
    pub ma_external_lock: lockdep_map_p,
}
impl Default for maple_tree__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for maple_tree {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct maple_node {
    pub __bindgen_anon_1: maple_node__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union maple_node__bindgen_ty_1 {
    pub __bindgen_anon_1: maple_node__bindgen_ty_1__bindgen_ty_1,
    pub __bindgen_anon_2: maple_node__bindgen_ty_1__bindgen_ty_2,
    pub mr64: maple_range_64,
    pub ma64: maple_arange_64,
    pub alloc: maple_alloc,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct maple_node__bindgen_ty_1__bindgen_ty_1 {
    pub parent: *mut maple_pnode,
    pub slot: [*mut ffi::c_void; 31usize],
}
impl Default for maple_node__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct maple_node__bindgen_ty_1__bindgen_ty_2 {
    pub pad: *mut ffi::c_void,
    pub rcu: callback_head,
    pub piv_parent: *mut maple_enode,
    pub parent_slot: ffi::c_uchar,
    pub type_: maple_type,
    pub slot_len: ffi::c_uchar,
    pub ma_flags: ffi::c_uint,
}
impl Default for maple_node__bindgen_ty_1__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for maple_node__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for maple_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ma_topiary {
    pub head: *mut maple_enode,
    pub tail: *mut maple_enode,
    pub mtree: *mut maple_tree,
}
impl Default for ma_topiary {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn mtree_load(mt: *mut maple_tree, index: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn mtree_insert(
        mt: *mut maple_tree,
        index: ffi::c_ulong,
        entry: *mut ffi::c_void,
        gfp: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mtree_insert_range(
        mt: *mut maple_tree,
        first: ffi::c_ulong,
        last: ffi::c_ulong,
        entry: *mut ffi::c_void,
        gfp: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mtree_alloc_range(
        mt: *mut maple_tree,
        startp: *mut ffi::c_ulong,
        entry: *mut ffi::c_void,
        size: ffi::c_ulong,
        min: ffi::c_ulong,
        max: ffi::c_ulong,
        gfp: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mtree_alloc_cyclic(
        mt: *mut maple_tree,
        startp: *mut ffi::c_ulong,
        entry: *mut ffi::c_void,
        range_lo: ffi::c_ulong,
        range_hi: ffi::c_ulong,
        next: *mut ffi::c_ulong,
        gfp: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mtree_alloc_rrange(
        mt: *mut maple_tree,
        startp: *mut ffi::c_ulong,
        entry: *mut ffi::c_void,
        size: ffi::c_ulong,
        min: ffi::c_ulong,
        max: ffi::c_ulong,
        gfp: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mtree_store_range(
        mt: *mut maple_tree,
        first: ffi::c_ulong,
        last: ffi::c_ulong,
        entry: *mut ffi::c_void,
        gfp: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mtree_store(
        mt: *mut maple_tree,
        index: ffi::c_ulong,
        entry: *mut ffi::c_void,
        gfp: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mtree_erase(mt: *mut maple_tree, index: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn mtree_dup(mt: *mut maple_tree, new: *mut maple_tree, gfp: gfp_t) -> ffi::c_int;
}
extern "C" {
    pub fn __mt_dup(mt: *mut maple_tree, new: *mut maple_tree, gfp: gfp_t) -> ffi::c_int;
}
extern "C" {
    pub fn mtree_destroy(mt: *mut maple_tree);
}
extern "C" {
    pub fn __mt_destroy(mt: *mut maple_tree);
}
pub const maple_status_ma_active: maple_status = 0;
pub const maple_status_ma_start: maple_status = 1;
pub const maple_status_ma_root: maple_status = 2;
pub const maple_status_ma_none: maple_status = 3;
pub const maple_status_ma_pause: maple_status = 4;
pub const maple_status_ma_overflow: maple_status = 5;
pub const maple_status_ma_underflow: maple_status = 6;
pub const maple_status_ma_error: maple_status = 7;
pub type maple_status = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ma_state {
    pub tree: *mut maple_tree,
    pub index: ffi::c_ulong,
    pub last: ffi::c_ulong,
    pub node: *mut maple_enode,
    pub min: ffi::c_ulong,
    pub max: ffi::c_ulong,
    pub alloc: *mut maple_alloc,
    pub status: maple_status,
    pub depth: ffi::c_uchar,
    pub offset: ffi::c_uchar,
    pub mas_flags: ffi::c_uchar,
    pub end: ffi::c_uchar,
    pub store_type: store_type,
}
impl Default for ma_state {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ma_wr_state {
    pub mas: *mut ma_state,
    pub node: *mut maple_node,
    pub r_min: ffi::c_ulong,
    pub r_max: ffi::c_ulong,
    pub type_: maple_type,
    pub offset_end: ffi::c_uchar,
    pub pivots: *mut ffi::c_ulong,
    pub end_piv: ffi::c_ulong,
    pub slots: *mut *mut ffi::c_void,
    pub entry: *mut ffi::c_void,
    pub content: *mut ffi::c_void,
}
impl Default for ma_wr_state {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn mas_walk(mas: *mut ma_state) -> *mut ffi::c_void;
}
extern "C" {
    pub fn mas_store(mas: *mut ma_state, entry: *mut ffi::c_void) -> *mut ffi::c_void;
}
extern "C" {
    pub fn mas_erase(mas: *mut ma_state) -> *mut ffi::c_void;
}
extern "C" {
    pub fn mas_store_gfp(mas: *mut ma_state, entry: *mut ffi::c_void, gfp: gfp_t) -> ffi::c_int;
}
extern "C" {
    pub fn mas_store_prealloc(mas: *mut ma_state, entry: *mut ffi::c_void);
}
extern "C" {
    pub fn mas_find(mas: *mut ma_state, max: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn mas_find_range(mas: *mut ma_state, max: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn mas_find_rev(mas: *mut ma_state, min: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn mas_find_range_rev(mas: *mut ma_state, max: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn mas_preallocate(mas: *mut ma_state, entry: *mut ffi::c_void, gfp: gfp_t) -> ffi::c_int;
}
extern "C" {
    pub fn mas_alloc_cyclic(
        mas: *mut ma_state,
        startp: *mut ffi::c_ulong,
        entry: *mut ffi::c_void,
        range_lo: ffi::c_ulong,
        range_hi: ffi::c_ulong,
        next: *mut ffi::c_ulong,
        gfp: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mas_nomem(mas: *mut ma_state, gfp: gfp_t) -> bool_;
}
extern "C" {
    pub fn mas_pause(mas: *mut ma_state);
}
extern "C" {
    pub fn maple_tree_init();
}
extern "C" {
    pub fn mas_destroy(mas: *mut ma_state);
}
extern "C" {
    pub fn mas_expected_entries(mas: *mut ma_state, nr_entries: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn mas_prev(mas: *mut ma_state, min: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn mas_prev_range(mas: *mut ma_state, max: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn mas_next(mas: *mut ma_state, max: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn mas_next_range(mas: *mut ma_state, max: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn mas_empty_area(
        mas: *mut ma_state,
        min: ffi::c_ulong,
        max: ffi::c_ulong,
        size: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mas_empty_area_rev(
        mas: *mut ma_state,
        min: ffi::c_ulong,
        max: ffi::c_ulong,
        size: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mt_find(
        mt: *mut maple_tree,
        index: *mut ffi::c_ulong,
        max: ffi::c_ulong,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn mt_find_after(
        mt: *mut maple_tree,
        index: *mut ffi::c_ulong,
        max: ffi::c_ulong,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn mt_prev(mt: *mut maple_tree, index: ffi::c_ulong, min: ffi::c_ulong)
        -> *mut ffi::c_void;
}
extern "C" {
    pub fn mt_next(mt: *mut maple_tree, index: ffi::c_ulong, max: ffi::c_ulong)
        -> *mut ffi::c_void;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rw_semaphore {
    pub count: atomic_long_t,
    pub owner: atomic_long_t,
    pub osq: optimistic_spin_queue,
    pub wait_lock: raw_spinlock_t,
    pub wait_list: list_head,
}
impl Default for rw_semaphore {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn __init_rwsem(sem: *mut rw_semaphore, name: *const ffi::c_char, key: *mut lock_class_key);
}
extern "C" {
    pub fn down_read(sem: *mut rw_semaphore);
}
extern "C" {
    #[must_use]
    pub fn down_read_interruptible(sem: *mut rw_semaphore) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn down_read_killable(sem: *mut rw_semaphore) -> ffi::c_int;
}
extern "C" {
    pub fn down_read_trylock(sem: *mut rw_semaphore) -> ffi::c_int;
}
extern "C" {
    pub fn down_write(sem: *mut rw_semaphore);
}
extern "C" {
    #[must_use]
    pub fn down_write_killable(sem: *mut rw_semaphore) -> ffi::c_int;
}
extern "C" {
    pub fn down_write_trylock(sem: *mut rw_semaphore) -> ffi::c_int;
}
extern "C" {
    pub fn up_read(sem: *mut rw_semaphore);
}
extern "C" {
    pub fn up_write(sem: *mut rw_semaphore);
}
pub type class_rwsem_read_t = *mut rw_semaphore;
pub const class_rwsem_read_is_conditional: bool_ = false;
pub const class_rwsem_read_try_is_conditional: bool_ = true;
pub type class_rwsem_read_try_t = class_rwsem_read_t;
pub const class_rwsem_read_intr_is_conditional: bool_ = true;
pub type class_rwsem_read_intr_t = class_rwsem_read_t;
pub type class_rwsem_write_t = *mut rw_semaphore;
pub const class_rwsem_write_is_conditional: bool_ = false;
pub const class_rwsem_write_try_is_conditional: bool_ = true;
pub type class_rwsem_write_try_t = class_rwsem_write_t;
extern "C" {
    pub fn downgrade_write(sem: *mut rw_semaphore);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct swait_queue_head {
    pub lock: raw_spinlock_t,
    pub task_list: list_head,
}
impl Default for swait_queue_head {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct swait_queue {
    pub task: *mut task_struct,
    pub task_list: list_head,
}
impl Default for swait_queue {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn __init_swait_queue_head(
        q: *mut swait_queue_head,
        name: *const ffi::c_char,
        key: *mut lock_class_key,
    );
}
extern "C" {
    pub fn swake_up_one(q: *mut swait_queue_head);
}
extern "C" {
    pub fn swake_up_all(q: *mut swait_queue_head);
}
extern "C" {
    pub fn swake_up_locked(q: *mut swait_queue_head, wake_flags: ffi::c_int);
}
extern "C" {
    pub fn prepare_to_swait_exclusive(
        q: *mut swait_queue_head,
        wait: *mut swait_queue,
        state: ffi::c_int,
    );
}
extern "C" {
    pub fn prepare_to_swait_event(
        q: *mut swait_queue_head,
        wait: *mut swait_queue,
        state: ffi::c_int,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn __finish_swait(q: *mut swait_queue_head, wait: *mut swait_queue);
}
extern "C" {
    pub fn finish_swait(q: *mut swait_queue_head, wait: *mut swait_queue);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct completion {
    pub done: ffi::c_uint,
    pub wait: swait_queue_head,
}
impl Default for completion {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn wait_for_completion(arg1: *mut completion);
}
extern "C" {
    pub fn wait_for_completion_io(arg1: *mut completion);
}
extern "C" {
    pub fn wait_for_completion_interruptible(x: *mut completion) -> ffi::c_int;
}
extern "C" {
    pub fn wait_for_completion_killable(x: *mut completion) -> ffi::c_int;
}
extern "C" {
    pub fn wait_for_completion_state(x: *mut completion, state: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn wait_for_completion_timeout(x: *mut completion, timeout: ffi::c_ulong) -> ffi::c_ulong;
}
extern "C" {
    pub fn wait_for_completion_io_timeout(
        x: *mut completion,
        timeout: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn wait_for_completion_interruptible_timeout(
        x: *mut completion,
        timeout: ffi::c_ulong,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn wait_for_completion_killable_timeout(
        x: *mut completion,
        timeout: ffi::c_ulong,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn try_wait_for_completion(x: *mut completion) -> bool_;
}
extern "C" {
    pub fn completion_done(x: *mut completion) -> bool_;
}
extern "C" {
    pub fn complete(arg1: *mut completion);
}
extern "C" {
    pub fn complete_on_current_cpu(x: *mut completion);
}
extern "C" {
    pub fn complete_all(arg1: *mut completion);
}
extern "C" {
    pub fn register_refined_jiffies(clock_tick_rate: ffi::c_long) -> ffi::c_int;
}
extern "C" {
    pub static mut jiffies_64: u64_;
}
extern "C" {
    pub static mut jiffies: ffi::c_ulong;
}
extern "C" {
    pub static mut preset_lpj: ffi::c_ulong;
}
extern "C" {
    pub fn jiffies_to_msecs(j: ffi::c_ulong) -> ffi::c_uint;
}
extern "C" {
    pub fn jiffies_to_usecs(j: ffi::c_ulong) -> ffi::c_uint;
}
extern "C" {
    pub fn jiffies64_to_nsecs(j: u64_) -> u64_;
}
extern "C" {
    pub fn jiffies64_to_msecs(j: u64_) -> u64_;
}
extern "C" {
    pub fn __msecs_to_jiffies(m: ffi::c_uint) -> ffi::c_ulong;
}
extern "C" {
    pub fn __usecs_to_jiffies(u: ffi::c_uint) -> ffi::c_ulong;
}
extern "C" {
    pub fn timespec64_to_jiffies(value: *const timespec64) -> ffi::c_ulong;
}
extern "C" {
    pub fn jiffies_to_timespec64(jiffies: ffi::c_ulong, value: *mut timespec64);
}
extern "C" {
    pub fn jiffies_to_clock_t(x: ffi::c_ulong) -> clock_t;
}
extern "C" {
    pub fn clock_t_to_jiffies(x: ffi::c_ulong) -> ffi::c_ulong;
}
extern "C" {
    pub fn jiffies_64_to_clock_t(x: u64_) -> u64_;
}
extern "C" {
    pub fn nsec_to_clock_t(x: u64_) -> u64_;
}
extern "C" {
    pub fn nsecs_to_jiffies64(n: u64_) -> u64_;
}
extern "C" {
    pub fn nsecs_to_jiffies(n: u64_) -> ffi::c_ulong;
}
extern "C" {
    pub fn ktime_add_safe(lhs: ktime_t, rhs: ktime_t) -> ktime_t;
}
pub const clocksource_ids_CSID_GENERIC: clocksource_ids = 0;
pub const clocksource_ids_CSID_ARM_ARCH_COUNTER: clocksource_ids = 1;
pub const clocksource_ids_CSID_S390_TOD: clocksource_ids = 2;
pub const clocksource_ids_CSID_X86_TSC_EARLY: clocksource_ids = 3;
pub const clocksource_ids_CSID_X86_TSC: clocksource_ids = 4;
pub const clocksource_ids_CSID_X86_KVM_CLK: clocksource_ids = 5;
pub const clocksource_ids_CSID_X86_ART: clocksource_ids = 6;
pub const clocksource_ids_CSID_MAX: clocksource_ids = 7;
pub type clocksource_ids = ffi::c_uint;
extern "C" {
    pub fn timekeeping_init();
}
extern "C" {
    pub static mut timekeeping_suspended: ffi::c_int;
}
extern "C" {
    pub fn legacy_timer_tick(ticks: ffi::c_ulong);
}
extern "C" {
    pub fn do_settimeofday64(ts: *const timespec64) -> ffi::c_int;
}
extern "C" {
    pub fn do_sys_settimeofday64(tv: *const timespec64, tz: *const timezone) -> ffi::c_int;
}
extern "C" {
    pub fn ktime_get_raw_ts64(ts: *mut timespec64);
}
extern "C" {
    pub fn ktime_get_ts64(ts: *mut timespec64);
}
extern "C" {
    pub fn ktime_get_real_ts64(tv: *mut timespec64);
}
extern "C" {
    pub fn ktime_get_coarse_ts64(ts: *mut timespec64);
}
extern "C" {
    pub fn ktime_get_coarse_real_ts64(ts: *mut timespec64);
}
extern "C" {
    pub fn ktime_get_coarse_real_ts64_mg(ts: *mut timespec64);
}
extern "C" {
    pub fn ktime_get_real_ts64_mg(ts: *mut timespec64);
}
extern "C" {
    pub fn timekeeping_get_mg_floor_swaps() -> ffi::c_ulong;
}
extern "C" {
    pub fn getboottime64(ts: *mut timespec64);
}
extern "C" {
    pub fn ktime_get_seconds() -> time64_t;
}
extern "C" {
    pub fn __ktime_get_real_seconds() -> time64_t;
}
extern "C" {
    pub fn ktime_get_real_seconds() -> time64_t;
}
pub const tk_offsets_TK_OFFS_REAL: tk_offsets = 0;
pub const tk_offsets_TK_OFFS_BOOT: tk_offsets = 1;
pub const tk_offsets_TK_OFFS_TAI: tk_offsets = 2;
pub const tk_offsets_TK_OFFS_MAX: tk_offsets = 3;
pub type tk_offsets = ffi::c_uint;
extern "C" {
    pub fn ktime_get() -> ktime_t;
}
extern "C" {
    pub fn ktime_get_with_offset(offs: tk_offsets) -> ktime_t;
}
extern "C" {
    pub fn ktime_get_coarse_with_offset(offs: tk_offsets) -> ktime_t;
}
extern "C" {
    pub fn ktime_mono_to_any(tmono: ktime_t, offs: tk_offsets) -> ktime_t;
}
extern "C" {
    pub fn ktime_get_raw() -> ktime_t;
}
extern "C" {
    pub fn ktime_get_resolution_ns() -> u32_;
}
extern "C" {
    pub fn ktime_get_mono_fast_ns() -> u64_;
}
extern "C" {
    pub fn ktime_get_raw_fast_ns() -> u64_;
}
extern "C" {
    pub fn ktime_get_boot_fast_ns() -> u64_;
}
extern "C" {
    pub fn ktime_get_tai_fast_ns() -> u64_;
}
extern "C" {
    pub fn ktime_get_real_fast_ns() -> u64_;
}
extern "C" {
    pub fn timekeeping_rtc_skipsuspend() -> bool_;
}
extern "C" {
    pub fn timekeeping_rtc_skipresume() -> bool_;
}
extern "C" {
    pub fn timekeeping_inject_sleeptime64(delta: *const timespec64);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct system_time_snapshot {
    pub cycles: u64_,
    pub real: ktime_t,
    pub boot: ktime_t,
    pub raw: ktime_t,
    pub cs_id: clocksource_ids,
    pub clock_was_set_seq: ffi::c_uint,
    pub cs_was_changed_seq: u8_,
}
impl Default for system_time_snapshot {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct system_device_crosststamp {
    pub device: ktime_t,
    pub sys_realtime: ktime_t,
    pub sys_monoraw: ktime_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct system_counterval_t {
    pub cycles: u64_,
    pub cs_id: clocksource_ids,
    pub use_nsecs: bool_,
}
impl Default for system_counterval_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn ktime_real_to_base_clock(
        treal: ktime_t,
        base_id: clocksource_ids,
        cycles: *mut u64_,
    ) -> bool_;
}
extern "C" {
    pub fn timekeeping_clocksource_has_base(id: clocksource_ids) -> bool_;
}
extern "C" {
    pub fn get_device_system_crosststamp(
        get_time_fn: ::core::option::Option<
            unsafe extern "C" fn(
                device_time: *mut ktime_t,
                system_counterval: *mut system_counterval_t,
                ctx: *mut ffi::c_void,
            ) -> ffi::c_int,
        >,
        ctx: *mut ffi::c_void,
        history: *mut system_time_snapshot,
        xtstamp: *mut system_device_crosststamp,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn ktime_get_snapshot(systime_snapshot: *mut system_time_snapshot);
}
extern "C" {
    pub static mut persistent_clock_is_local: ffi::c_int;
}
extern "C" {
    pub fn read_persistent_clock64(ts: *mut timespec64);
}
extern "C" {
    pub fn read_persistent_wall_and_boot_offset(
        wall_clock: *mut timespec64,
        boot_offset: *mut timespec64,
    );
}
pub const debug_obj_state_ODEBUG_STATE_NONE: debug_obj_state = 0;
pub const debug_obj_state_ODEBUG_STATE_INIT: debug_obj_state = 1;
pub const debug_obj_state_ODEBUG_STATE_INACTIVE: debug_obj_state = 2;
pub const debug_obj_state_ODEBUG_STATE_ACTIVE: debug_obj_state = 3;
pub const debug_obj_state_ODEBUG_STATE_DESTROYED: debug_obj_state = 4;
pub const debug_obj_state_ODEBUG_STATE_NOTAVAILABLE: debug_obj_state = 5;
pub const debug_obj_state_ODEBUG_STATE_MAX: debug_obj_state = 6;
pub type debug_obj_state = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct debug_obj {
    pub node: hlist_node,
    pub state: debug_obj_state,
    pub astate: ffi::c_uint,
    pub __bindgen_anon_1: debug_obj__bindgen_ty_1,
    pub descr: *const debug_obj_descr,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union debug_obj__bindgen_ty_1 {
    pub object: *mut ffi::c_void,
    pub batch_last: *mut hlist_node,
}
impl Default for debug_obj__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for debug_obj {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct debug_obj_descr {
    pub name: *const ffi::c_char,
    pub debug_hint:
        ::core::option::Option<unsafe extern "C" fn(addr: *mut ffi::c_void) -> *mut ffi::c_void>,
    pub is_static_object:
        ::core::option::Option<unsafe extern "C" fn(addr: *mut ffi::c_void) -> bool_>,
    pub fixup_init: ::core::option::Option<
        unsafe extern "C" fn(addr: *mut ffi::c_void, state: debug_obj_state) -> bool_,
    >,
    pub fixup_activate: ::core::option::Option<
        unsafe extern "C" fn(addr: *mut ffi::c_void, state: debug_obj_state) -> bool_,
    >,
    pub fixup_destroy: ::core::option::Option<
        unsafe extern "C" fn(addr: *mut ffi::c_void, state: debug_obj_state) -> bool_,
    >,
    pub fixup_free: ::core::option::Option<
        unsafe extern "C" fn(addr: *mut ffi::c_void, state: debug_obj_state) -> bool_,
    >,
    pub fixup_assert_init: ::core::option::Option<
        unsafe extern "C" fn(addr: *mut ffi::c_void, state: debug_obj_state) -> bool_,
    >,
}
impl Default for debug_obj_descr {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn init_timer_key(
        timer: *mut timer_list,
        func: ::core::option::Option<unsafe extern "C" fn(arg1: *mut timer_list)>,
        flags: ffi::c_uint,
        name: *const ffi::c_char,
        key: *mut lock_class_key,
    );
}
extern "C" {
    pub fn add_timer_on(timer: *mut timer_list, cpu: ffi::c_int);
}
extern "C" {
    pub fn mod_timer(timer: *mut timer_list, expires: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn mod_timer_pending(timer: *mut timer_list, expires: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn timer_reduce(timer: *mut timer_list, expires: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn add_timer(timer: *mut timer_list);
}
extern "C" {
    pub fn add_timer_local(timer: *mut timer_list);
}
extern "C" {
    pub fn add_timer_global(timer: *mut timer_list);
}
extern "C" {
    pub fn try_to_del_timer_sync(timer: *mut timer_list) -> ffi::c_int;
}
extern "C" {
    pub fn timer_delete_sync(timer: *mut timer_list) -> ffi::c_int;
}
extern "C" {
    pub fn timer_delete(timer: *mut timer_list) -> ffi::c_int;
}
extern "C" {
    pub fn timer_shutdown_sync(timer: *mut timer_list) -> ffi::c_int;
}
extern "C" {
    pub fn timer_shutdown(timer: *mut timer_list) -> ffi::c_int;
}
extern "C" {
    pub fn init_timers();
}
extern "C" {
    pub fn it_real_fn(arg1: *mut hrtimer) -> hrtimer_restart;
}
extern "C" {
    pub fn __round_jiffies(j: ffi::c_ulong, cpu: ffi::c_int) -> ffi::c_ulong;
}
extern "C" {
    pub fn __round_jiffies_relative(j: ffi::c_ulong, cpu: ffi::c_int) -> ffi::c_ulong;
}
extern "C" {
    pub fn round_jiffies(j: ffi::c_ulong) -> ffi::c_ulong;
}
extern "C" {
    pub fn round_jiffies_relative(j: ffi::c_ulong) -> ffi::c_ulong;
}
extern "C" {
    pub fn __round_jiffies_up(j: ffi::c_ulong, cpu: ffi::c_int) -> ffi::c_ulong;
}
extern "C" {
    pub fn __round_jiffies_up_relative(j: ffi::c_ulong, cpu: ffi::c_int) -> ffi::c_ulong;
}
extern "C" {
    pub fn round_jiffies_up(j: ffi::c_ulong) -> ffi::c_ulong;
}
extern "C" {
    pub fn round_jiffies_up_relative(j: ffi::c_ulong) -> ffi::c_ulong;
}
extern "C" {
    pub fn timers_prepare_cpu(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn timers_dead_cpu(cpu: ffi::c_uint) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct uprobe {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct uprobe_consumer {
    pub handler: ::core::option::Option<
        unsafe extern "C" fn(
            self_: *mut uprobe_consumer,
            regs: *mut pt_regs,
            data: *mut __u64,
        ) -> ffi::c_int,
    >,
    pub ret_handler: ::core::option::Option<
        unsafe extern "C" fn(
            self_: *mut uprobe_consumer,
            func: ffi::c_ulong,
            regs: *mut pt_regs,
            data: *mut __u64,
        ) -> ffi::c_int,
    >,
    pub filter: ::core::option::Option<
        unsafe extern "C" fn(self_: *mut uprobe_consumer, mm: *mut mm_struct) -> bool_,
    >,
    pub cons_node: list_head,
    pub id: __u64,
}
impl Default for uprobe_consumer {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn esr_get_class_string(esr: ffi::c_ulong) -> *const ffi::c_char;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct step_hook {
    pub node: list_head,
    pub fn_: ::core::option::Option<
        unsafe extern "C" fn(regs: *mut pt_regs, esr: ffi::c_ulong) -> ffi::c_int,
    >,
}
impl Default for step_hook {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn register_user_step_hook(hook: *mut step_hook);
}
extern "C" {
    pub fn unregister_user_step_hook(hook: *mut step_hook);
}
extern "C" {
    pub fn register_kernel_step_hook(hook: *mut step_hook);
}
extern "C" {
    pub fn unregister_kernel_step_hook(hook: *mut step_hook);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct break_hook {
    pub node: list_head,
    pub fn_: ::core::option::Option<
        unsafe extern "C" fn(regs: *mut pt_regs, esr: ffi::c_ulong) -> ffi::c_int,
    >,
    pub imm: u16_,
    pub mask: u16_,
}
impl Default for break_hook {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn register_user_break_hook(hook: *mut break_hook);
}
extern "C" {
    pub fn unregister_user_break_hook(hook: *mut break_hook);
}
extern "C" {
    pub fn register_kernel_break_hook(hook: *mut break_hook);
}
extern "C" {
    pub fn unregister_kernel_break_hook(hook: *mut break_hook);
}
extern "C" {
    pub fn debug_monitors_arch() -> u8_;
}
pub const dbg_active_el_DBG_ACTIVE_EL0: dbg_active_el = 0;
pub const dbg_active_el_DBG_ACTIVE_EL1: dbg_active_el = 1;
pub type dbg_active_el = ffi::c_uint;
extern "C" {
    pub fn enable_debug_monitors(el: dbg_active_el);
}
extern "C" {
    pub fn disable_debug_monitors(el: dbg_active_el);
}
extern "C" {
    pub fn user_rewind_single_step(task: *mut task_struct);
}
extern "C" {
    pub fn user_fastforward_single_step(task: *mut task_struct);
}
extern "C" {
    pub fn user_regs_reset_single_step(regs: *mut user_pt_regs, task: *mut task_struct);
}
extern "C" {
    pub fn kernel_enable_single_step(regs: *mut pt_regs);
}
extern "C" {
    pub fn kernel_disable_single_step();
}
extern "C" {
    pub fn kernel_active_single_step() -> ffi::c_int;
}
extern "C" {
    pub fn kernel_rewind_single_step(regs: *mut pt_regs);
}
extern "C" {
    pub fn kernel_fastforward_single_step(regs: *mut pt_regs);
}
extern "C" {
    pub fn reinstall_suspended_bps(regs: *mut pt_regs) -> ffi::c_int;
}
extern "C" {
    pub fn aarch32_break_handler(regs: *mut pt_regs) -> ffi::c_int;
}
extern "C" {
    pub fn debug_traps_init();
}
pub type probes_handler_t = ::core::option::Option<
    unsafe extern "C" fn(opcode: u32_, addr: ffi::c_long, arg1: *mut pt_regs),
>;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct arch_probe_insn {
    pub handler: probes_handler_t,
}
pub type kprobe_opcode_t = __le32;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct arch_specific_insn {
    pub api: arch_probe_insn,
    pub xol_insn: *mut kprobe_opcode_t,
    pub xol_restore: ffi::c_ulong,
}
impl Default for arch_specific_insn {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type uprobe_opcode_t = __le32;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct arch_uprobe_task {}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct arch_uprobe {
    pub __bindgen_anon_1: arch_uprobe__bindgen_ty_1,
    pub api: arch_probe_insn,
    pub simulate: bool_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union arch_uprobe__bindgen_ty_1 {
    pub insn: __le32,
    pub ixol: __le32,
}
impl Default for arch_uprobe__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for arch_uprobe {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const uprobe_task_state_UTASK_RUNNING: uprobe_task_state = 0;
pub const uprobe_task_state_UTASK_SSTEP: uprobe_task_state = 1;
pub const uprobe_task_state_UTASK_SSTEP_ACK: uprobe_task_state = 2;
pub const uprobe_task_state_UTASK_SSTEP_TRAPPED: uprobe_task_state = 3;
pub type uprobe_task_state = ffi::c_uint;
pub const hprobe_state_HPROBE_LEASED: hprobe_state = 0;
pub const hprobe_state_HPROBE_STABLE: hprobe_state = 1;
pub const hprobe_state_HPROBE_GONE: hprobe_state = 2;
pub const hprobe_state_HPROBE_CONSUMED: hprobe_state = 3;
pub type hprobe_state = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct hprobe {
    pub state: hprobe_state,
    pub srcu_idx: ffi::c_int,
    pub uprobe: *mut uprobe,
}
impl Default for hprobe {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct uprobe_task {
    pub state: uprobe_task_state,
    pub depth: ffi::c_uint,
    pub return_instances: *mut return_instance,
    pub ri_pool: *mut return_instance,
    pub ri_timer: timer_list,
    pub ri_seqcount: seqcount_t,
    pub __bindgen_anon_1: uprobe_task__bindgen_ty_1,
    pub active_uprobe: *mut uprobe,
    pub xol_vaddr: ffi::c_ulong,
    pub signal_denied: bool_,
    pub auprobe: *mut arch_uprobe,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union uprobe_task__bindgen_ty_1 {
    pub __bindgen_anon_1: uprobe_task__bindgen_ty_1__bindgen_ty_1,
    pub __bindgen_anon_2: uprobe_task__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct uprobe_task__bindgen_ty_1__bindgen_ty_1 {
    pub autask: arch_uprobe_task,
    pub vaddr: ffi::c_ulong,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct uprobe_task__bindgen_ty_1__bindgen_ty_2 {
    pub dup_xol_work: callback_head,
    pub dup_xol_addr: ffi::c_ulong,
}
impl Default for uprobe_task__bindgen_ty_1__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for uprobe_task__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for uprobe_task {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct return_consumer {
    pub cookie: __u64,
    pub id: __u64,
}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct return_instance {
    pub hprobe: hprobe,
    pub func: ffi::c_ulong,
    pub stack: ffi::c_ulong,
    pub orig_ret_vaddr: ffi::c_ulong,
    pub chained: bool_,
    pub cons_cnt: ffi::c_int,
    pub next: *mut return_instance,
    pub rcu: callback_head,
    pub consumer: return_consumer,
    pub extra_consumers: *mut return_consumer,
}
impl Default for return_instance {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const rp_check_RP_CHECK_CALL: rp_check = 0;
pub const rp_check_RP_CHECK_CHAIN_CALL: rp_check = 1;
pub const rp_check_RP_CHECK_RET: rp_check = 2;
pub type rp_check = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct xol_area {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct uprobes_state {
    pub xol_area: *mut xol_area,
}
impl Default for uprobes_state {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn uprobes_init();
}
extern "C" {
    pub fn set_swbp(aup: *mut arch_uprobe, mm: *mut mm_struct, vaddr: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn set_orig_insn(
        aup: *mut arch_uprobe,
        mm: *mut mm_struct,
        vaddr: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn is_swbp_insn(insn: *mut uprobe_opcode_t) -> bool_;
}
extern "C" {
    pub fn is_trap_insn(insn: *mut uprobe_opcode_t) -> bool_;
}
extern "C" {
    pub fn uprobe_get_swbp_addr(regs: *mut pt_regs) -> ffi::c_ulong;
}
extern "C" {
    pub fn uprobe_get_trap_addr(regs: *mut pt_regs) -> ffi::c_ulong;
}
extern "C" {
    pub fn uprobe_write_opcode(
        auprobe: *mut arch_uprobe,
        mm: *mut mm_struct,
        vaddr: ffi::c_ulong,
        arg1: uprobe_opcode_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn uprobe_register(
        inode: *mut inode,
        offset: loff_t,
        ref_ctr_offset: loff_t,
        uc: *mut uprobe_consumer,
    ) -> *mut uprobe;
}
extern "C" {
    pub fn uprobe_apply(uprobe: *mut uprobe, uc: *mut uprobe_consumer, arg1: bool_) -> ffi::c_int;
}
extern "C" {
    pub fn uprobe_unregister_nosync(uprobe: *mut uprobe, uc: *mut uprobe_consumer);
}
extern "C" {
    pub fn uprobe_unregister_sync();
}
extern "C" {
    pub fn uprobe_mmap(vma: *mut vm_area_struct) -> ffi::c_int;
}
extern "C" {
    pub fn uprobe_munmap(vma: *mut vm_area_struct, start: ffi::c_ulong, end: ffi::c_ulong);
}
extern "C" {
    pub fn uprobe_start_dup_mmap();
}
extern "C" {
    pub fn uprobe_end_dup_mmap();
}
extern "C" {
    pub fn uprobe_dup_mmap(oldmm: *mut mm_struct, newmm: *mut mm_struct);
}
extern "C" {
    pub fn uprobe_free_utask(t: *mut task_struct);
}
extern "C" {
    pub fn uprobe_copy_process(t: *mut task_struct, flags: ffi::c_ulong);
}
extern "C" {
    pub fn uprobe_post_sstep_notifier(regs: *mut pt_regs) -> ffi::c_int;
}
extern "C" {
    pub fn uprobe_pre_sstep_notifier(regs: *mut pt_regs) -> ffi::c_int;
}
extern "C" {
    pub fn uprobe_notify_resume(regs: *mut pt_regs);
}
extern "C" {
    pub fn uprobe_deny_signal() -> bool_;
}
extern "C" {
    pub fn arch_uprobe_skip_sstep(aup: *mut arch_uprobe, regs: *mut pt_regs) -> bool_;
}
extern "C" {
    pub fn uprobe_clear_state(mm: *mut mm_struct);
}
extern "C" {
    pub fn arch_uprobe_analyze_insn(
        aup: *mut arch_uprobe,
        mm: *mut mm_struct,
        addr: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn arch_uprobe_pre_xol(aup: *mut arch_uprobe, regs: *mut pt_regs) -> ffi::c_int;
}
extern "C" {
    pub fn arch_uprobe_post_xol(aup: *mut arch_uprobe, regs: *mut pt_regs) -> ffi::c_int;
}
extern "C" {
    pub fn arch_uprobe_xol_was_trapped(tsk: *mut task_struct) -> bool_;
}
extern "C" {
    pub fn arch_uprobe_exception_notify(
        self_: *mut notifier_block,
        val: ffi::c_ulong,
        data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn arch_uprobe_abort_xol(aup: *mut arch_uprobe, regs: *mut pt_regs);
}
extern "C" {
    pub fn arch_uretprobe_hijack_return_addr(
        trampoline_vaddr: ffi::c_ulong,
        regs: *mut pt_regs,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn arch_uretprobe_is_alive(
        ret: *mut return_instance,
        ctx: rp_check,
        regs: *mut pt_regs,
    ) -> bool_;
}
extern "C" {
    pub fn arch_uprobe_ignore(aup: *mut arch_uprobe, regs: *mut pt_regs) -> bool_;
}
extern "C" {
    pub fn arch_uprobe_copy_ixol(
        page: *mut page,
        vaddr: ffi::c_ulong,
        src: *mut ffi::c_void,
        len: ffi::c_ulong,
    );
}
extern "C" {
    pub fn uprobe_handle_trampoline(regs: *mut pt_regs);
}
extern "C" {
    pub fn arch_uprobe_trampoline(psize: *mut ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn uprobe_get_trampoline_vaddr() -> ffi::c_ulong;
}
pub const work_bits_WORK_STRUCT_PENDING_BIT: work_bits = 0;
pub const work_bits_WORK_STRUCT_INACTIVE_BIT: work_bits = 1;
pub const work_bits_WORK_STRUCT_PWQ_BIT: work_bits = 2;
pub const work_bits_WORK_STRUCT_LINKED_BIT: work_bits = 3;
pub const work_bits_WORK_STRUCT_FLAG_BITS: work_bits = 4;
pub const work_bits_WORK_STRUCT_COLOR_SHIFT: work_bits = 4;
pub const work_bits_WORK_STRUCT_COLOR_BITS: work_bits = 4;
pub const work_bits_WORK_STRUCT_PWQ_SHIFT: work_bits = 8;
pub const work_bits_WORK_OFFQ_FLAG_SHIFT: work_bits = 4;
pub const work_bits_WORK_OFFQ_BH_BIT: work_bits = 4;
pub const work_bits_WORK_OFFQ_FLAG_END: work_bits = 5;
pub const work_bits_WORK_OFFQ_FLAG_BITS: work_bits = 1;
pub const work_bits_WORK_OFFQ_DISABLE_SHIFT: work_bits = 5;
pub const work_bits_WORK_OFFQ_DISABLE_BITS: work_bits = 16;
pub const work_bits_WORK_OFFQ_POOL_SHIFT: work_bits = 21;
pub const work_bits_WORK_OFFQ_LEFT: work_bits = 43;
pub const work_bits_WORK_OFFQ_POOL_BITS: work_bits = 31;
pub type work_bits = ffi::c_uint;
pub const work_flags_WORK_STRUCT_PENDING: work_flags = 1;
pub const work_flags_WORK_STRUCT_INACTIVE: work_flags = 2;
pub const work_flags_WORK_STRUCT_PWQ: work_flags = 4;
pub const work_flags_WORK_STRUCT_LINKED: work_flags = 8;
pub const work_flags_WORK_STRUCT_STATIC: work_flags = 0;
pub type work_flags = ffi::c_uint;
pub const wq_misc_consts_WORK_NR_COLORS: wq_misc_consts = 16;
pub const wq_misc_consts_WORK_CPU_UNBOUND: wq_misc_consts = 4096;
pub const wq_misc_consts_WORK_BUSY_PENDING: wq_misc_consts = 1;
pub const wq_misc_consts_WORK_BUSY_RUNNING: wq_misc_consts = 2;
pub const wq_misc_consts_WORKER_DESC_LEN: wq_misc_consts = 32;
pub type wq_misc_consts = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct delayed_work {
    pub work: work_struct,
    pub timer: timer_list,
    pub wq: *mut workqueue_struct,
    pub cpu: ffi::c_int,
}
impl Default for delayed_work {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rcu_work {
    pub work: work_struct,
    pub rcu: callback_head,
    pub wq: *mut workqueue_struct,
}
impl Default for rcu_work {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const wq_affn_scope_WQ_AFFN_DFL: wq_affn_scope = 0;
pub const wq_affn_scope_WQ_AFFN_CPU: wq_affn_scope = 1;
pub const wq_affn_scope_WQ_AFFN_SMT: wq_affn_scope = 2;
pub const wq_affn_scope_WQ_AFFN_CACHE: wq_affn_scope = 3;
pub const wq_affn_scope_WQ_AFFN_NUMA: wq_affn_scope = 4;
pub const wq_affn_scope_WQ_AFFN_SYSTEM: wq_affn_scope = 5;
pub const wq_affn_scope_WQ_AFFN_NR_TYPES: wq_affn_scope = 6;
pub type wq_affn_scope = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct workqueue_attrs {
    pub nice: ffi::c_int,
    pub cpumask: cpumask_var_t,
    pub __pod_cpumask: cpumask_var_t,
    pub affn_strict: bool_,
    pub affn_scope: wq_affn_scope,
    pub ordered: bool_,
}
impl Default for workqueue_attrs {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct execute_work {
    pub work: work_struct,
}
impl Default for execute_work {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const wq_flags_WQ_BH: wq_flags = 1;
pub const wq_flags_WQ_UNBOUND: wq_flags = 2;
pub const wq_flags_WQ_FREEZABLE: wq_flags = 4;
pub const wq_flags_WQ_MEM_RECLAIM: wq_flags = 8;
pub const wq_flags_WQ_HIGHPRI: wq_flags = 16;
pub const wq_flags_WQ_CPU_INTENSIVE: wq_flags = 32;
pub const wq_flags_WQ_SYSFS: wq_flags = 64;
pub const wq_flags_WQ_POWER_EFFICIENT: wq_flags = 128;
pub const wq_flags___WQ_DESTROYING: wq_flags = 32768;
pub const wq_flags___WQ_DRAINING: wq_flags = 65536;
pub const wq_flags___WQ_ORDERED: wq_flags = 131072;
pub const wq_flags___WQ_LEGACY: wq_flags = 262144;
pub const wq_flags___WQ_BH_ALLOWS: wq_flags = 17;
pub type wq_flags = ffi::c_uint;
pub const wq_consts_WQ_MAX_ACTIVE: wq_consts = 2048;
pub const wq_consts_WQ_UNBOUND_MAX_ACTIVE: wq_consts = 2048;
pub const wq_consts_WQ_DFL_ACTIVE: wq_consts = 1024;
pub const wq_consts_WQ_DFL_MIN_ACTIVE: wq_consts = 8;
pub type wq_consts = ffi::c_uint;
extern "C" {
    pub static mut system_wq: *mut workqueue_struct;
}
extern "C" {
    pub static mut system_highpri_wq: *mut workqueue_struct;
}
extern "C" {
    pub static mut system_long_wq: *mut workqueue_struct;
}
extern "C" {
    pub static mut system_unbound_wq: *mut workqueue_struct;
}
extern "C" {
    pub static mut system_freezable_wq: *mut workqueue_struct;
}
extern "C" {
    pub static mut system_power_efficient_wq: *mut workqueue_struct;
}
extern "C" {
    pub static mut system_freezable_power_efficient_wq: *mut workqueue_struct;
}
extern "C" {
    pub static mut system_bh_wq: *mut workqueue_struct;
}
extern "C" {
    pub static mut system_bh_highpri_wq: *mut workqueue_struct;
}
extern "C" {
    pub fn workqueue_softirq_action(highpri: bool_);
}
extern "C" {
    pub fn workqueue_softirq_dead(cpu: ffi::c_uint);
}
extern "C" {
    pub fn alloc_workqueue(
        fmt: *const ffi::c_char,
        flags: ffi::c_uint,
        max_active: ffi::c_int,
        ...
    ) -> *mut workqueue_struct;
}
extern "C" {
    pub fn destroy_workqueue(wq: *mut workqueue_struct);
}
extern "C" {
    pub fn alloc_workqueue_attrs() -> *mut workqueue_attrs;
}
extern "C" {
    pub fn free_workqueue_attrs(attrs: *mut workqueue_attrs);
}
extern "C" {
    pub fn apply_workqueue_attrs(
        wq: *mut workqueue_struct,
        attrs: *const workqueue_attrs,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn workqueue_unbound_exclude_cpumask(cpumask: cpumask_var_t) -> ffi::c_int;
}
extern "C" {
    pub fn queue_work_on(
        cpu: ffi::c_int,
        wq: *mut workqueue_struct,
        work: *mut work_struct,
    ) -> bool_;
}
extern "C" {
    pub fn queue_work_node(
        node: ffi::c_int,
        wq: *mut workqueue_struct,
        work: *mut work_struct,
    ) -> bool_;
}
extern "C" {
    pub fn queue_delayed_work_on(
        cpu: ffi::c_int,
        wq: *mut workqueue_struct,
        work: *mut delayed_work,
        delay: ffi::c_ulong,
    ) -> bool_;
}
extern "C" {
    pub fn mod_delayed_work_on(
        cpu: ffi::c_int,
        wq: *mut workqueue_struct,
        dwork: *mut delayed_work,
        delay: ffi::c_ulong,
    ) -> bool_;
}
extern "C" {
    pub fn queue_rcu_work(wq: *mut workqueue_struct, rwork: *mut rcu_work) -> bool_;
}
extern "C" {
    pub fn __flush_workqueue(wq: *mut workqueue_struct);
}
extern "C" {
    pub fn drain_workqueue(wq: *mut workqueue_struct);
}
extern "C" {
    pub fn schedule_on_each_cpu(func: work_func_t) -> ffi::c_int;
}
extern "C" {
    pub fn execute_in_process_context(fn_: work_func_t, arg1: *mut execute_work) -> ffi::c_int;
}
extern "C" {
    pub fn flush_work(work: *mut work_struct) -> bool_;
}
extern "C" {
    pub fn cancel_work(work: *mut work_struct) -> bool_;
}
extern "C" {
    pub fn cancel_work_sync(work: *mut work_struct) -> bool_;
}
extern "C" {
    pub fn flush_delayed_work(dwork: *mut delayed_work) -> bool_;
}
extern "C" {
    pub fn cancel_delayed_work(dwork: *mut delayed_work) -> bool_;
}
extern "C" {
    pub fn cancel_delayed_work_sync(dwork: *mut delayed_work) -> bool_;
}
extern "C" {
    pub fn disable_work(work: *mut work_struct) -> bool_;
}
extern "C" {
    pub fn disable_work_sync(work: *mut work_struct) -> bool_;
}
extern "C" {
    pub fn enable_work(work: *mut work_struct) -> bool_;
}
extern "C" {
    pub fn disable_delayed_work(dwork: *mut delayed_work) -> bool_;
}
extern "C" {
    pub fn disable_delayed_work_sync(dwork: *mut delayed_work) -> bool_;
}
extern "C" {
    pub fn enable_delayed_work(dwork: *mut delayed_work) -> bool_;
}
extern "C" {
    pub fn flush_rcu_work(rwork: *mut rcu_work) -> bool_;
}
extern "C" {
    pub fn workqueue_set_max_active(wq: *mut workqueue_struct, max_active: ffi::c_int);
}
extern "C" {
    pub fn workqueue_set_min_active(wq: *mut workqueue_struct, min_active: ffi::c_int);
}
extern "C" {
    pub fn current_work() -> *mut work_struct;
}
extern "C" {
    pub fn current_is_workqueue_rescuer() -> bool_;
}
extern "C" {
    pub fn workqueue_congested(cpu: ffi::c_int, wq: *mut workqueue_struct) -> bool_;
}
extern "C" {
    pub fn work_busy(work: *mut work_struct) -> ffi::c_uint;
}
extern "C" {
    pub fn set_worker_desc(fmt: *const ffi::c_char, ...);
}
extern "C" {
    pub fn print_worker_info(log_lvl: *const ffi::c_char, task: *mut task_struct);
}
extern "C" {
    pub fn show_all_workqueues();
}
extern "C" {
    pub fn show_freezable_workqueues();
}
extern "C" {
    pub fn show_one_workqueue(wq: *mut workqueue_struct);
}
extern "C" {
    pub fn wq_worker_comm(buf: *mut ffi::c_char, size: usize, task: *mut task_struct);
}
extern "C" {
    pub fn __warn_flushing_systemwide_wq();
}
extern "C" {
    pub fn work_on_cpu_key(
        cpu: ffi::c_int,
        fn_: ::core::option::Option<unsafe extern "C" fn(arg1: *mut ffi::c_void) -> ffi::c_long>,
        arg: *mut ffi::c_void,
        key: *mut lock_class_key,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn work_on_cpu_safe_key(
        cpu: ffi::c_int,
        fn_: ::core::option::Option<unsafe extern "C" fn(arg1: *mut ffi::c_void) -> ffi::c_long>,
        arg: *mut ffi::c_void,
        key: *mut lock_class_key,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn freeze_workqueues_begin();
}
extern "C" {
    pub fn freeze_workqueues_busy() -> bool_;
}
extern "C" {
    pub fn thaw_workqueues();
}
extern "C" {
    pub fn workqueue_sysfs_register(wq: *mut workqueue_struct) -> ffi::c_int;
}
extern "C" {
    pub fn workqueue_prepare_cpu(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn workqueue_online_cpu(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn workqueue_offline_cpu(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn workqueue_init_early();
}
extern "C" {
    pub fn workqueue_init();
}
extern "C" {
    pub fn workqueue_init_topology();
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct percpu_counter {
    pub lock: raw_spinlock_t,
    pub count: s64,
    pub list: list_head,
    pub counters: *mut s32,
}
impl Default for percpu_counter {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut percpu_counter_batch: ffi::c_int;
}
extern "C" {
    pub fn __percpu_counter_init_many(
        fbc: *mut percpu_counter,
        amount: s64,
        gfp: gfp_t,
        nr_counters: u32_,
        key: *mut lock_class_key,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn percpu_counter_destroy_many(fbc: *mut percpu_counter, nr_counters: u32_);
}
extern "C" {
    pub fn percpu_counter_set(fbc: *mut percpu_counter, amount: s64);
}
extern "C" {
    pub fn percpu_counter_add_batch(fbc: *mut percpu_counter, amount: s64, batch: s32);
}
extern "C" {
    pub fn __percpu_counter_sum(fbc: *mut percpu_counter) -> s64;
}
extern "C" {
    pub fn __percpu_counter_compare(fbc: *mut percpu_counter, rhs: s64, batch: s32) -> ffi::c_int;
}
extern "C" {
    pub fn __percpu_counter_limited_add(
        fbc: *mut percpu_counter,
        limit: s64,
        amount: s64,
        batch: s32,
    ) -> bool_;
}
extern "C" {
    pub fn percpu_counter_sync(fbc: *mut percpu_counter);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mm_context_t {
    pub id: atomic64_t,
    pub sigpage: *mut ffi::c_void,
    pub pinned: refcount_t,
    pub vdso: *mut ffi::c_void,
    pub flags: ffi::c_ulong,
    pub pkey_allocation_map: u8_,
}
impl Default for mm_context_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn arm64_memblock_init();
}
extern "C" {
    pub fn paging_init();
}
extern "C" {
    pub fn bootmem_init();
}
extern "C" {
    pub fn create_mapping_noalloc(
        phys: phys_addr_t,
        virt: ffi::c_ulong,
        size: phys_addr_t,
        prot: pgprot_t,
    );
}
extern "C" {
    pub fn create_pgd_mapping(
        mm: *mut mm_struct,
        phys: phys_addr_t,
        virt: ffi::c_ulong,
        size: phys_addr_t,
        prot: pgprot_t,
        page_mappings_only: bool_,
    );
}
extern "C" {
    pub fn fixmap_remap_fdt(
        dt_phys: phys_addr_t,
        size: *mut ffi::c_int,
        prot: pgprot_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn mark_linear_text_alias_ro();
}
#[repr(C)]
#[repr(align(16))]
#[derive(Copy, Clone)]
pub struct page {
    pub flags: ffi::c_ulong,
    pub __bindgen_anon_1: page__bindgen_ty_1,
    pub __bindgen_anon_2: page__bindgen_ty_2,
    pub _refcount: atomic_t,
    pub memcg_data: ffi::c_ulong,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union page__bindgen_ty_1 {
    pub __bindgen_anon_1: page__bindgen_ty_1__bindgen_ty_1,
    pub __bindgen_anon_2: page__bindgen_ty_1__bindgen_ty_2,
    pub __bindgen_anon_3: page__bindgen_ty_1__bindgen_ty_3,
    pub __bindgen_anon_4: page__bindgen_ty_1__bindgen_ty_4,
    pub callback_head: callback_head,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct page__bindgen_ty_1__bindgen_ty_1 {
    pub __bindgen_anon_1: page__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
    pub mapping: *mut address_space,
    pub __bindgen_anon_2: page__bindgen_ty_1__bindgen_ty_1__bindgen_ty_2,
    pub private: ffi::c_ulong,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union page__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    pub lru: list_head,
    pub __bindgen_anon_1: page__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
    pub buddy_list: list_head,
    pub pcp_list: list_head,
    pub __bindgen_anon_2: page__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct page__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    pub __filler: *mut ffi::c_void,
    pub mlock_count: ffi::c_uint,
}
impl Default for page__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct page__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_2 {
    pub pcp_llist: llist_node,
    pub order: ffi::c_uint,
}
impl Default for page__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for page__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union page__bindgen_ty_1__bindgen_ty_1__bindgen_ty_2 {
    pub index: ffi::c_ulong,
    pub share: ffi::c_ulong,
}
impl Default for page__bindgen_ty_1__bindgen_ty_1__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for page__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct page__bindgen_ty_1__bindgen_ty_2 {
    pub pp_magic: ffi::c_ulong,
    pub pp: *mut page_pool,
    pub _pp_mapping_pad: ffi::c_ulong,
    pub dma_addr: ffi::c_ulong,
    pub pp_ref_count: atomic_long_t,
}
impl Default for page__bindgen_ty_1__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct page__bindgen_ty_1__bindgen_ty_3 {
    pub compound_head: ffi::c_ulong,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct page__bindgen_ty_1__bindgen_ty_4 {
    pub _unused_pgmap_compound_head: *mut ffi::c_void,
    pub zone_device_data: *mut ffi::c_void,
}
impl Default for page__bindgen_ty_1__bindgen_ty_4 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for page__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union page__bindgen_ty_2 {
    pub page_type: ffi::c_uint,
    pub _mapcount: atomic_t,
}
impl Default for page__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for page {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct encoded_page {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct swp_entry_t {
    pub val: ffi::c_ulong,
}
pub type mm_id_mapcount_t = ffi::c_int;
pub type mm_id_t = ffi::c_uint;
#[repr(C)]
#[repr(align(16))]
#[derive(Copy, Clone)]
pub struct folio {
    pub __bindgen_anon_1: folio__bindgen_ty_1,
    pub __bindgen_anon_2: folio__bindgen_ty_2,
    pub __bindgen_anon_3: folio__bindgen_ty_3,
    pub __bindgen_anon_4: folio__bindgen_ty_4,
}
#[repr(C)]
#[repr(align(16))]
#[derive(Copy, Clone)]
pub union folio__bindgen_ty_1 {
    pub __bindgen_anon_1: folio__bindgen_ty_1__bindgen_ty_1,
    pub page: page,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct folio__bindgen_ty_1__bindgen_ty_1 {
    pub flags: ffi::c_ulong,
    pub __bindgen_anon_1: folio__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
    pub mapping: *mut address_space,
    pub __bindgen_anon_2: folio__bindgen_ty_1__bindgen_ty_1__bindgen_ty_2,
    pub __bindgen_anon_3: folio__bindgen_ty_1__bindgen_ty_1__bindgen_ty_3,
    pub _mapcount: atomic_t,
    pub _refcount: atomic_t,
    pub memcg_data: ffi::c_ulong,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union folio__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    pub lru: list_head,
    pub __bindgen_anon_1: folio__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
    pub pgmap: *mut dev_pagemap,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct folio__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    pub __filler: *mut ffi::c_void,
    pub mlock_count: ffi::c_uint,
}
impl Default for folio__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for folio__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union folio__bindgen_ty_1__bindgen_ty_1__bindgen_ty_2 {
    pub index: ffi::c_ulong,
    pub share: ffi::c_ulong,
}
impl Default for folio__bindgen_ty_1__bindgen_ty_1__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union folio__bindgen_ty_1__bindgen_ty_1__bindgen_ty_3 {
    pub private: *mut ffi::c_void,
    pub swap: swp_entry_t,
}
impl Default for folio__bindgen_ty_1__bindgen_ty_1__bindgen_ty_3 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for folio__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for folio__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[repr(align(16))]
#[derive(Copy, Clone)]
pub union folio__bindgen_ty_2 {
    pub __bindgen_anon_1: folio__bindgen_ty_2__bindgen_ty_1,
    pub __page_1: page,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct folio__bindgen_ty_2__bindgen_ty_1 {
    pub _flags_1: ffi::c_ulong,
    pub _head_1: ffi::c_ulong,
    pub __bindgen_anon_1: folio__bindgen_ty_2__bindgen_ty_1__bindgen_ty_1,
    pub _mapcount_1: atomic_t,
    pub _refcount_1: atomic_t,
    pub _nr_pages: ffi::c_uint,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union folio__bindgen_ty_2__bindgen_ty_1__bindgen_ty_1 {
    pub __bindgen_anon_1: folio__bindgen_ty_2__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
    pub _usable_1: [ffi::c_ulong; 4usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct folio__bindgen_ty_2__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    pub _large_mapcount: atomic_t,
    pub _nr_pages_mapped: atomic_t,
    pub _entire_mapcount: atomic_t,
    pub _pincount: atomic_t,
    pub _mm_id_mapcount: [mm_id_mapcount_t; 2usize],
    pub __bindgen_anon_1:
        folio__bindgen_ty_2__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union folio__bindgen_ty_2__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    pub _mm_id: [mm_id_t; 2usize],
    pub _mm_ids: ffi::c_ulong,
}
impl Default for folio__bindgen_ty_2__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for folio__bindgen_ty_2__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for folio__bindgen_ty_2__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for folio__bindgen_ty_2__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for folio__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[repr(align(16))]
#[derive(Copy, Clone)]
pub union folio__bindgen_ty_3 {
    pub __bindgen_anon_1: folio__bindgen_ty_3__bindgen_ty_1,
    pub __page_2: page,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct folio__bindgen_ty_3__bindgen_ty_1 {
    pub _flags_2: ffi::c_ulong,
    pub _head_2: ffi::c_ulong,
    pub _deferred_list: list_head,
}
impl Default for folio__bindgen_ty_3__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for folio__bindgen_ty_3 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[repr(align(16))]
#[derive(Copy, Clone)]
pub union folio__bindgen_ty_4 {
    pub __bindgen_anon_1: folio__bindgen_ty_4__bindgen_ty_1,
    pub __page_3: page,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct folio__bindgen_ty_4__bindgen_ty_1 {
    pub _flags_3: ffi::c_ulong,
    pub _head_3: ffi::c_ulong,
    pub _hugetlb_subpool: *mut ffi::c_void,
    pub _hugetlb_cgroup: *mut ffi::c_void,
    pub _hugetlb_cgroup_rsvd: *mut ffi::c_void,
    pub _hugetlb_hwpoison: *mut ffi::c_void,
}
impl Default for folio__bindgen_ty_4__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for folio__bindgen_ty_4 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for folio {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ptdesc {
    pub __page_flags: ffi::c_ulong,
    pub __bindgen_anon_1: ptdesc__bindgen_ty_1,
    pub __page_mapping: ffi::c_ulong,
    pub __bindgen_anon_2: ptdesc__bindgen_ty_2,
    pub __bindgen_anon_3: ptdesc__bindgen_ty_3,
    pub __page_type: ffi::c_uint,
    pub __page_refcount: atomic_t,
    pub pt_memcg_data: ffi::c_ulong,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union ptdesc__bindgen_ty_1 {
    pub pt_rcu_head: callback_head,
    pub pt_list: list_head,
    pub __bindgen_anon_1: ptdesc__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ptdesc__bindgen_ty_1__bindgen_ty_1 {
    pub _pt_pad_1: ffi::c_ulong,
    pub pmd_huge_pte: pgtable_t,
}
impl Default for ptdesc__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for ptdesc__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union ptdesc__bindgen_ty_2 {
    pub pt_index: ffi::c_ulong,
    pub pt_mm: *mut mm_struct,
    pub pt_frag_refcount: atomic_t,
    pub pt_share_count: atomic_t,
}
impl Default for ptdesc__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union ptdesc__bindgen_ty_3 {
    pub _pt_pad_2: ffi::c_ulong,
    pub ptl: spinlock_t,
}
impl Default for ptdesc__bindgen_ty_3 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for ptdesc {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type vm_flags_t = ffi::c_ulong;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct freeptr_t {
    pub v: ffi::c_ulong,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct vm_region {
    pub vm_rb: rb_node,
    pub vm_flags: vm_flags_t,
    pub vm_start: ffi::c_ulong,
    pub vm_end: ffi::c_ulong,
    pub vm_top: ffi::c_ulong,
    pub vm_pgoff: ffi::c_ulong,
    pub vm_file: *mut file,
    pub vm_usage: ffi::c_int,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub __bindgen_padding_0: [u8; 3usize],
}
impl Default for vm_region {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl vm_region {
    #[inline]
    pub fn vm_icache_flushed(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_vm_icache_flushed(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn vm_icache_flushed_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_vm_icache_flushed_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(vm_icache_flushed: bool_) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let vm_icache_flushed: u8 = unsafe { ::core::mem::transmute(vm_icache_flushed) };
            vm_icache_flushed as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct vm_userfaultfd_ctx {
    pub ctx: *mut userfaultfd_ctx,
}
impl Default for vm_userfaultfd_ctx {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default)]
pub struct anon_vma_name {
    pub kref: kref,
    pub name: __IncompleteArrayField<ffi::c_char>,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct vma_numab_state {
    pub next_scan: ffi::c_ulong,
    pub pids_active_reset: ffi::c_ulong,
    pub pids_active: [ffi::c_ulong; 2usize],
    pub start_scan_seq: ffi::c_int,
    pub prev_scan_seq: ffi::c_int,
}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct vm_area_struct {
    pub __bindgen_anon_1: vm_area_struct__bindgen_ty_1,
    pub vm_mm: *mut mm_struct,
    pub vm_page_prot: pgprot_t,
    pub __bindgen_anon_2: vm_area_struct__bindgen_ty_2,
    pub vm_lock_seq: ffi::c_uint,
    pub anon_vma_chain: list_head,
    pub anon_vma: *mut anon_vma,
    pub vm_ops: *const vm_operations_struct,
    pub vm_pgoff: ffi::c_ulong,
    pub vm_file: *mut file,
    pub vm_private_data: *mut ffi::c_void,
    pub swap_readahead_info: atomic_long_t,
    pub vm_policy: *mut mempolicy,
    pub numab_state: *mut vma_numab_state,
    pub vm_refcnt: refcount_t,
    pub shared: vm_area_struct__bindgen_ty_3,
    pub vm_userfaultfd_ctx: vm_userfaultfd_ctx,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union vm_area_struct__bindgen_ty_1 {
    pub __bindgen_anon_1: vm_area_struct__bindgen_ty_1__bindgen_ty_1,
    pub vm_freeptr: freeptr_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct vm_area_struct__bindgen_ty_1__bindgen_ty_1 {
    pub vm_start: ffi::c_ulong,
    pub vm_end: ffi::c_ulong,
}
impl Default for vm_area_struct__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union vm_area_struct__bindgen_ty_2 {
    pub vm_flags: vm_flags_t,
    pub __vm_flags: vm_flags_t,
}
impl Default for vm_area_struct__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct vm_area_struct__bindgen_ty_3 {
    pub rb: rb_node,
    pub rb_subtree_last: ffi::c_ulong,
}
impl Default for vm_area_struct__bindgen_ty_3 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for vm_area_struct {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct mm_cid {
    pub time: u64_,
    pub cid: ffi::c_int,
    pub recent_cid: ffi::c_int,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kioctx_table {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct iommu_mm_data {
    _unused: [u8; 0],
}
#[repr(C)]
#[repr(align(64))]
pub struct mm_struct {
    pub __bindgen_anon_1: mm_struct__bindgen_ty_1,
    pub cpu_bitmap: __IncompleteArrayField<ffi::c_ulong>,
}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct mm_struct__bindgen_ty_1 {
    pub __bindgen_anon_1: mm_struct__bindgen_ty_1__bindgen_ty_1,
    pub mm_mt: maple_tree,
    pub mmap_base: ffi::c_ulong,
    pub mmap_legacy_base: ffi::c_ulong,
    pub task_size: ffi::c_ulong,
    pub pgd: *mut pgd_t,
    pub membarrier_state: atomic_t,
    pub mm_users: atomic_t,
    pub pcpu_cid: *mut mm_cid,
    pub mm_cid_next_scan: ffi::c_ulong,
    pub nr_cpus_allowed: ffi::c_uint,
    pub max_nr_cid: atomic_t,
    pub cpus_allowed_lock: raw_spinlock_t,
    pub pgtables_bytes: atomic_long_t,
    pub map_count: ffi::c_int,
    pub page_table_lock: spinlock_t,
    pub mmap_lock: rw_semaphore,
    pub mmlist: list_head,
    pub vma_writer_wait: rcuwait,
    pub mm_lock_seq: seqcount_t,
    pub hiwater_rss: ffi::c_ulong,
    pub hiwater_vm: ffi::c_ulong,
    pub total_vm: ffi::c_ulong,
    pub locked_vm: ffi::c_ulong,
    pub pinned_vm: atomic64_t,
    pub data_vm: ffi::c_ulong,
    pub exec_vm: ffi::c_ulong,
    pub stack_vm: ffi::c_ulong,
    pub def_flags: ffi::c_ulong,
    pub write_protect_seq: seqcount_t,
    pub arg_lock: spinlock_t,
    pub start_code: ffi::c_ulong,
    pub end_code: ffi::c_ulong,
    pub start_data: ffi::c_ulong,
    pub end_data: ffi::c_ulong,
    pub start_brk: ffi::c_ulong,
    pub brk: ffi::c_ulong,
    pub start_stack: ffi::c_ulong,
    pub arg_start: ffi::c_ulong,
    pub arg_end: ffi::c_ulong,
    pub env_start: ffi::c_ulong,
    pub env_end: ffi::c_ulong,
    pub saved_auxv: [ffi::c_ulong; 50usize],
    pub rss_stat: [percpu_counter; 4usize],
    pub binfmt: *mut linux_binfmt,
    pub context: mm_context_t,
    pub flags: ffi::c_ulong,
    pub ioctx_lock: spinlock_t,
    pub ioctx_table: *mut kioctx_table,
    pub owner: *mut task_struct,
    pub user_ns: *mut user_namespace,
    pub exe_file: *mut file,
    pub notifier_subscriptions: *mut mmu_notifier_subscriptions,
    pub numa_next_scan: ffi::c_ulong,
    pub numa_scan_offset: ffi::c_ulong,
    pub numa_scan_seq: ffi::c_int,
    pub tlb_flush_pending: atomic_t,
    pub tlb_flush_batched: atomic_t,
    pub uprobes_state: uprobes_state,
    pub hugetlb_usage: atomic_long_t,
    pub async_put_work: work_struct,
    pub iommu_mm: *mut iommu_mm_data,
    pub ksm_merging_pages: ffi::c_ulong,
    pub ksm_rmap_items: ffi::c_ulong,
    pub ksm_zero_pages: atomic_long_t,
    pub lru_gen: mm_struct__bindgen_ty_1__bindgen_ty_2,
    pub mm_id: mm_id_t,
}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct mm_struct__bindgen_ty_1__bindgen_ty_1 {
    pub mm_count: atomic_t,
}
impl Default for mm_struct__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mm_struct__bindgen_ty_1__bindgen_ty_2 {
    pub list: list_head,
    pub bitmap: ffi::c_ulong,
    pub memcg: *mut mem_cgroup,
}
impl Default for mm_struct__bindgen_ty_1__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for mm_struct__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for mm_struct {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut init_mm: mm_struct;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct lru_gen_mm_list {
    pub fifo: list_head,
    pub lock: spinlock_t,
}
impl Default for lru_gen_mm_list {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn lru_gen_add_mm(mm: *mut mm_struct);
}
extern "C" {
    pub fn lru_gen_del_mm(mm: *mut mm_struct);
}
extern "C" {
    pub fn lru_gen_migrate_mm(mm: *mut mm_struct);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct vma_iterator {
    pub mas: ma_state,
}
impl Default for vma_iterator {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const mm_cid_state_MM_CID_UNSET: mm_cid_state = 4294967295;
pub const mm_cid_state_MM_CID_LAZY_PUT: mm_cid_state = 2147483648;
pub type mm_cid_state = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mmu_gather {
    _unused: [u8; 0],
}
extern "C" {
    pub fn tlb_gather_mmu(tlb: *mut mmu_gather, mm: *mut mm_struct);
}
extern "C" {
    pub fn tlb_gather_mmu_fullmm(tlb: *mut mmu_gather, mm: *mut mm_struct);
}
extern "C" {
    pub fn tlb_finish_mmu(tlb: *mut mmu_gather);
}
pub type vm_fault_t = ffi::c_uint;
pub const vm_fault_reason_VM_FAULT_OOM: vm_fault_reason = 1;
pub const vm_fault_reason_VM_FAULT_SIGBUS: vm_fault_reason = 2;
pub const vm_fault_reason_VM_FAULT_MAJOR: vm_fault_reason = 4;
pub const vm_fault_reason_VM_FAULT_HWPOISON: vm_fault_reason = 16;
pub const vm_fault_reason_VM_FAULT_HWPOISON_LARGE: vm_fault_reason = 32;
pub const vm_fault_reason_VM_FAULT_SIGSEGV: vm_fault_reason = 64;
pub const vm_fault_reason_VM_FAULT_NOPAGE: vm_fault_reason = 256;
pub const vm_fault_reason_VM_FAULT_LOCKED: vm_fault_reason = 512;
pub const vm_fault_reason_VM_FAULT_RETRY: vm_fault_reason = 1024;
pub const vm_fault_reason_VM_FAULT_FALLBACK: vm_fault_reason = 2048;
pub const vm_fault_reason_VM_FAULT_DONE_COW: vm_fault_reason = 4096;
pub const vm_fault_reason_VM_FAULT_NEEDDSYNC: vm_fault_reason = 8192;
pub const vm_fault_reason_VM_FAULT_COMPLETED: vm_fault_reason = 16384;
pub const vm_fault_reason_VM_FAULT_HINDEX_MASK: vm_fault_reason = 983040;
pub type vm_fault_reason = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct vm_special_mapping {
    pub name: *const ffi::c_char,
    pub pages: *mut *mut page,
    pub fault: ::core::option::Option<
        unsafe extern "C" fn(
            sm: *const vm_special_mapping,
            vma: *mut vm_area_struct,
            vmf: *mut vm_fault,
        ) -> vm_fault_t,
    >,
    pub mremap: ::core::option::Option<
        unsafe extern "C" fn(
            sm: *const vm_special_mapping,
            new_vma: *mut vm_area_struct,
        ) -> ffi::c_int,
    >,
    pub close: ::core::option::Option<
        unsafe extern "C" fn(sm: *const vm_special_mapping, vma: *mut vm_area_struct),
    >,
}
impl Default for vm_special_mapping {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const tlb_flush_reason_TLB_FLUSH_ON_TASK_SWITCH: tlb_flush_reason = 0;
pub const tlb_flush_reason_TLB_REMOTE_SHOOTDOWN: tlb_flush_reason = 1;
pub const tlb_flush_reason_TLB_LOCAL_SHOOTDOWN: tlb_flush_reason = 2;
pub const tlb_flush_reason_TLB_LOCAL_MM_SHOOTDOWN: tlb_flush_reason = 3;
pub const tlb_flush_reason_TLB_REMOTE_SEND_IPI: tlb_flush_reason = 4;
pub const tlb_flush_reason_TLB_REMOTE_WRONG_CPU: tlb_flush_reason = 5;
pub const tlb_flush_reason_NR_TLB_FLUSH_REASONS: tlb_flush_reason = 6;
pub type tlb_flush_reason = ffi::c_uint;
pub const fault_flag_FAULT_FLAG_WRITE: fault_flag = 1;
pub const fault_flag_FAULT_FLAG_MKWRITE: fault_flag = 2;
pub const fault_flag_FAULT_FLAG_ALLOW_RETRY: fault_flag = 4;
pub const fault_flag_FAULT_FLAG_RETRY_NOWAIT: fault_flag = 8;
pub const fault_flag_FAULT_FLAG_KILLABLE: fault_flag = 16;
pub const fault_flag_FAULT_FLAG_TRIED: fault_flag = 32;
pub const fault_flag_FAULT_FLAG_USER: fault_flag = 64;
pub const fault_flag_FAULT_FLAG_REMOTE: fault_flag = 128;
pub const fault_flag_FAULT_FLAG_INSTRUCTION: fault_flag = 256;
pub const fault_flag_FAULT_FLAG_INTERRUPTIBLE: fault_flag = 512;
pub const fault_flag_FAULT_FLAG_UNSHARE: fault_flag = 1024;
pub const fault_flag_FAULT_FLAG_ORIG_PTE_VALID: fault_flag = 2048;
pub const fault_flag_FAULT_FLAG_VMA_LOCK: fault_flag = 4096;
pub type fault_flag = ffi::c_uint;
pub type zap_flags_t = ffi::c_uint;
pub type cydp_t = ffi::c_int;
pub const FOLL_WRITE: _bindgen_ty_11 = 1;
pub const FOLL_GET: _bindgen_ty_11 = 2;
pub const FOLL_DUMP: _bindgen_ty_11 = 4;
pub const FOLL_FORCE: _bindgen_ty_11 = 8;
pub const FOLL_NOWAIT: _bindgen_ty_11 = 16;
pub const FOLL_NOFAULT: _bindgen_ty_11 = 32;
pub const FOLL_HWPOISON: _bindgen_ty_11 = 64;
pub const FOLL_ANON: _bindgen_ty_11 = 128;
pub const FOLL_LONGTERM: _bindgen_ty_11 = 256;
pub const FOLL_SPLIT_PMD: _bindgen_ty_11 = 512;
pub const FOLL_PCI_P2PDMA: _bindgen_ty_11 = 1024;
pub const FOLL_INTERRUPTIBLE: _bindgen_ty_11 = 2048;
pub const FOLL_HONOR_NUMA_FAULT: _bindgen_ty_11 = 4096;
pub type _bindgen_ty_11 = ffi::c_uint;
pub const pageflags_PG_locked: pageflags = 0;
pub const pageflags_PG_writeback: pageflags = 1;
pub const pageflags_PG_referenced: pageflags = 2;
pub const pageflags_PG_uptodate: pageflags = 3;
pub const pageflags_PG_dirty: pageflags = 4;
pub const pageflags_PG_lru: pageflags = 5;
pub const pageflags_PG_head: pageflags = 6;
pub const pageflags_PG_waiters: pageflags = 7;
pub const pageflags_PG_active: pageflags = 8;
pub const pageflags_PG_workingset: pageflags = 9;
pub const pageflags_PG_owner_priv_1: pageflags = 10;
pub const pageflags_PG_owner_2: pageflags = 11;
pub const pageflags_PG_arch_1: pageflags = 12;
pub const pageflags_PG_reserved: pageflags = 13;
pub const pageflags_PG_private: pageflags = 14;
pub const pageflags_PG_private_2: pageflags = 15;
pub const pageflags_PG_reclaim: pageflags = 16;
pub const pageflags_PG_swapbacked: pageflags = 17;
pub const pageflags_PG_unevictable: pageflags = 18;
pub const pageflags_PG_dropbehind: pageflags = 19;
pub const pageflags_PG_mlocked: pageflags = 20;
pub const pageflags_PG_hwpoison: pageflags = 21;
pub const pageflags_PG_young: pageflags = 22;
pub const pageflags_PG_idle: pageflags = 23;
pub const pageflags_PG_arch_2: pageflags = 24;
pub const pageflags_PG_arch_3: pageflags = 25;
pub const pageflags___NR_PAGEFLAGS: pageflags = 26;
pub const pageflags_PG_readahead: pageflags = 16;
pub const pageflags_PG_swapcache: pageflags = 10;
pub const pageflags_PG_checked: pageflags = 10;
pub const pageflags_PG_anon_exclusive: pageflags = 11;
pub const pageflags_PG_mappedtodisk: pageflags = 11;
pub const pageflags_PG_fscache: pageflags = 15;
pub const pageflags_PG_pinned: pageflags = 10;
pub const pageflags_PG_savepinned: pageflags = 4;
pub const pageflags_PG_foreign: pageflags = 10;
pub const pageflags_PG_xen_remapped: pageflags = 10;
pub const pageflags_PG_isolated: pageflags = 16;
pub const pageflags_PG_reported: pageflags = 3;
pub const pageflags_PG_vmemmap_self_hosted: pageflags = 10;
pub const pageflags_PG_has_hwpoisoned: pageflags = 8;
pub const pageflags_PG_large_rmappable: pageflags = 9;
pub const pageflags_PG_partially_mapped: pageflags = 16;
pub type pageflags = ffi::c_uint;
extern "C" {
    pub fn stable_page_flags(page: *const page) -> u64_;
}
extern "C" {
    pub fn __folio_start_writeback(folio: *mut folio, keep_write: bool_);
}
extern "C" {
    pub fn set_page_writeback(page: *mut page);
}
pub const pagetype_PGTY_buddy: pagetype = 240;
pub const pagetype_PGTY_offline: pagetype = 241;
pub const pagetype_PGTY_table: pagetype = 242;
pub const pagetype_PGTY_guard: pagetype = 243;
pub const pagetype_PGTY_hugetlb: pagetype = 244;
pub const pagetype_PGTY_slab: pagetype = 245;
pub const pagetype_PGTY_zsmalloc: pagetype = 246;
pub const pagetype_PGTY_unaccepted: pagetype = 247;
pub const pagetype_PGTY_large_kmalloc: pagetype = 248;
pub const pagetype_PGTY_mapcount_underflow: pagetype = 255;
pub type pagetype = ffi::c_uint;
extern "C" {
    pub fn page_offline_freeze();
}
extern "C" {
    pub fn page_offline_thaw();
}
extern "C" {
    pub fn page_offline_begin();
}
extern "C" {
    pub fn page_offline_end();
}
extern "C" {
    pub fn is_free_buddy_page(page: *const page) -> bool_;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct local_lock_t {}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct local_trylock_t {
    pub llock: local_lock_t,
    pub acquired: u8_,
}
pub type class_local_lock_t = *mut local_lock_t;
pub const class_local_lock_is_conditional: bool_ = false;
pub type class_local_lock_irq_t = *mut local_lock_t;
pub const class_local_lock_irq_is_conditional: bool_ = false;
pub const class_local_lock_irqsave_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_local_lock_irqsave_t {
    pub lock: *mut local_lock_t,
    pub flags: ffi::c_ulong,
}
impl Default for class_local_lock_irqsave_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type class_local_lock_nested_bh_t = *mut local_lock_t;
pub const class_local_lock_nested_bh_is_conditional: bool_ = false;
extern "C" {
    pub static mut zswap_stored_pages: atomic_long_t;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct zswap_lruvec_state {
    pub nr_disk_swapins: atomic_long_t,
}
extern "C" {
    pub fn zswap_total_pages() -> ffi::c_ulong;
}
extern "C" {
    pub fn zswap_store(folio: *mut folio) -> bool_;
}
extern "C" {
    pub fn zswap_load(folio: *mut folio) -> ffi::c_int;
}
extern "C" {
    pub fn zswap_invalidate(swp: swp_entry_t);
}
extern "C" {
    pub fn zswap_swapon(type_: ffi::c_int, nr_pages: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn zswap_swapoff(type_: ffi::c_int);
}
extern "C" {
    pub fn zswap_memcg_offline_cleanup(memcg: *mut mem_cgroup);
}
extern "C" {
    pub fn zswap_lruvec_state_init(lruvec: *mut lruvec);
}
extern "C" {
    pub fn zswap_folio_swapin(folio: *mut folio);
}
extern "C" {
    pub fn zswap_is_enabled() -> bool_;
}
extern "C" {
    pub fn zswap_never_enabled() -> bool_;
}
pub const migratetype_MIGRATE_UNMOVABLE: migratetype = 0;
pub const migratetype_MIGRATE_MOVABLE: migratetype = 1;
pub const migratetype_MIGRATE_RECLAIMABLE: migratetype = 2;
pub const migratetype_MIGRATE_PCPTYPES: migratetype = 3;
pub const migratetype_MIGRATE_HIGHATOMIC: migratetype = 3;
pub const migratetype_MIGRATE_CMA: migratetype = 4;
pub const migratetype_MIGRATE_ISOLATE: migratetype = 5;
pub const migratetype_MIGRATE_TYPES: migratetype = 6;
pub type migratetype = ffi::c_uint;
extern "C" {
    pub static migratetype_names: [*const ffi::c_char; 6usize];
}
extern "C" {
    pub static mut page_group_by_mobility_disabled: ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct free_area {
    pub free_list: [list_head; 6usize],
    pub nr_free: ffi::c_ulong,
}
impl Default for free_area {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const numa_stat_item_NUMA_HIT: numa_stat_item = 0;
pub const numa_stat_item_NUMA_MISS: numa_stat_item = 1;
pub const numa_stat_item_NUMA_FOREIGN: numa_stat_item = 2;
pub const numa_stat_item_NUMA_INTERLEAVE_HIT: numa_stat_item = 3;
pub const numa_stat_item_NUMA_LOCAL: numa_stat_item = 4;
pub const numa_stat_item_NUMA_OTHER: numa_stat_item = 5;
pub const numa_stat_item_NR_VM_NUMA_EVENT_ITEMS: numa_stat_item = 6;
pub type numa_stat_item = ffi::c_uint;
pub const zone_stat_item_NR_FREE_PAGES: zone_stat_item = 0;
pub const zone_stat_item_NR_FREE_PAGES_BLOCKS: zone_stat_item = 1;
pub const zone_stat_item_NR_ZONE_LRU_BASE: zone_stat_item = 2;
pub const zone_stat_item_NR_ZONE_INACTIVE_ANON: zone_stat_item = 2;
pub const zone_stat_item_NR_ZONE_ACTIVE_ANON: zone_stat_item = 3;
pub const zone_stat_item_NR_ZONE_INACTIVE_FILE: zone_stat_item = 4;
pub const zone_stat_item_NR_ZONE_ACTIVE_FILE: zone_stat_item = 5;
pub const zone_stat_item_NR_ZONE_UNEVICTABLE: zone_stat_item = 6;
pub const zone_stat_item_NR_ZONE_WRITE_PENDING: zone_stat_item = 7;
pub const zone_stat_item_NR_MLOCK: zone_stat_item = 8;
pub const zone_stat_item_NR_BOUNCE: zone_stat_item = 9;
pub const zone_stat_item_NR_ZSPAGES: zone_stat_item = 10;
pub const zone_stat_item_NR_FREE_CMA_PAGES: zone_stat_item = 11;
pub const zone_stat_item_NR_VM_ZONE_STAT_ITEMS: zone_stat_item = 12;
pub type zone_stat_item = ffi::c_uint;
pub const node_stat_item_NR_LRU_BASE: node_stat_item = 0;
pub const node_stat_item_NR_INACTIVE_ANON: node_stat_item = 0;
pub const node_stat_item_NR_ACTIVE_ANON: node_stat_item = 1;
pub const node_stat_item_NR_INACTIVE_FILE: node_stat_item = 2;
pub const node_stat_item_NR_ACTIVE_FILE: node_stat_item = 3;
pub const node_stat_item_NR_UNEVICTABLE: node_stat_item = 4;
pub const node_stat_item_NR_SLAB_RECLAIMABLE_B: node_stat_item = 5;
pub const node_stat_item_NR_SLAB_UNRECLAIMABLE_B: node_stat_item = 6;
pub const node_stat_item_NR_ISOLATED_ANON: node_stat_item = 7;
pub const node_stat_item_NR_ISOLATED_FILE: node_stat_item = 8;
pub const node_stat_item_WORKINGSET_NODES: node_stat_item = 9;
pub const node_stat_item_WORKINGSET_REFAULT_BASE: node_stat_item = 10;
pub const node_stat_item_WORKINGSET_REFAULT_ANON: node_stat_item = 10;
pub const node_stat_item_WORKINGSET_REFAULT_FILE: node_stat_item = 11;
pub const node_stat_item_WORKINGSET_ACTIVATE_BASE: node_stat_item = 12;
pub const node_stat_item_WORKINGSET_ACTIVATE_ANON: node_stat_item = 12;
pub const node_stat_item_WORKINGSET_ACTIVATE_FILE: node_stat_item = 13;
pub const node_stat_item_WORKINGSET_RESTORE_BASE: node_stat_item = 14;
pub const node_stat_item_WORKINGSET_RESTORE_ANON: node_stat_item = 14;
pub const node_stat_item_WORKINGSET_RESTORE_FILE: node_stat_item = 15;
pub const node_stat_item_WORKINGSET_NODERECLAIM: node_stat_item = 16;
pub const node_stat_item_NR_ANON_MAPPED: node_stat_item = 17;
pub const node_stat_item_NR_FILE_MAPPED: node_stat_item = 18;
pub const node_stat_item_NR_FILE_PAGES: node_stat_item = 19;
pub const node_stat_item_NR_FILE_DIRTY: node_stat_item = 20;
pub const node_stat_item_NR_WRITEBACK: node_stat_item = 21;
pub const node_stat_item_NR_WRITEBACK_TEMP: node_stat_item = 22;
pub const node_stat_item_NR_SHMEM: node_stat_item = 23;
pub const node_stat_item_NR_SHMEM_THPS: node_stat_item = 24;
pub const node_stat_item_NR_SHMEM_PMDMAPPED: node_stat_item = 25;
pub const node_stat_item_NR_FILE_THPS: node_stat_item = 26;
pub const node_stat_item_NR_FILE_PMDMAPPED: node_stat_item = 27;
pub const node_stat_item_NR_ANON_THPS: node_stat_item = 28;
pub const node_stat_item_NR_VMSCAN_WRITE: node_stat_item = 29;
pub const node_stat_item_NR_VMSCAN_IMMEDIATE: node_stat_item = 30;
pub const node_stat_item_NR_DIRTIED: node_stat_item = 31;
pub const node_stat_item_NR_WRITTEN: node_stat_item = 32;
pub const node_stat_item_NR_THROTTLED_WRITTEN: node_stat_item = 33;
pub const node_stat_item_NR_KERNEL_MISC_RECLAIMABLE: node_stat_item = 34;
pub const node_stat_item_NR_FOLL_PIN_ACQUIRED: node_stat_item = 35;
pub const node_stat_item_NR_FOLL_PIN_RELEASED: node_stat_item = 36;
pub const node_stat_item_NR_KERNEL_STACK_KB: node_stat_item = 37;
pub const node_stat_item_NR_PAGETABLE: node_stat_item = 38;
pub const node_stat_item_NR_SECONDARY_PAGETABLE: node_stat_item = 39;
pub const node_stat_item_NR_IOMMU_PAGES: node_stat_item = 40;
pub const node_stat_item_NR_SWAPCACHE: node_stat_item = 41;
pub const node_stat_item_PGPROMOTE_SUCCESS: node_stat_item = 42;
pub const node_stat_item_PGPROMOTE_CANDIDATE: node_stat_item = 43;
pub const node_stat_item_PGDEMOTE_KSWAPD: node_stat_item = 44;
pub const node_stat_item_PGDEMOTE_DIRECT: node_stat_item = 45;
pub const node_stat_item_PGDEMOTE_KHUGEPAGED: node_stat_item = 46;
pub const node_stat_item_PGDEMOTE_PROACTIVE: node_stat_item = 47;
pub const node_stat_item_NR_HUGETLB: node_stat_item = 48;
pub const node_stat_item_NR_BALLOON_PAGES: node_stat_item = 49;
pub const node_stat_item_NR_VM_NODE_STAT_ITEMS: node_stat_item = 50;
pub type node_stat_item = ffi::c_uint;
pub const lru_list_LRU_INACTIVE_ANON: lru_list = 0;
pub const lru_list_LRU_ACTIVE_ANON: lru_list = 1;
pub const lru_list_LRU_INACTIVE_FILE: lru_list = 2;
pub const lru_list_LRU_ACTIVE_FILE: lru_list = 3;
pub const lru_list_LRU_UNEVICTABLE: lru_list = 4;
pub const lru_list_NR_LRU_LISTS: lru_list = 5;
pub type lru_list = ffi::c_uint;
pub const vmscan_throttle_state_VMSCAN_THROTTLE_WRITEBACK: vmscan_throttle_state = 0;
pub const vmscan_throttle_state_VMSCAN_THROTTLE_ISOLATED: vmscan_throttle_state = 1;
pub const vmscan_throttle_state_VMSCAN_THROTTLE_NOPROGRESS: vmscan_throttle_state = 2;
pub const vmscan_throttle_state_VMSCAN_THROTTLE_CONGESTED: vmscan_throttle_state = 3;
pub const vmscan_throttle_state_NR_VMSCAN_THROTTLE: vmscan_throttle_state = 4;
pub type vmscan_throttle_state = ffi::c_uint;
pub const lruvec_flags_LRUVEC_CGROUP_CONGESTED: lruvec_flags = 0;
pub const lruvec_flags_LRUVEC_NODE_CONGESTED: lruvec_flags = 1;
pub type lruvec_flags = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct page_vma_mapped_walk {
    _unused: [u8; 0],
}
pub const LRU_GEN_ANON: _bindgen_ty_12 = 0;
pub const LRU_GEN_FILE: _bindgen_ty_12 = 1;
pub type _bindgen_ty_12 = ffi::c_uint;
pub const LRU_GEN_CORE: _bindgen_ty_13 = 0;
pub const LRU_GEN_MM_WALK: _bindgen_ty_13 = 1;
pub const LRU_GEN_NONLEAF_YOUNG: _bindgen_ty_13 = 2;
pub const NR_LRU_GEN_CAPS: _bindgen_ty_13 = 3;
pub type _bindgen_ty_13 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct lru_gen_folio {
    pub max_seq: ffi::c_ulong,
    pub min_seq: [ffi::c_ulong; 2usize],
    pub timestamps: [ffi::c_ulong; 4usize],
    pub folios: [[[list_head; 5usize]; 2usize]; 4usize],
    pub nr_pages: [[[ffi::c_long; 5usize]; 2usize]; 4usize],
    pub avg_refaulted: [[ffi::c_ulong; 4usize]; 2usize],
    pub avg_total: [[ffi::c_ulong; 4usize]; 2usize],
    pub protected: [[[ffi::c_ulong; 4usize]; 2usize]; 1usize],
    pub evicted: [[[atomic_long_t; 4usize]; 2usize]; 1usize],
    pub refaulted: [[[atomic_long_t; 4usize]; 2usize]; 1usize],
    pub enabled: bool_,
    pub gen: u8_,
    pub seg: u8_,
    pub list: hlist_nulls_node,
}
impl Default for lru_gen_folio {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const MM_LEAF_TOTAL: _bindgen_ty_14 = 0;
pub const MM_LEAF_YOUNG: _bindgen_ty_14 = 1;
pub const MM_NONLEAF_FOUND: _bindgen_ty_14 = 2;
pub const MM_NONLEAF_ADDED: _bindgen_ty_14 = 3;
pub const NR_MM_STATS: _bindgen_ty_14 = 4;
pub type _bindgen_ty_14 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct lru_gen_mm_state {
    pub seq: ffi::c_ulong,
    pub head: *mut list_head,
    pub tail: *mut list_head,
    pub filters: [*mut ffi::c_ulong; 2usize],
    pub stats: [[ffi::c_ulong; 4usize]; 1usize],
}
impl Default for lru_gen_mm_state {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct lru_gen_mm_walk {
    pub lruvec: *mut lruvec,
    pub seq: ffi::c_ulong,
    pub next_addr: ffi::c_ulong,
    pub nr_pages: [[[ffi::c_int; 5usize]; 2usize]; 4usize],
    pub mm_stats: [ffi::c_int; 4usize],
    pub batched: ffi::c_int,
    pub swappiness: ffi::c_int,
    pub force_scan: bool_,
}
impl Default for lru_gen_mm_walk {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct lru_gen_memcg {
    pub seq: ffi::c_ulong,
    pub nr_memcgs: [ffi::c_ulong; 3usize],
    pub fifo: [[hlist_nulls_head; 8usize]; 3usize],
    pub lock: spinlock_t,
}
impl Default for lru_gen_memcg {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn lru_gen_init_pgdat(pgdat: *mut pglist_data);
}
extern "C" {
    pub fn lru_gen_init_lruvec(lruvec: *mut lruvec);
}
extern "C" {
    pub fn lru_gen_look_around(pvmw: *mut page_vma_mapped_walk) -> bool_;
}
extern "C" {
    pub fn lru_gen_init_memcg(memcg: *mut mem_cgroup);
}
extern "C" {
    pub fn lru_gen_exit_memcg(memcg: *mut mem_cgroup);
}
extern "C" {
    pub fn lru_gen_online_memcg(memcg: *mut mem_cgroup);
}
extern "C" {
    pub fn lru_gen_offline_memcg(memcg: *mut mem_cgroup);
}
extern "C" {
    pub fn lru_gen_release_memcg(memcg: *mut mem_cgroup);
}
extern "C" {
    pub fn lru_gen_soft_reclaim(memcg: *mut mem_cgroup, nid: ffi::c_int);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct lruvec {
    pub lists: [list_head; 5usize],
    pub lru_lock: spinlock_t,
    pub anon_cost: ffi::c_ulong,
    pub file_cost: ffi::c_ulong,
    pub nonresident_age: atomic_long_t,
    pub refaults: [ffi::c_ulong; 2usize],
    pub flags: ffi::c_ulong,
    pub lrugen: lru_gen_folio,
    pub mm_state: lru_gen_mm_state,
    pub pgdat: *mut pglist_data,
    pub zswap_lruvec_state: zswap_lruvec_state,
}
impl Default for lruvec {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type isolate_mode_t = ffi::c_uint;
pub const zone_watermarks_WMARK_MIN: zone_watermarks = 0;
pub const zone_watermarks_WMARK_LOW: zone_watermarks = 1;
pub const zone_watermarks_WMARK_HIGH: zone_watermarks = 2;
pub const zone_watermarks_WMARK_PROMO: zone_watermarks = 3;
pub const zone_watermarks_NR_WMARK: zone_watermarks = 4;
pub type zone_watermarks = ffi::c_uint;
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct per_cpu_pages {
    pub lock: spinlock_t,
    pub count: ffi::c_int,
    pub high: ffi::c_int,
    pub high_min: ffi::c_int,
    pub high_max: ffi::c_int,
    pub batch: ffi::c_int,
    pub flags: u8_,
    pub alloc_factor: u8_,
    pub expire: u8_,
    pub free_count: ffi::c_short,
    pub lists: [list_head; 14usize],
}
impl Default for per_cpu_pages {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct per_cpu_zonestat {
    pub vm_stat_diff: [s8; 12usize],
    pub stat_threshold: s8,
    pub vm_numa_event: [ffi::c_ulong; 6usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct per_cpu_nodestat {
    pub stat_threshold: s8,
    pub vm_node_stat_diff: [s8; 50usize],
}
impl Default for per_cpu_nodestat {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const zone_type_ZONE_DMA: zone_type = 0;
pub const zone_type_ZONE_DMA32: zone_type = 1;
pub const zone_type_ZONE_NORMAL: zone_type = 2;
pub const zone_type_ZONE_MOVABLE: zone_type = 3;
pub const zone_type_ZONE_DEVICE: zone_type = 4;
pub const zone_type___MAX_NR_ZONES: zone_type = 5;
pub type zone_type = ffi::c_uint;
#[repr(C)]
#[repr(align(64))]
pub struct zone {
    pub _watermark: [ffi::c_ulong; 4usize],
    pub watermark_boost: ffi::c_ulong,
    pub nr_reserved_highatomic: ffi::c_ulong,
    pub nr_free_highatomic: ffi::c_ulong,
    pub lowmem_reserve: [ffi::c_long; 5usize],
    pub node: ffi::c_int,
    pub zone_pgdat: *mut pglist_data,
    pub per_cpu_pageset: *mut per_cpu_pages,
    pub per_cpu_zonestats: *mut per_cpu_zonestat,
    pub pageset_high_min: ffi::c_int,
    pub pageset_high_max: ffi::c_int,
    pub pageset_batch: ffi::c_int,
    pub zone_start_pfn: ffi::c_ulong,
    pub managed_pages: atomic_long_t,
    pub spanned_pages: ffi::c_ulong,
    pub present_pages: ffi::c_ulong,
    pub present_early_pages: ffi::c_ulong,
    pub cma_pages: ffi::c_ulong,
    pub name: *const ffi::c_char,
    pub nr_isolate_pageblock: ffi::c_ulong,
    pub span_seqlock: seqlock_t,
    pub initialized: ffi::c_int,
    pub __bindgen_padding_0: [u64; 4usize],
    pub _pad1_: cacheline_padding,
    pub free_area: [free_area; 11usize],
    pub flags: ffi::c_ulong,
    pub lock: spinlock_t,
    pub trylock_free_pages: llist_head,
    pub __bindgen_padding_1: [u64; 6usize],
    pub _pad2_: cacheline_padding,
    pub percpu_drift_mark: ffi::c_ulong,
    pub compact_cached_free_pfn: ffi::c_ulong,
    pub compact_cached_migrate_pfn: [ffi::c_ulong; 2usize],
    pub compact_init_migrate_pfn: ffi::c_ulong,
    pub compact_init_free_pfn: ffi::c_ulong,
    pub compact_considered: ffi::c_uint,
    pub compact_defer_shift: ffi::c_uint,
    pub compact_order_failed: ffi::c_int,
    pub compact_blockskip_flush: bool_,
    pub contiguous: bool_,
    pub __bindgen_padding_2: [u64; 0usize],
    pub _pad3_: cacheline_padding,
    pub vm_stat: [atomic_long_t; 12usize],
    pub vm_numa_event: [atomic_long_t; 6usize],
}
impl Default for zone {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const pgdat_flags_PGDAT_DIRTY: pgdat_flags = 0;
pub const pgdat_flags_PGDAT_WRITEBACK: pgdat_flags = 1;
pub const pgdat_flags_PGDAT_RECLAIM_LOCKED: pgdat_flags = 2;
pub type pgdat_flags = ffi::c_uint;
pub const zone_flags_ZONE_BOOSTED_WATERMARK: zone_flags = 0;
pub const zone_flags_ZONE_RECLAIM_ACTIVE: zone_flags = 1;
pub const zone_flags_ZONE_BELOW_HIGH: zone_flags = 2;
pub type zone_flags = ffi::c_uint;
extern "C" {
    pub fn memmap_init_zone_device(
        arg1: *mut zone,
        arg2: ffi::c_ulong,
        arg3: ffi::c_ulong,
        arg4: *mut dev_pagemap,
    );
}
pub const ZONELIST_FALLBACK: _bindgen_ty_15 = 0;
pub const ZONELIST_NOFALLBACK: _bindgen_ty_15 = 1;
pub const MAX_ZONELISTS: _bindgen_ty_15 = 2;
pub type _bindgen_ty_15 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct zoneref {
    pub zone: *mut zone,
    pub zone_idx: ffi::c_int,
}
impl Default for zoneref {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct zonelist {
    pub _zonerefs: [zoneref; 2561usize],
}
impl Default for zonelist {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut mem_map: *mut page;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct deferred_split {
    pub split_queue_lock: spinlock_t,
    pub split_queue: list_head,
    pub split_queue_len: ffi::c_ulong,
}
impl Default for deferred_split {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct memory_failure_stats {
    pub total: ffi::c_ulong,
    pub ignored: ffi::c_ulong,
    pub failed: ffi::c_ulong,
    pub delayed: ffi::c_ulong,
    pub recovered: ffi::c_ulong,
}
#[repr(C)]
#[repr(align(64))]
pub struct pglist_data {
    pub node_zones: [zone; 5usize],
    pub node_zonelists: [zonelist; 2usize],
    pub nr_zones: ffi::c_int,
    pub node_size_lock: spinlock_t,
    pub node_start_pfn: ffi::c_ulong,
    pub node_present_pages: ffi::c_ulong,
    pub node_spanned_pages: ffi::c_ulong,
    pub node_id: ffi::c_int,
    pub kswapd_wait: wait_queue_head_t,
    pub pfmemalloc_wait: wait_queue_head_t,
    pub reclaim_wait: [wait_queue_head_t; 4usize],
    pub nr_writeback_throttled: atomic_t,
    pub nr_reclaim_start: ffi::c_ulong,
    pub kswapd_lock: mutex,
    pub kswapd: *mut task_struct,
    pub kswapd_order: ffi::c_int,
    pub kswapd_highest_zoneidx: zone_type,
    pub kswapd_failures: ffi::c_int,
    pub kcompactd_max_order: ffi::c_int,
    pub kcompactd_highest_zoneidx: zone_type,
    pub kcompactd_wait: wait_queue_head_t,
    pub kcompactd: *mut task_struct,
    pub proactive_compact_trigger: bool_,
    pub totalreserve_pages: ffi::c_ulong,
    pub min_unmapped_pages: ffi::c_ulong,
    pub min_slab_pages: ffi::c_ulong,
    pub __bindgen_padding_0: [u64; 3usize],
    pub _pad1_: cacheline_padding,
    pub deferred_split_queue: deferred_split,
    pub nbp_rl_start: ffi::c_uint,
    pub nbp_rl_nr_cand: ffi::c_ulong,
    pub nbp_threshold: ffi::c_uint,
    pub nbp_th_start: ffi::c_uint,
    pub nbp_th_nr_cand: ffi::c_ulong,
    pub __lruvec: lruvec,
    pub flags: ffi::c_ulong,
    pub mm_walk: lru_gen_mm_walk,
    pub memcg_lru: lru_gen_memcg,
    pub __bindgen_padding_1: u64,
    pub _pad2_: cacheline_padding,
    pub per_cpu_nodestats: *mut per_cpu_nodestat,
    pub vm_stat: [atomic_long_t; 50usize],
    pub memtier: *mut memory_tier,
    pub mf_stats: memory_failure_stats,
}
impl Default for pglist_data {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type pg_data_t = pglist_data;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rcu_cblist {
    pub head: *mut callback_head,
    pub tail: *mut *mut callback_head,
    pub len: ffi::c_long,
}
impl Default for rcu_cblist {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rcu_segcblist {
    pub head: *mut callback_head,
    pub tails: [*mut *mut callback_head; 4usize],
    pub gp_seq: [ffi::c_ulong; 4usize],
    pub len: atomic_long_t,
    pub seglen: [ffi::c_long; 4usize],
    pub flags: u8_,
}
impl Default for rcu_segcblist {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn init_srcu_struct(ssp: *mut srcu_struct) -> ffi::c_int;
}
extern "C" {
    pub fn __srcu_read_unlock(ssp: *mut srcu_struct, idx: ffi::c_int);
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct srcu_ctr {
    pub srcu_locks: atomic_long_t,
    pub srcu_unlocks: atomic_long_t,
}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct srcu_data {
    pub srcu_ctrs: [srcu_ctr; 2usize],
    pub srcu_reader_flavor: ffi::c_int,
    pub __bindgen_padding_0: [u32; 7usize],
    pub lock: spinlock_t,
    pub srcu_cblist: rcu_segcblist,
    pub srcu_gp_seq_needed: ffi::c_ulong,
    pub srcu_gp_seq_needed_exp: ffi::c_ulong,
    pub srcu_cblist_invoking: bool_,
    pub delay_work: timer_list,
    pub work: work_struct,
    pub srcu_barrier_head: callback_head,
    pub mynode: *mut srcu_node,
    pub grpmask: ffi::c_ulong,
    pub cpu: ffi::c_int,
    pub ssp: *mut srcu_struct,
}
impl Default for srcu_data {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct srcu_node {
    pub lock: spinlock_t,
    pub srcu_have_cbs: [ffi::c_ulong; 4usize],
    pub srcu_data_have_cbs: [ffi::c_ulong; 4usize],
    pub srcu_gp_seq_needed_exp: ffi::c_ulong,
    pub srcu_parent: *mut srcu_node,
    pub grplo: ffi::c_int,
    pub grphi: ffi::c_int,
}
impl Default for srcu_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct srcu_usage {
    pub node: *mut srcu_node,
    pub level: [*mut srcu_node; 4usize],
    pub srcu_size_state: ffi::c_int,
    pub srcu_cb_mutex: mutex,
    pub lock: spinlock_t,
    pub srcu_gp_mutex: mutex,
    pub srcu_gp_seq: ffi::c_ulong,
    pub srcu_gp_seq_needed: ffi::c_ulong,
    pub srcu_gp_seq_needed_exp: ffi::c_ulong,
    pub srcu_gp_start: ffi::c_ulong,
    pub srcu_last_gp_end: ffi::c_ulong,
    pub srcu_size_jiffies: ffi::c_ulong,
    pub srcu_n_lock_retries: ffi::c_ulong,
    pub srcu_n_exp_nodelay: ffi::c_ulong,
    pub sda_is_static: bool_,
    pub srcu_barrier_seq: ffi::c_ulong,
    pub srcu_barrier_mutex: mutex,
    pub srcu_barrier_completion: completion,
    pub srcu_barrier_cpu_cnt: atomic_t,
    pub reschedule_jiffies: ffi::c_ulong,
    pub reschedule_count: ffi::c_ulong,
    pub work: delayed_work,
    pub srcu_ssp: *mut srcu_struct,
}
impl Default for srcu_usage {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct srcu_struct {
    pub srcu_ctrp: *mut srcu_ctr,
    pub sda: *mut srcu_data,
    pub dep_map: lockdep_map,
    pub srcu_sup: *mut srcu_usage,
}
impl Default for srcu_struct {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn __srcu_read_lock(ssp: *mut srcu_struct) -> ffi::c_int;
}
extern "C" {
    pub fn synchronize_srcu_expedited(ssp: *mut srcu_struct);
}
extern "C" {
    pub fn srcu_barrier(ssp: *mut srcu_struct);
}
extern "C" {
    pub fn srcu_torture_stats_print(
        ssp: *mut srcu_struct,
        tt: *mut ffi::c_char,
        tf: *mut ffi::c_char,
    );
}
extern "C" {
    pub fn __srcu_check_read_flavor(ssp: *mut srcu_struct, read_flavor: ffi::c_int);
}
extern "C" {
    pub fn call_srcu(
        ssp: *mut srcu_struct,
        head: *mut callback_head,
        func: ::core::option::Option<unsafe extern "C" fn(head: *mut callback_head)>,
    );
}
extern "C" {
    pub fn cleanup_srcu_struct(ssp: *mut srcu_struct);
}
extern "C" {
    pub fn synchronize_srcu(ssp: *mut srcu_struct);
}
extern "C" {
    pub fn get_state_synchronize_srcu(ssp: *mut srcu_struct) -> ffi::c_ulong;
}
extern "C" {
    pub fn start_poll_synchronize_srcu(ssp: *mut srcu_struct) -> ffi::c_ulong;
}
extern "C" {
    pub fn poll_state_synchronize_srcu(ssp: *mut srcu_struct, cookie: ffi::c_ulong) -> bool_;
}
extern "C" {
    pub fn srcu_init();
}
pub const class_srcu_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_srcu_t {
    pub lock: *mut srcu_struct,
    pub idx: ffi::c_int,
}
impl Default for class_srcu_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type notifier_fn_t = ::core::option::Option<
    unsafe extern "C" fn(
        nb: *mut notifier_block,
        action: ffi::c_ulong,
        data: *mut ffi::c_void,
    ) -> ffi::c_int,
>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct notifier_block {
    pub notifier_call: notifier_fn_t,
    pub next: *mut notifier_block,
    pub priority: ffi::c_int,
}
impl Default for notifier_block {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct atomic_notifier_head {
    pub lock: spinlock_t,
    pub head: *mut notifier_block,
}
impl Default for atomic_notifier_head {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct blocking_notifier_head {
    pub rwsem: rw_semaphore,
    pub head: *mut notifier_block,
}
impl Default for blocking_notifier_head {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct raw_notifier_head {
    pub head: *mut notifier_block,
}
impl Default for raw_notifier_head {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct srcu_notifier_head {
    pub mutex: mutex,
    pub srcuu: srcu_usage,
    pub srcu: srcu_struct,
    pub head: *mut notifier_block,
}
impl Default for srcu_notifier_head {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn srcu_init_notifier_head(nh: *mut srcu_notifier_head);
}
extern "C" {
    pub fn atomic_notifier_chain_register(
        nh: *mut atomic_notifier_head,
        nb: *mut notifier_block,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn blocking_notifier_chain_register(
        nh: *mut blocking_notifier_head,
        nb: *mut notifier_block,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn raw_notifier_chain_register(
        nh: *mut raw_notifier_head,
        nb: *mut notifier_block,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn srcu_notifier_chain_register(
        nh: *mut srcu_notifier_head,
        nb: *mut notifier_block,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn atomic_notifier_chain_register_unique_prio(
        nh: *mut atomic_notifier_head,
        nb: *mut notifier_block,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn blocking_notifier_chain_register_unique_prio(
        nh: *mut blocking_notifier_head,
        nb: *mut notifier_block,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn atomic_notifier_chain_unregister(
        nh: *mut atomic_notifier_head,
        nb: *mut notifier_block,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn blocking_notifier_chain_unregister(
        nh: *mut blocking_notifier_head,
        nb: *mut notifier_block,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn raw_notifier_chain_unregister(
        nh: *mut raw_notifier_head,
        nb: *mut notifier_block,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn srcu_notifier_chain_unregister(
        nh: *mut srcu_notifier_head,
        nb: *mut notifier_block,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn atomic_notifier_call_chain(
        nh: *mut atomic_notifier_head,
        val: ffi::c_ulong,
        v: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn blocking_notifier_call_chain(
        nh: *mut blocking_notifier_head,
        val: ffi::c_ulong,
        v: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn raw_notifier_call_chain(
        nh: *mut raw_notifier_head,
        val: ffi::c_ulong,
        v: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn srcu_notifier_call_chain(
        nh: *mut srcu_notifier_head,
        val: ffi::c_ulong,
        v: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn blocking_notifier_call_chain_robust(
        nh: *mut blocking_notifier_head,
        val_up: ffi::c_ulong,
        val_down: ffi::c_ulong,
        v: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn raw_notifier_call_chain_robust(
        nh: *mut raw_notifier_head,
        val_up: ffi::c_ulong,
        val_down: ffi::c_ulong,
        v: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn atomic_notifier_call_chain_is_empty(nh: *mut atomic_notifier_head) -> bool_;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct memory_group {
    _unused: [u8; 0],
}
extern "C" {
    pub fn pfn_to_online_page(pfn: ffi::c_ulong) -> *mut page;
}
pub const MMOP_OFFLINE: _bindgen_ty_16 = 0;
pub const MMOP_ONLINE: _bindgen_ty_16 = 1;
pub const MMOP_ONLINE_KERNEL: _bindgen_ty_16 = 2;
pub const MMOP_ONLINE_MOVABLE: _bindgen_ty_16 = 3;
pub type _bindgen_ty_16 = ffi::c_uint;
pub type mhp_t = ffi::c_int;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mhp_params {
    pub altmap: *mut vmem_altmap,
    pub pgprot: pgprot_t,
    pub pgmap: *mut dev_pagemap,
}
impl Default for mhp_params {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn mhp_range_allowed(start: u64_, size: u64_, need_mapping: bool_) -> bool_;
}
extern "C" {
    pub fn mhp_get_pluggable_range(need_mapping: bool_) -> range;
}
extern "C" {
    pub fn mhp_supports_memmap_on_memory() -> bool_;
}
extern "C" {
    pub fn adjust_present_page_count(
        page: *mut page,
        group: *mut memory_group,
        nr_pages: ffi::c_long,
    );
}
extern "C" {
    pub fn mhp_init_memmap_on_memory(
        pfn: ffi::c_ulong,
        nr_pages: ffi::c_ulong,
        zone: *mut zone,
        mhp_off_inaccessible: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mhp_deinit_memmap_on_memory(pfn: ffi::c_ulong, nr_pages: ffi::c_ulong);
}
extern "C" {
    pub fn online_pages(
        pfn: ffi::c_ulong,
        nr_pages: ffi::c_ulong,
        zone: *mut zone,
        group: *mut memory_group,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __offline_isolated_pages(start_pfn: ffi::c_ulong, end_pfn: ffi::c_ulong)
        -> ffi::c_ulong;
}
pub type online_page_callback_t =
    ::core::option::Option<unsafe extern "C" fn(page: *mut page, order: ffi::c_uint)>;
extern "C" {
    pub fn generic_online_page(page: *mut page, order: ffi::c_uint);
}
extern "C" {
    pub fn set_online_page_callback(callback: online_page_callback_t) -> ffi::c_int;
}
extern "C" {
    pub fn restore_online_page_callback(callback: online_page_callback_t) -> ffi::c_int;
}
extern "C" {
    pub fn try_online_node(nid: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn arch_add_memory(
        nid: ffi::c_int,
        start: u64_,
        size: u64_,
        params: *mut mhp_params,
    ) -> ffi::c_int;
}
extern "C" {
    pub static mut max_mem_size: u64_;
}
extern "C" {
    pub fn mhp_online_type_from_str(str_: *const ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub static mut movable_node_enabled: bool_;
}
extern "C" {
    pub fn arch_remove_memory(start: u64_, size: u64_, altmap: *mut vmem_altmap);
}
extern "C" {
    pub fn __remove_pages(
        start_pfn: ffi::c_ulong,
        nr_pages: ffi::c_ulong,
        altmap: *mut vmem_altmap,
    );
}
extern "C" {
    pub fn __add_pages(
        nid: ffi::c_int,
        start_pfn: ffi::c_ulong,
        nr_pages: ffi::c_ulong,
        params: *mut mhp_params,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn get_online_mems();
}
extern "C" {
    pub fn put_online_mems();
}
extern "C" {
    pub fn mem_hotplug_begin();
}
extern "C" {
    pub fn mem_hotplug_done();
}
extern "C" {
    pub fn arch_get_mappable_range() -> range;
}
extern "C" {
    pub fn try_offline_node(nid: ffi::c_int);
}
extern "C" {
    pub fn offline_pages(
        start_pfn: ffi::c_ulong,
        nr_pages: ffi::c_ulong,
        zone: *mut zone,
        group: *mut memory_group,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn remove_memory(start: u64_, size: u64_) -> ffi::c_int;
}
extern "C" {
    pub fn __remove_memory(start: u64_, size: u64_);
}
extern "C" {
    pub fn offline_and_remove_memory(start: u64_, size: u64_) -> ffi::c_int;
}
extern "C" {
    pub fn mhp_get_default_online_type() -> ffi::c_int;
}
extern "C" {
    pub fn mhp_set_default_online_type(online_type: ffi::c_int);
}
extern "C" {
    pub fn free_area_init_core_hotplug(pgdat: *mut pglist_data);
}
extern "C" {
    pub fn __add_memory(nid: ffi::c_int, start: u64_, size: u64_, mhp_flags: mhp_t) -> ffi::c_int;
}
extern "C" {
    pub fn add_memory(nid: ffi::c_int, start: u64_, size: u64_, mhp_flags: mhp_t) -> ffi::c_int;
}
extern "C" {
    pub fn add_memory_resource(
        nid: ffi::c_int,
        resource: *mut resource,
        mhp_flags: mhp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn add_memory_driver_managed(
        nid: ffi::c_int,
        start: u64_,
        size: u64_,
        resource_name: *const ffi::c_char,
        mhp_flags: mhp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn move_pfn_range_to_zone(
        zone: *mut zone,
        start_pfn: ffi::c_ulong,
        nr_pages: ffi::c_ulong,
        altmap: *mut vmem_altmap,
        migratetype: ffi::c_int,
    );
}
extern "C" {
    pub fn remove_pfn_range_from_zone(
        zone: *mut zone,
        start_pfn: ffi::c_ulong,
        nr_pages: ffi::c_ulong,
    );
}
extern "C" {
    pub fn sparse_add_section(
        nid: ffi::c_int,
        pfn: ffi::c_ulong,
        nr_pages: ffi::c_ulong,
        altmap: *mut vmem_altmap,
        pgmap: *mut dev_pagemap,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sparse_remove_section(
        pfn: ffi::c_ulong,
        nr_pages: ffi::c_ulong,
        altmap: *mut vmem_altmap,
    );
}
extern "C" {
    pub fn sparse_decode_mem_map(coded_mem_map: ffi::c_ulong, pnum: ffi::c_ulong) -> *mut page;
}
extern "C" {
    pub fn zone_for_pfn_range(
        online_type: ffi::c_int,
        nid: ffi::c_int,
        group: *mut memory_group,
        start_pfn: ffi::c_ulong,
        nr_pages: ffi::c_ulong,
    ) -> *mut zone;
}
extern "C" {
    pub fn arch_create_linear_mapping(
        nid: ffi::c_int,
        start: u64_,
        size: u64_,
        params: *mut mhp_params,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn arch_remove_linear_mapping(start: u64_, size: u64_);
}
extern "C" {
    pub fn build_all_zonelists(pgdat: *mut pg_data_t);
}
extern "C" {
    pub fn wakeup_kswapd(
        zone: *mut zone,
        gfp_mask: gfp_t,
        order: ffi::c_int,
        highest_zoneidx: zone_type,
    );
}
extern "C" {
    pub fn __zone_watermark_ok(
        z: *mut zone,
        order: ffi::c_uint,
        mark: ffi::c_ulong,
        highest_zoneidx: ffi::c_int,
        alloc_flags: ffi::c_uint,
        free_pages: ffi::c_long,
    ) -> bool_;
}
extern "C" {
    pub fn zone_watermark_ok(
        z: *mut zone,
        order: ffi::c_uint,
        mark: ffi::c_ulong,
        highest_zoneidx: ffi::c_int,
        alloc_flags: ffi::c_uint,
    ) -> bool_;
}
pub const meminit_context_MEMINIT_EARLY: meminit_context = 0;
pub const meminit_context_MEMINIT_HOTPLUG: meminit_context = 1;
pub type meminit_context = ffi::c_uint;
extern "C" {
    pub fn init_currently_empty_zone(zone: *mut zone, start_pfn: ffi::c_ulong, size: ffi::c_ulong);
}
extern "C" {
    pub fn lruvec_init(lruvec: *mut lruvec);
}
extern "C" {
    pub static mut movable_zone: ffi::c_int;
}
extern "C" {
    pub fn has_managed_dma() -> bool_;
}
extern "C" {
    pub fn first_online_pgdat() -> *mut pglist_data;
}
extern "C" {
    pub fn next_online_pgdat(pgdat: *mut pglist_data) -> *mut pglist_data;
}
extern "C" {
    pub fn next_zone(zone: *mut zone) -> *mut zone;
}
extern "C" {
    pub fn __next_zones_zonelist(
        z: *mut zoneref,
        highest_zoneidx: zone_type,
        nodes: *mut nodemask_t,
    ) -> *mut zoneref;
}
#[repr(C)]
pub struct mem_section_usage {
    pub rcu: callback_head,
    pub subsection_map: [ffi::c_ulong; 1usize],
    pub pageblock_flags: __IncompleteArrayField<ffi::c_ulong>,
}
impl Default for mem_section_usage {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn subsection_map_init(pfn: ffi::c_ulong, nr_pages: ffi::c_ulong);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mem_section {
    pub section_mem_map: ffi::c_ulong,
    pub usage: *mut mem_section_usage,
    pub page_ext: *mut page_ext,
    pub pad: ffi::c_ulong,
}
impl Default for mem_section {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut mem_section: *mut *mut mem_section;
}
extern "C" {
    pub fn mem_section_usage_size() -> usize;
}
pub const SECTION_MARKED_PRESENT_BIT: _bindgen_ty_17 = 0;
pub const SECTION_HAS_MEM_MAP_BIT: _bindgen_ty_17 = 1;
pub const SECTION_IS_ONLINE_BIT: _bindgen_ty_17 = 2;
pub const SECTION_IS_EARLY_BIT: _bindgen_ty_17 = 3;
pub const SECTION_TAINT_ZONE_DEVICE_BIT: _bindgen_ty_17 = 4;
pub const SECTION_MAP_LAST_BIT: _bindgen_ty_17 = 5;
pub type _bindgen_ty_17 = ffi::c_uint;
extern "C" {
    pub fn online_mem_sections(start_pfn: ffi::c_ulong, end_pfn: ffi::c_ulong);
}
extern "C" {
    pub fn offline_mem_sections(start_pfn: ffi::c_ulong, end_pfn: ffi::c_ulong);
}
extern "C" {
    pub static mut __highest_present_section_nr: ffi::c_ulong;
}
extern "C" {
    pub fn sparse_init_early_section(
        nid: ffi::c_int,
        map: *mut page,
        pnum: ffi::c_ulong,
        flags: ffi::c_ulong,
    );
}
extern "C" {
    pub fn sparse_init();
}
extern "C" {
    pub fn topology_normalize_cpu_scale();
}
extern "C" {
    pub fn topology_update_cpu_topology() -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct device_node {
    _unused: [u8; 0],
}
extern "C" {
    pub fn topology_parse_cpu_capacity(cpu_node: *mut device_node, cpu: ffi::c_int) -> bool_;
}
extern "C" {
    pub static mut cpu_scale: ffi::c_ulong;
}
extern "C" {
    pub fn topology_set_cpu_scale(cpu: ffi::c_uint, capacity: ffi::c_ulong);
}
extern "C" {
    pub static mut capacity_freq_ref: ffi::c_ulong;
}
extern "C" {
    pub static mut arch_freq_scale: ffi::c_ulong;
}
extern "C" {
    pub fn topology_set_freq_scale(
        cpus: *const cpumask,
        cur_freq: ffi::c_ulong,
        max_freq: ffi::c_ulong,
    );
}
extern "C" {
    pub fn topology_scale_freq_invariant() -> bool_;
}
pub const scale_freq_source_SCALE_FREQ_SOURCE_CPUFREQ: scale_freq_source = 0;
pub const scale_freq_source_SCALE_FREQ_SOURCE_ARCH: scale_freq_source = 1;
pub const scale_freq_source_SCALE_FREQ_SOURCE_CPPC: scale_freq_source = 2;
pub const scale_freq_source_SCALE_FREQ_SOURCE_VIRT: scale_freq_source = 3;
pub type scale_freq_source = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct scale_freq_data {
    pub source: scale_freq_source,
    pub set_freq_scale: ::core::option::Option<unsafe extern "C" fn()>,
}
impl Default for scale_freq_data {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn topology_scale_freq_tick();
}
extern "C" {
    pub fn topology_set_scale_freq_source(data: *mut scale_freq_data, cpus: *const cpumask);
}
extern "C" {
    pub fn topology_clear_scale_freq_source(source: scale_freq_source, cpus: *const cpumask);
}
extern "C" {
    pub static mut hw_pressure: ffi::c_ulong;
}
extern "C" {
    pub fn topology_update_hw_pressure(cpus: *const cpumask, capped_freq: ffi::c_ulong);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct cpu_topology {
    pub thread_id: ffi::c_int,
    pub core_id: ffi::c_int,
    pub cluster_id: ffi::c_int,
    pub package_id: ffi::c_int,
    pub thread_sibling: cpumask_t,
    pub core_sibling: cpumask_t,
    pub cluster_sibling: cpumask_t,
    pub llc_sibling: cpumask_t,
}
impl Default for cpu_topology {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut cpu_topology: [cpu_topology; 4096usize];
}
extern "C" {
    pub fn init_cpu_topology();
}
extern "C" {
    pub fn store_cpu_topology(cpuid: ffi::c_uint);
}
extern "C" {
    pub fn cpu_coregroup_mask(cpu: ffi::c_int) -> *const cpumask;
}
extern "C" {
    pub fn cpu_clustergroup_mask(cpu: ffi::c_int) -> *const cpumask;
}
extern "C" {
    pub fn update_siblings_masks(cpu: ffi::c_uint);
}
extern "C" {
    pub fn remove_cpu_topology(cpuid: ffi::c_uint);
}
extern "C" {
    pub fn reset_cpu_topology();
}
extern "C" {
    pub fn parse_acpi_topology() -> ffi::c_int;
}
extern "C" {
    pub fn freq_inv_set_max_ratio(cpu: ffi::c_int, max_rate: u64_);
}
extern "C" {
    pub fn __node_distance(from: ffi::c_int, to: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub static mut numa_nodes_parsed: nodemask_t;
}
extern "C" {
    pub static mut numa_off: bool_;
}
extern "C" {
    pub static mut node_to_cpumask_map: [cpumask_var_t; 512usize];
}
extern "C" {
    pub fn numa_clear_node(cpu: ffi::c_uint);
}
extern "C" {
    pub fn arch_numa_init();
}
extern "C" {
    pub fn numa_add_memblk(nodeid: ffi::c_int, start: u64_, end: u64_) -> ffi::c_int;
}
extern "C" {
    pub fn early_map_cpu_to_node(cpu: ffi::c_uint, nid: ffi::c_int);
}
extern "C" {
    pub fn early_cpu_to_node(cpu: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn numa_store_cpu_info(cpu: ffi::c_uint);
}
extern "C" {
    pub fn numa_add_cpu(cpu: ffi::c_uint);
}
extern "C" {
    pub fn numa_remove_cpu(cpu: ffi::c_uint);
}
extern "C" {
    pub fn pcibus_to_node(bus: *mut pci_bus) -> ffi::c_int;
}
extern "C" {
    pub fn update_freq_counters_refs();
}
extern "C" {
    pub static mut node_reclaim_distance: ffi::c_int;
}
extern "C" {
    pub static mut numa_node: ffi::c_int;
}
extern "C" {
    pub fn sched_numa_find_nth_cpu(
        cpus: *const cpumask,
        cpu: ffi::c_int,
        node: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sched_numa_hop_mask(node: ffi::c_uint, hops: ffi::c_uint) -> *const cpumask;
}
extern "C" {
    pub fn __alloc_pages_noprof(
        gfp: gfp_t,
        order: ffi::c_uint,
        preferred_nid: ffi::c_int,
        nodemask: *mut nodemask_t,
    ) -> *mut page;
}
extern "C" {
    pub fn __folio_alloc_noprof(
        gfp: gfp_t,
        order: ffi::c_uint,
        preferred_nid: ffi::c_int,
        nodemask: *mut nodemask_t,
    ) -> *mut folio;
}
extern "C" {
    pub fn alloc_pages_bulk_noprof(
        gfp: gfp_t,
        preferred_nid: ffi::c_int,
        nodemask: *mut nodemask_t,
        nr_pages: ffi::c_int,
        page_array: *mut *mut page,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn alloc_pages_bulk_mempolicy_noprof(
        gfp: gfp_t,
        nr_pages: ffi::c_ulong,
        page_array: *mut *mut page,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn alloc_pages_noprof(gfp: gfp_t, order: ffi::c_uint) -> *mut page;
}
extern "C" {
    pub fn folio_alloc_noprof(gfp: gfp_t, order: ffi::c_uint) -> *mut folio;
}
extern "C" {
    pub fn folio_alloc_mpol_noprof(
        gfp: gfp_t,
        order: ffi::c_uint,
        mpol: *mut mempolicy,
        ilx: ffi::c_ulong,
        nid: ffi::c_int,
    ) -> *mut folio;
}
extern "C" {
    pub fn vma_alloc_folio_noprof(
        gfp: gfp_t,
        order: ffi::c_int,
        vma: *mut vm_area_struct,
        addr: ffi::c_ulong,
    ) -> *mut folio;
}
extern "C" {
    pub fn try_alloc_pages_noprof(nid: ffi::c_int, order: ffi::c_uint) -> *mut page;
}
extern "C" {
    pub fn get_free_pages_noprof(gfp_mask: gfp_t, order: ffi::c_uint) -> ffi::c_ulong;
}
extern "C" {
    pub fn get_zeroed_page_noprof(gfp_mask: gfp_t) -> ffi::c_ulong;
}
extern "C" {
    pub fn alloc_pages_exact_noprof(size: usize, gfp_mask: gfp_t) -> *mut ffi::c_void;
}
extern "C" {
    pub fn free_pages_exact(virt: *mut ffi::c_void, size: usize);
}
extern "C" {
    pub fn alloc_pages_exact_nid_noprof(
        nid: ffi::c_int,
        size: usize,
        gfp_mask: gfp_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn __free_pages(page: *mut page, order: ffi::c_uint);
}
extern "C" {
    pub fn free_pages_nolock(page: *mut page, order: ffi::c_uint);
}
extern "C" {
    pub fn free_pages(addr: ffi::c_ulong, order: ffi::c_uint);
}
extern "C" {
    pub fn page_alloc_init_cpuhp();
}
extern "C" {
    pub fn decay_pcp_high(zone: *mut zone, pcp: *mut per_cpu_pages) -> ffi::c_int;
}
extern "C" {
    pub fn drain_zone_pages(zone: *mut zone, pcp: *mut per_cpu_pages);
}
extern "C" {
    pub fn drain_all_pages(zone: *mut zone);
}
extern "C" {
    pub fn drain_local_pages(zone: *mut zone);
}
extern "C" {
    pub fn page_alloc_init_late();
}
extern "C" {
    pub fn setup_pcp_cacheinfo(cpu: ffi::c_uint);
}
extern "C" {
    pub static mut gfp_allowed_mask: gfp_t;
}
extern "C" {
    pub fn gfp_pfmemalloc_allowed(gfp_mask: gfp_t) -> bool_;
}
extern "C" {
    pub fn vma_thp_gfp_mask(vma: *mut vm_area_struct) -> gfp_t;
}
extern "C" {
    pub fn alloc_contig_range_noprof(
        start: ffi::c_ulong,
        end: ffi::c_ulong,
        migratetype: ffi::c_uint,
        gfp_mask: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn alloc_contig_pages_noprof(
        nr_pages: ffi::c_ulong,
        gfp_mask: gfp_t,
        nid: ffi::c_int,
        nodemask: *mut nodemask_t,
    ) -> *mut page;
}
extern "C" {
    pub fn free_contig_range(pfn: ffi::c_ulong, nr_pages: ffi::c_ulong);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct __sysctl_args {
    pub name: *mut ffi::c_int,
    pub nlen: ffi::c_int,
    pub oldval: *mut ffi::c_void,
    pub oldlenp: *mut usize,
    pub newval: *mut ffi::c_void,
    pub newlen: usize,
    pub __unused: [ffi::c_ulong; 4usize],
}
impl Default for __sysctl_args {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const CTL_KERN: _bindgen_ty_18 = 1;
pub const CTL_VM: _bindgen_ty_18 = 2;
pub const CTL_NET: _bindgen_ty_18 = 3;
pub const CTL_PROC: _bindgen_ty_18 = 4;
pub const CTL_FS: _bindgen_ty_18 = 5;
pub const CTL_DEBUG: _bindgen_ty_18 = 6;
pub const CTL_DEV: _bindgen_ty_18 = 7;
pub const CTL_BUS: _bindgen_ty_18 = 8;
pub const CTL_ABI: _bindgen_ty_18 = 9;
pub const CTL_CPU: _bindgen_ty_18 = 10;
pub const CTL_ARLAN: _bindgen_ty_18 = 254;
pub const CTL_S390DBF: _bindgen_ty_18 = 5677;
pub const CTL_SUNRPC: _bindgen_ty_18 = 7249;
pub const CTL_PM: _bindgen_ty_18 = 9899;
pub const CTL_FRV: _bindgen_ty_18 = 9898;
pub type _bindgen_ty_18 = ffi::c_uint;
pub const CTL_BUS_ISA: _bindgen_ty_19 = 1;
pub type _bindgen_ty_19 = ffi::c_uint;
pub const INOTIFY_MAX_USER_INSTANCES: _bindgen_ty_20 = 1;
pub const INOTIFY_MAX_USER_WATCHES: _bindgen_ty_20 = 2;
pub const INOTIFY_MAX_QUEUED_EVENTS: _bindgen_ty_20 = 3;
pub type _bindgen_ty_20 = ffi::c_uint;
pub const KERN_OSTYPE: _bindgen_ty_21 = 1;
pub const KERN_OSRELEASE: _bindgen_ty_21 = 2;
pub const KERN_OSREV: _bindgen_ty_21 = 3;
pub const KERN_VERSION: _bindgen_ty_21 = 4;
pub const KERN_SECUREMASK: _bindgen_ty_21 = 5;
pub const KERN_PROF: _bindgen_ty_21 = 6;
pub const KERN_NODENAME: _bindgen_ty_21 = 7;
pub const KERN_DOMAINNAME: _bindgen_ty_21 = 8;
pub const KERN_PANIC: _bindgen_ty_21 = 15;
pub const KERN_REALROOTDEV: _bindgen_ty_21 = 16;
pub const KERN_SPARC_REBOOT: _bindgen_ty_21 = 21;
pub const KERN_CTLALTDEL: _bindgen_ty_21 = 22;
pub const KERN_PRINTK: _bindgen_ty_21 = 23;
pub const KERN_NAMETRANS: _bindgen_ty_21 = 24;
pub const KERN_PPC_HTABRECLAIM: _bindgen_ty_21 = 25;
pub const KERN_PPC_ZEROPAGED: _bindgen_ty_21 = 26;
pub const KERN_PPC_POWERSAVE_NAP: _bindgen_ty_21 = 27;
pub const KERN_MODPROBE: _bindgen_ty_21 = 28;
pub const KERN_SG_BIG_BUFF: _bindgen_ty_21 = 29;
pub const KERN_ACCT: _bindgen_ty_21 = 30;
pub const KERN_PPC_L2CR: _bindgen_ty_21 = 31;
pub const KERN_RTSIGNR: _bindgen_ty_21 = 32;
pub const KERN_RTSIGMAX: _bindgen_ty_21 = 33;
pub const KERN_SHMMAX: _bindgen_ty_21 = 34;
pub const KERN_MSGMAX: _bindgen_ty_21 = 35;
pub const KERN_MSGMNB: _bindgen_ty_21 = 36;
pub const KERN_MSGPOOL: _bindgen_ty_21 = 37;
pub const KERN_SYSRQ: _bindgen_ty_21 = 38;
pub const KERN_MAX_THREADS: _bindgen_ty_21 = 39;
pub const KERN_RANDOM: _bindgen_ty_21 = 40;
pub const KERN_SHMALL: _bindgen_ty_21 = 41;
pub const KERN_MSGMNI: _bindgen_ty_21 = 42;
pub const KERN_SEM: _bindgen_ty_21 = 43;
pub const KERN_SPARC_STOP_A: _bindgen_ty_21 = 44;
pub const KERN_SHMMNI: _bindgen_ty_21 = 45;
pub const KERN_OVERFLOWUID: _bindgen_ty_21 = 46;
pub const KERN_OVERFLOWGID: _bindgen_ty_21 = 47;
pub const KERN_SHMPATH: _bindgen_ty_21 = 48;
pub const KERN_HOTPLUG: _bindgen_ty_21 = 49;
pub const KERN_IEEE_EMULATION_WARNINGS: _bindgen_ty_21 = 50;
pub const KERN_S390_USER_DEBUG_LOGGING: _bindgen_ty_21 = 51;
pub const KERN_CORE_USES_PID: _bindgen_ty_21 = 52;
pub const KERN_TAINTED: _bindgen_ty_21 = 53;
pub const KERN_CADPID: _bindgen_ty_21 = 54;
pub const KERN_PIDMAX: _bindgen_ty_21 = 55;
pub const KERN_CORE_PATTERN: _bindgen_ty_21 = 56;
pub const KERN_PANIC_ON_OOPS: _bindgen_ty_21 = 57;
pub const KERN_HPPA_PWRSW: _bindgen_ty_21 = 58;
pub const KERN_HPPA_UNALIGNED: _bindgen_ty_21 = 59;
pub const KERN_PRINTK_RATELIMIT: _bindgen_ty_21 = 60;
pub const KERN_PRINTK_RATELIMIT_BURST: _bindgen_ty_21 = 61;
pub const KERN_PTY: _bindgen_ty_21 = 62;
pub const KERN_NGROUPS_MAX: _bindgen_ty_21 = 63;
pub const KERN_SPARC_SCONS_PWROFF: _bindgen_ty_21 = 64;
pub const KERN_HZ_TIMER: _bindgen_ty_21 = 65;
pub const KERN_UNKNOWN_NMI_PANIC: _bindgen_ty_21 = 66;
pub const KERN_BOOTLOADER_TYPE: _bindgen_ty_21 = 67;
pub const KERN_RANDOMIZE: _bindgen_ty_21 = 68;
pub const KERN_SETUID_DUMPABLE: _bindgen_ty_21 = 69;
pub const KERN_SPIN_RETRY: _bindgen_ty_21 = 70;
pub const KERN_ACPI_VIDEO_FLAGS: _bindgen_ty_21 = 71;
pub const KERN_IA64_UNALIGNED: _bindgen_ty_21 = 72;
pub const KERN_COMPAT_LOG: _bindgen_ty_21 = 73;
pub const KERN_MAX_LOCK_DEPTH: _bindgen_ty_21 = 74;
pub const KERN_NMI_WATCHDOG: _bindgen_ty_21 = 75;
pub const KERN_PANIC_ON_NMI: _bindgen_ty_21 = 76;
pub const KERN_PANIC_ON_WARN: _bindgen_ty_21 = 77;
pub const KERN_PANIC_PRINT: _bindgen_ty_21 = 78;
pub type _bindgen_ty_21 = ffi::c_uint;
pub const VM_UNUSED1: _bindgen_ty_22 = 1;
pub const VM_UNUSED2: _bindgen_ty_22 = 2;
pub const VM_UNUSED3: _bindgen_ty_22 = 3;
pub const VM_UNUSED4: _bindgen_ty_22 = 4;
pub const VM_OVERCOMMIT_MEMORY: _bindgen_ty_22 = 5;
pub const VM_UNUSED5: _bindgen_ty_22 = 6;
pub const VM_UNUSED7: _bindgen_ty_22 = 7;
pub const VM_UNUSED8: _bindgen_ty_22 = 8;
pub const VM_UNUSED9: _bindgen_ty_22 = 9;
pub const VM_PAGE_CLUSTER: _bindgen_ty_22 = 10;
pub const VM_DIRTY_BACKGROUND: _bindgen_ty_22 = 11;
pub const VM_DIRTY_RATIO: _bindgen_ty_22 = 12;
pub const VM_DIRTY_WB_CS: _bindgen_ty_22 = 13;
pub const VM_DIRTY_EXPIRE_CS: _bindgen_ty_22 = 14;
pub const VM_NR_PDFLUSH_THREADS: _bindgen_ty_22 = 15;
pub const VM_OVERCOMMIT_RATIO: _bindgen_ty_22 = 16;
pub const VM_PAGEBUF: _bindgen_ty_22 = 17;
pub const VM_HUGETLB_PAGES: _bindgen_ty_22 = 18;
pub const VM_SWAPPINESS: _bindgen_ty_22 = 19;
pub const VM_LOWMEM_RESERVE_RATIO: _bindgen_ty_22 = 20;
pub const VM_MIN_FREE_KBYTES: _bindgen_ty_22 = 21;
pub const VM_MAX_MAP_COUNT: _bindgen_ty_22 = 22;
pub const VM_LAPTOP_MODE: _bindgen_ty_22 = 23;
pub const VM_BLOCK_DUMP: _bindgen_ty_22 = 24;
pub const VM_HUGETLB_GROUP: _bindgen_ty_22 = 25;
pub const VM_VFS_CACHE_PRESSURE: _bindgen_ty_22 = 26;
pub const VM_LEGACY_VA_LAYOUT: _bindgen_ty_22 = 27;
pub const VM_SWAP_TOKEN_TIMEOUT: _bindgen_ty_22 = 28;
pub const VM_DROP_PAGECACHE: _bindgen_ty_22 = 29;
pub const VM_PERCPU_PAGELIST_FRACTION: _bindgen_ty_22 = 30;
pub const VM_ZONE_RECLAIM_MODE: _bindgen_ty_22 = 31;
pub const VM_MIN_UNMAPPED: _bindgen_ty_22 = 32;
pub const VM_PANIC_ON_OOM: _bindgen_ty_22 = 33;
pub const VM_VDSO_ENABLED: _bindgen_ty_22 = 34;
pub const VM_MIN_SLAB: _bindgen_ty_22 = 35;
pub type _bindgen_ty_22 = ffi::c_uint;
pub const NET_CORE: _bindgen_ty_23 = 1;
pub const NET_ETHER: _bindgen_ty_23 = 2;
pub const NET_802: _bindgen_ty_23 = 3;
pub const NET_UNIX: _bindgen_ty_23 = 4;
pub const NET_IPV4: _bindgen_ty_23 = 5;
pub const NET_IPX: _bindgen_ty_23 = 6;
pub const NET_ATALK: _bindgen_ty_23 = 7;
pub const NET_NETROM: _bindgen_ty_23 = 8;
pub const NET_AX25: _bindgen_ty_23 = 9;
pub const NET_BRIDGE: _bindgen_ty_23 = 10;
pub const NET_ROSE: _bindgen_ty_23 = 11;
pub const NET_IPV6: _bindgen_ty_23 = 12;
pub const NET_X25: _bindgen_ty_23 = 13;
pub const NET_TR: _bindgen_ty_23 = 14;
pub const NET_DECNET: _bindgen_ty_23 = 15;
pub const NET_ECONET: _bindgen_ty_23 = 16;
pub const NET_SCTP: _bindgen_ty_23 = 17;
pub const NET_LLC: _bindgen_ty_23 = 18;
pub const NET_NETFILTER: _bindgen_ty_23 = 19;
pub const NET_DCCP: _bindgen_ty_23 = 20;
pub const NET_IRDA: _bindgen_ty_23 = 412;
pub type _bindgen_ty_23 = ffi::c_uint;
pub const RANDOM_POOLSIZE: _bindgen_ty_24 = 1;
pub const RANDOM_ENTROPY_COUNT: _bindgen_ty_24 = 2;
pub const RANDOM_READ_THRESH: _bindgen_ty_24 = 3;
pub const RANDOM_WRITE_THRESH: _bindgen_ty_24 = 4;
pub const RANDOM_BOOT_ID: _bindgen_ty_24 = 5;
pub const RANDOM_UUID: _bindgen_ty_24 = 6;
pub type _bindgen_ty_24 = ffi::c_uint;
pub const PTY_MAX: _bindgen_ty_25 = 1;
pub const PTY_NR: _bindgen_ty_25 = 2;
pub type _bindgen_ty_25 = ffi::c_uint;
pub const BUS_ISA_MEM_BASE: _bindgen_ty_26 = 1;
pub const BUS_ISA_PORT_BASE: _bindgen_ty_26 = 2;
pub const BUS_ISA_PORT_SHIFT: _bindgen_ty_26 = 3;
pub type _bindgen_ty_26 = ffi::c_uint;
pub const NET_CORE_WMEM_MAX: _bindgen_ty_27 = 1;
pub const NET_CORE_RMEM_MAX: _bindgen_ty_27 = 2;
pub const NET_CORE_WMEM_DEFAULT: _bindgen_ty_27 = 3;
pub const NET_CORE_RMEM_DEFAULT: _bindgen_ty_27 = 4;
pub const NET_CORE_MAX_BACKLOG: _bindgen_ty_27 = 6;
pub const NET_CORE_FASTROUTE: _bindgen_ty_27 = 7;
pub const NET_CORE_MSG_COST: _bindgen_ty_27 = 8;
pub const NET_CORE_MSG_BURST: _bindgen_ty_27 = 9;
pub const NET_CORE_OPTMEM_MAX: _bindgen_ty_27 = 10;
pub const NET_CORE_HOT_LIST_LENGTH: _bindgen_ty_27 = 11;
pub const NET_CORE_DIVERT_VERSION: _bindgen_ty_27 = 12;
pub const NET_CORE_NO_CONG_THRESH: _bindgen_ty_27 = 13;
pub const NET_CORE_NO_CONG: _bindgen_ty_27 = 14;
pub const NET_CORE_LO_CONG: _bindgen_ty_27 = 15;
pub const NET_CORE_MOD_CONG: _bindgen_ty_27 = 16;
pub const NET_CORE_DEV_WEIGHT: _bindgen_ty_27 = 17;
pub const NET_CORE_SOMAXCONN: _bindgen_ty_27 = 18;
pub const NET_CORE_BUDGET: _bindgen_ty_27 = 19;
pub const NET_CORE_AEVENT_ETIME: _bindgen_ty_27 = 20;
pub const NET_CORE_AEVENT_RSEQTH: _bindgen_ty_27 = 21;
pub const NET_CORE_WARNINGS: _bindgen_ty_27 = 22;
pub type _bindgen_ty_27 = ffi::c_uint;
pub const NET_UNIX_DESTROY_DELAY: _bindgen_ty_28 = 1;
pub const NET_UNIX_DELETE_DELAY: _bindgen_ty_28 = 2;
pub const NET_UNIX_MAX_DGRAM_QLEN: _bindgen_ty_28 = 3;
pub type _bindgen_ty_28 = ffi::c_uint;
pub const NET_NF_CONNTRACK_MAX: _bindgen_ty_29 = 1;
pub const NET_NF_CONNTRACK_TCP_TIMEOUT_SYN_SENT: _bindgen_ty_29 = 2;
pub const NET_NF_CONNTRACK_TCP_TIMEOUT_SYN_RECV: _bindgen_ty_29 = 3;
pub const NET_NF_CONNTRACK_TCP_TIMEOUT_ESTABLISHED: _bindgen_ty_29 = 4;
pub const NET_NF_CONNTRACK_TCP_TIMEOUT_FIN_WAIT: _bindgen_ty_29 = 5;
pub const NET_NF_CONNTRACK_TCP_TIMEOUT_CLOSE_WAIT: _bindgen_ty_29 = 6;
pub const NET_NF_CONNTRACK_TCP_TIMEOUT_LAST_ACK: _bindgen_ty_29 = 7;
pub const NET_NF_CONNTRACK_TCP_TIMEOUT_TIME_WAIT: _bindgen_ty_29 = 8;
pub const NET_NF_CONNTRACK_TCP_TIMEOUT_CLOSE: _bindgen_ty_29 = 9;
pub const NET_NF_CONNTRACK_UDP_TIMEOUT: _bindgen_ty_29 = 10;
pub const NET_NF_CONNTRACK_UDP_TIMEOUT_STREAM: _bindgen_ty_29 = 11;
pub const NET_NF_CONNTRACK_ICMP_TIMEOUT: _bindgen_ty_29 = 12;
pub const NET_NF_CONNTRACK_GENERIC_TIMEOUT: _bindgen_ty_29 = 13;
pub const NET_NF_CONNTRACK_BUCKETS: _bindgen_ty_29 = 14;
pub const NET_NF_CONNTRACK_LOG_INVALID: _bindgen_ty_29 = 15;
pub const NET_NF_CONNTRACK_TCP_TIMEOUT_MAX_RETRANS: _bindgen_ty_29 = 16;
pub const NET_NF_CONNTRACK_TCP_LOOSE: _bindgen_ty_29 = 17;
pub const NET_NF_CONNTRACK_TCP_BE_LIBERAL: _bindgen_ty_29 = 18;
pub const NET_NF_CONNTRACK_TCP_MAX_RETRANS: _bindgen_ty_29 = 19;
pub const NET_NF_CONNTRACK_SCTP_TIMEOUT_CLOSED: _bindgen_ty_29 = 20;
pub const NET_NF_CONNTRACK_SCTP_TIMEOUT_COOKIE_WAIT: _bindgen_ty_29 = 21;
pub const NET_NF_CONNTRACK_SCTP_TIMEOUT_COOKIE_ECHOED: _bindgen_ty_29 = 22;
pub const NET_NF_CONNTRACK_SCTP_TIMEOUT_ESTABLISHED: _bindgen_ty_29 = 23;
pub const NET_NF_CONNTRACK_SCTP_TIMEOUT_SHUTDOWN_SENT: _bindgen_ty_29 = 24;
pub const NET_NF_CONNTRACK_SCTP_TIMEOUT_SHUTDOWN_RECD: _bindgen_ty_29 = 25;
pub const NET_NF_CONNTRACK_SCTP_TIMEOUT_SHUTDOWN_ACK_SENT: _bindgen_ty_29 = 26;
pub const NET_NF_CONNTRACK_COUNT: _bindgen_ty_29 = 27;
pub const NET_NF_CONNTRACK_ICMPV6_TIMEOUT: _bindgen_ty_29 = 28;
pub const NET_NF_CONNTRACK_FRAG6_TIMEOUT: _bindgen_ty_29 = 29;
pub const NET_NF_CONNTRACK_FRAG6_LOW_THRESH: _bindgen_ty_29 = 30;
pub const NET_NF_CONNTRACK_FRAG6_HIGH_THRESH: _bindgen_ty_29 = 31;
pub const NET_NF_CONNTRACK_CHECKSUM: _bindgen_ty_29 = 32;
pub type _bindgen_ty_29 = ffi::c_uint;
pub const NET_IPV4_FORWARD: _bindgen_ty_30 = 8;
pub const NET_IPV4_DYNADDR: _bindgen_ty_30 = 9;
pub const NET_IPV4_CONF: _bindgen_ty_30 = 16;
pub const NET_IPV4_NEIGH: _bindgen_ty_30 = 17;
pub const NET_IPV4_ROUTE: _bindgen_ty_30 = 18;
pub const NET_IPV4_FIB_HASH: _bindgen_ty_30 = 19;
pub const NET_IPV4_NETFILTER: _bindgen_ty_30 = 20;
pub const NET_IPV4_TCP_TIMESTAMPS: _bindgen_ty_30 = 33;
pub const NET_IPV4_TCP_WINDOW_SCALING: _bindgen_ty_30 = 34;
pub const NET_IPV4_TCP_SACK: _bindgen_ty_30 = 35;
pub const NET_IPV4_TCP_RETRANS_COLLAPSE: _bindgen_ty_30 = 36;
pub const NET_IPV4_DEFAULT_TTL: _bindgen_ty_30 = 37;
pub const NET_IPV4_AUTOCONFIG: _bindgen_ty_30 = 38;
pub const NET_IPV4_NO_PMTU_DISC: _bindgen_ty_30 = 39;
pub const NET_IPV4_TCP_SYN_RETRIES: _bindgen_ty_30 = 40;
pub const NET_IPV4_IPFRAG_HIGH_THRESH: _bindgen_ty_30 = 41;
pub const NET_IPV4_IPFRAG_LOW_THRESH: _bindgen_ty_30 = 42;
pub const NET_IPV4_IPFRAG_TIME: _bindgen_ty_30 = 43;
pub const NET_IPV4_TCP_MAX_KA_PROBES: _bindgen_ty_30 = 44;
pub const NET_IPV4_TCP_KEEPALIVE_TIME: _bindgen_ty_30 = 45;
pub const NET_IPV4_TCP_KEEPALIVE_PROBES: _bindgen_ty_30 = 46;
pub const NET_IPV4_TCP_RETRIES1: _bindgen_ty_30 = 47;
pub const NET_IPV4_TCP_RETRIES2: _bindgen_ty_30 = 48;
pub const NET_IPV4_TCP_FIN_TIMEOUT: _bindgen_ty_30 = 49;
pub const NET_IPV4_IP_MASQ_DEBUG: _bindgen_ty_30 = 50;
pub const NET_TCP_SYNCOOKIES: _bindgen_ty_30 = 51;
pub const NET_TCP_STDURG: _bindgen_ty_30 = 52;
pub const NET_TCP_RFC1337: _bindgen_ty_30 = 53;
pub const NET_TCP_SYN_TAILDROP: _bindgen_ty_30 = 54;
pub const NET_TCP_MAX_SYN_BACKLOG: _bindgen_ty_30 = 55;
pub const NET_IPV4_LOCAL_PORT_RANGE: _bindgen_ty_30 = 56;
pub const NET_IPV4_ICMP_ECHO_IGNORE_ALL: _bindgen_ty_30 = 57;
pub const NET_IPV4_ICMP_ECHO_IGNORE_BROADCASTS: _bindgen_ty_30 = 58;
pub const NET_IPV4_ICMP_SOURCEQUENCH_RATE: _bindgen_ty_30 = 59;
pub const NET_IPV4_ICMP_DESTUNREACH_RATE: _bindgen_ty_30 = 60;
pub const NET_IPV4_ICMP_TIMEEXCEED_RATE: _bindgen_ty_30 = 61;
pub const NET_IPV4_ICMP_PARAMPROB_RATE: _bindgen_ty_30 = 62;
pub const NET_IPV4_ICMP_ECHOREPLY_RATE: _bindgen_ty_30 = 63;
pub const NET_IPV4_ICMP_IGNORE_BOGUS_ERROR_RESPONSES: _bindgen_ty_30 = 64;
pub const NET_IPV4_IGMP_MAX_MEMBERSHIPS: _bindgen_ty_30 = 65;
pub const NET_TCP_TW_RECYCLE: _bindgen_ty_30 = 66;
pub const NET_IPV4_ALWAYS_DEFRAG: _bindgen_ty_30 = 67;
pub const NET_IPV4_TCP_KEEPALIVE_INTVL: _bindgen_ty_30 = 68;
pub const NET_IPV4_INET_PEER_THRESHOLD: _bindgen_ty_30 = 69;
pub const NET_IPV4_INET_PEER_MINTTL: _bindgen_ty_30 = 70;
pub const NET_IPV4_INET_PEER_MAXTTL: _bindgen_ty_30 = 71;
pub const NET_IPV4_INET_PEER_GC_MINTIME: _bindgen_ty_30 = 72;
pub const NET_IPV4_INET_PEER_GC_MAXTIME: _bindgen_ty_30 = 73;
pub const NET_TCP_ORPHAN_RETRIES: _bindgen_ty_30 = 74;
pub const NET_TCP_ABORT_ON_OVERFLOW: _bindgen_ty_30 = 75;
pub const NET_TCP_SYNACK_RETRIES: _bindgen_ty_30 = 76;
pub const NET_TCP_MAX_ORPHANS: _bindgen_ty_30 = 77;
pub const NET_TCP_MAX_TW_BUCKETS: _bindgen_ty_30 = 78;
pub const NET_TCP_FACK: _bindgen_ty_30 = 79;
pub const NET_TCP_REORDERING: _bindgen_ty_30 = 80;
pub const NET_TCP_ECN: _bindgen_ty_30 = 81;
pub const NET_TCP_DSACK: _bindgen_ty_30 = 82;
pub const NET_TCP_MEM: _bindgen_ty_30 = 83;
pub const NET_TCP_WMEM: _bindgen_ty_30 = 84;
pub const NET_TCP_RMEM: _bindgen_ty_30 = 85;
pub const NET_TCP_APP_WIN: _bindgen_ty_30 = 86;
pub const NET_TCP_ADV_WIN_SCALE: _bindgen_ty_30 = 87;
pub const NET_IPV4_NONLOCAL_BIND: _bindgen_ty_30 = 88;
pub const NET_IPV4_ICMP_RATELIMIT: _bindgen_ty_30 = 89;
pub const NET_IPV4_ICMP_RATEMASK: _bindgen_ty_30 = 90;
pub const NET_TCP_TW_REUSE: _bindgen_ty_30 = 91;
pub const NET_TCP_FRTO: _bindgen_ty_30 = 92;
pub const NET_TCP_LOW_LATENCY: _bindgen_ty_30 = 93;
pub const NET_IPV4_IPFRAG_SECRET_INTERVAL: _bindgen_ty_30 = 94;
pub const NET_IPV4_IGMP_MAX_MSF: _bindgen_ty_30 = 96;
pub const NET_TCP_NO_METRICS_SAVE: _bindgen_ty_30 = 97;
pub const NET_TCP_DEFAULT_WIN_SCALE: _bindgen_ty_30 = 105;
pub const NET_TCP_MODERATE_RCVBUF: _bindgen_ty_30 = 106;
pub const NET_TCP_TSO_WIN_DIVISOR: _bindgen_ty_30 = 107;
pub const NET_TCP_BIC_BETA: _bindgen_ty_30 = 108;
pub const NET_IPV4_ICMP_ERRORS_USE_INBOUND_IFADDR: _bindgen_ty_30 = 109;
pub const NET_TCP_CONG_CONTROL: _bindgen_ty_30 = 110;
pub const NET_TCP_ABC: _bindgen_ty_30 = 111;
pub const NET_IPV4_IPFRAG_MAX_DIST: _bindgen_ty_30 = 112;
pub const NET_TCP_MTU_PROBING: _bindgen_ty_30 = 113;
pub const NET_TCP_BASE_MSS: _bindgen_ty_30 = 114;
pub const NET_IPV4_TCP_WORKAROUND_SIGNED_WINDOWS: _bindgen_ty_30 = 115;
pub const NET_TCP_DMA_COPYBREAK: _bindgen_ty_30 = 116;
pub const NET_TCP_SLOW_START_AFTER_IDLE: _bindgen_ty_30 = 117;
pub const NET_CIPSOV4_CACHE_ENABLE: _bindgen_ty_30 = 118;
pub const NET_CIPSOV4_CACHE_BUCKET_SIZE: _bindgen_ty_30 = 119;
pub const NET_CIPSOV4_RBM_OPTFMT: _bindgen_ty_30 = 120;
pub const NET_CIPSOV4_RBM_STRICTVALID: _bindgen_ty_30 = 121;
pub const NET_TCP_AVAIL_CONG_CONTROL: _bindgen_ty_30 = 122;
pub const NET_TCP_ALLOWED_CONG_CONTROL: _bindgen_ty_30 = 123;
pub const NET_TCP_MAX_SSTHRESH: _bindgen_ty_30 = 124;
pub const NET_TCP_FRTO_RESPONSE: _bindgen_ty_30 = 125;
pub type _bindgen_ty_30 = ffi::c_uint;
pub const NET_IPV4_ROUTE_FLUSH: _bindgen_ty_31 = 1;
pub const NET_IPV4_ROUTE_MIN_DELAY: _bindgen_ty_31 = 2;
pub const NET_IPV4_ROUTE_MAX_DELAY: _bindgen_ty_31 = 3;
pub const NET_IPV4_ROUTE_GC_THRESH: _bindgen_ty_31 = 4;
pub const NET_IPV4_ROUTE_MAX_SIZE: _bindgen_ty_31 = 5;
pub const NET_IPV4_ROUTE_GC_MIN_INTERVAL: _bindgen_ty_31 = 6;
pub const NET_IPV4_ROUTE_GC_TIMEOUT: _bindgen_ty_31 = 7;
pub const NET_IPV4_ROUTE_GC_INTERVAL: _bindgen_ty_31 = 8;
pub const NET_IPV4_ROUTE_REDIRECT_LOAD: _bindgen_ty_31 = 9;
pub const NET_IPV4_ROUTE_REDIRECT_NUMBER: _bindgen_ty_31 = 10;
pub const NET_IPV4_ROUTE_REDIRECT_SILENCE: _bindgen_ty_31 = 11;
pub const NET_IPV4_ROUTE_ERROR_COST: _bindgen_ty_31 = 12;
pub const NET_IPV4_ROUTE_ERROR_BURST: _bindgen_ty_31 = 13;
pub const NET_IPV4_ROUTE_GC_ELASTICITY: _bindgen_ty_31 = 14;
pub const NET_IPV4_ROUTE_MTU_EXPIRES: _bindgen_ty_31 = 15;
pub const NET_IPV4_ROUTE_MIN_PMTU: _bindgen_ty_31 = 16;
pub const NET_IPV4_ROUTE_MIN_ADVMSS: _bindgen_ty_31 = 17;
pub const NET_IPV4_ROUTE_SECRET_INTERVAL: _bindgen_ty_31 = 18;
pub const NET_IPV4_ROUTE_GC_MIN_INTERVAL_MS: _bindgen_ty_31 = 19;
pub type _bindgen_ty_31 = ffi::c_uint;
pub const NET_PROTO_CONF_ALL: _bindgen_ty_32 = -2;
pub const NET_PROTO_CONF_DEFAULT: _bindgen_ty_32 = -3;
pub type _bindgen_ty_32 = ffi::c_int;
pub const NET_IPV4_CONF_FORWARDING: _bindgen_ty_33 = 1;
pub const NET_IPV4_CONF_MC_FORWARDING: _bindgen_ty_33 = 2;
pub const NET_IPV4_CONF_PROXY_ARP: _bindgen_ty_33 = 3;
pub const NET_IPV4_CONF_ACCEPT_REDIRECTS: _bindgen_ty_33 = 4;
pub const NET_IPV4_CONF_SECURE_REDIRECTS: _bindgen_ty_33 = 5;
pub const NET_IPV4_CONF_SEND_REDIRECTS: _bindgen_ty_33 = 6;
pub const NET_IPV4_CONF_SHARED_MEDIA: _bindgen_ty_33 = 7;
pub const NET_IPV4_CONF_RP_FILTER: _bindgen_ty_33 = 8;
pub const NET_IPV4_CONF_ACCEPT_SOURCE_ROUTE: _bindgen_ty_33 = 9;
pub const NET_IPV4_CONF_BOOTP_RELAY: _bindgen_ty_33 = 10;
pub const NET_IPV4_CONF_LOG_MARTIANS: _bindgen_ty_33 = 11;
pub const NET_IPV4_CONF_TAG: _bindgen_ty_33 = 12;
pub const NET_IPV4_CONF_ARPFILTER: _bindgen_ty_33 = 13;
pub const NET_IPV4_CONF_MEDIUM_ID: _bindgen_ty_33 = 14;
pub const NET_IPV4_CONF_NOXFRM: _bindgen_ty_33 = 15;
pub const NET_IPV4_CONF_NOPOLICY: _bindgen_ty_33 = 16;
pub const NET_IPV4_CONF_FORCE_IGMP_VERSION: _bindgen_ty_33 = 17;
pub const NET_IPV4_CONF_ARP_ANNOUNCE: _bindgen_ty_33 = 18;
pub const NET_IPV4_CONF_ARP_IGNORE: _bindgen_ty_33 = 19;
pub const NET_IPV4_CONF_PROMOTE_SECONDARIES: _bindgen_ty_33 = 20;
pub const NET_IPV4_CONF_ARP_ACCEPT: _bindgen_ty_33 = 21;
pub const NET_IPV4_CONF_ARP_NOTIFY: _bindgen_ty_33 = 22;
pub const NET_IPV4_CONF_ARP_EVICT_NOCARRIER: _bindgen_ty_33 = 23;
pub type _bindgen_ty_33 = ffi::c_uint;
pub const NET_IPV4_NF_CONNTRACK_MAX: _bindgen_ty_34 = 1;
pub const NET_IPV4_NF_CONNTRACK_TCP_TIMEOUT_SYN_SENT: _bindgen_ty_34 = 2;
pub const NET_IPV4_NF_CONNTRACK_TCP_TIMEOUT_SYN_RECV: _bindgen_ty_34 = 3;
pub const NET_IPV4_NF_CONNTRACK_TCP_TIMEOUT_ESTABLISHED: _bindgen_ty_34 = 4;
pub const NET_IPV4_NF_CONNTRACK_TCP_TIMEOUT_FIN_WAIT: _bindgen_ty_34 = 5;
pub const NET_IPV4_NF_CONNTRACK_TCP_TIMEOUT_CLOSE_WAIT: _bindgen_ty_34 = 6;
pub const NET_IPV4_NF_CONNTRACK_TCP_TIMEOUT_LAST_ACK: _bindgen_ty_34 = 7;
pub const NET_IPV4_NF_CONNTRACK_TCP_TIMEOUT_TIME_WAIT: _bindgen_ty_34 = 8;
pub const NET_IPV4_NF_CONNTRACK_TCP_TIMEOUT_CLOSE: _bindgen_ty_34 = 9;
pub const NET_IPV4_NF_CONNTRACK_UDP_TIMEOUT: _bindgen_ty_34 = 10;
pub const NET_IPV4_NF_CONNTRACK_UDP_TIMEOUT_STREAM: _bindgen_ty_34 = 11;
pub const NET_IPV4_NF_CONNTRACK_ICMP_TIMEOUT: _bindgen_ty_34 = 12;
pub const NET_IPV4_NF_CONNTRACK_GENERIC_TIMEOUT: _bindgen_ty_34 = 13;
pub const NET_IPV4_NF_CONNTRACK_BUCKETS: _bindgen_ty_34 = 14;
pub const NET_IPV4_NF_CONNTRACK_LOG_INVALID: _bindgen_ty_34 = 15;
pub const NET_IPV4_NF_CONNTRACK_TCP_TIMEOUT_MAX_RETRANS: _bindgen_ty_34 = 16;
pub const NET_IPV4_NF_CONNTRACK_TCP_LOOSE: _bindgen_ty_34 = 17;
pub const NET_IPV4_NF_CONNTRACK_TCP_BE_LIBERAL: _bindgen_ty_34 = 18;
pub const NET_IPV4_NF_CONNTRACK_TCP_MAX_RETRANS: _bindgen_ty_34 = 19;
pub const NET_IPV4_NF_CONNTRACK_SCTP_TIMEOUT_CLOSED: _bindgen_ty_34 = 20;
pub const NET_IPV4_NF_CONNTRACK_SCTP_TIMEOUT_COOKIE_WAIT: _bindgen_ty_34 = 21;
pub const NET_IPV4_NF_CONNTRACK_SCTP_TIMEOUT_COOKIE_ECHOED: _bindgen_ty_34 = 22;
pub const NET_IPV4_NF_CONNTRACK_SCTP_TIMEOUT_ESTABLISHED: _bindgen_ty_34 = 23;
pub const NET_IPV4_NF_CONNTRACK_SCTP_TIMEOUT_SHUTDOWN_SENT: _bindgen_ty_34 = 24;
pub const NET_IPV4_NF_CONNTRACK_SCTP_TIMEOUT_SHUTDOWN_RECD: _bindgen_ty_34 = 25;
pub const NET_IPV4_NF_CONNTRACK_SCTP_TIMEOUT_SHUTDOWN_ACK_SENT: _bindgen_ty_34 = 26;
pub const NET_IPV4_NF_CONNTRACK_COUNT: _bindgen_ty_34 = 27;
pub const NET_IPV4_NF_CONNTRACK_CHECKSUM: _bindgen_ty_34 = 28;
pub type _bindgen_ty_34 = ffi::c_uint;
pub const NET_IPV6_CONF: _bindgen_ty_35 = 16;
pub const NET_IPV6_NEIGH: _bindgen_ty_35 = 17;
pub const NET_IPV6_ROUTE: _bindgen_ty_35 = 18;
pub const NET_IPV6_ICMP: _bindgen_ty_35 = 19;
pub const NET_IPV6_BINDV6ONLY: _bindgen_ty_35 = 20;
pub const NET_IPV6_IP6FRAG_HIGH_THRESH: _bindgen_ty_35 = 21;
pub const NET_IPV6_IP6FRAG_LOW_THRESH: _bindgen_ty_35 = 22;
pub const NET_IPV6_IP6FRAG_TIME: _bindgen_ty_35 = 23;
pub const NET_IPV6_IP6FRAG_SECRET_INTERVAL: _bindgen_ty_35 = 24;
pub const NET_IPV6_MLD_MAX_MSF: _bindgen_ty_35 = 25;
pub type _bindgen_ty_35 = ffi::c_uint;
pub const NET_IPV6_ROUTE_FLUSH: _bindgen_ty_36 = 1;
pub const NET_IPV6_ROUTE_GC_THRESH: _bindgen_ty_36 = 2;
pub const NET_IPV6_ROUTE_MAX_SIZE: _bindgen_ty_36 = 3;
pub const NET_IPV6_ROUTE_GC_MIN_INTERVAL: _bindgen_ty_36 = 4;
pub const NET_IPV6_ROUTE_GC_TIMEOUT: _bindgen_ty_36 = 5;
pub const NET_IPV6_ROUTE_GC_INTERVAL: _bindgen_ty_36 = 6;
pub const NET_IPV6_ROUTE_GC_ELASTICITY: _bindgen_ty_36 = 7;
pub const NET_IPV6_ROUTE_MTU_EXPIRES: _bindgen_ty_36 = 8;
pub const NET_IPV6_ROUTE_MIN_ADVMSS: _bindgen_ty_36 = 9;
pub const NET_IPV6_ROUTE_GC_MIN_INTERVAL_MS: _bindgen_ty_36 = 10;
pub type _bindgen_ty_36 = ffi::c_uint;
pub const NET_IPV6_FORWARDING: _bindgen_ty_37 = 1;
pub const NET_IPV6_HOP_LIMIT: _bindgen_ty_37 = 2;
pub const NET_IPV6_MTU: _bindgen_ty_37 = 3;
pub const NET_IPV6_ACCEPT_RA: _bindgen_ty_37 = 4;
pub const NET_IPV6_ACCEPT_REDIRECTS: _bindgen_ty_37 = 5;
pub const NET_IPV6_AUTOCONF: _bindgen_ty_37 = 6;
pub const NET_IPV6_DAD_TRANSMITS: _bindgen_ty_37 = 7;
pub const NET_IPV6_RTR_SOLICITS: _bindgen_ty_37 = 8;
pub const NET_IPV6_RTR_SOLICIT_INTERVAL: _bindgen_ty_37 = 9;
pub const NET_IPV6_RTR_SOLICIT_DELAY: _bindgen_ty_37 = 10;
pub const NET_IPV6_USE_TEMPADDR: _bindgen_ty_37 = 11;
pub const NET_IPV6_TEMP_VALID_LFT: _bindgen_ty_37 = 12;
pub const NET_IPV6_TEMP_PREFERED_LFT: _bindgen_ty_37 = 13;
pub const NET_IPV6_REGEN_MAX_RETRY: _bindgen_ty_37 = 14;
pub const NET_IPV6_MAX_DESYNC_FACTOR: _bindgen_ty_37 = 15;
pub const NET_IPV6_MAX_ADDRESSES: _bindgen_ty_37 = 16;
pub const NET_IPV6_FORCE_MLD_VERSION: _bindgen_ty_37 = 17;
pub const NET_IPV6_ACCEPT_RA_DEFRTR: _bindgen_ty_37 = 18;
pub const NET_IPV6_ACCEPT_RA_PINFO: _bindgen_ty_37 = 19;
pub const NET_IPV6_ACCEPT_RA_RTR_PREF: _bindgen_ty_37 = 20;
pub const NET_IPV6_RTR_PROBE_INTERVAL: _bindgen_ty_37 = 21;
pub const NET_IPV6_ACCEPT_RA_RT_INFO_MAX_PLEN: _bindgen_ty_37 = 22;
pub const NET_IPV6_PROXY_NDP: _bindgen_ty_37 = 23;
pub const NET_IPV6_ACCEPT_SOURCE_ROUTE: _bindgen_ty_37 = 25;
pub const NET_IPV6_ACCEPT_RA_FROM_LOCAL: _bindgen_ty_37 = 26;
pub const NET_IPV6_ACCEPT_RA_RT_INFO_MIN_PLEN: _bindgen_ty_37 = 27;
pub const NET_IPV6_RA_DEFRTR_METRIC: _bindgen_ty_37 = 28;
pub const __NET_IPV6_MAX: _bindgen_ty_37 = 29;
pub type _bindgen_ty_37 = ffi::c_uint;
pub const NET_IPV6_ICMP_RATELIMIT: _bindgen_ty_38 = 1;
pub const NET_IPV6_ICMP_ECHO_IGNORE_ALL: _bindgen_ty_38 = 2;
pub type _bindgen_ty_38 = ffi::c_uint;
pub const NET_NEIGH_MCAST_SOLICIT: _bindgen_ty_39 = 1;
pub const NET_NEIGH_UCAST_SOLICIT: _bindgen_ty_39 = 2;
pub const NET_NEIGH_APP_SOLICIT: _bindgen_ty_39 = 3;
pub const NET_NEIGH_RETRANS_TIME: _bindgen_ty_39 = 4;
pub const NET_NEIGH_REACHABLE_TIME: _bindgen_ty_39 = 5;
pub const NET_NEIGH_DELAY_PROBE_TIME: _bindgen_ty_39 = 6;
pub const NET_NEIGH_GC_STALE_TIME: _bindgen_ty_39 = 7;
pub const NET_NEIGH_UNRES_QLEN: _bindgen_ty_39 = 8;
pub const NET_NEIGH_PROXY_QLEN: _bindgen_ty_39 = 9;
pub const NET_NEIGH_ANYCAST_DELAY: _bindgen_ty_39 = 10;
pub const NET_NEIGH_PROXY_DELAY: _bindgen_ty_39 = 11;
pub const NET_NEIGH_LOCKTIME: _bindgen_ty_39 = 12;
pub const NET_NEIGH_GC_INTERVAL: _bindgen_ty_39 = 13;
pub const NET_NEIGH_GC_THRESH1: _bindgen_ty_39 = 14;
pub const NET_NEIGH_GC_THRESH2: _bindgen_ty_39 = 15;
pub const NET_NEIGH_GC_THRESH3: _bindgen_ty_39 = 16;
pub const NET_NEIGH_RETRANS_TIME_MS: _bindgen_ty_39 = 17;
pub const NET_NEIGH_REACHABLE_TIME_MS: _bindgen_ty_39 = 18;
pub const NET_NEIGH_INTERVAL_PROBE_TIME_MS: _bindgen_ty_39 = 19;
pub type _bindgen_ty_39 = ffi::c_uint;
pub const NET_DCCP_DEFAULT: _bindgen_ty_40 = 1;
pub type _bindgen_ty_40 = ffi::c_uint;
pub const NET_IPX_PPROP_BROADCASTING: _bindgen_ty_41 = 1;
pub const NET_IPX_FORWARDING: _bindgen_ty_41 = 2;
pub type _bindgen_ty_41 = ffi::c_uint;
pub const NET_LLC2: _bindgen_ty_42 = 1;
pub const NET_LLC_STATION: _bindgen_ty_42 = 2;
pub type _bindgen_ty_42 = ffi::c_uint;
pub const NET_LLC2_TIMEOUT: _bindgen_ty_43 = 1;
pub type _bindgen_ty_43 = ffi::c_uint;
pub const NET_LLC_STATION_ACK_TIMEOUT: _bindgen_ty_44 = 1;
pub type _bindgen_ty_44 = ffi::c_uint;
pub const NET_LLC2_ACK_TIMEOUT: _bindgen_ty_45 = 1;
pub const NET_LLC2_P_TIMEOUT: _bindgen_ty_45 = 2;
pub const NET_LLC2_REJ_TIMEOUT: _bindgen_ty_45 = 3;
pub const NET_LLC2_BUSY_TIMEOUT: _bindgen_ty_45 = 4;
pub type _bindgen_ty_45 = ffi::c_uint;
pub const NET_ATALK_AARP_EXPIRY_TIME: _bindgen_ty_46 = 1;
pub const NET_ATALK_AARP_TICK_TIME: _bindgen_ty_46 = 2;
pub const NET_ATALK_AARP_RETRANSMIT_LIMIT: _bindgen_ty_46 = 3;
pub const NET_ATALK_AARP_RESOLVE_TIME: _bindgen_ty_46 = 4;
pub type _bindgen_ty_46 = ffi::c_uint;
pub const NET_NETROM_DEFAULT_PATH_QUALITY: _bindgen_ty_47 = 1;
pub const NET_NETROM_OBSOLESCENCE_COUNT_INITIALISER: _bindgen_ty_47 = 2;
pub const NET_NETROM_NETWORK_TTL_INITIALISER: _bindgen_ty_47 = 3;
pub const NET_NETROM_TRANSPORT_TIMEOUT: _bindgen_ty_47 = 4;
pub const NET_NETROM_TRANSPORT_MAXIMUM_TRIES: _bindgen_ty_47 = 5;
pub const NET_NETROM_TRANSPORT_ACKNOWLEDGE_DELAY: _bindgen_ty_47 = 6;
pub const NET_NETROM_TRANSPORT_BUSY_DELAY: _bindgen_ty_47 = 7;
pub const NET_NETROM_TRANSPORT_REQUESTED_WINDOW_SIZE: _bindgen_ty_47 = 8;
pub const NET_NETROM_TRANSPORT_NO_ACTIVITY_TIMEOUT: _bindgen_ty_47 = 9;
pub const NET_NETROM_ROUTING_CONTROL: _bindgen_ty_47 = 10;
pub const NET_NETROM_LINK_FAILS_COUNT: _bindgen_ty_47 = 11;
pub const NET_NETROM_RESET: _bindgen_ty_47 = 12;
pub type _bindgen_ty_47 = ffi::c_uint;
pub const NET_AX25_IP_DEFAULT_MODE: _bindgen_ty_48 = 1;
pub const NET_AX25_DEFAULT_MODE: _bindgen_ty_48 = 2;
pub const NET_AX25_BACKOFF_TYPE: _bindgen_ty_48 = 3;
pub const NET_AX25_CONNECT_MODE: _bindgen_ty_48 = 4;
pub const NET_AX25_STANDARD_WINDOW: _bindgen_ty_48 = 5;
pub const NET_AX25_EXTENDED_WINDOW: _bindgen_ty_48 = 6;
pub const NET_AX25_T1_TIMEOUT: _bindgen_ty_48 = 7;
pub const NET_AX25_T2_TIMEOUT: _bindgen_ty_48 = 8;
pub const NET_AX25_T3_TIMEOUT: _bindgen_ty_48 = 9;
pub const NET_AX25_IDLE_TIMEOUT: _bindgen_ty_48 = 10;
pub const NET_AX25_N2: _bindgen_ty_48 = 11;
pub const NET_AX25_PACLEN: _bindgen_ty_48 = 12;
pub const NET_AX25_PROTOCOL: _bindgen_ty_48 = 13;
pub const NET_AX25_DAMA_SLAVE_TIMEOUT: _bindgen_ty_48 = 14;
pub type _bindgen_ty_48 = ffi::c_uint;
pub const NET_ROSE_RESTART_REQUEST_TIMEOUT: _bindgen_ty_49 = 1;
pub const NET_ROSE_CALL_REQUEST_TIMEOUT: _bindgen_ty_49 = 2;
pub const NET_ROSE_RESET_REQUEST_TIMEOUT: _bindgen_ty_49 = 3;
pub const NET_ROSE_CLEAR_REQUEST_TIMEOUT: _bindgen_ty_49 = 4;
pub const NET_ROSE_ACK_HOLD_BACK_TIMEOUT: _bindgen_ty_49 = 5;
pub const NET_ROSE_ROUTING_CONTROL: _bindgen_ty_49 = 6;
pub const NET_ROSE_LINK_FAIL_TIMEOUT: _bindgen_ty_49 = 7;
pub const NET_ROSE_MAX_VCS: _bindgen_ty_49 = 8;
pub const NET_ROSE_WINDOW_SIZE: _bindgen_ty_49 = 9;
pub const NET_ROSE_NO_ACTIVITY_TIMEOUT: _bindgen_ty_49 = 10;
pub type _bindgen_ty_49 = ffi::c_uint;
pub const NET_X25_RESTART_REQUEST_TIMEOUT: _bindgen_ty_50 = 1;
pub const NET_X25_CALL_REQUEST_TIMEOUT: _bindgen_ty_50 = 2;
pub const NET_X25_RESET_REQUEST_TIMEOUT: _bindgen_ty_50 = 3;
pub const NET_X25_CLEAR_REQUEST_TIMEOUT: _bindgen_ty_50 = 4;
pub const NET_X25_ACK_HOLD_BACK_TIMEOUT: _bindgen_ty_50 = 5;
pub const NET_X25_FORWARD: _bindgen_ty_50 = 6;
pub type _bindgen_ty_50 = ffi::c_uint;
pub const NET_TR_RIF_TIMEOUT: _bindgen_ty_51 = 1;
pub type _bindgen_ty_51 = ffi::c_uint;
pub const NET_DECNET_NODE_TYPE: _bindgen_ty_52 = 1;
pub const NET_DECNET_NODE_ADDRESS: _bindgen_ty_52 = 2;
pub const NET_DECNET_NODE_NAME: _bindgen_ty_52 = 3;
pub const NET_DECNET_DEFAULT_DEVICE: _bindgen_ty_52 = 4;
pub const NET_DECNET_TIME_WAIT: _bindgen_ty_52 = 5;
pub const NET_DECNET_DN_COUNT: _bindgen_ty_52 = 6;
pub const NET_DECNET_DI_COUNT: _bindgen_ty_52 = 7;
pub const NET_DECNET_DR_COUNT: _bindgen_ty_52 = 8;
pub const NET_DECNET_DST_GC_INTERVAL: _bindgen_ty_52 = 9;
pub const NET_DECNET_CONF: _bindgen_ty_52 = 10;
pub const NET_DECNET_NO_FC_MAX_CWND: _bindgen_ty_52 = 11;
pub const NET_DECNET_MEM: _bindgen_ty_52 = 12;
pub const NET_DECNET_RMEM: _bindgen_ty_52 = 13;
pub const NET_DECNET_WMEM: _bindgen_ty_52 = 14;
pub const NET_DECNET_DEBUG_LEVEL: _bindgen_ty_52 = 255;
pub type _bindgen_ty_52 = ffi::c_uint;
pub const NET_DECNET_CONF_LOOPBACK: _bindgen_ty_53 = -2;
pub const NET_DECNET_CONF_DDCMP: _bindgen_ty_53 = -3;
pub const NET_DECNET_CONF_PPP: _bindgen_ty_53 = -4;
pub const NET_DECNET_CONF_X25: _bindgen_ty_53 = -5;
pub const NET_DECNET_CONF_GRE: _bindgen_ty_53 = -6;
pub const NET_DECNET_CONF_ETHER: _bindgen_ty_53 = -7;
pub type _bindgen_ty_53 = ffi::c_int;
pub const NET_DECNET_CONF_DEV_PRIORITY: _bindgen_ty_54 = 1;
pub const NET_DECNET_CONF_DEV_T1: _bindgen_ty_54 = 2;
pub const NET_DECNET_CONF_DEV_T2: _bindgen_ty_54 = 3;
pub const NET_DECNET_CONF_DEV_T3: _bindgen_ty_54 = 4;
pub const NET_DECNET_CONF_DEV_FORWARDING: _bindgen_ty_54 = 5;
pub const NET_DECNET_CONF_DEV_BLKSIZE: _bindgen_ty_54 = 6;
pub const NET_DECNET_CONF_DEV_STATE: _bindgen_ty_54 = 7;
pub type _bindgen_ty_54 = ffi::c_uint;
pub const NET_SCTP_RTO_INITIAL: _bindgen_ty_55 = 1;
pub const NET_SCTP_RTO_MIN: _bindgen_ty_55 = 2;
pub const NET_SCTP_RTO_MAX: _bindgen_ty_55 = 3;
pub const NET_SCTP_RTO_ALPHA: _bindgen_ty_55 = 4;
pub const NET_SCTP_RTO_BETA: _bindgen_ty_55 = 5;
pub const NET_SCTP_VALID_COOKIE_LIFE: _bindgen_ty_55 = 6;
pub const NET_SCTP_ASSOCIATION_MAX_RETRANS: _bindgen_ty_55 = 7;
pub const NET_SCTP_PATH_MAX_RETRANS: _bindgen_ty_55 = 8;
pub const NET_SCTP_MAX_INIT_RETRANSMITS: _bindgen_ty_55 = 9;
pub const NET_SCTP_HB_INTERVAL: _bindgen_ty_55 = 10;
pub const NET_SCTP_PRESERVE_ENABLE: _bindgen_ty_55 = 11;
pub const NET_SCTP_MAX_BURST: _bindgen_ty_55 = 12;
pub const NET_SCTP_ADDIP_ENABLE: _bindgen_ty_55 = 13;
pub const NET_SCTP_PRSCTP_ENABLE: _bindgen_ty_55 = 14;
pub const NET_SCTP_SNDBUF_POLICY: _bindgen_ty_55 = 15;
pub const NET_SCTP_SACK_TIMEOUT: _bindgen_ty_55 = 16;
pub const NET_SCTP_RCVBUF_POLICY: _bindgen_ty_55 = 17;
pub type _bindgen_ty_55 = ffi::c_uint;
pub const NET_BRIDGE_NF_CALL_ARPTABLES: _bindgen_ty_56 = 1;
pub const NET_BRIDGE_NF_CALL_IPTABLES: _bindgen_ty_56 = 2;
pub const NET_BRIDGE_NF_CALL_IP6TABLES: _bindgen_ty_56 = 3;
pub const NET_BRIDGE_NF_FILTER_VLAN_TAGGED: _bindgen_ty_56 = 4;
pub const NET_BRIDGE_NF_FILTER_PPPOE_TAGGED: _bindgen_ty_56 = 5;
pub type _bindgen_ty_56 = ffi::c_uint;
pub const FS_NRINODE: _bindgen_ty_57 = 1;
pub const FS_STATINODE: _bindgen_ty_57 = 2;
pub const FS_MAXINODE: _bindgen_ty_57 = 3;
pub const FS_NRDQUOT: _bindgen_ty_57 = 4;
pub const FS_MAXDQUOT: _bindgen_ty_57 = 5;
pub const FS_NRFILE: _bindgen_ty_57 = 6;
pub const FS_MAXFILE: _bindgen_ty_57 = 7;
pub const FS_DENTRY: _bindgen_ty_57 = 8;
pub const FS_NRSUPER: _bindgen_ty_57 = 9;
pub const FS_MAXSUPER: _bindgen_ty_57 = 10;
pub const FS_OVERFLOWUID: _bindgen_ty_57 = 11;
pub const FS_OVERFLOWGID: _bindgen_ty_57 = 12;
pub const FS_LEASES: _bindgen_ty_57 = 13;
pub const FS_DIR_NOTIFY: _bindgen_ty_57 = 14;
pub const FS_LEASE_TIME: _bindgen_ty_57 = 15;
pub const FS_DQSTATS: _bindgen_ty_57 = 16;
pub const FS_XFS: _bindgen_ty_57 = 17;
pub const FS_AIO_NR: _bindgen_ty_57 = 18;
pub const FS_AIO_MAX_NR: _bindgen_ty_57 = 19;
pub const FS_INOTIFY: _bindgen_ty_57 = 20;
pub const FS_OCFS2: _bindgen_ty_57 = 988;
pub type _bindgen_ty_57 = ffi::c_uint;
pub const FS_DQ_LOOKUPS: _bindgen_ty_58 = 1;
pub const FS_DQ_DROPS: _bindgen_ty_58 = 2;
pub const FS_DQ_READS: _bindgen_ty_58 = 3;
pub const FS_DQ_WRITES: _bindgen_ty_58 = 4;
pub const FS_DQ_CACHE_HITS: _bindgen_ty_58 = 5;
pub const FS_DQ_ALLOCATED: _bindgen_ty_58 = 6;
pub const FS_DQ_FREE: _bindgen_ty_58 = 7;
pub const FS_DQ_SYNCS: _bindgen_ty_58 = 8;
pub const FS_DQ_WARNINGS: _bindgen_ty_58 = 9;
pub type _bindgen_ty_58 = ffi::c_uint;
pub const DEV_CDROM: _bindgen_ty_59 = 1;
pub const DEV_HWMON: _bindgen_ty_59 = 2;
pub const DEV_PARPORT: _bindgen_ty_59 = 3;
pub const DEV_RAID: _bindgen_ty_59 = 4;
pub const DEV_MAC_HID: _bindgen_ty_59 = 5;
pub const DEV_SCSI: _bindgen_ty_59 = 6;
pub const DEV_IPMI: _bindgen_ty_59 = 7;
pub type _bindgen_ty_59 = ffi::c_uint;
pub const DEV_CDROM_INFO: _bindgen_ty_60 = 1;
pub const DEV_CDROM_AUTOCLOSE: _bindgen_ty_60 = 2;
pub const DEV_CDROM_AUTOEJECT: _bindgen_ty_60 = 3;
pub const DEV_CDROM_DEBUG: _bindgen_ty_60 = 4;
pub const DEV_CDROM_LOCK: _bindgen_ty_60 = 5;
pub const DEV_CDROM_CHECK_MEDIA: _bindgen_ty_60 = 6;
pub type _bindgen_ty_60 = ffi::c_uint;
pub const DEV_PARPORT_DEFAULT: _bindgen_ty_61 = -3;
pub type _bindgen_ty_61 = ffi::c_int;
pub const DEV_RAID_SPEED_LIMIT_MIN: _bindgen_ty_62 = 1;
pub const DEV_RAID_SPEED_LIMIT_MAX: _bindgen_ty_62 = 2;
pub type _bindgen_ty_62 = ffi::c_uint;
pub const DEV_PARPORT_DEFAULT_TIMESLICE: _bindgen_ty_63 = 1;
pub const DEV_PARPORT_DEFAULT_SPINTIME: _bindgen_ty_63 = 2;
pub type _bindgen_ty_63 = ffi::c_uint;
pub const DEV_PARPORT_SPINTIME: _bindgen_ty_64 = 1;
pub const DEV_PARPORT_BASE_ADDR: _bindgen_ty_64 = 2;
pub const DEV_PARPORT_IRQ: _bindgen_ty_64 = 3;
pub const DEV_PARPORT_DMA: _bindgen_ty_64 = 4;
pub const DEV_PARPORT_MODES: _bindgen_ty_64 = 5;
pub const DEV_PARPORT_DEVICES: _bindgen_ty_64 = 6;
pub const DEV_PARPORT_AUTOPROBE: _bindgen_ty_64 = 16;
pub type _bindgen_ty_64 = ffi::c_uint;
pub const DEV_PARPORT_DEVICES_ACTIVE: _bindgen_ty_65 = -3;
pub type _bindgen_ty_65 = ffi::c_int;
pub const DEV_PARPORT_DEVICE_TIMESLICE: _bindgen_ty_66 = 1;
pub type _bindgen_ty_66 = ffi::c_uint;
pub const DEV_MAC_HID_KEYBOARD_SENDS_LINUX_KEYCODES: _bindgen_ty_67 = 1;
pub const DEV_MAC_HID_KEYBOARD_LOCK_KEYCODES: _bindgen_ty_67 = 2;
pub const DEV_MAC_HID_MOUSE_BUTTON_EMULATION: _bindgen_ty_67 = 3;
pub const DEV_MAC_HID_MOUSE_BUTTON2_KEYCODE: _bindgen_ty_67 = 4;
pub const DEV_MAC_HID_MOUSE_BUTTON3_KEYCODE: _bindgen_ty_67 = 5;
pub const DEV_MAC_HID_ADB_MOUSE_SENDS_KEYCODES: _bindgen_ty_67 = 6;
pub type _bindgen_ty_67 = ffi::c_uint;
pub const DEV_SCSI_LOGGING_LEVEL: _bindgen_ty_68 = 1;
pub type _bindgen_ty_68 = ffi::c_uint;
pub const DEV_IPMI_POWEROFF_POWERCYCLE: _bindgen_ty_69 = 1;
pub type _bindgen_ty_69 = ffi::c_uint;
pub const ABI_DEFHANDLER_COFF: _bindgen_ty_70 = 1;
pub const ABI_DEFHANDLER_ELF: _bindgen_ty_70 = 2;
pub const ABI_DEFHANDLER_LCALL7: _bindgen_ty_70 = 3;
pub const ABI_DEFHANDLER_LIBCSO: _bindgen_ty_70 = 4;
pub const ABI_TRACE: _bindgen_ty_70 = 5;
pub const ABI_FAKE_UTSNAME: _bindgen_ty_70 = 6;
pub type _bindgen_ty_70 = ffi::c_uint;
extern "C" {
    pub static sysctl_vals: [ffi::c_int; 0usize];
}
extern "C" {
    pub static sysctl_long_vals: [ffi::c_ulong; 0usize];
}
pub type proc_handler = ::core::option::Option<
    unsafe extern "C" fn(
        ctl: *const ctl_table,
        write: ffi::c_int,
        buffer: *mut ffi::c_void,
        lenp: *mut usize,
        ppos: *mut loff_t,
    ) -> ffi::c_int,
>;
extern "C" {
    pub fn proc_dostring(
        arg1: *const ctl_table,
        arg2: ffi::c_int,
        arg3: *mut ffi::c_void,
        arg4: *mut usize,
        arg5: *mut loff_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn proc_dobool(
        table: *const ctl_table,
        write: ffi::c_int,
        buffer: *mut ffi::c_void,
        lenp: *mut usize,
        ppos: *mut loff_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn proc_dointvec(
        arg1: *const ctl_table,
        arg2: ffi::c_int,
        arg3: *mut ffi::c_void,
        arg4: *mut usize,
        arg5: *mut loff_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn proc_douintvec(
        arg1: *const ctl_table,
        arg2: ffi::c_int,
        arg3: *mut ffi::c_void,
        arg4: *mut usize,
        arg5: *mut loff_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn proc_dointvec_minmax(
        arg1: *const ctl_table,
        arg2: ffi::c_int,
        arg3: *mut ffi::c_void,
        arg4: *mut usize,
        arg5: *mut loff_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn proc_douintvec_minmax(
        table: *const ctl_table,
        write: ffi::c_int,
        buffer: *mut ffi::c_void,
        lenp: *mut usize,
        ppos: *mut loff_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn proc_dou8vec_minmax(
        table: *const ctl_table,
        write: ffi::c_int,
        buffer: *mut ffi::c_void,
        lenp: *mut usize,
        ppos: *mut loff_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn proc_dointvec_jiffies(
        arg1: *const ctl_table,
        arg2: ffi::c_int,
        arg3: *mut ffi::c_void,
        arg4: *mut usize,
        arg5: *mut loff_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn proc_dointvec_ms_jiffies_minmax(
        table: *const ctl_table,
        write: ffi::c_int,
        buffer: *mut ffi::c_void,
        lenp: *mut usize,
        ppos: *mut loff_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn proc_dointvec_userhz_jiffies(
        arg1: *const ctl_table,
        arg2: ffi::c_int,
        arg3: *mut ffi::c_void,
        arg4: *mut usize,
        arg5: *mut loff_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn proc_dointvec_ms_jiffies(
        arg1: *const ctl_table,
        arg2: ffi::c_int,
        arg3: *mut ffi::c_void,
        arg4: *mut usize,
        arg5: *mut loff_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn proc_doulongvec_minmax(
        arg1: *const ctl_table,
        arg2: ffi::c_int,
        arg3: *mut ffi::c_void,
        arg4: *mut usize,
        arg5: *mut loff_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn proc_doulongvec_ms_jiffies_minmax(
        table: *const ctl_table,
        arg1: ffi::c_int,
        arg2: *mut ffi::c_void,
        arg3: *mut usize,
        arg4: *mut loff_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn proc_do_large_bitmap(
        arg1: *const ctl_table,
        arg2: ffi::c_int,
        arg3: *mut ffi::c_void,
        arg4: *mut usize,
        arg5: *mut loff_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn proc_do_static_key(
        table: *const ctl_table,
        write: ffi::c_int,
        buffer: *mut ffi::c_void,
        lenp: *mut usize,
        ppos: *mut loff_t,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ctl_table_poll {
    pub event: atomic_t,
    pub wait: wait_queue_head_t,
}
impl Default for ctl_table_poll {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ctl_table {
    pub procname: *const ffi::c_char,
    pub data: *mut ffi::c_void,
    pub maxlen: ffi::c_int,
    pub mode: umode_t,
    pub proc_handler: proc_handler,
    pub poll: *mut ctl_table_poll,
    pub extra1: *mut ffi::c_void,
    pub extra2: *mut ffi::c_void,
}
impl Default for ctl_table {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ctl_node {
    pub node: rb_node,
    pub header: *mut ctl_table_header,
}
impl Default for ctl_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ctl_table_header {
    pub __bindgen_anon_1: ctl_table_header__bindgen_ty_1,
    pub unregistering: *mut completion,
    pub ctl_table_arg: *const ctl_table,
    pub root: *mut ctl_table_root,
    pub set: *mut ctl_table_set,
    pub parent: *mut ctl_dir,
    pub node: *mut ctl_node,
    pub inodes: hlist_head,
    pub type_: ctl_table_header__bindgen_ty_2,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union ctl_table_header__bindgen_ty_1 {
    pub __bindgen_anon_1: ctl_table_header__bindgen_ty_1__bindgen_ty_1,
    pub rcu: callback_head,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ctl_table_header__bindgen_ty_1__bindgen_ty_1 {
    pub ctl_table: *const ctl_table,
    pub ctl_table_size: ffi::c_int,
    pub used: ffi::c_int,
    pub count: ffi::c_int,
    pub nreg: ffi::c_int,
}
impl Default for ctl_table_header__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for ctl_table_header__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const ctl_table_header_SYSCTL_TABLE_TYPE_DEFAULT: ctl_table_header__bindgen_ty_2 = 0;
pub const ctl_table_header_SYSCTL_TABLE_TYPE_PERMANENTLY_EMPTY: ctl_table_header__bindgen_ty_2 = 1;
pub type ctl_table_header__bindgen_ty_2 = ffi::c_uint;
impl Default for ctl_table_header {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ctl_dir {
    pub header: ctl_table_header,
    pub root: rb_root,
}
impl Default for ctl_dir {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ctl_table_set {
    pub is_seen:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut ctl_table_set) -> ffi::c_int>,
    pub dir: ctl_dir,
}
impl Default for ctl_table_set {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ctl_table_root {
    pub default_set: ctl_table_set,
    pub lookup: ::core::option::Option<
        unsafe extern "C" fn(root: *mut ctl_table_root) -> *mut ctl_table_set,
    >,
    pub set_ownership: ::core::option::Option<
        unsafe extern "C" fn(head: *mut ctl_table_header, uid: *mut kuid_t, gid: *mut kgid_t),
    >,
    pub permissions: ::core::option::Option<
        unsafe extern "C" fn(head: *mut ctl_table_header, table: *const ctl_table) -> ffi::c_int,
    >,
}
impl Default for ctl_table_root {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn proc_sys_poll_notify(poll: *mut ctl_table_poll);
}
extern "C" {
    pub fn setup_sysctl_set(
        p: *mut ctl_table_set,
        root: *mut ctl_table_root,
        is_seen: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut ctl_table_set) -> ffi::c_int,
        >,
    );
}
extern "C" {
    pub fn retire_sysctl_set(set: *mut ctl_table_set);
}
extern "C" {
    pub fn __register_sysctl_table(
        set: *mut ctl_table_set,
        path: *const ffi::c_char,
        table: *const ctl_table,
        table_size: usize,
    ) -> *mut ctl_table_header;
}
extern "C" {
    pub fn register_sysctl_sz(
        path: *const ffi::c_char,
        table: *const ctl_table,
        table_size: usize,
    ) -> *mut ctl_table_header;
}
extern "C" {
    pub fn unregister_sysctl_table(table: *mut ctl_table_header);
}
extern "C" {
    pub fn sysctl_init_bases() -> ffi::c_int;
}
extern "C" {
    pub fn __register_sysctl_init(
        path: *const ffi::c_char,
        table: *const ctl_table,
        table_name: *const ffi::c_char,
        table_size: usize,
    );
}
extern "C" {
    pub fn register_sysctl_mount_point(path: *const ffi::c_char) -> *mut ctl_table_header;
}
extern "C" {
    pub fn do_sysctl_args();
}
extern "C" {
    pub fn sysctl_is_alias(param: *mut ffi::c_char) -> bool_;
}
extern "C" {
    pub fn do_proc_douintvec(
        table: *const ctl_table,
        write: ffi::c_int,
        buffer: *mut ffi::c_void,
        lenp: *mut usize,
        ppos: *mut loff_t,
        conv: ::core::option::Option<
            unsafe extern "C" fn(
                lvalp: *mut ffi::c_ulong,
                valp: *mut ffi::c_uint,
                write: ffi::c_int,
                data: *mut ffi::c_void,
            ) -> ffi::c_int,
        >,
        data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub static mut pwrsw_enabled: ffi::c_int;
}
extern "C" {
    pub static mut unaligned_enabled: ffi::c_int;
}
extern "C" {
    pub static mut unaligned_dump_stack: ffi::c_int;
}
extern "C" {
    pub static mut no_unaligned_warning: ffi::c_int;
}
extern "C" {
    pub fn sysctl_max_threads(
        table: *const ctl_table,
        write: ffi::c_int,
        buffer: *mut ffi::c_void,
        lenp: *mut usize,
        ppos: *mut loff_t,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct subprocess_info {
    pub work: work_struct,
    pub complete: *mut completion,
    pub path: *const ffi::c_char,
    pub argv: *mut *mut ffi::c_char,
    pub envp: *mut *mut ffi::c_char,
    pub wait: ffi::c_int,
    pub retval: ffi::c_int,
    pub init: ::core::option::Option<
        unsafe extern "C" fn(info: *mut subprocess_info, new: *mut cred) -> ffi::c_int,
    >,
    pub cleanup: ::core::option::Option<unsafe extern "C" fn(info: *mut subprocess_info)>,
    pub data: *mut ffi::c_void,
}
impl Default for subprocess_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn call_usermodehelper(
        path: *const ffi::c_char,
        argv: *mut *mut ffi::c_char,
        envp: *mut *mut ffi::c_char,
        wait: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn call_usermodehelper_setup(
        path: *const ffi::c_char,
        argv: *mut *mut ffi::c_char,
        envp: *mut *mut ffi::c_char,
        gfp_mask: gfp_t,
        init: ::core::option::Option<
            unsafe extern "C" fn(info: *mut subprocess_info, new: *mut cred) -> ffi::c_int,
        >,
        cleanup: ::core::option::Option<unsafe extern "C" fn(arg1: *mut subprocess_info)>,
        data: *mut ffi::c_void,
    ) -> *mut subprocess_info;
}
extern "C" {
    pub fn call_usermodehelper_exec(info: *mut subprocess_info, wait: ffi::c_int) -> ffi::c_int;
}
pub const umh_disable_depth_UMH_ENABLED: umh_disable_depth = 0;
pub const umh_disable_depth_UMH_FREEZING: umh_disable_depth = 1;
pub const umh_disable_depth_UMH_DISABLED: umh_disable_depth = 2;
pub type umh_disable_depth = ffi::c_uint;
extern "C" {
    pub fn __usermodehelper_disable(depth: umh_disable_depth) -> ffi::c_int;
}
extern "C" {
    pub fn __usermodehelper_set_disable_depth(depth: umh_disable_depth);
}
extern "C" {
    pub fn usermodehelper_read_trylock() -> ffi::c_int;
}
extern "C" {
    pub fn usermodehelper_read_lock_wait(timeout: ffi::c_long) -> ffi::c_long;
}
extern "C" {
    pub fn usermodehelper_read_unlock();
}
extern "C" {
    pub static mut modprobe_path: [ffi::c_char; 0usize];
}
extern "C" {
    pub fn __request_module(wait: bool_, name: *const ffi::c_char, ...) -> ffi::c_int;
}
pub type Elf32_Addr = __u32;
pub type Elf32_Half = __u16;
pub type Elf32_Off = __u32;
pub type Elf32_Sword = __s32;
pub type Elf32_Word = __u32;
pub type Elf32_Versym = __u16;
pub type Elf64_Addr = __u64;
pub type Elf64_Half = __u16;
pub type Elf64_SHalf = __s16;
pub type Elf64_Off = __u64;
pub type Elf64_Sword = __s32;
pub type Elf64_Word = __u32;
pub type Elf64_Xword = __u64;
pub type Elf64_Sxword = __s64;
pub type Elf64_Versym = __u16;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct Elf32_Dyn {
    pub d_tag: Elf32_Sword,
    pub d_un: Elf32_Dyn__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union Elf32_Dyn__bindgen_ty_1 {
    pub d_val: Elf32_Sword,
    pub d_ptr: Elf32_Addr,
}
impl Default for Elf32_Dyn__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for Elf32_Dyn {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct Elf64_Dyn {
    pub d_tag: Elf64_Sxword,
    pub d_un: Elf64_Dyn__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union Elf64_Dyn__bindgen_ty_1 {
    pub d_val: Elf64_Xword,
    pub d_ptr: Elf64_Addr,
}
impl Default for Elf64_Dyn__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for Elf64_Dyn {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct elf32_rel {
    pub r_offset: Elf32_Addr,
    pub r_info: Elf32_Word,
}
pub type Elf32_Rel = elf32_rel;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct elf64_rel {
    pub r_offset: Elf64_Addr,
    pub r_info: Elf64_Xword,
}
pub type Elf64_Rel = elf64_rel;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct elf32_rela {
    pub r_offset: Elf32_Addr,
    pub r_info: Elf32_Word,
    pub r_addend: Elf32_Sword,
}
pub type Elf32_Rela = elf32_rela;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct elf64_rela {
    pub r_offset: Elf64_Addr,
    pub r_info: Elf64_Xword,
    pub r_addend: Elf64_Sxword,
}
pub type Elf64_Rela = elf64_rela;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct elf32_sym {
    pub st_name: Elf32_Word,
    pub st_value: Elf32_Addr,
    pub st_size: Elf32_Word,
    pub st_info: ffi::c_uchar,
    pub st_other: ffi::c_uchar,
    pub st_shndx: Elf32_Half,
}
pub type Elf32_Sym = elf32_sym;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct elf64_sym {
    pub st_name: Elf64_Word,
    pub st_info: ffi::c_uchar,
    pub st_other: ffi::c_uchar,
    pub st_shndx: Elf64_Half,
    pub st_value: Elf64_Addr,
    pub st_size: Elf64_Xword,
}
pub type Elf64_Sym = elf64_sym;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct elf32_hdr {
    pub e_ident: [ffi::c_uchar; 16usize],
    pub e_type: Elf32_Half,
    pub e_machine: Elf32_Half,
    pub e_version: Elf32_Word,
    pub e_entry: Elf32_Addr,
    pub e_phoff: Elf32_Off,
    pub e_shoff: Elf32_Off,
    pub e_flags: Elf32_Word,
    pub e_ehsize: Elf32_Half,
    pub e_phentsize: Elf32_Half,
    pub e_phnum: Elf32_Half,
    pub e_shentsize: Elf32_Half,
    pub e_shnum: Elf32_Half,
    pub e_shstrndx: Elf32_Half,
}
pub type Elf32_Ehdr = elf32_hdr;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct elf64_hdr {
    pub e_ident: [ffi::c_uchar; 16usize],
    pub e_type: Elf64_Half,
    pub e_machine: Elf64_Half,
    pub e_version: Elf64_Word,
    pub e_entry: Elf64_Addr,
    pub e_phoff: Elf64_Off,
    pub e_shoff: Elf64_Off,
    pub e_flags: Elf64_Word,
    pub e_ehsize: Elf64_Half,
    pub e_phentsize: Elf64_Half,
    pub e_phnum: Elf64_Half,
    pub e_shentsize: Elf64_Half,
    pub e_shnum: Elf64_Half,
    pub e_shstrndx: Elf64_Half,
}
pub type Elf64_Ehdr = elf64_hdr;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct elf32_phdr {
    pub p_type: Elf32_Word,
    pub p_offset: Elf32_Off,
    pub p_vaddr: Elf32_Addr,
    pub p_paddr: Elf32_Addr,
    pub p_filesz: Elf32_Word,
    pub p_memsz: Elf32_Word,
    pub p_flags: Elf32_Word,
    pub p_align: Elf32_Word,
}
pub type Elf32_Phdr = elf32_phdr;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct elf64_phdr {
    pub p_type: Elf64_Word,
    pub p_flags: Elf64_Word,
    pub p_offset: Elf64_Off,
    pub p_vaddr: Elf64_Addr,
    pub p_paddr: Elf64_Addr,
    pub p_filesz: Elf64_Xword,
    pub p_memsz: Elf64_Xword,
    pub p_align: Elf64_Xword,
}
pub type Elf64_Phdr = elf64_phdr;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct elf32_shdr {
    pub sh_name: Elf32_Word,
    pub sh_type: Elf32_Word,
    pub sh_flags: Elf32_Word,
    pub sh_addr: Elf32_Addr,
    pub sh_offset: Elf32_Off,
    pub sh_size: Elf32_Word,
    pub sh_link: Elf32_Word,
    pub sh_info: Elf32_Word,
    pub sh_addralign: Elf32_Word,
    pub sh_entsize: Elf32_Word,
}
pub type Elf32_Shdr = elf32_shdr;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct elf64_shdr {
    pub sh_name: Elf64_Word,
    pub sh_type: Elf64_Word,
    pub sh_flags: Elf64_Xword,
    pub sh_addr: Elf64_Addr,
    pub sh_offset: Elf64_Off,
    pub sh_size: Elf64_Xword,
    pub sh_link: Elf64_Word,
    pub sh_info: Elf64_Word,
    pub sh_addralign: Elf64_Xword,
    pub sh_entsize: Elf64_Xword,
}
pub type Elf64_Shdr = elf64_shdr;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct elf32_note {
    pub n_namesz: Elf32_Word,
    pub n_descsz: Elf32_Word,
    pub n_type: Elf32_Word,
}
pub type Elf32_Nhdr = elf32_note;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct elf64_note {
    pub n_namesz: Elf64_Word,
    pub n_descsz: Elf64_Word,
    pub n_type: Elf64_Word,
}
pub type Elf64_Nhdr = elf64_note;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct Elf32_Verdef {
    pub vd_version: Elf32_Half,
    pub vd_flags: Elf32_Half,
    pub vd_ndx: Elf32_Half,
    pub vd_cnt: Elf32_Half,
    pub vd_hash: Elf32_Word,
    pub vd_aux: Elf32_Word,
    pub vd_next: Elf32_Word,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct Elf64_Verdef {
    pub vd_version: Elf64_Half,
    pub vd_flags: Elf64_Half,
    pub vd_ndx: Elf64_Half,
    pub vd_cnt: Elf64_Half,
    pub vd_hash: Elf64_Word,
    pub vd_aux: Elf64_Word,
    pub vd_next: Elf64_Word,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct Elf32_Verdaux {
    pub vda_name: Elf32_Word,
    pub vda_next: Elf32_Word,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct Elf64_Verdaux {
    pub vda_name: Elf64_Word,
    pub vda_next: Elf64_Word,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct wait_bit_key {
    pub flags: *mut ffi::c_ulong,
    pub bit_nr: ffi::c_int,
    pub timeout: ffi::c_ulong,
}
impl Default for wait_bit_key {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct wait_bit_queue_entry {
    pub key: wait_bit_key,
    pub wq_entry: wait_queue_entry,
}
impl Default for wait_bit_queue_entry {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type wait_bit_action_f = ::core::option::Option<
    unsafe extern "C" fn(key: *mut wait_bit_key, mode: ffi::c_int) -> ffi::c_int,
>;
extern "C" {
    pub fn __wake_up_bit(wq_head: *mut wait_queue_head, word: *mut ffi::c_ulong, bit: ffi::c_int);
}
extern "C" {
    pub fn __wait_on_bit(
        wq_head: *mut wait_queue_head,
        wbq_entry: *mut wait_bit_queue_entry,
        action: wait_bit_action_f,
        mode: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __wait_on_bit_lock(
        wq_head: *mut wait_queue_head,
        wbq_entry: *mut wait_bit_queue_entry,
        action: wait_bit_action_f,
        mode: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn wake_up_bit(word: *mut ffi::c_ulong, bit: ffi::c_int);
}
extern "C" {
    pub fn out_of_line_wait_on_bit(
        word: *mut ffi::c_ulong,
        arg1: ffi::c_int,
        action: wait_bit_action_f,
        mode: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn out_of_line_wait_on_bit_timeout(
        word: *mut ffi::c_ulong,
        arg1: ffi::c_int,
        action: wait_bit_action_f,
        mode: ffi::c_uint,
        timeout: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn out_of_line_wait_on_bit_lock(
        word: *mut ffi::c_ulong,
        arg1: ffi::c_int,
        action: wait_bit_action_f,
        mode: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bit_waitqueue(word: *mut ffi::c_ulong, bit: ffi::c_int) -> *mut wait_queue_head;
}
extern "C" {
    pub fn wait_bit_init();
}
extern "C" {
    pub fn wake_bit_function(
        wq_entry: *mut wait_queue_entry,
        mode: ffi::c_uint,
        sync: ffi::c_int,
        key: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bit_wait(key: *mut wait_bit_key, mode: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn bit_wait_io(key: *mut wait_bit_key, mode: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn bit_wait_timeout(key: *mut wait_bit_key, mode: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn init_wait_var_entry(
        wbq_entry: *mut wait_bit_queue_entry,
        var: *mut ffi::c_void,
        flags: ffi::c_int,
    );
}
extern "C" {
    pub fn wake_up_var(var: *mut ffi::c_void);
}
extern "C" {
    pub fn __var_waitqueue(p: *mut ffi::c_void) -> *mut wait_queue_head_t;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct hlist_bl_head {
    pub first: *mut hlist_bl_node,
}
impl Default for hlist_bl_head {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct hlist_bl_node {
    pub next: *mut hlist_bl_node,
    pub pprev: *mut *mut hlist_bl_node,
}
impl Default for hlist_bl_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct lockref {
    pub __bindgen_anon_1: lockref__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union lockref__bindgen_ty_1 {
    pub lock_count: __u64,
    pub __bindgen_anon_1: lockref__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct lockref__bindgen_ty_1__bindgen_ty_1 {
    pub lock: spinlock_t,
    pub count: ffi::c_int,
}
impl Default for lockref__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for lockref {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn lockref_get(lockref: *mut lockref);
}
extern "C" {
    pub fn lockref_put_return(lockref: *mut lockref) -> ffi::c_int;
}
extern "C" {
    pub fn lockref_get_not_zero(lockref: *mut lockref) -> bool_;
}
extern "C" {
    pub fn lockref_put_or_lock(lockref: *mut lockref) -> bool_;
}
extern "C" {
    pub fn lockref_mark_dead(lockref: *mut lockref);
}
extern "C" {
    pub fn lockref_get_not_dead(lockref: *mut lockref) -> bool_;
}
extern "C" {
    pub fn full_name_hash(
        salt: *const ffi::c_void,
        arg1: *const ffi::c_char,
        arg2: ffi::c_uint,
    ) -> ffi::c_uint;
}
extern "C" {
    pub fn hashlen_string(salt: *const ffi::c_void, name: *const ffi::c_char) -> u64_;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct qstr {
    pub __bindgen_anon_1: qstr__bindgen_ty_1,
    pub name: *const ffi::c_uchar,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union qstr__bindgen_ty_1 {
    pub __bindgen_anon_1: qstr__bindgen_ty_1__bindgen_ty_1,
    pub hash_len: u64_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct qstr__bindgen_ty_1__bindgen_ty_1 {
    pub hash: u32_,
    pub len: u32_,
}
impl Default for qstr__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for qstr {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static empty_name: qstr;
}
extern "C" {
    pub static slash_name: qstr;
}
extern "C" {
    pub static dotdot_name: qstr;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union shortname_store {
    pub string: [ffi::c_uchar; 40usize],
    pub words: [ffi::c_ulong; 5usize],
}
impl Default for shortname_store {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct dentry {
    pub d_flags: ffi::c_uint,
    pub d_seq: seqcount_spinlock_t,
    pub d_hash: hlist_bl_node,
    pub d_parent: *mut dentry,
    pub d_name: qstr,
    pub d_inode: *mut inode,
    pub d_shortname: shortname_store,
    pub d_op: *const dentry_operations,
    pub d_sb: *mut super_block,
    pub d_time: ffi::c_ulong,
    pub d_fsdata: *mut ffi::c_void,
    pub d_lockref: lockref,
    pub __bindgen_anon_1: dentry__bindgen_ty_1,
    pub d_sib: hlist_node,
    pub d_children: hlist_head,
    pub d_u: dentry__bindgen_ty_2,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union dentry__bindgen_ty_1 {
    pub d_lru: list_head,
    pub d_wait: *mut wait_queue_head_t,
}
impl Default for dentry__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union dentry__bindgen_ty_2 {
    pub d_alias: hlist_node,
    pub d_in_lookup_hash: hlist_bl_node,
    pub d_rcu: callback_head,
}
impl Default for dentry__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for dentry {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const dentry_d_lock_class_DENTRY_D_LOCK_NORMAL: dentry_d_lock_class = 0;
pub const dentry_d_lock_class_DENTRY_D_LOCK_NESTED: dentry_d_lock_class = 1;
pub type dentry_d_lock_class = ffi::c_uint;
pub const d_real_type_D_REAL_DATA: d_real_type = 0;
pub const d_real_type_D_REAL_METADATA: d_real_type = 1;
pub type d_real_type = ffi::c_uint;
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct dentry_operations {
    pub d_revalidate: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut inode,
            arg2: *const qstr,
            arg3: *mut dentry,
            arg4: ffi::c_uint,
        ) -> ffi::c_int,
    >,
    pub d_weak_revalidate: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut dentry, arg2: ffi::c_uint) -> ffi::c_int,
    >,
    pub d_hash: ::core::option::Option<
        unsafe extern "C" fn(arg1: *const dentry, arg2: *mut qstr) -> ffi::c_int,
    >,
    pub d_compare: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *const dentry,
            arg2: ffi::c_uint,
            arg3: *const ffi::c_char,
            arg4: *const qstr,
        ) -> ffi::c_int,
    >,
    pub d_delete: ::core::option::Option<unsafe extern "C" fn(arg1: *const dentry) -> ffi::c_int>,
    pub d_init: ::core::option::Option<unsafe extern "C" fn(arg1: *mut dentry) -> ffi::c_int>,
    pub d_release: ::core::option::Option<unsafe extern "C" fn(arg1: *mut dentry)>,
    pub d_prune: ::core::option::Option<unsafe extern "C" fn(arg1: *mut dentry)>,
    pub d_iput: ::core::option::Option<unsafe extern "C" fn(arg1: *mut dentry, arg2: *mut inode)>,
    pub d_dname: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut dentry,
            arg2: *mut ffi::c_char,
            arg3: ffi::c_int,
        ) -> *mut ffi::c_char,
    >,
    pub d_automount: ::core::option::Option<unsafe extern "C" fn(arg1: *mut path) -> *mut vfsmount>,
    pub d_manage:
        ::core::option::Option<unsafe extern "C" fn(arg1: *const path, arg2: bool_) -> ffi::c_int>,
    pub d_real: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut dentry, type_: d_real_type) -> *mut dentry,
    >,
    pub d_unalias_trylock:
        ::core::option::Option<unsafe extern "C" fn(arg1: *const dentry) -> bool_>,
    pub d_unalias_unlock: ::core::option::Option<unsafe extern "C" fn(arg1: *const dentry)>,
}
impl Default for dentry_operations {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const dentry_flags_DCACHE_OP_HASH: dentry_flags = 1;
pub const dentry_flags_DCACHE_OP_COMPARE: dentry_flags = 2;
pub const dentry_flags_DCACHE_OP_REVALIDATE: dentry_flags = 4;
pub const dentry_flags_DCACHE_OP_DELETE: dentry_flags = 8;
pub const dentry_flags_DCACHE_OP_PRUNE: dentry_flags = 16;
pub const dentry_flags_DCACHE_DISCONNECTED: dentry_flags = 32;
pub const dentry_flags_DCACHE_REFERENCED: dentry_flags = 64;
pub const dentry_flags_DCACHE_DONTCACHE: dentry_flags = 128;
pub const dentry_flags_DCACHE_CANT_MOUNT: dentry_flags = 256;
pub const dentry_flags_DCACHE_GENOCIDE: dentry_flags = 512;
pub const dentry_flags_DCACHE_SHRINK_LIST: dentry_flags = 1024;
pub const dentry_flags_DCACHE_OP_WEAK_REVALIDATE: dentry_flags = 2048;
pub const dentry_flags_DCACHE_NFSFS_RENAMED: dentry_flags = 4096;
pub const dentry_flags_DCACHE_FSNOTIFY_PARENT_WATCHED: dentry_flags = 8192;
pub const dentry_flags_DCACHE_DENTRY_KILLED: dentry_flags = 16384;
pub const dentry_flags_DCACHE_MOUNTED: dentry_flags = 32768;
pub const dentry_flags_DCACHE_NEED_AUTOMOUNT: dentry_flags = 65536;
pub const dentry_flags_DCACHE_MANAGE_TRANSIT: dentry_flags = 131072;
pub const dentry_flags_DCACHE_LRU_LIST: dentry_flags = 262144;
pub const dentry_flags_DCACHE_ENTRY_TYPE: dentry_flags = 3670016;
pub const dentry_flags_DCACHE_MISS_TYPE: dentry_flags = 0;
pub const dentry_flags_DCACHE_WHITEOUT_TYPE: dentry_flags = 524288;
pub const dentry_flags_DCACHE_DIRECTORY_TYPE: dentry_flags = 1048576;
pub const dentry_flags_DCACHE_AUTODIR_TYPE: dentry_flags = 1572864;
pub const dentry_flags_DCACHE_REGULAR_TYPE: dentry_flags = 2097152;
pub const dentry_flags_DCACHE_SPECIAL_TYPE: dentry_flags = 2621440;
pub const dentry_flags_DCACHE_SYMLINK_TYPE: dentry_flags = 3145728;
pub const dentry_flags_DCACHE_NOKEY_NAME: dentry_flags = 4194304;
pub const dentry_flags_DCACHE_OP_REAL: dentry_flags = 8388608;
pub const dentry_flags_DCACHE_PAR_LOOKUP: dentry_flags = 16777216;
pub const dentry_flags_DCACHE_DENTRY_CURSOR: dentry_flags = 33554432;
pub const dentry_flags_DCACHE_NORCU: dentry_flags = 67108864;
pub type dentry_flags = ffi::c_uint;
extern "C" {
    pub static mut rename_lock: seqlock_t;
}
extern "C" {
    pub fn d_instantiate(arg1: *mut dentry, arg2: *mut inode);
}
extern "C" {
    pub fn d_instantiate_new(arg1: *mut dentry, arg2: *mut inode);
}
extern "C" {
    pub fn __d_drop(dentry: *mut dentry);
}
extern "C" {
    pub fn d_drop(dentry: *mut dentry);
}
extern "C" {
    pub fn d_delete(arg1: *mut dentry);
}
extern "C" {
    pub fn d_set_d_op(dentry: *mut dentry, op: *const dentry_operations);
}
extern "C" {
    pub fn d_alloc(arg1: *mut dentry, arg2: *const qstr) -> *mut dentry;
}
extern "C" {
    pub fn d_alloc_anon(arg1: *mut super_block) -> *mut dentry;
}
extern "C" {
    pub fn d_alloc_parallel(
        arg1: *mut dentry,
        arg2: *const qstr,
        arg3: *mut wait_queue_head_t,
    ) -> *mut dentry;
}
extern "C" {
    pub fn d_splice_alias(arg1: *mut inode, arg2: *mut dentry) -> *mut dentry;
}
extern "C" {
    pub fn d_add_ci(arg1: *mut dentry, arg2: *mut inode, arg3: *mut qstr) -> *mut dentry;
}
extern "C" {
    pub fn d_same_name(dentry: *const dentry, parent: *const dentry, name: *const qstr) -> bool_;
}
extern "C" {
    pub fn d_find_any_alias(inode: *mut inode) -> *mut dentry;
}
extern "C" {
    pub fn d_obtain_alias(arg1: *mut inode) -> *mut dentry;
}
extern "C" {
    pub fn d_obtain_root(arg1: *mut inode) -> *mut dentry;
}
extern "C" {
    pub fn shrink_dcache_sb(arg1: *mut super_block);
}
extern "C" {
    pub fn shrink_dcache_parent(arg1: *mut dentry);
}
extern "C" {
    pub fn d_invalidate(arg1: *mut dentry);
}
extern "C" {
    pub fn d_make_root(arg1: *mut inode) -> *mut dentry;
}
extern "C" {
    pub fn d_mark_tmpfile(arg1: *mut file, arg2: *mut inode);
}
extern "C" {
    pub fn d_tmpfile(arg1: *mut file, arg2: *mut inode);
}
extern "C" {
    pub fn d_find_alias(arg1: *mut inode) -> *mut dentry;
}
extern "C" {
    pub fn d_prune_aliases(arg1: *mut inode);
}
extern "C" {
    pub fn d_find_alias_rcu(arg1: *mut inode) -> *mut dentry;
}
extern "C" {
    pub fn path_has_submounts(arg1: *const path) -> ffi::c_int;
}
extern "C" {
    pub fn d_rehash(arg1: *mut dentry);
}
extern "C" {
    pub fn d_add(arg1: *mut dentry, arg2: *mut inode);
}
extern "C" {
    pub fn d_move(arg1: *mut dentry, arg2: *mut dentry);
}
extern "C" {
    pub fn d_exchange(arg1: *mut dentry, arg2: *mut dentry);
}
extern "C" {
    pub fn d_ancestor(arg1: *mut dentry, arg2: *mut dentry) -> *mut dentry;
}
extern "C" {
    pub fn d_lookup(arg1: *const dentry, arg2: *const qstr) -> *mut dentry;
}
extern "C" {
    pub fn d_hash_and_lookup(arg1: *mut dentry, arg2: *mut qstr) -> *mut dentry;
}
extern "C" {
    pub fn d_parent_ino(dentry: *mut dentry) -> ino_t;
}
extern "C" {
    pub fn dynamic_dname(
        arg1: *mut ffi::c_char,
        arg2: ffi::c_int,
        arg3: *const ffi::c_char,
        ...
    ) -> *mut ffi::c_char;
}
extern "C" {
    pub fn __d_path(
        arg1: *const path,
        arg2: *const path,
        arg3: *mut ffi::c_char,
        arg4: ffi::c_int,
    ) -> *mut ffi::c_char;
}
extern "C" {
    pub fn d_absolute_path(
        arg1: *const path,
        arg2: *mut ffi::c_char,
        arg3: ffi::c_int,
    ) -> *mut ffi::c_char;
}
extern "C" {
    pub fn d_path(arg1: *const path, arg2: *mut ffi::c_char, arg3: ffi::c_int) -> *mut ffi::c_char;
}
extern "C" {
    pub fn dentry_path_raw(
        arg1: *const dentry,
        arg2: *mut ffi::c_char,
        arg3: ffi::c_int,
    ) -> *mut ffi::c_char;
}
extern "C" {
    pub fn dentry_path(
        arg1: *const dentry,
        arg2: *mut ffi::c_char,
        arg3: ffi::c_int,
    ) -> *mut ffi::c_char;
}
extern "C" {
    pub fn dget_parent(dentry: *mut dentry) -> *mut dentry;
}
extern "C" {
    pub fn __d_lookup_unhash_wake(dentry: *mut dentry);
}
extern "C" {
    pub fn dput(arg1: *mut dentry);
}
extern "C" {
    pub fn vfs_pressure_ratio(val: ffi::c_ulong) -> ffi::c_ulong;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct name_snapshot {
    pub name: qstr,
    pub inline_name: shortname_store,
}
impl Default for name_snapshot {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn take_dentry_name_snapshot(arg1: *mut name_snapshot, arg2: *mut dentry);
}
extern "C" {
    pub fn release_dentry_name_snapshot(arg1: *mut name_snapshot);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct path {
    pub mnt: *mut vfsmount,
    pub dentry: *mut dentry,
}
impl Default for path {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn path_get(arg1: *const path);
}
extern "C" {
    pub fn path_put(arg1: *const path);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct shrinker_info_unit {
    pub nr_deferred: [atomic_long_t; 64usize],
    pub map: [ffi::c_ulong; 1usize],
}
impl Default for shrinker_info_unit {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct shrinker_info {
    pub rcu: callback_head,
    pub map_nr_max: ffi::c_int,
    pub unit: __IncompleteArrayField<*mut shrinker_info_unit>,
}
impl Default for shrinker_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct shrink_control {
    pub gfp_mask: gfp_t,
    pub nid: ffi::c_int,
    pub nr_to_scan: ffi::c_ulong,
    pub nr_scanned: ffi::c_ulong,
    pub memcg: *mut mem_cgroup,
}
impl Default for shrink_control {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct shrinker {
    pub count_objects: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut shrinker, sc: *mut shrink_control) -> ffi::c_ulong,
    >,
    pub scan_objects: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut shrinker, sc: *mut shrink_control) -> ffi::c_ulong,
    >,
    pub batch: ffi::c_long,
    pub seeks: ffi::c_int,
    pub flags: ffi::c_uint,
    pub refcount: refcount_t,
    pub done: completion,
    pub rcu: callback_head,
    pub private_data: *mut ffi::c_void,
    pub list: list_head,
    pub id: ffi::c_int,
    pub nr_deferred: *mut atomic_long_t,
}
impl Default for shrinker {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn shrinker_alloc(flags: ffi::c_uint, fmt: *const ffi::c_char, ...) -> *mut shrinker;
}
extern "C" {
    pub fn shrinker_register(shrinker: *mut shrinker);
}
extern "C" {
    pub fn shrinker_free(shrinker: *mut shrinker);
}
extern "C" {
    pub fn set_dumpable(mm: *mut mm_struct, value: ffi::c_int);
}
extern "C" {
    pub fn mm_alloc() -> *mut mm_struct;
}
extern "C" {
    pub fn __mmdrop(mm: *mut mm_struct);
}
extern "C" {
    pub fn mmput(arg1: *mut mm_struct);
}
extern "C" {
    pub fn mmput_async(arg1: *mut mm_struct);
}
extern "C" {
    pub fn get_task_mm(task: *mut task_struct) -> *mut mm_struct;
}
extern "C" {
    pub fn mm_access(task: *mut task_struct, mode: ffi::c_uint) -> *mut mm_struct;
}
extern "C" {
    pub fn exit_mm_release(arg1: *mut task_struct, arg2: *mut mm_struct);
}
extern "C" {
    pub fn exec_mm_release(arg1: *mut task_struct, arg2: *mut mm_struct);
}
extern "C" {
    pub fn mm_update_next_owner(mm: *mut mm_struct);
}
extern "C" {
    pub fn arch_pick_mmap_layout(mm: *mut mm_struct, rlim_stack: *mut rlimit);
}
extern "C" {
    pub fn arch_get_unmapped_area(
        filp: *mut file,
        addr: ffi::c_ulong,
        len: ffi::c_ulong,
        pgoff: ffi::c_ulong,
        flags: ffi::c_ulong,
        vm_flags: vm_flags_t,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn arch_get_unmapped_area_topdown(
        filp: *mut file,
        addr: ffi::c_ulong,
        len: ffi::c_ulong,
        pgoff: ffi::c_ulong,
        flags: ffi::c_ulong,
        arg1: vm_flags_t,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn mm_get_unmapped_area(
        mm: *mut mm_struct,
        filp: *mut file,
        addr: ffi::c_ulong,
        len: ffi::c_ulong,
        pgoff: ffi::c_ulong,
        flags: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn mm_get_unmapped_area_vmflags(
        mm: *mut mm_struct,
        filp: *mut file,
        addr: ffi::c_ulong,
        len: ffi::c_ulong,
        pgoff: ffi::c_ulong,
        flags: ffi::c_ulong,
        vm_flags: vm_flags_t,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn generic_get_unmapped_area(
        filp: *mut file,
        addr: ffi::c_ulong,
        len: ffi::c_ulong,
        pgoff: ffi::c_ulong,
        flags: ffi::c_ulong,
        vm_flags: vm_flags_t,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn generic_get_unmapped_area_topdown(
        filp: *mut file,
        addr: ffi::c_ulong,
        len: ffi::c_ulong,
        pgoff: ffi::c_ulong,
        flags: ffi::c_ulong,
        vm_flags: vm_flags_t,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub static mut int_active_memcg: *mut mem_cgroup;
}
pub const MEMBARRIER_STATE_PRIVATE_EXPEDITED_READY: _bindgen_ty_71 = 1;
pub const MEMBARRIER_STATE_PRIVATE_EXPEDITED: _bindgen_ty_71 = 2;
pub const MEMBARRIER_STATE_GLOBAL_EXPEDITED_READY: _bindgen_ty_71 = 4;
pub const MEMBARRIER_STATE_GLOBAL_EXPEDITED: _bindgen_ty_71 = 8;
pub const MEMBARRIER_STATE_PRIVATE_EXPEDITED_SYNC_CORE_READY: _bindgen_ty_71 = 16;
pub const MEMBARRIER_STATE_PRIVATE_EXPEDITED_SYNC_CORE: _bindgen_ty_71 = 32;
pub const MEMBARRIER_STATE_PRIVATE_EXPEDITED_RSEQ_READY: _bindgen_ty_71 = 64;
pub const MEMBARRIER_STATE_PRIVATE_EXPEDITED_RSEQ: _bindgen_ty_71 = 128;
pub type _bindgen_ty_71 = ffi::c_uint;
pub const MEMBARRIER_FLAG_SYNC_CORE: _bindgen_ty_72 = 1;
pub const MEMBARRIER_FLAG_RSEQ: _bindgen_ty_72 = 2;
pub type _bindgen_ty_72 = ffi::c_uint;
extern "C" {
    pub fn membarrier_exec_mmap(mm: *mut mm_struct);
}
extern "C" {
    pub fn membarrier_update_current_mm(next_mm: *mut mm_struct);
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct xa_limit {
    pub max: u32_,
    pub min: u32_,
}
pub type xa_mark_t = ffi::c_uint;
pub const xa_lock_type_XA_LOCK_IRQ: xa_lock_type = 1;
pub const xa_lock_type_XA_LOCK_BH: xa_lock_type = 2;
pub type xa_lock_type = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct xarray {
    pub xa_lock: spinlock_t,
    pub xa_flags: gfp_t,
    pub xa_head: *mut ffi::c_void,
}
impl Default for xarray {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn xa_load(arg1: *mut xarray, index: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn xa_store(
        arg1: *mut xarray,
        index: ffi::c_ulong,
        entry: *mut ffi::c_void,
        arg2: gfp_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn xa_erase(arg1: *mut xarray, index: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn xa_store_range(
        arg1: *mut xarray,
        first: ffi::c_ulong,
        last: ffi::c_ulong,
        entry: *mut ffi::c_void,
        arg2: gfp_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn xa_get_mark(arg1: *mut xarray, index: ffi::c_ulong, arg2: xa_mark_t) -> bool_;
}
extern "C" {
    pub fn xa_set_mark(arg1: *mut xarray, index: ffi::c_ulong, arg2: xa_mark_t);
}
extern "C" {
    pub fn xa_clear_mark(arg1: *mut xarray, index: ffi::c_ulong, arg2: xa_mark_t);
}
extern "C" {
    pub fn xa_find(
        xa: *mut xarray,
        index: *mut ffi::c_ulong,
        max: ffi::c_ulong,
        arg1: xa_mark_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn xa_find_after(
        xa: *mut xarray,
        index: *mut ffi::c_ulong,
        max: ffi::c_ulong,
        arg1: xa_mark_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn xa_extract(
        arg1: *mut xarray,
        dst: *mut *mut ffi::c_void,
        start: ffi::c_ulong,
        max: ffi::c_ulong,
        n: ffi::c_uint,
        arg2: xa_mark_t,
    ) -> ffi::c_uint;
}
extern "C" {
    pub fn xa_destroy(arg1: *mut xarray);
}
extern "C" {
    pub fn __xa_erase(arg1: *mut xarray, index: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn __xa_store(
        arg1: *mut xarray,
        index: ffi::c_ulong,
        entry: *mut ffi::c_void,
        arg2: gfp_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn __xa_cmpxchg(
        arg1: *mut xarray,
        index: ffi::c_ulong,
        old: *mut ffi::c_void,
        entry: *mut ffi::c_void,
        arg2: gfp_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    #[must_use]
    pub fn __xa_insert(
        arg1: *mut xarray,
        index: ffi::c_ulong,
        entry: *mut ffi::c_void,
        arg2: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn __xa_alloc(
        arg1: *mut xarray,
        id: *mut u32_,
        entry: *mut ffi::c_void,
        arg2: xa_limit,
        arg3: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn __xa_alloc_cyclic(
        arg1: *mut xarray,
        id: *mut u32_,
        entry: *mut ffi::c_void,
        arg2: xa_limit,
        next: *mut u32_,
        arg3: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __xa_set_mark(arg1: *mut xarray, index: ffi::c_ulong, arg2: xa_mark_t);
}
extern "C" {
    pub fn __xa_clear_mark(arg1: *mut xarray, index: ffi::c_ulong, arg2: xa_mark_t);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct xa_node {
    pub shift: ffi::c_uchar,
    pub offset: ffi::c_uchar,
    pub count: ffi::c_uchar,
    pub nr_values: ffi::c_uchar,
    pub parent: *mut xa_node,
    pub array: *mut xarray,
    pub __bindgen_anon_1: xa_node__bindgen_ty_1,
    pub slots: [*mut ffi::c_void; 64usize],
    pub __bindgen_anon_2: xa_node__bindgen_ty_2,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union xa_node__bindgen_ty_1 {
    pub private_list: list_head,
    pub callback_head: callback_head,
}
impl Default for xa_node__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union xa_node__bindgen_ty_2 {
    pub tags: [[ffi::c_ulong; 1usize]; 3usize],
    pub marks: [[ffi::c_ulong; 1usize]; 3usize],
}
impl Default for xa_node__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for xa_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn xa_dump(arg1: *const xarray);
}
extern "C" {
    pub fn xa_dump_node(arg1: *const xa_node);
}
pub type xa_update_node_t = ::core::option::Option<unsafe extern "C" fn(node: *mut xa_node)>;
extern "C" {
    pub fn xa_delete_node(arg1: *mut xa_node, arg2: xa_update_node_t);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct xa_state {
    pub xa: *mut xarray,
    pub xa_index: ffi::c_ulong,
    pub xa_shift: ffi::c_uchar,
    pub xa_sibs: ffi::c_uchar,
    pub xa_offset: ffi::c_uchar,
    pub xa_pad: ffi::c_uchar,
    pub xa_node: *mut xa_node,
    pub xa_alloc: *mut xa_node,
    pub xa_update: xa_update_node_t,
    pub xa_lru: *mut list_lru,
}
impl Default for xa_state {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn xas_load(arg1: *mut xa_state) -> *mut ffi::c_void;
}
extern "C" {
    pub fn xas_store(arg1: *mut xa_state, entry: *mut ffi::c_void) -> *mut ffi::c_void;
}
extern "C" {
    pub fn xas_find(arg1: *mut xa_state, max: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn xas_find_conflict(arg1: *mut xa_state) -> *mut ffi::c_void;
}
extern "C" {
    pub fn xas_get_mark(arg1: *const xa_state, arg2: xa_mark_t) -> bool_;
}
extern "C" {
    pub fn xas_set_mark(arg1: *const xa_state, arg2: xa_mark_t);
}
extern "C" {
    pub fn xas_clear_mark(arg1: *const xa_state, arg2: xa_mark_t);
}
extern "C" {
    pub fn xas_find_marked(
        arg1: *mut xa_state,
        max: ffi::c_ulong,
        arg2: xa_mark_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn xas_init_marks(arg1: *const xa_state);
}
extern "C" {
    pub fn xas_nomem(arg1: *mut xa_state, arg2: gfp_t) -> bool_;
}
extern "C" {
    pub fn xas_destroy(arg1: *mut xa_state);
}
extern "C" {
    pub fn xas_pause(arg1: *mut xa_state);
}
extern "C" {
    pub fn xas_create_range(arg1: *mut xa_state);
}
extern "C" {
    pub fn xa_get_order(arg1: *mut xarray, index: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn xas_get_order(xas: *mut xa_state) -> ffi::c_int;
}
extern "C" {
    pub fn xas_split(arg1: *mut xa_state, entry: *mut ffi::c_void, order: ffi::c_uint);
}
extern "C" {
    pub fn xas_split_alloc(
        arg1: *mut xa_state,
        entry: *mut ffi::c_void,
        order: ffi::c_uint,
        arg2: gfp_t,
    );
}
extern "C" {
    pub fn xas_try_split(xas: *mut xa_state, entry: *mut ffi::c_void, order: ffi::c_uint);
}
extern "C" {
    pub fn xas_try_split_min_order(order: ffi::c_uint) -> ffi::c_uint;
}
pub const XA_CHECK_SCHED: _bindgen_ty_73 = 4096;
pub type _bindgen_ty_73 = ffi::c_uint;
extern "C" {
    pub fn __xas_next(arg1: *mut xa_state) -> *mut ffi::c_void;
}
extern "C" {
    pub fn __xas_prev(arg1: *mut xa_state) -> *mut ffi::c_void;
}
pub const lru_status_LRU_REMOVED: lru_status = 0;
pub const lru_status_LRU_REMOVED_RETRY: lru_status = 1;
pub const lru_status_LRU_ROTATE: lru_status = 2;
pub const lru_status_LRU_SKIP: lru_status = 3;
pub const lru_status_LRU_RETRY: lru_status = 4;
pub const lru_status_LRU_STOP: lru_status = 5;
pub type lru_status = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct list_lru_one {
    pub list: list_head,
    pub nr_items: ffi::c_long,
    pub lock: spinlock_t,
}
impl Default for list_lru_one {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct list_lru_memcg {
    pub rcu: callback_head,
    pub node: __IncompleteArrayField<list_lru_one>,
}
impl Default for list_lru_memcg {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct list_lru_node {
    pub lru: list_lru_one,
    pub nr_items: atomic_long_t,
}
impl Default for list_lru_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct list_lru {
    pub node: *mut list_lru_node,
    pub list: list_head,
    pub shrinker_id: ffi::c_int,
    pub memcg_aware: bool_,
    pub xa: xarray,
}
impl Default for list_lru {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn list_lru_destroy(lru: *mut list_lru);
}
extern "C" {
    pub fn __list_lru_init(
        lru: *mut list_lru,
        memcg_aware: bool_,
        shrinker: *mut shrinker,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn memcg_list_lru_alloc(
        memcg: *mut mem_cgroup,
        lru: *mut list_lru,
        gfp: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn memcg_reparent_list_lrus(memcg: *mut mem_cgroup, parent: *mut mem_cgroup);
}
extern "C" {
    pub fn list_lru_add(
        lru: *mut list_lru,
        item: *mut list_head,
        nid: ffi::c_int,
        memcg: *mut mem_cgroup,
    ) -> bool_;
}
extern "C" {
    pub fn list_lru_add_obj(lru: *mut list_lru, item: *mut list_head) -> bool_;
}
extern "C" {
    pub fn list_lru_del(
        lru: *mut list_lru,
        item: *mut list_head,
        nid: ffi::c_int,
        memcg: *mut mem_cgroup,
    ) -> bool_;
}
extern "C" {
    pub fn list_lru_del_obj(lru: *mut list_lru, item: *mut list_head) -> bool_;
}
extern "C" {
    pub fn list_lru_count_one(
        lru: *mut list_lru,
        nid: ffi::c_int,
        memcg: *mut mem_cgroup,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn list_lru_count_node(lru: *mut list_lru, nid: ffi::c_int) -> ffi::c_ulong;
}
extern "C" {
    pub fn list_lru_isolate(list: *mut list_lru_one, item: *mut list_head);
}
extern "C" {
    pub fn list_lru_isolate_move(
        list: *mut list_lru_one,
        item: *mut list_head,
        head: *mut list_head,
    );
}
pub type list_lru_walk_cb = ::core::option::Option<
    unsafe extern "C" fn(
        item: *mut list_head,
        list: *mut list_lru_one,
        cb_arg: *mut ffi::c_void,
    ) -> lru_status,
>;
extern "C" {
    pub fn list_lru_walk_one(
        lru: *mut list_lru,
        nid: ffi::c_int,
        memcg: *mut mem_cgroup,
        isolate: list_lru_walk_cb,
        cb_arg: *mut ffi::c_void,
        nr_to_walk: *mut ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn list_lru_walk_one_irq(
        lru: *mut list_lru,
        nid: ffi::c_int,
        memcg: *mut mem_cgroup,
        isolate: list_lru_walk_cb,
        cb_arg: *mut ffi::c_void,
        nr_to_walk: *mut ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn list_lru_walk_node(
        lru: *mut list_lru,
        nid: ffi::c_int,
        isolate: list_lru_walk_cb,
        cb_arg: *mut ffi::c_void,
        nr_to_walk: *mut ffi::c_ulong,
    ) -> ffi::c_ulong;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct radix_tree_preload {
    pub lock: local_lock_t,
    pub nr: ffi::c_uint,
    pub nodes: *mut xa_node,
}
impl Default for radix_tree_preload {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut radix_tree_preloads: radix_tree_preload;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct radix_tree_iter {
    pub index: ffi::c_ulong,
    pub next_index: ffi::c_ulong,
    pub tags: ffi::c_ulong,
    pub node: *mut xa_node,
}
impl Default for radix_tree_iter {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn radix_tree_insert(
        arg1: *mut xarray,
        index: ffi::c_ulong,
        arg2: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __radix_tree_lookup(
        arg1: *const xarray,
        index: ffi::c_ulong,
        nodep: *mut *mut xa_node,
        slotp: *mut *mut *mut ffi::c_void,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn radix_tree_lookup(arg1: *const xarray, arg2: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn radix_tree_lookup_slot(
        arg1: *const xarray,
        index: ffi::c_ulong,
    ) -> *mut *mut ffi::c_void;
}
extern "C" {
    pub fn __radix_tree_replace(
        arg1: *mut xarray,
        arg2: *mut xa_node,
        slot: *mut *mut ffi::c_void,
        entry: *mut ffi::c_void,
    );
}
extern "C" {
    pub fn radix_tree_iter_replace(
        arg1: *mut xarray,
        arg2: *const radix_tree_iter,
        slot: *mut *mut ffi::c_void,
        entry: *mut ffi::c_void,
    );
}
extern "C" {
    pub fn radix_tree_replace_slot(
        arg1: *mut xarray,
        slot: *mut *mut ffi::c_void,
        entry: *mut ffi::c_void,
    );
}
extern "C" {
    pub fn radix_tree_iter_delete(
        arg1: *mut xarray,
        iter: *mut radix_tree_iter,
        slot: *mut *mut ffi::c_void,
    );
}
extern "C" {
    pub fn radix_tree_delete_item(
        arg1: *mut xarray,
        arg2: ffi::c_ulong,
        arg3: *mut ffi::c_void,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn radix_tree_delete(arg1: *mut xarray, arg2: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn radix_tree_gang_lookup(
        arg1: *const xarray,
        results: *mut *mut ffi::c_void,
        first_index: ffi::c_ulong,
        max_items: ffi::c_uint,
    ) -> ffi::c_uint;
}
extern "C" {
    pub fn radix_tree_preload(gfp_mask: gfp_t) -> ffi::c_int;
}
extern "C" {
    pub fn radix_tree_maybe_preload(gfp_mask: gfp_t) -> ffi::c_int;
}
extern "C" {
    pub fn radix_tree_init();
}
extern "C" {
    pub fn radix_tree_tag_set(
        arg1: *mut xarray,
        index: ffi::c_ulong,
        tag: ffi::c_uint,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn radix_tree_tag_clear(
        arg1: *mut xarray,
        index: ffi::c_ulong,
        tag: ffi::c_uint,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn radix_tree_tag_get(
        arg1: *const xarray,
        index: ffi::c_ulong,
        tag: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn radix_tree_iter_tag_clear(
        arg1: *mut xarray,
        iter: *const radix_tree_iter,
        tag: ffi::c_uint,
    );
}
extern "C" {
    pub fn radix_tree_gang_lookup_tag(
        arg1: *const xarray,
        results: *mut *mut ffi::c_void,
        first_index: ffi::c_ulong,
        max_items: ffi::c_uint,
        tag: ffi::c_uint,
    ) -> ffi::c_uint;
}
extern "C" {
    pub fn radix_tree_gang_lookup_tag_slot(
        arg1: *const xarray,
        results: *mut *mut *mut ffi::c_void,
        first_index: ffi::c_ulong,
        max_items: ffi::c_uint,
        tag: ffi::c_uint,
    ) -> ffi::c_uint;
}
extern "C" {
    pub fn radix_tree_tagged(arg1: *const xarray, tag: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn idr_get_free(
        root: *mut xarray,
        iter: *mut radix_tree_iter,
        gfp: gfp_t,
        max: ffi::c_ulong,
    ) -> *mut *mut ffi::c_void;
}
pub const RADIX_TREE_ITER_TAG_MASK: _bindgen_ty_74 = 15;
pub const RADIX_TREE_ITER_TAGGED: _bindgen_ty_74 = 16;
pub const RADIX_TREE_ITER_CONTIG: _bindgen_ty_74 = 32;
pub type _bindgen_ty_74 = ffi::c_uint;
extern "C" {
    pub fn radix_tree_next_chunk(
        arg1: *const xarray,
        iter: *mut radix_tree_iter,
        flags: ffi::c_uint,
    ) -> *mut *mut ffi::c_void;
}
extern "C" {
    #[must_use]
    pub fn radix_tree_iter_resume(
        slot: *mut *mut ffi::c_void,
        iter: *mut radix_tree_iter,
    ) -> *mut *mut ffi::c_void;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct upid {
    pub nr: ffi::c_int,
    pub ns: *mut pid_namespace,
}
impl Default for upid {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct pid {
    pub count: refcount_t,
    pub level: ffi::c_uint,
    pub lock: spinlock_t,
    pub stashed: *mut dentry,
    pub ino: u64_,
    pub pidfs_node: rb_node,
    pub tasks: [hlist_head; 4usize],
    pub inodes: hlist_head,
    pub wait_pidfd: wait_queue_head_t,
    pub rcu: callback_head,
    pub numbers: __IncompleteArrayField<upid>,
}
impl Default for pid {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut pidmap_lock_seq: seqcount_spinlock_t;
}
extern "C" {
    pub static mut init_struct_pid: pid;
}
extern "C" {
    pub fn pidfd_pid(file: *const file) -> *mut pid;
}
extern "C" {
    pub fn pidfd_get_pid(fd: ffi::c_uint, flags: *mut ffi::c_uint) -> *mut pid;
}
extern "C" {
    pub fn pidfd_get_task(pidfd: ffi::c_int, flags: *mut ffi::c_uint) -> *mut task_struct;
}
extern "C" {
    pub fn pidfd_prepare(pid: *mut pid, flags: ffi::c_uint, ret: *mut *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn do_notify_pidfd(task: *mut task_struct);
}
extern "C" {
    pub fn put_pid(pid: *mut pid);
}
extern "C" {
    pub fn pid_task(pid: *mut pid, arg1: pid_type) -> *mut task_struct;
}
extern "C" {
    pub fn get_pid_task(pid: *mut pid, arg1: pid_type) -> *mut task_struct;
}
extern "C" {
    pub fn get_task_pid(task: *mut task_struct, type_: pid_type) -> *mut pid;
}
extern "C" {
    pub fn attach_pid(task: *mut task_struct, arg1: pid_type);
}
extern "C" {
    pub fn detach_pid(pids: *mut *mut pid, task: *mut task_struct, arg1: pid_type);
}
extern "C" {
    pub fn change_pid(pids: *mut *mut pid, task: *mut task_struct, arg1: pid_type, pid: *mut pid);
}
extern "C" {
    pub fn exchange_tids(task: *mut task_struct, old: *mut task_struct);
}
extern "C" {
    pub fn transfer_pid(old: *mut task_struct, new: *mut task_struct, arg1: pid_type);
}
extern "C" {
    pub fn find_pid_ns(nr: ffi::c_int, ns: *mut pid_namespace) -> *mut pid;
}
extern "C" {
    pub fn find_vpid(nr: ffi::c_int) -> *mut pid;
}
extern "C" {
    pub fn find_get_pid(nr: ffi::c_int) -> *mut pid;
}
extern "C" {
    pub fn find_ge_pid(nr: ffi::c_int, arg1: *mut pid_namespace) -> *mut pid;
}
extern "C" {
    pub fn alloc_pid(ns: *mut pid_namespace, set_tid: *mut pid_t, set_tid_size: usize) -> *mut pid;
}
extern "C" {
    pub fn free_pid(pid: *mut pid);
}
extern "C" {
    pub fn free_pids(pids: *mut *mut pid);
}
extern "C" {
    pub fn disable_pid_allocation(ns: *mut pid_namespace);
}
extern "C" {
    pub fn pid_nr_ns(pid: *mut pid, ns: *mut pid_namespace) -> pid_t;
}
extern "C" {
    pub fn pid_vnr(pid: *mut pid) -> pid_t;
}
extern "C" {
    pub fn __task_pid_nr_ns(
        task: *mut task_struct,
        type_: pid_type,
        ns: *mut pid_namespace,
    ) -> pid_t;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct __user_cap_header_struct {
    pub version: __u32,
    pub pid: ffi::c_int,
}
pub type cap_user_header_t = *mut __user_cap_header_struct;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct __user_cap_data_struct {
    pub effective: __u32,
    pub permitted: __u32,
    pub inheritable: __u32,
}
pub type cap_user_data_t = *mut __user_cap_data_struct;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct vfs_cap_data {
    pub magic_etc: __le32,
    pub data: [vfs_cap_data__bindgen_ty_1; 2usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct vfs_cap_data__bindgen_ty_1 {
    pub permitted: __le32,
    pub inheritable: __le32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct vfs_ns_cap_data {
    pub magic_etc: __le32,
    pub data: [vfs_ns_cap_data__bindgen_ty_1; 2usize],
    pub rootid: __le32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct vfs_ns_cap_data__bindgen_ty_1 {
    pub permitted: __le32,
    pub inheritable: __le32,
}
extern "C" {
    pub static mut file_caps_enabled: ffi::c_int;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct kernel_cap_t {
    pub val: u64_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct cpu_vfs_cap_data {
    pub magic_etc: __u32,
    pub rootid: kuid_t,
    pub permitted: kernel_cap_t,
    pub inheritable: kernel_cap_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mnt_idmap {
    _unused: [u8; 0],
}
extern "C" {
    pub fn has_ns_capability(
        t: *mut task_struct,
        ns: *mut user_namespace,
        cap: ffi::c_int,
    ) -> bool_;
}
extern "C" {
    pub fn has_capability_noaudit(t: *mut task_struct, cap: ffi::c_int) -> bool_;
}
extern "C" {
    pub fn has_ns_capability_noaudit(
        t: *mut task_struct,
        ns: *mut user_namespace,
        cap: ffi::c_int,
    ) -> bool_;
}
extern "C" {
    pub fn capable(cap: ffi::c_int) -> bool_;
}
extern "C" {
    pub fn ns_capable(ns: *mut user_namespace, cap: ffi::c_int) -> bool_;
}
extern "C" {
    pub fn ns_capable_noaudit(ns: *mut user_namespace, cap: ffi::c_int) -> bool_;
}
extern "C" {
    pub fn ns_capable_setid(ns: *mut user_namespace, cap: ffi::c_int) -> bool_;
}
extern "C" {
    pub fn privileged_wrt_inode_uidgid(
        ns: *mut user_namespace,
        idmap: *mut mnt_idmap,
        inode: *const inode,
    ) -> bool_;
}
extern "C" {
    pub fn capable_wrt_inode_uidgid(
        idmap: *mut mnt_idmap,
        inode: *const inode,
        cap: ffi::c_int,
    ) -> bool_;
}
extern "C" {
    pub fn file_ns_capable(file: *const file, ns: *mut user_namespace, cap: ffi::c_int) -> bool_;
}
extern "C" {
    pub fn ptracer_capable(tsk: *mut task_struct, ns: *mut user_namespace) -> bool_;
}
extern "C" {
    pub fn get_vfs_caps_from_disk(
        idmap: *mut mnt_idmap,
        dentry: *const dentry,
        cpu_caps: *mut cpu_vfs_cap_data,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn cap_convert_nscap(
        idmap: *mut mnt_idmap,
        dentry: *mut dentry,
        ivalue: *mut *const ffi::c_void,
        size: usize,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct semaphore {
    pub lock: raw_spinlock_t,
    pub count: ffi::c_uint,
    pub wait_list: list_head,
}
impl Default for semaphore {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn down(sem: *mut semaphore);
}
extern "C" {
    #[must_use]
    pub fn down_interruptible(sem: *mut semaphore) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn down_killable(sem: *mut semaphore) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn down_trylock(sem: *mut semaphore) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn down_timeout(sem: *mut semaphore, jiffies: ffi::c_long) -> ffi::c_int;
}
extern "C" {
    pub fn up(sem: *mut semaphore);
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct f_owner_ex {
    pub type_: ffi::c_int,
    pub pid: __kernel_pid_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flock {
    pub l_type: ffi::c_short,
    pub l_whence: ffi::c_short,
    pub l_start: __kernel_off_t,
    pub l_len: __kernel_off_t,
    pub l_pid: __kernel_pid_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flock64 {
    pub l_type: ffi::c_short,
    pub l_whence: ffi::c_short,
    pub l_start: __kernel_loff_t,
    pub l_len: __kernel_loff_t,
    pub l_pid: __kernel_pid_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct open_how {
    pub flags: __u64,
    pub mode: __u64,
    pub resolve: __u64,
}
pub const migrate_mode_MIGRATE_ASYNC: migrate_mode = 0;
pub const migrate_mode_MIGRATE_SYNC_LIGHT: migrate_mode = 1;
pub const migrate_mode_MIGRATE_SYNC: migrate_mode = 2;
pub type migrate_mode = ffi::c_uint;
pub const migrate_reason_MR_COMPACTION: migrate_reason = 0;
pub const migrate_reason_MR_MEMORY_FAILURE: migrate_reason = 1;
pub const migrate_reason_MR_MEMORY_HOTPLUG: migrate_reason = 2;
pub const migrate_reason_MR_SYSCALL: migrate_reason = 3;
pub const migrate_reason_MR_MEMPOLICY_MBIND: migrate_reason = 4;
pub const migrate_reason_MR_NUMA_MISPLACED: migrate_reason = 5;
pub const migrate_reason_MR_CONTIG_RANGE: migrate_reason = 6;
pub const migrate_reason_MR_LONGTERM_PIN: migrate_reason = 7;
pub const migrate_reason_MR_DEMOTION: migrate_reason = 8;
pub const migrate_reason_MR_DAMON: migrate_reason = 9;
pub const migrate_reason_MR_TYPES: migrate_reason = 10;
pub type migrate_reason = ffi::c_uint;
extern "C" {
    pub static mut print_fatal_signals: ffi::c_int;
}
extern "C" {
    pub fn copy_siginfo_to_user(to: *mut siginfo_t, from: *const kernel_siginfo_t) -> ffi::c_int;
}
extern "C" {
    pub fn copy_siginfo_from_user(to: *mut kernel_siginfo_t, from: *const siginfo_t) -> ffi::c_int;
}
pub const siginfo_layout_SIL_KILL: siginfo_layout = 0;
pub const siginfo_layout_SIL_TIMER: siginfo_layout = 1;
pub const siginfo_layout_SIL_POLL: siginfo_layout = 2;
pub const siginfo_layout_SIL_FAULT: siginfo_layout = 3;
pub const siginfo_layout_SIL_FAULT_TRAPNO: siginfo_layout = 4;
pub const siginfo_layout_SIL_FAULT_MCEERR: siginfo_layout = 5;
pub const siginfo_layout_SIL_FAULT_BNDERR: siginfo_layout = 6;
pub const siginfo_layout_SIL_FAULT_PKUERR: siginfo_layout = 7;
pub const siginfo_layout_SIL_FAULT_PERF_EVENT: siginfo_layout = 8;
pub const siginfo_layout_SIL_CHLD: siginfo_layout = 9;
pub const siginfo_layout_SIL_RT: siginfo_layout = 10;
pub const siginfo_layout_SIL_SYS: siginfo_layout = 11;
pub type siginfo_layout = ffi::c_uint;
extern "C" {
    pub fn siginfo_layout(sig: ffi::c_uint, si_code: ffi::c_int) -> siginfo_layout;
}
extern "C" {
    pub fn flush_sigqueue(queue: *mut sigpending);
}
extern "C" {
    pub fn next_signal(pending: *mut sigpending, mask: *mut sigset_t) -> ffi::c_int;
}
extern "C" {
    pub fn do_send_sig_info(
        sig: ffi::c_int,
        info: *mut kernel_siginfo,
        p: *mut task_struct,
        type_: pid_type,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn group_send_sig_info(
        sig: ffi::c_int,
        info: *mut kernel_siginfo,
        p: *mut task_struct,
        type_: pid_type,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn send_signal_locked(
        sig: ffi::c_int,
        info: *mut kernel_siginfo,
        p: *mut task_struct,
        type_: pid_type,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sigprocmask(arg1: ffi::c_int, arg2: *mut sigset_t, arg3: *mut sigset_t) -> ffi::c_int;
}
extern "C" {
    pub fn set_current_blocked(arg1: *mut sigset_t);
}
extern "C" {
    pub fn __set_current_blocked(arg1: *const sigset_t);
}
extern "C" {
    pub static mut show_unhandled_signals: ffi::c_int;
}
extern "C" {
    pub fn get_signal(ksig: *mut ksignal) -> bool_;
}
extern "C" {
    pub fn signal_setup_done(failed: ffi::c_int, ksig: *mut ksignal, stepping: ffi::c_int);
}
extern "C" {
    pub fn exit_signals(tsk: *mut task_struct);
}
extern "C" {
    pub fn kernel_sigaction(arg1: ffi::c_int, arg2: __sighandler_t);
}
extern "C" {
    pub static mut sighand_cachep: *mut kmem_cache;
}
extern "C" {
    pub fn unhandled_signal(tsk: *mut task_struct, sig: ffi::c_int) -> bool_;
}
extern "C" {
    pub fn signals_init();
}
extern "C" {
    pub fn restore_altstack(arg1: *const stack_t) -> ffi::c_int;
}
extern "C" {
    pub fn __save_altstack(arg1: *mut stack_t, arg2: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn render_sigset_t(arg1: *mut seq_file, arg2: *const ffi::c_char, arg3: *mut sigset_t);
}
extern "C" {
    pub fn task_set_jobctl_pending(task: *mut task_struct, mask: ffi::c_ulong) -> bool_;
}
extern "C" {
    pub fn task_clear_jobctl_trapping(task: *mut task_struct);
}
extern "C" {
    pub fn task_clear_jobctl_pending(task: *mut task_struct, mask: ffi::c_ulong);
}
extern "C" {
    pub fn arch_prctl_spec_ctrl_get(task: *mut task_struct, which: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn arch_prctl_spec_ctrl_set(
        task: *mut task_struct,
        which: ffi::c_ulong,
        ctrl: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn arch_seccomp_spec_mitigate(task: *mut task_struct);
}
extern "C" {
    pub fn __check_object_size(ptr: *const ffi::c_void, n: ffi::c_ulong, to_user: bool_);
}
extern "C" {
    pub static mut validate_usercopy_range: static_key_true;
}
extern "C" {
    pub fn __bad_copy_from();
}
extern "C" {
    pub fn __bad_copy_to();
}
extern "C" {
    pub fn __copy_overflow(size: ffi::c_int, count: ffi::c_ulong);
}
extern "C" {
    pub fn mte_clear_page_tags(addr: *mut ffi::c_void);
}
extern "C" {
    pub fn mte_copy_tags_from_user(
        to: *mut ffi::c_void,
        from: *const ffi::c_void,
        n: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn mte_copy_tags_to_user(
        to: *mut ffi::c_void,
        from: *mut ffi::c_void,
        n: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn mte_save_tags(page: *mut page) -> ffi::c_int;
}
extern "C" {
    pub fn mte_save_page_tags(page_addr: *const ffi::c_void, tag_storage: *mut ffi::c_void);
}
extern "C" {
    pub fn mte_restore_tags(entry: swp_entry_t, page: *mut page);
}
extern "C" {
    pub fn mte_restore_page_tags(page_addr: *mut ffi::c_void, tag_storage: *const ffi::c_void);
}
extern "C" {
    pub fn mte_invalidate_tags(type_: ffi::c_int, offset: ffi::c_ulong);
}
extern "C" {
    pub fn mte_invalidate_tags_area(type_: ffi::c_int);
}
extern "C" {
    pub fn mte_allocate_tag_storage() -> *mut ffi::c_void;
}
extern "C" {
    pub fn mte_free_tag_storage(storage: *mut ffi::c_char);
}
extern "C" {
    pub fn mte_zero_clear_page_tags(addr: *mut ffi::c_void);
}
extern "C" {
    pub fn mte_sync_tags(pte: pte_t, nr_pages: ffi::c_uint);
}
extern "C" {
    pub fn mte_copy_page_tags(kto: *mut ffi::c_void, kfrom: *const ffi::c_void);
}
extern "C" {
    pub fn mte_thread_init_user();
}
extern "C" {
    pub fn mte_thread_switch(next: *mut task_struct);
}
extern "C" {
    pub fn mte_cpu_setup();
}
extern "C" {
    pub fn mte_suspend_enter();
}
extern "C" {
    pub fn mte_suspend_exit();
}
extern "C" {
    pub fn set_mte_ctrl(task: *mut task_struct, arg: ffi::c_ulong) -> ffi::c_long;
}
extern "C" {
    pub fn get_mte_ctrl(task: *mut task_struct) -> ffi::c_long;
}
extern "C" {
    pub fn mte_ptrace_copy_tags(
        child: *mut task_struct,
        request: ffi::c_long,
        addr: ffi::c_ulong,
        data: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mte_probe_user_range(uaddr: *const ffi::c_char, size: usize) -> usize;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct exception_table_entry {
    pub insn: ffi::c_int,
    pub fixup: ffi::c_int,
    pub type_: ffi::c_short,
    pub data: ffi::c_short,
}
extern "C" {
    pub fn insn_may_access_user(addr: ffi::c_ulong, esr: ffi::c_ulong) -> bool_;
}
extern "C" {
    pub fn ex_handler_bpf(ex: *const exception_table_entry, regs: *mut pt_regs) -> bool_;
}
extern "C" {
    pub fn fixup_exception(regs: *mut pt_regs, esr: ffi::c_ulong) -> bool_;
}
extern "C" {
    #[must_use]
    pub fn __arch_copy_from_user(
        to: *mut ffi::c_void,
        from: *const ffi::c_void,
        n: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    #[must_use]
    pub fn __arch_copy_to_user(
        to: *mut ffi::c_void,
        from: *const ffi::c_void,
        n: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    #[must_use]
    pub fn __arch_clear_user(to: *mut ffi::c_void, n: ffi::c_ulong) -> ffi::c_ulong;
}
extern "C" {
    pub fn strncpy_from_user(
        dest: *mut ffi::c_char,
        src: *const ffi::c_char,
        count: ffi::c_long,
    ) -> ffi::c_long;
}
extern "C" {
    #[must_use]
    pub fn strnlen_user(str_: *const ffi::c_char, n: ffi::c_long) -> ffi::c_long;
}
extern "C" {
    #[must_use]
    pub fn __copy_user_flushcache(
        to: *mut ffi::c_void,
        from: *const ffi::c_void,
        n: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    #[must_use]
    pub fn _copy_from_user(
        arg1: *mut ffi::c_void,
        arg2: *const ffi::c_void,
        arg3: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    #[must_use]
    pub fn _copy_to_user(
        arg1: *mut ffi::c_void,
        arg2: *const ffi::c_void,
        arg3: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    #[must_use]
    pub fn check_zeroed_user(from: *const ffi::c_void, size: usize) -> ffi::c_int;
}
extern "C" {
    pub fn copy_from_kernel_nofault_allowed(unsafe_src: *const ffi::c_void, size: usize) -> bool_;
}
extern "C" {
    pub fn copy_from_kernel_nofault(
        dst: *mut ffi::c_void,
        src: *const ffi::c_void,
        size: usize,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn copy_to_kernel_nofault(
        dst: *mut ffi::c_void,
        src: *const ffi::c_void,
        size: usize,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn copy_from_user_nofault(
        dst: *mut ffi::c_void,
        src: *const ffi::c_void,
        size: usize,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn copy_to_user_nofault(
        dst: *mut ffi::c_void,
        src: *const ffi::c_void,
        size: usize,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn strncpy_from_kernel_nofault(
        dst: *mut ffi::c_char,
        unsafe_addr: *const ffi::c_void,
        count: ffi::c_long,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn strncpy_from_user_nofault(
        dst: *mut ffi::c_char,
        unsafe_addr: *const ffi::c_void,
        count: ffi::c_long,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn strnlen_user_nofault(unsafe_addr: *const ffi::c_void, count: ffi::c_long)
        -> ffi::c_long;
}
extern "C" {
    pub fn usercopy_abort(
        name: *const ffi::c_char,
        detail: *const ffi::c_char,
        to_user: bool_,
        offset: ffi::c_ulong,
        len: ffi::c_ulong,
    ) -> !;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kernel_clone_args {
    pub flags: u64_,
    pub pidfd: *mut ffi::c_int,
    pub child_tid: *mut ffi::c_int,
    pub parent_tid: *mut ffi::c_int,
    pub name: *const ffi::c_char,
    pub exit_signal: ffi::c_int,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub stack: ffi::c_ulong,
    pub stack_size: ffi::c_ulong,
    pub tls: ffi::c_ulong,
    pub set_tid: *mut pid_t,
    pub set_tid_size: usize,
    pub cgroup: ffi::c_int,
    pub idle: ffi::c_int,
    pub fn_: ::core::option::Option<unsafe extern "C" fn(arg1: *mut ffi::c_void) -> ffi::c_int>,
    pub fn_arg: *mut ffi::c_void,
    pub cgrp: *mut cgroup,
    pub cset: *mut css_set,
    pub kill_seq: ffi::c_uint,
}
impl Default for kernel_clone_args {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl kernel_clone_args {
    #[inline]
    pub fn kthread(&self) -> u32_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_kthread(&mut self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn kthread_raw(this: *const Self) -> u32_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_kthread_raw(this: *mut Self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn io_thread(&self) -> u32_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_io_thread(&mut self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn io_thread_raw(this: *const Self) -> u32_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_io_thread_raw(this: *mut Self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn user_worker(&self) -> u32_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_user_worker(&mut self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn user_worker_raw(this: *const Self) -> u32_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_user_worker_raw(this: *mut Self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn no_files(&self) -> u32_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_no_files(&mut self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn no_files_raw(this: *const Self) -> u32_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_no_files_raw(this: *mut Self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        kthread: u32_,
        io_thread: u32_,
        user_worker: u32_,
        no_files: u32_,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let kthread: u32 = unsafe { ::core::mem::transmute(kthread) };
            kthread as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let io_thread: u32 = unsafe { ::core::mem::transmute(io_thread) };
            io_thread as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let user_worker: u32 = unsafe { ::core::mem::transmute(user_worker) };
            user_worker as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let no_files: u32 = unsafe { ::core::mem::transmute(no_files) };
            no_files as u64
        });
        __bindgen_bitfield_unit
    }
}
extern "C" {
    pub static mut tasklist_lock: rwlock_t;
}
extern "C" {
    pub static mut mmlist_lock: spinlock_t;
}
extern "C" {
    pub static mut init_thread_union: thread_union;
}
extern "C" {
    pub static mut init_task: task_struct;
}
extern "C" {
    pub fn lockdep_tasklist_lock_is_held() -> ffi::c_int;
}
extern "C" {
    pub fn schedule_tail(prev: *mut task_struct);
}
extern "C" {
    pub fn init_idle(idle: *mut task_struct, cpu: ffi::c_int);
}
extern "C" {
    pub fn sched_fork(clone_flags: ffi::c_ulong, p: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn sched_cgroup_fork(p: *mut task_struct, kargs: *mut kernel_clone_args) -> ffi::c_int;
}
extern "C" {
    pub fn sched_cancel_fork(p: *mut task_struct);
}
extern "C" {
    pub fn sched_post_fork(p: *mut task_struct);
}
extern "C" {
    pub fn sched_dead(p: *mut task_struct);
}
extern "C" {
    pub fn do_task_dead() -> !;
}
extern "C" {
    pub fn make_task_dead(signr: ffi::c_int) -> !;
}
extern "C" {
    pub fn mm_cache_init();
}
extern "C" {
    pub fn proc_caches_init();
}
extern "C" {
    pub fn fork_init();
}
extern "C" {
    pub fn release_task(p: *mut task_struct);
}
extern "C" {
    pub fn copy_thread(arg1: *mut task_struct, arg2: *const kernel_clone_args) -> ffi::c_int;
}
extern "C" {
    pub fn flush_thread();
}
extern "C" {
    pub fn do_group_exit(arg1: ffi::c_int) -> !;
}
extern "C" {
    pub fn exit_files(arg1: *mut task_struct);
}
extern "C" {
    pub fn exit_itimers(arg1: *mut task_struct);
}
extern "C" {
    pub fn kernel_clone(kargs: *mut kernel_clone_args) -> pid_t;
}
extern "C" {
    pub fn copy_process(
        pid: *mut pid,
        trace: ffi::c_int,
        node: ffi::c_int,
        args: *mut kernel_clone_args,
    ) -> *mut task_struct;
}
extern "C" {
    pub fn create_io_thread(
        fn_: ::core::option::Option<unsafe extern "C" fn(arg1: *mut ffi::c_void) -> ffi::c_int>,
        arg: *mut ffi::c_void,
        node: ffi::c_int,
    ) -> *mut task_struct;
}
extern "C" {
    pub fn fork_idle(arg1: ffi::c_int) -> *mut task_struct;
}
extern "C" {
    pub fn kernel_thread(
        fn_: ::core::option::Option<unsafe extern "C" fn(arg1: *mut ffi::c_void) -> ffi::c_int>,
        arg: *mut ffi::c_void,
        name: *const ffi::c_char,
        flags: ffi::c_ulong,
    ) -> pid_t;
}
extern "C" {
    pub fn user_mode_thread(
        fn_: ::core::option::Option<unsafe extern "C" fn(arg1: *mut ffi::c_void) -> ffi::c_int>,
        arg: *mut ffi::c_void,
        flags: ffi::c_ulong,
    ) -> pid_t;
}
extern "C" {
    pub fn kernel_wait4(
        arg1: pid_t,
        arg2: *mut ffi::c_int,
        arg3: ffi::c_int,
        arg4: *mut rusage,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn kernel_wait(pid: pid_t, stat: *mut ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn free_task(tsk: *mut task_struct);
}
extern "C" {
    pub fn sched_exec();
}
extern "C" {
    pub fn __put_task_struct(t: *mut task_struct);
}
extern "C" {
    pub fn __put_task_struct_rcu_cb(rhp: *mut callback_head);
}
extern "C" {
    pub fn put_task_struct_rcu_user(task: *mut task_struct);
}
extern "C" {
    pub fn release_thread(dead_task: *mut task_struct);
}
pub type class_task_lock_t = *mut task_struct;
pub const class_task_lock_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct assoc_array {
    pub root: *mut assoc_array_ptr,
    pub nr_leaves_on_tree: ffi::c_ulong,
}
impl Default for assoc_array {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct assoc_array_ops {
    pub get_key_chunk: ::core::option::Option<
        unsafe extern "C" fn(index_key: *const ffi::c_void, level: ffi::c_int) -> ffi::c_ulong,
    >,
    pub get_object_key_chunk: ::core::option::Option<
        unsafe extern "C" fn(object: *const ffi::c_void, level: ffi::c_int) -> ffi::c_ulong,
    >,
    pub compare_object: ::core::option::Option<
        unsafe extern "C" fn(object: *const ffi::c_void, index_key: *const ffi::c_void) -> bool_,
    >,
    pub diff_objects: ::core::option::Option<
        unsafe extern "C" fn(
            object: *const ffi::c_void,
            index_key: *const ffi::c_void,
        ) -> ffi::c_int,
    >,
    pub free_object: ::core::option::Option<unsafe extern "C" fn(object: *mut ffi::c_void)>,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct assoc_array_edit {
    _unused: [u8; 0],
}
extern "C" {
    pub fn assoc_array_iterate(
        array: *const assoc_array,
        iterator: ::core::option::Option<
            unsafe extern "C" fn(
                object: *const ffi::c_void,
                iterator_data: *mut ffi::c_void,
            ) -> ffi::c_int,
        >,
        iterator_data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn assoc_array_find(
        array: *const assoc_array,
        ops: *const assoc_array_ops,
        index_key: *const ffi::c_void,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn assoc_array_destroy(array: *mut assoc_array, ops: *const assoc_array_ops);
}
extern "C" {
    pub fn assoc_array_insert(
        array: *mut assoc_array,
        ops: *const assoc_array_ops,
        index_key: *const ffi::c_void,
        object: *mut ffi::c_void,
    ) -> *mut assoc_array_edit;
}
extern "C" {
    pub fn assoc_array_insert_set_object(edit: *mut assoc_array_edit, object: *mut ffi::c_void);
}
extern "C" {
    pub fn assoc_array_delete(
        array: *mut assoc_array,
        ops: *const assoc_array_ops,
        index_key: *const ffi::c_void,
    ) -> *mut assoc_array_edit;
}
extern "C" {
    pub fn assoc_array_clear(
        array: *mut assoc_array,
        ops: *const assoc_array_ops,
    ) -> *mut assoc_array_edit;
}
extern "C" {
    pub fn assoc_array_apply_edit(edit: *mut assoc_array_edit);
}
extern "C" {
    pub fn assoc_array_cancel_edit(edit: *mut assoc_array_edit);
}
extern "C" {
    pub fn assoc_array_gc(
        array: *mut assoc_array,
        ops: *const assoc_array_ops,
        iterator: ::core::option::Option<
            unsafe extern "C" fn(
                object: *mut ffi::c_void,
                iterator_data: *mut ffi::c_void,
            ) -> bool_,
        >,
        iterator_data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
pub type key_serial_t = i32;
pub type key_perm_t = u32;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct net {
    _unused: [u8; 0],
}
pub const key_need_perm_KEY_NEED_UNSPECIFIED: key_need_perm = 0;
pub const key_need_perm_KEY_NEED_VIEW: key_need_perm = 1;
pub const key_need_perm_KEY_NEED_READ: key_need_perm = 2;
pub const key_need_perm_KEY_NEED_WRITE: key_need_perm = 3;
pub const key_need_perm_KEY_NEED_SEARCH: key_need_perm = 4;
pub const key_need_perm_KEY_NEED_LINK: key_need_perm = 5;
pub const key_need_perm_KEY_NEED_SETATTR: key_need_perm = 6;
pub const key_need_perm_KEY_NEED_UNLINK: key_need_perm = 7;
pub const key_need_perm_KEY_SYSADMIN_OVERRIDE: key_need_perm = 8;
pub const key_need_perm_KEY_AUTHTOKEN_OVERRIDE: key_need_perm = 9;
pub const key_need_perm_KEY_DEFER_PERM_CHECK: key_need_perm = 10;
pub type key_need_perm = ffi::c_uint;
pub const key_lookup_flag_KEY_LOOKUP_CREATE: key_lookup_flag = 1;
pub const key_lookup_flag_KEY_LOOKUP_PARTIAL: key_lookup_flag = 2;
pub const key_lookup_flag_KEY_LOOKUP_ALL: key_lookup_flag = 3;
pub type key_lookup_flag = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct key_type {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct key_owner {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct keyring_list {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct keyring_name {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct key_tag {
    pub rcu: callback_head,
    pub usage: refcount_t,
    pub removed: bool_,
}
impl Default for key_tag {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct keyring_index_key {
    pub hash: ffi::c_ulong,
    pub __bindgen_anon_1: keyring_index_key__bindgen_ty_1,
    pub type_: *mut key_type,
    pub domain_tag: *mut key_tag,
    pub description: *const ffi::c_char,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union keyring_index_key__bindgen_ty_1 {
    pub __bindgen_anon_1: keyring_index_key__bindgen_ty_1__bindgen_ty_1,
    pub x: ffi::c_ulong,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct keyring_index_key__bindgen_ty_1__bindgen_ty_1 {
    pub desc_len: u16_,
    pub desc: [ffi::c_char; 6usize],
}
impl Default for keyring_index_key__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for keyring_index_key {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union key_payload {
    pub rcu_data0: *mut ffi::c_void,
    pub data: [*mut ffi::c_void; 4usize],
}
impl Default for key_payload {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct __key_reference_with_attributes {
    _unused: [u8; 0],
}
pub type key_ref_t = *mut __key_reference_with_attributes;
pub type key_restrict_link_func_t = ::core::option::Option<
    unsafe extern "C" fn(
        dest_keyring: *mut key,
        type_: *const key_type,
        payload: *const key_payload,
        restriction_key: *mut key,
    ) -> ffi::c_int,
>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct key_restriction {
    pub check: key_restrict_link_func_t,
    pub key: *mut key,
    pub keytype: *mut key_type,
}
impl Default for key_restriction {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const key_state_KEY_IS_UNINSTANTIATED: key_state = 0;
pub const key_state_KEY_IS_POSITIVE: key_state = 1;
pub type key_state = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct key {
    pub usage: refcount_t,
    pub serial: key_serial_t,
    pub __bindgen_anon_1: key__bindgen_ty_1,
    pub watchers: *mut watch_list,
    pub sem: rw_semaphore,
    pub user: *mut key_user,
    pub security: *mut ffi::c_void,
    pub __bindgen_anon_2: key__bindgen_ty_2,
    pub last_used_at: time64_t,
    pub uid: kuid_t,
    pub gid: kgid_t,
    pub perm: key_perm_t,
    pub quotalen: ffi::c_ushort,
    pub datalen: ffi::c_ushort,
    pub state: ffi::c_short,
    pub flags: ffi::c_ulong,
    pub __bindgen_anon_3: key__bindgen_ty_3,
    pub __bindgen_anon_4: key__bindgen_ty_4,
    pub restrict_link: *mut key_restriction,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union key__bindgen_ty_1 {
    pub graveyard_link: list_head,
    pub serial_node: rb_node,
}
impl Default for key__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union key__bindgen_ty_2 {
    pub expiry: time64_t,
    pub revoked_at: time64_t,
}
impl Default for key__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union key__bindgen_ty_3 {
    pub index_key: keyring_index_key,
    pub __bindgen_anon_1: key__bindgen_ty_3__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct key__bindgen_ty_3__bindgen_ty_1 {
    pub hash: ffi::c_ulong,
    pub len_desc: ffi::c_ulong,
    pub type_: *mut key_type,
    pub domain_tag: *mut key_tag,
    pub description: *mut ffi::c_char,
}
impl Default for key__bindgen_ty_3__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for key__bindgen_ty_3 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union key__bindgen_ty_4 {
    pub payload: key_payload,
    pub __bindgen_anon_1: key__bindgen_ty_4__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct key__bindgen_ty_4__bindgen_ty_1 {
    pub name_link: list_head,
    pub keys: assoc_array,
}
impl Default for key__bindgen_ty_4__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for key__bindgen_ty_4 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for key {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn key_alloc(
        type_: *mut key_type,
        desc: *const ffi::c_char,
        uid: kuid_t,
        gid: kgid_t,
        cred: *const cred,
        perm: key_perm_t,
        flags: ffi::c_ulong,
        restrict_link: *mut key_restriction,
    ) -> *mut key;
}
extern "C" {
    pub fn key_revoke(key: *mut key);
}
extern "C" {
    pub fn key_invalidate(key: *mut key);
}
extern "C" {
    pub fn key_put(key: *mut key);
}
extern "C" {
    pub fn key_put_tag(tag: *mut key_tag) -> bool_;
}
extern "C" {
    pub fn key_remove_domain(domain_tag: *mut key_tag);
}
extern "C" {
    pub fn request_key_tag(
        type_: *mut key_type,
        description: *const ffi::c_char,
        domain_tag: *mut key_tag,
        callout_info: *const ffi::c_char,
    ) -> *mut key;
}
extern "C" {
    pub fn request_key_rcu(
        type_: *mut key_type,
        description: *const ffi::c_char,
        domain_tag: *mut key_tag,
    ) -> *mut key;
}
extern "C" {
    pub fn request_key_with_auxdata(
        type_: *mut key_type,
        description: *const ffi::c_char,
        domain_tag: *mut key_tag,
        callout_info: *const ffi::c_void,
        callout_len: usize,
        aux: *mut ffi::c_void,
    ) -> *mut key;
}
extern "C" {
    pub fn wait_for_key_construction(key: *mut key, intr: bool_) -> ffi::c_int;
}
extern "C" {
    pub fn key_validate(key: *const key) -> ffi::c_int;
}
extern "C" {
    pub fn key_create(
        keyring: key_ref_t,
        type_: *const ffi::c_char,
        description: *const ffi::c_char,
        payload: *const ffi::c_void,
        plen: usize,
        perm: key_perm_t,
        flags: ffi::c_ulong,
    ) -> key_ref_t;
}
extern "C" {
    pub fn key_create_or_update(
        keyring: key_ref_t,
        type_: *const ffi::c_char,
        description: *const ffi::c_char,
        payload: *const ffi::c_void,
        plen: usize,
        perm: key_perm_t,
        flags: ffi::c_ulong,
    ) -> key_ref_t;
}
extern "C" {
    pub fn key_update(key: key_ref_t, payload: *const ffi::c_void, plen: usize) -> ffi::c_int;
}
extern "C" {
    pub fn key_link(keyring: *mut key, key: *mut key) -> ffi::c_int;
}
extern "C" {
    pub fn key_move(
        key: *mut key,
        from_keyring: *mut key,
        to_keyring: *mut key,
        flags: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn key_unlink(keyring: *mut key, key: *mut key) -> ffi::c_int;
}
extern "C" {
    pub fn keyring_alloc(
        description: *const ffi::c_char,
        uid: kuid_t,
        gid: kgid_t,
        cred: *const cred,
        perm: key_perm_t,
        flags: ffi::c_ulong,
        restrict_link: *mut key_restriction,
        dest: *mut key,
    ) -> *mut key;
}
extern "C" {
    pub fn restrict_link_reject(
        keyring: *mut key,
        type_: *const key_type,
        payload: *const key_payload,
        restriction_key: *mut key,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn keyring_clear(keyring: *mut key) -> ffi::c_int;
}
extern "C" {
    pub fn keyring_search(
        keyring: key_ref_t,
        type_: *mut key_type,
        description: *const ffi::c_char,
        recurse: bool_,
    ) -> key_ref_t;
}
extern "C" {
    pub fn keyring_restrict(
        keyring: key_ref_t,
        type_: *const ffi::c_char,
        restriction: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn key_lookup(id: key_serial_t) -> *mut key;
}
extern "C" {
    pub fn key_set_timeout(arg1: *mut key, arg2: ffi::c_uint);
}
extern "C" {
    pub fn lookup_user_key(
        id: key_serial_t,
        flags: ffi::c_ulong,
        need_perm: key_need_perm,
    ) -> key_ref_t;
}
extern "C" {
    pub fn key_free_user_ns(arg1: *mut user_namespace);
}
extern "C" {
    pub fn install_thread_keyring_to_cred(cred: *mut cred) -> ffi::c_int;
}
extern "C" {
    pub fn key_fsuid_changed(new_cred: *mut cred);
}
extern "C" {
    pub fn key_fsgid_changed(new_cred: *mut cred);
}
extern "C" {
    pub fn key_init();
}
extern "C" {
    pub static mut printk_ratelimit_state: ratelimit_state;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct user_struct {
    pub __count: refcount_t,
    pub epoll_watches: percpu_counter,
    pub unix_inflight: ffi::c_ulong,
    pub pipe_bufs: atomic_long_t,
    pub uidhash_node: hlist_node,
    pub uid: kuid_t,
    pub locked_vm: atomic_long_t,
    pub nr_watches: atomic_t,
    pub ratelimit: ratelimit_state,
}
impl Default for user_struct {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn uids_sysfs_init() -> ffi::c_int;
}
extern "C" {
    pub fn find_user(arg1: kuid_t) -> *mut user_struct;
}
extern "C" {
    pub static mut root_user: user_struct;
}
extern "C" {
    pub fn alloc_uid(arg1: kuid_t) -> *mut user_struct;
}
extern "C" {
    pub fn free_uid(arg1: *mut user_struct);
}
#[repr(C)]
#[derive(Default)]
pub struct group_info {
    pub usage: refcount_t,
    pub ngroups: ffi::c_int,
    pub gid: __IncompleteArrayField<kgid_t>,
}
extern "C" {
    pub fn groups_alloc(arg1: ffi::c_int) -> *mut group_info;
}
extern "C" {
    pub fn groups_free(arg1: *mut group_info);
}
extern "C" {
    pub fn in_group_p(arg1: kgid_t) -> ffi::c_int;
}
extern "C" {
    pub fn in_egroup_p(arg1: kgid_t) -> ffi::c_int;
}
extern "C" {
    pub fn groups_search(arg1: *const group_info, arg2: kgid_t) -> ffi::c_int;
}
extern "C" {
    pub fn set_current_groups(arg1: *mut group_info) -> ffi::c_int;
}
extern "C" {
    pub fn set_groups(arg1: *mut cred, arg2: *mut group_info);
}
extern "C" {
    pub fn may_setgroups() -> bool_;
}
extern "C" {
    pub fn groups_sort(arg1: *mut group_info);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct cred {
    pub usage: atomic_long_t,
    pub uid: kuid_t,
    pub gid: kgid_t,
    pub suid: kuid_t,
    pub sgid: kgid_t,
    pub euid: kuid_t,
    pub egid: kgid_t,
    pub fsuid: kuid_t,
    pub fsgid: kgid_t,
    pub securebits: ffi::c_uint,
    pub cap_inheritable: kernel_cap_t,
    pub cap_permitted: kernel_cap_t,
    pub cap_effective: kernel_cap_t,
    pub cap_bset: kernel_cap_t,
    pub cap_ambient: kernel_cap_t,
    pub jit_keyring: ffi::c_uchar,
    pub session_keyring: *mut key,
    pub process_keyring: *mut key,
    pub thread_keyring: *mut key,
    pub request_key_auth: *mut key,
    pub security: *mut ffi::c_void,
    pub user: *mut user_struct,
    pub user_ns: *mut user_namespace,
    pub ucounts: *mut ucounts,
    pub group_info: *mut group_info,
    pub __bindgen_anon_1: cred__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union cred__bindgen_ty_1 {
    pub non_rcu: ffi::c_int,
    pub rcu: callback_head,
}
impl Default for cred__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for cred {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn __put_cred(arg1: *mut cred);
}
extern "C" {
    pub fn exit_creds(arg1: *mut task_struct);
}
extern "C" {
    pub fn copy_creds(arg1: *mut task_struct, arg2: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn get_task_cred(arg1: *mut task_struct) -> *const cred;
}
extern "C" {
    pub fn cred_alloc_blank() -> *mut cred;
}
extern "C" {
    pub fn prepare_creds() -> *mut cred;
}
extern "C" {
    pub fn prepare_exec_creds() -> *mut cred;
}
extern "C" {
    pub fn commit_creds(arg1: *mut cred) -> ffi::c_int;
}
extern "C" {
    pub fn abort_creds(arg1: *mut cred);
}
extern "C" {
    pub fn prepare_kernel_cred(arg1: *mut task_struct) -> *mut cred;
}
extern "C" {
    pub fn set_security_override(arg1: *mut cred, arg2: u32_) -> ffi::c_int;
}
extern "C" {
    pub fn set_security_override_from_ctx(arg1: *mut cred, arg2: *const ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub fn set_create_files_as(arg1: *mut cred, arg2: *mut inode) -> ffi::c_int;
}
extern "C" {
    pub fn cred_fscmp(arg1: *const cred, arg2: *const cred) -> ffi::c_int;
}
extern "C" {
    pub fn cred_init();
}
extern "C" {
    pub fn set_cred_ucounts(arg1: *mut cred) -> ffi::c_int;
}
extern "C" {
    pub fn timerqueue_add(head: *mut timerqueue_head, node: *mut timerqueue_node) -> bool_;
}
extern "C" {
    pub fn timerqueue_del(head: *mut timerqueue_head, node: *mut timerqueue_node) -> bool_;
}
extern "C" {
    pub fn timerqueue_iterate_next(node: *mut timerqueue_node) -> *mut timerqueue_node;
}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct hrtimer_clock_base {
    pub cpu_base: *mut hrtimer_cpu_base,
    pub index: ffi::c_uint,
    pub clockid: clockid_t,
    pub seq: seqcount_raw_spinlock_t,
    pub running: *mut hrtimer,
    pub active: timerqueue_head,
    pub get_time: ::core::option::Option<unsafe extern "C" fn() -> ktime_t>,
    pub offset: ktime_t,
}
impl Default for hrtimer_clock_base {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const hrtimer_base_type_HRTIMER_BASE_MONOTONIC: hrtimer_base_type = 0;
pub const hrtimer_base_type_HRTIMER_BASE_REALTIME: hrtimer_base_type = 1;
pub const hrtimer_base_type_HRTIMER_BASE_BOOTTIME: hrtimer_base_type = 2;
pub const hrtimer_base_type_HRTIMER_BASE_TAI: hrtimer_base_type = 3;
pub const hrtimer_base_type_HRTIMER_BASE_MONOTONIC_SOFT: hrtimer_base_type = 4;
pub const hrtimer_base_type_HRTIMER_BASE_REALTIME_SOFT: hrtimer_base_type = 5;
pub const hrtimer_base_type_HRTIMER_BASE_BOOTTIME_SOFT: hrtimer_base_type = 6;
pub const hrtimer_base_type_HRTIMER_BASE_TAI_SOFT: hrtimer_base_type = 7;
pub const hrtimer_base_type_HRTIMER_MAX_CLOCK_BASES: hrtimer_base_type = 8;
pub type hrtimer_base_type = ffi::c_uint;
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct hrtimer_cpu_base {
    pub lock: raw_spinlock_t,
    pub cpu: ffi::c_uint,
    pub active_bases: ffi::c_uint,
    pub clock_was_set_seq: ffi::c_uint,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub nr_events: ffi::c_uint,
    pub nr_retries: ffi::c_ushort,
    pub nr_hangs: ffi::c_ushort,
    pub max_hang_time: ffi::c_uint,
    pub expires_next: ktime_t,
    pub next_timer: *mut hrtimer,
    pub softirq_expires_next: ktime_t,
    pub softirq_next_timer: *mut hrtimer,
    pub clock_base: [hrtimer_clock_base; 8usize],
    pub csd: call_single_data_t,
}
impl Default for hrtimer_cpu_base {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl hrtimer_cpu_base {
    #[inline]
    pub fn hres_active(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_hres_active(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn hres_active_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_hres_active_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn in_hrtirq(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_in_hrtirq(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn in_hrtirq_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_in_hrtirq_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn hang_detected(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_hang_detected(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn hang_detected_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_hang_detected_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn softirq_activated(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_softirq_activated(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn softirq_activated_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_softirq_activated_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn online(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_online(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn online_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_online_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        hres_active: ffi::c_uint,
        in_hrtirq: ffi::c_uint,
        hang_detected: ffi::c_uint,
        softirq_activated: ffi::c_uint,
        online: ffi::c_uint,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let hres_active: u32 = unsafe { ::core::mem::transmute(hres_active) };
            hres_active as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let in_hrtirq: u32 = unsafe { ::core::mem::transmute(in_hrtirq) };
            in_hrtirq as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let hang_detected: u32 = unsafe { ::core::mem::transmute(hang_detected) };
            hang_detected as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let softirq_activated: u32 = unsafe { ::core::mem::transmute(softirq_activated) };
            softirq_activated as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let online: u32 = unsafe { ::core::mem::transmute(online) };
            online as u64
        });
        __bindgen_bitfield_unit
    }
}
pub const hrtimer_mode_HRTIMER_MODE_ABS: hrtimer_mode = 0;
pub const hrtimer_mode_HRTIMER_MODE_REL: hrtimer_mode = 1;
pub const hrtimer_mode_HRTIMER_MODE_PINNED: hrtimer_mode = 2;
pub const hrtimer_mode_HRTIMER_MODE_SOFT: hrtimer_mode = 4;
pub const hrtimer_mode_HRTIMER_MODE_HARD: hrtimer_mode = 8;
pub const hrtimer_mode_HRTIMER_MODE_ABS_PINNED: hrtimer_mode = 2;
pub const hrtimer_mode_HRTIMER_MODE_REL_PINNED: hrtimer_mode = 3;
pub const hrtimer_mode_HRTIMER_MODE_ABS_SOFT: hrtimer_mode = 4;
pub const hrtimer_mode_HRTIMER_MODE_REL_SOFT: hrtimer_mode = 5;
pub const hrtimer_mode_HRTIMER_MODE_ABS_PINNED_SOFT: hrtimer_mode = 6;
pub const hrtimer_mode_HRTIMER_MODE_REL_PINNED_SOFT: hrtimer_mode = 7;
pub const hrtimer_mode_HRTIMER_MODE_ABS_HARD: hrtimer_mode = 8;
pub const hrtimer_mode_HRTIMER_MODE_REL_HARD: hrtimer_mode = 9;
pub const hrtimer_mode_HRTIMER_MODE_ABS_PINNED_HARD: hrtimer_mode = 10;
pub const hrtimer_mode_HRTIMER_MODE_REL_PINNED_HARD: hrtimer_mode = 11;
pub type hrtimer_mode = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct hrtimer_sleeper {
    pub timer: hrtimer,
    pub task: *mut task_struct,
}
impl Default for hrtimer_sleeper {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn hrtimer_interrupt(dev: *mut clock_event_device);
}
extern "C" {
    pub static mut hrtimer_resolution: ffi::c_uint;
}
extern "C" {
    pub fn timerfd_clock_was_set();
}
extern "C" {
    pub fn timerfd_resume();
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tick_device {
    _unused: [u8; 0],
}
extern "C" {
    pub static mut tick_cpu_device: tick_device;
}
extern "C" {
    pub fn hrtimer_setup(
        timer: *mut hrtimer,
        function: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut hrtimer) -> hrtimer_restart,
        >,
        clock_id: clockid_t,
        mode: hrtimer_mode,
    );
}
extern "C" {
    pub fn hrtimer_setup_on_stack(
        timer: *mut hrtimer,
        function: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut hrtimer) -> hrtimer_restart,
        >,
        clock_id: clockid_t,
        mode: hrtimer_mode,
    );
}
extern "C" {
    pub fn hrtimer_setup_sleeper_on_stack(
        sl: *mut hrtimer_sleeper,
        clock_id: clockid_t,
        mode: hrtimer_mode,
    );
}
extern "C" {
    pub fn hrtimer_start_range_ns(
        timer: *mut hrtimer,
        tim: ktime_t,
        range_ns: u64_,
        mode: hrtimer_mode,
    );
}
extern "C" {
    pub fn hrtimer_cancel(timer: *mut hrtimer) -> ffi::c_int;
}
extern "C" {
    pub fn hrtimer_try_to_cancel(timer: *mut hrtimer) -> ffi::c_int;
}
extern "C" {
    pub fn hrtimer_sleeper_start_expires(sl: *mut hrtimer_sleeper, mode: hrtimer_mode);
}
extern "C" {
    pub fn __hrtimer_get_remaining(timer: *const hrtimer, adjust: bool_) -> ktime_t;
}
extern "C" {
    pub fn hrtimer_get_next_event() -> u64_;
}
extern "C" {
    pub fn hrtimer_next_event_without(exclude: *const hrtimer) -> u64_;
}
extern "C" {
    pub fn hrtimer_active(timer: *const hrtimer) -> bool_;
}
extern "C" {
    pub fn hrtimer_forward(timer: *mut hrtimer, now: ktime_t, interval: ktime_t) -> u64_;
}
extern "C" {
    pub fn nanosleep_copyout(arg1: *mut restart_block, arg2: *mut timespec64) -> ffi::c_int;
}
extern "C" {
    pub fn hrtimer_nanosleep(rqtp: ktime_t, mode: hrtimer_mode, clockid: clockid_t) -> ffi::c_long;
}
extern "C" {
    pub fn schedule_hrtimeout_range(
        expires: *mut ktime_t,
        delta: u64_,
        mode: hrtimer_mode,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn schedule_hrtimeout_range_clock(
        expires: *mut ktime_t,
        delta: u64_,
        mode: hrtimer_mode,
        clock_id: clockid_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn schedule_hrtimeout(expires: *mut ktime_t, mode: hrtimer_mode) -> ffi::c_int;
}
extern "C" {
    pub fn hrtimer_run_queues();
}
extern "C" {
    pub fn hrtimers_init();
}
extern "C" {
    pub fn sysrq_timer_list_show();
}
extern "C" {
    pub fn hrtimers_prepare_cpu(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn hrtimers_cpu_starting(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn hrtimers_cpu_dying(cpu: ffi::c_uint) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rtc_device {
    _unused: [u8; 0],
}
pub const alarmtimer_type_ALARM_REALTIME: alarmtimer_type = 0;
pub const alarmtimer_type_ALARM_BOOTTIME: alarmtimer_type = 1;
pub const alarmtimer_type_ALARM_NUMTYPE: alarmtimer_type = 2;
pub const alarmtimer_type_ALARM_REALTIME_FREEZER: alarmtimer_type = 3;
pub const alarmtimer_type_ALARM_BOOTTIME_FREEZER: alarmtimer_type = 4;
pub type alarmtimer_type = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct alarm {
    pub node: timerqueue_node,
    pub timer: hrtimer,
    pub function: ::core::option::Option<unsafe extern "C" fn(arg1: *mut alarm, now: ktime_t)>,
    pub type_: alarmtimer_type,
    pub state: ffi::c_int,
    pub data: *mut ffi::c_void,
}
impl Default for alarm {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn alarm_init(
        alarm: *mut alarm,
        type_: alarmtimer_type,
        function: ::core::option::Option<unsafe extern "C" fn(arg1: *mut alarm, arg2: ktime_t)>,
    );
}
extern "C" {
    pub fn alarm_start(alarm: *mut alarm, start: ktime_t);
}
extern "C" {
    pub fn alarm_start_relative(alarm: *mut alarm, start: ktime_t);
}
extern "C" {
    pub fn alarm_restart(alarm: *mut alarm);
}
extern "C" {
    pub fn alarm_try_to_cancel(alarm: *mut alarm) -> ffi::c_int;
}
extern "C" {
    pub fn alarm_cancel(alarm: *mut alarm) -> ffi::c_int;
}
extern "C" {
    pub fn alarm_forward(alarm: *mut alarm, now: ktime_t, interval: ktime_t) -> u64_;
}
extern "C" {
    pub fn alarm_forward_now(alarm: *mut alarm, interval: ktime_t) -> u64_;
}
extern "C" {
    pub fn alarm_expires_remaining(alarm: *const alarm) -> ktime_t;
}
extern "C" {
    pub fn alarmtimer_get_rtcdev() -> *mut rtc_device;
}
extern "C" {
    #[must_use]
    pub fn rcuref_get_slowpath(ref_: *mut rcuref_t) -> bool_;
}
extern "C" {
    #[must_use]
    pub fn rcuref_put_slowpath(ref_: *mut rcuref_t, cnt: ffi::c_uint) -> bool_;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct cpu_timer {
    pub node: timerqueue_node,
    pub head: *mut timerqueue_head,
    pub pid: *mut pid,
    pub elist: list_head,
    pub firing: bool_,
    pub nanosleep: bool_,
    pub handling: *mut task_struct,
}
impl Default for cpu_timer {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn posix_cputimers_group_init(pct: *mut posix_cputimers, cpu_limit: u64_);
}
extern "C" {
    pub fn posixtimer_rearm_itimer(p: *mut task_struct);
}
extern "C" {
    pub fn posixtimer_init_sigqueue(q: *mut sigqueue) -> bool_;
}
extern "C" {
    pub fn posixtimer_send_sigqueue(tmr: *mut k_itimer);
}
extern "C" {
    pub fn posixtimer_deliver_signal(info: *mut kernel_siginfo, timer_sigq: *mut sigqueue)
        -> bool_;
}
extern "C" {
    pub fn posixtimer_free_timer(timer: *mut k_itimer);
}
extern "C" {
    pub fn posixtimer_create_prctl(ctrl: ffi::c_ulong) -> ffi::c_long;
}
extern "C" {
    pub fn clear_posix_cputimers_work(p: *mut task_struct);
}
extern "C" {
    pub fn posix_cputimers_init_work();
}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct k_itimer {
    pub t_hash: hlist_node,
    pub list: hlist_node,
    pub it_id: timer_t,
    pub it_clock: clockid_t,
    pub it_sigev_notify: ffi::c_int,
    pub it_pid_type: pid_type,
    pub it_signal: *mut signal_struct,
    pub kclock: *mut k_clock,
    pub it_lock: spinlock_t,
    pub it_status: ffi::c_int,
    pub it_sig_periodic: bool_,
    pub it_overrun: s64,
    pub it_overrun_last: s64,
    pub it_signal_seq: ffi::c_uint,
    pub it_sigqueue_seq: ffi::c_uint,
    pub it_interval: ktime_t,
    pub ignored_list: hlist_node,
    pub __bindgen_anon_1: k_itimer__bindgen_ty_1,
    pub sigq: sigqueue,
    pub rcuref: rcuref_t,
    pub it: k_itimer__bindgen_ty_2,
    pub rcu: callback_head,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union k_itimer__bindgen_ty_1 {
    pub it_pid: *mut pid,
    pub it_process: *mut task_struct,
}
impl Default for k_itimer__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union k_itimer__bindgen_ty_2 {
    pub real: k_itimer__bindgen_ty_2__bindgen_ty_1,
    pub cpu: cpu_timer,
    pub alarm: k_itimer__bindgen_ty_2__bindgen_ty_2,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct k_itimer__bindgen_ty_2__bindgen_ty_1 {
    pub timer: hrtimer,
}
impl Default for k_itimer__bindgen_ty_2__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct k_itimer__bindgen_ty_2__bindgen_ty_2 {
    pub alarmtimer: alarm,
}
impl Default for k_itimer__bindgen_ty_2__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for k_itimer__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for k_itimer {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn run_posix_cpu_timers();
}
extern "C" {
    pub fn posix_cpu_timers_exit(task: *mut task_struct);
}
extern "C" {
    pub fn posix_cpu_timers_exit_group(task: *mut task_struct);
}
extern "C" {
    pub fn set_process_cpu_timer(
        task: *mut task_struct,
        clock_idx: ffi::c_uint,
        newval: *mut u64_,
        oldval: *mut u64_,
    );
}
extern "C" {
    pub fn update_rlimit_cpu(task: *mut task_struct, rlim_new: ffi::c_ulong) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sighand_struct {
    pub siglock: spinlock_t,
    pub count: refcount_t,
    pub signalfd_wqh: wait_queue_head_t,
    pub action: [k_sigaction; 64usize],
}
impl Default for sighand_struct {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pacct_struct {
    pub ac_flag: ffi::c_int,
    pub ac_exitcode: ffi::c_long,
    pub ac_mem: ffi::c_ulong,
    pub ac_utime: u64_,
    pub ac_stime: u64_,
    pub ac_minflt: ffi::c_ulong,
    pub ac_majflt: ffi::c_ulong,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct cpu_itimer {
    pub expires: u64_,
    pub incr: u64_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct task_cputime_atomic {
    pub utime: atomic64_t,
    pub stime: atomic64_t,
    pub sum_exec_runtime: atomic64_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct thread_group_cputimer {
    pub cputime_atomic: task_cputime_atomic,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct multiprocess_signals {
    pub signal: sigset_t,
    pub node: hlist_node,
}
impl Default for multiprocess_signals {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct core_thread {
    pub task: *mut task_struct,
    pub next: *mut core_thread,
}
impl Default for core_thread {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct core_state {
    pub nr_threads: atomic_t,
    pub dumper: core_thread,
    pub startup: completion,
}
impl Default for core_state {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct signal_struct {
    pub sigcnt: refcount_t,
    pub live: atomic_t,
    pub nr_threads: ffi::c_int,
    pub quick_threads: ffi::c_int,
    pub thread_head: list_head,
    pub wait_chldexit: wait_queue_head_t,
    pub curr_target: *mut task_struct,
    pub shared_pending: sigpending,
    pub multiprocess: hlist_head,
    pub group_exit_code: ffi::c_int,
    pub notify_count: ffi::c_int,
    pub group_exec_task: *mut task_struct,
    pub group_stop_count: ffi::c_int,
    pub flags: ffi::c_uint,
    pub core_state: *mut core_state,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub next_posix_timer_id: atomic_t,
    pub posix_timers: hlist_head,
    pub ignored_posix_timers: hlist_head,
    pub real_timer: hrtimer,
    pub it_real_incr: ktime_t,
    pub it: [cpu_itimer; 2usize],
    pub cputimer: thread_group_cputimer,
    pub posix_cputimers: posix_cputimers,
    pub pids: [*mut pid; 4usize],
    pub tick_dep_mask: atomic_t,
    pub tty_old_pgrp: *mut pid,
    pub leader: ffi::c_int,
    pub tty: *mut tty_struct,
    pub autogroup: *mut autogroup,
    pub stats_lock: seqlock_t,
    pub utime: u64_,
    pub stime: u64_,
    pub cutime: u64_,
    pub cstime: u64_,
    pub gtime: u64_,
    pub cgtime: u64_,
    pub prev_cputime: prev_cputime,
    pub nvcsw: ffi::c_ulong,
    pub nivcsw: ffi::c_ulong,
    pub cnvcsw: ffi::c_ulong,
    pub cnivcsw: ffi::c_ulong,
    pub min_flt: ffi::c_ulong,
    pub maj_flt: ffi::c_ulong,
    pub cmin_flt: ffi::c_ulong,
    pub cmaj_flt: ffi::c_ulong,
    pub inblock: ffi::c_ulong,
    pub oublock: ffi::c_ulong,
    pub cinblock: ffi::c_ulong,
    pub coublock: ffi::c_ulong,
    pub maxrss: ffi::c_ulong,
    pub cmaxrss: ffi::c_ulong,
    pub ioac: task_io_accounting,
    pub sum_sched_runtime: ffi::c_ulonglong,
    pub rlim: [rlimit; 16usize],
    pub pacct: pacct_struct,
    pub stats: *mut taskstats,
    pub audit_tty: ffi::c_uint,
    pub tty_audit_buf: *mut tty_audit_buf,
    pub oom_flag_origin: bool_,
    pub oom_score_adj: ffi::c_short,
    pub oom_score_adj_min: ffi::c_short,
    pub oom_mm: *mut mm_struct,
    pub cred_guard_mutex: mutex,
    pub exec_update_lock: rw_semaphore,
}
impl Default for signal_struct {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl signal_struct {
    #[inline]
    pub fn is_child_subreaper(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_is_child_subreaper(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn is_child_subreaper_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_is_child_subreaper_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn has_child_subreaper(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_has_child_subreaper(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn has_child_subreaper_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_has_child_subreaper_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn timer_create_restore_ids(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_timer_create_restore_ids(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn timer_create_restore_ids_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_timer_create_restore_ids_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        is_child_subreaper: ffi::c_uint,
        has_child_subreaper: ffi::c_uint,
        timer_create_restore_ids: ffi::c_uint,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let is_child_subreaper: u32 = unsafe { ::core::mem::transmute(is_child_subreaper) };
            is_child_subreaper as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let has_child_subreaper: u32 = unsafe { ::core::mem::transmute(has_child_subreaper) };
            has_child_subreaper as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let timer_create_restore_ids: u32 =
                unsafe { ::core::mem::transmute(timer_create_restore_ids) };
            timer_create_restore_ids as u64
        });
        __bindgen_bitfield_unit
    }
}
extern "C" {
    pub fn flush_signals(arg1: *mut task_struct);
}
extern "C" {
    pub fn ignore_signals(arg1: *mut task_struct);
}
extern "C" {
    pub fn flush_signal_handlers(arg1: *mut task_struct, force_default: ffi::c_int);
}
extern "C" {
    pub fn dequeue_signal(
        mask: *mut sigset_t,
        info: *mut kernel_siginfo_t,
        type_: *mut pid_type,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn force_sig_fault_to_task(
        sig: ffi::c_int,
        code: ffi::c_int,
        addr: *mut ffi::c_void,
        t: *mut task_struct,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn force_sig_fault(sig: ffi::c_int, code: ffi::c_int, addr: *mut ffi::c_void)
        -> ffi::c_int;
}
extern "C" {
    pub fn send_sig_fault(
        sig: ffi::c_int,
        code: ffi::c_int,
        addr: *mut ffi::c_void,
        t: *mut task_struct,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn force_sig_mceerr(
        code: ffi::c_int,
        arg1: *mut ffi::c_void,
        arg2: ffi::c_short,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn send_sig_mceerr(
        code: ffi::c_int,
        arg1: *mut ffi::c_void,
        arg2: ffi::c_short,
        arg3: *mut task_struct,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn force_sig_bnderr(
        addr: *mut ffi::c_void,
        lower: *mut ffi::c_void,
        upper: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn force_sig_pkuerr(addr: *mut ffi::c_void, pkey: u32_) -> ffi::c_int;
}
extern "C" {
    pub fn send_sig_perf(addr: *mut ffi::c_void, type_: u32_, sig_data: u64_) -> ffi::c_int;
}
extern "C" {
    pub fn force_sig_ptrace_errno_trap(errno: ffi::c_int, addr: *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn force_sig_fault_trapno(
        sig: ffi::c_int,
        code: ffi::c_int,
        addr: *mut ffi::c_void,
        trapno: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn send_sig_fault_trapno(
        sig: ffi::c_int,
        code: ffi::c_int,
        addr: *mut ffi::c_void,
        trapno: ffi::c_int,
        t: *mut task_struct,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn force_sig_seccomp(
        syscall: ffi::c_int,
        reason: ffi::c_int,
        force_coredump: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn send_sig_info(
        arg1: ffi::c_int,
        arg2: *mut kernel_siginfo,
        arg3: *mut task_struct,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn force_sigsegv(sig: ffi::c_int);
}
extern "C" {
    pub fn force_sig_info(arg1: *mut kernel_siginfo) -> ffi::c_int;
}
extern "C" {
    pub fn __kill_pgrp_info(
        sig: ffi::c_int,
        info: *mut kernel_siginfo,
        pgrp: *mut pid,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kill_pid_info(sig: ffi::c_int, info: *mut kernel_siginfo, pid: *mut pid) -> ffi::c_int;
}
extern "C" {
    pub fn kill_pid_usb_asyncio(
        sig: ffi::c_int,
        errno: ffi::c_int,
        addr: sigval_t,
        arg1: *mut pid,
        arg2: *const cred,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kill_pgrp(pid: *mut pid, sig: ffi::c_int, priv_: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn kill_pid(pid: *mut pid, sig: ffi::c_int, priv_: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn do_notify_parent(arg1: *mut task_struct, arg2: ffi::c_int) -> bool_;
}
extern "C" {
    pub fn __wake_up_parent(p: *mut task_struct, parent: *mut task_struct);
}
extern "C" {
    pub fn force_sig(arg1: ffi::c_int);
}
extern "C" {
    pub fn force_fatal_sig(arg1: ffi::c_int);
}
extern "C" {
    pub fn force_exit_sig(arg1: ffi::c_int);
}
extern "C" {
    pub fn send_sig(arg1: ffi::c_int, arg2: *mut task_struct, arg3: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn zap_other_threads(p: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn do_sigaction(
        arg1: ffi::c_int,
        arg2: *mut k_sigaction,
        arg3: *mut k_sigaction,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn recalc_sigpending();
}
extern "C" {
    pub fn calculate_sigpending();
}
extern "C" {
    pub fn signal_wake_up_state(t: *mut task_struct, state: ffi::c_uint);
}
extern "C" {
    pub fn task_join_group_stop(task: *mut task_struct);
}
extern "C" {
    pub fn set_user_sigmask(umask: *const sigset_t, sigsetsize: usize) -> ffi::c_int;
}
extern "C" {
    pub fn __cleanup_sighand(arg1: *mut sighand_struct);
}
extern "C" {
    pub fn flush_itimer_signals();
}
extern "C" {
    pub fn current_is_single_threaded() -> bool_;
}
pub type proc_visitor = ::core::option::Option<
    unsafe extern "C" fn(p: *mut task_struct, data: *mut ffi::c_void) -> ffi::c_int,
>;
extern "C" {
    pub fn walk_process_tree(top: *mut task_struct, arg1: proc_visitor, arg2: *mut ffi::c_void);
}
extern "C" {
    pub fn __lock_task_sighand(
        task: *mut task_struct,
        flags: *mut ffi::c_ulong,
    ) -> *mut sighand_struct;
}
extern "C" {
    pub fn rcuwait_wake_up(w: *mut rcuwait) -> ffi::c_int;
}
extern "C" {
    pub fn finish_rcuwait(w: *mut rcuwait);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rcu_sync {
    pub gp_state: ffi::c_int,
    pub gp_count: ffi::c_int,
    pub gp_wait: wait_queue_head_t,
    pub cb_head: callback_head,
}
impl Default for rcu_sync {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn rcu_sync_init(arg1: *mut rcu_sync);
}
extern "C" {
    pub fn rcu_sync_enter(arg1: *mut rcu_sync);
}
extern "C" {
    pub fn rcu_sync_exit(arg1: *mut rcu_sync);
}
extern "C" {
    pub fn rcu_sync_dtor(arg1: *mut rcu_sync);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct percpu_rw_semaphore {
    pub rss: rcu_sync,
    pub read_count: *mut ffi::c_uint,
    pub writer: rcuwait,
    pub waiters: wait_queue_head_t,
    pub block: atomic_t,
}
impl Default for percpu_rw_semaphore {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn __percpu_down_read(arg1: *mut percpu_rw_semaphore, arg2: bool_) -> bool_;
}
extern "C" {
    pub fn percpu_is_read_locked(arg1: *mut percpu_rw_semaphore) -> bool_;
}
extern "C" {
    pub fn percpu_down_write(arg1: *mut percpu_rw_semaphore);
}
extern "C" {
    pub fn percpu_up_write(arg1: *mut percpu_rw_semaphore);
}
pub type class_percpu_read_t = *mut percpu_rw_semaphore;
pub const class_percpu_read_is_conditional: bool_ = false;
pub const class_percpu_read_try_is_conditional: bool_ = true;
pub type class_percpu_read_try_t = class_percpu_read_t;
pub type class_percpu_write_t = *mut percpu_rw_semaphore;
pub const class_percpu_write_is_conditional: bool_ = false;
extern "C" {
    pub fn __percpu_init_rwsem(
        arg1: *mut percpu_rw_semaphore,
        arg2: *const ffi::c_char,
        arg3: *mut lock_class_key,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn percpu_free_rwsem(arg1: *mut percpu_rw_semaphore);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct delayed_call {
    pub fn_: ::core::option::Option<unsafe extern "C" fn(arg1: *mut ffi::c_void)>,
    pub arg: *mut ffi::c_void,
}
impl Default for delayed_call {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct guid_t {
    pub b: [__u8; 16usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct uuid_t {
    pub b: [__u8; 16usize],
}
extern "C" {
    pub static guid_null: guid_t;
}
extern "C" {
    pub static uuid_null: uuid_t;
}
extern "C" {
    pub fn generate_random_uuid(uuid: *mut ffi::c_uchar);
}
extern "C" {
    pub fn generate_random_guid(guid: *mut ffi::c_uchar);
}
extern "C" {
    pub fn guid_gen(u: *mut guid_t);
}
extern "C" {
    pub fn uuid_gen(u: *mut uuid_t);
}
extern "C" {
    #[must_use]
    pub fn uuid_is_valid(uuid: *const ffi::c_char) -> bool_;
}
extern "C" {
    pub static guid_index: [u8_; 16usize];
}
extern "C" {
    pub static uuid_index: [u8_; 16usize];
}
extern "C" {
    pub fn guid_parse(uuid: *const ffi::c_char, u: *mut guid_t) -> ffi::c_int;
}
extern "C" {
    pub fn uuid_parse(uuid: *const ffi::c_char, u: *mut uuid_t) -> ffi::c_int;
}
pub type errseq_t = u32_;
extern "C" {
    pub fn errseq_set(eseq: *mut errseq_t, err: ffi::c_int) -> errseq_t;
}
extern "C" {
    pub fn errseq_sample(eseq: *mut errseq_t) -> errseq_t;
}
extern "C" {
    pub fn errseq_check(eseq: *mut errseq_t, since: errseq_t) -> ffi::c_int;
}
extern "C" {
    pub fn errseq_check_and_advance(eseq: *mut errseq_t, since: *mut errseq_t) -> ffi::c_int;
}
extern "C" {
    pub fn rt_mutex_pre_schedule();
}
extern "C" {
    pub fn rt_mutex_schedule();
}
extern "C" {
    pub fn rt_mutex_post_schedule();
}
extern "C" {
    pub fn rt_mutex_setprio(p: *mut task_struct, pi_task: *mut task_struct);
}
extern "C" {
    pub fn rt_mutex_adjust_pi(p: *mut task_struct);
}
extern "C" {
    pub fn normalize_rt_tasks();
}
pub const ICQ_EXITED: _bindgen_ty_75 = 4;
pub const ICQ_DESTROYED: _bindgen_ty_75 = 8;
pub type _bindgen_ty_75 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct io_cq {
    pub q: *mut request_queue,
    pub ioc: *mut io_context,
    pub __bindgen_anon_1: io_cq__bindgen_ty_1,
    pub __bindgen_anon_2: io_cq__bindgen_ty_2,
    pub flags: ffi::c_uint,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union io_cq__bindgen_ty_1 {
    pub q_node: list_head,
    pub __rcu_icq_cache: *mut kmem_cache,
}
impl Default for io_cq__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union io_cq__bindgen_ty_2 {
    pub ioc_node: hlist_node,
    pub __rcu_head: callback_head,
}
impl Default for io_cq__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for io_cq {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct io_context {
    pub refcount: atomic_long_t,
    pub active_ref: atomic_t,
    pub ioprio: ffi::c_ushort,
    pub lock: spinlock_t,
    pub icq_tree: xarray,
    pub icq_hint: *mut io_cq,
    pub icq_list: hlist_head,
    pub release_work: work_struct,
}
impl Default for io_context {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn put_io_context(ioc: *mut io_context);
}
extern "C" {
    pub fn exit_io_context(task: *mut task_struct);
}
extern "C" {
    pub fn __copy_io(clone_flags: ffi::c_ulong, tsk: *mut task_struct) -> ffi::c_int;
}
pub const IOPRIO_CLASS_NONE: _bindgen_ty_76 = 0;
pub const IOPRIO_CLASS_RT: _bindgen_ty_76 = 1;
pub const IOPRIO_CLASS_BE: _bindgen_ty_76 = 2;
pub const IOPRIO_CLASS_IDLE: _bindgen_ty_76 = 3;
pub const IOPRIO_CLASS_INVALID: _bindgen_ty_76 = 7;
pub type _bindgen_ty_76 = ffi::c_uint;
pub const IOPRIO_WHO_PROCESS: _bindgen_ty_77 = 1;
pub const IOPRIO_WHO_PGRP: _bindgen_ty_77 = 2;
pub const IOPRIO_WHO_USER: _bindgen_ty_77 = 3;
pub type _bindgen_ty_77 = ffi::c_uint;
pub const IOPRIO_HINT_NONE: _bindgen_ty_78 = 0;
pub const IOPRIO_HINT_DEV_DURATION_LIMIT_1: _bindgen_ty_78 = 1;
pub const IOPRIO_HINT_DEV_DURATION_LIMIT_2: _bindgen_ty_78 = 2;
pub const IOPRIO_HINT_DEV_DURATION_LIMIT_3: _bindgen_ty_78 = 3;
pub const IOPRIO_HINT_DEV_DURATION_LIMIT_4: _bindgen_ty_78 = 4;
pub const IOPRIO_HINT_DEV_DURATION_LIMIT_5: _bindgen_ty_78 = 5;
pub const IOPRIO_HINT_DEV_DURATION_LIMIT_6: _bindgen_ty_78 = 6;
pub const IOPRIO_HINT_DEV_DURATION_LIMIT_7: _bindgen_ty_78 = 7;
pub type _bindgen_ty_78 = ffi::c_uint;
extern "C" {
    pub fn set_task_ioprio(task: *mut task_struct, ioprio: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn ioprio_check_cap(ioprio: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn fs_ftype_to_dtype(filetype: ffi::c_uint) -> ffi::c_uchar;
}
extern "C" {
    pub fn fs_umode_to_ftype(mode: umode_t) -> ffi::c_uchar;
}
extern "C" {
    pub fn fs_umode_to_dtype(mode: umode_t) -> ffi::c_uchar;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fs_context {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct vfsmount {
    pub mnt_root: *mut dentry,
    pub mnt_sb: *mut super_block,
    pub mnt_flags: ffi::c_int,
    pub mnt_idmap: *mut mnt_idmap,
}
impl Default for vfsmount {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn mnt_want_write(mnt: *mut vfsmount) -> ffi::c_int;
}
extern "C" {
    pub fn mnt_want_write_file(file: *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn mnt_drop_write(mnt: *mut vfsmount);
}
extern "C" {
    pub fn mnt_drop_write_file(file: *mut file);
}
extern "C" {
    pub fn mntput(mnt: *mut vfsmount);
}
extern "C" {
    pub fn mntget(mnt: *mut vfsmount) -> *mut vfsmount;
}
extern "C" {
    pub fn mnt_make_shortterm(mnt: *mut vfsmount);
}
extern "C" {
    pub fn mnt_clone_internal(path: *const path) -> *mut vfsmount;
}
extern "C" {
    pub fn __mnt_is_readonly(mnt: *mut vfsmount) -> bool_;
}
extern "C" {
    pub fn mnt_may_suid(mnt: *mut vfsmount) -> bool_;
}
extern "C" {
    pub fn clone_private_mount(path: *const path) -> *mut vfsmount;
}
extern "C" {
    pub fn mnt_get_write_access(mnt: *mut vfsmount) -> ffi::c_int;
}
extern "C" {
    pub fn mnt_put_write_access(mnt: *mut vfsmount);
}
extern "C" {
    pub fn fc_mount(fc: *mut fs_context) -> *mut vfsmount;
}
extern "C" {
    pub fn vfs_create_mount(fc: *mut fs_context) -> *mut vfsmount;
}
extern "C" {
    pub fn vfs_kern_mount(
        type_: *mut file_system_type,
        flags: ffi::c_int,
        name: *const ffi::c_char,
        data: *mut ffi::c_void,
    ) -> *mut vfsmount;
}
extern "C" {
    pub fn vfs_submount(
        mountpoint: *const dentry,
        type_: *mut file_system_type,
        name: *const ffi::c_char,
        data: *mut ffi::c_void,
    ) -> *mut vfsmount;
}
extern "C" {
    pub fn mnt_set_expiry(mnt: *mut vfsmount, expiry_list: *mut list_head);
}
extern "C" {
    pub fn mark_mounts_for_expiry(mounts: *mut list_head);
}
extern "C" {
    pub fn path_is_mountpoint(path: *const path) -> bool_;
}
extern "C" {
    pub fn our_mnt(mnt: *mut vfsmount) -> bool_;
}
extern "C" {
    pub fn kern_mount(arg1: *mut file_system_type) -> *mut vfsmount;
}
extern "C" {
    pub fn kern_unmount(mnt: *mut vfsmount);
}
extern "C" {
    pub fn may_umount_tree(arg1: *mut vfsmount) -> ffi::c_int;
}
extern "C" {
    pub fn may_umount(arg1: *mut vfsmount) -> ffi::c_int;
}
extern "C" {
    pub fn do_mount(
        arg1: *const ffi::c_char,
        arg2: *const ffi::c_char,
        arg3: *const ffi::c_char,
        arg4: ffi::c_ulong,
        arg5: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn collect_mounts(arg1: *const path) -> *mut vfsmount;
}
extern "C" {
    pub fn drop_collected_mounts(arg1: *mut vfsmount);
}
extern "C" {
    pub fn iterate_mounts(
        arg1: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut vfsmount, arg2: *mut ffi::c_void) -> ffi::c_int,
        >,
        arg2: *mut ffi::c_void,
        arg3: *mut vfsmount,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kern_unmount_array(mnt: *mut *mut vfsmount, num: ffi::c_uint);
}
extern "C" {
    pub fn cifs_root_data(dev: *mut *mut ffi::c_char, opts: *mut *mut ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub static mut nop_mnt_idmap: mnt_idmap;
}
extern "C" {
    pub static mut invalid_mnt_idmap: mnt_idmap;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct vfsuid_t {
    pub val: uid_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct vfsgid_t {
    pub val: gid_t,
}
extern "C" {
    pub fn vfsgid_in_group_p(vfsgid: vfsgid_t) -> ffi::c_int;
}
extern "C" {
    pub fn mnt_idmap_get(idmap: *mut mnt_idmap) -> *mut mnt_idmap;
}
extern "C" {
    pub fn mnt_idmap_put(idmap: *mut mnt_idmap);
}
extern "C" {
    pub fn make_vfsuid(
        idmap: *mut mnt_idmap,
        fs_userns: *mut user_namespace,
        kuid: kuid_t,
    ) -> vfsuid_t;
}
extern "C" {
    pub fn make_vfsgid(
        idmap: *mut mnt_idmap,
        fs_userns: *mut user_namespace,
        kgid: kgid_t,
    ) -> vfsgid_t;
}
extern "C" {
    pub fn from_vfsuid(
        idmap: *mut mnt_idmap,
        fs_userns: *mut user_namespace,
        vfsuid: vfsuid_t,
    ) -> kuid_t;
}
extern "C" {
    pub fn from_vfsgid(
        idmap: *mut mnt_idmap,
        fs_userns: *mut user_namespace,
        vfsgid: vfsgid_t,
    ) -> kgid_t;
}
pub type percpu_ref_func_t = ::core::option::Option<unsafe extern "C" fn(arg1: *mut percpu_ref)>;
pub const __PERCPU_REF_ATOMIC: _bindgen_ty_79 = 1;
pub const __PERCPU_REF_DEAD: _bindgen_ty_79 = 2;
pub const __PERCPU_REF_ATOMIC_DEAD: _bindgen_ty_79 = 3;
pub const __PERCPU_REF_FLAG_BITS: _bindgen_ty_79 = 2;
pub type _bindgen_ty_79 = ffi::c_uint;
pub const PERCPU_REF_INIT_ATOMIC: _bindgen_ty_80 = 1;
pub const PERCPU_REF_INIT_DEAD: _bindgen_ty_80 = 2;
pub const PERCPU_REF_ALLOW_REINIT: _bindgen_ty_80 = 4;
pub type _bindgen_ty_80 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct percpu_ref_data {
    pub count: atomic_long_t,
    pub release: percpu_ref_func_t,
    pub confirm_switch: percpu_ref_func_t,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub rcu: callback_head,
    pub ref_: *mut percpu_ref,
}
impl Default for percpu_ref_data {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl percpu_ref_data {
    #[inline]
    pub fn force_atomic(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_force_atomic(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn force_atomic_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_force_atomic_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn allow_reinit(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_allow_reinit(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn allow_reinit_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_allow_reinit_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        force_atomic: bool_,
        allow_reinit: bool_,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let force_atomic: u8 = unsafe { ::core::mem::transmute(force_atomic) };
            force_atomic as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let allow_reinit: u8 = unsafe { ::core::mem::transmute(allow_reinit) };
            allow_reinit as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct percpu_ref {
    pub percpu_count_ptr: ffi::c_ulong,
    pub data: *mut percpu_ref_data,
}
impl Default for percpu_ref {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    #[must_use]
    pub fn percpu_ref_init(
        ref_: *mut percpu_ref,
        release: percpu_ref_func_t,
        flags: ffi::c_uint,
        gfp: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn percpu_ref_exit(ref_: *mut percpu_ref);
}
extern "C" {
    pub fn percpu_ref_switch_to_atomic(ref_: *mut percpu_ref, confirm_switch: percpu_ref_func_t);
}
extern "C" {
    pub fn percpu_ref_switch_to_atomic_sync(ref_: *mut percpu_ref);
}
extern "C" {
    pub fn percpu_ref_switch_to_percpu(ref_: *mut percpu_ref);
}
extern "C" {
    pub fn percpu_ref_kill_and_confirm(ref_: *mut percpu_ref, confirm_kill: percpu_ref_func_t);
}
extern "C" {
    pub fn percpu_ref_resurrect(ref_: *mut percpu_ref);
}
extern "C" {
    pub fn percpu_ref_reinit(ref_: *mut percpu_ref);
}
extern "C" {
    pub fn percpu_ref_is_zero(ref_: *mut percpu_ref) -> bool_;
}
pub const _slab_flag_bits__SLAB_CONSISTENCY_CHECKS: _slab_flag_bits = 0;
pub const _slab_flag_bits__SLAB_RED_ZONE: _slab_flag_bits = 1;
pub const _slab_flag_bits__SLAB_POISON: _slab_flag_bits = 2;
pub const _slab_flag_bits__SLAB_KMALLOC: _slab_flag_bits = 3;
pub const _slab_flag_bits__SLAB_HWCACHE_ALIGN: _slab_flag_bits = 4;
pub const _slab_flag_bits__SLAB_CACHE_DMA: _slab_flag_bits = 5;
pub const _slab_flag_bits__SLAB_CACHE_DMA32: _slab_flag_bits = 6;
pub const _slab_flag_bits__SLAB_STORE_USER: _slab_flag_bits = 7;
pub const _slab_flag_bits__SLAB_PANIC: _slab_flag_bits = 8;
pub const _slab_flag_bits__SLAB_TYPESAFE_BY_RCU: _slab_flag_bits = 9;
pub const _slab_flag_bits__SLAB_TRACE: _slab_flag_bits = 10;
pub const _slab_flag_bits__SLAB_NOLEAKTRACE: _slab_flag_bits = 11;
pub const _slab_flag_bits__SLAB_NO_MERGE: _slab_flag_bits = 12;
pub const _slab_flag_bits__SLAB_ACCOUNT: _slab_flag_bits = 13;
pub const _slab_flag_bits__SLAB_NO_USER_FLAGS: _slab_flag_bits = 14;
pub const _slab_flag_bits__SLAB_SKIP_KFENCE: _slab_flag_bits = 15;
pub const _slab_flag_bits__SLAB_RECLAIM_ACCOUNT: _slab_flag_bits = 16;
pub const _slab_flag_bits__SLAB_OBJECT_POISON: _slab_flag_bits = 17;
pub const _slab_flag_bits__SLAB_CMPXCHG_DOUBLE: _slab_flag_bits = 18;
pub const _slab_flag_bits__SLAB_NO_OBJ_EXT: _slab_flag_bits = 19;
pub const _slab_flag_bits__SLAB_FLAGS_LAST_BIT: _slab_flag_bits = 20;
pub type _slab_flag_bits = ffi::c_uint;
extern "C" {
    pub fn slab_is_available() -> bool_;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct kmem_cache_args {
    pub align: ffi::c_uint,
    pub useroffset: ffi::c_uint,
    pub usersize: ffi::c_uint,
    pub freeptr_offset: ffi::c_uint,
    pub use_freeptr_offset: bool_,
    pub ctor: ::core::option::Option<unsafe extern "C" fn(arg1: *mut ffi::c_void)>,
}
extern "C" {
    pub fn __kmem_cache_create_args(
        name: *const ffi::c_char,
        object_size: ffi::c_uint,
        args: *mut kmem_cache_args,
        flags: slab_flags_t,
    ) -> *mut kmem_cache;
}
extern "C" {
    pub fn kmem_cache_destroy(s: *mut kmem_cache);
}
extern "C" {
    pub fn kmem_cache_shrink(s: *mut kmem_cache) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn krealloc_noprof(
        objp: *const ffi::c_void,
        new_size: usize,
        flags: gfp_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn kfree(objp: *const ffi::c_void);
}
extern "C" {
    pub fn kfree_sensitive(objp: *const ffi::c_void);
}
extern "C" {
    pub fn __ksize(objp: *const ffi::c_void) -> usize;
}
extern "C" {
    pub fn ksize(objp: *const ffi::c_void) -> usize;
}
extern "C" {
    pub fn kmem_dump_obj(object: *mut ffi::c_void) -> bool_;
}
pub const kmalloc_cache_type_KMALLOC_NORMAL: kmalloc_cache_type = 0;
pub const kmalloc_cache_type_KMALLOC_RANDOM_START: kmalloc_cache_type = 0;
pub const kmalloc_cache_type_KMALLOC_RANDOM_END: kmalloc_cache_type = 15;
pub const kmalloc_cache_type_KMALLOC_RECLAIM: kmalloc_cache_type = 16;
pub const kmalloc_cache_type_KMALLOC_DMA: kmalloc_cache_type = 17;
pub const kmalloc_cache_type_KMALLOC_CGROUP: kmalloc_cache_type = 18;
pub const kmalloc_cache_type_NR_KMALLOC_TYPES: kmalloc_cache_type = 19;
pub type kmalloc_cache_type = ffi::c_uint;
pub type kmem_buckets = [*mut kmem_cache; 14usize];
extern "C" {
    pub static mut kmalloc_caches: [kmem_buckets; 19usize];
}
extern "C" {
    pub static mut random_kmalloc_seed: ffi::c_ulong;
}
extern "C" {
    pub fn kmem_cache_alloc_noprof(cachep: *mut kmem_cache, flags: gfp_t) -> *mut ffi::c_void;
}
extern "C" {
    pub fn kmem_cache_alloc_lru_noprof(
        s: *mut kmem_cache,
        lru: *mut list_lru,
        gfpflags: gfp_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn kmem_cache_charge(objp: *mut ffi::c_void, gfpflags: gfp_t) -> bool_;
}
extern "C" {
    pub fn kmem_cache_free(s: *mut kmem_cache, objp: *mut ffi::c_void);
}
extern "C" {
    pub fn kmem_buckets_create(
        name: *const ffi::c_char,
        flags: slab_flags_t,
        useroffset: ffi::c_uint,
        usersize: ffi::c_uint,
        ctor: ::core::option::Option<unsafe extern "C" fn(arg1: *mut ffi::c_void)>,
    ) -> *mut kmem_buckets;
}
extern "C" {
    pub fn kmem_cache_free_bulk(s: *mut kmem_cache, size: usize, p: *mut *mut ffi::c_void);
}
extern "C" {
    pub fn kmem_cache_alloc_bulk_noprof(
        s: *mut kmem_cache,
        flags: gfp_t,
        size: usize,
        p: *mut *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kmem_cache_alloc_node_noprof(
        s: *mut kmem_cache,
        flags: gfp_t,
        node: ffi::c_int,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn __kmalloc_noprof(size: usize, flags: gfp_t) -> *mut ffi::c_void;
}
extern "C" {
    pub fn __kmalloc_node_noprof(
        size: usize,
        b: *mut kmem_buckets,
        flags: gfp_t,
        node: ffi::c_int,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn __kmalloc_cache_noprof(
        s: *mut kmem_cache,
        flags: gfp_t,
        size: usize,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn __kmalloc_cache_node_noprof(
        s: *mut kmem_cache,
        gfpflags: gfp_t,
        node: ffi::c_int,
        size: usize,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn __kmalloc_large_noprof(size: usize, flags: gfp_t) -> *mut ffi::c_void;
}
extern "C" {
    pub fn __kmalloc_large_node_noprof(
        size: usize,
        flags: gfp_t,
        node: ffi::c_int,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn __kmalloc_node_track_caller_noprof(
        size: usize,
        b: *mut kmem_buckets,
        flags: gfp_t,
        node: ffi::c_int,
        caller: ffi::c_ulong,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn __kvmalloc_node_noprof(
        size: usize,
        b: *mut kmem_buckets,
        flags: gfp_t,
        node: ffi::c_int,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn kvrealloc_noprof(p: *const ffi::c_void, size: usize, flags: gfp_t) -> *mut ffi::c_void;
}
extern "C" {
    pub fn kvfree(addr: *const ffi::c_void);
}
extern "C" {
    pub fn kvfree_sensitive(addr: *const ffi::c_void, len: usize);
}
extern "C" {
    pub fn kmem_cache_size(s: *mut kmem_cache) -> ffi::c_uint;
}
extern "C" {
    pub fn kvfree_rcu_barrier();
}
extern "C" {
    pub fn kfree_rcu_scheduler_running();
}
extern "C" {
    pub fn kmalloc_size_roundup(size: usize) -> usize;
}
extern "C" {
    pub fn kmem_cache_init_late();
}
extern "C" {
    pub fn kvfree_rcu_init();
}
pub const rw_hint_WRITE_LIFE_NOT_SET: rw_hint = 0;
pub const rw_hint_WRITE_LIFE_NONE: rw_hint = 1;
pub const rw_hint_WRITE_LIFE_SHORT: rw_hint = 2;
pub const rw_hint_WRITE_LIFE_MEDIUM: rw_hint = 3;
pub const rw_hint_WRITE_LIFE_LONG: rw_hint = 4;
pub const rw_hint_WRITE_LIFE_EXTREME: rw_hint = 5;
pub type rw_hint = ffi::c_uchar;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct file_ref_t {
    pub refcnt: atomic64_t,
}
extern "C" {
    pub fn __file_ref_put(ref_: *mut file_ref_t, cnt: ffi::c_ulong) -> bool_;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct utf8data {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct utf8data_table {
    _unused: [u8; 0],
}
pub const utf8_normalization_UTF8_NFDI: utf8_normalization = 0;
pub const utf8_normalization_UTF8_NFDICF: utf8_normalization = 1;
pub const utf8_normalization_UTF8_NMAX: utf8_normalization = 2;
pub type utf8_normalization = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct unicode_map {
    pub version: ffi::c_uint,
    pub ntab: [*const utf8data; 2usize],
    pub tables: *const utf8data_table,
}
impl Default for unicode_map {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn utf8_validate(um: *const unicode_map, str_: *const qstr) -> ffi::c_int;
}
extern "C" {
    pub fn utf8_strncmp(um: *const unicode_map, s1: *const qstr, s2: *const qstr) -> ffi::c_int;
}
extern "C" {
    pub fn utf8_strncasecmp(um: *const unicode_map, s1: *const qstr, s2: *const qstr)
        -> ffi::c_int;
}
extern "C" {
    pub fn utf8_strncasecmp_folded(
        um: *const unicode_map,
        cf: *const qstr,
        s1: *const qstr,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn utf8_normalize(
        um: *const unicode_map,
        str_: *const qstr,
        dest: *mut ffi::c_uchar,
        dlen: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn utf8_casefold(
        um: *const unicode_map,
        str_: *const qstr,
        dest: *mut ffi::c_uchar,
        dlen: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn utf8_casefold_hash(
        um: *const unicode_map,
        salt: *const ffi::c_void,
        str_: *mut qstr,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn utf8_load(version: ffi::c_uint) -> *mut unicode_map;
}
extern "C" {
    pub fn utf8_unload(um: *mut unicode_map);
}
extern "C" {
    pub fn utf8_parse_version(version: *mut ffi::c_char) -> ffi::c_int;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct file_clone_range {
    pub src_fd: __s64,
    pub src_offset: __u64,
    pub src_length: __u64,
    pub dest_offset: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct fstrim_range {
    pub start: __u64,
    pub len: __u64,
    pub minlen: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct fsuuid2 {
    pub len: __u8,
    pub uuid: [__u8; 16usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fs_sysfs_path {
    pub len: __u8,
    pub name: [__u8; 128usize],
}
impl Default for fs_sysfs_path {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct file_dedupe_range_info {
    pub dest_fd: __s64,
    pub dest_offset: __u64,
    pub bytes_deduped: __u64,
    pub status: __s32,
    pub reserved: __u32,
}
#[repr(C)]
#[derive(Default)]
pub struct file_dedupe_range {
    pub src_offset: __u64,
    pub src_length: __u64,
    pub dest_count: __u16,
    pub reserved1: __u16,
    pub reserved2: __u32,
    pub info: __IncompleteArrayField<file_dedupe_range_info>,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct files_stat_struct {
    pub nr_files: ffi::c_ulong,
    pub nr_free_files: ffi::c_ulong,
    pub max_files: ffi::c_ulong,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct inodes_stat_t {
    pub nr_inodes: ffi::c_long,
    pub nr_unused: ffi::c_long,
    pub dummy: [ffi::c_long; 5usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct fsxattr {
    pub fsx_xflags: __u32,
    pub fsx_extsize: __u32,
    pub fsx_nextents: __u32,
    pub fsx_projid: __u32,
    pub fsx_cowextsize: __u32,
    pub fsx_pad: [ffi::c_uchar; 8usize],
}
pub type __kernel_rwf_t = ffi::c_int;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct page_region {
    pub start: __u64,
    pub end: __u64,
    pub categories: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pm_scan_arg {
    pub size: __u64,
    pub flags: __u64,
    pub start: __u64,
    pub end: __u64,
    pub walk_end: __u64,
    pub vec: __u64,
    pub vec_len: __u64,
    pub max_pages: __u64,
    pub category_inverted: __u64,
    pub category_mask: __u64,
    pub category_anyof_mask: __u64,
    pub return_mask: __u64,
}
pub const procmap_query_flags_PROCMAP_QUERY_VMA_READABLE: procmap_query_flags = 1;
pub const procmap_query_flags_PROCMAP_QUERY_VMA_WRITABLE: procmap_query_flags = 2;
pub const procmap_query_flags_PROCMAP_QUERY_VMA_EXECUTABLE: procmap_query_flags = 4;
pub const procmap_query_flags_PROCMAP_QUERY_VMA_SHARED: procmap_query_flags = 8;
pub const procmap_query_flags_PROCMAP_QUERY_COVERING_OR_NEXT_VMA: procmap_query_flags = 16;
pub const procmap_query_flags_PROCMAP_QUERY_FILE_BACKED_VMA: procmap_query_flags = 32;
pub type procmap_query_flags = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct procmap_query {
    pub size: __u64,
    pub query_flags: __u64,
    pub query_addr: __u64,
    pub vma_start: __u64,
    pub vma_end: __u64,
    pub vma_flags: __u64,
    pub vma_page_size: __u64,
    pub vma_offset: __u64,
    pub inode: __u64,
    pub dev_major: __u32,
    pub dev_minor: __u32,
    pub vma_name_size: __u32,
    pub build_id_size: __u32,
    pub vma_name_addr: __u64,
    pub build_id_addr: __u64,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct export_operations {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fiemap_extent_info {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct hd_geometry {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kstatfs {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct swap_info_struct {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fscrypt_inode_info {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fscrypt_operations {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fsverity_info {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fsverity_operations {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fsnotify_mark_connector {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fsnotify_sb_info {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fs_parameter_spec {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fileattr {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct iomap_ops {
    _unused: [u8; 0],
}
extern "C" {
    pub fn inode_init();
}
extern "C" {
    pub fn inode_init_early();
}
extern "C" {
    pub fn files_init();
}
extern "C" {
    pub fn files_maxfiles_init();
}
extern "C" {
    pub fn get_max_files() -> ffi::c_ulong;
}
extern "C" {
    pub static mut sysctl_nr_open: ffi::c_uint;
}
pub type rwf_t = __kernel_rwf_t;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct buffer_head {
    _unused: [u8; 0],
}
pub type get_block_t = ::core::option::Option<
    unsafe extern "C" fn(
        inode: *mut inode,
        iblock: sector_t,
        bh_result: *mut buffer_head,
        create: ffi::c_int,
    ) -> ffi::c_int,
>;
pub type dio_iodone_t = ::core::option::Option<
    unsafe extern "C" fn(
        iocb: *mut kiocb,
        offset: loff_t,
        bytes: isize,
        private: *mut ffi::c_void,
    ) -> ffi::c_int,
>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct iattr {
    pub ia_valid: ffi::c_uint,
    pub ia_mode: umode_t,
    pub __bindgen_anon_1: iattr__bindgen_ty_1,
    pub __bindgen_anon_2: iattr__bindgen_ty_2,
    pub ia_size: loff_t,
    pub ia_atime: timespec64,
    pub ia_mtime: timespec64,
    pub ia_ctime: timespec64,
    pub ia_file: *mut file,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union iattr__bindgen_ty_1 {
    pub ia_uid: kuid_t,
    pub ia_vfsuid: vfsuid_t,
}
impl Default for iattr__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union iattr__bindgen_ty_2 {
    pub ia_gid: kgid_t,
    pub ia_vfsgid: vfsgid_t,
}
impl Default for iattr__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for iattr {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct fs_disk_quota {
    pub d_version: __s8,
    pub d_flags: __s8,
    pub d_fieldmask: __u16,
    pub d_id: __u32,
    pub d_blk_hardlimit: __u64,
    pub d_blk_softlimit: __u64,
    pub d_ino_hardlimit: __u64,
    pub d_ino_softlimit: __u64,
    pub d_bcount: __u64,
    pub d_icount: __u64,
    pub d_itimer: __s32,
    pub d_btimer: __s32,
    pub d_iwarns: __u16,
    pub d_bwarns: __u16,
    pub d_itimer_hi: __s8,
    pub d_btimer_hi: __s8,
    pub d_rtbtimer_hi: __s8,
    pub d_padding2: __s8,
    pub d_rtb_hardlimit: __u64,
    pub d_rtb_softlimit: __u64,
    pub d_rtbcount: __u64,
    pub d_rtbtimer: __s32,
    pub d_rtbwarns: __u16,
    pub d_padding3: __s16,
    pub d_padding4: [ffi::c_char; 8usize],
}
pub type fs_disk_quota_t = fs_disk_quota;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct fs_qfilestat {
    pub qfs_ino: __u64,
    pub qfs_nblks: __u64,
    pub qfs_nextents: __u32,
}
pub type fs_qfilestat_t = fs_qfilestat;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct fs_quota_stat {
    pub qs_version: __s8,
    pub qs_flags: __u16,
    pub qs_pad: __s8,
    pub qs_uquota: fs_qfilestat_t,
    pub qs_gquota: fs_qfilestat_t,
    pub qs_incoredqs: __u32,
    pub qs_btimelimit: __s32,
    pub qs_itimelimit: __s32,
    pub qs_rtbtimelimit: __s32,
    pub qs_bwarnlimit: __u16,
    pub qs_iwarnlimit: __u16,
}
pub type fs_quota_stat_t = fs_quota_stat;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct fs_qfilestatv {
    pub qfs_ino: __u64,
    pub qfs_nblks: __u64,
    pub qfs_nextents: __u32,
    pub qfs_pad: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct fs_quota_statv {
    pub qs_version: __s8,
    pub qs_pad1: __u8,
    pub qs_flags: __u16,
    pub qs_incoredqs: __u32,
    pub qs_uquota: fs_qfilestatv,
    pub qs_gquota: fs_qfilestatv,
    pub qs_pquota: fs_qfilestatv,
    pub qs_btimelimit: __s32,
    pub qs_itimelimit: __s32,
    pub qs_rtbtimelimit: __s32,
    pub qs_bwarnlimit: __u16,
    pub qs_iwarnlimit: __u16,
    pub qs_rtbwarnlimit: __u16,
    pub qs_pad3: __u16,
    pub qs_pad4: __u32,
    pub qs_pad2: [__u64; 7usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct qtree_fmt_operations {
    pub mem2disk_dqblk:
        ::core::option::Option<unsafe extern "C" fn(disk: *mut ffi::c_void, dquot: *mut dquot)>,
    pub disk2mem_dqblk:
        ::core::option::Option<unsafe extern "C" fn(dquot: *mut dquot, disk: *mut ffi::c_void)>,
    pub is_id: ::core::option::Option<
        unsafe extern "C" fn(disk: *mut ffi::c_void, dquot: *mut dquot) -> ffi::c_int,
    >,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct qtree_mem_dqinfo {
    pub dqi_sb: *mut super_block,
    pub dqi_type: ffi::c_int,
    pub dqi_blocks: ffi::c_uint,
    pub dqi_free_blk: ffi::c_uint,
    pub dqi_free_entry: ffi::c_uint,
    pub dqi_blocksize_bits: ffi::c_uint,
    pub dqi_entry_size: ffi::c_uint,
    pub dqi_usable_bs: ffi::c_uint,
    pub dqi_qtree_depth: ffi::c_uint,
    pub dqi_ops: *const qtree_fmt_operations,
}
impl Default for qtree_mem_dqinfo {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn qtree_write_dquot(info: *mut qtree_mem_dqinfo, dquot: *mut dquot) -> ffi::c_int;
}
extern "C" {
    pub fn qtree_read_dquot(info: *mut qtree_mem_dqinfo, dquot: *mut dquot) -> ffi::c_int;
}
extern "C" {
    pub fn qtree_delete_dquot(info: *mut qtree_mem_dqinfo, dquot: *mut dquot) -> ffi::c_int;
}
extern "C" {
    pub fn qtree_release_dquot(info: *mut qtree_mem_dqinfo, dquot: *mut dquot) -> ffi::c_int;
}
extern "C" {
    pub fn qtree_entry_unused(info: *mut qtree_mem_dqinfo, disk: *mut ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub fn qtree_get_next_id(info: *mut qtree_mem_dqinfo, qid: *mut kqid) -> ffi::c_int;
}
pub type projid_t = __kernel_uid32_t;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct kprojid_t {
    pub val: projid_t,
}
extern "C" {
    pub fn make_kprojid(from: *mut user_namespace, projid: projid_t) -> kprojid_t;
}
extern "C" {
    pub fn from_kprojid(to: *mut user_namespace, projid: kprojid_t) -> projid_t;
}
extern "C" {
    pub fn from_kprojid_munged(to: *mut user_namespace, projid: kprojid_t) -> projid_t;
}
pub const QIF_BLIMITS_B: _bindgen_ty_81 = 0;
pub const QIF_SPACE_B: _bindgen_ty_81 = 1;
pub const QIF_ILIMITS_B: _bindgen_ty_81 = 2;
pub const QIF_INODES_B: _bindgen_ty_81 = 3;
pub const QIF_BTIME_B: _bindgen_ty_81 = 4;
pub const QIF_ITIME_B: _bindgen_ty_81 = 5;
pub type _bindgen_ty_81 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct if_dqblk {
    pub dqb_bhardlimit: __u64,
    pub dqb_bsoftlimit: __u64,
    pub dqb_curspace: __u64,
    pub dqb_ihardlimit: __u64,
    pub dqb_isoftlimit: __u64,
    pub dqb_curinodes: __u64,
    pub dqb_btime: __u64,
    pub dqb_itime: __u64,
    pub dqb_valid: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct if_nextdqblk {
    pub dqb_bhardlimit: __u64,
    pub dqb_bsoftlimit: __u64,
    pub dqb_curspace: __u64,
    pub dqb_ihardlimit: __u64,
    pub dqb_isoftlimit: __u64,
    pub dqb_curinodes: __u64,
    pub dqb_btime: __u64,
    pub dqb_itime: __u64,
    pub dqb_valid: __u32,
    pub dqb_id: __u32,
}
pub const DQF_ROOT_SQUASH_B: _bindgen_ty_82 = 0;
pub const DQF_SYS_FILE_B: _bindgen_ty_82 = 16;
pub const DQF_PRIVATE: _bindgen_ty_82 = 17;
pub type _bindgen_ty_82 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct if_dqinfo {
    pub dqi_bgrace: __u64,
    pub dqi_igrace: __u64,
    pub dqi_flags: __u32,
    pub dqi_valid: __u32,
}
pub const QUOTA_NL_C_UNSPEC: _bindgen_ty_83 = 0;
pub const QUOTA_NL_C_WARNING: _bindgen_ty_83 = 1;
pub const __QUOTA_NL_C_MAX: _bindgen_ty_83 = 2;
pub type _bindgen_ty_83 = ffi::c_uint;
pub const QUOTA_NL_A_UNSPEC: _bindgen_ty_84 = 0;
pub const QUOTA_NL_A_QTYPE: _bindgen_ty_84 = 1;
pub const QUOTA_NL_A_EXCESS_ID: _bindgen_ty_84 = 2;
pub const QUOTA_NL_A_WARNING: _bindgen_ty_84 = 3;
pub const QUOTA_NL_A_DEV_MAJOR: _bindgen_ty_84 = 4;
pub const QUOTA_NL_A_DEV_MINOR: _bindgen_ty_84 = 5;
pub const QUOTA_NL_A_CAUSED_ID: _bindgen_ty_84 = 6;
pub const QUOTA_NL_A_PAD: _bindgen_ty_84 = 7;
pub const __QUOTA_NL_A_MAX: _bindgen_ty_84 = 8;
pub type _bindgen_ty_84 = ffi::c_uint;
pub const quota_type_USRQUOTA: quota_type = 0;
pub const quota_type_GRPQUOTA: quota_type = 1;
pub const quota_type_PRJQUOTA: quota_type = 2;
pub type quota_type = ffi::c_uint;
pub type qid_t = __kernel_uid32_t;
pub type qsize_t = ffi::c_longlong;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kqid {
    pub __bindgen_anon_1: kqid__bindgen_ty_1,
    pub type_: quota_type,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union kqid__bindgen_ty_1 {
    pub uid: kuid_t,
    pub gid: kgid_t,
    pub projid: kprojid_t,
}
impl Default for kqid__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for kqid {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn qid_eq(left: kqid, right: kqid) -> bool_;
}
extern "C" {
    pub fn qid_lt(left: kqid, right: kqid) -> bool_;
}
extern "C" {
    pub fn from_kqid(to: *mut user_namespace, qid: kqid) -> qid_t;
}
extern "C" {
    pub fn from_kqid_munged(to: *mut user_namespace, qid: kqid) -> qid_t;
}
extern "C" {
    pub fn qid_valid(qid: kqid) -> bool_;
}
extern "C" {
    pub static mut dq_data_lock: spinlock_t;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct mem_dqblk {
    pub dqb_bhardlimit: qsize_t,
    pub dqb_bsoftlimit: qsize_t,
    pub dqb_curspace: qsize_t,
    pub dqb_rsvspace: qsize_t,
    pub dqb_ihardlimit: qsize_t,
    pub dqb_isoftlimit: qsize_t,
    pub dqb_curinodes: qsize_t,
    pub dqb_btime: time64_t,
    pub dqb_itime: time64_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mem_dqinfo {
    pub dqi_format: *mut quota_format_type,
    pub dqi_fmt_id: ffi::c_int,
    pub dqi_dirty_list: list_head,
    pub dqi_flags: ffi::c_ulong,
    pub dqi_bgrace: ffi::c_uint,
    pub dqi_igrace: ffi::c_uint,
    pub dqi_max_spc_limit: qsize_t,
    pub dqi_max_ino_limit: qsize_t,
    pub dqi_priv: *mut ffi::c_void,
}
impl Default for mem_dqinfo {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const DQF_INFO_DIRTY_B: _bindgen_ty_85 = 17;
pub type _bindgen_ty_85 = ffi::c_uint;
extern "C" {
    pub fn mark_info_dirty(sb: *mut super_block, type_: ffi::c_int);
}
pub const DQST_LOOKUPS: _bindgen_ty_86 = 0;
pub const DQST_DROPS: _bindgen_ty_86 = 1;
pub const DQST_READS: _bindgen_ty_86 = 2;
pub const DQST_WRITES: _bindgen_ty_86 = 3;
pub const DQST_CACHE_HITS: _bindgen_ty_86 = 4;
pub const DQST_ALLOC_DQUOTS: _bindgen_ty_86 = 5;
pub const DQST_FREE_DQUOTS: _bindgen_ty_86 = 6;
pub const DQST_SYNCS: _bindgen_ty_86 = 7;
pub const _DQST_DQSTAT_LAST: _bindgen_ty_86 = 8;
pub type _bindgen_ty_86 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct dqstats {
    pub stat: [ffi::c_ulong; 8usize],
    pub counter: [percpu_counter; 8usize],
}
impl Default for dqstats {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut dqstats: dqstats;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct dquot {
    pub dq_hash: hlist_node,
    pub dq_inuse: list_head,
    pub dq_free: list_head,
    pub dq_dirty: list_head,
    pub dq_lock: mutex,
    pub dq_dqb_lock: spinlock_t,
    pub dq_count: atomic_t,
    pub dq_sb: *mut super_block,
    pub dq_id: kqid,
    pub dq_off: loff_t,
    pub dq_flags: ffi::c_ulong,
    pub dq_dqb: mem_dqblk,
}
impl Default for dquot {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct quota_format_ops {
    pub check_quota_file: ::core::option::Option<
        unsafe extern "C" fn(sb: *mut super_block, type_: ffi::c_int) -> ffi::c_int,
    >,
    pub read_file_info: ::core::option::Option<
        unsafe extern "C" fn(sb: *mut super_block, type_: ffi::c_int) -> ffi::c_int,
    >,
    pub write_file_info: ::core::option::Option<
        unsafe extern "C" fn(sb: *mut super_block, type_: ffi::c_int) -> ffi::c_int,
    >,
    pub free_file_info: ::core::option::Option<
        unsafe extern "C" fn(sb: *mut super_block, type_: ffi::c_int) -> ffi::c_int,
    >,
    pub read_dqblk: ::core::option::Option<unsafe extern "C" fn(dquot: *mut dquot) -> ffi::c_int>,
    pub commit_dqblk: ::core::option::Option<unsafe extern "C" fn(dquot: *mut dquot) -> ffi::c_int>,
    pub release_dqblk:
        ::core::option::Option<unsafe extern "C" fn(dquot: *mut dquot) -> ffi::c_int>,
    pub get_next_id: ::core::option::Option<
        unsafe extern "C" fn(sb: *mut super_block, qid: *mut kqid) -> ffi::c_int,
    >,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct dquot_operations {
    pub write_dquot: ::core::option::Option<unsafe extern "C" fn(arg1: *mut dquot) -> ffi::c_int>,
    pub alloc_dquot: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut super_block, arg2: ffi::c_int) -> *mut dquot,
    >,
    pub destroy_dquot: ::core::option::Option<unsafe extern "C" fn(arg1: *mut dquot)>,
    pub acquire_dquot: ::core::option::Option<unsafe extern "C" fn(arg1: *mut dquot) -> ffi::c_int>,
    pub release_dquot: ::core::option::Option<unsafe extern "C" fn(arg1: *mut dquot) -> ffi::c_int>,
    pub mark_dirty: ::core::option::Option<unsafe extern "C" fn(arg1: *mut dquot) -> ffi::c_int>,
    pub write_info: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut super_block, arg2: ffi::c_int) -> ffi::c_int,
    >,
    pub get_reserved_space:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut inode) -> *mut qsize_t>,
    pub get_projid: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut inode, arg2: *mut kprojid_t) -> ffi::c_int,
    >,
    pub get_inode_usage: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut inode, arg2: *mut qsize_t) -> ffi::c_int,
    >,
    pub get_next_id: ::core::option::Option<
        unsafe extern "C" fn(sb: *mut super_block, qid: *mut kqid) -> ffi::c_int,
    >,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct qc_dqblk {
    pub d_fieldmask: ffi::c_int,
    pub d_spc_hardlimit: u64_,
    pub d_spc_softlimit: u64_,
    pub d_ino_hardlimit: u64_,
    pub d_ino_softlimit: u64_,
    pub d_space: u64_,
    pub d_ino_count: u64_,
    pub d_ino_timer: s64,
    pub d_spc_timer: s64,
    pub d_ino_warns: ffi::c_int,
    pub d_spc_warns: ffi::c_int,
    pub d_rt_spc_hardlimit: u64_,
    pub d_rt_spc_softlimit: u64_,
    pub d_rt_space: u64_,
    pub d_rt_spc_timer: s64,
    pub d_rt_spc_warns: ffi::c_int,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct qc_type_state {
    pub flags: ffi::c_uint,
    pub spc_timelimit: ffi::c_uint,
    pub ino_timelimit: ffi::c_uint,
    pub rt_spc_timelimit: ffi::c_uint,
    pub spc_warnlimit: ffi::c_uint,
    pub ino_warnlimit: ffi::c_uint,
    pub rt_spc_warnlimit: ffi::c_uint,
    pub ino: ffi::c_ulonglong,
    pub blocks: blkcnt_t,
    pub nextents: blkcnt_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct qc_state {
    pub s_incoredqs: ffi::c_uint,
    pub s_state: [qc_type_state; 3usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct qc_info {
    pub i_fieldmask: ffi::c_int,
    pub i_flags: ffi::c_uint,
    pub i_spc_timelimit: ffi::c_uint,
    pub i_ino_timelimit: ffi::c_uint,
    pub i_rt_spc_timelimit: ffi::c_uint,
    pub i_spc_warnlimit: ffi::c_uint,
    pub i_ino_warnlimit: ffi::c_uint,
    pub i_rt_spc_warnlimit: ffi::c_uint,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct quotactl_ops {
    pub quota_on: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut super_block,
            arg2: ffi::c_int,
            arg3: ffi::c_int,
            arg4: *const path,
        ) -> ffi::c_int,
    >,
    pub quota_off: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut super_block, arg2: ffi::c_int) -> ffi::c_int,
    >,
    pub quota_enable: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut super_block, arg2: ffi::c_uint) -> ffi::c_int,
    >,
    pub quota_disable: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut super_block, arg2: ffi::c_uint) -> ffi::c_int,
    >,
    pub quota_sync: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut super_block, arg2: ffi::c_int) -> ffi::c_int,
    >,
    pub set_info: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut super_block,
            arg2: ffi::c_int,
            arg3: *mut qc_info,
        ) -> ffi::c_int,
    >,
    pub get_dqblk: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut super_block, arg2: kqid, arg3: *mut qc_dqblk) -> ffi::c_int,
    >,
    pub get_nextdqblk: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut super_block,
            arg2: *mut kqid,
            arg3: *mut qc_dqblk,
        ) -> ffi::c_int,
    >,
    pub set_dqblk: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut super_block, arg2: kqid, arg3: *mut qc_dqblk) -> ffi::c_int,
    >,
    pub get_state: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut super_block, arg2: *mut qc_state) -> ffi::c_int,
    >,
    pub rm_xquota: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut super_block, arg2: ffi::c_uint) -> ffi::c_int,
    >,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct quota_format_type {
    pub qf_fmt_id: ffi::c_int,
    pub qf_ops: *const quota_format_ops,
    pub qf_owner: *mut module,
    pub qf_next: *mut quota_format_type,
}
impl Default for quota_format_type {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const _DQUOT_USAGE_ENABLED: _bindgen_ty_87 = 0;
pub const _DQUOT_LIMITS_ENABLED: _bindgen_ty_87 = 1;
pub const _DQUOT_SUSPENDED: _bindgen_ty_87 = 2;
pub const _DQUOT_STATE_FLAGS: _bindgen_ty_87 = 3;
pub type _bindgen_ty_87 = ffi::c_uint;
extern "C" {
    pub fn quota_send_warning(qid: kqid, dev: dev_t, warntype: ffi::c_char);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct quota_info {
    pub flags: ffi::c_uint,
    pub dqio_sem: rw_semaphore,
    pub files: [*mut inode; 3usize],
    pub info: [mem_dqinfo; 3usize],
    pub ops: [*const quota_format_ops; 3usize],
}
impl Default for quota_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn register_quota_format(fmt: *mut quota_format_type);
}
extern "C" {
    pub fn unregister_quota_format(fmt: *mut quota_format_type);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct quota_module_name {
    pub qm_fmt_id: ffi::c_int,
    pub qm_mod_name: *mut ffi::c_char,
}
impl Default for quota_module_name {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const positive_aop_returns_AOP_WRITEPAGE_ACTIVATE: positive_aop_returns = 524288;
pub const positive_aop_returns_AOP_TRUNCATED_PAGE: positive_aop_returns = 524289;
pub type positive_aop_returns = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct readahead_control {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kiocb {
    pub ki_filp: *mut file,
    pub ki_pos: loff_t,
    pub ki_complete:
        ::core::option::Option<unsafe extern "C" fn(iocb: *mut kiocb, ret: ffi::c_long)>,
    pub private: *mut ffi::c_void,
    pub ki_flags: ffi::c_int,
    pub ki_ioprio: u16_,
    pub __bindgen_anon_1: kiocb__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union kiocb__bindgen_ty_1 {
    pub ki_waitq: *mut wait_page_queue,
    pub dio_complete: ::core::option::Option<unsafe extern "C" fn(data: *mut ffi::c_void) -> isize>,
}
impl Default for kiocb__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for kiocb {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct address_space_operations {
    pub writepage: ::core::option::Option<
        unsafe extern "C" fn(page: *mut page, wbc: *mut writeback_control) -> ffi::c_int,
    >,
    pub read_folio: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut file, arg2: *mut folio) -> ffi::c_int,
    >,
    pub writepages: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut address_space, arg2: *mut writeback_control) -> ffi::c_int,
    >,
    pub dirty_folio: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut address_space, arg2: *mut folio) -> bool_,
    >,
    pub readahead: ::core::option::Option<unsafe extern "C" fn(arg1: *mut readahead_control)>,
    pub write_begin: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut file,
            mapping: *mut address_space,
            pos: loff_t,
            len: ffi::c_uint,
            foliop: *mut *mut folio,
            fsdata: *mut *mut ffi::c_void,
        ) -> ffi::c_int,
    >,
    pub write_end: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut file,
            mapping: *mut address_space,
            pos: loff_t,
            len: ffi::c_uint,
            copied: ffi::c_uint,
            folio: *mut folio,
            fsdata: *mut ffi::c_void,
        ) -> ffi::c_int,
    >,
    pub bmap: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut address_space, arg2: sector_t) -> sector_t,
    >,
    pub invalidate_folio:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut folio, offset: usize, len: usize)>,
    pub release_folio:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut folio, arg2: gfp_t) -> bool_>,
    pub free_folio: ::core::option::Option<unsafe extern "C" fn(folio: *mut folio)>,
    pub direct_IO: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut kiocb, iter: *mut iov_iter) -> isize,
    >,
    pub migrate_folio: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut address_space,
            dst: *mut folio,
            src: *mut folio,
            arg2: migrate_mode,
        ) -> ffi::c_int,
    >,
    pub launder_folio: ::core::option::Option<unsafe extern "C" fn(arg1: *mut folio) -> ffi::c_int>,
    pub is_partially_uptodate: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut folio, from: usize, count: usize) -> bool_,
    >,
    pub is_dirty_writeback: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut folio, dirty: *mut bool_, wb: *mut bool_),
    >,
    pub error_remove_folio: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut address_space, arg2: *mut folio) -> ffi::c_int,
    >,
    pub swap_activate: ::core::option::Option<
        unsafe extern "C" fn(
            sis: *mut swap_info_struct,
            file: *mut file,
            span: *mut sector_t,
        ) -> ffi::c_int,
    >,
    pub swap_deactivate: ::core::option::Option<unsafe extern "C" fn(file: *mut file)>,
    pub swap_rw: ::core::option::Option<
        unsafe extern "C" fn(iocb: *mut kiocb, iter: *mut iov_iter) -> ffi::c_int,
    >,
}
extern "C" {
    pub static empty_aops: address_space_operations;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct address_space {
    pub host: *mut inode,
    pub i_pages: xarray,
    pub invalidate_lock: rw_semaphore,
    pub gfp_mask: gfp_t,
    pub i_mmap_writable: atomic_t,
    pub nr_thps: atomic_t,
    pub i_mmap: rb_root_cached,
    pub nrpages: ffi::c_ulong,
    pub writeback_index: ffi::c_ulong,
    pub a_ops: *const address_space_operations,
    pub flags: ffi::c_ulong,
    pub wb_err: errseq_t,
    pub i_private_lock: spinlock_t,
    pub i_private_list: list_head,
    pub i_mmap_rwsem: rw_semaphore,
    pub i_private_data: *mut ffi::c_void,
}
impl Default for address_space {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct posix_acl {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct inode {
    pub i_mode: umode_t,
    pub i_opflags: ffi::c_ushort,
    pub i_uid: kuid_t,
    pub i_gid: kgid_t,
    pub i_flags: ffi::c_uint,
    pub i_acl: *mut posix_acl,
    pub i_default_acl: *mut posix_acl,
    pub i_op: *const inode_operations,
    pub i_sb: *mut super_block,
    pub i_mapping: *mut address_space,
    pub i_security: *mut ffi::c_void,
    pub i_ino: ffi::c_ulong,
    pub __bindgen_anon_1: inode__bindgen_ty_1,
    pub i_rdev: dev_t,
    pub i_size: loff_t,
    pub i_atime_sec: time64_t,
    pub i_mtime_sec: time64_t,
    pub i_ctime_sec: time64_t,
    pub i_atime_nsec: u32_,
    pub i_mtime_nsec: u32_,
    pub i_ctime_nsec: u32_,
    pub i_generation: u32_,
    pub i_lock: spinlock_t,
    pub i_bytes: ffi::c_ushort,
    pub i_blkbits: u8_,
    pub i_write_hint: rw_hint,
    pub i_blocks: blkcnt_t,
    pub i_state: u32_,
    pub i_rwsem: rw_semaphore,
    pub dirtied_when: ffi::c_ulong,
    pub dirtied_time_when: ffi::c_ulong,
    pub i_hash: hlist_node,
    pub i_io_list: list_head,
    pub i_wb: *mut bdi_writeback,
    pub i_wb_frn_winner: ffi::c_int,
    pub i_wb_frn_avg_time: u16_,
    pub i_wb_frn_history: u16_,
    pub i_lru: list_head,
    pub i_sb_list: list_head,
    pub i_wb_list: list_head,
    pub __bindgen_anon_2: inode__bindgen_ty_2,
    pub i_version: atomic64_t,
    pub i_sequence: atomic64_t,
    pub i_count: atomic_t,
    pub i_dio_count: atomic_t,
    pub i_writecount: atomic_t,
    pub i_readcount: atomic_t,
    pub __bindgen_anon_3: inode__bindgen_ty_3,
    pub i_flctx: *mut file_lock_context,
    pub i_data: address_space,
    pub __bindgen_anon_4: inode__bindgen_ty_4,
    pub __bindgen_anon_5: inode__bindgen_ty_5,
    pub i_fsnotify_mask: __u32,
    pub i_fsnotify_marks: *mut fsnotify_mark_connector,
    pub i_crypt_info: *mut fscrypt_inode_info,
    pub i_verity_info: *mut fsverity_info,
    pub i_private: *mut ffi::c_void,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union inode__bindgen_ty_1 {
    pub i_nlink: ffi::c_uint,
    pub __i_nlink: ffi::c_uint,
}
impl Default for inode__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union inode__bindgen_ty_2 {
    pub i_dentry: hlist_head,
    pub i_rcu: callback_head,
}
impl Default for inode__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union inode__bindgen_ty_3 {
    pub i_fop: *const file_operations,
    pub free_inode: ::core::option::Option<unsafe extern "C" fn(arg1: *mut inode)>,
}
impl Default for inode__bindgen_ty_3 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union inode__bindgen_ty_4 {
    pub i_devices: list_head,
    pub i_linklen: ffi::c_int,
}
impl Default for inode__bindgen_ty_4 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union inode__bindgen_ty_5 {
    pub i_pipe: *mut pipe_inode_info,
    pub i_cdev: *mut cdev,
    pub i_link: *mut ffi::c_char,
    pub i_dir_seq: ffi::c_uint,
}
impl Default for inode__bindgen_ty_5 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for inode {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn inode_bit_waitqueue(
        wqe: *mut wait_bit_queue_entry,
        inode: *mut inode,
        bit: u32_,
    ) -> *mut wait_queue_head;
}
extern "C" {
    pub fn timestamp_truncate(t: timespec64, inode: *mut inode) -> timespec64;
}
pub const inode_i_mutex_lock_class_I_MUTEX_NORMAL: inode_i_mutex_lock_class = 0;
pub const inode_i_mutex_lock_class_I_MUTEX_PARENT: inode_i_mutex_lock_class = 1;
pub const inode_i_mutex_lock_class_I_MUTEX_CHILD: inode_i_mutex_lock_class = 2;
pub const inode_i_mutex_lock_class_I_MUTEX_XATTR: inode_i_mutex_lock_class = 3;
pub const inode_i_mutex_lock_class_I_MUTEX_NONDIR2: inode_i_mutex_lock_class = 4;
pub const inode_i_mutex_lock_class_I_MUTEX_PARENT2: inode_i_mutex_lock_class = 5;
pub type inode_i_mutex_lock_class = ffi::c_uint;
extern "C" {
    pub fn lock_two_nondirectories(arg1: *mut inode, arg2: *mut inode);
}
extern "C" {
    pub fn unlock_two_nondirectories(arg1: *mut inode, arg2: *mut inode);
}
extern "C" {
    pub fn filemap_invalidate_lock_two(mapping1: *mut address_space, mapping2: *mut address_space);
}
extern "C" {
    pub fn filemap_invalidate_unlock_two(
        mapping1: *mut address_space,
        mapping2: *mut address_space,
    );
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fown_struct {
    pub file: *mut file,
    pub lock: rwlock_t,
    pub pid: *mut pid,
    pub pid_type: pid_type,
    pub uid: kuid_t,
    pub euid: kuid_t,
    pub signum: ffi::c_int,
}
impl Default for fown_struct {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct file_ra_state {
    pub start: ffi::c_ulong,
    pub size: ffi::c_uint,
    pub async_size: ffi::c_uint,
    pub ra_pages: ffi::c_uint,
    pub mmap_miss: ffi::c_uint,
    pub prev_pos: loff_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct file {
    pub f_lock: spinlock_t,
    pub f_mode: fmode_t,
    pub f_op: *const file_operations,
    pub f_mapping: *mut address_space,
    pub private_data: *mut ffi::c_void,
    pub f_inode: *mut inode,
    pub f_flags: ffi::c_uint,
    pub f_iocb_flags: ffi::c_uint,
    pub f_cred: *const cred,
    pub f_owner: *mut fown_struct,
    pub f_path: path,
    pub __bindgen_anon_1: file__bindgen_ty_1,
    pub f_pos: loff_t,
    pub f_security: *mut ffi::c_void,
    pub f_wb_err: errseq_t,
    pub f_sb_err: errseq_t,
    pub f_ep: *mut hlist_head,
    pub __bindgen_anon_2: file__bindgen_ty_2,
    pub f_ref: file_ref_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union file__bindgen_ty_1 {
    pub f_pos_lock: mutex,
    pub f_pipe: u64_,
}
impl Default for file__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union file__bindgen_ty_2 {
    pub f_task_work: callback_head,
    pub f_llist: llist_node,
    pub f_ra: file_ra_state,
    pub f_freeptr: freeptr_t,
}
impl Default for file__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for file {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default)]
pub struct file_handle {
    pub handle_bytes: __u32,
    pub handle_type: ffi::c_int,
    pub f_handle: __IncompleteArrayField<ffi::c_uchar>,
}
extern "C" {
    pub fn get_file_rcu(f: *mut *mut file) -> *mut file;
}
extern "C" {
    pub fn get_file_active(f: *mut *mut file) -> *mut file;
}
pub type fl_owner_t = *mut ffi::c_void;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct file_lock {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct file_lease {
    _unused: [u8; 0],
}
extern "C" {
    pub fn file_f_owner_allocate(file: *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn send_sigio(fown: *mut fown_struct, fd: ffi::c_int, band: ffi::c_int);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fasync_struct {
    pub fa_lock: rwlock_t,
    pub magic: ffi::c_int,
    pub fa_fd: ffi::c_int,
    pub fa_next: *mut fasync_struct,
    pub fa_file: *mut file,
    pub fa_rcu: callback_head,
}
impl Default for fasync_struct {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn fasync_helper(
        arg1: ffi::c_int,
        arg2: *mut file,
        arg3: ffi::c_int,
        arg4: *mut *mut fasync_struct,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn fasync_insert_entry(
        arg1: ffi::c_int,
        arg2: *mut file,
        arg3: *mut *mut fasync_struct,
        arg4: *mut fasync_struct,
    ) -> *mut fasync_struct;
}
extern "C" {
    pub fn fasync_remove_entry(arg1: *mut file, arg2: *mut *mut fasync_struct) -> ffi::c_int;
}
extern "C" {
    pub fn fasync_alloc() -> *mut fasync_struct;
}
extern "C" {
    pub fn fasync_free(arg1: *mut fasync_struct);
}
extern "C" {
    pub fn kill_fasync(arg1: *mut *mut fasync_struct, arg2: ffi::c_int, arg3: ffi::c_int);
}
extern "C" {
    pub fn __f_setown(filp: *mut file, arg1: *mut pid, arg2: pid_type, force: ffi::c_int);
}
extern "C" {
    pub fn f_setown(filp: *mut file, who: ffi::c_int, force: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn f_delown(filp: *mut file);
}
extern "C" {
    pub fn f_getown(filp: *mut file) -> pid_t;
}
extern "C" {
    pub fn send_sigurg(file: *mut file) -> ffi::c_int;
}
pub const SB_UNFROZEN: _bindgen_ty_88 = 0;
pub const SB_FREEZE_WRITE: _bindgen_ty_88 = 1;
pub const SB_FREEZE_PAGEFAULT: _bindgen_ty_88 = 2;
pub const SB_FREEZE_FS: _bindgen_ty_88 = 3;
pub const SB_FREEZE_COMPLETE: _bindgen_ty_88 = 4;
pub type _bindgen_ty_88 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sb_writers {
    pub frozen: ffi::c_ushort,
    pub freeze_kcount: ffi::c_int,
    pub freeze_ucount: ffi::c_int,
    pub rw_sem: [percpu_rw_semaphore; 3usize],
}
impl Default for sb_writers {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct super_block {
    pub s_list: list_head,
    pub s_dev: dev_t,
    pub s_blocksize_bits: ffi::c_uchar,
    pub s_blocksize: ffi::c_ulong,
    pub s_maxbytes: loff_t,
    pub s_type: *mut file_system_type,
    pub s_op: *const super_operations,
    pub dq_op: *const dquot_operations,
    pub s_qcop: *const quotactl_ops,
    pub s_export_op: *const export_operations,
    pub s_flags: ffi::c_ulong,
    pub s_iflags: ffi::c_ulong,
    pub s_magic: ffi::c_ulong,
    pub s_root: *mut dentry,
    pub s_umount: rw_semaphore,
    pub s_count: ffi::c_int,
    pub s_active: atomic_t,
    pub s_security: *mut ffi::c_void,
    pub s_xattr: *const *mut xattr_handler,
    pub s_cop: *const fscrypt_operations,
    pub s_master_keys: *mut fscrypt_keyring,
    pub s_vop: *const fsverity_operations,
    pub s_encoding: *mut unicode_map,
    pub s_encoding_flags: __u16,
    pub s_roots: hlist_bl_head,
    pub s_mounts: list_head,
    pub s_bdev: *mut block_device,
    pub s_bdev_file: *mut file,
    pub s_bdi: *mut backing_dev_info,
    pub s_mtd: *mut mtd_info,
    pub s_instances: hlist_node,
    pub s_quota_types: ffi::c_uint,
    pub s_dquot: quota_info,
    pub s_writers: sb_writers,
    pub s_fs_info: *mut ffi::c_void,
    pub s_time_gran: u32_,
    pub s_time_min: time64_t,
    pub s_time_max: time64_t,
    pub s_fsnotify_mask: u32_,
    pub s_fsnotify_info: *mut fsnotify_sb_info,
    pub s_id: [ffi::c_char; 32usize],
    pub s_uuid: uuid_t,
    pub s_uuid_len: u8_,
    pub s_sysfs_name: [ffi::c_char; 37usize],
    pub s_max_links: ffi::c_uint,
    pub s_vfs_rename_mutex: mutex,
    pub s_subtype: *const ffi::c_char,
    pub s_d_op: *const dentry_operations,
    pub s_shrink: *mut shrinker,
    pub s_remove_count: atomic_long_t,
    pub s_readonly_remount: ffi::c_int,
    pub s_wb_err: errseq_t,
    pub s_dio_done_wq: *mut workqueue_struct,
    pub s_pins: hlist_head,
    pub s_user_ns: *mut user_namespace,
    pub s_dentry_lru: list_lru,
    pub s_inode_lru: list_lru,
    pub rcu: callback_head,
    pub destroy_work: work_struct,
    pub s_sync_lock: mutex,
    pub s_stack_depth: ffi::c_int,
    pub __bindgen_padding_0: [u32; 3usize],
    pub s_inode_list_lock: spinlock_t,
    pub s_inodes: list_head,
    pub s_inode_wblist_lock: spinlock_t,
    pub s_inodes_wb: list_head,
}
impl Default for super_block {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn current_time(inode: *mut inode) -> timespec64;
}
extern "C" {
    pub fn inode_set_ctime_current(inode: *mut inode) -> timespec64;
}
extern "C" {
    pub fn inode_set_ctime_deleg(inode: *mut inode, update: timespec64) -> timespec64;
}
extern "C" {
    pub fn inode_set_ctime_to_ts(inode: *mut inode, ts: timespec64) -> timespec64;
}
extern "C" {
    pub fn simple_inode_init_ts(inode: *mut inode) -> timespec64;
}
extern "C" {
    pub fn inode_owner_or_capable(idmap: *mut mnt_idmap, inode: *const inode) -> bool_;
}
extern "C" {
    pub fn vfs_create(
        arg1: *mut mnt_idmap,
        arg2: *mut inode,
        arg3: *mut dentry,
        arg4: umode_t,
        arg5: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vfs_mkdir(
        arg1: *mut mnt_idmap,
        arg2: *mut inode,
        arg3: *mut dentry,
        arg4: umode_t,
    ) -> *mut dentry;
}
extern "C" {
    pub fn vfs_mknod(
        arg1: *mut mnt_idmap,
        arg2: *mut inode,
        arg3: *mut dentry,
        arg4: umode_t,
        arg5: dev_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vfs_symlink(
        arg1: *mut mnt_idmap,
        arg2: *mut inode,
        arg3: *mut dentry,
        arg4: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vfs_link(
        arg1: *mut dentry,
        arg2: *mut mnt_idmap,
        arg3: *mut inode,
        arg4: *mut dentry,
        arg5: *mut *mut inode,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vfs_rmdir(arg1: *mut mnt_idmap, arg2: *mut inode, arg3: *mut dentry) -> ffi::c_int;
}
extern "C" {
    pub fn vfs_unlink(
        arg1: *mut mnt_idmap,
        arg2: *mut inode,
        arg3: *mut dentry,
        arg4: *mut *mut inode,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct renamedata {
    pub old_mnt_idmap: *mut mnt_idmap,
    pub old_dir: *mut inode,
    pub old_dentry: *mut dentry,
    pub new_mnt_idmap: *mut mnt_idmap,
    pub new_dir: *mut inode,
    pub new_dentry: *mut dentry,
    pub delegated_inode: *mut *mut inode,
    pub flags: ffi::c_uint,
}
impl Default for renamedata {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn vfs_rename(arg1: *mut renamedata) -> ffi::c_int;
}
extern "C" {
    pub fn kernel_tmpfile_open(
        idmap: *mut mnt_idmap,
        parentpath: *const path,
        mode: umode_t,
        open_flag: ffi::c_int,
        cred: *const cred,
    ) -> *mut file;
}
extern "C" {
    pub fn kernel_file_open(path: *const path, flags: ffi::c_int, cred: *const cred) -> *mut file;
}
extern "C" {
    pub fn vfs_mkobj(
        arg1: *mut dentry,
        arg2: umode_t,
        f: ::core::option::Option<
            unsafe extern "C" fn(
                arg1: *mut dentry,
                arg2: umode_t,
                arg3: *mut ffi::c_void,
            ) -> ffi::c_int,
        >,
        arg3: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vfs_fchown(file: *mut file, user: uid_t, group: gid_t) -> ffi::c_int;
}
extern "C" {
    pub fn vfs_fchmod(file: *mut file, mode: umode_t) -> ffi::c_int;
}
extern "C" {
    pub fn vfs_utimes(path: *const path, times: *mut timespec64) -> ffi::c_int;
}
extern "C" {
    pub fn vfs_ioctl(file: *mut file, cmd: ffi::c_uint, arg: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn compat_ptr_ioctl(file: *mut file, cmd: ffi::c_uint, arg: ffi::c_ulong) -> ffi::c_long;
}
extern "C" {
    pub fn inode_init_owner(
        idmap: *mut mnt_idmap,
        inode: *mut inode,
        dir: *const inode,
        mode: umode_t,
    );
}
extern "C" {
    pub fn may_open_dev(path: *const path) -> bool_;
}
extern "C" {
    pub fn mode_strip_sgid(idmap: *mut mnt_idmap, dir: *const inode, mode: umode_t) -> umode_t;
}
extern "C" {
    pub fn in_group_or_capable(
        idmap: *mut mnt_idmap,
        inode: *const inode,
        vfsgid: vfsgid_t,
    ) -> bool_;
}
pub type filldir_t = ::core::option::Option<
    unsafe extern "C" fn(
        arg1: *mut dir_context,
        arg2: *const ffi::c_char,
        arg3: ffi::c_int,
        arg4: loff_t,
        arg5: u64_,
        arg6: ffi::c_uint,
    ) -> bool_,
>;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct dir_context {
    pub actor: filldir_t,
    pub pos: loff_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct io_uring_cmd {
    _unused: [u8; 0],
}
pub type fop_flags_t = ffi::c_uint;
extern "C" {
    pub fn wrap_directory_iterator(
        arg1: *mut file,
        arg2: *mut dir_context,
        arg3: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut file, arg2: *mut dir_context) -> ffi::c_int,
        >,
    ) -> ffi::c_int;
}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct inode_operations {
    pub lookup: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut inode, arg2: *mut dentry, arg3: ffi::c_uint) -> *mut dentry,
    >,
    pub get_link: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut dentry,
            arg2: *mut inode,
            arg3: *mut delayed_call,
        ) -> *const ffi::c_char,
    >,
    pub permission: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut mnt_idmap,
            arg2: *mut inode,
            arg3: ffi::c_int,
        ) -> ffi::c_int,
    >,
    pub get_inode_acl: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut inode, arg2: ffi::c_int, arg3: bool_) -> *mut posix_acl,
    >,
    pub readlink: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut dentry,
            arg2: *mut ffi::c_char,
            arg3: ffi::c_int,
        ) -> ffi::c_int,
    >,
    pub create: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut mnt_idmap,
            arg2: *mut inode,
            arg3: *mut dentry,
            arg4: umode_t,
            arg5: bool_,
        ) -> ffi::c_int,
    >,
    pub link: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut dentry, arg2: *mut inode, arg3: *mut dentry) -> ffi::c_int,
    >,
    pub unlink: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut inode, arg2: *mut dentry) -> ffi::c_int,
    >,
    pub symlink: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut mnt_idmap,
            arg2: *mut inode,
            arg3: *mut dentry,
            arg4: *const ffi::c_char,
        ) -> ffi::c_int,
    >,
    pub mkdir: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut mnt_idmap,
            arg2: *mut inode,
            arg3: *mut dentry,
            arg4: umode_t,
        ) -> *mut dentry,
    >,
    pub rmdir: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut inode, arg2: *mut dentry) -> ffi::c_int,
    >,
    pub mknod: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut mnt_idmap,
            arg2: *mut inode,
            arg3: *mut dentry,
            arg4: umode_t,
            arg5: dev_t,
        ) -> ffi::c_int,
    >,
    pub rename: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut mnt_idmap,
            arg2: *mut inode,
            arg3: *mut dentry,
            arg4: *mut inode,
            arg5: *mut dentry,
            arg6: ffi::c_uint,
        ) -> ffi::c_int,
    >,
    pub setattr: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut mnt_idmap,
            arg2: *mut dentry,
            arg3: *mut iattr,
        ) -> ffi::c_int,
    >,
    pub getattr: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut mnt_idmap,
            arg2: *const path,
            arg3: *mut kstat,
            arg4: u32_,
            arg5: ffi::c_uint,
        ) -> ffi::c_int,
    >,
    pub listxattr: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut dentry, arg2: *mut ffi::c_char, arg3: usize) -> isize,
    >,
    pub fiemap: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut inode,
            arg2: *mut fiemap_extent_info,
            start: u64_,
            len: u64_,
        ) -> ffi::c_int,
    >,
    pub update_time: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut inode, arg2: ffi::c_int) -> ffi::c_int,
    >,
    pub atomic_open: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut inode,
            arg2: *mut dentry,
            arg3: *mut file,
            open_flag: ffi::c_uint,
            create_mode: umode_t,
        ) -> ffi::c_int,
    >,
    pub tmpfile: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut mnt_idmap,
            arg2: *mut inode,
            arg3: *mut file,
            arg4: umode_t,
        ) -> ffi::c_int,
    >,
    pub get_acl: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut mnt_idmap,
            arg2: *mut dentry,
            arg3: ffi::c_int,
        ) -> *mut posix_acl,
    >,
    pub set_acl: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut mnt_idmap,
            arg2: *mut dentry,
            arg3: *mut posix_acl,
            arg4: ffi::c_int,
        ) -> ffi::c_int,
    >,
    pub fileattr_set: ::core::option::Option<
        unsafe extern "C" fn(
            idmap: *mut mnt_idmap,
            dentry: *mut dentry,
            fa: *mut fileattr,
        ) -> ffi::c_int,
    >,
    pub fileattr_get: ::core::option::Option<
        unsafe extern "C" fn(dentry: *mut dentry, fa: *mut fileattr) -> ffi::c_int,
    >,
    pub get_offset_ctx:
        ::core::option::Option<unsafe extern "C" fn(inode: *mut inode) -> *mut offset_ctx>,
}
impl Default for inode_operations {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn vfs_read(
        arg1: *mut file,
        arg2: *mut ffi::c_char,
        arg3: usize,
        arg4: *mut loff_t,
    ) -> isize;
}
extern "C" {
    pub fn vfs_write(
        arg1: *mut file,
        arg2: *const ffi::c_char,
        arg3: usize,
        arg4: *mut loff_t,
    ) -> isize;
}
extern "C" {
    pub fn vfs_copy_file_range(
        arg1: *mut file,
        arg2: loff_t,
        arg3: *mut file,
        arg4: loff_t,
        arg5: usize,
        arg6: ffi::c_uint,
    ) -> isize;
}
extern "C" {
    pub fn remap_verify_area(file: *mut file, pos: loff_t, len: loff_t, write: bool_)
        -> ffi::c_int;
}
extern "C" {
    pub fn __generic_remap_file_range_prep(
        file_in: *mut file,
        pos_in: loff_t,
        file_out: *mut file,
        pos_out: loff_t,
        len: *mut loff_t,
        remap_flags: ffi::c_uint,
        dax_read_ops: *const iomap_ops,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn generic_remap_file_range_prep(
        file_in: *mut file,
        pos_in: loff_t,
        file_out: *mut file,
        pos_out: loff_t,
        count: *mut loff_t,
        remap_flags: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vfs_clone_file_range(
        file_in: *mut file,
        pos_in: loff_t,
        file_out: *mut file,
        pos_out: loff_t,
        len: loff_t,
        remap_flags: ffi::c_uint,
    ) -> loff_t;
}
extern "C" {
    pub fn vfs_dedupe_file_range(file: *mut file, same: *mut file_dedupe_range) -> ffi::c_int;
}
extern "C" {
    pub fn vfs_dedupe_file_range_one(
        src_file: *mut file,
        src_pos: loff_t,
        dst_file: *mut file,
        dst_pos: loff_t,
        len: loff_t,
        remap_flags: ffi::c_uint,
    ) -> loff_t;
}
pub const freeze_holder_FREEZE_HOLDER_KERNEL: freeze_holder = 1;
pub const freeze_holder_FREEZE_HOLDER_USERSPACE: freeze_holder = 2;
pub const freeze_holder_FREEZE_MAY_NEST: freeze_holder = 4;
pub type freeze_holder = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct super_operations {
    pub alloc_inode:
        ::core::option::Option<unsafe extern "C" fn(sb: *mut super_block) -> *mut inode>,
    pub destroy_inode: ::core::option::Option<unsafe extern "C" fn(arg1: *mut inode)>,
    pub free_inode: ::core::option::Option<unsafe extern "C" fn(arg1: *mut inode)>,
    pub dirty_inode:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut inode, flags: ffi::c_int)>,
    pub write_inode: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut inode, wbc: *mut writeback_control) -> ffi::c_int,
    >,
    pub drop_inode: ::core::option::Option<unsafe extern "C" fn(arg1: *mut inode) -> ffi::c_int>,
    pub evict_inode: ::core::option::Option<unsafe extern "C" fn(arg1: *mut inode)>,
    pub put_super: ::core::option::Option<unsafe extern "C" fn(arg1: *mut super_block)>,
    pub sync_fs: ::core::option::Option<
        unsafe extern "C" fn(sb: *mut super_block, wait: ffi::c_int) -> ffi::c_int,
    >,
    pub freeze_super: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut super_block, who: freeze_holder) -> ffi::c_int,
    >,
    pub freeze_fs:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut super_block) -> ffi::c_int>,
    pub thaw_super: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut super_block, who: freeze_holder) -> ffi::c_int,
    >,
    pub unfreeze_fs:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut super_block) -> ffi::c_int>,
    pub statfs: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut dentry, arg2: *mut kstatfs) -> ffi::c_int,
    >,
    pub remount_fs: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut super_block,
            arg2: *mut ffi::c_int,
            arg3: *mut ffi::c_char,
        ) -> ffi::c_int,
    >,
    pub umount_begin: ::core::option::Option<unsafe extern "C" fn(arg1: *mut super_block)>,
    pub show_options: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut seq_file, arg2: *mut dentry) -> ffi::c_int,
    >,
    pub show_devname: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut seq_file, arg2: *mut dentry) -> ffi::c_int,
    >,
    pub show_path: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut seq_file, arg2: *mut dentry) -> ffi::c_int,
    >,
    pub show_stats: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut seq_file, arg2: *mut dentry) -> ffi::c_int,
    >,
    pub quota_read: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut super_block,
            arg2: ffi::c_int,
            arg3: *mut ffi::c_char,
            arg4: usize,
            arg5: loff_t,
        ) -> isize,
    >,
    pub quota_write: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut super_block,
            arg2: ffi::c_int,
            arg3: *const ffi::c_char,
            arg4: usize,
            arg5: loff_t,
        ) -> isize,
    >,
    pub get_dquots:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut inode) -> *mut *mut dquot>,
    pub nr_cached_objects: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut super_block, arg2: *mut shrink_control) -> ffi::c_long,
    >,
    pub free_cached_objects: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut super_block, arg2: *mut shrink_control) -> ffi::c_long,
    >,
    pub shutdown: ::core::option::Option<unsafe extern "C" fn(sb: *mut super_block)>,
}
extern "C" {
    pub fn __mark_inode_dirty(arg1: *mut inode, arg2: ffi::c_int);
}
extern "C" {
    pub fn inc_nlink(inode: *mut inode);
}
extern "C" {
    pub fn drop_nlink(inode: *mut inode);
}
extern "C" {
    pub fn clear_nlink(inode: *mut inode);
}
extern "C" {
    pub fn set_nlink(inode: *mut inode, nlink: ffi::c_uint);
}
pub const file_time_flags_S_ATIME: file_time_flags = 1;
pub const file_time_flags_S_MTIME: file_time_flags = 2;
pub const file_time_flags_S_CTIME: file_time_flags = 4;
pub const file_time_flags_S_VERSION: file_time_flags = 8;
pub type file_time_flags = ffi::c_uint;
extern "C" {
    pub fn atime_needs_update(arg1: *const path, arg2: *mut inode) -> bool_;
}
extern "C" {
    pub fn touch_atime(arg1: *const path);
}
extern "C" {
    pub fn inode_update_time(inode: *mut inode, flags: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn file_modified(file: *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn kiocb_modified(iocb: *mut kiocb) -> ffi::c_int;
}
extern "C" {
    pub fn sync_inode_metadata(inode: *mut inode, wait: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn mount_bdev(
        fs_type: *mut file_system_type,
        flags: ffi::c_int,
        dev_name: *const ffi::c_char,
        data: *mut ffi::c_void,
        fill_super: ::core::option::Option<
            unsafe extern "C" fn(
                arg1: *mut super_block,
                arg2: *mut ffi::c_void,
                arg3: ffi::c_int,
            ) -> ffi::c_int,
        >,
    ) -> *mut dentry;
}
extern "C" {
    pub fn mount_nodev(
        fs_type: *mut file_system_type,
        flags: ffi::c_int,
        data: *mut ffi::c_void,
        fill_super: ::core::option::Option<
            unsafe extern "C" fn(
                arg1: *mut super_block,
                arg2: *mut ffi::c_void,
                arg3: ffi::c_int,
            ) -> ffi::c_int,
        >,
    ) -> *mut dentry;
}
extern "C" {
    pub fn mount_subtree(mnt: *mut vfsmount, path: *const ffi::c_char) -> *mut dentry;
}
extern "C" {
    pub fn retire_super(sb: *mut super_block);
}
extern "C" {
    pub fn generic_shutdown_super(sb: *mut super_block);
}
extern "C" {
    pub fn kill_block_super(sb: *mut super_block);
}
extern "C" {
    pub fn kill_anon_super(sb: *mut super_block);
}
extern "C" {
    pub fn kill_litter_super(sb: *mut super_block);
}
extern "C" {
    pub fn deactivate_super(sb: *mut super_block);
}
extern "C" {
    pub fn deactivate_locked_super(sb: *mut super_block);
}
extern "C" {
    pub fn set_anon_super(s: *mut super_block, data: *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn set_anon_super_fc(s: *mut super_block, fc: *mut fs_context) -> ffi::c_int;
}
extern "C" {
    pub fn get_anon_bdev(arg1: *mut dev_t) -> ffi::c_int;
}
extern "C" {
    pub fn free_anon_bdev(arg1: dev_t);
}
extern "C" {
    pub fn sget_fc(
        fc: *mut fs_context,
        test: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut super_block, arg2: *mut fs_context) -> ffi::c_int,
        >,
        set: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut super_block, arg2: *mut fs_context) -> ffi::c_int,
        >,
    ) -> *mut super_block;
}
extern "C" {
    pub fn sget(
        type_: *mut file_system_type,
        test: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut super_block, arg2: *mut ffi::c_void) -> ffi::c_int,
        >,
        set: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut super_block, arg2: *mut ffi::c_void) -> ffi::c_int,
        >,
        flags: ffi::c_int,
        data: *mut ffi::c_void,
    ) -> *mut super_block;
}
extern "C" {
    pub fn sget_dev(fc: *mut fs_context, dev: dev_t) -> *mut super_block;
}
extern "C" {
    pub fn register_filesystem(arg1: *mut file_system_type) -> ffi::c_int;
}
extern "C" {
    pub fn unregister_filesystem(arg1: *mut file_system_type) -> ffi::c_int;
}
extern "C" {
    pub fn vfs_statfs(arg1: *const path, arg2: *mut kstatfs) -> ffi::c_int;
}
extern "C" {
    pub fn user_statfs(arg1: *const ffi::c_char, arg2: *mut kstatfs) -> ffi::c_int;
}
extern "C" {
    pub fn fd_statfs(arg1: ffi::c_int, arg2: *mut kstatfs) -> ffi::c_int;
}
extern "C" {
    pub fn freeze_super(super_: *mut super_block, who: freeze_holder) -> ffi::c_int;
}
extern "C" {
    pub fn thaw_super(super_: *mut super_block, who: freeze_holder) -> ffi::c_int;
}
extern "C" {
    pub fn super_setup_bdi_name(sb: *mut super_block, fmt: *mut ffi::c_char, ...) -> ffi::c_int;
}
extern "C" {
    pub fn super_setup_bdi(sb: *mut super_block) -> ffi::c_int;
}
extern "C" {
    pub fn current_umask() -> ffi::c_int;
}
extern "C" {
    pub fn ihold(inode: *mut inode);
}
extern "C" {
    pub fn iput(arg1: *mut inode);
}
extern "C" {
    pub fn inode_update_timestamps(inode: *mut inode, flags: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn generic_update_time(arg1: *mut inode, arg2: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub static mut fs_kobj: *mut kobject;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct audit_names {
    _unused: [u8; 0],
}
#[repr(C)]
pub struct filename {
    pub name: *const ffi::c_char,
    pub uptr: *const ffi::c_char,
    pub refcnt: atomic_t,
    pub aname: *mut audit_names,
    pub iname: __IncompleteArrayField<ffi::c_char>,
}
impl Default for filename {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn vfs_truncate(arg1: *const path, arg2: loff_t) -> ffi::c_int;
}
extern "C" {
    pub fn do_truncate(
        arg1: *mut mnt_idmap,
        arg2: *mut dentry,
        start: loff_t,
        time_attrs: ffi::c_uint,
        filp: *mut file,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vfs_fallocate(
        file: *mut file,
        mode: ffi::c_int,
        offset: loff_t,
        len: loff_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn do_sys_open(
        dfd: ffi::c_int,
        filename: *const ffi::c_char,
        flags: ffi::c_int,
        mode: umode_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn file_open_name(arg1: *mut filename, arg2: ffi::c_int, arg3: umode_t) -> *mut file;
}
extern "C" {
    pub fn filp_open(arg1: *const ffi::c_char, arg2: ffi::c_int, arg3: umode_t) -> *mut file;
}
extern "C" {
    pub fn file_open_root(
        arg1: *const path,
        arg2: *const ffi::c_char,
        arg3: ffi::c_int,
        arg4: umode_t,
    ) -> *mut file;
}
extern "C" {
    pub fn dentry_open(path: *const path, flags: ffi::c_int, creds: *const cred) -> *mut file;
}
extern "C" {
    pub fn dentry_open_nonotify(
        path: *const path,
        flags: ffi::c_int,
        cred: *const cred,
    ) -> *mut file;
}
extern "C" {
    pub fn dentry_create(
        path: *const path,
        flags: ffi::c_int,
        mode: umode_t,
        cred: *const cred,
    ) -> *mut file;
}
extern "C" {
    pub fn backing_file_user_path(f: *mut file) -> *mut path;
}
extern "C" {
    pub fn filp_close(arg1: *mut file, id: fl_owner_t) -> ffi::c_int;
}
extern "C" {
    pub fn getname_flags(arg1: *const ffi::c_char, arg2: ffi::c_int) -> *mut filename;
}
extern "C" {
    pub fn getname_uflags(arg1: *const ffi::c_char, arg2: ffi::c_int) -> *mut filename;
}
extern "C" {
    pub fn getname_kernel(arg1: *const ffi::c_char) -> *mut filename;
}
extern "C" {
    pub fn __getname_maybe_null(arg1: *const ffi::c_char) -> *mut filename;
}
extern "C" {
    pub fn putname(name: *mut filename);
}
extern "C" {
    pub fn finish_open(
        file: *mut file,
        dentry: *mut dentry,
        open: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut inode, arg2: *mut file) -> ffi::c_int,
        >,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn finish_no_open(file: *mut file, dentry: *mut dentry) -> ffi::c_int;
}
extern "C" {
    pub fn vfs_caches_init_early();
}
extern "C" {
    pub fn vfs_caches_init();
}
extern "C" {
    pub static mut names_cachep: *mut kmem_cache;
}
extern "C" {
    pub static mut blockdev_superblock: *mut super_block;
}
extern "C" {
    pub fn emergency_thaw_all();
}
extern "C" {
    pub fn sync_filesystem(arg1: *mut super_block) -> ffi::c_int;
}
extern "C" {
    pub static def_blk_fops: file_operations;
}
extern "C" {
    pub static def_chr_fops: file_operations;
}
extern "C" {
    pub fn alloc_chrdev_region(
        arg1: *mut dev_t,
        arg2: ffi::c_uint,
        arg3: ffi::c_uint,
        arg4: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn register_chrdev_region(
        arg1: dev_t,
        arg2: ffi::c_uint,
        arg3: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __register_chrdev(
        major: ffi::c_uint,
        baseminor: ffi::c_uint,
        count: ffi::c_uint,
        name: *const ffi::c_char,
        fops: *const file_operations,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __unregister_chrdev(
        major: ffi::c_uint,
        baseminor: ffi::c_uint,
        count: ffi::c_uint,
        name: *const ffi::c_char,
    );
}
extern "C" {
    pub fn unregister_chrdev_region(arg1: dev_t, arg2: ffi::c_uint);
}
extern "C" {
    pub fn chrdev_show(arg1: *mut seq_file, arg2: off_t);
}
extern "C" {
    pub fn init_special_inode(arg1: *mut inode, arg2: umode_t, arg3: dev_t);
}
extern "C" {
    pub fn make_bad_inode(arg1: *mut inode);
}
extern "C" {
    pub fn is_bad_inode(arg1: *mut inode) -> bool_;
}
extern "C" {
    #[must_use]
    pub fn file_fdatawait_range(file: *mut file, lstart: loff_t, lend: loff_t) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn file_check_and_advance_wb_err(file: *mut file) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn file_write_and_wait_range(file: *mut file, start: loff_t, end: loff_t) -> ffi::c_int;
}
extern "C" {
    pub fn filemap_fdatawrite_range_kick(
        mapping: *mut address_space,
        start: loff_t,
        end: loff_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vfs_fsync_range(
        file: *mut file,
        start: loff_t,
        end: loff_t,
        datasync: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vfs_fsync(file: *mut file, datasync: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn sync_file_range(
        file: *mut file,
        offset: loff_t,
        nbytes: loff_t,
        flags: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn emergency_sync();
}
extern "C" {
    pub fn emergency_remount();
}
extern "C" {
    pub fn bmap(inode: *mut inode, block: *mut sector_t) -> ffi::c_int;
}
extern "C" {
    pub fn notify_change(
        arg1: *mut mnt_idmap,
        arg2: *mut dentry,
        arg3: *mut iattr,
        arg4: *mut *mut inode,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn inode_permission(arg1: *mut mnt_idmap, arg2: *mut inode, arg3: ffi::c_int)
        -> ffi::c_int;
}
extern "C" {
    pub fn generic_permission(
        arg1: *mut mnt_idmap,
        arg2: *mut inode,
        arg3: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __check_sticky(idmap: *mut mnt_idmap, dir: *mut inode, inode: *mut inode) -> ffi::c_int;
}
extern "C" {
    pub fn do_pipe_flags(arg1: *mut ffi::c_int, arg2: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn kernel_read(
        arg1: *mut file,
        arg2: *mut ffi::c_void,
        arg3: usize,
        arg4: *mut loff_t,
    ) -> isize;
}
extern "C" {
    pub fn __kernel_read(
        file: *mut file,
        buf: *mut ffi::c_void,
        count: usize,
        pos: *mut loff_t,
    ) -> isize;
}
extern "C" {
    pub fn kernel_write(
        arg1: *mut file,
        arg2: *const ffi::c_void,
        arg3: usize,
        arg4: *mut loff_t,
    ) -> isize;
}
extern "C" {
    pub fn __kernel_write(
        arg1: *mut file,
        arg2: *const ffi::c_void,
        arg3: usize,
        arg4: *mut loff_t,
    ) -> isize;
}
extern "C" {
    pub fn open_exec(arg1: *const ffi::c_char) -> *mut file;
}
extern "C" {
    pub fn is_subdir(arg1: *mut dentry, arg2: *mut dentry) -> bool_;
}
extern "C" {
    pub fn path_is_under(arg1: *const path, arg2: *const path) -> bool_;
}
extern "C" {
    pub fn file_path(arg1: *mut file, arg2: *mut ffi::c_char, arg3: ffi::c_int)
        -> *mut ffi::c_char;
}
extern "C" {
    pub fn default_llseek(file: *mut file, offset: loff_t, whence: ffi::c_int) -> loff_t;
}
extern "C" {
    pub fn vfs_llseek(file: *mut file, offset: loff_t, whence: ffi::c_int) -> loff_t;
}
extern "C" {
    pub fn inode_init_always_gfp(
        arg1: *mut super_block,
        arg2: *mut inode,
        arg3: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn inode_init_once(arg1: *mut inode);
}
extern "C" {
    pub fn address_space_init_once(mapping: *mut address_space);
}
extern "C" {
    pub fn igrab(arg1: *mut inode) -> *mut inode;
}
extern "C" {
    pub fn iunique(arg1: *mut super_block, arg2: ino_t) -> ino_t;
}
extern "C" {
    pub fn inode_needs_sync(inode: *mut inode) -> ffi::c_int;
}
extern "C" {
    pub fn generic_delete_inode(inode: *mut inode) -> ffi::c_int;
}
extern "C" {
    pub fn d_mark_dontcache(inode: *mut inode);
}
extern "C" {
    pub fn ilookup5_nowait(
        sb: *mut super_block,
        hashval: ffi::c_ulong,
        test: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut inode, arg2: *mut ffi::c_void) -> ffi::c_int,
        >,
        data: *mut ffi::c_void,
    ) -> *mut inode;
}
extern "C" {
    pub fn ilookup5(
        sb: *mut super_block,
        hashval: ffi::c_ulong,
        test: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut inode, arg2: *mut ffi::c_void) -> ffi::c_int,
        >,
        data: *mut ffi::c_void,
    ) -> *mut inode;
}
extern "C" {
    pub fn ilookup(sb: *mut super_block, ino: ffi::c_ulong) -> *mut inode;
}
extern "C" {
    pub fn inode_insert5(
        inode: *mut inode,
        hashval: ffi::c_ulong,
        test: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut inode, arg2: *mut ffi::c_void) -> ffi::c_int,
        >,
        set: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut inode, arg2: *mut ffi::c_void) -> ffi::c_int,
        >,
        data: *mut ffi::c_void,
    ) -> *mut inode;
}
extern "C" {
    pub fn iget5_locked(
        arg1: *mut super_block,
        arg2: ffi::c_ulong,
        test: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut inode, arg2: *mut ffi::c_void) -> ffi::c_int,
        >,
        set: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut inode, arg2: *mut ffi::c_void) -> ffi::c_int,
        >,
        arg3: *mut ffi::c_void,
    ) -> *mut inode;
}
extern "C" {
    pub fn iget5_locked_rcu(
        arg1: *mut super_block,
        arg2: ffi::c_ulong,
        test: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut inode, arg2: *mut ffi::c_void) -> ffi::c_int,
        >,
        set: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut inode, arg2: *mut ffi::c_void) -> ffi::c_int,
        >,
        arg3: *mut ffi::c_void,
    ) -> *mut inode;
}
extern "C" {
    pub fn iget_locked(arg1: *mut super_block, arg2: ffi::c_ulong) -> *mut inode;
}
extern "C" {
    pub fn find_inode_nowait(
        arg1: *mut super_block,
        arg2: ffi::c_ulong,
        match_: ::core::option::Option<
            unsafe extern "C" fn(
                arg1: *mut inode,
                arg2: ffi::c_ulong,
                arg3: *mut ffi::c_void,
            ) -> ffi::c_int,
        >,
        data: *mut ffi::c_void,
    ) -> *mut inode;
}
extern "C" {
    pub fn find_inode_rcu(
        arg1: *mut super_block,
        arg2: ffi::c_ulong,
        arg3: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut inode, arg2: *mut ffi::c_void) -> ffi::c_int,
        >,
        arg4: *mut ffi::c_void,
    ) -> *mut inode;
}
extern "C" {
    pub fn find_inode_by_ino_rcu(arg1: *mut super_block, arg2: ffi::c_ulong) -> *mut inode;
}
extern "C" {
    pub fn insert_inode_locked4(
        arg1: *mut inode,
        arg2: ffi::c_ulong,
        test: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut inode, arg2: *mut ffi::c_void) -> ffi::c_int,
        >,
        arg3: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn insert_inode_locked(arg1: *mut inode) -> ffi::c_int;
}
extern "C" {
    pub fn unlock_new_inode(arg1: *mut inode);
}
extern "C" {
    pub fn discard_new_inode(arg1: *mut inode);
}
extern "C" {
    pub fn get_next_ino() -> ffi::c_uint;
}
extern "C" {
    pub fn evict_inodes(sb: *mut super_block);
}
extern "C" {
    pub fn dump_mapping(arg1: *const address_space);
}
extern "C" {
    pub fn iget_failed(arg1: *mut inode);
}
extern "C" {
    pub fn clear_inode(arg1: *mut inode);
}
extern "C" {
    pub fn __destroy_inode(arg1: *mut inode);
}
extern "C" {
    pub fn alloc_inode(sb: *mut super_block) -> *mut inode;
}
extern "C" {
    pub fn new_inode(sb: *mut super_block) -> *mut inode;
}
extern "C" {
    pub fn free_inode_nonrcu(inode: *mut inode);
}
extern "C" {
    pub fn setattr_should_drop_suidgid(arg1: *mut mnt_idmap, arg2: *mut inode) -> ffi::c_int;
}
extern "C" {
    pub fn file_remove_privs_flags(file: *mut file, flags: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn file_remove_privs(arg1: *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn setattr_should_drop_sgid(idmap: *mut mnt_idmap, inode: *const inode) -> ffi::c_int;
}
extern "C" {
    pub fn __insert_inode_hash(arg1: *mut inode, hashval: ffi::c_ulong);
}
extern "C" {
    pub fn __remove_inode_hash(arg1: *mut inode);
}
extern "C" {
    pub fn inode_sb_list_add(inode: *mut inode);
}
extern "C" {
    pub fn inode_add_lru(inode: *mut inode);
}
extern "C" {
    pub fn sb_set_blocksize(arg1: *mut super_block, arg2: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn sb_min_blocksize(arg1: *mut super_block, arg2: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn generic_file_mmap(arg1: *mut file, arg2: *mut vm_area_struct) -> ffi::c_int;
}
extern "C" {
    pub fn generic_file_readonly_mmap(arg1: *mut file, arg2: *mut vm_area_struct) -> ffi::c_int;
}
extern "C" {
    pub fn generic_write_checks(arg1: *mut kiocb, arg2: *mut iov_iter) -> isize;
}
extern "C" {
    pub fn generic_write_checks_count(iocb: *mut kiocb, count: *mut loff_t) -> ffi::c_int;
}
extern "C" {
    pub fn generic_write_check_limits(
        file: *mut file,
        pos: loff_t,
        count: *mut loff_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn generic_file_rw_checks(file_in: *mut file, file_out: *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn filemap_read(iocb: *mut kiocb, to: *mut iov_iter, already_read: isize) -> isize;
}
extern "C" {
    pub fn generic_file_read_iter(arg1: *mut kiocb, arg2: *mut iov_iter) -> isize;
}
extern "C" {
    pub fn __generic_file_write_iter(arg1: *mut kiocb, arg2: *mut iov_iter) -> isize;
}
extern "C" {
    pub fn generic_file_write_iter(arg1: *mut kiocb, arg2: *mut iov_iter) -> isize;
}
extern "C" {
    pub fn generic_file_direct_write(arg1: *mut kiocb, arg2: *mut iov_iter) -> isize;
}
extern "C" {
    pub fn generic_perform_write(arg1: *mut kiocb, arg2: *mut iov_iter) -> isize;
}
extern "C" {
    pub fn direct_write_fallback(
        iocb: *mut kiocb,
        iter: *mut iov_iter,
        direct_written: isize,
        buffered_written: isize,
    ) -> isize;
}
extern "C" {
    pub fn vfs_iter_read(
        file: *mut file,
        iter: *mut iov_iter,
        ppos: *mut loff_t,
        flags: rwf_t,
    ) -> isize;
}
extern "C" {
    pub fn vfs_iter_write(
        file: *mut file,
        iter: *mut iov_iter,
        ppos: *mut loff_t,
        flags: rwf_t,
    ) -> isize;
}
extern "C" {
    pub fn vfs_iocb_iter_read(file: *mut file, iocb: *mut kiocb, iter: *mut iov_iter) -> isize;
}
extern "C" {
    pub fn vfs_iocb_iter_write(file: *mut file, iocb: *mut kiocb, iter: *mut iov_iter) -> isize;
}
extern "C" {
    pub fn filemap_splice_read(
        in_: *mut file,
        ppos: *mut loff_t,
        pipe: *mut pipe_inode_info,
        len: usize,
        flags: ffi::c_uint,
    ) -> isize;
}
extern "C" {
    pub fn copy_splice_read(
        in_: *mut file,
        ppos: *mut loff_t,
        pipe: *mut pipe_inode_info,
        len: usize,
        flags: ffi::c_uint,
    ) -> isize;
}
extern "C" {
    pub fn iter_file_splice_write(
        arg1: *mut pipe_inode_info,
        arg2: *mut file,
        arg3: *mut loff_t,
        arg4: usize,
        arg5: ffi::c_uint,
    ) -> isize;
}
extern "C" {
    pub fn file_ra_state_init(ra: *mut file_ra_state, mapping: *mut address_space);
}
extern "C" {
    pub fn noop_llseek(file: *mut file, offset: loff_t, whence: ffi::c_int) -> loff_t;
}
extern "C" {
    pub fn vfs_setpos(file: *mut file, offset: loff_t, maxsize: loff_t) -> loff_t;
}
extern "C" {
    pub fn generic_file_llseek(file: *mut file, offset: loff_t, whence: ffi::c_int) -> loff_t;
}
extern "C" {
    pub fn generic_file_llseek_size(
        file: *mut file,
        offset: loff_t,
        whence: ffi::c_int,
        maxsize: loff_t,
        eof: loff_t,
    ) -> loff_t;
}
extern "C" {
    pub fn generic_llseek_cookie(
        file: *mut file,
        offset: loff_t,
        whence: ffi::c_int,
        cookie: *mut u64_,
    ) -> loff_t;
}
extern "C" {
    pub fn fixed_size_llseek(
        file: *mut file,
        offset: loff_t,
        whence: ffi::c_int,
        size: loff_t,
    ) -> loff_t;
}
extern "C" {
    pub fn no_seek_end_llseek_size(
        arg1: *mut file,
        arg2: loff_t,
        arg3: ffi::c_int,
        arg4: loff_t,
    ) -> loff_t;
}
extern "C" {
    pub fn no_seek_end_llseek(arg1: *mut file, arg2: loff_t, arg3: ffi::c_int) -> loff_t;
}
extern "C" {
    pub fn rw_verify_area(
        arg1: ffi::c_int,
        arg2: *mut file,
        arg3: *const loff_t,
        arg4: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn generic_file_open(inode: *mut inode, filp: *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn nonseekable_open(inode: *mut inode, filp: *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn stream_open(inode: *mut inode, filp: *mut file) -> ffi::c_int;
}
pub type dio_submit_t = ::core::option::Option<
    unsafe extern "C" fn(bio: *mut bio, inode: *mut inode, file_offset: loff_t),
>;
pub const DIO_LOCKING: _bindgen_ty_89 = 1;
pub const DIO_SKIP_HOLES: _bindgen_ty_89 = 2;
pub type _bindgen_ty_89 = ffi::c_uint;
extern "C" {
    pub fn __blockdev_direct_IO(
        iocb: *mut kiocb,
        inode: *mut inode,
        bdev: *mut block_device,
        iter: *mut iov_iter,
        get_block: get_block_t,
        end_io: dio_iodone_t,
        flags: ffi::c_int,
    ) -> isize;
}
extern "C" {
    pub fn inode_dio_finished(inode: *const inode) -> bool_;
}
extern "C" {
    pub fn inode_dio_wait(inode: *mut inode);
}
extern "C" {
    pub fn inode_dio_wait_interruptible(inode: *mut inode);
}
extern "C" {
    pub fn inode_set_flags(inode: *mut inode, flags: ffi::c_uint, mask: ffi::c_uint);
}
extern "C" {
    pub static generic_ro_fops: file_operations;
}
extern "C" {
    pub fn readlink_copy(
        arg1: *mut ffi::c_char,
        arg2: ffi::c_int,
        arg3: *const ffi::c_char,
        arg4: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn page_readlink(arg1: *mut dentry, arg2: *mut ffi::c_char, arg3: ffi::c_int)
        -> ffi::c_int;
}
extern "C" {
    pub fn page_get_link_raw(
        arg1: *mut dentry,
        arg2: *mut inode,
        arg3: *mut delayed_call,
    ) -> *const ffi::c_char;
}
extern "C" {
    pub fn page_get_link(
        arg1: *mut dentry,
        arg2: *mut inode,
        arg3: *mut delayed_call,
    ) -> *const ffi::c_char;
}
extern "C" {
    pub fn page_put_link(arg1: *mut ffi::c_void);
}
extern "C" {
    pub fn page_symlink(
        inode: *mut inode,
        symname: *const ffi::c_char,
        len: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub static page_symlink_inode_operations: inode_operations;
}
extern "C" {
    pub fn kfree_link(arg1: *mut ffi::c_void);
}
extern "C" {
    pub fn fill_mg_cmtime(stat: *mut kstat, request_mask: u32_, inode: *mut inode);
}
extern "C" {
    pub fn generic_fillattr(arg1: *mut mnt_idmap, arg2: u32_, arg3: *mut inode, arg4: *mut kstat);
}
extern "C" {
    pub fn generic_fill_statx_attr(inode: *mut inode, stat: *mut kstat);
}
extern "C" {
    pub fn generic_fill_statx_atomic_writes(
        stat: *mut kstat,
        unit_min: ffi::c_uint,
        unit_max: ffi::c_uint,
    );
}
extern "C" {
    pub fn vfs_getattr_nosec(
        arg1: *const path,
        arg2: *mut kstat,
        arg3: u32_,
        arg4: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vfs_getattr(
        arg1: *const path,
        arg2: *mut kstat,
        arg3: u32_,
        arg4: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __inode_add_bytes(inode: *mut inode, bytes: loff_t);
}
extern "C" {
    pub fn inode_add_bytes(inode: *mut inode, bytes: loff_t);
}
extern "C" {
    pub fn __inode_sub_bytes(inode: *mut inode, bytes: loff_t);
}
extern "C" {
    pub fn inode_sub_bytes(inode: *mut inode, bytes: loff_t);
}
extern "C" {
    pub fn inode_get_bytes(inode: *mut inode) -> loff_t;
}
extern "C" {
    pub fn inode_set_bytes(inode: *mut inode, bytes: loff_t);
}
extern "C" {
    pub fn simple_get_link(
        arg1: *mut dentry,
        arg2: *mut inode,
        arg3: *mut delayed_call,
    ) -> *const ffi::c_char;
}
extern "C" {
    pub static simple_symlink_inode_operations: inode_operations;
}
extern "C" {
    pub fn iterate_dir(arg1: *mut file, arg2: *mut dir_context) -> ffi::c_int;
}
extern "C" {
    pub fn vfs_fstatat(
        dfd: ffi::c_int,
        filename: *const ffi::c_char,
        stat: *mut kstat,
        flags: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vfs_fstat(fd: ffi::c_int, stat: *mut kstat) -> ffi::c_int;
}
extern "C" {
    pub fn vfs_get_link(arg1: *mut dentry, arg2: *mut delayed_call) -> *const ffi::c_char;
}
extern "C" {
    pub fn vfs_readlink(arg1: *mut dentry, arg2: *mut ffi::c_char, arg3: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn get_filesystem(fs: *mut file_system_type) -> *mut file_system_type;
}
extern "C" {
    pub fn put_filesystem(fs: *mut file_system_type);
}
extern "C" {
    pub fn get_fs_type(name: *const ffi::c_char) -> *mut file_system_type;
}
extern "C" {
    pub fn drop_super(sb: *mut super_block);
}
extern "C" {
    pub fn drop_super_exclusive(sb: *mut super_block);
}
extern "C" {
    pub fn iterate_supers(
        arg1: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut super_block, arg2: *mut ffi::c_void),
        >,
        arg2: *mut ffi::c_void,
    );
}
extern "C" {
    pub fn iterate_supers_type(
        arg1: *mut file_system_type,
        arg2: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut super_block, arg2: *mut ffi::c_void),
        >,
        arg3: *mut ffi::c_void,
    );
}
extern "C" {
    pub fn dcache_dir_open(arg1: *mut inode, arg2: *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn dcache_dir_close(arg1: *mut inode, arg2: *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn dcache_dir_lseek(arg1: *mut file, arg2: loff_t, arg3: ffi::c_int) -> loff_t;
}
extern "C" {
    pub fn dcache_readdir(arg1: *mut file, arg2: *mut dir_context) -> ffi::c_int;
}
extern "C" {
    pub fn simple_setattr(arg1: *mut mnt_idmap, arg2: *mut dentry, arg3: *mut iattr) -> ffi::c_int;
}
extern "C" {
    pub fn simple_getattr(
        arg1: *mut mnt_idmap,
        arg2: *const path,
        arg3: *mut kstat,
        arg4: u32_,
        arg5: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn simple_statfs(arg1: *mut dentry, arg2: *mut kstatfs) -> ffi::c_int;
}
extern "C" {
    pub fn simple_open(inode: *mut inode, file: *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn simple_link(arg1: *mut dentry, arg2: *mut inode, arg3: *mut dentry) -> ffi::c_int;
}
extern "C" {
    pub fn simple_unlink(arg1: *mut inode, arg2: *mut dentry) -> ffi::c_int;
}
extern "C" {
    pub fn simple_rmdir(arg1: *mut inode, arg2: *mut dentry) -> ffi::c_int;
}
extern "C" {
    pub fn simple_rename_timestamp(
        old_dir: *mut inode,
        old_dentry: *mut dentry,
        new_dir: *mut inode,
        new_dentry: *mut dentry,
    );
}
extern "C" {
    pub fn simple_rename_exchange(
        old_dir: *mut inode,
        old_dentry: *mut dentry,
        new_dir: *mut inode,
        new_dentry: *mut dentry,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn simple_rename(
        arg1: *mut mnt_idmap,
        arg2: *mut inode,
        arg3: *mut dentry,
        arg4: *mut inode,
        arg5: *mut dentry,
        arg6: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn simple_recursive_removal(
        arg1: *mut dentry,
        callback: ::core::option::Option<unsafe extern "C" fn(arg1: *mut dentry)>,
    );
}
extern "C" {
    pub fn noop_fsync(arg1: *mut file, arg2: loff_t, arg3: loff_t, arg4: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn noop_direct_IO(iocb: *mut kiocb, iter: *mut iov_iter) -> isize;
}
extern "C" {
    pub fn simple_empty(arg1: *mut dentry) -> ffi::c_int;
}
extern "C" {
    pub fn simple_write_begin(
        file: *mut file,
        mapping: *mut address_space,
        pos: loff_t,
        len: ffi::c_uint,
        foliop: *mut *mut folio,
        fsdata: *mut *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub static ram_aops: address_space_operations;
}
extern "C" {
    pub fn always_delete_dentry(arg1: *const dentry) -> ffi::c_int;
}
extern "C" {
    pub fn alloc_anon_inode(arg1: *mut super_block) -> *mut inode;
}
extern "C" {
    pub fn simple_nosetlease(
        arg1: *mut file,
        arg2: ffi::c_int,
        arg3: *mut *mut file_lease,
        arg4: *mut *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub static simple_dentry_operations: dentry_operations;
}
extern "C" {
    pub fn simple_lookup(arg1: *mut inode, arg2: *mut dentry, flags: ffi::c_uint) -> *mut dentry;
}
extern "C" {
    pub fn generic_read_dir(
        arg1: *mut file,
        arg2: *mut ffi::c_char,
        arg3: usize,
        arg4: *mut loff_t,
    ) -> isize;
}
extern "C" {
    pub static simple_dir_operations: file_operations;
}
extern "C" {
    pub static simple_dir_inode_operations: inode_operations;
}
extern "C" {
    pub fn make_empty_dir_inode(inode: *mut inode);
}
extern "C" {
    pub fn is_empty_dir_inode(inode: *mut inode) -> bool_;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tree_descr {
    pub name: *const ffi::c_char,
    pub ops: *const file_operations,
    pub mode: ffi::c_int,
}
impl Default for tree_descr {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn d_alloc_name(arg1: *mut dentry, arg2: *const ffi::c_char) -> *mut dentry;
}
extern "C" {
    pub fn simple_fill_super(
        arg1: *mut super_block,
        arg2: ffi::c_ulong,
        arg3: *const tree_descr,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn simple_pin_fs(
        arg1: *mut file_system_type,
        mount: *mut *mut vfsmount,
        count: *mut ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn simple_release_fs(mount: *mut *mut vfsmount, count: *mut ffi::c_int);
}
extern "C" {
    pub fn simple_read_from_buffer(
        to: *mut ffi::c_void,
        count: usize,
        ppos: *mut loff_t,
        from: *const ffi::c_void,
        available: usize,
    ) -> isize;
}
extern "C" {
    pub fn simple_write_to_buffer(
        to: *mut ffi::c_void,
        available: usize,
        ppos: *mut loff_t,
        from: *const ffi::c_void,
        count: usize,
    ) -> isize;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct offset_ctx {
    pub mt: maple_tree,
    pub next_offset: ffi::c_ulong,
}
impl Default for offset_ctx {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn simple_offset_init(octx: *mut offset_ctx);
}
extern "C" {
    pub fn simple_offset_add(octx: *mut offset_ctx, dentry: *mut dentry) -> ffi::c_int;
}
extern "C" {
    pub fn simple_offset_remove(octx: *mut offset_ctx, dentry: *mut dentry);
}
extern "C" {
    pub fn simple_offset_rename(
        old_dir: *mut inode,
        old_dentry: *mut dentry,
        new_dir: *mut inode,
        new_dentry: *mut dentry,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn simple_offset_rename_exchange(
        old_dir: *mut inode,
        old_dentry: *mut dentry,
        new_dir: *mut inode,
        new_dentry: *mut dentry,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn simple_offset_destroy(octx: *mut offset_ctx);
}
extern "C" {
    pub static simple_offset_dir_operations: file_operations;
}
extern "C" {
    pub fn __generic_file_fsync(
        arg1: *mut file,
        arg2: loff_t,
        arg3: loff_t,
        arg4: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn generic_file_fsync(
        arg1: *mut file,
        arg2: loff_t,
        arg3: loff_t,
        arg4: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn generic_check_addressable(arg1: ffi::c_uint, arg2: u64_) -> ffi::c_int;
}
extern "C" {
    pub fn generic_set_sb_d_ops(sb: *mut super_block);
}
extern "C" {
    pub fn generic_ci_match(
        parent: *const inode,
        name: *const qstr,
        folded_name: *const qstr,
        de_name: *const u8_,
        de_name_len: u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn generic_ci_d_hash(dentry: *const dentry, str_: *mut qstr) -> ffi::c_int;
}
extern "C" {
    pub fn generic_ci_d_compare(
        dentry: *const dentry,
        len: ffi::c_uint,
        str_: *const ffi::c_char,
        name: *const qstr,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn may_setattr(
        idmap: *mut mnt_idmap,
        inode: *mut inode,
        ia_valid: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn setattr_prepare(arg1: *mut mnt_idmap, arg2: *mut dentry, arg3: *mut iattr)
        -> ffi::c_int;
}
extern "C" {
    pub fn inode_newsize_ok(arg1: *const inode, offset: loff_t) -> ffi::c_int;
}
extern "C" {
    pub fn setattr_copy(arg1: *mut mnt_idmap, inode: *mut inode, attr: *const iattr);
}
extern "C" {
    pub fn file_update_time(file: *mut file) -> ffi::c_int;
}
#[repr(C)]
#[derive(Default)]
pub struct simple_transaction_argresp {
    pub size: isize,
    pub data: __IncompleteArrayField<ffi::c_char>,
}
extern "C" {
    pub fn simple_transaction_get(
        file: *mut file,
        buf: *const ffi::c_char,
        size: usize,
    ) -> *mut ffi::c_char;
}
extern "C" {
    pub fn simple_transaction_read(
        file: *mut file,
        buf: *mut ffi::c_char,
        size: usize,
        pos: *mut loff_t,
    ) -> isize;
}
extern "C" {
    pub fn simple_transaction_release(inode: *mut inode, file: *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn simple_transaction_set(file: *mut file, n: usize);
}
extern "C" {
    pub fn simple_attr_open(
        inode: *mut inode,
        file: *mut file,
        get: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut ffi::c_void, arg2: *mut u64_) -> ffi::c_int,
        >,
        set: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut ffi::c_void, arg2: u64_) -> ffi::c_int,
        >,
        fmt: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn simple_attr_release(inode: *mut inode, file: *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn simple_attr_read(
        file: *mut file,
        buf: *mut ffi::c_char,
        len: usize,
        ppos: *mut loff_t,
    ) -> isize;
}
extern "C" {
    pub fn simple_attr_write(
        file: *mut file,
        buf: *const ffi::c_char,
        len: usize,
        ppos: *mut loff_t,
    ) -> isize;
}
extern "C" {
    pub fn simple_attr_write_signed(
        file: *mut file,
        buf: *const ffi::c_char,
        len: usize,
        ppos: *mut loff_t,
    ) -> isize;
}
extern "C" {
    pub fn list_bdev_fs_names(buf: *mut ffi::c_char, size: usize) -> ffi::c_int;
}
extern "C" {
    pub fn path_noexec(path: *const path) -> bool_;
}
extern "C" {
    pub fn inode_nohighmem(inode: *mut inode);
}
extern "C" {
    pub fn vfs_fadvise(
        file: *mut file,
        offset: loff_t,
        len: loff_t,
        advice: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn generic_fadvise(
        file: *mut file,
        offset: loff_t,
        len: loff_t,
        advice: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn generic_atomic_write_valid(iocb: *mut kiocb, iter: *mut iov_iter) -> ffi::c_int;
}
pub type elf_greg_t = ffi::c_ulong;
pub type elf_gregset_t = [elf_greg_t; 34usize];
pub type elf_fpregset_t = user_fpsimd_state;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct linux_binprm {
    _unused: [u8; 0],
}
extern "C" {
    pub fn arch_setup_additional_pages(
        bprm: *mut linux_binprm,
        uses_interp: ffi::c_int,
    ) -> ffi::c_int;
}
pub type compat_elf_greg_t = ffi::c_uint;
pub type compat_elf_gregset_t = [compat_elf_greg_t; 18usize];
extern "C" {
    pub fn compat_elf_check_arch(arg1: *const elf32_hdr) -> ffi::c_int;
}
extern "C" {
    pub fn aarch32_setup_additional_pages(
        bprm: *mut linux_binprm,
        uses_interp: ffi::c_int,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct arch_elf_state {
    pub flags: ffi::c_int,
}
extern "C" {
    pub static mut _DYNAMIC: [Elf64_Dyn; 0usize];
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct coredump_params {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct gnu_property {
    pub pr_type: u32_,
    pub pr_datasz: u32_,
}
extern "C" {
    pub fn arch_elf_adjust_prot(
        prot: ffi::c_int,
        state: *const arch_elf_state,
        has_interp: bool_,
        is_interp: bool_,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct idr {
    pub idr_rt: xarray,
    pub idr_base: ffi::c_uint,
    pub idr_next: ffi::c_uint,
}
impl Default for idr {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn idr_preload(gfp_mask: gfp_t);
}
extern "C" {
    pub fn idr_alloc(
        arg1: *mut idr,
        ptr: *mut ffi::c_void,
        start: ffi::c_int,
        end: ffi::c_int,
        arg2: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn idr_alloc_u32(
        arg1: *mut idr,
        ptr: *mut ffi::c_void,
        id: *mut u32_,
        max: ffi::c_ulong,
        arg2: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn idr_alloc_cyclic(
        arg1: *mut idr,
        ptr: *mut ffi::c_void,
        start: ffi::c_int,
        end: ffi::c_int,
        arg2: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn idr_remove(arg1: *mut idr, id: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn idr_find(arg1: *const idr, id: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn idr_for_each(
        arg1: *const idr,
        fn_: ::core::option::Option<
            unsafe extern "C" fn(
                id: ffi::c_int,
                p: *mut ffi::c_void,
                data: *mut ffi::c_void,
            ) -> ffi::c_int,
        >,
        data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn idr_get_next(arg1: *mut idr, nextid: *mut ffi::c_int) -> *mut ffi::c_void;
}
extern "C" {
    pub fn idr_get_next_ul(arg1: *mut idr, nextid: *mut ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn idr_replace(
        arg1: *mut idr,
        arg2: *mut ffi::c_void,
        id: ffi::c_ulong,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn idr_destroy(arg1: *mut idr);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct __class_idr {
    pub idr: *mut idr,
    pub id: ffi::c_int,
}
impl Default for __class_idr {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type class_idr_alloc_t = __class_idr;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ida_bitmap {
    pub bitmap: [ffi::c_ulong; 16usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ida {
    pub xa: xarray,
}
impl Default for ida {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn ida_alloc_range(
        arg1: *mut ida,
        min: ffi::c_uint,
        max: ffi::c_uint,
        arg2: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn ida_free(arg1: *mut ida, id: ffi::c_uint);
}
extern "C" {
    pub fn ida_destroy(ida: *mut ida);
}
extern "C" {
    pub fn ida_find_first_range(ida: *mut ida, min: ffi::c_uint, max: ffi::c_uint) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kernfs_open_node {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kernfs_iattrs {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kernfs_global_locks {
    pub open_file_mutex: [mutex; 1024usize],
}
impl Default for kernfs_global_locks {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const kernfs_node_type_KERNFS_DIR: kernfs_node_type = 1;
pub const kernfs_node_type_KERNFS_FILE: kernfs_node_type = 2;
pub const kernfs_node_type_KERNFS_LINK: kernfs_node_type = 4;
pub type kernfs_node_type = ffi::c_uint;
pub const kernfs_node_flag_KERNFS_ACTIVATED: kernfs_node_flag = 16;
pub const kernfs_node_flag_KERNFS_NS: kernfs_node_flag = 32;
pub const kernfs_node_flag_KERNFS_HAS_SEQ_SHOW: kernfs_node_flag = 64;
pub const kernfs_node_flag_KERNFS_HAS_MMAP: kernfs_node_flag = 128;
pub const kernfs_node_flag_KERNFS_LOCKDEP: kernfs_node_flag = 256;
pub const kernfs_node_flag_KERNFS_HIDDEN: kernfs_node_flag = 512;
pub const kernfs_node_flag_KERNFS_SUICIDAL: kernfs_node_flag = 1024;
pub const kernfs_node_flag_KERNFS_SUICIDED: kernfs_node_flag = 2048;
pub const kernfs_node_flag_KERNFS_EMPTY_DIR: kernfs_node_flag = 4096;
pub const kernfs_node_flag_KERNFS_HAS_RELEASE: kernfs_node_flag = 8192;
pub const kernfs_node_flag_KERNFS_REMOVING: kernfs_node_flag = 16384;
pub type kernfs_node_flag = ffi::c_uint;
pub const kernfs_root_flag_KERNFS_ROOT_CREATE_DEACTIVATED: kernfs_root_flag = 1;
pub const kernfs_root_flag_KERNFS_ROOT_EXTRA_OPEN_PERM_CHECK: kernfs_root_flag = 2;
pub const kernfs_root_flag_KERNFS_ROOT_SUPPORT_EXPORTOP: kernfs_root_flag = 4;
pub const kernfs_root_flag_KERNFS_ROOT_SUPPORT_USER_XATTR: kernfs_root_flag = 8;
pub const kernfs_root_flag_KERNFS_ROOT_INVARIANT_PARENT: kernfs_root_flag = 16;
pub type kernfs_root_flag = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kernfs_elem_dir {
    pub subdirs: ffi::c_ulong,
    pub children: rb_root,
    pub root: *mut kernfs_root,
    pub rev: ffi::c_ulong,
}
impl Default for kernfs_elem_dir {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kernfs_elem_symlink {
    pub target_kn: *mut kernfs_node,
}
impl Default for kernfs_elem_symlink {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kernfs_elem_attr {
    pub ops: *const kernfs_ops,
    pub open: *mut kernfs_open_node,
    pub size: loff_t,
    pub notify_next: *mut kernfs_node,
}
impl Default for kernfs_elem_attr {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kernfs_node {
    pub count: atomic_t,
    pub active: atomic_t,
    pub __parent: *mut kernfs_node,
    pub name: *const ffi::c_char,
    pub rb: rb_node,
    pub ns: *const ffi::c_void,
    pub hash: ffi::c_uint,
    pub flags: ffi::c_ushort,
    pub mode: umode_t,
    pub __bindgen_anon_1: kernfs_node__bindgen_ty_1,
    pub id: u64_,
    pub priv_: *mut ffi::c_void,
    pub iattr: *mut kernfs_iattrs,
    pub rcu: callback_head,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union kernfs_node__bindgen_ty_1 {
    pub dir: kernfs_elem_dir,
    pub symlink: kernfs_elem_symlink,
    pub attr: kernfs_elem_attr,
}
impl Default for kernfs_node__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for kernfs_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct kernfs_syscall_ops {
    pub show_options: ::core::option::Option<
        unsafe extern "C" fn(sf: *mut seq_file, root: *mut kernfs_root) -> ffi::c_int,
    >,
    pub mkdir: ::core::option::Option<
        unsafe extern "C" fn(
            parent: *mut kernfs_node,
            name: *const ffi::c_char,
            mode: umode_t,
        ) -> ffi::c_int,
    >,
    pub rmdir: ::core::option::Option<unsafe extern "C" fn(kn: *mut kernfs_node) -> ffi::c_int>,
    pub rename: ::core::option::Option<
        unsafe extern "C" fn(
            kn: *mut kernfs_node,
            new_parent: *mut kernfs_node,
            new_name: *const ffi::c_char,
        ) -> ffi::c_int,
    >,
    pub show_path: ::core::option::Option<
        unsafe extern "C" fn(
            sf: *mut seq_file,
            kn: *mut kernfs_node,
            root: *mut kernfs_root,
        ) -> ffi::c_int,
    >,
}
extern "C" {
    pub fn kernfs_root_to_node(root: *mut kernfs_root) -> *mut kernfs_node;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kernfs_open_file {
    pub kn: *mut kernfs_node,
    pub file: *mut file,
    pub seq_file: *mut seq_file,
    pub priv_: *mut ffi::c_void,
    pub mutex: mutex,
    pub prealloc_mutex: mutex,
    pub event: ffi::c_int,
    pub list: list_head,
    pub prealloc_buf: *mut ffi::c_char,
    pub atomic_write_len: usize,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub vm_ops: *const vm_operations_struct,
}
impl Default for kernfs_open_file {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl kernfs_open_file {
    #[inline]
    pub fn mmapped(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_mmapped(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn mmapped_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_mmapped_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn released(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_released(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn released_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_released_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(mmapped: bool_, released: bool_) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let mmapped: u8 = unsafe { ::core::mem::transmute(mmapped) };
            mmapped as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let released: u8 = unsafe { ::core::mem::transmute(released) };
            released as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct kernfs_ops {
    pub open: ::core::option::Option<unsafe extern "C" fn(of: *mut kernfs_open_file) -> ffi::c_int>,
    pub release: ::core::option::Option<unsafe extern "C" fn(of: *mut kernfs_open_file)>,
    pub seq_show: ::core::option::Option<
        unsafe extern "C" fn(sf: *mut seq_file, v: *mut ffi::c_void) -> ffi::c_int,
    >,
    pub seq_start: ::core::option::Option<
        unsafe extern "C" fn(sf: *mut seq_file, ppos: *mut loff_t) -> *mut ffi::c_void,
    >,
    pub seq_next: ::core::option::Option<
        unsafe extern "C" fn(
            sf: *mut seq_file,
            v: *mut ffi::c_void,
            ppos: *mut loff_t,
        ) -> *mut ffi::c_void,
    >,
    pub seq_stop:
        ::core::option::Option<unsafe extern "C" fn(sf: *mut seq_file, v: *mut ffi::c_void)>,
    pub read: ::core::option::Option<
        unsafe extern "C" fn(
            of: *mut kernfs_open_file,
            buf: *mut ffi::c_char,
            bytes: usize,
            off: loff_t,
        ) -> isize,
    >,
    pub atomic_write_len: usize,
    pub prealloc: bool_,
    pub write: ::core::option::Option<
        unsafe extern "C" fn(
            of: *mut kernfs_open_file,
            buf: *mut ffi::c_char,
            bytes: usize,
            off: loff_t,
        ) -> isize,
    >,
    pub poll: ::core::option::Option<
        unsafe extern "C" fn(of: *mut kernfs_open_file, pt: *mut poll_table_struct) -> __poll_t,
    >,
    pub mmap: ::core::option::Option<
        unsafe extern "C" fn(of: *mut kernfs_open_file, vma: *mut vm_area_struct) -> ffi::c_int,
    >,
    pub llseek: ::core::option::Option<
        unsafe extern "C" fn(
            of: *mut kernfs_open_file,
            offset: loff_t,
            whence: ffi::c_int,
        ) -> loff_t,
    >,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kernfs_fs_context {
    pub root: *mut kernfs_root,
    pub ns_tag: *mut ffi::c_void,
    pub magic: ffi::c_ulong,
    pub new_sb_created: bool_,
}
impl Default for kernfs_fs_context {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn kernfs_name(kn: *mut kernfs_node, buf: *mut ffi::c_char, buflen: usize) -> ffi::c_int;
}
extern "C" {
    pub fn kernfs_path_from_node(
        kn_to: *mut kernfs_node,
        kn_from: *mut kernfs_node,
        buf: *mut ffi::c_char,
        buflen: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pr_cont_kernfs_name(kn: *mut kernfs_node);
}
extern "C" {
    pub fn pr_cont_kernfs_path(kn: *mut kernfs_node);
}
extern "C" {
    pub fn kernfs_get_parent(kn: *mut kernfs_node) -> *mut kernfs_node;
}
extern "C" {
    pub fn kernfs_find_and_get_ns(
        parent: *mut kernfs_node,
        name: *const ffi::c_char,
        ns: *const ffi::c_void,
    ) -> *mut kernfs_node;
}
extern "C" {
    pub fn kernfs_walk_and_get_ns(
        parent: *mut kernfs_node,
        path: *const ffi::c_char,
        ns: *const ffi::c_void,
    ) -> *mut kernfs_node;
}
extern "C" {
    pub fn kernfs_get(kn: *mut kernfs_node);
}
extern "C" {
    pub fn kernfs_put(kn: *mut kernfs_node);
}
extern "C" {
    pub fn kernfs_node_from_dentry(dentry: *mut dentry) -> *mut kernfs_node;
}
extern "C" {
    pub fn kernfs_root_from_sb(sb: *mut super_block) -> *mut kernfs_root;
}
extern "C" {
    pub fn kernfs_get_inode(sb: *mut super_block, kn: *mut kernfs_node) -> *mut inode;
}
extern "C" {
    pub fn kernfs_node_dentry(kn: *mut kernfs_node, sb: *mut super_block) -> *mut dentry;
}
extern "C" {
    pub fn kernfs_create_root(
        scops: *mut kernfs_syscall_ops,
        flags: ffi::c_uint,
        priv_: *mut ffi::c_void,
    ) -> *mut kernfs_root;
}
extern "C" {
    pub fn kernfs_destroy_root(root: *mut kernfs_root);
}
extern "C" {
    pub fn kernfs_root_flags(kn: *mut kernfs_node) -> ffi::c_uint;
}
extern "C" {
    pub fn kernfs_create_dir_ns(
        parent: *mut kernfs_node,
        name: *const ffi::c_char,
        mode: umode_t,
        uid: kuid_t,
        gid: kgid_t,
        priv_: *mut ffi::c_void,
        ns: *const ffi::c_void,
    ) -> *mut kernfs_node;
}
extern "C" {
    pub fn kernfs_create_empty_dir(
        parent: *mut kernfs_node,
        name: *const ffi::c_char,
    ) -> *mut kernfs_node;
}
extern "C" {
    pub fn __kernfs_create_file(
        parent: *mut kernfs_node,
        name: *const ffi::c_char,
        mode: umode_t,
        uid: kuid_t,
        gid: kgid_t,
        size: loff_t,
        ops: *const kernfs_ops,
        priv_: *mut ffi::c_void,
        ns: *const ffi::c_void,
        key: *mut lock_class_key,
    ) -> *mut kernfs_node;
}
extern "C" {
    pub fn kernfs_create_link(
        parent: *mut kernfs_node,
        name: *const ffi::c_char,
        target: *mut kernfs_node,
    ) -> *mut kernfs_node;
}
extern "C" {
    pub fn kernfs_activate(kn: *mut kernfs_node);
}
extern "C" {
    pub fn kernfs_show(kn: *mut kernfs_node, show: bool_);
}
extern "C" {
    pub fn kernfs_remove(kn: *mut kernfs_node);
}
extern "C" {
    pub fn kernfs_break_active_protection(kn: *mut kernfs_node);
}
extern "C" {
    pub fn kernfs_unbreak_active_protection(kn: *mut kernfs_node);
}
extern "C" {
    pub fn kernfs_remove_self(kn: *mut kernfs_node) -> bool_;
}
extern "C" {
    pub fn kernfs_remove_by_name_ns(
        parent: *mut kernfs_node,
        name: *const ffi::c_char,
        ns: *const ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kernfs_rename_ns(
        kn: *mut kernfs_node,
        new_parent: *mut kernfs_node,
        new_name: *const ffi::c_char,
        new_ns: *const ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kernfs_setattr(kn: *mut kernfs_node, iattr: *const iattr) -> ffi::c_int;
}
extern "C" {
    pub fn kernfs_generic_poll(of: *mut kernfs_open_file, pt: *mut poll_table_struct) -> __poll_t;
}
extern "C" {
    pub fn kernfs_notify(kn: *mut kernfs_node);
}
extern "C" {
    pub fn kernfs_xattr_get(
        kn: *mut kernfs_node,
        name: *const ffi::c_char,
        value: *mut ffi::c_void,
        size: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kernfs_xattr_set(
        kn: *mut kernfs_node,
        name: *const ffi::c_char,
        value: *const ffi::c_void,
        size: usize,
        flags: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kernfs_super_ns(sb: *mut super_block) -> *const ffi::c_void;
}
extern "C" {
    pub fn kernfs_get_tree(fc: *mut fs_context) -> ffi::c_int;
}
extern "C" {
    pub fn kernfs_free_fs_context(fc: *mut fs_context);
}
extern "C" {
    pub fn kernfs_kill_sb(sb: *mut super_block);
}
extern "C" {
    pub fn kernfs_init();
}
extern "C" {
    pub fn kernfs_find_and_get_node_by_id(root: *mut kernfs_root, id: u64_) -> *mut kernfs_node;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sock {
    _unused: [u8; 0],
}
pub const kobj_ns_type_KOBJ_NS_TYPE_NONE: kobj_ns_type = 0;
pub const kobj_ns_type_KOBJ_NS_TYPE_NET: kobj_ns_type = 1;
pub const kobj_ns_type_KOBJ_NS_TYPES: kobj_ns_type = 2;
pub type kobj_ns_type = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kobj_ns_type_operations {
    pub type_: kobj_ns_type,
    pub current_may_mount: ::core::option::Option<unsafe extern "C" fn() -> bool_>,
    pub grab_current_ns: ::core::option::Option<unsafe extern "C" fn() -> *mut ffi::c_void>,
    pub netlink_ns:
        ::core::option::Option<unsafe extern "C" fn(sk: *mut sock) -> *const ffi::c_void>,
    pub initial_ns: ::core::option::Option<unsafe extern "C" fn() -> *const ffi::c_void>,
    pub drop_ns: ::core::option::Option<unsafe extern "C" fn(arg1: *mut ffi::c_void)>,
}
impl Default for kobj_ns_type_operations {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn kobj_ns_type_register(ops: *const kobj_ns_type_operations) -> ffi::c_int;
}
extern "C" {
    pub fn kobj_ns_type_registered(type_: kobj_ns_type) -> ffi::c_int;
}
extern "C" {
    pub fn kobj_child_ns_ops(parent: *const kobject) -> *const kobj_ns_type_operations;
}
extern "C" {
    pub fn kobj_ns_ops(kobj: *const kobject) -> *const kobj_ns_type_operations;
}
extern "C" {
    pub fn kobj_ns_current_may_mount(type_: kobj_ns_type) -> bool_;
}
extern "C" {
    pub fn kobj_ns_grab_current(type_: kobj_ns_type) -> *mut ffi::c_void;
}
extern "C" {
    pub fn kobj_ns_drop(type_: kobj_ns_type, ns: *mut ffi::c_void);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct attribute {
    pub name: *const ffi::c_char,
    pub mode: umode_t,
}
impl Default for attribute {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct attribute_group {
    pub name: *const ffi::c_char,
    pub is_visible: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut kobject, arg2: *mut attribute, arg3: ffi::c_int) -> umode_t,
    >,
    pub is_bin_visible: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut kobject,
            arg2: *const bin_attribute,
            arg3: ffi::c_int,
        ) -> umode_t,
    >,
    pub bin_size: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut kobject,
            arg2: *const bin_attribute,
            arg3: ffi::c_int,
        ) -> usize,
    >,
    pub attrs: *mut *mut attribute,
    pub __bindgen_anon_1: attribute_group__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union attribute_group__bindgen_ty_1 {
    pub bin_attrs: *mut *mut bin_attribute,
    pub bin_attrs_new: *const *const bin_attribute,
}
impl Default for attribute_group__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for attribute_group {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bin_attribute {
    pub attr: attribute,
    pub size: usize,
    pub private: *mut ffi::c_void,
    pub f_mapping: ::core::option::Option<unsafe extern "C" fn() -> *mut address_space>,
    pub read: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut file,
            arg2: *mut kobject,
            arg3: *mut bin_attribute,
            arg4: *mut ffi::c_char,
            arg5: loff_t,
            arg6: usize,
        ) -> isize,
    >,
    pub read_new: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut file,
            arg2: *mut kobject,
            arg3: *const bin_attribute,
            arg4: *mut ffi::c_char,
            arg5: loff_t,
            arg6: usize,
        ) -> isize,
    >,
    pub write: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut file,
            arg2: *mut kobject,
            arg3: *mut bin_attribute,
            arg4: *mut ffi::c_char,
            arg5: loff_t,
            arg6: usize,
        ) -> isize,
    >,
    pub write_new: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut file,
            arg2: *mut kobject,
            arg3: *const bin_attribute,
            arg4: *mut ffi::c_char,
            arg5: loff_t,
            arg6: usize,
        ) -> isize,
    >,
    pub llseek: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut file,
            arg2: *mut kobject,
            arg3: *const bin_attribute,
            arg4: loff_t,
            arg5: ffi::c_int,
        ) -> loff_t,
    >,
    pub mmap: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut file,
            arg2: *mut kobject,
            attr: *const bin_attribute,
            vma: *mut vm_area_struct,
        ) -> ffi::c_int,
    >,
}
impl Default for bin_attribute {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type __sysfs_bin_rw_handler_new = ::core::option::Option<
    unsafe extern "C" fn(
        arg1: *mut file,
        arg2: *mut kobject,
        arg3: *const bin_attribute,
        arg4: *mut ffi::c_char,
        arg5: loff_t,
        arg6: usize,
    ) -> isize,
>;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sysfs_ops {
    pub show: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut kobject,
            arg2: *mut attribute,
            arg3: *mut ffi::c_char,
        ) -> isize,
    >,
    pub store: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut kobject,
            arg2: *mut attribute,
            arg3: *const ffi::c_char,
            arg4: usize,
        ) -> isize,
    >,
}
extern "C" {
    #[must_use]
    pub fn sysfs_create_dir_ns(kobj: *mut kobject, ns: *const ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn sysfs_remove_dir(kobj: *mut kobject);
}
extern "C" {
    #[must_use]
    pub fn sysfs_rename_dir_ns(
        kobj: *mut kobject,
        new_name: *const ffi::c_char,
        new_ns: *const ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn sysfs_move_dir_ns(
        kobj: *mut kobject,
        new_parent_kobj: *mut kobject,
        new_ns: *const ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn sysfs_create_mount_point(
        parent_kobj: *mut kobject,
        name: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sysfs_remove_mount_point(parent_kobj: *mut kobject, name: *const ffi::c_char);
}
extern "C" {
    #[must_use]
    pub fn sysfs_create_file_ns(
        kobj: *mut kobject,
        attr: *const attribute,
        ns: *const ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn sysfs_create_files(kobj: *mut kobject, attr: *const *const attribute) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn sysfs_chmod_file(
        kobj: *mut kobject,
        attr: *const attribute,
        mode: umode_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sysfs_break_active_protection(
        kobj: *mut kobject,
        attr: *const attribute,
    ) -> *mut kernfs_node;
}
extern "C" {
    pub fn sysfs_unbreak_active_protection(kn: *mut kernfs_node);
}
extern "C" {
    pub fn sysfs_remove_file_ns(kobj: *mut kobject, attr: *const attribute, ns: *const ffi::c_void);
}
extern "C" {
    pub fn sysfs_remove_file_self(kobj: *mut kobject, attr: *const attribute) -> bool_;
}
extern "C" {
    pub fn sysfs_remove_files(kobj: *mut kobject, attr: *const *const attribute);
}
extern "C" {
    #[must_use]
    pub fn sysfs_create_bin_file(kobj: *mut kobject, attr: *const bin_attribute) -> ffi::c_int;
}
extern "C" {
    pub fn sysfs_remove_bin_file(kobj: *mut kobject, attr: *const bin_attribute);
}
extern "C" {
    #[must_use]
    pub fn sysfs_create_link(
        kobj: *mut kobject,
        target: *mut kobject,
        name: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn sysfs_create_link_nowarn(
        kobj: *mut kobject,
        target: *mut kobject,
        name: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sysfs_remove_link(kobj: *mut kobject, name: *const ffi::c_char);
}
extern "C" {
    pub fn sysfs_rename_link_ns(
        kobj: *mut kobject,
        target: *mut kobject,
        old_name: *const ffi::c_char,
        new_name: *const ffi::c_char,
        new_ns: *const ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sysfs_delete_link(dir: *mut kobject, targ: *mut kobject, name: *const ffi::c_char);
}
extern "C" {
    #[must_use]
    pub fn sysfs_create_group(kobj: *mut kobject, grp: *const attribute_group) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn sysfs_create_groups(
        kobj: *mut kobject,
        groups: *mut *const attribute_group,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn sysfs_update_groups(
        kobj: *mut kobject,
        groups: *mut *const attribute_group,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sysfs_update_group(kobj: *mut kobject, grp: *const attribute_group) -> ffi::c_int;
}
extern "C" {
    pub fn sysfs_remove_group(kobj: *mut kobject, grp: *const attribute_group);
}
extern "C" {
    pub fn sysfs_remove_groups(kobj: *mut kobject, groups: *mut *const attribute_group);
}
extern "C" {
    pub fn sysfs_add_file_to_group(
        kobj: *mut kobject,
        attr: *const attribute,
        group: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sysfs_remove_file_from_group(
        kobj: *mut kobject,
        attr: *const attribute,
        group: *const ffi::c_char,
    );
}
extern "C" {
    pub fn sysfs_merge_group(kobj: *mut kobject, grp: *const attribute_group) -> ffi::c_int;
}
extern "C" {
    pub fn sysfs_unmerge_group(kobj: *mut kobject, grp: *const attribute_group);
}
extern "C" {
    pub fn sysfs_add_link_to_group(
        kobj: *mut kobject,
        group_name: *const ffi::c_char,
        target: *mut kobject,
        link_name: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sysfs_remove_link_from_group(
        kobj: *mut kobject,
        group_name: *const ffi::c_char,
        link_name: *const ffi::c_char,
    );
}
extern "C" {
    pub fn compat_only_sysfs_link_entry_to_kobj(
        kobj: *mut kobject,
        target_kobj: *mut kobject,
        target_name: *const ffi::c_char,
        symlink_name: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sysfs_notify(kobj: *mut kobject, dir: *const ffi::c_char, attr: *const ffi::c_char);
}
extern "C" {
    #[must_use]
    pub fn sysfs_init() -> ffi::c_int;
}
extern "C" {
    pub fn sysfs_file_change_owner(
        kobj: *mut kobject,
        name: *const ffi::c_char,
        kuid: kuid_t,
        kgid: kgid_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sysfs_change_owner(kobj: *mut kobject, kuid: kuid_t, kgid: kgid_t) -> ffi::c_int;
}
extern "C" {
    pub fn sysfs_link_change_owner(
        kobj: *mut kobject,
        targ: *mut kobject,
        name: *const ffi::c_char,
        kuid: kuid_t,
        kgid: kgid_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sysfs_groups_change_owner(
        kobj: *mut kobject,
        groups: *mut *const attribute_group,
        kuid: kuid_t,
        kgid: kgid_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sysfs_group_change_owner(
        kobj: *mut kobject,
        groups: *const attribute_group,
        kuid: kuid_t,
        kgid: kgid_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sysfs_emit(buf: *mut ffi::c_char, fmt: *const ffi::c_char, ...) -> ffi::c_int;
}
extern "C" {
    pub fn sysfs_emit_at(
        buf: *mut ffi::c_char,
        at: ffi::c_int,
        fmt: *const ffi::c_char,
        ...
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sysfs_bin_attr_simple_read(
        file: *mut file,
        kobj: *mut kobject,
        attr: *const bin_attribute,
        buf: *mut ffi::c_char,
        off: loff_t,
        count: usize,
    ) -> isize;
}
extern "C" {
    pub static mut uevent_seqnum: atomic64_t;
}
pub const kobject_action_KOBJ_ADD: kobject_action = 0;
pub const kobject_action_KOBJ_REMOVE: kobject_action = 1;
pub const kobject_action_KOBJ_CHANGE: kobject_action = 2;
pub const kobject_action_KOBJ_MOVE: kobject_action = 3;
pub const kobject_action_KOBJ_ONLINE: kobject_action = 4;
pub const kobject_action_KOBJ_OFFLINE: kobject_action = 5;
pub const kobject_action_KOBJ_BIND: kobject_action = 6;
pub const kobject_action_KOBJ_UNBIND: kobject_action = 7;
pub type kobject_action = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kobject {
    pub name: *const ffi::c_char,
    pub entry: list_head,
    pub parent: *mut kobject,
    pub kset: *mut kset,
    pub ktype: *const kobj_type,
    pub sd: *mut kernfs_node,
    pub kref: kref,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub __bindgen_padding_0: [u8; 3usize],
}
impl Default for kobject {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl kobject {
    #[inline]
    pub fn state_initialized(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_state_initialized(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn state_initialized_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_state_initialized_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn state_in_sysfs(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_state_in_sysfs(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn state_in_sysfs_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_state_in_sysfs_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn state_add_uevent_sent(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_state_add_uevent_sent(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn state_add_uevent_sent_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_state_add_uevent_sent_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn state_remove_uevent_sent(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_state_remove_uevent_sent(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn state_remove_uevent_sent_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_state_remove_uevent_sent_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn uevent_suppress(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_uevent_suppress(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn uevent_suppress_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_uevent_suppress_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        state_initialized: ffi::c_uint,
        state_in_sysfs: ffi::c_uint,
        state_add_uevent_sent: ffi::c_uint,
        state_remove_uevent_sent: ffi::c_uint,
        uevent_suppress: ffi::c_uint,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let state_initialized: u32 = unsafe { ::core::mem::transmute(state_initialized) };
            state_initialized as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let state_in_sysfs: u32 = unsafe { ::core::mem::transmute(state_in_sysfs) };
            state_in_sysfs as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let state_add_uevent_sent: u32 =
                unsafe { ::core::mem::transmute(state_add_uevent_sent) };
            state_add_uevent_sent as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let state_remove_uevent_sent: u32 =
                unsafe { ::core::mem::transmute(state_remove_uevent_sent) };
            state_remove_uevent_sent as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let uevent_suppress: u32 = unsafe { ::core::mem::transmute(uevent_suppress) };
            uevent_suppress as u64
        });
        __bindgen_bitfield_unit
    }
}
extern "C" {
    pub fn kobject_set_name(kobj: *mut kobject, name: *const ffi::c_char, ...) -> ffi::c_int;
}
extern "C" {
    pub fn kobject_set_name_vargs(
        kobj: *mut kobject,
        fmt: *const ffi::c_char,
        vargs: va_list,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kobject_init(kobj: *mut kobject, ktype: *const kobj_type);
}
extern "C" {
    #[must_use]
    pub fn kobject_add(
        kobj: *mut kobject,
        parent: *mut kobject,
        fmt: *const ffi::c_char,
        ...
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn kobject_init_and_add(
        kobj: *mut kobject,
        ktype: *const kobj_type,
        parent: *mut kobject,
        fmt: *const ffi::c_char,
        ...
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kobject_del(kobj: *mut kobject);
}
extern "C" {
    #[must_use]
    pub fn kobject_create_and_add(name: *const ffi::c_char, parent: *mut kobject) -> *mut kobject;
}
extern "C" {
    #[must_use]
    pub fn kobject_rename(arg1: *mut kobject, new_name: *const ffi::c_char) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn kobject_move(arg1: *mut kobject, arg2: *mut kobject) -> ffi::c_int;
}
extern "C" {
    pub fn kobject_get(kobj: *mut kobject) -> *mut kobject;
}
extern "C" {
    #[must_use]
    pub fn kobject_get_unless_zero(kobj: *mut kobject) -> *mut kobject;
}
extern "C" {
    pub fn kobject_put(kobj: *mut kobject);
}
extern "C" {
    pub fn kobject_namespace(kobj: *const kobject) -> *const ffi::c_void;
}
extern "C" {
    pub fn kobject_get_ownership(kobj: *const kobject, uid: *mut kuid_t, gid: *mut kgid_t);
}
extern "C" {
    pub fn kobject_get_path(kobj: *const kobject, flag: gfp_t) -> *mut ffi::c_char;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kobj_type {
    pub release: ::core::option::Option<unsafe extern "C" fn(kobj: *mut kobject)>,
    pub sysfs_ops: *const sysfs_ops,
    pub default_groups: *mut *const attribute_group,
    pub child_ns_type: ::core::option::Option<
        unsafe extern "C" fn(kobj: *const kobject) -> *const kobj_ns_type_operations,
    >,
    pub namespace:
        ::core::option::Option<unsafe extern "C" fn(kobj: *const kobject) -> *const ffi::c_void>,
    pub get_ownership: ::core::option::Option<
        unsafe extern "C" fn(kobj: *const kobject, uid: *mut kuid_t, gid: *mut kgid_t),
    >,
}
impl Default for kobj_type {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kobj_uevent_env {
    pub argv: [*mut ffi::c_char; 3usize],
    pub envp: [*mut ffi::c_char; 64usize],
    pub envp_idx: ffi::c_int,
    pub buf: [ffi::c_char; 2048usize],
    pub buflen: ffi::c_int,
}
impl Default for kobj_uevent_env {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct kset_uevent_ops {
    pub filter: ::core::option::Option<unsafe extern "C" fn(kobj: *const kobject) -> ffi::c_int>,
    pub name:
        ::core::option::Option<unsafe extern "C" fn(kobj: *const kobject) -> *const ffi::c_char>,
    pub uevent: ::core::option::Option<
        unsafe extern "C" fn(kobj: *const kobject, env: *mut kobj_uevent_env) -> ffi::c_int,
    >,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kobj_attribute {
    pub attr: attribute,
    pub show: ::core::option::Option<
        unsafe extern "C" fn(
            kobj: *mut kobject,
            attr: *mut kobj_attribute,
            buf: *mut ffi::c_char,
        ) -> isize,
    >,
    pub store: ::core::option::Option<
        unsafe extern "C" fn(
            kobj: *mut kobject,
            attr: *mut kobj_attribute,
            buf: *const ffi::c_char,
            count: usize,
        ) -> isize,
    >,
}
impl Default for kobj_attribute {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static kobj_sysfs_ops: sysfs_ops;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kset {
    pub list: list_head,
    pub list_lock: spinlock_t,
    pub kobj: kobject,
    pub uevent_ops: *const kset_uevent_ops,
}
impl Default for kset {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn kset_init(kset: *mut kset);
}
extern "C" {
    #[must_use]
    pub fn kset_register(kset: *mut kset) -> ffi::c_int;
}
extern "C" {
    pub fn kset_unregister(kset: *mut kset);
}
extern "C" {
    #[must_use]
    pub fn kset_create_and_add(
        name: *const ffi::c_char,
        u: *const kset_uevent_ops,
        parent_kobj: *mut kobject,
    ) -> *mut kset;
}
extern "C" {
    pub fn kset_find_obj(arg1: *mut kset, arg2: *const ffi::c_char) -> *mut kobject;
}
extern "C" {
    pub static mut kernel_kobj: *mut kobject;
}
extern "C" {
    pub static mut mm_kobj: *mut kobject;
}
extern "C" {
    pub static mut hypervisor_kobj: *mut kobject;
}
extern "C" {
    pub static mut power_kobj: *mut kobject;
}
extern "C" {
    pub static mut firmware_kobj: *mut kobject;
}
extern "C" {
    pub fn kobject_uevent(kobj: *mut kobject, action: kobject_action) -> ffi::c_int;
}
extern "C" {
    pub fn kobject_uevent_env(
        kobj: *mut kobject,
        action: kobject_action,
        envp: *mut *mut ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kobject_synth_uevent(
        kobj: *mut kobject,
        buf: *const ffi::c_char,
        count: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn add_uevent_var(env: *mut kobj_uevent_env, format: *const ffi::c_char, ...)
        -> ffi::c_int;
}
pub const KERNEL_PARAM_OPS_FL_NOARG: _bindgen_ty_90 = 1;
pub type _bindgen_ty_90 = ffi::c_uint;
pub const KERNEL_PARAM_FL_UNSAFE: _bindgen_ty_91 = 1;
pub const KERNEL_PARAM_FL_HWPARAM: _bindgen_ty_91 = 2;
pub type _bindgen_ty_91 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kernel_param {
    pub name: *const ffi::c_char,
    pub mod_: *mut module,
    pub ops: *const kernel_param_ops,
    pub perm: u16_,
    pub level: s8,
    pub flags: u8_,
    pub __bindgen_anon_1: kernel_param__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union kernel_param__bindgen_ty_1 {
    pub arg: *mut ffi::c_void,
    pub str_: *const kparam_string,
    pub arr: *const kparam_array,
}
impl Default for kernel_param__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for kernel_param {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static __start___param: [kernel_param; 0usize];
}
extern "C" {
    pub static __stop___param: [kernel_param; 0usize];
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kparam_string {
    pub maxlen: ffi::c_uint,
    pub string: *mut ffi::c_char,
}
impl Default for kparam_string {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kparam_array {
    pub max: ffi::c_uint,
    pub elemsize: ffi::c_uint,
    pub num: *mut ffi::c_uint,
    pub ops: *const kernel_param_ops,
    pub elem: *mut ffi::c_void,
}
impl Default for kparam_array {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn kernel_param_lock(mod_: *mut module);
}
extern "C" {
    pub fn kernel_param_unlock(mod_: *mut module);
}
extern "C" {
    pub fn parameq(name1: *const ffi::c_char, name2: *const ffi::c_char) -> bool_;
}
extern "C" {
    pub fn parameqn(name1: *const ffi::c_char, name2: *const ffi::c_char, n: usize) -> bool_;
}
pub type parse_unknown_fn = ::core::option::Option<
    unsafe extern "C" fn(
        param: *mut ffi::c_char,
        val: *mut ffi::c_char,
        doing: *const ffi::c_char,
        arg: *mut ffi::c_void,
    ) -> ffi::c_int,
>;
extern "C" {
    pub fn parse_args(
        name: *const ffi::c_char,
        args: *mut ffi::c_char,
        params: *const kernel_param,
        num: ffi::c_uint,
        level_min: s16,
        level_max: s16,
        arg: *mut ffi::c_void,
        unknown: parse_unknown_fn,
    ) -> *mut ffi::c_char;
}
extern "C" {
    pub fn destroy_params(params: *const kernel_param, num: ffi::c_uint);
}
extern "C" {
    pub static param_ops_byte: kernel_param_ops;
}
extern "C" {
    pub fn param_set_byte(val: *const ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub fn param_get_byte(buffer: *mut ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub static param_ops_short: kernel_param_ops;
}
extern "C" {
    pub fn param_set_short(val: *const ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub fn param_get_short(buffer: *mut ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub static param_ops_ushort: kernel_param_ops;
}
extern "C" {
    pub fn param_set_ushort(val: *const ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub fn param_get_ushort(buffer: *mut ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub static param_ops_int: kernel_param_ops;
}
extern "C" {
    pub fn param_set_int(val: *const ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub fn param_get_int(buffer: *mut ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub static param_ops_uint: kernel_param_ops;
}
extern "C" {
    pub fn param_set_uint(val: *const ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub fn param_get_uint(buffer: *mut ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub fn param_set_uint_minmax(
        val: *const ffi::c_char,
        kp: *const kernel_param,
        min: ffi::c_uint,
        max: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub static param_ops_long: kernel_param_ops;
}
extern "C" {
    pub fn param_set_long(val: *const ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub fn param_get_long(buffer: *mut ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub static param_ops_ulong: kernel_param_ops;
}
extern "C" {
    pub fn param_set_ulong(val: *const ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub fn param_get_ulong(buffer: *mut ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub static param_ops_ullong: kernel_param_ops;
}
extern "C" {
    pub fn param_set_ullong(val: *const ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub fn param_get_ullong(buffer: *mut ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub static param_ops_hexint: kernel_param_ops;
}
extern "C" {
    pub fn param_set_hexint(val: *const ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub fn param_get_hexint(buffer: *mut ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub static param_ops_charp: kernel_param_ops;
}
extern "C" {
    pub fn param_set_charp(val: *const ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub fn param_get_charp(buffer: *mut ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub fn param_free_charp(arg: *mut ffi::c_void);
}
extern "C" {
    pub static param_ops_bool: kernel_param_ops;
}
extern "C" {
    pub fn param_set_bool(val: *const ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub fn param_get_bool(buffer: *mut ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub static param_ops_bool_enable_only: kernel_param_ops;
}
extern "C" {
    pub fn param_set_bool_enable_only(
        val: *const ffi::c_char,
        kp: *const kernel_param,
    ) -> ffi::c_int;
}
extern "C" {
    pub static param_ops_invbool: kernel_param_ops;
}
extern "C" {
    pub fn param_set_invbool(val: *const ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub fn param_get_invbool(buffer: *mut ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub static param_ops_bint: kernel_param_ops;
}
extern "C" {
    pub fn param_set_bint(val: *const ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
pub const hwparam_type_hwparam_ioport: hwparam_type = 0;
pub const hwparam_type_hwparam_iomem: hwparam_type = 1;
pub const hwparam_type_hwparam_ioport_or_iomem: hwparam_type = 2;
pub const hwparam_type_hwparam_irq: hwparam_type = 3;
pub const hwparam_type_hwparam_dma: hwparam_type = 4;
pub const hwparam_type_hwparam_dma_addr: hwparam_type = 5;
pub const hwparam_type_hwparam_other: hwparam_type = 6;
pub type hwparam_type = ffi::c_uint;
extern "C" {
    pub static param_array_ops: kernel_param_ops;
}
extern "C" {
    pub static param_ops_string: kernel_param_ops;
}
extern "C" {
    pub fn param_set_copystring(val: *const ffi::c_char, arg1: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub fn param_get_string(buffer: *mut ffi::c_char, kp: *const kernel_param) -> ffi::c_int;
}
extern "C" {
    pub fn module_param_sysfs_setup(
        mod_: *mut module,
        kparam: *const kernel_param,
        num_params: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn module_param_sysfs_remove(mod_: *mut module);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct latch_tree_node {
    pub node: [rb_node; 2usize],
}
impl Default for latch_tree_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct latch_tree_root {
    pub seq: seqcount_latch_t,
    pub tree: [rb_root; 2usize],
}
impl Default for latch_tree_root {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct latch_tree_ops {
    pub less: ::core::option::Option<
        unsafe extern "C" fn(a: *mut latch_tree_node, b: *mut latch_tree_node) -> bool_,
    >,
    pub comp: ::core::option::Option<
        unsafe extern "C" fn(key: *mut ffi::c_void, b: *mut latch_tree_node) -> ffi::c_int,
    >,
}
pub const EI_ETYPE_NULL: _bindgen_ty_92 = 0;
pub const EI_ETYPE_ERRNO: _bindgen_ty_92 = 1;
pub const EI_ETYPE_ERRNO_NULL: _bindgen_ty_92 = 2;
pub const EI_ETYPE_TRUE: _bindgen_ty_92 = 3;
pub type _bindgen_ty_92 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct error_injection_entry {
    pub addr: ffi::c_ulong,
    pub etype: ffi::c_int,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct mod_plt_sec {
    pub plt_shndx: ffi::c_int,
    pub plt_num_entries: ffi::c_int,
    pub plt_max_entries: ffi::c_int,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mod_arch_specific {
    pub core: mod_plt_sec,
    pub init: mod_plt_sec,
    pub ftrace_trampolines: *mut plt_entry,
}
impl Default for mod_arch_specific {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn module_emit_plt_entry(
        mod_: *mut module,
        sechdrs: *mut Elf64_Shdr,
        loc: *mut ffi::c_void,
        rela: *const Elf64_Rela,
        sym: *mut Elf64_Sym,
    ) -> u64_;
}
extern "C" {
    pub fn module_emit_veneer_for_adrp(
        mod_: *mut module,
        sechdrs: *mut Elf64_Shdr,
        loc: *mut ffi::c_void,
        val: u64_,
    ) -> u64_;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct plt_entry {
    pub adrp: __le32,
    pub add: __le32,
    pub br: __le32,
}
extern "C" {
    pub fn get_plt_entry(dst: u64_, pc: *mut ffi::c_void) -> plt_entry;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct modversion_info {
    pub crc: ffi::c_ulong,
    pub name: [ffi::c_char; 56usize],
}
impl Default for modversion_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct module_kobject {
    pub kobj: kobject,
    pub mod_: *mut module,
    pub drivers_dir: *mut kobject,
    pub mp: *mut module_param_attrs,
    pub kobj_completion: *mut completion,
}
impl Default for module_kobject {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct module_attribute {
    pub attr: attribute,
    pub show: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *const module_attribute,
            arg2: *mut module_kobject,
            arg3: *mut ffi::c_char,
        ) -> isize,
    >,
    pub store: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *const module_attribute,
            arg2: *mut module_kobject,
            arg3: *const ffi::c_char,
            count: usize,
        ) -> isize,
    >,
    pub setup:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut module, arg2: *const ffi::c_char)>,
    pub test: ::core::option::Option<unsafe extern "C" fn(arg1: *mut module) -> ffi::c_int>,
    pub free: ::core::option::Option<unsafe extern "C" fn(arg1: *mut module)>,
}
impl Default for module_attribute {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct module_version_attribute {
    pub mattr: module_attribute,
    pub module_name: *const ffi::c_char,
    pub version: *const ffi::c_char,
}
impl Default for module_version_attribute {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn __modver_version_show(
        arg1: *const module_attribute,
        arg2: *mut module_kobject,
        arg3: *mut ffi::c_char,
    ) -> isize;
}
extern "C" {
    pub static module_uevent: module_attribute;
}
extern "C" {
    pub fn init_module() -> ffi::c_int;
}
extern "C" {
    pub fn cleanup_module();
}
extern "C" {
    pub fn lookup_or_create_module_kobject(name: *const ffi::c_char) -> *mut module_kobject;
}
extern "C" {
    pub static mut modules_disabled: ffi::c_int;
}
extern "C" {
    pub fn __symbol_get(symbol: *const ffi::c_char) -> *mut ffi::c_void;
}
extern "C" {
    pub fn __symbol_get_gpl(symbol: *const ffi::c_char) -> *mut ffi::c_void;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct module_use {
    pub source_list: list_head,
    pub target_list: list_head,
    pub source: *mut module,
    pub target: *mut module,
}
impl Default for module_use {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const module_state_MODULE_STATE_LIVE: module_state = 0;
pub const module_state_MODULE_STATE_COMING: module_state = 1;
pub const module_state_MODULE_STATE_GOING: module_state = 2;
pub const module_state_MODULE_STATE_UNFORMED: module_state = 3;
pub type module_state = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mod_tree_node {
    pub mod_: *mut module,
    pub node: latch_tree_node,
}
impl Default for mod_tree_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const mod_mem_type_MOD_TEXT: mod_mem_type = 0;
pub const mod_mem_type_MOD_DATA: mod_mem_type = 1;
pub const mod_mem_type_MOD_RODATA: mod_mem_type = 2;
pub const mod_mem_type_MOD_RO_AFTER_INIT: mod_mem_type = 3;
pub const mod_mem_type_MOD_INIT_TEXT: mod_mem_type = 4;
pub const mod_mem_type_MOD_INIT_DATA: mod_mem_type = 5;
pub const mod_mem_type_MOD_INIT_RODATA: mod_mem_type = 6;
pub const mod_mem_type_MOD_MEM_NUM_TYPES: mod_mem_type = 7;
pub const mod_mem_type_MOD_INVALID: mod_mem_type = -1;
pub type mod_mem_type = ffi::c_int;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct module_memory {
    pub base: *mut ffi::c_void,
    pub is_rox: bool_,
    pub size: ffi::c_uint,
    pub mtn: mod_tree_node,
}
impl Default for module_memory {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mod_kallsyms {
    pub symtab: *mut Elf64_Sym,
    pub num_symtab: ffi::c_uint,
    pub strtab: *mut ffi::c_char,
    pub typetab: *mut ffi::c_char,
}
impl Default for mod_kallsyms {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn __module_text_address(addr: ffi::c_ulong) -> *mut module;
}
extern "C" {
    pub fn __module_address(addr: ffi::c_ulong) -> *mut module;
}
extern "C" {
    pub fn is_module_address(addr: ffi::c_ulong) -> bool_;
}
extern "C" {
    pub fn __is_module_percpu_address(addr: ffi::c_ulong, can_addr: *mut ffi::c_ulong) -> bool_;
}
extern "C" {
    pub fn is_module_percpu_address(addr: ffi::c_ulong) -> bool_;
}
extern "C" {
    pub fn is_module_text_address(addr: ffi::c_ulong) -> bool_;
}
extern "C" {
    pub fn find_module(name: *const ffi::c_char) -> *mut module;
}
extern "C" {
    pub fn __module_put_and_kthread_exit(mod_: *mut module, code: ffi::c_long) -> !;
}
extern "C" {
    pub fn module_refcount(mod_: *mut module) -> ffi::c_int;
}
extern "C" {
    pub fn __symbol_put(symbol: *const ffi::c_char);
}
extern "C" {
    pub fn symbol_put_addr(addr: *mut ffi::c_void);
}
extern "C" {
    pub fn __module_get(module: *mut module);
}
extern "C" {
    pub fn try_module_get(module: *mut module) -> bool_;
}
extern "C" {
    pub fn module_put(module: *mut module);
}
extern "C" {
    pub fn dereference_module_function_descriptor(
        mod_: *mut module,
        ptr: *mut ffi::c_void,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn register_module_notifier(nb: *mut notifier_block) -> ffi::c_int;
}
extern "C" {
    pub fn unregister_module_notifier(nb: *mut notifier_block) -> ffi::c_int;
}
extern "C" {
    pub fn print_modules();
}
extern "C" {
    pub fn set_module_sig_enforced();
}
extern "C" {
    pub fn module_for_each_mod(
        func: ::core::option::Option<
            unsafe extern "C" fn(mod_: *mut module, data: *mut ffi::c_void) -> ffi::c_int,
        >,
        data: *mut ffi::c_void,
    );
}
extern "C" {
    pub static mut module_kset: *mut kset;
}
extern "C" {
    pub static module_ktype: kobj_type;
}
extern "C" {
    pub fn module_bug_finalize(arg1: *const Elf64_Ehdr, arg2: *const Elf64_Shdr, arg3: *mut module);
}
extern "C" {
    pub fn module_bug_cleanup(arg1: *mut module);
}
extern "C" {
    pub fn is_module_sig_enforced() -> bool_;
}
extern "C" {
    pub fn module_kallsyms_on_each_symbol(
        modname: *const ffi::c_char,
        fn_: ::core::option::Option<
            unsafe extern "C" fn(
                arg1: *mut ffi::c_void,
                arg2: *const ffi::c_char,
                arg3: ffi::c_ulong,
            ) -> ffi::c_int,
        >,
        data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn module_address_lookup(
        addr: ffi::c_ulong,
        symbolsize: *mut ffi::c_ulong,
        offset: *mut ffi::c_ulong,
        modname: *mut *mut ffi::c_char,
        modbuildid: *mut *const ffi::c_uchar,
        namebuf: *mut ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn lookup_module_symbol_name(addr: ffi::c_ulong, symname: *mut ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub fn lookup_module_symbol_attrs(
        addr: ffi::c_ulong,
        size: *mut ffi::c_ulong,
        offset: *mut ffi::c_ulong,
        modname: *mut ffi::c_char,
        name: *mut ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn module_get_kallsym(
        symnum: ffi::c_uint,
        value: *mut ffi::c_ulong,
        type_: *mut ffi::c_char,
        name: *mut ffi::c_char,
        module_name: *mut ffi::c_char,
        exported: *mut ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn module_kallsyms_lookup_name(name: *const ffi::c_char) -> ffi::c_ulong;
}
extern "C" {
    pub fn find_kallsyms_symbol_value(mod_: *mut module, name: *const ffi::c_char) -> ffi::c_ulong;
}
extern "C" {
    pub static mut kunit_running: static_key_false;
}
pub const kunit_status_KUNIT_SUCCESS: kunit_status = 0;
pub const kunit_status_KUNIT_FAILURE: kunit_status = 1;
pub const kunit_status_KUNIT_SKIPPED: kunit_status = 2;
pub type kunit_status = ffi::c_uint;
pub const kunit_speed_KUNIT_SPEED_UNSET: kunit_speed = 0;
pub const kunit_speed_KUNIT_SPEED_VERY_SLOW: kunit_speed = 1;
pub const kunit_speed_KUNIT_SPEED_SLOW: kunit_speed = 2;
pub const kunit_speed_KUNIT_SPEED_NORMAL: kunit_speed = 3;
pub const kunit_speed_KUNIT_SPEED_MAX: kunit_speed = 3;
pub type kunit_speed = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kunit_attributes {
    pub speed: kunit_speed,
}
impl Default for kunit_attributes {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kunit_case {
    pub run_case: ::core::option::Option<unsafe extern "C" fn(test: *mut kunit)>,
    pub name: *const ffi::c_char,
    pub generate_params: ::core::option::Option<
        unsafe extern "C" fn(
            prev: *const ffi::c_void,
            desc: *mut ffi::c_char,
        ) -> *const ffi::c_void,
    >,
    pub attr: kunit_attributes,
    pub status: kunit_status,
    pub module_name: *mut ffi::c_char,
    pub log: *mut string_stream,
}
impl Default for kunit_case {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kunit_suite {
    pub name: [ffi::c_char; 256usize],
    pub suite_init:
        ::core::option::Option<unsafe extern "C" fn(suite: *mut kunit_suite) -> ffi::c_int>,
    pub suite_exit: ::core::option::Option<unsafe extern "C" fn(suite: *mut kunit_suite)>,
    pub init: ::core::option::Option<unsafe extern "C" fn(test: *mut kunit) -> ffi::c_int>,
    pub exit: ::core::option::Option<unsafe extern "C" fn(test: *mut kunit)>,
    pub test_cases: *mut kunit_case,
    pub attr: kunit_attributes,
    pub status_comment: [ffi::c_char; 256usize],
    pub debugfs: *mut dentry,
    pub log: *mut string_stream,
    pub suite_init_err: ffi::c_int,
    pub is_init: bool_,
}
impl Default for kunit_suite {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kunit_suite_set {
    pub start: *const *mut kunit_suite,
    pub end: *const *mut kunit_suite,
}
impl Default for kunit_suite_set {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kunit {
    pub priv_: *mut ffi::c_void,
    pub name: *const ffi::c_char,
    pub log: *mut string_stream,
    pub try_catch: kunit_try_catch,
    pub param_value: *const ffi::c_void,
    pub param_index: ffi::c_int,
    pub lock: spinlock_t,
    pub status: kunit_status,
    pub resources: list_head,
    pub status_comment: [ffi::c_char; 256usize],
    pub last_seen: kunit_loc,
}
impl Default for kunit {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn kunit_enabled() -> bool_;
}
extern "C" {
    pub fn kunit_autorun() -> bool_;
}
extern "C" {
    pub fn kunit_action() -> *const ffi::c_char;
}
extern "C" {
    pub fn kunit_filter_glob() -> *const ffi::c_char;
}
extern "C" {
    pub fn kunit_filter() -> *mut ffi::c_char;
}
extern "C" {
    pub fn kunit_filter_action() -> *mut ffi::c_char;
}
extern "C" {
    pub fn kunit_init_test(test: *mut kunit, name: *const ffi::c_char, log: *mut string_stream);
}
extern "C" {
    pub fn kunit_run_tests(suite: *mut kunit_suite) -> ffi::c_int;
}
extern "C" {
    pub fn kunit_suite_num_test_cases(suite: *mut kunit_suite) -> usize;
}
extern "C" {
    pub fn kunit_test_case_num(suite: *mut kunit_suite, test_case: *mut kunit_case) -> ffi::c_uint;
}
extern "C" {
    pub fn kunit_filter_suites(
        suite_set: *const kunit_suite_set,
        filter_glob: *const ffi::c_char,
        filters: *mut ffi::c_char,
        filter_action: *mut ffi::c_char,
        err: *mut ffi::c_int,
    ) -> kunit_suite_set;
}
extern "C" {
    pub fn kunit_free_suite_set(suite_set: kunit_suite_set);
}
extern "C" {
    pub fn __kunit_test_suites_init(
        suites: *const *mut kunit_suite,
        num_suites: ffi::c_int,
        run_tests: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __kunit_test_suites_exit(suites: *mut *mut kunit_suite, num_suites: ffi::c_int);
}
extern "C" {
    pub fn kunit_exec_run_tests(suite_set: *mut kunit_suite_set, builtin: bool_);
}
extern "C" {
    pub fn kunit_exec_list_tests(suite_set: *mut kunit_suite_set, include_attr: bool_);
}
extern "C" {
    pub fn kunit_merge_suite_sets(
        init_suite_set: kunit_suite_set,
        suite_set: kunit_suite_set,
    ) -> kunit_suite_set;
}
extern "C" {
    pub fn kunit_suite_has_succeeded(suite: *mut kunit_suite) -> kunit_status;
}
extern "C" {
    pub fn kunit_kmalloc_array(
        test: *mut kunit,
        n: usize,
        size: usize,
        gfp: gfp_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn kunit_kfree(test: *mut kunit, ptr: *const ffi::c_void);
}
extern "C" {
    pub fn kunit_kfree_const(test: *mut kunit, x: *const ffi::c_void);
}
extern "C" {
    pub fn kunit_kstrdup_const(
        test: *mut kunit,
        str_: *const ffi::c_char,
        gfp: gfp_t,
    ) -> *const ffi::c_char;
}
extern "C" {
    pub fn kunit_vm_mmap(
        test: *mut kunit,
        file: *mut file,
        addr: ffi::c_ulong,
        len: ffi::c_ulong,
        prot: ffi::c_ulong,
        flag: ffi::c_ulong,
        offset: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn kunit_cleanup(test: *mut kunit);
}
extern "C" {
    pub fn kunit_log_append(log: *mut string_stream, fmt: *const ffi::c_char, ...);
}
extern "C" {
    pub fn __kunit_abort(test: *mut kunit) -> !;
}
extern "C" {
    pub fn __kunit_do_failed_assertion(
        test: *mut kunit,
        loc: *const kunit_loc,
        type_: kunit_assert_type,
        assert: *const kunit_assert,
        assert_format: assert_format_t,
        fmt: *const ffi::c_char,
        ...
    );
}
pub type kunit_resource_init_t = ::core::option::Option<
    unsafe extern "C" fn(arg1: *mut kunit_resource, arg2: *mut ffi::c_void) -> ffi::c_int,
>;
pub type kunit_resource_free_t =
    ::core::option::Option<unsafe extern "C" fn(arg1: *mut kunit_resource)>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kunit_resource {
    pub data: *mut ffi::c_void,
    pub name: *const ffi::c_char,
    pub free: kunit_resource_free_t,
    pub refcount: kref,
    pub node: list_head,
    pub should_kfree: bool_,
}
impl Default for kunit_resource {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn __kunit_add_resource(
        test: *mut kunit,
        init: kunit_resource_init_t,
        free: kunit_resource_free_t,
        res: *mut kunit_resource,
        data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
pub type kunit_resource_match_t = ::core::option::Option<
    unsafe extern "C" fn(
        test: *mut kunit,
        res: *mut kunit_resource,
        match_data: *mut ffi::c_void,
    ) -> bool_,
>;
extern "C" {
    pub fn kunit_destroy_resource(
        test: *mut kunit,
        match_: kunit_resource_match_t,
        match_data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kunit_remove_resource(test: *mut kunit, res: *mut kunit_resource);
}
pub type kunit_action_t = ::core::option::Option<unsafe extern "C" fn(arg1: *mut ffi::c_void)>;
extern "C" {
    pub fn kunit_add_action(
        test: *mut kunit,
        action: kunit_action_t,
        ctx: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kunit_add_action_or_reset(
        test: *mut kunit,
        action: kunit_action_t,
        ctx: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kunit_remove_action(test: *mut kunit, action: kunit_action_t, ctx: *mut ffi::c_void);
}
extern "C" {
    pub fn kunit_release_action(test: *mut kunit, action: kunit_action_t, ctx: *mut ffi::c_void);
}
pub const irqreturn_IRQ_NONE: irqreturn = 0;
pub const irqreturn_IRQ_HANDLED: irqreturn = 1;
pub const irqreturn_IRQ_WAKE_THREAD: irqreturn = 2;
pub type irqreturn = ffi::c_uint;
pub use self::irqreturn as irqreturn_t;
pub const ctx_state_CT_STATE_DISABLED: ctx_state = -1;
pub const ctx_state_CT_STATE_KERNEL: ctx_state = 0;
pub const ctx_state_CT_STATE_IDLE: ctx_state = 1;
pub const ctx_state_CT_STATE_USER: ctx_state = 2;
pub const ctx_state_CT_STATE_GUEST: ctx_state = 3;
pub const ctx_state_CT_STATE_MAX: ctx_state = 4;
pub type ctx_state = ffi::c_int;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct context_tracking {
    pub active: bool_,
    pub recursion: ffi::c_int,
    pub state: atomic_t,
    pub nesting: ffi::c_long,
    pub nmi_nesting: ffi::c_long,
}
extern "C" {
    pub static mut context_tracking: context_tracking;
}
extern "C" {
    pub static mut context_tracking_key: static_key_false;
}
extern "C" {
    pub static mut trace_hwlat_callback_enabled: bool_;
}
extern "C" {
    pub fn trace_hwlat_callback(enter: bool_);
}
extern "C" {
    pub static mut trace_osnoise_callback_enabled: bool_;
}
extern "C" {
    pub fn trace_osnoise_callback(enter: bool_);
}
extern "C" {
    pub fn vtime_account_kernel(tsk: *mut task_struct);
}
extern "C" {
    pub fn vtime_account_idle(tsk: *mut task_struct);
}
extern "C" {
    pub fn vtime_user_enter(tsk: *mut task_struct);
}
extern "C" {
    pub fn vtime_user_exit(tsk: *mut task_struct);
}
extern "C" {
    pub fn vtime_guest_enter(tsk: *mut task_struct);
}
extern "C" {
    pub fn vtime_guest_exit(tsk: *mut task_struct);
}
extern "C" {
    pub fn vtime_init_idle(tsk: *mut task_struct, cpu: ffi::c_int);
}
extern "C" {
    pub fn vtime_task_switch_generic(prev: *mut task_struct);
}
extern "C" {
    pub fn irqtime_account_irq(tsk: *mut task_struct, offset: ffi::c_uint);
}
extern "C" {
    pub fn arch_trigger_cpumask_backtrace(mask: *const cpumask_t, exclude_cpu: ffi::c_int);
}
extern "C" {
    pub fn set_handle_irq(
        handle_irq: ::core::option::Option<unsafe extern "C" fn(arg1: *mut pt_regs)>,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn set_handle_fiq(
        handle_fiq: ::core::option::Option<unsafe extern "C" fn(arg1: *mut pt_regs)>,
    ) -> ffi::c_int;
}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct irq_cpustat_t {
    pub __softirq_pending: ffi::c_uint,
}
impl Default for irq_cpustat_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut irq_stat: irq_cpustat_t;
}
pub type irq_flow_handler_t = ::core::option::Option<unsafe extern "C" fn(desc: *mut irq_desc)>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct cpu_suspend_ctx {
    _unused: [u8; 0],
}
extern "C" {
    pub fn cpu_do_idle();
}
extern "C" {
    pub fn cpu_do_suspend(ptr: *mut cpu_suspend_ctx);
}
extern "C" {
    pub fn cpu_do_resume(ptr: phys_addr_t, idmap_ttbr: u64_) -> u64_;
}
extern "C" {
    pub static mut __tracepoint_mmap_lock_start_locking: tracepoint;
}
extern "C" {
    pub static mut __tracepoint_mmap_lock_acquire_returned: tracepoint;
}
extern "C" {
    pub static mut __tracepoint_mmap_lock_released: tracepoint;
}
extern "C" {
    pub fn __mmap_lock_do_trace_start_locking(mm: *mut mm_struct, write: bool_);
}
extern "C" {
    pub fn __mmap_lock_do_trace_acquire_returned(mm: *mut mm_struct, write: bool_, success: bool_);
}
extern "C" {
    pub fn __mmap_lock_do_trace_released(mm: *mut mm_struct, write: bool_);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct interval_tree_node {
    pub rb: rb_node,
    pub start: ffi::c_ulong,
    pub last: ffi::c_ulong,
    pub __subtree_last: ffi::c_ulong,
}
impl Default for interval_tree_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn interval_tree_insert(node: *mut interval_tree_node, root: *mut rb_root_cached);
}
extern "C" {
    pub fn interval_tree_remove(node: *mut interval_tree_node, root: *mut rb_root_cached);
}
extern "C" {
    pub fn interval_tree_iter_first(
        root: *mut rb_root_cached,
        start: ffi::c_ulong,
        last: ffi::c_ulong,
    ) -> *mut interval_tree_node;
}
extern "C" {
    pub fn interval_tree_iter_next(
        node: *mut interval_tree_node,
        start: ffi::c_ulong,
        last: ffi::c_ulong,
    ) -> *mut interval_tree_node;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct interval_tree_span_iter {
    pub nodes: [*mut interval_tree_node; 2usize],
    pub first_index: ffi::c_ulong,
    pub last_index: ffi::c_ulong,
    pub __bindgen_anon_1: interval_tree_span_iter__bindgen_ty_1,
    pub __bindgen_anon_2: interval_tree_span_iter__bindgen_ty_2,
    pub is_hole: ffi::c_int,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union interval_tree_span_iter__bindgen_ty_1 {
    pub start_hole: ffi::c_ulong,
    pub start_used: ffi::c_ulong,
}
impl Default for interval_tree_span_iter__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union interval_tree_span_iter__bindgen_ty_2 {
    pub last_hole: ffi::c_ulong,
    pub last_used: ffi::c_ulong,
}
impl Default for interval_tree_span_iter__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for interval_tree_span_iter {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn interval_tree_span_iter_first(
        state: *mut interval_tree_span_iter,
        itree: *mut rb_root_cached,
        first_index: ffi::c_ulong,
        last_index: ffi::c_ulong,
    );
}
extern "C" {
    pub fn interval_tree_span_iter_advance(
        iter: *mut interval_tree_span_iter,
        itree: *mut rb_root_cached,
        new_index: ffi::c_ulong,
    );
}
extern "C" {
    pub fn interval_tree_span_iter_next(state: *mut interval_tree_span_iter);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mmu_notifier_subscriptions {
    _unused: [u8; 0],
}
pub const mmu_notifier_event_MMU_NOTIFY_UNMAP: mmu_notifier_event = 0;
pub const mmu_notifier_event_MMU_NOTIFY_CLEAR: mmu_notifier_event = 1;
pub const mmu_notifier_event_MMU_NOTIFY_PROTECTION_VMA: mmu_notifier_event = 2;
pub const mmu_notifier_event_MMU_NOTIFY_PROTECTION_PAGE: mmu_notifier_event = 3;
pub const mmu_notifier_event_MMU_NOTIFY_SOFT_DIRTY: mmu_notifier_event = 4;
pub const mmu_notifier_event_MMU_NOTIFY_RELEASE: mmu_notifier_event = 5;
pub const mmu_notifier_event_MMU_NOTIFY_MIGRATE: mmu_notifier_event = 6;
pub const mmu_notifier_event_MMU_NOTIFY_EXCLUSIVE: mmu_notifier_event = 7;
pub type mmu_notifier_event = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct mmu_notifier_ops {
    pub release: ::core::option::Option<
        unsafe extern "C" fn(subscription: *mut mmu_notifier, mm: *mut mm_struct),
    >,
    pub clear_flush_young: ::core::option::Option<
        unsafe extern "C" fn(
            subscription: *mut mmu_notifier,
            mm: *mut mm_struct,
            start: ffi::c_ulong,
            end: ffi::c_ulong,
        ) -> ffi::c_int,
    >,
    pub clear_young: ::core::option::Option<
        unsafe extern "C" fn(
            subscription: *mut mmu_notifier,
            mm: *mut mm_struct,
            start: ffi::c_ulong,
            end: ffi::c_ulong,
        ) -> ffi::c_int,
    >,
    pub test_young: ::core::option::Option<
        unsafe extern "C" fn(
            subscription: *mut mmu_notifier,
            mm: *mut mm_struct,
            address: ffi::c_ulong,
        ) -> ffi::c_int,
    >,
    pub invalidate_range_start: ::core::option::Option<
        unsafe extern "C" fn(
            subscription: *mut mmu_notifier,
            range: *const mmu_notifier_range,
        ) -> ffi::c_int,
    >,
    pub invalidate_range_end: ::core::option::Option<
        unsafe extern "C" fn(subscription: *mut mmu_notifier, range: *const mmu_notifier_range),
    >,
    pub arch_invalidate_secondary_tlbs: ::core::option::Option<
        unsafe extern "C" fn(
            subscription: *mut mmu_notifier,
            mm: *mut mm_struct,
            start: ffi::c_ulong,
            end: ffi::c_ulong,
        ),
    >,
    pub alloc_notifier:
        ::core::option::Option<unsafe extern "C" fn(mm: *mut mm_struct) -> *mut mmu_notifier>,
    pub free_notifier:
        ::core::option::Option<unsafe extern "C" fn(subscription: *mut mmu_notifier)>,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mmu_notifier {
    pub hlist: hlist_node,
    pub ops: *const mmu_notifier_ops,
    pub mm: *mut mm_struct,
    pub rcu: callback_head,
    pub users: ffi::c_uint,
}
impl Default for mmu_notifier {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct mmu_interval_notifier_ops {
    pub invalidate: ::core::option::Option<
        unsafe extern "C" fn(
            interval_sub: *mut mmu_interval_notifier,
            range: *const mmu_notifier_range,
            cur_seq: ffi::c_ulong,
        ) -> bool_,
    >,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mmu_interval_notifier {
    pub interval_tree: interval_tree_node,
    pub ops: *const mmu_interval_notifier_ops,
    pub mm: *mut mm_struct,
    pub deferred_item: hlist_node,
    pub invalidate_seq: ffi::c_ulong,
}
impl Default for mmu_interval_notifier {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mmu_notifier_range {
    pub mm: *mut mm_struct,
    pub start: ffi::c_ulong,
    pub end: ffi::c_ulong,
    pub flags: ffi::c_uint,
    pub event: mmu_notifier_event,
    pub owner: *mut ffi::c_void,
}
impl Default for mmu_notifier_range {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn mmu_notifier_get_locked(
        ops: *const mmu_notifier_ops,
        mm: *mut mm_struct,
    ) -> *mut mmu_notifier;
}
extern "C" {
    pub fn mmu_notifier_put(subscription: *mut mmu_notifier);
}
extern "C" {
    pub fn mmu_notifier_synchronize();
}
extern "C" {
    pub fn mmu_notifier_register(subscription: *mut mmu_notifier, mm: *mut mm_struct)
        -> ffi::c_int;
}
extern "C" {
    pub fn __mmu_notifier_register(
        subscription: *mut mmu_notifier,
        mm: *mut mm_struct,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mmu_notifier_unregister(subscription: *mut mmu_notifier, mm: *mut mm_struct);
}
extern "C" {
    pub fn mmu_interval_read_begin(interval_sub: *mut mmu_interval_notifier) -> ffi::c_ulong;
}
extern "C" {
    pub fn mmu_interval_notifier_insert(
        interval_sub: *mut mmu_interval_notifier,
        mm: *mut mm_struct,
        start: ffi::c_ulong,
        length: ffi::c_ulong,
        ops: *const mmu_interval_notifier_ops,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mmu_interval_notifier_insert_locked(
        interval_sub: *mut mmu_interval_notifier,
        mm: *mut mm_struct,
        start: ffi::c_ulong,
        length: ffi::c_ulong,
        ops: *const mmu_interval_notifier_ops,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mmu_interval_notifier_remove(interval_sub: *mut mmu_interval_notifier);
}
extern "C" {
    pub fn __mmu_notifier_subscriptions_destroy(mm: *mut mm_struct);
}
extern "C" {
    pub fn __mmu_notifier_release(mm: *mut mm_struct);
}
extern "C" {
    pub fn __mmu_notifier_clear_flush_young(
        mm: *mut mm_struct,
        start: ffi::c_ulong,
        end: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __mmu_notifier_clear_young(
        mm: *mut mm_struct,
        start: ffi::c_ulong,
        end: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __mmu_notifier_test_young(mm: *mut mm_struct, address: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn __mmu_notifier_invalidate_range_start(r: *mut mmu_notifier_range) -> ffi::c_int;
}
extern "C" {
    pub fn __mmu_notifier_invalidate_range_end(r: *mut mmu_notifier_range);
}
extern "C" {
    pub fn __mmu_notifier_arch_invalidate_secondary_tlbs(
        mm: *mut mm_struct,
        start: ffi::c_ulong,
        end: ffi::c_ulong,
    );
}
extern "C" {
    pub fn mmu_notifier_range_update_to_read_only(range: *const mmu_notifier_range) -> bool_;
}
pub const fixed_addresses_FIX_HOLE: fixed_addresses = 0;
pub const fixed_addresses_FIX_FDT_END: fixed_addresses = 1;
pub const fixed_addresses_FIX_FDT: fixed_addresses = 514;
pub const fixed_addresses_FIX_EARLYCON_MEM_BASE: fixed_addresses = 515;
pub const fixed_addresses_FIX_TEXT_POKE0: fixed_addresses = 516;
pub const fixed_addresses_FIX_APEI_GHES_IRQ: fixed_addresses = 517;
pub const fixed_addresses_FIX_APEI_GHES_SEA: fixed_addresses = 518;
pub const fixed_addresses_FIX_APEI_GHES_SDEI_NORMAL: fixed_addresses = 519;
pub const fixed_addresses_FIX_APEI_GHES_SDEI_CRITICAL: fixed_addresses = 520;
pub const fixed_addresses_FIX_ENTRY_TRAMP_TEXT4: fixed_addresses = 521;
pub const fixed_addresses_FIX_ENTRY_TRAMP_TEXT3: fixed_addresses = 522;
pub const fixed_addresses_FIX_ENTRY_TRAMP_TEXT2: fixed_addresses = 523;
pub const fixed_addresses_FIX_ENTRY_TRAMP_TEXT1: fixed_addresses = 524;
pub const fixed_addresses___end_of_permanent_fixed_addresses: fixed_addresses = 525;
pub const fixed_addresses_FIX_BTMAP_END: fixed_addresses = 525;
pub const fixed_addresses_FIX_BTMAP_BEGIN: fixed_addresses = 972;
pub const fixed_addresses_FIX_PTE: fixed_addresses = 973;
pub const fixed_addresses_FIX_PMD: fixed_addresses = 974;
pub const fixed_addresses_FIX_PUD: fixed_addresses = 975;
pub const fixed_addresses_FIX_P4D: fixed_addresses = 976;
pub const fixed_addresses_FIX_PGD: fixed_addresses = 977;
pub const fixed_addresses___end_of_fixed_addresses: fixed_addresses = 978;
pub type fixed_addresses = ffi::c_uint;
extern "C" {
    pub fn early_fixmap_init();
}
extern "C" {
    pub fn __set_fixmap(idx: fixed_addresses, phys: phys_addr_t, prot: pgprot_t);
}
extern "C" {
    pub static mut empty_zero_page: [ffi::c_ulong; 512usize];
}
extern "C" {
    pub fn __sync_icache_dcache(pteval: pte_t);
}
extern "C" {
    pub fn pgattr_change_is_safe(old: pteval_t, new: pteval_t) -> bool_;
}
extern "C" {
    pub fn phys_mem_access_prot(
        file: *mut file,
        pfn: ffi::c_ulong,
        size: ffi::c_ulong,
        vma_prot: pgprot_t,
    ) -> pgprot_t;
}
extern "C" {
    pub static mut init_pg_dir: [pgd_t; 0usize];
}
extern "C" {
    pub static mut init_pg_end: [pgd_t; 0usize];
}
extern "C" {
    pub static mut swapper_pg_dir: [pgd_t; 0usize];
}
extern "C" {
    pub static mut idmap_pg_dir: [pgd_t; 0usize];
}
extern "C" {
    pub static mut tramp_pg_dir: [pgd_t; 0usize];
}
extern "C" {
    pub static mut reserved_pg_dir: [pgd_t; 0usize];
}
extern "C" {
    pub fn set_swapper_pgd(pgdp: *mut pgd_t, pgd: pgd_t);
}
extern "C" {
    pub fn __ptep_set_access_flags(
        vma: *mut vm_area_struct,
        address: ffi::c_ulong,
        ptep: *mut pte_t,
        entry: pte_t,
        dirty: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn arch_prepare_to_swap(folio: *mut folio) -> ffi::c_int;
}
extern "C" {
    pub fn arch_swap_restore(entry: swp_entry_t, folio: *mut folio);
}
extern "C" {
    pub fn ptep_modify_prot_start(
        vma: *mut vm_area_struct,
        addr: ffi::c_ulong,
        ptep: *mut pte_t,
    ) -> pte_t;
}
extern "C" {
    pub fn ptep_modify_prot_commit(
        vma: *mut vm_area_struct,
        addr: ffi::c_ulong,
        ptep: *mut pte_t,
        old_pte: pte_t,
        new_pte: pte_t,
    );
}
extern "C" {
    pub fn __contpte_try_fold(mm: *mut mm_struct, addr: ffi::c_ulong, ptep: *mut pte_t, pte: pte_t);
}
extern "C" {
    pub fn __contpte_try_unfold(
        mm: *mut mm_struct,
        addr: ffi::c_ulong,
        ptep: *mut pte_t,
        pte: pte_t,
    );
}
extern "C" {
    pub fn contpte_ptep_get(ptep: *mut pte_t, orig_pte: pte_t) -> pte_t;
}
extern "C" {
    pub fn contpte_ptep_get_lockless(orig_ptep: *mut pte_t) -> pte_t;
}
extern "C" {
    pub fn contpte_set_ptes(
        mm: *mut mm_struct,
        addr: ffi::c_ulong,
        ptep: *mut pte_t,
        pte: pte_t,
        nr: ffi::c_uint,
    );
}
extern "C" {
    pub fn contpte_clear_full_ptes(
        mm: *mut mm_struct,
        addr: ffi::c_ulong,
        ptep: *mut pte_t,
        nr: ffi::c_uint,
        full: ffi::c_int,
    );
}
extern "C" {
    pub fn contpte_get_and_clear_full_ptes(
        mm: *mut mm_struct,
        addr: ffi::c_ulong,
        ptep: *mut pte_t,
        nr: ffi::c_uint,
        full: ffi::c_int,
    ) -> pte_t;
}
extern "C" {
    pub fn contpte_ptep_test_and_clear_young(
        vma: *mut vm_area_struct,
        addr: ffi::c_ulong,
        ptep: *mut pte_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn contpte_ptep_clear_flush_young(
        vma: *mut vm_area_struct,
        addr: ffi::c_ulong,
        ptep: *mut pte_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn contpte_wrprotect_ptes(
        mm: *mut mm_struct,
        addr: ffi::c_ulong,
        ptep: *mut pte_t,
        nr: ffi::c_uint,
    );
}
extern "C" {
    pub fn contpte_ptep_set_access_flags(
        vma: *mut vm_area_struct,
        addr: ffi::c_ulong,
        ptep: *mut pte_t,
        entry: pte_t,
        dirty: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn contpte_clear_young_dirty_ptes(
        vma: *mut vm_area_struct,
        addr: ffi::c_ulong,
        ptep: *mut pte_t,
        nr: ffi::c_uint,
        flags: cydp_t,
    );
}
extern "C" {
    pub fn pte_free_defer(mm: *mut mm_struct, pgtable: pgtable_t);
}
extern "C" {
    pub fn pmdp_clear_flush_young(
        vma: *mut vm_area_struct,
        address: ffi::c_ulong,
        pmdp: *mut pmd_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn ptep_clear_flush(
        vma: *mut vm_area_struct,
        address: ffi::c_ulong,
        ptep: *mut pte_t,
    ) -> pte_t;
}
extern "C" {
    pub fn pmdp_huge_clear_flush(
        vma: *mut vm_area_struct,
        address: ffi::c_ulong,
        pmdp: *mut pmd_t,
    ) -> pmd_t;
}
extern "C" {
    pub fn pudp_huge_clear_flush(
        vma: *mut vm_area_struct,
        address: ffi::c_ulong,
        pudp: *mut pud_t,
    ) -> pud_t;
}
extern "C" {
    pub fn pmdp_collapse_flush(
        vma: *mut vm_area_struct,
        address: ffi::c_ulong,
        pmdp: *mut pmd_t,
    ) -> pmd_t;
}
extern "C" {
    pub fn pgtable_trans_huge_deposit(mm: *mut mm_struct, pmdp: *mut pmd_t, pgtable: pgtable_t);
}
extern "C" {
    pub fn pgtable_trans_huge_withdraw(mm: *mut mm_struct, pmdp: *mut pmd_t) -> pgtable_t;
}
extern "C" {
    pub fn pmdp_invalidate(
        vma: *mut vm_area_struct,
        address: ffi::c_ulong,
        pmdp: *mut pmd_t,
    ) -> pmd_t;
}
extern "C" {
    pub fn pmdp_invalidate_ad(
        vma: *mut vm_area_struct,
        address: ffi::c_ulong,
        pmdp: *mut pmd_t,
    ) -> pmd_t;
}
extern "C" {
    pub fn pgd_clear_bad(arg1: *mut pgd_t);
}
extern "C" {
    pub fn pud_clear_bad(arg1: *mut pud_t);
}
extern "C" {
    pub fn pmd_clear_bad(arg1: *mut pmd_t);
}
extern "C" {
    pub fn pud_set_huge(pud: *mut pud_t, addr: phys_addr_t, prot: pgprot_t) -> ffi::c_int;
}
extern "C" {
    pub fn pmd_set_huge(pmd: *mut pmd_t, addr: phys_addr_t, prot: pgprot_t) -> ffi::c_int;
}
extern "C" {
    pub fn pud_clear_huge(pud: *mut pud_t) -> ffi::c_int;
}
extern "C" {
    pub fn pmd_clear_huge(pmd: *mut pmd_t) -> ffi::c_int;
}
extern "C" {
    pub fn p4d_free_pud_page(p4d: *mut p4d_t, addr: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn pud_free_pmd_page(pud: *mut pud_t, addr: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn pmd_free_pte_page(pmd: *mut pmd_t, addr: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn phys_mem_access_prot_allowed(
        file: *mut file,
        pfn: ffi::c_ulong,
        size: ffi::c_ulong,
        vma_prot: *mut pgprot_t,
    ) -> ffi::c_int;
}
pub type pgtbl_mod_mask = ffi::c_uint;
extern "C" {
    pub fn early_ioremap(phys_addr: resource_size_t, size: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn early_memremap(phys_addr: resource_size_t, size: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn early_memremap_ro(phys_addr: resource_size_t, size: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn early_memremap_prot(
        phys_addr: resource_size_t,
        size: ffi::c_ulong,
        prot_val: ffi::c_ulong,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn early_iounmap(addr: *mut ffi::c_void, size: ffi::c_ulong);
}
extern "C" {
    pub fn early_memunmap(addr: *mut ffi::c_void, size: ffi::c_ulong);
}
extern "C" {
    pub fn early_ioremap_init();
}
extern "C" {
    pub fn early_ioremap_setup();
}
extern "C" {
    pub fn early_ioremap_reset();
}
extern "C" {
    pub fn copy_from_early_mem(
        dest: *mut ffi::c_void,
        src: phys_addr_t,
        size: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __iowrite32_copy_full(to: *mut ffi::c_void, from: *const ffi::c_void, count: usize);
}
extern "C" {
    pub fn __iowrite64_copy_full(to: *mut ffi::c_void, from: *const ffi::c_void, count: usize);
}
pub type ioremap_prot_hook_t = ::core::option::Option<
    unsafe extern "C" fn(phys_addr: phys_addr_t, size: usize, prot: *mut pgprot_t) -> ffi::c_int,
>;
extern "C" {
    pub fn arm64_ioremap_prot_hook_register(hook: ioremap_prot_hook_t) -> ffi::c_int;
}
extern "C" {
    pub fn pci_iomap(dev: *mut pci_dev, bar: ffi::c_int, max: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn pci_iomap_wc(dev: *mut pci_dev, bar: ffi::c_int, max: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn pci_iomap_range(
        dev: *mut pci_dev,
        bar: ffi::c_int,
        offset: ffi::c_ulong,
        maxlen: ffi::c_ulong,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn pci_iomap_wc_range(
        dev: *mut pci_dev,
        bar: ffi::c_int,
        offset: ffi::c_ulong,
        maxlen: ffi::c_ulong,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn pci_iounmap(dev: *mut pci_dev, arg1: *mut ffi::c_void);
}
pub const dev_dma_attr_DEV_DMA_NOT_SUPPORTED: dev_dma_attr = 0;
pub const dev_dma_attr_DEV_DMA_NON_COHERENT: dev_dma_attr = 1;
pub const dev_dma_attr_DEV_DMA_COHERENT: dev_dma_attr = 2;
pub type dev_dma_attr = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fwnode_handle {
    pub secondary: *mut fwnode_handle,
    pub ops: *const fwnode_operations,
    pub dev: *mut device,
    pub suppliers: list_head,
    pub consumers: list_head,
    pub flags: u8_,
}
impl Default for fwnode_handle {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fwnode_link {
    pub supplier: *mut fwnode_handle,
    pub s_hook: list_head,
    pub consumer: *mut fwnode_handle,
    pub c_hook: list_head,
    pub flags: u8_,
}
impl Default for fwnode_link {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fwnode_endpoint {
    pub port: ffi::c_uint,
    pub id: ffi::c_uint,
    pub local_fwnode: *const fwnode_handle,
}
impl Default for fwnode_endpoint {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fwnode_reference_args {
    pub fwnode: *mut fwnode_handle,
    pub nargs: ffi::c_uint,
    pub args: [u64_; 16usize],
}
impl Default for fwnode_reference_args {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct fwnode_operations {
    pub get: ::core::option::Option<
        unsafe extern "C" fn(fwnode: *mut fwnode_handle) -> *mut fwnode_handle,
    >,
    pub put: ::core::option::Option<unsafe extern "C" fn(fwnode: *mut fwnode_handle)>,
    pub device_is_available:
        ::core::option::Option<unsafe extern "C" fn(fwnode: *const fwnode_handle) -> bool_>,
    pub device_get_match_data: ::core::option::Option<
        unsafe extern "C" fn(
            fwnode: *const fwnode_handle,
            dev: *const device,
        ) -> *const ffi::c_void,
    >,
    pub device_dma_supported:
        ::core::option::Option<unsafe extern "C" fn(fwnode: *const fwnode_handle) -> bool_>,
    pub device_get_dma_attr:
        ::core::option::Option<unsafe extern "C" fn(fwnode: *const fwnode_handle) -> dev_dma_attr>,
    pub property_present: ::core::option::Option<
        unsafe extern "C" fn(fwnode: *const fwnode_handle, propname: *const ffi::c_char) -> bool_,
    >,
    pub property_read_bool: ::core::option::Option<
        unsafe extern "C" fn(fwnode: *const fwnode_handle, propname: *const ffi::c_char) -> bool_,
    >,
    pub property_read_int_array: ::core::option::Option<
        unsafe extern "C" fn(
            fwnode: *const fwnode_handle,
            propname: *const ffi::c_char,
            elem_size: ffi::c_uint,
            val: *mut ffi::c_void,
            nval: usize,
        ) -> ffi::c_int,
    >,
    pub property_read_string_array: ::core::option::Option<
        unsafe extern "C" fn(
            fwnode_handle: *const fwnode_handle,
            propname: *const ffi::c_char,
            val: *mut *const ffi::c_char,
            nval: usize,
        ) -> ffi::c_int,
    >,
    pub get_name: ::core::option::Option<
        unsafe extern "C" fn(fwnode: *const fwnode_handle) -> *const ffi::c_char,
    >,
    pub get_name_prefix: ::core::option::Option<
        unsafe extern "C" fn(fwnode: *const fwnode_handle) -> *const ffi::c_char,
    >,
    pub get_parent: ::core::option::Option<
        unsafe extern "C" fn(fwnode: *const fwnode_handle) -> *mut fwnode_handle,
    >,
    pub get_next_child_node: ::core::option::Option<
        unsafe extern "C" fn(
            fwnode: *const fwnode_handle,
            child: *mut fwnode_handle,
        ) -> *mut fwnode_handle,
    >,
    pub get_named_child_node: ::core::option::Option<
        unsafe extern "C" fn(
            fwnode: *const fwnode_handle,
            name: *const ffi::c_char,
        ) -> *mut fwnode_handle,
    >,
    pub get_reference_args: ::core::option::Option<
        unsafe extern "C" fn(
            fwnode: *const fwnode_handle,
            prop: *const ffi::c_char,
            nargs_prop: *const ffi::c_char,
            nargs: ffi::c_uint,
            index: ffi::c_uint,
            args: *mut fwnode_reference_args,
        ) -> ffi::c_int,
    >,
    pub graph_get_next_endpoint: ::core::option::Option<
        unsafe extern "C" fn(
            fwnode: *const fwnode_handle,
            prev: *mut fwnode_handle,
        ) -> *mut fwnode_handle,
    >,
    pub graph_get_remote_endpoint: ::core::option::Option<
        unsafe extern "C" fn(fwnode: *const fwnode_handle) -> *mut fwnode_handle,
    >,
    pub graph_get_port_parent: ::core::option::Option<
        unsafe extern "C" fn(fwnode: *mut fwnode_handle) -> *mut fwnode_handle,
    >,
    pub graph_parse_endpoint: ::core::option::Option<
        unsafe extern "C" fn(
            fwnode: *const fwnode_handle,
            endpoint: *mut fwnode_endpoint,
        ) -> ffi::c_int,
    >,
    pub iomap: ::core::option::Option<
        unsafe extern "C" fn(fwnode: *mut fwnode_handle, index: ffi::c_int) -> *mut ffi::c_void,
    >,
    pub irq_get: ::core::option::Option<
        unsafe extern "C" fn(fwnode: *const fwnode_handle, index: ffi::c_uint) -> ffi::c_int,
    >,
    pub add_links:
        ::core::option::Option<unsafe extern "C" fn(fwnode: *mut fwnode_handle) -> ffi::c_int>,
}
extern "C" {
    pub fn fwnode_link_add(
        con: *mut fwnode_handle,
        sup: *mut fwnode_handle,
        flags: u8_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn fwnode_links_purge(fwnode: *mut fwnode_handle);
}
extern "C" {
    pub fn fw_devlink_purge_absent_suppliers(fwnode: *mut fwnode_handle);
}
extern "C" {
    pub fn fw_devlink_is_strict() -> bool_;
}
pub const LOGIC_PIO_INDIRECT: _bindgen_ty_93 = 0;
pub const LOGIC_PIO_CPU_MMIO: _bindgen_ty_93 = 1;
pub type _bindgen_ty_93 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct logic_pio_hwaddr {
    pub list: list_head,
    pub fwnode: *const fwnode_handle,
    pub hw_start: resource_size_t,
    pub io_start: resource_size_t,
    pub size: resource_size_t,
    pub flags: ffi::c_ulong,
    pub hostdata: *mut ffi::c_void,
    pub ops: *const logic_pio_host_ops,
}
impl Default for logic_pio_hwaddr {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct logic_pio_host_ops {
    pub in_: ::core::option::Option<
        unsafe extern "C" fn(hostdata: *mut ffi::c_void, addr: ffi::c_ulong, dwidth: usize) -> u32_,
    >,
    pub out: ::core::option::Option<
        unsafe extern "C" fn(
            hostdata: *mut ffi::c_void,
            addr: ffi::c_ulong,
            val: u32_,
            dwidth: usize,
        ),
    >,
    pub ins: ::core::option::Option<
        unsafe extern "C" fn(
            hostdata: *mut ffi::c_void,
            addr: ffi::c_ulong,
            buffer: *mut ffi::c_void,
            dwidth: usize,
            count: ffi::c_uint,
        ) -> u32_,
    >,
    pub outs: ::core::option::Option<
        unsafe extern "C" fn(
            hostdata: *mut ffi::c_void,
            addr: ffi::c_ulong,
            buffer: *const ffi::c_void,
            dwidth: usize,
            count: ffi::c_uint,
        ),
    >,
}
extern "C" {
    pub fn logic_inb(addr: ffi::c_ulong) -> u8_;
}
extern "C" {
    pub fn logic_inw(addr: ffi::c_ulong) -> u16_;
}
extern "C" {
    pub fn logic_inl(addr: ffi::c_ulong) -> u32_;
}
extern "C" {
    pub fn logic_outb(value: u8_, addr: ffi::c_ulong);
}
extern "C" {
    pub fn logic_outw(value: u16_, addr: ffi::c_ulong);
}
extern "C" {
    pub fn logic_outl(value: u32_, addr: ffi::c_ulong);
}
extern "C" {
    pub fn logic_insb(addr: ffi::c_ulong, buffer: *mut ffi::c_void, count: ffi::c_uint);
}
extern "C" {
    pub fn logic_insl(addr: ffi::c_ulong, buffer: *mut ffi::c_void, count: ffi::c_uint);
}
extern "C" {
    pub fn logic_insw(addr: ffi::c_ulong, buffer: *mut ffi::c_void, count: ffi::c_uint);
}
extern "C" {
    pub fn logic_outsb(addr: ffi::c_ulong, buffer: *const ffi::c_void, count: ffi::c_uint);
}
extern "C" {
    pub fn logic_outsw(addr: ffi::c_ulong, buffer: *const ffi::c_void, count: ffi::c_uint);
}
extern "C" {
    pub fn logic_outsl(addr: ffi::c_ulong, buffer: *const ffi::c_void, count: ffi::c_uint);
}
extern "C" {
    pub fn find_io_range_by_fwnode(fwnode: *const fwnode_handle) -> *mut logic_pio_hwaddr;
}
extern "C" {
    pub fn logic_pio_trans_hwaddr(
        fwnode: *const fwnode_handle,
        hw_addr: resource_size_t,
        size: resource_size_t,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn logic_pio_register_range(newrange: *mut logic_pio_hwaddr) -> ffi::c_int;
}
extern "C" {
    pub fn logic_pio_unregister_range(range: *mut logic_pio_hwaddr);
}
extern "C" {
    pub fn logic_pio_to_hwaddr(pio: ffi::c_ulong) -> resource_size_t;
}
extern "C" {
    pub fn logic_pio_trans_cpuaddr(hw_addr: resource_size_t) -> ffi::c_ulong;
}
extern "C" {
    pub fn generic_ioremap_prot(
        phys_addr: phys_addr_t,
        size: usize,
        prot: pgprot_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn ioremap_prot(phys_addr: phys_addr_t, size: usize, prot: pgprot_t) -> *mut ffi::c_void;
}
extern "C" {
    pub fn iounmap(addr: *mut ffi::c_void);
}
extern "C" {
    pub fn generic_iounmap(addr: *mut ffi::c_void);
}
extern "C" {
    pub fn memset_io(addr: *mut ffi::c_void, val: ffi::c_int, count: usize);
}
extern "C" {
    pub fn memcpy_fromio(dst: *mut ffi::c_void, src: *const ffi::c_void, count: usize);
}
extern "C" {
    pub fn memcpy_toio(dst: *mut ffi::c_void, src: *const ffi::c_void, count: usize);
}
extern "C" {
    pub fn devmem_is_allowed(pfn: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn valid_phys_addr_range(addr: phys_addr_t, size: usize) -> ffi::c_int;
}
extern "C" {
    pub fn valid_mmap_phys_addr_range(pfn: ffi::c_ulong, size: usize) -> ffi::c_int;
}
extern "C" {
    pub fn arch_memremap_can_ram_remap(
        offset: resource_size_t,
        size: usize,
        flags: ffi::c_ulong,
    ) -> bool_;
}
extern "C" {
    pub fn __ioread32_copy(to: *mut ffi::c_void, from: *const ffi::c_void, count: usize);
}
extern "C" {
    pub fn ioremap_page_range(
        addr: ffi::c_ulong,
        end: ffi::c_ulong,
        phys_addr: phys_addr_t,
        prot: pgprot_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vmap_page_range(
        addr: ffi::c_ulong,
        end: ffi::c_ulong,
        phys_addr: phys_addr_t,
        prot: pgprot_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn devm_ioport_map(
        dev: *mut device,
        port: ffi::c_ulong,
        nr: ffi::c_uint,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn devm_ioport_unmap(dev: *mut device, addr: *mut ffi::c_void);
}
extern "C" {
    pub fn devm_ioremap(
        dev: *mut device,
        offset: resource_size_t,
        size: resource_size_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn devm_ioremap_uc(
        dev: *mut device,
        offset: resource_size_t,
        size: resource_size_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn devm_ioremap_wc(
        dev: *mut device,
        offset: resource_size_t,
        size: resource_size_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn devm_iounmap(dev: *mut device, addr: *mut ffi::c_void);
}
extern "C" {
    pub fn check_signature(
        io_addr: *const ffi::c_void,
        signature: *const ffi::c_uchar,
        length: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn devm_ioremap_release(dev: *mut device, res: *mut ffi::c_void);
}
extern "C" {
    pub fn devm_memremap(
        dev: *mut device,
        offset: resource_size_t,
        size: usize,
        flags: ffi::c_ulong,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn devm_memunmap(dev: *mut device, addr: *mut ffi::c_void);
}
extern "C" {
    pub fn early_memremap_pgprot_adjust(
        phys_addr: resource_size_t,
        size: ffi::c_ulong,
        prot: pgprot_t,
    ) -> pgprot_t;
}
extern "C" {
    pub fn devm_arch_phys_wc_add(
        dev: *mut device,
        base: ffi::c_ulong,
        size: ffi::c_ulong,
    ) -> ffi::c_int;
}
pub const MEMREMAP_WB: _bindgen_ty_94 = 1;
pub const MEMREMAP_WT: _bindgen_ty_94 = 2;
pub const MEMREMAP_WC: _bindgen_ty_94 = 4;
pub const MEMREMAP_ENC: _bindgen_ty_94 = 8;
pub const MEMREMAP_DEC: _bindgen_ty_94 = 16;
pub type _bindgen_ty_94 = ffi::c_uint;
extern "C" {
    pub fn memremap(offset: resource_size_t, size: usize, flags: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn memunmap(addr: *mut ffi::c_void);
}
extern "C" {
    pub fn devm_arch_io_reserve_memtype_wc(
        dev: *mut device,
        start: resource_size_t,
        size: resource_size_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub static mut __irq_regs: *mut pt_regs;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct msi_msg {
    _unused: [u8; 0],
}
pub const IRQ_TYPE_NONE: _bindgen_ty_95 = 0;
pub const IRQ_TYPE_EDGE_RISING: _bindgen_ty_95 = 1;
pub const IRQ_TYPE_EDGE_FALLING: _bindgen_ty_95 = 2;
pub const IRQ_TYPE_EDGE_BOTH: _bindgen_ty_95 = 3;
pub const IRQ_TYPE_LEVEL_HIGH: _bindgen_ty_95 = 4;
pub const IRQ_TYPE_LEVEL_LOW: _bindgen_ty_95 = 8;
pub const IRQ_TYPE_LEVEL_MASK: _bindgen_ty_95 = 12;
pub const IRQ_TYPE_SENSE_MASK: _bindgen_ty_95 = 15;
pub const IRQ_TYPE_DEFAULT: _bindgen_ty_95 = 15;
pub const IRQ_TYPE_PROBE: _bindgen_ty_95 = 16;
pub const IRQ_LEVEL: _bindgen_ty_95 = 256;
pub const IRQ_PER_CPU: _bindgen_ty_95 = 512;
pub const IRQ_NOPROBE: _bindgen_ty_95 = 1024;
pub const IRQ_NOREQUEST: _bindgen_ty_95 = 2048;
pub const IRQ_NOAUTOEN: _bindgen_ty_95 = 4096;
pub const IRQ_NO_BALANCING: _bindgen_ty_95 = 8192;
pub const IRQ_NESTED_THREAD: _bindgen_ty_95 = 32768;
pub const IRQ_NOTHREAD: _bindgen_ty_95 = 65536;
pub const IRQ_PER_CPU_DEVID: _bindgen_ty_95 = 131072;
pub const IRQ_IS_POLLED: _bindgen_ty_95 = 262144;
pub const IRQ_DISABLE_UNLAZY: _bindgen_ty_95 = 524288;
pub const IRQ_HIDDEN: _bindgen_ty_95 = 1048576;
pub const IRQ_NO_DEBUG: _bindgen_ty_95 = 2097152;
pub type _bindgen_ty_95 = ffi::c_uint;
pub const IRQ_SET_MASK_OK: _bindgen_ty_96 = 0;
pub const IRQ_SET_MASK_OK_NOCOPY: _bindgen_ty_96 = 1;
pub const IRQ_SET_MASK_OK_DONE: _bindgen_ty_96 = 2;
pub type _bindgen_ty_96 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct msi_desc {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct irq_domain {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct irq_common_data {
    pub state_use_accessors: ffi::c_uint,
    pub node: ffi::c_uint,
    pub handler_data: *mut ffi::c_void,
    pub msi_desc: *mut msi_desc,
    pub affinity: cpumask_var_t,
    pub effective_affinity: cpumask_var_t,
    pub ipi_offset: ffi::c_uint,
}
impl Default for irq_common_data {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct irq_data {
    pub mask: u32_,
    pub irq: ffi::c_uint,
    pub hwirq: irq_hw_number_t,
    pub common: *mut irq_common_data,
    pub chip: *mut irq_chip,
    pub domain: *mut irq_domain,
    pub parent_data: *mut irq_data,
    pub chip_data: *mut ffi::c_void,
}
impl Default for irq_data {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const IRQD_TRIGGER_MASK: _bindgen_ty_97 = 15;
pub const IRQD_SETAFFINITY_PENDING: _bindgen_ty_97 = 256;
pub const IRQD_ACTIVATED: _bindgen_ty_97 = 512;
pub const IRQD_NO_BALANCING: _bindgen_ty_97 = 1024;
pub const IRQD_PER_CPU: _bindgen_ty_97 = 2048;
pub const IRQD_AFFINITY_SET: _bindgen_ty_97 = 4096;
pub const IRQD_LEVEL: _bindgen_ty_97 = 8192;
pub const IRQD_WAKEUP_STATE: _bindgen_ty_97 = 16384;
pub const IRQD_IRQ_DISABLED: _bindgen_ty_97 = 65536;
pub const IRQD_IRQ_MASKED: _bindgen_ty_97 = 131072;
pub const IRQD_IRQ_INPROGRESS: _bindgen_ty_97 = 262144;
pub const IRQD_WAKEUP_ARMED: _bindgen_ty_97 = 524288;
pub const IRQD_FORWARDED_TO_VCPU: _bindgen_ty_97 = 1048576;
pub const IRQD_AFFINITY_MANAGED: _bindgen_ty_97 = 2097152;
pub const IRQD_IRQ_STARTED: _bindgen_ty_97 = 4194304;
pub const IRQD_MANAGED_SHUTDOWN: _bindgen_ty_97 = 8388608;
pub const IRQD_SINGLE_TARGET: _bindgen_ty_97 = 16777216;
pub const IRQD_DEFAULT_TRIGGER_SET: _bindgen_ty_97 = 33554432;
pub const IRQD_CAN_RESERVE: _bindgen_ty_97 = 67108864;
pub const IRQD_HANDLE_ENFORCE_IRQCTX: _bindgen_ty_97 = 134217728;
pub const IRQD_AFFINITY_ON_ACTIVATE: _bindgen_ty_97 = 268435456;
pub const IRQD_IRQ_ENABLED_ON_SUSPEND: _bindgen_ty_97 = 536870912;
pub const IRQD_RESEND_WHEN_IN_PROGRESS: _bindgen_ty_97 = 1073741824;
pub type _bindgen_ty_97 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct irq_chip {
    pub name: *const ffi::c_char,
    pub irq_startup:
        ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data) -> ffi::c_uint>,
    pub irq_shutdown: ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data)>,
    pub irq_enable: ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data)>,
    pub irq_disable: ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data)>,
    pub irq_ack: ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data)>,
    pub irq_mask: ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data)>,
    pub irq_mask_ack: ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data)>,
    pub irq_unmask: ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data)>,
    pub irq_eoi: ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data)>,
    pub irq_set_affinity: ::core::option::Option<
        unsafe extern "C" fn(data: *mut irq_data, dest: *const cpumask, force: bool_) -> ffi::c_int,
    >,
    pub irq_retrigger:
        ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data) -> ffi::c_int>,
    pub irq_set_type: ::core::option::Option<
        unsafe extern "C" fn(data: *mut irq_data, flow_type: ffi::c_uint) -> ffi::c_int,
    >,
    pub irq_set_wake: ::core::option::Option<
        unsafe extern "C" fn(data: *mut irq_data, on: ffi::c_uint) -> ffi::c_int,
    >,
    pub irq_bus_lock: ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data)>,
    pub irq_bus_sync_unlock: ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data)>,
    pub irq_suspend: ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data)>,
    pub irq_resume: ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data)>,
    pub irq_pm_shutdown: ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data)>,
    pub irq_calc_mask: ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data)>,
    pub irq_print_chip:
        ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data, p: *mut seq_file)>,
    pub irq_request_resources:
        ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data) -> ffi::c_int>,
    pub irq_release_resources: ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data)>,
    pub irq_compose_msi_msg:
        ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data, msg: *mut msi_msg)>,
    pub irq_write_msi_msg:
        ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data, msg: *mut msi_msg)>,
    pub irq_get_irqchip_state: ::core::option::Option<
        unsafe extern "C" fn(
            data: *mut irq_data,
            which: irqchip_irq_state,
            state: *mut bool_,
        ) -> ffi::c_int,
    >,
    pub irq_set_irqchip_state: ::core::option::Option<
        unsafe extern "C" fn(
            data: *mut irq_data,
            which: irqchip_irq_state,
            state: bool_,
        ) -> ffi::c_int,
    >,
    pub irq_set_vcpu_affinity: ::core::option::Option<
        unsafe extern "C" fn(data: *mut irq_data, vcpu_info: *mut ffi::c_void) -> ffi::c_int,
    >,
    pub ipi_send_single:
        ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data, cpu: ffi::c_uint)>,
    pub ipi_send_mask:
        ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data, dest: *const cpumask)>,
    pub irq_nmi_setup:
        ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data) -> ffi::c_int>,
    pub irq_nmi_teardown: ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data)>,
    pub irq_force_complete_move: ::core::option::Option<unsafe extern "C" fn(data: *mut irq_data)>,
    pub flags: ffi::c_ulong,
}
impl Default for irq_chip {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const IRQCHIP_SET_TYPE_MASKED: _bindgen_ty_98 = 1;
pub const IRQCHIP_EOI_IF_HANDLED: _bindgen_ty_98 = 2;
pub const IRQCHIP_MASK_ON_SUSPEND: _bindgen_ty_98 = 4;
pub const IRQCHIP_ONOFFLINE_ENABLED: _bindgen_ty_98 = 8;
pub const IRQCHIP_SKIP_SET_WAKE: _bindgen_ty_98 = 16;
pub const IRQCHIP_ONESHOT_SAFE: _bindgen_ty_98 = 32;
pub const IRQCHIP_EOI_THREADED: _bindgen_ty_98 = 64;
pub const IRQCHIP_SUPPORTS_LEVEL_MSI: _bindgen_ty_98 = 128;
pub const IRQCHIP_SUPPORTS_NMI: _bindgen_ty_98 = 256;
pub const IRQCHIP_ENABLE_WAKEUP_ON_SUSPEND: _bindgen_ty_98 = 512;
pub const IRQCHIP_AFFINITY_PRE_STARTUP: _bindgen_ty_98 = 1024;
pub const IRQCHIP_IMMUTABLE: _bindgen_ty_98 = 2048;
pub const IRQCHIP_MOVE_DEFERRED: _bindgen_ty_98 = 4096;
pub type _bindgen_ty_98 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct proc_dir_entry {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct irqstat {
    pub cnt: ffi::c_uint,
    pub ref_: ffi::c_uint,
}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct irq_desc {
    pub irq_common_data: irq_common_data,
    pub irq_data: irq_data,
    pub kstat_irqs: *mut irqstat,
    pub handle_irq: irq_flow_handler_t,
    pub action: *mut irqaction,
    pub status_use_accessors: ffi::c_uint,
    pub core_internal_state__do_not_mess_with_it: ffi::c_uint,
    pub depth: ffi::c_uint,
    pub wake_depth: ffi::c_uint,
    pub tot_count: ffi::c_uint,
    pub irq_count: ffi::c_uint,
    pub last_unhandled: ffi::c_ulong,
    pub irqs_unhandled: ffi::c_uint,
    pub threads_handled: atomic_t,
    pub threads_handled_last: ffi::c_int,
    pub lock: raw_spinlock_t,
    pub percpu_enabled: *mut cpumask,
    pub percpu_affinity: *const cpumask,
    pub affinity_hint: *const cpumask,
    pub affinity_notify: *mut irq_affinity_notify,
    pub threads_oneshot: ffi::c_ulong,
    pub threads_active: atomic_t,
    pub wait_for_threads: wait_queue_head_t,
    pub nr_actions: ffi::c_uint,
    pub no_suspend_depth: ffi::c_uint,
    pub cond_suspend_depth: ffi::c_uint,
    pub force_resume_depth: ffi::c_uint,
    pub dir: *mut proc_dir_entry,
    pub rcu: callback_head,
    pub kobj: kobject,
    pub request_mutex: mutex,
    pub parent_irq: ffi::c_int,
    pub owner: *mut module,
    pub name: *const ffi::c_char,
    pub resend_node: hlist_node,
}
impl Default for irq_desc {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn irq_lock_sparse();
}
extern "C" {
    pub fn irq_unlock_sparse();
}
extern "C" {
    pub fn handle_irq_desc(desc: *mut irq_desc) -> ffi::c_int;
}
extern "C" {
    pub fn generic_handle_irq(irq: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn generic_handle_irq_safe(irq: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn generic_handle_domain_irq(domain: *mut irq_domain, hwirq: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn generic_handle_domain_irq_safe(
        domain: *mut irq_domain,
        hwirq: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn generic_handle_domain_nmi(domain: *mut irq_domain, hwirq: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn irq_check_status_bit(irq: ffi::c_uint, bitmask: ffi::c_uint) -> bool_;
}
extern "C" {
    pub fn __irq_set_lockdep_class(
        irq: ffi::c_uint,
        lock_class: *mut lock_class_key,
        request_class: *mut lock_class_key,
    );
}
extern "C" {
    pub fn setup_percpu_irq(irq: ffi::c_uint, new: *mut irqaction) -> ffi::c_int;
}
extern "C" {
    pub fn remove_percpu_irq(irq: ffi::c_uint, act: *mut irqaction);
}
extern "C" {
    pub fn irq_set_affinity_locked(
        data: *mut irq_data,
        cpumask: *const cpumask,
        force: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn irq_set_vcpu_affinity(irq: ffi::c_uint, vcpu_info: *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn irq_migrate_all_off_this_cpu();
}
extern "C" {
    pub fn irq_affinity_online_cpu(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub static mut no_irq_affinity: ffi::c_int;
}
extern "C" {
    pub fn irq_set_parent(irq: ffi::c_int, parent_irq: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn handle_level_irq(desc: *mut irq_desc);
}
extern "C" {
    pub fn handle_fasteoi_irq(desc: *mut irq_desc);
}
extern "C" {
    pub fn handle_edge_irq(desc: *mut irq_desc);
}
extern "C" {
    pub fn handle_edge_eoi_irq(desc: *mut irq_desc);
}
extern "C" {
    pub fn handle_simple_irq(desc: *mut irq_desc);
}
extern "C" {
    pub fn handle_untracked_irq(desc: *mut irq_desc);
}
extern "C" {
    pub fn handle_percpu_irq(desc: *mut irq_desc);
}
extern "C" {
    pub fn handle_percpu_devid_irq(desc: *mut irq_desc);
}
extern "C" {
    pub fn handle_bad_irq(desc: *mut irq_desc);
}
extern "C" {
    pub fn handle_nested_irq(irq: ffi::c_uint);
}
extern "C" {
    pub fn handle_fasteoi_nmi(desc: *mut irq_desc);
}
extern "C" {
    pub fn handle_percpu_devid_fasteoi_nmi(desc: *mut irq_desc);
}
extern "C" {
    pub fn irq_chip_compose_msi_msg(data: *mut irq_data, msg: *mut msi_msg) -> ffi::c_int;
}
extern "C" {
    pub fn irq_chip_pm_get(data: *mut irq_data) -> ffi::c_int;
}
extern "C" {
    pub fn irq_chip_pm_put(data: *mut irq_data) -> ffi::c_int;
}
extern "C" {
    pub fn handle_fasteoi_ack_irq(desc: *mut irq_desc);
}
extern "C" {
    pub fn handle_fasteoi_mask_irq(desc: *mut irq_desc);
}
extern "C" {
    pub fn irq_chip_set_parent_state(
        data: *mut irq_data,
        which: irqchip_irq_state,
        val: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn irq_chip_get_parent_state(
        data: *mut irq_data,
        which: irqchip_irq_state,
        state: *mut bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn irq_chip_enable_parent(data: *mut irq_data);
}
extern "C" {
    pub fn irq_chip_disable_parent(data: *mut irq_data);
}
extern "C" {
    pub fn irq_chip_ack_parent(data: *mut irq_data);
}
extern "C" {
    pub fn irq_chip_retrigger_hierarchy(data: *mut irq_data) -> ffi::c_int;
}
extern "C" {
    pub fn irq_chip_mask_parent(data: *mut irq_data);
}
extern "C" {
    pub fn irq_chip_mask_ack_parent(data: *mut irq_data);
}
extern "C" {
    pub fn irq_chip_unmask_parent(data: *mut irq_data);
}
extern "C" {
    pub fn irq_chip_eoi_parent(data: *mut irq_data);
}
extern "C" {
    pub fn irq_chip_set_affinity_parent(
        data: *mut irq_data,
        dest: *const cpumask,
        force: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn irq_chip_set_wake_parent(data: *mut irq_data, on: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn irq_chip_set_vcpu_affinity_parent(
        data: *mut irq_data,
        vcpu_info: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn irq_chip_set_type_parent(data: *mut irq_data, type_: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn irq_chip_request_resources_parent(data: *mut irq_data) -> ffi::c_int;
}
extern "C" {
    pub fn irq_chip_release_resources_parent(data: *mut irq_data);
}
extern "C" {
    pub fn machine_kexec_mask_interrupts();
}
extern "C" {
    pub fn note_interrupt(desc: *mut irq_desc, action_ret: irqreturn_t);
}
extern "C" {
    pub fn noirqdebug_setup(str_: *mut ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub fn can_request_irq(irq: ffi::c_uint, irqflags: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub static mut no_irq_chip: irq_chip;
}
extern "C" {
    pub static mut dummy_irq_chip: irq_chip;
}
extern "C" {
    pub fn irq_set_chip_and_handler_name(
        irq: ffi::c_uint,
        chip: *const irq_chip,
        handle: irq_flow_handler_t,
        name: *const ffi::c_char,
    );
}
extern "C" {
    pub fn irq_set_percpu_devid(irq: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn irq_set_percpu_devid_partition(irq: ffi::c_uint, affinity: *const cpumask)
        -> ffi::c_int;
}
extern "C" {
    pub fn irq_get_percpu_devid_partition(irq: ffi::c_uint, affinity: *mut cpumask) -> ffi::c_int;
}
extern "C" {
    pub fn __irq_set_handler(
        irq: ffi::c_uint,
        handle: irq_flow_handler_t,
        is_chained: ffi::c_int,
        name: *const ffi::c_char,
    );
}
extern "C" {
    pub fn irq_set_chained_handler_and_data(
        irq: ffi::c_uint,
        handle: irq_flow_handler_t,
        data: *mut ffi::c_void,
    );
}
extern "C" {
    pub fn irq_modify_status(irq: ffi::c_uint, clr: ffi::c_ulong, set: ffi::c_ulong);
}
extern "C" {
    pub fn irq_set_chip(irq: ffi::c_uint, chip: *const irq_chip) -> ffi::c_int;
}
extern "C" {
    pub fn irq_set_handler_data(irq: ffi::c_uint, data: *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn irq_set_chip_data(irq: ffi::c_uint, data: *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn irq_set_irq_type(irq: ffi::c_uint, type_: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn irq_set_msi_desc(irq: ffi::c_uint, entry: *mut msi_desc) -> ffi::c_int;
}
extern "C" {
    pub fn irq_set_msi_desc_off(
        irq_base: ffi::c_uint,
        irq_offset: ffi::c_uint,
        entry: *mut msi_desc,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn irq_get_irq_data(irq: ffi::c_uint) -> *mut irq_data;
}
extern "C" {
    pub fn arch_dynirq_lower_bound(from: ffi::c_uint) -> ffi::c_uint;
}
extern "C" {
    pub fn __irq_alloc_descs(
        irq: ffi::c_int,
        from: ffi::c_uint,
        cnt: ffi::c_uint,
        node: ffi::c_int,
        owner: *mut module,
        affinity: *const irq_affinity_desc,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __devm_irq_alloc_descs(
        dev: *mut device,
        irq: ffi::c_int,
        from: ffi::c_uint,
        cnt: ffi::c_uint,
        node: ffi::c_int,
        owner: *mut module,
        affinity: *const irq_affinity_desc,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn irq_free_descs(irq: ffi::c_uint, cnt: ffi::c_uint);
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct irq_chip_regs {
    pub enable: ffi::c_ulong,
    pub disable: ffi::c_ulong,
    pub mask: ffi::c_ulong,
    pub ack: ffi::c_ulong,
    pub eoi: ffi::c_ulong,
    pub type_: ffi::c_ulong,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct irq_chip_type {
    pub chip: irq_chip,
    pub regs: irq_chip_regs,
    pub handler: irq_flow_handler_t,
    pub type_: u32_,
    pub mask_cache_priv: u32_,
    pub mask_cache: *mut u32_,
}
impl Default for irq_chip_type {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct irq_chip_generic {
    pub lock: raw_spinlock_t,
    pub reg_base: *mut ffi::c_void,
    pub reg_readl: ::core::option::Option<unsafe extern "C" fn(addr: *mut ffi::c_void) -> u32_>,
    pub reg_writel: ::core::option::Option<unsafe extern "C" fn(val: u32_, addr: *mut ffi::c_void)>,
    pub suspend: ::core::option::Option<unsafe extern "C" fn(gc: *mut irq_chip_generic)>,
    pub resume: ::core::option::Option<unsafe extern "C" fn(gc: *mut irq_chip_generic)>,
    pub irq_base: ffi::c_uint,
    pub irq_cnt: ffi::c_uint,
    pub mask_cache: u32_,
    pub wake_enabled: u32_,
    pub wake_active: u32_,
    pub num_ct: ffi::c_uint,
    pub private: *mut ffi::c_void,
    pub installed: ffi::c_ulong,
    pub unused: ffi::c_ulong,
    pub domain: *mut irq_domain,
    pub list: list_head,
    pub chip_types: __IncompleteArrayField<irq_chip_type>,
}
impl Default for irq_chip_generic {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const irq_gc_flags_IRQ_GC_INIT_MASK_CACHE: irq_gc_flags = 1;
pub const irq_gc_flags_IRQ_GC_INIT_NESTED_LOCK: irq_gc_flags = 2;
pub const irq_gc_flags_IRQ_GC_MASK_CACHE_PER_TYPE: irq_gc_flags = 4;
pub const irq_gc_flags_IRQ_GC_NO_MASK: irq_gc_flags = 8;
pub const irq_gc_flags_IRQ_GC_BE_IO: irq_gc_flags = 16;
pub type irq_gc_flags = ffi::c_uint;
#[repr(C)]
pub struct irq_domain_chip_generic {
    pub irqs_per_chip: ffi::c_uint,
    pub num_chips: ffi::c_uint,
    pub irq_flags_to_clear: ffi::c_uint,
    pub irq_flags_to_set: ffi::c_uint,
    pub gc_flags: irq_gc_flags,
    pub exit: ::core::option::Option<unsafe extern "C" fn(gc: *mut irq_chip_generic)>,
    pub gc: __IncompleteArrayField<*mut irq_chip_generic>,
}
impl Default for irq_domain_chip_generic {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct irq_domain_chip_generic_info {
    pub name: *const ffi::c_char,
    pub handler: irq_flow_handler_t,
    pub irqs_per_chip: ffi::c_uint,
    pub num_ct: ffi::c_uint,
    pub irq_flags_to_clear: ffi::c_uint,
    pub irq_flags_to_set: ffi::c_uint,
    pub gc_flags: irq_gc_flags,
    pub init: ::core::option::Option<unsafe extern "C" fn(gc: *mut irq_chip_generic) -> ffi::c_int>,
    pub exit: ::core::option::Option<unsafe extern "C" fn(gc: *mut irq_chip_generic)>,
}
impl Default for irq_domain_chip_generic_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn irq_gc_noop(d: *mut irq_data);
}
extern "C" {
    pub fn irq_gc_mask_disable_reg(d: *mut irq_data);
}
extern "C" {
    pub fn irq_gc_mask_set_bit(d: *mut irq_data);
}
extern "C" {
    pub fn irq_gc_mask_clr_bit(d: *mut irq_data);
}
extern "C" {
    pub fn irq_gc_unmask_enable_reg(d: *mut irq_data);
}
extern "C" {
    pub fn irq_gc_ack_set_bit(d: *mut irq_data);
}
extern "C" {
    pub fn irq_gc_ack_clr_bit(d: *mut irq_data);
}
extern "C" {
    pub fn irq_gc_mask_disable_and_ack_set(d: *mut irq_data);
}
extern "C" {
    pub fn irq_gc_eoi(d: *mut irq_data);
}
extern "C" {
    pub fn irq_gc_set_wake(d: *mut irq_data, on: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn irq_map_generic_chip(
        d: *mut irq_domain,
        virq: ffi::c_uint,
        hw_irq: irq_hw_number_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn irq_unmap_generic_chip(d: *mut irq_domain, virq: ffi::c_uint);
}
extern "C" {
    pub fn irq_alloc_generic_chip(
        name: *const ffi::c_char,
        nr_ct: ffi::c_int,
        irq_base: ffi::c_uint,
        reg_base: *mut ffi::c_void,
        handler: irq_flow_handler_t,
    ) -> *mut irq_chip_generic;
}
extern "C" {
    pub fn irq_setup_generic_chip(
        gc: *mut irq_chip_generic,
        msk: u32_,
        flags: irq_gc_flags,
        clr: ffi::c_uint,
        set: ffi::c_uint,
    );
}
extern "C" {
    pub fn irq_setup_alt_chip(d: *mut irq_data, type_: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn irq_remove_generic_chip(
        gc: *mut irq_chip_generic,
        msk: u32_,
        clr: ffi::c_uint,
        set: ffi::c_uint,
    );
}
extern "C" {
    pub fn devm_irq_alloc_generic_chip(
        dev: *mut device,
        name: *const ffi::c_char,
        num_ct: ffi::c_int,
        irq_base: ffi::c_uint,
        reg_base: *mut ffi::c_void,
        handler: irq_flow_handler_t,
    ) -> *mut irq_chip_generic;
}
extern "C" {
    pub fn devm_irq_setup_generic_chip(
        dev: *mut device,
        gc: *mut irq_chip_generic,
        msk: u32_,
        flags: irq_gc_flags,
        clr: ffi::c_uint,
        set: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn irq_get_domain_generic_chip(
        d: *mut irq_domain,
        hw_irq: ffi::c_uint,
    ) -> *mut irq_chip_generic;
}
extern "C" {
    pub fn irq_domain_alloc_generic_chips(
        d: *mut irq_domain,
        info: *const irq_domain_chip_generic_info,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn irq_domain_remove_generic_chips(d: *mut irq_domain);
}
extern "C" {
    pub fn __irq_alloc_domain_generic_chips(
        d: *mut irq_domain,
        irqs_per_chip: ffi::c_int,
        num_ct: ffi::c_int,
        name: *const ffi::c_char,
        handler: irq_flow_handler_t,
        clr: ffi::c_uint,
        set: ffi::c_uint,
        flags: irq_gc_flags,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct irq_matrix {
    _unused: [u8; 0],
}
extern "C" {
    pub fn irq_alloc_matrix(
        matrix_bits: ffi::c_uint,
        alloc_start: ffi::c_uint,
        alloc_end: ffi::c_uint,
    ) -> *mut irq_matrix;
}
extern "C" {
    pub fn irq_matrix_online(m: *mut irq_matrix);
}
extern "C" {
    pub fn irq_matrix_offline(m: *mut irq_matrix);
}
extern "C" {
    pub fn irq_matrix_assign_system(m: *mut irq_matrix, bit: ffi::c_uint, replace: bool_);
}
extern "C" {
    pub fn irq_matrix_reserve_managed(m: *mut irq_matrix, msk: *const cpumask) -> ffi::c_int;
}
extern "C" {
    pub fn irq_matrix_remove_managed(m: *mut irq_matrix, msk: *const cpumask);
}
extern "C" {
    pub fn irq_matrix_alloc_managed(
        m: *mut irq_matrix,
        msk: *const cpumask,
        mapped_cpu: *mut ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn irq_matrix_reserve(m: *mut irq_matrix);
}
extern "C" {
    pub fn irq_matrix_remove_reserved(m: *mut irq_matrix);
}
extern "C" {
    pub fn irq_matrix_alloc(
        m: *mut irq_matrix,
        msk: *const cpumask,
        reserved: bool_,
        mapped_cpu: *mut ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn irq_matrix_free(m: *mut irq_matrix, cpu: ffi::c_uint, bit: ffi::c_uint, managed: bool_);
}
extern "C" {
    pub fn irq_matrix_assign(m: *mut irq_matrix, bit: ffi::c_uint);
}
extern "C" {
    pub fn irq_matrix_available(m: *mut irq_matrix, cpudown: bool_) -> ffi::c_uint;
}
extern "C" {
    pub fn irq_matrix_allocated(m: *mut irq_matrix) -> ffi::c_uint;
}
extern "C" {
    pub fn irq_matrix_reserved(m: *mut irq_matrix) -> ffi::c_uint;
}
extern "C" {
    pub fn irq_matrix_debug_show(sf: *mut seq_file, m: *mut irq_matrix, ind: ffi::c_int);
}
extern "C" {
    pub fn ipi_get_hwirq(irq: ffi::c_uint, cpu: ffi::c_uint) -> irq_hw_number_t;
}
extern "C" {
    pub fn __ipi_send_single(desc: *mut irq_desc, cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn __ipi_send_mask(desc: *mut irq_desc, dest: *const cpumask) -> ffi::c_int;
}
extern "C" {
    pub fn ipi_send_single(virq: ffi::c_uint, cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn ipi_send_mask(virq: ffi::c_uint, dest: *const cpumask) -> ffi::c_int;
}
extern "C" {
    pub fn ipi_mux_process();
}
extern "C" {
    pub fn ipi_mux_create(
        nr_ipi: ffi::c_uint,
        mux_send: ::core::option::Option<unsafe extern "C" fn(cpu: ffi::c_uint)>,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct nmi_ctx {
    pub hcr: u64_,
    pub cnt: ffi::c_uint,
}
extern "C" {
    pub static mut nmi_contexts: nmi_ctx;
}
extern "C" {
    pub fn synchronize_irq(irq: ffi::c_uint);
}
extern "C" {
    pub fn synchronize_hardirq(irq: ffi::c_uint) -> bool_;
}
extern "C" {
    pub fn __rcu_irq_enter_check_tick();
}
extern "C" {
    pub fn irq_enter();
}
extern "C" {
    pub fn irq_enter_rcu();
}
extern "C" {
    pub fn irq_exit();
}
extern "C" {
    pub fn irq_exit_rcu();
}
pub const IRQC_IS_HARDIRQ: _bindgen_ty_99 = 0;
pub const IRQC_IS_NESTED: _bindgen_ty_99 = 1;
pub type _bindgen_ty_99 = ffi::c_uint;
pub type irq_handler_t = ::core::option::Option<
    unsafe extern "C" fn(arg1: ffi::c_int, arg2: *mut ffi::c_void) -> irqreturn_t,
>;
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct irqaction {
    pub handler: irq_handler_t,
    pub dev_id: *mut ffi::c_void,
    pub percpu_dev_id: *mut ffi::c_void,
    pub next: *mut irqaction,
    pub thread_fn: irq_handler_t,
    pub thread: *mut task_struct,
    pub secondary: *mut irqaction,
    pub irq: ffi::c_uint,
    pub flags: ffi::c_uint,
    pub thread_flags: ffi::c_ulong,
    pub thread_mask: ffi::c_ulong,
    pub name: *const ffi::c_char,
    pub dir: *mut proc_dir_entry,
}
impl Default for irqaction {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn no_action(cpl: ffi::c_int, dev_id: *mut ffi::c_void) -> irqreturn_t;
}
extern "C" {
    #[must_use]
    pub fn request_threaded_irq(
        irq: ffi::c_uint,
        handler: irq_handler_t,
        thread_fn: irq_handler_t,
        flags: ffi::c_ulong,
        name: *const ffi::c_char,
        dev: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn request_any_context_irq(
        irq: ffi::c_uint,
        handler: irq_handler_t,
        flags: ffi::c_ulong,
        name: *const ffi::c_char,
        dev_id: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn __request_percpu_irq(
        irq: ffi::c_uint,
        handler: irq_handler_t,
        flags: ffi::c_ulong,
        devname: *const ffi::c_char,
        percpu_dev_id: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn request_nmi(
        irq: ffi::c_uint,
        handler: irq_handler_t,
        flags: ffi::c_ulong,
        name: *const ffi::c_char,
        dev: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn request_percpu_nmi(
        irq: ffi::c_uint,
        handler: irq_handler_t,
        devname: *const ffi::c_char,
        dev: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn free_irq(arg1: ffi::c_uint, arg2: *mut ffi::c_void) -> *const ffi::c_void;
}
extern "C" {
    pub fn free_percpu_irq(arg1: ffi::c_uint, arg2: *mut ffi::c_void);
}
extern "C" {
    pub fn free_nmi(irq: ffi::c_uint, dev_id: *mut ffi::c_void) -> *const ffi::c_void;
}
extern "C" {
    pub fn free_percpu_nmi(irq: ffi::c_uint, percpu_dev_id: *mut ffi::c_void);
}
extern "C" {
    #[must_use]
    pub fn devm_request_threaded_irq(
        dev: *mut device,
        irq: ffi::c_uint,
        handler: irq_handler_t,
        thread_fn: irq_handler_t,
        irqflags: ffi::c_ulong,
        devname: *const ffi::c_char,
        dev_id: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn devm_request_any_context_irq(
        dev: *mut device,
        irq: ffi::c_uint,
        handler: irq_handler_t,
        irqflags: ffi::c_ulong,
        devname: *const ffi::c_char,
        dev_id: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn devm_free_irq(dev: *mut device, irq: ffi::c_uint, dev_id: *mut ffi::c_void);
}
extern "C" {
    pub fn irq_has_action(irq: ffi::c_uint) -> bool_;
}
extern "C" {
    pub fn disable_irq_nosync(irq: ffi::c_uint);
}
extern "C" {
    pub fn disable_hardirq(irq: ffi::c_uint) -> bool_;
}
extern "C" {
    pub fn disable_irq(irq: ffi::c_uint);
}
extern "C" {
    pub fn disable_percpu_irq(irq: ffi::c_uint);
}
extern "C" {
    pub fn enable_irq(irq: ffi::c_uint);
}
extern "C" {
    pub fn enable_percpu_irq(irq: ffi::c_uint, type_: ffi::c_uint);
}
extern "C" {
    pub fn irq_percpu_is_enabled(irq: ffi::c_uint) -> bool_;
}
extern "C" {
    pub fn irq_wake_thread(irq: ffi::c_uint, dev_id: *mut ffi::c_void);
}
pub const class_disable_irq_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_disable_irq_t {
    pub lock: *mut ffi::c_int,
}
impl Default for class_disable_irq_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn disable_nmi_nosync(irq: ffi::c_uint);
}
extern "C" {
    pub fn disable_percpu_nmi(irq: ffi::c_uint);
}
extern "C" {
    pub fn enable_nmi(irq: ffi::c_uint);
}
extern "C" {
    pub fn enable_percpu_nmi(irq: ffi::c_uint, type_: ffi::c_uint);
}
extern "C" {
    pub fn prepare_percpu_nmi(irq: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn teardown_percpu_nmi(irq: ffi::c_uint);
}
extern "C" {
    pub fn irq_inject_interrupt(irq: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn suspend_device_irqs();
}
extern "C" {
    pub fn resume_device_irqs();
}
extern "C" {
    pub fn rearm_wake_irq(irq: ffi::c_uint);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct irq_affinity_notify {
    pub irq: ffi::c_uint,
    pub kref: kref,
    pub work: work_struct,
    pub notify: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut irq_affinity_notify, mask: *const cpumask_t),
    >,
    pub release: ::core::option::Option<unsafe extern "C" fn(ref_: *mut kref)>,
}
impl Default for irq_affinity_notify {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct irq_affinity {
    pub pre_vectors: ffi::c_uint,
    pub post_vectors: ffi::c_uint,
    pub nr_sets: ffi::c_uint,
    pub set_size: [ffi::c_uint; 4usize],
    pub calc_sets:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut irq_affinity, nvecs: ffi::c_uint)>,
    pub priv_: *mut ffi::c_void,
}
impl Default for irq_affinity {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct irq_affinity_desc {
    pub mask: cpumask,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub __bindgen_padding_0: [u8; 7usize],
}
impl Default for irq_affinity_desc {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl irq_affinity_desc {
    #[inline]
    pub fn is_managed(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_is_managed(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn is_managed_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_is_managed_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(is_managed: ffi::c_uint) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let is_managed: u32 = unsafe { ::core::mem::transmute(is_managed) };
            is_managed as u64
        });
        __bindgen_bitfield_unit
    }
}
extern "C" {
    pub static mut irq_default_affinity: cpumask_var_t;
}
extern "C" {
    pub fn irq_set_affinity(irq: ffi::c_uint, cpumask: *const cpumask) -> ffi::c_int;
}
extern "C" {
    pub fn irq_force_affinity(irq: ffi::c_uint, cpumask: *const cpumask) -> ffi::c_int;
}
extern "C" {
    pub fn irq_can_set_affinity(irq: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn irq_select_affinity(irq: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn __irq_apply_affinity_hint(
        irq: ffi::c_uint,
        m: *const cpumask,
        setaffinity: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn irq_update_affinity_desc(
        irq: ffi::c_uint,
        affinity: *mut irq_affinity_desc,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn irq_set_affinity_notifier(
        irq: ffi::c_uint,
        notify: *mut irq_affinity_notify,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn irq_create_affinity_masks(
        nvec: ffi::c_uint,
        affd: *mut irq_affinity,
    ) -> *mut irq_affinity_desc;
}
extern "C" {
    pub fn irq_calc_affinity_vectors(
        minvec: ffi::c_uint,
        maxvec: ffi::c_uint,
        affd: *const irq_affinity,
    ) -> ffi::c_uint;
}
extern "C" {
    pub fn irq_set_irq_wake(irq: ffi::c_uint, on: ffi::c_uint) -> ffi::c_int;
}
pub const irqchip_irq_state_IRQCHIP_STATE_PENDING: irqchip_irq_state = 0;
pub const irqchip_irq_state_IRQCHIP_STATE_ACTIVE: irqchip_irq_state = 1;
pub const irqchip_irq_state_IRQCHIP_STATE_MASKED: irqchip_irq_state = 2;
pub const irqchip_irq_state_IRQCHIP_STATE_LINE_LEVEL: irqchip_irq_state = 3;
pub type irqchip_irq_state = i32;
extern "C" {
    pub fn irq_get_irqchip_state(
        irq: ffi::c_uint,
        which: irqchip_irq_state,
        state: *mut bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn irq_set_irqchip_state(
        irq: ffi::c_uint,
        which: irqchip_irq_state,
        state: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub static mut force_irqthreads_key: static_key_false;
}
pub const HI_SOFTIRQ: _bindgen_ty_100 = 0;
pub const TIMER_SOFTIRQ: _bindgen_ty_100 = 1;
pub const NET_TX_SOFTIRQ: _bindgen_ty_100 = 2;
pub const NET_RX_SOFTIRQ: _bindgen_ty_100 = 3;
pub const BLOCK_SOFTIRQ: _bindgen_ty_100 = 4;
pub const IRQ_POLL_SOFTIRQ: _bindgen_ty_100 = 5;
pub const TASKLET_SOFTIRQ: _bindgen_ty_100 = 6;
pub const SCHED_SOFTIRQ: _bindgen_ty_100 = 7;
pub const HRTIMER_SOFTIRQ: _bindgen_ty_100 = 8;
pub const RCU_SOFTIRQ: _bindgen_ty_100 = 9;
pub const NR_SOFTIRQS: _bindgen_ty_100 = 10;
pub type _bindgen_ty_100 = ffi::c_uint;
extern "C" {
    pub static softirq_to_name: [*const ffi::c_char; 10usize];
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct softirq_action {
    pub action: ::core::option::Option<unsafe extern "C" fn()>,
}
extern "C" {
    pub fn do_softirq();
}
extern "C" {
    pub fn __do_softirq();
}
extern "C" {
    pub fn open_softirq(nr: ffi::c_int, action: ::core::option::Option<unsafe extern "C" fn()>);
}
extern "C" {
    pub fn softirq_init();
}
extern "C" {
    pub fn __raise_softirq_irqoff(nr: ffi::c_uint);
}
extern "C" {
    pub fn raise_softirq_irqoff(nr: ffi::c_uint);
}
extern "C" {
    pub fn raise_softirq(nr: ffi::c_uint);
}
extern "C" {
    pub static mut ktimerd: *mut task_struct;
}
extern "C" {
    pub static mut pending_timer_softirq: ffi::c_ulong;
}
extern "C" {
    pub fn raise_ktimers_thread(nr: ffi::c_uint);
}
extern "C" {
    pub static mut ksoftirqd: *mut task_struct;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tasklet_struct {
    pub next: *mut tasklet_struct,
    pub state: ffi::c_ulong,
    pub count: atomic_t,
    pub use_callback: bool_,
    pub __bindgen_anon_1: tasklet_struct__bindgen_ty_1,
    pub data: ffi::c_ulong,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tasklet_struct__bindgen_ty_1 {
    pub func: ::core::option::Option<unsafe extern "C" fn(data: ffi::c_ulong)>,
    pub callback: ::core::option::Option<unsafe extern "C" fn(t: *mut tasklet_struct)>,
}
impl Default for tasklet_struct__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for tasklet_struct {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const TASKLET_STATE_SCHED: _bindgen_ty_101 = 0;
pub const TASKLET_STATE_RUN: _bindgen_ty_101 = 1;
pub type _bindgen_ty_101 = ffi::c_uint;
extern "C" {
    pub fn tasklet_unlock(t: *mut tasklet_struct);
}
extern "C" {
    pub fn tasklet_unlock_wait(t: *mut tasklet_struct);
}
extern "C" {
    pub fn tasklet_unlock_spin_wait(t: *mut tasklet_struct);
}
extern "C" {
    pub fn __tasklet_schedule(t: *mut tasklet_struct);
}
extern "C" {
    pub fn __tasklet_hi_schedule(t: *mut tasklet_struct);
}
extern "C" {
    pub fn tasklet_kill(t: *mut tasklet_struct);
}
extern "C" {
    pub fn tasklet_init(
        t: *mut tasklet_struct,
        func: ::core::option::Option<unsafe extern "C" fn(arg1: ffi::c_ulong)>,
        data: ffi::c_ulong,
    );
}
extern "C" {
    pub fn tasklet_setup(
        t: *mut tasklet_struct,
        callback: ::core::option::Option<unsafe extern "C" fn(arg1: *mut tasklet_struct)>,
    );
}
extern "C" {
    pub fn probe_irq_on() -> ffi::c_ulong;
}
extern "C" {
    pub fn probe_irq_off(arg1: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn probe_irq_mask(arg1: ffi::c_ulong) -> ffi::c_uint;
}
extern "C" {
    pub fn init_irq_proc();
}
extern "C" {
    pub fn show_interrupts(p: *mut seq_file, v: *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn arch_show_interrupts(p: *mut seq_file, prec: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn early_irq_init() -> ffi::c_int;
}
extern "C" {
    pub fn arch_probe_nr_irqs() -> ffi::c_int;
}
extern "C" {
    pub fn arch_early_irq_init() -> ffi::c_int;
}
pub const TRACE_FTRACE_BIT: _bindgen_ty_102 = 0;
pub const TRACE_FTRACE_NMI_BIT: _bindgen_ty_102 = 1;
pub const TRACE_FTRACE_IRQ_BIT: _bindgen_ty_102 = 2;
pub const TRACE_FTRACE_SIRQ_BIT: _bindgen_ty_102 = 3;
pub const TRACE_FTRACE_TRANSITION_BIT: _bindgen_ty_102 = 4;
pub const TRACE_INTERNAL_BIT: _bindgen_ty_102 = 5;
pub const TRACE_INTERNAL_NMI_BIT: _bindgen_ty_102 = 6;
pub const TRACE_INTERNAL_IRQ_BIT: _bindgen_ty_102 = 7;
pub const TRACE_INTERNAL_SIRQ_BIT: _bindgen_ty_102 = 8;
pub const TRACE_INTERNAL_TRANSITION_BIT: _bindgen_ty_102 = 9;
pub const TRACE_BRANCH_BIT: _bindgen_ty_102 = 10;
pub const TRACE_IRQ_BIT: _bindgen_ty_102 = 11;
pub const TRACE_RECORD_RECURSION_BIT: _bindgen_ty_102 = 12;
pub type _bindgen_ty_102 = ffi::c_uint;
pub const TRACE_CTX_NMI: _bindgen_ty_103 = 0;
pub const TRACE_CTX_IRQ: _bindgen_ty_103 = 1;
pub const TRACE_CTX_SOFTIRQ: _bindgen_ty_103 = 2;
pub const TRACE_CTX_NORMAL: _bindgen_ty_103 = 3;
pub const TRACE_CTX_TRANSITION: _bindgen_ty_103 = 4;
pub type _bindgen_ty_103 = ffi::c_uint;
extern "C" {
    pub fn trace_clock_local() -> u64_;
}
extern "C" {
    pub fn trace_clock() -> u64_;
}
extern "C" {
    pub fn trace_clock_jiffies() -> u64_;
}
extern "C" {
    pub fn trace_clock_global() -> u64_;
}
extern "C" {
    pub fn trace_clock_counter() -> u64_;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct range {
    pub start: u64_,
    pub end: u64_,
}
extern "C" {
    pub fn add_range(
        range: *mut range,
        az: ffi::c_int,
        nr_range: ffi::c_int,
        start: u64_,
        end: u64_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn add_range_with_merge(
        range: *mut range,
        az: ffi::c_int,
        nr_range: ffi::c_int,
        start: u64_,
        end: u64_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn subtract_range(range: *mut range, az: ffi::c_int, start: u64_, end: u64_);
}
extern "C" {
    pub fn clean_sort_range(range: *mut range, az: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn sort_range(range: *mut range, nr_range: ffi::c_int);
}
pub type stack_trace_consume_fn = ::core::option::Option<
    unsafe extern "C" fn(cookie: *mut ffi::c_void, addr: ffi::c_ulong) -> bool_,
>;
extern "C" {
    pub fn arch_stack_walk(
        consume_entry: stack_trace_consume_fn,
        cookie: *mut ffi::c_void,
        task: *mut task_struct,
        regs: *mut pt_regs,
    );
}
extern "C" {
    pub fn arch_stack_walk_reliable(
        consume_entry: stack_trace_consume_fn,
        cookie: *mut ffi::c_void,
        task: *mut task_struct,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn arch_stack_walk_user(
        consume_entry: stack_trace_consume_fn,
        cookie: *mut ffi::c_void,
        regs: *const pt_regs,
    );
}
extern "C" {
    pub fn stack_trace_print(
        trace: *const ffi::c_ulong,
        nr_entries: ffi::c_uint,
        spaces: ffi::c_int,
    );
}
extern "C" {
    pub fn stack_trace_snprint(
        buf: *mut ffi::c_char,
        size: usize,
        entries: *const ffi::c_ulong,
        nr_entries: ffi::c_uint,
        spaces: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn stack_trace_save(
        store: *mut ffi::c_ulong,
        size: ffi::c_uint,
        skipnr: ffi::c_uint,
    ) -> ffi::c_uint;
}
extern "C" {
    pub fn stack_trace_save_tsk(
        task: *mut task_struct,
        store: *mut ffi::c_ulong,
        size: ffi::c_uint,
        skipnr: ffi::c_uint,
    ) -> ffi::c_uint;
}
extern "C" {
    pub fn stack_trace_save_regs(
        regs: *mut pt_regs,
        store: *mut ffi::c_ulong,
        size: ffi::c_uint,
        skipnr: ffi::c_uint,
    ) -> ffi::c_uint;
}
extern "C" {
    pub fn stack_trace_save_user(store: *mut ffi::c_ulong, size: ffi::c_uint) -> ffi::c_uint;
}
extern "C" {
    pub fn filter_irq_stacks(entries: *mut ffi::c_ulong, nr_entries: ffi::c_uint) -> ffi::c_uint;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct page_ext_operations {
    pub offset: usize,
    pub size: usize,
    pub need: ::core::option::Option<unsafe extern "C" fn() -> bool_>,
    pub init: ::core::option::Option<unsafe extern "C" fn()>,
    pub need_shared_flags: bool_,
}
pub const page_ext_flags_PAGE_EXT_OWNER: page_ext_flags = 0;
pub const page_ext_flags_PAGE_EXT_OWNER_ALLOCATED: page_ext_flags = 1;
pub type page_ext_flags = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct page_ext {
    pub flags: ffi::c_ulong,
}
extern "C" {
    pub static mut early_page_ext: bool_;
}
extern "C" {
    pub static mut page_ext_size: ffi::c_ulong;
}
extern "C" {
    pub fn pgdat_page_ext_init(pgdat: *mut pglist_data);
}
extern "C" {
    pub fn page_ext_init();
}
extern "C" {
    pub fn page_ext_get(page: *const page) -> *mut page_ext;
}
extern "C" {
    pub fn page_ext_put(page_ext: *mut page_ext);
}
extern "C" {
    pub fn page_ext_lookup(pfn: ffi::c_ulong) -> *mut page_ext;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct page_ext_iter {
    pub index: ffi::c_ulong,
    pub start_pfn: ffi::c_ulong,
    pub page_ext: *mut page_ext,
}
impl Default for page_ext_iter {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut __tracepoint_page_ref_set: tracepoint;
}
extern "C" {
    pub static mut __tracepoint_page_ref_mod: tracepoint;
}
extern "C" {
    pub static mut __tracepoint_page_ref_mod_and_test: tracepoint;
}
extern "C" {
    pub static mut __tracepoint_page_ref_mod_and_return: tracepoint;
}
extern "C" {
    pub static mut __tracepoint_page_ref_mod_unless: tracepoint;
}
extern "C" {
    pub static mut __tracepoint_page_ref_freeze: tracepoint;
}
extern "C" {
    pub static mut __tracepoint_page_ref_unfreeze: tracepoint;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct resource {
    pub start: resource_size_t,
    pub end: resource_size_t,
    pub name: *const ffi::c_char,
    pub flags: ffi::c_ulong,
    pub desc: ffi::c_ulong,
    pub parent: *mut resource,
    pub sibling: *mut resource,
    pub child: *mut resource,
}
impl Default for resource {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const IORES_DESC_NONE: _bindgen_ty_104 = 0;
pub const IORES_DESC_CRASH_KERNEL: _bindgen_ty_104 = 1;
pub const IORES_DESC_ACPI_TABLES: _bindgen_ty_104 = 2;
pub const IORES_DESC_ACPI_NV_STORAGE: _bindgen_ty_104 = 3;
pub const IORES_DESC_PERSISTENT_MEMORY: _bindgen_ty_104 = 4;
pub const IORES_DESC_PERSISTENT_MEMORY_LEGACY: _bindgen_ty_104 = 5;
pub const IORES_DESC_DEVICE_PRIVATE_MEMORY: _bindgen_ty_104 = 6;
pub const IORES_DESC_RESERVED: _bindgen_ty_104 = 7;
pub const IORES_DESC_SOFT_RESERVED: _bindgen_ty_104 = 8;
pub const IORES_DESC_CXL: _bindgen_ty_104 = 9;
pub type _bindgen_ty_104 = ffi::c_uint;
pub const IORES_MAP_SYSTEM_RAM: _bindgen_ty_105 = 1;
pub const IORES_MAP_ENCRYPTED: _bindgen_ty_105 = 2;
pub type _bindgen_ty_105 = ffi::c_uint;
pub type resource_alignf = ::core::option::Option<
    unsafe extern "C" fn(
        data: *mut ffi::c_void,
        res: *const resource,
        size: resource_size_t,
        align: resource_size_t,
    ) -> resource_size_t,
>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct resource_constraint {
    pub min: resource_size_t,
    pub max: resource_size_t,
    pub align: resource_size_t,
    pub alignf: resource_alignf,
    pub alignf_data: *mut ffi::c_void,
}
impl Default for resource_constraint {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut ioport_resource: resource;
}
extern "C" {
    pub static mut iomem_resource: resource;
}
extern "C" {
    pub fn request_resource_conflict(root: *mut resource, new: *mut resource) -> *mut resource;
}
extern "C" {
    pub fn request_resource(root: *mut resource, new: *mut resource) -> ffi::c_int;
}
extern "C" {
    pub fn release_resource(new: *mut resource) -> ffi::c_int;
}
extern "C" {
    pub fn release_child_resources(new: *mut resource);
}
extern "C" {
    pub fn reserve_region_with_split(
        root: *mut resource,
        start: resource_size_t,
        end: resource_size_t,
        name: *const ffi::c_char,
    );
}
extern "C" {
    pub fn insert_resource_conflict(parent: *mut resource, new: *mut resource) -> *mut resource;
}
extern "C" {
    pub fn insert_resource(parent: *mut resource, new: *mut resource) -> ffi::c_int;
}
extern "C" {
    pub fn insert_resource_expand_to_fit(root: *mut resource, new: *mut resource);
}
extern "C" {
    pub fn remove_resource(old: *mut resource) -> ffi::c_int;
}
extern "C" {
    pub fn arch_remove_reservations(avail: *mut resource);
}
extern "C" {
    pub fn allocate_resource(
        root: *mut resource,
        new: *mut resource,
        size: resource_size_t,
        min: resource_size_t,
        max: resource_size_t,
        align: resource_size_t,
        alignf: resource_alignf,
        alignf_data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn lookup_resource(root: *mut resource, start: resource_size_t) -> *mut resource;
}
extern "C" {
    pub fn adjust_resource(
        res: *mut resource,
        start: resource_size_t,
        size: resource_size_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn resource_alignment(res: *mut resource) -> resource_size_t;
}
extern "C" {
    pub fn find_resource_space(
        root: *mut resource,
        new: *mut resource,
        size: resource_size_t,
        constraint: *mut resource_constraint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __request_region(
        arg1: *mut resource,
        start: resource_size_t,
        n: resource_size_t,
        name: *const ffi::c_char,
        flags: ffi::c_int,
    ) -> *mut resource;
}
extern "C" {
    pub fn __release_region(arg1: *mut resource, arg2: resource_size_t, arg3: resource_size_t);
}
extern "C" {
    pub fn release_mem_region_adjustable(arg1: resource_size_t, arg2: resource_size_t);
}
extern "C" {
    pub fn merge_system_ram_resource(res: *mut resource);
}
extern "C" {
    pub fn devm_request_resource(
        dev: *mut device,
        root: *mut resource,
        new: *mut resource,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn devm_release_resource(dev: *mut device, new: *mut resource);
}
extern "C" {
    pub fn __devm_request_region(
        dev: *mut device,
        parent: *mut resource,
        start: resource_size_t,
        n: resource_size_t,
        name: *const ffi::c_char,
    ) -> *mut resource;
}
extern "C" {
    pub fn __devm_release_region(
        dev: *mut device,
        parent: *mut resource,
        start: resource_size_t,
        n: resource_size_t,
    );
}
extern "C" {
    pub fn iomem_map_sanity_check(addr: resource_size_t, size: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn iomem_is_exclusive(addr: u64_) -> bool_;
}
extern "C" {
    pub fn resource_is_exclusive(
        resource: *mut resource,
        addr: u64_,
        size: resource_size_t,
    ) -> bool_;
}
extern "C" {
    pub fn walk_system_ram_range(
        start_pfn: ffi::c_ulong,
        nr_pages: ffi::c_ulong,
        arg: *mut ffi::c_void,
        func: ::core::option::Option<
            unsafe extern "C" fn(
                arg1: ffi::c_ulong,
                arg2: ffi::c_ulong,
                arg3: *mut ffi::c_void,
            ) -> ffi::c_int,
        >,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn walk_mem_res(
        start: u64_,
        end: u64_,
        arg: *mut ffi::c_void,
        func: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut resource, arg2: *mut ffi::c_void) -> ffi::c_int,
        >,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn walk_system_ram_res(
        start: u64_,
        end: u64_,
        arg: *mut ffi::c_void,
        func: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut resource, arg2: *mut ffi::c_void) -> ffi::c_int,
        >,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn walk_system_ram_res_rev(
        start: u64_,
        end: u64_,
        arg: *mut ffi::c_void,
        func: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut resource, arg2: *mut ffi::c_void) -> ffi::c_int,
        >,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn walk_iomem_res_desc(
        desc: ffi::c_ulong,
        flags: ffi::c_ulong,
        start: u64_,
        end: u64_,
        arg: *mut ffi::c_void,
        func: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut resource, arg2: *mut ffi::c_void) -> ffi::c_int,
        >,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn devm_request_free_mem_region(
        dev: *mut device,
        base: *mut resource,
        size: ffi::c_ulong,
    ) -> *mut resource;
}
extern "C" {
    pub fn request_free_mem_region(
        base: *mut resource,
        size: ffi::c_ulong,
        name: *const ffi::c_char,
    ) -> *mut resource;
}
extern "C" {
    pub fn alloc_free_mem_region(
        base: *mut resource,
        size: ffi::c_ulong,
        align: ffi::c_ulong,
        name: *const ffi::c_char,
    ) -> *mut resource;
}
extern "C" {
    pub fn iomem_get_mapping() -> *mut address_space;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct vmem_altmap {
    pub base_pfn: ffi::c_ulong,
    pub end_pfn: ffi::c_ulong,
    pub reserve: ffi::c_ulong,
    pub free: ffi::c_ulong,
    pub align: ffi::c_ulong,
    pub alloc: ffi::c_ulong,
    pub inaccessible: bool_,
}
pub const memory_type_MEMORY_DEVICE_PRIVATE: memory_type = 1;
pub const memory_type_MEMORY_DEVICE_COHERENT: memory_type = 2;
pub const memory_type_MEMORY_DEVICE_FS_DAX: memory_type = 3;
pub const memory_type_MEMORY_DEVICE_GENERIC: memory_type = 4;
pub const memory_type_MEMORY_DEVICE_PCI_P2PDMA: memory_type = 5;
pub type memory_type = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct dev_pagemap_ops {
    pub page_free: ::core::option::Option<unsafe extern "C" fn(page: *mut page)>,
    pub migrate_to_ram:
        ::core::option::Option<unsafe extern "C" fn(vmf: *mut vm_fault) -> vm_fault_t>,
    pub memory_failure: ::core::option::Option<
        unsafe extern "C" fn(
            pgmap: *mut dev_pagemap,
            pfn: ffi::c_ulong,
            nr_pages: ffi::c_ulong,
            mf_flags: ffi::c_int,
        ) -> ffi::c_int,
    >,
}
#[repr(C)]
pub struct dev_pagemap {
    pub altmap: vmem_altmap,
    pub ref_: percpu_ref,
    pub done: completion,
    pub type_: memory_type,
    pub flags: ffi::c_uint,
    pub vmemmap_shift: ffi::c_ulong,
    pub ops: *const dev_pagemap_ops,
    pub owner: *mut ffi::c_void,
    pub nr_range: ffi::c_int,
    pub __bindgen_anon_1: dev_pagemap__bindgen_ty_1,
}
#[repr(C)]
pub struct dev_pagemap__bindgen_ty_1 {
    pub range: __BindgenUnionField<range>,
    pub __bindgen_anon_1: __BindgenUnionField<dev_pagemap__bindgen_ty_1__bindgen_ty_1>,
    pub bindgen_union_field: [u64; 2usize],
}
#[repr(C)]
#[derive(Default)]
pub struct dev_pagemap__bindgen_ty_1__bindgen_ty_1 {
    pub __empty_ranges: dev_pagemap__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
    pub ranges: __IncompleteArrayField<range>,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct dev_pagemap__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {}
impl Default for dev_pagemap__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for dev_pagemap {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn zone_device_page_init(page: *mut page);
}
extern "C" {
    pub fn memremap_pages(pgmap: *mut dev_pagemap, nid: ffi::c_int) -> *mut ffi::c_void;
}
extern "C" {
    pub fn memunmap_pages(pgmap: *mut dev_pagemap);
}
extern "C" {
    pub fn devm_memremap_pages(dev: *mut device, pgmap: *mut dev_pagemap) -> *mut ffi::c_void;
}
extern "C" {
    pub fn devm_memunmap_pages(dev: *mut device, pgmap: *mut dev_pagemap);
}
extern "C" {
    pub fn get_dev_pagemap(pfn: ffi::c_ulong, pgmap: *mut dev_pagemap) -> *mut dev_pagemap;
}
extern "C" {
    pub fn pgmap_pfn_valid(pgmap: *mut dev_pagemap, pfn: ffi::c_ulong) -> bool_;
}
extern "C" {
    pub fn memremap_compat_align() -> ffi::c_ulong;
}
extern "C" {
    pub fn lockdep_is_cpus_held() -> ffi::c_int;
}
extern "C" {
    pub fn cpus_write_lock();
}
extern "C" {
    pub fn cpus_write_unlock();
}
extern "C" {
    pub fn cpus_read_lock();
}
extern "C" {
    pub fn cpus_read_unlock();
}
extern "C" {
    pub fn cpus_read_trylock() -> ffi::c_int;
}
extern "C" {
    pub fn lockdep_assert_cpus_held();
}
extern "C" {
    pub fn cpu_hotplug_disable_offlining();
}
extern "C" {
    pub fn cpu_hotplug_disable();
}
extern "C" {
    pub fn cpu_hotplug_enable();
}
extern "C" {
    pub fn clear_tasks_mm_cpumask(cpu: ffi::c_int);
}
extern "C" {
    pub fn remove_cpu(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn cpu_device_down(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn smp_shutdown_nonboot_cpus(primary_cpu: ffi::c_uint);
}
pub const class_cpus_read_lock_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_cpus_read_lock_t {
    pub lock: *mut ffi::c_void,
}
impl Default for class_cpus_read_lock_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const cache_type_CACHE_TYPE_NOCACHE: cache_type = 0;
pub const cache_type_CACHE_TYPE_INST: cache_type = 1;
pub const cache_type_CACHE_TYPE_DATA: cache_type = 2;
pub const cache_type_CACHE_TYPE_SEPARATE: cache_type = 3;
pub const cache_type_CACHE_TYPE_UNIFIED: cache_type = 4;
pub type cache_type = ffi::c_uint;
extern "C" {
    pub static mut coherency_max_size: ffi::c_uint;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct cacheinfo {
    pub id: ffi::c_uint,
    pub type_: cache_type,
    pub level: ffi::c_uint,
    pub coherency_line_size: ffi::c_uint,
    pub number_of_sets: ffi::c_uint,
    pub ways_of_associativity: ffi::c_uint,
    pub physical_line_partition: ffi::c_uint,
    pub size: ffi::c_uint,
    pub shared_cpu_map: cpumask_t,
    pub attributes: ffi::c_uint,
    pub fw_token: *mut ffi::c_void,
    pub disable_sysfs: bool_,
    pub priv_: *mut ffi::c_void,
}
impl Default for cacheinfo {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct cpu_cacheinfo {
    pub info_list: *mut cacheinfo,
    pub per_cpu_data_slice_size: ffi::c_uint,
    pub num_levels: ffi::c_uint,
    pub num_leaves: ffi::c_uint,
    pub cpu_map_populated: bool_,
    pub early_ci_levels: bool_,
}
impl Default for cpu_cacheinfo {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn get_cpu_cacheinfo(cpu: ffi::c_uint) -> *mut cpu_cacheinfo;
}
extern "C" {
    pub fn early_cache_level(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn init_cache_level(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn init_of_cache_level(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn populate_cache_leaves(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn cache_setup_acpi(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn last_level_cache_is_valid(cpu: ffi::c_uint) -> bool_;
}
extern "C" {
    pub fn last_level_cache_is_shared(cpu_x: ffi::c_uint, cpu_y: ffi::c_uint) -> bool_;
}
extern "C" {
    pub fn fetch_cache_info(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn detect_cache_attributes(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn acpi_get_cache_info(
        cpu: ffi::c_uint,
        levels: *mut ffi::c_uint,
        split_levels: *mut ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn cache_get_priv_group(this_leaf: *mut cacheinfo) -> *const attribute_group;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct anon_vma {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct anon_vma_chain {
    _unused: [u8; 0],
}
extern "C" {
    pub fn arch_mm_preinit();
}
extern "C" {
    pub fn mm_core_init();
}
extern "C" {
    pub fn init_mm_internals();
}
extern "C" {
    pub static mut _totalram_pages: atomic_long_t;
}
extern "C" {
    pub static mut high_memory: *mut ffi::c_void;
}
extern "C" {
    pub static mut sysctl_legacy_va_layout: ffi::c_int;
}
extern "C" {
    pub static mmap_rnd_bits_min: ffi::c_int;
}
extern "C" {
    pub static mut mmap_rnd_bits_max: ffi::c_int;
}
extern "C" {
    pub static mut mmap_rnd_bits: ffi::c_int;
}
extern "C" {
    pub static mmap_rnd_compat_bits_min: ffi::c_int;
}
extern "C" {
    pub static mmap_rnd_compat_bits_max: ffi::c_int;
}
extern "C" {
    pub static mut mmap_rnd_compat_bits: ffi::c_int;
}
extern "C" {
    pub static mut sysctl_max_map_count: ffi::c_int;
}
extern "C" {
    pub static mut sysctl_user_reserve_kbytes: ffi::c_ulong;
}
extern "C" {
    pub static mut sysctl_admin_reserve_kbytes: ffi::c_ulong;
}
extern "C" {
    pub fn setup_initial_init_mm(
        start_code: *mut ffi::c_void,
        end_code: *mut ffi::c_void,
        end_data: *mut ffi::c_void,
        brk: *mut ffi::c_void,
    );
}
extern "C" {
    pub fn vm_area_alloc(arg1: *mut mm_struct) -> *mut vm_area_struct;
}
extern "C" {
    pub fn vm_area_dup(arg1: *mut vm_area_struct) -> *mut vm_area_struct;
}
extern "C" {
    pub fn vm_area_free(arg1: *mut vm_area_struct);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct vm_fault {
    pub __bindgen_anon_1: vm_fault__bindgen_ty_1,
    pub flags: fault_flag,
    pub pmd: *mut pmd_t,
    pub pud: *mut pud_t,
    pub __bindgen_anon_2: vm_fault__bindgen_ty_2,
    pub cow_page: *mut page,
    pub page: *mut page,
    pub pte: *mut pte_t,
    pub ptl: *mut spinlock_t,
    pub prealloc_pte: pgtable_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct vm_fault__bindgen_ty_1 {
    pub vma: *mut vm_area_struct,
    pub gfp_mask: gfp_t,
    pub pgoff: ffi::c_ulong,
    pub address: ffi::c_ulong,
    pub real_address: ffi::c_ulong,
}
impl Default for vm_fault__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union vm_fault__bindgen_ty_2 {
    pub orig_pte: pte_t,
    pub orig_pmd: pmd_t,
}
impl Default for vm_fault__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for vm_fault {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct vm_operations_struct {
    pub open: ::core::option::Option<unsafe extern "C" fn(area: *mut vm_area_struct)>,
    pub close: ::core::option::Option<unsafe extern "C" fn(area: *mut vm_area_struct)>,
    pub may_split: ::core::option::Option<
        unsafe extern "C" fn(area: *mut vm_area_struct, addr: ffi::c_ulong) -> ffi::c_int,
    >,
    pub mremap:
        ::core::option::Option<unsafe extern "C" fn(area: *mut vm_area_struct) -> ffi::c_int>,
    pub mprotect: ::core::option::Option<
        unsafe extern "C" fn(
            vma: *mut vm_area_struct,
            start: ffi::c_ulong,
            end: ffi::c_ulong,
            newflags: ffi::c_ulong,
        ) -> ffi::c_int,
    >,
    pub fault: ::core::option::Option<unsafe extern "C" fn(vmf: *mut vm_fault) -> vm_fault_t>,
    pub huge_fault: ::core::option::Option<
        unsafe extern "C" fn(vmf: *mut vm_fault, order: ffi::c_uint) -> vm_fault_t,
    >,
    pub map_pages: ::core::option::Option<
        unsafe extern "C" fn(
            vmf: *mut vm_fault,
            start_pgoff: ffi::c_ulong,
            end_pgoff: ffi::c_ulong,
        ) -> vm_fault_t,
    >,
    pub pagesize:
        ::core::option::Option<unsafe extern "C" fn(area: *mut vm_area_struct) -> ffi::c_ulong>,
    pub page_mkwrite:
        ::core::option::Option<unsafe extern "C" fn(vmf: *mut vm_fault) -> vm_fault_t>,
    pub pfn_mkwrite: ::core::option::Option<unsafe extern "C" fn(vmf: *mut vm_fault) -> vm_fault_t>,
    pub access: ::core::option::Option<
        unsafe extern "C" fn(
            vma: *mut vm_area_struct,
            addr: ffi::c_ulong,
            buf: *mut ffi::c_void,
            len: ffi::c_int,
            write: ffi::c_int,
        ) -> ffi::c_int,
    >,
    pub name: ::core::option::Option<
        unsafe extern "C" fn(vma: *mut vm_area_struct) -> *const ffi::c_char,
    >,
    pub set_policy: ::core::option::Option<
        unsafe extern "C" fn(vma: *mut vm_area_struct, new: *mut mempolicy) -> ffi::c_int,
    >,
    pub get_policy: ::core::option::Option<
        unsafe extern "C" fn(
            vma: *mut vm_area_struct,
            addr: ffi::c_ulong,
            ilx: *mut ffi::c_ulong,
        ) -> *mut mempolicy,
    >,
    pub find_special_page: ::core::option::Option<
        unsafe extern "C" fn(vma: *mut vm_area_struct, addr: ffi::c_ulong) -> *mut page,
    >,
}
extern "C" {
    pub fn __vma_start_write(vma: *mut vm_area_struct, mm_lock_seq: ffi::c_uint);
}
extern "C" {
    pub fn vma_mark_detached(vma: *mut vm_area_struct);
}
extern "C" {
    pub fn lock_vma_under_rcu(mm: *mut mm_struct, address: ffi::c_ulong) -> *mut vm_area_struct;
}
extern "C" {
    pub static vma_dummy_vm_ops: vm_operations_struct;
}
extern "C" {
    pub fn vma_is_shmem(vma: *mut vm_area_struct) -> bool_;
}
extern "C" {
    pub fn vma_is_anon_shmem(vma: *mut vm_area_struct) -> bool_;
}
extern "C" {
    pub fn vma_is_stack_for_current(vma: *mut vm_area_struct) -> ffi::c_int;
}
extern "C" {
    pub fn prep_compound_page(page: *mut page, order: ffi::c_uint);
}
extern "C" {
    pub fn do_huge_pmd_anonymous_page(vmf: *mut vm_fault) -> vm_fault_t;
}
extern "C" {
    pub fn copy_huge_pmd(
        dst_mm: *mut mm_struct,
        src_mm: *mut mm_struct,
        dst_pmd: *mut pmd_t,
        src_pmd: *mut pmd_t,
        addr: ffi::c_ulong,
        dst_vma: *mut vm_area_struct,
        src_vma: *mut vm_area_struct,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn huge_pmd_set_accessed(vmf: *mut vm_fault);
}
extern "C" {
    pub fn copy_huge_pud(
        dst_mm: *mut mm_struct,
        src_mm: *mut mm_struct,
        dst_pud: *mut pud_t,
        src_pud: *mut pud_t,
        addr: ffi::c_ulong,
        vma: *mut vm_area_struct,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn do_huge_pmd_wp_page(vmf: *mut vm_fault) -> vm_fault_t;
}
extern "C" {
    pub fn madvise_free_huge_pmd(
        tlb: *mut mmu_gather,
        vma: *mut vm_area_struct,
        pmd: *mut pmd_t,
        addr: ffi::c_ulong,
        next: ffi::c_ulong,
    ) -> bool_;
}
extern "C" {
    pub fn zap_huge_pmd(
        tlb: *mut mmu_gather,
        vma: *mut vm_area_struct,
        pmd: *mut pmd_t,
        addr: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn zap_huge_pud(
        tlb: *mut mmu_gather,
        vma: *mut vm_area_struct,
        pud: *mut pud_t,
        addr: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn move_huge_pmd(
        vma: *mut vm_area_struct,
        old_addr: ffi::c_ulong,
        new_addr: ffi::c_ulong,
        old_pmd: *mut pmd_t,
        new_pmd: *mut pmd_t,
    ) -> bool_;
}
extern "C" {
    pub fn change_huge_pmd(
        tlb: *mut mmu_gather,
        vma: *mut vm_area_struct,
        pmd: *mut pmd_t,
        addr: ffi::c_ulong,
        newprot: pgprot_t,
        cp_flags: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vmf_insert_pfn_pmd(vmf: *mut vm_fault, pfn: pfn_t, write: bool_) -> vm_fault_t;
}
extern "C" {
    pub fn vmf_insert_pfn_pud(vmf: *mut vm_fault, pfn: pfn_t, write: bool_) -> vm_fault_t;
}
extern "C" {
    pub fn vmf_insert_folio_pmd(vmf: *mut vm_fault, folio: *mut folio, write: bool_) -> vm_fault_t;
}
extern "C" {
    pub fn vmf_insert_folio_pud(vmf: *mut vm_fault, folio: *mut folio, write: bool_) -> vm_fault_t;
}
pub const transparent_hugepage_flag_TRANSPARENT_HUGEPAGE_UNSUPPORTED: transparent_hugepage_flag = 0;
pub const transparent_hugepage_flag_TRANSPARENT_HUGEPAGE_FLAG: transparent_hugepage_flag = 1;
pub const transparent_hugepage_flag_TRANSPARENT_HUGEPAGE_REQ_MADV_FLAG: transparent_hugepage_flag =
    2;
pub const transparent_hugepage_flag_TRANSPARENT_HUGEPAGE_DEFRAG_DIRECT_FLAG:
    transparent_hugepage_flag = 3;
pub const transparent_hugepage_flag_TRANSPARENT_HUGEPAGE_DEFRAG_KSWAPD_FLAG:
    transparent_hugepage_flag = 4;
pub const transparent_hugepage_flag_TRANSPARENT_HUGEPAGE_DEFRAG_KSWAPD_OR_MADV_FLAG:
    transparent_hugepage_flag = 5;
pub const transparent_hugepage_flag_TRANSPARENT_HUGEPAGE_DEFRAG_REQ_MADV_FLAG:
    transparent_hugepage_flag = 6;
pub const transparent_hugepage_flag_TRANSPARENT_HUGEPAGE_DEFRAG_KHUGEPAGED_FLAG:
    transparent_hugepage_flag = 7;
pub const transparent_hugepage_flag_TRANSPARENT_HUGEPAGE_USE_ZERO_PAGE_FLAG:
    transparent_hugepage_flag = 8;
pub type transparent_hugepage_flag = ffi::c_uint;
extern "C" {
    pub fn single_hugepage_flag_store(
        kobj: *mut kobject,
        attr: *mut kobj_attribute,
        buf: *const ffi::c_char,
        count: usize,
        flag: transparent_hugepage_flag,
    ) -> isize;
}
extern "C" {
    pub fn single_hugepage_flag_show(
        kobj: *mut kobject,
        attr: *mut kobj_attribute,
        buf: *mut ffi::c_char,
        flag: transparent_hugepage_flag,
    ) -> isize;
}
extern "C" {
    pub static mut shmem_enabled_attr: kobj_attribute;
}
extern "C" {
    pub static mut thpsize_shmem_enabled_attr: kobj_attribute;
}
pub const mthp_stat_item_MTHP_STAT_ANON_FAULT_ALLOC: mthp_stat_item = 0;
pub const mthp_stat_item_MTHP_STAT_ANON_FAULT_FALLBACK: mthp_stat_item = 1;
pub const mthp_stat_item_MTHP_STAT_ANON_FAULT_FALLBACK_CHARGE: mthp_stat_item = 2;
pub const mthp_stat_item_MTHP_STAT_ZSWPOUT: mthp_stat_item = 3;
pub const mthp_stat_item_MTHP_STAT_SWPIN: mthp_stat_item = 4;
pub const mthp_stat_item_MTHP_STAT_SWPIN_FALLBACK: mthp_stat_item = 5;
pub const mthp_stat_item_MTHP_STAT_SWPIN_FALLBACK_CHARGE: mthp_stat_item = 6;
pub const mthp_stat_item_MTHP_STAT_SWPOUT: mthp_stat_item = 7;
pub const mthp_stat_item_MTHP_STAT_SWPOUT_FALLBACK: mthp_stat_item = 8;
pub const mthp_stat_item_MTHP_STAT_SHMEM_ALLOC: mthp_stat_item = 9;
pub const mthp_stat_item_MTHP_STAT_SHMEM_FALLBACK: mthp_stat_item = 10;
pub const mthp_stat_item_MTHP_STAT_SHMEM_FALLBACK_CHARGE: mthp_stat_item = 11;
pub const mthp_stat_item_MTHP_STAT_SPLIT: mthp_stat_item = 12;
pub const mthp_stat_item_MTHP_STAT_SPLIT_FAILED: mthp_stat_item = 13;
pub const mthp_stat_item_MTHP_STAT_SPLIT_DEFERRED: mthp_stat_item = 14;
pub const mthp_stat_item_MTHP_STAT_NR_ANON: mthp_stat_item = 15;
pub const mthp_stat_item_MTHP_STAT_NR_ANON_PARTIALLY_MAPPED: mthp_stat_item = 16;
pub const mthp_stat_item___MTHP_STAT_COUNT: mthp_stat_item = 17;
pub type mthp_stat_item = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct mthp_stat {
    pub stats: [[ffi::c_ulong; 17usize]; 10usize],
}
extern "C" {
    pub static mut mthp_stats: mthp_stat;
}
extern "C" {
    pub static mut transparent_hugepage_flags: ffi::c_ulong;
}
extern "C" {
    pub static mut huge_anon_orders_always: ffi::c_ulong;
}
extern "C" {
    pub static mut huge_anon_orders_madvise: ffi::c_ulong;
}
extern "C" {
    pub static mut huge_anon_orders_inherit: ffi::c_ulong;
}
extern "C" {
    pub fn __thp_vma_allowable_orders(
        vma: *mut vm_area_struct,
        vm_flags: ffi::c_ulong,
        tva_flags: ffi::c_ulong,
        orders: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct thpsize {
    pub kobj: kobject,
    pub node: list_head,
    pub order: ffi::c_int,
}
impl Default for thpsize {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn thp_get_unmapped_area(
        filp: *mut file,
        addr: ffi::c_ulong,
        len: ffi::c_ulong,
        pgoff: ffi::c_ulong,
        flags: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn thp_get_unmapped_area_vmflags(
        filp: *mut file,
        addr: ffi::c_ulong,
        len: ffi::c_ulong,
        pgoff: ffi::c_ulong,
        flags: ffi::c_ulong,
        vm_flags: vm_flags_t,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn can_split_folio(
        folio: *mut folio,
        caller_pins: ffi::c_int,
        pextra_pins: *mut ffi::c_int,
    ) -> bool_;
}
extern "C" {
    pub fn split_huge_page_to_list_to_order(
        page: *mut page,
        list: *mut list_head,
        new_order: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn min_order_for_split(folio: *mut folio) -> ffi::c_int;
}
extern "C" {
    pub fn split_folio_to_list(folio: *mut folio, list: *mut list_head) -> ffi::c_int;
}
extern "C" {
    pub fn uniform_split_supported(
        folio: *mut folio,
        new_order: ffi::c_uint,
        warns: bool_,
    ) -> bool_;
}
extern "C" {
    pub fn non_uniform_split_supported(
        folio: *mut folio,
        new_order: ffi::c_uint,
        warns: bool_,
    ) -> bool_;
}
extern "C" {
    pub fn folio_split(
        folio: *mut folio,
        new_order: ffi::c_uint,
        page: *mut page,
        list: *mut list_head,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn deferred_split_folio(folio: *mut folio, partially_mapped: bool_);
}
extern "C" {
    pub fn __split_huge_pmd(
        vma: *mut vm_area_struct,
        pmd: *mut pmd_t,
        address: ffi::c_ulong,
        freeze: bool_,
        folio: *mut folio,
    );
}
extern "C" {
    pub fn split_huge_pmd_address(
        vma: *mut vm_area_struct,
        address: ffi::c_ulong,
        freeze: bool_,
        folio: *mut folio,
    );
}
extern "C" {
    pub fn __split_huge_pud(vma: *mut vm_area_struct, pud: *mut pud_t, address: ffi::c_ulong);
}
extern "C" {
    pub fn hugepage_madvise(
        vma: *mut vm_area_struct,
        vm_flags: *mut ffi::c_ulong,
        advice: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn madvise_collapse(
        vma: *mut vm_area_struct,
        prev: *mut *mut vm_area_struct,
        start: ffi::c_ulong,
        end: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vma_adjust_trans_huge(
        vma: *mut vm_area_struct,
        start: ffi::c_ulong,
        end: ffi::c_ulong,
        next: *mut vm_area_struct,
    );
}
extern "C" {
    pub fn __pmd_trans_huge_lock(pmd: *mut pmd_t, vma: *mut vm_area_struct) -> *mut spinlock_t;
}
extern "C" {
    pub fn __pud_trans_huge_lock(pud: *mut pud_t, vma: *mut vm_area_struct) -> *mut spinlock_t;
}
extern "C" {
    pub fn follow_devmap_pmd(
        vma: *mut vm_area_struct,
        addr: ffi::c_ulong,
        pmd: *mut pmd_t,
        flags: ffi::c_int,
        pgmap: *mut *mut dev_pagemap,
    ) -> *mut page;
}
extern "C" {
    pub fn do_huge_pmd_numa_page(vmf: *mut vm_fault) -> vm_fault_t;
}
extern "C" {
    pub static mut huge_zero_folio: *mut folio;
}
extern "C" {
    pub static mut huge_zero_pfn: ffi::c_ulong;
}
extern "C" {
    pub fn mm_get_huge_zero_folio(mm: *mut mm_struct) -> *mut folio;
}
extern "C" {
    pub fn mm_put_huge_zero_folio(mm: *mut mm_struct);
}
extern "C" {
    pub fn split_huge_pmd_locked(
        vma: *mut vm_area_struct,
        address: ffi::c_ulong,
        pmd: *mut pmd_t,
        freeze: bool_,
        folio: *mut folio,
    );
}
extern "C" {
    pub fn unmap_huge_pmd_locked(
        vma: *mut vm_area_struct,
        addr: ffi::c_ulong,
        pmdp: *mut pmd_t,
        folio: *mut folio,
    ) -> bool_;
}
extern "C" {
    pub fn page_is_ram(pfn: ffi::c_ulong) -> ffi::c_int;
}
pub const REGION_INTERSECTS: _bindgen_ty_106 = 0;
pub const REGION_DISJOINT: _bindgen_ty_106 = 1;
pub const REGION_MIXED: _bindgen_ty_106 = 2;
pub type _bindgen_ty_106 = ffi::c_uint;
extern "C" {
    pub fn region_intersects(
        offset: resource_size_t,
        size: usize,
        flags: ffi::c_ulong,
        desc: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vmalloc_to_page(addr: *const ffi::c_void) -> *mut page;
}
extern "C" {
    pub fn vmalloc_to_pfn(addr: *const ffi::c_void) -> ffi::c_ulong;
}
extern "C" {
    pub fn is_vmalloc_addr(x: *const ffi::c_void) -> bool_;
}
extern "C" {
    pub fn is_vmalloc_or_module_addr(x: *const ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn __folio_put(folio: *mut folio);
}
extern "C" {
    pub fn split_page(page: *mut page, order: ffi::c_uint);
}
extern "C" {
    pub fn folio_copy(dst: *mut folio, src: *mut folio);
}
extern "C" {
    pub fn folio_mc_copy(dst: *mut folio, src: *mut folio) -> ffi::c_int;
}
extern "C" {
    pub fn nr_free_buffer_pages() -> ffi::c_ulong;
}
extern "C" {
    pub fn do_set_pmd(vmf: *mut vm_fault, page: *mut page) -> vm_fault_t;
}
extern "C" {
    pub fn set_pte_range(
        vmf: *mut vm_fault,
        folio: *mut folio,
        page: *mut page,
        nr: ffi::c_uint,
        addr: ffi::c_ulong,
    );
}
extern "C" {
    pub fn finish_fault(vmf: *mut vm_fault) -> vm_fault_t;
}
extern "C" {
    pub fn folios_put_refs(folios: *mut folio_batch, refs: *mut ffi::c_uint);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union release_pages_arg {
    pub pages: *mut *mut page,
    pub folios: *mut *mut folio,
    pub encoded_pages: *mut *mut encoded_page,
}
impl Default for release_pages_arg {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn release_pages(arg1: release_pages_arg, nr: ffi::c_int);
}
extern "C" {
    pub fn unpin_user_page(page: *mut page);
}
extern "C" {
    pub fn unpin_folio(folio: *mut folio);
}
extern "C" {
    pub fn unpin_user_pages_dirty_lock(
        pages: *mut *mut page,
        npages: ffi::c_ulong,
        make_dirty: bool_,
    );
}
extern "C" {
    pub fn unpin_user_page_range_dirty_lock(
        page: *mut page,
        npages: ffi::c_ulong,
        make_dirty: bool_,
    );
}
extern "C" {
    pub fn unpin_user_pages(pages: *mut *mut page, npages: ffi::c_ulong);
}
extern "C" {
    pub fn unpin_user_folio(folio: *mut folio, npages: ffi::c_ulong);
}
extern "C" {
    pub fn unpin_folios(folios: *mut *mut folio, nfolios: ffi::c_ulong);
}
extern "C" {
    pub fn folio_xchg_last_cpupid(folio: *mut folio, cpupid: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn folio_use_access_time(folio: *mut folio) -> bool_;
}
pub const vm_event_item_PGPGIN: vm_event_item = 0;
pub const vm_event_item_PGPGOUT: vm_event_item = 1;
pub const vm_event_item_PSWPIN: vm_event_item = 2;
pub const vm_event_item_PSWPOUT: vm_event_item = 3;
pub const vm_event_item_PGALLOC_DMA: vm_event_item = 4;
pub const vm_event_item_PGALLOC_DMA32: vm_event_item = 5;
pub const vm_event_item_PGALLOC_NORMAL: vm_event_item = 6;
pub const vm_event_item_PGALLOC_MOVABLE: vm_event_item = 7;
pub const vm_event_item_PGALLOC_DEVICE: vm_event_item = 8;
pub const vm_event_item_ALLOCSTALL_DMA: vm_event_item = 9;
pub const vm_event_item_ALLOCSTALL_DMA32: vm_event_item = 10;
pub const vm_event_item_ALLOCSTALL_NORMAL: vm_event_item = 11;
pub const vm_event_item_ALLOCSTALL_MOVABLE: vm_event_item = 12;
pub const vm_event_item_ALLOCSTALL_DEVICE: vm_event_item = 13;
pub const vm_event_item_PGSCAN_SKIP_DMA: vm_event_item = 14;
pub const vm_event_item_PGSCAN_SKIP_DMA32: vm_event_item = 15;
pub const vm_event_item_PGSCAN_SKIP_NORMAL: vm_event_item = 16;
pub const vm_event_item_PGSCAN_SKIP_MOVABLE: vm_event_item = 17;
pub const vm_event_item_PGSCAN_SKIP_DEVICE: vm_event_item = 18;
pub const vm_event_item_PGFREE: vm_event_item = 19;
pub const vm_event_item_PGACTIVATE: vm_event_item = 20;
pub const vm_event_item_PGDEACTIVATE: vm_event_item = 21;
pub const vm_event_item_PGLAZYFREE: vm_event_item = 22;
pub const vm_event_item_PGFAULT: vm_event_item = 23;
pub const vm_event_item_PGMAJFAULT: vm_event_item = 24;
pub const vm_event_item_PGLAZYFREED: vm_event_item = 25;
pub const vm_event_item_PGREFILL: vm_event_item = 26;
pub const vm_event_item_PGREUSE: vm_event_item = 27;
pub const vm_event_item_PGSTEAL_KSWAPD: vm_event_item = 28;
pub const vm_event_item_PGSTEAL_DIRECT: vm_event_item = 29;
pub const vm_event_item_PGSTEAL_KHUGEPAGED: vm_event_item = 30;
pub const vm_event_item_PGSTEAL_PROACTIVE: vm_event_item = 31;
pub const vm_event_item_PGSCAN_KSWAPD: vm_event_item = 32;
pub const vm_event_item_PGSCAN_DIRECT: vm_event_item = 33;
pub const vm_event_item_PGSCAN_KHUGEPAGED: vm_event_item = 34;
pub const vm_event_item_PGSCAN_PROACTIVE: vm_event_item = 35;
pub const vm_event_item_PGSCAN_DIRECT_THROTTLE: vm_event_item = 36;
pub const vm_event_item_PGSCAN_ANON: vm_event_item = 37;
pub const vm_event_item_PGSCAN_FILE: vm_event_item = 38;
pub const vm_event_item_PGSTEAL_ANON: vm_event_item = 39;
pub const vm_event_item_PGSTEAL_FILE: vm_event_item = 40;
pub const vm_event_item_PGSCAN_ZONE_RECLAIM_SUCCESS: vm_event_item = 41;
pub const vm_event_item_PGSCAN_ZONE_RECLAIM_FAILED: vm_event_item = 42;
pub const vm_event_item_PGINODESTEAL: vm_event_item = 43;
pub const vm_event_item_SLABS_SCANNED: vm_event_item = 44;
pub const vm_event_item_KSWAPD_INODESTEAL: vm_event_item = 45;
pub const vm_event_item_KSWAPD_LOW_WMARK_HIT_QUICKLY: vm_event_item = 46;
pub const vm_event_item_KSWAPD_HIGH_WMARK_HIT_QUICKLY: vm_event_item = 47;
pub const vm_event_item_PAGEOUTRUN: vm_event_item = 48;
pub const vm_event_item_PGROTATED: vm_event_item = 49;
pub const vm_event_item_DROP_PAGECACHE: vm_event_item = 50;
pub const vm_event_item_DROP_SLAB: vm_event_item = 51;
pub const vm_event_item_OOM_KILL: vm_event_item = 52;
pub const vm_event_item_NUMA_PTE_UPDATES: vm_event_item = 53;
pub const vm_event_item_NUMA_HUGE_PTE_UPDATES: vm_event_item = 54;
pub const vm_event_item_NUMA_HINT_FAULTS: vm_event_item = 55;
pub const vm_event_item_NUMA_HINT_FAULTS_LOCAL: vm_event_item = 56;
pub const vm_event_item_NUMA_PAGE_MIGRATE: vm_event_item = 57;
pub const vm_event_item_PGMIGRATE_SUCCESS: vm_event_item = 58;
pub const vm_event_item_PGMIGRATE_FAIL: vm_event_item = 59;
pub const vm_event_item_THP_MIGRATION_SUCCESS: vm_event_item = 60;
pub const vm_event_item_THP_MIGRATION_FAIL: vm_event_item = 61;
pub const vm_event_item_THP_MIGRATION_SPLIT: vm_event_item = 62;
pub const vm_event_item_COMPACTMIGRATE_SCANNED: vm_event_item = 63;
pub const vm_event_item_COMPACTFREE_SCANNED: vm_event_item = 64;
pub const vm_event_item_COMPACTISOLATED: vm_event_item = 65;
pub const vm_event_item_COMPACTSTALL: vm_event_item = 66;
pub const vm_event_item_COMPACTFAIL: vm_event_item = 67;
pub const vm_event_item_COMPACTSUCCESS: vm_event_item = 68;
pub const vm_event_item_KCOMPACTD_WAKE: vm_event_item = 69;
pub const vm_event_item_KCOMPACTD_MIGRATE_SCANNED: vm_event_item = 70;
pub const vm_event_item_KCOMPACTD_FREE_SCANNED: vm_event_item = 71;
pub const vm_event_item_HTLB_BUDDY_PGALLOC: vm_event_item = 72;
pub const vm_event_item_HTLB_BUDDY_PGALLOC_FAIL: vm_event_item = 73;
pub const vm_event_item_CMA_ALLOC_SUCCESS: vm_event_item = 74;
pub const vm_event_item_CMA_ALLOC_FAIL: vm_event_item = 75;
pub const vm_event_item_UNEVICTABLE_PGCULLED: vm_event_item = 76;
pub const vm_event_item_UNEVICTABLE_PGSCANNED: vm_event_item = 77;
pub const vm_event_item_UNEVICTABLE_PGRESCUED: vm_event_item = 78;
pub const vm_event_item_UNEVICTABLE_PGMLOCKED: vm_event_item = 79;
pub const vm_event_item_UNEVICTABLE_PGMUNLOCKED: vm_event_item = 80;
pub const vm_event_item_UNEVICTABLE_PGCLEARED: vm_event_item = 81;
pub const vm_event_item_UNEVICTABLE_PGSTRANDED: vm_event_item = 82;
pub const vm_event_item_THP_FAULT_ALLOC: vm_event_item = 83;
pub const vm_event_item_THP_FAULT_FALLBACK: vm_event_item = 84;
pub const vm_event_item_THP_FAULT_FALLBACK_CHARGE: vm_event_item = 85;
pub const vm_event_item_THP_COLLAPSE_ALLOC: vm_event_item = 86;
pub const vm_event_item_THP_COLLAPSE_ALLOC_FAILED: vm_event_item = 87;
pub const vm_event_item_THP_FILE_ALLOC: vm_event_item = 88;
pub const vm_event_item_THP_FILE_FALLBACK: vm_event_item = 89;
pub const vm_event_item_THP_FILE_FALLBACK_CHARGE: vm_event_item = 90;
pub const vm_event_item_THP_FILE_MAPPED: vm_event_item = 91;
pub const vm_event_item_THP_SPLIT_PAGE: vm_event_item = 92;
pub const vm_event_item_THP_SPLIT_PAGE_FAILED: vm_event_item = 93;
pub const vm_event_item_THP_DEFERRED_SPLIT_PAGE: vm_event_item = 94;
pub const vm_event_item_THP_UNDERUSED_SPLIT_PAGE: vm_event_item = 95;
pub const vm_event_item_THP_SPLIT_PMD: vm_event_item = 96;
pub const vm_event_item_THP_SCAN_EXCEED_NONE_PTE: vm_event_item = 97;
pub const vm_event_item_THP_SCAN_EXCEED_SWAP_PTE: vm_event_item = 98;
pub const vm_event_item_THP_SCAN_EXCEED_SHARED_PTE: vm_event_item = 99;
pub const vm_event_item_THP_ZERO_PAGE_ALLOC: vm_event_item = 100;
pub const vm_event_item_THP_ZERO_PAGE_ALLOC_FAILED: vm_event_item = 101;
pub const vm_event_item_THP_SWPOUT: vm_event_item = 102;
pub const vm_event_item_THP_SWPOUT_FALLBACK: vm_event_item = 103;
pub const vm_event_item_BALLOON_INFLATE: vm_event_item = 104;
pub const vm_event_item_BALLOON_DEFLATE: vm_event_item = 105;
pub const vm_event_item_BALLOON_MIGRATE: vm_event_item = 106;
pub const vm_event_item_SWAP_RA: vm_event_item = 107;
pub const vm_event_item_SWAP_RA_HIT: vm_event_item = 108;
pub const vm_event_item_SWPIN_ZERO: vm_event_item = 109;
pub const vm_event_item_SWPOUT_ZERO: vm_event_item = 110;
pub const vm_event_item_KSM_SWPIN_COPY: vm_event_item = 111;
pub const vm_event_item_COW_KSM: vm_event_item = 112;
pub const vm_event_item_ZSWPIN: vm_event_item = 113;
pub const vm_event_item_ZSWPOUT: vm_event_item = 114;
pub const vm_event_item_ZSWPWB: vm_event_item = 115;
pub const vm_event_item_NR_VM_EVENT_ITEMS: vm_event_item = 116;
pub type vm_event_item = ffi::c_uint;
extern "C" {
    pub static mut vm_numa_stat_key: static_key_true;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct reclaim_stat {
    pub nr_dirty: ffi::c_uint,
    pub nr_unqueued_dirty: ffi::c_uint,
    pub nr_congested: ffi::c_uint,
    pub nr_writeback: ffi::c_uint,
    pub nr_immediate: ffi::c_uint,
    pub nr_pageout: ffi::c_uint,
    pub nr_activate: [ffi::c_uint; 2usize],
    pub nr_ref_keep: ffi::c_uint,
    pub nr_unmap_fail: ffi::c_uint,
    pub nr_lazyfree_fail: ffi::c_uint,
    pub nr_demoted: ffi::c_uint,
}
pub const vm_stat_item_NR_DIRTY_THRESHOLD: vm_stat_item = 0;
pub const vm_stat_item_NR_DIRTY_BG_THRESHOLD: vm_stat_item = 1;
pub const vm_stat_item_NR_MEMMAP_PAGES: vm_stat_item = 2;
pub const vm_stat_item_NR_MEMMAP_BOOT_PAGES: vm_stat_item = 3;
pub const vm_stat_item_NR_VM_STAT_ITEMS: vm_stat_item = 4;
pub type vm_stat_item = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct vm_event_state {
    pub event: [ffi::c_ulong; 116usize],
}
impl Default for vm_event_state {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut vm_event_states: vm_event_state;
}
extern "C" {
    pub fn all_vm_events(arg1: *mut ffi::c_ulong);
}
extern "C" {
    pub fn vm_events_fold_cpu(cpu: ffi::c_int);
}
extern "C" {
    pub static mut vm_zone_stat: [atomic_long_t; 12usize];
}
extern "C" {
    pub static mut vm_node_stat: [atomic_long_t; 50usize];
}
extern "C" {
    pub static mut vm_numa_event: [atomic_long_t; 6usize];
}
extern "C" {
    pub fn sum_zone_node_page_state(node: ffi::c_int, item: zone_stat_item) -> ffi::c_ulong;
}
extern "C" {
    pub fn sum_zone_numa_event_state(node: ffi::c_int, item: numa_stat_item) -> ffi::c_ulong;
}
extern "C" {
    pub fn node_page_state(pgdat: *mut pglist_data, item: node_stat_item) -> ffi::c_ulong;
}
extern "C" {
    pub fn node_page_state_pages(pgdat: *mut pglist_data, item: node_stat_item) -> ffi::c_ulong;
}
extern "C" {
    pub fn fold_vm_numa_events();
}
extern "C" {
    pub fn __mod_zone_page_state(arg1: *mut zone, item: zone_stat_item, arg2: ffi::c_long);
}
extern "C" {
    pub fn __inc_zone_page_state(arg1: *mut page, arg2: zone_stat_item);
}
extern "C" {
    pub fn __dec_zone_page_state(arg1: *mut page, arg2: zone_stat_item);
}
extern "C" {
    pub fn __mod_node_page_state(arg1: *mut pglist_data, item: node_stat_item, arg2: ffi::c_long);
}
extern "C" {
    pub fn __inc_node_page_state(arg1: *mut page, arg2: node_stat_item);
}
extern "C" {
    pub fn __dec_node_page_state(arg1: *mut page, arg2: node_stat_item);
}
extern "C" {
    pub fn mod_zone_page_state(arg1: *mut zone, arg2: zone_stat_item, arg3: ffi::c_long);
}
extern "C" {
    pub fn inc_zone_page_state(arg1: *mut page, arg2: zone_stat_item);
}
extern "C" {
    pub fn dec_zone_page_state(arg1: *mut page, arg2: zone_stat_item);
}
extern "C" {
    pub fn mod_node_page_state(arg1: *mut pglist_data, arg2: node_stat_item, arg3: ffi::c_long);
}
extern "C" {
    pub fn inc_node_page_state(arg1: *mut page, arg2: node_stat_item);
}
extern "C" {
    pub fn dec_node_page_state(arg1: *mut page, arg2: node_stat_item);
}
extern "C" {
    pub fn inc_node_state(arg1: *mut pglist_data, arg2: node_stat_item);
}
extern "C" {
    pub fn __inc_zone_state(arg1: *mut zone, arg2: zone_stat_item);
}
extern "C" {
    pub fn __inc_node_state(arg1: *mut pglist_data, arg2: node_stat_item);
}
extern "C" {
    pub fn dec_zone_state(arg1: *mut zone, arg2: zone_stat_item);
}
extern "C" {
    pub fn __dec_zone_state(arg1: *mut zone, arg2: zone_stat_item);
}
extern "C" {
    pub fn __dec_node_state(arg1: *mut pglist_data, arg2: node_stat_item);
}
extern "C" {
    pub fn quiet_vmstat();
}
extern "C" {
    pub fn cpu_vm_stats_fold(cpu: ffi::c_int);
}
extern "C" {
    pub fn refresh_zone_stat_thresholds();
}
extern "C" {
    pub fn drain_zonestat(zone: *mut zone, arg1: *mut per_cpu_zonestat);
}
extern "C" {
    pub fn calculate_pressure_threshold(zone: *mut zone) -> ffi::c_int;
}
extern "C" {
    pub fn calculate_normal_threshold(zone: *mut zone) -> ffi::c_int;
}
extern "C" {
    pub fn set_pgdat_percpu_threshold(
        pgdat: *mut pg_data_t,
        calculate_pressure: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut zone) -> ffi::c_int,
        >,
    );
}
extern "C" {
    pub static vmstat_text: [*const ffi::c_char; 0usize];
}
extern "C" {
    pub fn __mod_lruvec_state(lruvec: *mut lruvec, idx: node_stat_item, val: ffi::c_int);
}
extern "C" {
    pub fn __lruvec_stat_mod_folio(folio: *mut folio, idx: node_stat_item, val: ffi::c_int);
}
extern "C" {
    pub fn memmap_boot_pages_add(delta: ffi::c_long);
}
extern "C" {
    pub fn memmap_pages_add(delta: ffi::c_long);
}
extern "C" {
    pub fn pagefault_out_of_memory();
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct zap_details {
    pub single_folio: *mut folio,
    pub even_cows: bool_,
    pub reclaim_pt: bool_,
    pub zap_flags: zap_flags_t,
}
impl Default for zap_details {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn sched_mm_cid_before_execve(t: *mut task_struct);
}
extern "C" {
    pub fn sched_mm_cid_after_execve(t: *mut task_struct);
}
extern "C" {
    pub fn sched_mm_cid_fork(t: *mut task_struct);
}
extern "C" {
    pub fn sched_mm_cid_exit_signals(t: *mut task_struct);
}
extern "C" {
    pub fn can_do_mlock() -> bool_;
}
extern "C" {
    pub fn user_shm_lock(arg1: usize, arg2: *mut ucounts) -> ffi::c_int;
}
extern "C" {
    pub fn user_shm_unlock(arg1: usize, arg2: *mut ucounts);
}
extern "C" {
    pub fn vm_normal_folio(vma: *mut vm_area_struct, addr: ffi::c_ulong, pte: pte_t) -> *mut folio;
}
extern "C" {
    pub fn vm_normal_page(vma: *mut vm_area_struct, addr: ffi::c_ulong, pte: pte_t) -> *mut page;
}
extern "C" {
    pub fn vm_normal_folio_pmd(
        vma: *mut vm_area_struct,
        addr: ffi::c_ulong,
        pmd: pmd_t,
    ) -> *mut folio;
}
extern "C" {
    pub fn vm_normal_page_pmd(
        vma: *mut vm_area_struct,
        addr: ffi::c_ulong,
        pmd: pmd_t,
    ) -> *mut page;
}
extern "C" {
    pub fn zap_vma_ptes(vma: *mut vm_area_struct, address: ffi::c_ulong, size: ffi::c_ulong);
}
extern "C" {
    pub fn zap_page_range_single(
        vma: *mut vm_area_struct,
        address: ffi::c_ulong,
        size: ffi::c_ulong,
        details: *mut zap_details,
    );
}
extern "C" {
    pub fn unmap_vmas(
        tlb: *mut mmu_gather,
        mas: *mut ma_state,
        start_vma: *mut vm_area_struct,
        start: ffi::c_ulong,
        end: ffi::c_ulong,
        tree_end: ffi::c_ulong,
        mm_wr_locked: bool_,
    );
}
extern "C" {
    pub fn free_pgd_range(
        tlb: *mut mmu_gather,
        addr: ffi::c_ulong,
        end: ffi::c_ulong,
        floor: ffi::c_ulong,
        ceiling: ffi::c_ulong,
    );
}
extern "C" {
    pub fn copy_page_range(
        dst_vma: *mut vm_area_struct,
        src_vma: *mut vm_area_struct,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn generic_access_phys(
        vma: *mut vm_area_struct,
        addr: ffi::c_ulong,
        buf: *mut ffi::c_void,
        len: ffi::c_int,
        write: ffi::c_int,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct follow_pfnmap_args {
    pub vma: *mut vm_area_struct,
    pub address: ffi::c_ulong,
    pub lock: *mut spinlock_t,
    pub ptep: *mut pte_t,
    pub pfn: ffi::c_ulong,
    pub addr_mask: ffi::c_ulong,
    pub pgprot: pgprot_t,
    pub writable: bool_,
    pub special: bool_,
}
impl Default for follow_pfnmap_args {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn follow_pfnmap_start(args: *mut follow_pfnmap_args) -> ffi::c_int;
}
extern "C" {
    pub fn follow_pfnmap_end(args: *mut follow_pfnmap_args);
}
extern "C" {
    pub fn truncate_pagecache(inode: *mut inode, new: loff_t);
}
extern "C" {
    pub fn truncate_setsize(inode: *mut inode, newsize: loff_t);
}
extern "C" {
    pub fn pagecache_isize_extended(inode: *mut inode, from: loff_t, to: loff_t);
}
extern "C" {
    pub fn truncate_pagecache_range(inode: *mut inode, offset: loff_t, end: loff_t);
}
extern "C" {
    pub fn generic_error_remove_folio(mapping: *mut address_space, folio: *mut folio)
        -> ffi::c_int;
}
extern "C" {
    pub fn lock_mm_and_find_vma(
        mm: *mut mm_struct,
        address: ffi::c_ulong,
        regs: *mut pt_regs,
    ) -> *mut vm_area_struct;
}
extern "C" {
    pub fn handle_mm_fault(
        vma: *mut vm_area_struct,
        address: ffi::c_ulong,
        flags: ffi::c_uint,
        regs: *mut pt_regs,
    ) -> vm_fault_t;
}
extern "C" {
    pub fn fixup_user_fault(
        mm: *mut mm_struct,
        address: ffi::c_ulong,
        fault_flags: ffi::c_uint,
        unlocked: *mut bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn unmap_mapping_pages(
        mapping: *mut address_space,
        start: ffi::c_ulong,
        nr: ffi::c_ulong,
        even_cows: bool_,
    );
}
extern "C" {
    pub fn unmap_mapping_range(
        mapping: *mut address_space,
        holebegin: loff_t,
        holelen: loff_t,
        even_cows: ffi::c_int,
    );
}
extern "C" {
    pub fn access_process_vm(
        tsk: *mut task_struct,
        addr: ffi::c_ulong,
        buf: *mut ffi::c_void,
        len: ffi::c_int,
        gup_flags: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn access_remote_vm(
        mm: *mut mm_struct,
        addr: ffi::c_ulong,
        buf: *mut ffi::c_void,
        len: ffi::c_int,
        gup_flags: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn copy_remote_vm_str(
        tsk: *mut task_struct,
        addr: ffi::c_ulong,
        buf: *mut ffi::c_void,
        len: ffi::c_int,
        gup_flags: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn get_user_pages_remote(
        mm: *mut mm_struct,
        start: ffi::c_ulong,
        nr_pages: ffi::c_ulong,
        gup_flags: ffi::c_uint,
        pages: *mut *mut page,
        locked: *mut ffi::c_int,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn pin_user_pages_remote(
        mm: *mut mm_struct,
        start: ffi::c_ulong,
        nr_pages: ffi::c_ulong,
        gup_flags: ffi::c_uint,
        pages: *mut *mut page,
        locked: *mut ffi::c_int,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn get_user_pages(
        start: ffi::c_ulong,
        nr_pages: ffi::c_ulong,
        gup_flags: ffi::c_uint,
        pages: *mut *mut page,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn pin_user_pages(
        start: ffi::c_ulong,
        nr_pages: ffi::c_ulong,
        gup_flags: ffi::c_uint,
        pages: *mut *mut page,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn get_user_pages_unlocked(
        start: ffi::c_ulong,
        nr_pages: ffi::c_ulong,
        pages: *mut *mut page,
        gup_flags: ffi::c_uint,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn pin_user_pages_unlocked(
        start: ffi::c_ulong,
        nr_pages: ffi::c_ulong,
        pages: *mut *mut page,
        gup_flags: ffi::c_uint,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn memfd_pin_folios(
        memfd: *mut file,
        start: loff_t,
        end: loff_t,
        folios: *mut *mut folio,
        max_folios: ffi::c_uint,
        offset: *mut ffi::c_ulong,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn folio_add_pins(folio: *mut folio, pins: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn get_user_pages_fast(
        start: ffi::c_ulong,
        nr_pages: ffi::c_int,
        gup_flags: ffi::c_uint,
        pages: *mut *mut page,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pin_user_pages_fast(
        start: ffi::c_ulong,
        nr_pages: ffi::c_int,
        gup_flags: ffi::c_uint,
        pages: *mut *mut page,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn folio_add_pin(folio: *mut folio);
}
extern "C" {
    pub fn account_locked_vm(mm: *mut mm_struct, pages: ffi::c_ulong, inc: bool_) -> ffi::c_int;
}
extern "C" {
    pub fn __account_locked_vm(
        mm: *mut mm_struct,
        pages: ffi::c_ulong,
        inc: bool_,
        task: *mut task_struct,
        bypass_rlim: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn get_dump_page(addr: ffi::c_ulong, locked: *mut ffi::c_int) -> *mut page;
}
extern "C" {
    pub fn folio_mark_dirty(folio: *mut folio) -> bool_;
}
extern "C" {
    pub fn folio_mark_dirty_lock(folio: *mut folio) -> bool_;
}
extern "C" {
    pub fn set_page_dirty(page: *mut page) -> bool_;
}
extern "C" {
    pub fn set_page_dirty_lock(page: *mut page) -> ffi::c_int;
}
extern "C" {
    pub fn get_cmdline(
        task: *mut task_struct,
        buffer: *mut ffi::c_char,
        buflen: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn can_change_pte_writable(
        vma: *mut vm_area_struct,
        addr: ffi::c_ulong,
        pte: pte_t,
    ) -> bool_;
}
extern "C" {
    pub fn change_protection(
        tlb: *mut mmu_gather,
        vma: *mut vm_area_struct,
        start: ffi::c_ulong,
        end: ffi::c_ulong,
        cp_flags: ffi::c_ulong,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn mprotect_fixup(
        vmi: *mut vma_iterator,
        tlb: *mut mmu_gather,
        vma: *mut vm_area_struct,
        pprev: *mut *mut vm_area_struct,
        start: ffi::c_ulong,
        end: ffi::c_ulong,
        newflags: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn get_user_pages_fast_only(
        start: ffi::c_ulong,
        nr_pages: ffi::c_int,
        gup_flags: ffi::c_uint,
        pages: *mut *mut page,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mm_trace_rss_stat(mm: *mut mm_struct, member: ffi::c_int);
}
extern "C" {
    pub fn __get_locked_pte(
        mm: *mut mm_struct,
        addr: ffi::c_ulong,
        ptl: *mut *mut spinlock_t,
    ) -> *mut pte_t;
}
extern "C" {
    pub fn __pud_alloc(mm: *mut mm_struct, p4d: *mut p4d_t, address: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn __pmd_alloc(mm: *mut mm_struct, pud: *mut pud_t, address: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn __pte_alloc(mm: *mut mm_struct, pmd: *mut pmd_t) -> ffi::c_int;
}
extern "C" {
    pub fn __pte_alloc_kernel(pmd: *mut pmd_t) -> ffi::c_int;
}
extern "C" {
    pub fn ___pte_offset_map(
        pmd: *mut pmd_t,
        addr: ffi::c_ulong,
        pmdvalp: *mut pmd_t,
    ) -> *mut pte_t;
}
extern "C" {
    pub fn __pte_offset_map_lock(
        mm: *mut mm_struct,
        pmd: *mut pmd_t,
        addr: ffi::c_ulong,
        ptlp: *mut *mut spinlock_t,
    ) -> *mut pte_t;
}
extern "C" {
    pub fn pte_offset_map_ro_nolock(
        mm: *mut mm_struct,
        pmd: *mut pmd_t,
        addr: ffi::c_ulong,
        ptlp: *mut *mut spinlock_t,
    ) -> *mut pte_t;
}
extern "C" {
    pub fn pte_offset_map_rw_nolock(
        mm: *mut mm_struct,
        pmd: *mut pmd_t,
        addr: ffi::c_ulong,
        pmdvalp: *mut pmd_t,
        ptlp: *mut *mut spinlock_t,
    ) -> *mut pte_t;
}
extern "C" {
    pub fn pagecache_init();
}
extern "C" {
    pub fn free_initmem();
}
extern "C" {
    pub fn free_reserved_area(
        start: *mut ffi::c_void,
        end: *mut ffi::c_void,
        poison: ffi::c_int,
        s: *const ffi::c_char,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn adjust_managed_page_count(page: *mut page, count: ffi::c_long);
}
extern "C" {
    pub fn reserve_bootmem_region(start: phys_addr_t, end: phys_addr_t, nid: ffi::c_int);
}
extern "C" {
    pub fn free_reserved_page(page: *mut page);
}
extern "C" {
    pub fn free_area_init(max_zone_pfn: *mut ffi::c_ulong);
}
extern "C" {
    pub fn node_map_pfn_alignment() -> ffi::c_ulong;
}
extern "C" {
    pub fn absent_pages_in_range(start_pfn: ffi::c_ulong, end_pfn: ffi::c_ulong) -> ffi::c_ulong;
}
extern "C" {
    pub fn get_pfn_range_for_nid(
        nid: ffi::c_uint,
        start_pfn: *mut ffi::c_ulong,
        end_pfn: *mut ffi::c_ulong,
    );
}
extern "C" {
    pub fn early_pfn_to_nid(pfn: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn mem_init();
}
extern "C" {
    pub fn mmap_init();
}
extern "C" {
    pub fn __show_mem(flags: ffi::c_uint, nodemask: *mut nodemask_t, max_zone_idx: ffi::c_int);
}
extern "C" {
    pub fn si_mem_available() -> ffi::c_long;
}
extern "C" {
    pub fn si_meminfo(val: *mut sysinfo);
}
extern "C" {
    pub fn si_meminfo_node(val: *mut sysinfo, nid: ffi::c_int);
}
extern "C" {
    pub fn warn_alloc(gfp_mask: gfp_t, nodemask: *mut nodemask_t, fmt: *const ffi::c_char, ...);
}
extern "C" {
    pub fn setup_per_cpu_pageset();
}
extern "C" {
    pub static mut mmap_pages_allocated: atomic_long_t;
}
extern "C" {
    pub fn nommu_shrink_inode_mappings(arg1: *mut inode, arg2: usize, arg3: usize) -> ffi::c_int;
}
extern "C" {
    pub fn vma_interval_tree_insert(node: *mut vm_area_struct, root: *mut rb_root_cached);
}
extern "C" {
    pub fn vma_interval_tree_insert_after(
        node: *mut vm_area_struct,
        prev: *mut vm_area_struct,
        root: *mut rb_root_cached,
    );
}
extern "C" {
    pub fn vma_interval_tree_remove(node: *mut vm_area_struct, root: *mut rb_root_cached);
}
extern "C" {
    pub fn vma_interval_tree_iter_first(
        root: *mut rb_root_cached,
        start: ffi::c_ulong,
        last: ffi::c_ulong,
    ) -> *mut vm_area_struct;
}
extern "C" {
    pub fn vma_interval_tree_iter_next(
        node: *mut vm_area_struct,
        start: ffi::c_ulong,
        last: ffi::c_ulong,
    ) -> *mut vm_area_struct;
}
extern "C" {
    pub fn anon_vma_interval_tree_insert(node: *mut anon_vma_chain, root: *mut rb_root_cached);
}
extern "C" {
    pub fn anon_vma_interval_tree_remove(node: *mut anon_vma_chain, root: *mut rb_root_cached);
}
extern "C" {
    pub fn anon_vma_interval_tree_iter_first(
        root: *mut rb_root_cached,
        start: ffi::c_ulong,
        last: ffi::c_ulong,
    ) -> *mut anon_vma_chain;
}
extern "C" {
    pub fn anon_vma_interval_tree_iter_next(
        node: *mut anon_vma_chain,
        start: ffi::c_ulong,
        last: ffi::c_ulong,
    ) -> *mut anon_vma_chain;
}
extern "C" {
    pub fn __vm_enough_memory(
        mm: *mut mm_struct,
        pages: ffi::c_long,
        cap_sys_admin: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn insert_vm_struct(arg1: *mut mm_struct, arg2: *mut vm_area_struct) -> ffi::c_int;
}
extern "C" {
    pub fn exit_mmap(arg1: *mut mm_struct);
}
extern "C" {
    pub fn relocate_vma_down(vma: *mut vm_area_struct, shift: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn mmap_read_lock_maybe_expand(
        mm: *mut mm_struct,
        vma: *mut vm_area_struct,
        addr: ffi::c_ulong,
        write: bool_,
    ) -> bool_;
}
extern "C" {
    pub fn mm_take_all_locks(mm: *mut mm_struct) -> ffi::c_int;
}
extern "C" {
    pub fn mm_drop_all_locks(mm: *mut mm_struct);
}
extern "C" {
    pub fn set_mm_exe_file(mm: *mut mm_struct, new_exe_file: *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn replace_mm_exe_file(mm: *mut mm_struct, new_exe_file: *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn get_mm_exe_file(mm: *mut mm_struct) -> *mut file;
}
extern "C" {
    pub fn get_task_exe_file(task: *mut task_struct) -> *mut file;
}
extern "C" {
    pub fn may_expand_vm(arg1: *mut mm_struct, arg2: vm_flags_t, npages: ffi::c_ulong) -> bool_;
}
extern "C" {
    pub fn vm_stat_account(arg1: *mut mm_struct, arg2: vm_flags_t, npages: ffi::c_long);
}
extern "C" {
    pub fn vma_is_special_mapping(
        vma: *const vm_area_struct,
        sm: *const vm_special_mapping,
    ) -> bool_;
}
extern "C" {
    pub fn _install_special_mapping(
        mm: *mut mm_struct,
        addr: ffi::c_ulong,
        len: ffi::c_ulong,
        flags: ffi::c_ulong,
        spec: *const vm_special_mapping,
    ) -> *mut vm_area_struct;
}
extern "C" {
    pub fn randomize_stack_top(stack_top: ffi::c_ulong) -> ffi::c_ulong;
}
extern "C" {
    pub fn randomize_page(start: ffi::c_ulong, range: ffi::c_ulong) -> ffi::c_ulong;
}
extern "C" {
    pub fn __get_unmapped_area(
        file: *mut file,
        addr: ffi::c_ulong,
        len: ffi::c_ulong,
        pgoff: ffi::c_ulong,
        flags: ffi::c_ulong,
        vm_flags: vm_flags_t,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn do_mmap(
        file: *mut file,
        addr: ffi::c_ulong,
        len: ffi::c_ulong,
        prot: ffi::c_ulong,
        flags: ffi::c_ulong,
        vm_flags: vm_flags_t,
        pgoff: ffi::c_ulong,
        populate: *mut ffi::c_ulong,
        uf: *mut list_head,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn do_vmi_munmap(
        vmi: *mut vma_iterator,
        mm: *mut mm_struct,
        start: ffi::c_ulong,
        len: usize,
        uf: *mut list_head,
        unlock: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn do_vmi_align_munmap(
        vmi: *mut vma_iterator,
        vma: *mut vm_area_struct,
        mm: *mut mm_struct,
        start: ffi::c_ulong,
        end: ffi::c_ulong,
        uf: *mut list_head,
        unlock: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn do_munmap(
        arg1: *mut mm_struct,
        arg2: ffi::c_ulong,
        arg3: usize,
        uf: *mut list_head,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn do_madvise(
        mm: *mut mm_struct,
        start: ffi::c_ulong,
        len_in: usize,
        behavior: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __mm_populate(
        addr: ffi::c_ulong,
        len: ffi::c_ulong,
        ignore_errors: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn vm_brk_flags(arg1: ffi::c_ulong, arg2: ffi::c_ulong, arg3: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn vm_munmap(arg1: ffi::c_ulong, arg2: usize) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn vm_mmap(
        arg1: *mut file,
        arg2: ffi::c_ulong,
        arg3: ffi::c_ulong,
        arg4: ffi::c_ulong,
        arg5: ffi::c_ulong,
        arg6: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct vm_unmapped_area_info {
    pub flags: ffi::c_ulong,
    pub length: ffi::c_ulong,
    pub low_limit: ffi::c_ulong,
    pub high_limit: ffi::c_ulong,
    pub align_mask: ffi::c_ulong,
    pub align_offset: ffi::c_ulong,
    pub start_gap: ffi::c_ulong,
}
extern "C" {
    pub fn vm_unmapped_area(info: *mut vm_unmapped_area_info) -> ffi::c_ulong;
}
extern "C" {
    pub fn truncate_inode_pages(arg1: *mut address_space, arg2: loff_t);
}
extern "C" {
    pub fn truncate_inode_pages_range(arg1: *mut address_space, lstart: loff_t, lend: loff_t);
}
extern "C" {
    pub fn truncate_inode_pages_final(arg1: *mut address_space);
}
extern "C" {
    pub fn filemap_fault(vmf: *mut vm_fault) -> vm_fault_t;
}
extern "C" {
    pub fn filemap_map_pages(
        vmf: *mut vm_fault,
        start_pgoff: ffi::c_ulong,
        end_pgoff: ffi::c_ulong,
    ) -> vm_fault_t;
}
extern "C" {
    pub fn filemap_page_mkwrite(vmf: *mut vm_fault) -> vm_fault_t;
}
extern "C" {
    pub static mut stack_guard_gap: ffi::c_ulong;
}
extern "C" {
    pub fn expand_stack_locked(vma: *mut vm_area_struct, address: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn expand_stack(mm: *mut mm_struct, addr: ffi::c_ulong) -> *mut vm_area_struct;
}
extern "C" {
    pub fn find_vma(mm: *mut mm_struct, addr: ffi::c_ulong) -> *mut vm_area_struct;
}
extern "C" {
    pub fn find_vma_prev(
        mm: *mut mm_struct,
        addr: ffi::c_ulong,
        pprev: *mut *mut vm_area_struct,
    ) -> *mut vm_area_struct;
}
extern "C" {
    pub fn find_vma_intersection(
        mm: *mut mm_struct,
        start_addr: ffi::c_ulong,
        end_addr: ffi::c_ulong,
    ) -> *mut vm_area_struct;
}
extern "C" {
    pub fn vm_get_page_prot(vm_flags: ffi::c_ulong) -> pgprot_t;
}
extern "C" {
    pub fn vma_set_page_prot(vma: *mut vm_area_struct);
}
extern "C" {
    pub fn vma_set_file(vma: *mut vm_area_struct, file: *mut file);
}
extern "C" {
    pub fn change_prot_numa(
        vma: *mut vm_area_struct,
        start: ffi::c_ulong,
        end: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn find_extend_vma_locked(arg1: *mut mm_struct, addr: ffi::c_ulong) -> *mut vm_area_struct;
}
extern "C" {
    pub fn remap_pfn_range(
        arg1: *mut vm_area_struct,
        addr: ffi::c_ulong,
        pfn: ffi::c_ulong,
        size: ffi::c_ulong,
        arg2: pgprot_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn remap_pfn_range_notrack(
        vma: *mut vm_area_struct,
        addr: ffi::c_ulong,
        pfn: ffi::c_ulong,
        size: ffi::c_ulong,
        prot: pgprot_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vm_insert_page(
        arg1: *mut vm_area_struct,
        addr: ffi::c_ulong,
        arg2: *mut page,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vm_insert_pages(
        vma: *mut vm_area_struct,
        addr: ffi::c_ulong,
        pages: *mut *mut page,
        num: *mut ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vm_map_pages(
        vma: *mut vm_area_struct,
        pages: *mut *mut page,
        num: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vm_map_pages_zero(
        vma: *mut vm_area_struct,
        pages: *mut *mut page,
        num: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vmf_insert_page_mkwrite(vmf: *mut vm_fault, page: *mut page, write: bool_)
        -> vm_fault_t;
}
extern "C" {
    pub fn vmf_insert_pfn(
        vma: *mut vm_area_struct,
        addr: ffi::c_ulong,
        pfn: ffi::c_ulong,
    ) -> vm_fault_t;
}
extern "C" {
    pub fn vmf_insert_pfn_prot(
        vma: *mut vm_area_struct,
        addr: ffi::c_ulong,
        pfn: ffi::c_ulong,
        pgprot: pgprot_t,
    ) -> vm_fault_t;
}
extern "C" {
    pub fn vmf_insert_mixed(vma: *mut vm_area_struct, addr: ffi::c_ulong, pfn: pfn_t)
        -> vm_fault_t;
}
extern "C" {
    pub fn vmf_insert_mixed_mkwrite(
        vma: *mut vm_area_struct,
        addr: ffi::c_ulong,
        pfn: pfn_t,
    ) -> vm_fault_t;
}
extern "C" {
    pub fn vm_iomap_memory(
        vma: *mut vm_area_struct,
        start: phys_addr_t,
        len: ffi::c_ulong,
    ) -> ffi::c_int;
}
pub type pte_fn_t = ::core::option::Option<
    unsafe extern "C" fn(pte: *mut pte_t, addr: ffi::c_ulong, data: *mut ffi::c_void) -> ffi::c_int,
>;
extern "C" {
    pub fn apply_to_page_range(
        mm: *mut mm_struct,
        address: ffi::c_ulong,
        size: ffi::c_ulong,
        fn_: pte_fn_t,
        data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn apply_to_existing_page_range(
        mm: *mut mm_struct,
        address: ffi::c_ulong,
        size: ffi::c_ulong,
        fn_: pte_fn_t,
        data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __kernel_poison_pages(page: *mut page, numpages: ffi::c_int);
}
extern "C" {
    pub fn __kernel_unpoison_pages(page: *mut page, numpages: ffi::c_int);
}
extern "C" {
    pub static mut _page_poisoning_enabled_early: bool_;
}
extern "C" {
    pub static mut _page_poisoning_enabled: static_key_false;
}
extern "C" {
    pub static mut init_on_alloc: static_key_true;
}
extern "C" {
    pub static mut init_on_free: static_key_false;
}
extern "C" {
    pub static mut _debug_pagealloc_enabled_early: bool_;
}
extern "C" {
    pub static mut _debug_pagealloc_enabled: static_key_false;
}
extern "C" {
    pub fn __kernel_map_pages(page: *mut page, numpages: ffi::c_int, enable: ffi::c_int);
}
extern "C" {
    pub fn process_shares_mm(p: *mut task_struct, mm: *mut mm_struct) -> bool_;
}
extern "C" {
    pub fn drop_slab();
}
extern "C" {
    pub static mut randomize_va_space: ffi::c_int;
}
extern "C" {
    pub fn arch_vma_name(vma: *mut vm_area_struct) -> *const ffi::c_char;
}
extern "C" {
    pub fn print_vma_addr(prefix: *mut ffi::c_char, rip: ffi::c_ulong);
}
extern "C" {
    pub fn sparse_buffer_alloc(size: ffi::c_ulong) -> *mut ffi::c_void;
}
extern "C" {
    pub fn section_map_size() -> ffi::c_ulong;
}
extern "C" {
    pub fn __populate_section_memmap(
        pfn: ffi::c_ulong,
        nr_pages: ffi::c_ulong,
        nid: ffi::c_int,
        altmap: *mut vmem_altmap,
        pgmap: *mut dev_pagemap,
    ) -> *mut page;
}
extern "C" {
    pub fn vmemmap_pgd_populate(addr: ffi::c_ulong, node: ffi::c_int) -> *mut pgd_t;
}
extern "C" {
    pub fn vmemmap_p4d_populate(
        pgd: *mut pgd_t,
        addr: ffi::c_ulong,
        node: ffi::c_int,
    ) -> *mut p4d_t;
}
extern "C" {
    pub fn vmemmap_pud_populate(
        p4d: *mut p4d_t,
        addr: ffi::c_ulong,
        node: ffi::c_int,
    ) -> *mut pud_t;
}
extern "C" {
    pub fn vmemmap_pmd_populate(
        pud: *mut pud_t,
        addr: ffi::c_ulong,
        node: ffi::c_int,
    ) -> *mut pmd_t;
}
extern "C" {
    pub fn vmemmap_pte_populate(
        pmd: *mut pmd_t,
        addr: ffi::c_ulong,
        node: ffi::c_int,
        altmap: *mut vmem_altmap,
        ptpfn: ffi::c_ulong,
        flags: ffi::c_ulong,
    ) -> *mut pte_t;
}
extern "C" {
    pub fn vmemmap_alloc_block(size: ffi::c_ulong, node: ffi::c_int) -> *mut ffi::c_void;
}
extern "C" {
    pub fn vmemmap_alloc_block_buf(
        size: ffi::c_ulong,
        node: ffi::c_int,
        altmap: *mut vmem_altmap,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn vmemmap_verify(
        arg1: *mut pte_t,
        arg2: ffi::c_int,
        arg3: ffi::c_ulong,
        arg4: ffi::c_ulong,
    );
}
extern "C" {
    pub fn vmemmap_set_pmd(
        pmd: *mut pmd_t,
        p: *mut ffi::c_void,
        node: ffi::c_int,
        addr: ffi::c_ulong,
        next: ffi::c_ulong,
    );
}
extern "C" {
    pub fn vmemmap_check_pmd(
        pmd: *mut pmd_t,
        node: ffi::c_int,
        addr: ffi::c_ulong,
        next: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vmemmap_populate_basepages(
        start: ffi::c_ulong,
        end: ffi::c_ulong,
        node: ffi::c_int,
        altmap: *mut vmem_altmap,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vmemmap_populate_hugepages(
        start: ffi::c_ulong,
        end: ffi::c_ulong,
        node: ffi::c_int,
        altmap: *mut vmem_altmap,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vmemmap_populate(
        start: ffi::c_ulong,
        end: ffi::c_ulong,
        node: ffi::c_int,
        altmap: *mut vmem_altmap,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vmemmap_populate_hvo(
        start: ffi::c_ulong,
        end: ffi::c_ulong,
        node: ffi::c_int,
        headsize: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vmemmap_undo_hvo(
        start: ffi::c_ulong,
        end: ffi::c_ulong,
        node: ffi::c_int,
        headsize: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vmemmap_wrprotect_hvo(
        start: ffi::c_ulong,
        end: ffi::c_ulong,
        node: ffi::c_int,
        headsize: ffi::c_ulong,
    );
}
extern "C" {
    pub fn vmemmap_populate_print_last();
}
extern "C" {
    pub fn vmemmap_free(start: ffi::c_ulong, end: ffi::c_ulong, altmap: *mut vmem_altmap);
}
pub const mf_flags_MF_COUNT_INCREASED: mf_flags = 1;
pub const mf_flags_MF_ACTION_REQUIRED: mf_flags = 2;
pub const mf_flags_MF_MUST_KILL: mf_flags = 4;
pub const mf_flags_MF_SOFT_OFFLINE: mf_flags = 8;
pub const mf_flags_MF_UNPOISON: mf_flags = 16;
pub const mf_flags_MF_SW_SIMULATED: mf_flags = 32;
pub const mf_flags_MF_NO_RETRY: mf_flags = 64;
pub const mf_flags_MF_MEM_PRE_REMOVE: mf_flags = 128;
pub type mf_flags = ffi::c_uint;
extern "C" {
    pub fn mf_dax_kill_procs(
        mapping: *mut address_space,
        index: ffi::c_ulong,
        count: ffi::c_ulong,
        mf_flags: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn memory_failure(pfn: ffi::c_ulong, flags: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn memory_failure_queue_kick(cpu: ffi::c_int);
}
extern "C" {
    pub fn unpoison_memory(pfn: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub static mut num_poisoned_pages: atomic_long_t;
}
extern "C" {
    pub fn soft_offline_page(pfn: ffi::c_ulong, flags: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub static memory_failure_attr_group: attribute_group;
}
extern "C" {
    pub fn memory_failure_queue(pfn: ffi::c_ulong, flags: ffi::c_int);
}
extern "C" {
    pub fn __get_huge_page_for_hwpoison(
        pfn: ffi::c_ulong,
        flags: ffi::c_int,
        migratable_cleared: *mut bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn num_poisoned_pages_inc(pfn: ffi::c_ulong);
}
extern "C" {
    pub fn num_poisoned_pages_sub(pfn: ffi::c_ulong, i: ffi::c_long);
}
extern "C" {
    pub fn memblk_nr_poison_inc(pfn: ffi::c_ulong);
}
extern "C" {
    pub fn memblk_nr_poison_sub(pfn: ffi::c_ulong, i: ffi::c_long);
}
pub const mf_result_MF_IGNORED: mf_result = 0;
pub const mf_result_MF_FAILED: mf_result = 1;
pub const mf_result_MF_DELAYED: mf_result = 2;
pub const mf_result_MF_RECOVERED: mf_result = 3;
pub type mf_result = ffi::c_uint;
pub const mf_action_page_type_MF_MSG_KERNEL: mf_action_page_type = 0;
pub const mf_action_page_type_MF_MSG_KERNEL_HIGH_ORDER: mf_action_page_type = 1;
pub const mf_action_page_type_MF_MSG_DIFFERENT_COMPOUND: mf_action_page_type = 2;
pub const mf_action_page_type_MF_MSG_HUGE: mf_action_page_type = 3;
pub const mf_action_page_type_MF_MSG_FREE_HUGE: mf_action_page_type = 4;
pub const mf_action_page_type_MF_MSG_GET_HWPOISON: mf_action_page_type = 5;
pub const mf_action_page_type_MF_MSG_UNMAP_FAILED: mf_action_page_type = 6;
pub const mf_action_page_type_MF_MSG_DIRTY_SWAPCACHE: mf_action_page_type = 7;
pub const mf_action_page_type_MF_MSG_CLEAN_SWAPCACHE: mf_action_page_type = 8;
pub const mf_action_page_type_MF_MSG_DIRTY_MLOCKED_LRU: mf_action_page_type = 9;
pub const mf_action_page_type_MF_MSG_CLEAN_MLOCKED_LRU: mf_action_page_type = 10;
pub const mf_action_page_type_MF_MSG_DIRTY_UNEVICTABLE_LRU: mf_action_page_type = 11;
pub const mf_action_page_type_MF_MSG_CLEAN_UNEVICTABLE_LRU: mf_action_page_type = 12;
pub const mf_action_page_type_MF_MSG_DIRTY_LRU: mf_action_page_type = 13;
pub const mf_action_page_type_MF_MSG_CLEAN_LRU: mf_action_page_type = 14;
pub const mf_action_page_type_MF_MSG_TRUNCATED_LRU: mf_action_page_type = 15;
pub const mf_action_page_type_MF_MSG_BUDDY: mf_action_page_type = 16;
pub const mf_action_page_type_MF_MSG_DAX: mf_action_page_type = 17;
pub const mf_action_page_type_MF_MSG_UNSPLIT_THP: mf_action_page_type = 18;
pub const mf_action_page_type_MF_MSG_ALREADY_POISONED: mf_action_page_type = 19;
pub const mf_action_page_type_MF_MSG_UNKNOWN: mf_action_page_type = 20;
pub type mf_action_page_type = ffi::c_uint;
extern "C" {
    pub fn folio_zero_user(folio: *mut folio, addr_hint: ffi::c_ulong);
}
extern "C" {
    pub fn copy_user_large_folio(
        dst: *mut folio,
        src: *mut folio,
        addr_hint: ffi::c_ulong,
        vma: *mut vm_area_struct,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn copy_folio_from_user(
        dst_folio: *mut folio,
        usr_src: *const ffi::c_void,
        allow_pagefault: bool_,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn setup_nr_node_ids();
}
extern "C" {
    pub fn memcmp_pages(page1: *mut page, page2: *mut page) -> ffi::c_int;
}
extern "C" {
    pub fn clean_record_shared_mapping_range(
        mapping: *mut address_space,
        first_index: ffi::c_ulong,
        nr: ffi::c_ulong,
        bitmap_pgoff: ffi::c_ulong,
        bitmap: *mut ffi::c_ulong,
        start: *mut ffi::c_ulong,
        end: *mut ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn wp_shared_mapping_range(
        mapping: *mut address_space,
        first_index: ffi::c_ulong,
        nr: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn vma_pgtable_walk_begin(vma: *mut vm_area_struct);
}
extern "C" {
    pub fn vma_pgtable_walk_end(vma: *mut vm_area_struct);
}
extern "C" {
    pub fn reserve_mem_find_by_name(
        name: *const ffi::c_char,
        start: *mut phys_addr_t,
        size: *mut phys_addr_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn reserve_mem_release_by_name(name: *const ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub fn do_mseal(start: ffi::c_ulong, len_in: usize, flags: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn arch_get_shadow_stack_status(
        t: *mut task_struct,
        status: *mut ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn arch_set_shadow_stack_status(t: *mut task_struct, status: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn arch_lock_shadow_stack_status(t: *mut task_struct, status: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn kallsyms_show_value(cred: *const cred) -> bool_;
}
extern "C" {
    pub fn kallsyms_sym_address(idx: ffi::c_int) -> ffi::c_ulong;
}
extern "C" {
    pub fn kallsyms_on_each_symbol(
        fn_: ::core::option::Option<
            unsafe extern "C" fn(
                arg1: *mut ffi::c_void,
                arg2: *const ffi::c_char,
                arg3: ffi::c_ulong,
            ) -> ffi::c_int,
        >,
        data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kallsyms_on_each_match_symbol(
        fn_: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut ffi::c_void, arg2: ffi::c_ulong) -> ffi::c_int,
        >,
        name: *const ffi::c_char,
        data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kallsyms_lookup_name(name: *const ffi::c_char) -> ffi::c_ulong;
}
extern "C" {
    pub fn kallsyms_lookup_size_offset(
        addr: ffi::c_ulong,
        symbolsize: *mut ffi::c_ulong,
        offset: *mut ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kallsyms_lookup(
        addr: ffi::c_ulong,
        symbolsize: *mut ffi::c_ulong,
        offset: *mut ffi::c_ulong,
        modname: *mut *mut ffi::c_char,
        namebuf: *mut ffi::c_char,
    ) -> *const ffi::c_char;
}
extern "C" {
    pub fn sprint_symbol(buffer: *mut ffi::c_char, address: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn sprint_symbol_build_id(buffer: *mut ffi::c_char, address: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn sprint_symbol_no_offset(buffer: *mut ffi::c_char, address: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn sprint_backtrace(buffer: *mut ffi::c_char, address: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn sprint_backtrace_build_id(buffer: *mut ffi::c_char, address: ffi::c_ulong)
        -> ffi::c_int;
}
extern "C" {
    pub fn lookup_symbol_name(addr: ffi::c_ulong, symname: *mut ffi::c_char) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mnt_namespace {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct uts_namespace {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ipc_namespace {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct nsproxy {
    pub count: refcount_t,
    pub uts_ns: *mut uts_namespace,
    pub ipc_ns: *mut ipc_namespace,
    pub mnt_ns: *mut mnt_namespace,
    pub pid_ns_for_children: *mut pid_namespace,
    pub net_ns: *mut net,
    pub time_ns: *mut time_namespace,
    pub time_ns_for_children: *mut time_namespace,
    pub cgroup_ns: *mut cgroup_namespace,
}
impl Default for nsproxy {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut init_nsproxy: nsproxy;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct nsset {
    pub flags: ffi::c_uint,
    pub nsproxy: *mut nsproxy,
    pub fs: *mut fs_struct,
    pub cred: *const cred,
}
impl Default for nsset {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn copy_namespaces(flags: ffi::c_ulong, tsk: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn exit_task_namespaces(tsk: *mut task_struct);
}
extern "C" {
    pub fn switch_task_namespaces(tsk: *mut task_struct, new: *mut nsproxy);
}
extern "C" {
    pub fn exec_task_namespaces() -> ffi::c_int;
}
extern "C" {
    pub fn free_nsproxy(ns: *mut nsproxy);
}
extern "C" {
    pub fn unshare_nsproxy_namespaces(
        arg1: ffi::c_ulong,
        arg2: *mut *mut nsproxy,
        arg3: *mut cred,
        arg4: *mut fs_struct,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn nsproxy_cache_init() -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct proc_ns_operations {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ns_common {
    pub stashed: *mut dentry,
    pub ops: *const proc_ns_operations,
    pub inum: ffi::c_uint,
    pub count: refcount_t,
}
impl Default for ns_common {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fs_pin {
    _unused: [u8; 0],
}
extern "C" {
    pub fn copy_pid_ns(
        flags: ffi::c_ulong,
        user_ns: *mut user_namespace,
        ns: *mut pid_namespace,
    ) -> *mut pid_namespace;
}
extern "C" {
    pub fn zap_pid_ns_processes(pid_ns: *mut pid_namespace);
}
extern "C" {
    pub fn reboot_pid_ns(pid_ns: *mut pid_namespace, cmd: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn put_pid_ns(ns: *mut pid_namespace);
}
extern "C" {
    pub fn task_active_pid_ns(tsk: *mut task_struct) -> *mut pid_namespace;
}
extern "C" {
    pub fn pidhash_init();
}
extern "C" {
    pub fn pid_idr_init();
}
extern "C" {
    pub fn register_pidns_sysctls(pidns: *mut pid_namespace) -> ffi::c_int;
}
extern "C" {
    pub fn unregister_pidns_sysctls(pidns: *mut pid_namespace);
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ptrace_peeksiginfo_args {
    pub off: __u64,
    pub flags: __u32,
    pub nr: __s32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct seccomp_metadata {
    pub filter_off: __u64,
    pub flags: __u64,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ptrace_syscall_info {
    pub op: __u8,
    pub pad: [__u8; 3usize],
    pub arch: __u32,
    pub instruction_pointer: __u64,
    pub stack_pointer: __u64,
    pub __bindgen_anon_1: ptrace_syscall_info__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union ptrace_syscall_info__bindgen_ty_1 {
    pub entry: ptrace_syscall_info__bindgen_ty_1__bindgen_ty_1,
    pub exit: ptrace_syscall_info__bindgen_ty_1__bindgen_ty_2,
    pub seccomp: ptrace_syscall_info__bindgen_ty_1__bindgen_ty_3,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ptrace_syscall_info__bindgen_ty_1__bindgen_ty_1 {
    pub nr: __u64,
    pub args: [__u64; 6usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ptrace_syscall_info__bindgen_ty_1__bindgen_ty_2 {
    pub rval: __s64,
    pub is_error: __u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ptrace_syscall_info__bindgen_ty_1__bindgen_ty_3 {
    pub nr: __u64,
    pub args: [__u64; 6usize],
    pub ret_data: __u32,
}
impl Default for ptrace_syscall_info__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for ptrace_syscall_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ptrace_rseq_configuration {
    pub rseq_abi_pointer: __u64,
    pub rseq_abi_size: __u32,
    pub signature: __u32,
    pub flags: __u32,
    pub pad: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ptrace_sud_config {
    pub mode: __u64,
    pub selector: __u64,
    pub offset: __u64,
    pub len: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct seccomp_data {
    pub nr: ffi::c_int,
    pub arch: __u32,
    pub instruction_pointer: __u64,
    pub args: [__u64; 6usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct seccomp_notif_sizes {
    pub seccomp_notif: __u16,
    pub seccomp_notif_resp: __u16,
    pub seccomp_data: __u16,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct seccomp_notif {
    pub id: __u64,
    pub pid: __u32,
    pub flags: __u32,
    pub data: seccomp_data,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct seccomp_notif_resp {
    pub id: __u64,
    pub val: __s64,
    pub error: __s32,
    pub flags: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct seccomp_notif_addfd {
    pub id: __u64,
    pub flags: __u32,
    pub srcfd: __u32,
    pub newfd: __u32,
    pub newfd_flags: __u32,
}
extern "C" {
    pub fn __secure_computing() -> ffi::c_int;
}
extern "C" {
    pub fn prctl_get_seccomp() -> ffi::c_long;
}
extern "C" {
    pub fn prctl_set_seccomp(arg1: ffi::c_ulong, arg2: *mut ffi::c_void) -> ffi::c_long;
}
extern "C" {
    pub fn seccomp_filter_release(tsk: *mut task_struct);
}
extern "C" {
    pub fn get_seccomp_filter(tsk: *mut task_struct);
}
extern "C" {
    pub fn seccomp_get_filter(
        task: *mut task_struct,
        filter_off: ffi::c_ulong,
        data: *mut ffi::c_void,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn seccomp_get_metadata(
        task: *mut task_struct,
        filter_off: ffi::c_ulong,
        data: *mut ffi::c_void,
    ) -> ffi::c_long;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct syscall_info {
    pub sp: __u64,
    pub data: seccomp_data,
}
extern "C" {
    pub fn ptrace_access_vm(
        tsk: *mut task_struct,
        addr: ffi::c_ulong,
        buf: *mut ffi::c_void,
        len: ffi::c_int,
        gup_flags: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn arch_ptrace(
        child: *mut task_struct,
        request: ffi::c_long,
        addr: ffi::c_ulong,
        data: ffi::c_ulong,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn ptrace_readdata(
        tsk: *mut task_struct,
        src: ffi::c_ulong,
        dst: *mut ffi::c_char,
        len: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn ptrace_writedata(
        tsk: *mut task_struct,
        src: *mut ffi::c_char,
        dst: ffi::c_ulong,
        len: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn ptrace_disable(arg1: *mut task_struct);
}
extern "C" {
    pub fn ptrace_request(
        child: *mut task_struct,
        request: ffi::c_long,
        addr: ffi::c_ulong,
        data: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn ptrace_notify(exit_code: ffi::c_int, message: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn __ptrace_link(
        child: *mut task_struct,
        new_parent: *mut task_struct,
        ptracer_cred: *const cred,
    );
}
extern "C" {
    pub fn __ptrace_unlink(child: *mut task_struct);
}
extern "C" {
    pub fn exit_ptrace(tracer: *mut task_struct, dead: *mut list_head);
}
extern "C" {
    pub fn ptrace_may_access(task: *mut task_struct, mode: ffi::c_uint) -> bool_;
}
extern "C" {
    pub fn generic_ptrace_peekdata(
        tsk: *mut task_struct,
        addr: ffi::c_ulong,
        data: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn generic_ptrace_pokedata(
        tsk: *mut task_struct,
        addr: ffi::c_ulong,
        data: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn user_enable_single_step(arg1: *mut task_struct);
}
extern "C" {
    pub fn user_disable_single_step(arg1: *mut task_struct);
}
extern "C" {
    pub fn task_current_syscall(target: *mut task_struct, info: *mut syscall_info) -> ffi::c_int;
}
extern "C" {
    pub fn sigaction_compat_abi(act: *mut k_sigaction, oact: *mut k_sigaction);
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ipc_perm {
    pub key: __kernel_key_t,
    pub uid: __kernel_uid_t,
    pub gid: __kernel_gid_t,
    pub cuid: __kernel_uid_t,
    pub cgid: __kernel_gid_t,
    pub mode: __kernel_mode_t,
    pub seq: ffi::c_ushort,
}
#[repr(C)]
#[derive(Default)]
pub struct ipc64_perm {
    pub key: __kernel_key_t,
    pub uid: __kernel_uid32_t,
    pub gid: __kernel_gid32_t,
    pub cuid: __kernel_uid32_t,
    pub cgid: __kernel_gid32_t,
    pub mode: __kernel_mode_t,
    pub __pad1: __IncompleteArrayField<ffi::c_uchar>,
    pub seq: ffi::c_ushort,
    pub __pad2: ffi::c_ushort,
    pub __unused1: __kernel_ulong_t,
    pub __unused2: __kernel_ulong_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ipc_kludge {
    pub msgp: *mut msgbuf,
    pub msgtyp: ffi::c_long,
}
impl Default for ipc_kludge {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct kern_ipc_perm {
    pub lock: spinlock_t,
    pub deleted: bool_,
    pub id: ffi::c_int,
    pub key: key_t,
    pub uid: kuid_t,
    pub gid: kgid_t,
    pub cuid: kuid_t,
    pub cgid: kgid_t,
    pub mode: umode_t,
    pub seq: ffi::c_ulong,
    pub security: *mut ffi::c_void,
    pub khtnode: rhash_head,
    pub rcu: callback_head,
    pub refcount: refcount_t,
}
impl Default for kern_ipc_perm {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct semid_ds {
    pub sem_perm: ipc_perm,
    pub sem_otime: __kernel_old_time_t,
    pub sem_ctime: __kernel_old_time_t,
    pub sem_base: *mut sem,
    pub sem_pending: *mut sem_queue,
    pub sem_pending_last: *mut *mut sem_queue,
    pub undo: *mut sem_undo,
    pub sem_nsems: ffi::c_ushort,
}
impl Default for semid_ds {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default)]
pub struct semid64_ds {
    pub sem_perm: ipc64_perm,
    pub sem_otime: ffi::c_long,
    pub sem_ctime: ffi::c_long,
    pub sem_nsems: ffi::c_ulong,
    pub __unused3: ffi::c_ulong,
    pub __unused4: ffi::c_ulong,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sembuf {
    pub sem_num: ffi::c_ushort,
    pub sem_op: ffi::c_short,
    pub sem_flg: ffi::c_short,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union semun {
    pub val: ffi::c_int,
    pub buf: *mut semid_ds,
    pub array: *mut ffi::c_ushort,
    pub __buf: *mut seminfo,
    pub __pad: *mut ffi::c_void,
}
impl Default for semun {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct seminfo {
    pub semmap: ffi::c_int,
    pub semmni: ffi::c_int,
    pub semmns: ffi::c_int,
    pub semmnu: ffi::c_int,
    pub semmsl: ffi::c_int,
    pub semopm: ffi::c_int,
    pub semume: ffi::c_int,
    pub semusz: ffi::c_int,
    pub semvmx: ffi::c_int,
    pub semaem: ffi::c_int,
}
extern "C" {
    pub fn copy_semundo(clone_flags: ffi::c_ulong, tsk: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn exit_sem(tsk: *mut task_struct);
}
#[repr(C)]
pub struct iovec {
    pub iov_base: *mut ffi::c_void,
    pub iov_len: __kernel_size_t,
}
impl Default for iovec {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct dmabuf_cmsg {
    pub frag_offset: __u64,
    pub frag_size: __u32,
    pub frag_token: __u32,
    pub dmabuf_id: __u32,
    pub flags: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct dmabuf_token {
    pub token_start: __u32,
    pub token_count: __u32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct folio_queue {
    _unused: [u8; 0],
}
pub type iov_iter_extraction_t = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kvec {
    pub iov_base: *mut ffi::c_void,
    pub iov_len: usize,
}
impl Default for kvec {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const iter_type_ITER_UBUF: iter_type = 0;
pub const iter_type_ITER_IOVEC: iter_type = 1;
pub const iter_type_ITER_BVEC: iter_type = 2;
pub const iter_type_ITER_KVEC: iter_type = 3;
pub const iter_type_ITER_FOLIOQ: iter_type = 4;
pub const iter_type_ITER_XARRAY: iter_type = 5;
pub const iter_type_ITER_DISCARD: iter_type = 6;
pub type iter_type = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct iov_iter_state {
    pub iov_offset: usize,
    pub count: usize,
    pub nr_segs: ffi::c_ulong,
}
#[repr(C)]
pub struct iov_iter {
    pub iter_type: u8_,
    pub nofault: bool_,
    pub data_source: bool_,
    pub iov_offset: usize,
    pub __bindgen_anon_1: iov_iter__bindgen_ty_1,
    pub __bindgen_anon_2: iov_iter__bindgen_ty_2,
}
#[repr(C)]
pub struct iov_iter__bindgen_ty_1 {
    pub __ubuf_iovec: __BindgenUnionField<iovec>,
    pub __bindgen_anon_1: __BindgenUnionField<iov_iter__bindgen_ty_1__bindgen_ty_1>,
    pub bindgen_union_field: [u64; 2usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct iov_iter__bindgen_ty_1__bindgen_ty_1 {
    pub __bindgen_anon_1: iov_iter__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
    pub count: usize,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union iov_iter__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    pub __iov: *const iovec,
    pub kvec: *const kvec,
    pub bvec: *const bio_vec,
    pub folioq: *const folio_queue,
    pub xarray: *mut xarray,
    pub ubuf: *mut ffi::c_void,
}
impl Default for iov_iter__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for iov_iter__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for iov_iter__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union iov_iter__bindgen_ty_2 {
    pub nr_segs: ffi::c_ulong,
    pub folioq_slot: u8_,
    pub xarray_start: loff_t,
}
impl Default for iov_iter__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for iov_iter {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type uio_meta_flags_t = __u16;
#[repr(C)]
pub struct uio_meta {
    pub flags: uio_meta_flags_t,
    pub app_tag: u16_,
    pub seed: u64_,
    pub iter: iov_iter,
}
impl Default for uio_meta {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn copy_page_from_iter_atomic(
        page: *mut page,
        offset: usize,
        bytes: usize,
        i: *mut iov_iter,
    ) -> usize;
}
extern "C" {
    pub fn iov_iter_advance(i: *mut iov_iter, bytes: usize);
}
extern "C" {
    pub fn iov_iter_revert(i: *mut iov_iter, bytes: usize);
}
extern "C" {
    pub fn fault_in_iov_iter_readable(i: *const iov_iter, bytes: usize) -> usize;
}
extern "C" {
    pub fn fault_in_iov_iter_writeable(i: *const iov_iter, bytes: usize) -> usize;
}
extern "C" {
    pub fn iov_iter_single_seg_count(i: *const iov_iter) -> usize;
}
extern "C" {
    pub fn copy_page_to_iter(
        page: *mut page,
        offset: usize,
        bytes: usize,
        i: *mut iov_iter,
    ) -> usize;
}
extern "C" {
    pub fn copy_page_from_iter(
        page: *mut page,
        offset: usize,
        bytes: usize,
        i: *mut iov_iter,
    ) -> usize;
}
extern "C" {
    pub fn _copy_to_iter(addr: *const ffi::c_void, bytes: usize, i: *mut iov_iter) -> usize;
}
extern "C" {
    pub fn _copy_from_iter(addr: *mut ffi::c_void, bytes: usize, i: *mut iov_iter) -> usize;
}
extern "C" {
    pub fn _copy_from_iter_nocache(addr: *mut ffi::c_void, bytes: usize, i: *mut iov_iter)
        -> usize;
}
extern "C" {
    pub fn copy_page_to_iter_nofault(
        page: *mut page,
        offset: ffi::c_uint,
        bytes: usize,
        i: *mut iov_iter,
    ) -> usize;
}
extern "C" {
    pub fn _copy_from_iter_flushcache(
        addr: *mut ffi::c_void,
        bytes: usize,
        i: *mut iov_iter,
    ) -> usize;
}
extern "C" {
    pub fn iov_iter_zero(bytes: usize, arg1: *mut iov_iter) -> usize;
}
extern "C" {
    pub fn iov_iter_is_aligned(
        i: *const iov_iter,
        addr_mask: ffi::c_uint,
        len_mask: ffi::c_uint,
    ) -> bool_;
}
extern "C" {
    pub fn iov_iter_alignment(i: *const iov_iter) -> ffi::c_ulong;
}
extern "C" {
    pub fn iov_iter_gap_alignment(i: *const iov_iter) -> ffi::c_ulong;
}
extern "C" {
    pub fn iov_iter_init(
        i: *mut iov_iter,
        direction: ffi::c_uint,
        iov: *const iovec,
        nr_segs: ffi::c_ulong,
        count: usize,
    );
}
extern "C" {
    pub fn iov_iter_kvec(
        i: *mut iov_iter,
        direction: ffi::c_uint,
        kvec: *const kvec,
        nr_segs: ffi::c_ulong,
        count: usize,
    );
}
extern "C" {
    pub fn iov_iter_bvec(
        i: *mut iov_iter,
        direction: ffi::c_uint,
        bvec: *const bio_vec,
        nr_segs: ffi::c_ulong,
        count: usize,
    );
}
extern "C" {
    pub fn iov_iter_discard(i: *mut iov_iter, direction: ffi::c_uint, count: usize);
}
extern "C" {
    pub fn iov_iter_folio_queue(
        i: *mut iov_iter,
        direction: ffi::c_uint,
        folioq: *const folio_queue,
        first_slot: ffi::c_uint,
        offset: ffi::c_uint,
        count: usize,
    );
}
extern "C" {
    pub fn iov_iter_xarray(
        i: *mut iov_iter,
        direction: ffi::c_uint,
        xarray: *mut xarray,
        start: loff_t,
        count: usize,
    );
}
extern "C" {
    pub fn iov_iter_get_pages2(
        i: *mut iov_iter,
        pages: *mut *mut page,
        maxsize: usize,
        maxpages: ffi::c_uint,
        start: *mut usize,
    ) -> isize;
}
extern "C" {
    pub fn iov_iter_get_pages_alloc2(
        i: *mut iov_iter,
        pages: *mut *mut *mut page,
        maxsize: usize,
        start: *mut usize,
    ) -> isize;
}
extern "C" {
    pub fn iov_iter_npages(i: *const iov_iter, maxpages: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn iov_iter_restore(i: *mut iov_iter, state: *mut iov_iter_state);
}
extern "C" {
    pub fn dup_iter(new: *mut iov_iter, old: *mut iov_iter, flags: gfp_t) -> *const ffi::c_void;
}
extern "C" {
    pub fn iovec_from_user(
        uvector: *const iovec,
        nr_segs: ffi::c_ulong,
        fast_segs: ffi::c_ulong,
        fast_iov: *mut iovec,
        compat: bool_,
    ) -> *mut iovec;
}
extern "C" {
    pub fn import_iovec(
        type_: ffi::c_int,
        uvec: *const iovec,
        nr_segs: ffi::c_uint,
        fast_segs: ffi::c_uint,
        iovp: *mut *mut iovec,
        i: *mut iov_iter,
    ) -> isize;
}
extern "C" {
    pub fn __import_iovec(
        type_: ffi::c_int,
        uvec: *const iovec,
        nr_segs: ffi::c_uint,
        fast_segs: ffi::c_uint,
        iovp: *mut *mut iovec,
        i: *mut iov_iter,
        compat: bool_,
    ) -> isize;
}
extern "C" {
    pub fn import_ubuf(
        type_: ffi::c_int,
        buf: *mut ffi::c_void,
        len: usize,
        i: *mut iov_iter,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn iov_iter_extract_pages(
        i: *mut iov_iter,
        pages: *mut *mut *mut page,
        maxsize: usize,
        maxpages: ffi::c_uint,
        extraction_flags: iov_iter_extraction_t,
        offset0: *mut usize,
    ) -> isize;
}
extern "C" {
    pub fn extract_iter_to_sg(
        iter: *mut iov_iter,
        len: usize,
        sgtable: *mut sg_table,
        sg_max: ffi::c_uint,
        extraction_flags: iov_iter_extraction_t,
    ) -> isize;
}
pub type __kernel_sa_family_t = ffi::c_ushort;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct __kernel_sockaddr_storage {
    pub __bindgen_anon_1: __kernel_sockaddr_storage__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union __kernel_sockaddr_storage__bindgen_ty_1 {
    pub __bindgen_anon_1: __kernel_sockaddr_storage__bindgen_ty_1__bindgen_ty_1,
    pub __align: *mut ffi::c_void,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct __kernel_sockaddr_storage__bindgen_ty_1__bindgen_ty_1 {
    pub ss_family: __kernel_sa_family_t,
    pub __data: [ffi::c_char; 126usize],
}
impl Default for __kernel_sockaddr_storage__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for __kernel_sockaddr_storage__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for __kernel_sockaddr_storage {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct proto_accept_arg {
    _unused: [u8; 0],
}
extern "C" {
    pub fn socket_seq_show(seq: *mut seq_file);
}
pub type sa_family_t = __kernel_sa_family_t;
#[repr(C)]
pub struct sockaddr {
    pub sa_family: sa_family_t,
    pub __bindgen_anon_1: sockaddr__bindgen_ty_1,
}
#[repr(C)]
pub struct sockaddr__bindgen_ty_1 {
    pub sa_data_min: __BindgenUnionField<[ffi::c_char; 14usize]>,
    pub __bindgen_anon_1: __BindgenUnionField<sockaddr__bindgen_ty_1__bindgen_ty_1>,
    pub bindgen_union_field: [u8; 14usize],
}
#[repr(C)]
#[derive(Default)]
pub struct sockaddr__bindgen_ty_1__bindgen_ty_1 {
    pub __empty_sa_data: sockaddr__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
    pub sa_data: __IncompleteArrayField<ffi::c_char>,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sockaddr__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {}
impl Default for sockaddr__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for sockaddr {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct linger {
    pub l_onoff: ffi::c_int,
    pub l_linger: ffi::c_int,
}
#[repr(C)]
pub struct msghdr {
    pub msg_name: *mut ffi::c_void,
    pub msg_namelen: ffi::c_int,
    pub msg_inq: ffi::c_int,
    pub msg_iter: iov_iter,
    pub __bindgen_anon_1: msghdr__bindgen_ty_1,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub msg_flags: ffi::c_uint,
    pub msg_controllen: __kernel_size_t,
    pub msg_iocb: *mut kiocb,
    pub msg_ubuf: *mut ubuf_info,
    pub sg_from_iter: ::core::option::Option<
        unsafe extern "C" fn(skb: *mut sk_buff, from: *mut iov_iter, length: usize) -> ffi::c_int,
    >,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union msghdr__bindgen_ty_1 {
    pub msg_control: *mut ffi::c_void,
    pub msg_control_user: *mut ffi::c_void,
}
impl Default for msghdr__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for msghdr {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl msghdr {
    #[inline]
    pub fn msg_control_is_user(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_msg_control_is_user(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn msg_control_is_user_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_msg_control_is_user_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn msg_get_inq(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_msg_get_inq(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn msg_get_inq_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_msg_get_inq_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        msg_control_is_user: bool_,
        msg_get_inq: bool_,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let msg_control_is_user: u8 = unsafe { ::core::mem::transmute(msg_control_is_user) };
            msg_control_is_user as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let msg_get_inq: u8 = unsafe { ::core::mem::transmute(msg_get_inq) };
            msg_get_inq as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
pub struct user_msghdr {
    pub msg_name: *mut ffi::c_void,
    pub msg_namelen: ffi::c_int,
    pub msg_iov: *mut iovec,
    pub msg_iovlen: __kernel_size_t,
    pub msg_control: *mut ffi::c_void,
    pub msg_controllen: __kernel_size_t,
    pub msg_flags: ffi::c_uint,
}
impl Default for user_msghdr {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct mmsghdr {
    pub msg_hdr: user_msghdr,
    pub msg_len: ffi::c_uint,
}
impl Default for mmsghdr {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct cmsghdr {
    pub cmsg_len: __kernel_size_t,
    pub cmsg_level: ffi::c_int,
    pub cmsg_type: ffi::c_int,
}
impl Default for cmsghdr {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ucred {
    pub pid: __u32,
    pub uid: __u32,
    pub gid: __u32,
}
extern "C" {
    pub fn move_addr_to_kernel(
        uaddr: *mut ffi::c_void,
        ulen: ffi::c_int,
        kaddr: *mut __kernel_sockaddr_storage,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn put_cmsg(
        arg1: *mut msghdr,
        level: ffi::c_int,
        type_: ffi::c_int,
        len: ffi::c_int,
        data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn put_cmsg_notrunc(
        msg: *mut msghdr,
        level: ffi::c_int,
        type_: ffi::c_int,
        len: ffi::c_int,
        data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct scm_timestamping_internal {
    pub ts: [timespec64; 3usize],
}
extern "C" {
    pub fn put_cmsg_scm_timestamping64(msg: *mut msghdr, tss: *mut scm_timestamping_internal);
}
extern "C" {
    pub fn put_cmsg_scm_timestamping(msg: *mut msghdr, tss: *mut scm_timestamping_internal);
}
extern "C" {
    pub fn __sys_recvmsg(
        fd: ffi::c_int,
        msg: *mut user_msghdr,
        flags: ffi::c_uint,
        forbid_cmsg_compat: bool_,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn __sys_sendmsg(
        fd: ffi::c_int,
        msg: *mut user_msghdr,
        flags: ffi::c_uint,
        forbid_cmsg_compat: bool_,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn __sys_recvmmsg(
        fd: ffi::c_int,
        mmsg: *mut mmsghdr,
        vlen: ffi::c_uint,
        flags: ffi::c_uint,
        timeout: *mut __kernel_timespec,
        timeout32: *mut old_timespec32,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __sys_sendmmsg(
        fd: ffi::c_int,
        mmsg: *mut mmsghdr,
        vlen: ffi::c_uint,
        flags: ffi::c_uint,
        forbid_cmsg_compat: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __sys_sendmsg_sock(
        sock: *mut socket,
        msg: *mut msghdr,
        flags: ffi::c_uint,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn __sys_recvmsg_sock(
        sock: *mut socket,
        msg: *mut msghdr,
        umsg: *mut user_msghdr,
        uaddr: *mut sockaddr,
        flags: ffi::c_uint,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn __copy_msghdr(
        kmsg: *mut msghdr,
        umsg: *mut user_msghdr,
        save_addr: *mut *mut sockaddr,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __sys_recvfrom(
        fd: ffi::c_int,
        ubuf: *mut ffi::c_void,
        size: usize,
        flags: ffi::c_uint,
        addr: *mut sockaddr,
        addr_len: *mut ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __sys_sendto(
        fd: ffi::c_int,
        buff: *mut ffi::c_void,
        len: usize,
        flags: ffi::c_uint,
        addr: *mut sockaddr,
        addr_len: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn do_accept(
        file: *mut file,
        arg: *mut proto_accept_arg,
        upeer_sockaddr: *mut sockaddr,
        upeer_addrlen: *mut ffi::c_int,
        flags: ffi::c_int,
    ) -> *mut file;
}
extern "C" {
    pub fn __sys_accept4(
        fd: ffi::c_int,
        upeer_sockaddr: *mut sockaddr,
        upeer_addrlen: *mut ffi::c_int,
        flags: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __sys_socket(family: ffi::c_int, type_: ffi::c_int, protocol: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn __sys_socket_file(
        family: ffi::c_int,
        type_: ffi::c_int,
        protocol: ffi::c_int,
    ) -> *mut file;
}
extern "C" {
    pub fn __sys_bind(fd: ffi::c_int, umyaddr: *mut sockaddr, addrlen: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn __sys_bind_socket(
        sock: *mut socket,
        address: *mut __kernel_sockaddr_storage,
        addrlen: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __sys_connect_file(
        file: *mut file,
        addr: *mut __kernel_sockaddr_storage,
        addrlen: ffi::c_int,
        file_flags: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __sys_connect(
        fd: ffi::c_int,
        uservaddr: *mut sockaddr,
        addrlen: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __sys_listen(fd: ffi::c_int, backlog: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn __sys_listen_socket(sock: *mut socket, backlog: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn __sys_getsockname(
        fd: ffi::c_int,
        usockaddr: *mut sockaddr,
        usockaddr_len: *mut ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __sys_getpeername(
        fd: ffi::c_int,
        usockaddr: *mut sockaddr,
        usockaddr_len: *mut ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __sys_socketpair(
        family: ffi::c_int,
        type_: ffi::c_int,
        protocol: ffi::c_int,
        usockvec: *mut ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __sys_shutdown_sock(sock: *mut socket, how: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn __sys_shutdown(fd: ffi::c_int, how: ffi::c_int) -> ffi::c_int;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sync_serial_settings {
    pub clock_rate: ffi::c_uint,
    pub clock_type: ffi::c_uint,
    pub loopback: ffi::c_ushort,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct te1_settings {
    pub clock_rate: ffi::c_uint,
    pub clock_type: ffi::c_uint,
    pub loopback: ffi::c_ushort,
    pub slot_map: ffi::c_uint,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct raw_hdlc_proto {
    pub encoding: ffi::c_ushort,
    pub parity: ffi::c_ushort,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct fr_proto {
    pub t391: ffi::c_uint,
    pub t392: ffi::c_uint,
    pub n391: ffi::c_uint,
    pub n392: ffi::c_uint,
    pub n393: ffi::c_uint,
    pub lmi: ffi::c_ushort,
    pub dce: ffi::c_ushort,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct fr_proto_pvc {
    pub dlci: ffi::c_uint,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct fr_proto_pvc_info {
    pub dlci: ffi::c_uint,
    pub master: [ffi::c_char; 16usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct cisco_proto {
    pub interval: ffi::c_uint,
    pub timeout: ffi::c_uint,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct x25_hdlc_proto {
    pub dce: ffi::c_ushort,
    pub modulo: ffi::c_uint,
    pub window: ffi::c_uint,
    pub t1: ffi::c_uint,
    pub t2: ffi::c_uint,
    pub n2: ffi::c_uint,
}
pub const net_device_flags_IFF_UP: net_device_flags = 1;
pub const net_device_flags_IFF_BROADCAST: net_device_flags = 2;
pub const net_device_flags_IFF_DEBUG: net_device_flags = 4;
pub const net_device_flags_IFF_LOOPBACK: net_device_flags = 8;
pub const net_device_flags_IFF_POINTOPOINT: net_device_flags = 16;
pub const net_device_flags_IFF_NOTRAILERS: net_device_flags = 32;
pub const net_device_flags_IFF_RUNNING: net_device_flags = 64;
pub const net_device_flags_IFF_NOARP: net_device_flags = 128;
pub const net_device_flags_IFF_PROMISC: net_device_flags = 256;
pub const net_device_flags_IFF_ALLMULTI: net_device_flags = 512;
pub const net_device_flags_IFF_MASTER: net_device_flags = 1024;
pub const net_device_flags_IFF_SLAVE: net_device_flags = 2048;
pub const net_device_flags_IFF_MULTICAST: net_device_flags = 4096;
pub const net_device_flags_IFF_PORTSEL: net_device_flags = 8192;
pub const net_device_flags_IFF_AUTOMEDIA: net_device_flags = 16384;
pub const net_device_flags_IFF_DYNAMIC: net_device_flags = 32768;
pub const net_device_flags_IFF_LOWER_UP: net_device_flags = 65536;
pub const net_device_flags_IFF_DORMANT: net_device_flags = 131072;
pub const net_device_flags_IFF_ECHO: net_device_flags = 262144;
pub type net_device_flags = ffi::c_uint;
pub const IF_OPER_UNKNOWN: _bindgen_ty_107 = 0;
pub const IF_OPER_NOTPRESENT: _bindgen_ty_107 = 1;
pub const IF_OPER_DOWN: _bindgen_ty_107 = 2;
pub const IF_OPER_LOWERLAYERDOWN: _bindgen_ty_107 = 3;
pub const IF_OPER_TESTING: _bindgen_ty_107 = 4;
pub const IF_OPER_DORMANT: _bindgen_ty_107 = 5;
pub const IF_OPER_UP: _bindgen_ty_107 = 6;
pub type _bindgen_ty_107 = ffi::c_uint;
pub const IF_LINK_MODE_DEFAULT: _bindgen_ty_108 = 0;
pub const IF_LINK_MODE_DORMANT: _bindgen_ty_108 = 1;
pub const IF_LINK_MODE_TESTING: _bindgen_ty_108 = 2;
pub type _bindgen_ty_108 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ifmap {
    pub mem_start: ffi::c_ulong,
    pub mem_end: ffi::c_ulong,
    pub base_addr: ffi::c_ushort,
    pub irq: ffi::c_uchar,
    pub dma: ffi::c_uchar,
    pub port: ffi::c_uchar,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct if_settings {
    pub type_: ffi::c_uint,
    pub size: ffi::c_uint,
    pub ifs_ifsu: if_settings__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union if_settings__bindgen_ty_1 {
    pub raw_hdlc: *mut raw_hdlc_proto,
    pub cisco: *mut cisco_proto,
    pub fr: *mut fr_proto,
    pub fr_pvc: *mut fr_proto_pvc,
    pub fr_pvc_info: *mut fr_proto_pvc_info,
    pub x25: *mut x25_hdlc_proto,
    pub sync: *mut sync_serial_settings,
    pub te1: *mut te1_settings,
}
impl Default for if_settings__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for if_settings {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct ifreq {
    pub ifr_ifrn: ifreq__bindgen_ty_1,
    pub ifr_ifru: ifreq__bindgen_ty_2,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union ifreq__bindgen_ty_1 {
    pub ifrn_name: [ffi::c_char; 16usize],
}
impl Default for ifreq__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct ifreq__bindgen_ty_2 {
    pub ifru_addr: __BindgenUnionField<sockaddr>,
    pub ifru_dstaddr: __BindgenUnionField<sockaddr>,
    pub ifru_broadaddr: __BindgenUnionField<sockaddr>,
    pub ifru_netmask: __BindgenUnionField<sockaddr>,
    pub ifru_hwaddr: __BindgenUnionField<sockaddr>,
    pub ifru_flags: __BindgenUnionField<ffi::c_short>,
    pub ifru_ivalue: __BindgenUnionField<ffi::c_int>,
    pub ifru_mtu: __BindgenUnionField<ffi::c_int>,
    pub ifru_map: __BindgenUnionField<ifmap>,
    pub ifru_slave: __BindgenUnionField<[ffi::c_char; 16usize]>,
    pub ifru_newname: __BindgenUnionField<[ffi::c_char; 16usize]>,
    pub ifru_data: __BindgenUnionField<*mut ffi::c_void>,
    pub ifru_settings: __BindgenUnionField<if_settings>,
    pub bindgen_union_field: [u64; 3usize],
}
impl Default for ifreq__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for ifreq {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ifconf {
    pub ifc_len: ffi::c_int,
    pub ifc_ifcu: ifconf__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union ifconf__bindgen_ty_1 {
    pub ifcu_buf: *mut ffi::c_char,
    pub ifcu_req: *mut ifreq,
}
impl Default for ifconf__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for ifconf {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type aio_context_t = __kernel_ulong_t;
pub const IOCB_CMD_PREAD: _bindgen_ty_109 = 0;
pub const IOCB_CMD_PWRITE: _bindgen_ty_109 = 1;
pub const IOCB_CMD_FSYNC: _bindgen_ty_109 = 2;
pub const IOCB_CMD_FDSYNC: _bindgen_ty_109 = 3;
pub const IOCB_CMD_POLL: _bindgen_ty_109 = 5;
pub const IOCB_CMD_NOOP: _bindgen_ty_109 = 6;
pub const IOCB_CMD_PREADV: _bindgen_ty_109 = 7;
pub const IOCB_CMD_PWRITEV: _bindgen_ty_109 = 8;
pub type _bindgen_ty_109 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct io_event {
    pub data: __u64,
    pub obj: __u64,
    pub res: __s64,
    pub res2: __s64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct iocb {
    pub aio_data: __u64,
    pub aio_key: __u32,
    pub aio_rw_flags: __kernel_rwf_t,
    pub aio_lio_opcode: __u16,
    pub aio_reqprio: __s16,
    pub aio_fildes: __u32,
    pub aio_buf: __u64,
    pub aio_nbytes: __u64,
    pub aio_offset: __s64,
    pub aio_reserved2: __u64,
    pub aio_flags: __u32,
    pub aio_resfd: __u32,
}
extern "C" {
    pub fn __arm64_sys_ni_syscall(__unused: *const pt_regs) -> ffi::c_long;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_iovec {
    pub iov_base: compat_uptr_t,
    pub iov_len: compat_size_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_sigaltstack {
    pub ss_sp: compat_uptr_t,
    pub ss_flags: ffi::c_int,
    pub ss_size: compat_size_t,
}
pub type compat_stack_t = compat_sigaltstack;
pub type compat_uid_t = __compat_uid32_t;
pub type compat_gid_t = __compat_gid32_t;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct compat_sel_arg_struct {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct old_itimerval32 {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_tms {
    pub tms_utime: compat_clock_t,
    pub tms_stime: compat_clock_t,
    pub tms_cutime: compat_clock_t,
    pub tms_cstime: compat_clock_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_sigset_t {
    pub sig: [compat_sigset_word; 2usize],
}
extern "C" {
    pub fn set_compat_user_sigmask(umask: *const compat_sigset_t, sigsetsize: usize) -> ffi::c_int;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_sigaction {
    pub sa_handler: compat_uptr_t,
    pub sa_flags: compat_ulong_t,
    pub sa_restorer: compat_uptr_t,
    pub sa_mask: compat_sigset_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union compat_sigval {
    pub sival_int: compat_int_t,
    pub sival_ptr: compat_uptr_t,
}
impl Default for compat_sigval {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type compat_sigval_t = compat_sigval;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct compat_siginfo {
    pub si_signo: ffi::c_int,
    pub si_errno: ffi::c_int,
    pub si_code: ffi::c_int,
    pub _sifields: compat_siginfo__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union compat_siginfo__bindgen_ty_1 {
    pub _pad: [ffi::c_int; 29usize],
    pub _kill: compat_siginfo__bindgen_ty_1__bindgen_ty_1,
    pub _timer: compat_siginfo__bindgen_ty_1__bindgen_ty_2,
    pub _rt: compat_siginfo__bindgen_ty_1__bindgen_ty_3,
    pub _sigchld: compat_siginfo__bindgen_ty_1__bindgen_ty_4,
    pub _sigfault: compat_siginfo__bindgen_ty_1__bindgen_ty_5,
    pub _sigpoll: compat_siginfo__bindgen_ty_1__bindgen_ty_6,
    pub _sigsys: compat_siginfo__bindgen_ty_1__bindgen_ty_7,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_siginfo__bindgen_ty_1__bindgen_ty_1 {
    pub _pid: compat_pid_t,
    pub _uid: __compat_uid32_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct compat_siginfo__bindgen_ty_1__bindgen_ty_2 {
    pub _tid: compat_timer_t,
    pub _overrun: ffi::c_int,
    pub _sigval: compat_sigval_t,
}
impl Default for compat_siginfo__bindgen_ty_1__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct compat_siginfo__bindgen_ty_1__bindgen_ty_3 {
    pub _pid: compat_pid_t,
    pub _uid: __compat_uid32_t,
    pub _sigval: compat_sigval_t,
}
impl Default for compat_siginfo__bindgen_ty_1__bindgen_ty_3 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_siginfo__bindgen_ty_1__bindgen_ty_4 {
    pub _pid: compat_pid_t,
    pub _uid: __compat_uid32_t,
    pub _status: ffi::c_int,
    pub _utime: compat_clock_t,
    pub _stime: compat_clock_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct compat_siginfo__bindgen_ty_1__bindgen_ty_5 {
    pub _addr: compat_uptr_t,
    pub __bindgen_anon_1: compat_siginfo__bindgen_ty_1__bindgen_ty_5__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union compat_siginfo__bindgen_ty_1__bindgen_ty_5__bindgen_ty_1 {
    pub _trapno: ffi::c_int,
    pub _addr_lsb: ffi::c_short,
    pub _addr_bnd: compat_siginfo__bindgen_ty_1__bindgen_ty_5__bindgen_ty_1__bindgen_ty_1,
    pub _addr_pkey: compat_siginfo__bindgen_ty_1__bindgen_ty_5__bindgen_ty_1__bindgen_ty_2,
    pub _perf: compat_siginfo__bindgen_ty_1__bindgen_ty_5__bindgen_ty_1__bindgen_ty_3,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_siginfo__bindgen_ty_1__bindgen_ty_5__bindgen_ty_1__bindgen_ty_1 {
    pub _dummy_bnd: [ffi::c_char; 4usize],
    pub _lower: compat_uptr_t,
    pub _upper: compat_uptr_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_siginfo__bindgen_ty_1__bindgen_ty_5__bindgen_ty_1__bindgen_ty_2 {
    pub _dummy_pkey: [ffi::c_char; 4usize],
    pub _pkey: u32_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_siginfo__bindgen_ty_1__bindgen_ty_5__bindgen_ty_1__bindgen_ty_3 {
    pub _data: compat_ulong_t,
    pub _type: u32_,
    pub _flags: u32_,
}
impl Default for compat_siginfo__bindgen_ty_1__bindgen_ty_5__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for compat_siginfo__bindgen_ty_1__bindgen_ty_5 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_siginfo__bindgen_ty_1__bindgen_ty_6 {
    pub _band: compat_long_t,
    pub _fd: ffi::c_int,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_siginfo__bindgen_ty_1__bindgen_ty_7 {
    pub _call_addr: compat_uptr_t,
    pub _syscall: ffi::c_int,
    pub _arch: ffi::c_uint,
}
impl Default for compat_siginfo__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for compat_siginfo {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type compat_siginfo_t = compat_siginfo;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_rlimit {
    pub rlim_cur: compat_ulong_t,
    pub rlim_max: compat_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_flock {
    pub l_type: ffi::c_short,
    pub l_whence: ffi::c_short,
    pub l_start: compat_off_t,
    pub l_len: compat_off_t,
    pub l_pid: compat_pid_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_flock64 {
    pub l_type: ffi::c_short,
    pub l_whence: ffi::c_short,
    pub l_start: compat_loff_t,
    pub l_len: compat_loff_t,
    pub l_pid: compat_pid_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_rusage {
    pub ru_utime: old_timeval32,
    pub ru_stime: old_timeval32,
    pub ru_maxrss: compat_long_t,
    pub ru_ixrss: compat_long_t,
    pub ru_idrss: compat_long_t,
    pub ru_isrss: compat_long_t,
    pub ru_minflt: compat_long_t,
    pub ru_majflt: compat_long_t,
    pub ru_nswap: compat_long_t,
    pub ru_inblock: compat_long_t,
    pub ru_oublock: compat_long_t,
    pub ru_msgsnd: compat_long_t,
    pub ru_msgrcv: compat_long_t,
    pub ru_nsignals: compat_long_t,
    pub ru_nvcsw: compat_long_t,
    pub ru_nivcsw: compat_long_t,
}
extern "C" {
    pub fn put_compat_rusage(arg1: *const rusage, arg2: *mut compat_rusage) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct __compat_aio_sigset {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct compat_dirent {
    pub d_ino: u32_,
    pub d_off: compat_off_t,
    pub d_reclen: u16_,
    pub d_name: [ffi::c_char; 256usize],
}
impl Default for compat_dirent {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_ustat {
    pub f_tfree: compat_daddr_t,
    pub f_tinode: compat_ino_t,
    pub f_fname: [ffi::c_char; 6usize],
    pub f_fpack: [ffi::c_char; 6usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct compat_sigevent {
    pub sigev_value: compat_sigval_t,
    pub sigev_signo: compat_int_t,
    pub sigev_notify: compat_int_t,
    pub _sigev_un: compat_sigevent__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union compat_sigevent__bindgen_ty_1 {
    pub _pad: [compat_int_t; 13usize],
    pub _tid: compat_int_t,
    pub _sigev_thread: compat_sigevent__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_sigevent__bindgen_ty_1__bindgen_ty_1 {
    pub _function: compat_uptr_t,
    pub _attribute: compat_uptr_t,
}
impl Default for compat_sigevent__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for compat_sigevent {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type compat_sigevent_t = compat_sigevent;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_ifmap {
    pub mem_start: compat_ulong_t,
    pub mem_end: compat_ulong_t,
    pub base_addr: ffi::c_ushort,
    pub irq: ffi::c_uchar,
    pub dma: ffi::c_uchar,
    pub port: ffi::c_uchar,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_if_settings {
    pub type_: ffi::c_uint,
    pub size: ffi::c_uint,
    pub ifs_ifsu: compat_uptr_t,
}
#[repr(C)]
pub struct compat_ifreq {
    pub ifr_ifrn: compat_ifreq__bindgen_ty_1,
    pub ifr_ifru: compat_ifreq__bindgen_ty_2,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union compat_ifreq__bindgen_ty_1 {
    pub ifrn_name: [ffi::c_char; 16usize],
}
impl Default for compat_ifreq__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct compat_ifreq__bindgen_ty_2 {
    pub ifru_addr: __BindgenUnionField<sockaddr>,
    pub ifru_dstaddr: __BindgenUnionField<sockaddr>,
    pub ifru_broadaddr: __BindgenUnionField<sockaddr>,
    pub ifru_netmask: __BindgenUnionField<sockaddr>,
    pub ifru_hwaddr: __BindgenUnionField<sockaddr>,
    pub ifru_flags: __BindgenUnionField<ffi::c_short>,
    pub ifru_ivalue: __BindgenUnionField<compat_int_t>,
    pub ifru_mtu: __BindgenUnionField<compat_int_t>,
    pub ifru_map: __BindgenUnionField<compat_ifmap>,
    pub ifru_slave: __BindgenUnionField<[ffi::c_char; 16usize]>,
    pub ifru_newname: __BindgenUnionField<[ffi::c_char; 16usize]>,
    pub ifru_data: __BindgenUnionField<compat_caddr_t>,
    pub ifru_settings: __BindgenUnionField<compat_if_settings>,
    pub bindgen_union_field: [u32; 4usize],
}
impl Default for compat_ifreq__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for compat_ifreq {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_ifconf {
    pub ifc_len: compat_int_t,
    pub ifcbuf: compat_caddr_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_robust_list {
    pub next: compat_uptr_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_robust_list_head {
    pub list: compat_robust_list,
    pub futex_offset: compat_long_t,
    pub list_op_pending: compat_uptr_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_old_sigaction {
    pub sa_handler: compat_uptr_t,
    pub sa_mask: compat_old_sigset_t,
    pub sa_flags: compat_ulong_t,
    pub sa_restorer: compat_uptr_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_keyctl_kdf_params {
    pub hashname: compat_uptr_t,
    pub otherinfo: compat_uptr_t,
    pub otherinfolen: __u32,
    pub __spare: [__u32; 8usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct compat_statfs64 {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct compat_old_linux_dirent {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct compat_linux_dirent {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct linux_dirent64 {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct compat_sysinfo {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct compat_sysctl_args {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct compat_kexec_segment {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct compat_mq_attr {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct compat_msgbuf {
    _unused: [u8; 0],
}
extern "C" {
    pub fn copy_siginfo_to_external32(to: *mut compat_siginfo, from: *const kernel_siginfo);
}
extern "C" {
    pub fn copy_siginfo_from_user32(
        to: *mut kernel_siginfo_t,
        from: *const compat_siginfo,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __copy_siginfo_to_user32(
        to: *mut compat_siginfo,
        from: *const kernel_siginfo_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn get_compat_sigevent(event: *mut sigevent, u_event: *const compat_sigevent)
        -> ffi::c_int;
}
extern "C" {
    pub fn get_compat_sigset(set: *mut sigset_t, compat: *const compat_sigset_t) -> ffi::c_int;
}
extern "C" {
    pub fn compat_ptrace_request(
        child: *mut task_struct,
        request: compat_long_t,
        addr: compat_ulong_t,
        data: compat_ulong_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn compat_arch_ptrace(
        child: *mut task_struct,
        request: compat_long_t,
        addr: compat_ulong_t,
        data: compat_ulong_t,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn compat_restore_altstack(uss: *const compat_stack_t) -> ffi::c_int;
}
extern "C" {
    pub fn __compat_save_altstack(arg1: *mut compat_stack_t, arg2: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn kcompat_sys_statfs64(
        pathname: *const ffi::c_char,
        sz: compat_size_t,
        buf: *mut compat_statfs64,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kcompat_sys_fstatfs64(
        fd: ffi::c_uint,
        sz: compat_size_t,
        buf: *mut compat_statfs64,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn compat_get_bitmap(
        mask: *mut ffi::c_ulong,
        umask: *const compat_ulong_t,
        bitmap_size: ffi::c_ulong,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn compat_put_bitmap(
        umask: *mut compat_ulong_t,
        mask: *mut ffi::c_ulong,
        bitmap_size: ffi::c_ulong,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn _mcount(arg1: ffi::c_ulong);
}
extern "C" {
    pub fn return_address(arg1: ffi::c_uint) -> *mut ffi::c_void;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct dyn_arch_ftrace {}
extern "C" {
    pub static mut ftrace_graph_call: ffi::c_ulong;
}
extern "C" {
    pub fn return_to_handler();
}
extern "C" {
    pub fn ftrace_call_adjust(addr: ffi::c_ulong) -> ffi::c_ulong;
}
extern "C" {
    pub fn arch_ftrace_get_symaddr(fentry_ip: ffi::c_ulong) -> ffi::c_ulong;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct __arch_ftrace_regs {
    pub regs: [ffi::c_ulong; 9usize],
    pub direct_tramp: ffi::c_ulong,
    pub fp: ffi::c_ulong,
    pub lr: ffi::c_ulong,
    pub sp: ffi::c_ulong,
    pub pc: ffi::c_ulong,
}
extern "C" {
    pub fn ftrace_regs_query_register_offset(name: *const ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_init_nop(mod_: *mut module, rec: *mut dyn_ftrace) -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_graph_func(
        ip: ffi::c_ulong,
        parent_ip: ffi::c_ulong,
        op: *mut ftrace_ops,
        fregs: *mut ftrace_regs,
    );
}
extern "C" {
    pub fn prepare_ftrace_return(
        self_addr: ffi::c_ulong,
        parent: *mut ffi::c_ulong,
        frame_pointer: ffi::c_ulong,
    );
}
extern "C" {
    pub fn ftrace_boot_snapshot();
}
extern "C" {
    pub fn arch_ftrace_match_adjust(
        str_: *mut ffi::c_char,
        search: *const ffi::c_char,
    ) -> *mut ffi::c_char;
}
extern "C" {
    pub fn ftrace_return_to_handler(fregs: *mut ftrace_regs) -> ffi::c_ulong;
}
extern "C" {
    pub fn arch_ftrace_ops_list_func(
        ip: ffi::c_ulong,
        parent_ip: ffi::c_ulong,
        op: *mut ftrace_ops,
        fregs: *mut ftrace_regs,
    );
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ftrace_ops {
    pub func: ftrace_func_t,
    pub next: *mut ftrace_ops,
    pub flags: ffi::c_ulong,
    pub private: *mut ffi::c_void,
    pub saved_func: ftrace_func_t,
    pub local_hash: ftrace_ops_hash,
    pub func_hash: *mut ftrace_ops_hash,
    pub old_hash: ftrace_ops_hash,
    pub trampoline: ffi::c_ulong,
    pub trampoline_size: ffi::c_ulong,
    pub list: list_head,
    pub subop_list: list_head,
    pub ops_func: ftrace_ops_func_t,
    pub managed: *mut ftrace_ops,
    pub direct_call: ffi::c_ulong,
}
impl Default for ftrace_ops {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static ftrace_nop_ops: ftrace_ops;
}
extern "C" {
    pub static ftrace_list_ops: ftrace_ops;
}
extern "C" {
    pub fn ftrace_find_unique_ops(rec: *mut dyn_ftrace) -> *mut ftrace_ops;
}
extern "C" {
    pub fn trace_init();
}
extern "C" {
    pub fn early_trace_init();
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ftrace_hash {
    _unused: [u8; 0],
}
extern "C" {
    pub fn ftrace_mod_address_lookup(
        addr: ffi::c_ulong,
        size: *mut ffi::c_ulong,
        off: *mut ffi::c_ulong,
        modname: *mut *mut ffi::c_char,
        sym: *mut ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_mod_get_kallsym(
        symnum: ffi::c_uint,
        value: *mut ffi::c_ulong,
        type_: *mut ffi::c_char,
        name: *mut ffi::c_char,
        module_name: *mut ffi::c_char,
        exported: *mut ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub static mut ftrace_enabled: ffi::c_int;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ftrace_regs {}
pub type ftrace_func_t = ::core::option::Option<
    unsafe extern "C" fn(
        ip: ffi::c_ulong,
        parent_ip: ffi::c_ulong,
        op: *mut ftrace_ops,
        fregs: *mut ftrace_regs,
    ),
>;
extern "C" {
    pub fn ftrace_ops_get_func(ops: *mut ftrace_ops) -> ftrace_func_t;
}
pub const FTRACE_OPS_FL_ENABLED: _bindgen_ty_110 = 1;
pub const FTRACE_OPS_FL_DYNAMIC: _bindgen_ty_110 = 2;
pub const FTRACE_OPS_FL_SAVE_REGS: _bindgen_ty_110 = 4;
pub const FTRACE_OPS_FL_SAVE_REGS_IF_SUPPORTED: _bindgen_ty_110 = 8;
pub const FTRACE_OPS_FL_RECURSION: _bindgen_ty_110 = 16;
pub const FTRACE_OPS_FL_STUB: _bindgen_ty_110 = 32;
pub const FTRACE_OPS_FL_INITIALIZED: _bindgen_ty_110 = 64;
pub const FTRACE_OPS_FL_DELETED: _bindgen_ty_110 = 128;
pub const FTRACE_OPS_FL_ADDING: _bindgen_ty_110 = 256;
pub const FTRACE_OPS_FL_REMOVING: _bindgen_ty_110 = 512;
pub const FTRACE_OPS_FL_MODIFYING: _bindgen_ty_110 = 1024;
pub const FTRACE_OPS_FL_ALLOC_TRAMP: _bindgen_ty_110 = 2048;
pub const FTRACE_OPS_FL_IPMODIFY: _bindgen_ty_110 = 4096;
pub const FTRACE_OPS_FL_PID: _bindgen_ty_110 = 8192;
pub const FTRACE_OPS_FL_RCU: _bindgen_ty_110 = 16384;
pub const FTRACE_OPS_FL_TRACE_ARRAY: _bindgen_ty_110 = 32768;
pub const FTRACE_OPS_FL_PERMANENT: _bindgen_ty_110 = 65536;
pub const FTRACE_OPS_FL_DIRECT: _bindgen_ty_110 = 131072;
pub const FTRACE_OPS_FL_SUBOP: _bindgen_ty_110 = 262144;
pub type _bindgen_ty_110 = ffi::c_uint;
pub const ftrace_ops_cmd_FTRACE_OPS_CMD_ENABLE_SHARE_IPMODIFY_SELF: ftrace_ops_cmd = 0;
pub const ftrace_ops_cmd_FTRACE_OPS_CMD_ENABLE_SHARE_IPMODIFY_PEER: ftrace_ops_cmd = 1;
pub const ftrace_ops_cmd_FTRACE_OPS_CMD_DISABLE_SHARE_IPMODIFY_PEER: ftrace_ops_cmd = 2;
pub type ftrace_ops_cmd = ffi::c_uint;
pub type ftrace_ops_func_t = ::core::option::Option<
    unsafe extern "C" fn(op: *mut ftrace_ops, cmd: ftrace_ops_cmd) -> ffi::c_int,
>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ftrace_ops_hash {
    pub notrace_hash: *mut ftrace_hash,
    pub filter_hash: *mut ftrace_hash,
    pub regex_lock: mutex,
}
impl Default for ftrace_ops_hash {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn ftrace_free_init_mem();
}
extern "C" {
    pub fn ftrace_free_mem(mod_: *mut module, start: *mut ffi::c_void, end: *mut ffi::c_void);
}
extern "C" {
    pub static mut ftrace_ops_list: *mut ftrace_ops;
}
extern "C" {
    pub static mut ftrace_list_end: ftrace_ops;
}
pub const ftrace_tracing_type_t_FTRACE_TYPE_ENTER: ftrace_tracing_type_t = 0;
pub const ftrace_tracing_type_t_FTRACE_TYPE_RETURN: ftrace_tracing_type_t = 1;
pub type ftrace_tracing_type_t = ffi::c_uint;
extern "C" {
    pub static mut ftrace_tracing_type: ftrace_tracing_type_t;
}
extern "C" {
    pub fn register_ftrace_function(ops: *mut ftrace_ops) -> ffi::c_int;
}
extern "C" {
    pub fn unregister_ftrace_function(ops: *mut ftrace_ops) -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_stub(
        a0: ffi::c_ulong,
        a1: ffi::c_ulong,
        op: *mut ftrace_ops,
        fregs: *mut ftrace_regs,
    );
}
extern "C" {
    pub fn ftrace_lookup_symbols(
        sorted_syms: *mut *const ffi::c_char,
        cnt: usize,
        addrs: *mut ffi::c_ulong,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ftrace_func_entry {
    pub hlist: hlist_node,
    pub ip: ffi::c_ulong,
    pub direct: ffi::c_ulong,
}
impl Default for ftrace_func_entry {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn ftrace_find_rec_direct(ip: ffi::c_ulong) -> ffi::c_ulong;
}
extern "C" {
    pub fn register_ftrace_direct(ops: *mut ftrace_ops, addr: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn unregister_ftrace_direct(
        ops: *mut ftrace_ops,
        addr: ffi::c_ulong,
        free_filters: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn modify_ftrace_direct(ops: *mut ftrace_ops, addr: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn modify_ftrace_direct_nolock(ops: *mut ftrace_ops, addr: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_stub_direct_tramp();
}
extern "C" {
    pub static mut stack_tracer_enabled: ffi::c_int;
}
extern "C" {
    pub fn stack_trace_sysctl(
        table: *const ctl_table,
        write: ffi::c_int,
        buffer: *mut ffi::c_void,
        lenp: *mut usize,
        ppos: *mut loff_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub static mut disable_stack_tracer: ffi::c_int;
}
pub const FTRACE_UPDATE_CALLS: _bindgen_ty_111 = 1;
pub const FTRACE_DISABLE_CALLS: _bindgen_ty_111 = 2;
pub const FTRACE_UPDATE_TRACE_FUNC: _bindgen_ty_111 = 4;
pub const FTRACE_START_FUNC_RET: _bindgen_ty_111 = 8;
pub const FTRACE_STOP_FUNC_RET: _bindgen_ty_111 = 16;
pub const FTRACE_MAY_SLEEP: _bindgen_ty_111 = 32;
pub type _bindgen_ty_111 = ffi::c_uint;
extern "C" {
    pub fn ftrace_arch_code_modify_prepare();
}
extern "C" {
    pub fn ftrace_arch_code_modify_post_process();
}
pub const ftrace_bug_type_FTRACE_BUG_UNKNOWN: ftrace_bug_type = 0;
pub const ftrace_bug_type_FTRACE_BUG_INIT: ftrace_bug_type = 1;
pub const ftrace_bug_type_FTRACE_BUG_NOP: ftrace_bug_type = 2;
pub const ftrace_bug_type_FTRACE_BUG_CALL: ftrace_bug_type = 3;
pub const ftrace_bug_type_FTRACE_BUG_UPDATE: ftrace_bug_type = 4;
pub type ftrace_bug_type = ffi::c_uint;
extern "C" {
    pub static mut ftrace_bug_type: ftrace_bug_type;
}
extern "C" {
    pub static mut ftrace_expected: *const ffi::c_void;
}
extern "C" {
    pub fn ftrace_bug(err: ffi::c_int, rec: *mut dyn_ftrace);
}
extern "C" {
    pub fn ftrace_text_reserved(start: *const ffi::c_void, end: *const ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_ops_trampoline(addr: ffi::c_ulong) -> *mut ftrace_ops;
}
extern "C" {
    pub fn is_ftrace_trampoline(addr: ffi::c_ulong) -> bool_;
}
pub const FTRACE_FL_ENABLED: _bindgen_ty_112 = 2147483648;
pub const FTRACE_FL_REGS: _bindgen_ty_112 = 1073741824;
pub const FTRACE_FL_REGS_EN: _bindgen_ty_112 = 536870912;
pub const FTRACE_FL_TRAMP: _bindgen_ty_112 = 268435456;
pub const FTRACE_FL_TRAMP_EN: _bindgen_ty_112 = 134217728;
pub const FTRACE_FL_IPMODIFY: _bindgen_ty_112 = 67108864;
pub const FTRACE_FL_DISABLED: _bindgen_ty_112 = 33554432;
pub const FTRACE_FL_DIRECT: _bindgen_ty_112 = 16777216;
pub const FTRACE_FL_DIRECT_EN: _bindgen_ty_112 = 8388608;
pub const FTRACE_FL_CALL_OPS: _bindgen_ty_112 = 4194304;
pub const FTRACE_FL_CALL_OPS_EN: _bindgen_ty_112 = 2097152;
pub const FTRACE_FL_TOUCHED: _bindgen_ty_112 = 1048576;
pub const FTRACE_FL_MODIFIED: _bindgen_ty_112 = 524288;
pub type _bindgen_ty_112 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct dyn_ftrace {
    pub ip: ffi::c_ulong,
    pub flags: ffi::c_ulong,
    pub arch: dyn_arch_ftrace,
}
extern "C" {
    pub fn ftrace_set_filter_ip(
        ops: *mut ftrace_ops,
        ip: ffi::c_ulong,
        remove: ffi::c_int,
        reset: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_set_filter_ips(
        ops: *mut ftrace_ops,
        ips: *mut ffi::c_ulong,
        cnt: ffi::c_uint,
        remove: ffi::c_int,
        reset: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_set_filter(
        ops: *mut ftrace_ops,
        buf: *mut ffi::c_uchar,
        len: ffi::c_int,
        reset: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_set_notrace(
        ops: *mut ftrace_ops,
        buf: *mut ffi::c_uchar,
        len: ffi::c_int,
        reset: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_set_global_filter(buf: *mut ffi::c_uchar, len: ffi::c_int, reset: ffi::c_int);
}
extern "C" {
    pub fn ftrace_set_global_notrace(buf: *mut ffi::c_uchar, len: ffi::c_int, reset: ffi::c_int);
}
extern "C" {
    pub fn ftrace_free_filter(ops: *mut ftrace_ops);
}
extern "C" {
    pub fn ftrace_ops_set_global_filter(ops: *mut ftrace_ops);
}
pub const FTRACE_UPDATE_IGNORE: _bindgen_ty_113 = 0;
pub const FTRACE_UPDATE_MAKE_CALL: _bindgen_ty_113 = 1;
pub const FTRACE_UPDATE_MODIFY_CALL: _bindgen_ty_113 = 2;
pub const FTRACE_UPDATE_MAKE_NOP: _bindgen_ty_113 = 3;
pub type _bindgen_ty_113 = ffi::c_uint;
pub const FTRACE_ITER_FILTER: _bindgen_ty_114 = 1;
pub const FTRACE_ITER_NOTRACE: _bindgen_ty_114 = 2;
pub const FTRACE_ITER_PRINTALL: _bindgen_ty_114 = 4;
pub const FTRACE_ITER_DO_PROBES: _bindgen_ty_114 = 8;
pub const FTRACE_ITER_PROBE: _bindgen_ty_114 = 16;
pub const FTRACE_ITER_MOD: _bindgen_ty_114 = 32;
pub const FTRACE_ITER_ENABLED: _bindgen_ty_114 = 64;
pub const FTRACE_ITER_TOUCHED: _bindgen_ty_114 = 128;
pub const FTRACE_ITER_ADDRS: _bindgen_ty_114 = 256;
pub type _bindgen_ty_114 = ffi::c_uint;
extern "C" {
    pub fn arch_ftrace_update_code(command: ffi::c_int);
}
extern "C" {
    pub fn arch_ftrace_update_trampoline(ops: *mut ftrace_ops);
}
extern "C" {
    pub fn arch_ftrace_trampoline_func(
        ops: *mut ftrace_ops,
        rec: *mut dyn_ftrace,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn arch_ftrace_trampoline_free(ops: *mut ftrace_ops);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ftrace_rec_iter {
    _unused: [u8; 0],
}
extern "C" {
    pub fn ftrace_rec_iter_start() -> *mut ftrace_rec_iter;
}
extern "C" {
    pub fn ftrace_rec_iter_next(iter: *mut ftrace_rec_iter) -> *mut ftrace_rec_iter;
}
extern "C" {
    pub fn ftrace_rec_iter_record(iter: *mut ftrace_rec_iter) -> *mut dyn_ftrace;
}
extern "C" {
    pub fn ftrace_update_record(rec: *mut dyn_ftrace, enable: bool_) -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_test_record(rec: *mut dyn_ftrace, enable: bool_) -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_run_stop_machine(command: ffi::c_int);
}
extern "C" {
    pub fn ftrace_location(ip: ffi::c_ulong) -> ffi::c_ulong;
}
extern "C" {
    pub fn ftrace_location_range(start: ffi::c_ulong, end: ffi::c_ulong) -> ffi::c_ulong;
}
extern "C" {
    pub fn ftrace_get_addr_new(rec: *mut dyn_ftrace) -> ffi::c_ulong;
}
extern "C" {
    pub fn ftrace_get_addr_curr(rec: *mut dyn_ftrace) -> ffi::c_ulong;
}
extern "C" {
    pub static mut ftrace_trace_function: ftrace_func_t;
}
extern "C" {
    pub fn ftrace_regex_open(
        ops: *mut ftrace_ops,
        flag: ffi::c_int,
        inode: *mut inode,
        file: *mut file,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_filter_write(
        file: *mut file,
        ubuf: *const ffi::c_char,
        cnt: usize,
        ppos: *mut loff_t,
    ) -> isize;
}
extern "C" {
    pub fn ftrace_notrace_write(
        file: *mut file,
        ubuf: *const ffi::c_char,
        cnt: usize,
        ppos: *mut loff_t,
    ) -> isize;
}
extern "C" {
    pub fn ftrace_regex_release(inode: *mut inode, file: *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_set_early_filter(ops: *mut ftrace_ops, buf: *mut ffi::c_char, enable: ffi::c_int);
}
extern "C" {
    pub fn ftrace_dyn_arch_init() -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_replace_code(enable: ffi::c_int);
}
extern "C" {
    pub fn ftrace_update_ftrace_func(func: ftrace_func_t) -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_caller();
}
extern "C" {
    pub fn ftrace_regs_caller();
}
extern "C" {
    pub fn ftrace_call();
}
extern "C" {
    pub fn ftrace_regs_call();
}
extern "C" {
    pub fn mcount_call();
}
extern "C" {
    pub fn ftrace_modify_all_code(command: ffi::c_int);
}
extern "C" {
    pub fn ftrace_graph_caller();
}
extern "C" {
    pub fn ftrace_enable_ftrace_graph_caller() -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_disable_ftrace_graph_caller() -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_make_nop(
        mod_: *mut module,
        rec: *mut dyn_ftrace,
        addr: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_make_call(rec: *mut dyn_ftrace, addr: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_modify_call(
        rec: *mut dyn_ftrace,
        old_addr: ffi::c_ulong,
        addr: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn skip_trace(ip: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_module_init(mod_: *mut module);
}
extern "C" {
    pub fn ftrace_module_enable(mod_: *mut module);
}
extern "C" {
    pub fn ftrace_release_mod(mod_: *mut module);
}
extern "C" {
    pub fn ftrace_kill();
}
extern "C" {
    pub fn ftrace_init();
}
#[repr(C, packed)]
#[derive(Default, Copy, Clone)]
pub struct ftrace_graph_ent {
    pub func: ffi::c_ulong,
    pub depth: ffi::c_int,
}
#[repr(C, packed)]
#[derive(Default, Copy, Clone)]
pub struct fgraph_retaddr_ent {
    pub func: ffi::c_ulong,
    pub depth: ffi::c_int,
    pub retaddr: ffi::c_ulong,
}
#[repr(C, packed)]
#[derive(Default, Copy, Clone)]
pub struct ftrace_graph_ret {
    pub func: ffi::c_ulong,
    pub retval: ffi::c_ulong,
    pub depth: ffi::c_int,
    pub overrun: ffi::c_uint,
}
pub type trace_func_graph_ret_t = ::core::option::Option<
    unsafe extern "C" fn(
        arg1: *mut ftrace_graph_ret,
        arg2: *mut fgraph_ops,
        arg3: *mut ftrace_regs,
    ),
>;
pub type trace_func_graph_ent_t = ::core::option::Option<
    unsafe extern "C" fn(
        arg1: *mut ftrace_graph_ent,
        arg2: *mut fgraph_ops,
        arg3: *mut ftrace_regs,
    ) -> ffi::c_int,
>;
extern "C" {
    pub fn ftrace_graph_entry_stub(
        trace: *mut ftrace_graph_ent,
        gops: *mut fgraph_ops,
        fregs: *mut ftrace_regs,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_pids_enabled(ops: *mut ftrace_ops) -> bool_;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fgraph_ops {
    pub entryfunc: trace_func_graph_ent_t,
    pub retfunc: trace_func_graph_ret_t,
    pub ops: ftrace_ops,
    pub private: *mut ffi::c_void,
    pub saved_func: trace_func_graph_ent_t,
    pub idx: ffi::c_int,
}
impl Default for fgraph_ops {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn fgraph_reserve_data(idx: ffi::c_int, size_bytes: ffi::c_int) -> *mut ffi::c_void;
}
extern "C" {
    pub fn fgraph_retrieve_data(idx: ffi::c_int, size_bytes: *mut ffi::c_int) -> *mut ffi::c_void;
}
extern "C" {
    pub fn fgraph_retrieve_parent_data(
        idx: ffi::c_int,
        size_bytes: *mut ffi::c_int,
        depth: ffi::c_int,
    ) -> *mut ffi::c_void;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ftrace_ret_stack {
    pub ret: ffi::c_ulong,
    pub func: ffi::c_ulong,
    pub fp: ffi::c_ulong,
    pub retp: *mut ffi::c_ulong,
}
impl Default for ftrace_ret_stack {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn function_graph_enter_regs(
        ret: ffi::c_ulong,
        func: ffi::c_ulong,
        frame_pointer: ffi::c_ulong,
        retp: *mut ffi::c_ulong,
        fregs: *mut ftrace_regs,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn ftrace_graph_get_ret_stack(
        task: *mut task_struct,
        skip: ffi::c_int,
    ) -> *mut ftrace_ret_stack;
}
extern "C" {
    pub fn ftrace_graph_top_ret_addr(task: *mut task_struct) -> ffi::c_ulong;
}
extern "C" {
    pub fn ftrace_graph_ret_addr(
        task: *mut task_struct,
        idx: *mut ffi::c_int,
        ret: ffi::c_ulong,
        retp: *mut ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn fgraph_get_task_var(gops: *mut fgraph_ops) -> *mut ffi::c_ulong;
}
extern "C" {
    pub fn register_ftrace_graph(ops: *mut fgraph_ops) -> ffi::c_int;
}
extern "C" {
    pub fn unregister_ftrace_graph(ops: *mut fgraph_ops);
}
extern "C" {
    pub static mut kill_ftrace_graph: static_key_false;
}
extern "C" {
    pub fn ftrace_graph_stop();
}
extern "C" {
    pub static mut ftrace_graph_return: trace_func_graph_ret_t;
}
extern "C" {
    pub static mut ftrace_graph_entry: trace_func_graph_ent_t;
}
extern "C" {
    pub fn ftrace_graph_init_task(t: *mut task_struct);
}
extern "C" {
    pub fn ftrace_graph_exit_task(t: *mut task_struct);
}
extern "C" {
    pub fn ftrace_graph_init_idle_task(t: *mut task_struct, cpu: ffi::c_int);
}
extern "C" {
    pub static mut function_trace_op: *mut ftrace_ops;
}
extern "C" {
    pub static mut ftrace_dump_on_oops: [ffi::c_char; 0usize];
}
extern "C" {
    pub fn ftrace_dump_on_oops_enabled() -> ffi::c_int;
}
extern "C" {
    pub static mut tracepoint_printk: ffi::c_int;
}
extern "C" {
    pub fn disable_trace_on_warning();
}
extern "C" {
    pub static mut __disable_trace_on_warning: ffi::c_int;
}
extern "C" {
    pub fn tracepoint_printk_sysctl(
        table: *const ctl_table,
        write: ffi::c_int,
        buffer: *mut ffi::c_void,
        lenp: *mut usize,
        ppos: *mut loff_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn arch_syscall_addr(nr: ffi::c_int) -> ffi::c_ulong;
}
#[repr(C, packed)]
pub struct objpool_slot {
    pub head: u32,
    pub tail: u32,
    pub last: u32,
    pub mask: u32,
    pub entries: __IncompleteArrayField<*mut ffi::c_void>,
}
impl Default for objpool_slot {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type objpool_init_obj_cb = ::core::option::Option<
    unsafe extern "C" fn(obj: *mut ffi::c_void, context: *mut ffi::c_void) -> ffi::c_int,
>;
pub type objpool_fini_cb = ::core::option::Option<
    unsafe extern "C" fn(head: *mut objpool_head, context: *mut ffi::c_void) -> ffi::c_int,
>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct objpool_head {
    pub obj_size: ffi::c_int,
    pub nr_objs: ffi::c_int,
    pub nr_possible_cpus: ffi::c_int,
    pub capacity: ffi::c_int,
    pub gfp: gfp_t,
    pub ref_: refcount_t,
    pub flags: ffi::c_ulong,
    pub cpu_slots: *mut *mut objpool_slot,
    pub release: objpool_fini_cb,
    pub context: *mut ffi::c_void,
}
impl Default for objpool_head {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn objpool_init(
        pool: *mut objpool_head,
        nr_objs: ffi::c_int,
        object_size: ffi::c_int,
        gfp: gfp_t,
        context: *mut ffi::c_void,
        objinit: objpool_init_obj_cb,
        release: objpool_fini_cb,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn objpool_drop(obj: *mut ffi::c_void, pool: *mut objpool_head) -> ffi::c_int;
}
extern "C" {
    pub fn objpool_free(pool: *mut objpool_head);
}
extern "C" {
    pub fn objpool_fini(pool: *mut objpool_head);
}
pub type rethook_handler_t = ::core::option::Option<
    unsafe extern "C" fn(
        arg1: *mut rethook_node,
        arg2: *mut ffi::c_void,
        arg3: ffi::c_ulong,
        arg4: *mut pt_regs,
    ),
>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rethook {
    pub data: *mut ffi::c_void,
    pub handler: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut rethook_node,
            arg2: *mut ffi::c_void,
            arg3: ffi::c_ulong,
            arg4: *mut pt_regs,
        ),
    >,
    pub pool: objpool_head,
    pub rcu: callback_head,
}
impl Default for rethook {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rethook_node {
    pub rcu: callback_head,
    pub llist: llist_node,
    pub rethook: *mut rethook,
    pub ret_addr: ffi::c_ulong,
    pub frame: ffi::c_ulong,
}
impl Default for rethook_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn rethook_alloc(
        data: *mut ffi::c_void,
        handler: rethook_handler_t,
        size: ffi::c_int,
        num: ffi::c_int,
    ) -> *mut rethook;
}
extern "C" {
    pub fn rethook_stop(rh: *mut rethook);
}
extern "C" {
    pub fn rethook_free(rh: *mut rethook);
}
extern "C" {
    pub fn rethook_try_get(rh: *mut rethook) -> *mut rethook_node;
}
extern "C" {
    pub fn rethook_recycle(node: *mut rethook_node);
}
extern "C" {
    pub fn rethook_hook(node: *mut rethook_node, regs: *mut pt_regs, mcount: bool_);
}
extern "C" {
    pub fn rethook_find_ret_addr(
        tsk: *mut task_struct,
        frame: ffi::c_ulong,
        cur: *mut *mut llist_node,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn arch_rethook_prepare(node: *mut rethook_node, regs: *mut pt_regs, mcount: bool_);
}
extern "C" {
    pub fn arch_rethook_trampoline();
}
extern "C" {
    pub fn arch_rethook_fixup_return(regs: *mut pt_regs, correct_ret_addr: ffi::c_ulong);
}
extern "C" {
    pub fn rethook_trampoline_handler(regs: *mut pt_regs, frame: ffi::c_ulong) -> ffi::c_ulong;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct prev_kprobe {
    pub kp: *mut kprobe,
    pub status: ffi::c_uint,
}
impl Default for prev_kprobe {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kprobe_ctlblk {
    pub kprobe_status: ffi::c_uint,
    pub saved_irqflag: ffi::c_ulong,
    pub prev_kprobe: prev_kprobe,
}
impl Default for kprobe_ctlblk {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn arch_remove_kprobe(arg1: *mut kprobe);
}
extern "C" {
    pub fn kprobe_fault_handler(regs: *mut pt_regs, fsr: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn __kretprobe_trampoline();
}
extern "C" {
    pub fn trampoline_probe_handler(regs: *mut pt_regs) -> *mut ffi::c_void;
}
pub type kprobe_pre_handler_t = ::core::option::Option<
    unsafe extern "C" fn(arg1: *mut kprobe, arg2: *mut pt_regs) -> ffi::c_int,
>;
pub type kprobe_post_handler_t = ::core::option::Option<
    unsafe extern "C" fn(arg1: *mut kprobe, arg2: *mut pt_regs, flags: ffi::c_ulong),
>;
pub type kretprobe_handler_t = ::core::option::Option<
    unsafe extern "C" fn(arg1: *mut kretprobe_instance, arg2: *mut pt_regs) -> ffi::c_int,
>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kprobe {
    pub hlist: hlist_node,
    pub list: list_head,
    pub nmissed: ffi::c_ulong,
    pub addr: *mut kprobe_opcode_t,
    pub symbol_name: *const ffi::c_char,
    pub offset: ffi::c_uint,
    pub pre_handler: kprobe_pre_handler_t,
    pub post_handler: kprobe_post_handler_t,
    pub opcode: kprobe_opcode_t,
    pub ainsn: arch_specific_insn,
    pub flags: u32_,
}
impl Default for kprobe {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kretprobe_holder {
    pub rp: *mut kretprobe,
    pub pool: objpool_head,
}
impl Default for kretprobe_holder {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kretprobe {
    pub kp: kprobe,
    pub handler: kretprobe_handler_t,
    pub entry_handler: kretprobe_handler_t,
    pub maxactive: ffi::c_int,
    pub nmissed: ffi::c_int,
    pub data_size: usize,
    pub rph: *mut kretprobe_holder,
}
impl Default for kretprobe {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct kretprobe_instance {
    pub rcu: callback_head,
    pub llist: llist_node,
    pub rph: *mut kretprobe_holder,
    pub ret_addr: *mut kprobe_opcode_t,
    pub fp: *mut ffi::c_void,
    pub data: __IncompleteArrayField<ffi::c_char>,
}
impl Default for kretprobe_instance {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kretprobe_blackpoint {
    pub name: *const ffi::c_char,
    pub addr: *mut ffi::c_void,
}
impl Default for kretprobe_blackpoint {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kprobe_blacklist_entry {
    pub list: list_head,
    pub start_addr: ffi::c_ulong,
    pub end_addr: ffi::c_ulong,
}
impl Default for kprobe_blacklist_entry {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut current_kprobe: *mut kprobe;
}
extern "C" {
    pub static mut kprobe_ctlblk: kprobe_ctlblk;
}
extern "C" {
    pub fn kprobe_busy_begin();
}
extern "C" {
    pub fn kprobe_busy_end();
}
extern "C" {
    pub fn arch_trampoline_kprobe(p: *mut kprobe) -> ffi::c_int;
}
extern "C" {
    pub fn arch_prepare_kretprobe(ri: *mut kretprobe_instance, regs: *mut pt_regs);
}
extern "C" {
    pub fn arch_kretprobe_fixup_return(regs: *mut pt_regs, correct_ret_addr: *mut kprobe_opcode_t);
}
extern "C" {
    pub fn __kretprobe_trampoline_handler(
        regs: *mut pt_regs,
        frame_pointer: *mut ffi::c_void,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub static mut __start_kprobe_blacklist: [ffi::c_ulong; 0usize];
}
extern "C" {
    pub static mut __stop_kprobe_blacklist: [ffi::c_ulong; 0usize];
}
extern "C" {
    pub static mut kretprobe_blacklist: [kretprobe_blackpoint; 0usize];
}
extern "C" {
    pub fn arch_prepare_kprobe(p: *mut kprobe) -> ffi::c_int;
}
extern "C" {
    pub fn arch_arm_kprobe(p: *mut kprobe);
}
extern "C" {
    pub fn arch_disarm_kprobe(p: *mut kprobe);
}
extern "C" {
    pub fn arch_init_kprobes() -> ffi::c_int;
}
extern "C" {
    pub fn kprobes_inc_nmissed_count(p: *mut kprobe);
}
extern "C" {
    pub fn arch_within_kprobe_blacklist(addr: ffi::c_ulong) -> bool_;
}
extern "C" {
    pub fn arch_populate_kprobe_blacklist() -> ffi::c_int;
}
extern "C" {
    pub fn kprobe_on_func_entry(
        addr: *mut kprobe_opcode_t,
        sym: *const ffi::c_char,
        offset: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn within_kprobe_blacklist(addr: ffi::c_ulong) -> bool_;
}
extern "C" {
    pub fn kprobe_add_ksym_blacklist(entry: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn kprobe_add_area_blacklist(start: ffi::c_ulong, end: ffi::c_ulong) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kprobe_insn_cache {
    pub mutex: mutex,
    pub alloc: ::core::option::Option<unsafe extern "C" fn() -> *mut ffi::c_void>,
    pub free: ::core::option::Option<unsafe extern "C" fn(arg1: *mut ffi::c_void)>,
    pub sym: *const ffi::c_char,
    pub pages: list_head,
    pub insn_size: usize,
    pub nr_garbage: ffi::c_int,
}
impl Default for kprobe_insn_cache {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn __get_insn_slot(c: *mut kprobe_insn_cache) -> *mut kprobe_opcode_t;
}
extern "C" {
    pub fn __free_insn_slot(
        c: *mut kprobe_insn_cache,
        slot: *mut kprobe_opcode_t,
        dirty: ffi::c_int,
    );
}
extern "C" {
    pub fn __is_insn_slot_addr(c: *mut kprobe_insn_cache, addr: ffi::c_ulong) -> bool_;
}
extern "C" {
    pub fn kprobe_cache_get_kallsym(
        c: *mut kprobe_insn_cache,
        symnum: *mut ffi::c_uint,
        value: *mut ffi::c_ulong,
        type_: *mut ffi::c_char,
        sym: *mut ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub static mut kprobe_insn_slots: kprobe_insn_cache;
}
extern "C" {
    pub fn get_kprobe(addr: *mut ffi::c_void) -> *mut kprobe;
}
extern "C" {
    pub fn kprobe_lookup_name(
        name: *const ffi::c_char,
        offset: ffi::c_uint,
    ) -> *mut kprobe_opcode_t;
}
extern "C" {
    pub fn arch_adjust_kprobe_addr(
        addr: ffi::c_ulong,
        offset: ffi::c_ulong,
        on_func_entry: *mut bool_,
    ) -> *mut kprobe_opcode_t;
}
extern "C" {
    pub fn register_kprobe(p: *mut kprobe) -> ffi::c_int;
}
extern "C" {
    pub fn unregister_kprobe(p: *mut kprobe);
}
extern "C" {
    pub fn register_kprobes(kps: *mut *mut kprobe, num: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn unregister_kprobes(kps: *mut *mut kprobe, num: ffi::c_int);
}
extern "C" {
    pub fn register_kretprobe(rp: *mut kretprobe) -> ffi::c_int;
}
extern "C" {
    pub fn unregister_kretprobe(rp: *mut kretprobe);
}
extern "C" {
    pub fn register_kretprobes(rps: *mut *mut kretprobe, num: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn unregister_kretprobes(rps: *mut *mut kretprobe, num: ffi::c_int);
}
extern "C" {
    pub fn kprobe_flush_task(tk: *mut task_struct);
}
extern "C" {
    pub fn kprobe_free_init_mem();
}
extern "C" {
    pub fn disable_kprobe(kp: *mut kprobe) -> ffi::c_int;
}
extern "C" {
    pub fn enable_kprobe(kp: *mut kprobe) -> ffi::c_int;
}
extern "C" {
    pub fn dump_kprobe(kp: *mut kprobe);
}
extern "C" {
    pub fn alloc_insn_page() -> *mut ffi::c_void;
}
extern "C" {
    pub fn alloc_optinsn_page() -> *mut ffi::c_void;
}
extern "C" {
    pub fn free_optinsn_page(page: *mut ffi::c_void);
}
extern "C" {
    pub fn kprobe_get_kallsym(
        symnum: ffi::c_uint,
        value: *mut ffi::c_ulong,
        type_: *mut ffi::c_char,
        sym: *mut ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn arch_kprobe_get_kallsym(
        symnum: *mut ffi::c_uint,
        value: *mut ffi::c_ulong,
        type_: *mut ffi::c_char,
        sym: *mut ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kprobe_exceptions_notify(
        self_: *mut notifier_block,
        val: ffi::c_ulong,
        data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kretprobe_find_ret_addr(
        tsk: *mut task_struct,
        fp: *mut ffi::c_void,
        cur: *mut *mut llist_node,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn kgdb_handle_bus_error();
}
extern "C" {
    pub static mut kgdb_fault_expected: ffi::c_int;
}
extern "C" {
    pub fn kgdb_skipexception(exception: ffi::c_int, regs: *mut pt_regs) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct uart_port {
    _unused: [u8; 0],
}
extern "C" {
    pub fn kgdb_breakpoint();
}
extern "C" {
    pub static mut kgdb_connected: ffi::c_int;
}
extern "C" {
    pub static mut kgdb_io_module_registered: ffi::c_int;
}
extern "C" {
    pub static mut kgdb_setting_breakpoint: atomic_t;
}
extern "C" {
    pub static mut kgdb_cpu_doing_single_step: atomic_t;
}
extern "C" {
    pub static mut kgdb_usethread: *mut task_struct;
}
extern "C" {
    pub static mut kgdb_contthread: *mut task_struct;
}
pub const kgdb_bptype_BP_BREAKPOINT: kgdb_bptype = 0;
pub const kgdb_bptype_BP_HARDWARE_BREAKPOINT: kgdb_bptype = 1;
pub const kgdb_bptype_BP_WRITE_WATCHPOINT: kgdb_bptype = 2;
pub const kgdb_bptype_BP_READ_WATCHPOINT: kgdb_bptype = 3;
pub const kgdb_bptype_BP_ACCESS_WATCHPOINT: kgdb_bptype = 4;
pub const kgdb_bptype_BP_POKE_BREAKPOINT: kgdb_bptype = 5;
pub type kgdb_bptype = ffi::c_uint;
pub const kgdb_bpstate_BP_UNDEFINED: kgdb_bpstate = 0;
pub const kgdb_bpstate_BP_REMOVED: kgdb_bpstate = 1;
pub const kgdb_bpstate_BP_SET: kgdb_bpstate = 2;
pub const kgdb_bpstate_BP_ACTIVE: kgdb_bpstate = 3;
pub type kgdb_bpstate = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kgdb_bkpt {
    pub bpt_addr: ffi::c_ulong,
    pub saved_instr: [ffi::c_uchar; 4usize],
    pub type_: kgdb_bptype,
    pub state: kgdb_bpstate,
}
impl Default for kgdb_bkpt {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct dbg_reg_def_t {
    pub name: *mut ffi::c_char,
    pub size: ffi::c_int,
    pub offset: ffi::c_int,
}
impl Default for dbg_reg_def_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut dbg_reg_def: [dbg_reg_def_t; 0usize];
}
extern "C" {
    pub fn dbg_get_reg(
        regno: ffi::c_int,
        mem: *mut ffi::c_void,
        regs: *mut pt_regs,
    ) -> *mut ffi::c_char;
}
extern "C" {
    pub fn dbg_set_reg(regno: ffi::c_int, mem: *mut ffi::c_void, regs: *mut pt_regs) -> ffi::c_int;
}
extern "C" {
    pub fn kgdb_arch_init() -> ffi::c_int;
}
extern "C" {
    pub fn kgdb_arch_exit();
}
extern "C" {
    pub fn pt_regs_to_gdb_regs(gdb_regs: *mut ffi::c_ulong, regs: *mut pt_regs);
}
extern "C" {
    pub fn sleeping_thread_to_gdb_regs(gdb_regs: *mut ffi::c_ulong, p: *mut task_struct);
}
extern "C" {
    pub fn gdb_regs_to_pt_regs(gdb_regs: *mut ffi::c_ulong, regs: *mut pt_regs);
}
extern "C" {
    pub fn kgdb_arch_handle_exception(
        vector: ffi::c_int,
        signo: ffi::c_int,
        err_code: ffi::c_int,
        remcom_in_buffer: *mut ffi::c_char,
        remcom_out_buffer: *mut ffi::c_char,
        regs: *mut pt_regs,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kgdb_arch_handle_qxfer_pkt(
        remcom_in_buffer: *mut ffi::c_char,
        remcom_out_buffer: *mut ffi::c_char,
    );
}
extern "C" {
    pub fn kgdb_call_nmi_hook(ignored: *mut ffi::c_void);
}
extern "C" {
    pub fn kgdb_roundup_cpus();
}
extern "C" {
    pub fn kgdb_arch_set_pc(regs: *mut pt_regs, pc: ffi::c_ulong);
}
extern "C" {
    pub fn kgdb_validate_break_address(addr: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn kgdb_arch_set_breakpoint(bpt: *mut kgdb_bkpt) -> ffi::c_int;
}
extern "C" {
    pub fn kgdb_arch_remove_breakpoint(bpt: *mut kgdb_bkpt) -> ffi::c_int;
}
extern "C" {
    pub fn kgdb_arch_late();
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct kgdb_arch {
    pub gdb_bpt_instr: [ffi::c_uchar; 4usize],
    pub flags: ffi::c_ulong,
    pub set_breakpoint: ::core::option::Option<
        unsafe extern "C" fn(arg1: ffi::c_ulong, arg2: *mut ffi::c_char) -> ffi::c_int,
    >,
    pub remove_breakpoint: ::core::option::Option<
        unsafe extern "C" fn(arg1: ffi::c_ulong, arg2: *mut ffi::c_char) -> ffi::c_int,
    >,
    pub set_hw_breakpoint: ::core::option::Option<
        unsafe extern "C" fn(arg1: ffi::c_ulong, arg2: ffi::c_int, arg3: kgdb_bptype) -> ffi::c_int,
    >,
    pub remove_hw_breakpoint: ::core::option::Option<
        unsafe extern "C" fn(arg1: ffi::c_ulong, arg2: ffi::c_int, arg3: kgdb_bptype) -> ffi::c_int,
    >,
    pub disable_hw_break: ::core::option::Option<unsafe extern "C" fn(regs: *mut pt_regs)>,
    pub remove_all_hw_break: ::core::option::Option<unsafe extern "C" fn()>,
    pub correct_hw_break: ::core::option::Option<unsafe extern "C" fn()>,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kgdb_io {
    pub name: *const ffi::c_char,
    pub read_char: ::core::option::Option<unsafe extern "C" fn() -> ffi::c_int>,
    pub write_char: ::core::option::Option<unsafe extern "C" fn(arg1: u8_)>,
    pub flush: ::core::option::Option<unsafe extern "C" fn()>,
    pub init: ::core::option::Option<unsafe extern "C" fn() -> ffi::c_int>,
    pub deinit: ::core::option::Option<unsafe extern "C" fn()>,
    pub pre_exception: ::core::option::Option<unsafe extern "C" fn()>,
    pub post_exception: ::core::option::Option<unsafe extern "C" fn()>,
    pub cons: *mut console,
}
impl Default for kgdb_io {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static arch_kgdb_ops: kgdb_arch;
}
extern "C" {
    pub fn kgdb_arch_pc(exception: ffi::c_int, regs: *mut pt_regs) -> ffi::c_ulong;
}
extern "C" {
    pub fn kgdb_register_io_module(local_kgdb_io_ops: *mut kgdb_io) -> ffi::c_int;
}
extern "C" {
    pub fn kgdb_unregister_io_module(local_kgdb_io_ops: *mut kgdb_io);
}
extern "C" {
    pub static mut dbg_io_ops: *mut kgdb_io;
}
extern "C" {
    pub fn kgdb_hex2long(ptr: *mut *mut ffi::c_char, long_val: *mut ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn kgdb_mem2hex(
        mem: *mut ffi::c_char,
        buf: *mut ffi::c_char,
        count: ffi::c_int,
    ) -> *mut ffi::c_char;
}
extern "C" {
    pub fn kgdb_hex2mem(
        buf: *mut ffi::c_char,
        mem: *mut ffi::c_char,
        count: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kgdb_isremovedbreak(addr: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn kgdb_has_hit_break(addr: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn kgdb_handle_exception(
        ex_vector: ffi::c_int,
        signo: ffi::c_int,
        err_code: ffi::c_int,
        regs: *mut pt_regs,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kgdb_nmicallback(cpu: ffi::c_int, regs: *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn kgdb_nmicallin(
        cpu: ffi::c_int,
        trapnr: ffi::c_int,
        regs: *mut ffi::c_void,
        err_code: ffi::c_int,
        snd_rdy: *mut atomic_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn gdbstub_exit(status: ffi::c_int);
}
extern "C" {
    pub static mut kgdb_single_step: ffi::c_int;
}
extern "C" {
    pub static mut kgdb_active: atomic_t;
}
extern "C" {
    pub static mut dbg_is_early: bool_;
}
extern "C" {
    pub fn dbg_late_init();
}
extern "C" {
    pub fn kgdb_panic(msg: *const ffi::c_char);
}
extern "C" {
    pub fn kgdb_free_init_mem();
}
extern "C" {
    pub fn caches_clean_inval_pou(start: ffi::c_ulong, end: ffi::c_ulong);
}
extern "C" {
    pub fn icache_inval_pou(start: ffi::c_ulong, end: ffi::c_ulong);
}
extern "C" {
    pub fn dcache_clean_inval_poc(start: ffi::c_ulong, end: ffi::c_ulong);
}
extern "C" {
    pub fn dcache_inval_poc(start: ffi::c_ulong, end: ffi::c_ulong);
}
extern "C" {
    pub fn dcache_clean_poc(start: ffi::c_ulong, end: ffi::c_ulong);
}
extern "C" {
    pub fn dcache_clean_pop(start: ffi::c_ulong, end: ffi::c_ulong);
}
extern "C" {
    pub fn dcache_clean_pou(start: ffi::c_ulong, end: ffi::c_ulong);
}
extern "C" {
    pub fn caches_clean_inval_user_pou(start: ffi::c_ulong, end: ffi::c_ulong) -> ffi::c_long;
}
extern "C" {
    pub fn sync_icache_aliases(start: ffi::c_ulong, end: ffi::c_ulong);
}
extern "C" {
    pub fn copy_to_user_page(
        arg1: *mut vm_area_struct,
        arg2: *mut page,
        arg3: ffi::c_ulong,
        arg4: *mut ffi::c_void,
        arg5: *const ffi::c_void,
        arg6: ffi::c_ulong,
    );
}
extern "C" {
    pub fn flush_dcache_page(arg1: *mut page);
}
extern "C" {
    pub fn flush_dcache_folio(arg1: *mut folio);
}
pub const dma_data_direction_DMA_BIDIRECTIONAL: dma_data_direction = 0;
pub const dma_data_direction_DMA_TO_DEVICE: dma_data_direction = 1;
pub const dma_data_direction_DMA_FROM_DEVICE: dma_data_direction = 2;
pub const dma_data_direction_DMA_NONE: dma_data_direction = 3;
pub type dma_data_direction = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct urb {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bio_vec {
    pub bv_page: *mut page,
    pub bv_len: ffi::c_uint,
    pub bv_offset: ffi::c_uint,
}
impl Default for bio_vec {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C, packed(4))]
#[derive(Default, Copy, Clone)]
pub struct bvec_iter {
    pub bi_sector: sector_t,
    pub bi_size: ffi::c_uint,
    pub bi_idx: ffi::c_uint,
    pub bi_bvec_done: ffi::c_uint,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bvec_iter_all {
    pub bv: bio_vec,
    pub idx: ffi::c_int,
    pub done: ffi::c_uint,
}
impl Default for bvec_iter_all {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct dev_printk_info {
    pub subsystem: [ffi::c_char; 16usize],
    pub device: [ffi::c_char; 48usize],
}
impl Default for dev_printk_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn dev_vprintk_emit(
        level: ffi::c_int,
        dev: *const device,
        fmt: *const ffi::c_char,
        args: va_list,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn dev_printk_emit(
        level: ffi::c_int,
        dev: *const device,
        fmt: *const ffi::c_char,
        ...
    ) -> ffi::c_int;
}
extern "C" {
    pub fn _dev_printk(level: *const ffi::c_char, dev: *const device, fmt: *const ffi::c_char, ...);
}
extern "C" {
    pub fn _dev_emerg(dev: *const device, fmt: *const ffi::c_char, ...);
}
extern "C" {
    pub fn _dev_alert(dev: *const device, fmt: *const ffi::c_char, ...);
}
extern "C" {
    pub fn _dev_crit(dev: *const device, fmt: *const ffi::c_char, ...);
}
extern "C" {
    pub fn _dev_err(dev: *const device, fmt: *const ffi::c_char, ...);
}
extern "C" {
    pub fn _dev_warn(dev: *const device, fmt: *const ffi::c_char, ...);
}
extern "C" {
    pub fn _dev_notice(dev: *const device, fmt: *const ffi::c_char, ...);
}
extern "C" {
    pub fn _dev_info(dev: *const device, fmt: *const ffi::c_char, ...);
}
extern "C" {
    pub fn dev_err_probe(
        dev: *const device,
        err: ffi::c_int,
        fmt: *const ffi::c_char,
        ...
    ) -> ffi::c_int;
}
extern "C" {
    pub fn dev_warn_probe(
        dev: *const device,
        err: ffi::c_int,
        fmt: *const ffi::c_char,
        ...
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct cpufreq_policy {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct update_util_data {
    pub func: ::core::option::Option<
        unsafe extern "C" fn(data: *mut update_util_data, time: u64_, flags: ffi::c_uint),
    >,
}
extern "C" {
    pub fn cpufreq_add_update_util_hook(
        cpu: ffi::c_int,
        data: *mut update_util_data,
        func: ::core::option::Option<
            unsafe extern "C" fn(data: *mut update_util_data, time: u64_, flags: ffi::c_uint),
        >,
    );
}
extern "C" {
    pub fn cpufreq_remove_update_util_hook(cpu: ffi::c_int);
}
extern "C" {
    pub fn cpufreq_this_cpu_can_update(policy: *mut cpufreq_policy) -> bool_;
}
pub const cpu_idle_type___CPU_NOT_IDLE: cpu_idle_type = 0;
pub const cpu_idle_type_CPU_IDLE: cpu_idle_type = 1;
pub const cpu_idle_type_CPU_NEWLY_IDLE: cpu_idle_type = 2;
pub const cpu_idle_type_CPU_MAX_IDLE_TYPES: cpu_idle_type = 3;
pub type cpu_idle_type = ffi::c_uint;
extern "C" {
    pub fn wake_up_if_idle(cpu: ffi::c_int);
}
pub const __SD_BALANCE_NEWIDLE: _bindgen_ty_115 = 0;
pub const __SD_BALANCE_EXEC: _bindgen_ty_115 = 1;
pub const __SD_BALANCE_FORK: _bindgen_ty_115 = 2;
pub const __SD_BALANCE_WAKE: _bindgen_ty_115 = 3;
pub const __SD_WAKE_AFFINE: _bindgen_ty_115 = 4;
pub const __SD_ASYM_CPUCAPACITY: _bindgen_ty_115 = 5;
pub const __SD_ASYM_CPUCAPACITY_FULL: _bindgen_ty_115 = 6;
pub const __SD_SHARE_CPUCAPACITY: _bindgen_ty_115 = 7;
pub const __SD_CLUSTER: _bindgen_ty_115 = 8;
pub const __SD_SHARE_LLC: _bindgen_ty_115 = 9;
pub const __SD_SERIALIZE: _bindgen_ty_115 = 10;
pub const __SD_ASYM_PACKING: _bindgen_ty_115 = 11;
pub const __SD_PREFER_SIBLING: _bindgen_ty_115 = 12;
pub const __SD_OVERLAP: _bindgen_ty_115 = 13;
pub const __SD_NUMA: _bindgen_ty_115 = 14;
pub const __SD_FLAG_CNT: _bindgen_ty_115 = 15;
pub type _bindgen_ty_115 = ffi::c_uint;
pub const SD_BALANCE_NEWIDLE: _bindgen_ty_116 = 1;
pub const SD_BALANCE_EXEC: _bindgen_ty_116 = 2;
pub const SD_BALANCE_FORK: _bindgen_ty_116 = 4;
pub const SD_BALANCE_WAKE: _bindgen_ty_116 = 8;
pub const SD_WAKE_AFFINE: _bindgen_ty_116 = 16;
pub const SD_ASYM_CPUCAPACITY: _bindgen_ty_116 = 32;
pub const SD_ASYM_CPUCAPACITY_FULL: _bindgen_ty_116 = 64;
pub const SD_SHARE_CPUCAPACITY: _bindgen_ty_116 = 128;
pub const SD_CLUSTER: _bindgen_ty_116 = 256;
pub const SD_SHARE_LLC: _bindgen_ty_116 = 512;
pub const SD_SERIALIZE: _bindgen_ty_116 = 1024;
pub const SD_ASYM_PACKING: _bindgen_ty_116 = 2048;
pub const SD_PREFER_SIBLING: _bindgen_ty_116 = 4096;
pub const SD_OVERLAP: _bindgen_ty_116 = 8192;
pub const SD_NUMA: _bindgen_ty_116 = 16384;
pub type _bindgen_ty_116 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sd_flag_debug {
    pub meta_flags: ffi::c_uint,
    pub name: *mut ffi::c_char,
}
impl Default for sd_flag_debug {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static sd_flag_debug: [sd_flag_debug; 0usize];
}
extern "C" {
    pub fn arch_asym_cpu_priority(cpu: ffi::c_int) -> ffi::c_int;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sched_domain_attr {
    pub relax_domain_level: ffi::c_int,
}
extern "C" {
    pub static mut sched_domain_level_max: ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sched_group {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sched_domain_shared {
    pub ref_: atomic_t,
    pub nr_busy_cpus: atomic_t,
    pub has_idle_cores: ffi::c_int,
    pub nr_idle_scan: ffi::c_int,
}
#[repr(C)]
pub struct sched_domain {
    pub parent: *mut sched_domain,
    pub child: *mut sched_domain,
    pub groups: *mut sched_group,
    pub min_interval: ffi::c_ulong,
    pub max_interval: ffi::c_ulong,
    pub busy_factor: ffi::c_uint,
    pub imbalance_pct: ffi::c_uint,
    pub cache_nice_tries: ffi::c_uint,
    pub imb_numa_nr: ffi::c_uint,
    pub nohz_idle: ffi::c_int,
    pub flags: ffi::c_int,
    pub level: ffi::c_int,
    pub last_balance: ffi::c_ulong,
    pub balance_interval: ffi::c_uint,
    pub nr_balance_failed: ffi::c_uint,
    pub max_newidle_lb_cost: u64_,
    pub last_decay_max_lb_cost: ffi::c_ulong,
    pub lb_count: [ffi::c_uint; 3usize],
    pub lb_failed: [ffi::c_uint; 3usize],
    pub lb_balanced: [ffi::c_uint; 3usize],
    pub lb_imbalance_load: [ffi::c_uint; 3usize],
    pub lb_imbalance_util: [ffi::c_uint; 3usize],
    pub lb_imbalance_task: [ffi::c_uint; 3usize],
    pub lb_imbalance_misfit: [ffi::c_uint; 3usize],
    pub lb_gained: [ffi::c_uint; 3usize],
    pub lb_hot_gained: [ffi::c_uint; 3usize],
    pub lb_nobusyg: [ffi::c_uint; 3usize],
    pub lb_nobusyq: [ffi::c_uint; 3usize],
    pub alb_count: ffi::c_uint,
    pub alb_failed: ffi::c_uint,
    pub alb_pushed: ffi::c_uint,
    pub sbe_count: ffi::c_uint,
    pub sbe_balanced: ffi::c_uint,
    pub sbe_pushed: ffi::c_uint,
    pub sbf_count: ffi::c_uint,
    pub sbf_balanced: ffi::c_uint,
    pub sbf_pushed: ffi::c_uint,
    pub ttwu_wake_remote: ffi::c_uint,
    pub ttwu_move_affine: ffi::c_uint,
    pub ttwu_move_balance: ffi::c_uint,
    pub name: *mut ffi::c_char,
    pub __bindgen_anon_1: sched_domain__bindgen_ty_1,
    pub shared: *mut sched_domain_shared,
    pub span_weight: ffi::c_uint,
    pub span: __IncompleteArrayField<ffi::c_ulong>,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sched_domain__bindgen_ty_1 {
    pub private: *mut ffi::c_void,
    pub rcu: callback_head,
}
impl Default for sched_domain__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for sched_domain {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn partition_sched_domains(
        ndoms_new: ffi::c_int,
        doms_new: *mut cpumask_var_t,
        dattr_new: *mut sched_domain_attr,
    );
}
extern "C" {
    pub fn alloc_sched_domains(ndoms: ffi::c_uint) -> *mut cpumask_var_t;
}
extern "C" {
    pub fn free_sched_domains(doms: *mut cpumask_var_t, ndoms: ffi::c_uint);
}
extern "C" {
    pub fn cpus_equal_capacity(this_cpu: ffi::c_int, that_cpu: ffi::c_int) -> bool_;
}
extern "C" {
    pub fn cpus_share_cache(this_cpu: ffi::c_int, that_cpu: ffi::c_int) -> bool_;
}
extern "C" {
    pub fn cpus_share_resources(this_cpu: ffi::c_int, that_cpu: ffi::c_int) -> bool_;
}
pub type sched_domain_mask_f =
    ::core::option::Option<unsafe extern "C" fn(cpu: ffi::c_int) -> *const cpumask>;
pub type sched_domain_flags_f = ::core::option::Option<unsafe extern "C" fn() -> ffi::c_int>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sd_data {
    pub sd: *mut *mut sched_domain,
    pub sds: *mut *mut sched_domain_shared,
    pub sg: *mut *mut sched_group,
    pub sgc: *mut *mut sched_group_capacity,
}
impl Default for sd_data {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sched_domain_topology_level {
    pub mask: sched_domain_mask_f,
    pub sd_flags: sched_domain_flags_f,
    pub flags: ffi::c_int,
    pub numa_level: ffi::c_int,
    pub data: sd_data,
    pub name: *mut ffi::c_char,
}
impl Default for sched_domain_topology_level {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn set_sched_topology(tl: *mut sched_domain_topology_level);
}
extern "C" {
    pub fn rebuild_sched_domains_energy();
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct em_perf_state {
    pub performance: ffi::c_ulong,
    pub frequency: ffi::c_ulong,
    pub power: ffi::c_ulong,
    pub cost: ffi::c_ulong,
    pub flags: ffi::c_ulong,
}
#[repr(C)]
pub struct em_perf_table {
    pub rcu: callback_head,
    pub kref: kref,
    pub state: __IncompleteArrayField<em_perf_state>,
}
impl Default for em_perf_table {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct em_perf_domain {
    pub em_table: *mut em_perf_table,
    pub nr_perf_states: ffi::c_int,
    pub min_perf_state: ffi::c_int,
    pub max_perf_state: ffi::c_int,
    pub flags: ffi::c_ulong,
    pub cpus: __IncompleteArrayField<ffi::c_ulong>,
}
impl Default for em_perf_domain {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct em_data_callback {
    pub active_power: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut device,
            power: *mut ffi::c_ulong,
            freq: *mut ffi::c_ulong,
        ) -> ffi::c_int,
    >,
    pub get_cost: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut device,
            freq: ffi::c_ulong,
            cost: *mut ffi::c_ulong,
        ) -> ffi::c_int,
    >,
}
extern "C" {
    pub fn em_cpu_get(cpu: ffi::c_int) -> *mut em_perf_domain;
}
extern "C" {
    pub fn em_pd_get(dev: *mut device) -> *mut em_perf_domain;
}
extern "C" {
    pub fn em_dev_update_perf_domain(dev: *mut device, new_table: *mut em_perf_table)
        -> ffi::c_int;
}
extern "C" {
    pub fn em_dev_register_perf_domain(
        dev: *mut device,
        nr_states: ffi::c_uint,
        cb: *const em_data_callback,
        cpus: *const cpumask_t,
        microwatts: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn em_dev_unregister_perf_domain(dev: *mut device);
}
extern "C" {
    pub fn em_table_alloc(pd: *mut em_perf_domain) -> *mut em_perf_table;
}
extern "C" {
    pub fn em_table_free(table: *mut em_perf_table);
}
extern "C" {
    pub fn em_dev_compute_costs(
        dev: *mut device,
        table: *mut em_perf_state,
        nr_states: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn em_dev_update_chip_binning(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn em_update_performance_limits(
        pd: *mut em_perf_domain,
        freq_min_khz: ffi::c_ulong,
        freq_max_khz: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn em_rebuild_sched_domains();
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct klist {
    pub k_lock: spinlock_t,
    pub k_list: list_head,
    pub get: ::core::option::Option<unsafe extern "C" fn(arg1: *mut klist_node)>,
    pub put: ::core::option::Option<unsafe extern "C" fn(arg1: *mut klist_node)>,
}
impl Default for klist {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn klist_init(
        k: *mut klist,
        get: ::core::option::Option<unsafe extern "C" fn(arg1: *mut klist_node)>,
        put: ::core::option::Option<unsafe extern "C" fn(arg1: *mut klist_node)>,
    );
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct klist_node {
    pub n_klist: *mut ffi::c_void,
    pub n_node: list_head,
    pub n_ref: kref,
}
impl Default for klist_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn klist_add_tail(n: *mut klist_node, k: *mut klist);
}
extern "C" {
    pub fn klist_add_head(n: *mut klist_node, k: *mut klist);
}
extern "C" {
    pub fn klist_add_behind(n: *mut klist_node, pos: *mut klist_node);
}
extern "C" {
    pub fn klist_add_before(n: *mut klist_node, pos: *mut klist_node);
}
extern "C" {
    pub fn klist_del(n: *mut klist_node);
}
extern "C" {
    pub fn klist_remove(n: *mut klist_node);
}
extern "C" {
    pub fn klist_node_attached(n: *mut klist_node) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct klist_iter {
    pub i_klist: *mut klist,
    pub i_cur: *mut klist_node,
}
impl Default for klist_iter {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn klist_iter_init(k: *mut klist, i: *mut klist_iter);
}
extern "C" {
    pub fn klist_iter_init_node(k: *mut klist, i: *mut klist_iter, n: *mut klist_node);
}
extern "C" {
    pub fn klist_iter_exit(i: *mut klist_iter);
}
extern "C" {
    pub fn klist_prev(i: *mut klist_iter) -> *mut klist_node;
}
extern "C" {
    pub fn klist_next(i: *mut klist_iter) -> *mut klist_node;
}
extern "C" {
    pub static mut pm_power_off: ::core::option::Option<unsafe extern "C" fn()>;
}
extern "C" {
    pub fn pm_vt_switch_required(dev: *mut device, required: bool_);
}
extern "C" {
    pub fn pm_vt_switch_unregister(dev: *mut device);
}
extern "C" {
    pub fn cxl_mem_active() -> bool_;
}
extern "C" {
    pub static power_group_name: [ffi::c_char; 0usize];
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pm_message {
    pub event: ffi::c_int,
}
pub type pm_message_t = pm_message;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct dev_pm_ops {
    pub prepare: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub complete: ::core::option::Option<unsafe extern "C" fn(dev: *mut device)>,
    pub suspend: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub resume: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub freeze: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub thaw: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub poweroff: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub restore: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub suspend_late: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub resume_early: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub freeze_late: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub thaw_early: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub poweroff_late: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub restore_early: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub suspend_noirq: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub resume_noirq: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub freeze_noirq: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub thaw_noirq: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub poweroff_noirq:
        ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub restore_noirq: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub runtime_suspend:
        ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub runtime_resume:
        ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub runtime_idle: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
}
pub const rpm_status_RPM_INVALID: rpm_status = -1;
pub const rpm_status_RPM_ACTIVE: rpm_status = 0;
pub const rpm_status_RPM_RESUMING: rpm_status = 1;
pub const rpm_status_RPM_SUSPENDED: rpm_status = 2;
pub const rpm_status_RPM_SUSPENDING: rpm_status = 3;
pub const rpm_status_RPM_BLOCKED: rpm_status = 4;
pub type rpm_status = ffi::c_int;
pub const rpm_request_RPM_REQ_NONE: rpm_request = 0;
pub const rpm_request_RPM_REQ_IDLE: rpm_request = 1;
pub const rpm_request_RPM_REQ_SUSPEND: rpm_request = 2;
pub const rpm_request_RPM_REQ_AUTOSUSPEND: rpm_request = 3;
pub const rpm_request_RPM_REQ_RESUME: rpm_request = 4;
pub type rpm_request = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct wake_irq {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct pm_domain_data {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct pm_subsys_data {
    pub lock: spinlock_t,
    pub refcount: ffi::c_uint,
    pub clock_op_might_sleep: ffi::c_uint,
    pub clock_mutex: mutex,
    pub clock_list: list_head,
    pub domain_data: *mut pm_domain_data,
}
impl Default for pm_subsys_data {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct dev_pm_info {
    pub power_state: pm_message_t,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
    pub driver_flags: u32_,
    pub lock: spinlock_t,
    pub entry: list_head,
    pub completion: completion,
    pub wakeup: *mut wakeup_source,
    pub _bitfield_align_2: [u8; 0],
    pub _bitfield_2: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub suspend_timer: hrtimer,
    pub timer_expires: u64_,
    pub work: work_struct,
    pub wait_queue: wait_queue_head_t,
    pub wakeirq: *mut wake_irq,
    pub usage_count: atomic_t,
    pub child_count: atomic_t,
    pub _bitfield_align_3: [u8; 0],
    pub _bitfield_3: __BindgenBitfieldUnit<[u8; 2usize]>,
    pub links_count: ffi::c_uint,
    pub request: rpm_request,
    pub runtime_status: rpm_status,
    pub last_status: rpm_status,
    pub runtime_error: ffi::c_int,
    pub autosuspend_delay: ffi::c_int,
    pub last_busy: u64_,
    pub active_time: u64_,
    pub suspended_time: u64_,
    pub accounting_timestamp: u64_,
    pub subsys_data: *mut pm_subsys_data,
    pub set_latency_tolerance:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut device, arg2: s32)>,
    pub qos: *mut dev_pm_qos,
}
impl Default for dev_pm_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl dev_pm_info {
    #[inline]
    pub fn can_wakeup(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_can_wakeup(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn can_wakeup_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_can_wakeup_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn async_suspend(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_async_suspend(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn async_suspend_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_async_suspend_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn in_dpm_list(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_in_dpm_list(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn in_dpm_list_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_in_dpm_list_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn is_prepared(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_is_prepared(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn is_prepared_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_is_prepared_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn is_suspended(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_is_suspended(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn is_suspended_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_is_suspended_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn is_noirq_suspended(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_is_noirq_suspended(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(5usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn is_noirq_suspended_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_is_noirq_suspended_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn is_late_suspended(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_is_late_suspended(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(6usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn is_late_suspended_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                6usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_is_late_suspended_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                6usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn no_pm(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_no_pm(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(7usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn no_pm_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                7usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_no_pm_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                7usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn early_init(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(8usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_early_init(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(8usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn early_init_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                8usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_early_init_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                8usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn direct_complete(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(9usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_direct_complete(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(9usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn direct_complete_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                9usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_direct_complete_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                9usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        can_wakeup: bool_,
        async_suspend: bool_,
        in_dpm_list: bool_,
        is_prepared: bool_,
        is_suspended: bool_,
        is_noirq_suspended: bool_,
        is_late_suspended: bool_,
        no_pm: bool_,
        early_init: bool_,
        direct_complete: bool_,
    ) -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let can_wakeup: u8 = unsafe { ::core::mem::transmute(can_wakeup) };
            can_wakeup as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let async_suspend: u8 = unsafe { ::core::mem::transmute(async_suspend) };
            async_suspend as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let in_dpm_list: u8 = unsafe { ::core::mem::transmute(in_dpm_list) };
            in_dpm_list as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let is_prepared: u8 = unsafe { ::core::mem::transmute(is_prepared) };
            is_prepared as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let is_suspended: u8 = unsafe { ::core::mem::transmute(is_suspended) };
            is_suspended as u64
        });
        __bindgen_bitfield_unit.set(5usize, 1u8, {
            let is_noirq_suspended: u8 = unsafe { ::core::mem::transmute(is_noirq_suspended) };
            is_noirq_suspended as u64
        });
        __bindgen_bitfield_unit.set(6usize, 1u8, {
            let is_late_suspended: u8 = unsafe { ::core::mem::transmute(is_late_suspended) };
            is_late_suspended as u64
        });
        __bindgen_bitfield_unit.set(7usize, 1u8, {
            let no_pm: u8 = unsafe { ::core::mem::transmute(no_pm) };
            no_pm as u64
        });
        __bindgen_bitfield_unit.set(8usize, 1u8, {
            let early_init: u8 = unsafe { ::core::mem::transmute(early_init) };
            early_init as u64
        });
        __bindgen_bitfield_unit.set(9usize, 1u8, {
            let direct_complete: u8 = unsafe { ::core::mem::transmute(direct_complete) };
            direct_complete as u64
        });
        __bindgen_bitfield_unit
    }
    #[inline]
    pub fn wakeup_path(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_wakeup_path(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn wakeup_path_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                0usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_wakeup_path_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn syscore(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(1usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_syscore(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn syscore_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                1usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_syscore_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn no_pm_callbacks(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(2usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_no_pm_callbacks(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn no_pm_callbacks_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                2usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_no_pm_callbacks_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn work_in_progress(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(3usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_work_in_progress(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn work_in_progress_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                3usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_work_in_progress_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn smart_suspend(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(4usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_smart_suspend(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn smart_suspend_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                4usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_smart_suspend_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn must_resume(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(5usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_must_resume(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(5usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn must_resume_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                5usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_must_resume_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                5usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn may_skip_resume(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(6usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_may_skip_resume(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(6usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn may_skip_resume_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                6usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_may_skip_resume_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                6usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_2(
        wakeup_path: bool_,
        syscore: bool_,
        no_pm_callbacks: bool_,
        work_in_progress: bool_,
        smart_suspend: bool_,
        must_resume: bool_,
        may_skip_resume: bool_,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let wakeup_path: u8 = unsafe { ::core::mem::transmute(wakeup_path) };
            wakeup_path as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let syscore: u8 = unsafe { ::core::mem::transmute(syscore) };
            syscore as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let no_pm_callbacks: u8 = unsafe { ::core::mem::transmute(no_pm_callbacks) };
            no_pm_callbacks as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let work_in_progress: u8 = unsafe { ::core::mem::transmute(work_in_progress) };
            work_in_progress as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let smart_suspend: u8 = unsafe { ::core::mem::transmute(smart_suspend) };
            smart_suspend as u64
        });
        __bindgen_bitfield_unit.set(5usize, 1u8, {
            let must_resume: u8 = unsafe { ::core::mem::transmute(must_resume) };
            must_resume as u64
        });
        __bindgen_bitfield_unit.set(6usize, 1u8, {
            let may_skip_resume: u8 = unsafe { ::core::mem::transmute(may_skip_resume) };
            may_skip_resume as u64
        });
        __bindgen_bitfield_unit
    }
    #[inline]
    pub fn disable_depth(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_3.get(0usize, 3u8) as u32) }
    }
    #[inline]
    pub fn set_disable_depth(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_3.set(0usize, 3u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn disable_depth_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_3),
                0usize,
                3u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_disable_depth_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_3),
                0usize,
                3u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn idle_notification(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_3.get(3usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_idle_notification(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_3.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn idle_notification_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_3),
                3usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_idle_notification_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_3),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn request_pending(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_3.get(4usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_request_pending(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_3.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn request_pending_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_3),
                4usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_request_pending_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_3),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn deferred_resume(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_3.get(5usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_deferred_resume(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_3.set(5usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn deferred_resume_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_3),
                5usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_deferred_resume_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_3),
                5usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn needs_force_resume(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_3.get(6usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_needs_force_resume(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_3.set(6usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn needs_force_resume_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_3),
                6usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_needs_force_resume_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_3),
                6usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn runtime_auto(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_3.get(7usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_runtime_auto(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_3.set(7usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn runtime_auto_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_3),
                7usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_runtime_auto_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_3),
                7usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ignore_children(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_3.get(8usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_ignore_children(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_3.set(8usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ignore_children_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_3),
                8usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_ignore_children_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_3),
                8usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn no_callbacks(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_3.get(9usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_no_callbacks(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_3.set(9usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn no_callbacks_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_3),
                9usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_no_callbacks_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_3),
                9usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn irq_safe(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_3.get(10usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_irq_safe(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_3.set(10usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn irq_safe_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_3),
                10usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_irq_safe_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_3),
                10usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn use_autosuspend(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_3.get(11usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_use_autosuspend(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_3.set(11usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn use_autosuspend_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_3),
                11usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_use_autosuspend_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_3),
                11usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn timer_autosuspends(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_3.get(12usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_timer_autosuspends(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_3.set(12usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn timer_autosuspends_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_3),
                12usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_timer_autosuspends_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_3),
                12usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn memalloc_noio(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_3.get(13usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_memalloc_noio(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_3.set(13usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn memalloc_noio_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_3),
                13usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_memalloc_noio_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_3),
                13usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_3(
        disable_depth: ffi::c_uint,
        idle_notification: bool_,
        request_pending: bool_,
        deferred_resume: bool_,
        needs_force_resume: bool_,
        runtime_auto: bool_,
        ignore_children: bool_,
        no_callbacks: bool_,
        irq_safe: bool_,
        use_autosuspend: bool_,
        timer_autosuspends: bool_,
        memalloc_noio: bool_,
    ) -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 3u8, {
            let disable_depth: u32 = unsafe { ::core::mem::transmute(disable_depth) };
            disable_depth as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let idle_notification: u8 = unsafe { ::core::mem::transmute(idle_notification) };
            idle_notification as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let request_pending: u8 = unsafe { ::core::mem::transmute(request_pending) };
            request_pending as u64
        });
        __bindgen_bitfield_unit.set(5usize, 1u8, {
            let deferred_resume: u8 = unsafe { ::core::mem::transmute(deferred_resume) };
            deferred_resume as u64
        });
        __bindgen_bitfield_unit.set(6usize, 1u8, {
            let needs_force_resume: u8 = unsafe { ::core::mem::transmute(needs_force_resume) };
            needs_force_resume as u64
        });
        __bindgen_bitfield_unit.set(7usize, 1u8, {
            let runtime_auto: u8 = unsafe { ::core::mem::transmute(runtime_auto) };
            runtime_auto as u64
        });
        __bindgen_bitfield_unit.set(8usize, 1u8, {
            let ignore_children: u8 = unsafe { ::core::mem::transmute(ignore_children) };
            ignore_children as u64
        });
        __bindgen_bitfield_unit.set(9usize, 1u8, {
            let no_callbacks: u8 = unsafe { ::core::mem::transmute(no_callbacks) };
            no_callbacks as u64
        });
        __bindgen_bitfield_unit.set(10usize, 1u8, {
            let irq_safe: u8 = unsafe { ::core::mem::transmute(irq_safe) };
            irq_safe as u64
        });
        __bindgen_bitfield_unit.set(11usize, 1u8, {
            let use_autosuspend: u8 = unsafe { ::core::mem::transmute(use_autosuspend) };
            use_autosuspend as u64
        });
        __bindgen_bitfield_unit.set(12usize, 1u8, {
            let timer_autosuspends: u8 = unsafe { ::core::mem::transmute(timer_autosuspends) };
            timer_autosuspends as u64
        });
        __bindgen_bitfield_unit.set(13usize, 1u8, {
            let memalloc_noio: u8 = unsafe { ::core::mem::transmute(memalloc_noio) };
            memalloc_noio as u64
        });
        __bindgen_bitfield_unit
    }
}
extern "C" {
    pub fn dev_pm_get_subsys_data(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn dev_pm_put_subsys_data(dev: *mut device);
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct dev_pm_domain {
    pub ops: dev_pm_ops,
    pub start: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub detach: ::core::option::Option<unsafe extern "C" fn(dev: *mut device, power_off: bool_)>,
    pub activate: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub sync: ::core::option::Option<unsafe extern "C" fn(dev: *mut device)>,
    pub dismiss: ::core::option::Option<unsafe extern "C" fn(dev: *mut device)>,
    pub set_performance_state: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut device, state: ffi::c_uint) -> ffi::c_int,
    >,
}
extern "C" {
    pub fn device_pm_lock();
}
extern "C" {
    pub fn dpm_resume_start(state: pm_message_t);
}
extern "C" {
    pub fn dpm_resume_end(state: pm_message_t);
}
extern "C" {
    pub fn dpm_resume_noirq(state: pm_message_t);
}
extern "C" {
    pub fn dpm_resume_early(state: pm_message_t);
}
extern "C" {
    pub fn dpm_resume(state: pm_message_t);
}
extern "C" {
    pub fn dpm_complete(state: pm_message_t);
}
extern "C" {
    pub fn device_pm_unlock();
}
extern "C" {
    pub fn dpm_suspend_end(state: pm_message_t) -> ffi::c_int;
}
extern "C" {
    pub fn dpm_suspend_start(state: pm_message_t) -> ffi::c_int;
}
extern "C" {
    pub fn dpm_suspend_noirq(state: pm_message_t) -> ffi::c_int;
}
extern "C" {
    pub fn dpm_suspend_late(state: pm_message_t) -> ffi::c_int;
}
extern "C" {
    pub fn dpm_suspend(state: pm_message_t) -> ffi::c_int;
}
extern "C" {
    pub fn dpm_prepare(state: pm_message_t) -> ffi::c_int;
}
extern "C" {
    pub fn __suspend_report_result(
        function: *const ffi::c_char,
        dev: *mut device,
        fn_: *mut ffi::c_void,
        ret: ffi::c_int,
    );
}
extern "C" {
    pub fn device_pm_wait_for_dev(sub: *mut device, dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn dpm_for_each_dev(
        data: *mut ffi::c_void,
        fn_: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut device, arg2: *mut ffi::c_void),
        >,
    );
}
extern "C" {
    pub fn pm_generic_prepare(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn pm_generic_suspend_late(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn pm_generic_suspend_noirq(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn pm_generic_suspend(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn pm_generic_resume_early(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn pm_generic_resume_noirq(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn pm_generic_resume(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn pm_generic_freeze_noirq(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn pm_generic_freeze(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn pm_generic_thaw_noirq(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn pm_generic_thaw(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn pm_generic_restore_noirq(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn pm_generic_restore_early(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn pm_generic_restore(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn pm_generic_poweroff_noirq(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn pm_generic_poweroff_late(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn pm_generic_poweroff(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn pm_generic_complete(dev: *mut device);
}
extern "C" {
    pub fn dev_pm_skip_resume(dev: *mut device) -> bool_;
}
extern "C" {
    pub fn dev_pm_skip_suspend(dev: *mut device) -> bool_;
}
pub const dpm_order_DPM_ORDER_NONE: dpm_order = 0;
pub const dpm_order_DPM_ORDER_DEV_AFTER_PARENT: dpm_order = 1;
pub const dpm_order_DPM_ORDER_PARENT_BEFORE_DEV: dpm_order = 2;
pub const dpm_order_DPM_ORDER_DEV_LAST: dpm_order = 3;
pub type dpm_order = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bus_type {
    pub name: *const ffi::c_char,
    pub dev_name: *const ffi::c_char,
    pub bus_groups: *mut *const attribute_group,
    pub dev_groups: *mut *const attribute_group,
    pub drv_groups: *mut *const attribute_group,
    pub match_: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut device, drv: *const device_driver) -> ffi::c_int,
    >,
    pub uevent: ::core::option::Option<
        unsafe extern "C" fn(dev: *const device, env: *mut kobj_uevent_env) -> ffi::c_int,
    >,
    pub probe: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub sync_state: ::core::option::Option<unsafe extern "C" fn(dev: *mut device)>,
    pub remove: ::core::option::Option<unsafe extern "C" fn(dev: *mut device)>,
    pub shutdown: ::core::option::Option<unsafe extern "C" fn(dev: *mut device)>,
    pub irq_get_affinity: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut device, irq_vec: ffi::c_uint) -> *const cpumask,
    >,
    pub online: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub offline: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub suspend: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut device, state: pm_message_t) -> ffi::c_int,
    >,
    pub resume: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub num_vf: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub dma_configure: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub dma_cleanup: ::core::option::Option<unsafe extern "C" fn(dev: *mut device)>,
    pub pm: *const dev_pm_ops,
    pub need_parent_lock: bool_,
}
impl Default for bus_type {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    #[must_use]
    pub fn bus_register(bus: *const bus_type) -> ffi::c_int;
}
extern "C" {
    pub fn bus_unregister(bus: *const bus_type);
}
extern "C" {
    #[must_use]
    pub fn bus_rescan_devices(bus: *const bus_type) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bus_attribute {
    pub attr: attribute,
    pub show: ::core::option::Option<
        unsafe extern "C" fn(bus: *const bus_type, buf: *mut ffi::c_char) -> isize,
    >,
    pub store: ::core::option::Option<
        unsafe extern "C" fn(bus: *const bus_type, buf: *const ffi::c_char, count: usize) -> isize,
    >,
}
impl Default for bus_attribute {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    #[must_use]
    pub fn bus_create_file(bus: *const bus_type, attr: *mut bus_attribute) -> ffi::c_int;
}
extern "C" {
    pub fn bus_remove_file(bus: *const bus_type, attr: *mut bus_attribute);
}
pub type device_match_t = ::core::option::Option<
    unsafe extern "C" fn(dev: *mut device, data: *const ffi::c_void) -> ffi::c_int,
>;
extern "C" {
    pub fn device_match_name(dev: *mut device, name: *const ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn device_match_type(dev: *mut device, type_: *const ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn device_match_of_node(dev: *mut device, np: *const ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn device_match_fwnode(dev: *mut device, fwnode: *const ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn device_match_devt(dev: *mut device, pdevt: *const ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn device_match_acpi_dev(dev: *mut device, adev: *const ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn device_match_acpi_handle(dev: *mut device, handle: *const ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn device_match_any(dev: *mut device, unused: *const ffi::c_void) -> ffi::c_int;
}
pub type device_iter_t = ::core::option::Option<
    unsafe extern "C" fn(dev: *mut device, data: *mut ffi::c_void) -> ffi::c_int,
>;
extern "C" {
    pub fn bus_for_each_dev(
        bus: *const bus_type,
        start: *mut device,
        data: *mut ffi::c_void,
        fn_: device_iter_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bus_find_device(
        bus: *const bus_type,
        start: *mut device,
        data: *const ffi::c_void,
        match_: device_match_t,
    ) -> *mut device;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct acpi_device {
    _unused: [u8; 0],
}
extern "C" {
    pub fn bus_for_each_drv(
        bus: *const bus_type,
        start: *mut device_driver,
        data: *mut ffi::c_void,
        fn_: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut device_driver, arg2: *mut ffi::c_void) -> ffi::c_int,
        >,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bus_sort_breadthfirst(
        bus: *const bus_type,
        compare: ::core::option::Option<
            unsafe extern "C" fn(a: *const device, b: *const device) -> ffi::c_int,
        >,
    );
}
extern "C" {
    pub fn bus_register_notifier(bus: *const bus_type, nb: *mut notifier_block) -> ffi::c_int;
}
extern "C" {
    pub fn bus_unregister_notifier(bus: *const bus_type, nb: *mut notifier_block) -> ffi::c_int;
}
pub const bus_notifier_event_BUS_NOTIFY_ADD_DEVICE: bus_notifier_event = 0;
pub const bus_notifier_event_BUS_NOTIFY_DEL_DEVICE: bus_notifier_event = 1;
pub const bus_notifier_event_BUS_NOTIFY_REMOVED_DEVICE: bus_notifier_event = 2;
pub const bus_notifier_event_BUS_NOTIFY_BIND_DRIVER: bus_notifier_event = 3;
pub const bus_notifier_event_BUS_NOTIFY_BOUND_DRIVER: bus_notifier_event = 4;
pub const bus_notifier_event_BUS_NOTIFY_UNBIND_DRIVER: bus_notifier_event = 5;
pub const bus_notifier_event_BUS_NOTIFY_UNBOUND_DRIVER: bus_notifier_event = 6;
pub const bus_notifier_event_BUS_NOTIFY_DRIVER_NOT_BOUND: bus_notifier_event = 7;
pub type bus_notifier_event = ffi::c_uint;
extern "C" {
    pub fn bus_get_kset(bus: *const bus_type) -> *mut kset;
}
extern "C" {
    pub fn bus_get_dev_root(bus: *const bus_type) -> *mut device;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class {
    pub name: *const ffi::c_char,
    pub class_groups: *mut *const attribute_group,
    pub dev_groups: *mut *const attribute_group,
    pub dev_uevent: ::core::option::Option<
        unsafe extern "C" fn(dev: *const device, env: *mut kobj_uevent_env) -> ffi::c_int,
    >,
    pub devnode: ::core::option::Option<
        unsafe extern "C" fn(dev: *const device, mode: *mut umode_t) -> *mut ffi::c_char,
    >,
    pub class_release: ::core::option::Option<unsafe extern "C" fn(class: *const class)>,
    pub dev_release: ::core::option::Option<unsafe extern "C" fn(dev: *mut device)>,
    pub shutdown_pre: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub ns_type: *const kobj_ns_type_operations,
    pub namespace:
        ::core::option::Option<unsafe extern "C" fn(dev: *const device) -> *const ffi::c_void>,
    pub get_ownership: ::core::option::Option<
        unsafe extern "C" fn(dev: *const device, uid: *mut kuid_t, gid: *mut kgid_t),
    >,
    pub pm: *const dev_pm_ops,
}
impl Default for class {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_dev_iter {
    pub ki: klist_iter,
    pub type_: *const device_type,
    pub sp: *mut subsys_private,
}
impl Default for class_dev_iter {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    #[must_use]
    pub fn class_register(class: *const class) -> ffi::c_int;
}
extern "C" {
    pub fn class_unregister(class: *const class);
}
extern "C" {
    pub fn class_is_registered(class: *const class) -> bool_;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_compat {
    _unused: [u8; 0],
}
extern "C" {
    pub fn class_compat_register(name: *const ffi::c_char) -> *mut class_compat;
}
extern "C" {
    pub fn class_compat_unregister(cls: *mut class_compat);
}
extern "C" {
    pub fn class_compat_create_link(cls: *mut class_compat, dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn class_compat_remove_link(cls: *mut class_compat, dev: *mut device);
}
extern "C" {
    pub fn class_dev_iter_init(
        iter: *mut class_dev_iter,
        class: *const class,
        start: *const device,
        type_: *const device_type,
    );
}
extern "C" {
    pub fn class_dev_iter_next(iter: *mut class_dev_iter) -> *mut device;
}
extern "C" {
    pub fn class_dev_iter_exit(iter: *mut class_dev_iter);
}
extern "C" {
    pub fn class_for_each_device(
        class: *const class,
        start: *const device,
        data: *mut ffi::c_void,
        fn_: device_iter_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn class_find_device(
        class: *const class,
        start: *const device,
        data: *const ffi::c_void,
        match_: device_match_t,
    ) -> *mut device;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_attribute {
    pub attr: attribute,
    pub show: ::core::option::Option<
        unsafe extern "C" fn(
            class: *const class,
            attr: *const class_attribute,
            buf: *mut ffi::c_char,
        ) -> isize,
    >,
    pub store: ::core::option::Option<
        unsafe extern "C" fn(
            class: *const class,
            attr: *const class_attribute,
            buf: *const ffi::c_char,
            count: usize,
        ) -> isize,
    >,
}
impl Default for class_attribute {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    #[must_use]
    pub fn class_create_file_ns(
        class: *const class,
        attr: *const class_attribute,
        ns: *const ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn class_remove_file_ns(
        class: *const class,
        attr: *const class_attribute,
        ns: *const ffi::c_void,
    );
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_attribute_string {
    pub attr: class_attribute,
    pub str_: *mut ffi::c_char,
}
impl Default for class_attribute_string {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn show_class_attr_string(
        class: *const class,
        attr: *const class_attribute,
        buf: *mut ffi::c_char,
    ) -> isize;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_interface {
    pub node: list_head,
    pub class: *const class,
    pub add_dev: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub remove_dev: ::core::option::Option<unsafe extern "C" fn(dev: *mut device)>,
}
impl Default for class_interface {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    #[must_use]
    pub fn class_interface_register(arg1: *mut class_interface) -> ffi::c_int;
}
extern "C" {
    pub fn class_interface_unregister(arg1: *mut class_interface);
}
extern "C" {
    #[must_use]
    pub fn class_create(name: *const ffi::c_char) -> *mut class;
}
extern "C" {
    pub fn class_destroy(cls: *const class);
}
pub type dr_release_t =
    ::core::option::Option<unsafe extern "C" fn(dev: *mut device, res: *mut ffi::c_void)>;
pub type dr_match_t = ::core::option::Option<
    unsafe extern "C" fn(
        dev: *mut device,
        res: *mut ffi::c_void,
        match_data: *mut ffi::c_void,
    ) -> ffi::c_int,
>;
extern "C" {
    pub fn __devres_alloc_node(
        release: dr_release_t,
        size: usize,
        gfp: gfp_t,
        nid: ffi::c_int,
        name: *const ffi::c_char,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn devres_for_each_res(
        dev: *mut device,
        release: dr_release_t,
        match_: dr_match_t,
        match_data: *mut ffi::c_void,
        fn_: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut device, arg2: *mut ffi::c_void, arg3: *mut ffi::c_void),
        >,
        data: *mut ffi::c_void,
    );
}
extern "C" {
    pub fn devres_free(res: *mut ffi::c_void);
}
extern "C" {
    pub fn devres_add(dev: *mut device, res: *mut ffi::c_void);
}
extern "C" {
    pub fn devres_find(
        dev: *mut device,
        release: dr_release_t,
        match_: dr_match_t,
        match_data: *mut ffi::c_void,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn devres_get(
        dev: *mut device,
        new_res: *mut ffi::c_void,
        match_: dr_match_t,
        match_data: *mut ffi::c_void,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn devres_remove(
        dev: *mut device,
        release: dr_release_t,
        match_: dr_match_t,
        match_data: *mut ffi::c_void,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn devres_destroy(
        dev: *mut device,
        release: dr_release_t,
        match_: dr_match_t,
        match_data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn devres_release(
        dev: *mut device,
        release: dr_release_t,
        match_: dr_match_t,
        match_data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn devres_open_group(
        dev: *mut device,
        id: *mut ffi::c_void,
        gfp: gfp_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn devres_close_group(dev: *mut device, id: *mut ffi::c_void);
}
extern "C" {
    pub fn devres_remove_group(dev: *mut device, id: *mut ffi::c_void);
}
extern "C" {
    pub fn devres_release_group(dev: *mut device, id: *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn devm_kmalloc(dev: *mut device, size: usize, gfp: gfp_t) -> *mut ffi::c_void;
}
extern "C" {
    #[must_use]
    pub fn devm_krealloc(
        dev: *mut device,
        ptr: *mut ffi::c_void,
        size: usize,
        gfp: gfp_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn devm_kfree(dev: *mut device, p: *const ffi::c_void);
}
extern "C" {
    pub fn devm_kmemdup(
        dev: *mut device,
        src: *const ffi::c_void,
        len: usize,
        gfp: gfp_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn devm_kstrdup(dev: *mut device, s: *const ffi::c_char, gfp: gfp_t) -> *mut ffi::c_char;
}
extern "C" {
    pub fn devm_kstrdup_const(
        dev: *mut device,
        s: *const ffi::c_char,
        gfp: gfp_t,
    ) -> *const ffi::c_char;
}
extern "C" {
    pub fn devm_kvasprintf(
        dev: *mut device,
        gfp: gfp_t,
        fmt: *const ffi::c_char,
        ap: va_list,
    ) -> *mut ffi::c_char;
}
extern "C" {
    pub fn devm_kasprintf(
        dev: *mut device,
        gfp: gfp_t,
        fmt: *const ffi::c_char,
        ...
    ) -> *mut ffi::c_char;
}
extern "C" {
    pub fn devm_get_free_pages(
        dev: *mut device,
        gfp_mask: gfp_t,
        order: ffi::c_uint,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn devm_free_pages(dev: *mut device, addr: ffi::c_ulong);
}
extern "C" {
    pub fn devm_ioremap_resource(dev: *mut device, res: *const resource) -> *mut ffi::c_void;
}
extern "C" {
    pub fn devm_ioremap_resource_wc(dev: *mut device, res: *const resource) -> *mut ffi::c_void;
}
extern "C" {
    pub fn devm_of_iomap(
        dev: *mut device,
        node: *mut device_node,
        index: ffi::c_int,
        size: *mut resource_size_t,
    ) -> *mut ffi::c_void;
}
pub const probe_type_PROBE_DEFAULT_STRATEGY: probe_type = 0;
pub const probe_type_PROBE_PREFER_ASYNCHRONOUS: probe_type = 1;
pub const probe_type_PROBE_FORCE_SYNCHRONOUS: probe_type = 2;
pub type probe_type = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct device_driver {
    pub name: *const ffi::c_char,
    pub bus: *const bus_type,
    pub owner: *mut module,
    pub mod_name: *const ffi::c_char,
    pub suppress_bind_attrs: bool_,
    pub probe_type: probe_type,
    pub of_match_table: *const of_device_id,
    pub acpi_match_table: *const acpi_device_id,
    pub probe: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub sync_state: ::core::option::Option<unsafe extern "C" fn(dev: *mut device)>,
    pub remove: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub shutdown: ::core::option::Option<unsafe extern "C" fn(dev: *mut device)>,
    pub suspend: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut device, state: pm_message_t) -> ffi::c_int,
    >,
    pub resume: ::core::option::Option<unsafe extern "C" fn(dev: *mut device) -> ffi::c_int>,
    pub groups: *mut *const attribute_group,
    pub dev_groups: *mut *const attribute_group,
    pub pm: *const dev_pm_ops,
    pub coredump: ::core::option::Option<unsafe extern "C" fn(dev: *mut device)>,
    pub p: *mut driver_private,
}
impl Default for device_driver {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    #[must_use]
    pub fn driver_register(drv: *mut device_driver) -> ffi::c_int;
}
extern "C" {
    pub fn driver_unregister(drv: *mut device_driver);
}
extern "C" {
    pub fn driver_find(name: *const ffi::c_char, bus: *const bus_type) -> *mut device_driver;
}
extern "C" {
    pub fn driver_probe_done() -> bool_;
}
extern "C" {
    pub fn wait_for_device_probe();
}
extern "C" {
    pub fn wait_for_init_devices_probe();
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct driver_attribute {
    pub attr: attribute,
    pub show: ::core::option::Option<
        unsafe extern "C" fn(driver: *mut device_driver, buf: *mut ffi::c_char) -> isize,
    >,
    pub store: ::core::option::Option<
        unsafe extern "C" fn(
            driver: *mut device_driver,
            buf: *const ffi::c_char,
            count: usize,
        ) -> isize,
    >,
}
impl Default for driver_attribute {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    #[must_use]
    pub fn driver_create_file(
        driver: *const device_driver,
        attr: *const driver_attribute,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn driver_remove_file(driver: *const device_driver, attr: *const driver_attribute);
}
extern "C" {
    pub fn driver_set_override(
        dev: *mut device,
        override_: *mut *const ffi::c_char,
        s: *const ffi::c_char,
        len: usize,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn driver_for_each_device(
        drv: *mut device_driver,
        start: *mut device,
        data: *mut ffi::c_void,
        fn_: device_iter_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn driver_find_device(
        drv: *const device_driver,
        start: *mut device,
        data: *const ffi::c_void,
        match_: device_match_t,
    ) -> *mut device;
}
extern "C" {
    pub fn driver_deferred_probe_add(dev: *mut device);
}
extern "C" {
    pub fn driver_deferred_probe_check_state(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn driver_init();
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct dev_archdata {}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pdev_archdata {}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct device_private {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct driver_private {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct subsys_private {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct iommu_group {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct dev_pin_info {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct dev_iommu {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct msi_device_data {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct subsys_interface {
    pub name: *const ffi::c_char,
    pub subsys: *const bus_type,
    pub node: list_head,
    pub add_dev: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut device, sif: *mut subsys_interface) -> ffi::c_int,
    >,
    pub remove_dev:
        ::core::option::Option<unsafe extern "C" fn(dev: *mut device, sif: *mut subsys_interface)>,
}
impl Default for subsys_interface {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn subsys_interface_register(sif: *mut subsys_interface) -> ffi::c_int;
}
extern "C" {
    pub fn subsys_interface_unregister(sif: *mut subsys_interface);
}
extern "C" {
    pub fn subsys_system_register(
        subsys: *const bus_type,
        groups: *mut *const attribute_group,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn subsys_virtual_register(
        subsys: *const bus_type,
        groups: *mut *const attribute_group,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct device_type {
    pub name: *const ffi::c_char,
    pub groups: *mut *const attribute_group,
    pub uevent: ::core::option::Option<
        unsafe extern "C" fn(dev: *const device, env: *mut kobj_uevent_env) -> ffi::c_int,
    >,
    pub devnode: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *const device,
            mode: *mut umode_t,
            uid: *mut kuid_t,
            gid: *mut kgid_t,
        ) -> *mut ffi::c_char,
    >,
    pub release: ::core::option::Option<unsafe extern "C" fn(dev: *mut device)>,
    pub pm: *const dev_pm_ops,
}
impl Default for device_type {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct device_attribute {
    pub attr: attribute,
    pub show: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut device,
            attr: *mut device_attribute,
            buf: *mut ffi::c_char,
        ) -> isize,
    >,
    pub store: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut device,
            attr: *mut device_attribute,
            buf: *const ffi::c_char,
            count: usize,
        ) -> isize,
    >,
}
impl Default for device_attribute {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct dev_ext_attribute {
    pub attr: device_attribute,
    pub var: *mut ffi::c_void,
}
impl Default for dev_ext_attribute {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn device_show_ulong(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *mut ffi::c_char,
    ) -> isize;
}
extern "C" {
    pub fn device_store_ulong(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *const ffi::c_char,
        count: usize,
    ) -> isize;
}
extern "C" {
    pub fn device_show_int(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *mut ffi::c_char,
    ) -> isize;
}
extern "C" {
    pub fn device_store_int(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *const ffi::c_char,
        count: usize,
    ) -> isize;
}
extern "C" {
    pub fn device_show_bool(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *mut ffi::c_char,
    ) -> isize;
}
extern "C" {
    pub fn device_store_bool(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *const ffi::c_char,
        count: usize,
    ) -> isize;
}
extern "C" {
    pub fn device_show_string(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *mut ffi::c_char,
    ) -> isize;
}
extern "C" {
    pub fn device_create_file(device: *mut device, entry: *const device_attribute) -> ffi::c_int;
}
extern "C" {
    pub fn device_remove_file(dev: *mut device, attr: *const device_attribute);
}
extern "C" {
    pub fn device_remove_file_self(dev: *mut device, attr: *const device_attribute) -> bool_;
}
extern "C" {
    #[must_use]
    pub fn device_create_bin_file(dev: *mut device, attr: *const bin_attribute) -> ffi::c_int;
}
extern "C" {
    pub fn device_remove_bin_file(dev: *mut device, attr: *const bin_attribute);
}
extern "C" {
    pub fn devm_remove_action_nowarn(
        dev: *mut device,
        action: ::core::option::Option<unsafe extern "C" fn(arg1: *mut ffi::c_void)>,
        data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn devm_release_action(
        dev: *mut device,
        action: ::core::option::Option<unsafe extern "C" fn(arg1: *mut ffi::c_void)>,
        data: *mut ffi::c_void,
    );
}
extern "C" {
    pub fn __devm_add_action(
        dev: *mut device,
        action: ::core::option::Option<unsafe extern "C" fn(arg1: *mut ffi::c_void)>,
        data: *mut ffi::c_void,
        name: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __devm_alloc_percpu(dev: *mut device, size: usize, align: usize) -> *mut ffi::c_void;
}
extern "C" {
    pub fn devm_free_percpu(dev: *mut device, pdata: *mut ffi::c_void);
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct device_dma_parameters {
    pub max_segment_size: ffi::c_uint,
    pub min_align_mask: ffi::c_uint,
    pub segment_boundary_mask: ffi::c_ulong,
}
pub const device_link_state_DL_STATE_NONE: device_link_state = -1;
pub const device_link_state_DL_STATE_DORMANT: device_link_state = 0;
pub const device_link_state_DL_STATE_AVAILABLE: device_link_state = 1;
pub const device_link_state_DL_STATE_CONSUMER_PROBE: device_link_state = 2;
pub const device_link_state_DL_STATE_ACTIVE: device_link_state = 3;
pub const device_link_state_DL_STATE_SUPPLIER_UNBIND: device_link_state = 4;
pub type device_link_state = ffi::c_int;
pub const dl_dev_state_DL_DEV_NO_DRIVER: dl_dev_state = 0;
pub const dl_dev_state_DL_DEV_PROBING: dl_dev_state = 1;
pub const dl_dev_state_DL_DEV_DRIVER_BOUND: dl_dev_state = 2;
pub const dl_dev_state_DL_DEV_UNBINDING: dl_dev_state = 3;
pub type dl_dev_state = ffi::c_uint;
pub const device_removable_DEVICE_REMOVABLE_NOT_SUPPORTED: device_removable = 0;
pub const device_removable_DEVICE_REMOVABLE_UNKNOWN: device_removable = 1;
pub const device_removable_DEVICE_FIXED: device_removable = 2;
pub const device_removable_DEVICE_REMOVABLE: device_removable = 3;
pub type device_removable = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct dev_links_info {
    pub suppliers: list_head,
    pub consumers: list_head,
    pub defer_sync: list_head,
    pub status: dl_dev_state,
}
impl Default for dev_links_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct dev_msi_info {
    pub domain: *mut irq_domain,
    pub data: *mut msi_device_data,
}
impl Default for dev_msi_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const device_physical_location_panel_DEVICE_PANEL_TOP: device_physical_location_panel = 0;
pub const device_physical_location_panel_DEVICE_PANEL_BOTTOM: device_physical_location_panel = 1;
pub const device_physical_location_panel_DEVICE_PANEL_LEFT: device_physical_location_panel = 2;
pub const device_physical_location_panel_DEVICE_PANEL_RIGHT: device_physical_location_panel = 3;
pub const device_physical_location_panel_DEVICE_PANEL_FRONT: device_physical_location_panel = 4;
pub const device_physical_location_panel_DEVICE_PANEL_BACK: device_physical_location_panel = 5;
pub const device_physical_location_panel_DEVICE_PANEL_UNKNOWN: device_physical_location_panel = 6;
pub type device_physical_location_panel = ffi::c_uint;
pub const device_physical_location_vertical_position_DEVICE_VERT_POS_UPPER:
    device_physical_location_vertical_position = 0;
pub const device_physical_location_vertical_position_DEVICE_VERT_POS_CENTER:
    device_physical_location_vertical_position = 1;
pub const device_physical_location_vertical_position_DEVICE_VERT_POS_LOWER:
    device_physical_location_vertical_position = 2;
pub type device_physical_location_vertical_position = ffi::c_uint;
pub const device_physical_location_horizontal_position_DEVICE_HORI_POS_LEFT:
    device_physical_location_horizontal_position = 0;
pub const device_physical_location_horizontal_position_DEVICE_HORI_POS_CENTER:
    device_physical_location_horizontal_position = 1;
pub const device_physical_location_horizontal_position_DEVICE_HORI_POS_RIGHT:
    device_physical_location_horizontal_position = 2;
pub type device_physical_location_horizontal_position = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct device_physical_location {
    pub panel: device_physical_location_panel,
    pub vertical_position: device_physical_location_vertical_position,
    pub horizontal_position: device_physical_location_horizontal_position,
    pub dock: bool_,
    pub lid: bool_,
}
impl Default for device_physical_location {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct device {
    pub kobj: kobject,
    pub parent: *mut device,
    pub p: *mut device_private,
    pub init_name: *const ffi::c_char,
    pub type_: *const device_type,
    pub bus: *const bus_type,
    pub driver: *mut device_driver,
    pub platform_data: *mut ffi::c_void,
    pub driver_data: *mut ffi::c_void,
    pub mutex: mutex,
    pub links: dev_links_info,
    pub power: dev_pm_info,
    pub pm_domain: *mut dev_pm_domain,
    pub em_pd: *mut em_perf_domain,
    pub pins: *mut dev_pin_info,
    pub msi: dev_msi_info,
    pub dma_mask: *mut u64_,
    pub coherent_dma_mask: u64_,
    pub bus_dma_limit: u64_,
    pub dma_range_map: *mut bus_dma_region,
    pub dma_parms: *mut device_dma_parameters,
    pub dma_pools: list_head,
    pub dma_mem: *mut dma_coherent_mem,
    pub cma_area: *mut cma,
    pub dma_io_tlb_mem: *mut io_tlb_mem,
    pub archdata: dev_archdata,
    pub of_node: *mut device_node,
    pub fwnode: *mut fwnode_handle,
    pub numa_node: ffi::c_int,
    pub devt: dev_t,
    pub id: u32_,
    pub devres_lock: spinlock_t,
    pub devres_head: list_head,
    pub class: *const class,
    pub groups: *mut *const attribute_group,
    pub release: ::core::option::Option<unsafe extern "C" fn(dev: *mut device)>,
    pub iommu_group: *mut iommu_group,
    pub iommu: *mut dev_iommu,
    pub physical_location: *mut device_physical_location,
    pub removable: device_removable,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub __bindgen_padding_0: [u8; 3usize],
}
impl Default for device {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl device {
    #[inline]
    pub fn offline_disabled(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_offline_disabled(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn offline_disabled_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_offline_disabled_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn offline(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_offline(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn offline_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_offline_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn of_node_reused(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_of_node_reused(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn of_node_reused_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_of_node_reused_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn state_synced(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_state_synced(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn state_synced_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_state_synced_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn can_match(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_can_match(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn can_match_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_can_match_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn dma_coherent(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_dma_coherent(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(5usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn dma_coherent_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_dma_coherent_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn dma_skip_sync(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_dma_skip_sync(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(6usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn dma_skip_sync_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                6usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_dma_skip_sync_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                6usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn dma_iommu(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_dma_iommu(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(7usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn dma_iommu_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                7usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_dma_iommu_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                7usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        offline_disabled: bool_,
        offline: bool_,
        of_node_reused: bool_,
        state_synced: bool_,
        can_match: bool_,
        dma_coherent: bool_,
        dma_skip_sync: bool_,
        dma_iommu: bool_,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let offline_disabled: u8 = unsafe { ::core::mem::transmute(offline_disabled) };
            offline_disabled as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let offline: u8 = unsafe { ::core::mem::transmute(offline) };
            offline as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let of_node_reused: u8 = unsafe { ::core::mem::transmute(of_node_reused) };
            of_node_reused as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let state_synced: u8 = unsafe { ::core::mem::transmute(state_synced) };
            state_synced as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let can_match: u8 = unsafe { ::core::mem::transmute(can_match) };
            can_match as u64
        });
        __bindgen_bitfield_unit.set(5usize, 1u8, {
            let dma_coherent: u8 = unsafe { ::core::mem::transmute(dma_coherent) };
            dma_coherent as u64
        });
        __bindgen_bitfield_unit.set(6usize, 1u8, {
            let dma_skip_sync: u8 = unsafe { ::core::mem::transmute(dma_skip_sync) };
            dma_skip_sync as u64
        });
        __bindgen_bitfield_unit.set(7usize, 1u8, {
            let dma_iommu: u8 = unsafe { ::core::mem::transmute(dma_iommu) };
            dma_iommu as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct device_link {
    pub supplier: *mut device,
    pub s_node: list_head,
    pub consumer: *mut device,
    pub c_node: list_head,
    pub link_dev: device,
    pub status: device_link_state,
    pub flags: u32_,
    pub rpm_active: refcount_t,
    pub kref: kref,
    pub rm_work: work_struct,
    pub supplier_preactivated: bool_,
}
impl Default for device_link {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct wakeup_source {
    pub name: *const ffi::c_char,
    pub id: ffi::c_int,
    pub entry: list_head,
    pub lock: spinlock_t,
    pub wakeirq: *mut wake_irq,
    pub timer: timer_list,
    pub timer_expires: ffi::c_ulong,
    pub total_time: ktime_t,
    pub max_time: ktime_t,
    pub last_time: ktime_t,
    pub start_prevent_time: ktime_t,
    pub prevent_sleep_time: ktime_t,
    pub event_count: ffi::c_ulong,
    pub active_count: ffi::c_ulong,
    pub relax_count: ffi::c_ulong,
    pub expire_count: ffi::c_ulong,
    pub wakeup_count: ffi::c_ulong,
    pub dev: *mut device,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub __bindgen_padding_0: [u8; 7usize],
}
impl Default for wakeup_source {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl wakeup_source {
    #[inline]
    pub fn active(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_active(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn active_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_active_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn autosleep_enabled(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_autosleep_enabled(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn autosleep_enabled_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_autosleep_enabled_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        active: bool_,
        autosleep_enabled: bool_,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let active: u8 = unsafe { ::core::mem::transmute(active) };
            active as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let autosleep_enabled: u8 = unsafe { ::core::mem::transmute(autosleep_enabled) };
            autosleep_enabled as u64
        });
        __bindgen_bitfield_unit
    }
}
extern "C" {
    pub fn wakeup_source_create(name: *const ffi::c_char) -> *mut wakeup_source;
}
extern "C" {
    pub fn wakeup_source_destroy(ws: *mut wakeup_source);
}
extern "C" {
    pub fn wakeup_source_add(ws: *mut wakeup_source);
}
extern "C" {
    pub fn wakeup_source_remove(ws: *mut wakeup_source);
}
extern "C" {
    pub fn wakeup_source_register(dev: *mut device, name: *const ffi::c_char)
        -> *mut wakeup_source;
}
extern "C" {
    pub fn wakeup_source_unregister(ws: *mut wakeup_source);
}
extern "C" {
    pub fn wakeup_sources_read_lock() -> ffi::c_int;
}
extern "C" {
    pub fn wakeup_sources_read_unlock(idx: ffi::c_int);
}
extern "C" {
    pub fn wakeup_sources_walk_start() -> *mut wakeup_source;
}
extern "C" {
    pub fn wakeup_sources_walk_next(ws: *mut wakeup_source) -> *mut wakeup_source;
}
extern "C" {
    pub fn device_wakeup_enable(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn device_wakeup_disable(dev: *mut device);
}
extern "C" {
    pub fn device_set_wakeup_capable(dev: *mut device, capable: bool_);
}
extern "C" {
    pub fn device_set_wakeup_enable(dev: *mut device, enable: bool_) -> ffi::c_int;
}
extern "C" {
    pub fn __pm_stay_awake(ws: *mut wakeup_source);
}
extern "C" {
    pub fn pm_stay_awake(dev: *mut device);
}
extern "C" {
    pub fn __pm_relax(ws: *mut wakeup_source);
}
extern "C" {
    pub fn pm_relax(dev: *mut device);
}
extern "C" {
    pub fn pm_wakeup_ws_event(ws: *mut wakeup_source, msec: ffi::c_uint, hard: bool_);
}
extern "C" {
    pub fn pm_wakeup_dev_event(dev: *mut device, msec: ffi::c_uint, hard: bool_);
}
extern "C" {
    pub fn dev_set_name(dev: *mut device, name: *const ffi::c_char, ...) -> ffi::c_int;
}
pub type class_device_t = *mut device;
pub const class_device_is_conditional: bool_ = false;
extern "C" {
    #[must_use]
    pub fn device_register(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn device_unregister(dev: *mut device);
}
extern "C" {
    pub fn device_initialize(dev: *mut device);
}
extern "C" {
    #[must_use]
    pub fn device_add(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn device_del(dev: *mut device);
}
extern "C" {
    pub fn device_for_each_child(
        parent: *mut device,
        data: *mut ffi::c_void,
        fn_: device_iter_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn device_for_each_child_reverse(
        parent: *mut device,
        data: *mut ffi::c_void,
        fn_: device_iter_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn device_for_each_child_reverse_from(
        parent: *mut device,
        from: *mut device,
        data: *mut ffi::c_void,
        fn_: device_iter_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn device_find_child(
        parent: *mut device,
        data: *const ffi::c_void,
        match_: device_match_t,
    ) -> *mut device;
}
extern "C" {
    pub fn device_rename(dev: *mut device, new_name: *const ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub fn device_move(
        dev: *mut device,
        new_parent: *mut device,
        dpm_order: dpm_order,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn device_change_owner(dev: *mut device, kuid: kuid_t, kgid: kgid_t) -> ffi::c_int;
}
extern "C" {
    pub fn lock_device_hotplug();
}
extern "C" {
    pub fn unlock_device_hotplug();
}
extern "C" {
    pub fn lock_device_hotplug_sysfs() -> ffi::c_int;
}
extern "C" {
    pub fn device_offline(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn device_online(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn set_primary_fwnode(dev: *mut device, fwnode: *mut fwnode_handle);
}
extern "C" {
    pub fn set_secondary_fwnode(dev: *mut device, fwnode: *mut fwnode_handle);
}
extern "C" {
    pub fn device_set_node(dev: *mut device, fwnode: *mut fwnode_handle);
}
extern "C" {
    pub fn device_add_of_node(dev: *mut device, of_node: *mut device_node) -> ffi::c_int;
}
extern "C" {
    pub fn device_remove_of_node(dev: *mut device);
}
extern "C" {
    pub fn device_set_of_node_from_dev(dev: *mut device, dev2: *const device);
}
extern "C" {
    pub fn __root_device_register(name: *const ffi::c_char, owner: *mut module) -> *mut device;
}
extern "C" {
    pub fn root_device_unregister(root: *mut device);
}
extern "C" {
    #[must_use]
    pub fn device_driver_attach(drv: *const device_driver, dev: *mut device) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn device_bind_driver(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn device_release_driver(dev: *mut device);
}
extern "C" {
    #[must_use]
    pub fn device_attach(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn driver_attach(drv: *const device_driver) -> ffi::c_int;
}
extern "C" {
    pub fn device_initial_probe(dev: *mut device);
}
extern "C" {
    #[must_use]
    pub fn device_reprobe(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn device_is_bound(dev: *mut device) -> bool_;
}
extern "C" {
    pub fn device_create(
        cls: *const class,
        parent: *mut device,
        devt: dev_t,
        drvdata: *mut ffi::c_void,
        fmt: *const ffi::c_char,
        ...
    ) -> *mut device;
}
extern "C" {
    pub fn device_create_with_groups(
        cls: *const class,
        parent: *mut device,
        devt: dev_t,
        drvdata: *mut ffi::c_void,
        groups: *mut *const attribute_group,
        fmt: *const ffi::c_char,
        ...
    ) -> *mut device;
}
extern "C" {
    pub fn device_destroy(cls: *const class, devt: dev_t);
}
extern "C" {
    #[must_use]
    pub fn device_add_groups(dev: *mut device, groups: *mut *const attribute_group) -> ffi::c_int;
}
extern "C" {
    pub fn device_remove_groups(dev: *mut device, groups: *mut *const attribute_group);
}
extern "C" {
    #[must_use]
    pub fn devm_device_add_group(dev: *mut device, grp: *const attribute_group) -> ffi::c_int;
}
extern "C" {
    pub fn get_device(dev: *mut device) -> *mut device;
}
extern "C" {
    pub fn put_device(dev: *mut device);
}
extern "C" {
    pub fn kill_device(dev: *mut device) -> bool_;
}
extern "C" {
    pub fn devtmpfs_mount() -> ffi::c_int;
}
extern "C" {
    pub fn device_shutdown();
}
extern "C" {
    pub fn dev_driver_string(dev: *const device) -> *const ffi::c_char;
}
extern "C" {
    pub fn device_link_add(
        consumer: *mut device,
        supplier: *mut device,
        flags: u32_,
    ) -> *mut device_link;
}
extern "C" {
    pub fn device_link_del(link: *mut device_link);
}
extern "C" {
    pub fn device_link_remove(consumer: *mut ffi::c_void, supplier: *mut device);
}
extern "C" {
    pub fn device_links_supplier_sync_state_pause();
}
extern "C" {
    pub fn device_links_supplier_sync_state_resume();
}
extern "C" {
    pub fn device_link_wait_removal();
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bio_integrity_payload {
    _unused: [u8; 0],
}
pub type bio_end_io_t = ::core::option::Option<unsafe extern "C" fn(arg1: *mut bio)>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bio_crypt_ctx {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct block_device {
    pub bd_start_sect: sector_t,
    pub bd_nr_sectors: sector_t,
    pub bd_disk: *mut gendisk,
    pub bd_queue: *mut request_queue,
    pub bd_stats: *mut disk_stats,
    pub bd_stamp: ffi::c_ulong,
    pub __bd_flags: atomic_t,
    pub bd_dev: dev_t,
    pub bd_mapping: *mut address_space,
    pub bd_openers: atomic_t,
    pub bd_size_lock: spinlock_t,
    pub bd_claiming: *mut ffi::c_void,
    pub bd_holder: *mut ffi::c_void,
    pub bd_holder_ops: *const blk_holder_ops,
    pub bd_holder_lock: mutex,
    pub bd_holders: ffi::c_int,
    pub bd_holder_dir: *mut kobject,
    pub bd_fsfreeze_count: atomic_t,
    pub bd_fsfreeze_mutex: mutex,
    pub bd_meta_info: *mut partition_meta_info,
    pub bd_writers: ffi::c_int,
    pub bd_security: *mut ffi::c_void,
    pub bd_device: device,
}
impl Default for block_device {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type blk_status_t = u8_;
pub type blk_short_t = u16_;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bio_issue {
    pub value: u64_,
}
pub type blk_opf_t = __u32;
pub type blk_qc_t = ffi::c_uint;
#[repr(C)]
pub struct bio {
    pub bi_next: *mut bio,
    pub bi_bdev: *mut block_device,
    pub bi_opf: blk_opf_t,
    pub bi_flags: ffi::c_ushort,
    pub bi_ioprio: ffi::c_ushort,
    pub bi_write_hint: rw_hint,
    pub bi_status: blk_status_t,
    pub __bi_remaining: atomic_t,
    pub bi_iter: bvec_iter,
    pub __bindgen_anon_1: bio__bindgen_ty_1,
    pub bi_end_io: bio_end_io_t,
    pub bi_private: *mut ffi::c_void,
    pub bi_blkg: *mut blkcg_gq,
    pub bi_issue: bio_issue,
    pub bi_iocost_cost: u64_,
    pub bi_crypt_context: *mut bio_crypt_ctx,
    pub bi_integrity: *mut bio_integrity_payload,
    pub bi_vcnt: ffi::c_ushort,
    pub bi_max_vecs: ffi::c_ushort,
    pub __bi_cnt: atomic_t,
    pub bi_io_vec: *mut bio_vec,
    pub bi_pool: *mut bio_set,
    pub bi_inline_vecs: __IncompleteArrayField<bio_vec>,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bio__bindgen_ty_1 {
    pub bi_cookie: blk_qc_t,
    pub __bi_nr_segments: ffi::c_uint,
}
impl Default for bio__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bio {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const BIO_PAGE_PINNED: _bindgen_ty_117 = 0;
pub const BIO_CLONED: _bindgen_ty_117 = 1;
pub const BIO_BOUNCED: _bindgen_ty_117 = 2;
pub const BIO_QUIET: _bindgen_ty_117 = 3;
pub const BIO_CHAIN: _bindgen_ty_117 = 4;
pub const BIO_REFFED: _bindgen_ty_117 = 5;
pub const BIO_BPS_THROTTLED: _bindgen_ty_117 = 6;
pub const BIO_TRACE_COMPLETION: _bindgen_ty_117 = 7;
pub const BIO_CGROUP_ACCT: _bindgen_ty_117 = 8;
pub const BIO_QOS_THROTTLED: _bindgen_ty_117 = 9;
pub const BIO_QOS_MERGED: _bindgen_ty_117 = 10;
pub const BIO_REMAPPED: _bindgen_ty_117 = 11;
pub const BIO_ZONE_WRITE_PLUGGING: _bindgen_ty_117 = 12;
pub const BIO_EMULATES_ZONE_APPEND: _bindgen_ty_117 = 13;
pub const BIO_FLAG_LAST: _bindgen_ty_117 = 14;
pub type _bindgen_ty_117 = ffi::c_uint;
pub type blk_mq_req_flags_t = __u32;
pub const req_op_REQ_OP_READ: req_op = 0;
pub const req_op_REQ_OP_WRITE: req_op = 1;
pub const req_op_REQ_OP_FLUSH: req_op = 2;
pub const req_op_REQ_OP_DISCARD: req_op = 3;
pub const req_op_REQ_OP_SECURE_ERASE: req_op = 5;
pub const req_op_REQ_OP_ZONE_APPEND: req_op = 7;
pub const req_op_REQ_OP_WRITE_ZEROES: req_op = 9;
pub const req_op_REQ_OP_ZONE_OPEN: req_op = 10;
pub const req_op_REQ_OP_ZONE_CLOSE: req_op = 11;
pub const req_op_REQ_OP_ZONE_FINISH: req_op = 12;
pub const req_op_REQ_OP_ZONE_RESET: req_op = 13;
pub const req_op_REQ_OP_ZONE_RESET_ALL: req_op = 15;
pub const req_op_REQ_OP_DRV_IN: req_op = 34;
pub const req_op_REQ_OP_DRV_OUT: req_op = 35;
pub const req_op_REQ_OP_LAST: req_op = 36;
pub type req_op = ffi::c_uint;
pub const req_flag_bits___REQ_FAILFAST_DEV: req_flag_bits = 8;
pub const req_flag_bits___REQ_FAILFAST_TRANSPORT: req_flag_bits = 9;
pub const req_flag_bits___REQ_FAILFAST_DRIVER: req_flag_bits = 10;
pub const req_flag_bits___REQ_SYNC: req_flag_bits = 11;
pub const req_flag_bits___REQ_META: req_flag_bits = 12;
pub const req_flag_bits___REQ_PRIO: req_flag_bits = 13;
pub const req_flag_bits___REQ_NOMERGE: req_flag_bits = 14;
pub const req_flag_bits___REQ_IDLE: req_flag_bits = 15;
pub const req_flag_bits___REQ_INTEGRITY: req_flag_bits = 16;
pub const req_flag_bits___REQ_FUA: req_flag_bits = 17;
pub const req_flag_bits___REQ_PREFLUSH: req_flag_bits = 18;
pub const req_flag_bits___REQ_RAHEAD: req_flag_bits = 19;
pub const req_flag_bits___REQ_BACKGROUND: req_flag_bits = 20;
pub const req_flag_bits___REQ_NOWAIT: req_flag_bits = 21;
pub const req_flag_bits___REQ_POLLED: req_flag_bits = 22;
pub const req_flag_bits___REQ_ALLOC_CACHE: req_flag_bits = 23;
pub const req_flag_bits___REQ_SWAP: req_flag_bits = 24;
pub const req_flag_bits___REQ_DRV: req_flag_bits = 25;
pub const req_flag_bits___REQ_FS_PRIVATE: req_flag_bits = 26;
pub const req_flag_bits___REQ_ATOMIC: req_flag_bits = 27;
pub const req_flag_bits___REQ_NOUNMAP: req_flag_bits = 28;
pub const req_flag_bits___REQ_NR_BITS: req_flag_bits = 29;
pub type req_flag_bits = ffi::c_uint;
pub const stat_group_STAT_READ: stat_group = 0;
pub const stat_group_STAT_WRITE: stat_group = 1;
pub const stat_group_STAT_DISCARD: stat_group = 2;
pub const stat_group_STAT_FLUSH: stat_group = 3;
pub const stat_group_NR_STAT_GROUPS: stat_group = 4;
pub type stat_group = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct blk_rq_stat {
    pub mean: u64_,
    pub min: u64_,
    pub max: u64_,
    pub nr_samples: u32_,
    pub batch: u64_,
}
pub type mempool_alloc_t = ::core::option::Option<
    unsafe extern "C" fn(gfp_mask: gfp_t, pool_data: *mut ffi::c_void) -> *mut ffi::c_void,
>;
pub type mempool_free_t = ::core::option::Option<
    unsafe extern "C" fn(element: *mut ffi::c_void, pool_data: *mut ffi::c_void),
>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mempool_s {
    pub lock: spinlock_t,
    pub min_nr: ffi::c_int,
    pub curr_nr: ffi::c_int,
    pub elements: *mut *mut ffi::c_void,
    pub pool_data: *mut ffi::c_void,
    pub alloc: mempool_alloc_t,
    pub free: mempool_free_t,
    pub wait: wait_queue_head_t,
}
impl Default for mempool_s {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type mempool_t = mempool_s;
extern "C" {
    pub fn mempool_exit(pool: *mut mempool_t);
}
extern "C" {
    pub fn mempool_init_node(
        pool: *mut mempool_t,
        min_nr: ffi::c_int,
        alloc_fn: mempool_alloc_t,
        free_fn: mempool_free_t,
        pool_data: *mut ffi::c_void,
        gfp_mask: gfp_t,
        node_id: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mempool_init_noprof(
        pool: *mut mempool_t,
        min_nr: ffi::c_int,
        alloc_fn: mempool_alloc_t,
        free_fn: mempool_free_t,
        pool_data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mempool_create(
        min_nr: ffi::c_int,
        alloc_fn: mempool_alloc_t,
        free_fn: mempool_free_t,
        pool_data: *mut ffi::c_void,
    ) -> *mut mempool_t;
}
extern "C" {
    pub fn mempool_create_node_noprof(
        min_nr: ffi::c_int,
        alloc_fn: mempool_alloc_t,
        free_fn: mempool_free_t,
        pool_data: *mut ffi::c_void,
        gfp_mask: gfp_t,
        nid: ffi::c_int,
    ) -> *mut mempool_t;
}
extern "C" {
    pub fn mempool_resize(pool: *mut mempool_t, new_min_nr: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn mempool_destroy(pool: *mut mempool_t);
}
extern "C" {
    pub fn mempool_alloc_noprof(pool: *mut mempool_t, gfp_mask: gfp_t) -> *mut ffi::c_void;
}
extern "C" {
    pub fn mempool_alloc_preallocated(pool: *mut mempool_t) -> *mut ffi::c_void;
}
extern "C" {
    pub fn mempool_free(element: *mut ffi::c_void, pool: *mut mempool_t);
}
extern "C" {
    pub fn mempool_alloc_slab(gfp_mask: gfp_t, pool_data: *mut ffi::c_void) -> *mut ffi::c_void;
}
extern "C" {
    pub fn mempool_free_slab(element: *mut ffi::c_void, pool_data: *mut ffi::c_void);
}
extern "C" {
    pub fn mempool_kmalloc(gfp_mask: gfp_t, pool_data: *mut ffi::c_void) -> *mut ffi::c_void;
}
extern "C" {
    pub fn mempool_kfree(element: *mut ffi::c_void, pool_data: *mut ffi::c_void);
}
extern "C" {
    pub fn mempool_kvmalloc(gfp_mask: gfp_t, pool_data: *mut ffi::c_void) -> *mut ffi::c_void;
}
extern "C" {
    pub fn mempool_kvfree(element: *mut ffi::c_void, pool_data: *mut ffi::c_void);
}
extern "C" {
    pub fn mempool_alloc_pages(gfp_mask: gfp_t, pool_data: *mut ffi::c_void) -> *mut ffi::c_void;
}
extern "C" {
    pub fn mempool_free_pages(element: *mut ffi::c_void, pool_data: *mut ffi::c_void);
}
extern "C" {
    pub fn __bio_advance(arg1: *mut bio, bytes: ffi::c_uint);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct folio_iter {
    pub folio: *mut folio,
    pub offset: usize,
    pub length: usize,
    pub _next: *mut folio,
    pub _seg_count: usize,
    pub _i: ffi::c_int,
}
impl Default for folio_iter {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn bio_trim(bio: *mut bio, offset: sector_t, size: sector_t);
}
extern "C" {
    pub fn bio_split(bio: *mut bio, sectors: ffi::c_int, gfp: gfp_t, bs: *mut bio_set) -> *mut bio;
}
extern "C" {
    pub fn bio_split_rw_at(
        bio: *mut bio,
        lim: *const queue_limits,
        segs: *mut ffi::c_uint,
        max_bytes: ffi::c_uint,
    ) -> ffi::c_int;
}
pub const BIOSET_NEED_BVECS: _bindgen_ty_118 = 1;
pub const BIOSET_NEED_RESCUER: _bindgen_ty_118 = 2;
pub const BIOSET_PERCPU_CACHE: _bindgen_ty_118 = 4;
pub type _bindgen_ty_118 = ffi::c_uint;
extern "C" {
    pub fn bioset_init(
        arg1: *mut bio_set,
        arg2: ffi::c_uint,
        arg3: ffi::c_uint,
        flags: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bioset_exit(arg1: *mut bio_set);
}
extern "C" {
    pub fn biovec_init_pool(pool: *mut mempool_t, pool_entries: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn bio_alloc_bioset(
        bdev: *mut block_device,
        nr_vecs: ffi::c_ushort,
        opf: blk_opf_t,
        gfp_mask: gfp_t,
        bs: *mut bio_set,
    ) -> *mut bio;
}
extern "C" {
    pub fn bio_kmalloc(nr_vecs: ffi::c_ushort, gfp_mask: gfp_t) -> *mut bio;
}
extern "C" {
    pub fn bio_put(arg1: *mut bio);
}
extern "C" {
    pub fn bio_alloc_clone(
        bdev: *mut block_device,
        bio_src: *mut bio,
        gfp: gfp_t,
        bs: *mut bio_set,
    ) -> *mut bio;
}
extern "C" {
    pub fn bio_init_clone(
        bdev: *mut block_device,
        bio: *mut bio,
        bio_src: *mut bio,
        gfp: gfp_t,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bio_set {
    pub bio_slab: *mut kmem_cache,
    pub front_pad: ffi::c_uint,
    pub cache: *mut bio_alloc_cache,
    pub bio_pool: mempool_t,
    pub bvec_pool: mempool_t,
    pub back_pad: ffi::c_uint,
    pub rescue_lock: spinlock_t,
    pub rescue_list: bio_list,
    pub rescue_work: work_struct,
    pub rescue_workqueue: *mut workqueue_struct,
    pub cpuhp_dead: hlist_node,
}
impl Default for bio_set {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut fs_bio_set: bio_set;
}
extern "C" {
    pub fn submit_bio(bio: *mut bio);
}
extern "C" {
    pub fn bio_endio(arg1: *mut bio);
}
extern "C" {
    pub fn submit_bio_wait(bio: *mut bio) -> ffi::c_int;
}
extern "C" {
    pub fn bio_init(
        bio: *mut bio,
        bdev: *mut block_device,
        table: *mut bio_vec,
        max_vecs: ffi::c_ushort,
        opf: blk_opf_t,
    );
}
extern "C" {
    pub fn bio_uninit(arg1: *mut bio);
}
extern "C" {
    pub fn bio_reset(bio: *mut bio, bdev: *mut block_device, opf: blk_opf_t);
}
extern "C" {
    pub fn bio_chain(arg1: *mut bio, arg2: *mut bio);
}
extern "C" {
    #[must_use]
    pub fn bio_add_page(
        bio: *mut bio,
        page: *mut page,
        len: ffi::c_uint,
        off: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn bio_add_folio(bio: *mut bio, folio: *mut folio, len: usize, off: usize) -> bool_;
}
extern "C" {
    pub fn __bio_add_page(bio: *mut bio, page: *mut page, len: ffi::c_uint, off: ffi::c_uint);
}
extern "C" {
    pub fn bio_add_folio_nofail(bio: *mut bio, folio: *mut folio, len: usize, off: usize);
}
extern "C" {
    pub fn bio_iov_iter_get_pages(bio: *mut bio, iter: *mut iov_iter) -> ffi::c_int;
}
extern "C" {
    pub fn bio_iov_bvec_set(bio: *mut bio, iter: *const iov_iter);
}
extern "C" {
    pub fn __bio_release_pages(bio: *mut bio, mark_dirty: bool_);
}
extern "C" {
    pub fn bio_set_pages_dirty(bio: *mut bio);
}
extern "C" {
    pub fn bio_check_pages_dirty(bio: *mut bio);
}
extern "C" {
    pub fn bio_copy_data_iter(
        dst: *mut bio,
        dst_iter: *mut bvec_iter,
        src: *mut bio,
        src_iter: *mut bvec_iter,
    );
}
extern "C" {
    pub fn bio_copy_data(dst: *mut bio, src: *mut bio);
}
extern "C" {
    pub fn bio_free_pages(bio: *mut bio);
}
extern "C" {
    pub fn guard_bio_eod(bio: *mut bio);
}
extern "C" {
    pub fn zero_fill_bio_iter(bio: *mut bio, iter: bvec_iter);
}
extern "C" {
    pub fn bio_associate_blkg(bio: *mut bio);
}
extern "C" {
    pub fn bio_associate_blkg_from_css(bio: *mut bio, css: *mut cgroup_subsys_state);
}
extern "C" {
    pub fn bio_clone_blkg_association(dst: *mut bio, src: *mut bio);
}
extern "C" {
    pub fn blkcg_punt_bio_submit(bio: *mut bio);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bio_list {
    pub head: *mut bio,
    pub tail: *mut bio,
}
impl Default for bio_list {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn blk_next_bio(
        bio: *mut bio,
        bdev: *mut block_device,
        nr_pages: ffi::c_uint,
        opf: blk_opf_t,
        gfp: gfp_t,
    ) -> *mut bio;
}
extern "C" {
    pub fn bio_chain_and_submit(prev: *mut bio, new: *mut bio) -> *mut bio;
}
extern "C" {
    pub fn blk_alloc_discard_bio(
        bdev: *mut block_device,
        sector: *mut sector_t,
        nr_sects: *mut sector_t,
        gfp_mask: gfp_t,
    ) -> *mut bio;
}
pub const blk_zone_type_BLK_ZONE_TYPE_CONVENTIONAL: blk_zone_type = 1;
pub const blk_zone_type_BLK_ZONE_TYPE_SEQWRITE_REQ: blk_zone_type = 2;
pub const blk_zone_type_BLK_ZONE_TYPE_SEQWRITE_PREF: blk_zone_type = 3;
pub type blk_zone_type = ffi::c_uint;
pub const blk_zone_cond_BLK_ZONE_COND_NOT_WP: blk_zone_cond = 0;
pub const blk_zone_cond_BLK_ZONE_COND_EMPTY: blk_zone_cond = 1;
pub const blk_zone_cond_BLK_ZONE_COND_IMP_OPEN: blk_zone_cond = 2;
pub const blk_zone_cond_BLK_ZONE_COND_EXP_OPEN: blk_zone_cond = 3;
pub const blk_zone_cond_BLK_ZONE_COND_CLOSED: blk_zone_cond = 4;
pub const blk_zone_cond_BLK_ZONE_COND_READONLY: blk_zone_cond = 13;
pub const blk_zone_cond_BLK_ZONE_COND_FULL: blk_zone_cond = 14;
pub const blk_zone_cond_BLK_ZONE_COND_OFFLINE: blk_zone_cond = 15;
pub type blk_zone_cond = ffi::c_uint;
pub const blk_zone_report_flags_BLK_ZONE_REP_CAPACITY: blk_zone_report_flags = 1;
pub type blk_zone_report_flags = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct blk_zone {
    pub start: __u64,
    pub len: __u64,
    pub wp: __u64,
    pub type_: __u8,
    pub cond: __u8,
    pub non_seq: __u8,
    pub reset: __u8,
    pub resv: [__u8; 4usize],
    pub capacity: __u64,
    pub reserved: [__u8; 24usize],
}
#[repr(C)]
#[derive(Default)]
pub struct blk_zone_report {
    pub sector: __u64,
    pub nr_zones: __u32,
    pub flags: __u32,
    pub zones: __IncompleteArrayField<blk_zone>,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct blk_zone_range {
    pub sector: __u64,
    pub nr_sectors: __u64,
}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct sbitmap_word {
    pub word: ffi::c_ulong,
    pub __bindgen_padding_0: [u64; 7usize],
    pub cleared: ffi::c_ulong,
    pub swap_lock: raw_spinlock_t,
}
impl Default for sbitmap_word {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sbitmap {
    pub depth: ffi::c_uint,
    pub shift: ffi::c_uint,
    pub map_nr: ffi::c_uint,
    pub round_robin: bool_,
    pub map: *mut sbitmap_word,
    pub alloc_hint: *mut ffi::c_uint,
}
impl Default for sbitmap {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct sbq_wait_state {
    pub wait: wait_queue_head_t,
}
impl Default for sbq_wait_state {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sbitmap_queue {
    pub sb: sbitmap,
    pub wake_batch: ffi::c_uint,
    pub wake_index: atomic_t,
    pub ws: *mut sbq_wait_state,
    pub ws_active: atomic_t,
    pub min_shallow_depth: ffi::c_uint,
    pub completion_cnt: atomic_t,
    pub wakeup_cnt: atomic_t,
}
impl Default for sbitmap_queue {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn sbitmap_init_node(
        sb: *mut sbitmap,
        depth: ffi::c_uint,
        shift: ffi::c_int,
        flags: gfp_t,
        node: ffi::c_int,
        round_robin: bool_,
        alloc_hint: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sbitmap_resize(sb: *mut sbitmap, depth: ffi::c_uint);
}
extern "C" {
    pub fn sbitmap_get(sb: *mut sbitmap) -> ffi::c_int;
}
extern "C" {
    pub fn sbitmap_get_shallow(sb: *mut sbitmap, shallow_depth: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn sbitmap_any_bit_set(sb: *const sbitmap) -> bool_;
}
pub type sb_for_each_fn = ::core::option::Option<
    unsafe extern "C" fn(arg1: *mut sbitmap, arg2: ffi::c_uint, arg3: *mut ffi::c_void) -> bool_,
>;
extern "C" {
    pub fn sbitmap_show(sb: *mut sbitmap, m: *mut seq_file);
}
extern "C" {
    pub fn sbitmap_weight(sb: *const sbitmap) -> ffi::c_uint;
}
extern "C" {
    pub fn sbitmap_bitmap_show(sb: *mut sbitmap, m: *mut seq_file);
}
extern "C" {
    pub fn sbitmap_queue_init_node(
        sbq: *mut sbitmap_queue,
        depth: ffi::c_uint,
        shift: ffi::c_int,
        round_robin: bool_,
        flags: gfp_t,
        node: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sbitmap_queue_recalculate_wake_batch(sbq: *mut sbitmap_queue, users: ffi::c_uint);
}
extern "C" {
    pub fn sbitmap_queue_resize(sbq: *mut sbitmap_queue, depth: ffi::c_uint);
}
extern "C" {
    pub fn __sbitmap_queue_get(sbq: *mut sbitmap_queue) -> ffi::c_int;
}
extern "C" {
    pub fn __sbitmap_queue_get_batch(
        sbq: *mut sbitmap_queue,
        nr_tags: ffi::c_int,
        offset: *mut ffi::c_uint,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn sbitmap_queue_get_shallow(
        sbq: *mut sbitmap_queue,
        shallow_depth: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sbitmap_queue_min_shallow_depth(sbq: *mut sbitmap_queue, min_shallow_depth: ffi::c_uint);
}
extern "C" {
    pub fn sbitmap_queue_clear(sbq: *mut sbitmap_queue, nr: ffi::c_uint, cpu: ffi::c_uint);
}
extern "C" {
    pub fn sbitmap_queue_clear_batch(
        sbq: *mut sbitmap_queue,
        offset: ffi::c_int,
        tags: *mut ffi::c_int,
        nr_tags: ffi::c_int,
    );
}
extern "C" {
    pub fn sbitmap_queue_wake_all(sbq: *mut sbitmap_queue);
}
extern "C" {
    pub fn sbitmap_queue_wake_up(sbq: *mut sbitmap_queue, nr: ffi::c_int);
}
extern "C" {
    pub fn sbitmap_queue_show(sbq: *mut sbitmap_queue, m: *mut seq_file);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sbq_wait {
    pub sbq: *mut sbitmap_queue,
    pub wait: wait_queue_entry,
}
impl Default for sbq_wait {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn sbitmap_prepare_to_wait(
        sbq: *mut sbitmap_queue,
        ws: *mut sbq_wait_state,
        sbq_wait: *mut sbq_wait,
        state: ffi::c_int,
    );
}
extern "C" {
    pub fn sbitmap_finish_wait(
        sbq: *mut sbitmap_queue,
        ws: *mut sbq_wait_state,
        sbq_wait: *mut sbq_wait,
    );
}
extern "C" {
    pub fn sbitmap_add_wait_queue(
        sbq: *mut sbitmap_queue,
        ws: *mut sbq_wait_state,
        sbq_wait: *mut sbq_wait,
    );
}
extern "C" {
    pub fn sbitmap_del_wait_queue(sbq_wait: *mut sbq_wait);
}
extern "C" {
    pub fn fput(arg1: *mut file);
}
extern "C" {
    pub fn alloc_file_pseudo(
        arg1: *mut inode,
        arg2: *mut vfsmount,
        arg3: *const ffi::c_char,
        flags: ffi::c_int,
        arg4: *const file_operations,
    ) -> *mut file;
}
extern "C" {
    pub fn alloc_file_pseudo_noaccount(
        arg1: *mut inode,
        arg2: *mut vfsmount,
        arg3: *const ffi::c_char,
        flags: ffi::c_int,
        arg4: *const file_operations,
    ) -> *mut file;
}
extern "C" {
    pub fn alloc_file_clone(
        arg1: *mut file,
        flags: ffi::c_int,
        arg2: *const file_operations,
    ) -> *mut file;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct fd {
    pub word: ffi::c_ulong,
}
extern "C" {
    pub fn fget(fd: ffi::c_uint) -> *mut file;
}
extern "C" {
    pub fn fget_raw(fd: ffi::c_uint) -> *mut file;
}
extern "C" {
    pub fn fget_task(task: *mut task_struct, fd: ffi::c_uint) -> *mut file;
}
extern "C" {
    pub fn fget_task_next(task: *mut task_struct, fd: *mut ffi::c_uint) -> *mut file;
}
extern "C" {
    pub fn __f_unlock_pos(arg1: *mut file);
}
extern "C" {
    pub fn fdget(fd: ffi::c_uint) -> fd;
}
extern "C" {
    pub fn fdget_raw(fd: ffi::c_uint) -> fd;
}
extern "C" {
    pub fn fdget_pos(fd: ffi::c_uint) -> fd;
}
pub type class_fd_t = fd;
pub type class_fd_raw_t = fd;
pub type class_fd_pos_t = fd;
extern "C" {
    pub fn f_dupfd(from: ffi::c_uint, file: *mut file, flags: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn replace_fd(fd: ffi::c_uint, file: *mut file, flags: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn set_close_on_exec(fd: ffi::c_uint, flag: ffi::c_int);
}
extern "C" {
    pub fn get_close_on_exec(fd: ffi::c_uint) -> bool_;
}
extern "C" {
    pub fn __get_unused_fd_flags(flags: ffi::c_uint, nofile: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn get_unused_fd_flags(flags: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn put_unused_fd(fd: ffi::c_uint);
}
pub type class_get_unused_fd_t = ffi::c_int;
extern "C" {
    pub fn fd_install(fd: ffi::c_uint, file: *mut file);
}
extern "C" {
    pub fn receive_fd(file: *mut file, ufd: *mut ffi::c_int, o_flags: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn receive_fd_replace(
        new_fd: ffi::c_int,
        file: *mut file,
        o_flags: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn flush_delayed_fput();
}
extern "C" {
    pub fn __fput_sync(arg1: *mut file);
}
extern "C" {
    pub static mut sysctl_nr_open_min: ffi::c_uint;
}
extern "C" {
    pub static mut sysctl_nr_open_max: ffi::c_uint;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct elevator_queue {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct blk_trace {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sg_io_hdr {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct blkcg_gq {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct blk_flush_queue {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct pr_ops {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rq_qos {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct blk_queue_stats {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct blk_stat_callback {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct blk_crypto_profile {
    _unused: [u8; 0],
}
extern "C" {
    pub static disk_type: device_type;
}
extern "C" {
    pub static part_type: device_type;
}
extern "C" {
    pub static block_class: class;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct partition_meta_info {
    pub uuid: [ffi::c_char; 37usize],
    pub volname: [u8_; 64usize],
}
impl Default for partition_meta_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const GENHD_FL_REMOVABLE: _bindgen_ty_119 = 1;
pub const GENHD_FL_HIDDEN: _bindgen_ty_119 = 2;
pub const GENHD_FL_NO_PART: _bindgen_ty_119 = 4;
pub type _bindgen_ty_119 = ffi::c_uint;
pub const DISK_EVENT_MEDIA_CHANGE: _bindgen_ty_120 = 1;
pub const DISK_EVENT_EJECT_REQUEST: _bindgen_ty_120 = 2;
pub type _bindgen_ty_120 = ffi::c_uint;
pub const DISK_EVENT_FLAG_POLL: _bindgen_ty_121 = 1;
pub const DISK_EVENT_FLAG_UEVENT: _bindgen_ty_121 = 2;
pub const DISK_EVENT_FLAG_BLOCK_ON_EXCL_WRITE: _bindgen_ty_121 = 4;
pub type _bindgen_ty_121 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct disk_events {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct badblocks {
    _unused: [u8; 0],
}
pub const blk_integrity_checksum_BLK_INTEGRITY_CSUM_NONE: blk_integrity_checksum = 0;
pub const blk_integrity_checksum_BLK_INTEGRITY_CSUM_IP: blk_integrity_checksum = 1;
pub const blk_integrity_checksum_BLK_INTEGRITY_CSUM_CRC: blk_integrity_checksum = 2;
pub const blk_integrity_checksum_BLK_INTEGRITY_CSUM_CRC64: blk_integrity_checksum = 3;
pub type blk_integrity_checksum = ffi::c_uchar;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct blk_integrity {
    pub flags: ffi::c_uchar,
    pub csum_type: blk_integrity_checksum,
    pub tuple_size: ffi::c_uchar,
    pub pi_offset: ffi::c_uchar,
    pub interval_exp: ffi::c_uchar,
    pub tag_size: ffi::c_uchar,
}
impl Default for blk_integrity {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type blk_mode_t = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct gendisk {
    pub major: ffi::c_int,
    pub first_minor: ffi::c_int,
    pub minors: ffi::c_int,
    pub disk_name: [ffi::c_char; 32usize],
    pub events: ffi::c_ushort,
    pub event_flags: ffi::c_ushort,
    pub part_tbl: xarray,
    pub part0: *mut block_device,
    pub fops: *const block_device_operations,
    pub queue: *mut request_queue,
    pub private_data: *mut ffi::c_void,
    pub bio_split: bio_set,
    pub flags: ffi::c_int,
    pub state: ffi::c_ulong,
    pub open_mutex: mutex,
    pub open_partitions: ffi::c_uint,
    pub bdi: *mut backing_dev_info,
    pub queue_kobj: kobject,
    pub slave_dir: *mut kobject,
    pub slave_bdevs: list_head,
    pub random: *mut timer_rand_state,
    pub sync_io: atomic_t,
    pub ev: *mut disk_events,
    pub nr_zones: ffi::c_uint,
    pub zone_capacity: ffi::c_uint,
    pub last_zone_capacity: ffi::c_uint,
    pub conv_zones_bitmap: *mut ffi::c_ulong,
    pub zone_wplugs_hash_bits: ffi::c_uint,
    pub nr_zone_wplugs: atomic_t,
    pub zone_wplugs_lock: spinlock_t,
    pub zone_wplugs_pool: *mut mempool_s,
    pub zone_wplugs_hash: *mut hlist_head,
    pub zone_wplugs_wq: *mut workqueue_struct,
    pub cdi: *mut cdrom_device_info,
    pub node_id: ffi::c_int,
    pub bb: *mut badblocks,
    pub lockdep_map: lockdep_map,
    pub diskseq: u64_,
    pub open_mode: blk_mode_t,
    pub ia_ranges: *mut blk_independent_access_ranges,
}
impl Default for gendisk {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type blk_features_t = ffi::c_uint;
pub type blk_flags_t = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct queue_limits {
    pub features: blk_features_t,
    pub flags: blk_flags_t,
    pub seg_boundary_mask: ffi::c_ulong,
    pub virt_boundary_mask: ffi::c_ulong,
    pub max_hw_sectors: ffi::c_uint,
    pub max_dev_sectors: ffi::c_uint,
    pub chunk_sectors: ffi::c_uint,
    pub max_sectors: ffi::c_uint,
    pub max_user_sectors: ffi::c_uint,
    pub max_segment_size: ffi::c_uint,
    pub min_segment_size: ffi::c_uint,
    pub physical_block_size: ffi::c_uint,
    pub logical_block_size: ffi::c_uint,
    pub alignment_offset: ffi::c_uint,
    pub io_min: ffi::c_uint,
    pub io_opt: ffi::c_uint,
    pub max_discard_sectors: ffi::c_uint,
    pub max_hw_discard_sectors: ffi::c_uint,
    pub max_user_discard_sectors: ffi::c_uint,
    pub max_secure_erase_sectors: ffi::c_uint,
    pub max_write_zeroes_sectors: ffi::c_uint,
    pub max_hw_zone_append_sectors: ffi::c_uint,
    pub max_zone_append_sectors: ffi::c_uint,
    pub discard_granularity: ffi::c_uint,
    pub discard_alignment: ffi::c_uint,
    pub zone_write_granularity: ffi::c_uint,
    pub atomic_write_hw_max: ffi::c_uint,
    pub atomic_write_max_sectors: ffi::c_uint,
    pub atomic_write_hw_boundary: ffi::c_uint,
    pub atomic_write_boundary_sectors: ffi::c_uint,
    pub atomic_write_hw_unit_min: ffi::c_uint,
    pub atomic_write_unit_min: ffi::c_uint,
    pub atomic_write_hw_unit_max: ffi::c_uint,
    pub atomic_write_unit_max: ffi::c_uint,
    pub max_segments: ffi::c_ushort,
    pub max_integrity_segments: ffi::c_ushort,
    pub max_discard_segments: ffi::c_ushort,
    pub max_open_zones: ffi::c_uint,
    pub max_active_zones: ffi::c_uint,
    pub dma_alignment: ffi::c_uint,
    pub dma_pad_mask: ffi::c_uint,
    pub integrity: blk_integrity,
}
impl Default for queue_limits {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type report_zones_cb = ::core::option::Option<
    unsafe extern "C" fn(
        zone: *mut blk_zone,
        idx: ffi::c_uint,
        data: *mut ffi::c_void,
    ) -> ffi::c_int,
>;
extern "C" {
    pub fn blkdev_report_zones(
        bdev: *mut block_device,
        sector: sector_t,
        nr_zones: ffi::c_uint,
        cb: report_zones_cb,
        data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn blkdev_zone_mgmt(
        bdev: *mut block_device,
        op: req_op,
        sectors: sector_t,
        nr_sectors: sector_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn blk_revalidate_disk_zones(disk: *mut gendisk) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct blk_independent_access_range {
    pub kobj: kobject,
    pub sector: sector_t,
    pub nr_sectors: sector_t,
}
impl Default for blk_independent_access_range {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct blk_independent_access_ranges {
    pub kobj: kobject,
    pub sysfs_registered: bool_,
    pub nr_ia_ranges: ffi::c_uint,
    pub ia_range: __IncompleteArrayField<blk_independent_access_range>,
}
impl Default for blk_independent_access_ranges {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct request_queue {
    pub queuedata: *mut ffi::c_void,
    pub elevator: *mut elevator_queue,
    pub mq_ops: *const blk_mq_ops,
    pub queue_ctx: *mut blk_mq_ctx,
    pub queue_flags: ffi::c_ulong,
    pub rq_timeout: ffi::c_uint,
    pub queue_depth: ffi::c_uint,
    pub refs: refcount_t,
    pub nr_hw_queues: ffi::c_uint,
    pub hctx_table: xarray,
    pub q_usage_counter: percpu_ref,
    pub io_lock_cls_key: lock_class_key,
    pub io_lockdep_map: lockdep_map,
    pub q_lock_cls_key: lock_class_key,
    pub q_lockdep_map: lockdep_map,
    pub last_merge: *mut request,
    pub queue_lock: spinlock_t,
    pub quiesce_depth: ffi::c_int,
    pub disk: *mut gendisk,
    pub mq_kobj: *mut kobject,
    pub limits: queue_limits,
    pub dev: *mut device,
    pub rpm_status: rpm_status,
    pub pm_only: atomic_t,
    pub stats: *mut blk_queue_stats,
    pub rq_qos: *mut rq_qos,
    pub rq_qos_mutex: mutex,
    pub id: ffi::c_int,
    pub nr_requests: ffi::c_ulong,
    pub crypto_profile: *mut blk_crypto_profile,
    pub crypto_kobject: *mut kobject,
    pub timeout: timer_list,
    pub timeout_work: work_struct,
    pub nr_active_requests_shared_tags: atomic_t,
    pub sched_shared_tags: *mut blk_mq_tags,
    pub icq_list: list_head,
    pub blkcg_pols: [ffi::c_ulong; 1usize],
    pub root_blkg: *mut blkcg_gq,
    pub blkg_list: list_head,
    pub blkcg_mutex: mutex,
    pub node: ffi::c_int,
    pub requeue_lock: spinlock_t,
    pub requeue_list: list_head,
    pub requeue_work: delayed_work,
    pub blk_trace: *mut blk_trace,
    pub fq: *mut blk_flush_queue,
    pub flush_list: list_head,
    pub elevator_lock: mutex,
    pub sysfs_lock: mutex,
    pub limits_lock: mutex,
    pub unused_hctx_list: list_head,
    pub unused_hctx_lock: spinlock_t,
    pub mq_freeze_depth: ffi::c_int,
    pub td: *mut throtl_data,
    pub callback_head: callback_head,
    pub mq_freeze_wq: wait_queue_head_t,
    pub mq_freeze_lock: mutex,
    pub tag_set: *mut blk_mq_tag_set,
    pub tag_set_list: list_head,
    pub debugfs_dir: *mut dentry,
    pub sched_debugfs_dir: *mut dentry,
    pub rqos_debugfs_dir: *mut dentry,
    pub debugfs_mutex: mutex,
}
impl Default for request_queue {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const QUEUE_FLAG_DYING: _bindgen_ty_122 = 0;
pub const QUEUE_FLAG_NOMERGES: _bindgen_ty_122 = 1;
pub const QUEUE_FLAG_SAME_COMP: _bindgen_ty_122 = 2;
pub const QUEUE_FLAG_FAIL_IO: _bindgen_ty_122 = 3;
pub const QUEUE_FLAG_NOXMERGES: _bindgen_ty_122 = 4;
pub const QUEUE_FLAG_SAME_FORCE: _bindgen_ty_122 = 5;
pub const QUEUE_FLAG_INIT_DONE: _bindgen_ty_122 = 6;
pub const QUEUE_FLAG_STATS: _bindgen_ty_122 = 7;
pub const QUEUE_FLAG_REGISTERED: _bindgen_ty_122 = 8;
pub const QUEUE_FLAG_QUIESCED: _bindgen_ty_122 = 9;
pub const QUEUE_FLAG_RQ_ALLOC_TIME: _bindgen_ty_122 = 10;
pub const QUEUE_FLAG_HCTX_ACTIVE: _bindgen_ty_122 = 11;
pub const QUEUE_FLAG_SQ_SCHED: _bindgen_ty_122 = 12;
pub const QUEUE_FLAG_MAX: _bindgen_ty_122 = 13;
pub type _bindgen_ty_122 = ffi::c_uint;
extern "C" {
    pub fn blk_queue_flag_set(flag: ffi::c_uint, q: *mut request_queue);
}
extern "C" {
    pub fn blk_queue_flag_clear(flag: ffi::c_uint, q: *mut request_queue);
}
extern "C" {
    pub fn blk_set_pm_only(q: *mut request_queue);
}
extern "C" {
    pub fn blk_clear_pm_only(q: *mut request_queue);
}
extern "C" {
    #[must_use]
    pub fn add_disk_fwnode(
        parent: *mut device,
        disk: *mut gendisk,
        groups: *mut *const attribute_group,
        fwnode: *mut fwnode_handle,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn device_add_disk(
        parent: *mut device,
        disk: *mut gendisk,
        groups: *mut *const attribute_group,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn del_gendisk(gp: *mut gendisk);
}
extern "C" {
    pub fn invalidate_disk(disk: *mut gendisk);
}
extern "C" {
    pub fn set_disk_ro(disk: *mut gendisk, read_only: bool_);
}
extern "C" {
    pub fn disk_uevent(disk: *mut gendisk, action: kobject_action);
}
extern "C" {
    pub fn set_capacity_and_notify(disk: *mut gendisk, size: sector_t) -> bool_;
}
extern "C" {
    pub fn disk_force_media_change(disk: *mut gendisk);
}
extern "C" {
    pub fn bdev_mark_dead(bdev: *mut block_device, surprise: bool_);
}
extern "C" {
    pub fn add_disk_randomness(disk: *mut gendisk);
}
extern "C" {
    pub fn rand_initialize_disk(disk: *mut gendisk);
}
extern "C" {
    pub fn blk_zone_plug_bio(bio: *mut bio, nr_segs: ffi::c_uint) -> bool_;
}
extern "C" {
    pub fn bdev_disk_changed(disk: *mut gendisk, invalidate: bool_) -> ffi::c_int;
}
extern "C" {
    pub fn put_disk(disk: *mut gendisk);
}
extern "C" {
    pub fn __blk_alloc_disk(
        lim: *mut queue_limits,
        node: ffi::c_int,
        lkclass: *mut lock_class_key,
    ) -> *mut gendisk;
}
extern "C" {
    pub fn __register_blkdev(
        major: ffi::c_uint,
        name: *const ffi::c_char,
        probe: ::core::option::Option<unsafe extern "C" fn(devt: dev_t)>,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn unregister_blkdev(major: ffi::c_uint, name: *const ffi::c_char);
}
extern "C" {
    pub fn disk_check_media_change(disk: *mut gendisk) -> bool_;
}
extern "C" {
    pub fn set_capacity(disk: *mut gendisk, size: sector_t);
}
extern "C" {
    pub fn bd_link_disk_holder(bdev: *mut block_device, disk: *mut gendisk) -> ffi::c_int;
}
extern "C" {
    pub fn bd_unlink_disk_holder(bdev: *mut block_device, disk: *mut gendisk);
}
extern "C" {
    pub fn part_devt(disk: *mut gendisk, partno: u8_) -> dev_t;
}
extern "C" {
    pub fn inc_diskseq(disk: *mut gendisk);
}
extern "C" {
    pub fn blk_request_module(devt: dev_t);
}
extern "C" {
    pub fn blk_register_queue(disk: *mut gendisk) -> ffi::c_int;
}
extern "C" {
    pub fn blk_unregister_queue(disk: *mut gendisk);
}
extern "C" {
    pub fn submit_bio_noacct(bio: *mut bio);
}
extern "C" {
    pub fn bio_split_to_limits(bio: *mut bio) -> *mut bio;
}
extern "C" {
    pub fn blk_lld_busy(q: *mut request_queue) -> ffi::c_int;
}
extern "C" {
    pub fn blk_queue_enter(q: *mut request_queue, flags: blk_mq_req_flags_t) -> ffi::c_int;
}
extern "C" {
    pub fn blk_queue_exit(q: *mut request_queue);
}
extern "C" {
    pub fn blk_sync_queue(q: *mut request_queue);
}
extern "C" {
    pub fn blk_op_str(op: req_op) -> *const ffi::c_char;
}
extern "C" {
    pub fn blk_status_to_errno(status: blk_status_t) -> ffi::c_int;
}
extern "C" {
    pub fn errno_to_blk_status(errno: ffi::c_int) -> blk_status_t;
}
extern "C" {
    pub fn blk_status_to_str(status: blk_status_t) -> *const ffi::c_char;
}
extern "C" {
    pub fn bio_poll(bio: *mut bio, iob: *mut io_comp_batch, flags: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn iocb_bio_iopoll(
        kiocb: *mut kiocb,
        iob: *mut io_comp_batch,
        flags: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn blk_zone_cond_str(zone_cond: blk_zone_cond) -> *const ffi::c_char;
}
extern "C" {
    pub fn queue_limits_commit_update_frozen(
        q: *mut request_queue,
        lim: *mut queue_limits,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn queue_limits_commit_update(q: *mut request_queue, lim: *mut queue_limits) -> ffi::c_int;
}
extern "C" {
    pub fn queue_limits_set(q: *mut request_queue, lim: *mut queue_limits) -> ffi::c_int;
}
extern "C" {
    pub fn blk_validate_limits(lim: *mut queue_limits) -> ffi::c_int;
}
extern "C" {
    pub fn blk_set_queue_depth(q: *mut request_queue, depth: ffi::c_uint);
}
extern "C" {
    pub fn blk_set_stacking_limits(lim: *mut queue_limits);
}
extern "C" {
    pub fn blk_stack_limits(
        t: *mut queue_limits,
        b: *mut queue_limits,
        offset: sector_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn queue_limits_stack_bdev(
        t: *mut queue_limits,
        bdev: *mut block_device,
        offset: sector_t,
        pfx: *const ffi::c_char,
    );
}
extern "C" {
    pub fn blk_queue_rq_timeout(arg1: *mut request_queue, arg2: ffi::c_uint);
}
extern "C" {
    pub fn disk_alloc_independent_access_ranges(
        disk: *mut gendisk,
        nr_ia_ranges: ffi::c_int,
    ) -> *mut blk_independent_access_ranges;
}
extern "C" {
    pub fn disk_set_independent_access_ranges(
        disk: *mut gendisk,
        iars: *mut blk_independent_access_ranges,
    );
}
extern "C" {
    #[must_use]
    pub fn blk_get_queue(arg1: *mut request_queue) -> bool_;
}
extern "C" {
    pub fn blk_put_queue(arg1: *mut request_queue);
}
extern "C" {
    pub fn blk_mark_disk_dead(disk: *mut gendisk);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rq_list {
    pub head: *mut request,
    pub tail: *mut request,
}
impl Default for rq_list {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct blk_plug {
    pub mq_list: rq_list,
    pub cached_rqs: rq_list,
    pub cur_ktime: u64_,
    pub nr_ios: ffi::c_ushort,
    pub rq_count: ffi::c_ushort,
    pub multiple_queues: bool_,
    pub has_elevator: bool_,
    pub cb_list: list_head,
}
impl Default for blk_plug {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type blk_plug_cb_fn =
    ::core::option::Option<unsafe extern "C" fn(arg1: *mut blk_plug_cb, arg2: bool_)>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct blk_plug_cb {
    pub list: list_head,
    pub callback: blk_plug_cb_fn,
    pub data: *mut ffi::c_void,
}
impl Default for blk_plug_cb {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn blk_check_plugged(
        unplug: blk_plug_cb_fn,
        data: *mut ffi::c_void,
        size: ffi::c_int,
    ) -> *mut blk_plug_cb;
}
extern "C" {
    pub fn blk_start_plug(arg1: *mut blk_plug);
}
extern "C" {
    pub fn blk_start_plug_nr_ios(arg1: *mut blk_plug, arg2: ffi::c_ushort);
}
extern "C" {
    pub fn blk_finish_plug(arg1: *mut blk_plug);
}
extern "C" {
    pub fn __blk_flush_plug(plug: *mut blk_plug, from_schedule: bool_);
}
extern "C" {
    pub fn blkdev_issue_flush(bdev: *mut block_device) -> ffi::c_int;
}
extern "C" {
    pub fn nr_blockdev_pages() -> ffi::c_long;
}
extern "C" {
    pub fn blk_io_schedule();
}
extern "C" {
    pub fn blkdev_issue_discard(
        bdev: *mut block_device,
        sector: sector_t,
        nr_sects: sector_t,
        gfp_mask: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __blkdev_issue_discard(
        bdev: *mut block_device,
        sector: sector_t,
        nr_sects: sector_t,
        gfp_mask: gfp_t,
        biop: *mut *mut bio,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn blkdev_issue_secure_erase(
        bdev: *mut block_device,
        sector: sector_t,
        nr_sects: sector_t,
        gfp: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __blkdev_issue_zeroout(
        bdev: *mut block_device,
        sector: sector_t,
        nr_sects: sector_t,
        gfp_mask: gfp_t,
        biop: *mut *mut bio,
        flags: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn blkdev_issue_zeroout(
        bdev: *mut block_device,
        sector: sector_t,
        nr_sects: sector_t,
        gfp_mask: gfp_t,
        flags: ffi::c_uint,
    ) -> ffi::c_int;
}
pub const blk_default_limits_BLK_MAX_SEGMENTS: blk_default_limits = 128;
pub const blk_default_limits_BLK_SAFE_MAX_SECTORS: blk_default_limits = 255;
pub const blk_default_limits_BLK_MAX_SEGMENT_SIZE: blk_default_limits = 65536;
pub const blk_default_limits_BLK_SEG_BOUNDARY_MASK: blk_default_limits = 4294967295;
pub type blk_default_limits = ffi::c_uint;
extern "C" {
    pub fn bdev_alignment_offset(bdev: *mut block_device) -> ffi::c_int;
}
extern "C" {
    pub fn bdev_discard_alignment(bdev: *mut block_device) -> ffi::c_uint;
}
extern "C" {
    pub fn blk_zone_issue_zeroout(
        bdev: *mut block_device,
        sector: sector_t,
        nr_sects: sector_t,
        gfp_mask: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kblockd_schedule_work(work: *mut work_struct) -> ffi::c_int;
}
extern "C" {
    pub fn kblockd_mod_delayed_work_on(
        cpu: ffi::c_int,
        dwork: *mut delayed_work,
        delay: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn blk_crypto_register(profile: *mut blk_crypto_profile, q: *mut request_queue) -> bool_;
}
pub const blk_unique_id_BLK_UID_T10: blk_unique_id = 1;
pub const blk_unique_id_BLK_UID_EUI64: blk_unique_id = 2;
pub const blk_unique_id_BLK_UID_NAA: blk_unique_id = 3;
pub type blk_unique_id = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct block_device_operations {
    pub submit_bio: ::core::option::Option<unsafe extern "C" fn(bio: *mut bio)>,
    pub poll_bio: ::core::option::Option<
        unsafe extern "C" fn(
            bio: *mut bio,
            iob: *mut io_comp_batch,
            flags: ffi::c_uint,
        ) -> ffi::c_int,
    >,
    pub open: ::core::option::Option<
        unsafe extern "C" fn(disk: *mut gendisk, mode: blk_mode_t) -> ffi::c_int,
    >,
    pub release: ::core::option::Option<unsafe extern "C" fn(disk: *mut gendisk)>,
    pub ioctl: ::core::option::Option<
        unsafe extern "C" fn(
            bdev: *mut block_device,
            mode: blk_mode_t,
            cmd: ffi::c_uint,
            arg: ffi::c_ulong,
        ) -> ffi::c_int,
    >,
    pub compat_ioctl: ::core::option::Option<
        unsafe extern "C" fn(
            bdev: *mut block_device,
            mode: blk_mode_t,
            cmd: ffi::c_uint,
            arg: ffi::c_ulong,
        ) -> ffi::c_int,
    >,
    pub check_events: ::core::option::Option<
        unsafe extern "C" fn(disk: *mut gendisk, clearing: ffi::c_uint) -> ffi::c_uint,
    >,
    pub unlock_native_capacity: ::core::option::Option<unsafe extern "C" fn(arg1: *mut gendisk)>,
    pub getgeo: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut block_device, arg2: *mut hd_geometry) -> ffi::c_int,
    >,
    pub set_read_only: ::core::option::Option<
        unsafe extern "C" fn(bdev: *mut block_device, ro: bool_) -> ffi::c_int,
    >,
    pub free_disk: ::core::option::Option<unsafe extern "C" fn(disk: *mut gendisk)>,
    pub swap_slot_free_notify:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut block_device, arg2: ffi::c_ulong)>,
    pub report_zones: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut gendisk,
            sector: sector_t,
            nr_zones: ffi::c_uint,
            cb: report_zones_cb,
            data: *mut ffi::c_void,
        ) -> ffi::c_int,
    >,
    pub devnode: ::core::option::Option<
        unsafe extern "C" fn(disk: *mut gendisk, mode: *mut umode_t) -> *mut ffi::c_char,
    >,
    pub get_unique_id: ::core::option::Option<
        unsafe extern "C" fn(
            disk: *mut gendisk,
            id: *mut u8_,
            id_type: blk_unique_id,
        ) -> ffi::c_int,
    >,
    pub owner: *mut module,
    pub pr_ops: *const pr_ops,
    pub alternative_gpt_sector: ::core::option::Option<
        unsafe extern "C" fn(disk: *mut gendisk, sector: *mut sector_t) -> ffi::c_int,
    >,
}
impl Default for block_device_operations {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn blkdev_compat_ptr_ioctl(
        arg1: *mut block_device,
        arg2: blk_mode_t,
        arg3: ffi::c_uint,
        arg4: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bdev_start_io_acct(
        bdev: *mut block_device,
        op: req_op,
        start_time: ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn bdev_end_io_acct(
        bdev: *mut block_device,
        op: req_op,
        sectors: ffi::c_uint,
        start_time: ffi::c_ulong,
    );
}
extern "C" {
    pub fn bio_start_io_acct(bio: *mut bio) -> ffi::c_ulong;
}
extern "C" {
    pub fn bio_end_io_acct_remapped(
        bio: *mut bio,
        start_time: ffi::c_ulong,
        orig_bdev: *mut block_device,
    );
}
extern "C" {
    pub fn bdev_validate_blocksize(bdev: *mut block_device, block_size: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn set_blocksize(file: *mut file, size: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn lookup_bdev(pathname: *const ffi::c_char, dev: *mut dev_t) -> ffi::c_int;
}
extern "C" {
    pub fn blkdev_show(seqf: *mut seq_file, offset: off_t);
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct blk_holder_ops {
    pub mark_dead:
        ::core::option::Option<unsafe extern "C" fn(bdev: *mut block_device, surprise: bool_)>,
    pub sync: ::core::option::Option<unsafe extern "C" fn(bdev: *mut block_device)>,
    pub freeze: ::core::option::Option<unsafe extern "C" fn(bdev: *mut block_device) -> ffi::c_int>,
    pub thaw: ::core::option::Option<unsafe extern "C" fn(bdev: *mut block_device) -> ffi::c_int>,
}
extern "C" {
    pub static fs_holder_ops: blk_holder_ops;
}
extern "C" {
    pub fn bdev_file_open_by_dev(
        dev: dev_t,
        mode: blk_mode_t,
        holder: *mut ffi::c_void,
        hops: *const blk_holder_ops,
    ) -> *mut file;
}
extern "C" {
    pub fn bdev_file_open_by_path(
        path: *const ffi::c_char,
        mode: blk_mode_t,
        holder: *mut ffi::c_void,
        hops: *const blk_holder_ops,
    ) -> *mut file;
}
extern "C" {
    pub fn bd_prepare_to_claim(
        bdev: *mut block_device,
        holder: *mut ffi::c_void,
        hops: *const blk_holder_ops,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bd_abort_claiming(bdev: *mut block_device, holder: *mut ffi::c_void);
}
extern "C" {
    pub fn I_BDEV(inode: *mut inode) -> *mut block_device;
}
extern "C" {
    pub fn file_bdev(bdev_file: *mut file) -> *mut block_device;
}
extern "C" {
    pub fn disk_live(disk: *mut gendisk) -> bool_;
}
extern "C" {
    pub fn block_size(bdev: *mut block_device) -> ffi::c_uint;
}
extern "C" {
    pub fn invalidate_bdev(bdev: *mut block_device);
}
extern "C" {
    pub fn sync_blockdev(bdev: *mut block_device) -> ffi::c_int;
}
extern "C" {
    pub fn sync_blockdev_range(bdev: *mut block_device, lstart: loff_t, lend: loff_t)
        -> ffi::c_int;
}
extern "C" {
    pub fn sync_blockdev_nowait(bdev: *mut block_device) -> ffi::c_int;
}
extern "C" {
    pub fn sync_bdevs(wait: bool_);
}
extern "C" {
    pub fn bdev_statx(path: *const path, stat: *mut kstat, request_mask: u32_);
}
extern "C" {
    pub fn printk_all_partitions();
}
extern "C" {
    pub fn early_lookup_bdev(pathname: *const ffi::c_char, dev: *mut dev_t) -> ffi::c_int;
}
extern "C" {
    pub fn bdev_freeze(bdev: *mut block_device) -> ffi::c_int;
}
extern "C" {
    pub fn bdev_thaw(bdev: *mut block_device) -> ffi::c_int;
}
extern "C" {
    pub fn bdev_fput(bdev_file: *mut file);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct io_comp_batch {
    pub req_list: rq_list,
    pub need_ts: bool_,
    pub complete: ::core::option::Option<unsafe extern "C" fn(arg1: *mut io_comp_batch)>,
}
impl Default for io_comp_batch {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct scatterlist {
    pub page_link: ffi::c_ulong,
    pub offset: ffi::c_uint,
    pub length: ffi::c_uint,
    pub dma_address: dma_addr_t,
    pub dma_length: ffi::c_uint,
    pub dma_flags: ffi::c_uint,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sg_table {
    pub sgl: *mut scatterlist,
    pub nents: ffi::c_uint,
    pub orig_nents: ffi::c_uint,
}
impl Default for sg_table {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sg_append_table {
    pub sgt: sg_table,
    pub prv: *mut scatterlist,
    pub total_nents: ffi::c_uint,
}
impl Default for sg_append_table {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn sg_nents(sg: *mut scatterlist) -> ffi::c_int;
}
extern "C" {
    pub fn sg_nents_for_len(sg: *mut scatterlist, len: u64_) -> ffi::c_int;
}
extern "C" {
    pub fn sg_next(arg1: *mut scatterlist) -> *mut scatterlist;
}
extern "C" {
    pub fn sg_last(s: *mut scatterlist, arg1: ffi::c_uint) -> *mut scatterlist;
}
extern "C" {
    pub fn sg_init_table(arg1: *mut scatterlist, arg2: ffi::c_uint);
}
extern "C" {
    pub fn sg_init_one(arg1: *mut scatterlist, arg2: *const ffi::c_void, arg3: ffi::c_uint);
}
extern "C" {
    pub fn sg_split(
        in_: *mut scatterlist,
        in_mapped_nents: ffi::c_int,
        skip: off_t,
        nb_splits: ffi::c_int,
        split_sizes: *const usize,
        out: *mut *mut scatterlist,
        out_mapped_nents: *mut ffi::c_int,
        gfp_mask: gfp_t,
    ) -> ffi::c_int;
}
pub type sg_alloc_fn = ::core::option::Option<
    unsafe extern "C" fn(arg1: ffi::c_uint, arg2: gfp_t) -> *mut scatterlist,
>;
pub type sg_free_fn =
    ::core::option::Option<unsafe extern "C" fn(arg1: *mut scatterlist, arg2: ffi::c_uint)>;
extern "C" {
    pub fn __sg_free_table(
        arg1: *mut sg_table,
        arg2: ffi::c_uint,
        arg3: ffi::c_uint,
        arg4: sg_free_fn,
        arg5: ffi::c_uint,
    );
}
extern "C" {
    pub fn sg_free_table(arg1: *mut sg_table);
}
extern "C" {
    pub fn sg_free_append_table(sgt: *mut sg_append_table);
}
extern "C" {
    pub fn __sg_alloc_table(
        arg1: *mut sg_table,
        arg2: ffi::c_uint,
        arg3: ffi::c_uint,
        arg4: *mut scatterlist,
        arg5: ffi::c_uint,
        arg6: gfp_t,
        arg7: sg_alloc_fn,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sg_alloc_table(arg1: *mut sg_table, arg2: ffi::c_uint, arg3: gfp_t) -> ffi::c_int;
}
extern "C" {
    pub fn sg_alloc_append_table_from_pages(
        sgt: *mut sg_append_table,
        pages: *mut *mut page,
        n_pages: ffi::c_uint,
        offset: ffi::c_uint,
        size: ffi::c_ulong,
        max_segment: ffi::c_uint,
        left_pages: ffi::c_uint,
        gfp_mask: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sg_alloc_table_from_pages_segment(
        sgt: *mut sg_table,
        pages: *mut *mut page,
        n_pages: ffi::c_uint,
        offset: ffi::c_uint,
        size: ffi::c_ulong,
        max_segment: ffi::c_uint,
        gfp_mask: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sgl_alloc_order(
        length: ffi::c_ulonglong,
        order: ffi::c_uint,
        chainable: bool_,
        gfp: gfp_t,
        nent_p: *mut ffi::c_uint,
    ) -> *mut scatterlist;
}
extern "C" {
    pub fn sgl_alloc(
        length: ffi::c_ulonglong,
        gfp: gfp_t,
        nent_p: *mut ffi::c_uint,
    ) -> *mut scatterlist;
}
extern "C" {
    pub fn sgl_free_n_order(sgl: *mut scatterlist, nents: ffi::c_int, order: ffi::c_int);
}
extern "C" {
    pub fn sgl_free_order(sgl: *mut scatterlist, order: ffi::c_int);
}
extern "C" {
    pub fn sgl_free(sgl: *mut scatterlist);
}
extern "C" {
    pub fn sg_copy_buffer(
        sgl: *mut scatterlist,
        nents: ffi::c_uint,
        buf: *mut ffi::c_void,
        buflen: usize,
        skip: off_t,
        to_buffer: bool_,
    ) -> usize;
}
extern "C" {
    pub fn sg_copy_from_buffer(
        sgl: *mut scatterlist,
        nents: ffi::c_uint,
        buf: *const ffi::c_void,
        buflen: usize,
    ) -> usize;
}
extern "C" {
    pub fn sg_copy_to_buffer(
        sgl: *mut scatterlist,
        nents: ffi::c_uint,
        buf: *mut ffi::c_void,
        buflen: usize,
    ) -> usize;
}
extern "C" {
    pub fn sg_pcopy_from_buffer(
        sgl: *mut scatterlist,
        nents: ffi::c_uint,
        buf: *const ffi::c_void,
        buflen: usize,
        skip: off_t,
    ) -> usize;
}
extern "C" {
    pub fn sg_pcopy_to_buffer(
        sgl: *mut scatterlist,
        nents: ffi::c_uint,
        buf: *mut ffi::c_void,
        buflen: usize,
        skip: off_t,
    ) -> usize;
}
extern "C" {
    pub fn sg_zero_buffer(
        sgl: *mut scatterlist,
        nents: ffi::c_uint,
        buflen: usize,
        skip: off_t,
    ) -> usize;
}
extern "C" {
    pub fn sg_free_table_chained(table: *mut sg_table, nents_first_chunk: ffi::c_uint);
}
extern "C" {
    pub fn sg_alloc_table_chained(
        table: *mut sg_table,
        nents: ffi::c_int,
        first_chunk: *mut scatterlist,
        nents_first_chunk: ffi::c_uint,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sg_page_iter {
    pub sg: *mut scatterlist,
    pub sg_pgoffset: ffi::c_uint,
    pub __nents: ffi::c_uint,
    pub __pg_advance: ffi::c_int,
}
impl Default for sg_page_iter {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sg_dma_page_iter {
    pub base: sg_page_iter,
}
impl Default for sg_dma_page_iter {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn __sg_page_iter_next(piter: *mut sg_page_iter) -> bool_;
}
extern "C" {
    pub fn __sg_page_iter_dma_next(dma_iter: *mut sg_dma_page_iter) -> bool_;
}
extern "C" {
    pub fn __sg_page_iter_start(
        piter: *mut sg_page_iter,
        sglist: *mut scatterlist,
        nents: ffi::c_uint,
        pgoffset: ffi::c_ulong,
    );
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sg_mapping_iter {
    pub page: *mut page,
    pub addr: *mut ffi::c_void,
    pub length: usize,
    pub consumed: usize,
    pub piter: sg_page_iter,
    pub __offset: ffi::c_uint,
    pub __remaining: ffi::c_uint,
    pub __flags: ffi::c_uint,
}
impl Default for sg_mapping_iter {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn sg_miter_start(
        miter: *mut sg_mapping_iter,
        sgl: *mut scatterlist,
        nents: ffi::c_uint,
        flags: ffi::c_uint,
    );
}
extern "C" {
    pub fn sg_miter_skip(miter: *mut sg_mapping_iter, offset: off_t) -> bool_;
}
extern "C" {
    pub fn sg_miter_next(miter: *mut sg_mapping_iter) -> bool_;
}
extern "C" {
    pub fn sg_miter_stop(miter: *mut sg_mapping_iter);
}
pub const rq_end_io_ret_RQ_END_IO_NONE: rq_end_io_ret = 0;
pub const rq_end_io_ret_RQ_END_IO_FREE: rq_end_io_ret = 1;
pub type rq_end_io_ret = ffi::c_uint;
pub type rq_end_io_fn = ::core::option::Option<
    unsafe extern "C" fn(arg1: *mut request, arg2: blk_status_t) -> rq_end_io_ret,
>;
pub type req_flags_t = __u32;
pub const rqf_flags___RQF_STARTED: rqf_flags = 0;
pub const rqf_flags___RQF_FLUSH_SEQ: rqf_flags = 1;
pub const rqf_flags___RQF_MIXED_MERGE: rqf_flags = 2;
pub const rqf_flags___RQF_DONTPREP: rqf_flags = 3;
pub const rqf_flags___RQF_SCHED_TAGS: rqf_flags = 4;
pub const rqf_flags___RQF_USE_SCHED: rqf_flags = 5;
pub const rqf_flags___RQF_FAILED: rqf_flags = 6;
pub const rqf_flags___RQF_QUIET: rqf_flags = 7;
pub const rqf_flags___RQF_IO_STAT: rqf_flags = 8;
pub const rqf_flags___RQF_PM: rqf_flags = 9;
pub const rqf_flags___RQF_HASHED: rqf_flags = 10;
pub const rqf_flags___RQF_STATS: rqf_flags = 11;
pub const rqf_flags___RQF_SPECIAL_PAYLOAD: rqf_flags = 12;
pub const rqf_flags___RQF_ZONE_WRITE_PLUGGING: rqf_flags = 13;
pub const rqf_flags___RQF_TIMED_OUT: rqf_flags = 14;
pub const rqf_flags___RQF_RESV: rqf_flags = 15;
pub const rqf_flags___RQF_BITS: rqf_flags = 16;
pub type rqf_flags = ffi::c_uint;
pub const mq_rq_state_MQ_RQ_IDLE: mq_rq_state = 0;
pub const mq_rq_state_MQ_RQ_IN_FLIGHT: mq_rq_state = 1;
pub const mq_rq_state_MQ_RQ_COMPLETE: mq_rq_state = 2;
pub type mq_rq_state = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct request {
    pub q: *mut request_queue,
    pub mq_ctx: *mut blk_mq_ctx,
    pub mq_hctx: *mut blk_mq_hw_ctx,
    pub cmd_flags: blk_opf_t,
    pub rq_flags: req_flags_t,
    pub tag: ffi::c_int,
    pub internal_tag: ffi::c_int,
    pub timeout: ffi::c_uint,
    pub __data_len: ffi::c_uint,
    pub __sector: sector_t,
    pub bio: *mut bio,
    pub biotail: *mut bio,
    pub __bindgen_anon_1: request__bindgen_ty_1,
    pub part: *mut block_device,
    pub alloc_time_ns: u64_,
    pub start_time_ns: u64_,
    pub io_start_time_ns: u64_,
    pub wbt_flags: ffi::c_ushort,
    pub stats_sectors: ffi::c_ushort,
    pub nr_phys_segments: ffi::c_ushort,
    pub nr_integrity_segments: ffi::c_ushort,
    pub crypt_ctx: *mut bio_crypt_ctx,
    pub crypt_keyslot: *mut blk_crypto_keyslot,
    pub state: mq_rq_state,
    pub ref_: atomic_t,
    pub deadline: ffi::c_ulong,
    pub __bindgen_anon_2: request__bindgen_ty_2,
    pub __bindgen_anon_3: request__bindgen_ty_3,
    pub elv: request__bindgen_ty_4,
    pub flush: request__bindgen_ty_5,
    pub fifo_time: u64_,
    pub end_io: rq_end_io_fn,
    pub end_io_data: *mut ffi::c_void,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union request__bindgen_ty_1 {
    pub queuelist: list_head,
    pub rq_next: *mut request,
}
impl Default for request__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union request__bindgen_ty_2 {
    pub hash: hlist_node,
    pub ipi_list: llist_node,
}
impl Default for request__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union request__bindgen_ty_3 {
    pub rb_node: rb_node,
    pub special_vec: bio_vec,
}
impl Default for request__bindgen_ty_3 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct request__bindgen_ty_4 {
    pub icq: *mut io_cq,
    pub priv_: [*mut ffi::c_void; 2usize],
}
impl Default for request__bindgen_ty_4 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct request__bindgen_ty_5 {
    pub seq: ffi::c_uint,
    pub saved_end_io: rq_end_io_fn,
}
impl Default for request {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const blk_eh_timer_return_BLK_EH_DONE: blk_eh_timer_return = 0;
pub const blk_eh_timer_return_BLK_EH_RESET_TIMER: blk_eh_timer_return = 1;
pub type blk_eh_timer_return = ffi::c_uint;
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct blk_mq_hw_ctx {
    pub __bindgen_anon_1: blk_mq_hw_ctx__bindgen_ty_1,
    pub run_work: delayed_work,
    pub cpumask: cpumask_var_t,
    pub next_cpu: ffi::c_int,
    pub next_cpu_batch: ffi::c_int,
    pub flags: ffi::c_ulong,
    pub sched_data: *mut ffi::c_void,
    pub queue: *mut request_queue,
    pub fq: *mut blk_flush_queue,
    pub driver_data: *mut ffi::c_void,
    pub ctx_map: sbitmap,
    pub dispatch_from: *mut blk_mq_ctx,
    pub dispatch_busy: ffi::c_uint,
    pub type_: ffi::c_ushort,
    pub nr_ctx: ffi::c_ushort,
    pub ctxs: *mut *mut blk_mq_ctx,
    pub dispatch_wait_lock: spinlock_t,
    pub dispatch_wait: wait_queue_entry_t,
    pub wait_index: atomic_t,
    pub tags: *mut blk_mq_tags,
    pub sched_tags: *mut blk_mq_tags,
    pub numa_node: ffi::c_uint,
    pub queue_num: ffi::c_uint,
    pub nr_active: atomic_t,
    pub cpuhp_online: hlist_node,
    pub cpuhp_dead: hlist_node,
    pub kobj: kobject,
    pub debugfs_dir: *mut dentry,
    pub sched_debugfs_dir: *mut dentry,
    pub hctx_list: list_head,
}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct blk_mq_hw_ctx__bindgen_ty_1 {
    pub lock: spinlock_t,
    pub dispatch: list_head,
    pub state: ffi::c_ulong,
}
impl Default for blk_mq_hw_ctx__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for blk_mq_hw_ctx {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct blk_mq_queue_map {
    pub mq_map: *mut ffi::c_uint,
    pub nr_queues: ffi::c_uint,
    pub queue_offset: ffi::c_uint,
}
impl Default for blk_mq_queue_map {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const hctx_type_HCTX_TYPE_DEFAULT: hctx_type = 0;
pub const hctx_type_HCTX_TYPE_READ: hctx_type = 1;
pub const hctx_type_HCTX_TYPE_POLL: hctx_type = 2;
pub const hctx_type_HCTX_MAX_TYPES: hctx_type = 3;
pub type hctx_type = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct blk_mq_tag_set {
    pub ops: *const blk_mq_ops,
    pub map: [blk_mq_queue_map; 3usize],
    pub nr_maps: ffi::c_uint,
    pub nr_hw_queues: ffi::c_uint,
    pub queue_depth: ffi::c_uint,
    pub reserved_tags: ffi::c_uint,
    pub cmd_size: ffi::c_uint,
    pub numa_node: ffi::c_int,
    pub timeout: ffi::c_uint,
    pub flags: ffi::c_uint,
    pub driver_data: *mut ffi::c_void,
    pub tags: *mut *mut blk_mq_tags,
    pub shared_tags: *mut blk_mq_tags,
    pub tag_list_lock: mutex,
    pub tag_list: list_head,
    pub srcu: *mut srcu_struct,
}
impl Default for blk_mq_tag_set {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct blk_mq_queue_data {
    pub rq: *mut request,
    pub last: bool_,
}
impl Default for blk_mq_queue_data {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type busy_tag_iter_fn = ::core::option::Option<
    unsafe extern "C" fn(arg1: *mut request, arg2: *mut ffi::c_void) -> bool_,
>;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct blk_mq_ops {
    pub queue_rq: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut blk_mq_hw_ctx,
            arg2: *const blk_mq_queue_data,
        ) -> blk_status_t,
    >,
    pub commit_rqs: ::core::option::Option<unsafe extern "C" fn(arg1: *mut blk_mq_hw_ctx)>,
    pub queue_rqs: ::core::option::Option<unsafe extern "C" fn(rqlist: *mut rq_list)>,
    pub get_budget:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut request_queue) -> ffi::c_int>,
    pub put_budget:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut request_queue, arg2: ffi::c_int)>,
    pub set_rq_budget_token:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut request, arg2: ffi::c_int)>,
    pub get_rq_budget_token:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut request) -> ffi::c_int>,
    pub timeout:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut request) -> blk_eh_timer_return>,
    pub poll: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut blk_mq_hw_ctx, arg2: *mut io_comp_batch) -> ffi::c_int,
    >,
    pub complete: ::core::option::Option<unsafe extern "C" fn(arg1: *mut request)>,
    pub init_hctx: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut blk_mq_hw_ctx,
            arg2: *mut ffi::c_void,
            arg3: ffi::c_uint,
        ) -> ffi::c_int,
    >,
    pub exit_hctx:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut blk_mq_hw_ctx, arg2: ffi::c_uint)>,
    pub init_request: ::core::option::Option<
        unsafe extern "C" fn(
            set: *mut blk_mq_tag_set,
            arg1: *mut request,
            arg2: ffi::c_uint,
            arg3: ffi::c_uint,
        ) -> ffi::c_int,
    >,
    pub exit_request: ::core::option::Option<
        unsafe extern "C" fn(set: *mut blk_mq_tag_set, arg1: *mut request, arg2: ffi::c_uint),
    >,
    pub cleanup_rq: ::core::option::Option<unsafe extern "C" fn(arg1: *mut request)>,
    pub busy: ::core::option::Option<unsafe extern "C" fn(arg1: *mut request_queue) -> bool_>,
    pub map_queues: ::core::option::Option<unsafe extern "C" fn(set: *mut blk_mq_tag_set)>,
    pub show_rq: ::core::option::Option<unsafe extern "C" fn(m: *mut seq_file, rq: *mut request)>,
}
pub const BLK_MQ_F_TAG_QUEUE_SHARED: _bindgen_ty_123 = 2;
pub const BLK_MQ_F_STACKING: _bindgen_ty_123 = 4;
pub const BLK_MQ_F_TAG_HCTX_SHARED: _bindgen_ty_123 = 8;
pub const BLK_MQ_F_BLOCKING: _bindgen_ty_123 = 16;
pub const BLK_MQ_F_TAG_RR: _bindgen_ty_123 = 32;
pub const BLK_MQ_F_NO_SCHED_BY_DEFAULT: _bindgen_ty_123 = 64;
pub const BLK_MQ_F_MAX: _bindgen_ty_123 = 128;
pub type _bindgen_ty_123 = ffi::c_uint;
pub const BLK_MQ_S_STOPPED: _bindgen_ty_124 = 0;
pub const BLK_MQ_S_TAG_ACTIVE: _bindgen_ty_124 = 1;
pub const BLK_MQ_S_SCHED_RESTART: _bindgen_ty_124 = 2;
pub const BLK_MQ_S_INACTIVE: _bindgen_ty_124 = 3;
pub const BLK_MQ_S_MAX: _bindgen_ty_124 = 4;
pub type _bindgen_ty_124 = ffi::c_uint;
extern "C" {
    pub fn __blk_mq_alloc_disk(
        set: *mut blk_mq_tag_set,
        lim: *mut queue_limits,
        queuedata: *mut ffi::c_void,
        lkclass: *mut lock_class_key,
    ) -> *mut gendisk;
}
extern "C" {
    pub fn blk_mq_alloc_disk_for_queue(
        q: *mut request_queue,
        lkclass: *mut lock_class_key,
    ) -> *mut gendisk;
}
extern "C" {
    pub fn blk_mq_alloc_queue(
        set: *mut blk_mq_tag_set,
        lim: *mut queue_limits,
        queuedata: *mut ffi::c_void,
    ) -> *mut request_queue;
}
extern "C" {
    pub fn blk_mq_init_allocated_queue(
        set: *mut blk_mq_tag_set,
        q: *mut request_queue,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn blk_mq_destroy_queue(arg1: *mut request_queue);
}
extern "C" {
    pub fn blk_mq_alloc_tag_set(set: *mut blk_mq_tag_set) -> ffi::c_int;
}
extern "C" {
    pub fn blk_mq_alloc_sq_tag_set(
        set: *mut blk_mq_tag_set,
        ops: *const blk_mq_ops,
        queue_depth: ffi::c_uint,
        set_flags: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn blk_mq_free_tag_set(set: *mut blk_mq_tag_set);
}
extern "C" {
    pub fn blk_mq_free_request(rq: *mut request);
}
extern "C" {
    pub fn blk_rq_poll(
        rq: *mut request,
        iob: *mut io_comp_batch,
        poll_flags: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn blk_mq_queue_inflight(q: *mut request_queue) -> bool_;
}
pub const BLK_MQ_REQ_NOWAIT: _bindgen_ty_125 = 1;
pub const BLK_MQ_REQ_RESERVED: _bindgen_ty_125 = 2;
pub const BLK_MQ_REQ_PM: _bindgen_ty_125 = 4;
pub type _bindgen_ty_125 = ffi::c_uint;
extern "C" {
    pub fn blk_mq_alloc_request(
        q: *mut request_queue,
        opf: blk_opf_t,
        flags: blk_mq_req_flags_t,
    ) -> *mut request;
}
extern "C" {
    pub fn blk_mq_alloc_request_hctx(
        q: *mut request_queue,
        opf: blk_opf_t,
        flags: blk_mq_req_flags_t,
        hctx_idx: ffi::c_uint,
    ) -> *mut request;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct blk_mq_tags {
    pub nr_tags: ffi::c_uint,
    pub nr_reserved_tags: ffi::c_uint,
    pub active_queues: ffi::c_uint,
    pub bitmap_tags: sbitmap_queue,
    pub breserved_tags: sbitmap_queue,
    pub rqs: *mut *mut request,
    pub static_rqs: *mut *mut request,
    pub page_list: list_head,
    pub lock: spinlock_t,
}
impl Default for blk_mq_tags {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const BLK_MQ_UNIQUE_TAG_BITS: _bindgen_ty_126 = 16;
pub const BLK_MQ_UNIQUE_TAG_MASK: _bindgen_ty_126 = 65535;
pub type _bindgen_ty_126 = ffi::c_uint;
extern "C" {
    pub fn blk_mq_unique_tag(rq: *mut request) -> u32_;
}
extern "C" {
    pub fn blk_mq_start_request(rq: *mut request);
}
extern "C" {
    pub fn blk_mq_end_request(rq: *mut request, error: blk_status_t);
}
extern "C" {
    pub fn __blk_mq_end_request(rq: *mut request, error: blk_status_t);
}
extern "C" {
    pub fn blk_mq_end_request_batch(ib: *mut io_comp_batch);
}
extern "C" {
    pub fn blk_mq_requeue_request(rq: *mut request, kick_requeue_list: bool_);
}
extern "C" {
    pub fn blk_mq_kick_requeue_list(q: *mut request_queue);
}
extern "C" {
    pub fn blk_mq_delay_kick_requeue_list(q: *mut request_queue, msecs: ffi::c_ulong);
}
extern "C" {
    pub fn blk_mq_complete_request(rq: *mut request);
}
extern "C" {
    pub fn blk_mq_complete_request_remote(rq: *mut request) -> bool_;
}
extern "C" {
    pub fn blk_mq_stop_hw_queue(hctx: *mut blk_mq_hw_ctx);
}
extern "C" {
    pub fn blk_mq_start_hw_queue(hctx: *mut blk_mq_hw_ctx);
}
extern "C" {
    pub fn blk_mq_stop_hw_queues(q: *mut request_queue);
}
extern "C" {
    pub fn blk_mq_start_hw_queues(q: *mut request_queue);
}
extern "C" {
    pub fn blk_mq_start_stopped_hw_queue(hctx: *mut blk_mq_hw_ctx, async_: bool_);
}
extern "C" {
    pub fn blk_mq_start_stopped_hw_queues(q: *mut request_queue, async_: bool_);
}
extern "C" {
    pub fn blk_mq_quiesce_queue(q: *mut request_queue);
}
extern "C" {
    pub fn blk_mq_wait_quiesce_done(set: *mut blk_mq_tag_set);
}
extern "C" {
    pub fn blk_mq_quiesce_tagset(set: *mut blk_mq_tag_set);
}
extern "C" {
    pub fn blk_mq_unquiesce_tagset(set: *mut blk_mq_tag_set);
}
extern "C" {
    pub fn blk_mq_unquiesce_queue(q: *mut request_queue);
}
extern "C" {
    pub fn blk_mq_delay_run_hw_queue(hctx: *mut blk_mq_hw_ctx, msecs: ffi::c_ulong);
}
extern "C" {
    pub fn blk_mq_run_hw_queue(hctx: *mut blk_mq_hw_ctx, async_: bool_);
}
extern "C" {
    pub fn blk_mq_run_hw_queues(q: *mut request_queue, async_: bool_);
}
extern "C" {
    pub fn blk_mq_delay_run_hw_queues(q: *mut request_queue, msecs: ffi::c_ulong);
}
extern "C" {
    pub fn blk_mq_tagset_busy_iter(
        tagset: *mut blk_mq_tag_set,
        fn_: busy_tag_iter_fn,
        priv_: *mut ffi::c_void,
    );
}
extern "C" {
    pub fn blk_mq_tagset_wait_completed_request(tagset: *mut blk_mq_tag_set);
}
extern "C" {
    pub fn blk_mq_freeze_queue_nomemsave(q: *mut request_queue);
}
extern "C" {
    pub fn blk_mq_unfreeze_queue_nomemrestore(q: *mut request_queue);
}
extern "C" {
    pub fn blk_freeze_queue_start(q: *mut request_queue);
}
extern "C" {
    pub fn blk_mq_freeze_queue_wait(q: *mut request_queue);
}
extern "C" {
    pub fn blk_mq_freeze_queue_wait_timeout(
        q: *mut request_queue,
        timeout: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn blk_mq_unfreeze_queue_non_owner(q: *mut request_queue);
}
extern "C" {
    pub fn blk_freeze_queue_start_non_owner(q: *mut request_queue);
}
extern "C" {
    pub fn blk_mq_map_queues(qmap: *mut blk_mq_queue_map);
}
extern "C" {
    pub fn blk_mq_map_hw_queues(qmap: *mut blk_mq_queue_map, dev: *mut device, offset: ffi::c_uint);
}
extern "C" {
    pub fn blk_mq_update_nr_hw_queues(set: *mut blk_mq_tag_set, nr_hw_queues: ffi::c_int);
}
extern "C" {
    pub fn blk_mq_quiesce_queue_nowait(q: *mut request_queue);
}
extern "C" {
    pub fn blk_mq_rq_cpu(rq: *mut request) -> ffi::c_uint;
}
extern "C" {
    pub fn __blk_should_fake_timeout(q: *mut request_queue) -> bool_;
}
extern "C" {
    pub fn blk_mq_hctx_set_fq_lock_class(hctx: *mut blk_mq_hw_ctx, key: *mut lock_class_key);
}
extern "C" {
    pub fn blk_rq_init(q: *mut request_queue, rq: *mut request);
}
extern "C" {
    pub fn blk_rq_prep_clone(
        rq: *mut request,
        rq_src: *mut request,
        bs: *mut bio_set,
        gfp_mask: gfp_t,
        bio_ctr: ::core::option::Option<
            unsafe extern "C" fn(
                arg1: *mut bio,
                arg2: *mut bio,
                arg3: *mut ffi::c_void,
            ) -> ffi::c_int,
        >,
        data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn blk_rq_unprep_clone(rq: *mut request);
}
extern "C" {
    pub fn blk_insert_cloned_request(rq: *mut request) -> blk_status_t;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rq_map_data {
    pub pages: *mut *mut page,
    pub offset: ffi::c_ulong,
    pub page_order: ffi::c_ushort,
    pub nr_entries: ffi::c_ushort,
    pub null_mapped: bool_,
    pub from_user: bool_,
}
impl Default for rq_map_data {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn blk_rq_map_user(
        arg1: *mut request_queue,
        arg2: *mut request,
        arg3: *mut rq_map_data,
        arg4: *mut ffi::c_void,
        arg5: ffi::c_ulong,
        arg6: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn blk_rq_map_user_io(
        arg1: *mut request,
        arg2: *mut rq_map_data,
        arg3: *mut ffi::c_void,
        arg4: ffi::c_ulong,
        arg5: gfp_t,
        arg6: bool_,
        arg7: ffi::c_int,
        arg8: bool_,
        arg9: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn blk_rq_map_user_iov(
        arg1: *mut request_queue,
        arg2: *mut request,
        arg3: *mut rq_map_data,
        arg4: *const iov_iter,
        arg5: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn blk_rq_unmap_user(arg1: *mut bio) -> ffi::c_int;
}
extern "C" {
    pub fn blk_rq_map_kern(
        arg1: *mut request_queue,
        arg2: *mut request,
        arg3: *mut ffi::c_void,
        arg4: ffi::c_uint,
        arg5: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn blk_rq_append_bio(rq: *mut request, bio: *mut bio) -> ffi::c_int;
}
extern "C" {
    pub fn blk_execute_rq_nowait(rq: *mut request, at_head: bool_);
}
extern "C" {
    pub fn blk_execute_rq(rq: *mut request, at_head: bool_) -> blk_status_t;
}
extern "C" {
    pub fn blk_rq_is_poll(rq: *mut request) -> bool_;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct req_iterator {
    pub iter: bvec_iter,
    pub bio: *mut bio,
}
impl Default for req_iterator {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn blk_steal_bios(list: *mut bio_list, rq: *mut request);
}
extern "C" {
    pub fn blk_update_request(
        rq: *mut request,
        error: blk_status_t,
        nr_bytes: ffi::c_uint,
    ) -> bool_;
}
extern "C" {
    pub fn blk_abort_request(arg1: *mut request);
}
extern "C" {
    pub fn __blk_rq_map_sg(
        rq: *mut request,
        sglist: *mut scatterlist,
        last_sg: *mut *mut scatterlist,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn blk_dump_rq_flags(arg1: *mut request, arg2: *mut ffi::c_char);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct faux_device {
    pub dev: device,
}
impl Default for faux_device {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct faux_device_ops {
    pub probe:
        ::core::option::Option<unsafe extern "C" fn(faux_dev: *mut faux_device) -> ffi::c_int>,
    pub remove: ::core::option::Option<unsafe extern "C" fn(faux_dev: *mut faux_device)>,
}
extern "C" {
    pub fn faux_device_create(
        name: *const ffi::c_char,
        parent: *mut device,
        faux_ops: *const faux_device_ops,
    ) -> *mut faux_device;
}
extern "C" {
    pub fn faux_device_create_with_groups(
        name: *const ffi::c_char,
        parent: *mut device,
        faux_ops: *const faux_device_ops,
        groups: *mut *const attribute_group,
    ) -> *mut faux_device;
}
extern "C" {
    pub fn faux_device_destroy(faux_dev: *mut faux_device);
}
extern "C" {
    pub fn dma_map_page_attrs(
        dev: *mut device,
        page: *mut page,
        offset: usize,
        size: usize,
        dir: dma_data_direction,
        attrs: ffi::c_ulong,
    ) -> dma_addr_t;
}
extern "C" {
    pub fn dma_unmap_page_attrs(
        dev: *mut device,
        addr: dma_addr_t,
        size: usize,
        dir: dma_data_direction,
        attrs: ffi::c_ulong,
    );
}
extern "C" {
    pub fn dma_map_sg_attrs(
        dev: *mut device,
        sg: *mut scatterlist,
        nents: ffi::c_int,
        dir: dma_data_direction,
        attrs: ffi::c_ulong,
    ) -> ffi::c_uint;
}
extern "C" {
    pub fn dma_unmap_sg_attrs(
        dev: *mut device,
        sg: *mut scatterlist,
        nents: ffi::c_int,
        dir: dma_data_direction,
        attrs: ffi::c_ulong,
    );
}
extern "C" {
    pub fn dma_map_sgtable(
        dev: *mut device,
        sgt: *mut sg_table,
        dir: dma_data_direction,
        attrs: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn dma_map_resource(
        dev: *mut device,
        phys_addr: phys_addr_t,
        size: usize,
        dir: dma_data_direction,
        attrs: ffi::c_ulong,
    ) -> dma_addr_t;
}
extern "C" {
    pub fn dma_unmap_resource(
        dev: *mut device,
        addr: dma_addr_t,
        size: usize,
        dir: dma_data_direction,
        attrs: ffi::c_ulong,
    );
}
extern "C" {
    pub fn dma_alloc_attrs(
        dev: *mut device,
        size: usize,
        dma_handle: *mut dma_addr_t,
        flag: gfp_t,
        attrs: ffi::c_ulong,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn dma_free_attrs(
        dev: *mut device,
        size: usize,
        cpu_addr: *mut ffi::c_void,
        dma_handle: dma_addr_t,
        attrs: ffi::c_ulong,
    );
}
extern "C" {
    pub fn dmam_alloc_attrs(
        dev: *mut device,
        size: usize,
        dma_handle: *mut dma_addr_t,
        gfp: gfp_t,
        attrs: ffi::c_ulong,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn dmam_free_coherent(
        dev: *mut device,
        size: usize,
        vaddr: *mut ffi::c_void,
        dma_handle: dma_addr_t,
    );
}
extern "C" {
    pub fn dma_get_sgtable_attrs(
        dev: *mut device,
        sgt: *mut sg_table,
        cpu_addr: *mut ffi::c_void,
        dma_addr: dma_addr_t,
        size: usize,
        attrs: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn dma_mmap_attrs(
        dev: *mut device,
        vma: *mut vm_area_struct,
        cpu_addr: *mut ffi::c_void,
        dma_addr: dma_addr_t,
        size: usize,
        attrs: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn dma_can_mmap(dev: *mut device) -> bool_;
}
extern "C" {
    pub fn dma_pci_p2pdma_supported(dev: *mut device) -> bool_;
}
extern "C" {
    pub fn dma_set_mask(dev: *mut device, mask: u64_) -> ffi::c_int;
}
extern "C" {
    pub fn dma_set_coherent_mask(dev: *mut device, mask: u64_) -> ffi::c_int;
}
extern "C" {
    pub fn dma_get_required_mask(dev: *mut device) -> u64_;
}
extern "C" {
    pub fn dma_addressing_limited(dev: *mut device) -> bool_;
}
extern "C" {
    pub fn dma_max_mapping_size(dev: *mut device) -> usize;
}
extern "C" {
    pub fn dma_opt_mapping_size(dev: *mut device) -> usize;
}
extern "C" {
    pub fn dma_get_merge_boundary(dev: *mut device) -> ffi::c_ulong;
}
extern "C" {
    pub fn dma_alloc_noncontiguous(
        dev: *mut device,
        size: usize,
        dir: dma_data_direction,
        gfp: gfp_t,
        attrs: ffi::c_ulong,
    ) -> *mut sg_table;
}
extern "C" {
    pub fn dma_free_noncontiguous(
        dev: *mut device,
        size: usize,
        sgt: *mut sg_table,
        dir: dma_data_direction,
    );
}
extern "C" {
    pub fn dma_vmap_noncontiguous(
        dev: *mut device,
        size: usize,
        sgt: *mut sg_table,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn dma_vunmap_noncontiguous(dev: *mut device, vaddr: *mut ffi::c_void);
}
extern "C" {
    pub fn dma_mmap_noncontiguous(
        dev: *mut device,
        vma: *mut vm_area_struct,
        size: usize,
        sgt: *mut sg_table,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __dma_sync_single_for_cpu(
        dev: *mut device,
        addr: dma_addr_t,
        size: usize,
        dir: dma_data_direction,
    );
}
extern "C" {
    pub fn __dma_sync_single_for_device(
        dev: *mut device,
        addr: dma_addr_t,
        size: usize,
        dir: dma_data_direction,
    );
}
extern "C" {
    pub fn __dma_sync_sg_for_cpu(
        dev: *mut device,
        sg: *mut scatterlist,
        nelems: ffi::c_int,
        dir: dma_data_direction,
    );
}
extern "C" {
    pub fn __dma_sync_sg_for_device(
        dev: *mut device,
        sg: *mut scatterlist,
        nelems: ffi::c_int,
        dir: dma_data_direction,
    );
}
extern "C" {
    pub fn __dma_need_sync(dev: *mut device, dma_addr: dma_addr_t) -> bool_;
}
extern "C" {
    pub fn dma_alloc_pages(
        dev: *mut device,
        size: usize,
        dma_handle: *mut dma_addr_t,
        dir: dma_data_direction,
        gfp: gfp_t,
    ) -> *mut page;
}
extern "C" {
    pub fn dma_free_pages(
        dev: *mut device,
        size: usize,
        page: *mut page,
        dma_handle: dma_addr_t,
        dir: dma_data_direction,
    );
}
extern "C" {
    pub fn dma_mmap_pages(
        dev: *mut device,
        vma: *mut vm_area_struct,
        size: usize,
        page: *mut page,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn dma_coherent_ok(dev: *mut device, phys: phys_addr_t, size: usize) -> bool_;
}
extern "C" {
    pub fn errname(err: ffi::c_int) -> *const ffi::c_char;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct in6_addr {
    pub in6_u: in6_addr__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union in6_addr__bindgen_ty_1 {
    pub u6_addr8: [__u8; 16usize],
    pub u6_addr16: [__be16; 8usize],
    pub u6_addr32: [__be32; 4usize],
}
impl Default for in6_addr__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for in6_addr {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sockaddr_in6 {
    pub sin6_family: ffi::c_ushort,
    pub sin6_port: __be16,
    pub sin6_flowinfo: __be32,
    pub sin6_addr: in6_addr,
    pub sin6_scope_id: __u32,
}
impl Default for sockaddr_in6 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ipv6_mreq {
    pub ipv6mr_multiaddr: in6_addr,
    pub ipv6mr_ifindex: ffi::c_int,
}
impl Default for ipv6_mreq {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct in6_flowlabel_req {
    pub flr_dst: in6_addr,
    pub flr_label: __be32,
    pub flr_action: __u8,
    pub flr_share: __u8,
    pub flr_flags: __u16,
    pub flr_expires: __u16,
    pub flr_linger: __u16,
    pub __flr_pad: __u32,
}
impl Default for in6_flowlabel_req {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static in6addr_any: in6_addr;
}
extern "C" {
    pub static in6addr_loopback: in6_addr;
}
extern "C" {
    pub static in6addr_linklocal_allnodes: in6_addr;
}
extern "C" {
    pub static in6addr_linklocal_allrouters: in6_addr;
}
extern "C" {
    pub static in6addr_interfacelocal_allnodes: in6_addr;
}
extern "C" {
    pub static in6addr_interfacelocal_allrouters: in6_addr;
}
extern "C" {
    pub static in6addr_sitelocal_allrouters: in6_addr;
}
extern "C" {
    pub fn csum_ipv6_magic(
        saddr: *const in6_addr,
        daddr: *const in6_addr,
        len: __u32,
        proto: __u8,
        sum: __wsum,
    ) -> __sum16;
}
extern "C" {
    pub fn do_csum(buff: *const ffi::c_uchar, len: ffi::c_int) -> ffi::c_uint;
}
extern "C" {
    pub fn csum_partial(buff: *const ffi::c_void, len: ffi::c_int, sum: __wsum) -> __wsum;
}
extern "C" {
    pub fn csum_tcpudp_nofold(
        saddr: __be32,
        daddr: __be32,
        len: __u32,
        proto: __u8,
        sum: __wsum,
    ) -> __wsum;
}
extern "C" {
    pub fn ip_compute_csum(buff: *const ffi::c_void, len: ffi::c_int) -> __sum16;
}
extern "C" {
    pub fn inet_proto_csum_replace4(
        sum: *mut __sum16,
        skb: *mut sk_buff,
        from: __be32,
        to: __be32,
        pseudohdr: bool_,
    );
}
extern "C" {
    pub fn inet_proto_csum_replace16(
        sum: *mut __sum16,
        skb: *mut sk_buff,
        from: *const __be32,
        to: *const __be32,
        pseudohdr: bool_,
    );
}
extern "C" {
    pub fn inet_proto_csum_replace_by_diff(
        sum: *mut __sum16,
        skb: *mut sk_buff,
        diff: __wsum,
        pseudohdr: bool_,
    );
}
pub type netdev_features_t = u64_;
pub const NETIF_F_SG_BIT: _bindgen_ty_127 = 0;
pub const NETIF_F_IP_CSUM_BIT: _bindgen_ty_127 = 1;
pub const __UNUSED_NETIF_F_1: _bindgen_ty_127 = 2;
pub const NETIF_F_HW_CSUM_BIT: _bindgen_ty_127 = 3;
pub const NETIF_F_IPV6_CSUM_BIT: _bindgen_ty_127 = 4;
pub const NETIF_F_HIGHDMA_BIT: _bindgen_ty_127 = 5;
pub const NETIF_F_FRAGLIST_BIT: _bindgen_ty_127 = 6;
pub const NETIF_F_HW_VLAN_CTAG_TX_BIT: _bindgen_ty_127 = 7;
pub const NETIF_F_HW_VLAN_CTAG_RX_BIT: _bindgen_ty_127 = 8;
pub const NETIF_F_HW_VLAN_CTAG_FILTER_BIT: _bindgen_ty_127 = 9;
pub const NETIF_F_VLAN_CHALLENGED_BIT: _bindgen_ty_127 = 10;
pub const NETIF_F_GSO_BIT: _bindgen_ty_127 = 11;
pub const __UNUSED_NETIF_F_12: _bindgen_ty_127 = 12;
pub const __UNUSED_NETIF_F_13: _bindgen_ty_127 = 13;
pub const NETIF_F_GRO_BIT: _bindgen_ty_127 = 14;
pub const NETIF_F_LRO_BIT: _bindgen_ty_127 = 15;
pub const NETIF_F_GSO_SHIFT: _bindgen_ty_127 = 16;
pub const NETIF_F_TSO_BIT: _bindgen_ty_127 = 16;
pub const NETIF_F_GSO_ROBUST_BIT: _bindgen_ty_127 = 17;
pub const NETIF_F_TSO_ECN_BIT: _bindgen_ty_127 = 18;
pub const NETIF_F_TSO_MANGLEID_BIT: _bindgen_ty_127 = 19;
pub const NETIF_F_TSO6_BIT: _bindgen_ty_127 = 20;
pub const NETIF_F_FSO_BIT: _bindgen_ty_127 = 21;
pub const NETIF_F_GSO_GRE_BIT: _bindgen_ty_127 = 22;
pub const NETIF_F_GSO_GRE_CSUM_BIT: _bindgen_ty_127 = 23;
pub const NETIF_F_GSO_IPXIP4_BIT: _bindgen_ty_127 = 24;
pub const NETIF_F_GSO_IPXIP6_BIT: _bindgen_ty_127 = 25;
pub const NETIF_F_GSO_UDP_TUNNEL_BIT: _bindgen_ty_127 = 26;
pub const NETIF_F_GSO_UDP_TUNNEL_CSUM_BIT: _bindgen_ty_127 = 27;
pub const NETIF_F_GSO_PARTIAL_BIT: _bindgen_ty_127 = 28;
pub const NETIF_F_GSO_TUNNEL_REMCSUM_BIT: _bindgen_ty_127 = 29;
pub const NETIF_F_GSO_SCTP_BIT: _bindgen_ty_127 = 30;
pub const NETIF_F_GSO_ESP_BIT: _bindgen_ty_127 = 31;
pub const NETIF_F_GSO_UDP_BIT: _bindgen_ty_127 = 32;
pub const NETIF_F_GSO_UDP_L4_BIT: _bindgen_ty_127 = 33;
pub const NETIF_F_GSO_FRAGLIST_BIT: _bindgen_ty_127 = 34;
pub const NETIF_F_GSO_ACCECN_BIT: _bindgen_ty_127 = 35;
pub const NETIF_F_GSO_LAST: _bindgen_ty_127 = 35;
pub const NETIF_F_FCOE_CRC_BIT: _bindgen_ty_127 = 36;
pub const NETIF_F_SCTP_CRC_BIT: _bindgen_ty_127 = 37;
pub const NETIF_F_NTUPLE_BIT: _bindgen_ty_127 = 38;
pub const NETIF_F_RXHASH_BIT: _bindgen_ty_127 = 39;
pub const NETIF_F_RXCSUM_BIT: _bindgen_ty_127 = 40;
pub const NETIF_F_NOCACHE_COPY_BIT: _bindgen_ty_127 = 41;
pub const NETIF_F_LOOPBACK_BIT: _bindgen_ty_127 = 42;
pub const NETIF_F_RXFCS_BIT: _bindgen_ty_127 = 43;
pub const NETIF_F_RXALL_BIT: _bindgen_ty_127 = 44;
pub const NETIF_F_HW_VLAN_STAG_TX_BIT: _bindgen_ty_127 = 45;
pub const NETIF_F_HW_VLAN_STAG_RX_BIT: _bindgen_ty_127 = 46;
pub const NETIF_F_HW_VLAN_STAG_FILTER_BIT: _bindgen_ty_127 = 47;
pub const NETIF_F_HW_L2FW_DOFFLOAD_BIT: _bindgen_ty_127 = 48;
pub const NETIF_F_HW_TC_BIT: _bindgen_ty_127 = 49;
pub const NETIF_F_HW_ESP_BIT: _bindgen_ty_127 = 50;
pub const NETIF_F_HW_ESP_TX_CSUM_BIT: _bindgen_ty_127 = 51;
pub const NETIF_F_RX_UDP_TUNNEL_PORT_BIT: _bindgen_ty_127 = 52;
pub const NETIF_F_HW_TLS_TX_BIT: _bindgen_ty_127 = 53;
pub const NETIF_F_HW_TLS_RX_BIT: _bindgen_ty_127 = 54;
pub const NETIF_F_GRO_HW_BIT: _bindgen_ty_127 = 55;
pub const NETIF_F_HW_TLS_RECORD_BIT: _bindgen_ty_127 = 56;
pub const NETIF_F_GRO_FRAGLIST_BIT: _bindgen_ty_127 = 57;
pub const NETIF_F_HW_MACSEC_BIT: _bindgen_ty_127 = 58;
pub const NETIF_F_GRO_UDP_FWD_BIT: _bindgen_ty_127 = 59;
pub const NETIF_F_HW_HSR_TAG_INS_BIT: _bindgen_ty_127 = 60;
pub const NETIF_F_HW_HSR_TAG_RM_BIT: _bindgen_ty_127 = 61;
pub const NETIF_F_HW_HSR_FWD_BIT: _bindgen_ty_127 = 62;
pub const NETIF_F_HW_HSR_DUP_BIT: _bindgen_ty_127 = 63;
pub const NETDEV_FEATURE_COUNT: _bindgen_ty_127 = 64;
pub type _bindgen_ty_127 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct siphash_key_t {
    pub key: [u64_; 2usize],
}
extern "C" {
    pub fn __siphash_aligned(
        data: *const ffi::c_void,
        len: usize,
        key: *const siphash_key_t,
    ) -> u64_;
}
extern "C" {
    pub fn __siphash_unaligned(
        data: *const ffi::c_void,
        len: usize,
        key: *const siphash_key_t,
    ) -> u64_;
}
extern "C" {
    pub fn siphash_1u64(a: u64_, key: *const siphash_key_t) -> u64_;
}
extern "C" {
    pub fn siphash_2u64(a: u64_, b: u64_, key: *const siphash_key_t) -> u64_;
}
extern "C" {
    pub fn siphash_3u64(a: u64_, b: u64_, c: u64_, key: *const siphash_key_t) -> u64_;
}
extern "C" {
    pub fn siphash_4u64(a: u64_, b: u64_, c: u64_, d: u64_, key: *const siphash_key_t) -> u64_;
}
extern "C" {
    pub fn siphash_1u32(a: u32_, key: *const siphash_key_t) -> u64_;
}
extern "C" {
    pub fn siphash_3u32(a: u32_, b: u32_, c: u32_, key: *const siphash_key_t) -> u64_;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct hsiphash_key_t {
    pub key: [ffi::c_ulong; 2usize],
}
extern "C" {
    pub fn __hsiphash_aligned(
        data: *const ffi::c_void,
        len: usize,
        key: *const hsiphash_key_t,
    ) -> u32_;
}
extern "C" {
    pub fn __hsiphash_unaligned(
        data: *const ffi::c_void,
        len: usize,
        key: *const hsiphash_key_t,
    ) -> u32_;
}
extern "C" {
    pub fn hsiphash_1u32(a: u32_, key: *const hsiphash_key_t) -> u32_;
}
extern "C" {
    pub fn hsiphash_2u32(a: u32_, b: u32_, key: *const hsiphash_key_t) -> u32_;
}
extern "C" {
    pub fn hsiphash_3u32(a: u32_, b: u32_, c: u32_, key: *const hsiphash_key_t) -> u32_;
}
extern "C" {
    pub fn hsiphash_4u32(a: u32_, b: u32_, c: u32_, d: u32_, key: *const hsiphash_key_t) -> u32_;
}
#[repr(C, packed)]
#[derive(Default, Copy, Clone)]
pub struct ethhdr {
    pub h_dest: [ffi::c_uchar; 6usize],
    pub h_source: [ffi::c_uchar; 6usize],
    pub h_proto: __be16,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_stats {
    pub bytes: __u64,
    pub packets: __u32,
    pub drops: __u32,
    pub overlimits: __u32,
    pub bps: __u32,
    pub pps: __u32,
    pub qlen: __u32,
    pub backlog: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_estimator {
    pub interval: ffi::c_schar,
    pub ewma_log: ffi::c_uchar,
}
pub const tc_link_layer_TC_LINKLAYER_UNAWARE: tc_link_layer = 0;
pub const tc_link_layer_TC_LINKLAYER_ETHERNET: tc_link_layer = 1;
pub const tc_link_layer_TC_LINKLAYER_ATM: tc_link_layer = 2;
pub type tc_link_layer = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_ratespec {
    pub cell_log: ffi::c_uchar,
    pub linklayer: __u8,
    pub overhead: ffi::c_ushort,
    pub cell_align: ffi::c_short,
    pub mpu: ffi::c_ushort,
    pub rate: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_sizespec {
    pub cell_log: ffi::c_uchar,
    pub size_log: ffi::c_uchar,
    pub cell_align: ffi::c_short,
    pub overhead: ffi::c_int,
    pub linklayer: ffi::c_uint,
    pub mpu: ffi::c_uint,
    pub mtu: ffi::c_uint,
    pub tsize: ffi::c_uint,
}
pub const TCA_STAB_UNSPEC: _bindgen_ty_128 = 0;
pub const TCA_STAB_BASE: _bindgen_ty_128 = 1;
pub const TCA_STAB_DATA: _bindgen_ty_128 = 2;
pub const __TCA_STAB_MAX: _bindgen_ty_128 = 3;
pub type _bindgen_ty_128 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_fifo_qopt {
    pub limit: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_skbprio_qopt {
    pub limit: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_prio_qopt {
    pub bands: ffi::c_int,
    pub priomap: [__u8; 16usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_multiq_qopt {
    pub bands: __u16,
    pub max_bands: __u16,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_plug_qopt {
    pub action: ffi::c_int,
    pub limit: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_tbf_qopt {
    pub rate: tc_ratespec,
    pub peakrate: tc_ratespec,
    pub limit: __u32,
    pub buffer: __u32,
    pub mtu: __u32,
}
pub const TCA_TBF_UNSPEC: _bindgen_ty_129 = 0;
pub const TCA_TBF_PARMS: _bindgen_ty_129 = 1;
pub const TCA_TBF_RTAB: _bindgen_ty_129 = 2;
pub const TCA_TBF_PTAB: _bindgen_ty_129 = 3;
pub const TCA_TBF_RATE64: _bindgen_ty_129 = 4;
pub const TCA_TBF_PRATE64: _bindgen_ty_129 = 5;
pub const TCA_TBF_BURST: _bindgen_ty_129 = 6;
pub const TCA_TBF_PBURST: _bindgen_ty_129 = 7;
pub const TCA_TBF_PAD: _bindgen_ty_129 = 8;
pub const __TCA_TBF_MAX: _bindgen_ty_129 = 9;
pub type _bindgen_ty_129 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_sfq_qopt {
    pub quantum: ffi::c_uint,
    pub perturb_period: ffi::c_int,
    pub limit: __u32,
    pub divisor: ffi::c_uint,
    pub flows: ffi::c_uint,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_sfqred_stats {
    pub prob_drop: __u32,
    pub forced_drop: __u32,
    pub prob_mark: __u32,
    pub forced_mark: __u32,
    pub prob_mark_head: __u32,
    pub forced_mark_head: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_sfq_qopt_v1 {
    pub v0: tc_sfq_qopt,
    pub depth: ffi::c_uint,
    pub headdrop: ffi::c_uint,
    pub limit: __u32,
    pub qth_min: __u32,
    pub qth_max: __u32,
    pub Wlog: ffi::c_uchar,
    pub Plog: ffi::c_uchar,
    pub Scell_log: ffi::c_uchar,
    pub flags: ffi::c_uchar,
    pub max_P: __u32,
    pub stats: tc_sfqred_stats,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_sfq_xstats {
    pub allot: __s32,
}
pub const TCA_RED_UNSPEC: _bindgen_ty_130 = 0;
pub const TCA_RED_PARMS: _bindgen_ty_130 = 1;
pub const TCA_RED_STAB: _bindgen_ty_130 = 2;
pub const TCA_RED_MAX_P: _bindgen_ty_130 = 3;
pub const TCA_RED_FLAGS: _bindgen_ty_130 = 4;
pub const TCA_RED_EARLY_DROP_BLOCK: _bindgen_ty_130 = 5;
pub const TCA_RED_MARK_BLOCK: _bindgen_ty_130 = 6;
pub const __TCA_RED_MAX: _bindgen_ty_130 = 7;
pub type _bindgen_ty_130 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_red_qopt {
    pub limit: __u32,
    pub qth_min: __u32,
    pub qth_max: __u32,
    pub Wlog: ffi::c_uchar,
    pub Plog: ffi::c_uchar,
    pub Scell_log: ffi::c_uchar,
    pub flags: ffi::c_uchar,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_red_xstats {
    pub early: __u32,
    pub pdrop: __u32,
    pub other: __u32,
    pub marked: __u32,
}
pub const TCA_GRED_UNSPEC: _bindgen_ty_131 = 0;
pub const TCA_GRED_PARMS: _bindgen_ty_131 = 1;
pub const TCA_GRED_STAB: _bindgen_ty_131 = 2;
pub const TCA_GRED_DPS: _bindgen_ty_131 = 3;
pub const TCA_GRED_MAX_P: _bindgen_ty_131 = 4;
pub const TCA_GRED_LIMIT: _bindgen_ty_131 = 5;
pub const TCA_GRED_VQ_LIST: _bindgen_ty_131 = 6;
pub const __TCA_GRED_MAX: _bindgen_ty_131 = 7;
pub type _bindgen_ty_131 = ffi::c_uint;
pub const TCA_GRED_VQ_ENTRY_UNSPEC: _bindgen_ty_132 = 0;
pub const TCA_GRED_VQ_ENTRY: _bindgen_ty_132 = 1;
pub const __TCA_GRED_VQ_ENTRY_MAX: _bindgen_ty_132 = 2;
pub type _bindgen_ty_132 = ffi::c_uint;
pub const TCA_GRED_VQ_UNSPEC: _bindgen_ty_133 = 0;
pub const TCA_GRED_VQ_PAD: _bindgen_ty_133 = 1;
pub const TCA_GRED_VQ_DP: _bindgen_ty_133 = 2;
pub const TCA_GRED_VQ_STAT_BYTES: _bindgen_ty_133 = 3;
pub const TCA_GRED_VQ_STAT_PACKETS: _bindgen_ty_133 = 4;
pub const TCA_GRED_VQ_STAT_BACKLOG: _bindgen_ty_133 = 5;
pub const TCA_GRED_VQ_STAT_PROB_DROP: _bindgen_ty_133 = 6;
pub const TCA_GRED_VQ_STAT_PROB_MARK: _bindgen_ty_133 = 7;
pub const TCA_GRED_VQ_STAT_FORCED_DROP: _bindgen_ty_133 = 8;
pub const TCA_GRED_VQ_STAT_FORCED_MARK: _bindgen_ty_133 = 9;
pub const TCA_GRED_VQ_STAT_PDROP: _bindgen_ty_133 = 10;
pub const TCA_GRED_VQ_STAT_OTHER: _bindgen_ty_133 = 11;
pub const TCA_GRED_VQ_FLAGS: _bindgen_ty_133 = 12;
pub const __TCA_GRED_VQ_MAX: _bindgen_ty_133 = 13;
pub type _bindgen_ty_133 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_gred_qopt {
    pub limit: __u32,
    pub qth_min: __u32,
    pub qth_max: __u32,
    pub DP: __u32,
    pub backlog: __u32,
    pub qave: __u32,
    pub forced: __u32,
    pub early: __u32,
    pub other: __u32,
    pub pdrop: __u32,
    pub Wlog: __u8,
    pub Plog: __u8,
    pub Scell_log: __u8,
    pub prio: __u8,
    pub packets: __u32,
    pub bytesin: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_gred_sopt {
    pub DPs: __u32,
    pub def_DP: __u32,
    pub grio: __u8,
    pub flags: __u8,
    pub pad1: __u16,
}
pub const TCA_CHOKE_UNSPEC: _bindgen_ty_134 = 0;
pub const TCA_CHOKE_PARMS: _bindgen_ty_134 = 1;
pub const TCA_CHOKE_STAB: _bindgen_ty_134 = 2;
pub const TCA_CHOKE_MAX_P: _bindgen_ty_134 = 3;
pub const __TCA_CHOKE_MAX: _bindgen_ty_134 = 4;
pub type _bindgen_ty_134 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_choke_qopt {
    pub limit: __u32,
    pub qth_min: __u32,
    pub qth_max: __u32,
    pub Wlog: ffi::c_uchar,
    pub Plog: ffi::c_uchar,
    pub Scell_log: ffi::c_uchar,
    pub flags: ffi::c_uchar,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_choke_xstats {
    pub early: __u32,
    pub pdrop: __u32,
    pub other: __u32,
    pub marked: __u32,
    pub matched: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_htb_opt {
    pub rate: tc_ratespec,
    pub ceil: tc_ratespec,
    pub buffer: __u32,
    pub cbuffer: __u32,
    pub quantum: __u32,
    pub level: __u32,
    pub prio: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_htb_glob {
    pub version: __u32,
    pub rate2quantum: __u32,
    pub defcls: __u32,
    pub debug: __u32,
    pub direct_pkts: __u32,
}
pub const TCA_HTB_UNSPEC: _bindgen_ty_135 = 0;
pub const TCA_HTB_PARMS: _bindgen_ty_135 = 1;
pub const TCA_HTB_INIT: _bindgen_ty_135 = 2;
pub const TCA_HTB_CTAB: _bindgen_ty_135 = 3;
pub const TCA_HTB_RTAB: _bindgen_ty_135 = 4;
pub const TCA_HTB_DIRECT_QLEN: _bindgen_ty_135 = 5;
pub const TCA_HTB_RATE64: _bindgen_ty_135 = 6;
pub const TCA_HTB_CEIL64: _bindgen_ty_135 = 7;
pub const TCA_HTB_PAD: _bindgen_ty_135 = 8;
pub const TCA_HTB_OFFLOAD: _bindgen_ty_135 = 9;
pub const __TCA_HTB_MAX: _bindgen_ty_135 = 10;
pub type _bindgen_ty_135 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_htb_xstats {
    pub lends: __u32,
    pub borrows: __u32,
    pub giants: __u32,
    pub tokens: __s32,
    pub ctokens: __s32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_hfsc_qopt {
    pub defcls: __u16,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_service_curve {
    pub m1: __u32,
    pub d: __u32,
    pub m2: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_hfsc_stats {
    pub work: __u64,
    pub rtwork: __u64,
    pub period: __u32,
    pub level: __u32,
}
pub const TCA_HFSC_UNSPEC: _bindgen_ty_136 = 0;
pub const TCA_HFSC_RSC: _bindgen_ty_136 = 1;
pub const TCA_HFSC_FSC: _bindgen_ty_136 = 2;
pub const TCA_HFSC_USC: _bindgen_ty_136 = 3;
pub const __TCA_HFSC_MAX: _bindgen_ty_136 = 4;
pub type _bindgen_ty_136 = ffi::c_uint;
pub const TCA_NETEM_UNSPEC: _bindgen_ty_137 = 0;
pub const TCA_NETEM_CORR: _bindgen_ty_137 = 1;
pub const TCA_NETEM_DELAY_DIST: _bindgen_ty_137 = 2;
pub const TCA_NETEM_REORDER: _bindgen_ty_137 = 3;
pub const TCA_NETEM_CORRUPT: _bindgen_ty_137 = 4;
pub const TCA_NETEM_LOSS: _bindgen_ty_137 = 5;
pub const TCA_NETEM_RATE: _bindgen_ty_137 = 6;
pub const TCA_NETEM_ECN: _bindgen_ty_137 = 7;
pub const TCA_NETEM_RATE64: _bindgen_ty_137 = 8;
pub const TCA_NETEM_PAD: _bindgen_ty_137 = 9;
pub const TCA_NETEM_LATENCY64: _bindgen_ty_137 = 10;
pub const TCA_NETEM_JITTER64: _bindgen_ty_137 = 11;
pub const TCA_NETEM_SLOT: _bindgen_ty_137 = 12;
pub const TCA_NETEM_SLOT_DIST: _bindgen_ty_137 = 13;
pub const TCA_NETEM_PRNG_SEED: _bindgen_ty_137 = 14;
pub const __TCA_NETEM_MAX: _bindgen_ty_137 = 15;
pub type _bindgen_ty_137 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_netem_qopt {
    pub latency: __u32,
    pub limit: __u32,
    pub loss: __u32,
    pub gap: __u32,
    pub duplicate: __u32,
    pub jitter: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_netem_corr {
    pub delay_corr: __u32,
    pub loss_corr: __u32,
    pub dup_corr: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_netem_reorder {
    pub probability: __u32,
    pub correlation: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_netem_corrupt {
    pub probability: __u32,
    pub correlation: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_netem_rate {
    pub rate: __u32,
    pub packet_overhead: __s32,
    pub cell_size: __u32,
    pub cell_overhead: __s32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_netem_slot {
    pub min_delay: __s64,
    pub max_delay: __s64,
    pub max_packets: __s32,
    pub max_bytes: __s32,
    pub dist_delay: __s64,
    pub dist_jitter: __s64,
}
pub const NETEM_LOSS_UNSPEC: _bindgen_ty_138 = 0;
pub const NETEM_LOSS_GI: _bindgen_ty_138 = 1;
pub const NETEM_LOSS_GE: _bindgen_ty_138 = 2;
pub const __NETEM_LOSS_MAX: _bindgen_ty_138 = 3;
pub type _bindgen_ty_138 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_netem_gimodel {
    pub p13: __u32,
    pub p31: __u32,
    pub p32: __u32,
    pub p14: __u32,
    pub p23: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_netem_gemodel {
    pub p: __u32,
    pub r: __u32,
    pub h: __u32,
    pub k1: __u32,
}
pub const TCA_DRR_UNSPEC: _bindgen_ty_139 = 0;
pub const TCA_DRR_QUANTUM: _bindgen_ty_139 = 1;
pub const __TCA_DRR_MAX: _bindgen_ty_139 = 2;
pub type _bindgen_ty_139 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_drr_stats {
    pub deficit: __u32,
}
pub const TC_MQPRIO_HW_OFFLOAD_NONE: _bindgen_ty_140 = 0;
pub const TC_MQPRIO_HW_OFFLOAD_TCS: _bindgen_ty_140 = 1;
pub const __TC_MQPRIO_HW_OFFLOAD_MAX: _bindgen_ty_140 = 2;
pub type _bindgen_ty_140 = ffi::c_uint;
pub const TC_MQPRIO_MODE_DCB: _bindgen_ty_141 = 0;
pub const TC_MQPRIO_MODE_CHANNEL: _bindgen_ty_141 = 1;
pub const __TC_MQPRIO_MODE_MAX: _bindgen_ty_141 = 2;
pub type _bindgen_ty_141 = ffi::c_uint;
pub const TC_MQPRIO_SHAPER_DCB: _bindgen_ty_142 = 0;
pub const TC_MQPRIO_SHAPER_BW_RATE: _bindgen_ty_142 = 1;
pub const __TC_MQPRIO_SHAPER_MAX: _bindgen_ty_142 = 2;
pub type _bindgen_ty_142 = ffi::c_uint;
pub const TC_FP_EXPRESS: _bindgen_ty_143 = 1;
pub const TC_FP_PREEMPTIBLE: _bindgen_ty_143 = 2;
pub type _bindgen_ty_143 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_mqprio_qopt {
    pub num_tc: __u8,
    pub prio_tc_map: [__u8; 16usize],
    pub hw: __u8,
    pub count: [__u16; 16usize],
    pub offset: [__u16; 16usize],
}
pub const TCA_MQPRIO_TC_ENTRY_UNSPEC: _bindgen_ty_144 = 0;
pub const TCA_MQPRIO_TC_ENTRY_INDEX: _bindgen_ty_144 = 1;
pub const TCA_MQPRIO_TC_ENTRY_FP: _bindgen_ty_144 = 2;
pub const __TCA_MQPRIO_TC_ENTRY_CNT: _bindgen_ty_144 = 3;
pub const TCA_MQPRIO_TC_ENTRY_MAX: _bindgen_ty_144 = 2;
pub type _bindgen_ty_144 = ffi::c_uint;
pub const TCA_MQPRIO_UNSPEC: _bindgen_ty_145 = 0;
pub const TCA_MQPRIO_MODE: _bindgen_ty_145 = 1;
pub const TCA_MQPRIO_SHAPER: _bindgen_ty_145 = 2;
pub const TCA_MQPRIO_MIN_RATE64: _bindgen_ty_145 = 3;
pub const TCA_MQPRIO_MAX_RATE64: _bindgen_ty_145 = 4;
pub const TCA_MQPRIO_TC_ENTRY: _bindgen_ty_145 = 5;
pub const __TCA_MQPRIO_MAX: _bindgen_ty_145 = 6;
pub type _bindgen_ty_145 = ffi::c_uint;
pub const TCA_SFB_UNSPEC: _bindgen_ty_146 = 0;
pub const TCA_SFB_PARMS: _bindgen_ty_146 = 1;
pub const __TCA_SFB_MAX: _bindgen_ty_146 = 2;
pub type _bindgen_ty_146 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_sfb_qopt {
    pub rehash_interval: __u32,
    pub warmup_time: __u32,
    pub max: __u32,
    pub bin_size: __u32,
    pub increment: __u32,
    pub decrement: __u32,
    pub limit: __u32,
    pub penalty_rate: __u32,
    pub penalty_burst: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_sfb_xstats {
    pub earlydrop: __u32,
    pub penaltydrop: __u32,
    pub bucketdrop: __u32,
    pub queuedrop: __u32,
    pub childdrop: __u32,
    pub marked: __u32,
    pub maxqlen: __u32,
    pub maxprob: __u32,
    pub avgprob: __u32,
}
pub const TCA_QFQ_UNSPEC: _bindgen_ty_147 = 0;
pub const TCA_QFQ_WEIGHT: _bindgen_ty_147 = 1;
pub const TCA_QFQ_LMAX: _bindgen_ty_147 = 2;
pub const __TCA_QFQ_MAX: _bindgen_ty_147 = 3;
pub type _bindgen_ty_147 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_qfq_stats {
    pub weight: __u32,
    pub lmax: __u32,
}
pub const TCA_CODEL_UNSPEC: _bindgen_ty_148 = 0;
pub const TCA_CODEL_TARGET: _bindgen_ty_148 = 1;
pub const TCA_CODEL_LIMIT: _bindgen_ty_148 = 2;
pub const TCA_CODEL_INTERVAL: _bindgen_ty_148 = 3;
pub const TCA_CODEL_ECN: _bindgen_ty_148 = 4;
pub const TCA_CODEL_CE_THRESHOLD: _bindgen_ty_148 = 5;
pub const __TCA_CODEL_MAX: _bindgen_ty_148 = 6;
pub type _bindgen_ty_148 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_codel_xstats {
    pub maxpacket: __u32,
    pub count: __u32,
    pub lastcount: __u32,
    pub ldelay: __u32,
    pub drop_next: __s32,
    pub drop_overlimit: __u32,
    pub ecn_mark: __u32,
    pub dropping: __u32,
    pub ce_mark: __u32,
}
pub const TCA_FQ_CODEL_UNSPEC: _bindgen_ty_149 = 0;
pub const TCA_FQ_CODEL_TARGET: _bindgen_ty_149 = 1;
pub const TCA_FQ_CODEL_LIMIT: _bindgen_ty_149 = 2;
pub const TCA_FQ_CODEL_INTERVAL: _bindgen_ty_149 = 3;
pub const TCA_FQ_CODEL_ECN: _bindgen_ty_149 = 4;
pub const TCA_FQ_CODEL_FLOWS: _bindgen_ty_149 = 5;
pub const TCA_FQ_CODEL_QUANTUM: _bindgen_ty_149 = 6;
pub const TCA_FQ_CODEL_CE_THRESHOLD: _bindgen_ty_149 = 7;
pub const TCA_FQ_CODEL_DROP_BATCH_SIZE: _bindgen_ty_149 = 8;
pub const TCA_FQ_CODEL_MEMORY_LIMIT: _bindgen_ty_149 = 9;
pub const TCA_FQ_CODEL_CE_THRESHOLD_SELECTOR: _bindgen_ty_149 = 10;
pub const TCA_FQ_CODEL_CE_THRESHOLD_MASK: _bindgen_ty_149 = 11;
pub const __TCA_FQ_CODEL_MAX: _bindgen_ty_149 = 12;
pub type _bindgen_ty_149 = ffi::c_uint;
pub const TCA_FQ_CODEL_XSTATS_QDISC: _bindgen_ty_150 = 0;
pub const TCA_FQ_CODEL_XSTATS_CLASS: _bindgen_ty_150 = 1;
pub type _bindgen_ty_150 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_fq_codel_qd_stats {
    pub maxpacket: __u32,
    pub drop_overlimit: __u32,
    pub ecn_mark: __u32,
    pub new_flow_count: __u32,
    pub new_flows_len: __u32,
    pub old_flows_len: __u32,
    pub ce_mark: __u32,
    pub memory_usage: __u32,
    pub drop_overmemory: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_fq_codel_cl_stats {
    pub deficit: __s32,
    pub ldelay: __u32,
    pub count: __u32,
    pub lastcount: __u32,
    pub dropping: __u32,
    pub drop_next: __s32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tc_fq_codel_xstats {
    pub type_: __u32,
    pub __bindgen_anon_1: tc_fq_codel_xstats__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tc_fq_codel_xstats__bindgen_ty_1 {
    pub qdisc_stats: tc_fq_codel_qd_stats,
    pub class_stats: tc_fq_codel_cl_stats,
}
impl Default for tc_fq_codel_xstats__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for tc_fq_codel_xstats {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const TCA_FQ_UNSPEC: _bindgen_ty_151 = 0;
pub const TCA_FQ_PLIMIT: _bindgen_ty_151 = 1;
pub const TCA_FQ_FLOW_PLIMIT: _bindgen_ty_151 = 2;
pub const TCA_FQ_QUANTUM: _bindgen_ty_151 = 3;
pub const TCA_FQ_INITIAL_QUANTUM: _bindgen_ty_151 = 4;
pub const TCA_FQ_RATE_ENABLE: _bindgen_ty_151 = 5;
pub const TCA_FQ_FLOW_DEFAULT_RATE: _bindgen_ty_151 = 6;
pub const TCA_FQ_FLOW_MAX_RATE: _bindgen_ty_151 = 7;
pub const TCA_FQ_BUCKETS_LOG: _bindgen_ty_151 = 8;
pub const TCA_FQ_FLOW_REFILL_DELAY: _bindgen_ty_151 = 9;
pub const TCA_FQ_ORPHAN_MASK: _bindgen_ty_151 = 10;
pub const TCA_FQ_LOW_RATE_THRESHOLD: _bindgen_ty_151 = 11;
pub const TCA_FQ_CE_THRESHOLD: _bindgen_ty_151 = 12;
pub const TCA_FQ_TIMER_SLACK: _bindgen_ty_151 = 13;
pub const TCA_FQ_HORIZON: _bindgen_ty_151 = 14;
pub const TCA_FQ_HORIZON_DROP: _bindgen_ty_151 = 15;
pub const TCA_FQ_PRIOMAP: _bindgen_ty_151 = 16;
pub const TCA_FQ_WEIGHTS: _bindgen_ty_151 = 17;
pub const TCA_FQ_OFFLOAD_HORIZON: _bindgen_ty_151 = 18;
pub const __TCA_FQ_MAX: _bindgen_ty_151 = 19;
pub type _bindgen_ty_151 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_fq_qd_stats {
    pub gc_flows: __u64,
    pub highprio_packets: __u64,
    pub tcp_retrans: __u64,
    pub throttled: __u64,
    pub flows_plimit: __u64,
    pub pkts_too_long: __u64,
    pub allocation_errors: __u64,
    pub time_next_delayed_flow: __s64,
    pub flows: __u32,
    pub inactive_flows: __u32,
    pub throttled_flows: __u32,
    pub unthrottle_latency_ns: __u32,
    pub ce_mark: __u64,
    pub horizon_drops: __u64,
    pub horizon_caps: __u64,
    pub fastpath_packets: __u64,
    pub band_drops: [__u64; 3usize],
    pub band_pkt_count: [__u32; 3usize],
    pub pad: __u32,
}
pub const TCA_HHF_UNSPEC: _bindgen_ty_152 = 0;
pub const TCA_HHF_BACKLOG_LIMIT: _bindgen_ty_152 = 1;
pub const TCA_HHF_QUANTUM: _bindgen_ty_152 = 2;
pub const TCA_HHF_HH_FLOWS_LIMIT: _bindgen_ty_152 = 3;
pub const TCA_HHF_RESET_TIMEOUT: _bindgen_ty_152 = 4;
pub const TCA_HHF_ADMIT_BYTES: _bindgen_ty_152 = 5;
pub const TCA_HHF_EVICT_TIMEOUT: _bindgen_ty_152 = 6;
pub const TCA_HHF_NON_HH_WEIGHT: _bindgen_ty_152 = 7;
pub const __TCA_HHF_MAX: _bindgen_ty_152 = 8;
pub type _bindgen_ty_152 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_hhf_xstats {
    pub drop_overlimit: __u32,
    pub hh_overlimit: __u32,
    pub hh_tot_count: __u32,
    pub hh_cur_count: __u32,
}
pub const TCA_PIE_UNSPEC: _bindgen_ty_153 = 0;
pub const TCA_PIE_TARGET: _bindgen_ty_153 = 1;
pub const TCA_PIE_LIMIT: _bindgen_ty_153 = 2;
pub const TCA_PIE_TUPDATE: _bindgen_ty_153 = 3;
pub const TCA_PIE_ALPHA: _bindgen_ty_153 = 4;
pub const TCA_PIE_BETA: _bindgen_ty_153 = 5;
pub const TCA_PIE_ECN: _bindgen_ty_153 = 6;
pub const TCA_PIE_BYTEMODE: _bindgen_ty_153 = 7;
pub const TCA_PIE_DQ_RATE_ESTIMATOR: _bindgen_ty_153 = 8;
pub const __TCA_PIE_MAX: _bindgen_ty_153 = 9;
pub type _bindgen_ty_153 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_pie_xstats {
    pub prob: __u64,
    pub delay: __u32,
    pub avg_dq_rate: __u32,
    pub dq_rate_estimating: __u32,
    pub packets_in: __u32,
    pub dropped: __u32,
    pub overlimit: __u32,
    pub maxq: __u32,
    pub ecn_mark: __u32,
}
pub const TCA_FQ_PIE_UNSPEC: _bindgen_ty_154 = 0;
pub const TCA_FQ_PIE_LIMIT: _bindgen_ty_154 = 1;
pub const TCA_FQ_PIE_FLOWS: _bindgen_ty_154 = 2;
pub const TCA_FQ_PIE_TARGET: _bindgen_ty_154 = 3;
pub const TCA_FQ_PIE_TUPDATE: _bindgen_ty_154 = 4;
pub const TCA_FQ_PIE_ALPHA: _bindgen_ty_154 = 5;
pub const TCA_FQ_PIE_BETA: _bindgen_ty_154 = 6;
pub const TCA_FQ_PIE_QUANTUM: _bindgen_ty_154 = 7;
pub const TCA_FQ_PIE_MEMORY_LIMIT: _bindgen_ty_154 = 8;
pub const TCA_FQ_PIE_ECN_PROB: _bindgen_ty_154 = 9;
pub const TCA_FQ_PIE_ECN: _bindgen_ty_154 = 10;
pub const TCA_FQ_PIE_BYTEMODE: _bindgen_ty_154 = 11;
pub const TCA_FQ_PIE_DQ_RATE_ESTIMATOR: _bindgen_ty_154 = 12;
pub const __TCA_FQ_PIE_MAX: _bindgen_ty_154 = 13;
pub type _bindgen_ty_154 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_fq_pie_xstats {
    pub packets_in: __u32,
    pub dropped: __u32,
    pub overlimit: __u32,
    pub overmemory: __u32,
    pub ecn_mark: __u32,
    pub new_flow_count: __u32,
    pub new_flows_len: __u32,
    pub old_flows_len: __u32,
    pub memory_usage: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_cbs_qopt {
    pub offload: __u8,
    pub _pad: [__u8; 3usize],
    pub hicredit: __s32,
    pub locredit: __s32,
    pub idleslope: __s32,
    pub sendslope: __s32,
}
pub const TCA_CBS_UNSPEC: _bindgen_ty_155 = 0;
pub const TCA_CBS_PARMS: _bindgen_ty_155 = 1;
pub const __TCA_CBS_MAX: _bindgen_ty_155 = 2;
pub type _bindgen_ty_155 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_etf_qopt {
    pub delta: __s32,
    pub clockid: __s32,
    pub flags: __u32,
}
pub const TCA_ETF_UNSPEC: _bindgen_ty_156 = 0;
pub const TCA_ETF_PARMS: _bindgen_ty_156 = 1;
pub const __TCA_ETF_MAX: _bindgen_ty_156 = 2;
pub type _bindgen_ty_156 = ffi::c_uint;
pub const TCA_CAKE_UNSPEC: _bindgen_ty_157 = 0;
pub const TCA_CAKE_PAD: _bindgen_ty_157 = 1;
pub const TCA_CAKE_BASE_RATE64: _bindgen_ty_157 = 2;
pub const TCA_CAKE_DIFFSERV_MODE: _bindgen_ty_157 = 3;
pub const TCA_CAKE_ATM: _bindgen_ty_157 = 4;
pub const TCA_CAKE_FLOW_MODE: _bindgen_ty_157 = 5;
pub const TCA_CAKE_OVERHEAD: _bindgen_ty_157 = 6;
pub const TCA_CAKE_RTT: _bindgen_ty_157 = 7;
pub const TCA_CAKE_TARGET: _bindgen_ty_157 = 8;
pub const TCA_CAKE_AUTORATE: _bindgen_ty_157 = 9;
pub const TCA_CAKE_MEMORY: _bindgen_ty_157 = 10;
pub const TCA_CAKE_NAT: _bindgen_ty_157 = 11;
pub const TCA_CAKE_RAW: _bindgen_ty_157 = 12;
pub const TCA_CAKE_WASH: _bindgen_ty_157 = 13;
pub const TCA_CAKE_MPU: _bindgen_ty_157 = 14;
pub const TCA_CAKE_INGRESS: _bindgen_ty_157 = 15;
pub const TCA_CAKE_ACK_FILTER: _bindgen_ty_157 = 16;
pub const TCA_CAKE_SPLIT_GSO: _bindgen_ty_157 = 17;
pub const TCA_CAKE_FWMARK: _bindgen_ty_157 = 18;
pub const __TCA_CAKE_MAX: _bindgen_ty_157 = 19;
pub type _bindgen_ty_157 = ffi::c_uint;
pub const __TCA_CAKE_STATS_INVALID: _bindgen_ty_158 = 0;
pub const TCA_CAKE_STATS_PAD: _bindgen_ty_158 = 1;
pub const TCA_CAKE_STATS_CAPACITY_ESTIMATE64: _bindgen_ty_158 = 2;
pub const TCA_CAKE_STATS_MEMORY_LIMIT: _bindgen_ty_158 = 3;
pub const TCA_CAKE_STATS_MEMORY_USED: _bindgen_ty_158 = 4;
pub const TCA_CAKE_STATS_AVG_NETOFF: _bindgen_ty_158 = 5;
pub const TCA_CAKE_STATS_MIN_NETLEN: _bindgen_ty_158 = 6;
pub const TCA_CAKE_STATS_MAX_NETLEN: _bindgen_ty_158 = 7;
pub const TCA_CAKE_STATS_MIN_ADJLEN: _bindgen_ty_158 = 8;
pub const TCA_CAKE_STATS_MAX_ADJLEN: _bindgen_ty_158 = 9;
pub const TCA_CAKE_STATS_TIN_STATS: _bindgen_ty_158 = 10;
pub const TCA_CAKE_STATS_DEFICIT: _bindgen_ty_158 = 11;
pub const TCA_CAKE_STATS_COBALT_COUNT: _bindgen_ty_158 = 12;
pub const TCA_CAKE_STATS_DROPPING: _bindgen_ty_158 = 13;
pub const TCA_CAKE_STATS_DROP_NEXT_US: _bindgen_ty_158 = 14;
pub const TCA_CAKE_STATS_P_DROP: _bindgen_ty_158 = 15;
pub const TCA_CAKE_STATS_BLUE_TIMER_US: _bindgen_ty_158 = 16;
pub const __TCA_CAKE_STATS_MAX: _bindgen_ty_158 = 17;
pub type _bindgen_ty_158 = ffi::c_uint;
pub const __TCA_CAKE_TIN_STATS_INVALID: _bindgen_ty_159 = 0;
pub const TCA_CAKE_TIN_STATS_PAD: _bindgen_ty_159 = 1;
pub const TCA_CAKE_TIN_STATS_SENT_PACKETS: _bindgen_ty_159 = 2;
pub const TCA_CAKE_TIN_STATS_SENT_BYTES64: _bindgen_ty_159 = 3;
pub const TCA_CAKE_TIN_STATS_DROPPED_PACKETS: _bindgen_ty_159 = 4;
pub const TCA_CAKE_TIN_STATS_DROPPED_BYTES64: _bindgen_ty_159 = 5;
pub const TCA_CAKE_TIN_STATS_ACKS_DROPPED_PACKETS: _bindgen_ty_159 = 6;
pub const TCA_CAKE_TIN_STATS_ACKS_DROPPED_BYTES64: _bindgen_ty_159 = 7;
pub const TCA_CAKE_TIN_STATS_ECN_MARKED_PACKETS: _bindgen_ty_159 = 8;
pub const TCA_CAKE_TIN_STATS_ECN_MARKED_BYTES64: _bindgen_ty_159 = 9;
pub const TCA_CAKE_TIN_STATS_BACKLOG_PACKETS: _bindgen_ty_159 = 10;
pub const TCA_CAKE_TIN_STATS_BACKLOG_BYTES: _bindgen_ty_159 = 11;
pub const TCA_CAKE_TIN_STATS_THRESHOLD_RATE64: _bindgen_ty_159 = 12;
pub const TCA_CAKE_TIN_STATS_TARGET_US: _bindgen_ty_159 = 13;
pub const TCA_CAKE_TIN_STATS_INTERVAL_US: _bindgen_ty_159 = 14;
pub const TCA_CAKE_TIN_STATS_WAY_INDIRECT_HITS: _bindgen_ty_159 = 15;
pub const TCA_CAKE_TIN_STATS_WAY_MISSES: _bindgen_ty_159 = 16;
pub const TCA_CAKE_TIN_STATS_WAY_COLLISIONS: _bindgen_ty_159 = 17;
pub const TCA_CAKE_TIN_STATS_PEAK_DELAY_US: _bindgen_ty_159 = 18;
pub const TCA_CAKE_TIN_STATS_AVG_DELAY_US: _bindgen_ty_159 = 19;
pub const TCA_CAKE_TIN_STATS_BASE_DELAY_US: _bindgen_ty_159 = 20;
pub const TCA_CAKE_TIN_STATS_SPARSE_FLOWS: _bindgen_ty_159 = 21;
pub const TCA_CAKE_TIN_STATS_BULK_FLOWS: _bindgen_ty_159 = 22;
pub const TCA_CAKE_TIN_STATS_UNRESPONSIVE_FLOWS: _bindgen_ty_159 = 23;
pub const TCA_CAKE_TIN_STATS_MAX_SKBLEN: _bindgen_ty_159 = 24;
pub const TCA_CAKE_TIN_STATS_FLOW_QUANTUM: _bindgen_ty_159 = 25;
pub const __TCA_CAKE_TIN_STATS_MAX: _bindgen_ty_159 = 26;
pub type _bindgen_ty_159 = ffi::c_uint;
pub const CAKE_FLOW_NONE: _bindgen_ty_160 = 0;
pub const CAKE_FLOW_SRC_IP: _bindgen_ty_160 = 1;
pub const CAKE_FLOW_DST_IP: _bindgen_ty_160 = 2;
pub const CAKE_FLOW_HOSTS: _bindgen_ty_160 = 3;
pub const CAKE_FLOW_FLOWS: _bindgen_ty_160 = 4;
pub const CAKE_FLOW_DUAL_SRC: _bindgen_ty_160 = 5;
pub const CAKE_FLOW_DUAL_DST: _bindgen_ty_160 = 6;
pub const CAKE_FLOW_TRIPLE: _bindgen_ty_160 = 7;
pub const CAKE_FLOW_MAX: _bindgen_ty_160 = 8;
pub type _bindgen_ty_160 = ffi::c_uint;
pub const CAKE_DIFFSERV_DIFFSERV3: _bindgen_ty_161 = 0;
pub const CAKE_DIFFSERV_DIFFSERV4: _bindgen_ty_161 = 1;
pub const CAKE_DIFFSERV_DIFFSERV8: _bindgen_ty_161 = 2;
pub const CAKE_DIFFSERV_BESTEFFORT: _bindgen_ty_161 = 3;
pub const CAKE_DIFFSERV_PRECEDENCE: _bindgen_ty_161 = 4;
pub const CAKE_DIFFSERV_MAX: _bindgen_ty_161 = 5;
pub type _bindgen_ty_161 = ffi::c_uint;
pub const CAKE_ACK_NONE: _bindgen_ty_162 = 0;
pub const CAKE_ACK_FILTER: _bindgen_ty_162 = 1;
pub const CAKE_ACK_AGGRESSIVE: _bindgen_ty_162 = 2;
pub const CAKE_ACK_MAX: _bindgen_ty_162 = 3;
pub type _bindgen_ty_162 = ffi::c_uint;
pub const CAKE_ATM_NONE: _bindgen_ty_163 = 0;
pub const CAKE_ATM_ATM: _bindgen_ty_163 = 1;
pub const CAKE_ATM_PTM: _bindgen_ty_163 = 2;
pub const CAKE_ATM_MAX: _bindgen_ty_163 = 3;
pub type _bindgen_ty_163 = ffi::c_uint;
pub const TC_TAPRIO_CMD_SET_GATES: _bindgen_ty_164 = 0;
pub const TC_TAPRIO_CMD_SET_AND_HOLD: _bindgen_ty_164 = 1;
pub const TC_TAPRIO_CMD_SET_AND_RELEASE: _bindgen_ty_164 = 2;
pub type _bindgen_ty_164 = ffi::c_uint;
pub const TCA_TAPRIO_SCHED_ENTRY_UNSPEC: _bindgen_ty_165 = 0;
pub const TCA_TAPRIO_SCHED_ENTRY_INDEX: _bindgen_ty_165 = 1;
pub const TCA_TAPRIO_SCHED_ENTRY_CMD: _bindgen_ty_165 = 2;
pub const TCA_TAPRIO_SCHED_ENTRY_GATE_MASK: _bindgen_ty_165 = 3;
pub const TCA_TAPRIO_SCHED_ENTRY_INTERVAL: _bindgen_ty_165 = 4;
pub const __TCA_TAPRIO_SCHED_ENTRY_MAX: _bindgen_ty_165 = 5;
pub type _bindgen_ty_165 = ffi::c_uint;
pub const TCA_TAPRIO_SCHED_UNSPEC: _bindgen_ty_166 = 0;
pub const TCA_TAPRIO_SCHED_ENTRY: _bindgen_ty_166 = 1;
pub const __TCA_TAPRIO_SCHED_MAX: _bindgen_ty_166 = 2;
pub type _bindgen_ty_166 = ffi::c_uint;
pub const TCA_TAPRIO_TC_ENTRY_UNSPEC: _bindgen_ty_167 = 0;
pub const TCA_TAPRIO_TC_ENTRY_INDEX: _bindgen_ty_167 = 1;
pub const TCA_TAPRIO_TC_ENTRY_MAX_SDU: _bindgen_ty_167 = 2;
pub const TCA_TAPRIO_TC_ENTRY_FP: _bindgen_ty_167 = 3;
pub const __TCA_TAPRIO_TC_ENTRY_CNT: _bindgen_ty_167 = 4;
pub const TCA_TAPRIO_TC_ENTRY_MAX: _bindgen_ty_167 = 3;
pub type _bindgen_ty_167 = ffi::c_uint;
pub const TCA_TAPRIO_OFFLOAD_STATS_PAD: _bindgen_ty_168 = 1;
pub const TCA_TAPRIO_OFFLOAD_STATS_WINDOW_DROPS: _bindgen_ty_168 = 2;
pub const TCA_TAPRIO_OFFLOAD_STATS_TX_OVERRUNS: _bindgen_ty_168 = 3;
pub const __TCA_TAPRIO_OFFLOAD_STATS_CNT: _bindgen_ty_168 = 4;
pub const TCA_TAPRIO_OFFLOAD_STATS_MAX: _bindgen_ty_168 = 3;
pub type _bindgen_ty_168 = ffi::c_uint;
pub const TCA_TAPRIO_ATTR_UNSPEC: _bindgen_ty_169 = 0;
pub const TCA_TAPRIO_ATTR_PRIOMAP: _bindgen_ty_169 = 1;
pub const TCA_TAPRIO_ATTR_SCHED_ENTRY_LIST: _bindgen_ty_169 = 2;
pub const TCA_TAPRIO_ATTR_SCHED_BASE_TIME: _bindgen_ty_169 = 3;
pub const TCA_TAPRIO_ATTR_SCHED_SINGLE_ENTRY: _bindgen_ty_169 = 4;
pub const TCA_TAPRIO_ATTR_SCHED_CLOCKID: _bindgen_ty_169 = 5;
pub const TCA_TAPRIO_PAD: _bindgen_ty_169 = 6;
pub const TCA_TAPRIO_ATTR_ADMIN_SCHED: _bindgen_ty_169 = 7;
pub const TCA_TAPRIO_ATTR_SCHED_CYCLE_TIME: _bindgen_ty_169 = 8;
pub const TCA_TAPRIO_ATTR_SCHED_CYCLE_TIME_EXTENSION: _bindgen_ty_169 = 9;
pub const TCA_TAPRIO_ATTR_FLAGS: _bindgen_ty_169 = 10;
pub const TCA_TAPRIO_ATTR_TXTIME_DELAY: _bindgen_ty_169 = 11;
pub const TCA_TAPRIO_ATTR_TC_ENTRY: _bindgen_ty_169 = 12;
pub const __TCA_TAPRIO_ATTR_MAX: _bindgen_ty_169 = 13;
pub type _bindgen_ty_169 = ffi::c_uint;
pub const TCA_ETS_UNSPEC: _bindgen_ty_170 = 0;
pub const TCA_ETS_NBANDS: _bindgen_ty_170 = 1;
pub const TCA_ETS_NSTRICT: _bindgen_ty_170 = 2;
pub const TCA_ETS_QUANTA: _bindgen_ty_170 = 3;
pub const TCA_ETS_QUANTA_BAND: _bindgen_ty_170 = 4;
pub const TCA_ETS_PRIOMAP: _bindgen_ty_170 = 5;
pub const TCA_ETS_PRIOMAP_BAND: _bindgen_ty_170 = 6;
pub const __TCA_ETS_MAX: _bindgen_ty_170 = 7;
pub type _bindgen_ty_170 = ffi::c_uint;
pub const TCA_ACT_UNSPEC: _bindgen_ty_171 = 0;
pub const TCA_ACT_KIND: _bindgen_ty_171 = 1;
pub const TCA_ACT_OPTIONS: _bindgen_ty_171 = 2;
pub const TCA_ACT_INDEX: _bindgen_ty_171 = 3;
pub const TCA_ACT_STATS: _bindgen_ty_171 = 4;
pub const TCA_ACT_PAD: _bindgen_ty_171 = 5;
pub const TCA_ACT_COOKIE: _bindgen_ty_171 = 6;
pub const TCA_ACT_FLAGS: _bindgen_ty_171 = 7;
pub const TCA_ACT_HW_STATS: _bindgen_ty_171 = 8;
pub const TCA_ACT_USED_HW_STATS: _bindgen_ty_171 = 9;
pub const TCA_ACT_IN_HW_COUNT: _bindgen_ty_171 = 10;
pub const __TCA_ACT_MAX: _bindgen_ty_171 = 11;
pub type _bindgen_ty_171 = ffi::c_uint;
pub const tca_id_TCA_ID_UNSPEC: tca_id = 0;
pub const tca_id_TCA_ID_POLICE: tca_id = 1;
pub const tca_id_TCA_ID_GACT: tca_id = 5;
pub const tca_id_TCA_ID_IPT: tca_id = 6;
pub const tca_id_TCA_ID_PEDIT: tca_id = 7;
pub const tca_id_TCA_ID_MIRRED: tca_id = 8;
pub const tca_id_TCA_ID_NAT: tca_id = 9;
pub const tca_id_TCA_ID_XT: tca_id = 10;
pub const tca_id_TCA_ID_SKBEDIT: tca_id = 11;
pub const tca_id_TCA_ID_VLAN: tca_id = 12;
pub const tca_id_TCA_ID_BPF: tca_id = 13;
pub const tca_id_TCA_ID_CONNMARK: tca_id = 14;
pub const tca_id_TCA_ID_SKBMOD: tca_id = 15;
pub const tca_id_TCA_ID_CSUM: tca_id = 16;
pub const tca_id_TCA_ID_TUNNEL_KEY: tca_id = 17;
pub const tca_id_TCA_ID_SIMP: tca_id = 22;
pub const tca_id_TCA_ID_IFE: tca_id = 25;
pub const tca_id_TCA_ID_SAMPLE: tca_id = 26;
pub const tca_id_TCA_ID_CTINFO: tca_id = 27;
pub const tca_id_TCA_ID_MPLS: tca_id = 28;
pub const tca_id_TCA_ID_CT: tca_id = 29;
pub const tca_id_TCA_ID_GATE: tca_id = 30;
pub const tca_id___TCA_ID_MAX: tca_id = 255;
pub type tca_id = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_police {
    pub index: __u32,
    pub action: ffi::c_int,
    pub limit: __u32,
    pub burst: __u32,
    pub mtu: __u32,
    pub rate: tc_ratespec,
    pub peakrate: tc_ratespec,
    pub refcnt: ffi::c_int,
    pub bindcnt: ffi::c_int,
    pub capab: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tcf_t {
    pub install: __u64,
    pub lastuse: __u64,
    pub expires: __u64,
    pub firstuse: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_cnt {
    pub refcnt: ffi::c_int,
    pub bindcnt: ffi::c_int,
}
pub const TCA_POLICE_UNSPEC: _bindgen_ty_172 = 0;
pub const TCA_POLICE_TBF: _bindgen_ty_172 = 1;
pub const TCA_POLICE_RATE: _bindgen_ty_172 = 2;
pub const TCA_POLICE_PEAKRATE: _bindgen_ty_172 = 3;
pub const TCA_POLICE_AVRATE: _bindgen_ty_172 = 4;
pub const TCA_POLICE_RESULT: _bindgen_ty_172 = 5;
pub const TCA_POLICE_TM: _bindgen_ty_172 = 6;
pub const TCA_POLICE_PAD: _bindgen_ty_172 = 7;
pub const TCA_POLICE_RATE64: _bindgen_ty_172 = 8;
pub const TCA_POLICE_PEAKRATE64: _bindgen_ty_172 = 9;
pub const TCA_POLICE_PKTRATE64: _bindgen_ty_172 = 10;
pub const TCA_POLICE_PKTBURST64: _bindgen_ty_172 = 11;
pub const __TCA_POLICE_MAX: _bindgen_ty_172 = 12;
pub type _bindgen_ty_172 = ffi::c_uint;
pub const TCA_U32_UNSPEC: _bindgen_ty_173 = 0;
pub const TCA_U32_CLASSID: _bindgen_ty_173 = 1;
pub const TCA_U32_HASH: _bindgen_ty_173 = 2;
pub const TCA_U32_LINK: _bindgen_ty_173 = 3;
pub const TCA_U32_DIVISOR: _bindgen_ty_173 = 4;
pub const TCA_U32_SEL: _bindgen_ty_173 = 5;
pub const TCA_U32_POLICE: _bindgen_ty_173 = 6;
pub const TCA_U32_ACT: _bindgen_ty_173 = 7;
pub const TCA_U32_INDEV: _bindgen_ty_173 = 8;
pub const TCA_U32_PCNT: _bindgen_ty_173 = 9;
pub const TCA_U32_MARK: _bindgen_ty_173 = 10;
pub const TCA_U32_FLAGS: _bindgen_ty_173 = 11;
pub const TCA_U32_PAD: _bindgen_ty_173 = 12;
pub const __TCA_U32_MAX: _bindgen_ty_173 = 13;
pub type _bindgen_ty_173 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_u32_key {
    pub mask: __be32,
    pub val: __be32,
    pub off: ffi::c_int,
    pub offmask: ffi::c_int,
}
#[repr(C)]
pub struct tc_u32_sel {
    pub __bindgen_anon_1: tc_u32_sel__bindgen_ty_1,
    pub keys: __IncompleteArrayField<tc_u32_key>,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tc_u32_sel__bindgen_ty_1 {
    pub __bindgen_anon_1: tc_u32_sel__bindgen_ty_1__bindgen_ty_1,
    pub hdr: tc_u32_sel__bindgen_ty_1_tc_u32_sel_hdr,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_u32_sel__bindgen_ty_1__bindgen_ty_1 {
    pub flags: ffi::c_uchar,
    pub offshift: ffi::c_uchar,
    pub nkeys: ffi::c_uchar,
    pub offmask: __be16,
    pub off: __u16,
    pub offoff: ffi::c_short,
    pub hoff: ffi::c_short,
    pub hmask: __be32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_u32_sel__bindgen_ty_1_tc_u32_sel_hdr {
    pub flags: ffi::c_uchar,
    pub offshift: ffi::c_uchar,
    pub nkeys: ffi::c_uchar,
    pub offmask: __be16,
    pub off: __u16,
    pub offoff: ffi::c_short,
    pub hoff: ffi::c_short,
    pub hmask: __be32,
}
impl Default for tc_u32_sel__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for tc_u32_sel {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_u32_mark {
    pub val: __u32,
    pub mask: __u32,
    pub success: __u32,
}
#[repr(C)]
#[derive(Default)]
pub struct tc_u32_pcnt {
    pub rcnt: __u64,
    pub rhit: __u64,
    pub kcnts: __IncompleteArrayField<__u64>,
}
pub const TCA_ROUTE4_UNSPEC: _bindgen_ty_174 = 0;
pub const TCA_ROUTE4_CLASSID: _bindgen_ty_174 = 1;
pub const TCA_ROUTE4_TO: _bindgen_ty_174 = 2;
pub const TCA_ROUTE4_FROM: _bindgen_ty_174 = 3;
pub const TCA_ROUTE4_IIF: _bindgen_ty_174 = 4;
pub const TCA_ROUTE4_POLICE: _bindgen_ty_174 = 5;
pub const TCA_ROUTE4_ACT: _bindgen_ty_174 = 6;
pub const __TCA_ROUTE4_MAX: _bindgen_ty_174 = 7;
pub type _bindgen_ty_174 = ffi::c_uint;
pub const TCA_FW_UNSPEC: _bindgen_ty_175 = 0;
pub const TCA_FW_CLASSID: _bindgen_ty_175 = 1;
pub const TCA_FW_POLICE: _bindgen_ty_175 = 2;
pub const TCA_FW_INDEV: _bindgen_ty_175 = 3;
pub const TCA_FW_ACT: _bindgen_ty_175 = 4;
pub const TCA_FW_MASK: _bindgen_ty_175 = 5;
pub const __TCA_FW_MAX: _bindgen_ty_175 = 6;
pub type _bindgen_ty_175 = ffi::c_uint;
pub const FLOW_KEY_SRC: _bindgen_ty_176 = 0;
pub const FLOW_KEY_DST: _bindgen_ty_176 = 1;
pub const FLOW_KEY_PROTO: _bindgen_ty_176 = 2;
pub const FLOW_KEY_PROTO_SRC: _bindgen_ty_176 = 3;
pub const FLOW_KEY_PROTO_DST: _bindgen_ty_176 = 4;
pub const FLOW_KEY_IIF: _bindgen_ty_176 = 5;
pub const FLOW_KEY_PRIORITY: _bindgen_ty_176 = 6;
pub const FLOW_KEY_MARK: _bindgen_ty_176 = 7;
pub const FLOW_KEY_NFCT: _bindgen_ty_176 = 8;
pub const FLOW_KEY_NFCT_SRC: _bindgen_ty_176 = 9;
pub const FLOW_KEY_NFCT_DST: _bindgen_ty_176 = 10;
pub const FLOW_KEY_NFCT_PROTO_SRC: _bindgen_ty_176 = 11;
pub const FLOW_KEY_NFCT_PROTO_DST: _bindgen_ty_176 = 12;
pub const FLOW_KEY_RTCLASSID: _bindgen_ty_176 = 13;
pub const FLOW_KEY_SKUID: _bindgen_ty_176 = 14;
pub const FLOW_KEY_SKGID: _bindgen_ty_176 = 15;
pub const FLOW_KEY_VLAN_TAG: _bindgen_ty_176 = 16;
pub const FLOW_KEY_RXHASH: _bindgen_ty_176 = 17;
pub const __FLOW_KEY_MAX: _bindgen_ty_176 = 18;
pub type _bindgen_ty_176 = ffi::c_uint;
pub const FLOW_MODE_MAP: _bindgen_ty_177 = 0;
pub const FLOW_MODE_HASH: _bindgen_ty_177 = 1;
pub type _bindgen_ty_177 = ffi::c_uint;
pub const TCA_FLOW_UNSPEC: _bindgen_ty_178 = 0;
pub const TCA_FLOW_KEYS: _bindgen_ty_178 = 1;
pub const TCA_FLOW_MODE: _bindgen_ty_178 = 2;
pub const TCA_FLOW_BASECLASS: _bindgen_ty_178 = 3;
pub const TCA_FLOW_RSHIFT: _bindgen_ty_178 = 4;
pub const TCA_FLOW_ADDEND: _bindgen_ty_178 = 5;
pub const TCA_FLOW_MASK: _bindgen_ty_178 = 6;
pub const TCA_FLOW_XOR: _bindgen_ty_178 = 7;
pub const TCA_FLOW_DIVISOR: _bindgen_ty_178 = 8;
pub const TCA_FLOW_ACT: _bindgen_ty_178 = 9;
pub const TCA_FLOW_POLICE: _bindgen_ty_178 = 10;
pub const TCA_FLOW_EMATCHES: _bindgen_ty_178 = 11;
pub const TCA_FLOW_PERTURB: _bindgen_ty_178 = 12;
pub const __TCA_FLOW_MAX: _bindgen_ty_178 = 13;
pub type _bindgen_ty_178 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_basic_pcnt {
    pub rcnt: __u64,
    pub rhit: __u64,
}
pub const TCA_BASIC_UNSPEC: _bindgen_ty_179 = 0;
pub const TCA_BASIC_CLASSID: _bindgen_ty_179 = 1;
pub const TCA_BASIC_EMATCHES: _bindgen_ty_179 = 2;
pub const TCA_BASIC_ACT: _bindgen_ty_179 = 3;
pub const TCA_BASIC_POLICE: _bindgen_ty_179 = 4;
pub const TCA_BASIC_PCNT: _bindgen_ty_179 = 5;
pub const TCA_BASIC_PAD: _bindgen_ty_179 = 6;
pub const __TCA_BASIC_MAX: _bindgen_ty_179 = 7;
pub type _bindgen_ty_179 = ffi::c_uint;
pub const TCA_CGROUP_UNSPEC: _bindgen_ty_180 = 0;
pub const TCA_CGROUP_ACT: _bindgen_ty_180 = 1;
pub const TCA_CGROUP_POLICE: _bindgen_ty_180 = 2;
pub const TCA_CGROUP_EMATCHES: _bindgen_ty_180 = 3;
pub const __TCA_CGROUP_MAX: _bindgen_ty_180 = 4;
pub type _bindgen_ty_180 = ffi::c_uint;
pub const TCA_BPF_UNSPEC: _bindgen_ty_181 = 0;
pub const TCA_BPF_ACT: _bindgen_ty_181 = 1;
pub const TCA_BPF_POLICE: _bindgen_ty_181 = 2;
pub const TCA_BPF_CLASSID: _bindgen_ty_181 = 3;
pub const TCA_BPF_OPS_LEN: _bindgen_ty_181 = 4;
pub const TCA_BPF_OPS: _bindgen_ty_181 = 5;
pub const TCA_BPF_FD: _bindgen_ty_181 = 6;
pub const TCA_BPF_NAME: _bindgen_ty_181 = 7;
pub const TCA_BPF_FLAGS: _bindgen_ty_181 = 8;
pub const TCA_BPF_FLAGS_GEN: _bindgen_ty_181 = 9;
pub const TCA_BPF_TAG: _bindgen_ty_181 = 10;
pub const TCA_BPF_ID: _bindgen_ty_181 = 11;
pub const __TCA_BPF_MAX: _bindgen_ty_181 = 12;
pub type _bindgen_ty_181 = ffi::c_uint;
pub const TCA_FLOWER_UNSPEC: _bindgen_ty_182 = 0;
pub const TCA_FLOWER_CLASSID: _bindgen_ty_182 = 1;
pub const TCA_FLOWER_INDEV: _bindgen_ty_182 = 2;
pub const TCA_FLOWER_ACT: _bindgen_ty_182 = 3;
pub const TCA_FLOWER_KEY_ETH_DST: _bindgen_ty_182 = 4;
pub const TCA_FLOWER_KEY_ETH_DST_MASK: _bindgen_ty_182 = 5;
pub const TCA_FLOWER_KEY_ETH_SRC: _bindgen_ty_182 = 6;
pub const TCA_FLOWER_KEY_ETH_SRC_MASK: _bindgen_ty_182 = 7;
pub const TCA_FLOWER_KEY_ETH_TYPE: _bindgen_ty_182 = 8;
pub const TCA_FLOWER_KEY_IP_PROTO: _bindgen_ty_182 = 9;
pub const TCA_FLOWER_KEY_IPV4_SRC: _bindgen_ty_182 = 10;
pub const TCA_FLOWER_KEY_IPV4_SRC_MASK: _bindgen_ty_182 = 11;
pub const TCA_FLOWER_KEY_IPV4_DST: _bindgen_ty_182 = 12;
pub const TCA_FLOWER_KEY_IPV4_DST_MASK: _bindgen_ty_182 = 13;
pub const TCA_FLOWER_KEY_IPV6_SRC: _bindgen_ty_182 = 14;
pub const TCA_FLOWER_KEY_IPV6_SRC_MASK: _bindgen_ty_182 = 15;
pub const TCA_FLOWER_KEY_IPV6_DST: _bindgen_ty_182 = 16;
pub const TCA_FLOWER_KEY_IPV6_DST_MASK: _bindgen_ty_182 = 17;
pub const TCA_FLOWER_KEY_TCP_SRC: _bindgen_ty_182 = 18;
pub const TCA_FLOWER_KEY_TCP_DST: _bindgen_ty_182 = 19;
pub const TCA_FLOWER_KEY_UDP_SRC: _bindgen_ty_182 = 20;
pub const TCA_FLOWER_KEY_UDP_DST: _bindgen_ty_182 = 21;
pub const TCA_FLOWER_FLAGS: _bindgen_ty_182 = 22;
pub const TCA_FLOWER_KEY_VLAN_ID: _bindgen_ty_182 = 23;
pub const TCA_FLOWER_KEY_VLAN_PRIO: _bindgen_ty_182 = 24;
pub const TCA_FLOWER_KEY_VLAN_ETH_TYPE: _bindgen_ty_182 = 25;
pub const TCA_FLOWER_KEY_ENC_KEY_ID: _bindgen_ty_182 = 26;
pub const TCA_FLOWER_KEY_ENC_IPV4_SRC: _bindgen_ty_182 = 27;
pub const TCA_FLOWER_KEY_ENC_IPV4_SRC_MASK: _bindgen_ty_182 = 28;
pub const TCA_FLOWER_KEY_ENC_IPV4_DST: _bindgen_ty_182 = 29;
pub const TCA_FLOWER_KEY_ENC_IPV4_DST_MASK: _bindgen_ty_182 = 30;
pub const TCA_FLOWER_KEY_ENC_IPV6_SRC: _bindgen_ty_182 = 31;
pub const TCA_FLOWER_KEY_ENC_IPV6_SRC_MASK: _bindgen_ty_182 = 32;
pub const TCA_FLOWER_KEY_ENC_IPV6_DST: _bindgen_ty_182 = 33;
pub const TCA_FLOWER_KEY_ENC_IPV6_DST_MASK: _bindgen_ty_182 = 34;
pub const TCA_FLOWER_KEY_TCP_SRC_MASK: _bindgen_ty_182 = 35;
pub const TCA_FLOWER_KEY_TCP_DST_MASK: _bindgen_ty_182 = 36;
pub const TCA_FLOWER_KEY_UDP_SRC_MASK: _bindgen_ty_182 = 37;
pub const TCA_FLOWER_KEY_UDP_DST_MASK: _bindgen_ty_182 = 38;
pub const TCA_FLOWER_KEY_SCTP_SRC_MASK: _bindgen_ty_182 = 39;
pub const TCA_FLOWER_KEY_SCTP_DST_MASK: _bindgen_ty_182 = 40;
pub const TCA_FLOWER_KEY_SCTP_SRC: _bindgen_ty_182 = 41;
pub const TCA_FLOWER_KEY_SCTP_DST: _bindgen_ty_182 = 42;
pub const TCA_FLOWER_KEY_ENC_UDP_SRC_PORT: _bindgen_ty_182 = 43;
pub const TCA_FLOWER_KEY_ENC_UDP_SRC_PORT_MASK: _bindgen_ty_182 = 44;
pub const TCA_FLOWER_KEY_ENC_UDP_DST_PORT: _bindgen_ty_182 = 45;
pub const TCA_FLOWER_KEY_ENC_UDP_DST_PORT_MASK: _bindgen_ty_182 = 46;
pub const TCA_FLOWER_KEY_FLAGS: _bindgen_ty_182 = 47;
pub const TCA_FLOWER_KEY_FLAGS_MASK: _bindgen_ty_182 = 48;
pub const TCA_FLOWER_KEY_ICMPV4_CODE: _bindgen_ty_182 = 49;
pub const TCA_FLOWER_KEY_ICMPV4_CODE_MASK: _bindgen_ty_182 = 50;
pub const TCA_FLOWER_KEY_ICMPV4_TYPE: _bindgen_ty_182 = 51;
pub const TCA_FLOWER_KEY_ICMPV4_TYPE_MASK: _bindgen_ty_182 = 52;
pub const TCA_FLOWER_KEY_ICMPV6_CODE: _bindgen_ty_182 = 53;
pub const TCA_FLOWER_KEY_ICMPV6_CODE_MASK: _bindgen_ty_182 = 54;
pub const TCA_FLOWER_KEY_ICMPV6_TYPE: _bindgen_ty_182 = 55;
pub const TCA_FLOWER_KEY_ICMPV6_TYPE_MASK: _bindgen_ty_182 = 56;
pub const TCA_FLOWER_KEY_ARP_SIP: _bindgen_ty_182 = 57;
pub const TCA_FLOWER_KEY_ARP_SIP_MASK: _bindgen_ty_182 = 58;
pub const TCA_FLOWER_KEY_ARP_TIP: _bindgen_ty_182 = 59;
pub const TCA_FLOWER_KEY_ARP_TIP_MASK: _bindgen_ty_182 = 60;
pub const TCA_FLOWER_KEY_ARP_OP: _bindgen_ty_182 = 61;
pub const TCA_FLOWER_KEY_ARP_OP_MASK: _bindgen_ty_182 = 62;
pub const TCA_FLOWER_KEY_ARP_SHA: _bindgen_ty_182 = 63;
pub const TCA_FLOWER_KEY_ARP_SHA_MASK: _bindgen_ty_182 = 64;
pub const TCA_FLOWER_KEY_ARP_THA: _bindgen_ty_182 = 65;
pub const TCA_FLOWER_KEY_ARP_THA_MASK: _bindgen_ty_182 = 66;
pub const TCA_FLOWER_KEY_MPLS_TTL: _bindgen_ty_182 = 67;
pub const TCA_FLOWER_KEY_MPLS_BOS: _bindgen_ty_182 = 68;
pub const TCA_FLOWER_KEY_MPLS_TC: _bindgen_ty_182 = 69;
pub const TCA_FLOWER_KEY_MPLS_LABEL: _bindgen_ty_182 = 70;
pub const TCA_FLOWER_KEY_TCP_FLAGS: _bindgen_ty_182 = 71;
pub const TCA_FLOWER_KEY_TCP_FLAGS_MASK: _bindgen_ty_182 = 72;
pub const TCA_FLOWER_KEY_IP_TOS: _bindgen_ty_182 = 73;
pub const TCA_FLOWER_KEY_IP_TOS_MASK: _bindgen_ty_182 = 74;
pub const TCA_FLOWER_KEY_IP_TTL: _bindgen_ty_182 = 75;
pub const TCA_FLOWER_KEY_IP_TTL_MASK: _bindgen_ty_182 = 76;
pub const TCA_FLOWER_KEY_CVLAN_ID: _bindgen_ty_182 = 77;
pub const TCA_FLOWER_KEY_CVLAN_PRIO: _bindgen_ty_182 = 78;
pub const TCA_FLOWER_KEY_CVLAN_ETH_TYPE: _bindgen_ty_182 = 79;
pub const TCA_FLOWER_KEY_ENC_IP_TOS: _bindgen_ty_182 = 80;
pub const TCA_FLOWER_KEY_ENC_IP_TOS_MASK: _bindgen_ty_182 = 81;
pub const TCA_FLOWER_KEY_ENC_IP_TTL: _bindgen_ty_182 = 82;
pub const TCA_FLOWER_KEY_ENC_IP_TTL_MASK: _bindgen_ty_182 = 83;
pub const TCA_FLOWER_KEY_ENC_OPTS: _bindgen_ty_182 = 84;
pub const TCA_FLOWER_KEY_ENC_OPTS_MASK: _bindgen_ty_182 = 85;
pub const TCA_FLOWER_IN_HW_COUNT: _bindgen_ty_182 = 86;
pub const TCA_FLOWER_KEY_PORT_SRC_MIN: _bindgen_ty_182 = 87;
pub const TCA_FLOWER_KEY_PORT_SRC_MAX: _bindgen_ty_182 = 88;
pub const TCA_FLOWER_KEY_PORT_DST_MIN: _bindgen_ty_182 = 89;
pub const TCA_FLOWER_KEY_PORT_DST_MAX: _bindgen_ty_182 = 90;
pub const TCA_FLOWER_KEY_CT_STATE: _bindgen_ty_182 = 91;
pub const TCA_FLOWER_KEY_CT_STATE_MASK: _bindgen_ty_182 = 92;
pub const TCA_FLOWER_KEY_CT_ZONE: _bindgen_ty_182 = 93;
pub const TCA_FLOWER_KEY_CT_ZONE_MASK: _bindgen_ty_182 = 94;
pub const TCA_FLOWER_KEY_CT_MARK: _bindgen_ty_182 = 95;
pub const TCA_FLOWER_KEY_CT_MARK_MASK: _bindgen_ty_182 = 96;
pub const TCA_FLOWER_KEY_CT_LABELS: _bindgen_ty_182 = 97;
pub const TCA_FLOWER_KEY_CT_LABELS_MASK: _bindgen_ty_182 = 98;
pub const TCA_FLOWER_KEY_MPLS_OPTS: _bindgen_ty_182 = 99;
pub const TCA_FLOWER_KEY_HASH: _bindgen_ty_182 = 100;
pub const TCA_FLOWER_KEY_HASH_MASK: _bindgen_ty_182 = 101;
pub const TCA_FLOWER_KEY_NUM_OF_VLANS: _bindgen_ty_182 = 102;
pub const TCA_FLOWER_KEY_PPPOE_SID: _bindgen_ty_182 = 103;
pub const TCA_FLOWER_KEY_PPP_PROTO: _bindgen_ty_182 = 104;
pub const TCA_FLOWER_KEY_L2TPV3_SID: _bindgen_ty_182 = 105;
pub const TCA_FLOWER_L2_MISS: _bindgen_ty_182 = 106;
pub const TCA_FLOWER_KEY_CFM: _bindgen_ty_182 = 107;
pub const TCA_FLOWER_KEY_SPI: _bindgen_ty_182 = 108;
pub const TCA_FLOWER_KEY_SPI_MASK: _bindgen_ty_182 = 109;
pub const TCA_FLOWER_KEY_ENC_FLAGS: _bindgen_ty_182 = 110;
pub const TCA_FLOWER_KEY_ENC_FLAGS_MASK: _bindgen_ty_182 = 111;
pub const __TCA_FLOWER_MAX: _bindgen_ty_182 = 112;
pub type _bindgen_ty_182 = ffi::c_uint;
pub const TCA_FLOWER_KEY_CT_FLAGS_NEW: _bindgen_ty_183 = 1;
pub const TCA_FLOWER_KEY_CT_FLAGS_ESTABLISHED: _bindgen_ty_183 = 2;
pub const TCA_FLOWER_KEY_CT_FLAGS_RELATED: _bindgen_ty_183 = 4;
pub const TCA_FLOWER_KEY_CT_FLAGS_TRACKED: _bindgen_ty_183 = 8;
pub const TCA_FLOWER_KEY_CT_FLAGS_INVALID: _bindgen_ty_183 = 16;
pub const TCA_FLOWER_KEY_CT_FLAGS_REPLY: _bindgen_ty_183 = 32;
pub const __TCA_FLOWER_KEY_CT_FLAGS_MAX: _bindgen_ty_183 = 33;
pub type _bindgen_ty_183 = ffi::c_uint;
pub const TCA_FLOWER_KEY_ENC_OPTS_UNSPEC: _bindgen_ty_184 = 0;
pub const TCA_FLOWER_KEY_ENC_OPTS_GENEVE: _bindgen_ty_184 = 1;
pub const TCA_FLOWER_KEY_ENC_OPTS_VXLAN: _bindgen_ty_184 = 2;
pub const TCA_FLOWER_KEY_ENC_OPTS_ERSPAN: _bindgen_ty_184 = 3;
pub const TCA_FLOWER_KEY_ENC_OPTS_GTP: _bindgen_ty_184 = 4;
pub const TCA_FLOWER_KEY_ENC_OPTS_PFCP: _bindgen_ty_184 = 5;
pub const __TCA_FLOWER_KEY_ENC_OPTS_MAX: _bindgen_ty_184 = 6;
pub type _bindgen_ty_184 = ffi::c_uint;
pub const TCA_FLOWER_KEY_ENC_OPT_GENEVE_UNSPEC: _bindgen_ty_185 = 0;
pub const TCA_FLOWER_KEY_ENC_OPT_GENEVE_CLASS: _bindgen_ty_185 = 1;
pub const TCA_FLOWER_KEY_ENC_OPT_GENEVE_TYPE: _bindgen_ty_185 = 2;
pub const TCA_FLOWER_KEY_ENC_OPT_GENEVE_DATA: _bindgen_ty_185 = 3;
pub const __TCA_FLOWER_KEY_ENC_OPT_GENEVE_MAX: _bindgen_ty_185 = 4;
pub type _bindgen_ty_185 = ffi::c_uint;
pub const TCA_FLOWER_KEY_ENC_OPT_VXLAN_UNSPEC: _bindgen_ty_186 = 0;
pub const TCA_FLOWER_KEY_ENC_OPT_VXLAN_GBP: _bindgen_ty_186 = 1;
pub const __TCA_FLOWER_KEY_ENC_OPT_VXLAN_MAX: _bindgen_ty_186 = 2;
pub type _bindgen_ty_186 = ffi::c_uint;
pub const TCA_FLOWER_KEY_ENC_OPT_ERSPAN_UNSPEC: _bindgen_ty_187 = 0;
pub const TCA_FLOWER_KEY_ENC_OPT_ERSPAN_VER: _bindgen_ty_187 = 1;
pub const TCA_FLOWER_KEY_ENC_OPT_ERSPAN_INDEX: _bindgen_ty_187 = 2;
pub const TCA_FLOWER_KEY_ENC_OPT_ERSPAN_DIR: _bindgen_ty_187 = 3;
pub const TCA_FLOWER_KEY_ENC_OPT_ERSPAN_HWID: _bindgen_ty_187 = 4;
pub const __TCA_FLOWER_KEY_ENC_OPT_ERSPAN_MAX: _bindgen_ty_187 = 5;
pub type _bindgen_ty_187 = ffi::c_uint;
pub const TCA_FLOWER_KEY_ENC_OPT_GTP_UNSPEC: _bindgen_ty_188 = 0;
pub const TCA_FLOWER_KEY_ENC_OPT_GTP_PDU_TYPE: _bindgen_ty_188 = 1;
pub const TCA_FLOWER_KEY_ENC_OPT_GTP_QFI: _bindgen_ty_188 = 2;
pub const __TCA_FLOWER_KEY_ENC_OPT_GTP_MAX: _bindgen_ty_188 = 3;
pub type _bindgen_ty_188 = ffi::c_uint;
pub const TCA_FLOWER_KEY_ENC_OPT_PFCP_UNSPEC: _bindgen_ty_189 = 0;
pub const TCA_FLOWER_KEY_ENC_OPT_PFCP_TYPE: _bindgen_ty_189 = 1;
pub const TCA_FLOWER_KEY_ENC_OPT_PFCP_SEID: _bindgen_ty_189 = 2;
pub const __TCA_FLOWER_KEY_ENC_OPT_PFCP_MAX: _bindgen_ty_189 = 3;
pub type _bindgen_ty_189 = ffi::c_uint;
pub const TCA_FLOWER_KEY_MPLS_OPTS_UNSPEC: _bindgen_ty_190 = 0;
pub const TCA_FLOWER_KEY_MPLS_OPTS_LSE: _bindgen_ty_190 = 1;
pub const __TCA_FLOWER_KEY_MPLS_OPTS_MAX: _bindgen_ty_190 = 2;
pub type _bindgen_ty_190 = ffi::c_uint;
pub const TCA_FLOWER_KEY_MPLS_OPT_LSE_UNSPEC: _bindgen_ty_191 = 0;
pub const TCA_FLOWER_KEY_MPLS_OPT_LSE_DEPTH: _bindgen_ty_191 = 1;
pub const TCA_FLOWER_KEY_MPLS_OPT_LSE_TTL: _bindgen_ty_191 = 2;
pub const TCA_FLOWER_KEY_MPLS_OPT_LSE_BOS: _bindgen_ty_191 = 3;
pub const TCA_FLOWER_KEY_MPLS_OPT_LSE_TC: _bindgen_ty_191 = 4;
pub const TCA_FLOWER_KEY_MPLS_OPT_LSE_LABEL: _bindgen_ty_191 = 5;
pub const __TCA_FLOWER_KEY_MPLS_OPT_LSE_MAX: _bindgen_ty_191 = 6;
pub type _bindgen_ty_191 = ffi::c_uint;
pub const TCA_FLOWER_KEY_FLAGS_IS_FRAGMENT: _bindgen_ty_192 = 1;
pub const TCA_FLOWER_KEY_FLAGS_FRAG_IS_FIRST: _bindgen_ty_192 = 2;
pub const TCA_FLOWER_KEY_FLAGS_TUNNEL_CSUM: _bindgen_ty_192 = 4;
pub const TCA_FLOWER_KEY_FLAGS_TUNNEL_DONT_FRAGMENT: _bindgen_ty_192 = 8;
pub const TCA_FLOWER_KEY_FLAGS_TUNNEL_OAM: _bindgen_ty_192 = 16;
pub const TCA_FLOWER_KEY_FLAGS_TUNNEL_CRIT_OPT: _bindgen_ty_192 = 32;
pub const __TCA_FLOWER_KEY_FLAGS_MAX: _bindgen_ty_192 = 33;
pub type _bindgen_ty_192 = ffi::c_uint;
pub const TCA_FLOWER_KEY_CFM_OPT_UNSPEC: _bindgen_ty_193 = 0;
pub const TCA_FLOWER_KEY_CFM_MD_LEVEL: _bindgen_ty_193 = 1;
pub const TCA_FLOWER_KEY_CFM_OPCODE: _bindgen_ty_193 = 2;
pub const __TCA_FLOWER_KEY_CFM_OPT_MAX: _bindgen_ty_193 = 3;
pub type _bindgen_ty_193 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tc_matchall_pcnt {
    pub rhit: __u64,
}
pub const TCA_MATCHALL_UNSPEC: _bindgen_ty_194 = 0;
pub const TCA_MATCHALL_CLASSID: _bindgen_ty_194 = 1;
pub const TCA_MATCHALL_ACT: _bindgen_ty_194 = 2;
pub const TCA_MATCHALL_FLAGS: _bindgen_ty_194 = 3;
pub const TCA_MATCHALL_PCNT: _bindgen_ty_194 = 4;
pub const TCA_MATCHALL_PAD: _bindgen_ty_194 = 5;
pub const __TCA_MATCHALL_MAX: _bindgen_ty_194 = 6;
pub type _bindgen_ty_194 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tcf_ematch_tree_hdr {
    pub nmatches: __u16,
    pub progid: __u16,
}
pub const TCA_EMATCH_TREE_UNSPEC: _bindgen_ty_195 = 0;
pub const TCA_EMATCH_TREE_HDR: _bindgen_ty_195 = 1;
pub const TCA_EMATCH_TREE_LIST: _bindgen_ty_195 = 2;
pub const __TCA_EMATCH_TREE_MAX: _bindgen_ty_195 = 3;
pub type _bindgen_ty_195 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tcf_ematch_hdr {
    pub matchid: __u16,
    pub kind: __u16,
    pub flags: __u16,
    pub pad: __u16,
}
pub const TCF_LAYER_LINK: _bindgen_ty_196 = 0;
pub const TCF_LAYER_NETWORK: _bindgen_ty_196 = 1;
pub const TCF_LAYER_TRANSPORT: _bindgen_ty_196 = 2;
pub const __TCF_LAYER_MAX: _bindgen_ty_196 = 3;
pub type _bindgen_ty_196 = ffi::c_uint;
pub const TCF_EM_PROG_TC: _bindgen_ty_197 = 0;
pub type _bindgen_ty_197 = ffi::c_uint;
pub const TCF_EM_OPND_EQ: _bindgen_ty_198 = 0;
pub const TCF_EM_OPND_GT: _bindgen_ty_198 = 1;
pub const TCF_EM_OPND_LT: _bindgen_ty_198 = 2;
pub type _bindgen_ty_198 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_control {
    pub thoff: u16_,
    pub addr_type: u16_,
    pub flags: u32_,
}
pub const flow_dissector_ctrl_flags_FLOW_DIS_IS_FRAGMENT: flow_dissector_ctrl_flags = 1;
pub const flow_dissector_ctrl_flags_FLOW_DIS_FIRST_FRAG: flow_dissector_ctrl_flags = 2;
pub const flow_dissector_ctrl_flags_FLOW_DIS_F_TUNNEL_CSUM: flow_dissector_ctrl_flags = 4;
pub const flow_dissector_ctrl_flags_FLOW_DIS_F_TUNNEL_DONT_FRAGMENT: flow_dissector_ctrl_flags = 8;
pub const flow_dissector_ctrl_flags_FLOW_DIS_F_TUNNEL_OAM: flow_dissector_ctrl_flags = 16;
pub const flow_dissector_ctrl_flags_FLOW_DIS_F_TUNNEL_CRIT_OPT: flow_dissector_ctrl_flags = 32;
pub const flow_dissector_ctrl_flags_FLOW_DIS_ENCAPSULATION: flow_dissector_ctrl_flags = 64;
pub type flow_dissector_ctrl_flags = ffi::c_uint;
pub const flow_dissect_ret_FLOW_DISSECT_RET_OUT_GOOD: flow_dissect_ret = 0;
pub const flow_dissect_ret_FLOW_DISSECT_RET_OUT_BAD: flow_dissect_ret = 1;
pub const flow_dissect_ret_FLOW_DISSECT_RET_PROTO_AGAIN: flow_dissect_ret = 2;
pub const flow_dissect_ret_FLOW_DISSECT_RET_IPPROTO_AGAIN: flow_dissect_ret = 3;
pub const flow_dissect_ret_FLOW_DISSECT_RET_CONTINUE: flow_dissect_ret = 4;
pub type flow_dissect_ret = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_basic {
    pub n_proto: __be16,
    pub ip_proto: u8_,
    pub padding: u8_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_tags {
    pub flow_label: u32_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct flow_dissector_key_vlan {
    pub __bindgen_anon_1: flow_dissector_key_vlan__bindgen_ty_1,
    pub vlan_tpid: __be16,
    pub vlan_eth_type: __be16,
    pub padding: u16_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union flow_dissector_key_vlan__bindgen_ty_1 {
    pub __bindgen_anon_1: flow_dissector_key_vlan__bindgen_ty_1__bindgen_ty_1,
    pub vlan_tci: __be16,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_vlan__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u16; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
}
impl flow_dissector_key_vlan__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn vlan_id(&self) -> u16_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 12u8) as u16) }
    }
    #[inline]
    pub fn set_vlan_id(&mut self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 12u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn vlan_id_raw(this: *const Self) -> u16_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                12u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_vlan_id_raw(this: *mut Self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                12u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn vlan_dei(&self) -> u16_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(12usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_vlan_dei(&mut self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            self._bitfield_1.set(12usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn vlan_dei_raw(this: *const Self) -> u16_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                12usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_vlan_dei_raw(this: *mut Self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                12usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn vlan_priority(&self) -> u16_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(13usize, 3u8) as u16) }
    }
    #[inline]
    pub fn set_vlan_priority(&mut self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            self._bitfield_1.set(13usize, 3u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn vlan_priority_raw(this: *const Self) -> u16_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                13usize,
                3u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_vlan_priority_raw(this: *mut Self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                13usize,
                3u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        vlan_id: u16_,
        vlan_dei: u16_,
        vlan_priority: u16_,
    ) -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 12u8, {
            let vlan_id: u16 = unsafe { ::core::mem::transmute(vlan_id) };
            vlan_id as u64
        });
        __bindgen_bitfield_unit.set(12usize, 1u8, {
            let vlan_dei: u16 = unsafe { ::core::mem::transmute(vlan_dei) };
            vlan_dei as u64
        });
        __bindgen_bitfield_unit.set(13usize, 3u8, {
            let vlan_priority: u16 = unsafe { ::core::mem::transmute(vlan_priority) };
            vlan_priority as u64
        });
        __bindgen_bitfield_unit
    }
}
impl Default for flow_dissector_key_vlan__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for flow_dissector_key_vlan {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_mpls_lse {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
impl flow_dissector_mpls_lse {
    #[inline]
    pub fn mpls_ttl(&self) -> u32_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 8u8) as u32) }
    }
    #[inline]
    pub fn set_mpls_ttl(&mut self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 8u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn mpls_ttl_raw(this: *const Self) -> u32_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                8u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_mpls_ttl_raw(this: *mut Self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                8u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn mpls_bos(&self) -> u32_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(8usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_mpls_bos(&mut self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(8usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn mpls_bos_raw(this: *const Self) -> u32_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                8usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_mpls_bos_raw(this: *mut Self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                8usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn mpls_tc(&self) -> u32_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(9usize, 3u8) as u32) }
    }
    #[inline]
    pub fn set_mpls_tc(&mut self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(9usize, 3u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn mpls_tc_raw(this: *const Self) -> u32_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                9usize,
                3u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_mpls_tc_raw(this: *mut Self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                9usize,
                3u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn mpls_label(&self) -> u32_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(12usize, 20u8) as u32) }
    }
    #[inline]
    pub fn set_mpls_label(&mut self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(12usize, 20u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn mpls_label_raw(this: *const Self) -> u32_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                12usize,
                20u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_mpls_label_raw(this: *mut Self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                12usize,
                20u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        mpls_ttl: u32_,
        mpls_bos: u32_,
        mpls_tc: u32_,
        mpls_label: u32_,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 8u8, {
            let mpls_ttl: u32 = unsafe { ::core::mem::transmute(mpls_ttl) };
            mpls_ttl as u64
        });
        __bindgen_bitfield_unit.set(8usize, 1u8, {
            let mpls_bos: u32 = unsafe { ::core::mem::transmute(mpls_bos) };
            mpls_bos as u64
        });
        __bindgen_bitfield_unit.set(9usize, 3u8, {
            let mpls_tc: u32 = unsafe { ::core::mem::transmute(mpls_tc) };
            mpls_tc as u64
        });
        __bindgen_bitfield_unit.set(12usize, 20u8, {
            let mpls_label: u32 = unsafe { ::core::mem::transmute(mpls_label) };
            mpls_label as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_mpls {
    pub ls: [flow_dissector_mpls_lse; 7usize],
    pub used_lses: u8_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct flow_dissector_key_enc_opts {
    pub data: [u8_; 255usize],
    pub len: u8_,
    pub dst_opt_type: u32_,
}
impl Default for flow_dissector_key_enc_opts {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_keyid {
    pub keyid: __be32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_ipv4_addrs {
    pub src: __be32,
    pub dst: __be32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct flow_dissector_key_ipv6_addrs {
    pub src: in6_addr,
    pub dst: in6_addr,
}
impl Default for flow_dissector_key_ipv6_addrs {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_tipc {
    pub key: __be32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct flow_dissector_key_addrs {
    pub __bindgen_anon_1: flow_dissector_key_addrs__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union flow_dissector_key_addrs__bindgen_ty_1 {
    pub v4addrs: flow_dissector_key_ipv4_addrs,
    pub v6addrs: flow_dissector_key_ipv6_addrs,
    pub tipckey: flow_dissector_key_tipc,
}
impl Default for flow_dissector_key_addrs__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for flow_dissector_key_addrs {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_arp {
    pub sip: __u32,
    pub tip: __u32,
    pub op: __u8,
    pub sha: [ffi::c_uchar; 6usize],
    pub tha: [ffi::c_uchar; 6usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct flow_dissector_key_ports {
    pub __bindgen_anon_1: flow_dissector_key_ports__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union flow_dissector_key_ports__bindgen_ty_1 {
    pub ports: __be32,
    pub __bindgen_anon_1: flow_dissector_key_ports__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_ports__bindgen_ty_1__bindgen_ty_1 {
    pub src: __be16,
    pub dst: __be16,
}
impl Default for flow_dissector_key_ports__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for flow_dissector_key_ports {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct flow_dissector_key_ports_range {
    pub __bindgen_anon_1: flow_dissector_key_ports_range__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union flow_dissector_key_ports_range__bindgen_ty_1 {
    pub tp: flow_dissector_key_ports,
    pub __bindgen_anon_1: flow_dissector_key_ports_range__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct flow_dissector_key_ports_range__bindgen_ty_1__bindgen_ty_1 {
    pub tp_min: flow_dissector_key_ports,
    pub tp_max: flow_dissector_key_ports,
}
impl Default for flow_dissector_key_ports_range__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for flow_dissector_key_ports_range__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for flow_dissector_key_ports_range {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_icmp {
    pub __bindgen_anon_1: flow_dissector_key_icmp__bindgen_ty_1,
    pub id: u16_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_icmp__bindgen_ty_1 {
    pub type_: u8_,
    pub code: u8_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_eth_addrs {
    pub dst: [ffi::c_uchar; 6usize],
    pub src: [ffi::c_uchar; 6usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_tcp {
    pub flags: __be16,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_ip {
    pub tos: __u8,
    pub ttl: __u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_meta {
    pub ingress_ifindex: ffi::c_int,
    pub ingress_iftype: u16_,
    pub l2_miss: u8_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_ct {
    pub ct_state: u16_,
    pub ct_zone: u16_,
    pub ct_mark: u32_,
    pub ct_labels: [u32_; 4usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_hash {
    pub hash: u32_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_num_of_vlans {
    pub num_of_vlans: u8_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_pppoe {
    pub session_id: __be16,
    pub ppp_proto: __be16,
    pub type_: __be16,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_l2tpv3 {
    pub session_id: __be32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_ipsec {
    pub spi: __be32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_dissector_key_cfm {
    pub mdl_ver: u8_,
    pub opcode: u8_,
}
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_CONTROL: flow_dissector_key_id = 0;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_BASIC: flow_dissector_key_id = 1;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_IPV4_ADDRS: flow_dissector_key_id = 2;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_IPV6_ADDRS: flow_dissector_key_id = 3;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_PORTS: flow_dissector_key_id = 4;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_PORTS_RANGE: flow_dissector_key_id = 5;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_ICMP: flow_dissector_key_id = 6;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_ETH_ADDRS: flow_dissector_key_id = 7;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_TIPC: flow_dissector_key_id = 8;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_ARP: flow_dissector_key_id = 9;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_VLAN: flow_dissector_key_id = 10;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_FLOW_LABEL: flow_dissector_key_id = 11;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_GRE_KEYID: flow_dissector_key_id = 12;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_MPLS_ENTROPY: flow_dissector_key_id = 13;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_ENC_KEYID: flow_dissector_key_id = 14;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_ENC_IPV4_ADDRS: flow_dissector_key_id = 15;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_ENC_IPV6_ADDRS: flow_dissector_key_id = 16;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_ENC_CONTROL: flow_dissector_key_id = 17;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_ENC_PORTS: flow_dissector_key_id = 18;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_MPLS: flow_dissector_key_id = 19;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_TCP: flow_dissector_key_id = 20;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_IP: flow_dissector_key_id = 21;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_CVLAN: flow_dissector_key_id = 22;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_ENC_IP: flow_dissector_key_id = 23;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_ENC_OPTS: flow_dissector_key_id = 24;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_META: flow_dissector_key_id = 25;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_CT: flow_dissector_key_id = 26;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_HASH: flow_dissector_key_id = 27;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_NUM_OF_VLANS: flow_dissector_key_id = 28;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_PPPOE: flow_dissector_key_id = 29;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_L2TPV3: flow_dissector_key_id = 30;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_CFM: flow_dissector_key_id = 31;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_IPSEC: flow_dissector_key_id = 32;
pub const flow_dissector_key_id_FLOW_DISSECTOR_KEY_MAX: flow_dissector_key_id = 33;
pub type flow_dissector_key_id = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct flow_dissector_key {
    pub key_id: flow_dissector_key_id,
    pub offset: usize,
}
impl Default for flow_dissector_key {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct flow_dissector {
    pub used_keys: ffi::c_ulonglong,
    pub offset: [ffi::c_ushort; 33usize],
}
impl Default for flow_dissector {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_keys_basic {
    pub control: flow_dissector_key_control,
    pub basic: flow_dissector_key_basic,
}
#[repr(C)]
#[repr(align(8))]
#[derive(Copy, Clone)]
pub struct flow_keys {
    pub control: flow_dissector_key_control,
    pub basic: flow_dissector_key_basic,
    pub tags: flow_dissector_key_tags,
    pub vlan: flow_dissector_key_vlan,
    pub cvlan: flow_dissector_key_vlan,
    pub keyid: flow_dissector_key_keyid,
    pub ports: flow_dissector_key_ports,
    pub icmp: flow_dissector_key_icmp,
    pub addrs: flow_dissector_key_addrs,
}
impl Default for flow_keys {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn flow_get_u32_src(flow: *const flow_keys) -> __be32;
}
extern "C" {
    pub fn flow_get_u32_dst(flow: *const flow_keys) -> __be32;
}
extern "C" {
    pub static mut flow_keys_dissector: flow_dissector;
}
extern "C" {
    pub static mut flow_keys_basic_dissector: flow_dissector;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_keys_digest {
    pub data: [u8_; 16usize],
}
extern "C" {
    pub fn make_flow_keys_digest(digest: *mut flow_keys_digest, flow: *const flow_keys);
}
extern "C" {
    pub fn flow_hash_from_keys(keys: *mut flow_keys) -> u32_;
}
extern "C" {
    pub fn flow_hash_from_keys_seed(keys: *mut flow_keys, keyval: *const siphash_key_t) -> u32_;
}
extern "C" {
    pub fn skb_flow_get_icmp_tci(
        skb: *const sk_buff,
        key_icmp: *mut flow_dissector_key_icmp,
        data: *const ffi::c_void,
        thoff: ffi::c_int,
        hlen: ffi::c_int,
    );
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_flow_dissector {
    pub flow_keys: *mut bpf_flow_keys,
    pub skb: *const sk_buff,
    pub data: *const ffi::c_void,
    pub data_end: *const ffi::c_void,
}
impl Default for bpf_flow_dissector {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn flow_dissector_bpf_prog_attach_check(net: *mut net, prog: *mut bpf_prog) -> ffi::c_int;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sockaddr_pkt {
    pub spkt_family: ffi::c_ushort,
    pub spkt_device: [ffi::c_uchar; 14usize],
    pub spkt_protocol: __be16,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sockaddr_ll {
    pub sll_family: ffi::c_ushort,
    pub sll_protocol: __be16,
    pub sll_ifindex: ffi::c_int,
    pub sll_hatype: ffi::c_ushort,
    pub sll_pkttype: ffi::c_uchar,
    pub sll_halen: ffi::c_uchar,
    pub sll_addr: [ffi::c_uchar; 8usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tpacket_stats {
    pub tp_packets: ffi::c_uint,
    pub tp_drops: ffi::c_uint,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tpacket_stats_v3 {
    pub tp_packets: ffi::c_uint,
    pub tp_drops: ffi::c_uint,
    pub tp_freeze_q_cnt: ffi::c_uint,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tpacket_rollover_stats {
    pub tp_all: __u64,
    pub tp_huge: __u64,
    pub tp_failed: __u64,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tpacket_stats_u {
    pub stats1: tpacket_stats,
    pub stats3: tpacket_stats_v3,
}
impl Default for tpacket_stats_u {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tpacket_auxdata {
    pub tp_status: __u32,
    pub tp_len: __u32,
    pub tp_snaplen: __u32,
    pub tp_mac: __u16,
    pub tp_net: __u16,
    pub tp_vlan_tci: __u16,
    pub tp_vlan_tpid: __u16,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tpacket_hdr {
    pub tp_status: ffi::c_ulong,
    pub tp_len: ffi::c_uint,
    pub tp_snaplen: ffi::c_uint,
    pub tp_mac: ffi::c_ushort,
    pub tp_net: ffi::c_ushort,
    pub tp_sec: ffi::c_uint,
    pub tp_usec: ffi::c_uint,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tpacket2_hdr {
    pub tp_status: __u32,
    pub tp_len: __u32,
    pub tp_snaplen: __u32,
    pub tp_mac: __u16,
    pub tp_net: __u16,
    pub tp_sec: __u32,
    pub tp_nsec: __u32,
    pub tp_vlan_tci: __u16,
    pub tp_vlan_tpid: __u16,
    pub tp_padding: [__u8; 4usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tpacket_hdr_variant1 {
    pub tp_rxhash: __u32,
    pub tp_vlan_tci: __u32,
    pub tp_vlan_tpid: __u16,
    pub tp_padding: __u16,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tpacket3_hdr {
    pub tp_next_offset: __u32,
    pub tp_sec: __u32,
    pub tp_nsec: __u32,
    pub tp_snaplen: __u32,
    pub tp_len: __u32,
    pub tp_status: __u32,
    pub tp_mac: __u16,
    pub tp_net: __u16,
    pub __bindgen_anon_1: tpacket3_hdr__bindgen_ty_1,
    pub tp_padding: [__u8; 8usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tpacket3_hdr__bindgen_ty_1 {
    pub hv1: tpacket_hdr_variant1,
}
impl Default for tpacket3_hdr__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for tpacket3_hdr {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tpacket_bd_ts {
    pub ts_sec: ffi::c_uint,
    pub __bindgen_anon_1: tpacket_bd_ts__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tpacket_bd_ts__bindgen_ty_1 {
    pub ts_usec: ffi::c_uint,
    pub ts_nsec: ffi::c_uint,
}
impl Default for tpacket_bd_ts__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for tpacket_bd_ts {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tpacket_hdr_v1 {
    pub block_status: __u32,
    pub num_pkts: __u32,
    pub offset_to_first_pkt: __u32,
    pub blk_len: __u32,
    pub seq_num: __u64,
    pub ts_first_pkt: tpacket_bd_ts,
    pub ts_last_pkt: tpacket_bd_ts,
}
impl Default for tpacket_hdr_v1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tpacket_bd_header_u {
    pub bh1: tpacket_hdr_v1,
}
impl Default for tpacket_bd_header_u {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tpacket_block_desc {
    pub version: __u32,
    pub offset_to_priv: __u32,
    pub hdr: tpacket_bd_header_u,
}
impl Default for tpacket_block_desc {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const tpacket_versions_TPACKET_V1: tpacket_versions = 0;
pub const tpacket_versions_TPACKET_V2: tpacket_versions = 1;
pub const tpacket_versions_TPACKET_V3: tpacket_versions = 2;
pub type tpacket_versions = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tpacket_req {
    pub tp_block_size: ffi::c_uint,
    pub tp_block_nr: ffi::c_uint,
    pub tp_frame_size: ffi::c_uint,
    pub tp_frame_nr: ffi::c_uint,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tpacket_req3 {
    pub tp_block_size: ffi::c_uint,
    pub tp_block_nr: ffi::c_uint,
    pub tp_frame_size: ffi::c_uint,
    pub tp_frame_nr: ffi::c_uint,
    pub tp_retire_blk_tov: ffi::c_uint,
    pub tp_sizeof_priv: ffi::c_uint,
    pub tp_feature_req_word: ffi::c_uint,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tpacket_req_u {
    pub req: tpacket_req,
    pub req3: tpacket_req3,
}
impl Default for tpacket_req_u {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct packet_mreq {
    pub mr_ifindex: ffi::c_int,
    pub mr_type: ffi::c_ushort,
    pub mr_alen: ffi::c_ushort,
    pub mr_address: [ffi::c_uchar; 8usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct fanout_args {
    pub id: __u16,
    pub type_flags: __u16,
    pub max_num_members: __u32,
}
extern "C" {
    pub fn page_frag_cache_drain(nc: *mut page_frag_cache);
}
extern "C" {
    pub fn __page_frag_cache_drain(page: *mut page, count: ffi::c_uint);
}
extern "C" {
    pub fn __page_frag_alloc_align(
        nc: *mut page_frag_cache,
        fragsz: ffi::c_uint,
        gfp_mask: gfp_t,
        align_mask: ffi::c_uint,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn page_frag_free(addr: *mut ffi::c_void);
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flowi_tunnel {
    pub tun_id: __be64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flowi_common {
    pub flowic_oif: ffi::c_int,
    pub flowic_iif: ffi::c_int,
    pub flowic_l3mdev: ffi::c_int,
    pub flowic_mark: __u32,
    pub flowic_tos: __u8,
    pub flowic_scope: __u8,
    pub flowic_proto: __u8,
    pub flowic_flags: __u8,
    pub flowic_secid: __u32,
    pub flowic_uid: kuid_t,
    pub flowic_multipath_hash: __u32,
    pub flowic_tun_key: flowi_tunnel,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union flowi_uli {
    pub ports: flowi_uli__bindgen_ty_1,
    pub icmpt: flowi_uli__bindgen_ty_2,
    pub gre_key: __be32,
    pub mht: flowi_uli__bindgen_ty_3,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flowi_uli__bindgen_ty_1 {
    pub dport: __be16,
    pub sport: __be16,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flowi_uli__bindgen_ty_2 {
    pub type_: __u8,
    pub code: __u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flowi_uli__bindgen_ty_3 {
    pub type_: __u8,
}
impl Default for flowi_uli {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct flowi4 {
    pub __fl_common: flowi_common,
    pub saddr: __be32,
    pub daddr: __be32,
    pub uli: flowi_uli,
}
impl Default for flowi4 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct flowi6 {
    pub __fl_common: flowi_common,
    pub daddr: in6_addr,
    pub saddr: in6_addr,
    pub flowlabel: __be32,
    pub uli: flowi_uli,
    pub mp_hash: __u32,
}
impl Default for flowi6 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct flowi {
    pub u: flowi__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union flowi__bindgen_ty_1 {
    pub __fl_common: flowi_common,
    pub ip4: flowi4,
    pub ip6: flowi6,
}
impl Default for flowi__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for flowi {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn __get_hash_from_flowi6(fl6: *const flowi6, keys: *mut flow_keys) -> __u32;
}
pub const ip_conntrack_info_IP_CT_ESTABLISHED: ip_conntrack_info = 0;
pub const ip_conntrack_info_IP_CT_RELATED: ip_conntrack_info = 1;
pub const ip_conntrack_info_IP_CT_NEW: ip_conntrack_info = 2;
pub const ip_conntrack_info_IP_CT_IS_REPLY: ip_conntrack_info = 3;
pub const ip_conntrack_info_IP_CT_ESTABLISHED_REPLY: ip_conntrack_info = 3;
pub const ip_conntrack_info_IP_CT_RELATED_REPLY: ip_conntrack_info = 4;
pub const ip_conntrack_info_IP_CT_NUMBER: ip_conntrack_info = 5;
pub const ip_conntrack_info_IP_CT_UNTRACKED: ip_conntrack_info = 7;
pub type ip_conntrack_info = ffi::c_uint;
pub const ip_conntrack_status_IPS_EXPECTED_BIT: ip_conntrack_status = 0;
pub const ip_conntrack_status_IPS_EXPECTED: ip_conntrack_status = 1;
pub const ip_conntrack_status_IPS_SEEN_REPLY_BIT: ip_conntrack_status = 1;
pub const ip_conntrack_status_IPS_SEEN_REPLY: ip_conntrack_status = 2;
pub const ip_conntrack_status_IPS_ASSURED_BIT: ip_conntrack_status = 2;
pub const ip_conntrack_status_IPS_ASSURED: ip_conntrack_status = 4;
pub const ip_conntrack_status_IPS_CONFIRMED_BIT: ip_conntrack_status = 3;
pub const ip_conntrack_status_IPS_CONFIRMED: ip_conntrack_status = 8;
pub const ip_conntrack_status_IPS_SRC_NAT_BIT: ip_conntrack_status = 4;
pub const ip_conntrack_status_IPS_SRC_NAT: ip_conntrack_status = 16;
pub const ip_conntrack_status_IPS_DST_NAT_BIT: ip_conntrack_status = 5;
pub const ip_conntrack_status_IPS_DST_NAT: ip_conntrack_status = 32;
pub const ip_conntrack_status_IPS_NAT_MASK: ip_conntrack_status = 48;
pub const ip_conntrack_status_IPS_SEQ_ADJUST_BIT: ip_conntrack_status = 6;
pub const ip_conntrack_status_IPS_SEQ_ADJUST: ip_conntrack_status = 64;
pub const ip_conntrack_status_IPS_SRC_NAT_DONE_BIT: ip_conntrack_status = 7;
pub const ip_conntrack_status_IPS_SRC_NAT_DONE: ip_conntrack_status = 128;
pub const ip_conntrack_status_IPS_DST_NAT_DONE_BIT: ip_conntrack_status = 8;
pub const ip_conntrack_status_IPS_DST_NAT_DONE: ip_conntrack_status = 256;
pub const ip_conntrack_status_IPS_NAT_DONE_MASK: ip_conntrack_status = 384;
pub const ip_conntrack_status_IPS_DYING_BIT: ip_conntrack_status = 9;
pub const ip_conntrack_status_IPS_DYING: ip_conntrack_status = 512;
pub const ip_conntrack_status_IPS_FIXED_TIMEOUT_BIT: ip_conntrack_status = 10;
pub const ip_conntrack_status_IPS_FIXED_TIMEOUT: ip_conntrack_status = 1024;
pub const ip_conntrack_status_IPS_TEMPLATE_BIT: ip_conntrack_status = 11;
pub const ip_conntrack_status_IPS_TEMPLATE: ip_conntrack_status = 2048;
pub const ip_conntrack_status_IPS_UNTRACKED_BIT: ip_conntrack_status = 12;
pub const ip_conntrack_status_IPS_UNTRACKED: ip_conntrack_status = 4096;
pub const ip_conntrack_status_IPS_NAT_CLASH_BIT: ip_conntrack_status = 12;
pub const ip_conntrack_status_IPS_NAT_CLASH: ip_conntrack_status = 4096;
pub const ip_conntrack_status_IPS_HELPER_BIT: ip_conntrack_status = 13;
pub const ip_conntrack_status_IPS_HELPER: ip_conntrack_status = 8192;
pub const ip_conntrack_status_IPS_OFFLOAD_BIT: ip_conntrack_status = 14;
pub const ip_conntrack_status_IPS_OFFLOAD: ip_conntrack_status = 16384;
pub const ip_conntrack_status_IPS_HW_OFFLOAD_BIT: ip_conntrack_status = 15;
pub const ip_conntrack_status_IPS_HW_OFFLOAD: ip_conntrack_status = 32768;
pub const ip_conntrack_status_IPS_UNCHANGEABLE_MASK: ip_conntrack_status = 56313;
pub const ip_conntrack_status___IPS_MAX_BIT: ip_conntrack_status = 16;
pub type ip_conntrack_status = ffi::c_uint;
pub const ip_conntrack_events_IPCT_NEW: ip_conntrack_events = 0;
pub const ip_conntrack_events_IPCT_RELATED: ip_conntrack_events = 1;
pub const ip_conntrack_events_IPCT_DESTROY: ip_conntrack_events = 2;
pub const ip_conntrack_events_IPCT_REPLY: ip_conntrack_events = 3;
pub const ip_conntrack_events_IPCT_ASSURED: ip_conntrack_events = 4;
pub const ip_conntrack_events_IPCT_PROTOINFO: ip_conntrack_events = 5;
pub const ip_conntrack_events_IPCT_HELPER: ip_conntrack_events = 6;
pub const ip_conntrack_events_IPCT_MARK: ip_conntrack_events = 7;
pub const ip_conntrack_events_IPCT_SEQADJ: ip_conntrack_events = 8;
pub const ip_conntrack_events_IPCT_NATSEQADJ: ip_conntrack_events = 8;
pub const ip_conntrack_events_IPCT_SECMARK: ip_conntrack_events = 9;
pub const ip_conntrack_events_IPCT_LABEL: ip_conntrack_events = 10;
pub const ip_conntrack_events_IPCT_SYNPROXY: ip_conntrack_events = 11;
pub const ip_conntrack_events___IPCT_MAX: ip_conntrack_events = 12;
pub type ip_conntrack_events = ffi::c_uint;
pub const ip_conntrack_expect_events_IPEXP_NEW: ip_conntrack_expect_events = 0;
pub const ip_conntrack_expect_events_IPEXP_DESTROY: ip_conntrack_expect_events = 1;
pub type ip_conntrack_expect_events = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ip_conntrack_stat {
    pub found: ffi::c_uint,
    pub invalid: ffi::c_uint,
    pub insert: ffi::c_uint,
    pub insert_failed: ffi::c_uint,
    pub clash_resolve: ffi::c_uint,
    pub drop: ffi::c_uint,
    pub early_drop: ffi::c_uint,
    pub error: ffi::c_uint,
    pub expect_new: ffi::c_uint,
    pub expect_create: ffi::c_uint,
    pub expect_delete: ffi::c_uint,
    pub search_restart: ffi::c_uint,
    pub chaintoolong: ffi::c_uint,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct nf_conntrack {
    pub use_: refcount_t,
}
extern "C" {
    pub fn nf_conntrack_destroy(nfct: *mut nf_conntrack);
}
extern "C" {
    pub fn netdev_printk(
        level: *const ffi::c_char,
        dev: *const net_device,
        format: *const ffi::c_char,
        ...
    );
}
extern "C" {
    pub fn netdev_emerg(dev: *const net_device, format: *const ffi::c_char, ...);
}
extern "C" {
    pub fn netdev_alert(dev: *const net_device, format: *const ffi::c_char, ...);
}
extern "C" {
    pub fn netdev_crit(dev: *const net_device, format: *const ffi::c_char, ...);
}
extern "C" {
    pub fn netdev_err(dev: *const net_device, format: *const ffi::c_char, ...);
}
extern "C" {
    pub fn netdev_warn(dev: *const net_device, format: *const ffi::c_char, ...);
}
extern "C" {
    pub fn netdev_notice(dev: *const net_device, format: *const ffi::c_char, ...);
}
extern "C" {
    pub fn netdev_info(dev: *const net_device, format: *const ffi::c_char, ...);
}
pub const skb_drop_reason_SKB_NOT_DROPPED_YET: skb_drop_reason = 0;
pub const skb_drop_reason_SKB_CONSUMED: skb_drop_reason = 1;
pub const skb_drop_reason_SKB_DROP_REASON_NOT_SPECIFIED: skb_drop_reason = 2;
pub const skb_drop_reason_SKB_DROP_REASON_NO_SOCKET: skb_drop_reason = 3;
pub const skb_drop_reason_SKB_DROP_REASON_SOCKET_CLOSE: skb_drop_reason = 4;
pub const skb_drop_reason_SKB_DROP_REASON_SOCKET_FILTER: skb_drop_reason = 5;
pub const skb_drop_reason_SKB_DROP_REASON_SOCKET_RCVBUFF: skb_drop_reason = 6;
pub const skb_drop_reason_SKB_DROP_REASON_UNIX_DISCONNECT: skb_drop_reason = 7;
pub const skb_drop_reason_SKB_DROP_REASON_UNIX_SKIP_OOB: skb_drop_reason = 8;
pub const skb_drop_reason_SKB_DROP_REASON_PKT_TOO_SMALL: skb_drop_reason = 9;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_CSUM: skb_drop_reason = 10;
pub const skb_drop_reason_SKB_DROP_REASON_UDP_CSUM: skb_drop_reason = 11;
pub const skb_drop_reason_SKB_DROP_REASON_NETFILTER_DROP: skb_drop_reason = 12;
pub const skb_drop_reason_SKB_DROP_REASON_OTHERHOST: skb_drop_reason = 13;
pub const skb_drop_reason_SKB_DROP_REASON_IP_CSUM: skb_drop_reason = 14;
pub const skb_drop_reason_SKB_DROP_REASON_IP_INHDR: skb_drop_reason = 15;
pub const skb_drop_reason_SKB_DROP_REASON_IP_RPFILTER: skb_drop_reason = 16;
pub const skb_drop_reason_SKB_DROP_REASON_UNICAST_IN_L2_MULTICAST: skb_drop_reason = 17;
pub const skb_drop_reason_SKB_DROP_REASON_XFRM_POLICY: skb_drop_reason = 18;
pub const skb_drop_reason_SKB_DROP_REASON_IP_NOPROTO: skb_drop_reason = 19;
pub const skb_drop_reason_SKB_DROP_REASON_PROTO_MEM: skb_drop_reason = 20;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_AUTH_HDR: skb_drop_reason = 21;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_MD5NOTFOUND: skb_drop_reason = 22;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_MD5UNEXPECTED: skb_drop_reason = 23;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_MD5FAILURE: skb_drop_reason = 24;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_AONOTFOUND: skb_drop_reason = 25;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_AOUNEXPECTED: skb_drop_reason = 26;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_AOKEYNOTFOUND: skb_drop_reason = 27;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_AOFAILURE: skb_drop_reason = 28;
pub const skb_drop_reason_SKB_DROP_REASON_SOCKET_BACKLOG: skb_drop_reason = 29;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_FLAGS: skb_drop_reason = 30;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_ABORT_ON_DATA: skb_drop_reason = 31;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_ZEROWINDOW: skb_drop_reason = 32;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_OLD_DATA: skb_drop_reason = 33;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_OVERWINDOW: skb_drop_reason = 34;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_OFOMERGE: skb_drop_reason = 35;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_RFC7323_PAWS: skb_drop_reason = 36;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_RFC7323_PAWS_ACK: skb_drop_reason = 37;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_RFC7323_TSECR: skb_drop_reason = 38;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_LISTEN_OVERFLOW: skb_drop_reason = 39;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_OLD_SEQUENCE: skb_drop_reason = 40;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_INVALID_SEQUENCE: skb_drop_reason = 41;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_INVALID_ACK_SEQUENCE: skb_drop_reason = 42;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_RESET: skb_drop_reason = 43;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_INVALID_SYN: skb_drop_reason = 44;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_CLOSE: skb_drop_reason = 45;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_FASTOPEN: skb_drop_reason = 46;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_OLD_ACK: skb_drop_reason = 47;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_TOO_OLD_ACK: skb_drop_reason = 48;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_ACK_UNSENT_DATA: skb_drop_reason = 49;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_OFO_QUEUE_PRUNE: skb_drop_reason = 50;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_OFO_DROP: skb_drop_reason = 51;
pub const skb_drop_reason_SKB_DROP_REASON_IP_OUTNOROUTES: skb_drop_reason = 52;
pub const skb_drop_reason_SKB_DROP_REASON_BPF_CGROUP_EGRESS: skb_drop_reason = 53;
pub const skb_drop_reason_SKB_DROP_REASON_IPV6DISABLED: skb_drop_reason = 54;
pub const skb_drop_reason_SKB_DROP_REASON_NEIGH_CREATEFAIL: skb_drop_reason = 55;
pub const skb_drop_reason_SKB_DROP_REASON_NEIGH_FAILED: skb_drop_reason = 56;
pub const skb_drop_reason_SKB_DROP_REASON_NEIGH_QUEUEFULL: skb_drop_reason = 57;
pub const skb_drop_reason_SKB_DROP_REASON_NEIGH_DEAD: skb_drop_reason = 58;
pub const skb_drop_reason_SKB_DROP_REASON_TC_EGRESS: skb_drop_reason = 59;
pub const skb_drop_reason_SKB_DROP_REASON_SECURITY_HOOK: skb_drop_reason = 60;
pub const skb_drop_reason_SKB_DROP_REASON_QDISC_DROP: skb_drop_reason = 61;
pub const skb_drop_reason_SKB_DROP_REASON_QDISC_OVERLIMIT: skb_drop_reason = 62;
pub const skb_drop_reason_SKB_DROP_REASON_QDISC_CONGESTED: skb_drop_reason = 63;
pub const skb_drop_reason_SKB_DROP_REASON_CAKE_FLOOD: skb_drop_reason = 64;
pub const skb_drop_reason_SKB_DROP_REASON_FQ_BAND_LIMIT: skb_drop_reason = 65;
pub const skb_drop_reason_SKB_DROP_REASON_FQ_HORIZON_LIMIT: skb_drop_reason = 66;
pub const skb_drop_reason_SKB_DROP_REASON_FQ_FLOW_LIMIT: skb_drop_reason = 67;
pub const skb_drop_reason_SKB_DROP_REASON_CPU_BACKLOG: skb_drop_reason = 68;
pub const skb_drop_reason_SKB_DROP_REASON_XDP: skb_drop_reason = 69;
pub const skb_drop_reason_SKB_DROP_REASON_TC_INGRESS: skb_drop_reason = 70;
pub const skb_drop_reason_SKB_DROP_REASON_UNHANDLED_PROTO: skb_drop_reason = 71;
pub const skb_drop_reason_SKB_DROP_REASON_SKB_CSUM: skb_drop_reason = 72;
pub const skb_drop_reason_SKB_DROP_REASON_SKB_GSO_SEG: skb_drop_reason = 73;
pub const skb_drop_reason_SKB_DROP_REASON_SKB_UCOPY_FAULT: skb_drop_reason = 74;
pub const skb_drop_reason_SKB_DROP_REASON_DEV_HDR: skb_drop_reason = 75;
pub const skb_drop_reason_SKB_DROP_REASON_DEV_READY: skb_drop_reason = 76;
pub const skb_drop_reason_SKB_DROP_REASON_FULL_RING: skb_drop_reason = 77;
pub const skb_drop_reason_SKB_DROP_REASON_NOMEM: skb_drop_reason = 78;
pub const skb_drop_reason_SKB_DROP_REASON_HDR_TRUNC: skb_drop_reason = 79;
pub const skb_drop_reason_SKB_DROP_REASON_TAP_FILTER: skb_drop_reason = 80;
pub const skb_drop_reason_SKB_DROP_REASON_TAP_TXFILTER: skb_drop_reason = 81;
pub const skb_drop_reason_SKB_DROP_REASON_ICMP_CSUM: skb_drop_reason = 82;
pub const skb_drop_reason_SKB_DROP_REASON_INVALID_PROTO: skb_drop_reason = 83;
pub const skb_drop_reason_SKB_DROP_REASON_IP_INADDRERRORS: skb_drop_reason = 84;
pub const skb_drop_reason_SKB_DROP_REASON_IP_INNOROUTES: skb_drop_reason = 85;
pub const skb_drop_reason_SKB_DROP_REASON_IP_LOCAL_SOURCE: skb_drop_reason = 86;
pub const skb_drop_reason_SKB_DROP_REASON_IP_INVALID_SOURCE: skb_drop_reason = 87;
pub const skb_drop_reason_SKB_DROP_REASON_IP_LOCALNET: skb_drop_reason = 88;
pub const skb_drop_reason_SKB_DROP_REASON_IP_INVALID_DEST: skb_drop_reason = 89;
pub const skb_drop_reason_SKB_DROP_REASON_PKT_TOO_BIG: skb_drop_reason = 90;
pub const skb_drop_reason_SKB_DROP_REASON_DUP_FRAG: skb_drop_reason = 91;
pub const skb_drop_reason_SKB_DROP_REASON_FRAG_REASM_TIMEOUT: skb_drop_reason = 92;
pub const skb_drop_reason_SKB_DROP_REASON_FRAG_TOO_FAR: skb_drop_reason = 93;
pub const skb_drop_reason_SKB_DROP_REASON_TCP_MINTTL: skb_drop_reason = 94;
pub const skb_drop_reason_SKB_DROP_REASON_IPV6_BAD_EXTHDR: skb_drop_reason = 95;
pub const skb_drop_reason_SKB_DROP_REASON_IPV6_NDISC_FRAG: skb_drop_reason = 96;
pub const skb_drop_reason_SKB_DROP_REASON_IPV6_NDISC_HOP_LIMIT: skb_drop_reason = 97;
pub const skb_drop_reason_SKB_DROP_REASON_IPV6_NDISC_BAD_CODE: skb_drop_reason = 98;
pub const skb_drop_reason_SKB_DROP_REASON_IPV6_NDISC_BAD_OPTIONS: skb_drop_reason = 99;
pub const skb_drop_reason_SKB_DROP_REASON_IPV6_NDISC_NS_OTHERHOST: skb_drop_reason = 100;
pub const skb_drop_reason_SKB_DROP_REASON_QUEUE_PURGE: skb_drop_reason = 101;
pub const skb_drop_reason_SKB_DROP_REASON_TC_COOKIE_ERROR: skb_drop_reason = 102;
pub const skb_drop_reason_SKB_DROP_REASON_PACKET_SOCK_ERROR: skb_drop_reason = 103;
pub const skb_drop_reason_SKB_DROP_REASON_TC_CHAIN_NOTFOUND: skb_drop_reason = 104;
pub const skb_drop_reason_SKB_DROP_REASON_TC_RECLASSIFY_LOOP: skb_drop_reason = 105;
pub const skb_drop_reason_SKB_DROP_REASON_VXLAN_INVALID_HDR: skb_drop_reason = 106;
pub const skb_drop_reason_SKB_DROP_REASON_VXLAN_VNI_NOT_FOUND: skb_drop_reason = 107;
pub const skb_drop_reason_SKB_DROP_REASON_MAC_INVALID_SOURCE: skb_drop_reason = 108;
pub const skb_drop_reason_SKB_DROP_REASON_VXLAN_ENTRY_EXISTS: skb_drop_reason = 109;
pub const skb_drop_reason_SKB_DROP_REASON_NO_TX_TARGET: skb_drop_reason = 110;
pub const skb_drop_reason_SKB_DROP_REASON_IP_TUNNEL_ECN: skb_drop_reason = 111;
pub const skb_drop_reason_SKB_DROP_REASON_TUNNEL_TXINFO: skb_drop_reason = 112;
pub const skb_drop_reason_SKB_DROP_REASON_LOCAL_MAC: skb_drop_reason = 113;
pub const skb_drop_reason_SKB_DROP_REASON_ARP_PVLAN_DISABLE: skb_drop_reason = 114;
pub const skb_drop_reason_SKB_DROP_REASON_MAC_IEEE_MAC_CONTROL: skb_drop_reason = 115;
pub const skb_drop_reason_SKB_DROP_REASON_BRIDGE_INGRESS_STP_STATE: skb_drop_reason = 116;
pub const skb_drop_reason_SKB_DROP_REASON_MAX: skb_drop_reason = 117;
pub const skb_drop_reason_SKB_DROP_REASON_SUBSYS_MASK: skb_drop_reason = 4294901760;
pub type skb_drop_reason = ffi::c_uint;
extern "C" {
    pub static mut page_pool_mem_providers: static_key_false;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct net_iov {
    pub __unused_padding: ffi::c_ulong,
    pub pp_magic: ffi::c_ulong,
    pub pp: *mut page_pool,
    pub owner: *mut net_iov_area,
    pub dma_addr: ffi::c_ulong,
    pub pp_ref_count: atomic_long_t,
}
impl Default for net_iov {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct net_iov_area {
    pub niovs: *mut net_iov,
    pub num_niovs: usize,
    pub base_virtual: ffi::c_ulong,
}
impl Default for net_iov_area {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type netmem_ref = ffi::c_ulong;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ahash_request {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct napi_struct {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ts_config {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct nf_bridge_info {
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
    pub frag_max_size: __u16,
    pub physinif: ffi::c_int,
    pub physoutdev: *mut net_device,
    pub __bindgen_anon_1: nf_bridge_info__bindgen_ty_2,
}
pub const nf_bridge_info_BRNF_PROTO_UNCHANGED: nf_bridge_info__bindgen_ty_1 = 0;
pub const nf_bridge_info_BRNF_PROTO_8021Q: nf_bridge_info__bindgen_ty_1 = 1;
pub const nf_bridge_info_BRNF_PROTO_PPPOE: nf_bridge_info__bindgen_ty_1 = 2;
pub type nf_bridge_info__bindgen_ty_1 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub union nf_bridge_info__bindgen_ty_2 {
    pub ipv4_daddr: __be32,
    pub ipv6_daddr: in6_addr,
    pub neigh_header: [ffi::c_char; 8usize],
}
impl Default for nf_bridge_info__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for nf_bridge_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl nf_bridge_info {
    #[inline]
    pub fn orig_proto(&self) -> nf_bridge_info__bindgen_ty_1 {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 8u8) as u32) }
    }
    #[inline]
    pub fn set_orig_proto(&mut self, val: nf_bridge_info__bindgen_ty_1) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 8u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn orig_proto_raw(this: *const Self) -> nf_bridge_info__bindgen_ty_1 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                8u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_orig_proto_raw(this: *mut Self, val: nf_bridge_info__bindgen_ty_1) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                8u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn pkt_otherhost(&self) -> u8_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(8usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_pkt_otherhost(&mut self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(8usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn pkt_otherhost_raw(this: *const Self) -> u8_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                8usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_pkt_otherhost_raw(this: *mut Self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                8usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn in_prerouting(&self) -> u8_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(9usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_in_prerouting(&mut self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(9usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn in_prerouting_raw(this: *const Self) -> u8_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                9usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_in_prerouting_raw(this: *mut Self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                9usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn bridged_dnat(&self) -> u8_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(10usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_bridged_dnat(&mut self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(10usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn bridged_dnat_raw(this: *const Self) -> u8_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                10usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_bridged_dnat_raw(this: *mut Self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                10usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn sabotage_in_done(&self) -> u8_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(11usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_sabotage_in_done(&mut self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(11usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn sabotage_in_done_raw(this: *const Self) -> u8_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                11usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_sabotage_in_done_raw(this: *mut Self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                11usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        orig_proto: nf_bridge_info__bindgen_ty_1,
        pkt_otherhost: u8_,
        in_prerouting: u8_,
        bridged_dnat: u8_,
        sabotage_in_done: u8_,
    ) -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 8u8, {
            let orig_proto: u32 = unsafe { ::core::mem::transmute(orig_proto) };
            orig_proto as u64
        });
        __bindgen_bitfield_unit.set(8usize, 1u8, {
            let pkt_otherhost: u8 = unsafe { ::core::mem::transmute(pkt_otherhost) };
            pkt_otherhost as u64
        });
        __bindgen_bitfield_unit.set(9usize, 1u8, {
            let in_prerouting: u8 = unsafe { ::core::mem::transmute(in_prerouting) };
            in_prerouting as u64
        });
        __bindgen_bitfield_unit.set(10usize, 1u8, {
            let bridged_dnat: u8 = unsafe { ::core::mem::transmute(bridged_dnat) };
            bridged_dnat as u64
        });
        __bindgen_bitfield_unit.set(11usize, 1u8, {
            let sabotage_in_done: u8 = unsafe { ::core::mem::transmute(sabotage_in_done) };
            sabotage_in_done as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tc_skb_ext {
    pub __bindgen_anon_1: tc_skb_ext__bindgen_ty_1,
    pub mru: __u16,
    pub zone: __u16,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub __bindgen_padding_0: [u8; 3usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tc_skb_ext__bindgen_ty_1 {
    pub act_miss_cookie: u64_,
    pub chain: __u32,
}
impl Default for tc_skb_ext__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for tc_skb_ext {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl tc_skb_ext {
    #[inline]
    pub fn post_ct(&self) -> u8_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_post_ct(&mut self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn post_ct_raw(this: *const Self) -> u8_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_post_ct_raw(this: *mut Self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn post_ct_snat(&self) -> u8_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_post_ct_snat(&mut self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn post_ct_snat_raw(this: *const Self) -> u8_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_post_ct_snat_raw(this: *mut Self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn post_ct_dnat(&self) -> u8_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_post_ct_dnat(&mut self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn post_ct_dnat_raw(this: *const Self) -> u8_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_post_ct_dnat_raw(this: *mut Self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn act_miss(&self) -> u8_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_act_miss(&mut self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn act_miss_raw(this: *const Self) -> u8_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_act_miss_raw(this: *mut Self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn l2_miss(&self) -> u8_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_l2_miss(&mut self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn l2_miss_raw(this: *const Self) -> u8_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_l2_miss_raw(this: *mut Self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        post_ct: u8_,
        post_ct_snat: u8_,
        post_ct_dnat: u8_,
        act_miss: u8_,
        l2_miss: u8_,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let post_ct: u8 = unsafe { ::core::mem::transmute(post_ct) };
            post_ct as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let post_ct_snat: u8 = unsafe { ::core::mem::transmute(post_ct_snat) };
            post_ct_snat as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let post_ct_dnat: u8 = unsafe { ::core::mem::transmute(post_ct_dnat) };
            post_ct_dnat as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let act_miss: u8 = unsafe { ::core::mem::transmute(act_miss) };
            act_miss as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let l2_miss: u8 = unsafe { ::core::mem::transmute(l2_miss) };
            l2_miss as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sk_buff_head {
    pub __bindgen_anon_1: sk_buff_head__bindgen_ty_1,
    pub qlen: __u32,
    pub lock: spinlock_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sk_buff_head__bindgen_ty_1 {
    pub __bindgen_anon_1: sk_buff_head__bindgen_ty_1__bindgen_ty_1,
    pub list: sk_buff_head__bindgen_ty_1_sk_buff_list,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sk_buff_head__bindgen_ty_1__bindgen_ty_1 {
    pub next: *mut sk_buff,
    pub prev: *mut sk_buff,
}
impl Default for sk_buff_head__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sk_buff_head__bindgen_ty_1_sk_buff_list {
    pub next: *mut sk_buff,
    pub prev: *mut sk_buff,
}
impl Default for sk_buff_head__bindgen_ty_1_sk_buff_list {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for sk_buff_head__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for sk_buff_head {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct skb_frag {
    pub netmem: netmem_ref,
    pub len: ffi::c_uint,
    pub offset: ffi::c_uint,
}
pub type skb_frag_t = skb_frag;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct skb_shared_hwtstamps {
    pub __bindgen_anon_1: skb_shared_hwtstamps__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union skb_shared_hwtstamps__bindgen_ty_1 {
    pub hwtstamp: ktime_t,
    pub netdev_data: *mut ffi::c_void,
}
impl Default for skb_shared_hwtstamps__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for skb_shared_hwtstamps {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const SKBTX_HW_TSTAMP_NOBPF: _bindgen_ty_199 = 1;
pub const SKBTX_SW_TSTAMP: _bindgen_ty_199 = 2;
pub const SKBTX_IN_PROGRESS: _bindgen_ty_199 = 4;
pub const SKBTX_COMPLETION_TSTAMP: _bindgen_ty_199 = 8;
pub const SKBTX_WIFI_STATUS: _bindgen_ty_199 = 16;
pub const SKBTX_HW_TSTAMP_NETDEV: _bindgen_ty_199 = 32;
pub const SKBTX_SCHED_TSTAMP: _bindgen_ty_199 = 64;
pub const SKBTX_BPF: _bindgen_ty_199 = 128;
pub type _bindgen_ty_199 = ffi::c_uint;
pub const SKBFL_ZEROCOPY_ENABLE: _bindgen_ty_200 = 1;
pub const SKBFL_SHARED_FRAG: _bindgen_ty_200 = 2;
pub const SKBFL_PURE_ZEROCOPY: _bindgen_ty_200 = 4;
pub const SKBFL_DONT_ORPHAN: _bindgen_ty_200 = 8;
pub const SKBFL_MANAGED_FRAG_REFS: _bindgen_ty_200 = 16;
pub type _bindgen_ty_200 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ubuf_info_ops {
    pub complete: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut sk_buff, arg2: *mut ubuf_info, zerocopy_success: bool_),
    >,
    pub link_skb: ::core::option::Option<
        unsafe extern "C" fn(skb: *mut sk_buff, uarg: *mut ubuf_info) -> ffi::c_int,
    >,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ubuf_info {
    pub ops: *const ubuf_info_ops,
    pub refcnt: refcount_t,
    pub flags: u8_,
}
impl Default for ubuf_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ubuf_info_msgzc {
    pub ubuf: ubuf_info,
    pub __bindgen_anon_1: ubuf_info_msgzc__bindgen_ty_1,
    pub mmp: ubuf_info_msgzc_mmpin,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union ubuf_info_msgzc__bindgen_ty_1 {
    pub __bindgen_anon_1: ubuf_info_msgzc__bindgen_ty_1__bindgen_ty_1,
    pub __bindgen_anon_2: ubuf_info_msgzc__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ubuf_info_msgzc__bindgen_ty_1__bindgen_ty_1 {
    pub desc: ffi::c_ulong,
    pub ctx: *mut ffi::c_void,
}
impl Default for ubuf_info_msgzc__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ubuf_info_msgzc__bindgen_ty_1__bindgen_ty_2 {
    pub id: u32_,
    pub len: u16_,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub bytelen: u32_,
}
impl ubuf_info_msgzc__bindgen_ty_1__bindgen_ty_2 {
    #[inline]
    pub fn zerocopy(&self) -> u16_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_zerocopy(&mut self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn zerocopy_raw(this: *const Self) -> u16_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_zerocopy_raw(this: *mut Self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(zerocopy: u16_) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let zerocopy: u16 = unsafe { ::core::mem::transmute(zerocopy) };
            zerocopy as u64
        });
        __bindgen_bitfield_unit
    }
}
impl Default for ubuf_info_msgzc__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ubuf_info_msgzc_mmpin {
    pub user: *mut user_struct,
    pub num_pg: ffi::c_uint,
}
impl Default for ubuf_info_msgzc_mmpin {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for ubuf_info_msgzc {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn mm_account_pinned_pages(mmp: *mut ubuf_info_msgzc_mmpin, size: usize) -> ffi::c_int;
}
extern "C" {
    pub fn mm_unaccount_pinned_pages(mmp: *mut ubuf_info_msgzc_mmpin);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct xsk_tx_metadata_compl {
    pub tx_timestamp: *mut __u64,
}
impl Default for xsk_tx_metadata_compl {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct skb_shared_info {
    pub flags: __u8,
    pub meta_len: __u8,
    pub nr_frags: __u8,
    pub tx_flags: __u8,
    pub gso_size: ffi::c_ushort,
    pub gso_segs: ffi::c_ushort,
    pub frag_list: *mut sk_buff,
    pub __bindgen_anon_1: skb_shared_info__bindgen_ty_1,
    pub gso_type: ffi::c_uint,
    pub tskey: u32_,
    pub dataref: atomic_t,
    pub __bindgen_anon_2: skb_shared_info__bindgen_ty_2,
    pub frags: [skb_frag_t; 17usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union skb_shared_info__bindgen_ty_1 {
    pub hwtstamps: skb_shared_hwtstamps,
    pub xsk_meta: xsk_tx_metadata_compl,
}
impl Default for skb_shared_info__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union skb_shared_info__bindgen_ty_2 {
    pub __bindgen_anon_1: skb_shared_info__bindgen_ty_2__bindgen_ty_1,
    pub destructor_arg: *mut ffi::c_void,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct skb_shared_info__bindgen_ty_2__bindgen_ty_1 {
    pub xdp_frags_size: u32_,
    pub xdp_frags_truesize: u32_,
}
impl Default for skb_shared_info__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for skb_shared_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const SKB_FCLONE_UNAVAILABLE: _bindgen_ty_201 = 0;
pub const SKB_FCLONE_ORIG: _bindgen_ty_201 = 1;
pub const SKB_FCLONE_CLONE: _bindgen_ty_201 = 2;
pub type _bindgen_ty_201 = ffi::c_uint;
pub const SKB_GSO_TCPV4: _bindgen_ty_202 = 1;
pub const SKB_GSO_DODGY: _bindgen_ty_202 = 2;
pub const SKB_GSO_TCP_ECN: _bindgen_ty_202 = 4;
pub const SKB_GSO_TCP_FIXEDID: _bindgen_ty_202 = 8;
pub const SKB_GSO_TCPV6: _bindgen_ty_202 = 16;
pub const SKB_GSO_FCOE: _bindgen_ty_202 = 32;
pub const SKB_GSO_GRE: _bindgen_ty_202 = 64;
pub const SKB_GSO_GRE_CSUM: _bindgen_ty_202 = 128;
pub const SKB_GSO_IPXIP4: _bindgen_ty_202 = 256;
pub const SKB_GSO_IPXIP6: _bindgen_ty_202 = 512;
pub const SKB_GSO_UDP_TUNNEL: _bindgen_ty_202 = 1024;
pub const SKB_GSO_UDP_TUNNEL_CSUM: _bindgen_ty_202 = 2048;
pub const SKB_GSO_PARTIAL: _bindgen_ty_202 = 4096;
pub const SKB_GSO_TUNNEL_REMCSUM: _bindgen_ty_202 = 8192;
pub const SKB_GSO_SCTP: _bindgen_ty_202 = 16384;
pub const SKB_GSO_ESP: _bindgen_ty_202 = 32768;
pub const SKB_GSO_UDP: _bindgen_ty_202 = 65536;
pub const SKB_GSO_UDP_L4: _bindgen_ty_202 = 131072;
pub const SKB_GSO_FRAGLIST: _bindgen_ty_202 = 262144;
pub const SKB_GSO_TCP_ACCECN: _bindgen_ty_202 = 524288;
pub type _bindgen_ty_202 = ffi::c_uint;
pub type sk_buff_data_t = ffi::c_uint;
pub const skb_tstamp_type_SKB_CLOCK_REALTIME: skb_tstamp_type = 0;
pub const skb_tstamp_type_SKB_CLOCK_MONOTONIC: skb_tstamp_type = 1;
pub const skb_tstamp_type_SKB_CLOCK_TAI: skb_tstamp_type = 2;
pub const skb_tstamp_type___SKB_CLOCK_MAX: skb_tstamp_type = 2;
pub type skb_tstamp_type = ffi::c_uint;
#[repr(C)]
pub struct sk_buff {
    pub __bindgen_anon_1: sk_buff__bindgen_ty_1,
    pub sk: *mut sock,
    pub __bindgen_anon_2: sk_buff__bindgen_ty_2,
    pub cb: [ffi::c_char; 48usize],
    pub __bindgen_anon_3: sk_buff__bindgen_ty_3,
    pub _nfct: ffi::c_ulong,
    pub len: ffi::c_uint,
    pub data_len: ffi::c_uint,
    pub mac_len: __u16,
    pub hdr_len: __u16,
    pub queue_mapping: __u16,
    pub __cloned_offset: __IncompleteArrayField<__u8>,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub active_extensions: __u8,
    pub __bindgen_anon_4: sk_buff__bindgen_ty_4,
    pub tail: sk_buff_data_t,
    pub end: sk_buff_data_t,
    pub head: *mut ffi::c_uchar,
    pub data: *mut ffi::c_uchar,
    pub truesize: ffi::c_uint,
    pub users: refcount_t,
    pub extensions: *mut skb_ext,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sk_buff__bindgen_ty_1 {
    pub __bindgen_anon_1: sk_buff__bindgen_ty_1__bindgen_ty_1,
    pub rbnode: rb_node,
    pub list: list_head,
    pub ll_node: llist_node,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sk_buff__bindgen_ty_1__bindgen_ty_1 {
    pub next: *mut sk_buff,
    pub prev: *mut sk_buff,
    pub __bindgen_anon_1: sk_buff__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sk_buff__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    pub dev: *mut net_device,
    pub dev_scratch: ffi::c_ulong,
}
impl Default for sk_buff__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for sk_buff__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for sk_buff__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sk_buff__bindgen_ty_2 {
    pub tstamp: ktime_t,
    pub skb_mstamp_ns: u64_,
}
impl Default for sk_buff__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sk_buff__bindgen_ty_3 {
    pub __bindgen_anon_1: sk_buff__bindgen_ty_3__bindgen_ty_1,
    pub tcp_tsorted_anchor: list_head,
    pub _sk_redir: ffi::c_ulong,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sk_buff__bindgen_ty_3__bindgen_ty_1 {
    pub _skb_refdst: ffi::c_ulong,
    pub destructor: ::core::option::Option<unsafe extern "C" fn(skb: *mut sk_buff)>,
}
impl Default for sk_buff__bindgen_ty_3 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct sk_buff__bindgen_ty_4 {
    pub __bindgen_anon_1: __BindgenUnionField<sk_buff__bindgen_ty_4__bindgen_ty_1>,
    pub headers: __BindgenUnionField<sk_buff__bindgen_ty_4__bindgen_ty_2>,
    pub bindgen_union_field: [u32; 15usize],
}
#[repr(C)]
pub struct sk_buff__bindgen_ty_4__bindgen_ty_1 {
    pub __pkt_type_offset: __IncompleteArrayField<__u8>,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub __mono_tc_offset: __IncompleteArrayField<__u8>,
    pub _bitfield_align_2: [u8; 0],
    pub _bitfield_2: __BindgenBitfieldUnit<[u8; 4usize]>,
    pub tc_index: __u16,
    pub alloc_cpu: u16_,
    pub __bindgen_anon_1: sk_buff__bindgen_ty_4__bindgen_ty_1__bindgen_ty_1,
    pub priority: __u32,
    pub skb_iif: ffi::c_int,
    pub hash: __u32,
    pub __bindgen_anon_2: sk_buff__bindgen_ty_4__bindgen_ty_1__bindgen_ty_2,
    pub __bindgen_anon_3: sk_buff__bindgen_ty_4__bindgen_ty_1__bindgen_ty_3,
    pub secmark: __u32,
    pub __bindgen_anon_4: sk_buff__bindgen_ty_4__bindgen_ty_1__bindgen_ty_4,
    pub __bindgen_anon_5: sk_buff__bindgen_ty_4__bindgen_ty_1__bindgen_ty_5,
    pub inner_transport_header: __u16,
    pub inner_network_header: __u16,
    pub inner_mac_header: __u16,
    pub protocol: __be16,
    pub transport_header: __u16,
    pub network_header: __u16,
    pub mac_header: __u16,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sk_buff__bindgen_ty_4__bindgen_ty_1__bindgen_ty_1 {
    pub csum: __wsum,
    pub __bindgen_anon_1: sk_buff__bindgen_ty_4__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sk_buff__bindgen_ty_4__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    pub csum_start: __u16,
    pub csum_offset: __u16,
}
impl Default for sk_buff__bindgen_ty_4__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sk_buff__bindgen_ty_4__bindgen_ty_1__bindgen_ty_2 {
    pub vlan_all: u32_,
    pub __bindgen_anon_1: sk_buff__bindgen_ty_4__bindgen_ty_1__bindgen_ty_2__bindgen_ty_1,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sk_buff__bindgen_ty_4__bindgen_ty_1__bindgen_ty_2__bindgen_ty_1 {
    pub vlan_proto: __be16,
    pub vlan_tci: __u16,
}
impl Default for sk_buff__bindgen_ty_4__bindgen_ty_1__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sk_buff__bindgen_ty_4__bindgen_ty_1__bindgen_ty_3 {
    pub napi_id: ffi::c_uint,
    pub sender_cpu: ffi::c_uint,
}
impl Default for sk_buff__bindgen_ty_4__bindgen_ty_1__bindgen_ty_3 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sk_buff__bindgen_ty_4__bindgen_ty_1__bindgen_ty_4 {
    pub mark: __u32,
    pub reserved_tailroom: __u32,
}
impl Default for sk_buff__bindgen_ty_4__bindgen_ty_1__bindgen_ty_4 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sk_buff__bindgen_ty_4__bindgen_ty_1__bindgen_ty_5 {
    pub inner_protocol: __be16,
    pub inner_ipproto: __u8,
}
impl Default for sk_buff__bindgen_ty_4__bindgen_ty_1__bindgen_ty_5 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for sk_buff__bindgen_ty_4__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl sk_buff__bindgen_ty_4__bindgen_ty_1 {
    #[inline]
    pub fn pkt_type(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 3u8) as u8) }
    }
    #[inline]
    pub fn set_pkt_type(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 3u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn pkt_type_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                3u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_pkt_type_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                3u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ignore_df(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_ignore_df(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ignore_df_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_ignore_df_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn dst_pending_confirm(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_dst_pending_confirm(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn dst_pending_confirm_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_dst_pending_confirm_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ip_summed(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(5usize, 2u8) as u8) }
    }
    #[inline]
    pub fn set_ip_summed(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(5usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ip_summed_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                2u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_ip_summed_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ooo_okay(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_ooo_okay(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(7usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ooo_okay_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                7usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_ooo_okay_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                7usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        pkt_type: __u8,
        ignore_df: __u8,
        dst_pending_confirm: __u8,
        ip_summed: __u8,
        ooo_okay: __u8,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 3u8, {
            let pkt_type: u8 = unsafe { ::core::mem::transmute(pkt_type) };
            pkt_type as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let ignore_df: u8 = unsafe { ::core::mem::transmute(ignore_df) };
            ignore_df as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let dst_pending_confirm: u8 = unsafe { ::core::mem::transmute(dst_pending_confirm) };
            dst_pending_confirm as u64
        });
        __bindgen_bitfield_unit.set(5usize, 2u8, {
            let ip_summed: u8 = unsafe { ::core::mem::transmute(ip_summed) };
            ip_summed as u64
        });
        __bindgen_bitfield_unit.set(7usize, 1u8, {
            let ooo_okay: u8 = unsafe { ::core::mem::transmute(ooo_okay) };
            ooo_okay as u64
        });
        __bindgen_bitfield_unit
    }
    #[inline]
    pub fn tstamp_type(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(0usize, 2u8) as u8) }
    }
    #[inline]
    pub fn set_tstamp_type(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(0usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn tstamp_type_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                0usize,
                2u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_tstamp_type_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                0usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn tc_at_ingress(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(2usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_tc_at_ingress(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn tc_at_ingress_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                2usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_tc_at_ingress_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn tc_skip_classify(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(3usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_tc_skip_classify(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn tc_skip_classify_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                3usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_tc_skip_classify_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn remcsum_offload(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(4usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_remcsum_offload(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn remcsum_offload_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                4usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_remcsum_offload_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn csum_complete_sw(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(5usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_csum_complete_sw(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(5usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn csum_complete_sw_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                5usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_csum_complete_sw_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                5usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn csum_level(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(6usize, 2u8) as u8) }
    }
    #[inline]
    pub fn set_csum_level(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(6usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn csum_level_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                6usize,
                2u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_csum_level_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                6usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn inner_protocol_type(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(8usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_inner_protocol_type(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(8usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn inner_protocol_type_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                8usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_inner_protocol_type_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                8usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn l4_hash(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(9usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_l4_hash(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(9usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn l4_hash_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                9usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_l4_hash_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                9usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn sw_hash(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(10usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_sw_hash(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(10usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn sw_hash_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                10usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_sw_hash_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                10usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn wifi_acked_valid(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(11usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_wifi_acked_valid(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(11usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn wifi_acked_valid_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                11usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_wifi_acked_valid_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                11usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn wifi_acked(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(12usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_wifi_acked(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(12usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn wifi_acked_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                12usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_wifi_acked_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                12usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn no_fcs(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(13usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_no_fcs(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(13usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn no_fcs_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                13usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_no_fcs_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                13usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn encapsulation(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(14usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_encapsulation(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(14usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn encapsulation_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                14usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_encapsulation_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                14usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn encap_hdr_csum(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(15usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_encap_hdr_csum(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(15usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn encap_hdr_csum_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                15usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_encap_hdr_csum_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                15usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn csum_valid(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(16usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_csum_valid(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(16usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn csum_valid_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                16usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_csum_valid_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                16usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ndisc_nodetype(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(17usize, 2u8) as u8) }
    }
    #[inline]
    pub fn set_ndisc_nodetype(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(17usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ndisc_nodetype_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                17usize,
                2u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_ndisc_nodetype_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                17usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ipvs_property(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(19usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_ipvs_property(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(19usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ipvs_property_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                19usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_ipvs_property_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                19usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn nf_trace(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(20usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_nf_trace(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(20usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn nf_trace_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                20usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_nf_trace_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                20usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn offload_fwd_mark(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(21usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_offload_fwd_mark(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(21usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn offload_fwd_mark_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                21usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_offload_fwd_mark_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                21usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn offload_l3_fwd_mark(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(22usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_offload_l3_fwd_mark(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(22usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn offload_l3_fwd_mark_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                22usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_offload_l3_fwd_mark_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                22usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn redirected(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(23usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_redirected(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(23usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn redirected_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                23usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_redirected_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                23usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn from_ingress(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(24usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_from_ingress(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(24usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn from_ingress_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                24usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_from_ingress_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                24usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn nf_skip_egress(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(25usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_nf_skip_egress(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(25usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn nf_skip_egress_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                25usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_nf_skip_egress_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                25usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn decrypted(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(26usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_decrypted(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(26usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn decrypted_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                26usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_decrypted_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                26usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn slow_gro(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(27usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_slow_gro(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(27usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn slow_gro_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                27usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_slow_gro_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                27usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn csum_not_inet(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(28usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_csum_not_inet(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(28usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn csum_not_inet_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                28usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_csum_not_inet_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                28usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn unreadable(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(29usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_unreadable(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(29usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn unreadable_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                29usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_unreadable_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                29usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_2(
        tstamp_type: __u8,
        tc_at_ingress: __u8,
        tc_skip_classify: __u8,
        remcsum_offload: __u8,
        csum_complete_sw: __u8,
        csum_level: __u8,
        inner_protocol_type: __u8,
        l4_hash: __u8,
        sw_hash: __u8,
        wifi_acked_valid: __u8,
        wifi_acked: __u8,
        no_fcs: __u8,
        encapsulation: __u8,
        encap_hdr_csum: __u8,
        csum_valid: __u8,
        ndisc_nodetype: __u8,
        ipvs_property: __u8,
        nf_trace: __u8,
        offload_fwd_mark: __u8,
        offload_l3_fwd_mark: __u8,
        redirected: __u8,
        from_ingress: __u8,
        nf_skip_egress: __u8,
        decrypted: __u8,
        slow_gro: __u8,
        csum_not_inet: __u8,
        unreadable: __u8,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 2u8, {
            let tstamp_type: u8 = unsafe { ::core::mem::transmute(tstamp_type) };
            tstamp_type as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let tc_at_ingress: u8 = unsafe { ::core::mem::transmute(tc_at_ingress) };
            tc_at_ingress as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let tc_skip_classify: u8 = unsafe { ::core::mem::transmute(tc_skip_classify) };
            tc_skip_classify as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let remcsum_offload: u8 = unsafe { ::core::mem::transmute(remcsum_offload) };
            remcsum_offload as u64
        });
        __bindgen_bitfield_unit.set(5usize, 1u8, {
            let csum_complete_sw: u8 = unsafe { ::core::mem::transmute(csum_complete_sw) };
            csum_complete_sw as u64
        });
        __bindgen_bitfield_unit.set(6usize, 2u8, {
            let csum_level: u8 = unsafe { ::core::mem::transmute(csum_level) };
            csum_level as u64
        });
        __bindgen_bitfield_unit.set(8usize, 1u8, {
            let inner_protocol_type: u8 = unsafe { ::core::mem::transmute(inner_protocol_type) };
            inner_protocol_type as u64
        });
        __bindgen_bitfield_unit.set(9usize, 1u8, {
            let l4_hash: u8 = unsafe { ::core::mem::transmute(l4_hash) };
            l4_hash as u64
        });
        __bindgen_bitfield_unit.set(10usize, 1u8, {
            let sw_hash: u8 = unsafe { ::core::mem::transmute(sw_hash) };
            sw_hash as u64
        });
        __bindgen_bitfield_unit.set(11usize, 1u8, {
            let wifi_acked_valid: u8 = unsafe { ::core::mem::transmute(wifi_acked_valid) };
            wifi_acked_valid as u64
        });
        __bindgen_bitfield_unit.set(12usize, 1u8, {
            let wifi_acked: u8 = unsafe { ::core::mem::transmute(wifi_acked) };
            wifi_acked as u64
        });
        __bindgen_bitfield_unit.set(13usize, 1u8, {
            let no_fcs: u8 = unsafe { ::core::mem::transmute(no_fcs) };
            no_fcs as u64
        });
        __bindgen_bitfield_unit.set(14usize, 1u8, {
            let encapsulation: u8 = unsafe { ::core::mem::transmute(encapsulation) };
            encapsulation as u64
        });
        __bindgen_bitfield_unit.set(15usize, 1u8, {
            let encap_hdr_csum: u8 = unsafe { ::core::mem::transmute(encap_hdr_csum) };
            encap_hdr_csum as u64
        });
        __bindgen_bitfield_unit.set(16usize, 1u8, {
            let csum_valid: u8 = unsafe { ::core::mem::transmute(csum_valid) };
            csum_valid as u64
        });
        __bindgen_bitfield_unit.set(17usize, 2u8, {
            let ndisc_nodetype: u8 = unsafe { ::core::mem::transmute(ndisc_nodetype) };
            ndisc_nodetype as u64
        });
        __bindgen_bitfield_unit.set(19usize, 1u8, {
            let ipvs_property: u8 = unsafe { ::core::mem::transmute(ipvs_property) };
            ipvs_property as u64
        });
        __bindgen_bitfield_unit.set(20usize, 1u8, {
            let nf_trace: u8 = unsafe { ::core::mem::transmute(nf_trace) };
            nf_trace as u64
        });
        __bindgen_bitfield_unit.set(21usize, 1u8, {
            let offload_fwd_mark: u8 = unsafe { ::core::mem::transmute(offload_fwd_mark) };
            offload_fwd_mark as u64
        });
        __bindgen_bitfield_unit.set(22usize, 1u8, {
            let offload_l3_fwd_mark: u8 = unsafe { ::core::mem::transmute(offload_l3_fwd_mark) };
            offload_l3_fwd_mark as u64
        });
        __bindgen_bitfield_unit.set(23usize, 1u8, {
            let redirected: u8 = unsafe { ::core::mem::transmute(redirected) };
            redirected as u64
        });
        __bindgen_bitfield_unit.set(24usize, 1u8, {
            let from_ingress: u8 = unsafe { ::core::mem::transmute(from_ingress) };
            from_ingress as u64
        });
        __bindgen_bitfield_unit.set(25usize, 1u8, {
            let nf_skip_egress: u8 = unsafe { ::core::mem::transmute(nf_skip_egress) };
            nf_skip_egress as u64
        });
        __bindgen_bitfield_unit.set(26usize, 1u8, {
            let decrypted: u8 = unsafe { ::core::mem::transmute(decrypted) };
            decrypted as u64
        });
        __bindgen_bitfield_unit.set(27usize, 1u8, {
            let slow_gro: u8 = unsafe { ::core::mem::transmute(slow_gro) };
            slow_gro as u64
        });
        __bindgen_bitfield_unit.set(28usize, 1u8, {
            let csum_not_inet: u8 = unsafe { ::core::mem::transmute(csum_not_inet) };
            csum_not_inet as u64
        });
        __bindgen_bitfield_unit.set(29usize, 1u8, {
            let unreadable: u8 = unsafe { ::core::mem::transmute(unreadable) };
            unreadable as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
pub struct sk_buff__bindgen_ty_4__bindgen_ty_2 {
    pub __pkt_type_offset: __IncompleteArrayField<__u8>,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub __mono_tc_offset: __IncompleteArrayField<__u8>,
    pub _bitfield_align_2: [u8; 0],
    pub _bitfield_2: __BindgenBitfieldUnit<[u8; 4usize]>,
    pub tc_index: __u16,
    pub alloc_cpu: u16_,
    pub __bindgen_anon_1: sk_buff__bindgen_ty_4__bindgen_ty_2__bindgen_ty_1,
    pub priority: __u32,
    pub skb_iif: ffi::c_int,
    pub hash: __u32,
    pub __bindgen_anon_2: sk_buff__bindgen_ty_4__bindgen_ty_2__bindgen_ty_2,
    pub __bindgen_anon_3: sk_buff__bindgen_ty_4__bindgen_ty_2__bindgen_ty_3,
    pub secmark: __u32,
    pub __bindgen_anon_4: sk_buff__bindgen_ty_4__bindgen_ty_2__bindgen_ty_4,
    pub __bindgen_anon_5: sk_buff__bindgen_ty_4__bindgen_ty_2__bindgen_ty_5,
    pub inner_transport_header: __u16,
    pub inner_network_header: __u16,
    pub inner_mac_header: __u16,
    pub protocol: __be16,
    pub transport_header: __u16,
    pub network_header: __u16,
    pub mac_header: __u16,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sk_buff__bindgen_ty_4__bindgen_ty_2__bindgen_ty_1 {
    pub csum: __wsum,
    pub __bindgen_anon_1: sk_buff__bindgen_ty_4__bindgen_ty_2__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sk_buff__bindgen_ty_4__bindgen_ty_2__bindgen_ty_1__bindgen_ty_1 {
    pub csum_start: __u16,
    pub csum_offset: __u16,
}
impl Default for sk_buff__bindgen_ty_4__bindgen_ty_2__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sk_buff__bindgen_ty_4__bindgen_ty_2__bindgen_ty_2 {
    pub vlan_all: u32_,
    pub __bindgen_anon_1: sk_buff__bindgen_ty_4__bindgen_ty_2__bindgen_ty_2__bindgen_ty_1,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sk_buff__bindgen_ty_4__bindgen_ty_2__bindgen_ty_2__bindgen_ty_1 {
    pub vlan_proto: __be16,
    pub vlan_tci: __u16,
}
impl Default for sk_buff__bindgen_ty_4__bindgen_ty_2__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sk_buff__bindgen_ty_4__bindgen_ty_2__bindgen_ty_3 {
    pub napi_id: ffi::c_uint,
    pub sender_cpu: ffi::c_uint,
}
impl Default for sk_buff__bindgen_ty_4__bindgen_ty_2__bindgen_ty_3 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sk_buff__bindgen_ty_4__bindgen_ty_2__bindgen_ty_4 {
    pub mark: __u32,
    pub reserved_tailroom: __u32,
}
impl Default for sk_buff__bindgen_ty_4__bindgen_ty_2__bindgen_ty_4 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sk_buff__bindgen_ty_4__bindgen_ty_2__bindgen_ty_5 {
    pub inner_protocol: __be16,
    pub inner_ipproto: __u8,
}
impl Default for sk_buff__bindgen_ty_4__bindgen_ty_2__bindgen_ty_5 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for sk_buff__bindgen_ty_4__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl sk_buff__bindgen_ty_4__bindgen_ty_2 {
    #[inline]
    pub fn pkt_type(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 3u8) as u8) }
    }
    #[inline]
    pub fn set_pkt_type(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 3u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn pkt_type_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                3u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_pkt_type_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                3u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ignore_df(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_ignore_df(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ignore_df_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_ignore_df_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn dst_pending_confirm(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_dst_pending_confirm(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn dst_pending_confirm_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_dst_pending_confirm_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ip_summed(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(5usize, 2u8) as u8) }
    }
    #[inline]
    pub fn set_ip_summed(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(5usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ip_summed_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                2u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_ip_summed_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ooo_okay(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_ooo_okay(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(7usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ooo_okay_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                7usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_ooo_okay_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                7usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        pkt_type: __u8,
        ignore_df: __u8,
        dst_pending_confirm: __u8,
        ip_summed: __u8,
        ooo_okay: __u8,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 3u8, {
            let pkt_type: u8 = unsafe { ::core::mem::transmute(pkt_type) };
            pkt_type as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let ignore_df: u8 = unsafe { ::core::mem::transmute(ignore_df) };
            ignore_df as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let dst_pending_confirm: u8 = unsafe { ::core::mem::transmute(dst_pending_confirm) };
            dst_pending_confirm as u64
        });
        __bindgen_bitfield_unit.set(5usize, 2u8, {
            let ip_summed: u8 = unsafe { ::core::mem::transmute(ip_summed) };
            ip_summed as u64
        });
        __bindgen_bitfield_unit.set(7usize, 1u8, {
            let ooo_okay: u8 = unsafe { ::core::mem::transmute(ooo_okay) };
            ooo_okay as u64
        });
        __bindgen_bitfield_unit
    }
    #[inline]
    pub fn tstamp_type(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(0usize, 2u8) as u8) }
    }
    #[inline]
    pub fn set_tstamp_type(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(0usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn tstamp_type_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                0usize,
                2u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_tstamp_type_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                0usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn tc_at_ingress(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(2usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_tc_at_ingress(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn tc_at_ingress_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                2usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_tc_at_ingress_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn tc_skip_classify(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(3usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_tc_skip_classify(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn tc_skip_classify_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                3usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_tc_skip_classify_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn remcsum_offload(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(4usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_remcsum_offload(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn remcsum_offload_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                4usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_remcsum_offload_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn csum_complete_sw(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(5usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_csum_complete_sw(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(5usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn csum_complete_sw_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                5usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_csum_complete_sw_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                5usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn csum_level(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(6usize, 2u8) as u8) }
    }
    #[inline]
    pub fn set_csum_level(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(6usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn csum_level_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                6usize,
                2u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_csum_level_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                6usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn inner_protocol_type(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(8usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_inner_protocol_type(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(8usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn inner_protocol_type_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                8usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_inner_protocol_type_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                8usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn l4_hash(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(9usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_l4_hash(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(9usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn l4_hash_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                9usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_l4_hash_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                9usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn sw_hash(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(10usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_sw_hash(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(10usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn sw_hash_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                10usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_sw_hash_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                10usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn wifi_acked_valid(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(11usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_wifi_acked_valid(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(11usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn wifi_acked_valid_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                11usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_wifi_acked_valid_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                11usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn wifi_acked(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(12usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_wifi_acked(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(12usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn wifi_acked_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                12usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_wifi_acked_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                12usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn no_fcs(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(13usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_no_fcs(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(13usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn no_fcs_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                13usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_no_fcs_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                13usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn encapsulation(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(14usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_encapsulation(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(14usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn encapsulation_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                14usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_encapsulation_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                14usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn encap_hdr_csum(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(15usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_encap_hdr_csum(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(15usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn encap_hdr_csum_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                15usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_encap_hdr_csum_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                15usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn csum_valid(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(16usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_csum_valid(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(16usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn csum_valid_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                16usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_csum_valid_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                16usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ndisc_nodetype(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(17usize, 2u8) as u8) }
    }
    #[inline]
    pub fn set_ndisc_nodetype(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(17usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ndisc_nodetype_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                17usize,
                2u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_ndisc_nodetype_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                17usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ipvs_property(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(19usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_ipvs_property(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(19usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ipvs_property_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                19usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_ipvs_property_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                19usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn nf_trace(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(20usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_nf_trace(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(20usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn nf_trace_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                20usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_nf_trace_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                20usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn offload_fwd_mark(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(21usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_offload_fwd_mark(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(21usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn offload_fwd_mark_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                21usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_offload_fwd_mark_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                21usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn offload_l3_fwd_mark(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(22usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_offload_l3_fwd_mark(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(22usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn offload_l3_fwd_mark_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                22usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_offload_l3_fwd_mark_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                22usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn redirected(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(23usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_redirected(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(23usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn redirected_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                23usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_redirected_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                23usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn from_ingress(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(24usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_from_ingress(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(24usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn from_ingress_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                24usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_from_ingress_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                24usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn nf_skip_egress(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(25usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_nf_skip_egress(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(25usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn nf_skip_egress_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                25usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_nf_skip_egress_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                25usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn decrypted(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(26usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_decrypted(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(26usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn decrypted_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                26usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_decrypted_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                26usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn slow_gro(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(27usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_slow_gro(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(27usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn slow_gro_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                27usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_slow_gro_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                27usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn csum_not_inet(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(28usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_csum_not_inet(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(28usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn csum_not_inet_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                28usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_csum_not_inet_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                28usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn unreadable(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(29usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_unreadable(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_2.set(29usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn unreadable_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                29usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_unreadable_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                29usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_2(
        tstamp_type: __u8,
        tc_at_ingress: __u8,
        tc_skip_classify: __u8,
        remcsum_offload: __u8,
        csum_complete_sw: __u8,
        csum_level: __u8,
        inner_protocol_type: __u8,
        l4_hash: __u8,
        sw_hash: __u8,
        wifi_acked_valid: __u8,
        wifi_acked: __u8,
        no_fcs: __u8,
        encapsulation: __u8,
        encap_hdr_csum: __u8,
        csum_valid: __u8,
        ndisc_nodetype: __u8,
        ipvs_property: __u8,
        nf_trace: __u8,
        offload_fwd_mark: __u8,
        offload_l3_fwd_mark: __u8,
        redirected: __u8,
        from_ingress: __u8,
        nf_skip_egress: __u8,
        decrypted: __u8,
        slow_gro: __u8,
        csum_not_inet: __u8,
        unreadable: __u8,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 2u8, {
            let tstamp_type: u8 = unsafe { ::core::mem::transmute(tstamp_type) };
            tstamp_type as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let tc_at_ingress: u8 = unsafe { ::core::mem::transmute(tc_at_ingress) };
            tc_at_ingress as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let tc_skip_classify: u8 = unsafe { ::core::mem::transmute(tc_skip_classify) };
            tc_skip_classify as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let remcsum_offload: u8 = unsafe { ::core::mem::transmute(remcsum_offload) };
            remcsum_offload as u64
        });
        __bindgen_bitfield_unit.set(5usize, 1u8, {
            let csum_complete_sw: u8 = unsafe { ::core::mem::transmute(csum_complete_sw) };
            csum_complete_sw as u64
        });
        __bindgen_bitfield_unit.set(6usize, 2u8, {
            let csum_level: u8 = unsafe { ::core::mem::transmute(csum_level) };
            csum_level as u64
        });
        __bindgen_bitfield_unit.set(8usize, 1u8, {
            let inner_protocol_type: u8 = unsafe { ::core::mem::transmute(inner_protocol_type) };
            inner_protocol_type as u64
        });
        __bindgen_bitfield_unit.set(9usize, 1u8, {
            let l4_hash: u8 = unsafe { ::core::mem::transmute(l4_hash) };
            l4_hash as u64
        });
        __bindgen_bitfield_unit.set(10usize, 1u8, {
            let sw_hash: u8 = unsafe { ::core::mem::transmute(sw_hash) };
            sw_hash as u64
        });
        __bindgen_bitfield_unit.set(11usize, 1u8, {
            let wifi_acked_valid: u8 = unsafe { ::core::mem::transmute(wifi_acked_valid) };
            wifi_acked_valid as u64
        });
        __bindgen_bitfield_unit.set(12usize, 1u8, {
            let wifi_acked: u8 = unsafe { ::core::mem::transmute(wifi_acked) };
            wifi_acked as u64
        });
        __bindgen_bitfield_unit.set(13usize, 1u8, {
            let no_fcs: u8 = unsafe { ::core::mem::transmute(no_fcs) };
            no_fcs as u64
        });
        __bindgen_bitfield_unit.set(14usize, 1u8, {
            let encapsulation: u8 = unsafe { ::core::mem::transmute(encapsulation) };
            encapsulation as u64
        });
        __bindgen_bitfield_unit.set(15usize, 1u8, {
            let encap_hdr_csum: u8 = unsafe { ::core::mem::transmute(encap_hdr_csum) };
            encap_hdr_csum as u64
        });
        __bindgen_bitfield_unit.set(16usize, 1u8, {
            let csum_valid: u8 = unsafe { ::core::mem::transmute(csum_valid) };
            csum_valid as u64
        });
        __bindgen_bitfield_unit.set(17usize, 2u8, {
            let ndisc_nodetype: u8 = unsafe { ::core::mem::transmute(ndisc_nodetype) };
            ndisc_nodetype as u64
        });
        __bindgen_bitfield_unit.set(19usize, 1u8, {
            let ipvs_property: u8 = unsafe { ::core::mem::transmute(ipvs_property) };
            ipvs_property as u64
        });
        __bindgen_bitfield_unit.set(20usize, 1u8, {
            let nf_trace: u8 = unsafe { ::core::mem::transmute(nf_trace) };
            nf_trace as u64
        });
        __bindgen_bitfield_unit.set(21usize, 1u8, {
            let offload_fwd_mark: u8 = unsafe { ::core::mem::transmute(offload_fwd_mark) };
            offload_fwd_mark as u64
        });
        __bindgen_bitfield_unit.set(22usize, 1u8, {
            let offload_l3_fwd_mark: u8 = unsafe { ::core::mem::transmute(offload_l3_fwd_mark) };
            offload_l3_fwd_mark as u64
        });
        __bindgen_bitfield_unit.set(23usize, 1u8, {
            let redirected: u8 = unsafe { ::core::mem::transmute(redirected) };
            redirected as u64
        });
        __bindgen_bitfield_unit.set(24usize, 1u8, {
            let from_ingress: u8 = unsafe { ::core::mem::transmute(from_ingress) };
            from_ingress as u64
        });
        __bindgen_bitfield_unit.set(25usize, 1u8, {
            let nf_skip_egress: u8 = unsafe { ::core::mem::transmute(nf_skip_egress) };
            nf_skip_egress as u64
        });
        __bindgen_bitfield_unit.set(26usize, 1u8, {
            let decrypted: u8 = unsafe { ::core::mem::transmute(decrypted) };
            decrypted as u64
        });
        __bindgen_bitfield_unit.set(27usize, 1u8, {
            let slow_gro: u8 = unsafe { ::core::mem::transmute(slow_gro) };
            slow_gro as u64
        });
        __bindgen_bitfield_unit.set(28usize, 1u8, {
            let csum_not_inet: u8 = unsafe { ::core::mem::transmute(csum_not_inet) };
            csum_not_inet as u64
        });
        __bindgen_bitfield_unit.set(29usize, 1u8, {
            let unreadable: u8 = unsafe { ::core::mem::transmute(unreadable) };
            unreadable as u64
        });
        __bindgen_bitfield_unit
    }
}
impl Default for sk_buff__bindgen_ty_4 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for sk_buff {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl sk_buff {
    #[inline]
    pub fn cloned(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_cloned(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn cloned_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_cloned_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn nohdr(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_nohdr(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn nohdr_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_nohdr_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fclone(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(2usize, 2u8) as u8) }
    }
    #[inline]
    pub fn set_fclone(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(2usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fclone_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                2u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_fclone_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn peeked(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_peeked(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn peeked_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_peeked_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn head_frag(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_head_frag(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(5usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn head_frag_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_head_frag_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn pfmemalloc(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_pfmemalloc(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(6usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn pfmemalloc_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                6usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_pfmemalloc_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                6usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn pp_recycle(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_pp_recycle(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(7usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn pp_recycle_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                7usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_pp_recycle_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                7usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        cloned: __u8,
        nohdr: __u8,
        fclone: __u8,
        peeked: __u8,
        head_frag: __u8,
        pfmemalloc: __u8,
        pp_recycle: __u8,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let cloned: u8 = unsafe { ::core::mem::transmute(cloned) };
            cloned as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let nohdr: u8 = unsafe { ::core::mem::transmute(nohdr) };
            nohdr as u64
        });
        __bindgen_bitfield_unit.set(2usize, 2u8, {
            let fclone: u8 = unsafe { ::core::mem::transmute(fclone) };
            fclone as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let peeked: u8 = unsafe { ::core::mem::transmute(peeked) };
            peeked as u64
        });
        __bindgen_bitfield_unit.set(5usize, 1u8, {
            let head_frag: u8 = unsafe { ::core::mem::transmute(head_frag) };
            head_frag as u64
        });
        __bindgen_bitfield_unit.set(6usize, 1u8, {
            let pfmemalloc: u8 = unsafe { ::core::mem::transmute(pfmemalloc) };
            pfmemalloc as u64
        });
        __bindgen_bitfield_unit.set(7usize, 1u8, {
            let pp_recycle: u8 = unsafe { ::core::mem::transmute(pp_recycle) };
            pp_recycle as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct dst_entry {
    _unused: [u8; 0],
}
extern "C" {
    pub fn sk_skb_reason_drop(sk: *mut sock, skb: *mut sk_buff, reason: skb_drop_reason);
}
extern "C" {
    pub fn skb_release_head_state(skb: *mut sk_buff);
}
extern "C" {
    pub fn kfree_skb_list_reason(segs: *mut sk_buff, reason: skb_drop_reason);
}
extern "C" {
    pub fn skb_dump(level: *const ffi::c_char, skb: *const sk_buff, full_pkt: bool_);
}
extern "C" {
    pub fn skb_tx_error(skb: *mut sk_buff);
}
extern "C" {
    pub fn consume_skb(skb: *mut sk_buff);
}
extern "C" {
    pub fn __consume_stateless_skb(skb: *mut sk_buff);
}
extern "C" {
    pub fn __kfree_skb(skb: *mut sk_buff);
}
extern "C" {
    pub fn kfree_skb_partial(skb: *mut sk_buff, head_stolen: bool_);
}
extern "C" {
    pub fn skb_try_coalesce(
        to: *mut sk_buff,
        from: *mut sk_buff,
        fragstolen: *mut bool_,
        delta_truesize: *mut ffi::c_int,
    ) -> bool_;
}
extern "C" {
    pub fn __alloc_skb(
        size: ffi::c_uint,
        priority: gfp_t,
        flags: ffi::c_int,
        node: ffi::c_int,
    ) -> *mut sk_buff;
}
extern "C" {
    pub fn __build_skb(data: *mut ffi::c_void, frag_size: ffi::c_uint) -> *mut sk_buff;
}
extern "C" {
    pub fn build_skb(data: *mut ffi::c_void, frag_size: ffi::c_uint) -> *mut sk_buff;
}
extern "C" {
    pub fn build_skb_around(
        skb: *mut sk_buff,
        data: *mut ffi::c_void,
        frag_size: ffi::c_uint,
    ) -> *mut sk_buff;
}
extern "C" {
    pub fn skb_attempt_defer_free(skb: *mut sk_buff);
}
extern "C" {
    pub fn napi_skb_cache_get_bulk(skbs: *mut *mut ffi::c_void, n: u32_) -> u32_;
}
extern "C" {
    pub fn napi_build_skb(data: *mut ffi::c_void, frag_size: ffi::c_uint) -> *mut sk_buff;
}
extern "C" {
    pub fn slab_build_skb(data: *mut ffi::c_void) -> *mut sk_buff;
}
extern "C" {
    pub fn alloc_skb_with_frags(
        header_len: ffi::c_ulong,
        data_len: ffi::c_ulong,
        max_page_order: ffi::c_int,
        errcode: *mut ffi::c_int,
        gfp_mask: gfp_t,
    ) -> *mut sk_buff;
}
extern "C" {
    pub fn alloc_skb_for_msg(first: *mut sk_buff) -> *mut sk_buff;
}
#[repr(C)]
pub struct sk_buff_fclones {
    pub skb1: sk_buff,
    pub skb2: sk_buff,
    pub fclone_ref: refcount_t,
}
impl Default for sk_buff_fclones {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn skb_morph(dst: *mut sk_buff, src: *mut sk_buff) -> *mut sk_buff;
}
extern "C" {
    pub fn skb_headers_offset_update(skb: *mut sk_buff, off: ffi::c_int);
}
extern "C" {
    pub fn skb_copy_ubufs(skb: *mut sk_buff, gfp_mask: gfp_t) -> ffi::c_int;
}
extern "C" {
    pub fn skb_clone(skb: *mut sk_buff, priority: gfp_t) -> *mut sk_buff;
}
extern "C" {
    pub fn skb_copy_header(new: *mut sk_buff, old: *const sk_buff);
}
extern "C" {
    pub fn skb_copy(skb: *const sk_buff, priority: gfp_t) -> *mut sk_buff;
}
extern "C" {
    pub fn __pskb_copy_fclone(
        skb: *mut sk_buff,
        headroom: ffi::c_int,
        gfp_mask: gfp_t,
        fclone: bool_,
    ) -> *mut sk_buff;
}
extern "C" {
    pub fn pskb_expand_head(
        skb: *mut sk_buff,
        nhead: ffi::c_int,
        ntail: ffi::c_int,
        gfp_mask: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn skb_realloc_headroom(skb: *mut sk_buff, headroom: ffi::c_uint) -> *mut sk_buff;
}
extern "C" {
    pub fn skb_expand_head(skb: *mut sk_buff, headroom: ffi::c_uint) -> *mut sk_buff;
}
extern "C" {
    pub fn skb_copy_expand(
        skb: *const sk_buff,
        newheadroom: ffi::c_int,
        newtailroom: ffi::c_int,
        priority: gfp_t,
    ) -> *mut sk_buff;
}
extern "C" {
    #[must_use]
    pub fn skb_to_sgvec_nomark(
        skb: *mut sk_buff,
        sg: *mut scatterlist,
        offset: ffi::c_int,
        len: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn skb_to_sgvec(
        skb: *mut sk_buff,
        sg: *mut scatterlist,
        offset: ffi::c_int,
        len: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn skb_cow_data(
        skb: *mut sk_buff,
        tailbits: ffi::c_int,
        trailer: *mut *mut sk_buff,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __skb_pad(skb: *mut sk_buff, pad: ffi::c_int, free_on_error: bool_) -> ffi::c_int;
}
extern "C" {
    pub fn skb_append_pagefrags(
        skb: *mut sk_buff,
        page: *mut page,
        offset: ffi::c_int,
        size: usize,
        max_frags: usize,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct skb_seq_state {
    pub lower_offset: __u32,
    pub upper_offset: __u32,
    pub frag_idx: __u32,
    pub stepped_offset: __u32,
    pub root_skb: *mut sk_buff,
    pub cur_skb: *mut sk_buff,
    pub frag_data: *mut __u8,
    pub frag_off: __u32,
}
impl Default for skb_seq_state {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn skb_prepare_seq_read(
        skb: *mut sk_buff,
        from: ffi::c_uint,
        to: ffi::c_uint,
        st: *mut skb_seq_state,
    );
}
extern "C" {
    pub fn skb_seq_read(
        consumed: ffi::c_uint,
        data: *mut *const u8_,
        st: *mut skb_seq_state,
    ) -> ffi::c_uint;
}
extern "C" {
    pub fn skb_abort_seq_read(st: *mut skb_seq_state);
}
extern "C" {
    pub fn skb_copy_seq_read(
        st: *mut skb_seq_state,
        offset: ffi::c_int,
        to: *mut ffi::c_void,
        len: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn skb_find_text(
        skb: *mut sk_buff,
        from: ffi::c_uint,
        to: ffi::c_uint,
        config: *mut ts_config,
    ) -> ffi::c_uint;
}
pub const pkt_hash_types_PKT_HASH_TYPE_NONE: pkt_hash_types = 0;
pub const pkt_hash_types_PKT_HASH_TYPE_L2: pkt_hash_types = 1;
pub const pkt_hash_types_PKT_HASH_TYPE_L3: pkt_hash_types = 2;
pub const pkt_hash_types_PKT_HASH_TYPE_L4: pkt_hash_types = 3;
pub type pkt_hash_types = ffi::c_uint;
extern "C" {
    pub fn __skb_get_hash_symmetric_net(net: *const net, skb: *const sk_buff) -> u32_;
}
extern "C" {
    pub fn __skb_get_hash_net(net: *const net, skb: *mut sk_buff);
}
extern "C" {
    pub fn skb_get_poff(skb: *const sk_buff) -> u32_;
}
extern "C" {
    pub fn __skb_get_poff(
        skb: *const sk_buff,
        data: *const ffi::c_void,
        keys: *const flow_keys_basic,
        hlen: ffi::c_int,
    ) -> u32_;
}
extern "C" {
    pub fn skb_flow_get_ports(
        skb: *const sk_buff,
        thoff: ffi::c_int,
        ip_proto: u8_,
        data: *const ffi::c_void,
        hlen_proto: ffi::c_int,
    ) -> __be32;
}
extern "C" {
    pub fn skb_flow_dissector_init(
        flow_dissector: *mut flow_dissector,
        key: *const flow_dissector_key,
        key_count: ffi::c_uint,
    );
}
extern "C" {
    pub fn bpf_flow_dissect(
        prog: *mut bpf_prog,
        ctx: *mut bpf_flow_dissector,
        proto: __be16,
        nhoff: ffi::c_int,
        hlen: ffi::c_int,
        flags: ffi::c_uint,
    ) -> u32_;
}
extern "C" {
    pub fn __skb_flow_dissect(
        net: *const net,
        skb: *const sk_buff,
        flow_dissector: *mut flow_dissector,
        target_container: *mut ffi::c_void,
        data: *const ffi::c_void,
        proto: __be16,
        nhoff: ffi::c_int,
        hlen: ffi::c_int,
        flags: ffi::c_uint,
    ) -> bool_;
}
extern "C" {
    pub fn skb_flow_dissect_meta(
        skb: *const sk_buff,
        flow_dissector: *mut flow_dissector,
        target_container: *mut ffi::c_void,
    );
}
extern "C" {
    pub fn skb_flow_dissect_ct(
        skb: *const sk_buff,
        flow_dissector: *mut flow_dissector,
        target_container: *mut ffi::c_void,
        ctinfo_map: *mut u16_,
        mapsize: usize,
        post_ct: bool_,
        zone: u16_,
    );
}
extern "C" {
    pub fn skb_flow_dissect_tunnel_info(
        skb: *const sk_buff,
        flow_dissector: *mut flow_dissector,
        target_container: *mut ffi::c_void,
    );
}
extern "C" {
    pub fn skb_flow_dissect_hash(
        skb: *const sk_buff,
        flow_dissector: *mut flow_dissector,
        target_container: *mut ffi::c_void,
    );
}
extern "C" {
    pub fn skb_get_hash_perturb(skb: *const sk_buff, perturb: *const siphash_key_t) -> __u32;
}
extern "C" {
    pub static msg_zerocopy_ubuf_ops: ubuf_info_ops;
}
extern "C" {
    pub fn msg_zerocopy_realloc(sk: *mut sock, size: usize, uarg: *mut ubuf_info)
        -> *mut ubuf_info;
}
extern "C" {
    pub fn msg_zerocopy_put_abort(uarg: *mut ubuf_info, have_uref: bool_);
}
extern "C" {
    pub fn __zerocopy_sg_from_iter(
        msg: *mut msghdr,
        sk: *mut sock,
        skb: *mut sk_buff,
        from: *mut iov_iter,
        length: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn zerocopy_fill_skb_from_iter(
        skb: *mut sk_buff,
        from: *mut iov_iter,
        length: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn skb_zerocopy_iter_stream(
        sk: *mut sock,
        skb: *mut sk_buff,
        msg: *mut msghdr,
        len: ffi::c_int,
        uarg: *mut ubuf_info,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __skb_zcopy_downgrade_managed(skb: *mut sk_buff);
}
extern "C" {
    pub fn __skb_unclone_keeptruesize(skb: *mut sk_buff, pri: gfp_t) -> ffi::c_int;
}
extern "C" {
    pub fn skb_append(old: *mut sk_buff, newsk: *mut sk_buff, list: *mut sk_buff_head);
}
extern "C" {
    pub fn skb_queue_head(list: *mut sk_buff_head, newsk: *mut sk_buff);
}
extern "C" {
    pub fn skb_queue_tail(list: *mut sk_buff_head, newsk: *mut sk_buff);
}
extern "C" {
    pub fn skb_unlink(skb: *mut sk_buff, list: *mut sk_buff_head);
}
extern "C" {
    pub fn skb_dequeue(list: *mut sk_buff_head) -> *mut sk_buff;
}
extern "C" {
    pub fn skb_dequeue_tail(list: *mut sk_buff_head) -> *mut sk_buff;
}
extern "C" {
    pub fn skb_add_rx_frag_netmem(
        skb: *mut sk_buff,
        i: ffi::c_int,
        netmem: netmem_ref,
        off: ffi::c_int,
        size: ffi::c_int,
        truesize: ffi::c_uint,
    );
}
extern "C" {
    pub fn skb_coalesce_rx_frag(
        skb: *mut sk_buff,
        i: ffi::c_int,
        size: ffi::c_int,
        truesize: ffi::c_uint,
    );
}
extern "C" {
    pub fn pskb_put(skb: *mut sk_buff, tail: *mut sk_buff, len: ffi::c_int) -> *mut ffi::c_void;
}
extern "C" {
    pub fn skb_put(skb: *mut sk_buff, len: ffi::c_uint) -> *mut ffi::c_void;
}
extern "C" {
    pub fn skb_push(skb: *mut sk_buff, len: ffi::c_uint) -> *mut ffi::c_void;
}
extern "C" {
    pub fn skb_pull(skb: *mut sk_buff, len: ffi::c_uint) -> *mut ffi::c_void;
}
extern "C" {
    pub fn skb_pull_data(skb: *mut sk_buff, len: usize) -> *mut ffi::c_void;
}
extern "C" {
    pub fn __pskb_pull_tail(skb: *mut sk_buff, delta: ffi::c_int) -> *mut ffi::c_void;
}
extern "C" {
    pub fn skb_condense(skb: *mut sk_buff);
}
extern "C" {
    pub fn ___pskb_trim(skb: *mut sk_buff, len: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn skb_trim(skb: *mut sk_buff, len: ffi::c_uint);
}
extern "C" {
    pub fn skb_queue_purge_reason(list: *mut sk_buff_head, reason: skb_drop_reason);
}
extern "C" {
    pub fn skb_rbtree_purge(root: *mut rb_root) -> ffi::c_uint;
}
extern "C" {
    pub fn skb_errqueue_purge(list: *mut sk_buff_head);
}
extern "C" {
    pub fn __netdev_alloc_frag_align(
        fragsz: ffi::c_uint,
        align_mask: ffi::c_uint,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn __netdev_alloc_skb(
        dev: *mut net_device,
        length: ffi::c_uint,
        gfp_mask: gfp_t,
    ) -> *mut sk_buff;
}
extern "C" {
    pub fn __napi_alloc_frag_align(
        fragsz: ffi::c_uint,
        align_mask: ffi::c_uint,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn napi_alloc_skb(napi: *mut napi_struct, length: ffi::c_uint) -> *mut sk_buff;
}
extern "C" {
    pub fn napi_consume_skb(skb: *mut sk_buff, budget: ffi::c_int);
}
extern "C" {
    pub fn napi_skb_free_stolen_head(skb: *mut sk_buff);
}
extern "C" {
    pub fn __napi_kfree_skb(skb: *mut sk_buff, reason: skb_drop_reason);
}
extern "C" {
    pub fn skb_pp_cow_data(
        pool: *mut page_pool,
        pskb: *mut *mut sk_buff,
        headroom: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn skb_cow_data_for_xdp(
        pool: *mut page_pool,
        pskb: *mut *mut sk_buff,
        prog: *const bpf_prog,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn skb_page_frag_refill(sz: ffi::c_uint, pfrag: *mut page_frag, prio: gfp_t) -> bool_;
}
extern "C" {
    #[must_use]
    pub fn csum_and_copy_from_iter_full(
        addr: *mut ffi::c_void,
        bytes: usize,
        csum: *mut __wsum,
        i: *mut iov_iter,
    ) -> bool_;
}
extern "C" {
    pub fn skb_pull_rcsum(skb: *mut sk_buff, len: ffi::c_uint) -> *mut ffi::c_void;
}
extern "C" {
    pub fn pskb_trim_rcsum_slow(skb: *mut sk_buff, len: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn __skb_wait_for_more_packets(
        sk: *mut sock,
        queue: *mut sk_buff_head,
        err: *mut ffi::c_int,
        timeo_p: *mut ffi::c_long,
        skb: *const sk_buff,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __skb_try_recv_from_queue(
        sk: *mut sock,
        queue: *mut sk_buff_head,
        flags: ffi::c_uint,
        off: *mut ffi::c_int,
        err: *mut ffi::c_int,
        last: *mut *mut sk_buff,
    ) -> *mut sk_buff;
}
extern "C" {
    pub fn __skb_try_recv_datagram(
        sk: *mut sock,
        queue: *mut sk_buff_head,
        flags: ffi::c_uint,
        off: *mut ffi::c_int,
        err: *mut ffi::c_int,
        last: *mut *mut sk_buff,
    ) -> *mut sk_buff;
}
extern "C" {
    pub fn __skb_recv_datagram(
        sk: *mut sock,
        sk_queue: *mut sk_buff_head,
        flags: ffi::c_uint,
        off: *mut ffi::c_int,
        err: *mut ffi::c_int,
    ) -> *mut sk_buff;
}
extern "C" {
    pub fn skb_recv_datagram(
        sk: *mut sock,
        flags: ffi::c_uint,
        err: *mut ffi::c_int,
    ) -> *mut sk_buff;
}
extern "C" {
    pub fn datagram_poll(
        file: *mut file,
        sock: *mut socket,
        wait: *mut poll_table_struct,
    ) -> __poll_t;
}
extern "C" {
    pub fn skb_copy_datagram_iter(
        from: *const sk_buff,
        offset: ffi::c_int,
        to: *mut iov_iter,
        size: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn skb_copy_and_csum_datagram_msg(
        skb: *mut sk_buff,
        hlen: ffi::c_int,
        msg: *mut msghdr,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn skb_copy_and_hash_datagram_iter(
        skb: *const sk_buff,
        offset: ffi::c_int,
        to: *mut iov_iter,
        len: ffi::c_int,
        hash: *mut ahash_request,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn skb_copy_datagram_from_iter(
        skb: *mut sk_buff,
        offset: ffi::c_int,
        from: *mut iov_iter,
        len: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn zerocopy_sg_from_iter(skb: *mut sk_buff, frm: *mut iov_iter) -> ffi::c_int;
}
extern "C" {
    pub fn skb_free_datagram(sk: *mut sock, skb: *mut sk_buff);
}
extern "C" {
    pub fn skb_kill_datagram(sk: *mut sock, skb: *mut sk_buff, flags: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn skb_copy_bits(
        skb: *const sk_buff,
        offset: ffi::c_int,
        to: *mut ffi::c_void,
        len: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn skb_store_bits(
        skb: *mut sk_buff,
        offset: ffi::c_int,
        from: *const ffi::c_void,
        len: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn skb_copy_and_csum_bits(
        skb: *const sk_buff,
        offset: ffi::c_int,
        to: *mut u8_,
        len: ffi::c_int,
    ) -> __wsum;
}
extern "C" {
    pub fn skb_splice_bits(
        skb: *mut sk_buff,
        sk: *mut sock,
        offset: ffi::c_uint,
        pipe: *mut pipe_inode_info,
        len: ffi::c_uint,
        flags: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn skb_send_sock_locked(
        sk: *mut sock,
        skb: *mut sk_buff,
        offset: ffi::c_int,
        len: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn skb_send_sock(
        sk: *mut sock,
        skb: *mut sk_buff,
        offset: ffi::c_int,
        len: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn skb_copy_and_csum_dev(skb: *const sk_buff, to: *mut u8_);
}
extern "C" {
    pub fn skb_zerocopy_headlen(from: *const sk_buff) -> ffi::c_uint;
}
extern "C" {
    pub fn skb_zerocopy(
        to: *mut sk_buff,
        from: *mut sk_buff,
        len: ffi::c_int,
        hlen: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn skb_split(skb: *mut sk_buff, skb1: *mut sk_buff, len: u32_);
}
extern "C" {
    pub fn skb_shift(tgt: *mut sk_buff, skb: *mut sk_buff, shiftlen: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn skb_scrub_packet(skb: *mut sk_buff, xnet: bool_);
}
extern "C" {
    pub fn skb_segment(skb: *mut sk_buff, features: netdev_features_t) -> *mut sk_buff;
}
extern "C" {
    pub fn skb_segment_list(
        skb: *mut sk_buff,
        features: netdev_features_t,
        offset: ffi::c_uint,
    ) -> *mut sk_buff;
}
extern "C" {
    pub fn skb_vlan_untag(skb: *mut sk_buff) -> *mut sk_buff;
}
extern "C" {
    pub fn skb_ensure_writable(skb: *mut sk_buff, write_len: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn skb_ensure_writable_head_tail(skb: *mut sk_buff, dev: *mut net_device) -> ffi::c_int;
}
extern "C" {
    pub fn __skb_vlan_pop(skb: *mut sk_buff, vlan_tci: *mut u16_) -> ffi::c_int;
}
extern "C" {
    pub fn skb_vlan_pop(skb: *mut sk_buff) -> ffi::c_int;
}
extern "C" {
    pub fn skb_vlan_push(skb: *mut sk_buff, vlan_proto: __be16, vlan_tci: u16_) -> ffi::c_int;
}
extern "C" {
    pub fn skb_eth_pop(skb: *mut sk_buff) -> ffi::c_int;
}
extern "C" {
    pub fn skb_eth_push(
        skb: *mut sk_buff,
        dst: *const ffi::c_uchar,
        src: *const ffi::c_uchar,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn skb_mpls_push(
        skb: *mut sk_buff,
        mpls_lse: __be32,
        mpls_proto: __be16,
        mac_len: ffi::c_int,
        ethernet: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn skb_mpls_pop(
        skb: *mut sk_buff,
        next_proto: __be16,
        mac_len: ffi::c_int,
        ethernet: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn skb_mpls_update_lse(skb: *mut sk_buff, mpls_lse: __be32) -> ffi::c_int;
}
extern "C" {
    pub fn skb_mpls_dec_ttl(skb: *mut sk_buff) -> ffi::c_int;
}
extern "C" {
    pub fn pskb_extract(
        skb: *mut sk_buff,
        off: ffi::c_int,
        to_copy: ffi::c_int,
        gfp: gfp_t,
    ) -> *mut sk_buff;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct skb_checksum_ops {
    pub update: ::core::option::Option<
        unsafe extern "C" fn(mem: *const ffi::c_void, len: ffi::c_int, wsum: __wsum) -> __wsum,
    >,
    pub combine: ::core::option::Option<
        unsafe extern "C" fn(
            csum: __wsum,
            csum2: __wsum,
            offset: ffi::c_int,
            len: ffi::c_int,
        ) -> __wsum,
    >,
}
extern "C" {
    pub static mut crc32c_csum_stub: *const skb_checksum_ops;
}
extern "C" {
    pub fn __skb_checksum(
        skb: *const sk_buff,
        offset: ffi::c_int,
        len: ffi::c_int,
        csum: __wsum,
        ops: *const skb_checksum_ops,
    ) -> __wsum;
}
extern "C" {
    pub fn skb_checksum(
        skb: *const sk_buff,
        offset: ffi::c_int,
        len: ffi::c_int,
        csum: __wsum,
    ) -> __wsum;
}
extern "C" {
    pub fn skb_init();
}
extern "C" {
    pub static mut netstamp_needed_key: static_key_false;
}
extern "C" {
    pub fn skb_clone_sk(skb: *mut sk_buff) -> *mut sk_buff;
}
extern "C" {
    pub fn skb_clone_tx_timestamp(skb: *mut sk_buff);
}
extern "C" {
    pub fn skb_defer_rx_timestamp(skb: *mut sk_buff) -> bool_;
}
extern "C" {
    pub fn skb_complete_tx_timestamp(skb: *mut sk_buff, hwtstamps: *mut skb_shared_hwtstamps);
}
extern "C" {
    pub fn __skb_tstamp_tx(
        orig_skb: *mut sk_buff,
        ack_skb: *const sk_buff,
        hwtstamps: *mut skb_shared_hwtstamps,
        sk: *mut sock,
        tstype: ffi::c_int,
    );
}
extern "C" {
    pub fn skb_tstamp_tx(orig_skb: *mut sk_buff, hwtstamps: *mut skb_shared_hwtstamps);
}
extern "C" {
    pub fn skb_complete_wifi_ack(skb: *mut sk_buff, acked: bool_);
}
extern "C" {
    pub fn __skb_checksum_complete_head(skb: *mut sk_buff, len: ffi::c_int) -> __sum16;
}
extern "C" {
    pub fn __skb_checksum_complete(skb: *mut sk_buff) -> __sum16;
}
pub const skb_ext_id_SKB_EXT_BRIDGE_NF: skb_ext_id = 0;
pub const skb_ext_id_SKB_EXT_SEC_PATH: skb_ext_id = 1;
pub const skb_ext_id_TC_SKB_EXT: skb_ext_id = 2;
pub const skb_ext_id_SKB_EXT_MPTCP: skb_ext_id = 3;
pub const skb_ext_id_SKB_EXT_NUM: skb_ext_id = 4;
pub type skb_ext_id = ffi::c_uint;
#[repr(C)]
#[repr(align(8))]
#[derive(Default)]
pub struct skb_ext {
    pub refcnt: refcount_t,
    pub offset: [u8_; 4usize],
    pub chunks: u8_,
    pub __bindgen_padding_0: [u8; 7usize],
    pub data: __IncompleteArrayField<ffi::c_char>,
}
extern "C" {
    pub fn __skb_ext_alloc(flags: gfp_t) -> *mut skb_ext;
}
extern "C" {
    pub fn __skb_ext_set(skb: *mut sk_buff, id: skb_ext_id, ext: *mut skb_ext) -> *mut ffi::c_void;
}
extern "C" {
    pub fn skb_ext_add(skb: *mut sk_buff, id: skb_ext_id) -> *mut ffi::c_void;
}
extern "C" {
    pub fn __skb_ext_del(skb: *mut sk_buff, id: skb_ext_id);
}
extern "C" {
    pub fn __skb_ext_put(ext: *mut skb_ext);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sec_path {
    _unused: [u8; 0],
}
extern "C" {
    pub fn __skb_warn_lro_forwarding(skb: *const sk_buff);
}
extern "C" {
    pub fn skb_partial_csum_set(skb: *mut sk_buff, start: u16_, off: u16_) -> bool_;
}
extern "C" {
    pub fn skb_checksum_setup(skb: *mut sk_buff, recalculate: bool_) -> ffi::c_int;
}
extern "C" {
    pub fn skb_checksum_trimmed(
        skb: *mut sk_buff,
        transport_len: ffi::c_uint,
        skb_chkf: ::core::option::Option<unsafe extern "C" fn(skb: *mut sk_buff) -> __sum16>,
    ) -> *mut sk_buff;
}
extern "C" {
    pub fn skb_splice_from_iter(
        skb: *mut sk_buff,
        iter: *mut iov_iter,
        maxsize: isize,
        gfp: gfp_t,
    ) -> isize;
}
extern "C" {
    pub fn eth_header_parse(skb: *const sk_buff, haddr: *mut ffi::c_uchar) -> ffi::c_int;
}
extern "C" {
    pub fn sysfs_format_mac(
        buf: *mut ffi::c_char,
        addr: *const ffi::c_uchar,
        len: ffi::c_int,
    ) -> isize;
}
extern "C" {
    pub fn __do_once_start(done: *mut bool_, flags: *mut ffi::c_ulong) -> bool_;
}
extern "C" {
    pub fn __do_once_done(
        done: *mut bool_,
        once_key: *mut static_key_true,
        flags: *mut ffi::c_ulong,
        mod_: *mut module,
    );
}
extern "C" {
    pub fn __do_once_sleepable_start(done: *mut bool_) -> bool_;
}
extern "C" {
    pub fn __do_once_sleepable_done(
        done: *mut bool_,
        once_key: *mut static_key_true,
        mod_: *mut module,
    );
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sockptr_t {
    pub __bindgen_anon_1: sockptr_t__bindgen_ty_1,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub __bindgen_padding_0: [u8; 7usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sockptr_t__bindgen_ty_1 {
    pub kernel: *mut ffi::c_void,
    pub user: *mut ffi::c_void,
}
impl Default for sockptr_t__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for sockptr_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl sockptr_t {
    #[inline]
    pub fn is_kernel(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_is_kernel(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn is_kernel_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_is_kernel_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(is_kernel: bool_) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let is_kernel: u8 = unsafe { ::core::mem::transmute(is_kernel) };
            is_kernel as u64
        });
        __bindgen_bitfield_unit
    }
}
pub const socket_state_SS_FREE: socket_state = 0;
pub const socket_state_SS_UNCONNECTED: socket_state = 1;
pub const socket_state_SS_CONNECTING: socket_state = 2;
pub const socket_state_SS_CONNECTED: socket_state = 3;
pub const socket_state_SS_DISCONNECTING: socket_state = 4;
pub type socket_state = ffi::c_uint;
pub const sock_type_SOCK_STREAM: sock_type = 1;
pub const sock_type_SOCK_DGRAM: sock_type = 2;
pub const sock_type_SOCK_RAW: sock_type = 3;
pub const sock_type_SOCK_RDM: sock_type = 4;
pub const sock_type_SOCK_SEQPACKET: sock_type = 5;
pub const sock_type_SOCK_DCCP: sock_type = 6;
pub const sock_type_SOCK_PACKET: sock_type = 10;
pub type sock_type = ffi::c_uint;
pub const sock_shutdown_cmd_SHUT_RD: sock_shutdown_cmd = 0;
pub const sock_shutdown_cmd_SHUT_WR: sock_shutdown_cmd = 1;
pub const sock_shutdown_cmd_SHUT_RDWR: sock_shutdown_cmd = 2;
pub type sock_shutdown_cmd = ffi::c_uint;
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct socket_wq {
    pub wait: wait_queue_head_t,
    pub fasync_list: *mut fasync_struct,
    pub flags: ffi::c_ulong,
    pub rcu: callback_head,
}
impl Default for socket_wq {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct socket {
    pub state: socket_state,
    pub type_: ffi::c_short,
    pub flags: ffi::c_ulong,
    pub file: *mut file,
    pub sk: *mut sock,
    pub ops: *const proto_ops,
    pub __bindgen_padding_0: [u64; 3usize],
    pub wq: socket_wq,
}
impl Default for socket {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct read_descriptor_t {
    pub written: usize,
    pub count: usize,
    pub arg: read_descriptor_t__bindgen_ty_1,
    pub error: ffi::c_int,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union read_descriptor_t__bindgen_ty_1 {
    pub buf: *mut ffi::c_char,
    pub data: *mut ffi::c_void,
}
impl Default for read_descriptor_t__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for read_descriptor_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type sk_read_actor_t = ::core::option::Option<
    unsafe extern "C" fn(
        arg1: *mut read_descriptor_t,
        arg2: *mut sk_buff,
        arg3: ffi::c_uint,
        arg4: usize,
    ) -> ffi::c_int,
>;
pub type skb_read_actor_t =
    ::core::option::Option<unsafe extern "C" fn(arg1: *mut sock, arg2: *mut sk_buff) -> ffi::c_int>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct proto_ops {
    pub family: ffi::c_int,
    pub owner: *mut module,
    pub release: ::core::option::Option<unsafe extern "C" fn(sock: *mut socket) -> ffi::c_int>,
    pub bind: ::core::option::Option<
        unsafe extern "C" fn(
            sock: *mut socket,
            myaddr: *mut sockaddr,
            sockaddr_len: ffi::c_int,
        ) -> ffi::c_int,
    >,
    pub connect: ::core::option::Option<
        unsafe extern "C" fn(
            sock: *mut socket,
            vaddr: *mut sockaddr,
            sockaddr_len: ffi::c_int,
            flags: ffi::c_int,
        ) -> ffi::c_int,
    >,
    pub socketpair: ::core::option::Option<
        unsafe extern "C" fn(sock1: *mut socket, sock2: *mut socket) -> ffi::c_int,
    >,
    pub accept: ::core::option::Option<
        unsafe extern "C" fn(
            sock: *mut socket,
            newsock: *mut socket,
            arg: *mut proto_accept_arg,
        ) -> ffi::c_int,
    >,
    pub getname: ::core::option::Option<
        unsafe extern "C" fn(
            sock: *mut socket,
            addr: *mut sockaddr,
            peer: ffi::c_int,
        ) -> ffi::c_int,
    >,
    pub poll: ::core::option::Option<
        unsafe extern "C" fn(
            file: *mut file,
            sock: *mut socket,
            wait: *mut poll_table_struct,
        ) -> __poll_t,
    >,
    pub ioctl: ::core::option::Option<
        unsafe extern "C" fn(sock: *mut socket, cmd: ffi::c_uint, arg: ffi::c_ulong) -> ffi::c_int,
    >,
    pub compat_ioctl: ::core::option::Option<
        unsafe extern "C" fn(sock: *mut socket, cmd: ffi::c_uint, arg: ffi::c_ulong) -> ffi::c_int,
    >,
    pub gettstamp: ::core::option::Option<
        unsafe extern "C" fn(
            sock: *mut socket,
            userstamp: *mut ffi::c_void,
            timeval: bool_,
            time32: bool_,
        ) -> ffi::c_int,
    >,
    pub listen: ::core::option::Option<
        unsafe extern "C" fn(sock: *mut socket, len: ffi::c_int) -> ffi::c_int,
    >,
    pub shutdown: ::core::option::Option<
        unsafe extern "C" fn(sock: *mut socket, flags: ffi::c_int) -> ffi::c_int,
    >,
    pub setsockopt: ::core::option::Option<
        unsafe extern "C" fn(
            sock: *mut socket,
            level: ffi::c_int,
            optname: ffi::c_int,
            optval: sockptr_t,
            optlen: ffi::c_uint,
        ) -> ffi::c_int,
    >,
    pub getsockopt: ::core::option::Option<
        unsafe extern "C" fn(
            sock: *mut socket,
            level: ffi::c_int,
            optname: ffi::c_int,
            optval: *mut ffi::c_char,
            optlen: *mut ffi::c_int,
        ) -> ffi::c_int,
    >,
    pub show_fdinfo:
        ::core::option::Option<unsafe extern "C" fn(m: *mut seq_file, sock: *mut socket)>,
    pub sendmsg: ::core::option::Option<
        unsafe extern "C" fn(sock: *mut socket, m: *mut msghdr, total_len: usize) -> ffi::c_int,
    >,
    pub recvmsg: ::core::option::Option<
        unsafe extern "C" fn(
            sock: *mut socket,
            m: *mut msghdr,
            total_len: usize,
            flags: ffi::c_int,
        ) -> ffi::c_int,
    >,
    pub mmap: ::core::option::Option<
        unsafe extern "C" fn(
            file: *mut file,
            sock: *mut socket,
            vma: *mut vm_area_struct,
        ) -> ffi::c_int,
    >,
    pub splice_read: ::core::option::Option<
        unsafe extern "C" fn(
            sock: *mut socket,
            ppos: *mut loff_t,
            pipe: *mut pipe_inode_info,
            len: usize,
            flags: ffi::c_uint,
        ) -> isize,
    >,
    pub splice_eof: ::core::option::Option<unsafe extern "C" fn(sock: *mut socket)>,
    pub set_peek_off:
        ::core::option::Option<unsafe extern "C" fn(sk: *mut sock, val: ffi::c_int) -> ffi::c_int>,
    pub peek_len: ::core::option::Option<unsafe extern "C" fn(sock: *mut socket) -> ffi::c_int>,
    pub read_sock: ::core::option::Option<
        unsafe extern "C" fn(
            sk: *mut sock,
            desc: *mut read_descriptor_t,
            recv_actor: sk_read_actor_t,
        ) -> ffi::c_int,
    >,
    pub read_skb: ::core::option::Option<
        unsafe extern "C" fn(sk: *mut sock, recv_actor: skb_read_actor_t) -> ffi::c_int,
    >,
    pub sendmsg_locked: ::core::option::Option<
        unsafe extern "C" fn(sk: *mut sock, msg: *mut msghdr, size: usize) -> ffi::c_int,
    >,
    pub set_rcvlowat:
        ::core::option::Option<unsafe extern "C" fn(sk: *mut sock, val: ffi::c_int) -> ffi::c_int>,
}
impl Default for proto_ops {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct net_proto_family {
    pub family: ffi::c_int,
    pub create: ::core::option::Option<
        unsafe extern "C" fn(
            net: *mut net,
            sock: *mut socket,
            protocol: ffi::c_int,
            kern: ffi::c_int,
        ) -> ffi::c_int,
    >,
    pub owner: *mut module,
}
impl Default for net_proto_family {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const SOCK_WAKE_IO: _bindgen_ty_203 = 0;
pub const SOCK_WAKE_WAITD: _bindgen_ty_203 = 1;
pub const SOCK_WAKE_SPACE: _bindgen_ty_203 = 2;
pub const SOCK_WAKE_URG: _bindgen_ty_203 = 3;
pub type _bindgen_ty_203 = ffi::c_uint;
extern "C" {
    pub fn sock_wake_async(sk_wq: *mut socket_wq, how: ffi::c_int, band: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn sock_register(fam: *const net_proto_family) -> ffi::c_int;
}
extern "C" {
    pub fn sock_unregister(family: ffi::c_int);
}
extern "C" {
    pub fn sock_is_registered(family: ffi::c_int) -> bool_;
}
extern "C" {
    pub fn __sock_create(
        net: *mut net,
        family: ffi::c_int,
        type_: ffi::c_int,
        proto: ffi::c_int,
        res: *mut *mut socket,
        kern: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sock_create(
        family: ffi::c_int,
        type_: ffi::c_int,
        proto: ffi::c_int,
        res: *mut *mut socket,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sock_create_kern(
        net: *mut net,
        family: ffi::c_int,
        type_: ffi::c_int,
        proto: ffi::c_int,
        res: *mut *mut socket,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sock_create_lite(
        family: ffi::c_int,
        type_: ffi::c_int,
        proto: ffi::c_int,
        res: *mut *mut socket,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sock_alloc() -> *mut socket;
}
extern "C" {
    pub fn sock_release(sock: *mut socket);
}
extern "C" {
    pub fn sock_sendmsg(sock: *mut socket, msg: *mut msghdr) -> ffi::c_int;
}
extern "C" {
    pub fn sock_recvmsg(sock: *mut socket, msg: *mut msghdr, flags: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn sock_alloc_file(
        sock: *mut socket,
        flags: ffi::c_int,
        dname: *const ffi::c_char,
    ) -> *mut file;
}
extern "C" {
    pub fn sockfd_lookup(fd: ffi::c_int, err: *mut ffi::c_int) -> *mut socket;
}
extern "C" {
    pub fn sock_from_file(file: *mut file) -> *mut socket;
}
extern "C" {
    pub fn net_ratelimit() -> ffi::c_int;
}
extern "C" {
    pub fn kernel_sendmsg(
        sock: *mut socket,
        msg: *mut msghdr,
        vec: *mut kvec,
        num: usize,
        len: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kernel_recvmsg(
        sock: *mut socket,
        msg: *mut msghdr,
        vec: *mut kvec,
        num: usize,
        len: usize,
        flags: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kernel_bind(sock: *mut socket, addr: *mut sockaddr, addrlen: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn kernel_listen(sock: *mut socket, backlog: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn kernel_accept(
        sock: *mut socket,
        newsock: *mut *mut socket,
        flags: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kernel_connect(
        sock: *mut socket,
        addr: *mut sockaddr,
        addrlen: ffi::c_int,
        flags: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kernel_getsockname(sock: *mut socket, addr: *mut sockaddr) -> ffi::c_int;
}
extern "C" {
    pub fn kernel_getpeername(sock: *mut socket, addr: *mut sockaddr) -> ffi::c_int;
}
extern "C" {
    pub fn kernel_sock_shutdown(sock: *mut socket, how: sock_shutdown_cmd) -> ffi::c_int;
}
extern "C" {
    pub fn kernel_sock_ip_overhead(sk: *mut sock) -> u32_;
}
pub const kernel_read_file_id_READING_UNKNOWN: kernel_read_file_id = 0;
pub const kernel_read_file_id_READING_FIRMWARE: kernel_read_file_id = 1;
pub const kernel_read_file_id_READING_MODULE: kernel_read_file_id = 2;
pub const kernel_read_file_id_READING_KEXEC_IMAGE: kernel_read_file_id = 3;
pub const kernel_read_file_id_READING_KEXEC_INITRAMFS: kernel_read_file_id = 4;
pub const kernel_read_file_id_READING_POLICY: kernel_read_file_id = 5;
pub const kernel_read_file_id_READING_X509_CERTIFICATE: kernel_read_file_id = 6;
pub const kernel_read_file_id_READING_MAX_ID: kernel_read_file_id = 7;
pub type kernel_read_file_id = ffi::c_uint;
extern "C" {
    pub static kernel_read_file_str: [*const ffi::c_char; 8usize];
}
extern "C" {
    pub fn kernel_read_file(
        file: *mut file,
        offset: loff_t,
        buf: *mut *mut ffi::c_void,
        buf_size: usize,
        file_size: *mut usize,
        id: kernel_read_file_id,
    ) -> isize;
}
extern "C" {
    pub fn kernel_read_file_from_path(
        path: *const ffi::c_char,
        offset: loff_t,
        buf: *mut *mut ffi::c_void,
        buf_size: usize,
        file_size: *mut usize,
        id: kernel_read_file_id,
    ) -> isize;
}
extern "C" {
    pub fn kernel_read_file_from_path_initns(
        path: *const ffi::c_char,
        offset: loff_t,
        buf: *mut *mut ffi::c_void,
        buf_size: usize,
        file_size: *mut usize,
        id: kernel_read_file_id,
    ) -> isize;
}
extern "C" {
    pub fn kernel_read_file_from_fd(
        fd: ffi::c_int,
        offset: loff_t,
        buf: *mut *mut ffi::c_void,
        buf_size: usize,
        file_size: *mut usize,
        id: kernel_read_file_id,
    ) -> isize;
}
pub const bpf_cond_pseudo_jmp_BPF_MAY_GOTO: bpf_cond_pseudo_jmp = 0;
pub type bpf_cond_pseudo_jmp = ffi::c_uint;
pub const BPF_REG_0: _bindgen_ty_204 = 0;
pub const BPF_REG_1: _bindgen_ty_204 = 1;
pub const BPF_REG_2: _bindgen_ty_204 = 2;
pub const BPF_REG_3: _bindgen_ty_204 = 3;
pub const BPF_REG_4: _bindgen_ty_204 = 4;
pub const BPF_REG_5: _bindgen_ty_204 = 5;
pub const BPF_REG_6: _bindgen_ty_204 = 6;
pub const BPF_REG_7: _bindgen_ty_204 = 7;
pub const BPF_REG_8: _bindgen_ty_204 = 8;
pub const BPF_REG_9: _bindgen_ty_204 = 9;
pub const BPF_REG_10: _bindgen_ty_204 = 10;
pub const __MAX_BPF_REG: _bindgen_ty_204 = 11;
pub type _bindgen_ty_204 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_insn {
    pub code: __u8,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub off: __s16,
    pub imm: __s32,
}
impl bpf_insn {
    #[inline]
    pub fn dst_reg(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 4u8) as u8) }
    }
    #[inline]
    pub fn set_dst_reg(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 4u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn dst_reg_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                4u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_dst_reg_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                4u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn src_reg(&self) -> __u8 {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(4usize, 4u8) as u8) }
    }
    #[inline]
    pub fn set_src_reg(&mut self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(4usize, 4u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn src_reg_raw(this: *const Self) -> __u8 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                4u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_src_reg_raw(this: *mut Self, val: __u8) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                4u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(dst_reg: __u8, src_reg: __u8) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 4u8, {
            let dst_reg: u8 = unsafe { ::core::mem::transmute(dst_reg) };
            dst_reg as u64
        });
        __bindgen_bitfield_unit.set(4usize, 4u8, {
            let src_reg: u8 = unsafe { ::core::mem::transmute(src_reg) };
            src_reg as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Default)]
pub struct bpf_lpm_trie_key {
    pub prefixlen: __u32,
    pub data: __IncompleteArrayField<__u8>,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_lpm_trie_key_hdr {
    pub prefixlen: __u32,
}
#[repr(C)]
pub struct bpf_lpm_trie_key_u8 {
    pub __bindgen_anon_1: bpf_lpm_trie_key_u8__bindgen_ty_1,
    pub data: __IncompleteArrayField<__u8>,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_lpm_trie_key_u8__bindgen_ty_1 {
    pub hdr: bpf_lpm_trie_key_hdr,
    pub prefixlen: __u32,
}
impl Default for bpf_lpm_trie_key_u8__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_lpm_trie_key_u8 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_cgroup_storage_key {
    pub cgroup_inode_id: __u64,
    pub attach_type: __u32,
}
pub const bpf_cgroup_iter_order_BPF_CGROUP_ITER_ORDER_UNSPEC: bpf_cgroup_iter_order = 0;
pub const bpf_cgroup_iter_order_BPF_CGROUP_ITER_SELF_ONLY: bpf_cgroup_iter_order = 1;
pub const bpf_cgroup_iter_order_BPF_CGROUP_ITER_DESCENDANTS_PRE: bpf_cgroup_iter_order = 2;
pub const bpf_cgroup_iter_order_BPF_CGROUP_ITER_DESCENDANTS_POST: bpf_cgroup_iter_order = 3;
pub const bpf_cgroup_iter_order_BPF_CGROUP_ITER_ANCESTORS_UP: bpf_cgroup_iter_order = 4;
pub type bpf_cgroup_iter_order = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_iter_link_info {
    pub map: bpf_iter_link_info__bindgen_ty_1,
    pub cgroup: bpf_iter_link_info__bindgen_ty_2,
    pub task: bpf_iter_link_info__bindgen_ty_3,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_iter_link_info__bindgen_ty_1 {
    pub map_fd: __u32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_iter_link_info__bindgen_ty_2 {
    pub order: bpf_cgroup_iter_order,
    pub cgroup_fd: __u32,
    pub cgroup_id: __u64,
}
impl Default for bpf_iter_link_info__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_iter_link_info__bindgen_ty_3 {
    pub tid: __u32,
    pub pid: __u32,
    pub pid_fd: __u32,
}
impl Default for bpf_iter_link_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const bpf_cmd_BPF_MAP_CREATE: bpf_cmd = 0;
pub const bpf_cmd_BPF_MAP_LOOKUP_ELEM: bpf_cmd = 1;
pub const bpf_cmd_BPF_MAP_UPDATE_ELEM: bpf_cmd = 2;
pub const bpf_cmd_BPF_MAP_DELETE_ELEM: bpf_cmd = 3;
pub const bpf_cmd_BPF_MAP_GET_NEXT_KEY: bpf_cmd = 4;
pub const bpf_cmd_BPF_PROG_LOAD: bpf_cmd = 5;
pub const bpf_cmd_BPF_OBJ_PIN: bpf_cmd = 6;
pub const bpf_cmd_BPF_OBJ_GET: bpf_cmd = 7;
pub const bpf_cmd_BPF_PROG_ATTACH: bpf_cmd = 8;
pub const bpf_cmd_BPF_PROG_DETACH: bpf_cmd = 9;
pub const bpf_cmd_BPF_PROG_TEST_RUN: bpf_cmd = 10;
pub const bpf_cmd_BPF_PROG_RUN: bpf_cmd = 10;
pub const bpf_cmd_BPF_PROG_GET_NEXT_ID: bpf_cmd = 11;
pub const bpf_cmd_BPF_MAP_GET_NEXT_ID: bpf_cmd = 12;
pub const bpf_cmd_BPF_PROG_GET_FD_BY_ID: bpf_cmd = 13;
pub const bpf_cmd_BPF_MAP_GET_FD_BY_ID: bpf_cmd = 14;
pub const bpf_cmd_BPF_OBJ_GET_INFO_BY_FD: bpf_cmd = 15;
pub const bpf_cmd_BPF_PROG_QUERY: bpf_cmd = 16;
pub const bpf_cmd_BPF_RAW_TRACEPOINT_OPEN: bpf_cmd = 17;
pub const bpf_cmd_BPF_BTF_LOAD: bpf_cmd = 18;
pub const bpf_cmd_BPF_BTF_GET_FD_BY_ID: bpf_cmd = 19;
pub const bpf_cmd_BPF_TASK_FD_QUERY: bpf_cmd = 20;
pub const bpf_cmd_BPF_MAP_LOOKUP_AND_DELETE_ELEM: bpf_cmd = 21;
pub const bpf_cmd_BPF_MAP_FREEZE: bpf_cmd = 22;
pub const bpf_cmd_BPF_BTF_GET_NEXT_ID: bpf_cmd = 23;
pub const bpf_cmd_BPF_MAP_LOOKUP_BATCH: bpf_cmd = 24;
pub const bpf_cmd_BPF_MAP_LOOKUP_AND_DELETE_BATCH: bpf_cmd = 25;
pub const bpf_cmd_BPF_MAP_UPDATE_BATCH: bpf_cmd = 26;
pub const bpf_cmd_BPF_MAP_DELETE_BATCH: bpf_cmd = 27;
pub const bpf_cmd_BPF_LINK_CREATE: bpf_cmd = 28;
pub const bpf_cmd_BPF_LINK_UPDATE: bpf_cmd = 29;
pub const bpf_cmd_BPF_LINK_GET_FD_BY_ID: bpf_cmd = 30;
pub const bpf_cmd_BPF_LINK_GET_NEXT_ID: bpf_cmd = 31;
pub const bpf_cmd_BPF_ENABLE_STATS: bpf_cmd = 32;
pub const bpf_cmd_BPF_ITER_CREATE: bpf_cmd = 33;
pub const bpf_cmd_BPF_LINK_DETACH: bpf_cmd = 34;
pub const bpf_cmd_BPF_PROG_BIND_MAP: bpf_cmd = 35;
pub const bpf_cmd_BPF_TOKEN_CREATE: bpf_cmd = 36;
pub const bpf_cmd___MAX_BPF_CMD: bpf_cmd = 37;
pub type bpf_cmd = ffi::c_uint;
pub const bpf_map_type_BPF_MAP_TYPE_UNSPEC: bpf_map_type = 0;
pub const bpf_map_type_BPF_MAP_TYPE_HASH: bpf_map_type = 1;
pub const bpf_map_type_BPF_MAP_TYPE_ARRAY: bpf_map_type = 2;
pub const bpf_map_type_BPF_MAP_TYPE_PROG_ARRAY: bpf_map_type = 3;
pub const bpf_map_type_BPF_MAP_TYPE_PERF_EVENT_ARRAY: bpf_map_type = 4;
pub const bpf_map_type_BPF_MAP_TYPE_PERCPU_HASH: bpf_map_type = 5;
pub const bpf_map_type_BPF_MAP_TYPE_PERCPU_ARRAY: bpf_map_type = 6;
pub const bpf_map_type_BPF_MAP_TYPE_STACK_TRACE: bpf_map_type = 7;
pub const bpf_map_type_BPF_MAP_TYPE_CGROUP_ARRAY: bpf_map_type = 8;
pub const bpf_map_type_BPF_MAP_TYPE_LRU_HASH: bpf_map_type = 9;
pub const bpf_map_type_BPF_MAP_TYPE_LRU_PERCPU_HASH: bpf_map_type = 10;
pub const bpf_map_type_BPF_MAP_TYPE_LPM_TRIE: bpf_map_type = 11;
pub const bpf_map_type_BPF_MAP_TYPE_ARRAY_OF_MAPS: bpf_map_type = 12;
pub const bpf_map_type_BPF_MAP_TYPE_HASH_OF_MAPS: bpf_map_type = 13;
pub const bpf_map_type_BPF_MAP_TYPE_DEVMAP: bpf_map_type = 14;
pub const bpf_map_type_BPF_MAP_TYPE_SOCKMAP: bpf_map_type = 15;
pub const bpf_map_type_BPF_MAP_TYPE_CPUMAP: bpf_map_type = 16;
pub const bpf_map_type_BPF_MAP_TYPE_XSKMAP: bpf_map_type = 17;
pub const bpf_map_type_BPF_MAP_TYPE_SOCKHASH: bpf_map_type = 18;
pub const bpf_map_type_BPF_MAP_TYPE_CGROUP_STORAGE_DEPRECATED: bpf_map_type = 19;
pub const bpf_map_type_BPF_MAP_TYPE_CGROUP_STORAGE: bpf_map_type = 19;
pub const bpf_map_type_BPF_MAP_TYPE_REUSEPORT_SOCKARRAY: bpf_map_type = 20;
pub const bpf_map_type_BPF_MAP_TYPE_PERCPU_CGROUP_STORAGE_DEPRECATED: bpf_map_type = 21;
pub const bpf_map_type_BPF_MAP_TYPE_PERCPU_CGROUP_STORAGE: bpf_map_type = 21;
pub const bpf_map_type_BPF_MAP_TYPE_QUEUE: bpf_map_type = 22;
pub const bpf_map_type_BPF_MAP_TYPE_STACK: bpf_map_type = 23;
pub const bpf_map_type_BPF_MAP_TYPE_SK_STORAGE: bpf_map_type = 24;
pub const bpf_map_type_BPF_MAP_TYPE_DEVMAP_HASH: bpf_map_type = 25;
pub const bpf_map_type_BPF_MAP_TYPE_STRUCT_OPS: bpf_map_type = 26;
pub const bpf_map_type_BPF_MAP_TYPE_RINGBUF: bpf_map_type = 27;
pub const bpf_map_type_BPF_MAP_TYPE_INODE_STORAGE: bpf_map_type = 28;
pub const bpf_map_type_BPF_MAP_TYPE_TASK_STORAGE: bpf_map_type = 29;
pub const bpf_map_type_BPF_MAP_TYPE_BLOOM_FILTER: bpf_map_type = 30;
pub const bpf_map_type_BPF_MAP_TYPE_USER_RINGBUF: bpf_map_type = 31;
pub const bpf_map_type_BPF_MAP_TYPE_CGRP_STORAGE: bpf_map_type = 32;
pub const bpf_map_type_BPF_MAP_TYPE_ARENA: bpf_map_type = 33;
pub const bpf_map_type___MAX_BPF_MAP_TYPE: bpf_map_type = 34;
pub type bpf_map_type = ffi::c_uint;
pub const bpf_prog_type_BPF_PROG_TYPE_UNSPEC: bpf_prog_type = 0;
pub const bpf_prog_type_BPF_PROG_TYPE_SOCKET_FILTER: bpf_prog_type = 1;
pub const bpf_prog_type_BPF_PROG_TYPE_KPROBE: bpf_prog_type = 2;
pub const bpf_prog_type_BPF_PROG_TYPE_SCHED_CLS: bpf_prog_type = 3;
pub const bpf_prog_type_BPF_PROG_TYPE_SCHED_ACT: bpf_prog_type = 4;
pub const bpf_prog_type_BPF_PROG_TYPE_TRACEPOINT: bpf_prog_type = 5;
pub const bpf_prog_type_BPF_PROG_TYPE_XDP: bpf_prog_type = 6;
pub const bpf_prog_type_BPF_PROG_TYPE_PERF_EVENT: bpf_prog_type = 7;
pub const bpf_prog_type_BPF_PROG_TYPE_CGROUP_SKB: bpf_prog_type = 8;
pub const bpf_prog_type_BPF_PROG_TYPE_CGROUP_SOCK: bpf_prog_type = 9;
pub const bpf_prog_type_BPF_PROG_TYPE_LWT_IN: bpf_prog_type = 10;
pub const bpf_prog_type_BPF_PROG_TYPE_LWT_OUT: bpf_prog_type = 11;
pub const bpf_prog_type_BPF_PROG_TYPE_LWT_XMIT: bpf_prog_type = 12;
pub const bpf_prog_type_BPF_PROG_TYPE_SOCK_OPS: bpf_prog_type = 13;
pub const bpf_prog_type_BPF_PROG_TYPE_SK_SKB: bpf_prog_type = 14;
pub const bpf_prog_type_BPF_PROG_TYPE_CGROUP_DEVICE: bpf_prog_type = 15;
pub const bpf_prog_type_BPF_PROG_TYPE_SK_MSG: bpf_prog_type = 16;
pub const bpf_prog_type_BPF_PROG_TYPE_RAW_TRACEPOINT: bpf_prog_type = 17;
pub const bpf_prog_type_BPF_PROG_TYPE_CGROUP_SOCK_ADDR: bpf_prog_type = 18;
pub const bpf_prog_type_BPF_PROG_TYPE_LWT_SEG6LOCAL: bpf_prog_type = 19;
pub const bpf_prog_type_BPF_PROG_TYPE_LIRC_MODE2: bpf_prog_type = 20;
pub const bpf_prog_type_BPF_PROG_TYPE_SK_REUSEPORT: bpf_prog_type = 21;
pub const bpf_prog_type_BPF_PROG_TYPE_FLOW_DISSECTOR: bpf_prog_type = 22;
pub const bpf_prog_type_BPF_PROG_TYPE_CGROUP_SYSCTL: bpf_prog_type = 23;
pub const bpf_prog_type_BPF_PROG_TYPE_RAW_TRACEPOINT_WRITABLE: bpf_prog_type = 24;
pub const bpf_prog_type_BPF_PROG_TYPE_CGROUP_SOCKOPT: bpf_prog_type = 25;
pub const bpf_prog_type_BPF_PROG_TYPE_TRACING: bpf_prog_type = 26;
pub const bpf_prog_type_BPF_PROG_TYPE_STRUCT_OPS: bpf_prog_type = 27;
pub const bpf_prog_type_BPF_PROG_TYPE_EXT: bpf_prog_type = 28;
pub const bpf_prog_type_BPF_PROG_TYPE_LSM: bpf_prog_type = 29;
pub const bpf_prog_type_BPF_PROG_TYPE_SK_LOOKUP: bpf_prog_type = 30;
pub const bpf_prog_type_BPF_PROG_TYPE_SYSCALL: bpf_prog_type = 31;
pub const bpf_prog_type_BPF_PROG_TYPE_NETFILTER: bpf_prog_type = 32;
pub const bpf_prog_type___MAX_BPF_PROG_TYPE: bpf_prog_type = 33;
pub type bpf_prog_type = ffi::c_uint;
pub const bpf_attach_type_BPF_CGROUP_INET_INGRESS: bpf_attach_type = 0;
pub const bpf_attach_type_BPF_CGROUP_INET_EGRESS: bpf_attach_type = 1;
pub const bpf_attach_type_BPF_CGROUP_INET_SOCK_CREATE: bpf_attach_type = 2;
pub const bpf_attach_type_BPF_CGROUP_SOCK_OPS: bpf_attach_type = 3;
pub const bpf_attach_type_BPF_SK_SKB_STREAM_PARSER: bpf_attach_type = 4;
pub const bpf_attach_type_BPF_SK_SKB_STREAM_VERDICT: bpf_attach_type = 5;
pub const bpf_attach_type_BPF_CGROUP_DEVICE: bpf_attach_type = 6;
pub const bpf_attach_type_BPF_SK_MSG_VERDICT: bpf_attach_type = 7;
pub const bpf_attach_type_BPF_CGROUP_INET4_BIND: bpf_attach_type = 8;
pub const bpf_attach_type_BPF_CGROUP_INET6_BIND: bpf_attach_type = 9;
pub const bpf_attach_type_BPF_CGROUP_INET4_CONNECT: bpf_attach_type = 10;
pub const bpf_attach_type_BPF_CGROUP_INET6_CONNECT: bpf_attach_type = 11;
pub const bpf_attach_type_BPF_CGROUP_INET4_POST_BIND: bpf_attach_type = 12;
pub const bpf_attach_type_BPF_CGROUP_INET6_POST_BIND: bpf_attach_type = 13;
pub const bpf_attach_type_BPF_CGROUP_UDP4_SENDMSG: bpf_attach_type = 14;
pub const bpf_attach_type_BPF_CGROUP_UDP6_SENDMSG: bpf_attach_type = 15;
pub const bpf_attach_type_BPF_LIRC_MODE2: bpf_attach_type = 16;
pub const bpf_attach_type_BPF_FLOW_DISSECTOR: bpf_attach_type = 17;
pub const bpf_attach_type_BPF_CGROUP_SYSCTL: bpf_attach_type = 18;
pub const bpf_attach_type_BPF_CGROUP_UDP4_RECVMSG: bpf_attach_type = 19;
pub const bpf_attach_type_BPF_CGROUP_UDP6_RECVMSG: bpf_attach_type = 20;
pub const bpf_attach_type_BPF_CGROUP_GETSOCKOPT: bpf_attach_type = 21;
pub const bpf_attach_type_BPF_CGROUP_SETSOCKOPT: bpf_attach_type = 22;
pub const bpf_attach_type_BPF_TRACE_RAW_TP: bpf_attach_type = 23;
pub const bpf_attach_type_BPF_TRACE_FENTRY: bpf_attach_type = 24;
pub const bpf_attach_type_BPF_TRACE_FEXIT: bpf_attach_type = 25;
pub const bpf_attach_type_BPF_MODIFY_RETURN: bpf_attach_type = 26;
pub const bpf_attach_type_BPF_LSM_MAC: bpf_attach_type = 27;
pub const bpf_attach_type_BPF_TRACE_ITER: bpf_attach_type = 28;
pub const bpf_attach_type_BPF_CGROUP_INET4_GETPEERNAME: bpf_attach_type = 29;
pub const bpf_attach_type_BPF_CGROUP_INET6_GETPEERNAME: bpf_attach_type = 30;
pub const bpf_attach_type_BPF_CGROUP_INET4_GETSOCKNAME: bpf_attach_type = 31;
pub const bpf_attach_type_BPF_CGROUP_INET6_GETSOCKNAME: bpf_attach_type = 32;
pub const bpf_attach_type_BPF_XDP_DEVMAP: bpf_attach_type = 33;
pub const bpf_attach_type_BPF_CGROUP_INET_SOCK_RELEASE: bpf_attach_type = 34;
pub const bpf_attach_type_BPF_XDP_CPUMAP: bpf_attach_type = 35;
pub const bpf_attach_type_BPF_SK_LOOKUP: bpf_attach_type = 36;
pub const bpf_attach_type_BPF_XDP: bpf_attach_type = 37;
pub const bpf_attach_type_BPF_SK_SKB_VERDICT: bpf_attach_type = 38;
pub const bpf_attach_type_BPF_SK_REUSEPORT_SELECT: bpf_attach_type = 39;
pub const bpf_attach_type_BPF_SK_REUSEPORT_SELECT_OR_MIGRATE: bpf_attach_type = 40;
pub const bpf_attach_type_BPF_PERF_EVENT: bpf_attach_type = 41;
pub const bpf_attach_type_BPF_TRACE_KPROBE_MULTI: bpf_attach_type = 42;
pub const bpf_attach_type_BPF_LSM_CGROUP: bpf_attach_type = 43;
pub const bpf_attach_type_BPF_STRUCT_OPS: bpf_attach_type = 44;
pub const bpf_attach_type_BPF_NETFILTER: bpf_attach_type = 45;
pub const bpf_attach_type_BPF_TCX_INGRESS: bpf_attach_type = 46;
pub const bpf_attach_type_BPF_TCX_EGRESS: bpf_attach_type = 47;
pub const bpf_attach_type_BPF_TRACE_UPROBE_MULTI: bpf_attach_type = 48;
pub const bpf_attach_type_BPF_CGROUP_UNIX_CONNECT: bpf_attach_type = 49;
pub const bpf_attach_type_BPF_CGROUP_UNIX_SENDMSG: bpf_attach_type = 50;
pub const bpf_attach_type_BPF_CGROUP_UNIX_RECVMSG: bpf_attach_type = 51;
pub const bpf_attach_type_BPF_CGROUP_UNIX_GETPEERNAME: bpf_attach_type = 52;
pub const bpf_attach_type_BPF_CGROUP_UNIX_GETSOCKNAME: bpf_attach_type = 53;
pub const bpf_attach_type_BPF_NETKIT_PRIMARY: bpf_attach_type = 54;
pub const bpf_attach_type_BPF_NETKIT_PEER: bpf_attach_type = 55;
pub const bpf_attach_type_BPF_TRACE_KPROBE_SESSION: bpf_attach_type = 56;
pub const bpf_attach_type_BPF_TRACE_UPROBE_SESSION: bpf_attach_type = 57;
pub const bpf_attach_type___MAX_BPF_ATTACH_TYPE: bpf_attach_type = 58;
pub type bpf_attach_type = ffi::c_uint;
pub const bpf_link_type_BPF_LINK_TYPE_UNSPEC: bpf_link_type = 0;
pub const bpf_link_type_BPF_LINK_TYPE_RAW_TRACEPOINT: bpf_link_type = 1;
pub const bpf_link_type_BPF_LINK_TYPE_TRACING: bpf_link_type = 2;
pub const bpf_link_type_BPF_LINK_TYPE_CGROUP: bpf_link_type = 3;
pub const bpf_link_type_BPF_LINK_TYPE_ITER: bpf_link_type = 4;
pub const bpf_link_type_BPF_LINK_TYPE_NETNS: bpf_link_type = 5;
pub const bpf_link_type_BPF_LINK_TYPE_XDP: bpf_link_type = 6;
pub const bpf_link_type_BPF_LINK_TYPE_PERF_EVENT: bpf_link_type = 7;
pub const bpf_link_type_BPF_LINK_TYPE_KPROBE_MULTI: bpf_link_type = 8;
pub const bpf_link_type_BPF_LINK_TYPE_STRUCT_OPS: bpf_link_type = 9;
pub const bpf_link_type_BPF_LINK_TYPE_NETFILTER: bpf_link_type = 10;
pub const bpf_link_type_BPF_LINK_TYPE_TCX: bpf_link_type = 11;
pub const bpf_link_type_BPF_LINK_TYPE_UPROBE_MULTI: bpf_link_type = 12;
pub const bpf_link_type_BPF_LINK_TYPE_NETKIT: bpf_link_type = 13;
pub const bpf_link_type_BPF_LINK_TYPE_SOCKMAP: bpf_link_type = 14;
pub const bpf_link_type___MAX_BPF_LINK_TYPE: bpf_link_type = 15;
pub type bpf_link_type = ffi::c_uint;
pub const bpf_perf_event_type_BPF_PERF_EVENT_UNSPEC: bpf_perf_event_type = 0;
pub const bpf_perf_event_type_BPF_PERF_EVENT_UPROBE: bpf_perf_event_type = 1;
pub const bpf_perf_event_type_BPF_PERF_EVENT_URETPROBE: bpf_perf_event_type = 2;
pub const bpf_perf_event_type_BPF_PERF_EVENT_KPROBE: bpf_perf_event_type = 3;
pub const bpf_perf_event_type_BPF_PERF_EVENT_KRETPROBE: bpf_perf_event_type = 4;
pub const bpf_perf_event_type_BPF_PERF_EVENT_TRACEPOINT: bpf_perf_event_type = 5;
pub const bpf_perf_event_type_BPF_PERF_EVENT_EVENT: bpf_perf_event_type = 6;
pub type bpf_perf_event_type = ffi::c_uint;
pub const BPF_F_KPROBE_MULTI_RETURN: _bindgen_ty_205 = 1;
pub type _bindgen_ty_205 = ffi::c_uint;
pub const BPF_F_UPROBE_MULTI_RETURN: _bindgen_ty_206 = 1;
pub type _bindgen_ty_206 = ffi::c_uint;
pub const bpf_addr_space_cast_BPF_ADDR_SPACE_CAST: bpf_addr_space_cast = 1;
pub type bpf_addr_space_cast = ffi::c_uint;
pub const BPF_ANY: _bindgen_ty_207 = 0;
pub const BPF_NOEXIST: _bindgen_ty_207 = 1;
pub const BPF_EXIST: _bindgen_ty_207 = 2;
pub const BPF_F_LOCK: _bindgen_ty_207 = 4;
pub type _bindgen_ty_207 = ffi::c_uint;
pub const BPF_F_NO_PREALLOC: _bindgen_ty_208 = 1;
pub const BPF_F_NO_COMMON_LRU: _bindgen_ty_208 = 2;
pub const BPF_F_NUMA_NODE: _bindgen_ty_208 = 4;
pub const BPF_F_RDONLY: _bindgen_ty_208 = 8;
pub const BPF_F_WRONLY: _bindgen_ty_208 = 16;
pub const BPF_F_STACK_BUILD_ID: _bindgen_ty_208 = 32;
pub const BPF_F_ZERO_SEED: _bindgen_ty_208 = 64;
pub const BPF_F_RDONLY_PROG: _bindgen_ty_208 = 128;
pub const BPF_F_WRONLY_PROG: _bindgen_ty_208 = 256;
pub const BPF_F_CLONE: _bindgen_ty_208 = 512;
pub const BPF_F_MMAPABLE: _bindgen_ty_208 = 1024;
pub const BPF_F_PRESERVE_ELEMS: _bindgen_ty_208 = 2048;
pub const BPF_F_INNER_MAP: _bindgen_ty_208 = 4096;
pub const BPF_F_LINK: _bindgen_ty_208 = 8192;
pub const BPF_F_PATH_FD: _bindgen_ty_208 = 16384;
pub const BPF_F_VTYPE_BTF_OBJ_FD: _bindgen_ty_208 = 32768;
pub const BPF_F_TOKEN_FD: _bindgen_ty_208 = 65536;
pub const BPF_F_SEGV_ON_FAULT: _bindgen_ty_208 = 131072;
pub const BPF_F_NO_USER_CONV: _bindgen_ty_208 = 262144;
pub type _bindgen_ty_208 = ffi::c_uint;
pub const bpf_stats_type_BPF_STATS_RUN_TIME: bpf_stats_type = 0;
pub type bpf_stats_type = ffi::c_uint;
pub const bpf_stack_build_id_status_BPF_STACK_BUILD_ID_EMPTY: bpf_stack_build_id_status = 0;
pub const bpf_stack_build_id_status_BPF_STACK_BUILD_ID_VALID: bpf_stack_build_id_status = 1;
pub const bpf_stack_build_id_status_BPF_STACK_BUILD_ID_IP: bpf_stack_build_id_status = 2;
pub type bpf_stack_build_id_status = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_stack_build_id {
    pub status: __s32,
    pub build_id: [ffi::c_uchar; 20usize],
    pub __bindgen_anon_1: bpf_stack_build_id__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_stack_build_id__bindgen_ty_1 {
    pub offset: __u64,
    pub ip: __u64,
}
impl Default for bpf_stack_build_id__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_stack_build_id {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_attr {
    pub __bindgen_anon_1: bpf_attr__bindgen_ty_1,
    pub __bindgen_anon_2: bpf_attr__bindgen_ty_2,
    pub batch: bpf_attr__bindgen_ty_3,
    pub __bindgen_anon_3: bpf_attr__bindgen_ty_4,
    pub __bindgen_anon_4: bpf_attr__bindgen_ty_5,
    pub __bindgen_anon_5: bpf_attr__bindgen_ty_6,
    pub test: bpf_attr__bindgen_ty_7,
    pub __bindgen_anon_6: bpf_attr__bindgen_ty_8,
    pub info: bpf_attr__bindgen_ty_9,
    pub query: bpf_attr__bindgen_ty_10,
    pub raw_tracepoint: bpf_attr__bindgen_ty_11,
    pub __bindgen_anon_7: bpf_attr__bindgen_ty_12,
    pub task_fd_query: bpf_attr__bindgen_ty_13,
    pub link_create: bpf_attr__bindgen_ty_14,
    pub link_update: bpf_attr__bindgen_ty_15,
    pub link_detach: bpf_attr__bindgen_ty_16,
    pub enable_stats: bpf_attr__bindgen_ty_17,
    pub iter_create: bpf_attr__bindgen_ty_18,
    pub prog_bind_map: bpf_attr__bindgen_ty_19,
    pub token_create: bpf_attr__bindgen_ty_20,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_attr__bindgen_ty_1 {
    pub map_type: __u32,
    pub key_size: __u32,
    pub value_size: __u32,
    pub max_entries: __u32,
    pub map_flags: __u32,
    pub inner_map_fd: __u32,
    pub numa_node: __u32,
    pub map_name: [ffi::c_char; 16usize],
    pub map_ifindex: __u32,
    pub btf_fd: __u32,
    pub btf_key_type_id: __u32,
    pub btf_value_type_id: __u32,
    pub btf_vmlinux_value_type_id: __u32,
    pub map_extra: __u64,
    pub value_type_btf_obj_fd: __s32,
    pub map_token_fd: __s32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_attr__bindgen_ty_2 {
    pub map_fd: __u32,
    pub key: __u64,
    pub __bindgen_anon_1: bpf_attr__bindgen_ty_2__bindgen_ty_1,
    pub flags: __u64,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_attr__bindgen_ty_2__bindgen_ty_1 {
    pub value: __u64,
    pub next_key: __u64,
}
impl Default for bpf_attr__bindgen_ty_2__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_attr__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_attr__bindgen_ty_3 {
    pub in_batch: __u64,
    pub out_batch: __u64,
    pub keys: __u64,
    pub values: __u64,
    pub count: __u32,
    pub map_fd: __u32,
    pub elem_flags: __u64,
    pub flags: __u64,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_attr__bindgen_ty_4 {
    pub prog_type: __u32,
    pub insn_cnt: __u32,
    pub insns: __u64,
    pub license: __u64,
    pub log_level: __u32,
    pub log_size: __u32,
    pub log_buf: __u64,
    pub kern_version: __u32,
    pub prog_flags: __u32,
    pub prog_name: [ffi::c_char; 16usize],
    pub prog_ifindex: __u32,
    pub expected_attach_type: __u32,
    pub prog_btf_fd: __u32,
    pub func_info_rec_size: __u32,
    pub func_info: __u64,
    pub func_info_cnt: __u32,
    pub line_info_rec_size: __u32,
    pub line_info: __u64,
    pub line_info_cnt: __u32,
    pub attach_btf_id: __u32,
    pub __bindgen_anon_1: bpf_attr__bindgen_ty_4__bindgen_ty_1,
    pub core_relo_cnt: __u32,
    pub fd_array: __u64,
    pub core_relos: __u64,
    pub core_relo_rec_size: __u32,
    pub log_true_size: __u32,
    pub prog_token_fd: __s32,
    pub fd_array_cnt: __u32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_attr__bindgen_ty_4__bindgen_ty_1 {
    pub attach_prog_fd: __u32,
    pub attach_btf_obj_fd: __u32,
}
impl Default for bpf_attr__bindgen_ty_4__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_attr__bindgen_ty_4 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_attr__bindgen_ty_5 {
    pub pathname: __u64,
    pub bpf_fd: __u32,
    pub file_flags: __u32,
    pub path_fd: __s32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_attr__bindgen_ty_6 {
    pub __bindgen_anon_1: bpf_attr__bindgen_ty_6__bindgen_ty_1,
    pub attach_bpf_fd: __u32,
    pub attach_type: __u32,
    pub attach_flags: __u32,
    pub replace_bpf_fd: __u32,
    pub __bindgen_anon_2: bpf_attr__bindgen_ty_6__bindgen_ty_2,
    pub expected_revision: __u64,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_attr__bindgen_ty_6__bindgen_ty_1 {
    pub target_fd: __u32,
    pub target_ifindex: __u32,
}
impl Default for bpf_attr__bindgen_ty_6__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_attr__bindgen_ty_6__bindgen_ty_2 {
    pub relative_fd: __u32,
    pub relative_id: __u32,
}
impl Default for bpf_attr__bindgen_ty_6__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_attr__bindgen_ty_6 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_attr__bindgen_ty_7 {
    pub prog_fd: __u32,
    pub retval: __u32,
    pub data_size_in: __u32,
    pub data_size_out: __u32,
    pub data_in: __u64,
    pub data_out: __u64,
    pub repeat: __u32,
    pub duration: __u32,
    pub ctx_size_in: __u32,
    pub ctx_size_out: __u32,
    pub ctx_in: __u64,
    pub ctx_out: __u64,
    pub flags: __u32,
    pub cpu: __u32,
    pub batch_size: __u32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_attr__bindgen_ty_8 {
    pub __bindgen_anon_1: bpf_attr__bindgen_ty_8__bindgen_ty_1,
    pub next_id: __u32,
    pub open_flags: __u32,
    pub fd_by_id_token_fd: __s32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_attr__bindgen_ty_8__bindgen_ty_1 {
    pub start_id: __u32,
    pub prog_id: __u32,
    pub map_id: __u32,
    pub btf_id: __u32,
    pub link_id: __u32,
}
impl Default for bpf_attr__bindgen_ty_8__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_attr__bindgen_ty_8 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_attr__bindgen_ty_9 {
    pub bpf_fd: __u32,
    pub info_len: __u32,
    pub info: __u64,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_attr__bindgen_ty_10 {
    pub __bindgen_anon_1: bpf_attr__bindgen_ty_10__bindgen_ty_1,
    pub attach_type: __u32,
    pub query_flags: __u32,
    pub attach_flags: __u32,
    pub prog_ids: __u64,
    pub __bindgen_anon_2: bpf_attr__bindgen_ty_10__bindgen_ty_2,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
    pub prog_attach_flags: __u64,
    pub link_ids: __u64,
    pub link_attach_flags: __u64,
    pub revision: __u64,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_attr__bindgen_ty_10__bindgen_ty_1 {
    pub target_fd: __u32,
    pub target_ifindex: __u32,
}
impl Default for bpf_attr__bindgen_ty_10__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_attr__bindgen_ty_10__bindgen_ty_2 {
    pub prog_cnt: __u32,
    pub count: __u32,
}
impl Default for bpf_attr__bindgen_ty_10__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_attr__bindgen_ty_10 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl bpf_attr__bindgen_ty_10 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_attr__bindgen_ty_11 {
    pub name: __u64,
    pub prog_fd: __u32,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
    pub cookie: __u64,
}
impl bpf_attr__bindgen_ty_11 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_attr__bindgen_ty_12 {
    pub btf: __u64,
    pub btf_log_buf: __u64,
    pub btf_size: __u32,
    pub btf_log_size: __u32,
    pub btf_log_level: __u32,
    pub btf_log_true_size: __u32,
    pub btf_flags: __u32,
    pub btf_token_fd: __s32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_attr__bindgen_ty_13 {
    pub pid: __u32,
    pub fd: __u32,
    pub flags: __u32,
    pub buf_len: __u32,
    pub buf: __u64,
    pub prog_id: __u32,
    pub fd_type: __u32,
    pub probe_offset: __u64,
    pub probe_addr: __u64,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_attr__bindgen_ty_14 {
    pub __bindgen_anon_1: bpf_attr__bindgen_ty_14__bindgen_ty_1,
    pub __bindgen_anon_2: bpf_attr__bindgen_ty_14__bindgen_ty_2,
    pub attach_type: __u32,
    pub flags: __u32,
    pub __bindgen_anon_3: bpf_attr__bindgen_ty_14__bindgen_ty_3,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_attr__bindgen_ty_14__bindgen_ty_1 {
    pub prog_fd: __u32,
    pub map_fd: __u32,
}
impl Default for bpf_attr__bindgen_ty_14__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_attr__bindgen_ty_14__bindgen_ty_2 {
    pub target_fd: __u32,
    pub target_ifindex: __u32,
}
impl Default for bpf_attr__bindgen_ty_14__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_attr__bindgen_ty_14__bindgen_ty_3 {
    pub target_btf_id: __u32,
    pub __bindgen_anon_1: bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_1,
    pub perf_event: bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_2,
    pub kprobe_multi: bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_3,
    pub tracing: bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_4,
    pub netfilter: bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_5,
    pub tcx: bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_6,
    pub uprobe_multi: bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_7,
    pub netkit: bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_1 {
    pub iter_info: __u64,
    pub iter_info_len: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_2 {
    pub bpf_cookie: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_3 {
    pub flags: __u32,
    pub cnt: __u32,
    pub syms: __u64,
    pub addrs: __u64,
    pub cookies: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_4 {
    pub target_btf_id: __u32,
    pub cookie: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_5 {
    pub pf: __u32,
    pub hooknum: __u32,
    pub priority: __s32,
    pub flags: __u32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_6 {
    pub __bindgen_anon_1: bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_6__bindgen_ty_1,
    pub expected_revision: __u64,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_6__bindgen_ty_1 {
    pub relative_fd: __u32,
    pub relative_id: __u32,
}
impl Default for bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_6__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_6 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_7 {
    pub path: __u64,
    pub offsets: __u64,
    pub ref_ctr_offsets: __u64,
    pub cookies: __u64,
    pub cnt: __u32,
    pub flags: __u32,
    pub pid: __u32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_8 {
    pub __bindgen_anon_1: bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_8__bindgen_ty_1,
    pub expected_revision: __u64,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_8__bindgen_ty_1 {
    pub relative_fd: __u32,
    pub relative_id: __u32,
}
impl Default for bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_8__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_attr__bindgen_ty_14__bindgen_ty_3__bindgen_ty_8 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_attr__bindgen_ty_14__bindgen_ty_3 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_attr__bindgen_ty_14 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_attr__bindgen_ty_15 {
    pub link_fd: __u32,
    pub __bindgen_anon_1: bpf_attr__bindgen_ty_15__bindgen_ty_1,
    pub flags: __u32,
    pub __bindgen_anon_2: bpf_attr__bindgen_ty_15__bindgen_ty_2,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_attr__bindgen_ty_15__bindgen_ty_1 {
    pub new_prog_fd: __u32,
    pub new_map_fd: __u32,
}
impl Default for bpf_attr__bindgen_ty_15__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_attr__bindgen_ty_15__bindgen_ty_2 {
    pub old_prog_fd: __u32,
    pub old_map_fd: __u32,
}
impl Default for bpf_attr__bindgen_ty_15__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_attr__bindgen_ty_15 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_attr__bindgen_ty_16 {
    pub link_fd: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_attr__bindgen_ty_17 {
    pub type_: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_attr__bindgen_ty_18 {
    pub link_fd: __u32,
    pub flags: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_attr__bindgen_ty_19 {
    pub prog_fd: __u32,
    pub map_fd: __u32,
    pub flags: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_attr__bindgen_ty_20 {
    pub flags: __u32,
    pub bpffs_fd: __u32,
}
impl Default for bpf_attr {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const bpf_func_id_BPF_FUNC_unspec: bpf_func_id = 0;
pub const bpf_func_id_BPF_FUNC_map_lookup_elem: bpf_func_id = 1;
pub const bpf_func_id_BPF_FUNC_map_update_elem: bpf_func_id = 2;
pub const bpf_func_id_BPF_FUNC_map_delete_elem: bpf_func_id = 3;
pub const bpf_func_id_BPF_FUNC_probe_read: bpf_func_id = 4;
pub const bpf_func_id_BPF_FUNC_ktime_get_ns: bpf_func_id = 5;
pub const bpf_func_id_BPF_FUNC_trace_printk: bpf_func_id = 6;
pub const bpf_func_id_BPF_FUNC_get_prandom_u32: bpf_func_id = 7;
pub const bpf_func_id_BPF_FUNC_get_smp_processor_id: bpf_func_id = 8;
pub const bpf_func_id_BPF_FUNC_skb_store_bytes: bpf_func_id = 9;
pub const bpf_func_id_BPF_FUNC_l3_csum_replace: bpf_func_id = 10;
pub const bpf_func_id_BPF_FUNC_l4_csum_replace: bpf_func_id = 11;
pub const bpf_func_id_BPF_FUNC_tail_call: bpf_func_id = 12;
pub const bpf_func_id_BPF_FUNC_clone_redirect: bpf_func_id = 13;
pub const bpf_func_id_BPF_FUNC_get_current_pid_tgid: bpf_func_id = 14;
pub const bpf_func_id_BPF_FUNC_get_current_uid_gid: bpf_func_id = 15;
pub const bpf_func_id_BPF_FUNC_get_current_comm: bpf_func_id = 16;
pub const bpf_func_id_BPF_FUNC_get_cgroup_classid: bpf_func_id = 17;
pub const bpf_func_id_BPF_FUNC_skb_vlan_push: bpf_func_id = 18;
pub const bpf_func_id_BPF_FUNC_skb_vlan_pop: bpf_func_id = 19;
pub const bpf_func_id_BPF_FUNC_skb_get_tunnel_key: bpf_func_id = 20;
pub const bpf_func_id_BPF_FUNC_skb_set_tunnel_key: bpf_func_id = 21;
pub const bpf_func_id_BPF_FUNC_perf_event_read: bpf_func_id = 22;
pub const bpf_func_id_BPF_FUNC_redirect: bpf_func_id = 23;
pub const bpf_func_id_BPF_FUNC_get_route_realm: bpf_func_id = 24;
pub const bpf_func_id_BPF_FUNC_perf_event_output: bpf_func_id = 25;
pub const bpf_func_id_BPF_FUNC_skb_load_bytes: bpf_func_id = 26;
pub const bpf_func_id_BPF_FUNC_get_stackid: bpf_func_id = 27;
pub const bpf_func_id_BPF_FUNC_csum_diff: bpf_func_id = 28;
pub const bpf_func_id_BPF_FUNC_skb_get_tunnel_opt: bpf_func_id = 29;
pub const bpf_func_id_BPF_FUNC_skb_set_tunnel_opt: bpf_func_id = 30;
pub const bpf_func_id_BPF_FUNC_skb_change_proto: bpf_func_id = 31;
pub const bpf_func_id_BPF_FUNC_skb_change_type: bpf_func_id = 32;
pub const bpf_func_id_BPF_FUNC_skb_under_cgroup: bpf_func_id = 33;
pub const bpf_func_id_BPF_FUNC_get_hash_recalc: bpf_func_id = 34;
pub const bpf_func_id_BPF_FUNC_get_current_task: bpf_func_id = 35;
pub const bpf_func_id_BPF_FUNC_probe_write_user: bpf_func_id = 36;
pub const bpf_func_id_BPF_FUNC_current_task_under_cgroup: bpf_func_id = 37;
pub const bpf_func_id_BPF_FUNC_skb_change_tail: bpf_func_id = 38;
pub const bpf_func_id_BPF_FUNC_skb_pull_data: bpf_func_id = 39;
pub const bpf_func_id_BPF_FUNC_csum_update: bpf_func_id = 40;
pub const bpf_func_id_BPF_FUNC_set_hash_invalid: bpf_func_id = 41;
pub const bpf_func_id_BPF_FUNC_get_numa_node_id: bpf_func_id = 42;
pub const bpf_func_id_BPF_FUNC_skb_change_head: bpf_func_id = 43;
pub const bpf_func_id_BPF_FUNC_xdp_adjust_head: bpf_func_id = 44;
pub const bpf_func_id_BPF_FUNC_probe_read_str: bpf_func_id = 45;
pub const bpf_func_id_BPF_FUNC_get_socket_cookie: bpf_func_id = 46;
pub const bpf_func_id_BPF_FUNC_get_socket_uid: bpf_func_id = 47;
pub const bpf_func_id_BPF_FUNC_set_hash: bpf_func_id = 48;
pub const bpf_func_id_BPF_FUNC_setsockopt: bpf_func_id = 49;
pub const bpf_func_id_BPF_FUNC_skb_adjust_room: bpf_func_id = 50;
pub const bpf_func_id_BPF_FUNC_redirect_map: bpf_func_id = 51;
pub const bpf_func_id_BPF_FUNC_sk_redirect_map: bpf_func_id = 52;
pub const bpf_func_id_BPF_FUNC_sock_map_update: bpf_func_id = 53;
pub const bpf_func_id_BPF_FUNC_xdp_adjust_meta: bpf_func_id = 54;
pub const bpf_func_id_BPF_FUNC_perf_event_read_value: bpf_func_id = 55;
pub const bpf_func_id_BPF_FUNC_perf_prog_read_value: bpf_func_id = 56;
pub const bpf_func_id_BPF_FUNC_getsockopt: bpf_func_id = 57;
pub const bpf_func_id_BPF_FUNC_override_return: bpf_func_id = 58;
pub const bpf_func_id_BPF_FUNC_sock_ops_cb_flags_set: bpf_func_id = 59;
pub const bpf_func_id_BPF_FUNC_msg_redirect_map: bpf_func_id = 60;
pub const bpf_func_id_BPF_FUNC_msg_apply_bytes: bpf_func_id = 61;
pub const bpf_func_id_BPF_FUNC_msg_cork_bytes: bpf_func_id = 62;
pub const bpf_func_id_BPF_FUNC_msg_pull_data: bpf_func_id = 63;
pub const bpf_func_id_BPF_FUNC_bind: bpf_func_id = 64;
pub const bpf_func_id_BPF_FUNC_xdp_adjust_tail: bpf_func_id = 65;
pub const bpf_func_id_BPF_FUNC_skb_get_xfrm_state: bpf_func_id = 66;
pub const bpf_func_id_BPF_FUNC_get_stack: bpf_func_id = 67;
pub const bpf_func_id_BPF_FUNC_skb_load_bytes_relative: bpf_func_id = 68;
pub const bpf_func_id_BPF_FUNC_fib_lookup: bpf_func_id = 69;
pub const bpf_func_id_BPF_FUNC_sock_hash_update: bpf_func_id = 70;
pub const bpf_func_id_BPF_FUNC_msg_redirect_hash: bpf_func_id = 71;
pub const bpf_func_id_BPF_FUNC_sk_redirect_hash: bpf_func_id = 72;
pub const bpf_func_id_BPF_FUNC_lwt_push_encap: bpf_func_id = 73;
pub const bpf_func_id_BPF_FUNC_lwt_seg6_store_bytes: bpf_func_id = 74;
pub const bpf_func_id_BPF_FUNC_lwt_seg6_adjust_srh: bpf_func_id = 75;
pub const bpf_func_id_BPF_FUNC_lwt_seg6_action: bpf_func_id = 76;
pub const bpf_func_id_BPF_FUNC_rc_repeat: bpf_func_id = 77;
pub const bpf_func_id_BPF_FUNC_rc_keydown: bpf_func_id = 78;
pub const bpf_func_id_BPF_FUNC_skb_cgroup_id: bpf_func_id = 79;
pub const bpf_func_id_BPF_FUNC_get_current_cgroup_id: bpf_func_id = 80;
pub const bpf_func_id_BPF_FUNC_get_local_storage: bpf_func_id = 81;
pub const bpf_func_id_BPF_FUNC_sk_select_reuseport: bpf_func_id = 82;
pub const bpf_func_id_BPF_FUNC_skb_ancestor_cgroup_id: bpf_func_id = 83;
pub const bpf_func_id_BPF_FUNC_sk_lookup_tcp: bpf_func_id = 84;
pub const bpf_func_id_BPF_FUNC_sk_lookup_udp: bpf_func_id = 85;
pub const bpf_func_id_BPF_FUNC_sk_release: bpf_func_id = 86;
pub const bpf_func_id_BPF_FUNC_map_push_elem: bpf_func_id = 87;
pub const bpf_func_id_BPF_FUNC_map_pop_elem: bpf_func_id = 88;
pub const bpf_func_id_BPF_FUNC_map_peek_elem: bpf_func_id = 89;
pub const bpf_func_id_BPF_FUNC_msg_push_data: bpf_func_id = 90;
pub const bpf_func_id_BPF_FUNC_msg_pop_data: bpf_func_id = 91;
pub const bpf_func_id_BPF_FUNC_rc_pointer_rel: bpf_func_id = 92;
pub const bpf_func_id_BPF_FUNC_spin_lock: bpf_func_id = 93;
pub const bpf_func_id_BPF_FUNC_spin_unlock: bpf_func_id = 94;
pub const bpf_func_id_BPF_FUNC_sk_fullsock: bpf_func_id = 95;
pub const bpf_func_id_BPF_FUNC_tcp_sock: bpf_func_id = 96;
pub const bpf_func_id_BPF_FUNC_skb_ecn_set_ce: bpf_func_id = 97;
pub const bpf_func_id_BPF_FUNC_get_listener_sock: bpf_func_id = 98;
pub const bpf_func_id_BPF_FUNC_skc_lookup_tcp: bpf_func_id = 99;
pub const bpf_func_id_BPF_FUNC_tcp_check_syncookie: bpf_func_id = 100;
pub const bpf_func_id_BPF_FUNC_sysctl_get_name: bpf_func_id = 101;
pub const bpf_func_id_BPF_FUNC_sysctl_get_current_value: bpf_func_id = 102;
pub const bpf_func_id_BPF_FUNC_sysctl_get_new_value: bpf_func_id = 103;
pub const bpf_func_id_BPF_FUNC_sysctl_set_new_value: bpf_func_id = 104;
pub const bpf_func_id_BPF_FUNC_strtol: bpf_func_id = 105;
pub const bpf_func_id_BPF_FUNC_strtoul: bpf_func_id = 106;
pub const bpf_func_id_BPF_FUNC_sk_storage_get: bpf_func_id = 107;
pub const bpf_func_id_BPF_FUNC_sk_storage_delete: bpf_func_id = 108;
pub const bpf_func_id_BPF_FUNC_send_signal: bpf_func_id = 109;
pub const bpf_func_id_BPF_FUNC_tcp_gen_syncookie: bpf_func_id = 110;
pub const bpf_func_id_BPF_FUNC_skb_output: bpf_func_id = 111;
pub const bpf_func_id_BPF_FUNC_probe_read_user: bpf_func_id = 112;
pub const bpf_func_id_BPF_FUNC_probe_read_kernel: bpf_func_id = 113;
pub const bpf_func_id_BPF_FUNC_probe_read_user_str: bpf_func_id = 114;
pub const bpf_func_id_BPF_FUNC_probe_read_kernel_str: bpf_func_id = 115;
pub const bpf_func_id_BPF_FUNC_tcp_send_ack: bpf_func_id = 116;
pub const bpf_func_id_BPF_FUNC_send_signal_thread: bpf_func_id = 117;
pub const bpf_func_id_BPF_FUNC_jiffies64: bpf_func_id = 118;
pub const bpf_func_id_BPF_FUNC_read_branch_records: bpf_func_id = 119;
pub const bpf_func_id_BPF_FUNC_get_ns_current_pid_tgid: bpf_func_id = 120;
pub const bpf_func_id_BPF_FUNC_xdp_output: bpf_func_id = 121;
pub const bpf_func_id_BPF_FUNC_get_netns_cookie: bpf_func_id = 122;
pub const bpf_func_id_BPF_FUNC_get_current_ancestor_cgroup_id: bpf_func_id = 123;
pub const bpf_func_id_BPF_FUNC_sk_assign: bpf_func_id = 124;
pub const bpf_func_id_BPF_FUNC_ktime_get_boot_ns: bpf_func_id = 125;
pub const bpf_func_id_BPF_FUNC_seq_printf: bpf_func_id = 126;
pub const bpf_func_id_BPF_FUNC_seq_write: bpf_func_id = 127;
pub const bpf_func_id_BPF_FUNC_sk_cgroup_id: bpf_func_id = 128;
pub const bpf_func_id_BPF_FUNC_sk_ancestor_cgroup_id: bpf_func_id = 129;
pub const bpf_func_id_BPF_FUNC_ringbuf_output: bpf_func_id = 130;
pub const bpf_func_id_BPF_FUNC_ringbuf_reserve: bpf_func_id = 131;
pub const bpf_func_id_BPF_FUNC_ringbuf_submit: bpf_func_id = 132;
pub const bpf_func_id_BPF_FUNC_ringbuf_discard: bpf_func_id = 133;
pub const bpf_func_id_BPF_FUNC_ringbuf_query: bpf_func_id = 134;
pub const bpf_func_id_BPF_FUNC_csum_level: bpf_func_id = 135;
pub const bpf_func_id_BPF_FUNC_skc_to_tcp6_sock: bpf_func_id = 136;
pub const bpf_func_id_BPF_FUNC_skc_to_tcp_sock: bpf_func_id = 137;
pub const bpf_func_id_BPF_FUNC_skc_to_tcp_timewait_sock: bpf_func_id = 138;
pub const bpf_func_id_BPF_FUNC_skc_to_tcp_request_sock: bpf_func_id = 139;
pub const bpf_func_id_BPF_FUNC_skc_to_udp6_sock: bpf_func_id = 140;
pub const bpf_func_id_BPF_FUNC_get_task_stack: bpf_func_id = 141;
pub const bpf_func_id_BPF_FUNC_load_hdr_opt: bpf_func_id = 142;
pub const bpf_func_id_BPF_FUNC_store_hdr_opt: bpf_func_id = 143;
pub const bpf_func_id_BPF_FUNC_reserve_hdr_opt: bpf_func_id = 144;
pub const bpf_func_id_BPF_FUNC_inode_storage_get: bpf_func_id = 145;
pub const bpf_func_id_BPF_FUNC_inode_storage_delete: bpf_func_id = 146;
pub const bpf_func_id_BPF_FUNC_d_path: bpf_func_id = 147;
pub const bpf_func_id_BPF_FUNC_copy_from_user: bpf_func_id = 148;
pub const bpf_func_id_BPF_FUNC_snprintf_btf: bpf_func_id = 149;
pub const bpf_func_id_BPF_FUNC_seq_printf_btf: bpf_func_id = 150;
pub const bpf_func_id_BPF_FUNC_skb_cgroup_classid: bpf_func_id = 151;
pub const bpf_func_id_BPF_FUNC_redirect_neigh: bpf_func_id = 152;
pub const bpf_func_id_BPF_FUNC_per_cpu_ptr: bpf_func_id = 153;
pub const bpf_func_id_BPF_FUNC_this_cpu_ptr: bpf_func_id = 154;
pub const bpf_func_id_BPF_FUNC_redirect_peer: bpf_func_id = 155;
pub const bpf_func_id_BPF_FUNC_task_storage_get: bpf_func_id = 156;
pub const bpf_func_id_BPF_FUNC_task_storage_delete: bpf_func_id = 157;
pub const bpf_func_id_BPF_FUNC_get_current_task_btf: bpf_func_id = 158;
pub const bpf_func_id_BPF_FUNC_bprm_opts_set: bpf_func_id = 159;
pub const bpf_func_id_BPF_FUNC_ktime_get_coarse_ns: bpf_func_id = 160;
pub const bpf_func_id_BPF_FUNC_ima_inode_hash: bpf_func_id = 161;
pub const bpf_func_id_BPF_FUNC_sock_from_file: bpf_func_id = 162;
pub const bpf_func_id_BPF_FUNC_check_mtu: bpf_func_id = 163;
pub const bpf_func_id_BPF_FUNC_for_each_map_elem: bpf_func_id = 164;
pub const bpf_func_id_BPF_FUNC_snprintf: bpf_func_id = 165;
pub const bpf_func_id_BPF_FUNC_sys_bpf: bpf_func_id = 166;
pub const bpf_func_id_BPF_FUNC_btf_find_by_name_kind: bpf_func_id = 167;
pub const bpf_func_id_BPF_FUNC_sys_close: bpf_func_id = 168;
pub const bpf_func_id_BPF_FUNC_timer_init: bpf_func_id = 169;
pub const bpf_func_id_BPF_FUNC_timer_set_callback: bpf_func_id = 170;
pub const bpf_func_id_BPF_FUNC_timer_start: bpf_func_id = 171;
pub const bpf_func_id_BPF_FUNC_timer_cancel: bpf_func_id = 172;
pub const bpf_func_id_BPF_FUNC_get_func_ip: bpf_func_id = 173;
pub const bpf_func_id_BPF_FUNC_get_attach_cookie: bpf_func_id = 174;
pub const bpf_func_id_BPF_FUNC_task_pt_regs: bpf_func_id = 175;
pub const bpf_func_id_BPF_FUNC_get_branch_snapshot: bpf_func_id = 176;
pub const bpf_func_id_BPF_FUNC_trace_vprintk: bpf_func_id = 177;
pub const bpf_func_id_BPF_FUNC_skc_to_unix_sock: bpf_func_id = 178;
pub const bpf_func_id_BPF_FUNC_kallsyms_lookup_name: bpf_func_id = 179;
pub const bpf_func_id_BPF_FUNC_find_vma: bpf_func_id = 180;
pub const bpf_func_id_BPF_FUNC_loop: bpf_func_id = 181;
pub const bpf_func_id_BPF_FUNC_strncmp: bpf_func_id = 182;
pub const bpf_func_id_BPF_FUNC_get_func_arg: bpf_func_id = 183;
pub const bpf_func_id_BPF_FUNC_get_func_ret: bpf_func_id = 184;
pub const bpf_func_id_BPF_FUNC_get_func_arg_cnt: bpf_func_id = 185;
pub const bpf_func_id_BPF_FUNC_get_retval: bpf_func_id = 186;
pub const bpf_func_id_BPF_FUNC_set_retval: bpf_func_id = 187;
pub const bpf_func_id_BPF_FUNC_xdp_get_buff_len: bpf_func_id = 188;
pub const bpf_func_id_BPF_FUNC_xdp_load_bytes: bpf_func_id = 189;
pub const bpf_func_id_BPF_FUNC_xdp_store_bytes: bpf_func_id = 190;
pub const bpf_func_id_BPF_FUNC_copy_from_user_task: bpf_func_id = 191;
pub const bpf_func_id_BPF_FUNC_skb_set_tstamp: bpf_func_id = 192;
pub const bpf_func_id_BPF_FUNC_ima_file_hash: bpf_func_id = 193;
pub const bpf_func_id_BPF_FUNC_kptr_xchg: bpf_func_id = 194;
pub const bpf_func_id_BPF_FUNC_map_lookup_percpu_elem: bpf_func_id = 195;
pub const bpf_func_id_BPF_FUNC_skc_to_mptcp_sock: bpf_func_id = 196;
pub const bpf_func_id_BPF_FUNC_dynptr_from_mem: bpf_func_id = 197;
pub const bpf_func_id_BPF_FUNC_ringbuf_reserve_dynptr: bpf_func_id = 198;
pub const bpf_func_id_BPF_FUNC_ringbuf_submit_dynptr: bpf_func_id = 199;
pub const bpf_func_id_BPF_FUNC_ringbuf_discard_dynptr: bpf_func_id = 200;
pub const bpf_func_id_BPF_FUNC_dynptr_read: bpf_func_id = 201;
pub const bpf_func_id_BPF_FUNC_dynptr_write: bpf_func_id = 202;
pub const bpf_func_id_BPF_FUNC_dynptr_data: bpf_func_id = 203;
pub const bpf_func_id_BPF_FUNC_tcp_raw_gen_syncookie_ipv4: bpf_func_id = 204;
pub const bpf_func_id_BPF_FUNC_tcp_raw_gen_syncookie_ipv6: bpf_func_id = 205;
pub const bpf_func_id_BPF_FUNC_tcp_raw_check_syncookie_ipv4: bpf_func_id = 206;
pub const bpf_func_id_BPF_FUNC_tcp_raw_check_syncookie_ipv6: bpf_func_id = 207;
pub const bpf_func_id_BPF_FUNC_ktime_get_tai_ns: bpf_func_id = 208;
pub const bpf_func_id_BPF_FUNC_user_ringbuf_drain: bpf_func_id = 209;
pub const bpf_func_id_BPF_FUNC_cgrp_storage_get: bpf_func_id = 210;
pub const bpf_func_id_BPF_FUNC_cgrp_storage_delete: bpf_func_id = 211;
pub const bpf_func_id___BPF_FUNC_MAX_ID: bpf_func_id = 212;
pub type bpf_func_id = ffi::c_uint;
pub const BPF_F_RECOMPUTE_CSUM: _bindgen_ty_209 = 1;
pub const BPF_F_INVALIDATE_HASH: _bindgen_ty_209 = 2;
pub type _bindgen_ty_209 = ffi::c_uint;
pub const BPF_F_HDR_FIELD_MASK: _bindgen_ty_210 = 15;
pub type _bindgen_ty_210 = ffi::c_uint;
pub const BPF_F_PSEUDO_HDR: _bindgen_ty_211 = 16;
pub const BPF_F_MARK_MANGLED_0: _bindgen_ty_211 = 32;
pub const BPF_F_MARK_ENFORCE: _bindgen_ty_211 = 64;
pub type _bindgen_ty_211 = ffi::c_uint;
pub const BPF_F_TUNINFO_IPV6: _bindgen_ty_212 = 1;
pub type _bindgen_ty_212 = ffi::c_uint;
pub const BPF_F_SKIP_FIELD_MASK: _bindgen_ty_213 = 255;
pub const BPF_F_USER_STACK: _bindgen_ty_213 = 256;
pub const BPF_F_FAST_STACK_CMP: _bindgen_ty_213 = 512;
pub const BPF_F_REUSE_STACKID: _bindgen_ty_213 = 1024;
pub const BPF_F_USER_BUILD_ID: _bindgen_ty_213 = 2048;
pub type _bindgen_ty_213 = ffi::c_uint;
pub const BPF_F_ZERO_CSUM_TX: _bindgen_ty_214 = 2;
pub const BPF_F_DONT_FRAGMENT: _bindgen_ty_214 = 4;
pub const BPF_F_SEQ_NUMBER: _bindgen_ty_214 = 8;
pub const BPF_F_NO_TUNNEL_KEY: _bindgen_ty_214 = 16;
pub type _bindgen_ty_214 = ffi::c_uint;
pub const BPF_F_TUNINFO_FLAGS: _bindgen_ty_215 = 16;
pub type _bindgen_ty_215 = ffi::c_uint;
pub const BPF_F_INDEX_MASK: _bindgen_ty_216 = 4294967295;
pub const BPF_F_CURRENT_CPU: _bindgen_ty_216 = 4294967295;
pub const BPF_F_CTXLEN_MASK: _bindgen_ty_216 = 4503595332403200;
pub type _bindgen_ty_216 = ffi::c_ulong;
pub const BPF_F_CURRENT_NETNS: _bindgen_ty_217 = -1;
pub type _bindgen_ty_217 = ffi::c_int;
pub const BPF_CSUM_LEVEL_QUERY: _bindgen_ty_218 = 0;
pub const BPF_CSUM_LEVEL_INC: _bindgen_ty_218 = 1;
pub const BPF_CSUM_LEVEL_DEC: _bindgen_ty_218 = 2;
pub const BPF_CSUM_LEVEL_RESET: _bindgen_ty_218 = 3;
pub type _bindgen_ty_218 = ffi::c_uint;
pub const BPF_F_ADJ_ROOM_FIXED_GSO: _bindgen_ty_219 = 1;
pub const BPF_F_ADJ_ROOM_ENCAP_L3_IPV4: _bindgen_ty_219 = 2;
pub const BPF_F_ADJ_ROOM_ENCAP_L3_IPV6: _bindgen_ty_219 = 4;
pub const BPF_F_ADJ_ROOM_ENCAP_L4_GRE: _bindgen_ty_219 = 8;
pub const BPF_F_ADJ_ROOM_ENCAP_L4_UDP: _bindgen_ty_219 = 16;
pub const BPF_F_ADJ_ROOM_NO_CSUM_RESET: _bindgen_ty_219 = 32;
pub const BPF_F_ADJ_ROOM_ENCAP_L2_ETH: _bindgen_ty_219 = 64;
pub const BPF_F_ADJ_ROOM_DECAP_L3_IPV4: _bindgen_ty_219 = 128;
pub const BPF_F_ADJ_ROOM_DECAP_L3_IPV6: _bindgen_ty_219 = 256;
pub type _bindgen_ty_219 = ffi::c_uint;
pub const BPF_ADJ_ROOM_ENCAP_L2_MASK: _bindgen_ty_220 = 255;
pub const BPF_ADJ_ROOM_ENCAP_L2_SHIFT: _bindgen_ty_220 = 56;
pub type _bindgen_ty_220 = ffi::c_uint;
pub const BPF_F_SYSCTL_BASE_NAME: _bindgen_ty_221 = 1;
pub type _bindgen_ty_221 = ffi::c_uint;
pub const BPF_LOCAL_STORAGE_GET_F_CREATE: _bindgen_ty_222 = 1;
pub const BPF_SK_STORAGE_GET_F_CREATE: _bindgen_ty_222 = 1;
pub type _bindgen_ty_222 = ffi::c_uint;
pub const BPF_F_GET_BRANCH_RECORDS_SIZE: _bindgen_ty_223 = 1;
pub type _bindgen_ty_223 = ffi::c_uint;
pub const BPF_RB_NO_WAKEUP: _bindgen_ty_224 = 1;
pub const BPF_RB_FORCE_WAKEUP: _bindgen_ty_224 = 2;
pub type _bindgen_ty_224 = ffi::c_uint;
pub const BPF_RB_AVAIL_DATA: _bindgen_ty_225 = 0;
pub const BPF_RB_RING_SIZE: _bindgen_ty_225 = 1;
pub const BPF_RB_CONS_POS: _bindgen_ty_225 = 2;
pub const BPF_RB_PROD_POS: _bindgen_ty_225 = 3;
pub type _bindgen_ty_225 = ffi::c_uint;
pub const BPF_RINGBUF_BUSY_BIT: _bindgen_ty_226 = 2147483648;
pub const BPF_RINGBUF_DISCARD_BIT: _bindgen_ty_226 = 1073741824;
pub const BPF_RINGBUF_HDR_SZ: _bindgen_ty_226 = 8;
pub type _bindgen_ty_226 = ffi::c_uint;
pub const BPF_SK_LOOKUP_F_REPLACE: _bindgen_ty_227 = 1;
pub const BPF_SK_LOOKUP_F_NO_REUSEPORT: _bindgen_ty_227 = 2;
pub type _bindgen_ty_227 = ffi::c_uint;
pub const bpf_adj_room_mode_BPF_ADJ_ROOM_NET: bpf_adj_room_mode = 0;
pub const bpf_adj_room_mode_BPF_ADJ_ROOM_MAC: bpf_adj_room_mode = 1;
pub type bpf_adj_room_mode = ffi::c_uint;
pub const bpf_hdr_start_off_BPF_HDR_START_MAC: bpf_hdr_start_off = 0;
pub const bpf_hdr_start_off_BPF_HDR_START_NET: bpf_hdr_start_off = 1;
pub type bpf_hdr_start_off = ffi::c_uint;
pub const bpf_lwt_encap_mode_BPF_LWT_ENCAP_SEG6: bpf_lwt_encap_mode = 0;
pub const bpf_lwt_encap_mode_BPF_LWT_ENCAP_SEG6_INLINE: bpf_lwt_encap_mode = 1;
pub const bpf_lwt_encap_mode_BPF_LWT_ENCAP_IP: bpf_lwt_encap_mode = 2;
pub type bpf_lwt_encap_mode = ffi::c_uint;
pub const BPF_F_BPRM_SECUREEXEC: _bindgen_ty_228 = 1;
pub type _bindgen_ty_228 = ffi::c_uint;
pub const BPF_F_INGRESS: _bindgen_ty_229 = 1;
pub const BPF_F_BROADCAST: _bindgen_ty_229 = 8;
pub const BPF_F_EXCLUDE_INGRESS: _bindgen_ty_229 = 16;
pub type _bindgen_ty_229 = ffi::c_uint;
pub const BPF_SKB_TSTAMP_UNSPEC: _bindgen_ty_230 = 0;
pub const BPF_SKB_TSTAMP_DELIVERY_MONO: _bindgen_ty_230 = 1;
pub const BPF_SKB_CLOCK_REALTIME: _bindgen_ty_230 = 0;
pub const BPF_SKB_CLOCK_MONOTONIC: _bindgen_ty_230 = 1;
pub const BPF_SKB_CLOCK_TAI: _bindgen_ty_230 = 2;
pub type _bindgen_ty_230 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct __sk_buff {
    pub len: __u32,
    pub pkt_type: __u32,
    pub mark: __u32,
    pub queue_mapping: __u32,
    pub protocol: __u32,
    pub vlan_present: __u32,
    pub vlan_tci: __u32,
    pub vlan_proto: __u32,
    pub priority: __u32,
    pub ingress_ifindex: __u32,
    pub ifindex: __u32,
    pub tc_index: __u32,
    pub cb: [__u32; 5usize],
    pub hash: __u32,
    pub tc_classid: __u32,
    pub data: __u32,
    pub data_end: __u32,
    pub napi_id: __u32,
    pub family: __u32,
    pub remote_ip4: __u32,
    pub local_ip4: __u32,
    pub remote_ip6: [__u32; 4usize],
    pub local_ip6: [__u32; 4usize],
    pub remote_port: __u32,
    pub local_port: __u32,
    pub data_meta: __u32,
    pub __bindgen_anon_1: __sk_buff__bindgen_ty_1,
    pub tstamp: __u64,
    pub wire_len: __u32,
    pub gso_segs: __u32,
    pub __bindgen_anon_2: __sk_buff__bindgen_ty_2,
    pub gso_size: __u32,
    pub tstamp_type: __u8,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 3usize]>,
    pub hwtstamp: __u64,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union __sk_buff__bindgen_ty_1 {
    pub flow_keys: *mut bpf_flow_keys,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
impl Default for __sk_buff__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl __sk_buff__bindgen_ty_1 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union __sk_buff__bindgen_ty_2 {
    pub sk: *mut bpf_sock,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
impl Default for __sk_buff__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl __sk_buff__bindgen_ty_2 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
impl Default for __sk_buff {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl __sk_buff {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 3usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 3usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_tunnel_key {
    pub tunnel_id: __u32,
    pub __bindgen_anon_1: bpf_tunnel_key__bindgen_ty_1,
    pub tunnel_tos: __u8,
    pub tunnel_ttl: __u8,
    pub __bindgen_anon_2: bpf_tunnel_key__bindgen_ty_2,
    pub tunnel_label: __u32,
    pub __bindgen_anon_3: bpf_tunnel_key__bindgen_ty_3,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_tunnel_key__bindgen_ty_1 {
    pub remote_ipv4: __u32,
    pub remote_ipv6: [__u32; 4usize],
}
impl Default for bpf_tunnel_key__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_tunnel_key__bindgen_ty_2 {
    pub tunnel_ext: __u16,
    pub tunnel_flags: __be16,
}
impl Default for bpf_tunnel_key__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_tunnel_key__bindgen_ty_3 {
    pub local_ipv4: __u32,
    pub local_ipv6: [__u32; 4usize],
}
impl Default for bpf_tunnel_key__bindgen_ty_3 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_tunnel_key {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_xfrm_state {
    pub reqid: __u32,
    pub spi: __u32,
    pub family: __u16,
    pub ext: __u16,
    pub __bindgen_anon_1: bpf_xfrm_state__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_xfrm_state__bindgen_ty_1 {
    pub remote_ipv4: __u32,
    pub remote_ipv6: [__u32; 4usize],
}
impl Default for bpf_xfrm_state__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_xfrm_state {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const bpf_ret_code_BPF_OK: bpf_ret_code = 0;
pub const bpf_ret_code_BPF_DROP: bpf_ret_code = 2;
pub const bpf_ret_code_BPF_REDIRECT: bpf_ret_code = 7;
pub const bpf_ret_code_BPF_LWT_REROUTE: bpf_ret_code = 128;
pub const bpf_ret_code_BPF_FLOW_DISSECTOR_CONTINUE: bpf_ret_code = 129;
pub type bpf_ret_code = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_sock {
    pub bound_dev_if: __u32,
    pub family: __u32,
    pub type_: __u32,
    pub protocol: __u32,
    pub mark: __u32,
    pub priority: __u32,
    pub src_ip4: __u32,
    pub src_ip6: [__u32; 4usize],
    pub src_port: __u32,
    pub dst_port: __be16,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
    pub dst_ip4: __u32,
    pub dst_ip6: [__u32; 4usize],
    pub state: __u32,
    pub rx_queue_mapping: __s32,
}
impl bpf_sock {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_tcp_sock {
    pub snd_cwnd: __u32,
    pub srtt_us: __u32,
    pub rtt_min: __u32,
    pub snd_ssthresh: __u32,
    pub rcv_nxt: __u32,
    pub snd_nxt: __u32,
    pub snd_una: __u32,
    pub mss_cache: __u32,
    pub ecn_flags: __u32,
    pub rate_delivered: __u32,
    pub rate_interval_us: __u32,
    pub packets_out: __u32,
    pub retrans_out: __u32,
    pub total_retrans: __u32,
    pub segs_in: __u32,
    pub data_segs_in: __u32,
    pub segs_out: __u32,
    pub data_segs_out: __u32,
    pub lost_out: __u32,
    pub sacked_out: __u32,
    pub bytes_received: __u64,
    pub bytes_acked: __u64,
    pub dsack_dups: __u32,
    pub delivered: __u32,
    pub delivered_ce: __u32,
    pub icsk_retransmits: __u32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_sock_tuple {
    pub __bindgen_anon_1: bpf_sock_tuple__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_sock_tuple__bindgen_ty_1 {
    pub ipv4: bpf_sock_tuple__bindgen_ty_1__bindgen_ty_1,
    pub ipv6: bpf_sock_tuple__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_sock_tuple__bindgen_ty_1__bindgen_ty_1 {
    pub saddr: __be32,
    pub daddr: __be32,
    pub sport: __be16,
    pub dport: __be16,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_sock_tuple__bindgen_ty_1__bindgen_ty_2 {
    pub saddr: [__be32; 4usize],
    pub daddr: [__be32; 4usize],
    pub sport: __be16,
    pub dport: __be16,
}
impl Default for bpf_sock_tuple__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_sock_tuple {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const tcx_action_base_TCX_NEXT: tcx_action_base = -1;
pub const tcx_action_base_TCX_PASS: tcx_action_base = 0;
pub const tcx_action_base_TCX_DROP: tcx_action_base = 2;
pub const tcx_action_base_TCX_REDIRECT: tcx_action_base = 7;
pub type tcx_action_base = ffi::c_int;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_xdp_sock {
    pub queue_id: __u32,
}
pub const xdp_action_XDP_ABORTED: xdp_action = 0;
pub const xdp_action_XDP_DROP: xdp_action = 1;
pub const xdp_action_XDP_PASS: xdp_action = 2;
pub const xdp_action_XDP_TX: xdp_action = 3;
pub const xdp_action_XDP_REDIRECT: xdp_action = 4;
pub type xdp_action = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct xdp_md {
    pub data: __u32,
    pub data_end: __u32,
    pub data_meta: __u32,
    pub ingress_ifindex: __u32,
    pub rx_queue_index: __u32,
    pub egress_ifindex: __u32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_devmap_val {
    pub ifindex: __u32,
    pub bpf_prog: bpf_devmap_val__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_devmap_val__bindgen_ty_1 {
    pub fd: ffi::c_int,
    pub id: __u32,
}
impl Default for bpf_devmap_val__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_devmap_val {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_cpumap_val {
    pub qsize: __u32,
    pub bpf_prog: bpf_cpumap_val__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_cpumap_val__bindgen_ty_1 {
    pub fd: ffi::c_int,
    pub id: __u32,
}
impl Default for bpf_cpumap_val__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_cpumap_val {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const sk_action_SK_DROP: sk_action = 0;
pub const sk_action_SK_PASS: sk_action = 1;
pub type sk_action = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sk_msg_md {
    pub __bindgen_anon_1: sk_msg_md__bindgen_ty_1,
    pub __bindgen_anon_2: sk_msg_md__bindgen_ty_2,
    pub family: __u32,
    pub remote_ip4: __u32,
    pub local_ip4: __u32,
    pub remote_ip6: [__u32; 4usize],
    pub local_ip6: [__u32; 4usize],
    pub remote_port: __u32,
    pub local_port: __u32,
    pub size: __u32,
    pub __bindgen_anon_3: sk_msg_md__bindgen_ty_3,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sk_msg_md__bindgen_ty_1 {
    pub data: *mut ffi::c_void,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
impl Default for sk_msg_md__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl sk_msg_md__bindgen_ty_1 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sk_msg_md__bindgen_ty_2 {
    pub data_end: *mut ffi::c_void,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
impl Default for sk_msg_md__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl sk_msg_md__bindgen_ty_2 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sk_msg_md__bindgen_ty_3 {
    pub sk: *mut bpf_sock,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
impl Default for sk_msg_md__bindgen_ty_3 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl sk_msg_md__bindgen_ty_3 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
impl Default for sk_msg_md {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sk_reuseport_md {
    pub __bindgen_anon_1: sk_reuseport_md__bindgen_ty_1,
    pub __bindgen_anon_2: sk_reuseport_md__bindgen_ty_2,
    pub len: __u32,
    pub eth_protocol: __u32,
    pub ip_protocol: __u32,
    pub bind_inany: __u32,
    pub hash: __u32,
    pub __bindgen_anon_3: sk_reuseport_md__bindgen_ty_3,
    pub __bindgen_anon_4: sk_reuseport_md__bindgen_ty_4,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sk_reuseport_md__bindgen_ty_1 {
    pub data: *mut ffi::c_void,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
impl Default for sk_reuseport_md__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl sk_reuseport_md__bindgen_ty_1 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sk_reuseport_md__bindgen_ty_2 {
    pub data_end: *mut ffi::c_void,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
impl Default for sk_reuseport_md__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl sk_reuseport_md__bindgen_ty_2 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sk_reuseport_md__bindgen_ty_3 {
    pub sk: *mut bpf_sock,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
impl Default for sk_reuseport_md__bindgen_ty_3 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl sk_reuseport_md__bindgen_ty_3 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union sk_reuseport_md__bindgen_ty_4 {
    pub migrating_sk: *mut bpf_sock,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
impl Default for sk_reuseport_md__bindgen_ty_4 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl sk_reuseport_md__bindgen_ty_4 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
impl Default for sk_reuseport_md {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_prog_info {
    pub type_: __u32,
    pub id: __u32,
    pub tag: [__u8; 8usize],
    pub jited_prog_len: __u32,
    pub xlated_prog_len: __u32,
    pub jited_prog_insns: __u64,
    pub xlated_prog_insns: __u64,
    pub load_time: __u64,
    pub created_by_uid: __u32,
    pub nr_map_ids: __u32,
    pub map_ids: __u64,
    pub name: [ffi::c_char; 16usize],
    pub ifindex: __u32,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
    pub netns_dev: __u64,
    pub netns_ino: __u64,
    pub nr_jited_ksyms: __u32,
    pub nr_jited_func_lens: __u32,
    pub jited_ksyms: __u64,
    pub jited_func_lens: __u64,
    pub btf_id: __u32,
    pub func_info_rec_size: __u32,
    pub func_info: __u64,
    pub nr_func_info: __u32,
    pub nr_line_info: __u32,
    pub line_info: __u64,
    pub jited_line_info: __u64,
    pub nr_jited_line_info: __u32,
    pub line_info_rec_size: __u32,
    pub jited_line_info_rec_size: __u32,
    pub nr_prog_tags: __u32,
    pub prog_tags: __u64,
    pub run_time_ns: __u64,
    pub run_cnt: __u64,
    pub recursion_misses: __u64,
    pub verified_insns: __u32,
    pub attach_btf_obj_id: __u32,
    pub attach_btf_id: __u32,
}
impl bpf_prog_info {
    #[inline]
    pub fn gpl_compatible(&self) -> __u32 {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_gpl_compatible(&mut self, val: __u32) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn gpl_compatible_raw(this: *const Self) -> __u32 {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_gpl_compatible_raw(this: *mut Self, val: __u32) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(gpl_compatible: __u32) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let gpl_compatible: u32 = unsafe { ::core::mem::transmute(gpl_compatible) };
            gpl_compatible as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_map_info {
    pub type_: __u32,
    pub id: __u32,
    pub key_size: __u32,
    pub value_size: __u32,
    pub max_entries: __u32,
    pub map_flags: __u32,
    pub name: [ffi::c_char; 16usize],
    pub ifindex: __u32,
    pub btf_vmlinux_value_type_id: __u32,
    pub netns_dev: __u64,
    pub netns_ino: __u64,
    pub btf_id: __u32,
    pub btf_key_type_id: __u32,
    pub btf_value_type_id: __u32,
    pub btf_vmlinux_id: __u32,
    pub map_extra: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_btf_info {
    pub btf: __u64,
    pub btf_size: __u32,
    pub id: __u32,
    pub name: __u64,
    pub name_len: __u32,
    pub kernel_btf: __u32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_link_info {
    pub type_: __u32,
    pub id: __u32,
    pub prog_id: __u32,
    pub __bindgen_anon_1: bpf_link_info__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_link_info__bindgen_ty_1 {
    pub raw_tracepoint: bpf_link_info__bindgen_ty_1__bindgen_ty_1,
    pub tracing: bpf_link_info__bindgen_ty_1__bindgen_ty_2,
    pub cgroup: bpf_link_info__bindgen_ty_1__bindgen_ty_3,
    pub iter: bpf_link_info__bindgen_ty_1__bindgen_ty_4,
    pub netns: bpf_link_info__bindgen_ty_1__bindgen_ty_5,
    pub xdp: bpf_link_info__bindgen_ty_1__bindgen_ty_6,
    pub struct_ops: bpf_link_info__bindgen_ty_1__bindgen_ty_7,
    pub netfilter: bpf_link_info__bindgen_ty_1__bindgen_ty_8,
    pub kprobe_multi: bpf_link_info__bindgen_ty_1__bindgen_ty_9,
    pub uprobe_multi: bpf_link_info__bindgen_ty_1__bindgen_ty_10,
    pub perf_event: bpf_link_info__bindgen_ty_1__bindgen_ty_11,
    pub tcx: bpf_link_info__bindgen_ty_1__bindgen_ty_12,
    pub netkit: bpf_link_info__bindgen_ty_1__bindgen_ty_13,
    pub sockmap: bpf_link_info__bindgen_ty_1__bindgen_ty_14,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_link_info__bindgen_ty_1__bindgen_ty_1 {
    pub tp_name: __u64,
    pub tp_name_len: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_link_info__bindgen_ty_1__bindgen_ty_2 {
    pub attach_type: __u32,
    pub target_obj_id: __u32,
    pub target_btf_id: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_link_info__bindgen_ty_1__bindgen_ty_3 {
    pub cgroup_id: __u64,
    pub attach_type: __u32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_link_info__bindgen_ty_1__bindgen_ty_4 {
    pub target_name: __u64,
    pub target_name_len: __u32,
    pub __bindgen_anon_1: bpf_link_info__bindgen_ty_1__bindgen_ty_4__bindgen_ty_1,
    pub __bindgen_anon_2: bpf_link_info__bindgen_ty_1__bindgen_ty_4__bindgen_ty_2,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_link_info__bindgen_ty_1__bindgen_ty_4__bindgen_ty_1 {
    pub map: bpf_link_info__bindgen_ty_1__bindgen_ty_4__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_link_info__bindgen_ty_1__bindgen_ty_4__bindgen_ty_1__bindgen_ty_1 {
    pub map_id: __u32,
}
impl Default for bpf_link_info__bindgen_ty_1__bindgen_ty_4__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_link_info__bindgen_ty_1__bindgen_ty_4__bindgen_ty_2 {
    pub cgroup: bpf_link_info__bindgen_ty_1__bindgen_ty_4__bindgen_ty_2__bindgen_ty_1,
    pub task: bpf_link_info__bindgen_ty_1__bindgen_ty_4__bindgen_ty_2__bindgen_ty_2,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_link_info__bindgen_ty_1__bindgen_ty_4__bindgen_ty_2__bindgen_ty_1 {
    pub cgroup_id: __u64,
    pub order: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_link_info__bindgen_ty_1__bindgen_ty_4__bindgen_ty_2__bindgen_ty_2 {
    pub tid: __u32,
    pub pid: __u32,
}
impl Default for bpf_link_info__bindgen_ty_1__bindgen_ty_4__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_link_info__bindgen_ty_1__bindgen_ty_4 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_link_info__bindgen_ty_1__bindgen_ty_5 {
    pub netns_ino: __u32,
    pub attach_type: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_link_info__bindgen_ty_1__bindgen_ty_6 {
    pub ifindex: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_link_info__bindgen_ty_1__bindgen_ty_7 {
    pub map_id: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_link_info__bindgen_ty_1__bindgen_ty_8 {
    pub pf: __u32,
    pub hooknum: __u32,
    pub priority: __s32,
    pub flags: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_link_info__bindgen_ty_1__bindgen_ty_9 {
    pub addrs: __u64,
    pub count: __u32,
    pub flags: __u32,
    pub missed: __u64,
    pub cookies: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_link_info__bindgen_ty_1__bindgen_ty_10 {
    pub path: __u64,
    pub offsets: __u64,
    pub ref_ctr_offsets: __u64,
    pub cookies: __u64,
    pub path_size: __u32,
    pub count: __u32,
    pub flags: __u32,
    pub pid: __u32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_link_info__bindgen_ty_1__bindgen_ty_11 {
    pub type_: __u32,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
    pub __bindgen_anon_1: bpf_link_info__bindgen_ty_1__bindgen_ty_11__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_link_info__bindgen_ty_1__bindgen_ty_11__bindgen_ty_1 {
    pub uprobe: bpf_link_info__bindgen_ty_1__bindgen_ty_11__bindgen_ty_1__bindgen_ty_1,
    pub kprobe: bpf_link_info__bindgen_ty_1__bindgen_ty_11__bindgen_ty_1__bindgen_ty_2,
    pub tracepoint: bpf_link_info__bindgen_ty_1__bindgen_ty_11__bindgen_ty_1__bindgen_ty_3,
    pub event: bpf_link_info__bindgen_ty_1__bindgen_ty_11__bindgen_ty_1__bindgen_ty_4,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_link_info__bindgen_ty_1__bindgen_ty_11__bindgen_ty_1__bindgen_ty_1 {
    pub file_name: __u64,
    pub name_len: __u32,
    pub offset: __u32,
    pub cookie: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_link_info__bindgen_ty_1__bindgen_ty_11__bindgen_ty_1__bindgen_ty_2 {
    pub func_name: __u64,
    pub name_len: __u32,
    pub offset: __u32,
    pub addr: __u64,
    pub missed: __u64,
    pub cookie: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_link_info__bindgen_ty_1__bindgen_ty_11__bindgen_ty_1__bindgen_ty_3 {
    pub tp_name: __u64,
    pub name_len: __u32,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
    pub cookie: __u64,
}
impl bpf_link_info__bindgen_ty_1__bindgen_ty_11__bindgen_ty_1__bindgen_ty_3 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_link_info__bindgen_ty_1__bindgen_ty_11__bindgen_ty_1__bindgen_ty_4 {
    pub config: __u64,
    pub type_: __u32,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
    pub cookie: __u64,
}
impl bpf_link_info__bindgen_ty_1__bindgen_ty_11__bindgen_ty_1__bindgen_ty_4 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
impl Default for bpf_link_info__bindgen_ty_1__bindgen_ty_11__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_link_info__bindgen_ty_1__bindgen_ty_11 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl bpf_link_info__bindgen_ty_1__bindgen_ty_11 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_link_info__bindgen_ty_1__bindgen_ty_12 {
    pub ifindex: __u32,
    pub attach_type: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_link_info__bindgen_ty_1__bindgen_ty_13 {
    pub ifindex: __u32,
    pub attach_type: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_link_info__bindgen_ty_1__bindgen_ty_14 {
    pub map_id: __u32,
    pub attach_type: __u32,
}
impl Default for bpf_link_info__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_link_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_sock_addr {
    pub user_family: __u32,
    pub user_ip4: __u32,
    pub user_ip6: [__u32; 4usize],
    pub user_port: __u32,
    pub family: __u32,
    pub type_: __u32,
    pub protocol: __u32,
    pub msg_src_ip4: __u32,
    pub msg_src_ip6: [__u32; 4usize],
    pub __bindgen_anon_1: bpf_sock_addr__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_sock_addr__bindgen_ty_1 {
    pub sk: *mut bpf_sock,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
impl Default for bpf_sock_addr__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl bpf_sock_addr__bindgen_ty_1 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
impl Default for bpf_sock_addr {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_sock_ops {
    pub op: __u32,
    pub __bindgen_anon_1: bpf_sock_ops__bindgen_ty_1,
    pub family: __u32,
    pub remote_ip4: __u32,
    pub local_ip4: __u32,
    pub remote_ip6: [__u32; 4usize],
    pub local_ip6: [__u32; 4usize],
    pub remote_port: __u32,
    pub local_port: __u32,
    pub is_fullsock: __u32,
    pub snd_cwnd: __u32,
    pub srtt_us: __u32,
    pub bpf_sock_ops_cb_flags: __u32,
    pub state: __u32,
    pub rtt_min: __u32,
    pub snd_ssthresh: __u32,
    pub rcv_nxt: __u32,
    pub snd_nxt: __u32,
    pub snd_una: __u32,
    pub mss_cache: __u32,
    pub ecn_flags: __u32,
    pub rate_delivered: __u32,
    pub rate_interval_us: __u32,
    pub packets_out: __u32,
    pub retrans_out: __u32,
    pub total_retrans: __u32,
    pub segs_in: __u32,
    pub data_segs_in: __u32,
    pub segs_out: __u32,
    pub data_segs_out: __u32,
    pub lost_out: __u32,
    pub sacked_out: __u32,
    pub sk_txhash: __u32,
    pub bytes_received: __u64,
    pub bytes_acked: __u64,
    pub __bindgen_anon_2: bpf_sock_ops__bindgen_ty_2,
    pub __bindgen_anon_3: bpf_sock_ops__bindgen_ty_3,
    pub __bindgen_anon_4: bpf_sock_ops__bindgen_ty_4,
    pub skb_len: __u32,
    pub skb_tcp_flags: __u32,
    pub skb_hwtstamp: __u64,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_sock_ops__bindgen_ty_1 {
    pub args: [__u32; 4usize],
    pub reply: __u32,
    pub replylong: [__u32; 4usize],
}
impl Default for bpf_sock_ops__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_sock_ops__bindgen_ty_2 {
    pub sk: *mut bpf_sock,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
impl Default for bpf_sock_ops__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl bpf_sock_ops__bindgen_ty_2 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_sock_ops__bindgen_ty_3 {
    pub skb_data: *mut ffi::c_void,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
impl Default for bpf_sock_ops__bindgen_ty_3 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl bpf_sock_ops__bindgen_ty_3 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_sock_ops__bindgen_ty_4 {
    pub skb_data_end: *mut ffi::c_void,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
impl Default for bpf_sock_ops__bindgen_ty_4 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl bpf_sock_ops__bindgen_ty_4 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
impl Default for bpf_sock_ops {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const BPF_SOCK_OPS_RTO_CB_FLAG: _bindgen_ty_231 = 1;
pub const BPF_SOCK_OPS_RETRANS_CB_FLAG: _bindgen_ty_231 = 2;
pub const BPF_SOCK_OPS_STATE_CB_FLAG: _bindgen_ty_231 = 4;
pub const BPF_SOCK_OPS_RTT_CB_FLAG: _bindgen_ty_231 = 8;
pub const BPF_SOCK_OPS_PARSE_ALL_HDR_OPT_CB_FLAG: _bindgen_ty_231 = 16;
pub const BPF_SOCK_OPS_PARSE_UNKNOWN_HDR_OPT_CB_FLAG: _bindgen_ty_231 = 32;
pub const BPF_SOCK_OPS_WRITE_HDR_OPT_CB_FLAG: _bindgen_ty_231 = 64;
pub const BPF_SOCK_OPS_ALL_CB_FLAGS: _bindgen_ty_231 = 127;
pub type _bindgen_ty_231 = ffi::c_uint;
pub const SK_BPF_CB_TX_TIMESTAMPING: _bindgen_ty_232 = 1;
pub const SK_BPF_CB_MASK: _bindgen_ty_232 = 1;
pub type _bindgen_ty_232 = ffi::c_uint;
pub const BPF_SOCK_OPS_VOID: _bindgen_ty_233 = 0;
pub const BPF_SOCK_OPS_TIMEOUT_INIT: _bindgen_ty_233 = 1;
pub const BPF_SOCK_OPS_RWND_INIT: _bindgen_ty_233 = 2;
pub const BPF_SOCK_OPS_TCP_CONNECT_CB: _bindgen_ty_233 = 3;
pub const BPF_SOCK_OPS_ACTIVE_ESTABLISHED_CB: _bindgen_ty_233 = 4;
pub const BPF_SOCK_OPS_PASSIVE_ESTABLISHED_CB: _bindgen_ty_233 = 5;
pub const BPF_SOCK_OPS_NEEDS_ECN: _bindgen_ty_233 = 6;
pub const BPF_SOCK_OPS_BASE_RTT: _bindgen_ty_233 = 7;
pub const BPF_SOCK_OPS_RTO_CB: _bindgen_ty_233 = 8;
pub const BPF_SOCK_OPS_RETRANS_CB: _bindgen_ty_233 = 9;
pub const BPF_SOCK_OPS_STATE_CB: _bindgen_ty_233 = 10;
pub const BPF_SOCK_OPS_TCP_LISTEN_CB: _bindgen_ty_233 = 11;
pub const BPF_SOCK_OPS_RTT_CB: _bindgen_ty_233 = 12;
pub const BPF_SOCK_OPS_PARSE_HDR_OPT_CB: _bindgen_ty_233 = 13;
pub const BPF_SOCK_OPS_HDR_OPT_LEN_CB: _bindgen_ty_233 = 14;
pub const BPF_SOCK_OPS_WRITE_HDR_OPT_CB: _bindgen_ty_233 = 15;
pub const BPF_SOCK_OPS_TSTAMP_SCHED_CB: _bindgen_ty_233 = 16;
pub const BPF_SOCK_OPS_TSTAMP_SND_SW_CB: _bindgen_ty_233 = 17;
pub const BPF_SOCK_OPS_TSTAMP_SND_HW_CB: _bindgen_ty_233 = 18;
pub const BPF_SOCK_OPS_TSTAMP_ACK_CB: _bindgen_ty_233 = 19;
pub const BPF_SOCK_OPS_TSTAMP_SENDMSG_CB: _bindgen_ty_233 = 20;
pub type _bindgen_ty_233 = ffi::c_uint;
pub const BPF_TCP_ESTABLISHED: _bindgen_ty_234 = 1;
pub const BPF_TCP_SYN_SENT: _bindgen_ty_234 = 2;
pub const BPF_TCP_SYN_RECV: _bindgen_ty_234 = 3;
pub const BPF_TCP_FIN_WAIT1: _bindgen_ty_234 = 4;
pub const BPF_TCP_FIN_WAIT2: _bindgen_ty_234 = 5;
pub const BPF_TCP_TIME_WAIT: _bindgen_ty_234 = 6;
pub const BPF_TCP_CLOSE: _bindgen_ty_234 = 7;
pub const BPF_TCP_CLOSE_WAIT: _bindgen_ty_234 = 8;
pub const BPF_TCP_LAST_ACK: _bindgen_ty_234 = 9;
pub const BPF_TCP_LISTEN: _bindgen_ty_234 = 10;
pub const BPF_TCP_CLOSING: _bindgen_ty_234 = 11;
pub const BPF_TCP_NEW_SYN_RECV: _bindgen_ty_234 = 12;
pub const BPF_TCP_BOUND_INACTIVE: _bindgen_ty_234 = 13;
pub const BPF_TCP_MAX_STATES: _bindgen_ty_234 = 14;
pub type _bindgen_ty_234 = ffi::c_uint;
pub const TCP_BPF_IW: _bindgen_ty_235 = 1001;
pub const TCP_BPF_SNDCWND_CLAMP: _bindgen_ty_235 = 1002;
pub const TCP_BPF_DELACK_MAX: _bindgen_ty_235 = 1003;
pub const TCP_BPF_RTO_MIN: _bindgen_ty_235 = 1004;
pub const TCP_BPF_SYN: _bindgen_ty_235 = 1005;
pub const TCP_BPF_SYN_IP: _bindgen_ty_235 = 1006;
pub const TCP_BPF_SYN_MAC: _bindgen_ty_235 = 1007;
pub const TCP_BPF_SOCK_OPS_CB_FLAGS: _bindgen_ty_235 = 1008;
pub const SK_BPF_CB_FLAGS: _bindgen_ty_235 = 1009;
pub type _bindgen_ty_235 = ffi::c_uint;
pub const BPF_LOAD_HDR_OPT_TCP_SYN: _bindgen_ty_236 = 1;
pub type _bindgen_ty_236 = ffi::c_uint;
pub const BPF_WRITE_HDR_TCP_CURRENT_MSS: _bindgen_ty_237 = 1;
pub const BPF_WRITE_HDR_TCP_SYNACK_COOKIE: _bindgen_ty_237 = 2;
pub type _bindgen_ty_237 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_perf_event_value {
    pub counter: __u64,
    pub enabled: __u64,
    pub running: __u64,
}
pub const BPF_DEVCG_ACC_MKNOD: _bindgen_ty_238 = 1;
pub const BPF_DEVCG_ACC_READ: _bindgen_ty_238 = 2;
pub const BPF_DEVCG_ACC_WRITE: _bindgen_ty_238 = 4;
pub type _bindgen_ty_238 = ffi::c_uint;
pub const BPF_DEVCG_DEV_BLOCK: _bindgen_ty_239 = 1;
pub const BPF_DEVCG_DEV_CHAR: _bindgen_ty_239 = 2;
pub type _bindgen_ty_239 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_cgroup_dev_ctx {
    pub access_type: __u32,
    pub major: __u32,
    pub minor: __u32,
}
#[repr(C)]
#[derive(Default)]
pub struct bpf_raw_tracepoint_args {
    pub args: __IncompleteArrayField<__u64>,
}
pub const BPF_FIB_LOOKUP_DIRECT: _bindgen_ty_240 = 1;
pub const BPF_FIB_LOOKUP_OUTPUT: _bindgen_ty_240 = 2;
pub const BPF_FIB_LOOKUP_SKIP_NEIGH: _bindgen_ty_240 = 4;
pub const BPF_FIB_LOOKUP_TBID: _bindgen_ty_240 = 8;
pub const BPF_FIB_LOOKUP_SRC: _bindgen_ty_240 = 16;
pub const BPF_FIB_LOOKUP_MARK: _bindgen_ty_240 = 32;
pub type _bindgen_ty_240 = ffi::c_uint;
pub const BPF_FIB_LKUP_RET_SUCCESS: _bindgen_ty_241 = 0;
pub const BPF_FIB_LKUP_RET_BLACKHOLE: _bindgen_ty_241 = 1;
pub const BPF_FIB_LKUP_RET_UNREACHABLE: _bindgen_ty_241 = 2;
pub const BPF_FIB_LKUP_RET_PROHIBIT: _bindgen_ty_241 = 3;
pub const BPF_FIB_LKUP_RET_NOT_FWDED: _bindgen_ty_241 = 4;
pub const BPF_FIB_LKUP_RET_FWD_DISABLED: _bindgen_ty_241 = 5;
pub const BPF_FIB_LKUP_RET_UNSUPP_LWT: _bindgen_ty_241 = 6;
pub const BPF_FIB_LKUP_RET_NO_NEIGH: _bindgen_ty_241 = 7;
pub const BPF_FIB_LKUP_RET_FRAG_NEEDED: _bindgen_ty_241 = 8;
pub const BPF_FIB_LKUP_RET_NO_SRC_ADDR: _bindgen_ty_241 = 9;
pub type _bindgen_ty_241 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_fib_lookup {
    pub family: __u8,
    pub l4_protocol: __u8,
    pub sport: __be16,
    pub dport: __be16,
    pub __bindgen_anon_1: bpf_fib_lookup__bindgen_ty_1,
    pub ifindex: __u32,
    pub __bindgen_anon_2: bpf_fib_lookup__bindgen_ty_2,
    pub __bindgen_anon_3: bpf_fib_lookup__bindgen_ty_3,
    pub __bindgen_anon_4: bpf_fib_lookup__bindgen_ty_4,
    pub __bindgen_anon_5: bpf_fib_lookup__bindgen_ty_5,
    pub __bindgen_anon_6: bpf_fib_lookup__bindgen_ty_6,
}
#[repr(C, packed(2))]
#[derive(Copy, Clone)]
pub union bpf_fib_lookup__bindgen_ty_1 {
    pub tot_len: __u16,
    pub mtu_result: __u16,
}
impl Default for bpf_fib_lookup__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_fib_lookup__bindgen_ty_2 {
    pub tos: __u8,
    pub flowinfo: __be32,
    pub rt_metric: __u32,
}
impl Default for bpf_fib_lookup__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_fib_lookup__bindgen_ty_3 {
    pub ipv4_src: __be32,
    pub ipv6_src: [__u32; 4usize],
}
impl Default for bpf_fib_lookup__bindgen_ty_3 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_fib_lookup__bindgen_ty_4 {
    pub ipv4_dst: __be32,
    pub ipv6_dst: [__u32; 4usize],
}
impl Default for bpf_fib_lookup__bindgen_ty_4 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_fib_lookup__bindgen_ty_5 {
    pub __bindgen_anon_1: bpf_fib_lookup__bindgen_ty_5__bindgen_ty_1,
    pub tbid: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_fib_lookup__bindgen_ty_5__bindgen_ty_1 {
    pub h_vlan_proto: __be16,
    pub h_vlan_TCI: __be16,
}
impl Default for bpf_fib_lookup__bindgen_ty_5 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_fib_lookup__bindgen_ty_6 {
    pub __bindgen_anon_1: bpf_fib_lookup__bindgen_ty_6__bindgen_ty_1,
    pub __bindgen_anon_2: bpf_fib_lookup__bindgen_ty_6__bindgen_ty_2,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_fib_lookup__bindgen_ty_6__bindgen_ty_1 {
    pub mark: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_fib_lookup__bindgen_ty_6__bindgen_ty_2 {
    pub smac: [__u8; 6usize],
    pub dmac: [__u8; 6usize],
}
impl Default for bpf_fib_lookup__bindgen_ty_6 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_fib_lookup {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_redir_neigh {
    pub nh_family: __u32,
    pub __bindgen_anon_1: bpf_redir_neigh__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_redir_neigh__bindgen_ty_1 {
    pub ipv4_nh: __be32,
    pub ipv6_nh: [__u32; 4usize],
}
impl Default for bpf_redir_neigh__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_redir_neigh {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const bpf_check_mtu_flags_BPF_MTU_CHK_SEGS: bpf_check_mtu_flags = 1;
pub type bpf_check_mtu_flags = ffi::c_uint;
pub const bpf_check_mtu_ret_BPF_MTU_CHK_RET_SUCCESS: bpf_check_mtu_ret = 0;
pub const bpf_check_mtu_ret_BPF_MTU_CHK_RET_FRAG_NEEDED: bpf_check_mtu_ret = 1;
pub const bpf_check_mtu_ret_BPF_MTU_CHK_RET_SEGS_TOOBIG: bpf_check_mtu_ret = 2;
pub type bpf_check_mtu_ret = ffi::c_uint;
pub const bpf_task_fd_type_BPF_FD_TYPE_RAW_TRACEPOINT: bpf_task_fd_type = 0;
pub const bpf_task_fd_type_BPF_FD_TYPE_TRACEPOINT: bpf_task_fd_type = 1;
pub const bpf_task_fd_type_BPF_FD_TYPE_KPROBE: bpf_task_fd_type = 2;
pub const bpf_task_fd_type_BPF_FD_TYPE_KRETPROBE: bpf_task_fd_type = 3;
pub const bpf_task_fd_type_BPF_FD_TYPE_UPROBE: bpf_task_fd_type = 4;
pub const bpf_task_fd_type_BPF_FD_TYPE_URETPROBE: bpf_task_fd_type = 5;
pub type bpf_task_fd_type = ffi::c_uint;
pub const BPF_FLOW_DISSECTOR_F_PARSE_1ST_FRAG: _bindgen_ty_242 = 1;
pub const BPF_FLOW_DISSECTOR_F_STOP_AT_FLOW_LABEL: _bindgen_ty_242 = 2;
pub const BPF_FLOW_DISSECTOR_F_STOP_AT_ENCAP: _bindgen_ty_242 = 4;
pub type _bindgen_ty_242 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_flow_keys {
    pub nhoff: __u16,
    pub thoff: __u16,
    pub addr_proto: __u16,
    pub is_frag: __u8,
    pub is_first_frag: __u8,
    pub is_encap: __u8,
    pub ip_proto: __u8,
    pub n_proto: __be16,
    pub sport: __be16,
    pub dport: __be16,
    pub __bindgen_anon_1: bpf_flow_keys__bindgen_ty_1,
    pub flags: __u32,
    pub flow_label: __be32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_flow_keys__bindgen_ty_1 {
    pub __bindgen_anon_1: bpf_flow_keys__bindgen_ty_1__bindgen_ty_1,
    pub __bindgen_anon_2: bpf_flow_keys__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_flow_keys__bindgen_ty_1__bindgen_ty_1 {
    pub ipv4_src: __be32,
    pub ipv4_dst: __be32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_flow_keys__bindgen_ty_1__bindgen_ty_2 {
    pub ipv6_src: [__u32; 4usize],
    pub ipv6_dst: [__u32; 4usize],
}
impl Default for bpf_flow_keys__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_flow_keys {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_func_info {
    pub insn_off: __u32,
    pub type_id: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_line_info {
    pub insn_off: __u32,
    pub file_name_off: __u32,
    pub line_off: __u32,
    pub line_col: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_spin_lock {
    pub val: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_timer {
    pub __opaque: [__u64; 2usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_wq {
    pub __opaque: [__u64; 2usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_dynptr {
    pub __opaque: [__u64; 2usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_list_head {
    pub __opaque: [__u64; 2usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_list_node {
    pub __opaque: [__u64; 3usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_rb_root {
    pub __opaque: [__u64; 2usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_rb_node {
    pub __opaque: [__u64; 4usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_refcount {
    pub __opaque: [__u32; 1usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_sysctl {
    pub write: __u32,
    pub file_pos: __u32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_sockopt {
    pub __bindgen_anon_1: bpf_sockopt__bindgen_ty_1,
    pub __bindgen_anon_2: bpf_sockopt__bindgen_ty_2,
    pub __bindgen_anon_3: bpf_sockopt__bindgen_ty_3,
    pub level: __s32,
    pub optname: __s32,
    pub optlen: __s32,
    pub retval: __s32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_sockopt__bindgen_ty_1 {
    pub sk: *mut bpf_sock,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
impl Default for bpf_sockopt__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl bpf_sockopt__bindgen_ty_1 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_sockopt__bindgen_ty_2 {
    pub optval: *mut ffi::c_void,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
impl Default for bpf_sockopt__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl bpf_sockopt__bindgen_ty_2 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_sockopt__bindgen_ty_3 {
    pub optval_end: *mut ffi::c_void,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
impl Default for bpf_sockopt__bindgen_ty_3 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl bpf_sockopt__bindgen_ty_3 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
impl Default for bpf_sockopt {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_pidns_info {
    pub pid: __u32,
    pub tgid: __u32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_sk_lookup {
    pub __bindgen_anon_1: bpf_sk_lookup__bindgen_ty_1,
    pub family: __u32,
    pub protocol: __u32,
    pub remote_ip4: __u32,
    pub remote_ip6: [__u32; 4usize],
    pub remote_port: __be16,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
    pub local_ip4: __u32,
    pub local_ip6: [__u32; 4usize],
    pub local_port: __u32,
    pub ingress_ifindex: __u32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_sk_lookup__bindgen_ty_1 {
    pub __bindgen_anon_1: bpf_sk_lookup__bindgen_ty_1__bindgen_ty_1,
    pub cookie: __u64,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_sk_lookup__bindgen_ty_1__bindgen_ty_1 {
    pub sk: *mut bpf_sock,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
impl Default for bpf_sk_lookup__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl bpf_sk_lookup__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
impl Default for bpf_sk_lookup__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_sk_lookup {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl bpf_sk_lookup {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct btf_ptr {
    pub ptr: *mut ffi::c_void,
    pub type_id: __u32,
    pub flags: __u32,
}
impl Default for btf_ptr {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const BTF_F_COMPACT: _bindgen_ty_243 = 1;
pub const BTF_F_NONAME: _bindgen_ty_243 = 2;
pub const BTF_F_PTR_RAW: _bindgen_ty_243 = 4;
pub const BTF_F_ZERO: _bindgen_ty_243 = 8;
pub type _bindgen_ty_243 = ffi::c_uint;
pub const bpf_core_relo_kind_BPF_CORE_FIELD_BYTE_OFFSET: bpf_core_relo_kind = 0;
pub const bpf_core_relo_kind_BPF_CORE_FIELD_BYTE_SIZE: bpf_core_relo_kind = 1;
pub const bpf_core_relo_kind_BPF_CORE_FIELD_EXISTS: bpf_core_relo_kind = 2;
pub const bpf_core_relo_kind_BPF_CORE_FIELD_SIGNED: bpf_core_relo_kind = 3;
pub const bpf_core_relo_kind_BPF_CORE_FIELD_LSHIFT_U64: bpf_core_relo_kind = 4;
pub const bpf_core_relo_kind_BPF_CORE_FIELD_RSHIFT_U64: bpf_core_relo_kind = 5;
pub const bpf_core_relo_kind_BPF_CORE_TYPE_ID_LOCAL: bpf_core_relo_kind = 6;
pub const bpf_core_relo_kind_BPF_CORE_TYPE_ID_TARGET: bpf_core_relo_kind = 7;
pub const bpf_core_relo_kind_BPF_CORE_TYPE_EXISTS: bpf_core_relo_kind = 8;
pub const bpf_core_relo_kind_BPF_CORE_TYPE_SIZE: bpf_core_relo_kind = 9;
pub const bpf_core_relo_kind_BPF_CORE_ENUMVAL_EXISTS: bpf_core_relo_kind = 10;
pub const bpf_core_relo_kind_BPF_CORE_ENUMVAL_VALUE: bpf_core_relo_kind = 11;
pub const bpf_core_relo_kind_BPF_CORE_TYPE_MATCHES: bpf_core_relo_kind = 12;
pub type bpf_core_relo_kind = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_core_relo {
    pub insn_off: __u32,
    pub type_id: __u32,
    pub access_str_off: __u32,
    pub kind: bpf_core_relo_kind,
}
impl Default for bpf_core_relo {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const BPF_F_TIMER_ABS: _bindgen_ty_244 = 1;
pub const BPF_F_TIMER_CPU_PIN: _bindgen_ty_244 = 2;
pub type _bindgen_ty_244 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_iter_num {
    pub __opaque: [__u64; 1usize],
}
pub const bpf_kfunc_flags_BPF_F_PAD_ZEROS: bpf_kfunc_flags = 1;
pub type bpf_kfunc_flags = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sock_filter {
    pub code: __u16,
    pub jt: __u8,
    pub jf: __u8,
    pub k: __u32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sock_fprog {
    pub len: ffi::c_ushort,
    pub filter: *mut sock_filter,
}
impl Default for sock_fprog {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type bpfptr_t = sockptr_t;
extern "C" {
    pub fn bsearch(
        key: *const ffi::c_void,
        base: *const ffi::c_void,
        num: usize,
        size: usize,
        cmp: cmp_func_t,
    ) -> *mut ffi::c_void;
}
#[repr(C)]
#[derive(Default)]
pub struct btf_id_set {
    pub cnt: u32_,
    pub ids: __IncompleteArrayField<u32_>,
}
#[repr(C)]
#[derive(Default)]
pub struct btf_id_set8 {
    pub cnt: u32_,
    pub flags: u32_,
    pub pairs: __IncompleteArrayField<btf_id_set8__bindgen_ty_1>,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct btf_id_set8__bindgen_ty_1 {
    pub id: u32_,
    pub flags: u32_,
}
pub const BTF_SOCK_TYPE_INET: _bindgen_ty_245 = 0;
pub const BTF_SOCK_TYPE_INET_CONN: _bindgen_ty_245 = 1;
pub const BTF_SOCK_TYPE_INET_REQ: _bindgen_ty_245 = 2;
pub const BTF_SOCK_TYPE_INET_TW: _bindgen_ty_245 = 3;
pub const BTF_SOCK_TYPE_REQ: _bindgen_ty_245 = 4;
pub const BTF_SOCK_TYPE_SOCK: _bindgen_ty_245 = 5;
pub const BTF_SOCK_TYPE_SOCK_COMMON: _bindgen_ty_245 = 6;
pub const BTF_SOCK_TYPE_TCP: _bindgen_ty_245 = 7;
pub const BTF_SOCK_TYPE_TCP_REQ: _bindgen_ty_245 = 8;
pub const BTF_SOCK_TYPE_TCP_TW: _bindgen_ty_245 = 9;
pub const BTF_SOCK_TYPE_TCP6: _bindgen_ty_245 = 10;
pub const BTF_SOCK_TYPE_UDP: _bindgen_ty_245 = 11;
pub const BTF_SOCK_TYPE_UDP6: _bindgen_ty_245 = 12;
pub const BTF_SOCK_TYPE_UNIX: _bindgen_ty_245 = 13;
pub const BTF_SOCK_TYPE_MPTCP: _bindgen_ty_245 = 14;
pub const BTF_SOCK_TYPE_SOCKET: _bindgen_ty_245 = 15;
pub const MAX_BTF_SOCK_TYPE: _bindgen_ty_245 = 16;
pub type _bindgen_ty_245 = ffi::c_uint;
extern "C" {
    pub static mut btf_sock_ids: [u32_; 0usize];
}
pub const BTF_TRACING_TYPE_TASK: _bindgen_ty_246 = 0;
pub const BTF_TRACING_TYPE_FILE: _bindgen_ty_246 = 1;
pub const BTF_TRACING_TYPE_VMA: _bindgen_ty_246 = 2;
pub const MAX_BTF_TRACING_TYPE: _bindgen_ty_246 = 3;
pub type _bindgen_ty_246 = ffi::c_uint;
extern "C" {
    pub static mut btf_tracing_ids: [u32_; 0usize];
}
extern "C" {
    pub static mut bpf_cgroup_btf_id: [u32_; 0usize];
}
extern "C" {
    pub static mut bpf_local_storage_map_btf_id: [u32_; 0usize];
}
extern "C" {
    pub static mut btf_bpf_map_id: [u32_; 0usize];
}
extern "C" {
    pub static mut bpf_kmem_cache_btf_id: [u32_; 0usize];
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct btf_header {
    pub magic: __u16,
    pub version: __u8,
    pub flags: __u8,
    pub hdr_len: __u32,
    pub type_off: __u32,
    pub type_len: __u32,
    pub str_off: __u32,
    pub str_len: __u32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct btf_type {
    pub name_off: __u32,
    pub info: __u32,
    pub __bindgen_anon_1: btf_type__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union btf_type__bindgen_ty_1 {
    pub size: __u32,
    pub type_: __u32,
}
impl Default for btf_type__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for btf_type {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const BTF_KIND_UNKN: _bindgen_ty_247 = 0;
pub const BTF_KIND_INT: _bindgen_ty_247 = 1;
pub const BTF_KIND_PTR: _bindgen_ty_247 = 2;
pub const BTF_KIND_ARRAY: _bindgen_ty_247 = 3;
pub const BTF_KIND_STRUCT: _bindgen_ty_247 = 4;
pub const BTF_KIND_UNION: _bindgen_ty_247 = 5;
pub const BTF_KIND_ENUM: _bindgen_ty_247 = 6;
pub const BTF_KIND_FWD: _bindgen_ty_247 = 7;
pub const BTF_KIND_TYPEDEF: _bindgen_ty_247 = 8;
pub const BTF_KIND_VOLATILE: _bindgen_ty_247 = 9;
pub const BTF_KIND_CONST: _bindgen_ty_247 = 10;
pub const BTF_KIND_RESTRICT: _bindgen_ty_247 = 11;
pub const BTF_KIND_FUNC: _bindgen_ty_247 = 12;
pub const BTF_KIND_FUNC_PROTO: _bindgen_ty_247 = 13;
pub const BTF_KIND_VAR: _bindgen_ty_247 = 14;
pub const BTF_KIND_DATASEC: _bindgen_ty_247 = 15;
pub const BTF_KIND_FLOAT: _bindgen_ty_247 = 16;
pub const BTF_KIND_DECL_TAG: _bindgen_ty_247 = 17;
pub const BTF_KIND_TYPE_TAG: _bindgen_ty_247 = 18;
pub const BTF_KIND_ENUM64: _bindgen_ty_247 = 19;
pub const NR_BTF_KINDS: _bindgen_ty_247 = 20;
pub const BTF_KIND_MAX: _bindgen_ty_247 = 19;
pub type _bindgen_ty_247 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct btf_enum {
    pub name_off: __u32,
    pub val: __s32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct btf_array {
    pub type_: __u32,
    pub index_type: __u32,
    pub nelems: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct btf_member {
    pub name_off: __u32,
    pub type_: __u32,
    pub offset: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct btf_param {
    pub name_off: __u32,
    pub type_: __u32,
}
pub const BTF_VAR_STATIC: _bindgen_ty_248 = 0;
pub const BTF_VAR_GLOBAL_ALLOCATED: _bindgen_ty_248 = 1;
pub const BTF_VAR_GLOBAL_EXTERN: _bindgen_ty_248 = 2;
pub type _bindgen_ty_248 = ffi::c_uint;
pub const btf_func_linkage_BTF_FUNC_STATIC: btf_func_linkage = 0;
pub const btf_func_linkage_BTF_FUNC_GLOBAL: btf_func_linkage = 1;
pub const btf_func_linkage_BTF_FUNC_EXTERN: btf_func_linkage = 2;
pub type btf_func_linkage = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct btf_var {
    pub linkage: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct btf_var_secinfo {
    pub type_: __u32,
    pub offset: __u32,
    pub size: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct btf_decl_tag {
    pub component_idx: __s32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct btf_enum64 {
    pub name_off: __u32,
    pub val_lo32: __u32,
    pub val_hi32: __u32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct btf {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct btf_show {
    _unused: [u8; 0],
}
pub type btf_kfunc_filter_t = ::core::option::Option<
    unsafe extern "C" fn(prog: *const bpf_prog, kfunc_id: u32_) -> ffi::c_int,
>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct btf_kfunc_id_set {
    pub owner: *mut module,
    pub set: *mut btf_id_set8,
    pub filter: btf_kfunc_filter_t,
}
impl Default for btf_kfunc_id_set {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct btf_id_dtor_kfunc {
    pub btf_id: u32_,
    pub kfunc_btf_id: u32_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct btf_struct_meta {
    pub btf_id: u32_,
    pub record: *mut btf_record,
}
impl Default for btf_struct_meta {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct btf_struct_metas {
    pub cnt: u32_,
    pub types: __IncompleteArrayField<btf_struct_meta>,
}
impl Default for btf_struct_metas {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static btf_fops: file_operations;
}
extern "C" {
    pub fn btf_get_name(btf: *const btf) -> *const ffi::c_char;
}
extern "C" {
    pub fn btf_get(btf: *mut btf);
}
extern "C" {
    pub fn btf_put(btf: *mut btf);
}
extern "C" {
    pub fn btf_header(btf: *const btf) -> *const btf_header;
}
extern "C" {
    pub fn btf_new_fd(attr: *const bpf_attr, uattr: bpfptr_t, uattr_sz: u32_) -> ffi::c_int;
}
extern "C" {
    pub fn btf_get_by_fd(fd: ffi::c_int) -> *mut btf;
}
extern "C" {
    pub fn btf_get_info_by_fd(
        btf: *const btf,
        attr: *const bpf_attr,
        uattr: *mut bpf_attr,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn btf_type_id_size(
        btf: *const btf,
        type_id: *mut u32_,
        ret_size: *mut u32_,
    ) -> *const btf_type;
}
extern "C" {
    pub fn btf_type_seq_show(
        btf: *const btf,
        type_id: u32_,
        obj: *mut ffi::c_void,
        m: *mut seq_file,
    );
}
extern "C" {
    pub fn btf_type_seq_show_flags(
        btf: *const btf,
        type_id: u32_,
        obj: *mut ffi::c_void,
        m: *mut seq_file,
        flags: u64_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn btf_type_snprintf_show(
        btf: *const btf,
        type_id: u32_,
        obj: *mut ffi::c_void,
        buf: *mut ffi::c_char,
        len: ffi::c_int,
        flags: u64_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn btf_get_fd_by_id(id: u32_) -> ffi::c_int;
}
extern "C" {
    pub fn btf_obj_id(btf: *const btf) -> u32_;
}
extern "C" {
    pub fn btf_is_kernel(btf: *const btf) -> bool_;
}
extern "C" {
    pub fn btf_is_module(btf: *const btf) -> bool_;
}
extern "C" {
    pub fn btf_is_vmlinux(btf: *const btf) -> bool_;
}
extern "C" {
    pub fn btf_try_get_module(btf: *const btf) -> *mut module;
}
extern "C" {
    pub fn btf_nr_types(btf: *const btf) -> u32_;
}
extern "C" {
    pub fn btf_base_btf(btf: *const btf) -> *mut btf;
}
extern "C" {
    pub fn btf_member_is_reg_int(
        btf: *const btf,
        s: *const btf_type,
        m: *const btf_member,
        expected_offset: u32_,
        expected_size: u32_,
    ) -> bool_;
}
extern "C" {
    pub fn btf_parse_fields(
        btf: *const btf,
        t: *const btf_type,
        field_mask: u32_,
        value_size: u32_,
    ) -> *mut btf_record;
}
extern "C" {
    pub fn btf_check_and_fixup_fields(btf: *const btf, rec: *mut btf_record) -> ffi::c_int;
}
extern "C" {
    pub fn btf_type_is_void(t: *const btf_type) -> bool_;
}
extern "C" {
    pub fn btf_find_by_name_kind(btf: *const btf, name: *const ffi::c_char, kind: u8_) -> s32;
}
extern "C" {
    pub fn bpf_find_btf_id(name: *const ffi::c_char, kind: u32_, btf_p: *mut *mut btf) -> s32;
}
extern "C" {
    pub fn btf_type_skip_modifiers(btf: *const btf, id: u32_, res_id: *mut u32_)
        -> *const btf_type;
}
extern "C" {
    pub fn btf_type_resolve_ptr(btf: *const btf, id: u32_, res_id: *mut u32_) -> *const btf_type;
}
extern "C" {
    pub fn btf_type_resolve_func_ptr(
        btf: *const btf,
        id: u32_,
        res_id: *mut u32_,
    ) -> *const btf_type;
}
extern "C" {
    pub fn btf_resolve_size(
        btf: *const btf,
        type_: *const btf_type,
        type_size: *mut u32_,
    ) -> *const btf_type;
}
extern "C" {
    pub fn btf_type_str(t: *const btf_type) -> *const ffi::c_char;
}
extern "C" {
    pub fn btf_param_match_suffix(
        btf: *const btf,
        arg: *const btf_param,
        suffix: *const ffi::c_char,
    ) -> bool_;
}
extern "C" {
    pub fn btf_ctx_arg_offset(
        btf: *const btf,
        func_proto: *const btf_type,
        arg_no: u32_,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_verifier_log {
    _unused: [u8; 0],
}
extern "C" {
    pub fn __register_bpf_struct_ops(st_ops: *mut bpf_struct_ops) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_struct_ops_find_value(btf: *mut btf, value_id: u32_) -> *const bpf_struct_ops_desc;
}
extern "C" {
    pub fn bpf_struct_ops_find(btf: *mut btf, type_id: u32_) -> *const bpf_struct_ops_desc;
}
pub const btf_field_iter_kind_BTF_FIELD_ITER_IDS: btf_field_iter_kind = 0;
pub const btf_field_iter_kind_BTF_FIELD_ITER_STRS: btf_field_iter_kind = 1;
pub type btf_field_iter_kind = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct btf_field_desc {
    pub t_off_cnt: ffi::c_int,
    pub t_offs: [ffi::c_int; 2usize],
    pub m_sz: ffi::c_int,
    pub m_off_cnt: ffi::c_int,
    pub m_offs: [ffi::c_int; 1usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct btf_field_iter {
    pub desc: btf_field_desc,
    pub p: *mut ffi::c_void,
    pub m_idx: ffi::c_int,
    pub off_idx: ffi::c_int,
    pub vlen: ffi::c_int,
}
impl Default for btf_field_iter {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn btf_type_by_id(btf: *const btf, type_id: u32_) -> *const btf_type;
}
extern "C" {
    pub fn btf_set_base_btf(btf: *mut btf, base_btf: *const btf);
}
extern "C" {
    pub fn btf_relocate(
        btf: *mut btf,
        base_btf: *const btf,
        map_ids: *mut *mut __u32,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn btf_field_iter_init(
        it: *mut btf_field_iter,
        t: *mut btf_type,
        iter_kind: btf_field_iter_kind,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn btf_field_iter_next(it: *mut btf_field_iter) -> *mut __u32;
}
extern "C" {
    pub fn btf_name_by_offset(btf: *const btf, offset: u32_) -> *const ffi::c_char;
}
extern "C" {
    pub fn btf_str_by_offset(btf: *const btf, offset: u32_) -> *const ffi::c_char;
}
extern "C" {
    pub fn btf_parse_vmlinux() -> *mut btf;
}
extern "C" {
    pub fn bpf_prog_get_target_btf(prog: *const bpf_prog) -> *mut btf;
}
extern "C" {
    pub fn btf_kfunc_id_set_contains(
        btf: *const btf,
        kfunc_btf_id: u32_,
        prog: *const bpf_prog,
    ) -> *mut u32_;
}
extern "C" {
    pub fn btf_kfunc_is_modify_return(
        btf: *const btf,
        kfunc_btf_id: u32_,
        prog: *const bpf_prog,
    ) -> *mut u32_;
}
extern "C" {
    pub fn register_btf_kfunc_id_set(
        prog_type: bpf_prog_type,
        s: *const btf_kfunc_id_set,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn register_btf_fmodret_id_set(kset: *const btf_kfunc_id_set) -> ffi::c_int;
}
extern "C" {
    pub fn btf_find_dtor_kfunc(btf: *mut btf, btf_id: u32_) -> s32;
}
extern "C" {
    pub fn register_btf_id_dtor_kfuncs(
        dtors: *const btf_id_dtor_kfunc,
        add_cnt: u32_,
        owner: *mut module,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn btf_find_struct_meta(btf: *const btf, btf_id: u32_) -> *mut btf_struct_meta;
}
extern "C" {
    pub fn btf_is_projection_of(pname: *const ffi::c_char, tname: *const ffi::c_char) -> bool_;
}
extern "C" {
    pub fn btf_is_prog_ctx_type(
        log: *mut bpf_verifier_log,
        btf: *const btf,
        t: *const btf_type,
        prog_type: bpf_prog_type,
        arg: ffi::c_int,
    ) -> bool_;
}
extern "C" {
    pub fn get_kern_ctx_btf_id(log: *mut bpf_verifier_log, prog_type: bpf_prog_type) -> ffi::c_int;
}
extern "C" {
    pub fn btf_types_are_same(btf1: *const btf, id1: u32_, btf2: *const btf, id2: u32_) -> bool_;
}
extern "C" {
    pub fn btf_check_iter_arg(
        btf: *mut btf,
        func: *const btf_type,
        arg_idx: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub static mut rcu_trace_lock_map: lockdep_map;
}
extern "C" {
    pub fn rcu_read_unlock_trace_special(t: *mut task_struct);
}
extern "C" {
    pub fn call_rcu_tasks_trace(rhp: *mut callback_head, func: rcu_callback_t);
}
extern "C" {
    pub fn synchronize_rcu_tasks_trace();
}
extern "C" {
    pub fn rcu_barrier_tasks_trace();
}
extern "C" {
    pub fn get_rcu_tasks_trace_gp_kthread() -> *mut task_struct;
}
pub const class_rcu_tasks_trace_is_conditional: bool_ = false;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct class_rcu_tasks_trace_t {
    pub lock: *mut ffi::c_void,
}
impl Default for class_rcu_tasks_trace_t {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct access_coordinate {
    pub read_bandwidth: ffi::c_uint,
    pub write_bandwidth: ffi::c_uint,
    pub read_latency: ffi::c_uint,
    pub write_latency: ffi::c_uint,
}
pub const access_coordinate_class_ACCESS_COORDINATE_LOCAL: access_coordinate_class = 0;
pub const access_coordinate_class_ACCESS_COORDINATE_CPU: access_coordinate_class = 1;
pub const access_coordinate_class_ACCESS_COORDINATE_MAX: access_coordinate_class = 2;
pub type access_coordinate_class = ffi::c_uint;
pub const cache_indexing_NODE_CACHE_DIRECT_MAP: cache_indexing = 0;
pub const cache_indexing_NODE_CACHE_INDEXED: cache_indexing = 1;
pub const cache_indexing_NODE_CACHE_OTHER: cache_indexing = 2;
pub type cache_indexing = ffi::c_uint;
pub const cache_write_policy_NODE_CACHE_WRITE_BACK: cache_write_policy = 0;
pub const cache_write_policy_NODE_CACHE_WRITE_THROUGH: cache_write_policy = 1;
pub const cache_write_policy_NODE_CACHE_WRITE_OTHER: cache_write_policy = 2;
pub type cache_write_policy = ffi::c_uint;
pub const cache_mode_NODE_CACHE_ADDR_MODE_RESERVED: cache_mode = 0;
pub const cache_mode_NODE_CACHE_ADDR_MODE_EXTENDED_LINEAR: cache_mode = 1;
pub type cache_mode = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct node_cache_attrs {
    pub indexing: cache_indexing,
    pub write_policy: cache_write_policy,
    pub size: u64_,
    pub line_size: u16_,
    pub level: u8_,
    pub address_mode: u16_,
}
impl Default for node_cache_attrs {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn node_add_cache(nid: ffi::c_uint, cache_attrs: *mut node_cache_attrs);
}
extern "C" {
    pub fn node_set_perf_attrs(
        nid: ffi::c_uint,
        coord: *mut access_coordinate,
        access: access_coordinate_class,
    );
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct node {
    pub dev: device,
    pub access_list: list_head,
    pub cache_attrs: list_head,
    pub cache_dev: *mut device,
}
impl Default for node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct memory_block {
    _unused: [u8; 0],
}
extern "C" {
    pub static mut node_devices: [*mut node; 0usize];
}
extern "C" {
    pub fn register_memory_blocks_under_node(
        nid: ffi::c_int,
        start_pfn: ffi::c_ulong,
        end_pfn: ffi::c_ulong,
        context: meminit_context,
    );
}
extern "C" {
    pub fn unregister_node(node: *mut node);
}
extern "C" {
    pub fn node_dev_init();
}
extern "C" {
    pub fn __register_one_node(nid: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn unregister_one_node(nid: ffi::c_int);
}
extern "C" {
    pub fn register_cpu_under_node(cpu: ffi::c_uint, nid: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn unregister_cpu_under_node(cpu: ffi::c_uint, nid: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn unregister_memory_block_under_nodes(mem_blk: *mut memory_block);
}
extern "C" {
    pub fn register_memory_node_under_compute_node(
        mem_nid: ffi::c_uint,
        cpu_nid: ffi::c_uint,
        access: access_coordinate_class,
    ) -> ffi::c_int;
}
pub const cpuhp_state_CPUHP_INVALID: cpuhp_state = -1;
pub const cpuhp_state_CPUHP_OFFLINE: cpuhp_state = 0;
pub const cpuhp_state_CPUHP_CREATE_THREADS: cpuhp_state = 1;
pub const cpuhp_state_CPUHP_PERF_PREPARE: cpuhp_state = 2;
pub const cpuhp_state_CPUHP_PERF_X86_PREPARE: cpuhp_state = 3;
pub const cpuhp_state_CPUHP_PERF_X86_AMD_UNCORE_PREP: cpuhp_state = 4;
pub const cpuhp_state_CPUHP_PERF_POWER: cpuhp_state = 5;
pub const cpuhp_state_CPUHP_PERF_SUPERH: cpuhp_state = 6;
pub const cpuhp_state_CPUHP_X86_HPET_DEAD: cpuhp_state = 7;
pub const cpuhp_state_CPUHP_X86_MCE_DEAD: cpuhp_state = 8;
pub const cpuhp_state_CPUHP_VIRT_NET_DEAD: cpuhp_state = 9;
pub const cpuhp_state_CPUHP_IBMVNIC_DEAD: cpuhp_state = 10;
pub const cpuhp_state_CPUHP_SLUB_DEAD: cpuhp_state = 11;
pub const cpuhp_state_CPUHP_DEBUG_OBJ_DEAD: cpuhp_state = 12;
pub const cpuhp_state_CPUHP_MM_WRITEBACK_DEAD: cpuhp_state = 13;
pub const cpuhp_state_CPUHP_MM_VMSTAT_DEAD: cpuhp_state = 14;
pub const cpuhp_state_CPUHP_SOFTIRQ_DEAD: cpuhp_state = 15;
pub const cpuhp_state_CPUHP_NET_MVNETA_DEAD: cpuhp_state = 16;
pub const cpuhp_state_CPUHP_CPUIDLE_DEAD: cpuhp_state = 17;
pub const cpuhp_state_CPUHP_ARM64_FPSIMD_DEAD: cpuhp_state = 18;
pub const cpuhp_state_CPUHP_ARM_OMAP_WAKE_DEAD: cpuhp_state = 19;
pub const cpuhp_state_CPUHP_IRQ_POLL_DEAD: cpuhp_state = 20;
pub const cpuhp_state_CPUHP_BLOCK_SOFTIRQ_DEAD: cpuhp_state = 21;
pub const cpuhp_state_CPUHP_BIO_DEAD: cpuhp_state = 22;
pub const cpuhp_state_CPUHP_ACPI_CPUDRV_DEAD: cpuhp_state = 23;
pub const cpuhp_state_CPUHP_S390_PFAULT_DEAD: cpuhp_state = 24;
pub const cpuhp_state_CPUHP_BLK_MQ_DEAD: cpuhp_state = 25;
pub const cpuhp_state_CPUHP_FS_BUFF_DEAD: cpuhp_state = 26;
pub const cpuhp_state_CPUHP_PRINTK_DEAD: cpuhp_state = 27;
pub const cpuhp_state_CPUHP_MM_MEMCQ_DEAD: cpuhp_state = 28;
pub const cpuhp_state_CPUHP_PERCPU_CNT_DEAD: cpuhp_state = 29;
pub const cpuhp_state_CPUHP_RADIX_DEAD: cpuhp_state = 30;
pub const cpuhp_state_CPUHP_PAGE_ALLOC: cpuhp_state = 31;
pub const cpuhp_state_CPUHP_NET_DEV_DEAD: cpuhp_state = 32;
pub const cpuhp_state_CPUHP_PCI_XGENE_DEAD: cpuhp_state = 33;
pub const cpuhp_state_CPUHP_IOMMU_IOVA_DEAD: cpuhp_state = 34;
pub const cpuhp_state_CPUHP_AP_ARM_CACHE_B15_RAC_DEAD: cpuhp_state = 35;
pub const cpuhp_state_CPUHP_PADATA_DEAD: cpuhp_state = 36;
pub const cpuhp_state_CPUHP_AP_DTPM_CPU_DEAD: cpuhp_state = 37;
pub const cpuhp_state_CPUHP_RANDOM_PREPARE: cpuhp_state = 38;
pub const cpuhp_state_CPUHP_WORKQUEUE_PREP: cpuhp_state = 39;
pub const cpuhp_state_CPUHP_POWER_NUMA_PREPARE: cpuhp_state = 40;
pub const cpuhp_state_CPUHP_HRTIMERS_PREPARE: cpuhp_state = 41;
pub const cpuhp_state_CPUHP_X2APIC_PREPARE: cpuhp_state = 42;
pub const cpuhp_state_CPUHP_SMPCFD_PREPARE: cpuhp_state = 43;
pub const cpuhp_state_CPUHP_RELAY_PREPARE: cpuhp_state = 44;
pub const cpuhp_state_CPUHP_MD_RAID5_PREPARE: cpuhp_state = 45;
pub const cpuhp_state_CPUHP_RCUTREE_PREP: cpuhp_state = 46;
pub const cpuhp_state_CPUHP_CPUIDLE_COUPLED_PREPARE: cpuhp_state = 47;
pub const cpuhp_state_CPUHP_POWERPC_PMAC_PREPARE: cpuhp_state = 48;
pub const cpuhp_state_CPUHP_POWERPC_MMU_CTX_PREPARE: cpuhp_state = 49;
pub const cpuhp_state_CPUHP_XEN_PREPARE: cpuhp_state = 50;
pub const cpuhp_state_CPUHP_XEN_EVTCHN_PREPARE: cpuhp_state = 51;
pub const cpuhp_state_CPUHP_ARM_SHMOBILE_SCU_PREPARE: cpuhp_state = 52;
pub const cpuhp_state_CPUHP_SH_SH3X_PREPARE: cpuhp_state = 53;
pub const cpuhp_state_CPUHP_TOPOLOGY_PREPARE: cpuhp_state = 54;
pub const cpuhp_state_CPUHP_NET_IUCV_PREPARE: cpuhp_state = 55;
pub const cpuhp_state_CPUHP_ARM_BL_PREPARE: cpuhp_state = 56;
pub const cpuhp_state_CPUHP_TRACE_RB_PREPARE: cpuhp_state = 57;
pub const cpuhp_state_CPUHP_MM_ZSWP_POOL_PREPARE: cpuhp_state = 58;
pub const cpuhp_state_CPUHP_KVM_PPC_BOOK3S_PREPARE: cpuhp_state = 59;
pub const cpuhp_state_CPUHP_ZCOMP_PREPARE: cpuhp_state = 60;
pub const cpuhp_state_CPUHP_TIMERS_PREPARE: cpuhp_state = 61;
pub const cpuhp_state_CPUHP_TMIGR_PREPARE: cpuhp_state = 62;
pub const cpuhp_state_CPUHP_MIPS_SOC_PREPARE: cpuhp_state = 63;
pub const cpuhp_state_CPUHP_BP_PREPARE_DYN: cpuhp_state = 64;
pub const cpuhp_state_CPUHP_BP_PREPARE_DYN_END: cpuhp_state = 84;
pub const cpuhp_state_CPUHP_BP_KICK_AP: cpuhp_state = 85;
pub const cpuhp_state_CPUHP_BRINGUP_CPU: cpuhp_state = 86;
pub const cpuhp_state_CPUHP_AP_IDLE_DEAD: cpuhp_state = 87;
pub const cpuhp_state_CPUHP_AP_OFFLINE: cpuhp_state = 88;
pub const cpuhp_state_CPUHP_AP_CACHECTRL_STARTING: cpuhp_state = 89;
pub const cpuhp_state_CPUHP_AP_SCHED_STARTING: cpuhp_state = 90;
pub const cpuhp_state_CPUHP_AP_RCUTREE_DYING: cpuhp_state = 91;
pub const cpuhp_state_CPUHP_AP_CPU_PM_STARTING: cpuhp_state = 92;
pub const cpuhp_state_CPUHP_AP_IRQ_GIC_STARTING: cpuhp_state = 93;
pub const cpuhp_state_CPUHP_AP_IRQ_HIP04_STARTING: cpuhp_state = 94;
pub const cpuhp_state_CPUHP_AP_IRQ_APPLE_AIC_STARTING: cpuhp_state = 95;
pub const cpuhp_state_CPUHP_AP_IRQ_ARMADA_XP_STARTING: cpuhp_state = 96;
pub const cpuhp_state_CPUHP_AP_IRQ_BCM2836_STARTING: cpuhp_state = 97;
pub const cpuhp_state_CPUHP_AP_IRQ_MIPS_GIC_STARTING: cpuhp_state = 98;
pub const cpuhp_state_CPUHP_AP_IRQ_EIOINTC_STARTING: cpuhp_state = 99;
pub const cpuhp_state_CPUHP_AP_IRQ_AVECINTC_STARTING: cpuhp_state = 100;
pub const cpuhp_state_CPUHP_AP_IRQ_SIFIVE_PLIC_STARTING: cpuhp_state = 101;
pub const cpuhp_state_CPUHP_AP_IRQ_THEAD_ACLINT_SSWI_STARTING: cpuhp_state = 102;
pub const cpuhp_state_CPUHP_AP_IRQ_RISCV_IMSIC_STARTING: cpuhp_state = 103;
pub const cpuhp_state_CPUHP_AP_IRQ_RISCV_SBI_IPI_STARTING: cpuhp_state = 104;
pub const cpuhp_state_CPUHP_AP_ARM_MVEBU_COHERENCY: cpuhp_state = 105;
pub const cpuhp_state_CPUHP_AP_PERF_X86_AMD_UNCORE_STARTING: cpuhp_state = 106;
pub const cpuhp_state_CPUHP_AP_PERF_X86_STARTING: cpuhp_state = 107;
pub const cpuhp_state_CPUHP_AP_PERF_X86_AMD_IBS_STARTING: cpuhp_state = 108;
pub const cpuhp_state_CPUHP_AP_PERF_XTENSA_STARTING: cpuhp_state = 109;
pub const cpuhp_state_CPUHP_AP_ARM_VFP_STARTING: cpuhp_state = 110;
pub const cpuhp_state_CPUHP_AP_ARM64_DEBUG_MONITORS_STARTING: cpuhp_state = 111;
pub const cpuhp_state_CPUHP_AP_PERF_ARM_HW_BREAKPOINT_STARTING: cpuhp_state = 112;
pub const cpuhp_state_CPUHP_AP_PERF_ARM_ACPI_STARTING: cpuhp_state = 113;
pub const cpuhp_state_CPUHP_AP_PERF_ARM_STARTING: cpuhp_state = 114;
pub const cpuhp_state_CPUHP_AP_PERF_RISCV_STARTING: cpuhp_state = 115;
pub const cpuhp_state_CPUHP_AP_ARM_L2X0_STARTING: cpuhp_state = 116;
pub const cpuhp_state_CPUHP_AP_EXYNOS4_MCT_TIMER_STARTING: cpuhp_state = 117;
pub const cpuhp_state_CPUHP_AP_ARM_ARCH_TIMER_STARTING: cpuhp_state = 118;
pub const cpuhp_state_CPUHP_AP_ARM_ARCH_TIMER_EVTSTRM_STARTING: cpuhp_state = 119;
pub const cpuhp_state_CPUHP_AP_ARM_GLOBAL_TIMER_STARTING: cpuhp_state = 120;
pub const cpuhp_state_CPUHP_AP_JCORE_TIMER_STARTING: cpuhp_state = 121;
pub const cpuhp_state_CPUHP_AP_ARM_TWD_STARTING: cpuhp_state = 122;
pub const cpuhp_state_CPUHP_AP_QCOM_TIMER_STARTING: cpuhp_state = 123;
pub const cpuhp_state_CPUHP_AP_TEGRA_TIMER_STARTING: cpuhp_state = 124;
pub const cpuhp_state_CPUHP_AP_ARMADA_TIMER_STARTING: cpuhp_state = 125;
pub const cpuhp_state_CPUHP_AP_MIPS_GIC_TIMER_STARTING: cpuhp_state = 126;
pub const cpuhp_state_CPUHP_AP_ARC_TIMER_STARTING: cpuhp_state = 127;
pub const cpuhp_state_CPUHP_AP_REALTEK_TIMER_STARTING: cpuhp_state = 128;
pub const cpuhp_state_CPUHP_AP_RISCV_TIMER_STARTING: cpuhp_state = 129;
pub const cpuhp_state_CPUHP_AP_CLINT_TIMER_STARTING: cpuhp_state = 130;
pub const cpuhp_state_CPUHP_AP_CSKY_TIMER_STARTING: cpuhp_state = 131;
pub const cpuhp_state_CPUHP_AP_TI_GP_TIMER_STARTING: cpuhp_state = 132;
pub const cpuhp_state_CPUHP_AP_HYPERV_TIMER_STARTING: cpuhp_state = 133;
pub const cpuhp_state_CPUHP_AP_DUMMY_TIMER_STARTING: cpuhp_state = 134;
pub const cpuhp_state_CPUHP_AP_ARM_XEN_STARTING: cpuhp_state = 135;
pub const cpuhp_state_CPUHP_AP_ARM_XEN_RUNSTATE_STARTING: cpuhp_state = 136;
pub const cpuhp_state_CPUHP_AP_ARM_CORESIGHT_STARTING: cpuhp_state = 137;
pub const cpuhp_state_CPUHP_AP_ARM_CORESIGHT_CTI_STARTING: cpuhp_state = 138;
pub const cpuhp_state_CPUHP_AP_ARM64_ISNDEP_STARTING: cpuhp_state = 139;
pub const cpuhp_state_CPUHP_AP_SMPCFD_DYING: cpuhp_state = 140;
pub const cpuhp_state_CPUHP_AP_HRTIMERS_DYING: cpuhp_state = 141;
pub const cpuhp_state_CPUHP_AP_TICK_DYING: cpuhp_state = 142;
pub const cpuhp_state_CPUHP_AP_X86_TBOOT_DYING: cpuhp_state = 143;
pub const cpuhp_state_CPUHP_AP_ARM_CACHE_B15_RAC_DYING: cpuhp_state = 144;
pub const cpuhp_state_CPUHP_AP_ONLINE: cpuhp_state = 145;
pub const cpuhp_state_CPUHP_TEARDOWN_CPU: cpuhp_state = 146;
pub const cpuhp_state_CPUHP_AP_ONLINE_IDLE: cpuhp_state = 147;
pub const cpuhp_state_CPUHP_AP_HYPERV_ONLINE: cpuhp_state = 148;
pub const cpuhp_state_CPUHP_AP_KVM_ONLINE: cpuhp_state = 149;
pub const cpuhp_state_CPUHP_AP_SCHED_WAIT_EMPTY: cpuhp_state = 150;
pub const cpuhp_state_CPUHP_AP_SMPBOOT_THREADS: cpuhp_state = 151;
pub const cpuhp_state_CPUHP_AP_IRQ_AFFINITY_ONLINE: cpuhp_state = 152;
pub const cpuhp_state_CPUHP_AP_BLK_MQ_ONLINE: cpuhp_state = 153;
pub const cpuhp_state_CPUHP_AP_ARM_MVEBU_SYNC_CLOCKS: cpuhp_state = 154;
pub const cpuhp_state_CPUHP_AP_X86_INTEL_EPB_ONLINE: cpuhp_state = 155;
pub const cpuhp_state_CPUHP_AP_PERF_ONLINE: cpuhp_state = 156;
pub const cpuhp_state_CPUHP_AP_PERF_X86_ONLINE: cpuhp_state = 157;
pub const cpuhp_state_CPUHP_AP_PERF_X86_UNCORE_ONLINE: cpuhp_state = 158;
pub const cpuhp_state_CPUHP_AP_PERF_X86_AMD_UNCORE_ONLINE: cpuhp_state = 159;
pub const cpuhp_state_CPUHP_AP_PERF_X86_AMD_POWER_ONLINE: cpuhp_state = 160;
pub const cpuhp_state_CPUHP_AP_PERF_S390_CF_ONLINE: cpuhp_state = 161;
pub const cpuhp_state_CPUHP_AP_PERF_S390_SF_ONLINE: cpuhp_state = 162;
pub const cpuhp_state_CPUHP_AP_PERF_ARM_CCI_ONLINE: cpuhp_state = 163;
pub const cpuhp_state_CPUHP_AP_PERF_ARM_CCN_ONLINE: cpuhp_state = 164;
pub const cpuhp_state_CPUHP_AP_PERF_ARM_HISI_CPA_ONLINE: cpuhp_state = 165;
pub const cpuhp_state_CPUHP_AP_PERF_ARM_HISI_DDRC_ONLINE: cpuhp_state = 166;
pub const cpuhp_state_CPUHP_AP_PERF_ARM_HISI_HHA_ONLINE: cpuhp_state = 167;
pub const cpuhp_state_CPUHP_AP_PERF_ARM_HISI_L3_ONLINE: cpuhp_state = 168;
pub const cpuhp_state_CPUHP_AP_PERF_ARM_HISI_PA_ONLINE: cpuhp_state = 169;
pub const cpuhp_state_CPUHP_AP_PERF_ARM_HISI_SLLC_ONLINE: cpuhp_state = 170;
pub const cpuhp_state_CPUHP_AP_PERF_ARM_HISI_PCIE_PMU_ONLINE: cpuhp_state = 171;
pub const cpuhp_state_CPUHP_AP_PERF_ARM_HNS3_PMU_ONLINE: cpuhp_state = 172;
pub const cpuhp_state_CPUHP_AP_PERF_ARM_L2X0_ONLINE: cpuhp_state = 173;
pub const cpuhp_state_CPUHP_AP_PERF_ARM_QCOM_L2_ONLINE: cpuhp_state = 174;
pub const cpuhp_state_CPUHP_AP_PERF_ARM_QCOM_L3_ONLINE: cpuhp_state = 175;
pub const cpuhp_state_CPUHP_AP_PERF_ARM_APM_XGENE_ONLINE: cpuhp_state = 176;
pub const cpuhp_state_CPUHP_AP_PERF_ARM_CAVIUM_TX2_UNCORE_ONLINE: cpuhp_state = 177;
pub const cpuhp_state_CPUHP_AP_PERF_ARM_MARVELL_CN10K_DDR_ONLINE: cpuhp_state = 178;
pub const cpuhp_state_CPUHP_AP_PERF_ARM_MRVL_PEM_ONLINE: cpuhp_state = 179;
pub const cpuhp_state_CPUHP_AP_PERF_POWERPC_NEST_IMC_ONLINE: cpuhp_state = 180;
pub const cpuhp_state_CPUHP_AP_PERF_POWERPC_CORE_IMC_ONLINE: cpuhp_state = 181;
pub const cpuhp_state_CPUHP_AP_PERF_POWERPC_THREAD_IMC_ONLINE: cpuhp_state = 182;
pub const cpuhp_state_CPUHP_AP_PERF_POWERPC_TRACE_IMC_ONLINE: cpuhp_state = 183;
pub const cpuhp_state_CPUHP_AP_PERF_POWERPC_HV_24x7_ONLINE: cpuhp_state = 184;
pub const cpuhp_state_CPUHP_AP_PERF_POWERPC_HV_GPCI_ONLINE: cpuhp_state = 185;
pub const cpuhp_state_CPUHP_AP_PERF_CSKY_ONLINE: cpuhp_state = 186;
pub const cpuhp_state_CPUHP_AP_TMIGR_ONLINE: cpuhp_state = 187;
pub const cpuhp_state_CPUHP_AP_WATCHDOG_ONLINE: cpuhp_state = 188;
pub const cpuhp_state_CPUHP_AP_WORKQUEUE_ONLINE: cpuhp_state = 189;
pub const cpuhp_state_CPUHP_AP_RANDOM_ONLINE: cpuhp_state = 190;
pub const cpuhp_state_CPUHP_AP_RCUTREE_ONLINE: cpuhp_state = 191;
pub const cpuhp_state_CPUHP_AP_KTHREADS_ONLINE: cpuhp_state = 192;
pub const cpuhp_state_CPUHP_AP_BASE_CACHEINFO_ONLINE: cpuhp_state = 193;
pub const cpuhp_state_CPUHP_AP_ONLINE_DYN: cpuhp_state = 194;
pub const cpuhp_state_CPUHP_AP_ONLINE_DYN_END: cpuhp_state = 234;
pub const cpuhp_state_CPUHP_AP_X86_HPET_ONLINE: cpuhp_state = 235;
pub const cpuhp_state_CPUHP_AP_X86_KVM_CLK_ONLINE: cpuhp_state = 236;
pub const cpuhp_state_CPUHP_AP_ACTIVE: cpuhp_state = 237;
pub const cpuhp_state_CPUHP_ONLINE: cpuhp_state = 238;
pub type cpuhp_state = ffi::c_int;
extern "C" {
    pub fn __cpuhp_setup_state(
        state: cpuhp_state,
        name: *const ffi::c_char,
        invoke: bool_,
        startup: ::core::option::Option<unsafe extern "C" fn(cpu: ffi::c_uint) -> ffi::c_int>,
        teardown: ::core::option::Option<unsafe extern "C" fn(cpu: ffi::c_uint) -> ffi::c_int>,
        multi_instance: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __cpuhp_setup_state_cpuslocked(
        state: cpuhp_state,
        name: *const ffi::c_char,
        invoke: bool_,
        startup: ::core::option::Option<unsafe extern "C" fn(cpu: ffi::c_uint) -> ffi::c_int>,
        teardown: ::core::option::Option<unsafe extern "C" fn(cpu: ffi::c_uint) -> ffi::c_int>,
        multi_instance: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __cpuhp_state_add_instance(
        state: cpuhp_state,
        node: *mut hlist_node,
        invoke: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __cpuhp_state_add_instance_cpuslocked(
        state: cpuhp_state,
        node: *mut hlist_node,
        invoke: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __cpuhp_remove_state(state: cpuhp_state, invoke: bool_);
}
extern "C" {
    pub fn __cpuhp_remove_state_cpuslocked(state: cpuhp_state, invoke: bool_);
}
extern "C" {
    pub fn __cpuhp_state_remove_instance(
        state: cpuhp_state,
        node: *mut hlist_node,
        invoke: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn cpuhp_online_idle(state: cpuhp_state);
}
extern "C" {
    pub fn cpuhp_ap_sync_alive();
}
extern "C" {
    pub fn arch_cpuhp_sync_state_poll();
}
extern "C" {
    pub fn arch_cpuhp_cleanup_kick_cpu(cpu: ffi::c_uint);
}
extern "C" {
    pub fn arch_cpuhp_kick_ap_alive(cpu: ffi::c_uint, tidle: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn arch_cpuhp_init_parallel_bringup() -> bool_;
}
extern "C" {
    pub fn cpuhp_ap_report_dead();
}
extern "C" {
    pub fn arch_cpuhp_cleanup_dead_cpu(cpu: ffi::c_uint);
}
pub const cpuhp_smt_control_CPU_SMT_ENABLED: cpuhp_smt_control = 0;
pub const cpuhp_smt_control_CPU_SMT_DISABLED: cpuhp_smt_control = 1;
pub const cpuhp_smt_control_CPU_SMT_FORCE_DISABLED: cpuhp_smt_control = 2;
pub const cpuhp_smt_control_CPU_SMT_NOT_SUPPORTED: cpuhp_smt_control = 3;
pub const cpuhp_smt_control_CPU_SMT_NOT_IMPLEMENTED: cpuhp_smt_control = 4;
pub type cpuhp_smt_control = ffi::c_uint;
extern "C" {
    pub static mut cpu_smt_control: cpuhp_smt_control;
}
extern "C" {
    pub static mut cpu_smt_num_threads: ffi::c_uint;
}
extern "C" {
    pub fn cpu_smt_disable(force: bool_);
}
extern "C" {
    pub fn cpu_smt_set_num_threads(num_threads: ffi::c_uint, max_threads: ffi::c_uint);
}
extern "C" {
    pub fn cpu_smt_possible() -> bool_;
}
extern "C" {
    pub fn cpuhp_smt_enable() -> ffi::c_int;
}
extern "C" {
    pub fn cpuhp_smt_disable(ctrlval: cpuhp_smt_control) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct cpu {
    pub node_id: ffi::c_int,
    pub hotpluggable: ffi::c_int,
    pub dev: device,
}
impl Default for cpu {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn boot_cpu_init();
}
extern "C" {
    pub fn boot_cpu_hotplug_init();
}
extern "C" {
    pub fn cpu_init();
}
extern "C" {
    pub fn trap_init();
}
extern "C" {
    pub fn register_cpu(cpu: *mut cpu, num: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn get_cpu_device(cpu: ffi::c_uint) -> *mut device;
}
extern "C" {
    pub fn cpu_is_hotpluggable(cpu: ffi::c_uint) -> bool_;
}
extern "C" {
    pub fn arch_match_cpu_phys_id(cpu: ffi::c_int, phys_id: u64_) -> bool_;
}
extern "C" {
    pub fn arch_find_n_match_cpu_physical_id(
        cpun: *mut device_node,
        cpu: ffi::c_int,
        thread: *mut ffi::c_uint,
    ) -> bool_;
}
extern "C" {
    pub fn cpu_add_dev_attr(attr: *mut device_attribute) -> ffi::c_int;
}
extern "C" {
    pub fn cpu_remove_dev_attr(attr: *mut device_attribute);
}
extern "C" {
    pub fn cpu_add_dev_attr_group(attrs: *mut attribute_group) -> ffi::c_int;
}
extern "C" {
    pub fn cpu_remove_dev_attr_group(attrs: *mut attribute_group);
}
extern "C" {
    pub fn cpu_show_meltdown(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *mut ffi::c_char,
    ) -> isize;
}
extern "C" {
    pub fn cpu_show_spectre_v1(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *mut ffi::c_char,
    ) -> isize;
}
extern "C" {
    pub fn cpu_show_spectre_v2(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *mut ffi::c_char,
    ) -> isize;
}
extern "C" {
    pub fn cpu_show_spec_store_bypass(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *mut ffi::c_char,
    ) -> isize;
}
extern "C" {
    pub fn cpu_show_l1tf(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *mut ffi::c_char,
    ) -> isize;
}
extern "C" {
    pub fn cpu_show_mds(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *mut ffi::c_char,
    ) -> isize;
}
extern "C" {
    pub fn cpu_show_tsx_async_abort(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *mut ffi::c_char,
    ) -> isize;
}
extern "C" {
    pub fn cpu_show_itlb_multihit(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *mut ffi::c_char,
    ) -> isize;
}
extern "C" {
    pub fn cpu_show_srbds(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *mut ffi::c_char,
    ) -> isize;
}
extern "C" {
    pub fn cpu_show_mmio_stale_data(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *mut ffi::c_char,
    ) -> isize;
}
extern "C" {
    pub fn cpu_show_retbleed(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *mut ffi::c_char,
    ) -> isize;
}
extern "C" {
    pub fn cpu_show_spec_rstack_overflow(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *mut ffi::c_char,
    ) -> isize;
}
extern "C" {
    pub fn cpu_show_gds(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *mut ffi::c_char,
    ) -> isize;
}
extern "C" {
    pub fn cpu_show_reg_file_data_sampling(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *mut ffi::c_char,
    ) -> isize;
}
extern "C" {
    pub fn cpu_show_ghostwrite(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *mut ffi::c_char,
    ) -> isize;
}
extern "C" {
    pub fn cpu_show_indirect_target_selection(
        dev: *mut device,
        attr: *mut device_attribute,
        buf: *mut ffi::c_char,
    ) -> isize;
}
extern "C" {
    pub fn cpu_device_create(
        parent: *mut device,
        drvdata: *mut ffi::c_void,
        groups: *mut *const attribute_group,
        fmt: *const ffi::c_char,
        ...
    ) -> *mut device;
}
extern "C" {
    pub fn arch_cpu_is_hotpluggable(cpu: ffi::c_int) -> bool_;
}
extern "C" {
    pub fn arch_register_cpu(cpu: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn arch_unregister_cpu(cpu: ffi::c_int);
}
extern "C" {
    pub fn unregister_cpu(cpu: *mut cpu);
}
extern "C" {
    pub fn arch_cpu_probe(arg1: *const ffi::c_char, arg2: usize) -> isize;
}
extern "C" {
    pub fn arch_cpu_release(arg1: *const ffi::c_char, arg2: usize) -> isize;
}
extern "C" {
    pub static mut cpu_devices: cpu;
}
extern "C" {
    pub static mut cpuhp_tasks_frozen: bool_;
}
extern "C" {
    pub fn add_cpu(cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn cpu_device_up(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn notify_cpu_starting(cpu: ffi::c_uint);
}
extern "C" {
    pub fn cpu_maps_update_begin();
}
extern "C" {
    pub fn cpu_maps_update_done();
}
extern "C" {
    pub fn bringup_hibernate_cpu(sleep_cpu: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn bringup_nonboot_cpus(max_cpus: ffi::c_uint);
}
extern "C" {
    pub static cpu_subsys: bus_type;
}
extern "C" {
    pub fn freeze_secondary_cpus(primary: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn thaw_secondary_cpus();
}
extern "C" {
    pub fn cpu_startup_entry(state: cpuhp_state) -> !;
}
extern "C" {
    pub fn cpu_idle_poll_ctrl(enable: bool_);
}
extern "C" {
    pub fn cpu_in_idle(pc: ffi::c_ulong) -> bool_;
}
extern "C" {
    pub fn arch_cpu_idle();
}
extern "C" {
    pub fn arch_cpu_idle_prepare();
}
extern "C" {
    pub fn arch_cpu_idle_enter();
}
extern "C" {
    pub fn arch_cpu_idle_exit();
}
extern "C" {
    pub fn arch_tick_broadcast_enter();
}
extern "C" {
    pub fn arch_tick_broadcast_exit();
}
extern "C" {
    pub fn arch_cpu_idle_dead() -> !;
}
extern "C" {
    pub fn play_idle_precise(duration_ns: u64_, latency_ns: u64_);
}
extern "C" {
    pub fn cpuhp_report_idle_dead();
}
extern "C" {
    pub fn cpu_mitigations_off() -> bool_;
}
extern "C" {
    pub fn cpu_mitigations_auto_nosmt() -> bool_;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct taskstats {
    pub version: __u16,
    pub ac_exitcode: __u32,
    pub ac_flag: __u8,
    pub ac_nice: __u8,
    pub cpu_count: __u64,
    pub cpu_delay_total: __u64,
    pub cpu_delay_max: __u64,
    pub cpu_delay_min: __u64,
    pub blkio_count: __u64,
    pub blkio_delay_total: __u64,
    pub blkio_delay_max: __u64,
    pub blkio_delay_min: __u64,
    pub swapin_count: __u64,
    pub swapin_delay_total: __u64,
    pub swapin_delay_max: __u64,
    pub swapin_delay_min: __u64,
    pub cpu_run_real_total: __u64,
    pub cpu_run_virtual_total: __u64,
    pub ac_comm: [ffi::c_char; 32usize],
    pub ac_sched: __u8,
    pub ac_pad: [__u8; 3usize],
    pub __bindgen_padding_0: u32,
    pub ac_uid: __u32,
    pub ac_gid: __u32,
    pub ac_pid: __u32,
    pub ac_ppid: __u32,
    pub ac_btime: __u32,
    pub ac_etime: __u64,
    pub ac_utime: __u64,
    pub ac_stime: __u64,
    pub ac_minflt: __u64,
    pub ac_majflt: __u64,
    pub coremem: __u64,
    pub virtmem: __u64,
    pub hiwater_rss: __u64,
    pub hiwater_vm: __u64,
    pub read_char: __u64,
    pub write_char: __u64,
    pub read_syscalls: __u64,
    pub write_syscalls: __u64,
    pub read_bytes: __u64,
    pub write_bytes: __u64,
    pub cancelled_write_bytes: __u64,
    pub nvcsw: __u64,
    pub nivcsw: __u64,
    pub ac_utimescaled: __u64,
    pub ac_stimescaled: __u64,
    pub cpu_scaled_run_real_total: __u64,
    pub freepages_count: __u64,
    pub freepages_delay_total: __u64,
    pub freepages_delay_max: __u64,
    pub freepages_delay_min: __u64,
    pub thrashing_count: __u64,
    pub thrashing_delay_total: __u64,
    pub thrashing_delay_max: __u64,
    pub thrashing_delay_min: __u64,
    pub ac_btime64: __u64,
    pub compact_count: __u64,
    pub compact_delay_total: __u64,
    pub compact_delay_max: __u64,
    pub compact_delay_min: __u64,
    pub ac_tgid: __u32,
    pub ac_tgetime: __u64,
    pub ac_exe_dev: __u64,
    pub ac_exe_inode: __u64,
    pub wpcopy_count: __u64,
    pub wpcopy_delay_total: __u64,
    pub wpcopy_delay_max: __u64,
    pub wpcopy_delay_min: __u64,
    pub irq_count: __u64,
    pub irq_delay_total: __u64,
    pub irq_delay_max: __u64,
    pub irq_delay_min: __u64,
}
pub const TASKSTATS_CMD_UNSPEC: _bindgen_ty_249 = 0;
pub const TASKSTATS_CMD_GET: _bindgen_ty_249 = 1;
pub const TASKSTATS_CMD_NEW: _bindgen_ty_249 = 2;
pub const __TASKSTATS_CMD_MAX: _bindgen_ty_249 = 3;
pub type _bindgen_ty_249 = ffi::c_uint;
pub const TASKSTATS_TYPE_UNSPEC: _bindgen_ty_250 = 0;
pub const TASKSTATS_TYPE_PID: _bindgen_ty_250 = 1;
pub const TASKSTATS_TYPE_TGID: _bindgen_ty_250 = 2;
pub const TASKSTATS_TYPE_STATS: _bindgen_ty_250 = 3;
pub const TASKSTATS_TYPE_AGGR_PID: _bindgen_ty_250 = 4;
pub const TASKSTATS_TYPE_AGGR_TGID: _bindgen_ty_250 = 5;
pub const TASKSTATS_TYPE_NULL: _bindgen_ty_250 = 6;
pub const __TASKSTATS_TYPE_MAX: _bindgen_ty_250 = 7;
pub type _bindgen_ty_250 = ffi::c_uint;
pub const TASKSTATS_CMD_ATTR_UNSPEC: _bindgen_ty_251 = 0;
pub const TASKSTATS_CMD_ATTR_PID: _bindgen_ty_251 = 1;
pub const TASKSTATS_CMD_ATTR_TGID: _bindgen_ty_251 = 2;
pub const TASKSTATS_CMD_ATTR_REGISTER_CPUMASK: _bindgen_ty_251 = 3;
pub const TASKSTATS_CMD_ATTR_DEREGISTER_CPUMASK: _bindgen_ty_251 = 4;
pub const __TASKSTATS_CMD_ATTR_MAX: _bindgen_ty_251 = 5;
pub type _bindgen_ty_251 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct cgroupstats {
    pub nr_sleeping: __u64,
    pub nr_running: __u64,
    pub nr_stopped: __u64,
    pub nr_uninterruptible: __u64,
    pub nr_io_wait: __u64,
}
pub const CGROUPSTATS_CMD_UNSPEC: _bindgen_ty_252 = 3;
pub const CGROUPSTATS_CMD_GET: _bindgen_ty_252 = 4;
pub const CGROUPSTATS_CMD_NEW: _bindgen_ty_252 = 5;
pub const __CGROUPSTATS_CMD_MAX: _bindgen_ty_252 = 6;
pub type _bindgen_ty_252 = ffi::c_uint;
pub const CGROUPSTATS_TYPE_UNSPEC: _bindgen_ty_253 = 0;
pub const CGROUPSTATS_TYPE_CGROUP_STATS: _bindgen_ty_253 = 1;
pub const __CGROUPSTATS_TYPE_MAX: _bindgen_ty_253 = 2;
pub type _bindgen_ty_253 = ffi::c_uint;
pub const CGROUPSTATS_CMD_ATTR_UNSPEC: _bindgen_ty_254 = 0;
pub const CGROUPSTATS_CMD_ATTR_FD: _bindgen_ty_254 = 1;
pub const __CGROUPSTATS_CMD_ATTR_MAX: _bindgen_ty_254 = 2;
pub type _bindgen_ty_254 = ffi::c_uint;
extern "C" {
    pub static _ctype: [ffi::c_uchar; 0usize];
}
pub const string_size_units_STRING_UNITS_10: string_size_units = 0;
pub const string_size_units_STRING_UNITS_2: string_size_units = 1;
pub const string_size_units_STRING_UNITS_MASK: string_size_units = 1;
pub const string_size_units_STRING_UNITS_NO_SPACE: string_size_units = 1073741824;
pub const string_size_units_STRING_UNITS_NO_BYTES: string_size_units = 2147483648;
pub type string_size_units = ffi::c_uint;
extern "C" {
    pub fn string_get_size(
        size: u64_,
        blk_size: u64_,
        units: string_size_units,
        buf: *mut ffi::c_char,
        len: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn parse_int_array_user(
        from: *const ffi::c_char,
        count: usize,
        array: *mut *mut ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn string_unescape(
        src: *mut ffi::c_char,
        dst: *mut ffi::c_char,
        size: usize,
        flags: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn string_escape_mem(
        src: *const ffi::c_char,
        isz: usize,
        dst: *mut ffi::c_char,
        osz: usize,
        flags: ffi::c_uint,
        only: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn kstrdup_quotable(src: *const ffi::c_char, gfp: gfp_t) -> *mut ffi::c_char;
}
extern "C" {
    pub fn kstrdup_quotable_cmdline(task: *mut task_struct, gfp: gfp_t) -> *mut ffi::c_char;
}
extern "C" {
    pub fn kstrdup_quotable_file(file: *mut file, gfp: gfp_t) -> *mut ffi::c_char;
}
extern "C" {
    pub fn kstrdup_and_replace(
        src: *const ffi::c_char,
        old: ffi::c_char,
        new: ffi::c_char,
        gfp: gfp_t,
    ) -> *mut ffi::c_char;
}
extern "C" {
    pub fn kasprintf_strarray(
        gfp: gfp_t,
        prefix: *const ffi::c_char,
        n: usize,
    ) -> *mut *mut ffi::c_char;
}
extern "C" {
    pub fn kfree_strarray(array: *mut *mut ffi::c_char, n: usize);
}
extern "C" {
    pub fn devm_kasprintf_strarray(
        dev: *mut device,
        prefix: *const ffi::c_char,
        n: usize,
    ) -> *mut *mut ffi::c_char;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct seq_file {
    pub buf: *mut ffi::c_char,
    pub size: usize,
    pub from: usize,
    pub count: usize,
    pub pad_until: usize,
    pub index: loff_t,
    pub read_pos: loff_t,
    pub lock: mutex,
    pub op: *const seq_operations,
    pub poll_event: ffi::c_int,
    pub file: *const file,
    pub private: *mut ffi::c_void,
}
impl Default for seq_file {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct seq_operations {
    pub start: ::core::option::Option<
        unsafe extern "C" fn(m: *mut seq_file, pos: *mut loff_t) -> *mut ffi::c_void,
    >,
    pub stop: ::core::option::Option<unsafe extern "C" fn(m: *mut seq_file, v: *mut ffi::c_void)>,
    pub next: ::core::option::Option<
        unsafe extern "C" fn(
            m: *mut seq_file,
            v: *mut ffi::c_void,
            pos: *mut loff_t,
        ) -> *mut ffi::c_void,
    >,
    pub show: ::core::option::Option<
        unsafe extern "C" fn(m: *mut seq_file, v: *mut ffi::c_void) -> ffi::c_int,
    >,
}
extern "C" {
    pub fn seq_pad(m: *mut seq_file, c: ffi::c_char);
}
extern "C" {
    pub fn mangle_path(
        s: *mut ffi::c_char,
        p: *const ffi::c_char,
        esc: *const ffi::c_char,
    ) -> *mut ffi::c_char;
}
extern "C" {
    pub fn seq_open(arg1: *mut file, arg2: *const seq_operations) -> ffi::c_int;
}
extern "C" {
    pub fn seq_read(
        arg1: *mut file,
        arg2: *mut ffi::c_char,
        arg3: usize,
        arg4: *mut loff_t,
    ) -> isize;
}
extern "C" {
    pub fn seq_read_iter(iocb: *mut kiocb, iter: *mut iov_iter) -> isize;
}
extern "C" {
    pub fn seq_lseek(arg1: *mut file, arg2: loff_t, arg3: ffi::c_int) -> loff_t;
}
extern "C" {
    pub fn seq_release(arg1: *mut inode, arg2: *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn seq_write(seq: *mut seq_file, data: *const ffi::c_void, len: usize) -> ffi::c_int;
}
extern "C" {
    pub fn seq_vprintf(m: *mut seq_file, fmt: *const ffi::c_char, args: va_list);
}
extern "C" {
    pub fn seq_printf(m: *mut seq_file, fmt: *const ffi::c_char, ...);
}
extern "C" {
    pub fn seq_putc(m: *mut seq_file, c: ffi::c_char);
}
extern "C" {
    pub fn __seq_puts(m: *mut seq_file, s: *const ffi::c_char);
}
extern "C" {
    pub fn seq_put_decimal_ull_width(
        m: *mut seq_file,
        delimiter: *const ffi::c_char,
        num: ffi::c_ulonglong,
        width: ffi::c_uint,
    );
}
extern "C" {
    pub fn seq_put_decimal_ull(
        m: *mut seq_file,
        delimiter: *const ffi::c_char,
        num: ffi::c_ulonglong,
    );
}
extern "C" {
    pub fn seq_put_decimal_ll(
        m: *mut seq_file,
        delimiter: *const ffi::c_char,
        num: ffi::c_longlong,
    );
}
extern "C" {
    pub fn seq_put_hex_ll(
        m: *mut seq_file,
        delimiter: *const ffi::c_char,
        v: ffi::c_ulonglong,
        width: ffi::c_uint,
    );
}
extern "C" {
    pub fn seq_escape_mem(
        m: *mut seq_file,
        src: *const ffi::c_char,
        len: usize,
        flags: ffi::c_uint,
        esc: *const ffi::c_char,
    );
}
extern "C" {
    pub fn seq_hex_dump(
        m: *mut seq_file,
        prefix_str: *const ffi::c_char,
        prefix_type: ffi::c_int,
        rowsize: ffi::c_int,
        groupsize: ffi::c_int,
        buf: *const ffi::c_void,
        len: usize,
        ascii: bool_,
    );
}
extern "C" {
    pub fn seq_path(arg1: *mut seq_file, arg2: *const path, arg3: *const ffi::c_char)
        -> ffi::c_int;
}
extern "C" {
    pub fn seq_file_path(
        arg1: *mut seq_file,
        arg2: *mut file,
        arg3: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn seq_dentry(
        arg1: *mut seq_file,
        arg2: *mut dentry,
        arg3: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn seq_path_root(
        m: *mut seq_file,
        path: *const path,
        root: *const path,
        esc: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn single_start(arg1: *mut seq_file, arg2: *mut loff_t) -> *mut ffi::c_void;
}
extern "C" {
    pub fn single_open(
        arg1: *mut file,
        arg2: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut seq_file, arg2: *mut ffi::c_void) -> ffi::c_int,
        >,
        arg3: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn single_open_size(
        arg1: *mut file,
        arg2: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut seq_file, arg2: *mut ffi::c_void) -> ffi::c_int,
        >,
        arg3: *mut ffi::c_void,
        arg4: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn single_release(arg1: *mut inode, arg2: *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn __seq_open_private(
        arg1: *mut file,
        arg2: *const seq_operations,
        arg3: ffi::c_int,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn seq_open_private(
        arg1: *mut file,
        arg2: *const seq_operations,
        arg3: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn seq_release_private(arg1: *mut inode, arg2: *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn seq_bprintf(m: *mut seq_file, f: *const ffi::c_char, binary: *const u32_);
}
extern "C" {
    pub fn seq_list_start(head: *mut list_head, pos: loff_t) -> *mut list_head;
}
extern "C" {
    pub fn seq_list_start_head(head: *mut list_head, pos: loff_t) -> *mut list_head;
}
extern "C" {
    pub fn seq_list_next(
        v: *mut ffi::c_void,
        head: *mut list_head,
        ppos: *mut loff_t,
    ) -> *mut list_head;
}
extern "C" {
    pub fn seq_list_start_rcu(head: *mut list_head, pos: loff_t) -> *mut list_head;
}
extern "C" {
    pub fn seq_list_start_head_rcu(head: *mut list_head, pos: loff_t) -> *mut list_head;
}
extern "C" {
    pub fn seq_list_next_rcu(
        v: *mut ffi::c_void,
        head: *mut list_head,
        ppos: *mut loff_t,
    ) -> *mut list_head;
}
extern "C" {
    pub fn seq_hlist_start(head: *mut hlist_head, pos: loff_t) -> *mut hlist_node;
}
extern "C" {
    pub fn seq_hlist_start_head(head: *mut hlist_head, pos: loff_t) -> *mut hlist_node;
}
extern "C" {
    pub fn seq_hlist_next(
        v: *mut ffi::c_void,
        head: *mut hlist_head,
        ppos: *mut loff_t,
    ) -> *mut hlist_node;
}
extern "C" {
    pub fn seq_hlist_start_rcu(head: *mut hlist_head, pos: loff_t) -> *mut hlist_node;
}
extern "C" {
    pub fn seq_hlist_start_head_rcu(head: *mut hlist_head, pos: loff_t) -> *mut hlist_node;
}
extern "C" {
    pub fn seq_hlist_next_rcu(
        v: *mut ffi::c_void,
        head: *mut hlist_head,
        ppos: *mut loff_t,
    ) -> *mut hlist_node;
}
extern "C" {
    pub fn seq_hlist_start_percpu(
        head: *mut hlist_head,
        cpu: *mut ffi::c_int,
        pos: loff_t,
    ) -> *mut hlist_node;
}
extern "C" {
    pub fn seq_hlist_next_percpu(
        v: *mut ffi::c_void,
        head: *mut hlist_head,
        cpu: *mut ffi::c_int,
        pos: *mut loff_t,
    ) -> *mut hlist_node;
}
extern "C" {
    pub fn seq_file_init();
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct uid_gid_extent {
    pub first: u32_,
    pub lower_first: u32_,
    pub count: u32_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct uid_gid_map {
    pub __bindgen_anon_1: uid_gid_map__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union uid_gid_map__bindgen_ty_1 {
    pub __bindgen_anon_1: uid_gid_map__bindgen_ty_1__bindgen_ty_1,
    pub __bindgen_anon_2: uid_gid_map__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct uid_gid_map__bindgen_ty_1__bindgen_ty_1 {
    pub extent: [uid_gid_extent; 5usize],
    pub nr_extents: u32_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct uid_gid_map__bindgen_ty_1__bindgen_ty_2 {
    pub forward: *mut uid_gid_extent,
    pub reverse: *mut uid_gid_extent,
}
impl Default for uid_gid_map__bindgen_ty_1__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for uid_gid_map__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for uid_gid_map {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const ucount_type_UCOUNT_USER_NAMESPACES: ucount_type = 0;
pub const ucount_type_UCOUNT_PID_NAMESPACES: ucount_type = 1;
pub const ucount_type_UCOUNT_UTS_NAMESPACES: ucount_type = 2;
pub const ucount_type_UCOUNT_IPC_NAMESPACES: ucount_type = 3;
pub const ucount_type_UCOUNT_NET_NAMESPACES: ucount_type = 4;
pub const ucount_type_UCOUNT_MNT_NAMESPACES: ucount_type = 5;
pub const ucount_type_UCOUNT_CGROUP_NAMESPACES: ucount_type = 6;
pub const ucount_type_UCOUNT_TIME_NAMESPACES: ucount_type = 7;
pub const ucount_type_UCOUNT_INOTIFY_INSTANCES: ucount_type = 8;
pub const ucount_type_UCOUNT_INOTIFY_WATCHES: ucount_type = 9;
pub const ucount_type_UCOUNT_FANOTIFY_GROUPS: ucount_type = 10;
pub const ucount_type_UCOUNT_FANOTIFY_MARKS: ucount_type = 11;
pub const ucount_type_UCOUNT_COUNTS: ucount_type = 12;
pub type ucount_type = ffi::c_uint;
pub const rlimit_type_UCOUNT_RLIMIT_NPROC: rlimit_type = 0;
pub const rlimit_type_UCOUNT_RLIMIT_MSGQUEUE: rlimit_type = 1;
pub const rlimit_type_UCOUNT_RLIMIT_SIGPENDING: rlimit_type = 2;
pub const rlimit_type_UCOUNT_RLIMIT_MEMLOCK: rlimit_type = 3;
pub const rlimit_type_UCOUNT_RLIMIT_COUNTS: rlimit_type = 4;
pub type rlimit_type = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct binfmt_misc {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ucounts {
    pub node: hlist_nulls_node,
    pub ns: *mut user_namespace,
    pub uid: kuid_t,
    pub rcu: callback_head,
    pub count: rcuref_t,
    pub ucount: [atomic_long_t; 12usize],
    pub rlimit: [atomic_long_t; 4usize],
}
impl Default for ucounts {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut init_ucounts: ucounts;
}
extern "C" {
    pub fn setup_userns_sysctls(ns: *mut user_namespace) -> bool_;
}
extern "C" {
    pub fn retire_userns_sysctls(ns: *mut user_namespace);
}
extern "C" {
    pub fn inc_ucount(ns: *mut user_namespace, uid: kuid_t, type_: ucount_type) -> *mut ucounts;
}
extern "C" {
    pub fn dec_ucount(ucounts: *mut ucounts, type_: ucount_type);
}
extern "C" {
    pub fn alloc_ucounts(ns: *mut user_namespace, uid: kuid_t) -> *mut ucounts;
}
extern "C" {
    pub fn put_ucounts(ucounts: *mut ucounts);
}
extern "C" {
    pub fn inc_rlimit_ucounts(
        ucounts: *mut ucounts,
        type_: rlimit_type,
        v: ffi::c_long,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn dec_rlimit_ucounts(ucounts: *mut ucounts, type_: rlimit_type, v: ffi::c_long) -> bool_;
}
extern "C" {
    pub fn inc_rlimit_get_ucounts(
        ucounts: *mut ucounts,
        type_: rlimit_type,
        override_rlimit: bool_,
    ) -> ffi::c_long;
}
extern "C" {
    pub fn dec_rlimit_put_ucounts(ucounts: *mut ucounts, type_: rlimit_type);
}
extern "C" {
    pub fn is_rlimit_overlimit(
        ucounts: *mut ucounts,
        type_: rlimit_type,
        max: ffi::c_ulong,
    ) -> bool_;
}
extern "C" {
    pub fn create_user_ns(new: *mut cred) -> ffi::c_int;
}
extern "C" {
    pub fn unshare_userns(unshare_flags: ffi::c_ulong, new_cred: *mut *mut cred) -> ffi::c_int;
}
extern "C" {
    pub fn __put_user_ns(ns: *mut user_namespace);
}
extern "C" {
    pub static proc_uid_seq_operations: seq_operations;
}
extern "C" {
    pub static proc_gid_seq_operations: seq_operations;
}
extern "C" {
    pub static proc_projid_seq_operations: seq_operations;
}
extern "C" {
    pub fn proc_uid_map_write(
        arg1: *mut file,
        arg2: *const ffi::c_char,
        arg3: usize,
        arg4: *mut loff_t,
    ) -> isize;
}
extern "C" {
    pub fn proc_gid_map_write(
        arg1: *mut file,
        arg2: *const ffi::c_char,
        arg3: usize,
        arg4: *mut loff_t,
    ) -> isize;
}
extern "C" {
    pub fn proc_projid_map_write(
        arg1: *mut file,
        arg2: *const ffi::c_char,
        arg3: usize,
        arg4: *mut loff_t,
    ) -> isize;
}
extern "C" {
    pub fn proc_setgroups_write(
        arg1: *mut file,
        arg2: *const ffi::c_char,
        arg3: usize,
        arg4: *mut loff_t,
    ) -> isize;
}
extern "C" {
    pub fn proc_setgroups_show(m: *mut seq_file, v: *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn userns_may_setgroups(ns: *const user_namespace) -> bool_;
}
extern "C" {
    pub fn in_userns(ancestor: *const user_namespace, child: *const user_namespace) -> bool_;
}
extern "C" {
    pub fn current_in_userns(target_ns: *const user_namespace) -> bool_;
}
extern "C" {
    pub fn ns_get_owner(ns: *mut ns_common) -> *mut ns_common;
}
pub const cpu_usage_stat_CPUTIME_USER: cpu_usage_stat = 0;
pub const cpu_usage_stat_CPUTIME_NICE: cpu_usage_stat = 1;
pub const cpu_usage_stat_CPUTIME_SYSTEM: cpu_usage_stat = 2;
pub const cpu_usage_stat_CPUTIME_SOFTIRQ: cpu_usage_stat = 3;
pub const cpu_usage_stat_CPUTIME_IRQ: cpu_usage_stat = 4;
pub const cpu_usage_stat_CPUTIME_IDLE: cpu_usage_stat = 5;
pub const cpu_usage_stat_CPUTIME_IOWAIT: cpu_usage_stat = 6;
pub const cpu_usage_stat_CPUTIME_STEAL: cpu_usage_stat = 7;
pub const cpu_usage_stat_CPUTIME_GUEST: cpu_usage_stat = 8;
pub const cpu_usage_stat_CPUTIME_GUEST_NICE: cpu_usage_stat = 9;
pub const cpu_usage_stat_CPUTIME_FORCEIDLE: cpu_usage_stat = 10;
pub const cpu_usage_stat_NR_STATS: cpu_usage_stat = 11;
pub type cpu_usage_stat = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct kernel_cpustat {
    pub cpustat: [u64_; 11usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct kernel_stat {
    pub irqs_sum: ffi::c_ulong,
    pub softirqs: [ffi::c_uint; 10usize],
}
extern "C" {
    pub static mut kstat: kernel_stat;
}
extern "C" {
    pub static mut kernel_cpustat: kernel_cpustat;
}
extern "C" {
    pub fn nr_context_switches_cpu(cpu: ffi::c_int) -> ffi::c_ulonglong;
}
extern "C" {
    pub fn nr_context_switches() -> ffi::c_ulonglong;
}
extern "C" {
    pub fn kstat_irqs_cpu(irq: ffi::c_uint, cpu: ffi::c_int) -> ffi::c_uint;
}
extern "C" {
    pub fn kstat_incr_irq_this_cpu(irq: ffi::c_uint);
}
extern "C" {
    pub fn kstat_snapshot_irqs();
}
extern "C" {
    pub fn kstat_get_irq_since_snapshot(irq: ffi::c_uint) -> ffi::c_uint;
}
extern "C" {
    pub fn kstat_irqs_usr(irq: ffi::c_uint) -> ffi::c_uint;
}
extern "C" {
    pub fn kcpustat_field(
        kcpustat: *mut kernel_cpustat,
        usage: cpu_usage_stat,
        cpu: ffi::c_int,
    ) -> u64_;
}
extern "C" {
    pub fn kcpustat_cpu_fetch(dst: *mut kernel_cpustat, cpu: ffi::c_int);
}
extern "C" {
    pub fn account_user_time(arg1: *mut task_struct, arg2: u64_);
}
extern "C" {
    pub fn account_guest_time(arg1: *mut task_struct, arg2: u64_);
}
extern "C" {
    pub fn account_system_time(arg1: *mut task_struct, arg2: ffi::c_int, arg3: u64_);
}
extern "C" {
    pub fn account_system_index_time(arg1: *mut task_struct, arg2: u64_, arg3: cpu_usage_stat);
}
extern "C" {
    pub fn account_steal_time(arg1: u64_);
}
extern "C" {
    pub fn account_idle_time(arg1: u64_);
}
extern "C" {
    pub fn get_idle_time(kcs: *mut kernel_cpustat, cpu: ffi::c_int) -> u64_;
}
extern "C" {
    pub fn account_process_tick(arg1: *mut task_struct, user: ffi::c_int);
}
extern "C" {
    pub fn account_idle_ticks(ticks: ffi::c_ulong);
}
extern "C" {
    pub fn __account_forceidle_time(tsk: *mut task_struct, delta: u64_);
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct u64_stats_sync {}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct local_t {
    pub a: atomic_long_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct local64_t {
    pub a: local_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct u64_stats_t {
    pub v: local64_t,
}
pub const cgroup_bpf_attach_type_CGROUP_BPF_ATTACH_TYPE_INVALID: cgroup_bpf_attach_type = -1;
pub const cgroup_bpf_attach_type_CGROUP_INET_INGRESS: cgroup_bpf_attach_type = 0;
pub const cgroup_bpf_attach_type_CGROUP_INET_EGRESS: cgroup_bpf_attach_type = 1;
pub const cgroup_bpf_attach_type_CGROUP_INET_SOCK_CREATE: cgroup_bpf_attach_type = 2;
pub const cgroup_bpf_attach_type_CGROUP_SOCK_OPS: cgroup_bpf_attach_type = 3;
pub const cgroup_bpf_attach_type_CGROUP_DEVICE: cgroup_bpf_attach_type = 4;
pub const cgroup_bpf_attach_type_CGROUP_INET4_BIND: cgroup_bpf_attach_type = 5;
pub const cgroup_bpf_attach_type_CGROUP_INET6_BIND: cgroup_bpf_attach_type = 6;
pub const cgroup_bpf_attach_type_CGROUP_INET4_CONNECT: cgroup_bpf_attach_type = 7;
pub const cgroup_bpf_attach_type_CGROUP_INET6_CONNECT: cgroup_bpf_attach_type = 8;
pub const cgroup_bpf_attach_type_CGROUP_UNIX_CONNECT: cgroup_bpf_attach_type = 9;
pub const cgroup_bpf_attach_type_CGROUP_INET4_POST_BIND: cgroup_bpf_attach_type = 10;
pub const cgroup_bpf_attach_type_CGROUP_INET6_POST_BIND: cgroup_bpf_attach_type = 11;
pub const cgroup_bpf_attach_type_CGROUP_UDP4_SENDMSG: cgroup_bpf_attach_type = 12;
pub const cgroup_bpf_attach_type_CGROUP_UDP6_SENDMSG: cgroup_bpf_attach_type = 13;
pub const cgroup_bpf_attach_type_CGROUP_UNIX_SENDMSG: cgroup_bpf_attach_type = 14;
pub const cgroup_bpf_attach_type_CGROUP_SYSCTL: cgroup_bpf_attach_type = 15;
pub const cgroup_bpf_attach_type_CGROUP_UDP4_RECVMSG: cgroup_bpf_attach_type = 16;
pub const cgroup_bpf_attach_type_CGROUP_UDP6_RECVMSG: cgroup_bpf_attach_type = 17;
pub const cgroup_bpf_attach_type_CGROUP_UNIX_RECVMSG: cgroup_bpf_attach_type = 18;
pub const cgroup_bpf_attach_type_CGROUP_GETSOCKOPT: cgroup_bpf_attach_type = 19;
pub const cgroup_bpf_attach_type_CGROUP_SETSOCKOPT: cgroup_bpf_attach_type = 20;
pub const cgroup_bpf_attach_type_CGROUP_INET4_GETPEERNAME: cgroup_bpf_attach_type = 21;
pub const cgroup_bpf_attach_type_CGROUP_INET6_GETPEERNAME: cgroup_bpf_attach_type = 22;
pub const cgroup_bpf_attach_type_CGROUP_UNIX_GETPEERNAME: cgroup_bpf_attach_type = 23;
pub const cgroup_bpf_attach_type_CGROUP_INET4_GETSOCKNAME: cgroup_bpf_attach_type = 24;
pub const cgroup_bpf_attach_type_CGROUP_INET6_GETSOCKNAME: cgroup_bpf_attach_type = 25;
pub const cgroup_bpf_attach_type_CGROUP_UNIX_GETSOCKNAME: cgroup_bpf_attach_type = 26;
pub const cgroup_bpf_attach_type_CGROUP_INET_SOCK_RELEASE: cgroup_bpf_attach_type = 27;
pub const cgroup_bpf_attach_type_CGROUP_LSM_START: cgroup_bpf_attach_type = 28;
pub const cgroup_bpf_attach_type_CGROUP_LSM_END: cgroup_bpf_attach_type = 37;
pub const cgroup_bpf_attach_type_MAX_CGROUP_BPF_ATTACH_TYPE: cgroup_bpf_attach_type = 38;
pub type cgroup_bpf_attach_type = ffi::c_int;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct cgroup_bpf {
    pub effective: [*mut bpf_prog_array; 38usize],
    pub progs: [hlist_head; 38usize],
    pub flags: [u8_; 38usize],
    pub storages: list_head,
    pub inactive: *mut bpf_prog_array,
    pub refcnt: percpu_ref,
    pub release_work: work_struct,
}
impl Default for cgroup_bpf {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn kthread_create_on_node(
        threadfn: ::core::option::Option<
            unsafe extern "C" fn(data: *mut ffi::c_void) -> ffi::c_int,
        >,
        data: *mut ffi::c_void,
        node: ffi::c_int,
        namefmt: *const ffi::c_char,
        ...
    ) -> *mut task_struct;
}
extern "C" {
    pub fn kthread_create_on_cpu(
        threadfn: ::core::option::Option<
            unsafe extern "C" fn(data: *mut ffi::c_void) -> ffi::c_int,
        >,
        data: *mut ffi::c_void,
        cpu: ffi::c_uint,
        namefmt: *const ffi::c_char,
    ) -> *mut task_struct;
}
extern "C" {
    pub fn get_kthread_comm(buf: *mut ffi::c_char, buf_size: usize, tsk: *mut task_struct);
}
extern "C" {
    pub fn set_kthread_struct(p: *mut task_struct) -> bool_;
}
extern "C" {
    pub fn kthread_set_per_cpu(k: *mut task_struct, cpu: ffi::c_int);
}
extern "C" {
    pub fn kthread_is_per_cpu(k: *mut task_struct) -> bool_;
}
extern "C" {
    pub fn free_kthread_struct(k: *mut task_struct);
}
extern "C" {
    pub fn kthread_bind(k: *mut task_struct, cpu: ffi::c_uint);
}
extern "C" {
    pub fn kthread_bind_mask(k: *mut task_struct, mask: *const cpumask);
}
extern "C" {
    pub fn kthread_affine_preferred(p: *mut task_struct, mask: *const cpumask) -> ffi::c_int;
}
extern "C" {
    pub fn kthread_stop(k: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn kthread_stop_put(k: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn kthread_should_stop() -> bool_;
}
extern "C" {
    pub fn kthread_should_park() -> bool_;
}
extern "C" {
    pub fn kthread_should_stop_or_park() -> bool_;
}
extern "C" {
    pub fn kthread_freezable_should_stop(was_frozen: *mut bool_) -> bool_;
}
extern "C" {
    pub fn kthread_func(k: *mut task_struct) -> *mut ffi::c_void;
}
extern "C" {
    pub fn kthread_data(k: *mut task_struct) -> *mut ffi::c_void;
}
extern "C" {
    pub fn kthread_probe_data(k: *mut task_struct) -> *mut ffi::c_void;
}
extern "C" {
    pub fn kthread_park(k: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn kthread_unpark(k: *mut task_struct);
}
extern "C" {
    pub fn kthread_parkme();
}
extern "C" {
    pub fn kthread_exit(result: ffi::c_long) -> !;
}
extern "C" {
    pub fn kthread_complete_and_exit(arg1: *mut completion, arg2: ffi::c_long) -> !;
}
extern "C" {
    pub fn kthreadd(unused: *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub static mut kthreadd_task: *mut task_struct;
}
extern "C" {
    pub fn tsk_fork_get_node(tsk: *mut task_struct) -> ffi::c_int;
}
pub type kthread_work_func_t =
    ::core::option::Option<unsafe extern "C" fn(work: *mut kthread_work)>;
extern "C" {
    pub fn kthread_delayed_work_timer_fn(t: *mut timer_list);
}
pub const KTW_FREEZABLE: _bindgen_ty_255 = 1;
pub type _bindgen_ty_255 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kthread_worker {
    pub flags: ffi::c_uint,
    pub lock: raw_spinlock_t,
    pub work_list: list_head,
    pub delayed_work_list: list_head,
    pub task: *mut task_struct,
    pub current_work: *mut kthread_work,
}
impl Default for kthread_worker {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kthread_work {
    pub node: list_head,
    pub func: kthread_work_func_t,
    pub worker: *mut kthread_worker,
    pub canceling: ffi::c_int,
}
impl Default for kthread_work {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kthread_delayed_work {
    pub work: kthread_work,
    pub timer: timer_list,
}
impl Default for kthread_delayed_work {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn __kthread_init_worker(
        worker: *mut kthread_worker,
        name: *const ffi::c_char,
        key: *mut lock_class_key,
    );
}
extern "C" {
    pub fn kthread_worker_fn(worker_ptr: *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn kthread_create_worker_on_node(
        flags: ffi::c_uint,
        node: ffi::c_int,
        namefmt: *const ffi::c_char,
        ...
    ) -> *mut kthread_worker;
}
extern "C" {
    pub fn kthread_create_worker_on_cpu(
        cpu: ffi::c_int,
        flags: ffi::c_uint,
        namefmt: *const ffi::c_char,
    ) -> *mut kthread_worker;
}
extern "C" {
    pub fn kthread_queue_work(worker: *mut kthread_worker, work: *mut kthread_work) -> bool_;
}
extern "C" {
    pub fn kthread_queue_delayed_work(
        worker: *mut kthread_worker,
        dwork: *mut kthread_delayed_work,
        delay: ffi::c_ulong,
    ) -> bool_;
}
extern "C" {
    pub fn kthread_mod_delayed_work(
        worker: *mut kthread_worker,
        dwork: *mut kthread_delayed_work,
        delay: ffi::c_ulong,
    ) -> bool_;
}
extern "C" {
    pub fn kthread_flush_work(work: *mut kthread_work);
}
extern "C" {
    pub fn kthread_flush_worker(worker: *mut kthread_worker);
}
extern "C" {
    pub fn kthread_cancel_work_sync(work: *mut kthread_work) -> bool_;
}
extern "C" {
    pub fn kthread_cancel_delayed_work_sync(work: *mut kthread_delayed_work) -> bool_;
}
extern "C" {
    pub fn kthread_destroy_worker(worker: *mut kthread_worker);
}
extern "C" {
    pub fn kthread_use_mm(mm: *mut mm_struct);
}
extern "C" {
    pub fn kthread_unuse_mm(mm: *mut mm_struct);
}
extern "C" {
    pub fn kthread_associate_blkcg(css: *mut cgroup_subsys_state);
}
extern "C" {
    pub fn kthread_blkcg() -> *mut cgroup_subsys_state;
}
pub const psi_task_count_NR_IOWAIT: psi_task_count = 0;
pub const psi_task_count_NR_MEMSTALL: psi_task_count = 1;
pub const psi_task_count_NR_RUNNING: psi_task_count = 2;
pub const psi_task_count_NR_MEMSTALL_RUNNING: psi_task_count = 3;
pub const psi_task_count_NR_PSI_TASK_COUNTS: psi_task_count = 4;
pub type psi_task_count = ffi::c_uint;
pub const psi_res_PSI_IO: psi_res = 0;
pub const psi_res_PSI_MEM: psi_res = 1;
pub const psi_res_PSI_CPU: psi_res = 2;
pub const psi_res_PSI_IRQ: psi_res = 3;
pub const psi_res_NR_PSI_RESOURCES: psi_res = 4;
pub type psi_res = ffi::c_uint;
pub const psi_states_PSI_IO_SOME: psi_states = 0;
pub const psi_states_PSI_IO_FULL: psi_states = 1;
pub const psi_states_PSI_MEM_SOME: psi_states = 2;
pub const psi_states_PSI_MEM_FULL: psi_states = 3;
pub const psi_states_PSI_CPU_SOME: psi_states = 4;
pub const psi_states_PSI_CPU_FULL: psi_states = 5;
pub const psi_states_PSI_IRQ_FULL: psi_states = 6;
pub const psi_states_PSI_NONIDLE: psi_states = 7;
pub const psi_states_NR_PSI_STATES: psi_states = 8;
pub type psi_states = ffi::c_uint;
pub const psi_aggregators_PSI_AVGS: psi_aggregators = 0;
pub const psi_aggregators_PSI_POLL: psi_aggregators = 1;
pub const psi_aggregators_NR_PSI_AGGREGATORS: psi_aggregators = 2;
pub type psi_aggregators = ffi::c_uint;
#[repr(C)]
#[repr(align(64))]
#[derive(Copy, Clone)]
pub struct psi_group_cpu {
    pub seq: seqcount_t,
    pub tasks: [ffi::c_uint; 4usize],
    pub state_mask: u32_,
    pub times: [u32_; 8usize],
    pub state_start: u64_,
    pub times_prev: [[u32_; 8usize]; 2usize],
}
impl Default for psi_group_cpu {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct psi_window {
    pub size: u64_,
    pub start_time: u64_,
    pub start_value: u64_,
    pub prev_growth: u64_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct psi_trigger {
    pub state: psi_states,
    pub threshold: u64_,
    pub node: list_head,
    pub group: *mut psi_group,
    pub event_wait: wait_queue_head_t,
    pub of: *mut kernfs_open_file,
    pub event: ffi::c_int,
    pub win: psi_window,
    pub last_event_time: u64_,
    pub pending_event: bool_,
    pub aggregator: psi_aggregators,
}
impl Default for psi_trigger {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct psi_group {
    pub parent: *mut psi_group,
    pub enabled: bool_,
    pub avgs_lock: mutex,
    pub pcpu: *mut psi_group_cpu,
    pub avg_total: [u64_; 7usize],
    pub avg_last_update: u64_,
    pub avg_next_update: u64_,
    pub avgs_work: delayed_work,
    pub avg_triggers: list_head,
    pub avg_nr_triggers: [u32_; 7usize],
    pub total: [[u64_; 7usize]; 2usize],
    pub avg: [[ffi::c_ulong; 3usize]; 7usize],
    pub rtpoll_task: *mut task_struct,
    pub rtpoll_timer: timer_list,
    pub rtpoll_wait: wait_queue_head_t,
    pub rtpoll_wakeup: atomic_t,
    pub rtpoll_scheduled: atomic_t,
    pub rtpoll_trigger_lock: mutex,
    pub rtpoll_triggers: list_head,
    pub rtpoll_nr_triggers: [u32_; 7usize],
    pub rtpoll_states: u32_,
    pub rtpoll_min_period: u64_,
    pub rtpoll_total: [u64_; 7usize],
    pub rtpoll_next_update: u64_,
    pub rtpoll_until: u64_,
}
impl Default for psi_group {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct cgroup_taskset {
    _unused: [u8; 0],
}
pub const cgroup_subsys_id_cpuset_cgrp_id: cgroup_subsys_id = 0;
pub const cgroup_subsys_id_cpu_cgrp_id: cgroup_subsys_id = 1;
pub const cgroup_subsys_id_cpuacct_cgrp_id: cgroup_subsys_id = 2;
pub const cgroup_subsys_id_io_cgrp_id: cgroup_subsys_id = 3;
pub const cgroup_subsys_id_memory_cgrp_id: cgroup_subsys_id = 4;
pub const cgroup_subsys_id_devices_cgrp_id: cgroup_subsys_id = 5;
pub const cgroup_subsys_id_freezer_cgrp_id: cgroup_subsys_id = 6;
pub const cgroup_subsys_id_net_cls_cgrp_id: cgroup_subsys_id = 7;
pub const cgroup_subsys_id_perf_event_cgrp_id: cgroup_subsys_id = 8;
pub const cgroup_subsys_id_net_prio_cgrp_id: cgroup_subsys_id = 9;
pub const cgroup_subsys_id_pids_cgrp_id: cgroup_subsys_id = 10;
pub const cgroup_subsys_id_rdma_cgrp_id: cgroup_subsys_id = 11;
pub const cgroup_subsys_id_misc_cgrp_id: cgroup_subsys_id = 12;
pub const cgroup_subsys_id_dmem_cgrp_id: cgroup_subsys_id = 13;
pub const cgroup_subsys_id_CGROUP_SUBSYS_COUNT: cgroup_subsys_id = 14;
pub type cgroup_subsys_id = ffi::c_uint;
pub const CSS_NO_REF: _bindgen_ty_256 = 1;
pub const CSS_ONLINE: _bindgen_ty_256 = 2;
pub const CSS_RELEASED: _bindgen_ty_256 = 4;
pub const CSS_VISIBLE: _bindgen_ty_256 = 8;
pub const CSS_DYING: _bindgen_ty_256 = 16;
pub type _bindgen_ty_256 = ffi::c_uint;
pub const CGRP_NOTIFY_ON_RELEASE: _bindgen_ty_257 = 0;
pub const CGRP_CPUSET_CLONE_CHILDREN: _bindgen_ty_257 = 1;
pub const CGRP_FREEZE: _bindgen_ty_257 = 2;
pub const CGRP_FROZEN: _bindgen_ty_257 = 3;
pub type _bindgen_ty_257 = ffi::c_uint;
pub const CGRP_ROOT_NOPREFIX: _bindgen_ty_258 = 2;
pub const CGRP_ROOT_XATTR: _bindgen_ty_258 = 4;
pub const CGRP_ROOT_NS_DELEGATE: _bindgen_ty_258 = 8;
pub const CGRP_ROOT_FAVOR_DYNMODS: _bindgen_ty_258 = 16;
pub const CGRP_ROOT_CPUSET_V2_MODE: _bindgen_ty_258 = 65536;
pub const CGRP_ROOT_MEMORY_LOCAL_EVENTS: _bindgen_ty_258 = 131072;
pub const CGRP_ROOT_MEMORY_RECURSIVE_PROT: _bindgen_ty_258 = 262144;
pub const CGRP_ROOT_MEMORY_HUGETLB_ACCOUNTING: _bindgen_ty_258 = 524288;
pub const CGRP_ROOT_PIDS_LOCAL_EVENTS: _bindgen_ty_258 = 1048576;
pub type _bindgen_ty_258 = ffi::c_uint;
pub const CFTYPE_ONLY_ON_ROOT: _bindgen_ty_259 = 1;
pub const CFTYPE_NOT_ON_ROOT: _bindgen_ty_259 = 2;
pub const CFTYPE_NS_DELEGATABLE: _bindgen_ty_259 = 4;
pub const CFTYPE_NO_PREFIX: _bindgen_ty_259 = 8;
pub const CFTYPE_WORLD_WRITABLE: _bindgen_ty_259 = 16;
pub const CFTYPE_DEBUG: _bindgen_ty_259 = 32;
pub const __CFTYPE_ONLY_ON_DFL: _bindgen_ty_259 = 65536;
pub const __CFTYPE_NOT_ON_DFL: _bindgen_ty_259 = 131072;
pub const __CFTYPE_ADDED: _bindgen_ty_259 = 262144;
pub type _bindgen_ty_259 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct cgroup_file {
    pub kn: *mut kernfs_node,
    pub notified_at: ffi::c_ulong,
    pub notify_timer: timer_list,
}
impl Default for cgroup_file {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct cgroup_subsys_state {
    pub cgroup: *mut cgroup,
    pub ss: *mut cgroup_subsys,
    pub refcnt: percpu_ref,
    pub sibling: list_head,
    pub children: list_head,
    pub rstat_css_node: list_head,
    pub id: ffi::c_int,
    pub flags: ffi::c_uint,
    pub serial_nr: u64_,
    pub online_cnt: atomic_t,
    pub destroy_work: work_struct,
    pub destroy_rwork: rcu_work,
    pub parent: *mut cgroup_subsys_state,
    pub nr_descendants: ffi::c_int,
}
impl Default for cgroup_subsys_state {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct css_set {
    pub subsys: [*mut cgroup_subsys_state; 14usize],
    pub refcount: refcount_t,
    pub dom_cset: *mut css_set,
    pub dfl_cgrp: *mut cgroup,
    pub nr_tasks: ffi::c_int,
    pub tasks: list_head,
    pub mg_tasks: list_head,
    pub dying_tasks: list_head,
    pub task_iters: list_head,
    pub e_cset_node: [list_head; 14usize],
    pub threaded_csets: list_head,
    pub threaded_csets_node: list_head,
    pub hlist: hlist_node,
    pub cgrp_links: list_head,
    pub mg_src_preload_node: list_head,
    pub mg_dst_preload_node: list_head,
    pub mg_node: list_head,
    pub mg_src_cgrp: *mut cgroup,
    pub mg_dst_cgrp: *mut cgroup,
    pub mg_dst_cset: *mut css_set,
    pub dead: bool_,
    pub callback_head: callback_head,
}
impl Default for css_set {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct cgroup_base_stat {
    pub cputime: task_cputime,
    pub forceidle_sum: u64_,
    pub ntime: u64_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct cgroup_rstat_cpu {
    pub bsync: u64_stats_sync,
    pub bstat: cgroup_base_stat,
    pub last_bstat: cgroup_base_stat,
    pub subtree_bstat: cgroup_base_stat,
    pub last_subtree_bstat: cgroup_base_stat,
    pub updated_children: *mut cgroup,
    pub updated_next: *mut cgroup,
}
impl Default for cgroup_rstat_cpu {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct cgroup_freezer_state {
    pub freeze: bool_,
    pub e_freeze: bool_,
    pub nr_frozen_descendants: ffi::c_int,
    pub nr_frozen_tasks: ffi::c_int,
}
#[repr(C)]
#[repr(align(64))]
pub struct cgroup {
    pub self_: cgroup_subsys_state,
    pub flags: ffi::c_ulong,
    pub level: ffi::c_int,
    pub max_depth: ffi::c_int,
    pub nr_descendants: ffi::c_int,
    pub nr_dying_descendants: ffi::c_int,
    pub max_descendants: ffi::c_int,
    pub nr_populated_csets: ffi::c_int,
    pub nr_populated_domain_children: ffi::c_int,
    pub nr_populated_threaded_children: ffi::c_int,
    pub nr_threaded_children: ffi::c_int,
    pub kill_seq: ffi::c_uint,
    pub kn: *mut kernfs_node,
    pub procs_file: cgroup_file,
    pub events_file: cgroup_file,
    pub psi_files: [cgroup_file; 4usize],
    pub subtree_control: u16_,
    pub subtree_ss_mask: u16_,
    pub old_subtree_control: u16_,
    pub old_subtree_ss_mask: u16_,
    pub subsys: [*mut cgroup_subsys_state; 14usize],
    pub nr_dying_subsys: [ffi::c_int; 14usize],
    pub root: *mut cgroup_root,
    pub cset_links: list_head,
    pub e_csets: [list_head; 14usize],
    pub dom_cgrp: *mut cgroup,
    pub old_dom_cgrp: *mut cgroup,
    pub rstat_cpu: *mut cgroup_rstat_cpu,
    pub rstat_css_list: list_head,
    pub __bindgen_padding_0: [u64; 3usize],
    pub _pad_: cacheline_padding,
    pub rstat_flush_next: *mut cgroup,
    pub last_bstat: cgroup_base_stat,
    pub bstat: cgroup_base_stat,
    pub prev_cputime: prev_cputime,
    pub pidlists: list_head,
    pub pidlist_mutex: mutex,
    pub offline_waitq: wait_queue_head_t,
    pub release_agent_work: work_struct,
    pub psi: *mut psi_group,
    pub bpf: cgroup_bpf,
    pub freezer: cgroup_freezer_state,
    pub bpf_cgrp_storage: *mut bpf_local_storage,
    pub ancestors: __IncompleteArrayField<*mut cgroup>,
}
impl Default for cgroup {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[repr(align(64))]
pub struct cgroup_root {
    pub kf_root: *mut kernfs_root,
    pub subsys_mask: ffi::c_uint,
    pub hierarchy_id: ffi::c_int,
    pub root_list: list_head,
    pub rcu: callback_head,
    pub __bindgen_padding_0: [u64; 2usize],
    pub cgrp: cgroup,
    pub cgrp_ancestor_storage: *mut cgroup,
    pub nr_cgrps: atomic_t,
    pub flags: ffi::c_uint,
    pub release_agent_path: [ffi::c_char; 4096usize],
    pub name: [ffi::c_char; 64usize],
}
impl Default for cgroup_root {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct cftype {
    pub name: [ffi::c_char; 64usize],
    pub private: ffi::c_ulong,
    pub max_write_len: usize,
    pub flags: ffi::c_uint,
    pub file_offset: ffi::c_uint,
    pub ss: *mut cgroup_subsys,
    pub node: list_head,
    pub kf_ops: *mut kernfs_ops,
    pub open: ::core::option::Option<unsafe extern "C" fn(of: *mut kernfs_open_file) -> ffi::c_int>,
    pub release: ::core::option::Option<unsafe extern "C" fn(of: *mut kernfs_open_file)>,
    pub read_u64: ::core::option::Option<
        unsafe extern "C" fn(css: *mut cgroup_subsys_state, cft: *mut cftype) -> u64_,
    >,
    pub read_s64: ::core::option::Option<
        unsafe extern "C" fn(css: *mut cgroup_subsys_state, cft: *mut cftype) -> s64,
    >,
    pub seq_show: ::core::option::Option<
        unsafe extern "C" fn(sf: *mut seq_file, v: *mut ffi::c_void) -> ffi::c_int,
    >,
    pub seq_start: ::core::option::Option<
        unsafe extern "C" fn(sf: *mut seq_file, ppos: *mut loff_t) -> *mut ffi::c_void,
    >,
    pub seq_next: ::core::option::Option<
        unsafe extern "C" fn(
            sf: *mut seq_file,
            v: *mut ffi::c_void,
            ppos: *mut loff_t,
        ) -> *mut ffi::c_void,
    >,
    pub seq_stop:
        ::core::option::Option<unsafe extern "C" fn(sf: *mut seq_file, v: *mut ffi::c_void)>,
    pub write_u64: ::core::option::Option<
        unsafe extern "C" fn(
            css: *mut cgroup_subsys_state,
            cft: *mut cftype,
            val: u64_,
        ) -> ffi::c_int,
    >,
    pub write_s64: ::core::option::Option<
        unsafe extern "C" fn(
            css: *mut cgroup_subsys_state,
            cft: *mut cftype,
            val: s64,
        ) -> ffi::c_int,
    >,
    pub write: ::core::option::Option<
        unsafe extern "C" fn(
            of: *mut kernfs_open_file,
            buf: *mut ffi::c_char,
            nbytes: usize,
            off: loff_t,
        ) -> isize,
    >,
    pub poll: ::core::option::Option<
        unsafe extern "C" fn(of: *mut kernfs_open_file, pt: *mut poll_table_struct) -> __poll_t,
    >,
    pub lockdep_key: lock_class_key,
}
impl Default for cftype {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct cgroup_subsys {
    pub css_alloc: ::core::option::Option<
        unsafe extern "C" fn(parent_css: *mut cgroup_subsys_state) -> *mut cgroup_subsys_state,
    >,
    pub css_online:
        ::core::option::Option<unsafe extern "C" fn(css: *mut cgroup_subsys_state) -> ffi::c_int>,
    pub css_offline: ::core::option::Option<unsafe extern "C" fn(css: *mut cgroup_subsys_state)>,
    pub css_released: ::core::option::Option<unsafe extern "C" fn(css: *mut cgroup_subsys_state)>,
    pub css_free: ::core::option::Option<unsafe extern "C" fn(css: *mut cgroup_subsys_state)>,
    pub css_reset: ::core::option::Option<unsafe extern "C" fn(css: *mut cgroup_subsys_state)>,
    pub css_killed: ::core::option::Option<unsafe extern "C" fn(css: *mut cgroup_subsys_state)>,
    pub css_rstat_flush: ::core::option::Option<
        unsafe extern "C" fn(css: *mut cgroup_subsys_state, cpu: ffi::c_int),
    >,
    pub css_extra_stat_show: ::core::option::Option<
        unsafe extern "C" fn(seq: *mut seq_file, css: *mut cgroup_subsys_state) -> ffi::c_int,
    >,
    pub css_local_stat_show: ::core::option::Option<
        unsafe extern "C" fn(seq: *mut seq_file, css: *mut cgroup_subsys_state) -> ffi::c_int,
    >,
    pub can_attach:
        ::core::option::Option<unsafe extern "C" fn(tset: *mut cgroup_taskset) -> ffi::c_int>,
    pub cancel_attach: ::core::option::Option<unsafe extern "C" fn(tset: *mut cgroup_taskset)>,
    pub attach: ::core::option::Option<unsafe extern "C" fn(tset: *mut cgroup_taskset)>,
    pub post_attach: ::core::option::Option<unsafe extern "C" fn()>,
    pub can_fork: ::core::option::Option<
        unsafe extern "C" fn(task: *mut task_struct, cset: *mut css_set) -> ffi::c_int,
    >,
    pub cancel_fork:
        ::core::option::Option<unsafe extern "C" fn(task: *mut task_struct, cset: *mut css_set)>,
    pub fork: ::core::option::Option<unsafe extern "C" fn(task: *mut task_struct)>,
    pub exit: ::core::option::Option<unsafe extern "C" fn(task: *mut task_struct)>,
    pub release: ::core::option::Option<unsafe extern "C" fn(task: *mut task_struct)>,
    pub bind: ::core::option::Option<unsafe extern "C" fn(root_css: *mut cgroup_subsys_state)>,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub id: ffi::c_int,
    pub name: *const ffi::c_char,
    pub legacy_name: *const ffi::c_char,
    pub root: *mut cgroup_root,
    pub css_idr: idr,
    pub cfts: list_head,
    pub dfl_cftypes: *mut cftype,
    pub legacy_cftypes: *mut cftype,
    pub depends_on: ffi::c_uint,
}
impl Default for cgroup_subsys {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl cgroup_subsys {
    #[inline]
    pub fn early_init(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_early_init(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn early_init_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_early_init_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn implicit_on_dfl(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_implicit_on_dfl(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn implicit_on_dfl_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_implicit_on_dfl_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn threaded(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_threaded(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn threaded_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_threaded_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        early_init: bool_,
        implicit_on_dfl: bool_,
        threaded: bool_,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let early_init: u8 = unsafe { ::core::mem::transmute(early_init) };
            early_init as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let implicit_on_dfl: u8 = unsafe { ::core::mem::transmute(implicit_on_dfl) };
            implicit_on_dfl as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let threaded: u8 = unsafe { ::core::mem::transmute(threaded) };
            threaded as u64
        });
        __bindgen_bitfield_unit
    }
}
extern "C" {
    pub static mut cgroup_threadgroup_rwsem: percpu_rw_semaphore;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct cgroup_of_peak {
    pub value: ffi::c_ulong,
    pub list: list_head,
}
impl Default for cgroup_of_peak {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sock_cgroup_data {
    pub cgroup: *mut cgroup,
    pub classid: u32_,
    pub prioidx: u16_,
}
impl Default for sock_cgroup_data {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const CSS_TASK_ITER_PROCS: _bindgen_ty_260 = 1;
pub const CSS_TASK_ITER_THREADED: _bindgen_ty_260 = 2;
pub const CSS_TASK_ITER_SKIPPED: _bindgen_ty_260 = 65536;
pub type _bindgen_ty_260 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct css_task_iter {
    pub ss: *mut cgroup_subsys,
    pub flags: ffi::c_uint,
    pub cset_pos: *mut list_head,
    pub cset_head: *mut list_head,
    pub tcset_pos: *mut list_head,
    pub tcset_head: *mut list_head,
    pub task_pos: *mut list_head,
    pub cur_tasks_head: *mut list_head,
    pub cur_cset: *mut css_set,
    pub cur_dcset: *mut css_set,
    pub cur_task: *mut task_struct,
    pub iters_node: list_head,
}
impl Default for css_task_iter {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut cgroup_fs_type: file_system_type;
}
extern "C" {
    pub static mut cgrp_dfl_root: cgroup_root;
}
extern "C" {
    pub static mut init_css_set: css_set;
}
extern "C" {
    pub static mut css_set_lock: spinlock_t;
}
extern "C" {
    pub static mut cpuset_cgrp_subsys: cgroup_subsys;
}
extern "C" {
    pub static mut cpu_cgrp_subsys: cgroup_subsys;
}
extern "C" {
    pub static mut cpuacct_cgrp_subsys: cgroup_subsys;
}
extern "C" {
    pub static mut io_cgrp_subsys: cgroup_subsys;
}
extern "C" {
    pub static mut memory_cgrp_subsys: cgroup_subsys;
}
extern "C" {
    pub static mut devices_cgrp_subsys: cgroup_subsys;
}
extern "C" {
    pub static mut freezer_cgrp_subsys: cgroup_subsys;
}
extern "C" {
    pub static mut net_cls_cgrp_subsys: cgroup_subsys;
}
extern "C" {
    pub static mut perf_event_cgrp_subsys: cgroup_subsys;
}
extern "C" {
    pub static mut net_prio_cgrp_subsys: cgroup_subsys;
}
extern "C" {
    pub static mut pids_cgrp_subsys: cgroup_subsys;
}
extern "C" {
    pub static mut rdma_cgrp_subsys: cgroup_subsys;
}
extern "C" {
    pub static mut misc_cgrp_subsys: cgroup_subsys;
}
extern "C" {
    pub static mut dmem_cgrp_subsys: cgroup_subsys;
}
extern "C" {
    pub static mut cpuset_cgrp_subsys_enabled_key: static_key_true;
}
extern "C" {
    pub static mut cpuset_cgrp_subsys_on_dfl_key: static_key_true;
}
extern "C" {
    pub static mut cpu_cgrp_subsys_enabled_key: static_key_true;
}
extern "C" {
    pub static mut cpu_cgrp_subsys_on_dfl_key: static_key_true;
}
extern "C" {
    pub static mut cpuacct_cgrp_subsys_enabled_key: static_key_true;
}
extern "C" {
    pub static mut cpuacct_cgrp_subsys_on_dfl_key: static_key_true;
}
extern "C" {
    pub static mut io_cgrp_subsys_enabled_key: static_key_true;
}
extern "C" {
    pub static mut io_cgrp_subsys_on_dfl_key: static_key_true;
}
extern "C" {
    pub static mut memory_cgrp_subsys_enabled_key: static_key_true;
}
extern "C" {
    pub static mut memory_cgrp_subsys_on_dfl_key: static_key_true;
}
extern "C" {
    pub static mut devices_cgrp_subsys_enabled_key: static_key_true;
}
extern "C" {
    pub static mut devices_cgrp_subsys_on_dfl_key: static_key_true;
}
extern "C" {
    pub static mut freezer_cgrp_subsys_enabled_key: static_key_true;
}
extern "C" {
    pub static mut freezer_cgrp_subsys_on_dfl_key: static_key_true;
}
extern "C" {
    pub static mut net_cls_cgrp_subsys_enabled_key: static_key_true;
}
extern "C" {
    pub static mut net_cls_cgrp_subsys_on_dfl_key: static_key_true;
}
extern "C" {
    pub static mut perf_event_cgrp_subsys_enabled_key: static_key_true;
}
extern "C" {
    pub static mut perf_event_cgrp_subsys_on_dfl_key: static_key_true;
}
extern "C" {
    pub static mut net_prio_cgrp_subsys_enabled_key: static_key_true;
}
extern "C" {
    pub static mut net_prio_cgrp_subsys_on_dfl_key: static_key_true;
}
extern "C" {
    pub static mut pids_cgrp_subsys_enabled_key: static_key_true;
}
extern "C" {
    pub static mut pids_cgrp_subsys_on_dfl_key: static_key_true;
}
extern "C" {
    pub static mut rdma_cgrp_subsys_enabled_key: static_key_true;
}
extern "C" {
    pub static mut rdma_cgrp_subsys_on_dfl_key: static_key_true;
}
extern "C" {
    pub static mut misc_cgrp_subsys_enabled_key: static_key_true;
}
extern "C" {
    pub static mut misc_cgrp_subsys_on_dfl_key: static_key_true;
}
extern "C" {
    pub static mut dmem_cgrp_subsys_enabled_key: static_key_true;
}
extern "C" {
    pub static mut dmem_cgrp_subsys_on_dfl_key: static_key_true;
}
extern "C" {
    pub fn css_has_online_children(css: *mut cgroup_subsys_state) -> bool_;
}
extern "C" {
    pub fn css_from_id(id: ffi::c_int, ss: *mut cgroup_subsys) -> *mut cgroup_subsys_state;
}
extern "C" {
    pub fn cgroup_e_css(cgroup: *mut cgroup, ss: *mut cgroup_subsys) -> *mut cgroup_subsys_state;
}
extern "C" {
    pub fn cgroup_get_e_css(
        cgroup: *mut cgroup,
        ss: *mut cgroup_subsys,
    ) -> *mut cgroup_subsys_state;
}
extern "C" {
    pub fn css_tryget_online_from_dir(
        dentry: *mut dentry,
        ss: *mut cgroup_subsys,
    ) -> *mut cgroup_subsys_state;
}
extern "C" {
    pub fn cgroup_get_from_path(path: *const ffi::c_char) -> *mut cgroup;
}
extern "C" {
    pub fn cgroup_get_from_fd(fd: ffi::c_int) -> *mut cgroup;
}
extern "C" {
    pub fn cgroup_v1v2_get_from_fd(fd: ffi::c_int) -> *mut cgroup;
}
extern "C" {
    pub fn cgroup_attach_task_all(from: *mut task_struct, arg1: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn cgroup_transfer_tasks(to: *mut cgroup, from: *mut cgroup) -> ffi::c_int;
}
extern "C" {
    pub fn cgroup_add_dfl_cftypes(ss: *mut cgroup_subsys, cfts: *mut cftype) -> ffi::c_int;
}
extern "C" {
    pub fn cgroup_add_legacy_cftypes(ss: *mut cgroup_subsys, cfts: *mut cftype) -> ffi::c_int;
}
extern "C" {
    pub fn cgroup_add_cftypes(ss: *mut cgroup_subsys, cfts: *mut cftype) -> ffi::c_int;
}
extern "C" {
    pub fn cgroup_rm_cftypes(cfts: *mut cftype) -> ffi::c_int;
}
extern "C" {
    pub fn cgroup_file_notify(cfile: *mut cgroup_file);
}
extern "C" {
    pub fn cgroup_file_show(cfile: *mut cgroup_file, show: bool_);
}
extern "C" {
    pub fn cgroupstats_build(stats: *mut cgroupstats, dentry: *mut dentry) -> ffi::c_int;
}
extern "C" {
    pub fn proc_cgroup_show(
        m: *mut seq_file,
        ns: *mut pid_namespace,
        pid: *mut pid,
        tsk: *mut task_struct,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn cgroup_fork(p: *mut task_struct);
}
extern "C" {
    pub fn cgroup_can_fork(p: *mut task_struct, kargs: *mut kernel_clone_args) -> ffi::c_int;
}
extern "C" {
    pub fn cgroup_cancel_fork(p: *mut task_struct, kargs: *mut kernel_clone_args);
}
extern "C" {
    pub fn cgroup_post_fork(p: *mut task_struct, kargs: *mut kernel_clone_args);
}
extern "C" {
    pub fn cgroup_exit(p: *mut task_struct);
}
extern "C" {
    pub fn cgroup_release(p: *mut task_struct);
}
extern "C" {
    pub fn cgroup_free(p: *mut task_struct);
}
extern "C" {
    pub fn cgroup_init_early() -> ffi::c_int;
}
extern "C" {
    pub fn cgroup_init() -> ffi::c_int;
}
extern "C" {
    pub fn cgroup_parse_float(
        input: *const ffi::c_char,
        dec_shift: ffi::c_uint,
        v: *mut s64,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn css_next_child(
        pos: *mut cgroup_subsys_state,
        parent: *mut cgroup_subsys_state,
    ) -> *mut cgroup_subsys_state;
}
extern "C" {
    pub fn css_next_descendant_pre(
        pos: *mut cgroup_subsys_state,
        css: *mut cgroup_subsys_state,
    ) -> *mut cgroup_subsys_state;
}
extern "C" {
    pub fn css_rightmost_descendant(pos: *mut cgroup_subsys_state) -> *mut cgroup_subsys_state;
}
extern "C" {
    pub fn css_next_descendant_post(
        pos: *mut cgroup_subsys_state,
        css: *mut cgroup_subsys_state,
    ) -> *mut cgroup_subsys_state;
}
extern "C" {
    pub fn cgroup_taskset_first(
        tset: *mut cgroup_taskset,
        dst_cssp: *mut *mut cgroup_subsys_state,
    ) -> *mut task_struct;
}
extern "C" {
    pub fn cgroup_taskset_next(
        tset: *mut cgroup_taskset,
        dst_cssp: *mut *mut cgroup_subsys_state,
    ) -> *mut task_struct;
}
extern "C" {
    pub fn css_task_iter_start(
        css: *mut cgroup_subsys_state,
        flags: ffi::c_uint,
        it: *mut css_task_iter,
    );
}
extern "C" {
    pub fn css_task_iter_next(it: *mut css_task_iter) -> *mut task_struct;
}
extern "C" {
    pub fn css_task_iter_end(it: *mut css_task_iter);
}
extern "C" {
    pub static mut cgroup_mutex: mutex;
}
extern "C" {
    pub fn of_css(of: *mut kernfs_open_file) -> *mut cgroup_subsys_state;
}
extern "C" {
    pub fn cgroup_psi_enabled() -> bool_;
}
extern "C" {
    pub fn cgroup_path_from_kernfs_id(id: u64_, buf: *mut ffi::c_char, buflen: usize);
}
extern "C" {
    pub fn cgroup_get_from_id(id: u64_) -> *mut cgroup;
}
extern "C" {
    pub fn cgroup_rstat_updated(cgrp: *mut cgroup, cpu: ffi::c_int);
}
extern "C" {
    pub fn cgroup_rstat_flush(cgrp: *mut cgroup);
}
extern "C" {
    pub fn cpuacct_charge(tsk: *mut task_struct, cputime: u64_);
}
extern "C" {
    pub fn cpuacct_account_field(tsk: *mut task_struct, index: ffi::c_int, val: u64_);
}
extern "C" {
    pub fn __cgroup_account_cputime(cgrp: *mut cgroup, delta_exec: u64_);
}
extern "C" {
    pub fn __cgroup_account_cputime_field(
        cgrp: *mut cgroup,
        index: cpu_usage_stat,
        delta_exec: u64_,
    );
}
extern "C" {
    pub fn cgroup_sk_alloc(skcd: *mut sock_cgroup_data);
}
extern "C" {
    pub fn cgroup_sk_clone(skcd: *mut sock_cgroup_data);
}
extern "C" {
    pub fn cgroup_sk_free(skcd: *mut sock_cgroup_data);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct cgroup_namespace {
    pub ns: ns_common,
    pub user_ns: *mut user_namespace,
    pub ucounts: *mut ucounts,
    pub root_cset: *mut css_set,
}
impl Default for cgroup_namespace {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut init_cgroup_ns: cgroup_namespace;
}
extern "C" {
    pub fn free_cgroup_ns(ns: *mut cgroup_namespace);
}
extern "C" {
    pub fn copy_cgroup_ns(
        flags: ffi::c_ulong,
        user_ns: *mut user_namespace,
        old_ns: *mut cgroup_namespace,
    ) -> *mut cgroup_namespace;
}
extern "C" {
    pub fn cgroup_path_ns(
        cgrp: *mut cgroup,
        buf: *mut ffi::c_char,
        buflen: usize,
        ns: *mut cgroup_namespace,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn cgroup_enter_frozen();
}
extern "C" {
    pub fn cgroup_leave_frozen(always_leave: bool_);
}
extern "C" {
    pub fn cgroup_update_frozen(cgrp: *mut cgroup);
}
extern "C" {
    pub fn cgroup_freeze(cgrp: *mut cgroup, freeze: bool_);
}
extern "C" {
    pub fn cgroup_freezer_migrate_task(task: *mut task_struct, src: *mut cgroup, dst: *mut cgroup);
}
extern "C" {
    pub fn task_get_cgroup1(tsk: *mut task_struct, hierarchy_id: ffi::c_int) -> *mut cgroup;
}
extern "C" {
    pub fn of_peak(of: *mut kernfs_open_file) -> *mut cgroup_of_peak;
}
#[repr(C)]
#[repr(align(64))]
pub struct page_counter {
    pub usage: atomic_long_t,
    pub failcnt: ffi::c_ulong,
    pub __bindgen_padding_0: [u64; 6usize],
    pub _pad1_: cacheline_padding,
    pub emin: ffi::c_ulong,
    pub min_usage: atomic_long_t,
    pub children_min_usage: atomic_long_t,
    pub elow: ffi::c_ulong,
    pub low_usage: atomic_long_t,
    pub children_low_usage: atomic_long_t,
    pub watermark: ffi::c_ulong,
    pub local_watermark: ffi::c_ulong,
    pub _pad2_: cacheline_padding,
    pub protection_support: bool_,
    pub track_failcnt: bool_,
    pub min: ffi::c_ulong,
    pub low: ffi::c_ulong,
    pub high: ffi::c_ulong,
    pub max: ffi::c_ulong,
    pub parent: *mut page_counter,
}
impl Default for page_counter {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn page_counter_cancel(counter: *mut page_counter, nr_pages: ffi::c_ulong);
}
extern "C" {
    pub fn page_counter_charge(counter: *mut page_counter, nr_pages: ffi::c_ulong);
}
extern "C" {
    pub fn page_counter_try_charge(
        counter: *mut page_counter,
        nr_pages: ffi::c_ulong,
        fail: *mut *mut page_counter,
    ) -> bool_;
}
extern "C" {
    pub fn page_counter_uncharge(counter: *mut page_counter, nr_pages: ffi::c_ulong);
}
extern "C" {
    pub fn page_counter_set_min(counter: *mut page_counter, nr_pages: ffi::c_ulong);
}
extern "C" {
    pub fn page_counter_set_low(counter: *mut page_counter, nr_pages: ffi::c_ulong);
}
extern "C" {
    pub fn page_counter_set_max(counter: *mut page_counter, nr_pages: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn page_counter_memparse(
        buf: *const ffi::c_char,
        max: *const ffi::c_char,
        nr_pages: *mut ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn page_counter_calculate_protection(
        root: *mut page_counter,
        counter: *mut page_counter,
        recursive_protection: bool_,
    );
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct eventfd_ctx {
    _unused: [u8; 0],
}
extern "C" {
    pub fn eventfd_ctx_put(ctx: *mut eventfd_ctx);
}
extern "C" {
    pub fn eventfd_fget(fd: ffi::c_int) -> *mut file;
}
extern "C" {
    pub fn eventfd_ctx_fdget(fd: ffi::c_int) -> *mut eventfd_ctx;
}
extern "C" {
    pub fn eventfd_ctx_fileget(file: *mut file) -> *mut eventfd_ctx;
}
extern "C" {
    pub fn eventfd_signal_mask(ctx: *mut eventfd_ctx, mask: __poll_t);
}
extern "C" {
    pub fn eventfd_ctx_remove_wait_queue(
        ctx: *mut eventfd_ctx,
        wait: *mut wait_queue_entry_t,
        cnt: *mut __u64,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn eventfd_ctx_do_read(ctx: *mut eventfd_ctx, cnt: *mut __u64);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct vmpressure {
    pub scanned: ffi::c_ulong,
    pub reclaimed: ffi::c_ulong,
    pub tree_scanned: ffi::c_ulong,
    pub tree_reclaimed: ffi::c_ulong,
    pub sr_lock: spinlock_t,
    pub events: list_head,
    pub events_lock: mutex,
    pub work: work_struct,
}
impl Default for vmpressure {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn vmpressure(
        gfp: gfp_t,
        memcg: *mut mem_cgroup,
        tree: bool_,
        scanned: ffi::c_ulong,
        reclaimed: ffi::c_ulong,
    );
}
extern "C" {
    pub fn vmpressure_prio(gfp: gfp_t, memcg: *mut mem_cgroup, prio: ffi::c_int);
}
extern "C" {
    pub fn vmpressure_init(vmpr: *mut vmpressure);
}
extern "C" {
    pub fn vmpressure_cleanup(vmpr: *mut vmpressure);
}
extern "C" {
    pub fn memcg_to_vmpressure(memcg: *mut mem_cgroup) -> *mut vmpressure;
}
extern "C" {
    pub fn vmpressure_to_memcg(vmpr: *mut vmpressure) -> *mut mem_cgroup;
}
extern "C" {
    pub fn vmpressure_register_event(
        memcg: *mut mem_cgroup,
        eventfd: *mut eventfd_ctx,
        args: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn vmpressure_unregister_event(memcg: *mut mem_cgroup, eventfd: *mut eventfd_ctx);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fprop_global {
    pub events: percpu_counter,
    pub period: ffi::c_uint,
    pub sequence: seqcount_t,
}
impl Default for fprop_global {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn fprop_global_init(p: *mut fprop_global, gfp: gfp_t) -> ffi::c_int;
}
extern "C" {
    pub fn fprop_global_destroy(p: *mut fprop_global);
}
extern "C" {
    pub fn fprop_new_period(p: *mut fprop_global, periods: ffi::c_int) -> bool_;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fprop_local_percpu {
    pub events: percpu_counter,
    pub period: ffi::c_uint,
    pub lock: raw_spinlock_t,
}
impl Default for fprop_local_percpu {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn fprop_local_init_percpu(pl: *mut fprop_local_percpu, gfp: gfp_t) -> ffi::c_int;
}
extern "C" {
    pub fn fprop_local_destroy_percpu(pl: *mut fprop_local_percpu);
}
extern "C" {
    pub fn __fprop_add_percpu(p: *mut fprop_global, pl: *mut fprop_local_percpu, nr: ffi::c_long);
}
extern "C" {
    pub fn __fprop_add_percpu_max(
        p: *mut fprop_global,
        pl: *mut fprop_local_percpu,
        max_frac: ffi::c_int,
        nr: ffi::c_long,
    );
}
extern "C" {
    pub fn fprop_fraction_percpu(
        p: *mut fprop_global,
        pl: *mut fprop_local_percpu,
        numerator: *mut ffi::c_ulong,
        denominator: *mut ffi::c_ulong,
    );
}
pub const wb_state_WB_registered: wb_state = 0;
pub const wb_state_WB_writeback_running: wb_state = 1;
pub const wb_state_WB_has_dirty_io: wb_state = 2;
pub const wb_state_WB_start_all: wb_state = 3;
pub type wb_state = ffi::c_uint;
pub const wb_stat_item_WB_RECLAIMABLE: wb_stat_item = 0;
pub const wb_stat_item_WB_WRITEBACK: wb_stat_item = 1;
pub const wb_stat_item_WB_DIRTIED: wb_stat_item = 2;
pub const wb_stat_item_WB_WRITTEN: wb_stat_item = 3;
pub const wb_stat_item_NR_WB_STAT_ITEMS: wb_stat_item = 4;
pub type wb_stat_item = ffi::c_uint;
pub const wb_reason_WB_REASON_BACKGROUND: wb_reason = 0;
pub const wb_reason_WB_REASON_VMSCAN: wb_reason = 1;
pub const wb_reason_WB_REASON_SYNC: wb_reason = 2;
pub const wb_reason_WB_REASON_PERIODIC: wb_reason = 3;
pub const wb_reason_WB_REASON_LAPTOP_TIMER: wb_reason = 4;
pub const wb_reason_WB_REASON_FS_FREE_SPACE: wb_reason = 5;
pub const wb_reason_WB_REASON_FORKER_THREAD: wb_reason = 6;
pub const wb_reason_WB_REASON_FOREIGN_FLUSH: wb_reason = 7;
pub const wb_reason_WB_REASON_MAX: wb_reason = 8;
pub type wb_reason = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct wb_completion {
    pub cnt: atomic_t,
    pub waitq: *mut wait_queue_head_t,
}
impl Default for wb_completion {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bdi_writeback {
    pub bdi: *mut backing_dev_info,
    pub state: ffi::c_ulong,
    pub last_old_flush: ffi::c_ulong,
    pub b_dirty: list_head,
    pub b_io: list_head,
    pub b_more_io: list_head,
    pub b_dirty_time: list_head,
    pub list_lock: spinlock_t,
    pub writeback_inodes: atomic_t,
    pub stat: [percpu_counter; 4usize],
    pub bw_time_stamp: ffi::c_ulong,
    pub dirtied_stamp: ffi::c_ulong,
    pub written_stamp: ffi::c_ulong,
    pub write_bandwidth: ffi::c_ulong,
    pub avg_write_bandwidth: ffi::c_ulong,
    pub dirty_ratelimit: ffi::c_ulong,
    pub balanced_dirty_ratelimit: ffi::c_ulong,
    pub completions: fprop_local_percpu,
    pub dirty_exceeded: ffi::c_int,
    pub start_all_reason: wb_reason,
    pub work_lock: spinlock_t,
    pub work_list: list_head,
    pub dwork: delayed_work,
    pub bw_dwork: delayed_work,
    pub bdi_node: list_head,
    pub refcnt: percpu_ref,
    pub memcg_completions: fprop_local_percpu,
    pub memcg_css: *mut cgroup_subsys_state,
    pub blkcg_css: *mut cgroup_subsys_state,
    pub memcg_node: list_head,
    pub blkcg_node: list_head,
    pub b_attached: list_head,
    pub offline_node: list_head,
    pub __bindgen_anon_1: bdi_writeback__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bdi_writeback__bindgen_ty_1 {
    pub release_work: work_struct,
    pub rcu: callback_head,
}
impl Default for bdi_writeback__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bdi_writeback {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct backing_dev_info {
    pub id: u64_,
    pub rb_node: rb_node,
    pub bdi_list: list_head,
    pub ra_pages: ffi::c_ulong,
    pub io_pages: ffi::c_ulong,
    pub refcnt: kref,
    pub capabilities: ffi::c_uint,
    pub min_ratio: ffi::c_uint,
    pub max_ratio: ffi::c_uint,
    pub max_prop_frac: ffi::c_uint,
    pub tot_write_bandwidth: atomic_long_t,
    pub last_bdp_sleep: ffi::c_ulong,
    pub wb: bdi_writeback,
    pub wb_list: list_head,
    pub cgwb_tree: xarray,
    pub cgwb_release_mutex: mutex,
    pub wb_switch_rwsem: rw_semaphore,
    pub wb_waitq: wait_queue_head_t,
    pub dev: *mut device,
    pub dev_name: [ffi::c_char; 64usize],
    pub owner: *mut device,
    pub laptop_mode_wb_timer: timer_list,
    pub debug_dir: *mut dentry,
}
impl Default for backing_dev_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct wb_lock_cookie {
    pub locked: bool_,
    pub flags: ffi::c_ulong,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct folio_batch {
    pub nr: ffi::c_uchar,
    pub i: ffi::c_uchar,
    pub percpu_pvec_drained: bool_,
    pub folios: [*mut folio; 31usize],
}
impl Default for folio_batch {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn __folio_batch_release(pvec: *mut folio_batch);
}
extern "C" {
    pub fn folio_batch_remove_exceptionals(fbatch: *mut folio_batch);
}
extern "C" {
    pub static mut dirty_throttle_leaks: ffi::c_int;
}
pub const writeback_sync_modes_WB_SYNC_NONE: writeback_sync_modes = 0;
pub const writeback_sync_modes_WB_SYNC_ALL: writeback_sync_modes = 1;
pub type writeback_sync_modes = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct writeback_control {
    pub nr_to_write: ffi::c_long,
    pub pages_skipped: ffi::c_long,
    pub range_start: loff_t,
    pub range_end: loff_t,
    pub sync_mode: writeback_sync_modes,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub swap_plug: *mut *mut swap_iocb,
    pub list: *mut list_head,
    pub fbatch: folio_batch,
    pub index: ffi::c_ulong,
    pub saved_err: ffi::c_int,
    pub wb: *mut bdi_writeback,
    pub inode: *mut inode,
    pub wb_id: ffi::c_int,
    pub wb_lcand_id: ffi::c_int,
    pub wb_tcand_id: ffi::c_int,
    pub wb_bytes: usize,
    pub wb_lcand_bytes: usize,
    pub wb_tcand_bytes: usize,
}
impl Default for writeback_control {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl writeback_control {
    #[inline]
    pub fn for_kupdate(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_for_kupdate(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn for_kupdate_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_for_kupdate_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn for_background(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_for_background(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn for_background_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_for_background_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn tagged_writepages(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_tagged_writepages(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn tagged_writepages_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_tagged_writepages_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn for_reclaim(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_for_reclaim(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn for_reclaim_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_for_reclaim_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn range_cyclic(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_range_cyclic(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn range_cyclic_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_range_cyclic_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn for_sync(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_for_sync(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(5usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn for_sync_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_for_sync_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn unpinned_netfs_wb(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_unpinned_netfs_wb(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(6usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn unpinned_netfs_wb_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                6usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_unpinned_netfs_wb_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                6usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn no_cgroup_owner(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_no_cgroup_owner(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(7usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn no_cgroup_owner_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                7usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_no_cgroup_owner_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                7usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        for_kupdate: ffi::c_uint,
        for_background: ffi::c_uint,
        tagged_writepages: ffi::c_uint,
        for_reclaim: ffi::c_uint,
        range_cyclic: ffi::c_uint,
        for_sync: ffi::c_uint,
        unpinned_netfs_wb: ffi::c_uint,
        no_cgroup_owner: ffi::c_uint,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let for_kupdate: u32 = unsafe { ::core::mem::transmute(for_kupdate) };
            for_kupdate as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let for_background: u32 = unsafe { ::core::mem::transmute(for_background) };
            for_background as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let tagged_writepages: u32 = unsafe { ::core::mem::transmute(tagged_writepages) };
            tagged_writepages as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let for_reclaim: u32 = unsafe { ::core::mem::transmute(for_reclaim) };
            for_reclaim as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let range_cyclic: u32 = unsafe { ::core::mem::transmute(range_cyclic) };
            range_cyclic as u64
        });
        __bindgen_bitfield_unit.set(5usize, 1u8, {
            let for_sync: u32 = unsafe { ::core::mem::transmute(for_sync) };
            for_sync as u64
        });
        __bindgen_bitfield_unit.set(6usize, 1u8, {
            let unpinned_netfs_wb: u32 = unsafe { ::core::mem::transmute(unpinned_netfs_wb) };
            unpinned_netfs_wb as u64
        });
        __bindgen_bitfield_unit.set(7usize, 1u8, {
            let no_cgroup_owner: u32 = unsafe { ::core::mem::transmute(no_cgroup_owner) };
            no_cgroup_owner as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct wb_domain {
    pub lock: spinlock_t,
    pub completions: fprop_global,
    pub period_timer: timer_list,
    pub period_time: ffi::c_ulong,
    pub dirty_limit_tstamp: ffi::c_ulong,
    pub dirty_limit: ffi::c_ulong,
}
impl Default for wb_domain {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn writeback_inodes_sb(arg1: *mut super_block, reason: wb_reason);
}
extern "C" {
    pub fn writeback_inodes_sb_nr(arg1: *mut super_block, nr: ffi::c_ulong, reason: wb_reason);
}
extern "C" {
    pub fn try_to_writeback_inodes_sb(sb: *mut super_block, reason: wb_reason);
}
extern "C" {
    pub fn sync_inodes_sb(arg1: *mut super_block);
}
extern "C" {
    pub fn wakeup_flusher_threads(reason: wb_reason);
}
extern "C" {
    pub fn wakeup_flusher_threads_bdi(bdi: *mut backing_dev_info, reason: wb_reason);
}
extern "C" {
    pub fn inode_wait_for_writeback(inode: *mut inode);
}
extern "C" {
    pub fn inode_io_list_del(inode: *mut inode);
}
extern "C" {
    pub fn __inode_attach_wb(inode: *mut inode, folio: *mut folio);
}
extern "C" {
    pub fn wbc_detach_inode(wbc: *mut writeback_control);
}
extern "C" {
    pub fn wbc_account_cgroup_owner(wbc: *mut writeback_control, folio: *mut folio, bytes: usize);
}
extern "C" {
    pub fn cgroup_writeback_by_id(
        bdi_id: u64_,
        memcg_id: ffi::c_int,
        reason: wb_reason,
        done: *mut wb_completion,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn cgroup_writeback_umount(sb: *mut super_block);
}
extern "C" {
    pub fn cleanup_offline_cgwb(wb: *mut bdi_writeback) -> bool_;
}
extern "C" {
    pub fn wbc_attach_fdatawrite_inode(wbc: *mut writeback_control, inode: *mut inode);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct dirty_throttle_control {
    pub dom: *mut wb_domain,
    pub gdtc: *mut dirty_throttle_control,
    pub wb: *mut bdi_writeback,
    pub wb_completions: *mut fprop_local_percpu,
    pub avail: ffi::c_ulong,
    pub dirty: ffi::c_ulong,
    pub thresh: ffi::c_ulong,
    pub bg_thresh: ffi::c_ulong,
    pub limit: ffi::c_ulong,
    pub wb_dirty: ffi::c_ulong,
    pub wb_thresh: ffi::c_ulong,
    pub wb_bg_thresh: ffi::c_ulong,
    pub pos_ratio: ffi::c_ulong,
    pub freerun: bool_,
    pub dirty_exceeded: bool_,
}
impl Default for dirty_throttle_control {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn laptop_io_completion(info: *mut backing_dev_info);
}
extern "C" {
    pub fn laptop_sync_completion();
}
extern "C" {
    pub fn laptop_mode_timer_fn(t: *mut timer_list);
}
extern "C" {
    pub fn node_dirty_ok(pgdat: *mut pglist_data) -> bool_;
}
extern "C" {
    pub fn wb_domain_init(dom: *mut wb_domain, gfp: gfp_t) -> ffi::c_int;
}
extern "C" {
    pub fn wb_domain_exit(dom: *mut wb_domain);
}
extern "C" {
    pub static mut global_wb_domain: wb_domain;
}
extern "C" {
    pub static mut dirty_writeback_interval: ffi::c_uint;
}
extern "C" {
    pub static mut dirty_expire_interval: ffi::c_uint;
}
extern "C" {
    pub static mut laptop_mode: ffi::c_int;
}
extern "C" {
    pub fn global_dirty_limits(pbackground: *mut ffi::c_ulong, pdirty: *mut ffi::c_ulong);
}
extern "C" {
    pub fn wb_calc_thresh(wb: *mut bdi_writeback, thresh: ffi::c_ulong) -> ffi::c_ulong;
}
extern "C" {
    pub fn cgwb_calc_thresh(wb: *mut bdi_writeback) -> ffi::c_ulong;
}
extern "C" {
    pub fn wb_update_bandwidth(wb: *mut bdi_writeback);
}
extern "C" {
    pub fn balance_dirty_pages_ratelimited(mapping: *mut address_space);
}
extern "C" {
    pub fn balance_dirty_pages_ratelimited_flags(
        mapping: *mut address_space,
        flags: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn wb_over_bg_thresh(wb: *mut bdi_writeback) -> bool_;
}
extern "C" {
    pub fn writeback_iter(
        mapping: *mut address_space,
        wbc: *mut writeback_control,
        folio: *mut folio,
        error: *mut ffi::c_int,
    ) -> *mut folio;
}
pub type writepage_t = ::core::option::Option<
    unsafe extern "C" fn(
        folio: *mut folio,
        wbc: *mut writeback_control,
        data: *mut ffi::c_void,
    ) -> ffi::c_int,
>;
extern "C" {
    pub fn write_cache_pages(
        mapping: *mut address_space,
        wbc: *mut writeback_control,
        writepage: writepage_t,
        data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn do_writepages(mapping: *mut address_space, wbc: *mut writeback_control) -> ffi::c_int;
}
extern "C" {
    pub fn writeback_set_ratelimit();
}
extern "C" {
    pub fn tag_pages_for_writeback(
        mapping: *mut address_space,
        start: ffi::c_ulong,
        end: ffi::c_ulong,
    );
}
extern "C" {
    pub fn filemap_dirty_folio(mapping: *mut address_space, folio: *mut folio) -> bool_;
}
extern "C" {
    pub fn folio_redirty_for_writepage(arg1: *mut writeback_control, arg2: *mut folio) -> bool_;
}
extern "C" {
    pub fn redirty_page_for_writepage(arg1: *mut writeback_control, arg2: *mut page) -> bool_;
}
extern "C" {
    pub fn sb_mark_inode_writeback(inode: *mut inode);
}
extern "C" {
    pub fn sb_clear_inode_writeback(inode: *mut inode);
}
pub const memcg_stat_item_MEMCG_SWAP: memcg_stat_item = 50;
pub const memcg_stat_item_MEMCG_SOCK: memcg_stat_item = 51;
pub const memcg_stat_item_MEMCG_PERCPU_B: memcg_stat_item = 52;
pub const memcg_stat_item_MEMCG_VMALLOC: memcg_stat_item = 53;
pub const memcg_stat_item_MEMCG_KMEM: memcg_stat_item = 54;
pub const memcg_stat_item_MEMCG_ZSWAP_B: memcg_stat_item = 55;
pub const memcg_stat_item_MEMCG_ZSWAPPED: memcg_stat_item = 56;
pub const memcg_stat_item_MEMCG_NR_STAT: memcg_stat_item = 57;
pub type memcg_stat_item = ffi::c_uint;
pub const memcg_memory_event_MEMCG_LOW: memcg_memory_event = 0;
pub const memcg_memory_event_MEMCG_HIGH: memcg_memory_event = 1;
pub const memcg_memory_event_MEMCG_MAX: memcg_memory_event = 2;
pub const memcg_memory_event_MEMCG_OOM: memcg_memory_event = 3;
pub const memcg_memory_event_MEMCG_OOM_KILL: memcg_memory_event = 4;
pub const memcg_memory_event_MEMCG_OOM_GROUP_KILL: memcg_memory_event = 5;
pub const memcg_memory_event_MEMCG_SWAP_HIGH: memcg_memory_event = 6;
pub const memcg_memory_event_MEMCG_SWAP_MAX: memcg_memory_event = 7;
pub const memcg_memory_event_MEMCG_SWAP_FAIL: memcg_memory_event = 8;
pub const memcg_memory_event_MEMCG_NR_MEMORY_EVENTS: memcg_memory_event = 9;
pub type memcg_memory_event = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mem_cgroup_reclaim_cookie {
    pub pgdat: *mut pg_data_t,
    pub generation: ffi::c_int,
}
impl Default for mem_cgroup_reclaim_cookie {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct mem_cgroup_id {
    pub id: ffi::c_int,
    pub ref_: refcount_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct memcg_vmstats_percpu {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct memcg1_events_percpu {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct memcg_vmstats {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct lruvec_stats_percpu {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct lruvec_stats {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mem_cgroup_reclaim_iter {
    pub position: *mut mem_cgroup,
    pub generation: atomic_t,
}
impl Default for mem_cgroup_reclaim_iter {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[repr(align(64))]
pub struct mem_cgroup_per_node {
    pub memcg: *mut mem_cgroup,
    pub lruvec_stats_percpu: *mut lruvec_stats_percpu,
    pub lruvec_stats: *mut lruvec_stats,
    pub shrinker_info: *mut shrinker_info,
    pub tree_node: rb_node,
    pub usage_in_excess: ffi::c_ulong,
    pub on_tree: bool_,
    pub lruvec: lruvec,
    pub __bindgen_padding_0: u64,
    pub _pad2_: cacheline_padding,
    pub lru_zone_size: [[ffi::c_ulong; 5usize]; 5usize],
    pub iter: mem_cgroup_reclaim_iter,
}
impl Default for mem_cgroup_per_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mem_cgroup_threshold {
    pub eventfd: *mut eventfd_ctx,
    pub threshold: ffi::c_ulong,
}
impl Default for mem_cgroup_threshold {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct mem_cgroup_threshold_ary {
    pub current_threshold: ffi::c_int,
    pub size: ffi::c_uint,
    pub entries: __IncompleteArrayField<mem_cgroup_threshold>,
}
impl Default for mem_cgroup_threshold_ary {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mem_cgroup_thresholds {
    pub primary: *mut mem_cgroup_threshold_ary,
    pub spare: *mut mem_cgroup_threshold_ary,
}
impl Default for mem_cgroup_thresholds {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct memcg_cgwb_frn {
    pub bdi_id: u64_,
    pub memcg_id: ffi::c_int,
    pub at: u64_,
    pub done: wb_completion,
}
impl Default for memcg_cgwb_frn {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct obj_cgroup {
    pub refcnt: percpu_ref,
    pub memcg: *mut mem_cgroup,
    pub nr_charged_bytes: atomic_t,
    pub __bindgen_anon_1: obj_cgroup__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union obj_cgroup__bindgen_ty_1 {
    pub list: list_head,
    pub rcu: callback_head,
}
impl Default for obj_cgroup__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for obj_cgroup {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[repr(align(64))]
pub struct mem_cgroup {
    pub css: cgroup_subsys_state,
    pub id: mem_cgroup_id,
    pub __bindgen_padding_0: [u64; 5usize],
    pub memory: page_counter,
    pub __bindgen_anon_1: mem_cgroup__bindgen_ty_1,
    pub memory_peaks: list_head,
    pub swap_peaks: list_head,
    pub peaks_lock: spinlock_t,
    pub high_work: work_struct,
    pub zswap_max: ffi::c_ulong,
    pub zswap_writeback: bool_,
    pub vmpressure: vmpressure,
    pub oom_group: bool_,
    pub swappiness: ffi::c_int,
    pub events_file: cgroup_file,
    pub events_local_file: cgroup_file,
    pub swap_events_file: cgroup_file,
    pub vmstats: *mut memcg_vmstats,
    pub memory_events: [atomic_long_t; 9usize],
    pub memory_events_local: [atomic_long_t; 9usize],
    pub socket_pressure: ffi::c_ulong,
    pub kmemcg_id: ffi::c_int,
    pub objcg: *mut obj_cgroup,
    pub orig_objcg: *mut obj_cgroup,
    pub objcg_list: list_head,
    pub vmstats_percpu: *mut memcg_vmstats_percpu,
    pub cgwb_list: list_head,
    pub cgwb_domain: wb_domain,
    pub cgwb_frn: [memcg_cgwb_frn; 4usize],
    pub deferred_split_queue: deferred_split,
    pub mm_list: lru_gen_mm_list,
    pub __bindgen_padding_1: [u64; 2usize],
    pub kmem: page_counter,
    pub tcpmem: page_counter,
    pub events_percpu: *mut memcg1_events_percpu,
    pub soft_limit: ffi::c_ulong,
    pub oom_lock: bool_,
    pub under_oom: ffi::c_int,
    pub oom_kill_disable: ffi::c_int,
    pub thresholds_lock: mutex,
    pub thresholds: mem_cgroup_thresholds,
    pub memsw_thresholds: mem_cgroup_thresholds,
    pub oom_notify: list_head,
    pub tcpmem_active: bool_,
    pub tcpmem_pressure: ffi::c_int,
    pub event_list: list_head,
    pub event_list_lock: spinlock_t,
    pub nodeinfo: __IncompleteArrayField<*mut mem_cgroup_per_node>,
}
#[repr(C)]
#[repr(align(64))]
pub struct mem_cgroup__bindgen_ty_1 {
    pub swap: __BindgenUnionField<page_counter>,
    pub memsw: __BindgenUnionField<page_counter>,
    pub bindgen_union_field: [u8; 192usize],
}
impl Default for mem_cgroup__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for mem_cgroup {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut root_mem_cgroup: *mut mem_cgroup;
}
pub const page_memcg_data_flags_MEMCG_DATA_OBJEXTS: page_memcg_data_flags = 1;
pub const page_memcg_data_flags_MEMCG_DATA_KMEM: page_memcg_data_flags = 2;
pub const page_memcg_data_flags___NR_MEMCG_DATA_FLAGS: page_memcg_data_flags = 4;
pub type page_memcg_data_flags = ffi::c_uint;
pub const objext_flags_OBJEXTS_ALLOC_FAIL: objext_flags = 4;
pub const objext_flags___NR_OBJEXTS_FLAGS: objext_flags = 8;
pub type objext_flags = ffi::c_uint;
extern "C" {
    pub fn mem_cgroup_calculate_protection(root: *mut mem_cgroup, memcg: *mut mem_cgroup);
}
extern "C" {
    pub fn __mem_cgroup_charge(folio: *mut folio, mm: *mut mm_struct, gfp: gfp_t) -> ffi::c_int;
}
extern "C" {
    pub fn mem_cgroup_charge_hugetlb(folio: *mut folio, gfp: gfp_t) -> ffi::c_int;
}
extern "C" {
    pub fn mem_cgroup_swapin_charge_folio(
        folio: *mut folio,
        mm: *mut mm_struct,
        gfp: gfp_t,
        entry: swp_entry_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __mem_cgroup_uncharge(folio: *mut folio);
}
extern "C" {
    pub fn __mem_cgroup_uncharge_folios(folios: *mut folio_batch);
}
extern "C" {
    pub fn mem_cgroup_replace_folio(old: *mut folio, new: *mut folio);
}
extern "C" {
    pub fn mem_cgroup_migrate(old: *mut folio, new: *mut folio);
}
extern "C" {
    pub fn mem_cgroup_from_task(p: *mut task_struct) -> *mut mem_cgroup;
}
extern "C" {
    pub fn get_mem_cgroup_from_mm(mm: *mut mm_struct) -> *mut mem_cgroup;
}
extern "C" {
    pub fn get_mem_cgroup_from_current() -> *mut mem_cgroup;
}
extern "C" {
    pub fn get_mem_cgroup_from_folio(folio: *mut folio) -> *mut mem_cgroup;
}
extern "C" {
    pub fn folio_lruvec_lock(folio: *mut folio) -> *mut lruvec;
}
extern "C" {
    pub fn folio_lruvec_lock_irq(folio: *mut folio) -> *mut lruvec;
}
extern "C" {
    pub fn folio_lruvec_lock_irqsave(folio: *mut folio, flags: *mut ffi::c_ulong) -> *mut lruvec;
}
extern "C" {
    pub fn mem_cgroup_iter(
        arg1: *mut mem_cgroup,
        arg2: *mut mem_cgroup,
        arg3: *mut mem_cgroup_reclaim_cookie,
    ) -> *mut mem_cgroup;
}
extern "C" {
    pub fn mem_cgroup_iter_break(arg1: *mut mem_cgroup, arg2: *mut mem_cgroup);
}
extern "C" {
    pub fn mem_cgroup_scan_tasks(
        memcg: *mut mem_cgroup,
        arg1: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut task_struct, arg2: *mut ffi::c_void) -> ffi::c_int,
        >,
        arg: *mut ffi::c_void,
    );
}
extern "C" {
    pub fn mem_cgroup_from_id(id: ffi::c_ushort) -> *mut mem_cgroup;
}
extern "C" {
    pub fn mem_cgroup_css_from_folio(folio: *mut folio) -> *mut cgroup_subsys_state;
}
extern "C" {
    pub fn page_cgroup_ino(page: *mut page) -> ino_t;
}
extern "C" {
    pub fn mem_cgroup_update_lru_size(
        lruvec: *mut lruvec,
        lru: lru_list,
        zid: ffi::c_int,
        nr_pages: ffi::c_int,
    );
}
extern "C" {
    pub fn mem_cgroup_handle_over_high(gfp_mask: gfp_t);
}
extern "C" {
    pub fn mem_cgroup_get_max(memcg: *mut mem_cgroup) -> ffi::c_ulong;
}
extern "C" {
    pub fn mem_cgroup_size(memcg: *mut mem_cgroup) -> ffi::c_ulong;
}
extern "C" {
    pub fn mem_cgroup_print_oom_context(memcg: *mut mem_cgroup, p: *mut task_struct);
}
extern "C" {
    pub fn mem_cgroup_print_oom_meminfo(memcg: *mut mem_cgroup);
}
extern "C" {
    pub fn mem_cgroup_get_oom_group(
        victim: *mut task_struct,
        oom_domain: *mut mem_cgroup,
    ) -> *mut mem_cgroup;
}
extern "C" {
    pub fn mem_cgroup_print_oom_group(memcg: *mut mem_cgroup);
}
extern "C" {
    pub fn __mod_memcg_state(memcg: *mut mem_cgroup, idx: memcg_stat_item, val: ffi::c_int);
}
extern "C" {
    pub fn memcg_page_state(memcg: *mut mem_cgroup, idx: ffi::c_int) -> ffi::c_ulong;
}
extern "C" {
    pub fn lruvec_page_state(lruvec: *mut lruvec, idx: node_stat_item) -> ffi::c_ulong;
}
extern "C" {
    pub fn lruvec_page_state_local(lruvec: *mut lruvec, idx: node_stat_item) -> ffi::c_ulong;
}
extern "C" {
    pub fn mem_cgroup_flush_stats(memcg: *mut mem_cgroup);
}
extern "C" {
    pub fn mem_cgroup_flush_stats_ratelimited(memcg: *mut mem_cgroup);
}
extern "C" {
    pub fn __mod_lruvec_kmem_state(p: *mut ffi::c_void, idx: node_stat_item, val: ffi::c_int);
}
extern "C" {
    pub fn __count_memcg_events(memcg: *mut mem_cgroup, idx: vm_event_item, count: ffi::c_ulong);
}
extern "C" {
    pub fn split_page_memcg(first: *mut page, order: ffi::c_uint);
}
extern "C" {
    pub fn folio_split_memcg_refs(
        folio: *mut folio,
        old_order: ffi::c_uint,
        new_order: ffi::c_uint,
    );
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct slabobj_ext {
    pub objcg: *mut obj_cgroup,
}
impl Default for slabobj_ext {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn mem_cgroup_wb_domain(wb: *mut bdi_writeback) -> *mut wb_domain;
}
extern "C" {
    pub fn mem_cgroup_wb_stats(
        wb: *mut bdi_writeback,
        pfilepages: *mut ffi::c_ulong,
        pheadroom: *mut ffi::c_ulong,
        pdirty: *mut ffi::c_ulong,
        pwriteback: *mut ffi::c_ulong,
    );
}
extern "C" {
    pub fn mem_cgroup_track_foreign_dirty_slowpath(folio: *mut folio, wb: *mut bdi_writeback);
}
extern "C" {
    pub fn mem_cgroup_flush_foreign(wb: *mut bdi_writeback);
}
extern "C" {
    pub fn mem_cgroup_charge_skmem(
        memcg: *mut mem_cgroup,
        nr_pages: ffi::c_uint,
        gfp_mask: gfp_t,
    ) -> bool_;
}
extern "C" {
    pub fn mem_cgroup_uncharge_skmem(memcg: *mut mem_cgroup, nr_pages: ffi::c_uint);
}
extern "C" {
    pub static mut memcg_sockets_enabled_key: static_key_false;
}
extern "C" {
    pub fn mem_cgroup_sk_alloc(sk: *mut sock);
}
extern "C" {
    pub fn mem_cgroup_sk_free(sk: *mut sock);
}
extern "C" {
    pub fn alloc_shrinker_info(memcg: *mut mem_cgroup) -> ffi::c_int;
}
extern "C" {
    pub fn free_shrinker_info(memcg: *mut mem_cgroup);
}
extern "C" {
    pub fn set_shrinker_bit(memcg: *mut mem_cgroup, nid: ffi::c_int, shrinker_id: ffi::c_int);
}
extern "C" {
    pub fn reparent_shrinker_deferred(memcg: *mut mem_cgroup);
}
extern "C" {
    pub fn mem_cgroup_kmem_disabled() -> bool_;
}
extern "C" {
    pub fn __memcg_kmem_charge_page(page: *mut page, gfp: gfp_t, order: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn __memcg_kmem_uncharge_page(page: *mut page, order: ffi::c_int);
}
extern "C" {
    pub fn current_obj_cgroup() -> *mut obj_cgroup;
}
extern "C" {
    pub fn get_obj_cgroup_from_folio(folio: *mut folio) -> *mut obj_cgroup;
}
extern "C" {
    pub fn obj_cgroup_charge(objcg: *mut obj_cgroup, gfp: gfp_t, size: usize) -> ffi::c_int;
}
extern "C" {
    pub fn obj_cgroup_uncharge(objcg: *mut obj_cgroup, size: usize);
}
extern "C" {
    pub static mut memcg_bpf_enabled_key: static_key_false;
}
extern "C" {
    pub static mut memcg_kmem_online_key: static_key_false;
}
extern "C" {
    pub fn mem_cgroup_from_slab_obj(p: *mut ffi::c_void) -> *mut mem_cgroup;
}
extern "C" {
    pub fn obj_cgroup_may_zswap(objcg: *mut obj_cgroup) -> bool_;
}
extern "C" {
    pub fn obj_cgroup_charge_zswap(objcg: *mut obj_cgroup, size: usize);
}
extern "C" {
    pub fn obj_cgroup_uncharge_zswap(objcg: *mut obj_cgroup, size: usize);
}
extern "C" {
    pub fn mem_cgroup_zswap_writeback_enabled(memcg: *mut mem_cgroup) -> bool_;
}
extern "C" {
    pub fn memcg1_soft_limit_reclaim(
        pgdat: *mut pg_data_t,
        order: ffi::c_int,
        gfp_mask: gfp_t,
        total_scanned: *mut ffi::c_ulong,
    ) -> ffi::c_ulong;
}
extern "C" {
    pub fn mem_cgroup_oom_synchronize(wait: bool_) -> bool_;
}
extern "C" {
    pub fn memcg1_swapout(folio: *mut folio, entry: swp_entry_t);
}
extern "C" {
    pub fn memcg1_swapin(entry: swp_entry_t, nr_pages: ffi::c_uint);
}
extern "C" {
    pub static mut cfi_warn: bool_;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rqspinlock {
    pub __bindgen_anon_1: rqspinlock__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union rqspinlock__bindgen_ty_1 {
    pub val: atomic_t,
    pub locked: u32_,
}
impl Default for rqspinlock__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for rqspinlock {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_res_spin_lock {
    pub val: u32_,
}
pub type rqspinlock_t = qspinlock;
extern "C" {
    pub fn resilient_tas_spin_lock(lock: *mut rqspinlock_t) -> ffi::c_int;
}
extern "C" {
    pub fn resilient_queued_spin_lock_slowpath(lock: *mut rqspinlock_t, val: u32_) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rqspinlock_held {
    pub cnt: ffi::c_int,
    pub locks: [*mut ffi::c_void; 31usize],
}
impl Default for rqspinlock_held {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut rqspinlock_held_locks: rqspinlock_held;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_verifier_env {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_arena {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_local_storage_map {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_func_state {
    _unused: [u8; 0],
}
extern "C" {
    pub static mut btf_idr: idr;
}
extern "C" {
    pub static mut btf_idr_lock: spinlock_t;
}
extern "C" {
    pub static mut btf_kobj: *mut kobject;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_mem_alloc {
    _unused: [u8; 0],
}
extern "C" {
    pub static mut bpf_global_ma: bpf_mem_alloc;
}
extern "C" {
    pub static mut bpf_global_percpu_ma: bpf_mem_alloc;
}
extern "C" {
    pub static mut bpf_global_ma_set: bool_;
}
pub type bpf_callback_t = ::core::option::Option<
    unsafe extern "C" fn(arg1: u64_, arg2: u64_, arg3: u64_, arg4: u64_, arg5: u64_) -> u64_,
>;
pub type bpf_iter_init_seq_priv_t = ::core::option::Option<
    unsafe extern "C" fn(private_data: *mut ffi::c_void, aux: *mut bpf_iter_aux_info) -> ffi::c_int,
>;
pub type bpf_iter_fini_seq_priv_t =
    ::core::option::Option<unsafe extern "C" fn(private_data: *mut ffi::c_void)>;
pub type bpf_func_t = ::core::option::Option<
    unsafe extern "C" fn(arg1: *const ffi::c_void, arg2: *const bpf_insn) -> ffi::c_uint,
>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_iter_seq_info {
    pub seq_ops: *const seq_operations,
    pub init_seq_private: bpf_iter_init_seq_priv_t,
    pub fini_seq_private: bpf_iter_fini_seq_priv_t,
    pub seq_priv_size: u32_,
}
impl Default for bpf_iter_seq_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_map_ops {
    pub map_alloc_check:
        ::core::option::Option<unsafe extern "C" fn(attr: *mut bpf_attr) -> ffi::c_int>,
    pub map_alloc:
        ::core::option::Option<unsafe extern "C" fn(attr: *mut bpf_attr) -> *mut bpf_map>,
    pub map_release:
        ::core::option::Option<unsafe extern "C" fn(map: *mut bpf_map, map_file: *mut file)>,
    pub map_free: ::core::option::Option<unsafe extern "C" fn(map: *mut bpf_map)>,
    pub map_get_next_key: ::core::option::Option<
        unsafe extern "C" fn(
            map: *mut bpf_map,
            key: *mut ffi::c_void,
            next_key: *mut ffi::c_void,
        ) -> ffi::c_int,
    >,
    pub map_release_uref: ::core::option::Option<unsafe extern "C" fn(map: *mut bpf_map)>,
    pub map_lookup_elem_sys_only: ::core::option::Option<
        unsafe extern "C" fn(map: *mut bpf_map, key: *mut ffi::c_void) -> *mut ffi::c_void,
    >,
    pub map_lookup_batch: ::core::option::Option<
        unsafe extern "C" fn(
            map: *mut bpf_map,
            attr: *const bpf_attr,
            uattr: *mut bpf_attr,
        ) -> ffi::c_int,
    >,
    pub map_lookup_and_delete_elem: ::core::option::Option<
        unsafe extern "C" fn(
            map: *mut bpf_map,
            key: *mut ffi::c_void,
            value: *mut ffi::c_void,
            flags: u64_,
        ) -> ffi::c_int,
    >,
    pub map_lookup_and_delete_batch: ::core::option::Option<
        unsafe extern "C" fn(
            map: *mut bpf_map,
            attr: *const bpf_attr,
            uattr: *mut bpf_attr,
        ) -> ffi::c_int,
    >,
    pub map_update_batch: ::core::option::Option<
        unsafe extern "C" fn(
            map: *mut bpf_map,
            map_file: *mut file,
            attr: *const bpf_attr,
            uattr: *mut bpf_attr,
        ) -> ffi::c_int,
    >,
    pub map_delete_batch: ::core::option::Option<
        unsafe extern "C" fn(
            map: *mut bpf_map,
            attr: *const bpf_attr,
            uattr: *mut bpf_attr,
        ) -> ffi::c_int,
    >,
    pub map_lookup_elem: ::core::option::Option<
        unsafe extern "C" fn(map: *mut bpf_map, key: *mut ffi::c_void) -> *mut ffi::c_void,
    >,
    pub map_update_elem: ::core::option::Option<
        unsafe extern "C" fn(
            map: *mut bpf_map,
            key: *mut ffi::c_void,
            value: *mut ffi::c_void,
            flags: u64_,
        ) -> ffi::c_long,
    >,
    pub map_delete_elem: ::core::option::Option<
        unsafe extern "C" fn(map: *mut bpf_map, key: *mut ffi::c_void) -> ffi::c_long,
    >,
    pub map_push_elem: ::core::option::Option<
        unsafe extern "C" fn(
            map: *mut bpf_map,
            value: *mut ffi::c_void,
            flags: u64_,
        ) -> ffi::c_long,
    >,
    pub map_pop_elem: ::core::option::Option<
        unsafe extern "C" fn(map: *mut bpf_map, value: *mut ffi::c_void) -> ffi::c_long,
    >,
    pub map_peek_elem: ::core::option::Option<
        unsafe extern "C" fn(map: *mut bpf_map, value: *mut ffi::c_void) -> ffi::c_long,
    >,
    pub map_lookup_percpu_elem: ::core::option::Option<
        unsafe extern "C" fn(
            map: *mut bpf_map,
            key: *mut ffi::c_void,
            cpu: u32_,
        ) -> *mut ffi::c_void,
    >,
    pub map_fd_get_ptr: ::core::option::Option<
        unsafe extern "C" fn(
            map: *mut bpf_map,
            map_file: *mut file,
            fd: ffi::c_int,
        ) -> *mut ffi::c_void,
    >,
    pub map_fd_put_ptr: ::core::option::Option<
        unsafe extern "C" fn(map: *mut bpf_map, ptr: *mut ffi::c_void, need_defer: bool_),
    >,
    pub map_gen_lookup: ::core::option::Option<
        unsafe extern "C" fn(map: *mut bpf_map, insn_buf: *mut bpf_insn) -> ffi::c_int,
    >,
    pub map_fd_sys_lookup_elem:
        ::core::option::Option<unsafe extern "C" fn(ptr: *mut ffi::c_void) -> u32_>,
    pub map_seq_show_elem: ::core::option::Option<
        unsafe extern "C" fn(map: *mut bpf_map, key: *mut ffi::c_void, m: *mut seq_file),
    >,
    pub map_check_btf: ::core::option::Option<
        unsafe extern "C" fn(
            map: *const bpf_map,
            btf: *const btf,
            key_type: *const btf_type,
            value_type: *const btf_type,
        ) -> ffi::c_int,
    >,
    pub map_poke_track: ::core::option::Option<
        unsafe extern "C" fn(map: *mut bpf_map, aux: *mut bpf_prog_aux) -> ffi::c_int,
    >,
    pub map_poke_untrack:
        ::core::option::Option<unsafe extern "C" fn(map: *mut bpf_map, aux: *mut bpf_prog_aux)>,
    pub map_poke_run: ::core::option::Option<
        unsafe extern "C" fn(map: *mut bpf_map, key: u32_, old: *mut bpf_prog, new: *mut bpf_prog),
    >,
    pub map_direct_value_addr: ::core::option::Option<
        unsafe extern "C" fn(map: *const bpf_map, imm: *mut u64_, off: u32_) -> ffi::c_int,
    >,
    pub map_direct_value_meta: ::core::option::Option<
        unsafe extern "C" fn(map: *const bpf_map, imm: u64_, off: *mut u32_) -> ffi::c_int,
    >,
    pub map_mmap: ::core::option::Option<
        unsafe extern "C" fn(map: *mut bpf_map, vma: *mut vm_area_struct) -> ffi::c_int,
    >,
    pub map_poll: ::core::option::Option<
        unsafe extern "C" fn(
            map: *mut bpf_map,
            filp: *mut file,
            pts: *mut poll_table_struct,
        ) -> __poll_t,
    >,
    pub map_get_unmapped_area: ::core::option::Option<
        unsafe extern "C" fn(
            filep: *mut file,
            addr: ffi::c_ulong,
            len: ffi::c_ulong,
            pgoff: ffi::c_ulong,
            flags: ffi::c_ulong,
        ) -> ffi::c_ulong,
    >,
    pub map_local_storage_charge: ::core::option::Option<
        unsafe extern "C" fn(
            smap: *mut bpf_local_storage_map,
            owner: *mut ffi::c_void,
            size: u32_,
        ) -> ffi::c_int,
    >,
    pub map_local_storage_uncharge: ::core::option::Option<
        unsafe extern "C" fn(smap: *mut bpf_local_storage_map, owner: *mut ffi::c_void, size: u32_),
    >,
    pub map_owner_storage_ptr: ::core::option::Option<
        unsafe extern "C" fn(owner: *mut ffi::c_void) -> *mut *mut bpf_local_storage,
    >,
    pub map_redirect: ::core::option::Option<
        unsafe extern "C" fn(map: *mut bpf_map, key: u64_, flags: u64_) -> ffi::c_long,
    >,
    pub map_meta_equal: ::core::option::Option<
        unsafe extern "C" fn(meta0: *const bpf_map, meta1: *const bpf_map) -> bool_,
    >,
    pub map_set_for_each_callback_args: ::core::option::Option<
        unsafe extern "C" fn(
            env: *mut bpf_verifier_env,
            caller: *mut bpf_func_state,
            callee: *mut bpf_func_state,
        ) -> ffi::c_int,
    >,
    pub map_for_each_callback: ::core::option::Option<
        unsafe extern "C" fn(
            map: *mut bpf_map,
            callback_fn: bpf_callback_t,
            callback_ctx: *mut ffi::c_void,
            flags: u64_,
        ) -> ffi::c_long,
    >,
    pub map_mem_usage: ::core::option::Option<unsafe extern "C" fn(map: *const bpf_map) -> u64_>,
    pub map_btf_id: *mut ffi::c_int,
    pub iter_seq_info: *const bpf_iter_seq_info,
}
impl Default for bpf_map_ops {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const BTF_FIELDS_MAX: _bindgen_ty_261 = 11;
pub type _bindgen_ty_261 = ffi::c_uint;
pub const btf_field_type_BPF_SPIN_LOCK: btf_field_type = 1;
pub const btf_field_type_BPF_TIMER: btf_field_type = 2;
pub const btf_field_type_BPF_KPTR_UNREF: btf_field_type = 4;
pub const btf_field_type_BPF_KPTR_REF: btf_field_type = 8;
pub const btf_field_type_BPF_KPTR_PERCPU: btf_field_type = 16;
pub const btf_field_type_BPF_KPTR: btf_field_type = 28;
pub const btf_field_type_BPF_LIST_HEAD: btf_field_type = 32;
pub const btf_field_type_BPF_LIST_NODE: btf_field_type = 64;
pub const btf_field_type_BPF_RB_ROOT: btf_field_type = 128;
pub const btf_field_type_BPF_RB_NODE: btf_field_type = 256;
pub const btf_field_type_BPF_GRAPH_NODE: btf_field_type = 320;
pub const btf_field_type_BPF_GRAPH_ROOT: btf_field_type = 160;
pub const btf_field_type_BPF_REFCOUNT: btf_field_type = 512;
pub const btf_field_type_BPF_WORKQUEUE: btf_field_type = 1024;
pub const btf_field_type_BPF_UPTR: btf_field_type = 2048;
pub const btf_field_type_BPF_RES_SPIN_LOCK: btf_field_type = 4096;
pub type btf_field_type = ffi::c_uint;
pub type btf_dtor_kfunc_t = ::core::option::Option<unsafe extern "C" fn(arg1: *mut ffi::c_void)>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct btf_field_kptr {
    pub btf: *mut btf,
    pub module: *mut module,
    pub dtor: btf_dtor_kfunc_t,
    pub btf_id: u32_,
}
impl Default for btf_field_kptr {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct btf_field_graph_root {
    pub btf: *mut btf,
    pub value_btf_id: u32_,
    pub node_offset: u32_,
    pub value_rec: *mut btf_record,
}
impl Default for btf_field_graph_root {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct btf_field {
    pub offset: u32_,
    pub size: u32_,
    pub type_: btf_field_type,
    pub __bindgen_anon_1: btf_field__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union btf_field__bindgen_ty_1 {
    pub kptr: btf_field_kptr,
    pub graph_root: btf_field_graph_root,
}
impl Default for btf_field__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for btf_field {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct btf_record {
    pub cnt: u32_,
    pub field_mask: u32_,
    pub spin_lock_off: ffi::c_int,
    pub res_spin_lock_off: ffi::c_int,
    pub timer_off: ffi::c_int,
    pub wq_off: ffi::c_int,
    pub refcount_off: ffi::c_int,
    pub fields: __IncompleteArrayField<btf_field>,
}
impl Default for btf_record {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_rb_node_kern {
    pub rb_node: rb_node,
    pub owner: *mut ffi::c_void,
}
impl Default for bpf_rb_node_kern {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_list_node_kern {
    pub list_head: list_head,
    pub owner: *mut ffi::c_void,
}
impl Default for bpf_list_node_kern {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_map {
    pub ops: *const bpf_map_ops,
    pub inner_map_meta: *mut bpf_map,
    pub security: *mut ffi::c_void,
    pub map_type: bpf_map_type,
    pub key_size: u32_,
    pub value_size: u32_,
    pub max_entries: u32_,
    pub map_extra: u64_,
    pub map_flags: u32_,
    pub id: u32_,
    pub record: *mut btf_record,
    pub numa_node: ffi::c_int,
    pub btf_key_type_id: u32_,
    pub btf_value_type_id: u32_,
    pub btf_vmlinux_value_type_id: u32_,
    pub btf: *mut btf,
    pub objcg: *mut obj_cgroup,
    pub name: [ffi::c_char; 16usize],
    pub freeze_mutex: mutex,
    pub refcnt: atomic64_t,
    pub usercnt: atomic64_t,
    pub __bindgen_anon_1: bpf_map__bindgen_ty_1,
    pub writecnt: atomic64_t,
    pub owner: bpf_map__bindgen_ty_2,
    pub bypass_spec_v1: bool_,
    pub frozen: bool_,
    pub free_after_mult_rcu_gp: bool_,
    pub free_after_rcu_gp: bool_,
    pub sleepable_refcnt: atomic64_t,
    pub elem_count: *mut s64,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_map__bindgen_ty_1 {
    pub work: work_struct,
    pub rcu: callback_head,
}
impl Default for bpf_map__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_map__bindgen_ty_2 {
    pub attach_func_proto: *const btf_type,
    pub lock: spinlock_t,
    pub type_: bpf_prog_type,
    pub jited: bool_,
    pub xdp_has_frags: bool_,
}
impl Default for bpf_map__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_map {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn copy_map_value_locked(
        map: *mut bpf_map,
        dst: *mut ffi::c_void,
        src: *mut ffi::c_void,
        lock_src: bool_,
    );
}
extern "C" {
    pub fn bpf_timer_cancel_and_free(timer: *mut ffi::c_void);
}
extern "C" {
    pub fn bpf_wq_cancel_and_free(timer: *mut ffi::c_void);
}
extern "C" {
    pub fn bpf_list_head_free(
        field: *const btf_field,
        list_head: *mut ffi::c_void,
        spin_lock: *mut bpf_spin_lock,
    );
}
extern "C" {
    pub fn bpf_rb_root_free(
        field: *const btf_field,
        rb_root: *mut ffi::c_void,
        spin_lock: *mut bpf_spin_lock,
    );
}
extern "C" {
    pub fn bpf_arena_get_kern_vm_start(arena: *mut bpf_arena) -> u64_;
}
extern "C" {
    pub fn bpf_arena_get_user_vm_start(arena: *mut bpf_arena) -> u64_;
}
extern "C" {
    pub fn bpf_obj_name_cpy(
        dst: *mut ffi::c_char,
        src: *const ffi::c_char,
        size: ffi::c_uint,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_offload_dev {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_map_dev_ops {
    pub map_get_next_key: ::core::option::Option<
        unsafe extern "C" fn(
            map: *mut bpf_offloaded_map,
            key: *mut ffi::c_void,
            next_key: *mut ffi::c_void,
        ) -> ffi::c_int,
    >,
    pub map_lookup_elem: ::core::option::Option<
        unsafe extern "C" fn(
            map: *mut bpf_offloaded_map,
            key: *mut ffi::c_void,
            value: *mut ffi::c_void,
        ) -> ffi::c_int,
    >,
    pub map_update_elem: ::core::option::Option<
        unsafe extern "C" fn(
            map: *mut bpf_offloaded_map,
            key: *mut ffi::c_void,
            value: *mut ffi::c_void,
            flags: u64_,
        ) -> ffi::c_int,
    >,
    pub map_delete_elem: ::core::option::Option<
        unsafe extern "C" fn(map: *mut bpf_offloaded_map, key: *mut ffi::c_void) -> ffi::c_int,
    >,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_offloaded_map {
    pub map: bpf_map,
    pub netdev: *mut net_device,
    pub dev_ops: *const bpf_map_dev_ops,
    pub dev_priv: *mut ffi::c_void,
    pub offloads: list_head,
}
impl Default for bpf_offloaded_map {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn map_check_no_btf(
        map: *const bpf_map,
        btf: *const btf,
        key_type: *const btf_type,
        value_type: *const btf_type,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_map_meta_equal(meta0: *const bpf_map, meta1: *const bpf_map) -> bool_;
}
extern "C" {
    pub static bpf_map_offload_ops: bpf_map_ops;
}
pub const bpf_type_flag_PTR_MAYBE_NULL: bpf_type_flag = 256;
pub const bpf_type_flag_MEM_RDONLY: bpf_type_flag = 512;
pub const bpf_type_flag_MEM_RINGBUF: bpf_type_flag = 1024;
pub const bpf_type_flag_MEM_USER: bpf_type_flag = 2048;
pub const bpf_type_flag_MEM_PERCPU: bpf_type_flag = 4096;
pub const bpf_type_flag_OBJ_RELEASE: bpf_type_flag = 8192;
pub const bpf_type_flag_PTR_UNTRUSTED: bpf_type_flag = 16384;
pub const bpf_type_flag_MEM_UNINIT: bpf_type_flag = 32768;
pub const bpf_type_flag_DYNPTR_TYPE_LOCAL: bpf_type_flag = 65536;
pub const bpf_type_flag_DYNPTR_TYPE_RINGBUF: bpf_type_flag = 131072;
pub const bpf_type_flag_MEM_FIXED_SIZE: bpf_type_flag = 262144;
pub const bpf_type_flag_MEM_ALLOC: bpf_type_flag = 524288;
pub const bpf_type_flag_PTR_TRUSTED: bpf_type_flag = 1048576;
pub const bpf_type_flag_MEM_RCU: bpf_type_flag = 2097152;
pub const bpf_type_flag_NON_OWN_REF: bpf_type_flag = 4194304;
pub const bpf_type_flag_DYNPTR_TYPE_SKB: bpf_type_flag = 8388608;
pub const bpf_type_flag_DYNPTR_TYPE_XDP: bpf_type_flag = 16777216;
pub const bpf_type_flag_MEM_ALIGNED: bpf_type_flag = 33554432;
pub const bpf_type_flag_MEM_WRITE: bpf_type_flag = 67108864;
pub const bpf_type_flag___BPF_TYPE_FLAG_MAX: bpf_type_flag = 67108865;
pub const bpf_type_flag___BPF_TYPE_LAST_FLAG: bpf_type_flag = 67108864;
pub type bpf_type_flag = ffi::c_uint;
pub const bpf_arg_type_ARG_DONTCARE: bpf_arg_type = 0;
pub const bpf_arg_type_ARG_CONST_MAP_PTR: bpf_arg_type = 1;
pub const bpf_arg_type_ARG_PTR_TO_MAP_KEY: bpf_arg_type = 2;
pub const bpf_arg_type_ARG_PTR_TO_MAP_VALUE: bpf_arg_type = 3;
pub const bpf_arg_type_ARG_PTR_TO_MEM: bpf_arg_type = 4;
pub const bpf_arg_type_ARG_PTR_TO_ARENA: bpf_arg_type = 5;
pub const bpf_arg_type_ARG_CONST_SIZE: bpf_arg_type = 6;
pub const bpf_arg_type_ARG_CONST_SIZE_OR_ZERO: bpf_arg_type = 7;
pub const bpf_arg_type_ARG_PTR_TO_CTX: bpf_arg_type = 8;
pub const bpf_arg_type_ARG_ANYTHING: bpf_arg_type = 9;
pub const bpf_arg_type_ARG_PTR_TO_SPIN_LOCK: bpf_arg_type = 10;
pub const bpf_arg_type_ARG_PTR_TO_SOCK_COMMON: bpf_arg_type = 11;
pub const bpf_arg_type_ARG_PTR_TO_SOCKET: bpf_arg_type = 12;
pub const bpf_arg_type_ARG_PTR_TO_BTF_ID: bpf_arg_type = 13;
pub const bpf_arg_type_ARG_PTR_TO_RINGBUF_MEM: bpf_arg_type = 14;
pub const bpf_arg_type_ARG_CONST_ALLOC_SIZE_OR_ZERO: bpf_arg_type = 15;
pub const bpf_arg_type_ARG_PTR_TO_BTF_ID_SOCK_COMMON: bpf_arg_type = 16;
pub const bpf_arg_type_ARG_PTR_TO_PERCPU_BTF_ID: bpf_arg_type = 17;
pub const bpf_arg_type_ARG_PTR_TO_FUNC: bpf_arg_type = 18;
pub const bpf_arg_type_ARG_PTR_TO_STACK: bpf_arg_type = 19;
pub const bpf_arg_type_ARG_PTR_TO_CONST_STR: bpf_arg_type = 20;
pub const bpf_arg_type_ARG_PTR_TO_TIMER: bpf_arg_type = 21;
pub const bpf_arg_type_ARG_KPTR_XCHG_DEST: bpf_arg_type = 22;
pub const bpf_arg_type_ARG_PTR_TO_DYNPTR: bpf_arg_type = 23;
pub const bpf_arg_type___BPF_ARG_TYPE_MAX: bpf_arg_type = 24;
pub const bpf_arg_type_ARG_PTR_TO_MAP_VALUE_OR_NULL: bpf_arg_type = 259;
pub const bpf_arg_type_ARG_PTR_TO_MEM_OR_NULL: bpf_arg_type = 260;
pub const bpf_arg_type_ARG_PTR_TO_CTX_OR_NULL: bpf_arg_type = 264;
pub const bpf_arg_type_ARG_PTR_TO_SOCKET_OR_NULL: bpf_arg_type = 268;
pub const bpf_arg_type_ARG_PTR_TO_STACK_OR_NULL: bpf_arg_type = 275;
pub const bpf_arg_type_ARG_PTR_TO_BTF_ID_OR_NULL: bpf_arg_type = 269;
pub const bpf_arg_type_ARG_PTR_TO_UNINIT_MEM: bpf_arg_type = 67141636;
pub const bpf_arg_type_ARG_PTR_TO_FIXED_SIZE_MEM: bpf_arg_type = 262148;
pub const bpf_arg_type___BPF_ARG_TYPE_LIMIT: bpf_arg_type = 134217727;
pub type bpf_arg_type = ffi::c_uint;
pub const bpf_return_type_RET_INTEGER: bpf_return_type = 0;
pub const bpf_return_type_RET_VOID: bpf_return_type = 1;
pub const bpf_return_type_RET_PTR_TO_MAP_VALUE: bpf_return_type = 2;
pub const bpf_return_type_RET_PTR_TO_SOCKET: bpf_return_type = 3;
pub const bpf_return_type_RET_PTR_TO_TCP_SOCK: bpf_return_type = 4;
pub const bpf_return_type_RET_PTR_TO_SOCK_COMMON: bpf_return_type = 5;
pub const bpf_return_type_RET_PTR_TO_MEM: bpf_return_type = 6;
pub const bpf_return_type_RET_PTR_TO_MEM_OR_BTF_ID: bpf_return_type = 7;
pub const bpf_return_type_RET_PTR_TO_BTF_ID: bpf_return_type = 8;
pub const bpf_return_type___BPF_RET_TYPE_MAX: bpf_return_type = 9;
pub const bpf_return_type_RET_PTR_TO_MAP_VALUE_OR_NULL: bpf_return_type = 258;
pub const bpf_return_type_RET_PTR_TO_SOCKET_OR_NULL: bpf_return_type = 259;
pub const bpf_return_type_RET_PTR_TO_TCP_SOCK_OR_NULL: bpf_return_type = 260;
pub const bpf_return_type_RET_PTR_TO_SOCK_COMMON_OR_NULL: bpf_return_type = 261;
pub const bpf_return_type_RET_PTR_TO_RINGBUF_MEM_OR_NULL: bpf_return_type = 1286;
pub const bpf_return_type_RET_PTR_TO_DYNPTR_MEM_OR_NULL: bpf_return_type = 262;
pub const bpf_return_type_RET_PTR_TO_BTF_ID_OR_NULL: bpf_return_type = 264;
pub const bpf_return_type_RET_PTR_TO_BTF_ID_TRUSTED: bpf_return_type = 1048584;
pub const bpf_return_type___BPF_RET_TYPE_LIMIT: bpf_return_type = 134217727;
pub type bpf_return_type = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_func_proto {
    pub func: ::core::option::Option<
        unsafe extern "C" fn(r1: u64_, r2: u64_, r3: u64_, r4: u64_, r5: u64_) -> u64_,
    >,
    pub gpl_only: bool_,
    pub pkt_access: bool_,
    pub might_sleep: bool_,
    pub allow_fastcall: bool_,
    pub ret_type: bpf_return_type,
    pub __bindgen_anon_1: bpf_func_proto__bindgen_ty_1,
    pub __bindgen_anon_2: bpf_func_proto__bindgen_ty_2,
    pub ret_btf_id: *mut ffi::c_int,
    pub allowed: ::core::option::Option<unsafe extern "C" fn(prog: *const bpf_prog) -> bool_>,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_func_proto__bindgen_ty_1 {
    pub __bindgen_anon_1: bpf_func_proto__bindgen_ty_1__bindgen_ty_1,
    pub arg_type: [bpf_arg_type; 5usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_func_proto__bindgen_ty_1__bindgen_ty_1 {
    pub arg1_type: bpf_arg_type,
    pub arg2_type: bpf_arg_type,
    pub arg3_type: bpf_arg_type,
    pub arg4_type: bpf_arg_type,
    pub arg5_type: bpf_arg_type,
}
impl Default for bpf_func_proto__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_func_proto__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_func_proto__bindgen_ty_2 {
    pub __bindgen_anon_1: bpf_func_proto__bindgen_ty_2__bindgen_ty_1,
    pub arg_btf_id: [*mut u32_; 5usize],
    pub __bindgen_anon_2: bpf_func_proto__bindgen_ty_2__bindgen_ty_2,
    pub arg_size: [usize; 5usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_func_proto__bindgen_ty_2__bindgen_ty_1 {
    pub arg1_btf_id: *mut u32_,
    pub arg2_btf_id: *mut u32_,
    pub arg3_btf_id: *mut u32_,
    pub arg4_btf_id: *mut u32_,
    pub arg5_btf_id: *mut u32_,
}
impl Default for bpf_func_proto__bindgen_ty_2__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_func_proto__bindgen_ty_2__bindgen_ty_2 {
    pub arg1_size: usize,
    pub arg2_size: usize,
    pub arg3_size: usize,
    pub arg4_size: usize,
    pub arg5_size: usize,
}
impl Default for bpf_func_proto__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_func_proto {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_context {
    _unused: [u8; 0],
}
pub const bpf_access_type_BPF_READ: bpf_access_type = 1;
pub const bpf_access_type_BPF_WRITE: bpf_access_type = 2;
pub type bpf_access_type = ffi::c_uint;
pub const bpf_reg_type_NOT_INIT: bpf_reg_type = 0;
pub const bpf_reg_type_SCALAR_VALUE: bpf_reg_type = 1;
pub const bpf_reg_type_PTR_TO_CTX: bpf_reg_type = 2;
pub const bpf_reg_type_CONST_PTR_TO_MAP: bpf_reg_type = 3;
pub const bpf_reg_type_PTR_TO_MAP_VALUE: bpf_reg_type = 4;
pub const bpf_reg_type_PTR_TO_MAP_KEY: bpf_reg_type = 5;
pub const bpf_reg_type_PTR_TO_STACK: bpf_reg_type = 6;
pub const bpf_reg_type_PTR_TO_PACKET_META: bpf_reg_type = 7;
pub const bpf_reg_type_PTR_TO_PACKET: bpf_reg_type = 8;
pub const bpf_reg_type_PTR_TO_PACKET_END: bpf_reg_type = 9;
pub const bpf_reg_type_PTR_TO_FLOW_KEYS: bpf_reg_type = 10;
pub const bpf_reg_type_PTR_TO_SOCKET: bpf_reg_type = 11;
pub const bpf_reg_type_PTR_TO_SOCK_COMMON: bpf_reg_type = 12;
pub const bpf_reg_type_PTR_TO_TCP_SOCK: bpf_reg_type = 13;
pub const bpf_reg_type_PTR_TO_TP_BUFFER: bpf_reg_type = 14;
pub const bpf_reg_type_PTR_TO_XDP_SOCK: bpf_reg_type = 15;
pub const bpf_reg_type_PTR_TO_BTF_ID: bpf_reg_type = 16;
pub const bpf_reg_type_PTR_TO_MEM: bpf_reg_type = 17;
pub const bpf_reg_type_PTR_TO_ARENA: bpf_reg_type = 18;
pub const bpf_reg_type_PTR_TO_BUF: bpf_reg_type = 19;
pub const bpf_reg_type_PTR_TO_FUNC: bpf_reg_type = 20;
pub const bpf_reg_type_CONST_PTR_TO_DYNPTR: bpf_reg_type = 21;
pub const bpf_reg_type___BPF_REG_TYPE_MAX: bpf_reg_type = 22;
pub const bpf_reg_type_PTR_TO_MAP_VALUE_OR_NULL: bpf_reg_type = 260;
pub const bpf_reg_type_PTR_TO_SOCKET_OR_NULL: bpf_reg_type = 267;
pub const bpf_reg_type_PTR_TO_SOCK_COMMON_OR_NULL: bpf_reg_type = 268;
pub const bpf_reg_type_PTR_TO_TCP_SOCK_OR_NULL: bpf_reg_type = 269;
pub const bpf_reg_type_PTR_TO_BTF_ID_OR_NULL: bpf_reg_type = 272;
pub const bpf_reg_type___BPF_REG_TYPE_LIMIT: bpf_reg_type = 134217727;
pub type bpf_reg_type = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_insn_access_aux {
    pub reg_type: bpf_reg_type,
    pub is_ldsx: bool_,
    pub __bindgen_anon_1: bpf_insn_access_aux__bindgen_ty_1,
    pub log: *mut bpf_verifier_log,
    pub is_retval: bool_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_insn_access_aux__bindgen_ty_1 {
    pub ctx_field_size: ffi::c_int,
    pub __bindgen_anon_1: bpf_insn_access_aux__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_insn_access_aux__bindgen_ty_1__bindgen_ty_1 {
    pub btf: *mut btf,
    pub btf_id: u32_,
    pub ref_obj_id: u32_,
}
impl Default for bpf_insn_access_aux__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_insn_access_aux__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_insn_access_aux {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_prog_ops {
    pub test_run: ::core::option::Option<
        unsafe extern "C" fn(
            prog: *mut bpf_prog,
            kattr: *const bpf_attr,
            uattr: *mut bpf_attr,
        ) -> ffi::c_int,
    >,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_reg_state {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_verifier_ops {
    pub get_func_proto: ::core::option::Option<
        unsafe extern "C" fn(func_id: bpf_func_id, prog: *const bpf_prog) -> *const bpf_func_proto,
    >,
    pub is_valid_access: ::core::option::Option<
        unsafe extern "C" fn(
            off: ffi::c_int,
            size: ffi::c_int,
            type_: bpf_access_type,
            prog: *const bpf_prog,
            info: *mut bpf_insn_access_aux,
        ) -> bool_,
    >,
    pub gen_prologue: ::core::option::Option<
        unsafe extern "C" fn(
            insn: *mut bpf_insn,
            direct_write: bool_,
            prog: *const bpf_prog,
        ) -> ffi::c_int,
    >,
    pub gen_epilogue: ::core::option::Option<
        unsafe extern "C" fn(
            insn: *mut bpf_insn,
            prog: *const bpf_prog,
            ctx_stack_off: s16,
        ) -> ffi::c_int,
    >,
    pub gen_ld_abs: ::core::option::Option<
        unsafe extern "C" fn(orig: *const bpf_insn, insn_buf: *mut bpf_insn) -> ffi::c_int,
    >,
    pub convert_ctx_access: ::core::option::Option<
        unsafe extern "C" fn(
            type_: bpf_access_type,
            src: *const bpf_insn,
            dst: *mut bpf_insn,
            prog: *mut bpf_prog,
            target_size: *mut u32_,
        ) -> u32_,
    >,
    pub btf_struct_access: ::core::option::Option<
        unsafe extern "C" fn(
            log: *mut bpf_verifier_log,
            reg: *const bpf_reg_state,
            off: ffi::c_int,
            size: ffi::c_int,
        ) -> ffi::c_int,
    >,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_prog_offload_ops {
    pub insn_hook: ::core::option::Option<
        unsafe extern "C" fn(
            env: *mut bpf_verifier_env,
            insn_idx: ffi::c_int,
            prev_insn_idx: ffi::c_int,
        ) -> ffi::c_int,
    >,
    pub finalize:
        ::core::option::Option<unsafe extern "C" fn(env: *mut bpf_verifier_env) -> ffi::c_int>,
    pub replace_insn: ::core::option::Option<
        unsafe extern "C" fn(
            env: *mut bpf_verifier_env,
            off: u32_,
            insn: *mut bpf_insn,
        ) -> ffi::c_int,
    >,
    pub remove_insns: ::core::option::Option<
        unsafe extern "C" fn(env: *mut bpf_verifier_env, off: u32_, cnt: u32_) -> ffi::c_int,
    >,
    pub prepare: ::core::option::Option<unsafe extern "C" fn(prog: *mut bpf_prog) -> ffi::c_int>,
    pub translate: ::core::option::Option<unsafe extern "C" fn(prog: *mut bpf_prog) -> ffi::c_int>,
    pub destroy: ::core::option::Option<unsafe extern "C" fn(prog: *mut bpf_prog)>,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_prog_offload {
    pub prog: *mut bpf_prog,
    pub netdev: *mut net_device,
    pub offdev: *mut bpf_offload_dev,
    pub dev_priv: *mut ffi::c_void,
    pub offloads: list_head,
    pub dev_state: bool_,
    pub opt_failed: bool_,
    pub jited_image: *mut ffi::c_void,
    pub jited_len: u32_,
}
impl Default for bpf_prog_offload {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const bpf_cgroup_storage_type_BPF_CGROUP_STORAGE_SHARED: bpf_cgroup_storage_type = 0;
pub const bpf_cgroup_storage_type_BPF_CGROUP_STORAGE_PERCPU: bpf_cgroup_storage_type = 1;
pub const bpf_cgroup_storage_type___BPF_CGROUP_STORAGE_MAX: bpf_cgroup_storage_type = 2;
pub type bpf_cgroup_storage_type = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct btf_func_model {
    pub ret_size: u8_,
    pub ret_flags: u8_,
    pub nr_args: u8_,
    pub arg_size: [u8_; 12usize],
    pub arg_flags: [u8_; 12usize],
}
pub const BPF_MAX_TRAMP_LINKS: _bindgen_ty_262 = 38;
pub type _bindgen_ty_262 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_tramp_links {
    pub links: [*mut bpf_tramp_link; 38usize],
    pub nr_links: ffi::c_int,
}
impl Default for bpf_tramp_links {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn arch_prepare_bpf_trampoline(
        im: *mut bpf_tramp_image,
        image: *mut ffi::c_void,
        image_end: *mut ffi::c_void,
        m: *const btf_func_model,
        flags: u32_,
        tlinks: *mut bpf_tramp_links,
        func_addr: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn arch_alloc_bpf_trampoline(size: ffi::c_uint) -> *mut ffi::c_void;
}
extern "C" {
    pub fn arch_free_bpf_trampoline(image: *mut ffi::c_void, size: ffi::c_uint);
}
extern "C" {
    #[must_use]
    pub fn arch_protect_bpf_trampoline(image: *mut ffi::c_void, size: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn arch_bpf_trampoline_size(
        m: *const btf_func_model,
        flags: u32_,
        tlinks: *mut bpf_tramp_links,
        func_addr: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __bpf_prog_enter_sleepable_recur(
        prog: *mut bpf_prog,
        run_ctx: *mut bpf_tramp_run_ctx,
    ) -> u64_;
}
extern "C" {
    pub fn __bpf_prog_exit_sleepable_recur(
        prog: *mut bpf_prog,
        start: u64_,
        run_ctx: *mut bpf_tramp_run_ctx,
    );
}
extern "C" {
    pub fn __bpf_tramp_enter(tr: *mut bpf_tramp_image);
}
extern "C" {
    pub fn __bpf_tramp_exit(tr: *mut bpf_tramp_image);
}
pub type bpf_trampoline_enter_t = ::core::option::Option<
    unsafe extern "C" fn(prog: *mut bpf_prog, run_ctx: *mut bpf_tramp_run_ctx) -> u64_,
>;
pub type bpf_trampoline_exit_t = ::core::option::Option<
    unsafe extern "C" fn(prog: *mut bpf_prog, start: u64_, run_ctx: *mut bpf_tramp_run_ctx),
>;
extern "C" {
    pub fn bpf_trampoline_enter(prog: *const bpf_prog) -> bpf_trampoline_enter_t;
}
extern "C" {
    pub fn bpf_trampoline_exit(prog: *const bpf_prog) -> bpf_trampoline_exit_t;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_ksym {
    pub start: ffi::c_ulong,
    pub end: ffi::c_ulong,
    pub name: [ffi::c_char; 512usize],
    pub lnode: list_head,
    pub tnode: latch_tree_node,
    pub prog: bool_,
}
impl Default for bpf_ksym {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const bpf_tramp_prog_type_BPF_TRAMP_FENTRY: bpf_tramp_prog_type = 0;
pub const bpf_tramp_prog_type_BPF_TRAMP_FEXIT: bpf_tramp_prog_type = 1;
pub const bpf_tramp_prog_type_BPF_TRAMP_MODIFY_RETURN: bpf_tramp_prog_type = 2;
pub const bpf_tramp_prog_type_BPF_TRAMP_MAX: bpf_tramp_prog_type = 3;
pub const bpf_tramp_prog_type_BPF_TRAMP_REPLACE: bpf_tramp_prog_type = 4;
pub type bpf_tramp_prog_type = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_tramp_image {
    pub image: *mut ffi::c_void,
    pub size: ffi::c_int,
    pub ksym: bpf_ksym,
    pub pcref: percpu_ref,
    pub ip_after_call: *mut ffi::c_void,
    pub ip_epilogue: *mut ffi::c_void,
    pub __bindgen_anon_1: bpf_tramp_image__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_tramp_image__bindgen_ty_1 {
    pub rcu: callback_head,
    pub work: work_struct,
}
impl Default for bpf_tramp_image__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_tramp_image {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_trampoline {
    pub hlist: hlist_node,
    pub fops: *mut ftrace_ops,
    pub mutex: mutex,
    pub refcnt: refcount_t,
    pub flags: u32_,
    pub key: u64_,
    pub func: bpf_trampoline__bindgen_ty_1,
    pub extension_prog: *mut bpf_prog,
    pub progs_hlist: [hlist_head; 3usize],
    pub progs_cnt: [ffi::c_int; 3usize],
    pub cur_image: *mut bpf_tramp_image,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_trampoline__bindgen_ty_1 {
    pub model: btf_func_model,
    pub addr: *mut ffi::c_void,
    pub ftrace_managed: bool_,
}
impl Default for bpf_trampoline__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_trampoline {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_attach_target_info {
    pub fmodel: btf_func_model,
    pub tgt_addr: ffi::c_long,
    pub tgt_mod: *mut module,
    pub tgt_name: *const ffi::c_char,
    pub tgt_type: *const btf_type,
}
impl Default for bpf_attach_target_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_dispatcher_prog {
    pub prog: *mut bpf_prog,
    pub users: refcount_t,
}
impl Default for bpf_dispatcher_prog {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_dispatcher {
    pub mutex: mutex,
    pub func: *mut ffi::c_void,
    pub progs: [bpf_dispatcher_prog; 48usize],
    pub num_progs: ffi::c_int,
    pub image: *mut ffi::c_void,
    pub rw_image: *mut ffi::c_void,
    pub image_off: u32_,
    pub ksym: bpf_ksym,
}
impl Default for bpf_dispatcher {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_dynptr_kern {
    pub data: *mut ffi::c_void,
    pub size: u32_,
    pub offset: u32_,
}
impl Default for bpf_dynptr_kern {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const bpf_dynptr_type_BPF_DYNPTR_TYPE_INVALID: bpf_dynptr_type = 0;
pub const bpf_dynptr_type_BPF_DYNPTR_TYPE_LOCAL: bpf_dynptr_type = 1;
pub const bpf_dynptr_type_BPF_DYNPTR_TYPE_RINGBUF: bpf_dynptr_type = 2;
pub const bpf_dynptr_type_BPF_DYNPTR_TYPE_SKB: bpf_dynptr_type = 3;
pub const bpf_dynptr_type_BPF_DYNPTR_TYPE_XDP: bpf_dynptr_type = 4;
pub type bpf_dynptr_type = ffi::c_uint;
extern "C" {
    pub fn bpf_dynptr_check_size(size: u32_) -> ffi::c_int;
}
extern "C" {
    pub fn __bpf_dynptr_size(ptr: *const bpf_dynptr_kern) -> u32_;
}
extern "C" {
    pub fn __bpf_dynptr_data(ptr: *const bpf_dynptr_kern, len: u32_) -> *const ffi::c_void;
}
extern "C" {
    pub fn __bpf_dynptr_data_rw(ptr: *const bpf_dynptr_kern, len: u32_) -> *mut ffi::c_void;
}
extern "C" {
    pub fn __bpf_dynptr_is_rdonly(ptr: *const bpf_dynptr_kern) -> bool_;
}
extern "C" {
    pub fn bpf_trampoline_link_prog(
        link: *mut bpf_tramp_link,
        tr: *mut bpf_trampoline,
        tgt_prog: *mut bpf_prog,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_trampoline_unlink_prog(
        link: *mut bpf_tramp_link,
        tr: *mut bpf_trampoline,
        tgt_prog: *mut bpf_prog,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_trampoline_get(
        key: u64_,
        tgt_info: *mut bpf_attach_target_info,
    ) -> *mut bpf_trampoline;
}
extern "C" {
    pub fn bpf_trampoline_put(tr: *mut bpf_trampoline);
}
extern "C" {
    pub fn arch_prepare_bpf_dispatcher(
        image: *mut ffi::c_void,
        buf: *mut ffi::c_void,
        funcs: *mut s64,
        num_funcs: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_dispatcher_change_prog(
        d: *mut bpf_dispatcher,
        from: *mut bpf_prog,
        to: *mut bpf_prog,
    );
}
extern "C" {
    pub fn bpf_image_ksym_init(data: *mut ffi::c_void, size: ffi::c_uint, ksym: *mut bpf_ksym);
}
extern "C" {
    pub fn bpf_image_ksym_add(ksym: *mut bpf_ksym);
}
extern "C" {
    pub fn bpf_image_ksym_del(ksym: *mut bpf_ksym);
}
extern "C" {
    pub fn bpf_ksym_add(ksym: *mut bpf_ksym);
}
extern "C" {
    pub fn bpf_ksym_del(ksym: *mut bpf_ksym);
}
extern "C" {
    pub fn bpf_jit_charge_modmem(size: u32_) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_jit_uncharge_modmem(size: u32_);
}
extern "C" {
    pub fn bpf_prog_has_trampoline(prog: *const bpf_prog) -> bool_;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_func_info_aux {
    pub linkage: u16_,
    pub unreliable: bool_,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
}
impl bpf_func_info_aux {
    #[inline]
    pub fn called(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_called(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn called_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_called_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn verified(&self) -> bool_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_verified(&mut self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn verified_raw(this: *const Self) -> bool_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_verified_raw(this: *mut Self, val: bool_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(called: bool_, verified: bool_) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let called: u8 = unsafe { ::core::mem::transmute(called) };
            called as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let verified: u8 = unsafe { ::core::mem::transmute(verified) };
            verified as u64
        });
        __bindgen_bitfield_unit
    }
}
pub const bpf_jit_poke_reason_BPF_POKE_REASON_TAIL_CALL: bpf_jit_poke_reason = 0;
pub type bpf_jit_poke_reason = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_jit_poke_descriptor {
    pub tailcall_target: *mut ffi::c_void,
    pub tailcall_bypass: *mut ffi::c_void,
    pub bypass_addr: *mut ffi::c_void,
    pub aux: *mut ffi::c_void,
    pub __bindgen_anon_1: bpf_jit_poke_descriptor__bindgen_ty_1,
    pub tailcall_target_stable: bool_,
    pub adj_off: u8_,
    pub reason: u16_,
    pub insn_idx: u32_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_jit_poke_descriptor__bindgen_ty_1 {
    pub tail_call: bpf_jit_poke_descriptor__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_jit_poke_descriptor__bindgen_ty_1__bindgen_ty_1 {
    pub map: *mut bpf_map,
    pub key: u32_,
}
impl Default for bpf_jit_poke_descriptor__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_jit_poke_descriptor__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_jit_poke_descriptor {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_ctx_arg_aux {
    pub offset: u32_,
    pub reg_type: bpf_reg_type,
    pub btf: *mut btf,
    pub btf_id: u32_,
    pub ref_obj_id: u32_,
    pub refcounted: bool_,
}
impl Default for bpf_ctx_arg_aux {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct btf_mod_pair {
    pub btf: *mut btf,
    pub module: *mut module,
}
impl Default for btf_mod_pair {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_kfunc_desc_tab {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_prog_aux {
    pub refcnt: atomic64_t,
    pub used_map_cnt: u32_,
    pub used_btf_cnt: u32_,
    pub max_ctx_offset: u32_,
    pub max_pkt_offset: u32_,
    pub max_tp_access: u32_,
    pub stack_depth: u32_,
    pub id: u32_,
    pub func_cnt: u32_,
    pub real_func_cnt: u32_,
    pub func_idx: u32_,
    pub attach_btf_id: u32_,
    pub attach_st_ops_member_off: u32_,
    pub ctx_arg_info_size: u32_,
    pub max_rdonly_access: u32_,
    pub max_rdwr_access: u32_,
    pub attach_btf: *mut btf,
    pub ctx_arg_info: *mut bpf_ctx_arg_aux,
    pub priv_stack_ptr: *mut ffi::c_void,
    pub dst_mutex: mutex,
    pub dst_prog: *mut bpf_prog,
    pub dst_trampoline: *mut bpf_trampoline,
    pub saved_dst_prog_type: bpf_prog_type,
    pub saved_dst_attach_type: bpf_attach_type,
    pub verifier_zext: bool_,
    pub dev_bound: bool_,
    pub offload_requested: bool_,
    pub attach_btf_trace: bool_,
    pub attach_tracing_prog: bool_,
    pub func_proto_unreliable: bool_,
    pub tail_call_reachable: bool_,
    pub xdp_has_frags: bool_,
    pub exception_cb: bool_,
    pub exception_boundary: bool_,
    pub is_extended: bool_,
    pub jits_use_priv_stack: bool_,
    pub priv_stack_requested: bool_,
    pub changes_pkt_data: bool_,
    pub might_sleep: bool_,
    pub prog_array_member_cnt: u64_,
    pub ext_mutex: mutex,
    pub arena: *mut bpf_arena,
    pub recursion_detected: ::core::option::Option<unsafe extern "C" fn(prog: *mut bpf_prog)>,
    pub attach_func_proto: *const btf_type,
    pub attach_func_name: *const ffi::c_char,
    pub func: *mut *mut bpf_prog,
    pub jit_data: *mut ffi::c_void,
    pub poke_tab: *mut bpf_jit_poke_descriptor,
    pub kfunc_tab: *mut bpf_kfunc_desc_tab,
    pub kfunc_btf_tab: *mut bpf_kfunc_btf_tab,
    pub size_poke_tab: u32_,
    pub ksym: bpf_ksym,
    pub ops: *const bpf_prog_ops,
    pub st_ops: *const bpf_struct_ops,
    pub used_maps: *mut *mut bpf_map,
    pub used_maps_mutex: mutex,
    pub used_btfs: *mut btf_mod_pair,
    pub prog: *mut bpf_prog,
    pub user: *mut user_struct,
    pub load_time: u64_,
    pub verified_insns: u32_,
    pub cgroup_atype: ffi::c_int,
    pub cgroup_storage: [*mut bpf_map; 2usize],
    pub name: [ffi::c_char; 16usize],
    pub bpf_exception_cb: ::core::option::Option<
        unsafe extern "C" fn(cookie: u64_, sp: u64_, bp: u64_, arg1: u64_, arg2: u64_) -> u64_,
    >,
    pub security: *mut ffi::c_void,
    pub token: *mut bpf_token,
    pub offload: *mut bpf_prog_offload,
    pub btf: *mut btf,
    pub func_info: *mut bpf_func_info,
    pub func_info_aux: *mut bpf_func_info_aux,
    pub linfo: *mut bpf_line_info,
    pub jited_linfo: *mut *mut ffi::c_void,
    pub func_info_cnt: u32_,
    pub nr_linfo: u32_,
    pub linfo_idx: u32_,
    pub mod_: *mut module,
    pub num_exentries: u32_,
    pub extable: *mut exception_table_entry,
    pub __bindgen_anon_1: bpf_prog_aux__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_prog_aux__bindgen_ty_1 {
    pub work: work_struct,
    pub rcu: callback_head,
}
impl Default for bpf_prog_aux__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_prog_aux {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct bpf_prog {
    pub pages: u16_,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
    pub type_: bpf_prog_type,
    pub expected_attach_type: bpf_attach_type,
    pub len: u32_,
    pub jited_len: u32_,
    pub tag: [u8_; 8usize],
    pub stats: *mut bpf_prog_stats,
    pub active: *mut ffi::c_int,
    pub bpf_func: ::core::option::Option<
        unsafe extern "C" fn(ctx: *const ffi::c_void, insn: *const bpf_insn) -> ffi::c_uint,
    >,
    pub aux: *mut bpf_prog_aux,
    pub orig_prog: *mut sock_fprog_kern,
    pub __bindgen_anon_1: bpf_prog__bindgen_ty_1,
}
#[repr(C)]
pub struct bpf_prog__bindgen_ty_1 {
    pub __bindgen_anon_1: __BindgenUnionField<bpf_prog__bindgen_ty_1__bindgen_ty_1>,
    pub __bindgen_anon_2: __BindgenUnionField<bpf_prog__bindgen_ty_1__bindgen_ty_2>,
    pub bindgen_union_field: [u32; 0usize],
}
#[repr(C)]
#[derive(Default)]
pub struct bpf_prog__bindgen_ty_1__bindgen_ty_1 {
    pub __empty_insns: bpf_prog__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
    pub insns: __IncompleteArrayField<sock_filter>,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_prog__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {}
#[repr(C)]
#[derive(Default)]
pub struct bpf_prog__bindgen_ty_1__bindgen_ty_2 {
    pub __empty_insnsi: bpf_prog__bindgen_ty_1__bindgen_ty_2__bindgen_ty_1,
    pub insnsi: __IncompleteArrayField<bpf_insn>,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_prog__bindgen_ty_1__bindgen_ty_2__bindgen_ty_1 {}
impl Default for bpf_prog__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_prog {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl bpf_prog {
    #[inline]
    pub fn jited(&self) -> u16_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_jited(&mut self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn jited_raw(this: *const Self) -> u16_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_jited_raw(this: *mut Self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn jit_requested(&self) -> u16_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_jit_requested(&mut self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn jit_requested_raw(this: *const Self) -> u16_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_jit_requested_raw(this: *mut Self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn gpl_compatible(&self) -> u16_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_gpl_compatible(&mut self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn gpl_compatible_raw(this: *const Self) -> u16_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_gpl_compatible_raw(this: *mut Self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn cb_access(&self) -> u16_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_cb_access(&mut self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn cb_access_raw(this: *const Self) -> u16_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_cb_access_raw(this: *mut Self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn dst_needed(&self) -> u16_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_dst_needed(&mut self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            self._bitfield_1.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn dst_needed_raw(this: *const Self) -> u16_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_dst_needed_raw(this: *mut Self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn blinding_requested(&self) -> u16_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_blinding_requested(&mut self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            self._bitfield_1.set(5usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn blinding_requested_raw(this: *const Self) -> u16_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_blinding_requested_raw(this: *mut Self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn blinded(&self) -> u16_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_blinded(&mut self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            self._bitfield_1.set(6usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn blinded_raw(this: *const Self) -> u16_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                6usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_blinded_raw(this: *mut Self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                6usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn is_func(&self) -> u16_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_is_func(&mut self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            self._bitfield_1.set(7usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn is_func_raw(this: *const Self) -> u16_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                7usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_is_func_raw(this: *mut Self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                7usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn kprobe_override(&self) -> u16_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(8usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_kprobe_override(&mut self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            self._bitfield_1.set(8usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn kprobe_override_raw(this: *const Self) -> u16_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                8usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_kprobe_override_raw(this: *mut Self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                8usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn has_callchain_buf(&self) -> u16_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(9usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_has_callchain_buf(&mut self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            self._bitfield_1.set(9usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn has_callchain_buf_raw(this: *const Self) -> u16_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                9usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_has_callchain_buf_raw(this: *mut Self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                9usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn enforce_expected_attach_type(&self) -> u16_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(10usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_enforce_expected_attach_type(&mut self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            self._bitfield_1.set(10usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn enforce_expected_attach_type_raw(this: *const Self) -> u16_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                10usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_enforce_expected_attach_type_raw(this: *mut Self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                10usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn call_get_stack(&self) -> u16_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(11usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_call_get_stack(&mut self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            self._bitfield_1.set(11usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn call_get_stack_raw(this: *const Self) -> u16_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                11usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_call_get_stack_raw(this: *mut Self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                11usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn call_get_func_ip(&self) -> u16_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(12usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_call_get_func_ip(&mut self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            self._bitfield_1.set(12usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn call_get_func_ip_raw(this: *const Self) -> u16_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                12usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_call_get_func_ip_raw(this: *mut Self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                12usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn tstamp_type_access(&self) -> u16_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(13usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_tstamp_type_access(&mut self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            self._bitfield_1.set(13usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn tstamp_type_access_raw(this: *const Self) -> u16_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                13usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_tstamp_type_access_raw(this: *mut Self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                13usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn sleepable(&self) -> u16_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(14usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_sleepable(&mut self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            self._bitfield_1.set(14usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn sleepable_raw(this: *const Self) -> u16_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                14usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_sleepable_raw(this: *mut Self, val: u16_) {
        unsafe {
            let val: u16 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                14usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        jited: u16_,
        jit_requested: u16_,
        gpl_compatible: u16_,
        cb_access: u16_,
        dst_needed: u16_,
        blinding_requested: u16_,
        blinded: u16_,
        is_func: u16_,
        kprobe_override: u16_,
        has_callchain_buf: u16_,
        enforce_expected_attach_type: u16_,
        call_get_stack: u16_,
        call_get_func_ip: u16_,
        tstamp_type_access: u16_,
        sleepable: u16_,
    ) -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let jited: u16 = unsafe { ::core::mem::transmute(jited) };
            jited as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let jit_requested: u16 = unsafe { ::core::mem::transmute(jit_requested) };
            jit_requested as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let gpl_compatible: u16 = unsafe { ::core::mem::transmute(gpl_compatible) };
            gpl_compatible as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let cb_access: u16 = unsafe { ::core::mem::transmute(cb_access) };
            cb_access as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let dst_needed: u16 = unsafe { ::core::mem::transmute(dst_needed) };
            dst_needed as u64
        });
        __bindgen_bitfield_unit.set(5usize, 1u8, {
            let blinding_requested: u16 = unsafe { ::core::mem::transmute(blinding_requested) };
            blinding_requested as u64
        });
        __bindgen_bitfield_unit.set(6usize, 1u8, {
            let blinded: u16 = unsafe { ::core::mem::transmute(blinded) };
            blinded as u64
        });
        __bindgen_bitfield_unit.set(7usize, 1u8, {
            let is_func: u16 = unsafe { ::core::mem::transmute(is_func) };
            is_func as u64
        });
        __bindgen_bitfield_unit.set(8usize, 1u8, {
            let kprobe_override: u16 = unsafe { ::core::mem::transmute(kprobe_override) };
            kprobe_override as u64
        });
        __bindgen_bitfield_unit.set(9usize, 1u8, {
            let has_callchain_buf: u16 = unsafe { ::core::mem::transmute(has_callchain_buf) };
            has_callchain_buf as u64
        });
        __bindgen_bitfield_unit.set(10usize, 1u8, {
            let enforce_expected_attach_type: u16 =
                unsafe { ::core::mem::transmute(enforce_expected_attach_type) };
            enforce_expected_attach_type as u64
        });
        __bindgen_bitfield_unit.set(11usize, 1u8, {
            let call_get_stack: u16 = unsafe { ::core::mem::transmute(call_get_stack) };
            call_get_stack as u64
        });
        __bindgen_bitfield_unit.set(12usize, 1u8, {
            let call_get_func_ip: u16 = unsafe { ::core::mem::transmute(call_get_func_ip) };
            call_get_func_ip as u64
        });
        __bindgen_bitfield_unit.set(13usize, 1u8, {
            let tstamp_type_access: u16 = unsafe { ::core::mem::transmute(tstamp_type_access) };
            tstamp_type_access as u64
        });
        __bindgen_bitfield_unit.set(14usize, 1u8, {
            let sleepable: u16 = unsafe { ::core::mem::transmute(sleepable) };
            sleepable as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_array_aux {
    pub poke_progs: list_head,
    pub map: *mut bpf_map,
    pub poke_mutex: mutex,
    pub work: work_struct,
}
impl Default for bpf_array_aux {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_link {
    pub refcnt: atomic64_t,
    pub id: u32_,
    pub type_: bpf_link_type,
    pub ops: *const bpf_link_ops,
    pub prog: *mut bpf_prog,
    pub sleepable: bool_,
    pub __bindgen_anon_1: bpf_link__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_link__bindgen_ty_1 {
    pub rcu: callback_head,
    pub work: work_struct,
}
impl Default for bpf_link__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_link {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_link_ops {
    pub release: ::core::option::Option<unsafe extern "C" fn(link: *mut bpf_link)>,
    pub dealloc: ::core::option::Option<unsafe extern "C" fn(link: *mut bpf_link)>,
    pub dealloc_deferred: ::core::option::Option<unsafe extern "C" fn(link: *mut bpf_link)>,
    pub detach: ::core::option::Option<unsafe extern "C" fn(link: *mut bpf_link) -> ffi::c_int>,
    pub update_prog: ::core::option::Option<
        unsafe extern "C" fn(
            link: *mut bpf_link,
            new_prog: *mut bpf_prog,
            old_prog: *mut bpf_prog,
        ) -> ffi::c_int,
    >,
    pub show_fdinfo:
        ::core::option::Option<unsafe extern "C" fn(link: *const bpf_link, seq: *mut seq_file)>,
    pub fill_link_info: ::core::option::Option<
        unsafe extern "C" fn(link: *const bpf_link, info: *mut bpf_link_info) -> ffi::c_int,
    >,
    pub update_map: ::core::option::Option<
        unsafe extern "C" fn(
            link: *mut bpf_link,
            new_map: *mut bpf_map,
            old_map: *mut bpf_map,
        ) -> ffi::c_int,
    >,
    pub poll: ::core::option::Option<
        unsafe extern "C" fn(file: *mut file, pts: *mut poll_table_struct) -> __poll_t,
    >,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_tramp_link {
    pub link: bpf_link,
    pub tramp_hlist: hlist_node,
    pub cookie: u64_,
}
impl Default for bpf_tramp_link {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_shim_tramp_link {
    pub link: bpf_tramp_link,
    pub trampoline: *mut bpf_trampoline,
}
impl Default for bpf_shim_tramp_link {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_tracing_link {
    pub link: bpf_tramp_link,
    pub attach_type: bpf_attach_type,
    pub trampoline: *mut bpf_trampoline,
    pub tgt_prog: *mut bpf_prog,
}
impl Default for bpf_tracing_link {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_raw_tp_link {
    pub link: bpf_link,
    pub btp: *mut bpf_raw_event_map,
    pub cookie: u64_,
}
impl Default for bpf_raw_tp_link {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_link_primer {
    pub link: *mut bpf_link,
    pub file: *mut file,
    pub fd: ffi::c_int,
    pub id: u32_,
}
impl Default for bpf_link_primer {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_mount_opts {
    pub uid: kuid_t,
    pub gid: kgid_t,
    pub mode: umode_t,
    pub delegate_cmds: u64_,
    pub delegate_maps: u64_,
    pub delegate_progs: u64_,
    pub delegate_attachs: u64_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_token {
    pub work: work_struct,
    pub refcnt: atomic64_t,
    pub userns: *mut user_namespace,
    pub allowed_cmds: u64_,
    pub allowed_maps: u64_,
    pub allowed_progs: u64_,
    pub allowed_attachs: u64_,
    pub security: *mut ffi::c_void,
}
impl Default for bpf_token {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_struct_ops_value {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_struct_ops {
    pub verifier_ops: *const bpf_verifier_ops,
    pub init: ::core::option::Option<unsafe extern "C" fn(btf: *mut btf) -> ffi::c_int>,
    pub check_member: ::core::option::Option<
        unsafe extern "C" fn(
            t: *const btf_type,
            member: *const btf_member,
            prog: *const bpf_prog,
        ) -> ffi::c_int,
    >,
    pub init_member: ::core::option::Option<
        unsafe extern "C" fn(
            t: *const btf_type,
            member: *const btf_member,
            kdata: *mut ffi::c_void,
            udata: *const ffi::c_void,
        ) -> ffi::c_int,
    >,
    pub reg: ::core::option::Option<
        unsafe extern "C" fn(kdata: *mut ffi::c_void, link: *mut bpf_link) -> ffi::c_int,
    >,
    pub unreg:
        ::core::option::Option<unsafe extern "C" fn(kdata: *mut ffi::c_void, link: *mut bpf_link)>,
    pub update: ::core::option::Option<
        unsafe extern "C" fn(
            kdata: *mut ffi::c_void,
            old_kdata: *mut ffi::c_void,
            link: *mut bpf_link,
        ) -> ffi::c_int,
    >,
    pub validate:
        ::core::option::Option<unsafe extern "C" fn(kdata: *mut ffi::c_void) -> ffi::c_int>,
    pub cfi_stubs: *mut ffi::c_void,
    pub owner: *mut module,
    pub name: *const ffi::c_char,
    pub func_models: [btf_func_model; 64usize],
}
impl Default for bpf_struct_ops {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_struct_ops_arg_info {
    pub info: *mut bpf_ctx_arg_aux,
    pub cnt: u32_,
}
impl Default for bpf_struct_ops_arg_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_struct_ops_desc {
    pub st_ops: *mut bpf_struct_ops,
    pub type_: *const btf_type,
    pub value_type: *const btf_type,
    pub type_id: u32_,
    pub value_id: u32_,
    pub arg_info: *mut bpf_struct_ops_arg_info,
}
impl Default for bpf_struct_ops_desc {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const bpf_struct_ops_state_BPF_STRUCT_OPS_STATE_INIT: bpf_struct_ops_state = 0;
pub const bpf_struct_ops_state_BPF_STRUCT_OPS_STATE_INUSE: bpf_struct_ops_state = 1;
pub const bpf_struct_ops_state_BPF_STRUCT_OPS_STATE_TOBEFREE: bpf_struct_ops_state = 2;
pub const bpf_struct_ops_state_BPF_STRUCT_OPS_STATE_READY: bpf_struct_ops_state = 3;
pub type bpf_struct_ops_state = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_struct_ops_common_value {
    pub refcnt: refcount_t,
    pub state: bpf_struct_ops_state,
}
impl Default for bpf_struct_ops_common_value {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn bpf_struct_ops_get(kdata: *const ffi::c_void) -> bool_;
}
extern "C" {
    pub fn bpf_struct_ops_put(kdata: *const ffi::c_void);
}
extern "C" {
    pub fn bpf_struct_ops_supported(st_ops: *const bpf_struct_ops, moff: u32_) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_struct_ops_map_sys_lookup_elem(
        map: *mut bpf_map,
        key: *mut ffi::c_void,
        value: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_struct_ops_prepare_trampoline(
        tlinks: *mut bpf_tramp_links,
        link: *mut bpf_tramp_link,
        model: *const btf_func_model,
        stub_func: *mut ffi::c_void,
        image: *mut *mut ffi::c_void,
        image_off: *mut u32_,
        allow_alloc: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_struct_ops_image_free(image: *mut ffi::c_void);
}
extern "C" {
    pub fn bpf_struct_ops_link_create(attr: *mut bpf_attr) -> ffi::c_int;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_dummy_ops_state {
    pub val: ffi::c_int,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_dummy_ops {
    pub test_1:
        ::core::option::Option<unsafe extern "C" fn(cb: *mut bpf_dummy_ops_state) -> ffi::c_int>,
    pub test_2: ::core::option::Option<
        unsafe extern "C" fn(
            cb: *mut bpf_dummy_ops_state,
            a1: ffi::c_int,
            a2: ffi::c_ushort,
            a3: ffi::c_char,
            a4: ffi::c_ulong,
        ) -> ffi::c_int,
    >,
    pub test_sleepable:
        ::core::option::Option<unsafe extern "C" fn(cb: *mut bpf_dummy_ops_state) -> ffi::c_int>,
}
extern "C" {
    pub fn bpf_struct_ops_test_run(
        prog: *mut bpf_prog,
        kattr: *const bpf_attr,
        uattr: *mut bpf_attr,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_struct_ops_desc_init(
        st_ops_desc: *mut bpf_struct_ops_desc,
        btf: *mut btf,
        log: *mut bpf_verifier_log,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_map_struct_ops_info_fill(info: *mut bpf_map_info, map: *mut bpf_map);
}
extern "C" {
    pub fn bpf_struct_ops_desc_release(st_ops_desc: *mut bpf_struct_ops_desc);
}
extern "C" {
    pub fn bpf_prog_ctx_arg_info_init(
        prog: *mut bpf_prog,
        info: *const bpf_ctx_arg_aux,
        cnt: u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_trampoline_link_cgroup_shim(
        prog: *mut bpf_prog,
        cgroup_atype: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_trampoline_unlink_cgroup_shim(prog: *mut bpf_prog);
}
#[repr(C)]
pub struct bpf_array {
    pub map: bpf_map,
    pub elem_size: u32_,
    pub index_mask: u32_,
    pub aux: *mut bpf_array_aux,
    pub __bindgen_anon_1: bpf_array__bindgen_ty_1,
}
#[repr(C)]
pub struct bpf_array__bindgen_ty_1 {
    pub __bindgen_anon_1: __BindgenUnionField<bpf_array__bindgen_ty_1__bindgen_ty_1>,
    pub __bindgen_anon_2: __BindgenUnionField<bpf_array__bindgen_ty_1__bindgen_ty_2>,
    pub __bindgen_anon_3: __BindgenUnionField<bpf_array__bindgen_ty_1__bindgen_ty_3>,
    pub bindgen_union_field: [u64; 0usize],
}
#[repr(C)]
#[repr(align(8))]
#[derive(Default)]
pub struct bpf_array__bindgen_ty_1__bindgen_ty_1 {
    pub __empty_value: bpf_array__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
    pub value: __IncompleteArrayField<ffi::c_char>,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_array__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {}
#[repr(C)]
pub struct bpf_array__bindgen_ty_1__bindgen_ty_2 {
    pub __empty_ptrs: bpf_array__bindgen_ty_1__bindgen_ty_2__bindgen_ty_1,
    pub ptrs: __IncompleteArrayField<*mut ffi::c_void>,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_array__bindgen_ty_1__bindgen_ty_2__bindgen_ty_1 {}
impl Default for bpf_array__bindgen_ty_1__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct bpf_array__bindgen_ty_1__bindgen_ty_3 {
    pub __empty_pptrs: bpf_array__bindgen_ty_1__bindgen_ty_3__bindgen_ty_1,
    pub pptrs: __IncompleteArrayField<*mut ffi::c_void>,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_array__bindgen_ty_1__bindgen_ty_3__bindgen_ty_1 {}
impl Default for bpf_array__bindgen_ty_1__bindgen_ty_3 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_array__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_array {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const BPF_MAX_LOOPS: _bindgen_ty_263 = 8388608;
pub const BPF_MAX_TIMED_LOOPS: _bindgen_ty_263 = 65535;
pub type _bindgen_ty_263 = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_event_entry {
    pub event: *mut perf_event,
    pub perf_file: *mut file,
    pub map_file: *mut file,
    pub rcu: callback_head,
}
impl Default for bpf_event_entry {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn bpf_prog_map_compatible(map: *mut bpf_map, fp: *const bpf_prog) -> bool_;
}
extern "C" {
    pub fn bpf_prog_calc_tag(fp: *mut bpf_prog) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_get_trace_printk_proto() -> *const bpf_func_proto;
}
extern "C" {
    pub fn bpf_get_trace_vprintk_proto() -> *const bpf_func_proto;
}
extern "C" {
    pub fn bpf_get_perf_event_read_value_proto() -> *const bpf_func_proto;
}
pub type bpf_ctx_copy_t = ::core::option::Option<
    unsafe extern "C" fn(
        dst: *mut ffi::c_void,
        src: *const ffi::c_void,
        off: ffi::c_ulong,
        len: ffi::c_ulong,
    ) -> ffi::c_ulong,
>;
pub type bpf_convert_ctx_access_t = ::core::option::Option<
    unsafe extern "C" fn(
        type_: bpf_access_type,
        src: *const bpf_insn,
        dst: *mut bpf_insn,
        prog: *mut bpf_prog,
        target_size: *mut u32_,
    ) -> u32_,
>;
extern "C" {
    pub fn bpf_event_output(
        map: *mut bpf_map,
        flags: u64_,
        meta: *mut ffi::c_void,
        meta_size: u64_,
        ctx: *mut ffi::c_void,
        ctx_size: u64_,
        ctx_copy: bpf_ctx_copy_t,
    ) -> u64_;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_prog_array_item {
    pub prog: *mut bpf_prog,
    pub __bindgen_anon_1: bpf_prog_array_item__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_prog_array_item__bindgen_ty_1 {
    pub cgroup_storage: [*mut bpf_cgroup_storage; 2usize],
    pub bpf_cookie: u64_,
}
impl Default for bpf_prog_array_item__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_prog_array_item {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct bpf_prog_array {
    pub rcu: callback_head,
    pub items: __IncompleteArrayField<bpf_prog_array_item>,
}
impl Default for bpf_prog_array {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct bpf_empty_prog_array {
    pub hdr: bpf_prog_array,
    pub null_prog: *mut bpf_prog,
}
impl Default for bpf_empty_prog_array {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub static mut bpf_empty_prog_array: bpf_empty_prog_array;
}
extern "C" {
    pub fn bpf_prog_array_alloc(prog_cnt: u32_, flags: gfp_t) -> *mut bpf_prog_array;
}
extern "C" {
    pub fn bpf_prog_array_free(progs: *mut bpf_prog_array);
}
extern "C" {
    pub fn bpf_prog_array_free_sleepable(progs: *mut bpf_prog_array);
}
extern "C" {
    pub fn bpf_prog_array_length(progs: *mut bpf_prog_array) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_prog_array_is_empty(array: *mut bpf_prog_array) -> bool_;
}
extern "C" {
    pub fn bpf_prog_array_copy_to_user(
        progs: *mut bpf_prog_array,
        prog_ids: *mut __u32,
        cnt: u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_prog_array_delete_safe(progs: *mut bpf_prog_array, old_prog: *mut bpf_prog);
}
extern "C" {
    pub fn bpf_prog_array_delete_safe_at(
        array: *mut bpf_prog_array,
        index: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_prog_array_update_at(
        array: *mut bpf_prog_array,
        index: ffi::c_int,
        prog: *mut bpf_prog,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_prog_array_copy_info(
        array: *mut bpf_prog_array,
        prog_ids: *mut u32_,
        request_cnt: u32_,
        prog_cnt: *mut u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_prog_array_copy(
        old_array: *mut bpf_prog_array,
        exclude_prog: *mut bpf_prog,
        include_prog: *mut bpf_prog,
        bpf_cookie: u64_,
        new_array: *mut *mut bpf_prog_array,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_run_ctx {}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_cg_run_ctx {
    pub run_ctx: bpf_run_ctx,
    pub prog_item: *const bpf_prog_array_item,
    pub retval: ffi::c_int,
}
impl Default for bpf_cg_run_ctx {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_trace_run_ctx {
    pub run_ctx: bpf_run_ctx,
    pub bpf_cookie: u64_,
    pub is_uprobe: bool_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_tramp_run_ctx {
    pub run_ctx: bpf_run_ctx,
    pub bpf_cookie: u64_,
    pub saved_run_ctx: *mut bpf_run_ctx,
}
impl Default for bpf_tramp_run_ctx {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type bpf_prog_run_fn = ::core::option::Option<
    unsafe extern "C" fn(prog: *const bpf_prog, ctx: *const ffi::c_void) -> u32_,
>;
extern "C" {
    pub static mut bpf_prog_active: ffi::c_int;
}
extern "C" {
    pub static mut bpf_stats_enabled_mutex: mutex;
}
extern "C" {
    pub static bpf_super_ops: super_operations;
}
extern "C" {
    pub static bpf_map_fops: file_operations;
}
extern "C" {
    pub static bpf_prog_fops: file_operations;
}
extern "C" {
    pub static bpf_iter_fops: file_operations;
}
extern "C" {
    pub static sk_filter_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static sk_filter_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static tc_cls_act_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static tc_cls_act_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static xdp_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static xdp_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static cg_skb_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static cg_skb_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static cg_sock_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static cg_sock_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static cg_sock_addr_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static cg_sock_addr_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static lwt_in_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static lwt_in_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static lwt_out_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static lwt_out_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static lwt_xmit_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static lwt_xmit_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static lwt_seg6local_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static lwt_seg6local_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static sock_ops_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static sock_ops_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static sk_skb_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static sk_skb_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static sk_msg_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static sk_msg_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static flow_dissector_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static flow_dissector_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static kprobe_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static kprobe_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static tracepoint_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static tracepoint_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static perf_event_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static perf_event_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static raw_tracepoint_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static raw_tracepoint_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static raw_tracepoint_writable_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static raw_tracepoint_writable_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static tracing_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static tracing_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static cg_dev_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static cg_dev_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static cg_sysctl_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static cg_sysctl_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static cg_sockopt_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static cg_sockopt_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static lirc_mode2_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static lirc_mode2_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static sk_reuseport_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static sk_reuseport_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static sk_lookup_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static sk_lookup_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static bpf_struct_ops_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static bpf_struct_ops_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static bpf_extension_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static bpf_extension_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static lsm_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static lsm_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static bpf_syscall_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static bpf_syscall_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static netfilter_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static netfilter_verifier_ops: bpf_verifier_ops;
}
extern "C" {
    pub static array_map_ops: bpf_map_ops;
}
extern "C" {
    pub static percpu_array_map_ops: bpf_map_ops;
}
extern "C" {
    pub static prog_array_map_ops: bpf_map_ops;
}
extern "C" {
    pub static perf_event_array_map_ops: bpf_map_ops;
}
extern "C" {
    pub static cgroup_array_map_ops: bpf_map_ops;
}
extern "C" {
    pub static cgrp_storage_map_ops: bpf_map_ops;
}
extern "C" {
    pub static cgroup_storage_map_ops: bpf_map_ops;
}
extern "C" {
    pub static htab_map_ops: bpf_map_ops;
}
extern "C" {
    pub static htab_percpu_map_ops: bpf_map_ops;
}
extern "C" {
    pub static htab_lru_map_ops: bpf_map_ops;
}
extern "C" {
    pub static htab_lru_percpu_map_ops: bpf_map_ops;
}
extern "C" {
    pub static trie_map_ops: bpf_map_ops;
}
extern "C" {
    pub static stack_trace_map_ops: bpf_map_ops;
}
extern "C" {
    pub static array_of_maps_map_ops: bpf_map_ops;
}
extern "C" {
    pub static htab_of_maps_map_ops: bpf_map_ops;
}
extern "C" {
    pub static inode_storage_map_ops: bpf_map_ops;
}
extern "C" {
    pub static task_storage_map_ops: bpf_map_ops;
}
extern "C" {
    pub static dev_map_ops: bpf_map_ops;
}
extern "C" {
    pub static dev_map_hash_ops: bpf_map_ops;
}
extern "C" {
    pub static sk_storage_map_ops: bpf_map_ops;
}
extern "C" {
    pub static cpu_map_ops: bpf_map_ops;
}
extern "C" {
    pub static xsk_map_ops: bpf_map_ops;
}
extern "C" {
    pub static sock_map_ops: bpf_map_ops;
}
extern "C" {
    pub static sock_hash_ops: bpf_map_ops;
}
extern "C" {
    pub static reuseport_array_ops: bpf_map_ops;
}
extern "C" {
    pub static queue_map_ops: bpf_map_ops;
}
extern "C" {
    pub static stack_map_ops: bpf_map_ops;
}
extern "C" {
    pub static bpf_struct_ops_map_ops: bpf_map_ops;
}
extern "C" {
    pub static ringbuf_map_ops: bpf_map_ops;
}
extern "C" {
    pub static bloom_filter_map_ops: bpf_map_ops;
}
extern "C" {
    pub static user_ringbuf_map_ops: bpf_map_ops;
}
extern "C" {
    pub static arena_map_ops: bpf_map_ops;
}
extern "C" {
    pub static bpf_offload_prog_ops: bpf_prog_ops;
}
extern "C" {
    pub static tc_cls_act_analyzer_ops: bpf_verifier_ops;
}
extern "C" {
    pub static xdp_analyzer_ops: bpf_verifier_ops;
}
extern "C" {
    pub fn bpf_prog_get(ufd: u32_) -> *mut bpf_prog;
}
extern "C" {
    pub fn bpf_prog_get_type_dev(
        ufd: u32_,
        type_: bpf_prog_type,
        attach_drv: bool_,
    ) -> *mut bpf_prog;
}
extern "C" {
    pub fn bpf_prog_add(prog: *mut bpf_prog, i: ffi::c_int);
}
extern "C" {
    pub fn bpf_prog_sub(prog: *mut bpf_prog, i: ffi::c_int);
}
extern "C" {
    pub fn bpf_prog_inc(prog: *mut bpf_prog);
}
extern "C" {
    #[must_use]
    pub fn bpf_prog_inc_not_zero(prog: *mut bpf_prog) -> *mut bpf_prog;
}
extern "C" {
    pub fn bpf_prog_put(prog: *mut bpf_prog);
}
extern "C" {
    pub fn bpf_prog_free_id(prog: *mut bpf_prog);
}
extern "C" {
    pub fn bpf_map_free_id(map: *mut bpf_map);
}
extern "C" {
    pub fn btf_record_find(
        rec: *const btf_record,
        offset: u32_,
        field_mask: u32_,
    ) -> *mut btf_field;
}
extern "C" {
    pub fn btf_record_free(rec: *mut btf_record);
}
extern "C" {
    pub fn bpf_map_free_record(map: *mut bpf_map);
}
extern "C" {
    pub fn btf_record_dup(rec: *const btf_record) -> *mut btf_record;
}
extern "C" {
    pub fn btf_record_equal(rec_a: *const btf_record, rec_b: *const btf_record) -> bool_;
}
extern "C" {
    pub fn bpf_obj_free_timer(rec: *const btf_record, obj: *mut ffi::c_void);
}
extern "C" {
    pub fn bpf_obj_free_workqueue(rec: *const btf_record, obj: *mut ffi::c_void);
}
extern "C" {
    pub fn bpf_obj_free_fields(rec: *const btf_record, obj: *mut ffi::c_void);
}
extern "C" {
    pub fn __bpf_obj_drop_impl(p: *mut ffi::c_void, rec: *const btf_record, percpu: bool_);
}
extern "C" {
    pub fn bpf_map_get(ufd: u32_) -> *mut bpf_map;
}
extern "C" {
    pub fn bpf_map_get_with_uref(ufd: u32_) -> *mut bpf_map;
}
extern "C" {
    pub fn bpf_map_inc(map: *mut bpf_map);
}
extern "C" {
    pub fn bpf_map_inc_with_uref(map: *mut bpf_map);
}
extern "C" {
    pub fn __bpf_map_inc_not_zero(map: *mut bpf_map, uref: bool_) -> *mut bpf_map;
}
extern "C" {
    #[must_use]
    pub fn bpf_map_inc_not_zero(map: *mut bpf_map) -> *mut bpf_map;
}
extern "C" {
    pub fn bpf_map_put_with_uref(map: *mut bpf_map);
}
extern "C" {
    pub fn bpf_map_put(map: *mut bpf_map);
}
extern "C" {
    pub fn bpf_map_area_alloc(size: u64_, numa_node: ffi::c_int) -> *mut ffi::c_void;
}
extern "C" {
    pub fn bpf_map_area_mmapable_alloc(size: u64_, numa_node: ffi::c_int) -> *mut ffi::c_void;
}
extern "C" {
    pub fn bpf_map_area_free(base: *mut ffi::c_void);
}
extern "C" {
    pub fn bpf_map_write_active(map: *const bpf_map) -> bool_;
}
extern "C" {
    pub fn bpf_map_init_from_attr(map: *mut bpf_map, attr: *mut bpf_attr);
}
extern "C" {
    pub fn generic_map_lookup_batch(
        map: *mut bpf_map,
        attr: *const bpf_attr,
        uattr: *mut bpf_attr,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn generic_map_update_batch(
        map: *mut bpf_map,
        map_file: *mut file,
        attr: *const bpf_attr,
        uattr: *mut bpf_attr,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn generic_map_delete_batch(
        map: *mut bpf_map,
        attr: *const bpf_attr,
        uattr: *mut bpf_attr,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_map_get_curr_or_next(id: *mut u32_) -> *mut bpf_map;
}
extern "C" {
    pub fn bpf_prog_get_curr_or_next(id: *mut u32_) -> *mut bpf_prog;
}
extern "C" {
    pub fn bpf_map_alloc_pages(
        map: *const bpf_map,
        nid: ffi::c_int,
        nr_pages: ffi::c_ulong,
        page_array: *mut *mut page,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_map_kmalloc_node(
        map: *const bpf_map,
        size: usize,
        flags: gfp_t,
        node: ffi::c_int,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn bpf_map_kzalloc(map: *const bpf_map, size: usize, flags: gfp_t) -> *mut ffi::c_void;
}
extern "C" {
    pub fn bpf_map_kvcalloc(
        map: *mut bpf_map,
        n: usize,
        size: usize,
        flags: gfp_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn bpf_map_alloc_percpu(
        map: *const bpf_map,
        size: usize,
        align: usize,
        flags: gfp_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub static mut sysctl_unprivileged_bpf_disabled: ffi::c_int;
}
extern "C" {
    pub fn bpf_token_capable(token: *const bpf_token, cap: ffi::c_int) -> bool_;
}
extern "C" {
    pub fn bpf_map_new_fd(map: *mut bpf_map, flags: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_prog_new_fd(prog: *mut bpf_prog) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_link_init(
        link: *mut bpf_link,
        type_: bpf_link_type,
        ops: *const bpf_link_ops,
        prog: *mut bpf_prog,
    );
}
extern "C" {
    pub fn bpf_link_init_sleepable(
        link: *mut bpf_link,
        type_: bpf_link_type,
        ops: *const bpf_link_ops,
        prog: *mut bpf_prog,
        sleepable: bool_,
    );
}
extern "C" {
    pub fn bpf_link_prime(link: *mut bpf_link, primer: *mut bpf_link_primer) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_link_settle(primer: *mut bpf_link_primer) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_link_cleanup(primer: *mut bpf_link_primer);
}
extern "C" {
    pub fn bpf_link_inc(link: *mut bpf_link);
}
extern "C" {
    pub fn bpf_link_inc_not_zero(link: *mut bpf_link) -> *mut bpf_link;
}
extern "C" {
    pub fn bpf_link_put(link: *mut bpf_link);
}
extern "C" {
    pub fn bpf_link_new_fd(link: *mut bpf_link) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_link_get_from_fd(ufd: u32_) -> *mut bpf_link;
}
extern "C" {
    pub fn bpf_link_get_curr_or_next(id: *mut u32_) -> *mut bpf_link;
}
extern "C" {
    pub fn bpf_token_inc(token: *mut bpf_token);
}
extern "C" {
    pub fn bpf_token_put(token: *mut bpf_token);
}
extern "C" {
    pub fn bpf_token_create(attr: *mut bpf_attr) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_token_get_from_fd(ufd: u32_) -> *mut bpf_token;
}
extern "C" {
    pub fn bpf_token_allow_cmd(token: *const bpf_token, cmd: bpf_cmd) -> bool_;
}
extern "C" {
    pub fn bpf_token_allow_map_type(token: *const bpf_token, type_: bpf_map_type) -> bool_;
}
extern "C" {
    pub fn bpf_token_allow_prog_type(
        token: *const bpf_token,
        prog_type: bpf_prog_type,
        attach_type: bpf_attach_type,
    ) -> bool_;
}
extern "C" {
    pub fn bpf_obj_pin_user(
        ufd: u32_,
        path_fd: ffi::c_int,
        pathname: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_obj_get_user(
        path_fd: ffi::c_int,
        pathname: *const ffi::c_char,
        flags: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_get_inode(sb: *mut super_block, dir: *const inode, mode: umode_t) -> *mut inode;
}
pub const bpf_iter_task_type_BPF_TASK_ITER_ALL: bpf_iter_task_type = 0;
pub const bpf_iter_task_type_BPF_TASK_ITER_TID: bpf_iter_task_type = 1;
pub const bpf_iter_task_type_BPF_TASK_ITER_TGID: bpf_iter_task_type = 2;
pub type bpf_iter_task_type = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_iter_aux_info {
    pub map: *mut bpf_map,
    pub cgroup: bpf_iter_aux_info__bindgen_ty_1,
    pub task: bpf_iter_aux_info__bindgen_ty_2,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_iter_aux_info__bindgen_ty_1 {
    pub start: *mut cgroup,
    pub order: bpf_cgroup_iter_order,
}
impl Default for bpf_iter_aux_info__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_iter_aux_info__bindgen_ty_2 {
    pub type_: bpf_iter_task_type,
    pub pid: u32_,
}
impl Default for bpf_iter_aux_info__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for bpf_iter_aux_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type bpf_iter_attach_target_t = ::core::option::Option<
    unsafe extern "C" fn(
        prog: *mut bpf_prog,
        linfo: *mut bpf_iter_link_info,
        aux: *mut bpf_iter_aux_info,
    ) -> ffi::c_int,
>;
pub type bpf_iter_detach_target_t =
    ::core::option::Option<unsafe extern "C" fn(aux: *mut bpf_iter_aux_info)>;
pub type bpf_iter_show_fdinfo_t =
    ::core::option::Option<unsafe extern "C" fn(aux: *const bpf_iter_aux_info, seq: *mut seq_file)>;
pub type bpf_iter_fill_link_info_t = ::core::option::Option<
    unsafe extern "C" fn(aux: *const bpf_iter_aux_info, info: *mut bpf_link_info) -> ffi::c_int,
>;
pub type bpf_iter_get_func_proto_t = ::core::option::Option<
    unsafe extern "C" fn(func_id: bpf_func_id, prog: *const bpf_prog) -> *const bpf_func_proto,
>;
pub const bpf_iter_feature_BPF_ITER_RESCHED: bpf_iter_feature = 1;
pub type bpf_iter_feature = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_iter_reg {
    pub target: *const ffi::c_char,
    pub attach_target: bpf_iter_attach_target_t,
    pub detach_target: bpf_iter_detach_target_t,
    pub show_fdinfo: bpf_iter_show_fdinfo_t,
    pub fill_link_info: bpf_iter_fill_link_info_t,
    pub get_func_proto: bpf_iter_get_func_proto_t,
    pub ctx_arg_info_size: u32_,
    pub feature: u32_,
    pub ctx_arg_info: [bpf_ctx_arg_aux; 2usize],
    pub seq_info: *const bpf_iter_seq_info,
}
impl Default for bpf_iter_reg {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_iter_meta {
    pub __bindgen_anon_1: bpf_iter_meta__bindgen_ty_1,
    pub session_id: u64_,
    pub seq_num: u64_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_iter_meta__bindgen_ty_1 {
    pub seq: *mut seq_file,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
impl Default for bpf_iter_meta__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl bpf_iter_meta__bindgen_ty_1 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
impl Default for bpf_iter_meta {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_iter__bpf_map_elem {
    pub __bindgen_anon_1: bpf_iter__bpf_map_elem__bindgen_ty_1,
    pub __bindgen_anon_2: bpf_iter__bpf_map_elem__bindgen_ty_2,
    pub __bindgen_anon_3: bpf_iter__bpf_map_elem__bindgen_ty_3,
    pub __bindgen_anon_4: bpf_iter__bpf_map_elem__bindgen_ty_4,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_iter__bpf_map_elem__bindgen_ty_1 {
    pub meta: *mut bpf_iter_meta,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
impl Default for bpf_iter__bpf_map_elem__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl bpf_iter__bpf_map_elem__bindgen_ty_1 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_iter__bpf_map_elem__bindgen_ty_2 {
    pub map: *mut bpf_map,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
impl Default for bpf_iter__bpf_map_elem__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl bpf_iter__bpf_map_elem__bindgen_ty_2 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_iter__bpf_map_elem__bindgen_ty_3 {
    pub key: *mut ffi::c_void,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
impl Default for bpf_iter__bpf_map_elem__bindgen_ty_3 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl bpf_iter__bpf_map_elem__bindgen_ty_3 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union bpf_iter__bpf_map_elem__bindgen_ty_4 {
    pub value: *mut ffi::c_void,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
impl Default for bpf_iter__bpf_map_elem__bindgen_ty_4 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl bpf_iter__bpf_map_elem__bindgen_ty_4 {
    #[inline]
    pub fn new_bitfield_1() -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit
    }
}
impl Default for bpf_iter__bpf_map_elem {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn bpf_iter_reg_target(reg_info: *const bpf_iter_reg) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_iter_unreg_target(reg_info: *const bpf_iter_reg);
}
extern "C" {
    pub fn bpf_iter_prog_supported(prog: *mut bpf_prog) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_iter_get_func_proto(
        func_id: bpf_func_id,
        prog: *const bpf_prog,
    ) -> *const bpf_func_proto;
}
extern "C" {
    pub fn bpf_iter_link_attach(
        attr: *const bpf_attr,
        uattr: bpfptr_t,
        prog: *mut bpf_prog,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_iter_new_fd(link: *mut bpf_link) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_link_is_iter(link: *mut bpf_link) -> bool_;
}
extern "C" {
    pub fn bpf_iter_get_info(meta: *mut bpf_iter_meta, in_stop: bool_) -> *mut bpf_prog;
}
extern "C" {
    pub fn bpf_iter_run_prog(prog: *mut bpf_prog, ctx: *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_iter_map_show_fdinfo(aux: *const bpf_iter_aux_info, seq: *mut seq_file);
}
extern "C" {
    pub fn bpf_iter_map_fill_link_info(
        aux: *const bpf_iter_aux_info,
        info: *mut bpf_link_info,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn map_set_for_each_callback_args(
        env: *mut bpf_verifier_env,
        caller: *mut bpf_func_state,
        callee: *mut bpf_func_state,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_percpu_hash_copy(
        map: *mut bpf_map,
        key: *mut ffi::c_void,
        value: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_percpu_array_copy(
        map: *mut bpf_map,
        key: *mut ffi::c_void,
        value: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_percpu_hash_update(
        map: *mut bpf_map,
        key: *mut ffi::c_void,
        value: *mut ffi::c_void,
        flags: u64_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_percpu_array_update(
        map: *mut bpf_map,
        key: *mut ffi::c_void,
        value: *mut ffi::c_void,
        flags: u64_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_stackmap_copy(
        map: *mut bpf_map,
        key: *mut ffi::c_void,
        value: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_fd_array_map_update_elem(
        map: *mut bpf_map,
        map_file: *mut file,
        key: *mut ffi::c_void,
        value: *mut ffi::c_void,
        map_flags: u64_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_fd_array_map_lookup_elem(
        map: *mut bpf_map,
        key: *mut ffi::c_void,
        value: *mut u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_fd_htab_map_update_elem(
        map: *mut bpf_map,
        map_file: *mut file,
        key: *mut ffi::c_void,
        value: *mut ffi::c_void,
        map_flags: u64_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_fd_htab_map_lookup_elem(
        map: *mut bpf_map,
        key: *mut ffi::c_void,
        value: *mut u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_get_file_flag(flags: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_check_uarg_tail_zero(
        uaddr: bpfptr_t,
        expected_size: usize,
        actual_size: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_check(
        fp: *mut *mut bpf_prog,
        attr: *mut bpf_attr,
        uattr: bpfptr_t,
        uattr_size: u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_get_btf_vmlinux() -> *mut btf;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct xdp_frame {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_dtab_netdev {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_cpu_map_entry {
    _unused: [u8; 0],
}
extern "C" {
    pub fn __dev_flush(flush_list: *mut list_head);
}
extern "C" {
    pub fn dev_xdp_enqueue(
        dev: *mut net_device,
        xdpf: *mut xdp_frame,
        dev_rx: *mut net_device,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn dev_map_enqueue(
        dst: *mut bpf_dtab_netdev,
        xdpf: *mut xdp_frame,
        dev_rx: *mut net_device,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn dev_map_enqueue_multi(
        xdpf: *mut xdp_frame,
        dev_rx: *mut net_device,
        map: *mut bpf_map,
        exclude_ingress: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn dev_map_generic_redirect(
        dst: *mut bpf_dtab_netdev,
        skb: *mut sk_buff,
        xdp_prog: *const bpf_prog,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn dev_map_redirect_multi(
        dev: *mut net_device,
        skb: *mut sk_buff,
        xdp_prog: *const bpf_prog,
        map: *mut bpf_map,
        exclude_ingress: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __cpu_map_flush(flush_list: *mut list_head);
}
extern "C" {
    pub fn cpu_map_enqueue(
        rcpu: *mut bpf_cpu_map_entry,
        xdpf: *mut xdp_frame,
        dev_rx: *mut net_device,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn cpu_map_generic_redirect(rcpu: *mut bpf_cpu_map_entry, skb: *mut sk_buff) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_prog_get_type_path(name: *const ffi::c_char, type_: bpf_prog_type) -> *mut bpf_prog;
}
extern "C" {
    pub fn array_map_alloc_check(attr: *mut bpf_attr) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_prog_test_run_xdp(
        prog: *mut bpf_prog,
        kattr: *const bpf_attr,
        uattr: *mut bpf_attr,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_prog_test_run_skb(
        prog: *mut bpf_prog,
        kattr: *const bpf_attr,
        uattr: *mut bpf_attr,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_prog_test_run_tracing(
        prog: *mut bpf_prog,
        kattr: *const bpf_attr,
        uattr: *mut bpf_attr,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_prog_test_run_flow_dissector(
        prog: *mut bpf_prog,
        kattr: *const bpf_attr,
        uattr: *mut bpf_attr,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_prog_test_run_raw_tp(
        prog: *mut bpf_prog,
        kattr: *const bpf_attr,
        uattr: *mut bpf_attr,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_prog_test_run_sk_lookup(
        prog: *mut bpf_prog,
        kattr: *const bpf_attr,
        uattr: *mut bpf_attr,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_prog_test_run_nf(
        prog: *mut bpf_prog,
        kattr: *const bpf_attr,
        uattr: *mut bpf_attr,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn btf_ctx_access(
        off: ffi::c_int,
        size: ffi::c_int,
        type_: bpf_access_type,
        prog: *const bpf_prog,
        info: *mut bpf_insn_access_aux,
    ) -> bool_;
}
extern "C" {
    pub fn btf_struct_access(
        log: *mut bpf_verifier_log,
        reg: *const bpf_reg_state,
        off: ffi::c_int,
        size: ffi::c_int,
        atype: bpf_access_type,
        next_btf_id: *mut u32_,
        flag: *mut bpf_type_flag,
        field_name: *mut *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn btf_struct_ids_match(
        log: *mut bpf_verifier_log,
        btf: *const btf,
        id: u32_,
        off: ffi::c_int,
        need_btf: *const btf,
        need_type_id: u32_,
        strict: bool_,
    ) -> bool_;
}
extern "C" {
    pub fn btf_distill_func_proto(
        log: *mut bpf_verifier_log,
        btf: *mut btf,
        func_proto: *const btf_type,
        func_name: *const ffi::c_char,
        m: *mut btf_func_model,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn btf_prepare_func_args(env: *mut bpf_verifier_env, subprog: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn btf_check_type_match(
        log: *mut bpf_verifier_log,
        prog: *const bpf_prog,
        btf: *mut btf,
        t: *const btf_type,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn btf_find_decl_tag_value(
        btf: *const btf,
        pt: *const btf_type,
        comp_idx: ffi::c_int,
        tag_key: *const ffi::c_char,
    ) -> *const ffi::c_char;
}
extern "C" {
    pub fn btf_find_next_decl_tag(
        btf: *const btf,
        pt: *const btf_type,
        comp_idx: ffi::c_int,
        tag_key: *const ffi::c_char,
        last_id: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_prog_by_id(id: u32_) -> *mut bpf_prog;
}
extern "C" {
    pub fn bpf_link_by_id(id: u32_) -> *mut bpf_link;
}
extern "C" {
    pub fn bpf_base_func_proto(
        func_id: bpf_func_id,
        prog: *const bpf_prog,
    ) -> *const bpf_func_proto;
}
extern "C" {
    pub fn bpf_task_storage_free(task: *mut task_struct);
}
extern "C" {
    pub fn bpf_cgrp_storage_free(cgroup: *mut cgroup);
}
extern "C" {
    pub fn bpf_prog_has_kfunc_call(prog: *const bpf_prog) -> bool_;
}
extern "C" {
    pub fn bpf_jit_find_kfunc_model(
        prog: *const bpf_prog,
        insn: *const bpf_insn,
    ) -> *const btf_func_model;
}
extern "C" {
    pub fn bpf_get_kfunc_addr(
        prog: *const bpf_prog,
        func_id: u32_,
        btf_fd_idx: u16_,
        func_addr: *mut *mut u8_,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_core_ctx {
    pub log: *mut bpf_verifier_log,
    pub btf: *const btf,
}
impl Default for bpf_core_ctx {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn btf_nested_type_is_trusted(
        log: *mut bpf_verifier_log,
        reg: *const bpf_reg_state,
        field_name: *const ffi::c_char,
        btf_id: u32_,
        suffix: *const ffi::c_char,
    ) -> bool_;
}
extern "C" {
    pub fn btf_type_ids_nocast_alias(
        log: *mut bpf_verifier_log,
        reg_btf: *const btf,
        reg_id: u32_,
        arg_btf: *const btf,
        arg_id: u32_,
    ) -> bool_;
}
extern "C" {
    pub fn bpf_core_apply(
        ctx: *mut bpf_core_ctx,
        relo: *const bpf_core_relo,
        relo_idx: ffi::c_int,
        insn: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_prog_inc_misses_counter(prog: *mut bpf_prog);
}
extern "C" {
    pub fn bpf_dynptr_init(
        ptr: *mut bpf_dynptr_kern,
        data: *mut ffi::c_void,
        type_: bpf_dynptr_type,
        offset: u32_,
        size: u32_,
    );
}
extern "C" {
    pub fn bpf_dynptr_set_null(ptr: *mut bpf_dynptr_kern);
}
extern "C" {
    pub fn bpf_dynptr_set_rdonly(ptr: *mut bpf_dynptr_kern);
}
extern "C" {
    pub fn __bpf_free_used_btfs(used_btfs: *mut btf_mod_pair, len: u32_);
}
extern "C" {
    pub fn __bpf_free_used_maps(aux: *mut bpf_prog_aux, used_maps: *mut *mut bpf_map, len: u32_);
}
extern "C" {
    pub fn bpf_prog_get_ok(arg1: *mut bpf_prog, arg2: *mut bpf_prog_type, arg3: bool_) -> bool_;
}
extern "C" {
    pub fn bpf_prog_offload_compile(prog: *mut bpf_prog) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_prog_dev_bound_destroy(prog: *mut bpf_prog);
}
extern "C" {
    pub fn bpf_prog_offload_info_fill(info: *mut bpf_prog_info, prog: *mut bpf_prog) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_map_offload_info_fill(info: *mut bpf_map_info, map: *mut bpf_map) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_map_offload_lookup_elem(
        map: *mut bpf_map,
        key: *mut ffi::c_void,
        value: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_map_offload_update_elem(
        map: *mut bpf_map,
        key: *mut ffi::c_void,
        value: *mut ffi::c_void,
        flags: u64_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_map_offload_delete_elem(map: *mut bpf_map, key: *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_map_offload_get_next_key(
        map: *mut bpf_map,
        key: *mut ffi::c_void,
        next_key: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_offload_prog_map_match(prog: *mut bpf_prog, map: *mut bpf_map) -> bool_;
}
extern "C" {
    pub fn bpf_offload_dev_create(
        ops: *const bpf_prog_offload_ops,
        priv_: *mut ffi::c_void,
    ) -> *mut bpf_offload_dev;
}
extern "C" {
    pub fn bpf_offload_dev_destroy(offdev: *mut bpf_offload_dev);
}
extern "C" {
    pub fn bpf_offload_dev_priv(offdev: *mut bpf_offload_dev) -> *mut ffi::c_void;
}
extern "C" {
    pub fn bpf_offload_dev_netdev_register(
        offdev: *mut bpf_offload_dev,
        netdev: *mut net_device,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_offload_dev_netdev_unregister(offdev: *mut bpf_offload_dev, netdev: *mut net_device);
}
extern "C" {
    pub fn bpf_offload_dev_match(prog: *mut bpf_prog, netdev: *mut net_device) -> bool_;
}
extern "C" {
    pub fn unpriv_ebpf_notify(new_state: ffi::c_int);
}
extern "C" {
    pub fn bpf_dev_bound_kfunc_check(
        log: *mut bpf_verifier_log,
        prog_aux: *mut bpf_prog_aux,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_dev_bound_resolve_kfunc(prog: *mut bpf_prog, func_id: u32_) -> *mut ffi::c_void;
}
extern "C" {
    pub fn bpf_prog_dev_bound_init(prog: *mut bpf_prog, attr: *mut bpf_attr) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_prog_dev_bound_inherit(
        new_prog: *mut bpf_prog,
        old_prog: *mut bpf_prog,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_dev_bound_netdev_unregister(dev: *mut net_device);
}
extern "C" {
    pub fn bpf_prog_dev_bound_match(lhs: *const bpf_prog, rhs: *const bpf_prog) -> bool_;
}
extern "C" {
    pub fn bpf_map_offload_map_alloc(attr: *mut bpf_attr) -> *mut bpf_map;
}
extern "C" {
    pub fn bpf_map_offload_map_free(map: *mut bpf_map);
}
extern "C" {
    pub fn bpf_map_offload_map_mem_usage(map: *const bpf_map) -> u64_;
}
extern "C" {
    pub fn bpf_prog_test_run_syscall(
        prog: *mut bpf_prog,
        kattr: *const bpf_attr,
        uattr: *mut bpf_attr,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sock_map_get_from_fd(attr: *const bpf_attr, prog: *mut bpf_prog) -> ffi::c_int;
}
extern "C" {
    pub fn sock_map_prog_detach(attr: *const bpf_attr, ptype: bpf_prog_type) -> ffi::c_int;
}
extern "C" {
    pub fn sock_map_update_elem_sys(
        map: *mut bpf_map,
        key: *mut ffi::c_void,
        value: *mut ffi::c_void,
        flags: u64_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn sock_map_bpf_prog_query(attr: *const bpf_attr, uattr: *mut bpf_attr) -> ffi::c_int;
}
extern "C" {
    pub fn sock_map_link_create(attr: *const bpf_attr, prog: *mut bpf_prog) -> ffi::c_int;
}
extern "C" {
    pub fn sock_map_unhash(sk: *mut sock);
}
extern "C" {
    pub fn sock_map_destroy(sk: *mut sock);
}
extern "C" {
    pub fn sock_map_close(sk: *mut sock, timeout: ffi::c_long);
}
extern "C" {
    pub fn bpf_sk_reuseport_detach(sk: *mut sock);
}
extern "C" {
    pub fn bpf_fd_reuseport_array_lookup_elem(
        map: *mut bpf_map,
        key: *mut ffi::c_void,
        value: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_fd_reuseport_array_update_elem(
        map: *mut bpf_map,
        key: *mut ffi::c_void,
        value: *mut ffi::c_void,
        map_flags: u64_,
    ) -> ffi::c_int;
}
extern "C" {
    pub static bpf_map_lookup_elem_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_map_update_elem_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_map_delete_elem_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_map_push_elem_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_map_pop_elem_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_map_peek_elem_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_map_lookup_percpu_elem_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_get_prandom_u32_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_get_smp_processor_id_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_get_numa_node_id_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_tail_call_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_ktime_get_ns_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_ktime_get_boot_ns_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_ktime_get_tai_ns_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_get_current_pid_tgid_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_get_current_uid_gid_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_get_current_comm_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_get_stackid_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_get_stack_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_get_stack_sleepable_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_get_task_stack_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_get_task_stack_sleepable_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_get_stackid_proto_pe: bpf_func_proto;
}
extern "C" {
    pub static bpf_get_stack_proto_pe: bpf_func_proto;
}
extern "C" {
    pub static bpf_sock_map_update_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_sock_hash_update_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_get_current_cgroup_id_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_get_current_ancestor_cgroup_id_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_get_cgroup_classid_curr_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_current_task_under_cgroup_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_msg_redirect_hash_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_msg_redirect_map_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_sk_redirect_hash_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_sk_redirect_map_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_spin_lock_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_spin_unlock_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_get_local_storage_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_strtol_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_strtoul_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_tcp_sock_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_jiffies64_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_get_ns_current_pid_tgid_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_event_output_data_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_ringbuf_output_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_ringbuf_reserve_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_ringbuf_submit_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_ringbuf_discard_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_ringbuf_query_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_ringbuf_reserve_dynptr_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_ringbuf_submit_dynptr_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_ringbuf_discard_dynptr_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_skc_to_tcp6_sock_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_skc_to_tcp_sock_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_skc_to_tcp_timewait_sock_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_skc_to_tcp_request_sock_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_skc_to_udp6_sock_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_skc_to_unix_sock_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_skc_to_mptcp_sock_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_copy_from_user_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_snprintf_btf_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_snprintf_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_per_cpu_ptr_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_this_cpu_ptr_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_ktime_get_coarse_ns_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_sock_from_file_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_get_socket_ptr_cookie_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_task_storage_get_recur_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_task_storage_get_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_task_storage_delete_recur_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_task_storage_delete_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_for_each_map_elem_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_btf_find_by_name_kind_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_sk_setsockopt_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_sk_getsockopt_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_unlocked_sk_setsockopt_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_unlocked_sk_getsockopt_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_find_vma_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_loop_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_copy_from_user_task_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_set_retval_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_get_retval_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_user_ringbuf_drain_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_cgrp_storage_get_proto: bpf_func_proto;
}
extern "C" {
    pub static bpf_cgrp_storage_delete_proto: bpf_func_proto;
}
extern "C" {
    pub fn tracing_prog_func_proto(
        func_id: bpf_func_id,
        prog: *const bpf_prog,
    ) -> *const bpf_func_proto;
}
extern "C" {
    pub fn bpf_user_rnd_init_once();
}
extern "C" {
    pub fn bpf_user_rnd_u32(r1: u64_, r2: u64_, r3: u64_, r4: u64_, r5: u64_) -> u64_;
}
extern "C" {
    pub fn bpf_get_raw_cpu_id(r1: u64_, r2: u64_, r3: u64_, r4: u64_, r5: u64_) -> u64_;
}
extern "C" {
    pub fn bpf_sock_common_is_valid_access(
        off: ffi::c_int,
        size: ffi::c_int,
        type_: bpf_access_type,
        info: *mut bpf_insn_access_aux,
    ) -> bool_;
}
extern "C" {
    pub fn bpf_sock_is_valid_access(
        off: ffi::c_int,
        size: ffi::c_int,
        type_: bpf_access_type,
        info: *mut bpf_insn_access_aux,
    ) -> bool_;
}
extern "C" {
    pub fn bpf_sock_convert_ctx_access(
        type_: bpf_access_type,
        si: *const bpf_insn,
        insn_buf: *mut bpf_insn,
        prog: *mut bpf_prog,
        target_size: *mut u32_,
    ) -> u32_;
}
extern "C" {
    pub fn bpf_dynptr_from_skb_rdonly(
        skb: *mut __sk_buff,
        flags: u64_,
        ptr: *mut bpf_dynptr,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sk_reuseport_kern {
    pub skb: *mut sk_buff,
    pub sk: *mut sock,
    pub selected_sk: *mut sock,
    pub migrating_sk: *mut sock,
    pub data_end: *mut ffi::c_void,
    pub hash: u32_,
    pub reuseport_id: u32_,
    pub bind_inany: bool_,
}
impl Default for sk_reuseport_kern {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn bpf_tcp_sock_is_valid_access(
        off: ffi::c_int,
        size: ffi::c_int,
        type_: bpf_access_type,
        info: *mut bpf_insn_access_aux,
    ) -> bool_;
}
extern "C" {
    pub fn bpf_tcp_sock_convert_ctx_access(
        type_: bpf_access_type,
        si: *const bpf_insn,
        insn_buf: *mut bpf_insn,
        prog: *mut bpf_prog,
        target_size: *mut u32_,
    ) -> u32_;
}
extern "C" {
    pub fn bpf_xdp_sock_is_valid_access(
        off: ffi::c_int,
        size: ffi::c_int,
        type_: bpf_access_type,
        info: *mut bpf_insn_access_aux,
    ) -> bool_;
}
extern "C" {
    pub fn bpf_xdp_sock_convert_ctx_access(
        type_: bpf_access_type,
        si: *const bpf_insn,
        insn_buf: *mut bpf_insn,
        prog: *mut bpf_prog,
        target_size: *mut u32_,
    ) -> u32_;
}
pub const bpf_text_poke_type_BPF_MOD_CALL: bpf_text_poke_type = 0;
pub const bpf_text_poke_type_BPF_MOD_JUMP: bpf_text_poke_type = 1;
pub type bpf_text_poke_type = ffi::c_uint;
extern "C" {
    pub fn bpf_arch_text_poke(
        ip: *mut ffi::c_void,
        t: bpf_text_poke_type,
        addr1: *mut ffi::c_void,
        addr2: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_arch_poke_desc_update(
        poke: *mut bpf_jit_poke_descriptor,
        new: *mut bpf_prog,
        old: *mut bpf_prog,
    );
}
extern "C" {
    pub fn bpf_arch_text_copy(
        dst: *mut ffi::c_void,
        src: *mut ffi::c_void,
        len: usize,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn bpf_arch_text_invalidate(dst: *mut ffi::c_void, len: usize) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_bprintf_data {
    pub bin_args: *mut u32_,
    pub buf: *mut ffi::c_char,
    pub get_bin_args: bool_,
    pub get_buf: bool_,
}
impl Default for bpf_bprintf_data {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn bpf_bprintf_prepare(
        fmt: *mut ffi::c_char,
        fmt_size: u32_,
        raw_args: *const u64_,
        num_args: u32_,
        data: *mut bpf_bprintf_data,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn bpf_bprintf_cleanup(data: *mut bpf_bprintf_data);
}
extern "C" {
    pub fn bpf_cgroup_atype_get(attach_btf_id: u32_, cgroup_atype: ffi::c_int);
}
extern "C" {
    pub fn bpf_cgroup_atype_put(cgroup_atype: ffi::c_int);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct bpf_key {
    pub key: *mut key,
    pub has_ref: bool_,
}
impl Default for bpf_key {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default)]
pub struct lsm_ctx {
    pub id: __u64,
    pub flags: __u64,
    pub len: __u64,
    pub ctx_len: __u64,
    pub ctx: __IncompleteArrayField<ffi::c_uchar>,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct lsm_prop_selinux {
    pub secid: u32_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct smack_known {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct lsm_prop_smack {}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct aa_label {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct lsm_prop_apparmor {}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct lsm_prop_bpf {
    pub secid: u32_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct msg_msg {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct xattr {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct xfrm_sec_ctx {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fs_parameter {
    _unused: [u8; 0],
}
pub type fs_value_type = i32;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct watch {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct watch_notification {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct audit_krule {
    _unused: [u8; 0],
}
pub const lsm_event_LSM_POLICY_CHANGE: lsm_event = 0;
pub type lsm_event = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct dm_verity_digest {
    pub alg: *const ffi::c_char,
    pub digest: *const u8_,
    pub digest_len: usize,
}
impl Default for dm_verity_digest {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const lsm_integrity_type_LSM_INT_DMVERITY_SIG_VALID: lsm_integrity_type = 0;
pub const lsm_integrity_type_LSM_INT_DMVERITY_ROOTHASH: lsm_integrity_type = 1;
pub const lsm_integrity_type_LSM_INT_FSVERITY_BUILTINSIG_VALID: lsm_integrity_type = 2;
pub type lsm_integrity_type = ffi::c_uint;
pub const lockdown_reason_LOCKDOWN_NONE: lockdown_reason = 0;
pub const lockdown_reason_LOCKDOWN_MODULE_SIGNATURE: lockdown_reason = 1;
pub const lockdown_reason_LOCKDOWN_DEV_MEM: lockdown_reason = 2;
pub const lockdown_reason_LOCKDOWN_EFI_TEST: lockdown_reason = 3;
pub const lockdown_reason_LOCKDOWN_KEXEC: lockdown_reason = 4;
pub const lockdown_reason_LOCKDOWN_HIBERNATION: lockdown_reason = 5;
pub const lockdown_reason_LOCKDOWN_PCI_ACCESS: lockdown_reason = 6;
pub const lockdown_reason_LOCKDOWN_IOPORT: lockdown_reason = 7;
pub const lockdown_reason_LOCKDOWN_MSR: lockdown_reason = 8;
pub const lockdown_reason_LOCKDOWN_ACPI_TABLES: lockdown_reason = 9;
pub const lockdown_reason_LOCKDOWN_DEVICE_TREE: lockdown_reason = 10;
pub const lockdown_reason_LOCKDOWN_PCMCIA_CIS: lockdown_reason = 11;
pub const lockdown_reason_LOCKDOWN_TIOCSSERIAL: lockdown_reason = 12;
pub const lockdown_reason_LOCKDOWN_MODULE_PARAMETERS: lockdown_reason = 13;
pub const lockdown_reason_LOCKDOWN_MMIOTRACE: lockdown_reason = 14;
pub const lockdown_reason_LOCKDOWN_DEBUGFS: lockdown_reason = 15;
pub const lockdown_reason_LOCKDOWN_XMON_WR: lockdown_reason = 16;
pub const lockdown_reason_LOCKDOWN_BPF_WRITE_USER: lockdown_reason = 17;
pub const lockdown_reason_LOCKDOWN_DBG_WRITE_KERNEL: lockdown_reason = 18;
pub const lockdown_reason_LOCKDOWN_RTAS_ERROR_INJECTION: lockdown_reason = 19;
pub const lockdown_reason_LOCKDOWN_INTEGRITY_MAX: lockdown_reason = 20;
pub const lockdown_reason_LOCKDOWN_KCORE: lockdown_reason = 21;
pub const lockdown_reason_LOCKDOWN_KPROBES: lockdown_reason = 22;
pub const lockdown_reason_LOCKDOWN_BPF_READ_KERNEL: lockdown_reason = 23;
pub const lockdown_reason_LOCKDOWN_DBG_READ_KERNEL: lockdown_reason = 24;
pub const lockdown_reason_LOCKDOWN_PERF: lockdown_reason = 25;
pub const lockdown_reason_LOCKDOWN_TRACEFS: lockdown_reason = 26;
pub const lockdown_reason_LOCKDOWN_XMON_RW: lockdown_reason = 27;
pub const lockdown_reason_LOCKDOWN_XFRM_SECRET: lockdown_reason = 28;
pub const lockdown_reason_LOCKDOWN_CONFIDENTIALITY_MAX: lockdown_reason = 29;
pub type lockdown_reason = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct lsm_prop {
    pub selinux: lsm_prop_selinux,
    pub smack: lsm_prop_smack,
    pub apparmor: lsm_prop_apparmor,
    pub bpf: lsm_prop_bpf,
}
extern "C" {
    pub static lockdown_reasons: [*const ffi::c_char; 30usize];
}
extern "C" {
    pub static mut lsm_active_cnt: u32_;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct lsm_id {
    _unused: [u8; 0],
}
extern "C" {
    pub static mut lsm_idlist: [*const lsm_id; 0usize];
}
extern "C" {
    pub fn cap_capable(
        cred: *const cred,
        ns: *mut user_namespace,
        cap: ffi::c_int,
        opts: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn cap_settime(ts: *const timespec64, tz: *const timezone) -> ffi::c_int;
}
extern "C" {
    pub fn cap_ptrace_access_check(child: *mut task_struct, mode: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn cap_ptrace_traceme(parent: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn cap_capget(
        target: *const task_struct,
        effective: *mut kernel_cap_t,
        inheritable: *mut kernel_cap_t,
        permitted: *mut kernel_cap_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn cap_capset(
        new: *mut cred,
        old: *const cred,
        effective: *const kernel_cap_t,
        inheritable: *const kernel_cap_t,
        permitted: *const kernel_cap_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn cap_bprm_creds_from_file(bprm: *mut linux_binprm, file: *const file) -> ffi::c_int;
}
extern "C" {
    pub fn cap_inode_setxattr(
        dentry: *mut dentry,
        name: *const ffi::c_char,
        value: *const ffi::c_void,
        size: usize,
        flags: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn cap_inode_removexattr(
        idmap: *mut mnt_idmap,
        dentry: *mut dentry,
        name: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn cap_inode_need_killpriv(dentry: *mut dentry) -> ffi::c_int;
}
extern "C" {
    pub fn cap_inode_killpriv(idmap: *mut mnt_idmap, dentry: *mut dentry) -> ffi::c_int;
}
extern "C" {
    pub fn cap_inode_getsecurity(
        idmap: *mut mnt_idmap,
        inode: *mut inode,
        name: *const ffi::c_char,
        buffer: *mut *mut ffi::c_void,
        alloc: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn cap_mmap_addr(addr: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn cap_mmap_file(
        file: *mut file,
        reqprot: ffi::c_ulong,
        prot: ffi::c_ulong,
        flags: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn cap_task_fix_setuid(new: *mut cred, old: *const cred, flags: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn cap_task_prctl(
        option: ffi::c_int,
        arg2: ffi::c_ulong,
        arg3: ffi::c_ulong,
        arg4: ffi::c_ulong,
        arg5: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn cap_task_setscheduler(p: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn cap_task_setioprio(p: *mut task_struct, ioprio: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn cap_task_setnice(p: *mut task_struct, nice: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn cap_vm_enough_memory(mm: *mut mm_struct, pages: ffi::c_long) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct xfrm_selector {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct xfrm_policy {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct xfrm_state {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct xfrm_user_sec_ctx {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sctp_association {
    _unused: [u8; 0],
}
extern "C" {
    pub static mut mmap_min_addr: ffi::c_ulong;
}
extern "C" {
    pub static mut dac_mmap_min_addr: ffi::c_ulong;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct lsm_context {
    pub context: *mut ffi::c_char,
    pub len: u32_,
    pub id: ffi::c_int,
}
impl Default for lsm_context {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct request_sock {
    _unused: [u8; 0],
}
extern "C" {
    pub fn mmap_min_addr_handler(
        table: *const ctl_table,
        write: ffi::c_int,
        buffer: *mut ffi::c_void,
        lenp: *mut usize,
        ppos: *mut loff_t,
    ) -> ffi::c_int;
}
pub type initxattrs = ::core::option::Option<
    unsafe extern "C" fn(
        inode: *mut inode,
        xattr_array: *const xattr,
        fs_data: *mut ffi::c_void,
    ) -> ffi::c_int,
>;
pub const kernel_load_data_id_LOADING_UNKNOWN: kernel_load_data_id = 0;
pub const kernel_load_data_id_LOADING_FIRMWARE: kernel_load_data_id = 1;
pub const kernel_load_data_id_LOADING_MODULE: kernel_load_data_id = 2;
pub const kernel_load_data_id_LOADING_KEXEC_IMAGE: kernel_load_data_id = 3;
pub const kernel_load_data_id_LOADING_KEXEC_INITRAMFS: kernel_load_data_id = 4;
pub const kernel_load_data_id_LOADING_POLICY: kernel_load_data_id = 5;
pub const kernel_load_data_id_LOADING_X509_CERTIFICATE: kernel_load_data_id = 6;
pub const kernel_load_data_id_LOADING_MAX_ID: kernel_load_data_id = 7;
pub type kernel_load_data_id = ffi::c_uint;
extern "C" {
    pub static kernel_load_data_str: [*const ffi::c_char; 8usize];
}
extern "C" {
    pub fn call_blocking_lsm_notifier(event: lsm_event, data: *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn register_blocking_lsm_notifier(nb: *mut notifier_block) -> ffi::c_int;
}
extern "C" {
    pub fn unregister_blocking_lsm_notifier(nb: *mut notifier_block) -> ffi::c_int;
}
extern "C" {
    pub fn security_init() -> ffi::c_int;
}
extern "C" {
    pub fn early_security_init() -> ffi::c_int;
}
extern "C" {
    pub fn lsm_name_to_attr(name: *const ffi::c_char) -> u64_;
}
extern "C" {
    pub fn security_binder_set_context_mgr(mgr: *const cred) -> ffi::c_int;
}
extern "C" {
    pub fn security_binder_transaction(from: *const cred, to: *const cred) -> ffi::c_int;
}
extern "C" {
    pub fn security_binder_transfer_binder(from: *const cred, to: *const cred) -> ffi::c_int;
}
extern "C" {
    pub fn security_binder_transfer_file(
        from: *const cred,
        to: *const cred,
        file: *const file,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_ptrace_access_check(child: *mut task_struct, mode: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn security_ptrace_traceme(parent: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn security_capget(
        target: *const task_struct,
        effective: *mut kernel_cap_t,
        inheritable: *mut kernel_cap_t,
        permitted: *mut kernel_cap_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_capset(
        new: *mut cred,
        old: *const cred,
        effective: *const kernel_cap_t,
        inheritable: *const kernel_cap_t,
        permitted: *const kernel_cap_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_capable(
        cred: *const cred,
        ns: *mut user_namespace,
        cap: ffi::c_int,
        opts: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_quotactl(
        cmds: ffi::c_int,
        type_: ffi::c_int,
        id: ffi::c_int,
        sb: *const super_block,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_quota_on(dentry: *mut dentry) -> ffi::c_int;
}
extern "C" {
    pub fn security_syslog(type_: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn security_settime64(ts: *const timespec64, tz: *const timezone) -> ffi::c_int;
}
extern "C" {
    pub fn security_vm_enough_memory_mm(mm: *mut mm_struct, pages: ffi::c_long) -> ffi::c_int;
}
extern "C" {
    pub fn security_bprm_creds_for_exec(bprm: *mut linux_binprm) -> ffi::c_int;
}
extern "C" {
    pub fn security_bprm_creds_from_file(bprm: *mut linux_binprm, file: *const file) -> ffi::c_int;
}
extern "C" {
    pub fn security_bprm_check(bprm: *mut linux_binprm) -> ffi::c_int;
}
extern "C" {
    pub fn security_bprm_committing_creds(bprm: *const linux_binprm);
}
extern "C" {
    pub fn security_bprm_committed_creds(bprm: *const linux_binprm);
}
extern "C" {
    pub fn security_fs_context_submount(
        fc: *mut fs_context,
        reference: *mut super_block,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_fs_context_dup(fc: *mut fs_context, src_fc: *mut fs_context) -> ffi::c_int;
}
extern "C" {
    pub fn security_fs_context_parse_param(
        fc: *mut fs_context,
        param: *mut fs_parameter,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_sb_alloc(sb: *mut super_block) -> ffi::c_int;
}
extern "C" {
    pub fn security_sb_delete(sb: *mut super_block);
}
extern "C" {
    pub fn security_sb_free(sb: *mut super_block);
}
extern "C" {
    pub fn security_free_mnt_opts(mnt_opts: *mut *mut ffi::c_void);
}
extern "C" {
    pub fn security_sb_eat_lsm_opts(
        options: *mut ffi::c_char,
        mnt_opts: *mut *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_sb_mnt_opts_compat(
        sb: *mut super_block,
        mnt_opts: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_sb_remount(sb: *mut super_block, mnt_opts: *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn security_sb_kern_mount(sb: *const super_block) -> ffi::c_int;
}
extern "C" {
    pub fn security_sb_show_options(m: *mut seq_file, sb: *mut super_block) -> ffi::c_int;
}
extern "C" {
    pub fn security_sb_statfs(dentry: *mut dentry) -> ffi::c_int;
}
extern "C" {
    pub fn security_sb_mount(
        dev_name: *const ffi::c_char,
        path: *const path,
        type_: *const ffi::c_char,
        flags: ffi::c_ulong,
        data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_sb_umount(mnt: *mut vfsmount, flags: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn security_sb_pivotroot(old_path: *const path, new_path: *const path) -> ffi::c_int;
}
extern "C" {
    pub fn security_sb_set_mnt_opts(
        sb: *mut super_block,
        mnt_opts: *mut ffi::c_void,
        kern_flags: ffi::c_ulong,
        set_kern_flags: *mut ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_sb_clone_mnt_opts(
        oldsb: *const super_block,
        newsb: *mut super_block,
        kern_flags: ffi::c_ulong,
        set_kern_flags: *mut ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_move_mount(from_path: *const path, to_path: *const path) -> ffi::c_int;
}
extern "C" {
    pub fn security_dentry_init_security(
        dentry: *mut dentry,
        mode: ffi::c_int,
        name: *const qstr,
        xattr_name: *mut *const ffi::c_char,
        lsmcxt: *mut lsm_context,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_dentry_create_files_as(
        dentry: *mut dentry,
        mode: ffi::c_int,
        name: *mut qstr,
        old: *const cred,
        new: *mut cred,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_path_notify(path: *const path, mask: u64_, obj_type: ffi::c_uint)
        -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_alloc(inode: *mut inode, gfp: gfp_t) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_free(inode: *mut inode);
}
extern "C" {
    pub fn security_inode_init_security(
        inode: *mut inode,
        dir: *mut inode,
        qstr: *const qstr,
        initxattrs: initxattrs,
        fs_data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_init_security_anon(
        inode: *mut inode,
        name: *const qstr,
        context_inode: *const inode,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_create(dir: *mut inode, dentry: *mut dentry, mode: umode_t)
        -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_post_create_tmpfile(idmap: *mut mnt_idmap, inode: *mut inode);
}
extern "C" {
    pub fn security_inode_link(
        old_dentry: *mut dentry,
        dir: *mut inode,
        new_dentry: *mut dentry,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_unlink(dir: *mut inode, dentry: *mut dentry) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_symlink(
        dir: *mut inode,
        dentry: *mut dentry,
        old_name: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_mkdir(dir: *mut inode, dentry: *mut dentry, mode: umode_t) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_rmdir(dir: *mut inode, dentry: *mut dentry) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_mknod(
        dir: *mut inode,
        dentry: *mut dentry,
        mode: umode_t,
        dev: dev_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_rename(
        old_dir: *mut inode,
        old_dentry: *mut dentry,
        new_dir: *mut inode,
        new_dentry: *mut dentry,
        flags: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_readlink(dentry: *mut dentry) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_follow_link(
        dentry: *mut dentry,
        inode: *mut inode,
        rcu: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_permission(inode: *mut inode, mask: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_setattr(
        idmap: *mut mnt_idmap,
        dentry: *mut dentry,
        attr: *mut iattr,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_post_setattr(
        idmap: *mut mnt_idmap,
        dentry: *mut dentry,
        ia_valid: ffi::c_int,
    );
}
extern "C" {
    pub fn security_inode_getattr(path: *const path) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_setxattr(
        idmap: *mut mnt_idmap,
        dentry: *mut dentry,
        name: *const ffi::c_char,
        value: *const ffi::c_void,
        size: usize,
        flags: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_set_acl(
        idmap: *mut mnt_idmap,
        dentry: *mut dentry,
        acl_name: *const ffi::c_char,
        kacl: *mut posix_acl,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_post_set_acl(
        dentry: *mut dentry,
        acl_name: *const ffi::c_char,
        kacl: *mut posix_acl,
    );
}
extern "C" {
    pub fn security_inode_get_acl(
        idmap: *mut mnt_idmap,
        dentry: *mut dentry,
        acl_name: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_remove_acl(
        idmap: *mut mnt_idmap,
        dentry: *mut dentry,
        acl_name: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_post_remove_acl(
        idmap: *mut mnt_idmap,
        dentry: *mut dentry,
        acl_name: *const ffi::c_char,
    );
}
extern "C" {
    pub fn security_inode_post_setxattr(
        dentry: *mut dentry,
        name: *const ffi::c_char,
        value: *const ffi::c_void,
        size: usize,
        flags: ffi::c_int,
    );
}
extern "C" {
    pub fn security_inode_getxattr(dentry: *mut dentry, name: *const ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_listxattr(dentry: *mut dentry) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_removexattr(
        idmap: *mut mnt_idmap,
        dentry: *mut dentry,
        name: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_post_removexattr(dentry: *mut dentry, name: *const ffi::c_char);
}
extern "C" {
    pub fn security_inode_need_killpriv(dentry: *mut dentry) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_killpriv(idmap: *mut mnt_idmap, dentry: *mut dentry) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_getsecurity(
        idmap: *mut mnt_idmap,
        inode: *mut inode,
        name: *const ffi::c_char,
        buffer: *mut *mut ffi::c_void,
        alloc: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_setsecurity(
        inode: *mut inode,
        name: *const ffi::c_char,
        value: *const ffi::c_void,
        size: usize,
        flags: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_listsecurity(
        inode: *mut inode,
        buffer: *mut ffi::c_char,
        buffer_size: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_getlsmprop(inode: *mut inode, prop: *mut lsm_prop);
}
extern "C" {
    pub fn security_inode_copy_up(src: *mut dentry, new: *mut *mut cred) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_copy_up_xattr(src: *mut dentry, name: *const ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_setintegrity(
        inode: *const inode,
        type_: lsm_integrity_type,
        value: *const ffi::c_void,
        size: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_kernfs_init_security(
        kn_dir: *mut kernfs_node,
        kn: *mut kernfs_node,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_file_permission(file: *mut file, mask: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn security_file_alloc(file: *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn security_file_release(file: *mut file);
}
extern "C" {
    pub fn security_file_free(file: *mut file);
}
extern "C" {
    pub fn security_file_ioctl(file: *mut file, cmd: ffi::c_uint, arg: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn security_file_ioctl_compat(
        file: *mut file,
        cmd: ffi::c_uint,
        arg: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_mmap_file(
        file: *mut file,
        prot: ffi::c_ulong,
        flags: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_mmap_addr(addr: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn security_file_mprotect(
        vma: *mut vm_area_struct,
        reqprot: ffi::c_ulong,
        prot: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_file_lock(file: *mut file, cmd: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn security_file_fcntl(file: *mut file, cmd: ffi::c_uint, arg: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn security_file_set_fowner(file: *mut file);
}
extern "C" {
    pub fn security_file_send_sigiotask(
        tsk: *mut task_struct,
        fown: *mut fown_struct,
        sig: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_file_receive(file: *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn security_file_open(file: *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn security_file_post_open(file: *mut file, mask: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn security_file_truncate(file: *mut file) -> ffi::c_int;
}
extern "C" {
    pub fn security_task_alloc(task: *mut task_struct, clone_flags: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn security_task_free(task: *mut task_struct);
}
extern "C" {
    pub fn security_cred_alloc_blank(cred: *mut cred, gfp: gfp_t) -> ffi::c_int;
}
extern "C" {
    pub fn security_cred_free(cred: *mut cred);
}
extern "C" {
    pub fn security_prepare_creds(new: *mut cred, old: *const cred, gfp: gfp_t) -> ffi::c_int;
}
extern "C" {
    pub fn security_transfer_creds(new: *mut cred, old: *const cred);
}
extern "C" {
    pub fn security_cred_getsecid(c: *const cred, secid: *mut u32_);
}
extern "C" {
    pub fn security_cred_getlsmprop(c: *const cred, prop: *mut lsm_prop);
}
extern "C" {
    pub fn security_kernel_act_as(new: *mut cred, secid: u32_) -> ffi::c_int;
}
extern "C" {
    pub fn security_kernel_create_files_as(new: *mut cred, inode: *mut inode) -> ffi::c_int;
}
extern "C" {
    pub fn security_kernel_module_request(kmod_name: *mut ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub fn security_kernel_load_data(id: kernel_load_data_id, contents: bool_) -> ffi::c_int;
}
extern "C" {
    pub fn security_kernel_post_load_data(
        buf: *mut ffi::c_char,
        size: loff_t,
        id: kernel_load_data_id,
        description: *mut ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_kernel_read_file(
        file: *mut file,
        id: kernel_read_file_id,
        contents: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_kernel_post_read_file(
        file: *mut file,
        buf: *mut ffi::c_char,
        size: loff_t,
        id: kernel_read_file_id,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_task_fix_setuid(
        new: *mut cred,
        old: *const cred,
        flags: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_task_fix_setgid(
        new: *mut cred,
        old: *const cred,
        flags: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_task_fix_setgroups(new: *mut cred, old: *const cred) -> ffi::c_int;
}
extern "C" {
    pub fn security_task_setpgid(p: *mut task_struct, pgid: pid_t) -> ffi::c_int;
}
extern "C" {
    pub fn security_task_getpgid(p: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn security_task_getsid(p: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn security_current_getlsmprop_subj(prop: *mut lsm_prop);
}
extern "C" {
    pub fn security_task_getlsmprop_obj(p: *mut task_struct, prop: *mut lsm_prop);
}
extern "C" {
    pub fn security_task_setnice(p: *mut task_struct, nice: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn security_task_setioprio(p: *mut task_struct, ioprio: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn security_task_getioprio(p: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn security_task_prlimit(
        cred: *const cred,
        tcred: *const cred,
        flags: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_task_setrlimit(
        p: *mut task_struct,
        resource: ffi::c_uint,
        new_rlim: *mut rlimit,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_task_setscheduler(p: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn security_task_getscheduler(p: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn security_task_movememory(p: *mut task_struct) -> ffi::c_int;
}
extern "C" {
    pub fn security_task_kill(
        p: *mut task_struct,
        info: *mut kernel_siginfo,
        sig: ffi::c_int,
        cred: *const cred,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_task_prctl(
        option: ffi::c_int,
        arg2: ffi::c_ulong,
        arg3: ffi::c_ulong,
        arg4: ffi::c_ulong,
        arg5: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_task_to_inode(p: *mut task_struct, inode: *mut inode);
}
extern "C" {
    pub fn security_create_user_ns(cred: *const cred) -> ffi::c_int;
}
extern "C" {
    pub fn security_ipc_permission(ipcp: *mut kern_ipc_perm, flag: ffi::c_short) -> ffi::c_int;
}
extern "C" {
    pub fn security_ipc_getlsmprop(ipcp: *mut kern_ipc_perm, prop: *mut lsm_prop);
}
extern "C" {
    pub fn security_msg_msg_alloc(msg: *mut msg_msg) -> ffi::c_int;
}
extern "C" {
    pub fn security_msg_msg_free(msg: *mut msg_msg);
}
extern "C" {
    pub fn security_msg_queue_alloc(msq: *mut kern_ipc_perm) -> ffi::c_int;
}
extern "C" {
    pub fn security_msg_queue_free(msq: *mut kern_ipc_perm);
}
extern "C" {
    pub fn security_msg_queue_associate(msq: *mut kern_ipc_perm, msqflg: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn security_msg_queue_msgctl(msq: *mut kern_ipc_perm, cmd: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn security_msg_queue_msgsnd(
        msq: *mut kern_ipc_perm,
        msg: *mut msg_msg,
        msqflg: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_msg_queue_msgrcv(
        msq: *mut kern_ipc_perm,
        msg: *mut msg_msg,
        target: *mut task_struct,
        type_: ffi::c_long,
        mode: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_shm_alloc(shp: *mut kern_ipc_perm) -> ffi::c_int;
}
extern "C" {
    pub fn security_shm_free(shp: *mut kern_ipc_perm);
}
extern "C" {
    pub fn security_shm_associate(shp: *mut kern_ipc_perm, shmflg: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn security_shm_shmctl(shp: *mut kern_ipc_perm, cmd: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn security_shm_shmat(
        shp: *mut kern_ipc_perm,
        shmaddr: *mut ffi::c_char,
        shmflg: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_sem_alloc(sma: *mut kern_ipc_perm) -> ffi::c_int;
}
extern "C" {
    pub fn security_sem_free(sma: *mut kern_ipc_perm);
}
extern "C" {
    pub fn security_sem_associate(sma: *mut kern_ipc_perm, semflg: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn security_sem_semctl(sma: *mut kern_ipc_perm, cmd: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn security_sem_semop(
        sma: *mut kern_ipc_perm,
        sops: *mut sembuf,
        nsops: ffi::c_uint,
        alter: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_d_instantiate(dentry: *mut dentry, inode: *mut inode);
}
extern "C" {
    pub fn security_getselfattr(
        attr: ffi::c_uint,
        ctx: *mut lsm_ctx,
        size: *mut u32_,
        flags: u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_setselfattr(
        attr: ffi::c_uint,
        ctx: *mut lsm_ctx,
        size: u32_,
        flags: u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_getprocattr(
        p: *mut task_struct,
        lsmid: ffi::c_int,
        name: *const ffi::c_char,
        value: *mut *mut ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_setprocattr(
        lsmid: ffi::c_int,
        name: *const ffi::c_char,
        value: *mut ffi::c_void,
        size: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_netlink_send(sk: *mut sock, skb: *mut sk_buff) -> ffi::c_int;
}
extern "C" {
    pub fn security_ismaclabel(name: *const ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub fn security_secid_to_secctx(secid: u32_, cp: *mut lsm_context) -> ffi::c_int;
}
extern "C" {
    pub fn security_lsmprop_to_secctx(prop: *mut lsm_prop, cp: *mut lsm_context) -> ffi::c_int;
}
extern "C" {
    pub fn security_secctx_to_secid(
        secdata: *const ffi::c_char,
        seclen: u32_,
        secid: *mut u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_release_secctx(cp: *mut lsm_context);
}
extern "C" {
    pub fn security_inode_invalidate_secctx(inode: *mut inode);
}
extern "C" {
    pub fn security_inode_notifysecctx(
        inode: *mut inode,
        ctx: *mut ffi::c_void,
        ctxlen: u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_setsecctx(
        dentry: *mut dentry,
        ctx: *mut ffi::c_void,
        ctxlen: u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_inode_getsecctx(inode: *mut inode, cp: *mut lsm_context) -> ffi::c_int;
}
extern "C" {
    pub fn security_locked_down(what: lockdown_reason) -> ffi::c_int;
}
extern "C" {
    pub fn lsm_fill_user_ctx(
        uctx: *mut lsm_ctx,
        uctx_len: *mut u32_,
        val: *mut ffi::c_void,
        val_len: usize,
        id: u64_,
        flags: u64_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_bdev_alloc(bdev: *mut block_device) -> ffi::c_int;
}
extern "C" {
    pub fn security_bdev_free(bdev: *mut block_device);
}
extern "C" {
    pub fn security_bdev_setintegrity(
        bdev: *mut block_device,
        type_: lsm_integrity_type,
        value: *const ffi::c_void,
        size: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_post_notification(
        w_cred: *const cred,
        cred: *const cred,
        n: *mut watch_notification,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_watch_key(key: *mut key) -> ffi::c_int;
}
extern "C" {
    pub fn security_unix_stream_connect(
        sock: *mut sock,
        other: *mut sock,
        newsk: *mut sock,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_unix_may_send(sock: *mut socket, other: *mut socket) -> ffi::c_int;
}
extern "C" {
    pub fn security_socket_create(
        family: ffi::c_int,
        type_: ffi::c_int,
        protocol: ffi::c_int,
        kern: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_socket_post_create(
        sock: *mut socket,
        family: ffi::c_int,
        type_: ffi::c_int,
        protocol: ffi::c_int,
        kern: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_socket_socketpair(socka: *mut socket, sockb: *mut socket) -> ffi::c_int;
}
extern "C" {
    pub fn security_socket_bind(
        sock: *mut socket,
        address: *mut sockaddr,
        addrlen: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_socket_connect(
        sock: *mut socket,
        address: *mut sockaddr,
        addrlen: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_socket_listen(sock: *mut socket, backlog: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn security_socket_accept(sock: *mut socket, newsock: *mut socket) -> ffi::c_int;
}
extern "C" {
    pub fn security_socket_sendmsg(
        sock: *mut socket,
        msg: *mut msghdr,
        size: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_socket_recvmsg(
        sock: *mut socket,
        msg: *mut msghdr,
        size: ffi::c_int,
        flags: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_socket_getsockname(sock: *mut socket) -> ffi::c_int;
}
extern "C" {
    pub fn security_socket_getpeername(sock: *mut socket) -> ffi::c_int;
}
extern "C" {
    pub fn security_socket_getsockopt(
        sock: *mut socket,
        level: ffi::c_int,
        optname: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_socket_setsockopt(
        sock: *mut socket,
        level: ffi::c_int,
        optname: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_socket_shutdown(sock: *mut socket, how: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn security_sock_rcv_skb(sk: *mut sock, skb: *mut sk_buff) -> ffi::c_int;
}
extern "C" {
    pub fn security_socket_getpeersec_stream(
        sock: *mut socket,
        optval: sockptr_t,
        optlen: sockptr_t,
        len: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_socket_getpeersec_dgram(
        sock: *mut socket,
        skb: *mut sk_buff,
        secid: *mut u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_sk_alloc(sk: *mut sock, family: ffi::c_int, priority: gfp_t) -> ffi::c_int;
}
extern "C" {
    pub fn security_sk_free(sk: *mut sock);
}
extern "C" {
    pub fn security_sk_clone(sk: *const sock, newsk: *mut sock);
}
extern "C" {
    pub fn security_sk_classify_flow(sk: *const sock, flic: *mut flowi_common);
}
extern "C" {
    pub fn security_req_classify_flow(req: *const request_sock, flic: *mut flowi_common);
}
extern "C" {
    pub fn security_sock_graft(sk: *mut sock, parent: *mut socket);
}
extern "C" {
    pub fn security_inet_conn_request(
        sk: *const sock,
        skb: *mut sk_buff,
        req: *mut request_sock,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_inet_csk_clone(newsk: *mut sock, req: *const request_sock);
}
extern "C" {
    pub fn security_inet_conn_established(sk: *mut sock, skb: *mut sk_buff);
}
extern "C" {
    pub fn security_secmark_relabel_packet(secid: u32_) -> ffi::c_int;
}
extern "C" {
    pub fn security_secmark_refcount_inc();
}
extern "C" {
    pub fn security_secmark_refcount_dec();
}
extern "C" {
    pub fn security_tun_dev_alloc_security(security: *mut *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn security_tun_dev_free_security(security: *mut ffi::c_void);
}
extern "C" {
    pub fn security_tun_dev_create() -> ffi::c_int;
}
extern "C" {
    pub fn security_tun_dev_attach_queue(security: *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn security_tun_dev_attach(sk: *mut sock, security: *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn security_tun_dev_open(security: *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn security_sctp_assoc_request(
        asoc: *mut sctp_association,
        skb: *mut sk_buff,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_sctp_bind_connect(
        sk: *mut sock,
        optname: ffi::c_int,
        address: *mut sockaddr,
        addrlen: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_sctp_sk_clone(asoc: *mut sctp_association, sk: *mut sock, newsk: *mut sock);
}
extern "C" {
    pub fn security_sctp_assoc_established(
        asoc: *mut sctp_association,
        skb: *mut sk_buff,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_mptcp_add_subflow(sk: *mut sock, ssk: *mut sock) -> ffi::c_int;
}
extern "C" {
    pub fn security_ib_pkey_access(
        sec: *mut ffi::c_void,
        subnet_prefix: u64_,
        pkey: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_ib_endport_manage_subnet(
        sec: *mut ffi::c_void,
        name: *const ffi::c_char,
        port_num: u8_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_ib_alloc_security(sec: *mut *mut ffi::c_void) -> ffi::c_int;
}
extern "C" {
    pub fn security_ib_free_security(sec: *mut ffi::c_void);
}
extern "C" {
    pub fn security_xfrm_policy_alloc(
        ctxp: *mut *mut xfrm_sec_ctx,
        sec_ctx: *mut xfrm_user_sec_ctx,
        gfp: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_xfrm_policy_clone(
        old_ctx: *mut xfrm_sec_ctx,
        new_ctxp: *mut *mut xfrm_sec_ctx,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_xfrm_policy_free(ctx: *mut xfrm_sec_ctx);
}
extern "C" {
    pub fn security_xfrm_policy_delete(ctx: *mut xfrm_sec_ctx) -> ffi::c_int;
}
extern "C" {
    pub fn security_xfrm_state_alloc(
        x: *mut xfrm_state,
        sec_ctx: *mut xfrm_user_sec_ctx,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_xfrm_state_alloc_acquire(
        x: *mut xfrm_state,
        polsec: *mut xfrm_sec_ctx,
        secid: u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_xfrm_state_delete(x: *mut xfrm_state) -> ffi::c_int;
}
extern "C" {
    pub fn security_xfrm_state_free(x: *mut xfrm_state);
}
extern "C" {
    pub fn security_xfrm_policy_lookup(ctx: *mut xfrm_sec_ctx, fl_secid: u32_) -> ffi::c_int;
}
extern "C" {
    pub fn security_xfrm_state_pol_flow_match(
        x: *mut xfrm_state,
        xp: *mut xfrm_policy,
        flic: *const flowi_common,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_xfrm_decode_session(skb: *mut sk_buff, secid: *mut u32_) -> ffi::c_int;
}
extern "C" {
    pub fn security_skb_classify_flow(skb: *mut sk_buff, flic: *mut flowi_common);
}
extern "C" {
    pub fn security_path_unlink(dir: *const path, dentry: *mut dentry) -> ffi::c_int;
}
extern "C" {
    pub fn security_path_mkdir(dir: *const path, dentry: *mut dentry, mode: umode_t) -> ffi::c_int;
}
extern "C" {
    pub fn security_path_rmdir(dir: *const path, dentry: *mut dentry) -> ffi::c_int;
}
extern "C" {
    pub fn security_path_mknod(
        dir: *const path,
        dentry: *mut dentry,
        mode: umode_t,
        dev: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_path_post_mknod(idmap: *mut mnt_idmap, dentry: *mut dentry);
}
extern "C" {
    pub fn security_path_truncate(path: *const path) -> ffi::c_int;
}
extern "C" {
    pub fn security_path_symlink(
        dir: *const path,
        dentry: *mut dentry,
        old_name: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_path_link(
        old_dentry: *mut dentry,
        new_dir: *const path,
        new_dentry: *mut dentry,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_path_rename(
        old_dir: *const path,
        old_dentry: *mut dentry,
        new_dir: *const path,
        new_dentry: *mut dentry,
        flags: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_path_chmod(path: *const path, mode: umode_t) -> ffi::c_int;
}
extern "C" {
    pub fn security_path_chown(path: *const path, uid: kuid_t, gid: kgid_t) -> ffi::c_int;
}
extern "C" {
    pub fn security_path_chroot(path: *const path) -> ffi::c_int;
}
extern "C" {
    pub fn security_key_alloc(key: *mut key, cred: *const cred, flags: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn security_key_free(key: *mut key);
}
extern "C" {
    pub fn security_key_permission(
        key_ref: key_ref_t,
        cred: *const cred,
        need_perm: key_need_perm,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_key_getsecurity(key: *mut key, _buffer: *mut *mut ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub fn security_key_post_create_or_update(
        keyring: *mut key,
        key: *mut key,
        payload: *const ffi::c_void,
        payload_len: usize,
        flags: ffi::c_ulong,
        create: bool_,
    );
}
extern "C" {
    pub fn security_audit_rule_init(
        field: u32_,
        op: u32_,
        rulestr: *mut ffi::c_char,
        lsmrule: *mut *mut ffi::c_void,
        gfp: gfp_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_audit_rule_known(krule: *mut audit_krule) -> ffi::c_int;
}
extern "C" {
    pub fn security_audit_rule_match(
        prop: *mut lsm_prop,
        field: u32_,
        op: u32_,
        lsmrule: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_audit_rule_free(lsmrule: *mut ffi::c_void);
}
extern "C" {
    pub fn securityfs_create_file(
        name: *const ffi::c_char,
        mode: umode_t,
        parent: *mut dentry,
        data: *mut ffi::c_void,
        fops: *const file_operations,
    ) -> *mut dentry;
}
extern "C" {
    pub fn securityfs_create_dir(name: *const ffi::c_char, parent: *mut dentry) -> *mut dentry;
}
extern "C" {
    pub fn securityfs_create_symlink(
        name: *const ffi::c_char,
        parent: *mut dentry,
        target: *const ffi::c_char,
        iops: *const inode_operations,
    ) -> *mut dentry;
}
extern "C" {
    pub fn securityfs_remove(dentry: *mut dentry);
}
extern "C" {
    pub fn securityfs_recursive_remove(dentry: *mut dentry);
}
extern "C" {
    pub fn security_bpf(
        cmd: ffi::c_int,
        attr: *mut bpf_attr,
        size: ffi::c_uint,
        kernel: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_bpf_map(map: *mut bpf_map, fmode: fmode_t) -> ffi::c_int;
}
extern "C" {
    pub fn security_bpf_prog(prog: *mut bpf_prog) -> ffi::c_int;
}
extern "C" {
    pub fn security_bpf_map_create(
        map: *mut bpf_map,
        attr: *mut bpf_attr,
        token: *mut bpf_token,
        kernel: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_bpf_map_free(map: *mut bpf_map);
}
extern "C" {
    pub fn security_bpf_prog_load(
        prog: *mut bpf_prog,
        attr: *mut bpf_attr,
        token: *mut bpf_token,
        kernel: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_bpf_prog_free(prog: *mut bpf_prog);
}
extern "C" {
    pub fn security_bpf_token_create(
        token: *mut bpf_token,
        attr: *mut bpf_attr,
        path: *const path,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn security_bpf_token_free(token: *mut bpf_token);
}
extern "C" {
    pub fn security_bpf_token_cmd(token: *const bpf_token, cmd: bpf_cmd) -> ffi::c_int;
}
extern "C" {
    pub fn security_bpf_token_capable(token: *const bpf_token, cap: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn security_perf_event_open(type_: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn security_perf_event_alloc(event: *mut perf_event) -> ffi::c_int;
}
extern "C" {
    pub fn security_perf_event_free(event: *mut perf_event);
}
extern "C" {
    pub fn security_perf_event_read(event: *mut perf_event) -> ffi::c_int;
}
extern "C" {
    pub fn security_perf_event_write(event: *mut perf_event) -> ffi::c_int;
}
extern "C" {
    pub fn security_uring_override_creds(new: *const cred) -> ffi::c_int;
}
extern "C" {
    pub fn security_uring_sqpoll() -> ffi::c_int;
}
extern "C" {
    pub fn security_uring_cmd(ioucmd: *mut io_uring_cmd) -> ffi::c_int;
}
extern "C" {
    pub fn security_uring_allowed() -> ffi::c_int;
}
extern "C" {
    pub fn security_initramfs_populated();
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_msghdr {
    pub msg_name: compat_uptr_t,
    pub msg_namelen: compat_int_t,
    pub msg_iov: compat_uptr_t,
    pub msg_iovlen: compat_size_t,
    pub msg_control: compat_uptr_t,
    pub msg_controllen: compat_size_t,
    pub msg_flags: compat_uint_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_mmsghdr {
    pub msg_hdr: compat_msghdr,
    pub msg_len: compat_uint_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct compat_cmsghdr {
    pub cmsg_len: compat_size_t,
    pub cmsg_level: compat_int_t,
    pub cmsg_type: compat_int_t,
}
#[repr(C)]
pub struct compat_rtentry {
    pub rt_pad1: u32_,
    pub rt_dst: sockaddr,
    pub rt_gateway: sockaddr,
    pub rt_genmask: sockaddr,
    pub rt_flags: ffi::c_ushort,
    pub rt_pad2: ffi::c_short,
    pub rt_pad3: u32_,
    pub rt_tos: ffi::c_uchar,
    pub rt_class: ffi::c_uchar,
    pub rt_pad4: ffi::c_short,
    pub rt_metric: ffi::c_short,
    pub rt_dev: compat_uptr_t,
    pub rt_mtu: u32_,
    pub rt_window: u32_,
    pub rt_irtt: ffi::c_ushort,
}
impl Default for compat_rtentry {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn __get_compat_msghdr(
        kmsg: *mut msghdr,
        msg: *mut compat_msghdr,
        save_addr: *mut *mut sockaddr,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn get_compat_msghdr(
        arg1: *mut msghdr,
        arg2: *mut compat_msghdr,
        arg3: *mut *mut sockaddr,
        arg4: *mut *mut iovec,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn put_cmsg_compat(
        arg1: *mut msghdr,
        arg2: ffi::c_int,
        arg3: ffi::c_int,
        arg4: ffi::c_int,
        arg5: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn cmsghdr_from_user_compat_to_kern(
        arg1: *mut msghdr,
        arg2: *mut sock,
        arg3: *mut ffi::c_uchar,
        arg4: ffi::c_int,
    ) -> ffi::c_int;
}
#[repr(C, packed(4))]
#[derive(Copy, Clone)]
pub struct compat_group_req {
    pub gr_interface: __u32,
    pub gr_group: __kernel_sockaddr_storage,
}
impl Default for compat_group_req {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C, packed(4))]
#[derive(Copy, Clone)]
pub struct compat_group_source_req {
    pub gsr_interface: __u32,
    pub gsr_group: __kernel_sockaddr_storage,
    pub gsr_source: __kernel_sockaddr_storage,
}
impl Default for compat_group_source_req {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C, packed)]
pub struct compat_group_filter {
    pub __bindgen_anon_1: compat_group_filter__bindgen_ty_1,
}
#[repr(C)]
pub struct compat_group_filter__bindgen_ty_1 {
    pub __bindgen_anon_1: __BindgenUnionField<compat_group_filter__bindgen_ty_1__bindgen_ty_1>,
    pub __bindgen_anon_2: __BindgenUnionField<compat_group_filter__bindgen_ty_1__bindgen_ty_2>,
    pub bindgen_union_field: [u32; 67usize],
}
#[repr(C, packed(4))]
#[derive(Copy, Clone)]
pub struct compat_group_filter__bindgen_ty_1__bindgen_ty_1 {
    pub gf_interface_aux: __u32,
    pub gf_group_aux: __kernel_sockaddr_storage,
    pub gf_fmode_aux: __u32,
    pub gf_numsrc_aux: __u32,
    pub gf_slist: [__kernel_sockaddr_storage; 1usize],
}
impl Default for compat_group_filter__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C, packed(4))]
pub struct compat_group_filter__bindgen_ty_1__bindgen_ty_2 {
    pub gf_interface: __u32,
    pub gf_group: __kernel_sockaddr_storage,
    pub gf_fmode: __u32,
    pub gf_numsrc: __u32,
    pub gf_slist_flex: __IncompleteArrayField<__kernel_sockaddr_storage>,
}
impl Default for compat_group_filter__bindgen_ty_1__bindgen_ty_2 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for compat_group_filter__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for compat_group_filter {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct scm_creds {
    pub pid: u32_,
    pub uid: kuid_t,
    pub gid: kgid_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct unix_edge {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct scm_fp_list {
    pub count: ffi::c_short,
    pub count_unix: ffi::c_short,
    pub max: ffi::c_short,
    pub inflight: bool_,
    pub dead: bool_,
    pub vertices: list_head,
    pub edges: *mut unix_edge,
    pub user: *mut user_struct,
    pub fp: [*mut file; 253usize],
}
impl Default for scm_fp_list {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct scm_cookie {
    pub pid: *mut pid,
    pub fp: *mut scm_fp_list,
    pub creds: scm_creds,
    pub secid: u32_,
}
impl Default for scm_cookie {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn scm_detach_fds(msg: *mut msghdr, scm: *mut scm_cookie);
}
extern "C" {
    pub fn scm_detach_fds_compat(msg: *mut msghdr, scm: *mut scm_cookie);
}
extern "C" {
    pub fn __scm_send(sock: *mut socket, msg: *mut msghdr, scm: *mut scm_cookie) -> ffi::c_int;
}
extern "C" {
    pub fn __scm_destroy(scm: *mut scm_cookie);
}
extern "C" {
    pub fn scm_fp_dup(fpl: *mut scm_fp_list) -> *mut scm_fp_list;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sockaddr_nl {
    pub nl_family: __kernel_sa_family_t,
    pub nl_pad: ffi::c_ushort,
    pub nl_pid: __u32,
    pub nl_groups: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct nlmsghdr {
    pub nlmsg_len: __u32,
    pub nlmsg_type: __u16,
    pub nlmsg_flags: __u16,
    pub nlmsg_seq: __u32,
    pub nlmsg_pid: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct nlmsgerr {
    pub error: ffi::c_int,
    pub msg: nlmsghdr,
}
pub const nlmsgerr_attrs_NLMSGERR_ATTR_UNUSED: nlmsgerr_attrs = 0;
pub const nlmsgerr_attrs_NLMSGERR_ATTR_MSG: nlmsgerr_attrs = 1;
pub const nlmsgerr_attrs_NLMSGERR_ATTR_OFFS: nlmsgerr_attrs = 2;
pub const nlmsgerr_attrs_NLMSGERR_ATTR_COOKIE: nlmsgerr_attrs = 3;
pub const nlmsgerr_attrs_NLMSGERR_ATTR_POLICY: nlmsgerr_attrs = 4;
pub const nlmsgerr_attrs_NLMSGERR_ATTR_MISS_TYPE: nlmsgerr_attrs = 5;
pub const nlmsgerr_attrs_NLMSGERR_ATTR_MISS_NEST: nlmsgerr_attrs = 6;
pub const nlmsgerr_attrs___NLMSGERR_ATTR_MAX: nlmsgerr_attrs = 7;
pub const nlmsgerr_attrs_NLMSGERR_ATTR_MAX: nlmsgerr_attrs = 6;
pub type nlmsgerr_attrs = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct nl_pktinfo {
    pub group: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct nl_mmap_req {
    pub nm_block_size: ffi::c_uint,
    pub nm_block_nr: ffi::c_uint,
    pub nm_frame_size: ffi::c_uint,
    pub nm_frame_nr: ffi::c_uint,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct nl_mmap_hdr {
    pub nm_status: ffi::c_uint,
    pub nm_len: ffi::c_uint,
    pub nm_group: __u32,
    pub nm_pid: __u32,
    pub nm_uid: __u32,
    pub nm_gid: __u32,
}
pub const NETLINK_UNCONNECTED: _bindgen_ty_264 = 0;
pub const NETLINK_CONNECTED: _bindgen_ty_264 = 1;
pub type _bindgen_ty_264 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct nlattr {
    pub nla_len: __u16,
    pub nla_type: __u16,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct nla_bitfield32 {
    pub value: __u32,
    pub selector: __u32,
}
pub const netlink_attribute_type_NL_ATTR_TYPE_INVALID: netlink_attribute_type = 0;
pub const netlink_attribute_type_NL_ATTR_TYPE_FLAG: netlink_attribute_type = 1;
pub const netlink_attribute_type_NL_ATTR_TYPE_U8: netlink_attribute_type = 2;
pub const netlink_attribute_type_NL_ATTR_TYPE_U16: netlink_attribute_type = 3;
pub const netlink_attribute_type_NL_ATTR_TYPE_U32: netlink_attribute_type = 4;
pub const netlink_attribute_type_NL_ATTR_TYPE_U64: netlink_attribute_type = 5;
pub const netlink_attribute_type_NL_ATTR_TYPE_S8: netlink_attribute_type = 6;
pub const netlink_attribute_type_NL_ATTR_TYPE_S16: netlink_attribute_type = 7;
pub const netlink_attribute_type_NL_ATTR_TYPE_S32: netlink_attribute_type = 8;
pub const netlink_attribute_type_NL_ATTR_TYPE_S64: netlink_attribute_type = 9;
pub const netlink_attribute_type_NL_ATTR_TYPE_BINARY: netlink_attribute_type = 10;
pub const netlink_attribute_type_NL_ATTR_TYPE_STRING: netlink_attribute_type = 11;
pub const netlink_attribute_type_NL_ATTR_TYPE_NUL_STRING: netlink_attribute_type = 12;
pub const netlink_attribute_type_NL_ATTR_TYPE_NESTED: netlink_attribute_type = 13;
pub const netlink_attribute_type_NL_ATTR_TYPE_NESTED_ARRAY: netlink_attribute_type = 14;
pub const netlink_attribute_type_NL_ATTR_TYPE_BITFIELD32: netlink_attribute_type = 15;
pub const netlink_attribute_type_NL_ATTR_TYPE_SINT: netlink_attribute_type = 16;
pub const netlink_attribute_type_NL_ATTR_TYPE_UINT: netlink_attribute_type = 17;
pub type netlink_attribute_type = ffi::c_uint;
pub const netlink_policy_type_attr_NL_POLICY_TYPE_ATTR_UNSPEC: netlink_policy_type_attr = 0;
pub const netlink_policy_type_attr_NL_POLICY_TYPE_ATTR_TYPE: netlink_policy_type_attr = 1;
pub const netlink_policy_type_attr_NL_POLICY_TYPE_ATTR_MIN_VALUE_S: netlink_policy_type_attr = 2;
pub const netlink_policy_type_attr_NL_POLICY_TYPE_ATTR_MAX_VALUE_S: netlink_policy_type_attr = 3;
pub const netlink_policy_type_attr_NL_POLICY_TYPE_ATTR_MIN_VALUE_U: netlink_policy_type_attr = 4;
pub const netlink_policy_type_attr_NL_POLICY_TYPE_ATTR_MAX_VALUE_U: netlink_policy_type_attr = 5;
pub const netlink_policy_type_attr_NL_POLICY_TYPE_ATTR_MIN_LENGTH: netlink_policy_type_attr = 6;
pub const netlink_policy_type_attr_NL_POLICY_TYPE_ATTR_MAX_LENGTH: netlink_policy_type_attr = 7;
pub const netlink_policy_type_attr_NL_POLICY_TYPE_ATTR_POLICY_IDX: netlink_policy_type_attr = 8;
pub const netlink_policy_type_attr_NL_POLICY_TYPE_ATTR_POLICY_MAXTYPE: netlink_policy_type_attr = 9;
pub const netlink_policy_type_attr_NL_POLICY_TYPE_ATTR_BITFIELD32_MASK: netlink_policy_type_attr =
    10;
pub const netlink_policy_type_attr_NL_POLICY_TYPE_ATTR_PAD: netlink_policy_type_attr = 11;
pub const netlink_policy_type_attr_NL_POLICY_TYPE_ATTR_MASK: netlink_policy_type_attr = 12;
pub const netlink_policy_type_attr___NL_POLICY_TYPE_ATTR_MAX: netlink_policy_type_attr = 13;
pub const netlink_policy_type_attr_NL_POLICY_TYPE_ATTR_MAX: netlink_policy_type_attr = 12;
pub type netlink_policy_type_attr = ffi::c_uint;
extern "C" {
    pub fn do_trace_netlink_extack(msg: *const ffi::c_char);
}
pub const netlink_skb_flags_NETLINK_SKB_DST: netlink_skb_flags = 8;
pub type netlink_skb_flags = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct netlink_skb_parms {
    pub creds: scm_creds,
    pub portid: __u32,
    pub dst_group: __u32,
    pub flags: __u32,
    pub sk: *mut sock,
    pub nsid_is_set: bool_,
    pub nsid: ffi::c_int,
}
impl Default for netlink_skb_parms {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn netlink_table_grab();
}
extern "C" {
    pub fn netlink_table_ungrab();
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct netlink_kernel_cfg {
    pub groups: ffi::c_uint,
    pub flags: ffi::c_uint,
    pub input: ::core::option::Option<unsafe extern "C" fn(skb: *mut sk_buff)>,
    pub bind: ::core::option::Option<
        unsafe extern "C" fn(net: *mut net, group: ffi::c_int) -> ffi::c_int,
    >,
    pub unbind: ::core::option::Option<unsafe extern "C" fn(net: *mut net, group: ffi::c_int)>,
    pub release:
        ::core::option::Option<unsafe extern "C" fn(sk: *mut sock, groups: *mut ffi::c_ulong)>,
}
extern "C" {
    pub fn __netlink_kernel_create(
        net: *mut net,
        unit: ffi::c_int,
        module: *mut module,
        cfg: *mut netlink_kernel_cfg,
    ) -> *mut sock;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct netlink_ext_ack {
    pub _msg: *const ffi::c_char,
    pub bad_attr: *const nlattr,
    pub policy: *mut nla_policy,
    pub miss_nest: *const nlattr,
    pub miss_type: u16_,
    pub cookie: [u8_; 20usize],
    pub cookie_len: u8_,
    pub _msg_buf: [ffi::c_char; 80usize],
}
impl Default for netlink_ext_ack {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn netlink_kernel_release(sk: *mut sock);
}
extern "C" {
    pub fn __netlink_change_ngroups(sk: *mut sock, groups: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn netlink_change_ngroups(sk: *mut sock, groups: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn __netlink_clear_multicast_users(sk: *mut sock, group: ffi::c_uint);
}
extern "C" {
    pub fn netlink_ack(
        in_skb: *mut sk_buff,
        nlh: *mut nlmsghdr,
        err: ffi::c_int,
        extack: *const netlink_ext_ack,
    );
}
extern "C" {
    pub fn netlink_has_listeners(sk: *mut sock, group: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn netlink_strict_get_check(skb: *mut sk_buff) -> bool_;
}
extern "C" {
    pub fn netlink_unicast(
        ssk: *mut sock,
        skb: *mut sk_buff,
        portid: __u32,
        nonblock: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn netlink_broadcast(
        ssk: *mut sock,
        skb: *mut sk_buff,
        portid: __u32,
        group: __u32,
        allocation: gfp_t,
    ) -> ffi::c_int;
}
pub type netlink_filter_fn = ::core::option::Option<
    unsafe extern "C" fn(dsk: *mut sock, skb: *mut sk_buff, data: *mut ffi::c_void) -> ffi::c_int,
>;
extern "C" {
    pub fn netlink_broadcast_filtered(
        ssk: *mut sock,
        skb: *mut sk_buff,
        portid: __u32,
        group: __u32,
        allocation: gfp_t,
        filter: netlink_filter_fn,
        filter_data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn netlink_set_err(
        ssk: *mut sock,
        portid: __u32,
        group: __u32,
        code: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn netlink_register_notifier(nb: *mut notifier_block) -> ffi::c_int;
}
extern "C" {
    pub fn netlink_unregister_notifier(nb: *mut notifier_block) -> ffi::c_int;
}
extern "C" {
    pub fn netlink_getsockbyfd(fd: ffi::c_int) -> *mut sock;
}
extern "C" {
    pub fn netlink_attachskb(
        sk: *mut sock,
        skb: *mut sk_buff,
        timeo: *mut ffi::c_long,
        ssk: *mut sock,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn netlink_detachskb(sk: *mut sock, skb: *mut sk_buff);
}
extern "C" {
    pub fn netlink_sendskb(sk: *mut sock, skb: *mut sk_buff) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct netlink_callback {
    pub skb: *mut sk_buff,
    pub nlh: *const nlmsghdr,
    pub dump: ::core::option::Option<
        unsafe extern "C" fn(skb: *mut sk_buff, cb: *mut netlink_callback) -> ffi::c_int,
    >,
    pub done: ::core::option::Option<unsafe extern "C" fn(cb: *mut netlink_callback) -> ffi::c_int>,
    pub data: *mut ffi::c_void,
    pub module: *mut module,
    pub extack: *mut netlink_ext_ack,
    pub family: u16_,
    pub answer_flags: u16_,
    pub min_dump_alloc: u32_,
    pub prev_seq: ffi::c_uint,
    pub seq: ffi::c_uint,
    pub flags: ffi::c_int,
    pub strict_check: bool_,
    pub __bindgen_anon_1: netlink_callback__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union netlink_callback__bindgen_ty_1 {
    pub ctx: [u8_; 48usize],
    pub args: [ffi::c_long; 6usize],
}
impl Default for netlink_callback__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for netlink_callback {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct netlink_notify {
    pub net: *mut net,
    pub portid: u32_,
    pub protocol: ffi::c_int,
}
impl Default for netlink_notify {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn __nlmsg_put(
        skb: *mut sk_buff,
        portid: u32_,
        seq: u32_,
        type_: ffi::c_int,
        len: ffi::c_int,
        flags: ffi::c_int,
    ) -> *mut nlmsghdr;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct netlink_dump_control {
    pub start:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut netlink_callback) -> ffi::c_int>,
    pub dump: ::core::option::Option<
        unsafe extern "C" fn(skb: *mut sk_buff, arg1: *mut netlink_callback) -> ffi::c_int,
    >,
    pub done:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut netlink_callback) -> ffi::c_int>,
    pub extack: *mut netlink_ext_ack,
    pub data: *mut ffi::c_void,
    pub module: *mut module,
    pub min_dump_alloc: u32_,
    pub flags: ffi::c_int,
}
impl Default for netlink_dump_control {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn __netlink_dump_start(
        ssk: *mut sock,
        skb: *mut sk_buff,
        nlh: *const nlmsghdr,
        control: *mut netlink_dump_control,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct netlink_tap {
    pub dev: *mut net_device,
    pub module: *mut module,
    pub list: list_head,
}
impl Default for netlink_tap {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn netlink_add_tap(nt: *mut netlink_tap) -> ffi::c_int;
}
extern "C" {
    pub fn netlink_remove_tap(nt: *mut netlink_tap) -> ffi::c_int;
}
extern "C" {
    pub fn __netlink_ns_capable(
        nsp: *const netlink_skb_parms,
        ns: *mut user_namespace,
        cap: ffi::c_int,
    ) -> bool_;
}
extern "C" {
    pub fn netlink_ns_capable(
        skb: *const sk_buff,
        ns: *mut user_namespace,
        cap: ffi::c_int,
    ) -> bool_;
}
extern "C" {
    pub fn netlink_capable(skb: *const sk_buff, cap: ffi::c_int) -> bool_;
}
extern "C" {
    pub fn netlink_net_capable(skb: *const sk_buff, cap: ffi::c_int) -> bool_;
}
extern "C" {
    pub fn netlink_alloc_large_skb(size: ffi::c_uint, broadcast: ffi::c_int) -> *mut sk_buff;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_cmd {
    pub cmd: __u32,
    pub supported: __u32,
    pub advertising: __u32,
    pub speed: __u16,
    pub duplex: __u8,
    pub port: __u8,
    pub phy_address: __u8,
    pub transceiver: __u8,
    pub autoneg: __u8,
    pub mdio_support: __u8,
    pub maxtxpkt: __u32,
    pub maxrxpkt: __u32,
    pub speed_hi: __u16,
    pub eth_tp_mdix: __u8,
    pub eth_tp_mdix_ctrl: __u8,
    pub lp_advertising: __u32,
    pub reserved: [__u32; 2usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_drvinfo {
    pub cmd: __u32,
    pub driver: [ffi::c_char; 32usize],
    pub version: [ffi::c_char; 32usize],
    pub fw_version: [ffi::c_char; 32usize],
    pub bus_info: [ffi::c_char; 32usize],
    pub erom_version: [ffi::c_char; 32usize],
    pub reserved2: [ffi::c_char; 12usize],
    pub n_priv_flags: __u32,
    pub n_stats: __u32,
    pub testinfo_len: __u32,
    pub eedump_len: __u32,
    pub regdump_len: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_wolinfo {
    pub cmd: __u32,
    pub supported: __u32,
    pub wolopts: __u32,
    pub sopass: [__u8; 6usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_value {
    pub cmd: __u32,
    pub data: __u32,
}
pub const tunable_id_ETHTOOL_ID_UNSPEC: tunable_id = 0;
pub const tunable_id_ETHTOOL_RX_COPYBREAK: tunable_id = 1;
pub const tunable_id_ETHTOOL_TX_COPYBREAK: tunable_id = 2;
pub const tunable_id_ETHTOOL_PFC_PREVENTION_TOUT: tunable_id = 3;
pub const tunable_id_ETHTOOL_TX_COPYBREAK_BUF_SIZE: tunable_id = 4;
pub const tunable_id___ETHTOOL_TUNABLE_COUNT: tunable_id = 5;
pub type tunable_id = ffi::c_uint;
pub const tunable_type_id_ETHTOOL_TUNABLE_UNSPEC: tunable_type_id = 0;
pub const tunable_type_id_ETHTOOL_TUNABLE_U8: tunable_type_id = 1;
pub const tunable_type_id_ETHTOOL_TUNABLE_U16: tunable_type_id = 2;
pub const tunable_type_id_ETHTOOL_TUNABLE_U32: tunable_type_id = 3;
pub const tunable_type_id_ETHTOOL_TUNABLE_U64: tunable_type_id = 4;
pub const tunable_type_id_ETHTOOL_TUNABLE_STRING: tunable_type_id = 5;
pub const tunable_type_id_ETHTOOL_TUNABLE_S8: tunable_type_id = 6;
pub const tunable_type_id_ETHTOOL_TUNABLE_S16: tunable_type_id = 7;
pub const tunable_type_id_ETHTOOL_TUNABLE_S32: tunable_type_id = 8;
pub const tunable_type_id_ETHTOOL_TUNABLE_S64: tunable_type_id = 9;
pub type tunable_type_id = ffi::c_uint;
#[repr(C)]
pub struct ethtool_tunable {
    pub cmd: __u32,
    pub id: __u32,
    pub type_id: __u32,
    pub len: __u32,
    pub data: __IncompleteArrayField<*mut ffi::c_void>,
}
impl Default for ethtool_tunable {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const phy_tunable_id_ETHTOOL_PHY_ID_UNSPEC: phy_tunable_id = 0;
pub const phy_tunable_id_ETHTOOL_PHY_DOWNSHIFT: phy_tunable_id = 1;
pub const phy_tunable_id_ETHTOOL_PHY_FAST_LINK_DOWN: phy_tunable_id = 2;
pub const phy_tunable_id_ETHTOOL_PHY_EDPD: phy_tunable_id = 3;
pub const phy_tunable_id___ETHTOOL_PHY_TUNABLE_COUNT: phy_tunable_id = 4;
pub type phy_tunable_id = ffi::c_uint;
#[repr(C)]
#[derive(Default)]
pub struct ethtool_regs {
    pub cmd: __u32,
    pub version: __u32,
    pub len: __u32,
    pub data: __IncompleteArrayField<__u8>,
}
#[repr(C)]
#[derive(Default)]
pub struct ethtool_eeprom {
    pub cmd: __u32,
    pub magic: __u32,
    pub offset: __u32,
    pub len: __u32,
    pub data: __IncompleteArrayField<__u8>,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_eee {
    pub cmd: __u32,
    pub supported: __u32,
    pub advertised: __u32,
    pub lp_advertised: __u32,
    pub eee_active: __u32,
    pub eee_enabled: __u32,
    pub tx_lpi_enabled: __u32,
    pub tx_lpi_timer: __u32,
    pub reserved: [__u32; 2usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_modinfo {
    pub cmd: __u32,
    pub type_: __u32,
    pub eeprom_len: __u32,
    pub reserved: [__u32; 8usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_coalesce {
    pub cmd: __u32,
    pub rx_coalesce_usecs: __u32,
    pub rx_max_coalesced_frames: __u32,
    pub rx_coalesce_usecs_irq: __u32,
    pub rx_max_coalesced_frames_irq: __u32,
    pub tx_coalesce_usecs: __u32,
    pub tx_max_coalesced_frames: __u32,
    pub tx_coalesce_usecs_irq: __u32,
    pub tx_max_coalesced_frames_irq: __u32,
    pub stats_block_coalesce_usecs: __u32,
    pub use_adaptive_rx_coalesce: __u32,
    pub use_adaptive_tx_coalesce: __u32,
    pub pkt_rate_low: __u32,
    pub rx_coalesce_usecs_low: __u32,
    pub rx_max_coalesced_frames_low: __u32,
    pub tx_coalesce_usecs_low: __u32,
    pub tx_max_coalesced_frames_low: __u32,
    pub pkt_rate_high: __u32,
    pub rx_coalesce_usecs_high: __u32,
    pub rx_max_coalesced_frames_high: __u32,
    pub tx_coalesce_usecs_high: __u32,
    pub tx_max_coalesced_frames_high: __u32,
    pub rate_sample_interval: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_ringparam {
    pub cmd: __u32,
    pub rx_max_pending: __u32,
    pub rx_mini_max_pending: __u32,
    pub rx_jumbo_max_pending: __u32,
    pub tx_max_pending: __u32,
    pub rx_pending: __u32,
    pub rx_mini_pending: __u32,
    pub rx_jumbo_pending: __u32,
    pub tx_pending: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_channels {
    pub cmd: __u32,
    pub max_rx: __u32,
    pub max_tx: __u32,
    pub max_other: __u32,
    pub max_combined: __u32,
    pub rx_count: __u32,
    pub tx_count: __u32,
    pub other_count: __u32,
    pub combined_count: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_pauseparam {
    pub cmd: __u32,
    pub autoneg: __u32,
    pub rx_pause: __u32,
    pub tx_pause: __u32,
}
pub const ethtool_link_ext_state_ETHTOOL_LINK_EXT_STATE_AUTONEG: ethtool_link_ext_state = 0;
pub const ethtool_link_ext_state_ETHTOOL_LINK_EXT_STATE_LINK_TRAINING_FAILURE:
    ethtool_link_ext_state = 1;
pub const ethtool_link_ext_state_ETHTOOL_LINK_EXT_STATE_LINK_LOGICAL_MISMATCH:
    ethtool_link_ext_state = 2;
pub const ethtool_link_ext_state_ETHTOOL_LINK_EXT_STATE_BAD_SIGNAL_INTEGRITY:
    ethtool_link_ext_state = 3;
pub const ethtool_link_ext_state_ETHTOOL_LINK_EXT_STATE_NO_CABLE: ethtool_link_ext_state = 4;
pub const ethtool_link_ext_state_ETHTOOL_LINK_EXT_STATE_CABLE_ISSUE: ethtool_link_ext_state = 5;
pub const ethtool_link_ext_state_ETHTOOL_LINK_EXT_STATE_EEPROM_ISSUE: ethtool_link_ext_state = 6;
pub const ethtool_link_ext_state_ETHTOOL_LINK_EXT_STATE_CALIBRATION_FAILURE:
    ethtool_link_ext_state = 7;
pub const ethtool_link_ext_state_ETHTOOL_LINK_EXT_STATE_POWER_BUDGET_EXCEEDED:
    ethtool_link_ext_state = 8;
pub const ethtool_link_ext_state_ETHTOOL_LINK_EXT_STATE_OVERHEAT: ethtool_link_ext_state = 9;
pub const ethtool_link_ext_state_ETHTOOL_LINK_EXT_STATE_MODULE: ethtool_link_ext_state = 10;
pub type ethtool_link_ext_state = ffi::c_uint;
pub const ethtool_link_ext_substate_autoneg_ETHTOOL_LINK_EXT_SUBSTATE_AN_NO_PARTNER_DETECTED:
    ethtool_link_ext_substate_autoneg = 1;
pub const ethtool_link_ext_substate_autoneg_ETHTOOL_LINK_EXT_SUBSTATE_AN_ACK_NOT_RECEIVED:
    ethtool_link_ext_substate_autoneg = 2;
pub const ethtool_link_ext_substate_autoneg_ETHTOOL_LINK_EXT_SUBSTATE_AN_NEXT_PAGE_EXCHANGE_FAILED : ethtool_link_ext_substate_autoneg = 3 ;
pub const ethtool_link_ext_substate_autoneg_ETHTOOL_LINK_EXT_SUBSTATE_AN_NO_PARTNER_DETECTED_FORCE_MODE : ethtool_link_ext_substate_autoneg = 4 ;
pub const ethtool_link_ext_substate_autoneg_ETHTOOL_LINK_EXT_SUBSTATE_AN_FEC_MISMATCH_DURING_OVERRIDE : ethtool_link_ext_substate_autoneg = 5 ;
pub const ethtool_link_ext_substate_autoneg_ETHTOOL_LINK_EXT_SUBSTATE_AN_NO_HCD:
    ethtool_link_ext_substate_autoneg = 6;
pub type ethtool_link_ext_substate_autoneg = ffi::c_uint;
pub const ethtool_link_ext_substate_link_training_ETHTOOL_LINK_EXT_SUBSTATE_LT_KR_FRAME_LOCK_NOT_ACQUIRED : ethtool_link_ext_substate_link_training = 1 ;
pub const ethtool_link_ext_substate_link_training_ETHTOOL_LINK_EXT_SUBSTATE_LT_KR_LINK_INHIBIT_TIMEOUT : ethtool_link_ext_substate_link_training = 2 ;
pub const ethtool_link_ext_substate_link_training_ETHTOOL_LINK_EXT_SUBSTATE_LT_KR_LINK_PARTNER_DID_NOT_SET_RECEIVER_READY : ethtool_link_ext_substate_link_training = 3 ;
pub const ethtool_link_ext_substate_link_training_ETHTOOL_LINK_EXT_SUBSTATE_LT_REMOTE_FAULT:
    ethtool_link_ext_substate_link_training = 4;
pub type ethtool_link_ext_substate_link_training = ffi::c_uint;
pub const ethtool_link_ext_substate_link_logical_mismatch_ETHTOOL_LINK_EXT_SUBSTATE_LLM_PCS_DID_NOT_ACQUIRE_BLOCK_LOCK : ethtool_link_ext_substate_link_logical_mismatch = 1 ;
pub const ethtool_link_ext_substate_link_logical_mismatch_ETHTOOL_LINK_EXT_SUBSTATE_LLM_PCS_DID_NOT_ACQUIRE_AM_LOCK : ethtool_link_ext_substate_link_logical_mismatch = 2 ;
pub const ethtool_link_ext_substate_link_logical_mismatch_ETHTOOL_LINK_EXT_SUBSTATE_LLM_PCS_DID_NOT_GET_ALIGN_STATUS : ethtool_link_ext_substate_link_logical_mismatch = 3 ;
pub const ethtool_link_ext_substate_link_logical_mismatch_ETHTOOL_LINK_EXT_SUBSTATE_LLM_FC_FEC_IS_NOT_LOCKED : ethtool_link_ext_substate_link_logical_mismatch = 4 ;
pub const ethtool_link_ext_substate_link_logical_mismatch_ETHTOOL_LINK_EXT_SUBSTATE_LLM_RS_FEC_IS_NOT_LOCKED : ethtool_link_ext_substate_link_logical_mismatch = 5 ;
pub type ethtool_link_ext_substate_link_logical_mismatch = ffi::c_uint;
pub const ethtool_link_ext_substate_bad_signal_integrity_ETHTOOL_LINK_EXT_SUBSTATE_BSI_LARGE_NUMBER_OF_PHYSICAL_ERRORS : ethtool_link_ext_substate_bad_signal_integrity = 1 ;
pub const ethtool_link_ext_substate_bad_signal_integrity_ETHTOOL_LINK_EXT_SUBSTATE_BSI_UNSUPPORTED_RATE : ethtool_link_ext_substate_bad_signal_integrity = 2 ;
pub const ethtool_link_ext_substate_bad_signal_integrity_ETHTOOL_LINK_EXT_SUBSTATE_BSI_SERDES_REFERENCE_CLOCK_LOST : ethtool_link_ext_substate_bad_signal_integrity = 3 ;
pub const ethtool_link_ext_substate_bad_signal_integrity_ETHTOOL_LINK_EXT_SUBSTATE_BSI_SERDES_ALOS : ethtool_link_ext_substate_bad_signal_integrity = 4 ;
pub type ethtool_link_ext_substate_bad_signal_integrity = ffi::c_uint;
pub const ethtool_link_ext_substate_cable_issue_ETHTOOL_LINK_EXT_SUBSTATE_CI_UNSUPPORTED_CABLE:
    ethtool_link_ext_substate_cable_issue = 1;
pub const ethtool_link_ext_substate_cable_issue_ETHTOOL_LINK_EXT_SUBSTATE_CI_CABLE_TEST_FAILURE:
    ethtool_link_ext_substate_cable_issue = 2;
pub type ethtool_link_ext_substate_cable_issue = ffi::c_uint;
pub const ethtool_link_ext_substate_module_ETHTOOL_LINK_EXT_SUBSTATE_MODULE_CMIS_NOT_READY:
    ethtool_link_ext_substate_module = 1;
pub type ethtool_link_ext_substate_module = ffi::c_uint;
pub const ethtool_stringset_ETH_SS_TEST: ethtool_stringset = 0;
pub const ethtool_stringset_ETH_SS_STATS: ethtool_stringset = 1;
pub const ethtool_stringset_ETH_SS_PRIV_FLAGS: ethtool_stringset = 2;
pub const ethtool_stringset_ETH_SS_NTUPLE_FILTERS: ethtool_stringset = 3;
pub const ethtool_stringset_ETH_SS_FEATURES: ethtool_stringset = 4;
pub const ethtool_stringset_ETH_SS_RSS_HASH_FUNCS: ethtool_stringset = 5;
pub const ethtool_stringset_ETH_SS_TUNABLES: ethtool_stringset = 6;
pub const ethtool_stringset_ETH_SS_PHY_STATS: ethtool_stringset = 7;
pub const ethtool_stringset_ETH_SS_PHY_TUNABLES: ethtool_stringset = 8;
pub const ethtool_stringset_ETH_SS_LINK_MODES: ethtool_stringset = 9;
pub const ethtool_stringset_ETH_SS_MSG_CLASSES: ethtool_stringset = 10;
pub const ethtool_stringset_ETH_SS_WOL_MODES: ethtool_stringset = 11;
pub const ethtool_stringset_ETH_SS_SOF_TIMESTAMPING: ethtool_stringset = 12;
pub const ethtool_stringset_ETH_SS_TS_TX_TYPES: ethtool_stringset = 13;
pub const ethtool_stringset_ETH_SS_TS_RX_FILTERS: ethtool_stringset = 14;
pub const ethtool_stringset_ETH_SS_UDP_TUNNEL_TYPES: ethtool_stringset = 15;
pub const ethtool_stringset_ETH_SS_STATS_STD: ethtool_stringset = 16;
pub const ethtool_stringset_ETH_SS_STATS_ETH_PHY: ethtool_stringset = 17;
pub const ethtool_stringset_ETH_SS_STATS_ETH_MAC: ethtool_stringset = 18;
pub const ethtool_stringset_ETH_SS_STATS_ETH_CTRL: ethtool_stringset = 19;
pub const ethtool_stringset_ETH_SS_STATS_RMON: ethtool_stringset = 20;
pub const ethtool_stringset_ETH_SS_STATS_PHY: ethtool_stringset = 21;
pub const ethtool_stringset_ETH_SS_TS_FLAGS: ethtool_stringset = 22;
pub const ethtool_stringset_ETH_SS_COUNT: ethtool_stringset = 23;
pub type ethtool_stringset = ffi::c_uint;
pub const ethtool_mac_stats_src_ETHTOOL_MAC_STATS_SRC_AGGREGATE: ethtool_mac_stats_src = 0;
pub const ethtool_mac_stats_src_ETHTOOL_MAC_STATS_SRC_EMAC: ethtool_mac_stats_src = 1;
pub const ethtool_mac_stats_src_ETHTOOL_MAC_STATS_SRC_PMAC: ethtool_mac_stats_src = 2;
pub type ethtool_mac_stats_src = ffi::c_uint;
pub const ethtool_module_power_mode_policy_ETHTOOL_MODULE_POWER_MODE_POLICY_HIGH:
    ethtool_module_power_mode_policy = 1;
pub const ethtool_module_power_mode_policy_ETHTOOL_MODULE_POWER_MODE_POLICY_AUTO:
    ethtool_module_power_mode_policy = 2;
pub type ethtool_module_power_mode_policy = ffi::c_uint;
pub const ethtool_module_power_mode_ETHTOOL_MODULE_POWER_MODE_LOW: ethtool_module_power_mode = 1;
pub const ethtool_module_power_mode_ETHTOOL_MODULE_POWER_MODE_HIGH: ethtool_module_power_mode = 2;
pub type ethtool_module_power_mode = ffi::c_uint;
pub const ethtool_c33_pse_ext_state_ETHTOOL_C33_PSE_EXT_STATE_ERROR_CONDITION:
    ethtool_c33_pse_ext_state = 1;
pub const ethtool_c33_pse_ext_state_ETHTOOL_C33_PSE_EXT_STATE_MR_MPS_VALID:
    ethtool_c33_pse_ext_state = 2;
pub const ethtool_c33_pse_ext_state_ETHTOOL_C33_PSE_EXT_STATE_MR_PSE_ENABLE:
    ethtool_c33_pse_ext_state = 3;
pub const ethtool_c33_pse_ext_state_ETHTOOL_C33_PSE_EXT_STATE_OPTION_DETECT_TED:
    ethtool_c33_pse_ext_state = 4;
pub const ethtool_c33_pse_ext_state_ETHTOOL_C33_PSE_EXT_STATE_OPTION_VPORT_LIM:
    ethtool_c33_pse_ext_state = 5;
pub const ethtool_c33_pse_ext_state_ETHTOOL_C33_PSE_EXT_STATE_OVLD_DETECTED:
    ethtool_c33_pse_ext_state = 6;
pub const ethtool_c33_pse_ext_state_ETHTOOL_C33_PSE_EXT_STATE_PD_DLL_POWER_TYPE:
    ethtool_c33_pse_ext_state = 7;
pub const ethtool_c33_pse_ext_state_ETHTOOL_C33_PSE_EXT_STATE_POWER_NOT_AVAILABLE:
    ethtool_c33_pse_ext_state = 8;
pub const ethtool_c33_pse_ext_state_ETHTOOL_C33_PSE_EXT_STATE_SHORT_DETECTED:
    ethtool_c33_pse_ext_state = 9;
pub type ethtool_c33_pse_ext_state = ffi::c_uint;
pub const ethtool_c33_pse_ext_substate_mr_mps_valid_ETHTOOL_C33_PSE_EXT_SUBSTATE_MR_MPS_VALID_DETECTED_UNDERLOAD : ethtool_c33_pse_ext_substate_mr_mps_valid = 1 ;
pub const ethtool_c33_pse_ext_substate_mr_mps_valid_ETHTOOL_C33_PSE_EXT_SUBSTATE_MR_MPS_VALID_CONNECTION_OPEN : ethtool_c33_pse_ext_substate_mr_mps_valid = 2 ;
pub type ethtool_c33_pse_ext_substate_mr_mps_valid = ffi::c_uint;
pub const ethtool_c33_pse_ext_substate_error_condition_ETHTOOL_C33_PSE_EXT_SUBSTATE_ERROR_CONDITION_NON_EXISTING_PORT : ethtool_c33_pse_ext_substate_error_condition = 1 ;
pub const ethtool_c33_pse_ext_substate_error_condition_ETHTOOL_C33_PSE_EXT_SUBSTATE_ERROR_CONDITION_UNDEFINED_PORT : ethtool_c33_pse_ext_substate_error_condition = 2 ;
pub const ethtool_c33_pse_ext_substate_error_condition_ETHTOOL_C33_PSE_EXT_SUBSTATE_ERROR_CONDITION_INTERNAL_HW_FAULT : ethtool_c33_pse_ext_substate_error_condition = 3 ;
pub const ethtool_c33_pse_ext_substate_error_condition_ETHTOOL_C33_PSE_EXT_SUBSTATE_ERROR_CONDITION_COMM_ERROR_AFTER_FORCE_ON : ethtool_c33_pse_ext_substate_error_condition = 4 ;
pub const ethtool_c33_pse_ext_substate_error_condition_ETHTOOL_C33_PSE_EXT_SUBSTATE_ERROR_CONDITION_UNKNOWN_PORT_STATUS : ethtool_c33_pse_ext_substate_error_condition = 5 ;
pub const ethtool_c33_pse_ext_substate_error_condition_ETHTOOL_C33_PSE_EXT_SUBSTATE_ERROR_CONDITION_HOST_CRASH_TURN_OFF : ethtool_c33_pse_ext_substate_error_condition = 6 ;
pub const ethtool_c33_pse_ext_substate_error_condition_ETHTOOL_C33_PSE_EXT_SUBSTATE_ERROR_CONDITION_HOST_CRASH_FORCE_SHUTDOWN : ethtool_c33_pse_ext_substate_error_condition = 7 ;
pub const ethtool_c33_pse_ext_substate_error_condition_ETHTOOL_C33_PSE_EXT_SUBSTATE_ERROR_CONDITION_CONFIG_CHANGE : ethtool_c33_pse_ext_substate_error_condition = 8 ;
pub const ethtool_c33_pse_ext_substate_error_condition_ETHTOOL_C33_PSE_EXT_SUBSTATE_ERROR_CONDITION_DETECTED_OVER_TEMP : ethtool_c33_pse_ext_substate_error_condition = 9 ;
pub type ethtool_c33_pse_ext_substate_error_condition = ffi::c_uint;
pub const ethtool_c33_pse_ext_substate_mr_pse_enable_ETHTOOL_C33_PSE_EXT_SUBSTATE_MR_PSE_ENABLE_DISABLE_PIN_ACTIVE : ethtool_c33_pse_ext_substate_mr_pse_enable = 1 ;
pub type ethtool_c33_pse_ext_substate_mr_pse_enable = ffi::c_uint;
pub const ethtool_c33_pse_ext_substate_option_detect_ted_ETHTOOL_C33_PSE_EXT_SUBSTATE_OPTION_DETECT_TED_DET_IN_PROCESS : ethtool_c33_pse_ext_substate_option_detect_ted = 1 ;
pub const ethtool_c33_pse_ext_substate_option_detect_ted_ETHTOOL_C33_PSE_EXT_SUBSTATE_OPTION_DETECT_TED_CONNECTION_CHECK_ERROR : ethtool_c33_pse_ext_substate_option_detect_ted = 2 ;
pub type ethtool_c33_pse_ext_substate_option_detect_ted = ffi::c_uint;
pub const ethtool_c33_pse_ext_substate_option_vport_lim_ETHTOOL_C33_PSE_EXT_SUBSTATE_OPTION_VPORT_LIM_HIGH_VOLTAGE : ethtool_c33_pse_ext_substate_option_vport_lim = 1 ;
pub const ethtool_c33_pse_ext_substate_option_vport_lim_ETHTOOL_C33_PSE_EXT_SUBSTATE_OPTION_VPORT_LIM_LOW_VOLTAGE : ethtool_c33_pse_ext_substate_option_vport_lim = 2 ;
pub const ethtool_c33_pse_ext_substate_option_vport_lim_ETHTOOL_C33_PSE_EXT_SUBSTATE_OPTION_VPORT_LIM_VOLTAGE_INJECTION : ethtool_c33_pse_ext_substate_option_vport_lim = 3 ;
pub type ethtool_c33_pse_ext_substate_option_vport_lim = ffi::c_uint;
pub const ethtool_c33_pse_ext_substate_ovld_detected_ETHTOOL_C33_PSE_EXT_SUBSTATE_OVLD_DETECTED_OVERLOAD : ethtool_c33_pse_ext_substate_ovld_detected = 1 ;
pub type ethtool_c33_pse_ext_substate_ovld_detected = ffi::c_uint;
pub const ethtool_c33_pse_ext_substate_power_not_available_ETHTOOL_C33_PSE_EXT_SUBSTATE_POWER_NOT_AVAILABLE_BUDGET_EXCEEDED : ethtool_c33_pse_ext_substate_power_not_available = 1 ;
pub const ethtool_c33_pse_ext_substate_power_not_available_ETHTOOL_C33_PSE_EXT_SUBSTATE_POWER_NOT_AVAILABLE_PORT_PW_LIMIT_EXCEEDS_CONTROLLER_BUDGET : ethtool_c33_pse_ext_substate_power_not_available = 2 ;
pub const ethtool_c33_pse_ext_substate_power_not_available_ETHTOOL_C33_PSE_EXT_SUBSTATE_POWER_NOT_AVAILABLE_PD_REQUEST_EXCEEDS_PORT_LIMIT : ethtool_c33_pse_ext_substate_power_not_available = 3 ;
pub const ethtool_c33_pse_ext_substate_power_not_available_ETHTOOL_C33_PSE_EXT_SUBSTATE_POWER_NOT_AVAILABLE_HW_PW_LIMIT : ethtool_c33_pse_ext_substate_power_not_available = 4 ;
pub type ethtool_c33_pse_ext_substate_power_not_available = ffi::c_uint;
pub const ethtool_c33_pse_ext_substate_short_detected_ETHTOOL_C33_PSE_EXT_SUBSTATE_SHORT_DETECTED_SHORT_CONDITION : ethtool_c33_pse_ext_substate_short_detected = 1 ;
pub type ethtool_c33_pse_ext_substate_short_detected = ffi::c_uint;
pub const ethtool_pse_types_ETHTOOL_PSE_UNKNOWN: ethtool_pse_types = 1;
pub const ethtool_pse_types_ETHTOOL_PSE_PODL: ethtool_pse_types = 2;
pub const ethtool_pse_types_ETHTOOL_PSE_C33: ethtool_pse_types = 4;
pub type ethtool_pse_types = ffi::c_uint;
pub const ethtool_c33_pse_admin_state_ETHTOOL_C33_PSE_ADMIN_STATE_UNKNOWN:
    ethtool_c33_pse_admin_state = 1;
pub const ethtool_c33_pse_admin_state_ETHTOOL_C33_PSE_ADMIN_STATE_DISABLED:
    ethtool_c33_pse_admin_state = 2;
pub const ethtool_c33_pse_admin_state_ETHTOOL_C33_PSE_ADMIN_STATE_ENABLED:
    ethtool_c33_pse_admin_state = 3;
pub type ethtool_c33_pse_admin_state = ffi::c_uint;
pub const ethtool_c33_pse_pw_d_status_ETHTOOL_C33_PSE_PW_D_STATUS_UNKNOWN:
    ethtool_c33_pse_pw_d_status = 1;
pub const ethtool_c33_pse_pw_d_status_ETHTOOL_C33_PSE_PW_D_STATUS_DISABLED:
    ethtool_c33_pse_pw_d_status = 2;
pub const ethtool_c33_pse_pw_d_status_ETHTOOL_C33_PSE_PW_D_STATUS_SEARCHING:
    ethtool_c33_pse_pw_d_status = 3;
pub const ethtool_c33_pse_pw_d_status_ETHTOOL_C33_PSE_PW_D_STATUS_DELIVERING:
    ethtool_c33_pse_pw_d_status = 4;
pub const ethtool_c33_pse_pw_d_status_ETHTOOL_C33_PSE_PW_D_STATUS_TEST:
    ethtool_c33_pse_pw_d_status = 5;
pub const ethtool_c33_pse_pw_d_status_ETHTOOL_C33_PSE_PW_D_STATUS_FAULT:
    ethtool_c33_pse_pw_d_status = 6;
pub const ethtool_c33_pse_pw_d_status_ETHTOOL_C33_PSE_PW_D_STATUS_OTHERFAULT:
    ethtool_c33_pse_pw_d_status = 7;
pub type ethtool_c33_pse_pw_d_status = ffi::c_uint;
pub const ethtool_podl_pse_admin_state_ETHTOOL_PODL_PSE_ADMIN_STATE_UNKNOWN:
    ethtool_podl_pse_admin_state = 1;
pub const ethtool_podl_pse_admin_state_ETHTOOL_PODL_PSE_ADMIN_STATE_DISABLED:
    ethtool_podl_pse_admin_state = 2;
pub const ethtool_podl_pse_admin_state_ETHTOOL_PODL_PSE_ADMIN_STATE_ENABLED:
    ethtool_podl_pse_admin_state = 3;
pub type ethtool_podl_pse_admin_state = ffi::c_uint;
pub const ethtool_podl_pse_pw_d_status_ETHTOOL_PODL_PSE_PW_D_STATUS_UNKNOWN:
    ethtool_podl_pse_pw_d_status = 1;
pub const ethtool_podl_pse_pw_d_status_ETHTOOL_PODL_PSE_PW_D_STATUS_DISABLED:
    ethtool_podl_pse_pw_d_status = 2;
pub const ethtool_podl_pse_pw_d_status_ETHTOOL_PODL_PSE_PW_D_STATUS_SEARCHING:
    ethtool_podl_pse_pw_d_status = 3;
pub const ethtool_podl_pse_pw_d_status_ETHTOOL_PODL_PSE_PW_D_STATUS_DELIVERING:
    ethtool_podl_pse_pw_d_status = 4;
pub const ethtool_podl_pse_pw_d_status_ETHTOOL_PODL_PSE_PW_D_STATUS_SLEEP:
    ethtool_podl_pse_pw_d_status = 5;
pub const ethtool_podl_pse_pw_d_status_ETHTOOL_PODL_PSE_PW_D_STATUS_IDLE:
    ethtool_podl_pse_pw_d_status = 6;
pub const ethtool_podl_pse_pw_d_status_ETHTOOL_PODL_PSE_PW_D_STATUS_ERROR:
    ethtool_podl_pse_pw_d_status = 7;
pub type ethtool_podl_pse_pw_d_status = ffi::c_uint;
pub const ethtool_mm_verify_status_ETHTOOL_MM_VERIFY_STATUS_UNKNOWN: ethtool_mm_verify_status = 0;
pub const ethtool_mm_verify_status_ETHTOOL_MM_VERIFY_STATUS_INITIAL: ethtool_mm_verify_status = 1;
pub const ethtool_mm_verify_status_ETHTOOL_MM_VERIFY_STATUS_VERIFYING: ethtool_mm_verify_status = 2;
pub const ethtool_mm_verify_status_ETHTOOL_MM_VERIFY_STATUS_SUCCEEDED: ethtool_mm_verify_status = 3;
pub const ethtool_mm_verify_status_ETHTOOL_MM_VERIFY_STATUS_FAILED: ethtool_mm_verify_status = 4;
pub const ethtool_mm_verify_status_ETHTOOL_MM_VERIFY_STATUS_DISABLED: ethtool_mm_verify_status = 5;
pub type ethtool_mm_verify_status = ffi::c_uint;
pub const ethtool_module_fw_flash_status_ETHTOOL_MODULE_FW_FLASH_STATUS_STARTED:
    ethtool_module_fw_flash_status = 1;
pub const ethtool_module_fw_flash_status_ETHTOOL_MODULE_FW_FLASH_STATUS_IN_PROGRESS:
    ethtool_module_fw_flash_status = 2;
pub const ethtool_module_fw_flash_status_ETHTOOL_MODULE_FW_FLASH_STATUS_COMPLETED:
    ethtool_module_fw_flash_status = 3;
pub const ethtool_module_fw_flash_status_ETHTOOL_MODULE_FW_FLASH_STATUS_ERROR:
    ethtool_module_fw_flash_status = 4;
pub type ethtool_module_fw_flash_status = ffi::c_uint;
#[repr(C)]
#[derive(Default)]
pub struct ethtool_gstrings {
    pub cmd: __u32,
    pub string_set: __u32,
    pub len: __u32,
    pub data: __IncompleteArrayField<__u8>,
}
#[repr(C)]
#[derive(Default)]
pub struct ethtool_sset_info {
    pub cmd: __u32,
    pub reserved: __u32,
    pub sset_mask: __u64,
    pub data: __IncompleteArrayField<__u32>,
}
pub const ethtool_test_flags_ETH_TEST_FL_OFFLINE: ethtool_test_flags = 1;
pub const ethtool_test_flags_ETH_TEST_FL_FAILED: ethtool_test_flags = 2;
pub const ethtool_test_flags_ETH_TEST_FL_EXTERNAL_LB: ethtool_test_flags = 4;
pub const ethtool_test_flags_ETH_TEST_FL_EXTERNAL_LB_DONE: ethtool_test_flags = 8;
pub type ethtool_test_flags = ffi::c_uint;
#[repr(C)]
#[derive(Default)]
pub struct ethtool_test {
    pub cmd: __u32,
    pub flags: __u32,
    pub reserved: __u32,
    pub len: __u32,
    pub data: __IncompleteArrayField<__u64>,
}
#[repr(C)]
#[derive(Default)]
pub struct ethtool_stats {
    pub cmd: __u32,
    pub n_stats: __u32,
    pub data: __IncompleteArrayField<__u64>,
}
#[repr(C)]
#[derive(Default)]
pub struct ethtool_perm_addr {
    pub cmd: __u32,
    pub size: __u32,
    pub data: __IncompleteArrayField<__u8>,
}
pub const ethtool_flags_ETH_FLAG_TXVLAN: ethtool_flags = 128;
pub const ethtool_flags_ETH_FLAG_RXVLAN: ethtool_flags = 256;
pub const ethtool_flags_ETH_FLAG_LRO: ethtool_flags = 32768;
pub const ethtool_flags_ETH_FLAG_NTUPLE: ethtool_flags = 134217728;
pub const ethtool_flags_ETH_FLAG_RXHASH: ethtool_flags = 268435456;
pub type ethtool_flags = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_tcpip4_spec {
    pub ip4src: __be32,
    pub ip4dst: __be32,
    pub psrc: __be16,
    pub pdst: __be16,
    pub tos: __u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_ah_espip4_spec {
    pub ip4src: __be32,
    pub ip4dst: __be32,
    pub spi: __be32,
    pub tos: __u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_usrip4_spec {
    pub ip4src: __be32,
    pub ip4dst: __be32,
    pub l4_4_bytes: __be32,
    pub tos: __u8,
    pub ip_ver: __u8,
    pub proto: __u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_tcpip6_spec {
    pub ip6src: [__be32; 4usize],
    pub ip6dst: [__be32; 4usize],
    pub psrc: __be16,
    pub pdst: __be16,
    pub tclass: __u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_ah_espip6_spec {
    pub ip6src: [__be32; 4usize],
    pub ip6dst: [__be32; 4usize],
    pub spi: __be32,
    pub tclass: __u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_usrip6_spec {
    pub ip6src: [__be32; 4usize],
    pub ip6dst: [__be32; 4usize],
    pub l4_4_bytes: __be32,
    pub tclass: __u8,
    pub l4_proto: __u8,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union ethtool_flow_union {
    pub tcp_ip4_spec: ethtool_tcpip4_spec,
    pub udp_ip4_spec: ethtool_tcpip4_spec,
    pub sctp_ip4_spec: ethtool_tcpip4_spec,
    pub ah_ip4_spec: ethtool_ah_espip4_spec,
    pub esp_ip4_spec: ethtool_ah_espip4_spec,
    pub usr_ip4_spec: ethtool_usrip4_spec,
    pub tcp_ip6_spec: ethtool_tcpip6_spec,
    pub udp_ip6_spec: ethtool_tcpip6_spec,
    pub sctp_ip6_spec: ethtool_tcpip6_spec,
    pub ah_ip6_spec: ethtool_ah_espip6_spec,
    pub esp_ip6_spec: ethtool_ah_espip6_spec,
    pub usr_ip6_spec: ethtool_usrip6_spec,
    pub ether_spec: ethhdr,
    pub hdata: [__u8; 52usize],
}
impl Default for ethtool_flow_union {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_flow_ext {
    pub padding: [__u8; 2usize],
    pub h_dest: [ffi::c_uchar; 6usize],
    pub vlan_etype: __be16,
    pub vlan_tci: __be16,
    pub data: [__be32; 2usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ethtool_rx_flow_spec {
    pub flow_type: __u32,
    pub h_u: ethtool_flow_union,
    pub h_ext: ethtool_flow_ext,
    pub m_u: ethtool_flow_union,
    pub m_ext: ethtool_flow_ext,
    pub ring_cookie: __u64,
    pub location: __u32,
}
impl Default for ethtool_rx_flow_spec {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct ethtool_rxnfc {
    pub cmd: __u32,
    pub flow_type: __u32,
    pub data: __u64,
    pub fs: ethtool_rx_flow_spec,
    pub __bindgen_anon_1: ethtool_rxnfc__bindgen_ty_1,
    pub rule_locs: __IncompleteArrayField<__u32>,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union ethtool_rxnfc__bindgen_ty_1 {
    pub rule_cnt: __u32,
    pub rss_context: __u32,
}
impl Default for ethtool_rxnfc__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for ethtool_rxnfc {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default)]
pub struct ethtool_rxfh_indir {
    pub cmd: __u32,
    pub size: __u32,
    pub ring_index: __IncompleteArrayField<__u32>,
}
#[repr(C)]
#[derive(Default)]
pub struct ethtool_rxfh {
    pub cmd: __u32,
    pub rss_context: __u32,
    pub indir_size: __u32,
    pub key_size: __u32,
    pub hfunc: __u8,
    pub input_xfrm: __u8,
    pub rsvd8: [__u8; 2usize],
    pub rsvd32: __u32,
    pub rss_config: __IncompleteArrayField<__u32>,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ethtool_rx_ntuple_flow_spec {
    pub flow_type: __u32,
    pub h_u: ethtool_rx_ntuple_flow_spec__bindgen_ty_1,
    pub m_u: ethtool_rx_ntuple_flow_spec__bindgen_ty_1,
    pub vlan_tag: __u16,
    pub vlan_tag_mask: __u16,
    pub data: __u64,
    pub data_mask: __u64,
    pub action: __s32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union ethtool_rx_ntuple_flow_spec__bindgen_ty_1 {
    pub tcp_ip4_spec: ethtool_tcpip4_spec,
    pub udp_ip4_spec: ethtool_tcpip4_spec,
    pub sctp_ip4_spec: ethtool_tcpip4_spec,
    pub ah_ip4_spec: ethtool_ah_espip4_spec,
    pub esp_ip4_spec: ethtool_ah_espip4_spec,
    pub usr_ip4_spec: ethtool_usrip4_spec,
    pub ether_spec: ethhdr,
    pub hdata: [__u8; 72usize],
}
impl Default for ethtool_rx_ntuple_flow_spec__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for ethtool_rx_ntuple_flow_spec {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ethtool_rx_ntuple {
    pub cmd: __u32,
    pub fs: ethtool_rx_ntuple_flow_spec,
}
impl Default for ethtool_rx_ntuple {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const ethtool_flash_op_type_ETHTOOL_FLASH_ALL_REGIONS: ethtool_flash_op_type = 0;
pub type ethtool_flash_op_type = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ethtool_flash {
    pub cmd: __u32,
    pub region: __u32,
    pub data: [ffi::c_char; 128usize],
}
impl Default for ethtool_flash {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default)]
pub struct ethtool_dump {
    pub cmd: __u32,
    pub version: __u32,
    pub flag: __u32,
    pub len: __u32,
    pub data: __IncompleteArrayField<__u8>,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_get_features_block {
    pub available: __u32,
    pub requested: __u32,
    pub active: __u32,
    pub never_changed: __u32,
}
#[repr(C)]
#[derive(Default)]
pub struct ethtool_gfeatures {
    pub cmd: __u32,
    pub size: __u32,
    pub features: __IncompleteArrayField<ethtool_get_features_block>,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_set_features_block {
    pub valid: __u32,
    pub requested: __u32,
}
#[repr(C)]
#[derive(Default)]
pub struct ethtool_sfeatures {
    pub cmd: __u32,
    pub size: __u32,
    pub features: __IncompleteArrayField<ethtool_set_features_block>,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_ts_info {
    pub cmd: __u32,
    pub so_timestamping: __u32,
    pub phc_index: __s32,
    pub tx_types: __u32,
    pub tx_reserved: [__u32; 3usize],
    pub rx_filters: __u32,
    pub rx_reserved: [__u32; 3usize],
}
pub const ethtool_sfeatures_retval_bits_ETHTOOL_F_UNSUPPORTED__BIT: ethtool_sfeatures_retval_bits =
    0;
pub const ethtool_sfeatures_retval_bits_ETHTOOL_F_WISH__BIT: ethtool_sfeatures_retval_bits = 1;
pub const ethtool_sfeatures_retval_bits_ETHTOOL_F_COMPAT__BIT: ethtool_sfeatures_retval_bits = 2;
pub type ethtool_sfeatures_retval_bits = ffi::c_uint;
#[repr(C)]
pub struct ethtool_per_queue_op {
    pub cmd: __u32,
    pub sub_command: __u32,
    pub queue_mask: [__u32; 128usize],
    pub data: __IncompleteArrayField<ffi::c_char>,
}
impl Default for ethtool_per_queue_op {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_fecparam {
    pub cmd: __u32,
    pub active_fec: __u32,
    pub fec: __u32,
    pub reserved: __u32,
}
pub const ethtool_fec_config_bits_ETHTOOL_FEC_NONE_BIT: ethtool_fec_config_bits = 0;
pub const ethtool_fec_config_bits_ETHTOOL_FEC_AUTO_BIT: ethtool_fec_config_bits = 1;
pub const ethtool_fec_config_bits_ETHTOOL_FEC_OFF_BIT: ethtool_fec_config_bits = 2;
pub const ethtool_fec_config_bits_ETHTOOL_FEC_RS_BIT: ethtool_fec_config_bits = 3;
pub const ethtool_fec_config_bits_ETHTOOL_FEC_BASER_BIT: ethtool_fec_config_bits = 4;
pub const ethtool_fec_config_bits_ETHTOOL_FEC_LLRS_BIT: ethtool_fec_config_bits = 5;
pub type ethtool_fec_config_bits = ffi::c_uint;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_10baseT_Half_BIT:
    ethtool_link_mode_bit_indices = 0;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_10baseT_Full_BIT:
    ethtool_link_mode_bit_indices = 1;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_100baseT_Half_BIT:
    ethtool_link_mode_bit_indices = 2;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_100baseT_Full_BIT:
    ethtool_link_mode_bit_indices = 3;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_1000baseT_Half_BIT:
    ethtool_link_mode_bit_indices = 4;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_1000baseT_Full_BIT:
    ethtool_link_mode_bit_indices = 5;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_Autoneg_BIT:
    ethtool_link_mode_bit_indices = 6;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_TP_BIT: ethtool_link_mode_bit_indices = 7;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_AUI_BIT: ethtool_link_mode_bit_indices =
    8;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_MII_BIT: ethtool_link_mode_bit_indices =
    9;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_FIBRE_BIT: ethtool_link_mode_bit_indices =
    10;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_BNC_BIT: ethtool_link_mode_bit_indices =
    11;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_10000baseT_Full_BIT:
    ethtool_link_mode_bit_indices = 12;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_Pause_BIT: ethtool_link_mode_bit_indices =
    13;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_Asym_Pause_BIT:
    ethtool_link_mode_bit_indices = 14;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_2500baseX_Full_BIT:
    ethtool_link_mode_bit_indices = 15;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_Backplane_BIT:
    ethtool_link_mode_bit_indices = 16;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_1000baseKX_Full_BIT:
    ethtool_link_mode_bit_indices = 17;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_10000baseKX4_Full_BIT:
    ethtool_link_mode_bit_indices = 18;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_10000baseKR_Full_BIT:
    ethtool_link_mode_bit_indices = 19;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_10000baseR_FEC_BIT:
    ethtool_link_mode_bit_indices = 20;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_20000baseMLD2_Full_BIT:
    ethtool_link_mode_bit_indices = 21;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_20000baseKR2_Full_BIT:
    ethtool_link_mode_bit_indices = 22;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_40000baseKR4_Full_BIT:
    ethtool_link_mode_bit_indices = 23;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_40000baseCR4_Full_BIT:
    ethtool_link_mode_bit_indices = 24;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_40000baseSR4_Full_BIT:
    ethtool_link_mode_bit_indices = 25;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_40000baseLR4_Full_BIT:
    ethtool_link_mode_bit_indices = 26;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_56000baseKR4_Full_BIT:
    ethtool_link_mode_bit_indices = 27;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_56000baseCR4_Full_BIT:
    ethtool_link_mode_bit_indices = 28;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_56000baseSR4_Full_BIT:
    ethtool_link_mode_bit_indices = 29;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_56000baseLR4_Full_BIT:
    ethtool_link_mode_bit_indices = 30;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_25000baseCR_Full_BIT:
    ethtool_link_mode_bit_indices = 31;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_25000baseKR_Full_BIT:
    ethtool_link_mode_bit_indices = 32;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_25000baseSR_Full_BIT:
    ethtool_link_mode_bit_indices = 33;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_50000baseCR2_Full_BIT:
    ethtool_link_mode_bit_indices = 34;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_50000baseKR2_Full_BIT:
    ethtool_link_mode_bit_indices = 35;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_100000baseKR4_Full_BIT:
    ethtool_link_mode_bit_indices = 36;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_100000baseSR4_Full_BIT:
    ethtool_link_mode_bit_indices = 37;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_100000baseCR4_Full_BIT:
    ethtool_link_mode_bit_indices = 38;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_100000baseLR4_ER4_Full_BIT:
    ethtool_link_mode_bit_indices = 39;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_50000baseSR2_Full_BIT:
    ethtool_link_mode_bit_indices = 40;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_1000baseX_Full_BIT:
    ethtool_link_mode_bit_indices = 41;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_10000baseCR_Full_BIT:
    ethtool_link_mode_bit_indices = 42;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_10000baseSR_Full_BIT:
    ethtool_link_mode_bit_indices = 43;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_10000baseLR_Full_BIT:
    ethtool_link_mode_bit_indices = 44;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_10000baseLRM_Full_BIT:
    ethtool_link_mode_bit_indices = 45;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_10000baseER_Full_BIT:
    ethtool_link_mode_bit_indices = 46;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_2500baseT_Full_BIT:
    ethtool_link_mode_bit_indices = 47;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_5000baseT_Full_BIT:
    ethtool_link_mode_bit_indices = 48;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_FEC_NONE_BIT:
    ethtool_link_mode_bit_indices = 49;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_FEC_RS_BIT:
    ethtool_link_mode_bit_indices = 50;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_FEC_BASER_BIT:
    ethtool_link_mode_bit_indices = 51;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_50000baseKR_Full_BIT:
    ethtool_link_mode_bit_indices = 52;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_50000baseSR_Full_BIT:
    ethtool_link_mode_bit_indices = 53;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_50000baseCR_Full_BIT:
    ethtool_link_mode_bit_indices = 54;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_50000baseLR_ER_FR_Full_BIT:
    ethtool_link_mode_bit_indices = 55;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_50000baseDR_Full_BIT:
    ethtool_link_mode_bit_indices = 56;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_100000baseKR2_Full_BIT:
    ethtool_link_mode_bit_indices = 57;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_100000baseSR2_Full_BIT:
    ethtool_link_mode_bit_indices = 58;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_100000baseCR2_Full_BIT:
    ethtool_link_mode_bit_indices = 59;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_100000baseLR2_ER2_FR2_Full_BIT:
    ethtool_link_mode_bit_indices = 60;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_100000baseDR2_Full_BIT:
    ethtool_link_mode_bit_indices = 61;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_200000baseKR4_Full_BIT:
    ethtool_link_mode_bit_indices = 62;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_200000baseSR4_Full_BIT:
    ethtool_link_mode_bit_indices = 63;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_200000baseLR4_ER4_FR4_Full_BIT:
    ethtool_link_mode_bit_indices = 64;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_200000baseDR4_Full_BIT:
    ethtool_link_mode_bit_indices = 65;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_200000baseCR4_Full_BIT:
    ethtool_link_mode_bit_indices = 66;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_100baseT1_Full_BIT:
    ethtool_link_mode_bit_indices = 67;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_1000baseT1_Full_BIT:
    ethtool_link_mode_bit_indices = 68;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_400000baseKR8_Full_BIT:
    ethtool_link_mode_bit_indices = 69;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_400000baseSR8_Full_BIT:
    ethtool_link_mode_bit_indices = 70;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_400000baseLR8_ER8_FR8_Full_BIT:
    ethtool_link_mode_bit_indices = 71;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_400000baseDR8_Full_BIT:
    ethtool_link_mode_bit_indices = 72;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_400000baseCR8_Full_BIT:
    ethtool_link_mode_bit_indices = 73;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_FEC_LLRS_BIT:
    ethtool_link_mode_bit_indices = 74;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_100000baseKR_Full_BIT:
    ethtool_link_mode_bit_indices = 75;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_100000baseSR_Full_BIT:
    ethtool_link_mode_bit_indices = 76;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_100000baseLR_ER_FR_Full_BIT:
    ethtool_link_mode_bit_indices = 77;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_100000baseCR_Full_BIT:
    ethtool_link_mode_bit_indices = 78;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_100000baseDR_Full_BIT:
    ethtool_link_mode_bit_indices = 79;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_200000baseKR2_Full_BIT:
    ethtool_link_mode_bit_indices = 80;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_200000baseSR2_Full_BIT:
    ethtool_link_mode_bit_indices = 81;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_200000baseLR2_ER2_FR2_Full_BIT:
    ethtool_link_mode_bit_indices = 82;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_200000baseDR2_Full_BIT:
    ethtool_link_mode_bit_indices = 83;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_200000baseCR2_Full_BIT:
    ethtool_link_mode_bit_indices = 84;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_400000baseKR4_Full_BIT:
    ethtool_link_mode_bit_indices = 85;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_400000baseSR4_Full_BIT:
    ethtool_link_mode_bit_indices = 86;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_400000baseLR4_ER4_FR4_Full_BIT:
    ethtool_link_mode_bit_indices = 87;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_400000baseDR4_Full_BIT:
    ethtool_link_mode_bit_indices = 88;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_400000baseCR4_Full_BIT:
    ethtool_link_mode_bit_indices = 89;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_100baseFX_Half_BIT:
    ethtool_link_mode_bit_indices = 90;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_100baseFX_Full_BIT:
    ethtool_link_mode_bit_indices = 91;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_10baseT1L_Full_BIT:
    ethtool_link_mode_bit_indices = 92;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_800000baseCR8_Full_BIT:
    ethtool_link_mode_bit_indices = 93;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_800000baseKR8_Full_BIT:
    ethtool_link_mode_bit_indices = 94;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_800000baseDR8_Full_BIT:
    ethtool_link_mode_bit_indices = 95;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_800000baseDR8_2_Full_BIT:
    ethtool_link_mode_bit_indices = 96;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_800000baseSR8_Full_BIT:
    ethtool_link_mode_bit_indices = 97;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_800000baseVR8_Full_BIT:
    ethtool_link_mode_bit_indices = 98;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_10baseT1S_Full_BIT:
    ethtool_link_mode_bit_indices = 99;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_10baseT1S_Half_BIT:
    ethtool_link_mode_bit_indices = 100;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_10baseT1S_P2MP_Half_BIT:
    ethtool_link_mode_bit_indices = 101;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_10baseT1BRR_Full_BIT:
    ethtool_link_mode_bit_indices = 102;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_200000baseCR_Full_BIT:
    ethtool_link_mode_bit_indices = 103;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_200000baseKR_Full_BIT:
    ethtool_link_mode_bit_indices = 104;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_200000baseDR_Full_BIT:
    ethtool_link_mode_bit_indices = 105;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_200000baseDR_2_Full_BIT:
    ethtool_link_mode_bit_indices = 106;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_200000baseSR_Full_BIT:
    ethtool_link_mode_bit_indices = 107;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_200000baseVR_Full_BIT:
    ethtool_link_mode_bit_indices = 108;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_400000baseCR2_Full_BIT:
    ethtool_link_mode_bit_indices = 109;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_400000baseKR2_Full_BIT:
    ethtool_link_mode_bit_indices = 110;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_400000baseDR2_Full_BIT:
    ethtool_link_mode_bit_indices = 111;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_400000baseDR2_2_Full_BIT:
    ethtool_link_mode_bit_indices = 112;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_400000baseSR2_Full_BIT:
    ethtool_link_mode_bit_indices = 113;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_400000baseVR2_Full_BIT:
    ethtool_link_mode_bit_indices = 114;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_800000baseCR4_Full_BIT:
    ethtool_link_mode_bit_indices = 115;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_800000baseKR4_Full_BIT:
    ethtool_link_mode_bit_indices = 116;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_800000baseDR4_Full_BIT:
    ethtool_link_mode_bit_indices = 117;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_800000baseDR4_2_Full_BIT:
    ethtool_link_mode_bit_indices = 118;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_800000baseSR4_Full_BIT:
    ethtool_link_mode_bit_indices = 119;
pub const ethtool_link_mode_bit_indices_ETHTOOL_LINK_MODE_800000baseVR4_Full_BIT:
    ethtool_link_mode_bit_indices = 120;
pub const ethtool_link_mode_bit_indices___ETHTOOL_LINK_MODE_MASK_NBITS:
    ethtool_link_mode_bit_indices = 121;
pub type ethtool_link_mode_bit_indices = ffi::c_uint;
pub const ethtool_reset_flags_ETH_RESET_MGMT: ethtool_reset_flags = 1;
pub const ethtool_reset_flags_ETH_RESET_IRQ: ethtool_reset_flags = 2;
pub const ethtool_reset_flags_ETH_RESET_DMA: ethtool_reset_flags = 4;
pub const ethtool_reset_flags_ETH_RESET_FILTER: ethtool_reset_flags = 8;
pub const ethtool_reset_flags_ETH_RESET_OFFLOAD: ethtool_reset_flags = 16;
pub const ethtool_reset_flags_ETH_RESET_MAC: ethtool_reset_flags = 32;
pub const ethtool_reset_flags_ETH_RESET_PHY: ethtool_reset_flags = 64;
pub const ethtool_reset_flags_ETH_RESET_RAM: ethtool_reset_flags = 128;
pub const ethtool_reset_flags_ETH_RESET_AP: ethtool_reset_flags = 256;
pub const ethtool_reset_flags_ETH_RESET_DEDICATED: ethtool_reset_flags = 65535;
pub const ethtool_reset_flags_ETH_RESET_ALL: ethtool_reset_flags = 4294967295;
pub type ethtool_reset_flags = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_link_settings {
    pub cmd: __u32,
    pub speed: __u32,
    pub duplex: __u8,
    pub port: __u8,
    pub phy_address: __u8,
    pub autoneg: __u8,
    pub mdio_support: __u8,
    pub eth_tp_mdix: __u8,
    pub eth_tp_mdix_ctrl: __u8,
    pub link_mode_masks_nwords: __s8,
    pub transceiver: __u8,
    pub master_slave_cfg: __u8,
    pub master_slave_state: __u8,
    pub rate_matching: __u8,
    pub reserved: [__u32; 7usize],
}
pub const phy_upstream_PHY_UPSTREAM_MAC: phy_upstream = 0;
pub const phy_upstream_PHY_UPSTREAM_PHY: phy_upstream = 1;
pub type phy_upstream = ffi::c_uint;
pub const hwtstamp_provider_qualifier_HWTSTAMP_PROVIDER_QUALIFIER_PRECISE:
    hwtstamp_provider_qualifier = 0;
pub const hwtstamp_provider_qualifier_HWTSTAMP_PROVIDER_QUALIFIER_APPROX:
    hwtstamp_provider_qualifier = 1;
pub const hwtstamp_provider_qualifier_HWTSTAMP_PROVIDER_QUALIFIER_CNT: hwtstamp_provider_qualifier =
    2;
pub type hwtstamp_provider_qualifier = ffi::c_uint;
pub const SOF_TIMESTAMPING_TX_HARDWARE: _bindgen_ty_265 = 1;
pub const SOF_TIMESTAMPING_TX_SOFTWARE: _bindgen_ty_265 = 2;
pub const SOF_TIMESTAMPING_RX_HARDWARE: _bindgen_ty_265 = 4;
pub const SOF_TIMESTAMPING_RX_SOFTWARE: _bindgen_ty_265 = 8;
pub const SOF_TIMESTAMPING_SOFTWARE: _bindgen_ty_265 = 16;
pub const SOF_TIMESTAMPING_SYS_HARDWARE: _bindgen_ty_265 = 32;
pub const SOF_TIMESTAMPING_RAW_HARDWARE: _bindgen_ty_265 = 64;
pub const SOF_TIMESTAMPING_OPT_ID: _bindgen_ty_265 = 128;
pub const SOF_TIMESTAMPING_TX_SCHED: _bindgen_ty_265 = 256;
pub const SOF_TIMESTAMPING_TX_ACK: _bindgen_ty_265 = 512;
pub const SOF_TIMESTAMPING_OPT_CMSG: _bindgen_ty_265 = 1024;
pub const SOF_TIMESTAMPING_OPT_TSONLY: _bindgen_ty_265 = 2048;
pub const SOF_TIMESTAMPING_OPT_STATS: _bindgen_ty_265 = 4096;
pub const SOF_TIMESTAMPING_OPT_PKTINFO: _bindgen_ty_265 = 8192;
pub const SOF_TIMESTAMPING_OPT_TX_SWHW: _bindgen_ty_265 = 16384;
pub const SOF_TIMESTAMPING_BIND_PHC: _bindgen_ty_265 = 32768;
pub const SOF_TIMESTAMPING_OPT_ID_TCP: _bindgen_ty_265 = 65536;
pub const SOF_TIMESTAMPING_OPT_RX_FILTER: _bindgen_ty_265 = 131072;
pub const SOF_TIMESTAMPING_TX_COMPLETION: _bindgen_ty_265 = 262144;
pub const SOF_TIMESTAMPING_LAST: _bindgen_ty_265 = 262144;
pub const SOF_TIMESTAMPING_MASK: _bindgen_ty_265 = 524287;
pub type _bindgen_ty_265 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct so_timestamping {
    pub flags: ffi::c_int,
    pub bind_phc: ffi::c_int,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct hwtstamp_config {
    pub flags: ffi::c_int,
    pub tx_type: ffi::c_int,
    pub rx_filter: ffi::c_int,
}
pub const hwtstamp_flags_HWTSTAMP_FLAG_BONDED_PHC_INDEX: hwtstamp_flags = 1;
pub const hwtstamp_flags_HWTSTAMP_FLAG_LAST: hwtstamp_flags = 1;
pub const hwtstamp_flags_HWTSTAMP_FLAG_MASK: hwtstamp_flags = 1;
pub type hwtstamp_flags = ffi::c_uint;
pub const hwtstamp_tx_types_HWTSTAMP_TX_OFF: hwtstamp_tx_types = 0;
pub const hwtstamp_tx_types_HWTSTAMP_TX_ON: hwtstamp_tx_types = 1;
pub const hwtstamp_tx_types_HWTSTAMP_TX_ONESTEP_SYNC: hwtstamp_tx_types = 2;
pub const hwtstamp_tx_types_HWTSTAMP_TX_ONESTEP_P2P: hwtstamp_tx_types = 3;
pub const hwtstamp_tx_types___HWTSTAMP_TX_CNT: hwtstamp_tx_types = 4;
pub type hwtstamp_tx_types = ffi::c_uint;
pub const hwtstamp_rx_filters_HWTSTAMP_FILTER_NONE: hwtstamp_rx_filters = 0;
pub const hwtstamp_rx_filters_HWTSTAMP_FILTER_ALL: hwtstamp_rx_filters = 1;
pub const hwtstamp_rx_filters_HWTSTAMP_FILTER_SOME: hwtstamp_rx_filters = 2;
pub const hwtstamp_rx_filters_HWTSTAMP_FILTER_PTP_V1_L4_EVENT: hwtstamp_rx_filters = 3;
pub const hwtstamp_rx_filters_HWTSTAMP_FILTER_PTP_V1_L4_SYNC: hwtstamp_rx_filters = 4;
pub const hwtstamp_rx_filters_HWTSTAMP_FILTER_PTP_V1_L4_DELAY_REQ: hwtstamp_rx_filters = 5;
pub const hwtstamp_rx_filters_HWTSTAMP_FILTER_PTP_V2_L4_EVENT: hwtstamp_rx_filters = 6;
pub const hwtstamp_rx_filters_HWTSTAMP_FILTER_PTP_V2_L4_SYNC: hwtstamp_rx_filters = 7;
pub const hwtstamp_rx_filters_HWTSTAMP_FILTER_PTP_V2_L4_DELAY_REQ: hwtstamp_rx_filters = 8;
pub const hwtstamp_rx_filters_HWTSTAMP_FILTER_PTP_V2_L2_EVENT: hwtstamp_rx_filters = 9;
pub const hwtstamp_rx_filters_HWTSTAMP_FILTER_PTP_V2_L2_SYNC: hwtstamp_rx_filters = 10;
pub const hwtstamp_rx_filters_HWTSTAMP_FILTER_PTP_V2_L2_DELAY_REQ: hwtstamp_rx_filters = 11;
pub const hwtstamp_rx_filters_HWTSTAMP_FILTER_PTP_V2_EVENT: hwtstamp_rx_filters = 12;
pub const hwtstamp_rx_filters_HWTSTAMP_FILTER_PTP_V2_SYNC: hwtstamp_rx_filters = 13;
pub const hwtstamp_rx_filters_HWTSTAMP_FILTER_PTP_V2_DELAY_REQ: hwtstamp_rx_filters = 14;
pub const hwtstamp_rx_filters_HWTSTAMP_FILTER_NTP_ALL: hwtstamp_rx_filters = 15;
pub const hwtstamp_rx_filters___HWTSTAMP_FILTER_CNT: hwtstamp_rx_filters = 16;
pub type hwtstamp_rx_filters = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct scm_ts_pktinfo {
    pub if_index: __u32,
    pub pkt_length: __u32,
    pub reserved: [__u32; 2usize],
}
pub const txtime_flags_SOF_TXTIME_DEADLINE_MODE: txtime_flags = 1;
pub const txtime_flags_SOF_TXTIME_REPORT_ERRORS: txtime_flags = 2;
pub const txtime_flags_SOF_TXTIME_FLAGS_LAST: txtime_flags = 2;
pub const txtime_flags_SOF_TXTIME_FLAGS_MASK: txtime_flags = 3;
pub type txtime_flags = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sock_txtime {
    pub clockid: __kernel_clockid_t,
    pub flags: __u32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct compat_ethtool_rx_flow_spec {
    pub flow_type: u32_,
    pub h_u: ethtool_flow_union,
    pub h_ext: ethtool_flow_ext,
    pub m_u: ethtool_flow_union,
    pub m_ext: ethtool_flow_ext,
    pub ring_cookie: compat_u64,
    pub location: u32_,
}
impl Default for compat_ethtool_rx_flow_spec {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct compat_ethtool_rxnfc {
    pub cmd: u32_,
    pub flow_type: u32_,
    pub data: compat_u64,
    pub fs: compat_ethtool_rx_flow_spec,
    pub rule_cnt: u32_,
    pub rule_locs: __IncompleteArrayField<u32_>,
}
impl Default for compat_ethtool_rxnfc {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const ethtool_phys_id_state_ETHTOOL_ID_INACTIVE: ethtool_phys_id_state = 0;
pub const ethtool_phys_id_state_ETHTOOL_ID_ACTIVE: ethtool_phys_id_state = 1;
pub const ethtool_phys_id_state_ETHTOOL_ID_ON: ethtool_phys_id_state = 2;
pub const ethtool_phys_id_state_ETHTOOL_ID_OFF: ethtool_phys_id_state = 3;
pub type ethtool_phys_id_state = ffi::c_uint;
pub const ETH_RSS_HASH_TOP_BIT: _bindgen_ty_266 = 0;
pub const ETH_RSS_HASH_XOR_BIT: _bindgen_ty_266 = 1;
pub const ETH_RSS_HASH_CRC32_BIT: _bindgen_ty_266 = 2;
pub const ETH_RSS_HASH_FUNCS_COUNT: _bindgen_ty_266 = 3;
pub type _bindgen_ty_266 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct kernel_ethtool_ringparam {
    pub rx_buf_len: u32_,
    pub tcp_data_split: u8_,
    pub tx_push: u8_,
    pub rx_push: u8_,
    pub cqe_size: u32_,
    pub tx_push_buf_len: u32_,
    pub tx_push_buf_max_len: u32_,
    pub hds_thresh: u32_,
    pub hds_thresh_max: u32_,
}
pub const ethtool_supported_ring_param_ETHTOOL_RING_USE_RX_BUF_LEN: ethtool_supported_ring_param =
    1;
pub const ethtool_supported_ring_param_ETHTOOL_RING_USE_CQE_SIZE: ethtool_supported_ring_param = 2;
pub const ethtool_supported_ring_param_ETHTOOL_RING_USE_TX_PUSH: ethtool_supported_ring_param = 4;
pub const ethtool_supported_ring_param_ETHTOOL_RING_USE_RX_PUSH: ethtool_supported_ring_param = 8;
pub const ethtool_supported_ring_param_ETHTOOL_RING_USE_TX_PUSH_BUF_LEN:
    ethtool_supported_ring_param = 16;
pub const ethtool_supported_ring_param_ETHTOOL_RING_USE_TCP_DATA_SPLIT:
    ethtool_supported_ring_param = 32;
pub const ethtool_supported_ring_param_ETHTOOL_RING_USE_HDS_THRS: ethtool_supported_ring_param = 64;
pub type ethtool_supported_ring_param = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ethtool_link_ext_state_info {
    pub link_ext_state: ethtool_link_ext_state,
    pub __bindgen_anon_1: ethtool_link_ext_state_info__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union ethtool_link_ext_state_info__bindgen_ty_1 {
    pub autoneg: ethtool_link_ext_substate_autoneg,
    pub link_training: ethtool_link_ext_substate_link_training,
    pub link_logical_mismatch: ethtool_link_ext_substate_link_logical_mismatch,
    pub bad_signal_integrity: ethtool_link_ext_substate_bad_signal_integrity,
    pub cable_issue: ethtool_link_ext_substate_cable_issue,
    pub module: ethtool_link_ext_substate_module,
    pub __link_ext_substate: u32_,
}
impl Default for ethtool_link_ext_state_info__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for ethtool_link_ext_state_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_link_ext_stats {
    pub link_down_events: u64_,
}
#[repr(C)]
#[repr(align(8))]
#[derive(Default)]
pub struct ethtool_rxfh_context {
    pub indir_size: u32_,
    pub key_size: u32_,
    pub priv_size: u16_,
    pub hfunc: u8_,
    pub input_xfrm: u8_,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub key_off: u32_,
    pub __bindgen_padding_0: [u8; 4usize],
    pub data: __IncompleteArrayField<u8_>,
}
impl ethtool_rxfh_context {
    #[inline]
    pub fn indir_configured(&self) -> u8_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_indir_configured(&mut self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn indir_configured_raw(this: *const Self) -> u8_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_indir_configured_raw(this: *mut Self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn key_configured(&self) -> u8_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_key_configured(&mut self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn key_configured_raw(this: *const Self) -> u8_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_key_configured_raw(this: *mut Self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        indir_configured: u8_,
        key_configured: u8_,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let indir_configured: u8 = unsafe { ::core::mem::transmute(indir_configured) };
            indir_configured as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let key_configured: u8 = unsafe { ::core::mem::transmute(key_configured) };
            key_configured as u64
        });
        __bindgen_bitfield_unit
    }
}
extern "C" {
    pub fn ethtool_rxfh_context_lost(dev: *mut net_device, context_id: u32_);
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct link_mode_info {
    pub speed: ffi::c_int,
    pub lanes: u8_,
    pub duplex: u8_,
}
extern "C" {
    pub static link_mode_params: [link_mode_info; 0usize];
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_link_ksettings {
    pub base: ethtool_link_settings,
    pub link_modes: ethtool_link_ksettings__bindgen_ty_1,
    pub lanes: u32_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_link_ksettings__bindgen_ty_1 {
    pub supported: [ffi::c_ulong; 2usize],
    pub advertising: [ffi::c_ulong; 2usize],
    pub lp_advertising: [ffi::c_ulong; 2usize],
}
extern "C" {
    pub fn __ethtool_get_link_ksettings(
        dev: *mut net_device,
        link_ksettings: *mut ethtool_link_ksettings,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_keee {
    pub supported: [ffi::c_ulong; 2usize],
    pub advertised: [ffi::c_ulong; 2usize],
    pub lp_advertised: [ffi::c_ulong; 2usize],
    pub tx_lpi_timer: u32_,
    pub tx_lpi_enabled: bool_,
    pub eee_active: bool_,
    pub eee_enabled: bool_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct kernel_ethtool_coalesce {
    pub use_cqe_mode_tx: u8_,
    pub use_cqe_mode_rx: u8_,
    pub tx_aggr_max_bytes: u32_,
    pub tx_aggr_max_frames: u32_,
    pub tx_aggr_time_usecs: u32_,
}
extern "C" {
    pub fn ethtool_intersect_link_masks(
        dst: *mut ethtool_link_ksettings,
        src: *mut ethtool_link_ksettings,
    );
}
extern "C" {
    pub fn ethtool_convert_legacy_u32_to_link_mode(dst: *mut ffi::c_ulong, legacy_u32: u32_);
}
extern "C" {
    pub fn ethtool_convert_link_mode_to_legacy_u32(
        legacy_u32: *mut u32_,
        src: *const ffi::c_ulong,
    ) -> bool_;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ethtool_eth_mac_stats {
    pub src: ethtool_mac_stats_src,
    pub __bindgen_anon_1: ethtool_eth_mac_stats__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union ethtool_eth_mac_stats__bindgen_ty_1 {
    pub __bindgen_anon_1: ethtool_eth_mac_stats__bindgen_ty_1__bindgen_ty_1,
    pub stats: ethtool_eth_mac_stats__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_eth_mac_stats__bindgen_ty_1__bindgen_ty_1 {
    pub FramesTransmittedOK: u64_,
    pub SingleCollisionFrames: u64_,
    pub MultipleCollisionFrames: u64_,
    pub FramesReceivedOK: u64_,
    pub FrameCheckSequenceErrors: u64_,
    pub AlignmentErrors: u64_,
    pub OctetsTransmittedOK: u64_,
    pub FramesWithDeferredXmissions: u64_,
    pub LateCollisions: u64_,
    pub FramesAbortedDueToXSColls: u64_,
    pub FramesLostDueToIntMACXmitError: u64_,
    pub CarrierSenseErrors: u64_,
    pub OctetsReceivedOK: u64_,
    pub FramesLostDueToIntMACRcvError: u64_,
    pub MulticastFramesXmittedOK: u64_,
    pub BroadcastFramesXmittedOK: u64_,
    pub FramesWithExcessiveDeferral: u64_,
    pub MulticastFramesReceivedOK: u64_,
    pub BroadcastFramesReceivedOK: u64_,
    pub InRangeLengthErrors: u64_,
    pub OutOfRangeLengthField: u64_,
    pub FrameTooLongErrors: u64_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_eth_mac_stats__bindgen_ty_1__bindgen_ty_2 {
    pub FramesTransmittedOK: u64_,
    pub SingleCollisionFrames: u64_,
    pub MultipleCollisionFrames: u64_,
    pub FramesReceivedOK: u64_,
    pub FrameCheckSequenceErrors: u64_,
    pub AlignmentErrors: u64_,
    pub OctetsTransmittedOK: u64_,
    pub FramesWithDeferredXmissions: u64_,
    pub LateCollisions: u64_,
    pub FramesAbortedDueToXSColls: u64_,
    pub FramesLostDueToIntMACXmitError: u64_,
    pub CarrierSenseErrors: u64_,
    pub OctetsReceivedOK: u64_,
    pub FramesLostDueToIntMACRcvError: u64_,
    pub MulticastFramesXmittedOK: u64_,
    pub BroadcastFramesXmittedOK: u64_,
    pub FramesWithExcessiveDeferral: u64_,
    pub MulticastFramesReceivedOK: u64_,
    pub BroadcastFramesReceivedOK: u64_,
    pub InRangeLengthErrors: u64_,
    pub OutOfRangeLengthField: u64_,
    pub FrameTooLongErrors: u64_,
}
impl Default for ethtool_eth_mac_stats__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for ethtool_eth_mac_stats {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ethtool_eth_phy_stats {
    pub src: ethtool_mac_stats_src,
    pub __bindgen_anon_1: ethtool_eth_phy_stats__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union ethtool_eth_phy_stats__bindgen_ty_1 {
    pub __bindgen_anon_1: ethtool_eth_phy_stats__bindgen_ty_1__bindgen_ty_1,
    pub stats: ethtool_eth_phy_stats__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_eth_phy_stats__bindgen_ty_1__bindgen_ty_1 {
    pub SymbolErrorDuringCarrier: u64_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_eth_phy_stats__bindgen_ty_1__bindgen_ty_2 {
    pub SymbolErrorDuringCarrier: u64_,
}
impl Default for ethtool_eth_phy_stats__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for ethtool_eth_phy_stats {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_phy_stats {
    pub rx_packets: u64_,
    pub rx_bytes: u64_,
    pub rx_errors: u64_,
    pub tx_packets: u64_,
    pub tx_bytes: u64_,
    pub tx_errors: u64_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ethtool_eth_ctrl_stats {
    pub src: ethtool_mac_stats_src,
    pub __bindgen_anon_1: ethtool_eth_ctrl_stats__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union ethtool_eth_ctrl_stats__bindgen_ty_1 {
    pub __bindgen_anon_1: ethtool_eth_ctrl_stats__bindgen_ty_1__bindgen_ty_1,
    pub stats: ethtool_eth_ctrl_stats__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_eth_ctrl_stats__bindgen_ty_1__bindgen_ty_1 {
    pub MACControlFramesTransmitted: u64_,
    pub MACControlFramesReceived: u64_,
    pub UnsupportedOpcodesReceived: u64_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_eth_ctrl_stats__bindgen_ty_1__bindgen_ty_2 {
    pub MACControlFramesTransmitted: u64_,
    pub MACControlFramesReceived: u64_,
    pub UnsupportedOpcodesReceived: u64_,
}
impl Default for ethtool_eth_ctrl_stats__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for ethtool_eth_ctrl_stats {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ethtool_pause_stats {
    pub src: ethtool_mac_stats_src,
    pub __bindgen_anon_1: ethtool_pause_stats__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union ethtool_pause_stats__bindgen_ty_1 {
    pub __bindgen_anon_1: ethtool_pause_stats__bindgen_ty_1__bindgen_ty_1,
    pub stats: ethtool_pause_stats__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_pause_stats__bindgen_ty_1__bindgen_ty_1 {
    pub tx_pause_frames: u64_,
    pub rx_pause_frames: u64_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_pause_stats__bindgen_ty_1__bindgen_ty_2 {
    pub tx_pause_frames: u64_,
    pub rx_pause_frames: u64_,
}
impl Default for ethtool_pause_stats__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for ethtool_pause_stats {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_fec_stats {
    pub corrected_blocks: ethtool_fec_stats_ethtool_fec_stat,
    pub uncorrectable_blocks: ethtool_fec_stats_ethtool_fec_stat,
    pub corrected_bits: ethtool_fec_stats_ethtool_fec_stat,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_fec_stats_ethtool_fec_stat {
    pub total: u64_,
    pub lanes: [u64_; 8usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_rmon_hist_range {
    pub low: u16_,
    pub high: u16_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ethtool_rmon_stats {
    pub src: ethtool_mac_stats_src,
    pub __bindgen_anon_1: ethtool_rmon_stats__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union ethtool_rmon_stats__bindgen_ty_1 {
    pub __bindgen_anon_1: ethtool_rmon_stats__bindgen_ty_1__bindgen_ty_1,
    pub stats: ethtool_rmon_stats__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_rmon_stats__bindgen_ty_1__bindgen_ty_1 {
    pub undersize_pkts: u64_,
    pub oversize_pkts: u64_,
    pub fragments: u64_,
    pub jabbers: u64_,
    pub hist: [u64_; 10usize],
    pub hist_tx: [u64_; 10usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_rmon_stats__bindgen_ty_1__bindgen_ty_2 {
    pub undersize_pkts: u64_,
    pub oversize_pkts: u64_,
    pub fragments: u64_,
    pub jabbers: u64_,
    pub hist: [u64_; 10usize],
    pub hist_tx: [u64_; 10usize],
}
impl Default for ethtool_rmon_stats__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for ethtool_rmon_stats {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ethtool_ts_stats {
    pub __bindgen_anon_1: ethtool_ts_stats__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union ethtool_ts_stats__bindgen_ty_1 {
    pub __bindgen_anon_1: ethtool_ts_stats__bindgen_ty_1__bindgen_ty_1,
    pub tx_stats: ethtool_ts_stats__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_ts_stats__bindgen_ty_1__bindgen_ty_1 {
    pub pkts: u64_,
    pub onestep_pkts_unconfirmed: u64_,
    pub lost: u64_,
    pub err: u64_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_ts_stats__bindgen_ty_1__bindgen_ty_2 {
    pub pkts: u64_,
    pub onestep_pkts_unconfirmed: u64_,
    pub lost: u64_,
    pub err: u64_,
}
impl Default for ethtool_ts_stats__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for ethtool_ts_stats {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ethtool_module_eeprom {
    pub offset: u32_,
    pub length: u32_,
    pub page: u8_,
    pub bank: u8_,
    pub i2c_address: u8_,
    pub data: *mut u8_,
}
impl Default for ethtool_module_eeprom {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ethtool_module_power_mode_params {
    pub policy: ethtool_module_power_mode_policy,
    pub mode: ethtool_module_power_mode,
}
impl Default for ethtool_module_power_mode_params {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ethtool_mm_state {
    pub verify_time: u32_,
    pub max_verify_time: u32_,
    pub verify_status: ethtool_mm_verify_status,
    pub tx_enabled: bool_,
    pub tx_active: bool_,
    pub pmac_enabled: bool_,
    pub verify_enabled: bool_,
    pub tx_min_frag_size: u32_,
    pub rx_min_frag_size: u32_,
}
impl Default for ethtool_mm_state {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_mm_cfg {
    pub verify_time: u32_,
    pub verify_enabled: bool_,
    pub tx_enabled: bool_,
    pub pmac_enabled: bool_,
    pub tx_min_frag_size: u32_,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_mm_stats {
    pub MACMergeFrameAssErrorCount: u64_,
    pub MACMergeFrameSmdErrorCount: u64_,
    pub MACMergeFrameAssOkCount: u64_,
    pub MACMergeFragCountRx: u64_,
    pub MACMergeFragCountTx: u64_,
    pub MACMergeHoldCount: u64_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ethtool_rxfh_param {
    pub hfunc: u8_,
    pub indir_size: u32_,
    pub indir: *mut u32_,
    pub key_size: u32_,
    pub key: *mut u8_,
    pub rss_context: u32_,
    pub rss_delete: u8_,
    pub input_xfrm: u8_,
}
impl Default for ethtool_rxfh_param {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kernel_ethtool_ts_info {
    pub cmd: u32_,
    pub so_timestamping: u32_,
    pub phc_index: ffi::c_int,
    pub phc_qualifier: hwtstamp_provider_qualifier,
    pub tx_types: hwtstamp_tx_types,
    pub rx_filters: hwtstamp_rx_filters,
}
impl Default for kernel_ethtool_ts_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_ops {
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
    pub rxfh_indir_space: u32_,
    pub rxfh_key_space: u16_,
    pub rxfh_priv_size: u16_,
    pub rxfh_max_num_contexts: u32_,
    pub supported_coalesce_params: u32_,
    pub supported_ring_params: u32_,
    pub supported_hwtstamp_qualifiers: u32_,
    pub get_drvinfo: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, arg2: *mut ethtool_drvinfo),
    >,
    pub get_regs_len:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut net_device) -> ffi::c_int>,
    pub get_regs: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            arg2: *mut ethtool_regs,
            arg3: *mut ffi::c_void,
        ),
    >,
    pub get_wol: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, arg2: *mut ethtool_wolinfo),
    >,
    pub set_wol: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, arg2: *mut ethtool_wolinfo) -> ffi::c_int,
    >,
    pub get_msglevel: ::core::option::Option<unsafe extern "C" fn(arg1: *mut net_device) -> u32_>,
    pub set_msglevel:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut net_device, arg2: u32_)>,
    pub nway_reset:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut net_device) -> ffi::c_int>,
    pub get_link: ::core::option::Option<unsafe extern "C" fn(arg1: *mut net_device) -> u32_>,
    pub get_link_ext_state: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            arg2: *mut ethtool_link_ext_state_info,
        ) -> ffi::c_int,
    >,
    pub get_link_ext_stats: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut net_device, stats: *mut ethtool_link_ext_stats),
    >,
    pub get_eeprom_len:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut net_device) -> ffi::c_int>,
    pub get_eeprom: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            arg2: *mut ethtool_eeprom,
            arg3: *mut u8_,
        ) -> ffi::c_int,
    >,
    pub set_eeprom: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            arg2: *mut ethtool_eeprom,
            arg3: *mut u8_,
        ) -> ffi::c_int,
    >,
    pub get_coalesce: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            arg2: *mut ethtool_coalesce,
            arg3: *mut kernel_ethtool_coalesce,
            arg4: *mut netlink_ext_ack,
        ) -> ffi::c_int,
    >,
    pub set_coalesce: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            arg2: *mut ethtool_coalesce,
            arg3: *mut kernel_ethtool_coalesce,
            arg4: *mut netlink_ext_ack,
        ) -> ffi::c_int,
    >,
    pub get_ringparam: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            arg2: *mut ethtool_ringparam,
            arg3: *mut kernel_ethtool_ringparam,
            arg4: *mut netlink_ext_ack,
        ),
    >,
    pub set_ringparam: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            arg2: *mut ethtool_ringparam,
            arg3: *mut kernel_ethtool_ringparam,
            arg4: *mut netlink_ext_ack,
        ) -> ffi::c_int,
    >,
    pub get_pause_stats: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut net_device, pause_stats: *mut ethtool_pause_stats),
    >,
    pub get_pauseparam: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, arg2: *mut ethtool_pauseparam),
    >,
    pub set_pauseparam: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, arg2: *mut ethtool_pauseparam) -> ffi::c_int,
    >,
    pub self_test: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, arg2: *mut ethtool_test, arg3: *mut u64_),
    >,
    pub get_strings: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, stringset: u32_, arg2: *mut u8_),
    >,
    pub set_phys_id: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, arg2: ethtool_phys_id_state) -> ffi::c_int,
    >,
    pub get_ethtool_stats: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, arg2: *mut ethtool_stats, arg3: *mut u64_),
    >,
    pub begin: ::core::option::Option<unsafe extern "C" fn(arg1: *mut net_device) -> ffi::c_int>,
    pub complete: ::core::option::Option<unsafe extern "C" fn(arg1: *mut net_device)>,
    pub get_priv_flags: ::core::option::Option<unsafe extern "C" fn(arg1: *mut net_device) -> u32_>,
    pub set_priv_flags: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, arg2: u32_) -> ffi::c_int,
    >,
    pub get_sset_count: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, arg2: ffi::c_int) -> ffi::c_int,
    >,
    pub get_rxnfc: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            arg2: *mut ethtool_rxnfc,
            rule_locs: *mut u32_,
        ) -> ffi::c_int,
    >,
    pub set_rxnfc: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, arg2: *mut ethtool_rxnfc) -> ffi::c_int,
    >,
    pub flash_device: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, arg2: *mut ethtool_flash) -> ffi::c_int,
    >,
    pub reset: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, arg2: *mut u32_) -> ffi::c_int,
    >,
    pub get_rxfh_key_size:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut net_device) -> u32_>,
    pub get_rxfh_indir_size:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut net_device) -> u32_>,
    pub get_rxfh: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, arg2: *mut ethtool_rxfh_param) -> ffi::c_int,
    >,
    pub set_rxfh: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            arg2: *mut ethtool_rxfh_param,
            extack: *mut netlink_ext_ack,
        ) -> ffi::c_int,
    >,
    pub create_rxfh_context: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            ctx: *mut ethtool_rxfh_context,
            rxfh: *const ethtool_rxfh_param,
            extack: *mut netlink_ext_ack,
        ) -> ffi::c_int,
    >,
    pub modify_rxfh_context: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            ctx: *mut ethtool_rxfh_context,
            rxfh: *const ethtool_rxfh_param,
            extack: *mut netlink_ext_ack,
        ) -> ffi::c_int,
    >,
    pub remove_rxfh_context: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            ctx: *mut ethtool_rxfh_context,
            rss_context: u32_,
            extack: *mut netlink_ext_ack,
        ) -> ffi::c_int,
    >,
    pub get_channels: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, arg2: *mut ethtool_channels),
    >,
    pub set_channels: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, arg2: *mut ethtool_channels) -> ffi::c_int,
    >,
    pub get_dump_flag: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, arg2: *mut ethtool_dump) -> ffi::c_int,
    >,
    pub get_dump_data: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            arg2: *mut ethtool_dump,
            arg3: *mut ffi::c_void,
        ) -> ffi::c_int,
    >,
    pub set_dump: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, arg2: *mut ethtool_dump) -> ffi::c_int,
    >,
    pub get_ts_info: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            arg2: *mut kernel_ethtool_ts_info,
        ) -> ffi::c_int,
    >,
    pub get_ts_stats: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut net_device, ts_stats: *mut ethtool_ts_stats),
    >,
    pub get_module_info: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, arg2: *mut ethtool_modinfo) -> ffi::c_int,
    >,
    pub get_module_eeprom: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            arg2: *mut ethtool_eeprom,
            arg3: *mut u8_,
        ) -> ffi::c_int,
    >,
    pub get_eee: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut net_device, eee: *mut ethtool_keee) -> ffi::c_int,
    >,
    pub set_eee: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut net_device, eee: *mut ethtool_keee) -> ffi::c_int,
    >,
    pub get_tunable: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            arg2: *const ethtool_tunable,
            arg3: *mut ffi::c_void,
        ) -> ffi::c_int,
    >,
    pub set_tunable: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            arg2: *const ethtool_tunable,
            arg3: *const ffi::c_void,
        ) -> ffi::c_int,
    >,
    pub get_per_queue_coalesce: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            arg2: u32_,
            arg3: *mut ethtool_coalesce,
        ) -> ffi::c_int,
    >,
    pub set_per_queue_coalesce: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            arg2: u32_,
            arg3: *mut ethtool_coalesce,
        ) -> ffi::c_int,
    >,
    pub get_link_ksettings: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            arg2: *mut ethtool_link_ksettings,
        ) -> ffi::c_int,
    >,
    pub set_link_ksettings: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            arg2: *const ethtool_link_ksettings,
        ) -> ffi::c_int,
    >,
    pub get_fec_stats: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut net_device, fec_stats: *mut ethtool_fec_stats),
    >,
    pub get_fecparam: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, arg2: *mut ethtool_fecparam) -> ffi::c_int,
    >,
    pub set_fecparam: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, arg2: *mut ethtool_fecparam) -> ffi::c_int,
    >,
    pub get_ethtool_phy_stats: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut net_device, arg2: *mut ethtool_stats, arg3: *mut u64_),
    >,
    pub get_phy_tunable: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            arg2: *const ethtool_tunable,
            arg3: *mut ffi::c_void,
        ) -> ffi::c_int,
    >,
    pub set_phy_tunable: ::core::option::Option<
        unsafe extern "C" fn(
            arg1: *mut net_device,
            arg2: *const ethtool_tunable,
            arg3: *const ffi::c_void,
        ) -> ffi::c_int,
    >,
    pub get_module_eeprom_by_page: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut net_device,
            page: *const ethtool_module_eeprom,
            extack: *mut netlink_ext_ack,
        ) -> ffi::c_int,
    >,
    pub set_module_eeprom_by_page: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut net_device,
            page: *const ethtool_module_eeprom,
            extack: *mut netlink_ext_ack,
        ) -> ffi::c_int,
    >,
    pub get_eth_phy_stats: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut net_device, phy_stats: *mut ethtool_eth_phy_stats),
    >,
    pub get_eth_mac_stats: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut net_device, mac_stats: *mut ethtool_eth_mac_stats),
    >,
    pub get_eth_ctrl_stats: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut net_device, ctrl_stats: *mut ethtool_eth_ctrl_stats),
    >,
    pub get_rmon_stats: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut net_device,
            rmon_stats: *mut ethtool_rmon_stats,
            ranges: *mut *const ethtool_rmon_hist_range,
        ),
    >,
    pub get_module_power_mode: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut net_device,
            params: *mut ethtool_module_power_mode_params,
            extack: *mut netlink_ext_ack,
        ) -> ffi::c_int,
    >,
    pub set_module_power_mode: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut net_device,
            params: *const ethtool_module_power_mode_params,
            extack: *mut netlink_ext_ack,
        ) -> ffi::c_int,
    >,
    pub get_mm: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut net_device, state: *mut ethtool_mm_state) -> ffi::c_int,
    >,
    pub set_mm: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut net_device,
            cfg: *mut ethtool_mm_cfg,
            extack: *mut netlink_ext_ack,
        ) -> ffi::c_int,
    >,
    pub get_mm_stats: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut net_device, stats: *mut ethtool_mm_stats),
    >,
}
impl ethtool_ops {
    #[inline]
    pub fn supported_input_xfrm(&self) -> u32_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 8u8) as u32) }
    }
    #[inline]
    pub fn set_supported_input_xfrm(&mut self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 8u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn supported_input_xfrm_raw(this: *const Self) -> u32_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                8u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_supported_input_xfrm_raw(this: *mut Self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                8u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn cap_link_lanes_supported(&self) -> u32_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(8usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_cap_link_lanes_supported(&mut self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(8usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn cap_link_lanes_supported_raw(this: *const Self) -> u32_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                8usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_cap_link_lanes_supported_raw(this: *mut Self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                8usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn cap_rss_ctx_supported(&self) -> u32_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(9usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_cap_rss_ctx_supported(&mut self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(9usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn cap_rss_ctx_supported_raw(this: *const Self) -> u32_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                9usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_cap_rss_ctx_supported_raw(this: *mut Self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                9usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn rxfh_per_ctx_key(&self) -> u32_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(10usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_rxfh_per_ctx_key(&mut self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(10usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn rxfh_per_ctx_key_raw(this: *const Self) -> u32_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                10usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_rxfh_per_ctx_key_raw(this: *mut Self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                10usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn cap_rss_rxnfc_adds(&self) -> u32_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(11usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_cap_rss_rxnfc_adds(&mut self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(11usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn cap_rss_rxnfc_adds_raw(this: *const Self) -> u32_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                11usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_cap_rss_rxnfc_adds_raw(this: *mut Self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                11usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        supported_input_xfrm: u32_,
        cap_link_lanes_supported: u32_,
        cap_rss_ctx_supported: u32_,
        rxfh_per_ctx_key: u32_,
        cap_rss_rxnfc_adds: u32_,
    ) -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 8u8, {
            let supported_input_xfrm: u32 = unsafe { ::core::mem::transmute(supported_input_xfrm) };
            supported_input_xfrm as u64
        });
        __bindgen_bitfield_unit.set(8usize, 1u8, {
            let cap_link_lanes_supported: u32 =
                unsafe { ::core::mem::transmute(cap_link_lanes_supported) };
            cap_link_lanes_supported as u64
        });
        __bindgen_bitfield_unit.set(9usize, 1u8, {
            let cap_rss_ctx_supported: u32 =
                unsafe { ::core::mem::transmute(cap_rss_ctx_supported) };
            cap_rss_ctx_supported as u64
        });
        __bindgen_bitfield_unit.set(10usize, 1u8, {
            let rxfh_per_ctx_key: u32 = unsafe { ::core::mem::transmute(rxfh_per_ctx_key) };
            rxfh_per_ctx_key as u64
        });
        __bindgen_bitfield_unit.set(11usize, 1u8, {
            let cap_rss_rxnfc_adds: u32 = unsafe { ::core::mem::transmute(cap_rss_rxnfc_adds) };
            cap_rss_rxnfc_adds as u64
        });
        __bindgen_bitfield_unit
    }
}
extern "C" {
    pub fn ethtool_check_ops(ops: *const ethtool_ops) -> ffi::c_int;
}
#[repr(C)]
pub struct ethtool_rx_flow_rule {
    pub rule: *mut flow_rule,
    pub priv_: __IncompleteArrayField<ffi::c_ulong>,
}
impl Default for ethtool_rx_flow_rule {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ethtool_rx_flow_spec_input {
    pub fs: *const ethtool_rx_flow_spec,
    pub rss_ctx: u32_,
}
impl Default for ethtool_rx_flow_spec_input {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn ethtool_rx_flow_rule_create(
        input: *const ethtool_rx_flow_spec_input,
    ) -> *mut ethtool_rx_flow_rule;
}
extern "C" {
    pub fn ethtool_rx_flow_rule_destroy(rule: *mut ethtool_rx_flow_rule);
}
extern "C" {
    pub fn ethtool_virtdev_validate_cmd(cmd: *const ethtool_link_ksettings) -> bool_;
}
extern "C" {
    pub fn ethtool_virtdev_set_link_ksettings(
        dev: *mut net_device,
        cmd: *const ethtool_link_ksettings,
        dev_speed: *mut u32_,
        dev_duplex: *mut u8_,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ethtool_netdev_state {
    pub rss_ctx: xarray,
    pub rss_lock: mutex,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub __bindgen_padding_0: [u8; 7usize],
}
impl Default for ethtool_netdev_state {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl ethtool_netdev_state {
    #[inline]
    pub fn wol_enabled(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_wol_enabled(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn wol_enabled_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_wol_enabled_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn module_fw_flash_in_progress(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_module_fw_flash_in_progress(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn module_fw_flash_in_progress_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_module_fw_flash_in_progress_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        wol_enabled: ffi::c_uint,
        module_fw_flash_in_progress: ffi::c_uint,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let wol_enabled: u32 = unsafe { ::core::mem::transmute(wol_enabled) };
            wol_enabled as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let module_fw_flash_in_progress: u32 =
                unsafe { ::core::mem::transmute(module_fw_flash_in_progress) };
            module_fw_flash_in_progress as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ethtool_phy_ops {
    pub get_sset_count:
        ::core::option::Option<unsafe extern "C" fn(dev: *mut phy_device) -> ffi::c_int>,
    pub get_strings: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut phy_device, data: *mut u8_) -> ffi::c_int,
    >,
    pub get_stats: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut phy_device,
            stats: *mut ethtool_stats,
            data: *mut u64_,
        ) -> ffi::c_int,
    >,
    pub get_plca_cfg: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut phy_device, plca_cfg: *mut phy_plca_cfg) -> ffi::c_int,
    >,
    pub set_plca_cfg: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut phy_device,
            plca_cfg: *const phy_plca_cfg,
            extack: *mut netlink_ext_ack,
        ) -> ffi::c_int,
    >,
    pub get_plca_status: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut phy_device, plca_st: *mut phy_plca_status) -> ffi::c_int,
    >,
    pub start_cable_test: ::core::option::Option<
        unsafe extern "C" fn(phydev: *mut phy_device, extack: *mut netlink_ext_ack) -> ffi::c_int,
    >,
    pub start_cable_test_tdr: ::core::option::Option<
        unsafe extern "C" fn(
            phydev: *mut phy_device,
            extack: *mut netlink_ext_ack,
            config: *const phy_tdr_config,
        ) -> ffi::c_int,
    >,
}
extern "C" {
    pub fn ethtool_set_ethtool_phy_ops(ops: *const ethtool_phy_ops);
}
extern "C" {
    pub fn ethtool_params_from_link_mode(
        link_ksettings: *mut ethtool_link_ksettings,
        link_mode: ethtool_link_mode_bit_indices,
    );
}
extern "C" {
    pub fn ethtool_get_phc_vclocks(
        dev: *mut net_device,
        vclock_index: *mut *mut ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn ethtool_op_get_link(dev: *mut net_device) -> u32_;
}
extern "C" {
    pub fn ethtool_op_get_ts_info(
        dev: *mut net_device,
        eti: *mut kernel_ethtool_ts_info,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn ethtool_get_ts_info_by_layer(
        dev: *mut net_device,
        info: *mut kernel_ethtool_ts_info,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn ethtool_sprintf(data: *mut *mut u8_, fmt: *const ffi::c_char, ...);
}
extern "C" {
    pub fn ethtool_puts(data: *mut *mut u8_, str_: *const ffi::c_char);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ethtool_forced_speed_map {
    pub speed: u32_,
    pub caps: [ffi::c_ulong; 2usize],
    pub cap_arr: *const u32_,
    pub arr_size: u32_,
}
impl Default for ethtool_forced_speed_map {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn ethtool_forced_speed_maps_init(maps: *mut ethtool_forced_speed_map, size: u32_);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct firmware {
    pub size: usize,
    pub data: *const u8_,
    pub priv_: *mut ffi::c_void,
}
impl Default for firmware {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const fw_upload_err_FW_UPLOAD_ERR_NONE: fw_upload_err = 0;
pub const fw_upload_err_FW_UPLOAD_ERR_HW_ERROR: fw_upload_err = 1;
pub const fw_upload_err_FW_UPLOAD_ERR_TIMEOUT: fw_upload_err = 2;
pub const fw_upload_err_FW_UPLOAD_ERR_CANCELED: fw_upload_err = 3;
pub const fw_upload_err_FW_UPLOAD_ERR_BUSY: fw_upload_err = 4;
pub const fw_upload_err_FW_UPLOAD_ERR_INVALID_SIZE: fw_upload_err = 5;
pub const fw_upload_err_FW_UPLOAD_ERR_RW_ERROR: fw_upload_err = 6;
pub const fw_upload_err_FW_UPLOAD_ERR_WEAROUT: fw_upload_err = 7;
pub const fw_upload_err_FW_UPLOAD_ERR_FW_INVALID: fw_upload_err = 8;
pub const fw_upload_err_FW_UPLOAD_ERR_MAX: fw_upload_err = 9;
pub type fw_upload_err = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fw_upload {
    pub dd_handle: *mut ffi::c_void,
    pub priv_: *mut ffi::c_void,
}
impl Default for fw_upload {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct fw_upload_ops {
    pub prepare: ::core::option::Option<
        unsafe extern "C" fn(
            fw_upload: *mut fw_upload,
            data: *const u8_,
            size: u32_,
        ) -> fw_upload_err,
    >,
    pub write: ::core::option::Option<
        unsafe extern "C" fn(
            fw_upload: *mut fw_upload,
            data: *const u8_,
            offset: u32_,
            size: u32_,
            written: *mut u32_,
        ) -> fw_upload_err,
    >,
    pub poll_complete:
        ::core::option::Option<unsafe extern "C" fn(fw_upload: *mut fw_upload) -> fw_upload_err>,
    pub cancel: ::core::option::Option<unsafe extern "C" fn(fw_upload: *mut fw_upload)>,
    pub cleanup: ::core::option::Option<unsafe extern "C" fn(fw_upload: *mut fw_upload)>,
}
extern "C" {
    pub fn firmware_request_builtin(fw: *mut firmware, name: *const ffi::c_char) -> bool_;
}
extern "C" {
    pub fn request_firmware(
        fw: *mut *const firmware,
        name: *const ffi::c_char,
        device: *mut device,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn firmware_request_nowait_nowarn(
        module: *mut module,
        name: *const ffi::c_char,
        device: *mut device,
        gfp: gfp_t,
        context: *mut ffi::c_void,
        cont: ::core::option::Option<
            unsafe extern "C" fn(fw: *const firmware, context: *mut ffi::c_void),
        >,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn firmware_request_nowarn(
        fw: *mut *const firmware,
        name: *const ffi::c_char,
        device: *mut device,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn firmware_request_platform(
        fw: *mut *const firmware,
        name: *const ffi::c_char,
        device: *mut device,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn request_firmware_nowait(
        module: *mut module,
        uevent: bool_,
        name: *const ffi::c_char,
        device: *mut device,
        gfp: gfp_t,
        context: *mut ffi::c_void,
        cont: ::core::option::Option<
            unsafe extern "C" fn(fw: *const firmware, context: *mut ffi::c_void),
        >,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn request_firmware_direct(
        fw: *mut *const firmware,
        name: *const ffi::c_char,
        device: *mut device,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn request_firmware_into_buf(
        firmware_p: *mut *const firmware,
        name: *const ffi::c_char,
        device: *mut device,
        buf: *mut ffi::c_void,
        size: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn request_partial_firmware_into_buf(
        firmware_p: *mut *const firmware,
        name: *const ffi::c_char,
        device: *mut device,
        buf: *mut ffi::c_void,
        size: usize,
        offset: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn release_firmware(fw: *const firmware);
}
extern "C" {
    pub fn firmware_upload_register(
        module: *mut module,
        parent: *mut device,
        name: *const ffi::c_char,
        ops: *const fw_upload_ops,
        dd_handle: *mut ffi::c_void,
    ) -> *mut fw_upload;
}
extern "C" {
    pub fn firmware_upload_unregister(fw_upload: *mut fw_upload);
}
extern "C" {
    pub fn firmware_request_cache(device: *mut device, name: *const ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub fn linkmode_resolve_pause(
        local_adv: *const ffi::c_ulong,
        partner_adv: *const ffi::c_ulong,
        tx_pause: *mut bool_,
        rx_pause: *mut bool_,
    );
}
extern "C" {
    pub fn linkmode_set_pause(advertisement: *mut ffi::c_ulong, tx: bool_, rx: bool_);
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct mii_ioctl_data {
    pub phy_id: __u16,
    pub reg_num: __u16,
    pub val_in: __u16,
    pub val_out: __u16,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mii_if_info {
    pub phy_id: ffi::c_int,
    pub advertising: ffi::c_int,
    pub phy_id_mask: ffi::c_int,
    pub reg_num_mask: ffi::c_int,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub dev: *mut net_device,
    pub mdio_read: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut net_device,
            phy_id: ffi::c_int,
            location: ffi::c_int,
        ) -> ffi::c_int,
    >,
    pub mdio_write: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut net_device,
            phy_id: ffi::c_int,
            location: ffi::c_int,
            val: ffi::c_int,
        ),
    >,
}
impl Default for mii_if_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl mii_if_info {
    #[inline]
    pub fn full_duplex(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_full_duplex(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn full_duplex_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_full_duplex_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn force_media(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_force_media(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn force_media_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_force_media_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn supports_gmii(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_supports_gmii(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn supports_gmii_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_supports_gmii_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        full_duplex: ffi::c_uint,
        force_media: ffi::c_uint,
        supports_gmii: ffi::c_uint,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let full_duplex: u32 = unsafe { ::core::mem::transmute(full_duplex) };
            full_duplex as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let force_media: u32 = unsafe { ::core::mem::transmute(force_media) };
            force_media as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let supports_gmii: u32 = unsafe { ::core::mem::transmute(supports_gmii) };
            supports_gmii as u64
        });
        __bindgen_bitfield_unit
    }
}
extern "C" {
    pub fn mii_link_ok(mii: *mut mii_if_info) -> ffi::c_int;
}
extern "C" {
    pub fn mii_nway_restart(mii: *mut mii_if_info) -> ffi::c_int;
}
extern "C" {
    pub fn mii_ethtool_gset(mii: *mut mii_if_info, ecmd: *mut ethtool_cmd);
}
extern "C" {
    pub fn mii_ethtool_get_link_ksettings(mii: *mut mii_if_info, cmd: *mut ethtool_link_ksettings);
}
extern "C" {
    pub fn mii_ethtool_sset(mii: *mut mii_if_info, ecmd: *mut ethtool_cmd) -> ffi::c_int;
}
extern "C" {
    pub fn mii_ethtool_set_link_ksettings(
        mii: *mut mii_if_info,
        cmd: *const ethtool_link_ksettings,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mii_check_gmii_support(mii: *mut mii_if_info) -> ffi::c_int;
}
extern "C" {
    pub fn mii_check_link(mii: *mut mii_if_info);
}
extern "C" {
    pub fn mii_check_media(
        mii: *mut mii_if_info,
        ok_to_print: ffi::c_uint,
        init_media: ffi::c_uint,
    ) -> ffi::c_uint;
}
extern "C" {
    pub fn generic_mii_ioctl(
        mii_if: *mut mii_if_info,
        mii_data: *mut mii_ioctl_data,
        cmd: ffi::c_int,
        duplex_changed: *mut ffi::c_uint,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct uuid_le {
    pub b: [__u8; 16usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct mei_client {
    pub max_msg_length: __u32,
    pub protocol_version: __u8,
    pub reserved: [__u8; 3usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mei_connect_client_data {
    pub __bindgen_anon_1: mei_connect_client_data__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union mei_connect_client_data__bindgen_ty_1 {
    pub in_client_uuid: uuid_le,
    pub out_client_properties: mei_client,
}
impl Default for mei_connect_client_data__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for mei_connect_client_data {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct mei_connect_client_vtag {
    pub in_client_uuid: uuid_le,
    pub vtag: __u8,
    pub reserved: [__u8; 3usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mei_connect_client_data_vtag {
    pub __bindgen_anon_1: mei_connect_client_data_vtag__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union mei_connect_client_data_vtag__bindgen_ty_1 {
    pub connect: mei_connect_client_vtag,
    pub out_client_properties: mei_client,
}
impl Default for mei_connect_client_data_vtag__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for mei_connect_client_data_vtag {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type kernel_ulong_t = ffi::c_ulong;
pub const PCI_ID_F_VFIO_DRIVER_OVERRIDE: _bindgen_ty_267 = 1;
pub type _bindgen_ty_267 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pci_device_id {
    pub vendor: __u32,
    pub device: __u32,
    pub subvendor: __u32,
    pub subdevice: __u32,
    pub class: __u32,
    pub class_mask: __u32,
    pub driver_data: kernel_ulong_t,
    pub override_only: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ieee1394_device_id {
    pub match_flags: __u32,
    pub vendor_id: __u32,
    pub model_id: __u32,
    pub specifier_id: __u32,
    pub version: __u32,
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct usb_device_id {
    pub match_flags: __u16,
    pub idVendor: __u16,
    pub idProduct: __u16,
    pub bcdDevice_lo: __u16,
    pub bcdDevice_hi: __u16,
    pub bDeviceClass: __u8,
    pub bDeviceSubClass: __u8,
    pub bDeviceProtocol: __u8,
    pub bInterfaceClass: __u8,
    pub bInterfaceSubClass: __u8,
    pub bInterfaceProtocol: __u8,
    pub bInterfaceNumber: __u8,
    pub driver_info: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct hid_device_id {
    pub bus: __u16,
    pub group: __u16,
    pub vendor: __u32,
    pub product: __u32,
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ccw_device_id {
    pub match_flags: __u16,
    pub cu_type: __u16,
    pub dev_type: __u16,
    pub cu_model: __u8,
    pub dev_model: __u8,
    pub driver_info: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ap_device_id {
    pub match_flags: __u16,
    pub dev_type: __u8,
    pub driver_info: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct css_device_id {
    pub match_flags: __u8,
    pub type_: __u8,
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct acpi_device_id {
    pub id: [__u8; 16usize],
    pub driver_data: kernel_ulong_t,
    pub cls: __u32,
    pub cls_msk: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pnp_device_id {
    pub id: [__u8; 8usize],
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pnp_card_device_id {
    pub id: [__u8; 8usize],
    pub driver_data: kernel_ulong_t,
    pub devs: [pnp_card_device_id__bindgen_ty_1; 8usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pnp_card_device_id__bindgen_ty_1 {
    pub id: [__u8; 8usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct serio_device_id {
    pub type_: __u8,
    pub extra: __u8,
    pub id: __u8,
    pub proto: __u8,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct hda_device_id {
    pub vendor_id: __u32,
    pub rev_id: __u32,
    pub api_version: __u8,
    pub name: *const ffi::c_char,
    pub driver_data: ffi::c_ulong,
}
impl Default for hda_device_id {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sdw_device_id {
    pub mfg_id: __u16,
    pub part_id: __u16,
    pub sdw_version: __u8,
    pub class_id: __u8,
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct of_device_id {
    pub name: [ffi::c_char; 32usize],
    pub type_: [ffi::c_char; 32usize],
    pub compatible: [ffi::c_char; 128usize],
    pub data: *const ffi::c_void,
}
impl Default for of_device_id {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct vio_device_id {
    pub type_: [ffi::c_char; 32usize],
    pub compat: [ffi::c_char; 32usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct pcmcia_device_id {
    pub match_flags: __u16,
    pub manf_id: __u16,
    pub card_id: __u16,
    pub func_id: __u8,
    pub function: __u8,
    pub device_no: __u8,
    pub prod_id_hash: [__u32; 4usize],
    pub prod_id: [*const ffi::c_char; 4usize],
    pub driver_info: kernel_ulong_t,
    pub cisfile: *mut ffi::c_char,
}
impl Default for pcmcia_device_id {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct input_device_id {
    pub flags: kernel_ulong_t,
    pub bustype: __u16,
    pub vendor: __u16,
    pub product: __u16,
    pub version: __u16,
    pub evbit: [kernel_ulong_t; 1usize],
    pub keybit: [kernel_ulong_t; 12usize],
    pub relbit: [kernel_ulong_t; 1usize],
    pub absbit: [kernel_ulong_t; 1usize],
    pub mscbit: [kernel_ulong_t; 1usize],
    pub ledbit: [kernel_ulong_t; 1usize],
    pub sndbit: [kernel_ulong_t; 1usize],
    pub ffbit: [kernel_ulong_t; 2usize],
    pub swbit: [kernel_ulong_t; 1usize],
    pub propbit: [kernel_ulong_t; 1usize],
    pub driver_info: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct eisa_device_id {
    pub sig: [ffi::c_char; 8usize],
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct parisc_device_id {
    pub hw_type: __u8,
    pub hversion_rev: __u8,
    pub hversion: __u16,
    pub sversion: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sdio_device_id {
    pub class: __u8,
    pub vendor: __u16,
    pub device: __u16,
    pub driver_data: kernel_ulong_t,
}
#[repr(C, packed(2))]
#[derive(Default, Copy, Clone)]
pub struct ssb_device_id {
    pub vendor: __u16,
    pub coreid: __u16,
    pub revision: __u8,
    pub __pad: __u8,
}
#[repr(C, packed(2))]
#[derive(Default, Copy, Clone)]
pub struct bcma_device_id {
    pub manuf: __u16,
    pub id: __u16,
    pub rev: __u8,
    pub class: __u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct virtio_device_id {
    pub device: __u32,
    pub vendor: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct hv_vmbus_device_id {
    pub guid: guid_t,
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct rpmsg_device_id {
    pub name: [ffi::c_char; 32usize],
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct i2c_device_id {
    pub name: [ffi::c_char; 20usize],
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pci_epf_device_id {
    pub name: [ffi::c_char; 20usize],
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct i3c_device_id {
    pub match_flags: __u8,
    pub dcr: __u8,
    pub manuf_id: __u16,
    pub part_id: __u16,
    pub extra_info: __u16,
    pub data: *const ffi::c_void,
}
impl Default for i3c_device_id {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct spi_device_id {
    pub name: [ffi::c_char; 32usize],
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct slim_device_id {
    pub manf_id: __u16,
    pub prod_code: __u16,
    pub dev_index: __u16,
    pub instance: __u16,
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct apr_device_id {
    pub name: [ffi::c_char; 32usize],
    pub domain_id: __u32,
    pub svc_id: __u32,
    pub svc_version: __u32,
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct spmi_device_id {
    pub name: [ffi::c_char; 32usize],
    pub driver_data: kernel_ulong_t,
}
pub const dmi_field_DMI_NONE: dmi_field = 0;
pub const dmi_field_DMI_BIOS_VENDOR: dmi_field = 1;
pub const dmi_field_DMI_BIOS_VERSION: dmi_field = 2;
pub const dmi_field_DMI_BIOS_DATE: dmi_field = 3;
pub const dmi_field_DMI_BIOS_RELEASE: dmi_field = 4;
pub const dmi_field_DMI_EC_FIRMWARE_RELEASE: dmi_field = 5;
pub const dmi_field_DMI_SYS_VENDOR: dmi_field = 6;
pub const dmi_field_DMI_PRODUCT_NAME: dmi_field = 7;
pub const dmi_field_DMI_PRODUCT_VERSION: dmi_field = 8;
pub const dmi_field_DMI_PRODUCT_SERIAL: dmi_field = 9;
pub const dmi_field_DMI_PRODUCT_UUID: dmi_field = 10;
pub const dmi_field_DMI_PRODUCT_SKU: dmi_field = 11;
pub const dmi_field_DMI_PRODUCT_FAMILY: dmi_field = 12;
pub const dmi_field_DMI_BOARD_VENDOR: dmi_field = 13;
pub const dmi_field_DMI_BOARD_NAME: dmi_field = 14;
pub const dmi_field_DMI_BOARD_VERSION: dmi_field = 15;
pub const dmi_field_DMI_BOARD_SERIAL: dmi_field = 16;
pub const dmi_field_DMI_BOARD_ASSET_TAG: dmi_field = 17;
pub const dmi_field_DMI_CHASSIS_VENDOR: dmi_field = 18;
pub const dmi_field_DMI_CHASSIS_TYPE: dmi_field = 19;
pub const dmi_field_DMI_CHASSIS_VERSION: dmi_field = 20;
pub const dmi_field_DMI_CHASSIS_SERIAL: dmi_field = 21;
pub const dmi_field_DMI_CHASSIS_ASSET_TAG: dmi_field = 22;
pub const dmi_field_DMI_STRING_MAX: dmi_field = 23;
pub const dmi_field_DMI_OEM_STRING: dmi_field = 24;
pub type dmi_field = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct dmi_strmatch {
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub substr: [ffi::c_char; 79usize],
}
impl Default for dmi_strmatch {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl dmi_strmatch {
    #[inline]
    pub fn slot(&self) -> ffi::c_uchar {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 7u8) as u8) }
    }
    #[inline]
    pub fn set_slot(&mut self, val: ffi::c_uchar) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 7u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn slot_raw(this: *const Self) -> ffi::c_uchar {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                7u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_slot_raw(this: *mut Self, val: ffi::c_uchar) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                7u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn exact_match(&self) -> ffi::c_uchar {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_exact_match(&mut self, val: ffi::c_uchar) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(7usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn exact_match_raw(this: *const Self) -> ffi::c_uchar {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                7usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_exact_match_raw(this: *mut Self, val: ffi::c_uchar) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                7usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        slot: ffi::c_uchar,
        exact_match: ffi::c_uchar,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 7u8, {
            let slot: u8 = unsafe { ::core::mem::transmute(slot) };
            slot as u64
        });
        __bindgen_bitfield_unit.set(7usize, 1u8, {
            let exact_match: u8 = unsafe { ::core::mem::transmute(exact_match) };
            exact_match as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct dmi_system_id {
    pub callback:
        ::core::option::Option<unsafe extern "C" fn(arg1: *const dmi_system_id) -> ffi::c_int>,
    pub ident: *const ffi::c_char,
    pub matches: [dmi_strmatch; 4usize],
    pub driver_data: *mut ffi::c_void,
}
impl Default for dmi_system_id {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct platform_device_id {
    pub name: [ffi::c_char; 20usize],
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct mdio_device_id {
    pub phy_id: __u32,
    pub phy_id_mask: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct zorro_device_id {
    pub id: __u32,
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct isapnp_device_id {
    pub card_vendor: ffi::c_ushort,
    pub card_device: ffi::c_ushort,
    pub vendor: ffi::c_ushort,
    pub function: ffi::c_ushort,
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct amba_id {
    pub id: ffi::c_uint,
    pub mask: ffi::c_uint,
    pub data: *mut ffi::c_void,
}
impl Default for amba_id {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct mips_cdmm_device_id {
    pub type_: __u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct x86_cpu_id {
    pub vendor: __u16,
    pub family: __u16,
    pub model: __u16,
    pub steppings: __u16,
    pub feature: __u16,
    pub flags: __u16,
    pub type_: __u8,
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct cpu_feature {
    pub feature: __u16,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ipack_device_id {
    pub format: __u8,
    pub vendor: __u32,
    pub device: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct mei_cl_device_id {
    pub name: [ffi::c_char; 32usize],
    pub uuid: uuid_le,
    pub version: __u8,
    pub driver_info: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct rio_device_id {
    pub did: __u16,
    pub vid: __u16,
    pub asm_did: __u16,
    pub asm_vid: __u16,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct mcb_device_id {
    pub device: __u16,
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ulpi_device_id {
    pub vendor: __u16,
    pub product: __u16,
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct fsl_mc_device_id {
    pub vendor: __u16,
    pub obj_type: [ffi::c_char; 16usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tb_service_id {
    pub match_flags: __u32,
    pub protocol_key: [ffi::c_char; 9usize],
    pub protocol_id: __u32,
    pub protocol_version: __u32,
    pub protocol_revision: __u32,
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct typec_device_id {
    pub svid: __u16,
    pub mode: __u8,
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tee_client_device_id {
    pub uuid: uuid_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct wmi_device_id {
    pub guid_string: [ffi::c_char; 37usize],
    pub context: *const ffi::c_void,
}
impl Default for wmi_device_id {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct mhi_device_id {
    pub chan: [ffi::c_char; 32usize],
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct auxiliary_device_id {
    pub name: [ffi::c_char; 32usize],
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ssam_device_id {
    pub match_flags: __u8,
    pub domain: __u8,
    pub category: __u8,
    pub target: __u8,
    pub instance: __u8,
    pub function: __u8,
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct dfl_device_id {
    pub type_: __u16,
    pub feature_id: __u16,
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct ishtp_device_id {
    pub guid: guid_t,
    pub driver_data: kernel_ulong_t,
}
pub const CDX_ID_F_VFIO_DRIVER_OVERRIDE: _bindgen_ty_268 = 1;
pub type _bindgen_ty_268 = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct cdx_device_id {
    pub vendor: __u16,
    pub device: __u16,
    pub subvendor: __u16,
    pub subdevice: __u16,
    pub class: __u32,
    pub class_mask: __u32,
    pub override_only: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct vchiq_device_id {
    pub name: [ffi::c_char; 32usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct coreboot_device_id {
    pub tag: __u32,
    pub driver_data: kernel_ulong_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct gpio_desc {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct reset_control {
    _unused: [u8; 0],
}
pub const mdio_mutex_lock_class_MDIO_MUTEX_NORMAL: mdio_mutex_lock_class = 0;
pub const mdio_mutex_lock_class_MDIO_MUTEX_MUX: mdio_mutex_lock_class = 1;
pub const mdio_mutex_lock_class_MDIO_MUTEX_NESTED: mdio_mutex_lock_class = 2;
pub type mdio_mutex_lock_class = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mdio_device {
    pub dev: device,
    pub bus: *mut mii_bus,
    pub modalias: [ffi::c_char; 32usize],
    pub bus_match: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut device, drv: *const device_driver) -> ffi::c_int,
    >,
    pub device_free: ::core::option::Option<unsafe extern "C" fn(mdiodev: *mut mdio_device)>,
    pub device_remove: ::core::option::Option<unsafe extern "C" fn(mdiodev: *mut mdio_device)>,
    pub addr: ffi::c_int,
    pub flags: ffi::c_int,
    pub reset_state: ffi::c_int,
    pub reset_gpio: *mut gpio_desc,
    pub reset_ctrl: *mut reset_control,
    pub reset_assert_delay: ffi::c_uint,
    pub reset_deassert_delay: ffi::c_uint,
}
impl Default for mdio_device {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mdio_driver_common {
    pub driver: device_driver,
    pub flags: ffi::c_int,
}
impl Default for mdio_driver_common {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mdio_driver {
    pub mdiodrv: mdio_driver_common,
    pub probe:
        ::core::option::Option<unsafe extern "C" fn(mdiodev: *mut mdio_device) -> ffi::c_int>,
    pub remove: ::core::option::Option<unsafe extern "C" fn(mdiodev: *mut mdio_device)>,
    pub shutdown: ::core::option::Option<unsafe extern "C" fn(mdiodev: *mut mdio_device)>,
}
impl Default for mdio_driver {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn mdio_device_free(mdiodev: *mut mdio_device);
}
extern "C" {
    pub fn mdio_device_create(bus: *mut mii_bus, addr: ffi::c_int) -> *mut mdio_device;
}
extern "C" {
    pub fn mdio_device_register(mdiodev: *mut mdio_device) -> ffi::c_int;
}
extern "C" {
    pub fn mdio_device_remove(mdiodev: *mut mdio_device);
}
extern "C" {
    pub fn mdio_device_reset(mdiodev: *mut mdio_device, value: ffi::c_int);
}
extern "C" {
    pub fn mdio_driver_register(drv: *mut mdio_driver) -> ffi::c_int;
}
extern "C" {
    pub fn mdio_driver_unregister(drv: *mut mdio_driver);
}
extern "C" {
    pub fn mdio_device_bus_match(dev: *mut device, drv: *const device_driver) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mdio_if_info {
    pub prtad: ffi::c_int,
    pub mmds: u32_,
    pub mode_support: ffi::c_uint,
    pub dev: *mut net_device,
    pub mdio_read: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut net_device,
            prtad: ffi::c_int,
            devad: ffi::c_int,
            addr: u16_,
        ) -> ffi::c_int,
    >,
    pub mdio_write: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut net_device,
            prtad: ffi::c_int,
            devad: ffi::c_int,
            addr: u16_,
            val: u16_,
        ) -> ffi::c_int,
    >,
}
impl Default for mdio_if_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn mdio45_probe(mdio: *mut mdio_if_info, prtad: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn mdio_set_flag(
        mdio: *const mdio_if_info,
        prtad: ffi::c_int,
        devad: ffi::c_int,
        addr: u16_,
        mask: ffi::c_int,
        sense: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mdio45_links_ok(mdio: *const mdio_if_info, mmds: u32_) -> ffi::c_int;
}
extern "C" {
    pub fn mdio45_nway_restart(mdio: *const mdio_if_info) -> ffi::c_int;
}
extern "C" {
    pub fn mdio45_ethtool_ksettings_get_npage(
        mdio: *const mdio_if_info,
        cmd: *mut ethtool_link_ksettings,
        npage_adv: u32_,
        npage_lpa: u32_,
    );
}
extern "C" {
    pub fn mdio_mii_ioctl(
        mdio: *const mdio_if_info,
        mii_data: *mut mii_ioctl_data,
        cmd: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __mdiobus_read(bus: *mut mii_bus, addr: ffi::c_int, regnum: u32_) -> ffi::c_int;
}
extern "C" {
    pub fn __mdiobus_write(
        bus: *mut mii_bus,
        addr: ffi::c_int,
        regnum: u32_,
        val: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __mdiobus_modify(
        bus: *mut mii_bus,
        addr: ffi::c_int,
        regnum: u32_,
        mask: u16_,
        set: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __mdiobus_modify_changed(
        bus: *mut mii_bus,
        addr: ffi::c_int,
        regnum: u32_,
        mask: u16_,
        set: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mdiobus_read(bus: *mut mii_bus, addr: ffi::c_int, regnum: u32_) -> ffi::c_int;
}
extern "C" {
    pub fn mdiobus_read_nested(bus: *mut mii_bus, addr: ffi::c_int, regnum: u32_) -> ffi::c_int;
}
extern "C" {
    pub fn mdiobus_write(
        bus: *mut mii_bus,
        addr: ffi::c_int,
        regnum: u32_,
        val: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mdiobus_write_nested(
        bus: *mut mii_bus,
        addr: ffi::c_int,
        regnum: u32_,
        val: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mdiobus_modify(
        bus: *mut mii_bus,
        addr: ffi::c_int,
        regnum: u32_,
        mask: u16_,
        set: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mdiobus_modify_changed(
        bus: *mut mii_bus,
        addr: ffi::c_int,
        regnum: u32_,
        mask: u16_,
        set: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __mdiobus_c45_read(
        bus: *mut mii_bus,
        addr: ffi::c_int,
        devad: ffi::c_int,
        regnum: u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mdiobus_c45_read(
        bus: *mut mii_bus,
        addr: ffi::c_int,
        devad: ffi::c_int,
        regnum: u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mdiobus_c45_read_nested(
        bus: *mut mii_bus,
        addr: ffi::c_int,
        devad: ffi::c_int,
        regnum: u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __mdiobus_c45_write(
        bus: *mut mii_bus,
        addr: ffi::c_int,
        devad: ffi::c_int,
        regnum: u32_,
        val: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mdiobus_c45_write(
        bus: *mut mii_bus,
        addr: ffi::c_int,
        devad: ffi::c_int,
        regnum: u32_,
        val: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mdiobus_c45_write_nested(
        bus: *mut mii_bus,
        addr: ffi::c_int,
        devad: ffi::c_int,
        regnum: u32_,
        val: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mdiobus_c45_modify(
        bus: *mut mii_bus,
        addr: ffi::c_int,
        devad: ffi::c_int,
        regnum: u32_,
        mask: u16_,
        set: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mdiobus_c45_modify_changed(
        bus: *mut mii_bus,
        addr: ffi::c_int,
        devad: ffi::c_int,
        regnum: u32_,
        mask: u16_,
        set: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mdiobus_register_device(mdiodev: *mut mdio_device) -> ffi::c_int;
}
extern "C" {
    pub fn mdiobus_unregister_device(mdiodev: *mut mdio_device) -> ffi::c_int;
}
extern "C" {
    pub fn mdiobus_is_registered_device(bus: *mut mii_bus, addr: ffi::c_int) -> bool_;
}
extern "C" {
    pub fn mdiobus_get_phy(bus: *mut mii_bus, addr: ffi::c_int) -> *mut phy_device;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct miscdevice {
    pub minor: ffi::c_int,
    pub name: *const ffi::c_char,
    pub fops: *const file_operations,
    pub list: list_head,
    pub parent: *mut device,
    pub this_device: *mut device,
    pub groups: *mut *const attribute_group,
    pub nodename: *const ffi::c_char,
    pub mode: umode_t,
}
impl Default for miscdevice {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn misc_register(misc: *mut miscdevice) -> ffi::c_int;
}
extern "C" {
    pub fn misc_deregister(misc: *mut miscdevice);
}
extern "C" {
    pub fn of_match_device(matches: *const of_device_id, dev: *const device)
        -> *const of_device_id;
}
extern "C" {
    pub fn of_device_modalias(dev: *mut device, str_: *mut ffi::c_char, len: isize) -> isize;
}
extern "C" {
    pub fn of_device_uevent(dev: *const device, env: *mut kobj_uevent_env);
}
extern "C" {
    pub fn of_device_uevent_modalias(dev: *const device, env: *mut kobj_uevent_env) -> ffi::c_int;
}
extern "C" {
    pub fn of_dma_configure_id(
        dev: *mut device,
        np: *mut device_node,
        force_dma: bool_,
        id: *const u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn of_device_make_bus_id(dev: *mut device);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct resource_win {
    pub res: resource,
    pub offset: resource_size_t,
}
impl Default for resource_win {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct resource_entry {
    pub node: list_head,
    pub res: *mut resource,
    pub offset: resource_size_t,
    pub __res: resource,
}
impl Default for resource_entry {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn resource_list_create_entry(res: *mut resource, extra_size: usize)
        -> *mut resource_entry;
}
extern "C" {
    pub fn resource_list_free(head: *mut list_head);
}
pub const msi_domain_ids_MSI_DEFAULT_DOMAIN: msi_domain_ids = 0;
pub const msi_domain_ids_MSI_MAX_DEVICE_IRQDOMAINS: msi_domain_ids = 1;
pub type msi_domain_ids = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub union msi_instance_cookie {
    pub value: u64_,
    pub ptr: *mut ffi::c_void,
}
impl Default for msi_instance_cookie {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct msi_map {
    pub index: ffi::c_int,
    pub virq: ffi::c_int,
}
extern "C" {
    pub fn msi_domain_get_virq(
        dev: *mut device,
        domid: ffi::c_uint,
        index: ffi::c_uint,
    ) -> ffi::c_uint;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct pci_slot {
    pub bus: *mut pci_bus,
    pub list: list_head,
    pub hotplug: *mut hotplug_slot,
    pub number: ffi::c_uchar,
    pub kobj: kobject,
}
impl Default for pci_slot {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const pci_mmap_state_pci_mmap_io: pci_mmap_state = 0;
pub const pci_mmap_state_pci_mmap_mem: pci_mmap_state = 1;
pub type pci_mmap_state = ffi::c_uint;
pub const PCI_STD_RESOURCES: _bindgen_ty_269 = 0;
pub const PCI_STD_RESOURCE_END: _bindgen_ty_269 = 5;
pub const PCI_ROM_RESOURCE: _bindgen_ty_269 = 6;
pub const PCI_IOV_RESOURCES: _bindgen_ty_269 = 7;
pub const PCI_IOV_RESOURCE_END: _bindgen_ty_269 = 12;
pub const PCI_BRIDGE_RESOURCES: _bindgen_ty_269 = 13;
pub const PCI_BRIDGE_RESOURCE_END: _bindgen_ty_269 = 16;
pub const PCI_NUM_RESOURCES: _bindgen_ty_269 = 17;
pub const DEVICE_COUNT_RESOURCE: _bindgen_ty_269 = 17;
pub type _bindgen_ty_269 = ffi::c_uint;
pub const pci_interrupt_pin_PCI_INTERRUPT_UNKNOWN: pci_interrupt_pin = 0;
pub const pci_interrupt_pin_PCI_INTERRUPT_INTA: pci_interrupt_pin = 1;
pub const pci_interrupt_pin_PCI_INTERRUPT_INTB: pci_interrupt_pin = 2;
pub const pci_interrupt_pin_PCI_INTERRUPT_INTC: pci_interrupt_pin = 3;
pub const pci_interrupt_pin_PCI_INTERRUPT_INTD: pci_interrupt_pin = 4;
pub type pci_interrupt_pin = ffi::c_uint;
pub type pci_power_t = ffi::c_int;
extern "C" {
    pub static mut pci_power_names: [*const ffi::c_char; 0usize];
}
pub type pci_channel_state_t = ffi::c_uint;
pub const pci_channel_io_normal: _bindgen_ty_270 = 1;
pub const pci_channel_io_frozen: _bindgen_ty_270 = 2;
pub const pci_channel_io_perm_failure: _bindgen_ty_270 = 3;
pub type _bindgen_ty_270 = ffi::c_uint;
pub type pcie_reset_state_t = ffi::c_uint;
pub const pcie_reset_state_pcie_deassert_reset: pcie_reset_state = 1;
pub const pcie_reset_state_pcie_warm_reset: pcie_reset_state = 2;
pub const pcie_reset_state_pcie_hot_reset: pcie_reset_state = 3;
pub type pcie_reset_state = ffi::c_uint;
pub type pci_dev_flags_t = ffi::c_ushort;
pub const pci_dev_flags_PCI_DEV_FLAGS_MSI_INTX_DISABLE_BUG: pci_dev_flags = 1;
pub const pci_dev_flags_PCI_DEV_FLAGS_NO_D3: pci_dev_flags = 2;
pub const pci_dev_flags_PCI_DEV_FLAGS_ASSIGNED: pci_dev_flags = 4;
pub const pci_dev_flags_PCI_DEV_FLAGS_ACS_ENABLED_QUIRK: pci_dev_flags = 8;
pub const pci_dev_flags_PCI_DEV_FLAG_PCIE_BRIDGE_ALIAS: pci_dev_flags = 32;
pub const pci_dev_flags_PCI_DEV_FLAGS_NO_BUS_RESET: pci_dev_flags = 64;
pub const pci_dev_flags_PCI_DEV_FLAGS_NO_PM_RESET: pci_dev_flags = 128;
pub const pci_dev_flags_PCI_DEV_FLAGS_VPD_REF_F0: pci_dev_flags = 256;
pub const pci_dev_flags_PCI_DEV_FLAGS_BRIDGE_XLATE_ROOT: pci_dev_flags = 512;
pub const pci_dev_flags_PCI_DEV_FLAGS_NO_FLR_RESET: pci_dev_flags = 1024;
pub const pci_dev_flags_PCI_DEV_FLAGS_NO_RELAXED_ORDERING: pci_dev_flags = 2048;
pub const pci_dev_flags_PCI_DEV_FLAGS_HAS_MSI_MASKING: pci_dev_flags = 4096;
pub const pci_dev_flags_PCI_DEV_FLAGS_MSIX_TOUCH_ENTRY_DATA_FIRST: pci_dev_flags = 8192;
pub type pci_dev_flags = ffi::c_uint;
pub const pci_irq_reroute_variant_INTEL_IRQ_REROUTE_VARIANT: pci_irq_reroute_variant = 1;
pub const pci_irq_reroute_variant_MAX_IRQ_REROUTE_VARIANTS: pci_irq_reroute_variant = 3;
pub type pci_irq_reroute_variant = ffi::c_uint;
pub type pci_bus_flags_t = ffi::c_ushort;
pub const pci_bus_flags_PCI_BUS_FLAGS_NO_MSI: pci_bus_flags = 1;
pub const pci_bus_flags_PCI_BUS_FLAGS_NO_MMRBC: pci_bus_flags = 2;
pub const pci_bus_flags_PCI_BUS_FLAGS_NO_AERSID: pci_bus_flags = 4;
pub const pci_bus_flags_PCI_BUS_FLAGS_NO_EXTCFG: pci_bus_flags = 8;
pub type pci_bus_flags = ffi::c_uint;
pub const pcie_link_width_PCIE_LNK_WIDTH_RESRV: pcie_link_width = 0;
pub const pcie_link_width_PCIE_LNK_X1: pcie_link_width = 1;
pub const pcie_link_width_PCIE_LNK_X2: pcie_link_width = 2;
pub const pcie_link_width_PCIE_LNK_X4: pcie_link_width = 4;
pub const pcie_link_width_PCIE_LNK_X8: pcie_link_width = 8;
pub const pcie_link_width_PCIE_LNK_X12: pcie_link_width = 12;
pub const pcie_link_width_PCIE_LNK_X16: pcie_link_width = 16;
pub const pcie_link_width_PCIE_LNK_X32: pcie_link_width = 32;
pub const pcie_link_width_PCIE_LNK_WIDTH_UNKNOWN: pcie_link_width = 255;
pub type pcie_link_width = ffi::c_uint;
pub const pci_bus_speed_PCI_SPEED_33MHz: pci_bus_speed = 0;
pub const pci_bus_speed_PCI_SPEED_66MHz: pci_bus_speed = 1;
pub const pci_bus_speed_PCI_SPEED_66MHz_PCIX: pci_bus_speed = 2;
pub const pci_bus_speed_PCI_SPEED_100MHz_PCIX: pci_bus_speed = 3;
pub const pci_bus_speed_PCI_SPEED_133MHz_PCIX: pci_bus_speed = 4;
pub const pci_bus_speed_PCI_SPEED_66MHz_PCIX_ECC: pci_bus_speed = 5;
pub const pci_bus_speed_PCI_SPEED_100MHz_PCIX_ECC: pci_bus_speed = 6;
pub const pci_bus_speed_PCI_SPEED_133MHz_PCIX_ECC: pci_bus_speed = 7;
pub const pci_bus_speed_PCI_SPEED_66MHz_PCIX_266: pci_bus_speed = 9;
pub const pci_bus_speed_PCI_SPEED_100MHz_PCIX_266: pci_bus_speed = 10;
pub const pci_bus_speed_PCI_SPEED_133MHz_PCIX_266: pci_bus_speed = 11;
pub const pci_bus_speed_AGP_UNKNOWN: pci_bus_speed = 12;
pub const pci_bus_speed_AGP_1X: pci_bus_speed = 13;
pub const pci_bus_speed_AGP_2X: pci_bus_speed = 14;
pub const pci_bus_speed_AGP_4X: pci_bus_speed = 15;
pub const pci_bus_speed_AGP_8X: pci_bus_speed = 16;
pub const pci_bus_speed_PCI_SPEED_66MHz_PCIX_533: pci_bus_speed = 17;
pub const pci_bus_speed_PCI_SPEED_100MHz_PCIX_533: pci_bus_speed = 18;
pub const pci_bus_speed_PCI_SPEED_133MHz_PCIX_533: pci_bus_speed = 19;
pub const pci_bus_speed_PCIE_SPEED_2_5GT: pci_bus_speed = 20;
pub const pci_bus_speed_PCIE_SPEED_5_0GT: pci_bus_speed = 21;
pub const pci_bus_speed_PCIE_SPEED_8_0GT: pci_bus_speed = 22;
pub const pci_bus_speed_PCIE_SPEED_16_0GT: pci_bus_speed = 23;
pub const pci_bus_speed_PCIE_SPEED_32_0GT: pci_bus_speed = 24;
pub const pci_bus_speed_PCIE_SPEED_64_0GT: pci_bus_speed = 25;
pub const pci_bus_speed_PCI_SPEED_UNKNOWN: pci_bus_speed = 255;
pub type pci_bus_speed = ffi::c_uint;
extern "C" {
    pub fn pcie_get_speed_cap(dev: *mut pci_dev) -> pci_bus_speed;
}
extern "C" {
    pub fn pcie_get_width_cap(dev: *mut pci_dev) -> pcie_link_width;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct pci_vpd {
    pub lock: mutex,
    pub len: ffi::c_uint,
    pub cap: u8_,
}
impl Default for pci_vpd {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct pcie_bwctrl_data {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct pcie_link_state {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct pci_sriov {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct pci_p2pdma {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rcec_ea {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct pci_dev {
    pub bus_list: list_head,
    pub bus: *mut pci_bus,
    pub subordinate: *mut pci_bus,
    pub sysdata: *mut ffi::c_void,
    pub procent: *mut proc_dir_entry,
    pub slot: *mut pci_slot,
    pub devfn: ffi::c_uint,
    pub vendor: ffi::c_ushort,
    pub device: ffi::c_ushort,
    pub subsystem_vendor: ffi::c_ushort,
    pub subsystem_device: ffi::c_ushort,
    pub class: ffi::c_uint,
    pub revision: u8_,
    pub hdr_type: u8_,
    pub aer_cap: u16_,
    pub aer_stats: *mut aer_stats,
    pub rcec_ea: *mut rcec_ea,
    pub rcec: *mut pci_dev,
    pub devcap: u32_,
    pub rebar_cap: u16_,
    pub pcie_cap: u8_,
    pub msi_cap: u8_,
    pub msix_cap: u8_,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub rom_base_reg: u8_,
    pub pin: u8_,
    pub pcie_flags_reg: u16_,
    pub dma_alias_mask: *mut ffi::c_ulong,
    pub driver: *mut pci_driver,
    pub dma_mask: u64_,
    pub dma_parms: device_dma_parameters,
    pub current_state: pci_power_t,
    pub pm_cap: u8_,
    pub _bitfield_align_2: [u8; 0],
    pub _bitfield_2: __BindgenBitfieldUnit<[u8; 3usize]>,
    pub d3hot_delay: ffi::c_uint,
    pub d3cold_delay: ffi::c_uint,
    pub l1ss: u16_,
    pub link_state: *mut pcie_link_state,
    pub _bitfield_align_3: [u8; 0],
    pub _bitfield_3: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub error_state: pci_channel_state_t,
    pub dev: device,
    pub cfg_size: ffi::c_int,
    pub irq: ffi::c_uint,
    pub resource: [resource; 17usize],
    pub driver_exclusive_resource: resource,
    pub match_driver: bool_,
    pub _bitfield_align_4: [u8; 0],
    pub _bitfield_4: __BindgenBitfieldUnit<[u8; 6usize]>,
    pub dev_flags: pci_dev_flags_t,
    pub enable_cnt: atomic_t,
    pub pcie_cap_lock: spinlock_t,
    pub saved_config_space: [u32_; 16usize],
    pub saved_cap_space: hlist_head,
    pub res_attr: [*mut bin_attribute; 17usize],
    pub res_attr_wc: [*mut bin_attribute; 17usize],
    pub _bitfield_align_5: [u8; 0],
    pub _bitfield_5: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub ptm_cap: u16_,
    pub _bitfield_align_6: [u8; 0],
    pub _bitfield_6: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub ptm_granularity: u8_,
    pub msix_base: *mut ffi::c_void,
    pub msi_lock: raw_spinlock_t,
    pub vpd: pci_vpd,
    pub dpc_cap: u16_,
    pub _bitfield_align_7: [u8; 0],
    pub _bitfield_7: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub dpc_rp_log_size: u8_,
    pub link_bwctrl: *mut pcie_bwctrl_data,
    pub __bindgen_anon_1: pci_dev__bindgen_ty_1,
    pub ats_cap: u16_,
    pub ats_stu: u8_,
    pub pri_cap: u16_,
    pub pri_reqs_alloc: u32_,
    pub _bitfield_align_8: [u8; 0],
    pub _bitfield_8: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub pasid_cap: u16_,
    pub pasid_features: u16_,
    pub p2pdma: *mut pci_p2pdma,
    pub doe_mbs: xarray,
    pub npem: *mut npem,
    pub acs_cap: u16_,
    pub supported_speeds: u8_,
    pub rom: phys_addr_t,
    pub romlen: usize,
    pub driver_override: *const ffi::c_char,
    pub priv_flags: ffi::c_ulong,
    pub reset_methods: [u8_; 8usize],
    pub tph_cap: u16_,
    pub tph_mode: u8_,
    pub tph_req_type: u8_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union pci_dev__bindgen_ty_1 {
    pub sriov: *mut pci_sriov,
    pub physfn: *mut pci_dev,
}
impl Default for pci_dev__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for pci_dev {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl pci_dev {
    #[inline]
    pub fn pcie_mpss(&self) -> u8_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 3u8) as u8) }
    }
    #[inline]
    pub fn set_pcie_mpss(&mut self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 3u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn pcie_mpss_raw(this: *const Self) -> u8_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                3u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_pcie_mpss_raw(this: *mut Self, val: u8_) {
        unsafe {
            let val: u8 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                3u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(pcie_mpss: u8_) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 3u8, {
            let pcie_mpss: u8 = unsafe { ::core::mem::transmute(pcie_mpss) };
            pcie_mpss as u64
        });
        __bindgen_bitfield_unit
    }
    #[inline]
    pub fn pme_support(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(0usize, 5u8) as u32) }
    }
    #[inline]
    pub fn set_pme_support(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_2.set(0usize, 5u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn pme_support_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                0usize,
                5u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_pme_support_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                0usize,
                5u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn pme_poll(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(5usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_pme_poll(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_2.set(5usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn pme_poll_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                5usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_pme_poll_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                5usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn pinned(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(6usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_pinned(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_2.set(6usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn pinned_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                6usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_pinned_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                6usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn config_rrs_sv(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(7usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_config_rrs_sv(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_2.set(7usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn config_rrs_sv_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                7usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_config_rrs_sv_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                7usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn imm_ready(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(8usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_imm_ready(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_2.set(8usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn imm_ready_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                8usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_imm_ready_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                8usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn d1_support(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(9usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_d1_support(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_2.set(9usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn d1_support_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                9usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_d1_support_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                9usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn d2_support(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(10usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_d2_support(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_2.set(10usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn d2_support_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                10usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_d2_support_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                10usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn no_d1d2(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(11usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_no_d1d2(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_2.set(11usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn no_d1d2_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                11usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_no_d1d2_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                11usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn no_d3cold(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(12usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_no_d3cold(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_2.set(12usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn no_d3cold_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                12usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_no_d3cold_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                12usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn bridge_d3(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(13usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_bridge_d3(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_2.set(13usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn bridge_d3_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                13usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_bridge_d3_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                13usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn d3cold_allowed(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(14usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_d3cold_allowed(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_2.set(14usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn d3cold_allowed_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                14usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_d3cold_allowed_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                14usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn mmio_always_on(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(15usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_mmio_always_on(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_2.set(15usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn mmio_always_on_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                15usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_mmio_always_on_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                15usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn wakeup_prepared(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(16usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_wakeup_prepared(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_2.set(16usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn wakeup_prepared_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                16usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_wakeup_prepared_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                16usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn skip_bus_pm(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(17usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_skip_bus_pm(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_2.set(17usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn skip_bus_pm_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                17usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_skip_bus_pm_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                17usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ignore_hotplug(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(18usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_ignore_hotplug(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_2.set(18usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ignore_hotplug_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                18usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ignore_hotplug_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                18usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn hotplug_user_indicators(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(19usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_hotplug_user_indicators(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_2.set(19usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn hotplug_user_indicators_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                19usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_hotplug_user_indicators_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                19usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn clear_retrain_link(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_2.get(20usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_clear_retrain_link(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_2.set(20usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn clear_retrain_link_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_2),
                20usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_clear_retrain_link_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_2),
                20usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_2(
        pme_support: ffi::c_uint,
        pme_poll: ffi::c_uint,
        pinned: ffi::c_uint,
        config_rrs_sv: ffi::c_uint,
        imm_ready: ffi::c_uint,
        d1_support: ffi::c_uint,
        d2_support: ffi::c_uint,
        no_d1d2: ffi::c_uint,
        no_d3cold: ffi::c_uint,
        bridge_d3: ffi::c_uint,
        d3cold_allowed: ffi::c_uint,
        mmio_always_on: ffi::c_uint,
        wakeup_prepared: ffi::c_uint,
        skip_bus_pm: ffi::c_uint,
        ignore_hotplug: ffi::c_uint,
        hotplug_user_indicators: ffi::c_uint,
        clear_retrain_link: ffi::c_uint,
    ) -> __BindgenBitfieldUnit<[u8; 3usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 3usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 5u8, {
            let pme_support: u32 = unsafe { ::core::mem::transmute(pme_support) };
            pme_support as u64
        });
        __bindgen_bitfield_unit.set(5usize, 1u8, {
            let pme_poll: u32 = unsafe { ::core::mem::transmute(pme_poll) };
            pme_poll as u64
        });
        __bindgen_bitfield_unit.set(6usize, 1u8, {
            let pinned: u32 = unsafe { ::core::mem::transmute(pinned) };
            pinned as u64
        });
        __bindgen_bitfield_unit.set(7usize, 1u8, {
            let config_rrs_sv: u32 = unsafe { ::core::mem::transmute(config_rrs_sv) };
            config_rrs_sv as u64
        });
        __bindgen_bitfield_unit.set(8usize, 1u8, {
            let imm_ready: u32 = unsafe { ::core::mem::transmute(imm_ready) };
            imm_ready as u64
        });
        __bindgen_bitfield_unit.set(9usize, 1u8, {
            let d1_support: u32 = unsafe { ::core::mem::transmute(d1_support) };
            d1_support as u64
        });
        __bindgen_bitfield_unit.set(10usize, 1u8, {
            let d2_support: u32 = unsafe { ::core::mem::transmute(d2_support) };
            d2_support as u64
        });
        __bindgen_bitfield_unit.set(11usize, 1u8, {
            let no_d1d2: u32 = unsafe { ::core::mem::transmute(no_d1d2) };
            no_d1d2 as u64
        });
        __bindgen_bitfield_unit.set(12usize, 1u8, {
            let no_d3cold: u32 = unsafe { ::core::mem::transmute(no_d3cold) };
            no_d3cold as u64
        });
        __bindgen_bitfield_unit.set(13usize, 1u8, {
            let bridge_d3: u32 = unsafe { ::core::mem::transmute(bridge_d3) };
            bridge_d3 as u64
        });
        __bindgen_bitfield_unit.set(14usize, 1u8, {
            let d3cold_allowed: u32 = unsafe { ::core::mem::transmute(d3cold_allowed) };
            d3cold_allowed as u64
        });
        __bindgen_bitfield_unit.set(15usize, 1u8, {
            let mmio_always_on: u32 = unsafe { ::core::mem::transmute(mmio_always_on) };
            mmio_always_on as u64
        });
        __bindgen_bitfield_unit.set(16usize, 1u8, {
            let wakeup_prepared: u32 = unsafe { ::core::mem::transmute(wakeup_prepared) };
            wakeup_prepared as u64
        });
        __bindgen_bitfield_unit.set(17usize, 1u8, {
            let skip_bus_pm: u32 = unsafe { ::core::mem::transmute(skip_bus_pm) };
            skip_bus_pm as u64
        });
        __bindgen_bitfield_unit.set(18usize, 1u8, {
            let ignore_hotplug: u32 = unsafe { ::core::mem::transmute(ignore_hotplug) };
            ignore_hotplug as u64
        });
        __bindgen_bitfield_unit.set(19usize, 1u8, {
            let hotplug_user_indicators: u32 =
                unsafe { ::core::mem::transmute(hotplug_user_indicators) };
            hotplug_user_indicators as u64
        });
        __bindgen_bitfield_unit.set(20usize, 1u8, {
            let clear_retrain_link: u32 = unsafe { ::core::mem::transmute(clear_retrain_link) };
            clear_retrain_link as u64
        });
        __bindgen_bitfield_unit
    }
    #[inline]
    pub fn ltr_path(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_3.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_ltr_path(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_3.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ltr_path_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_3),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ltr_path_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_3),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn pasid_no_tlp(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_3.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_pasid_no_tlp(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_3.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn pasid_no_tlp_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_3),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_pasid_no_tlp_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_3),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn eetlp_prefix_max(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_3.get(2usize, 3u8) as u32) }
    }
    #[inline]
    pub fn set_eetlp_prefix_max(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_3.set(2usize, 3u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn eetlp_prefix_max_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_3),
                2usize,
                3u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_eetlp_prefix_max_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_3),
                2usize,
                3u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_3(
        ltr_path: ffi::c_uint,
        pasid_no_tlp: ffi::c_uint,
        eetlp_prefix_max: ffi::c_uint,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let ltr_path: u32 = unsafe { ::core::mem::transmute(ltr_path) };
            ltr_path as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let pasid_no_tlp: u32 = unsafe { ::core::mem::transmute(pasid_no_tlp) };
            pasid_no_tlp as u64
        });
        __bindgen_bitfield_unit.set(2usize, 3u8, {
            let eetlp_prefix_max: u32 = unsafe { ::core::mem::transmute(eetlp_prefix_max) };
            eetlp_prefix_max as u64
        });
        __bindgen_bitfield_unit
    }
    #[inline]
    pub fn transparent(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_transparent(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn transparent_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_transparent_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn io_window(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_io_window(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn io_window_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_io_window_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn pref_window(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_pref_window(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn pref_window_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_pref_window_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn pref_64_window(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(3usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_pref_64_window(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn pref_64_window_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                3usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_pref_64_window_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn multifunction(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(4usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_multifunction(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn multifunction_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                4usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_multifunction_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn is_busmaster(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(5usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_is_busmaster(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(5usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn is_busmaster_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                5usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_is_busmaster_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                5usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn no_msi(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(6usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_no_msi(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(6usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn no_msi_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                6usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_no_msi_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                6usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn no_64bit_msi(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(7usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_no_64bit_msi(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(7usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn no_64bit_msi_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                7usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_no_64bit_msi_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                7usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn block_cfg_access(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(8usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_block_cfg_access(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(8usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn block_cfg_access_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                8usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_block_cfg_access_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                8usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn broken_parity_status(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(9usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_broken_parity_status(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(9usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn broken_parity_status_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                9usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_broken_parity_status_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                9usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn irq_reroute_variant(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(10usize, 2u8) as u32) }
    }
    #[inline]
    pub fn set_irq_reroute_variant(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(10usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn irq_reroute_variant_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                10usize,
                2u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_irq_reroute_variant_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                10usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn msi_enabled(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(12usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_msi_enabled(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(12usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn msi_enabled_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                12usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_msi_enabled_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                12usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn msix_enabled(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(13usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_msix_enabled(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(13usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn msix_enabled_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                13usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_msix_enabled_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                13usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ari_enabled(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(14usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_ari_enabled(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(14usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ari_enabled_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                14usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ari_enabled_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                14usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ats_enabled(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(15usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_ats_enabled(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(15usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ats_enabled_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                15usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ats_enabled_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                15usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn pasid_enabled(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(16usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_pasid_enabled(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(16usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn pasid_enabled_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                16usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_pasid_enabled_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                16usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn pri_enabled(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(17usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_pri_enabled(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(17usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn pri_enabled_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                17usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_pri_enabled_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                17usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn tph_enabled(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(18usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_tph_enabled(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(18usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn tph_enabled_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                18usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_tph_enabled_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                18usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn is_managed(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(19usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_is_managed(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(19usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn is_managed_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                19usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_is_managed_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                19usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn is_msi_managed(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(20usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_is_msi_managed(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(20usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn is_msi_managed_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                20usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_is_msi_managed_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                20usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn needs_freset(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(21usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_needs_freset(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(21usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn needs_freset_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                21usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_needs_freset_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                21usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn state_saved(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(22usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_state_saved(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(22usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn state_saved_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                22usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_state_saved_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                22usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn is_physfn(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(23usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_is_physfn(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(23usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn is_physfn_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                23usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_is_physfn_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                23usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn is_virtfn(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(24usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_is_virtfn(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(24usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn is_virtfn_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                24usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_is_virtfn_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                24usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn is_hotplug_bridge(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(25usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_is_hotplug_bridge(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(25usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn is_hotplug_bridge_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                25usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_is_hotplug_bridge_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                25usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn shpc_managed(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(26usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_shpc_managed(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(26usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn shpc_managed_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                26usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_shpc_managed_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                26usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn is_thunderbolt(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(27usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_is_thunderbolt(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(27usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn is_thunderbolt_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                27usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_is_thunderbolt_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                27usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn untrusted(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(28usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_untrusted(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(28usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn untrusted_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                28usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_untrusted_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                28usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn external_facing(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(29usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_external_facing(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(29usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn external_facing_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                29usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_external_facing_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                29usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn broken_intx_masking(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(30usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_broken_intx_masking(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(30usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn broken_intx_masking_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                30usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_broken_intx_masking_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                30usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn io_window_1k(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(31usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_io_window_1k(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(31usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn io_window_1k_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                31usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_io_window_1k_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                31usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn irq_managed(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(32usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_irq_managed(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(32usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn irq_managed_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                32usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_irq_managed_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                32usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn non_compliant_bars(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(33usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_non_compliant_bars(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(33usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn non_compliant_bars_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                33usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_non_compliant_bars_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                33usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn is_probed(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(34usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_is_probed(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(34usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn is_probed_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                34usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_is_probed_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                34usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn link_active_reporting(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(35usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_link_active_reporting(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(35usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn link_active_reporting_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                35usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_link_active_reporting_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                35usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn no_vf_scan(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(36usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_no_vf_scan(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(36usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn no_vf_scan_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                36usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_no_vf_scan_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                36usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn no_command_memory(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(37usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_no_command_memory(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(37usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn no_command_memory_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                37usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_no_command_memory_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                37usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn rom_bar_overlap(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(38usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_rom_bar_overlap(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(38usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn rom_bar_overlap_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                38usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_rom_bar_overlap_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                38usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn rom_attr_enabled(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(39usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_rom_attr_enabled(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(39usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn rom_attr_enabled_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                39usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_rom_attr_enabled_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                39usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn non_mappable_bars(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_4.get(40usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_non_mappable_bars(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_4.set(40usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn non_mappable_bars_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 6usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_4),
                40usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_non_mappable_bars_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 6usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_4),
                40usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_4(
        transparent: ffi::c_uint,
        io_window: ffi::c_uint,
        pref_window: ffi::c_uint,
        pref_64_window: ffi::c_uint,
        multifunction: ffi::c_uint,
        is_busmaster: ffi::c_uint,
        no_msi: ffi::c_uint,
        no_64bit_msi: ffi::c_uint,
        block_cfg_access: ffi::c_uint,
        broken_parity_status: ffi::c_uint,
        irq_reroute_variant: ffi::c_uint,
        msi_enabled: ffi::c_uint,
        msix_enabled: ffi::c_uint,
        ari_enabled: ffi::c_uint,
        ats_enabled: ffi::c_uint,
        pasid_enabled: ffi::c_uint,
        pri_enabled: ffi::c_uint,
        tph_enabled: ffi::c_uint,
        is_managed: ffi::c_uint,
        is_msi_managed: ffi::c_uint,
        needs_freset: ffi::c_uint,
        state_saved: ffi::c_uint,
        is_physfn: ffi::c_uint,
        is_virtfn: ffi::c_uint,
        is_hotplug_bridge: ffi::c_uint,
        shpc_managed: ffi::c_uint,
        is_thunderbolt: ffi::c_uint,
        untrusted: ffi::c_uint,
        external_facing: ffi::c_uint,
        broken_intx_masking: ffi::c_uint,
        io_window_1k: ffi::c_uint,
        irq_managed: ffi::c_uint,
        non_compliant_bars: ffi::c_uint,
        is_probed: ffi::c_uint,
        link_active_reporting: ffi::c_uint,
        no_vf_scan: ffi::c_uint,
        no_command_memory: ffi::c_uint,
        rom_bar_overlap: ffi::c_uint,
        rom_attr_enabled: ffi::c_uint,
        non_mappable_bars: ffi::c_uint,
    ) -> __BindgenBitfieldUnit<[u8; 6usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 6usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let transparent: u32 = unsafe { ::core::mem::transmute(transparent) };
            transparent as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let io_window: u32 = unsafe { ::core::mem::transmute(io_window) };
            io_window as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let pref_window: u32 = unsafe { ::core::mem::transmute(pref_window) };
            pref_window as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let pref_64_window: u32 = unsafe { ::core::mem::transmute(pref_64_window) };
            pref_64_window as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let multifunction: u32 = unsafe { ::core::mem::transmute(multifunction) };
            multifunction as u64
        });
        __bindgen_bitfield_unit.set(5usize, 1u8, {
            let is_busmaster: u32 = unsafe { ::core::mem::transmute(is_busmaster) };
            is_busmaster as u64
        });
        __bindgen_bitfield_unit.set(6usize, 1u8, {
            let no_msi: u32 = unsafe { ::core::mem::transmute(no_msi) };
            no_msi as u64
        });
        __bindgen_bitfield_unit.set(7usize, 1u8, {
            let no_64bit_msi: u32 = unsafe { ::core::mem::transmute(no_64bit_msi) };
            no_64bit_msi as u64
        });
        __bindgen_bitfield_unit.set(8usize, 1u8, {
            let block_cfg_access: u32 = unsafe { ::core::mem::transmute(block_cfg_access) };
            block_cfg_access as u64
        });
        __bindgen_bitfield_unit.set(9usize, 1u8, {
            let broken_parity_status: u32 = unsafe { ::core::mem::transmute(broken_parity_status) };
            broken_parity_status as u64
        });
        __bindgen_bitfield_unit.set(10usize, 2u8, {
            let irq_reroute_variant: u32 = unsafe { ::core::mem::transmute(irq_reroute_variant) };
            irq_reroute_variant as u64
        });
        __bindgen_bitfield_unit.set(12usize, 1u8, {
            let msi_enabled: u32 = unsafe { ::core::mem::transmute(msi_enabled) };
            msi_enabled as u64
        });
        __bindgen_bitfield_unit.set(13usize, 1u8, {
            let msix_enabled: u32 = unsafe { ::core::mem::transmute(msix_enabled) };
            msix_enabled as u64
        });
        __bindgen_bitfield_unit.set(14usize, 1u8, {
            let ari_enabled: u32 = unsafe { ::core::mem::transmute(ari_enabled) };
            ari_enabled as u64
        });
        __bindgen_bitfield_unit.set(15usize, 1u8, {
            let ats_enabled: u32 = unsafe { ::core::mem::transmute(ats_enabled) };
            ats_enabled as u64
        });
        __bindgen_bitfield_unit.set(16usize, 1u8, {
            let pasid_enabled: u32 = unsafe { ::core::mem::transmute(pasid_enabled) };
            pasid_enabled as u64
        });
        __bindgen_bitfield_unit.set(17usize, 1u8, {
            let pri_enabled: u32 = unsafe { ::core::mem::transmute(pri_enabled) };
            pri_enabled as u64
        });
        __bindgen_bitfield_unit.set(18usize, 1u8, {
            let tph_enabled: u32 = unsafe { ::core::mem::transmute(tph_enabled) };
            tph_enabled as u64
        });
        __bindgen_bitfield_unit.set(19usize, 1u8, {
            let is_managed: u32 = unsafe { ::core::mem::transmute(is_managed) };
            is_managed as u64
        });
        __bindgen_bitfield_unit.set(20usize, 1u8, {
            let is_msi_managed: u32 = unsafe { ::core::mem::transmute(is_msi_managed) };
            is_msi_managed as u64
        });
        __bindgen_bitfield_unit.set(21usize, 1u8, {
            let needs_freset: u32 = unsafe { ::core::mem::transmute(needs_freset) };
            needs_freset as u64
        });
        __bindgen_bitfield_unit.set(22usize, 1u8, {
            let state_saved: u32 = unsafe { ::core::mem::transmute(state_saved) };
            state_saved as u64
        });
        __bindgen_bitfield_unit.set(23usize, 1u8, {
            let is_physfn: u32 = unsafe { ::core::mem::transmute(is_physfn) };
            is_physfn as u64
        });
        __bindgen_bitfield_unit.set(24usize, 1u8, {
            let is_virtfn: u32 = unsafe { ::core::mem::transmute(is_virtfn) };
            is_virtfn as u64
        });
        __bindgen_bitfield_unit.set(25usize, 1u8, {
            let is_hotplug_bridge: u32 = unsafe { ::core::mem::transmute(is_hotplug_bridge) };
            is_hotplug_bridge as u64
        });
        __bindgen_bitfield_unit.set(26usize, 1u8, {
            let shpc_managed: u32 = unsafe { ::core::mem::transmute(shpc_managed) };
            shpc_managed as u64
        });
        __bindgen_bitfield_unit.set(27usize, 1u8, {
            let is_thunderbolt: u32 = unsafe { ::core::mem::transmute(is_thunderbolt) };
            is_thunderbolt as u64
        });
        __bindgen_bitfield_unit.set(28usize, 1u8, {
            let untrusted: u32 = unsafe { ::core::mem::transmute(untrusted) };
            untrusted as u64
        });
        __bindgen_bitfield_unit.set(29usize, 1u8, {
            let external_facing: u32 = unsafe { ::core::mem::transmute(external_facing) };
            external_facing as u64
        });
        __bindgen_bitfield_unit.set(30usize, 1u8, {
            let broken_intx_masking: u32 = unsafe { ::core::mem::transmute(broken_intx_masking) };
            broken_intx_masking as u64
        });
        __bindgen_bitfield_unit.set(31usize, 1u8, {
            let io_window_1k: u32 = unsafe { ::core::mem::transmute(io_window_1k) };
            io_window_1k as u64
        });
        __bindgen_bitfield_unit.set(32usize, 1u8, {
            let irq_managed: u32 = unsafe { ::core::mem::transmute(irq_managed) };
            irq_managed as u64
        });
        __bindgen_bitfield_unit.set(33usize, 1u8, {
            let non_compliant_bars: u32 = unsafe { ::core::mem::transmute(non_compliant_bars) };
            non_compliant_bars as u64
        });
        __bindgen_bitfield_unit.set(34usize, 1u8, {
            let is_probed: u32 = unsafe { ::core::mem::transmute(is_probed) };
            is_probed as u64
        });
        __bindgen_bitfield_unit.set(35usize, 1u8, {
            let link_active_reporting: u32 =
                unsafe { ::core::mem::transmute(link_active_reporting) };
            link_active_reporting as u64
        });
        __bindgen_bitfield_unit.set(36usize, 1u8, {
            let no_vf_scan: u32 = unsafe { ::core::mem::transmute(no_vf_scan) };
            no_vf_scan as u64
        });
        __bindgen_bitfield_unit.set(37usize, 1u8, {
            let no_command_memory: u32 = unsafe { ::core::mem::transmute(no_command_memory) };
            no_command_memory as u64
        });
        __bindgen_bitfield_unit.set(38usize, 1u8, {
            let rom_bar_overlap: u32 = unsafe { ::core::mem::transmute(rom_bar_overlap) };
            rom_bar_overlap as u64
        });
        __bindgen_bitfield_unit.set(39usize, 1u8, {
            let rom_attr_enabled: u32 = unsafe { ::core::mem::transmute(rom_attr_enabled) };
            rom_attr_enabled as u64
        });
        __bindgen_bitfield_unit.set(40usize, 1u8, {
            let non_mappable_bars: u32 = unsafe { ::core::mem::transmute(non_mappable_bars) };
            non_mappable_bars as u64
        });
        __bindgen_bitfield_unit
    }
    #[inline]
    pub fn broken_cmd_compl(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_5.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_broken_cmd_compl(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_5.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn broken_cmd_compl_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_5),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_broken_cmd_compl_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_5),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_5(broken_cmd_compl: ffi::c_uint) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let broken_cmd_compl: u32 = unsafe { ::core::mem::transmute(broken_cmd_compl) };
            broken_cmd_compl as u64
        });
        __bindgen_bitfield_unit
    }
    #[inline]
    pub fn ptm_root(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_6.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_ptm_root(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_6.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ptm_root_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_6),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ptm_root_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_6),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ptm_enabled(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_6.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_ptm_enabled(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_6.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ptm_enabled_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_6),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ptm_enabled_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_6),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_6(
        ptm_root: ffi::c_uint,
        ptm_enabled: ffi::c_uint,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let ptm_root: u32 = unsafe { ::core::mem::transmute(ptm_root) };
            ptm_root as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let ptm_enabled: u32 = unsafe { ::core::mem::transmute(ptm_enabled) };
            ptm_enabled as u64
        });
        __bindgen_bitfield_unit
    }
    #[inline]
    pub fn dpc_rp_extensions(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_7.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_dpc_rp_extensions(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_7.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn dpc_rp_extensions_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_7),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_dpc_rp_extensions_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_7),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_7(dpc_rp_extensions: ffi::c_uint) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let dpc_rp_extensions: u32 = unsafe { ::core::mem::transmute(dpc_rp_extensions) };
            dpc_rp_extensions as u64
        });
        __bindgen_bitfield_unit
    }
    #[inline]
    pub fn pasid_required(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_8.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_pasid_required(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_8.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn pasid_required_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_8),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_pasid_required_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_8),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_8(pasid_required: ffi::c_uint) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let pasid_required: u32 = unsafe { ::core::mem::transmute(pasid_required) };
            pasid_required as u64
        });
        __bindgen_bitfield_unit
    }
}
extern "C" {
    pub fn pci_alloc_dev(bus: *mut pci_bus) -> *mut pci_dev;
}
#[repr(C)]
#[repr(align(64))]
pub struct pci_host_bridge {
    pub dev: device,
    pub bus: *mut pci_bus,
    pub ops: *mut pci_ops,
    pub child_ops: *mut pci_ops,
    pub sysdata: *mut ffi::c_void,
    pub busnr: ffi::c_int,
    pub domain_nr: ffi::c_int,
    pub windows: list_head,
    pub dma_ranges: list_head,
    pub swizzle_irq:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut pci_dev, arg2: *mut u8_) -> u8_>,
    pub map_irq: ::core::option::Option<
        unsafe extern "C" fn(arg1: *const pci_dev, arg2: u8_, arg3: u8_) -> ffi::c_int,
    >,
    pub release_fn: ::core::option::Option<unsafe extern "C" fn(arg1: *mut pci_host_bridge)>,
    pub enable_device: ::core::option::Option<
        unsafe extern "C" fn(bridge: *mut pci_host_bridge, dev: *mut pci_dev) -> ffi::c_int,
    >,
    pub disable_device: ::core::option::Option<
        unsafe extern "C" fn(bridge: *mut pci_host_bridge, dev: *mut pci_dev),
    >,
    pub release_data: *mut ffi::c_void,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
    pub align_resource: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut pci_dev,
            res: *const resource,
            start: resource_size_t,
            size: resource_size_t,
            align: resource_size_t,
        ) -> resource_size_t,
    >,
    pub __bindgen_padding_0: u64,
    pub private: __IncompleteArrayField<ffi::c_ulong>,
}
impl Default for pci_host_bridge {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl pci_host_bridge {
    #[inline]
    pub fn ignore_reset_delay(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_ignore_reset_delay(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ignore_reset_delay_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ignore_reset_delay_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn no_ext_tags(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_no_ext_tags(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn no_ext_tags_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_no_ext_tags_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn no_inc_mrrs(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_no_inc_mrrs(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn no_inc_mrrs_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_no_inc_mrrs_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn native_aer(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_native_aer(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn native_aer_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_native_aer_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn native_pcie_hotplug(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_native_pcie_hotplug(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn native_pcie_hotplug_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_native_pcie_hotplug_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn native_shpc_hotplug(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_native_shpc_hotplug(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(5usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn native_shpc_hotplug_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_native_shpc_hotplug_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn native_pme(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_native_pme(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(6usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn native_pme_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                6usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_native_pme_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                6usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn native_ltr(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_native_ltr(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(7usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn native_ltr_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                7usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_native_ltr_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                7usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn native_dpc(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(8usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_native_dpc(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(8usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn native_dpc_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                8usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_native_dpc_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                8usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn native_cxl_error(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(9usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_native_cxl_error(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(9usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn native_cxl_error_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                9usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_native_cxl_error_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                9usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn preserve_config(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(10usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_preserve_config(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(10usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn preserve_config_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                10usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_preserve_config_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                10usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn size_windows(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(11usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_size_windows(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(11usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn size_windows_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                11usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_size_windows_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                11usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn msi_domain(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(12usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_msi_domain(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(12usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn msi_domain_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                12usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_msi_domain_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                12usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        ignore_reset_delay: ffi::c_uint,
        no_ext_tags: ffi::c_uint,
        no_inc_mrrs: ffi::c_uint,
        native_aer: ffi::c_uint,
        native_pcie_hotplug: ffi::c_uint,
        native_shpc_hotplug: ffi::c_uint,
        native_pme: ffi::c_uint,
        native_ltr: ffi::c_uint,
        native_dpc: ffi::c_uint,
        native_cxl_error: ffi::c_uint,
        preserve_config: ffi::c_uint,
        size_windows: ffi::c_uint,
        msi_domain: ffi::c_uint,
    ) -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let ignore_reset_delay: u32 = unsafe { ::core::mem::transmute(ignore_reset_delay) };
            ignore_reset_delay as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let no_ext_tags: u32 = unsafe { ::core::mem::transmute(no_ext_tags) };
            no_ext_tags as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let no_inc_mrrs: u32 = unsafe { ::core::mem::transmute(no_inc_mrrs) };
            no_inc_mrrs as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let native_aer: u32 = unsafe { ::core::mem::transmute(native_aer) };
            native_aer as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let native_pcie_hotplug: u32 = unsafe { ::core::mem::transmute(native_pcie_hotplug) };
            native_pcie_hotplug as u64
        });
        __bindgen_bitfield_unit.set(5usize, 1u8, {
            let native_shpc_hotplug: u32 = unsafe { ::core::mem::transmute(native_shpc_hotplug) };
            native_shpc_hotplug as u64
        });
        __bindgen_bitfield_unit.set(6usize, 1u8, {
            let native_pme: u32 = unsafe { ::core::mem::transmute(native_pme) };
            native_pme as u64
        });
        __bindgen_bitfield_unit.set(7usize, 1u8, {
            let native_ltr: u32 = unsafe { ::core::mem::transmute(native_ltr) };
            native_ltr as u64
        });
        __bindgen_bitfield_unit.set(8usize, 1u8, {
            let native_dpc: u32 = unsafe { ::core::mem::transmute(native_dpc) };
            native_dpc as u64
        });
        __bindgen_bitfield_unit.set(9usize, 1u8, {
            let native_cxl_error: u32 = unsafe { ::core::mem::transmute(native_cxl_error) };
            native_cxl_error as u64
        });
        __bindgen_bitfield_unit.set(10usize, 1u8, {
            let preserve_config: u32 = unsafe { ::core::mem::transmute(preserve_config) };
            preserve_config as u64
        });
        __bindgen_bitfield_unit.set(11usize, 1u8, {
            let size_windows: u32 = unsafe { ::core::mem::transmute(size_windows) };
            size_windows as u64
        });
        __bindgen_bitfield_unit.set(12usize, 1u8, {
            let msi_domain: u32 = unsafe { ::core::mem::transmute(msi_domain) };
            msi_domain as u64
        });
        __bindgen_bitfield_unit
    }
}
extern "C" {
    pub fn pci_alloc_host_bridge(priv_: usize) -> *mut pci_host_bridge;
}
extern "C" {
    pub fn devm_pci_alloc_host_bridge(dev: *mut device, priv_: usize) -> *mut pci_host_bridge;
}
extern "C" {
    pub fn pci_free_host_bridge(bridge: *mut pci_host_bridge);
}
extern "C" {
    pub fn pci_find_host_bridge(bus: *mut pci_bus) -> *mut pci_host_bridge;
}
extern "C" {
    pub fn pci_set_host_bridge_release(
        bridge: *mut pci_host_bridge,
        release_fn: ::core::option::Option<unsafe extern "C" fn(arg1: *mut pci_host_bridge)>,
        release_data: *mut ffi::c_void,
    );
}
extern "C" {
    pub fn pcibios_root_bridge_prepare(bridge: *mut pci_host_bridge) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct pci_bus {
    pub node: list_head,
    pub parent: *mut pci_bus,
    pub children: list_head,
    pub devices: list_head,
    pub self_: *mut pci_dev,
    pub slots: list_head,
    pub resource: [*mut resource; 4usize],
    pub resources: list_head,
    pub busn_res: resource,
    pub ops: *mut pci_ops,
    pub sysdata: *mut ffi::c_void,
    pub procdir: *mut proc_dir_entry,
    pub number: ffi::c_uchar,
    pub primary: ffi::c_uchar,
    pub max_bus_speed: ffi::c_uchar,
    pub cur_bus_speed: ffi::c_uchar,
    pub domain_nr: ffi::c_int,
    pub name: [ffi::c_char; 48usize],
    pub bridge_ctl: ffi::c_ushort,
    pub bus_flags: pci_bus_flags_t,
    pub bridge: *mut device,
    pub dev: device,
    pub legacy_io: *mut bin_attribute,
    pub legacy_mem: *mut bin_attribute,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub __bindgen_padding_0: [u8; 7usize],
}
impl Default for pci_bus {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl pci_bus {
    #[inline]
    pub fn is_added(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_is_added(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn is_added_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_is_added_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn unsafe_warn(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_unsafe_warn(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn unsafe_warn_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_unsafe_warn_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn flit_mode(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_flit_mode(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn flit_mode_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_flit_mode_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        is_added: ffi::c_uint,
        unsafe_warn: ffi::c_uint,
        flit_mode: ffi::c_uint,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let is_added: u32 = unsafe { ::core::mem::transmute(is_added) };
            is_added as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let unsafe_warn: u32 = unsafe { ::core::mem::transmute(unsafe_warn) };
            unsafe_warn as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let flit_mode: u32 = unsafe { ::core::mem::transmute(flit_mode) };
            flit_mode as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pci_ops {
    pub add_bus: ::core::option::Option<unsafe extern "C" fn(bus: *mut pci_bus) -> ffi::c_int>,
    pub remove_bus: ::core::option::Option<unsafe extern "C" fn(bus: *mut pci_bus)>,
    pub map_bus: ::core::option::Option<
        unsafe extern "C" fn(
            bus: *mut pci_bus,
            devfn: ffi::c_uint,
            where_: ffi::c_int,
        ) -> *mut ffi::c_void,
    >,
    pub read: ::core::option::Option<
        unsafe extern "C" fn(
            bus: *mut pci_bus,
            devfn: ffi::c_uint,
            where_: ffi::c_int,
            size: ffi::c_int,
            val: *mut u32_,
        ) -> ffi::c_int,
    >,
    pub write: ::core::option::Option<
        unsafe extern "C" fn(
            bus: *mut pci_bus,
            devfn: ffi::c_uint,
            where_: ffi::c_int,
            size: ffi::c_int,
            val: u32_,
        ) -> ffi::c_int,
    >,
}
extern "C" {
    pub fn raw_pci_read(
        domain: ffi::c_uint,
        bus: ffi::c_uint,
        devfn: ffi::c_uint,
        reg: ffi::c_int,
        len: ffi::c_int,
        val: *mut u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn raw_pci_write(
        domain: ffi::c_uint,
        bus: ffi::c_uint,
        devfn: ffi::c_uint,
        reg: ffi::c_int,
        len: ffi::c_int,
        val: u32_,
    ) -> ffi::c_int;
}
pub type pci_bus_addr_t = u64_;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pci_bus_region {
    pub start: pci_bus_addr_t,
    pub end: pci_bus_addr_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct pci_dynids {
    pub lock: spinlock_t,
    pub list: list_head,
}
impl Default for pci_dynids {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type pci_ers_result_t = ffi::c_uint;
pub const pci_ers_result_PCI_ERS_RESULT_NONE: pci_ers_result = 1;
pub const pci_ers_result_PCI_ERS_RESULT_CAN_RECOVER: pci_ers_result = 2;
pub const pci_ers_result_PCI_ERS_RESULT_NEED_RESET: pci_ers_result = 3;
pub const pci_ers_result_PCI_ERS_RESULT_DISCONNECT: pci_ers_result = 4;
pub const pci_ers_result_PCI_ERS_RESULT_RECOVERED: pci_ers_result = 5;
pub const pci_ers_result_PCI_ERS_RESULT_NO_AER_DRIVER: pci_ers_result = 6;
pub type pci_ers_result = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pci_error_handlers {
    pub error_detected: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut pci_dev, error: pci_channel_state_t) -> pci_ers_result_t,
    >,
    pub mmio_enabled:
        ::core::option::Option<unsafe extern "C" fn(dev: *mut pci_dev) -> pci_ers_result_t>,
    pub slot_reset:
        ::core::option::Option<unsafe extern "C" fn(dev: *mut pci_dev) -> pci_ers_result_t>,
    pub reset_prepare: ::core::option::Option<unsafe extern "C" fn(dev: *mut pci_dev)>,
    pub reset_done: ::core::option::Option<unsafe extern "C" fn(dev: *mut pci_dev)>,
    pub resume: ::core::option::Option<unsafe extern "C" fn(dev: *mut pci_dev)>,
    pub cor_error_detected: ::core::option::Option<unsafe extern "C" fn(dev: *mut pci_dev)>,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct pci_driver {
    pub name: *const ffi::c_char,
    pub id_table: *const pci_device_id,
    pub probe: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut pci_dev, id: *const pci_device_id) -> ffi::c_int,
    >,
    pub remove: ::core::option::Option<unsafe extern "C" fn(dev: *mut pci_dev)>,
    pub suspend: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut pci_dev, state: pm_message_t) -> ffi::c_int,
    >,
    pub resume: ::core::option::Option<unsafe extern "C" fn(dev: *mut pci_dev) -> ffi::c_int>,
    pub shutdown: ::core::option::Option<unsafe extern "C" fn(dev: *mut pci_dev)>,
    pub sriov_configure: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut pci_dev, num_vfs: ffi::c_int) -> ffi::c_int,
    >,
    pub sriov_set_msix_vec_count: ::core::option::Option<
        unsafe extern "C" fn(vf: *mut pci_dev, msix_vec_count: ffi::c_int) -> ffi::c_int,
    >,
    pub sriov_get_vf_total_msix:
        ::core::option::Option<unsafe extern "C" fn(pf: *mut pci_dev) -> u32_>,
    pub err_handler: *const pci_error_handlers,
    pub groups: *mut *const attribute_group,
    pub dev_groups: *mut *const attribute_group,
    pub driver: device_driver,
    pub dynids: pci_dynids,
    pub driver_managed_dma: bool_,
}
impl Default for pci_driver {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const PCI_REASSIGN_ALL_RSRC: _bindgen_ty_271 = 1;
pub const PCI_REASSIGN_ALL_BUS: _bindgen_ty_271 = 2;
pub const PCI_PROBE_ONLY: _bindgen_ty_271 = 4;
pub const PCI_CAN_SKIP_ISA_ALIGN: _bindgen_ty_271 = 8;
pub const PCI_ENABLE_PROC_DOMAINS: _bindgen_ty_271 = 16;
pub const PCI_COMPAT_DOMAIN_0: _bindgen_ty_271 = 32;
pub const PCI_SCAN_ALL_PCIE_DEVS: _bindgen_ty_271 = 64;
pub type _bindgen_ty_271 = ffi::c_uint;
extern "C" {
    pub static mut pci_flags: ffi::c_uint;
}
extern "C" {
    pub fn pcie_bus_configure_settings(bus: *mut pci_bus);
}
pub const pcie_bus_config_types_PCIE_BUS_TUNE_OFF: pcie_bus_config_types = 0;
pub const pcie_bus_config_types_PCIE_BUS_DEFAULT: pcie_bus_config_types = 1;
pub const pcie_bus_config_types_PCIE_BUS_SAFE: pcie_bus_config_types = 2;
pub const pcie_bus_config_types_PCIE_BUS_PERFORMANCE: pcie_bus_config_types = 3;
pub const pcie_bus_config_types_PCIE_BUS_PEER2PEER: pcie_bus_config_types = 4;
pub type pcie_bus_config_types = ffi::c_uint;
extern "C" {
    pub static mut pcie_bus_config: pcie_bus_config_types;
}
extern "C" {
    pub static pci_bus_type: bus_type;
}
extern "C" {
    pub static mut pci_root_buses: list_head;
}
extern "C" {
    pub fn no_pci_devices() -> ffi::c_int;
}
extern "C" {
    pub fn pcibios_resource_survey_bus(bus: *mut pci_bus);
}
extern "C" {
    pub fn pcibios_bus_add_device(pdev: *mut pci_dev);
}
extern "C" {
    pub fn pcibios_add_bus(bus: *mut pci_bus);
}
extern "C" {
    pub fn pcibios_remove_bus(bus: *mut pci_bus);
}
extern "C" {
    pub fn pcibios_fixup_bus(arg1: *mut pci_bus);
}
extern "C" {
    #[must_use]
    pub fn pcibios_enable_device(arg1: *mut pci_dev, mask: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn pcibios_setup(str_: *mut ffi::c_char) -> *mut ffi::c_char;
}
extern "C" {
    pub fn pcibios_align_resource(
        arg1: *mut ffi::c_void,
        arg2: *const resource,
        arg3: resource_size_t,
        arg4: resource_size_t,
    ) -> resource_size_t;
}
extern "C" {
    pub fn pci_fixup_cardbus(arg1: *mut pci_bus);
}
extern "C" {
    pub fn pcibios_resource_to_bus(
        bus: *mut pci_bus,
        region: *mut pci_bus_region,
        res: *mut resource,
    );
}
extern "C" {
    pub fn pcibios_bus_to_resource(
        bus: *mut pci_bus,
        res: *mut resource,
        region: *mut pci_bus_region,
    );
}
extern "C" {
    pub fn pcibios_scan_specific_bus(busn: ffi::c_int);
}
extern "C" {
    pub fn pci_find_bus(domain: ffi::c_int, busnr: ffi::c_int) -> *mut pci_bus;
}
extern "C" {
    pub fn pci_bus_add_devices(bus: *const pci_bus);
}
extern "C" {
    pub fn pci_scan_bus(
        bus: ffi::c_int,
        ops: *mut pci_ops,
        sysdata: *mut ffi::c_void,
    ) -> *mut pci_bus;
}
extern "C" {
    pub fn pci_create_root_bus(
        parent: *mut device,
        bus: ffi::c_int,
        ops: *mut pci_ops,
        sysdata: *mut ffi::c_void,
        resources: *mut list_head,
    ) -> *mut pci_bus;
}
extern "C" {
    pub fn pci_host_probe(bridge: *mut pci_host_bridge) -> ffi::c_int;
}
extern "C" {
    pub fn pci_bus_insert_busn_res(
        b: *mut pci_bus,
        bus: ffi::c_int,
        busmax: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_bus_update_busn_res_end(b: *mut pci_bus, busmax: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn pci_bus_release_busn_res(b: *mut pci_bus);
}
extern "C" {
    pub fn pci_scan_root_bus(
        parent: *mut device,
        bus: ffi::c_int,
        ops: *mut pci_ops,
        sysdata: *mut ffi::c_void,
        resources: *mut list_head,
    ) -> *mut pci_bus;
}
extern "C" {
    pub fn pci_scan_root_bus_bridge(bridge: *mut pci_host_bridge) -> ffi::c_int;
}
extern "C" {
    pub fn pci_add_new_bus(
        parent: *mut pci_bus,
        dev: *mut pci_dev,
        busnr: ffi::c_int,
    ) -> *mut pci_bus;
}
extern "C" {
    pub fn pci_create_slot(
        parent: *mut pci_bus,
        slot_nr: ffi::c_int,
        name: *const ffi::c_char,
        hotplug: *mut hotplug_slot,
    ) -> *mut pci_slot;
}
extern "C" {
    pub fn pci_destroy_slot(slot: *mut pci_slot);
}
extern "C" {
    pub fn pci_dev_assign_slot(dev: *mut pci_dev);
}
extern "C" {
    pub fn pci_scan_slot(bus: *mut pci_bus, devfn: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn pci_scan_single_device(bus: *mut pci_bus, devfn: ffi::c_int) -> *mut pci_dev;
}
extern "C" {
    pub fn pci_device_add(dev: *mut pci_dev, bus: *mut pci_bus);
}
extern "C" {
    pub fn pci_scan_child_bus(bus: *mut pci_bus) -> ffi::c_uint;
}
extern "C" {
    pub fn pci_bus_add_device(dev: *mut pci_dev);
}
extern "C" {
    pub fn pci_read_bridge_bases(child: *mut pci_bus);
}
extern "C" {
    pub fn pci_find_parent_resource(dev: *const pci_dev, res: *mut resource) -> *mut resource;
}
extern "C" {
    pub fn pci_swizzle_interrupt_pin(dev: *const pci_dev, pin: u8_) -> u8_;
}
extern "C" {
    pub fn pci_get_interrupt_pin(dev: *mut pci_dev, bridge: *mut *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pci_common_swizzle(dev: *mut pci_dev, pinp: *mut u8_) -> u8_;
}
extern "C" {
    pub fn pci_dev_get(dev: *mut pci_dev) -> *mut pci_dev;
}
extern "C" {
    pub fn pci_dev_put(dev: *mut pci_dev);
}
extern "C" {
    pub fn pci_remove_bus(b: *mut pci_bus);
}
extern "C" {
    pub fn pci_stop_and_remove_bus_device(dev: *mut pci_dev);
}
extern "C" {
    pub fn pci_stop_and_remove_bus_device_locked(dev: *mut pci_dev);
}
extern "C" {
    pub fn pci_stop_root_bus(bus: *mut pci_bus);
}
extern "C" {
    pub fn pci_remove_root_bus(bus: *mut pci_bus);
}
extern "C" {
    pub fn pci_setup_cardbus(bus: *mut pci_bus);
}
extern "C" {
    pub fn pcibios_setup_bridge(bus: *mut pci_bus, type_: ffi::c_ulong);
}
extern "C" {
    pub fn pci_sort_breadthfirst();
}
extern "C" {
    pub fn pci_bus_find_capability(bus: *mut pci_bus, devfn: ffi::c_uint, cap: ffi::c_int) -> u8_;
}
extern "C" {
    pub fn pci_find_capability(dev: *mut pci_dev, cap: ffi::c_int) -> u8_;
}
extern "C" {
    pub fn pci_find_next_capability(dev: *mut pci_dev, pos: u8_, cap: ffi::c_int) -> u8_;
}
extern "C" {
    pub fn pci_find_ht_capability(dev: *mut pci_dev, ht_cap: ffi::c_int) -> u8_;
}
extern "C" {
    pub fn pci_find_next_ht_capability(dev: *mut pci_dev, pos: u8_, ht_cap: ffi::c_int) -> u8_;
}
extern "C" {
    pub fn pci_find_ext_capability(dev: *mut pci_dev, cap: ffi::c_int) -> u16_;
}
extern "C" {
    pub fn pci_find_next_ext_capability(dev: *mut pci_dev, pos: u16_, cap: ffi::c_int) -> u16_;
}
extern "C" {
    pub fn pci_find_next_bus(from: *const pci_bus) -> *mut pci_bus;
}
extern "C" {
    pub fn pci_find_vsec_capability(dev: *mut pci_dev, vendor: u16_, cap: ffi::c_int) -> u16_;
}
extern "C" {
    pub fn pci_find_dvsec_capability(dev: *mut pci_dev, vendor: u16_, dvsec: u16_) -> u16_;
}
extern "C" {
    pub fn pci_get_dsn(dev: *mut pci_dev) -> u64_;
}
extern "C" {
    pub fn pci_get_device(
        vendor: ffi::c_uint,
        device: ffi::c_uint,
        from: *mut pci_dev,
    ) -> *mut pci_dev;
}
extern "C" {
    pub fn pci_get_subsys(
        vendor: ffi::c_uint,
        device: ffi::c_uint,
        ss_vendor: ffi::c_uint,
        ss_device: ffi::c_uint,
        from: *mut pci_dev,
    ) -> *mut pci_dev;
}
extern "C" {
    pub fn pci_get_slot(bus: *mut pci_bus, devfn: ffi::c_uint) -> *mut pci_dev;
}
extern "C" {
    pub fn pci_get_domain_bus_and_slot(
        domain: ffi::c_int,
        bus: ffi::c_uint,
        devfn: ffi::c_uint,
    ) -> *mut pci_dev;
}
extern "C" {
    pub fn pci_get_class(class: ffi::c_uint, from: *mut pci_dev) -> *mut pci_dev;
}
extern "C" {
    pub fn pci_get_base_class(class: ffi::c_uint, from: *mut pci_dev) -> *mut pci_dev;
}
extern "C" {
    pub fn pci_dev_present(ids: *const pci_device_id) -> ffi::c_int;
}
extern "C" {
    pub fn pci_bus_read_config_byte(
        bus: *mut pci_bus,
        devfn: ffi::c_uint,
        where_: ffi::c_int,
        val: *mut u8_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_bus_read_config_word(
        bus: *mut pci_bus,
        devfn: ffi::c_uint,
        where_: ffi::c_int,
        val: *mut u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_bus_read_config_dword(
        bus: *mut pci_bus,
        devfn: ffi::c_uint,
        where_: ffi::c_int,
        val: *mut u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_bus_write_config_byte(
        bus: *mut pci_bus,
        devfn: ffi::c_uint,
        where_: ffi::c_int,
        val: u8_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_bus_write_config_word(
        bus: *mut pci_bus,
        devfn: ffi::c_uint,
        where_: ffi::c_int,
        val: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_bus_write_config_dword(
        bus: *mut pci_bus,
        devfn: ffi::c_uint,
        where_: ffi::c_int,
        val: u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_generic_config_read(
        bus: *mut pci_bus,
        devfn: ffi::c_uint,
        where_: ffi::c_int,
        size: ffi::c_int,
        val: *mut u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_generic_config_write(
        bus: *mut pci_bus,
        devfn: ffi::c_uint,
        where_: ffi::c_int,
        size: ffi::c_int,
        val: u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_generic_config_read32(
        bus: *mut pci_bus,
        devfn: ffi::c_uint,
        where_: ffi::c_int,
        size: ffi::c_int,
        val: *mut u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_generic_config_write32(
        bus: *mut pci_bus,
        devfn: ffi::c_uint,
        where_: ffi::c_int,
        size: ffi::c_int,
        val: u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_bus_set_ops(bus: *mut pci_bus, ops: *mut pci_ops) -> *mut pci_ops;
}
extern "C" {
    pub fn pci_read_config_byte(
        dev: *const pci_dev,
        where_: ffi::c_int,
        val: *mut u8_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_read_config_word(
        dev: *const pci_dev,
        where_: ffi::c_int,
        val: *mut u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_read_config_dword(
        dev: *const pci_dev,
        where_: ffi::c_int,
        val: *mut u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_write_config_byte(dev: *const pci_dev, where_: ffi::c_int, val: u8_) -> ffi::c_int;
}
extern "C" {
    pub fn pci_write_config_word(dev: *const pci_dev, where_: ffi::c_int, val: u16_) -> ffi::c_int;
}
extern "C" {
    pub fn pci_write_config_dword(dev: *const pci_dev, where_: ffi::c_int, val: u32_)
        -> ffi::c_int;
}
extern "C" {
    pub fn pci_clear_and_set_config_dword(
        dev: *const pci_dev,
        pos: ffi::c_int,
        clear: u32_,
        set: u32_,
    );
}
extern "C" {
    pub fn pcie_capability_read_word(
        dev: *mut pci_dev,
        pos: ffi::c_int,
        val: *mut u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pcie_capability_read_dword(
        dev: *mut pci_dev,
        pos: ffi::c_int,
        val: *mut u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pcie_capability_write_word(dev: *mut pci_dev, pos: ffi::c_int, val: u16_) -> ffi::c_int;
}
extern "C" {
    pub fn pcie_capability_write_dword(dev: *mut pci_dev, pos: ffi::c_int, val: u32_)
        -> ffi::c_int;
}
extern "C" {
    pub fn pcie_capability_clear_and_set_word_unlocked(
        dev: *mut pci_dev,
        pos: ffi::c_int,
        clear: u16_,
        set: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pcie_capability_clear_and_set_word_locked(
        dev: *mut pci_dev,
        pos: ffi::c_int,
        clear: u16_,
        set: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pcie_capability_clear_and_set_dword(
        dev: *mut pci_dev,
        pos: ffi::c_int,
        clear: u32_,
        set: u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_user_read_config_byte(
        dev: *mut pci_dev,
        where_: ffi::c_int,
        val: *mut u8_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_user_read_config_word(
        dev: *mut pci_dev,
        where_: ffi::c_int,
        val: *mut u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_user_read_config_dword(
        dev: *mut pci_dev,
        where_: ffi::c_int,
        val: *mut u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_user_write_config_byte(
        dev: *mut pci_dev,
        where_: ffi::c_int,
        val: u8_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_user_write_config_word(
        dev: *mut pci_dev,
        where_: ffi::c_int,
        val: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_user_write_config_dword(
        dev: *mut pci_dev,
        where_: ffi::c_int,
        val: u32_,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn pci_enable_device(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn pci_enable_device_mem(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn pci_reenable_device(arg1: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn pcim_enable_device(pdev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pcim_pin_device(pdev: *mut pci_dev);
}
extern "C" {
    pub fn pci_disable_device(dev: *mut pci_dev);
}
extern "C" {
    pub static mut pcibios_max_latency: ffi::c_uint;
}
extern "C" {
    pub fn pci_set_master(dev: *mut pci_dev);
}
extern "C" {
    pub fn pci_clear_master(dev: *mut pci_dev);
}
extern "C" {
    pub fn pci_set_pcie_reset_state(dev: *mut pci_dev, state: pcie_reset_state) -> ffi::c_int;
}
extern "C" {
    pub fn pci_set_cacheline_size(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn pci_set_mwi(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn pcim_set_mwi(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pci_try_set_mwi(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pci_clear_mwi(dev: *mut pci_dev);
}
extern "C" {
    pub fn pci_disable_parity(dev: *mut pci_dev);
}
extern "C" {
    pub fn pci_intx(dev: *mut pci_dev, enable: ffi::c_int);
}
extern "C" {
    pub fn pci_check_and_mask_intx(dev: *mut pci_dev) -> bool_;
}
extern "C" {
    pub fn pci_check_and_unmask_intx(dev: *mut pci_dev) -> bool_;
}
extern "C" {
    pub fn pci_wait_for_pending(dev: *mut pci_dev, pos: ffi::c_int, mask: u16_) -> ffi::c_int;
}
extern "C" {
    pub fn pci_wait_for_pending_transaction(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pcix_get_max_mmrbc(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pcix_get_mmrbc(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pcix_set_mmrbc(dev: *mut pci_dev, mmrbc: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn pcie_get_readrq(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pcie_set_readrq(dev: *mut pci_dev, rq: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn pcie_get_mps(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pcie_set_mps(dev: *mut pci_dev, mps: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn pcie_bandwidth_available(
        dev: *mut pci_dev,
        limiting_dev: *mut *mut pci_dev,
        speed: *mut pci_bus_speed,
        width: *mut pcie_link_width,
    ) -> u32_;
}
extern "C" {
    pub fn pcie_link_speed_mbps(pdev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pcie_print_link_status(dev: *mut pci_dev);
}
extern "C" {
    pub fn pcie_reset_flr(dev: *mut pci_dev, probe: bool_) -> ffi::c_int;
}
extern "C" {
    pub fn pcie_flr(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn __pci_reset_function_locked(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pci_reset_function(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pci_reset_function_locked(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pci_try_reset_function(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pci_probe_reset_slot(slot: *mut pci_slot) -> ffi::c_int;
}
extern "C" {
    pub fn pci_probe_reset_bus(bus: *mut pci_bus) -> ffi::c_int;
}
extern "C" {
    pub fn pci_reset_bus(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pci_reset_secondary_bus(dev: *mut pci_dev);
}
extern "C" {
    pub fn pcibios_reset_secondary_bus(dev: *mut pci_dev);
}
extern "C" {
    pub fn pci_update_resource(dev: *mut pci_dev, resno: ffi::c_int);
}
extern "C" {
    #[must_use]
    pub fn pci_assign_resource(dev: *mut pci_dev, i: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn pci_release_resource(dev: *mut pci_dev, resno: ffi::c_int);
}
extern "C" {
    pub fn pci_rebar_get_possible_sizes(pdev: *mut pci_dev, bar: ffi::c_int) -> u32_;
}
extern "C" {
    #[must_use]
    pub fn pci_resize_resource(dev: *mut pci_dev, i: ffi::c_int, size: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn pci_select_bars(dev: *mut pci_dev, flags: ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn pci_device_is_present(pdev: *mut pci_dev) -> bool_;
}
extern "C" {
    pub fn pci_ignore_hotplug(dev: *mut pci_dev);
}
extern "C" {
    pub fn pci_real_dma_dev(dev: *mut pci_dev) -> *mut pci_dev;
}
extern "C" {
    pub fn pci_status_get_and_clear_errors(pdev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pci_request_irq(
        dev: *mut pci_dev,
        nr: ffi::c_uint,
        handler: irq_handler_t,
        thread_fn: irq_handler_t,
        dev_id: *mut ffi::c_void,
        fmt: *const ffi::c_char,
        ...
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_free_irq(dev: *mut pci_dev, nr: ffi::c_uint, dev_id: *mut ffi::c_void);
}
extern "C" {
    pub fn pci_enable_rom(pdev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pci_disable_rom(pdev: *mut pci_dev);
}
extern "C" {
    #[must_use]
    pub fn pci_map_rom(pdev: *mut pci_dev, size: *mut usize) -> *mut ffi::c_void;
}
extern "C" {
    pub fn pci_unmap_rom(pdev: *mut pci_dev, rom: *mut ffi::c_void);
}
extern "C" {
    pub fn pci_save_state(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pci_restore_state(dev: *mut pci_dev);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct pci_saved_state {
    _unused: [u8; 0],
}
extern "C" {
    pub fn pci_store_saved_state(dev: *mut pci_dev) -> *mut pci_saved_state;
}
extern "C" {
    pub fn pci_load_saved_state(dev: *mut pci_dev, state: *mut pci_saved_state) -> ffi::c_int;
}
extern "C" {
    pub fn pci_load_and_free_saved_state(
        dev: *mut pci_dev,
        state: *mut *mut pci_saved_state,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_platform_power_transition(dev: *mut pci_dev, state: pci_power_t) -> ffi::c_int;
}
extern "C" {
    pub fn pci_set_power_state(dev: *mut pci_dev, state: pci_power_t) -> ffi::c_int;
}
extern "C" {
    pub fn pci_set_power_state_locked(dev: *mut pci_dev, state: pci_power_t) -> ffi::c_int;
}
extern "C" {
    pub fn pci_choose_state(dev: *mut pci_dev, state: pm_message_t) -> pci_power_t;
}
extern "C" {
    pub fn pci_pme_capable(dev: *mut pci_dev, state: pci_power_t) -> bool_;
}
extern "C" {
    pub fn pci_pme_active(dev: *mut pci_dev, enable: bool_);
}
extern "C" {
    pub fn pci_enable_wake(dev: *mut pci_dev, state: pci_power_t, enable: bool_) -> ffi::c_int;
}
extern "C" {
    pub fn pci_wake_from_d3(dev: *mut pci_dev, enable: bool_) -> ffi::c_int;
}
extern "C" {
    pub fn pci_prepare_to_sleep(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pci_back_from_sleep(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pci_dev_run_wake(dev: *mut pci_dev) -> bool_;
}
extern "C" {
    pub fn pci_d3cold_enable(dev: *mut pci_dev);
}
extern "C" {
    pub fn pci_d3cold_disable(dev: *mut pci_dev);
}
extern "C" {
    pub fn pcie_relaxed_ordering_enabled(dev: *mut pci_dev) -> bool_;
}
extern "C" {
    pub fn pci_resume_bus(bus: *mut pci_bus);
}
extern "C" {
    pub fn pci_bus_set_current_state(bus: *mut pci_bus, state: pci_power_t);
}
extern "C" {
    pub fn set_pcie_port_type(pdev: *mut pci_dev);
}
extern "C" {
    pub fn set_pcie_hotplug_bridge(pdev: *mut pci_dev);
}
extern "C" {
    pub fn pci_rescan_bus(bus: *mut pci_bus) -> ffi::c_uint;
}
extern "C" {
    pub fn pci_lock_rescan_remove();
}
extern "C" {
    pub fn pci_unlock_rescan_remove();
}
extern "C" {
    pub fn pci_read_vpd(
        dev: *mut pci_dev,
        pos: loff_t,
        count: usize,
        buf: *mut ffi::c_void,
    ) -> isize;
}
extern "C" {
    pub fn pci_write_vpd(
        dev: *mut pci_dev,
        pos: loff_t,
        count: usize,
        buf: *const ffi::c_void,
    ) -> isize;
}
extern "C" {
    pub fn pci_read_vpd_any(
        dev: *mut pci_dev,
        pos: loff_t,
        count: usize,
        buf: *mut ffi::c_void,
    ) -> isize;
}
extern "C" {
    pub fn pci_write_vpd_any(
        dev: *mut pci_dev,
        pos: loff_t,
        count: usize,
        buf: *const ffi::c_void,
    ) -> isize;
}
extern "C" {
    pub fn pcibios_retrieve_fw_addr(dev: *mut pci_dev, idx: ffi::c_int) -> resource_size_t;
}
extern "C" {
    pub fn pci_bus_assign_resources(bus: *const pci_bus);
}
extern "C" {
    pub fn pci_bus_claim_resources(bus: *mut pci_bus);
}
extern "C" {
    pub fn pci_bus_size_bridges(bus: *mut pci_bus);
}
extern "C" {
    pub fn pci_claim_resource(arg1: *mut pci_dev, arg2: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn pci_claim_bridge_resource(bridge: *mut pci_dev, i: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn pci_assign_unassigned_resources();
}
extern "C" {
    pub fn pci_assign_unassigned_bridge_resources(bridge: *mut pci_dev);
}
extern "C" {
    pub fn pci_assign_unassigned_bus_resources(bus: *mut pci_bus);
}
extern "C" {
    pub fn pci_assign_unassigned_root_bus_resources(bus: *mut pci_bus);
}
extern "C" {
    pub fn pci_enable_resources(arg1: *mut pci_dev, mask: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn pci_assign_irq(dev: *mut pci_dev);
}
extern "C" {
    pub fn pci_find_resource(dev: *mut pci_dev, res: *mut resource) -> *mut resource;
}
extern "C" {
    #[must_use]
    pub fn pci_request_regions(arg1: *mut pci_dev, arg2: *const ffi::c_char) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn pci_request_regions_exclusive(
        arg1: *mut pci_dev,
        arg2: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_release_regions(arg1: *mut pci_dev);
}
extern "C" {
    #[must_use]
    pub fn pci_request_region(
        arg1: *mut pci_dev,
        arg2: ffi::c_int,
        arg3: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_release_region(arg1: *mut pci_dev, arg2: ffi::c_int);
}
extern "C" {
    pub fn pci_request_selected_regions(
        arg1: *mut pci_dev,
        arg2: ffi::c_int,
        arg3: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_request_selected_regions_exclusive(
        arg1: *mut pci_dev,
        arg2: ffi::c_int,
        arg3: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_release_selected_regions(arg1: *mut pci_dev, arg2: ffi::c_int);
}
extern "C" {
    pub fn pci_add_resource(resources: *mut list_head, res: *mut resource);
}
extern "C" {
    pub fn pci_add_resource_offset(
        resources: *mut list_head,
        res: *mut resource,
        offset: resource_size_t,
    );
}
extern "C" {
    pub fn pci_free_resource_list(resources: *mut list_head);
}
extern "C" {
    pub fn pci_bus_add_resource(bus: *mut pci_bus, res: *mut resource);
}
extern "C" {
    pub fn pci_bus_resource_n(bus: *const pci_bus, n: ffi::c_int) -> *mut resource;
}
extern "C" {
    pub fn pci_bus_remove_resources(bus: *mut pci_bus);
}
extern "C" {
    pub fn pci_bus_remove_resource(bus: *mut pci_bus, res: *mut resource);
}
extern "C" {
    pub fn devm_request_pci_bus_resources(
        dev: *mut device,
        resources: *mut list_head,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_bridge_secondary_bus_reset(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn pci_bus_alloc_resource(
        bus: *mut pci_bus,
        res: *mut resource,
        size: resource_size_t,
        align: resource_size_t,
        min: resource_size_t,
        type_mask: ffi::c_ulong,
        alignf: resource_alignf,
        alignf_data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_register_io_range(
        fwnode: *const fwnode_handle,
        addr: phys_addr_t,
        size: resource_size_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_address_to_pio(addr: phys_addr_t) -> ffi::c_ulong;
}
extern "C" {
    pub fn pci_pio_to_address(pio: ffi::c_ulong) -> phys_addr_t;
}
extern "C" {
    pub fn pci_remap_iospace(res: *const resource, phys_addr: phys_addr_t) -> ffi::c_int;
}
extern "C" {
    pub fn devm_pci_remap_iospace(
        dev: *mut device,
        res: *const resource,
        phys_addr: phys_addr_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_unmap_iospace(res: *mut resource);
}
extern "C" {
    pub fn devm_pci_remap_cfgspace(
        dev: *mut device,
        offset: resource_size_t,
        size: resource_size_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn devm_pci_remap_cfg_resource(dev: *mut device, res: *mut resource) -> *mut ffi::c_void;
}
extern "C" {
    #[must_use]
    pub fn __pci_register_driver(
        arg1: *mut pci_driver,
        arg2: *mut module,
        mod_name: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_unregister_driver(dev: *mut pci_driver);
}
extern "C" {
    pub fn pci_dev_driver(dev: *const pci_dev) -> *mut pci_driver;
}
extern "C" {
    pub fn pci_add_dynid(
        drv: *mut pci_driver,
        vendor: ffi::c_uint,
        device: ffi::c_uint,
        subvendor: ffi::c_uint,
        subdevice: ffi::c_uint,
        class: ffi::c_uint,
        class_mask: ffi::c_uint,
        driver_data: ffi::c_ulong,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_match_id(ids: *const pci_device_id, dev: *mut pci_dev) -> *const pci_device_id;
}
extern "C" {
    pub fn pci_scan_bridge(
        bus: *mut pci_bus,
        dev: *mut pci_dev,
        max: ffi::c_int,
        pass: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_walk_bus(
        top: *mut pci_bus,
        cb: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut pci_dev, arg2: *mut ffi::c_void) -> ffi::c_int,
        >,
        userdata: *mut ffi::c_void,
    );
}
extern "C" {
    pub fn pci_cfg_space_size(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pci_bus_max_busnr(bus: *mut pci_bus) -> ffi::c_uchar;
}
extern "C" {
    pub fn pcibios_window_alignment(bus: *mut pci_bus, type_: ffi::c_ulong) -> resource_size_t;
}
extern "C" {
    pub fn pci_set_vga_state(
        pdev: *mut pci_dev,
        decode: bool_,
        command_bits: ffi::c_uint,
        flags: u32_,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct dma_pool {
    _unused: [u8; 0],
}
extern "C" {
    pub fn dma_pool_create(
        name: *const ffi::c_char,
        dev: *mut device,
        size: usize,
        align: usize,
        allocation: usize,
    ) -> *mut dma_pool;
}
extern "C" {
    pub fn dma_pool_destroy(pool: *mut dma_pool);
}
extern "C" {
    pub fn dma_pool_alloc(
        pool: *mut dma_pool,
        mem_flags: gfp_t,
        handle: *mut dma_addr_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn dma_pool_free(pool: *mut dma_pool, vaddr: *mut ffi::c_void, addr: dma_addr_t);
}
extern "C" {
    pub fn dmam_pool_create(
        name: *const ffi::c_char,
        dev: *mut device,
        size: usize,
        align: usize,
        allocation: usize,
    ) -> *mut dma_pool;
}
extern "C" {
    pub fn dmam_pool_destroy(pool: *mut dma_pool);
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct msix_entry {
    pub vector: u32_,
    pub entry: u16_,
}
extern "C" {
    pub fn pci_msi_vec_count(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pci_disable_msi(dev: *mut pci_dev);
}
extern "C" {
    pub fn pci_msix_vec_count(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pci_disable_msix(dev: *mut pci_dev);
}
extern "C" {
    pub fn pci_restore_msi_state(dev: *mut pci_dev);
}
extern "C" {
    pub fn pci_msi_enabled() -> ffi::c_int;
}
extern "C" {
    pub fn pci_enable_msi(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pci_enable_msix_range(
        dev: *mut pci_dev,
        entries: *mut msix_entry,
        minvec: ffi::c_int,
        maxvec: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_alloc_irq_vectors(
        dev: *mut pci_dev,
        min_vecs: ffi::c_uint,
        max_vecs: ffi::c_uint,
        flags: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_alloc_irq_vectors_affinity(
        dev: *mut pci_dev,
        min_vecs: ffi::c_uint,
        max_vecs: ffi::c_uint,
        flags: ffi::c_uint,
        affd: *mut irq_affinity,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_msix_can_alloc_dyn(dev: *mut pci_dev) -> bool_;
}
extern "C" {
    pub fn pci_msix_alloc_irq_at(
        dev: *mut pci_dev,
        index: ffi::c_uint,
        affdesc: *const irq_affinity_desc,
    ) -> msi_map;
}
extern "C" {
    pub fn pci_msix_free_irq(pdev: *mut pci_dev, map: msi_map);
}
extern "C" {
    pub fn pci_free_irq_vectors(dev: *mut pci_dev);
}
extern "C" {
    pub fn pci_irq_vector(dev: *mut pci_dev, nr: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn pci_irq_get_affinity(pdev: *mut pci_dev, vec: ffi::c_int) -> *const cpumask;
}
extern "C" {
    pub static mut pcie_ports_disabled: bool_;
}
extern "C" {
    pub static mut pcie_ports_native: bool_;
}
extern "C" {
    pub fn pcie_set_target_speed(
        port: *mut pci_dev,
        speed_req: pci_bus_speed,
        use_lt: bool_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_disable_link_state(pdev: *mut pci_dev, state: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn pci_disable_link_state_locked(pdev: *mut pci_dev, state: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn pci_enable_link_state(pdev: *mut pci_dev, state: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn pci_enable_link_state_locked(pdev: *mut pci_dev, state: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn pcie_no_aspm();
}
extern "C" {
    pub fn pcie_aspm_support_enabled() -> bool_;
}
extern "C" {
    pub fn pcie_aspm_enabled(pdev: *mut pci_dev) -> bool_;
}
extern "C" {
    pub fn pci_aer_available() -> bool_;
}
extern "C" {
    pub fn pci_ats_disabled() -> bool_;
}
extern "C" {
    pub fn pci_enable_ptm(dev: *mut pci_dev, granularity: *mut u8_) -> ffi::c_int;
}
extern "C" {
    pub fn pci_disable_ptm(dev: *mut pci_dev);
}
extern "C" {
    pub fn pcie_ptm_enabled(dev: *mut pci_dev) -> bool_;
}
extern "C" {
    pub fn pci_cfg_access_lock(dev: *mut pci_dev);
}
extern "C" {
    pub fn pci_cfg_access_trylock(dev: *mut pci_dev) -> bool_;
}
extern "C" {
    pub fn pci_cfg_access_unlock(dev: *mut pci_dev);
}
extern "C" {
    pub fn pci_dev_lock(dev: *mut pci_dev);
}
extern "C" {
    pub fn pci_dev_trylock(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pci_dev_unlock(dev: *mut pci_dev);
}
pub type class_pci_dev_t = *mut pci_dev;
pub const class_pci_dev_is_conditional: bool_ = false;
extern "C" {
    pub static mut pci_domains_supported: ffi::c_int;
}
extern "C" {
    pub fn acpi_pci_bus_find_domain_nr(bus: *mut pci_bus) -> ffi::c_int;
}
extern "C" {
    pub fn pci_bus_find_domain_nr(bus: *mut pci_bus, parent: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn pci_bus_release_domain_nr(parent: *mut device, domain_nr: ffi::c_int);
}
pub type arch_set_vga_state_t = ::core::option::Option<
    unsafe extern "C" fn(
        pdev: *mut pci_dev,
        decode: bool_,
        command_bits: ffi::c_uint,
        flags: u32_,
    ) -> ffi::c_int,
>;
extern "C" {
    pub fn pci_register_set_vga_state(func: arch_set_vga_state_t);
}
extern "C" {
    pub fn pci_mmap_resource_range(
        dev: *mut pci_dev,
        bar: ffi::c_int,
        vma: *mut vm_area_struct,
        mmap_state: pci_mmap_state,
        write_combine: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_resource_to_user(
        dev: *const pci_dev,
        bar: ffi::c_int,
        rsrc: *const resource,
        start: *mut resource_size_t,
        end: *mut resource_size_t,
    );
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pci_fixup {
    pub vendor: u16_,
    pub device: u16_,
    pub class: u32_,
    pub class_shift: ffi::c_uint,
    pub hook_offset: ffi::c_int,
}
pub const pci_fixup_pass_pci_fixup_early: pci_fixup_pass = 0;
pub const pci_fixup_pass_pci_fixup_header: pci_fixup_pass = 1;
pub const pci_fixup_pass_pci_fixup_final: pci_fixup_pass = 2;
pub const pci_fixup_pass_pci_fixup_enable: pci_fixup_pass = 3;
pub const pci_fixup_pass_pci_fixup_resume: pci_fixup_pass = 4;
pub const pci_fixup_pass_pci_fixup_suspend: pci_fixup_pass = 5;
pub const pci_fixup_pass_pci_fixup_resume_early: pci_fixup_pass = 6;
pub const pci_fixup_pass_pci_fixup_suspend_late: pci_fixup_pass = 7;
pub type pci_fixup_pass = ffi::c_uint;
extern "C" {
    pub fn pci_fixup_device(pass: pci_fixup_pass, dev: *mut pci_dev);
}
extern "C" {
    pub fn pcim_intx(pdev: *mut pci_dev, enabled: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn pcim_request_all_regions(pdev: *mut pci_dev, name: *const ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub fn pcim_iomap(
        pdev: *mut pci_dev,
        bar: ffi::c_int,
        maxlen: ffi::c_ulong,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn pcim_iomap_region(
        pdev: *mut pci_dev,
        bar: ffi::c_int,
        name: *const ffi::c_char,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn pcim_iounmap_region(pdev: *mut pci_dev, bar: ffi::c_int);
}
extern "C" {
    pub fn pcim_iounmap(pdev: *mut pci_dev, addr: *mut ffi::c_void);
}
extern "C" {
    pub fn pcim_iomap_table(pdev: *mut pci_dev) -> *const *mut ffi::c_void;
}
extern "C" {
    pub fn pcim_request_region(
        pdev: *mut pci_dev,
        bar: ffi::c_int,
        name: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pcim_iomap_regions(
        pdev: *mut pci_dev,
        mask: ffi::c_int,
        name: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pcim_iounmap_regions(pdev: *mut pci_dev, mask: ffi::c_int);
}
extern "C" {
    pub fn pcim_iomap_range(
        pdev: *mut pci_dev,
        bar: ffi::c_int,
        offset: ffi::c_ulong,
        len: ffi::c_ulong,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub static mut pci_pci_problems: ffi::c_int;
}
extern "C" {
    pub static mut pci_dfl_cache_line_size: u8_;
}
extern "C" {
    pub static mut pci_cache_line_size: u8_;
}
extern "C" {
    pub fn pcibios_disable_device(dev: *mut pci_dev);
}
extern "C" {
    pub fn pcibios_set_master(dev: *mut pci_dev);
}
extern "C" {
    pub fn pcibios_set_pcie_reset_state(dev: *mut pci_dev, state: pcie_reset_state) -> ffi::c_int;
}
extern "C" {
    pub fn pcibios_device_add(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pcibios_release_device(dev: *mut pci_dev);
}
extern "C" {
    pub fn pcibios_penalize_isa_irq(irq: ffi::c_int, active: ffi::c_int);
}
extern "C" {
    pub fn pcibios_alloc_irq(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pcibios_free_irq(dev: *mut pci_dev);
}
extern "C" {
    pub fn pcibios_default_alignment() -> resource_size_t;
}
extern "C" {
    pub fn pci_mmcfg_early_init();
}
extern "C" {
    pub fn pci_mmcfg_late_init();
}
extern "C" {
    pub fn pci_ext_cfg_avail() -> ffi::c_int;
}
extern "C" {
    pub fn pci_ioremap_bar(pdev: *mut pci_dev, bar: ffi::c_int) -> *mut ffi::c_void;
}
extern "C" {
    pub fn pci_ioremap_wc_bar(pdev: *mut pci_dev, bar: ffi::c_int) -> *mut ffi::c_void;
}
extern "C" {
    pub fn pci_iov_virtfn_bus(dev: *mut pci_dev, id: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn pci_iov_virtfn_devfn(dev: *mut pci_dev, id: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn pci_iov_vf_id(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pci_iov_get_pf_drvdata(
        dev: *mut pci_dev,
        pf_driver: *mut pci_driver,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn pci_enable_sriov(dev: *mut pci_dev, nr_virtfn: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn pci_disable_sriov(dev: *mut pci_dev);
}
extern "C" {
    pub fn pci_iov_sysfs_link(
        dev: *mut pci_dev,
        virtfn: *mut pci_dev,
        id: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_iov_add_virtfn(dev: *mut pci_dev, id: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn pci_iov_remove_virtfn(dev: *mut pci_dev, id: ffi::c_int);
}
extern "C" {
    pub fn pci_num_vf(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pci_vfs_assigned(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pci_sriov_set_totalvfs(dev: *mut pci_dev, numvfs: u16_) -> ffi::c_int;
}
extern "C" {
    pub fn pci_sriov_get_totalvfs(dev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pci_sriov_configure_simple(dev: *mut pci_dev, nr_virtfn: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn pci_iov_resource_size(dev: *mut pci_dev, resno: ffi::c_int) -> resource_size_t;
}
extern "C" {
    pub fn pci_vf_drivers_autoprobe(dev: *mut pci_dev, probe: bool_);
}
extern "C" {
    pub fn pcibios_sriov_enable(pdev: *mut pci_dev, num_vfs: u16_) -> ffi::c_int;
}
extern "C" {
    pub fn pcibios_sriov_disable(pdev: *mut pci_dev) -> ffi::c_int;
}
extern "C" {
    pub fn pcibios_iov_resource_alignment(dev: *mut pci_dev, resno: ffi::c_int) -> resource_size_t;
}
extern "C" {
    pub fn pci_request_acs();
}
extern "C" {
    pub fn pci_acs_enabled(pdev: *mut pci_dev, acs_flags: u16_) -> bool_;
}
extern "C" {
    pub fn pci_acs_path_enabled(start: *mut pci_dev, end: *mut pci_dev, acs_flags: u16_) -> bool_;
}
extern "C" {
    pub fn pci_enable_atomic_ops_to_root(dev: *mut pci_dev, cap_mask: u32_) -> ffi::c_int;
}
extern "C" {
    pub fn pci_vpd_alloc(dev: *mut pci_dev, size: *mut ffi::c_uint) -> *mut ffi::c_void;
}
extern "C" {
    pub fn pci_vpd_find_id_string(
        buf: *const u8_,
        len: ffi::c_uint,
        size: *mut ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_vpd_find_ro_info_keyword(
        buf: *const ffi::c_void,
        len: ffi::c_uint,
        kw: *const ffi::c_char,
        size: *mut ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_vpd_check_csum(buf: *const ffi::c_void, len: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn pci_host_bridge_of_msi_domain(bus: *mut pci_bus) -> *mut irq_domain;
}
extern "C" {
    pub fn pci_host_of_has_msi_map(dev: *mut device) -> bool_;
}
extern "C" {
    pub fn pcibios_get_phb_of_node(bus: *mut pci_bus) -> *mut device_node;
}
extern "C" {
    pub fn pci_host_bridge_acpi_msi_domain(bus: *mut pci_bus) -> *mut irq_domain;
}
extern "C" {
    pub fn pci_msi_register_fwnode_provider(
        fn_: ::core::option::Option<unsafe extern "C" fn(arg1: *mut device) -> *mut fwnode_handle>,
    );
}
extern "C" {
    pub fn pci_pr3_present(pdev: *mut pci_dev) -> bool_;
}
extern "C" {
    pub fn pci_add_dma_alias(dev: *mut pci_dev, devfn_from: u8_, nr_devfns: ffi::c_uint);
}
extern "C" {
    pub fn pci_devs_are_dma_aliases(dev1: *mut pci_dev, dev2: *mut pci_dev) -> bool_;
}
extern "C" {
    pub fn pci_for_each_dma_alias(
        pdev: *mut pci_dev,
        fn_: ::core::option::Option<
            unsafe extern "C" fn(
                pdev: *mut pci_dev,
                alias: u16_,
                data: *mut ffi::c_void,
            ) -> ffi::c_int,
        >,
        data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn pci_uevent_ers(pdev: *mut pci_dev, err_type: pci_ers_result);
}
pub const led_brightness_LED_OFF: led_brightness = 0;
pub const led_brightness_LED_ON: led_brightness = 1;
pub const led_brightness_LED_HALF: led_brightness = 127;
pub const led_brightness_LED_FULL: led_brightness = 255;
pub type led_brightness = ffi::c_uint;
pub const led_default_state_LEDS_DEFSTATE_OFF: led_default_state = 0;
pub const led_default_state_LEDS_DEFSTATE_ON: led_default_state = 1;
pub const led_default_state_LEDS_DEFSTATE_KEEP: led_default_state = 2;
pub type led_default_state = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct led_lookup_data {
    pub list: list_head,
    pub provider: *const ffi::c_char,
    pub dev_id: *const ffi::c_char,
    pub con_id: *const ffi::c_char,
}
impl Default for led_lookup_data {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct led_init_data {
    pub fwnode: *mut fwnode_handle,
    pub default_label: *const ffi::c_char,
    pub devicename: *const ffi::c_char,
    pub devname_mandatory: bool_,
}
impl Default for led_init_data {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn led_init_default_state_get(fwnode: *mut fwnode_handle) -> led_default_state;
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct led_hw_trigger_type {
    pub dummy: ffi::c_int,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct led_classdev {
    pub name: *const ffi::c_char,
    pub brightness: ffi::c_uint,
    pub max_brightness: ffi::c_uint,
    pub color: ffi::c_uint,
    pub flags: ffi::c_int,
    pub work_flags: ffi::c_ulong,
    pub brightness_set: ::core::option::Option<
        unsafe extern "C" fn(led_cdev: *mut led_classdev, brightness: led_brightness),
    >,
    pub brightness_set_blocking: ::core::option::Option<
        unsafe extern "C" fn(led_cdev: *mut led_classdev, brightness: led_brightness) -> ffi::c_int,
    >,
    pub brightness_get:
        ::core::option::Option<unsafe extern "C" fn(led_cdev: *mut led_classdev) -> led_brightness>,
    pub blink_set: ::core::option::Option<
        unsafe extern "C" fn(
            led_cdev: *mut led_classdev,
            delay_on: *mut ffi::c_ulong,
            delay_off: *mut ffi::c_ulong,
        ) -> ffi::c_int,
    >,
    pub pattern_set: ::core::option::Option<
        unsafe extern "C" fn(
            led_cdev: *mut led_classdev,
            pattern: *mut led_pattern,
            len: u32_,
            repeat: ffi::c_int,
        ) -> ffi::c_int,
    >,
    pub pattern_clear:
        ::core::option::Option<unsafe extern "C" fn(led_cdev: *mut led_classdev) -> ffi::c_int>,
    pub dev: *mut device,
    pub groups: *mut *const attribute_group,
    pub node: list_head,
    pub default_trigger: *const ffi::c_char,
    pub blink_delay_on: ffi::c_ulong,
    pub blink_delay_off: ffi::c_ulong,
    pub blink_timer: timer_list,
    pub blink_brightness: ffi::c_int,
    pub new_blink_brightness: ffi::c_int,
    pub flash_resume: ::core::option::Option<unsafe extern "C" fn(led_cdev: *mut led_classdev)>,
    pub wq: *mut workqueue_struct,
    pub set_brightness_work: work_struct,
    pub delayed_set_value: ffi::c_int,
    pub delayed_delay_on: ffi::c_ulong,
    pub delayed_delay_off: ffi::c_ulong,
    pub trigger_lock: rw_semaphore,
    pub trigger: *mut led_trigger,
    pub trig_list: list_head,
    pub trigger_data: *mut ffi::c_void,
    pub activated: bool_,
    pub trigger_type: *mut led_hw_trigger_type,
    pub hw_control_trigger: *const ffi::c_char,
    pub hw_control_is_supported: ::core::option::Option<
        unsafe extern "C" fn(led_cdev: *mut led_classdev, flags: ffi::c_ulong) -> ffi::c_int,
    >,
    pub hw_control_set: ::core::option::Option<
        unsafe extern "C" fn(led_cdev: *mut led_classdev, flags: ffi::c_ulong) -> ffi::c_int,
    >,
    pub hw_control_get: ::core::option::Option<
        unsafe extern "C" fn(led_cdev: *mut led_classdev, flags: *mut ffi::c_ulong) -> ffi::c_int,
    >,
    pub hw_control_get_device:
        ::core::option::Option<unsafe extern "C" fn(led_cdev: *mut led_classdev) -> *mut device>,
    pub brightness_hw_changed: ffi::c_int,
    pub brightness_hw_changed_kn: *mut kernfs_node,
    pub led_access: mutex,
}
impl Default for led_classdev {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn led_classdev_register_ext(
        parent: *mut device,
        led_cdev: *mut led_classdev,
        init_data: *mut led_init_data,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn devm_led_classdev_register_ext(
        parent: *mut device,
        led_cdev: *mut led_classdev,
        init_data: *mut led_init_data,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn led_classdev_unregister(led_cdev: *mut led_classdev);
}
extern "C" {
    pub fn devm_led_classdev_unregister(parent: *mut device, led_cdev: *mut led_classdev);
}
extern "C" {
    pub fn led_classdev_suspend(led_cdev: *mut led_classdev);
}
extern "C" {
    pub fn led_classdev_resume(led_cdev: *mut led_classdev);
}
extern "C" {
    pub fn led_add_lookup(led_lookup: *mut led_lookup_data);
}
extern "C" {
    pub fn led_remove_lookup(led_lookup: *mut led_lookup_data);
}
extern "C" {
    #[must_use]
    pub fn led_get(dev: *mut device, con_id: *mut ffi::c_char) -> *mut led_classdev;
}
extern "C" {
    #[must_use]
    pub fn devm_led_get(dev: *mut device, con_id: *mut ffi::c_char) -> *mut led_classdev;
}
extern "C" {
    pub fn of_led_get(np: *mut device_node, index: ffi::c_int) -> *mut led_classdev;
}
extern "C" {
    pub fn led_put(led_cdev: *mut led_classdev);
}
extern "C" {
    #[must_use]
    pub fn devm_of_led_get(dev: *mut device, index: ffi::c_int) -> *mut led_classdev;
}
extern "C" {
    #[must_use]
    pub fn devm_of_led_get_optional(dev: *mut device, index: ffi::c_int) -> *mut led_classdev;
}
extern "C" {
    pub fn led_blink_set(
        led_cdev: *mut led_classdev,
        delay_on: *mut ffi::c_ulong,
        delay_off: *mut ffi::c_ulong,
    );
}
extern "C" {
    pub fn led_blink_set_nosleep(
        led_cdev: *mut led_classdev,
        delay_on: ffi::c_ulong,
        delay_off: ffi::c_ulong,
    );
}
extern "C" {
    pub fn led_blink_set_oneshot(
        led_cdev: *mut led_classdev,
        delay_on: *mut ffi::c_ulong,
        delay_off: *mut ffi::c_ulong,
        invert: ffi::c_int,
    );
}
extern "C" {
    pub fn led_set_brightness(led_cdev: *mut led_classdev, brightness: ffi::c_uint);
}
extern "C" {
    pub fn led_set_brightness_sync(led_cdev: *mut led_classdev, value: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn led_mc_set_brightness(
        led_cdev: *mut led_classdev,
        intensity_value: *mut ffi::c_uint,
        num_colors: ffi::c_uint,
        brightness: ffi::c_uint,
    );
}
extern "C" {
    pub fn led_update_brightness(led_cdev: *mut led_classdev) -> ffi::c_int;
}
extern "C" {
    pub fn led_get_default_pattern(
        led_cdev: *mut led_classdev,
        size: *mut ffi::c_uint,
    ) -> *mut u32_;
}
extern "C" {
    pub fn led_sysfs_disable(led_cdev: *mut led_classdev);
}
extern "C" {
    pub fn led_sysfs_enable(led_cdev: *mut led_classdev);
}
extern "C" {
    pub fn led_compose_name(
        dev: *mut device,
        init_data: *mut led_init_data,
        led_classdev_name: *mut ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn led_get_color_name(color_id: u8_) -> *const ffi::c_char;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct led_trigger {
    pub name: *const ffi::c_char,
    pub activate:
        ::core::option::Option<unsafe extern "C" fn(led_cdev: *mut led_classdev) -> ffi::c_int>,
    pub deactivate: ::core::option::Option<unsafe extern "C" fn(led_cdev: *mut led_classdev)>,
    pub brightness: led_brightness,
    pub trigger_type: *mut led_hw_trigger_type,
    pub leddev_list_lock: spinlock_t,
    pub led_cdevs: list_head,
    pub next_trig: list_head,
    pub groups: *mut *const attribute_group,
}
impl Default for led_trigger {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn led_trigger_register(trigger: *mut led_trigger) -> ffi::c_int;
}
extern "C" {
    pub fn led_trigger_unregister(trigger: *mut led_trigger);
}
extern "C" {
    pub fn devm_led_trigger_register(dev: *mut device, trigger: *mut led_trigger) -> ffi::c_int;
}
extern "C" {
    pub fn led_trigger_register_simple(name: *const ffi::c_char, trigger: *mut *mut led_trigger);
}
extern "C" {
    pub fn led_trigger_unregister_simple(trigger: *mut led_trigger);
}
extern "C" {
    pub fn led_trigger_event(trigger: *mut led_trigger, event: led_brightness);
}
extern "C" {
    pub fn led_mc_trigger_event(
        trig: *mut led_trigger,
        intensity_value: *mut ffi::c_uint,
        num_colors: ffi::c_uint,
        brightness: led_brightness,
    );
}
extern "C" {
    pub fn led_trigger_blink(
        trigger: *mut led_trigger,
        delay_on: ffi::c_ulong,
        delay_off: ffi::c_ulong,
    );
}
extern "C" {
    pub fn led_trigger_blink_oneshot(
        trigger: *mut led_trigger,
        delay_on: ffi::c_ulong,
        delay_off: ffi::c_ulong,
        invert: ffi::c_int,
    );
}
extern "C" {
    pub fn led_trigger_set_default(led_cdev: *mut led_classdev);
}
extern "C" {
    pub fn led_trigger_set(led_cdev: *mut led_classdev, trigger: *mut led_trigger) -> ffi::c_int;
}
extern "C" {
    pub fn led_trigger_remove(led_cdev: *mut led_classdev);
}
pub const led_trigger_netdev_modes_TRIGGER_NETDEV_LINK: led_trigger_netdev_modes = 0;
pub const led_trigger_netdev_modes_TRIGGER_NETDEV_LINK_10: led_trigger_netdev_modes = 1;
pub const led_trigger_netdev_modes_TRIGGER_NETDEV_LINK_100: led_trigger_netdev_modes = 2;
pub const led_trigger_netdev_modes_TRIGGER_NETDEV_LINK_1000: led_trigger_netdev_modes = 3;
pub const led_trigger_netdev_modes_TRIGGER_NETDEV_LINK_2500: led_trigger_netdev_modes = 4;
pub const led_trigger_netdev_modes_TRIGGER_NETDEV_LINK_5000: led_trigger_netdev_modes = 5;
pub const led_trigger_netdev_modes_TRIGGER_NETDEV_LINK_10000: led_trigger_netdev_modes = 6;
pub const led_trigger_netdev_modes_TRIGGER_NETDEV_HALF_DUPLEX: led_trigger_netdev_modes = 7;
pub const led_trigger_netdev_modes_TRIGGER_NETDEV_FULL_DUPLEX: led_trigger_netdev_modes = 8;
pub const led_trigger_netdev_modes_TRIGGER_NETDEV_TX: led_trigger_netdev_modes = 9;
pub const led_trigger_netdev_modes_TRIGGER_NETDEV_RX: led_trigger_netdev_modes = 10;
pub const led_trigger_netdev_modes_TRIGGER_NETDEV_TX_ERR: led_trigger_netdev_modes = 11;
pub const led_trigger_netdev_modes_TRIGGER_NETDEV_RX_ERR: led_trigger_netdev_modes = 12;
pub const led_trigger_netdev_modes___TRIGGER_NETDEV_MAX: led_trigger_netdev_modes = 13;
pub type led_trigger_netdev_modes = ffi::c_uint;
extern "C" {
    pub fn ledtrig_disk_activity(write: bool_);
}
extern "C" {
    pub fn ledtrig_mtd_activity();
}
extern "C" {
    pub fn ledtrig_flash_ctrl(on: bool_);
}
extern "C" {
    pub fn ledtrig_torch_ctrl(on: bool_);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct led_info {
    pub name: *const ffi::c_char,
    pub default_trigger: *const ffi::c_char,
    pub flags: ffi::c_int,
}
impl Default for led_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct led_platform_data {
    pub num_leds: ffi::c_int,
    pub leds: *mut led_info,
}
impl Default for led_platform_data {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct led_properties {
    pub color: u32_,
    pub color_present: bool_,
    pub function: *const ffi::c_char,
    pub func_enum: u32_,
    pub func_enum_present: bool_,
    pub label: *const ffi::c_char,
}
impl Default for led_properties {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type gpio_blink_set_t = ::core::option::Option<
    unsafe extern "C" fn(
        desc: *mut gpio_desc,
        state: ffi::c_int,
        delay_on: *mut ffi::c_ulong,
        delay_off: *mut ffi::c_ulong,
    ) -> ffi::c_int,
>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct gpio_led {
    pub name: *const ffi::c_char,
    pub default_trigger: *const ffi::c_char,
    pub gpio: ffi::c_uint,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub gpiod: *mut gpio_desc,
}
impl Default for gpio_led {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl gpio_led {
    #[inline]
    pub fn active_low(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_active_low(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn active_low_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_active_low_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn retain_state_suspended(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_retain_state_suspended(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn retain_state_suspended_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_retain_state_suspended_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn panic_indicator(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_panic_indicator(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn panic_indicator_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_panic_indicator_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn default_state(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(3usize, 2u8) as u32) }
    }
    #[inline]
    pub fn set_default_state(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(3usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn default_state_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                2u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_default_state_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn retain_state_shutdown(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_retain_state_shutdown(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(5usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn retain_state_shutdown_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_retain_state_shutdown_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        active_low: ffi::c_uint,
        retain_state_suspended: ffi::c_uint,
        panic_indicator: ffi::c_uint,
        default_state: ffi::c_uint,
        retain_state_shutdown: ffi::c_uint,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let active_low: u32 = unsafe { ::core::mem::transmute(active_low) };
            active_low as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let retain_state_suspended: u32 =
                unsafe { ::core::mem::transmute(retain_state_suspended) };
            retain_state_suspended as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let panic_indicator: u32 = unsafe { ::core::mem::transmute(panic_indicator) };
            panic_indicator as u64
        });
        __bindgen_bitfield_unit.set(3usize, 2u8, {
            let default_state: u32 = unsafe { ::core::mem::transmute(default_state) };
            default_state as u64
        });
        __bindgen_bitfield_unit.set(5usize, 1u8, {
            let retain_state_shutdown: u32 =
                unsafe { ::core::mem::transmute(retain_state_shutdown) };
            retain_state_shutdown as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct gpio_led_platform_data {
    pub num_leds: ffi::c_int,
    pub leds: *const gpio_led,
    pub gpio_blink_set: gpio_blink_set_t,
}
impl Default for gpio_led_platform_data {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const cpu_led_event_CPU_LED_IDLE_START: cpu_led_event = 0;
pub const cpu_led_event_CPU_LED_IDLE_END: cpu_led_event = 1;
pub const cpu_led_event_CPU_LED_START: cpu_led_event = 2;
pub const cpu_led_event_CPU_LED_STOP: cpu_led_event = 3;
pub const cpu_led_event_CPU_LED_HALTED: cpu_led_event = 4;
pub type cpu_led_event = ffi::c_uint;
extern "C" {
    pub fn ledtrig_cpu(evt: cpu_led_event);
}
extern "C" {
    pub fn led_classdev_notify_brightness_hw_changed(
        led_cdev: *mut led_classdev,
        brightness: ffi::c_uint,
    );
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct led_pattern {
    pub delta_t: u32_,
    pub brightness: ffi::c_int,
}
pub const led_audio_LED_AUDIO_MUTE: led_audio = 0;
pub const led_audio_LED_AUDIO_MICMUTE: led_audio = 1;
pub const led_audio_NUM_AUDIO_LEDS: led_audio = 2;
pub type led_audio = ffi::c_uint;
pub const hwtstamp_source_HWTSTAMP_SOURCE_UNSPEC: hwtstamp_source = 0;
pub const hwtstamp_source_HWTSTAMP_SOURCE_NETDEV: hwtstamp_source = 1;
pub const hwtstamp_source_HWTSTAMP_SOURCE_PHYLIB: hwtstamp_source = 2;
pub type hwtstamp_source = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct hwtstamp_provider_desc {
    pub index: ffi::c_int,
    pub qualifier: hwtstamp_provider_qualifier,
}
impl Default for hwtstamp_provider_desc {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct hwtstamp_provider {
    pub callback_head: callback_head,
    pub source: hwtstamp_source,
    pub phydev: *mut phy_device,
    pub desc: hwtstamp_provider_desc,
}
impl Default for hwtstamp_provider {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct kernel_hwtstamp_config {
    pub flags: ffi::c_int,
    pub tx_type: ffi::c_int,
    pub rx_filter: ffi::c_int,
    pub ifr: *mut ifreq,
    pub copied_to_user: bool_,
    pub source: hwtstamp_source,
    pub qualifier: hwtstamp_provider_qualifier,
}
impl Default for kernel_hwtstamp_config {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mii_timestamper {
    pub rxtstamp: ::core::option::Option<
        unsafe extern "C" fn(
            mii_ts: *mut mii_timestamper,
            skb: *mut sk_buff,
            type_: ffi::c_int,
        ) -> bool_,
    >,
    pub txtstamp: ::core::option::Option<
        unsafe extern "C" fn(mii_ts: *mut mii_timestamper, skb: *mut sk_buff, type_: ffi::c_int),
    >,
    pub hwtstamp: ::core::option::Option<
        unsafe extern "C" fn(
            mii_ts: *mut mii_timestamper,
            kernel_config: *mut kernel_hwtstamp_config,
            extack: *mut netlink_ext_ack,
        ) -> ffi::c_int,
    >,
    pub link_state: ::core::option::Option<
        unsafe extern "C" fn(mii_ts: *mut mii_timestamper, phydev: *mut phy_device),
    >,
    pub ts_info: ::core::option::Option<
        unsafe extern "C" fn(
            mii_ts: *mut mii_timestamper,
            ts_info: *mut kernel_ethtool_ts_info,
        ) -> ffi::c_int,
    >,
    pub device: *mut device,
}
impl Default for mii_timestamper {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct mii_timestamping_ctrl {
    pub probe_channel: ::core::option::Option<
        unsafe extern "C" fn(device: *mut device, port: ffi::c_uint) -> *mut mii_timestamper,
    >,
    pub release_channel: ::core::option::Option<
        unsafe extern "C" fn(device: *mut device, mii_ts: *mut mii_timestamper),
    >,
}
extern "C" {
    pub fn register_mii_tstamp_controller(
        device: *mut device,
        ctrl: *mut mii_timestamping_ctrl,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn unregister_mii_tstamp_controller(device: *mut device);
}
extern "C" {
    pub fn register_mii_timestamper(
        node: *mut device_node,
        port: ffi::c_uint,
    ) -> *mut mii_timestamper;
}
extern "C" {
    pub fn unregister_mii_timestamper(mii_ts: *mut mii_timestamper);
}
extern "C" {
    pub static mut loops_per_jiffy: ffi::c_ulong;
}
extern "C" {
    pub fn __bad_udelay();
}
extern "C" {
    pub fn __bad_ndelay();
}
extern "C" {
    pub fn __udelay(usecs: ffi::c_ulong);
}
extern "C" {
    pub fn __ndelay(nsecs: ffi::c_ulong);
}
extern "C" {
    pub fn __const_udelay(xloops: ffi::c_ulong);
}
extern "C" {
    pub fn __delay(loops: ffi::c_ulong);
}
extern "C" {
    pub static mut lpj_fine: ffi::c_ulong;
}
extern "C" {
    pub fn calibrate_delay();
}
extern "C" {
    pub fn calibrate_delay_is_known() -> ffi::c_ulong;
}
extern "C" {
    pub fn calibration_delay_done();
}
extern "C" {
    pub fn msleep(msecs: ffi::c_uint);
}
extern "C" {
    pub fn msleep_interruptible(msecs: ffi::c_uint) -> ffi::c_ulong;
}
extern "C" {
    pub fn usleep_range_state(min: ffi::c_ulong, max: ffi::c_ulong, state: ffi::c_uint);
}
pub const max_slack_shift: ffi::c_uint = 2;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct eee_config {
    pub tx_lpi_timer: u32_,
    pub tx_lpi_enabled: bool_,
    pub eee_enabled: bool_,
}
extern "C" {
    pub static mut phy_basic_features: [ffi::c_ulong; 2usize];
}
extern "C" {
    pub static mut phy_basic_t1_features: [ffi::c_ulong; 2usize];
}
extern "C" {
    pub static mut phy_basic_t1s_p2mp_features: [ffi::c_ulong; 2usize];
}
extern "C" {
    pub static mut phy_gbit_features: [ffi::c_ulong; 2usize];
}
extern "C" {
    pub static mut phy_gbit_fibre_features: [ffi::c_ulong; 2usize];
}
extern "C" {
    pub static mut phy_10gbit_features: [ffi::c_ulong; 2usize];
}
extern "C" {
    pub static mut phy_eee_cap1_features: [ffi::c_ulong; 2usize];
}
extern "C" {
    pub static mut phy_eee_cap2_features: [ffi::c_ulong; 2usize];
}
extern "C" {
    pub static phy_basic_ports_array: [ffi::c_int; 3usize];
}
pub const phy_interface_t_PHY_INTERFACE_MODE_NA: phy_interface_t = 0;
pub const phy_interface_t_PHY_INTERFACE_MODE_INTERNAL: phy_interface_t = 1;
pub const phy_interface_t_PHY_INTERFACE_MODE_MII: phy_interface_t = 2;
pub const phy_interface_t_PHY_INTERFACE_MODE_GMII: phy_interface_t = 3;
pub const phy_interface_t_PHY_INTERFACE_MODE_SGMII: phy_interface_t = 4;
pub const phy_interface_t_PHY_INTERFACE_MODE_TBI: phy_interface_t = 5;
pub const phy_interface_t_PHY_INTERFACE_MODE_REVMII: phy_interface_t = 6;
pub const phy_interface_t_PHY_INTERFACE_MODE_RMII: phy_interface_t = 7;
pub const phy_interface_t_PHY_INTERFACE_MODE_REVRMII: phy_interface_t = 8;
pub const phy_interface_t_PHY_INTERFACE_MODE_RGMII: phy_interface_t = 9;
pub const phy_interface_t_PHY_INTERFACE_MODE_RGMII_ID: phy_interface_t = 10;
pub const phy_interface_t_PHY_INTERFACE_MODE_RGMII_RXID: phy_interface_t = 11;
pub const phy_interface_t_PHY_INTERFACE_MODE_RGMII_TXID: phy_interface_t = 12;
pub const phy_interface_t_PHY_INTERFACE_MODE_RTBI: phy_interface_t = 13;
pub const phy_interface_t_PHY_INTERFACE_MODE_SMII: phy_interface_t = 14;
pub const phy_interface_t_PHY_INTERFACE_MODE_XGMII: phy_interface_t = 15;
pub const phy_interface_t_PHY_INTERFACE_MODE_XLGMII: phy_interface_t = 16;
pub const phy_interface_t_PHY_INTERFACE_MODE_MOCA: phy_interface_t = 17;
pub const phy_interface_t_PHY_INTERFACE_MODE_PSGMII: phy_interface_t = 18;
pub const phy_interface_t_PHY_INTERFACE_MODE_QSGMII: phy_interface_t = 19;
pub const phy_interface_t_PHY_INTERFACE_MODE_TRGMII: phy_interface_t = 20;
pub const phy_interface_t_PHY_INTERFACE_MODE_100BASEX: phy_interface_t = 21;
pub const phy_interface_t_PHY_INTERFACE_MODE_1000BASEX: phy_interface_t = 22;
pub const phy_interface_t_PHY_INTERFACE_MODE_2500BASEX: phy_interface_t = 23;
pub const phy_interface_t_PHY_INTERFACE_MODE_5GBASER: phy_interface_t = 24;
pub const phy_interface_t_PHY_INTERFACE_MODE_RXAUI: phy_interface_t = 25;
pub const phy_interface_t_PHY_INTERFACE_MODE_XAUI: phy_interface_t = 26;
pub const phy_interface_t_PHY_INTERFACE_MODE_10GBASER: phy_interface_t = 27;
pub const phy_interface_t_PHY_INTERFACE_MODE_25GBASER: phy_interface_t = 28;
pub const phy_interface_t_PHY_INTERFACE_MODE_USXGMII: phy_interface_t = 29;
pub const phy_interface_t_PHY_INTERFACE_MODE_10GKR: phy_interface_t = 30;
pub const phy_interface_t_PHY_INTERFACE_MODE_QUSGMII: phy_interface_t = 31;
pub const phy_interface_t_PHY_INTERFACE_MODE_1000BASEKX: phy_interface_t = 32;
pub const phy_interface_t_PHY_INTERFACE_MODE_10G_QXGMII: phy_interface_t = 33;
pub const phy_interface_t_PHY_INTERFACE_MODE_MAX: phy_interface_t = 34;
pub type phy_interface_t = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct phylink {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sfp_bus {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sfp_upstream_ops {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct mdio_bus_stats {
    pub transfers: u64_stats_t,
    pub errors: u64_stats_t,
    pub writes: u64_stats_t,
    pub reads: u64_stats_t,
    pub syncp: u64_stats_sync,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mii_bus {
    pub owner: *mut module,
    pub name: *const ffi::c_char,
    pub id: [ffi::c_char; 61usize],
    pub priv_: *mut ffi::c_void,
    pub read: ::core::option::Option<
        unsafe extern "C" fn(bus: *mut mii_bus, addr: ffi::c_int, regnum: ffi::c_int) -> ffi::c_int,
    >,
    pub write: ::core::option::Option<
        unsafe extern "C" fn(
            bus: *mut mii_bus,
            addr: ffi::c_int,
            regnum: ffi::c_int,
            val: u16_,
        ) -> ffi::c_int,
    >,
    pub read_c45: ::core::option::Option<
        unsafe extern "C" fn(
            bus: *mut mii_bus,
            addr: ffi::c_int,
            devnum: ffi::c_int,
            regnum: ffi::c_int,
        ) -> ffi::c_int,
    >,
    pub write_c45: ::core::option::Option<
        unsafe extern "C" fn(
            bus: *mut mii_bus,
            addr: ffi::c_int,
            devnum: ffi::c_int,
            regnum: ffi::c_int,
            val: u16_,
        ) -> ffi::c_int,
    >,
    pub reset: ::core::option::Option<unsafe extern "C" fn(bus: *mut mii_bus) -> ffi::c_int>,
    pub stats: [mdio_bus_stats; 32usize],
    pub mdio_lock: mutex,
    pub parent: *mut device,
    pub state: mii_bus__bindgen_ty_1,
    pub dev: device,
    pub mdio_map: [*mut mdio_device; 32usize],
    pub phy_mask: u32_,
    pub phy_ignore_ta_mask: u32_,
    pub irq: [ffi::c_int; 32usize],
    pub reset_delay_us: ffi::c_int,
    pub reset_post_delay_us: ffi::c_int,
    pub reset_gpiod: *mut gpio_desc,
    pub shared_lock: mutex,
    pub shared: [*mut phy_package_shared; 32usize],
}
pub const mii_bus_MDIOBUS_ALLOCATED: mii_bus__bindgen_ty_1 = 1;
pub const mii_bus_MDIOBUS_REGISTERED: mii_bus__bindgen_ty_1 = 2;
pub const mii_bus_MDIOBUS_UNREGISTERED: mii_bus__bindgen_ty_1 = 3;
pub const mii_bus_MDIOBUS_RELEASED: mii_bus__bindgen_ty_1 = 4;
pub type mii_bus__bindgen_ty_1 = ffi::c_uint;
impl Default for mii_bus {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn mdiobus_alloc_size(size: usize) -> *mut mii_bus;
}
extern "C" {
    pub fn __mdiobus_register(bus: *mut mii_bus, owner: *mut module) -> ffi::c_int;
}
extern "C" {
    pub fn __devm_mdiobus_register(
        dev: *mut device,
        bus: *mut mii_bus,
        owner: *mut module,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn mdiobus_unregister(bus: *mut mii_bus);
}
extern "C" {
    pub fn mdiobus_free(bus: *mut mii_bus);
}
extern "C" {
    pub fn devm_mdiobus_alloc_size(dev: *mut device, sizeof_priv: ffi::c_int) -> *mut mii_bus;
}
extern "C" {
    pub fn mdio_find_bus(mdio_name: *const ffi::c_char) -> *mut mii_bus;
}
extern "C" {
    pub fn mdiobus_scan_c22(bus: *mut mii_bus, addr: ffi::c_int) -> *mut phy_device;
}
pub const phy_state_PHY_DOWN: phy_state = 0;
pub const phy_state_PHY_READY: phy_state = 1;
pub const phy_state_PHY_HALTED: phy_state = 2;
pub const phy_state_PHY_ERROR: phy_state = 3;
pub const phy_state_PHY_UP: phy_state = 4;
pub const phy_state_PHY_RUNNING: phy_state = 5;
pub const phy_state_PHY_NOLINK: phy_state = 6;
pub const phy_state_PHY_CABLETEST: phy_state = 7;
pub type phy_state = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct phy_c45_device_ids {
    pub devices_in_package: u32_,
    pub mmds_present: u32_,
    pub device_ids: [u32_; 32usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct macsec_context {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct macsec_ops {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct phy_device {
    pub mdio: mdio_device,
    pub drv: *const phy_driver,
    pub devlink: *mut device_link,
    pub phyindex: u32_,
    pub phy_id: u32_,
    pub c45_ids: phy_c45_device_ids,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 3usize]>,
    pub rate_matching: ffi::c_int,
    pub state: phy_state,
    pub dev_flags: u32_,
    pub interface: phy_interface_t,
    pub possible_interfaces: [ffi::c_ulong; 1usize],
    pub speed: ffi::c_int,
    pub duplex: ffi::c_int,
    pub port: ffi::c_int,
    pub pause: ffi::c_int,
    pub asym_pause: ffi::c_int,
    pub master_slave_get: u8_,
    pub master_slave_set: u8_,
    pub master_slave_state: u8_,
    pub supported: [ffi::c_ulong; 2usize],
    pub advertising: [ffi::c_ulong; 2usize],
    pub lp_advertising: [ffi::c_ulong; 2usize],
    pub adv_old: [ffi::c_ulong; 2usize],
    pub supported_eee: [ffi::c_ulong; 2usize],
    pub advertising_eee: [ffi::c_ulong; 2usize],
    pub eee_disabled_modes: [ffi::c_ulong; 2usize],
    pub enable_tx_lpi: bool_,
    pub eee_active: bool_,
    pub eee_cfg: eee_config,
    pub host_interfaces: [ffi::c_ulong; 1usize],
    pub phy_led_triggers: *mut phy_led_trigger,
    pub phy_num_led_triggers: ffi::c_uint,
    pub last_triggered: *mut phy_led_trigger,
    pub led_link_trigger: *mut phy_led_trigger,
    pub leds: list_head,
    pub irq: ffi::c_int,
    pub priv_: *mut ffi::c_void,
    pub shared: *mut phy_package_shared,
    pub skb: *mut sk_buff,
    pub ehdr: *mut ffi::c_void,
    pub nest: *mut nlattr,
    pub state_queue: delayed_work,
    pub lock: mutex,
    pub sfp_bus_attached: bool_,
    pub sfp_bus: *mut sfp_bus,
    pub phylink: *mut phylink,
    pub attached_dev: *mut net_device,
    pub mii_ts: *mut mii_timestamper,
    pub psec: *mut pse_control,
    pub mdix: u8_,
    pub mdix_ctrl: u8_,
    pub pma_extable: ffi::c_int,
    pub link_down_events: ffi::c_uint,
    pub phy_link_change:
        ::core::option::Option<unsafe extern "C" fn(phydev: *mut phy_device, up: bool_)>,
    pub adjust_link: ::core::option::Option<unsafe extern "C" fn(dev: *mut net_device)>,
    pub macsec_ops: *const macsec_ops,
}
impl Default for phy_device {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl phy_device {
    #[inline]
    pub fn is_c45(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_is_c45(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn is_c45_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_is_c45_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn is_internal(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_is_internal(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn is_internal_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_is_internal_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn is_pseudo_fixed_link(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_is_pseudo_fixed_link(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn is_pseudo_fixed_link_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_is_pseudo_fixed_link_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn is_gigabit_capable(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_is_gigabit_capable(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn is_gigabit_capable_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_is_gigabit_capable_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn has_fixups(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_has_fixups(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn has_fixups_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_has_fixups_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn suspended(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_suspended(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(5usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn suspended_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_suspended_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn suspended_by_mdio_bus(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_suspended_by_mdio_bus(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(6usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn suspended_by_mdio_bus_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                6usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_suspended_by_mdio_bus_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                6usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn sysfs_links(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_sysfs_links(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(7usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn sysfs_links_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                7usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_sysfs_links_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                7usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn loopback_enabled(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(8usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_loopback_enabled(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(8usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn loopback_enabled_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                8usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_loopback_enabled_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                8usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn downshifted_rate(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(9usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_downshifted_rate(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(9usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn downshifted_rate_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                9usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_downshifted_rate_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                9usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn is_on_sfp_module(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(10usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_is_on_sfp_module(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(10usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn is_on_sfp_module_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                10usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_is_on_sfp_module_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                10usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn mac_managed_pm(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(11usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_mac_managed_pm(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(11usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn mac_managed_pm_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                11usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_mac_managed_pm_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                11usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn wol_enabled(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(12usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_wol_enabled(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(12usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn wol_enabled_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                12usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_wol_enabled_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                12usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn autoneg(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(13usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_autoneg(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(13usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn autoneg_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                13usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_autoneg_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                13usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn link(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(14usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_link(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(14usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn link_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                14usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_link_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                14usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn autoneg_complete(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(15usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_autoneg_complete(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(15usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn autoneg_complete_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                15usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_autoneg_complete_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                15usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn interrupts(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(16usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_interrupts(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(16usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn interrupts_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                16usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_interrupts_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                16usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn irq_suspended(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(17usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_irq_suspended(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(17usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn irq_suspended_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                17usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_irq_suspended_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                17usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn irq_rerun(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(18usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_irq_rerun(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(18usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn irq_rerun_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                18usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_irq_rerun_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                18usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn default_timestamp(&self) -> ffi::c_uint {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(19usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_default_timestamp(&mut self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(19usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn default_timestamp_raw(this: *const Self) -> ffi::c_uint {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 3usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                19usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_default_timestamp_raw(this: *mut Self, val: ffi::c_uint) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 3usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                19usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        is_c45: ffi::c_uint,
        is_internal: ffi::c_uint,
        is_pseudo_fixed_link: ffi::c_uint,
        is_gigabit_capable: ffi::c_uint,
        has_fixups: ffi::c_uint,
        suspended: ffi::c_uint,
        suspended_by_mdio_bus: ffi::c_uint,
        sysfs_links: ffi::c_uint,
        loopback_enabled: ffi::c_uint,
        downshifted_rate: ffi::c_uint,
        is_on_sfp_module: ffi::c_uint,
        mac_managed_pm: ffi::c_uint,
        wol_enabled: ffi::c_uint,
        autoneg: ffi::c_uint,
        link: ffi::c_uint,
        autoneg_complete: ffi::c_uint,
        interrupts: ffi::c_uint,
        irq_suspended: ffi::c_uint,
        irq_rerun: ffi::c_uint,
        default_timestamp: ffi::c_uint,
    ) -> __BindgenBitfieldUnit<[u8; 3usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 3usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let is_c45: u32 = unsafe { ::core::mem::transmute(is_c45) };
            is_c45 as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let is_internal: u32 = unsafe { ::core::mem::transmute(is_internal) };
            is_internal as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let is_pseudo_fixed_link: u32 = unsafe { ::core::mem::transmute(is_pseudo_fixed_link) };
            is_pseudo_fixed_link as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let is_gigabit_capable: u32 = unsafe { ::core::mem::transmute(is_gigabit_capable) };
            is_gigabit_capable as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let has_fixups: u32 = unsafe { ::core::mem::transmute(has_fixups) };
            has_fixups as u64
        });
        __bindgen_bitfield_unit.set(5usize, 1u8, {
            let suspended: u32 = unsafe { ::core::mem::transmute(suspended) };
            suspended as u64
        });
        __bindgen_bitfield_unit.set(6usize, 1u8, {
            let suspended_by_mdio_bus: u32 =
                unsafe { ::core::mem::transmute(suspended_by_mdio_bus) };
            suspended_by_mdio_bus as u64
        });
        __bindgen_bitfield_unit.set(7usize, 1u8, {
            let sysfs_links: u32 = unsafe { ::core::mem::transmute(sysfs_links) };
            sysfs_links as u64
        });
        __bindgen_bitfield_unit.set(8usize, 1u8, {
            let loopback_enabled: u32 = unsafe { ::core::mem::transmute(loopback_enabled) };
            loopback_enabled as u64
        });
        __bindgen_bitfield_unit.set(9usize, 1u8, {
            let downshifted_rate: u32 = unsafe { ::core::mem::transmute(downshifted_rate) };
            downshifted_rate as u64
        });
        __bindgen_bitfield_unit.set(10usize, 1u8, {
            let is_on_sfp_module: u32 = unsafe { ::core::mem::transmute(is_on_sfp_module) };
            is_on_sfp_module as u64
        });
        __bindgen_bitfield_unit.set(11usize, 1u8, {
            let mac_managed_pm: u32 = unsafe { ::core::mem::transmute(mac_managed_pm) };
            mac_managed_pm as u64
        });
        __bindgen_bitfield_unit.set(12usize, 1u8, {
            let wol_enabled: u32 = unsafe { ::core::mem::transmute(wol_enabled) };
            wol_enabled as u64
        });
        __bindgen_bitfield_unit.set(13usize, 1u8, {
            let autoneg: u32 = unsafe { ::core::mem::transmute(autoneg) };
            autoneg as u64
        });
        __bindgen_bitfield_unit.set(14usize, 1u8, {
            let link: u32 = unsafe { ::core::mem::transmute(link) };
            link as u64
        });
        __bindgen_bitfield_unit.set(15usize, 1u8, {
            let autoneg_complete: u32 = unsafe { ::core::mem::transmute(autoneg_complete) };
            autoneg_complete as u64
        });
        __bindgen_bitfield_unit.set(16usize, 1u8, {
            let interrupts: u32 = unsafe { ::core::mem::transmute(interrupts) };
            interrupts as u64
        });
        __bindgen_bitfield_unit.set(17usize, 1u8, {
            let irq_suspended: u32 = unsafe { ::core::mem::transmute(irq_suspended) };
            irq_suspended as u64
        });
        __bindgen_bitfield_unit.set(18usize, 1u8, {
            let irq_rerun: u32 = unsafe { ::core::mem::transmute(irq_rerun) };
            irq_rerun as u64
        });
        __bindgen_bitfield_unit.set(19usize, 1u8, {
            let default_timestamp: u32 = unsafe { ::core::mem::transmute(default_timestamp) };
            default_timestamp as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct phy_tdr_config {
    pub first: u32_,
    pub last: u32_,
    pub step: u32_,
    pub pair: s8,
}
pub const link_inband_signalling_LINK_INBAND_DISABLE: link_inband_signalling = 1;
pub const link_inband_signalling_LINK_INBAND_ENABLE: link_inband_signalling = 2;
pub const link_inband_signalling_LINK_INBAND_BYPASS: link_inband_signalling = 4;
pub type link_inband_signalling = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct phy_plca_cfg {
    pub version: ffi::c_int,
    pub enabled: ffi::c_int,
    pub node_id: ffi::c_int,
    pub node_cnt: ffi::c_int,
    pub to_tmr: ffi::c_int,
    pub burst_cnt: ffi::c_int,
    pub burst_tmr: ffi::c_int,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct phy_plca_status {
    pub pst: bool_,
}
pub const phy_led_modes_PHY_LED_ACTIVE_HIGH: phy_led_modes = 0;
pub const phy_led_modes_PHY_LED_ACTIVE_LOW: phy_led_modes = 1;
pub const phy_led_modes_PHY_LED_INACTIVE_HIGH_IMPEDANCE: phy_led_modes = 2;
pub const phy_led_modes___PHY_LED_MODES_NUM: phy_led_modes = 3;
pub type phy_led_modes = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct phy_led {
    pub list: list_head,
    pub phydev: *mut phy_device,
    pub led_cdev: led_classdev,
    pub index: u8_,
}
impl Default for phy_led {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct phy_driver {
    pub mdiodrv: mdio_driver_common,
    pub phy_id: u32_,
    pub name: *mut ffi::c_char,
    pub phy_id_mask: u32_,
    pub features: *const ffi::c_ulong,
    pub flags: u32_,
    pub driver_data: *const ffi::c_void,
    pub soft_reset:
        ::core::option::Option<unsafe extern "C" fn(phydev: *mut phy_device) -> ffi::c_int>,
    pub config_init:
        ::core::option::Option<unsafe extern "C" fn(phydev: *mut phy_device) -> ffi::c_int>,
    pub probe: ::core::option::Option<unsafe extern "C" fn(phydev: *mut phy_device) -> ffi::c_int>,
    pub get_features:
        ::core::option::Option<unsafe extern "C" fn(phydev: *mut phy_device) -> ffi::c_int>,
    pub inband_caps: ::core::option::Option<
        unsafe extern "C" fn(phydev: *mut phy_device, interface: phy_interface_t) -> ffi::c_uint,
    >,
    pub config_inband: ::core::option::Option<
        unsafe extern "C" fn(phydev: *mut phy_device, modes: ffi::c_uint) -> ffi::c_int,
    >,
    pub get_rate_matching: ::core::option::Option<
        unsafe extern "C" fn(phydev: *mut phy_device, iface: phy_interface_t) -> ffi::c_int,
    >,
    pub suspend:
        ::core::option::Option<unsafe extern "C" fn(phydev: *mut phy_device) -> ffi::c_int>,
    pub resume: ::core::option::Option<unsafe extern "C" fn(phydev: *mut phy_device) -> ffi::c_int>,
    pub config_aneg:
        ::core::option::Option<unsafe extern "C" fn(phydev: *mut phy_device) -> ffi::c_int>,
    pub aneg_done:
        ::core::option::Option<unsafe extern "C" fn(phydev: *mut phy_device) -> ffi::c_int>,
    pub read_status:
        ::core::option::Option<unsafe extern "C" fn(phydev: *mut phy_device) -> ffi::c_int>,
    pub config_intr:
        ::core::option::Option<unsafe extern "C" fn(phydev: *mut phy_device) -> ffi::c_int>,
    pub handle_interrupt:
        ::core::option::Option<unsafe extern "C" fn(phydev: *mut phy_device) -> irqreturn_t>,
    pub remove: ::core::option::Option<unsafe extern "C" fn(phydev: *mut phy_device)>,
    pub match_phy_device:
        ::core::option::Option<unsafe extern "C" fn(phydev: *mut phy_device) -> ffi::c_int>,
    pub set_wol: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut phy_device, wol: *mut ethtool_wolinfo) -> ffi::c_int,
    >,
    pub get_wol: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut phy_device, wol: *mut ethtool_wolinfo),
    >,
    pub link_change_notify: ::core::option::Option<unsafe extern "C" fn(dev: *mut phy_device)>,
    pub read_mmd: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut phy_device, devnum: ffi::c_int, regnum: u16_) -> ffi::c_int,
    >,
    pub write_mmd: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut phy_device,
            devnum: ffi::c_int,
            regnum: u16_,
            val: u16_,
        ) -> ffi::c_int,
    >,
    pub read_page: ::core::option::Option<unsafe extern "C" fn(dev: *mut phy_device) -> ffi::c_int>,
    pub write_page: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut phy_device, page: ffi::c_int) -> ffi::c_int,
    >,
    pub module_info: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut phy_device, modinfo: *mut ethtool_modinfo) -> ffi::c_int,
    >,
    pub module_eeprom: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut phy_device,
            ee: *mut ethtool_eeprom,
            data: *mut u8_,
        ) -> ffi::c_int,
    >,
    pub cable_test_start:
        ::core::option::Option<unsafe extern "C" fn(dev: *mut phy_device) -> ffi::c_int>,
    pub cable_test_tdr_start: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut phy_device, config: *const phy_tdr_config) -> ffi::c_int,
    >,
    pub cable_test_get_status: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut phy_device, finished: *mut bool_) -> ffi::c_int,
    >,
    pub get_phy_stats: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut phy_device,
            eth_stats: *mut ethtool_eth_phy_stats,
            stats: *mut ethtool_phy_stats,
        ),
    >,
    pub get_link_stats: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut phy_device, link_stats: *mut ethtool_link_ext_stats),
    >,
    pub update_stats:
        ::core::option::Option<unsafe extern "C" fn(dev: *mut phy_device) -> ffi::c_int>,
    pub get_sset_count:
        ::core::option::Option<unsafe extern "C" fn(dev: *mut phy_device) -> ffi::c_int>,
    pub get_strings:
        ::core::option::Option<unsafe extern "C" fn(dev: *mut phy_device, data: *mut u8_)>,
    pub get_stats: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut phy_device, stats: *mut ethtool_stats, data: *mut u64_),
    >,
    pub get_tunable: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut phy_device,
            tuna: *mut ethtool_tunable,
            data: *mut ffi::c_void,
        ) -> ffi::c_int,
    >,
    pub set_tunable: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut phy_device,
            tuna: *mut ethtool_tunable,
            data: *const ffi::c_void,
        ) -> ffi::c_int,
    >,
    pub set_loopback: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut phy_device, enable: bool_, speed: ffi::c_int) -> ffi::c_int,
    >,
    pub get_sqi: ::core::option::Option<unsafe extern "C" fn(dev: *mut phy_device) -> ffi::c_int>,
    pub get_sqi_max:
        ::core::option::Option<unsafe extern "C" fn(dev: *mut phy_device) -> ffi::c_int>,
    pub get_plca_cfg: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut phy_device, plca_cfg: *mut phy_plca_cfg) -> ffi::c_int,
    >,
    pub set_plca_cfg: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut phy_device, plca_cfg: *const phy_plca_cfg) -> ffi::c_int,
    >,
    pub get_plca_status: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut phy_device, plca_st: *mut phy_plca_status) -> ffi::c_int,
    >,
    pub led_brightness_set: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut phy_device, index: u8_, value: led_brightness) -> ffi::c_int,
    >,
    pub led_blink_set: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut phy_device,
            index: u8_,
            delay_on: *mut ffi::c_ulong,
            delay_off: *mut ffi::c_ulong,
        ) -> ffi::c_int,
    >,
    pub led_hw_is_supported: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut phy_device, index: u8_, rules: ffi::c_ulong) -> ffi::c_int,
    >,
    pub led_hw_control_set: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut phy_device, index: u8_, rules: ffi::c_ulong) -> ffi::c_int,
    >,
    pub led_hw_control_get: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut phy_device,
            index: u8_,
            rules: *mut ffi::c_ulong,
        ) -> ffi::c_int,
    >,
    pub led_polarity_set: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut phy_device,
            index: ffi::c_int,
            modes: ffi::c_ulong,
        ) -> ffi::c_int,
    >,
    pub get_next_update_time:
        ::core::option::Option<unsafe extern "C" fn(dev: *mut phy_device) -> ffi::c_uint>,
}
impl Default for phy_driver {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn phy_speed_to_str(speed: ffi::c_int) -> *const ffi::c_char;
}
extern "C" {
    pub fn phy_duplex_to_str(duplex: ffi::c_uint) -> *const ffi::c_char;
}
extern "C" {
    pub fn phy_rate_matching_to_str(rate_matching: ffi::c_int) -> *const ffi::c_char;
}
extern "C" {
    pub fn phy_interface_num_ports(interface: phy_interface_t) -> ffi::c_int;
}
extern "C" {
    pub fn phy_resolve_aneg_pause(phydev: *mut phy_device);
}
extern "C" {
    pub fn phy_resolve_aneg_linkmode(phydev: *mut phy_device);
}
extern "C" {
    pub fn phy_read_mmd(phydev: *mut phy_device, devad: ffi::c_int, regnum: u32_) -> ffi::c_int;
}
extern "C" {
    pub fn __phy_read_mmd(phydev: *mut phy_device, devad: ffi::c_int, regnum: u32_) -> ffi::c_int;
}
extern "C" {
    pub fn phy_write_mmd(
        phydev: *mut phy_device,
        devad: ffi::c_int,
        regnum: u32_,
        val: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __phy_write_mmd(
        phydev: *mut phy_device,
        devad: ffi::c_int,
        regnum: u32_,
        val: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_modify_changed(
        phydev: *mut phy_device,
        regnum: u32_,
        mask: u16_,
        set: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __phy_modify(phydev: *mut phy_device, regnum: u32_, mask: u16_, set: u16_)
        -> ffi::c_int;
}
extern "C" {
    pub fn phy_modify(phydev: *mut phy_device, regnum: u32_, mask: u16_, set: u16_) -> ffi::c_int;
}
extern "C" {
    pub fn __phy_modify_mmd_changed(
        phydev: *mut phy_device,
        devad: ffi::c_int,
        regnum: u32_,
        mask: u16_,
        set: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_modify_mmd_changed(
        phydev: *mut phy_device,
        devad: ffi::c_int,
        regnum: u32_,
        mask: u16_,
        set: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __phy_modify_mmd(
        phydev: *mut phy_device,
        devad: ffi::c_int,
        regnum: u32_,
        mask: u16_,
        set: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_modify_mmd(
        phydev: *mut phy_device,
        devad: ffi::c_int,
        regnum: u32_,
        mask: u16_,
        set: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_save_page(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn phy_select_page(phydev: *mut phy_device, page: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn phy_restore_page(
        phydev: *mut phy_device,
        oldpage: ffi::c_int,
        ret: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_read_paged(phydev: *mut phy_device, page: ffi::c_int, regnum: u32_) -> ffi::c_int;
}
extern "C" {
    pub fn phy_write_paged(
        phydev: *mut phy_device,
        page: ffi::c_int,
        regnum: u32_,
        val: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_modify_paged_changed(
        phydev: *mut phy_device,
        page: ffi::c_int,
        regnum: u32_,
        mask: u16_,
        set: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_modify_paged(
        phydev: *mut phy_device,
        page: ffi::c_int,
        regnum: u32_,
        mask: u16_,
        set: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_device_create(
        bus: *mut mii_bus,
        addr: ffi::c_int,
        phy_id: u32_,
        is_c45: bool_,
        c45_ids: *mut phy_c45_device_ids,
    ) -> *mut phy_device;
}
extern "C" {
    pub fn fwnode_get_phy_id(fwnode: *mut fwnode_handle, phy_id: *mut u32_) -> ffi::c_int;
}
extern "C" {
    pub fn fwnode_mdio_find_device(fwnode: *mut fwnode_handle) -> *mut mdio_device;
}
extern "C" {
    pub fn fwnode_phy_find_device(phy_fwnode: *mut fwnode_handle) -> *mut phy_device;
}
extern "C" {
    pub fn device_phy_find_device(dev: *mut device) -> *mut phy_device;
}
extern "C" {
    pub fn fwnode_get_phy_node(fwnode: *const fwnode_handle) -> *mut fwnode_handle;
}
extern "C" {
    pub fn get_phy_device(bus: *mut mii_bus, addr: ffi::c_int, is_c45: bool_) -> *mut phy_device;
}
extern "C" {
    pub fn phy_device_register(phy: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn phy_device_free(phydev: *mut phy_device);
}
extern "C" {
    pub fn phy_device_remove(phydev: *mut phy_device);
}
extern "C" {
    pub fn phy_get_c45_ids(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn phy_init_hw(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn phy_suspend(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn phy_resume(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn __phy_resume(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn phy_loopback(phydev: *mut phy_device, enable: bool_, speed: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn phy_sfp_connect_phy(upstream: *mut ffi::c_void, phy: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn phy_sfp_disconnect_phy(upstream: *mut ffi::c_void, phy: *mut phy_device);
}
extern "C" {
    pub fn phy_sfp_attach(upstream: *mut ffi::c_void, bus: *mut sfp_bus);
}
extern "C" {
    pub fn phy_sfp_detach(upstream: *mut ffi::c_void, bus: *mut sfp_bus);
}
extern "C" {
    pub fn phy_sfp_probe(phydev: *mut phy_device, ops: *const sfp_upstream_ops) -> ffi::c_int;
}
extern "C" {
    pub fn phy_attach(
        dev: *mut net_device,
        bus_id: *const ffi::c_char,
        interface: phy_interface_t,
    ) -> *mut phy_device;
}
extern "C" {
    pub fn phy_find_first(bus: *mut mii_bus) -> *mut phy_device;
}
extern "C" {
    pub fn phy_attach_direct(
        dev: *mut net_device,
        phydev: *mut phy_device,
        flags: u32_,
        interface: phy_interface_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_connect_direct(
        dev: *mut net_device,
        phydev: *mut phy_device,
        handler: ::core::option::Option<unsafe extern "C" fn(arg1: *mut net_device)>,
        interface: phy_interface_t,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_connect(
        dev: *mut net_device,
        bus_id: *const ffi::c_char,
        handler: ::core::option::Option<unsafe extern "C" fn(arg1: *mut net_device)>,
        interface: phy_interface_t,
    ) -> *mut phy_device;
}
extern "C" {
    pub fn phy_disconnect(phydev: *mut phy_device);
}
extern "C" {
    pub fn phy_detach(phydev: *mut phy_device);
}
extern "C" {
    pub fn phy_start(phydev: *mut phy_device);
}
extern "C" {
    pub fn phy_stop(phydev: *mut phy_device);
}
extern "C" {
    pub fn phy_config_aneg(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn _phy_start_aneg(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn phy_start_aneg(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn phy_aneg_done(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn phy_inband_caps(phydev: *mut phy_device, interface: phy_interface_t) -> ffi::c_uint;
}
extern "C" {
    pub fn phy_config_inband(phydev: *mut phy_device, modes: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn phy_speed_down(phydev: *mut phy_device, sync: bool_) -> ffi::c_int;
}
extern "C" {
    pub fn phy_speed_up(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn phy_check_valid(
        speed: ffi::c_int,
        duplex: ffi::c_int,
        features: *mut ffi::c_ulong,
    ) -> bool_;
}
extern "C" {
    pub fn phy_restart_aneg(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn phy_reset_after_clk_enable(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn phy_start_cable_test(
        phydev: *mut phy_device,
        extack: *mut netlink_ext_ack,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_start_cable_test_tdr(
        phydev: *mut phy_device,
        extack: *mut netlink_ext_ack,
        config: *const phy_tdr_config,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_attached_print(phydev: *mut phy_device, fmt: *const ffi::c_char, ...);
}
extern "C" {
    pub fn phy_attached_info_irq(phydev: *mut phy_device) -> *mut ffi::c_char;
}
extern "C" {
    pub fn phy_attached_info(phydev: *mut phy_device);
}
extern "C" {
    pub fn genphy_read_abilities(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_setup_forced(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_restart_aneg(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_check_and_restart_aneg(phydev: *mut phy_device, restart: bool_) -> ffi::c_int;
}
extern "C" {
    pub fn __genphy_config_aneg(phydev: *mut phy_device, changed: bool_) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_aneg_done(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_update_link(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_read_lpa(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_read_status_fixed(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_read_status(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_read_master_slave(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_suspend(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_resume(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_loopback(phydev: *mut phy_device, enable: bool_, speed: ffi::c_int)
        -> ffi::c_int;
}
extern "C" {
    pub fn genphy_soft_reset(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_handle_interrupt_no_ack(phydev: *mut phy_device) -> irqreturn_t;
}
extern "C" {
    pub fn genphy_read_mmd_unsupported(
        phdev: *mut phy_device,
        devad: ffi::c_int,
        regnum: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_write_mmd_unsupported(
        phdev: *mut phy_device,
        devnum: ffi::c_int,
        regnum: u16_,
        val: u16_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c37_config_aneg(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c37_read_status(phydev: *mut phy_device, changed: *mut bool_) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_restart_aneg(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_check_and_restart_aneg(phydev: *mut phy_device, restart: bool_)
        -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_aneg_done(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_read_link(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_read_lpa(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_read_pma(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_pma_setup_forced(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_pma_baset1_setup_master_slave(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_an_config_aneg(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_an_disable_aneg(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_read_mdix(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_pma_read_abilities(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_pma_read_ext_abilities(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_pma_baset1_read_abilities(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_read_eee_abilities(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_pma_baset1_read_master_slave(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_read_status(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_baset1_read_status(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_config_aneg(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_loopback(
        phydev: *mut phy_device,
        enable: bool_,
        speed: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_pma_resume(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_pma_suspend(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_fast_retrain(phydev: *mut phy_device, enable: bool_) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_plca_get_cfg(
        phydev: *mut phy_device,
        plca_cfg: *mut phy_plca_cfg,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_plca_set_cfg(
        phydev: *mut phy_device,
        plca_cfg: *const phy_plca_cfg,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_plca_get_status(
        phydev: *mut phy_device,
        plca_st: *mut phy_plca_status,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_eee_is_active(phydev: *mut phy_device, lp: *mut ffi::c_ulong) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_ethtool_get_eee(
        phydev: *mut phy_device,
        data: *mut ethtool_keee,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_ethtool_set_eee(
        phydev: *mut phy_device,
        data: *mut ethtool_keee,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn genphy_c45_an_config_eee_aneg(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub static mut genphy_c45_driver: phy_driver;
}
extern "C" {
    pub fn gen10g_config_aneg(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn phy_driver_unregister(drv: *mut phy_driver);
}
extern "C" {
    pub fn phy_drivers_unregister(drv: *mut phy_driver, n: ffi::c_int);
}
extern "C" {
    pub fn phy_driver_register(new_driver: *mut phy_driver, owner: *mut module) -> ffi::c_int;
}
extern "C" {
    pub fn phy_drivers_register(
        new_driver: *mut phy_driver,
        n: ffi::c_int,
        owner: *mut module,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_error(phydev: *mut phy_device);
}
extern "C" {
    pub fn phy_state_machine(work: *mut work_struct);
}
extern "C" {
    pub fn phy_trigger_machine(phydev: *mut phy_device);
}
extern "C" {
    pub fn phy_mac_interrupt(phydev: *mut phy_device);
}
extern "C" {
    pub fn phy_start_machine(phydev: *mut phy_device);
}
extern "C" {
    pub fn phy_stop_machine(phydev: *mut phy_device);
}
extern "C" {
    pub fn phy_ethtool_ksettings_get(phydev: *mut phy_device, cmd: *mut ethtool_link_ksettings);
}
extern "C" {
    pub fn phy_ethtool_ksettings_set(
        phydev: *mut phy_device,
        cmd: *const ethtool_link_ksettings,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_mii_ioctl(phydev: *mut phy_device, ifr: *mut ifreq, cmd: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn phy_do_ioctl(dev: *mut net_device, ifr: *mut ifreq, cmd: ffi::c_int) -> ffi::c_int;
}
extern "C" {
    pub fn phy_do_ioctl_running(
        dev: *mut net_device,
        ifr: *mut ifreq,
        cmd: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_disable_interrupts(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn phy_request_interrupt(phydev: *mut phy_device);
}
extern "C" {
    pub fn phy_free_interrupt(phydev: *mut phy_device);
}
extern "C" {
    pub fn phy_print_status(phydev: *mut phy_device);
}
extern "C" {
    pub fn phy_get_rate_matching(phydev: *mut phy_device, iface: phy_interface_t) -> ffi::c_int;
}
extern "C" {
    pub fn phy_set_max_speed(phydev: *mut phy_device, max_speed: u32_);
}
extern "C" {
    pub fn phy_remove_link_mode(phydev: *mut phy_device, link_mode: u32_);
}
extern "C" {
    pub fn phy_advertise_supported(phydev: *mut phy_device);
}
extern "C" {
    pub fn phy_advertise_eee_all(phydev: *mut phy_device);
}
extern "C" {
    pub fn phy_support_sym_pause(phydev: *mut phy_device);
}
extern "C" {
    pub fn phy_support_asym_pause(phydev: *mut phy_device);
}
extern "C" {
    pub fn phy_support_eee(phydev: *mut phy_device);
}
extern "C" {
    pub fn phy_disable_eee(phydev: *mut phy_device);
}
extern "C" {
    pub fn phy_set_sym_pause(phydev: *mut phy_device, rx: bool_, tx: bool_, autoneg: bool_);
}
extern "C" {
    pub fn phy_set_asym_pause(phydev: *mut phy_device, rx: bool_, tx: bool_);
}
extern "C" {
    pub fn phy_validate_pause(phydev: *mut phy_device, pp: *mut ethtool_pauseparam) -> bool_;
}
extern "C" {
    pub fn phy_get_pause(phydev: *mut phy_device, tx_pause: *mut bool_, rx_pause: *mut bool_);
}
extern "C" {
    pub fn phy_get_internal_delay(
        phydev: *mut phy_device,
        dev: *mut device,
        delay_values: *const ffi::c_int,
        size: ffi::c_int,
        is_rx: bool_,
    ) -> s32;
}
extern "C" {
    pub fn phy_get_tx_amplitude_gain(
        phydev: *mut phy_device,
        dev: *mut device,
        linkmode: ethtool_link_mode_bit_indices,
        val: *mut u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_resolve_pause(
        local_adv: *mut ffi::c_ulong,
        partner_adv: *mut ffi::c_ulong,
        tx_pause: *mut bool_,
        rx_pause: *mut bool_,
    );
}
extern "C" {
    pub fn phy_register_fixup_for_id(
        bus_id: *const ffi::c_char,
        run: ::core::option::Option<unsafe extern "C" fn(arg1: *mut phy_device) -> ffi::c_int>,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_register_fixup_for_uid(
        phy_uid: u32_,
        phy_uid_mask: u32_,
        run: ::core::option::Option<unsafe extern "C" fn(arg1: *mut phy_device) -> ffi::c_int>,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_unregister_fixup(
        bus_id: *const ffi::c_char,
        phy_uid: u32_,
        phy_uid_mask: u32_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_unregister_fixup_for_id(bus_id: *const ffi::c_char) -> ffi::c_int;
}
extern "C" {
    pub fn phy_unregister_fixup_for_uid(phy_uid: u32_, phy_uid_mask: u32_) -> ffi::c_int;
}
extern "C" {
    pub fn phy_eee_tx_clock_stop_capable(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn phy_eee_rx_clock_stop(phydev: *mut phy_device, clk_stop_enable: bool_) -> ffi::c_int;
}
extern "C" {
    pub fn phy_init_eee(phydev: *mut phy_device, clk_stop_enable: bool_) -> ffi::c_int;
}
extern "C" {
    pub fn phy_get_eee_err(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn phy_ethtool_set_eee(phydev: *mut phy_device, data: *mut ethtool_keee) -> ffi::c_int;
}
extern "C" {
    pub fn phy_ethtool_get_eee(phydev: *mut phy_device, data: *mut ethtool_keee) -> ffi::c_int;
}
extern "C" {
    pub fn phy_ethtool_set_wol(phydev: *mut phy_device, wol: *mut ethtool_wolinfo) -> ffi::c_int;
}
extern "C" {
    pub fn phy_ethtool_get_wol(phydev: *mut phy_device, wol: *mut ethtool_wolinfo);
}
extern "C" {
    pub fn phy_ethtool_get_link_ksettings(
        ndev: *mut net_device,
        cmd: *mut ethtool_link_ksettings,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_ethtool_set_link_ksettings(
        ndev: *mut net_device,
        cmd: *const ethtool_link_ksettings,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_ethtool_nway_reset(ndev: *mut net_device) -> ffi::c_int;
}
extern "C" {
    pub fn mdio_bus_init() -> ffi::c_int;
}
extern "C" {
    pub fn mdio_bus_exit();
}
extern "C" {
    pub fn phy_ethtool_get_strings(phydev: *mut phy_device, data: *mut u8_) -> ffi::c_int;
}
extern "C" {
    pub fn phy_ethtool_get_sset_count(phydev: *mut phy_device) -> ffi::c_int;
}
extern "C" {
    pub fn phy_ethtool_get_stats(
        phydev: *mut phy_device,
        stats: *mut ethtool_stats,
        data: *mut u64_,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __phy_ethtool_get_phy_stats(
        phydev: *mut phy_device,
        phy_stats: *mut ethtool_eth_phy_stats,
        phydev_stats: *mut ethtool_phy_stats,
    );
}
extern "C" {
    pub fn __phy_ethtool_get_link_ext_stats(
        phydev: *mut phy_device,
        link_stats: *mut ethtool_link_ext_stats,
    );
}
extern "C" {
    pub fn phy_ethtool_get_plca_cfg(
        phydev: *mut phy_device,
        plca_cfg: *mut phy_plca_cfg,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_ethtool_set_plca_cfg(
        phydev: *mut phy_device,
        plca_cfg: *const phy_plca_cfg,
        extack: *mut netlink_ext_ack,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn phy_ethtool_get_plca_status(
        phydev: *mut phy_device,
        plca_st: *mut phy_plca_status,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __phy_hwtstamp_get(
        phydev: *mut phy_device,
        config: *mut kernel_hwtstamp_config,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __phy_hwtstamp_set(
        phydev: *mut phy_device,
        config: *mut kernel_hwtstamp_config,
        extack: *mut netlink_ext_ack,
    ) -> ffi::c_int;
}
extern "C" {
    pub static mdio_bus_type: bus_type;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mdio_board_info {
    pub bus_id: *const ffi::c_char,
    pub modalias: [ffi::c_char; 32usize],
    pub mdio_addr: ffi::c_int,
    pub platform_data: *const ffi::c_void,
}
impl Default for mdio_board_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn mdiobus_register_board_info(info: *const mdio_board_info, n: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn phy_driver_is_genphy(phydev: *mut phy_device) -> bool_;
}
extern "C" {
    pub fn phy_driver_is_genphy_10g(phydev: *mut phy_device) -> bool_;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mfd_cell {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct platform_device {
    pub name: *const ffi::c_char,
    pub id: ffi::c_int,
    pub id_auto: bool_,
    pub dev: device,
    pub platform_dma_mask: u64_,
    pub dma_parms: device_dma_parameters,
    pub num_resources: u32_,
    pub resource: *mut resource,
    pub id_entry: *const platform_device_id,
    pub driver_override: *const ffi::c_char,
    pub mfd_cell: *mut mfd_cell,
    pub archdata: pdev_archdata,
}
impl Default for platform_device {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn platform_device_register(arg1: *mut platform_device) -> ffi::c_int;
}
extern "C" {
    pub fn platform_device_unregister(arg1: *mut platform_device);
}
extern "C" {
    pub static platform_bus_type: bus_type;
}
extern "C" {
    pub static mut platform_bus: device;
}
extern "C" {
    pub fn platform_get_resource(
        arg1: *mut platform_device,
        arg2: ffi::c_uint,
        arg3: ffi::c_uint,
    ) -> *mut resource;
}
extern "C" {
    pub fn platform_get_mem_or_io(arg1: *mut platform_device, arg2: ffi::c_uint) -> *mut resource;
}
extern "C" {
    pub fn platform_find_device_by_driver(
        start: *mut device,
        drv: *const device_driver,
    ) -> *mut device;
}
extern "C" {
    pub fn devm_platform_get_and_ioremap_resource(
        pdev: *mut platform_device,
        index: ffi::c_uint,
        res: *mut *mut resource,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn devm_platform_ioremap_resource(
        pdev: *mut platform_device,
        index: ffi::c_uint,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn devm_platform_ioremap_resource_byname(
        pdev: *mut platform_device,
        name: *const ffi::c_char,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn platform_get_irq(arg1: *mut platform_device, arg2: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn platform_get_irq_optional(arg1: *mut platform_device, arg2: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn platform_irq_count(arg1: *mut platform_device) -> ffi::c_int;
}
extern "C" {
    pub fn devm_platform_get_irqs_affinity(
        dev: *mut platform_device,
        affd: *mut irq_affinity,
        minvec: ffi::c_uint,
        maxvec: ffi::c_uint,
        irqs: *mut *mut ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn platform_get_resource_byname(
        arg1: *mut platform_device,
        arg2: ffi::c_uint,
        arg3: *const ffi::c_char,
    ) -> *mut resource;
}
extern "C" {
    pub fn platform_get_irq_byname(
        arg1: *mut platform_device,
        arg2: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn platform_get_irq_byname_optional(
        dev: *mut platform_device,
        name: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn platform_add_devices(arg1: *mut *mut platform_device, arg2: ffi::c_int) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct platform_device_info {
    pub parent: *mut device,
    pub fwnode: *mut fwnode_handle,
    pub of_node_reused: bool_,
    pub name: *const ffi::c_char,
    pub id: ffi::c_int,
    pub res: *const resource,
    pub num_res: ffi::c_uint,
    pub data: *const ffi::c_void,
    pub size_data: usize,
    pub dma_mask: u64_,
    pub properties: *const property_entry,
}
impl Default for platform_device_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn platform_device_register_full(
        pdevinfo: *const platform_device_info,
    ) -> *mut platform_device;
}
extern "C" {
    pub fn platform_device_alloc(name: *const ffi::c_char, id: ffi::c_int) -> *mut platform_device;
}
extern "C" {
    pub fn platform_device_add_resources(
        pdev: *mut platform_device,
        res: *const resource,
        num: ffi::c_uint,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn platform_device_add_data(
        pdev: *mut platform_device,
        data: *const ffi::c_void,
        size: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn platform_device_add(pdev: *mut platform_device) -> ffi::c_int;
}
extern "C" {
    pub fn platform_device_del(pdev: *mut platform_device);
}
extern "C" {
    pub fn platform_device_put(pdev: *mut platform_device);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct platform_driver {
    pub probe:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut platform_device) -> ffi::c_int>,
    pub remove: ::core::option::Option<unsafe extern "C" fn(arg1: *mut platform_device)>,
    pub shutdown: ::core::option::Option<unsafe extern "C" fn(arg1: *mut platform_device)>,
    pub suspend: ::core::option::Option<
        unsafe extern "C" fn(arg1: *mut platform_device, state: pm_message_t) -> ffi::c_int,
    >,
    pub resume:
        ::core::option::Option<unsafe extern "C" fn(arg1: *mut platform_device) -> ffi::c_int>,
    pub driver: device_driver,
    pub id_table: *const platform_device_id,
    pub prevent_deferred_probe: bool_,
    pub driver_managed_dma: bool_,
}
impl Default for platform_driver {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn __platform_driver_register(arg1: *mut platform_driver, arg2: *mut module) -> ffi::c_int;
}
extern "C" {
    pub fn platform_driver_unregister(arg1: *mut platform_driver);
}
extern "C" {
    pub fn __platform_driver_probe(
        driver: *mut platform_driver,
        probe: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut platform_device) -> ffi::c_int,
        >,
        module: *mut module,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn __platform_create_bundle(
        driver: *mut platform_driver,
        probe: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut platform_device) -> ffi::c_int,
        >,
        res: *mut resource,
        n_res: ffi::c_uint,
        data: *const ffi::c_void,
        size: usize,
        module: *mut module,
    ) -> *mut platform_device;
}
extern "C" {
    pub fn __platform_register_drivers(
        drivers: *const *mut platform_driver,
        count: ffi::c_uint,
        owner: *mut module,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn platform_unregister_drivers(drivers: *const *mut platform_driver, count: ffi::c_uint);
}
extern "C" {
    pub fn platform_pm_suspend(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn platform_pm_resume(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn platform_pm_freeze(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn platform_pm_thaw(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn platform_pm_poweroff(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn platform_pm_restore(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn early_platform_cleanup();
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pollfd {
    pub fd: ffi::c_int,
    pub events: ffi::c_short,
    pub revents: ffi::c_short,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct epoll_event {
    pub events: __poll_t,
    pub data: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct epoll_params {
    pub busy_poll_usecs: __u32,
    pub busy_poll_budget: __u16,
    pub prefer_busy_poll: __u8,
    pub __pad: __u8,
}
pub type poll_queue_proc = ::core::option::Option<
    unsafe extern "C" fn(
        arg1: *mut file,
        arg2: *mut wait_queue_head_t,
        arg3: *mut poll_table_struct,
    ),
>;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct poll_table_struct {
    pub _qproc: poll_queue_proc,
    pub _key: __poll_t,
}
pub type poll_table = poll_table_struct;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct poll_table_entry {
    pub filp: *mut file,
    pub key: __poll_t,
    pub wait: wait_queue_entry_t,
    pub wait_address: *mut wait_queue_head_t,
}
impl Default for poll_table_entry {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct poll_wqueues {
    pub pt: poll_table,
    pub table: *mut poll_table_page,
    pub polling_task: *mut task_struct,
    pub triggered: ffi::c_int,
    pub error: ffi::c_int,
    pub inline_index: ffi::c_int,
    pub inline_entries: [poll_table_entry; 9usize],
}
impl Default for poll_wqueues {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn poll_initwait(pwq: *mut poll_wqueues);
}
extern "C" {
    pub fn poll_freewait(pwq: *mut poll_wqueues);
}
extern "C" {
    pub fn select_estimate_accuracy(tv: *mut timespec64) -> u64_;
}
extern "C" {
    pub fn core_sys_select(
        n: ffi::c_int,
        inp: *mut fd_set,
        outp: *mut fd_set,
        exp: *mut fd_set,
        end_time: *mut timespec64,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn poll_select_set_timeout(
        to: *mut timespec64,
        sec: time64_t,
        nsec: ffi::c_long,
    ) -> ffi::c_int;
}
pub const dev_prop_type_DEV_PROP_U8: dev_prop_type = 0;
pub const dev_prop_type_DEV_PROP_U16: dev_prop_type = 1;
pub const dev_prop_type_DEV_PROP_U32: dev_prop_type = 2;
pub const dev_prop_type_DEV_PROP_U64: dev_prop_type = 3;
pub const dev_prop_type_DEV_PROP_STRING: dev_prop_type = 4;
pub const dev_prop_type_DEV_PROP_REF: dev_prop_type = 5;
pub type dev_prop_type = ffi::c_uint;
extern "C" {
    pub fn __dev_fwnode_const(dev: *const device) -> *const fwnode_handle;
}
extern "C" {
    pub fn __dev_fwnode(dev: *mut device) -> *mut fwnode_handle;
}
extern "C" {
    pub fn device_property_present(dev: *const device, propname: *const ffi::c_char) -> bool_;
}
extern "C" {
    pub fn device_property_read_bool(dev: *const device, propname: *const ffi::c_char) -> bool_;
}
extern "C" {
    pub fn device_property_read_u8_array(
        dev: *const device,
        propname: *const ffi::c_char,
        val: *mut u8_,
        nval: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn device_property_read_u16_array(
        dev: *const device,
        propname: *const ffi::c_char,
        val: *mut u16_,
        nval: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn device_property_read_u32_array(
        dev: *const device,
        propname: *const ffi::c_char,
        val: *mut u32_,
        nval: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn device_property_read_u64_array(
        dev: *const device,
        propname: *const ffi::c_char,
        val: *mut u64_,
        nval: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn device_property_read_string_array(
        dev: *const device,
        propname: *const ffi::c_char,
        val: *mut *const ffi::c_char,
        nval: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn device_property_read_string(
        dev: *const device,
        propname: *const ffi::c_char,
        val: *mut *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn device_property_match_string(
        dev: *const device,
        propname: *const ffi::c_char,
        string: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn fwnode_property_present(
        fwnode: *const fwnode_handle,
        propname: *const ffi::c_char,
    ) -> bool_;
}
extern "C" {
    pub fn fwnode_property_read_bool(
        fwnode: *const fwnode_handle,
        propname: *const ffi::c_char,
    ) -> bool_;
}
extern "C" {
    pub fn fwnode_property_read_u8_array(
        fwnode: *const fwnode_handle,
        propname: *const ffi::c_char,
        val: *mut u8_,
        nval: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn fwnode_property_read_u16_array(
        fwnode: *const fwnode_handle,
        propname: *const ffi::c_char,
        val: *mut u16_,
        nval: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn fwnode_property_read_u32_array(
        fwnode: *const fwnode_handle,
        propname: *const ffi::c_char,
        val: *mut u32_,
        nval: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn fwnode_property_read_u64_array(
        fwnode: *const fwnode_handle,
        propname: *const ffi::c_char,
        val: *mut u64_,
        nval: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn fwnode_property_read_string_array(
        fwnode: *const fwnode_handle,
        propname: *const ffi::c_char,
        val: *mut *const ffi::c_char,
        nval: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn fwnode_property_read_string(
        fwnode: *const fwnode_handle,
        propname: *const ffi::c_char,
        val: *mut *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn fwnode_property_match_string(
        fwnode: *const fwnode_handle,
        propname: *const ffi::c_char,
        string: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn fwnode_device_is_available(fwnode: *const fwnode_handle) -> bool_;
}
extern "C" {
    pub fn fwnode_property_match_property_string(
        fwnode: *const fwnode_handle,
        propname: *const ffi::c_char,
        array: *const *const ffi::c_char,
        n: usize,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn fwnode_property_get_reference_args(
        fwnode: *const fwnode_handle,
        prop: *const ffi::c_char,
        nargs_prop: *const ffi::c_char,
        nargs: ffi::c_uint,
        index: ffi::c_uint,
        args: *mut fwnode_reference_args,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn fwnode_find_reference(
        fwnode: *const fwnode_handle,
        name: *const ffi::c_char,
        index: ffi::c_uint,
    ) -> *mut fwnode_handle;
}
extern "C" {
    pub fn fwnode_get_name(fwnode: *const fwnode_handle) -> *const ffi::c_char;
}
extern "C" {
    pub fn fwnode_get_name_prefix(fwnode: *const fwnode_handle) -> *const ffi::c_char;
}
extern "C" {
    pub fn fwnode_name_eq(fwnode: *const fwnode_handle, name: *const ffi::c_char) -> bool_;
}
extern "C" {
    pub fn fwnode_get_parent(fwnode: *const fwnode_handle) -> *mut fwnode_handle;
}
extern "C" {
    pub fn fwnode_get_next_parent(fwnode: *mut fwnode_handle) -> *mut fwnode_handle;
}
extern "C" {
    pub fn fwnode_count_parents(fwn: *const fwnode_handle) -> ffi::c_uint;
}
extern "C" {
    pub fn fwnode_get_nth_parent(fwn: *mut fwnode_handle, depth: ffi::c_uint)
        -> *mut fwnode_handle;
}
extern "C" {
    pub fn fwnode_get_next_child_node(
        fwnode: *const fwnode_handle,
        child: *mut fwnode_handle,
    ) -> *mut fwnode_handle;
}
extern "C" {
    pub fn fwnode_get_next_available_child_node(
        fwnode: *const fwnode_handle,
        child: *mut fwnode_handle,
    ) -> *mut fwnode_handle;
}
extern "C" {
    pub fn device_get_next_child_node(
        dev: *const device,
        child: *mut fwnode_handle,
    ) -> *mut fwnode_handle;
}
extern "C" {
    pub fn fwnode_get_named_child_node(
        fwnode: *const fwnode_handle,
        childname: *const ffi::c_char,
    ) -> *mut fwnode_handle;
}
extern "C" {
    pub fn device_get_named_child_node(
        dev: *const device,
        childname: *const ffi::c_char,
    ) -> *mut fwnode_handle;
}
extern "C" {
    pub fn fwnode_handle_get(fwnode: *mut fwnode_handle) -> *mut fwnode_handle;
}
extern "C" {
    pub fn fwnode_irq_get(fwnode: *const fwnode_handle, index: ffi::c_uint) -> ffi::c_int;
}
extern "C" {
    pub fn fwnode_irq_get_byname(
        fwnode: *const fwnode_handle,
        name: *const ffi::c_char,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn device_get_child_node_count(dev: *const device) -> ffi::c_uint;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct software_node_ref_args {
    pub node: *const software_node,
    pub nargs: ffi::c_uint,
    pub args: [u64_; 16usize],
}
impl Default for software_node_ref_args {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct property_entry {
    pub name: *const ffi::c_char,
    pub length: usize,
    pub is_inline: bool_,
    pub type_: dev_prop_type,
    pub __bindgen_anon_1: property_entry__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union property_entry__bindgen_ty_1 {
    pub pointer: *const ffi::c_void,
    pub value: property_entry__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union property_entry__bindgen_ty_1__bindgen_ty_1 {
    pub u8_data: [u8_; 8usize],
    pub u16_data: [u16_; 4usize],
    pub u32_data: [u32_; 2usize],
    pub u64_data: [u64_; 1usize],
    pub str_: [*const ffi::c_char; 1usize],
}
impl Default for property_entry__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for property_entry__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for property_entry {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn property_entries_dup(properties: *const property_entry) -> *mut property_entry;
}
extern "C" {
    pub fn property_entries_free(properties: *const property_entry);
}
extern "C" {
    pub fn device_dma_supported(dev: *const device) -> bool_;
}
extern "C" {
    pub fn device_get_dma_attr(dev: *const device) -> dev_dma_attr;
}
extern "C" {
    pub fn device_get_match_data(dev: *const device) -> *const ffi::c_void;
}
extern "C" {
    pub fn device_get_phy_mode(dev: *mut device) -> ffi::c_int;
}
extern "C" {
    pub fn fwnode_get_phy_mode(fwnode: *const fwnode_handle) -> ffi::c_int;
}
extern "C" {
    pub fn fwnode_iomap(fwnode: *mut fwnode_handle, index: ffi::c_int) -> *mut ffi::c_void;
}
extern "C" {
    pub fn fwnode_graph_get_next_endpoint(
        fwnode: *const fwnode_handle,
        prev: *mut fwnode_handle,
    ) -> *mut fwnode_handle;
}
extern "C" {
    pub fn fwnode_graph_get_port_parent(fwnode: *const fwnode_handle) -> *mut fwnode_handle;
}
extern "C" {
    pub fn fwnode_graph_get_remote_port_parent(fwnode: *const fwnode_handle) -> *mut fwnode_handle;
}
extern "C" {
    pub fn fwnode_graph_get_remote_port(fwnode: *const fwnode_handle) -> *mut fwnode_handle;
}
extern "C" {
    pub fn fwnode_graph_get_remote_endpoint(fwnode: *const fwnode_handle) -> *mut fwnode_handle;
}
extern "C" {
    pub fn fwnode_graph_get_endpoint_by_id(
        fwnode: *const fwnode_handle,
        port: u32_,
        endpoint: u32_,
        flags: ffi::c_ulong,
    ) -> *mut fwnode_handle;
}
extern "C" {
    pub fn fwnode_graph_get_endpoint_count(
        fwnode: *const fwnode_handle,
        flags: ffi::c_ulong,
    ) -> ffi::c_uint;
}
extern "C" {
    pub fn fwnode_graph_parse_endpoint(
        fwnode: *const fwnode_handle,
        endpoint: *mut fwnode_endpoint,
    ) -> ffi::c_int;
}
pub type devcon_match_fn_t = ::core::option::Option<
    unsafe extern "C" fn(
        fwnode: *const fwnode_handle,
        id: *const ffi::c_char,
        data: *mut ffi::c_void,
    ) -> *mut ffi::c_void,
>;
extern "C" {
    pub fn fwnode_connection_find_match(
        fwnode: *const fwnode_handle,
        con_id: *const ffi::c_char,
        data: *mut ffi::c_void,
        match_: devcon_match_fn_t,
    ) -> *mut ffi::c_void;
}
extern "C" {
    pub fn fwnode_connection_find_matches(
        fwnode: *const fwnode_handle,
        con_id: *const ffi::c_char,
        data: *mut ffi::c_void,
        match_: devcon_match_fn_t,
        matches: *mut *mut ffi::c_void,
        matches_len: ffi::c_uint,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct software_node {
    pub name: *const ffi::c_char,
    pub parent: *const software_node,
    pub properties: *const property_entry,
}
impl Default for software_node {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn is_software_node(fwnode: *const fwnode_handle) -> bool_;
}
extern "C" {
    pub fn to_software_node(fwnode: *const fwnode_handle) -> *const software_node;
}
extern "C" {
    pub fn software_node_fwnode(node: *const software_node) -> *mut fwnode_handle;
}
extern "C" {
    pub fn software_node_find_by_name(
        parent: *const software_node,
        name: *const ffi::c_char,
    ) -> *const software_node;
}
extern "C" {
    pub fn software_node_register_node_group(node_group: *mut *const software_node) -> ffi::c_int;
}
extern "C" {
    pub fn software_node_unregister_node_group(node_group: *mut *const software_node);
}
extern "C" {
    pub fn software_node_register(node: *const software_node) -> ffi::c_int;
}
extern "C" {
    pub fn software_node_unregister(node: *const software_node);
}
extern "C" {
    pub fn fwnode_create_software_node(
        properties: *const property_entry,
        parent: *const fwnode_handle,
    ) -> *mut fwnode_handle;
}
extern "C" {
    pub fn fwnode_remove_software_node(fwnode: *mut fwnode_handle);
}
extern "C" {
    pub fn device_add_software_node(dev: *mut device, node: *const software_node) -> ffi::c_int;
}
extern "C" {
    pub fn device_remove_software_node(dev: *mut device);
}
extern "C" {
    pub fn device_create_managed_software_node(
        dev: *mut device,
        properties: *const property_entry,
        parent: *const software_node,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct trace_eval_map {
    pub system: *const ffi::c_char,
    pub eval_string: *const ffi::c_char,
    pub eval_value: ffi::c_ulong,
}
impl Default for trace_eval_map {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn tracepoint_probe_register(
        tp: *mut tracepoint,
        probe: *mut ffi::c_void,
        data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn tracepoint_probe_register_prio(
        tp: *mut tracepoint,
        probe: *mut ffi::c_void,
        data: *mut ffi::c_void,
        prio: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn tracepoint_probe_register_prio_may_exist(
        tp: *mut tracepoint,
        probe: *mut ffi::c_void,
        data: *mut ffi::c_void,
        prio: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn tracepoint_probe_unregister(
        tp: *mut tracepoint,
        probe: *mut ffi::c_void,
        data: *mut ffi::c_void,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn for_each_kernel_tracepoint(
        fct: ::core::option::Option<
            unsafe extern "C" fn(tp: *mut tracepoint, priv_: *mut ffi::c_void),
        >,
        priv_: *mut ffi::c_void,
    );
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tp_module {
    pub list: list_head,
    pub mod_: *mut module,
}
impl Default for tp_module {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn trace_module_has_bad_taint(mod_: *mut module) -> bool_;
}
extern "C" {
    pub fn register_tracepoint_module_notifier(nb: *mut notifier_block) -> ffi::c_int;
}
extern "C" {
    pub fn unregister_tracepoint_module_notifier(nb: *mut notifier_block) -> ffi::c_int;
}
extern "C" {
    pub fn for_each_module_tracepoint(
        fct: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut tracepoint, arg2: *mut module, arg3: *mut ffi::c_void),
        >,
        priv_: *mut ffi::c_void,
    );
}
extern "C" {
    pub fn for_each_tracepoint_in_module(
        arg1: *mut module,
        fct: ::core::option::Option<
            unsafe extern "C" fn(arg1: *mut tracepoint, arg2: *mut module, arg3: *mut ffi::c_void),
        >,
        priv_: *mut ffi::c_void,
    );
}
extern "C" {
    pub fn syscall_regfunc() -> ffi::c_int;
}
extern "C" {
    pub fn syscall_unregfunc();
}
extern "C" {
    pub fn __traceiter_rust_sample_loaded(
        __data: *mut ffi::c_void,
        magic_number: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub static mut __SCK__tp_func_rust_sample_loaded: static_call_key;
}
extern "C" {
    pub fn __SCT__tp_func_rust_sample_loaded(
        arg1: *mut ffi::c_void,
        arg2: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub static mut __tracepoint_rust_sample_loaded: tracepoint;
}
extern "C" {
    pub fn rust_do_trace_rust_sample_loaded(magic_number: ffi::c_int);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct iosys_map {
    pub __bindgen_anon_1: iosys_map__bindgen_ty_1,
    pub is_iomem: bool_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union iosys_map__bindgen_ty_1 {
    pub vaddr_iomem: *mut ffi::c_void,
    pub vaddr: *mut ffi::c_void,
}
impl Default for iosys_map__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for iosys_map {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type depot_stack_handle_t = u32_;
#[repr(C)]
#[derive(Copy, Clone)]
pub union handle_parts {
    pub handle: depot_stack_handle_t,
    pub __bindgen_anon_1: handle_parts__bindgen_ty_1,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct handle_parts__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
impl handle_parts__bindgen_ty_1 {
    #[inline]
    pub fn pool_index_plus_1(&self) -> u32_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(0usize, 17u8) as u32) }
    }
    #[inline]
    pub fn set_pool_index_plus_1(&mut self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(0usize, 17u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn pool_index_plus_1_raw(this: *const Self) -> u32_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                17u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_pool_index_plus_1_raw(this: *mut Self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                17u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn offset(&self) -> u32_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(17usize, 10u8) as u32) }
    }
    #[inline]
    pub fn set_offset(&mut self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(17usize, 10u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn offset_raw(this: *const Self) -> u32_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                17usize,
                10u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_offset_raw(this: *mut Self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                17usize,
                10u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn extra(&self) -> u32_ {
        unsafe { ::core::mem::transmute(self._bitfield_1.get(27usize, 5u8) as u32) }
    }
    #[inline]
    pub fn set_extra(&mut self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            self._bitfield_1.set(27usize, 5u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn extra_raw(this: *const Self) -> u32_ {
        unsafe {
            ::core::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::core::ptr::addr_of!((*this)._bitfield_1),
                27usize,
                5u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_extra_raw(this: *mut Self, val: u32_) {
        unsafe {
            let val: u32 = ::core::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::core::ptr::addr_of_mut!((*this)._bitfield_1),
                27usize,
                5u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        pool_index_plus_1: u32_,
        offset: u32_,
        extra: u32_,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 17u8, {
            let pool_index_plus_1: u32 = unsafe { ::core::mem::transmute(pool_index_plus_1) };
            pool_index_plus_1 as u64
        });
        __bindgen_bitfield_unit.set(17usize, 10u8, {
            let offset: u32 = unsafe { ::core::mem::transmute(offset) };
            offset as u64
        });
        __bindgen_bitfield_unit.set(27usize, 5u8, {
            let extra: u32 = unsafe { ::core::mem::transmute(extra) };
            extra as u64
        });
        __bindgen_bitfield_unit
    }
}
impl Default for handle_parts {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct stack_record {
    pub hash_list: list_head,
    pub hash: u32_,
    pub size: u32_,
    pub handle: handle_parts,
    pub count: refcount_t,
    pub __bindgen_anon_1: stack_record__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union stack_record__bindgen_ty_1 {
    pub entries: [ffi::c_ulong; 64usize],
    pub __bindgen_anon_1: stack_record__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct stack_record__bindgen_ty_1__bindgen_ty_1 {
    pub free_list: list_head,
    pub rcu_state: ffi::c_ulong,
}
impl Default for stack_record__bindgen_ty_1__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for stack_record__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for stack_record {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type depot_flags_t = u32_;
extern "C" {
    pub fn stack_depot_init() -> ffi::c_int;
}
extern "C" {
    pub fn stack_depot_request_early_init();
}
extern "C" {
    pub fn stack_depot_early_init() -> ffi::c_int;
}
extern "C" {
    pub fn stack_depot_save_flags(
        entries: *mut ffi::c_ulong,
        nr_entries: ffi::c_uint,
        alloc_flags: gfp_t,
        depot_flags: depot_flags_t,
    ) -> depot_stack_handle_t;
}
extern "C" {
    pub fn stack_depot_save(
        entries: *mut ffi::c_ulong,
        nr_entries: ffi::c_uint,
        alloc_flags: gfp_t,
    ) -> depot_stack_handle_t;
}
extern "C" {
    pub fn __stack_depot_get_stack_record(handle: depot_stack_handle_t) -> *mut stack_record;
}
extern "C" {
    pub fn stack_depot_fetch(
        handle: depot_stack_handle_t,
        entries: *mut *mut ffi::c_ulong,
    ) -> ffi::c_uint;
}
extern "C" {
    pub fn stack_depot_print(stack: depot_stack_handle_t);
}
extern "C" {
    pub fn stack_depot_snprint(
        handle: depot_stack_handle_t,
        buf: *mut ffi::c_char,
        size: usize,
        spaces: ffi::c_int,
    ) -> ffi::c_int;
}
extern "C" {
    pub fn stack_depot_put(handle: depot_stack_handle_t);
}
extern "C" {
    #[must_use]
    pub fn stack_depot_set_extra_bits(
        handle: depot_stack_handle_t,
        extra_bits: ffi::c_uint,
    ) -> depot_stack_handle_t;
}
extern "C" {
    pub fn stack_depot_get_extra_bits(handle: depot_stack_handle_t) -> ffi::c_uint;
}
extern "C" {
    pub static mut max_lock_depth: ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rt_mutex_base {
    pub wait_lock: raw_spinlock_t,
    pub waiters: rb_root_cached,
    pub owner: *mut task_struct,
}
impl Default for rt_mutex_base {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn rt_mutex_base_init(rtb: *mut rt_mutex_base);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rt_mutex {
    pub rtmutex: rt_mutex_base,
}
impl Default for rt_mutex {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct rt_mutex_waiter {
    _unused: [u8; 0],
}
extern "C" {
    pub fn __rt_mutex_init(lock: *mut rt_mutex, name: *const ffi::c_char, key: *mut lock_class_key);
}
extern "C" {
    pub fn rt_mutex_lock(lock: *mut rt_mutex);
}
extern "C" {
    pub fn rt_mutex_lock_interruptible(lock: *mut rt_mutex) -> ffi::c_int;
}
extern "C" {
    pub fn rt_mutex_lock_killable(lock: *mut rt_mutex) -> ffi::c_int;
}
extern "C" {
    pub fn rt_mutex_trylock(lock: *mut rt_mutex) -> ffi::c_int;
}
extern "C" {
    pub fn rt_mutex_unlock(lock: *mut rt_mutex);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ww_class {
    pub stamp: atomic_long_t,
    pub acquire_key: lock_class_key,
    pub mutex_key: lock_class_key,
    pub acquire_name: *const ffi::c_char,
    pub mutex_name: *const ffi::c_char,
    pub is_wait_die: ffi::c_uint,
}
impl Default for ww_class {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ww_mutex {
    pub base: mutex,
    pub ctx: *mut ww_acquire_ctx,
}
impl Default for ww_mutex {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ww_acquire_ctx {
    pub task: *mut task_struct,
    pub stamp: ffi::c_ulong,
    pub acquired: ffi::c_uint,
    pub wounded: ffi::c_ushort,
    pub is_wait_die: ffi::c_ushort,
}
impl Default for ww_acquire_ctx {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn ww_mutex_lock(lock: *mut ww_mutex, ctx: *mut ww_acquire_ctx) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn ww_mutex_lock_interruptible(lock: *mut ww_mutex, ctx: *mut ww_acquire_ctx)
        -> ffi::c_int;
}
extern "C" {
    pub fn ww_mutex_unlock(lock: *mut ww_mutex);
}
extern "C" {
    #[must_use]
    pub fn ww_mutex_trylock(lock: *mut ww_mutex, ctx: *mut ww_acquire_ctx) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_modeset_acquire_ctx {
    pub ww_ctx: ww_acquire_ctx,
    pub contended: *mut drm_modeset_lock,
    pub stack_depot: depot_stack_handle_t,
    pub locked: list_head,
    pub trylock_only: bool_,
    pub interruptible: bool_,
}
impl Default for drm_modeset_acquire_ctx {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_modeset_lock {
    pub mutex: ww_mutex,
    pub head: list_head,
}
impl Default for drm_modeset_lock {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn drm_modeset_acquire_init(ctx: *mut drm_modeset_acquire_ctx, flags: u32);
}
extern "C" {
    pub fn drm_modeset_acquire_fini(ctx: *mut drm_modeset_acquire_ctx);
}
extern "C" {
    pub fn drm_modeset_drop_locks(ctx: *mut drm_modeset_acquire_ctx);
}
extern "C" {
    pub fn drm_modeset_backoff(ctx: *mut drm_modeset_acquire_ctx) -> ffi::c_int;
}
extern "C" {
    pub fn drm_modeset_lock_init(lock: *mut drm_modeset_lock);
}
extern "C" {
    pub fn drm_modeset_lock(
        lock: *mut drm_modeset_lock,
        ctx: *mut drm_modeset_acquire_ctx,
    ) -> ffi::c_int;
}
extern "C" {
    #[must_use]
    pub fn drm_modeset_lock_single_interruptible(lock: *mut drm_modeset_lock) -> ffi::c_int;
}
extern "C" {
    pub fn drm_modeset_unlock(lock: *mut drm_modeset_lock);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_crtc {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_plane {
    _unused: [u8; 0],
}
extern "C" {
    pub fn drm_modeset_lock_all(dev: *mut drm_device);
}
extern "C" {
    pub fn drm_modeset_unlock_all(dev: *mut drm_device);
}
extern "C" {
    pub fn drm_warn_on_modeset_not_all_locked(dev: *mut drm_device);
}
extern "C" {
    pub fn drm_modeset_lock_all_ctx(
        dev: *mut drm_device,
        ctx: *mut drm_modeset_acquire_ctx,
    ) -> ffi::c_int;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_file {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_atomic_state {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_display_mode {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_config_funcs {
    pub fb_create: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut drm_device,
            file_priv: *mut drm_file,
            mode_cmd: *const drm_mode_fb_cmd2,
        ) -> *mut drm_framebuffer,
    >,
    pub get_format_info: ::core::option::Option<
        unsafe extern "C" fn(mode_cmd: *const drm_mode_fb_cmd2) -> *const drm_format_info,
    >,
    pub mode_valid: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut drm_device,
            mode: *const drm_display_mode,
        ) -> drm_mode_status,
    >,
    pub atomic_check: ::core::option::Option<
        unsafe extern "C" fn(dev: *mut drm_device, state: *mut drm_atomic_state) -> ffi::c_int,
    >,
    pub atomic_commit: ::core::option::Option<
        unsafe extern "C" fn(
            dev: *mut drm_device,
            state: *mut drm_atomic_state,
            nonblock: bool_,
        ) -> ffi::c_int,
    >,
    pub atomic_state_alloc:
        ::core::option::Option<unsafe extern "C" fn(dev: *mut drm_device) -> *mut drm_atomic_state>,
    pub atomic_state_clear:
        ::core::option::Option<unsafe extern "C" fn(state: *mut drm_atomic_state)>,
    pub atomic_state_free:
        ::core::option::Option<unsafe extern "C" fn(state: *mut drm_atomic_state)>,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_mode_config {
    pub mutex: mutex,
    pub connection_mutex: drm_modeset_lock,
    pub acquire_ctx: *mut drm_modeset_acquire_ctx,
    pub idr_mutex: mutex,
    pub object_idr: idr,
    pub tile_idr: idr,
    pub fb_lock: mutex,
    pub num_fb: ffi::c_int,
    pub fb_list: list_head,
    pub connector_list_lock: spinlock_t,
    pub num_connector: ffi::c_int,
    pub connector_ida: ida,
    pub connector_list: list_head,
    pub connector_free_list: llist_head,
    pub connector_free_work: work_struct,
    pub num_encoder: ffi::c_int,
    pub encoder_list: list_head,
    pub num_total_plane: ffi::c_int,
    pub plane_list: list_head,
    pub panic_lock: raw_spinlock,
    pub num_crtc: ffi::c_int,
    pub crtc_list: list_head,
    pub property_list: list_head,
    pub privobj_list: list_head,
    pub min_width: ffi::c_int,
    pub min_height: ffi::c_int,
    pub max_width: ffi::c_int,
    pub max_height: ffi::c_int,
    pub funcs: *const drm_mode_config_funcs,
    pub poll_enabled: bool_,
    pub poll_running: bool_,
    pub delayed_event: bool_,
    pub output_poll_work: delayed_work,
    pub blob_lock: mutex,
    pub property_blob_list: list_head,
    pub edid_property: *mut drm_property,
    pub dpms_property: *mut drm_property,
    pub path_property: *mut drm_property,
    pub tile_property: *mut drm_property,
    pub link_status_property: *mut drm_property,
    pub plane_type_property: *mut drm_property,
    pub prop_src_x: *mut drm_property,
    pub prop_src_y: *mut drm_property,
    pub prop_src_w: *mut drm_property,
    pub prop_src_h: *mut drm_property,
    pub prop_crtc_x: *mut drm_property,
    pub prop_crtc_y: *mut drm_property,
    pub prop_crtc_w: *mut drm_property,
    pub prop_crtc_h: *mut drm_property,
    pub prop_fb_id: *mut drm_property,
    pub prop_in_fence_fd: *mut drm_property,
    pub prop_out_fence_ptr: *mut drm_property,
    pub prop_crtc_id: *mut drm_property,
    pub prop_fb_damage_clips: *mut drm_property,
    pub prop_active: *mut drm_property,
    pub prop_mode_id: *mut drm_property,
    pub prop_vrr_enabled: *mut drm_property,
    pub dvi_i_subconnector_property: *mut drm_property,
    pub dvi_i_select_subconnector_property: *mut drm_property,
    pub dp_subconnector_property: *mut drm_property,
    pub tv_subconnector_property: *mut drm_property,
    pub tv_select_subconnector_property: *mut drm_property,
    pub legacy_tv_mode_property: *mut drm_property,
    pub tv_mode_property: *mut drm_property,
    pub tv_left_margin_property: *mut drm_property,
    pub tv_right_margin_property: *mut drm_property,
    pub tv_top_margin_property: *mut drm_property,
    pub tv_bottom_margin_property: *mut drm_property,
    pub tv_brightness_property: *mut drm_property,
    pub tv_contrast_property: *mut drm_property,
    pub tv_flicker_reduction_property: *mut drm_property,
    pub tv_overscan_property: *mut drm_property,
    pub tv_saturation_property: *mut drm_property,
    pub tv_hue_property: *mut drm_property,
    pub scaling_mode_property: *mut drm_property,
    pub aspect_ratio_property: *mut drm_property,
    pub content_type_property: *mut drm_property,
    pub degamma_lut_property: *mut drm_property,
    pub degamma_lut_size_property: *mut drm_property,
    pub ctm_property: *mut drm_property,
    pub gamma_lut_property: *mut drm_property,
    pub gamma_lut_size_property: *mut drm_property,
    pub suggested_x_property: *mut drm_property,
    pub suggested_y_property: *mut drm_property,
    pub non_desktop_property: *mut drm_property,
    pub panel_orientation_property: *mut drm_property,
    pub writeback_fb_id_property: *mut drm_property,
    pub writeback_pixel_formats_property: *mut drm_property,
    pub writeback_out_fence_ptr_property: *mut drm_property,
    pub hdr_output_metadata_property: *mut drm_property,
    pub content_protection_property: *mut drm_property,
    pub hdcp_content_type_property: *mut drm_property,
    pub preferred_depth: u32,
    pub prefer_shadow: u32,
    pub quirk_addfb_prefer_xbgr_30bpp: bool_,
    pub quirk_addfb_prefer_host_byte_order: bool_,
    pub async_page_flip: bool_,
    pub fb_modifiers_not_supported: bool_,
    pub normalize_zpos: bool_,
    pub modifiers_property: *mut drm_property,
    pub size_hints_property: *mut drm_property,
    pub cursor_width: u32,
    pub cursor_height: u32,
    pub suspend_state: *mut drm_atomic_state,
    pub helper_private: *mut drm_mode_config_helper_funcs,
}
impl Default for drm_mode_config {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    #[must_use]
    pub fn drmm_mode_config_init(dev: *mut drm_device) -> ffi::c_int;
}
extern "C" {
    pub fn drm_mode_config_reset(dev: *mut drm_device);
}
extern "C" {
    pub fn drm_mode_config_cleanup(dev: *mut drm_device);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_driver {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_minor {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_master {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_vblank_crtc {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_vma_offset_manager {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_vram_mm {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_fb_helper {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct pci_controller {
    _unused: [u8; 0],
}
pub const switch_power_state_DRM_SWITCH_POWER_ON: switch_power_state = 0;
pub const switch_power_state_DRM_SWITCH_POWER_OFF: switch_power_state = 1;
pub const switch_power_state_DRM_SWITCH_POWER_CHANGING: switch_power_state = 2;
pub const switch_power_state_DRM_SWITCH_POWER_DYNAMIC_OFF: switch_power_state = 3;
pub type switch_power_state = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_device {
    pub if_version: ffi::c_int,
    pub ref_: kref,
    pub dev: *mut device,
    pub managed: drm_device__bindgen_ty_1,
    pub driver: *const drm_driver,
    pub dev_private: *mut ffi::c_void,
    pub primary: *mut drm_minor,
    pub render: *mut drm_minor,
    pub accel: *mut drm_minor,
    pub registered: bool_,
    pub master: *mut drm_master,
    pub driver_features: u32_,
    pub unplugged: bool_,
    pub anon_inode: *mut inode,
    pub unique: *mut ffi::c_char,
    pub struct_mutex: mutex,
    pub master_mutex: mutex,
    pub open_count: atomic_t,
    pub filelist_mutex: mutex,
    pub filelist: list_head,
    pub filelist_internal: list_head,
    pub clientlist_mutex: mutex,
    pub clientlist: list_head,
    pub vblank_disable_immediate: bool_,
    pub vblank: *mut drm_vblank_crtc,
    pub vblank_time_lock: spinlock_t,
    pub vbl_lock: spinlock_t,
    pub max_vblank_count: u32_,
    pub vblank_event_list: list_head,
    pub event_lock: spinlock_t,
    pub num_crtcs: ffi::c_uint,
    pub mode_config: drm_mode_config,
    pub object_name_lock: mutex,
    pub object_name_idr: idr,
    pub vma_offset_manager: *mut drm_vma_offset_manager,
    pub vram_mm: *mut drm_vram_mm,
    pub switch_power_state: switch_power_state,
    pub fb_helper: *mut drm_fb_helper,
    pub debugfs_root: *mut dentry,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_device__bindgen_ty_1 {
    pub resources: list_head,
    pub final_kfree: *mut ffi::c_void,
    pub lock: spinlock_t,
}
impl Default for drm_device__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for drm_device {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub type drm_handle_t = ffi::c_uint;
pub type drm_context_t = ffi::c_uint;
pub type drm_drawable_t = ffi::c_uint;
pub type drm_magic_t = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_clip_rect {
    pub x1: ffi::c_ushort,
    pub y1: ffi::c_ushort,
    pub x2: ffi::c_ushort,
    pub y2: ffi::c_ushort,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_drawable_info {
    pub num_rects: ffi::c_uint,
    pub rects: *mut drm_clip_rect,
}
impl Default for drm_drawable_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_tex_region {
    pub next: ffi::c_uchar,
    pub prev: ffi::c_uchar,
    pub in_use: ffi::c_uchar,
    pub padding: ffi::c_uchar,
    pub age: ffi::c_uint,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_hw_lock {
    pub lock: ffi::c_uint,
    pub padding: [ffi::c_char; 60usize],
}
impl Default for drm_hw_lock {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct drm_version {
    pub version_major: ffi::c_int,
    pub version_minor: ffi::c_int,
    pub version_patchlevel: ffi::c_int,
    pub name_len: __kernel_size_t,
    pub name: *mut ffi::c_char,
    pub date_len: __kernel_size_t,
    pub date: *mut ffi::c_char,
    pub desc_len: __kernel_size_t,
    pub desc: *mut ffi::c_char,
}
impl Default for drm_version {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
pub struct drm_unique {
    pub unique_len: __kernel_size_t,
    pub unique: *mut ffi::c_char,
}
impl Default for drm_unique {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_list {
    pub count: ffi::c_int,
    pub version: *mut drm_version,
}
impl Default for drm_list {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_block {
    pub unused: ffi::c_int,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_control {
    pub func: drm_control__bindgen_ty_1,
    pub irq: ffi::c_int,
}
pub const drm_control_DRM_ADD_COMMAND: drm_control__bindgen_ty_1 = 0;
pub const drm_control_DRM_RM_COMMAND: drm_control__bindgen_ty_1 = 1;
pub const drm_control_DRM_INST_HANDLER: drm_control__bindgen_ty_1 = 2;
pub const drm_control_DRM_UNINST_HANDLER: drm_control__bindgen_ty_1 = 3;
pub type drm_control__bindgen_ty_1 = ffi::c_uint;
impl Default for drm_control {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const drm_map_type__DRM_FRAME_BUFFER: drm_map_type = 0;
pub const drm_map_type__DRM_REGISTERS: drm_map_type = 1;
pub const drm_map_type__DRM_SHM: drm_map_type = 2;
pub const drm_map_type__DRM_AGP: drm_map_type = 3;
pub const drm_map_type__DRM_SCATTER_GATHER: drm_map_type = 4;
pub const drm_map_type__DRM_CONSISTENT: drm_map_type = 5;
pub type drm_map_type = ffi::c_uint;
pub const drm_map_flags__DRM_RESTRICTED: drm_map_flags = 1;
pub const drm_map_flags__DRM_READ_ONLY: drm_map_flags = 2;
pub const drm_map_flags__DRM_LOCKED: drm_map_flags = 4;
pub const drm_map_flags__DRM_KERNEL: drm_map_flags = 8;
pub const drm_map_flags__DRM_WRITE_COMBINING: drm_map_flags = 16;
pub const drm_map_flags__DRM_CONTAINS_LOCK: drm_map_flags = 32;
pub const drm_map_flags__DRM_REMOVABLE: drm_map_flags = 64;
pub const drm_map_flags__DRM_DRIVER: drm_map_flags = 128;
pub type drm_map_flags = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_ctx_priv_map {
    pub ctx_id: ffi::c_uint,
    pub handle: *mut ffi::c_void,
}
impl Default for drm_ctx_priv_map {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_map {
    pub offset: ffi::c_ulong,
    pub size: ffi::c_ulong,
    pub type_: drm_map_type,
    pub flags: drm_map_flags,
    pub handle: *mut ffi::c_void,
    pub mtrr: ffi::c_int,
}
impl Default for drm_map {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_client {
    pub idx: ffi::c_int,
    pub auth: ffi::c_int,
    pub pid: ffi::c_ulong,
    pub uid: ffi::c_ulong,
    pub magic: ffi::c_ulong,
    pub iocs: ffi::c_ulong,
}
pub const drm_stat_type__DRM_STAT_LOCK: drm_stat_type = 0;
pub const drm_stat_type__DRM_STAT_OPENS: drm_stat_type = 1;
pub const drm_stat_type__DRM_STAT_CLOSES: drm_stat_type = 2;
pub const drm_stat_type__DRM_STAT_IOCTLS: drm_stat_type = 3;
pub const drm_stat_type__DRM_STAT_LOCKS: drm_stat_type = 4;
pub const drm_stat_type__DRM_STAT_UNLOCKS: drm_stat_type = 5;
pub const drm_stat_type__DRM_STAT_VALUE: drm_stat_type = 6;
pub const drm_stat_type__DRM_STAT_BYTE: drm_stat_type = 7;
pub const drm_stat_type__DRM_STAT_COUNT: drm_stat_type = 8;
pub const drm_stat_type__DRM_STAT_IRQ: drm_stat_type = 9;
pub const drm_stat_type__DRM_STAT_PRIMARY: drm_stat_type = 10;
pub const drm_stat_type__DRM_STAT_SECONDARY: drm_stat_type = 11;
pub const drm_stat_type__DRM_STAT_DMA: drm_stat_type = 12;
pub const drm_stat_type__DRM_STAT_SPECIAL: drm_stat_type = 13;
pub const drm_stat_type__DRM_STAT_MISSED: drm_stat_type = 14;
pub type drm_stat_type = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_stats {
    pub count: ffi::c_ulong,
    pub data: [drm_stats__bindgen_ty_1; 15usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_stats__bindgen_ty_1 {
    pub value: ffi::c_ulong,
    pub type_: drm_stat_type,
}
impl Default for drm_stats__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for drm_stats {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const drm_lock_flags__DRM_LOCK_READY: drm_lock_flags = 1;
pub const drm_lock_flags__DRM_LOCK_QUIESCENT: drm_lock_flags = 2;
pub const drm_lock_flags__DRM_LOCK_FLUSH: drm_lock_flags = 4;
pub const drm_lock_flags__DRM_LOCK_FLUSH_ALL: drm_lock_flags = 8;
pub const drm_lock_flags__DRM_HALT_ALL_QUEUES: drm_lock_flags = 16;
pub const drm_lock_flags__DRM_HALT_CUR_QUEUES: drm_lock_flags = 32;
pub type drm_lock_flags = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_lock {
    pub context: ffi::c_int,
    pub flags: drm_lock_flags,
}
impl Default for drm_lock {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const drm_dma_flags__DRM_DMA_BLOCK: drm_dma_flags = 1;
pub const drm_dma_flags__DRM_DMA_WHILE_LOCKED: drm_dma_flags = 2;
pub const drm_dma_flags__DRM_DMA_PRIORITY: drm_dma_flags = 4;
pub const drm_dma_flags__DRM_DMA_WAIT: drm_dma_flags = 16;
pub const drm_dma_flags__DRM_DMA_SMALLER_OK: drm_dma_flags = 32;
pub const drm_dma_flags__DRM_DMA_LARGER_OK: drm_dma_flags = 64;
pub type drm_dma_flags = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_buf_desc {
    pub count: ffi::c_int,
    pub size: ffi::c_int,
    pub low_mark: ffi::c_int,
    pub high_mark: ffi::c_int,
    pub flags: drm_buf_desc__bindgen_ty_1,
    pub agp_start: ffi::c_ulong,
}
pub const drm_buf_desc__DRM_PAGE_ALIGN: drm_buf_desc__bindgen_ty_1 = 1;
pub const drm_buf_desc__DRM_AGP_BUFFER: drm_buf_desc__bindgen_ty_1 = 2;
pub const drm_buf_desc__DRM_SG_BUFFER: drm_buf_desc__bindgen_ty_1 = 4;
pub const drm_buf_desc__DRM_FB_BUFFER: drm_buf_desc__bindgen_ty_1 = 8;
pub const drm_buf_desc__DRM_PCI_BUFFER_RO: drm_buf_desc__bindgen_ty_1 = 16;
pub type drm_buf_desc__bindgen_ty_1 = ffi::c_uint;
impl Default for drm_buf_desc {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_buf_info {
    pub count: ffi::c_int,
    pub list: *mut drm_buf_desc,
}
impl Default for drm_buf_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_buf_free {
    pub count: ffi::c_int,
    pub list: *mut ffi::c_int,
}
impl Default for drm_buf_free {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_buf_pub {
    pub idx: ffi::c_int,
    pub total: ffi::c_int,
    pub used: ffi::c_int,
    pub address: *mut ffi::c_void,
}
impl Default for drm_buf_pub {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_buf_map {
    pub count: ffi::c_int,
    pub virtual_: *mut ffi::c_void,
    pub list: *mut drm_buf_pub,
}
impl Default for drm_buf_map {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_dma {
    pub context: ffi::c_int,
    pub send_count: ffi::c_int,
    pub send_indices: *mut ffi::c_int,
    pub send_sizes: *mut ffi::c_int,
    pub flags: drm_dma_flags,
    pub request_count: ffi::c_int,
    pub request_size: ffi::c_int,
    pub request_indices: *mut ffi::c_int,
    pub request_sizes: *mut ffi::c_int,
    pub granted_count: ffi::c_int,
}
impl Default for drm_dma {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
pub const drm_ctx_flags__DRM_CONTEXT_PRESERVED: drm_ctx_flags = 1;
pub const drm_ctx_flags__DRM_CONTEXT_2DONLY: drm_ctx_flags = 2;
pub type drm_ctx_flags = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_ctx {
    pub handle: drm_context_t,
    pub flags: drm_ctx_flags,
}
impl Default for drm_ctx {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_ctx_res {
    pub count: ffi::c_int,
    pub contexts: *mut drm_ctx,
}
impl Default for drm_ctx_res {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_draw {
    pub handle: drm_drawable_t,
}
pub const drm_drawable_info_type_t_DRM_DRAWABLE_CLIPRECTS: drm_drawable_info_type_t = 0;
pub type drm_drawable_info_type_t = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_update_draw {
    pub handle: drm_drawable_t,
    pub type_: ffi::c_uint,
    pub num: ffi::c_uint,
    pub data: ffi::c_ulonglong,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_auth {
    pub magic: drm_magic_t,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_irq_busid {
    pub irq: ffi::c_int,
    pub busnum: ffi::c_int,
    pub devnum: ffi::c_int,
    pub funcnum: ffi::c_int,
}
pub const drm_vblank_seq_type__DRM_VBLANK_ABSOLUTE: drm_vblank_seq_type = 0;
pub const drm_vblank_seq_type__DRM_VBLANK_RELATIVE: drm_vblank_seq_type = 1;
pub const drm_vblank_seq_type__DRM_VBLANK_HIGH_CRTC_MASK: drm_vblank_seq_type = 62;
pub const drm_vblank_seq_type__DRM_VBLANK_EVENT: drm_vblank_seq_type = 67108864;
pub const drm_vblank_seq_type__DRM_VBLANK_FLIP: drm_vblank_seq_type = 134217728;
pub const drm_vblank_seq_type__DRM_VBLANK_NEXTONMISS: drm_vblank_seq_type = 268435456;
pub const drm_vblank_seq_type__DRM_VBLANK_SECONDARY: drm_vblank_seq_type = 536870912;
pub const drm_vblank_seq_type__DRM_VBLANK_SIGNAL: drm_vblank_seq_type = 1073741824;
pub type drm_vblank_seq_type = ffi::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_wait_vblank_request {
    pub type_: drm_vblank_seq_type,
    pub sequence: ffi::c_uint,
    pub signal: ffi::c_ulong,
}
impl Default for drm_wait_vblank_request {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_wait_vblank_reply {
    pub type_: drm_vblank_seq_type,
    pub sequence: ffi::c_uint,
    pub tval_sec: ffi::c_long,
    pub tval_usec: ffi::c_long,
}
impl Default for drm_wait_vblank_reply {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union drm_wait_vblank {
    pub request: drm_wait_vblank_request,
    pub reply: drm_wait_vblank_reply,
}
impl Default for drm_wait_vblank {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_modeset_ctl {
    pub crtc: __u32,
    pub cmd: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_agp_mode {
    pub mode: ffi::c_ulong,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_agp_buffer {
    pub size: ffi::c_ulong,
    pub handle: ffi::c_ulong,
    pub type_: ffi::c_ulong,
    pub physical: ffi::c_ulong,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_agp_binding {
    pub handle: ffi::c_ulong,
    pub offset: ffi::c_ulong,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_agp_info {
    pub agp_version_major: ffi::c_int,
    pub agp_version_minor: ffi::c_int,
    pub mode: ffi::c_ulong,
    pub aperture_base: ffi::c_ulong,
    pub aperture_size: ffi::c_ulong,
    pub memory_allowed: ffi::c_ulong,
    pub memory_used: ffi::c_ulong,
    pub id_vendor: ffi::c_ushort,
    pub id_device: ffi::c_ushort,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_scatter_gather {
    pub size: ffi::c_ulong,
    pub handle: ffi::c_ulong,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_set_version {
    pub drm_di_major: ffi::c_int,
    pub drm_di_minor: ffi::c_int,
    pub drm_dd_major: ffi::c_int,
    pub drm_dd_minor: ffi::c_int,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_gem_close {
    pub handle: __u32,
    pub pad: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_gem_flink {
    pub handle: __u32,
    pub name: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_gem_open {
    pub name: __u32,
    pub handle: __u32,
    pub size: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_get_cap {
    pub capability: __u64,
    pub value: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_set_client_cap {
    pub capability: __u64,
    pub value: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_prime_handle {
    pub handle: __u32,
    pub flags: __u32,
    pub fd: __s32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_syncobj_create {
    pub handle: __u32,
    pub flags: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_syncobj_destroy {
    pub handle: __u32,
    pub pad: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_syncobj_handle {
    pub handle: __u32,
    pub flags: __u32,
    pub fd: __s32,
    pub pad: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_syncobj_transfer {
    pub src_handle: __u32,
    pub dst_handle: __u32,
    pub src_point: __u64,
    pub dst_point: __u64,
    pub flags: __u32,
    pub pad: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_syncobj_wait {
    pub handles: __u64,
    pub timeout_nsec: __s64,
    pub count_handles: __u32,
    pub flags: __u32,
    pub first_signaled: __u32,
    pub pad: __u32,
    pub deadline_nsec: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_syncobj_timeline_wait {
    pub handles: __u64,
    pub points: __u64,
    pub timeout_nsec: __s64,
    pub count_handles: __u32,
    pub flags: __u32,
    pub first_signaled: __u32,
    pub pad: __u32,
    pub deadline_nsec: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_syncobj_eventfd {
    pub handle: __u32,
    pub flags: __u32,
    pub point: __u64,
    pub fd: __s32,
    pub pad: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_syncobj_array {
    pub handles: __u64,
    pub count_handles: __u32,
    pub pad: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_syncobj_timeline_array {
    pub handles: __u64,
    pub points: __u64,
    pub count_handles: __u32,
    pub flags: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_crtc_get_sequence {
    pub crtc_id: __u32,
    pub active: __u32,
    pub sequence: __u64,
    pub sequence_ns: __s64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_crtc_queue_sequence {
    pub crtc_id: __u32,
    pub flags: __u32,
    pub sequence: __u64,
    pub user_data: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_set_client_name {
    pub name_len: __u64,
    pub name: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_modeinfo {
    pub clock: __u32,
    pub hdisplay: __u16,
    pub hsync_start: __u16,
    pub hsync_end: __u16,
    pub htotal: __u16,
    pub hskew: __u16,
    pub vdisplay: __u16,
    pub vsync_start: __u16,
    pub vsync_end: __u16,
    pub vtotal: __u16,
    pub vscan: __u16,
    pub vrefresh: __u32,
    pub flags: __u32,
    pub type_: __u32,
    pub name: [ffi::c_char; 32usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_card_res {
    pub fb_id_ptr: __u64,
    pub crtc_id_ptr: __u64,
    pub connector_id_ptr: __u64,
    pub encoder_id_ptr: __u64,
    pub count_fbs: __u32,
    pub count_crtcs: __u32,
    pub count_connectors: __u32,
    pub count_encoders: __u32,
    pub min_width: __u32,
    pub max_width: __u32,
    pub min_height: __u32,
    pub max_height: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_crtc {
    pub set_connectors_ptr: __u64,
    pub count_connectors: __u32,
    pub crtc_id: __u32,
    pub fb_id: __u32,
    pub x: __u32,
    pub y: __u32,
    pub gamma_size: __u32,
    pub mode_valid: __u32,
    pub mode: drm_mode_modeinfo,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_set_plane {
    pub plane_id: __u32,
    pub crtc_id: __u32,
    pub fb_id: __u32,
    pub flags: __u32,
    pub crtc_x: __s32,
    pub crtc_y: __s32,
    pub crtc_w: __u32,
    pub crtc_h: __u32,
    pub src_x: __u32,
    pub src_y: __u32,
    pub src_h: __u32,
    pub src_w: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_get_plane {
    pub plane_id: __u32,
    pub crtc_id: __u32,
    pub fb_id: __u32,
    pub possible_crtcs: __u32,
    pub gamma_size: __u32,
    pub count_format_types: __u32,
    pub format_type_ptr: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_get_plane_res {
    pub plane_id_ptr: __u64,
    pub count_planes: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_get_encoder {
    pub encoder_id: __u32,
    pub encoder_type: __u32,
    pub crtc_id: __u32,
    pub possible_crtcs: __u32,
    pub possible_clones: __u32,
}
pub const drm_mode_subconnector_DRM_MODE_SUBCONNECTOR_Automatic: drm_mode_subconnector = 0;
pub const drm_mode_subconnector_DRM_MODE_SUBCONNECTOR_Unknown: drm_mode_subconnector = 0;
pub const drm_mode_subconnector_DRM_MODE_SUBCONNECTOR_VGA: drm_mode_subconnector = 1;
pub const drm_mode_subconnector_DRM_MODE_SUBCONNECTOR_DVID: drm_mode_subconnector = 3;
pub const drm_mode_subconnector_DRM_MODE_SUBCONNECTOR_DVIA: drm_mode_subconnector = 4;
pub const drm_mode_subconnector_DRM_MODE_SUBCONNECTOR_Composite: drm_mode_subconnector = 5;
pub const drm_mode_subconnector_DRM_MODE_SUBCONNECTOR_SVIDEO: drm_mode_subconnector = 6;
pub const drm_mode_subconnector_DRM_MODE_SUBCONNECTOR_Component: drm_mode_subconnector = 8;
pub const drm_mode_subconnector_DRM_MODE_SUBCONNECTOR_SCART: drm_mode_subconnector = 9;
pub const drm_mode_subconnector_DRM_MODE_SUBCONNECTOR_DisplayPort: drm_mode_subconnector = 10;
pub const drm_mode_subconnector_DRM_MODE_SUBCONNECTOR_HDMIA: drm_mode_subconnector = 11;
pub const drm_mode_subconnector_DRM_MODE_SUBCONNECTOR_Native: drm_mode_subconnector = 15;
pub const drm_mode_subconnector_DRM_MODE_SUBCONNECTOR_Wireless: drm_mode_subconnector = 18;
pub type drm_mode_subconnector = ffi::c_uint;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_get_connector {
    pub encoders_ptr: __u64,
    pub modes_ptr: __u64,
    pub props_ptr: __u64,
    pub prop_values_ptr: __u64,
    pub count_modes: __u32,
    pub count_props: __u32,
    pub count_encoders: __u32,
    pub encoder_id: __u32,
    pub connector_id: __u32,
    pub connector_type: __u32,
    pub connector_type_id: __u32,
    pub connection: __u32,
    pub mm_width: __u32,
    pub mm_height: __u32,
    pub subpixel: __u32,
    pub pad: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_property_enum {
    pub value: __u64,
    pub name: [ffi::c_char; 32usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_get_property {
    pub values_ptr: __u64,
    pub enum_blob_ptr: __u64,
    pub prop_id: __u32,
    pub flags: __u32,
    pub name: [ffi::c_char; 32usize],
    pub count_values: __u32,
    pub count_enum_blobs: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_connector_set_property {
    pub value: __u64,
    pub prop_id: __u32,
    pub connector_id: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_obj_get_properties {
    pub props_ptr: __u64,
    pub prop_values_ptr: __u64,
    pub count_props: __u32,
    pub obj_id: __u32,
    pub obj_type: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_obj_set_property {
    pub value: __u64,
    pub prop_id: __u32,
    pub obj_id: __u32,
    pub obj_type: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_get_blob {
    pub blob_id: __u32,
    pub length: __u32,
    pub data: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_fb_cmd {
    pub fb_id: __u32,
    pub width: __u32,
    pub height: __u32,
    pub pitch: __u32,
    pub bpp: __u32,
    pub depth: __u32,
    pub handle: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_fb_cmd2 {
    pub fb_id: __u32,
    pub width: __u32,
    pub height: __u32,
    pub pixel_format: __u32,
    pub flags: __u32,
    pub handles: [__u32; 4usize],
    pub pitches: [__u32; 4usize],
    pub offsets: [__u32; 4usize],
    pub modifier: [__u64; 4usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_fb_dirty_cmd {
    pub fb_id: __u32,
    pub flags: __u32,
    pub color: __u32,
    pub num_clips: __u32,
    pub clips_ptr: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_mode_cmd {
    pub connector_id: __u32,
    pub mode: drm_mode_modeinfo,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_cursor {
    pub flags: __u32,
    pub crtc_id: __u32,
    pub x: __s32,
    pub y: __s32,
    pub width: __u32,
    pub height: __u32,
    pub handle: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_cursor2 {
    pub flags: __u32,
    pub crtc_id: __u32,
    pub x: __s32,
    pub y: __s32,
    pub width: __u32,
    pub height: __u32,
    pub handle: __u32,
    pub hot_x: __s32,
    pub hot_y: __s32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_crtc_lut {
    pub crtc_id: __u32,
    pub gamma_size: __u32,
    pub red: __u64,
    pub green: __u64,
    pub blue: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_color_ctm {
    pub matrix: [__u64; 9usize],
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_color_lut {
    pub red: __u16,
    pub green: __u16,
    pub blue: __u16,
    pub reserved: __u16,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_plane_size_hint {
    pub width: __u16,
    pub height: __u16,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct hdr_metadata_infoframe {
    pub eotf: __u8,
    pub metadata_type: __u8,
    pub display_primaries: [hdr_metadata_infoframe__bindgen_ty_1; 3usize],
    pub white_point: hdr_metadata_infoframe__bindgen_ty_2,
    pub max_display_mastering_luminance: __u16,
    pub min_display_mastering_luminance: __u16,
    pub max_cll: __u16,
    pub max_fall: __u16,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct hdr_metadata_infoframe__bindgen_ty_1 {
    pub x: __u16,
    pub y: __u16,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct hdr_metadata_infoframe__bindgen_ty_2 {
    pub x: __u16,
    pub y: __u16,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct hdr_output_metadata {
    pub metadata_type: __u32,
    pub __bindgen_anon_1: hdr_output_metadata__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union hdr_output_metadata__bindgen_ty_1 {
    pub hdmi_metadata_type1: hdr_metadata_infoframe,
}
impl Default for hdr_output_metadata__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for hdr_output_metadata {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_crtc_page_flip {
    pub crtc_id: __u32,
    pub fb_id: __u32,
    pub flags: __u32,
    pub reserved: __u32,
    pub user_data: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_crtc_page_flip_target {
    pub crtc_id: __u32,
    pub fb_id: __u32,
    pub flags: __u32,
    pub sequence: __u32,
    pub user_data: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_create_dumb {
    pub height: __u32,
    pub width: __u32,
    pub bpp: __u32,
    pub flags: __u32,
    pub handle: __u32,
    pub pitch: __u32,
    pub size: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_map_dumb {
    pub handle: __u32,
    pub pad: __u32,
    pub offset: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_destroy_dumb {
    pub handle: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_atomic {
    pub flags: __u32,
    pub count_objs: __u32,
    pub objs_ptr: __u64,
    pub count_props_ptr: __u64,
    pub props_ptr: __u64,
    pub prop_values_ptr: __u64,
    pub reserved: __u64,
    pub user_data: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_format_modifier_blob {
    pub version: __u32,
    pub flags: __u32,
    pub count_formats: __u32,
    pub formats_offset: __u32,
    pub count_modifiers: __u32,
    pub modifiers_offset: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_format_modifier {
    pub formats: __u64,
    pub offset: __u32,
    pub pad: __u32,
    pub modifier: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_create_blob {
    pub data: __u64,
    pub length: __u32,
    pub blob_id: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_destroy_blob {
    pub blob_id: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_create_lease {
    pub object_ids: __u64,
    pub object_count: __u32,
    pub flags: __u32,
    pub lessee_id: __u32,
    pub fd: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_list_lessees {
    pub count_lessees: __u32,
    pub pad: __u32,
    pub lessees_ptr: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_get_lease {
    pub count_objects: __u32,
    pub pad: __u32,
    pub objects_ptr: __u64,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_revoke_lease {
    pub lessee_id: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_rect {
    pub x1: __s32,
    pub y1: __s32,
    pub x2: __s32,
    pub y2: __s32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_closefb {
    pub fb_id: __u32,
    pub pad: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_event {
    pub type_: __u32,
    pub length: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_event_vblank {
    pub base: drm_event,
    pub user_data: __u64,
    pub tv_sec: __u32,
    pub tv_usec: __u32,
    pub sequence: __u32,
    pub crtc_id: __u32,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_event_crtc_sequence {
    pub base: drm_event,
    pub user_data: __u64,
    pub time_ns: __s64,
    pub sequence: __u64,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_format_info {
    pub format: u32_,
    pub depth: u8_,
    pub num_planes: u8_,
    pub __bindgen_anon_1: drm_format_info__bindgen_ty_1,
    pub block_w: [u8_; 4usize],
    pub block_h: [u8_; 4usize],
    pub hsub: u8_,
    pub vsub: u8_,
    pub has_alpha: bool_,
    pub is_yuv: bool_,
    pub is_color_indexed: bool_,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union drm_format_info__bindgen_ty_1 {
    pub cpp: [u8_; 4usize],
    pub char_per_block: [u8_; 4usize],
}
impl Default for drm_format_info__bindgen_ty_1 {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
impl Default for drm_format_info {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn __drm_format_info(format: u32_) -> *const drm_format_info;
}
extern "C" {
    pub fn drm_format_info(format: u32_) -> *const drm_format_info;
}
extern "C" {
    pub fn drm_get_format_info(
        dev: *mut drm_device,
        mode_cmd: *const drm_mode_fb_cmd2,
    ) -> *const drm_format_info;
}
extern "C" {
    pub fn drm_mode_legacy_fb_format(bpp: u32, depth: u32) -> u32;
}
extern "C" {
    pub fn drm_driver_legacy_fb_format(dev: *mut drm_device, bpp: u32, depth: u32) -> u32;
}
extern "C" {
    pub fn drm_driver_color_mode_format(dev: *mut drm_device, color_mode: ffi::c_uint) -> u32;
}
extern "C" {
    pub fn drm_format_info_block_width(
        info: *const drm_format_info,
        plane: ffi::c_int,
    ) -> ffi::c_uint;
}
extern "C" {
    pub fn drm_format_info_block_height(
        info: *const drm_format_info,
        plane: ffi::c_int,
    ) -> ffi::c_uint;
}
extern "C" {
    pub fn drm_format_info_bpp(info: *const drm_format_info, plane: ffi::c_int) -> ffi::c_uint;
}
extern "C" {
    pub fn drm_format_info_min_pitch(
        info: *const drm_format_info,
        plane: ffi::c_int,
        buffer_width: ffi::c_uint,
    ) -> u64;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct drm_scanout_buffer {
    pub format: *const drm_format_info,
    pub map: [iosys_map; 4usize],
    pub width: ffi::c_uint,
    pub height: ffi::c_uint,
    pub pitch: [ffi::c_uint; 4usize],
    pub set_pixel: ::core::option::Option<
        unsafe extern "C" fn(
            sb: *mut drm_scanout_buffer,
            x: ffi::c_uint,
            y: ffi::c_uint,
            color: u32_,
        ),
    >,
}
impl Default for drm_scanout_buffer {
    fn default() -> Self {
        let mut s = ::core::mem::MaybeUninit::<Self>::uninit();
        unsafe {
            ::core::ptr::write_bytes(s.as_mut_ptr(), 0, 1);
            s.assume_init()
        }
    }
}
extern "C" {
    pub fn drm_panic_qr_max_data_size(version: u8_, url_len: usize) -> usize;
}
extern "C" {
    pub fn drm_panic_qr_generate(
        url: *const ffi::c_char,
        data: *mut u8_,
        data_len: usize,
        data_size: usize,
        tmp: *mut u8_,
        tmp_size: usize,
    ) -> u8_;
}
pub const ARCH_SLAB_MINALIGN: usize = 8;
pub const PAGE_SIZE: usize = 4096;
pub const GFP_ATOMIC: gfp_t = 2080;
pub const GFP_KERNEL: gfp_t = 3264;
pub const GFP_KERNEL_ACCOUNT: gfp_t = 4197568;
pub const GFP_NOWAIT: gfp_t = 10240;
pub const __GFP_ZERO: gfp_t = 256;
pub const __GFP_HIGHMEM: gfp_t = 2;
pub const __GFP_NOWARN: gfp_t = 8192;
pub const BLK_FEAT_ROTATIONAL: blk_features_t = 4;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct kernel_symbol {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct module_sect_attrs {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct module_notes_attrs {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct trace_event_call {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct static_key_mod {
    pub _address: u8,
}
pub type __uint128_t = u128;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sched_class {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct files_struct {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct numa_group {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct maple_pnode {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct maple_enode {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct page_pool {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct userfaultfd_ctx {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct linux_binfmt {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct memory_tier {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct assoc_array_ptr {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct watch_list {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct key_user {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct k_clock {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tty_struct {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct autogroup {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct tty_audit_buf {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct wait_page_queue {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct file_lock_context {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct cdev {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct xattr_handler {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct fscrypt_keyring {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct mtd_info {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct kernfs_root {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct module_param_attrs {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct time_namespace {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct msgbuf {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sem {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sem_queue {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sem_undo {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sched_group_capacity {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct dev_pm_qos {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bus_dma_region {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct dma_coherent_mem {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct cma {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct io_tlb_mem {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct disk_stats {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bio_alloc_cache {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct timer_rand_state {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct cdrom_device_info {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct blk_mq_ctx {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct throtl_data {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct blk_crypto_keyslot {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct swap_iocb {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_kfunc_btf_tab {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_prog_stats {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct sock_fprog_kern {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct bpf_cgroup_storage {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct nla_policy {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct flow_rule {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct hotplug_slot {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct aer_stats {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct npem {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct phy_package_shared {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct phy_led_trigger {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct pse_control {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct poll_table_page {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_framebuffer {
    pub _address: u8,
}
pub type drm_mode_status = i32;
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_property {
    pub _address: u8,
}
#[repr(C)]
#[derive(Default, Copy, Clone)]
pub struct drm_mode_config_helper_funcs {
    pub _address: u8,
}
